/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/editor/common/core/range","vs/editor/common/core/position","vs/base/common/strings","vs/base/common/platform","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/errors","vs/base/common/objects","vs/editor/common/diff/algorithms/diffAlgorithm","vs/base/common/uri","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/diff/linesDiffComputer","vs/base/common/stopwatch","vs/base/common/cancellation","vs/base/common/diff/diff","vs/editor/common/diff/smartLinesDiffComputer","vs/nls","vs/base/common/assert","vs/base/common/codicons","vs/base/common/diff/diffChange","vs/base/common/arrays","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/types","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/algorithms/myersDiffAlgorithm","vs/editor/common/diff/algorithms/utils","vs/editor/common/diff/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/standardLinesDiffComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/standalone/standaloneEnums","vs/nls!vs/base/common/platform","vs/base/common/process","vs/base/common/path","vs/base/common/cache","vs/base/common/hash","vs/editor/common/diff/linesDiffComputers","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/tokenizationRegistry","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/nls!vs/editor/common/services/editorSimpleWorker","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],J=function(O){for(var n=[],y=0,t=O.length;y<t;y++)n[y]=Z[O[y]];return n},Ue=this,Oe=typeof global=="object"?global:{},ue;(function(O){O.global=Ue;var n=function(){function y(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}return Object.defineProperty(y.prototype,"isWindows",{get:function(){return this._detect(),this._isWindows},enumerable:!1,configurable:!0}),Object.defineProperty(y.prototype,"isNode",{get:function(){return this._detect(),this._isNode},enumerable:!1,configurable:!0}),Object.defineProperty(y.prototype,"isElectronRenderer",{get:function(){return this._detect(),this._isElectronRenderer},enumerable:!1,configurable:!0}),Object.defineProperty(y.prototype,"isWebWorker",{get:function(){return this._detect(),this._isWebWorker},enumerable:!1,configurable:!0}),Object.defineProperty(y.prototype,"isElectronNodeIntegrationWebWorker",{get:function(){return this._detect(),this._isElectronNodeIntegrationWebWorker},enumerable:!1,configurable:!0}),y.prototype._detect=function(){this._detected||(this._detected=!0,this._isWindows=y._isWindows(),this._isNode=typeof module!="undefined"&&!!module.exports,this._isElectronRenderer=typeof process!="undefined"&&typeof process.versions!="undefined"&&typeof process.versions.electron!="undefined"&&process.type==="renderer",this._isWebWorker=typeof O.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process!="undefined"&&typeof process.versions!="undefined"&&typeof process.versions.electron!="undefined"&&process.type==="worker")},y._isWindows=function(){return typeof navigator!="undefined"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process!="undefined"?process.platform==="win32":!1},y}();O.Environment=n})(ue||(ue={}));var ue;(function(O){var n=function(){function M(c,N,d){this.type=c,this.detail=N,this.timestamp=d}return M}();O.LoaderEvent=n;var y=function(){function M(c){this._events=[new n(1,"",c)]}return M.prototype.record=function(c,N){this._events.push(new n(c,N,O.Utilities.getHighPerformanceTimestamp()))},M.prototype.getEvents=function(){return this._events},M}();O.LoaderEventRecorder=y;var t=function(){function M(){}return M.prototype.record=function(c,N){},M.prototype.getEvents=function(){return[]},M.INSTANCE=new M,M}();O.NullLoaderEventRecorder=t})(ue||(ue={}));var ue;(function(O){var n=function(){function y(){}return y.fileUriToFilePath=function(t,M){if(M=decodeURI(M).replace(/%23/g,"#"),t){if(/^file:\/\/\//.test(M))return M.substr(8);if(/^file:\/\//.test(M))return M.substr(5)}else if(/^file:\/\//.test(M))return M.substr(7);return M},y.startsWith=function(t,M){return t.length>=M.length&&t.substr(0,M.length)===M},y.endsWith=function(t,M){return t.length>=M.length&&t.substr(t.length-M.length)===M},y.containsQueryString=function(t){return/^[^\#]*\?/gi.test(t)},y.isAbsolutePath=function(t){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(t)},y.forEachProperty=function(t,M){if(t){var c=void 0;for(c in t)t.hasOwnProperty(c)&&M(c,t[c])}},y.isEmpty=function(t){var M=!0;return y.forEachProperty(t,function(){M=!1}),M},y.recursiveClone=function(t){if(!t||typeof t!="object"||t instanceof RegExp||!Array.isArray(t)&&Object.getPrototypeOf(t)!==Object.prototype)return t;var M=Array.isArray(t)?[]:{};return y.forEachProperty(t,function(c,N){N&&typeof N=="object"?M[c]=y.recursiveClone(N):M[c]=N}),M},y.generateAnonymousModule=function(){return"===anonymous"+y.NEXT_ANONYMOUS_ID+++"==="},y.isAnonymousModule=function(t){return y.startsWith(t,"===anonymous")},y.getHighPerformanceTimestamp=function(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=O.global.performance&&typeof O.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?O.global.performance.now():Date.now()},y.NEXT_ANONYMOUS_ID=1,y.PERFORMANCE_NOW_PROBED=!1,y.HAS_PERFORMANCE_NOW=!1,y}();O.Utilities=n})(ue||(ue={}));var ue;(function(O){function n(M){if(M instanceof Error)return M;var c=new Error(M.message||String(M)||"Unknown Error");return M.stack&&(c.stack=M.stack),c}O.ensureError=n;var y=function(){function M(){}return M.validateConfigurationOptions=function(c){function N(o){if(o.phase==="loading"){console.error('Loading "'+o.moduleId+'" failed'),console.error(o),console.error("Here are the modules that depend on it:"),console.error(o.neededBy);return}if(o.phase==="factory"){console.error('The factory function of "'+o.moduleId+'" has thrown an exception'),console.error(o),console.error("Here are the modules that depend on it:"),console.error(o.neededBy);return}}if(c=c||{},typeof c.baseUrl!="string"&&(c.baseUrl=""),typeof c.isBuild!="boolean"&&(c.isBuild=!1),typeof c.buildForceInvokeFactory!="object"&&(c.buildForceInvokeFactory={}),typeof c.paths!="object"&&(c.paths={}),typeof c.config!="object"&&(c.config={}),typeof c.catchError=="undefined"&&(c.catchError=!1),typeof c.recordStats=="undefined"&&(c.recordStats=!1),typeof c.urlArgs!="string"&&(c.urlArgs=""),typeof c.onError!="function"&&(c.onError=N),Array.isArray(c.ignoreDuplicateModules)||(c.ignoreDuplicateModules=[]),c.baseUrl.length>0&&(O.Utilities.endsWith(c.baseUrl,"/")||(c.baseUrl+="/")),typeof c.cspNonce!="string"&&(c.cspNonce=""),typeof c.preferScriptTags=="undefined"&&(c.preferScriptTags=!1),Array.isArray(c.nodeModules)||(c.nodeModules=[]),c.nodeCachedData&&typeof c.nodeCachedData=="object"&&(typeof c.nodeCachedData.seed!="string"&&(c.nodeCachedData.seed="seed"),(typeof c.nodeCachedData.writeDelay!="number"||c.nodeCachedData.writeDelay<0)&&(c.nodeCachedData.writeDelay=1e3*7),!c.nodeCachedData.path||typeof c.nodeCachedData.path!="string")){var d=n(new Error("INVALID cached data configuration, 'path' MUST be set"));d.phase="configuration",c.onError(d),c.nodeCachedData=void 0}return c},M.mergeConfigurationOptions=function(c,N){c===void 0&&(c=null),N===void 0&&(N=null);var d=O.Utilities.recursiveClone(N||{});return O.Utilities.forEachProperty(c,function(o,g){o==="ignoreDuplicateModules"&&typeof d.ignoreDuplicateModules!="undefined"?d.ignoreDuplicateModules=d.ignoreDuplicateModules.concat(g):o==="paths"&&typeof d.paths!="undefined"?O.Utilities.forEachProperty(g,function(E,D){return d.paths[E]=D}):o==="config"&&typeof d.config!="undefined"?O.Utilities.forEachProperty(g,function(E,D){return d.config[E]=D}):d[o]=O.Utilities.recursiveClone(g)}),M.validateConfigurationOptions(d)},M}();O.ConfigurationOptionsUtil=y;var t=function(){function M(c,N){if(this._env=c,this.options=y.mergeConfigurationOptions(N),this._createIgnoreDuplicateModulesMap(),this._createNodeModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""){if(this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){var d=this.options.nodeRequire.main.filename,o=Math.max(d.lastIndexOf("/"),d.lastIndexOf("\\"));this.options.baseUrl=d.substring(0,o+1)}if(this.options.nodeMain&&this._env.isNode){var d=this.options.nodeMain,o=Math.max(d.lastIndexOf("/"),d.lastIndexOf("\\"));this.options.baseUrl=d.substring(0,o+1)}}}return M.prototype._createIgnoreDuplicateModulesMap=function(){this.ignoreDuplicateModulesMap={};for(var c=0;c<this.options.ignoreDuplicateModules.length;c++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[c]]=!0},M.prototype._createNodeModulesMap=function(){this.nodeModulesMap=Object.create(null);for(var c=0,N=this.options.nodeModules;c<N.length;c++){var d=N[c];this.nodeModulesMap[d]=!0}},M.prototype._createSortedPathsRules=function(){var c=this;this.sortedPathsRules=[],O.Utilities.forEachProperty(this.options.paths,function(N,d){Array.isArray(d)?c.sortedPathsRules.push({from:N,to:d}):c.sortedPathsRules.push({from:N,to:[d]})}),this.sortedPathsRules.sort(function(N,d){return d.from.length-N.from.length})},M.prototype.cloneAndMerge=function(c){return new M(this._env,y.mergeConfigurationOptions(c,this.options))},M.prototype.getOptionsLiteral=function(){return this.options},M.prototype._applyPaths=function(c){for(var N,d=0,o=this.sortedPathsRules.length;d<o;d++)if(N=this.sortedPathsRules[d],O.Utilities.startsWith(c,N.from)){for(var g=[],E=0,D=N.to.length;E<D;E++)g.push(N.to[E]+c.substr(N.from.length));return g}return[c]},M.prototype._addUrlArgsToUrl=function(c){return O.Utilities.containsQueryString(c)?c+"&"+this.options.urlArgs:c+"?"+this.options.urlArgs},M.prototype._addUrlArgsIfNecessaryToUrl=function(c){return this.options.urlArgs?this._addUrlArgsToUrl(c):c},M.prototype._addUrlArgsIfNecessaryToUrls=function(c){if(this.options.urlArgs)for(var N=0,d=c.length;N<d;N++)c[N]=this._addUrlArgsToUrl(c[N]);return c},M.prototype.moduleIdToPaths=function(c){if(this._env.isNode){var N=this.nodeModulesMap[c]===!0||this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(c);if(N)return this.isBuild()?["empty:"]:["node|"+c]}var d=c,o;if(!O.Utilities.endsWith(d,".js")&&!O.Utilities.isAbsolutePath(d)){o=this._applyPaths(d);for(var g=0,E=o.length;g<E;g++)this.isBuild()&&o[g]==="empty:"||(O.Utilities.isAbsolutePath(o[g])||(o[g]=this.options.baseUrl+o[g]),!O.Utilities.endsWith(o[g],".js")&&!O.Utilities.containsQueryString(o[g])&&(o[g]=o[g]+".js"))}else!O.Utilities.endsWith(d,".js")&&!O.Utilities.containsQueryString(d)&&(d=d+".js"),o=[d];return this._addUrlArgsIfNecessaryToUrls(o)},M.prototype.requireToUrl=function(c){var N=c;return O.Utilities.isAbsolutePath(N)||(N=this._applyPaths(N)[0],O.Utilities.isAbsolutePath(N)||(N=this.options.baseUrl+N)),this._addUrlArgsIfNecessaryToUrl(N)},M.prototype.isBuild=function(){return this.options.isBuild},M.prototype.shouldInvokeFactory=function(c){return this.options.isBuild?this.options.buildForceInvokeFactory[c]||O.Utilities.isAnonymousModule(c):!0},M.prototype.isDuplicateMessageIgnoredFor=function(c){return this.ignoreDuplicateModulesMap.hasOwnProperty(c)},M.prototype.getConfigForModule=function(c){if(this.options.config)return this.options.config[c]},M.prototype.shouldCatchError=function(){return this.options.catchError},M.prototype.shouldRecordStats=function(){return this.options.recordStats},M.prototype.onError=function(c){this.options.onError(c)},M}();O.Configuration=t})(ue||(ue={}));var ue;(function(O){var n=function(){function o(g){this._env=g,this._scriptLoader=null,this._callbackMap={}}return o.prototype.load=function(g,E,D,p){var f=this;if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new M;else if(this._env.isElectronRenderer){var e=g.getConfig().getOptionsLiteral().preferScriptTags;e?this._scriptLoader=new y:this._scriptLoader=new c(this._env)}else this._env.isNode?this._scriptLoader=new c(this._env):this._scriptLoader=new y;var C={callback:D,errorback:p};if(this._callbackMap.hasOwnProperty(E)){this._callbackMap[E].push(C);return}this._callbackMap[E]=[C],this._scriptLoader.load(g,E,function(){return f.triggerCallback(E)},function(R){return f.triggerErrorback(E,R)})},o.prototype.triggerCallback=function(g){var E=this._callbackMap[g];delete this._callbackMap[g];for(var D=0;D<E.length;D++)E[D].callback()},o.prototype.triggerErrorback=function(g,E){var D=this._callbackMap[g];delete this._callbackMap[g];for(var p=0;p<D.length;p++)D[p].errorback(E)},o}(),y=function(){function o(){}return o.prototype.attachListeners=function(g,E,D){var p=function(){g.removeEventListener("load",f),g.removeEventListener("error",e)},f=function(C){p(),E()},e=function(C){p(),D(C)};g.addEventListener("load",f),g.addEventListener("error",e)},o.prototype.load=function(g,E,D,p){if(/^node\|/.test(E)){var f=g.getConfig().getOptionsLiteral(),e=N(g.getRecorder(),f.nodeRequire||O.global.nodeRequire),C=E.split("|"),R=null;try{R=e(C[1])}catch(s){p(s);return}g.enqueueDefineAnonymousModule([],function(){return R}),D()}else{var A=document.createElement("script");A.setAttribute("async","async"),A.setAttribute("type","text/javascript"),this.attachListeners(A,D,p);var _=g.getConfig().getOptionsLiteral().trustedTypesPolicy;_&&(E=_.createScriptURL(E)),A.setAttribute("src",E);var i=g.getConfig().getOptionsLiteral().cspNonce;i&&A.setAttribute("nonce",i),document.getElementsByTagName("head")[0].appendChild(A)}},o}();function t(o){var g=o.getConfig().getOptionsLiteral().trustedTypesPolicy;try{var E=g?self.eval(g.createScript("","true")):new Function("true");return E.call(self),!0}catch{return!1}}var M=function(){function o(){this._cachedCanUseEval=null}return o.prototype._canUseEval=function(g){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=t(g)),this._cachedCanUseEval},o.prototype.load=function(g,E,D,p){if(/^node\|/.test(E)){var f=g.getConfig().getOptionsLiteral(),e=N(g.getRecorder(),f.nodeRequire||O.global.nodeRequire),C=E.split("|"),R=null;try{R=e(C[1])}catch(i){p(i);return}g.enqueueDefineAnonymousModule([],function(){return R}),D()}else{var A=g.getConfig().getOptionsLiteral().trustedTypesPolicy,_=/^((http:)|(https:)|(file:))/.test(E)&&E.substring(0,self.origin.length)!==self.origin;if(!_&&this._canUseEval(g)){fetch(E).then(function(i){if(i.status!==200)throw new Error(i.statusText);return i.text()}).then(function(i){i=i+`
//# sourceURL=`+E;var s=A?self.eval(A.createScript("",i)):new Function(i);s.call(self),D()}).then(void 0,p);return}try{A&&(E=A.createScriptURL(E)),importScripts(E),D()}catch(i){p(i)}}},o}(),c=function(){function o(g){this._env=g,this._didInitialize=!1,this._didPatchNodeRequire=!1}return o.prototype._init=function(g){this._didInitialize||(this._didInitialize=!0,this._fs=g("fs"),this._vm=g("vm"),this._path=g("path"),this._crypto=g("crypto"))},o.prototype._initNodeRequire=function(g,E){var D=E.getConfig().getOptionsLiteral().nodeCachedData;if(!D||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;var p=this,f=g("module");function e(C){var R=C.constructor,A=function(i){try{return C.require(i)}finally{}};return A.resolve=function(i,s){return R._resolveFilename(i,C,!1,s)},A.resolve.paths=function(i){return R._resolveLookupPaths(i,C)},A.main=process.mainModule,A.extensions=R._extensions,A.cache=R._cache,A}f.prototype._compile=function(C,R){var A=f.wrap(C.replace(/^#!.*/,"")),_=E.getRecorder(),i=p._getCachedDataPath(D,R),s={filename:R},a;try{var l=p._fs.readFileSync(i);a=l.slice(0,16),s.cachedData=l.slice(16),_.record(60,i)}catch{_.record(61,i)}var u=new p._vm.Script(A,s),m=u.runInThisContext(s),h=p._path.dirname(R),b=e(this),w=[this.exports,b,this,R,h,process,Oe,Buffer],L=m.apply(this.exports,w);return p._handleCachedData(u,A,i,!s.cachedData,E),p._verifyCachedData(u,A,i,a,E),L}},o.prototype.load=function(g,E,D,p){var f=this,e=g.getConfig().getOptionsLiteral(),C=N(g.getRecorder(),e.nodeRequire||O.global.nodeRequire),R=e.nodeInstrumenter||function(m){return m};this._init(C),this._initNodeRequire(C,g);var A=g.getRecorder();if(/^node\|/.test(E)){var _=E.split("|"),i=null;try{i=C(_[1])}catch(m){p(m);return}g.enqueueDefineAnonymousModule([],function(){return i}),D()}else{E=O.Utilities.fileUriToFilePath(this._env.isWindows,E);var s=this._path.normalize(E),a=this._getElectronRendererScriptPathOrUri(s),l=Boolean(e.nodeCachedData),u=l?this._getCachedDataPath(e.nodeCachedData,E):void 0;this._readSourceAndCachedData(s,u,A,function(m,h,b,w){if(m){p(m);return}var L;h.charCodeAt(0)===o._BOM?L=o._PREFIX+h.substring(1)+o._SUFFIX:L=o._PREFIX+h+o._SUFFIX,L=R(L,s);var v={filename:a,cachedData:b},F=f._createAndEvalScript(g,L,v,D,p);f._handleCachedData(F,L,u,l&&!b,g),f._verifyCachedData(F,L,u,w,g)})}},o.prototype._createAndEvalScript=function(g,E,D,p,f){var e=g.getRecorder();e.record(31,D.filename);var C=new this._vm.Script(E,D),R=C.runInThisContext(D),A=g.getGlobalAMDDefineFunc(),_=!1,i=function(){return _=!0,A.apply(null,arguments)};return i.amd=A.amd,R.call(O.global,g.getGlobalAMDRequireFunc(),i,D.filename,this._path.dirname(D.filename)),e.record(32,D.filename),_?p():f(new Error("Didn't receive define call in "+D.filename+"!")),C},o.prototype._getElectronRendererScriptPathOrUri=function(g){if(!this._env.isElectronRenderer)return g;var E=g.match(/^([a-z])\:(.*)/i);return E?"file:///"+(E[1].toUpperCase()+":"+E[2]).replace(/\\/g,"/"):"file://"+g},o.prototype._getCachedDataPath=function(g,E){var D=this._crypto.createHash("md5").update(E,"utf8").update(g.seed,"utf8").update(process.arch,"").digest("hex"),p=this._path.basename(E).replace(/\.js$/,"");return this._path.join(g.path,p+"-"+D+".code")},o.prototype._handleCachedData=function(g,E,D,p,f){var e=this;g.cachedDataRejected?this._fs.unlink(D,function(C){f.getRecorder().record(62,D),e._createAndWriteCachedData(g,E,D,f),C&&f.getConfig().onError(C)}):p&&this._createAndWriteCachedData(g,E,D,f)},o.prototype._createAndWriteCachedData=function(g,E,D,p){var f=this,e=Math.ceil(p.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),C=-1,R=0,A=void 0,_=function(){setTimeout(function(){A||(A=f._crypto.createHash("md5").update(E,"utf8").digest());var i=g.createCachedData();if(!(i.length===0||i.length===C||R>=5)){if(i.length<C){_();return}C=i.length,f._fs.writeFile(D,Buffer.concat([A,i]),function(s){s&&p.getConfig().onError(s),p.getRecorder().record(63,D),_()})}},e*Math.pow(4,R++))};_()},o.prototype._readSourceAndCachedData=function(g,E,D,p){if(!E)this._fs.readFile(g,{encoding:"utf8"},p);else{var f=void 0,e=void 0,C=void 0,R=2,A=function(_){_?p(_):--R==0&&p(void 0,f,e,C)};this._fs.readFile(g,{encoding:"utf8"},function(_,i){f=i,A(_)}),this._fs.readFile(E,function(_,i){!_&&i&&i.length>0?(C=i.slice(0,16),e=i.slice(16),D.record(60,E)):D.record(61,E),A()})}},o.prototype._verifyCachedData=function(g,E,D,p,f){var e=this;!p||g.cachedDataRejected||setTimeout(function(){var C=e._crypto.createHash("md5").update(E,"utf8").digest();p.equals(C)||(f.getConfig().onError(new Error("FAILED TO VERIFY CACHED DATA, deleting stale '"+D+"' now, but a RESTART IS REQUIRED")),e._fs.unlink(D,function(R){R&&f.getConfig().onError(R)}))},Math.ceil(5e3*(1+Math.random())))},o._BOM=65279,o._PREFIX="(function (require, define, __filename, __dirname) { ",o._SUFFIX=`
});`,o}();function N(o,g){if(g.__$__isRecorded)return g;var E=function(p){o.record(33,p);try{return g(p)}finally{o.record(34,p)}};return E.__$__isRecorded=!0,E}O.ensureRecordedNodeRequire=N;function d(o){return new n(o)}O.createScriptLoader=d})(ue||(ue={}));var ue;(function(O){var n=function(){function d(o){var g=o.lastIndexOf("/");g!==-1?this.fromModulePath=o.substr(0,g+1):this.fromModulePath=""}return d._normalizeModuleId=function(o){var g=o,E;for(E=/\/\.\//;E.test(g);)g=g.replace(E,"/");for(g=g.replace(/^\.\//g,""),E=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;E.test(g);)g=g.replace(E,"/");return g=g.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),g},d.prototype.resolveModule=function(o){var g=o;return O.Utilities.isAbsolutePath(g)||(O.Utilities.startsWith(g,"./")||O.Utilities.startsWith(g,"../"))&&(g=d._normalizeModuleId(this.fromModulePath+g)),g},d.ROOT=new d(""),d}();O.ModuleIdResolver=n;var y=function(){function d(o,g,E,D,p,f){this.id=o,this.strId=g,this.dependencies=E,this._callback=D,this._errorback=p,this.moduleIdResolver=f,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}return d._safeInvokeFunction=function(o,g){try{return{returnedValue:o.apply(O.global,g),producedError:null}}catch(E){return{returnedValue:null,producedError:E}}},d._invokeFactory=function(o,g,E,D){return o.shouldInvokeFactory(g)?o.shouldCatchError()?this._safeInvokeFunction(E,D):{returnedValue:E.apply(O.global,D),producedError:null}:{returnedValue:null,producedError:null}},d.prototype.complete=function(o,g,E,D){this._isComplete=!0;var p=null;if(this._callback)if(typeof this._callback=="function"){o.record(21,this.strId);var f=d._invokeFactory(g,this.strId,this._callback,E);p=f.producedError,o.record(22,this.strId),!p&&typeof f.returnedValue!="undefined"&&(!this.exportsPassedIn||O.Utilities.isEmpty(this.exports))&&(this.exports=f.returnedValue)}else this.exports=this._callback;if(p){var e=O.ensureError(p);e.phase="factory",e.moduleId=this.strId,e.neededBy=D(this.id),this.error=e,g.onError(e)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null},d.prototype.onDependencyError=function(o){return this._isComplete=!0,this.error=o,this._errorback?(this._errorback(o),!0):!1},d.prototype.isComplete=function(){return this._isComplete},d}();O.Module=y;var t=function(){function d(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}return d.prototype.getMaxModuleId=function(){return this._nextId},d.prototype.getModuleId=function(o){var g=this._strModuleIdToIntModuleId.get(o);return typeof g=="undefined"&&(g=this._nextId++,this._strModuleIdToIntModuleId.set(o,g),this._intModuleIdToStrModuleId[g]=o),g},d.prototype.getStrModuleId=function(o){return this._intModuleIdToStrModuleId[o]},d}(),M=function(){function d(o){this.id=o}return d.EXPORTS=new d(0),d.MODULE=new d(1),d.REQUIRE=new d(2),d}();O.RegularDependency=M;var c=function(){function d(o,g,E){this.id=o,this.pluginId=g,this.pluginParam=E}return d}();O.PluginDependency=c;var N=function(){function d(o,g,E,D,p){p===void 0&&(p=0),this._env=o,this._scriptLoader=g,this._loaderAvailableTimestamp=p,this._defineFunc=E,this._requireFunc=D,this._moduleIdProvider=new t,this._config=new O.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[]}return d.prototype.reset=function(){return new d(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)},d.prototype.getGlobalAMDDefineFunc=function(){return this._defineFunc},d.prototype.getGlobalAMDRequireFunc=function(){return this._requireFunc},d._findRelevantLocationInStack=function(o,g){for(var E=function(s){return s.replace(/\\/g,"/")},D=E(o),p=g.split(/\n/),f=0;f<p.length;f++){var e=p[f].match(/(.*):(\d+):(\d+)\)?$/);if(e){var C=e[1],R=e[2],A=e[3],_=Math.max(C.lastIndexOf(" ")+1,C.lastIndexOf("(")+1);if(C=C.substr(_),C=E(C),C===D){var i={line:parseInt(R,10),col:parseInt(A,10)};return i.line===1&&(i.col-="(function (require, define, __filename, __dirname) { ".length),i}}}throw new Error("Could not correlate define call site for needle "+o)},d.prototype.getBuildInfo=function(){if(!this._config.isBuild())return null;for(var o=[],g=0,E=0,D=this._modules2.length;E<D;E++){var p=this._modules2[E];if(!!p){var f=this._buildInfoPath[p.id]||null,e=this._buildInfoDefineStack[p.id]||null,C=this._buildInfoDependencies[p.id];o[g++]={id:p.strId,path:f,defineLocation:f&&e?d._findRelevantLocationInStack(f,e):null,dependencies:C,shim:null,exports:p.exports}}}return o},d.prototype.getRecorder=function(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new O.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=O.NullLoaderEventRecorder.INSTANCE),this._recorder},d.prototype.getLoaderEvents=function(){return this.getRecorder().getEvents()},d.prototype.enqueueDefineAnonymousModule=function(o,g){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");var E=null;this._config.isBuild()&&(E=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:E,dependencies:o,callback:g}},d.prototype.defineModule=function(o,g,E,D,p,f){var e=this;f===void 0&&(f=new n(o));var C=this._moduleIdProvider.getModuleId(o);if(this._modules2[C]){this._config.isDuplicateMessageIgnoredFor(o)||console.warn("Duplicate definition of module '"+o+"'");return}var R=new y(C,o,this._normalizeDependencies(g,f),E,D,f);this._modules2[C]=R,this._config.isBuild()&&(this._buildInfoDefineStack[C]=p,this._buildInfoDependencies[C]=(R.dependencies||[]).map(function(A){return e._moduleIdProvider.getStrModuleId(A.id)})),this._resolve(R)},d.prototype._normalizeDependency=function(o,g){if(o==="exports")return M.EXPORTS;if(o==="module")return M.MODULE;if(o==="require")return M.REQUIRE;var E=o.indexOf("!");if(E>=0){var D=g.resolveModule(o.substr(0,E)),p=g.resolveModule(o.substr(E+1)),f=this._moduleIdProvider.getModuleId(D+"!"+p),e=this._moduleIdProvider.getModuleId(D);return new c(f,e,p)}return new M(this._moduleIdProvider.getModuleId(g.resolveModule(o)))},d.prototype._normalizeDependencies=function(o,g){for(var E=[],D=0,p=0,f=o.length;p<f;p++)E[D++]=this._normalizeDependency(o[p],g);return E},d.prototype._relativeRequire=function(o,g,E,D){if(typeof g=="string")return this.synchronousRequire(g,o);this.defineModule(O.Utilities.generateAnonymousModule(),g,E,D,null,o)},d.prototype.synchronousRequire=function(o,g){g===void 0&&(g=new n(o));var E=this._normalizeDependency(o,g),D=this._modules2[E.id];if(!D)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+o+"'. This is the first mention of this module!");if(!D.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+o+"'. This module has not been resolved completely yet.");if(D.error)throw D.error;return D.exports},d.prototype.configure=function(o,g){var E=this._config.shouldRecordStats();g?this._config=new O.Configuration(this._env,o):this._config=this._config.cloneAndMerge(o),this._config.shouldRecordStats()&&!E&&(this._recorder=null)},d.prototype.getConfig=function(){return this._config},d.prototype._onLoad=function(o){if(this._currentAnonymousDefineCall!==null){var g=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(o),g.dependencies,g.callback,null,g.stack)}},d.prototype._createLoadError=function(o,g){var E=this,D=this._moduleIdProvider.getStrModuleId(o),p=(this._inverseDependencies2[o]||[]).map(function(e){return E._moduleIdProvider.getStrModuleId(e)}),f=O.ensureError(g);return f.phase="loading",f.moduleId=D,f.neededBy=p,f},d.prototype._onLoadError=function(o,g){var E=this._createLoadError(o,g);this._modules2[o]||(this._modules2[o]=new y(o,this._moduleIdProvider.getStrModuleId(o),[],function(){},null,null));for(var D=[],p=0,f=this._moduleIdProvider.getMaxModuleId();p<f;p++)D[p]=!1;var e=!1,C=[];for(C.push(o),D[o]=!0;C.length>0;){var R=C.shift(),A=this._modules2[R];A&&(e=A.onDependencyError(E)||e);var _=this._inverseDependencies2[R];if(_)for(var p=0,f=_.length;p<f;p++){var i=_[p];D[i]||(C.push(i),D[i]=!0)}}e||this._config.onError(E)},d.prototype._hasDependencyPath=function(o,g){var E=this._modules2[o];if(!E)return!1;for(var D=[],p=0,f=this._moduleIdProvider.getMaxModuleId();p<f;p++)D[p]=!1;var e=[];for(e.push(E),D[o]=!0;e.length>0;){var C=e.shift(),R=C.dependencies;if(R)for(var p=0,f=R.length;p<f;p++){var A=R[p];if(A.id===g)return!0;var _=this._modules2[A.id];_&&!D[A.id]&&(D[A.id]=!0,e.push(_))}}return!1},d.prototype._findCyclePath=function(o,g,E){if(o===g||E===50)return[o];var D=this._modules2[o];if(!D)return null;var p=D.dependencies;if(p)for(var f=0,e=p.length;f<e;f++){var C=this._findCyclePath(p[f].id,g,E+1);if(C!==null)return C.push(o),C}return null},d.prototype._createRequire=function(o){var g=this,E=function(D,p,f){return g._relativeRequire(o,D,p,f)};return E.toUrl=function(D){return g._config.requireToUrl(o.resolveModule(D))},E.getStats=function(){return g.getLoaderEvents()},E.hasDependencyCycle=function(){return g._hasDependencyCycle},E.config=function(D,p){p===void 0&&(p=!1),g.configure(D,p)},E.__$__nodeRequire=O.global.nodeRequire,E},d.prototype._loadModule=function(o){var g=this;if(!(this._modules2[o]||this._knownModules2[o])){this._knownModules2[o]=!0;var E=this._moduleIdProvider.getStrModuleId(o),D=this._config.moduleIdToPaths(E),p=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(E.indexOf("/")===-1||p.test(E))&&D.push("node|"+E);var f=-1,e=function(C){if(f++,f>=D.length)g._onLoadError(o,C);else{var R=D[f],A=g.getRecorder();if(g._config.isBuild()&&R==="empty:"){g._buildInfoPath[o]=R,g.defineModule(g._moduleIdProvider.getStrModuleId(o),[],null,null,null),g._onLoad(o);return}A.record(10,R),g._scriptLoader.load(g,R,function(){g._config.isBuild()&&(g._buildInfoPath[o]=R),A.record(11,R),g._onLoad(o)},function(_){A.record(12,R),e(_)})}};e(null)}},d.prototype._loadPluginDependency=function(o,g){var E=this;if(!(this._modules2[g.id]||this._knownModules2[g.id])){this._knownModules2[g.id]=!0;var D=function(p){E.defineModule(E._moduleIdProvider.getStrModuleId(g.id),[],p,null,null)};D.error=function(p){E._config.onError(E._createLoadError(g.id,p))},o.load(g.pluginParam,this._createRequire(n.ROOT),D,this._config.getOptionsLiteral())}},d.prototype._resolve=function(o){var g=this,E=o.dependencies;if(E)for(var D=0,p=E.length;D<p;D++){var f=E[D];if(f===M.EXPORTS){o.exportsPassedIn=!0,o.unresolvedDependenciesCount--;continue}if(f===M.MODULE){o.unresolvedDependenciesCount--;continue}if(f===M.REQUIRE){o.unresolvedDependenciesCount--;continue}var e=this._modules2[f.id];if(e&&e.isComplete()){if(e.error){o.onDependencyError(e.error);return}o.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(f.id,o.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(f.id)+"' and '"+this._moduleIdProvider.getStrModuleId(o.id)+"'. The cyclic path follows:");var C=this._findCyclePath(f.id,o.id,0)||[];C.reverse(),C.push(f.id),console.warn(C.map(function(_){return g._moduleIdProvider.getStrModuleId(_)}).join(` => 
`)),o.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[f.id]=this._inverseDependencies2[f.id]||[],this._inverseDependencies2[f.id].push(o.id),f instanceof c){var R=this._modules2[f.pluginId];if(R&&R.isComplete()){this._loadPluginDependency(R.exports,f);continue}var A=this._inversePluginDependencies2.get(f.pluginId);A||(A=[],this._inversePluginDependencies2.set(f.pluginId,A)),A.push(f),this._loadModule(f.pluginId);continue}this._loadModule(f.id)}o.unresolvedDependenciesCount===0&&this._onModuleComplete(o)},d.prototype._onModuleComplete=function(o){var g=this,E=this.getRecorder();if(!o.isComplete()){var D=o.dependencies,p=[];if(D)for(var f=0,e=D.length;f<e;f++){var C=D[f];if(C===M.EXPORTS){p[f]=o.exports;continue}if(C===M.MODULE){p[f]={id:o.strId,config:function(){return g._config.getConfigForModule(o.strId)}};continue}if(C===M.REQUIRE){p[f]=this._createRequire(o.moduleIdResolver);continue}var R=this._modules2[C.id];if(R){p[f]=R.exports;continue}p[f]=null}var A=function(l){return(g._inverseDependencies2[l]||[]).map(function(u){return g._moduleIdProvider.getStrModuleId(u)})};o.complete(E,this._config,p,A);var _=this._inverseDependencies2[o.id];if(this._inverseDependencies2[o.id]=null,_)for(var f=0,e=_.length;f<e;f++){var i=_[f],s=this._modules2[i];s.unresolvedDependenciesCount--,s.unresolvedDependenciesCount===0&&this._onModuleComplete(s)}var a=this._inversePluginDependencies2.get(o.id);if(a){this._inversePluginDependencies2.delete(o.id);for(var f=0,e=a.length;f<e;f++)this._loadPluginDependency(o.exports,a[f])}}},d}();O.ModuleManager=N})(ue||(ue={}));var Y,ue;(function(O){var n=new O.Environment,y=null,t=function(d,o,g){typeof d!="string"&&(g=o,o=d,d=null),(typeof o!="object"||!Array.isArray(o))&&(g=o,o=null),o||(o=["require","exports","module"]),d?y.defineModule(d,o,g,null,null):y.enqueueDefineAnonymousModule(o,g)};t.amd={jQuery:!0};var M=function(d,o){o===void 0&&(o=!1),y.configure(d,o)},c=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){M(arguments[0]);return}if(typeof arguments[0]=="string")return y.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){y.defineModule(O.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};c.config=M,c.getConfig=function(){return y.getConfig().getOptionsLiteral()},c.reset=function(){y=y.reset()},c.getBuildInfo=function(){return y.getBuildInfo()},c.getStats=function(){return y.getLoaderEvents()},c.define=t;function N(){if(typeof O.global.require!="undefined"||typeof require!="undefined"){var d=O.global.require||require;if(typeof d=="function"&&typeof d.resolve=="function"){var o=O.ensureRecordedNodeRequire(y.getRecorder(),d);O.global.nodeRequire=o,c.nodeRequire=o,c.__$__nodeRequire=o}}n.isNode&&!n.isElectronRenderer&&!n.isElectronNodeIntegrationWebWorker?(module.exports=c,require=c):(n.isElectronRenderer||(O.global.define=t),O.global.require=c)}O.init=N,(typeof O.global.define!="function"||!O.global.define.amd)&&(y=new O.ModuleManager(n,O.createScriptLoader(n),t,c,O.Utilities.getHighPerformanceTimestamp()),typeof O.global.require!="undefined"&&typeof O.global.require!="function"&&c.config(O.global.require),Y=function(){return t.apply(null,arguments)},Y.amd=t.amd,typeof doNotInitLoader=="undefined"&&N())})(ue||(ue={})),Y(Z[23],J([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.load=n.create=n.setPseudoTranslation=n.getConfiguredDefaultLocale=n.localize=void 0;let y=typeof document!="undefined"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const t="i-default";function M(e,C){let R;return C.length===0?R=e:R=e.replace(/\{(\d+)\}/g,(A,_)=>{const i=_[0],s=C[i];let a=A;return typeof s=="string"?a=s:(typeof s=="number"||typeof s=="boolean"||s===void 0||s===null)&&(a=String(s)),a}),y&&(R="\uFF3B"+R.replace(/[aouei]/g,"$&$&")+"\uFF3D"),R}function c(e,C){let R=e[C];return R||(R=e["*"],R)?R:null}function N(e){return e.charAt(e.length-1)==="/"?e:e+"/"}async function d(e,C,R){const A=N(e)+N(C)+"vscode/"+N(R),_=await fetch(A);if(_.ok)return await _.json();throw new Error(`${_.status} - ${_.statusText}`)}function o(e){return function(C,R){const A=Array.prototype.slice.call(arguments,2);return M(e[C],A)}}function g(e,C,...R){return M(C,R)}n.localize=g;function E(e){}n.getConfiguredDefaultLocale=E;function D(e){y=e}n.setPseudoTranslation=D;function p(e,C){return{localize:o(C[e]),getConfiguredDefaultLocale:C.getConfiguredDefaultLocale??(R=>{})}}n.create=p;function f(e,C,R,A){const _=A["vs/nls"]??{};if(!e||e.length===0)return R({localize:g,getConfiguredDefaultLocale:()=>_.availableLanguages?.["*"]});const i=_.availableLanguages?c(_.availableLanguages,e):null,s=i===null||i===t;let a=".nls";s||(a=a+"."+i);const l=u=>{Array.isArray(u)?u.localize=o(u):u.localize=o(u[e]),u.getConfiguredDefaultLocale=()=>_.availableLanguages?.["*"],R(u)};typeof _.loadBundle=="function"?_.loadBundle(e,i,(u,m)=>{u?C([e+".nls"],l):l(m)}):_.translationServiceUrl&&!s?(async()=>{try{const u=await d(_.translationServiceUrl,i,e);return l(u)}catch(u){if(!i.includes("-"))return console.error(u),C([e+".nls"],l);try{const m=i.split("-")[0],h=await d(_.translationServiceUrl,m,e);return _.availableLanguages??(_.availableLanguages={}),_.availableLanguages["*"]=m,l(h)}catch(m){return console.error(m),C([e+".nls"],l)}}})():C([e+a],l,u=>{if(a===".nls"){console.error("Failed trying to load default language strings",u);return}console.error(`Failed to load message bundle for language ${i}. Falling back to the default language:`,u),C([e+".nls"],l)})}n.load=f}),function(){const O=self.MonacoEnvironment,n=O&&O.baseUrl?O.baseUrl:"../../../",y=typeof self.trustedTypes?.createPolicy=="function"?self.trustedTypes?.createPolicy("amdLoader",{createScriptURL:g=>g,createScript:(g,...E)=>{const D=E.slice(0,-1).join(","),p=E.pop().toString();return`(function anonymous(${D}) { ${p}
})`}}):void 0;function t(){try{return(y?self.eval(y.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}function M(){return new Promise((g,E)=>{if(typeof self.define=="function"&&self.define.amd)return g();const D=n+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(D)&&D.substring(0,self.origin.length)!==self.origin)&&t()){fetch(D).then(f=>{if(f.status!==200)throw new Error(f.statusText);return f.text()}).then(f=>{f=`${f}
//# sourceURL=${D}`,(y?self.eval(y.createScript("",f)):new Function(f)).call(self),g()}).then(void 0,E);return}y?importScripts(y.createScriptURL(D)):importScripts(D),g()})}function c(){require.config({baseUrl:n,catchError:!0,trustedTypesPolicy:y,amdModulesPattern:/^vs\//})}function N(g){M().then(()=>{c(),require([g],function(E){setTimeout(function(){const D=E.create((p,f)=>{self.postMessage(p,f)},null);for(self.onmessage=p=>D.onmessage(p.data,p.ports);o.length>0;)self.onmessage(o.shift())},0)})})}typeof self.define=="function"&&self.define.amd&&c();let d=!0;const o=[];self.onmessage=g=>{if(!d){o.push(g);return}d=!1,N(g.data)}}(),Y(Z[24],J([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.assertNever=n.ok=void 0;function y(M,c){if(!M)throw new Error(c?`Assertion failed (${c})`:"Assertion Failed")}n.ok=y;function t(M,c="Unreachable"){throw new Error(c)}n.assertNever=t}),Y(Z[25],J([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CSSIcon=n.getClassNamesArray=n.Codicon=n.getCodiconAriaLabel=void 0;function y(N){return N?N.replace(/\$\((.*?)\)/g,(d,o)=>` ${o} `).trim():""}n.getCodiconAriaLabel=y;class t{constructor(d,o,g){this.id=d,this.definition=o,this.description=g,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}n.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",t.circleFilled.definition),t.closeDirty=new t("close-dirty",t.circleFilled.definition),t.terminalDecorationSuccess=new t("terminal-decoration-success",t.circleFilled.definition),t.debugBreakpoint=new t("debug-breakpoint",t.circleFilled.definition),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",t.circleFilled.definition),t.debugHint=new t("debug-hint",t.circleFilled.definition),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circle=new t("circle",{fontCharacter:"\\eabc"}),t.circleOutline=new t("circle-outline",t.circle.definition),t.terminalDecorationIncomplete=new t("terminal-decoration-incomplete",t.circle.definition),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",t.circle.definition),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.terminalDecorationMark=new t("terminal-decoration-mark",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLarge=new t("circle-large",{fontCharacter:"\\ebb5"}),t.circleLargeOutline=new t("circle-large-outline",t.circleLarge.definition),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.terminalDecorationError=new t("terminal-decoration-error",t.errorSmall.definition),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\ec09"}),t.commentUnresolved=new t("comment-unresolved",{fontCharacter:"\\ec0a"}),t.gitPullRequestGoToChanges=new t("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),t.gitPullRequestNewChanges=new t("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function M(N,d){const o=["codicon","codicon-"+N];return d&&o.push("codicon-modifier-"+d),o}n.getClassNamesArray=M;var c;(function(N){N.iconNameSegment="[A-Za-z0-9]+",N.iconNameExpression="[A-Za-z0-9-]+",N.iconModifierExpression="~[A-Za-z]+",N.iconNameCharacter="[A-Za-z0-9~-]";const d=new RegExp(`^(${N.iconNameExpression})(${N.iconModifierExpression})?$`);function o(D){if(D instanceof t)return["codicon","codicon-"+D.id];const p=d.exec(D.id);if(!p)return o(t.error);const[,f,e]=p,C=["codicon","codicon-"+f];return e&&C.push("codicon-modifier-"+e.substr(1)),C}N.asClassNameArray=o;function g(D){return o(D).join(" ")}N.asClassName=g;function E(D){return"."+o(D).join(".")}N.asCSSSelector=E})(c=n.CSSIcon||(n.CSSIcon={}))}),Y(Z[26],J([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DiffChange=void 0;class y{constructor(M,c,N,d){this.originalStart=M,this.originalLength=c,this.modifiedStart=N,this.modifiedLength=d}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}n.DiffChange=y}),Y(Z[8],J([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.BugIndicatingError=n.ErrorNoTelemetry=n.ExpectedError=n.NotSupportedError=n.NotImplementedError=n.getErrorMessage=n.disposed=n.readonly=n.illegalState=n.illegalArgument=n.canceled=n.CancellationError=n.isCancellationError=n.transformErrorForSerialization=n.onUnexpectedExternalError=n.onUnexpectedError=n.setUnexpectedErrorHandler=n.errorHandler=n.ErrorHandler=void 0;class y{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(l){setTimeout(()=>{throw l.stack?i.isErrorNoTelemetry(l)?new i(l.message+`

`+l.stack):new Error(l.message+`

`+l.stack):l},0)}}addListener(l){return this.listeners.push(l),()=>{this._removeListener(l)}}emit(l){this.listeners.forEach(u=>{u(l)})}_removeListener(l){this.listeners.splice(this.listeners.indexOf(l),1)}setUnexpectedErrorHandler(l){this.unexpectedErrorHandler=l}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(l){this.unexpectedErrorHandler(l),this.emit(l)}onUnexpectedExternalError(l){this.unexpectedErrorHandler(l)}}n.ErrorHandler=y,n.errorHandler=new y;function t(a){n.errorHandler.setUnexpectedErrorHandler(a)}n.setUnexpectedErrorHandler=t;function M(a){o(a)||n.errorHandler.onUnexpectedError(a)}n.onUnexpectedError=M;function c(a){o(a)||n.errorHandler.onUnexpectedExternalError(a)}n.onUnexpectedExternalError=c;function N(a){if(a instanceof Error){const{name:l,message:u}=a,m=a.stacktrace||a.stack;return{$isError:!0,name:l,message:u,stack:m,noTelemetry:i.isErrorNoTelemetry(a)}}return a}n.transformErrorForSerialization=N;const d="Canceled";function o(a){return a instanceof g?!0:a instanceof Error&&a.name===d&&a.message===d}n.isCancellationError=o;class g extends Error{constructor(){super(d);this.name=this.message}}n.CancellationError=g;function E(){const a=new Error(d);return a.name=a.message,a}n.canceled=E;function D(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}n.illegalArgument=D;function p(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}n.illegalState=p;function f(a){return a?new Error(`readonly property '${a} cannot be changed'`):new Error("readonly property cannot be changed")}n.readonly=f;function e(a){const l=new Error(`${a} has been disposed`);return l.name="DISPOSED",l}n.disposed=e;function C(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}n.getErrorMessage=C;class R extends Error{constructor(l){super("NotImplemented");l&&(this.message=l)}}n.NotImplementedError=R;class A extends Error{constructor(l){super("NotSupported");l&&(this.message=l)}}n.NotSupportedError=A;class _ extends Error{constructor(){super(...arguments);this.isExpected=!0}}n.ExpectedError=_;class i extends Error{constructor(l){super(l);this.name="ErrorNoTelemetry"}static fromError(l){if(l instanceof i)return l;const u=new i;return u.message=l.message,u.stack=l.stack,u}static isErrorNoTelemetry(l){return l.name==="ErrorNoTelemetry"}}n.ErrorNoTelemetry=i;class s extends Error{constructor(l){super(l||"An unexpected bug occurred.");Object.setPrototypeOf(this,s.prototype);debugger}}n.BugIndicatingError=s}),Y(Z[27],J([0,1,8]),function(O,n,y){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CallbackIterable=n.ArrayQueue=n.findMinBy=n.findLastMaxBy=n.findMaxBy=n.numberComparator=n.tieBreakComparators=n.compareBy=n.CompareResult=n.splice=n.insertInto=n.mapFind=n.getRandomElement=n.asArray=n.mapArrayOrNot=n.pushMany=n.pushToEnd=n.pushToStart=n.shuffle=n.arrayInsert=n.remove=n.insert=n.index=n.range=n.flatten=n.commonPrefixLength=n.lastOrDefault=n.firstOrDefault=n.lastIndex=n.findLast=n.uniqueFilter=n.distinct=n.isNonEmptyArray=n.isFalsyOrEmpty=n.move=n.coalesceInPlace=n.coalesce=n.topAsync=n.top=n.delta=n.sortedDiff=n.groupBy=n.quickSelect=n.findFirstInSorted=n.binarySearch2=n.binarySearch=n.removeFastWithoutKeepingOrder=n.equals=n.tail2=n.tail=void 0;function t(S,k=0){return S[S.length-(1+k)]}n.tail=t;function M(S){if(S.length===0)throw new Error("Invalid tail call");return[S.slice(0,S.length-1),S[S.length-1]]}n.tail2=M;function c(S,k,I=(q,H)=>q===H){if(S===k)return!0;if(!S||!k||S.length!==k.length)return!1;for(let q=0,H=S.length;q<H;q++)if(!I(S[q],k[q]))return!1;return!0}n.equals=c;function N(S,k){const I=S.length-1;k<I&&(S[k]=S[I]),S.pop()}n.removeFastWithoutKeepingOrder=N;function d(S,k,I){return o(S.length,q=>I(S[q],k))}n.binarySearch=d;function o(S,k){let I=0,q=S-1;for(;I<=q;){const H=(I+q)/2|0,se=k(H);if(se<0)I=H+1;else if(se>0)q=H-1;else return H}return-(I+1)}n.binarySearch2=o;function g(S,k){let I=0,q=S.length;if(q===0)return 0;for(;I<q;){const H=Math.floor((I+q)/2);k(S[H])?q=H:I=H+1}return I}n.findFirstInSorted=g;function E(S,k,I){if(S=S|0,S>=k.length)throw new TypeError("invalid index");const q=k[Math.floor(k.length*Math.random())],H=[],se=[],ie=[];for(const ce of k){const fe=I(ce,q);fe<0?H.push(ce):fe>0?se.push(ce):ie.push(ce)}return S<H.length?E(S,H,I):S<H.length+ie.length?ie[0]:E(S-(H.length+ie.length),se,I)}n.quickSelect=E;function D(S,k){const I=[];let q;for(const H of S.slice(0).sort(k))!q||k(q[0],H)!==0?(q=[H],I.push(q)):q.push(H);return I}n.groupBy=D;function p(S,k,I){const q=[];function H(ce,fe,ge){if(fe===0&&ge.length===0)return;const me=q[q.length-1];me&&me.start+me.deleteCount===ce?(me.deleteCount+=fe,me.toInsert.push(...ge)):q.push({start:ce,deleteCount:fe,toInsert:ge})}let se=0,ie=0;for(;;){if(se===S.length){H(se,0,k.slice(ie));break}if(ie===k.length){H(se,S.length-se,[]);break}const ce=S[se],fe=k[ie],ge=I(ce,fe);ge===0?(se+=1,ie+=1):ge<0?(H(se,1,[]),se+=1):ge>0&&(H(se,0,[fe]),ie+=1)}return q}n.sortedDiff=p;function f(S,k,I){const q=p(S,k,I),H=[],se=[];for(const ie of q)H.push(...S.slice(ie.start,ie.start+ie.deleteCount)),se.push(...ie.toInsert);return{removed:H,added:se}}n.delta=f;function e(S,k,I){if(I===0)return[];const q=S.slice(0,I).sort(k);return R(S,k,q,I,S.length),q}n.top=e;function C(S,k,I,q,H){return I===0?Promise.resolve([]):new Promise((se,ie)=>{(async()=>{const ce=S.length,fe=S.slice(0,I).sort(k);for(let ge=I,me=Math.min(I+q,ce);ge<ce;ge=me,me=Math.min(me+q,ce)){if(ge>I&&await new Promise(Se=>setTimeout(Se)),H&&H.isCancellationRequested)throw new y.CancellationError;R(S,k,fe,ge,me)}return fe})().then(se,ie)})}n.topAsync=C;function R(S,k,I,q,H){for(const se=I.length;q<H;q++){const ie=S[q];if(k(ie,I[se-1])<0){I.pop();const ce=g(I,fe=>k(ie,fe)<0);I.splice(ce,0,ie)}}}function A(S){return S.filter(k=>!!k)}n.coalesce=A;function _(S){let k=0;for(let I=0;I<S.length;I++)S[I]&&(S[k]=S[I],k+=1);S.length=k}n.coalesceInPlace=_;function i(S,k,I){S.splice(I,0,S.splice(k,1)[0])}n.move=i;function s(S){return!Array.isArray(S)||S.length===0}n.isFalsyOrEmpty=s;function a(S){return Array.isArray(S)&&S.length>0}n.isNonEmptyArray=a;function l(S,k=I=>I){const I=new Set;return S.filter(q=>{const H=k(q);return I.has(H)?!1:(I.add(H),!0)})}n.distinct=l;function u(S){const k=new Set;return I=>{const q=S(I);return k.has(q)?!1:(k.add(q),!0)}}n.uniqueFilter=u;function m(S,k){const I=h(S,k);if(I!==-1)return S[I]}n.findLast=m;function h(S,k){for(let I=S.length-1;I>=0;I--){const q=S[I];if(k(q))return I}return-1}n.lastIndex=h;function b(S,k){return S.length>0?S[0]:k}n.firstOrDefault=b;function w(S,k){return S.length>0?S[S.length-1]:k}n.lastOrDefault=w;function L(S,k,I=(q,H)=>q===H){let q=0;for(let H=0,se=Math.min(S.length,k.length);H<se&&I(S[H],k[H]);H++)q++;return q}n.commonPrefixLength=L;function v(S){return[].concat(...S)}n.flatten=v;function F(S,k){let I=typeof k=="number"?S:0;typeof k=="number"?I=S:(I=0,k=S);const q=[];if(I<=k)for(let H=I;H<k;H++)q.push(H);else for(let H=I;H>k;H--)q.push(H);return q}n.range=F;function B(S,k,I){return S.reduce((q,H)=>(q[k(H)]=I?I(H):H,q),Object.create(null))}n.index=B;function U(S,k){return S.push(k),()=>V(S,k)}n.insert=U;function V(S,k){const I=S.indexOf(k);if(I>-1)return S.splice(I,1),k}n.remove=V;function $(S,k,I){const q=S.slice(0,k),H=S.slice(k);return q.concat(I,H)}n.arrayInsert=$;function j(S,k){let I;if(typeof k=="number"){let q=k;I=()=>{const H=Math.sin(q++)*179426549;return H-Math.floor(H)}}else I=Math.random;for(let q=S.length-1;q>0;q-=1){const H=Math.floor(I()*(q+1)),se=S[q];S[q]=S[H],S[H]=se}}n.shuffle=j;function ne(S,k){const I=S.indexOf(k);I>-1&&(S.splice(I,1),S.unshift(k))}n.pushToStart=ne;function oe(S,k){const I=S.indexOf(k);I>-1&&(S.splice(I,1),S.push(k))}n.pushToEnd=oe;function re(S,k){for(const I of k)S.push(I)}n.pushMany=re;function x(S,k){return Array.isArray(S)?S.map(k):k(S)}n.mapArrayOrNot=x;function r(S){return Array.isArray(S)?S:[S]}n.asArray=r;function de(S){return S[Math.floor(Math.random()*S.length)]}n.getRandomElement=de;function Ee(S,k){for(const I of S){const q=k(I);if(q!==void 0)return q}}n.mapFind=Ee;function ye(S,k,I){const q=Ae(S,k),H=S.length,se=I.length;S.length=H+se;for(let ie=H-1;ie>=q;ie--)S[ie+se]=S[ie];for(let ie=0;ie<se;ie++)S[ie+q]=I[ie]}n.insertInto=ye;function Ce(S,k,I,q){const H=Ae(S,k),se=S.splice(H,I);return ye(S,H,q),se}n.splice=Ce;function Ae(S,k){return k<0?Math.max(k+S.length,0):Math.min(k,S.length)}var pe;(function(S){function k(H){return H<0}S.isLessThan=k;function I(H){return H>0}S.isGreaterThan=I;function q(H){return H===0}S.isNeitherLessOrGreaterThan=q,S.greaterThan=1,S.lessThan=-1,S.neitherLessOrGreaterThan=0})(pe=n.CompareResult||(n.CompareResult={}));function Me(S,k){return(I,q)=>k(S(I),S(q))}n.compareBy=Me;function De(...S){return(k,I)=>{for(const q of S){const H=q(k,I);if(!pe.isNeitherLessOrGreaterThan(H))return H}return pe.neitherLessOrGreaterThan}}n.tieBreakComparators=De;const Fe=(S,k)=>S-k;n.numberComparator=Fe;function ee(S,k){if(S.length===0)return;let I=S[0];for(let q=1;q<S.length;q++){const H=S[q];k(H,I)>0&&(I=H)}return I}n.findMaxBy=ee;function G(S,k){if(S.length===0)return;let I=S[0];for(let q=1;q<S.length;q++){const H=S[q];k(H,I)>=0&&(I=H)}return I}n.findLastMaxBy=G;function K(S,k){return ee(S,(I,q)=>-k(I,q))}n.findMinBy=K;class X{constructor(k){this.items=k,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(k){let I=this.firstIdx;for(;I<this.items.length&&k(this.items[I]);)I++;const q=I===this.firstIdx?null:this.items.slice(this.firstIdx,I);return this.firstIdx=I,q}takeFromEndWhile(k){let I=this.lastIdx;for(;I>=0&&k(this.items[I]);)I--;const q=I===this.lastIdx?null:this.items.slice(I+1,this.lastIdx+1);return this.lastIdx=I,q}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const k=this.items[this.firstIdx];return this.firstIdx++,k}removeLast(){const k=this.items[this.lastIdx];return this.lastIdx--,k}takeCount(k){const I=this.items.slice(this.firstIdx,this.firstIdx+k);return this.firstIdx+=k,I}}n.ArrayQueue=X;class te{constructor(k){this.iterate=k}forEach(k){this.iterate(I=>(k(I),!0))}toArray(){const k=[];return this.iterate(I=>(k.push(I),!0)),k}filter(k){return new te(I=>this.iterate(q=>k(q)?I(q):!0))}map(k){return new te(I=>this.iterate(q=>I(k(q))))}some(k){let I=!1;return this.iterate(q=>(I=k(q),!I)),I}findFirst(k){let I;return this.iterate(q=>k(q)?(I=q,!1):!0),I}findLast(k){let I;return this.iterate(q=>(k(q)&&(I=q),!0)),I}findLastMaxBy(k){let I,q=!0;return this.iterate(H=>((q||pe.isGreaterThan(k(H,I)))&&(q=!1,I=H),!0)),I}}n.CallbackIterable=te,te.empty=new te(S=>{})}),Y(Z[12],J([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.once=void 0;function y(t){const M=this;let c=!1,N;return function(){return c||(c=!0,N=t.apply(M,arguments)),N}}n.once=y}),Y(Z[13],J([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Iterable=void 0;var y;(function(t){function M(u){return u&&typeof u=="object"&&typeof u[Symbol.iterator]=="function"}t.is=M;const c=Object.freeze([]);function N(){return c}t.empty=N;function*d(u){yield u}t.single=d;function o(u){return u||c}t.from=o;function g(u){return!u||u[Symbol.iterator]().next().done===!0}t.isEmpty=g;function E(u){return u[Symbol.iterator]().next().value}t.first=E;function D(u,m){for(const h of u)if(m(h))return!0;return!1}t.some=D;function p(u,m){for(const h of u)if(m(h))return h}t.find=p;function*f(u,m){for(const h of u)m(h)&&(yield h)}t.filter=f;function*e(u,m){let h=0;for(const b of u)yield m(b,h++)}t.map=e;function*C(...u){for(const m of u)for(const h of m)yield h}t.concat=C;function*R(u){for(const m of u)for(const h of m)yield h}t.concatNested=R;function A(u,m,h){let b=h;for(const w of u)b=m(b,w);return b}t.reduce=A;function _(u,m){let h=0;for(const b of u)m(b,h++)}t.forEach=_;function*i(u,m,h=u.length){for(m<0&&(m+=u.length),h<0?h+=u.length:h>u.length&&(h=u.length);m<h;m++)yield u[m]}t.slice=i;function s(u,m=Number.POSITIVE_INFINITY){const h=[];if(m===0)return[h,u];const b=u[Symbol.iterator]();for(let w=0;w<m;w++){const L=b.next();if(L.done)return[h,t.empty()];h.push(L.value)}return[h,{[Symbol.iterator](){return b}}]}t.consume=s;function a(u){return s(u)[0]}t.collect=a;function l(u,m,h=(b,w)=>b===w){const b=u[Symbol.iterator](),w=m[Symbol.iterator]();for(;;){const L=b.next(),v=w.next();if(L.done!==v.done)return!1;if(L.done)return!0;if(!h(L.value,v.value))return!1}}t.equals=l})(y=n.Iterable||(n.Iterable={}))}),Y(Z[28],J([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.KeyChord=n.KeyMod=n.KeyCodeUtils=n.IMMUTABLE_KEY_CODE_TO_CODE=n.IMMUTABLE_CODE_TO_KEY_CODE=n.ScanCodeUtils=n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=n.EVENT_KEY_CODE_MAP=n.ScanCode=n.KeyCode=void 0;var y;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.NumLock=78]="NumLock",e[e.ScrollLock=79]="ScrollLock",e[e.Semicolon=80]="Semicolon",e[e.Equal=81]="Equal",e[e.Comma=82]="Comma",e[e.Minus=83]="Minus",e[e.Period=84]="Period",e[e.Slash=85]="Slash",e[e.Backquote=86]="Backquote",e[e.BracketLeft=87]="BracketLeft",e[e.Backslash=88]="Backslash",e[e.BracketRight=89]="BracketRight",e[e.Quote=90]="Quote",e[e.OEM_8=91]="OEM_8",e[e.IntlBackslash=92]="IntlBackslash",e[e.Numpad0=93]="Numpad0",e[e.Numpad1=94]="Numpad1",e[e.Numpad2=95]="Numpad2",e[e.Numpad3=96]="Numpad3",e[e.Numpad4=97]="Numpad4",e[e.Numpad5=98]="Numpad5",e[e.Numpad6=99]="Numpad6",e[e.Numpad7=100]="Numpad7",e[e.Numpad8=101]="Numpad8",e[e.Numpad9=102]="Numpad9",e[e.NumpadMultiply=103]="NumpadMultiply",e[e.NumpadAdd=104]="NumpadAdd",e[e.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=106]="NumpadSubtract",e[e.NumpadDecimal=107]="NumpadDecimal",e[e.NumpadDivide=108]="NumpadDivide",e[e.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",e[e.ABNT_C1=110]="ABNT_C1",e[e.ABNT_C2=111]="ABNT_C2",e[e.AudioVolumeMute=112]="AudioVolumeMute",e[e.AudioVolumeUp=113]="AudioVolumeUp",e[e.AudioVolumeDown=114]="AudioVolumeDown",e[e.BrowserSearch=115]="BrowserSearch",e[e.BrowserHome=116]="BrowserHome",e[e.BrowserBack=117]="BrowserBack",e[e.BrowserForward=118]="BrowserForward",e[e.MediaTrackNext=119]="MediaTrackNext",e[e.MediaTrackPrevious=120]="MediaTrackPrevious",e[e.MediaStop=121]="MediaStop",e[e.MediaPlayPause=122]="MediaPlayPause",e[e.LaunchMediaPlayer=123]="LaunchMediaPlayer",e[e.LaunchMail=124]="LaunchMail",e[e.LaunchApp2=125]="LaunchApp2",e[e.Clear=126]="Clear",e[e.MAX_VALUE=127]="MAX_VALUE"})(y=n.KeyCode||(n.KeyCode={}));var t;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(t=n.ScanCode||(n.ScanCode={}));class M{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(C,R){this._keyCodeToStr[C]=R,this._strToKeyCode[R.toLowerCase()]=C}keyCodeToStr(C){return this._keyCodeToStr[C]}strToKeyCode(C){return this._strToKeyCode[C.toLowerCase()]||0}}const c=new M,N=new M,d=new M;n.EVENT_KEY_CODE_MAP=new Array(230),n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const o=[],g=Object.create(null),E=Object.create(null);n.ScanCodeUtils={lowerCaseToEnum:e=>E[e]||0,toEnum:e=>g[e]||0,toString:e=>o[e]||"None"},n.IMMUTABLE_CODE_TO_KEY_CODE=[],n.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)n.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=127;e++)n.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",C=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[0,1,1,"Hyper",0,e,0,e,e,e],[0,1,2,"Super",0,e,0,e,e,e],[0,1,3,"Fn",0,e,0,e,e,e],[0,1,4,"FnLock",0,e,0,e,e,e],[0,1,5,"Suspend",0,e,0,e,e,e],[0,1,6,"Resume",0,e,0,e,e,e],[0,1,7,"Turbo",0,e,0,e,e,e],[0,1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[0,1,9,"WakeUp",0,e,0,e,e,e],[31,0,10,"KeyA",31,"A",65,"VK_A",e,e],[32,0,11,"KeyB",32,"B",66,"VK_B",e,e],[33,0,12,"KeyC",33,"C",67,"VK_C",e,e],[34,0,13,"KeyD",34,"D",68,"VK_D",e,e],[35,0,14,"KeyE",35,"E",69,"VK_E",e,e],[36,0,15,"KeyF",36,"F",70,"VK_F",e,e],[37,0,16,"KeyG",37,"G",71,"VK_G",e,e],[38,0,17,"KeyH",38,"H",72,"VK_H",e,e],[39,0,18,"KeyI",39,"I",73,"VK_I",e,e],[40,0,19,"KeyJ",40,"J",74,"VK_J",e,e],[41,0,20,"KeyK",41,"K",75,"VK_K",e,e],[42,0,21,"KeyL",42,"L",76,"VK_L",e,e],[43,0,22,"KeyM",43,"M",77,"VK_M",e,e],[44,0,23,"KeyN",44,"N",78,"VK_N",e,e],[45,0,24,"KeyO",45,"O",79,"VK_O",e,e],[46,0,25,"KeyP",46,"P",80,"VK_P",e,e],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[48,0,27,"KeyR",48,"R",82,"VK_R",e,e],[49,0,28,"KeyS",49,"S",83,"VK_S",e,e],[50,0,29,"KeyT",50,"T",84,"VK_T",e,e],[51,0,30,"KeyU",51,"U",85,"VK_U",e,e],[52,0,31,"KeyV",52,"V",86,"VK_V",e,e],[53,0,32,"KeyW",53,"W",87,"VK_W",e,e],[54,0,33,"KeyX",54,"X",88,"VK_X",e,e],[55,0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[22,0,36,"Digit1",22,"1",49,"VK_1",e,e],[23,0,37,"Digit2",23,"2",50,"VK_2",e,e],[24,0,38,"Digit3",24,"3",51,"VK_3",e,e],[25,0,39,"Digit4",25,"4",52,"VK_4",e,e],[26,0,40,"Digit5",26,"5",53,"VK_5",e,e],[27,0,41,"Digit6",27,"6",54,"VK_6",e,e],[28,0,42,"Digit7",28,"7",55,"VK_7",e,e],[29,0,43,"Digit8",29,"8",56,"VK_8",e,e],[30,0,44,"Digit9",30,"9",57,"VK_9",e,e],[21,0,45,"Digit0",21,"0",48,"VK_0",e,e],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[10,1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,e,0,e,e,e],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[59,1,64,"F1",59,"F1",112,"VK_F1",e,e],[60,1,65,"F2",60,"F2",113,"VK_F2",e,e],[61,1,66,"F3",61,"F3",114,"VK_F3",e,e],[62,1,67,"F4",62,"F4",115,"VK_F4",e,e],[63,1,68,"F5",63,"F5",116,"VK_F5",e,e],[64,1,69,"F6",64,"F6",117,"VK_F6",e,e],[65,1,70,"F7",65,"F7",118,"VK_F7",e,e],[66,1,71,"F8",66,"F8",119,"VK_F8",e,e],[67,1,72,"F9",67,"F9",120,"VK_F9",e,e],[68,1,73,"F10",68,"F10",121,"VK_F10",e,e],[69,1,74,"F11",69,"F11",122,"VK_F11",e,e],[70,1,75,"F12",70,"F12",123,"VK_F12",e,e],[0,1,76,"PrintScreen",0,e,0,e,e,e],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",e,e],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[14,1,80,"Home",14,"Home",36,"VK_HOME",e,e],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[13,1,83,"End",13,"End",35,"VK_END",e,e],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",e,e],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",e,e],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",e,e],[3,1,94,"NumpadEnter",3,e,0,e,e,e],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",e,e],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",e,e],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",e,e],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",e,e],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",e,e],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",e,e],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",e,e],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",e,e],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",e,e],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",e,e],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",e,e],[58,1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[0,1,108,"Power",0,e,0,e,e,e],[0,1,109,"NumpadEqual",0,e,0,e,e,e],[71,1,110,"F13",71,"F13",124,"VK_F13",e,e],[72,1,111,"F14",72,"F14",125,"VK_F14",e,e],[73,1,112,"F15",73,"F15",126,"VK_F15",e,e],[74,1,113,"F16",74,"F16",127,"VK_F16",e,e],[75,1,114,"F17",75,"F17",128,"VK_F17",e,e],[76,1,115,"F18",76,"F18",129,"VK_F18",e,e],[77,1,116,"F19",77,"F19",130,"VK_F19",e,e],[0,1,117,"F20",0,e,0,"VK_F20",e,e],[0,1,118,"F21",0,e,0,"VK_F21",e,e],[0,1,119,"F22",0,e,0,"VK_F22",e,e],[0,1,120,"F23",0,e,0,"VK_F23",e,e],[0,1,121,"F24",0,e,0,"VK_F24",e,e],[0,1,122,"Open",0,e,0,e,e,e],[0,1,123,"Help",0,e,0,e,e,e],[0,1,124,"Select",0,e,0,e,e,e],[0,1,125,"Again",0,e,0,e,e,e],[0,1,126,"Undo",0,e,0,e,e,e],[0,1,127,"Cut",0,e,0,e,e,e],[0,1,128,"Copy",0,e,0,e,e,e],[0,1,129,"Paste",0,e,0,e,e,e],[0,1,130,"Find",0,e,0,e,e,e],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",e,e],[0,1,136,"KanaMode",0,e,0,e,e,e],[0,0,137,"IntlYen",0,e,0,e,e,e],[0,1,138,"Convert",0,e,0,e,e,e],[0,1,139,"NonConvert",0,e,0,e,e,e],[0,1,140,"Lang1",0,e,0,e,e,e],[0,1,141,"Lang2",0,e,0,e,e,e],[0,1,142,"Lang3",0,e,0,e,e,e],[0,1,143,"Lang4",0,e,0,e,e,e],[0,1,144,"Lang5",0,e,0,e,e,e],[0,1,145,"Abort",0,e,0,e,e,e],[0,1,146,"Props",0,e,0,e,e,e],[0,1,147,"NumpadParenLeft",0,e,0,e,e,e],[0,1,148,"NumpadParenRight",0,e,0,e,e,e],[0,1,149,"NumpadBackspace",0,e,0,e,e,e],[0,1,150,"NumpadMemoryStore",0,e,0,e,e,e],[0,1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[0,1,152,"NumpadMemoryClear",0,e,0,e,e,e],[0,1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[0,1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[0,1,155,"NumpadClear",126,"Clear",12,"VK_CLEAR",e,e],[0,1,156,"NumpadClearEntry",0,e,0,e,e,e],[5,1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[4,1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[6,1,0,e,6,"Alt",18,"VK_MENU",e,e],[57,1,0,e,57,"Meta",0,"VK_COMMAND",e,e],[5,1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[4,1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[6,1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[57,1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[5,1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[4,1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[6,1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[57,1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[0,1,165,"BrightnessUp",0,e,0,e,e,e],[0,1,166,"BrightnessDown",0,e,0,e,e,e],[0,1,167,"MediaPlay",0,e,0,e,e,e],[0,1,168,"MediaRecord",0,e,0,e,e,e],[0,1,169,"MediaFastForward",0,e,0,e,e,e],[0,1,170,"MediaRewind",0,e,0,e,e,e],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",e,e],[0,1,174,"Eject",0,e,0,e,e,e],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[0,1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[0,1,180,"SelectTask",0,e,0,e,e,e],[0,1,181,"LaunchScreenSaver",0,e,0,e,e,e],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[0,1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[0,1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[0,1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[0,1,189,"ZoomToggle",0,e,0,e,e,e],[0,1,190,"MailReply",0,e,0,e,e,e],[0,1,191,"MailForward",0,e,0,e,e,e],[0,1,192,"MailSend",0,e,0,e,e,e],[109,1,0,e,109,"KeyInComposition",229,e,e,e],[111,1,0,e,111,"ABNT_C2",194,"VK_ABNT_C2",e,e],[91,1,0,e,91,"OEM_8",223,"VK_OEM_8",e,e],[0,1,0,e,0,e,0,"VK_KANA",e,e],[0,1,0,e,0,e,0,"VK_HANGUL",e,e],[0,1,0,e,0,e,0,"VK_JUNJA",e,e],[0,1,0,e,0,e,0,"VK_FINAL",e,e],[0,1,0,e,0,e,0,"VK_HANJA",e,e],[0,1,0,e,0,e,0,"VK_KANJI",e,e],[0,1,0,e,0,e,0,"VK_CONVERT",e,e],[0,1,0,e,0,e,0,"VK_NONCONVERT",e,e],[0,1,0,e,0,e,0,"VK_ACCEPT",e,e],[0,1,0,e,0,e,0,"VK_MODECHANGE",e,e],[0,1,0,e,0,e,0,"VK_SELECT",e,e],[0,1,0,e,0,e,0,"VK_PRINT",e,e],[0,1,0,e,0,e,0,"VK_EXECUTE",e,e],[0,1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[0,1,0,e,0,e,0,"VK_HELP",e,e],[0,1,0,e,0,e,0,"VK_APPS",e,e],[0,1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[0,1,0,e,0,e,0,"VK_PACKET",e,e],[0,1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_ATTN",e,e],[0,1,0,e,0,e,0,"VK_CRSEL",e,e],[0,1,0,e,0,e,0,"VK_EXSEL",e,e],[0,1,0,e,0,e,0,"VK_EREOF",e,e],[0,1,0,e,0,e,0,"VK_PLAY",e,e],[0,1,0,e,0,e,0,"VK_ZOOM",e,e],[0,1,0,e,0,e,0,"VK_NONAME",e,e],[0,1,0,e,0,e,0,"VK_PA1",e,e],[0,1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],R=[],A=[];for(const _ of C){const[i,s,a,l,u,m,h,b,w,L]=_;if(A[a]||(A[a]=!0,o[a]=l,g[l]=a,E[l.toLowerCase()]=a,s&&(n.IMMUTABLE_CODE_TO_KEY_CODE[a]=u,u!==0&&u!==3&&u!==5&&u!==4&&u!==6&&u!==57&&(n.IMMUTABLE_KEY_CODE_TO_CODE[u]=a))),!R[u]){if(R[u]=!0,!m)throw new Error(`String representation missing for key code ${u} around scan code ${l}`);c.define(u,m),N.define(u,w||m),d.define(u,L||w||m)}h&&(n.EVENT_KEY_CODE_MAP[h]=u),b&&(n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[b]=u)}n.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var D;(function(e){function C(a){return c.keyCodeToStr(a)}e.toString=C;function R(a){return c.strToKeyCode(a)}e.fromString=R;function A(a){return N.keyCodeToStr(a)}e.toUserSettingsUS=A;function _(a){return d.keyCodeToStr(a)}e.toUserSettingsGeneral=_;function i(a){return N.strToKeyCode(a)||d.strToKeyCode(a)}e.fromUserSettings=i;function s(a){if(a>=93&&a<=108)return null;switch(a){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return c.keyCodeToStr(a)}e.toElectronAccelerator=s})(D=n.KeyCodeUtils||(n.KeyCodeUtils={}));var p;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(p=n.KeyMod||(n.KeyMod={}));function f(e,C){const R=(C&65535)<<16>>>0;return(e|R)>>>0}n.KeyChord=f}),Y(Z[29],J([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Lazy=void 0;class y{constructor(M){this.executor=M,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(M){this._error=M}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(M){return new y(()=>M(this.getValue()))}}n.Lazy=y}),Y(Z[6],J([0,1,12,13]),function(O,n,y,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.disposeOnReturn=n.ImmortalReference=n.AsyncReferenceCollection=n.ReferenceCollection=n.SafeDisposable=n.RefCountedDisposable=n.MutableDisposable=n.Disposable=n.DisposableStore=n.toDisposable=n.combinedDisposable=n.dispose=n.isDisposable=n.MultiDisposeError=n.markAsSingleton=n.setDisposableTracker=void 0;const M=!1;let c=null;function N(b){c=b}if(n.setDisposableTracker=N,M){const b="__is_disposable_tracked__";N(new class{trackDisposable(w){const L=new Error("Potentially leaked disposable").stack;setTimeout(()=>{w[b]||console.log(L)},3e3)}setParent(w,L){if(w&&w!==_.None)try{w[b]=!0}catch{}}markAsDisposed(w){if(w&&w!==_.None)try{w[b]=!0}catch{}}markAsSingleton(w){}})}function d(b){return c?.trackDisposable(b),b}function o(b){c?.markAsDisposed(b)}function g(b,w){c?.setParent(b,w)}function E(b,w){if(!!c)for(const L of b)c.setParent(L,w)}function D(b){return c?.markAsSingleton(b),b}n.markAsSingleton=D;class p extends Error{constructor(w){super(`Encountered errors while disposing of store. Errors: [${w.join(", ")}]`);this.errors=w}}n.MultiDisposeError=p;function f(b){return typeof b.dispose=="function"&&b.dispose.length===0}n.isDisposable=f;function e(b){if(t.Iterable.is(b)){const w=[];for(const L of b)if(L)try{L.dispose()}catch(v){w.push(v)}if(w.length===1)throw w[0];if(w.length>1)throw new p(w);return Array.isArray(b)?[]:b}else if(b)return b.dispose(),b}n.dispose=e;function C(...b){const w=R(()=>e(b));return E(b,w),w}n.combinedDisposable=C;function R(b){const w=d({dispose:(0,y.once)(()=>{o(w),b()})});return w}n.toDisposable=R;class A{constructor(){this._toDispose=new Set,this._isDisposed=!1,d(this)}dispose(){this._isDisposed||(o(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{e(this._toDispose.values())}finally{this._toDispose.clear()}}add(w){if(!w)return w;if(w===this)throw new Error("Cannot register a disposable on itself!");return g(w,this),this._isDisposed?A.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(w),w}}n.DisposableStore=A,A.DISABLE_DISPOSED_WARNING=!1;class _{constructor(){this._store=new A,d(this),g(this._store,this)}dispose(){o(this),this._store.dispose()}_register(w){if(w===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(w)}}n.Disposable=_,_.None=Object.freeze({dispose(){}});class i{constructor(){this._isDisposed=!1,d(this)}get value(){return this._isDisposed?void 0:this._value}set value(w){this._isDisposed||w===this._value||(this._value?.dispose(),w&&g(w,this),this._value=w)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,o(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const w=this._value;return this._value=void 0,w&&g(w,null),w}}n.MutableDisposable=i;class s{constructor(w){this._disposable=w,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}n.RefCountedDisposable=s;class a{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,d(this)}set(w){let L=w;return this.unset=()=>L=void 0,this.isset=()=>L!==void 0,this.dispose=()=>{L&&(L(),L=void 0,o(this))},this}}n.SafeDisposable=a;class l{constructor(){this.references=new Map}acquire(w,...L){let v=this.references.get(w);v||(v={counter:0,object:this.createReferencedObject(w,...L)},this.references.set(w,v));const{object:F}=v,B=(0,y.once)(()=>{--v.counter==0&&(this.destroyReferencedObject(w,v.object),this.references.delete(w))});return v.counter++,{object:F,dispose:B}}}n.ReferenceCollection=l;class u{constructor(w){this.referenceCollection=w}async acquire(w,...L){const v=this.referenceCollection.acquire(w,...L);try{return{object:await v.object,dispose:()=>v.dispose()}}catch(F){throw v.dispose(),F}}}n.AsyncReferenceCollection=u;class m{constructor(w){this.object=w}dispose(){}}n.ImmortalReference=m;function h(b){const w=new A;try{b(w)}finally{w.dispose()}}n.disposeOnReturn=h}),Y(Z[14],J([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LinkedList=void 0;class y{constructor(c){this.element=c,this.next=y.Undefined,this.prev=y.Undefined}}y.Undefined=new y(void 0);class t{constructor(){this._first=y.Undefined,this._last=y.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===y.Undefined}clear(){let c=this._first;for(;c!==y.Undefined;){const N=c.next;c.prev=y.Undefined,c.next=y.Undefined,c=N}this._first=y.Undefined,this._last=y.Undefined,this._size=0}unshift(c){return this._insert(c,!1)}push(c){return this._insert(c,!0)}_insert(c,N){const d=new y(c);if(this._first===y.Undefined)this._first=d,this._last=d;else if(N){const g=this._last;this._last=d,d.prev=g,g.next=d}else{const g=this._first;this._first=d,d.next=g,g.prev=d}this._size+=1;let o=!1;return()=>{o||(o=!0,this._remove(d))}}shift(){if(this._first!==y.Undefined){const c=this._first.element;return this._remove(this._first),c}}pop(){if(this._last!==y.Undefined){const c=this._last.element;return this._remove(this._last),c}}_remove(c){if(c.prev!==y.Undefined&&c.next!==y.Undefined){const N=c.prev;N.next=c.next,c.next.prev=N}else c.prev===y.Undefined&&c.next===y.Undefined?(this._first=y.Undefined,this._last=y.Undefined):c.next===y.Undefined?(this._last=this._last.prev,this._last.next=y.Undefined):c.prev===y.Undefined&&(this._first=this._first.next,this._first.prev=y.Undefined);this._size-=1}*[Symbol.iterator](){let c=this._first;for(;c!==y.Undefined;)yield c.element,c=c.next}}n.LinkedList=t}),Y(Z[30],J([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.withUndefinedAsNull=n.withNullAsUndefined=n.validateConstraint=n.validateConstraints=n.areFunctions=n.isFunction=n.isEmptyObject=n.assertAllDefined=n.assertIsDefined=n.assertType=n.isUndefinedOrNull=n.isDefined=n.isUndefined=n.isBoolean=n.isIterable=n.isNumber=n.isTypedArray=n.isObject=n.isStringArray=n.isString=void 0;function y(u){return typeof u=="string"}n.isString=y;function t(u){return Array.isArray(u)&&u.every(m=>y(m))}n.isStringArray=t;function M(u){return typeof u=="object"&&u!==null&&!Array.isArray(u)&&!(u instanceof RegExp)&&!(u instanceof Date)}n.isObject=M;function c(u){const m=Object.getPrototypeOf(Uint8Array);return typeof u=="object"&&u instanceof m}n.isTypedArray=c;function N(u){return typeof u=="number"&&!isNaN(u)}n.isNumber=N;function d(u){return!!u&&typeof u[Symbol.iterator]=="function"}n.isIterable=d;function o(u){return u===!0||u===!1}n.isBoolean=o;function g(u){return typeof u=="undefined"}n.isUndefined=g;function E(u){return!D(u)}n.isDefined=E;function D(u){return g(u)||u===null}n.isUndefinedOrNull=D;function p(u,m){if(!u)throw new Error(m?`Unexpected type, expected '${m}'`:"Unexpected type")}n.assertType=p;function f(u){if(D(u))throw new Error("Assertion Failed: argument is undefined or null");return u}n.assertIsDefined=f;function e(...u){const m=[];for(let h=0;h<u.length;h++){const b=u[h];if(D(b))throw new Error(`Assertion Failed: argument at index ${h} is undefined or null`);m.push(b)}return m}n.assertAllDefined=e;const C=Object.prototype.hasOwnProperty;function R(u){if(!M(u))return!1;for(const m in u)if(C.call(u,m))return!1;return!0}n.isEmptyObject=R;function A(u){return typeof u=="function"}n.isFunction=A;function _(...u){return u.length>0&&u.every(A)}n.areFunctions=_;function i(u,m){const h=Math.min(u.length,m.length);for(let b=0;b<h;b++)s(u[b],m[b])}n.validateConstraints=i;function s(u,m){if(y(m)){if(typeof u!==m)throw new Error(`argument does not match constraint: typeof ${m}`)}else if(A(m)){try{if(u instanceof m)return}catch{}if(!D(u)&&u.constructor===m||m.length===1&&m.call(void 0,u)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}n.validateConstraint=s;function a(u){return u===null?void 0:u}n.withNullAsUndefined=a;function l(u){return typeof u=="undefined"?null:u}n.withUndefinedAsNull=l}),Y(Z[9],J([0,1,30]),function(O,n,y){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.createProxyObject=n.getAllMethodNames=n.getAllPropertyNames=n.filter=n.getCaseInsensitive=n.distinct=n.safeStringify=n.equals=n.mixin=n.cloneAndChange=n.deepFreeze=n.deepClone=void 0;function t(A){if(!A||typeof A!="object"||A instanceof RegExp)return A;const _=Array.isArray(A)?[]:{};return Object.keys(A).forEach(i=>{A[i]&&typeof A[i]=="object"?_[i]=t(A[i]):_[i]=A[i]}),_}n.deepClone=t;function M(A){if(!A||typeof A!="object")return A;const _=[A];for(;_.length>0;){const i=_.shift();Object.freeze(i);for(const s in i)if(c.call(i,s)){const a=i[s];typeof a=="object"&&!Object.isFrozen(a)&&!(0,y.isTypedArray)(a)&&_.push(a)}}return A}n.deepFreeze=M;const c=Object.prototype.hasOwnProperty;function N(A,_){return d(A,_,new Set)}n.cloneAndChange=N;function d(A,_,i){if((0,y.isUndefinedOrNull)(A))return A;const s=_(A);if(typeof s!="undefined")return s;if(Array.isArray(A)){const a=[];for(const l of A)a.push(d(l,_,i));return a}if((0,y.isObject)(A)){if(i.has(A))throw new Error("Cannot clone recursive data-structure");i.add(A);const a={};for(const l in A)c.call(A,l)&&(a[l]=d(A[l],_,i));return i.delete(A),a}return A}function o(A,_,i=!0){return(0,y.isObject)(A)?((0,y.isObject)(_)&&Object.keys(_).forEach(s=>{s in A?i&&((0,y.isObject)(A[s])&&(0,y.isObject)(_[s])?o(A[s],_[s],i):A[s]=_[s]):A[s]=_[s]}),A):_}n.mixin=o;function g(A,_){if(A===_)return!0;if(A==null||_===null||_===void 0||typeof A!=typeof _||typeof A!="object"||Array.isArray(A)!==Array.isArray(_))return!1;let i,s;if(Array.isArray(A)){if(A.length!==_.length)return!1;for(i=0;i<A.length;i++)if(!g(A[i],_[i]))return!1}else{const a=[];for(s in A)a.push(s);a.sort();const l=[];for(s in _)l.push(s);if(l.sort(),!g(a,l))return!1;for(i=0;i<a.length;i++)if(!g(A[a[i]],_[a[i]]))return!1}return!0}n.equals=g;function E(A){const _=new Set;return JSON.stringify(A,(i,s)=>{if((0,y.isObject)(s)||Array.isArray(s)){if(_.has(s))return"[Circular]";_.add(s)}return s})}n.safeStringify=E;function D(A,_){const i=Object.create(null);return!A||!_||Object.keys(_).forEach(a=>{const l=A[a],u=_[a];g(l,u)||(i[a]=u)}),i}n.distinct=D;function p(A,_){const i=_.toLowerCase(),s=Object.keys(A).find(a=>a.toLowerCase()===i);return s?A[s]:A[_]}n.getCaseInsensitive=p;function f(A,_){const i=Object.create(null);for(const[s,a]of Object.entries(A))_(s,a)&&(i[s]=a);return i}n.filter=f;function e(A){let _=[],i=Object.getPrototypeOf(A);for(;Object.prototype!==i;)_=_.concat(Object.getOwnPropertyNames(i)),i=Object.getPrototypeOf(i);return _}n.getAllPropertyNames=e;function C(A){const _=[];for(const i of e(A))typeof A[i]=="function"&&_.push(i);return _}n.getAllMethodNames=C;function R(A,_){const i=a=>function(){const l=Array.prototype.slice.call(arguments,0);return _(a,l)},s={};for(const a of A)s[a]=i(a);return s}n.createProxyObject=R}),Y(Z[15],J([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.toUint32=n.toUint8=n.Constants=void 0;var y;(function(c){c[c.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",c[c.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",c[c.MAX_UINT_8=255]="MAX_UINT_8",c[c.MAX_UINT_16=65535]="MAX_UINT_16",c[c.MAX_UINT_32=4294967295]="MAX_UINT_32",c[c.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(y=n.Constants||(n.Constants={}));function t(c){return c<0?0:c>255?255:c|0}n.toUint8=t;function M(c){return c<0?0:c>4294967295?4294967295:c|0}n.toUint32=M}),Y(Z[16],J([0,1,15]),function(O,n,y){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CharacterSet=n.CharacterClassifier=void 0;class t{constructor(d){const o=(0,y.toUint8)(d);this._defaultValue=o,this._asciiMap=t._createAsciiMap(o),this._map=new Map}static _createAsciiMap(d){const o=new Uint8Array(256);for(let g=0;g<256;g++)o[g]=d;return o}set(d,o){const g=(0,y.toUint8)(o);d>=0&&d<256?this._asciiMap[d]=g:this._map.set(d,g)}get(d){return d>=0&&d<256?this._asciiMap[d]:this._map.get(d)||this._defaultValue}}n.CharacterClassifier=t;var M;(function(N){N[N.False=0]="False",N[N.True=1]="True"})(M||(M={}));class c{constructor(){this._actual=new t(0)}add(d){this._actual.set(d,1)}has(d){return this._actual.get(d)===1}}n.CharacterSet=c}),Y(Z[3],J([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Position=void 0;class y{constructor(M,c){this.lineNumber=M,this.column=c}with(M=this.lineNumber,c=this.column){return M===this.lineNumber&&c===this.column?this:new y(M,c)}delta(M=0,c=0){return this.with(this.lineNumber+M,this.column+c)}equals(M){return y.equals(this,M)}static equals(M,c){return!M&&!c?!0:!!M&&!!c&&M.lineNumber===c.lineNumber&&M.column===c.column}isBefore(M){return y.isBefore(this,M)}static isBefore(M,c){return M.lineNumber<c.lineNumber?!0:c.lineNumber<M.lineNumber?!1:M.column<c.column}isBeforeOrEqual(M){return y.isBeforeOrEqual(this,M)}static isBeforeOrEqual(M,c){return M.lineNumber<c.lineNumber?!0:c.lineNumber<M.lineNumber?!1:M.column<=c.column}static compare(M,c){const N=M.lineNumber|0,d=c.lineNumber|0;if(N===d){const o=M.column|0,g=c.column|0;return o-g}return N-d}clone(){return new y(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(M){return new y(M.lineNumber,M.column)}static isIPosition(M){return M&&typeof M.lineNumber=="number"&&typeof M.column=="number"}}n.Position=y}),Y(Z[2],J([0,1,3]),function(O,n,y){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Range=void 0;class t{constructor(c,N,d,o){c>d||c===d&&N>o?(this.startLineNumber=d,this.startColumn=o,this.endLineNumber=c,this.endColumn=N):(this.startLineNumber=c,this.startColumn=N,this.endLineNumber=d,this.endColumn=o)}isEmpty(){return t.isEmpty(this)}static isEmpty(c){return c.startLineNumber===c.endLineNumber&&c.startColumn===c.endColumn}containsPosition(c){return t.containsPosition(this,c)}static containsPosition(c,N){return!(N.lineNumber<c.startLineNumber||N.lineNumber>c.endLineNumber||N.lineNumber===c.startLineNumber&&N.column<c.startColumn||N.lineNumber===c.endLineNumber&&N.column>c.endColumn)}static strictContainsPosition(c,N){return!(N.lineNumber<c.startLineNumber||N.lineNumber>c.endLineNumber||N.lineNumber===c.startLineNumber&&N.column<=c.startColumn||N.lineNumber===c.endLineNumber&&N.column>=c.endColumn)}containsRange(c){return t.containsRange(this,c)}static containsRange(c,N){return!(N.startLineNumber<c.startLineNumber||N.endLineNumber<c.startLineNumber||N.startLineNumber>c.endLineNumber||N.endLineNumber>c.endLineNumber||N.startLineNumber===c.startLineNumber&&N.startColumn<c.startColumn||N.endLineNumber===c.endLineNumber&&N.endColumn>c.endColumn)}strictContainsRange(c){return t.strictContainsRange(this,c)}static strictContainsRange(c,N){return!(N.startLineNumber<c.startLineNumber||N.endLineNumber<c.startLineNumber||N.startLineNumber>c.endLineNumber||N.endLineNumber>c.endLineNumber||N.startLineNumber===c.startLineNumber&&N.startColumn<=c.startColumn||N.endLineNumber===c.endLineNumber&&N.endColumn>=c.endColumn)}plusRange(c){return t.plusRange(this,c)}static plusRange(c,N){let d,o,g,E;return N.startLineNumber<c.startLineNumber?(d=N.startLineNumber,o=N.startColumn):N.startLineNumber===c.startLineNumber?(d=N.startLineNumber,o=Math.min(N.startColumn,c.startColumn)):(d=c.startLineNumber,o=c.startColumn),N.endLineNumber>c.endLineNumber?(g=N.endLineNumber,E=N.endColumn):N.endLineNumber===c.endLineNumber?(g=N.endLineNumber,E=Math.max(N.endColumn,c.endColumn)):(g=c.endLineNumber,E=c.endColumn),new t(d,o,g,E)}intersectRanges(c){return t.intersectRanges(this,c)}static intersectRanges(c,N){let d=c.startLineNumber,o=c.startColumn,g=c.endLineNumber,E=c.endColumn;const D=N.startLineNumber,p=N.startColumn,f=N.endLineNumber,e=N.endColumn;return d<D?(d=D,o=p):d===D&&(o=Math.max(o,p)),g>f?(g=f,E=e):g===f&&(E=Math.min(E,e)),d>g||d===g&&o>E?null:new t(d,o,g,E)}equalsRange(c){return t.equalsRange(this,c)}static equalsRange(c,N){return!!c&&!!N&&c.startLineNumber===N.startLineNumber&&c.startColumn===N.startColumn&&c.endLineNumber===N.endLineNumber&&c.endColumn===N.endColumn}getEndPosition(){return t.getEndPosition(this)}static getEndPosition(c){return new y.Position(c.endLineNumber,c.endColumn)}getStartPosition(){return t.getStartPosition(this)}static getStartPosition(c){return new y.Position(c.startLineNumber,c.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(c,N){return new t(this.startLineNumber,this.startColumn,c,N)}setStartPosition(c,N){return new t(c,N,this.endLineNumber,this.endColumn)}collapseToStart(){return t.collapseToStart(this)}delta(c){return new t(this.startLineNumber+c,this.startColumn,this.endLineNumber+c,this.endColumn)}static collapseToStart(c){return new t(c.startLineNumber,c.startColumn,c.startLineNumber,c.startColumn)}static fromPositions(c,N=c){return new t(c.lineNumber,c.column,N.lineNumber,N.column)}static lift(c){return c?new t(c.startLineNumber,c.startColumn,c.endLineNumber,c.endColumn):null}static isIRange(c){return c&&typeof c.startLineNumber=="number"&&typeof c.startColumn=="number"&&typeof c.endLineNumber=="number"&&typeof c.endColumn=="number"}static areIntersectingOrTouching(c,N){return!(c.endLineNumber<N.startLineNumber||c.endLineNumber===N.startLineNumber&&c.endColumn<N.startColumn||N.endLineNumber<c.startLineNumber||N.endLineNumber===c.startLineNumber&&N.endColumn<c.startColumn)}static areIntersecting(c,N){return!(c.endLineNumber<N.startLineNumber||c.endLineNumber===N.startLineNumber&&c.endColumn<=N.startColumn||N.endLineNumber<c.startLineNumber||N.endLineNumber===c.startLineNumber&&N.endColumn<=c.startColumn)}static compareRangesUsingStarts(c,N){if(c&&N){const g=c.startLineNumber|0,E=N.startLineNumber|0;if(g===E){const D=c.startColumn|0,p=N.startColumn|0;if(D===p){const f=c.endLineNumber|0,e=N.endLineNumber|0;if(f===e){const C=c.endColumn|0,R=N.endColumn|0;return C-R}return f-e}return D-p}return g-E}return(c?1:0)-(N?1:0)}static compareRangesUsingEnds(c,N){return c.endLineNumber===N.endLineNumber?c.endColumn===N.endColumn?c.startLineNumber===N.startLineNumber?c.startColumn-N.startColumn:c.startLineNumber-N.startLineNumber:c.endColumn-N.endColumn:c.endLineNumber-N.endLineNumber}static spansMultipleLines(c){return c.endLineNumber>c.startLineNumber}toJSON(){return this}}n.Range=t}),Y(Z[31],J([0,1,3,2]),function(O,n,y,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Selection=n.SelectionDirection=void 0;var M;(function(N){N[N.LTR=0]="LTR",N[N.RTL=1]="RTL"})(M=n.SelectionDirection||(n.SelectionDirection={}));class c extends t.Range{constructor(d,o,g,E){super(d,o,g,E);this.selectionStartLineNumber=d,this.selectionStartColumn=o,this.positionLineNumber=g,this.positionColumn=E}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(d){return c.selectionsEqual(this,d)}static selectionsEqual(d,o){return d.selectionStartLineNumber===o.selectionStartLineNumber&&d.selectionStartColumn===o.selectionStartColumn&&d.positionLineNumber===o.positionLineNumber&&d.positionColumn===o.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(d,o){return this.getDirection()===0?new c(this.startLineNumber,this.startColumn,d,o):new c(d,o,this.startLineNumber,this.startColumn)}getPosition(){return new y.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new y.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(d,o){return this.getDirection()===0?new c(d,o,this.endLineNumber,this.endColumn):new c(this.endLineNumber,this.endColumn,d,o)}static fromPositions(d,o=d){return new c(d.lineNumber,d.column,o.lineNumber,o.column)}static fromRange(d,o){return o===0?new c(d.startLineNumber,d.startColumn,d.endLineNumber,d.endColumn):new c(d.endLineNumber,d.endColumn,d.startLineNumber,d.startColumn)}static liftSelection(d){return new c(d.selectionStartLineNumber,d.selectionStartColumn,d.positionLineNumber,d.positionColumn)}static selectionsArrEqual(d,o){if(d&&!o||!d&&o)return!1;if(!d&&!o)return!0;if(d.length!==o.length)return!1;for(let g=0,E=d.length;g<E;g++)if(!this.selectionsEqual(d[g],o[g]))return!1;return!0}static isISelection(d){return d&&typeof d.selectionStartLineNumber=="number"&&typeof d.selectionStartColumn=="number"&&typeof d.positionLineNumber=="number"&&typeof d.positionColumn=="number"}static createWithDirection(d,o,g,E,D){return D===0?new c(d,o,g,E):new c(g,E,d,o)}}n.Selection=c}),Y(Z[32],J([0,1,16]),function(O,n,y){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.getMapForWordSeparators=n.WordCharacterClassifier=n.WordCharacterClass=void 0;var t;(function(N){N[N.Regular=0]="Regular",N[N.Whitespace=1]="Whitespace",N[N.WordSeparator=2]="WordSeparator"})(t=n.WordCharacterClass||(n.WordCharacterClass={}));class M extends y.CharacterClassifier{constructor(d){super(0);for(let o=0,g=d.length;o<g;o++)this.set(d.charCodeAt(o),2);this.set(32,1),this.set(9,1)}}n.WordCharacterClassifier=M;function c(N){const d={};return o=>(d.hasOwnProperty(o)||(d[o]=N(o)),d[o])}n.getMapForWordSeparators=c(N=>new M(N))}),Y(Z[17],J([0,1,13,6,14]),function(O,n,y,t,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.getWordAtText=n.setDefaultGetWordAtTextConfig=n.ensureValidWordDefinition=n.DEFAULT_WORD_REGEXP=n.USUAL_WORD_SEPARATORS=void 0,n.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function c(D=""){let p="(-?\\d*\\.\\d\\w*)|([^";for(const f of n.USUAL_WORD_SEPARATORS)D.indexOf(f)>=0||(p+="\\"+f);return p+="\\s]+)",new RegExp(p,"g")}n.DEFAULT_WORD_REGEXP=c();function N(D){let p=n.DEFAULT_WORD_REGEXP;if(D&&D instanceof RegExp)if(D.global)p=D;else{let f="g";D.ignoreCase&&(f+="i"),D.multiline&&(f+="m"),D.unicode&&(f+="u"),p=new RegExp(D.source,f)}return p.lastIndex=0,p}n.ensureValidWordDefinition=N;const d=new M.LinkedList;d.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function o(D){const p=d.unshift(D);return(0,t.toDisposable)(p)}n.setDefaultGetWordAtTextConfig=o;function g(D,p,f,e,C){if(C||(C=y.Iterable.first(d)),f.length>C.maxLen){let s=D-C.maxLen/2;return s<0?s=0:e+=s,f=f.substring(s,D+C.maxLen/2),g(D,p,f,e,C)}const R=Date.now(),A=D-1-e;let _=-1,i=null;for(let s=1;!(Date.now()-R>=C.timeBudget);s++){const a=A-C.windowSize*s;p.lastIndex=Math.max(0,a);const l=E(p,f,A,_);if(!l&&i||(i=l,a<=0))break;_=a}if(i){const s={word:i[0],startColumn:e+1+i.index,endColumn:e+1+i.index+i[0].length};return p.lastIndex=0,s}return null}n.getWordAtText=g;function E(D,p,f,e){let C;for(;C=D.exec(p);){const R=C.index||0;if(R<=f&&D.lastIndex>=f)return C;if(e>0&&R>e)return null}return null}}),Y(Z[10],J([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.SequenceFromIntArray=n.OffsetRange=n.SequenceDiff=void 0;class y{constructor(N,d){this.seq1Range=N,this.seq2Range=d}}n.SequenceDiff=y;class t{constructor(N,d){this.start=N,this.endExclusive=d}get isEmpty(){return this.start===this.endExclusive}delta(N){return new t(this.start+N,this.endExclusive+N)}get length(){return this.endExclusive-this.start}}n.OffsetRange=t;class M{constructor(N){this.arr=N}getElement(N){return this.arr[N]}get length(){return this.arr.length}}n.SequenceFromIntArray=M}),Y(Z[33],J([0,1,10]),function(O,n,y){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MyersDiffAlgorithm=void 0;class t{compute(o,g){function E(i,s){for(;i<o.length&&s<g.length&&o.getElement(i)===g.getElement(s);)i++,s++;return i}let D=0;const p=new c;p.set(0,E(0,0));const f=new N;f.set(0,p.get(0)===0?null:new M(null,0,0,p.get(0)));let e=0;e:for(;;)for(D++,e=-D;e<=D;e+=2){const i=e===D?-1:p.get(e+1),s=e===-D?-1:p.get(e-1)+1,a=Math.min(Math.max(i,s),o.length),l=a-e,u=E(a,l);p.set(e,u);const m=a===i?f.get(e+1):f.get(e-1);if(f.set(e,u!==a?new M(m,a,l,u-a):m),p.get(e)===o.length&&p.get(e)-e===g.length)break e}let C=f.get(e);const R=[];let A=o.length,_=g.length;for(;;){const i=C?C.x+C.length:0,s=C?C.y+C.length:0;if((i!==A||s!==_)&&R.push(new y.SequenceDiff(new y.OffsetRange(i,A),new y.OffsetRange(s,_))),!C)break;A=C.x,_=C.y,C=C.prev}return R.reverse(),R}}n.MyersDiffAlgorithm=t;class M{constructor(o,g,E,D){this.prev=o,this.x=g,this.y=E,this.length=D}}class c{constructor(){this.positiveArr=new Int32Array(10),this.negativeArr=new Int32Array(10)}get(o){return o<0?(o=-o-1,this.negativeArr[o]):this.positiveArr[o]}set(o,g){if(o<0){if(o=-o-1,o>=this.negativeArr.length){const E=this.negativeArr;this.negativeArr=new Int32Array(E.length*2),this.negativeArr.set(E)}this.negativeArr[o]=g}else{if(o>=this.positiveArr.length){const E=this.positiveArr;this.positiveArr=new Int32Array(E.length*2),this.positiveArr.set(E)}this.positiveArr[o]=g}}}class N{constructor(){this.positiveArr=[],this.negativeArr=[]}get(o){return o<0?(o=-o-1,this.negativeArr[o]):this.positiveArr[o]}set(o,g){o<0?(o=-o-1,this.negativeArr[o]=g):this.positiveArr[o]=g}}}),Y(Z[34],J([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Array2D=void 0;class y{constructor(M,c){this.width=M,this.height=c,this.array=[],this.array=new Array(M*c)}get(M,c){return this.array[M+c*this.width]}set(M,c,N){this.array[M+c*this.width]=N}}n.Array2D=y}),Y(Z[35],J([0,1,10,34]),function(O,n,y,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DynamicProgrammingDiffing=void 0;class M{compute(N,d,o){const g=new t.Array2D(N.length,d.length),E=new t.Array2D(N.length,d.length),D=new t.Array2D(N.length,d.length);for(let _=0;_<N.length;_++)for(let i=0;i<d.length;i++){const s=_===0?0:g.get(_-1,i),a=i===0?0:g.get(_,i-1);let l;N.getElement(_)===d.getElement(i)?(_===0||i===0?l=0:l=g.get(_-1,i-1),l+=o?o(_,i):1):l=-1;const u=Math.max(s,a,l);if(u===s)D.set(_,i,0),E.set(_,i,1);else if(u===a)D.set(_,i,0),E.set(_,i,2);else{const m=_>0&&i>0?D.get(_-1,i-1):0;D.set(_,i,m+1),E.set(_,i,3)}g.set(_,i,u)}const p=[];let f=N.length,e=d.length;function C(_,i){(_+1!==f||i+1!==e)&&p.push(new y.SequenceDiff(new y.OffsetRange(_+1,f),new y.OffsetRange(i+1,e))),f=_,e=i}let R=N.length-1,A=d.length-1;for(;R>=0&&A>=0;)E.get(R,A)===3?(C(R,A),R--,A--):E.get(R,A)===1?R--:A--;return C(-1,-1),p.reverse(),p}}n.DynamicProgrammingDiffing=M}),Y(Z[18],J([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LineRange=n.RangeMapping=n.LineRangeMapping=void 0;class y{constructor(N,d,o){this.originalRange=N,this.modifiedRange=d,this.innerChanges=o}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}}n.LineRangeMapping=y;class t{constructor(N,d){this.originalRange=N,this.modifiedRange=d}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}}n.RangeMapping=t;class M{constructor(N,d){this.startLineNumber=N,this.endLineNumberExclusive=d}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(N){return new M(this.startLineNumber+N,this.endLineNumberExclusive+N)}get length(){return this.endLineNumberExclusive-this.startLineNumber}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}}n.LineRange=M}),Y(Z[36],J([0,1,3,2,10,35,18]),function(O,n,y,t,M,c,N){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.lineRangeMappingFromRangeMappings=n.StandardLinesDiffComputer=void 0;class d{constructor(p){this.detailedDiffingAlgorithm=p,this.lineDiffingAlgorithm=new c.DynamicProgrammingDiffing}computeDiff(p,f,e){const C=new Map;function R(l){let u=C.get(l);return u===void 0&&(u=C.size,C.set(l,u)),u}const A=p.map(l=>R(l.trim())),_=f.map(l=>R(l.trim())),i=this.lineDiffingAlgorithm.compute(new M.SequenceFromIntArray(A),new M.SequenceFromIntArray(_),(l,u)=>p[l]===f[u]?f[u].length===0?.1:1:.99),s=[];for(let l of i){(l.seq1Range.start>0&&l.seq1Range.length>0&&A[l.seq1Range.start-1]===A[l.seq1Range.endExclusive-1]||l.seq2Range.start>0&&l.seq2Range.length>0&&_[l.seq2Range.start-1]===_[l.seq2Range.endExclusive-1])&&(l=new M.SequenceDiff(l.seq1Range.delta(-1),l.seq2Range.delta(-1)));for(const u of this.refineDiff(p,f,l))s.push(u)}const a=o(s);return{quitEarly:!1,changes:a}}refineDiff(p,f,e){const C=new E(p,e.seq1Range),R=new E(f,e.seq2Range);return this.detailedDiffingAlgorithm.compute(C,R).map(i=>new N.RangeMapping(C.translateRange(i.seq1Range).delta(e.seq1Range.start),R.translateRange(i.seq2Range).delta(e.seq2Range.start)))}}n.StandardLinesDiffComputer=d;function o(D){const p=[];for(const f of g(D,(e,C)=>C.modifiedRange.startLineNumber-(e.modifiedRange.endLineNumber-(e.modifiedRange.endColumn>1?0:1))<=1)){const e=f[0],C=f[f.length-1];p.push(new N.LineRangeMapping(new N.LineRange(e.originalRange.startLineNumber,C.originalRange.endLineNumber+(C.originalRange.endColumn>1||C.modifiedRange.endColumn>1?1:0)),new N.LineRange(e.modifiedRange.startLineNumber,C.modifiedRange.endLineNumber+(C.originalRange.endColumn>1||C.modifiedRange.endColumn>1?1:0)),f))}return p}n.lineRangeMappingFromRangeMappings=o;function*g(D,p){let f,e;for(const C of D)e!==void 0&&p(e,C)?f.push(C):(f&&(yield f),f=[C]),e=C;f&&(yield f)}class E{constructor(p,f){this.lines=p,this.lineRange=f;let e=0;this.firstCharOnLineOffsets=new Int32Array(f.length);for(let R=f.start;R<f.endExclusive;R++)e+=p[R].length,this.firstCharOnLineOffsets[R-f.start]=e+1,e++;this.elements=new Int32Array(e);let C=0;for(let R=f.start;R<f.endExclusive;R++){const A=p[R];for(let _=0;_<A.length;_++)this.elements[C+_]=A.charCodeAt(_);C+=A.length,R<p.length-1&&(this.elements[C]=`
`.charCodeAt(0),C+=1)}}getElement(p){return this.elements[p]}get length(){return this.elements.length}translateOffset(p){let f=0,e=this.firstCharOnLineOffsets.length;for(;f<e;){const R=Math.floor((f+e)/2);this.firstCharOnLineOffsets[R]>p?e=R:f=R+1}const C=f===0?0:this.firstCharOnLineOffsets[f-1];return new y.Position(f+1,p-C+1)}translateRange(p){return t.Range.fromPositions(this.translateOffset(p.start),this.translateOffset(p.endExclusive))}}}),Y(Z[37],J([0,1,16]),function(O,n,y){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.computeLinks=n.LinkComputer=n.StateMachine=n.Uint8Matrix=n.State=void 0;var t;(function(f){f[f.Invalid=0]="Invalid",f[f.Start=1]="Start",f[f.H=2]="H",f[f.HT=3]="HT",f[f.HTT=4]="HTT",f[f.HTTP=5]="HTTP",f[f.F=6]="F",f[f.FI=7]="FI",f[f.FIL=8]="FIL",f[f.BeforeColon=9]="BeforeColon",f[f.AfterColon=10]="AfterColon",f[f.AlmostThere=11]="AlmostThere",f[f.End=12]="End",f[f.Accept=13]="Accept",f[f.LastKnownState=14]="LastKnownState"})(t=n.State||(n.State={}));class M{constructor(e,C,R){const A=new Uint8Array(e*C);for(let _=0,i=e*C;_<i;_++)A[_]=R;this._data=A,this.rows=e,this.cols=C}get(e,C){return this._data[e*this.cols+C]}set(e,C,R){this._data[e*this.cols+C]=R}}n.Uint8Matrix=M;class c{constructor(e){let C=0,R=0;for(let _=0,i=e.length;_<i;_++){const[s,a,l]=e[_];a>C&&(C=a),s>R&&(R=s),l>R&&(R=l)}C++,R++;const A=new M(R,C,0);for(let _=0,i=e.length;_<i;_++){const[s,a,l]=e[_];A.set(s,a,l)}this._states=A,this._maxCharCode=C}nextState(e,C){return C<0||C>=this._maxCharCode?0:this._states.get(e,C)}}n.StateMachine=c;let N=null;function d(){return N===null&&(N=new c([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),N}var o;(function(f){f[f.None=0]="None",f[f.ForceTermination=1]="ForceTermination",f[f.CannotEndIn=2]="CannotEndIn"})(o||(o={}));let g=null;function E(){if(g===null){g=new y.CharacterClassifier(0);const f=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let C=0;C<f.length;C++)g.set(f.charCodeAt(C),1);const e=".,;:";for(let C=0;C<e.length;C++)g.set(e.charCodeAt(C),2)}return g}class D{static _createLink(e,C,R,A,_){let i=_-1;do{const s=C.charCodeAt(i);if(e.get(s)!==2)break;i--}while(i>A);if(A>0){const s=C.charCodeAt(A-1),a=C.charCodeAt(i);(s===40&&a===41||s===91&&a===93||s===123&&a===125)&&i--}return{range:{startLineNumber:R,startColumn:A+1,endLineNumber:R,endColumn:i+2},url:C.substring(A,i+1)}}static computeLinks(e,C=d()){const R=E(),A=[];for(let _=1,i=e.getLineCount();_<=i;_++){const s=e.getLineContent(_),a=s.length;let l=0,u=0,m=0,h=1,b=!1,w=!1,L=!1,v=!1;for(;l<a;){let F=!1;const B=s.charCodeAt(l);if(h===13){let U;switch(B){case 40:b=!0,U=0;break;case 41:U=b?0:1;break;case 91:L=!0,w=!0,U=0;break;case 93:L=!1,U=w?0:1;break;case 123:v=!0,U=0;break;case 125:U=v?0:1;break;case 39:U=m===39?1:0;break;case 34:U=m===34?1:0;break;case 96:U=m===96?1:0;break;case 42:U=m===42?1:0;break;case 124:U=m===124?1:0;break;case 32:U=L?0:1;break;default:U=R.get(B)}U===1&&(A.push(D._createLink(R,s,_,u,l)),F=!0)}else if(h===12){let U;B===91?(w=!0,U=0):U=R.get(B),U===1?F=!0:h=13}else h=C.nextState(h,B),h===0&&(F=!0);F&&(h=1,b=!1,w=!1,v=!1,u=l+1,m=B),l++}h===13&&A.push(D._createLink(R,s,_,u,a))}return A}}n.LinkComputer=D;function p(f){return!f||typeof f.getLineCount!="function"||typeof f.getLineContent!="function"?[]:D.computeLinks(f)}n.computeLinks=p}),Y(Z[38],J([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.BasicInplaceReplace=void 0;class y{constructor(){this._defaultValueSet=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}navigateValueSet(M,c,N,d,o){if(M&&c){const g=this.doNavigateValueSet(c,o);if(g)return{range:M,value:g}}if(N&&d){const g=this.doNavigateValueSet(d,o);if(g)return{range:N,value:g}}return null}doNavigateValueSet(M,c){const N=this.numberReplace(M,c);return N!==null?N:this.textReplace(M,c)}numberReplace(M,c){const N=Math.pow(10,M.length-(M.lastIndexOf(".")+1));let d=Number(M);const o=parseFloat(M);return!isNaN(d)&&!isNaN(o)&&d===o?d===0&&!c?null:(d=Math.floor(d*N),d+=c?N:-N,String(d/N)):null}textReplace(M,c){return this.valueSetsReplace(this._defaultValueSet,M,c)}valueSetsReplace(M,c,N){let d=null;for(let o=0,g=M.length;d===null&&o<g;o++)d=this.valueSetReplace(M[o],c,N);return d}valueSetReplace(M,c,N){let d=M.indexOf(c);return d>=0?(d+=N?1:-1,d<0?d=M.length-1:d%=M.length,M[d]):null}}n.BasicInplaceReplace=y,y.INSTANCE=new y}),Y(Z[39],J([0,1,9]),function(O,n,y){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.shouldSynchronizeModel=n.ApplyEditsResult=n.SearchData=n.ValidAnnotatedEditOperation=n.ModelConstants=n.PositionAffinity=n.isITextSnapshot=n.TrackedRangeStickiness=n.FindMatch=n.TextModelResolvedOptions=n.EndOfLineSequence=n.DefaultEndOfLine=n.EndOfLinePreference=n.InjectedTextCursorStops=n.MinimapPosition=n.OverviewRulerLane=void 0;var t;(function(i){i[i.Left=1]="Left",i[i.Center=2]="Center",i[i.Right=4]="Right",i[i.Full=7]="Full"})(t=n.OverviewRulerLane||(n.OverviewRulerLane={}));var M;(function(i){i[i.Inline=1]="Inline",i[i.Gutter=2]="Gutter"})(M=n.MinimapPosition||(n.MinimapPosition={}));var c;(function(i){i[i.Both=0]="Both",i[i.Right=1]="Right",i[i.Left=2]="Left",i[i.None=3]="None"})(c=n.InjectedTextCursorStops||(n.InjectedTextCursorStops={}));var N;(function(i){i[i.TextDefined=0]="TextDefined",i[i.LF=1]="LF",i[i.CRLF=2]="CRLF"})(N=n.EndOfLinePreference||(n.EndOfLinePreference={}));var d;(function(i){i[i.LF=1]="LF",i[i.CRLF=2]="CRLF"})(d=n.DefaultEndOfLine||(n.DefaultEndOfLine={}));var o;(function(i){i[i.LF=0]="LF",i[i.CRLF=1]="CRLF"})(o=n.EndOfLineSequence||(n.EndOfLineSequence={}));class g{constructor(s){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,s.tabSize|0),this.indentSize=s.tabSize|0,this.insertSpaces=Boolean(s.insertSpaces),this.defaultEOL=s.defaultEOL|0,this.trimAutoWhitespace=Boolean(s.trimAutoWhitespace),this.bracketPairColorizationOptions=s.bracketPairColorizationOptions}equals(s){return this.tabSize===s.tabSize&&this.indentSize===s.indentSize&&this.insertSpaces===s.insertSpaces&&this.defaultEOL===s.defaultEOL&&this.trimAutoWhitespace===s.trimAutoWhitespace&&(0,y.equals)(this.bracketPairColorizationOptions,s.bracketPairColorizationOptions)}createChangeEvent(s){return{tabSize:this.tabSize!==s.tabSize,indentSize:this.indentSize!==s.indentSize,insertSpaces:this.insertSpaces!==s.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==s.trimAutoWhitespace}}}n.TextModelResolvedOptions=g;class E{constructor(s,a){this._findMatchBrand=void 0,this.range=s,this.matches=a}}n.FindMatch=E;var D;(function(i){i[i.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",i[i.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",i[i.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",i[i.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(D=n.TrackedRangeStickiness||(n.TrackedRangeStickiness={}));function p(i){return i&&typeof i.read=="function"}n.isITextSnapshot=p;var f;(function(i){i[i.Left=0]="Left",i[i.Right=1]="Right",i[i.None=2]="None",i[i.LeftOfInjectedText=3]="LeftOfInjectedText",i[i.RightOfInjectedText=4]="RightOfInjectedText"})(f=n.PositionAffinity||(n.PositionAffinity={}));var e;(function(i){i[i.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(e=n.ModelConstants||(n.ModelConstants={}));class C{constructor(s,a,l,u,m,h){this.identifier=s,this.range=a,this.text=l,this.forceMoveMarkers=u,this.isAutoWhitespaceEdit=m,this._isTracked=h}}n.ValidAnnotatedEditOperation=C;class R{constructor(s,a,l){this.regex=s,this.wordSeparators=a,this.simpleSearch=l}}n.SearchData=R;class A{constructor(s,a,l){this.reverseEdits=s,this.changes=a,this.trimAutoWhitespaceLineNumbers=l}}n.ApplyEditsResult=A;function _(i){return!i.isTooLargeForSyncing()&&!i.isForSimpleWidget}n.shouldSynchronizeModel=_}),Y(Z[40],J([0,1,27,15]),function(O,n,y,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.PrefixSumIndexOfResult=n.ConstantTimePrefixSumComputer=n.PrefixSumComputer=void 0;class M{constructor(o){this.values=o,this.prefixSum=new Uint32Array(o.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(o,g){o=(0,t.toUint32)(o);const E=this.values,D=this.prefixSum,p=g.length;return p===0?!1:(this.values=new Uint32Array(E.length+p),this.values.set(E.subarray(0,o),0),this.values.set(E.subarray(o),o+p),this.values.set(g,o),o-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=o-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(D.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(o,g){return o=(0,t.toUint32)(o),g=(0,t.toUint32)(g),this.values[o]===g?!1:(this.values[o]=g,o-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=o-1),!0)}removeValues(o,g){o=(0,t.toUint32)(o),g=(0,t.toUint32)(g);const E=this.values,D=this.prefixSum;if(o>=E.length)return!1;const p=E.length-o;return g>=p&&(g=p),g===0?!1:(this.values=new Uint32Array(E.length-g),this.values.set(E.subarray(0,o),0),this.values.set(E.subarray(o+g),o),this.prefixSum=new Uint32Array(this.values.length),o-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=o-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(D.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(o){return o<0?0:(o=(0,t.toUint32)(o),this._getPrefixSum(o))}_getPrefixSum(o){if(o<=this.prefixSumValidIndex[0])return this.prefixSum[o];let g=this.prefixSumValidIndex[0]+1;g===0&&(this.prefixSum[0]=this.values[0],g++),o>=this.values.length&&(o=this.values.length-1);for(let E=g;E<=o;E++)this.prefixSum[E]=this.prefixSum[E-1]+this.values[E];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],o),this.prefixSum[o]}getIndexOf(o){o=Math.floor(o),this.getTotalSum();let g=0,E=this.values.length-1,D=0,p=0,f=0;for(;g<=E;)if(D=g+(E-g)/2|0,p=this.prefixSum[D],f=p-this.values[D],o<f)E=D-1;else if(o>=p)g=D+1;else break;return new N(D,o-f)}}n.PrefixSumComputer=M;class c{constructor(o){this._values=o,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(o){return this._ensureValid(),o===0?0:this._prefixSum[o-1]}getIndexOf(o){this._ensureValid();const g=this._indexBySum[o],E=g>0?this._prefixSum[g-1]:0;return new N(g,o-E)}removeValues(o,g){this._values.splice(o,g),this._invalidate(o)}insertValues(o,g){this._values=(0,y.arrayInsert)(this._values,o,g),this._invalidate(o)}_invalidate(o){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,o-1)}_ensureValid(){if(!this._isValid){for(let o=this._validEndIndex+1,g=this._values.length;o<g;o++){const E=this._values[o],D=o>0?this._prefixSum[o-1]:0;this._prefixSum[o]=D+E;for(let p=0;p<E;p++)this._indexBySum[D+p]=o}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(o,g){this._values[o]!==g&&(this._values[o]=g,this._invalidate(o))}}n.ConstantTimePrefixSumComputer=c;class N{constructor(o,g){this.index=o,this.remainder=g,this._prefixSumIndexOfResultBrand=void 0,this.index=o,this.remainder=g}}n.PrefixSumIndexOfResult=N}),Y(Z[41],J([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.WrappingIndent=n.TrackedRangeStickiness=n.TextEditorCursorStyle=n.TextEditorCursorBlinkingStyle=n.SymbolTag=n.SymbolKind=n.SignatureHelpTriggerKind=n.SelectionDirection=n.ScrollbarVisibility=n.ScrollType=n.RenderMinimap=n.RenderLineNumbersType=n.PositionAffinity=n.OverviewRulerLane=n.OverlayWidgetPositionPreference=n.MouseTargetType=n.MinimapPosition=n.MarkerTag=n.MarkerSeverity=n.KeyCode=n.InlineCompletionTriggerKind=n.InlayHintKind=n.InjectedTextCursorStops=n.IndentAction=n.EndOfLineSequence=n.EndOfLinePreference=n.EditorOption=n.EditorAutoIndentStrategy=n.DocumentHighlightKind=n.DefaultEndOfLine=n.CursorChangeReason=n.ContentWidgetPositionPreference=n.CompletionTriggerKind=n.CompletionItemTag=n.CompletionItemKind=n.CompletionItemInsertTextRule=n.CodeActionTriggerType=n.AccessibilitySupport=void 0;var y;(function(r){r[r.Unknown=0]="Unknown",r[r.Disabled=1]="Disabled",r[r.Enabled=2]="Enabled"})(y=n.AccessibilitySupport||(n.AccessibilitySupport={}));var t;(function(r){r[r.Invoke=1]="Invoke",r[r.Auto=2]="Auto"})(t=n.CodeActionTriggerType||(n.CodeActionTriggerType={}));var M;(function(r){r[r.KeepWhitespace=1]="KeepWhitespace",r[r.InsertAsSnippet=4]="InsertAsSnippet"})(M=n.CompletionItemInsertTextRule||(n.CompletionItemInsertTextRule={}));var c;(function(r){r[r.Method=0]="Method",r[r.Function=1]="Function",r[r.Constructor=2]="Constructor",r[r.Field=3]="Field",r[r.Variable=4]="Variable",r[r.Class=5]="Class",r[r.Struct=6]="Struct",r[r.Interface=7]="Interface",r[r.Module=8]="Module",r[r.Property=9]="Property",r[r.Event=10]="Event",r[r.Operator=11]="Operator",r[r.Unit=12]="Unit",r[r.Value=13]="Value",r[r.Constant=14]="Constant",r[r.Enum=15]="Enum",r[r.EnumMember=16]="EnumMember",r[r.Keyword=17]="Keyword",r[r.Text=18]="Text",r[r.Color=19]="Color",r[r.File=20]="File",r[r.Reference=21]="Reference",r[r.Customcolor=22]="Customcolor",r[r.Folder=23]="Folder",r[r.TypeParameter=24]="TypeParameter",r[r.User=25]="User",r[r.Issue=26]="Issue",r[r.Snippet=27]="Snippet"})(c=n.CompletionItemKind||(n.CompletionItemKind={}));var N;(function(r){r[r.Deprecated=1]="Deprecated"})(N=n.CompletionItemTag||(n.CompletionItemTag={}));var d;(function(r){r[r.Invoke=0]="Invoke",r[r.TriggerCharacter=1]="TriggerCharacter",r[r.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(d=n.CompletionTriggerKind||(n.CompletionTriggerKind={}));var o;(function(r){r[r.EXACT=0]="EXACT",r[r.ABOVE=1]="ABOVE",r[r.BELOW=2]="BELOW"})(o=n.ContentWidgetPositionPreference||(n.ContentWidgetPositionPreference={}));var g;(function(r){r[r.NotSet=0]="NotSet",r[r.ContentFlush=1]="ContentFlush",r[r.RecoverFromMarkers=2]="RecoverFromMarkers",r[r.Explicit=3]="Explicit",r[r.Paste=4]="Paste",r[r.Undo=5]="Undo",r[r.Redo=6]="Redo"})(g=n.CursorChangeReason||(n.CursorChangeReason={}));var E;(function(r){r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(E=n.DefaultEndOfLine||(n.DefaultEndOfLine={}));var D;(function(r){r[r.Text=0]="Text",r[r.Read=1]="Read",r[r.Write=2]="Write"})(D=n.DocumentHighlightKind||(n.DocumentHighlightKind={}));var p;(function(r){r[r.None=0]="None",r[r.Keep=1]="Keep",r[r.Brackets=2]="Brackets",r[r.Advanced=3]="Advanced",r[r.Full=4]="Full"})(p=n.EditorAutoIndentStrategy||(n.EditorAutoIndentStrategy={}));var f;(function(r){r[r.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",r[r.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",r[r.accessibilitySupport=2]="accessibilitySupport",r[r.accessibilityPageSize=3]="accessibilityPageSize",r[r.ariaLabel=4]="ariaLabel",r[r.autoClosingBrackets=5]="autoClosingBrackets",r[r.autoClosingDelete=6]="autoClosingDelete",r[r.autoClosingOvertype=7]="autoClosingOvertype",r[r.autoClosingQuotes=8]="autoClosingQuotes",r[r.autoIndent=9]="autoIndent",r[r.automaticLayout=10]="automaticLayout",r[r.autoSurround=11]="autoSurround",r[r.bracketPairColorization=12]="bracketPairColorization",r[r.guides=13]="guides",r[r.codeLens=14]="codeLens",r[r.codeLensFontFamily=15]="codeLensFontFamily",r[r.codeLensFontSize=16]="codeLensFontSize",r[r.colorDecorators=17]="colorDecorators",r[r.columnSelection=18]="columnSelection",r[r.comments=19]="comments",r[r.contextmenu=20]="contextmenu",r[r.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",r[r.cursorBlinking=22]="cursorBlinking",r[r.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",r[r.cursorStyle=24]="cursorStyle",r[r.cursorSurroundingLines=25]="cursorSurroundingLines",r[r.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",r[r.cursorWidth=27]="cursorWidth",r[r.disableLayerHinting=28]="disableLayerHinting",r[r.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",r[r.domReadOnly=30]="domReadOnly",r[r.dragAndDrop=31]="dragAndDrop",r[r.dropIntoEditor=32]="dropIntoEditor",r[r.emptySelectionClipboard=33]="emptySelectionClipboard",r[r.experimental=34]="experimental",r[r.extraEditorClassName=35]="extraEditorClassName",r[r.fastScrollSensitivity=36]="fastScrollSensitivity",r[r.find=37]="find",r[r.fixedOverflowWidgets=38]="fixedOverflowWidgets",r[r.folding=39]="folding",r[r.foldingStrategy=40]="foldingStrategy",r[r.foldingHighlight=41]="foldingHighlight",r[r.foldingImportsByDefault=42]="foldingImportsByDefault",r[r.foldingMaximumRegions=43]="foldingMaximumRegions",r[r.unfoldOnClickAfterEndOfLine=44]="unfoldOnClickAfterEndOfLine",r[r.fontFamily=45]="fontFamily",r[r.fontInfo=46]="fontInfo",r[r.fontLigatures=47]="fontLigatures",r[r.fontSize=48]="fontSize",r[r.fontWeight=49]="fontWeight",r[r.formatOnPaste=50]="formatOnPaste",r[r.formatOnType=51]="formatOnType",r[r.glyphMargin=52]="glyphMargin",r[r.gotoLocation=53]="gotoLocation",r[r.hideCursorInOverviewRuler=54]="hideCursorInOverviewRuler",r[r.hover=55]="hover",r[r.inDiffEditor=56]="inDiffEditor",r[r.inlineSuggest=57]="inlineSuggest",r[r.letterSpacing=58]="letterSpacing",r[r.lightbulb=59]="lightbulb",r[r.lineDecorationsWidth=60]="lineDecorationsWidth",r[r.lineHeight=61]="lineHeight",r[r.lineNumbers=62]="lineNumbers",r[r.lineNumbersMinChars=63]="lineNumbersMinChars",r[r.linkedEditing=64]="linkedEditing",r[r.links=65]="links",r[r.matchBrackets=66]="matchBrackets",r[r.minimap=67]="minimap",r[r.mouseStyle=68]="mouseStyle",r[r.mouseWheelScrollSensitivity=69]="mouseWheelScrollSensitivity",r[r.mouseWheelZoom=70]="mouseWheelZoom",r[r.multiCursorMergeOverlapping=71]="multiCursorMergeOverlapping",r[r.multiCursorModifier=72]="multiCursorModifier",r[r.multiCursorPaste=73]="multiCursorPaste",r[r.occurrencesHighlight=74]="occurrencesHighlight",r[r.overviewRulerBorder=75]="overviewRulerBorder",r[r.overviewRulerLanes=76]="overviewRulerLanes",r[r.padding=77]="padding",r[r.parameterHints=78]="parameterHints",r[r.peekWidgetDefaultFocus=79]="peekWidgetDefaultFocus",r[r.definitionLinkOpensInPeek=80]="definitionLinkOpensInPeek",r[r.quickSuggestions=81]="quickSuggestions",r[r.quickSuggestionsDelay=82]="quickSuggestionsDelay",r[r.readOnly=83]="readOnly",r[r.renameOnType=84]="renameOnType",r[r.renderControlCharacters=85]="renderControlCharacters",r[r.renderFinalNewline=86]="renderFinalNewline",r[r.renderLineHighlight=87]="renderLineHighlight",r[r.renderLineHighlightOnlyWhenFocus=88]="renderLineHighlightOnlyWhenFocus",r[r.renderValidationDecorations=89]="renderValidationDecorations",r[r.renderWhitespace=90]="renderWhitespace",r[r.revealHorizontalRightPadding=91]="revealHorizontalRightPadding",r[r.roundedSelection=92]="roundedSelection",r[r.rulers=93]="rulers",r[r.scrollbar=94]="scrollbar",r[r.scrollBeyondLastColumn=95]="scrollBeyondLastColumn",r[r.scrollBeyondLastLine=96]="scrollBeyondLastLine",r[r.scrollPredominantAxis=97]="scrollPredominantAxis",r[r.selectionClipboard=98]="selectionClipboard",r[r.selectionHighlight=99]="selectionHighlight",r[r.selectOnLineNumbers=100]="selectOnLineNumbers",r[r.showFoldingControls=101]="showFoldingControls",r[r.showUnused=102]="showUnused",r[r.snippetSuggestions=103]="snippetSuggestions",r[r.smartSelect=104]="smartSelect",r[r.smoothScrolling=105]="smoothScrolling",r[r.stickyTabStops=106]="stickyTabStops",r[r.stopRenderingLineAfter=107]="stopRenderingLineAfter",r[r.suggest=108]="suggest",r[r.suggestFontSize=109]="suggestFontSize",r[r.suggestLineHeight=110]="suggestLineHeight",r[r.suggestOnTriggerCharacters=111]="suggestOnTriggerCharacters",r[r.suggestSelection=112]="suggestSelection",r[r.tabCompletion=113]="tabCompletion",r[r.tabIndex=114]="tabIndex",r[r.unicodeHighlighting=115]="unicodeHighlighting",r[r.unusualLineTerminators=116]="unusualLineTerminators",r[r.useShadowDOM=117]="useShadowDOM",r[r.useTabStops=118]="useTabStops",r[r.wordSeparators=119]="wordSeparators",r[r.wordWrap=120]="wordWrap",r[r.wordWrapBreakAfterCharacters=121]="wordWrapBreakAfterCharacters",r[r.wordWrapBreakBeforeCharacters=122]="wordWrapBreakBeforeCharacters",r[r.wordWrapColumn=123]="wordWrapColumn",r[r.wordWrapOverride1=124]="wordWrapOverride1",r[r.wordWrapOverride2=125]="wordWrapOverride2",r[r.wrappingIndent=126]="wrappingIndent",r[r.wrappingStrategy=127]="wrappingStrategy",r[r.showDeprecated=128]="showDeprecated",r[r.inlayHints=129]="inlayHints",r[r.editorClassName=130]="editorClassName",r[r.pixelRatio=131]="pixelRatio",r[r.tabFocusMode=132]="tabFocusMode",r[r.layoutInfo=133]="layoutInfo",r[r.wrappingInfo=134]="wrappingInfo"})(f=n.EditorOption||(n.EditorOption={}));var e;(function(r){r[r.TextDefined=0]="TextDefined",r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(e=n.EndOfLinePreference||(n.EndOfLinePreference={}));var C;(function(r){r[r.LF=0]="LF",r[r.CRLF=1]="CRLF"})(C=n.EndOfLineSequence||(n.EndOfLineSequence={}));var R;(function(r){r[r.None=0]="None",r[r.Indent=1]="Indent",r[r.IndentOutdent=2]="IndentOutdent",r[r.Outdent=3]="Outdent"})(R=n.IndentAction||(n.IndentAction={}));var A;(function(r){r[r.Both=0]="Both",r[r.Right=1]="Right",r[r.Left=2]="Left",r[r.None=3]="None"})(A=n.InjectedTextCursorStops||(n.InjectedTextCursorStops={}));var _;(function(r){r[r.Type=1]="Type",r[r.Parameter=2]="Parameter"})(_=n.InlayHintKind||(n.InlayHintKind={}));var i;(function(r){r[r.Automatic=0]="Automatic",r[r.Explicit=1]="Explicit"})(i=n.InlineCompletionTriggerKind||(n.InlineCompletionTriggerKind={}));var s;(function(r){r[r.DependsOnKbLayout=-1]="DependsOnKbLayout",r[r.Unknown=0]="Unknown",r[r.Backspace=1]="Backspace",r[r.Tab=2]="Tab",r[r.Enter=3]="Enter",r[r.Shift=4]="Shift",r[r.Ctrl=5]="Ctrl",r[r.Alt=6]="Alt",r[r.PauseBreak=7]="PauseBreak",r[r.CapsLock=8]="CapsLock",r[r.Escape=9]="Escape",r[r.Space=10]="Space",r[r.PageUp=11]="PageUp",r[r.PageDown=12]="PageDown",r[r.End=13]="End",r[r.Home=14]="Home",r[r.LeftArrow=15]="LeftArrow",r[r.UpArrow=16]="UpArrow",r[r.RightArrow=17]="RightArrow",r[r.DownArrow=18]="DownArrow",r[r.Insert=19]="Insert",r[r.Delete=20]="Delete",r[r.Digit0=21]="Digit0",r[r.Digit1=22]="Digit1",r[r.Digit2=23]="Digit2",r[r.Digit3=24]="Digit3",r[r.Digit4=25]="Digit4",r[r.Digit5=26]="Digit5",r[r.Digit6=27]="Digit6",r[r.Digit7=28]="Digit7",r[r.Digit8=29]="Digit8",r[r.Digit9=30]="Digit9",r[r.KeyA=31]="KeyA",r[r.KeyB=32]="KeyB",r[r.KeyC=33]="KeyC",r[r.KeyD=34]="KeyD",r[r.KeyE=35]="KeyE",r[r.KeyF=36]="KeyF",r[r.KeyG=37]="KeyG",r[r.KeyH=38]="KeyH",r[r.KeyI=39]="KeyI",r[r.KeyJ=40]="KeyJ",r[r.KeyK=41]="KeyK",r[r.KeyL=42]="KeyL",r[r.KeyM=43]="KeyM",r[r.KeyN=44]="KeyN",r[r.KeyO=45]="KeyO",r[r.KeyP=46]="KeyP",r[r.KeyQ=47]="KeyQ",r[r.KeyR=48]="KeyR",r[r.KeyS=49]="KeyS",r[r.KeyT=50]="KeyT",r[r.KeyU=51]="KeyU",r[r.KeyV=52]="KeyV",r[r.KeyW=53]="KeyW",r[r.KeyX=54]="KeyX",r[r.KeyY=55]="KeyY",r[r.KeyZ=56]="KeyZ",r[r.Meta=57]="Meta",r[r.ContextMenu=58]="ContextMenu",r[r.F1=59]="F1",r[r.F2=60]="F2",r[r.F3=61]="F3",r[r.F4=62]="F4",r[r.F5=63]="F5",r[r.F6=64]="F6",r[r.F7=65]="F7",r[r.F8=66]="F8",r[r.F9=67]="F9",r[r.F10=68]="F10",r[r.F11=69]="F11",r[r.F12=70]="F12",r[r.F13=71]="F13",r[r.F14=72]="F14",r[r.F15=73]="F15",r[r.F16=74]="F16",r[r.F17=75]="F17",r[r.F18=76]="F18",r[r.F19=77]="F19",r[r.NumLock=78]="NumLock",r[r.ScrollLock=79]="ScrollLock",r[r.Semicolon=80]="Semicolon",r[r.Equal=81]="Equal",r[r.Comma=82]="Comma",r[r.Minus=83]="Minus",r[r.Period=84]="Period",r[r.Slash=85]="Slash",r[r.Backquote=86]="Backquote",r[r.BracketLeft=87]="BracketLeft",r[r.Backslash=88]="Backslash",r[r.BracketRight=89]="BracketRight",r[r.Quote=90]="Quote",r[r.OEM_8=91]="OEM_8",r[r.IntlBackslash=92]="IntlBackslash",r[r.Numpad0=93]="Numpad0",r[r.Numpad1=94]="Numpad1",r[r.Numpad2=95]="Numpad2",r[r.Numpad3=96]="Numpad3",r[r.Numpad4=97]="Numpad4",r[r.Numpad5=98]="Numpad5",r[r.Numpad6=99]="Numpad6",r[r.Numpad7=100]="Numpad7",r[r.Numpad8=101]="Numpad8",r[r.Numpad9=102]="Numpad9",r[r.NumpadMultiply=103]="NumpadMultiply",r[r.NumpadAdd=104]="NumpadAdd",r[r.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",r[r.NumpadSubtract=106]="NumpadSubtract",r[r.NumpadDecimal=107]="NumpadDecimal",r[r.NumpadDivide=108]="NumpadDivide",r[r.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",r[r.ABNT_C1=110]="ABNT_C1",r[r.ABNT_C2=111]="ABNT_C2",r[r.AudioVolumeMute=112]="AudioVolumeMute",r[r.AudioVolumeUp=113]="AudioVolumeUp",r[r.AudioVolumeDown=114]="AudioVolumeDown",r[r.BrowserSearch=115]="BrowserSearch",r[r.BrowserHome=116]="BrowserHome",r[r.BrowserBack=117]="BrowserBack",r[r.BrowserForward=118]="BrowserForward",r[r.MediaTrackNext=119]="MediaTrackNext",r[r.MediaTrackPrevious=120]="MediaTrackPrevious",r[r.MediaStop=121]="MediaStop",r[r.MediaPlayPause=122]="MediaPlayPause",r[r.LaunchMediaPlayer=123]="LaunchMediaPlayer",r[r.LaunchMail=124]="LaunchMail",r[r.LaunchApp2=125]="LaunchApp2",r[r.Clear=126]="Clear",r[r.MAX_VALUE=127]="MAX_VALUE"})(s=n.KeyCode||(n.KeyCode={}));var a;(function(r){r[r.Hint=1]="Hint",r[r.Info=2]="Info",r[r.Warning=4]="Warning",r[r.Error=8]="Error"})(a=n.MarkerSeverity||(n.MarkerSeverity={}));var l;(function(r){r[r.Unnecessary=1]="Unnecessary",r[r.Deprecated=2]="Deprecated"})(l=n.MarkerTag||(n.MarkerTag={}));var u;(function(r){r[r.Inline=1]="Inline",r[r.Gutter=2]="Gutter"})(u=n.MinimapPosition||(n.MinimapPosition={}));var m;(function(r){r[r.UNKNOWN=0]="UNKNOWN",r[r.TEXTAREA=1]="TEXTAREA",r[r.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",r[r.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",r[r.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",r[r.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",r[r.CONTENT_TEXT=6]="CONTENT_TEXT",r[r.CONTENT_EMPTY=7]="CONTENT_EMPTY",r[r.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",r[r.CONTENT_WIDGET=9]="CONTENT_WIDGET",r[r.OVERVIEW_RULER=10]="OVERVIEW_RULER",r[r.SCROLLBAR=11]="SCROLLBAR",r[r.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",r[r.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(m=n.MouseTargetType||(n.MouseTargetType={}));var h;(function(r){r[r.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",r[r.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",r[r.TOP_CENTER=2]="TOP_CENTER"})(h=n.OverlayWidgetPositionPreference||(n.OverlayWidgetPositionPreference={}));var b;(function(r){r[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=4]="Right",r[r.Full=7]="Full"})(b=n.OverviewRulerLane||(n.OverviewRulerLane={}));var w;(function(r){r[r.Left=0]="Left",r[r.Right=1]="Right",r[r.None=2]="None",r[r.LeftOfInjectedText=3]="LeftOfInjectedText",r[r.RightOfInjectedText=4]="RightOfInjectedText"})(w=n.PositionAffinity||(n.PositionAffinity={}));var L;(function(r){r[r.Off=0]="Off",r[r.On=1]="On",r[r.Relative=2]="Relative",r[r.Interval=3]="Interval",r[r.Custom=4]="Custom"})(L=n.RenderLineNumbersType||(n.RenderLineNumbersType={}));var v;(function(r){r[r.None=0]="None",r[r.Text=1]="Text",r[r.Blocks=2]="Blocks"})(v=n.RenderMinimap||(n.RenderMinimap={}));var F;(function(r){r[r.Smooth=0]="Smooth",r[r.Immediate=1]="Immediate"})(F=n.ScrollType||(n.ScrollType={}));var B;(function(r){r[r.Auto=1]="Auto",r[r.Hidden=2]="Hidden",r[r.Visible=3]="Visible"})(B=n.ScrollbarVisibility||(n.ScrollbarVisibility={}));var U;(function(r){r[r.LTR=0]="LTR",r[r.RTL=1]="RTL"})(U=n.SelectionDirection||(n.SelectionDirection={}));var V;(function(r){r[r.Invoke=1]="Invoke",r[r.TriggerCharacter=2]="TriggerCharacter",r[r.ContentChange=3]="ContentChange"})(V=n.SignatureHelpTriggerKind||(n.SignatureHelpTriggerKind={}));var $;(function(r){r[r.File=0]="File",r[r.Module=1]="Module",r[r.Namespace=2]="Namespace",r[r.Package=3]="Package",r[r.Class=4]="Class",r[r.Method=5]="Method",r[r.Property=6]="Property",r[r.Field=7]="Field",r[r.Constructor=8]="Constructor",r[r.Enum=9]="Enum",r[r.Interface=10]="Interface",r[r.Function=11]="Function",r[r.Variable=12]="Variable",r[r.Constant=13]="Constant",r[r.String=14]="String",r[r.Number=15]="Number",r[r.Boolean=16]="Boolean",r[r.Array=17]="Array",r[r.Object=18]="Object",r[r.Key=19]="Key",r[r.Null=20]="Null",r[r.EnumMember=21]="EnumMember",r[r.Struct=22]="Struct",r[r.Event=23]="Event",r[r.Operator=24]="Operator",r[r.TypeParameter=25]="TypeParameter"})($=n.SymbolKind||(n.SymbolKind={}));var j;(function(r){r[r.Deprecated=1]="Deprecated"})(j=n.SymbolTag||(n.SymbolTag={}));var ne;(function(r){r[r.Hidden=0]="Hidden",r[r.Blink=1]="Blink",r[r.Smooth=2]="Smooth",r[r.Phase=3]="Phase",r[r.Expand=4]="Expand",r[r.Solid=5]="Solid"})(ne=n.TextEditorCursorBlinkingStyle||(n.TextEditorCursorBlinkingStyle={}));var oe;(function(r){r[r.Line=1]="Line",r[r.Block=2]="Block",r[r.Underline=3]="Underline",r[r.LineThin=4]="LineThin",r[r.BlockOutline=5]="BlockOutline",r[r.UnderlineThin=6]="UnderlineThin"})(oe=n.TextEditorCursorStyle||(n.TextEditorCursorStyle={}));var re;(function(r){r[r.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",r[r.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",r[r.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",r[r.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(re=n.TrackedRangeStickiness||(n.TrackedRangeStickiness={}));var x;(function(r){r[r.None=0]="None",r[r.Same=1]="Same",r[r.Indent=2]="Indent",r[r.DeepIndent=3]="DeepIndent"})(x=n.WrappingIndent||(n.WrappingIndent={}))}),Y(Z[42],J([23,54]),function(O,n){return O.create("vs/base/common/platform",n)}),Y(Z[5],J([0,1,42]),function(O,n,y){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.isAndroid=n.isEdge=n.isSafari=n.isFirefox=n.isChrome=n.isLittleEndian=n.OS=n.OperatingSystem=n.setTimeout0=n.setTimeout0IsFaster=n.translationsConfigFile=n.locale=n.Language=n.language=n.userAgent=n.platform=n.isCI=n.isIOS=n.isWebWorker=n.isWeb=n.isElectron=n.isNative=n.isLinuxSnap=n.isLinux=n.isMacintosh=n.isWindows=n.PlatformToString=n.Platform=n.globals=void 0;const t="en";let M=!1,c=!1,N=!1,d=!1,o=!1,g=!1,E=!1,D=!1,p=!1,f,e=t,C,R;n.globals=typeof self=="object"?self:typeof global=="object"?global:{};let A;typeof n.globals.vscode!="undefined"&&typeof n.globals.vscode.process!="undefined"?A=n.globals.vscode.process:typeof process!="undefined"&&(A=process);const _=typeof A?.versions?.electron=="string",i=_&&A?.type==="renderer";if(typeof navigator=="object"&&!i)R=navigator.userAgent,M=R.indexOf("Windows")>=0,c=R.indexOf("Macintosh")>=0,D=(R.indexOf("Macintosh")>=0||R.indexOf("iPad")>=0||R.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,N=R.indexOf("Linux")>=0,g=!0,f=y.getConfiguredDefaultLocale(y.localize(0,null))||t,e=f;else if(typeof A=="object"){M=A.platform==="win32",c=A.platform==="darwin",N=A.platform==="linux",d=N&&!!A.env.SNAP&&!!A.env.SNAP_REVISION,E=_,p=!!A.env.CI||!!A.env.BUILD_ARTIFACTSTAGINGDIRECTORY,f=t,e=t;const L=A.env.VSCODE_NLS_CONFIG;if(L)try{const v=JSON.parse(L),F=v.availableLanguages["*"];f=v.locale,e=F||t,C=v._translationsConfigFile}catch{}o=!0}else console.error("Unable to resolve platform.");var s;(function(L){L[L.Web=0]="Web",L[L.Mac=1]="Mac",L[L.Linux=2]="Linux",L[L.Windows=3]="Windows"})(s=n.Platform||(n.Platform={}));function a(L){switch(L){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}n.PlatformToString=a;let l=0;c?l=1:M?l=3:N&&(l=2),n.isWindows=M,n.isMacintosh=c,n.isLinux=N,n.isLinuxSnap=d,n.isNative=o,n.isElectron=E,n.isWeb=g,n.isWebWorker=g&&typeof n.globals.importScripts=="function",n.isIOS=D,n.isCI=p,n.platform=l,n.userAgent=R,n.language=e;var u;(function(L){function v(){return n.language}L.value=v;function F(){return n.language.length===2?n.language==="en":n.language.length>=3?n.language[0]==="e"&&n.language[1]==="n"&&n.language[2]==="-":!1}L.isDefaultVariant=F;function B(){return n.language==="en"}L.isDefault=B})(u=n.Language||(n.Language={})),n.locale=f,n.translationsConfigFile=C,n.setTimeout0IsFaster=typeof n.globals.postMessage=="function"&&!n.globals.importScripts,n.setTimeout0=(()=>{if(n.setTimeout0IsFaster){const L=[];n.globals.addEventListener("message",F=>{if(F.data&&F.data.vscodeScheduleAsyncWork)for(let B=0,U=L.length;B<U;B++){const V=L[B];if(V.id===F.data.vscodeScheduleAsyncWork){L.splice(B,1),V.callback();return}}});let v=0;return F=>{const B=++v;L.push({id:B,callback:F}),n.globals.postMessage({vscodeScheduleAsyncWork:B},"*")}}return L=>setTimeout(L)})();var m;(function(L){L[L.Windows=1]="Windows",L[L.Macintosh=2]="Macintosh",L[L.Linux=3]="Linux"})(m=n.OperatingSystem||(n.OperatingSystem={})),n.OS=c||D?2:M?1:3;let h=!0,b=!1;function w(){if(!b){b=!0;const L=new Uint8Array(2);L[0]=1,L[1]=2,h=new Uint16Array(L.buffer)[0]===(2<<8)+1}return h}n.isLittleEndian=w,n.isChrome=!!(n.userAgent&&n.userAgent.indexOf("Chrome")>=0),n.isFirefox=!!(n.userAgent&&n.userAgent.indexOf("Firefox")>=0),n.isSafari=!!(!n.isChrome&&n.userAgent&&n.userAgent.indexOf("Safari")>=0),n.isEdge=!!(n.userAgent&&n.userAgent.indexOf("Edg/")>=0),n.isAndroid=!!(n.userAgent&&n.userAgent.indexOf("Android")>=0)}),Y(Z[43],J([0,1,5]),function(O,n,y){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.arch=n.platform=n.env=n.cwd=void 0;let t;if(typeof y.globals.vscode!="undefined"&&typeof y.globals.vscode.process!="undefined"){const M=y.globals.vscode.process;t={get platform(){return M.platform},get arch(){return M.arch},get env(){return M.env},cwd(){return M.cwd()}}}else typeof process!="undefined"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return y.isWindows?"win32":y.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};n.cwd=t.cwd,n.env=t.env,n.platform=t.platform,n.arch=t.arch}),Y(Z[44],J([0,1,43]),function(O,n,y){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.delimiter=n.sep=n.toNamespacedPath=n.parse=n.format=n.extname=n.basename=n.dirname=n.relative=n.resolve=n.join=n.isAbsolute=n.normalize=n.posix=n.win32=void 0;const t=65,M=97,c=90,N=122,d=46,o=47,g=92,E=58,D=63;class p extends Error{constructor(s,a,l){let u;typeof a=="string"&&a.indexOf("not ")===0?(u="must not be",a=a.replace(/^not /,"")):u="must be";const m=s.indexOf(".")!==-1?"property":"argument";let h=`The "${s}" ${m} ${u} of type ${a}`;h+=`. Received type ${typeof l}`;super(h);this.code="ERR_INVALID_ARG_TYPE"}}function f(i,s){if(typeof i!="string")throw new p(s,"string",i)}function e(i){return i===o||i===g}function C(i){return i===o}function R(i){return i>=t&&i<=c||i>=M&&i<=N}function A(i,s,a,l){let u="",m=0,h=-1,b=0,w=0;for(let L=0;L<=i.length;++L){if(L<i.length)w=i.charCodeAt(L);else{if(l(w))break;w=o}if(l(w)){if(!(h===L-1||b===1))if(b===2){if(u.length<2||m!==2||u.charCodeAt(u.length-1)!==d||u.charCodeAt(u.length-2)!==d){if(u.length>2){const v=u.lastIndexOf(a);v===-1?(u="",m=0):(u=u.slice(0,v),m=u.length-1-u.lastIndexOf(a)),h=L,b=0;continue}else if(u.length!==0){u="",m=0,h=L,b=0;continue}}s&&(u+=u.length>0?`${a}..`:"..",m=2)}else u.length>0?u+=`${a}${i.slice(h+1,L)}`:u=i.slice(h+1,L),m=L-h-1;h=L,b=0}else w===d&&b!==-1?++b:b=-1}return u}function _(i,s){if(s===null||typeof s!="object")throw new p("pathObject","Object",s);const a=s.dir||s.root,l=s.base||`${s.name||""}${s.ext||""}`;return a?a===s.root?`${a}${l}`:`${a}${i}${l}`:l}n.win32={resolve(...i){let s="",a="",l=!1;for(let u=i.length-1;u>=-1;u--){let m;if(u>=0){if(m=i[u],f(m,"path"),m.length===0)continue}else s.length===0?m=y.cwd():(m=y.env[`=${s}`]||y.cwd(),(m===void 0||m.slice(0,2).toLowerCase()!==s.toLowerCase()&&m.charCodeAt(2)===g)&&(m=`${s}\\`));const h=m.length;let b=0,w="",L=!1;const v=m.charCodeAt(0);if(h===1)e(v)&&(b=1,L=!0);else if(e(v))if(L=!0,e(m.charCodeAt(1))){let F=2,B=F;for(;F<h&&!e(m.charCodeAt(F));)F++;if(F<h&&F!==B){const U=m.slice(B,F);for(B=F;F<h&&e(m.charCodeAt(F));)F++;if(F<h&&F!==B){for(B=F;F<h&&!e(m.charCodeAt(F));)F++;(F===h||F!==B)&&(w=`\\\\${U}\\${m.slice(B,F)}`,b=F)}}}else b=1;else R(v)&&m.charCodeAt(1)===E&&(w=m.slice(0,2),b=2,h>2&&e(m.charCodeAt(2))&&(L=!0,b=3));if(w.length>0)if(s.length>0){if(w.toLowerCase()!==s.toLowerCase())continue}else s=w;if(l){if(s.length>0)break}else if(a=`${m.slice(b)}\\${a}`,l=L,L&&s.length>0)break}return a=A(a,!l,"\\",e),l?`${s}\\${a}`:`${s}${a}`||"."},normalize(i){f(i,"path");const s=i.length;if(s===0)return".";let a=0,l,u=!1;const m=i.charCodeAt(0);if(s===1)return C(m)?"\\":i;if(e(m))if(u=!0,e(i.charCodeAt(1))){let b=2,w=b;for(;b<s&&!e(i.charCodeAt(b));)b++;if(b<s&&b!==w){const L=i.slice(w,b);for(w=b;b<s&&e(i.charCodeAt(b));)b++;if(b<s&&b!==w){for(w=b;b<s&&!e(i.charCodeAt(b));)b++;if(b===s)return`\\\\${L}\\${i.slice(w)}\\`;b!==w&&(l=`\\\\${L}\\${i.slice(w,b)}`,a=b)}}}else a=1;else R(m)&&i.charCodeAt(1)===E&&(l=i.slice(0,2),a=2,s>2&&e(i.charCodeAt(2))&&(u=!0,a=3));let h=a<s?A(i.slice(a),!u,"\\",e):"";return h.length===0&&!u&&(h="."),h.length>0&&e(i.charCodeAt(s-1))&&(h+="\\"),l===void 0?u?`\\${h}`:h:u?`${l}\\${h}`:`${l}${h}`},isAbsolute(i){f(i,"path");const s=i.length;if(s===0)return!1;const a=i.charCodeAt(0);return e(a)||s>2&&R(a)&&i.charCodeAt(1)===E&&e(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let s,a;for(let m=0;m<i.length;++m){const h=i[m];f(h,"path"),h.length>0&&(s===void 0?s=a=h:s+=`\\${h}`)}if(s===void 0)return".";let l=!0,u=0;if(typeof a=="string"&&e(a.charCodeAt(0))){++u;const m=a.length;m>1&&e(a.charCodeAt(1))&&(++u,m>2&&(e(a.charCodeAt(2))?++u:l=!1))}if(l){for(;u<s.length&&e(s.charCodeAt(u));)u++;u>=2&&(s=`\\${s.slice(u)}`)}return n.win32.normalize(s)},relative(i,s){if(f(i,"from"),f(s,"to"),i===s)return"";const a=n.win32.resolve(i),l=n.win32.resolve(s);if(a===l||(i=a.toLowerCase(),s=l.toLowerCase(),i===s))return"";let u=0;for(;u<i.length&&i.charCodeAt(u)===g;)u++;let m=i.length;for(;m-1>u&&i.charCodeAt(m-1)===g;)m--;const h=m-u;let b=0;for(;b<s.length&&s.charCodeAt(b)===g;)b++;let w=s.length;for(;w-1>b&&s.charCodeAt(w-1)===g;)w--;const L=w-b,v=h<L?h:L;let F=-1,B=0;for(;B<v;B++){const V=i.charCodeAt(u+B);if(V!==s.charCodeAt(b+B))break;V===g&&(F=B)}if(B!==v){if(F===-1)return l}else{if(L>v){if(s.charCodeAt(b+B)===g)return l.slice(b+B+1);if(B===2)return l.slice(b+B)}h>v&&(i.charCodeAt(u+B)===g?F=B:B===2&&(F=3)),F===-1&&(F=0)}let U="";for(B=u+F+1;B<=m;++B)(B===m||i.charCodeAt(B)===g)&&(U+=U.length===0?"..":"\\..");return b+=F,U.length>0?`${U}${l.slice(b,w)}`:(l.charCodeAt(b)===g&&++b,l.slice(b,w))},toNamespacedPath(i){if(typeof i!="string")return i;if(i.length===0)return"";const s=n.win32.resolve(i);if(s.length<=2)return i;if(s.charCodeAt(0)===g){if(s.charCodeAt(1)===g){const a=s.charCodeAt(2);if(a!==D&&a!==d)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(R(s.charCodeAt(0))&&s.charCodeAt(1)===E&&s.charCodeAt(2)===g)return`\\\\?\\${s}`;return i},dirname(i){f(i,"path");const s=i.length;if(s===0)return".";let a=-1,l=0;const u=i.charCodeAt(0);if(s===1)return e(u)?i:".";if(e(u)){if(a=l=1,e(i.charCodeAt(1))){let b=2,w=b;for(;b<s&&!e(i.charCodeAt(b));)b++;if(b<s&&b!==w){for(w=b;b<s&&e(i.charCodeAt(b));)b++;if(b<s&&b!==w){for(w=b;b<s&&!e(i.charCodeAt(b));)b++;if(b===s)return i;b!==w&&(a=l=b+1)}}}}else R(u)&&i.charCodeAt(1)===E&&(a=s>2&&e(i.charCodeAt(2))?3:2,l=a);let m=-1,h=!0;for(let b=s-1;b>=l;--b)if(e(i.charCodeAt(b))){if(!h){m=b;break}}else h=!1;if(m===-1){if(a===-1)return".";m=a}return i.slice(0,m)},basename(i,s){s!==void 0&&f(s,"ext"),f(i,"path");let a=0,l=-1,u=!0,m;if(i.length>=2&&R(i.charCodeAt(0))&&i.charCodeAt(1)===E&&(a=2),s!==void 0&&s.length>0&&s.length<=i.length){if(s===i)return"";let h=s.length-1,b=-1;for(m=i.length-1;m>=a;--m){const w=i.charCodeAt(m);if(e(w)){if(!u){a=m+1;break}}else b===-1&&(u=!1,b=m+1),h>=0&&(w===s.charCodeAt(h)?--h==-1&&(l=m):(h=-1,l=b))}return a===l?l=b:l===-1&&(l=i.length),i.slice(a,l)}for(m=i.length-1;m>=a;--m)if(e(i.charCodeAt(m))){if(!u){a=m+1;break}}else l===-1&&(u=!1,l=m+1);return l===-1?"":i.slice(a,l)},extname(i){f(i,"path");let s=0,a=-1,l=0,u=-1,m=!0,h=0;i.length>=2&&i.charCodeAt(1)===E&&R(i.charCodeAt(0))&&(s=l=2);for(let b=i.length-1;b>=s;--b){const w=i.charCodeAt(b);if(e(w)){if(!m){l=b+1;break}continue}u===-1&&(m=!1,u=b+1),w===d?a===-1?a=b:h!==1&&(h=1):a!==-1&&(h=-1)}return a===-1||u===-1||h===0||h===1&&a===u-1&&a===l+1?"":i.slice(a,u)},format:_.bind(null,"\\"),parse(i){f(i,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return s;const a=i.length;let l=0,u=i.charCodeAt(0);if(a===1)return e(u)?(s.root=s.dir=i,s):(s.base=s.name=i,s);if(e(u)){if(l=1,e(i.charCodeAt(1))){let F=2,B=F;for(;F<a&&!e(i.charCodeAt(F));)F++;if(F<a&&F!==B){for(B=F;F<a&&e(i.charCodeAt(F));)F++;if(F<a&&F!==B){for(B=F;F<a&&!e(i.charCodeAt(F));)F++;F===a?l=F:F!==B&&(l=F+1)}}}}else if(R(u)&&i.charCodeAt(1)===E){if(a<=2)return s.root=s.dir=i,s;if(l=2,e(i.charCodeAt(2))){if(a===3)return s.root=s.dir=i,s;l=3}}l>0&&(s.root=i.slice(0,l));let m=-1,h=l,b=-1,w=!0,L=i.length-1,v=0;for(;L>=l;--L){if(u=i.charCodeAt(L),e(u)){if(!w){h=L+1;break}continue}b===-1&&(w=!1,b=L+1),u===d?m===-1?m=L:v!==1&&(v=1):m!==-1&&(v=-1)}return b!==-1&&(m===-1||v===0||v===1&&m===b-1&&m===h+1?s.base=s.name=i.slice(h,b):(s.name=i.slice(h,m),s.base=i.slice(h,b),s.ext=i.slice(m,b))),h>0&&h!==l?s.dir=i.slice(0,h-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null},n.posix={resolve(...i){let s="",a=!1;for(let l=i.length-1;l>=-1&&!a;l--){const u=l>=0?i[l]:y.cwd();f(u,"path"),u.length!==0&&(s=`${u}/${s}`,a=u.charCodeAt(0)===o)}return s=A(s,!a,"/",C),a?`/${s}`:s.length>0?s:"."},normalize(i){if(f(i,"path"),i.length===0)return".";const s=i.charCodeAt(0)===o,a=i.charCodeAt(i.length-1)===o;return i=A(i,!s,"/",C),i.length===0?s?"/":a?"./":".":(a&&(i+="/"),s?`/${i}`:i)},isAbsolute(i){return f(i,"path"),i.length>0&&i.charCodeAt(0)===o},join(...i){if(i.length===0)return".";let s;for(let a=0;a<i.length;++a){const l=i[a];f(l,"path"),l.length>0&&(s===void 0?s=l:s+=`/${l}`)}return s===void 0?".":n.posix.normalize(s)},relative(i,s){if(f(i,"from"),f(s,"to"),i===s||(i=n.posix.resolve(i),s=n.posix.resolve(s),i===s))return"";const a=1,l=i.length,u=l-a,m=1,h=s.length-m,b=u<h?u:h;let w=-1,L=0;for(;L<b;L++){const F=i.charCodeAt(a+L);if(F!==s.charCodeAt(m+L))break;F===o&&(w=L)}if(L===b)if(h>b){if(s.charCodeAt(m+L)===o)return s.slice(m+L+1);if(L===0)return s.slice(m+L)}else u>b&&(i.charCodeAt(a+L)===o?w=L:L===0&&(w=0));let v="";for(L=a+w+1;L<=l;++L)(L===l||i.charCodeAt(L)===o)&&(v+=v.length===0?"..":"/..");return`${v}${s.slice(m+w)}`},toNamespacedPath(i){return i},dirname(i){if(f(i,"path"),i.length===0)return".";const s=i.charCodeAt(0)===o;let a=-1,l=!0;for(let u=i.length-1;u>=1;--u)if(i.charCodeAt(u)===o){if(!l){a=u;break}}else l=!1;return a===-1?s?"/":".":s&&a===1?"//":i.slice(0,a)},basename(i,s){s!==void 0&&f(s,"ext"),f(i,"path");let a=0,l=-1,u=!0,m;if(s!==void 0&&s.length>0&&s.length<=i.length){if(s===i)return"";let h=s.length-1,b=-1;for(m=i.length-1;m>=0;--m){const w=i.charCodeAt(m);if(w===o){if(!u){a=m+1;break}}else b===-1&&(u=!1,b=m+1),h>=0&&(w===s.charCodeAt(h)?--h==-1&&(l=m):(h=-1,l=b))}return a===l?l=b:l===-1&&(l=i.length),i.slice(a,l)}for(m=i.length-1;m>=0;--m)if(i.charCodeAt(m)===o){if(!u){a=m+1;break}}else l===-1&&(u=!1,l=m+1);return l===-1?"":i.slice(a,l)},extname(i){f(i,"path");let s=-1,a=0,l=-1,u=!0,m=0;for(let h=i.length-1;h>=0;--h){const b=i.charCodeAt(h);if(b===o){if(!u){a=h+1;break}continue}l===-1&&(u=!1,l=h+1),b===d?s===-1?s=h:m!==1&&(m=1):s!==-1&&(m=-1)}return s===-1||l===-1||m===0||m===1&&s===l-1&&s===a+1?"":i.slice(s,l)},format:_.bind(null,"/"),parse(i){f(i,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return s;const a=i.charCodeAt(0)===o;let l;a?(s.root="/",l=1):l=0;let u=-1,m=0,h=-1,b=!0,w=i.length-1,L=0;for(;w>=l;--w){const v=i.charCodeAt(w);if(v===o){if(!b){m=w+1;break}continue}h===-1&&(b=!1,h=w+1),v===d?u===-1?u=w:L!==1&&(L=1):u!==-1&&(L=-1)}if(h!==-1){const v=m===0&&a?1:m;u===-1||L===0||L===1&&u===h-1&&u===m+1?s.base=s.name=i.slice(v,h):(s.name=i.slice(v,u),s.base=i.slice(v,h),s.ext=i.slice(u,h))}return m>0?s.dir=i.slice(0,m-1):a&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},n.posix.win32=n.win32.win32=n.win32,n.posix.posix=n.win32.posix=n.posix,n.normalize=y.platform==="win32"?n.win32.normalize:n.posix.normalize,n.isAbsolute=y.platform==="win32"?n.win32.isAbsolute:n.posix.isAbsolute,n.join=y.platform==="win32"?n.win32.join:n.posix.join,n.resolve=y.platform==="win32"?n.win32.resolve:n.posix.resolve,n.relative=y.platform==="win32"?n.win32.relative:n.posix.relative,n.dirname=y.platform==="win32"?n.win32.dirname:n.posix.dirname,n.basename=y.platform==="win32"?n.win32.basename:n.posix.basename,n.extname=y.platform==="win32"?n.win32.extname:n.posix.extname,n.format=y.platform==="win32"?n.win32.format:n.posix.format,n.parse=y.platform==="win32"?n.win32.parse:n.posix.parse,n.toNamespacedPath=y.platform==="win32"?n.win32.toNamespacedPath:n.posix.toNamespacedPath,n.sep=y.platform==="win32"?n.win32.sep:n.posix.sep,n.delimiter=y.platform==="win32"?n.win32.delimiter:n.posix.delimiter}),Y(Z[19],J([0,1,5]),function(O,n,y){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.StopWatch=void 0;const t=y.globals.performance&&typeof y.globals.performance.now=="function";class M{constructor(N){this._highResolution=t&&N,this._startTime=this._now(),this._stopTime=-1}static create(N=!0){return new M(N)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?y.globals.performance.now():Date.now()}}n.StopWatch=M}),Y(Z[7],J([0,1,8,12,6,14,19]),function(O,n,y,t,M,c,N){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Relay=n.EventBufferer=n.EventMultiplexer=n.MicrotaskEmitter=n.DebounceEmitter=n.PauseableEmitter=n.AsyncEmitter=n.EventDeliveryQueue=n.Emitter=n.setGlobalLeakWarningThreshold=n.Event=void 0;const d=!1,o=!1;var g;(function(w){w.None=()=>M.Disposable.None;function L(ee){if(o){const{onListenerDidAdd:G}=ee,K=e.create();let X=0;ee.onListenerDidAdd=()=>{++X==2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),K.print()),G?.()}}}function v(ee){return(G,K=null,X)=>{let te=!1,S;return S=ee(k=>{if(!te)return S?S.dispose():te=!0,G.call(K,k)},null,X),te&&S.dispose(),S}}w.once=v;function F(ee,G,K){return ne((X,te=null,S)=>ee(k=>X.call(te,G(k)),null,S),K)}w.map=F;function B(ee,G,K){return ne((X,te=null,S)=>ee(k=>{G(k),X.call(te,k)},null,S),K)}w.forEach=B;function U(ee,G,K){return ne((X,te=null,S)=>ee(k=>G(k)&&X.call(te,k),null,S),K)}w.filter=U;function V(ee){return ee}w.signal=V;function $(...ee){return(G,K=null,X)=>(0,M.combinedDisposable)(...ee.map(te=>te(S=>G.call(K,S),null,X)))}w.any=$;function j(ee,G,K,X){let te=K;return F(ee,S=>(te=G(te,S),te),X)}w.reduce=j;function ne(ee,G){let K;const X={onFirstListenerAdd(){K=ee(te.fire,te)},onLastListenerRemove(){K?.dispose()}};G||L(X);const te=new R(X);return G?.add(te),te.event}function oe(ee,G,K=100,X=!1,te,S){let k,I,q,H=0;const se={leakWarningThreshold:te,onFirstListenerAdd(){k=ee(ce=>{H++,I=G(I,ce),X&&!q&&(ie.fire(I),I=void 0),clearTimeout(q),q=setTimeout(()=>{const fe=I;I=void 0,q=void 0,(!X||H>1)&&ie.fire(fe),H=0},K)})},onLastListenerRemove(){k.dispose()}};S||L(se);const ie=new R(se);return S?.add(ie),ie.event}w.debounce=oe;function re(ee,G=(X,te)=>X===te,K){let X=!0,te;return U(ee,S=>{const k=X||!G(S,te);return X=!1,te=S,k},K)}w.latch=re;function x(ee,G,K){return[w.filter(ee,G,K),w.filter(ee,X=>!G(X),K)]}w.split=x;function r(ee,G=!1,K=[]){let X=K.slice(),te=ee(I=>{X?X.push(I):k.fire(I)});const S=()=>{X?.forEach(I=>k.fire(I)),X=null},k=new R({onFirstListenerAdd(){te||(te=ee(I=>k.fire(I)))},onFirstListenerDidAdd(){X&&(G?setTimeout(S):S())},onLastListenerRemove(){te&&te.dispose(),te=null}});return k.event}w.buffer=r;class de{constructor(G){this.event=G,this.disposables=new M.DisposableStore}map(G){return new de(F(this.event,G,this.disposables))}forEach(G){return new de(B(this.event,G,this.disposables))}filter(G){return new de(U(this.event,G,this.disposables))}reduce(G,K){return new de(j(this.event,G,K,this.disposables))}latch(){return new de(re(this.event,void 0,this.disposables))}debounce(G,K=100,X=!1,te){return new de(oe(this.event,G,K,X,te,this.disposables))}on(G,K,X){return this.event(G,K,X)}once(G,K,X){return v(this.event)(G,K,X)}dispose(){this.disposables.dispose()}}function Ee(ee){return new de(ee)}w.chain=Ee;function ye(ee,G,K=X=>X){const X=(...I)=>k.fire(K(...I)),te=()=>ee.on(G,X),S=()=>ee.removeListener(G,X),k=new R({onFirstListenerAdd:te,onLastListenerRemove:S});return k.event}w.fromNodeEventEmitter=ye;function Ce(ee,G,K=X=>X){const X=(...I)=>k.fire(K(...I)),te=()=>ee.addEventListener(G,X),S=()=>ee.removeEventListener(G,X),k=new R({onFirstListenerAdd:te,onLastListenerRemove:S});return k.event}w.fromDOMEventEmitter=Ce;function Ae(ee){return new Promise(G=>v(ee)(G))}w.toPromise=Ae;function pe(ee,G){return G(void 0),ee(K=>G(K))}w.runAndSubscribe=pe;function Me(ee,G){let K=null;function X(S){K?.dispose(),K=new M.DisposableStore,G(S,K)}X(void 0);const te=ee(S=>X(S));return(0,M.toDisposable)(()=>{te.dispose(),K?.dispose()})}w.runAndSubscribeWithStore=Me;class De{constructor(G,K){this.obs=G,this._counter=0,this._hasChanged=!1;const X={onFirstListenerAdd:()=>{G.addObserver(this)},onLastListenerRemove:()=>{G.removeObserver(this)}};K||L(X),this.emitter=new R(X),K&&K.add(this.emitter)}beginUpdate(G){this._counter++}handleChange(G,K){this._hasChanged=!0}endUpdate(G){--this._counter==0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function Fe(ee,G){return new De(ee,G).emitter.event}w.fromObservable=Fe})(g=n.Event||(n.Event={}));class E{constructor(L){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${L}_${E._idPool++}`}start(L){this._stopWatch=new N.StopWatch(!0),this._listenerCount=L}stop(){if(this._stopWatch){const L=this._stopWatch.elapsed();this._elapsedOverall+=L,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${L.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}E._idPool=0;let D=-1;function p(w){const L=D;return D=w,{dispose(){D=L}}}n.setGlobalLeakWarningThreshold=p;class f{constructor(L,v=Math.random().toString(18).slice(2,5)){this.customThreshold=L,this.name=v,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(L,v){let F=D;if(typeof this.customThreshold=="number"&&(F=this.customThreshold),F<=0||v<F)return;this._stacks||(this._stacks=new Map);const B=this._stacks.get(L.value)||0;if(this._stacks.set(L.value,B+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=F*.5;let U,V=0;for(const[$,j]of this._stacks)(!U||V<j)&&(U=$,V=j);console.warn(`[${this.name}] potential listener LEAK detected, having ${v} listeners already. MOST frequent listener (${V}):`),console.warn(U)}return()=>{const U=this._stacks.get(L.value)||0;this._stacks.set(L.value,U-1)}}}class e{constructor(L){this.value=L}static create(){return new e(new Error().stack??"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class C{constructor(L,v,F){this.callback=L,this.callbackThis=v,this.stack=F,this.subscription=new M.SafeDisposable}invoke(L){this.callback.call(this.callbackThis,L)}}class R{constructor(L){this._disposed=!1,this._options=L,this._leakageMon=D>0?new f(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new E(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(d){const L=Array.from(this._listeners);queueMicrotask(()=>{for(const v of L)v.subscription.isset()&&(v.subscription.unset(),v.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(L,v,F)=>{this._listeners||(this._listeners=new c.LinkedList);const B=this._listeners.isEmpty();B&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let U,V;this._leakageMon&&this._listeners.size>=30&&(V=e.create(),U=this._leakageMon.check(V,this._listeners.size+1)),d&&(V=V??e.create());const $=new C(L,v,V),j=this._listeners.push($);B&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,L,v);const ne=$.subscription.set(()=>{U?.(),this._disposed||(j(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return F instanceof M.DisposableStore?F.add(ne):Array.isArray(F)&&F.push(ne),ne}),this._event}fire(L){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new _);for(const v of this._listeners)this._deliveryQueue.push(this,v,L);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}n.Emitter=R;class A{constructor(){this._queue=new c.LinkedList}get size(){return this._queue.size}push(L,v,F){this._queue.push(new i(L,v,F))}clear(L){const v=new c.LinkedList;for(const F of this._queue)F.emitter!==L&&v.push(F);this._queue=v}deliver(){for(;this._queue.size>0;){const L=this._queue.shift();try{L.listener.invoke(L.event)}catch(v){(0,y.onUnexpectedError)(v)}}}}n.EventDeliveryQueue=A;class _ extends A{clear(L){this._queue.clear()}}class i{constructor(L,v,F){this.emitter=L,this.listener=v,this.event=F}}class s extends R{async fireAsync(L,v,F){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new c.LinkedList);for(const B of this._listeners)this._asyncDeliveryQueue.push([B,L]);for(;this._asyncDeliveryQueue.size>0&&!v.isCancellationRequested;){const[B,U]=this._asyncDeliveryQueue.shift(),V=[],$={...U,token:v,waitUntil:j=>{if(Object.isFrozen(V))throw new Error("waitUntil can NOT be called asynchronous");F&&(j=F(j,B.callback)),V.push(j)}};try{B.invoke($)}catch(j){(0,y.onUnexpectedError)(j);continue}Object.freeze(V),await Promise.allSettled(V).then(j=>{for(const ne of j)ne.status==="rejected"&&(0,y.onUnexpectedError)(ne.reason)})}}}}n.AsyncEmitter=s;class a extends R{constructor(L){super(L);this._isPaused=0,this._eventQueue=new c.LinkedList,this._mergeFn=L?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const L=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(L))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(L){this._listeners&&(this._isPaused!==0?this._eventQueue.push(L):super.fire(L))}}n.PauseableEmitter=a;class l extends a{constructor(L){super(L);this._delay=L.delay??100}fire(L){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(L)}}n.DebounceEmitter=l;class u extends R{constructor(L){super(L);this._queuedEvents=[],this._mergeFn=L?.merge}fire(L){this._queuedEvents.push(L),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(v=>super.fire(v)),this._queuedEvents=[]})}}n.MicrotaskEmitter=u;class m{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new R({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(L){const v={event:L,listener:null};this.events.push(v),this.hasListeners&&this.hook(v);const F=()=>{this.hasListeners&&this.unhook(v);const B=this.events.indexOf(v);this.events.splice(B,1)};return(0,M.toDisposable)((0,t.once)(F))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(L=>this.hook(L))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(L=>this.unhook(L))}hook(L){L.listener=L.event(v=>this.emitter.fire(v))}unhook(L){L.listener&&L.listener.dispose(),L.listener=null}dispose(){this.emitter.dispose()}}n.EventMultiplexer=m;class h{constructor(){this.buffers=[]}wrapEvent(L){return(v,F,B)=>L(U=>{const V=this.buffers[this.buffers.length-1];V?V.push(()=>v.call(F,U)):v.call(F,U)},void 0,B)}bufferEvents(L){const v=[];this.buffers.push(v);const F=L();return this.buffers.pop(),v.forEach(B=>B()),F}}n.EventBufferer=h;class b{constructor(){this.listening=!1,this.inputEvent=g.None,this.inputEventListener=M.Disposable.None,this.emitter=new R({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(L){this.inputEvent=L,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=L(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}n.Relay=b}),Y(Z[20],J([0,1,7]),function(O,n,y){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CancellationTokenSource=n.CancellationToken=void 0;const t=Object.freeze(function(d,o){const g=setTimeout(d.bind(o),0);return{dispose(){clearTimeout(g)}}});var M;(function(d){function o(g){return g===d.None||g===d.Cancelled||g instanceof c?!0:!g||typeof g!="object"?!1:typeof g.isCancellationRequested=="boolean"&&typeof g.onCancellationRequested=="function"}d.isCancellationToken=o,d.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:y.Event.None}),d.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(M=n.CancellationToken||(n.CancellationToken={}));class c{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new y.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class N{constructor(o){this._token=void 0,this._parentListener=void 0,this._parentListener=o&&o.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new c),this._token}cancel(){this._token?this._token instanceof c&&this._token.cancel():this._token=M.Cancelled}dispose(o=!1){o&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof c&&this._token.dispose():this._token=M.None}}n.CancellationTokenSource=N}),Y(Z[45],J([0,1,20]),function(O,n,y){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CachedFunction=n.LRUCachedFunction=n.Cache=void 0;class t{constructor(d){this.task=d,this.result=null}get(){if(this.result)return this.result;const d=new y.CancellationTokenSource,o=this.task(d.token);return this.result={promise:o,dispose:()=>{this.result=null,d.cancel(),d.dispose()}},this.result}}n.Cache=t;class M{constructor(d){this.fn=d,this.lastCache=void 0,this.lastArgKey=void 0}get(d){const o=JSON.stringify(d);return this.lastArgKey!==o&&(this.lastArgKey=o,this.lastCache=this.fn(d)),this.lastCache}}n.LRUCachedFunction=M;class c{constructor(d){this.fn=d,this._map=new Map}get cachedValues(){return this._map}get(d){if(this._map.has(d))return this._map.get(d);const o=this.fn(d);return this._map.set(d,o),o}}n.CachedFunction=c}),Y(Z[4],J([0,1,45,29]),function(O,n,y,t){"use strict";var M;Object.defineProperty(n,"__esModule",{value:!0}),n.InvisibleCharacters=n.AmbiguousCharacters=n.noBreakWhitespace=n.getLeftDeleteOffset=n.GraphemeBreakType=n.getGraphemeBreakType=n.singleLetterHash=n.getNLines=n.uppercaseFirstLetter=n.containsUppercaseCharacter=n.fuzzyContains=n.stripUTF8BOM=n.startsWithUTF8BOM=n.UTF8_BOM_CHARACTER=n.removeAnsiEscapeCodes=n.lcut=n.isEmojiImprecise=n.isFullWidthCharacter=n.containsUnusualLineTerminators=n.UNUSUAL_LINE_TERMINATORS=n.isBasicASCII=n.containsRTL=n.getCharContainingOffset=n.prevCharLength=n.nextCharLength=n.GraphemeIterator=n.CodePointIterator=n.getNextCodePoint=n.computeCodePoint=n.isLowSurrogate=n.isHighSurrogate=n.commonSuffixLength=n.commonPrefixLength=n.startsWithIgnoreCase=n.equalsIgnoreCase=n.isUpperAsciiLetter=n.isLowerAsciiLetter=n.isAsciiDigit=n.compareSubstringIgnoreCase=n.compareIgnoreCase=n.compareSubstring=n.compare=n.replaceAsync=n.lastNonWhitespaceIndex=n.getLeadingWhitespace=n.firstNonWhitespaceIndex=n.splitLines=n.regExpFlags=n.regExpContainsBackreference=n.regExpLeadsToEndlessLoop=n.createRegExp=n.stripWildcards=n.convertSimple2RegExpPattern=n.rtrim=n.ltrim=n.trim=n.truncate=n.count=n.escapeRegExpCharacters=n.escape=n.format2=n.format=n.isFalsyOrWhitespace=void 0;function c(P){return!P||typeof P!="string"?!0:P.trim().length===0}n.isFalsyOrWhitespace=c;const N=/{(\d+)}/g;function d(P,...T){return T.length===0?P:P.replace(N,function(W,z){const Q=parseInt(z,10);return isNaN(Q)||Q<0||Q>=T.length?W:T[Q]})}n.format=d;const o=/{([^}]+)}/g;function g(P,T){return P.replace(o,(W,z)=>T[z]??W)}n.format2=g;function E(P){return P.replace(/[<>&]/g,function(T){switch(T){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return T}})}n.escape=E;function D(P){return P.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}n.escapeRegExpCharacters=D;function p(P,T){let W=0;const z=T.charCodeAt(0);for(let Q=P.length-1;Q>=0;Q--)P.charCodeAt(Q)===z&&W++;return W}n.count=p;function f(P,T,W="\u2026"){return P.length<=T?P:`${P.substr(0,T)}${W}`}n.truncate=f;function e(P,T=" "){const W=C(P,T);return R(W,T)}n.trim=e;function C(P,T){if(!P||!T)return P;const W=T.length;if(W===0||P.length===0)return P;let z=0;for(;P.indexOf(T,z)===z;)z=z+W;return P.substring(z)}n.ltrim=C;function R(P,T){if(!P||!T)return P;const W=T.length,z=P.length;if(W===0||z===0)return P;let Q=z,ae=-1;for(;ae=P.lastIndexOf(T,Q-1),!(ae===-1||ae+W!==Q);){if(ae===0)return"";Q=ae}return P.substring(0,Q)}n.rtrim=R;function A(P){return P.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}n.convertSimple2RegExpPattern=A;function _(P){return P.replace(/\*/g,"")}n.stripWildcards=_;function i(P,T,W={}){if(!P)throw new Error("Cannot create regex from empty string");T||(P=D(P)),W.wholeWord&&(/\B/.test(P.charAt(0))||(P="\\b"+P),/\B/.test(P.charAt(P.length-1))||(P=P+"\\b"));let z="";return W.global&&(z+="g"),W.matchCase||(z+="i"),W.multiline&&(z+="m"),W.unicode&&(z+="u"),new RegExp(P,z)}n.createRegExp=i;function s(P){return P.source==="^"||P.source==="^$"||P.source==="$"||P.source==="^\\s*$"?!1:!!(P.exec("")&&P.lastIndex===0)}n.regExpLeadsToEndlessLoop=s;function a(P){return!!P.match(/([^\\]|^)(\\\\)*\\\d+/)}n.regExpContainsBackreference=a;function l(P){return(P.global?"g":"")+(P.ignoreCase?"i":"")+(P.multiline?"m":"")+(P.unicode?"u":"")}n.regExpFlags=l;function u(P){return P.split(/\r\n|\r|\n/)}n.splitLines=u;function m(P){for(let T=0,W=P.length;T<W;T++){const z=P.charCodeAt(T);if(z!==32&&z!==9)return T}return-1}n.firstNonWhitespaceIndex=m;function h(P,T=0,W=P.length){for(let z=T;z<W;z++){const Q=P.charCodeAt(z);if(Q!==32&&Q!==9)return P.substring(T,z)}return P.substring(T,W)}n.getLeadingWhitespace=h;function b(P,T=P.length-1){for(let W=T;W>=0;W--){const z=P.charCodeAt(W);if(z!==32&&z!==9)return W}return-1}n.lastNonWhitespaceIndex=b;function w(P,T,W){const z=[];let Q=0;for(const ae of P.matchAll(T)){if(z.push(P.slice(Q,ae.index)),ae.index===void 0)throw new Error("match.index should be defined");Q=ae.index+ae[0].length,z.push(W(ae[0],...ae.slice(1),ae.index,P,ae.groups))}return z.push(P.slice(Q)),Promise.all(z).then(ae=>ae.join(""))}n.replaceAsync=w;function L(P,T){return P<T?-1:P>T?1:0}n.compare=L;function v(P,T,W=0,z=P.length,Q=0,ae=T.length){for(;W<z&&Q<ae;W++,Q++){const we=P.charCodeAt(W),le=T.charCodeAt(Q);if(we<le)return-1;if(we>le)return 1}const he=z-W,Ne=ae-Q;return he<Ne?-1:he>Ne?1:0}n.compareSubstring=v;function F(P,T){return B(P,T,0,P.length,0,T.length)}n.compareIgnoreCase=F;function B(P,T,W=0,z=P.length,Q=0,ae=T.length){for(;W<z&&Q<ae;W++,Q++){let we=P.charCodeAt(W),le=T.charCodeAt(Q);if(we===le)continue;if(we>=128||le>=128)return v(P.toLowerCase(),T.toLowerCase(),W,z,Q,ae);V(we)&&(we-=32),V(le)&&(le-=32);const be=we-le;if(be!==0)return be}const he=z-W,Ne=ae-Q;return he<Ne?-1:he>Ne?1:0}n.compareSubstringIgnoreCase=B;function U(P){return P>=48&&P<=57}n.isAsciiDigit=U;function V(P){return P>=97&&P<=122}n.isLowerAsciiLetter=V;function $(P){return P>=65&&P<=90}n.isUpperAsciiLetter=$;function j(P,T){return P.length===T.length&&B(P,T)===0}n.equalsIgnoreCase=j;function ne(P,T){const W=T.length;return T.length>P.length?!1:B(P,T,0,W)===0}n.startsWithIgnoreCase=ne;function oe(P,T){const W=Math.min(P.length,T.length);let z;for(z=0;z<W;z++)if(P.charCodeAt(z)!==T.charCodeAt(z))return z;return W}n.commonPrefixLength=oe;function re(P,T){const W=Math.min(P.length,T.length);let z;const Q=P.length-1,ae=T.length-1;for(z=0;z<W;z++)if(P.charCodeAt(Q-z)!==T.charCodeAt(ae-z))return z;return W}n.commonSuffixLength=re;function x(P){return 55296<=P&&P<=56319}n.isHighSurrogate=x;function r(P){return 56320<=P&&P<=57343}n.isLowSurrogate=r;function de(P,T){return(P-55296<<10)+(T-56320)+65536}n.computeCodePoint=de;function Ee(P,T,W){const z=P.charCodeAt(W);if(x(z)&&W+1<T){const Q=P.charCodeAt(W+1);if(r(Q))return de(z,Q)}return z}n.getNextCodePoint=Ee;function ye(P,T){const W=P.charCodeAt(T-1);if(r(W)&&T>1){const z=P.charCodeAt(T-2);if(x(z))return de(z,W)}return W}class Ce{constructor(T,W=0){this._str=T,this._len=T.length,this._offset=W}get offset(){return this._offset}setOffset(T){this._offset=T}prevCodePoint(){const T=ye(this._str,this._offset);return this._offset-=T>=65536?2:1,T}nextCodePoint(){const T=Ee(this._str,this._len,this._offset);return this._offset+=T>=65536?2:1,T}eol(){return this._offset>=this._len}}n.CodePointIterator=Ce;class Ae{constructor(T,W=0){this._iterator=new Ce(T,W)}get offset(){return this._iterator.offset}nextGraphemeLength(){const T=Le.getInstance(),W=this._iterator,z=W.offset;let Q=T.getGraphemeBreakType(W.nextCodePoint());for(;!W.eol();){const ae=W.offset,he=T.getGraphemeBreakType(W.nextCodePoint());if(Ie(Q,he)){W.setOffset(ae);break}Q=he}return W.offset-z}prevGraphemeLength(){const T=Le.getInstance(),W=this._iterator,z=W.offset;let Q=T.getGraphemeBreakType(W.prevCodePoint());for(;W.offset>0;){const ae=W.offset,he=T.getGraphemeBreakType(W.prevCodePoint());if(Ie(he,Q)){W.setOffset(ae);break}Q=he}return z-W.offset}eol(){return this._iterator.eol()}}n.GraphemeIterator=Ae;function pe(P,T){return new Ae(P,T).nextGraphemeLength()}n.nextCharLength=pe;function Me(P,T){return new Ae(P,T).prevGraphemeLength()}n.prevCharLength=Me;function De(P,T){T>0&&r(P.charCodeAt(T))&&T--;const W=T+pe(P,T);return[W-Me(P,W),W]}n.getCharContainingOffset=De;const Fe=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function ee(P){return Fe.test(P)}n.containsRTL=ee;const G=/^[\t\n\r\x20-\x7E]*$/;function K(P){return G.test(P)}n.isBasicASCII=K,n.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function X(P){return n.UNUSUAL_LINE_TERMINATORS.test(P)}n.containsUnusualLineTerminators=X;function te(P){return P>=11904&&P<=55215||P>=63744&&P<=64255||P>=65281&&P<=65374}n.isFullWidthCharacter=te;function S(P){return P>=127462&&P<=127487||P===8986||P===8987||P===9200||P===9203||P>=9728&&P<=10175||P===11088||P===11093||P>=127744&&P<=128591||P>=128640&&P<=128764||P>=128992&&P<=129008||P>=129280&&P<=129535||P>=129648&&P<=129782}n.isEmojiImprecise=S;function k(P,T){if(P.length<T)return P;const W=/\b/g;let z=0;for(;W.test(P)&&!(P.length-W.lastIndex<T);)z=W.lastIndex,W.lastIndex+=1;return P.substring(z).replace(/^\s/,"")}n.lcut=k;const I=/\x1B\x5B[12]?K/g,q=/\x1b\[\d+m/g,H=/\x1b\[0?m/g;function se(P){return P&&(P=P.replace(I,""),P=P.replace(q,""),P=P.replace(H,"")),P}n.removeAnsiEscapeCodes=se,n.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ie(P){return!!(P&&P.length>0&&P.charCodeAt(0)===65279)}n.startsWithUTF8BOM=ie;function ce(P){return ie(P)?P.substr(1):P}n.stripUTF8BOM=ce;function fe(P,T){if(!P||!T||P.length<T.length)return!1;const W=T.length,z=P.toLowerCase();let Q=0,ae=-1;for(;Q<W;){const he=z.indexOf(T[Q],ae+1);if(he<0)return!1;ae=he,Q++}return!0}n.fuzzyContains=fe;function ge(P,T=!1){return P?(T&&(P=P.replace(/\\./g,"")),P.toLowerCase()!==P):!1}n.containsUppercaseCharacter=ge;function me(P){return P.charAt(0).toUpperCase()+P.slice(1)}n.uppercaseFirstLetter=me;function Se(P,T=1){if(T===0)return"";let W=-1;do W=P.indexOf(`
`,W+1),T--;while(T>0&&W>=0);return W===-1?P:(P[W-1]==="\r"&&W--,P.substr(0,W))}n.getNLines=Se;function Be(P){const T=90-65+1;return P=P%(2*T),P<T?String.fromCharCode(97+P):String.fromCharCode(65+P-T)}n.singleLetterHash=Be;function Ve(P){return Le.getInstance().getGraphemeBreakType(P)}n.getGraphemeBreakType=Ve;function Ie(P,T){return P===0?T!==5&&T!==7:P===2&&T===3?!1:P===4||P===2||P===3||T===4||T===2||T===3?!0:!(P===8&&(T===8||T===9||T===11||T===12)||(P===11||P===9)&&(T===9||T===10)||(P===12||P===10)&&T===10||T===5||T===13||T===7||P===1||P===13&&T===14||P===6&&T===6)}var qe;(function(P){P[P.Other=0]="Other",P[P.Prepend=1]="Prepend",P[P.CR=2]="CR",P[P.LF=3]="LF",P[P.Control=4]="Control",P[P.Extend=5]="Extend",P[P.Regional_Indicator=6]="Regional_Indicator",P[P.SpacingMark=7]="SpacingMark",P[P.L=8]="L",P[P.V=9]="V",P[P.T=10]="T",P[P.LV=11]="LV",P[P.LVT=12]="LVT",P[P.ZWJ=13]="ZWJ",P[P.Extended_Pictographic=14]="Extended_Pictographic"})(qe=n.GraphemeBreakType||(n.GraphemeBreakType={}));class Le{constructor(){this._data=We()}static getInstance(){return Le._INSTANCE||(Le._INSTANCE=new Le),Le._INSTANCE}getGraphemeBreakType(T){if(T<32)return T===10?3:T===13?2:4;if(T<127)return 0;const W=this._data,z=W.length/3;let Q=1;for(;Q<=z;)if(T<W[3*Q])Q=2*Q;else if(T>W[3*Q+1])Q=2*Q+1;else return W[3*Q+2];return 0}}Le._INSTANCE=null;function We(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function He(P,T){if(P===0)return 0;const W=ze(P,T);if(W!==void 0)return W;const z=new Ce(T,P);return z.prevCodePoint(),z.offset}n.getLeftDeleteOffset=He;function ze(P,T){const W=new Ce(T,P);let z=W.prevCodePoint();for(;je(z)||z===65039||z===8419;){if(W.offset===0)return;z=W.prevCodePoint()}if(!S(z))return;let Q=W.offset;return Q>0&&W.prevCodePoint()===8205&&(Q=W.offset),Q}function je(P){return 127995<=P&&P<=127999}var Te;(function(P){P[P.zwj=8205]="zwj",P[P.emojiVariantSelector=65039]="emojiVariantSelector",P[P.enclosingKeyCap=8419]="enclosingKeyCap"})(Te||(Te={})),n.noBreakWhitespace="\xA0";class _e{constructor(T){this.confusableDictionary=T}static getInstance(T){return _e.cache.get(Array.from(T))}static getLocales(){return _e._locales.getValue()}isAmbiguous(T){return this.confusableDictionary.has(T)}getPrimaryConfusable(T){return this.confusableDictionary.get(T)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}n.AmbiguousCharacters=_e,M=_e,_e.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),_e.cache=new y.LRUCachedFunction(P=>{function T(le){const be=new Map;for(let ve=0;ve<le.length;ve+=2)be.set(le[ve],le[ve+1]);return be}function W(le,be){const ve=new Map(le);for(const[Pe,ke]of be)ve.set(Pe,ke);return ve}function z(le,be){if(!le)return be;const ve=new Map;for(const[Pe,ke]of le)be.has(Pe)&&ve.set(Pe,ke);return ve}const Q=M.ambiguousCharacterData.getValue();let ae=P.filter(le=>!le.startsWith("_")&&le in Q);ae.length===0&&(ae=["_default"]);let he;for(const le of ae){const be=T(Q[le]);he=z(he,be)}const Ne=T(Q._common),we=W(Ne,he);return new _e(we)}),_e._locales=new t.Lazy(()=>Object.keys(_e.ambiguousCharacterData.getValue()).filter(P=>!P.startsWith("_")));class Re{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Re.getRawData())),this._data}static isInvisibleCharacter(T){return Re.getData().has(T)}static get codePoints(){return Re.getData()}}n.InvisibleCharacters=Re,Re._data=void 0}),Y(Z[46],J([0,1,4]),function(O,n,y){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.StringSHA1=n.toHexString=n.Hasher=n.stringHash=n.numberHash=n.doHash=n.hash=void 0;function t(A){return M(A,0)}n.hash=t;function M(A,_){switch(typeof A){case"object":return A===null?c(349,_):Array.isArray(A)?o(A,_):g(A,_);case"string":return d(A,_);case"boolean":return N(A,_);case"number":return c(A,_);case"undefined":return c(937,_);default:return c(617,_)}}n.doHash=M;function c(A,_){return(_<<5)-_+A|0}n.numberHash=c;function N(A,_){return c(A?433:863,_)}function d(A,_){_=c(149417,_);for(let i=0,s=A.length;i<s;i++)_=c(A.charCodeAt(i),_);return _}n.stringHash=d;function o(A,_){return _=c(104579,_),A.reduce((i,s)=>M(s,i),_)}function g(A,_){return _=c(181387,_),Object.keys(A).sort().reduce((i,s)=>(i=d(s,i),M(A[s],i)),_)}class E{constructor(){this._value=0}get value(){return this._value}hash(_){return this._value=M(_,this._value),this._value}}n.Hasher=E;var D;(function(A){A[A.BLOCK_SIZE=64]="BLOCK_SIZE",A[A.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(D||(D={}));function p(A,_,i=32){const s=i-_,a=~((1<<s)-1);return(A<<_|(a&A)>>>s)>>>0}function f(A,_=0,i=A.byteLength,s=0){for(let a=0;a<i;a++)A[_+a]=s}function e(A,_,i="0"){for(;A.length<_;)A=i+A;return A}function C(A,_=32){return A instanceof ArrayBuffer?Array.from(new Uint8Array(A)).map(i=>i.toString(16).padStart(2,"0")).join(""):e((A>>>0).toString(16),_/4)}n.toHexString=C;class R{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(_){const i=_.length;if(i===0)return;const s=this._buff;let a=this._buffLen,l=this._leftoverHighSurrogate,u,m;for(l!==0?(u=l,m=-1,l=0):(u=_.charCodeAt(0),m=0);;){let h=u;if(y.isHighSurrogate(u))if(m+1<i){const b=_.charCodeAt(m+1);y.isLowSurrogate(b)?(m++,h=y.computeCodePoint(u,b)):h=65533}else{l=u;break}else y.isLowSurrogate(u)&&(h=65533);if(a=this._push(s,a,h),m++,m<i)u=_.charCodeAt(m);else break}this._buffLen=a,this._leftoverHighSurrogate=l}_push(_,i,s){return s<128?_[i++]=s:s<2048?(_[i++]=192|(s&1984)>>>6,_[i++]=128|(s&63)>>>0):s<65536?(_[i++]=224|(s&61440)>>>12,_[i++]=128|(s&4032)>>>6,_[i++]=128|(s&63)>>>0):(_[i++]=240|(s&1835008)>>>18,_[i++]=128|(s&258048)>>>12,_[i++]=128|(s&4032)>>>6,_[i++]=128|(s&63)>>>0),i>=64&&(this._step(),i-=64,this._totalLen+=64,_[0]=_[64+0],_[1]=_[64+1],_[2]=_[64+2]),i}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),C(this._h0)+C(this._h1)+C(this._h2)+C(this._h3)+C(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,f(this._buff,this._buffLen),this._buffLen>56&&(this._step(),f(this._buff));const _=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(_/4294967296),!1),this._buffDV.setUint32(60,_%4294967296,!1),this._step()}_step(){const _=R._bigBlock32,i=this._buffDV;for(let L=0;L<64;L+=4)_.setUint32(L,i.getUint32(L,!1),!1);for(let L=64;L<320;L+=4)_.setUint32(L,p(_.getUint32(L-12,!1)^_.getUint32(L-32,!1)^_.getUint32(L-56,!1)^_.getUint32(L-64,!1),1),!1);let s=this._h0,a=this._h1,l=this._h2,u=this._h3,m=this._h4,h,b,w;for(let L=0;L<80;L++)L<20?(h=a&l|~a&u,b=1518500249):L<40?(h=a^l^u,b=1859775393):L<60?(h=a&l|a&u|l&u,b=2400959708):(h=a^l^u,b=3395469782),w=p(s,5)+h+m+b+_.getUint32(L*4,!1)&4294967295,m=u,u=l,l=p(a,30),a=s,s=w;this._h0=this._h0+s&4294967295,this._h1=this._h1+a&4294967295,this._h2=this._h2+l&4294967295,this._h3=this._h3+u&4294967295,this._h4=this._h4+m&4294967295}}n.StringSHA1=R,R._bigBlock32=new DataView(new ArrayBuffer(320))}),Y(Z[21],J([0,1,26,46]),function(O,n,y,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LcsDiff=n.MyArray=n.Debug=n.stringDiff=n.StringDiffSequence=void 0;class M{constructor(p){this.source=p}getElements(){const p=this.source,f=new Int32Array(p.length);for(let e=0,C=p.length;e<C;e++)f[e]=p.charCodeAt(e);return f}}n.StringDiffSequence=M;function c(D,p,f){return new E(new M(D),new M(p)).ComputeDiff(f).changes}n.stringDiff=c;class N{static Assert(p,f){if(!p)throw new Error(f)}}n.Debug=N;class d{static Copy(p,f,e,C,R){for(let A=0;A<R;A++)e[C+A]=p[f+A]}static Copy2(p,f,e,C,R){for(let A=0;A<R;A++)e[C+A]=p[f+A]}}n.MyArray=d;var o;(function(D){D[D.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(o||(o={}));class g{constructor(){this.m_changes=[],this.m_originalStart=1073741824,this.m_modifiedStart=1073741824,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new y.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=1073741824,this.m_modifiedStart=1073741824}AddOriginalElement(p,f){this.m_originalStart=Math.min(this.m_originalStart,p),this.m_modifiedStart=Math.min(this.m_modifiedStart,f),this.m_originalCount++}AddModifiedElement(p,f){this.m_originalStart=Math.min(this.m_originalStart,p),this.m_modifiedStart=Math.min(this.m_modifiedStart,f),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class E{constructor(p,f,e=null){this.ContinueProcessingPredicate=e,this._originalSequence=p,this._modifiedSequence=f;const[C,R,A]=E._getElements(p),[_,i,s]=E._getElements(f);this._hasStrings=A&&s,this._originalStringElements=C,this._originalElementsOrHash=R,this._modifiedStringElements=_,this._modifiedElementsOrHash=i,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(p){return p.length>0&&typeof p[0]=="string"}static _getElements(p){const f=p.getElements();if(E._isStringArray(f)){const e=new Int32Array(f.length);for(let C=0,R=f.length;C<R;C++)e[C]=(0,t.stringHash)(f[C],0);return[f,e,!0]}return f instanceof Int32Array?[[],f,!1]:[[],new Int32Array(f),!1]}ElementsAreEqual(p,f){return this._originalElementsOrHash[p]!==this._modifiedElementsOrHash[f]?!1:this._hasStrings?this._originalStringElements[p]===this._modifiedStringElements[f]:!0}ElementsAreStrictEqual(p,f){if(!this.ElementsAreEqual(p,f))return!1;const e=E._getStrictElement(this._originalSequence,p),C=E._getStrictElement(this._modifiedSequence,f);return e===C}static _getStrictElement(p,f){return typeof p.getStrictElement=="function"?p.getStrictElement(f):null}OriginalElementsAreEqual(p,f){return this._originalElementsOrHash[p]!==this._originalElementsOrHash[f]?!1:this._hasStrings?this._originalStringElements[p]===this._originalStringElements[f]:!0}ModifiedElementsAreEqual(p,f){return this._modifiedElementsOrHash[p]!==this._modifiedElementsOrHash[f]?!1:this._hasStrings?this._modifiedStringElements[p]===this._modifiedStringElements[f]:!0}ComputeDiff(p){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,p)}_ComputeDiff(p,f,e,C,R){const A=[!1];let _=this.ComputeDiffRecursive(p,f,e,C,A);return R&&(_=this.PrettifyChanges(_)),{quitEarly:A[0],changes:_}}ComputeDiffRecursive(p,f,e,C,R){for(R[0]=!1;p<=f&&e<=C&&this.ElementsAreEqual(p,e);)p++,e++;for(;f>=p&&C>=e&&this.ElementsAreEqual(f,C);)f--,C--;if(p>f||e>C){let l;return e<=C?(N.Assert(p===f+1,"originalStart should only be one more than originalEnd"),l=[new y.DiffChange(p,0,e,C-e+1)]):p<=f?(N.Assert(e===C+1,"modifiedStart should only be one more than modifiedEnd"),l=[new y.DiffChange(p,f-p+1,e,0)]):(N.Assert(p===f+1,"originalStart should only be one more than originalEnd"),N.Assert(e===C+1,"modifiedStart should only be one more than modifiedEnd"),l=[]),l}const A=[0],_=[0],i=this.ComputeRecursionPoint(p,f,e,C,A,_,R),s=A[0],a=_[0];if(i!==null)return i;if(!R[0]){const l=this.ComputeDiffRecursive(p,s,e,a,R);let u=[];return R[0]?u=[new y.DiffChange(s+1,f-(s+1)+1,a+1,C-(a+1)+1)]:u=this.ComputeDiffRecursive(s+1,f,a+1,C,R),this.ConcatenateChanges(l,u)}return[new y.DiffChange(p,f-p+1,e,C-e+1)]}WALKTRACE(p,f,e,C,R,A,_,i,s,a,l,u,m,h,b,w,L,v){let F=null,B=null,U=new g,V=f,$=e,j=m[0]-w[0]-C,ne=-1073741824,oe=this.m_forwardHistory.length-1;do{const re=j+p;re===V||re<$&&s[re-1]<s[re+1]?(l=s[re+1],h=l-j-C,l<ne&&U.MarkNextChange(),ne=l,U.AddModifiedElement(l+1,h),j=re+1-p):(l=s[re-1]+1,h=l-j-C,l<ne&&U.MarkNextChange(),ne=l-1,U.AddOriginalElement(l,h+1),j=re-1-p),oe>=0&&(s=this.m_forwardHistory[oe],p=s[0],V=1,$=s.length-1)}while(--oe>=-1);if(F=U.getReverseChanges(),v[0]){let re=m[0]+1,x=w[0]+1;if(F!==null&&F.length>0){const r=F[F.length-1];re=Math.max(re,r.getOriginalEnd()),x=Math.max(x,r.getModifiedEnd())}B=[new y.DiffChange(re,u-re+1,x,b-x+1)]}else{U=new g,V=A,$=_,j=m[0]-w[0]-i,ne=1073741824,oe=L?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const re=j+R;re===V||re<$&&a[re-1]>=a[re+1]?(l=a[re+1]-1,h=l-j-i,l>ne&&U.MarkNextChange(),ne=l+1,U.AddOriginalElement(l+1,h+1),j=re+1-R):(l=a[re-1],h=l-j-i,l>ne&&U.MarkNextChange(),ne=l,U.AddModifiedElement(l+1,h+1),j=re-1-R),oe>=0&&(a=this.m_reverseHistory[oe],R=a[0],V=1,$=a.length-1)}while(--oe>=-1);B=U.getChanges()}return this.ConcatenateChanges(F,B)}ComputeRecursionPoint(p,f,e,C,R,A,_){let i=0,s=0,a=0,l=0,u=0,m=0;p--,e--,R[0]=0,A[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const h=f-p+(C-e),b=h+1,w=new Int32Array(b),L=new Int32Array(b),v=C-e,F=f-p,B=p-e,U=f-C,$=(F-v)%2==0;w[v]=p,L[F]=f,_[0]=!1;for(let j=1;j<=h/2+1;j++){let ne=0,oe=0;a=this.ClipDiagonalBound(v-j,j,v,b),l=this.ClipDiagonalBound(v+j,j,v,b);for(let x=a;x<=l;x+=2){x===a||x<l&&w[x-1]<w[x+1]?i=w[x+1]:i=w[x-1]+1,s=i-(x-v)-B;const r=i;for(;i<f&&s<C&&this.ElementsAreEqual(i+1,s+1);)i++,s++;if(w[x]=i,i+s>ne+oe&&(ne=i,oe=s),!$&&Math.abs(x-F)<=j-1&&i>=L[x])return R[0]=i,A[0]=s,r<=L[x]&&1447>0&&j<=1447+1?this.WALKTRACE(v,a,l,B,F,u,m,U,w,L,i,f,R,s,C,A,$,_):null}const re=(ne-p+(oe-e)-j)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(ne,re))return _[0]=!0,R[0]=ne,A[0]=oe,re>0&&1447>0&&j<=1447+1?this.WALKTRACE(v,a,l,B,F,u,m,U,w,L,i,f,R,s,C,A,$,_):(p++,e++,[new y.DiffChange(p,f-p+1,e,C-e+1)]);u=this.ClipDiagonalBound(F-j,j,F,b),m=this.ClipDiagonalBound(F+j,j,F,b);for(let x=u;x<=m;x+=2){x===u||x<m&&L[x-1]>=L[x+1]?i=L[x+1]-1:i=L[x-1],s=i-(x-F)-U;const r=i;for(;i>p&&s>e&&this.ElementsAreEqual(i,s);)i--,s--;if(L[x]=i,$&&Math.abs(x-v)<=j&&i<=w[x])return R[0]=i,A[0]=s,r>=w[x]&&1447>0&&j<=1447+1?this.WALKTRACE(v,a,l,B,F,u,m,U,w,L,i,f,R,s,C,A,$,_):null}if(j<=1447){let x=new Int32Array(l-a+2);x[0]=v-a+1,d.Copy2(w,a,x,1,l-a+1),this.m_forwardHistory.push(x),x=new Int32Array(m-u+2),x[0]=F-u+1,d.Copy2(L,u,x,1,m-u+1),this.m_reverseHistory.push(x)}}return this.WALKTRACE(v,a,l,B,F,u,m,U,w,L,i,f,R,s,C,A,$,_)}PrettifyChanges(p){for(let f=0;f<p.length;f++){const e=p[f],C=f<p.length-1?p[f+1].originalStart:this._originalElementsOrHash.length,R=f<p.length-1?p[f+1].modifiedStart:this._modifiedElementsOrHash.length,A=e.originalLength>0,_=e.modifiedLength>0;for(;e.originalStart+e.originalLength<C&&e.modifiedStart+e.modifiedLength<R&&(!A||this.OriginalElementsAreEqual(e.originalStart,e.originalStart+e.originalLength))&&(!_||this.ModifiedElementsAreEqual(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const s=this.ElementsAreStrictEqual(e.originalStart,e.modifiedStart);if(this.ElementsAreStrictEqual(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!s)break;e.originalStart++,e.modifiedStart++}const i=[null];if(f<p.length-1&&this.ChangesOverlap(p[f],p[f+1],i)){p[f]=i[0],p.splice(f+1,1),f--;continue}}for(let f=p.length-1;f>=0;f--){const e=p[f];let C=0,R=0;if(f>0){const l=p[f-1];C=l.originalStart+l.originalLength,R=l.modifiedStart+l.modifiedLength}const A=e.originalLength>0,_=e.modifiedLength>0;let i=0,s=this._boundaryScore(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let l=1;;l++){const u=e.originalStart-l,m=e.modifiedStart-l;if(u<C||m<R||A&&!this.OriginalElementsAreEqual(u,u+e.originalLength)||_&&!this.ModifiedElementsAreEqual(m,m+e.modifiedLength))break;const b=(u===C&&m===R?5:0)+this._boundaryScore(u,e.originalLength,m,e.modifiedLength);b>s&&(s=b,i=l)}e.originalStart-=i,e.modifiedStart-=i;const a=[null];if(f>0&&this.ChangesOverlap(p[f-1],p[f],a)){p[f-1]=a[0],p.splice(f,1),f++;continue}}if(this._hasStrings)for(let f=1,e=p.length;f<e;f++){const C=p[f-1],R=p[f],A=R.originalStart-C.originalStart-C.originalLength,_=C.originalStart,i=R.originalStart+R.originalLength,s=i-_,a=C.modifiedStart,l=R.modifiedStart+R.modifiedLength,u=l-a;if(A<5&&s<20&&u<20){const m=this._findBetterContiguousSequence(_,s,a,u,A);if(m){const[h,b]=m;(h!==C.originalStart+C.originalLength||b!==C.modifiedStart+C.modifiedLength)&&(C.originalLength=h-C.originalStart,C.modifiedLength=b-C.modifiedStart,R.originalStart=h+A,R.modifiedStart=b+A,R.originalLength=i-R.originalStart,R.modifiedLength=l-R.modifiedStart)}}}return p}_findBetterContiguousSequence(p,f,e,C,R){if(f<R||C<R)return null;const A=p+f-R+1,_=e+C-R+1;let i=0,s=0,a=0;for(let l=p;l<A;l++)for(let u=e;u<_;u++){const m=this._contiguousSequenceScore(l,u,R);m>0&&m>i&&(i=m,s=l,a=u)}return i>0?[s,a]:null}_contiguousSequenceScore(p,f,e){let C=0;for(let R=0;R<e;R++){if(!this.ElementsAreEqual(p+R,f+R))return 0;C+=this._originalStringElements[p+R].length}return C}_OriginalIsBoundary(p){return p<=0||p>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[p])}_OriginalRegionIsBoundary(p,f){if(this._OriginalIsBoundary(p)||this._OriginalIsBoundary(p-1))return!0;if(f>0){const e=p+f;if(this._OriginalIsBoundary(e-1)||this._OriginalIsBoundary(e))return!0}return!1}_ModifiedIsBoundary(p){return p<=0||p>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[p])}_ModifiedRegionIsBoundary(p,f){if(this._ModifiedIsBoundary(p)||this._ModifiedIsBoundary(p-1))return!0;if(f>0){const e=p+f;if(this._ModifiedIsBoundary(e-1)||this._ModifiedIsBoundary(e))return!0}return!1}_boundaryScore(p,f,e,C){const R=this._OriginalRegionIsBoundary(p,f)?1:0,A=this._ModifiedRegionIsBoundary(e,C)?1:0;return R+A}ConcatenateChanges(p,f){const e=[];if(p.length===0||f.length===0)return f.length>0?f:p;if(this.ChangesOverlap(p[p.length-1],f[0],e)){const C=new Array(p.length+f.length-1);return d.Copy(p,0,C,0,p.length-1),C[p.length-1]=e[0],d.Copy(f,1,C,p.length,f.length-1),C}else{const C=new Array(p.length+f.length);return d.Copy(p,0,C,0,p.length),d.Copy(f,0,C,p.length,f.length),C}}ChangesOverlap(p,f,e){if(N.Assert(p.originalStart<=f.originalStart,"Left change is not less than or equal to right change"),N.Assert(p.modifiedStart<=f.modifiedStart,"Left change is not less than or equal to right change"),p.originalStart+p.originalLength>=f.originalStart||p.modifiedStart+p.modifiedLength>=f.modifiedStart){const C=p.originalStart;let R=p.originalLength;const A=p.modifiedStart;let _=p.modifiedLength;return p.originalStart+p.originalLength>=f.originalStart&&(R=f.originalStart+f.originalLength-p.originalStart),p.modifiedStart+p.modifiedLength>=f.modifiedStart&&(_=f.modifiedStart+f.modifiedLength-p.modifiedStart),e[0]=new y.DiffChange(C,R,A,_),!0}else return e[0]=null,!1}ClipDiagonalBound(p,f,e,C){if(p>=0&&p<C)return p;const R=e,A=C-e-1,_=f%2==0;if(p<0){const i=R%2==0;return _===i?0:1}else{const i=A%2==0;return _===i?C-1:C-2}}}n.LcsDiff=E}),Y(Z[11],J([0,1,44,5]),function(O,n,y,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.uriToFsPath=n.URI=void 0;const M=/^\w[\w\d+.-]*$/,c=/^\//,N=/^\/\//;function d(m,h){if(!m.scheme&&h)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${m.authority}", path: "${m.path}", query: "${m.query}", fragment: "${m.fragment}"}`);if(m.scheme&&!M.test(m.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(m.path){if(m.authority){if(!c.test(m.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(N.test(m.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function o(m,h){return!m&&!h?"file":m}function g(m,h){switch(m){case"https":case"http":case"file":h?h[0]!==D&&(h=D+h):h=D;break}return h}const E="",D="/",p=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{constructor(h,b,w,L,v,F=!1){typeof h=="object"?(this.scheme=h.scheme||E,this.authority=h.authority||E,this.path=h.path||E,this.query=h.query||E,this.fragment=h.fragment||E):(this.scheme=o(h,F),this.authority=b||E,this.path=g(this.scheme,w||E),this.query=L||E,this.fragment=v||E,d(this,F))}static isUri(h){return h instanceof f?!0:h?typeof h.authority=="string"&&typeof h.fragment=="string"&&typeof h.path=="string"&&typeof h.query=="string"&&typeof h.scheme=="string"&&typeof h.fsPath=="string"&&typeof h.with=="function"&&typeof h.toString=="function":!1}get fsPath(){return i(this,!1)}with(h){if(!h)return this;let{scheme:b,authority:w,path:L,query:v,fragment:F}=h;return b===void 0?b=this.scheme:b===null&&(b=E),w===void 0?w=this.authority:w===null&&(w=E),L===void 0?L=this.path:L===null&&(L=E),v===void 0?v=this.query:v===null&&(v=E),F===void 0?F=this.fragment:F===null&&(F=E),b===this.scheme&&w===this.authority&&L===this.path&&v===this.query&&F===this.fragment?this:new C(b,w,L,v,F)}static parse(h,b=!1){const w=p.exec(h);return w?new C(w[2]||E,u(w[4]||E),u(w[5]||E),u(w[7]||E),u(w[9]||E),b):new C(E,E,E,E,E)}static file(h){let b=E;if(t.isWindows&&(h=h.replace(/\\/g,D)),h[0]===D&&h[1]===D){const w=h.indexOf(D,2);w===-1?(b=h.substring(2),h=D):(b=h.substring(2,w),h=h.substring(w)||D)}return new C("file",b,h,E,E)}static from(h){const b=new C(h.scheme,h.authority,h.path,h.query,h.fragment);return d(b,!0),b}static joinPath(h,...b){if(!h.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let w;return t.isWindows&&h.scheme==="file"?w=f.file(y.win32.join(i(h,!0),...b)).path:w=y.posix.join(h.path,...b),h.with({path:w})}toString(h=!1){return s(this,h)}toJSON(){return this}static revive(h){if(h){if(h instanceof f)return h;{const b=new C(h);return b._formatted=h.external,b._fsPath=h._sep===e?h.fsPath:null,b}}else return h}}n.URI=f;const e=t.isWindows?1:void 0;class C extends f{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=i(this,!1)),this._fsPath}toString(h=!1){return h?s(this,!0):(this._formatted||(this._formatted=s(this,!1)),this._formatted)}toJSON(){const h={$mid:1};return this._fsPath&&(h.fsPath=this._fsPath,h._sep=e),this._formatted&&(h.external=this._formatted),this.path&&(h.path=this.path),this.scheme&&(h.scheme=this.scheme),this.authority&&(h.authority=this.authority),this.query&&(h.query=this.query),this.fragment&&(h.fragment=this.fragment),h}}const R={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function A(m,h){let b,w=-1;for(let L=0;L<m.length;L++){const v=m.charCodeAt(L);if(v>=97&&v<=122||v>=65&&v<=90||v>=48&&v<=57||v===45||v===46||v===95||v===126||h&&v===47)w!==-1&&(b+=encodeURIComponent(m.substring(w,L)),w=-1),b!==void 0&&(b+=m.charAt(L));else{b===void 0&&(b=m.substr(0,L));const F=R[v];F!==void 0?(w!==-1&&(b+=encodeURIComponent(m.substring(w,L)),w=-1),b+=F):w===-1&&(w=L)}}return w!==-1&&(b+=encodeURIComponent(m.substring(w))),b!==void 0?b:m}function _(m){let h;for(let b=0;b<m.length;b++){const w=m.charCodeAt(b);w===35||w===63?(h===void 0&&(h=m.substr(0,b)),h+=R[w]):h!==void 0&&(h+=m[b])}return h!==void 0?h:m}function i(m,h){let b;return m.authority&&m.path.length>1&&m.scheme==="file"?b=`//${m.authority}${m.path}`:m.path.charCodeAt(0)===47&&(m.path.charCodeAt(1)>=65&&m.path.charCodeAt(1)<=90||m.path.charCodeAt(1)>=97&&m.path.charCodeAt(1)<=122)&&m.path.charCodeAt(2)===58?h?b=m.path.substr(1):b=m.path[1].toLowerCase()+m.path.substr(2):b=m.path,t.isWindows&&(b=b.replace(/\//g,"\\")),b}n.uriToFsPath=i;function s(m,h){const b=h?_:A;let w="",{scheme:L,authority:v,path:F,query:B,fragment:U}=m;if(L&&(w+=L,w+=":"),(v||L==="file")&&(w+=D,w+=D),v){let V=v.indexOf("@");if(V!==-1){const $=v.substr(0,V);v=v.substr(V+1),V=$.indexOf(":"),V===-1?w+=b($,!1):(w+=b($.substr(0,V),!1),w+=":",w+=b($.substr(V+1),!1)),w+="@"}v=v.toLowerCase(),V=v.indexOf(":"),V===-1?w+=b(v,!1):(w+=b(v.substr(0,V),!1),w+=v.substr(V))}if(F){if(F.length>=3&&F.charCodeAt(0)===47&&F.charCodeAt(2)===58){const V=F.charCodeAt(1);V>=65&&V<=90&&(F=`/${String.fromCharCode(V+32)}:${F.substr(3)}`)}else if(F.length>=2&&F.charCodeAt(1)===58){const V=F.charCodeAt(0);V>=65&&V<=90&&(F=`${String.fromCharCode(V+32)}:${F.substr(2)}`)}w+=b(F,!0)}return B&&(w+="?",w+=b(B,!1)),U&&(w+="#",w+=h?U:A(U,!1)),w}function a(m){try{return decodeURIComponent(m)}catch{return m.length>3?m.substr(0,3)+a(m.substr(3)):m}}const l=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function u(m){return m.match(l)?m.replace(l,h=>a(h)):m}}),Y(Z[55],J([0,1,8,7,6,9,5,4]),function(O,n,y,t,M,c,N,d){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.create=n.SimpleWorkerServer=n.SimpleWorkerClient=n.logOnceWebWorkerWarning=void 0;const o="$initialize";let g=!1;function E(m){!N.isWeb||(g||(g=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(m.message))}n.logOnceWebWorkerWarning=E;var D;(function(m){m[m.Request=0]="Request",m[m.Reply=1]="Reply",m[m.SubscribeEvent=2]="SubscribeEvent",m[m.Event=3]="Event",m[m.UnsubscribeEvent=4]="UnsubscribeEvent"})(D||(D={}));class p{constructor(h,b,w,L){this.vsWorker=h,this.req=b,this.method=w,this.args=L,this.type=0}}class f{constructor(h,b,w,L){this.vsWorker=h,this.seq=b,this.res=w,this.err=L,this.type=1}}class e{constructor(h,b,w,L){this.vsWorker=h,this.req=b,this.eventName=w,this.arg=L,this.type=2}}class C{constructor(h,b,w){this.vsWorker=h,this.req=b,this.event=w,this.type=3}}class R{constructor(h,b){this.vsWorker=h,this.req=b,this.type=4}}class A{constructor(h){this._workerId=-1,this._handler=h,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(h){this._workerId=h}sendMessage(h,b){const w=String(++this._lastSentReq);return new Promise((L,v)=>{this._pendingReplies[w]={resolve:L,reject:v},this._send(new p(this._workerId,w,h,b))})}listen(h,b){let w=null;const L=new t.Emitter({onFirstListenerAdd:()=>{w=String(++this._lastSentReq),this._pendingEmitters.set(w,L),this._send(new e(this._workerId,w,h,b))},onLastListenerRemove:()=>{this._pendingEmitters.delete(w),this._send(new R(this._workerId,w)),w=null}});return L.event}handleMessage(h){!h||!h.vsWorker||this._workerId!==-1&&h.vsWorker!==this._workerId||this._handleMessage(h)}_handleMessage(h){switch(h.type){case 1:return this._handleReplyMessage(h);case 0:return this._handleRequestMessage(h);case 2:return this._handleSubscribeEventMessage(h);case 3:return this._handleEventMessage(h);case 4:return this._handleUnsubscribeEventMessage(h)}}_handleReplyMessage(h){if(!this._pendingReplies[h.seq]){console.warn("Got reply to unknown seq");return}const b=this._pendingReplies[h.seq];if(delete this._pendingReplies[h.seq],h.err){let w=h.err;h.err.$isError&&(w=new Error,w.name=h.err.name,w.message=h.err.message,w.stack=h.err.stack),b.reject(w);return}b.resolve(h.res)}_handleRequestMessage(h){const b=h.req;this._handler.handleMessage(h.method,h.args).then(L=>{this._send(new f(this._workerId,b,L,void 0))},L=>{L.detail instanceof Error&&(L.detail=(0,y.transformErrorForSerialization)(L.detail)),this._send(new f(this._workerId,b,void 0,(0,y.transformErrorForSerialization)(L)))})}_handleSubscribeEventMessage(h){const b=h.req,w=this._handler.handleEvent(h.eventName,h.arg)(L=>{this._send(new C(this._workerId,b,L))});this._pendingEvents.set(b,w)}_handleEventMessage(h){if(!this._pendingEmitters.has(h.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(h.req).fire(h.event)}_handleUnsubscribeEventMessage(h){if(!this._pendingEvents.has(h.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(h.req).dispose(),this._pendingEvents.delete(h.req)}_send(h){const b=[];if(h.type===0)for(let w=0;w<h.args.length;w++)h.args[w]instanceof ArrayBuffer&&b.push(h.args[w]);else h.type===1&&h.res instanceof ArrayBuffer&&b.push(h.res);this._handler.sendMessage(h,b)}}class _ extends M.Disposable{constructor(h,b,w){super();let L=null;this._worker=this._register(h.create("vs/base/common/worker/simpleWorker",V=>{this._protocol.handleMessage(V)},V=>{L?.(V)})),this._protocol=new A({sendMessage:(V,$)=>{this._worker.postMessage(V,$)},handleMessage:(V,$)=>{if(typeof w[V]!="function")return Promise.reject(new Error("Missing method "+V+" on main thread host."));try{return Promise.resolve(w[V].apply(w,$))}catch(j){return Promise.reject(j)}},handleEvent:(V,$)=>{if(s(V)){const j=w[V].call(w,$);if(typeof j!="function")throw new Error(`Missing dynamic event ${V} on main thread host.`);return j}if(i(V)){const j=w[V];if(typeof j!="function")throw new Error(`Missing event ${V} on main thread host.`);return j}throw new Error(`Malformed event name ${V}`)}}),this._protocol.setWorkerId(this._worker.getId());let v=null;typeof N.globals.require!="undefined"&&typeof N.globals.require.getConfig=="function"?v=N.globals.require.getConfig():typeof N.globals.requirejs!="undefined"&&(v=N.globals.requirejs.s.contexts._.config);const F=(0,c.getAllMethodNames)(w);this._onModuleLoaded=this._protocol.sendMessage(o,[this._worker.getId(),JSON.parse(JSON.stringify(v)),b,F]);const B=(V,$)=>this._request(V,$),U=(V,$)=>this._protocol.listen(V,$);this._lazyProxy=new Promise((V,$)=>{L=$,this._onModuleLoaded.then(j=>{V(a(j,B,U))},j=>{$(j),this._onError("Worker failed to load "+b,j)})})}getProxyObject(){return this._lazyProxy}_request(h,b){return new Promise((w,L)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(h,b).then(w,L)},L)})}_onError(h,b){console.error(h),console.info(b)}}n.SimpleWorkerClient=_;function i(m){return m[0]==="o"&&m[1]==="n"&&d.isUpperAsciiLetter(m.charCodeAt(2))}function s(m){return/^onDynamic/.test(m)&&d.isUpperAsciiLetter(m.charCodeAt(9))}function a(m,h,b){const w=F=>function(){const B=Array.prototype.slice.call(arguments,0);return h(F,B)},L=F=>function(B){return b(F,B)},v={};for(const F of m){if(s(F)){v[F]=L(F);continue}if(i(F)){v[F]=b(F,void 0);continue}v[F]=w(F)}return v}class l{constructor(h,b){this._requestHandlerFactory=b,this._requestHandler=null,this._protocol=new A({sendMessage:(w,L)=>{h(w,L)},handleMessage:(w,L)=>this._handleMessage(w,L),handleEvent:(w,L)=>this._handleEvent(w,L)})}onmessage(h){this._protocol.handleMessage(h)}_handleMessage(h,b){if(h===o)return this.initialize(b[0],b[1],b[2],b[3]);if(!this._requestHandler||typeof this._requestHandler[h]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+h));try{return Promise.resolve(this._requestHandler[h].apply(this._requestHandler,b))}catch(w){return Promise.reject(w)}}_handleEvent(h,b){if(!this._requestHandler)throw new Error("Missing requestHandler");if(s(h)){const w=this._requestHandler[h].call(this._requestHandler,b);if(typeof w!="function")throw new Error(`Missing dynamic event ${h} on request handler.`);return w}if(i(h)){const w=this._requestHandler[h];if(typeof w!="function")throw new Error(`Missing event ${h} on request handler.`);return w}throw new Error(`Malformed event name ${h}`)}initialize(h,b,w,L){this._protocol.setWorkerId(h);const B=a(L,(U,V)=>this._protocol.sendMessage(U,V),(U,V)=>this._protocol.listen(U,V));return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(B),Promise.resolve((0,c.getAllMethodNames)(this._requestHandler))):(b&&(typeof b.baseUrl!="undefined"&&delete b.baseUrl,typeof b.paths!="undefined"&&typeof b.paths.vs!="undefined"&&delete b.paths.vs,typeof b.trustedTypesPolicy!==void 0&&delete b.trustedTypesPolicy,b.catchError=!0,N.globals.require.config(b)),new Promise((U,V)=>{(N.globals.require||O)([w],j=>{if(this._requestHandler=j.create(B),!this._requestHandler){V(new Error("No RequestHandler!"));return}U((0,c.getAllMethodNames)(this._requestHandler))},V)}))}}n.SimpleWorkerServer=l;function u(m){return new l(m,null)}n.create=u}),Y(Z[22],J([0,1,21,18,4,2]),function(O,n,y,t,M,c){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DiffComputer=n.SmartLinesDiffComputer=void 0;const N=3;class d{computeDiff(i,s,a){const u=new e(i,s,{maxComputationTime:a.maxComputationTime,shouldIgnoreTrimWhitespace:a.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff();return{quitEarly:u.quitEarly,changes:u.changes.map(m=>{let h;m.originalEndLineNumber===0?h=new t.LineRange(m.originalStartLineNumber+1,m.originalStartLineNumber+1):h=new t.LineRange(m.originalStartLineNumber,m.originalEndLineNumber+1);let b;return m.modifiedEndLineNumber===0?b=new t.LineRange(m.modifiedStartLineNumber+1,m.modifiedStartLineNumber+1):b=new t.LineRange(m.modifiedStartLineNumber,m.modifiedEndLineNumber+1),{originalRange:h,modifiedRange:b,innerChanges:m.charChanges?.map(w=>new t.RangeMapping(new c.Range(w.originalStartLineNumber,w.originalStartColumn,w.originalEndLineNumber,w.originalEndColumn),new c.Range(w.modifiedStartLineNumber,w.modifiedStartColumn,w.modifiedEndLineNumber,w.modifiedEndColumn)))}})}}}n.SmartLinesDiffComputer=d;function o(_,i,s,a){return new y.LcsDiff(_,i,s).ComputeDiff(a)}class g{constructor(i){const s=[],a=[];for(let l=0,u=i.length;l<u;l++)s[l]=C(i[l],1),a[l]=R(i[l],1);this.lines=i,this._startColumns=s,this._endColumns=a}getElements(){const i=[];for(let s=0,a=this.lines.length;s<a;s++)i[s]=this.lines[s].substring(this._startColumns[s]-1,this._endColumns[s]-1);return i}getStrictElement(i){return this.lines[i]}getStartLineNumber(i){return i+1}getEndLineNumber(i){return i+1}createCharSequence(i,s,a){const l=[],u=[],m=[];let h=0;for(let b=s;b<=a;b++){const w=this.lines[b],L=i?this._startColumns[b]:1,v=i?this._endColumns[b]:w.length+1;for(let F=L;F<v;F++)l[h]=w.charCodeAt(F-1),u[h]=b+1,m[h]=F,h++;!i&&b<a&&(l[h]=10,u[h]=b+1,m[h]=w.length+1,h++)}return new E(l,u,m)}}class E{constructor(i,s,a){this._charCodes=i,this._lineNumbers=s,this._columns=a}toString(){return"["+this._charCodes.map((i,s)=>(i===10?"\\n":String.fromCharCode(i))+`-(${this._lineNumbers[s]},${this._columns[s]})`).join(", ")+"]"}_assertIndex(i,s){if(i<0||i>=s.length)throw new Error("Illegal index")}getElements(){return this._charCodes}getStartLineNumber(i){return i>0&&i===this._lineNumbers.length?this.getEndLineNumber(i-1):(this._assertIndex(i,this._lineNumbers),this._lineNumbers[i])}getEndLineNumber(i){return i===-1?this.getStartLineNumber(i+1):(this._assertIndex(i,this._lineNumbers),this._charCodes[i]===10?this._lineNumbers[i]+1:this._lineNumbers[i])}getStartColumn(i){return i>0&&i===this._columns.length?this.getEndColumn(i-1):(this._assertIndex(i,this._columns),this._columns[i])}getEndColumn(i){return i===-1?this.getStartColumn(i+1):(this._assertIndex(i,this._columns),this._charCodes[i]===10?1:this._columns[i]+1)}}class D{constructor(i,s,a,l,u,m,h,b){this.originalStartLineNumber=i,this.originalStartColumn=s,this.originalEndLineNumber=a,this.originalEndColumn=l,this.modifiedStartLineNumber=u,this.modifiedStartColumn=m,this.modifiedEndLineNumber=h,this.modifiedEndColumn=b}static createFromDiffChange(i,s,a){const l=s.getStartLineNumber(i.originalStart),u=s.getStartColumn(i.originalStart),m=s.getEndLineNumber(i.originalStart+i.originalLength-1),h=s.getEndColumn(i.originalStart+i.originalLength-1),b=a.getStartLineNumber(i.modifiedStart),w=a.getStartColumn(i.modifiedStart),L=a.getEndLineNumber(i.modifiedStart+i.modifiedLength-1),v=a.getEndColumn(i.modifiedStart+i.modifiedLength-1);return new D(l,u,m,h,b,w,L,v)}}function p(_){if(_.length<=1)return _;const i=[_[0]];let s=i[0];for(let a=1,l=_.length;a<l;a++){const u=_[a],m=u.originalStart-(s.originalStart+s.originalLength),h=u.modifiedStart-(s.modifiedStart+s.modifiedLength);Math.min(m,h)<N?(s.originalLength=u.originalStart+u.originalLength-s.originalStart,s.modifiedLength=u.modifiedStart+u.modifiedLength-s.modifiedStart):(i.push(u),s=u)}return i}class f{constructor(i,s,a,l,u){this.originalStartLineNumber=i,this.originalEndLineNumber=s,this.modifiedStartLineNumber=a,this.modifiedEndLineNumber=l,this.charChanges=u}static createFromDiffResult(i,s,a,l,u,m,h){let b,w,L,v,F;if(s.originalLength===0?(b=a.getStartLineNumber(s.originalStart)-1,w=0):(b=a.getStartLineNumber(s.originalStart),w=a.getEndLineNumber(s.originalStart+s.originalLength-1)),s.modifiedLength===0?(L=l.getStartLineNumber(s.modifiedStart)-1,v=0):(L=l.getStartLineNumber(s.modifiedStart),v=l.getEndLineNumber(s.modifiedStart+s.modifiedLength-1)),m&&s.originalLength>0&&s.originalLength<20&&s.modifiedLength>0&&s.modifiedLength<20&&u()){const B=a.createCharSequence(i,s.originalStart,s.originalStart+s.originalLength-1),U=l.createCharSequence(i,s.modifiedStart,s.modifiedStart+s.modifiedLength-1);if(B.getElements().length>0&&U.getElements().length>0){let V=o(B,U,u,!0).changes;h&&(V=p(V)),F=[];for(let $=0,j=V.length;$<j;$++)F.push(D.createFromDiffChange(V[$],B,U))}}return new f(b,w,L,v,F)}}class e{constructor(i,s,a){this.shouldComputeCharChanges=a.shouldComputeCharChanges,this.shouldPostProcessCharChanges=a.shouldPostProcessCharChanges,this.shouldIgnoreTrimWhitespace=a.shouldIgnoreTrimWhitespace,this.shouldMakePrettyDiff=a.shouldMakePrettyDiff,this.originalLines=i,this.modifiedLines=s,this.original=new g(i),this.modified=new g(s),this.continueLineDiff=A(a.maxComputationTime),this.continueCharDiff=A(a.maxComputationTime===0?0:Math.min(a.maxComputationTime,5e3))}computeDiff(){if(this.original.lines.length===1&&this.original.lines[0].length===0)return this.modified.lines.length===1&&this.modified.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.modified.lines.length,charChanges:void 0}]};if(this.modified.lines.length===1&&this.modified.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.original.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const i=o(this.original,this.modified,this.continueLineDiff,this.shouldMakePrettyDiff),s=i.changes,a=i.quitEarly;if(this.shouldIgnoreTrimWhitespace){const h=[];for(let b=0,w=s.length;b<w;b++)h.push(f.createFromDiffResult(this.shouldIgnoreTrimWhitespace,s[b],this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges));return{quitEarly:a,changes:h}}const l=[];let u=0,m=0;for(let h=-1,b=s.length;h<b;h++){const w=h+1<b?s[h+1]:null,L=w?w.originalStart:this.originalLines.length,v=w?w.modifiedStart:this.modifiedLines.length;for(;u<L&&m<v;){const F=this.originalLines[u],B=this.modifiedLines[m];if(F!==B){{let U=C(F,1),V=C(B,1);for(;U>1&&V>1;){const $=F.charCodeAt(U-2),j=B.charCodeAt(V-2);if($!==j)break;U--,V--}(U>1||V>1)&&this._pushTrimWhitespaceCharChange(l,u+1,1,U,m+1,1,V)}{let U=R(F,1),V=R(B,1);const $=F.length+1,j=B.length+1;for(;U<$&&V<j;){const ne=F.charCodeAt(U-1),oe=F.charCodeAt(V-1);if(ne!==oe)break;U++,V++}(U<$||V<j)&&this._pushTrimWhitespaceCharChange(l,u+1,U,$,m+1,V,j)}}u++,m++}w&&(l.push(f.createFromDiffResult(this.shouldIgnoreTrimWhitespace,w,this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges)),u+=w.originalLength,m+=w.modifiedLength)}return{quitEarly:a,changes:l}}_pushTrimWhitespaceCharChange(i,s,a,l,u,m,h){if(this._mergeTrimWhitespaceCharChange(i,s,a,l,u,m,h))return;let b;this.shouldComputeCharChanges&&(b=[new D(s,a,s,l,u,m,u,h)]),i.push(new f(s,s,u,u,b))}_mergeTrimWhitespaceCharChange(i,s,a,l,u,m,h){const b=i.length;if(b===0)return!1;const w=i[b-1];return w.originalEndLineNumber===0||w.modifiedEndLineNumber===0?!1:w.originalEndLineNumber+1===s&&w.modifiedEndLineNumber+1===u?(w.originalEndLineNumber=s,w.modifiedEndLineNumber=u,this.shouldComputeCharChanges&&w.charChanges&&w.charChanges.push(new D(s,a,s,l,u,m,u,h)),!0):!1}}n.DiffComputer=e;function C(_,i){const s=M.firstNonWhitespaceIndex(_);return s===-1?i:s+1}function R(_,i){const s=M.lastNonWhitespaceIndex(_);return s===-1?i:s+2}function A(_){if(_===0)return()=>!0;const i=Date.now();return()=>Date.now()-i<_}}),Y(Z[47],J([0,1,33,22,36]),function(O,n,y,t,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.linesDiffComputers=void 0,n.linesDiffComputers={smart:new t.SmartLinesDiffComputer,experimental:new M.StandardLinesDiffComputer(new y.MyersDiffAlgorithm)}}),Y(Z[48],J([0,1,4,3,40]),function(O,n,y,t,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MirrorTextModel=void 0;class c{constructor(d,o,g,E){this._uri=d,this._lines=o,this._eol=g,this._versionId=E,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(d){d.eol&&d.eol!==this._eol&&(this._eol=d.eol,this._lineStarts=null);const o=d.changes;for(const g of o)this._acceptDeleteRange(g.range),this._acceptInsertText(new t.Position(g.range.startLineNumber,g.range.startColumn),g.text);this._versionId=d.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const d=this._eol.length,o=this._lines.length,g=new Uint32Array(o);for(let E=0;E<o;E++)g[E]=this._lines[E].length+d;this._lineStarts=new M.PrefixSumComputer(g)}}_setLineText(d,o){this._lines[d]=o,this._lineStarts&&this._lineStarts.setValue(d,this._lines[d].length+this._eol.length)}_acceptDeleteRange(d){if(d.startLineNumber===d.endLineNumber){if(d.startColumn===d.endColumn)return;this._setLineText(d.startLineNumber-1,this._lines[d.startLineNumber-1].substring(0,d.startColumn-1)+this._lines[d.startLineNumber-1].substring(d.endColumn-1));return}this._setLineText(d.startLineNumber-1,this._lines[d.startLineNumber-1].substring(0,d.startColumn-1)+this._lines[d.endLineNumber-1].substring(d.endColumn-1)),this._lines.splice(d.startLineNumber,d.endLineNumber-d.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(d.startLineNumber,d.endLineNumber-d.startLineNumber)}_acceptInsertText(d,o){if(o.length===0)return;const g=(0,y.splitLines)(o);if(g.length===1){this._setLineText(d.lineNumber-1,this._lines[d.lineNumber-1].substring(0,d.column-1)+g[0]+this._lines[d.lineNumber-1].substring(d.column-1));return}g[g.length-1]+=this._lines[d.lineNumber-1].substring(d.column-1),this._setLineText(d.lineNumber-1,this._lines[d.lineNumber-1].substring(0,d.column-1)+g[0]);const E=new Uint32Array(g.length-1);for(let D=1;D<g.length;D++)this._lines.splice(d.lineNumber+D-1,0,g[D]),E[D-1]=g[D].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(d.lineNumber,E)}}n.MirrorTextModel=c}),Y(Z[49],J([0,1,4,32,3,2,39]),function(O,n,y,t,M,c,N){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Searcher=n.isValidMatch=n.TextModelSearch=n.createFindMatch=n.isMultilineRegexSource=n.SearchParams=void 0;const d=999;class o{constructor(_,i,s,a){this.searchString=_,this.isRegex=i,this.matchCase=s,this.wordSeparators=a}parseSearchRequest(){if(this.searchString==="")return null;let _;this.isRegex?_=g(this.searchString):_=this.searchString.indexOf(`
`)>=0;let i=null;try{i=y.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:_,global:!0,unicode:!0})}catch{return null}if(!i)return null;let s=!this.isRegex&&!_;return s&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(s=this.matchCase),new N.SearchData(i,this.wordSeparators?(0,t.getMapForWordSeparators)(this.wordSeparators):null,s?this.searchString:null)}}n.SearchParams=o;function g(A){if(!A||A.length===0)return!1;for(let _=0,i=A.length;_<i;_++){const s=A.charCodeAt(_);if(s===10)return!0;if(s===92){if(_++,_>=i)break;const a=A.charCodeAt(_);if(a===110||a===114||a===87)return!0}}return!1}n.isMultilineRegexSource=g;function E(A,_,i){if(!i)return new N.FindMatch(A,null);const s=[];for(let a=0,l=_.length;a<l;a++)s[a]=_[a];return new N.FindMatch(A,s)}n.createFindMatch=E;class D{constructor(_){const i=[];let s=0;for(let a=0,l=_.length;a<l;a++)_.charCodeAt(a)===10&&(i[s++]=a);this._lineFeedsOffsets=i}findLineFeedCountBeforeOffset(_){const i=this._lineFeedsOffsets;let s=0,a=i.length-1;if(a===-1||_<=i[0])return 0;for(;s<a;){const l=s+((a-s)/2>>0);i[l]>=_?a=l-1:i[l+1]>=_?(s=l,a=l):s=l+1}return s+1}}class p{static findMatches(_,i,s,a,l){const u=i.parseSearchRequest();return u?u.regex.multiline?this._doFindMatchesMultiline(_,s,new R(u.wordSeparators,u.regex),a,l):this._doFindMatchesLineByLine(_,s,u,a,l):[]}static _getMultilineMatchRange(_,i,s,a,l,u){let m,h=0;a?(h=a.findLineFeedCountBeforeOffset(l),m=i+l+h):m=i+l;let b;if(a){const F=a.findLineFeedCountBeforeOffset(l+u.length)-h;b=m+u.length+F}else b=m+u.length;const w=_.getPositionAt(m),L=_.getPositionAt(b);return new c.Range(w.lineNumber,w.column,L.lineNumber,L.column)}static _doFindMatchesMultiline(_,i,s,a,l){const u=_.getOffsetAt(i.getStartPosition()),m=_.getValueInRange(i,1),h=_.getEOL()===`\r
`?new D(m):null,b=[];let w=0,L;for(s.reset(0);L=s.next(m);)if(b[w++]=E(this._getMultilineMatchRange(_,u,m,h,L.index,L[0]),L,a),w>=l)return b;return b}static _doFindMatchesLineByLine(_,i,s,a,l){const u=[];let m=0;if(i.startLineNumber===i.endLineNumber){const b=_.getLineContent(i.startLineNumber).substring(i.startColumn-1,i.endColumn-1);return m=this._findMatchesInLine(s,b,i.startLineNumber,i.startColumn-1,m,u,a,l),u}const h=_.getLineContent(i.startLineNumber).substring(i.startColumn-1);m=this._findMatchesInLine(s,h,i.startLineNumber,i.startColumn-1,m,u,a,l);for(let b=i.startLineNumber+1;b<i.endLineNumber&&m<l;b++)m=this._findMatchesInLine(s,_.getLineContent(b),b,0,m,u,a,l);if(m<l){const b=_.getLineContent(i.endLineNumber).substring(0,i.endColumn-1);m=this._findMatchesInLine(s,b,i.endLineNumber,0,m,u,a,l)}return u}static _findMatchesInLine(_,i,s,a,l,u,m,h){const b=_.wordSeparators;if(!m&&_.simpleSearch){const v=_.simpleSearch,F=v.length,B=i.length;let U=-F;for(;(U=i.indexOf(v,U+F))!==-1;)if((!b||C(b,i,B,U,F))&&(u[l++]=new N.FindMatch(new c.Range(s,U+1+a,s,U+1+F+a),null),l>=h))return l;return l}const w=new R(_.wordSeparators,_.regex);let L;w.reset(0);do if(L=w.next(i),L&&(u[l++]=E(new c.Range(s,L.index+1+a,s,L.index+1+L[0].length+a),L,m),l>=h))return l;while(L);return l}static findNextMatch(_,i,s,a){const l=i.parseSearchRequest();if(!l)return null;const u=new R(l.wordSeparators,l.regex);return l.regex.multiline?this._doFindNextMatchMultiline(_,s,u,a):this._doFindNextMatchLineByLine(_,s,u,a)}static _doFindNextMatchMultiline(_,i,s,a){const l=new M.Position(i.lineNumber,1),u=_.getOffsetAt(l),m=_.getLineCount(),h=_.getValueInRange(new c.Range(l.lineNumber,l.column,m,_.getLineMaxColumn(m)),1),b=_.getEOL()===`\r
`?new D(h):null;s.reset(i.column-1);const w=s.next(h);return w?E(this._getMultilineMatchRange(_,u,h,b,w.index,w[0]),w,a):i.lineNumber!==1||i.column!==1?this._doFindNextMatchMultiline(_,new M.Position(1,1),s,a):null}static _doFindNextMatchLineByLine(_,i,s,a){const l=_.getLineCount(),u=i.lineNumber,m=_.getLineContent(u),h=this._findFirstMatchInLine(s,m,u,i.column,a);if(h)return h;for(let b=1;b<=l;b++){const w=(u+b-1)%l,L=_.getLineContent(w+1),v=this._findFirstMatchInLine(s,L,w+1,1,a);if(v)return v}return null}static _findFirstMatchInLine(_,i,s,a,l){_.reset(a-1);const u=_.next(i);return u?E(new c.Range(s,u.index+1,s,u.index+1+u[0].length),u,l):null}static findPreviousMatch(_,i,s,a){const l=i.parseSearchRequest();if(!l)return null;const u=new R(l.wordSeparators,l.regex);return l.regex.multiline?this._doFindPreviousMatchMultiline(_,s,u,a):this._doFindPreviousMatchLineByLine(_,s,u,a)}static _doFindPreviousMatchMultiline(_,i,s,a){const l=this._doFindMatchesMultiline(_,new c.Range(1,1,i.lineNumber,i.column),s,a,10*d);if(l.length>0)return l[l.length-1];const u=_.getLineCount();return i.lineNumber!==u||i.column!==_.getLineMaxColumn(u)?this._doFindPreviousMatchMultiline(_,new M.Position(u,_.getLineMaxColumn(u)),s,a):null}static _doFindPreviousMatchLineByLine(_,i,s,a){const l=_.getLineCount(),u=i.lineNumber,m=_.getLineContent(u).substring(0,i.column-1),h=this._findLastMatchInLine(s,m,u,a);if(h)return h;for(let b=1;b<=l;b++){const w=(l+u-b-1)%l,L=_.getLineContent(w+1),v=this._findLastMatchInLine(s,L,w+1,a);if(v)return v}return null}static _findLastMatchInLine(_,i,s,a){let l=null,u;for(_.reset(0);u=_.next(i);)l=E(new c.Range(s,u.index+1,s,u.index+1+u[0].length),u,a);return l}}n.TextModelSearch=p;function f(A,_,i,s,a){if(s===0)return!0;const l=_.charCodeAt(s-1);if(A.get(l)!==0||l===13||l===10)return!0;if(a>0){const u=_.charCodeAt(s);if(A.get(u)!==0)return!0}return!1}function e(A,_,i,s,a){if(s+a===i)return!0;const l=_.charCodeAt(s+a);if(A.get(l)!==0||l===13||l===10)return!0;if(a>0){const u=_.charCodeAt(s+a-1);if(A.get(u)!==0)return!0}return!1}function C(A,_,i,s,a){return f(A,_,i,s,a)&&e(A,_,i,s,a)}n.isValidMatch=C;class R{constructor(_,i){this._wordSeparators=_,this._searchRegex=i,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(_){this._searchRegex.lastIndex=_,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(_){const i=_.length;let s;do{if(this._prevMatchStartIndex+this._prevMatchLength===i||(s=this._searchRegex.exec(_),!s))return null;const a=s.index,l=s[0].length;if(a===this._prevMatchStartIndex&&l===this._prevMatchLength){if(l===0){y.getNextCodePoint(_,i,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=a,this._prevMatchLength=l,!this._wordSeparators||C(this._wordSeparators,_,i,a,l))return s}while(s);return null}}n.Searcher=R}),Y(Z[50],J([0,1,2,49,4,24,17]),function(O,n,y,t,M,c,N){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.UnicodeHighlighterReasonKind=n.UnicodeTextModelHighlighter=void 0;class d{static computeUnicodeHighlights(e,C,R){const A=R?R.startLineNumber:1,_=R?R.endLineNumber:e.getLineCount(),i=new E(C),s=i.getCandidateCodePoints();let a;s==="allNonBasicAscii"?a=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):a=new RegExp(`${o(Array.from(s))}`,"g");const l=new t.Searcher(null,a),u=[];let m=!1,h,b=0,w=0,L=0;e:for(let v=A,F=_;v<=F;v++){const B=e.getLineContent(v),U=B.length;l.reset(0);do if(h=l.next(B),h){let V=h.index,$=h.index+h[0].length;if(V>0){const re=B.charCodeAt(V-1);M.isHighSurrogate(re)&&V--}if($+1<U){const re=B.charCodeAt($-1);M.isHighSurrogate(re)&&$++}const j=B.substring(V,$),ne=(0,N.getWordAtText)(V+1,N.DEFAULT_WORD_REGEXP,B,0),oe=i.shouldHighlightNonBasicASCII(j,ne?ne.word:null);if(oe!==0){oe===3?b++:oe===2?w++:oe===1?L++:(0,c.assertNever)(oe);const re=1e3;if(u.length>=re){m=!0;break e}u.push(new y.Range(v,V+1,v,$+1))}}while(h)}return{ranges:u,hasMore:m,ambiguousCharacterCount:b,invisibleCharacterCount:w,nonBasicAsciiCharacterCount:L}}static computeUnicodeHighlightReason(e,C){const R=new E(C);switch(R.shouldHighlightNonBasicASCII(e,null)){case 0:return null;case 2:return{kind:1};case 3:{const _=e.codePointAt(0),i=R.ambiguousCharacters.getPrimaryConfusable(_),s=M.AmbiguousCharacters.getLocales().filter(a=>!M.AmbiguousCharacters.getInstance(new Set([...C.allowedLocales,a])).isAmbiguous(_));return{kind:0,confusableWith:String.fromCodePoint(i),notAmbiguousInLocales:s}}case 1:return{kind:2}}}}n.UnicodeTextModelHighlighter=d;function o(f,e){return`[${M.escapeRegExpCharacters(f.map(R=>String.fromCodePoint(R)).join(""))}]`}var g;(function(f){f[f.Ambiguous=0]="Ambiguous",f[f.Invisible=1]="Invisible",f[f.NonBasicAscii=2]="NonBasicAscii"})(g=n.UnicodeHighlighterReasonKind||(n.UnicodeHighlighterReasonKind={}));class E{constructor(e){this.options=e,this.allowedCodePoints=new Set(e.allowedCodePoints),this.ambiguousCharacters=M.AmbiguousCharacters.getInstance(new Set(e.allowedLocales))}getCandidateCodePoints(){if(this.options.nonBasicASCII)return"allNonBasicAscii";const e=new Set;if(this.options.invisibleCharacters)for(const C of M.InvisibleCharacters.codePoints)D(String.fromCodePoint(C))||e.add(C);if(this.options.ambiguousCharacters)for(const C of this.ambiguousCharacters.getConfusableCodePoints())e.add(C);for(const C of this.allowedCodePoints)e.delete(C);return e}shouldHighlightNonBasicASCII(e,C){const R=e.codePointAt(0);if(this.allowedCodePoints.has(R))return 0;if(this.options.nonBasicASCII)return 1;let A=!1,_=!1;if(C)for(const i of C){const s=i.codePointAt(0),a=M.isBasicASCII(i);A=A||a,!a&&!this.ambiguousCharacters.isAmbiguous(s)&&!M.InvisibleCharacters.isInvisibleCharacter(s)&&(_=!0)}return!A&&_?0:this.options.invisibleCharacters&&!D(e)&&M.InvisibleCharacters.isInvisibleCharacter(R)?2:this.options.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(R)?3:0}}function D(f){return f===" "||f===`
`||f==="	"}var p;(function(f){f[f.None=0]="None",f[f.NonBasicASCII=1]="NonBasicASCII",f[f.Invisible=2]="Invisible",f[f.Ambiguous=3]="Ambiguous"})(p||(p={}))}),Y(Z[51],J([0,1,7,6]),function(O,n,y,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.TokenizationRegistry=void 0;class M{constructor(){this._map=new Map,this._factories=new Map,this._onDidChange=new y.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(d){this._onDidChange.fire({changedLanguages:d,changedColorMap:!1})}register(d,o){return this._map.set(d,o),this.fire([d]),(0,t.toDisposable)(()=>{this._map.get(d)===o&&(this._map.delete(d),this.fire([d]))})}registerFactory(d,o){this._factories.get(d)?.dispose();const g=new c(this,d,o);return this._factories.set(d,g),(0,t.toDisposable)(()=>{const E=this._factories.get(d);!E||E!==g||(this._factories.delete(d),E.dispose())})}async getOrCreate(d){const o=this.get(d);if(o)return o;const g=this._factories.get(d);return!g||g.isResolved?null:(await g.resolve(),this.get(d))}get(d){return this._map.get(d)||null}isResolved(d){if(this.get(d))return!0;const g=this._factories.get(d);return!!(!g||g.isResolved)}setColorMap(d){this._colorMap=d,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}n.TokenizationRegistry=M;class c extends t.Disposable{constructor(d,o,g){super();this._registry=d,this._languageId=o,this._factory=g,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}get isResolved(){return this._isResolved}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const d=await Promise.resolve(this._factory.createTokenizationSupport());this._isResolved=!0,d&&!this._isDisposed&&this._register(this._registry.register(this._languageId,d))}}}),Y(Z[52],J([0,1,25,11,2,51]),function(O,n,y,t,M,c){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.ExternalUriOpenerPriority=n.TokenizationRegistry=n.InlayHintKind=n.CommentMode=n.CommentThreadState=n.CommentThreadCollapsibleState=n.Command=n.FoldingRangeKind=n.SymbolKinds=n.SymbolTag=n.SymbolKind=n.isLocationLink=n.DocumentHighlightKind=n.SignatureHelpTriggerKind=n.CodeActionTriggerType=n.InlineCompletionTriggerKind=n.CompletionTriggerKind=n.CompletionItemInsertTextRule=n.CompletionItemTag=n.CompletionItemKinds=n.CompletionItemKind=n.EncodedTokenizationResult=n.TokenizationResult=n.Token=void 0;class N{constructor(F,B,U){this._tokenBrand=void 0,this.offset=F,this.type=B,this.language=U}toString(){return"("+this.offset+", "+this.type+")"}}n.Token=N;class d{constructor(F,B){this._tokenizationResultBrand=void 0,this.tokens=F,this.endState=B}}n.TokenizationResult=d;class o{constructor(F,B){this._encodedTokenizationResultBrand=void 0,this.tokens=F,this.endState=B}}n.EncodedTokenizationResult=o;var g;(function(v){v[v.Method=0]="Method",v[v.Function=1]="Function",v[v.Constructor=2]="Constructor",v[v.Field=3]="Field",v[v.Variable=4]="Variable",v[v.Class=5]="Class",v[v.Struct=6]="Struct",v[v.Interface=7]="Interface",v[v.Module=8]="Module",v[v.Property=9]="Property",v[v.Event=10]="Event",v[v.Operator=11]="Operator",v[v.Unit=12]="Unit",v[v.Value=13]="Value",v[v.Constant=14]="Constant",v[v.Enum=15]="Enum",v[v.EnumMember=16]="EnumMember",v[v.Keyword=17]="Keyword",v[v.Text=18]="Text",v[v.Color=19]="Color",v[v.File=20]="File",v[v.Reference=21]="Reference",v[v.Customcolor=22]="Customcolor",v[v.Folder=23]="Folder",v[v.TypeParameter=24]="TypeParameter",v[v.User=25]="User",v[v.Issue=26]="Issue",v[v.Snippet=27]="Snippet"})(g=n.CompletionItemKind||(n.CompletionItemKind={}));var E;(function(v){const F=new Map;F.set(0,y.Codicon.symbolMethod),F.set(1,y.Codicon.symbolFunction),F.set(2,y.Codicon.symbolConstructor),F.set(3,y.Codicon.symbolField),F.set(4,y.Codicon.symbolVariable),F.set(5,y.Codicon.symbolClass),F.set(6,y.Codicon.symbolStruct),F.set(7,y.Codicon.symbolInterface),F.set(8,y.Codicon.symbolModule),F.set(9,y.Codicon.symbolProperty),F.set(10,y.Codicon.symbolEvent),F.set(11,y.Codicon.symbolOperator),F.set(12,y.Codicon.symbolUnit),F.set(13,y.Codicon.symbolValue),F.set(15,y.Codicon.symbolEnum),F.set(14,y.Codicon.symbolConstant),F.set(15,y.Codicon.symbolEnum),F.set(16,y.Codicon.symbolEnumMember),F.set(17,y.Codicon.symbolKeyword),F.set(27,y.Codicon.symbolSnippet),F.set(18,y.Codicon.symbolText),F.set(19,y.Codicon.symbolColor),F.set(20,y.Codicon.symbolFile),F.set(21,y.Codicon.symbolReference),F.set(22,y.Codicon.symbolCustomColor),F.set(23,y.Codicon.symbolFolder),F.set(24,y.Codicon.symbolTypeParameter),F.set(25,y.Codicon.account),F.set(26,y.Codicon.issues);function B($){let j=F.get($);return j||(console.info("No codicon found for CompletionItemKind "+$),j=y.Codicon.symbolProperty),j}v.toIcon=B;const U=new Map;U.set("method",0),U.set("function",1),U.set("constructor",2),U.set("field",3),U.set("variable",4),U.set("class",5),U.set("struct",6),U.set("interface",7),U.set("module",8),U.set("property",9),U.set("event",10),U.set("operator",11),U.set("unit",12),U.set("value",13),U.set("constant",14),U.set("enum",15),U.set("enum-member",16),U.set("enumMember",16),U.set("keyword",17),U.set("snippet",27),U.set("text",18),U.set("color",19),U.set("file",20),U.set("reference",21),U.set("customcolor",22),U.set("folder",23),U.set("type-parameter",24),U.set("typeParameter",24),U.set("account",25),U.set("issue",26);function V($,j){let ne=U.get($);return typeof ne=="undefined"&&!j&&(ne=9),ne}v.fromString=V})(E=n.CompletionItemKinds||(n.CompletionItemKinds={}));var D;(function(v){v[v.Deprecated=1]="Deprecated"})(D=n.CompletionItemTag||(n.CompletionItemTag={}));var p;(function(v){v[v.KeepWhitespace=1]="KeepWhitespace",v[v.InsertAsSnippet=4]="InsertAsSnippet"})(p=n.CompletionItemInsertTextRule||(n.CompletionItemInsertTextRule={}));var f;(function(v){v[v.Invoke=0]="Invoke",v[v.TriggerCharacter=1]="TriggerCharacter",v[v.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(f=n.CompletionTriggerKind||(n.CompletionTriggerKind={}));var e;(function(v){v[v.Automatic=0]="Automatic",v[v.Explicit=1]="Explicit"})(e=n.InlineCompletionTriggerKind||(n.InlineCompletionTriggerKind={}));var C;(function(v){v[v.Invoke=1]="Invoke",v[v.Auto=2]="Auto"})(C=n.CodeActionTriggerType||(n.CodeActionTriggerType={}));var R;(function(v){v[v.Invoke=1]="Invoke",v[v.TriggerCharacter=2]="TriggerCharacter",v[v.ContentChange=3]="ContentChange"})(R=n.SignatureHelpTriggerKind||(n.SignatureHelpTriggerKind={}));var A;(function(v){v[v.Text=0]="Text",v[v.Read=1]="Read",v[v.Write=2]="Write"})(A=n.DocumentHighlightKind||(n.DocumentHighlightKind={}));function _(v){return v&&t.URI.isUri(v.uri)&&M.Range.isIRange(v.range)&&(M.Range.isIRange(v.originSelectionRange)||M.Range.isIRange(v.targetSelectionRange))}n.isLocationLink=_;var i;(function(v){v[v.File=0]="File",v[v.Module=1]="Module",v[v.Namespace=2]="Namespace",v[v.Package=3]="Package",v[v.Class=4]="Class",v[v.Method=5]="Method",v[v.Property=6]="Property",v[v.Field=7]="Field",v[v.Constructor=8]="Constructor",v[v.Enum=9]="Enum",v[v.Interface=10]="Interface",v[v.Function=11]="Function",v[v.Variable=12]="Variable",v[v.Constant=13]="Constant",v[v.String=14]="String",v[v.Number=15]="Number",v[v.Boolean=16]="Boolean",v[v.Array=17]="Array",v[v.Object=18]="Object",v[v.Key=19]="Key",v[v.Null=20]="Null",v[v.EnumMember=21]="EnumMember",v[v.Struct=22]="Struct",v[v.Event=23]="Event",v[v.Operator=24]="Operator",v[v.TypeParameter=25]="TypeParameter"})(i=n.SymbolKind||(n.SymbolKind={}));var s;(function(v){v[v.Deprecated=1]="Deprecated"})(s=n.SymbolTag||(n.SymbolTag={}));var a;(function(v){const F=new Map;F.set(0,y.Codicon.symbolFile),F.set(1,y.Codicon.symbolModule),F.set(2,y.Codicon.symbolNamespace),F.set(3,y.Codicon.symbolPackage),F.set(4,y.Codicon.symbolClass),F.set(5,y.Codicon.symbolMethod),F.set(6,y.Codicon.symbolProperty),F.set(7,y.Codicon.symbolField),F.set(8,y.Codicon.symbolConstructor),F.set(9,y.Codicon.symbolEnum),F.set(10,y.Codicon.symbolInterface),F.set(11,y.Codicon.symbolFunction),F.set(12,y.Codicon.symbolVariable),F.set(13,y.Codicon.symbolConstant),F.set(14,y.Codicon.symbolString),F.set(15,y.Codicon.symbolNumber),F.set(16,y.Codicon.symbolBoolean),F.set(17,y.Codicon.symbolArray),F.set(18,y.Codicon.symbolObject),F.set(19,y.Codicon.symbolKey),F.set(20,y.Codicon.symbolNull),F.set(21,y.Codicon.symbolEnumMember),F.set(22,y.Codicon.symbolStruct),F.set(23,y.Codicon.symbolEvent),F.set(24,y.Codicon.symbolOperator),F.set(25,y.Codicon.symbolTypeParameter);function B(U){let V=F.get(U);return V||(console.info("No codicon found for SymbolKind "+U),V=y.Codicon.symbolProperty),V}v.toIcon=B})(a=n.SymbolKinds||(n.SymbolKinds={}));class l{constructor(F){this.value=F}}n.FoldingRangeKind=l,l.Comment=new l("comment"),l.Imports=new l("imports"),l.Region=new l("region");var u;(function(v){function F(B){return!B||typeof B!="object"?!1:typeof B.id=="string"&&typeof B.title=="string"}v.is=F})(u=n.Command||(n.Command={}));var m;(function(v){v[v.Collapsed=0]="Collapsed",v[v.Expanded=1]="Expanded"})(m=n.CommentThreadCollapsibleState||(n.CommentThreadCollapsibleState={}));var h;(function(v){v[v.Unresolved=0]="Unresolved",v[v.Resolved=1]="Resolved"})(h=n.CommentThreadState||(n.CommentThreadState={}));var b;(function(v){v[v.Editing=0]="Editing",v[v.Preview=1]="Preview"})(b=n.CommentMode||(n.CommentMode={}));var w;(function(v){v[v.Type=1]="Type",v[v.Parameter=2]="Parameter"})(w=n.InlayHintKind||(n.InlayHintKind={})),n.TokenizationRegistry=new c.TokenizationRegistry;var L;(function(v){v[v.None=0]="None",v[v.Option=1]="Option",v[v.Default=2]="Default",v[v.Preferred=3]="Preferred"})(L=n.ExternalUriOpenerPriority||(n.ExternalUriOpenerPriority={}))}),Y(Z[53],J([0,1,20,7,28,11,3,2,31,52,41]),function(O,n,y,t,M,c,N,d,o,g,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.createMonacoBaseAPI=n.KeyMod=void 0;class D{static chord(e,C){return(0,M.KeyChord)(e,C)}}n.KeyMod=D,D.CtrlCmd=2048,D.Shift=1024,D.Alt=512,D.WinCtrl=256;function p(){return{editor:void 0,languages:void 0,CancellationTokenSource:y.CancellationTokenSource,Emitter:t.Emitter,KeyCode:E.KeyCode,KeyMod:D,Position:N.Position,Range:d.Range,Selection:o.Selection,SelectionDirection:E.SelectionDirection,MarkerSeverity:E.MarkerSeverity,MarkerTag:E.MarkerTag,Uri:c.URI,Token:g.Token}}n.createMonacoBaseAPI=p}),Y(Z[56],J([0,1,21,5,11,3,2,48,17,37,38,53,19,50,22,47,9]),function(O,n,y,t,M,c,N,d,o,g,E,D,p,f,e,C,R){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.create=n.EditorSimpleWorker=n.MirrorModel=void 0;class A extends d.MirrorTextModel{get uri(){return this._uri}get eol(){return this._eol}getValue(){return this.getText()}getLinesContent(){return this._lines.slice(0)}getLineCount(){return this._lines.length}getLineContent(a){return this._lines[a-1]}getWordAtPosition(a,l){const u=(0,o.getWordAtText)(a.column,(0,o.ensureValidWordDefinition)(l),this._lines[a.lineNumber-1],0);return u?new N.Range(a.lineNumber,u.startColumn,a.lineNumber,u.endColumn):null}getWordUntilPosition(a,l){const u=this.getWordAtPosition(a,l);return u?{word:this._lines[a.lineNumber-1].substring(u.startColumn-1,a.column-1),startColumn:u.startColumn,endColumn:a.column}:{word:"",startColumn:a.column,endColumn:a.column}}words(a){const l=this._lines,u=this._wordenize.bind(this);let m=0,h="",b=0,w=[];return{*[Symbol.iterator](){for(;;)if(b<w.length){const L=h.substring(w[b].start,w[b].end);b+=1,yield L}else if(m<l.length)h=l[m],w=u(h,a),b=0,m+=1;else break}}}getLineWords(a,l){const u=this._lines[a-1],m=this._wordenize(u,l),h=[];for(const b of m)h.push({word:u.substring(b.start,b.end),startColumn:b.start+1,endColumn:b.end+1});return h}_wordenize(a,l){const u=[];let m;for(l.lastIndex=0;(m=l.exec(a))&&m[0].length!==0;)u.push({start:m.index,end:m.index+m[0].length});return u}getValueInRange(a){if(a=this._validateRange(a),a.startLineNumber===a.endLineNumber)return this._lines[a.startLineNumber-1].substring(a.startColumn-1,a.endColumn-1);const l=this._eol,u=a.startLineNumber-1,m=a.endLineNumber-1,h=[];h.push(this._lines[u].substring(a.startColumn-1));for(let b=u+1;b<m;b++)h.push(this._lines[b]);return h.push(this._lines[m].substring(0,a.endColumn-1)),h.join(l)}offsetAt(a){return a=this._validatePosition(a),this._ensureLineStarts(),this._lineStarts.getPrefixSum(a.lineNumber-2)+(a.column-1)}positionAt(a){a=Math.floor(a),a=Math.max(0,a),this._ensureLineStarts();const l=this._lineStarts.getIndexOf(a),u=this._lines[l.index].length;return{lineNumber:1+l.index,column:1+Math.min(l.remainder,u)}}_validateRange(a){const l=this._validatePosition({lineNumber:a.startLineNumber,column:a.startColumn}),u=this._validatePosition({lineNumber:a.endLineNumber,column:a.endColumn});return l.lineNumber!==a.startLineNumber||l.column!==a.startColumn||u.lineNumber!==a.endLineNumber||u.column!==a.endColumn?{startLineNumber:l.lineNumber,startColumn:l.column,endLineNumber:u.lineNumber,endColumn:u.column}:a}_validatePosition(a){if(!c.Position.isIPosition(a))throw new Error("bad position");let{lineNumber:l,column:u}=a,m=!1;if(l<1)l=1,u=1,m=!0;else if(l>this._lines.length)l=this._lines.length,u=this._lines[l-1].length+1,m=!0;else{const h=this._lines[l-1].length+1;u<1?(u=1,m=!0):u>h&&(u=h,m=!0)}return m?{lineNumber:l,column:u}:a}}n.MirrorModel=A;class _{constructor(a,l){this._host=a,this._models=Object.create(null),this._foreignModuleFactory=l,this._foreignModule=null}dispose(){this._models=Object.create(null)}_getModel(a){return this._models[a]}_getModels(){const a=[];return Object.keys(this._models).forEach(l=>a.push(this._models[l])),a}acceptNewModel(a){this._models[a.url]=new A(M.URI.parse(a.url),a.lines,a.EOL,a.versionId)}acceptModelChanged(a,l){if(!this._models[a])return;this._models[a].onEvents(l)}acceptRemovedModel(a){!this._models[a]||delete this._models[a]}async computeUnicodeHighlights(a,l,u){const m=this._getModel(a);return m?f.UnicodeTextModelHighlighter.computeUnicodeHighlights(m,l,u):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}async computeDiff(a,l,u){const m=this._getModel(a),h=this._getModel(l);return!m||!h?null:_.computeDiff(m,h,u)}static computeDiff(a,l,u){const m=u.diffAlgorithm==="experimental"?C.linesDiffComputers.experimental:C.linesDiffComputers.smart,h=a.getLinesContent(),b=l.getLinesContent(),w=m.computeDiff(h,b,u);return{identical:w.changes.length>0?!1:this._modelsAreIdentical(a,l),quitEarly:w.quitEarly,changes:w.changes.map(v=>[v.originalRange.startLineNumber,v.originalRange.endLineNumberExclusive,v.modifiedRange.startLineNumber,v.modifiedRange.endLineNumberExclusive,v.innerChanges?.map(F=>[F.originalRange.startLineNumber,F.originalRange.startColumn,F.originalRange.endLineNumber,F.originalRange.endColumn,F.modifiedRange.startLineNumber,F.modifiedRange.startColumn,F.modifiedRange.endLineNumber,F.modifiedRange.endColumn])])}}static _modelsAreIdentical(a,l){const u=a.getLineCount(),m=l.getLineCount();if(u!==m)return!1;for(let h=1;h<=u;h++){const b=a.getLineContent(h),w=l.getLineContent(h);if(b!==w)return!1}return!0}async computeDirtyDiff(a,l,u){const m=this._getModel(a),h=this._getModel(l);if(!m||!h)return null;const b=m.getLinesContent(),w=h.getLinesContent();return new e.DiffComputer(b,w,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:u,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}async computeMoreMinimalEdits(a,l){const u=this._getModel(a);if(!u)return l;const m=[];let h;l=l.slice(0).sort((b,w)=>{if(b.range&&w.range)return N.Range.compareRangesUsingStarts(b.range,w.range);const L=b.range?0:1,v=w.range?0:1;return L-v});for(let{range:b,text:w,eol:L}of l){if(typeof L=="number"&&(h=L),N.Range.isEmpty(b)&&!w)continue;const v=u.getValueInRange(b);if(w=w.replace(/\r\n|\n|\r/g,u.eol),v===w)continue;if(Math.max(w.length,v.length)>_._diffLimit){m.push({range:b,text:w});continue}const F=(0,y.stringDiff)(v,w,!1),B=u.offsetAt(N.Range.lift(b).getStartPosition());for(const U of F){const V=u.positionAt(B+U.originalStart),$=u.positionAt(B+U.originalStart+U.originalLength),j={text:w.substr(U.modifiedStart,U.modifiedLength),range:{startLineNumber:V.lineNumber,startColumn:V.column,endLineNumber:$.lineNumber,endColumn:$.column}};u.getValueInRange(j.range)!==j.text&&m.push(j)}}return typeof h=="number"&&m.push({eol:h,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),m}async computeLinks(a){const l=this._getModel(a);return l?(0,g.computeLinks)(l):null}async textualSuggest(a,l,u,m){const h=new p.StopWatch(!0),b=new RegExp(u,m),w=new Set;e:for(const L of a){const v=this._getModel(L);if(!!v){for(const F of v.words(b))if(!(F===l||!isNaN(Number(F)))&&(w.add(F),w.size>_._suggestionsLimit))break e}}return{words:Array.from(w),duration:h.elapsed()}}async computeWordRanges(a,l,u,m){const h=this._getModel(a);if(!h)return Object.create(null);const b=new RegExp(u,m),w=Object.create(null);for(let L=l.startLineNumber;L<l.endLineNumber;L++){const v=h.getLineWords(L,b);for(const F of v){if(!isNaN(Number(F.word)))continue;let B=w[F.word];B||(B=[],w[F.word]=B),B.push({startLineNumber:L,startColumn:F.startColumn,endLineNumber:L,endColumn:F.endColumn})}}return w}async navigateValueSet(a,l,u,m,h){const b=this._getModel(a);if(!b)return null;const w=new RegExp(m,h);l.startColumn===l.endColumn&&(l={startLineNumber:l.startLineNumber,startColumn:l.startColumn,endLineNumber:l.endLineNumber,endColumn:l.endColumn+1});const L=b.getValueInRange(l),v=b.getWordAtPosition({lineNumber:l.startLineNumber,column:l.startColumn},w);if(!v)return null;const F=b.getValueInRange(v);return E.BasicInplaceReplace.INSTANCE.navigateValueSet(l,L,v,F,u)}loadForeignModule(a,l,u){const m=(w,L)=>this._host.fhr(w,L),b={host:(0,R.createProxyObject)(u,m),getMirrorModels:()=>this._getModels()};return this._foreignModuleFactory?(this._foreignModule=this._foreignModuleFactory(b,l),Promise.resolve((0,R.getAllMethodNames)(this._foreignModule))):new Promise((w,L)=>{O([a],v=>{this._foreignModule=v.create(b,l),w((0,R.getAllMethodNames)(this._foreignModule))},L)})}fmr(a,l){if(!this._foreignModule||typeof this._foreignModule[a]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+a));try{return Promise.resolve(this._foreignModule[a].apply(this._foreignModule,l))}catch(u){return Promise.reject(u)}}}n.EditorSimpleWorker=_,_._diffLimit=1e5,_._suggestionsLimit=1e4;function i(s){return new _(s,null)}n.create=i,typeof importScripts=="function"&&(t.globals.monaco=(0,D.createMonacoBaseAPI)())})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/7fee053fdfef9bd86da74dc3c223b95019c5d297/core/vs/base/worker/workerMain.js.map
