/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","vs/base/common/network","vs/platform/files/common/files","electron","vs/base/common/resources","vs/base/common/buffer","vs/base/common/errors","vs/platform/configuration/common/configuration","vs/platform/product/common/productService","vs/base/common/cancellation","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/node/pfs","vs/base/common/arrays","vs/platform/workspace/common/workspace","vs/base/common/strings","vs/platform/environment/electron-main/environmentMainService","vs/base/common/uuid","fs","os","vs/base/common/extpath","vs/base/common/map","vs/platform/windows/electron-main/windows","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/process","vs/base/common/labels","vs/platform/environment/common/environment","vs/platform/telemetry/common/telemetry","vs/platform/policy/common/policy","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/state/electron-main/state","vs/base/common/json","vs/base/common/errorMessage","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/platform/update/common/update","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/functional","vs/base/common/objects","child_process","vs/base/common/decorators","vs/platform/request/common/request","vs/platform/uriIdentity/common/uriIdentity","vs/platform/dialogs/electron-main/dialogMainService","vs/base/common/iterator","vs/base/common/stream","vs/base/common/marshalling","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/theme/electron-main/themeMainService","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/hash","vs/platform/instantiation/common/descriptors","vs/platform/credentials/common/credentials","vs/platform/files/common/watcher","vs/base/common/performance","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/telemetry/common/telemetryUtils","vs/platform/window/common/window","vs/platform/workspaces/electron-main/workspacesHistoryMainService","crypto","net","vs/base/common/processes","vs/base/common/stopwatch","vs/base/common/normalization","vs/base/node/id","vs/base/node/processes","vs/base/parts/ipc/node/ipc.net","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/sign/common/sign","vs/platform/update/electron-main/abstractUpdateService","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/common/workspaces","vs/base/node/ports","vs/base/common/observableValue","vs/base/common/severity","vs/base/common/glob","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/encryption/common/encryptionService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/files/common/io","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/shell/node/shellEnv","vs/platform/telemetry/common/commonProperties","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/storage/common/storage","vs/platform/windows/electron-main/windowsFinder","vs/platform/workspaces/electron-main/workspaces","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/codicons","vs/base/common/color","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/skipList","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-main/contextmenu","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/encryption/node/encryptionMainService","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/credentials/common/credentialsMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/node/nodeSocketFactory","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/state/electron-main/stateMainService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/tunnel/node/tunnelService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/code/electron-main/auth","vs/platform/credentials/electron-main/credentialsMainService","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/backup/electron-main/backupMainService","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/node/userDataProfile","vs/platform/extensionManagement/electron-main/defaultExtensionsProfileInit","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/windowImpl","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","vs/platform/policy/node/nativePolicyService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","minimist","assert","path","graceful-fs","string_decoder","vscode-policy-watcher","zlib","vs/code/electron-main/main"],ee=function(H){for(var e=[],v=0,t=H.length;v<t;v++)e[v]=Z[H[v]];return e};define(Z[120],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.ok=void 0;function v(k,R){if(!k)throw new Error(R?`Assertion failed (${R})`:"Assertion Failed")}e.ok=v;function t(k,R="Unreachable"){throw new Error(R)}e.assertNever=t}),define(Z[121],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function v(D){return D?D.replace(/\$\((.*?)\)/g,(y,h)=>` ${h} `).trim():""}e.getCodiconAriaLabel=v;class t{constructor(y,h,p){this.id=y,this.definition=h,this.description=p,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",t.circleFilled.definition),t.closeDirty=new t("close-dirty",t.circleFilled.definition),t.terminalDecorationSuccess=new t("terminal-decoration-success",t.circleFilled.definition),t.debugBreakpoint=new t("debug-breakpoint",t.circleFilled.definition),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",t.circleFilled.definition),t.debugHint=new t("debug-hint",t.circleFilled.definition),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circle=new t("circle",{fontCharacter:"\\eabc"}),t.circleOutline=new t("circle-outline",t.circle.definition),t.terminalDecorationIncomplete=new t("terminal-decoration-incomplete",t.circle.definition),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",t.circle.definition),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.terminalDecorationMark=new t("terminal-decoration-mark",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLarge=new t("circle-large",{fontCharacter:"\\ebb5"}),t.circleLargeOutline=new t("circle-large-outline",t.circleLarge.definition),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.terminalDecorationError=new t("terminal-decoration-error",t.errorSmall.definition),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\ec09"}),t.commentUnresolved=new t("comment-unresolved",{fontCharacter:"\\ec0a"}),t.gitPullRequestGoToChanges=new t("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),t.gitPullRequestNewChanges=new t("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function k(D,y){const h=["codicon","codicon-"+D];return y&&h.push("codicon-modifier-"+y),h}e.getClassNamesArray=k;var R;(function(D){D.iconNameSegment="[A-Za-z0-9]+",D.iconNameExpression="[A-Za-z0-9-]+",D.iconModifierExpression="~[A-Za-z]+",D.iconNameCharacter="[A-Za-z0-9~-]";const y=new RegExp(`^(${D.iconNameExpression})(${D.iconModifierExpression})?$`);function h(C){if(C instanceof t)return["codicon","codicon-"+C.id];const b=y.exec(C.id);if(!b)return h(t.error);const[,g,d]=b,E=["codicon","codicon-"+g];return d&&E.push("codicon-modifier-"+d.substr(1)),E}D.asClassNameArray=h;function p(C){return h(C).join(" ")}D.asClassName=p;function I(C){return"."+h(C).join(".")}D.asCSSSelector=I})(R=e.CSSIcon||(e.CSSIcon={}))}),define(Z[122],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Color=e.HSVA=e.HSLA=e.RGBA=void 0;function v(y,h){const p=Math.pow(10,h);return Math.round(y*p)/p}class t{constructor(h,p,I,C=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,h))|0,this.g=Math.min(255,Math.max(0,p))|0,this.b=Math.min(255,Math.max(0,I))|0,this.a=v(Math.max(Math.min(1,C),0),3)}static equals(h,p){return h.r===p.r&&h.g===p.g&&h.b===p.b&&h.a===p.a}}e.RGBA=t;class k{constructor(h,p,I,C){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,h),0)|0,this.s=v(Math.max(Math.min(1,p),0),3),this.l=v(Math.max(Math.min(1,I),0),3),this.a=v(Math.max(Math.min(1,C),0),3)}static equals(h,p){return h.h===p.h&&h.s===p.s&&h.l===p.l&&h.a===p.a}static fromRGBA(h){const p=h.r/255,I=h.g/255,C=h.b/255,b=h.a,g=Math.max(p,I,C),d=Math.min(p,I,C);let E=0,S=0;const f=(d+g)/2,w=g-d;if(w>0){switch(S=Math.min(f<=.5?w/(2*f):w/(2-2*f),1),g){case p:E=(I-C)/w+(I<C?6:0);break;case I:E=(C-p)/w+2;break;case C:E=(p-I)/w+4;break}E*=60,E=Math.round(E)}return new k(E,S,f,b)}static _hue2rgb(h,p,I){return I<0&&(I+=1),I>1&&(I-=1),I<1/6?h+(p-h)*6*I:I<1/2?p:I<2/3?h+(p-h)*(2/3-I)*6:h}static toRGBA(h){const p=h.h/360,{s:I,l:C,a:b}=h;let g,d,E;if(I===0)g=d=E=C;else{const S=C<.5?C*(1+I):C+I-C*I,f=2*C-S;g=k._hue2rgb(f,S,p+1/3),d=k._hue2rgb(f,S,p),E=k._hue2rgb(f,S,p-1/3)}return new t(Math.round(g*255),Math.round(d*255),Math.round(E*255),b)}}e.HSLA=k;class R{constructor(h,p,I,C){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,h),0)|0,this.s=v(Math.max(Math.min(1,p),0),3),this.v=v(Math.max(Math.min(1,I),0),3),this.a=v(Math.max(Math.min(1,C),0),3)}static equals(h,p){return h.h===p.h&&h.s===p.s&&h.v===p.v&&h.a===p.a}static fromRGBA(h){const p=h.r/255,I=h.g/255,C=h.b/255,b=Math.max(p,I,C),g=Math.min(p,I,C),d=b-g,E=b===0?0:d/b;let S;return d===0?S=0:b===p?S=((I-C)/d%6+6)%6:b===I?S=(C-p)/d+2:S=(p-I)/d+4,new R(Math.round(S*60),E,b,h.a)}static toRGBA(h){const{h:p,s:I,v:C,a:b}=h,g=C*I,d=g*(1-Math.abs(p/60%2-1)),E=C-g;let[S,f,w]=[0,0,0];return p<60?(S=g,f=d):p<120?(S=d,f=g):p<180?(f=g,w=d):p<240?(f=d,w=g):p<300?(S=d,w=g):p<=360&&(S=g,w=d),S=Math.round((S+E)*255),f=Math.round((f+E)*255),w=Math.round((w+E)*255),new t(S,f,w,b)}}e.HSVA=R;class D{constructor(h){if(h)if(h instanceof t)this.rgba=h;else if(h instanceof k)this._hsla=h,this.rgba=k.toRGBA(h);else if(h instanceof R)this._hsva=h,this.rgba=R.toRGBA(h);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}static fromHex(h){return D.Format.CSS.parseHex(h)||D.red}get hsla(){return this._hsla?this._hsla:k.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:R.fromRGBA(this.rgba)}equals(h){return!!h&&t.equals(this.rgba,h.rgba)&&k.equals(this.hsla,h.hsla)&&R.equals(this.hsva,h.hsva)}getRelativeLuminance(){const h=D._relativeLuminanceForComponent(this.rgba.r),p=D._relativeLuminanceForComponent(this.rgba.g),I=D._relativeLuminanceForComponent(this.rgba.b),C=.2126*h+.7152*p+.0722*I;return v(C,4)}static _relativeLuminanceForComponent(h){const p=h/255;return p<=.03928?p/12.92:Math.pow((p+.055)/1.055,2.4)}getContrastRatio(h){const p=this.getRelativeLuminance(),I=h.getRelativeLuminance();return p>I?(p+.05)/(I+.05):(I+.05)/(p+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(h){const p=this.getRelativeLuminance(),I=h.getRelativeLuminance();return p>I}isDarkerThan(h){const p=this.getRelativeLuminance(),I=h.getRelativeLuminance();return p<I}lighten(h){return new D(new k(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*h,this.hsla.a))}darken(h){return new D(new k(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*h,this.hsla.a))}transparent(h){const{r:p,g:I,b:C,a:b}=this.rgba;return new D(new t(p,I,C,b*h))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new D(new t(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(h){const p=h.rgba,I=this.rgba.a,C=p.a,b=I+C*(1-I);if(b<1e-6)return D.transparent;const g=this.rgba.r*I/b+p.r*C*(1-I)/b,d=this.rgba.g*I/b+p.g*C*(1-I)/b,E=this.rgba.b*I/b+p.b*C*(1-I)/b;return new D(new t(g,d,E,b))}makeOpaque(h){if(this.isOpaque()||h.rgba.a!==1)return this;const{r:p,g:I,b:C,a:b}=this.rgba;return new D(new t(h.rgba.r-b*(h.rgba.r-p),h.rgba.g-b*(h.rgba.g-I),h.rgba.b-b*(h.rgba.b-C),1))}flatten(...h){const p=h.reduceRight((I,C)=>D._flatten(C,I));return D._flatten(this,p)}static _flatten(h,p){const I=1-h.rgba.a;return new D(new t(I*p.rgba.r+h.rgba.a*h.rgba.r,I*p.rgba.g+h.rgba.a*h.rgba.g,I*p.rgba.b+h.rgba.a*h.rgba.b))}toString(){return this._toString||(this._toString=D.Format.CSS.format(this)),this._toString}static getLighterColor(h,p,I){if(h.isLighterThan(p))return h;I=I||.5;const C=h.getRelativeLuminance(),b=p.getRelativeLuminance();return I=I*(b-C)/b,h.lighten(I)}static getDarkerColor(h,p,I){if(h.isDarkerThan(p))return h;I=I||.5;const C=h.getRelativeLuminance(),b=p.getRelativeLuminance();return I=I*(C-b)/C,h.darken(I)}}e.Color=D,D.white=new D(new t(255,255,255,1)),D.black=new D(new t(0,0,0,1)),D.red=new D(new t(255,0,0,1)),D.blue=new D(new t(0,0,255,1)),D.green=new D(new t(0,255,0,1)),D.cyan=new D(new t(0,255,255,1)),D.lightgrey=new D(new t(211,211,211,1)),D.transparent=new D(new t(0,0,0,0)),function(y){let h;(function(p){let I;(function(C){function b(s){return s.rgba.a===1?`rgb(${s.rgba.r}, ${s.rgba.g}, ${s.rgba.b})`:y.Format.CSS.formatRGBA(s)}C.formatRGB=b;function g(s){return`rgba(${s.rgba.r}, ${s.rgba.g}, ${s.rgba.b}, ${+s.rgba.a.toFixed(2)})`}C.formatRGBA=g;function d(s){return s.hsla.a===1?`hsl(${s.hsla.h}, ${(s.hsla.s*100).toFixed(2)}%, ${(s.hsla.l*100).toFixed(2)}%)`:y.Format.CSS.formatHSLA(s)}C.formatHSL=d;function E(s){return`hsla(${s.hsla.h}, ${(s.hsla.s*100).toFixed(2)}%, ${(s.hsla.l*100).toFixed(2)}%, ${s.hsla.a.toFixed(2)})`}C.formatHSLA=E;function S(s){const r=s.toString(16);return r.length!==2?"0"+r:r}function f(s){return`#${S(s.rgba.r)}${S(s.rgba.g)}${S(s.rgba.b)}`}C.formatHex=f;function w(s,r=!1){return r&&s.rgba.a===1?y.Format.CSS.formatHex(s):`#${S(s.rgba.r)}${S(s.rgba.g)}${S(s.rgba.b)}${S(Math.round(s.rgba.a*255))}`}C.formatHexA=w;function m(s){return s.isOpaque()?y.Format.CSS.formatHex(s):y.Format.CSS.formatRGBA(s)}C.format=m;function u(s){const r=s.length;if(r===0||s.charCodeAt(0)!==35)return null;if(r===7){const i=16*c(s.charCodeAt(1))+c(s.charCodeAt(2)),n=16*c(s.charCodeAt(3))+c(s.charCodeAt(4)),o=16*c(s.charCodeAt(5))+c(s.charCodeAt(6));return new y(new t(i,n,o,1))}if(r===9){const i=16*c(s.charCodeAt(1))+c(s.charCodeAt(2)),n=16*c(s.charCodeAt(3))+c(s.charCodeAt(4)),o=16*c(s.charCodeAt(5))+c(s.charCodeAt(6)),a=16*c(s.charCodeAt(7))+c(s.charCodeAt(8));return new y(new t(i,n,o,a/255))}if(r===4){const i=c(s.charCodeAt(1)),n=c(s.charCodeAt(2)),o=c(s.charCodeAt(3));return new y(new t(16*i+i,16*n+n,16*o+o))}if(r===5){const i=c(s.charCodeAt(1)),n=c(s.charCodeAt(2)),o=c(s.charCodeAt(3)),a=c(s.charCodeAt(4));return new y(new t(16*i+i,16*n+n,16*o+o,(16*a+a)/255))}return null}C.parseHex=u;function c(s){switch(s){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(I=p.CSS||(p.CSS={}))})(h=y.Format||(y.Format={}))}(D=e.Color||(e.Color={}))}),define(Z[51],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function v(D){return(y,h,p)=>{let I=null,C=null;if(typeof p.value=="function"?(I="value",C=p.value):typeof p.get=="function"&&(I="get",C=p.get),!C)throw new Error("not supported");p[I]=D(C,h)}}e.createDecorator=v;function t(D,y,h){let p=null,I=null;if(typeof h.value=="function"?(p="value",I=h.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof h.get=="function"&&(p="get",I=h.get),!I)throw new Error("not supported");const C=`$memoize$${y}`;h[p]=function(...b){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,b)}),this[C]}}e.memoize=t;function k(D,y,h){return v((p,I)=>{const C=`$debounce$${I}`,b=`$debounce$result$${I}`;return function(...g){this[b]||(this[b]=h?h():void 0),clearTimeout(this[C]),y&&(this[b]=y(this[b],...g),g=[this[b]]),this[C]=setTimeout(()=>{p.apply(this,g),this[b]=h?h():void 0},D)}})}e.debounce=k;function R(D,y,h){return v((p,I)=>{const C=`$throttle$timer$${I}`,b=`$throttle$result$${I}`,g=`$throttle$lastRun$${I}`,d=`$throttle$pending$${I}`;return function(...E){if(this[b]||(this[b]=h?h():void 0),(this[g]===null||this[g]===void 0)&&(this[g]=-Number.MAX_VALUE),y&&(this[b]=y(this[b],...E)),this[d])return;const S=this[g]+D;S<=Date.now()?(this[g]=Date.now(),p.apply(this,[this[b]]),this[b]=h?h():void 0):(this[d]=!0,this[C]=setTimeout(()=>{this[d]=!1,this[g]=Date.now(),p.apply(this,[this[b]]),this[b]=h?h():void 0},S-Date.now()))}})}e.throttle=R}),define(Z[18],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class v{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(s){setTimeout(()=>{throw s.stack?m.isErrorNoTelemetry(s)?new m(s.message+`

`+s.stack):new Error(s.message+`

`+s.stack):s},0)}}addListener(s){return this.listeners.push(s),()=>{this._removeListener(s)}}emit(s){this.listeners.forEach(r=>{r(s)})}_removeListener(s){this.listeners.splice(this.listeners.indexOf(s),1)}setUnexpectedErrorHandler(s){this.unexpectedErrorHandler=s}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(s){this.unexpectedErrorHandler(s),this.emit(s)}onUnexpectedExternalError(s){this.unexpectedErrorHandler(s)}}e.ErrorHandler=v,e.errorHandler=new v;function t(c){e.errorHandler.setUnexpectedErrorHandler(c)}e.setUnexpectedErrorHandler=t;function k(c){h(c)||e.errorHandler.onUnexpectedError(c)}e.onUnexpectedError=k;function R(c){h(c)||e.errorHandler.onUnexpectedExternalError(c)}e.onUnexpectedExternalError=R;function D(c){if(c instanceof Error){const{name:s,message:r}=c,i=c.stacktrace||c.stack;return{$isError:!0,name:s,message:r,stack:i,noTelemetry:m.isErrorNoTelemetry(c)}}return c}e.transformErrorForSerialization=D;const y="Canceled";function h(c){return c instanceof p?!0:c instanceof Error&&c.name===y&&c.message===y}e.isCancellationError=h;class p extends Error{constructor(){super(y);this.name=this.message}}e.CancellationError=p;function I(){const c=new Error(y);return c.name=c.message,c}e.canceled=I;function C(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}e.illegalArgument=C;function b(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}e.illegalState=b;function g(c){return c?new Error(`readonly property '${c} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=g;function d(c){const s=new Error(`${c} has been disposed`);return s.name="DISPOSED",s}e.disposed=d;function E(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}e.getErrorMessage=E;class S extends Error{constructor(s){super("NotImplemented");s&&(this.message=s)}}e.NotImplementedError=S;class f extends Error{constructor(s){super("NotSupported");s&&(this.message=s)}}e.NotSupportedError=f;class w extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=w;class m extends Error{constructor(s){super(s);this.name="ErrorNoTelemetry"}static fromError(s){if(s instanceof m)return s;const r=new m;return r.message=s.message,r.stack=s.stack,r}static isErrorNoTelemetry(s){return s.name==="ErrorNoTelemetry"}}e.ErrorNoTelemetry=m;class u extends Error{constructor(s){super(s||"An unexpected bug occurred.");Object.setPrototypeOf(this,u.prototype);debugger}}e.BugIndicatingError=u}),define(Z[24],ee([0,1,18]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function t(q,te=0){return q[q.length-(1+te)]}e.tail=t;function k(q){if(q.length===0)throw new Error("Invalid tail call");return[q.slice(0,q.length-1),q[q.length-1]]}e.tail2=k;function R(q,te,ne=(ce,he)=>ce===he){if(q===te)return!0;if(!q||!te||q.length!==te.length)return!1;for(let ce=0,he=q.length;ce<he;ce++)if(!ne(q[ce],te[ce]))return!1;return!0}e.equals=R;function D(q,te){const ne=q.length-1;te<ne&&(q[te]=q[ne]),q.pop()}e.removeFastWithoutKeepingOrder=D;function y(q,te,ne){return h(q.length,ce=>ne(q[ce],te))}e.binarySearch=y;function h(q,te){let ne=0,ce=q-1;for(;ne<=ce;){const he=(ne+ce)/2|0,ke=te(he);if(ke<0)ne=he+1;else if(ke>0)ce=he-1;else return he}return-(ne+1)}e.binarySearch2=h;function p(q,te){let ne=0,ce=q.length;if(ce===0)return 0;for(;ne<ce;){const he=Math.floor((ne+ce)/2);te(q[he])?ce=he:ne=he+1}return ne}e.findFirstInSorted=p;function I(q,te,ne){if(q=q|0,q>=te.length)throw new TypeError("invalid index");const ce=te[Math.floor(te.length*Math.random())],he=[],ke=[],Le=[];for(const Me of te){const Ae=ne(Me,ce);Ae<0?he.push(Me):Ae>0?ke.push(Me):Le.push(Me)}return q<he.length?I(q,he,ne):q<he.length+Le.length?Le[0]:I(q-(he.length+Le.length),ke,ne)}e.quickSelect=I;function C(q,te){const ne=[];let ce;for(const he of q.slice(0).sort(te))!ce||te(ce[0],he)!==0?(ce=[he],ne.push(ce)):ce.push(he);return ne}e.groupBy=C;function b(q,te,ne){const ce=[];function he(Me,Ae,je){if(Ae===0&&je.length===0)return;const me=ce[ce.length-1];me&&me.start+me.deleteCount===Me?(me.deleteCount+=Ae,me.toInsert.push(...je)):ce.push({start:Me,deleteCount:Ae,toInsert:je})}let ke=0,Le=0;for(;;){if(ke===q.length){he(ke,0,te.slice(Le));break}if(Le===te.length){he(ke,q.length-ke,[]);break}const Me=q[ke],Ae=te[Le],je=ne(Me,Ae);je===0?(ke+=1,Le+=1):je<0?(he(ke,1,[]),ke+=1):je>0&&(he(ke,0,[Ae]),Le+=1)}return ce}e.sortedDiff=b;function g(q,te,ne){const ce=b(q,te,ne),he=[],ke=[];for(const Le of ce)he.push(...q.slice(Le.start,Le.start+Le.deleteCount)),ke.push(...Le.toInsert);return{removed:he,added:ke}}e.delta=g;function d(q,te,ne){if(ne===0)return[];const ce=q.slice(0,ne).sort(te);return S(q,te,ce,ne,q.length),ce}e.top=d;function E(q,te,ne,ce,he){return ne===0?Promise.resolve([]):new Promise((ke,Le)=>{(async()=>{const Me=q.length,Ae=q.slice(0,ne).sort(te);for(let je=ne,me=Math.min(ne+ce,Me);je<Me;je=me,me=Math.min(me+ce,Me)){if(je>ne&&await new Promise(pe=>setTimeout(pe)),he&&he.isCancellationRequested)throw new v.CancellationError;S(q,te,Ae,je,me)}return Ae})().then(ke,Le)})}e.topAsync=E;function S(q,te,ne,ce,he){for(const ke=ne.length;ce<he;ce++){const Le=q[ce];if(te(Le,ne[ke-1])<0){ne.pop();const Me=p(ne,Ae=>te(Le,Ae)<0);ne.splice(Me,0,Le)}}}function f(q){return q.filter(te=>!!te)}e.coalesce=f;function w(q){let te=0;for(let ne=0;ne<q.length;ne++)q[ne]&&(q[te]=q[ne],te+=1);q.length=te}e.coalesceInPlace=w;function m(q,te,ne){q.splice(ne,0,q.splice(te,1)[0])}e.move=m;function u(q){return!Array.isArray(q)||q.length===0}e.isFalsyOrEmpty=u;function c(q){return Array.isArray(q)&&q.length>0}e.isNonEmptyArray=c;function s(q,te=ne=>ne){const ne=new Set;return q.filter(ce=>{const he=te(ce);return ne.has(he)?!1:(ne.add(he),!0)})}e.distinct=s;function r(q){const te=new Set;return ne=>{const ce=q(ne);return te.has(ce)?!1:(te.add(ce),!0)}}e.uniqueFilter=r;function i(q,te){const ne=n(q,te);if(ne!==-1)return q[ne]}e.findLast=i;function n(q,te){for(let ne=q.length-1;ne>=0;ne--){const ce=q[ne];if(te(ce))return ne}return-1}e.lastIndex=n;function o(q,te){return q.length>0?q[0]:te}e.firstOrDefault=o;function a(q,te){return q.length>0?q[q.length-1]:te}e.lastOrDefault=a;function l(q,te,ne=(ce,he)=>ce===he){let ce=0;for(let he=0,ke=Math.min(q.length,te.length);he<ke&&ne(q[he],te[he]);he++)ce++;return ce}e.commonPrefixLength=l;function P(q){return[].concat(...q)}e.flatten=P;function M(q,te){let ne=typeof te=="number"?q:0;typeof te=="number"?ne=q:(ne=0,te=q);const ce=[];if(ne<=te)for(let he=ne;he<te;he++)ce.push(he);else for(let he=ne;he>te;he--)ce.push(he);return ce}e.range=M;function T(q,te,ne){return q.reduce((ce,he)=>(ce[te(he)]=ne?ne(he):he,ce),Object.create(null))}e.index=T;function F(q,te){return q.push(te),()=>U(q,te)}e.insert=F;function U(q,te){const ne=q.indexOf(te);if(ne>-1)return q.splice(ne,1),te}e.remove=U;function Q(q,te,ne){const ce=q.slice(0,te),he=q.slice(te);return ce.concat(ne,he)}e.arrayInsert=Q;function re(q,te){let ne;if(typeof te=="number"){let ce=te;ne=()=>{const he=Math.sin(ce++)*179426549;return he-Math.floor(he)}}else ne=Math.random;for(let ce=q.length-1;ce>0;ce-=1){const he=Math.floor(ne()*(ce+1)),ke=q[ce];q[ce]=q[he],q[he]=ke}}e.shuffle=re;function ue(q,te){const ne=q.indexOf(te);ne>-1&&(q.splice(ne,1),q.unshift(te))}e.pushToStart=ue;function fe(q,te){const ne=q.indexOf(te);ne>-1&&(q.splice(ne,1),q.push(te))}e.pushToEnd=fe;function se(q,te){for(const ne of te)q.push(ne)}e.pushMany=se;function le(q,te){return Array.isArray(q)?q.map(te):te(q)}e.mapArrayOrNot=le;function K(q){return Array.isArray(q)?q:[q]}e.asArray=K;function N(q){return q[Math.floor(Math.random()*q.length)]}e.getRandomElement=N;function _(q,te){for(const ne of q){const ce=te(ne);if(ce!==void 0)return ce}}e.mapFind=_;function A(q,te,ne){const ce=$(q,te),he=q.length,ke=ne.length;q.length=he+ke;for(let Le=he-1;Le>=ce;Le--)q[Le+ke]=q[Le];for(let Le=0;Le<ke;Le++)q[Le+ce]=ne[Le]}e.insertInto=A;function W(q,te,ne,ce){const he=$(q,te),ke=q.splice(he,ne);return A(q,he,ce),ke}e.splice=W;function $(q,te){return te<0?Math.max(te+q.length,0):Math.min(te,q.length)}var Y;(function(q){function te(he){return he<0}q.isLessThan=te;function ne(he){return he>0}q.isGreaterThan=ne;function ce(he){return he===0}q.isNeitherLessOrGreaterThan=ce,q.greaterThan=1,q.lessThan=-1,q.neitherLessOrGreaterThan=0})(Y=e.CompareResult||(e.CompareResult={}));function z(q,te){return(ne,ce)=>te(q(ne),q(ce))}e.compareBy=z;function j(...q){return(te,ne)=>{for(const ce of q){const he=ce(te,ne);if(!Y.isNeitherLessOrGreaterThan(he))return he}return Y.neitherLessOrGreaterThan}}e.tieBreakComparators=j;const L=(q,te)=>q-te;e.numberComparator=L;function O(q,te){if(q.length===0)return;let ne=q[0];for(let ce=1;ce<q.length;ce++){const he=q[ce];te(he,ne)>0&&(ne=he)}return ne}e.findMaxBy=O;function B(q,te){if(q.length===0)return;let ne=q[0];for(let ce=1;ce<q.length;ce++){const he=q[ce];te(he,ne)>=0&&(ne=he)}return ne}e.findLastMaxBy=B;function V(q,te){return O(q,(ne,ce)=>-te(ne,ce))}e.findMinBy=V;class x{constructor(te){this.items=te,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(te){let ne=this.firstIdx;for(;ne<this.items.length&&te(this.items[ne]);)ne++;const ce=ne===this.firstIdx?null:this.items.slice(this.firstIdx,ne);return this.firstIdx=ne,ce}takeFromEndWhile(te){let ne=this.lastIdx;for(;ne>=0&&te(this.items[ne]);)ne--;const ce=ne===this.lastIdx?null:this.items.slice(ne+1,this.lastIdx+1);return this.lastIdx=ne,ce}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const te=this.items[this.firstIdx];return this.firstIdx++,te}removeLast(){const te=this.items[this.lastIdx];return this.lastIdx--,te}takeCount(te){const ne=this.items.slice(this.firstIdx,this.firstIdx+te);return this.firstIdx+=te,ne}}e.ArrayQueue=x;class ie{constructor(te){this.iterate=te}forEach(te){this.iterate(ne=>(te(ne),!0))}toArray(){const te=[];return this.iterate(ne=>(te.push(ne),!0)),te}filter(te){return new ie(ne=>this.iterate(ce=>te(ce)?ne(ce):!0))}map(te){return new ie(ne=>this.iterate(ce=>ne(te(ce))))}some(te){let ne=!1;return this.iterate(ce=>(ne=te(ce),!ne)),ne}findFirst(te){let ne;return this.iterate(ce=>te(ce)?(ne=ce,!1):!0),ne}findLast(te){let ne;return this.iterate(ce=>(te(ce)&&(ne=ce),!0)),ne}findLastMaxBy(te){let ne,ce=!0;return this.iterate(he=>((ce||Y.isGreaterThan(te(he,ne)))&&(ce=!1,ne=he),!0)),ne}}e.CallbackIterable=ie,ie.empty=new ie(q=>{})}),define(Z[48],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function v(t){const k=this;let R=!1,D;return function(){return R||(R=!0,D=t.apply(k,arguments)),D}}e.once=v}),define(Z[55],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var v;(function(t){function k(r){return r&&typeof r=="object"&&typeof r[Symbol.iterator]=="function"}t.is=k;const R=Object.freeze([]);function D(){return R}t.empty=D;function*y(r){yield r}t.single=y;function h(r){return r||R}t.from=h;function p(r){return!r||r[Symbol.iterator]().next().done===!0}t.isEmpty=p;function I(r){return r[Symbol.iterator]().next().value}t.first=I;function C(r,i){for(const n of r)if(i(n))return!0;return!1}t.some=C;function b(r,i){for(const n of r)if(i(n))return n}t.find=b;function*g(r,i){for(const n of r)i(n)&&(yield n)}t.filter=g;function*d(r,i){let n=0;for(const o of r)yield i(o,n++)}t.map=d;function*E(...r){for(const i of r)for(const n of i)yield n}t.concat=E;function*S(r){for(const i of r)for(const n of i)yield n}t.concatNested=S;function f(r,i,n){let o=n;for(const a of r)o=i(o,a);return o}t.reduce=f;function w(r,i){let n=0;for(const o of r)i(o,n++)}t.forEach=w;function*m(r,i,n=r.length){for(i<0&&(i+=r.length),n<0?n+=r.length:n>r.length&&(n=r.length);i<n;i++)yield r[i]}t.slice=m;function u(r,i=Number.POSITIVE_INFINITY){const n=[];if(i===0)return[n,r];const o=r[Symbol.iterator]();for(let a=0;a<i;a++){const l=o.next();if(l.done)return[n,t.empty()];n.push(l.value)}return[n,{[Symbol.iterator](){return o}}]}t.consume=u;function c(r){return u(r)[0]}t.collect=c;function s(r,i,n=(o,a)=>o===a){const o=r[Symbol.iterator](),a=i[Symbol.iterator]();for(;;){const l=o.next(),P=a.next();if(l.done!==P.done)return!1;if(l.done)return!0;if(!n(l.value,P.value))return!1}}t.equals=s})(v=e.Iterable||(e.Iterable={}))}),define(Z[42],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var v;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(v=e.ScanError||(e.ScanError={}));var t;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var R;(function(s){s.DEFAULT={allowTrailingComma:!0}})(R=e.ParseOptions||(e.ParseOptions={}));function D(s,r=!1){let i=0;const n=s.length;let o="",a=0,l=16,P=0;function M(fe){let se=0,le=0;for(;se<fe;){const K=s.charCodeAt(i);if(K>=48&&K<=57)le=le*16+K-48;else if(K>=65&&K<=70)le=le*16+K-65+10;else if(K>=97&&K<=102)le=le*16+K-97+10;else break;i++,se++}return se<fe&&(le=-1),le}function T(fe){i=fe,o="",a=0,l=16,P=0}function F(){const fe=i;if(s.charCodeAt(i)===48)i++;else for(i++;i<s.length&&p(s.charCodeAt(i));)i++;if(i<s.length&&s.charCodeAt(i)===46)if(i++,i<s.length&&p(s.charCodeAt(i)))for(i++;i<s.length&&p(s.charCodeAt(i));)i++;else return P=3,s.substring(fe,i);let se=i;if(i<s.length&&(s.charCodeAt(i)===69||s.charCodeAt(i)===101))if(i++,(i<s.length&&s.charCodeAt(i)===43||s.charCodeAt(i)===45)&&i++,i<s.length&&p(s.charCodeAt(i))){for(i++;i<s.length&&p(s.charCodeAt(i));)i++;se=i}else P=3;return s.substring(fe,se)}function U(){let fe="",se=i;for(;;){if(i>=n){fe+=s.substring(se,i),P=2;break}const le=s.charCodeAt(i);if(le===34){fe+=s.substring(se,i),i++;break}if(le===92){if(fe+=s.substring(se,i),i++,i>=n){P=2;break}switch(s.charCodeAt(i++)){case 34:fe+='"';break;case 92:fe+="\\";break;case 47:fe+="/";break;case 98:fe+="\b";break;case 102:fe+="\f";break;case 110:fe+=`
`;break;case 114:fe+="\r";break;case 116:fe+="	";break;case 117:{const N=M(4);N>=0?fe+=String.fromCharCode(N):P=4;break}default:P=5}se=i;continue}if(le>=0&&le<=31)if(h(le)){fe+=s.substring(se,i),P=2;break}else P=6;i++}return fe}function Q(){if(o="",P=0,a=i,i>=n)return a=n,l=17;let fe=s.charCodeAt(i);if(y(fe)){do i++,o+=String.fromCharCode(fe),fe=s.charCodeAt(i);while(y(fe));return l=15}if(h(fe))return i++,o+=String.fromCharCode(fe),fe===13&&s.charCodeAt(i)===10&&(i++,o+=`
`),l=14;switch(fe){case 123:return i++,l=1;case 125:return i++,l=2;case 91:return i++,l=3;case 93:return i++,l=4;case 58:return i++,l=6;case 44:return i++,l=5;case 34:return i++,o=U(),l=10;case 47:{const se=i-1;if(s.charCodeAt(i+1)===47){for(i+=2;i<n&&!h(s.charCodeAt(i));)i++;return o=s.substring(se,i),l=12}if(s.charCodeAt(i+1)===42){i+=2;const le=n-1;let K=!1;for(;i<le;){if(s.charCodeAt(i)===42&&s.charCodeAt(i+1)===47){i+=2,K=!0;break}i++}return K||(i++,P=1),o=s.substring(se,i),l=13}return o+=String.fromCharCode(fe),i++,l=16}case 45:if(o+=String.fromCharCode(fe),i++,i===n||!p(s.charCodeAt(i)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=F(),l=11;default:for(;i<n&&re(fe);)i++,fe=s.charCodeAt(i);if(a!==i){switch(o=s.substring(a,i),o){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return o+=String.fromCharCode(fe),i++,l=16}}function re(fe){if(y(fe)||h(fe))return!1;switch(fe){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ue(){let fe;do fe=Q();while(fe>=12&&fe<=15);return fe}return{setPosition:T,getPosition:()=>i,scan:r?ue:Q,getToken:()=>l,getTokenValue:()=>o,getTokenOffset:()=>a,getTokenLength:()=>i-a,getTokenError:()=>P}}e.createScanner=D;function y(s){return s===32||s===9||s===11||s===12||s===160||s===5760||s>=8192&&s<=8203||s===8239||s===8287||s===12288||s===65279}function h(s){return s===10||s===13||s===8232||s===8233}function p(s){return s>=48&&s<=57}var I;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(I||(I={}));function C(s,r){const i=[],n=new Object;let o;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function P(M,T,F,U){a.value=M,a.offset=T,a.length=F,a.type=U,a.colonOffset=void 0,o=a}try{m(s,{onObjectBegin:(M,T)=>{if(r<=M)throw n;o=void 0,l=r>M,i.push("")},onObjectProperty:(M,T,F)=>{if(r<T||(P(M,T,F,"property"),i[i.length-1]=M,r<=T+F))throw n},onObjectEnd:(M,T)=>{if(r<=M)throw n;o=void 0,i.pop()},onArrayBegin:(M,T)=>{if(r<=M)throw n;o=void 0,i.push(0)},onArrayEnd:(M,T)=>{if(r<=M)throw n;o=void 0,i.pop()},onLiteralValue:(M,T,F)=>{if(r<T||(P(M,T,F,c(M)),r<=T+F))throw n},onSeparator:(M,T,F)=>{if(r<=T)throw n;if(M===":"&&o&&o.type==="property")o.colonOffset=T,l=!1,o=void 0;else if(M===","){const U=i[i.length-1];typeof U=="number"?i[i.length-1]=U+1:(l=!0,i[i.length-1]=""),o=void 0}}})}catch(M){if(M!==n)throw M}return{path:i,previousNode:o,isAtPropertyKey:l,matches:M=>{let T=0;for(let F=0;T<M.length&&F<i.length;F++)if(M[T]===i[F]||M[T]==="*")T++;else if(M[T]!=="**")return!1;return T===M.length}}}e.getLocation=C;function b(s,r=[],i=R.DEFAULT){let n=null,o=[];const a=[];function l(M){Array.isArray(o)?o.push(M):n!==null&&(o[n]=M)}return m(s,{onObjectBegin:()=>{const M={};l(M),a.push(o),o=M,n=null},onObjectProperty:M=>{n=M},onObjectEnd:()=>{o=a.pop()},onArrayBegin:()=>{const M=[];l(M),a.push(o),o=M,n=null},onArrayEnd:()=>{o=a.pop()},onLiteralValue:l,onError:(M,T,F)=>{r.push({error:M,offset:T,length:F})}},i),o[0]}e.parse=b;function g(s,r=[],i=R.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(M){n.type==="property"&&(n.length=M-n.offset,n=n.parent)}function a(M){return n.children.push(M),M}m(s,{onObjectBegin:M=>{n=a({type:"object",offset:M,length:-1,parent:n,children:[]})},onObjectProperty:(M,T,F)=>{n=a({type:"property",offset:T,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:M,offset:T,length:F,parent:n})},onObjectEnd:(M,T)=>{n.length=M+T-n.offset,n=n.parent,o(M+T)},onArrayBegin:(M,T)=>{n=a({type:"array",offset:M,length:-1,parent:n,children:[]})},onArrayEnd:(M,T)=>{n.length=M+T-n.offset,n=n.parent,o(M+T)},onLiteralValue:(M,T,F)=>{a({type:c(M),offset:T,length:F,parent:n,value:M}),o(T+F)},onSeparator:(M,T,F)=>{n.type==="property"&&(M===":"?n.colonOffset=T:M===","&&o(T))},onError:(M,T,F)=>{r.push({error:M,offset:T,length:F})}},i);const P=n.children[0];return P&&delete P.parent,P}e.parseTree=g;function d(s,r){if(!s)return;let i=s;for(const n of r)if(typeof n=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let o=!1;for(const a of i.children)if(Array.isArray(a.children)&&a.children[0].value===n){i=a.children[1],o=!0;break}if(!o)return}else{const o=n;if(i.type!=="array"||o<0||!Array.isArray(i.children)||o>=i.children.length)return;i=i.children[o]}return i}e.findNodeAtLocation=d;function E(s){if(!s.parent||!s.parent.children)return[];const r=E(s.parent);if(s.parent.type==="property"){const i=s.parent.children[0].value;r.push(i)}else if(s.parent.type==="array"){const i=s.parent.children.indexOf(s);i!==-1&&r.push(i)}return r}e.getNodePath=E;function S(s){switch(s.type){case"array":return s.children.map(S);case"object":{const r=Object.create(null);for(const i of s.children){const n=i.children[1];n&&(r[i.children[0].value]=S(n))}return r}case"null":case"string":case"number":case"boolean":return s.value;default:return}}e.getNodeValue=S;function f(s,r,i=!1){return r>=s.offset&&r<s.offset+s.length||i&&r===s.offset+s.length}e.contains=f;function w(s,r,i=!1){if(f(s,r,i)){const n=s.children;if(Array.isArray(n))for(let o=0;o<n.length&&n[o].offset<=r;o++){const a=w(n[o],r,i);if(a)return a}return s}}e.findNodeAtOffset=w;function m(s,r,i=R.DEFAULT){const n=D(s,!1);function o(z){return z?()=>z(n.getTokenOffset(),n.getTokenLength()):()=>!0}function a(z){return z?j=>z(j,n.getTokenOffset(),n.getTokenLength()):()=>!0}const l=o(r.onObjectBegin),P=a(r.onObjectProperty),M=o(r.onObjectEnd),T=o(r.onArrayBegin),F=o(r.onArrayEnd),U=a(r.onLiteralValue),Q=a(r.onSeparator),re=o(r.onComment),ue=a(r.onError),fe=i&&i.disallowComments,se=i&&i.allowTrailingComma;function le(){for(;;){const z=n.scan();switch(n.getTokenError()){case 4:K(14);break;case 5:K(15);break;case 3:K(13);break;case 1:fe||K(11);break;case 2:K(12);break;case 6:K(16);break}switch(z){case 12:case 13:fe?K(10):re();break;case 16:K(1);break;case 15:case 14:break;default:return z}}}function K(z,j=[],L=[]){if(ue(z),j.length+L.length>0){let O=n.getToken();for(;O!==17;){if(j.indexOf(O)!==-1){le();break}else if(L.indexOf(O)!==-1)break;O=le()}}}function N(z){const j=n.getTokenValue();return z?U(j):P(j),le(),!0}function _(){switch(n.getToken()){case 11:{let z=0;try{z=JSON.parse(n.getTokenValue()),typeof z!="number"&&(K(2),z=0)}catch{K(2)}U(z);break}case 7:U(null);break;case 8:U(!0);break;case 9:U(!1);break;default:return!1}return le(),!0}function A(){return n.getToken()!==10?(K(3,[],[2,5]),!1):(N(!1),n.getToken()===6?(Q(":"),le(),Y()||K(4,[],[2,5])):K(5,[],[2,5]),!0)}function W(){l(),le();let z=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(z||K(4,[],[]),Q(","),le(),n.getToken()===2&&se)break}else z&&K(6,[],[]);A()||K(4,[],[2,5]),z=!0}return M(),n.getToken()!==2?K(7,[2],[]):le(),!0}function $(){T(),le();let z=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(z||K(4,[],[]),Q(","),le(),n.getToken()===4&&se)break}else z&&K(6,[],[]);Y()||K(4,[],[4,5]),z=!0}return F(),n.getToken()!==4?K(8,[4],[]):le(),!0}function Y(){switch(n.getToken()){case 3:return $();case 1:return W();case 10:return N(!0);default:return _()}}return le(),n.getToken()===17?i.allowEmptyContent?!0:(K(4,[],[]),!1):Y()?(n.getToken()!==17&&K(9,[],[]),!0):(K(4,[],[]),!1)}e.visit=m;function u(s,r){const i=D(s),n=[];let o,a=0,l;do switch(l=i.getPosition(),o=i.scan(),o){case 12:case 13:case 17:a!==l&&n.push(s.substring(a,l)),r!==void 0&&n.push(i.getTokenValue().replace(/[^\r\n]/g,r)),a=i.getPosition();break}while(o!==17);return n.join("")}e.stripComments=u;function c(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=c}),define(Z[123],ee([0,1,42]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function t(p,I,C){let b,g,d,E,S;if(I){for(E=I.offset,S=E+I.length,d=E;d>0&&!h(p,d-1);)d--;let l=S;for(;l<p.length&&!h(p,l);)l++;g=p.substring(d,l),b=D(g,C)}else g=p,b=0,d=0,E=0,S=p.length;const f=y(C,p);let w=!1,m=0,u;C.insertSpaces?u=R(" ",C.tabSize||4):u="	";const c=(0,v.createScanner)(g,!1);let s=!1;function r(){return f+R(u,b+m)}function i(){let l=c.scan();for(w=!1;l===15||l===14;)w=w||l===14,l=c.scan();return s=l===16||c.getTokenError()!==0,l}const n=[];function o(l,P,M){!s&&P<S&&M>E&&p.substring(P,M)!==l&&n.push({offset:P,length:M-P,content:l})}let a=i();if(a!==17){const l=c.getTokenOffset()+d,P=R(u,b);o(P,d,l)}for(;a!==17;){let l=c.getTokenOffset()+c.getTokenLength()+d,P=i(),M="";for(;!w&&(P===12||P===13);){const F=c.getTokenOffset()+d;o(" ",l,F),l=c.getTokenOffset()+c.getTokenLength()+d,M=P===12?r():"",P=i()}if(P===2)a!==1&&(m--,M=r());else if(P===4)a!==3&&(m--,M=r());else{switch(a){case 3:case 1:m++,M=r();break;case 5:case 12:M=r();break;case 13:w?M=r():M=" ";break;case 6:M=" ";break;case 10:if(P===6){M="";break}case 7:case 8:case 9:case 11:case 2:case 4:P===12||P===13?M=" ":P!==5&&P!==17&&(s=!0);break;case 16:s=!0;break}w&&(P===12||P===13)&&(M=r())}const T=c.getTokenOffset()+d;o(M,l,T),a=P}return n}e.format=t;function k(p,I){const C=JSON.stringify(p,void 0,I.insertSpaces?I.tabSize||4:"	");return I.eol!==void 0?C.replace(/\r\n|\r|\n/g,I.eol):C}e.toFormattedString=k;function R(p,I){let C="";for(let b=0;b<I;b++)C+=p;return C}function D(p,I){let C=0,b=0;const g=I.tabSize||4;for(;C<p.length;){const d=p.charAt(C);if(d===" ")b++;else if(d==="	")b+=g;else break;C++}return Math.floor(b/g)}function y(p,I){for(let C=0;C<I.length;C++){const b=I.charAt(C);if(b==="\r")return C+1<I.length&&I.charAt(C+1)===`
`?`\r
`:"\r";if(b===`
`)return`
`}return p&&p.eol||`
`}e.getEOL=y;function h(p,I){return`\r
`.indexOf(p.charAt(I))!==-1}e.isEOL=h}),define(Z[124],ee([0,1,42,123]),function(H,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function k(p,I,C){return R(p,I,void 0,C)}e.removeProperty=k;function R(p,I,C,b,g){const d=I.slice(),E=[],S=(0,v.parseTree)(p,E);let f,w;for(;d.length>0&&(w=d.pop(),f=(0,v.findNodeAtLocation)(S,d),f===void 0&&C!==void 0);)typeof w=="string"?C={[w]:C}:C=[C];if(f)if(f.type==="object"&&typeof w=="string"&&Array.isArray(f.children)){const m=(0,v.findNodeAtLocation)(f,[w]);if(m!==void 0)if(C===void 0){if(!m.parent)throw new Error("Malformed AST");const u=f.children.indexOf(m.parent);let c,s=m.parent.offset+m.parent.length;if(u>0){const r=f.children[u-1];c=r.offset+r.length}else c=f.offset+1,f.children.length>1&&(s=f.children[1].offset);return D(p,{offset:c,length:s-c,content:""},b)}else return D(p,{offset:m.offset,length:m.length,content:JSON.stringify(C)},b);else{if(C===void 0)return[];const u=`${JSON.stringify(w)}: ${JSON.stringify(C)}`,c=g?g(f.children.map(r=>r.children[0].value)):f.children.length;let s;if(c>0){const r=f.children[c-1];s={offset:r.offset+r.length,length:0,content:","+u}}else f.children.length===0?s={offset:f.offset+1,length:0,content:u}:s={offset:f.offset+1,length:0,content:u+","};return D(p,s,b)}}else if(f.type==="array"&&typeof w=="number"&&Array.isArray(f.children))if(C!==void 0){const m=`${JSON.stringify(C)}`;let u;if(f.children.length===0||w===0)u={offset:f.offset+1,length:0,content:f.children.length===0?m:m+","};else{const c=w===-1||w>f.children.length?f.children.length:w,s=f.children[c-1];u={offset:s.offset+s.length,length:0,content:","+m}}return D(p,u,b)}else{const m=w,u=f.children[m];let c;if(f.children.length===1)c={offset:f.offset+1,length:f.length-2,content:""};else if(f.children.length-1===m){const s=f.children[m-1],r=s.offset+s.length,i=f.offset+f.length;c={offset:r,length:i-2-r,content:""}}else c={offset:u.offset,length:f.children[m+1].offset-u.offset,content:""};return D(p,c,b)}else throw new Error(`Can not add ${typeof w!="number"?"index":"property"} to parent of type ${f.type}`);else{if(C===void 0)throw new Error("Can not delete in empty document");return D(p,{offset:S?S.offset:0,length:S?S.length:0,content:JSON.stringify(C)},b)}}e.setProperty=R;function D(p,I,C){let b=y(p,I),g=I.offset,d=I.offset+I.content.length;if(I.length===0||I.content.length===0){for(;g>0&&!(0,t.isEOL)(b,g-1);)g--;for(;d<b.length&&!(0,t.isEOL)(b,d);)d++}const E=(0,t.format)(b,{offset:g,length:d-g},C);for(let f=E.length-1;f>=0;f--){const w=E[f];b=y(b,w),g=Math.min(g,w.offset),d=Math.max(d,w.offset+w.length),d+=w.content.length-w.length}const S=p.length-(b.length-d)-g;return[{offset:g,length:S,content:b.substring(g,d)}]}e.withFormatting=D;function y(p,I){return p.substring(0,I.offset)+I.content+p.substring(I.offset+I.length)}e.applyEdit=y;function h(p,I){const C=I.slice(0).sort((g,d)=>{const E=g.offset-d.offset;return E===0?g.length-d.length:E});let b=p.length;for(let g=C.length-1;g>=0;g--){const d=C[g];if(d.offset+d.length<=b)p=y(p,d);else throw new Error("Overlapping edit");b=d.offset}return p}e.applyEdits=h}),define(Z[125],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class v{constructor(k){this.executor=k,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(k){this._error=k}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(k){return new v(()=>k(this.getValue()))}}e.Lazy=v}),define(Z[2],ee([0,1,48,55]),function(H,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const k=!1;let R=null;function D(o){R=o}if(e.setDisposableTracker=D,k){const o="__is_disposable_tracked__";D(new class{trackDisposable(a){const l=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[o]||console.log(l)},3e3)}setParent(a,l){if(a&&a!==w.None)try{a[o]=!0}catch{}}markAsDisposed(a){if(a&&a!==w.None)try{a[o]=!0}catch{}}markAsSingleton(a){}})}function y(o){return R?.trackDisposable(o),o}function h(o){R?.markAsDisposed(o)}function p(o,a){R?.setParent(o,a)}function I(o,a){if(!!R)for(const l of o)R.setParent(l,a)}function C(o){return R?.markAsSingleton(o),o}e.markAsSingleton=C;class b extends Error{constructor(a){super(`Encountered errors while disposing of store. Errors: [${a.join(", ")}]`);this.errors=a}}e.MultiDisposeError=b;function g(o){return typeof o.dispose=="function"&&o.dispose.length===0}e.isDisposable=g;function d(o){if(t.Iterable.is(o)){const a=[];for(const l of o)if(l)try{l.dispose()}catch(P){a.push(P)}if(a.length===1)throw a[0];if(a.length>1)throw new b(a);return Array.isArray(o)?[]:o}else if(o)return o.dispose(),o}e.dispose=d;function E(...o){const a=S(()=>d(o));return I(o,a),a}e.combinedDisposable=E;function S(o){const a=y({dispose:(0,v.once)(()=>{h(a),o()})});return a}e.toDisposable=S;class f{constructor(){this._toDispose=new Set,this._isDisposed=!1,y(this)}dispose(){this._isDisposed||(h(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{d(this._toDispose.values())}finally{this._toDispose.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return p(a,this),this._isDisposed?f.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(a),a}}e.DisposableStore=f,f.DISABLE_DISPOSED_WARNING=!1;class w{constructor(){this._store=new f,y(this),p(this._store,this)}dispose(){h(this),this._store.dispose()}_register(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(a)}}e.Disposable=w,w.None=Object.freeze({dispose(){}});class m{constructor(){this._isDisposed=!1,y(this)}get value(){return this._isDisposed?void 0:this._value}set value(a){this._isDisposed||a===this._value||(this._value?.dispose(),a&&p(a,this),this._value=a)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,h(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const a=this._value;return this._value=void 0,a&&p(a,null),a}}e.MutableDisposable=m;class u{constructor(a){this._disposable=a,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=u;class c{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,y(this)}set(a){let l=a;return this.unset=()=>l=void 0,this.isset=()=>l!==void 0,this.dispose=()=>{l&&(l(),l=void 0,h(this))},this}}e.SafeDisposable=c;class s{constructor(){this.references=new Map}acquire(a,...l){let P=this.references.get(a);P||(P={counter:0,object:this.createReferencedObject(a,...l)},this.references.set(a,P));const{object:M}=P,T=(0,v.once)(()=>{--P.counter==0&&(this.destroyReferencedObject(a,P.object),this.references.delete(a))});return P.counter++,{object:M,dispose:T}}}e.ReferenceCollection=s;class r{constructor(a){this.referenceCollection=a}async acquire(a,...l){const P=this.referenceCollection.acquire(a,...l);try{return{object:await P.object,dispose:()=>P.dispose()}}catch(M){throw P.dispose(),M}}}e.AsyncReferenceCollection=r;class i{constructor(a){this.object=a}dispose(){}}e.ImmortalReference=i;function n(o){const a=new f;try{o(a)}finally{a.dispose()}}e.disposeOnReturn=n}),define(Z[126],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class v{constructor(R){this.element=R,this.next=v.Undefined,this.prev=v.Undefined}}v.Undefined=new v(void 0);class t{constructor(){this._first=v.Undefined,this._last=v.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===v.Undefined}clear(){let R=this._first;for(;R!==v.Undefined;){const D=R.next;R.prev=v.Undefined,R.next=v.Undefined,R=D}this._first=v.Undefined,this._last=v.Undefined,this._size=0}unshift(R){return this._insert(R,!1)}push(R){return this._insert(R,!0)}_insert(R,D){const y=new v(R);if(this._first===v.Undefined)this._first=y,this._last=y;else if(D){const p=this._last;this._last=y,y.prev=p,p.next=y}else{const p=this._first;this._first=y,y.next=p,p.prev=y}this._size+=1;let h=!1;return()=>{h||(h=!0,this._remove(y))}}shift(){if(this._first!==v.Undefined){const R=this._first.element;return this._remove(this._first),R}}pop(){if(this._last!==v.Undefined){const R=this._last.element;return this._remove(this._last),R}}_remove(R){if(R.prev!==v.Undefined&&R.next!==v.Undefined){const D=R.prev;D.next=R.next,R.next.prev=D}else R.prev===v.Undefined&&R.next===v.Undefined?(this._first=v.Undefined,this._last=v.Undefined):R.next===v.Undefined?(this._last=this._last.prev,this._last.next=v.Undefined):R.prev===v.Undefined&&(this._first=this._first.next,this._first.prev=v.Undefined);this._size-=1}*[Symbol.iterator](){let R=this._first;for(;R!==v.Undefined;)yield R.element,R=R.next}}e.LinkedList=t}),function(){function H(k){const R=[];typeof k=="number"&&R.push("code/timeOrigin",k);function D(h){R.push(h,Date.now())}function y(){const h=[];for(let p=0;p<R.length;p+=2)h.push({name:R[p],startTime:R[p+1]});return h}return{mark:D,getMarks:y}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?H():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const D of performance.getEntriesByType("mark"))R.push({name:D.name,startTime:Math.round(k+D.startTime)});return R}};if(typeof process=="object"){const k=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return H(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),H()}function v(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return v(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=v(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=v(t))}(),function(H,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var v=e();for(var t in v)(typeof exports=="object"?exports:H)[t]=v[t]}}(typeof self!="undefined"?self:this,function(){return function(H){var e={};function v(t){if(e[t])return e[t].exports;var k=e[t]={i:t,l:!1,exports:{}};return H[t].call(k.exports,k,k.exports,v),k.l=!0,k.exports}return v.m=H,v.c=e,v.d=function(t,k,R){v.o(t,k)||Object.defineProperty(t,k,{enumerable:!0,get:R})},v.r=function(t){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},v.t=function(t,k){if(1&k&&(t=v(t)),8&k||4&k&&typeof t=="object"&&t&&t.__esModule)return t;var R=Object.create(null);if(v.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:t}),2&k&&typeof t!="string")for(var D in t)v.d(R,D,function(y){return t[y]}.bind(null,D));return R},v.n=function(t){var k=t&&t.__esModule?function(){return t.default}:function(){return t};return v.d(k,"a",k),k},v.o=function(t,k){return Object.prototype.hasOwnProperty.call(t,k)},v.p="",v(v.s=0)}([function(H,e,v){(function(t){var k;e=H.exports=L,k=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var X=Array.prototype.slice.call(arguments,0);X.unshift("SEMVER"),console.log.apply(console,X)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,y=e.re=[],h=e.src=[],p=0,I=p++;h[I]="0|[1-9]\\d*";var C=p++;h[C]="[0-9]+";var b=p++;h[b]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var g=p++;h[g]="("+h[I]+")\\.("+h[I]+")\\.("+h[I]+")";var d=p++;h[d]="("+h[C]+")\\.("+h[C]+")\\.("+h[C]+")";var E=p++;h[E]="(?:"+h[I]+"|"+h[b]+")";var S=p++;h[S]="(?:"+h[C]+"|"+h[b]+")";var f=p++;h[f]="(?:-("+h[E]+"(?:\\."+h[E]+")*))";var w=p++;h[w]="(?:-?("+h[S]+"(?:\\."+h[S]+")*))";var m=p++;h[m]="[0-9A-Za-z-]+";var u=p++;h[u]="(?:\\+("+h[m]+"(?:\\."+h[m]+")*))";var c=p++,s="v?"+h[g]+h[f]+"?"+h[u]+"?";h[c]="^"+s+"$";var r="[v=\\s]*"+h[d]+h[w]+"?"+h[u]+"?",i=p++;h[i]="^"+r+"$";var n=p++;h[n]="((?:<|>)?=?)";var o=p++;h[o]=h[C]+"|x|X|\\*";var a=p++;h[a]=h[I]+"|x|X|\\*";var l=p++;h[l]="[v=\\s]*("+h[a]+")(?:\\.("+h[a]+")(?:\\.("+h[a]+")(?:"+h[f]+")?"+h[u]+"?)?)?";var P=p++;h[P]="[v=\\s]*("+h[o]+")(?:\\.("+h[o]+")(?:\\.("+h[o]+")(?:"+h[w]+")?"+h[u]+"?)?)?";var M=p++;h[M]="^"+h[n]+"\\s*"+h[l]+"$";var T=p++;h[T]="^"+h[n]+"\\s*"+h[P]+"$";var F=p++;h[F]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var U=p++;h[U]="(?:~>?)";var Q=p++;h[Q]="(\\s*)"+h[U]+"\\s+",y[Q]=new RegExp(h[Q],"g");var re=p++;h[re]="^"+h[U]+h[l]+"$";var ue=p++;h[ue]="^"+h[U]+h[P]+"$";var fe=p++;h[fe]="(?:\\^)";var se=p++;h[se]="(\\s*)"+h[fe]+"\\s+",y[se]=new RegExp(h[se],"g");var le=p++;h[le]="^"+h[fe]+h[l]+"$";var K=p++;h[K]="^"+h[fe]+h[P]+"$";var N=p++;h[N]="^"+h[n]+"\\s*("+r+")$|^$";var _=p++;h[_]="^"+h[n]+"\\s*("+s+")$|^$";var A=p++;h[A]="(\\s*)"+h[n]+"\\s*("+r+"|"+h[l]+")",y[A]=new RegExp(h[A],"g");var W=p++;h[W]="^\\s*("+h[l]+")\\s+-\\s+("+h[l]+")\\s*$";var $=p++;h[$]="^\\s*("+h[P]+")\\s+-\\s+("+h[P]+")\\s*$";var Y=p++;h[Y]="(<|>)?=?\\s*\\*";for(var z=0;z<35;z++)k(z,h[z]),y[z]||(y[z]=new RegExp(h[z]));function j(X,oe){if(X instanceof L)return X;if(typeof X!="string"||X.length>R||!(oe?y[i]:y[c]).test(X))return null;try{return new L(X,oe)}catch{return null}}function L(X,oe){if(X instanceof L){if(X.loose===oe)return X;X=X.version}else if(typeof X!="string")throw new TypeError("Invalid Version: "+X);if(X.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof L))return new L(X,oe);k("SemVer",X,oe),this.loose=oe;var de=X.trim().match(oe?y[i]:y[c]);if(!de)throw new TypeError("Invalid Version: "+X);if(this.raw=X,this.major=+de[1],this.minor=+de[2],this.patch=+de[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");de[4]?this.prerelease=de[4].split(".").map(function(ye){if(/^[0-9]+$/.test(ye)){var Ce=+ye;if(Ce>=0&&Ce<D)return Ce}return ye}):this.prerelease=[],this.build=de[5]?de[5].split("."):[],this.format()}e.parse=j,e.valid=function(X,oe){var de=j(X,oe);return de?de.version:null},e.clean=function(X,oe){var de=j(X.trim().replace(/^[=v]+/,""),oe);return de?de.version:null},e.SemVer=L,L.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},L.prototype.toString=function(){return this.version},L.prototype.compare=function(X){return k("SemVer.compare",this.version,this.loose,X),X instanceof L||(X=new L(X,this.loose)),this.compareMain(X)||this.comparePre(X)},L.prototype.compareMain=function(X){return X instanceof L||(X=new L(X,this.loose)),B(this.major,X.major)||B(this.minor,X.minor)||B(this.patch,X.patch)},L.prototype.comparePre=function(X){if(X instanceof L||(X=new L(X,this.loose)),this.prerelease.length&&!X.prerelease.length)return-1;if(!this.prerelease.length&&X.prerelease.length)return 1;if(!this.prerelease.length&&!X.prerelease.length)return 0;var oe=0;do{var de=this.prerelease[oe],ye=X.prerelease[oe];if(k("prerelease compare",oe,de,ye),de===void 0&&ye===void 0)return 0;if(ye===void 0)return 1;if(de===void 0)return-1;if(de!==ye)return B(de,ye)}while(++oe)},L.prototype.inc=function(X,oe){switch(X){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",oe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",oe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",oe),this.inc("pre",oe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",oe),this.inc("pre",oe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var de=this.prerelease.length;--de>=0;)typeof this.prerelease[de]=="number"&&(this.prerelease[de]++,de=-2);de===-1&&this.prerelease.push(0)}oe&&(this.prerelease[0]===oe?isNaN(this.prerelease[1])&&(this.prerelease=[oe,0]):this.prerelease=[oe,0]);break;default:throw new Error("invalid increment argument: "+X)}return this.format(),this.raw=this.version,this},e.inc=function(X,oe,de,ye){typeof de=="string"&&(ye=de,de=void 0);try{return new L(X,de).inc(oe,ye).version}catch{return null}},e.diff=function(X,oe){if(q(X,oe))return null;var de=j(X),ye=j(oe);if(de.prerelease.length||ye.prerelease.length){for(var Ce in de)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&de[Ce]!==ye[Ce])return"pre"+Ce;return"prerelease"}for(var Ce in de)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&de[Ce]!==ye[Ce])return Ce},e.compareIdentifiers=B;var O=/^[0-9]+$/;function B(X,oe){var de=O.test(X),ye=O.test(oe);return de&&ye&&(X=+X,oe=+oe),de&&!ye?-1:ye&&!de?1:X<oe?-1:X>oe?1:0}function V(X,oe,de){return new L(X,de).compare(new L(oe,de))}function x(X,oe,de){return V(X,oe,de)>0}function ie(X,oe,de){return V(X,oe,de)<0}function q(X,oe,de){return V(X,oe,de)===0}function te(X,oe,de){return V(X,oe,de)!==0}function ne(X,oe,de){return V(X,oe,de)>=0}function ce(X,oe,de){return V(X,oe,de)<=0}function he(X,oe,de,ye){var Ce;switch(oe){case"===":typeof X=="object"&&(X=X.version),typeof de=="object"&&(de=de.version),Ce=X===de;break;case"!==":typeof X=="object"&&(X=X.version),typeof de=="object"&&(de=de.version),Ce=X!==de;break;case"":case"=":case"==":Ce=q(X,de,ye);break;case"!=":Ce=te(X,de,ye);break;case">":Ce=x(X,de,ye);break;case">=":Ce=ne(X,de,ye);break;case"<":Ce=ie(X,de,ye);break;case"<=":Ce=ce(X,de,ye);break;default:throw new TypeError("Invalid operator: "+oe)}return Ce}function ke(X,oe){if(X instanceof ke){if(X.loose===oe)return X;X=X.value}if(!(this instanceof ke))return new ke(X,oe);k("comparator",X,oe),this.loose=oe,this.parse(X),this.semver===Le?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(X,oe){return B(oe,X)},e.major=function(X,oe){return new L(X,oe).major},e.minor=function(X,oe){return new L(X,oe).minor},e.patch=function(X,oe){return new L(X,oe).patch},e.compare=V,e.compareLoose=function(X,oe){return V(X,oe,!0)},e.rcompare=function(X,oe,de){return V(oe,X,de)},e.sort=function(X,oe){return X.sort(function(de,ye){return e.compare(de,ye,oe)})},e.rsort=function(X,oe){return X.sort(function(de,ye){return e.rcompare(de,ye,oe)})},e.gt=x,e.lt=ie,e.eq=q,e.neq=te,e.gte=ne,e.lte=ce,e.cmp=he,e.Comparator=ke;var Le={};function Me(X,oe){if(X instanceof Me)return X.loose===oe?X:new Me(X.raw,oe);if(X instanceof ke)return new Me(X.value,oe);if(!(this instanceof Me))return new Me(X,oe);if(this.loose=oe,this.raw=X,this.set=X.split(/\s*\|\|\s*/).map(function(de){return this.parseRange(de.trim())},this).filter(function(de){return de.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+X);this.format()}function Ae(X){return!X||X.toLowerCase()==="x"||X==="*"}function je(X,oe,de,ye,Ce,Te,Oe,Be,Ne,Ue,qe,G,ae){return((oe=Ae(de)?"":Ae(ye)?">="+de+".0.0":Ae(Ce)?">="+de+"."+ye+".0":">="+oe)+" "+(Be=Ae(Ne)?"":Ae(Ue)?"<"+(+Ne+1)+".0.0":Ae(qe)?"<"+Ne+"."+(+Ue+1)+".0":G?"<="+Ne+"."+Ue+"."+qe+"-"+G:"<="+Be)).trim()}function me(X,oe){for(var de=0;de<X.length;de++)if(!X[de].test(oe))return!1;if(oe.prerelease.length){for(de=0;de<X.length;de++)if(k(X[de].semver),X[de].semver!==Le&&X[de].semver.prerelease.length>0){var ye=X[de].semver;if(ye.major===oe.major&&ye.minor===oe.minor&&ye.patch===oe.patch)return!0}return!1}return!0}function pe(X,oe,de){try{oe=new Me(oe,de)}catch{return!1}return oe.test(X)}function Ee(X,oe,de,ye){var Ce,Te,Oe,Be,Ne;switch(X=new L(X,ye),oe=new Me(oe,ye),de){case">":Ce=x,Te=ce,Oe=ie,Be=">",Ne=">=";break;case"<":Ce=ie,Te=ne,Oe=x,Be="<",Ne="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(pe(X,oe,ye))return!1;for(var Ue=0;Ue<oe.set.length;++Ue){var qe=oe.set[Ue],G=null,ae=null;if(qe.forEach(function(ge){ge.semver===Le&&(ge=new ke(">=0.0.0")),G=G||ge,ae=ae||ge,Ce(ge.semver,G.semver,ye)?G=ge:Oe(ge.semver,ae.semver,ye)&&(ae=ge)}),G.operator===Be||G.operator===Ne||(!ae.operator||ae.operator===Be)&&Te(X,ae.semver)||ae.operator===Ne&&Oe(X,ae.semver))return!1}return!0}ke.prototype.parse=function(X){var oe=this.loose?y[N]:y[_],de=X.match(oe);if(!de)throw new TypeError("Invalid comparator: "+X);this.operator=de[1],this.operator==="="&&(this.operator=""),de[2]?this.semver=new L(de[2],this.loose):this.semver=Le},ke.prototype.toString=function(){return this.value},ke.prototype.test=function(X){return k("Comparator.test",X,this.loose),this.semver===Le||(typeof X=="string"&&(X=new L(X,this.loose)),he(X,this.operator,this.semver,this.loose))},ke.prototype.intersects=function(X,oe){if(!(X instanceof ke))throw new TypeError("a Comparator is required");var de;if(this.operator==="")return de=new Me(X.value,oe),pe(this.value,de,oe);if(X.operator==="")return de=new Me(this.value,oe),pe(X.semver,de,oe);var ye=!(this.operator!==">="&&this.operator!==">"||X.operator!==">="&&X.operator!==">"),Ce=!(this.operator!=="<="&&this.operator!=="<"||X.operator!=="<="&&X.operator!=="<"),Te=this.semver.version===X.semver.version,Oe=!(this.operator!==">="&&this.operator!=="<="||X.operator!==">="&&X.operator!=="<="),Be=he(this.semver,"<",X.semver,oe)&&(this.operator===">="||this.operator===">")&&(X.operator==="<="||X.operator==="<"),Ne=he(this.semver,">",X.semver,oe)&&(this.operator==="<="||this.operator==="<")&&(X.operator===">="||X.operator===">");return ye||Ce||Te&&Oe||Be||Ne},e.Range=Me,Me.prototype.format=function(){return this.range=this.set.map(function(X){return X.join(" ").trim()}).join("||").trim(),this.range},Me.prototype.toString=function(){return this.range},Me.prototype.parseRange=function(X){var oe=this.loose;X=X.trim(),k("range",X,oe);var de=oe?y[$]:y[W];X=X.replace(de,je),k("hyphen replace",X),X=X.replace(y[A],"$1$2$3"),k("comparator trim",X,y[A]),X=(X=(X=X.replace(y[Q],"$1~")).replace(y[se],"$1^")).split(/\s+/).join(" ");var ye=oe?y[N]:y[_],Ce=X.split(" ").map(function(Te){return function(Oe,Be){return k("comp",Oe),Oe=function(Ne,Ue){return Ne.trim().split(/\s+/).map(function(qe){return function(G,ae){k("caret",G,ae);var ge=ae?y[K]:y[le];return G.replace(ge,function(Se,we,Ie,We,ze){var Ke;return k("caret",G,Se,we,Ie,We,ze),Ae(we)?Ke="":Ae(Ie)?Ke=">="+we+".0.0 <"+(+we+1)+".0.0":Ae(We)?Ke=we==="0"?">="+we+"."+Ie+".0 <"+we+"."+(+Ie+1)+".0":">="+we+"."+Ie+".0 <"+(+we+1)+".0.0":ze?(k("replaceCaret pr",ze),ze.charAt(0)!=="-"&&(ze="-"+ze),Ke=we==="0"?Ie==="0"?">="+we+"."+Ie+"."+We+ze+" <"+we+"."+Ie+"."+(+We+1):">="+we+"."+Ie+"."+We+ze+" <"+we+"."+(+Ie+1)+".0":">="+we+"."+Ie+"."+We+ze+" <"+(+we+1)+".0.0"):(k("no pr"),Ke=we==="0"?Ie==="0"?">="+we+"."+Ie+"."+We+" <"+we+"."+Ie+"."+(+We+1):">="+we+"."+Ie+"."+We+" <"+we+"."+(+Ie+1)+".0":">="+we+"."+Ie+"."+We+" <"+(+we+1)+".0.0"),k("caret return",Ke),Ke})}(qe,Ue)}).join(" ")}(Oe,Be),k("caret",Oe),Oe=function(Ne,Ue){return Ne.trim().split(/\s+/).map(function(qe){return function(G,ae){var ge=ae?y[ue]:y[re];return G.replace(ge,function(Se,we,Ie,We,ze){var Ke;return k("tilde",G,Se,we,Ie,We,ze),Ae(we)?Ke="":Ae(Ie)?Ke=">="+we+".0.0 <"+(+we+1)+".0.0":Ae(We)?Ke=">="+we+"."+Ie+".0 <"+we+"."+(+Ie+1)+".0":ze?(k("replaceTilde pr",ze),ze.charAt(0)!=="-"&&(ze="-"+ze),Ke=">="+we+"."+Ie+"."+We+ze+" <"+we+"."+(+Ie+1)+".0"):Ke=">="+we+"."+Ie+"."+We+" <"+we+"."+(+Ie+1)+".0",k("tilde return",Ke),Ke})}(qe,Ue)}).join(" ")}(Oe,Be),k("tildes",Oe),Oe=function(Ne,Ue){return k("replaceXRanges",Ne,Ue),Ne.split(/\s+/).map(function(qe){return function(G,ae){G=G.trim();var ge=ae?y[T]:y[M];return G.replace(ge,function(Se,we,Ie,We,ze,Ke){k("xRange",G,Se,we,Ie,We,ze,Ke);var Qe=Ae(Ie),Ye=Qe||Ae(We),et=Ye||Ae(ze);return we==="="&&et&&(we=""),Qe?Se=we===">"||we==="<"?"<0.0.0":"*":we&&et?(Ye&&(We=0),et&&(ze=0),we===">"?(we=">=",Ye?(Ie=+Ie+1,We=0,ze=0):et&&(We=+We+1,ze=0)):we==="<="&&(we="<",Ye?Ie=+Ie+1:We=+We+1),Se=we+Ie+"."+We+"."+ze):Ye?Se=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":et&&(Se=">="+Ie+"."+We+".0 <"+Ie+"."+(+We+1)+".0"),k("xRange return",Se),Se})}(qe,Ue)}).join(" ")}(Oe,Be),k("xrange",Oe),Oe=function(Ne,Ue){return k("replaceStars",Ne,Ue),Ne.trim().replace(y[Y],"")}(Oe,Be),k("stars",Oe),Oe}(Te,oe)}).join(" ").split(/\s+/);return this.loose&&(Ce=Ce.filter(function(Te){return!!Te.match(ye)})),Ce=Ce.map(function(Te){return new ke(Te,oe)})},Me.prototype.intersects=function(X,oe){if(!(X instanceof Me))throw new TypeError("a Range is required");return this.set.some(function(de){return de.every(function(ye){return X.set.some(function(Ce){return Ce.every(function(Te){return ye.intersects(Te,oe)})})})})},e.toComparators=function(X,oe){return new Me(X,oe).set.map(function(de){return de.map(function(ye){return ye.value}).join(" ").trim().split(" ")})},Me.prototype.test=function(X){if(!X)return!1;typeof X=="string"&&(X=new L(X,this.loose));for(var oe=0;oe<this.set.length;oe++)if(me(this.set[oe],X))return!0;return!1},e.satisfies=pe,e.maxSatisfying=function(X,oe,de){var ye=null,Ce=null;try{var Te=new Me(oe,de)}catch{return null}return X.forEach(function(Oe){Te.test(Oe)&&(ye&&Ce.compare(Oe)!==-1||(Ce=new L(ye=Oe,de)))}),ye},e.minSatisfying=function(X,oe,de){var ye=null,Ce=null;try{var Te=new Me(oe,de)}catch{return null}return X.forEach(function(Oe){Te.test(Oe)&&(ye&&Ce.compare(Oe)!==1||(Ce=new L(ye=Oe,de)))}),ye},e.validRange=function(X,oe){try{return new Me(X,oe).range||"*"}catch{return null}},e.ltr=function(X,oe,de){return Ee(X,oe,"<",de)},e.gtr=function(X,oe,de){return Ee(X,oe,">",de)},e.outside=Ee,e.prerelease=function(X,oe){var de=j(X,oe);return de&&de.prerelease.length?de.prerelease:null},e.intersects=function(X,oe,de){return X=new Me(X,de),oe=new Me(oe,de),X.intersects(oe)},e.coerce=function(X){if(X instanceof L)return X;if(typeof X!="string")return null;var oe=X.match(y[F]);return oe==null?null:j((oe[1]||"0")+"."+(oe[2]||"0")+"."+(oe[3]||"0"))}}).call(this,v(1))},function(H,e){var v,t,k=H.exports={};function R(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function y(S){if(v===setTimeout)return setTimeout(S,0);if((v===R||!v)&&setTimeout)return v=setTimeout,setTimeout(S,0);try{return v(S,0)}catch{try{return v.call(null,S,0)}catch{return v.call(this,S,0)}}}(function(){try{v=typeof setTimeout=="function"?setTimeout:R}catch{v=R}try{t=typeof clearTimeout=="function"?clearTimeout:D}catch{t=D}})();var h,p=[],I=!1,C=-1;function b(){I&&h&&(I=!1,h.length?p=h.concat(p):C=-1,p.length&&g())}function g(){if(!I){var S=y(b);I=!0;for(var f=p.length;f;){for(h=p,p=[];++C<f;)h&&h[C].run();C=-1,f=p.length}h=null,I=!1,function(w){if(t===clearTimeout)return clearTimeout(w);if((t===D||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(w);try{t(w)}catch{try{return t.call(null,w)}catch{return t.call(this,w)}}}(S)}}function d(S,f){this.fun=S,this.array=f}function E(){}k.nextTick=function(S){var f=new Array(arguments.length-1);if(arguments.length>1)for(var w=1;w<arguments.length;w++)f[w-1]=arguments[w];p.push(new d(S,f)),p.length!==1||I||y(g)},d.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=E,k.addListener=E,k.once=E,k.off=E,k.removeListener=E,k.removeAllListeners=E,k.emit=E,k.prependListener=E,k.prependOnceListener=E,k.listeners=function(S){return[]},k.binding=function(S){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(S){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(Z[127],ee([0,1]),function(H,e){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class t{constructor(y,h,p){this.level=y,this.key=h,this.value=p,this.forward=[]}}const k=void 0;class R{constructor(y,h=2**16){this.comparator=y,this[v]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(h)|0),this._header=new t(this._maxLevel,k,k)}get size(){return this._size}clear(){this._header=new t(this._maxLevel,k,k)}has(y){return Boolean(R._search(this,y,this.comparator))}get(y){return R._search(this,y,this.comparator)?.value}set(y,h){return R._insert(this,y,h,this.comparator)&&(this._size+=1),this}delete(y){const h=R._delete(this,y,this.comparator);return h&&(this._size-=1),h}forEach(y,h){let p=this._header.forward[0];for(;p;)y.call(h,p.value,p.key,this),p=p.forward[0]}[(v=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let y=this._header.forward[0];for(;y;)yield[y.key,y.value],y=y.forward[0]}*keys(){let y=this._header.forward[0];for(;y;)yield y.key,y=y.forward[0]}*values(){let y=this._header.forward[0];for(;y;)yield y.value,y=y.forward[0]}toString(){let y="[SkipList]:",h=this._header.forward[0];for(;h;)y+=`node(${h.key}, ${h.value}, lvl:${h.level})`,h=h.forward[0];return y}static _search(y,h,p){let I=y._header;for(let C=y._level-1;C>=0;C--)for(;I.forward[C]&&p(I.forward[C].key,h)<0;)I=I.forward[C];if(I=I.forward[0],I&&p(I.key,h)===0)return I}static _insert(y,h,p,I){const C=[];let b=y._header;for(let g=y._level-1;g>=0;g--){for(;b.forward[g]&&I(b.forward[g].key,h)<0;)b=b.forward[g];C[g]=b}if(b=b.forward[0],b&&I(b.key,h)===0)return b.value=p,!1;{const g=R._randomLevel(y);if(g>y._level){for(let d=y._level;d<g;d++)C[d]=y._header;y._level=g}b=new t(g,h,p);for(let d=0;d<g;d++)b.forward[d]=C[d].forward[d],C[d].forward[d]=b;return!0}}static _randomLevel(y,h=.5){let p=1;for(;Math.random()<h&&p<y._maxLevel;)p+=1;return p}static _delete(y,h,p){const I=[];let C=y._header;for(let b=y._level-1;b>=0;b--){for(;C.forward[b]&&p(C.forward[b].key,h)<0;)C=C.forward[b];I[b]=C}if(C=C.forward[0],!C||p(C.key,h)!==0)return!1;for(let b=0;b<y._level&&I[b].forward[b]===C;b++)I[b].forward[b]=C.forward[b];for(;y._level>0&&y._header.forward[y._level-1]===k;)y._level-=1;return!0}}e.SkipList=R}),define(Z[56],ee([0,1,18,2]),function(H,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function k(u){const c=u;return c?typeof c.read=="function":!1}e.isReadable=k;function R(u){const c=u;return c?[c.on,c.pause,c.resume,c.destroy].every(s=>typeof s=="function"):!1}e.isReadableStream=R;function D(u){const c=u;return c?R(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}e.isReadableBufferedStream=D;function y(u,c){return new h(u,c)}e.newWriteableStream=y;class h{constructor(c,s){this.reducer=c,this.options=s,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(c){if(!this.state.destroyed){if(this.state.flowing)this.emitData(c);else if(this.buffer.data.push(c),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(s=>this.pendingWritePromises.push(s))}}error(c){this.state.destroyed||(this.state.flowing?this.emitError(c):this.buffer.error.push(c))}end(c){this.state.destroyed||(typeof c!="undefined"&&this.write(c),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(c){this.listeners.data.slice(0).forEach(s=>s(c))}emitError(c){this.listeners.error.length===0?(0,v.onUnexpectedError)(c):this.listeners.error.slice(0).forEach(s=>s(c))}emitEnd(){this.listeners.end.slice(0).forEach(c=>c())}on(c,s){if(!this.state.destroyed)switch(c){case"data":this.listeners.data.push(s),this.resume();break;case"end":this.listeners.end.push(s),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(s),this.state.flowing&&this.flowErrors();break}}removeListener(c,s){if(this.state.destroyed)return;let r;switch(c){case"data":r=this.listeners.data;break;case"end":r=this.listeners.end;break;case"error":r=this.listeners.error;break}if(r){const i=r.indexOf(s);i>=0&&r.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const c=this.reducer(this.buffer.data);this.emitData(c),this.buffer.data.length=0;const s=[...this.pendingWritePromises];this.pendingWritePromises.length=0,s.forEach(r=>r())}}flowErrors(){if(this.listeners.error.length>0){for(const c of this.buffer.error)this.emitError(c);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function p(u,c){const s=[];let r;for(;(r=u.read())!==null;)s.push(r);return c(s)}e.consumeReadable=p;function I(u,c,s){const r=[];let i;for(;(i=u.read())!==null&&r.length<s;)r.push(i);return i===null&&r.length>0?c(r):{read:()=>{if(r.length>0)return r.shift();if(typeof i!="undefined"){const n=i;return i=void 0,n}return u.read()}}}e.peekReadable=I;function C(u,c){return new Promise((s,r)=>{const i=[];b(u,{onData:n=>{c&&i.push(n)},onError:n=>{c?r(n):s(void 0)},onEnd:()=>{s(c?c(i):void 0)}})})}e.consumeStream=C;function b(u,c){let s=!1;return u.on("error",r=>{s||c.onError(r)}),u.on("end",()=>{s||c.onEnd()}),u.on("data",r=>{s||c.onData(r)}),(0,t.toDisposable)(()=>s=!0)}e.listenStream=b;function g(u,c){return new Promise((s,r)=>{const i=new t.DisposableStore,n=[],o=P=>{if(n.push(P),n.length>c)return i.dispose(),u.pause(),s({stream:u,buffer:n,ended:!1})},a=P=>r(P),l=()=>s({stream:u,buffer:n,ended:!0});i.add((0,t.toDisposable)(()=>u.removeListener("error",a))),u.on("error",a),i.add((0,t.toDisposable)(()=>u.removeListener("end",l))),u.on("end",l),i.add((0,t.toDisposable)(()=>u.removeListener("data",o))),u.on("data",o)})}e.peekStream=g;function d(u,c){const s=y(c);return s.end(u),s}e.toStream=d;function E(){const u=y(()=>{throw new Error("not supported")});return u.end(),u}e.emptyStream=E;function S(u){let c=!1;return{read:()=>c?null:(c=!0,u)}}e.toReadable=S;function f(u,c,s){const r=y(s);return b(u,{onData:i=>r.write(c.data(i)),onError:i=>r.error(c.error?c.error(i):i),onEnd:()=>r.end()}),r}e.transform=f;function w(u,c,s){let r=!1;return{read:()=>{const i=c.read();return r?i:(r=!0,i!==null?s([u,i]):u)}}}e.prefixedReadable=w;function m(u,c,s){let r=!1;const i=y(s);return b(c,{onData:n=>r?i.write(n):(r=!0,i.write(s([u,n]))),onError:n=>i.error(n),onEnd:()=>{r||(r=!0,i.write(u)),i.end()}}),i}e.prefixedStream=m}),define(Z[17],ee([0,1,56]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer!="undefined";let k,R;class D{constructor(P){this.buffer=P,this.byteLength=this.buffer.byteLength}static alloc(P){return t?new D(Buffer.allocUnsafe(P)):new D(new Uint8Array(P))}static wrap(P){return t&&!Buffer.isBuffer(P)&&(P=Buffer.from(P.buffer,P.byteOffset,P.byteLength)),new D(P)}static fromString(P,M){return!(M?.dontUseNodeBuffer||!1)&&t?new D(Buffer.from(P)):(k||(k=new TextEncoder),new D(k.encode(P)))}static fromByteArray(P){const M=D.alloc(P.length);for(let T=0,F=P.length;T<F;T++)M.buffer[T]=P[T];return M}static concat(P,M){if(typeof M=="undefined"){M=0;for(let U=0,Q=P.length;U<Q;U++)M+=P[U].byteLength}const T=D.alloc(M);let F=0;for(let U=0,Q=P.length;U<Q;U++){const re=P[U];T.set(re,F),F+=re.byteLength}return T}clone(){const P=D.alloc(this.byteLength);return P.set(this),P}toString(){return t?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(P,M){return new D(this.buffer.subarray(P,M))}set(P,M){if(P instanceof D)this.buffer.set(P.buffer,M);else if(P instanceof Uint8Array)this.buffer.set(P,M);else if(P instanceof ArrayBuffer)this.buffer.set(new Uint8Array(P),M);else if(ArrayBuffer.isView(P))this.buffer.set(new Uint8Array(P.buffer,P.byteOffset,P.byteLength),M);else throw new Error("Unknown argument 'array'")}readUInt32BE(P){return p(this.buffer,P)}writeUInt32BE(P,M){I(this.buffer,P,M)}readUInt32LE(P){return C(this.buffer,P)}writeUInt32LE(P,M){b(this.buffer,P,M)}readUInt8(P){return g(this.buffer,P)}writeUInt8(P,M){d(this.buffer,P,M)}}e.VSBuffer=D;function y(l,P){return l[P+0]<<0>>>0|l[P+1]<<8>>>0}e.readUInt16LE=y;function h(l,P,M){l[M+0]=P&255,P=P>>>8,l[M+1]=P&255}e.writeUInt16LE=h;function p(l,P){return l[P]*2**24+l[P+1]*2**16+l[P+2]*2**8+l[P+3]}e.readUInt32BE=p;function I(l,P,M){l[M+3]=P,P=P>>>8,l[M+2]=P,P=P>>>8,l[M+1]=P,P=P>>>8,l[M]=P}e.writeUInt32BE=I;function C(l,P){return l[P+0]<<0>>>0|l[P+1]<<8>>>0|l[P+2]<<16>>>0|l[P+3]<<24>>>0}e.readUInt32LE=C;function b(l,P,M){l[M+0]=P&255,P=P>>>8,l[M+1]=P&255,P=P>>>8,l[M+2]=P&255,P=P>>>8,l[M+3]=P&255}e.writeUInt32LE=b;function g(l,P){return l[P]}e.readUInt8=g;function d(l,P,M){l[M]=P}e.writeUInt8=d;function E(l){return v.consumeReadable(l,P=>D.concat(P))}e.readableToBuffer=E;function S(l){return v.toReadable(l)}e.bufferToReadable=S;function f(l){return v.consumeStream(l,P=>D.concat(P))}e.streamToBuffer=f;async function w(l){return l.ended?D.concat(l.buffer):D.concat([...l.buffer,await f(l.stream)])}e.bufferedStreamToBuffer=w;function m(l){return v.toStream(l,P=>D.concat(P))}e.bufferToStream=m;function u(l){return v.transform(l,{data:P=>typeof P=="string"?D.fromString(P):D.wrap(P)},P=>D.concat(P))}e.streamToBufferReadableStream=u;function c(l){return v.newWriteableStream(P=>D.concat(P),l)}e.newWriteableBufferStream=c;function s(l,P){return v.prefixedReadable(l,P,M=>D.concat(M))}e.prefixedBufferReadable=s;function r(l,P){return v.prefixedStream(l,P,M=>D.concat(M))}e.prefixedBufferStream=r;function i(l){let P=0,M=0,T=0;const F=new Uint8Array(Math.floor(l.length/4*3)),U=re=>{switch(M){case 3:F[T++]=P|re,M=0;break;case 2:F[T++]=P|re>>>2,P=re<<6,M=3;break;case 1:F[T++]=P|re>>>4,P=re<<4,M=2;break;default:P=re<<2,M=1}};for(let re=0;re<l.length;re++){const ue=l.charCodeAt(re);if(ue>=65&&ue<=90)U(ue-65);else if(ue>=97&&ue<=122)U(ue-97+26);else if(ue>=48&&ue<=57)U(ue-48+52);else if(ue===43||ue===45)U(62);else if(ue===47||ue===95)U(63);else{if(ue===61)break;throw new SyntaxError(`Unexpected base64 character ${l[re]}`)}}const Q=T;for(;M>0;)U(0);return D.wrap(F).slice(0,Q)}e.decodeBase64=i;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function a({buffer:l},P=!0,M=!1){const T=M?o:n;let F="";const U=l.byteLength%3;let Q=0;for(;Q<l.byteLength-U;Q+=3){const re=l[Q+0],ue=l[Q+1],fe=l[Q+2];F+=T[re>>>2],F+=T[(re<<4|ue>>>4)&63],F+=T[(ue<<2|fe>>>6)&63],F+=T[fe&63]}if(U===1){const re=l[Q+0];F+=T[re>>>2],F+=T[re<<4&63],P&&(F+="==")}else if(U===2){const re=l[Q+0],ue=l[Q+1];F+=T[re>>>2],F+=T[(re<<4|ue>>>4)&63],F+=T[ue<<2&63],P&&(F+="=")}return F}e.encodeBase64=a}),define(Z[12],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function v(r){return typeof r=="string"}e.isString=v;function t(r){return Array.isArray(r)&&r.every(i=>v(i))}e.isStringArray=t;function k(r){return typeof r=="object"&&r!==null&&!Array.isArray(r)&&!(r instanceof RegExp)&&!(r instanceof Date)}e.isObject=k;function R(r){const i=Object.getPrototypeOf(Uint8Array);return typeof r=="object"&&r instanceof i}e.isTypedArray=R;function D(r){return typeof r=="number"&&!isNaN(r)}e.isNumber=D;function y(r){return!!r&&typeof r[Symbol.iterator]=="function"}e.isIterable=y;function h(r){return r===!0||r===!1}e.isBoolean=h;function p(r){return typeof r=="undefined"}e.isUndefined=p;function I(r){return!C(r)}e.isDefined=I;function C(r){return p(r)||r===null}e.isUndefinedOrNull=C;function b(r,i){if(!r)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}e.assertType=b;function g(r){if(C(r))throw new Error("Assertion Failed: argument is undefined or null");return r}e.assertIsDefined=g;function d(...r){const i=[];for(let n=0;n<r.length;n++){const o=r[n];if(C(o))throw new Error(`Assertion Failed: argument at index ${n} is undefined or null`);i.push(o)}return i}e.assertAllDefined=d;const E=Object.prototype.hasOwnProperty;function S(r){if(!k(r))return!1;for(const i in r)if(E.call(r,i))return!1;return!0}e.isEmptyObject=S;function f(r){return typeof r=="function"}e.isFunction=f;function w(...r){return r.length>0&&r.every(f)}e.areFunctions=w;function m(r,i){const n=Math.min(r.length,i.length);for(let o=0;o<n;o++)u(r[o],i[o])}e.validateConstraints=m;function u(r,i){if(v(i)){if(typeof r!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(f(i)){try{if(r instanceof i)return}catch{}if(!C(r)&&r.constructor===i||i.length===1&&i.call(void 0,r)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=u;function c(r){return r===null?void 0:r}e.withNullAsUndefined=c;function s(r){return typeof r=="undefined"?null:r}e.withUndefinedAsNull=s}),define(Z[49],ee([0,1,12]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(f){if(!f||typeof f!="object"||f instanceof RegExp)return f;const w=Array.isArray(f)?[]:{};return Object.keys(f).forEach(m=>{f[m]&&typeof f[m]=="object"?w[m]=t(f[m]):w[m]=f[m]}),w}e.deepClone=t;function k(f){if(!f||typeof f!="object")return f;const w=[f];for(;w.length>0;){const m=w.shift();Object.freeze(m);for(const u in m)if(R.call(m,u)){const c=m[u];typeof c=="object"&&!Object.isFrozen(c)&&!(0,v.isTypedArray)(c)&&w.push(c)}}return f}e.deepFreeze=k;const R=Object.prototype.hasOwnProperty;function D(f,w){return y(f,w,new Set)}e.cloneAndChange=D;function y(f,w,m){if((0,v.isUndefinedOrNull)(f))return f;const u=w(f);if(typeof u!="undefined")return u;if(Array.isArray(f)){const c=[];for(const s of f)c.push(y(s,w,m));return c}if((0,v.isObject)(f)){if(m.has(f))throw new Error("Cannot clone recursive data-structure");m.add(f);const c={};for(const s in f)R.call(f,s)&&(c[s]=y(f[s],w,m));return m.delete(f),c}return f}function h(f,w,m=!0){return(0,v.isObject)(f)?((0,v.isObject)(w)&&Object.keys(w).forEach(u=>{u in f?m&&((0,v.isObject)(f[u])&&(0,v.isObject)(w[u])?h(f[u],w[u],m):f[u]=w[u]):f[u]=w[u]}),f):w}e.mixin=h;function p(f,w){if(f===w)return!0;if(f==null||w===null||w===void 0||typeof f!=typeof w||typeof f!="object"||Array.isArray(f)!==Array.isArray(w))return!1;let m,u;if(Array.isArray(f)){if(f.length!==w.length)return!1;for(m=0;m<f.length;m++)if(!p(f[m],w[m]))return!1}else{const c=[];for(u in f)c.push(u);c.sort();const s=[];for(u in w)s.push(u);if(s.sort(),!p(c,s))return!1;for(m=0;m<c.length;m++)if(!p(f[c[m]],w[c[m]]))return!1}return!0}e.equals=p;function I(f){const w=new Set;return JSON.stringify(f,(m,u)=>{if((0,v.isObject)(u)||Array.isArray(u)){if(w.has(u))return"[Circular]";w.add(u)}return u})}e.safeStringify=I;function C(f,w){const m=Object.create(null);return!f||!w||Object.keys(w).forEach(c=>{const s=f[c],r=w[c];p(s,r)||(m[c]=r)}),m}e.distinct=C;function b(f,w){const m=w.toLowerCase(),u=Object.keys(f).find(c=>c.toLowerCase()===m);return u?f[u]:f[w]}e.getCaseInsensitive=b;function g(f,w){const m=Object.create(null);for(const[u,c]of Object.entries(f))w(u,c)&&(m[u]=c);return m}e.filter=g;function d(f){let w=[],m=Object.getPrototypeOf(f);for(;Object.prototype!==m;)w=w.concat(Object.getOwnPropertyNames(m)),m=Object.getPrototypeOf(m);return w}e.getAllPropertyNames=d;function E(f){const w=[];for(const m of d(f))typeof f[m]=="function"&&w.push(m);return w}e.getAllMethodNames=E;function S(f,w){const m=c=>function(){const s=Array.prototype.slice.call(arguments,0);return w(c,s)},u={};for(const c of f)u[c]=m(c);return u}e.createProxyObject=S}),define(Z[28],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const v=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(k){return v.test(k)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(y){for(let h=0;h<y.length;h++)y[h]=Math.floor(Math.random()*256);return y};const R=new Uint8Array(16),D=[];for(let y=0;y<256;y++)D.push(y.toString(16).padStart(2,"0"));return function(){k(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let h=0,p="";return p+=D[R[h++]],p+=D[R[h++]],p+=D[R[h++]],p+=D[R[h++]],p+="-",p+=D[R[h++]],p+=D[R[h++]],p+="-",p+=D[R[h++]],p+=D[R[h++]],p+="-",p+=D[R[h++]],p+=D[R[h++]],p+="-",p+=D[R[h++]],p+=D[R[h++]],p+=D[R[h++]],p+=D[R[h++]],p+=D[R[h++]],p+=D[R[h++]],p}}()}),define(Z[128],ee([0,1,76,29,48]),function(H,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function R(D,y){if(await new Promise((I,C)=>{const b=t.createReadStream(D),g=v.createHash("sha1");b.pipe(g);const d=(0,k.once)((E,S)=>{b.removeAllListeners(),g.removeAllListeners(),E?C(E):I(S)});b.once("error",d),b.once("end",d),g.once("error",d),g.once("data",E=>d(void 0,E.toString("hex")))})!==y)throw new Error("Hash mismatch")}e.checksum=R}),define(Z[129],ee([0,1,30]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const t=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(D){const y=D.replace(/\-/g,":").toLowerCase();return!t.has(y)}function R(){const D=(0,v.networkInterfaces)();for(const y in D){const h=D[y];if(h){for(const{mac:p}of h)if(k(p))return p}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=R}),define(Z[92],ee([0,1,77]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function t(y,h,p,I=1){let C=!1;return new Promise(b=>{const g=setTimeout(()=>{if(!C)return C=!0,b(0)},p);k(y,h,I,d=>{if(!C)return C=!0,clearTimeout(g),b(d)})})}e.findFreePort=t;function k(y,h,p,I){if(h===0)return I(0);const C=new v.Socket;C.once("connect",()=>(D(C),k(y+p,h-1,p,I))),C.once("data",()=>{}),C.once("error",b=>(D(C),b.code!=="ECONNREFUSED"?k(y+p,h-1,p,I):I(y))),C.connect(y,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(y,h,p){let I=!1,C,b=1;const g=v.createServer({pauseOnConnect:!0});function d(E,S){I||(I=!0,g.removeAllListeners(),g.close(),C&&clearTimeout(C),S(E))}return new Promise(E=>{C=setTimeout(()=>{d(0,E)},p),g.on("listening",()=>{d(y,E)}),g.on("error",S=>{S&&(S.code==="EADDRINUSE"||S.code==="EACCES")&&b<h?(y++,b++,g.listen(y,"127.0.0.1")):d(0,E)}),g.on("close",()=>{d(0,E)}),g.listen(y,"127.0.0.1")})}e.findFreePortFaster=R;function D(y){try{y.removeAllListeners("connect"),y.removeAllListeners("error"),y.end(),y.destroy(),y.unref()}catch(h){console.error(h)}}}),define(Z[130],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(Z[131],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class v{constructor(k,R){this.sender=k,this.onMessage=R}send(k){try{this.sender.send("vscode:message",k.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=v}),define(Z[40],ee([0,1,15,18]),function(H,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validatedIpcMain=void 0;class k{constructor(){this.mapListenerToWrapper=new WeakMap}on(D,y){const h=(p,...I)=>{this.validateEvent(D,p)&&y(p,...I)};return this.mapListenerToWrapper.set(y,h),v.ipcMain.on(D,h),this}once(D,y){return v.ipcMain.once(D,(h,...p)=>{this.validateEvent(D,h)&&y(h,...p)}),this}handle(D,y){return v.ipcMain.handle(D,(h,...p)=>this.validateEvent(D,h)?y(h,...p):Promise.reject(`Invalid channel '${D}' or sender for ipcMain.handle() usage.`)),this}removeHandler(D){return v.ipcMain.removeHandler(D),this}removeListener(D,y){const h=this.mapListenerToWrapper.get(y);return h&&(v.ipcMain.removeListener(D,h),this.mapListenerToWrapper.delete(y)),this}validateEvent(D,y){if(!D||!D.startsWith("vscode:"))return(0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because the channel is unknown.`),!1;const h=y.senderFrame,p=h.url;if(!p)return!0;let I="unknown";try{I=new URL(p).host}catch{return(0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because of a malformed URL '${p}'.`),!1}return I!=="vscode-app"?((0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because of a bad origin of '${I}'.`),!1):h.parent!==null?((0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because sender of origin '${I}' is not a main frame.`),!1):!0}}e.validatedIpcMain=new k}),define(Z[132],ee([0,1,15,40,12,130]),function(H,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function D(){t.validatedIpcMain.on(R.CONTEXT_MENU_CHANNEL,(h,p,I,C,b)=>{const g=y(h,C,I);g.popup({window:(0,k.withNullAsUndefined)(v.BrowserWindow.fromWebContents(h.sender)),x:b?b.x:void 0,y:b?b.y:void 0,positioningItem:b?b.positioningItem:void 0,callback:()=>{g&&h.sender.send(R.CONTEXT_MENU_CLOSE_CHANNEL,p)}})})}e.registerContextMenuListener=D;function y(h,p,I){const C=new v.Menu;return I.forEach(b=>{let g;b.type==="separator"?g=new v.MenuItem({type:b.type}):Array.isArray(b.submenu)?g=new v.MenuItem({submenu:y(h,p,b.submenu),label:b.label}):g=new v.MenuItem({label:b.label,type:b.type,accelerator:b.accelerator,checked:b.checked,enabled:b.enabled,visible:b.visible,click:(d,E,S)=>h.sender.send(p,b.id,S)}),C.append(g)}),C}}),define(Z[133],ee([11,10]),function(H,e){return H.create("vs/base/common/date",e)}),define(Z[134],ee([0,1,133]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,k=t*60,R=k*24,D=R*7,y=R*30,h=R*365;function p(C,b,g){typeof C!="number"&&(C=C.getTime());const d=Math.round((new Date().getTime()-C)/1e3);if(d<-30)return(0,v.localize)(0,null,p(new Date().getTime()+d*1e3,!1));if(d<30)return(0,v.localize)(1,null);let E;return d<t?(E=d,b?E===1?g?(0,v.localize)(2,null,E):(0,v.localize)(3,null,E):g?(0,v.localize)(4,null,E):(0,v.localize)(5,null,E):E===1?g?(0,v.localize)(6,null,E):(0,v.localize)(7,null,E):g?(0,v.localize)(8,null,E):(0,v.localize)(9,null,E)):d<k?(E=Math.floor(d/t),b?E===1?g?(0,v.localize)(10,null,E):(0,v.localize)(11,null,E):g?(0,v.localize)(12,null,E):(0,v.localize)(13,null,E):E===1?g?(0,v.localize)(14,null,E):(0,v.localize)(15,null,E):g?(0,v.localize)(16,null,E):(0,v.localize)(17,null,E)):d<R?(E=Math.floor(d/k),b?E===1?g?(0,v.localize)(18,null,E):(0,v.localize)(19,null,E):g?(0,v.localize)(20,null,E):(0,v.localize)(21,null,E):E===1?g?(0,v.localize)(22,null,E):(0,v.localize)(23,null,E):g?(0,v.localize)(24,null,E):(0,v.localize)(25,null,E)):d<D?(E=Math.floor(d/R),b?E===1?(0,v.localize)(26,null,E):(0,v.localize)(27,null,E):E===1?(0,v.localize)(28,null,E):(0,v.localize)(29,null,E)):d<y?(E=Math.floor(d/D),b?E===1?g?(0,v.localize)(30,null,E):(0,v.localize)(31,null,E):g?(0,v.localize)(32,null,E):(0,v.localize)(33,null,E):E===1?g?(0,v.localize)(34,null,E):(0,v.localize)(35,null,E):g?(0,v.localize)(36,null,E):(0,v.localize)(37,null,E)):d<h?(E=Math.floor(d/y),b?E===1?g?(0,v.localize)(38,null,E):(0,v.localize)(39,null,E):g?(0,v.localize)(40,null,E):(0,v.localize)(41,null,E):E===1?g?(0,v.localize)(42,null,E):(0,v.localize)(43,null,E):g?(0,v.localize)(44,null,E):(0,v.localize)(45,null,E)):(E=Math.floor(d/h),b?E===1?g?(0,v.localize)(46,null,E):(0,v.localize)(47,null,E):g?(0,v.localize)(48,null,E):(0,v.localize)(49,null,E):E===1?g?(0,v.localize)(50,null,E):(0,v.localize)(51,null,E):g?(0,v.localize)(52,null,E):(0,v.localize)(53,null,E))}e.fromNow=p;function I(C){return C.getFullYear()+"-"+String(C.getMonth()+1).padStart(2,"0")+"-"+String(C.getDate()).padStart(2,"0")+"T"+String(C.getHours()).padStart(2,"0")+":"+String(C.getMinutes()).padStart(2,"0")+":"+String(C.getSeconds()).padStart(2,"0")+"."+(C.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=I}),define(Z[135],ee([11,10]),function(H,e){return H.create("vs/base/common/errorMessage",e)}),define(Z[43],ee([0,1,24,12,135]),function(H,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function R(C,b){return b&&(C.stack||C.stacktrace)?k.localize(0,null,y(C),D(C.stack)||D(C.stacktrace)):y(C)}function D(C){return Array.isArray(C)?C.join(`
`):C}function y(C){return typeof C.code=="string"&&typeof C.errno=="number"&&typeof C.syscall=="string"?k.localize(1,null,C.message):C.message||k.localize(2,null)}function h(C=null,b=!1){if(!C)return k.localize(3,null);if(Array.isArray(C)){const g=v.coalesce(C),d=h(g[0],b);return g.length>1?k.localize(4,null,d,g.length):d}if(t.isString(C))return C;if(C.detail){const g=C.detail;if(g.error)return R(g.error,b);if(g.exception)return R(g.exception,b)}return C.stack?R(C,b):C.message?C.message:k.localize(5,null)}e.toErrorMessage=h;function p(C){const b=C;return b instanceof Error&&Array.isArray(b.actions)}e.isErrorWithActions=p;function I(C,b){let g;return typeof C=="string"?g=new Error(C):g=C,g.actions=b,g}e.createErrorWithActions=I}),define(Z[136],ee([11,10]),function(H,e){return H.create("vs/base/common/jsonErrorMessages",e)}),define(Z[137],ee([0,1,136]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function t(k){switch(k){case 1:return(0,v.localize)(0,null);case 2:return(0,v.localize)(1,null);case 3:return(0,v.localize)(2,null);case 4:return(0,v.localize)(3,null);case 5:return(0,v.localize)(4,null);case 6:return(0,v.localize)(5,null);case 7:return(0,v.localize)(6,null);case 8:return(0,v.localize)(7,null);case 9:return(0,v.localize)(8,null);default:return""}}e.getParseErrorMessage=t}),define(Z[138],ee([11,10]),function(H,e){return H.create("vs/base/common/platform",e)}),define(Z[4],ee([0,1,138]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=void 0;const t="en";let k=!1,R=!1,D=!1,y=!1,h=!1,p=!1,I=!1,C=!1,b=!1,g,d=t,E,S;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let f;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?f=e.globals.vscode.process:typeof process!="undefined"&&(f=process);const w=typeof f?.versions?.electron=="string",m=w&&f?.type==="renderer";if(typeof navigator=="object"&&!m)S=navigator.userAgent,k=S.indexOf("Windows")>=0,R=S.indexOf("Macintosh")>=0,C=(S.indexOf("Macintosh")>=0||S.indexOf("iPad")>=0||S.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,D=S.indexOf("Linux")>=0,p=!0,g=v.getConfiguredDefaultLocale(v.localize(0,null))||t,d=g;else if(typeof f=="object"){k=f.platform==="win32",R=f.platform==="darwin",D=f.platform==="linux",y=D&&!!f.env.SNAP&&!!f.env.SNAP_REVISION,I=w,b=!!f.env.CI||!!f.env.BUILD_ARTIFACTSTAGINGDIRECTORY,g=t,d=t;const l=f.env.VSCODE_NLS_CONFIG;if(l)try{const P=JSON.parse(l),M=P.availableLanguages["*"];g=P.locale,d=M||t,E=P._translationsConfigFile}catch{}h=!0}else console.error("Unable to resolve platform.");var u;(function(l){l[l.Web=0]="Web",l[l.Mac=1]="Mac",l[l.Linux=2]="Linux",l[l.Windows=3]="Windows"})(u=e.Platform||(e.Platform={}));function c(l){switch(l){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=c;let s=0;R?s=1:k?s=3:D&&(s=2),e.isWindows=k,e.isMacintosh=R,e.isLinux=D,e.isLinuxSnap=y,e.isNative=h,e.isElectron=I,e.isWeb=p,e.isWebWorker=p&&typeof e.globals.importScripts=="function",e.isIOS=C,e.isCI=b,e.platform=s,e.userAgent=S,e.language=d;var r;(function(l){function P(){return e.language}l.value=P;function M(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}l.isDefaultVariant=M;function T(){return e.language==="en"}l.isDefault=T})(r=e.Language||(e.Language={})),e.locale=g,e.translationsConfigFile=E,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const l=[];e.globals.addEventListener("message",M=>{if(M.data&&M.data.vscodeScheduleAsyncWork)for(let T=0,F=l.length;T<F;T++){const U=l[T];if(U.id===M.data.vscodeScheduleAsyncWork){l.splice(T,1),U.callback();return}}});let P=0;return M=>{const T=++P;l.push({id:T,callback:M}),e.globals.postMessage({vscodeScheduleAsyncWork:T},"*")}}return l=>setTimeout(l)})();var i;(function(l){l[l.Windows=1]="Windows",l[l.Macintosh=2]="Macintosh",l[l.Linux=3]="Linux"})(i=e.OperatingSystem||(e.OperatingSystem={})),e.OS=R||C?2:k?1:3;let n=!0,o=!1;function a(){if(!o){o=!0;const l=new Uint8Array(2);l[0]=1,l[1]=2,n=new Uint16Array(l.buffer)[0]===(2<<8)+1}return n}e.isLittleEndian=a,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(Z[35],ee([0,1,4]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof v.globals.vscode!="undefined"&&typeof v.globals.vscode.process!="undefined"){const k=v.globals.vscode.process;t={get platform(){return k.platform},get arch(){return k.arch},get env(){return k.env},cwd(){return k.cwd()}}}else typeof process!="undefined"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return v.isWindows?"win32":v.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(Z[9],ee([0,1,35]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,k=97,R=90,D=122,y=46,h=47,p=92,I=58,C=63;class b extends Error{constructor(u,c,s){let r;typeof c=="string"&&c.indexOf("not ")===0?(r="must not be",c=c.replace(/^not /,"")):r="must be";const i=u.indexOf(".")!==-1?"property":"argument";let n=`The "${u}" ${i} ${r} of type ${c}`;n+=`. Received type ${typeof s}`;super(n);this.code="ERR_INVALID_ARG_TYPE"}}function g(m,u){if(typeof m!="string")throw new b(u,"string",m)}function d(m){return m===h||m===p}function E(m){return m===h}function S(m){return m>=t&&m<=R||m>=k&&m<=D}function f(m,u,c,s){let r="",i=0,n=-1,o=0,a=0;for(let l=0;l<=m.length;++l){if(l<m.length)a=m.charCodeAt(l);else{if(s(a))break;a=h}if(s(a)){if(!(n===l-1||o===1))if(o===2){if(r.length<2||i!==2||r.charCodeAt(r.length-1)!==y||r.charCodeAt(r.length-2)!==y){if(r.length>2){const P=r.lastIndexOf(c);P===-1?(r="",i=0):(r=r.slice(0,P),i=r.length-1-r.lastIndexOf(c)),n=l,o=0;continue}else if(r.length!==0){r="",i=0,n=l,o=0;continue}}u&&(r+=r.length>0?`${c}..`:"..",i=2)}else r.length>0?r+=`${c}${m.slice(n+1,l)}`:r=m.slice(n+1,l),i=l-n-1;n=l,o=0}else a===y&&o!==-1?++o:o=-1}return r}function w(m,u){if(u===null||typeof u!="object")throw new b("pathObject","Object",u);const c=u.dir||u.root,s=u.base||`${u.name||""}${u.ext||""}`;return c?c===u.root?`${c}${s}`:`${c}${m}${s}`:s}e.win32={resolve(...m){let u="",c="",s=!1;for(let r=m.length-1;r>=-1;r--){let i;if(r>=0){if(i=m[r],g(i,"path"),i.length===0)continue}else u.length===0?i=v.cwd():(i=v.env[`=${u}`]||v.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==u.toLowerCase()&&i.charCodeAt(2)===p)&&(i=`${u}\\`));const n=i.length;let o=0,a="",l=!1;const P=i.charCodeAt(0);if(n===1)d(P)&&(o=1,l=!0);else if(d(P))if(l=!0,d(i.charCodeAt(1))){let M=2,T=M;for(;M<n&&!d(i.charCodeAt(M));)M++;if(M<n&&M!==T){const F=i.slice(T,M);for(T=M;M<n&&d(i.charCodeAt(M));)M++;if(M<n&&M!==T){for(T=M;M<n&&!d(i.charCodeAt(M));)M++;(M===n||M!==T)&&(a=`\\\\${F}\\${i.slice(T,M)}`,o=M)}}}else o=1;else S(P)&&i.charCodeAt(1)===I&&(a=i.slice(0,2),o=2,n>2&&d(i.charCodeAt(2))&&(l=!0,o=3));if(a.length>0)if(u.length>0){if(a.toLowerCase()!==u.toLowerCase())continue}else u=a;if(s){if(u.length>0)break}else if(c=`${i.slice(o)}\\${c}`,s=l,l&&u.length>0)break}return c=f(c,!s,"\\",d),s?`${u}\\${c}`:`${u}${c}`||"."},normalize(m){g(m,"path");const u=m.length;if(u===0)return".";let c=0,s,r=!1;const i=m.charCodeAt(0);if(u===1)return E(i)?"\\":m;if(d(i))if(r=!0,d(m.charCodeAt(1))){let o=2,a=o;for(;o<u&&!d(m.charCodeAt(o));)o++;if(o<u&&o!==a){const l=m.slice(a,o);for(a=o;o<u&&d(m.charCodeAt(o));)o++;if(o<u&&o!==a){for(a=o;o<u&&!d(m.charCodeAt(o));)o++;if(o===u)return`\\\\${l}\\${m.slice(a)}\\`;o!==a&&(s=`\\\\${l}\\${m.slice(a,o)}`,c=o)}}}else c=1;else S(i)&&m.charCodeAt(1)===I&&(s=m.slice(0,2),c=2,u>2&&d(m.charCodeAt(2))&&(r=!0,c=3));let n=c<u?f(m.slice(c),!r,"\\",d):"";return n.length===0&&!r&&(n="."),n.length>0&&d(m.charCodeAt(u-1))&&(n+="\\"),s===void 0?r?`\\${n}`:n:r?`${s}\\${n}`:`${s}${n}`},isAbsolute(m){g(m,"path");const u=m.length;if(u===0)return!1;const c=m.charCodeAt(0);return d(c)||u>2&&S(c)&&m.charCodeAt(1)===I&&d(m.charCodeAt(2))},join(...m){if(m.length===0)return".";let u,c;for(let i=0;i<m.length;++i){const n=m[i];g(n,"path"),n.length>0&&(u===void 0?u=c=n:u+=`\\${n}`)}if(u===void 0)return".";let s=!0,r=0;if(typeof c=="string"&&d(c.charCodeAt(0))){++r;const i=c.length;i>1&&d(c.charCodeAt(1))&&(++r,i>2&&(d(c.charCodeAt(2))?++r:s=!1))}if(s){for(;r<u.length&&d(u.charCodeAt(r));)r++;r>=2&&(u=`\\${u.slice(r)}`)}return e.win32.normalize(u)},relative(m,u){if(g(m,"from"),g(u,"to"),m===u)return"";const c=e.win32.resolve(m),s=e.win32.resolve(u);if(c===s||(m=c.toLowerCase(),u=s.toLowerCase(),m===u))return"";let r=0;for(;r<m.length&&m.charCodeAt(r)===p;)r++;let i=m.length;for(;i-1>r&&m.charCodeAt(i-1)===p;)i--;const n=i-r;let o=0;for(;o<u.length&&u.charCodeAt(o)===p;)o++;let a=u.length;for(;a-1>o&&u.charCodeAt(a-1)===p;)a--;const l=a-o,P=n<l?n:l;let M=-1,T=0;for(;T<P;T++){const U=m.charCodeAt(r+T);if(U!==u.charCodeAt(o+T))break;U===p&&(M=T)}if(T!==P){if(M===-1)return s}else{if(l>P){if(u.charCodeAt(o+T)===p)return s.slice(o+T+1);if(T===2)return s.slice(o+T)}n>P&&(m.charCodeAt(r+T)===p?M=T:T===2&&(M=3)),M===-1&&(M=0)}let F="";for(T=r+M+1;T<=i;++T)(T===i||m.charCodeAt(T)===p)&&(F+=F.length===0?"..":"\\..");return o+=M,F.length>0?`${F}${s.slice(o,a)}`:(s.charCodeAt(o)===p&&++o,s.slice(o,a))},toNamespacedPath(m){if(typeof m!="string")return m;if(m.length===0)return"";const u=e.win32.resolve(m);if(u.length<=2)return m;if(u.charCodeAt(0)===p){if(u.charCodeAt(1)===p){const c=u.charCodeAt(2);if(c!==C&&c!==y)return`\\\\?\\UNC\\${u.slice(2)}`}}else if(S(u.charCodeAt(0))&&u.charCodeAt(1)===I&&u.charCodeAt(2)===p)return`\\\\?\\${u}`;return m},dirname(m){g(m,"path");const u=m.length;if(u===0)return".";let c=-1,s=0;const r=m.charCodeAt(0);if(u===1)return d(r)?m:".";if(d(r)){if(c=s=1,d(m.charCodeAt(1))){let o=2,a=o;for(;o<u&&!d(m.charCodeAt(o));)o++;if(o<u&&o!==a){for(a=o;o<u&&d(m.charCodeAt(o));)o++;if(o<u&&o!==a){for(a=o;o<u&&!d(m.charCodeAt(o));)o++;if(o===u)return m;o!==a&&(c=s=o+1)}}}}else S(r)&&m.charCodeAt(1)===I&&(c=u>2&&d(m.charCodeAt(2))?3:2,s=c);let i=-1,n=!0;for(let o=u-1;o>=s;--o)if(d(m.charCodeAt(o))){if(!n){i=o;break}}else n=!1;if(i===-1){if(c===-1)return".";i=c}return m.slice(0,i)},basename(m,u){u!==void 0&&g(u,"ext"),g(m,"path");let c=0,s=-1,r=!0,i;if(m.length>=2&&S(m.charCodeAt(0))&&m.charCodeAt(1)===I&&(c=2),u!==void 0&&u.length>0&&u.length<=m.length){if(u===m)return"";let n=u.length-1,o=-1;for(i=m.length-1;i>=c;--i){const a=m.charCodeAt(i);if(d(a)){if(!r){c=i+1;break}}else o===-1&&(r=!1,o=i+1),n>=0&&(a===u.charCodeAt(n)?--n==-1&&(s=i):(n=-1,s=o))}return c===s?s=o:s===-1&&(s=m.length),m.slice(c,s)}for(i=m.length-1;i>=c;--i)if(d(m.charCodeAt(i))){if(!r){c=i+1;break}}else s===-1&&(r=!1,s=i+1);return s===-1?"":m.slice(c,s)},extname(m){g(m,"path");let u=0,c=-1,s=0,r=-1,i=!0,n=0;m.length>=2&&m.charCodeAt(1)===I&&S(m.charCodeAt(0))&&(u=s=2);for(let o=m.length-1;o>=u;--o){const a=m.charCodeAt(o);if(d(a)){if(!i){s=o+1;break}continue}r===-1&&(i=!1,r=o+1),a===y?c===-1?c=o:n!==1&&(n=1):c!==-1&&(n=-1)}return c===-1||r===-1||n===0||n===1&&c===r-1&&c===s+1?"":m.slice(c,r)},format:w.bind(null,"\\"),parse(m){g(m,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(m.length===0)return u;const c=m.length;let s=0,r=m.charCodeAt(0);if(c===1)return d(r)?(u.root=u.dir=m,u):(u.base=u.name=m,u);if(d(r)){if(s=1,d(m.charCodeAt(1))){let M=2,T=M;for(;M<c&&!d(m.charCodeAt(M));)M++;if(M<c&&M!==T){for(T=M;M<c&&d(m.charCodeAt(M));)M++;if(M<c&&M!==T){for(T=M;M<c&&!d(m.charCodeAt(M));)M++;M===c?s=M:M!==T&&(s=M+1)}}}}else if(S(r)&&m.charCodeAt(1)===I){if(c<=2)return u.root=u.dir=m,u;if(s=2,d(m.charCodeAt(2))){if(c===3)return u.root=u.dir=m,u;s=3}}s>0&&(u.root=m.slice(0,s));let i=-1,n=s,o=-1,a=!0,l=m.length-1,P=0;for(;l>=s;--l){if(r=m.charCodeAt(l),d(r)){if(!a){n=l+1;break}continue}o===-1&&(a=!1,o=l+1),r===y?i===-1?i=l:P!==1&&(P=1):i!==-1&&(P=-1)}return o!==-1&&(i===-1||P===0||P===1&&i===o-1&&i===n+1?u.base=u.name=m.slice(n,o):(u.name=m.slice(n,i),u.base=m.slice(n,o),u.ext=m.slice(i,o))),n>0&&n!==s?u.dir=m.slice(0,n-1):u.dir=u.root,u},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...m){let u="",c=!1;for(let s=m.length-1;s>=-1&&!c;s--){const r=s>=0?m[s]:v.cwd();g(r,"path"),r.length!==0&&(u=`${r}/${u}`,c=r.charCodeAt(0)===h)}return u=f(u,!c,"/",E),c?`/${u}`:u.length>0?u:"."},normalize(m){if(g(m,"path"),m.length===0)return".";const u=m.charCodeAt(0)===h,c=m.charCodeAt(m.length-1)===h;return m=f(m,!u,"/",E),m.length===0?u?"/":c?"./":".":(c&&(m+="/"),u?`/${m}`:m)},isAbsolute(m){return g(m,"path"),m.length>0&&m.charCodeAt(0)===h},join(...m){if(m.length===0)return".";let u;for(let c=0;c<m.length;++c){const s=m[c];g(s,"path"),s.length>0&&(u===void 0?u=s:u+=`/${s}`)}return u===void 0?".":e.posix.normalize(u)},relative(m,u){if(g(m,"from"),g(u,"to"),m===u||(m=e.posix.resolve(m),u=e.posix.resolve(u),m===u))return"";const c=1,s=m.length,r=s-c,i=1,n=u.length-i,o=r<n?r:n;let a=-1,l=0;for(;l<o;l++){const M=m.charCodeAt(c+l);if(M!==u.charCodeAt(i+l))break;M===h&&(a=l)}if(l===o)if(n>o){if(u.charCodeAt(i+l)===h)return u.slice(i+l+1);if(l===0)return u.slice(i+l)}else r>o&&(m.charCodeAt(c+l)===h?a=l:l===0&&(a=0));let P="";for(l=c+a+1;l<=s;++l)(l===s||m.charCodeAt(l)===h)&&(P+=P.length===0?"..":"/..");return`${P}${u.slice(i+a)}`},toNamespacedPath(m){return m},dirname(m){if(g(m,"path"),m.length===0)return".";const u=m.charCodeAt(0)===h;let c=-1,s=!0;for(let r=m.length-1;r>=1;--r)if(m.charCodeAt(r)===h){if(!s){c=r;break}}else s=!1;return c===-1?u?"/":".":u&&c===1?"//":m.slice(0,c)},basename(m,u){u!==void 0&&g(u,"ext"),g(m,"path");let c=0,s=-1,r=!0,i;if(u!==void 0&&u.length>0&&u.length<=m.length){if(u===m)return"";let n=u.length-1,o=-1;for(i=m.length-1;i>=0;--i){const a=m.charCodeAt(i);if(a===h){if(!r){c=i+1;break}}else o===-1&&(r=!1,o=i+1),n>=0&&(a===u.charCodeAt(n)?--n==-1&&(s=i):(n=-1,s=o))}return c===s?s=o:s===-1&&(s=m.length),m.slice(c,s)}for(i=m.length-1;i>=0;--i)if(m.charCodeAt(i)===h){if(!r){c=i+1;break}}else s===-1&&(r=!1,s=i+1);return s===-1?"":m.slice(c,s)},extname(m){g(m,"path");let u=-1,c=0,s=-1,r=!0,i=0;for(let n=m.length-1;n>=0;--n){const o=m.charCodeAt(n);if(o===h){if(!r){c=n+1;break}continue}s===-1&&(r=!1,s=n+1),o===y?u===-1?u=n:i!==1&&(i=1):u!==-1&&(i=-1)}return u===-1||s===-1||i===0||i===1&&u===s-1&&u===c+1?"":m.slice(u,s)},format:w.bind(null,"/"),parse(m){g(m,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(m.length===0)return u;const c=m.charCodeAt(0)===h;let s;c?(u.root="/",s=1):s=0;let r=-1,i=0,n=-1,o=!0,a=m.length-1,l=0;for(;a>=s;--a){const P=m.charCodeAt(a);if(P===h){if(!o){i=a+1;break}continue}n===-1&&(o=!1,n=a+1),P===y?r===-1?r=a:l!==1&&(l=1):r!==-1&&(l=-1)}if(n!==-1){const P=i===0&&c?1:i;r===-1||l===0||l===1&&r===n-1&&r===i+1?u.base=u.name=m.slice(P,n):(u.name=m.slice(P,r),u.base=m.slice(P,n),u.ext=m.slice(r,n))}return i>0?u.dir=m.slice(0,i-1):c&&(u.dir="/"),u},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=v.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=v.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=v.platform==="win32"?e.win32.join:e.posix.join,e.resolve=v.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=v.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=v.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=v.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=v.platform==="win32"?e.win32.extname:e.posix.extname,e.format=v.platform==="win32"?e.win32.format:e.posix.format,e.parse=v.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=v.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=v.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=v.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(Z[78],ee([0,1,4]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(y){y[y.stdout=0]="stdout",y[y.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var k;(function(y){y[y.Success=0]="Success",y[y.Unknown=1]="Unknown",y[y.AccessDenied=2]="AccessDenied",y[y.ProcessNotFound=3]="ProcessNotFound"})(k=e.TerminateResponseCode||(e.TerminateResponseCode={}));function R(y,...h){const p=h.reduce((b,g)=>(b[g]=!0,b),{}),I=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(y).filter(b=>!p[b]).forEach(b=>{for(let g=0;g<I.length;g++)if(b.search(I[g])!==-1){delete y[b];break}})}e.sanitizeProcessEnvironment=R;function D(y){!y||(delete y.DEBUG,v.isMacintosh&&delete y.DYLD_LIBRARY_PATH,v.isLinux&&delete y.LD_PRELOAD)}e.removeDangerousEnvVariables=D}),define(Z[79],ee([0,1,4]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=v.globals.performance&&typeof v.globals.performance.now=="function";class k{constructor(D){this._highResolution=t&&D,this._startTime=this._now(),this._stopTime=-1}static create(D=!0){return new k(D)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?v.globals.performance.now():Date.now()}}e.StopWatch=k}),define(Z[3],ee([0,1,18,48,2,126,79]),function(H,e,v,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;const y=!1,h=!1;var p;(function(a){a.None=()=>k.Disposable.None;function l(O){if(h){const{onListenerDidAdd:B}=O,V=d.create();let x=0;O.onListenerDidAdd=()=>{++x==2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),V.print()),B?.()}}}function P(O){return(B,V=null,x)=>{let ie=!1,q;return q=O(te=>{if(!ie)return q?q.dispose():ie=!0,B.call(V,te)},null,x),ie&&q.dispose(),q}}a.once=P;function M(O,B,V){return ue((x,ie=null,q)=>O(te=>x.call(ie,B(te)),null,q),V)}a.map=M;function T(O,B,V){return ue((x,ie=null,q)=>O(te=>{B(te),x.call(ie,te)},null,q),V)}a.forEach=T;function F(O,B,V){return ue((x,ie=null,q)=>O(te=>B(te)&&x.call(ie,te),null,q),V)}a.filter=F;function U(O){return O}a.signal=U;function Q(...O){return(B,V=null,x)=>(0,k.combinedDisposable)(...O.map(ie=>ie(q=>B.call(V,q),null,x)))}a.any=Q;function re(O,B,V,x){let ie=V;return M(O,q=>(ie=B(ie,q),ie),x)}a.reduce=re;function ue(O,B){let V;const x={onFirstListenerAdd(){V=O(ie.fire,ie)},onLastListenerRemove(){V?.dispose()}};B||l(x);const ie=new S(x);return B?.add(ie),ie.event}function fe(O,B,V=100,x=!1,ie,q){let te,ne,ce,he=0;const ke={leakWarningThreshold:ie,onFirstListenerAdd(){te=O(Me=>{he++,ne=B(ne,Me),x&&!ce&&(Le.fire(ne),ne=void 0),clearTimeout(ce),ce=setTimeout(()=>{const Ae=ne;ne=void 0,ce=void 0,(!x||he>1)&&Le.fire(Ae),he=0},V)})},onLastListenerRemove(){te.dispose()}};q||l(ke);const Le=new S(ke);return q?.add(Le),Le.event}a.debounce=fe;function se(O,B=(x,ie)=>x===ie,V){let x=!0,ie;return F(O,q=>{const te=x||!B(q,ie);return x=!1,ie=q,te},V)}a.latch=se;function le(O,B,V){return[a.filter(O,B,V),a.filter(O,x=>!B(x),V)]}a.split=le;function K(O,B=!1,V=[]){let x=V.slice(),ie=O(ne=>{x?x.push(ne):te.fire(ne)});const q=()=>{x?.forEach(ne=>te.fire(ne)),x=null},te=new S({onFirstListenerAdd(){ie||(ie=O(ne=>te.fire(ne)))},onFirstListenerDidAdd(){x&&(B?setTimeout(q):q())},onLastListenerRemove(){ie&&ie.dispose(),ie=null}});return te.event}a.buffer=K;class N{constructor(B){this.event=B,this.disposables=new k.DisposableStore}map(B){return new N(M(this.event,B,this.disposables))}forEach(B){return new N(T(this.event,B,this.disposables))}filter(B){return new N(F(this.event,B,this.disposables))}reduce(B,V){return new N(re(this.event,B,V,this.disposables))}latch(){return new N(se(this.event,void 0,this.disposables))}debounce(B,V=100,x=!1,ie){return new N(fe(this.event,B,V,x,ie,this.disposables))}on(B,V,x){return this.event(B,V,x)}once(B,V,x){return P(this.event)(B,V,x)}dispose(){this.disposables.dispose()}}function _(O){return new N(O)}a.chain=_;function A(O,B,V=x=>x){const x=(...ne)=>te.fire(V(...ne)),ie=()=>O.on(B,x),q=()=>O.removeListener(B,x),te=new S({onFirstListenerAdd:ie,onLastListenerRemove:q});return te.event}a.fromNodeEventEmitter=A;function W(O,B,V=x=>x){const x=(...ne)=>te.fire(V(...ne)),ie=()=>O.addEventListener(B,x),q=()=>O.removeEventListener(B,x),te=new S({onFirstListenerAdd:ie,onLastListenerRemove:q});return te.event}a.fromDOMEventEmitter=W;function $(O){return new Promise(B=>P(O)(B))}a.toPromise=$;function Y(O,B){return B(void 0),O(V=>B(V))}a.runAndSubscribe=Y;function z(O,B){let V=null;function x(q){V?.dispose(),V=new k.DisposableStore,B(q,V)}x(void 0);const ie=O(q=>x(q));return(0,k.toDisposable)(()=>{ie.dispose(),V?.dispose()})}a.runAndSubscribeWithStore=z;class j{constructor(B,V){this.obs=B,this._counter=0,this._hasChanged=!1;const x={onFirstListenerAdd:()=>{B.addObserver(this)},onLastListenerRemove:()=>{B.removeObserver(this)}};V||l(x),this.emitter=new S(x),V&&V.add(this.emitter)}beginUpdate(B){this._counter++}handleChange(B,V){this._hasChanged=!0}endUpdate(B){--this._counter==0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function L(O,B){return new j(O,B).emitter.event}a.fromObservable=L})(p=e.Event||(e.Event={}));class I{constructor(l){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${l}_${I._idPool++}`}start(l){this._stopWatch=new D.StopWatch(!0),this._listenerCount=l}stop(){if(this._stopWatch){const l=this._stopWatch.elapsed();this._elapsedOverall+=l,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${l.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}I._idPool=0;let C=-1;function b(a){const l=C;return C=a,{dispose(){C=l}}}e.setGlobalLeakWarningThreshold=b;class g{constructor(l,P=Math.random().toString(18).slice(2,5)){this.customThreshold=l,this.name=P,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(l,P){let M=C;if(typeof this.customThreshold=="number"&&(M=this.customThreshold),M<=0||P<M)return;this._stacks||(this._stacks=new Map);const T=this._stacks.get(l.value)||0;if(this._stacks.set(l.value,T+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=M*.5;let F,U=0;for(const[Q,re]of this._stacks)(!F||U<re)&&(F=Q,U=re);console.warn(`[${this.name}] potential listener LEAK detected, having ${P} listeners already. MOST frequent listener (${U}):`),console.warn(F)}return()=>{const F=this._stacks.get(l.value)||0;this._stacks.set(l.value,F-1)}}}class d{constructor(l){this.value=l}static create(){return new d(new Error().stack??"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class E{constructor(l,P,M){this.callback=l,this.callbackThis=P,this.stack=M,this.subscription=new k.SafeDisposable}invoke(l){this.callback.call(this.callbackThis,l)}}class S{constructor(l){this._disposed=!1,this._options=l,this._leakageMon=C>0?new g(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new I(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(y){const l=Array.from(this._listeners);queueMicrotask(()=>{for(const P of l)P.subscription.isset()&&(P.subscription.unset(),P.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(l,P,M)=>{this._listeners||(this._listeners=new R.LinkedList);const T=this._listeners.isEmpty();T&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let F,U;this._leakageMon&&this._listeners.size>=30&&(U=d.create(),F=this._leakageMon.check(U,this._listeners.size+1)),y&&(U=U??d.create());const Q=new E(l,P,U),re=this._listeners.push(Q);T&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,l,P);const ue=Q.subscription.set(()=>{F?.(),this._disposed||(re(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return M instanceof k.DisposableStore?M.add(ue):Array.isArray(M)&&M.push(ue),ue}),this._event}fire(l){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new w);for(const P of this._listeners)this._deliveryQueue.push(this,P,l);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=S;class f{constructor(){this._queue=new R.LinkedList}get size(){return this._queue.size}push(l,P,M){this._queue.push(new m(l,P,M))}clear(l){const P=new R.LinkedList;for(const M of this._queue)M.emitter!==l&&P.push(M);this._queue=P}deliver(){for(;this._queue.size>0;){const l=this._queue.shift();try{l.listener.invoke(l.event)}catch(P){(0,v.onUnexpectedError)(P)}}}}e.EventDeliveryQueue=f;class w extends f{clear(l){this._queue.clear()}}class m{constructor(l,P,M){this.emitter=l,this.listener=P,this.event=M}}class u extends S{async fireAsync(l,P,M){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new R.LinkedList);for(const T of this._listeners)this._asyncDeliveryQueue.push([T,l]);for(;this._asyncDeliveryQueue.size>0&&!P.isCancellationRequested;){const[T,F]=this._asyncDeliveryQueue.shift(),U=[],Q={...F,token:P,waitUntil:re=>{if(Object.isFrozen(U))throw new Error("waitUntil can NOT be called asynchronous");M&&(re=M(re,T.callback)),U.push(re)}};try{T.invoke(Q)}catch(re){(0,v.onUnexpectedError)(re);continue}Object.freeze(U),await Promise.allSettled(U).then(re=>{for(const ue of re)ue.status==="rejected"&&(0,v.onUnexpectedError)(ue.reason)})}}}}e.AsyncEmitter=u;class c extends S{constructor(l){super(l);this._isPaused=0,this._eventQueue=new R.LinkedList,this._mergeFn=l?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const l=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(l))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(l){this._listeners&&(this._isPaused!==0?this._eventQueue.push(l):super.fire(l))}}e.PauseableEmitter=c;class s extends c{constructor(l){super(l);this._delay=l.delay??100}fire(l){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(l)}}e.DebounceEmitter=s;class r extends S{constructor(l){super(l);this._queuedEvents=[],this._mergeFn=l?.merge}fire(l){this._queuedEvents.push(l),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(P=>super.fire(P)),this._queuedEvents=[]})}}e.MicrotaskEmitter=r;class i{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new S({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(l){const P={event:l,listener:null};this.events.push(P),this.hasListeners&&this.hook(P);const M=()=>{this.hasListeners&&this.unhook(P);const T=this.events.indexOf(P);this.events.splice(T,1)};return(0,k.toDisposable)((0,t.once)(M))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(l=>this.hook(l))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(l=>this.unhook(l))}hook(l){l.listener=l.event(P=>this.emitter.fire(P))}unhook(l){l.listener&&l.listener.dispose(),l.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=i;class n{constructor(){this.buffers=[]}wrapEvent(l){return(P,M,T)=>l(F=>{const U=this.buffers[this.buffers.length-1];U?U.push(()=>P.call(M,F)):P.call(M,F)},void 0,T)}bufferEvents(l){const P=[];this.buffers.push(P);const M=l();return this.buffers.pop(),P.forEach(T=>T()),M}}e.EventBufferer=n;class o{constructor(){this.listening=!1,this.inputEvent=p.None,this.inputEventListener=k.Disposable.None,this.emitter=new S({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(l){this.inputEvent=l,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=l(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=o}),define(Z[21],ee([0,1,3]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(y,h){const p=setTimeout(y.bind(h),0);return{dispose(){clearTimeout(p)}}});var k;(function(y){function h(p){return p===y.None||p===y.Cancelled||p instanceof R?!0:!p||typeof p!="object"?!1:typeof p.isCancellationRequested=="boolean"&&typeof p.onCancellationRequested=="function"}y.isCancellationToken=h,y.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:v.Event.None}),y.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(k=e.CancellationToken||(e.CancellationToken={}));class R{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new v.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class D{constructor(h){this._token=void 0,this._parentListener=void 0,this._parentListener=h&&h.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new R),this._token}cancel(){this._token?this._token instanceof R&&this._token.cancel():this._token=k.Cancelled}dispose(h=!1){h&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof R&&this._token.dispose():this._token=k.None}}e.CancellationTokenSource=D}),define(Z[139],ee([0,1,21]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(y){this.task=y,this.result=null}get(){if(this.result)return this.result;const y=new v.CancellationTokenSource,h=this.task(y.token);return this.result={promise:h,dispose:()=>{this.result=null,y.cancel(),y.dispose()}},this.result}}e.Cache=t;class k{constructor(y){this.fn=y,this.lastCache=void 0,this.lastArgKey=void 0}get(y){const h=JSON.stringify(y);return this.lastArgKey!==h&&(this.lastArgKey=h,this.lastCache=this.fn(y)),this.lastCache}}e.LRUCachedFunction=k;class R{constructor(y){this.fn=y,this._map=new Map}get cachedValues(){return this._map}get(y){if(this._map.has(y))return this._map.get(y);const h=this.fn(y);return this._map.set(y,h),h}}e.CachedFunction=R}),define(Z[93],ee([0,1,3,2]),function(H,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const k=D=>({onDidChange:v.Event.None,value:D});e.staticObservableValue=k;class R extends t.Disposable{constructor(y){super();this._value=y,this.changeEmitter=this._register(new v.Emitter),this.onDidChange=this.changeEmitter.event}get value(){return this._value}set value(y){y!==this._value&&(this._value=y,this.changeEmitter.fire(y))}}e.MutableObservableValue=R}),define(Z[26],ee([0,1,139,125]),function(H,e,v,t){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function R(G){return!G||typeof G!="string"?!0:G.trim().length===0}e.isFalsyOrWhitespace=R;const D=/{(\d+)}/g;function y(G,...ae){return ae.length===0?G:G.replace(D,function(ge,Se){const we=parseInt(Se,10);return isNaN(we)||we<0||we>=ae.length?ge:ae[we]})}e.format=y;const h=/{([^}]+)}/g;function p(G,ae){return G.replace(h,(ge,Se)=>ae[Se]??ge)}e.format2=p;function I(G){return G.replace(/[<>&]/g,function(ae){switch(ae){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ae}})}e.escape=I;function C(G){return G.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=C;function b(G,ae){let ge=0;const Se=ae.charCodeAt(0);for(let we=G.length-1;we>=0;we--)G.charCodeAt(we)===Se&&ge++;return ge}e.count=b;function g(G,ae,ge="\u2026"){return G.length<=ae?G:`${G.substr(0,ae)}${ge}`}e.truncate=g;function d(G,ae=" "){const ge=E(G,ae);return S(ge,ae)}e.trim=d;function E(G,ae){if(!G||!ae)return G;const ge=ae.length;if(ge===0||G.length===0)return G;let Se=0;for(;G.indexOf(ae,Se)===Se;)Se=Se+ge;return G.substring(Se)}e.ltrim=E;function S(G,ae){if(!G||!ae)return G;const ge=ae.length,Se=G.length;if(ge===0||Se===0)return G;let we=Se,Ie=-1;for(;Ie=G.lastIndexOf(ae,we-1),!(Ie===-1||Ie+ge!==we);){if(Ie===0)return"";we=Ie}return G.substring(0,we)}e.rtrim=S;function f(G){return G.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=f;function w(G){return G.replace(/\*/g,"")}e.stripWildcards=w;function m(G,ae,ge={}){if(!G)throw new Error("Cannot create regex from empty string");ae||(G=C(G)),ge.wholeWord&&(/\B/.test(G.charAt(0))||(G="\\b"+G),/\B/.test(G.charAt(G.length-1))||(G=G+"\\b"));let Se="";return ge.global&&(Se+="g"),ge.matchCase||(Se+="i"),ge.multiline&&(Se+="m"),ge.unicode&&(Se+="u"),new RegExp(G,Se)}e.createRegExp=m;function u(G){return G.source==="^"||G.source==="^$"||G.source==="$"||G.source==="^\\s*$"?!1:!!(G.exec("")&&G.lastIndex===0)}e.regExpLeadsToEndlessLoop=u;function c(G){return!!G.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=c;function s(G){return(G.global?"g":"")+(G.ignoreCase?"i":"")+(G.multiline?"m":"")+(G.unicode?"u":"")}e.regExpFlags=s;function r(G){return G.split(/\r\n|\r|\n/)}e.splitLines=r;function i(G){for(let ae=0,ge=G.length;ae<ge;ae++){const Se=G.charCodeAt(ae);if(Se!==32&&Se!==9)return ae}return-1}e.firstNonWhitespaceIndex=i;function n(G,ae=0,ge=G.length){for(let Se=ae;Se<ge;Se++){const we=G.charCodeAt(Se);if(we!==32&&we!==9)return G.substring(ae,Se)}return G.substring(ae,ge)}e.getLeadingWhitespace=n;function o(G,ae=G.length-1){for(let ge=ae;ge>=0;ge--){const Se=G.charCodeAt(ge);if(Se!==32&&Se!==9)return ge}return-1}e.lastNonWhitespaceIndex=o;function a(G,ae,ge){const Se=[];let we=0;for(const Ie of G.matchAll(ae)){if(Se.push(G.slice(we,Ie.index)),Ie.index===void 0)throw new Error("match.index should be defined");we=Ie.index+Ie[0].length,Se.push(ge(Ie[0],...Ie.slice(1),Ie.index,G,Ie.groups))}return Se.push(G.slice(we)),Promise.all(Se).then(Ie=>Ie.join(""))}e.replaceAsync=a;function l(G,ae){return G<ae?-1:G>ae?1:0}e.compare=l;function P(G,ae,ge=0,Se=G.length,we=0,Ie=ae.length){for(;ge<Se&&we<Ie;ge++,we++){const Ke=G.charCodeAt(ge),Qe=ae.charCodeAt(we);if(Ke<Qe)return-1;if(Ke>Qe)return 1}const We=Se-ge,ze=Ie-we;return We<ze?-1:We>ze?1:0}e.compareSubstring=P;function M(G,ae){return T(G,ae,0,G.length,0,ae.length)}e.compareIgnoreCase=M;function T(G,ae,ge=0,Se=G.length,we=0,Ie=ae.length){for(;ge<Se&&we<Ie;ge++,we++){let Ke=G.charCodeAt(ge),Qe=ae.charCodeAt(we);if(Ke===Qe)continue;if(Ke>=128||Qe>=128)return P(G.toLowerCase(),ae.toLowerCase(),ge,Se,we,Ie);U(Ke)&&(Ke-=32),U(Qe)&&(Qe-=32);const Ye=Ke-Qe;if(Ye!==0)return Ye}const We=Se-ge,ze=Ie-we;return We<ze?-1:We>ze?1:0}e.compareSubstringIgnoreCase=T;function F(G){return G>=48&&G<=57}e.isAsciiDigit=F;function U(G){return G>=97&&G<=122}e.isLowerAsciiLetter=U;function Q(G){return G>=65&&G<=90}e.isUpperAsciiLetter=Q;function re(G,ae){return G.length===ae.length&&T(G,ae)===0}e.equalsIgnoreCase=re;function ue(G,ae){const ge=ae.length;return ae.length>G.length?!1:T(G,ae,0,ge)===0}e.startsWithIgnoreCase=ue;function fe(G,ae){const ge=Math.min(G.length,ae.length);let Se;for(Se=0;Se<ge;Se++)if(G.charCodeAt(Se)!==ae.charCodeAt(Se))return Se;return ge}e.commonPrefixLength=fe;function se(G,ae){const ge=Math.min(G.length,ae.length);let Se;const we=G.length-1,Ie=ae.length-1;for(Se=0;Se<ge;Se++)if(G.charCodeAt(we-Se)!==ae.charCodeAt(Ie-Se))return Se;return ge}e.commonSuffixLength=se;function le(G){return 55296<=G&&G<=56319}e.isHighSurrogate=le;function K(G){return 56320<=G&&G<=57343}e.isLowSurrogate=K;function N(G,ae){return(G-55296<<10)+(ae-56320)+65536}e.computeCodePoint=N;function _(G,ae,ge){const Se=G.charCodeAt(ge);if(le(Se)&&ge+1<ae){const we=G.charCodeAt(ge+1);if(K(we))return N(Se,we)}return Se}e.getNextCodePoint=_;function A(G,ae){const ge=G.charCodeAt(ae-1);if(K(ge)&&ae>1){const Se=G.charCodeAt(ae-2);if(le(Se))return N(Se,ge)}return ge}class W{constructor(ae,ge=0){this._str=ae,this._len=ae.length,this._offset=ge}get offset(){return this._offset}setOffset(ae){this._offset=ae}prevCodePoint(){const ae=A(this._str,this._offset);return this._offset-=ae>=65536?2:1,ae}nextCodePoint(){const ae=_(this._str,this._len,this._offset);return this._offset+=ae>=65536?2:1,ae}eol(){return this._offset>=this._len}}e.CodePointIterator=W;class ${constructor(ae,ge=0){this._iterator=new W(ae,ge)}get offset(){return this._iterator.offset}nextGraphemeLength(){const ae=ye.getInstance(),ge=this._iterator,Se=ge.offset;let we=ae.getGraphemeBreakType(ge.nextCodePoint());for(;!ge.eol();){const Ie=ge.offset,We=ae.getGraphemeBreakType(ge.nextCodePoint());if(oe(we,We)){ge.setOffset(Ie);break}we=We}return ge.offset-Se}prevGraphemeLength(){const ae=ye.getInstance(),ge=this._iterator,Se=ge.offset;let we=ae.getGraphemeBreakType(ge.prevCodePoint());for(;ge.offset>0;){const Ie=ge.offset,We=ae.getGraphemeBreakType(ge.prevCodePoint());if(oe(We,we)){ge.setOffset(Ie);break}we=We}return Se-ge.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=$;function Y(G,ae){return new $(G,ae).nextGraphemeLength()}e.nextCharLength=Y;function z(G,ae){return new $(G,ae).prevGraphemeLength()}e.prevCharLength=z;function j(G,ae){ae>0&&K(G.charCodeAt(ae))&&ae--;const ge=ae+Y(G,ae);return[ge-z(G,ge),ge]}e.getCharContainingOffset=j;const L=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function O(G){return L.test(G)}e.containsRTL=O;const B=/^[\t\n\r\x20-\x7E]*$/;function V(G){return B.test(G)}e.isBasicASCII=V,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function x(G){return e.UNUSUAL_LINE_TERMINATORS.test(G)}e.containsUnusualLineTerminators=x;function ie(G){return G>=11904&&G<=55215||G>=63744&&G<=64255||G>=65281&&G<=65374}e.isFullWidthCharacter=ie;function q(G){return G>=127462&&G<=127487||G===8986||G===8987||G===9200||G===9203||G>=9728&&G<=10175||G===11088||G===11093||G>=127744&&G<=128591||G>=128640&&G<=128764||G>=128992&&G<=129008||G>=129280&&G<=129535||G>=129648&&G<=129782}e.isEmojiImprecise=q;function te(G,ae){if(G.length<ae)return G;const ge=/\b/g;let Se=0;for(;ge.test(G)&&!(G.length-ge.lastIndex<ae);)Se=ge.lastIndex,ge.lastIndex+=1;return G.substring(Se).replace(/^\s/,"")}e.lcut=te;const ne=/\x1B\x5B[12]?K/g,ce=/\x1b\[\d+m/g,he=/\x1b\[0?m/g;function ke(G){return G&&(G=G.replace(ne,""),G=G.replace(ce,""),G=G.replace(he,"")),G}e.removeAnsiEscapeCodes=ke,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Le(G){return!!(G&&G.length>0&&G.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Le;function Me(G){return Le(G)?G.substr(1):G}e.stripUTF8BOM=Me;function Ae(G,ae){if(!G||!ae||G.length<ae.length)return!1;const ge=ae.length,Se=G.toLowerCase();let we=0,Ie=-1;for(;we<ge;){const We=Se.indexOf(ae[we],Ie+1);if(We<0)return!1;Ie=We,we++}return!0}e.fuzzyContains=Ae;function je(G,ae=!1){return G?(ae&&(G=G.replace(/\\./g,"")),G.toLowerCase()!==G):!1}e.containsUppercaseCharacter=je;function me(G){return G.charAt(0).toUpperCase()+G.slice(1)}e.uppercaseFirstLetter=me;function pe(G,ae=1){if(ae===0)return"";let ge=-1;do ge=G.indexOf(`
`,ge+1),ae--;while(ae>0&&ge>=0);return ge===-1?G:(G[ge-1]==="\r"&&ge--,G.substr(0,ge))}e.getNLines=pe;function Ee(G){const ae=90-65+1;return G=G%(2*ae),G<ae?String.fromCharCode(97+G):String.fromCharCode(65+G-ae)}e.singleLetterHash=Ee;function X(G){return ye.getInstance().getGraphemeBreakType(G)}e.getGraphemeBreakType=X;function oe(G,ae){return G===0?ae!==5&&ae!==7:G===2&&ae===3?!1:G===4||G===2||G===3||ae===4||ae===2||ae===3?!0:!(G===8&&(ae===8||ae===9||ae===11||ae===12)||(G===11||G===9)&&(ae===9||ae===10)||(G===12||G===10)&&ae===10||ae===5||ae===13||ae===7||G===1||G===13&&ae===14||G===6&&ae===6)}var de;(function(G){G[G.Other=0]="Other",G[G.Prepend=1]="Prepend",G[G.CR=2]="CR",G[G.LF=3]="LF",G[G.Control=4]="Control",G[G.Extend=5]="Extend",G[G.Regional_Indicator=6]="Regional_Indicator",G[G.SpacingMark=7]="SpacingMark",G[G.L=8]="L",G[G.V=9]="V",G[G.T=10]="T",G[G.LV=11]="LV",G[G.LVT=12]="LVT",G[G.ZWJ=13]="ZWJ",G[G.Extended_Pictographic=14]="Extended_Pictographic"})(de=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ye{constructor(){this._data=Ce()}static getInstance(){return ye._INSTANCE||(ye._INSTANCE=new ye),ye._INSTANCE}getGraphemeBreakType(ae){if(ae<32)return ae===10?3:ae===13?2:4;if(ae<127)return 0;const ge=this._data,Se=ge.length/3;let we=1;for(;we<=Se;)if(ae<ge[3*we])we=2*we;else if(ae>ge[3*we+1])we=2*we+1;else return ge[3*we+2];return 0}}ye._INSTANCE=null;function Ce(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Te(G,ae){if(G===0)return 0;const ge=Oe(G,ae);if(ge!==void 0)return ge;const Se=new W(ae,G);return Se.prevCodePoint(),Se.offset}e.getLeftDeleteOffset=Te;function Oe(G,ae){const ge=new W(ae,G);let Se=ge.prevCodePoint();for(;Be(Se)||Se===65039||Se===8419;){if(ge.offset===0)return;Se=ge.prevCodePoint()}if(!q(Se))return;let we=ge.offset;return we>0&&ge.prevCodePoint()===8205&&(we=ge.offset),we}function Be(G){return 127995<=G&&G<=127999}var Ne;(function(G){G[G.zwj=8205]="zwj",G[G.emojiVariantSelector=65039]="emojiVariantSelector",G[G.enclosingKeyCap=8419]="enclosingKeyCap"})(Ne||(Ne={})),e.noBreakWhitespace="\xA0";class Ue{constructor(ae){this.confusableDictionary=ae}static getInstance(ae){return Ue.cache.get(Array.from(ae))}static getLocales(){return Ue._locales.getValue()}isAmbiguous(ae){return this.confusableDictionary.has(ae)}getPrimaryConfusable(ae){return this.confusableDictionary.get(ae)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=Ue,k=Ue,Ue.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Ue.cache=new v.LRUCachedFunction(G=>{function ae(Qe){const Ye=new Map;for(let et=0;et<Qe.length;et+=2)Ye.set(Qe[et],Qe[et+1]);return Ye}function ge(Qe,Ye){const et=new Map(Qe);for(const[at,ct]of Ye)et.set(at,ct);return et}function Se(Qe,Ye){if(!Qe)return Ye;const et=new Map;for(const[at,ct]of Qe)Ye.has(at)&&et.set(at,ct);return et}const we=k.ambiguousCharacterData.getValue();let Ie=G.filter(Qe=>!Qe.startsWith("_")&&Qe in we);Ie.length===0&&(Ie=["_default"]);let We;for(const Qe of Ie){const Ye=ae(we[Qe]);We=Se(We,Ye)}const ze=ae(we._common),Ke=ge(ze,We);return new Ue(Ke)}),Ue._locales=new t.Lazy(()=>Object.keys(Ue.ambiguousCharacterData.getValue()).filter(G=>!G.startsWith("_")));class qe{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(qe.getRawData())),this._data}static isInvisibleCharacter(ae){return qe.getData().has(ae)}static get codePoints(){return qe.getData()}}e.InvisibleCharacters=qe,qe._data=void 0}),define(Z[31],ee([0,1,9,4,26,12]),function(H,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function D(o){return o===47||o===92}e.isPathSeparator=D;function y(o){return o.replace(/[\\/]/g,v.posix.sep)}e.toSlashes=y;function h(o){return o.indexOf("/")===-1&&(o=y(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.toPosixPath=h;function p(o,a=v.posix.sep){if(!o)return"";const l=o.length,P=o.charCodeAt(0);if(D(P)){if(D(o.charCodeAt(1))&&!D(o.charCodeAt(2))){let T=3;const F=T;for(;T<l&&!D(o.charCodeAt(T));T++);if(F!==T&&!D(o.charCodeAt(T+1))){for(T+=1;T<l;T++)if(D(o.charCodeAt(T)))return o.slice(0,T+1).replace(/[\\/]/g,a)}}return a}else if(f(P)&&o.charCodeAt(1)===58)return D(o.charCodeAt(2))?o.slice(0,2)+a:o.slice(0,2);let M=o.indexOf("://");if(M!==-1){for(M+=3;M<l;M++)if(D(o.charCodeAt(M)))return o.slice(0,M+1)}return""}e.getRoot=p;function I(o){if(!t.isWindows||!o||o.length<5)return!1;let a=o.charCodeAt(0);if(a!==92||(a=o.charCodeAt(1),a!==92))return!1;let l=2;const P=l;for(;l<o.length&&(a=o.charCodeAt(l),a!==92);l++);return!(P===l||(a=o.charCodeAt(l+1),isNaN(a)||a===92))}e.isUNC=I;const C=/[\\/:\*\?"<>\|]/g,b=/[\\/]/g,g=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(o,a=t.isWindows){const l=a?C:b;return!(!o||o.length===0||/^\s+$/.test(o)||(l.lastIndex=0,l.test(o))||a&&g.test(o)||o==="."||o===".."||a&&o[o.length-1]==="."||a&&o.length!==o.trim().length||o.length>255)}e.isValidBasename=d;function E(o,a,l){const P=o===a;return!l||P?P:!o||!a?!1:(0,k.equalsIgnoreCase)(o,a)}e.isEqual=E;function S(o,a,l,P=v.sep){if(o===a)return!0;if(!o||!a||a.length>o.length)return!1;if(l){if(!(0,k.startsWithIgnoreCase)(o,a))return!1;if(a.length===o.length)return!0;let T=a.length;return a.charAt(a.length-1)===P&&T--,o.charAt(T)===P}return a.charAt(a.length-1)!==P&&(a+=P),o.indexOf(a)===0}e.isEqualOrParent=S;function f(o){return o>=65&&o<=90||o>=97&&o<=122}e.isWindowsDriveLetter=f;function w(o,a){return t.isWindows&&o.endsWith(":")&&(o+=v.sep),(0,v.isAbsolute)(o)||(o=(0,v.join)(a,o)),o=(0,v.normalize)(o),t.isWindows?(o=(0,k.rtrim)(o,v.sep),o.endsWith(":")&&(o+=v.sep)):(o=(0,k.rtrim)(o,v.sep),o||(o=v.sep)),o}e.sanitizeFilePath=w;function m(o){const a=(0,v.normalize)(o);return t.isWindows?o.length>3?!1:u(a)&&(o.length===2||a.charCodeAt(2)===92):a===v.posix.sep}e.isRootOrDriveLetter=m;function u(o,a=t.isWindows){return a?f(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.hasDriveLetter=u;function c(o){return u(o)?o[0]:void 0}e.getDriveLetter=c;function s(o,a,l){return a.length>o.length?-1:o===a?0:(l&&(o=o.toLowerCase(),a=a.toLowerCase()),o.indexOf(a))}e.indexOfPath=s;function r(o){const a=o.split(":");let l,P,M;for(const T of a){const F=Number(T);(0,R.isNumber)(F)?P===void 0?P=F:M===void 0&&(M=F):l=l?[l,T].join(":"):T}if(!l)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:l,line:P!==void 0?P:void 0,column:M!==void 0?M:P!==void 0?1:void 0}}e.parseLineAndColumnAware=r;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function n(o,a,l=8){let P="";for(let T=0;T<l;T++)P+=i.charAt(Math.floor(Math.random()*i.length));let M;return a?M=`${a}-${P}`:M=P,o?(0,v.join)(o,M):M}e.randomPath=n}),define(Z[67],ee([0,1,26]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(f){return k(f,0)}e.hash=t;function k(f,w){switch(typeof f){case"object":return f===null?R(349,w):Array.isArray(f)?h(f,w):p(f,w);case"string":return y(f,w);case"boolean":return D(f,w);case"number":return R(f,w);case"undefined":return R(937,w);default:return R(617,w)}}e.doHash=k;function R(f,w){return(w<<5)-w+f|0}e.numberHash=R;function D(f,w){return R(f?433:863,w)}function y(f,w){w=R(149417,w);for(let m=0,u=f.length;m<u;m++)w=R(f.charCodeAt(m),w);return w}e.stringHash=y;function h(f,w){return w=R(104579,w),f.reduce((m,u)=>k(u,m),w)}function p(f,w){return w=R(181387,w),Object.keys(f).sort().reduce((m,u)=>(m=y(u,m),k(f[u],m)),w)}class I{constructor(){this._value=0}get value(){return this._value}hash(w){return this._value=k(w,this._value),this._value}}e.Hasher=I;var C;(function(f){f[f.BLOCK_SIZE=64]="BLOCK_SIZE",f[f.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function b(f,w,m=32){const u=m-w,c=~((1<<u)-1);return(f<<w|(c&f)>>>u)>>>0}function g(f,w=0,m=f.byteLength,u=0){for(let c=0;c<m;c++)f[w+c]=u}function d(f,w,m="0"){for(;f.length<w;)f=m+f;return f}function E(f,w=32){return f instanceof ArrayBuffer?Array.from(new Uint8Array(f)).map(m=>m.toString(16).padStart(2,"0")).join(""):d((f>>>0).toString(16),w/4)}e.toHexString=E;class S{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(w){const m=w.length;if(m===0)return;const u=this._buff;let c=this._buffLen,s=this._leftoverHighSurrogate,r,i;for(s!==0?(r=s,i=-1,s=0):(r=w.charCodeAt(0),i=0);;){let n=r;if(v.isHighSurrogate(r))if(i+1<m){const o=w.charCodeAt(i+1);v.isLowSurrogate(o)?(i++,n=v.computeCodePoint(r,o)):n=65533}else{s=r;break}else v.isLowSurrogate(r)&&(n=65533);if(c=this._push(u,c,n),i++,i<m)r=w.charCodeAt(i);else break}this._buffLen=c,this._leftoverHighSurrogate=s}_push(w,m,u){return u<128?w[m++]=u:u<2048?(w[m++]=192|(u&1984)>>>6,w[m++]=128|(u&63)>>>0):u<65536?(w[m++]=224|(u&61440)>>>12,w[m++]=128|(u&4032)>>>6,w[m++]=128|(u&63)>>>0):(w[m++]=240|(u&1835008)>>>18,w[m++]=128|(u&258048)>>>12,w[m++]=128|(u&4032)>>>6,w[m++]=128|(u&63)>>>0),m>=64&&(this._step(),m-=64,this._totalLen+=64,w[0]=w[64+0],w[1]=w[64+1],w[2]=w[64+2]),m}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),E(this._h0)+E(this._h1)+E(this._h2)+E(this._h3)+E(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,g(this._buff,this._buffLen),this._buffLen>56&&(this._step(),g(this._buff));const w=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(w/4294967296),!1),this._buffDV.setUint32(60,w%4294967296,!1),this._step()}_step(){const w=S._bigBlock32,m=this._buffDV;for(let l=0;l<64;l+=4)w.setUint32(l,m.getUint32(l,!1),!1);for(let l=64;l<320;l+=4)w.setUint32(l,b(w.getUint32(l-12,!1)^w.getUint32(l-32,!1)^w.getUint32(l-56,!1)^w.getUint32(l-64,!1),1),!1);let u=this._h0,c=this._h1,s=this._h2,r=this._h3,i=this._h4,n,o,a;for(let l=0;l<80;l++)l<20?(n=c&s|~c&r,o=1518500249):l<40?(n=c^s^r,o=1859775393):l<60?(n=c&s|c&r|s&r,o=2400959708):(n=c^s^r,o=3395469782),a=b(u,5)+n+i+o+w.getUint32(l*4,!1)&4294967295,i=r,r=s,s=b(c,30),c=u,u=a;this._h0=this._h0+u&4294967295,this._h1=this._h1+c&4294967295,this._h2=this._h2+s&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+i&4294967295}}e.StringSHA1=S,S._bigBlock32=new DataView(new ArrayBuffer(320))}),define(Z[32],ee([0,1,24,26]),function(H,e,v,t){"use strict";var k,R,D;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function y(i,n,o){let a=i.get(n);return a===void 0&&(a=o,i.set(n,a)),a}e.getOrSet=y;function h(i){const n=[];return i.forEach((o,a)=>{n.push(`${a} => ${o}`)}),`Map(${i.size}) {${n.join(", ")}}`}e.mapToString=h;function p(i){const n=[];return i.forEach(o=>{n.push(o)}),`Set(${i.size}) {${n.join(", ")}}`}e.setToString=p;class I{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const o=n.charCodeAt(0),a=this._value.charCodeAt(this._pos);return o-a}value(){return this._value[this._pos]}}e.StringIterator=I;class C{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,t.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=C;class b{constructor(n=!0,o=!0){this._splitOnBackslash=n,this._caseSensitive=o}reset(n){this._from=0,this._to=0,this._value=n,this._valueLen=n.length;for(let o=n.length-1;o>=0;o--,this._valueLen--){const a=this._value.charCodeAt(o);if(!(a===47||this._splitOnBackslash&&a===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let n=!0;for(;this._to<this._valueLen;this._to++){const o=this._value.charCodeAt(this._to);if(o===47||this._splitOnBackslash&&o===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,t.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=b;var g;(function(i){i[i.Scheme=1]="Scheme",i[i.Authority=2]="Authority",i[i.Path=3]="Path",i[i.Query=4]="Query",i[i.Fragment=5]="Fragment"})(g||(g={}));class d{constructor(n,o){this._ignorePathCasing=n,this._ignoreQueryAndFragment=o,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new b(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(n)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,t.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=d;class E{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const n=this.right;return this.right=n.left,n.left=this,this.updateHeight(),n.updateHeight(),n}rotateRight(){const n=this.left;return this.left=n.right,n.right=this,this.updateHeight(),n.updateHeight(),n}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var S;(function(i){i[i.Left=-1]="Left",i[i.Mid=0]="Mid",i[i.Right=1]="Right"})(S||(S={}));class f{constructor(n){this._iter=n}static forUris(n=()=>!1,o=()=>!1){return new f(new d(n,o))}static forPaths(n=!1){return new f(new b(void 0,!n))}static forStrings(){return new f(new I)}static forConfigKeys(){return new f(new C)}clear(){this._root=void 0}fill(n,o){if(o){const a=o.slice(0);(0,v.shuffle)(a);for(const l of a)this.set(l,n)}else{const a=n.slice(0);(0,v.shuffle)(a);for(const l of a)this.set(l[0],l[1])}}set(n,o){const a=this._iter.reset(n);let l;this._root||(this._root=new E,this._root.segment=a.value());const P=[];for(l=this._root;;){const T=a.cmp(l.segment);if(T>0)l.left||(l.left=new E,l.left.segment=a.value()),P.push([-1,l]),l=l.left;else if(T<0)l.right||(l.right=new E,l.right.segment=a.value()),P.push([1,l]),l=l.right;else if(a.hasNext())a.next(),l.mid||(l.mid=new E,l.mid.segment=a.value()),P.push([0,l]),l=l.mid;else break}const M=l.value;l.value=o,l.key=n;for(let T=P.length-1;T>=0;T--){const F=P[T][1];F.updateHeight();const U=F.balanceFactor();if(U<-1||U>1){const Q=P[T][0],re=P[T+1][0];if(Q===1&&re===1)P[T][1]=F.rotateLeft();else if(Q===-1&&re===-1)P[T][1]=F.rotateRight();else if(Q===1&&re===-1)F.right=P[T+1][1]=P[T+1][1].rotateRight(),P[T][1]=F.rotateLeft();else if(Q===-1&&re===1)F.left=P[T+1][1]=P[T+1][1].rotateLeft(),P[T][1]=F.rotateRight();else throw new Error;if(T>0)switch(P[T-1][0]){case-1:P[T-1][1].left=P[T][1];break;case 1:P[T-1][1].right=P[T][1];break;case 0:P[T-1][1].mid=P[T][1];break}else this._root=P[0][1]}}return M}get(n){return this._getNode(n)?.value}_getNode(n){const o=this._iter.reset(n);let a=this._root;for(;a;){const l=o.cmp(a.segment);if(l>0)a=a.left;else if(l<0)a=a.right;else if(o.hasNext())o.next(),a=a.mid;else break}return a}has(n){const o=this._getNode(n);return!(o?.value===void 0&&o?.mid===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,o){const a=this._iter.reset(n),l=[];let P=this._root;for(;P;){const M=a.cmp(P.segment);if(M>0)l.push([-1,P]),P=P.left;else if(M<0)l.push([1,P]),P=P.right;else if(a.hasNext())a.next(),l.push([0,P]),P=P.mid;else break}if(!!P){if(o?(P.left=void 0,P.mid=void 0,P.right=void 0,P.height=1):(P.key=void 0,P.value=void 0),!P.mid&&!P.value)if(P.left&&P.right){const M=this._min(P.right),{key:T,value:F,segment:U}=M;this._delete(M.key,!1),P.key=T,P.value=F,P.segment=U}else{const M=P.left??P.right;if(l.length>0){const[T,F]=l[l.length-1];switch(T){case-1:F.left=M;break;case 0:F.mid=M;break;case 1:F.right=M;break}}else this._root=M}for(let M=l.length-1;M>=0;M--){const T=l[M][1];T.updateHeight();const F=T.balanceFactor();if(F>1?(T.right.balanceFactor()>=0||(T.right=T.right.rotateRight()),l[M][1]=T.rotateLeft()):F<-1&&(T.left.balanceFactor()<=0||(T.left=T.left.rotateLeft()),l[M][1]=T.rotateRight()),M>0)switch(l[M-1][0]){case-1:l[M-1][1].left=l[M][1];break;case 1:l[M-1][1].right=l[M][1];break;case 0:l[M-1][1].mid=l[M][1];break}else this._root=l[0][1]}}}_min(n){for(;n.left;)n=n.left;return n}findSubstr(n){const o=this._iter.reset(n);let a=this._root,l;for(;a;){const P=o.cmp(a.segment);if(P>0)a=a.left;else if(P<0)a=a.right;else if(o.hasNext())o.next(),l=a.value||l,a=a.mid;else break}return a&&a.value||l}findSuperstr(n){const o=this._iter.reset(n);let a=this._root;for(;a;){const l=o.cmp(a.segment);if(l>0)a=a.left;else if(l<0)a=a.right;else if(o.hasNext())o.next(),a=a.mid;else return a.mid?this._entries(a.mid):void 0}}forEach(n){for(const[o,a]of this)n(a,o)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(n){const o=[];return this._dfsEntries(n,o),o[Symbol.iterator]()}_dfsEntries(n,o){!n||(n.left&&this._dfsEntries(n.left,o),n.value&&o.push([n.key,n.value]),n.mid&&this._dfsEntries(n.mid,o),n.right&&this._dfsEntries(n.right,o))}_isBalanced(){const n=o=>{if(!o)return!0;const a=o.balanceFactor();return a<-1||a>1?!1:n(o.left)&&n(o.right)};return n(this._root)}}e.TernarySearchTree=f;class w{constructor(n,o){this.uri=n,this.value=o}}class m{constructor(n,o){this[k]="ResourceMap",n instanceof m?(this.map=new Map(n.map),this.toKey=o??m.defaultToKey):(this.map=new Map,this.toKey=n??m.defaultToKey)}set(n,o){return this.map.set(this.toKey(n),new w(n,o)),this}get(n){return this.map.get(this.toKey(n))?.value}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,o){typeof o!="undefined"&&(n=n.bind(o));for(const[a,l]of this.map)n(l.value,l.uri,this)}*values(){for(const n of this.map.values())yield n.value}*keys(){for(const n of this.map.values())yield n.uri}*entries(){for(const n of this.map.values())yield[n.uri,n.value]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.map)yield[n.uri,n.value]}}e.ResourceMap=m,m.defaultToKey=i=>i.toString();class u{constructor(n,o){this[R]="ResourceSet",!n||typeof n=="function"?this._map=new m(n):(this._map=new m(o),n.forEach(this.add,this))}get size(){return this._map.size}add(n){return this._map.set(n,n),this}clear(){this._map.clear()}delete(n){return this._map.delete(n)}forEach(n,o){this._map.forEach((a,l)=>n.call(o,l,l,this))}has(n){return this._map.has(n)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=u;var c;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(c=e.Touch||(e.Touch={}));class s{constructor(){this[D]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(n){return this._map.has(n)}get(n,o=0){const a=this._map.get(n);if(!!a)return o!==0&&this.touch(a,o),a.value}set(n,o,a=0){let l=this._map.get(n);if(l)l.value=o,a!==0&&this.touch(l,a);else{switch(l={key:n,value:o,next:void 0,previous:void 0},a){case 0:this.addItemLast(l);break;case 1:this.addItemFirst(l);break;case 2:this.addItemLast(l);break;default:this.addItemLast(l);break}this._map.set(n,l),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const o=this._map.get(n);if(!!o)return this._map.delete(n),this.removeItem(o),this._size--,o.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,o){const a=this._state;let l=this._head;for(;l;){if(o?n.bind(o)(l.value,l.key,this):n(l.value,l.key,this),this._state!==a)throw new Error("LinkedMap got modified during iteration.");l=l.next}}keys(){const n=this,o=this._state;let a=this._head;const l={[Symbol.iterator](){return l},next(){if(n._state!==o)throw new Error("LinkedMap got modified during iteration.");if(a){const P={value:a.key,done:!1};return a=a.next,P}else return{value:void 0,done:!0}}};return l}values(){const n=this,o=this._state;let a=this._head;const l={[Symbol.iterator](){return l},next(){if(n._state!==o)throw new Error("LinkedMap got modified during iteration.");if(a){const P={value:a.value,done:!1};return a=a.next,P}else return{value:void 0,done:!0}}};return l}entries(){const n=this,o=this._state;let a=this._head;const l={[Symbol.iterator](){return l},next(){if(n._state!==o)throw new Error("LinkedMap got modified during iteration.");if(a){const P={value:[a.key,a.value],done:!1};return a=a.next,P}else return{value:void 0,done:!0}}};return l}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let o=this._head,a=this.size;for(;o&&a>n;)this._map.delete(o.key),o=o.next,a--;this._head=o,this._size=a,o&&(o.previous=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const o=n.next,a=n.previous;if(!o||!a)throw new Error("Invalid list");o.previous=a,a.next=o}n.next=void 0,n.previous=void 0,this._state++}touch(n,o){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(n===this._head)return;const a=n.next,l=n.previous;n===this._tail?(l.next=void 0,this._tail=l):(a.previous=l,l.next=a),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(o===2){if(n===this._tail)return;const a=n.next,l=n.previous;n===this._head?(a.previous=void 0,this._head=a):(a.previous=l,l.next=a),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((o,a)=>{n.push([a,o])}),n}fromJSON(n){this.clear();for(const[o,a]of n)this.set(o,a)}}e.LinkedMap=s;class r extends s{constructor(n,o=1){super();this._limit=n,this._ratio=Math.min(Math.max(0,o),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,o=2){return super.get(n,o)}peek(n){return super.get(n,0)}set(n,o){return super.set(n,o,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=r}),define(Z[80],ee([0,1,32]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new v.LRUCache(1e4);function k(p){return h(p,"NFC",t)}e.normalizeNFC=k;const R=new v.LRUCache(1e4);function D(p){return h(p,"NFD",R)}e.normalizeNFD=D;const y=/[^\u0000-\u0080]/;function h(p,I,C){if(!p)return p;const b=C.get(p);if(b)return b;let g;return y.test(p)?g=p.normalize(I):g=p,C.set(p,g),g}e.removeAccents=function(){const p=/[\u0300-\u036f]/g;return function(I){return D(I).replace(p,"")}}()}),define(Z[94],ee([0,1,26]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(t||(t={})),function(k){const R="error",D="warning",y="warn",h="info",p="ignore";function I(b){return b?v.equalsIgnoreCase(R,b)?k.Error:v.equalsIgnoreCase(D,b)||v.equalsIgnoreCase(y,b)?k.Warning:v.equalsIgnoreCase(h,b)?k.Info:k.Ignore:k.Ignore}k.fromValue=I;function C(b){switch(b){case k.Error:return R;case k.Warning:return D;case k.Info:return h;default:return p}}k.toString=C}(t||(t={})),e.default=t}),define(Z[7],ee([0,1,9,4]),function(H,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,R=/^\//,D=/^\/\//;function y(i,n){if(!i.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!k.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!R.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function h(i,n){return!i&&!n?"file":i}function p(i,n){switch(i){case"https":case"http":case"file":n?n[0]!==C&&(n=C+n):n=C;break}return n}const I="",C="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class g{constructor(n,o,a,l,P,M=!1){typeof n=="object"?(this.scheme=n.scheme||I,this.authority=n.authority||I,this.path=n.path||I,this.query=n.query||I,this.fragment=n.fragment||I):(this.scheme=h(n,M),this.authority=o||I,this.path=p(this.scheme,a||I),this.query=l||I,this.fragment=P||I,y(this,M))}static isUri(n){return n instanceof g?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}get fsPath(){return m(this,!1)}with(n){if(!n)return this;let{scheme:o,authority:a,path:l,query:P,fragment:M}=n;return o===void 0?o=this.scheme:o===null&&(o=I),a===void 0?a=this.authority:a===null&&(a=I),l===void 0?l=this.path:l===null&&(l=I),P===void 0?P=this.query:P===null&&(P=I),M===void 0?M=this.fragment:M===null&&(M=I),o===this.scheme&&a===this.authority&&l===this.path&&P===this.query&&M===this.fragment?this:new E(o,a,l,P,M)}static parse(n,o=!1){const a=b.exec(n);return a?new E(a[2]||I,r(a[4]||I),r(a[5]||I),r(a[7]||I),r(a[9]||I),o):new E(I,I,I,I,I)}static file(n){let o=I;if(t.isWindows&&(n=n.replace(/\\/g,C)),n[0]===C&&n[1]===C){const a=n.indexOf(C,2);a===-1?(o=n.substring(2),n=C):(o=n.substring(2,a),n=n.substring(a)||C)}return new E("file",o,n,I,I)}static from(n){const o=new E(n.scheme,n.authority,n.path,n.query,n.fragment);return y(o,!0),o}static joinPath(n,...o){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return t.isWindows&&n.scheme==="file"?a=g.file(v.win32.join(m(n,!0),...o)).path:a=v.posix.join(n.path,...o),n.with({path:a})}toString(n=!1){return u(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof g)return n;{const o=new E(n);return o._formatted=n.external,o._fsPath=n._sep===d?n.fsPath:null,o}}else return n}}e.URI=g;const d=t.isWindows?1:void 0;class E extends g{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=m(this,!1)),this._fsPath}toString(n=!1){return n?u(this,!0):(this._formatted||(this._formatted=u(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=d),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const S={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function f(i,n){let o,a=-1;for(let l=0;l<i.length;l++){const P=i.charCodeAt(l);if(P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57||P===45||P===46||P===95||P===126||n&&P===47)a!==-1&&(o+=encodeURIComponent(i.substring(a,l)),a=-1),o!==void 0&&(o+=i.charAt(l));else{o===void 0&&(o=i.substr(0,l));const M=S[P];M!==void 0?(a!==-1&&(o+=encodeURIComponent(i.substring(a,l)),a=-1),o+=M):a===-1&&(a=l)}}return a!==-1&&(o+=encodeURIComponent(i.substring(a))),o!==void 0?o:i}function w(i){let n;for(let o=0;o<i.length;o++){const a=i.charCodeAt(o);a===35||a===63?(n===void 0&&(n=i.substr(0,o)),n+=S[a]):n!==void 0&&(n+=i[o])}return n!==void 0?n:i}function m(i,n){let o;return i.authority&&i.path.length>1&&i.scheme==="file"?o=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?n?o=i.path.substr(1):o=i.path[1].toLowerCase()+i.path.substr(2):o=i.path,t.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=m;function u(i,n){const o=n?w:f;let a="",{scheme:l,authority:P,path:M,query:T,fragment:F}=i;if(l&&(a+=l,a+=":"),(P||l==="file")&&(a+=C,a+=C),P){let U=P.indexOf("@");if(U!==-1){const Q=P.substr(0,U);P=P.substr(U+1),U=Q.indexOf(":"),U===-1?a+=o(Q,!1):(a+=o(Q.substr(0,U),!1),a+=":",a+=o(Q.substr(U+1),!1)),a+="@"}P=P.toLowerCase(),U=P.indexOf(":"),U===-1?a+=o(P,!1):(a+=o(P.substr(0,U),!1),a+=P.substr(U))}if(M){if(M.length>=3&&M.charCodeAt(0)===47&&M.charCodeAt(2)===58){const U=M.charCodeAt(1);U>=65&&U<=90&&(M=`/${String.fromCharCode(U+32)}:${M.substr(3)}`)}else if(M.length>=2&&M.charCodeAt(1)===58){const U=M.charCodeAt(0);U>=65&&U<=90&&(M=`${String.fromCharCode(U+32)}:${M.substr(2)}`)}a+=o(M,!0)}return T&&(a+="?",a+=o(T,!1)),F&&(a+="#",a+=n?F:f(F,!1)),a}function c(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+c(i.substr(3)):i}}const s=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(i){return i.match(s)?i.replace(s,n=>c(n)):i}}),define(Z[140],ee([0,1,7]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function t(p){const I=p;return I&&typeof I.type=="string"&&typeof I.severity=="string"}e.isRemoteConsoleLog=t;function k(p){const I=[];let C;try{const b=JSON.parse(p.arguments),g=b[b.length-1];g&&g.__$stack&&(b.pop(),C=g.__$stack),I.push(...b)}catch{I.push("Unable to log remote console arguments",p.arguments)}return{args:I,stack:C}}e.parse=k;function R(p){if(typeof p!="string")return R(k(p).stack);const I=p;if(I){const C=D(I),b=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(C||"");if(b&&b.length===4)return{uri:v.URI.file(b[1]),line:Number(b[2]),column:Number(b[3])}}}e.getFirstFrame=R;function D(p){if(!p)return p;const I=p.indexOf(`
`);return I===-1?p:p.substring(0,I)}function y(p,I){const{args:C,stack:b}=k(p),g=typeof C[0]=="string"&&C.length===1;let d=D(b);d&&(d=`(${d.trim()})`);let E=[];if(typeof C[0]=="string"?d&&g?E=[`%c[${I}] %c${C[0]} %c${d}`,h("blue"),h(""),h("grey")]:E=[`%c[${I}] %c${C[0]}`,h("blue"),h(""),...C.slice(1)]:E=[`%c[${I}]%`,h("blue"),...C],d&&!g&&E.push(d),typeof console[p.severity]!="function")throw new Error("Unknown console method");console[p.severity].apply(console,E)}e.log=y;function h(p){return`color: ${p}`}}),define(Z[57],ee([0,1,17,26,7]),function(H,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function R(p){return JSON.stringify(p,y)}e.stringify=R;function D(p){let I=JSON.parse(p);return I=h(I),I}e.parse=D;function y(p,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:(0,t.regExpFlags)(I)}:I}function h(p,I=0){if(!p||I>200)return p;if(typeof p=="object"){switch(p.$mid){case 1:return k.URI.revive(p);case 2:return new RegExp(p.source,p.flags);case 14:return new Date(p.source)}if(p instanceof v.VSBuffer||p instanceof Uint8Array)return p;if(Array.isArray(p))for(let C=0;C<p.length;++C)p[C]=h(p[C],I+1);else for(const C in p)Object.hasOwnProperty.call(p,C)&&(p[C]=h(p[C],I+1))}return p}e.revive=h}),define(Z[13],ee([0,1,4,7]),function(H,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var k;(function(y){y.inMemory="inmemory",y.vscode="vscode",y.internal="private",y.walkThrough="walkThrough",y.walkThroughSnippet="walkThroughSnippet",y.http="http",y.https="https",y.file="file",y.mailto="mailto",y.untitled="untitled",y.data="data",y.command="command",y.vscodeRemote="vscode-remote",y.vscodeRemoteResource="vscode-remote-resource",y.vscodeUserData="vscode-userdata",y.vscodeCustomEditor="vscode-custom-editor",y.vscodeNotebook="vscode-notebook",y.vscodeNotebookCell="vscode-notebook-cell",y.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",y.vscodeNotebookCellOutput="vscode-notebook-cell-output",y.vscodeInteractive="vscode-interactive",y.vscodeInteractiveInput="vscode-interactive-input",y.vscodeSettings="vscode-settings",y.vscodeWorkspaceTrust="vscode-workspace-trust",y.vscodeTerminal="vscode-terminal",y.webviewPanel="webview-panel",y.vscodeWebview="vscode-webview",y.extension="extension",y.vscodeFileResource="vscode-file",y.tmp="tmp",y.vsls="vsls",y.vscodeSourceControl="vscode-scm"})(k=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class R{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${k.vscodeRemoteResource}`}setPreferredWebSchema(h){this._preferredWebSchema=h}setDelegate(h){this._delegate=h}setServerRootPath(h){this._remoteResourcesPath=`${h}/${k.vscodeRemoteResource}`}set(h,p,I){this._hosts[h]=p,this._ports[h]=I}setConnectionToken(h,p){this._connectionTokens[h]=p}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(h){if(this._delegate)return this._delegate(h);const p=h.authority;let I=this._hosts[p];I&&I.indexOf(":")!==-1&&(I=`[${I}]`);const C=this._ports[p],b=this._connectionTokens[p];let g=`path=${encodeURIComponent(h.path)}`;return typeof b=="string"&&(g+=`&${e.connectionTokenQueryName}=${encodeURIComponent(b)}`),t.URI.from({scheme:v.isWeb?this._preferredWebSchema:k.vscodeRemoteResource,authority:`${I}:${C}`,path:this._remoteResourcesPath,query:g})}}e.RemoteAuthorities=new R;class D{asBrowserUri(h,p){const I=this.toUri(h,p);return I.scheme===k.vscodeRemote?e.RemoteAuthorities.rewrite(I):I.scheme===k.file&&(v.isNative||v.isWebWorker&&v.globals.origin===`${k.vscodeFileResource}://${D.FALLBACK_AUTHORITY}`)?I.with({scheme:k.vscodeFileResource,authority:I.authority||D.FALLBACK_AUTHORITY,query:null,fragment:null}):I}asFileUri(h,p){const I=this.toUri(h,p);return I.scheme===k.vscodeFileResource?I.with({scheme:k.file,authority:I.authority!==D.FALLBACK_AUTHORITY?I.authority:null,query:null,fragment:null}):I}toUri(h,p){return t.URI.isUri(h)?h:t.URI.parse(p.toUrl(h))}}D.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new D}),define(Z[16],ee([0,1,31,13,9,4,26,7]),function(H,e,v,t,k,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function h(g){return(0,y.uriToFsPath)(g,!0)}e.originalFSPath=h;class p{constructor(d){this._ignorePathCasing=d}compare(d,E,S=!1){return d===E?0:(0,D.compare)(this.getComparisonKey(d,S),this.getComparisonKey(E,S))}isEqual(d,E,S=!1){return d===E?!0:!d||!E?!1:this.getComparisonKey(d,S)===this.getComparisonKey(E,S)}getComparisonKey(d,E=!1){return d.with({path:this._ignorePathCasing(d)?d.path.toLowerCase():void 0,fragment:E?null:void 0}).toString()}ignorePathCasing(d){return this._ignorePathCasing(d)}isEqualOrParent(d,E,S=!1){if(d.scheme===E.scheme){if(d.scheme===t.Schemas.file)return v.isEqualOrParent(h(d),h(E),this._ignorePathCasing(d))&&d.query===E.query&&(S||d.fragment===E.fragment);if((0,e.isEqualAuthority)(d.authority,E.authority))return v.isEqualOrParent(d.path,E.path,this._ignorePathCasing(d),"/")&&d.query===E.query&&(S||d.fragment===E.fragment)}return!1}joinPath(d,...E){return y.URI.joinPath(d,...E)}basenameOrAuthority(d){return(0,e.basename)(d)||d.authority}basename(d){return k.posix.basename(d.path)}extname(d){return k.posix.extname(d.path)}dirname(d){if(d.path.length===0)return d;let E;return d.scheme===t.Schemas.file?E=y.URI.file(k.dirname(h(d))).path:(E=k.posix.dirname(d.path),d.authority&&E.length&&E.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),E="/")),d.with({path:E})}normalizePath(d){if(!d.path.length)return d;let E;return d.scheme===t.Schemas.file?E=y.URI.file(k.normalize(h(d))).path:E=k.posix.normalize(d.path),d.with({path:E})}relativePath(d,E){if(d.scheme!==E.scheme||!(0,e.isEqualAuthority)(d.authority,E.authority))return;if(d.scheme===t.Schemas.file){const w=k.relative(h(d),h(E));return R.isWindows?v.toSlashes(w):w}let S=d.path||"/";const f=E.path||"/";if(this._ignorePathCasing(d)){let w=0;for(const m=Math.min(S.length,f.length);w<m&&!(S.charCodeAt(w)!==f.charCodeAt(w)&&S.charAt(w).toLowerCase()!==f.charAt(w).toLowerCase());w++);S=f.substr(0,w)+S.substr(w)}return k.posix.relative(S,f)}resolvePath(d,E){if(d.scheme===t.Schemas.file){const S=y.URI.file(k.resolve(h(d),E));return d.with({authority:S.authority,path:S.path})}return E=v.toPosixPath(E),d.with({path:k.posix.resolve(d.path,E)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,E){return d===E||d!==void 0&&E!==void 0&&(0,D.equalsIgnoreCase)(d,E)}hasTrailingPathSeparator(d,E=k.sep){if(d.scheme===t.Schemas.file){const S=h(d);return S.length>v.getRoot(S).length&&S[S.length-1]===E}else{const S=d.path;return S.length>1&&S.charCodeAt(S.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,E=k.sep){return(0,e.hasTrailingPathSeparator)(d,E)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,E=k.sep){let S=!1;if(d.scheme===t.Schemas.file){const f=h(d);S=f!==void 0&&f.length===v.getRoot(f).length&&f[f.length-1]===E}else{E="/";const f=d.path;S=f.length===1&&f.charCodeAt(f.length-1)===47}return!S&&!(0,e.hasTrailingPathSeparator)(d,E)?d.with({path:d.path+"/"}):d}}e.ExtUri=p,e.extUri=new p(()=>!1),e.extUriBiasedIgnorePathCase=new p(g=>g.scheme===t.Schemas.file?!R.isLinux:!0),e.extUriIgnorePathCase=new p(g=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function I(g,d){const E=[];for(let S=0;S<g.length;S++){const f=d(g[S]);g.some((w,m)=>m===S?!1:(0,e.isEqualOrParent)(f,d(w)))||E.push(g[S])}return E}e.distinctParents=I;var C;(function(g){g.META_DATA_LABEL="label",g.META_DATA_DESCRIPTION="description",g.META_DATA_SIZE="size",g.META_DATA_MIME="mime";function d(E){const S=new Map;E.path.substring(E.path.indexOf(";")+1,E.path.lastIndexOf(";")).split(";").forEach(m=>{const[u,c]=m.split(":");u&&c&&S.set(u,c)});const w=E.path.substring(0,E.path.indexOf(";"));return w&&S.set(g.META_DATA_MIME,w),S}g.parseMetaData=d})(C=e.DataUri||(e.DataUri={}));function b(g,d,E){if(d){let S=g.path;return S&&S[0]!==k.posix.sep&&(S=k.posix.sep+S),g.with({scheme:E,authority:d,path:S})}return g.with({scheme:E})}e.toLocalResource=b}),define(Z[8],ee([0,1,21,18,3,2,16,4]),function(H,e,v,t,k,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function h(j){return!!j&&typeof j.then=="function"}e.isThenable=h;function p(j){const L=new v.CancellationTokenSource,O=j(L.token),B=new Promise((V,x)=>{const ie=L.token.onCancellationRequested(()=>{ie.dispose(),L.dispose(),x(new t.CancellationError)});Promise.resolve(O).then(q=>{ie.dispose(),L.dispose(),V(q)},q=>{ie.dispose(),L.dispose(),x(q)})});return new class{cancel(){L.cancel()}then(V,x){return B.then(V,x)}catch(V){return this.then(void 0,V)}finally(V){return B.finally(V)}}}e.createCancelablePromise=p;function I(j,L,O){return new Promise((B,V)=>{const x=L.onCancellationRequested(()=>{x.dispose(),B(O)});j.then(B,V).finally(()=>x.dispose())})}e.raceCancellation=I;function C(j,L){return new Promise((O,B)=>{const V=L.onCancellationRequested(()=>{V.dispose(),B(new t.CancellationError)});j.then(O,B).finally(()=>V.dispose())})}e.raceCancellationError=C;async function b(j){let L=-1;const O=j.map((V,x)=>V.then(ie=>(L=x,ie))),B=await Promise.race(O);return j.forEach((V,x)=>{x!==L&&V.cancel()}),B}e.raceCancellablePromises=b;function g(j,L,O){let B;const V=setTimeout(()=>{B?.(void 0),O?.()},L);return Promise.race([j.finally(()=>clearTimeout(V)),new Promise(x=>B=x)])}e.raceTimeout=g;function d(j){return new Promise((L,O)=>{const B=j();h(B)?B.then(L,O):L(B)})}e.asPromise=d;class E{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(L){if(this.activePromise){if(this.queuedPromiseFactory=L,!this.queuedPromise){const O=()=>{this.queuedPromise=null;const B=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,B};this.queuedPromise=new Promise(B=>{this.activePromise.then(O,O).then(B)})}return new Promise((O,B)=>{this.queuedPromise.then(O,B)})}return this.activePromise=L(),new Promise((O,B)=>{this.activePromise.then(V=>{this.activePromise=null,O(V)},V=>{this.activePromise=null,B(V)})})}}e.Throttler=E;class S{constructor(){this.current=Promise.resolve(null)}queue(L){return this.current=this.current.then(()=>L(),()=>L())}}e.Sequencer=S;class f{constructor(){this.promiseMap=new Map}queue(L,O){const V=(this.promiseMap.get(L)??Promise.resolve()).catch(()=>{}).then(O).finally(()=>{this.promiseMap.get(L)===V&&this.promiseMap.delete(L)});return this.promiseMap.set(L,V),V}}e.SequencerByKey=f;const w=(j,L)=>{let O=!0;const B=setTimeout(()=>{O=!1,L()},j);return{isTriggered:()=>O,dispose:()=>{clearTimeout(B),O=!1}}},m=j=>{let L=!0;return queueMicrotask(()=>{L&&(L=!1,j())}),{isTriggered:()=>L,dispose:()=>{L=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class u{constructor(L){this.defaultDelay=L,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(L,O=this.defaultDelay){this.task=L,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((V,x)=>{this.doResolve=V,this.doReject=x}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const V=this.task;return this.task=null,V()}}));const B=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=O===e.MicrotaskDelay?m(B):w(O,B),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=u;class c{constructor(L){this.delayer=new u(L),this.throttler=new E}trigger(L,O){return this.delayer.trigger(()=>this.throttler.queue(L),O)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=c;class s{constructor(){this._isOpen=!1,this._promise=new Promise((L,O)=>{this._completePromise=L})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=s;class r extends s{constructor(L){super();this._timeout=setTimeout(()=>this.open(),L)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=r;function i(j,L){return L?new Promise((O,B)=>{const V=setTimeout(()=>{x.dispose(),O()},j),x=L.onCancellationRequested(()=>{clearTimeout(V),x.dispose(),B(new t.CancellationError)})}):p(O=>i(j,O))}e.timeout=i;function n(j,L=0){const O=setTimeout(j,L);return(0,R.toDisposable)(()=>clearTimeout(O))}e.disposableTimeout=n;function o(j){const L=[];let O=0;const B=j.length;function V(){return O<B?j[O++]():null}function x(ie){ie!=null&&L.push(ie);const q=V();return q?q.then(x):Promise.resolve(L)}return Promise.resolve(null).then(x)}e.sequence=o;function a(j,L=B=>!!B,O=null){let B=0;const V=j.length,x=()=>{if(B>=V)return Promise.resolve(O);const ie=j[B++];return Promise.resolve(ie()).then(te=>L(te)?Promise.resolve(te):x())};return x()}e.first=a;function l(j,L=B=>!!B,O=null){if(j.length===0)return Promise.resolve(O);let B=j.length;const V=()=>{B=-1;for(const x of j)x.cancel?.()};return new Promise((x,ie)=>{for(const q of j)q.then(te=>{--B>=0&&L(te)?(V(),x(te)):B===0&&x(O)}).catch(te=>{--B>=0&&(V(),ie(te))})})}e.firstParallel=l;class P{constructor(L){this._size=0,this.maxDegreeOfParalellism=L,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new k.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(L){return this._size++,new Promise((O,B)=>{this.outstandingPromises.push({factory:L,c:O,e:B}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const L=this.outstandingPromises.shift();this.runningPromises++;const O=L.factory();O.then(L.c,L.e),O.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=P;class M extends P{constructor(){super(1)}}e.Queue=M;class T{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const L=new _;return this.drainers.add(L),L.p}isDrained(){for(const[,L]of this.queues)if(L.size>0)return!1;return!0}queueFor(L,O=D.extUri){const B=O.getComparisonKey(L);let V=this.queues.get(B);return V||(V=new M,k.Event.once(V.onDrained)(()=>{V?.dispose(),this.queues.delete(B),this.onDidQueueDrain()}),this.queues.set(B,V)),V}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const L of this.drainers)L.complete();this.drainers.clear()}dispose(){for(const[,L]of this.queues)L.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=T;class F{constructor(L,O){this._token=-1,typeof L=="function"&&typeof O=="number"&&this.setIfNotSet(L,O)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(L,O){this.cancel(),this._token=setTimeout(()=>{this._token=-1,L()},O)}setIfNotSet(L,O){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,L()},O))}}e.TimeoutTimer=F;class U{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(L,O){this.cancel(),this._token=setInterval(()=>{L()},O)}}e.IntervalTimer=U;class Q{constructor(L,O){this.timeoutToken=-1,this.runner=L,this.timeout=O,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(L=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,L)}get delay(){return this.timeout}set delay(L){this.timeout=L}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=Q;class re{constructor(L,O){O%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${O}ms is not a multiple of 1000ms.`),this.runner=L,this.timeout=O,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(L=this.timeout){L%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${L}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(L/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=re;class ue extends Q{constructor(L,O){super(L,O);this.units=[]}work(L){this.units.push(L),this.isScheduled()||this.schedule()}doRun(){const L=this.units;this.units=[],this.runner?.(L)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=ue;class fe extends R.Disposable{constructor(L,O){super();this.options=L,this.handler=O,this.pendingWork=[],this.throttler=this._register(new R.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(L){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+L.length>this.options.maxBufferedWork)return!1}else if(this.pending+L.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...L),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new Q(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=fe,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=j=>{(0,y.setTimeout0)(()=>{if(L)return;const O=Date.now()+15;j(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,O-Date.now())}}))});let L=!1;return{dispose(){L||(L=!0)}}}:e.runWhenIdle=(j,L)=>{const O=requestIdleCallback(j,typeof L=="number"?{timeout:L}:void 0);let B=!1;return{dispose(){B||(B=!0,cancelIdleCallback(O))}}}}();class se{constructor(L){this._didRun=!1,this._executor=()=>{try{this._value=L()}catch(O){this._error=O}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=se;async function le(j,L,O){let B;for(let V=0;V<O;V++)try{return await j()}catch(x){B=x,await i(L)}throw B}e.retry=le;class K{hasPending(L){return this._pending?typeof L=="number"?this._pending.taskId===L:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(L,O,B){return this._pending={taskId:L,cancel:()=>B?.(),promise:O},O.then(()=>this.donePending(L),()=>this.donePending(L)),O}donePending(L){this._pending&&L===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const L=this._next;this._next=void 0,L.run().then(L.promiseResolve,L.promiseReject)}}setNext(L){if(this._next)this._next.run=L;else{let O,B;const V=new Promise((x,ie)=>{O=x,B=ie});this._next={run:L,promise:V,promiseResolve:O,promiseReject:B}}return this._next.promise}}e.TaskSequentializer=K;class N{constructor(L,O=()=>Date.now()){this.interval=L,this.nowFn=O,this.lastIncrementTime=0,this.value=0}increment(){const L=this.nowFn();return L-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=L,this.value=0),this.value++,this.value}}e.IntervalCounter=N;class _{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((L,O)=>{this.completeCallback=L,this.errorCallback=O})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(L){return new Promise(O=>{this.completeCallback(L),this.resolved=!0,O()})}error(L){return new Promise(O=>{this.errorCallback(L),this.rejected=!0,O()})}cancel(){new Promise(L=>{this.errorCallback(new t.CancellationError),this.rejected=!0,L()})}}e.DeferredPromise=_;var A;(function(j){async function L(B){let V;const x=await Promise.all(B.map(ie=>ie.then(q=>q,q=>{V||(V=q)})));if(typeof V!="undefined")throw V;return x}j.settled=L;function O(B){return new Promise(async(V,x)=>{try{await B(V,x)}catch(ie){x(ie)}})}j.withAsyncBody=O})(A=e.Promises||(e.Promises={}));var W;(function(j){j[j.Initial=0]="Initial",j[j.DoneOK=1]="DoneOK",j[j.DoneError=2]="DoneError"})(W||(W={}));class ${constructor(L){this._state=0,this._results=[],this._error=null,this._onStateChanged=new k.Emitter,queueMicrotask(async()=>{const O={emitOne:B=>this.emitOne(B),emitMany:B=>this.emitMany(B),reject:B=>this.reject(B)};try{await Promise.resolve(L(O)),this.resolve()}catch(B){this.reject(B)}finally{O.emitOne=void 0,O.emitMany=void 0,O.reject=void 0}})}static fromArray(L){return new $(O=>{O.emitMany(L)})}static fromPromise(L){return new $(async O=>{O.emitMany(await L)})}static fromPromises(L){return new $(async O=>{await Promise.all(L.map(async B=>O.emitOne(await B)))})}static merge(L){return new $(async O=>{await Promise.all(L.map(async B=>{for await(const V of B)O.emitOne(V)}))})}[Symbol.asyncIterator](){let L=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(L<this._results.length)return{done:!1,value:this._results[L++]};if(this._state===1)return{done:!0,value:void 0};await k.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(L,O){return new $(async B=>{for await(const V of L)B.emitOne(O(V))})}map(L){return $.map(this,L)}static filter(L,O){return new $(async B=>{for await(const V of L)O(V)&&B.emitOne(V)})}filter(L){return $.filter(this,L)}static coalesce(L){return $.filter(L,O=>!!O)}coalesce(){return $.coalesce(this)}static async toPromise(L){const O=[];for await(const B of L)O.push(B);return O}toPromise(){return $.toPromise(this)}emitOne(L){this._state===0&&(this._results.push(L),this._onStateChanged.fire())}emitMany(L){this._state===0&&(this._results=this._results.concat(L),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(L){this._state===0&&(this._state=2,this._error=L,this._onStateChanged.fire())}}e.AsyncIterableObject=$,$.EMPTY=$.fromArray([]);class Y extends ${constructor(L,O){super(O);this._source=L}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=Y;function z(j){const L=new v.CancellationTokenSource,O=j(L.token);return new Y(L,async B=>{const V=L.token.onCancellationRequested(()=>{V.dispose(),L.dispose(),B.reject(new t.CancellationError)});try{for await(const x of O){if(L.token.isCancellationRequested)return;B.emitOne(x)}V.dispose(),L.dispose()}catch(x){V.dispose(),L.dispose(),B.reject(x)}})}e.createCancelableAsyncIterable=z}),define(Z[95],ee([0,1,24,8,31,32,9,4,26]),function(H,e,v,t,k,R,D,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function p(){return Object.create(null)}e.getEmptyExpression=p,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const I="[/\\\\]",C="[^/\\\\]",b=/\//g;function g(_,A){switch(_){case 0:return"";case 1:return`${C}*?`;default:return`(?:${I}|${C}+${I}${A?`|${I}${C}+`:""})*?`}}function d(_,A){if(!_)return[];const W=[];let $=!1,Y=!1,z="";for(const j of _){switch(j){case A:if(!$&&!Y){W.push(z),z="";continue}break;case"{":$=!0;break;case"}":$=!1;break;case"[":Y=!0;break;case"]":Y=!1;break}z+=j}return z&&W.push(z),W}e.splitGlobAware=d;function E(_){if(!_)return"";let A="";const W=d(_,e.GLOB_SPLIT);if(W.every($=>$===e.GLOBSTAR))A=".*";else{let $=!1;W.forEach((Y,z)=>{if(Y===e.GLOBSTAR){if($)return;A+=g(2,z===W.length-1)}else{let j=!1,L="",O=!1,B="";for(const V of Y){if(V!=="}"&&j){L+=V;continue}if(O&&(V!=="]"||!B)){let x;V==="-"?x=V:(V==="^"||V==="!")&&!B?x="^":V===e.GLOB_SPLIT?x="":x=(0,h.escapeRegExpCharacters)(V),B+=x;continue}switch(V){case"{":j=!0;continue;case"[":O=!0;continue;case"}":{A+=`(?:${d(L,",").map(q=>E(q)).join("|")})`,j=!1,L="";break}case"]":{A+="["+B+"]",O=!1,B="";break}case"?":A+=C;continue;case"*":A+=g(1);continue;default:A+=(0,h.escapeRegExpCharacters)(V)}}z<W.length-1&&(W[z+1]!==e.GLOBSTAR||z+2<W.length)&&(A+=I)}$=Y===e.GLOBSTAR})}return A}const S=/^\*\*\/\*\.[\w\.-]+$/,f=/^\*\*\/([\w\.-]+)\/?$/,w=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,m=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,u=/^\*\*((\/[\w\.-]+)+)\/?$/,c=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,s=new R.LRUCache(1e4),r=function(){return!1},i=function(){return null};function n(_,A){if(!_)return i;let W;typeof _!="string"?W=_.pattern:W=_,W=W.trim();const $=`${W}_${!!A.trimForExclusions}`;let Y=s.get($);if(Y)return o(Y,_);let z;return S.test(W)?Y=l(W.substr(4),W):(z=f.exec(a(W,A)))?Y=P(z[1],W):(A.trimForExclusions?m:w).test(W)?Y=M(W,A):(z=u.exec(a(W,A)))?Y=T(z[1].substr(1),W,!0):(z=c.exec(a(W,A)))?Y=T(z[1],W,!1):Y=F(W),s.set($,Y),o(Y,_)}function o(_,A){if(typeof A=="string")return _;const W=function($,Y){return(0,k.isEqualOrParent)($,A.base,!y.isLinux)?_($.substr(A.base.length+1),Y):null};return W.allBasenames=_.allBasenames,W.allPaths=_.allPaths,W.basenames=_.basenames,W.patterns=_.patterns,W}function a(_,A){return A.trimForExclusions&&_.endsWith("/**")?_.substr(0,_.length-2):_}function l(_,A){return function(W,$){return typeof W=="string"&&W.endsWith(_)?A:null}}function P(_,A){const W=`/${_}`,$=`\\${_}`,Y=function(j,L){return typeof j!="string"?null:L?L===_?A:null:j===_||j.endsWith(W)||j.endsWith($)?A:null},z=[_];return Y.basenames=z,Y.patterns=[A],Y.allBasenames=z,Y}function M(_,A){const W=K(_.slice(1,-1).split(",").map(L=>n(L,A)).filter(L=>L!==i),_),$=W.length;if(!$)return i;if($===1)return W[0];const Y=function(L,O){for(let B=0,V=W.length;B<V;B++)if(W[B](L,O))return _;return null},z=W.find(L=>!!L.allBasenames);z&&(Y.allBasenames=z.allBasenames);const j=W.reduce((L,O)=>O.allPaths?L.concat(O.allPaths):L,[]);return j.length&&(Y.allPaths=j),Y}function T(_,A,W){const $=D.sep===D.posix.sep,Y=$?_:_.replace(b,D.sep),z=D.sep+Y,j=D.posix.sep+_;let L;return W?L=function(O,B){return typeof O=="string"&&(O===Y||O.endsWith(z)||!$&&(O===_||O.endsWith(j)))?A:null}:L=function(O,B){return typeof O=="string"&&(O===Y||!$&&O===_)?A:null},L.allPaths=[(W?"*/":"./")+_],L}function F(_){try{const A=new RegExp(`^${E(_)}$`);return function(W){return A.lastIndex=0,typeof W=="string"&&A.test(W)?_:null}}catch{return i}}function U(_,A,W){return!_||typeof A!="string"?!1:Q(_)(A,void 0,W)}e.match=U;function Q(_,A={}){if(!_)return r;if(typeof _=="string"||re(_)){const W=n(_,A);if(W===i)return r;const $=function(Y,z){return!!W(Y,z)};return W.allBasenames&&($.allBasenames=W.allBasenames),W.allPaths&&($.allPaths=W.allPaths),$}return se(_,A)}e.parse=Q;function re(_){const A=_;return A?typeof A.base=="string"&&typeof A.pattern=="string":!1}e.isRelativePattern=re;function ue(_){return _.allBasenames||[]}e.getBasenameTerms=ue;function fe(_){return _.allPaths||[]}e.getPathTerms=fe;function se(_,A){const W=K(Object.getOwnPropertyNames(_).map(L=>le(L,_[L],A)).filter(L=>L!==i)),$=W.length;if(!$)return i;if(!W.some(L=>!!L.requiresSiblings)){if($===1)return W[0];const L=function(V,x){let ie;for(let q=0,te=W.length;q<te;q++){const ne=W[q](V,x);if(typeof ne=="string")return ne;(0,t.isThenable)(ne)&&(ie||(ie=[]),ie.push(ne))}return ie?(async()=>{for(const q of ie){const te=await q;if(typeof te=="string")return te}return null})():null},O=W.find(V=>!!V.allBasenames);O&&(L.allBasenames=O.allBasenames);const B=W.reduce((V,x)=>x.allPaths?V.concat(x.allPaths):V,[]);return B.length&&(L.allPaths=B),L}const Y=function(L,O,B){let V,x;for(let ie=0,q=W.length;ie<q;ie++){const te=W[ie];te.requiresSiblings&&B&&(O||(O=(0,D.basename)(L)),V||(V=O.substr(0,O.length-(0,D.extname)(L).length)));const ne=te(L,O,V,B);if(typeof ne=="string")return ne;(0,t.isThenable)(ne)&&(x||(x=[]),x.push(ne))}return x?(async()=>{for(const ie of x){const q=await ie;if(typeof q=="string")return q}return null})():null},z=W.find(L=>!!L.allBasenames);z&&(Y.allBasenames=z.allBasenames);const j=W.reduce((L,O)=>O.allPaths?L.concat(O.allPaths):L,[]);return j.length&&(Y.allPaths=j),Y}function le(_,A,W){if(A===!1)return i;const $=n(_,W);if($===i)return i;if(typeof A=="boolean")return $;if(A){const Y=A.when;if(typeof Y=="string"){const z=(j,L,O,B)=>{if(!B||!$(j,L))return null;const V=Y.replace("$(basename)",O),x=B(V);return(0,t.isThenable)(x)?x.then(ie=>ie?_:null):x?_:null};return z.requiresSiblings=!0,z}}return $}function K(_,A){const W=_.filter(L=>!!L.basenames);if(W.length<2)return _;const $=W.reduce((L,O)=>{const B=O.basenames;return B?L.concat(B):L},[]);let Y;if(A){Y=[];for(let L=0,O=$.length;L<O;L++)Y.push(A)}else Y=W.reduce((L,O)=>{const B=O.patterns;return B?L.concat(B):L},[]);const z=function(L,O){if(typeof L!="string")return null;if(!O){let V;for(V=L.length;V>0;V--){const x=L.charCodeAt(V-1);if(x===47||x===92)break}O=L.substr(V)}const B=$.indexOf(O);return B!==-1?Y[B]:null};z.basenames=$,z.patterns=Y,z.allBasenames=$;const j=_.filter(L=>!L.basenames);return j.push(z),j}function N(_,A){return(0,v.equals)(_,A,(W,$)=>typeof W=="string"&&typeof $=="string"?W===$:typeof W!="string"&&typeof $!="string"?W.base===$.base&&W.pattern===$.pattern:!1)}e.patternsEquals=N}),define(Z[36],ee([0,1,24,31,9,4,16,26]),function(H,e,v,t,k,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function h(i,n){const{os:o,tildify:a,relative:l}=n;if(l){const T=p(i,l,o);if(typeof T=="string")return T}let P=i.fsPath;if(o===1&&!R.isWindows?P=P.replace(/\//g,"\\"):o!==1&&R.isWindows&&(P=P.replace(/\\/g,"/")),o!==1&&a?.userHome){const T=a.userHome.fsPath;let F;i.scheme!==a.userHome.scheme&&i.path.startsWith(k.posix.sep)?F=a.userHome.with({path:i.path}).fsPath:F=i.fsPath,P=b(F,T,o)}return(o===1?k.win32:k.posix).normalize(I(P,o===1))}e.getPathLabel=h;function p(i,n,o){const a=o===1?k.win32:k.posix,l=o===3?D.extUri:D.extUriIgnorePathCase,P=n.getWorkspace(),M=(0,v.firstOrDefault)(P.folders);if(!M)return;i.scheme!==M.uri.scheme&&i.path.startsWith(k.posix.sep)&&(i=M.uri.with({path:i.path}));const T=n.getWorkspaceFolder(i);if(!T)return;let F;if(l.isEqual(T.uri,i)?F="":F=l.relativePath(T.uri,i)??"",F&&(F=a.normalize(F)),P.folders.length>1&&!n.noPrefix){const U=T.name?T.name:l.basenameOrAuthority(T.uri);F=F?`${U} \u2022 ${F}`:U}return F}function I(i,n=R.isWindows){return(0,t.hasDriveLetter)(i,n)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=I;let C=Object.create(null);function b(i,n,o=R.OS){if(o===1||!i||!n)return i;let a=C.original===n?C.normalized:void 0;a||(a=n,R.isWindows&&(a=(0,t.toSlashes)(a)),a=`${(0,y.rtrim)(a,k.posix.sep)}${k.posix.sep}`,C={original:n,normalized:a});let l=i;return R.isWindows&&(l=(0,t.toSlashes)(l)),(o===3?l.startsWith(a):(0,y.startsWithIgnoreCase)(l,a))?`~/${l.substr(a.length)}`:i}e.tildify=b;function g(i,n){return i.replace(/^~($|\/|\\)/,`${n}$1`)}e.untildify=g;const d="\u2026",E="\\\\",S="~";function f(i,n=k.sep){const o=new Array(i.length);let a=!1;for(let l=0;l<i.length;l++){const P=i[l];if(P===""){o[l]=`.${n}`;continue}if(!P){o[l]=P;continue}a=!0;let M="",T=P;T.indexOf(E)===0?(M=T.substr(0,T.indexOf(E)+E.length),T=T.substr(T.indexOf(E)+E.length)):T.indexOf(n)===0?(M=T.substr(0,T.indexOf(n)+n.length),T=T.substr(T.indexOf(n)+n.length)):T.indexOf(S)===0&&(M=T.substr(0,T.indexOf(S)+S.length),T=T.substr(T.indexOf(S)+S.length));const F=T.split(n);for(let U=1;a&&U<=F.length;U++)for(let Q=F.length-U;a&&Q>=0;Q--){a=!1;let re=F.slice(Q,Q+U).join(n);for(let ue=0;!a&&ue<i.length;ue++)if(ue!==l&&i[ue]&&i[ue].indexOf(re)>-1){const fe=Q+U===F.length,se=Q>0&&i[ue].indexOf(n)>-1?n+re:re,le=i[ue].endsWith(se);a=!fe||le}if(!a){let ue="";(F[0].endsWith(":")||M!=="")&&(Q===1&&(Q=0,U++,re=F[0]+n+re),Q>0&&(ue=F[0]+n),ue=M+ue),Q>0&&(ue=ue+d+n),ue=ue+re,Q+U<F.length&&(ue=ue+n+d),o[l]=ue}}a&&(o[l]=P)}return o}e.shorten=f;var w;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(w||(w={}));function m(i,n=Object.create(null)){const o=[];let a=!1,l="";for(const P of i)if(P==="$"||a&&P==="{")l&&o.push({value:l,type:w.TEXT}),l="",a=!0;else if(P==="}"&&a){const M=n[l];if(typeof M=="string")M.length&&o.push({value:M,type:w.VARIABLE});else if(M){const T=o[o.length-1];(!T||T.type!==w.SEPARATOR)&&o.push({value:M.label,type:w.SEPARATOR})}l="",a=!1}else l+=P;return l&&!a&&o.push({value:l,type:w.TEXT}),o.filter((P,M)=>{if(P.type===w.SEPARATOR){const T=o[M-1],F=o[M+1];return[T,F].every(U=>U&&(U.type===w.VARIABLE||U.type===w.TEXT)&&U.value.length>0)}return!0}).map(P=>P.value).join("")}e.template=m;function u(i,n){return R.isMacintosh||n?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.isMacintosh?"&":"&&"):i.replace(/&&|&/g,o=>o==="&"?"&&":"&")}e.mnemonicMenuLabel=u;function c(i,n){return R.isMacintosh||n?i.replace(/\(&&\w\)|&&/g,""):R.isWindows?i.replace(/&&|&/g,o=>o==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=c;function s(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=s;function r(i){const n=i.indexOf("/")!==-1?k.posix:k.win32,o=n.basename(i),a=n.dirname(i);return o.length?{name:o,parentPath:a}:{name:a,parentPath:""}}e.splitName=r}),define(Z[141],ee([0,1,7]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(I){return I.toJSON()}class k{constructor(C){this._uriTransformer=C}transformIncoming(C){const b=this._uriTransformer.transformIncoming(C);return b===C?C:t(v.URI.from(b))}transformOutgoing(C){const b=this._uriTransformer.transformOutgoing(C);return b===C?C:t(v.URI.from(b))}transformOutgoingURI(C){const b=this._uriTransformer.transformOutgoing(C);return b===C?C:v.URI.from(b)}transformOutgoingScheme(C){return this._uriTransformer.transformOutgoingScheme(C)}}e.URITransformer=k,e.DefaultURITransformer=new class{transformIncoming(I){return I}transformOutgoing(I){return I}transformOutgoingURI(I){return I}transformOutgoingScheme(I){return I}};function R(I,C,b){if(!I||b>200)return null;if(typeof I=="object"){if(I instanceof v.URI)return C.transformOutgoing(I);for(const g in I)if(Object.hasOwnProperty.call(I,g)){const d=R(I[g],C,b+1);d!==null&&(I[g]=d)}}return null}function D(I,C){const b=R(I,C,0);return b===null?I:b}e.transformOutgoingURIs=D;function y(I,C,b,g){if(!I||g>200)return null;if(typeof I=="object"){if(I.$mid===1)return b?v.URI.revive(C.transformIncoming(I)):C.transformIncoming(I);for(const d in I)if(Object.hasOwnProperty.call(I,d)){const E=y(I[d],C,b,g+1);E!==null&&(I[d]=E)}}return null}function h(I,C){const b=y(I,C,!1,0);return b===null?I:b}e.transformIncomingURIs=h;function p(I,C){const b=y(I,C,!0,0);return b===null?I:b}e.transformAndReviveIncomingURIs=p}),define(Z[81],ee([0,1,30,18,32,28,129]),function(H,e,v,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(I){return this._virtualMachineOUIs||(this._virtualMachineOUIs=k.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(I)}value(){if(this._value===void 0){let I=0,C=0;const b=(0,v.networkInterfaces)();for(const g in b){const d=b[g];if(d)for(const{mac:E,internal:S}of d)S||(C+=1,this._isVirtualMachineMacAddress(E.toUpperCase())&&(I+=1))}this._value=C>0?I/C:0}return this._value}};let y;async function h(){return y||(y=(async()=>await p()||R.generateUuid())()),y}e.getMachineId=h;async function p(){try{const I=await new Promise((b,g)=>{H(["crypto"],b,g)}),C=(0,D.getMac)();return I.createHash("sha256").update(C,"utf8").digest("hex")}catch(I){t.onUnexpectedError(I);return}}}),define(Z[23],ee([0,1,29,30,142,8,31,80,9,4,16,7]),function(H,e,v,t,k,R,D,y,h,p,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var b;(function(se){se[se.UNLINK=0]="UNLINK",se[se.MOVE=1]="MOVE"})(b=e.RimRafMode||(e.RimRafMode={}));async function g(se,le=b.UNLINK){if((0,D.isRootOrDriveLetter)(se))throw new Error("rimraf - will refuse to recursively delete root");return le===b.UNLINK?E(se):d(se)}async function d(se){try{const le=(0,D.randomPath)((0,t.tmpdir)());try{await v.promises.rename(se,le)}catch{return E(se)}E(le).catch(K=>{})}catch(le){if(le.code!=="ENOENT")throw le}}async function E(se){return(0,k.promisify)(v.rm)(se,{recursive:!0,force:!0,maxRetries:3})}function S(se){if((0,D.isRootOrDriveLetter)(se))throw new Error("rimraf - will refuse to recursively delete root");v.rmSync(se,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=S;async function f(se,le){return u(await(le?w(se):(0,k.promisify)(v.readdir)(se)))}async function w(se){try{return await(0,k.promisify)(v.readdir)(se,{withFileTypes:!0})}catch(N){console.warn("[node.js fs] readdir with filetypes failed with error: ",N)}const le=[],K=await f(se);for(const N of K){let _=!1,A=!1,W=!1;try{const $=await e.Promises.lstat((0,h.join)(se,N));_=$.isFile(),A=$.isDirectory(),W=$.isSymbolicLink()}catch($){console.warn("[node.js fs] unexpected error from lstat after readdir: ",$)}le.push({name:N,isFile:()=>_,isDirectory:()=>A,isSymbolicLink:()=>W})}return le}function m(se){return u(v.readdirSync(se))}e.readdirSync=m;function u(se){return se.map(le=>typeof le=="string"?p.isMacintosh?(0,y.normalizeNFC)(le):le:(le.name=p.isMacintosh?(0,y.normalizeNFC)(le.name):le.name,le))}async function c(se){const le=await f(se),K=[];for(const N of le)await r.existsDirectory((0,h.join)(se,N))&&K.push(N);return K}function s(se,le=1e3){return new Promise(K=>{let N=!1;const _=setInterval(()=>{N||(N=!0,v.access(se,A=>{N=!1,A&&(clearInterval(_),K(void 0))}))},le)})}e.whenDeleted=s;var r;(function(se){async function le(_){let A;try{if(A=await e.Promises.lstat(_),!A.isSymbolicLink())return{stat:A}}catch{}try{return{stat:await e.Promises.stat(_),symbolicLink:A?.isSymbolicLink()?{dangling:!1}:void 0}}catch(W){if(W.code==="ENOENT"&&A)return{stat:A,symbolicLink:{dangling:!0}};if(p.isWindows&&W.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(_)),symbolicLink:{dangling:!1}}}catch($){if($.code==="ENOENT"&&A)return{stat:A,symbolicLink:{dangling:!0}};throw $}throw W}}se.stat=le;async function K(_){try{const{stat:A,symbolicLink:W}=await se.stat(_);return A.isFile()&&W?.dangling!==!0}catch{}return!1}se.existsFile=K;async function N(_){try{const{stat:A,symbolicLink:W}=await se.stat(_);return A.isDirectory()&&W?.dangling!==!0}catch{}return!1}se.existsDirectory=N})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new R.ResourceQueue;function n(se,le,K){return i.queueFor(C.URI.file(se),I.extUriBiasedIgnorePathCase).queue(()=>{const N=M(K);return new Promise((_,A)=>l(se,le,N,W=>W?A(W):_()))})}let o=!0;function a(se){o=se}e.configureFlushOnWrite=a;function l(se,le,K,N){if(!o)return v.writeFile(se,le,{mode:K.mode,flag:K.flag},N);v.open(se,K.flag,K.mode,(_,A)=>{if(_)return N(_);v.writeFile(A,le,W=>{if(W)return v.close(A,()=>N(W));v.fdatasync(A,$=>($&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",$),a(!1)),v.close(A,Y=>N(Y))))})})}function P(se,le,K){const N=M(K);if(!o)return v.writeFileSync(se,le,{mode:N.mode,flag:N.flag});const _=v.openSync(se,N.flag,N.mode);try{v.writeFileSync(_,le);try{v.fdatasyncSync(_)}catch(A){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",A),a(!1)}}finally{v.closeSync(_)}}e.writeFileSync=P;function M(se){return se?{mode:typeof se.mode=="number"?se.mode:438,flag:typeof se.flag=="string"?se.flag:"w"}:{mode:438,flag:"w"}}async function T(se,le){if(se!==le)try{await e.Promises.rename(se,le)}catch(K){if(se.toLowerCase()!==le.toLowerCase()&&K.code==="EXDEV"||se.endsWith("."))await F(se,le,{preserveSymlinks:!1}),await g(se,b.MOVE);else throw K}}async function F(se,le,K){return Q(se,le,{root:{source:se,target:le},options:K,handledSourcePaths:new Set})}const U=511;async function Q(se,le,K){if(K.handledSourcePaths.has(se))return;K.handledSourcePaths.add(se);const{stat:N,symbolicLink:_}=await r.stat(se);if(_){if(K.options.preserveSymlinks)try{return await fe(se,le,K)}catch(A){console.warn("[node.js fs] copy of symlink failed: ",A)}if(_.dangling)return}return N.isDirectory()?re(se,le,N.mode&U,K):ue(se,le,N.mode&U)}async function re(se,le,K,N){await e.Promises.mkdir(le,{recursive:!0,mode:K});const _=await f(se);for(const A of _)await Q((0,h.join)(se,A),(0,h.join)(le,A),N)}async function ue(se,le,K){await e.Promises.copyFile(se,le),await e.Promises.chmod(le,K)}async function fe(se,le,K){let N=await e.Promises.readlink(se);(0,D.isEqualOrParent)(N,K.root.source,!p.isLinux)&&(N=(0,h.join)(K.root.target,N.substr(K.root.source.length+1))),await e.Promises.symlink(N,le)}e.Promises=new class{get access(){return(0,k.promisify)(v.access)}get stat(){return(0,k.promisify)(v.stat)}get lstat(){return(0,k.promisify)(v.lstat)}get utimes(){return(0,k.promisify)(v.utimes)}get read(){return(se,le,K,N,_)=>new Promise((A,W)=>{v.read(se,le,K,N,_,($,Y,z)=>$?W($):A({bytesRead:Y,buffer:z}))})}get readFile(){return(0,k.promisify)(v.readFile)}get write(){return(se,le,K,N,_)=>new Promise((A,W)=>{v.write(se,le,K,N,_,($,Y,z)=>$?W($):A({bytesWritten:Y,buffer:z}))})}get appendFile(){return(0,k.promisify)(v.appendFile)}get fdatasync(){return(0,k.promisify)(v.fdatasync)}get truncate(){return(0,k.promisify)(v.truncate)}get rename(){return(0,k.promisify)(v.rename)}get copyFile(){return(0,k.promisify)(v.copyFile)}get open(){return(0,k.promisify)(v.open)}get close(){return(0,k.promisify)(v.close)}get symlink(){return(0,k.promisify)(v.symlink)}get readlink(){return(0,k.promisify)(v.readlink)}get chmod(){return(0,k.promisify)(v.chmod)}get mkdir(){return(0,k.promisify)(v.mkdir)}get unlink(){return(0,k.promisify)(v.unlink)}get rmdir(){return(0,k.promisify)(v.rmdir)}get realpath(){return(0,k.promisify)(v.realpath)}async exists(se){try{return await e.Promises.access(se),!0}catch{return!1}}get readdir(){return f}get readDirsInDir(){return c}get writeFile(){return n}get rm(){return g}get move(){return T}get copy(){return F}}}),define(Z[96],ee([0,1,29,9,4,26,23]),function(H,e,v,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function y(b){if(k.isLinux)return b;const g=(0,t.dirname)(b);if(b===g)return b;const d=((0,t.basename)(b)||b).toLowerCase();try{const S=(0,D.readdirSync)(g).filter(f=>f.toLowerCase()===d);if(S.length===1){const f=y(g);if(f)return(0,t.join)(f,S[0])}else if(S.length>1){const f=S.indexOf(d);if(f>=0){const w=y(g);if(w)return(0,t.join)(w,S[f])}}}catch{}return null}e.realcaseSync=y;async function h(b){if(k.isLinux)return b;const g=(0,t.dirname)(b);if(b===g)return b;const d=((0,t.basename)(b)||b).toLowerCase();try{const S=(await D.Promises.readdir(g)).filter(f=>f.toLowerCase()===d);if(S.length===1){const f=await h(g);if(f)return(0,t.join)(f,S[0])}else if(S.length>1){const f=S.indexOf(d);if(f>=0){const w=await h(g);if(w)return(0,t.join)(w,S[f])}}}catch{}return null}e.realcase=h;async function p(b){try{return await D.Promises.realpath(b)}catch{const d=C(b);return await D.Promises.access(d,v.constants.R_OK),d}}e.realpath=p;function I(b){try{return v.realpathSync(b)}catch{const d=C(b);return v.accessSync(d,v.constants.R_OK),d}}e.realpathSync=I;function C(b){return(0,R.rtrim)((0,t.normalize)(b),t.sep)}}),define(Z[143],ee([0,1,30,9,23]),function(H,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const R=/^\d+$/,D=/^Microsoft.PowerShell_.*/,y=/^Microsoft.PowerShellPreview_.*/;var h;(function(u){u[u.x64=0]="x64",u[u.x86=1]="x86",u[u.ARM=2]="ARM"})(h||(h={}));let p;switch(process.arch){case"ia32":case"x32":p=1;break;case"arm":case"arm64":p=2;break;default:p=0;break}let I;process.env.PROCESSOR_ARCHITEW6432?I=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?I=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?I=1:I=0;class C{constructor(c,s,r){this.exePath=c,this.displayName=s,this.knownToExist=r}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await k.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function b({useAlternateBitness:u=!1}={}){return u?p===0?process.env["ProgramFiles(x86)"]||null:I===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function g({useAlternateBitness:u=!1,findPreview:c=!1}={}){const s=b({useAlternateBitness:u});if(!s)return null;const r=t.join(s,"PowerShell");if(!await k.SymlinkSupport.existsDirectory(r))return null;let i=-1,n=null;for(const l of await k.Promises.readdir(r)){let P=-1;if(c){const T=l.indexOf("-");if(T<0)continue;const F=l.substring(0,T);if(!R.test(F)||l.substring(T+1)!=="preview")continue;P=parseInt(F,10)}else{if(!R.test(l))continue;P=parseInt(l,10)}if(P<=i)continue;const M=t.join(r,l,"pwsh.exe");!await k.SymlinkSupport.existsFile(M)||(n=M,i=P)}if(!n)return null;const o=s.includes("x86")?" (x86)":"",a=c?" Preview":"";return new C(n,`PowerShell${a}${o}`,!0)}async function d({findPreview:u}={}){if(!process.env.LOCALAPPDATA)return null;const c=t.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await k.SymlinkSupport.existsDirectory(c))return null;const{pwshMsixDirRegex:s,pwshMsixName:r}=u?{pwshMsixDirRegex:y,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:D,pwshMsixName:"PowerShell (Store)"};for(const i of await k.Promises.readdir(c))if(s.test(i)){const n=t.join(c,i,"pwsh.exe");return new C(n,r)}return null}function E(){const u=t.join(v.homedir(),".dotnet","tools","pwsh.exe");return new C(u,".NET Core PowerShell Global Tool")}function S(){const u=t.join(process.env.windir,p===1&&I!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new C(u,"Windows PowerShell",!0)}async function*f(){let u=await g();u&&(yield u),u=await g({useAlternateBitness:!0}),u&&(yield u),u=await d(),u&&(yield u),u=E(),u&&(yield u),u=await g({findPreview:!0}),u&&(yield u),u=await d({findPreview:!0}),u&&(yield u),u=await g({useAlternateBitness:!0,findPreview:!0}),u&&(yield u),u=S(),u&&(yield u)}async function*w(){for await(const u of f())await u.exists()&&(yield u)}e.enumeratePowerShellInstallations=w;async function m(){for await(const u of w())return u;return null}e.getFirstAvailablePowerShellInstallation=m}),define(Z[82],ee([0,1,9,4,35,78,12,23]),function(H,e,v,t,k,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function h(C=k.env){return C.comspec||"cmd.exe"}e.getWindowsShell=h;function p(C){let b=[],g=!1;const d=function(E){if(g){b.push(E);return}(!C.send(E,f=>{if(f&&console.error(f),g=!1,b.length>0){const w=b.slice(0);b=[],w.forEach(m=>d(m))}})||t.isWindows)&&(g=!0)};return{send:d}}e.createQueuedSender=p;var I;(function(C){async function b(g,d,E){if(v.isAbsolute(g))return g;if(d===void 0&&(d=k.cwd()),v.dirname(g)!=="."||(E===void 0&&D.isString(k.env.PATH)&&(E=k.env.PATH.split(v.delimiter)),E===void 0||E.length===0))return v.join(d,g);async function f(w){if(await y.Promises.exists(w)){let m;try{m=await y.Promises.stat(w)}catch(u){u.message.startsWith("EACCES")&&(m=await y.Promises.lstat(w))}return m?!m.isDirectory():!1}return!1}for(const w of E){let m;if(v.isAbsolute(w)?m=v.join(w,g):m=v.join(d,w,g),await f(m))return m;let u=m+".com";if(await f(u)||(u=m+".exe",await f(u)))return u}return v.join(d,g)}C.findExecutable=b})(I=e.win32||(e.win32={}))}),define(Z[97],ee([0,1,50,13]),function(H,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function k(D){return new Promise((y,h)=>{let p;const I=new Map;function C(g,d,E,S,f){const w=I.get(d);if(g===D||w){const m={name:b(E),cmd:E,pid:g,ppid:d,load:S,mem:f};I.set(g,m),g===D&&(p=m),w&&(w.children||(w.children=[]),w.children.push(m),w.children.length>1&&(w.children=w.children.sort((u,c)=>u.pid-c.pid)))}}function b(g){const d=/--vscode-window-kind=shared-process/,E=/--vscode-window-kind=issue-reporter/,S=/--vscode-window-kind=process-explorer/,f=/--utility-sub-type=network/,w=/--utility-sub-type=node.mojom.NodeService/,m=/--crashes-directory/,u=/\\pipe\\winpty-control/,c=/conhost\.exe/,s=/--type=([a-zA-Z-]+)/;if(m.exec(g))return"electron-crash-reporter";if(u.exec(g))return"winpty-process";if(c.exec(g))return"console-window-host (Windows internal process)";let r=s.exec(g);if(r&&r.length===2){if(r[1]==="renderer")return d.exec(g)?"shared-process":E.exec(g)?"issue-reporter":S.exec(g)?"process-explorer":"window";if(r[1]==="utility"){if(f.exec(g))return"utility-network-service";if(w.exec(g))return"extension-host"}return r[1]}const i=/[a-zA-Z-]+\.js/g;let n="";do r=i.exec(g),r&&(n+=r+" ");while(r);return n&&g.indexOf("node ")<0&&g.indexOf("node.exe")<0?`electron_node ${n}`:g}if(process.platform==="win32"){const g=d=>d.indexOf("\\\\?\\")===0||d.indexOf("\\??\\")===0?d.substr(4):d.indexOf('"\\\\?\\')===0||d.indexOf('"\\??\\')===0?'"'+d.substr(5):d;new Promise((d,E)=>{H(["windows-process-tree"],d,E)}).then(d=>{d.getProcessList(D,E=>{if(!E){h(new Error(`Root process ${D} not found`));return}d.getProcessCpuUsage(E,S=>{const f=new Map;S.forEach(w=>{const m=g(w.commandLine||"");f.set(w.pid,{name:b(m),cmd:m,pid:w.pid,ppid:w.ppid,load:w.cpu||0,mem:w.memory||0})}),p=f.get(D),p?(f.forEach(w=>{const m=f.get(w.ppid);m&&(m.children||(m.children=[]),m.children.push(w))}),f.forEach(w=>{w.children&&(w.children=w.children.sort((m,u)=>m.pid-u.pid))}),y(p)):h(new Error(`Root process ${D} not found`))})},d.ProcessDataFlag.CommandLine|d.ProcessDataFlag.Memory)})}else{let g=function(){let d=[p];const E=[];for(;d.length;){const f=d.shift();f&&(E.push(f.pid),f.children&&(d=d.concat(f.children)))}let S=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",H).fsPath);S+=" "+E.join(" "),(0,v.exec)(S,{},(f,w,m)=>{if(f||m)h(f||new Error(m.toString()));else{const u=w.toString().split(`
`);for(let c=0;c<E.length;c++){const s=I.get(E[c]);s.load=parseFloat(u[c])}if(!p){h(new Error(`Root process ${D} not found`));return}y(p)}})};(0,v.exec)("which ps",{},(d,E,S)=>{if(d||S)if(process.platform!=="linux")h(d||new Error(S.toString()));else{const f=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/ps.sh",H).fsPath);(0,v.exec)(f,{},(w,m,u)=>{w||u?h(w||new Error(u.toString())):(R(m,C),g())})}else{const f=E.toString().trim(),w="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,v.exec)(`${f} ${w}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(m,u,c)=>{m||c&&!c.includes("screen size is bogus")?h(m||new Error(c.toString())):(R(u,C),process.platform==="linux"?g():p?y(p):h(new Error(`Root process ${D} not found`)))})}})}})}e.listProcesses=k;function R(D,y){const h=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,p=D.toString().split(`
`);for(const I of p){const C=h.exec(I.trim());C&&C.length===6&&y(parseInt(C[1]),parseInt(C[2]),C[5],parseFloat(C[3]),parseFloat(C[4]))}}}),define(Z[144],ee([0,1,30,4,143,82]),function(H,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function D(g,d){return g===1?t.isWindows?C():R.getWindowsShell(d):p(g,d)}e.getSystemShell=D;function y(g,d){return g===1?t.isWindows?b(d):R.getWindowsShell(d):p(g,d)}e.getSystemShellSync=y;let h=null;function p(g,d){if(t.isLinux&&g===2||t.isMacintosh&&g===3)return"/bin/bash";if(!h){let E;if(t.isWindows)E="/bin/bash";else{if(E=d.SHELL,!E)try{E=(0,v.userInfo)().shell}catch{}E||(E="sh"),E==="/bin/false"&&(E="/bin/bash")}h=E}return h}let I=null;async function C(){return I||(I=(await(0,k.getFirstAvailablePowerShellInstallation)()).exePath),I}function b(g){if(I)return I;const d=t.isWindows&&parseFloat((0,v.release)())>=10,E=g.hasOwnProperty("PROCESSOR_ARCHITEW6432"),S=`${g.windir}\\${E?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return d?S:R.getWindowsShell(g)}});var ve=this&&this.__decorate||function(H,e,v,t){var k=arguments.length,R=k<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,v):t,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(H,e,v,t);else for(var y=H.length-1;y>=0;y--)(D=H[y])&&(R=(k<3?D(R):k>3?D(e,v,R):D(e,v))||R);return k>3&&R&&Object.defineProperty(e,v,R),R};define(Z[44],ee([0,1,24,8,17,21,51,18,3,2,57,26,12]),function(H,e,v,t,k,R,D,y,h,p,I,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var g;(function(_){_[_.Promise=100]="Promise",_[_.PromiseCancel=101]="PromiseCancel",_[_.EventListen=102]="EventListen",_[_.EventDispose=103]="EventDispose"})(g=e.RequestType||(e.RequestType={}));function d(_){switch(_){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var E;(function(_){_[_.Initialize=200]="Initialize",_[_.PromiseSuccess=201]="PromiseSuccess",_[_.PromiseError=202]="PromiseError",_[_.PromiseErrorObj=203]="PromiseErrorObj",_[_.EventFire=204]="EventFire"})(E=e.ResponseType||(e.ResponseType={}));function S(_){switch(_){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var f;(function(_){_[_.Uninitialized=0]="Uninitialized",_[_.Idle=1]="Idle"})(f||(f={}));class w{constructor(A){this.buffer=A,this.pos=0}read(A){const W=this.buffer.slice(this.pos,this.pos+A);return this.pos+=W.byteLength,W}}class m{constructor(){this.buffers=[]}get buffer(){return k.VSBuffer.concat(this.buffers)}write(A){this.buffers.push(A)}}var u;(function(_){_[_.Undefined=0]="Undefined",_[_.String=1]="String",_[_.Buffer=2]="Buffer",_[_.VSBuffer=3]="VSBuffer",_[_.Array=4]="Array",_[_.Object=5]="Object"})(u||(u={}));function c(_){const A=k.VSBuffer.alloc(4);return A.writeUInt32BE(_,0),A}function s(_){return _.read(4).readUInt32BE(0)}function r(_){const A=k.VSBuffer.alloc(1);return A.writeUInt8(_,0),A}const i={Undefined:r(u.Undefined),String:r(u.String),Buffer:r(u.Buffer),VSBuffer:r(u.VSBuffer),Array:r(u.Array),Object:r(u.Object)},n=typeof Buffer!="undefined";function o(_,A){if(typeof A=="undefined")_.write(i.Undefined);else if(typeof A=="string"){const W=k.VSBuffer.fromString(A);_.write(i.String),_.write(c(W.byteLength)),_.write(W)}else if(n&&Buffer.isBuffer(A)){const W=k.VSBuffer.wrap(A);_.write(i.Buffer),_.write(c(W.byteLength)),_.write(W)}else if(A instanceof k.VSBuffer)_.write(i.VSBuffer),_.write(c(A.byteLength)),_.write(A);else if(Array.isArray(A)){_.write(i.Array),_.write(c(A.length));for(const W of A)o(_,W)}else{const W=k.VSBuffer.fromString(JSON.stringify(A));_.write(i.Object),_.write(c(W.byteLength)),_.write(W)}}function a(_){switch(_.read(1).readUInt8(0)){case u.Undefined:return;case u.String:return _.read(s(_)).toString();case u.Buffer:return _.read(s(_)).buffer;case u.VSBuffer:return _.read(s(_));case u.Array:{const W=s(_),$=[];for(let Y=0;Y<W;Y++)$.push(a(_));return $}case u.Object:return JSON.parse(_.read(s(_)).toString())}}class l{constructor(A,W,$=null,Y=1e3){this.protocol=A,this.ctx=W,this.logger=$,this.timeoutDelay=Y,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(z=>this.onRawMessage(z)),this.sendResponse({type:200})}registerChannel(A,W){this.channels.set(A,W),setTimeout(()=>this.flushPendingRequests(A),0)}sendResponse(A){switch(A.type){case 200:{const W=this.send([A.type]);this.logger?.logOutgoing(W,0,1,S(A.type));return}case 201:case 202:case 204:case 203:{const W=this.send([A.type,A.id],A.data);this.logger?.logOutgoing(W,A.id,1,S(A.type),A.data);return}}}send(A,W=void 0){const $=new m;return o($,A),o($,W),this.sendBuffer($.buffer)}sendBuffer(A){try{return this.protocol.send(A),A.byteLength}catch{return 0}}onRawMessage(A){const W=new w(A),$=a(W),Y=a(W),z=$[0];switch(z){case 100:return this.logger?.logIncoming(A.byteLength,$[1],1,`${d(z)}: ${$[2]}.${$[3]}`,Y),this.onPromise({type:z,id:$[1],channelName:$[2],name:$[3],arg:Y});case 102:return this.logger?.logIncoming(A.byteLength,$[1],1,`${d(z)}: ${$[2]}.${$[3]}`,Y),this.onEventListen({type:z,id:$[1],channelName:$[2],name:$[3],arg:Y});case 101:return this.logger?.logIncoming(A.byteLength,$[1],1,`${d(z)}`),this.disposeActiveRequest({type:z,id:$[1]});case 103:return this.logger?.logIncoming(A.byteLength,$[1],1,`${d(z)}`),this.disposeActiveRequest({type:z,id:$[1]})}}onPromise(A){const W=this.channels.get(A.channelName);if(!W){this.collectPendingRequest(A);return}const $=new R.CancellationTokenSource;let Y;try{Y=W.call(this.ctx,A.name,A.arg,$.token)}catch(L){Y=Promise.reject(L)}const z=A.id;Y.then(L=>{this.sendResponse({id:z,data:L,type:201}),this.activeRequests.delete(A.id)},L=>{L instanceof Error?this.sendResponse({id:z,data:{message:L.message,name:L.name,stack:L.stack?L.stack.split?L.stack.split(`
`):L.stack:void 0},type:202}):this.sendResponse({id:z,data:L,type:203}),this.activeRequests.delete(A.id)});const j=(0,p.toDisposable)(()=>$.cancel());this.activeRequests.set(A.id,j)}onEventListen(A){const W=this.channels.get(A.channelName);if(!W){this.collectPendingRequest(A);return}const $=A.id,z=W.listen(this.ctx,A.name,A.arg)(j=>this.sendResponse({id:$,data:j,type:204}));this.activeRequests.set(A.id,z)}disposeActiveRequest(A){const W=this.activeRequests.get(A.id);W&&(W.dispose(),this.activeRequests.delete(A.id))}collectPendingRequest(A){let W=this.pendingRequests.get(A.channelName);W||(W=[],this.pendingRequests.set(A.channelName,W));const $=setTimeout(()=>{console.error(`Unknown channel: ${A.channelName}`),A.type===100&&this.sendResponse({id:A.id,data:{name:"Unknown channel",message:`Channel name '${A.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);W.push({request:A,timeoutTimer:$})}flushPendingRequests(A){const W=this.pendingRequests.get(A);if(W){for(const $ of W)switch(clearTimeout($.timeoutTimer),$.request.type){case 100:this.onPromise($.request);break;case 102:this.onEventListen($.request);break}this.pendingRequests.delete(A)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,p.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=l;var P;(function(_){_[_.LocalSide=0]="LocalSide",_[_.OtherSide=1]="OtherSide"})(P=e.RequestInitiator||(e.RequestInitiator={}));class M{constructor(A,W=null){this.protocol=A,this.isDisposed=!1,this.state=f.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new h.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage($=>this.onBuffer($)),this.logger=W}getChannel(A){const W=this;return{call($,Y,z){return W.isDisposed?Promise.reject(y.canceled()):W.requestPromise(A,$,Y,z)},listen($,Y){return W.isDisposed?h.Event.None:W.requestEvent(A,$,Y)}}}requestPromise(A,W,$,Y=R.CancellationToken.None){const z=this.lastRequestId++,L={id:z,type:100,channelName:A,name:W,arg:$};if(Y.isCancellationRequested)return Promise.reject(y.canceled());let O;return new Promise((V,x)=>{if(Y.isCancellationRequested)return x(y.canceled());const ie=()=>{const ce=he=>{switch(he.type){case 201:this.handlers.delete(z),V(he.data);break;case 202:{this.handlers.delete(z);const ke=new Error(he.data.message);ke.stack=he.data.stack,ke.name=he.data.name,x(ke);break}case 203:this.handlers.delete(z),x(he.data);break}};this.handlers.set(z,ce),this.sendRequest(L)};let q=null;this.state===f.Idle?ie():(q=(0,t.createCancelablePromise)(ce=>this.whenInitialized()),q.then(()=>{q=null,ie()}));const te=()=>{q?(q.cancel(),q=null):this.sendRequest({id:z,type:101}),x(y.canceled())},ne=Y.onCancellationRequested(te);O=(0,p.combinedDisposable)((0,p.toDisposable)(te),ne),this.activeRequests.add(O)}).finally(()=>{this.activeRequests.delete(O)})}requestEvent(A,W,$){const Y=this.lastRequestId++,j={id:Y,type:102,channelName:A,name:W,arg:$};let L=null;const O=new h.Emitter({onFirstListenerAdd:()=>{L=(0,t.createCancelablePromise)(V=>this.whenInitialized()),L.then(()=>{L=null,this.activeRequests.add(O),this.sendRequest(j)})},onLastListenerRemove:()=>{L?(L.cancel(),L=null):(this.activeRequests.delete(O),this.sendRequest({id:Y,type:103}))}}),B=V=>O.fire(V.data);return this.handlers.set(Y,B),O.event}sendRequest(A){switch(A.type){case 100:case 102:{const W=this.send([A.type,A.id,A.channelName,A.name],A.arg);this.logger?.logOutgoing(W,A.id,0,`${d(A.type)}: ${A.channelName}.${A.name}`,A.arg);return}case 101:case 103:{const W=this.send([A.type,A.id]);this.logger?.logOutgoing(W,A.id,0,d(A.type));return}}}send(A,W=void 0){const $=new m;return o($,A),o($,W),this.sendBuffer($.buffer)}sendBuffer(A){try{return this.protocol.send(A),A.byteLength}catch{return 0}}onBuffer(A){const W=new w(A),$=a(W),Y=a(W),z=$[0];switch(z){case 200:return this.logger?.logIncoming(A.byteLength,0,0,S(z)),this.onResponse({type:$[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(A.byteLength,$[1],0,S(z),Y),this.onResponse({type:$[0],id:$[1],data:Y})}}onResponse(A){if(A.type===200){this.state=f.Idle,this._onDidInitialize.fire();return}this.handlers.get(A.id)?.(A)}get onDidInitializePromise(){return h.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===f.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,p.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}ve([D.memoize],M.prototype,"onDidInitializePromise",null),e.ChannelClient=M;class T{constructor(A){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new h.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new h.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,A(({protocol:W,onDidClientDisconnect:$})=>{h.Event.once(W.onMessage)(z=>{const j=new w(z),L=a(j),O=new l(W,L),B=new M(W);this.channels.forEach((x,ie)=>O.registerChannel(ie,x));const V={channelServer:O,channelClient:B,ctx:L};this._connections.add(V),this._onDidAddConnection.fire(V),$(()=>{O.dispose(),B.dispose(),this._connections.delete(V),this._onDidRemoveConnection.fire(V)})})})}get connections(){const A=[];return this._connections.forEach(W=>A.push(W)),A}getChannel(A,W){const $=this;return{call(Y,z,j){let L;if((0,b.isFunction)(W)){const B=(0,v.getRandomElement)($.connections.filter(W));L=B?Promise.resolve(B):h.Event.toPromise(h.Event.filter($.onDidAddConnection,W))}else L=W.routeCall($,Y,z);const O=L.then(B=>B.channelClient.getChannel(A));return U(O).call(Y,z,j)},listen(Y,z){if((0,b.isFunction)(W))return $.getMulticastEvent(A,W,Y,z);const j=W.routeEvent($,Y,z).then(L=>L.channelClient.getChannel(A));return U(j).listen(Y,z)}}}getMulticastEvent(A,W,$,Y){const z=this;let j=new p.DisposableStore;const L=new h.Emitter({onFirstListenerAdd:()=>{j=new p.DisposableStore;const O=new h.EventMultiplexer,B=new Map,V=ie=>{const te=ie.channelClient.getChannel(A).listen($,Y),ne=O.add(te);B.set(ie,ne)},x=ie=>{const q=B.get(ie);!q||(q.dispose(),B.delete(ie))};z.connections.filter(W).forEach(V),h.Event.filter(z.onDidAddConnection,W)(V,void 0,j),z.onDidRemoveConnection(x,void 0,j),O.event(L.fire,L,j),j.add(O)},onLastListenerRemove:()=>{j.dispose()}});return L.event}registerChannel(A,W){this.channels.set(A,W),this._connections.forEach($=>{$.channelServer.registerChannel(A,W)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=T;class F{constructor(A,W,$=null){const Y=new m;o(Y,W),A.send(Y.buffer),this.channelClient=new M(A,$),this.channelServer=new l(A,W,$)}getChannel(A){return this.channelClient.getChannel(A)}registerChannel(A,W){this.channelServer.registerChannel(A,W)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=F;function U(_){return{call(A,W,$){return _.then(Y=>Y.call(A,W,$))},listen(A,W){const $=new h.Relay;return _.then(Y=>$.input=Y.listen(A,W)),$.event}}}e.getDelayedChannel=U;function Q(_){let A=!1;return{call(W,$,Y){return A?_.call(W,$,Y):(0,t.timeout)(0).then(()=>A=!0).then(()=>_.call(W,$,Y))},listen(W,$){if(A)return _.listen(W,$);const Y=new h.Relay;return(0,t.timeout)(0).then(()=>A=!0).then(()=>Y.input=_.listen(W,$)),Y.event}}}e.getNextTickChannel=Q;class re{constructor(A){this.fn=A}routeCall(A){return this.route(A)}routeEvent(A){return this.route(A)}async route(A){for(const W of A.connections)if(await Promise.resolve(this.fn(W.ctx)))return Promise.resolve(W);return await h.Event.toPromise(A.onDidAddConnection),await this.route(A)}}e.StaticRouter=re;var ue;(function(_){function A(z,j){const L=z,O=j&&j.disableMarshalling,B=new Map;for(const V in L)$(V)&&B.set(V,h.Event.buffer(L[V],!0));return new class{listen(V,x,ie){const q=B.get(x);if(q)return q;if(Y(x)){const te=L[x];if(typeof te=="function")return te.call(L,ie)}throw new Error(`Event not found: ${x}`)}call(V,x,ie){const q=L[x];if(typeof q=="function"){if(!O&&Array.isArray(ie))for(let te=0;te<ie.length;te++)ie[te]=(0,I.revive)(ie[te]);return q.apply(L,ie)}throw new Error(`Method not found: ${x}`)}}}_.fromService=A;function W(z,j){const L=j&&j.disableMarshalling;return new Proxy({},{get(O,B){if(typeof B=="string")return j?.properties?.has(B)?j.properties.get(B):Y(B)?function(V){return z.listen(B,V)}:$(B)?z.listen(B):async function(...V){let x;j&&!(0,b.isUndefinedOrNull)(j.context)?x=[j.context,...V]:x=V;const ie=await z.call(B,x);return L?ie:(0,I.revive)(ie)};throw new Error(`Property not found: ${String(B)}`)}})}_.toService=W;function $(z){return z[0]==="o"&&z[1]==="n"&&C.isUpperAsciiLetter(z.charCodeAt(2))}function Y(z){return/^onDynamic/.test(z)&&C.isUpperAsciiLetter(z.charCodeAt(9))}})(ue=e.ProxyChannel||(e.ProxyChannel={}));const fe=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function se(_){if(Array.isArray(_))return _;if(_&&typeof _=="object"&&typeof _.toString=="function"){const A=_.toString();if(A!=="[object Object]")return A}return _}function le(_){return Array.isArray(_)?_.map(se):se(_)}function K(_,A,W,$,Y,z,j){j=le(j);const L=fe[Y],O=L[$%L.length];let B=[`%c[${_}]%c[${String(A).padStart(7," ")}]%c[len: ${String(W).padStart(5," ")}]%c${String($).padStart(5," ")} - ${z}`,"color: darkgreen","color: grey","color: grey",`color: ${O}`];/\($/.test(z)?(B=B.concat(j),B.push(")")):B.push(j),console.log.apply(console,B)}e.logWithColors=K;class N{constructor(A,W){this._outgoingPrefix=A,this._incomingPrefix=W,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(A,W,$,Y,z){this._totalOutgoing+=A,K(this._outgoingPrefix,this._totalOutgoing,A,W,$,Y,z)}logIncoming(A,W,$,Y,z){this._totalIncoming+=A,K(this._incomingPrefix,this._totalIncoming,A,W,$,Y,z)}}e.IPCLogger=N}),define(Z[145],ee([0,1,17,3,44]),function(H,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class R{constructor(h){this.port=h,this.onMessage=t.Event.fromDOMEventEmitter(this.port,"message",p=>v.VSBuffer.wrap(p.data)),h.start()}send(h){this.port.postMessage(h.buffer)}disconnect(){this.port.close()}}e.Protocol=R;class D extends k.IPCClient{constructor(h,p){const I=new R(h);super(I,p);this.protocol=I}dispose(){this.protocol.disconnect()}}e.Client=D}),define(Z[98],ee([0,1,17,3,2,44]),function(H,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var D;(function(n){n.Created="created",n.Read="read",n.Write="write",n.Open="open",n.Error="error",n.Close="close",n.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",n.NodeEndReceived="nodeEndReceived",n.NodeEndSent="nodeEndSent",n.NodeDrainBegin="nodeDrainBegin",n.NodeDrainEnd="nodeDrainEnd",n.zlibInflateError="zlibInflateError",n.zlibInflateData="zlibInflateData",n.zlibInflateInitialWrite="zlibInflateInitialWrite",n.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",n.zlibInflateWrite="zlibInflateWrite",n.zlibInflateFlushFired="zlibInflateFlushFired",n.zlibDeflateError="zlibDeflateError",n.zlibDeflateData="zlibDeflateData",n.zlibDeflateWrite="zlibDeflateWrite",n.zlibDeflateFlushFired="zlibDeflateFlushFired",n.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",n.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",n.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",n.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",n.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",n.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",n.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",n.ProtocolHeaderRead="protocolHeaderRead",n.ProtocolMessageRead="protocolMessageRead",n.ProtocolHeaderWrite="protocolHeaderWrite",n.ProtocolMessageWrite="protocolMessageWrite",n.ProtocolWrite="protocolWrite"})(D=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var y;(function(n){n.enableDiagnostics=!1,n.records=[];const o=new WeakMap;let a=0;function l(M,T){if(!o.has(M)){const F=String(++a);o.set(M,F)}return o.get(M)}function P(M,T,F,U){if(!n.enableDiagnostics)return;const Q=l(M,T);if(U instanceof v.VSBuffer||U instanceof Uint8Array||U instanceof ArrayBuffer||ArrayBuffer.isView(U)){const re=v.VSBuffer.alloc(U.byteLength);re.set(U),n.records.push({timestamp:Date.now(),id:Q,label:T,type:F,buff:re})}else n.records.push({timestamp:Date.now(),id:Q,label:T,type:F,data:U})}n.traceSocketEvent=P})(y=e.SocketDiagnostics||(e.SocketDiagnostics={}));var h;(function(n){n[n.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",n[n.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(h=e.SocketCloseEventType||(e.SocketCloseEventType={}));let p=null;function I(){return p||(p=v.VSBuffer.alloc(0)),p}class C{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(o){this._chunks.push(o),this._totalLength+=o.byteLength}read(o){return this._read(o,!0)}peek(o){return this._read(o,!1)}_read(o,a){if(o===0)return I();if(o>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===o){const T=this._chunks[0];return a&&(this._chunks.shift(),this._totalLength-=o),T}if(this._chunks[0].byteLength>o){const T=this._chunks[0].slice(0,o);return a&&(this._chunks[0]=this._chunks[0].slice(o),this._totalLength-=o),T}const l=v.VSBuffer.alloc(o);let P=0,M=0;for(;o>0;){const T=this._chunks[M];if(T.byteLength>o){const F=T.slice(0,o);l.set(F,P),P+=o,a&&(this._chunks[M]=T.slice(o),this._totalLength-=o),o-=o}else l.set(T,P),P+=T.byteLength,a?(this._chunks.shift(),this._totalLength-=T.byteLength):M++,o-=T.byteLength}return l}}e.ChunkStream=C;var b;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest",n[n.Pause=7]="Pause",n[n.Resume=8]="Resume"})(b||(b={}));function g(n){switch(n){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var d;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.TimeoutTime=2e4]="TimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(d=e.ProtocolConstants||(e.ProtocolConstants={}));class E{constructor(o,a,l,P){this.type=o,this.id=a,this.ack=l,this.data=P,this.writtenTime=0}get size(){return this.data.byteLength}}class S extends k.Disposable{constructor(o){super();this._onMessage=this._register(new t.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=o,this._isDisposed=!1,this._incomingData=new C,this._register(this._socket.onData(a=>this.acceptChunk(a))),this.lastReadTime=Date.now()}acceptChunk(o){if(!(!o||o.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(o);this._incomingData.byteLength>=this._state.readLen;){const a=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=a.readUInt32BE(9),this._state.messageType=a.readUInt8(0),this._state.id=a.readUInt32BE(1),this._state.ack=a.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:g(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const l=this._state.messageType,P=this._state.id,M=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",a),this._onMessage.fire(new E(l,P,M,a)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class f{constructor(o){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=o,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(o){if(this._isDisposed)return;o.writtenTime=Date.now(),this.lastWriteTime=Date.now();const a=v.VSBuffer.alloc(13);a.writeUInt8(o.type,0),a.writeUInt32BE(o.id,1),a.writeUInt32BE(o.ack,5),a.writeUInt32BE(o.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:g(o.type),id:o.id,ack:o.ack,messageSize:o.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",o.data),this._writeSoon(a,o.data)}_bufferAdd(o,a){const l=this._totalLength===0;return this._data.push(o,a),this._totalLength+=o.byteLength+a.byteLength,l}_bufferTake(){const o=v.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,o}_writeSoon(o,a){this._bufferAdd(o,a)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const o=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:o.byteLength}),this._socket.write(o)}}class w extends k.Disposable{constructor(o){super();this._onMessage=new t.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=o,this._socketWriter=this._register(new f(this._socket)),this._socketReader=this._register(new S(this._socket)),this._register(this._socketReader.onMessage(a=>{a.type===1&&this._onMessage.fire(a.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(o){this._socketWriter.write(new E(1,0,0,o))}}e.Protocol=w;class m extends R.IPCClient{constructor(o,a,l=null){super(o,a,l);this.protocol=o}static fromSocket(o,a){return new m(new w(o),a)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const o=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),o.end()}}e.Client=m;class u{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new t.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(o){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(o):this._emitter.fire(o):this._bufferedMessages.push(o)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=u;class c{constructor(o){this.data=o,this.next=null}}class s{constructor(){this._first=null,this._last=null}length(){let o=0,a=this._first;for(;a;)a=a.next,o++;return o}peek(){return this._first?this._first.data:null}toArray(){const o=[];let a=0,l=this._first;for(;l;)o[a++]=l.data,l=l.next;return o}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(o){const a=new c(o);if(!this._first){this._first=a,this._last=a;return}this._last.next=a,this._last=a}}class r{constructor(){this.lastRuns=[];const o=Date.now();for(let a=0;a<r._HISTORY_LENGTH;a++)this.lastRuns[a]=o-1e3*a;setInterval(()=>{for(let a=r._HISTORY_LENGTH;a>=1;a--)this.lastRuns[a]=this.lastRuns[a-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return r._INSTANCE||(r._INSTANCE=new r),r._INSTANCE}load(){const o=Date.now(),a=(1+r._HISTORY_LENGTH)*1e3;let l=0;for(let P=0;P<r._HISTORY_LENGTH;P++)o-this.lastRuns[P]<=a&&l++;return 1-l/r._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}r._HISTORY_LENGTH=10,r._INSTANCE=null;class i{constructor(o,a=null,l=r.getInstance()){this._onControlMessage=new u,this.onControlMessage=this._onControlMessage.event,this._onMessage=new u,this.onMessage=this._onMessage.event,this._onDidDispose=new u,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new u,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new u,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=l,this._isReconnecting=!1,this._outgoingUnackMsg=new s,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=o,this._socketWriter=new f(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new S(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(P=>this._receiveMessage(P))),this._socketDisposables.push(this._socket.onClose(P=>this._onSocketClose.fire(P))),a&&this._socketReader.acceptChunk(a)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,k.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const o=new E(5,0,0,I());this._socketWriter.write(o),this._socketWriter.flush()}sendPause(){const o=new E(7,0,0,I());this._socketWriter.write(o)}sendResume(){const o=new E(8,0,0,I());this._socketWriter.write(o)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(o,a){this._isReconnecting=!0,this._socketDisposables=(0,k.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=o,this._socketWriter=new f(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new S(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(l=>this._receiveMessage(l))),this._socketDisposables.push(this._socket.onClose(l=>this._onSocketClose.fire(l))),this._socketReader.acceptChunk(a)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const o=new E(3,0,this._incomingAckId,I());this._socketWriter.write(o);const a=this._outgoingUnackMsg.toArray();for(let l=0,P=a.length;l<P;l++)this._socketWriter.write(a[l]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(o){if(o.ack>this._outgoingAckId){this._outgoingAckId=o.ack;do{const a=this._outgoingUnackMsg.peek();if(a&&a.id<=o.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(o.type){case 0:break;case 1:{if(o.id>this._incomingMsgId)if(o.id!==this._incomingMsgId+1){const a=Date.now();a-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=a,this._socketWriter.write(new E(6,0,0,I())))}else this._incomingMsgId=o.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(o.data);break}case 2:{this._onControlMessage.fire(o.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const a=this._outgoingUnackMsg.toArray();for(let l=0,P=a.length;l<P;l++)this._socketWriter.write(a[l]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(o){const a=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const l=new E(1,a,this._incomingAckId,o);this._outgoingUnackMsg.push(l),this._isReconnecting||(this._socketWriter.write(l),this._recvAckCheck())}sendControl(o){const a=new E(2,0,0,o);this._socketWriter.write(a)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const o=Date.now()-this._incomingMsgLastTime;if(o>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-o+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const o=this._outgoingUnackMsg.peek(),a=Date.now()-o.writtenTime,l=Date.now()-this._socketReader.lastReadTime,P=Date.now()-this._lastSocketTimeoutTime;if(a>=2e4&&l>=2e4&&P>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:a,timeSinceLastReceivedSomeData:l});return}const M=Math.max(2e4-a,2e4-l,2e4-P,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},M)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const o=new E(3,0,this._incomingAckId,I());this._socketWriter.write(o)}}e.PersistentProtocol=i}),define(Z[146],ee([0,1,40,17,3,2,44,131]),function(H,e,v,t,k,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function h(I,C){const b=k.Event.fromNodeEventEmitter(v.validatedIpcMain,C,(d,E)=>({event:d,message:E})),g=k.Event.filter(b,({event:d})=>d.sender.id===I);return k.Event.map(g,({message:d})=>d&&t.VSBuffer.wrap(d))}class p extends D.IPCServer{constructor(){super(p.getOnDidClientConnect())}static getOnDidClientConnect(){const C=k.Event.fromNodeEventEmitter(v.validatedIpcMain,"vscode:hello",({sender:b})=>b);return k.Event.map(C,b=>{const g=b.id;p.Clients.get(g)?.dispose();const E=new k.Emitter;p.Clients.set(g,(0,R.toDisposable)(()=>E.fire()));const S=h(g,"vscode:message"),f=k.Event.any(k.Event.signal(h(g,"vscode:disconnect")),E.event);return{protocol:new y.Protocol(b,S),onDidClientDisconnect:f}})}}e.Server=p,p.Clients=new Map}),define(Z[99],ee([0,1,40,3,28,145]),function(H,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class D extends R.Client{constructor(p,I){super({addEventListener:(C,b)=>p.addListener(C,b),removeEventListener:(C,b)=>p.removeListener(C,b),postMessage:C=>p.postMessage(C),start:()=>p.start(),close:()=>p.close()},I)}}e.Client=D;async function y(h){if(h.isDestroyed()||h.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const p=(0,k.generateUuid)();h.webContents.send("vscode:createMessageChannel",p);const I=t.Event.fromNodeEventEmitter(v.validatedIpcMain,"vscode:createMessageChannelResult",(b,g)=>({nonce:g,port:b.ports[0]})),{port:C}=await t.Event.toPromise(t.Event.once(t.Event.filter(I,b=>b.nonce===p)));return C}e.connect=y}),define(Z[147],ee([0,1,50,8,17,21,140,18,3,2,49,82,78,44]),function(H,e,v,t,k,R,D,y,h,p,I,C,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class d extends g.ChannelServer{constructor(f){super({send:w=>{try{process.send?.(w.buffer.toString("base64"))}catch{}},onMessage:h.Event.fromNodeEventEmitter(process,"message",w=>k.VSBuffer.wrap(Buffer.from(w,"base64")))},f);process.once("disconnect",()=>this.dispose())}}e.Server=d;class E{constructor(f,w){this.modulePath=f,this.options=w,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new h.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const m=w&&w.timeout?w.timeout:6e4;this.disposeDelayer=new t.Delayer(m),this.child=null,this._client=null}getChannel(f){const w=this;return{call(m,u,c){return w.requestPromise(f,m,u,c)},listen(m,u){return w.requestEvent(f,m,u)}}}requestPromise(f,w,m,u=R.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(u.isCancellationRequested)return Promise.reject(y.canceled());this.disposeDelayer.cancel();const c=this.getCachedChannel(f),s=(0,t.createCancelablePromise)(n=>c.call(w,m,n)),r=u.onCancellationRequested(()=>s.cancel()),i=(0,p.toDisposable)(()=>s.cancel());return this.activeRequests.add(i),s.finally(()=>{r.dispose(),this.activeRequests.delete(i),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),s}requestEvent(f,w,m){if(!this.disposeDelayer)return h.Event.None;this.disposeDelayer.cancel();let u;const c=new h.Emitter({onFirstListenerAdd:()=>{u=this.getCachedChannel(f).listen(w,m)(c.fire,c),this.activeRequests.add(u)},onLastListenerRemove:()=>{this.activeRequests.delete(u),u.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return c.event}get client(){if(!this._client){const f=this.options&&this.options.args?this.options.args:[],w=Object.create(null);w.env={...(0,I.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(w.env={...w.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(w.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(w.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(w.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),w.execArgv===void 0&&(w.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o))),(0,b.removeDangerousEnvVariables)(w.env),this.child=(0,v.fork)(this.modulePath,f,w);const m=new h.Emitter;h.Event.fromNodeEventEmitter(this.child,"message",o=>o)(o=>{if((0,D.isRemoteConsoleLog)(o)){(0,D.log)(o,`IPC Library: ${this.options.serverName}`);return}m.fire(k.VSBuffer.wrap(Buffer.from(o,"base64")))});const c=this.options.useQueue?(0,C.createQueuedSender)(this.child):this.child,s=o=>this.child&&this.child.connected&&c.send(o.buffer.toString("base64")),r=m.event,i={send:s,onMessage:r};this._client=new g.ChannelClient(i);const n=()=>this.disposeClient();process.once("exit",n),this.child.on("error",o=>console.warn('IPC "'+this.options.serverName+'" errored with '+o)),this.child.on("exit",(o,a)=>{process.removeListener("exit",n),this.activeRequests.forEach(l=>(0,p.dispose)(l)),this.activeRequests.clear(),o!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+o+" and signal "+a),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:o,signal:a})})}return this._client}getCachedChannel(f){let w=this.channels.get(f);return w||(w=this.client.getChannel(f),this.channels.set(f,w)),w}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=E}),define(Z[83],ee([0,1,17,18,3,2,9,4,28,44,98]),function(H,e,v,t,k,R,D,y,h,p,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function C(){return{crypto:H.__$__nodeRequire("crypto"),zlib:H.__$__nodeRequire("zlib"),net:H.__$__nodeRequire("net"),os:H.__$__nodeRequire("os")}}class b{constructor(l,P=""){this.debugLabel=P,this.socket=l,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=M=>{if(this.traceSocketEvent("error",{code:M?.code,message:M?.message}),M){if(M.code==="EPIPE")return;(0,t.onUnexpectedError)(M)}},this.socket.on("error",this._errorListener)}traceSocketEvent(l,P){I.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,l,P)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(l){const P=M=>{this.traceSocketEvent("read",M),l(v.VSBuffer.wrap(M))};return this.socket.on("data",P),{dispose:()=>this.socket.off("data",P)}}onClose(l){const P=M=>{this.traceSocketEvent("close",{hadError:M}),l({type:0,hadError:M,error:void 0})};return this.socket.on("close",P),{dispose:()=>this.socket.off("close",P)}}onEnd(l){const P=()=>{this.traceSocketEvent("nodeEndReceived"),l()};return this.socket.on("end",P),{dispose:()=>this.socket.off("end",P)}}write(l){if(!this.socket.destroyed)try{this.traceSocketEvent("write",l),this.socket.write(l.buffer,P=>{if(P){if(P.code==="EPIPE")return;(0,t.onUnexpectedError)(P)}})}catch(P){if(P.code==="EPIPE")return;(0,t.onUnexpectedError)(P)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((l,P)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),l();return}const M=()=>{this.socket.off("close",M),this.socket.off("end",M),this.socket.off("error",M),this.socket.off("timeout",M),this.socket.off("drain",M),this.traceSocketEvent("nodeDrainEnd"),l()};this.socket.on("close",M),this.socket.on("end",M),this.socket.on("error",M),this.socket.on("timeout",M),this.socket.on("drain",M)})}}e.NodeSocket=b;var g;(function(a){a[a.MinHeaderByteSize=2]="MinHeaderByteSize"})(g||(g={}));var d;(function(a){a[a.PeekHeader=1]="PeekHeader",a[a.ReadHeader=2]="ReadHeader",a[a.ReadBody=3]="ReadBody",a[a.Fin=4]="Fin"})(d||(d={}));class E extends R.Disposable{constructor(l,P,M,T){super();this._onData=this._register(new k.Emitter),this._onClose=this._register(new k.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=l,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:P,inflateBytesLength:M?.byteLength||0,recordInflateBytes:T}),this._flowManager=this._register(new S(this,P,M,T,this._onData,(F,U)=>this._write(F,U))),this._register(this._flowManager.onError(F=>{console.error(F),(0,t.onUnexpectedError)(F),this._onClose.fire({type:0,hadError:!0,error:F})})),this._incomingData=new I.ChunkStream,this._register(this.socket.onData(F=>this._acceptChunk(F))),this._register(this.socket.onClose(F=>this._onClose.fire(F)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(l,P){this.socket.traceSocketEvent(l,P)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(l){return this._onData.event(l)}onClose(l){return this._onClose.event(l)}onEnd(l){return this.socket.onEnd(l)}write(l){this._flowManager.writeMessage(l)}_write(l,P){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",l);let M=2;l.byteLength<126?M+=0:l.byteLength<2**16?M+=2:M+=8;const T=v.VSBuffer.alloc(M);if(P?T.writeUInt8(194,0):T.writeUInt8(130,0),l.byteLength<126)T.writeUInt8(l.byteLength,1);else if(l.byteLength<2**16){T.writeUInt8(126,1);let F=1;T.writeUInt8(l.byteLength>>>8&255,++F),T.writeUInt8(l.byteLength>>>0&255,++F)}else{T.writeUInt8(127,1);let F=1;T.writeUInt8(0,++F),T.writeUInt8(0,++F),T.writeUInt8(0,++F),T.writeUInt8(0,++F),T.writeUInt8(l.byteLength>>>24&255,++F),T.writeUInt8(l.byteLength>>>16&255,++F),T.writeUInt8(l.byteLength>>>8&255,++F),T.writeUInt8(l.byteLength>>>0&255,++F)}this.socket.write(v.VSBuffer.concat([T,l]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(l){if(l.byteLength!==0){for(this._incomingData.acceptChunk(l);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const P=this._incomingData.peek(this._state.readLen),M=P.readUInt8(0),T=(M&128)>>>7,F=(M&64)>>>6,U=P.readUInt8(1),Q=(U&128)>>>7,re=U&127;this._state.state=2,this._state.readLen=2+(Q?4:0)+(re===126?2:0)+(re===127?8:0),this._state.fin=T,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(F)),this._state.firstFrameOfMessage=Boolean(T),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const P=this._incomingData.read(this._state.readLen),M=P.readUInt8(1),T=(M&128)>>>7;let F=M&127,U=1;F===126?F=P.readUInt8(++U)*2**8+P.readUInt8(++U):F===127&&(F=P.readUInt8(++U)*0+P.readUInt8(++U)*0+P.readUInt8(++U)*0+P.readUInt8(++U)*0+P.readUInt8(++U)*2**24+P.readUInt8(++U)*2**16+P.readUInt8(++U)*2**8+P.readUInt8(++U));let Q=0;T&&(Q=P.readUInt8(++U)*2**24+P.readUInt8(++U)*2**16+P.readUInt8(++U)*2**8+P.readUInt8(++U)),this._state.state=3,this._state.readLen=F,this._state.mask=Q,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const P=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",P),m(P,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",P),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(P,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await k.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=E;class S extends R.Disposable{constructor(l,P,M,T,F,U){super();this._tracer=l,this._onData=F,this._writeFn=U,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new k.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,P?(this._zlibInflateStream=this._register(new f(this._tracer,T,M,{windowBits:15})),this._zlibDeflateStream=this._register(new w(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(Q=>this._onError.fire(Q))),this._register(this._zlibDeflateStream.onError(Q=>this._onError.fire(Q)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:v.VSBuffer.alloc(0)}writeMessage(l){this._writeQueue.push(l),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const l=this._writeQueue.shift();if(this._zlibDeflateStream){const P=await this._deflateMessage(this._zlibDeflateStream,l);this._writeFn(P,!0)}else this._writeFn(l,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(l,P){return new Promise((M,T)=>{l.write(P),l.flush(F=>M(F))})}acceptFrame(l,P,M){this._readQueue.push({data:l,isCompressed:P,isLastFrameOfMessage:M}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const l=this._readQueue.shift();if(this._zlibInflateStream&&l.isCompressed){const P=await this._inflateFrame(this._zlibInflateStream,l.data,l.isLastFrameOfMessage);this._onData.fire(P)}else this._onData.fire(l.data)}this._isProcessingReadQueue=!1}}_inflateFrame(l,P,M){return new Promise((T,F)=>{l.write(P),M&&l.write(v.VSBuffer.fromByteArray([0,0,255,255])),l.flush(U=>T(U))})}}class f extends R.Disposable{constructor(l,P,M,T){super();this._tracer=l,this._recordInflateBytes=P,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=C().zlib.createInflateRaw(T),this._zlibInflate.on("error",F=>{this._tracer.traceSocketEvent("zlibInflateError",{message:F?.message,code:F?.code}),this._onError.fire(F)}),this._zlibInflate.on("data",F=>{this._tracer.traceSocketEvent("zlibInflateData",F),this._pendingInflateData.push(v.VSBuffer.wrap(F))}),M&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",M.buffer),this._zlibInflate.write(M.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?v.VSBuffer.concat(this._recordedInflateBytes):v.VSBuffer.alloc(0)}write(l){this._recordInflateBytes&&this._recordedInflateBytes.push(l.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",l),this._zlibInflate.write(l.buffer)}flush(l){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const P=v.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,l(P)})}}class w extends R.Disposable{constructor(l,P){super();this._tracer=l,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=C().zlib.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",M=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:M?.message,code:M?.code}),this._onError.fire(M)}),this._zlibDeflate.on("data",M=>{this._tracer.traceSocketEvent("zlibDeflateData",M),this._pendingDeflateData.push(v.VSBuffer.wrap(M))})}write(l){this._tracer.traceSocketEvent("zlibDeflateWrite",l.buffer),this._zlibDeflate.write(l.buffer)}flush(l){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let P=v.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,P=P.slice(0,P.byteLength-4),l(P)})}}function m(a,l){if(l===0)return;const P=a.byteLength>>>2;for(let re=0;re<P;re++){const ue=a.readUInt32BE(re*4);a.writeUInt32BE(ue^l,re*4)}const M=P*4,T=a.byteLength-M,F=l>>>24&255,U=l>>>16&255,Q=l>>>8&255;T>=1&&a.writeUInt8(a.readUInt8(M)^F,M),T>=2&&a.writeUInt8(a.readUInt8(M+1)^U,M+1),T>=3&&a.writeUInt8(a.readUInt8(M+2)^Q,M+2)}e.XDG_RUNTIME_DIR=typeof process!="undefined"?process.env.XDG_RUNTIME_DIR:void 0;const u={[2]:107,[1]:103};function c(){const a=(0,h.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${a}-sock`;let l;return e.XDG_RUNTIME_DIR?l=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${a}.sock`):l=(0,D.join)(C().os.tmpdir(),`vscode-ipc-${a}.sock`),r(l),l}e.createRandomIPCHandle=c;function s(a,l,P){const M=C().crypto.createHash("md5").update(a).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${M}-${P}-${l}-sock`;let T;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?T=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-${M.substr(0,8)}-${P}-${l}.sock`):T=(0,D.join)(a,`${P}-${l}.sock`),r(T),T}e.createStaticIPCHandle=s;function r(a){const l=u[y.platform];typeof l=="number"&&a.length>=l&&console.warn(`WARNING: IPC handle "${a}" is longer than ${l} chars, try a shorter --user-data-dir`)}class i extends p.IPCServer{constructor(l){super(i.toClientConnectionEvent(l));this.server=l}static toClientConnectionEvent(l){const P=k.Event.fromNodeEventEmitter(l,"connection");return k.Event.map(P,M=>({protocol:new I.Protocol(new b(M,"ipc-server-connection")),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(M,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=i;function n(a){return new Promise((l,P)=>{const M=C().net.createServer();M.on("error",P),M.listen(a,()=>{M.removeListener("error",P),l(new i(M))})})}e.serve=n;function o(a,l){return new Promise((P,M)=>{const T=C().net.createConnection(a,()=>{T.removeListener("error",M),P(I.Client.fromSocket(new b(T,`ipc-client${l}`),l))});T.once("error",M)})}e.connect=o}),define(Z[100],ee([0,1,8,3,2,12]),function(H,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var D;(function(C){C[C.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(D=e.StorageHint||(e.StorageHint={}));function y(C){const b=C;return b?.changed instanceof Map||b?.deleted instanceof Set}e.isStorageItemsChangeEvent=y;var h;(function(C){C[C.None=0]="None",C[C.Initialized=1]="Initialized",C[C.Closed=2]="Closed"})(h=e.StorageState||(e.StorageState={}));class p extends k.Disposable{constructor(b,g=Object.create(null)){super();this.database=b,this.options=g,this._onDidChangeStorage=this._register(new t.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=h.None,this.cache=new Map,this.flushDelayer=new v.ThrottledDelayer(p.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(b=>this.onDidChangeItemsExternal(b)))}onDidChangeItemsExternal(b){b.changed?.forEach((g,d)=>this.accept(d,g)),b.deleted?.forEach(g=>this.accept(g,void 0))}accept(b,g){if(this.state===h.Closed)return;let d=!1;(0,R.isUndefinedOrNull)(g)?d=this.cache.delete(b):this.cache.get(b)!==g&&(this.cache.set(b,g),d=!0),d&&this._onDidChangeStorage.fire(b)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===h.None&&(this.state=h.Initialized,this.options.hint!==D.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(b,g){const d=this.cache.get(b);return(0,R.isUndefinedOrNull)(d)?g:d}getBoolean(b,g){const d=this.get(b);return(0,R.isUndefinedOrNull)(d)?g:d==="true"}getNumber(b,g){const d=this.get(b);return(0,R.isUndefinedOrNull)(d)?g:parseInt(d,10)}async set(b,g){if(this.state===h.Closed)return;if((0,R.isUndefinedOrNull)(g))return this.delete(b);const d=String(g);if(this.cache.get(b)!==d)return this.cache.set(b,d),this.pendingInserts.set(b,d),this.pendingDeletes.delete(b),this._onDidChangeStorage.fire(b),this.doFlush()}async delete(b){if(!(this.state===h.Closed||!this.cache.delete(b)))return this.pendingDeletes.has(b)||this.pendingDeletes.add(b),this.pendingInserts.delete(b),this._onDidChangeStorage.fire(b),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=h.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const b={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(b).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(b){if(!!this.hasPending)return this.doFlush(b)}async doFlush(b){return this.flushDelayer.trigger(()=>this.flushPending(),b)}async whenFlushed(){if(!!this.hasPending)return new Promise(b=>this.whenFlushedCallbacks.push(b))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=p,p.DEFAULT_FLUSH_DELAY=100;class I{constructor(){this.onDidChangeItemsExternal=t.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(b){b.insert?.forEach((g,d)=>this.items.set(d,g)),b.delete?.forEach(g=>this.items.delete(g))}async close(){}}e.InMemoryStorageDatabase=I}),define(Z[148],ee([0,1,8,3,32,9,23]),function(H,e,v,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class y{constructor(I,C=Object.create(null)){this.path=I,this.options=C,this.name=(0,R.basename)(this.path),this.logger=new h(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return t.Event.None}async getItems(){const I=await this.whenConnected,C=new Map;return(await this.all(I,"SELECT * FROM ItemTable")).forEach(g=>C.set(g.key,g.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${C.size} rows`),C}async updateItems(I){const C=await this.whenConnected;return this.doUpdateItems(C,I)}doUpdateItems(I,C){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${C.insert?(0,k.mapToString)(C.insert):"0"}), delete(${C.delete?(0,k.setToString)(C.delete):"0"})`),this.transaction(I,()=>{const b=C.insert,g=C.delete;if(b&&b.size>0){const d=[];d.push([]);let E=0;b.forEach((S,f)=>{let w=d[E];w.length>y.MAX_HOST_PARAMETERS&&(E++,w=[],d.push(w)),w.push(f,S)}),d.forEach(S=>{this.prepare(I,`INSERT INTO ItemTable VALUES ${new Array(S.length/2).fill("(?,?)").join(",")}`,f=>f.run(S),()=>{const f=[];let w=0;return b.forEach((m,u)=>{f.push(u),w+=m.length}),`Keys: ${f.join(", ")} Length: ${w}`})})}if(g&&g.size){const d=[];d.push([]);let E=0;g.forEach(S=>{let f=d[E];f.length>y.MAX_HOST_PARAMETERS&&(E++,f=[],d.push(f)),f.push(S)}),d.forEach(S=>{this.prepare(I,`DELETE FROM ItemTable WHERE key IN (${new Array(S.length).fill("?").join(",")})`,f=>f.run(S),()=>{const f=[];return g.forEach(w=>{f.push(w)}),`Keys: ${f.join(", ")}`})})}})}async close(I){this.logger.trace(`[storage ${this.name}] close()`);const C=await this.whenConnected;return this.doClose(C,I)}doClose(I,C){return new Promise((b,g)=>{I.db.close(d=>(d&&this.handleSQLiteError(I,`[storage ${this.name}] close(): ${d}`),this.path===y.IN_MEMORY_PATH?b():!I.isErroneous&&!I.isInMemory?this.backup().then(b,E=>(this.logger.error(`[storage ${this.name}] backup(): ${E}`),b())):typeof C=="function"?D.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(E=>{const S=()=>this.doClose(E,void 0);return this.doUpdateItems(E,{insert:C()}).then(()=>S(),f=>(S(),Promise.reject(f)))})).then(b,g):g(d||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const I=this.toBackupPath(this.path);return D.Promises.copy(this.path,I,{preserveSymlinks:!1})}toBackupPath(I){return`${I}.backup`}async checkIntegrity(I){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${I})`);const C=await this.whenConnected,b=await this.get(C,I?"PRAGMA integrity_check":"PRAGMA quick_check"),g=I?b.integrity_check:b.quick_check;return C.isErroneous?`${g} (last error: ${C.lastError})`:C.isInMemory?`${g} (in-memory!)`:g}async connect(I,C=!0){this.logger.trace(`[storage ${this.name}] open(${I}, retryOnBusy: ${C})`);try{return await this.doConnect(I)}catch(b){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${b}`),b.code==="SQLITE_BUSY"&&C)return await(0,v.timeout)(y.BUSY_OPEN_TIMEOUT),this.connect(I,!1);try{await D.Promises.unlink(I);try{await D.Promises.rename(this.toBackupPath(I),I)}catch{}return await this.doConnect(I)}catch(g){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${g}`),this.doConnect(y.IN_MEMORY_PATH)}}}handleSQLiteError(I,C){I.isErroneous=!0,I.lastError=C,this.logger.error(C)}doConnect(I){return new Promise((C,b)=>{new Promise((g,d)=>{H(["@vscode/sqlite3"],g,d)}).then(g=>{const d={db:new(this.logger.isTracing?g.verbose().Database:g.Database)(I,E=>E?d.db&&E.code!=="SQLITE_CANTOPEN"?d.db.close(()=>b(E)):b(E):this.exec(d,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>C(d),S=>d.db.close(()=>b(S)))),isInMemory:I===y.IN_MEMORY_PATH};d.db.on("error",E=>this.handleSQLiteError(d,`[storage ${this.name}] Error (event): ${E}`)),this.logger.isTracing&&d.db.on("trace",E=>this.logger.trace(`[storage ${this.name}] Trace (event): ${E}`))},b)})}exec(I,C){return new Promise((b,g)=>{I.db.exec(C,d=>d?(this.handleSQLiteError(I,`[storage ${this.name}] exec(): ${d}`),g(d)):b())})}get(I,C){return new Promise((b,g)=>{I.db.get(C,(d,E)=>d?(this.handleSQLiteError(I,`[storage ${this.name}] get(): ${d}`),g(d)):b(E))})}all(I,C){return new Promise((b,g)=>{I.db.all(C,(d,E)=>d?(this.handleSQLiteError(I,`[storage ${this.name}] all(): ${d}`),g(d)):b(E))})}transaction(I,C){return new Promise((b,g)=>{I.db.serialize(()=>{I.db.run("BEGIN TRANSACTION"),C(),I.db.run("END TRANSACTION",d=>d?(this.handleSQLiteError(I,`[storage ${this.name}] transaction(): ${d}`),g(d)):b())})})}prepare(I,C,b,g){const d=I.db.prepare(C),E=S=>{this.handleSQLiteError(I,`[storage ${this.name}] prepare(): ${S} (${C}). Details: ${g()}`)};d.on("error",E),b(d),d.finalize(S=>{S&&E(S),d.removeListener("error",E)})}}e.SQLiteStorageDatabase=y,y.IN_MEMORY_PATH=":memory:",y.BUSY_OPEN_TIMEOUT=2e3,y.MAX_HOST_PARAMETERS=256;class h{constructor(I){I&&typeof I.logTrace=="function"&&process.env[h.VSCODE_TRACE_STORAGE]&&(this.logTrace=I.logTrace),I&&typeof I.logError=="function"&&(this.logError=I.logError)}get isTracing(){return!!this.logTrace}trace(I){this.logTrace?.(I)}error(I){this.logError?.(I)}}h.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(Z[149],ee([11,10]),function(H,e){return H.create("vs/code/electron-main/app",e)}),define(Z[150],ee([11,10]),function(H,e){return H.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Z[151],ee([11,10]),function(H,e){return H.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(Z[152],ee([11,10]),function(H,e){return H.create("vs/platform/environment/node/argv",e)}),define(Z[153],ee([11,10]),function(H,e){return H.create("vs/platform/environment/node/argvHelper",e)}),define(Z[154],ee([11,10]),function(H,e){return H.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Z[155],ee([11,10]),function(H,e){return H.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(Z[156],ee([11,10]),function(H,e){return H.create("vs/platform/extensions/common/extensionValidator",e)}),define(Z[157],ee([11,10]),function(H,e){return H.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Z[158],ee([11,10]),function(H,e){return H.create("vs/platform/files/common/fileService",e)}),define(Z[159],ee([11,10]),function(H,e){return H.create("vs/platform/files/common/files",e)}),define(Z[160],ee([11,10]),function(H,e){return H.create("vs/platform/files/common/io",e)}),define(Z[161],ee([11,10]),function(H,e){return H.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(Z[162],ee([11,10]),function(H,e){return H.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Z[163],ee([11,10]),function(H,e){return H.create("vs/platform/issue/electron-main/issueMainService",e)}),define(Z[164],ee([11,10]),function(H,e){return H.create("vs/platform/menubar/electron-main/menubar",e)}),define(Z[165],ee([11,10]),function(H,e){return H.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(Z[166],ee([11,10]),function(H,e){return H.create("vs/platform/request/common/request",e)}),define(Z[167],ee([11,10]),function(H,e){return H.create("vs/platform/shell/node/shellEnv",e)}),define(Z[168],ee([11,10]),function(H,e){return H.create("vs/platform/telemetry/common/telemetryService",e)}),define(Z[169],ee([11,10]),function(H,e){return H.create("vs/platform/update/common/update.config.contribution",e)}),define(Z[170],ee([11,10]),function(H,e){return H.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Z[171],ee([11,10]),function(H,e){return H.create("vs/platform/windows/electron-main/windowImpl",e)}),define(Z[172],ee([11,10]),function(H,e){return H.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(Z[173],ee([11,10]),function(H,e){return H.create("vs/platform/workspace/common/workspace",e)}),define(Z[174],ee([11,10]),function(H,e){return H.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(Z[175],ee([11,10]),function(H,e){return H.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(Z[176],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.isFolderBackupInfo=void 0;function v(k){return k&&k.hasOwnProperty("folderUri")}e.isFolderBackupInfo=v;function t(k){return k&&k.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=t}),define(Z[177],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEmptyWindowBackupInfo=void 0;function v(t){return typeof t?.backupFolder=="string"}e.isEmptyWindowBackupInfo=v}),define(Z[178],ee([0,1,3,2]),function(H,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class k{constructor(){this._onCloseEmitter=new v.Emitter,this._onReloadEmitter=new v.Emitter,this._onTerminateEmitter=new v.Emitter,this._onAttachEmitter=new v.Emitter}call(y,h,p){switch(h){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:p[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:p[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:p[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:p[0],port:p[1],subId:p[2]}))}throw new Error("Method not implemented.")}listen(y,h,p){switch(h){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=k,k.ChannelName="extensionhostdebugservice";class R extends t.Disposable{constructor(y){super();this.channel=y}reload(y){this.channel.call("reload",[y])}get onReload(){return this.channel.listen("reload")}close(y){this.channel.call("close",[y])}get onClose(){return this.channel.listen("close")}attachSession(y,h,p){this.channel.call("attach",[y,h,p])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(y,h){this.channel.call("terminate",[y,h])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(y,h){return this.channel.call("openExtensionDevelopmentHostWindow",[y,h])}}e.ExtensionHostDebugChannelClient=R}),define(Z[179],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;class v{constructor(k){this.machineId=k}encryption(){return new Promise((k,R)=>H(["vscode-encrypt"],k,R))}async encrypt(k){try{return(await this.encryption()).encrypt(this.machineId,k)}catch{return k}}async decrypt(k){try{return(await this.encryption()).decrypt(this.machineId,k)}catch{return k}}}e.EncryptionMainService=v}),define(Z[180],ee([0,1,134,51,13,9,35,16,7]),function(H,e,v,t,k,R,D,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class p{constructor(E,S,f){this._args=E,this.paths=S,this.productService=f,this.editSessionId=this.args.editSessionId}get appRoot(){return(0,R.dirname)(k.FileAccess.asFileUri("",H).fsPath)}get userHome(){return h.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return h.URI.file((0,R.join)(this.userDataPath,"User"))}get tmpDir(){return h.URI.file(this.paths.tmpDir)}get cacheHome(){return h.URI.file(this.userDataPath)}get stateResource(){return(0,y.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,y.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const E=(0,v.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,R.join)(this.userDataPath,"logs",E)}return this.args.logsPath}get userDataSyncLogResource(){return h.URI.file((0,R.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return h.URI.file((0,R.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,y.joinPath)(h.URI.file((0,R.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,y.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,y.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,y.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const E=D.env.VSCODE_PORTABLE;return E?h.URI.file((0,R.join)(E,"argv.json")):(0,y.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return h.URI.file((0,R.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,R.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const E=this.args["builtin-extensions-dir"];return E?(0,R.resolve)(E):(0,R.normalize)((0,R.join)(k.FileAccess.asFileUri("",H).fsPath,"..","extensions"))}get extensionsDownloadPath(){const E=this.args["extensions-download-dir"];return E?(0,R.resolve)(E):(0,R.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const E=this.args["extensions-dir"];if(E)return(0,R.resolve)(E);const S=D.env.VSCODE_EXTENSIONS;if(S)return S;const f=D.env.VSCODE_PORTABLE;return f?(0,R.join)(f,"extensions"):(0,y.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const E=this.args.extensionDevelopmentPath;if(Array.isArray(E))return E.map(S=>/^[^:/?#]+?:\/\//.test(S)?h.URI.parse(S):h.URI.file((0,R.normalize)(S)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(E=>E==="ui"||E==="workspace"||E==="web"?E:"workspace")}get extensionTestsLocationURI(){const E=this.args.extensionTestsPath;if(E)return/^[^:/?#]+?:\/\//.test(E)?h.URI.parse(E):h.URI.file((0,R.normalize)(E))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const E=this.args["disable-extension"];if(E){if(typeof E=="string")return[E];if(Array.isArray(E)&&E.length>0)return E}return!1}get debugExtensionHost(){return I(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!D.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,y.joinPath)(h.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return h.URI.file((0,R.join)(this.logsPath,"telemetry.log"))}get extensionTelemetryLogResource(){return h.URI.file((0,R.join)(this.logsPath,"extensionTelemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const E=D.env.VSCODE_PORTABLE;return E?h.URI.file((0,R.join)(E,"policy.json")):(0,y.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get args(){return this._args}}ve([t.memoize],p.prototype,"appRoot",null),ve([t.memoize],p.prototype,"userHome",null),ve([t.memoize],p.prototype,"userDataPath",null),ve([t.memoize],p.prototype,"appSettingsHome",null),ve([t.memoize],p.prototype,"tmpDir",null),ve([t.memoize],p.prototype,"cacheHome",null),ve([t.memoize],p.prototype,"stateResource",null),ve([t.memoize],p.prototype,"userRoamingDataHome",null),ve([t.memoize],p.prototype,"userDataSyncHome",null),ve([t.memoize],p.prototype,"userDataSyncLogResource",null),ve([t.memoize],p.prototype,"editSessionsLogResource",null),ve([t.memoize],p.prototype,"sync",null),ve([t.memoize],p.prototype,"machineSettingsResource",null),ve([t.memoize],p.prototype,"workspaceStorageHome",null),ve([t.memoize],p.prototype,"localHistoryHome",null),ve([t.memoize],p.prototype,"keyboardLayoutResource",null),ve([t.memoize],p.prototype,"argvResource",null),ve([t.memoize],p.prototype,"isExtensionDevelopment",null),ve([t.memoize],p.prototype,"untitledWorkspacesHome",null),ve([t.memoize],p.prototype,"installSourcePath",null),ve([t.memoize],p.prototype,"builtinExtensionsPath",null),ve([t.memoize],p.prototype,"extensionsPath",null),ve([t.memoize],p.prototype,"extensionDevelopmentLocationURI",null),ve([t.memoize],p.prototype,"extensionDevelopmentKind",null),ve([t.memoize],p.prototype,"extensionTestsLocationURI",null),ve([t.memoize],p.prototype,"debugExtensionHost",null),ve([t.memoize],p.prototype,"serviceMachineIdResource",null),ve([t.memoize],p.prototype,"telemetryLogResource",null),ve([t.memoize],p.prototype,"disableWorkspaceTrust",null),ve([t.memoize],p.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=p;function I(d,E){return g(d["inspect-extensions"],d["inspect-brk-extensions"],5870,E,d.debugId,d.extensionEnvironment)}e.parseExtensionHostPort=I;function C(d,E){return g(d["inspect-search"],d["inspect-brk-search"],5876,E,d.extensionEnvironment)}e.parseSearchPort=C;function b(d,E){return g(d["inspect-ptyhost"],d["inspect-brk-ptyhost"],5877,E,d.extensionEnvironment)}e.parsePtyHostPort=b;function g(d,E,S,f,w,m){const c=Number(E||d)||(f?null:S),s=c?Boolean(!!E):!1;let r;if(m)try{r=JSON.parse(m)}catch{}return{port:c,break:s,debugId:w,env:r}}}),define(Z[101],ee([0,1,269,4,152]),function(H,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const R={o:(0,k.localize)(0,null),e:(0,k.localize)(1,null),t:(0,k.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,k.localize)(3,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,k.localize)(4,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,k.localize)(5,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,k.localize)(6,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,k.localize)(7,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,k.localize)(8,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,k.localize)(9,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,k.localize)(10,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,k.localize)(11,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,k.localize)(12,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,k.localize)(13,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,k.localize)(14,null)},"show-versions":{type:"boolean",cat:"e",description:(0,k.localize)(15,null)},category:{type:"string",cat:"e",description:(0,k.localize)(16,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,k.localize)(17,null)},"pre-release":{type:"boolean",cat:"e",description:(0,k.localize)(18,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,k.localize)(19,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,k.localize)(20,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,k.localize)(21,null)},verbose:{type:"boolean",cat:"t",description:(0,k.localize)(22,null)},log:{type:"string",cat:"t",args:"level",description:(0,k.localize)(23,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,k.localize)(24,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,k.localize)(25,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,k.localize)(26,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,k.localize)(27,null)},sync:{type:"string",cat:"t",description:(0,k.localize)(28,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,k.localize)(29,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,k.localize)(30,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,k.localize)(31,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,k.localize)(32,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,k.localize)(33,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},_:{type:"string[]"}};const D={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function y(d,E,S=D){const f={},w=["_"],m=[];for(const r in E){const i=E[r];i.alias&&(f[r]=i.alias),i.type==="string"||i.type==="string[]"?(w.push(r),i.deprecates&&w.push(...i.deprecates)):i.type==="boolean"&&(m.push(r),i.deprecates&&m.push(...i.deprecates))}const u=v(d,{string:w,boolean:m,alias:f}),c={},s=u;c._=u._.map(r=>String(r)).filter(r=>r.length>0),delete s._;for(const r in E){const i=E[r];i.alias&&delete s[i.alias];let n=s[r];if(i.deprecates)for(const o of i.deprecates)s.hasOwnProperty(o)&&(n||(n=s[o],n&&S.onDeprecatedOption(o,i.deprecationMessage||(0,k.localize)(34,null,r))),delete s[o]);if(typeof n!="undefined"){if(i.type==="string[]"){if(Array.isArray(n)||(n=[n]),!i.allowEmptyValue){const o=n.filter(a=>a.length>0);o.length!==n.length&&(S.onEmptyValue(r),n=o.length>0?o:void 0)}}else i.type==="string"&&(Array.isArray(n)?(n=n.pop(),S.onMultipleValues(r,n)):!n&&!i.allowEmptyValue&&(S.onEmptyValue(r),n=void 0));c[r]=n,i.deprecationMessage&&S.onDeprecatedOption(r,i.deprecationMessage)}delete s[r]}for(const r in s)S.onUnknownOption(r);return c}e.parseArgs=y;function h(d,E){let S="";return E.args&&(Array.isArray(E.args)?S=` <${E.args.join("> <")}>`:S=` <${E.args}>`),E.alias?`-${E.alias} --${d}${S}`:`--${d}${S}`}function p(d,E){let S=0;const f=[];for(const c in d){const s=d[c],r=h(c,s);S=Math.max(S,r.length),f.push([r,s.description])}const w=S+2+1;if(E-w<25)return f.reduce((c,s)=>c.concat([`  ${s[0]}`,`      ${s[1]}`]),[]);const m=E-w-1,u=[];for(const c of f){const s=c[0],r=C(c[1],m),i=I(w-s.length-2);u.push("  "+s+i+r[0]);for(let n=1;n<r.length;n++)u.push(I(w)+r[n])}return u}e.formatOptions=p;function I(d){return" ".repeat(d)}function C(d,E){const S=[];for(;d.length;){const f=d.length<E?d.length:d.lastIndexOf(" ",E),w=d.slice(0,f).trim();d=d.slice(f),S.push(w)}return S}function b(d,E,S,f,w){const m=process.stdout.isTTY&&process.stdout.columns||80,u=w?.noInputFiles!==!0?`[${(0,k.localize)(35,null)}...]`:"",c=[`${d} ${S}`];c.push(""),c.push(`${(0,k.localize)(36,null)}: ${E} [${(0,k.localize)(37,null)}]${u}`),c.push(""),w?.noPipe!==!0&&(t.isWindows?c.push((0,k.localize)(38,null,E)):c.push((0,k.localize)(39,null,E)),c.push(""));const s={};for(const r in f){const i=f[r];if(i.description&&i.cat){let n=s[i.cat];n||(s[i.cat]=n={}),n[r]=i}}for(const r in s){const i=r,n=s[i];n&&(c.push(R[i]),c.push(...p(n,m)),c.push(""))}return c.join(`
`)}e.buildHelpMessage=b;function g(d,E){return`${d||(0,k.localize)(40,null)}
${E||(0,k.localize)(41,null)}
${process.arch}`}e.buildVersionMessage=g}),define(Z[181],ee([0,1,77,178,101]),function(H,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class R extends t.ExtensionHostDebugBroadcastChannel{constructor(y){super();this.windowsMainService=y}call(y,h,p){return h==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(p[0],p[1]):super.call(y,h,p)}async openExtensionDevelopmentHostWindow(y,h){const p=(0,k.parseArgs)(y,k.OPTIONS);p.debugRenderer=h;const I=p.extensionDevelopmentPath;if(!I)return{success:!1};const[C]=this.windowsMainService.openExtensionDevelopmentHostWindow(I,{context:5,cli:p});if(!h)return{success:!0};const b=C.win;if(!b)return{success:!0};const g=b.webContents.debugger;let d=g.isAttached()?1/0:0;const E=(0,v.createServer)(S=>{d++==0&&g.attach();let f=!1;const w=c=>{f||S.write(JSON.stringify(c)+"\0")},m=(c,s,r,i)=>w({method:s,params:r,sessionId:i});b.on("close",()=>{g.removeListener("message",m),S.end(),f=!0}),g.addListener("message",m);let u=Buffer.alloc(0);S.on("data",c=>{u=Buffer.concat([u,c]);for(let s=u.indexOf(0);s!==-1;s=u.indexOf(0)){let r;try{const i=u.slice(0,s).toString("utf8");u=u.slice(s+1),r=JSON.parse(i)}catch(i){console.error("error reading cdp line",i)}g.sendCommand(r.method,r.params,r.sessionId).then(i=>w({id:r.id,sessionId:r.sessionId,result:i})).catch(i=>w({id:r.id,sessionId:r.sessionId,error:{code:0,message:i.message}}))}}),S.on("error",c=>{console.error("error on cdp pipe:",c)}),S.on("close",()=>{f=!0,--d==0&&g.detach()})});return await new Promise(S=>E.listen(0,S)),b.on("close",()=>E.close()),{rendererDebugPort:E.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=R}),define(Z[58],ee([0,1,270,153,101]),function(H,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const R=2048;function D(b,g){const d={onUnknownOption:S=>{console.warn((0,t.localize)(0,null,S))},onMultipleValues:(S,f)=>{console.warn((0,t.localize)(1,null,S,f))},onEmptyValue:S=>{console.warn((0,t.localize)(2,null,S))},onDeprecatedOption:(S,f)=>{console.warn((0,t.localize)(3,null,S,f))}},E=(0,k.parseArgs)(b,k.OPTIONS,g?d:void 0);return E.goto&&E._.forEach(S=>v(/^(\w:)?[^:]+(:\d*){0,2}$/.test(S),(0,t.localize)(4,null))),E["max-memory"]&&v(parseInt(E["max-memory"])>=R,`The max-memory argument cannot be specified lower than ${R} MB.`),E}function y(b){const g=b.findIndex(d=>!/^-/.test(d));if(g>-1)return[...b.slice(0,g),...b.slice(g+1)]}function h(b){let[,...g]=b;process.env.VSCODE_DEV&&(g=y(g)||[]);const d=!C(process.env);return D(g,d)}e.parseMainProcessArgv=h;function p(b){const[,,...g]=b;return D(g,!0)}e.parseCLIProcessArgv=p;function I(b,...g){const d=b.indexOf("--");return d===-1?b.push(...g):b.splice(d,0,...g),b}e.addArg=I;function C(b){return b.VSCODE_CLI==="1"}e.isLaunchedFromCli=C}),function(){"use strict";function H(e,v,t,k){function R(y){const h=D(y),p=[h];return e.isAbsolute(h)||p.unshift(k),e.resolve(...p)}function D(y){const h=process.env.VSCODE_PORTABLE;if(h)return e.join(h,"user-data");let p=process.env.VSCODE_APPDATA;if(p)return e.join(p,t);const I=y["user-data-dir"];if(I)return I;switch(process.platform){case"win32":if(p=process.env.APPDATA,!p){const C=process.env.USERPROFILE;if(typeof C!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");p=e.join(C,"AppData","Roaming")}break;case"darwin":p=e.join(v.homedir(),"Library","Application Support");break;case"linux":p=process.env.XDG_CONFIG_HOME||e.join(v.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(p,t)}return{getUserDataPath:R}}if(typeof define=="function")define(Z[182],ee([0,271,30,13,16,35]),function(e,v,t,k,R,D){const y=R.dirname(k.FileAccess.asFileUri("",e)),h=e.__$__nodeRequire(R.joinPath(y,"package.json").fsPath);return H(v,t,h.name,D.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),v=require("path"),t=require("os");module.exports=H(v,t,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Z[183],ee([0,1,30,180,182]),function(H,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class R extends t.AbstractNativeEnvironmentService{constructor(y,h){super(y,{homeDir:(0,v.homedir)(),tmpDir:(0,v.tmpdir)(),userDataDir:(0,k.getUserDataPath)(y)},h)}}e.NativeEnvironmentService=R}),define(Z[184],ee([0,1,29,30,31]),function(H,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function R(D){const y=(0,k.randomPath)((0,t.tmpdir)());try{return(0,v.writeFileSync)(y,""),D&&console.log(`Marker file for --wait created: ${y}`),y}catch(h){D&&console.error(`Failed to create marker file for --wait: ${h}`);return}}e.createWaitMarkerFile=R}),define(Z[185],ee([0,1,16,94,156,186]),function(H,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,y=/^-(\d{4})(\d{2})(\d{2})$/;function h(f){return f=f.trim(),f==="*"||D.test(f)}e.isValidVersionStr=h;function p(f){if(!h(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const w=f.match(D);return w?{hasCaret:w[1]==="^",hasGreaterEquals:w[1]===">=",majorBase:w[2]==="x"?0:parseInt(w[2],10),majorMustEqual:w[2]!=="x",minorBase:w[4]==="x"?0:parseInt(w[4],10),minorMustEqual:w[4]!=="x",patchBase:w[6]==="x"?0:parseInt(w[6],10),patchMustEqual:w[6]!=="x",preRelease:w[8]||null}:null}e.parseVersion=p;function I(f){if(!f)return null;const w=f.majorBase,m=f.majorMustEqual,u=f.minorBase;let c=f.minorMustEqual;const s=f.patchBase;let r=f.patchMustEqual;f.hasCaret&&(w===0||(c=!1),r=!1);let i=0;if(f.preRelease){const n=y.exec(f.preRelease);if(n){const[,o,a,l]=n;i=Date.UTC(Number(o),Number(a)-1,Number(l))}}return{majorBase:w,majorMustEqual:m,minorBase:u,minorMustEqual:c,patchBase:s,patchMustEqual:r,isMinimum:f.hasGreaterEquals,notBefore:i}}e.normalizeVersion=I;function C(f,w,m){let u;typeof f=="string"?u=I(p(f)):u=f;let c;w instanceof Date?c=w.getTime():typeof w=="string"&&(c=new Date(w).getTime());let s;if(typeof m=="string"?s=I(p(m)):s=m,!u||!s)return!1;const r=u.majorBase,i=u.minorBase,n=u.patchBase;let o=s.majorBase,a=s.minorBase,l=s.patchBase;const P=s.notBefore;let M=s.majorMustEqual,T=s.minorMustEqual,F=s.patchMustEqual;return s.isMinimum?r>o?!0:r<o?!1:i>a?!0:i<a||c&&c<P?!1:n>=l:(r===1&&o===0&&(!M||!T||!F)&&(o=1,a=0,l=0,M=!0,T=!1,F=!1),r<o?!1:r>o?!M:i<a?!1:i>a?!T:n<l?!1:n>l?!F:!(c&&c<P))}e.isValidVersion=C;function b(f,w,m,u,c){const s=[];if(typeof u.publisher!="undefined"&&typeof u.publisher!="string")return s.push([t.default.Error,k.localize(0,null)]),s;if(typeof u.name!="string")return s.push([t.default.Error,k.localize(1,null,"name")]),s;if(typeof u.version!="string")return s.push([t.default.Error,k.localize(2,null,"version")]),s;if(!u.engines)return s.push([t.default.Error,k.localize(3,null,"engines")]),s;if(typeof u.engines.vscode!="string")return s.push([t.default.Error,k.localize(4,null,"engines.vscode")]),s;if(typeof u.extensionDependencies!="undefined"&&!S(u.extensionDependencies))return s.push([t.default.Error,k.localize(5,null,"extensionDependencies")]),s;if(typeof u.activationEvents!="undefined"){if(!S(u.activationEvents))return s.push([t.default.Error,k.localize(6,null,"activationEvents")]),s;if(typeof u.main=="undefined"&&typeof u.browser=="undefined")return s.push([t.default.Error,k.localize(7,null,"activationEvents","main")]),s}if(typeof u.extensionKind!="undefined"&&typeof u.main=="undefined"&&s.push([t.default.Warning,k.localize(8,null,"extensionKind")]),typeof u.main!="undefined"){if(typeof u.main!="string")return s.push([t.default.Error,k.localize(9,null,"main")]),s;{const n=(0,v.joinPath)(m,u.main);(0,v.isEqualOrParent)(n,m)||s.push([t.default.Warning,k.localize(10,null,n.path,m.path)])}if(typeof u.activationEvents=="undefined")return s.push([t.default.Error,k.localize(11,null,"activationEvents","main")]),s}if(typeof u.browser!="undefined"){if(typeof u.browser!="string")return s.push([t.default.Error,k.localize(12,null,"browser")]),s;{const n=(0,v.joinPath)(m,u.browser);(0,v.isEqualOrParent)(n,m)||s.push([t.default.Warning,k.localize(13,null,n.path,m.path)])}if(typeof u.activationEvents=="undefined")return s.push([t.default.Error,k.localize(14,null,"activationEvents","browser")]),s}if(!R.valid(u.version))return s.push([t.default.Error,k.localize(15,null)]),s;const r=[];if(!g(f,w,u,c,r))for(const n of r)s.push([t.default.Error,n]);return s}e.validateExtensionManifest=b;function g(f,w,m,u,c){return u||typeof m.main=="undefined"&&typeof m.browser=="undefined"?!0:E(f,w,m.engines.vscode,c)}e.isValidExtensionVersion=g;function d(f,w,m){return f==="*"||E(w,m,f)}e.isEngineValid=d;function E(f,w,m,u=[]){const c=I(p(m));if(!c)return u.push(k.localize(16,null,m)),!1;if(c.majorBase===0){if(!c.majorMustEqual||!c.minorMustEqual)return u.push(k.localize(17,null,m)),!1}else if(!c.majorMustEqual)return u.push(k.localize(18,null,m)),!1;return C(f,w,c)?!0:(u.push(k.localize(19,null,f,m)),!1)}function S(f){if(!Array.isArray(f))return!1;for(let w=0,m=f.length;w<m;w++)if(typeof f[w]!="string")return!1;return!0}}),define(Z[187],ee([0,1,17,28]),function(H,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function k(R,D,y){let h=y&&y.get("storage.serviceMachineId",-1)||null;if(h)return h;try{const I=(await D.readFile(R.serviceMachineIdResource)).value.toString();h=(0,t.isUUID)(I)?I:null}catch{h=null}if(!h){h=(0,t.generateUuid)();try{await D.writeFile(R.serviceMachineIdResource,v.VSBuffer.fromString(h))}catch{}}return y?.store("storage.serviceMachineId",h,-1,1),h}e.getServiceMachineId=k}),define(Z[68],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class v{constructor(k,R=[],D=!1){this.ctor=k,this.staticArguments=R,this.supportsDelayedInstantiation=D}}e.SyncDescriptor=v}),define(Z[188],ee([0,1,68]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const t=[];function k(D,y,h){y instanceof v.SyncDescriptor||(y=new v.SyncDescriptor(y,[],h)),t.push([D,y])}e.registerSingleton=k;function R(){return t}e.getSingletonServiceDescriptors=R}),define(Z[189],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class v{constructor(R){this.incoming=new Map,this.outgoing=new Map,this.data=R}}e.Node=v;class t{constructor(R){this._hashFn=R,this._nodes=new Map}roots(){const R=[];for(const D of this._nodes.values())D.outgoing.size===0&&R.push(D);return R}insertEdge(R,D){const y=this.lookupOrInsertNode(R),h=this.lookupOrInsertNode(D);y.outgoing.set(this._hashFn(D),h),h.incoming.set(this._hashFn(R),y)}removeNode(R){const D=this._hashFn(R);this._nodes.delete(D);for(const y of this._nodes.values())y.outgoing.delete(D),y.incoming.delete(D)}lookupOrInsertNode(R){const D=this._hashFn(R);let y=this._nodes.get(D);return y||(y=new v(R),this._nodes.set(D,y)),y}lookup(R){return this._nodes.get(this._hashFn(R))}isEmpty(){return this._nodes.size===0}toString(){const R=[];for(const[D,y]of this._nodes)R.push(`${D}, (incoming)[${[...y.incoming.keys()].join(", ")}], (outgoing)[${[...y.outgoing.keys()].join(",")}]`);return R.join(`
`)}findCycleSlow(){for(const[R,D]of this._nodes){const y=new Set([R]),h=this._findCycle(D,y);if(h)return h}}_findCycle(R,D){for(const[y,h]of R.outgoing){if(D.has(y))return[...D,y].join(" -> ");D.add(y);const p=this._findCycle(h,D);if(p)return p;D.delete(y)}}}e.Graph=t}),define(Z[5],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var v;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function y(h){return h[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=y})(v=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function t(D,y,h){y[v.DI_TARGET]===y?y[v.DI_DEPENDENCIES].push({id:D,index:h}):(y[v.DI_DEPENDENCIES]=[{id:D,index:h}],y[v.DI_TARGET]=y)}function k(D){if(v.serviceIds.has(D))return v.serviceIds.get(D);const y=function(h,p,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(y,h,I)};return y.toString=()=>D,v.serviceIds.set(D,y),y}e.createDecorator=k;function R(D){return D}e.refineServiceDecorator=R}),define(Z[59],ee([0,1,5]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,v.createDecorator)("backupMainService")}),define(Z[19],ee([0,1,12,7,5]),function(H,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function R(f){return f&&typeof f=="object"&&(!f.overrideIdentifier||typeof f.overrideIdentifier=="string")&&(!f.resource||f.resource instanceof t.URI)}e.isConfigurationOverrides=R;function D(f){return f&&typeof f=="object"&&(!f.overrideIdentifiers||Array.isArray(f.overrideIdentifiers))&&!f.overrideIdentifier&&(!f.resource||f.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=D;var y;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.USER=2]="USER",f[f.USER_LOCAL=3]="USER_LOCAL",f[f.USER_REMOTE=4]="USER_REMOTE",f[f.WORKSPACE=5]="WORKSPACE",f[f.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",f[f.DEFAULT=7]="DEFAULT",f[f.MEMORY=8]="MEMORY"})(y=e.ConfigurationTarget||(e.ConfigurationTarget={}));function h(f){switch(f){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=h;function p(f,w){const m=Object.create(null);for(const u in f)I(m,u,f[u],w);return m}e.toValuesTree=p;function I(f,w,m,u){const c=w.split("."),s=c.pop();let r=f;for(let i=0;i<c.length;i++){const n=c[i];let o=r[n];switch(typeof o){case"undefined":o=r[n]=Object.create(null);break;case"object":break;default:u(`Ignoring ${w} as ${c.slice(0,i+1).join(".")} is ${JSON.stringify(o)}`);return}r=o}if(typeof r=="object"&&r!==null)try{r[s]=m}catch{u(`Ignoring ${w} as ${c.join(".")} is ${JSON.stringify(r)}`)}else u(`Ignoring ${w} as ${c.join(".")} is ${JSON.stringify(r)}`)}e.addToValueTree=I;function C(f,w){const m=w.split(".");b(f,m)}e.removeFromValueTree=C;function b(f,w){const m=w.shift();if(w.length===0){delete f[m];return}if(Object.keys(f).indexOf(m)!==-1){const u=f[m];typeof u=="object"&&!Array.isArray(u)&&(b(u,w),Object.keys(u).length===0&&delete f[m])}}function g(f,w,m){function u(r,i){let n=r;for(const o of i){if(typeof n!="object"||n===null)return;n=n[o]}return n}const c=w.split("."),s=u(f,c);return typeof s=="undefined"?m:s}e.getConfigurationValue=g;function d(f,w,m){Object.keys(w).forEach(u=>{u!=="__proto__"&&(u in f?v.isObject(f[u])&&v.isObject(w[u])?d(f[u],w[u],m):m&&(f[u]=w[u]):f[u]=w[u])})}e.merge=d;function E(f,w,m){const u=f.inspect(w),c=f.inspect(m);return typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:u.defaultValue}e.getMigratedSettingValue=E;function S(f){return f.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=S}),define(Z[69],ee([0,1,5]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,v.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,v.createDecorator)("credentialsMainService");class t{constructor(){this.secretVault={}}async getPassword(R,D){return this.secretVault[R]?.[D]??null}async setPassword(R,D,y){this.secretVault[R]=this.secretVault[R]??{},this.secretVault[R][D]=y}async deletePassword(R,D){return this.secretVault[R]?.[D]?(delete this.secretVault[R][D],Object.keys(this.secretVault[R]).length===0&&delete this.secretVault[R],!0):!1}async findPassword(R){return JSON.stringify(this.secretVault[R])??null}async findCredentials(R){const D=[];for(const y of Object.keys(this.secretVault[R]||{}))D.push({account:y,password:this.secretVault[R][y]});return D}async clear(){this.secretVault={}}}e.InMemoryCredentialsProvider=t}),define(Z[84],ee([0,1,5]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,v.createDecorator)(e.ID);function t(R){return!!R.hostName&&!!R.errorMessage}e.isRemoteDiagnosticError=t;class k{async getPerformanceInfo(D,y){return{}}async getSystemInfo(D,y){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(D,y){return""}async getWorkspaceFileExtensions(D){return{extensions:[]}}async reportWorkspaceStats(D){}}e.NullDiagnosticsService=k}),define(Z[102],ee([0,1,5]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,v.createDecorator)("encryptionMainService")}),define(Z[37],ee([0,1,5]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,v.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,v.refineServiceDecorator)(e.IEnvironmentService)}),define(Z[27],ee([0,1,51,9,83,37,183,5]),function(H,e,v,t,k,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,y.refineServiceDecorator)(R.IEnvironmentService);class h extends D.NativeEnvironmentService{get cachedLanguagesPath(){return(0,t.join)(this.userDataPath,"clp")}get backupHome(){return(0,t.join)(this.userDataPath,"Backups")}get backupWorkspacesPath(){return(0,t.join)(this.backupHome,"workspaces.json")}get mainIPCHandle(){return(0,k.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,t.join)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}ve([v.memoize],h.prototype,"cachedLanguagesPath",null),ve([v.memoize],h.prototype,"backupHome",null),ve([v.memoize],h.prototype,"backupWorkspacesPath",null),ve([v.memoize],h.prototype,"mainIPCHandle",null),ve([v.memoize],h.prototype,"mainLockfile",null),ve([v.memoize],h.prototype,"disableUpdates",null),ve([v.memoize],h.prototype,"disableKeytar",null),ve([v.memoize],h.prototype,"codeCachePath",null),ve([v.memoize],h.prototype,"useCodeCache",null),e.EnvironmentMainService=h}),define(Z[190],ee([0,1,154,5]),function(H,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IServerExtensionManagementService=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function k(f){switch(f){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=k;function R(f){switch(f){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=R;function D(f,w){switch(f){case 3:return w==="x64"?"win32-x64":w==="ia32"?"win32-ia32":w==="arm64"?"win32-arm64":"unknown";case 2:return w==="x64"?"linux-x64":w==="arm64"?"linux-arm64":w==="arm"?"linux-armhf":"unknown";case"alpine":return w==="x64"?"alpine-x64":w==="arm64"?"alpine-arm64":"unknown";case 1:return w==="x64"?"darwin-x64":w==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=D;function y(f,w){return w==="web"&&!f.includes("web")}e.isNotWebExtensionInWebTargetPlatform=y;function h(f,w,m){return y(w,m)?!1:f==="undefined"||f==="universal"?!0:f==="unknown"?!1:f===m?!0:p(m).includes(f)}e.isTargetPlatformCompatible=h;function p(f){switch(f){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=p;function I(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=I;var C;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=10]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(C=e.SortBy||(e.SortBy={}));var b;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(b=e.SortOrder||(e.SortOrder={}));var g;(function(f){f.Install="install",f.Uninstall="uninstall"})(g=e.StatisticType||(e.StatisticType={}));var d;(function(f){f[f.None=1]="None",f[f.Install=2]="Install",f[f.Update=3]="Update",f[f.Migrate=4]="Migrate"})(d=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var E;(function(f){f.Unsupported="Unsupported",f.Deprecated="Deprecated",f.Malicious="Malicious",f.Incompatible="Incompatible",f.IncompatiblePreRelease="IncompatiblePreRelease",f.IncompatibleTargetPlatform="IncompatibleTargetPlatform",f.ReleaseVersionNotFound="ReleaseVersionNotFound",f.Invalid="Invalid",f.Download="Download",f.Extract="Extract",f.Delete="Delete",f.Rename="Rename",f.CorruptZip="CorruptZip",f.IncompleteZip="IncompleteZip",f.Internal="Internal"})(E=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class S extends Error{constructor(w,m){super(w);this.code=m,this.name=m}}e.ExtensionManagementError=S,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.IServerExtensionManagementService=(0,t.refineServiceDecorator)(e.IExtensionManagementService),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,v.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,v.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,t.createDecorator)("IExtensionManagementCLIService")}),define(Z[191],ee([0,1,5]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,v.createDecorator)("extensionUrlTrustService")}),define(Z[192],ee([0,1,5]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,v.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(Z[103],ee([0,1,5]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,v.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,v.createDecorator)("externalTerminal")}),define(Z[193],ee([0,1,50,13,9,4,78,23,82,157,103]),function(H,e,v,t,k,R,D,y,h,p,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const C=p.localize(0,null);class b{async getDefaultTerminalForPlatforms(){return{windows:g.getDefaultTerminalWindows(),linux:await E.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class g extends b{openTerminal(u,c){return this.spawnTerminal(v,u,h.getWindowsShell(),c)}spawnTerminal(u,c,s,r){const i=c.windowsExec||g.getDefaultTerminalWindows();r&&r[1]===":"&&(r=r[0].toUpperCase()+r.substr(1));const n=k.basename(i).toLowerCase();if(n==="cmder"||n==="cmder.exe")return u.spawn(i,r?[r]:void 0),Promise.resolve(void 0);const o=["/c","start","/wait"];return i.indexOf(" ")>=0&&o.push('""'),o.push(i),(n==="wt"||n==="wt.exe")&&o.push("-d ."),new Promise((a,l)=>{const P=S(process),M=u.spawn(s,o,{cwd:r,env:P});M.on("error",l),M.on("exit",()=>a())})}runInTerminal(u,c,s,r,i){const n="windowsExec"in i&&i.windowsExec?i.windowsExec:g.getDefaultTerminalWindows();return new Promise((o,a)=>{const l=`"${c} - ${C}"`,P=`""${s.join('" "')}" & pause"`,M=["/c","start",l,"/wait",n,"/c",P],T=Object.assign({},S(process),r);Object.keys(T).filter(Q=>T[Q]===null).forEach(Q=>delete T[Q]);const F={cwd:c,env:T,windowsVerbatimArguments:!0};v.spawn(g.CMD,M,F).on("error",Q=>{a(f(Q))}),o(void 0)})}static getDefaultTerminalWindows(){if(!g._DEFAULT_TERMINAL_WINDOWS){const u=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");g._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${u?"Sysnative":"System32"}\\cmd.exe`}return g._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=g,g.CMD="cmd.exe";class d extends b{openTerminal(u,c){return this.spawnTerminal(v,u,c)}runInTerminal(u,c,s,r,i){const n=i.osxExec||I.DEFAULT_TERMINAL_OSX;return new Promise((o,a)=>{if(n===I.DEFAULT_TERMINAL_OSX||n==="iTerm.app"){const l=n===I.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",M=[t.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${l}.scpt`,H).fsPath,"-t",u||C,"-w",c];for(const U of s)M.push("-a"),M.push(U);if(r){const U=Object.assign({},S(process),r);for(const Q in U){const re=U[Q];re===null?(M.push("-u"),M.push(Q)):(M.push("-e"),M.push(`${Q}=${re}`))}}let T="";const F=v.spawn(d.OSASCRIPT,M);F.on("error",U=>{a(f(U))}),F.stderr.on("data",U=>{T+=U.toString()}),F.on("exit",U=>{if(U===0)o(void 0);else if(T){const Q=T.split(`
`,1);a(new Error(Q[0]))}else a(new Error(p.localize(1,null,l,U)))})}else a(new Error(p.localize(2,null,n)))})}spawnTerminal(u,c,s){const r=c.osxExec||I.DEFAULT_TERMINAL_OSX;return new Promise((i,n)=>{const o=["-a",r];s&&o.push(s);const a=S(process),l=u.spawn("/usr/bin/open",o,{cwd:s,env:a});l.on("error",n),l.on("exit",()=>i())})}}e.MacExternalTerminalService=d,d.OSASCRIPT="/usr/bin/osascript";class E extends b{openTerminal(u,c){return this.spawnTerminal(v,u,c)}runInTerminal(u,c,s,r,i){const n=i.linuxExec?Promise.resolve(i.linuxExec):E.getDefaultTerminalLinuxReady();return new Promise((o,a)=>{const l=[];n.then(P=>{P.indexOf("gnome-terminal")>=0?l.push("-x"):l.push("-e"),l.push("bash"),l.push("-c");const M=`${w(s)}; echo; read -p "${E.WAIT_MESSAGE}" -n1;`;l.push(`''${M}''`);const T=Object.assign({},S(process),r);Object.keys(T).filter(re=>T[re]===null).forEach(re=>delete T[re]);const F={cwd:c,env:T};let U="";const Q=v.spawn(P,l,F);Q.on("error",re=>{a(f(re))}),Q.stderr.on("data",re=>{U+=re.toString()}),Q.on("exit",re=>{if(re===0)o(void 0);else if(U){const ue=U.split(`
`,1);a(new Error(ue[0]))}else a(new Error(p.localize(4,null,P,re)))})})})}static async getDefaultTerminalLinuxReady(){if(!E._DEFAULT_TERMINAL_LINUX_READY)if(!R.isLinux)E._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const u=await y.Promises.exists("/etc/debian_version");E._DEFAULT_TERMINAL_LINUX_READY=new Promise(c=>{u?c("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?c("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?c("konsole"):process.env.COLORTERM?c(process.env.COLORTERM):process.env.TERM?c(process.env.TERM):c("xterm")})}return E._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(u,c,s){const r=c.linuxExec?Promise.resolve(c.linuxExec):E.getDefaultTerminalLinuxReady();return new Promise((i,n)=>{r.then(o=>{const a=S(process),l=u.spawn(o,[],{cwd:s,env:a});l.on("error",n),l.on("exit",()=>i())})})}}e.LinuxExternalTerminalService=E,E.WAIT_MESSAGE=p.localize(3,null);function S(m){const u={...m.env};return(0,D.sanitizeProcessEnvironment)(u),u}function f(m){return"errno"in m&&m.errno==="ENOENT"&&"path"in m&&typeof m.path=="string"?new Error(p.localize(5,null,m.path)):m}function w(m){let u="";for(const c of m)c.indexOf(" ")>=0?u+='"'+c+'"':u+=c,u+=" ";return u}}),define(Z[14],ee([0,1,32,9,26,12,7,159,5]),function(H,e,v,t,k,R,D,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,h.createDecorator)("fileService");function p(N){return N.create===!0}e.isFileOpenForWriteOptions=p;var I;(function(N){N[N.Unknown=0]="Unknown",N[N.File=1]="File",N[N.Directory=2]="Directory",N[N.SymbolicLink=64]="SymbolicLink"})(I=e.FileType||(e.FileType={}));var C;(function(N){N[N.Readonly=1]="Readonly"})(C=e.FilePermission||(e.FilePermission={}));var b;(function(N){N[N.FileReadWrite=2]="FileReadWrite",N[N.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",N[N.FileReadStream=16]="FileReadStream",N[N.FileFolderCopy=8]="FileFolderCopy",N[N.PathCaseSensitive=1024]="PathCaseSensitive",N[N.Readonly=2048]="Readonly",N[N.Trash=4096]="Trash",N[N.FileWriteUnlock=8192]="FileWriteUnlock",N[N.FileAtomicRead=16384]="FileAtomicRead",N[N.FileClone=32768]="FileClone"})(b=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function g(N){return!!(N.capabilities&2)}e.hasReadWriteCapability=g;function d(N){return!!(N.capabilities&8)}e.hasFileFolderCopyCapability=d;function E(N){return!!(N.capabilities&32768)}e.hasFileCloneCapability=E;function S(N){return!!(N.capabilities&4)}e.hasOpenReadWriteCloseCapability=S;function f(N){return!!(N.capabilities&16)}e.hasFileReadStreamCapability=f;function w(N){return!!(N.capabilities&2048)}e.hasFileReadCapability=w;function m(N){return g(N)?!!(N.capabilities&16384):!1}e.hasFileAtomicReadCapability=m;var u;(function(N){N.FileExists="EntryExists",N.FileNotFound="EntryNotFound",N.FileNotADirectory="EntryNotADirectory",N.FileIsADirectory="EntryIsADirectory",N.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",N.FileTooLarge="EntryTooLarge",N.FileWriteLocked="EntryWriteLocked",N.NoPermissions="NoPermissions",N.Unavailable="Unavailable",N.Unknown="Unknown"})(u=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class c extends Error{constructor(_,A){super(_);this.code=A}}e.FileSystemProviderError=c;function s(N,_){const A=new c(N.toString(),_);return i(A,_),A}e.createFileSystemProviderError=s;function r(N){return N||s((0,y.localize)(0,null),u.Unknown)}e.ensureFileSystemProviderError=r;function i(N,_){return N.name=_?`${_} (FileSystemError)`:"FileSystemError",N}e.markAsFileSystemProviderError=i;function n(N){if(!N)return u.Unknown;if(N instanceof c)return N.code;const _=/^(.+) \(FileSystemError\)$/.exec(N.name);if(!_)return u.Unknown;switch(_[1]){case u.FileExists:return u.FileExists;case u.FileIsADirectory:return u.FileIsADirectory;case u.FileNotADirectory:return u.FileNotADirectory;case u.FileNotFound:return u.FileNotFound;case u.FileExceedsMemoryLimit:return u.FileExceedsMemoryLimit;case u.FileTooLarge:return u.FileTooLarge;case u.FileWriteLocked:return u.FileWriteLocked;case u.NoPermissions:return u.NoPermissions;case u.Unavailable:return u.Unavailable}return u.Unknown}e.toFileSystemProviderErrorCode=n;function o(N){if(N instanceof F)return N.fileOperationResult;switch(n(N)){case u.FileNotFound:return 1;case u.FileIsADirectory:return 0;case u.FileNotADirectory:return 10;case u.FileWriteLocked:return 5;case u.NoPermissions:return 6;case u.FileExists:return 4;case u.FileExceedsMemoryLimit:return 9;case u.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=o;var a;(function(N){N[N.CREATE=0]="CREATE",N[N.DELETE=1]="DELETE",N[N.MOVE=2]="MOVE",N[N.COPY=3]="COPY",N[N.WRITE=4]="WRITE"})(a=e.FileOperation||(e.FileOperation={}));class l{constructor(_,A,W){this.resource=_,this.operation=A,this.target=W}isOperation(_){return this.operation===_}}e.FileOperationEvent=l;var P;(function(N){N[N.UPDATED=0]="UPDATED",N[N.ADDED=1]="ADDED",N[N.DELETED=2]="DELETED"})(P=e.FileChangeType||(e.FileChangeType={}));class M{constructor(_,A){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=_;const W=new Map;for(const $ of _){const Y=W.get($.type);switch(Y?Y.push([$.resource,$]):W.set($.type,[[$.resource,$]]),$.type){case 1:this.rawAdded.push($.resource);break;case 0:this.rawUpdated.push($.resource);break;case 2:this.rawDeleted.push($.resource);break}}for(const[$,Y]of W)switch($){case 1:this.added=v.TernarySearchTree.forUris(()=>A),this.added.fill(Y);break;case 0:this.updated=v.TernarySearchTree.forUris(()=>A),this.updated.fill(Y);break;case 2:this.deleted=v.TernarySearchTree.forUris(()=>A),this.deleted.fill(Y);break}}contains(_,...A){return this.doContains(_,{includeChildren:!1},...A)}affects(_,...A){return this.doContains(_,{includeChildren:!0},...A)}doContains(_,A,...W){if(!_)return!1;const $=W.length>0;return!!((!$||W.includes(1))&&(this.added?.get(_)||A.includeChildren&&this.added?.findSuperstr(_))||(!$||W.includes(0))&&(this.updated?.get(_)||A.includeChildren&&this.updated?.findSuperstr(_))||(!$||W.includes(2))&&(this.deleted?.findSubstr(_)||A.includeChildren&&this.deleted?.findSuperstr(_)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=M;function T(N,_,A){return!N||!_||N===_||_.length>N.length?!1:(_.charAt(_.length-1)!==t.sep&&(_+=t.sep),A?(0,k.startsWithIgnoreCase)(N,_):N.indexOf(_)===0)}e.isParent=T;class F extends Error{constructor(_,A,W){super(_);this.fileOperationResult=A,this.options=W}}e.FileOperationError=F;class U extends F{constructor(_,A,W){super(_,2,W);this.stat=A}}e.NotModifiedSinceFileOperationError=U;var Q;(function(N){N[N.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",N[N.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",N[N.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",N[N.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",N[N.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",N[N.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",N[N.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",N[N.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",N[N.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",N[N.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",N[N.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",N[N.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(Q=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var re;(function(N){N[N.FILE=0]="FILE",N[N.FOLDER=1]="FOLDER",N[N.ROOT_FOLDER=2]="ROOT_FOLDER"})(re=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function ue(N){if(!(typeof N.size!="number"||typeof N.mtime!="number"))return N.mtime.toString(29)+N.size.toString(31)}e.etag=ue;async function fe(N,_){if(!_.hasProvider(D.URI.from({scheme:N.scheme})))return new Promise(A=>{const W=_.onDidChangeFileSystemProviderRegistrations($=>{$.scheme===N.scheme&&$.added&&(W.dispose(),A())})})}e.whenProviderRegistered=fe,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class se{static formatSize(_){return(0,R.isNumber)(_)||(_=0),_<se.KB?(0,y.localize)(1,null,_.toFixed(0)):_<se.MB?(0,y.localize)(2,null,(_/se.KB).toFixed(2)):_<se.GB?(0,y.localize)(3,null,(_/se.MB).toFixed(2)):_<se.TB?(0,y.localize)(4,null,(_/se.GB).toFixed(2)):(0,y.localize)(5,null,(_/se.TB).toFixed(2))}}e.ByteSize=se,se.KB=1024,se.MB=se.KB*se.KB,se.GB=se.MB*se.KB,se.TB=se.GB*se.KB;var le;(function(N){N[N.IA32=0]="IA32",N[N.OTHER=1]="OTHER"})(le=e.Arch||(e.Arch={}));function K(N){return{maxFileSize:N===0?300*se.MB:16*se.GB,maxHeapSize:N===0?700*se.MB:2*700*se.MB}}e.getPlatformLimits=K}),define(Z[194],ee([0,1,17,43,18,3,2,56,7,28,14]),function(H,e,v,t,k,R,D,y,h,p,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class C extends D.Disposable{constructor(g,d){super();this.channel=g,this.extraCapabilities=d,this.onDidChangeCapabilities=R.Event.None,this._onDidChange=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new R.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,p.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384|32768,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(g){return this.channel.call("stat",[g])}readdir(g){return this.channel.call("readdir",[g])}async readFile(g,d){const{buffer:E}=await this.channel.call("readFile",[g,d]);return E}readFileStream(g,d,E){const S=(0,y.newWriteableStream)(w=>v.VSBuffer.concat(w.map(m=>v.VSBuffer.wrap(m))).buffer),f=this.channel.listen("readFileStream",[g,d])(w=>{if(w instanceof v.VSBuffer)S.write(w.buffer);else{if(w==="end")S.end();else{let m=w;m instanceof Error||(m=(0,I.createFileSystemProviderError)((0,t.toErrorMessage)(m),I.FileSystemProviderErrorCode.Unknown)),S.error(m),S.end()}f.dispose()}});return E.onCancellationRequested(()=>{S.error((0,k.canceled)()),S.end(),f.dispose()}),S}writeFile(g,d,E){return this.channel.call("writeFile",[g,v.VSBuffer.wrap(d),E])}open(g,d){return this.channel.call("open",[g,d])}close(g){return this.channel.call("close",[g])}async read(g,d,E,S,f){const[w,m]=await this.channel.call("read",[g,d,f]);return E.set(w.buffer.slice(0,m),S),m}write(g,d,E,S,f){return this.channel.call("write",[g,d,v.VSBuffer.wrap(E),S,f])}mkdir(g){return this.channel.call("mkdir",[g])}delete(g,d){return this.channel.call("delete",[g,d])}rename(g,d,E){return this.channel.call("rename",[g,d,E])}copy(g,d,E){return this.channel.call("copy",[g,d,E])}cloneFile(g,d){return this.channel.call("cloneFile",[g,d])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(g=>{if(Array.isArray(g)){const d=g;this._onDidChange.fire(d.map(E=>({resource:h.URI.revive(E.resource),type:E.type})))}else{const d=g;this._onDidWatchError.fire(d)}}))}watch(g,d){const E=(0,p.generateUuid)();return this.channel.call("watch",[this.sessionId,E,g,d]),(0,D.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,E]))}}e.DiskFileSystemProviderClient=C}),define(Z[104],ee([0,1,17,18,160,14]),function(H,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function D(I,C,b,g,d,E){let S;try{await y(I,C,b,g,d,E)}catch(f){S=f}finally{S&&d.errorTransformer&&(S=d.errorTransformer(S)),typeof S!="undefined"&&b.error(S),b.end()}}e.readFileIntoStream=D;async function y(I,C,b,g,d,E){h(E);const S=await I.open(C,{create:!1});try{h(E);let f=0,w=0,m=d&&typeof d.length=="number"?d.length:void 0,u=v.VSBuffer.alloc(Math.min(d.bufferSize,typeof m=="number"?m:d.bufferSize)),c=d&&typeof d.position=="number"?d.position:0,s=0;do w=await I.read(S,c,u.buffer,s,u.byteLength-s),c+=w,s+=w,f+=w,typeof m=="number"&&(m-=w),s===u.byteLength&&(await b.write(g(u)),u=v.VSBuffer.alloc(Math.min(d.bufferSize,typeof m=="number"?m:d.bufferSize)),s=0);while(w>0&&(typeof m!="number"||m>0)&&h(E)&&p(f,d));if(s>0){let r=s;typeof m=="number"&&(r=Math.min(s,m)),b.write(g(u.slice(0,r)))}}catch(f){throw(0,R.ensureFileSystemProviderError)(f)}finally{await I.close(S)}}function h(I){if(I.isCancellationRequested)throw(0,t.canceled)();return!0}function p(I,C){if(C?.limits){if(typeof C.limits.memory=="number"&&I>C.limits.memory)throw(0,R.createFileSystemProviderError)((0,k.localize)(0,null),R.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof C.limits.size=="number"&&I>C.limits.size)throw(0,R.createFileSystemProviderError)((0,k.localize)(1,null),R.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Z[70],ee([0,1,95,2,9,4,7,14]),function(H,e,v,t,k,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function h(f){return f.recursive===!0}e.isRecursiveWatchRequest=h;class p extends t.Disposable{constructor(w,m,u,c){super();this.onFileChanges=w,this.onLogMessage=m,this.verboseLogging=u,this.options=c,this.watcherDisposables=this._register(new t.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const w=new t.DisposableStore;this.watcherDisposables.value=w,this.watcher=this.createWatcher(w),this.watcher.setVerboseLogging(this.verboseLogging),w.add(this.watcher.onDidChangeFile(m=>this.onFileChanges(m))),w.add(this.watcher.onDidLogMessage(m=>this.onLogMessage(m))),w.add(this.watcher.onDidError(m=>this.onError(m)))}onError(w){this.options.restartOnError?this.restartCounter<p.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${w}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${w}`):this.error(w)}restart(w){this.restartCounter++,this.init(),this.watch(w)}async watch(w){this.requests=w,await this.watcher?.watch(w)}async setVerboseLogging(w){this.verboseLogging=w,await this.watcher?.setVerboseLogging(w)}error(w){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${w}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=p,p.MAX_RESTARTS=5;class I extends p{constructor(w,m,u){super(w,m,u,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=I;class C extends p{constructor(w,m,u){super(w,m,u,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=C;function b(f){return f.map(w=>({type:w.type,resource:D.URI.file(w.path)}))}e.toFileChanges=b;function g(f){const w=new S;for(const m of f)w.processEvent(m);return w.coalesce()}e.coalesceEvents=g;function d(f,w){return typeof w=="string"&&!w.startsWith(v.GLOBSTAR)&&!(0,k.isAbsolute)(w)?{base:f,pattern:w}:w}e.normalizeWatcherPattern=d;function E(f,w){const m=[];for(const u of w)m.push((0,v.parse)(d(f,u)));return m}e.parseWatcherPatterns=E;class S{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(w){return R.isLinux?w.path:w.path.toLowerCase()}processEvent(w){const m=this.mapPathToChange.get(this.toKey(w));let u=!1;if(m){const c=m.type,s=w.type;m.path!==w.path&&(w.type===2||w.type===1)?u=!0:c===1&&s===2?(this.mapPathToChange.delete(this.toKey(w)),this.coalesced.delete(m)):c===2&&s===1?m.type=0:c===1&&s===0||(m.type=s)}else u=!0;u&&(this.coalesced.add(w),this.mapPathToChange.set(this.toKey(w),w))}coalesce(){const w=[],m=[];return Array.from(this.coalesced).filter(u=>u.type!==2?(w.push(u),!1):!0).sort((u,c)=>u.path.length-c.path.length).filter(u=>m.some(c=>(0,y.isParent)(u.path,c,!R.isLinux))?!1:(m.push(u.path),!0)).concat(w)}}}),define(Z[195],ee([0,1,29,8,21,31,2,80,9,4,96,23,70]),function(H,e,v,t,k,R,D,y,h,p,I,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class g extends D.Disposable{constructor(S,f,w,m){super();this.request=S,this.onDidFilesChange=f,this.onLogMessage=w,this.verboseLogging=m,this.throttledFileChangesWorker=new t.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},u=>this.onDidFilesChange(u)),this.fileChangesDelayer=this._register(new t.ThrottledDelayer(g.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=(0,b.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,b.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new k.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const S=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const f=await C.Promises.stat(S);this._register(await this.doWatch(S,f.isDirectory()))}catch(S){S.code!=="ENOENT"?this.error(S):this.trace(S)}}async normalizePath(S){let f=S.path;try{f=await C.Promises.realpath(S.path),S.path===f&&(f=await(0,I.realcase)(S.path)??S.path),S.path!==f&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${S.path}, real: ${f})`)}catch{}return f}async doWatch(S,f){if(p.isMacintosh&&(0,R.isEqualOrParent)(S,"/Volumes/",!0))return this.error(`Refusing to watch ${S} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),D.Disposable.None;const w=new k.CancellationTokenSource(this.cts.token),m=new D.DisposableStore;try{const u=(0,h.basename)(S),c=(0,v.watch)(S);m.add((0,D.toDisposable)(()=>{c.removeAllListeners(),c.close()})),this.trace(`Started watching: '${S}'`);const s=new Set;if(f)try{for(const i of await C.Promises.readdir(S))s.add(i)}catch(i){this.error(i)}const r=new Map;m.add((0,D.toDisposable)(()=>{for(const[,i]of r)i.dispose();r.clear()})),c.on("error",(i,n)=>{this.error(`Failed to watch ${S} for changes using fs.watch() (${i}, ${n})`),this.dispose()}),c.on("change",(i,n)=>{if(w.token.isCancellationRequested)return;this.trace(`[raw] ["${i}"] ${n}`);let o="";if(n&&(o=n.toString(),p.isMacintosh&&(o=(0,y.normalizeNFC)(o))),!(!o||i!=="change"&&i!=="rename"))if(f)if(i==="rename"){r.get(o)?.dispose();const a=setTimeout(async()=>{if(r.delete(o),o===u&&!await C.Promises.exists(S)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const l=await this.existsChildStrictCase((0,h.join)(S,o));if(w.token.isCancellationRequested)return;let P;l?s.has(o)?P=0:(P=1,s.add(o)):(s.delete(o),P=2),this.onFileChange({path:(0,h.join)(this.request.path,o),type:P})},g.FILE_DELETE_HANDLER_DELAY);r.set(o,(0,D.toDisposable)(()=>clearTimeout(a)))}else{let a;s.has(o)?a=0:(a=1,s.add(o)),this.onFileChange({path:(0,h.join)(this.request.path,o),type:a})}else if(i==="rename"||o!==u){const a=setTimeout(async()=>{const l=await C.Promises.exists(S);w.token.isCancellationRequested||(l?(this.onFileChange({path:this.request.path,type:0},!0),m.add(await this.doWatch(S,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},g.FILE_DELETE_HANDLER_DELAY);m.clear(),m.add((0,D.toDisposable)(()=>clearTimeout(a)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(u){await C.Promises.exists(S)&&!w.token.isCancellationRequested&&this.error(`Failed to watch ${S} for changes using fs.watch() (${u.toString()})`)}return(0,D.toDisposable)(()=>{w.dispose(!0),m.dispose()})}async onFileChange(S,f=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${S.type===1?"[ADDED]":S.type===2?"[DELETED]":"[CHANGED]"} ${S.path}`),!f&&this.excludes.some(w=>w(S.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${S.path}`):!f&&this.includes&&this.includes.length>0&&!this.includes.some(w=>w(S.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${S.path}`):this.fileChangesBuffer.push(S);try{await this.fileChangesDelayer.trigger(async()=>{const w=this.fileChangesBuffer;this.fileChangesBuffer=[];const m=(0,b.coalesceEvents)(w);if(m.length>0){if(this.verboseLogging)for(const c of m)this.trace(`>> normalized ${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.path}`);this.throttledFileChangesWorker.work(m)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${m[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${m.length}, most recent change: ${m[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(S){if(p.isLinux)return C.Promises.exists(S);try{const f=(0,h.basename)(S);return(await C.Promises.readdir((0,h.dirname)(S))).some(m=>m===f)}catch(f){return this.trace(f),!1}}setVerboseLogging(S){this.verboseLogging=S}error(S){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${S}`})}warn(S){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${S}`})}trace(S){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${S}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=g,g.FILE_DELETE_HANDLER_DELAY=100,g.FILE_CHANGES_HANDLER_DELAY=50;async function d(E,S,f,w,m=512){const u=await C.Promises.open(E,"r"),c=Buffer.allocUnsafe(m),s=new k.CancellationTokenSource(w);let r,i=!1;const n={path:E,excludes:[],recursive:!1},o=new g(n,a=>{(async()=>{for(const{type:l}of a)if(l===0){if(i)return;i=!0;try{for(;!s.token.isCancellationRequested;){const{bytesRead:P}=await C.Promises.read(u,c,0,m,null);if(!P||s.token.isCancellationRequested)break;S(c.slice(0,P))}}catch(P){r=new Error(P),s.dispose(!0)}finally{i=!1}}})()});return await o.ready,f(),new Promise((a,l)=>{s.token.onCancellationRequested(async()=>{o.dispose();try{await C.Promises.close(u)}catch(P){r=new Error(P)}r?l(r):a()})})}e.watchFileContents=d}),define(Z[196],ee([0,1,3,95,2,4,195]),function(H,e,v,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class y extends k.Disposable{constructor(){super(...arguments);this._onDidChangeFile=this._register(new v.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new v.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=v.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(p){const I=this.normalizeRequests(p),C=I.filter(g=>{const d=this.watchers.get(g.path);return d?!(0,t.patternsEquals)(d.request.excludes,g.excludes)||!(0,t.patternsEquals)(d.request.includes,g.includes):!0}),b=Array.from(this.watchers.values()).filter(({request:g})=>!I.find(d=>d.path===g.path&&(0,t.patternsEquals)(d.excludes,g.excludes)&&(0,t.patternsEquals)(d.includes,g.includes))).map(({request:g})=>g.path);C.length&&this.trace(`Request to start watching: ${C.map(g=>`${g.path} (excludes: ${g.excludes.length>0?g.excludes:"<none>"}, includes: ${g.includes&&g.includes.length>0?JSON.stringify(g.includes):"<all>"})`).join(",")}`),b.length&&this.trace(`Request to stop watching: ${b.join(",")}`);for(const g of b)this.stopWatching(g);for(const g of C)this.startWatching(g)}startWatching(p){const I=new D.NodeJSFileWatcherLibrary(p,b=>this._onDidChangeFile.fire(b),b=>this._onDidLogMessage.fire(b),this.verboseLogging),C={request:p,instance:I};this.watchers.set(p.path,C)}async stop(){for(const[p]of this.watchers)this.stopWatching(p);this.watchers.clear()}stopWatching(p){const I=this.watchers.get(p);I&&(this.watchers.delete(p),I.instance.dispose())}normalizeRequests(p){const I=new Map;for(const C of p){const b=R.isLinux?C.path:C.path.toLowerCase();I.set(b,C)}return Array.from(I.values())}async setVerboseLogging(p){this.verboseLogging=p;for(const[,I]of this.watchers)I.instance.setVerboseLogging(p)}trace(p){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(p)})}toMessage(p,I){return I?`[File Watcher (node.js)] ${p} (path: ${I.request.path})`:`[File Watcher (node.js)] ${p}`}}e.NodeJSWatcher=y}),define(Z[197],ee([0,1,70,196]),function(H,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class k extends v.AbstractNonRecursiveWatcherClient{constructor(D,y,h){super(D,y,h);this.init()}createWatcher(){return new t.NodeJSWatcher}}e.NodeJSWatcherClient=k}),define(Z[198],ee([0,1,13,44,147,70]),function(H,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class D extends R.AbstractUniversalWatcherClient{constructor(h,p,I){super(h,p,I);this.init()}createWatcher(h){const p=h.add(new k.Client(v.FileAccess.asFileUri("bootstrap-fork",H).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return h.add(p.onDidProcessExit(({code:I,signal:C})=>this.onError(`terminated by itself with code ${I}, signal: ${C}`))),t.ProxyChannel.toService((0,t.getNextTickChannel)(p.getChannel("watcher")))}}e.UniversalWatcherClient=D}),define(Z[85],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class v{constructor(...k){this._entries=new Map;for(const[R,D]of k)this.set(R,D)}set(k,R){const D=this._entries.get(k);return this._entries.set(k,R),D}has(k){return this._entries.has(k)}get(k){return this._entries.get(k)}}e.ServiceCollection=v}),define(Z[199],ee([0,1,8,18,68,189,5,85]),function(H,e,v,t,k,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const h=!1;class p extends Error{constructor(d){super("cyclic dependency between services");this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class I{constructor(d=new y.ServiceCollection,E=!1,S){this._activeInstantiations=new Set,this._services=d,this._strict=E,this._parent=S,this._services.set(D.IInstantiationService,this)}createChild(d){return new I(d,this._strict,this)}invokeFunction(d,...E){const S=b.traceInvocation(d);let f=!1;try{return d({get:m=>{if(f)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const u=this._getOrCreateServiceInstance(m,S);if(!u)throw new Error(`[invokeFunction] unknown service '${m}'`);return u}},...E)}finally{f=!0,S.stop()}}createInstance(d,...E){let S,f;return d instanceof k.SyncDescriptor?(S=b.traceCreation(d.ctor),f=this._createInstance(d.ctor,d.staticArguments.concat(E),S)):(S=b.traceCreation(d),f=this._createInstance(d,E,S)),S.stop(),f}_createInstance(d,E=[],S){const f=D._util.getServiceDependencies(d).sort((u,c)=>u.index-c.index),w=[];for(const u of f){const c=this._getOrCreateServiceInstance(u.id,S);c||this._throwIfStrict(`[createInstance] ${d.name} depends on UNKNOWN service ${u.id}.`,!1),w.push(c)}const m=f.length>0?f[0].index:E.length;if(E.length!==m){console.trace(`[createInstance] First service dependency of ${d.name} at position ${m+1} conflicts with ${E.length} static arguments`);const u=m-E.length;u>0?E=E.concat(new Array(u)):E=E.slice(0,m)}return new d(...[...E,...w])}_setServiceInstance(d,E){if(this._services.get(d)instanceof k.SyncDescriptor)this._services.set(d,E);else if(this._parent)this._parent._setServiceInstance(d,E);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(d){const E=this._services.get(d);return!E&&this._parent?this._parent._getServiceInstanceOrDescriptor(d):E}_getOrCreateServiceInstance(d,E){const S=this._getServiceInstanceOrDescriptor(d);return S instanceof k.SyncDescriptor?this._safeCreateAndCacheServiceInstance(d,S,E.branch(d,!0)):(E.branch(d,!1),S)}_safeCreateAndCacheServiceInstance(d,E,S){if(this._activeInstantiations.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this._activeInstantiations.add(d);try{return this._createAndCacheServiceInstance(d,E,S)}finally{this._activeInstantiations.delete(d)}}_createAndCacheServiceInstance(d,E,S){const f=new R.Graph(u=>u.id.toString());let w=0;const m=[{id:d,desc:E,_trace:S}];for(;m.length;){const u=m.pop();if(f.lookupOrInsertNode(u),w++>1e3)throw new p(f);for(const c of D._util.getServiceDependencies(u.desc.ctor)){const s=this._getServiceInstanceOrDescriptor(c.id);if(s||this._throwIfStrict(`[createInstance] ${d} depends on ${c.id} which is NOT registered.`,!0),s instanceof k.SyncDescriptor){const r={id:c.id,desc:s,_trace:u._trace.branch(c.id,!0)};f.insertEdge(u,r),m.push(r)}}}for(;;){const u=f.roots();if(u.length===0){if(!f.isEmpty())throw new p(f);break}for(const{data:c}of u){if(this._getServiceInstanceOrDescriptor(c.id)instanceof k.SyncDescriptor){const r=this._createServiceInstanceWithOwner(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this._setServiceInstance(c.id,r)}f.removeNode(c)}}return this._getServiceInstanceOrDescriptor(d)}_createServiceInstanceWithOwner(d,E,S=[],f,w){if(this._services.get(d)instanceof k.SyncDescriptor)return this._createServiceInstance(E,S,f,w);if(this._parent)return this._parent._createServiceInstanceWithOwner(d,E,S,f,w);throw new Error(`illegalState - creating UNKNOWN service instance ${E.name}`)}_createServiceInstance(d,E=[],S,f){if(S){const w=new v.IdleValue(()=>this._createInstance(d,E,f));return new Proxy(Object.create(null),{get(m,u){if(u in m)return m[u];const c=w.value;let s=c[u];return typeof s!="function"||(s=s.bind(c),m[u]=s),s},set(m,u,c){return w.value[u]=c,!0}})}else return this._createInstance(d,E,f)}_throwIfStrict(d,E){if(E&&console.warn(d),this._strict)throw new Error(d)}}e.InstantiationService=I;var C;(function(g){g[g.Creation=0]="Creation",g[g.Invocation=1]="Invocation",g[g.Branch=2]="Branch"})(C||(C={}));class b{constructor(d,E){this.type=d,this.name=E,this._start=Date.now(),this._dep=[]}static traceInvocation(d){return h?new b(1,d.name||d.toString().substring(0,42).replace(/\n/g,"")):b._None}static traceCreation(d){return h?new b(0,d.name):b._None}branch(d,E){const S=new b(2,d.toString());return this._dep.push([d,E,S]),S}stop(){const d=Date.now()-this._start;b._totals+=d;let E=!1;function S(w,m){const u=[],c=new Array(w+1).join("	");for(const[s,r,i]of m._dep)if(r&&i){E=!0,u.push(`${c}CREATES -> ${s}`);const n=S(w+1,i);n&&u.push(n)}else u.push(`${c}uses -> ${s}`);return u.join(`
`)}const f=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${S(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${b._totals.toFixed(2)}ms)`];(d>2||E)&&console.log(f.join(`
`))}}e.Trace=b,b._None=new class extends b{constructor(){super(-1,null)}stop(){}branch(){return this}},b._totals=0}),define(Z[6],ee([0,1,43,3,2,4,5]),function(H,e,v,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,D.createDecorator)("logService"),e.ILoggerService=(0,D.createDecorator)("loggerService");function y(){return new Date().toISOString()}var h;(function(r){r[r.Trace=0]="Trace",r[r.Debug=1]="Debug",r[r.Info=2]="Info",r[r.Warning=3]="Warning",r[r.Error=4]="Error",r[r.Critical=5]="Critical",r[r.Off=6]="Off"})(h=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=h.Info;function p(r,i,n){switch(i){case h.Trace:r.trace(n);break;case h.Debug:r.debug(n);break;case h.Info:r.info(n);break;case h.Warning:r.warn(n);break;case h.Error:r.error(n);break;case h.Critical:r.critical(n);break;default:throw new Error("Invalid log level")}}e.log=p;function I(r){let i="";for(let n=0;n<r.length;n++){let o=r[n];if(typeof o=="object")try{o=JSON.stringify(o)}catch{}i+=(n>0?" ":"")+o}return i}e.format=I;class C extends k.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=C;class b extends C{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...n){this.checkLogLevel(h.Trace)&&this.log(h.Trace,I([i,...n]))}debug(i,...n){this.checkLogLevel(h.Debug)&&this.log(h.Debug,I([i,...n]))}info(i,...n){this.checkLogLevel(h.Info)&&this.log(h.Info,I([i,...n]))}warn(i,...n){this.checkLogLevel(h.Warning)&&this.log(h.Warning,I([i,...n]))}error(i,...n){if(this.checkLogLevel(h.Error))if(i instanceof Error){const o=Array.prototype.slice.call(arguments);o[0]=i.stack,this.log(h.Error,I(o))}else this.log(h.Error,I([i,...n]))}critical(i,...n){this.checkLogLevel(h.Critical)&&this.log(h.Critical,I([i,...n]))}flush(){}}e.AbstractMessageLogger=b;class g extends C{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!R.isWindows}trace(i,...n){this.getLevel()<=h.Trace&&(this.useColors?console.log(`[90m[main ${y()}][0m`,i,...n):console.log(`[main ${y()}]`,i,...n))}debug(i,...n){this.getLevel()<=h.Debug&&(this.useColors?console.log(`[90m[main ${y()}][0m`,i,...n):console.log(`[main ${y()}]`,i,...n))}info(i,...n){this.getLevel()<=h.Info&&(this.useColors?console.log(`[90m[main ${y()}][0m`,i,...n):console.log(`[main ${y()}]`,i,...n))}warn(i,...n){this.getLevel()<=h.Warning&&(this.useColors?console.warn(`[93m[main ${y()}][0m`,i,...n):console.warn(`[main ${y()}]`,i,...n))}error(i,...n){this.getLevel()<=h.Error&&(this.useColors?console.error(`[91m[main ${y()}][0m`,i,...n):console.error(`[main ${y()}]`,i,...n))}critical(i,...n){this.getLevel()<=h.Critical&&(this.useColors?console.error(`[90m[main ${y()}][0m`,i,...n):console.error(`[main ${y()}]`,i,...n))}dispose(){}flush(){}}e.ConsoleMainLogger=g;class d extends C{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...n){this.getLevel()<=h.Trace&&console.log("%cTRACE","color: #888",i,...n)}debug(i,...n){this.getLevel()<=h.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...n)}info(i,...n){this.getLevel()<=h.Info&&console.log("%c INFO","color: #33f",i,...n)}warn(i,...n){this.getLevel()<=h.Warning&&console.log("%c WARN","color: #993",i,...n)}error(i,...n){this.getLevel()<=h.Error&&console.log("%c  ERR","color: #f33",i,...n)}critical(i,...n){this.getLevel()<=h.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...n)}dispose(){}flush(){}}e.ConsoleLogger=d;class E extends C{constructor(i,n=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(n)}trace(i,...n){this.getLevel()<=h.Trace&&this.adapter.log(h.Trace,[this.extractMessage(i),...n])}debug(i,...n){this.getLevel()<=h.Debug&&this.adapter.log(h.Debug,[this.extractMessage(i),...n])}info(i,...n){this.getLevel()<=h.Info&&this.adapter.log(h.Info,[this.extractMessage(i),...n])}warn(i,...n){this.getLevel()<=h.Warning&&this.adapter.log(h.Warning,[this.extractMessage(i),...n])}error(i,...n){this.getLevel()<=h.Error&&this.adapter.log(h.Error,[this.extractMessage(i),...n])}critical(i,...n){this.getLevel()<=h.Critical&&this.adapter.log(h.Critical,[this.extractMessage(i),...n])}extractMessage(i){return typeof i=="string"?i:(0,v.toErrorMessage)(i,this.getLevel()<=h.Trace)}dispose(){}flush(){}}e.AdapterLogger=E;class S extends C{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const n of this.logServices)n.setLevel(i);super.setLevel(i)}trace(i,...n){for(const o of this.logServices)o.trace(i,...n)}debug(i,...n){for(const o of this.logServices)o.debug(i,...n)}info(i,...n){for(const o of this.logServices)o.info(i,...n)}warn(i,...n){for(const o of this.logServices)o.warn(i,...n)}error(i,...n){for(const o of this.logServices)o.error(i,...n)}critical(i,...n){for(const o of this.logServices)o.critical(i,...n)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=S;class f extends k.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...n){this.logger.trace(i,...n)}debug(i,...n){this.logger.debug(i,...n)}info(i,...n){this.logger.info(i,...n)}warn(i,...n){this.logger.warn(i,...n)}error(i,...n){this.logger.error(i,...n)}critical(i,...n){this.logger.critical(i,...n)}flush(){this.logger.flush()}}e.LogService=f;class w extends k.Disposable{constructor(i,n){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(o=>{this.logLevel=o,this.logLevelChangeableLoggers.forEach(a=>a.setLevel(o))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,n){let o=this.loggers.get(i.toString());return o||(o=this.doCreateLogger(i,n?.always?h.Trace:this.logLevel,n),this.loggers.set(i.toString(),o),n?.always||this.logLevelChangeableLoggers.push(o)),o}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=w;class m{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(i){}getLevel(){return h.Info}trace(i,...n){}debug(i,...n){}info(i,...n){}warn(i,...n){}error(i,...n){}critical(i,...n){}dispose(){}flush(){}}e.NullLogService=m;function u(r){if(r.verbose)return h.Trace;if(typeof r.logLevel=="string"){const i=c(r.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=u;function c(r){switch(r){case"trace":return h.Trace;case"debug":return h.Debug;case"info":return h.Info;case"warn":return h.Warning;case"error":return h.Error;case"critical":return h.Critical;case"off":return h.Off}}e.parseLogLevel=c;function s(r){switch(r){case h.Trace:return"trace";case h.Debug:return"debug";case h.Info:return"info";case h.Warning:return"warn";case h.Error:return"error";case h.Critical:return"critical";case h.Off:return"off"}}e.LogLevelToString=s});var J=this&&this.__param||function(H,e){return function(v,t){e(v,t,H)}};define(Z[200],ee([0,1,69,3,2,6,4]),function(H,e,v,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let y=class St extends k.Disposable{constructor(p){super();this.logService=p,this._onDidChangePassword=this._register(new t.Emitter),this.onDidChangePassword=this._onDidChangePassword.event}async getPassword(p,I){let C;try{C=await this.withKeytar()}catch{return null}const b=await C.getPassword(p,I);if(b)try{let{content:g,hasNextChunk:d}=JSON.parse(b);if(!g||!d)return b;let E=1;for(;d;){const S=await C.getPassword(p,`${I}-${E}`),f=JSON.parse(S);g+=f.content,d=f.hasNextChunk,E++}return g}catch{return b}return b}async setPassword(p,I,C){let b;try{b=await this.withKeytar()}catch(E){throw this.surfaceKeytarLoadError?.(E),E}const g=3,d=async(E,S,f)=>{let w=0,m;for(;w<g;)try{await b.setPassword(E,S,f);return}catch(u){m=u,this.logService.warn("Error attempting to set a password: ",u?.message??u),w++,await new Promise(c=>setTimeout(c,200))}throw m};if(D.isWindows&&C.length>St.MAX_PASSWORD_LENGTH){let E=0,S=0,f=!0;for(;f;){const w=C.substring(E,E+St.PASSWORD_CHUNK_SIZE);E+=St.PASSWORD_CHUNK_SIZE,f=C.length-E>0;const m={content:w,hasNextChunk:f};await d(p,S?`${I}-${S}`:I,JSON.stringify(m)),S++}}else await d(p,I,C);this._onDidChangePassword.fire({service:p,account:I})}async deletePassword(p,I){let C;try{C=await this.withKeytar()}catch(d){throw this.surfaceKeytarLoadError?.(d),d}const b=await C.getPassword(p,I);if(!b)return!1;const g=await C.deletePassword(p,I);try{let{content:d,hasNextChunk:E}=JSON.parse(b);if(d&&E){let S=1;for(;E;){const f=`${I}-${S}`,w=await C.getPassword(p,f);await C.deletePassword(p,f),E=JSON.parse(w).hasNextChunk,S++}}}catch{}return g&&this._onDidChangePassword.fire({service:p,account:I}),g}async findPassword(p){let I;try{I=await this.withKeytar()}catch{return null}return I.findPassword(p)}async findCredentials(p){let I;try{I=await this.withKeytar()}catch{return[]}return I.findCredentials(p)}clear(){return this._keytarCache instanceof v.InMemoryCredentialsProvider?this._keytarCache.clear():Promise.resolve()}};y.MAX_PASSWORD_LENGTH=2500,y.PASSWORD_CHUNK_SIZE=y.MAX_PASSWORD_LENGTH-100,y=ve([J(0,R.ILogService)],y),e.BaseCredentialsMainService=y}),define(Z[201],ee([0,1,24,8,18,3,2,9,70,6]),function(H,e,v,t,k,R,D,y,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class I extends D.Disposable{constructor(b,g){super();this.logService=b,this.options=g,this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new R.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new t.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new t.ThrottledDelayer(0))}watch(b,g){return g.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(b,g):this.watchNonRecursive(b,g)}watchUniversal(b,g){const d={path:this.toFilePath(b),excludes:g.excludes,includes:g.includes,recursive:g.recursive},E=(0,v.insert)(this.universalPathsToWatch,d);return this.refreshUniversalWatchers(),(0,D.toDisposable)(()=>{E(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(b=>(0,k.onUnexpectedError)(b))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(g=>this._onDidChangeFile.fire((0,h.toFileChanges)(g)),g=>this.onWatcherLogMessage(g),this.logService.getLevel()===p.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===p.LogLevel.Trace)})));const b=this.options?.watcher?.recursive?.usePolling;if(b===!0)for(const g of this.universalPathsToWatch)(0,h.isRecursiveWatchRequest)(g)&&(g.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(b))for(const g of this.universalPathsToWatch)(0,h.isRecursiveWatchRequest)(g)&&b.includes(g.path)&&(g.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(b,g){const d={path:this.toFilePath(b),excludes:g.excludes,includes:g.includes,recursive:!1},E=(0,v.insert)(this.nonRecursivePathsToWatch,d);return this.refreshNonRecursiveWatchers(),(0,D.toDisposable)(()=>{E(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(b=>(0,k.onUnexpectedError)(b))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(b=>this._onDidChangeFile.fire((0,h.toFileChanges)(b)),b=>this.onWatcherLogMessage(b),this.logService.getLevel()===p.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===p.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(b){b.type==="error"&&this._onDidWatchError.fire(b.message),this.logService[b.type](b.message)}toFilePath(b){return(0,y.normalize)(b.fsPath)}}e.AbstractDiskFileSystemProvider=I}),define(Z[202],ee([0,1,24,8,17,21,3,67,55,2,32,13,71,16,56,158,14,104,6]),function(H,e,v,t,k,R,D,y,h,p,I,C,b,g,d,E,S,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let m=class extends p.Disposable{constructor(c){super();this.logService=c,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new D.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new D.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new D.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new D.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new D.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new D.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new t.ResourceQueue)}registerProvider(c,s){if(this.provider.has(c))throw new Error(`A filesystem provider for the scheme '${c}' is already registered.`);(0,b.mark)(`code/registerFilesystem/${c}`);const r=new p.DisposableStore;return this.provider.set(c,s),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:c,provider:s}),r.add(s.onDidChangeFile(i=>this._onDidFilesChange.fire(new S.FileChangesEvent(i,!this.isPathCaseSensitive(s))))),typeof s.onDidWatchError=="function"&&r.add(s.onDidWatchError(i=>this._onDidWatchError.fire(new Error(i)))),r.add(s.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:s,scheme:c}))),(0,p.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:c,provider:s}),this.provider.delete(c),(0,p.dispose)(r)})}getProvider(c){return this.provider.get(c)}async activateProvider(c){const s=[];this._onWillActivateFileSystemProvider.fire({scheme:c,join(r){s.push(r)}}),!this.provider.has(c)&&await t.Promises.settled(s)}async canHandleResource(c){return await this.activateProvider(c.scheme),this.hasProvider(c)}hasProvider(c){return this.provider.has(c.scheme)}hasCapability(c,s){const r=this.provider.get(c.scheme);return!!(r&&r.capabilities&s)}listCapabilities(){return h.Iterable.map(this.provider,([c,s])=>({scheme:c,capabilities:s.capabilities}))}async withProvider(c){if(!(0,g.isAbsolutePath)(c))throw new S.FileOperationError((0,E.localize)(0,null,this.resourceForError(c)),8);await this.activateProvider(c.scheme);const s=this.provider.get(c.scheme);if(!s){const r=new Error;throw r.name="ENOPRO",r.message=(0,E.localize)(1,null,c.toString()),r}return s}async withReadProvider(c){const s=await this.withProvider(c);if((0,S.hasOpenReadWriteCloseCapability)(s)||(0,S.hasReadWriteCapability)(s)||(0,S.hasFileReadStreamCapability)(s)||(0,S.hasFileReadCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite, FileReadStream, FileOpenReadWriteClose nor Readonly capability which is needed for the read operation.`)}async withWriteProvider(c){const s=await this.withProvider(c);if((0,S.hasOpenReadWriteCloseCapability)(s)||(0,S.hasReadWriteCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(c,s){try{return await this.doResolveFile(c,s)}catch(r){throw(0,S.toFileSystemProviderErrorCode)(r)===S.FileSystemProviderErrorCode.FileNotFound?new S.FileOperationError((0,E.localize)(2,null,this.resourceForError(c)),1):(0,S.ensureFileSystemProviderError)(r)}}async doResolveFile(c,s){const r=await this.withProvider(c),i=this.isPathCaseSensitive(r),n=s?.resolveTo,o=s?.resolveSingleChildDescendants,a=s?.resolveMetadata,l=await r.stat(c);let P;return this.toFileStat(r,c,l,void 0,!!a,(M,T)=>(P||(P=I.TernarySearchTree.forUris(()=>!i),P.set(c,!0),n&&P.fill(!0,n)),P.get(M.resource)||P.findSuperstr(M.resource.with({query:null,fragment:null}))?!0:M.isDirectory&&o?T===1:!1))}async toFileStat(c,s,r,i,n,o){const{providerExtUri:a}=this.getExtUri(c),l={resource:s,name:a.basename(s),isFile:(r.type&S.FileType.File)!=0,isDirectory:(r.type&S.FileType.Directory)!=0,isSymbolicLink:(r.type&S.FileType.SymbolicLink)!=0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:Boolean((r.permissions??0)&S.FilePermission.Readonly)||Boolean(c.capabilities&2048),etag:(0,S.etag)({mtime:r.mtime,size:r.size}),children:void 0};if(l.isDirectory&&o(l,i)){try{const P=await c.readdir(s),M=await t.Promises.settled(P.map(async([T,F])=>{try{const U=a.joinPath(s,T),Q=n?await c.stat(U):{type:F};return await this.toFileStat(c,U,Q,P.length,n,o)}catch(U){return this.logService.trace(U),null}}));l.children=(0,v.coalesce)(M)}catch(P){this.logService.trace(P),l.children=[]}return l}return l}async resolveAll(c){return t.Promises.settled(c.map(async s=>{try{return{stat:await this.doResolveFile(s.resource,s.options),success:!0}}catch(r){return this.logService.trace(r),{stat:void 0,success:!1}}}))}async stat(c){const s=await this.withProvider(c),r=await s.stat(c);return this.toFileStat(s,c,r,void 0,!0,()=>!1)}async exists(c){const s=await this.withProvider(c);try{return!!await s.stat(c)}catch{return!1}}async canCreateFile(c,s){try{await this.doValidateCreateFile(c,s)}catch(r){return r}return!0}async doValidateCreateFile(c,s){if(!s?.overwrite&&await this.exists(c))throw new S.FileOperationError((0,E.localize)(3,null,this.resourceForError(c)),3,s)}async createFile(c,s=k.VSBuffer.fromString(""),r){await this.doValidateCreateFile(c,r);const i=await this.writeFile(c,s);return this._onDidRunOperation.fire(new S.FileOperationEvent(c,0,i)),i}async writeFile(c,s,r){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),{providerExtUri:n}=this.getExtUri(i);try{await this.validateWriteFile(i,c,r)||await this.mkdirp(i,n.dirname(c));let a;if((0,S.hasReadWriteCapability)(i)&&!(s instanceof k.VSBuffer))if((0,d.isReadableStream)(s)){const l=await(0,d.peekStream)(s,3);l.ended?a=k.VSBuffer.concat(l.buffer):a=l}else a=(0,d.peekReadable)(s,l=>k.VSBuffer.concat(l),3);else a=s;!(0,S.hasOpenReadWriteCloseCapability)(i)||(0,S.hasReadWriteCapability)(i)&&a instanceof k.VSBuffer?await this.doWriteUnbuffered(i,c,r,a):await this.doWriteBuffered(i,c,r,a instanceof k.VSBuffer?(0,k.bufferToReadable)(a):a),this._onDidRunOperation.fire(new S.FileOperationEvent(c,4))}catch(o){throw new S.FileOperationError((0,E.localize)(4,null,this.resourceForError(c),(0,S.ensureFileSystemProviderError)(o).toString()),(0,S.toFileOperationResult)(o),r)}return this.resolve(c,{resolveMetadata:!0})}async validateWriteFile(c,s,r){if(!!r?.unlock&&!(c.capabilities&8192))throw new Error((0,E.localize)(5,null,this.resourceForError(s)));let n;try{n=await c.stat(s)}catch{return}if((n.type&S.FileType.Directory)!=0)throw new S.FileOperationError((0,E.localize)(6,null,this.resourceForError(s)),0,r);if(this.throwIfFileIsReadonly(s,n),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==S.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&r.mtime<n.mtime&&r.etag!==(0,S.etag)({mtime:r.mtime,size:n.size}))throw new S.FileOperationError((0,E.localize)(7,null),3,r);return n}async readFile(c,s,r){const i=await this.withReadProvider(c);return s?.atomic?this.doReadFileAtomic(i,c,s,r):this.doReadFile(i,c,s,r)}async doReadFileAtomic(c,s,r,i){return new Promise((n,o)=>{this.writeQueue.queueFor(s,this.getExtUri(c).providerExtUri).queue(async()=>{try{const a=await this.doReadFile(c,s,r,i);n(a)}catch(a){o(a)}})})}async doReadFile(c,s,r,i){const n=await this.doReadFileStream(c,s,{...r,preferUnbuffered:!0},i);return{...n,value:await(0,k.streamToBuffer)(n.value)}}async readFileStream(c,s,r){const i=await this.withReadProvider(c);return this.doReadFileStream(i,c,s,r)}async doReadFileStream(c,s,r,i){const n=new R.CancellationTokenSource(i),o=this.validateReadFile(s,r).then(l=>l,l=>{throw n.cancel(),l});let a;try{return typeof r?.etag=="string"&&r.etag!==S.ETAG_DISABLED&&await o,r?.atomic&&(0,S.hasFileAtomicReadCapability)(c)||!((0,S.hasOpenReadWriteCloseCapability)(c)||(0,S.hasFileReadStreamCapability)(c))||(0,S.hasReadWriteCapability)(c)&&r?.preferUnbuffered?a=this.readFileUnbuffered(c,s,r):(0,S.hasFileReadStreamCapability)(c)?a=this.readFileStreamed(c,s,n.token,r):a=this.readFileBuffered(c,s,n.token,r),{...await o,value:a}}catch(l){a&&await(0,d.consumeStream)(a);const P=(0,E.localize)(8,null,this.resourceForError(s),(0,S.ensureFileSystemProviderError)(l).toString());throw l instanceof S.NotModifiedSinceFileOperationError?new S.NotModifiedSinceFileOperationError(P,l.stat,r):new S.FileOperationError(P,(0,S.toFileOperationResult)(l),r)}}readFileStreamed(c,s,r,i=Object.create(null)){const n=c.readFileStream(s,i,r);return(0,d.transform)(n,{data:o=>o instanceof k.VSBuffer?o:k.VSBuffer.wrap(o),error:o=>new S.FileOperationError((0,E.localize)(9,null,this.resourceForError(s),(0,S.ensureFileSystemProviderError)(o).toString()),(0,S.toFileOperationResult)(o),i)},o=>k.VSBuffer.concat(o))}readFileBuffered(c,s,r,i=Object.create(null)){const n=(0,k.newWriteableBufferStream)();return(0,f.readFileIntoStream)(c,s,n,o=>o,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:o=>new S.FileOperationError((0,E.localize)(10,null,this.resourceForError(s),(0,S.ensureFileSystemProviderError)(o).toString()),(0,S.toFileOperationResult)(o),i)},r),n}readFileUnbuffered(c,s,r){const i=(0,d.newWriteableStream)(n=>k.VSBuffer.concat(n));return(async()=>{try{let n;r?.atomic&&(0,S.hasFileAtomicReadCapability)(c)?n=await c.readFile(s,{atomic:!0}):n=await c.readFile(s),typeof r?.position=="number"&&(n=n.slice(r.position)),typeof r?.length=="number"&&(n=n.slice(0,r.length)),this.validateReadFileLimits(s,n.byteLength,r),i.end(k.VSBuffer.wrap(n))}catch(n){i.error(n),i.end()}})(),i}async validateReadFile(c,s){const r=await this.resolve(c,{resolveMetadata:!0});if(r.isDirectory)throw new S.FileOperationError((0,E.localize)(11,null,this.resourceForError(c)),0,s);if(typeof s?.etag=="string"&&s.etag!==S.ETAG_DISABLED&&s.etag===r.etag)throw new S.NotModifiedSinceFileOperationError((0,E.localize)(12,null),r,s);return this.validateReadFileLimits(c,r.size,s),r}validateReadFileLimits(c,s,r){if(r?.limits){let i;if(typeof r.limits.memory=="number"&&s>r.limits.memory&&(i=9),typeof r.limits.size=="number"&&s>r.limits.size&&(i=7),typeof i=="number")throw new S.FileOperationError((0,E.localize)(13,null,this.resourceForError(c)),i)}}async canMove(c,s,r){return this.doCanMoveCopy(c,s,"move",r)}async canCopy(c,s,r){return this.doCanMoveCopy(c,s,"copy",r)}async doCanMoveCopy(c,s,r,i){if(c.toString()!==s.toString())try{const n=r==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c):await this.withReadProvider(c),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s);await this.doValidateMoveCopy(n,c,o,s,r,i)}catch(n){return n}return!0}async move(c,s,r){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),o=await this.doMoveCopy(i,c,n,s,"move",!!r),a=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(c,o==="move"?2:3,a)),a}async copy(c,s,r){const i=await this.withReadProvider(c),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),o=await this.doMoveCopy(i,c,n,s,"copy",!!r),a=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(c,o==="copy"?3:2,a)),a}async doMoveCopy(c,s,r,i,n,o){if(s.toString()===i.toString())return n;const{exists:a,isSameResourceWithDifferentPathCase:l}=await this.doValidateMoveCopy(c,s,r,i,n,o);if(a&&!l&&o&&await this.del(i,{recursive:!0}),await this.mkdirp(r,this.getExtUri(r).providerExtUri.dirname(i)),n==="copy"){if(c===r&&(0,S.hasFileFolderCopyCapability)(c))await c.copy(s,i,{overwrite:o});else{const P=await this.resolve(s);P.isDirectory?await this.doCopyFolder(c,P,r,i):await this.doCopyFile(c,s,r,i)}return n}else return c===r?(await c.rename(s,i,{overwrite:o}),n):(await this.doMoveCopy(c,s,r,i,"copy",o),await this.del(s,{recursive:!0}),"copy")}async doCopyFile(c,s,r,i){if((0,S.hasOpenReadWriteCloseCapability)(c)&&(0,S.hasOpenReadWriteCloseCapability)(r))return this.doPipeBuffered(c,s,r,i);if((0,S.hasOpenReadWriteCloseCapability)(c)&&(0,S.hasReadWriteCapability)(r))return this.doPipeBufferedToUnbuffered(c,s,r,i);if((0,S.hasReadWriteCapability)(c)&&(0,S.hasOpenReadWriteCloseCapability)(r))return this.doPipeUnbufferedToBuffered(c,s,r,i);if((0,S.hasReadWriteCapability)(c)&&(0,S.hasReadWriteCapability)(r))return this.doPipeUnbuffered(c,s,r,i)}async doCopyFolder(c,s,r,i){await r.mkdir(i),Array.isArray(s.children)&&await t.Promises.settled(s.children.map(async n=>{const o=this.getExtUri(r).providerExtUri.joinPath(i,n.name);return n.isDirectory?this.doCopyFolder(c,await this.resolve(n.resource),r,o):this.doCopyFile(c,n.resource,r,o)}))}async doValidateMoveCopy(c,s,r,i,n,o){let a=!1;if(c===r){const{providerExtUri:P,isPathCaseSensitive:M}=this.getExtUri(c);if(M||(a=P.isEqual(s,i)),a&&n==="copy")throw new Error((0,E.localize)(14,null,this.resourceForError(s),this.resourceForError(i)));if(!a&&P.isEqualOrParent(i,s))throw new Error((0,E.localize)(15,null,this.resourceForError(s),this.resourceForError(i)))}const l=await this.exists(i);if(l&&!a){if(!o)throw new S.FileOperationError((0,E.localize)(16,null,this.resourceForError(s),this.resourceForError(i)),4);if(c===r){const{providerExtUri:P}=this.getExtUri(c);if(P.isEqualOrParent(s,i))throw new Error((0,E.localize)(17,null,this.resourceForError(s),this.resourceForError(i)))}}return{exists:l,isSameResourceWithDifferentPathCase:a}}getExtUri(c){const s=this.isPathCaseSensitive(c);return{providerExtUri:s?g.extUri:g.extUriIgnorePathCase,isPathCaseSensitive:s}}isPathCaseSensitive(c){return!!(c.capabilities&1024)}async createFolder(c){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);await this.mkdirp(s,c);const r=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(c,0,r)),r}async mkdirp(c,s){const r=[],{providerExtUri:i}=this.getExtUri(c);for(;!i.isEqual(s,i.dirname(s));)try{if(((await c.stat(s)).type&S.FileType.Directory)==0)throw new Error((0,E.localize)(18,null,this.resourceForError(s)));break}catch(n){if((0,S.toFileSystemProviderErrorCode)(n)!==S.FileSystemProviderErrorCode.FileNotFound)throw n;r.push(i.basename(s)),s=i.dirname(s)}for(let n=r.length-1;n>=0;n--){s=i.joinPath(s,r[n]);try{await c.mkdir(s)}catch(o){if((0,S.toFileSystemProviderErrorCode)(o)!==S.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(c,s){try{await this.doValidateDelete(c,s)}catch(r){return r}return!0}async doValidateDelete(c,s){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);if(!!s?.useTrash&&!(r.capabilities&4096))throw new Error((0,E.localize)(19,null,this.resourceForError(c)));let n;try{n=await r.stat(c)}catch{}if(n)this.throwIfFileIsReadonly(c,n);else throw new S.FileOperationError((0,E.localize)(20,null,this.resourceForError(c)),1);if(!!!s?.recursive){const a=await this.resolve(c);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,E.localize)(21,null,this.resourceForError(c)))}return r}async del(c,s){const r=await this.doValidateDelete(c,s),i=!!s?.useTrash,n=!!s?.recursive;await r.delete(c,{recursive:n,useTrash:i}),this._onDidRunOperation.fire(new S.FileOperationEvent(c,1))}async cloneFile(c,s){const r=await this.withProvider(c),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s);if(r===i&&this.getExtUri(r).providerExtUri.isEqual(c,s))return;if(r===i&&(0,S.hasFileCloneCapability)(r))return r.cloneFile(c,s);await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(s));const n=this.writeQueue.queueFor(c,this.getExtUri(r).providerExtUri);return r===i&&(0,S.hasFileFolderCopyCapability)(r)?n.queue(()=>r.copy(c,s,{overwrite:!0})):n.queue(()=>this.doCopyFile(r,c,i,s))}watch(c,s={recursive:!1,excludes:[]}){const r=new p.DisposableStore;let i=!1,n=()=>{i=!0};return r.add((0,p.toDisposable)(()=>n())),(async()=>{try{const o=await this.doWatch(c,s);i?(0,p.dispose)(o):n=()=>(0,p.dispose)(o)}catch(o){this.logService.error(o)}})(),r}async doWatch(c,s){const r=await this.withProvider(c),i=(0,y.hash)([this.getExtUri(r).providerExtUri.getComparisonKey(c),s]);let n=this.activeWatchers.get(i);return n||(n={count:0,disposable:r.watch(c,s)},this.activeWatchers.set(i,n)),n.count+=1,(0,p.toDisposable)(()=>{n&&(n.count--,n.count===0&&((0,p.dispose)(n.disposable),this.activeWatchers.delete(i)))})}dispose(){super.dispose();for(const[,c]of this.activeWatchers)(0,p.dispose)(c.disposable);this.activeWatchers.clear()}async doWriteBuffered(c,s,r,i){return this.writeQueue.queueFor(s,this.getExtUri(c).providerExtUri).queue(async()=>{const n=await c.open(s,{create:!0,unlock:r?.unlock??!1});try{(0,d.isReadableStream)(i)||(0,d.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(c,n,i):await this.doWriteReadableBufferedQueued(c,n,i)}catch(o){throw(0,S.ensureFileSystemProviderError)(o)}finally{await c.close(n)}})}async doWriteStreamBufferedQueued(c,s,r){let i=0,n;if((0,d.isReadableBufferedStream)(r)){if(r.buffer.length>0){const o=k.VSBuffer.concat(r.buffer);await this.doWriteBuffer(c,s,o,o.byteLength,i,0),i+=o.byteLength}if(r.ended)return;n=r.stream}else n=r;return new Promise((o,a)=>{(0,d.listenStream)(n,{onData:async l=>{n.pause();try{await this.doWriteBuffer(c,s,l,l.byteLength,i,0)}catch(P){return a(P)}i+=l.byteLength,setTimeout(()=>n.resume())},onError:l=>a(l),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(c,s,r){let i=0,n;for(;(n=r.read())!==null;)await this.doWriteBuffer(c,s,n,n.byteLength,i,0),i+=n.byteLength}async doWriteBuffer(c,s,r,i,n,o){let a=0;for(;a<i;)a+=await c.write(s,n+a,r.buffer,o+a,i-a)}async doWriteUnbuffered(c,s,r,i){return this.writeQueue.queueFor(s,this.getExtUri(c).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(c,s,r,i))}async doWriteUnbufferedQueued(c,s,r,i){let n;i instanceof k.VSBuffer?n=i:(0,d.isReadableStream)(i)?n=await(0,k.streamToBuffer)(i):(0,d.isReadableBufferedStream)(i)?n=await(0,k.bufferedStreamToBuffer)(i):n=(0,k.readableToBuffer)(i),await c.writeFile(s,n.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1})}async doPipeBuffered(c,s,r,i){return this.writeQueue.queueFor(i,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeBufferedQueued(c,s,r,i))}async doPipeBufferedQueued(c,s,r,i){let n,o;try{n=await c.open(s,{create:!1}),o=await r.open(i,{create:!0,unlock:!1});const a=k.VSBuffer.alloc(this.BUFFER_SIZE);let l=0,P=0,M=0;do M=await c.read(n,l,a.buffer,P,a.byteLength-P),await this.doWriteBuffer(r,o,a,M,l,P),l+=M,P+=M,P===a.byteLength&&(P=0);while(M>0)}catch(a){throw(0,S.ensureFileSystemProviderError)(a)}finally{await t.Promises.settled([typeof n=="number"?c.close(n):Promise.resolve(),typeof o=="number"?r.close(o):Promise.resolve()])}}async doPipeUnbuffered(c,s,r,i){return this.writeQueue.queueFor(i,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(c,s,r,i))}async doPipeUnbufferedQueued(c,s,r,i){return r.writeFile(i,await c.readFile(s),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(c,s,r,i){return this.writeQueue.queueFor(i,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(c,s,r,i))}async doPipeUnbufferedToBufferedQueued(c,s,r,i){const n=await r.open(i,{create:!0,unlock:!1});try{const o=await c.readFile(s);await this.doWriteBuffer(r,n,k.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,S.ensureFileSystemProviderError)(o)}finally{await r.close(n)}}async doPipeBufferedToUnbuffered(c,s,r,i){const n=await(0,k.streamToBuffer)(this.readFileBuffered(c,s,R.CancellationToken.None));await this.doWriteUnbuffered(r,i,void 0,n)}throwIfFileSystemIsReadonly(c,s){if(c.capabilities&2048)throw new S.FileOperationError((0,E.localize)(22,null,this.resourceForError(s)),6);return c}throwIfFileIsReadonly(c,s){if((s.permissions??0)&S.FilePermission.Readonly)throw new S.FileOperationError((0,E.localize)(23,null,this.resourceForError(c)),6)}resourceForError(c){return c.scheme===C.Schemas.file?c.fsPath:c.toString(!0)}};m=ve([J(0,w.ILogService)],m),e.FileService=m}),define(Z[86],ee([0,1,29,272,8,32,17,3,31,2,9,4,16,56,23,162,14,104,201,43,198,197]),function(H,e,v,t,k,R,D,y,h,p,I,C,b,g,d,E,S,f,w,m,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,t.gracefulify)(v)}catch(r){console.error(`Error enabling graceful-fs: ${(0,m.toErrorMessage)(r)}`)}})();class s extends w.AbstractDiskFileSystemProvider{constructor(i,n){super(i,n);this.onDidChangeCapabilities=y.Event.None,this.resourceLocks=new R.ResourceMap(o=>b.extUriBiasedIgnorePathCase.getComparisonKey(o)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384|32768,C.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:n,symbolicLink:o}=await d.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(n,o),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size}}catch(n){throw this.toFileSystemProviderError(n)}}async readdir(i){try{const n=await d.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),o=[];return await Promise.all(n.map(async a=>{try{let l;a.isSymbolicLink()?l=(await this.stat((0,b.joinPath)(i,a.name))).type:l=this.toType(a),o.push([a.name,l])}catch(l){this.logService.trace(l)}})),o}catch(n){throw this.toFileSystemProviderError(n)}}toType(i,n){let o;return n?.dangling?o=S.FileType.Unknown:i.isFile()?o=S.FileType.File:i.isDirectory()?o=S.FileType.Directory:o=S.FileType.Unknown,n&&(o|=S.FileType.SymbolicLink),o}async createResourceLock(i){const n=this.toFilePath(i);this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let o;for(;o=this.resourceLocks.get(i);)this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await o.wait();const a=new k.Barrier;return this.resourceLocks.set(i,a),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,p.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.resourceLocks.get(i)===a&&(this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.resourceLocks.delete(i)),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),a.open()})}async readFile(i,n){let o;try{n?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(i)})`),o=await this.createResourceLock(i));const a=this.toFilePath(i);return await d.Promises.readFile(a)}catch(a){throw this.toFileSystemProviderError(a)}finally{o?.dispose()}}readFileStream(i,n,o){const a=(0,g.newWriteableStream)(l=>D.VSBuffer.concat(l.map(P=>D.VSBuffer.wrap(P))).buffer);return(0,f.readFileIntoStream)(this,i,a,l=>l.buffer,{...n,bufferSize:256*1024},o),a}async writeFile(i,n,o){let a;try{const l=this.toFilePath(i);if(!o.create||!o.overwrite){if(await d.Promises.exists(l)){if(!o.overwrite)throw(0,S.createFileSystemProviderError)((0,E.localize)(0,null),S.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,S.createFileSystemProviderError)((0,E.localize)(1,null),S.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(i,{create:!0,unlock:o.unlock}),await this.write(a,0,n,0,n.byteLength)}catch(l){throw await this.toFileSystemProviderWriteError(i,l)}finally{typeof a=="number"&&await this.close(a)}}static configureFlushOnWrite(i){s.canFlush=i}async open(i,n){const o=this.toFilePath(i);let a;(0,S.isFileOpenForWriteOptions)(n)&&(a=await this.createResourceLock(i));let l;try{if((0,S.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:M}=await d.SymlinkSupport.stat(o);M.mode&128||await d.Promises.chmod(o,M.mode|128)}catch(M){this.logService.trace(M)}let P;if((0,S.isFileOpenForWriteOptions)(n)){if(C.isWindows)try{await d.Promises.truncate(o,0),P="r+"}catch(M){M.code!=="ENOENT"&&this.logService.trace(M)}P||(P="w")}else P="r";l=await d.Promises.open(o,P)}catch(P){throw a?.dispose(),(0,S.isFileOpenForWriteOptions)(n)?await this.toFileSystemProviderWriteError(i,P):this.toFileSystemProviderError(P)}if(this.mapHandleToPos.set(l,0),(0,S.isFileOpenForWriteOptions)(n)&&this.writeHandles.set(l,i),a){const P=this.mapHandleToLock.get(l);this.logService.trace(`[Disk FileSystemProvider]: open() - storing lock for handle ${l} (${o})`),this.mapHandleToLock.set(l,a),P&&(this.logService.trace(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${l} (${o})`),P.dispose())}return l}async close(i){const n=this.mapHandleToLock.get(i);try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&s.canFlush)try{await d.Promises.fdatasync(i)}catch(o){s.configureFlushOnWrite(!1),this.logService.error(o)}return await d.Promises.close(i)}catch(o){throw this.toFileSystemProviderError(o)}finally{n&&(this.mapHandleToLock.get(i)===n&&(this.logService.trace(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.mapHandleToLock.delete(i)),this.logService.trace(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),n.dispose())}}async read(i,n,o,a,l){const P=this.normalizePos(i,n);let M=null;try{M=(await d.Promises.read(i,o,a,l,P)).bytesRead}catch(T){throw this.toFileSystemProviderError(T)}finally{this.updatePos(i,P,M)}return M}normalizePos(i,n){return n===this.mapHandleToPos.get(i)?null:n}updatePos(i,n,o){const a=this.mapHandleToPos.get(i);typeof a=="number"&&(typeof n=="number"||(typeof o=="number"?this.mapHandleToPos.set(i,a+o):this.mapHandleToPos.delete(i)))}async write(i,n,o,a,l){return(0,k.retry)(()=>this.doWrite(i,n,o,a,l),100,3)}async doWrite(i,n,o,a,l){const P=this.normalizePos(i,n);let M=null;try{M=(await d.Promises.write(i,o,a,l,P)).bytesWritten}catch(T){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),T)}finally{this.updatePos(i,P,M)}return M}async mkdir(i){try{await d.Promises.mkdir(this.toFilePath(i))}catch(n){throw this.toFileSystemProviderError(n)}}async delete(i,n){try{const o=this.toFilePath(i);n.recursive?await d.Promises.rm(o,d.RimRafMode.MOVE):await d.Promises.unlink(o)}catch(o){throw this.toFileSystemProviderError(o)}}async rename(i,n,o){const a=this.toFilePath(i),l=this.toFilePath(n);if(a!==l)try{await this.validateTargetDeleted(i,n,"move",o.overwrite),await d.Promises.move(a,l)}catch(P){throw(P.code==="EINVAL"||P.code==="EBUSY"||P.code==="ENAMETOOLONG")&&(P=new Error((0,E.localize)(2,null,(0,I.basename)(a),(0,I.basename)((0,I.dirname)(l)),P.toString()))),this.toFileSystemProviderError(P)}}async copy(i,n,o){const a=this.toFilePath(i),l=this.toFilePath(n);if(a!==l)try{await this.validateTargetDeleted(i,n,"copy",o.overwrite),await d.Promises.copy(a,l,{preserveSymlinks:!0})}catch(P){throw(P.code==="EINVAL"||P.code==="EBUSY"||P.code==="ENAMETOOLONG")&&(P=new Error((0,E.localize)(3,null,(0,I.basename)(a),(0,I.basename)((0,I.dirname)(l)),P.toString()))),this.toFileSystemProviderError(P)}}async validateTargetDeleted(i,n,o,a){const l=this.toFilePath(i),P=this.toFilePath(n);let M=!1;if(!!(this.capabilities&1024)||(M=(0,h.isEqual)(l,P,!0)),M&&o==="copy")throw(0,S.createFileSystemProviderError)((0,E.localize)(4,null),S.FileSystemProviderErrorCode.FileExists);if(!M&&await d.Promises.exists(P)){if(!a)throw(0,S.createFileSystemProviderError)((0,E.localize)(5,null),S.FileSystemProviderErrorCode.FileExists);await this.delete(n,{recursive:!0,useTrash:!1})}}async cloneFile(i,n){return this.doCloneFile(i,n,!1)}async doCloneFile(i,n,o){const a=this.toFilePath(i),l=this.toFilePath(n),P=!!(this.capabilities&1024);if((0,h.isEqual)(a,l,!P))return;const M=new p.DisposableStore;try{const[T,F]=await Promise.all([this.createResourceLock(i),this.createResourceLock(n)]);M.add(T),M.add(F),o&&await d.Promises.mkdir((0,I.dirname)(l),{recursive:!0}),await d.Promises.copyFile(a,l)}catch(T){if(T.code==="ENOENT"&&!o)return this.doCloneFile(i,n,!0);throw this.toFileSystemProviderError(T)}finally{M.dispose()}}createUniversalWatcher(i,n,o){return new u.UniversalWatcherClient(a=>i(a),a=>n(a),o)}createNonRecursiveWatcher(i,n,o){return new c.NodeJSWatcherClient(a=>i(a),a=>n(a),o)}toFileSystemProviderError(i){if(i instanceof S.FileSystemProviderError)return i;let n;switch(i.code){case"ENOENT":n=S.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=S.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=S.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=S.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=S.FileSystemProviderErrorCode.NoPermissions;break;default:n=S.FileSystemProviderErrorCode.Unknown}return(0,S.createFileSystemProviderError)(i,n)}async toFileSystemProviderWriteError(i,n){let o=this.toFileSystemProviderError(n);if(i&&o.code===S.FileSystemProviderErrorCode.NoPermissions)try{const{stat:a}=await d.SymlinkSupport.stat(this.toFilePath(i));a.mode&128||(o=(0,S.createFileSystemProviderError)(n,S.FileSystemProviderErrorCode.FileWriteLocked))}catch(a){this.logService.trace(a)}return o}}e.DiskFileSystemProvider=s,s.canFlush=!0}),define(Z[203],ee([0,1,3,86,2,17,56,21]),function(H,e,v,t,k,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class h extends k.Disposable{constructor(C,b){super();this.provider=C,this.logService=b,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(C,b,g){const d=this.getUriTransformer(C);switch(b){case"stat":return this.stat(d,g[0]);case"readdir":return this.readdir(d,g[0]);case"open":return this.open(d,g[0],g[1]);case"close":return this.close(g[0]);case"read":return this.read(g[0],g[1],g[2]);case"readFile":return this.readFile(d,g[0],g[1]);case"write":return this.write(g[0],g[1],g[2],g[3],g[4]);case"writeFile":return this.writeFile(d,g[0],g[1],g[2]);case"rename":return this.rename(d,g[0],g[1],g[2]);case"copy":return this.copy(d,g[0],g[1],g[2]);case"cloneFile":return this.cloneFile(d,g[0],g[1]);case"mkdir":return this.mkdir(d,g[0]);case"delete":return this.delete(d,g[0],g[1]);case"watch":return this.watch(d,g[0],g[1],g[2],g[3]);case"unwatch":return this.unwatch(g[0],g[1])}throw new Error(`IPC Command ${b} not found`)}listen(C,b,g){const d=this.getUriTransformer(C);switch(b){case"fileChange":return this.onFileChange(d,g[0]);case"readFileStream":return this.onReadFileStream(d,g[0],g[1])}throw new Error(`Unknown event ${b}`)}stat(C,b){const g=this.transformIncoming(C,b,!0);return this.provider.stat(g)}readdir(C,b){const g=this.transformIncoming(C,b);return this.provider.readdir(g)}async readFile(C,b,g){const d=this.transformIncoming(C,b,!0),E=await this.provider.readFile(d,g);return R.VSBuffer.wrap(E)}onReadFileStream(C,b,g){const d=this.transformIncoming(C,b,!0),E=new y.CancellationTokenSource,S=new v.Emitter({onLastListenerRemove:()=>{E.cancel()}}),f=this.provider.readFileStream(d,g,E.token);return(0,D.listenStream)(f,{onData:w=>S.fire(R.VSBuffer.wrap(w)),onError:w=>S.fire(w),onEnd:()=>{S.fire("end"),S.dispose(),E.dispose()}}),S.event}writeFile(C,b,g,d){const E=this.transformIncoming(C,b);return this.provider.writeFile(E,g.buffer,d)}open(C,b,g){const d=this.transformIncoming(C,b,!0);return this.provider.open(d,g)}close(C){return this.provider.close(C)}async read(C,b,g){const d=R.VSBuffer.alloc(g),E=0,S=await this.provider.read(C,b,d.buffer,E,g);return[d,S]}write(C,b,g,d,E){return this.provider.write(C,b,g.buffer,d,E)}mkdir(C,b){const g=this.transformIncoming(C,b);return this.provider.mkdir(g)}delete(C,b,g){const d=this.transformIncoming(C,b);return this.provider.delete(d,g)}rename(C,b,g,d){const E=this.transformIncoming(C,b),S=this.transformIncoming(C,g);return this.provider.rename(E,S,d)}copy(C,b,g,d){const E=this.transformIncoming(C,b),S=this.transformIncoming(C,g);return this.provider.copy(E,S,d)}cloneFile(C,b,g){const d=this.transformIncoming(C,b),E=this.transformIncoming(C,g);return this.provider.cloneFile(d,E)}onFileChange(C,b){const g=new v.Emitter({onFirstListenerAdd:()=>{this.sessionToWatcher.set(b,this.createSessionFileWatcher(C,g))},onLastListenerRemove:()=>{(0,k.dispose)(this.sessionToWatcher.get(b)),this.sessionToWatcher.delete(b)}});return g.event}async watch(C,b,g,d,E){const S=this.sessionToWatcher.get(b);if(S){const f=this.transformIncoming(C,d),w=S.watch(g,f,E);this.watchRequests.set(b+g,w)}}async unwatch(C,b){const g=C+b,d=this.watchRequests.get(g);d&&((0,k.dispose)(d),this.watchRequests.delete(g))}dispose(){super.dispose();for(const[,C]of this.watchRequests)C.dispose();this.watchRequests.clear();for(const[,C]of this.sessionToWatcher)C.dispose();this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=h;class p extends k.Disposable{constructor(C,b,g,d){super();this.uriTransformer=C,this.logService=g,this.environmentService=d,this.watcherRequests=new Map,this.fileWatcher=this._register(new t.DiskFileSystemProvider(this.logService,{watcher:{recursive:this.getRecursiveWatcherOptions(this.environmentService)}})),this.registerListeners(b)}registerListeners(C){const b=this._register(new v.Emitter);this._register(b.event(g=>{C.fire(g.map(d=>({resource:this.uriTransformer.transformOutgoingURI(d.resource),type:d.type})))})),this._register(this.fileWatcher.onDidChangeFile(g=>b.fire(g))),this._register(this.fileWatcher.onDidWatchError(g=>C.fire(g)))}getRecursiveWatcherOptions(C){}getExtraExcludes(C){}watch(C,b,g){const d=this.getExtraExcludes(this.environmentService);return Array.isArray(d)&&(g.excludes=[...g.excludes,...d]),this.watcherRequests.set(C,this.fileWatcher.watch(b,g)),(0,k.toDisposable)(()=>{(0,k.dispose)(this.watcherRequests.get(C)),this.watcherRequests.delete(C)})}dispose(){super.dispose();for(const[,C]of this.watcherRequests)C.dispose();this.watcherRequests.clear()}}e.AbstractSessionFileWatcher=p}),define(Z[204],ee([0,1,15,161,4,7,14,9,203,141]),function(H,e,v,t,k,R,D,y,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class I extends h.AbstractDiskFileSystemProviderChannel{constructor(g,d,E){super(g,d);this.environmentService=E}getUriTransformer(g){return p.DefaultURITransformer}transformIncoming(g,d){return R.URI.revive(d)}async delete(g,d,E){if(!E.useTrash)return super.delete(g,d,E);const S=this.transformIncoming(g,d),f=(0,y.normalize)(S.fsPath);try{await v.shell.trashItem(f)}catch{throw(0,D.createFileSystemProviderError)(k.isWindows?(0,t.localize)(0,null,(0,y.basename)(f)):(0,t.localize)(1,null,(0,y.basename)(f)),D.FileSystemProviderErrorCode.Unknown)}}createSessionFileWatcher(g,d){return new C(g,d,this.logService,this.environmentService)}}e.DiskFileSystemProviderChannel=I;class C extends h.AbstractSessionFileWatcher{watch(g,d,E){if(E.recursive)throw(0,D.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",D.FileSystemProviderErrorCode.Unavailable);return super.watch(g,d,E)}}}),define(Z[105],ee([0,1,6]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function t(R,D){switch(D){case v.LogLevel.Trace:return R.trace;case v.LogLevel.Debug:return R.debug;case v.LogLevel.Info:return R.info;case v.LogLevel.Warning:return R.warn;case v.LogLevel.Error:return R.error;case v.LogLevel.Critical:return R.critical;default:throw new Error("Invalid log level")}}class k extends v.AbstractLogger{constructor(D=v.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(D),this._register(this.onDidChangeLogLevel(y=>{this._logger?.setLevel(y)}))}set logger(D){this._logger=D;for(const{level:y,args:h}of this.buffer)t(D,y).apply(D,h);this.buffer=[]}_log(D,...y){this._logger?t(this._logger,D).apply(this._logger,y):this.getLevel()<=D&&this.buffer.push({level:D,args:y})}trace(D,...y){this._log(v.LogLevel.Trace,D,...y)}debug(D,...y){this._log(v.LogLevel.Debug,D,...y)}info(D,...y){this._log(v.LogLevel.Info,D,...y)}warn(D,...y){this._log(v.LogLevel.Warning,D,...y)}error(D,...y){this._log(v.LogLevel.Error,D,...y)}critical(D,...y){this._log(v.LogLevel.Critical,D,...y)}dispose(){this._logger?.dispose()}flush(){this._logger?.flush()}}e.BufferLogService=k}),define(Z[205],ee([0,1,8,17,16,14,5,105,6]),function(H,e,v,t,k,R,D,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const p=5*R.ByteSize.MB;let I=class extends h.AbstractLogger{constructor(g,d,E,S,f){super();this.name=g,this.resource=d,this.donotUseFormatters=S,this.fileService=f,this.backupIndex=1,this.setLevel(E),this.queue=this._register(new v.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=h.LogLevel.Trace&&this._log(h.LogLevel.Trace,(0,h.format)(arguments))}debug(){this.getLevel()<=h.LogLevel.Debug&&this._log(h.LogLevel.Debug,(0,h.format)(arguments))}info(){this.getLevel()<=h.LogLevel.Info&&this._log(h.LogLevel.Info,(0,h.format)(arguments))}warn(){this.getLevel()<=h.LogLevel.Warning&&this._log(h.LogLevel.Warning,(0,h.format)(arguments))}error(){if(this.getLevel()<=h.LogLevel.Error){const g=arguments[0];if(g instanceof Error){const d=Array.prototype.slice.call(arguments);d[0]=g.stack,this._log(h.LogLevel.Error,(0,h.format)(d))}else this._log(h.LogLevel.Error,(0,h.format)(arguments))}}critical(){this.getLevel()<=h.LogLevel.Critical&&this._log(h.LogLevel.Critical,(0,h.format)(arguments))}flush(){}async initialize(){try{await this.fileService.createFile(this.resource)}catch(g){if(g.fileOperationResult!==3)throw g}}_log(g,d){this.queue.queue(async()=>{await this.initializePromise;let E=await this.loadContent();E.length>p&&(await this.fileService.writeFile(this.getBackupResource(),t.VSBuffer.fromString(E)),E=""),this.donotUseFormatters?E+=d:E+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(g)}] ${d}
`,await this.fileService.writeFile(this.resource,t.VSBuffer.fromString(E))})}getCurrentTimestamp(){const g=S=>S<10?`0${S}`:S,d=S=>S<10?`00${S}`:S<100?`0${S}`:S,E=new Date;return`${E.getFullYear()}-${g(E.getMonth()+1)}-${g(E.getDate())} ${g(E.getHours())}:${g(E.getMinutes())}:${g(E.getSeconds())}.${d(E.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,k.joinPath)((0,k.dirname)(this.resource),`${(0,k.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch{return""}}stringifyLogLevel(g){switch(g){case h.LogLevel.Critical:return"critical";case h.LogLevel.Debug:return"debug";case h.LogLevel.Error:return"error";case h.LogLevel.Info:return"info";case h.LogLevel.Trace:return"trace";case h.LogLevel.Warning:return"warning"}return""}};I=ve([J(4,R.IFileService)],I),e.FileLogger=I;let C=class extends h.AbstractLoggerService{constructor(g,d,E){super(g.getLevel(),g.onDidChangeLogLevel);this.instantiationService=d,this.fileService=E}doCreateLogger(g,d,E){const S=new y.BufferLogService(d);return(0,R.whenProviderRegistered)(g,this.fileService).then(()=>S.logger=this.instantiationService.createInstance(I,E?.name||(0,k.basename)(g),g,S.getLevel(),!!E?.donotUseFormatters)),S}};C=ve([J(0,h.ILogService),J(1,D.IInstantiationService),J(2,R.IFileService)],C),e.FileLoggerService=C}),define(Z[206],ee([0,1,3,7,6]),function(H,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class R{constructor(b){this.service=b,this.onDidChangeLogLevel=v.Event.buffer(b.onDidChangeLogLevel,!0)}listen(b,g){switch(g){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${g}`)}async call(b,g,d){switch(g){case"setLevel":return this.service.setLevel(d)}throw new Error(`Call not found: ${g}`)}}e.LogLevelChannel=R;class D{constructor(b){this.channel=b}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(b){D.setLevel(this.channel,b)}static setLevel(b,g){return b.call("setLevel",g)}}e.LogLevelChannelClient=D;class y{constructor(b){this.loggerService=b,this.loggers=new Map}listen(b,g){throw new Error(`Event not found: ${g}`)}async call(b,g,d){switch(g){case"createLogger":this.createLogger(t.URI.revive(d[0]),d[1]);return;case"log":return this.log(t.URI.revive(d[0]),d[1]);case"consoleLog":return this.consoleLog(d[0],d[1])}throw new Error(`Call not found: ${g}`)}createLogger(b,g){this.loggers.set(b.toString(),this.loggerService.createLogger(b,g))}consoleLog(b,g){let d=console.log;switch(b){case k.LogLevel.Error:d=console.error;break;case k.LogLevel.Warning:d=console.warn;break;case k.LogLevel.Info:d=console.info;break}d.call(console,...g)}log(b,g){const d=this.loggers.get(b.toString());if(!d)throw new Error("Create the logger before logging");for(const[E,S]of g)(0,k.log)(d,E,S)}}e.LoggerChannel=y;class h extends k.AbstractLoggerService{constructor(b,g,d){super(b,g);this.channel=d}createConsoleMainLogger(){return new k.AdapterLogger({log:(b,g)=>{this.channel.call("consoleLog",[b,g])}})}doCreateLogger(b,g,d){return new p(this.channel,b,g,d)}}e.LoggerChannelClient=h;class p extends k.AbstractMessageLogger{constructor(b,g,d,E){super(E?.always);this.channel=b,this.file=g,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(d),this.channel.call("createLogger",[g,E]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(b,g){const d=[[b,g]];this.isLoggerCreated?this.doLog(d):this.buffer.push(...d)}doLog(b){this.channel.call("log",[this.file,b])}}class I extends k.LogService{constructor(b,g){super(g);this.parent=b,this._register(b.onDidChangeLogLevel(d=>g.setLevel(d)))}setLevel(b){super.setLevel(b),this.parent.setLevel(b)}}e.FollowerLogService=I}),define(Z[106],ee([0,1,14,6]),function(H,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function k(y,h,p,I,C){try{const b=await new Promise((d,E)=>{H(["spdlog"],d,E)});b.setFlushOn(t.LogLevel.Trace);const g=await b.createAsyncRotatingLogger(y,h,p,I);return C&&g.clearFormatters(),g}catch(b){console.error(b)}return null}function R(y,h,p){switch(h){case t.LogLevel.Trace:y.trace(p);break;case t.LogLevel.Debug:y.debug(p);break;case t.LogLevel.Info:y.info(p);break;case t.LogLevel.Warning:y.warn(p);break;case t.LogLevel.Error:y.error(p);break;case t.LogLevel.Critical:y.critical(p);break;default:throw new Error("Invalid log level")}}class D extends t.AbstractMessageLogger{constructor(h,p,I,C,b){super();this.buffer=[],this.setLevel(b),this._loggerCreationPromise=this._createSpdLogLogger(h,p,I,C),this._register(this.onDidChangeLogLevel(g=>{this._logger?.setLevel(g)}))}async _createSpdLogLogger(h,p,I,C){const b=I?6:1,g=30/b*v.ByteSize.MB,d=await k(h,p,g,b,C);if(d){this._logger=d,this._logger.setLevel(this.getLevel());for(const{level:E,message:S}of this.buffer)R(this._logger,E,S);this.buffer=[]}}log(h,p){this._logger?R(this._logger,h,p):this.getLevel()<=h&&this.buffer.push({level:h,message:p})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=D}),define(Z[207],ee([0,1,13,16,28,14,205,6,106]),function(H,e,v,t,k,R,D,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let p=class extends y.AbstractLoggerService{constructor(C,b){super(C.getLevel(),C.onDidChangeLogLevel);this.fileService=b}doCreateLogger(C,b,g){return C.scheme===v.Schemas.file?new h.SpdLogLogger(g?.name||(0,k.generateUuid)(),C.fsPath,!g?.donotRotate,!!g?.donotUseFormatters,b):new D.FileLogger(g?.name??(0,t.basename)(C),C,b,!!g?.donotUseFormatters,this.fileService)}};p=ve([J(0,y.ILogService),J(1,R.IFileService)],p),e.LoggerService=p}),define(Z[208],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function v(D){return D.submenu!==void 0}e.isMenubarMenuItemSubmenu=v;function t(D){return D.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=t;function k(D){return D.uri!==void 0}e.isMenubarMenuItemRecentAction=k;function R(D){return!v(D)&&!t(D)&&!k(D)}e.isMenubarMenuItemAction=R}),define(Z[39],ee([0,1,3,55,2,5]),function(H,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,R.createDecorator)("policy");class D extends k.Disposable{constructor(){super(...arguments);this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new v.Emitter),this.onDidChange=this._onDidChange.event}async registerPolicyDefinitions(p){const I=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...p,...this.policyDefinitions},I!==Object.keys(this.policyDefinitions).length&&await this.initializePolicies(p),t.Iterable.reduce(this.policies.entries(),(C,[b,g])=>({...C,[b]:g}),{})}getPolicyValue(p){return this.policies.get(p)}serialize(){return t.Iterable.reduce(Object.entries(this.policyDefinitions),(p,[I,C])=>({...p,[I]:{definition:C,value:this.policies.get(I)}}),{})}}e.AbstractPolicyService=D;class y{constructor(){this.onDidChange=v.Event.None}async registerPolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=y}),define(Z[209],ee([0,1,8,3,55,12,14,6,39]),function(H,e,v,t,k,R,D,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function p(C,b){const g=[];for(const d of k.Iterable.concat(C.keys(),b.keys()))C.get(d)!==b.get(d)&&g.push(d);return g}let I=class extends h.AbstractPolicyService{constructor(b,g,d){super();this.file=b,this.fileService=g,this.logService=d,this.throttledDelayer=this._register(new v.ThrottledDelayer(500));const E=t.Event.filter(g.onDidFilesChange,S=>S.affects(b));this._register(g.watch(b)),this._register(E(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async initializePolicies(b){await this.refresh()}async read(){const b=new Map;try{const g=await this.fileService.readFile(this.file),d=JSON.parse(g.value.toString());if(!(0,R.isObject)(d))throw new Error("Policy file isn't a JSON object");for(const E of Object.keys(d))this.policyDefinitions[E]&&b.set(E,d[E])}catch(g){g.fileOperationResult!==1&&this.logService.error("[FilePolicyService] Failed to read policies",g)}return b}async refresh(){const b=await this.read(),g=p(this.policies,b);this.policies=b,g.length>0&&this._onDidChange.fire(g)}};I=ve([J(1,D.IFileService),J(2,y.ILogService)],I),e.FilePolicyService=I}),define(Z[210],ee([0,1,3,2,39]),function(H,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class R{constructor(h){this.service=h,this.disposables=new t.DisposableStore}listen(h,p){switch(p){case"onDidChange":return v.Event.map(this.service.onDidChange,I=>I.reduce((C,b)=>({...C,[b]:this.service.getPolicyValue(b)??null}),{}),this.disposables)}throw new Error(`Event not found: ${p}`)}call(h,p,I){switch(p){case"registerPolicyDefinitions":return this.service.registerPolicyDefinitions(I)}throw new Error(`Call not found: ${p}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=R;class D extends k.AbstractPolicyService{constructor(h,p){super();this.channel=p;for(const I in h){const{definition:C,value:b}=h[I];this.policyDefinitions[I]=C,b!==void 0&&this.policies.set(I,b)}this.channel.listen("onDidChange")(I=>{for(const C in I){const b=I[C];b===null?this.policies.delete(C):this.policies.set(C,b)}this._onDidChange.fire(Object.keys(I))})}async initializePolicies(h){const p=await this.channel.call("registerPolicyDefinitions",h);for(const I in p)this.policies.set(I,p[I])}}e.PolicyChannelClient=D}),define(Z[60],ee([0,1,13,4,35,16]),function(H,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let D;if(typeof t.globals.vscode!="undefined"&&typeof t.globals.vscode.context!="undefined"){const y=t.globals.vscode.context.configuration();if(y)D=y.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof H?.__$__nodeRequire=="function"){const y=(0,R.dirname)(v.FileAccess.asFileUri("",H));D=H.__$__nodeRequire((0,R.joinPath)(y,"product.json").fsPath);const h=H.__$__nodeRequire((0,R.joinPath)(y,"package.json").fsPath);k.env.VSCODE_DEV&&Object.assign(D,{nameShort:`${D.nameShort} Dev`,nameLong:`${D.nameLong} Dev`,dataFolderName:`${D.dataFolderName}-dev`,serverDataFolderName:D.serverDataFolderName?`${D.serverDataFolderName}-dev`:void 0}),Object.assign(D,{version:h.version})}else D={},Object.keys(D).length===0&&Object.assign(D,{version:"1.67.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=D}),define(Z[20],ee([0,1,5]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,v.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(Z[211],ee([0,1,76,6,20]),function(H,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let R=class{constructor(y,h){this.productService=y,this.logService=h,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(y,h){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const p=/^(.*)#([^#]+)$/.exec(h);if(!p)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",h),!1;const[,I,C]=p;let b=this.trustedExtensionUrlPublicKeys.get(y);if(!b){if(b=this.productService.trustedExtensionUrlPublicKeys[y],!b||b.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",y),!1;this.trustedExtensionUrlPublicKeys.set(y,[...b])}const g=Buffer.from(decodeURIComponent(C),"base64");if(g.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",h),!1;const d=g.slice(0,6),E=g.readUIntBE(0,6),S=Date.now()-E;if(S<0||S>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",h),!1;const f=g.slice(6),w=v.createVerify("SHA256");w.write(d),w.write(Buffer.from(I)),w.end();for(let m=0;m<b.length;m++){let u=b[m];if(u!==null){if(typeof u=="string")try{u=v.createPublicKey({key:Buffer.from(u,"base64"),format:"der",type:"spki"}),b[m]=u}catch(c){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${m+1} for ${y}:`,c),b[m]=null;continue}if(w.verify(u,f))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",h),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",h),!1}};R=ve([J(0,k.IProductService),J(1,t.ILogService)],R),e.ExtensionUrlTrustService=R}),define(Z[61],ee([0,1,5]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,v.createDecorator)("protocolMainService")}),define(Z[45],ee([0,1,120,12]),function(H,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.data=new Map}add(D,y){v.ok(t.isString(D)),v.ok(t.isObject(y)),v.ok(!this.data.has(D),"There is already an extension with this id"),this.data.set(D,y)}knows(D){return this.data.has(D)}as(D){return this.data.get(D)||null}}e.Registry=new k}),define(Z[212],ee([0,1,3,45]),function(H,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(y){return y.length>0&&y.charAt(y.length-1)==="#"?y.substring(0,y.length-1):y}class R{constructor(){this._onDidChangeSchema=new v.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(h,p){this.schemasById[k(h)]=p,this._onDidChangeSchema.fire(h)}notifySchemaChanged(h){this._onDidChangeSchema.fire(h)}getSchemaContributions(){return{schemas:this.schemasById}}}const D=new R;t.Registry.add(e.Extensions.JSONContribution,D)}),define(Z[62],ee([0,1,24,3,12,150,19,212,45]),function(H,e,v,t,k,R,D,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var p;(function(c){c.Multiline="multilineText",c.Singleline="singlelineText"})(p=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var I;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.MACHINE=2]="MACHINE",c[c.WINDOW=3]="WINDOW",c[c.RESOURCE=4]="RESOURCE",c[c.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",c[c.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const C=h.Registry.as(y.Extensions.JSONContribution);class b{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(s,r=!0){this.registerConfigurations([s],r)}registerConfigurations(s,r=!0){const i=this.doRegisterConfigurations(s,r);C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i})}deregisterConfigurations(s){const r=this.doDeregisterConfigurations(s);C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}updateConfigurations({add:s,remove:r}){const i=[];i.push(...this.doDeregisterConfigurations(r)),i.push(...this.doRegisterConfigurations(s,!1)),C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,v.distinct)(i)})}registerDefaultConfigurations(s){const r=[],i=[];for(const{overrides:n,source:o}of s)for(const a in n)if(r.push(a),e.OVERRIDE_PROPERTY_REGEX.test(a)){const l=this.configurationDefaultsOverrides.get(a),P=l?.valuesSources??new Map;if(o)for(const U of Object.keys(n[a]))P.set(U,o);const M={...l?.value||{},...n[a]};this.configurationDefaultsOverrides.set(a,{source:o,value:M,valuesSources:P});const T=(0,D.getLanguageTagSettingPlainKey)(a),F={type:"object",default:M,description:R.localize(1,null,T),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:M,source:k.isString(o)?void 0:o,defaultValueSource:o};i.push(...E(a)),this.configurationProperties[a]=F,this.defaultLanguageConfigurationOverridesNode.properties[a]=F}else{this.configurationDefaultsOverrides.set(a,{value:n[a],source:o});const l=this.configurationProperties[a];l&&(this.updatePropertyDefaultValue(a,l),this.updateSchema(a,l))}this.registerOverrideIdentifiers(i),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}deregisterDefaultConfigurations(s){const r=[];for(const{overrides:i,source:n}of s)for(const o in i){const a=this.configurationDefaultsOverrides.get(o),l=k.isString(n)?n:n?.id,P=k.isString(a?.source)?a?.source:a?.source?.id;if(l===P)if(r.push(o),this.configurationDefaultsOverrides.delete(o),e.OVERRIDE_PROPERTY_REGEX.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const M=this.configurationProperties[o];M&&(this.updatePropertyDefaultValue(o,M),this.updateSchema(o,M))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...s){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(s){for(const r of s)this.overrideIdentifiers.add(r);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(s,r){const i=[];return s.forEach(n=>{i.push(...this.validateAndRegisterProperties(n,r,n.extensionInfo,n.restrictedProperties)),this.configurationContributors.push(n),this.registerJSONConfiguration(n)}),i}doDeregisterConfigurations(s){const r=[],i=n=>{if(n.properties)for(const o in n.properties){r.push(o);const a=this.configurationProperties[o];a?.policy?.name&&this.policyConfigurations.delete(a.policy.name),delete this.configurationProperties[o],this.removeFromSchema(o,n.properties[o])}n.allOf?.forEach(o=>i(o))};for(const n of s){i(n);const o=this.configurationContributors.indexOf(n);o!==-1&&this.configurationContributors.splice(o,1)}return r}validateAndRegisterProperties(s,r=!0,i,n,o=3){o=k.isUndefinedOrNull(s.scope)?o:s.scope;const a=[],l=s.properties;if(l)for(const M in l){const T=l[M];if(r&&m(M,T)){delete l[M];continue}if(T.source=i,T.defaultDefaultValue=l[M].default,this.updatePropertyDefaultValue(M,T),e.OVERRIDE_PROPERTY_REGEX.test(M)?T.scope=void 0:(T.scope=k.isUndefinedOrNull(T.scope)?o:T.scope,T.restricted=k.isUndefinedOrNull(T.restricted)?!!n?.includes(M):T.restricted),l[M].hasOwnProperty("included")&&!l[M].included){this.excludedConfigurationProperties[M]=l[M],delete l[M];continue}else this.configurationProperties[M]=l[M],l[M].policy?.name&&this.policyConfigurations.set(l[M].policy.name,M);!l[M].deprecationMessage&&l[M].markdownDeprecationMessage&&(l[M].deprecationMessage=l[M].markdownDeprecationMessage),a.push(M)}const P=s.allOf;if(P)for(const M of P)a.push(...this.validateAndRegisterProperties(M,r,i,n,o));return a}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(s){const r=i=>{const n=i.properties;if(n)for(const a in n)this.updateSchema(a,n[a]);i.allOf?.forEach(r)};r(s)}updateSchema(s,r){switch(e.allSettings.properties[s]=r,r.scope){case 1:e.applicationSettings.properties[s]=r;break;case 2:e.machineSettings.properties[s]=r;break;case 6:e.machineOverridableSettings.properties[s]=r;break;case 3:e.windowSettings.properties[s]=r;break;case 4:e.resourceSettings.properties[s]=r;break;case 5:e.resourceSettings.properties[s]=r,this.resourceLanguageSettingsSchema.properties[s]=r;break}}removeFromSchema(s,r){switch(delete e.allSettings.properties[s],r.scope){case 1:delete e.applicationSettings.properties[s];break;case 2:delete e.machineSettings.properties[s];break;case 6:delete e.machineOverridableSettings.properties[s];break;case 3:delete e.windowSettings.properties[s];break;case 4:case 5:delete e.resourceSettings.properties[s],delete this.resourceLanguageSettingsSchema.properties[s];break}}updateOverridePropertyPatternKey(){for(const s of this.overrideIdentifiers.values()){const r=`[${s}]`,i={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(r,i),e.allSettings.properties[r]=i,e.applicationSettings.properties[r]=i,e.machineSettings.properties[r]=i,e.machineOverridableSettings.properties[r]=i,e.windowSettings.properties[r]=i,e.resourceSettings.properties[r]=i}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const s={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(s,r){const i=this.configurationDefaultsOverrides.get(s);let n=i?.value,o=i?.source;k.isUndefined(n)&&(n=r.defaultDefaultValue,o=void 0),k.isUndefined(n)&&(n=f(r.type)),r.default=n,r.defaultValueSource=o}}const g="\\[([^\\]]+)\\]",d=new RegExp(g,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${g})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function E(c){const s=[];if(e.OVERRIDE_PROPERTY_REGEX.test(c)){let r=d.exec(c);for(;r?.length;){const i=r[1].trim();i&&s.push(i),r=d.exec(c)}}return(0,v.distinct)(s)}e.overrideIdentifiersFromKey=E;function S(c){return c.reduce((s,r)=>`${s}[${r}]`,"")}e.keyFromOverrideIdentifiers=S;function f(c){switch(Array.isArray(c)?c[0]:c){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=f;const w=new b;h.Registry.add(e.Extensions.Configuration,w);function m(c,s){return c.trim()?e.OVERRIDE_PROPERTY_REGEX.test(c)?R.localize(7,null,c):w.getConfigurationProperties()[c]!==void 0?R.localize(8,null,c):s.policy?.name&&w.getPolicyConfigurations().get(s.policy?.name)!==void 0?R.localize(9,null,c,s.policy?.name,w.getPolicyConfigurations().get(s.policy?.name)):null:R.localize(6,null)}e.validateProperty=m;function u(){const c=[],s=w.getConfigurationProperties();for(const r of Object.keys(s))c.push([r,s[r].scope]);return c.push(["launch",4]),c.push(["task",4]),c}e.getScopes=u}),define(Z[107],ee([0,1,24,3,42,2,32,49,12,7,19,62,45]),function(H,e,v,t,k,R,D,y,h,p,I,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class g{constructor(r={},i=[],n=[]){this._contents=r,this._keys=i,this._overrides=n,this.frozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(r){return r?(0,I.getConfigurationValue)(this.contents,r):this.contents}getOverrideValue(r,i){const n=this.getContentsForOverrideIdentifer(i);return n?r?(0,I.getConfigurationValue)(n,r):n:void 0}getKeysForOverrideIdentifier(r){const i=[];for(const n of this.overrides)n.identifiers.includes(r)&&i.push(...n.keys);return v.distinct(i)}getAllOverrideIdentifiers(){const r=[];for(const i of this.overrides)r.push(...i.identifiers);return v.distinct(r)}override(r){let i=this.overrideConfigurations.get(r);return i||(i=this.createOverrideConfigurationModel(r),this.overrideConfigurations.set(r,i)),i}merge(...r){const i=y.deepClone(this.contents),n=y.deepClone(this.overrides),o=[...this.keys];for(const a of r)if(!a.isEmpty()){this.mergeContents(i,a.contents);for(const l of a.overrides){const[P]=n.filter(M=>v.equals(M.identifiers,l.identifiers));P?(this.mergeContents(P.contents,l.contents),P.keys.push(...l.keys),P.keys=v.distinct(P.keys)):n.push(y.deepClone(l))}for(const l of a.keys)o.indexOf(l)===-1&&o.push(l)}return new g(i,o,n)}freeze(){return this.frozen=!0,this}clone(){return new g(y.deepClone(this.contents),[...this.keys],y.deepClone(this.overrides))}createOverrideConfigurationModel(r){const i=this.getContentsForOverrideIdentifer(r);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const n={};for(const o of v.distinct([...Object.keys(this.contents),...Object.keys(i)])){let a=this.contents[o];const l=i[o];l&&(typeof a=="object"&&typeof l=="object"?(a=y.deepClone(a),this.mergeContents(a,l)):a=l),n[o]=a}return new g(n,this.keys,this.overrides)}mergeContents(r,i){for(const n of Object.keys(i)){if(n in r&&h.isObject(r[n])&&h.isObject(i[n])){this.mergeContents(r[n],i[n]);continue}r[n]=y.deepClone(i[n])}}checkAndFreeze(r){return this.frozen&&!Object.isFrozen(r)?y.deepFreeze(r):r}getContentsForOverrideIdentifer(r){let i=null,n=null;const o=a=>{a&&(n?this.mergeContents(n,a):n=y.deepClone(a))};for(const a of this.overrides)v.equals(a.identifiers,[r])?i=a.contents:a.identifiers.includes(r)&&o(a.contents);return o(i),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,i){this.addKey(r),(0,I.addToValueTree)(this.contents,r,i,n=>{throw new Error(n)})}removeValue(r){this.removeKey(r)&&(0,I.removeFromValueTree)(this.contents,r)}addKey(r){let i=this.keys.length;for(let n=0;n<i;n++)r.indexOf(this.keys[n])===0&&(i=n);this.keys.splice(i,1,r)}removeKey(r){const i=this.keys.indexOf(r);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=g;class d{constructor(r){this._name=r,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new g}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(r,i){if(!h.isUndefinedOrNull(r)){const n=this.doParseContent(r);this.parseRaw(n,i)}}reparse(r){this._raw&&this.parseRaw(this._raw,r)}parseRaw(r,i){this._raw=r;const{contents:n,keys:o,overrides:a,restricted:l}=this.doParseRaw(r,i);this._configurationModel=new g(n,o,a),this._restrictedConfigurations=l||[]}doParseContent(r){let i={},n=null,o=[];const a=[],l=[];function P(T){Array.isArray(o)?o.push(T):n!==null&&(o[n]=T)}const M={onObjectBegin:()=>{const T={};P(T),a.push(o),o=T,n=null},onObjectProperty:T=>{n=T},onObjectEnd:()=>{o=a.pop()},onArrayBegin:()=>{const T=[];P(T),a.push(o),o=T,n=null},onArrayEnd:()=>{o=a.pop()},onLiteralValue:P,onError:(T,F,U)=>{l.push({error:T,offset:F,length:U})}};if(r)try{k.visit(r,M),i=o[0]||{}}catch(T){console.error(`Error while parsing settings file ${this._name}: ${T}`),this._parseErrors=[T]}return i}doParseRaw(r,i){const n=b.Registry.as(C.Extensions.Configuration).getConfigurationProperties(),o=this.filter(r,n,!0,i);r=o.raw;const a=(0,I.toValuesTree)(r,M=>console.error(`Conflict in settings file ${this._name}: ${M}`)),l=Object.keys(r),P=this.toOverrides(r,M=>console.error(`Conflict in settings file ${this._name}: ${M}`));return{contents:a,keys:l,overrides:P,restricted:o.restricted}}filter(r,i,n,o){if(!o?.scopes&&!o?.skipRestricted)return{raw:r,restricted:[]};const a={},l=[];for(const P in r)if(C.OVERRIDE_PROPERTY_REGEX.test(P)&&n){const M=this.filter(r[P],i,!1,o);a[P]=M.raw,l.push(...M.restricted)}else{const M=i[P],T=M?typeof M.scope!="undefined"?M.scope:3:void 0;M?.restricted&&l.push(P),(T===void 0||o.scopes===void 0||o.scopes.includes(T))&&(o.skipRestricted&&M?.restricted||(a[P]=r[P]))}return{raw:a,restricted:l}}toOverrides(r,i){const n=[];for(const o of Object.keys(r))if(C.OVERRIDE_PROPERTY_REGEX.test(o)){const a={};for(const l in r[o])a[l]=r[o][l];n.push({identifiers:(0,C.overrideIdentifiersFromKey)(o),keys:Object.keys(a),contents:(0,I.toValuesTree)(a,i)})}return n}}e.ConfigurationModelParser=d;class E extends R.Disposable{constructor(r,i,n,o){super();this.userSettingsResource=r,this.scopes=i,this.fileService=o,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new d(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.any(t.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource)),t.Event.filter(this.fileService.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(3)||a.isOperation(1)||a.isOperation(4))&&n.isEqual(a.resource,r)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const r=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(r.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new g}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=E;class S{constructor(r,i,n,o,a=new g,l=new g,P=new D.ResourceMap,M=new g,T=new D.ResourceMap,F=!0){this._defaultConfiguration=r,this._policyConfiguration=i,this._applicationConfiguration=n,this._localUserConfiguration=o,this._remoteUserConfiguration=a,this._workspaceConfiguration=l,this._folderConfigurations=P,this._memoryConfiguration=M,this._memoryConfigurationByResource=T,this._freeze=F,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new D.ResourceMap,this._userConfiguration=null}getValue(r,i,n){return this.getConsolidatedConfigurationModel(r,i,n).getValue(r)}updateValue(r,i,n={}){let o;n.resource?(o=this._memoryConfigurationByResource.get(n.resource),o||(o=new g,this._memoryConfigurationByResource.set(n.resource,o))):o=this._memoryConfiguration,i===void 0?o.removeValue(r):o.setValue(r,i),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(r,i,n){const o=this.getConsolidatedConfigurationModel(r,i,n),a=this.getFolderConfigurationModelForResource(i.resource,n),l=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,P=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this._defaultConfiguration.freeze().getValue(r),M=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().getValue(r),T=this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze().getValue(r),F=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.userConfiguration.freeze().getValue(r),U=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.localUserConfiguration.freeze().getValue(r),Q=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.remoteUserConfiguration.freeze().getValue(r),re=n?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this._workspaceConfiguration.freeze().getValue(r):void 0,ue=a?i.overrideIdentifier?a.freeze().override(i.overrideIdentifier).getValue(r):a.freeze().getValue(r):void 0,fe=i.overrideIdentifier?l.override(i.overrideIdentifier).getValue(r):l.getValue(r),se=o.getValue(r),le=v.distinct(o.overrides.map(K=>K.identifiers).flat()).filter(K=>o.getOverrideValue(r,K)!==void 0);return{defaultValue:P,policyValue:M,applicationValue:T,userValue:F,userLocalValue:U,userRemoteValue:Q,workspaceValue:re,workspaceFolderValue:ue,memoryValue:fe,value:se,default:P!==void 0?{value:this._defaultConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,policy:M!==void 0?{value:M}:void 0,application:T!==void 0?{value:T,override:i.overrideIdentifier?this.applicationConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,user:F!==void 0?{value:this.userConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,userLocal:U!==void 0?{value:this.localUserConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,userRemote:Q!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,workspace:re!==void 0?{value:this._workspaceConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,workspaceFolder:ue!==void 0?{value:a?.freeze().getValue(r),override:i.overrideIdentifier?a?.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,memory:fe!==void 0?{value:l.getValue(r),override:i.overrideIdentifier?l.getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:le.length?le:void 0}}keys(r){const i=this.getFolderConfigurationModelForResource(void 0,r);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(r){this._defaultConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(r){this._policyConfiguration=r}updateApplicationConfiguration(r){this._applicationConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(r){this._localUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(r){this._remoteUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(r){this._workspaceConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(r,i){this._folderConfigurations.set(r,i),this._foldersConsolidatedConfigurations.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this._foldersConsolidatedConfigurations.delete(r)}compareAndUpdateDefaultConfiguration(r,i){const n=[];if(!i){const{added:o,updated:a,removed:l}=u(this._defaultConfiguration,r);i=[...o,...a,...l]}for(const o of i)for(const a of(0,C.overrideIdentifiersFromKey)(o)){const l=this._defaultConfiguration.getKeysForOverrideIdentifier(a),P=r.getKeysForOverrideIdentifier(a),M=[...P.filter(T=>l.indexOf(T)===-1),...l.filter(T=>P.indexOf(T)===-1),...l.filter(T=>!y.equals(this._defaultConfiguration.override(a).getValue(T),r.override(a).getValue(T)))];n.push([a,M])}return this.updateDefaultConfiguration(r),{keys:i,overrides:n}}compareAndUpdatePolicyConfiguration(r){const{added:i,updated:n,removed:o}=u(this._policyConfiguration,r),a=[...i,...n,...o];return a.length&&this.updatePolicyConfiguration(r),{keys:a,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:i,updated:n,removed:o,overrides:a}=u(this.applicationConfiguration,r),l=[...i,...n,...o];return l.length&&this.updateApplicationConfiguration(r),{keys:l,overrides:a}}compareAndUpdateLocalUserConfiguration(r){const{added:i,updated:n,removed:o,overrides:a}=u(this.localUserConfiguration,r),l=[...i,...n,...o];return l.length&&this.updateLocalUserConfiguration(r),{keys:l,overrides:a}}compareAndUpdateRemoteUserConfiguration(r){const{added:i,updated:n,removed:o,overrides:a}=u(this.remoteUserConfiguration,r),l=[...i,...n,...o];return l.length&&this.updateRemoteUserConfiguration(r),{keys:l,overrides:a}}compareAndUpdateWorkspaceConfiguration(r){const{added:i,updated:n,removed:o,overrides:a}=u(this.workspaceConfiguration,r),l=[...i,...n,...o];return l.length&&this.updateWorkspaceConfiguration(r),{keys:l,overrides:a}}compareAndUpdateFolderConfiguration(r,i){const n=this.folderConfigurations.get(r),{added:o,updated:a,removed:l,overrides:P}=u(n,i),M=[...o,...a,...l];return(M.length||!n)&&this.updateFolderConfiguration(r,i),{keys:M,overrides:P}}compareAndDeleteFolderConfiguration(r){const i=this.folderConfigurations.get(r);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:n,updated:o,removed:a,overrides:l}=u(i,void 0);return{keys:[...n,...o,...a],overrides:l}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(r,i,n){let o=this.getConsolidatedConfigurationModelForResource(i,n);return i.overrideIdentifier&&(o=o.override(i.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(r)!==void 0&&(o=o.merge(this._policyConfiguration)),o}getConsolidatedConfigurationModelForResource({resource:r},i){let n=this.getWorkspaceConsolidatedConfiguration();if(i&&r){const o=i.getFolder(r);o&&(n=this.getFolderConsolidatedConfiguration(o.uri)||n);const a=this._memoryConfigurationByResource.get(r);a&&(n=n.merge(a))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(r){let i=this._foldersConsolidatedConfigurations.get(r);if(!i){const n=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(r);o?(i=n.merge(o),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(r,i)):i=n}return i}getFolderConfigurationModelForResource(r,i){if(i&&r){const n=i.getFolder(r);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((r,i)=>{const{contents:n,overrides:o,keys:a}=this._folderConfigurations.get(i);return r.push([i,{contents:n,overrides:o,keys:a}]),r},[])}}allKeys(){const r=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>r.add(i)),this.userConfiguration.freeze().keys.forEach(i=>r.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(n=>r.add(n))),[...r.values()]}allOverrideIdentifiers(){const r=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(n=>r.add(n))),[...r.values()]}getAllKeysForOverrideIdentifier(r){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(r).forEach(o=>i.add(o))),[...i.values()]}static parse(r){const i=this.parseConfigurationModel(r.defaults),n=this.parseConfigurationModel(r.policy),o=this.parseConfigurationModel(r.application),a=this.parseConfigurationModel(r.user),l=this.parseConfigurationModel(r.workspace),P=r.folders.reduce((M,T)=>(M.set(p.URI.revive(T[0]),this.parseConfigurationModel(T[1])),M),new D.ResourceMap);return new S(i,n,o,a,new g,l,P,new g,new D.ResourceMap,!1)}static parseConfigurationModel(r){return new g(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=S;function f(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const r=new Set,i=new Map;for(const o of s)o.keys.forEach(a=>r.add(a)),o.overrides.forEach(([a,l])=>{const P=(0,D.getOrSet)(i,a,new Set);l.forEach(M=>P.add(M))});const n=[];return i.forEach((o,a)=>n.push([a,[...o.values()]])),{keys:[...r.values()],overrides:n}}e.mergeChanges=f;class w{constructor(r,i,n,o){this.change=r,this.previous=i,this.currentConfiguraiton=n,this.currentWorkspace=o,this._previousConfiguration=void 0;const a=new Set;r.keys.forEach(P=>a.add(P)),r.overrides.forEach(([,P])=>P.forEach(M=>a.add(M))),this.affectedKeys=[...a.values()];const l=new g;this.affectedKeys.forEach(P=>l.setValue(P,{})),this.affectedKeysTree=l.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=S.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(r,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,r)){if(i){const n=this.previousConfiguration?this.previousConfiguration.getValue(r,i,this.previous?.workspace):void 0,o=this.currentConfiguraiton.getValue(r,i,this.currentWorkspace);return!y.equals(n,o)}return!0}return!1}doesAffectedKeysTreeContains(r,i){let n=(0,I.toValuesTree)({[i]:!0},()=>{}),o;for(;typeof n=="object"&&(o=Object.keys(n)[0]);){if(r=r[o],!r)return!1;n=n[o]}return!0}}e.ConfigurationChangeEvent=w;class m extends w{constructor(r,i,n,o){super({keys:r.allKeys(),overrides:[]},void 0,r,i);this.source=n,this.sourceConfig=o}}e.AllKeysConfigurationChangeEvent=m;function u(s,r){const{added:i,removed:n,updated:o}=c(r,s),a=[],l=s?.getAllOverrideIdentifiers()||[],P=r?.getAllOverrideIdentifiers()||[];if(r){const M=P.filter(T=>!l.includes(T));for(const T of M)a.push([T,r.getKeysForOverrideIdentifier(T)])}if(s){const M=l.filter(T=>!P.includes(T));for(const T of M)a.push([T,s.getKeysForOverrideIdentifier(T)])}if(r&&s){for(const M of l)if(P.includes(M)){const T=c({contents:s.getOverrideValue(void 0,M)||{},keys:s.getKeysForOverrideIdentifier(M)},{contents:r.getOverrideValue(void 0,M)||{},keys:r.getKeysForOverrideIdentifier(M)});a.push([M,[...T.added,...T.removed,...T.updated]])}}return{added:i,removed:n,updated:o,overrides:a}}function c(s,r){const i=s?r?s.keys.filter(a=>r.keys.indexOf(a)===-1):[...s.keys]:[],n=r?s?r.keys.filter(a=>s.keys.indexOf(a)===-1):[...r.keys]:[],o=[];if(s&&r){for(const a of r.keys)if(s.keys.indexOf(a)!==-1){const l=(0,I.getConfigurationValue)(r.contents,a),P=(0,I.getConfigurationValue)(s.contents,a);y.equals(l,P)||o.push(a)}}return{added:i,removed:n,updated:o}}}),define(Z[213],ee([0,1,24,3,2,49,12,19,107,62,6,39,45]),function(H,e,v,t,k,R,D,y,h,p,I,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class g extends k.Disposable{constructor(){super(...arguments);this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event}get configurationModel(){return this._configurationModel||(this._configurationModel=new d(this.getConfigurationDefaultOverrides())),this._configurationModel}async initialize(){return this._configurationModel=void 0,this._register(b.Registry.as(p.Extensions.Configuration).onDidUpdateConfiguration(({properties:w,defaultsOverrides:m})=>this.onDidUpdateConfiguration(w,m))),this.configurationModel}reload(){return this._configurationModel=void 0,this.configurationModel}onDidUpdateConfiguration(w,m){this._configurationModel=void 0,this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:w})}getConfigurationDefaultOverrides(){return{}}}e.DefaultConfiguration=g;class d extends h.ConfigurationModel{constructor(w={}){const m=b.Registry.as(p.Extensions.Configuration).getConfigurationProperties(),u=Object.keys(m),c=Object.create(null),s=[];for(const r in m){const i=w[r],n=i!==void 0?i:m[r].default;(0,y.addToValueTree)(c,r,n,o=>console.error(`Conflict in default settings: ${o}`))}for(const r of Object.keys(c))p.OVERRIDE_PROPERTY_REGEX.test(r)&&s.push({identifiers:(0,p.overrideIdentifiersFromKey)(r),keys:Object.keys(c[r]),contents:(0,y.toValuesTree)(c[r],i=>console.error(`Conflict in default settings file: ${i}`))});super(c,u,s)}}e.DefaultConfigurationModel=d;class E{constructor(){this.onDidChangeConfiguration=t.Event.None,this.configurationModel=new h.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=E;let S=class extends k.Disposable{constructor(w,m,u){super();this.defaultConfiguration=w,this.policyService=m,this.logService=u,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new h.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.update(await this.registerPolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(w=>this.onDidChangePolicies(w))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:w})=>this.update(await this.registerPolicyDefinitions(w),!0))),this._configurationModel}async registerPolicyDefinitions(w){const m={},u=[],c=b.Registry.as(p.Extensions.Configuration).getConfigurationProperties();for(const s of w){const r=c[s];if(!r){u.push(s);continue}if(r.policy){if(r.type!=="string"&&r.type!=="number"){this.logService.warn(`Policy ${r.policy.name} has unsupported type ${r.type}`);continue}u.push(s),m[r.policy.name]={type:r.type}}}return(0,D.isEmptyObject)(m)||await this.policyService.registerPolicyDefinitions(m),u}onDidChangePolicies(w){const m=b.Registry.as(p.Extensions.Configuration).getPolicyConfigurations(),u=(0,v.coalesce)(w.map(c=>m.get(c)));this.update(u,!0)}update(w,m){const u=b.Registry.as(p.Extensions.Configuration).getConfigurationProperties(),c=[],s=this._configurationModel.isEmpty();for(const r of w){const i=u[r]?.policy?.name;if(i){const n=this.policyService.getPolicyValue(i);(s?n!==void 0:!(0,R.equals)(this._configurationModel.getValue(r),n))&&c.push([r,n])}else this._configurationModel.getValue(r)!==void 0&&c.push([r,void 0])}if(c.length){const r=this._configurationModel;this._configurationModel=new h.ConfigurationModel;for(const i of r.keys)this._configurationModel.setValue(i,r.getValue(i));for(const[i,n]of c)n===void 0?this._configurationModel.removeValue(i):this._configurationModel.setValue(i,n);m&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};S=ve([J(1,C.IPolicyService),J(2,I.ILogService)],S),e.PolicyConfiguration=S}),define(Z[214],ee([0,1,8,3,2,16,19,107,213,39]),function(H,e,v,t,k,R,D,y,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class I extends k.Disposable{constructor(b,g,d,E){super();this.settingsResource=b,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new h.DefaultConfiguration),this.policyConfiguration=d instanceof p.NullPolicyService?new h.NullPolicyConfiguration:this._register(new h.PolicyConfiguration(this.defaultConfiguration,d,E)),this.userConfiguration=this._register(new y.UserSettings(this.settingsResource,void 0,R.extUriBiasedIgnorePathCase,g)),this.configuration=new y.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new y.ConfigurationModel,new y.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new v.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:S,properties:f})=>this.onDidDefaultConfigurationChange(S,f))),this._register(this.policyConfiguration.onDidChangeConfiguration(S=>this.onDidPolicyConfigurationChange(S))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[b,g,d]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new y.Configuration(b,g,new y.ConfigurationModel,d)}getConfigurationData(){return this.configuration.toData()}getValue(b,g){const d=typeof b=="string"?b:void 0,E=(0,D.isConfigurationOverrides)(b)?b:(0,D.isConfigurationOverrides)(g)?g:{};return this.configuration.getValue(d,E,void 0)}updateValue(b,g,d,E){return Promise.reject(new Error("not supported"))}inspect(b){return this.configuration.inspect(b,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const b=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(b)}onDidChangeUserConfiguration(b){const g=this.configuration.toData(),d=this.configuration.compareAndUpdateLocalUserConfiguration(b);this.trigger(d,g,2)}onDidDefaultConfigurationChange(b,g){const d=this.configuration.toData(),E=this.configuration.compareAndUpdateDefaultConfiguration(b,g);this.trigger(E,d,7)}onDidPolicyConfigurationChange(b){const g=this.configuration.toData(),d=this.configuration.compareAndUpdatePolicyConfiguration(b);this.trigger(d,g,7)}trigger(b,g,d){const E=new y.ConfigurationChangeEvent(b,{data:g},this.configuration);E.source=d,E.sourceConfig=this.getTargetConfiguration(d),this._onDidChangeConfiguration.fire(E)}getTargetConfiguration(b){switch(b){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=I}),define(Z[215],ee([0,1,18,5]),function(H,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var k;(function(D){D.Unknown="Unknown",D.NotAvailable="NotAvailable",D.TemporarilyNotAvailable="TemporarilyNotAvailable",D.NoResolverFound="NoResolverFound"})(k=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class R extends v.ErrorNoTelemetry{constructor(y,h=k.Unknown,p){super(y);this._message=y,this._code=h,this._detail=p,this.isHandled=h===k.NotAvailable&&p===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,R.prototype)}static isTemporarilyNotAvailable(y){return y instanceof R&&y._code===k.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof R&&y._code===k.NoResolverFound}static isHandled(y){return y instanceof R&&y.isHandled}}e.RemoteAuthorityResolverError=R}),define(Z[63],ee([0,1,13]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(p){return p.scheme===v.Schemas.vscodeRemote?p.authority:void 0}e.getRemoteAuthority=t;function k(p){if(!p)return;const I=p.indexOf("+");return I<0?p:p.substr(0,I)}e.getRemoteName=k;function R(p){return`/${p.quality??"oss"}-${p.commit??"dev"}`}e.getRemoteServerRootPath=R;function D(p){const{host:I,port:C}=h(p);if(typeof C=="undefined")throw new Error("Remote authority doesn't contain a port!");return{host:I,port:C}}e.parseAuthorityWithPort=D;function y(p,I){let{host:C,port:b}=h(p);return typeof b=="undefined"&&(b=I),{host:C,port:b}}e.parseAuthorityWithOptionalPort=y;function h(p){const I=p.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(I)return{host:I[1],port:parseInt(I[2],10)};const C=p.match(/^(\[[0-9a-z:]+\])$/);if(C)return{host:C[1],port:void 0};const b=p.match(/(.*):(\d+)$/);return b?{host:b[1],port:parseInt(b[2],10)}:{host:p,port:void 0}}}),define(Z[108],ee([0,1,26,5,63]),function(H,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}e.getWorkspaceSupportTypeMessage=R;function D(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=D,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var y;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(y=e.ExtensionType||(e.ExtensionType={}));var h;(function(d){d.WIN32_X64="win32-x64",d.WIN32_IA32="win32-ia32",d.WIN32_ARM64="win32-arm64",d.LINUX_X64="linux-x64",d.LINUX_ARM64="linux-arm64",d.LINUX_ARMHF="linux-armhf",d.ALPINE_X64="alpine-x64",d.ALPINE_ARM64="alpine-arm64",d.DARWIN_X64="darwin-x64",d.DARWIN_ARM64="darwin-arm64",d.WEB="web",d.UNIVERSAL="universal",d.UNKNOWN="unknown",d.UNDEFINED="undefined"})(h=e.TargetPlatform||(e.TargetPlatform={}));class p{constructor(E){this.value=E,this._lower=E.toLowerCase()}static equals(E,S){if(typeof E=="undefined"||E===null)return typeof S=="undefined"||S===null;if(typeof S=="undefined"||S===null)return!1;if(typeof E=="string"||typeof S=="string"){const f=typeof E=="string"?E:E.value,w=typeof S=="string"?S:S.value;return v.equalsIgnoreCase(f,w)}return E._lower===S._lower}static toKey(E){return typeof E=="string"?E.toLowerCase():E._lower}}e.ExtensionIdentifier=p;function I(d){return C(d)}e.isApplicationScopedExtension=I;function C(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}e.isLanguagePackExtension=C;function b(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=b;function g(d,E){if(E){const S=`onResolveRemoteAuthority:${(0,k.getRemoteName)(E)}`;return d.activationEvents?.indexOf(S)!==-1}return!1}e.isResolverExtension=g,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(Z[109],ee([0,1,26,190,108,4,7,18,35]),function(H,e,v,t,k,R,D,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function p(r,i){return r.uuid&&i.uuid?r.uuid===i.uuid:r.id===i.id?!0:(0,v.compareIgnoreCase)(r.id,i.id)===0}e.areSameExtensions=p;const I=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class C{constructor(i,n,o="undefined"){this.version=n,this.targetPlatform=o,this.id=i.id}static create(i){const n=i.manifest?i.manifest.version:i.version,o=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new C(i.identifier,n,o)}static parse(i){const n=I.exec(i);return n&&n[1]&&n[2]?new C({id:n[1]},n[2],n[4]||void 0):null}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof C?p(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.ExtensionKey=C;const b=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function g(r){const i=b.exec(r);return i&&i[1]?[E(i[1]),i[2]]:[E(r),void 0]}e.getIdAndVersion=g;function d(r,i){return`${r}.${i}`}e.getExtensionId=d;function E(r){return r.toLocaleLowerCase()}e.adoptToGalleryExtensionId=E;function S(r,i){return E(d(r,i))}e.getGalleryExtensionId=S;function f(r,i){const n=[],o=a=>{for(const l of n)if(l.some(P=>p(i(P),i(a))))return l;return null};for(const a of r){const l=o(a);l?l.push(a):n.push([a])}return n}e.groupByExtension=f;function w(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=w;function m(r){return{id:r.identifier.id,name:r.name,galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),...r.telemetryData}}e.getGalleryExtensionTelemetryData=m,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function u(r,i){const n=[],o=i.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const a=o.shift();if(a&&n.every(l=>!p(l.identifier,{id:a}))){const l=r.filter(P=>p(P.identifier,{id:a}));l.length===1&&(n.push(l[0]),o.push(...l[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.getExtensionDependencies=u;async function c(r,i){if(!R.isLinux)return!1;let n;try{n=(await r.readFile(D.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await r.readFile(D.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){i.debug("Error while getting the os-release file.",(0,y.getErrorMessage)(a))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=c;async function s(r,i){const n=await c(r,i),o=(0,t.getTargetPlatform)(n?"alpine":R.platform,h.arch);return i.debug("ComputeTargetPlatform:",o),o}e.computeTargetPlatform=s}),define(Z[72],ee([0,1,8,17,2,32,7,109,14,5,6]),function(H,e,v,t,k,R,D,y,h,p,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=e.IExtensionsProfileScannerService=void 0,e.IExtensionsProfileScannerService=(0,p.createDecorator)("IExtensionsProfileScannerService");let C=class extends k.Disposable{constructor(g,d){super();this.fileService=g,this.logService=d,this.resourcesAccessQueueMap=new R.ResourceMap}scanProfileExtensions(g){return this.withProfileExtensions(g)}addExtensionsToProfile(g,d){return this.withProfileExtensions(d,E=>(E=E.filter(S=>g.some(([f])=>!(0,y.areSameExtensions)(S.identifier,f.identifier))),E.push(...g.map(([S,f])=>({identifier:S.identifier,version:S.manifest.version,location:S.location,metadata:f}))),E))}removeExtensionFromProfile(g,d){return this.withProfileExtensions(d,E=>E.filter(S=>!(0,y.areSameExtensions)(S.identifier,g)))}async withProfileExtensions(g,d){return this.getResourceAccessQueue(g).queue(async()=>{let E=[];try{const S=await this.fileService.readFile(g),f=JSON.parse(S.value.toString());for(const w of f){if(!w.identifier){this.logService.info("Ignoring invalid extension while scanning. Identifier does not exist.",w);continue}if(!w.location){this.logService.info("Ignoring invalid extension while scanning. Location does not exist.",w);continue}if(!w.version){this.logService.info("Ignoring invalid extension while scanning. Version does not exist.",w);continue}E.push({identifier:w.identifier,location:D.URI.revive(w.location),version:w.version,metadata:w.metadata})}}catch(S){S.fileOperationResult!==1&&this.logService.error(S)}if(d){E=d(E);const S=E.map(f=>({identifier:f.identifier,version:f.version,location:f.location.toJSON(),metadata:f.metadata}));await this.fileService.writeFile(g,t.VSBuffer.fromString(JSON.stringify(S)))}return E})}getResourceAccessQueue(g){let d=this.resourcesAccessQueueMap.get(g);return d||(d=new v.Queue,this.resourcesAccessQueueMap.set(g,d)),d}};C=ve([J(0,h.IFileService),J(1,I.ILogService)],C),e.ExtensionsProfileScannerService=C}),define(Z[216],ee([0,1,8,17,21,18,3,2,28,98,215,63]),function(H,e,v,t,k,R,D,y,h,p,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const b=30*1e3;var g;(function(z){z[z.Management=1]="Management",z[z.ExtensionHost=2]="ExtensionHost",z[z.Tunnel=3]="Tunnel"})(g=e.ConnectionType||(e.ConnectionType={}));function d(z){switch(z){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function E(z){const j=new k.CancellationTokenSource;return setTimeout(()=>j.cancel(),z),j.token}function S(z,j){if(z.isCancellationRequested||j.isCancellationRequested)return k.CancellationToken.Cancelled;const L=new k.CancellationTokenSource;return z.onCancellationRequested(()=>L.cancel()),j.onCancellationRequested(()=>L.cancel()),L.token}class f{constructor(j){this._state="pending",this._disposables=new y.DisposableStore,this.promise=new Promise((L,O)=>{this._resolvePromise=L,this._rejectPromise=O}),j.isCancellationRequested?this._timeout():this._disposables.add(j.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(j){this._state==="pending"?this._disposables.add(j):j.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const j=new Error("Time limit reached");return j.code="ETIMEDOUT",j.syscall="connect",j}resolve(j){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(j))}reject(j){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(j))}}function w(z,j){const L=new f(j);return L.registerDisposable(z.onControlMessage(O=>{const B=JSON.parse(O.toString()),V=_(B);V?L.reject(V):L.resolve(B)})),L.promise}function m(z,j,L,O,B,V,x,ie){const q=new f(ie);return j.connect(L,O,B,V,x,(te,ne)=>{q.didTimeout?(te&&z.error(te),ne?.dispose()):te||!ne?q.reject(te):q.resolve(ne)}),q.promise}function u(z,j){const L=new f(j);return z.then(O=>{L.didTimeout||L.resolve(O)},O=>{L.didTimeout||L.reject(O)}),L.promise}async function c(z,j,L,O){const B=$(z,j);z.logService.trace(`${B} 1/6. invoking socketFactory.connect().`);let V;try{V=await m(z.logService,z.socketFactory,z.host,z.port,(0,C.getRemoteServerRootPath)(z),`reconnectionToken=${z.reconnectionToken}&reconnection=${z.reconnectionProtocol?"true":"false"}`,`renderer-${d(j)}-${z.reconnectionToken}`,O)}catch(ne){throw z.logService.error(`${B} socketFactory.connect() failed or timed out. Error:`),z.logService.error(ne),ne}z.logService.trace(`${B} 2/6. socketFactory.connect() was successful.`);let x,ie;z.reconnectionProtocol?(z.reconnectionProtocol.beginAcceptReconnection(V,null),x=z.reconnectionProtocol,ie=!1):(x=new p.PersistentProtocol(V,null),ie=!0),z.logService.trace(`${B} 3/6. sending AuthRequest control message.`);const q=await u(z.signService.createNewMessage((0,h.generateUuid)()),O),te={type:"auth",auth:z.connectionToken||"00000000000000000000",data:q.data};x.sendControl(t.VSBuffer.fromString(JSON.stringify(te)));try{const ne=await w(x,S(O,E(1e4)));if(ne.type!=="sign"||typeof ne.data!="string"){const Le=new Error("Unexpected handshake message");throw Le.code="VSCODE_CONNECTION_ERROR",Le}if(z.logService.trace(`${B} 4/6. received SignRequest control message.`),!await u(z.signService.validate(q,ne.signedData),O)){const Le=new Error("Refused to connect to unsupported server");throw Le.code="VSCODE_CONNECTION_ERROR",Le}const he=await u(z.signService.sign(ne.data),O),ke={type:"connectionType",commit:z.commit,signedData:he,desiredConnectionType:j};return L&&(ke.args=L),z.logService.trace(`${B} 5/6. sending ConnectionTypeRequest control message.`),x.sendControl(t.VSBuffer.fromString(JSON.stringify(ke))),{protocol:x,ownsProtocol:ie}}catch(ne){throw ne&&ne.code==="ETIMEDOUT"&&(z.logService.error(`${B} the handshake timed out. Error:`),z.logService.error(ne)),ne&&ne.code==="VSCODE_CONNECTION_ERROR"&&(z.logService.error(`${B} received error control message when negotiating connection. Error:`),z.logService.error(ne)),ie&&N(x),ne}}async function s(z,j,L,O){const B=Date.now(),V=$(z,j),{protocol:x,ownsProtocol:ie}=await c(z,j,L,O),q=new f(O);return q.registerDisposable(x.onControlMessage(te=>{const ne=JSON.parse(te.toString()),ce=_(ne);ce?(z.logService.error(`${V} received error control message when negotiating connection. Error:`),z.logService.error(ce),ie&&N(x),q.reject(ce)):(z.reconnectionProtocol?.endAcceptReconnection(),z.logService.trace(`${V} 6/6. handshake finished, connection is up and running after ${Y(B)}!`),q.resolve({protocol:x,firstMessage:ne}))})),q.promise}async function r(z,j){const{protocol:L}=await s(z,1,void 0,j);return{protocol:L}}async function i(z,j,L){const{protocol:O,firstMessage:B}=await s(z,2,j,L),V=B&&B.debugPort;return{protocol:O,debugPort:V}}async function n(z,j,L){const O=Date.now(),B=$(z,3),{protocol:V}=await c(z,3,j,L);return z.logService.trace(`${B} 6/6. handshake finished, connection is up and running after ${Y(O)}!`),V}async function o(z,j,L){const{host:O,port:B,connectionToken:V}=await z.addressProvider.getAddress();return{commit:z.commit,quality:z.quality,host:O,port:B,connectionToken:V,reconnectionToken:j,reconnectionProtocol:L,socketFactory:z.socketFactory,signService:z.signService,logService:z.logService}}async function a(z,j,L){return P(z,async O=>{const{protocol:B}=await r(O,k.CancellationToken.None);return new le(z,j,L,O.reconnectionToken,B)})}e.connectRemoteAgentManagement=a;async function l(z,j){return P(z,async L=>{const{protocol:O,debugPort:B}=await i(L,j,k.CancellationToken.None);return new K(z,j,L.reconnectionToken,O,B)})}e.connectRemoteAgentExtensionHost=l;async function P(z,j){const L=5;for(let O=1;;O++)try{const B=(0,h.generateUuid)(),V=await o(z,B,null);return await j(V)}catch(B){if(O<L)z.logService.error(`[remote-connection][attempt ${O}] An error occurred in initial connection! Will retry... Error:`),z.logService.error(B);else throw z.logService.error(`[remote-connection][attempt ${O}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),z.logService.error(B),se.triggerPermanentFailure(0,0,I.RemoteAuthorityResolverError.isHandled(B)),B}}async function M(z,j,L){const O=await o(z,(0,h.generateUuid)(),null);return await n(O,{host:j,port:L},k.CancellationToken.None)}e.connectRemoteAgentTunnel=M;function T(z){return(0,v.createCancelablePromise)(j=>new Promise((L,O)=>{const B=setTimeout(L,z*1e3);j.onCancellationRequested(()=>{clearTimeout(B),L()})}))}var F;(function(z){z[z.ConnectionLost=0]="ConnectionLost",z[z.ReconnectionWait=1]="ReconnectionWait",z[z.ReconnectionRunning=2]="ReconnectionRunning",z[z.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",z[z.ConnectionGain=4]="ConnectionGain"})(F=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class U{constructor(j,L){this.reconnectionToken=j,this.millisSinceLastIncomingData=L,this.type=0}}e.ConnectionLostEvent=U;class Q{constructor(j,L,O,B){this.reconnectionToken=j,this.millisSinceLastIncomingData=L,this.durationSeconds=O,this.cancellableTimer=B,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=Q;class re{constructor(j,L,O){this.reconnectionToken=j,this.millisSinceLastIncomingData=L,this.attempt=O,this.type=2}}e.ReconnectionRunningEvent=re;class ue{constructor(j,L,O){this.reconnectionToken=j,this.millisSinceLastIncomingData=L,this.attempt=O,this.type=4}}e.ConnectionGainEvent=ue;class fe{constructor(j,L,O,B){this.reconnectionToken=j,this.millisSinceLastIncomingData=L,this.attempt=O,this.handled=B,this.type=3}}e.ReconnectionPermanentFailureEvent=fe;class se extends y.Disposable{constructor(j,L,O,B,V){super();this._connectionType=j,this._options=L,this.reconnectionToken=O,this.protocol=B,this._reconnectionFailureIsFatal=V,this._onDidStateChange=this._register(new D.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._onDidStateChange.fire(new ue(this.reconnectionToken,0,0)),this._register(B.onSocketClose(x=>{const ie=W(this._connectionType,this.reconnectionToken,!0);x?x.type===0?(this._options.logService.info(`${ie} received socket close event (hadError: ${x.hadError}).`),x.error&&this._options.logService.error(x.error)):(this._options.logService.info(`${ie} received socket close event (wasClean: ${x.wasClean}, code: ${x.code}, reason: ${x.reason}).`),x.event&&this._options.logService.error(x.event)):this._options.logService.info(`${ie} received socket close event.`),this._beginReconnecting()})),this._register(B.onSocketTimeout(x=>{const ie=W(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${ie} received socket timeout event (unacknowledgedMsgCount: ${x.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${x.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${x.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),se._instances.push(this),this._register((0,y.toDisposable)(()=>{const x=se._instances.indexOf(this);x>=0&&se._instances.splice(x,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(se._permanentFailureMillisSinceLastIncomingData,se._permanentFailureAttempt,se._permanentFailureHandled)}static triggerPermanentFailure(j,L,O){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=j,this._permanentFailureAttempt=L,this._permanentFailureHandled=O,this._instances.forEach(B=>B._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(j=>j._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(j=>j._pauseSocketWriting())}get _isPermanentFailure(){return this._permanentFailure||se._permanentFailure}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure)return;const j=W(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${j} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const L=[0,5,5,10,10,10,10,10,30];let O=-1;do{O++;const B=O<L.length?L[O]:L[L.length-1];try{if(B>0){const x=T(B);this._onDidStateChange.fire(new Q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B,x)),this._options.logService.info(`${j} waiting for ${B} seconds before reconnecting...`);try{await x}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${j} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new re(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),O+1)),this._options.logService.info(`${j} resolving connection...`);const V=await o(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${j} connecting to ${V.host}:${V.port}...`),await this._reconnect(V,E(b)),this._options.logService.info(`${j} reconnected!`),this._onDidStateChange.fire(new ue(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),O+1));break}catch(V){if(V.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${j} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(V),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,!1);break}if(O>360){this._options.logService.error(`${j} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(V),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,!1);break}if(I.RemoteAuthorityResolverError.isTemporarilyNotAvailable(V)){this._options.logService.info(`${j} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(V);continue}if((V.code==="ETIMEDOUT"||V.code==="ENETUNREACH"||V.code==="ECONNREFUSED"||V.code==="ECONNRESET")&&V.syscall==="connect"){this._options.logService.info(`${j} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(V);continue}if((0,R.isCancellationError)(V)){this._options.logService.info(`${j} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(V);continue}if(V instanceof I.RemoteAuthorityResolverError){this._options.logService.error(`${j} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(V),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,I.RemoteAuthorityResolverError.isHandled(V));break}this._options.logService.error(`${j} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(V),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,!1);break}}while(!this._isPermanentFailure)}_onReconnectionPermanentFailure(j,L,O){this._reconnectionFailureIsFatal?se.triggerPermanentFailure(j,L,O):this._gotoPermanentFailure(j,L,O)}_gotoPermanentFailure(j,L,O){this._onDidStateChange.fire(new fe(this.reconnectionToken,j,L,O)),N(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=se,se._permanentFailure=!1,se._permanentFailureMillisSinceLastIncomingData=0,se._permanentFailureAttempt=0,se._permanentFailureHandled=!1,se._instances=[];class le extends se{constructor(j,L,O,B,V){super(1,j,B,V,!0);this.client=this._register(new p.Client(V,{remoteAuthority:L,clientId:O},j.ipcLogger))}async _reconnect(j,L){await r(j,L)}}e.ManagementPersistentConnection=le;class K extends se{constructor(j,L,O,B,V){super(2,j,O,B,!1);this._startArguments=L,this.debugPort=V}async _reconnect(j,L){await i(j,this._startArguments,L)}}e.ExtensionHostPersistentConnection=K;function N(z){try{z.acceptDisconnect();const j=z.getSocket();z.dispose(),j.dispose()}catch(j){(0,R.onUnexpectedError)(j)}}function _(z){if(z&&z.type==="error"){const j=new Error(`Connection error: ${z.reason}`);return j.code="VSCODE_CONNECTION_ERROR",j}return null}function A(z,j){for(;z.length<j;)z+=" ";return z}function W(z,j,L){return`[remote-connection][${A(d(z),13)}][${j.substr(0,5)}\u2026][${L?"reconnect":"initial"}]`}function $(z,j){return`${W(j,z.reconnectionToken,!!z.reconnectionProtocol)}[${z.host}:${z.port}]`}function Y(z){return`${Date.now()-z} ms`}}),define(Z[217],ee([0,1,77,83]),function(H,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(k,R,D,y,h,p){const I=b=>p(b,void 0),C=v.createConnection({host:k,port:R},()=>{C.removeListener("error",I);const b=Buffer.alloc(16);for(let S=0;S<16;S++)b[S]=Math.round(Math.random()*256);const g=b.toString("base64"),d=[`GET ws://${/:/.test(k)?`[${k}]`:k}:${R}${D}?${y}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${g}`];C.write(d.join(`\r
`)+`\r
\r
`);const E=S=>{S.toString().indexOf(`\r
\r
`)>=0&&(C.off("data",E),p(void 0,new t.NodeSocket(C,h)))};C.on("data",E)});C.setNoDelay(!0),C.once("error",I)}}}),define(Z[52],ee([0,1,17,166,62,5,45]),function(H,e,v,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,R.createDecorator)("requestService");function y(E){return E.res.statusCode&&E.res.statusCode>=200&&E.res.statusCode<300||E.res.statusCode===1223}e.isSuccess=y;function h(E){return E.res.statusCode===204}async function p(E){return h(E)?null:(await(0,v.streamToBuffer)(E.stream)).toString()}e.asText=p;async function I(E){if(!y(E))throw new Error("Server returned "+E.res.statusCode);return p(E)}e.asTextOrError=I;async function C(E){if(!y(E))throw new Error("Server returned "+E.res.statusCode);if(h(E))return null;const f=(await(0,v.streamToBuffer)(E.stream)).toString();try{return JSON.parse(f)}catch(w){throw w.message+=`:
`+f,w}}e.asJson=C;function b(E){d(E)}e.updateProxyConfigurationsScope=b;let g;function d(E){const S=D.Registry.as(k.Extensions.Configuration),f=g;g={id:"http",order:15,title:(0,t.localize)(0,null),type:"object",scope:E,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,t.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,t.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,t.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,t.localize)(4,null),(0,t.localize)(5,null),(0,t.localize)(6,null),(0,t.localize)(7,null)],default:"override",description:(0,t.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,t.localize)(9,null),restricted:!0}}},S.updateConfigurations({add:[g],remove:f?[f]:[]})}d(2)}),define(Z[218],ee([0,1,17,21]),function(H,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class k{constructor(y){this.service=y}listen(y,h){throw new Error("Invalid listen")}call(y,h,p,I=t.CancellationToken.None){switch(h){case"request":return this.service.request(p[0],I).then(async({res:C,stream:b})=>{const g=await(0,v.streamToBuffer)(b);return[{statusCode:C.statusCode,headers:C.headers},g]});case"resolveProxy":return this.service.resolveProxy(p[0])}throw new Error("Invalid call")}}e.RequestChannel=k;class R{constructor(y){this.channel=y}async request(y,h){const[p,I]=await this.channel.call("request",[y],h);return{res:p,stream:(0,v.bufferToStream)(I)}}async resolveProxy(y){return this.channel.call("resolveProxy",[y])}}e.RequestChannelClient=R}),define(Z[219],ee([0,1,220,12]),function(H,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function k(D,y){return D.protocol==="http:"?y.HTTP_PROXY||y.http_proxy||null:D.protocol==="https:"&&(y.HTTPS_PROXY||y.https_proxy||y.HTTP_PROXY||y.http_proxy)||null}async function R(D,y,h={}){const p=(0,v.parse)(D),I=h.proxyUrl||k(p,y);if(!I)return null;const C=(0,v.parse)(I);if(!/^https?:$/.test(C.protocol||""))return null;const b={host:C.hostname||"",port:C.port||(C.protocol==="https"?"443":"80"),auth:C.auth,rejectUnauthorized:(0,t.isBoolean)(h.strictSSL)?h.strictSSL:!0};return p.protocol==="http:"?new(await new Promise((g,d)=>{H(["http-proxy-agent"],g,d)}))(b):new(await new Promise((g,d)=>{H(["https-proxy-agent"],g,d)}))(b)}e.getProxyAgent=R}),define(Z[110],ee([0,1,50,9,167,21,43,18,4,28,144,58,8]),function(H,e,v,t,k,R,D,y,h,p,I,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const g=1e4;let d;async function E(f,w,m){return w["force-disable-user-env"]?(f.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):h.isWindows?(f.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,C.isLaunchedFromCli)(m)&&!w["force-user-env"]?(f.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,C.isLaunchedFromCli)(m)?f.trace("resolveShellEnv(): running (--force-user-env)"):f.trace("resolveShellEnv(): running (macOS/Linux)"),d||(d=b.Promises.withAsyncBody(async(u,c)=>{const s=new R.CancellationTokenSource,r=setTimeout(()=>{s.dispose(!0),c(new Error((0,k.localize)(0,null)))},g);try{u(await S(f,s.token))}catch(i){!(0,y.isCancellationError)(i)&&!s.token.isCancellationRequested?c(new Error((0,k.localize)(1,null,(0,D.toErrorMessage)(i)))):u({})}finally{clearTimeout(r),s.dispose()}})),d)}e.getResolvedShellEnv=E;async function S(f,w){const m=process.env.ELECTRON_RUN_AS_NODE;f.trace("getUnixShellEnvironment#runAsNode",m);const u=process.env.ELECTRON_NO_ATTACH_CONSOLE;f.trace("getUnixShellEnvironment#noAttach",u);const c=(0,p.generateUuid)().replace(/-/g,"").substr(0,12),s=new RegExp(c+"(.*)"+c),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};f.trace("getUnixShellEnvironment#env",r);const i=await(0,I.getSystemShell)(h.OS,r);return f.trace("getUnixShellEnvironment#shell",i),new Promise((n,o)=>{if(w.isCancellationRequested)return o((0,y.canceled)());const a=(0,t.basename)(i);let l,P;const M=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(a)?(l=`& '${process.execPath}' ${M} -p '''${c}'' + JSON.stringify(process.env) + ''${c}'''`,P=["-Login","-Command"]):(l=`'${process.execPath}' ${M} -p '"${c}" + JSON.stringify(process.env) + "${c}"'`,a==="tcsh"?P=["-ic"]:P=["-ilc"]),f.trace("getUnixShellEnvironment#spawn",JSON.stringify(P),l);const T=(0,v.spawn)(i,[...P,l],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});w.onCancellationRequested(()=>(T.kill(),o((0,y.canceled)()))),T.on("error",Q=>{f.error("getUnixShellEnvironment#errorChildProcess",(0,D.toErrorMessage)(Q)),o(Q)});const F=[];T.stdout.on("data",Q=>F.push(Q));const U=[];T.stderr.on("data",Q=>U.push(Q)),T.on("close",(Q,re)=>{const ue=Buffer.concat(F).toString("utf8");f.trace("getUnixShellEnvironment#raw",ue);const fe=Buffer.concat(U).toString("utf8");if(fe.trim()&&f.trace("getUnixShellEnvironment#stderr",fe),Q||re)return o(new Error((0,k.localize)(2,null,Q,re)));const se=s.exec(ue),le=se?se[1]:"{}";try{const K=JSON.parse(le);m?K.ELECTRON_RUN_AS_NODE=m:delete K.ELECTRON_RUN_AS_NODE,u?K.ELECTRON_NO_ATTACH_CONSOLE=u:delete K.ELECTRON_NO_ATTACH_CONSOLE,delete K.XDG_RUNTIME_DIR,f.trace("getUnixShellEnvironment#result",K),n(K)}catch(K){f.error("getUnixShellEnvironment#errorCaught",(0,D.toErrorMessage)(K)),o(K)}})})}}),define(Z[87],ee([0,1,5]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,v.createDecorator)(e.SIGN_SERVICE_ID)}),define(Z[221],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class v{constructor(){this.validators=new Map}vsda(){return new Promise((k,R)=>H(["vsda"],k,R))}async createNewMessage(k){try{const R=await this.vsda(),D=new R.validator;if(D){const y=String(v._nextId++);return this.validators.set(y,D),{id:y,data:D.createNewMessage(k)}}}catch{}return{id:"",data:k}}async validate(k,R){if(!k.id)return!0;const D=this.validators.get(k.id);if(!D)return!1;this.validators.delete(k.id);try{return D.validate(R)==="ok"}catch{return!1}}async sign(k){try{const R=await this.vsda(),D=new R.signer;if(D)return D.sign(k)}catch{}return k}}e.SignService=v,v._nextId=1}),define(Z[41],ee([0,1,5]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,v.createDecorator)("stateMainService")}),define(Z[22],ee([0,1,15,40,8,3,2,4,35,12,5,6,41]),function(H,e,v,t,k,R,D,y,h,p,I,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ShutdownReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,I.createDecorator)("lifecycleMainService");var g;(function(S){S[S.QUIT=1]="QUIT",S[S.KILL=2]="KILL"})(g=e.ShutdownReason||(e.ShutdownReason={}));var d;(function(S){S[S.Starting=1]="Starting",S[S.Ready=2]="Ready",S[S.AfterWindowOpen=3]="AfterWindowOpen"})(d=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let E=class yt extends D.Disposable{constructor(f,w){super();this.logService=f,this.stateMainService=w,this._onBeforeShutdown=this._register(new R.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new R.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new R.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new R.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.mapWindowIdToPendingUnload=new Map,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(yt.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(yt.QUIT_AND_RESTART_KEY)}registerListeners(){const f=()=>{this._quitRequested||(this.logService.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.logService.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),y.isMacintosh&&this.windowCounter===0&&this.fireOnWillShutdown(1))};v.app.addListener("before-quit",f);const w=()=>{this.logService.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!y.isMacintosh)&&v.app.quit()};v.app.addListener("window-all-closed",w),v.app.once("will-quit",m=>{this.logService.trace("Lifecycle#app.on(will-quit)"),m.preventDefault(),this.fireOnWillShutdown(1).finally(()=>{this.resolvePendingQuitPromise(!1),v.app.removeListener("before-quit",f),v.app.removeListener("window-all-closed",w),v.app.quit()})})}fireOnWillShutdown(f){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const w=[];return this._onWillShutdown.fire({reason:f,join(m){w.push(m)}}),this.pendingWillShutdownPromise=(async()=>{try{await k.Promises.settled(w)}catch(m){this.logService.error(m)}try{await this.stateMainService.close()}catch(m){this.logService.error(m)}})(),this.pendingWillShutdownPromise}set phase(f){if(f<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===f)return;this.logService.trace(`lifecycle (main): phase changed (value: ${f})`),this._phase=f;const w=this.phaseWhen.get(this._phase);w&&(w.open(),this.phaseWhen.delete(this._phase))}async when(f){if(f<=this._phase)return;let w=this.phaseWhen.get(f);w||(w=new k.Barrier,this.phaseWhen.set(f,w)),await w.wait()}registerWindow(f){const w=new D.DisposableStore;this.windowCounter++,w.add(f.onWillLoad(u=>this._onWillLoadWindow.fire({window:f,workspace:u.workspace,reason:u.reason})));const m=(0,p.assertIsDefined)(f.win);m.on("close",u=>{const c=f.id;if(this.windowToCloseRequest.has(c)){this.windowToCloseRequest.delete(c);return}this.logService.trace(`Lifecycle#window.on('close') - window ID ${f.id}`),u.preventDefault(),this.unload(f,1).then(s=>{if(s){this.windowToCloseRequest.delete(c);return}this.windowToCloseRequest.add(c),this.logService.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${c}`),this._onBeforeCloseWindow.fire(f),f.close()})}),m.on("closed",()=>{this.logService.trace(`Lifecycle#window.on('closed') - window ID ${f.id}`),this.windowCounter--,w.dispose(),this.windowCounter===0&&(!y.isMacintosh||this._quitRequested)&&this.fireOnWillShutdown(1)})}async reload(f,w){await this.unload(f,3)||f.reload(w)}unload(f,w){const m=this.mapWindowIdToPendingUnload.get(f.id);if(m)return m;const u=this.doUnload(f,w).finally(()=>{this.mapWindowIdToPendingUnload.delete(f.id)});return this.mapWindowIdToPendingUnload.set(f.id,u),u}async doUnload(f,w){if(!f.isReady)return!1;this.logService.trace(`Lifecycle#unload() - window ID ${f.id}`);const m=this._quitRequested?2:w,u=await this.onBeforeUnloadWindowInRenderer(f,m);return u?(this.logService.trace(`Lifecycle#unload() - veto in renderer (window ID ${f.id})`),this.handleWindowUnloadVeto(u)):(await this.onWillUnloadWindowInRenderer(f,m),!1)}handleWindowUnloadVeto(f){return f?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(f){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(f),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(f,w){return new Promise(m=>{const u=this.oneTimeListenerTokenGenerator++,c=`vscode:ok${u}`,s=`vscode:cancel${u}`;t.validatedIpcMain.once(c,()=>{m(!1)}),t.validatedIpcMain.once(s,()=>{m(!0)}),f.send("vscode:onBeforeUnload",{okChannel:c,cancelChannel:s,reason:w})})}onWillUnloadWindowInRenderer(f,w){return new Promise(m=>{const c=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;t.validatedIpcMain.once(c,()=>m()),f.send("vscode:onWillUnload",{replyChannel:c,reason:w})})}quit(f){return this.pendingQuitPromise?this.pendingQuitPromise:(this.logService.trace(`Lifecycle#quit() - will restart: ${f}`),f&&this.stateMainService.setItem(yt.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(w=>{this.pendingQuitPromiseResolve=w,this.logService.trace("Lifecycle#quit() - calling app.quit()"),v.app.quit()}),this.pendingQuitPromise)}async relaunch(f){this.logService.trace("Lifecycle#relaunch()");const w=process.argv.slice(1);if(f?.addArgs&&w.push(...f.addArgs),f?.removeArgs)for(const c of f.removeArgs){const s=w.indexOf(c);s>=0&&w.splice(s,1)}const m=()=>{try{if(y.isWindows){const c=(0,h.cwd)();c!==process.cwd()&&process.chdir(c)}}catch(c){this.logService.error(c)}this.logService.trace("Lifecycle#relaunch() - calling app.relaunch()"),v.app.relaunch({args:w})};v.app.once("quit",m),await this.quit(!0)&&v.app.removeListener("quit",m)}async kill(f){this.logService.trace("Lifecycle#kill()"),await this.fireOnWillShutdown(2),await Promise.race([(0,k.timeout)(1e3),(async()=>{for(const w of v.BrowserWindow.getAllWindows())if(w&&!w.isDestroyed()){let m;w.webContents&&!w.webContents.isDestroyed()?m=new Promise(u=>w.once("closed",u)):m=Promise.resolve(),w.destroy(),await m}})()]),v.app.exit(f)}};E.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",E=ve([J(0,C.ILogService),J(1,b.IStateMainService)],E),e.LifecycleMainService=E}),define(Z[222],ee([0,1,4,3,2,5,22]),function(H,e,v,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,R.createDecorator)("keyboardLayoutMainService");let y=class extends k.Disposable{constructor(I){super();this._onDidChangeKeyboardLayout=this._register(new t.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,I.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const I=await new Promise((C,b)=>{H(["native-keymap"],C,b)});this._keyboardLayoutData=h(I),v.isCI||I.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=h(I),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};y=ve([J(0,D.ILifecycleMainService)],y),e.KeyboardLayoutMainService=y;function h(p){const I=p.getKeyMap(),C=p.getCurrentKeyboardLayout();return{keyboardMapping:I,keyboardLayoutInfo:C}}}),define(Z[223],ee([0,1,5]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=void 0,e.IStateService=(0,v.createDecorator)("stateService")}),define(Z[224],ee([0,1,8,17,12,37,14,6]),function(H,e,v,t,k,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.FileStorage=void 0;class h{constructor(C,b,g){this.storagePath=C,this.logService=b,this.fileService=g,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new v.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(C){C.fileOperationResult!==1&&this.logService.error(C)}}getItem(C,b){const g=this.storage[C];return(0,k.isUndefinedOrNull)(g)?b:g}setItem(C,b){this.setItems([{key:C,data:b}])}setItems(C){let b=!1;for(const{key:g,data:d}of C)this.storage[g]!==d&&((0,k.isUndefinedOrNull)(d)?(0,k.isUndefined)(this.storage[g])||(this.storage[g]=void 0,b=!0):(this.storage[g]=d,b=!0));b&&this.save()}removeItem(C){(0,k.isUndefined)(this.storage[C])||(this.storage[C]=void 0,this.save())}async save(C){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave(),C)}async doSave(){if(!this.initializing)return;await this.initializing;const C=JSON.stringify(this.storage,null,4);if(C!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,t.VSBuffer.fromString(C)),this.lastSavedStorageContents=C}catch(b){this.logService.error(b)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=h;let p=class{constructor(C,b,g){this.fileStorage=new h(C.stateResource,b,g)}async init(){await this.fileStorage.init()}getItem(C,b){return this.fileStorage.getItem(C,b)}};p=ve([J(0,R.IEnvironmentService),J(1,y.ILogService),J(2,D.IFileService)],p),e.StateService=p}),define(Z[225],ee([0,1,224]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=void 0;class t extends v.StateService{setItem(R,D){this.fileStorage.setItem(R,D)}setItems(R){this.fileStorage.setItems(R)}removeItem(R){this.fileStorage.removeItem(R)}close(){return this.fileStorage.close()}}e.StateMainService=t}),define(Z[111],ee([0,1,4,35,7,28]),function(H,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function D(p){if(v.platform===2&&/^penguin(\.|$)/i.test(p))return"chromebook"}async function y(p,I,C,b,g,d,E,S,f,w){const m=Object.create(null);m["common.machineId"]=E,m.sessionID=(0,R.generateUuid)()+Date.now(),m.commitHash=g,m.version=d,m["common.platformVersion"]=(I||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),m["common.platform"]=(0,v.PlatformToString)(v.platform),m["common.nodePlatform"]=t.platform,m["common.nodeArch"]=b,m["common.product"]=w||"desktop",S&&(m["common.msftInternal"]=S);let u=0;const c=Date.now();Object.defineProperties(m,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-c,enumerable:!0},"common.sequence":{get:()=>u++,enumerable:!0}}),v.isLinuxSnap&&(m["common.snap"]="true");const s=D(C);s&&(m["common.platformDetail"]=s);try{const r=await p.readFile(k.URI.file(f));m["common.source"]=r.value.toString().slice(0,30)}catch{}return m}e.resolveCommonProperties=y;function h(p){const I=t.env.USERDNSDOMAIN;if(!I)return!1;const C=I.toLowerCase();return p.some(b=>C===b)}e.verifyMicrosoftInternalDomain=h}),define(Z[38],ee([0,1,5]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,v.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,v.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var k;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(k=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Z[226],ee([0,1,30,55,8,42,13,9,4,7,81,23,97,84,14,20,38]),function(H,e,v,t,k,R,D,y,h,p,I,C,b,g,d,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const f=new Map;async function w(r,i){const n=`${r}::${i.join(":")}`,o=f.get(n);if(o)return o;const a=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],l=new Map,P=new Map,M=2e4;function T(U,Q,re,ue){const fe=Q.substring(U.length+1);return k.Promises.withAsyncBody(async se=>{let le;try{le=await C.Promises.readdir(Q,{withFileTypes:!0})}catch{se();return}if(ue.count>=M){ue.count+=le.length,ue.maxReached=!0,se();return}let K=le.length;if(K===0){se();return}let N=le;ue.count+le.length>M&&(ue.maxReached=!0,K=M-ue.count,N=le.slice(0,K)),ue.count+=le.length;for(const _ of N)if(_.isDirectory()){if(re.includes(_.name)||await T(U,(0,y.join)(Q,_.name),re,ue),--K==0){se();return}}else{const A=_.name.lastIndexOf(".");if(A>=0){const W=_.name.substring(A+1);W&&l.set(W,(l.get(W)??0)+1)}for(const W of a)W.relativePathPattern?.test(fe)!==!1&&W.filePattern.test(_.name)&&P.set(W.tag,(P.get(W.tag)??0)+1);if(--K==0){se();return}}})}const F=k.Promises.withAsyncBody(async U=>{const Q={count:0,maxReached:!1};await T(r,r,i,Q);const re=await c(r);U({configFiles:m(P),fileTypes:m(l),fileCount:Q.count,maxFilesReached:Q.maxReached,launchConfigFiles:re})});return f.set(n,F),F}e.collectWorkspaceStats=w;function m(r){return[...t.Iterable.map(r.entries(),([i,n])=>({name:i,count:n}))].sort((i,n)=>n.count-i.count)}function u(){const r={os:`${v.type()} ${v.arch()} ${v.release()}`,memory:`${(v.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(v.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(I.virtualMachineHint.value()*100)}%`},i=v.cpus();return i&&i.length>0&&(r.cpus=`${i[0].model} (${i.length} x ${i[0].speed})`),r}e.getMachineInfo=u;async function c(r){try{const i=new Map,n=(0,y.join)(r,".vscode","launch.json"),o=await C.Promises.readFile(n),a=[],l=(0,R.parse)(o.toString(),a);if(a.length)return console.log(`Unable to parse ${n}`),[];if((0,R.getNodeType)(l)==="object"&&l.configurations)for(const P of l.configurations){const M=P.type;M&&(i.has(M)?i.set(M,i.get(M)+1):i.set(M,1))}return m(i)}catch{return[]}}e.collectLaunchConfigs=c;let s=class{constructor(i,n){this.telemetryService=i,this.productService=n}formatMachineInfo(i){const n=[];return n.push(`OS Version:       ${i.os}`),n.push(`CPUs:             ${i.cpus}`),n.push(`Memory (System):  ${i.memory}`),n.push(`VM:               ${i.vmHint}`),n.join(`
`)}formatEnvironment(i){const n=[];n.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),n.push(`OS Version:       ${v.type()} ${v.arch()} ${v.release()}`);const o=v.cpus();return o&&o.length>0&&n.push(`CPUs:             ${o[0].model} (${o.length} x ${o[0].speed})`),n.push(`Memory (System):  ${(v.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(v.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`),h.isWindows||n.push(`Load (avg):       ${v.loadavg().map(a=>Math.round(a)).join(", ")}`),n.push(`VM:               ${Math.round(I.virtualMachineHint.value()*100)}%`),n.push(`Screen Reader:    ${i.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${i.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.expandGPUFeatures(i.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(i,n){return Promise.all([(0,b.listProcesses)(i.mainPID),this.formatWorkspaceMetadata(i)]).then(async o=>{let[a,l]=o,P=this.formatProcessList(i,a);return n.forEach(M=>{if((0,g.isRemoteDiagnosticError)(M))P+=`
${M.errorMessage}`,l+=`
${M.errorMessage}`;else if(P+=`

Remote: ${M.hostName}`,M.processes&&(P+=`
${this.formatProcessList(i,M.processes)}`),M.workspaceMetadata){l+=`
|  Remote: ${M.hostName}`;for(const T of Object.keys(M.workspaceMetadata)){const F=M.workspaceMetadata[T];let U=`${F.fileCount} files`;F.maxFilesReached&&(U=`more than ${U}`),l+=`|    Folder (${T}): ${U}`,l+=this.formatWorkspaceStats(F)}}}),{processInfo:P,workspaceInfo:l}})}async getSystemInfo(i,n){const{memory:o,vmHint:a,os:l,cpus:P}=u(),M={os:l,memory:o,cpus:P,vmHint:a,processArgs:`${i.mainArguments.join(" ")}`,gpuStatus:i.gpuFeatureStatus,screenReader:`${i.screenReader?"yes":"no"}`,remoteData:n};return h.isWindows||(M.load=`${v.loadavg().map(T=>Math.round(T)).join(", ")}`),h.isLinux&&(M.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(M)}async getDiagnostics(i,n){const o=[];return(0,b.listProcesses)(i.mainPID).then(async a=>(o.push(""),o.push(this.formatEnvironment(i)),o.push(""),o.push(this.formatProcessList(i,a)),i.windows.some(l=>l.folderURIs&&l.folderURIs.length>0&&!l.remoteAuthority)&&(o.push(""),o.push("Workspace Stats: "),o.push(await this.formatWorkspaceMetadata(i))),n.forEach(l=>{if((0,g.isRemoteDiagnosticError)(l))o.push(`
${l.errorMessage}`);else if(o.push(`

`),o.push(`Remote:           ${l.hostName}`),o.push(this.formatMachineInfo(l.machineInfo)),l.processes&&o.push(this.formatProcessList(i,l.processes)),l.workspaceMetadata)for(const P of Object.keys(l.workspaceMetadata)){const M=l.workspaceMetadata[P];let T=`${M.fileCount} files`;M.maxFilesReached&&(T=`more than ${T}`),o.push(`Folder (${P}): ${T}`),o.push(this.formatWorkspaceStats(M))}}),o.push(""),o.push(""),o.join(`
`)))}formatWorkspaceStats(i){const n=[],o=60;let a=0;const l=(F,U)=>{const Q=` ${F}(${U})`;a+Q.length>o?(n.push(P),P="|                 ",a=P.length):a+=Q.length,P+=Q};let P="|      File types:";const M=10,T=i.fileTypes.length>M?M:i.fileTypes.length;for(let F=0;F<T;F++){const U=i.fileTypes[F];l(U.name,U.count)}if(n.push(P),i.configFiles.length>=0&&(P="|      Conf files:",a=0,i.configFiles.forEach(F=>{l(F.name,F.count)}),n.push(P)),i.launchConfigFiles.length>0){let F="|      Launch Configs:";i.launchConfigFiles.forEach(U=>{F+=U.count>1?` ${U.name}(${U.count})`:` ${U.name}`}),n.push(F)}return n.join(`
`)}expandGPUFeatures(i){const n=Math.max(...Object.keys(i).map(o=>o.length));return Object.keys(i).map(o=>`${o}:  ${" ".repeat(n-o.length)}  ${i[o]}`).join(`
                  `)}formatWorkspaceMetadata(i){const n=[],o=[];return i.windows.forEach(a=>{a.folderURIs.length===0||!!a.remoteAuthority||(n.push(`|  Window (${a.title})`),a.folderURIs.forEach(l=>{const P=p.URI.revive(l);if(P.scheme===D.Schemas.file){const M=P.fsPath;o.push(w(M,["node_modules",".git"]).then(T=>{let F=`${T.fileCount} files`;T.maxFilesReached&&(F=`more than ${F}`),n.push(`|    Folder (${(0,y.basename)(M)}): ${F}`),n.push(this.formatWorkspaceStats(T))}).catch(T=>{n.push(`|      Error: Unable to collect workspace stats for folder ${M} (${T.toString()})`)}))}else n.push(`|    Folder (${P.toString()}): Workspace stats not available.`)}))}),Promise.all(o).then(a=>n.join(`
`)).catch(a=>`Unable to collect workspace stats: ${a}`)}formatProcessList(i,n){const o=new Map;i.windows.forEach(l=>o.set(l.pid,l.title));const a=[];return a.push("CPU %	Mem MB	   PID	Process"),n&&this.formatProcessItem(i.mainPID,o,a,n,0),a.join(`
`)}formatProcessItem(i,n,o,a,l){const P=l===0;let M;P?M=a.pid===i?`${this.productService.applicationName} main`:"remote agent":(M=`${"  ".repeat(l)} ${a.name}`,a.name==="window"&&(M=`${M} (${n.get(a.pid)})`));const T=process.platform==="win32"?a.mem:v.totalmem()*(a.mem/100);o.push(`${a.load.toFixed(0).padStart(5," ")}	${(T/d.ByteSize.MB).toFixed(0).padStart(6," ")}	${a.pid.toFixed(0).padStart(6," ")}	${M}`),Array.isArray(a.children)&&a.children.forEach(F=>this.formatProcessItem(i,n,o,F,l+1))}async getWorkspaceFileExtensions(i){const n=new Set;for(const{uri:o}of i.folders){const a=p.URI.revive(o);if(a.scheme!==D.Schemas.file)continue;const l=a.fsPath;try{(await w(l,["node_modules",".git"])).fileTypes.forEach(M=>n.add(M.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(i){for(const{uri:n}of i.folders){const o=p.URI.revive(n);if(o.scheme!==D.Schemas.file)continue;const a=o.fsPath;try{const l=await w(a,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":i.telemetryId,rendererSessionId:i.rendererSessionId}),l.fileTypes.forEach(P=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:i.rendererSessionId,type:P.name,count:P.count})}),l.launchConfigFiles.forEach(P=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:i.rendererSessionId,type:P.name,count:P.count})}),l.configFiles.forEach(P=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:i.rendererSessionId,type:P.name,count:P.count})})}catch{}}}};s=ve([J(0,S.ITelemetryService),J(1,E.IProductService)],s),e.DiagnosticsService=s}),define(Z[227],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class v{constructor(R){this.appenders=R}listen(R,D){throw new Error(`Event not found: ${D}`)}call(R,D,{eventName:y,data:h}){return this.appenders.forEach(p=>p.log(y,h)),Promise.resolve(null)}}e.TelemetryAppenderChannel=v;class t{constructor(R){this.channel=R}log(R,D){return this.channel.call("log",{eventName:R,data:D}).then(void 0,y=>`Failed to log telemetry: ${console.warn(y)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=t}),define(Z[73],ee([0,1,49,93,12,19,111,38]),function(H,e,v,t,k,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class h{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,t.staticObservableValue)(0)}publicLog(s,r){return Promise.resolve(void 0)}publicLog2(s,r){return this.publicLog(s,r)}publicLogError(s,r){return Promise.resolve(void 0)}publicLogError2(s,r){return this.publicLogError(s,r)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=h,e.NullTelemetryService=new h;class p{async publicLog(s,r,i){}async publicLogError(s,r,i){}}e.NullEndpointTelemetryService=p,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function I(c,s){return s.onDidChangeConfiguration(r=>{r.source!==7&&c.publicLog2("updateConfiguration",{configurationSource:(0,R.ConfigurationTargetToString)(r.source),configurationKeys:f(r.sourceConfig)})})}e.configurationTelemetry=I;function C(c,s){return!(s.disableTelemetry||!c.enableTelemetry||s.extensionTestsLocationURI)}e.supportsTelemetry=C;function b(c){const s=c.getValue(y.TELEMETRY_SETTING_ID),r=c.getValue("telemetry.enableCrashReporter");if(c.getValue(y.TELEMETRY_OLD_SETTING_ID)===!1||r===!1)return 0;switch(s??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=b;function g(c){const s={},r={},i={};S(c,i);for(let n in i){n=n.length>150?n.substr(n.length-149):n;const o=i[n];typeof o=="number"?r[n]=o:typeof o=="boolean"?r[n]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${n} has been trimmed to 8192, the original length is ${o.length}`),s[n]=o.substring(0,8191)):typeof o!="undefined"&&o!==null&&(s[n]=o)}return{properties:s,measurements:r}}e.validateTelemetryData=g;const d=["ssh-remote","dev-container","attached-container","wsl","tunneling"];function E(c){if(!c)return"none";for(const s of d)if(c.startsWith(`${s}+`))return s;return"other"}e.cleanRemoteAuthority=E;function S(c,s,r=0,i){if(!!c)for(const n of Object.getOwnPropertyNames(c)){const o=c[n],a=i?i+n:n;Array.isArray(o)?s[a]=(0,v.safeStringify)(o):o instanceof Date?s[a]=o.toISOString():(0,k.isObject)(o)?r<2?S(o,s,r+1,a+"."):s[a]=(0,v.safeStringify)(o):s[a]=o}}function f(c){if(!c)return[];const s=[];return w(s,"",c),s}function w(c,s,r){r&&typeof r=="object"&&!Array.isArray(r)?Object.keys(r).forEach(i=>w(c,s?`${s}.${i}`:i,r[i])):c.push(s)}function m(c,s){const r=c.msftInternalDomains||[],i=s.getValue("telemetry.internalTesting");return(0,D.verifyMicrosoftInternalDomain)(r)||i}e.isInternalTelemetry=m;function u(c){return[c.appRoot,c.extensionsPath,c.userHome.fsPath,c.tmpDir.fsPath,c.userDataPath]}e.getPiiPathsFromEnvironment=u}),define(Z[228],ee([0,1,187,73]),function(H,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function k(R,D,y,h,p,I,C){const b={"X-Market-Client-Id":`VSCode ${R}`,"User-Agent":`VSCode ${R} (${D.nameShort})`},g=await(0,v.getServiceMachineId)(y,p,I),{sessionId:d}=await C.getTelemetryInfo();return(0,t.supportsTelemetry)(D,y)&&(0,t.getTelemetryLevel)(h)===3&&(b["X-Market-User-Id"]=g,b["VSCode-SessionId"]=d),b}e.resolveMarketplaceHeaders=k}),define(Z[229],ee([0,1,2,49,93,4,26,168,19,62,60,20,45,38,73]),function(H,e,v,t,k,R,D,y,h,p,I,C,b,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let E=class{constructor(w,m,u){this._configurationService=m,this._productService=u,this._experimentProperties={},this.telemetryLevel=new k.MutableObservableValue(3),this._disposables=new v.DisposableStore,this._cleanupPatterns=[],this._appenders=w.appenders,this._commonProperties=w.commonProperties||Promise.resolve({}),this._piiPaths=w.piiPaths||[],this._sendErrorTelemetry=!!w.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(const c of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,D.escapeRegExpCharacters)(c),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(w,m){this._experimentProperties[w]=m}_updateTelemetryLevel(){let w=(0,d.getTelemetryLevel)(this._configurationService);const m=this._productService.enabledTelemetryLevels;if(m){this._sendErrorTelemetry=this.sendErrorTelemetry?m.error:!1;const u=m.usage?3:m.error?2:0;w=Math.min(w,u)}this.telemetryLevel.value=w}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const w=await this._commonProperties,m=w.sessionID,u=w["common.machineId"],c=w["common.firstSessionDate"],s=w["common.msftInternal"];return{sessionId:m,machineId:u,firstSessionDate:c,msftInternal:s}}dispose(){this._disposables.dispose()}_log(w,m,u,c){return this.telemetryLevel.value<m?Promise.resolve(void 0):this._commonProperties.then(s=>{u=(0,t.mixin)(u,s),u=(0,t.mixin)(u,this._experimentProperties),u=(0,t.cloneAndChange)(u,r=>{if(typeof r=="string")return this._cleanupInfo(r,c)}),this._appenders.forEach(r=>r.log(w,u))},s=>{console.error(s)})}publicLog(w,m,u){return this._log(w,3,m,u)}publicLog2(w,m,u){return this.publicLog(w,m,u)}publicLogError(w,m){return this._sendErrorTelemetry?this._log(w,2,m,!0):Promise.resolve(void 0)}publicLogError2(w,m){return this.publicLogError(w,m)}_anonymizeFilePaths(w){let m=w;const u=[];for(const i of this._cleanupPatterns)for(;;){const n=i.exec(w);if(!n)break;u.push([n.index,i.lastIndex])}const c=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,s=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let r=0;for(m="";;){const i=s.exec(w);if(!i)break;!c.test(i[0])&&u.every(([n,o])=>i.index<n||i.index>=o)&&(m+=w.substring(r,i.index)+"<REDACTED: user-file-path>",r=s.lastIndex)}return r<w.length&&(m+=w.substr(r)),m}_removePropertiesWithPossibleUserInfo(w){if(!w)return w;const m=w.toLowerCase(),u=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-.]+/}];for(const c of u)if(c.regex.test(m))return`<REDACTED: ${c.label}>`;return w}_cleanupInfo(w,m){let u=w;m&&(u=this._anonymizeFilePaths(u));for(const c of this._cleanupPatterns)u=u.replace(c,"");return u=this._removePropertiesWithPossibleUserInfo(u),u}};E.IDLE_START_EVENT_NAME="UserIdleStart",E.IDLE_STOP_EVENT_NAME="UserIdleStop",E=ve([J(1,h.IConfigurationService),J(2,C.IProductService)],E),e.TelemetryService=E;function S(){const f=(0,y.localize)(0,null,I.default.nameLong),w=I.default.privacyStatementUrl?(0,y.localize)(2,null,"https://aka.ms/vscode-telemetry",I.default.privacyStatementUrl):(0,y.localize)(1,null,"https://aka.ms/vscode-telemetry"),m=R.isWeb?"":(0,y.localize)(3,null),u=(0,y.localize)(4,null),c=(0,y.localize)(5,null),s=(0,y.localize)(6,null),r=(0,y.localize)(7,null),i=`
|       | ${u} | ${c} | ${s} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,y.localize)(8,null);return`
${f} ${w} ${m}

&nbsp;

${r}
${i}

&nbsp;

${n}
`}b.Registry.as(p.Extensions.Configuration).registerConfiguration({id:g.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,y.localize)(9,null),properties:{[g.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,y.localize)(10,null),(0,y.localize)(11,null),(0,y.localize)(12,null),(0,y.localize)(13,null)],markdownDescription:S(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),b.Registry.as(p.Extensions.Configuration).registerConfiguration({id:g.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,y.localize)(14,null),properties:{[g.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:I.default.privacyStatementUrl?(0,y.localize)(16,null,I.default.nameLong,I.default.privacyStatementUrl):(0,y.localize)(15,null,I.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,y.localize)(17,null,`\`#${g.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Z[230],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var v;(function(R){R.DARK="dark",R.LIGHT="light",R.HIGH_CONTRAST_DARK="hcDark",R.HIGH_CONTRAST_LIGHT="hcLight"})(v=e.ColorScheme||(e.ColorScheme={}));function t(R){return R===v.HIGH_CONTRAST_DARK||R===v.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function k(R){return R===v.DARK||R===v.HIGH_CONTRAST_DARK}e.isDark=k}),define(Z[231],ee([0,1,121,3,2,5,45,230]),function(H,e,v,t,k,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,R.createDecorator)("themeService");var h;(function(S){function f(w){return w&&typeof w=="object"&&typeof w.id=="string"}S.isThemeColor=f})(h=e.ThemeColor||(e.ThemeColor={}));function p(S){return{id:S}}e.themeColorFromId=p;var I;(function(S){function f(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color=="undefined"||h.isThemeColor(n.color))}S.isThemeIcon=f;const w=new RegExp(`^\\$\\((${v.CSSIcon.iconNameExpression}(?:${v.CSSIcon.iconModifierExpression})?)\\)$`);function m(n){const o=w.exec(n);if(!o)return;const[,a]=o;return{id:a}}S.fromString=m;function u(n){return{id:n}}S.fromId=u;function c(n,o){let a=n.id;const l=a.lastIndexOf("~");return l!==-1&&(a=a.substring(0,l)),o&&(a=`${a}~${o}`),{id:a}}S.modify=c;function s(n){const o=n.id.lastIndexOf("~");if(o!==-1)return n.id.substring(o+1)}S.getModifier=s;function r(n,o){return n.id===o.id&&n.color?.id===o.color?.id}S.isEqual=r;function i(n,o){return{id:n.id,color:o?p(o):void 0}}S.asThemeIcon=i,S.asClassNameArray=v.CSSIcon.asClassNameArray,S.asClassName=v.CSSIcon.asClassName,S.asCSSSelector=v.CSSIcon.asCSSSelector})(I=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=v.Codicon.file,e.FolderThemeIcon=v.Codicon.folder;function C(S){switch(S){case y.ColorScheme.DARK:return"vs-dark";case y.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case y.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=C,e.Extensions={ThemingContribution:"base.contributions.theming"};class b{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(f){return this.themingParticipants.push(f),this.onThemingParticipantAddedEmitter.fire(f),(0,k.toDisposable)(()=>{const w=this.themingParticipants.indexOf(f);this.themingParticipants.splice(w,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const g=new b;D.Registry.add(e.Extensions.ThemingContribution,g);function d(S){return g.onColorThemeChange(S)}e.registerThemingParticipant=d;class E extends k.Disposable{constructor(f){super();this.themeService=f,this.theme=f.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(w=>this.onThemeChange(w)))}onThemeChange(f){this.theme=f,this.updateStyles()}updateStyles(){}getColor(f,w){let m=this.theme.getColor(f);return m&&w&&(m=w(m,this.theme)),m?m.toString():null}}e.Themable=E}),define(Z[64],ee([0,1,15,3,2,4,19,5,41]),function(H,e,v,t,k,R,D,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const p="#FFFFFF",I="#1E1E1E",C="#000000",b="#FFFFFF",g="theme",d="themeBackground",E="windowSplash";e.IThemeMainService=(0,y.createDecorator)("themeMainService");let S=class extends k.Disposable{constructor(w,m){super();this.stateMainService=w,this.configurationService=m,this._onDidChangeColorScheme=this._register(new t.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,v.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire(this.getColorScheme())})}getColorScheme(){if(R.isWindows){if(v.nativeTheme.shouldUseHighContrastColors)return{dark:v.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(R.isMacintosh){if(v.nativeTheme.shouldUseInvertedColorScheme||v.nativeTheme.shouldUseHighContrastColors)return{dark:v.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(R.isLinux&&v.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:v.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const w=this.getColorScheme();if(w.highContrast&&this.configurationService.getValue("window.autoDetectHighContrast"))return w.dark?C:b;let m=this.stateMainService.getItem(d,null);if(!m)switch(this.stateMainService.getItem(g,"vs-dark").split(" ")[0]){case"vs":m=p;break;case"hc-black":m=C;break;case"hc-light":m=b;break;default:m=I}return R.isMacintosh&&m.toUpperCase()===I&&(m="#171717"),m}saveWindowSplash(w,m){this.stateMainService.setItems([{key:g,data:m.baseTheme},{key:d,data:m.colorInfo.background},{key:E,data:m}]),typeof w=="number"&&this.updateBackgroundColor(w,m)}updateBackgroundColor(w,m){for(const u of v.BrowserWindow.getAllWindows())if(u.id===w){u.setBackgroundColor(m.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(E)}};S=ve([J(0,h.IStateMainService),J(1,D.IConfigurationService)],S),e.ThemeMainService=S}),define(Z[112],ee([0,1,3,4,5,6]),function(H,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,k.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,k.createDecorator)("sharedTunnelsService");var D;(function(E){E.Http="http",E.Https="https"})(D=e.TunnelProtocol||(e.TunnelProtocol={}));var y;(function(E){E.ConstantPrivate="constantPrivate",E.Private="private",E.Public="public"})(y=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var h;(function(E){E[E.Notify=1]="Notify",E[E.OpenBrowser=2]="OpenBrowser",E[E.OpenPreview=3]="OpenPreview",E[E.Silent=4]="Silent",E[E.Ignore=5]="Ignore",E[E.OpenBrowserOnce=6]="OpenBrowserOnce"})(h=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function p(E){if(E.scheme!=="http"&&E.scheme!=="https")return;const S=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(E.authority);if(!!S)return{address:S[1],port:+S[2]}}e.extractLocalHostUriMetaDataForPortMapping=p,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function I(E){return e.LOCALHOST_ADDRESSES.indexOf(E)>=0}e.isLocalhost=I,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function C(E){return e.ALL_INTERFACES_ADDRESSES.indexOf(E)>=0}e.isAllInterfaces=C;function b(E,S){return S?S!==1&&E<1024:!t.isWindows&&E<1024}e.isPortPrivileged=b;class g{constructor(S,f,w){this.remoteAddress=S,this.localAddress=f,this._dispose=w,this._onDispose=new v.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=g;let d=class{constructor(S){this.logService=S,this._onTunnelOpened=new v.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new v.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new v.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(S){return this._tunnelProvider=S,S?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(S){this._canElevate=S.elevation,this._privacyOptions=S.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const S=[],f=Array.from(this._tunnels.values());for(const w of f){const m=Array.from(w.values());for(const u of m){const c=await u.value;c&&S.push(c)}}return S}async dispose(){for(const S of this._tunnels.values()){for(const{value:f}of S.values())await f.then(w=>w?.dispose());S.clear()}this._tunnels.clear()}openTunnel(S,f,w,m,u=!1,c,s){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${f}:${w} on local port ${m}.`),!S)return;if(f||(f="localhost"),this._tunnelProvider&&this._factoryInProgress.has(w)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const r=this.retainOrCreateTunnel(S,f,w,m,u,c,s);return r?r.then(i=>{if(!i){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(f,w);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const n=this.makeTunnel(i);return(i.tunnelRemoteHost!==f||i.tunnelRemotePort!==w)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(n),n}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}makeTunnel(S){return{tunnelRemotePort:S.tunnelRemotePort,tunnelRemoteHost:S.tunnelRemoteHost,tunnelLocalPort:S.tunnelLocalPort,localAddress:S.localAddress,privacy:S.privacy,protocol:S.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${S.tunnelRemoteHost}:${S.tunnelRemotePort} `);const f=this._tunnels.get(S.tunnelRemoteHost);if(f){const w=f.get(S.tunnelRemotePort);w&&(w.refcount--,await this.tryDisposeTunnel(S.tunnelRemoteHost,S.tunnelRemotePort,w))}}}}async tryDisposeTunnel(S,f,w){if(w.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${S}:${f}.`);const m=w.value.then(async u=>{u&&(await u.dispose(!0),this._onTunnelClosed.fire({host:u.tunnelRemoteHost,port:u.tunnelRemotePort}))});return this._tunnels.has(S)&&this._tunnels.get(S).delete(f),m}}async closeTunnel(S,f){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${S}:${f} `);const w=this._tunnels.get(S);if(w&&w.has(f)){const m=w.get(f);m.refcount=0,await this.tryDisposeTunnel(S,f,m)}}addTunnelToMap(S,f,w){this._tunnels.has(S)||this._tunnels.set(S,new Map),this._tunnels.get(S).set(f,{refcount:1,value:w})}async removeEmptyTunnelFromMap(S,f){const w=this._tunnels.get(S);w&&(await w.get(f)||w.delete(f),w.size===0&&this._tunnels.delete(S))}getTunnelFromMap(S,f){const w=[S];I(S)?(w.push(...e.LOCALHOST_ADDRESSES),w.push(...e.ALL_INTERFACES_ADDRESSES)):C(S)&&w.push(...e.ALL_INTERFACES_ADDRESSES);const m=w.map(u=>this._tunnels.get(u));for(const u of m){const c=u?.get(f);if(c)return c}}canTunnel(S){return!!p(S)}createWithProvider(S,f,w,m,u,c,s){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${f}:${w} on local port ${m}.`);const r=w;this._factoryInProgress.add(r);const n={elevationRequired:u?b(m===void 0?w:m):!1},o={remoteAddress:{host:f,port:w},localAddressPort:m,privacy:c,public:c?c!==y.Private:void 0,protocol:s},a=S.forwardPort(o,n);return a?(this.addTunnelToMap(f,w,a),a.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(r)})):this._factoryInProgress.delete(r),a}};d=ve([J(0,R.ILogService)],d),e.AbstractTunnelService=d}),define(Z[232],ee([0,1,77,92,217,8,2,19,6,20,216,112,87]),function(H,e,v,t,k,R,D,y,h,p,I,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function g(w,m,u,c,s){let r;for(let i=3;i&&(r?.dispose(),r=await new d(w,m,u,c,s).waitForReady(),!(s&&t.BROWSER_RESTRICTED_PORTS[s]||!t.BROWSER_RESTRICTED_PORTS[r.tunnelLocalPort]));i--);return r}class d extends D.Disposable{constructor(m,u,c,s,r){super();this.defaultTunnelHost=u,this.suggestedLocalPort=r,this.privacy=C.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=m,this._server=v.createServer(),this._barrier=new R.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=i=>this._onConnection(i),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=s,this.tunnelRemoteHost=c}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(u=>{u()})}async waitForReady(){let m=await(0,t.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),u=null;return this._server.listen(m,this.defaultTunnelHost),await this._barrier.wait(),u=this._server.address(),u||(m=0,this._server.listen(m,this.defaultTunnelHost),await this._barrier.wait(),u=this._server.address()),this.tunnelLocalPort=u.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${u.port}`,this}async _onConnection(m){m.pause();const u=(0,C.isLocalhost)(this.tunnelRemoteHost)||(0,C.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,c=await(0,I.connectRemoteAgentTunnel)(this._options,u,this.tunnelRemotePort),s=c.getSocket().socket,r=c.readEntireBuffer();c.dispose(),r.byteLength>0&&m.write(r.buffer),m.on("end",()=>{m.localAddress&&this._socketsDispose.delete(m.localAddress),s.end()}),m.on("close",()=>s.end()),m.on("error",()=>{m.localAddress&&this._socketsDispose.delete(m.localAddress),s.destroy()}),s.on("end",()=>m.end()),s.on("close",()=>m.end()),s.on("error",()=>{m.destroy()}),m.pipe(s),s.pipe(m),m.localAddress&&this._socketsDispose.set(m.localAddress,()=>{m.end(),s.end()})}}let E=class extends C.AbstractTunnelService{constructor(m,u,c,s,r){super(u);this.socketFactory=m,this.signService=c,this.productService=s,this.configurationService=r}get defaultTunnelHost(){const m=this.configurationService.getValue("remote.localPortHost");return!m||m==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(m,u,c,s,r,i,n){const o=this.getTunnelFromMap(u,c);if(o)return++o.refcount,o.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,u,c,s,r,i,n);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${u}:${c} on local port ${s}.`);const a={commit:this.productService.commit,quality:this.productService.quality,socketFactory:this.socketFactory,addressProvider:m,signService:this.signService,logService:this.logService,ipcLogger:null},l=g(a,this.defaultTunnelHost,u,c,s);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(u,c,l),l}}};E=ve([J(1,h.ILogService),J(2,b.ISignService),J(3,p.IProductService),J(4,y.IConfigurationService)],E),e.BaseTunnelService=E;let S=class extends E{constructor(m,u,c,s){super(k.nodeSocketFactory,m,u,c,s)}};S=ve([J(0,h.ILogService),J(1,b.ISignService),J(2,p.IProductService),J(3,y.IConfigurationService)],S),e.TunnelService=S;let f=class extends D.Disposable{constructor(m,u,c,s){super();this.logService=m,this.productService=u,this.signService=c,this.configurationService=s,this._tunnelServices=new Map}async openTunnel(m,u,c,s,r,i,n,o){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${c}:${s} on local port ${r}.`),!this._tunnelServices.has(m)){const a=new S(this.logService,this.signService,this.productService,this.configurationService);this._register(a),this._tunnelServices.set(m,a),a.onTunnelClosed(async()=>{(await a.tunnels).length===0&&(a.dispose(),this._tunnelServices.delete(m))})}return this._tunnelServices.get(m).openTunnel(u,c,s,r,i,n,o)}};f=ve([J(0,h.ILogService),J(1,p.IProductService),J(2,b.ISignService),J(3,y.IConfigurationService)],f),e.SharedTunnelsService=f}),define(Z[46],ee([0,1,5]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var t;(function(R){R.Uninitialized="uninitialized",R.Idle="idle",R.CheckingForUpdates="checking for updates",R.AvailableForDownload="available for download",R.Downloading="downloading",R.Downloaded="downloaded",R.Updating="updating",R.Ready="ready"})(t=e.StateType||(e.StateType={}));var k;(function(R){R[R.Setup=0]="Setup",R[R.Archive=1]="Archive",R[R.Snap=2]="Snap"})(k=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(R,D)=>({type:"idle",updateType:R,error:D}),CheckingForUpdates:R=>({type:"checking for updates",explicit:R}),AvailableForDownload:R=>({type:"available for download",update:R}),Downloading:R=>({type:"downloading",update:R}),Downloaded:R=>({type:"downloaded",update:R}),Updating:R=>({type:"updating",update:R}),Ready:R=>({type:"ready",update:R})},e.IUpdateService=(0,v.createDecorator)("updateService")}),define(Z[233],ee([0,1,4,169,62,45]),function(H,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),R.Registry.as(k.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,t.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,t.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,t.localize)(2,null),(0,t.localize)(3,null),(0,t.localize)(4,null),(0,t.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,t.localize)(6,null),deprecationMessage:(0,t.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,t.localize)(8,null),description:(0,t.localize)(9,null),included:v.isWindows&&!v.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,t.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(Z[234],ee([0,1,3,46]),function(H,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class k{constructor(y){this.service=y}listen(y,h){switch(h){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${h}`)}call(y,h,p){switch(h){case"checkForUpdates":return this.service.checkForUpdates(p);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion();case"_applySpecificUpdate":return this.service._applySpecificUpdate(p)}throw new Error(`Call not found: ${h}`)}}e.UpdateChannel=k;class R{constructor(y){this.channel=y,this._onStateChange=new v.Emitter,this.onStateChange=this._onStateChange.event,this._state=t.State.Uninitialized,this.channel.listen("onStateChange")(h=>this.state=h),this.channel.call("_getInitialState").then(h=>this.state=h)}get state(){return this._state}set state(y){this._state=y,this._onStateChange.fire(y)}checkForUpdates(y){return this.channel.call("checkForUpdates",y)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}_applySpecificUpdate(y){return this.channel.call("_applySpecificUpdate",y)}}e.UpdateChannelClient=R}),define(Z[88],ee([0,1,8,21,3,19,27,22,6,20,52,46]),function(H,e,v,t,k,R,D,y,h,p,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function b(d,E,S){return`${S.updateUrl}/api/update/${d}/${E}/${S.commit}`}e.createUpdateURL=b;let g=class{constructor(E,S,f,w,m,u){this.lifecycleMainService=E,this.configurationService=S,this.environmentMainService=f,this.requestService=w,this.logService=m,this.productService=u,this._state=C.State.Uninitialized,this._onStateChange=new k.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(E){this.logService.info("update#setState",E.type),this._state=E,this._onStateChange.fire(E)}async initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const E=this.getUpdateMode(),S=this.getProductQuality(E);if(!S){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(S),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(C.State.Idle(this.getUpdateType())),E==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}E==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,f=>this.logService.error(f))}getUpdateMode(){return(0,R.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel")}getProductQuality(E){return E==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(E=60*60*1e3){return(0,v.timeout)(E).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(E){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(E)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(E){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(E=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${E}`),!E&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}async isLatestVersion(){return this.url?await this.getUpdateMode()==="none"?!1:(await this.requestService.request({url:this.url},t.CancellationToken.None)).res.statusCode===204:void 0}async _applySpecificUpdate(E){}getUpdateType(){return 1}doQuitAndInstall(){}};g=ve([J(0,y.ILifecycleMainService),J(1,R.IConfigurationService),J(2,D.IEnvironmentMainService),J(3,I.IRequestService),J(4,h.ILogService),J(5,p.IProductService)],g),e.AbstractUpdateService=g}),define(Z[235],ee([0,1,15,51,3,2,19,27,22,6,20,52,38,46,88]),function(H,e,v,t,k,R,D,y,h,p,I,C,b,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let E=class extends d.AbstractUpdateService{constructor(f,w,m,u,c,s,r){super(f,w,u,c,s,r);this.telemetryService=m,this.disposables=new R.DisposableStore}get onRawError(){return k.Event.fromNodeEventEmitter(v.autoUpdater,"error",(f,w)=>w)}get onRawUpdateNotAvailable(){return k.Event.fromNodeEventEmitter(v.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return k.Event.fromNodeEventEmitter(v.autoUpdater,"update-available",(f,w,m)=>({url:w,version:m,productVersion:m}))}get onRawUpdateDownloaded(){return k.Event.fromNodeEventEmitter(v.autoUpdater,"update-downloaded",(f,w,m,u)=>({releaseNotes:w,version:m,productVersion:m,date:u}))}async initialize(){await super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(f){this.logService.error("UpdateService error:",f);const m=(this.state.type==="checking for updates"?this.state.explicit:!0)?f:void 0;this.setState(g.State.Idle(1,m))}buildUpdateFeedUrl(f){let w;this.productService.darwinUniversalAssetId?w=this.productService.darwinUniversalAssetId:w=process.arch==="x64"?"darwin":"darwin-arm64";const m=(0,d.createUpdateURL)(w,f,this.productService);try{v.autoUpdater.setFeedURL({url:m})}catch(u){this.logService.error("Failed to set update feed URL",u);return}return m}doCheckForUpdates(f){this.setState(g.State.CheckingForUpdates(f)),v.autoUpdater.checkForUpdates()}onUpdateAvailable(f){this.state.type==="checking for updates"&&this.setState(g.State.Downloading(f))}onUpdateDownloaded(f){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:f.version}),this.setState(g.State.Ready(f)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(g.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),v.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};ve([t.memoize],E.prototype,"onRawError",null),ve([t.memoize],E.prototype,"onRawUpdateNotAvailable",null),ve([t.memoize],E.prototype,"onRawUpdateAvailable",null),ve([t.memoize],E.prototype,"onRawUpdateDownloaded",null),E=ve([J(0,h.ILifecycleMainService),J(1,D.IConfigurationService),J(2,b.ITelemetryService),J(3,y.IEnvironmentMainService),J(4,C.IRequestService),J(5,p.ILogService),J(6,I.IProductService)],E),e.DarwinUpdateService=E}),define(Z[236],ee([0,1,50,29,8,3,9,27,22,6,38,46]),function(H,e,v,t,k,R,D,y,h,p,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let b=class{constructor(E,S,f){if(this.lifecycleMainService=E,this.logService=f,this._state=C.State.Uninitialized,this._onStateChange=new R.Emitter,this.onStateChange=this._onStateChange.event,S.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(C.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,w=>this.logService.error(w))}get state(){return this._state}setState(E){this.logService.info("update#setState",E.type),this._state=E,this._onStateChange.fire(E)}scheduleCheckForUpdates(E=60*60*1e3){return(0,k.timeout)(E).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(E){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(E)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(E){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(E=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${E}`),!E&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}async _applySpecificUpdate(E){}};b=ve([J(0,h.ILifecycleMainService),J(1,y.IEnvironmentMainService),J(2,p.ILogService)],b);let g=class extends b{constructor(E,S,f,w,m,u){super(f,w,m);this.snap=E,this.snapRevision=S,this.telemetryService=u;const c=(0,t.watch)(D.dirname(this.snap)),s=R.Event.fromNodeEventEmitter(c,"change",(o,a)=>a),r=R.Event.filter(s,o=>o==="current"),n=R.Event.debounce(r,(o,a)=>a,2e3)(()=>this.checkForUpdates(!1));f.onWillShutdown(()=>{n.dispose(),c.close()})}doCheckForUpdates(){this.setState(C.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(E=>{E?this.setState(C.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(C.State.Idle(2)))},E=>{this.logService.error(E),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(C.State.Idle(2,E.message||E))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,v.spawn)("sleep 3 && "+D.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const E=await new Promise((f,w)=>(0,t.realpath)(`${D.dirname(this.snap)}/current`,(m,u)=>m?w(m):f(u))),S=D.basename(E);return this.snapRevision!==S}isLatestVersion(){return this.isUpdateAvailable().then(void 0,E=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};g=ve([J(2,h.ILifecycleMainService),J(3,y.IEnvironmentMainService),J(4,p.ILogService),J(5,I.ITelemetryService)],g),e.SnapUpdateService=g}),define(Z[53],ee([0,1,5]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,v.createDecorator)("IUriIdentityService")}),define(Z[237],ee([0,1,53,188,14,16,127,3,2]),function(H,e,v,t,k,R,D,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class p{constructor(b){this.uri=b,this.time=p._clock++}touch(){return this.time=p._clock++,this}}p._clock=0;let I=class{constructor(b){this._fileService=b,this._dispooables=new h.DisposableStore,this._limit=2**16;const g=new Map,d=E=>{let S=g.get(E.scheme);return S===void 0&&(S=b.hasProvider(E)&&!this._fileService.hasCapability(E,1024),g.set(E.scheme,S)),S};this._dispooables.add(y.Event.any(b.onDidChangeFileSystemProviderRegistrations,b.onDidChangeFileSystemProviderCapabilities)(E=>{g.delete(E.scheme)})),this.extUri=new R.ExtUri(d),this._canonicalUris=new D.SkipList((E,S)=>this.extUri.compare(E,S,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(b){this._fileService.hasProvider(b)&&(b=(0,R.normalizePath)(b));const g=this._canonicalUris.get(b);return g?g.touch().uri.with({fragment:b.fragment}):(this._canonicalUris.set(b,new p(b)),this._checkTrim(),b)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const b=[...this._canonicalUris.entries()].sort((d,E)=>d[1].touch<E[1].touch?1:d[1].touch>E[1].touch?-1:0);p._clock=0,this._canonicalUris.clear();const g=this._limit*.5;for(let d=0;d<g;d++)this._canonicalUris.set(b[d][0],b[d][1].touch())}};I=ve([J(0,k.IFileService)],I),e.UriIdentityService=I,(0,t.registerSingleton)(v.IUriIdentityService,I,!0)}),define(Z[113],ee([0,1,5]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,v.createDecorator)("urlService")}),define(Z[238],ee([0,1,7]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class t{constructor(y){this.handler=y}listen(y,h){throw new Error(`Event not found: ${h}`)}call(y,h,p){switch(h){case"handleURL":return this.handler.handleURL(v.URI.revive(p[0]),p[1])}throw new Error(`Call not found: ${h}`)}}e.URLHandlerChannel=t;class k{constructor(y){this.channel=y}handleURL(y,h){return this.channel.call("handleURL",[y.toJSON(),h])}}e.URLHandlerChannelClient=k;class R{constructor(y){this.next=y}async routeCall(y,h,p,I){if(h!=="handleURL")throw new Error(`Call not found: ${h}`);if(p){const C=v.URI.revive(p);if(C&&C.query){const b=/\bwindowId=(\d+)/.exec(C.query);if(b){const g=b[1],d=new RegExp(`window:${g}`),E=y.connections.find(S=>d.test(S.ctx));if(E)return E}}}return this.next.routeCall(y,h,p,I)}routeEvent(y,h){throw new Error(`Event not found: ${h}`)}}e.URLHandlerRouter=R}),define(Z[239],ee([0,1,8,2,7,20]),function(H,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class D extends t.Disposable{constructor(){super(...arguments);this.handlers=new Set}open(p,I){const C=[...this.handlers.values()];return(0,v.first)(C.map(b=>()=>b.handleURL(p,I)),void 0,!1).then(b=>b||!1)}registerHandler(p){return this.handlers.add(p),(0,t.toDisposable)(()=>this.handlers.delete(p))}}e.AbstractURLService=D;let y=class extends D{constructor(p){super();this.productService=p}create(p){let{authority:I,path:C,query:b,fragment:g}=p||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return I&&C&&C.indexOf("/")!==0&&(C=`/${C}`),k.URI.from({scheme:this.productService.urlProtocol,authority:I,path:C,query:b,fragment:g})}};y=ve([J(0,R.IProductService)],y),e.NativeURLService=y}),define(Z[240],ee([0,1,15,8,3,2,4,7]),function(H,e,v,t,k,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function h(I){try{return y.URI.parse(I)}catch{return null}}class p{constructor(C,b,g,d,E){if(this.urlService=b,this.uris=[],this.retryCount=0,this.flushDisposable=R.Disposable.None,this.disposables=new R.DisposableStore,this.uris=C,D.isWindows){const w=d.isBuilt?[]:[`"${d.appRoot}"`];w.push("--open-url","--"),v.app.setAsDefaultProtocolClient(E.urlProtocol,process.execPath,w)}const S=k.Event.map(k.Event.fromNodeEventEmitter(v.app,"open-url",(w,m)=>({event:w,url:m})),({event:w,url:m})=>(w.preventDefault(),m));this.disposables.add(S(w=>{const m=h(w);!m||this.urlService.open(m,{originalUrl:w})})),g.getWindows().filter(w=>w.isReady).length>0?this.flush():k.Event.once(g.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(this.retryCount++>10)return;const C=[];for(const b of this.uris)await this.urlService.open(b.uri,{originalUrl:b.url})||C.push(b);C.length!==0&&(this.uris=C,this.flushDisposable=(0,t.disposableTimeout)(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=p}),define(Z[241],ee([0,1,5]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,v.createDecorator)("webviewManagerService")}),define(Z[242],ee([0,1,15,2,13,7]),function(H,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class D extends t.Disposable{constructor(){super();const h=this.handleWebviewRequest.bind(this);v.protocol.registerFileProtocol(k.Schemas.vscodeWebview,h)}handleWebviewRequest(h,p){try{const I=R.URI.parse(h.url),C=D.validWebviewFilePaths.get(I.path);if(typeof C=="string"){const b=`vs/workbench/contrib/webview/browser/pre/${C}`,g=k.FileAccess.asFileUri(b,H);return p(decodeURIComponent(g.fsPath))}else return p({error:-10})}catch{}return p({error:-2})}}e.WebviewProtocolProvider=D,D.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}),define(Z[74],ee([0,1,4]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.useWindowControlsOverlay=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function t(I){return!!I.workspaceUri}e.isWorkspaceToOpen=t;function k(I){return!!I.folderUri}e.isFolderToOpen=k;function R(I){return!!I.fileUri}e.isFileToOpen=R;function D(I){const C=y(I),b=I.getValue("window.menuBarVisibility");return b==="default"||C==="native"&&b==="compact"||v.isMacintosh&&v.isNative?"classic":b}e.getMenuBarVisibility=D;function y(I){if(v.isWeb)return"custom";const C=I.getValue("window");if(C){if(v.isMacintosh&&C.nativeTabs===!0||v.isMacintosh&&C.nativeFullScreen===!1)return"native";const d=C.titleBarStyle;if(d==="native"||d==="custom")return d}return v.isLinux?"native":"custom"}e.getTitleBarStyle=y;function h(I,C){return!v.isWindows||v.isWeb||!C.isBuilt||y(I)==="native"?!1:I.getValue("window.experimental.windowControlsOverlay.enabled")}e.useWindowControlsOverlay=h;function p(I=0){return Math.pow(1.2,I)}e.zoomLevelToZoomFactor=p}),define(Z[114],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.defaultWindowState=e.UnloadReason=e.LoadReason=void 0;var v;(function(y){y[y.INITIAL=1]="INITIAL",y[y.LOAD=2]="LOAD",y[y.RELOAD=3]="RELOAD"})(v=e.LoadReason||(e.LoadReason={}));var t;(function(y){y[y.CLOSE=1]="CLOSE",y[y.QUIT=2]="QUIT",y[y.RELOAD=3]="RELOAD",y[y.LOAD=4]="LOAD"})(t=e.UnloadReason||(e.UnloadReason={}));const k=function(y=1){return{width:1024,height:768,mode:y}};e.defaultWindowState=k;var R;(function(y){y[y.Maximized=0]="Maximized",y[y.Normal=1]="Normal",y[y.Minimized=2]="Minimized",y[y.Fullscreen=3]="Fullscreen"})(R=e.WindowMode||(e.WindowMode={}));var D;(function(y){y[y.UNRESPONSIVE=1]="UNRESPONSIVE",y[y.CRASHED=2]="CRASHED",y[y.LOAD=3]="LOAD"})(D=e.WindowError||(e.WindowError={}))}),define(Z[33],ee([0,1,5]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenContext=e.IWindowsMainService=void 0,e.IWindowsMainService=(0,v.createDecorator)("windowsMainService");var t;(function(k){k[k.CLI=0]="CLI",k[k.DOCK=1]="DOCK",k[k.MENU=2]="MENU",k[k.DIALOG=3]="DIALOG",k[k.DESKTOP=4]="DESKTOP",k[k.API=5]="API"})(t=e.OpenContext||(e.OpenContext={}))}),define(Z[243],ee([0,1,15,21,3,67,2,28,69,102,6,20,33]),function(H,e,v,t,k,R,D,y,h,p,I,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var g;(function(E){E[E.Initial=1]="Initial",E[E.StoredCredentialsUsed=2]="StoredCredentialsUsed",E[E.LoginDialogShown=3]="LoginDialogShown"})(g||(g={}));let d=class extends D.Disposable{constructor(S,f,w,m,u){super();this.logService=S,this.windowsMainService=f,this.credentialsService=w,this.encryptionMainService=m,this.productService=u,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=g.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const S=k.Event.fromNodeEventEmitter(v.app,"login",(f,w,m,u,c)=>({event:f,webContents:w,req:m,authInfo:u,callback:c}));this._register(S(this.onLogin,this))}async onLogin({event:S,authInfo:f,req:w,callback:m}){if(!f.isProxy)return;if(!this.pendingProxyResolve&&this.state===g.LoginDialogShown&&w.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}S.preventDefault();let u;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),u=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(f);try{u=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}m(u?.username,u?.password)}async resolveProxyCredentials(S){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const f=await this.doResolveProxyCredentials(S);if(f)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),f;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(S){this.logService.trace("auth#doResolveProxyCredentials - enter",S);const f=String((0,R.hash)({scheme:S.scheme,host:S.host,port:S.port}));let w,m;try{const r=await this.credentialsService.getPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,f);if(r){const i=JSON.parse(await this.encryptionMainService.decrypt(r));w=i.username,m=i.password}}catch(r){this.logService.error(r)}if(this.state!==g.StoredCredentialsUsed&&typeof w=="string"&&typeof m=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=g.StoredCredentialsUsed,{username:w,password:m};const u=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!u){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${u.id} to handle proxy login`);const c={authInfo:S,username:this.sessionCredentials?.username??w,password:this.sessionCredentials?.password??m,replyChannel:`vscode:proxyAuthResponse:${(0,y.generateUuid)()}`};u.sendWhenReady("vscode:openProxyAuthenticationDialog",t.CancellationToken.None,c),this.state=g.LoginDialogShown;const s=await new Promise(r=>{const i=async(n,o,a)=>{if(o===c.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${u.id}`),u.win?.webContents.off("ipc-message",i),a){const l={username:a.username,password:a.password};try{if(a.remember){const P=await this.encryptionMainService.encrypt(JSON.stringify(l));await this.credentialsService.setPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,f,P)}else await this.credentialsService.deletePassword(this.PROXY_CREDENTIALS_SERVICE_KEY,f)}catch(P){this.logService.error(P)}r({username:l.username,password:l.password})}else r(void 0)};u.win?.webContents.on("ipc-message",i)});return this.sessionCredentials=s,s}};d=ve([J(0,I.ILogService),J(1,b.IWindowsMainService),J(2,h.ICredentialsMainService),J(3,p.IEncryptionMainService),J(4,C.IProductService)],d),e.ProxyAuthHandler=d}),define(Z[244],ee([0,1,69,6,37,20,33,200]),function(H,e,v,t,k,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsNativeMainService=void 0;let h=class extends y.BaseCredentialsMainService{constructor(I,C,b,g){super(I);this.environmentMainService=C,this.productService=b,this.windowsMainService=g,this.surfaceKeytarLoadError=d=>{this.windowsMainService.sendToFocused("vscode:showCredentialsError",d.message??d)}}async getSecretStoragePrefix(){return Promise.resolve(this.productService.urlProtocol)}async withKeytar(){if(this._keytarCache)return this._keytarCache;if(this.environmentMainService.disableKeytar)return this.logService.info("Keytar is disabled. Using in-memory credential store instead."),this._keytarCache=new v.InMemoryCredentialsProvider,this._keytarCache;const I=await new Promise((C,b)=>{H(["keytar"],C,b)});return await I.findCredentials("test-keytar-loads"),this._keytarCache=I,this._keytarCache}};h=ve([J(0,t.ILogService),J(1,k.INativeEnvironmentService),J(2,R.IProductService),J(3,D.IWindowsMainService)],h),e.CredentialsNativeMainService=h}),define(Z[245],ee([0,1,18,2,3,6,22,79,50,273,8,13,49,4,35,15,33]),function(H,e,v,t,k,R,D,y,h,p,I,C,b,g,d,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;const f=E.UtilityProcess,w=typeof f!="undefined";let m=class Lt{constructor(r,i,n){this._logService=r,this._windowsMainService=n,this._shutdown=!1,this._extHosts=new Map,i.onWillShutdown(o=>{this._shutdown=!0,o.join(this._waitForAllExit(6e3))})}dispose(){}_getExtHost(r){const i=this._extHosts.get(r);if(!i)throw new Error("Unknown extension host!");return i}onDynamicStdout(r){return this._getExtHost(r).onStdout}onDynamicStderr(r){return this._getExtHost(r).onStderr}onDynamicMessage(r){return this._getExtHost(r).onMessage}onDynamicError(r){return this._getExtHost(r).onError}onDynamicExit(r){return this._getExtHost(r).onExit}async canUseUtilityProcess(){return w}async createExtensionHost(r){if(this._shutdown)throw(0,v.canceled)();const i=String(++Lt._lastId);let n;if(r){if(!w)throw new Error("Cannot use UtilityProcess!");n=new c(i,this._logService,this._windowsMainService)}else n=new u(i,this._logService);return this._extHosts.set(i,n),n.onExit(({pid:o,code:a,signal:l})=>{this._logService.info(`Extension host with pid ${o} exited with code: ${a}, signal: ${l}.`),setTimeout(()=>{n.dispose(),this._extHosts.delete(i)})}),{id:i}}async start(r,i){if(this._shutdown)throw(0,v.canceled)();return this._getExtHost(r).start(i)}async enableInspectPort(r){if(this._shutdown)throw(0,v.canceled)();const i=this._extHosts.get(r);return i?i.enableInspectPort():!1}async kill(r){if(this._shutdown)throw(0,v.canceled)();const i=this._extHosts.get(r);!i||i.kill()}async _killAllNow(){for(const[,r]of this._extHosts)r.kill()}async _waitForAllExit(r){const i=[];for(const[,n]of this._extHosts)i.push(n.waitForExit(r));return I.Promises.settled(i).then(()=>{})}};m._lastId=0,m=ve([J(0,R.ILogService),J(1,D.ILifecycleMainService),J(2,S.IWindowsMainService)],m),e.ExtensionHostStarter=m;let u=class extends t.Disposable{constructor(r,i){super();this.id=r,this._logService=i,this._onStdout=this._register(new k.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this._register(new k.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this._register(new k.Emitter),this.onMessage=this._onMessage.event,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._onExit=this._register(new k.Emitter),this.onExit=this._onExit.event,this._process=null,this._hasExited=!1}start(r){g.isCI&&this._logService.info("Calling fork to start extension host...");const i=y.StopWatch.create(!1);this._process=(0,h.fork)(C.FileAccess.asFileUri("bootstrap-fork",H).fsPath,["--type=extensionHost","--skipWorkspaceStorageLock"],(0,b.mixin)({cwd:(0,d.cwd)()},r));const n=i.elapsed(),o=this._process.pid;this._logService.info(`Starting extension host with pid ${o} (fork() took ${n} ms).`);const a=new p.StringDecoder("utf-8");this._process.stdout?.on("data",P=>{const M=typeof P=="string"?P:a.write(P);this._onStdout.fire(M)});const l=new p.StringDecoder("utf-8");this._process.stderr?.on("data",P=>{const M=typeof P=="string"?P:l.write(P);this._onStderr.fire(M)}),this._process.on("message",P=>{this._onMessage.fire(P)}),this._process.on("error",P=>{this._onError.fire({error:(0,v.transformErrorForSerialization)(P)})}),this._process.on("exit",(P,M)=>{this._hasExited=!0,this._onExit.fire({pid:o,code:P,signal:M})})}enableInspectPort(){return this._process?(this._logService.info(`Enabling inspect port on extension host with pid ${this._process.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this._process.pid),!0):g.isWindows?!1:(this._process.kill("SIGUSR1"),!0)):!1}kill(){!this._process||(this._logService.info(`Killing extension host with pid ${this._process.pid}.`),this._process.kill())}async waitForExit(r){if(!this._process)return;const i=this._process.pid;this._logService.info(`Waiting for extension host with pid ${i} to exit.`),await Promise.race([k.Event.toPromise(this.onExit),(0,I.timeout)(r)]),this._hasExited||(this._logService.info(`Extension host with pid ${i} did not exit within ${r}ms.`),this._process.kill())}};u=ve([J(1,R.ILogService)],u);let c=class extends t.Disposable{constructor(r,i,n){super();this.id=r,this._logService=i,this._windowsMainService=n,this.onStdout=k.Event.None,this.onStderr=k.Event.None,this.onError=k.Event.None,this._onMessage=this._register(new k.Emitter),this.onMessage=this._onMessage.event,this._onExit=this._register(new k.Emitter),this.onExit=this._onExit.event,this._process=null,this._hasExited=!1}start(r){const i=this._windowsMainService.getWindowById(r.responseWindowId);if(!i){this._logService.info(`UtilityProcess<${this.id}>: Refusing to create new Extension Host UtilityProcess because requesting window cannot be found...`);return}const n=i.win;if(!n||n.isDestroyed()||n.webContents.isDestroyed()){this._logService.info(`UtilityProcess<${this.id}>: Refusing to create new Extension Host UtilityProcess because requesting window cannot be found...`);return}const o=`extensionHost${this.id}`,a=C.FileAccess.asFileUri("bootstrap-fork.js",H).fsPath,l=["--type=extensionHost","--skipWorkspaceStorageLock"],P=r.execArgv||[],M={...r.env};for(const Q of Object.keys(M))M[Q]=String(M[Q]);this._logService.info(`UtilityProcess<${this.id}>: Creating new...`),this._process=new f(a,l,{serviceName:o,env:M,execArgv:P}),this._register(k.Event.fromNodeEventEmitter(this._process,"spawn")(()=>{this._logService.info(`UtilityProcess<${this.id}>: received spawn event.`)})),this._register(k.Event.fromNodeEventEmitter(this._process,"exit")(Q=>{Q=Q||0,this._logService.info(`UtilityProcess<${this.id}>: received exit event with code ${Q}.`),this._hasExited=!0,this._onExit.fire({pid:this._process.pid,code:Q,signal:""})}));const T=(Q,re)=>{re.type==="Utility"&&re.name===o&&(this._logService.info(`UtilityProcess<${this.id}>: terminated unexpectedly with code ${re.exitCode}.`),this._hasExited=!0,this._onExit.fire({pid:this._process.pid,code:re.exitCode,signal:""}))};E.app.on("child-process-gone",T),this._register((0,t.toDisposable)(()=>{E.app.off("child-process-gone",T)}));const{port1:F,port2:U}=new E.MessageChannelMain;this._process.postMessage("port",null,[U]),n.webContents.postMessage(r.responseChannel,r.responseNonce,[F])}enableInspectPort(){return this._process?(this._logService.info(`UtilityProcess<${this.id}>: Enabling inspect port on extension host with pid ${this._process.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this._process.pid),!0):g.isWindows?!1:(this._process.kill("SIGUSR1"),!0)):!1}kill(){!this._process||(this._logService.info(`UtilityProcess<${this.id}>: Killing extension host with pid ${this._process.pid}.`),this._process.kill())}async waitForExit(r){if(!this._process)return;const i=this._process.pid;this._logService.info(`UtilityProcess<${this.id}>: Waiting for extension host with pid ${i} to exit.`),await Promise.race([k.Event.toPromise(this.onExit),(0,I.timeout)(r)]),this._hasExited||(this._logService.info(`UtilityProcess<${this.id}>: Extension host with pid ${i} did not exit within ${r}ms, will kill it now.`),this._process.kill())}};c=ve([J(1,R.ILogService),J(2,S.IWindowsMainService)],c)}),define(Z[246],ee([0,1,15,3,2,242,33]),function(H,e,v,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let y=class extends k.Disposable{constructor(p){super();this.windowsMainService=p,this._onFoundInFrame=this._register(new t.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new R.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(p,I){let C;if(typeof p.windowId=="number"){const{windowId:b}=p,g=this.windowsMainService.getWindowById(b);if(!g?.win)throw new Error(`Invalid windowId: ${b}`);C=g.win.webContents}else{const{webContentsId:b}=p;if(C=v.webContents.fromId(b),!C)throw new Error(`Invalid webContentsId: ${b}`)}C.isDestroyed()||C.setIgnoreMenuShortcuts(I)}async findInFrame(p,I,C,b){const d=this.getFrameByName(p,I);if(typeof d.findInFrame=="function"){d.findInFrame(C,{findNext:b.findNext,forward:b.forward});const E=(S,f)=>{f.finalUpdate&&(this._onFoundInFrame.fire(f),d.removeListener("found-in-frame",E))};d.on("found-in-frame",E)}}async stopFindInFrame(p,I,C){const g=this.getFrameByName(p,I);typeof g.stopFindInFrame=="function"&&g.stopFindInFrame(C.keepSelection?"keepSelection":"clearSelection")}getFrameByName(p,I){const C=this.windowsMainService.getWindowById(p.windowId);if(!C?.win)throw new Error(`Invalid windowId: ${p}`);const b=C.win.webContents.mainFrame.framesInSubtree.find(g=>g.name===I);if(!b)throw new Error(`Unknown frame: ${I}`);return b}};y=ve([J(0,D.IWindowsMainService)],y),e.WebviewMainService=y}),define(Z[247],ee([0,1,8,3,2]),function(H,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class R extends k.Disposable{constructor({onDidOpenWindow:y,onDidFocusWindow:h,getActiveWindowId:p}){super();this.disposables=this._register(new k.DisposableStore),t.Event.latch(t.Event.any(y,h))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,v.createCancelablePromise)(()=>p()),(async()=>{try{const C=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:C}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(y){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=y}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=R}),define(Z[25],ee([0,1,173,9,32,16,7,5,13]),function(H,e,v,t,k,R,D,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,y.createDecorator)("contextService");function p(i){const n=i;return typeof n?.id=="string"&&D.URI.isUri(n.uri)}e.isSingleFolderWorkspaceIdentifier=p;function I(i){if(i.configuration)return{id:i.id,configPath:i.configuration};if(i.folders.length===1)return{id:i.id,uri:i.folders[0].uri}}e.toWorkspaceIdentifier=I;function C(i){const n=i;return typeof n?.id=="string"&&D.URI.isUri(n.configPath)}e.isWorkspaceIdentifier=C;function b(i){const n=i;if(n?.uri)return{id:n.id,uri:D.URI.revive(n.uri)};const o=i;if(o?.configPath)return{id:o.id,configPath:D.URI.revive(o.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=b;var g;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(g=e.WorkbenchState||(e.WorkbenchState={}));function d(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.isWorkspace=d;function E(i){const n=i;return!!(n&&typeof n=="object"&&D.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.isWorkspaceFolder=E;class S{constructor(n,o,a,l,P){this._id=n,this._transient=a,this._configuration=l,this._ignorePathCasing=P,this._foldersMap=k.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=o}update(n){this._id=n.id,this._configuration=n.configuration,this._transient=n.transient,this._ignorePathCasing=n._ignorePathCasing,this.folders=n.folders}get folders(){return this._folders}set folders(n){this._folders=n,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(n){this._configuration=n}getFolder(n){return n&&this._foldersMap.findSubstr(n)||null}updateFoldersMap(){this._foldersMap=k.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const n of this.folders)this._foldersMap.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=S;class f{constructor(n,o){this.raw=o,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,R.joinPath)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=f;function w(i){return new f({uri:i,index:0,name:(0,R.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=w,e.WORKSPACE_EXTENSION="code-workspace";const m=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,v.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function u(i,n){return R.extUriBiasedIgnorePathCase.isEqualOrParent(i,n.untitledWorkspacesHome)}e.isUntitledWorkspace=u;function c(i){let n;return D.URI.isUri(i)?n=i:n=i.configuration,n?.scheme===h.Schemas.tmp}e.isTemporaryWorkspace=c;function s(i,n){return!u(i,n)&&!c(i)}e.isSavedWorkspace=s;function r(i){return(typeof i=="string"?(0,t.extname)(i):(0,R.extname)(i))===m}e.hasWorkspaceFileExtension=r}),define(Z[248],ee([0,1,76,29,31,13,9,4,16,7,23,177,19,27,14,6,176,25]),function(H,e,v,t,k,R,D,y,h,p,I,C,b,g,d,E,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let w=class{constructor(u,c,s){this.configurationService=c,this.logService=s,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=h.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(r,i)=>(0,k.isEqual)(r,i,!y.isLinux)},this.backupHome=u.backupHome,this.workspacesJsonPath=u.backupWorkspacesPath}async initialize(){let u;try{u=JSON.parse(await I.Promises.readFile(this.workspacesJsonPath,"utf8"))}catch{u=Object.create(null)}this.emptyWindows=await this.validateEmptyWorkspaces(u.emptyWorkspaceInfos);let c=[];try{Array.isArray(u.rootURIWorkspaces)&&(c=u.rootURIWorkspaces.map(r=>({workspace:{id:r.id,configPath:p.URI.parse(r.configURIPath)},remoteAuthority:r.remoteAuthority})))}catch{}this.workspaces=await this.validateWorkspaces(c);let s=[];try{Array.isArray(u.folderWorkspaceInfos)?s=u.folderWorkspaceInfos.map(r=>({folderUri:p.URI.parse(r.folderUri),remoteAuthority:r.remoteAuthority})):Array.isArray(u.folderURIWorkspaces)&&(s=u.folderURIWorkspaces.map(r=>({folderUri:p.URI.parse(r),remoteAuthority:void 0})))}catch{}this.folders=await this.validateFolders(s),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==d.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===d.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||d.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(u,c){this.workspaces.some(r=>u.workspace.id===r.workspace.id)||(this.workspaces.push(u),this.saveSync());const s=this.getBackupPath(u.workspace.id);return c&&this.moveBackupFolderSync(s,c),s}moveBackupFolderSync(u,c){if(t.existsSync(u)&&this.convertToEmptyWindowBackupSync(u),t.existsSync(c))try{t.renameSync(c,u)}catch(s){this.logService.error(`Backup: Could not move backup folder to new location: ${s.toString()}`)}}unregisterWorkspaceBackupSync(u){const c=u.id,s=this.workspaces.findIndex(r=>r.workspace.id===c);s!==-1&&(this.workspaces.splice(s,1),this.saveSync())}registerFolderBackupSync(u){return this.folders.some(c=>this.backupUriComparer.isEqual(u.folderUri,c.folderUri))||(this.folders.push(u),this.saveSync()),this.getBackupPath(this.getFolderHash(u))}unregisterFolderBackupSync(u){const c=this.folders.findIndex(s=>this.backupUriComparer.isEqual(u,s.folderUri));c!==-1&&(this.folders.splice(c,1),this.saveSync())}registerEmptyWindowBackupSync(u,c){const s=u||this.getRandomEmptyWindowId();return this.emptyWindows.some(r=>!!r.backupFolder&&this.backupPathComparer.isEqual(r.backupFolder,s))||(this.emptyWindows.push({backupFolder:s,remoteAuthority:c}),this.saveSync()),this.getBackupPath(s)}unregisterEmptyWindowBackupSync(u){const c=this.emptyWindows.findIndex(s=>!!s.backupFolder&&this.backupPathComparer.isEqual(s.backupFolder,u));c!==-1&&(this.emptyWindows.splice(c,1),this.saveSync())}getBackupPath(u){return(0,D.join)(this.backupHome,u)}async validateWorkspaces(u){if(!Array.isArray(u))return[];const c=new Set,s=[];for(const r of u){const i=r.workspace;if(!(0,f.isWorkspaceIdentifier)(i))return[];if(!c.has(i.id)){c.add(i.id);const n=this.getBackupPath(i.id);await this.doHasBackups(n)?i.configPath.scheme!==R.Schemas.file||await I.Promises.exists(i.configPath.fsPath)?s.push(r):await this.convertToEmptyWindowBackup(n):await this.deleteStaleBackup(n)}}return s}async validateFolders(u){if(!Array.isArray(u))return[];const c=[],s=new Set;for(const r of u){const i=r.folderUri,n=this.backupUriComparer.getComparisonKey(i);if(!s.has(n)){s.add(n);const o=this.getBackupPath(this.getFolderHash(r));await this.doHasBackups(o)?i.scheme!==R.Schemas.file||await I.Promises.exists(i.fsPath)?c.push(r):await this.convertToEmptyWindowBackup(o):await this.deleteStaleBackup(o)}}return c}async validateEmptyWorkspaces(u){if(!Array.isArray(u))return[];const c=[],s=new Set;for(const r of u){const i=r.backupFolder;if(typeof i!="string")return[];if(!s.has(i)){s.add(i);const n=this.getBackupPath(i);await this.doHasBackups(n)?c.push(r):await this.deleteStaleBackup(n)}}return c}async deleteStaleBackup(u){try{await I.Promises.exists(u)&&await I.Promises.rm(u,I.RimRafMode.MOVE)}catch(c){this.logService.error(`Backup: Could not delete stale backup: ${c.toString()}`)}}async convertToEmptyWindowBackup(u){let c=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(r=>!!r.backupFolder&&this.backupPathComparer.isEqual(r.backupFolder,c));)c=this.getRandomEmptyWindowId();const s=this.getBackupPath(c);try{await I.Promises.rename(u,s)}catch(r){return this.logService.error(`Backup: Could not rename backup folder: ${r.toString()}`),!1}return this.emptyWindows.push({backupFolder:c}),!0}convertToEmptyWindowBackupSync(u){let c=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(r=>!!r.backupFolder&&this.backupPathComparer.isEqual(r.backupFolder,c));)c=this.getRandomEmptyWindowId();const s=this.getBackupPath(c);try{t.renameSync(u,s)}catch(r){return this.logService.error(`Backup: Could not rename backup folder: ${r.toString()}`),!1}return this.emptyWindows.push({backupFolder:c}),!0}async getDirtyWorkspaces(){const u=[];for(const c of this.workspaces)await this.hasBackups(c)&&u.push(c);for(const c of this.folders)await this.hasBackups(c)&&u.push(c);return u}hasBackups(u){let c;return(0,C.isEmptyWindowBackupInfo)(u)?c=u.backupFolder:(0,S.isFolderBackupInfo)(u)?c=this.getBackupPath(this.getFolderHash(u)):c=this.getBackupPath(u.workspace.id),this.doHasBackups(c)}async doHasBackups(u){try{const c=await I.Promises.readdir(u);for(const s of c)try{if((await I.Promises.readdir((0,D.join)(u,s))).length>0)return!0}catch{}}catch{}return!1}saveSync(){try{(0,I.writeFileSync)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(u){this.logService.error(`Backup: Could not save workspaces.json: ${u.toString()}`)}}async save(){try{await I.Promises.writeFile(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(u){this.logService.error(`Backup: Could not save workspaces.json: ${u.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(u=>({id:u.workspace.id,configURIPath:u.workspace.configPath.toString(),remoteAuthority:u.remoteAuthority})),folderWorkspaceInfos:this.folders.map(u=>({folderUri:u.folderUri.toString(),remoteAuthority:u.remoteAuthority})),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(u){const c=u.folderUri;let s;return c.scheme===R.Schemas.file?s=y.isLinux?c.fsPath:c.fsPath.toLowerCase():s=c.toString().toLowerCase(),(0,v.createHash)("md5").update(s).digest("hex")}};w=ve([J(0,g.IEnvironmentMainService),J(1,b.IConfigurationService),J(2,E.ILogService)],w),e.BackupMainService=w}),define(Z[54],ee([0,1,15,8,67,36,2,80,4,12,23,151,5,6,25]),function(H,e,v,t,k,R,D,y,h,p,I,C,b,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,b.createDecorator)("dialogMainService");let E=class{constructor(f){this.logService=f,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new t.Queue}pickFileFolder(f,w){return this.doPick({...f,pickFolders:!0,pickFiles:!0,title:(0,C.localize)(0,null)},w)}pickFolder(f,w){return this.doPick({...f,pickFolders:!0,title:(0,C.localize)(1,null)},w)}pickFile(f,w){return this.doPick({...f,pickFiles:!0,title:(0,C.localize)(2,null)},w)}pickWorkspace(f,w){const m=(0,C.localize)(3,null),u=(0,R.mnemonicButtonLabel)((0,C.localize)(4,null)),c=d.WORKSPACE_FILTER;return this.doPick({...f,pickFiles:!0,title:m,filters:c,buttonLabel:u},w)}async doPick(f,w){const m={title:f.title,buttonLabel:f.buttonLabel,filters:f.filters,defaultPath:f.defaultPath};(typeof f.pickFiles=="boolean"||typeof f.pickFolders=="boolean")&&(m.properties=void 0,f.pickFiles&&f.pickFolders&&(m.properties=["multiSelections","openDirectory","openFile","createDirectory"])),m.properties||(m.properties=["multiSelections",f.pickFolders?"openDirectory":"openFile","createDirectory"]),h.isMacintosh&&m.properties.push("treatPackageAsDirectory");const u=await this.showOpenDialog(m,(0,p.withNullAsUndefined)(w||v.BrowserWindow.getFocusedWindow()));if(u&&u.filePaths&&u.filePaths.length>0)return u.filePaths}getWindowDialogQueue(f){if(f){let w=this.windowDialogQueues.get(f.id);return w||(w=new t.Queue,this.windowDialogQueues.set(f.id,w)),w}else return this.noWindowDialogueQueue}showMessageBox(f,w){return this.getWindowDialogQueue(w).queue(async()=>w?v.dialog.showMessageBox(w,f):v.dialog.showMessageBox(f))}async showSaveDialog(f,w){const m=this.acquireFileDialogLock(f,w);if(!m)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.getWindowDialogQueue(w).queue(async()=>{let u;return w?u=await v.dialog.showSaveDialog(w,f):u=await v.dialog.showSaveDialog(f),u.filePath=this.normalizePath(u.filePath),u})}finally{(0,D.dispose)(m)}}normalizePath(f){return f&&h.isMacintosh&&(f=(0,y.normalizeNFC)(f)),f}normalizePaths(f){return f.map(w=>this.normalizePath(w))}async showOpenDialog(f,w){f.defaultPath&&(await I.Promises.exists(f.defaultPath)||(f.defaultPath=void 0));const m=this.acquireFileDialogLock(f,w);if(!m)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(w).queue(async()=>{let u;return w?u=await v.dialog.showOpenDialog(w,f):u=await v.dialog.showOpenDialog(f),u.filePaths=this.normalizePaths(u.filePaths),u})}finally{(0,D.dispose)(m)}}acquireFileDialogLock(f,w){if(!w)return D.Disposable.None;this.logService.trace("[DialogMainService]: request to acquire file dialog lock",f);let m=this.windowFileDialogLocks.get(w.id);m||(m=new Set,this.windowFileDialogLocks.set(w.id,m));const u=(0,k.hash)(f);if(!m.has(u))return this.logService.trace("[DialogMainService]: new file dialog lock created",f),m.add(u),(0,D.toDisposable)(()=>{this.logService.trace("[DialogMainService]: file dialog lock disposed",f),m?.delete(u),m?.size===0&&this.windowFileDialogLocks.delete(w.id)})}};E=ve([J(0,g.ILogService)],E),e.DialogMainService=E}),define(Z[249],ee([0,1,3,2,57,25]),function(H,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class D extends t.Disposable{constructor(h,p){super();this.logService=h,this.storageMainService=p,this.onDidChangeApplicationStorageEmitter=this._register(new v.Emitter),this.mapProfileToOnDidChangeProfileStorageEmitter=new Map,this.registerStorageChangeListeners(p.applicationStorage,this.onDidChangeApplicationStorageEmitter)}registerStorageChangeListeners(h,p){this._register(v.Event.debounce(h.onDidChangeStorage,(I,C)=>(I?I.push(C):I=[C],I),D.STORAGE_CHANGE_DEBOUNCE_TIME)(I=>{I.length&&p.fire(this.serializeStorageChangeEvents(I,h))}))}serializeStorageChangeEvents(h,p){const I=new Map,C=new Set;return h.forEach(b=>{const g=p.get(b.key);typeof g=="string"?I.set(b.key,g):C.add(b.key)}),{changed:Array.from(I.entries()),deleted:Array.from(C.values())}}listen(h,p,I){switch(p){case"onDidChangeStorage":{const C=I.profile?(0,k.revive)(I.profile):void 0;if(!C)return this.onDidChangeApplicationStorageEmitter.event;let b=this.mapProfileToOnDidChangeProfileStorageEmitter.get(C.id);return b||(b=this._register(new v.Emitter),this.registerStorageChangeListeners(this.storageMainService.profileStorage(C),b),this.mapProfileToOnDidChangeProfileStorageEmitter.set(C.id,b)),b.event}}throw new Error(`Event not found: ${p}`)}async call(h,p,I){const C=I.profile?(0,k.revive)(I.profile):void 0,b=(0,R.reviveIdentifier)(I.workspace),g=await this.withStorageInitialized(C,b);switch(p){case"getItems":return Array.from(g.items.entries());case"updateItems":{const d=I;if(d.insert)for(const[E,S]of d.insert)g.set(E,S);d.delete?.forEach(E=>g.delete(E));break}default:throw new Error(`Call not found: ${p}`)}}async withStorageInitialized(h,p){let I;p?I=this.storageMainService.workspaceStorage(p):h?I=this.storageMainService.profileStorage(h):I=this.storageMainService.applicationStorage;try{await I.init()}catch(C){this.logService.error(`StorageIPC#init: Unable to init ${p?"workspace":h?"profile":"application"} storage due to ${C}`)}return I}}e.StorageDatabaseChannel=D,D.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(Z[34],ee([0,1,67,3,2,16,12,7,170,37,14,5,6,25,32,53,8,28]),function(H,e,v,t,k,R,D,y,h,p,I,C,b,g,d,E,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.toUserDataProfile=e.EXTENSIONS_RESOURCE_NAME=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function w(s){const r=s;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&typeof r.isDefault=="boolean"&&typeof r.name=="string"&&y.URI.isUri(r.location)&&y.URI.isUri(r.globalStorageHome)&&y.URI.isUri(r.settingsResource)&&y.URI.isUri(r.keybindingsResource)&&y.URI.isUri(r.tasksResource)&&y.URI.isUri(r.snippetsHome)&&((0,D.isUndefined)(r.extensionsResource)||y.URI.isUri(r.extensionsResource)))}e.isUserDataProfile=w,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,C.createDecorator)("IUserDataProfilesService");function m(s,r){return{id:s.id,isDefault:s.isDefault,name:s.name,location:y.URI.revive(s.location).with({scheme:r}),globalStorageHome:y.URI.revive(s.globalStorageHome).with({scheme:r}),settingsResource:y.URI.revive(s.settingsResource).with({scheme:r}),keybindingsResource:y.URI.revive(s.keybindingsResource).with({scheme:r}),tasksResource:y.URI.revive(s.tasksResource).with({scheme:r}),snippetsHome:y.URI.revive(s.snippetsHome).with({scheme:r}),extensionsResource:y.URI.revive(s.extensionsResource)?.with({scheme:r})}}e.reviveProfile=m,e.EXTENSIONS_RESOURCE_NAME="extensions.json";function u(s,r,i){return{id:(0,v.hash)(r.path).toString(16),name:s,location:r,isDefault:!1,globalStorageHome:(0,R.joinPath)(r,"globalStorage"),settingsResource:(0,R.joinPath)(r,"settings.json"),keybindingsResource:(0,R.joinPath)(r,"keybindings.json"),tasksResource:(0,R.joinPath)(r,"tasks.json"),snippetsHome:(0,R.joinPath)(r,"snippets"),extensionsResource:(0,R.joinPath)(r,e.EXTENSIONS_RESOURCE_NAME),useDefaultFlags:i}}e.toUserDataProfile=u;let c=class extends k.Disposable{constructor(r,i,n,o){super();this.environmentService=r,this.fileService=i,this.uriIdentityService=n,this.logService=o,this.enabled=!1,this.defaultProfileShouldIncludeExtensionsResourceAlways=!1,this._onDidChangeProfiles=this._register(new t.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new t.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new t.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new t.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profilesHome=(0,R.joinPath)(this.environmentService.userRoamingDataHome,"profiles")}get defaultProfile(){return this.profiles[0]}get profiles(){return this.profilesObject.profiles}setEnablement(r){this.enabled!==r&&(this._profilesObject=void 0,this.enabled=r)}get profilesObject(){if(!this._profilesObject){const r=this.enabled?this.getStoredProfiles().map(a=>u(a.name,a.location,a.useDefaultFlags)):[];let i;const n=new d.ResourceMap,o=u((0,h.localize)(0,null),this.environmentService.userRoamingDataHome);if(r.unshift({...o,isDefault:!0,extensionsResource:this.defaultProfileShouldIncludeExtensionsResourceAlways||r.length>0?o.extensionsResource:void 0}),r.length){const a=this.getStoredProfileAssociations();if(a.workspaces)for(const[l,P]of Object.entries(a.workspaces)){const M=y.URI.parse(l),T=y.URI.parse(P),F=r.find(U=>this.uriIdentityService.extUri.isEqual(U.location,T));F&&n.set(M,F)}if(a.emptyWindow){const l=y.URI.parse(a.emptyWindow);i=r.find(P=>this.uriIdentityService.extUri.isEqual(P.location,l))}}this._profilesObject={profiles:r,workspaces:n,emptyWindow:i}}return this._profilesObject}getProfile(r,i){if(!this.enabled)return this.defaultProfile;const n=this.getWorkspace(r);let o=y.URI.isUri(n)?this.profilesObject.workspaces.get(n):this.profilesObject.emptyWindow;return o||(o=i,this.profiles.length>1&&this.updateWorkspaceAssociation(r,o)),o}getWorkspace(r){return(0,g.isSingleFolderWorkspaceIdentifier)(r)?r.uri:(0,g.isWorkspaceIdentifier)(r)?r.configPath:"empty-window"}async createProfile(r,i,n){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(this.getStoredProfiles().some(l=>l.name===r))throw new Error(`Profile with name ${r} already exists`);const o=u(r,(0,R.joinPath)(this.profilesHome,(0,v.hash)((0,f.generateUuid)()).toString(16)),i);await this.fileService.createFolder(o.location);const a=[];return this._onWillCreateProfile.fire({profile:o,join(l){a.push(l)}}),await S.Promises.settled(a),this.updateProfiles([o],[],[]),n&&await this.setProfileForWorkspace(o,n),o}async updateProfile(r,i,n){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let o=this.profiles.find(a=>a.id===r.id);if(!o)throw new Error(`Profile '${r.name}' does not exist`);return o=u(i,o.location,n),this.updateProfiles([],[],[o]),o}async setProfileForWorkspace(r,i){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const n=this.profiles.find(o=>o.id===r.id);if(!n)throw new Error(`Profile '${r.name}' does not exist`);this.updateWorkspaceAssociation(i,n)}async unsetWorkspace(r){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.updateWorkspaceAssociation(r)}async resetWorkspaces(){this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindow=void 0,this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async removeProfile(r){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(r.isDefault)throw new Error("Cannot remove default profile");const i=this.profiles.find(o=>o.id===r.id);if(!i)throw new Error(`Profile '${r.name}' does not exist`);const n=[];this._onWillRemoveProfile.fire({profile:i,join(o){n.push(o)}}),await S.Promises.settled(n),i.id===this.profilesObject.emptyWindow?.id&&(this.profilesObject.emptyWindow=void 0);for(const o of[...this.profilesObject.workspaces.keys()])i.id===this.profilesObject.workspaces.get(o)?.id&&this.profilesObject.workspaces.delete(o);this.updateStoredProfileAssociations(),this.updateProfiles([],[i],[]);try{this.profiles.length===1?await this.fileService.del(this.profilesHome,{recursive:!0}):await this.fileService.del(i.location,{recursive:!0})}catch(o){this.logService.error(o)}}updateProfiles(r,i,n){const o=[];for(let a of[...this.profilesObject.profiles,...r])a.isDefault||i.some(l=>a.id===l.id)||(a=n.find(l=>a.id===l.id)??a,o.push({location:a.location,name:a.name,useDefaultFlags:a.useDefaultFlags}));this.saveStoredProfiles(o),this._profilesObject=void 0,this.triggerProfilesChanges(r,i,n)}triggerProfilesChanges(r,i,n){this._onDidChangeProfiles.fire({added:r,removed:i,updated:n,all:this.profiles})}updateWorkspaceAssociation(r,i){const n=this.getWorkspace(r);y.URI.isUri(n)?(this.profilesObject.workspaces.delete(n),i&&this.profilesObject.workspaces.set(n,i)):this.profilesObject.emptyWindow=i,this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const r={};for(const[n,o]of this.profilesObject.workspaces.entries())r[n.toString()]=o.location.toString();const i=this.profilesObject.emptyWindow?.location.toString();this.saveStoredProfileAssociations({workspaces:r,emptyWindow:i}),this._profilesObject=void 0}getStoredProfiles(){return[]}saveStoredProfiles(r){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(r){throw new Error("not implemented")}};c.PROFILES_KEY="userDataProfiles",c.PROFILE_ASSOCIATIONS_KEY="profileAssociations",c=ve([J(0,p.IEnvironmentService),J(1,I.IFileService),J(2,E.IUriIdentityService),J(3,b.ILogService)],c),e.UserDataProfilesService=c}),define(Z[89],ee([0,1,24,8,49,17,18,42,137,2,13,9,4,16,186,94,12,7,155,37,109,108,185,14,5,6,20,3,57,72,34,53]),function(H,e,v,t,k,R,D,y,h,p,I,C,b,g,d,E,S,f,w,m,u,c,s,r,i,n,o,a,l,P,M,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var F;(function(le){function K(N,_){if(N===_)return!0;const A=Object.keys(N),W=new Set;for(const $ of Object.keys(_))W.add($);if(A.length!==W.size)return!1;for(const $ of A){if(N[$]!==_[$])return!1;W.delete($)}return W.size===0}le.equals=K})(F=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,i.createDecorator)("IExtensionsScannerService");let U=class extends p.Disposable{constructor(K,N,_,A,W,$,Y,z,j,L,O){super();this.systemExtensionsLocation=K,this.userExtensionsLocation=N,this.extensionsControlLocation=_,this.cacheLocation=A,this.userDataProfilesService=W,this.extensionsProfileScannerService=$,this.fileService=Y,this.logService=z,this.environmentService=j,this.productService=L,this.instantiationService=O,this._onDidChangeCache=this._register(new a.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,g.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(ue,(0,g.joinPath)(this.cacheLocation,c.BUILTIN_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(ue,(0,g.joinPath)(this.cacheLocation,c.USER_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(re,this.obsoleteFile)),this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,u.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(K,N){const[_,A]=await Promise.all([this.scanSystemExtensions(K),this.scanUserExtensions(N)]),W=await this.scanExtensionsUnderDevelopment(K,[..._,...A]);return this.dedupExtensions(_,A,W,await this.getTargetPlatform(),!0)}async scanSystemExtensions(K){const N=[];N.push(this.scanDefaultSystemExtensions(!!K.useCache,K.language)),N.push(this.scanDevSystemExtensions(K.language,!!K.checkControlFile));const[_,A]=await Promise.all(N);return this.applyScanOptions([..._,...A],0,K,!1)}async scanUserExtensions(K){this.logService.trace("Started scanning user extensions");const N=await this.createExtensionScannerInput(K.profileLocation??this.userExtensionsLocation,!!K.profileLocation,1,!K.includeUninstalled,K.language);let A=await(K.useCache&&!N.devMode&&N.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner).scanExtensions(N);return A=await this.applyScanOptions(A,1,K,!0),this.logService.trace("Scanned user extensions:",A.length),A}async scanExtensionsUnderDevelopment(K,N){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const _=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(A=>A.scheme===I.Schemas.file).map(async A=>{const W=await this.createExtensionScannerInput(A,!1,1,!0,K.language,!1);return(await this.extensionsScanner.scanOneOrMultipleExtensions(W)).map(Y=>(Y.type=N.find(z=>(0,u.areSameExtensions)(z.identifier,Y.identifier))?.type??Y.type,this.extensionsScanner.validate(Y,W)))}))).flat();return this.applyScanOptions(_,"development",K,!0)}return[]}async scanExistingExtension(K,N,_){const A=await this.createExtensionScannerInput(K,!1,N,!0,_.language),W=await this.extensionsScanner.scanExtension(A);return!W||!_.includeInvalid&&!W.isValid?null:W}async scanOneOrMultipleExtensions(K,N,_){const A=await this.createExtensionScannerInput(K,!1,N,!0,_.language),W=await this.extensionsScanner.scanOneOrMultipleExtensions(A);return this.applyScanOptions(W,N,_,!0)}async scanMetadata(K){const N=(0,g.joinPath)(K,"package.json"),_=(await this.fileService.readFile(N)).value.toString();return JSON.parse(_).__metadata}async updateMetadata(K,N){const _=(0,g.joinPath)(K,"package.json"),A=(await this.fileService.readFile(_)).value.toString(),W=JSON.parse(A);N.isMachineScoped=N.isMachineScoped||void 0,N.isBuiltin=N.isBuiltin||void 0,N.installedTimestamp=N.installedTimestamp||void 0,W.__metadata={...W.__metadata,...N},await this.fileService.writeFile((0,g.joinPath)(K,"package.json"),R.VSBuffer.fromString(JSON.stringify(W,null,"	")))}async applyScanOptions(K,N,_,A){return _.includeAllVersions||(K=this.dedupExtensions(N===0?K:void 0,N===1?K:void 0,N==="development"?K:void 0,await this.getTargetPlatform(),A)),_.includeInvalid||(K=K.filter(W=>W.isValid)),K.sort((W,$)=>{const Y=C.basename(W.location.fsPath),z=C.basename($.location.fsPath);return Y<z?-1:Y>z?1:0})}dedupExtensions(K,N,_,A,W){const $=(z,j,L)=>{if(z.isValid&&!j.isValid)return!1;if(z.isValid===j.isValid){if(W&&d.gt(z.manifest.version,j.manifest.version))return this.logService.debug(`Skipping extension ${j.location.path} with lower version ${j.manifest.version} in favour of ${z.location.path} with version ${z.manifest.version}`),!1;if(d.eq(z.manifest.version,j.manifest.version)){if(z.type===0)return this.logService.debug(`Skipping extension ${j.location.path} in favour of system extension ${z.location.path} with same version`),!1;if(z.targetPlatform===A)return this.logService.debug(`Skipping extension ${j.location.path} from different target platform ${j.targetPlatform}`),!1}}return L?this.logService.warn(`Overwriting user extension ${z.location.path} with ${j.location.path}.`):this.logService.debug(`Overwriting user extension ${z.location.path} with ${j.location.path}.`),!0},Y=new Map;return K?.forEach(z=>{const j=c.ExtensionIdentifier.toKey(z.identifier.id),L=Y.get(j);(!L||$(L,z,!1))&&Y.set(j,z)}),N?.forEach(z=>{const j=c.ExtensionIdentifier.toKey(z.identifier.id),L=Y.get(j);if(!L&&K&&z.type===0){this.logService.debug(`Skipping obsolete system extension ${z.location.path}.`);return}(!L||$(L,z,!1))&&Y.set(j,z)}),_?.forEach(z=>{const j=c.ExtensionIdentifier.toKey(z.identifier.id),L=Y.get(j);(!L||$(L,z,!0))&&Y.set(j,z),Y.set(j,z)}),[...Y.values()]}async scanDefaultSystemExtensions(K,N){this.logService.trace("Started scanning system extensions");const _=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,N),W=await(K&&!_.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(_);return this.logService.trace("Scanned system extensions:",W.length),W}async scanDevSystemExtensions(K,N){const _=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!_?.length)return[];this.logService.trace("Started scanning dev system extensions");const A=N?await this.getBuiltInExtensionControl():{},W=[],$=f.URI.file(C.normalize(C.join(I.FileAccess.asFileUri("",H).fsPath,"..",".build","builtInExtensions")));for(const z of _){const j=A[z.name]||"marketplace";switch(j){case"disabled":break;case"marketplace":W.push((0,g.joinPath)($,z.name));break;default:W.push(f.URI.file(j));break}}const Y=await Promise.all(W.map(async z=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(z,!1,0,!0,K))));return this.logService.trace("Scanned dev system extensions:",Y.length),(0,v.coalesce)(Y)}async getBuiltInExtensionControl(){try{const K=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(K.value.toString())}catch{return{}}}async createExtensionScannerInput(K,N,_,A,W,$=!0){const Y=await this.getTranslations(W??b.language),z=await this.getMtime(K),j=N?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,L=j?await this.getMtime(j):void 0;return new Q(K,z,j,L,N,_,A,$,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,W,Y)}async getMtime(K){try{const N=await this.fileService.stat(K);if(typeof N.mtime=="number")return N.mtime}catch{}}};U=ve([J(4,M.IUserDataProfilesService),J(5,P.IExtensionsProfileScannerService),J(6,r.IFileService),J(7,n.ILogService),J(8,m.IEnvironmentService),J(9,o.IProductService),J(10,i.IInstantiationService)],U),e.AbstractExtensionsScannerService=U;class Q{constructor(K,N,_,A,W,$,Y,z,j,L,O,B,V,x){this.location=K,this.mtime=N,this.applicationExtensionslocation=_,this.applicationExtensionslocationMtime=A,this.profile=W,this.type=$,this.excludeObsolete=Y,this.validate=z,this.productVersion=j,this.productDate=L,this.productCommit=O,this.devMode=B,this.language=V,this.translations=x}static createNlsConfiguration(K){return{language:K.language,pseudo:K.language==="pseudo",devMode:K.devMode,translations:K.translations}}static equals(K,N){return(0,g.isEqual)(K.location,N.location)&&K.mtime===N.mtime&&(0,g.isEqual)(K.applicationExtensionslocation,N.applicationExtensionslocation)&&K.applicationExtensionslocationMtime===N.applicationExtensionslocationMtime&&K.profile===N.profile&&K.type===N.type&&K.excludeObsolete===N.excludeObsolete&&K.validate===N.validate&&K.productVersion===N.productVersion&&K.productDate===N.productDate&&K.productCommit===N.productCommit&&K.devMode===N.devMode&&K.language===N.language&&F.equals(K.translations,N.translations)}}let re=class extends p.Disposable{constructor(K,N,_,A,W){super();this.obsoleteFile=K,this.extensionsProfileScannerService=N,this.uriIdentityService=_,this.fileService=A,this.logService=W}async scanExtensions(K){const N=K.profile?await this.scanExtensionsFromProfile(K):await this.scanExtensionsFromLocation(K);let _={};if(K.excludeObsolete&&K.type===1)try{const A=(await this.fileService.readFile(this.obsoleteFile)).value.toString();_=JSON.parse(A)}catch{}return(0,S.isEmptyObject)(_)?N:N.filter(A=>!_[u.ExtensionKey.create(A).toString()])}async scanExtensionsFromLocation(K){const N=await this.fileService.resolve(K.location);if(!N.children?.length)return[];const _=await Promise.all(N.children.map(async A=>{if(!A.isDirectory||K.type===1&&(0,g.basename)(A.resource).indexOf(".")===0)return null;const W=new Q(A.resource,K.mtime,K.applicationExtensionslocation,K.applicationExtensionslocationMtime,K.profile,K.type,K.excludeObsolete,K.validate,K.productVersion,K.productDate,K.productCommit,K.devMode,K.language,K.translations);return this.scanExtension(W)}));return(0,v.coalesce)(_).sort((A,W)=>A.location.path<W.location.path?-1:1)}async scanExtensionsFromProfile(K){let N=await this.scanExtensionsFromProfileResource(K.location,()=>!0,K);if(K.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(K.location,K.applicationExtensionslocation)){N=N.filter(A=>!A.metadata?.isApplicationScoped);const _=await this.scanExtensionsFromProfileResource(K.applicationExtensionslocation,A=>!!A.metadata?.isApplicationScoped,K);N.push(..._)}return N}async scanExtensionsFromProfileResource(K,N,_){const A=await this.extensionsProfileScannerService.scanProfileExtensions(K);if(!A.length)return[];const W=await Promise.all(A.map(async $=>{if(N($)){const Y=new Q($.location,_.mtime,_.applicationExtensionslocation,_.applicationExtensionslocationMtime,_.profile,_.type,_.excludeObsolete,_.validate,_.productVersion,_.productDate,_.productCommit,_.devMode,_.language,_.translations);return this.scanExtension(Y,$.metadata)}return null}));return(0,v.coalesce)(W)}async scanOneOrMultipleExtensions(K){try{if(await this.fileService.exists((0,g.joinPath)(K.location,"package.json"))){const N=await this.scanExtension(K);return N?[N]:[]}else return await this.scanExtensions(K)}catch(N){return this.logService.error(`Error scanning extensions at ${K.location.path}:`,(0,D.getErrorMessage)(N)),[]}}async scanExtension(K,N){try{let _=await this.scanExtensionManifest(K.location);if(_){_.publisher||(_.publisher=c.UNDEFINED_PUBLISHER),N=N??_.__metadata,delete _.__metadata;const A=(0,u.getGalleryExtensionId)(_.publisher,_.name),W=N?.id?{id:A,uuid:N.id}:{id:A},$=N?.isSystem?0:K.type,Y=$===0||!!N?.isBuiltin;_=await this.translateManifest(K.location,_,Q.createNlsConfiguration(K));const z={type:$,identifier:W,manifest:_,location:K.location,isBuiltin:Y,targetPlatform:N?.targetPlatform??"undefined",metadata:N,isValid:!0,validations:[]};return K.validate?this.validate(z,K):z}}catch(_){K.type!==0&&this.logService.error(_)}return null}validate(K,N){let _=!0;const A=(0,s.validateExtensionManifest)(N.productVersion,N.productDate,N.location,K.manifest,K.isBuiltin);for(const[W,$]of A)W===E.default.Error&&(_=!1,this.logService.error(this.formatMessage(N.location,$)));return K.isValid=_,K.validations=A,K}async scanExtensionManifest(K){const N=(0,g.joinPath)(K,"package.json");let _;try{_=(await this.fileService.readFile(N)).value.toString()}catch(W){return(0,r.toFileOperationResult)(W)!==1&&this.logService.error(this.formatMessage(K,(0,w.localize)(0,null,N.path,W.message))),null}let A;try{A=JSON.parse(_)}catch{const $=[];(0,y.parse)(_,$);for(const Y of $)this.logService.error(this.formatMessage(K,(0,w.localize)(1,null,N.path,Y.offset,Y.length,(0,h.getParseErrorMessage)(Y.error))));return null}return(0,y.getNodeType)(A)!=="object"?(this.logService.error(this.formatMessage(K,(0,w.localize)(2,null,N.path))),null):A}async translateManifest(K,N,_){const A=await this.getLocalizedMessages(K,N,_);if(A)try{const W=[],$=await this.resolveOriginalMessageBundle(A.default,W);if(W.length>0)return W.forEach(z=>{this.logService.error(this.formatMessage(K,(0,w.localize)(3,null,A.default?.path,(0,h.getParseErrorMessage)(z.error))))}),N;if((0,y.getNodeType)(A)!=="object")return this.logService.error(this.formatMessage(K,(0,w.localize)(4,null,A.default?.path))),N;const Y=A.values||Object.create(null);this.replaceNLStrings(_.pseudo,N,Y,$,K)}catch{}return N}async getLocalizedMessages(K,N,_){const A=(0,g.joinPath)(K,"package.nls.json"),W=(j,L)=>{L.forEach(O=>{this.logService.error(this.formatMessage(K,(0,w.localize)(5,null,j?.path,(0,h.getParseErrorMessage)(O.error))))})},$=j=>{this.logService.error(this.formatMessage(K,(0,w.localize)(6,null,j?.path)))},Y=`${N.publisher}.${N.name}`,z=_.translations[Y];if(z)try{const j=f.URI.file(z),L=(await this.fileService.readFile(j)).value.toString(),O=[],B=(0,y.parse)(L,O);return O.length>0?(W(j,O),{values:void 0,default:A}):(0,y.getNodeType)(B)!=="object"?($(j),{values:void 0,default:A}):{values:B.contents?B.contents.package:void 0,default:A}}catch{return{values:void 0,default:A}}else{if(!await this.fileService.exists(A))return;let L;try{L=await this.findMessageBundles(K,_)}catch{return}if(!L.localized)return{values:void 0,default:L.original};try{const O=(await this.fileService.readFile(L.localized)).value.toString(),B=[],V=(0,y.parse)(O,B);return B.length>0?(W(L.localized,B),{values:void 0,default:L.original}):(0,y.getNodeType)(V)!=="object"?($(L.localized),{values:void 0,default:L.original}):{values:V,default:L.original}}catch{return{values:void 0,default:L.original}}}}async resolveOriginalMessageBundle(K,N){if(K)try{const _=(await this.fileService.readFile(K)).value.toString();return(0,y.parse)(_,N)}catch{return null}else return null}findMessageBundles(K,N){return new Promise((_,A)=>{const W=$=>{const Y=(0,g.joinPath)(K,`package.nls.${$}.json`);this.fileService.exists(Y).then(z=>{z&&_({localized:Y,original:(0,g.joinPath)(K,"package.nls.json")});const j=$.lastIndexOf("-");j===-1?_({localized:(0,g.joinPath)(K,"package.nls.json"),original:null}):($=$.substring(0,j),W($))})};if(N.devMode||N.pseudo||!N.language)return _({localized:(0,g.joinPath)(K,"package.nls.json"),original:null});W(N.language)})}replaceNLStrings(K,N,_,A,W){const $=(Y,z,j)=>{const L=Y[z];if((0,S.isString)(L)){const O=L,B=O.length;if(B>1&&O[0]==="%"&&O[B-1]==="%"){const V=O.substr(1,B-2);let x=_[V];x===void 0&&A&&(x=A[V]);let ie=typeof x=="string"?x:x.message;if(ie!==void 0)if(K&&(ie="\uFF3B"+ie.replace(/[aouei]/g,"$&$&")+"\uFF3D"),j&&A&&(z==="title"||z==="category")){const q=A[V],te={value:ie,original:typeof q=="string"?q:q?.message};Y[z]=te}else Y[z]=ie;else this.logService.warn(this.formatMessage(W,(0,w.localize)(7,null,V)))}}else if((0,S.isObject)(L))for(const O in L)L.hasOwnProperty(O)&&(O==="commands"?$(L,O,!0):$(L,O,j));else if(Array.isArray(L))for(let O=0;O<L.length;O++)$(L,O,j)};for(const Y in N)N.hasOwnProperty(Y)&&$(N,Y)}formatMessage(K,N){return`[${K.path}]: ${N}`}};re=ve([J(1,P.IExtensionsProfileScannerService),J(2,T.IUriIdentityService),J(3,r.IFileService),J(4,n.ILogService)],re);let ue=class extends re{constructor(K,N,_,A,W,$){super(N,_,A,W,$);this.cacheFile=K,this.cacheValidatorThrottler=this._register(new t.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new a.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(K){const N=await this.readExtensionCache();if(this.input=K,N&&N.input&&Q.equals(N.input,this.input))return this.cacheValidatorThrottler.trigger(()=>this.validateCache()),N.result.map(A=>(A.location=f.URI.revive(A.location),A));const _=await super.scanExtensions(K);return await this.writeExtensionCache({input:K,result:_}),_}async readExtensionCache(){try{const K=await this.fileService.readFile(this.cacheFile),N=JSON.parse(K.value.toString());return{result:N.result,input:(0,l.revive)(N.input)}}catch(K){this.logService.debug("Error while reading the extension cache file:",this.cacheFile.path,(0,D.getErrorMessage)(K))}return null}async writeExtensionCache(K){try{await this.fileService.writeFile(this.cacheFile,R.VSBuffer.fromString(JSON.stringify(K)))}catch(N){this.logService.debug("Error while writing the extension cache file:",this.cacheFile.path,(0,D.getErrorMessage)(N))}}async validateCache(){if(!this.input)return;const K=await this.readExtensionCache();if(!K)return;const N=K.result,_=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!k.equals(_,N))try{await this.fileService.del(this.cacheFile),this._onDidChangeCache.fire()}catch(A){this.logService.error(A)}}};ue=ve([J(2,P.IExtensionsProfileScannerService),J(3,T.IUriIdentityService),J(4,r.IFileService),J(5,n.ILogService)],ue);function fe(le,K){const N=(0,u.getExtensionId)(le.manifest.publisher,le.manifest.name);return{id:N,identifier:new c.ExtensionIdentifier(N),isBuiltin:le.type===0,isUserBuiltin:le.type===1&&le.isBuiltin,isUnderDevelopment:K,extensionLocation:le.location,uuid:le.identifier.uuid,targetPlatform:le.targetPlatform,...le.manifest}}e.toExtensionDescription=fe;class se extends U{constructor(K,N,_,A,W,$,Y,z,j,L,O){super(K,N,(0,g.joinPath)(_,".vscode-oss-dev","extensions","control.json"),(0,g.joinPath)(A,c.MANIFEST_CACHE_FOLDER),W,$,Y,z,j,L,O);this.translationsPromise=(async()=>{if(b.translationsConfigFile)try{const B=await this.fileService.readFile(f.URI.file(b.translationsConfigFile));return JSON.parse(B.value.toString())}catch{}return Object.create(null)})()}getTranslations(K){return this.translationsPromise}}e.NativeExtensionsScannerService=se}),define(Z[250],ee([0,1,7,37,72,89,14,5,6,20,34]),function(H,e,v,t,k,R,D,y,h,p,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let C=class extends R.NativeExtensionsScannerService{constructor(g,d,E,S,f,w,m){super(v.URI.file(f.builtinExtensionsPath),v.URI.file(f.extensionsPath),f.userHome,v.URI.file(f.userDataPath),g,d,E,S,f,w,m)}};C=ve([J(0,I.IUserDataProfilesService),J(1,k.IExtensionsProfileScannerService),J(2,D.IFileService),J(3,h.ILogService),J(4,t.INativeEnvironmentService),J(5,p.IProductService),J(6,y.IInstantiationService)],C),e.ExtensionsScannerService=C}),define(Z[251],ee([0,1,15,40,2,32,13,9,4,7,28,37,6,34]),function(H,e,v,t,k,R,D,y,h,p,I,C,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let d=class extends k.Disposable{constructor(S,f,w){super();this.logService=w,this.validRoots=R.TernarySearchTree.forPaths(!h.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(S.appRoot),this.addValidFileRoot(S.extensionsPath),this.addValidFileRoot(f.defaultProfile.globalStorageHome.fsPath),this.addValidFileRoot(S.workspaceStorageHome.fsPath),this.handleProtocols()}handleProtocols(){const{defaultSession:S}=v.session;S.protocol.registerFileProtocol(D.Schemas.vscodeFileResource,(f,w)=>this.handleResourceRequest(f,w)),S.protocol.interceptFileProtocol(D.Schemas.file,(f,w)=>this.handleFileRequest(f,w)),this._register((0,k.toDisposable)(()=>{S.protocol.unregisterProtocol(D.Schemas.vscodeFileResource),S.protocol.uninterceptProtocol(D.Schemas.file)}))}addValidFileRoot(S){const f=(0,y.normalize)(S);return this.validRoots.get(f)?k.Disposable.None:(this.validRoots.set(f,!0),(0,k.toDisposable)(()=>this.validRoots.delete(f)))}handleFileRequest(S,f){const w=p.URI.parse(S.url);return this.logService.error(`Refused to load resource ${w.fsPath} from ${D.Schemas.file}: protocol (original URL: ${S.url})`),f({error:-3})}handleResourceRequest(S,f){const w=this.requestToNormalizedFilePath(S);return this.validRoots.findSubstr(w)?f({path:w}):this.validExtensions.has((0,y.extname)(w))?f({path:w}):(this.logService.error(`${D.Schemas.vscodeFileResource}: Refused to load resource ${w} from ${D.Schemas.vscodeFileResource}: protocol (original URL: ${S.url})`),f({error:-3}))}requestToNormalizedFilePath(S){const f=p.URI.parse(S.url),w=D.FileAccess.asFileUri(f);return(0,y.normalize)(w.fsPath)}createIPCObjectUrl(){let S;const f=p.URI.from({scheme:"vscode",path:(0,I.generateUuid)()}),w=f.toString(),m=async()=>S;return t.validatedIpcMain.handle(w,m),this.logService.trace(`IPC Object URL: Registered new channel ${w}.`),{resource:f,update:u=>S=u,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${w}.`),t.validatedIpcMain.removeHandler(w)}}}};d=ve([J(0,C.INativeEnvironmentService),J(1,g.IUserDataProfilesService),J(2,b.ILogService)],d),e.ProtocolMainService=d}),define(Z[252],ee([0,1,15,40,8,3,2,13,12,99,27,22,6,60,61,64,43,34,39]),function(H,e,v,t,k,R,D,y,h,p,I,C,b,g,d,E,S,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let m=class extends D.Disposable{constructor(c,s,r,i,n,o,a,l,P){super();this.machineId=c,this.userEnv=s,this.environmentMainService=r,this.userDataProfilesService=i,this.lifecycleMainService=n,this.logService=o,this.policyService=a,this.themeMainService=l,this.protocolMainService=P,this.firstWindowConnectionBarrier=new k.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new R.Emitter),this.onDidError=R.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){t.validatedIpcMain.on("vscode:createSharedProcessMessageChannel",(c,s)=>this.onWindowConnection(c,s)),t.validatedIpcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(c,s)=>this.onWorkerConnection(c,s)),this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown()))}async onWindowConnection(c,s){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const r=await this.connect();if(c.sender.isDestroyed())return r.close();c.sender.postMessage("vscode:createSharedProcessMessageChannelResult",s,[r])}onWorkerConnection(c,s){this.logService.trace("SharedProcess: onWorkerConnection",s);const r=new D.DisposableStore,i=o=>{!this.isAlive()||(this.logService.trace(`SharedProcess: disposing worker (reason: '${o}')`,s),r.dispose(),this.send("vscode:electron-main->shared-process=disposeWorker",s))},n=v.BrowserWindow.fromId(s.reply.windowId);if(!n||n.isDestroyed()||n.webContents.isDestroyed()||!s.reply.channel){i("unavailable");return}r.add(R.Event.filter(this.lifecycleMainService.onWillLoadWindow,o=>o.window.win===n)(()=>i("load"))),r.add(R.Event.fromNodeEventEmitter(n,"closed")(()=>i("closed"))),n.webContents.postMessage(s.reply.channel,s.reply.nonce,c.ports)}onWillShutdown(){const c=this.window;!c||(this.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(c.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{c.close()}catch{}this.window=void 0},0))}send(c,...s){if(!this.isAlive()){this.logService.warn(`Sending IPC message to channel '${c}' for shared process window that is destroyed`);return}try{this.window?.webContents.send(c,...s)}catch(r){this.logService.warn(`Error sending IPC message to channel '${c}' of shared process: ${(0,S.toErrorMessage)(r)}`)}}whenReady(){return this._whenReady||(this._whenReady=new Promise(c=>t.validatedIpcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),c()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(c=>t.validatedIpcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),c()}))})()),this._whenIpcReady}createWindow(){const c=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new v.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:y.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",H).fsPath,additionalArguments:[`--vscode-window-config=${c.resource.toString()}`,"--vscode-window-kind=shared-process"],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,images:!1,webgl:!1}}),c.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,codeCachePath:this.environmentMainService.codeCachePath,backupWorkspacesPath:this.environmentMainService.backupWorkspacesPath,profiles:this.userDataProfilesService.profiles,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:g.default,policiesData:this.policyService.serialize()}),this.window.loadURL(y.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",H).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=c=>{this.logService.trace("SharedProcess#close prevented"),c.preventDefault(),this.window?.isVisible()&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(c,s)=>this._onDidError.fire({type:2,details:s})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1})),this.window.webContents.on("did-fail-load",(c,s,r)=>this._onDidError.fire({type:3,details:{reason:r,exitCode:s}})))}async connect(){await this.whenIpcReady;const c=(0,h.assertIsDefined)(this.window);return(0,p.connect)(c)}async toggle(){await this.whenIpcReady,!!this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){return this.window?.isVisible()??!1}isAlive(){const c=this.window;return c?!c.isDestroyed()&&!c.webContents.isDestroyed():!1}};m=ve([J(2,I.IEnvironmentMainService),J(3,f.IUserDataProfilesService),J(4,C.ILifecycleMainService),J(5,b.ILogService),J(6,w.IPolicyService),J(7,E.IThemeMainService),J(8,d.IProtocolMainService)],m),e.SharedProcess=m}),define(Z[115],ee([0,1,8,3,2,71,12,100,5,34]),function(H,e,v,t,k,R,D,y,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const I="__$__targetStorageMarker";e.IStorageService=(0,h.createDecorator)("storageService");var C;(function(w){w[w.NONE=0]="NONE",w[w.SHUTDOWN=1]="SHUTDOWN"})(C=e.WillSaveStateReason||(e.WillSaveStateReason={}));var b;(function(w){w[w.APPLICATION=-1]="APPLICATION",w[w.PROFILE=0]="PROFILE",w[w.WORKSPACE=1]="WORKSPACE"})(b=e.StorageScope||(e.StorageScope={}));var g;(function(w){w[w.USER=0]="USER",w[w.MACHINE=1]="MACHINE"})(g=e.StorageTarget||(e.StorageTarget={}));class d extends k.Disposable{constructor(m={flushInterval:d.DEFAULT_FLUSH_INTERVAL}){super();this.options=m,this._onDidChangeValue=this._register(new t.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new t.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new t.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new v.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new k.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,v.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,k.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,R.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(m,u){if(u===I){switch(m){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:m})}else this._onDidChangeValue.fire({scope:m,key:u,target:this.getKeyTargets(m)[u]})}emitWillSaveState(m){this._onWillSaveState.fire({reason:m})}get(m,u,c){return this.getStorage(u)?.get(m,c)}getBoolean(m,u,c){return this.getStorage(u)?.getBoolean(m,c)}getNumber(m,u,c){return this.getStorage(u)?.getNumber(m,c)}store(m,u,c,s){if((0,D.isUndefinedOrNull)(u)){this.remove(m,c);return}this.withPausedEmitters(()=>{this.updateKeyTarget(m,c,s),this.getStorage(c)?.set(m,u)})}remove(m,u){this.withPausedEmitters(()=>{this.updateKeyTarget(m,u,void 0),this.getStorage(u)?.delete(m)})}withPausedEmitters(m){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{m()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(m,u){const c=[],s=this.getKeyTargets(m);for(const r of Object.keys(s))s[r]===u&&c.push(r);return c}updateKeyTarget(m,u,c){const s=this.getKeyTargets(u);typeof c=="number"?s[m]!==c&&(s[m]=c,this.getStorage(u)?.set(I,JSON.stringify(s))):typeof s[m]=="number"&&(delete s[m],this.getStorage(u)?.set(I,JSON.stringify(s)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(m){switch(m){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(m){const u=this.get(I,m);if(u)try{return JSON.parse(u)}catch{}return Object.create(null)}isNew(m){return this.getBoolean(e.IS_NEW_KEY,m)===!0}async flush(m=C.NONE){this._onWillSaveState.fire({reason:m});const u=this.getStorage(-1),c=this.getStorage(0),s=this.getStorage(1);switch(m){case C.NONE:await v.Promises.settled([u?.whenFlushed()??Promise.resolve(),c?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve()]);break;case C.SHUTDOWN:await v.Promises.settled([u?.flush(0)??Promise.resolve(),c?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve()]);break}}async log(){const m=this.getStorage(-1)?.items??new Map,u=this.getStorage(0)?.items??new Map,c=this.getStorage(1)?.items??new Map;return f(m,u,c,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(m,u){return this.emitWillSaveState(C.NONE),(0,p.isUserDataProfile)(m)?this.switchToProfile(m,u):this.switchToWorkspace(m,u)}canSwitchProfile(m,u){return!(m.id===u.id||E(u)&&E(m))}switchData(m,u,c,s){this.withPausedEmitters(()=>{if(s)for(const[r,i]of m)u.set(r,i);else{const r=new Set;for(const[i,n]of m)r.add(i),u.get(i)!==n&&this.emitDidChangeValue(c,i);for(const[i]of u.items)r.has(i)||this.emitDidChangeValue(c,i)}})}}e.AbstractStorageService=d,d.DEFAULT_FLUSH_INTERVAL=60*1e3;function E(w){return w.isDefault||!!w.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=E;class S extends d{constructor(){super();this.applicationStorage=this._register(new y.Storage(new y.InMemoryStorageDatabase)),this.profileStorage=this._register(new y.Storage(new y.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new y.Storage(new y.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(m=>this.emitDidChangeValue(1,m))),this._register(this.profileStorage.onDidChangeStorage(m=>this.emitDidChangeValue(0,m))),this._register(this.applicationStorage.onDidChangeStorage(m=>this.emitDidChangeValue(-1,m)))}getStorage(m){switch(m){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(m){switch(m){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}}e.InMemoryStorageService=S;async function f(w,m,u,c,s,r){const i=U=>{try{return JSON.parse(U)}catch{return U}},n=new Map,o=new Map;w.forEach((U,Q)=>{n.set(Q,U),o.set(Q,i(U))});const a=new Map,l=new Map;m.forEach((U,Q)=>{a.set(Q,U),l.set(Q,i(U))});const P=new Map,M=new Map;u.forEach((U,Q)=>{P.set(Q,U),M.set(Q,i(U))}),console.group(c!==s?`Storage: Application (path: ${c})`:`Storage: Application & Profile (path: ${c}, default profile)`);const T=[];if(n.forEach((U,Q)=>{T.push({key:Q,value:U})}),console.table(T),console.groupEnd(),console.log(o),c!==s){console.group(`Storage: Profile (path: ${s}, profile specific)`);const U=[];a.forEach((Q,re)=>{U.push({key:re,value:Q})}),console.table(U),console.groupEnd(),console.log(l)}console.group(`Storage: Workspace (path: ${r})`);const F=[];P.forEach((U,Q)=>{F.push({key:Q,value:U})}),console.table(F),console.groupEnd(),console.log(M)}e.logStorage=f}),define(Z[253],ee([0,1,24,8,3,2,9,79,7,23,100,148,6,115,38,25]),function(H,e,v,t,k,R,D,y,h,p,I,C,b,g,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageMain=e.WorkspaceStorageMain=e.ApplicationStorageMain=e.ProfileStorageMain=void 0;class S extends R.Disposable{constructor(r,i){super();this.logService=r,this.fileService=i,this._onDidChangeStorage=this._register(new k.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new k.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this._storage=new I.Storage(new I.InMemoryStorageDatabase),this.initializePromise=void 0,this.whenInitPromise=new t.DeferredPromise,this.whenInit=this.whenInitPromise.p,this.state=I.StorageState.None}get storage(){return this._storage}init(){return this.initializePromise||(this.initializePromise=(async()=>{if(this.state===I.StorageState.None)try{const r=await this.doCreate();this._storage.dispose(),this._storage=r,this._register(r.onDidChangeStorage(n=>this._onDidChangeStorage.fire({key:n}))),await this.doInit(r);const i=r.getBoolean(g.IS_NEW_KEY);i===void 0?r.set(g.IS_NEW_KEY,!0):i&&r.set(g.IS_NEW_KEY,!1)}catch(r){this.logService.error(`[storage main] initialize(): Unable to init storage due to ${r}`)}finally{this.state=I.StorageState.Initialized,this.whenInitPromise.complete()}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===b.LogLevel.Trace?r=>this.logService.trace(r):void 0,logError:r=>this.logService.error(r)}}doInit(r){return r.init()}get items(){return this._storage.items}get(r,i){return this._storage.get(r,i)}set(r,i){return this._storage.set(r,i)}delete(r){return this._storage.delete(r)}async close(){const r=new y.StopWatch(!1);await this.doClose(),r.stop(),r.elapsed()>S.LOG_SLOW_CLOSE_THRESHOLD&&await this.logSlowClose(r),this._onDidCloseStorage.fire()}async logSlowClose(r){if(!!this.path)try{const i=(0,v.top)(Array.from(this._storage.items.entries()).map(([o,a])=>({key:o,length:a.length})),(o,a)=>a.length-o.length,5).map(o=>`${o.key}:${o.length}`).join(", "),n=(await this.fileService.stat(h.URI.file(this.path))).size;this.logService.warn(`[storage main] detected slow close() operation: Time: ${r.elapsed()}ms, DB size: ${n}b, Large Keys: ${i}`)}catch(i){this.logService.error("[storage main] figuring out stats for slow DB on close() resulted in an error",i)}}async doClose(){this.initializePromise&&await this.initializePromise,this.state=I.StorageState.Closed,await this._storage.close()}}S.LOG_SLOW_CLOSE_THRESHOLD=2e3;class f extends S{constructor(r,i,n,o){super(n,o);this.profile=r,this.options=i}get path(){if(!this.options.useInMemoryStorage)return(0,D.join)(this.profile.globalStorageHome.fsPath,f.STORAGE_NAME)}async doCreate(){return new I.Storage(new C.SQLiteStorageDatabase(this.path??C.SQLiteStorageDatabase.IN_MEMORY_PATH,{logging:this.createLoggingOptions()}))}}f.STORAGE_NAME="state.vscdb";class w extends f{constructor(r,i,n,o){super(r,i,n,o)}}e.ProfileStorageMain=w;class m extends f{constructor(r,i,n,o){super(i.defaultProfile,r,n,o)}async doInit(r){await super.doInit(r),this.updateTelemetryState(r)}updateTelemetryState(r){r.get(d.firstSessionDateStorageKey,void 0)===void 0&&r.set(d.firstSessionDateStorageKey,new Date().toUTCString());const n=r.get(d.currentSessionDateStorageKey,void 0),o=new Date().toUTCString();r.set(d.lastSessionDateStorageKey,typeof n=="undefined"?null:n),r.set(d.currentSessionDateStorageKey,o)}}e.ApplicationStorageMain=m;class u extends S{constructor(r,i,n,o,a){super(n,a);this.workspace=r,this.options=i,this.environmentService=o}get path(){if(!this.options.useInMemoryStorage)return(0,D.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id,u.WORKSPACE_STORAGE_NAME)}async doCreate(){const{storageFilePath:r,wasCreated:i}=await this.prepareWorkspaceStorageFolder();return new I.Storage(new C.SQLiteStorageDatabase(r,{logging:this.createLoggingOptions()}),{hint:i?I.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:C.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const r=(0,D.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),i=(0,D.join)(r,u.WORKSPACE_STORAGE_NAME);return await p.Promises.exists(r)?{storageFilePath:i,wasCreated:!1}:(await p.Promises.mkdir(r,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(r),{storageFilePath:i,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(r){let i;if((0,E.isSingleFolderWorkspaceIdentifier)(this.workspace)?i={folder:this.workspace.uri.toString()}:(0,E.isWorkspaceIdentifier)(this.workspace)&&(i={workspace:this.workspace.configPath.toString()}),i)try{const n=(0,D.join)(r,u.WORKSPACE_META_NAME);await p.Promises.exists(n)||await p.Promises.writeFile(n,JSON.stringify(i,void 0,2))}catch(n){this.logService.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${n}`)}}}e.WorkspaceStorageMain=u,u.WORKSPACE_STORAGE_NAME="state.vscdb",u.WORKSPACE_META_NAME="workspace.json";class c extends S{get path(){}async doCreate(){return new I.Storage(new I.InMemoryStorageDatabase)}}e.InMemoryStorageMain=c}),define(Z[254],ee([0,1,57,37,14,6,223,53,34]),function(H,e,v,t,k,R,D,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=void 0;let p=class Pt extends h.UserDataProfilesService{constructor(C,b,g,d,E){super(g,d,b,E);this.stateService=C}getStoredProfiles(){return(0,v.revive)(this.stateService.getItem(Pt.PROFILES_KEY,[]))}getStoredProfileAssociations(){return(0,v.revive)(this.stateService.getItem(Pt.PROFILE_ASSOCIATIONS_KEY,{}))}};p=ve([J(0,D.IStateService),J(1,y.IUriIdentityService),J(2,t.IEnvironmentService),J(3,k.IFileService),J(4,R.ILogService)],p),e.UserDataProfilesService=p}),define(Z[65],ee([0,1,7,37,14,5,6,41,53,34,254]),function(H,e,v,t,k,R,D,y,h,p,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesMainService=e.IUserDataProfilesMainService=void 0,e.IUserDataProfilesMainService=(0,R.refineServiceDecorator)(p.IUserDataProfilesService);let C=class bt extends I.UserDataProfilesService{constructor(g,d,E,S,f){super(g,d,E,S,f);this.stateMainService=g}isEnabled(){return this.enabled}saveStoredProfiles(g){this.stateMainService.setItem(bt.PROFILES_KEY,g)}saveStoredProfileAssociations(g){this.stateMainService.setItem(bt.PROFILE_ASSOCIATIONS_KEY,g)}getStoredProfileAssociations(){const g="workspaceAndProfileInfo",d=this.stateMainService.getItem(g,void 0);if(d){this.stateMainService.removeItem(g);const E=d.reduce((S,{workspace:f,profile:w})=>(S[v.URI.revive(f).toString()]=v.URI.revive(w).toString(),S),{});this.stateMainService.setItem(bt.PROFILE_ASSOCIATIONS_KEY,{workspaces:E})}return super.getStoredProfileAssociations()}};C=ve([J(0,y.IStateMainService),J(1,h.IUriIdentityService),J(2,t.IEnvironmentService),J(3,k.IFileService),J(4,D.ILogService)],C),e.UserDataProfilesMainService=C}),define(Z[255],ee([0,1,2,16,72,89,14,34,65]),function(H,e,v,t,k,R,D,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DefaultExtensionsProfileInitHandler=void 0;let p=class extends v.Disposable{constructor(C,b,g,d){super();this.userDataProfilesService=C,this.fileService=b,this.extensionsScannerService=g,this.extensionsProfileScannerService=d,this._register(C.onWillCreateProfile(E=>{C.profiles.length===1&&E.join(this.initialize())})),this._register(C.onDidChangeProfiles(E=>{C.profiles.length===1&&this.uninitialize()}))}async initialize(){const C=this.getDefaultExtensionsProfileResource();try{await this.fileService.del(C)}catch{}const b=await this.extensionsScannerService.scanUserExtensions({includeInvalid:!0});await this.extensionsProfileScannerService.addExtensionsToProfile(b.map(g=>[g,g.metadata]),C)}async uninitialize(){try{await this.fileService.del(this.getDefaultExtensionsProfileResource())}catch{}}getDefaultExtensionsProfileResource(){return this.userDataProfilesService.defaultProfile.extensionsResource??(0,t.joinPath)(this.userDataProfilesService.defaultProfile.location,y.EXTENSIONS_RESOURCE_NAME)}};p=ve([J(0,h.IUserDataProfilesMainService),J(1,D.IFileService),J(2,R.IExtensionsScannerService),J(3,k.IExtensionsProfileScannerService)],p),e.DefaultExtensionsProfileInitHandler=p}),define(Z[90],ee([0,1,48,2,37,14,5,22,6,115,253,34,65]),function(H,e,v,t,k,R,D,y,h,p,I,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplicationStorageMainService=e.IApplicationStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,D.createDecorator)("storageMainService");let g=class extends t.Disposable{constructor(S,f,w,m,u){super();this.logService=S,this.environmentService=f,this.userDataProfilesService=w,this.lifecycleMainService=m,this.fileService=u,this.shutdownReason=void 0,this.applicationStorage=this.createApplicationStorage(),this.mapProfileToStorage=new Map,this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>{await this.lifecycleMainService.when(3),this.applicationStorage.init()})(),this._register(this.lifecycleMainService.onWillLoadWindow(S=>{S.window.profile&&this.profileStorage(S.window.profile).init(),S.workspace&&this.workspaceStorage(S.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(S=>{this.logService.trace("storageMainService#onWillShutdown()"),this.shutdownReason=S.reason,S.join(this.applicationStorage.close());for(const[,f]of this.mapProfileToStorage)S.join(f.close());for(const[,f]of this.mapWorkspaceToStorage)S.join(f.close())})),this._register(this.userDataProfilesService.onWillCreateProfile(S=>{S.join((async()=>{await this.fileService.exists(S.profile.globalStorageHome)||await this.fileService.createFolder(S.profile.globalStorageHome)})())})),this._register(this.userDataProfilesService.onWillRemoveProfile(S=>{const f=this.mapProfileToStorage.get(S.profile.id);f&&S.join(f.close())}))}createApplicationStorage(){this.logService.trace("StorageMainService: creating application storage");const S=new I.ApplicationStorageMain(this.getStorageOptions(),this.userDataProfilesService,this.logService,this.fileService);return(0,v.once)(S.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed application storage")}),S}profileStorage(S){if((0,p.isProfileUsingDefaultStorage)(S))return this.applicationStorage;let f=this.mapProfileToStorage.get(S.id);return f||(this.logService.trace(`StorageMainService: creating profile storage (${S.name})`),f=this.createProfileStorage(S),this.mapProfileToStorage.set(S.id,f),(0,v.once)(f.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed profile storage (${S.name})`),this.mapProfileToStorage.delete(S.id)})),f}createProfileStorage(S){return this.shutdownReason===2?new I.InMemoryStorageMain(this.logService,this.fileService):new I.ProfileStorageMain(S,this.getStorageOptions(),this.logService,this.fileService)}workspaceStorage(S){let f=this.mapWorkspaceToStorage.get(S.id);return f||(this.logService.trace(`StorageMainService: creating workspace storage (${S.id})`),f=this.createWorkspaceStorage(S),this.mapWorkspaceToStorage.set(S.id,f),(0,v.once)(f.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${S.id})`),this.mapWorkspaceToStorage.delete(S.id)})),f}createWorkspaceStorage(S){return this.shutdownReason===2?new I.InMemoryStorageMain(this.logService,this.fileService):new I.WorkspaceStorageMain(S,this.getStorageOptions(),this.logService,this.environmentService,this.fileService)}};g=ve([J(0,h.ILogService),J(1,k.IEnvironmentService),J(2,b.IUserDataProfilesMainService),J(3,y.ILifecycleMainService),J(4,R.IFileService)],g),e.StorageMainService=g,e.IApplicationStorageMainService=(0,D.createDecorator)("applicationStorageMainService");let d=class extends p.AbstractStorageService{constructor(S,f){super();this.userDataProfilesService=S,this.storageMainService=f,this.whenReady=this.storageMainService.applicationStorage.whenInit}doInitialize(){return this.storageMainService.applicationStorage.whenInit}getStorage(S){if(S===-1)return this.storageMainService.applicationStorage.storage}getLogDetails(S){if(S===-1)return this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath}shouldFlushWhenIdle(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}switchToProfile(){throw new Error("Switching storage profile is unsupported from main process")}switchToWorkspace(){throw new Error("Switching storage workspace is unsupported from main process")}};d=ve([J(0,C.IUserDataProfilesService),J(1,e.IStorageMainService)],d),e.ApplicationStorageMainService=d}),define(Z[116],ee([0,1,16,7,25]),function(H,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function R(h,p,I){for(const b of h){const g=b.openedWorkspace;if((0,k.isWorkspaceIdentifier)(g)){const d=I(g);if(d){if(d.folders.some(E=>v.extUriBiasedIgnorePathCase.isEqualOrParent(p,E.uri)))return b}else if(v.extUriBiasedIgnorePathCase.isEqualOrParent(p,g.configPath))return b}}const C=h.filter(b=>(0,k.isSingleFolderWorkspaceIdentifier)(b.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqualOrParent(p,b.openedWorkspace.uri));if(C.length)return C.sort((b,g)=>-(b.openedWorkspace.uri.path.length-g.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=R;function D(h,p){for(const I of h)if((0,k.isWorkspaceIdentifier)(I.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqual(I.openedWorkspace.configPath,p)||(0,k.isSingleFolderWorkspaceIdentifier)(I.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqual(I.openedWorkspace.uri,p))return I}e.findWindowOnWorkspaceOrFolder=D;function y(h,p){const I=C=>p.some(b=>v.extUriBiasedIgnorePathCase.isEqual(t.URI.file(b),t.URI.file(C)));for(const C of h)if(C.config?.extensionDevelopmentPath?.some(b=>I(b)))return C}e.findWindowOnExtensionDevelopmentPath=y}),define(Z[256],ee([0,1,15,2,4,16,7,19,22,6,41,33,114,25]),function(H,e,v,t,k,R,D,y,h,p,I,C,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let d=class kt extends t.Disposable{constructor(u,c,s,r,i){super();this.windowsMainService=u,this.stateMainService=c,this.lifecycleMainService=s,this.logService=r,this.configurationService=i,this._state=E(this.stateMainService.getItem(kt.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){v.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(u=>this.onBeforeCloseWindow(u)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(u=>{u.newCount-u.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(u=>this.onBeforeCloseWindow(u))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const u={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!u.lastActiveWindow){let r=this.windowsMainService.getLastActiveWindow();(!r||r.isExtensionDevelopmentHost)&&(r=this.windowsMainService.getWindows().find(i=>!i.isExtensionDevelopmentHost)),r&&(u.lastActiveWindow=this.toWindowState(r))}const c=this.windowsMainService.getWindows().find(r=>r.isExtensionDevelopmentHost&&!r.isExtensionTestHost);c&&(u.lastPluginDevelopmentHostWindow=this.toWindowState(c)),this.windowsMainService.getWindowCount()>1&&(u.openedWindows=this.windowsMainService.getWindows().filter(r=>!r.isExtensionDevelopmentHost).map(r=>this.toWindowState(r)));const s=f(u);this.stateMainService.setItem(kt.windowsStateStorageKey,s),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",s)}onBeforeCloseWindow(u){if(this.lifecycleMainService.quitRequested)return;const c=this.toWindowState(u);u.isExtensionDevelopmentHost&&!u.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=c:!u.isExtensionDevelopmentHost&&u.openedWorkspace&&this._state.openedWindows.forEach(s=>{const r=(0,g.isWorkspaceIdentifier)(u.openedWorkspace)&&s.workspace?.id===u.openedWorkspace.id,i=(0,g.isSingleFolderWorkspaceIdentifier)(u.openedWorkspace)&&s.folderUri&&R.extUriBiasedIgnorePathCase.isEqual(s.folderUri,u.openedWorkspace.uri);(r||i)&&(s.uiState=c.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=c)}toWindowState(u){return{workspace:(0,g.isWorkspaceIdentifier)(u.openedWorkspace)?u.openedWorkspace:void 0,folderUri:(0,g.isSingleFolderWorkspaceIdentifier)(u.openedWorkspace)?u.openedWorkspace.uri:void 0,backupPath:u.backupPath,remoteAuthority:u.remoteAuthority,uiState:u.serializeWindowState()}}getNewWindowState(u){const c=this.doGetNewWindowState(u),s=this.configurationService.getValue("window");let r;return c.hasDefaultState?r=!!(s?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(s.newWindowDimensions)>=0):(r=!!(this.lifecycleMainService.wasRestarted||s?.restoreFullscreen),r&&k.isMacintosh&&this.windowsMainService.getWindows().some(i=>i.isFullScreen)&&(r=!1)),c.mode===3&&!r&&(c.mode=1),c}doGetNewWindowState(u){const c=this.windowsMainService.getLastActiveWindow();if(!u.extensionTestsPath){if(!!u.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const a=u.workspace;if((0,g.isWorkspaceIdentifier)(a)){const P=this.state.openedWindows.filter(M=>M.workspace&&M.workspace.id===a.id).map(M=>M.uiState);if(P.length)return P[0]}if((0,g.isSingleFolderWorkspaceIdentifier)(a)){const P=this.state.openedWindows.filter(M=>M.folderUri&&R.extUriBiasedIgnorePathCase.isEqual(M.folderUri,a.uri)).map(M=>M.uiState);if(P.length)return P[0]}else if(u.backupPath){const P=this.state.openedWindows.filter(M=>M.backupPath===u.backupPath).map(M=>M.uiState);if(P.length)return P[0]}const l=this.lastClosedState||this.state.lastActiveWindow;if(!c&&l)return l.uiState}let s;const r=v.screen.getAllDisplays();if(r.length===1)s=r[0];else{if(k.isMacintosh){const a=v.screen.getCursorScreenPoint();s=v.screen.getDisplayNearestPoint(a)}!s&&c&&(s=v.screen.getDisplayMatching(c.getBounds())),s||(s=v.screen.getPrimaryDisplay()||r[0])}let i=(0,b.defaultWindowState)();i.x=Math.round(s.bounds.x+s.bounds.width/2-i.width/2),i.y=Math.round(s.bounds.y+s.bounds.height/2-i.height/2);const n=this.configurationService.getValue("window");let o=!0;if(n?.newWindowDimensions){if(n.newWindowDimensions==="maximized")i.mode=0,o=!1;else if(n.newWindowDimensions==="fullscreen")i.mode=3,o=!1;else if((n.newWindowDimensions==="inherit"||n.newWindowDimensions==="offset")&&c){const a=c.serializeWindowState();a.mode===3?i.mode=3:i=a,o=i.mode!==3&&n.newWindowDimensions==="offset"}}return o&&(i=this.ensureNoOverlap(i)),i.hasDefaultState=!0,i}ensureNoOverlap(u){if(this.windowsMainService.getWindows().length===0)return u;u.x=typeof u.x=="number"?u.x:0,u.y=typeof u.y=="number"?u.y:0;const c=this.windowsMainService.getWindows().map(s=>s.getBounds());for(;c.some(s=>s.x===u.x||s.y===u.y);)u.x+=30,u.y+=30;return u}};d.windowsStateStorageKey="windowsState",d=ve([J(0,C.IWindowsMainService),J(1,I.IStateMainService),J(2,h.ILifecycleMainService),J(3,p.ILogService),J(4,y.IConfigurationService)],d),e.WindowsStateHandler=d;function E(m){const u={openedWindows:[]},c=m||{openedWindows:[]};return c.lastActiveWindow&&(u.lastActiveWindow=S(c.lastActiveWindow)),c.lastPluginDevelopmentHostWindow&&(u.lastPluginDevelopmentHostWindow=S(c.lastPluginDevelopmentHostWindow)),Array.isArray(c.openedWindows)&&(u.openedWindows=c.openedWindows.map(s=>S(s))),u}e.restoreWindowsState=E;function S(m){const u={uiState:m.uiState};return m.backupPath&&(u.backupPath=m.backupPath),m.remoteAuthority&&(u.remoteAuthority=m.remoteAuthority),m.folder&&(u.folderUri=D.URI.parse(m.folder)),m.workspaceIdentifier&&(u.workspace={id:m.workspaceIdentifier.id,configPath:D.URI.parse(m.workspaceIdentifier.configURIPath)}),u}function f(m){return{lastActiveWindow:m.lastActiveWindow&&w(m.lastActiveWindow),lastPluginDevelopmentHostWindow:m.lastPluginDevelopmentHostWindow&&w(m.lastPluginDevelopmentHostWindow),openedWindows:m.openedWindows.map(u=>w(u))}}e.getWindowsStateStoreData=f;function w(m){return{workspaceIdentifier:m.workspace&&{id:m.workspace.id,configURIPath:m.workspace.configPath.toString()},folder:m.folderUri&&m.folderUri.toString(),backupPath:m.backupPath,remoteAuthority:m.remoteAuthority,uiState:m.uiState}}}),define(Z[91],ee([0,1,31,42,124,36,13,9,4,16,7,5,63,25]),function(H,e,v,t,k,R,D,y,h,p,I,C,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isStoredWorkspaceFolder=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=void 0,e.IWorkspacesService=(0,C.createDecorator)("workspacesService");function d(M){return M.hasOwnProperty("workspace")}e.isRecentWorkspace=d;function E(M){return M.hasOwnProperty("folderUri")}e.isRecentFolder=E;function S(M){return M.hasOwnProperty("fileUri")}e.isRecentFile=S;function f(M){return w(M)||m(M)}e.isStoredWorkspaceFolder=f;function w(M){const T=M;return typeof T?.path=="string"&&(!T.name||typeof T.name=="string")}function m(M){const T=M;return typeof T?.uri=="string"&&(!T.name||typeof T.name=="string")}function u(M,T,F,U,Q){if(M.scheme!==U.scheme)return{name:F,uri:M.toString(!0)};let re=T?void 0:Q.relativePath(U,M);if(re!==void 0)re.length===0?re=".":h.isWindows&&(re=c(re));else if(M.scheme===D.Schemas.file)re=M.fsPath,h.isWindows&&(re=c(re));else if(Q.isEqualAuthority(M.authority,U.authority))re=M.path;else return{name:F,uri:M.toString(!0)};return{name:F,path:re}}e.getStoredWorkspaceFolder=u;function c(M){return M=(0,R.normalizeDriveLetter)(M),(0,v.isUNC)(M)||(M=(0,v.toSlashes)(M)),M}function s(M,T,F){const U=[],Q=new Set,re=F.dirname(T);for(const ue of M){let fe;if(w(ue))ue.path&&(fe=F.resolvePath(re,ue.path));else if(m(ue))try{fe=I.URI.parse(ue.uri),fe.path[0]!==y.posix.sep&&(fe=fe.with({path:y.posix.sep+fe.path}))}catch(se){console.warn(se)}if(fe){const se=F.getComparisonKey(fe);if(!Q.has(se)){Q.add(se);const le=ue.name||F.basenameOrAuthority(fe);U.push(new g.WorkspaceFolder({uri:fe,name:le,index:U.length},ue))}}}return U}e.toWorkspaceFolders=s;function r(M,T,F,U,Q){const re=i(T,M),ue=Q.dirname(T),fe=Q.dirname(U),se=[];for(const _ of re.folders){const A=w(_)?Q.resolvePath(ue,_.path):I.URI.parse(_.uri);let W;F?W=!1:W=!w(_)||(0,y.isAbsolute)(_.path),se.push(u(A,W,_.name,fe,Q))}const le={insertSpaces:!1,tabSize:4,eol:h.isLinux||h.isMacintosh?`
`:`\r
`},K=k.setProperty(M,["folders"],se,le);let N=k.applyEdits(M,K);return(0,p.isEqualAuthority)(re.remoteAuthority,(0,b.getRemoteAuthority)(U))&&(N=k.applyEdits(N,k.removeProperty(N,["remoteAuthority"],le))),N}e.rewriteWorkspaceFileForNewLocation=r;function i(M,T){const F=t.parse(T);if(F&&Array.isArray(F.folders))F.folders=F.folders.filter(U=>f(U));else throw new Error(`${M} looks like an invalid workspace file.`);return F}function n(M){return M.workspace&&typeof M.workspace=="object"&&typeof M.workspace.id=="string"&&typeof M.workspace.configPath=="string"}function o(M){return typeof M.folderUri=="string"}function a(M){return typeof M.fileUri=="string"}function l(M,T){const F={workspaces:[],files:[]};if(M){const U=function(re,ue){for(let fe=0;fe<re.length;fe++)try{ue(re[fe],fe)}catch(se){T.warn(`Error restoring recent entry ${JSON.stringify(re[fe])}: ${se.toString()}. Skip entry.`)}},Q=M;Array.isArray(Q.entries)&&U(Q.entries,re=>{const ue=re.label,fe=re.remoteAuthority;n(re)?F.workspaces.push({label:ue,remoteAuthority:fe,workspace:{id:re.workspace.id,configPath:I.URI.parse(re.workspace.configPath)}}):o(re)?F.workspaces.push({label:ue,remoteAuthority:fe,folderUri:I.URI.parse(re.folderUri)}):a(re)&&F.files.push({label:ue,remoteAuthority:fe,fileUri:I.URI.parse(re.fileUri)})})}return F}e.restoreRecentlyOpened=l;function P(M){const T={entries:[]};for(const F of M.workspaces)E(F)?T.entries.push({folderUri:F.folderUri.toString(),label:F.label,remoteAuthority:F.remoteAuthority}):T.entries.push({workspace:{id:F.workspace.id,configPath:F.workspace.configPath.toString()},label:F.label,remoteAuthority:F.remoteAuthority});for(const F of M.files)T.entries.push({fileUri:F.fileUri.toString(),label:F.label,remoteAuthority:F.remoteAuthority});return T}e.toStoreData=P}),define(Z[117],ee([0,1,76,29,13,4,16]),function(H,e,v,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=void 0;function y(p){function I(){let C=p.scheme===k.Schemas.file?(0,D.originalFSPath)(p):p.toString();return R.isLinux||(C=C.toLowerCase()),(0,v.createHash)("md5").update(C).digest("hex")}return{id:I(),configPath:p}}e.getWorkspaceIdentifier=y;function h(p,I){function C(){if(p.scheme!==k.Schemas.file)return(0,v.createHash)("md5").update(p.toString()).digest("hex");if(!I)try{I=(0,t.statSync)(p.fsPath)}catch{return}let g;return R.isLinux?g=I.ino:R.isMacintosh?g=I.birthtime.getTime():R.isWindows&&(typeof I.birthtimeMs=="number"?g=Math.floor(I.birthtimeMs):g=I.birthtime.getTime()),(0,v.createHash)("md5").update(p.fsPath).update(g?String(g):"").digest("hex")}const b=C();if(typeof b=="string")return{id:b,uri:p}}e.getSingleFolderWorkspaceIdentifier=h}),define(Z[47],ee([0,1,15,29,3,42,36,2,13,9,16,12,23,175,59,54,27,5,6,20,65,116,25,91,117]),function(H,e,v,t,k,R,D,y,h,p,I,C,b,g,d,E,S,f,w,m,u,c,s,r,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,f.createDecorator)("workspacesManagementMainService");let n=class extends y.Disposable{constructor(a,l,P,M,T,F){super();this.environmentMainService=a,this.logService=l,this.userDataProfilesMainService=P,this.backupMainService=M,this.dialogMainService=T,this.productService=F,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new k.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new k.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(a){return this.doResolveLocalWorkspace(a,l=>(0,t.readFileSync)(l,"utf8"))}resolveLocalWorkspace(a){return this.doResolveLocalWorkspace(a,l=>b.Promises.readFile(l,"utf8"))}doResolveLocalWorkspace(a,l){if(!!this.isWorkspacePath(a)&&a.scheme===h.Schemas.file)try{const P=l(a.fsPath);return P instanceof Promise?P.then(M=>this.doResolveWorkspace(a,M),M=>{}):this.doResolveWorkspace(a,P)}catch{return}}isWorkspacePath(a){return(0,s.isUntitledWorkspace)(a,this.environmentMainService)||(0,s.hasWorkspaceFileExtension)(a)}doResolveWorkspace(a,l){try{const P=this.doParseStoredWorkspace(a,l),M=(0,i.getWorkspaceIdentifier)(a);return{id:M.id,configPath:M.configPath,folders:(0,r.toWorkspaceFolders)(P.folders,M.configPath,I.extUriBiasedIgnorePathCase),remoteAuthority:P.remoteAuthority,transient:P.transient}}catch(P){this.logService.warn(P.toString())}}doParseStoredWorkspace(a,l){const P=(0,R.parse)(l);if(P&&Array.isArray(P.folders))P.folders=P.folders.filter(M=>(0,r.isStoredWorkspaceFolder)(M));else throw new Error(`${a.toString(!0)} looks like an invalid workspace file.`);return P}async createUntitledWorkspace(a,l){const{workspace:P,storedWorkspace:M}=this.newUntitledWorkspace(a,l),T=P.configPath.fsPath;return await b.Promises.mkdir((0,p.dirname)(T),{recursive:!0}),await b.Promises.writeFile(T,JSON.stringify(M,null,"	")),P}createUntitledWorkspaceSync(a,l){const{workspace:P,storedWorkspace:M}=this.newUntitledWorkspace(a,l),T=P.configPath.fsPath;return(0,t.mkdirSync)((0,p.dirname)(T),{recursive:!0}),(0,b.writeFileSync)(T,JSON.stringify(M,null,"	")),P}newUntitledWorkspace(a=[],l){const P=(Date.now()+Math.round(Math.random()*1e3)).toString(),M=(0,I.joinPath)(this.untitledWorkspacesHome,P),T=(0,I.joinPath)(M,s.UNTITLED_WORKSPACE_NAME),F=[];for(const U of a)F.push((0,r.getStoredWorkspaceFolder)(U.uri,!0,U.name,M,I.extUriBiasedIgnorePathCase));return{workspace:(0,i.getWorkspaceIdentifier)(T),storedWorkspace:{folders:F,remoteAuthority:l}}}async getWorkspaceIdentifier(a){return(0,i.getWorkspaceIdentifier)(a)}isUntitledWorkspace(a){return(0,s.isUntitledWorkspace)(a.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(a){!this.isUntitledWorkspace(a)||(this.doDeleteUntitledWorkspaceSync(a),this.userDataProfilesMainService.isEnabled()&&this.userDataProfilesMainService.unsetWorkspace(a),this._onDidDeleteUntitledWorkspace.fire(a))}async deleteUntitledWorkspace(a){this.deleteUntitledWorkspaceSync(a)}doDeleteUntitledWorkspaceSync(a){const l=(0,I.originalFSPath)(a.configPath);try{(0,b.rimrafSync)((0,p.dirname)(l));const P=(0,p.join)(this.environmentMainService.workspaceStorageHome.fsPath,a.id);(0,t.existsSync)(P)&&(0,b.writeFileSync)((0,p.join)(P,"obsolete"),"")}catch(P){this.logService.warn(`Unable to delete untitled workspace ${l} (${P}).`)}}getUntitledWorkspacesSync(){const a=[];try{const l=(0,b.readdirSync)(this.untitledWorkspacesHome.fsPath).map(P=>(0,I.joinPath)(this.untitledWorkspacesHome,P,s.UNTITLED_WORKSPACE_NAME));for(const P of l){const M=(0,i.getWorkspaceIdentifier)(P),T=this.resolveLocalWorkspaceSync(P);T?a.push({workspace:M,remoteAuthority:T.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(M)}}catch(l){l.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${l}).`)}return a}async enterWorkspace(a,l,P){if(!a||!a.win||!a.isReady||!await this.isValidTargetWorkspacePath(a,l,P))return;const T=this.doEnterWorkspace(a,(0,i.getWorkspaceIdentifier)(P));if(!!T)return this._onDidEnterWorkspace.fire({window:a,workspace:T.workspace}),T}async isValidTargetWorkspacePath(a,l,P){if(!P)return!0;if((0,s.isWorkspaceIdentifier)(a.openedWorkspace)&&I.extUriBiasedIgnorePathCase.isEqual(a.openedWorkspace.configPath,P))return!1;if((0,c.findWindowOnWorkspaceOrFolder)(l,P)){const M={title:this.productService.nameLong,type:"info",buttons:[(0,D.mnemonicButtonLabel)((0,g.localize)(0,null))],message:(0,g.localize)(1,null,(0,I.basename)(P)),detail:(0,g.localize)(2,null),noLink:!0,defaultId:0};return await this.dialogMainService.showMessageBox(M,(0,C.withNullAsUndefined)(v.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(a,l){if(!a.config)return;a.focus();let P;return a.config.extensionDevelopmentPath||(P=this.backupMainService.registerWorkspaceBackupSync({workspace:l,remoteAuthority:a.remoteAuthority},a.config.backupPath)),(0,s.isWorkspaceIdentifier)(a.openedWorkspace)&&this.isUntitledWorkspace(a.openedWorkspace)&&this.deleteUntitledWorkspaceSync(a.openedWorkspace),a.config.workspace=l,a.config.backupPath=P,{workspace:l,backupPath:P}}};n=ve([J(0,S.IEnvironmentMainService),J(1,w.ILogService),J(2,u.IUserDataProfilesMainService),J(3,d.IBackupMainService),J(4,E.IDialogMainService),J(5,m.IProductService)],n),e.WorkspacesManagementMainService=n}),define(Z[118],ee([0,1,40,21,5,33,25,47]),function(H,e,v,t,k,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,k.createDecorator)(e.ID);let h=class{constructor(I,C){this.windowsMainService=I,this.workspacesManagementMainService=C}async getRemoteDiagnostics(I){const C=this.windowsMainService.getWindows();return(await Promise.all(C.map(g=>new Promise(d=>{const E=g.remoteAuthority;if(E){const S=`vscode:getDiagnosticInfoResponse${g.id}`,f={includeProcesses:I.includeProcesses,folders:I.includeWorkspaceMetadata?this.getFolderURIs(g):void 0};g.sendWhenReady("vscode:getDiagnosticInfo",t.CancellationToken.None,{replyChannel:S,args:f}),v.validatedIpcMain.once(S,(w,m)=>{m||d({hostName:E,errorMessage:`Unable to resolve connection to '${E}'.`}),d(m)}),setTimeout(()=>{d({hostName:E,errorMessage:`Connection to '${E}' could not be established`})},5e3)}else d(void 0)})))).filter(g=>!!g)}getFolderURIs(I){const C=[],b=I.openedWorkspace;if((0,D.isSingleFolderWorkspaceIdentifier)(b))C.push(b.uri);else if((0,D.isWorkspaceIdentifier)(b)){const g=this.workspacesManagementMainService.resolveLocalWorkspaceSync(b.configPath);g&&g.folders.forEach(E=>{C.push(E.uri)})}return C}};h=ve([J(0,R.IWindowsMainService),J(1,y.IWorkspacesManagementMainService)],h),e.DiagnosticsMainService=h}),define(Z[119],ee([0,1,15,24,4,12,7,23,19,58,5,6,113,33,25,47]),function(H,e,v,t,k,R,D,y,h,p,I,C,b,g,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,I.createDecorator)(e.ID);let S=class{constructor(w,m,u,c,s){this.logService=w,this.windowsMainService=m,this.urlService=u,this.workspacesManagementMainService=c,this.configurationService=s}async start(w,m){this.logService.trace("Received data from other instance: ",w,m),k.isMacintosh&&v.app.focus({steal:!0});const u=this.parseOpenUrl(w);if(u.length){let c=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(c=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),c.then(()=>{for(const{uri:s,url:r}of u)this.urlService.open(s,{originalUrl:r})})}else return this.startOpenWindow(w,m)}parseOpenUrl(w){return w["open-url"]&&w._urls&&w._urls.length>0?(0,t.coalesce)(w._urls.map(m=>{try{return{uri:D.URI.parse(m),url:m}}catch{return null}})):[]}async startOpenWindow(w,m){const u=(0,p.isLaunchedFromCli)(m)?0:4;let c=[];const s=w.wait&&w.waitMarkerFilePath?D.URI.file(w.waitMarkerFilePath):void 0,r=w.remote||void 0,i={context:u,cli:w,userEnv:m,waitMarkerFileURI:s,remoteAuthority:r};if(w.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(w.extensionDevelopmentPath,i);else if(!w._.length&&!w["folder-uri"]&&!w["file-uri"]){let n=!1;if(w["new-window"]||w["unity-launch"])n=!0;else if(w["reuse-window"])n=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":n=!0;break;case"off":n=!1;break;default:n=!k.isMacintosh}if(n)c=this.windowsMainService.open({...i,forceNewWindow:!0,forceEmpty:!0});else{const o=this.windowsMainService.getLastActiveWindow();o?(this.windowsMainService.openExistingWindow(o,i),c=[o]):c=this.windowsMainService.open({...i,forceEmpty:!0})}}else c=this.windowsMainService.open({...i,forceNewWindow:w["new-window"],preferNewWindow:!w["reuse-window"]&&!w.wait,forceReuseWindow:w["reuse-window"],diffMode:w.diff,mergeMode:w.merge,addMode:w.add,noRecentEntry:!!w["skip-add-to-recently-opened"],gotoLineMode:w.goto});if(s&&c.length===1&&c[0])return Promise.race([c[0].whenClosedOrLoaded,(0,y.whenDeleted)(s.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const w=[];return v.BrowserWindow.getAllWindows().forEach(m=>{const u=this.windowsMainService.getWindowById(m.id);u?w.push(this.codeWindowToInfo(u)):w.push(this.browserWindowToInfo(m))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:w,screenReader:!!v.app.accessibilitySupportEnabled,gpuFeatureStatus:v.app.getGPUFeatureStatus()}}getFolderURIs(w){const m=[],u=w.openedWorkspace;if((0,d.isSingleFolderWorkspaceIdentifier)(u))m.push(u.uri);else if((0,d.isWorkspaceIdentifier)(u)){const c=this.workspacesManagementMainService.resolveLocalWorkspaceSync(u.configPath);c&&c.folders.forEach(r=>{m.push(r.uri)})}return m}codeWindowToInfo(w){const m=this.getFolderURIs(w),u=(0,R.assertIsDefined)(w.win);return this.browserWindowToInfo(u,m,w.remoteAuthority)}browserWindowToInfo(w,m=[],u){return{pid:w.webContents.getOSProcessId(),title:w.getTitle(),folderURIs:m,remoteAuthority:u}}};S=ve([J(0,C.ILogService),J(1,g.IWindowsMainService),J(2,b.IURLService),J(3,E.IWorkspacesManagementMainService),J(4,h.IConfigurationService)],S),e.LaunchMainService=S}),define(Z[66],ee([0,1,50,15,30,142,51,3,36,2,13,9,4,7,96,81,23,92,165,54,27,5,22,6,20,64,33,25,47,17]),function(H,e,v,t,k,R,D,y,h,p,I,C,b,g,d,E,S,f,w,m,u,c,s,r,i,n,o,a,l,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,c.createDecorator)("nativeHostMainService");let M=class extends p.Disposable{constructor(F,U,Q,re,ue,fe,se,le,K){super();this.sharedProcess=F,this.windowsMainService=U,this.dialogMainService=Q,this.lifecycleMainService=re,this.environmentMainService=ue,this.logService=fe,this.productService=se,this.themeMainService=le,this.workspacesManagementMainService=K,this.onDidOpenWindow=y.Event.map(this.windowsMainService.onDidOpenWindow,N=>N.id),this.onDidTriggerSystemContextMenu=y.Event.filter(y.Event.map(this.windowsMainService.onDidTriggerSystemContextMenu,({window:N,x:_,y:A})=>({windowId:N.id,x:_,y:A})),({windowId:N})=>!!this.windowsMainService.getWindowById(N)),this.onDidMaximizeWindow=y.Event.filter(y.Event.fromNodeEventEmitter(t.app,"browser-window-maximize",(N,_)=>_.id),N=>!!this.windowsMainService.getWindowById(N)),this.onDidUnmaximizeWindow=y.Event.filter(y.Event.fromNodeEventEmitter(t.app,"browser-window-unmaximize",(N,_)=>_.id),N=>!!this.windowsMainService.getWindowById(N)),this.onDidBlurWindow=y.Event.filter(y.Event.fromNodeEventEmitter(t.app,"browser-window-blur",(N,_)=>_.id),N=>!!this.windowsMainService.getWindowById(N)),this.onDidFocusWindow=y.Event.any(y.Event.map(y.Event.filter(y.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),N=>!!N),N=>N.id),y.Event.filter(y.Event.fromNodeEventEmitter(t.app,"browser-window-focus",(N,_)=>_.id),N=>!!this.windowsMainService.getWindowById(N))),this.onDidResumeOS=y.Event.fromNodeEventEmitter(t.powerMonitor,"resume"),this.onDidChangeColorScheme=this.themeMainService.onDidChangeColorScheme,this._onDidChangePassword=this._register(new y.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=y.Event.debounce(y.Event.any(y.Event.filter(y.Event.fromNodeEventEmitter(t.screen,"display-metrics-changed",(N,_,A)=>A),N=>!(Array.isArray(N)&&N.length===1&&N[0]==="workArea")),y.Event.fromNodeEventEmitter(t.screen,"display-added"),y.Event.fromNodeEventEmitter(t.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(U=>({id:U.id,workspace:U.openedWorkspace,title:U.win?.getTitle()??"",filename:U.getRepresentedFilename(),dirty:U.isDocumentEdited()}))}async getWindowCount(F){return this.windowsMainService.getWindowCount()}async getActiveWindowId(F){const U=t.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(U)return U.id}openWindow(F,U,Q){return Array.isArray(U)?this.doOpenWindow(F,U,Q):this.doOpenEmptyWindow(F,U)}async doOpenWindow(F,U,Q=Object.create(null)){U.length>0&&this.windowsMainService.open({context:5,contextWindowId:F,urisToOpen:U,cli:this.environmentMainService.args,forceNewWindow:Q.forceNewWindow,forceReuseWindow:Q.forceReuseWindow,preferNewWindow:Q.preferNewWindow,diffMode:Q.diffMode,mergeMode:Q.mergeMode,addMode:Q.addMode,gotoLineMode:Q.gotoLineMode,noRecentEntry:Q.noRecentEntry,waitMarkerFileURI:Q.waitMarkerFileURI,remoteAuthority:Q.remoteAuthority||void 0})}async doOpenEmptyWindow(F,U){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:F},U)}async toggleFullScreen(F){this.windowById(F)?.toggleFullScreen()}async handleTitleDoubleClick(F){this.windowById(F)?.handleTitleDoubleClick()}async isMaximized(F){const U=this.windowById(F);return U?.win?U.win.isMaximized():!1}async maximizeWindow(F){const U=this.windowById(F);U?.win&&U.win.maximize()}async unmaximizeWindow(F){const U=this.windowById(F);U?.win&&U.win.unmaximize()}async minimizeWindow(F){const U=this.windowById(F);U?.win&&U.win.minimize()}async updateWindowControls(F,U){const Q=this.windowById(F);Q&&Q.updateWindowControls(U)}async focusWindow(F,U){U&&typeof U.windowId=="number"&&(F=U.windowId),this.windowById(F)?.focus({force:U?.force??!1})}async setMinimumSize(F,U,Q){const re=this.windowById(F);if(re?.win){const[ue,fe]=re.win.getSize(),[se,le]=re.win.getMinimumSize(),[K,N]=[U??se,Q??le],[_,A]=[Math.max(ue,K),Math.max(fe,N)];(se!==K||le!==N)&&re.win.setMinimumSize(K,N),(ue!==_||fe!==A)&&re.win.setSize(_,A)}}async saveWindowSplash(F,U){this.themeMainService.saveWindowSplash(F,U)}async installShellCommand(F){const{source:U,target:Q}=await this.getShellCommandLink();try{const{symbolicLink:re}=await S.SymlinkSupport.stat(U);if(re&&!re.dangling){const ue=await(0,d.realpath)(U);if(Q===ue)return}await S.Promises.unlink(U)}catch(re){if(re.code!=="ENOENT")throw re}try{await S.Promises.symlink(Q,U)}catch(re){if(re.code!=="EACCES"&&re.code!=="ENOENT")throw re;const{response:ue}=await this.showMessageBox(F,{title:this.productService.nameLong,type:"info",message:(0,w.localize)(0,null,this.productService.nameShort),buttons:[(0,h.mnemonicButtonLabel)((0,w.localize)(1,null)),(0,h.mnemonicButtonLabel)((0,w.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(ue===0)try{const fe=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${Q}' '${U}'\\" with administrator privileges"`;await(0,R.promisify)(v.exec)(fe)}catch{throw new Error((0,w.localize)(3,null,U))}}}async uninstallShellCommand(F){const{source:U}=await this.getShellCommandLink();try{await S.Promises.unlink(U)}catch(Q){switch(Q.code){case"EACCES":{const{response:re}=await this.showMessageBox(F,{title:this.productService.nameLong,type:"info",message:(0,w.localize)(4,null,this.productService.nameShort),buttons:[(0,h.mnemonicButtonLabel)((0,w.localize)(5,null)),(0,h.mnemonicButtonLabel)((0,w.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(re===0)try{const ue=`osascript -e "do shell script \\"rm '${U}'\\" with administrator privileges"`;await(0,R.promisify)(v.exec)(ue)}catch{throw new Error((0,w.localize)(7,null,U))}break}case"ENOENT":break;default:throw Q}}}async getShellCommandLink(){const F=(0,C.resolve)(this.environmentMainService.appRoot,"bin","code"),U=`/usr/local/bin/${this.productService.applicationName}`;if(!await S.Promises.exists(F))throw new Error((0,w.localize)(8,null,F));return{source:U,target:F}}async showMessageBox(F,U){return this.dialogMainService.showMessageBox(U,this.toBrowserWindow(F))}async showSaveDialog(F,U){return this.dialogMainService.showSaveDialog(U,this.toBrowserWindow(F))}async showOpenDialog(F,U){return this.dialogMainService.showOpenDialog(U,this.toBrowserWindow(F))}toBrowserWindow(F){const U=this.windowById(F);if(U?.win)return U.win}async pickFileFolderAndOpen(F,U){const Q=await this.dialogMainService.pickFileFolder(U);Q&&this.doOpenPicked(await Promise.all(Q.map(async re=>await S.SymlinkSupport.existsDirectory(re)?{folderUri:g.URI.file(re)}:{fileUri:g.URI.file(re)})),U,F)}async pickFolderAndOpen(F,U){const Q=await this.dialogMainService.pickFolder(U);Q&&this.doOpenPicked(Q.map(re=>({folderUri:g.URI.file(re)})),U,F)}async pickFileAndOpen(F,U){const Q=await this.dialogMainService.pickFile(U);Q&&this.doOpenPicked(Q.map(re=>({fileUri:g.URI.file(re)})),U,F)}async pickWorkspaceAndOpen(F,U){const Q=await this.dialogMainService.pickWorkspace(U);Q&&this.doOpenPicked(Q.map(re=>({workspaceUri:g.URI.file(re)})),U,F)}doOpenPicked(F,U,Q){this.windowsMainService.open({context:3,contextWindowId:Q,cli:this.environmentMainService.args,urisToOpen:F,forceNewWindow:U.forceNewWindow})}async showItemInFolder(F,U){t.shell.showItemInFolder(U)}async setRepresentedFilename(F,U){this.windowById(F)?.setRepresentedFilename(U)}async setDocumentEdited(F,U){this.windowById(F)?.setDocumentEdited(U)}async openExternal(F,U){return b.isLinuxSnap?this.safeSnapOpenExternal(U):t.shell.openExternal(U),!0}safeSnapOpenExternal(F){const U=process.env.GDK_PIXBUF_MODULE_FILE,Q=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,t.shell.openExternal(F),process.env.GDK_PIXBUF_MODULE_FILE=U,process.env.GDK_PIXBUF_MODULEDIR=Q}moveItemToTrash(F,U){return t.shell.trashItem(U)}async isAdmin(){let F;return b.isWindows?F=(await new Promise((U,Q)=>{H(["native-is-elevated"],U,Q)}))():F=process.getuid()===0,F}async writeElevated(F,U,Q,re){const ue=await new Promise((fe,se)=>{H(["@vscode/sudo-prompt"],fe,se)});return new Promise((fe,se)=>{const le=[`"${this.cliPath}"`];re?.unlock&&le.push("--file-chmod"),le.push("--file-write",`"${U.fsPath}"`,`"${Q.fsPath}"`);const K={name:this.productService.nameLong.replace("-",""),icns:b.isMacintosh&&this.environmentMainService.isBuilt?(0,C.join)((0,C.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};ue.exec(le.join(" "),K,(N,_,A)=>{_&&this.logService.trace(`[sudo-prompt] received stdout: ${_}`),A&&this.logService.trace(`[sudo-prompt] received stderr: ${A}`),N?se(N):fe(void 0)})})}get cliPath(){return b.isWindows?this.environmentMainService.isBuilt?(0,C.join)((0,C.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,C.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):b.isLinux?this.environmentMainService.isBuilt?(0,C.join)((0,C.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,C.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,C.join)(this.environmentMainService.appRoot,"bin","code"):(0,C.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,k.totalmem)(),freemem:(0,k.freemem)(),loadavg:(0,k.loadavg)()}}async getOSProperties(){return{arch:(0,k.arch)(),platform:(0,k.platform)(),release:(0,k.release)(),type:(0,k.type)(),cpus:(0,k.cpus)()}}async getOSVirtualMachineHint(){return E.virtualMachineHint.value()}async getOSColorScheme(){return this.themeMainService.getColorScheme()}async killProcess(F,U,Q){process.kill(U,Q)}async readClipboardText(F,U){return t.clipboard.readText(U)}async writeClipboardText(F,U,Q){return t.clipboard.writeText(U,Q)}async readClipboardFindText(F){return t.clipboard.readFindText()}async writeClipboardFindText(F,U){return t.clipboard.writeFindText(U)}async writeClipboardBuffer(F,U,Q,re){return t.clipboard.writeBuffer(U,Buffer.from(Q.buffer),re)}async readClipboardBuffer(F,U){return P.VSBuffer.wrap(t.clipboard.readBuffer(U))}async hasClipboard(F,U,Q){return t.clipboard.has(U,Q)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){t.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){t.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){t.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){t.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){t.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(F,U){this.windowById(F)?.updateTouchBar(U)}async notifyReady(F){this.windowById(F)?.setReady()}async relaunch(F,U){return this.lifecycleMainService.relaunch(U)}async reload(F,U){const Q=this.windowById(F);if(Q){if((0,a.isWorkspaceIdentifier)(Q.openedWorkspace)){const re=Q.openedWorkspace.configPath;if(re.scheme===I.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(re))?.transient)return this.openWindow(Q.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(Q,U?.disableExtensions!==void 0?{_:[],"disable-extensions":U.disableExtensions}:void 0)}}async closeWindow(F){this.closeWindowById(F,F)}async closeWindowById(F,U){const Q=this.windowById(U);if(Q?.win)return Q.win.close()}async quit(F){const U=this.windowsMainService.getLastActiveWindow();U?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&U.win?U.win.close():this.lifecycleMainService.quit()}async exit(F,U){await this.lifecycleMainService.kill(U)}async resolveProxy(F,U){const re=this.windowById(F)?.win?.webContents?.session;if(re)return re.resolveProxy(U)}findFreePort(F,U,Q,re,ue=1){return(0,f.findFreePort)(U,Q,re,ue)}async openDevTools(F,U){const Q=this.windowById(F);Q?.win&&Q.win.webContents.openDevTools(U)}async toggleDevTools(F){const U=this.windowById(F);U?.win&&U.win.webContents.toggleDevTools()}async sendInputEvent(F,U){const Q=this.windowById(F);Q?.win&&(U.type==="mouseDown"||U.type==="mouseUp")&&Q.win.webContents.sendInputEvent(U)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(F,U,Q,re){if(!b.isWindows)return;const ue=await new Promise((fe,se)=>{H(["@vscode/windows-registry"],fe,se)});try{return ue.GetStringRegKey(U,Q,re)}catch{return}}windowById(F){if(typeof F=="number")return this.windowsMainService.getWindowById(F)}};ve([D.memoize],M.prototype,"cliPath",null),M=ve([J(1,o.IWindowsMainService),J(2,m.IDialogMainService),J(3,s.ILifecycleMainService),J(4,u.IEnvironmentMainService),J(5,r.ILogService),J(6,i.IProductService),J(7,n.IThemeMainService),J(8,l.IWorkspacesManagementMainService)],M),e.NativeHostMainService=M}),define(Z[257],ee([0,1,15,40,30,36,2,13,4,97,163,84,118,54,27,5,119,6,66,60,20,61,74]),function(H,e,v,t,k,R,D,y,h,p,I,C,b,g,d,E,S,f,w,m,u,c,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,E.createDecorator)("issueMainService");let r=class At{constructor(n,o,a,l,P,M,T,F,U,Q){this.userEnv=n,this.environmentMainService=o,this.launchMainService=a,this.logService=l,this.diagnosticsService=P,this.diagnosticsMainService=M,this.dialogMainService=T,this.nativeHostMainService=F,this.protocolMainService=U,this.productService=Q,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){t.validatedIpcMain.on("vscode:issueSystemInfoRequest",async n=>{const[o,a]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),l=await this.diagnosticsService.getSystemInfo(o,a);this.safeSend(n,"vscode:issueSystemInfoResponse",l)}),t.validatedIpcMain.on("vscode:listProcesses",async n=>{const o=[];try{const a=await this.launchMainService.getMainProcessId();o.push({name:(0,I.localize)(0,null),rootProcess:await(0,p.listProcesses)(a)}),(await this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(P=>{(0,C.isRemoteDiagnosticError)(P)?o.push({name:P.hostName,rootProcess:P}):P.processes&&o.push({name:P.hostName,rootProcess:P.processes})})}catch(a){this.logService.error(`Listing processes failed: ${a}`)}this.safeSend(n,"vscode:listProcessesResponse",o)}),t.validatedIpcMain.on("vscode:issueReporterClipboard",async n=>{const o={title:this.productService.nameLong,message:(0,I.localize)(1,null),type:"warning",buttons:[(0,R.mnemonicButtonLabel)((0,I.localize)(2,null)),(0,R.mnemonicButtonLabel)((0,I.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.issueReporterWindow){const a=await this.dialogMainService.showMessageBox(o,this.issueReporterWindow);this.safeSend(n,"vscode:issueReporterClipboardResponse",a.response===0)}}),t.validatedIpcMain.on("vscode:issuePerformanceInfoRequest",async n=>{const o=await this.getPerformanceInfo();this.safeSend(n,"vscode:issuePerformanceInfoResponse",o)}),t.validatedIpcMain.on("vscode:issueReporterConfirmClose",async()=>{const n={title:this.productService.nameLong,message:(0,I.localize)(4,null),type:"warning",buttons:[(0,R.mnemonicButtonLabel)((0,I.localize)(5,null)),(0,R.mnemonicButtonLabel)((0,I.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(n,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),t.validatedIpcMain.on("vscode:workbenchCommand",(n,o)=>{const{id:a,from:l,args:P}=o;let M;switch(l){case"issueReporter":M=this.issueReporterParentWindow;break;case"processExplorer":M=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${l}`)}M?.webContents.send("vscode:runAction",{id:a,from:l,args:P})}),t.validatedIpcMain.on("vscode:openExternal",(n,o)=>{this.nativeHostMainService.openExternal(void 0,o)}),t.validatedIpcMain.on("vscode:closeIssueReporter",n=>{this.issueReporterWindow?.close()}),t.validatedIpcMain.on("vscode:closeProcessExplorer",n=>{this.processExplorerWindow?.close()}),t.validatedIpcMain.on("vscode:windowsInfoRequest",async n=>{const o=await this.launchMainService.getMainProcessInfo();this.safeSend(n,"vscode:windowsInfoResponse",o.windows)})}safeSend(n,o,...a){n.sender.isDestroyed()||n.sender.send(o,...a)}async openReporter(n){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=v.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const o=new D.DisposableStore,a=o.add(this.protocolMainService.createIPCObjectUrl()),l=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(l,a,{backgroundColor:n.styles.backgroundColor,title:(0,I.localize)(7,null),zoomLevel:n.zoomLevel,alwaysOnTop:!1},"issue-reporter"),a.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:n,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,k.type)(),arch:(0,k.arch)(),release:(0,k.release)()},product:m.default}),this.issueReporterWindow.loadURL(y.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",H).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,o.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,o.dispose())})}this.issueReporterWindow&&this.focusWindow(this.issueReporterWindow)}async openProcessExplorer(n){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=v.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const o=new D.DisposableStore,a=o.add(this.protocolMainService.createIPCObjectUrl()),l=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(l,a,{backgroundColor:n.styles.backgroundColor,title:(0,I.localize)(8,null),zoomLevel:n.zoomLevel,alwaysOnTop:!0},"process-explorer"),a.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:n,product:m.default}),this.processExplorerWindow.loadURL(y.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",H).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,o.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,o.dispose())})}this.processExplorerWindow&&this.focusWindow(this.processExplorerWindow)}focusWindow(n){n.isMinimized()&&n.restore(),n.focus()}createBrowserWindow(n,o,a,l){const P=new v.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:n.width,height:n.height,minWidth:300,minHeight:200,x:n.x,y:n.y,title:a.title,backgroundColor:a.backgroundColor||At.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:y.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",H).fsPath,additionalArguments:[`--vscode-window-config=${o.resource.toString()}`,`--vscode-window-kind=${l}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,s.zoomLevelToZoomFactor)(a.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:a.alwaysOnTop,experimentalDarkMode:!0});return P.setMenuBarVisibility(!1),P}async getSystemStatus(){const[n,o]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(n,o)}getWindowPosition(n,o,a){let l;const P=v.screen.getAllDisplays();if(P.length===1)l=P[0];else{if(h.isMacintosh){const F=v.screen.getCursorScreenPoint();l=v.screen.getDisplayNearestPoint(F)}!l&&n&&(l=v.screen.getDisplayMatching(n.getBounds())),l||(l=v.screen.getPrimaryDisplay()||P[0])}const M={width:o,height:a},T=l.bounds;return M.x=T.x+T.width/2-M.width/2,M.y=T.y+T.height/2-M.height/2,T.width>0&&T.height>0&&(M.x<T.x&&(M.x=T.x),M.y<T.y&&(M.y=T.y),M.x>T.x+T.width&&(M.x=T.x),M.y>T.y+T.height&&(M.y=T.y),M.width>T.width&&(M.width=T.width),M.height>T.height&&(M.height=T.height)),M}async getPerformanceInfo(){try{const[n,o]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(n,o)}catch(n){throw this.logService.warn("issueService#getPerformanceInfo ",n.message),n}}};r.DEFAULT_BACKGROUND_COLOR="#1E1E1E",r=ve([J(1,d.IEnvironmentMainService),J(2,S.ILaunchMainService),J(3,f.ILogService),J(4,C.IDiagnosticsService),J(5,b.IDiagnosticsMainService),J(6,g.IDialogMainService),J(7,w.INativeHostMainService),J(8,c.IProtocolMainService),J(9,u.IProductService)],r),e.IssueMainService=r}),define(Z[258],ee([0,1,21,19,27,22,6,66,20,52,38,46,88]),function(H,e,v,t,k,R,D,y,h,p,I,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let g=class extends b.AbstractUpdateService{constructor(E,S,f,w,m,u,c,s){super(E,S,w,m,u,s);this.telemetryService=f,this.nativeHostMainService=c}buildUpdateFeedUrl(E){return(0,b.createUpdateURL)(`linux-${process.arch}`,E,this.productService)}doCheckForUpdates(E){!this.url||(this.setState(C.State.CheckingForUpdates(E)),this.requestService.request({url:this.url},v.CancellationToken.None).then(p.asJson).then(S=>{!S||!S.url||!S.version||!S.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!E}),this.setState(C.State.Idle(1))):this.setState(C.State.AvailableForDownload(S))}).then(void 0,S=>{this.logService.error(S),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!E});const f=E?S.message||S:void 0;this.setState(C.State.Idle(1,f))}))}async doDownloadUpdate(E){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):E.update.url&&this.nativeHostMainService.openExternal(void 0,E.update.url),this.setState(C.State.Idle(1))}};g=ve([J(0,R.ILifecycleMainService),J(1,t.IConfigurationService),J(2,I.ITelemetryService),J(3,k.IEnvironmentMainService),J(4,p.IRequestService),J(5,D.ILogService),J(6,y.INativeHostMainService),J(7,h.IProductService)],g),e.LinuxUpdateService=g}),define(Z[259],ee([0,1,50,29,30,8,21,51,9,7,128,23,19,27,14,22,6,66,20,52,38,46,88]),function(H,e,v,t,k,R,D,y,h,p,I,C,b,g,d,E,S,f,w,m,u,c,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function r(a,l=1e3){for(;!a();)await(0,R.timeout)(l)}let i;function n(){return typeof i=="undefined"&&(i=t.existsSync(h.join(h.dirname(process.execPath),"unins000.exe"))?0:1),i}let o=class extends s.AbstractUpdateService{constructor(l,P,M,T,F,U,Q,re,ue){super(l,P,T,F,U,ue);this.telemetryService=M,this.fileService=Q,this.nativeHostMainService=re}get cachePath(){const l=h.join((0,k.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return C.Promises.mkdir(l,{recursive:!0}).then(()=>l)}async initialize(){if(this.productService.target==="user"&&await this.nativeHostMainService.isAdmin(void 0)){this.logService.info("update#ctor - updates are disabled due to running as Admin in user setup");return}super.initialize()}buildUpdateFeedUrl(l){let P="win32";return process.arch!=="ia32"&&(P+=`-${process.arch}`),n()===1?P+="-archive":this.productService.target==="user"&&(P+="-user"),(0,s.createUpdateURL)(P,l,this.productService)}doCheckForUpdates(l){!this.url||(this.setState(c.State.CheckingForUpdates(l)),this.requestService.request({url:this.url},D.CancellationToken.None).then(m.asJson).then(P=>{const M=n();return!P||!P.url||!P.version||!P.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!l}),this.setState(c.State.Idle(M)),Promise.resolve(null)):M===1?(this.setState(c.State.AvailableForDownload(P)),Promise.resolve(null)):(this.setState(c.State.Downloading(P)),this.cleanup(P.version).then(()=>this.getUpdatePackagePath(P.version).then(T=>C.Promises.exists(T).then(F=>{if(F)return Promise.resolve(T);const U=P.url,Q=P.hash,re=`${T}.tmp`;return this.requestService.request({url:U},D.CancellationToken.None).then(ue=>this.fileService.writeFile(p.URI.file(re),ue.stream)).then(Q?()=>(0,I.checksum)(re,P.hash):()=>{}).then(()=>C.Promises.rename(re,T)).then(()=>T)})).then(T=>{const F=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:T},F&&P.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(c.State.Downloaded(P)):this.setState(c.State.Ready(P))})))}).then(void 0,P=>{this.logService.error(P),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!l});const M=l?P.message||P:void 0;this.setState(c.State.Idle(n(),M))}))}async doDownloadUpdate(l){l.update.url&&this.nativeHostMainService.openExternal(void 0,l.update.url),this.setState(c.State.Idle(n()))}async getUpdatePackagePath(l){const P=await this.cachePath;return h.join(P,`CodeSetup-${this.productService.quality}-${l}.exe`)}async cleanup(l=null){const P=l?U=>!new RegExp(`${this.productService.quality}-${l}\\.exe$`).test(U):()=>!0,M=await this.cachePath,F=(await C.Promises.readdir(M)).filter(P).map(async U=>{try{await C.Promises.unlink(h.join(M,U))}catch{}});await Promise.all(F)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const l=this.state.update;this.setState(c.State.Updating(l));const P=await this.cachePath;this.availableUpdate.updateFilePath=h.join(P,`CodeSetup-${this.productService.quality}-${l.version}.flag`),await C.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,v.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(c.State.Idle(n()))});const T=`${this.productService.win32MutexName}-ready`,F=await new Promise((U,Q)=>{H(["windows-mutex"],U,Q)});r(()=>F.isActive(T)).then(()=>this.setState(c.State.Ready(l)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?t.unlinkSync(this.availableUpdate.updateFilePath):(0,v.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return n()}async _applySpecificUpdate(l){if(this.state.type!=="idle")return;const P=this.configurationService.getValue("update.enableWindowsBackgroundUpdates"),M={version:"unknown",productVersion:"unknown",supportsFastUpdate:!!P};this.setState(c.State.Downloading(M)),this.availableUpdate={packagePath:l},P?this.productService.target==="user"?this.doApplyUpdate():this.setState(c.State.Downloaded(M)):this.setState(c.State.Ready(M))}};ve([y.memoize],o.prototype,"cachePath",null),o=ve([J(0,E.ILifecycleMainService),J(1,b.IConfigurationService),J(2,u.ITelemetryService),J(3,g.IEnvironmentMainService),J(4,m.IRequestService),J(5,S.ILogService),J(6,d.IFileService),J(7,f.INativeHostMainService),J(8,w.IProductService)],o),e.Win32UpdateService=o}),define(Z[260],ee([0,1,15,8,21,43,3,36,2,13,9,71,4,7,171,59,19,54,27,58,14,22,6,20,61,228,90,38,231,64,74,33,25,47,114,122,39,34,57,41]),function(H,e,v,t,k,R,D,y,h,p,I,C,b,g,d,E,S,f,w,m,u,c,s,r,i,n,o,a,l,P,M,T,F,U,Q,re,ue,fe,se,le){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var K;(function(_){_[_.NONE=0]="NONE",_[_.NAVIGATING=1]="NAVIGATING",_[_.READY=2]="READY"})(K||(K={}));let N=class Mt extends h.Disposable{constructor(A,W,$,Y,z,j,L,O,B,V,x,ie,q,te,ne,ce,he,ke,Le){super();this.logService=W,this.environmentMainService=$,this.policyService=Y,this.userDataProfilesService=z,this.fileService=j,this.applicationStorageMainService=L,this.storageMainService=O,this.configurationService=B,this.themeMainService=V,this.workspacesManagementMainService=x,this.backupMainService=ie,this.telemetryService=q,this.dialogMainService=te,this.lifecycleMainService=ne,this.productService=ce,this.protocolMainService=he,this.windowsMainService=ke,this.stateMainService=Le,this._onWillLoad=this._register(new D.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new D.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidTriggerSystemContextMenu=this._register(new D.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this._onDidClose=this._register(new D.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new D.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[Me,Ae]=this.restoreWindowState(A.state);this.windowState=Me,this.logService.trace("window#ctor: using window state",Me);const je=this.windowState.mode===0||this.windowState.mode===3,me=this.configurationService.getValue("window"),pe={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:M.WindowMinimumSize.WIDTH,minHeight:M.WindowMinimumSize.HEIGHT,show:!je,title:this.productService.nameLong,webPreferences:{preload:p.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",H).fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,M.zoomLevelToZoomFactor)(me?.zoomLevel),enableBlinkFeatures:"HighlightAPI",nodeIntegration:!0,contextIsolation:!1},experimentalDarkMode:!0};b.isLinux?pe.icon=(0,I.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):b.isWindows&&!this.environmentMainService.isBuilt&&(pe.icon=(0,I.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),b.isMacintosh&&!this.useNativeFullScreen()&&(pe.fullscreenable=!1),b.isMacintosh&&(pe.acceptFirstMouse=!0,me?.clickThroughInactive===!1&&(pe.acceptFirstMouse=!1));const Ee=b.isMacintosh&&me?.nativeTabs===!0;Ee&&(pe.tabbingIdentifier=this.productService.nameShort);const X=(0,M.getTitleBarStyle)(this.configurationService)==="custom";if(X&&(pe.titleBarStyle="hidden",b.isMacintosh||(pe.frame=!1),(0,M.useWindowControlsOverlay)(this.configurationService,this.environmentMainService))){const oe=this.themeMainService.getWindowSplash()?.colorInfo.titleBarBackground??this.themeMainService.getBackgroundColor(),de=re.Color.fromHex(oe).isDarker()?"#FFFFFF":"#000000";pe.titleBarOverlay={height:29,color:oe,symbolColor:de}}if((0,C.mark)("code/willCreateCodeBrowserWindow"),this._win=new v.BrowserWindow(pe),(0,C.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,b.isMacintosh&&X&&this._win.setSheetOffset(22),X&&(b.isWindows&&(0,M.useWindowControlsOverlay)(this.configurationService,this.environmentMainService)||b.isMacintosh)){const oe=this.stateMainService.getItem(Mt.windowControlHeightStateStorageKey);oe&&this.updateWindowControls({height:oe})}if(b.isWindows&&X){const oe=278;this._win.hookWindowMessage(oe,()=>{const[de,ye]=this._win.getPosition(),Ce=v.screen.getCursorScreenPoint(),Te=Ce.x-de,Oe=Ce.y-ye;return(()=>!(Te>30&&Oe>=0&&Oe<=Math.max(this._win.getBounds().height*.15,35)))()||(this._win.setEnabled(!1),this._win.setEnabled(!0),this._onDidTriggerSystemContextMenu.fire({x:Te,y:Oe})),0})}(b.isMacintosh||b.isWindows)&&Ae&&(!Ee||v.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(oe=>typeof oe=="number")&&this._win.setBounds({width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y}),je&&((0,C.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.show(),(0,C.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),this.onConfigurationUpdated(),this.createTouchBar(),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this._config?.backupPath}get openedWorkspace(){return this._config?.workspace}get profile(){return this.config?this.userDataProfilesService.getProfile(this.config.workspace??"empty-window",(0,se.revive)(this.config.profiles.current)):void 0}get remoteAuthority(){return this._config?.remoteAuthority}get config(){return this._config}get isExtensionDevelopmentHost(){return!!this._config?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this._config?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this._config?.debugId}setRepresentedFilename(A){b.isMacintosh?this._win.setRepresentedFilename(A):this.representedFilename=A}getRepresentedFilename(){return b.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(A){b.isMacintosh&&this._win.setDocumentEdited(A),this.documentEdited=A}isDocumentEdited(){return b.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(A){b.isMacintosh&&A?.force&&v.app.focus({steal:!0}),!!this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.logService.trace(`window#load: window reported ready (id: ${this._id})`),this.readyState=2;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(A=>{if(this.isReady)return A(this);this.whenReadyCallbacks.push(A)})}get isReady(){return this.readyState===2}get whenClosedOrLoaded(){return new Promise(A=>{function W(){$.dispose(),Y.dispose(),A()}const $=this.onDidClose(()=>W()),Y=this.onWillLoad(()=>W())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(W,$)=>this.onWindowError(2,$)),this._win.webContents.on("did-fail-load",(W,$,Y)=>this.onWindowError(3,{reason:Y,exitCode:$})),this._win.webContents.on("will-prevent-unload",W=>{W.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()}),this._win.webContents.on("did-finish-load",()=>{this.pendingLoadConfig&&(this._config=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",W=>{this._config&&(this._config.maximized=!0),v.app.emit("browser-window-maximize",W,this._win)}),this._win.on("unmaximize",W=>{this._config&&(this._config.maximized=!1),v.app.emit("browser-window-unmaximize",W,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",k.CancellationToken.None)}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",k.CancellationToken.None)}),this._register(this.configurationService.onDidChangeConfiguration(W=>this.onConfigurationUpdated(W))),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(W=>this.onDidDeleteUntitledWorkspace(W)));const A=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:A},async(W,$)=>{const Y=await this.getMarketplaceHeaders();$({cancel:!1,requestHeaders:Object.assign(W.requestHeaders,Y)})})}getMarketplaceHeaders(){return this.marketplaceHeadersPromise||(this.marketplaceHeadersPromise=(0,n.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,this.applicationStorageMainService,this.telemetryService)),this.marketplaceHeadersPromise}async onWindowError(A,W){switch(A){case 2:this.logService.error(`CodeWindow: renderer process crashed (reason: ${W?.reason||"<unknown>"}, code: ${W?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${W?.reason||"<unknown>"}, code: ${W?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:A,reason:W?.reason,code:W?.exitCode}),A){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.environmentMainService.args["enable-smoke-test-driver"]){this.destroyWindow(!1,!1);return}if(A===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const $=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,y.mnemonicButtonLabel)((0,d.localize)(0,null)),(0,y.mnemonicButtonLabel)((0,d.localize)(1,null)),(0,y.mnemonicButtonLabel)((0,d.localize)(2,null))],message:(0,d.localize)(3,null),detail:(0,d.localize)(4,null),noLink:!0,defaultId:0,cancelId:1,checkboxLabel:this._config?.workspace?(0,d.localize)(5,null):void 0},this._win);if($.response!==1){const Y=$.response===0;this.destroyWindow(Y,$.checkboxChecked)}}else if(A===2){let $;W?$=(0,d.localize)(7,null,W.reason,W.exitCode??"<unknown>"):$=(0,d.localize)(6,null);const Y=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,y.mnemonicButtonLabel)((0,d.localize)(8,null)),(0,y.mnemonicButtonLabel)((0,d.localize)(9,null))],message:$,detail:(0,d.localize)(10,null),noLink:!0,defaultId:0,checkboxLabel:this._config?.workspace?(0,d.localize)(11,null):void 0},this._win),z=Y.response===0;this.destroyWindow(z,Y.checkboxChecked)}break}}async destroyWindow(A,W){const $=this._config?.workspace;if(W&&$)try{const Y=this.storageMainService.workspaceStorage($);await Y.init(),Y.delete("memento/workbench.parts.editor"),await Y.close()}catch(Y){this.logService.error(Y)}if(this._onDidDestroy.fire(),this._win?.destroy(),A&&this._config){let Y,z;(0,F.isSingleFolderWorkspaceIdentifier)($)?Y={folderUri:$.uri}:(0,F.isWorkspaceIdentifier)($)?Y={workspaceUri:$.configPath}:z=!0;const[j]=this.windowsMainService.open({context:5,userEnv:this._config.userEnv,cli:{...this.environmentMainService.args,_:[]},urisToOpen:Y?[Y]:void 0,forceEmpty:z,forceNewWindow:!0,remoteAuthority:this.remoteAuthority});j.focus()}}onDidDeleteUntitledWorkspace(A){this._config?.workspace?.id===A.id&&this._config&&(this._config.workspace=void 0)}onConfigurationUpdated(A){const W=this.getMenuBarVisibility();W!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=W,this.setMenuBarVisibility(W));let $=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;$?.endsWith("/")&&($=$.substr(0,$.length-1));const Y=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if(($||"").indexOf("@")===-1&&($!==this.currentHttpProxy||Y!==this.currentNoProxy)){this.currentHttpProxy=$,this.currentNoProxy=Y;const z=$||"",j=Y?`${Y},<local>`:"<local>";this.logService.trace(`Setting proxy to '${z}', bypassing '${j}'`),this._win.webContents.session.setProxy({proxyRules:z,proxyBypassRules:j,pacScript:""})}}addTabbedWindow(A){b.isMacintosh&&A.win&&this._win.addTabbedWindow(A.win)}load(A,W=Object.create(null)){this.logService.trace(`window#load: attempt to load window (id: ${this._id})`),this.isDocumentEdited()&&(!W.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),W.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(A,W),this.readyState===0?this._config=A:this.pendingLoadConfig=A,this.readyState=1,this._win.loadURL(p.FileAccess.asBrowserUri("vs/code/electron-sandbox/workbench/workbench.html",H).toString(!0));const $=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new t.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:A.workspace,reason:W.isReload?3:$?2:1})}updateConfiguration(A,W){const $=(this._config??this.pendingLoadConfig)?.userEnv;if($){const Y=(0,m.isLaunchedFromCli)($)&&!(0,m.isLaunchedFromCli)(A.userEnv),z=this.isExtensionDevelopmentHost;(Y||z)&&(A.userEnv={...$,...A.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(A.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),W.disableExtensions!==void 0&&(A["disable-extensions"]=W.disableExtensions),A.fullscreen=this.isFullScreen,A.maximized=this._win.isMaximized(),A.partsSplash=this.themeMainService.getWindowSplash(),(0,C.mark)("code/willOpenNewWindow"),A.perfMarks=(0,C.getMarks)(),this.configObjectUrl.update(A)}async reload(A){const W=Object.assign({},this._config);W.workspace=await this.validateWorkspaceBeforeReload(W),delete W.filesToOpenOrCreate,delete W.filesToDiff,delete W.filesToMerge,delete W.filesToWait,this.isExtensionDevelopmentHost&&A&&(W.verbose=A.verbose,W.debugId=A.debugId,W.extensionEnvironment=A.extensionEnvironment,W["inspect-extensions"]=A["inspect-extensions"],W["inspect-brk-extensions"]=A["inspect-brk-extensions"],W["extensions-dir"]=A["extensions-dir"]),W.isInitialStartup=!1,W.policiesData=this.policyService.serialize(),W.editSessionId=this.environmentMainService.editSessionId,W.profiles={all:this.userDataProfilesService.profiles,current:this.profile||this.userDataProfilesService.defaultProfile},this.load(W,{isReload:!0,disableExtensions:A?.["disable-extensions"]})}async validateWorkspaceBeforeReload(A){if((0,F.isWorkspaceIdentifier)(A.workspace)){const W=A.workspace.configPath;if(W.scheme===p.Schemas.file&&!await this.fileService.exists(W))return}else if((0,F.isSingleFolderWorkspaceIdentifier)(A.workspace)){const W=A.workspace.uri;if(W.scheme===p.Schemas.file&&!await this.fileService.exists(W))return}return A.workspace}serializeWindowState(){if(!this._win)return(0,Q.defaultWindowState)();if(this.isFullScreen){let $;try{$=v.screen.getDisplayMatching(this.getBounds())}catch{}const Y=(0,Q.defaultWindowState)();return{mode:3,display:$?$.id:void 0,width:this.windowState.width||Y.width,height:this.windowState.height||Y.height,x:this.windowState.x||0,y:this.windowState.y||0}}const A=Object.create(null);let W;if(!b.isMacintosh&&this._win.isMaximized()?W=0:W=1,W===0?A.mode=0:A.mode=1,W===1||W===0){let $;W===1?$=this.getBounds():$=this._win.getNormalBounds(),A.x=$.x,A.y=$.y,A.width=$.width,A.height=$.height}return A}updateWindowControls(A){A.height&&this.stateMainService.setItem(Mt.windowControlHeightStateStorageKey,A.height),b.isWindows?this._win.setTitleBarOverlay({color:A.backgroundColor?.trim()===""?void 0:A.backgroundColor,symbolColor:A.foregroundColor?.trim()===""?void 0:A.foregroundColor,height:A.height?A.height-1:void 0}):b.isMacintosh&&A.height!==void 0&&this._win.setTrafficLightPosition({x:7,y:(A.height-15)/2})}restoreWindowState(A){(0,C.mark)("code/willRestoreCodeWindowState");let W=!1;if(A)try{const $=v.screen.getAllDisplays();W=$.length>1,A=this.validateWindowState(A,$)}catch($){this.logService.warn(`Unexpected error validating window state: ${$}
${$.stack}`)}return(0,C.mark)("code/didRestoreCodeWindowState"),[A||(0,Q.defaultWindowState)(),W]}validateWindowState(A,W){if(this.logService.trace(`window#validateWindowState: validating window state on ${W.length} display(s)`,A),typeof A.x!="number"||typeof A.y!="number"||typeof A.width!="number"||typeof A.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(A.width<=0||A.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(W.length===1){const z=this.getWorkingArea(W[0]);if(z){let j=function(){!A||typeof A.x!="number"||typeof A.y!="number"||!z||(A.x<z.x&&(A.x=z.x),A.y<z.y&&(A.y=z.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",z),j(),A.width>z.width&&(A.width=z.width),A.height>z.height&&(A.height=z.height),A.x>z.x+z.width-128&&(A.x=z.x+z.width-A.width),A.y>z.y+z.height-128&&(A.y=z.y+z.height-A.height),j()}return A}if(A.display&&A.mode===3){const z=W.find(j=>j.id===A.display);if(z&&typeof z.bounds?.x=="number"&&typeof z.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const j=(0,Q.defaultWindowState)(3);return j.x=z.bounds.x,j.y=z.bounds.y,j}}let $,Y;try{$=v.screen.getDisplayMatching({x:A.x,y:A.y,width:A.width,height:A.height}),Y=this.getWorkingArea($)}catch{}if($&&Y&&A.x+A.width>Y.x&&A.y+A.height>Y.y&&A.x<Y.x+Y.width&&A.y<Y.y+Y.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",Y),A}getWorkingArea(A){if(A.workArea.width>0&&A.workArea.height>0)return A.workArea;if(A.bounds.width>0&&A.bounds.height>0)return A.bounds}getBounds(){const[A,W]=this._win.getPosition(),[$,Y]=this._win.getSize();return{x:A,y:W,width:$,height:Y}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(A){this.useNativeFullScreen()?this.setNativeFullScreen(A):this.setSimpleFullScreen(A),this.sendWhenReady(A?"vscode:enterFullScreen":"vscode:leaveFullScreen",k.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(A){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this._win.setFullScreen(A)}setSimpleFullScreen(A){this._win.isFullScreen()&&this._win.setFullScreen(!1),this._win.setSimpleFullScreen(A),this._win.webContents.focus()}useNativeFullScreen(){const A=this.configurationService.getValue("window");return!A||typeof A.nativeFullScreen!="boolean"||A.nativeTabs?!0:A.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let A=(0,M.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(A)<0&&(A="classic"),A}setMenuBarVisibility(A,W=!0){b.isMacintosh||(A==="toggle"&&W&&this.send("vscode:showInfoMessage",(0,d.localize)(12,null)),A==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(A)}):this.doSetMenuBarVisibility(A))}doSetMenuBarVisibility(A){const W=this.isFullScreen;switch(A){case"classic":this._win.setMenuBarVisibility(!W),this._win.autoHideMenuBar=W;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(b.isMacintosh)switch(v.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win?.close()}sendWhenReady(A,W,...$){this.isReady?this.send(A,...$):this.ready().then(()=>{W.isCancellationRequested||this.send(A,...$)})}send(A,...W){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel '${A}' for window that is destroyed`);return}try{this._win.webContents.send(A,...W)}catch($){this.logService.warn(`Error sending IPC message to channel '${A}' of window ${this._id}: ${(0,R.toErrorMessage)($)}`)}}}updateTouchBar(A){!b.isMacintosh||this.touchBarGroups.forEach((W,$)=>{const Y=A[$];W.segments=this.createTouchBarGroupSegments(Y)})}createTouchBar(){if(!!b.isMacintosh){for(let A=0;A<10;A++){const W=this.createTouchBarGroup();this.touchBarGroups.push(W)}this._win.setTouchBar(new v.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(A=[]){const W=this.createTouchBarGroupSegments(A),$=new v.TouchBar.TouchBarSegmentedControl({segments:W,mode:"buttons",segmentStyle:"automatic",change:Y=>{this.sendWhenReady("vscode:runAction",k.CancellationToken.None,{id:$.segments[Y].id,from:"touchbar"})}});return $}createTouchBarGroupSegments(A=[]){return A.map($=>{let Y;$.icon&&!l.ThemeIcon.isThemeIcon($.icon)&&$.icon?.dark?.scheme===p.Schemas.file&&(Y=v.nativeImage.createFromPath(g.URI.revive($.icon.dark).fsPath),Y.isEmpty()&&(Y=void 0));let z;return typeof $.title=="string"?z=$.title:z=$.title.value,{id:$.id,label:Y?void 0:z,icon:Y}})}dispose(){super.dispose(),this._win=null}};N.windowControlHeightStateStorageKey="windowControlHeight",N=ve([J(1,s.ILogService),J(2,w.IEnvironmentMainService),J(3,ue.IPolicyService),J(4,fe.IUserDataProfilesService),J(5,u.IFileService),J(6,o.IApplicationStorageMainService),J(7,o.IStorageMainService),J(8,S.IConfigurationService),J(9,P.IThemeMainService),J(10,U.IWorkspacesManagementMainService),J(11,E.IBackupMainService),J(12,a.ITelemetryService),J(13,f.IDialogMainService),J(14,c.ILifecycleMainService),J(15,r.IProductService),J(16,i.IProtocolMainService),J(17,T.IWindowsMainService),J(18,le.IStateMainService)],N),e.CodeWindow=N}),define(Z[75],ee([0,1,15,24,8,3,36,2,13,4,16,7,23,174,5,22,6,90,91,25,47]),function(H,e,v,t,k,R,D,y,h,p,I,C,b,g,d,E,S,f,w,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,d.createDecorator)("workspacesHistoryMainService");let c=class it extends y.Disposable{constructor(r,i,n,o){super();this.logService=r,this.workspacesManagementMainService=i,this.lifecycleMainService=n,this.applicationStorageMainService=o,this._onDidChangeRecentlyOpened=this._register(new R.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new k.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(3).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(r=>this.addRecentlyOpened([{workspace:r.workspace,remoteAuthority:r.window.remoteAuthority}])))}async addRecentlyOpened(r){const i=[],n=[];for(const o of r)if((0,w.isRecentWorkspace)(o))!this.workspacesManagementMainService.isUntitledWorkspace(o.workspace)&&this.indexOfWorkspace(i,o.workspace)===-1&&i.push(o);else if((0,w.isRecentFolder)(o))this.indexOfFolder(i,o.folderUri)===-1&&i.push(o);else{const a=this.indexOfFile(n,o.fileUri)>=0,l=o.fileUri.scheme===h.Schemas.file&&it.COMMON_FILES_FILTER.indexOf((0,I.basename)(o.fileUri))>=0;!a&&!l&&(n.push(o),p.isWindows&&o.fileUri.scheme===h.Schemas.file&&v.app.addRecentDocument(o.fileUri.fsPath))}await this.addEntriesFromStorage(i,n),i.length>it.MAX_TOTAL_RECENT_ENTRIES&&(i.length=it.MAX_TOTAL_RECENT_ENTRIES),n.length>it.MAX_TOTAL_RECENT_ENTRIES&&(n.length=it.MAX_TOTAL_RECENT_ENTRIES),await this.saveRecentlyOpened({workspaces:i,files:n}),this._onDidChangeRecentlyOpened.fire(),p.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}async removeRecentlyOpened(r){const i=l=>{const P=this.location(l);for(const M of r)if(I.extUriBiasedIgnorePathCase.isEqual(M,P))return!1;return!0},n=await this.getRecentlyOpened(),o=n.workspaces.filter(i),a=n.files.filter(i);(o.length!==n.workspaces.length||a.length!==n.files.length)&&(await this.saveRecentlyOpened({files:a,workspaces:o}),this._onDidChangeRecentlyOpened.fire(),p.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async clearRecentlyOpened(){await this.saveRecentlyOpened({workspaces:[],files:[]}),v.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}async getRecentlyOpened(){const r=[],i=[];return await this.addEntriesFromStorage(r,i),{workspaces:r,files:i}}async addEntriesFromStorage(r,i){const n=await this.getRecentlyOpenedFromStorage();for(const o of n.workspaces){const a=(0,w.isRecentFolder)(o)?this.indexOfFolder(r,o.folderUri):this.indexOfWorkspace(r,o.workspace);a>=0?r[a].label=r[a].label||o.label:r.push(o)}for(const o of n.files){const a=this.indexOfFile(i,o.fileUri);a>=0?i[a].label=i[a].label||o.label:i.push(o)}}async getRecentlyOpenedFromStorage(){await this.applicationStorageMainService.whenReady;let r;const i=this.applicationStorageMainService.get(it.RECENTLY_OPENED_STORAGE_KEY,-1);if(typeof i=="string")try{r=JSON.parse(i)}catch(n){this.logService.error("Unexpected error parsing opened paths list",n)}return(0,w.restoreRecentlyOpened)(r,this.logService)}async saveRecentlyOpened(r){await this.applicationStorageMainService.whenReady,this.applicationStorageMainService.store(it.RECENTLY_OPENED_STORAGE_KEY,JSON.stringify((0,w.toStoreData)(r)),-1,1)}location(r){return(0,w.isRecentFolder)(r)?r.folderUri:(0,w.isRecentFile)(r)?r.fileUri:r.workspace.configPath}indexOfWorkspace(r,i){return r.findIndex(n=>(0,w.isRecentWorkspace)(n)&&n.workspace.id===i.id)}indexOfFolder(r,i){return r.findIndex(n=>(0,w.isRecentFolder)(n)&&I.extUriBiasedIgnorePathCase.isEqual(n.folderUri,i))}indexOfFile(r,i){return r.findIndex(n=>I.extUriBiasedIgnorePathCase.isEqual(n.fileUri,i))}async handleWindowsJumpList(){!p.isWindows||(await this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}async updateWindowsJumpList(){if(!p.isWindows)return;const r=[];if(r.push({type:"tasks",items:[{type:"task",title:(0,g.localize)(0,null),description:(0,g.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const i=[];for(const a of v.app.getJumpListSettings().removedItems){const l=a.args;if(l){const P=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(l);P&&i.push(C.URI.parse(P[2]))}}await this.removeRecentlyOpened(i);let n=!1;const o=(0,t.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,it.MAX_WINDOWS_JUMP_LIST_ENTRIES).map(a=>{const l=(0,w.isRecentWorkspace)(a)?a.workspace:a.folderUri,{title:P,description:M}=this.getWindowsJumpListLabel(l,a.label);let T;return C.URI.isUri(l)?T=`--folder-uri "${l.toString()}"`:(n=!0,T=`--file-uri "${l.configPath.toString()}"`),{type:"task",title:P.substr(0,255),description:M.substr(0,255),program:process.execPath,args:T,iconPath:"explorer.exe",iconIndex:0}}));o.length>0&&r.push({type:"custom",name:n?(0,g.localize)(2,null):(0,g.localize)(3,null),items:o})}r.push({type:"recent"});try{const i=v.app.setJumpList(r);i&&i!=="ok"&&this.logService.warn(`updateWindowsJumpList#setJumpList unexpected result: ${i}`)}catch(i){this.logService.warn("updateWindowsJumpList#setJumpList",i)}}getWindowsJumpListLabel(r,i){if(i)return{title:(0,D.splitName)(i).name,description:i};if(C.URI.isUri(r))return{title:(0,I.basename)(r),description:this.renderJumpListPathDescription(r)};if(this.workspacesManagementMainService.isUntitledWorkspace(r))return{title:(0,g.localize)(4,null),description:""};let n=(0,I.basename)(r.configPath);return n.endsWith(m.WORKSPACE_EXTENSION)&&(n=n.substr(0,n.length-m.WORKSPACE_EXTENSION.length-1)),{title:(0,g.localize)(5,null,n),description:this.renderJumpListPathDescription(r.configPath)}}renderJumpListPathDescription(r){return r.scheme==="file"?(0,D.normalizeDriveLetter)(r.fsPath):r.toString()}async updateMacOSRecentDocuments(){if(!p.isMacintosh)return;v.app.clearRecentDocuments();const r=await this.getRecentlyOpened(),i=[];let n=0;for(let a=0;a<r.workspaces.length&&n<it.MAX_MACOS_DOCK_RECENT_WORKSPACES;a++){const l=this.location(r.workspaces[a]);if(l.scheme===h.Schemas.file){const P=(0,I.originalFSPath)(l);await b.Promises.exists(P)&&(i.push(P),n++)}}const o=[];for(let a=0;a<r.files.length&&n<it.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;a++){const l=this.location(r.files[a]);if(l.scheme===h.Schemas.file){const P=(0,I.originalFSPath)(l);if(it.COMMON_FILES_FILTER.includes((0,I.basename)(l))||i.includes(P))continue;await b.Promises.exists(P)&&(o.push(P),n++)}}o.reverse().forEach(a=>v.app.addRecentDocument(a)),i.reverse().forEach(a=>v.app.addRecentDocument(a))}};c.MAX_TOTAL_RECENT_ENTRIES=500,c.RECENTLY_OPENED_STORAGE_KEY="history.recentlyOpenedPathsList",c.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,c.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,c.MAX_WINDOWS_JUMP_LIST_ENTRIES=7,c.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],c=ve([J(0,S.ILogService),J(1,u.IWorkspacesManagementMainService),J(2,E.ILifecycleMainService),J(3,f.IApplicationStorageMainService)],c),e.WorkspacesHistoryMainService=c}),define(Z[261],ee([0,1,15,8,21,36,4,7,164,19,27,22,6,208,66,20,41,38,46,74,33,75]),function(H,e,v,t,k,R,D,y,h,p,I,C,b,g,d,E,S,f,w,m,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const s="menu";let r=class Dt{constructor(o,a,l,P,M,T,F,U,Q,re,ue){this.updateService=o,this.configurationService=a,this.windowsMainService=l,this.environmentMainService=P,this.telemetryService=M,this.workspacesHistoryMainService=T,this.stateMainService=F,this.lifecycleMainService=U,this.logService=Q,this.nativeHostMainService=re,this.productService=ue,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new t.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new t.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(D.isMacintosh||(0,m.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const o=this.stateMainService.getItem(Dt.lastKnownMenubarStorageKey);o&&(o.menus&&(this.menubarMenus=o.menus),o.keybindings&&(this.keybindings=o.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(T,F,U)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:F?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(T,F,U)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:F?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(T,F,U)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(U),telemetryExtraData:{from:s}}),this.fallbackMenuHandlers["workbench.action.files.openFolder"]=(T,F,U)=>this.nativeHostMainService.pickFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(U),telemetryExtraData:{from:s}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(T,F,U)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(U),telemetryExtraData:{from:s}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const o=this.productService.twitterUrl;o&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(o,"openTwitterUrl"));const a=this.productService.requestFeatureUrl;a&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(a,"openUserVoiceUrl"));const l=this.productService.reportIssueUrl;l&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(l,"openReportIssues"));const P=this.productService.licenseUrl;P&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(D.language){const T=P.indexOf("?")>0?"&":"?";this.openUrl(`${P}${T}lang=${D.language}`,"openLicenseUrl")}else this.openUrl(P,"openLicenseUrl")});const M=this.productService.privacyStatementUrl;M&&P&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(M,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(o=>this.onDidChangeWindowsCount(o)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){const o=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof o!="boolean"?!0:o}get currentEnableNativeTabs(){if(!D.isMacintosh)return!1;const o=this.configurationService.getValue("window.nativeTabs");return typeof o!="boolean"?!1:o}updateMenu(o,a){this.menubarMenus=o.menus,this.keybindings=o.keybindings,this.stateMainService.setItem(Dt.lastKnownMenubarStorageKey,o),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(o){!D.isMacintosh||(o.oldCount===0&&o.newCount>0||o.oldCount>0&&o.newCount===0)&&(this.closedLastWindow=o.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!D.isMacintosh||(this.noActiveWindow=!v.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const o=v.Menu.getApplicationMenu();if(o&&this.oldMenus.push(o),Object.keys(this.menubarMenus).length===0){v.Menu.setApplicationMenu(D.isMacintosh?new v.Menu:null);return}const a=new v.Menu;let l;if(D.isMacintosh){const M=new v.Menu;l=new v.MenuItem({label:this.productService.nameShort,submenu:M}),this.setMacApplicationMenu(M),a.append(l)}if(D.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const M=new v.Menu;M.append(new v.MenuItem({label:this.mnemonicLabel(h.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),v.app.dock.setMenu(M)}if(this.shouldDrawMenu("File")){const M=new v.Menu,T=new v.MenuItem({label:this.mnemonicLabel(h.localize(1,null)),submenu:M});this.setMenuById(M,"File"),a.append(T)}if(this.shouldDrawMenu("Edit")){const M=new v.Menu,T=new v.MenuItem({label:this.mnemonicLabel(h.localize(2,null)),submenu:M});this.setMenuById(M,"Edit"),a.append(T)}if(this.shouldDrawMenu("Selection")){const M=new v.Menu,T=new v.MenuItem({label:this.mnemonicLabel(h.localize(3,null)),submenu:M});this.setMenuById(M,"Selection"),a.append(T)}if(this.shouldDrawMenu("View")){const M=new v.Menu,T=new v.MenuItem({label:this.mnemonicLabel(h.localize(4,null)),submenu:M});this.setMenuById(M,"View"),a.append(T)}if(this.shouldDrawMenu("Go")){const M=new v.Menu,T=new v.MenuItem({label:this.mnemonicLabel(h.localize(5,null)),submenu:M});this.setMenuById(M,"Go"),a.append(T)}if(this.shouldDrawMenu("Run")){const M=new v.Menu,T=new v.MenuItem({label:this.mnemonicLabel(h.localize(6,null)),submenu:M});this.setMenuById(M,"Run"),a.append(T)}if(this.shouldDrawMenu("Terminal")){const M=new v.Menu,T=new v.MenuItem({label:this.mnemonicLabel(h.localize(7,null)),submenu:M});this.setMenuById(M,"Terminal"),a.append(T)}let P;if(this.shouldDrawMenu("Window")){const M=new v.Menu;P=new v.MenuItem({label:this.mnemonicLabel(h.localize(8,null)),submenu:M,role:"window"}),this.setMacWindowMenu(M)}if(P&&a.append(P),this.shouldDrawMenu("Help")){const M=new v.Menu,T=new v.MenuItem({label:this.mnemonicLabel(h.localize(9,null)),submenu:M,role:"help"});this.setMenuById(M,"Help"),a.append(T)}a.items&&a.items.length>0?v.Menu.setApplicationMenu(a):v.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(o){const a=this.createMenuItem(h.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),l=this.getUpdateMenuItems();let P;if(this.shouldDrawMenu("Preferences")){const fe=new v.Menu;this.setMenuById(fe,"Preferences"),P=new v.MenuItem({label:this.mnemonicLabel(h.localize(11,null)),submenu:fe})}const M=new v.Menu,T=new v.MenuItem({label:h.localize(12,null),role:"services",submenu:M}),F=new v.MenuItem({label:h.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),U=new v.MenuItem({label:h.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),Q=new v.MenuItem({label:h.localize(15,null),role:"unhide"}),re=new v.MenuItem(this.likeAction("workbench.action.quit",{label:h.localize(16,null,this.productService.nameLong),click:async(fe,se,le)=>{const K=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!v.BrowserWindow.getFocusedWindow()||K?.isMinimized())&&await this.confirmBeforeQuit(le)&&this.nativeHostMainService.quit(void 0)}})),ue=[a];ue.push(...l),P&&ue.push(i(),P),ue.push(i(),T,i(),F,U,Q,i(),re),ue.forEach(fe=>o.append(fe))}async confirmBeforeQuit(o){if(this.windowsMainService.getWindowCount()===0)return!0;const a=this.configurationService.getValue("window.confirmBeforeClose");if(a==="always"||a==="keyboardOnly"&&this.isKeyboardEvent(o)){const l={title:this.productService.nameLong,type:"question",buttons:[(0,R.mnemonicButtonLabel)(h.localize(17,null)),(0,R.mnemonicButtonLabel)(h.localize(18,null))],message:h.localize(19,null),noLink:!0,defaultId:0,cancelId:1},{response:P}=await this.nativeHostMainService.showMessageBox(this.windowsMainService.getFocusedWindow()?.id,l);return P===0}return!0}shouldDrawMenu(o){if(!D.isMacintosh&&(0,m.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(o){case"File":case"Help":if(D.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[o];case"Window":if(D.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[o]}}setMenu(o,a){a.forEach(l=>{if((0,g.isMenubarMenuItemSeparator)(l))o.append(i());else if((0,g.isMenubarMenuItemSubmenu)(l)){const P=new v.Menu,M=new v.MenuItem({label:this.mnemonicLabel(l.label),submenu:P});this.setMenu(P,l.submenu.items),o.append(M)}else(0,g.isMenubarMenuItemRecentAction)(l)?o.append(this.createOpenRecentMenuItem(l)):(0,g.isMenubarMenuItemAction)(l)&&(l.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(o),D.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[l.id]?o.append(new v.MenuItem(this.likeAction(l.id,{label:this.mnemonicLabel(l.label),click:this.fallbackMenuHandlers[l.id]}))):o.append(this.createMenuItem(l.label,l.id,!1,l.checked)):o.append(this.createMenuItem(l.label,l.id,l.enabled!==!1,!!l.checked)):o.append(this.createMenuItem(l.label,l.id,l.enabled!==!1,!!l.checked)))})}setMenuById(o,a){this.menubarMenus&&this.menubarMenus[a]&&this.setMenu(o,this.menubarMenus[a].items)}insertCheckForUpdatesItems(o){const a=this.getUpdateMenuItems();a.length&&(a.forEach(l=>o.append(l)),o.append(i()))}createOpenRecentMenuItem(o){const a=y.URI.revive(o.uri),l=o.id,P=l==="openRecentFile"?{fileUri:a}:l==="openRecentWorkspace"?{workspaceUri:a}:{folderUri:a};return new v.MenuItem(this.likeAction(l,{label:o.label,click:(M,T,F)=>{const U=this.isOptionClick(F);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[P],forceNewWindow:U,gotoLineMode:!1,remoteAuthority:o.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([a])}},!1))}isOptionClick(o){return!!(o&&(!D.isMacintosh&&(o.ctrlKey||o.shiftKey)||D.isMacintosh&&(o.metaKey||o.altKey)))}isKeyboardEvent(o){return!!(o.triggeredByAccelerator||o.altKey||o.ctrlKey||o.metaKey||o.shiftKey)}createRoleMenuItem(o,a,l){const P={label:this.mnemonicLabel(o),role:l,enabled:!0};return new v.MenuItem(this.withKeybinding(a,P))}setMacWindowMenu(o){const a=new v.MenuItem({label:h.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),l=new v.MenuItem({label:h.localize(21,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),P=new v.MenuItem({label:h.localize(22,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),M=this.createMenuItem(h.localize(23,null),"workbench.action.switchWindow"),T=[];this.currentEnableNativeTabs&&(T.push(i()),T.push(this.createMenuItem(h.localize(24,null),"workbench.action.newWindowTab")),T.push(this.createRoleMenuItem(h.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),T.push(this.createRoleMenuItem(h.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),T.push(this.createRoleMenuItem(h.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),T.push(this.createRoleMenuItem(h.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[a,l,i(),M,...T,i(),P].forEach(F=>o.append(F))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new v.MenuItem({label:this.mnemonicLabel(h.localize(29,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new v.MenuItem({label:h.localize(30,null),enabled:!1})];case"available for download":return[new v.MenuItem({label:this.mnemonicLabel(h.localize(31,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new v.MenuItem({label:h.localize(32,null),enabled:!1})];case"downloaded":return[new v.MenuItem({label:this.mnemonicLabel(h.localize(33,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new v.MenuItem({label:h.localize(34,null),enabled:!1})];case"ready":return[new v.MenuItem({label:this.mnemonicLabel(h.localize(35,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(o,a,l,P){const M=this.mnemonicLabel(o),T=typeof a=="function"?a:(ue,fe,se)=>{const le=ue?ue.userSettingsLabel:null;let K=a;Array.isArray(a)&&(K=this.isOptionClick(se)?a[1]:a[0]),le&&se.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:le}):this.runActionInRenderer({type:"commandId",commandId:K})},F=typeof l=="boolean"?l:this.windowsMainService.getWindowCount()>0,U=typeof P=="boolean"?P:!1,Q={label:M,click:T,enabled:F};U&&(Q.type="checkbox",Q.checked=U);let re;return typeof a=="string"?re=a:Array.isArray(a)&&(re=a[0]),D.isMacintosh&&(re==="editor.action.clipboardCutAction"?Q.role="cut":re==="editor.action.clipboardCopyAction"?Q.role="copy":re==="editor.action.clipboardPasteAction"&&(Q.role="paste"),re==="undo"?Q.click=this.makeContextAwareClickHandler(T,{inDevTools:ue=>ue.undo(),inNoWindow:()=>v.Menu.sendActionToFirstResponder("undo:")}):re==="redo"?Q.click=this.makeContextAwareClickHandler(T,{inDevTools:ue=>ue.redo(),inNoWindow:()=>v.Menu.sendActionToFirstResponder("redo:")}):re==="editor.action.selectAll"&&(Q.click=this.makeContextAwareClickHandler(T,{inDevTools:ue=>ue.selectAll(),inNoWindow:()=>v.Menu.sendActionToFirstResponder("selectAll:")}))),new v.MenuItem(this.withKeybinding(re,Q))}makeContextAwareClickHandler(o,a){return(l,P,M)=>{const T=v.BrowserWindow.getFocusedWindow();if(!T)return a.inNoWindow();if(T.webContents.isDevToolsFocused()&&T.webContents.devToolsWebContents)return a.inDevTools(T.webContents.devToolsWebContents);o(l,P||T,M)}}runActionInRenderer(o){let a=v.BrowserWindow.getFocusedWindow();if(!a){const P=this.windowsMainService.getLastActiveWindow();P?.isMinimized()&&(a=P.win)}const l=a?this.windowsMainService.getWindowById(a.id):void 0;if(l){if(this.logService.trace("menubar#runActionInRenderer",o),D.isMacintosh&&!this.environmentMainService.isBuilt&&!l.isReady&&(o.type==="commandId"&&o.commandId==="workbench.action.toggleDevTools"||o.type!=="commandId"&&o.userSettingsLabel==="alt+cmd+i"))return;if(o.type==="commandId"){const P={id:o.commandId,from:"menu"};l.sendWhenReady("vscode:runAction",k.CancellationToken.None,P)}else{const P={userSettingsLabel:o.userSettingsLabel};l.sendWhenReady("vscode:runKeybinding",k.CancellationToken.None,P)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",o)}withKeybinding(o,a){const l=typeof o=="string"?this.keybindings[o]:void 0;if(l?.label){if(l.isNative!==!1)a.accelerator=l.label,a.userSettingsLabel=l.userSettingsLabel;else if(typeof a.label=="string"){const P=a.label.indexOf("[");P>=0?a.label=`${a.label.substr(0,P)} [${l.label}]`:a.label=`${a.label} [${l.label}]`}}else a.accelerator=void 0;return a}likeAction(o,a,l=!a.accelerator){l&&(a=this.withKeybinding(o,a));const P=a.click;return a.click=(M,T,F)=>{this.reportMenuActionTelemetry(o),P?.(M,T,F)},a}openUrl(o,a){this.nativeHostMainService.openExternal(void 0,o),this.reportMenuActionTelemetry(a)}reportMenuActionTelemetry(o){this.telemetryService.publicLog2("workbenchActionExecuted",{id:o,from:s})}mnemonicLabel(o){return(0,R.mnemonicMenuLabel)(o,!this.currentEnableMenuBarMnemonics)}};r.lastKnownMenubarStorageKey="lastKnownMenubarData",r=ve([J(0,w.IUpdateService),J(1,p.IConfigurationService),J(2,u.IWindowsMainService),J(3,I.IEnvironmentMainService),J(4,f.ITelemetryService),J(5,c.IWorkspacesHistoryMainService),J(6,S.IStateMainService),J(7,C.ILifecycleMainService),J(8,b.ILogService),J(9,d.INativeHostMainService),J(10,E.IProductService)],r),e.Menubar=r;function i(){return new v.MenuItem({type:"separator"})}}),define(Z[262],ee([0,1,5,22,6,261]),function(H,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,v.createDecorator)("menubarMainService");let D=class{constructor(h,p,I){this.instantiationService=h,this.lifecycleMainService=p,this.logService=I,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(R.Menubar)}async updateMenubar(h,p){this.logService.trace("menubarService#updateMenubar",h),(await this.menubar).updateMenu(p,h)}};D=ve([J(0,v.IInstantiationService),J(1,t.ILifecycleMainService),J(2,k.ILogService)],D),e.MenubarMainService=D}),define(Z[263],ee([0,1,15,29,30,24,21,3,31,48,36,2,13,9,71,4,35,16,12,7,172,59,19,54,27,14,5,22,6,60,20,61,63,41,74,260,116,256,25,117,75,47,64,34,39]),function(H,e,v,t,k,R,D,y,h,p,I,C,b,g,d,E,S,f,w,m,u,c,s,r,i,n,o,a,l,P,M,T,F,U,Q,re,ue,fe,se,le,K,N,_,A,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function $(j){return(0,se.isWorkspaceIdentifier)(j?.workspace)}function Y(j){return(0,se.isSingleFolderWorkspaceIdentifier)(j?.workspace)}let z=class ut extends C.Disposable{constructor(L,O,B,V,x,ie,q,te,ne,ce,he,ke,Le,Me,Ae,je,me,pe){super();this.machineId=L,this.initialUserEnv=O,this.logService=B,this.stateMainService=V,this.policyService=x,this.environmentMainService=ie,this.userDataProfilesService=q,this.lifecycleMainService=te,this.backupMainService=ne,this.configurationService=ce,this.workspacesHistoryMainService=he,this.workspacesManagementMainService=ke,this.instantiationService=Le,this.dialogMainService=Me,this.fileService=Ae,this.productService=je,this.protocolMainService=me,this.themeMainService=pe,this._onDidOpenWindow=this._register(new y.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new y.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new y.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new y.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this._onDidTriggerSystemContextMenu=this._register(new y.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this.windowsStateHandler=this._register(new fe.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(L=>this._onDidSignalReadyWindow.fire(L.window))),this._register(this.onDidSignalReadyWindow(L=>{if(L.config?.extensionDevelopmentPath||L.config?.extensionTestsPath){const O=new C.DisposableStore;if(O.add(y.Event.any(L.onDidClose,L.onDidDestroy)(()=>O.dispose())),L.config.extensionDevelopmentPath)for(const B of L.config.extensionDevelopmentPath)O.add(this.protocolMainService.addValidFileRoot(B));L.config.extensionTestsPath&&O.add(this.protocolMainService.addValidFileRoot(L.config.extensionTestsPath))}}))}openEmptyWindow(L,O){const B=this.environmentMainService.args,V=O?.remoteAuthority||void 0,x=!0,ie=O?.forceReuseWindow,q=!ie;return this.open({...L,cli:B,forceEmpty:x,forceNewWindow:q,forceReuseWindow:ie,remoteAuthority:V})}openExistingWindow(L,O){L.focus(),this.handleWaitMarkerFile(O,[L])}open(L){this.logService.trace("windowsManager#open"),L.addMode&&(L.initialStartup||!this.getLastActiveWindow())&&(L.addMode=!1);const O=[],B=[],V=[],x=[],ie=[];let q,te=0;const ne=this.getPathsToOpen(L);this.logService.trace("windowsManager#open pathsToOpen",ne);for(const Me of ne)Y(Me)?L.addMode?O.push(Me):B.push(Me):$(Me)?V.push(Me):Me.fileUri?(q||(q={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:Me.remoteAuthority}),q.filesToOpenOrCreate.push(Me)):Me.backupPath?ie.push({backupFolder:(0,g.basename)(Me.backupPath),remoteAuthority:Me.remoteAuthority}):te++;L.diffMode&&q&&q.filesToOpenOrCreate.length>=2&&(q.filesToDiff=q.filesToOpenOrCreate.slice(0,2),q.filesToOpenOrCreate=[]),L.mergeMode&&q&&q.filesToOpenOrCreate.length===4&&(q.filesToMerge=q.filesToOpenOrCreate.slice(0,4),q.filesToOpenOrCreate=[],q.filesToDiff=[]),q&&L.waitMarkerFileURI&&(q.filesToWait={paths:(0,R.coalesce)([...q.filesToDiff,q.filesToMerge[3],...q.filesToOpenOrCreate]),waitMarkerFileUri:L.waitMarkerFileURI}),L.initialStartup?(x.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),V.push(...x),ie.push(...this.backupMainService.getEmptyWindowBackupPaths())):ie.length=0;const{windows:ce,filesOpenedInWindow:he}=this.doOpen(L,V,B,ie,te,q,O);if(this.logService.trace(`windowsManager#open used window count ${ce.length} (workspacesToOpen: ${V.length}, foldersToOpen: ${B.length}, emptyToRestore: ${ie.length}, emptyToOpen: ${te})`),ce.length>1)if(he)he.focus();else{const Me=this.windowsStateHandler.state.lastActiveWindow&&!L.forceEmpty&&!L.cli._.length&&!L.cli["file-uri"]&&!L.cli["folder-uri"]&&!(L.urisToOpen&&L.urisToOpen.length);let Ae=!0,je=!0;if(Me){const me=ce.filter(pe=>this.windowsStateHandler.state.lastActiveWindow&&pe.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);me.length&&(me[0].focus(),Ae=!1,je=!1)}if(Ae)for(let me=ce.length-1;me>=0;me--){const pe=ce[me];if(!(pe.openedWorkspace&&x.some(Ee=>pe.openedWorkspace&&Ee.workspace.id===pe.openedWorkspace.id)||pe.backupPath&&ie.some(Ee=>pe.backupPath&&Ee.backupFolder===(0,g.basename)(pe.backupPath)))){pe.focus(),je=!1;break}}je&&ce[ce.length-1].focus()}const ke=q&&q.filesToDiff.length>0,Le=q&&q.filesToMerge.length>0;if(!ce.some(Me=>Me.isExtensionDevelopmentHost)&&!ke&&!Le&&!L.noRecentEntry){const Me=[];for(const Ae of ne)$(Ae)&&!Ae.transient?Me.push({label:Ae.label,workspace:Ae.workspace,remoteAuthority:Ae.remoteAuthority}):Y(Ae)?Me.push({label:Ae.label,folderUri:Ae.workspace.uri,remoteAuthority:Ae.remoteAuthority}):Ae.fileUri&&Me.push({label:Ae.label,fileUri:Ae.fileUri,remoteAuthority:Ae.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(Me)}return this.handleWaitMarkerFile(L,ce),ce}handleWaitMarkerFile(L,O){const B=L.waitMarkerFileURI;L.context===0&&B&&O.length===1&&O[0]&&(async()=>{await O[0].whenClosedOrLoaded;try{await this.fileService.del(B)}catch{}})()}doOpen(L,O,B,V,x,ie,q){const te=[];let ne;function ce(me,pe){te.push(me),pe&&(ne=me,ie=void 0)}let{openFolderInNewWindow:he,openFilesInNewWindow:ke}=this.shouldOpenNewWindow(L);if(!L.initialStartup&&q.length>0){const me=q[0].remoteAuthority,pe=this.getLastActiveWindowForAuthority(me);pe&&ce(this.doAddFoldersToExistingWindow(pe,q.map(Ee=>Ee.workspace.uri)))}const Le=B.length+O.length+V.length;if(ie&&Le===0){const me=ie.filesToOpenOrCreate[0]||ie.filesToDiff[0]||ie.filesToMerge[3],pe=this.getWindows().filter(X=>ie&&(0,f.isEqualAuthority)(X.remoteAuthority,ie.remoteAuthority));let Ee;me?.fileUri&&!ke&&((L.context===4||L.context===0||L.context===1)&&(Ee=(0,ue.findWindowOnFile)(pe,me.fileUri,X=>X.configPath.scheme===b.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(X.configPath):void 0)),Ee||(Ee=this.doGetLastActiveWindow(pe))),Ee?(0,se.isWorkspaceIdentifier)(Ee.openedWorkspace)?O.push({workspace:Ee.openedWorkspace,remoteAuthority:Ee.remoteAuthority}):(0,se.isSingleFolderWorkspaceIdentifier)(Ee.openedWorkspace)?B.push({workspace:Ee.openedWorkspace,remoteAuthority:Ee.remoteAuthority}):ce(this.doOpenFilesInExistingWindow(L,Ee,ie),!0):ce(this.openInBrowserWindow({userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,filesToOpen:ie,forceNewWindow:!0,remoteAuthority:ie.remoteAuthority,forceNewTabbedWindow:L.forceNewTabbedWindow}),!0)}const Me=(0,R.distinct)(O,me=>me.workspace.id);if(Me.length>0){const me=(0,R.coalesce)(Me.map(pe=>(0,ue.findWindowOnWorkspaceOrFolder)(this.getWindows(),pe.workspace.configPath)));if(me.length>0){const pe=me[0],Ee=(0,f.isEqualAuthority)(ie?.remoteAuthority,pe.remoteAuthority)?ie:void 0;ce(this.doOpenFilesInExistingWindow(L,pe,Ee),!!Ee),he=!0}Me.forEach(pe=>{if(me.some(oe=>oe.openedWorkspace&&oe.openedWorkspace.id===pe.workspace.id))return;const Ee=pe.remoteAuthority,X=(0,f.isEqualAuthority)(ie?.remoteAuthority,Ee)?ie:void 0;ce(this.doOpenFolderOrWorkspace(L,pe,he,X),!!X),he=!0})}const Ae=(0,R.distinct)(B,me=>f.extUriBiasedIgnorePathCase.getComparisonKey(me.workspace.uri));if(Ae.length>0){const me=(0,R.coalesce)(Ae.map(pe=>(0,ue.findWindowOnWorkspaceOrFolder)(this.getWindows(),pe.workspace.uri)));if(me.length>0){const pe=me[0],Ee=(0,f.isEqualAuthority)(ie?.remoteAuthority,pe.remoteAuthority)?ie:void 0;ce(this.doOpenFilesInExistingWindow(L,pe,Ee),!!Ee),he=!0}Ae.forEach(pe=>{if(me.some(oe=>(0,se.isSingleFolderWorkspaceIdentifier)(oe.openedWorkspace)&&f.extUriBiasedIgnorePathCase.isEqual(oe.openedWorkspace.uri,pe.workspace.uri)))return;const Ee=pe.remoteAuthority,X=(0,f.isEqualAuthority)(ie?.remoteAuthority,Ee)?ie:void 0;ce(this.doOpenFolderOrWorkspace(L,pe,he,X),!!X),he=!0})}const je=(0,R.distinct)(V,me=>me.backupFolder);if(je.length>0&&je.forEach(me=>{const pe=me.remoteAuthority,Ee=(0,f.isEqualAuthority)(ie?.remoteAuthority,pe)?ie:void 0;ce(this.doOpenEmpty(L,!0,pe,Ee,me),!!Ee),he=!0}),te.length===0||ie){ie&&!x&&x++;const me=ie?ie.remoteAuthority:L.remoteAuthority;for(let pe=0;pe<x;pe++)ce(this.doOpenEmpty(L,he,me,ie),!!ie),he=!0}return{windows:(0,R.distinct)(te),filesOpenedInWindow:ne}}doOpenFilesInExistingWindow(L,O,B){this.logService.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:B}),O.focus();const V={filesToOpenOrCreate:B?.filesToOpenOrCreate,filesToDiff:B?.filesToDiff,filesToMerge:B?.filesToMerge,filesToWait:B?.filesToWait,termProgram:L?.userEnv?.TERM_PROGRAM};return O.sendWhenReady("vscode:openFiles",D.CancellationToken.None,V),O}doAddFoldersToExistingWindow(L,O){this.logService.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:O}),L.focus();const B={foldersToAdd:O};return L.sendWhenReady("vscode:addFolders",D.CancellationToken.None,B),L}doOpenEmpty(L,O,B,V,x){this.logService.trace("windowsManager#doOpenEmpty",{restore:!!x,remoteAuthority:B,filesToOpen:V,forceNewWindow:O});let ie;return!O&&typeof L.contextWindowId=="number"&&(ie=this.getWindowById(L.contextWindowId)),this.openInBrowserWindow({userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,remoteAuthority:B,forceNewWindow:O,forceNewTabbedWindow:L.forceNewTabbedWindow,filesToOpen:V,windowToUse:ie,emptyWindowBackupInfo:x})}doOpenFolderOrWorkspace(L,O,B,V,x){return this.logService.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:O,filesToOpen:V}),!B&&!x&&typeof L.contextWindowId=="number"&&(x=this.getWindowById(L.contextWindowId)),this.openInBrowserWindow({workspace:O.workspace,userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,remoteAuthority:O.remoteAuthority,forceNewWindow:B,forceNewTabbedWindow:L.forceNewTabbedWindow,filesToOpen:V,windowToUse:x})}getPathsToOpen(L){let O,B=!1,V=!1;if(L.urisToOpen&&L.urisToOpen.length>0?(O=this.doExtractPathsFromAPI(L),B=!0):L.forceEmpty?O=[Object.create(null)]:L.cli._.length||L.cli["folder-uri"]||L.cli["file-uri"]?(O=this.doExtractPathsFromCLI(L.cli),O.length===0&&O.push(Object.create(null)),B=!0):(O=this.doGetPathsFromLastSession(),O.length===0&&O.push(Object.create(null)),V=!0),!L.addMode&&B){const x=O.filter(ie=>Y(ie));if(x.length>1){const ie=x[0].remoteAuthority;if(x.every(q=>(0,f.isEqualAuthority)(q.remoteAuthority,ie))){const q=this.workspacesManagementMainService.createUntitledWorkspaceSync(x.map(te=>({uri:te.workspace.uri})));O.push({workspace:q,remoteAuthority:ie}),O=O.filter(te=>!Y(te))}}}return L.initialStartup&&!V&&this.configurationService.getValue("window")?.restoreWindows==="preserve"&&O.unshift(...this.doGetPathsFromLastSession().filter(x=>$(x)||Y(x)||x.backupPath)),O}doExtractPathsFromAPI(L){const O=[],B={gotoLineMode:L.gotoLineMode,remoteAuthority:L.remoteAuthority};for(const V of(0,R.coalesce)(L.urisToOpen||[])){const x=this.resolveOpenable(V,B);if(x)x.label=V.label,O.push(x);else{const ie=this.resourceFromOpenable(V),q={title:this.productService.nameLong,type:"info",buttons:[(0,I.mnemonicButtonLabel)((0,u.localize)(0,null))],defaultId:0,message:ie.scheme===b.Schemas.file?(0,u.localize)(1,null):(0,u.localize)(2,null),detail:ie.scheme===b.Schemas.file?(0,u.localize)(3,null,(0,I.getPathLabel)(ie,{os:E.OS,tildify:this.environmentMainService})):(0,u.localize)(4,null,ie.toString(!0)),noLink:!0};this.dialogMainService.showMessageBox(q,(0,w.withNullAsUndefined)(v.BrowserWindow.getFocusedWindow()))}}return O}doExtractPathsFromCLI(L){const O=[],B={ignoreFileNotFound:!0,gotoLineMode:L.goto,remoteAuthority:L.remote||void 0,forceOpenWorkspaceAsFile:L.diff&&L._.length===2||L.merge&&L._.length===4},V=L["folder-uri"];if(V)for(const q of V){const te=this.cliArgToUri(q);if(te){const ne=this.resolveOpenable({folderUri:te},B);ne&&O.push(ne)}}const x=L["file-uri"];if(x)for(const q of x){const te=this.cliArgToUri(q);if(te){const ne=this.resolveOpenable((0,se.hasWorkspaceFileExtension)(q)?{workspaceUri:te}:{fileUri:te},B);ne&&O.push(ne)}}const ie=L._;for(const q of ie){const te=B.remoteAuthority?this.doResolvePathRemote(q,B):this.doResolveFilePath(q,B);te&&O.push(te)}return O}cliArgToUri(L){try{const O=m.URI.parse(L);if(!O.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${L}`);return}return O}catch(O){this.logService.error(`Invalid URI input string: ${L}, ${O.message}`)}}doGetPathsFromLastSession(){const L=this.getRestoreWindowsSetting();switch(L){case"none":return[];case"one":case"all":case"preserve":case"folders":{const O=[];L!=="one"&&O.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&O.push(this.windowsStateHandler.state.lastActiveWindow);const B=[];for(const V of O)if(V.workspace){const x=this.resolveOpenable({workspaceUri:V.workspace.configPath},{remoteAuthority:V.remoteAuthority,rejectTransientWorkspaces:!0});$(x)&&B.push(x)}else if(V.folderUri){const x=this.resolveOpenable({folderUri:V.folderUri},{remoteAuthority:V.remoteAuthority});Y(x)&&B.push(x)}else L!=="folders"&&V.backupPath&&B.push({backupPath:V.backupPath,remoteAuthority:V.remoteAuthority});return B}}}getRestoreWindowsSetting(){let L;return this.lifecycleMainService.wasRestarted?L="all":(L=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(L)||(L="all")),L}resolveOpenable(L,O=Object.create(null)){const B=this.resourceFromOpenable(L);return B.scheme===b.Schemas.file?((0,Q.isFileToOpen)(L)&&(O={...O,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(B.fsPath,O)):this.doResolveRemoteOpenable(L,O)}doResolveRemoteOpenable(L,O){let B=this.resourceFromOpenable(L);const V=(0,F.getRemoteAuthority)(B)||O.remoteAuthority;if(B=(0,f.removeTrailingPathSeparator)((0,f.normalizePath)(B)),(0,Q.isFileToOpen)(L)){if(O.gotoLineMode){const{path:x,line:ie,column:q}=(0,h.parseLineAndColumnAware)(B.path);return{fileUri:B.with({path:x}),options:{selection:ie?{startLineNumber:ie,startColumn:q||1}:void 0},remoteAuthority:V}}return{fileUri:B,remoteAuthority:V}}else if((0,Q.isWorkspaceToOpen)(L))return{workspace:(0,le.getWorkspaceIdentifier)(B),remoteAuthority:V};return{workspace:(0,le.getSingleFolderWorkspaceIdentifier)(B),remoteAuthority:V}}resourceFromOpenable(L){return(0,Q.isWorkspaceToOpen)(L)?L.workspaceUri:(0,Q.isFolderToOpen)(L)?L.folderUri:L.fileUri}doResolveFilePath(L,O){let B,V;O.gotoLineMode&&({path:L,line:B,column:V}=(0,h.parseLineAndColumnAware)(L)),L=(0,h.sanitizeFilePath)((0,g.normalize)(L),(0,S.cwd)());try{const x=(0,t.statSync)(L);if(x.isFile()){if(!O.forceOpenWorkspaceAsFile){const ie=this.workspacesManagementMainService.resolveLocalWorkspaceSync(m.URI.file(L));if(ie)return ie.transient&&O.rejectTransientWorkspaces?void 0:{workspace:{id:ie.id,configPath:ie.configPath},type:n.FileType.File,exists:!0,remoteAuthority:ie.remoteAuthority,transient:ie.transient}}return{fileUri:m.URI.file(L),type:n.FileType.File,exists:!0,options:{selection:B?{startLineNumber:B,startColumn:V||1}:void 0}}}else{if(x.isDirectory())return{workspace:(0,le.getSingleFolderWorkspaceIdentifier)(m.URI.file(L),x),type:n.FileType.Directory,exists:!0};if(!E.isWindows&&L==="/dev/null")return{fileUri:m.URI.file(L),type:n.FileType.File,exists:!0}}}catch{const ie=m.URI.file(L);if(this.workspacesHistoryMainService.removeRecentlyOpened([ie]),O.ignoreFileNotFound)return{fileUri:ie,type:n.FileType.File,exists:!1}}}doResolvePathRemote(L,O){const B=L.charCodeAt(0),V=O.remoteAuthority;let x,ie;O.gotoLineMode&&({path:L,line:x,column:ie}=(0,h.parseLineAndColumnAware)(L)),B!==47&&((0,h.isWindowsDriveLetter)(B)&&L.charCodeAt(L.charCodeAt(1))===58&&(L=(0,h.toSlashes)(L)),L=`/${L}`);const q=m.URI.from({scheme:b.Schemas.vscodeRemote,authority:V,path:L});if(L.charCodeAt(L.length-1)!==47){if((0,se.hasWorkspaceFileExtension)(L))return O.forceOpenWorkspaceAsFile?{fileUri:q,options:{selection:x?{startLineNumber:x,startColumn:ie||1}:void 0},remoteAuthority:O.remoteAuthority}:{workspace:(0,le.getWorkspaceIdentifier)(q),remoteAuthority:V};if(O.gotoLineMode||g.posix.basename(L).indexOf(".")!==-1)return{fileUri:q,options:{selection:x?{startLineNumber:x,startColumn:ie||1}:void 0},remoteAuthority:V}}return{workspace:(0,le.getSingleFolderWorkspaceIdentifier)(q),remoteAuthority:V}}shouldOpenNewWindow(L){const O=this.configurationService.getValue("window"),B=O?.openFoldersInNewWindow||"default",V=O?.openFilesInNewWindow||"off";let x=(L.preferNewWindow||L.forceNewWindow)&&!L.forceReuseWindow;!L.forceNewWindow&&!L.forceReuseWindow&&(B==="on"||B==="off")&&(x=B==="on");let ie=!1;return L.forceNewWindow||L.forceReuseWindow?ie=!!L.forceNewWindow&&!L.forceReuseWindow:(E.isMacintosh?L.context===1&&(ie=!0):L.context!==3&&L.context!==2&&!(L.userEnv&&L.userEnv.TERM_PROGRAM==="vscode")&&(ie=!0),!L.cli.extensionDevelopmentPath&&(V==="on"||V==="off")&&(ie=V==="on")),{openFolderInNewWindow:!!x,openFilesInNewWindow:ie}}openExtensionDevelopmentHostWindow(L,O){const B=(0,ue.findWindowOnExtensionDevelopmentPath)(this.getWindows(),L);if(B)return this.lifecycleMainService.reload(B,O.cli),B.focus(),[B];let V=O.cli["folder-uri"]||[],x=O.cli["file-uri"]||[],ie=O.cli._;if(!ie.length&&!V.length&&!x.length&&!O.cli.extensionTestsPath){const ce=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,he=ce&&(ce.workspace||ce.folderUri);he&&(m.URI.isUri(he)?he.scheme===b.Schemas.file?ie=[he.fsPath]:V=[he.toString()]:he.configPath.scheme===b.Schemas.file?ie=[(0,f.originalFSPath)(he.configPath)]:x=[he.configPath.toString()])}let q=O.remoteAuthority;for(const ce of L)if(ce.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const he=m.URI.parse(ce),ke=(0,F.getRemoteAuthority)(he);ke&&(q?(0,f.isEqualAuthority)(ke,q)||this.logService.error("more than one extension development path authority"):q=ke)}ie=ie.filter(ce=>{const he=m.URI.file(ce);return(0,ue.findWindowOnWorkspaceOrFolder)(this.getWindows(),he)?!1:(0,f.isEqualAuthority)((0,F.getRemoteAuthority)(he),q)}),V=V.filter(ce=>{const he=this.cliArgToUri(ce);return he&&!!(0,ue.findWindowOnWorkspaceOrFolder)(this.getWindows(),he)?!1:he?(0,f.isEqualAuthority)((0,F.getRemoteAuthority)(he),q):!1}),x=x.filter(ce=>{const he=this.cliArgToUri(ce);return he&&!!(0,ue.findWindowOnWorkspaceOrFolder)(this.getWindows(),he)?!1:he?(0,f.isEqualAuthority)((0,F.getRemoteAuthority)(he),q):!1}),O.cli._=ie,O.cli["folder-uri"]=V,O.cli["file-uri"]=x;const te=!ie.length&&!V.length&&!x.length,ne={context:O.context,cli:O.cli,forceNewWindow:!0,forceEmpty:te,userEnv:O.userEnv,noRecentEntry:!0,waitMarkerFileURI:O.waitMarkerFileURI,remoteAuthority:q};return this.open(ne)}openInBrowserWindow(L){const O=this.configurationService.getValue("window"),B={...this.environmentMainService.args,...L.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:L.emptyWindowBackupInfo?(0,g.join)(this.environmentMainService.backupHome,L.emptyWindowBackupInfo.backupFolder):void 0,profiles:{all:this.userDataProfilesService.profiles,current:this.userDataProfilesService.getProfile(L.workspace??"empty-window",(L.windowToUse??this.getLastActiveWindow())?.profile??this.userDataProfilesService.defaultProfile)},homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:L.remoteAuthority,workspace:L.workspace,userEnv:{...this.initialUserEnv,...L.userEnv},filesToOpenOrCreate:L.filesToOpen?.filesToOpenOrCreate,filesToDiff:L.filesToOpen?.filesToDiff,filesToMerge:L.filesToOpen?.filesToMerge,filesToWait:L.filesToOpen?.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:P.default,isInitialStartup:L.initialStartup,perfMarks:(0,d.getMarks)(),os:{release:(0,k.release)(),hostname:(0,k.hostname)()},zoomLevel:typeof O?.zoomLevel=="number"?O.zoomLevel:void 0,autoDetectHighContrast:O?.autoDetectHighContrast??!0,autoDetectColorScheme:O?.autoDetectColorScheme??!1,accessibilitySupport:v.app.accessibilitySupportEnabled,colorScheme:this.themeMainService.getColorScheme(),policiesData:this.policyService.serialize(),editSessionId:this.environmentMainService.editSessionId};let V;if(!L.forceNewWindow&&!L.forceNewTabbedWindow&&(V=L.windowToUse||this.getLastActiveWindow(),V&&V.focus()),V){const x=V.config;!B.extensionDevelopmentPath&&x&&!!x.extensionDevelopmentPath&&(B.extensionDevelopmentPath=x.extensionDevelopmentPath,B.extensionDevelopmentKind=x.extensionDevelopmentKind,B["enable-proposed-api"]=x["enable-proposed-api"],B.verbose=x.verbose,B["inspect-extensions"]=x["inspect-extensions"],B["inspect-brk-extensions"]=x["inspect-brk-extensions"],B.debugId=x.debugId,B.extensionEnvironment=x.extensionEnvironment,B["extensions-dir"]=x["extensions-dir"],B["disable-extensions"]=x["disable-extensions"])}else{const x=this.windowsStateHandler.getNewWindowState(B);(0,d.mark)("code/willCreateCodeWindow");const ie=V=this.instantiationService.createInstance(re.CodeWindow,{state:x,extensionDevelopmentPath:B.extensionDevelopmentPath,isExtensionTestHost:!!B.extensionTestsPath});(0,d.mark)("code/didCreateCodeWindow"),L.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(ie),ut.WINDOWS.push(ie),this._onDidOpenWindow.fire(ie),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,p.once)(ie.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(ie)),(0,p.once)(ie.onDidClose)(()=>this.onWindowClosed(ie)),(0,p.once)(ie.onDidDestroy)(()=>this._onDidDestroyWindow.fire(ie)),ie.onDidTriggerSystemContextMenu(({x:te,y:ne})=>this._onDidTriggerSystemContextMenu.fire({window:ie,x:te,y:ne}));const q=(0,w.assertIsDefined)(ie.win?.webContents);q.removeAllListeners("devtools-reload-page"),q.on("devtools-reload-page",()=>this.lifecycleMainService.reload(ie)),this.lifecycleMainService.registerWindow(ie)}return B.windowId=V.id,V.isReady?this.lifecycleMainService.unload(V,4).then(x=>{x||this.doOpenInBrowserWindow(V,B,L)}):this.doOpenInBrowserWindow(V,B,L),V}doOpenInBrowserWindow(L,O,B){if(!O.extensionDevelopmentPath)if((0,se.isWorkspaceIdentifier)(O.workspace))O.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:O.workspace,remoteAuthority:O.remoteAuthority});else if((0,se.isSingleFolderWorkspaceIdentifier)(O.workspace))O.backupPath=this.backupMainService.registerFolderBackupSync({folderUri:O.workspace.uri,remoteAuthority:O.remoteAuthority});else{const V=B.emptyWindowBackupInfo&&B.emptyWindowBackupInfo.backupFolder;O.backupPath=this.backupMainService.registerEmptyWindowBackupSync(V,O.remoteAuthority)}L.load(O)}onWindowClosed(L){const O=ut.WINDOWS.indexOf(L);ut.WINDOWS.splice(O,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const L=v.BrowserWindow.getFocusedWindow();if(L)return this.getWindowById(L.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(L){return this.doGetLastActiveWindow(this.getWindows().filter(O=>(0,f.isEqualAuthority)(O.remoteAuthority,L)))}doGetLastActiveWindow(L){const O=Math.max.apply(Math,L.map(B=>B.lastFocusTime));return L.find(B=>B.lastFocusTime===O)}sendToFocused(L,...O){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(L,D.CancellationToken.None,...O)}sendToAll(L,O,B){for(const V of this.getWindows())B&&B.indexOf(V.id)>=0||V.sendWhenReady(L,D.CancellationToken.None,O)}getWindows(){return ut.WINDOWS}getWindowCount(){return ut.WINDOWS.length}getWindowById(L){const O=this.getWindows().filter(B=>B.id===L);return(0,R.firstOrDefault)(O)}getWindowByWebContents(L){const O=v.BrowserWindow.fromWebContents(L);if(!!O)return this.getWindowById(O.id)}};z.WINDOWS=[],z=ve([J(2,l.ILogService),J(3,U.IStateMainService),J(4,W.IPolicyService),J(5,i.IEnvironmentMainService),J(6,A.IUserDataProfilesService),J(7,a.ILifecycleMainService),J(8,c.IBackupMainService),J(9,s.IConfigurationService),J(10,K.IWorkspacesHistoryMainService),J(11,N.IWorkspacesManagementMainService),J(12,o.IInstantiationService),J(13,r.IDialogMainService),J(14,n.IFileService),J(15,M.IProductService),J(16,T.IProtocolMainService),J(17,_.IThemeMainService)],z),e.WindowsMainService=z}),define(Z[264],ee([0,1,59,33,75,47]),function(H,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let D=class{constructor(h,p,I,C){this.workspacesManagementMainService=h,this.windowsMainService=p,this.workspacesHistoryMainService=I,this.backupMainService=C,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(h,p){const I=this.windowsMainService.getWindowById(h);if(I)return this.workspacesManagementMainService.enterWorkspace(I,this.windowsMainService.getWindows(),p)}createUntitledWorkspace(h,p,I){return this.workspacesManagementMainService.createUntitledWorkspace(p,I)}deleteUntitledWorkspace(h,p){return this.workspacesManagementMainService.deleteUntitledWorkspace(p)}getWorkspaceIdentifier(h,p){return this.workspacesManagementMainService.getWorkspaceIdentifier(p)}getRecentlyOpened(h){return this.workspacesHistoryMainService.getRecentlyOpened()}addRecentlyOpened(h,p){return this.workspacesHistoryMainService.addRecentlyOpened(p)}removeRecentlyOpened(h,p){return this.workspacesHistoryMainService.removeRecentlyOpened(p)}clearRecentlyOpened(h){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};D=ve([J(0,R.IWorkspacesManagementMainService),J(1,t.IWindowsMainService),J(2,k.IWorkspacesHistoryMainService),J(3,v.IBackupMainService)],D),e.WorkspacesMainService=D}),define(Z[265],ee([0,1,15,40,29,30,17,43,18,31,48,42,36,2,13,9,4,12,7,28,81,132,44,146,99,243,149,59,248,19,69,181,84,118,54,102,179,27,58,110,191,211,192,245,103,193,194,14,204,86,68,5,85,257,222,119,22,6,206,262,66,20,63,252,87,41,249,90,111,38,227,229,73,46,234,235,258,236,259,113,238,239,240,241,246,33,263,247,25,91,75,264,47,244,39,210,65,255,218,52,72,89,250]),function(H,e,v,t,k,R,D,y,h,p,I,C,b,g,d,E,S,f,w,m,u,c,s,r,i,n,o,a,l,P,M,T,F,U,Q,re,ue,fe,se,le,K,N,_,A,W,$,Y,z,j,L,O,B,V,x,ie,q,te,ne,ce,he,ke,Le,Me,Ae,je,me,pe,Ee,X,oe,de,ye,Ce,Te,Oe,Be,Ne,Ue,qe,G,ae,ge,Se,we,Ie,We,ze,Ke,Qe,Ye,et,at,ct,Tt,Ot,Ft,Wt,_t,Ut,Nt,Rt,Bt,zt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let Et=class extends g.Disposable{constructor(be,De,Re,Pe,_e,Ge,$e,He,Fe,Ve){super();this.mainProcessNodeIpcServer=be,this.userEnv=De,this.mainInstantiationService=Re,this.logService=Pe,this.environmentMainService=_e,this.lifecycleMainService=Ge,this.configurationService=$e,this.stateMainService=He,this.fileService=Fe,this.productService=Ve,this.configureSession(),this.registerListeners()}configureSession(){const be=Fe=>Fe?.startsWith(`${d.Schemas.vscodeWebview}://`),De=new Set(["clipboard-read","clipboard-sanitized-write"]);v.session.defaultSession.setPermissionRequestHandler((Fe,Ve,Xe,Je)=>be(Je.requestingUrl)?Xe(De.has(Ve)):Xe(!1)),v.session.defaultSession.setPermissionCheckHandler((Fe,Ve,Xe,Je)=>be(Je.requestingUrl)?De.has(Ve):!1);const Re=new Set([d.Schemas.file,d.Schemas.vscodeFileResource,d.Schemas.vscodeRemoteResource,"devtools"]),Pe=Fe=>{for(let Ve=Fe;Ve;Ve=Ve.parent)if(Ve.url.startsWith(`${d.Schemas.vscodeWebview}://`))return!0;return!1},_e=Fe=>Fe.resourceType==="xhr"||Pe(Fe.frame),Ge=Fe=>{const Ve=Fe.frame;if(!Ve||!this.windowsMainService)return!1;const Xe=v.BrowserWindow.getAllWindows();for(const Je of Xe)if(Ve.processId===Je.webContents.mainFrame.processId)return!0;return!1},$e=(Fe,Ve)=>{if(Fe.path!=="/index.html")return!0;const Xe=Ve.frame;if(!Xe||!this.windowsMainService)return!1;for(const Je of this.windowsMainService.getWindows())if(Je.win&&Xe.processId===Je.win.webContents.mainFrame.processId)return!0;return!1};v.session.defaultSession.webRequest.onBeforeRequest((Fe,Ve)=>{const Xe=w.URI.parse(Fe.url);return Xe.scheme===d.Schemas.vscodeWebview&&!$e(Xe,Fe)?(this.logService.error("Blocked vscode-webview request",Fe.url),Ve({cancel:!0})):Xe.scheme===d.Schemas.vscodeFileResource&&!Ge(Fe)?(this.logService.error("Blocked vscode-file request",Fe.url),Ve({cancel:!0})):Xe.path.endsWith(".svg")&&!Re.has(Xe.scheme)?Ve({cancel:!_e(Fe)}):Ve({cancel:!1})}),v.session.defaultSession.webRequest.onHeadersReceived((Fe,Ve)=>{const Xe=Fe.responseHeaders,Je=Xe["content-type"]||Xe["Content-Type"];if(Je&&Array.isArray(Je)){const rt=w.URI.parse(Fe.url);if(rt.path.endsWith(".svg")&&Re.has(rt.scheme))return Xe["Content-Type"]=["image/svg+xml"],Ve({cancel:!1,responseHeaders:Xe});if(!rt.path.endsWith(d.Schemas.vscodeRemoteResource)&&Je.some(ht=>ht.toLowerCase().includes("image/svg")))return Ve({cancel:!_e(Fe)})}return Ve({cancel:!1})});const He=v.session.defaultSession;typeof He.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&He.setCodeCachePath((0,E.join)(this.environmentMainService.codeCachePath,"chrome"))}registerListeners(){(0,h.setUnexpectedErrorHandler)(Re=>this.onUnexpectedError(Re)),process.on("uncaughtException",Re=>(0,h.onUnexpectedError)(Re)),process.on("unhandledRejection",Re=>(0,h.onUnexpectedError)(Re)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,c.registerContextMenuListener)(),v.app.on("accessibility-support-changed",(Re,Pe)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",Pe)}),v.app.on("activate",(Re,Pe)=>{this.logService.trace("app#activate"),Pe||this.windowsMainService?.openEmptyWindow({context:1})}),v.app.on("web-contents-created",(Re,Pe)=>{Pe.on("will-navigate",_e=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),_e.preventDefault()}),Pe.setWindowOpenHandler(({url:_e})=>(this.nativeHostMainService?.openExternal(void 0,_e),{action:"deny"}))});let be=[],De;v.app.on("open-file",(Re,Pe)=>{this.logService.trace("app#open-file: ",Pe),Re.preventDefault(),be.push(this.getWindowOpenableFromPathSync(Pe)),De!==void 0&&(clearTimeout(De),De=void 0),De=setTimeout(()=>{this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:be,gotoLineMode:!1,preferNewWindow:!0}),be=[],De=void 0},100)}),v.app.on("new-window-for-tab",()=>{this.windowsMainService?.openEmptyWindow({context:4})}),t.validatedIpcMain.handle("vscode:fetchShellEnv",Re=>{const Pe=this.windowsMainService?.getWindowByWebContents(Re.sender);let _e,Ge;return Pe?.config?(_e=Pe.config,Ge={...process.env,...Pe.config.userEnv}):(_e=this.environmentMainService.args,Ge=process.env),this.resolveShellEnvironment(_e,Ge,!1)}),t.validatedIpcMain.handle("vscode:writeNlsFile",(Re,Pe,_e)=>{const Ge=this.validateNlsPath([Pe]);if(!Ge||typeof _e!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(Ge,D.VSBuffer.fromString(_e))}),t.validatedIpcMain.handle("vscode:readNlsFile",async(Re,...Pe)=>{const _e=this.validateNlsPath(Pe);if(!_e)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(_e)).value.toString()}),t.validatedIpcMain.on("vscode:toggleDevTools",Re=>Re.sender.toggleDevTools()),t.validatedIpcMain.on("vscode:openDevTools",Re=>Re.sender.openDevTools()),t.validatedIpcMain.on("vscode:reloadWindow",Re=>Re.sender.reload())}validateNlsPath(be){let De;for(const Re of be)typeof Re=="string"&&(typeof De!="string"?De=Re:De=(0,E.join)(De,Re));if(!(typeof De!="string"||!(0,E.isAbsolute)(De)||!(0,p.isEqualOrParent)(De,this.environmentMainService.cachedLanguagesPath,!S.isLinux)))return w.URI.file(De)}onUnexpectedError(be){if(be){const De={message:`[uncaught exception in main]: ${be.message}`,stack:be.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(De))}this.logService.error(`[uncaught exception in main]: ${be}`),be.stack&&this.logService.error(be.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const be=this.productService.win32AppUserModelId;S.isWindows&&be&&v.app.setAppUserModelId(be);try{S.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!v.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&v.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Fe){this.logService.error(Fe)}const De=new r.Server;this.lifecycleMainService.onWillShutdown(Fe=>{Fe.reason===2&&De.dispose()}),this.logService.trace("Resolving machine identifier...");const Re=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${Re}`);const{sharedProcess:Pe,sharedProcessReady:_e,sharedProcessClient:Ge}=this.setupSharedProcess(Re),$e=await this.initServices(Re,Pe,_e);this.setUpHandlers($e),$e.invokeFunction(Fe=>this.initChannels(Fe,De,Ge));const He=$e.invokeFunction(Fe=>this.openFirstWindow(Fe,De));$e.invokeFunction(Fe=>this.afterWindowOpen(Fe,Pe)),this.environmentMainService.args.trace&&$e.invokeFunction(Fe=>this.stopTracingEventually(Fe,He))}setUpHandlers(be){this._register(be.createInstance(n.ProxyAuthHandler)),this._register(be.createInstance(_t.DefaultExtensionsProfileInitHandler))}async resolveMachineId(){let be=this.stateMainService.getItem(oe.machineIdKey);return(!be||S.isMacintosh&&be==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(be=await(0,u.getMachineId)(),this.stateMainService.setItem(oe.machineIdKey,be)),be}setupSharedProcess(be){const De=this._register(this.mainInstantiationService.createInstance(Ae.SharedProcess,be,this.userEnv)),Re=(async()=>{this.logService.trace("Main->SharedProcess#connect");const _e=await De.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new i.Client(_e,"main")})(),Pe=(async()=>(await De.whenReady(),Re))();return{sharedProcess:De,sharedProcessReady:Pe,sharedProcessClient:Re}}async initServices(be,De,Re){const Pe=new V.ServiceCollection;switch(process.platform){case"win32":Pe.set(Te.IUpdateService,new O.SyncDescriptor(qe.Win32UpdateService));break;case"linux":S.isLinuxSnap?Pe.set(Te.IUpdateService,new O.SyncDescriptor(Ue.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):Pe.set(Te.IUpdateService,new O.SyncDescriptor(Ne.LinuxUpdateService));break;case"darwin":Pe.set(Te.IUpdateService,new O.SyncDescriptor(Be.DarwinUpdateService));break}Pe.set(We.IWindowsMainService,new O.SyncDescriptor(ze.WindowsMainService,[be,this.userEnv])),Pe.set(Q.IDialogMainService,new O.SyncDescriptor(Q.DialogMainService)),Pe.set(q.ILaunchMainService,new O.SyncDescriptor(q.LaunchMainService)),Pe.set(U.IDiagnosticsMainService,new O.SyncDescriptor(U.DiagnosticsMainService)),Pe.set(F.IDiagnosticsService,s.ProxyChannel.toService((0,s.getDelayedChannel)(Re.then(Ge=>Ge.getChannel("diagnostics"))))),Pe.set(x.IIssueMainService,new O.SyncDescriptor(x.IssueMainService,[this.userEnv])),Pe.set(re.IEncryptionMainService,new O.SyncDescriptor(ue.EncryptionMainService,[be])),Pe.set(ie.IKeyboardLayoutMainService,new O.SyncDescriptor(ie.KeyboardLayoutMainService)),Pe.set(ke.INativeHostMainService,new O.SyncDescriptor(ke.NativeHostMainService,[De])),Pe.set(M.ICredentialsMainService,new O.SyncDescriptor(Tt.CredentialsNativeMainService)),Pe.set(we.IWebviewManagerService,new O.SyncDescriptor(Ie.WebviewMainService)),Pe.set(Ye.IWorkspacesService,new O.SyncDescriptor(at.WorkspacesMainService)),Pe.set(ct.IWorkspacesManagementMainService,new O.SyncDescriptor(ct.WorkspacesManagementMainService)),Pe.set(et.IWorkspacesHistoryMainService,new O.SyncDescriptor(et.WorkspacesHistoryMainService)),Pe.set(he.IMenubarMainService,new O.SyncDescriptor(he.MenubarMainService)),Pe.set(K.IExtensionUrlTrustService,new O.SyncDescriptor(N.ExtensionUrlTrustService)),Pe.set(_.IExtensionHostStarter,new O.SyncDescriptor(A.ExtensionHostStarter)),Pe.set(Ee.IStorageMainService,new O.SyncDescriptor(Ee.StorageMainService)),Pe.set(Ee.IApplicationStorageMainService,new O.SyncDescriptor(Ee.ApplicationStorageMainService)),S.isWindows?Pe.set(W.IExternalTerminalMainService,new O.SyncDescriptor($.WindowsExternalTerminalService)):S.isMacintosh?Pe.set(W.IExternalTerminalMainService,new O.SyncDescriptor($.MacExternalTerminalService)):S.isLinux&&Pe.set(W.IExternalTerminalMainService,new O.SyncDescriptor($.LinuxExternalTerminalService));const _e=new l.BackupMainService(this.environmentMainService,this.configurationService,this.logService);if(Pe.set(a.IBackupMainService,_e),Pe.set(G.IURLService,new O.SyncDescriptor(ge.NativeURLService)),(0,Ce.supportsTelemetry)(this.productService,this.environmentMainService)){const Ge=(0,Ce.isInternalTelemetry)(this.productService,this.configurationService),$e=(0,s.getDelayedChannel)(Re.then(Je=>Je.getChannel("telemetryAppender"))),He=new de.TelemetryAppenderClient($e),Fe=(0,X.resolveCommonProperties)(this.fileService,(0,R.release)(),(0,R.hostname)(),process.arch,this.productService.commit,this.productService.version,be,Ge,this.environmentMainService.installSourcePath),Ve=(0,Ce.getPiiPathsFromEnvironment)(this.environmentMainService),Xe={appenders:[He],commonProperties:Fe,piiPaths:Ve,sendErrorTelemetry:!0};Pe.set(oe.ITelemetryService,new O.SyncDescriptor(ye.TelemetryService,[Xe]))}else Pe.set(oe.ITelemetryService,Ce.NullTelemetryService);return Pe.set(Rt.IExtensionsProfileScannerService,new O.SyncDescriptor(Rt.ExtensionsProfileScannerService)),Pe.set(Bt.IExtensionsScannerService,new O.SyncDescriptor(zt.ExtensionsScannerService)),await _e.initialize(),this.mainInstantiationService.createChild(Pe)}initChannels(be,De,Re){const Pe=s.ProxyChannel.fromService(be.get(q.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",Pe);const _e=s.ProxyChannel.fromService(be.get(U.IDiagnosticsMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("diagnostics",_e);const Ge=new Ft.PolicyChannel(be.get(Ot.IPolicyService));De.registerChannel("policy",Ge),Re.then(tt=>tt.registerChannel("policy",Ge));const $e=this.fileService.getProvider(d.Schemas.file);(0,f.assertType)($e instanceof L.DiskFileSystemProvider);const He=new j.DiskFileSystemProviderChannel($e,this.logService,this.environmentMainService);De.registerChannel(Y.LOCAL_FILE_SYSTEM_CHANNEL_NAME,He),Re.then(tt=>tt.registerChannel(Y.LOCAL_FILE_SYSTEM_CHANNEL_NAME,He));const Fe=s.ProxyChannel.fromService(be.get(Wt.IUserDataProfilesMainService));De.registerChannel("userDataProfiles",Fe),Re.then(tt=>tt.registerChannel("userDataProfiles",Fe));const Ve=new Ut.RequestChannel(be.get(Nt.IRequestService));Re.then(tt=>tt.registerChannel("request",Ve));const Xe=new Oe.UpdateChannel(be.get(Te.IUpdateService));De.registerChannel("update",Xe);const Je=s.ProxyChannel.fromService(be.get(x.IIssueMainService));De.registerChannel("issue",Je);const rt=s.ProxyChannel.fromService(be.get(re.IEncryptionMainService));De.registerChannel("encryption",rt);const ht=s.ProxyChannel.fromService(be.get(M.ICredentialsMainService));De.registerChannel("credentials",ht);const Ct=s.ProxyChannel.fromService(be.get(je.ISignService));De.registerChannel("sign",Ct);const Ze=s.ProxyChannel.fromService(be.get(ie.IKeyboardLayoutMainService));De.registerChannel("keyboardLayout",Ze),this.nativeHostMainService=be.get(ke.INativeHostMainService);const dt=s.ProxyChannel.fromService(this.nativeHostMainService);De.registerChannel("nativeHost",dt),Re.then(tt=>tt.registerChannel("nativeHost",dt));const ft=s.ProxyChannel.fromService(be.get(Ye.IWorkspacesService));De.registerChannel("workspaces",ft);const gt=s.ProxyChannel.fromService(be.get(he.IMenubarMainService));De.registerChannel("menubar",gt);const pt=s.ProxyChannel.fromService(be.get(G.IURLService));De.registerChannel("url",pt);const wt=s.ProxyChannel.fromService(be.get(K.IExtensionUrlTrustService));De.registerChannel("extensionUrlTrust",wt);const mt=s.ProxyChannel.fromService(be.get(we.IWebviewManagerService));De.registerChannel("webview",mt);const lt=this._register(new pe.StorageDatabaseChannel(this.logService,be.get(Ee.IStorageMainService)));De.registerChannel("storage",lt),Re.then(tt=>tt.registerChannel("storage",lt));const vt=s.ProxyChannel.fromService(be.get(W.IExternalTerminalMainService));De.registerChannel("externalTerminal",vt);const xe=new ce.LogLevelChannel(be.get(ne.ILogService));De.registerChannel("logLevel",xe),Re.then(tt=>tt.registerChannel("logLevel",xe));const nt=new ce.LoggerChannel(be.get(ne.ILoggerService));De.registerChannel("logger",nt),Re.then(tt=>tt.registerChannel("logger",nt));const ot=new T.ElectronExtensionHostDebugBroadcastChannel(be.get(We.IWindowsMainService));De.registerChannel("extensionhostdebugservice",ot);const st=s.ProxyChannel.fromService(be.get(_.IExtensionHostStarter));De.registerChannel(_.ipcExtensionHostStarterChannelName,st)}openFirstWindow(be,De){const Re=this.windowsMainService=be.get(We.IWindowsMainService),Pe=be.get(G.IURLService),_e=be.get(ke.INativeHostMainService);this.lifecycleMainService.phase=2;const Ge=[],$e=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(xe=>{try{return{uri:w.URI.parse(xe),url:xe}}catch{return}}).filter(xe=>{if(!xe||this.shouldBlockURI(xe.uri))return!1;const nt=this.getWindowOpenableFromProtocolLink(xe.uri);return nt?(Ge.push(nt),!1):!0}),He=this,Fe=this.environmentMainService,Ve=this.productService,Xe=this.logService;Pe.registerHandler({async handleURL(xe,nt){if(Xe.trace("app#handleURL: ",xe.toString(!0),nt),xe.scheme===Ve.urlProtocol&&xe.path==="workspace"&&(xe=xe.with({authority:"file",path:w.URI.parse(xe.query).path,query:""})),He.shouldBlockURI(xe))return!0;let ot=!1;const st=new URLSearchParams(xe.query);st.get("windowId")==="_blank"&&(st.delete("windowId"),xe=xe.with({query:st.toString()}),ot=!0),ot||(ot=S.isMacintosh&&Re.getWindowCount()===0),st.get("editSessionId")!==null&&(Fe.editSessionId=st.get("editSessionId")??void 0,st.delete("editSessionId"),xe=xe.with({query:st.toString()}));const tt=He.getWindowOpenableFromProtocolLink(xe);if(Xe.trace("app#handleURL: windowOpenableFromProtocolLink = ",tt),tt){const[It]=Re.open({context:5,cli:{...Fe.args},urisToOpen:[tt],forceNewWindow:ot,gotoLineMode:!0});return It.focus(),!0}if(ot){const[It]=Re.open({context:5,cli:{...Fe.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,Me.getRemoteAuthority)(xe)});return await It.ready(),Pe.open(xe,nt)}return!1}});const Je=this._register(new Ke.ActiveWindowManager({onDidOpenWindow:_e.onDidOpenWindow,onDidFocusWindow:_e.onDidFocusWindow,getActiveWindowId:()=>_e.getActiveWindowId(-1)})),rt=new s.StaticRouter(xe=>Je.getActiveClientId().then(nt=>xe===nt)),ht=new ae.URLHandlerRouter(rt),Ct=De.getChannel("urlHandler",ht);Pe.registerHandler(new ae.URLHandlerChannelClient(Ct)),this._register(new Se.ElectronURLListener($e,Pe,Re,this.environmentMainService,this.productService));const Ze=this.environmentMainService.args,dt=global.macOpenFiles,ft=(0,se.isLaunchedFromCli)(process.env)?0:4,gt=Ze._.length,pt=!!Ze["folder-uri"],wt=!!Ze["file-uri"],mt=Ze["skip-add-to-recently-opened"]===!0,lt=Ze.wait&&Ze.waitMarkerFilePath?w.URI.file(Ze.waitMarkerFilePath):void 0,vt=Ze.remote||void 0;return Ge.length>0?Re.open({context:ft,cli:Ze,urisToOpen:Ge,gotoLineMode:!0,initialStartup:!0}):Ze["new-window"]&&!gt&&!pt&&!wt?Re.open({context:ft,cli:Ze,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:mt,waitMarkerFileURI:lt,initialStartup:!0,remoteAuthority:vt}):dt.length&&!gt&&!pt&&!wt?Re.open({context:1,cli:Ze,urisToOpen:dt.map(xe=>this.getWindowOpenableFromPathSync(xe)),noRecentEntry:mt,waitMarkerFileURI:lt,initialStartup:!0}):Re.open({context:ft,cli:Ze,forceNewWindow:Ze["new-window"]||!gt&&Ze["unity-launch"],diffMode:Ze.diff,mergeMode:Ze.merge,noRecentEntry:mt,waitMarkerFileURI:lt,gotoLineMode:Ze.goto,initialStartup:!0,remoteAuthority:vt})}shouldBlockURI(be){return!!(be.authority===d.Schemas.file&&S.isWindows&&v.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,b.mnemonicButtonLabel)((0,o.localize)(0,null)),(0,b.mnemonicButtonLabel)((0,o.localize)(1,null))],defaultId:0,cancelId:1,message:(0,o.localize)(2,null,(0,b.getPathLabel)(be,{os:S.OS,tildify:this.environmentMainService}),this.productService.nameShort),detail:(0,o.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(be){if(!!be.path){if(be.authority===d.Schemas.file){const De=w.URI.file(be.fsPath);return(0,Qe.hasWorkspaceFileExtension)(De)?{workspaceUri:De}:{fileUri:De}}else if(be.authority===d.Schemas.vscodeRemote){const De=be.path.indexOf(E.posix.sep,1);if(De!==-1){const Re=be.path.substring(1,De),Pe=be.path.substring(De),_e=w.URI.from({scheme:d.Schemas.vscodeRemote,authority:Re,path:Pe,query:be.query,fragment:be.fragment});return(0,Qe.hasWorkspaceFileExtension)(Pe)?{workspaceUri:_e}:/:[\d]+$/.test(Pe)?{fileUri:_e}:{folderUri:_e}}}}}getWindowOpenableFromPathSync(be){try{if((0,k.statSync)(be).isDirectory())return{folderUri:w.URI.file(be)};if((0,Qe.hasWorkspaceFileExtension)(be))return{workspaceUri:w.URI.file(be)}}catch{}return{fileUri:w.URI.file(be)}}async afterWindowOpen(be,De){this.lifecycleMainService.phase=3;let Re=!1;(0,I.once)(this.lifecycleMainService.onWillShutdown)(()=>Re=!0);const Pe=be.get(oe.ITelemetryService);this._register(De.onDidError(({type:$e,details:He})=>{let Fe;switch($e){case 1:Fe="SharedProcess: detected unresponsive window";break;case 2:Fe=`SharedProcess: crashed (detail: ${He?.reason??"<unknown>"}, code: ${He?.exitCode??"<unknown>"})`;break;case 3:Fe=`SharedProcess: failed to load (detail: ${He?.reason??"<unknown>"}, code: ${He?.exitCode??"<unknown>"})`;break}(0,h.onUnexpectedError)(new Error(Fe)),Pe.publicLog2("sharedprocesserror",{type:$e,reason:He?.reason,code:He?.exitCode,visible:De.isVisible(),shuttingdown:Re})}));const _e=this.productService.win32MutexName;if(S.isWindows&&_e)try{const $e=H.__$__nodeRequire("windows-mutex").Mutex,He=new $e(_e);(0,I.once)(this.lifecycleMainService.onWillShutdown)(()=>He.release())}catch($e){this.logService.error($e)}v.protocol.registerHttpProtocol(d.Schemas.vscodeRemoteResource,($e,He)=>{He({url:$e.url.replace(/^vscode-remote-resource:/,"http:"),method:$e.method})});const Ge=be.get(Te.IUpdateService);(Ge instanceof qe.Win32UpdateService||Ge instanceof Ne.LinuxUpdateService||Ge instanceof Be.DarwinUpdateService)&&await Ge.initialize(),this.resolveShellEnvironment(this.environmentMainService.args,process.env,!0);try{const He=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString();if(JSON.parse((0,C.stripComments)(He))["enable-crash-reporter"]===void 0){const Xe=(0,Ce.getTelemetryLevel)(this.configurationService)>=1,Je=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Xe},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,m.generateUuid)()}"`,"}"],rt=He.substring(0,He.length-2).concat(`,
`,Je.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,D.VSBuffer.fromString(rt))}}catch($e){this.logService.error($e)}}async resolveShellEnvironment(be,De,Re){try{return await(0,le.getResolvedShellEnv)(this.logService,be,De)}catch(Pe){const _e=(0,y.toErrorMessage)(Pe);Re?this.windowsMainService?.sendToFocused("vscode:showResolveShellEnvError",_e):this.logService.error(_e)}return{}}stopTracingEventually(be,De){this.logService.info("Tracing: waiting for windows to get ready...");const Re=be.get(Q.IDialogMainService);let Pe=!1;const _e=async $e=>{if(Pe)return;Pe=!0;const He=await v.contentTracing.stopRecording(`${(0,p.randomPath)(this.environmentMainService.userHome.fsPath,this.productService.applicationName)}.trace.txt`);$e?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${He}`):Re.showMessageBox({title:this.productService.nameLong,type:"info",message:(0,o.localize)(4,null),detail:(0,o.localize)(5,null,He),buttons:[(0,b.mnemonicButtonLabel)((0,o.localize)(6,null))],defaultId:0,noLink:!0},(0,f.withNullAsUndefined)(v.BrowserWindow.getFocusedWindow()))},Ge=setTimeout(()=>_e(!0),3e4);Promise.all(De.map($e=>$e.ready())).then(()=>{clearTimeout(Ge),_e(!1)})}};Et=ve([J(2,B.IInstantiationService),J(3,ne.ILogService),J(4,fe.IEnvironmentMainService),J(5,te.ILifecycleMainService),J(6,P.IConfigurationService),J(7,me.IStateMainService),J(8,z.IFileService),J(9,Le.IProductService)],Et),e.CodeApplication=Et}),define(Z[266],ee([0,1,39,8,274,2]),function(H,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;class D extends v.AbstractPolicyService{constructor(h){super();this.productName=h,this.throttler=new t.Throttler,this.watcher=this._register(new R.MutableDisposable)}async initializePolicies(h){await this.throttler.queue(()=>new Promise((p,I)=>{try{this.watcher.value=(0,k.createWatcher)(this.productName,h,C=>{for(const b in C){const g=C[b];g===void 0?this.policies.delete(b):this.policies.set(b,g)}this._onDidChange.fire(Object.keys(C)),p()})}catch(C){I(C)}}))}}e.NativePolicyService=D}),define(Z[267],ee([0,1,220,8,17,18,2,12,19,37,110,6,219,275]),function(H,e,v,t,k,R,D,y,h,p,I,C,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let d=class extends D.Disposable{constructor(S,f,w){super();this.environmentService=f,this.logService=w,this.configure(S.getValue()),this._register(S.onDidChangeConfiguration(()=>this.configure(S.getValue()),this))}configure(S){this.proxyUrl=S.http&&S.http.proxy,this.strictSSL=!!(S.http&&S.http.proxyStrictSSL),this.authorization=S.http&&S.http.proxyAuthorization}async request(S,f){this.logService.trace("RequestService#request (node) - begin",S.url);const{proxyUrl:w,strictSSL:m}=this;let u;try{u=await(0,I.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(r){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request (node) resolving shell environment failed",r))}const c={...process.env,...u},s=S.agent?S.agent:await(0,b.getProxyAgent)(S.url||"",c,{proxyUrl:w,strictSSL:m});S.agent=s,S.strictSSL=m,this.authorization&&(S.headers={...S.headers||{},"Proxy-Authorization":this.authorization});try{const r=await this._request(S,f);return this.logService.trace("RequestService#request (node) - success",S.url),r}catch(r){throw this.logService.trace("RequestService#request (node) - error",S.url,r),r}}async getNodeRequest(S){return((0,v.parse)(S.url).protocol==="https:"?await new Promise((m,u)=>{H(["https"],m,u)}):await new Promise((m,u)=>{H(["http"],m,u)})).request}_request(S,f){return t.Promises.withAsyncBody(async(w,m)=>{const u=(0,v.parse)(S.url),c=S.getRawRequest?S.getRawRequest(S):await this.getNodeRequest(S),s={hostname:u.hostname,port:u.port?parseInt(u.port):u.protocol==="https:"?443:80,protocol:u.protocol,path:u.path,method:S.type||"GET",headers:S.headers,agent:S.agent,rejectUnauthorized:(0,y.isBoolean)(S.strictSSL)?S.strictSSL:!0};S.user&&S.password&&(s.auth=S.user+":"+S.password);const r=c(s,i=>{const n=(0,y.isNumber)(S.followRedirects)?S.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)this._request({...S,url:i.headers.location,followRedirects:n-1},f).then(w,m);else{let o=i;i.headers["content-encoding"]==="gzip"&&(o=i.pipe((0,g.createGunzip)())),w({res:i,stream:(0,k.streamToBufferReadableStream)(o)})}});r.on("error",m),S.timeout&&r.setTimeout(S.timeout),S.data&&typeof S.data=="string"&&r.write(S.data),r.end(),f.onCancellationRequested(()=>{r.abort(),m(new R.CancellationError)})})}async resolveProxy(S){}};d=ve([J(0,h.IConfigurationService),J(1,p.INativeEnvironmentService),J(2,C.ILogService)],d),e.RequestService=d}),define(Z[268],ee([0,1,15,267]),function(H,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function k(D){return v.net.request}class R extends t.RequestService{request(y,h){return super.request({...y||{},getRawRequest:k},h)}}e.RequestMainService=R}),define(Z[276],ee([0,1,15,29,7,24,8,43,18,31,48,36,13,9,71,4,35,26,23,44,83,265,10,19,214,226,27,58,184,14,202,86,68,199,85,22,105,6,207,106,60,20,61,251,112,232,52,268,87,221,41,225,73,64,65,39,266,209,2,53,237,34,233]),function(H,e,v,t,k,R,D,y,h,p,I,C,b,g,d,E,S,f,w,m,u,c,s,r,i,n,o,a,l,P,M,T,F,U,Q,re,ue,fe,se,le,K,N,_,A,W,$,Y,z,j,L,O,B,V,x,ie,q,te,ne,ce,he,ke,Le){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Me{main(){try{this.startup()}catch(me){console.error(me.message),v.app.exit(1)}}async startup(){(0,h.setUnexpectedErrorHandler)(Te=>console.error(Te));const[me,pe,Ee,X,oe,de,ye,Ce]=this.createServices();try{try{await this.initServices(Ee,Ce,X,oe)}catch(Te){throw this.handleStartupDataDirError(Ee,ye.nameLong,Te),Te}await me.invokeFunction(async Te=>{const Oe=Te.get(fe.ILogService),Be=Te.get(re.ILifecycleMainService),Ne=Te.get(P.IFileService),Ue=await this.claimInstance(Oe,Ee,Be,me,ye,!0);return w.Promises.writeFile(Ee.mainLockfile,String(process.pid)).catch(qe=>{Oe.warn(`Error writing main lockfile: ${qe.stack}`)}),de.logger=new le.SpdLogLogger("main",(0,g.join)(Ee.logsPath,"main.log"),!0,!1,de.getLevel()),(0,I.once)(Be.onWillShutdown)(qe=>{Ne.dispose(),X.dispose(),qe.join(w.Promises.unlink(Ee.mainLockfile).catch(()=>{}))}),me.createInstance(c.CodeApplication,Ue,pe).startup()})}catch(Te){me.invokeFunction(this.quit,Te)}}createServices(){const me=new Q.ServiceCollection,pe=new ce.DisposableStore;process.once("exit",()=>pe.dispose());const Ee={_serviceBrand:void 0,...K.default};me.set(N.IProductService,Ee);const X=new o.EnvironmentMainService(this.resolveArgs(),Ee),oe=this.patchEnvironment(X);me.set(o.IEnvironmentMainService,X);const de=new ue.BufferLogService,ye=pe.add(new fe.MultiplexLogService([new fe.ConsoleMainLogger((0,fe.getLogLevel)(X)),de]));me.set(fe.ILogService,ye);const Ce=new M.FileService(ye);me.set(P.IFileService,Ce);const Te=new T.DiskFileSystemProvider(ye);Ce.registerProvider(b.Schemas.file,Te);const Oe=new ke.UriIdentityService(Ce);me.set(he.IUriIdentityService,Oe),me.set(fe.ILoggerService,new se.LoggerService(ye,Ce));const Be=new B.StateMainService(X,ye,Ce);me.set(O.IStateMainService,Be);const Ne=new ie.UserDataProfilesMainService(Be,Oe,X,Ce,ye);me.set(ie.IUserDataProfilesMainService,Ne);const Ue=E.isWindows&&Ee.win32RegValueName?pe.add(new te.NativePolicyService(Ee.win32RegValueName)):X.policyFile?pe.add(new ne.FilePolicyService(X.policyFile,Ce,ye)):new q.NullPolicyService;me.set(q.IPolicyService,Ue);const qe=new i.ConfigurationService(Ne.defaultProfile.settingsResource,Ce,Ue,ye);return me.set(r.IConfigurationService,qe),me.set(re.ILifecycleMainService,new F.SyncDescriptor(re.LifecycleMainService)),me.set(Y.IRequestService,new F.SyncDescriptor(z.RequestMainService)),me.set(x.IThemeMainService,new F.SyncDescriptor(x.ThemeMainService)),me.set(j.ISignService,new F.SyncDescriptor(L.SignService)),me.set(W.ITunnelService,new F.SyncDescriptor($.TunnelService)),me.set(_.IProtocolMainService,new F.SyncDescriptor(A.ProtocolMainService)),[new U.InstantiationService(me,!0),oe,X,qe,Be,de,Ee,Ne]}patchEnvironment(me){const pe={VSCODE_IPC_HOOK:me.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(Ee=>{const X=process.env[Ee];typeof X=="string"&&(pe[Ee]=X)}),Object.assign(process.env,pe),pe}async initServices(me,pe,Ee,X){await D.Promises.settled([Promise.all([me.extensionsPath,me.codeCachePath,me.logsPath,pe.defaultProfile.globalStorageHome.fsPath,me.workspaceStorageHome.fsPath,me.localHistoryHome.fsPath,me.backupHome].map(oe=>oe?w.Promises.mkdir(oe,{recursive:!0}):void 0)),X.init(),Ee.initialize()]),pe.setEnablement(!!Ee.getValue(Le.PROFILES_ENABLEMENT_CONFIG))}async claimInstance(me,pe,Ee,X,oe,de){let ye;try{(0,d.mark)("code/willStartMainServer"),ye=await(0,u.serve)(pe.mainIPCHandle),(0,d.mark)("code/didStartMainServer"),(0,I.once)(Ee.onWillShutdown)(()=>ye.dispose())}catch(Ce){if(Ce.code!=="EADDRINUSE")throw this.handleStartupDataDirError(pe,oe.nameLong,Ce),Ce;let Te;try{Te=await(0,u.connect)(pe.mainIPCHandle,"main")}catch(Ue){if(!de||E.isWindows||Ue.code!=="ECONNREFUSED")throw Ue.code==="EPERM"&&this.showStartupWarningDialog((0,s.localize)(0,null,oe.nameShort),(0,s.localize)(1,null),oe.nameLong),Ue;try{(0,t.unlinkSync)(pe.mainIPCHandle)}catch(qe){throw me.warn("Could not delete obsolete instance handle",qe),qe}return this.claimInstance(me,pe,Ee,X,oe,!1)}if(pe.extensionTestsLocationURI&&!pe.debugExtensionHost.break){const Ue="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw me.error(Ue),Te.dispose(),new Error(Ue)}let Oe;!pe.args.wait&&!pe.args.status&&(Oe=setTimeout(()=>{this.showStartupWarningDialog((0,s.localize)(2,null,oe.nameShort),(0,s.localize)(3,null),oe.nameLong)},1e4));const Be=m.ProxyChannel.toService(Te.getChannel("launch"),{disableMarshalling:!0}),Ne=m.ProxyChannel.toService(Te.getChannel("diagnostics"),{disableMarshalling:!0});if(pe.args.status)return X.invokeFunction(async()=>{const Ue=new n.DiagnosticsService(V.NullTelemetryService,oe),qe=await Be.getMainProcessInfo(),G=await Ne.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),ae=await Ue.getDiagnostics(qe,G);throw console.log(ae),new h.ExpectedError});throw E.isWindows&&await this.windowsAllowSetForegroundWindow(Be,me),me.trace("Sending env to running instance..."),await Be.start(pe.args,process.env),Te.dispose(),Oe&&clearTimeout(Oe),new h.ExpectedError("Sent env to running instance. Terminating...")}if(pe.args.status)throw me.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new h.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),ye}handleStartupDataDirError(me,pe,Ee){if(Ee.code==="EACCES"||Ee.code==="EPERM"){const X=(0,R.coalesce)([me.userDataPath,me.extensionsPath,u.XDG_RUNTIME_DIR]).map(oe=>(0,C.getPathLabel)(k.URI.file(oe),{os:E.OS,tildify:me}));this.showStartupWarningDialog((0,s.localize)(4,null),(0,s.localize)(5,null,(0,y.toErrorMessage)(Ee),X.join(`
`)),pe)}}showStartupWarningDialog(me,pe,Ee){v.dialog.showMessageBoxSync({title:Ee,type:"warning",buttons:[(0,C.mnemonicButtonLabel)((0,s.localize)(6,null))],message:me,detail:pe,defaultId:0,noLink:!0})}async windowsAllowSetForegroundWindow(me,pe){if(E.isWindows){const Ee=await me.getMainProcessId();pe.trace("Sending some foreground love to the running instance:",Ee);try{(await new Promise((X,oe)=>{H(["windows-foreground-love"],X,oe)})).allowSetForegroundWindow(Ee)}catch(X){pe.error(X)}}}quit(me,pe){const Ee=me.get(fe.ILogService),X=me.get(re.ILifecycleMainService);let oe=0;pe&&(pe.isExpected?pe.message&&Ee.trace(pe.message):(oe=1,pe.stack?Ee.error(pe.stack):Ee.error(`Startup error: ${pe.toString()}`))),X.kill(oe)}resolveArgs(){const me=this.validatePaths((0,a.parseMainProcessArgv)(process.argv));if(me.wait&&!me.waitMarkerFilePath){const pe=(0,l.createWaitMarkerFile)(me.verbose);pe&&((0,a.addArg)(process.argv,"--waitMarkerFilePath",pe),me.waitMarkerFilePath=pe)}return me}validatePaths(me){if(me["open-url"]&&(me._urls=me._,me._=[]),!me.remote){const pe=this.doValidatePaths(me._,me.goto);me._=pe}return me}doValidatePaths(me,pe){const Ee=(0,S.cwd)(),X=me.map(ye=>{let Ce=String(ye),Te;pe&&(Te=(0,p.parseLineAndColumnAware)(Ce),Ce=Te.path),Ce&&(Ce=this.preparePath(Ee,Ce));const Oe=(0,p.sanitizeFilePath)(Ce,Ee),Be=(0,g.basename)(Oe);return Be&&!(0,p.isValidBasename)(Be)?null:pe&&Te?(Te.path=Oe,this.toPath(Te)):Oe}),oe=E.isWindows||E.isMacintosh,de=(0,R.distinct)(X,ye=>ye&&oe?ye.toLowerCase():ye||"");return(0,R.coalesce)(de)}preparePath(me,pe){return E.isWindows&&(pe=(0,f.rtrim)(pe,'"')),pe=(0,f.trim)((0,f.trim)(pe," "),"	"),E.isWindows&&(pe=(0,g.resolve)(me,pe),pe=(0,f.rtrim)(pe,".")),pe}toPath(me){const pe=[me.path];return typeof me.line=="number"&&pe.push(String(me.line)),typeof me.column=="number"&&pe.push(String(me.column)),pe.join(":")}}new Me().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/7fee053fdfef9bd86da74dc3c223b95019c5d297/core/vs/code/electron-main/main.js.map
