/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var me=["exports","require","vs/base/common/lifecycle","vs/base/common/event","vs/base/browser/dom","vs/base/common/platform","vs/base/common/types","vs/css!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/async","vs/nls!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/strings","vs/base/common/codicons","vs/nls","vs/base/common/errors","vs/base/common/arrays","vs/base/browser/browser","vs/base/common/uri","vs/base/browser/ui/widget","vs/base/browser/event","vs/base/browser/keyboardEvent","vs/base/browser/mouseEvent","vs/base/common/path","vs/base/browser/touch","vs/base/browser/ui/tree/tree","vs/base/common/color","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/objects","vs/base/common/cancellation","vs/base/parts/sandbox/electron-sandbox/globals","vs/platform/instantiation/common/instantiation","vs/base/common/buffer","vs/base/common/actions","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/network","vs/base/common/resources","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/browser/fastDomNode","vs/base/browser/ui/scrollbar/scrollbarState","vs/base/common/functional","vs/base/common/keyCodes","vs/base/common/numbers","vs/base/common/range","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/base/common/scrollable","vs/base/common/map","vs/base/common/marshalling","vs/base/browser/dnd","vs/base/browser/formattedTextRenderer","vs/base/browser/globalPointerMoveMonitor","vs/base/browser/ui/aria/aria","vs/base/browser/ui/tree/indexTreeModel","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/ui/list/listView","vs/base/browser/ui/list/listWidget","vs/base/common/htmlContent","vs/base/browser/ui/actionbar/actionViewItems","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/toggle/toggle","vs/platform/instantiation/common/descriptors","vs/platform/theme/common/themeService","vs/base/browser/iframe","vs/base/browser/ui/list/list","vs/base/browser/ui/list/splice","vs/base/common/assert","vs/base/common/collections","vs/base/common/diff/diffChange","vs/base/common/idGenerator","vs/base/common/keybindings","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/marked/marked","vs/base/common/navigator","vs/base/common/history","vs/base/browser/ui/list/rangeMap","vs/base/common/stream","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/css!vs/base/browser/ui/aria/aria","vs/css!vs/base/browser/ui/codicons/codicon/codicon","vs/css!vs/base/browser/ui/codicons/codicon/codicon-modifiers","vs/base/browser/ui/codicons/codiconStyles","vs/css!vs/base/browser/ui/findinput/findInput","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/css!vs/base/browser/ui/selectBox/selectBox","vs/css!vs/base/browser/ui/selectBox/selectBoxCustom","vs/css!vs/base/browser/ui/toggle/toggle","vs/css!vs/base/browser/ui/tree/media/tree","vs/css!vs/code/electron-sandbox/processExplorer/media/processExplorer","vs/nls!vs/base/browser/ui/actionbar/actionViewItems","vs/nls!vs/base/browser/ui/findinput/findInput","vs/nls!vs/base/browser/ui/findinput/findInputToggles","vs/nls!vs/base/browser/ui/iconLabel/iconLabelHover","vs/nls!vs/base/browser/ui/inputbox/inputBox","vs/nls!vs/base/browser/ui/selectBox/selectBoxCustom","vs/nls!vs/base/browser/ui/tree/abstractTree","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/platform","vs/base/common/process","vs/base/common/mime","vs/base/common/stopwatch","vs/base/browser/canIUse","vs/base/common/cache","vs/base/common/extpath","vs/base/common/hash","vs/base/common/diff/diff","vs/base/browser/dompurify/dompurify","vs/base/browser/ui/iconLabel/iconLabels","vs/base/browser/ui/list/rowCache","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/base/browser/ui/selectBox/selectBoxNative","vs/base/browser/ui/tree/objectTreeModel","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/base/browser/markdownRenderer","vs/base/browser/ui/iconLabel/iconLabelHover","vs/base/browser/ui/selectBox/selectBoxCustom","vs/base/browser/ui/selectBox/selectBox","vs/base/browser/ui/inputbox/inputBox","vs/base/browser/ui/findinput/findInputToggles","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/tree/abstractTree","vs/base/browser/ui/tree/dataTree","vs/base/parts/contextmenu/electron-sandbox/contextmenu","vs/base/parts/ipc/electron-sandbox/ipc.electron","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/theme/common/iconRegistry","vs/platform/instantiation/common/extensions","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/files","vs/platform/ipc/electron-sandbox/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/platform/native/electron-sandbox/nativeHostService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/platform/theme/browser/iconsStyleSheet","vs/platform/window/common/window","vs/platform/window/electron-sandbox/window","vs/code/electron-sandbox/processExplorer/processExplorerMain"],pe=function(J){for(var t=[],y=0,i=J.length;y<i;y++)t[y]=me[J[y]];return t};/*! @license DOMPurify 2.3.1 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/2.3.1/LICENSE */function Vt(J){if(Array.isArray(J)){for(var t=0,y=Array(J.length);t<J.length;t++)y[t]=J[t];return y}else return Array.from(J)}var $t=Object.hasOwnProperty,It=Object.setPrototypeOf,Kt=Object.isFrozen,qt=Object.getPrototypeOf,xt=Object.getOwnPropertyDescriptor,it=Object.freeze,ot=Object.seal,jt=Object.create,Lt=typeof Reflect!="undefined"&&Reflect,wt=Lt.apply,Et=Lt.construct;wt||(wt=function(t,y,i){return t.apply(y,i)}),it||(it=function(t){return t}),ot||(ot=function(t){return t}),Et||(Et=function(t,y){return new(Function.prototype.bind.apply(t,[null].concat(Vt(y))))});var Gt=nt(Array.prototype.forEach),Nt=nt(Array.prototype.pop),pt=nt(Array.prototype.push),ut=nt(String.prototype.toLowerCase),kt=nt(String.prototype.match),lt=nt(String.prototype.replace),Yt=nt(String.prototype.indexOf),Xt=nt(String.prototype.trim),at=nt(RegExp.prototype.test),Pt=Zt(TypeError);function nt(J){return function(t){for(var y=arguments.length,i=Array(y>1?y-1:0),B=1;B<y;B++)i[B-1]=arguments[B];return wt(J,t,i)}}function Zt(J){return function(){for(var t=arguments.length,y=Array(t),i=0;i<t;i++)y[i]=arguments[i];return Et(J,y)}}function Be(J,t){It&&It(J,null);for(var y=t.length;y--;){var i=t[y];if(typeof i=="string"){var B=ut(i);B!==i&&(Kt(t)||(t[y]=B),i=B)}J[i]=!0}return J}function ct(J){var t=jt(null),y=void 0;for(y in J)wt($t,J,[y])&&(t[y]=J[y]);return t}function vt(J,t){for(;J!==null;){var y=xt(J,t);if(y){if(y.get)return nt(y.get);if(typeof y.value=="function")return nt(y.value)}J=qt(J)}function i(B){return console.warn("fallback value for",B),null}return i}var Rt=it(["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dialog","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","picture","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr"]),_t=it(["svg","a","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","style","switch","symbol","text","textpath","title","tref","tspan","view","vkern"]),Ct=it(["feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feDistantLight","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feMerge","feMergeNode","feMorphology","feOffset","fePointLight","feSpecularLighting","feSpotLight","feTile","feTurbulence"]),Qt=it(["animate","color-profile","cursor","discard","fedropshadow","feimage","font-face","font-face-format","font-face-name","font-face-src","font-face-uri","foreignobject","hatch","hatchpath","mesh","meshgradient","meshpatch","meshrow","missing-glyph","script","set","solidcolor","unknown","use"]),St=it(["math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmultiscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mspace","msqrt","mstyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover"]),Jt=it(["maction","maligngroup","malignmark","mlongdiv","mscarries","mscarry","msgroup","mstack","msline","msrow","semantics","annotation","annotation-xml","mprescripts","none"]),Mt=it(["#text"]),Ot=it(["accept","action","align","alt","autocapitalize","autocomplete","autopictureinpicture","autoplay","background","bgcolor","border","capture","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","controls","controlslist","coords","crossorigin","datetime","decoding","default","dir","disabled","disablepictureinpicture","disableremoteplayback","download","draggable","enctype","enterkeyhint","face","for","headers","height","hidden","high","href","hreflang","id","inputmode","integrity","ismap","kind","label","lang","list","loading","loop","low","max","maxlength","media","method","min","minlength","multiple","muted","name","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","playsinline","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","role","rows","rowspan","spellcheck","scope","selected","shape","size","sizes","span","srclang","start","src","srcset","step","style","summary","tabindex","title","translate","type","usemap","valign","value","width","xmlns","slot"]),At=it(["accent-height","accumulate","additive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","class","clip","clippathunits","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","filterunits","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","height","href","id","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lang","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","media","method","mode","min","name","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","preserveaspectratio","primitiveunits","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","startoffset","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","style","surfacescale","systemlanguage","tabindex","targetx","targety","transform","text-anchor","text-decoration","text-rendering","textlength","type","u1","u2","unicode","values","viewbox","visibility","version","vert-adv-y","vert-origin-x","vert-origin-y","width","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","xmlns","y","y1","y2","z","zoomandpan"]),Bt=it(["accent","accentunder","align","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","dir","display","displaystyle","encoding","fence","frame","height","href","id","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","width","xmlns"]),Dt=it(["xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"]),ei=ot(/\{\{[\s\S]*|[\s\S]*\}\}/gm),ti=ot(/<%[\s\S]*|[\s\S]*%>/gm),ii=ot(/^data-[\-\w.\u00B7-\uFFFF]/),ni=ot(/^aria-[\-\w]+$/),si=ot(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i),ri=ot(/^(?:\w+script|data):/i),oi=ot(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g),bt=typeof Symbol=="function"&&typeof Symbol.iterator=="symbol"?function(J){return typeof J}:function(J){return J&&typeof Symbol=="function"&&J.constructor===Symbol&&J!==Symbol.prototype?"symbol":typeof J};function rt(J){if(Array.isArray(J)){for(var t=0,y=Array(J.length);t<J.length;t++)y[t]=J[t];return y}else return Array.from(J)}var ai=function(){return typeof window=="undefined"?null:window},li=function(t,y){if((typeof t=="undefined"?"undefined":bt(t))!=="object"||typeof t.createPolicy!="function")return null;var i=null,B="data-tt-policy-suffix";y.currentScript&&y.currentScript.hasAttribute(B)&&(i=y.currentScript.getAttribute(B));var M="dompurify"+(i?"#"+i:"");try{return t.createPolicy(M,{createHTML:function(w){return w}})}catch{return console.warn("TrustedTypes policy "+M+" could not be created."),null}};function Ht(){var J=arguments.length>0&&arguments[0]!==void 0?arguments[0]:ai(),t=function(le){return Ht(le)};if(t.version="2.3.1",t.removed=[],!J||!J.document||J.document.nodeType!==9)return t.isSupported=!1,t;var y=J.document,i=J.document,B=J.DocumentFragment,M=J.HTMLTemplateElement,E=J.Node,w=J.Element,m=J.NodeFilter,f=J.NamedNodeMap,g=f===void 0?J.NamedNodeMap||J.MozNamedAttrMap:f,F=J.Text,l=J.Comment,s=J.DOMParser,e=J.trustedTypes,p=w.prototype,D=vt(p,"cloneNode"),v=vt(p,"nextSibling"),_=vt(p,"childNodes"),a=vt(p,"parentNode");if(typeof M=="function"){var o=i.createElement("template");o.content&&o.content.ownerDocument&&(i=o.content.ownerDocument)}var b=li(e,y),S=b&&Q?b.createHTML(""):"",A=i,C=A.implementation,r=A.createNodeIterator,n=A.createDocumentFragment,c=A.getElementsByTagName,u=y.importNode,h={};try{h=ct(i).documentMode?i.documentMode:{}}catch{}var O={};t.isSupported=typeof a=="function"&&C&&typeof C.createHTMLDocument!="undefined"&&h!==9;var V=ei,ue=ti,ie=ii,ge=ni,ae=ri,we=oi,ce=si,re=null,Ce=Be({},[].concat(rt(Rt),rt(_t),rt(Ct),rt(St),rt(Mt))),Ie=null,ne=Be({},[].concat(rt(Ot),rt(At),rt(Bt),rt(Dt))),Z=null,X=null,se=!0,te=!0,I=!1,$=!1,j=!1,H=!1,d=!1,L=!1,U=!1,K=!0,Q=!1,N=!0,R=!0,z=!1,T={},W=null,k=Be({},["annotation-xml","audio","colgroup","desc","foreignobject","head","iframe","math","mi","mn","mo","ms","mtext","noembed","noframes","noscript","plaintext","script","style","svg","template","thead","title","video","xmp"]),P=null,x=Be({},["audio","video","img","source","image","track"]),ee=null,he=Be({},["alt","class","for","id","label","name","pattern","placeholder","role","summary","title","value","style","xmlns"]),de="http://www.w3.org/1998/Math/MathML",De="http://www.w3.org/2000/svg",ye="http://www.w3.org/1999/xhtml",ke=ye,Fe=!1,ve=null,Pe=i.createElement("form"),Re=function(le){ve&&ve===le||((!le||(typeof le=="undefined"?"undefined":bt(le))!=="object")&&(le={}),le=ct(le),re="ALLOWED_TAGS"in le?Be({},le.ALLOWED_TAGS):Ce,Ie="ALLOWED_ATTR"in le?Be({},le.ALLOWED_ATTR):ne,ee="ADD_URI_SAFE_ATTR"in le?Be(ct(he),le.ADD_URI_SAFE_ATTR):he,P="ADD_DATA_URI_TAGS"in le?Be(ct(x),le.ADD_DATA_URI_TAGS):x,W="FORBID_CONTENTS"in le?Be({},le.FORBID_CONTENTS):k,Z="FORBID_TAGS"in le?Be({},le.FORBID_TAGS):{},X="FORBID_ATTR"in le?Be({},le.FORBID_ATTR):{},T="USE_PROFILES"in le?le.USE_PROFILES:!1,se=le.ALLOW_ARIA_ATTR!==!1,te=le.ALLOW_DATA_ATTR!==!1,I=le.ALLOW_UNKNOWN_PROTOCOLS||!1,$=le.SAFE_FOR_TEMPLATES||!1,j=le.WHOLE_DOCUMENT||!1,L=le.RETURN_DOM||!1,U=le.RETURN_DOM_FRAGMENT||!1,K=le.RETURN_DOM_IMPORT!==!1,Q=le.RETURN_TRUSTED_TYPE||!1,d=le.FORCE_BODY||!1,N=le.SANITIZE_DOM!==!1,R=le.KEEP_CONTENT!==!1,z=le.IN_PLACE||!1,ce=le.ALLOWED_URI_REGEXP||ce,ke=le.NAMESPACE||ye,$&&(te=!1),U&&(L=!0),T&&(re=Be({},[].concat(rt(Mt))),Ie=[],T.html===!0&&(Be(re,Rt),Be(Ie,Ot)),T.svg===!0&&(Be(re,_t),Be(Ie,At),Be(Ie,Dt)),T.svgFilters===!0&&(Be(re,Ct),Be(Ie,At),Be(Ie,Dt)),T.mathMl===!0&&(Be(re,St),Be(Ie,Bt),Be(Ie,Dt))),le.ADD_TAGS&&(re===Ce&&(re=ct(re)),Be(re,le.ADD_TAGS)),le.ADD_ATTR&&(Ie===ne&&(Ie=ct(Ie)),Be(Ie,le.ADD_ATTR)),le.ADD_URI_SAFE_ATTR&&Be(ee,le.ADD_URI_SAFE_ATTR),le.FORBID_CONTENTS&&(W===k&&(W=ct(W)),Be(W,le.FORBID_CONTENTS)),R&&(re["#text"]=!0),j&&Be(re,["html","head","body"]),re.table&&(Be(re,["tbody"]),delete Z.tbody),it&&it(le),ve=le)},Ge=Be({},["mi","mo","mn","ms","mtext"]),He=Be({},["foreignobject","desc","title","annotation-xml"]),ze=Be({},_t);Be(ze,Ct),Be(ze,Qt);var Xe=Be({},St);Be(Xe,Jt);var je=function(le){var _e=a(le);(!_e||!_e.tagName)&&(_e={namespaceURI:ye,tagName:"template"});var Ne=ut(le.tagName),$e=ut(_e.tagName);if(le.namespaceURI===De)return _e.namespaceURI===ye?Ne==="svg":_e.namespaceURI===de?Ne==="svg"&&($e==="annotation-xml"||Ge[$e]):Boolean(ze[Ne]);if(le.namespaceURI===de)return _e.namespaceURI===ye?Ne==="math":_e.namespaceURI===De?Ne==="math"&&He[$e]:Boolean(Xe[Ne]);if(le.namespaceURI===ye){if(_e.namespaceURI===De&&!He[$e]||_e.namespaceURI===de&&!Ge[$e])return!1;var Ze=Be({},["title","style","font","a","script"]);return!Xe[Ne]&&(Ze[Ne]||!ze[Ne])}return!1},Oe=function(le){pt(t.removed,{element:le});try{le.parentNode.removeChild(le)}catch{try{le.outerHTML=S}catch{le.remove()}}},q=function(le,_e){try{pt(t.removed,{attribute:_e.getAttributeNode(le),from:_e})}catch{pt(t.removed,{attribute:null,from:_e})}if(_e.removeAttribute(le),le==="is"&&!Ie[le])if(L||U)try{Oe(_e)}catch{}else try{_e.setAttribute(le,"")}catch{}},oe=function(le){var _e=void 0,Ne=void 0;if(d)le="<remove></remove>"+le;else{var $e=kt(le,/^[\r\n\t ]+/);Ne=$e&&$e[0]}var Ze=b?b.createHTML(le):le;if(ke===ye)try{_e=new s().parseFromString(Ze,"text/html")}catch{}if(!_e||!_e.documentElement){_e=C.createDocument(ke,"template",null);try{_e.documentElement.innerHTML=Fe?"":Ze}catch{}}var Qe=_e.body||_e.documentElement;return le&&Ne&&Qe.insertBefore(i.createTextNode(Ne),Qe.childNodes[0]||null),ke===ye?c.call(_e,j?"html":"body")[0]:j?_e.documentElement:Qe},be=function(le){return r.call(le.ownerDocument||le,le,m.SHOW_ELEMENT|m.SHOW_COMMENT|m.SHOW_TEXT,null,!1)},Ee=function(le){return le instanceof F||le instanceof l?!1:typeof le.nodeName!="string"||typeof le.textContent!="string"||typeof le.removeChild!="function"||!(le.attributes instanceof g)||typeof le.removeAttribute!="function"||typeof le.setAttribute!="function"||typeof le.namespaceURI!="string"||typeof le.insertBefore!="function"},Ae=function(le){return(typeof E=="undefined"?"undefined":bt(E))==="object"?le instanceof E:le&&(typeof le=="undefined"?"undefined":bt(le))==="object"&&typeof le.nodeType=="number"&&typeof le.nodeName=="string"},Me=function(le,_e,Ne){!O[le]||Gt(O[le],function($e){$e.call(t,_e,Ne,ve)})},Ve=function(le){var _e=void 0;if(Me("beforeSanitizeElements",le,null),Ee(le)||kt(le.nodeName,/[\u0080-\uFFFF]/))return Oe(le),!0;var Ne=ut(le.nodeName);if(Me("uponSanitizeElement",le,{tagName:Ne,allowedTags:re}),!Ae(le.firstElementChild)&&(!Ae(le.content)||!Ae(le.content.firstElementChild))&&at(/<[/\w]/g,le.innerHTML)&&at(/<[/\w]/g,le.textContent)||Ne==="select"&&at(/<template/i,le.innerHTML))return Oe(le),!0;if(!re[Ne]||Z[Ne]){if(R&&!W[Ne]){var $e=a(le)||le.parentNode,Ze=_(le)||le.childNodes;if(Ze&&$e)for(var Qe=Ze.length,Je=Qe-1;Je>=0;--Je)$e.insertBefore(D(Ze[Je],!0),v(le))}return Oe(le),!0}return le instanceof w&&!je(le)||(Ne==="noscript"||Ne==="noembed")&&at(/<\/no(script|embed)/i,le.innerHTML)?(Oe(le),!0):($&&le.nodeType===3&&(_e=le.textContent,_e=lt(_e,V," "),_e=lt(_e,ue," "),le.textContent!==_e&&(pt(t.removed,{element:le.cloneNode()}),le.textContent=_e)),Me("afterSanitizeElements",le,null),!1)},tt=function(le,_e,Ne){if(N&&(_e==="id"||_e==="name")&&(Ne in i||Ne in Pe))return!1;if(!(te&&!X[_e]&&at(ie,_e))){if(!(se&&at(ge,_e))){if(!Ie[_e]||X[_e])return!1;if(!ee[_e]){if(!at(ce,lt(Ne,we,""))){if(!((_e==="src"||_e==="xlink:href"||_e==="href")&&le!=="script"&&Yt(Ne,"data:")===0&&P[le])){if(!(I&&!at(ae,lt(Ne,we,"")))){if(Ne)return!1}}}}}}return!0},Ye=function(le){var _e=void 0,Ne=void 0,$e=void 0,Ze=void 0;Me("beforeSanitizeAttributes",le,null);var Qe=le.attributes;if(!!Qe){var Je={attrName:"",attrValue:"",keepAttr:!0,allowedAttributes:Ie};for(Ze=Qe.length;Ze--;){_e=Qe[Ze];var st=_e,ht=st.name,yt=st.namespaceURI;if(Ne=Xt(_e.value),$e=ut(ht),Je.attrName=$e,Je.attrValue=Ne,Je.keepAttr=!0,Je.forceKeepAttr=void 0,Me("uponSanitizeAttribute",le,Je),Ne=Je.attrValue,!Je.forceKeepAttr&&(q(ht,le),!!Je.keepAttr)){if(at(/\/>/i,Ne)){q(ht,le);continue}$&&(Ne=lt(Ne,V," "),Ne=lt(Ne,ue," "));var dt=le.nodeName.toLowerCase();if(!!tt(dt,$e,Ne))try{yt?le.setAttributeNS(yt,ht,Ne):le.setAttribute(ht,Ne),Nt(t.removed)}catch{}}}Me("afterSanitizeAttributes",le,null)}},qe=function Le(le){var _e=void 0,Ne=be(le);for(Me("beforeSanitizeShadowDOM",le,null);_e=Ne.nextNode();)Me("uponSanitizeShadowNode",_e,null),!Ve(_e)&&(_e.content instanceof B&&Le(_e.content),Ye(_e));Me("afterSanitizeShadowDOM",le,null)};return t.sanitize=function(Le,le){var _e=void 0,Ne=void 0,$e=void 0,Ze=void 0,Qe=void 0;if(Fe=!Le,Fe&&(Le="<!-->"),typeof Le!="string"&&!Ae(Le)){if(typeof Le.toString!="function")throw Pt("toString is not a function");if(Le=Le.toString(),typeof Le!="string")throw Pt("dirty is not a string, aborting")}if(!t.isSupported){if(bt(J.toStaticHTML)==="object"||typeof J.toStaticHTML=="function"){if(typeof Le=="string")return J.toStaticHTML(Le);if(Ae(Le))return J.toStaticHTML(Le.outerHTML)}return Le}if(H||Re(le),t.removed=[],typeof Le=="string"&&(z=!1),!z)if(Le instanceof E)_e=oe("<!---->"),Ne=_e.ownerDocument.importNode(Le,!0),Ne.nodeType===1&&Ne.nodeName==="BODY"||Ne.nodeName==="HTML"?_e=Ne:_e.appendChild(Ne);else{if(!L&&!$&&!j&&Le.indexOf("<")===-1)return b&&Q?b.createHTML(Le):Le;if(_e=oe(Le),!_e)return L?null:S}_e&&d&&Oe(_e.firstChild);for(var Je=be(z?Le:_e);$e=Je.nextNode();)$e.nodeType===3&&$e===Ze||Ve($e)||($e.content instanceof B&&qe($e.content),Ye($e),Ze=$e);if(Ze=null,z)return Le;if(L){if(U)for(Qe=n.call(_e.ownerDocument);_e.firstChild;)Qe.appendChild(_e.firstChild);else Qe=_e;return K&&(Qe=u.call(y,Qe,!0)),Qe}var st=j?_e.outerHTML:_e.innerHTML;return $&&(st=lt(st,V," "),st=lt(st,ue," ")),b&&Q?b.createHTML(st):st},t.setConfig=function(Le){Re(Le),H=!0},t.clearConfig=function(){ve=null,H=!1},t.isValidAttribute=function(Le,le,_e){ve||Re({});var Ne=ut(Le),$e=ut(le);return tt(Ne,$e,_e)},t.addHook=function(Le,le){typeof le=="function"&&(O[Le]=O[Le]||[],pt(O[Le],le))},t.removeHook=function(Le){O[Le]&&Nt(O[Le])},t.removeHooks=function(Le){O[Le]&&(O[Le]=[])},t.removeAllHooks=function(){O={}},t}var ui=Ht();define("vs/base/browser/dompurify/dompurify",function(){return ui}),define(me[40],pe([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createFastDomNode=t.FastDomNode=void 0;class y{constructor(E){this.domNode=E,this._maxWidth="",this._width="",this._height="",this._top="",this._left="",this._bottom="",this._right="",this._fontFamily="",this._fontWeight="",this._fontSize="",this._fontStyle="",this._fontFeatureSettings="",this._textDecoration="",this._lineHeight="",this._letterSpacing="",this._className="",this._display="",this._position="",this._visibility="",this._color="",this._backgroundColor="",this._layerHint=!1,this._contain="none",this._boxShadow=""}setMaxWidth(E){const w=i(E);this._maxWidth!==w&&(this._maxWidth=w,this.domNode.style.maxWidth=this._maxWidth)}setWidth(E){const w=i(E);this._width!==w&&(this._width=w,this.domNode.style.width=this._width)}setHeight(E){const w=i(E);this._height!==w&&(this._height=w,this.domNode.style.height=this._height)}setTop(E){const w=i(E);this._top!==w&&(this._top=w,this.domNode.style.top=this._top)}setLeft(E){const w=i(E);this._left!==w&&(this._left=w,this.domNode.style.left=this._left)}setBottom(E){const w=i(E);this._bottom!==w&&(this._bottom=w,this.domNode.style.bottom=this._bottom)}setRight(E){const w=i(E);this._right!==w&&(this._right=w,this.domNode.style.right=this._right)}setFontFamily(E){this._fontFamily!==E&&(this._fontFamily=E,this.domNode.style.fontFamily=this._fontFamily)}setFontWeight(E){this._fontWeight!==E&&(this._fontWeight=E,this.domNode.style.fontWeight=this._fontWeight)}setFontSize(E){const w=i(E);this._fontSize!==w&&(this._fontSize=w,this.domNode.style.fontSize=this._fontSize)}setFontStyle(E){this._fontStyle!==E&&(this._fontStyle=E,this.domNode.style.fontStyle=this._fontStyle)}setFontFeatureSettings(E){this._fontFeatureSettings!==E&&(this._fontFeatureSettings=E,this.domNode.style.fontFeatureSettings=this._fontFeatureSettings)}setTextDecoration(E){this._textDecoration!==E&&(this._textDecoration=E,this.domNode.style.textDecoration=this._textDecoration)}setLineHeight(E){const w=i(E);this._lineHeight!==w&&(this._lineHeight=w,this.domNode.style.lineHeight=this._lineHeight)}setLetterSpacing(E){const w=i(E);this._letterSpacing!==w&&(this._letterSpacing=w,this.domNode.style.letterSpacing=this._letterSpacing)}setClassName(E){this._className!==E&&(this._className=E,this.domNode.className=this._className)}toggleClassName(E,w){this.domNode.classList.toggle(E,w),this._className=this.domNode.className}setDisplay(E){this._display!==E&&(this._display=E,this.domNode.style.display=this._display)}setPosition(E){this._position!==E&&(this._position=E,this.domNode.style.position=this._position)}setVisibility(E){this._visibility!==E&&(this._visibility=E,this.domNode.style.visibility=this._visibility)}setColor(E){this._color!==E&&(this._color=E,this.domNode.style.color=this._color)}setBackgroundColor(E){this._backgroundColor!==E&&(this._backgroundColor=E,this.domNode.style.backgroundColor=this._backgroundColor)}setLayerHinting(E){this._layerHint!==E&&(this._layerHint=E,this.domNode.style.transform=this._layerHint?"translate3d(0px, 0px, 0px)":"")}setBoxShadow(E){this._boxShadow!==E&&(this._boxShadow=E,this.domNode.style.boxShadow=E)}setContain(E){this._contain!==E&&(this._contain=E,this.domNode.style.contain=this._contain)}setAttribute(E,w){this.domNode.setAttribute(E,w)}removeAttribute(E){this.domNode.removeAttribute(E)}appendChild(E){this.domNode.appendChild(E.domNode)}removeChild(E){this.domNode.removeChild(E.domNode)}}t.FastDomNode=y;function i(M){return typeof M=="number"?`${M}px`:M}function B(M){return new y(M)}t.createFastDomNode=B}),define(me[65],pe([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IframeUtils=void 0;let y=!1,i=null;function B(E){if(!E.parent||E.parent===E)return null;try{const w=E.location,m=E.parent.location;if(w.origin!=="null"&&m.origin!=="null"&&w.origin!==m.origin)return y=!0,null}catch{return y=!0,null}return E.parent}class M{static getSameOriginWindowChain(){if(!i){i=[];let w=window,m;do m=B(w),m?i.push({window:w,iframeElement:w.frameElement||null}):i.push({window:w,iframeElement:null}),w=m;while(w)}return i.slice(0)}static hasDifferentOriginAncestor(){return i||this.getSameOriginWindowChain(),y}static getPositionOfChildWindowRelativeToAncestorWindow(w,m){if(!m||w===m)return{top:0,left:0};let f=0,g=0;const F=this.getSameOriginWindowChain();for(const l of F){if(f+=l.window.scrollY,g+=l.window.scrollX,l.window===m||!l.iframeElement)break;const s=l.iframeElement.getBoundingClientRect();f+=s.top,g+=s.left}return{top:f,left:g}}}t.IframeUtils=M}),define(me[66],pe([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedListVirtualDelegate=t.ListError=t.ListDragOverReactions=t.ListDragOverEffect=void 0;var y;(function(M){M[M.Copy=0]="Copy",M[M.Move=1]="Move"})(y=t.ListDragOverEffect||(t.ListDragOverEffect={})),t.ListDragOverReactions={reject(){return{accept:!1}},accept(){return{accept:!0}}};class i extends Error{constructor(E,w){super(`ListError [${E}] ${w}`)}}t.ListError=i;class B{constructor(){this.cache=new WeakMap}getHeight(E){return this.cache.get(E)??this.estimateHeight(E)}setDynamicHeight(E,w){w>0&&this.cache.set(E,w)}}t.CachedListVirtualDelegate=B}),define(me[67],pe([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CombinedSpliceable=void 0;class y{constructor(B){this.spliceables=B}splice(B,M,E){this.spliceables.forEach(w=>w.splice(B,M,E))}}t.CombinedSpliceable=y}),define(me[41],pe([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarState=void 0;const y=20;class i{constructor(M,E,w,m,f,g){this._scrollbarSize=Math.round(E),this._oppositeScrollbarSize=Math.round(w),this._arrowSize=Math.round(M),this._visibleSize=m,this._scrollSize=f,this._scrollPosition=g,this._computedAvailableSize=0,this._computedIsNeeded=!1,this._computedSliderSize=0,this._computedSliderRatio=0,this._computedSliderPosition=0,this._refreshComputedValues()}clone(){return new i(this._arrowSize,this._scrollbarSize,this._oppositeScrollbarSize,this._visibleSize,this._scrollSize,this._scrollPosition)}setVisibleSize(M){const E=Math.round(M);return this._visibleSize!==E?(this._visibleSize=E,this._refreshComputedValues(),!0):!1}setScrollSize(M){const E=Math.round(M);return this._scrollSize!==E?(this._scrollSize=E,this._refreshComputedValues(),!0):!1}setScrollPosition(M){const E=Math.round(M);return this._scrollPosition!==E?(this._scrollPosition=E,this._refreshComputedValues(),!0):!1}setScrollbarSize(M){this._scrollbarSize=Math.round(M)}setOppositeScrollbarSize(M){this._oppositeScrollbarSize=Math.round(M)}static _computeValues(M,E,w,m,f){const g=Math.max(0,w-M),F=Math.max(0,g-2*E),l=m>0&&m>w;if(!l)return{computedAvailableSize:Math.round(g),computedIsNeeded:l,computedSliderSize:Math.round(F),computedSliderRatio:0,computedSliderPosition:0};const s=Math.round(Math.max(y,Math.floor(w*F/m))),e=(F-s)/(m-w),p=f*e;return{computedAvailableSize:Math.round(g),computedIsNeeded:l,computedSliderSize:Math.round(s),computedSliderRatio:e,computedSliderPosition:Math.round(p)}}_refreshComputedValues(){const M=i._computeValues(this._oppositeScrollbarSize,this._arrowSize,this._visibleSize,this._scrollSize,this._scrollPosition);this._computedAvailableSize=M.computedAvailableSize,this._computedIsNeeded=M.computedIsNeeded,this._computedSliderSize=M.computedSliderSize,this._computedSliderRatio=M.computedSliderRatio,this._computedSliderPosition=M.computedSliderPosition}getArrowSize(){return this._arrowSize}getScrollPosition(){return this._scrollPosition}getRectangleLargeSize(){return this._computedAvailableSize}getRectangleSmallSize(){return this._scrollbarSize}isNeeded(){return this._computedIsNeeded}getSliderSize(){return this._computedSliderSize}getSliderPosition(){return this._computedSliderPosition}getDesiredScrollPositionFromOffset(M){if(!this._computedIsNeeded)return 0;const E=M-this._arrowSize-this._computedSliderSize/2;return Math.round(E/this._computedSliderRatio)}getDesiredScrollPositionFromOffsetPaged(M){if(!this._computedIsNeeded)return 0;const E=M-this._arrowSize;let w=this._scrollPosition;return E<this._computedSliderPosition?w-=this._visibleSize:w+=this._visibleSize,w}getDesiredScrollPositionFromDelta(M){if(!this._computedIsNeeded)return 0;const E=this._computedSliderPosition+M;return Math.round(E/this._computedSliderRatio)}}t.ScrollbarState=i}),define(me[23],pe([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WeakMapper=t.TreeError=t.TreeDragOverReactions=t.TreeDragOverBubble=t.TreeMouseEventTarget=t.TreeVisibility=void 0;var y;(function(w){w[w.Hidden=0]="Hidden",w[w.Visible=1]="Visible",w[w.Recurse=2]="Recurse"})(y=t.TreeVisibility||(t.TreeVisibility={}));var i;(function(w){w[w.Unknown=0]="Unknown",w[w.Twistie=1]="Twistie",w[w.Element=2]="Element",w[w.Filter=3]="Filter"})(i=t.TreeMouseEventTarget||(t.TreeMouseEventTarget={}));var B;(function(w){w[w.Down=0]="Down",w[w.Up=1]="Up"})(B=t.TreeDragOverBubble||(t.TreeDragOverBubble={})),t.TreeDragOverReactions={acceptBubbleUp(){return{accept:!0,bubble:1}},acceptBubbleDown(w=!1){return{accept:!0,bubble:0,autoExpand:w}},acceptCopyBubbleUp(){return{accept:!0,bubble:1,effect:0}},acceptCopyBubbleDown(w=!1){return{accept:!0,bubble:0,effect:0,autoExpand:w}}};class M extends Error{constructor(m,f){super(`TreeError [${m}] ${f}`)}}t.TreeError=M;class E{constructor(m){this.fn=m,this._map=new WeakMap}map(m){let f=this._map.get(m);return f||(f=this.fn(m),this._map.set(m,f)),f}}t.WeakMapper=E}),define(me[68],pe([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.assertNever=t.ok=void 0;function y(B,M){if(!B)throw new Error(M?`Assertion failed (${M})`:"Assertion Failed")}t.ok=y;function i(B,M="Unreachable"){throw new Error(M)}t.assertNever=i}),define(me[11],pe([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CSSIcon=t.getClassNamesArray=t.Codicon=t.getCodiconAriaLabel=void 0;function y(E){return E?E.replace(/\$\((.*?)\)/g,(w,m)=>` ${m} `).trim():""}t.getCodiconAriaLabel=y;class i{constructor(w,m,f){this.id=w,this.definition=m,this.description=f,i._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return i._allCodicons}}t.Codicon=i,i._allCodicons=[],i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",i.add.definition),i.gistNew=new i("gist-new",i.add.definition),i.repoCreate=new i("repo-create",i.add.definition),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",i.circleFilled.definition),i.closeDirty=new i("close-dirty",i.circleFilled.definition),i.terminalDecorationSuccess=new i("terminal-decoration-success",i.circleFilled.definition),i.debugBreakpoint=new i("debug-breakpoint",i.circleFilled.definition),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",i.circleFilled.definition),i.debugHint=new i("debug-hint",i.circleFilled.definition),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circle=new i("circle",{fontCharacter:"\\eabc"}),i.circleOutline=new i("circle-outline",i.circle.definition),i.terminalDecorationIncomplete=new i("terminal-decoration-incomplete",i.circle.definition),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",i.circle.definition),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolCustomColor=new i("symbol-customcolor",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.circleSmallFilled=new i("circle-small-filled",{fontCharacter:"\\eb8a"}),i.debugStackframeDot=new i("debug-stackframe-dot",i.circleSmallFilled.definition),i.terminalDecorationMark=new i("terminal-decoration-mark",i.circleSmallFilled.definition),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLarge=new i("circle-large",{fontCharacter:"\\ebb5"}),i.circleLargeOutline=new i("circle-large-outline",i.circleLarge.definition),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.debugContinueSmall=new i("debug-continue-small",{fontCharacter:"\\ebe0"}),i.beakerStop=new i("beaker-stop",{fontCharacter:"\\ebe1"}),i.graphLine=new i("graph-line",{fontCharacter:"\\ebe2"}),i.graphScatter=new i("graph-scatter",{fontCharacter:"\\ebe3"}),i.pieChart=new i("pie-chart",{fontCharacter:"\\ebe4"}),i.bracket=new i("bracket",i.json.definition),i.bracketDot=new i("bracket-dot",{fontCharacter:"\\ebe5"}),i.bracketError=new i("bracket-error",{fontCharacter:"\\ebe6"}),i.lockSmall=new i("lock-small",{fontCharacter:"\\ebe7"}),i.azureDevops=new i("azure-devops",{fontCharacter:"\\ebe8"}),i.verifiedFilled=new i("verified-filled",{fontCharacter:"\\ebe9"}),i.newLine=new i("newline",{fontCharacter:"\\ebea"}),i.layout=new i("layout",{fontCharacter:"\\ebeb"}),i.layoutActivitybarLeft=new i("layout-activitybar-left",{fontCharacter:"\\ebec"}),i.layoutActivitybarRight=new i("layout-activitybar-right",{fontCharacter:"\\ebed"}),i.layoutPanelLeft=new i("layout-panel-left",{fontCharacter:"\\ebee"}),i.layoutPanelCenter=new i("layout-panel-center",{fontCharacter:"\\ebef"}),i.layoutPanelJustify=new i("layout-panel-justify",{fontCharacter:"\\ebf0"}),i.layoutPanelRight=new i("layout-panel-right",{fontCharacter:"\\ebf1"}),i.layoutPanel=new i("layout-panel",{fontCharacter:"\\ebf2"}),i.layoutSidebarLeft=new i("layout-sidebar-left",{fontCharacter:"\\ebf3"}),i.layoutSidebarRight=new i("layout-sidebar-right",{fontCharacter:"\\ebf4"}),i.layoutStatusbar=new i("layout-statusbar",{fontCharacter:"\\ebf5"}),i.layoutMenubar=new i("layout-menubar",{fontCharacter:"\\ebf6"}),i.layoutCentered=new i("layout-centered",{fontCharacter:"\\ebf7"}),i.layoutSidebarRightOff=new i("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),i.layoutPanelOff=new i("layout-panel-off",{fontCharacter:"\\ec01"}),i.layoutSidebarLeftOff=new i("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),i.target=new i("target",{fontCharacter:"\\ebf8"}),i.indent=new i("indent",{fontCharacter:"\\ebf9"}),i.recordSmall=new i("record-small",{fontCharacter:"\\ebfa"}),i.errorSmall=new i("error-small",{fontCharacter:"\\ebfb"}),i.terminalDecorationError=new i("terminal-decoration-error",i.errorSmall.definition),i.arrowCircleDown=new i("arrow-circle-down",{fontCharacter:"\\ebfc"}),i.arrowCircleLeft=new i("arrow-circle-left",{fontCharacter:"\\ebfd"}),i.arrowCircleRight=new i("arrow-circle-right",{fontCharacter:"\\ebfe"}),i.arrowCircleUp=new i("arrow-circle-up",{fontCharacter:"\\ebff"}),i.heartFilled=new i("heart-filled",{fontCharacter:"\\ec04"}),i.map=new i("map",{fontCharacter:"\\ec05"}),i.mapFilled=new i("map-filled",{fontCharacter:"\\ec06"}),i.circleSmall=new i("circle-small",{fontCharacter:"\\ec07"}),i.bellSlash=new i("bell-slash",{fontCharacter:"\\ec08"}),i.bellSlashDot=new i("bell-slash-dot",{fontCharacter:"\\ec09"}),i.commentUnresolved=new i("comment-unresolved",{fontCharacter:"\\ec0a"}),i.gitPullRequestGoToChanges=new i("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),i.gitPullRequestNewChanges=new i("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),i.dialogError=new i("dialog-error",i.error.definition),i.dialogWarning=new i("dialog-warning",i.warning.definition),i.dialogInfo=new i("dialog-info",i.info.definition),i.dialogClose=new i("dialog-close",i.close.definition),i.treeItemExpanded=new i("tree-item-expanded",i.chevronDown.definition),i.treeFilterOnTypeOn=new i("tree-filter-on-type-on",i.listFilter.definition),i.treeFilterOnTypeOff=new i("tree-filter-on-type-off",i.listSelection.definition),i.treeFilterClear=new i("tree-filter-clear",i.close.definition),i.treeItemLoading=new i("tree-item-loading",i.loading.definition),i.menuSelection=new i("menu-selection",i.check.definition),i.menuSubmenu=new i("menu-submenu",i.chevronRight.definition),i.menuBarMore=new i("menubar-more",i.more.definition),i.scrollbarButtonLeft=new i("scrollbar-button-left",i.triangleLeft.definition),i.scrollbarButtonRight=new i("scrollbar-button-right",i.triangleRight.definition),i.scrollbarButtonUp=new i("scrollbar-button-up",i.triangleUp.definition),i.scrollbarButtonDown=new i("scrollbar-button-down",i.triangleDown.definition),i.toolBarMore=new i("toolbar-more",i.more.definition),i.quickInputBack=new i("quick-input-back",i.arrowLeft.definition);function B(E,w){const m=["codicon","codicon-"+E];return w&&m.push("codicon-modifier-"+w),m}t.getClassNamesArray=B;var M;(function(E){E.iconNameSegment="[A-Za-z0-9]+",E.iconNameExpression="[A-Za-z0-9-]+",E.iconModifierExpression="~[A-Za-z]+",E.iconNameCharacter="[A-Za-z0-9~-]";const w=new RegExp(`^(${E.iconNameExpression})(${E.iconModifierExpression})?$`);function m(F){if(F instanceof i)return["codicon","codicon-"+F.id];const l=w.exec(F.id);if(!l)return m(i.error);const[,s,e]=l,p=["codicon","codicon-"+s];return e&&p.push("codicon-modifier-"+e.substr(1)),p}E.asClassNameArray=m;function f(F){return m(F).join(" ")}E.asClassName=f;function g(F){return"."+m(F).join(".")}E.asCSSSelector=g})(M=t.CSSIcon||(t.CSSIcon={}))}),define(me[69],pe([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SetMap=t.diffMaps=t.diffSets=t.groupBy=void 0;function y(E,w){const m=Object.create(null);for(const f of E){const g=w(f);let F=m[g];F||(F=m[g]=[]),F.push(f)}return m}t.groupBy=y;function i(E,w){const m=[],f=[];for(const g of E)w.has(g)||m.push(g);for(const g of w)E.has(g)||f.push(g);return{removed:m,added:f}}t.diffSets=i;function B(E,w){const m=[],f=[];for(const[g,F]of E)w.has(g)||m.push(F);for(const[g,F]of w)E.has(g)||f.push(F);return{removed:m,added:f}}t.diffMaps=B;class M{constructor(){this.map=new Map}add(w,m){let f=this.map.get(w);f||(f=new Set,this.map.set(w,f)),f.add(m)}delete(w,m){const f=this.map.get(w);!f||(f.delete(m),f.size===0&&this.map.delete(w))}forEach(w,m){const f=this.map.get(w);!f||f.forEach(m)}}t.SetMap=M}),define(me[24],pe([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Color=t.HSVA=t.HSLA=t.RGBA=void 0;function y(w,m){const f=Math.pow(10,m);return Math.round(w*f)/f}class i{constructor(m,f,g,F=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,m))|0,this.g=Math.min(255,Math.max(0,f))|0,this.b=Math.min(255,Math.max(0,g))|0,this.a=y(Math.max(Math.min(1,F),0),3)}static equals(m,f){return m.r===f.r&&m.g===f.g&&m.b===f.b&&m.a===f.a}}t.RGBA=i;class B{constructor(m,f,g,F){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,m),0)|0,this.s=y(Math.max(Math.min(1,f),0),3),this.l=y(Math.max(Math.min(1,g),0),3),this.a=y(Math.max(Math.min(1,F),0),3)}static equals(m,f){return m.h===f.h&&m.s===f.s&&m.l===f.l&&m.a===f.a}static fromRGBA(m){const f=m.r/255,g=m.g/255,F=m.b/255,l=m.a,s=Math.max(f,g,F),e=Math.min(f,g,F);let p=0,D=0;const v=(e+s)/2,_=s-e;if(_>0){switch(D=Math.min(v<=.5?_/(2*v):_/(2-2*v),1),s){case f:p=(g-F)/_+(g<F?6:0);break;case g:p=(F-f)/_+2;break;case F:p=(f-g)/_+4;break}p*=60,p=Math.round(p)}return new B(p,D,v,l)}static _hue2rgb(m,f,g){return g<0&&(g+=1),g>1&&(g-=1),g<1/6?m+(f-m)*6*g:g<1/2?f:g<2/3?m+(f-m)*(2/3-g)*6:m}static toRGBA(m){const f=m.h/360,{s:g,l:F,a:l}=m;let s,e,p;if(g===0)s=e=p=F;else{const D=F<.5?F*(1+g):F+g-F*g,v=2*F-D;s=B._hue2rgb(v,D,f+1/3),e=B._hue2rgb(v,D,f),p=B._hue2rgb(v,D,f-1/3)}return new i(Math.round(s*255),Math.round(e*255),Math.round(p*255),l)}}t.HSLA=B;class M{constructor(m,f,g,F){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,m),0)|0,this.s=y(Math.max(Math.min(1,f),0),3),this.v=y(Math.max(Math.min(1,g),0),3),this.a=y(Math.max(Math.min(1,F),0),3)}static equals(m,f){return m.h===f.h&&m.s===f.s&&m.v===f.v&&m.a===f.a}static fromRGBA(m){const f=m.r/255,g=m.g/255,F=m.b/255,l=Math.max(f,g,F),s=Math.min(f,g,F),e=l-s,p=l===0?0:e/l;let D;return e===0?D=0:l===f?D=((g-F)/e%6+6)%6:l===g?D=(F-f)/e+2:D=(f-g)/e+4,new M(Math.round(D*60),p,l,m.a)}static toRGBA(m){const{h:f,s:g,v:F,a:l}=m,s=F*g,e=s*(1-Math.abs(f/60%2-1)),p=F-s;let[D,v,_]=[0,0,0];return f<60?(D=s,v=e):f<120?(D=e,v=s):f<180?(v=s,_=e):f<240?(v=e,_=s):f<300?(D=e,_=s):f<=360&&(D=s,_=e),D=Math.round((D+p)*255),v=Math.round((v+p)*255),_=Math.round((_+p)*255),new i(D,v,_,l)}}t.HSVA=M;class E{constructor(m){if(m)if(m instanceof i)this.rgba=m;else if(m instanceof B)this._hsla=m,this.rgba=B.toRGBA(m);else if(m instanceof M)this._hsva=m,this.rgba=M.toRGBA(m);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}static fromHex(m){return E.Format.CSS.parseHex(m)||E.red}get hsla(){return this._hsla?this._hsla:B.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:M.fromRGBA(this.rgba)}equals(m){return!!m&&i.equals(this.rgba,m.rgba)&&B.equals(this.hsla,m.hsla)&&M.equals(this.hsva,m.hsva)}getRelativeLuminance(){const m=E._relativeLuminanceForComponent(this.rgba.r),f=E._relativeLuminanceForComponent(this.rgba.g),g=E._relativeLuminanceForComponent(this.rgba.b),F=.2126*m+.7152*f+.0722*g;return y(F,4)}static _relativeLuminanceForComponent(m){const f=m/255;return f<=.03928?f/12.92:Math.pow((f+.055)/1.055,2.4)}getContrastRatio(m){const f=this.getRelativeLuminance(),g=m.getRelativeLuminance();return f>g?(f+.05)/(g+.05):(g+.05)/(f+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(m){const f=this.getRelativeLuminance(),g=m.getRelativeLuminance();return f>g}isDarkerThan(m){const f=this.getRelativeLuminance(),g=m.getRelativeLuminance();return f<g}lighten(m){return new E(new B(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*m,this.hsla.a))}darken(m){return new E(new B(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*m,this.hsla.a))}transparent(m){const{r:f,g,b:F,a:l}=this.rgba;return new E(new i(f,g,F,l*m))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new E(new i(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(m){const f=m.rgba,g=this.rgba.a,F=f.a,l=g+F*(1-g);if(l<1e-6)return E.transparent;const s=this.rgba.r*g/l+f.r*F*(1-g)/l,e=this.rgba.g*g/l+f.g*F*(1-g)/l,p=this.rgba.b*g/l+f.b*F*(1-g)/l;return new E(new i(s,e,p,l))}makeOpaque(m){if(this.isOpaque()||m.rgba.a!==1)return this;const{r:f,g,b:F,a:l}=this.rgba;return new E(new i(m.rgba.r-l*(m.rgba.r-f),m.rgba.g-l*(m.rgba.g-g),m.rgba.b-l*(m.rgba.b-F),1))}flatten(...m){const f=m.reduceRight((g,F)=>E._flatten(F,g));return E._flatten(this,f)}static _flatten(m,f){const g=1-m.rgba.a;return new E(new i(g*f.rgba.r+m.rgba.a*m.rgba.r,g*f.rgba.g+m.rgba.a*m.rgba.g,g*f.rgba.b+m.rgba.a*m.rgba.b))}toString(){return this._toString||(this._toString=E.Format.CSS.format(this)),this._toString}static getLighterColor(m,f,g){if(m.isLighterThan(f))return m;g=g||.5;const F=m.getRelativeLuminance(),l=f.getRelativeLuminance();return g=g*(l-F)/l,m.lighten(g)}static getDarkerColor(m,f,g){if(m.isDarkerThan(f))return m;g=g||.5;const F=m.getRelativeLuminance(),l=f.getRelativeLuminance();return g=g*(F-l)/F,m.darken(g)}}t.Color=E,E.white=new E(new i(255,255,255,1)),E.black=new E(new i(0,0,0,1)),E.red=new E(new i(255,0,0,1)),E.blue=new E(new i(0,0,255,1)),E.green=new E(new i(0,255,0,1)),E.cyan=new E(new i(0,255,255,1)),E.lightgrey=new E(new i(211,211,211,1)),E.transparent=new E(new i(0,0,0,0)),function(w){let m;(function(f){let g;(function(F){function l(S){return S.rgba.a===1?`rgb(${S.rgba.r}, ${S.rgba.g}, ${S.rgba.b})`:w.Format.CSS.formatRGBA(S)}F.formatRGB=l;function s(S){return`rgba(${S.rgba.r}, ${S.rgba.g}, ${S.rgba.b}, ${+S.rgba.a.toFixed(2)})`}F.formatRGBA=s;function e(S){return S.hsla.a===1?`hsl(${S.hsla.h}, ${(S.hsla.s*100).toFixed(2)}%, ${(S.hsla.l*100).toFixed(2)}%)`:w.Format.CSS.formatHSLA(S)}F.formatHSL=e;function p(S){return`hsla(${S.hsla.h}, ${(S.hsla.s*100).toFixed(2)}%, ${(S.hsla.l*100).toFixed(2)}%, ${S.hsla.a.toFixed(2)})`}F.formatHSLA=p;function D(S){const A=S.toString(16);return A.length!==2?"0"+A:A}function v(S){return`#${D(S.rgba.r)}${D(S.rgba.g)}${D(S.rgba.b)}`}F.formatHex=v;function _(S,A=!1){return A&&S.rgba.a===1?w.Format.CSS.formatHex(S):`#${D(S.rgba.r)}${D(S.rgba.g)}${D(S.rgba.b)}${D(Math.round(S.rgba.a*255))}`}F.formatHexA=_;function a(S){return S.isOpaque()?w.Format.CSS.formatHex(S):w.Format.CSS.formatRGBA(S)}F.format=a;function o(S){const A=S.length;if(A===0||S.charCodeAt(0)!==35)return null;if(A===7){const C=16*b(S.charCodeAt(1))+b(S.charCodeAt(2)),r=16*b(S.charCodeAt(3))+b(S.charCodeAt(4)),n=16*b(S.charCodeAt(5))+b(S.charCodeAt(6));return new w(new i(C,r,n,1))}if(A===9){const C=16*b(S.charCodeAt(1))+b(S.charCodeAt(2)),r=16*b(S.charCodeAt(3))+b(S.charCodeAt(4)),n=16*b(S.charCodeAt(5))+b(S.charCodeAt(6)),c=16*b(S.charCodeAt(7))+b(S.charCodeAt(8));return new w(new i(C,r,n,c/255))}if(A===4){const C=b(S.charCodeAt(1)),r=b(S.charCodeAt(2)),n=b(S.charCodeAt(3));return new w(new i(16*C+C,16*r+r,16*n+n))}if(A===5){const C=b(S.charCodeAt(1)),r=b(S.charCodeAt(2)),n=b(S.charCodeAt(3)),c=b(S.charCodeAt(4));return new w(new i(16*C+C,16*r+r,16*n+n,(16*c+c)/255))}return null}F.parseHex=o;function b(S){switch(S){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(g=f.CSS||(f.CSS={}))})(m=w.Format||(w.Format={}))}(E=t.Color||(t.Color={}))}),define(me[25],pe([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=t.createDecorator=void 0;function y(E){return(w,m,f)=>{let g=null,F=null;if(typeof f.value=="function"?(g="value",F=f.value):typeof f.get=="function"&&(g="get",F=f.get),!F)throw new Error("not supported");f[g]=E(F,m)}}t.createDecorator=y;function i(E,w,m){let f=null,g=null;if(typeof m.value=="function"?(f="value",g=m.value,g.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof m.get=="function"&&(f="get",g=m.get),!g)throw new Error("not supported");const F=`$memoize$${w}`;m[f]=function(...l){return this.hasOwnProperty(F)||Object.defineProperty(this,F,{configurable:!1,enumerable:!1,writable:!1,value:g.apply(this,l)}),this[F]}}t.memoize=i;function B(E,w,m){return y((f,g)=>{const F=`$debounce$${g}`,l=`$debounce$result$${g}`;return function(...s){this[l]||(this[l]=m?m():void 0),clearTimeout(this[F]),w&&(this[l]=w(this[l],...s),s=[this[l]]),this[F]=setTimeout(()=>{f.apply(this,s),this[l]=m?m():void 0},E)}})}t.debounce=B;function M(E,w,m){return y((f,g)=>{const F=`$throttle$timer$${g}`,l=`$throttle$result$${g}`,s=`$throttle$lastRun$${g}`,e=`$throttle$pending$${g}`;return function(...p){if(this[l]||(this[l]=m?m():void 0),(this[s]===null||this[s]===void 0)&&(this[s]=-Number.MAX_VALUE),w&&(this[l]=w(this[l],...p)),this[e])return;const D=this[s]+E;D<=Date.now()?(this[s]=Date.now(),f.apply(this,[this[l]]),this[l]=m?m():void 0):(this[e]=!0,this[F]=setTimeout(()=>{this[e]=!1,this[s]=Date.now(),f.apply(this,[this[l]]),this[l]=m?m():void 0},D-Date.now()))}})}t.throttle=M}),define(me[70],pe([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffChange=void 0;class y{constructor(B,M,E,w){this.originalStart=B,this.originalLength=M,this.modifiedStart=E,this.modifiedLength=w}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.DiffChange=y}),define(me[13],pe([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BugIndicatingError=t.ErrorNoTelemetry=t.ExpectedError=t.NotSupportedError=t.NotImplementedError=t.getErrorMessage=t.disposed=t.readonly=t.illegalState=t.illegalArgument=t.canceled=t.CancellationError=t.isCancellationError=t.transformErrorForSerialization=t.onUnexpectedExternalError=t.onUnexpectedError=t.setUnexpectedErrorHandler=t.errorHandler=t.ErrorHandler=void 0;class y{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(S){setTimeout(()=>{throw S.stack?a.isErrorNoTelemetry(S)?new a(S.message+`

`+S.stack):new Error(S.message+`

`+S.stack):S},0)}}addListener(S){return this.listeners.push(S),()=>{this._removeListener(S)}}emit(S){this.listeners.forEach(A=>{A(S)})}_removeListener(S){this.listeners.splice(this.listeners.indexOf(S),1)}setUnexpectedErrorHandler(S){this.unexpectedErrorHandler=S}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(S){this.unexpectedErrorHandler(S),this.emit(S)}onUnexpectedExternalError(S){this.unexpectedErrorHandler(S)}}t.ErrorHandler=y,t.errorHandler=new y;function i(b){t.errorHandler.setUnexpectedErrorHandler(b)}t.setUnexpectedErrorHandler=i;function B(b){m(b)||t.errorHandler.onUnexpectedError(b)}t.onUnexpectedError=B;function M(b){m(b)||t.errorHandler.onUnexpectedExternalError(b)}t.onUnexpectedExternalError=M;function E(b){if(b instanceof Error){const{name:S,message:A}=b,C=b.stacktrace||b.stack;return{$isError:!0,name:S,message:A,stack:C,noTelemetry:a.isErrorNoTelemetry(b)}}return b}t.transformErrorForSerialization=E;const w="Canceled";function m(b){return b instanceof f?!0:b instanceof Error&&b.name===w&&b.message===w}t.isCancellationError=m;class f extends Error{constructor(){super(w);this.name=this.message}}t.CancellationError=f;function g(){const b=new Error(w);return b.name=b.message,b}t.canceled=g;function F(b){return b?new Error(`Illegal argument: ${b}`):new Error("Illegal argument")}t.illegalArgument=F;function l(b){return b?new Error(`Illegal state: ${b}`):new Error("Illegal state")}t.illegalState=l;function s(b){return b?new Error(`readonly property '${b} cannot be changed'`):new Error("readonly property cannot be changed")}t.readonly=s;function e(b){const S=new Error(`${b} has been disposed`);return S.name="DISPOSED",S}t.disposed=e;function p(b){return b?b.message?b.message:b.stack?b.stack.split(`
`)[0]:String(b):"Error"}t.getErrorMessage=p;class D extends Error{constructor(S){super("NotImplemented");S&&(this.message=S)}}t.NotImplementedError=D;class v extends Error{constructor(S){super("NotSupported");S&&(this.message=S)}}t.NotSupportedError=v;class _ extends Error{constructor(){super(...arguments);this.isExpected=!0}}t.ExpectedError=_;class a extends Error{constructor(S){super(S);this.name="ErrorNoTelemetry"}static fromError(S){if(S instanceof a)return S;const A=new a;return A.message=S.message,A.stack=S.stack,A}static isErrorNoTelemetry(S){return S.name==="ErrorNoTelemetry"}}t.ErrorNoTelemetry=a;class o extends Error{constructor(S){super(S||"An unexpected bug occurred.");Object.setPrototypeOf(this,o.prototype);debugger}}t.BugIndicatingError=o}),define(me[14],pe([1,0,13]),function(J,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CallbackIterable=t.ArrayQueue=t.findMinBy=t.findLastMaxBy=t.findMaxBy=t.numberComparator=t.tieBreakComparators=t.compareBy=t.CompareResult=t.splice=t.insertInto=t.mapFind=t.getRandomElement=t.asArray=t.mapArrayOrNot=t.pushMany=t.pushToEnd=t.pushToStart=t.shuffle=t.arrayInsert=t.remove=t.insert=t.index=t.range=t.flatten=t.commonPrefixLength=t.lastOrDefault=t.firstOrDefault=t.lastIndex=t.findLast=t.uniqueFilter=t.distinct=t.isNonEmptyArray=t.isFalsyOrEmpty=t.move=t.coalesceInPlace=t.coalesce=t.topAsync=t.top=t.delta=t.sortedDiff=t.groupBy=t.quickSelect=t.findFirstInSorted=t.binarySearch2=t.binarySearch=t.removeFastWithoutKeepingOrder=t.equals=t.tail2=t.tail=void 0;function i(N,R=0){return N[N.length-(1+R)]}t.tail=i;function B(N){if(N.length===0)throw new Error("Invalid tail call");return[N.slice(0,N.length-1),N[N.length-1]]}t.tail2=B;function M(N,R,z=(T,W)=>T===W){if(N===R)return!0;if(!N||!R||N.length!==R.length)return!1;for(let T=0,W=N.length;T<W;T++)if(!z(N[T],R[T]))return!1;return!0}t.equals=M;function E(N,R){const z=N.length-1;R<z&&(N[R]=N[z]),N.pop()}t.removeFastWithoutKeepingOrder=E;function w(N,R,z){return m(N.length,T=>z(N[T],R))}t.binarySearch=w;function m(N,R){let z=0,T=N-1;for(;z<=T;){const W=(z+T)/2|0,k=R(W);if(k<0)z=W+1;else if(k>0)T=W-1;else return W}return-(z+1)}t.binarySearch2=m;function f(N,R){let z=0,T=N.length;if(T===0)return 0;for(;z<T;){const W=Math.floor((z+T)/2);R(N[W])?T=W:z=W+1}return z}t.findFirstInSorted=f;function g(N,R,z){if(N=N|0,N>=R.length)throw new TypeError("invalid index");const T=R[Math.floor(R.length*Math.random())],W=[],k=[],P=[];for(const x of R){const ee=z(x,T);ee<0?W.push(x):ee>0?k.push(x):P.push(x)}return N<W.length?g(N,W,z):N<W.length+P.length?P[0]:g(N-(W.length+P.length),k,z)}t.quickSelect=g;function F(N,R){const z=[];let T;for(const W of N.slice(0).sort(R))!T||R(T[0],W)!==0?(T=[W],z.push(T)):T.push(W);return z}t.groupBy=F;function l(N,R,z){const T=[];function W(x,ee,he){if(ee===0&&he.length===0)return;const de=T[T.length-1];de&&de.start+de.deleteCount===x?(de.deleteCount+=ee,de.toInsert.push(...he)):T.push({start:x,deleteCount:ee,toInsert:he})}let k=0,P=0;for(;;){if(k===N.length){W(k,0,R.slice(P));break}if(P===R.length){W(k,N.length-k,[]);break}const x=N[k],ee=R[P],he=z(x,ee);he===0?(k+=1,P+=1):he<0?(W(k,1,[]),k+=1):he>0&&(W(k,0,[ee]),P+=1)}return T}t.sortedDiff=l;function s(N,R,z){const T=l(N,R,z),W=[],k=[];for(const P of T)W.push(...N.slice(P.start,P.start+P.deleteCount)),k.push(...P.toInsert);return{removed:W,added:k}}t.delta=s;function e(N,R,z){if(z===0)return[];const T=N.slice(0,z).sort(R);return D(N,R,T,z,N.length),T}t.top=e;function p(N,R,z,T,W){return z===0?Promise.resolve([]):new Promise((k,P)=>{(async()=>{const x=N.length,ee=N.slice(0,z).sort(R);for(let he=z,de=Math.min(z+T,x);he<x;he=de,de=Math.min(de+T,x)){if(he>z&&await new Promise(De=>setTimeout(De)),W&&W.isCancellationRequested)throw new y.CancellationError;D(N,R,ee,he,de)}return ee})().then(k,P)})}t.topAsync=p;function D(N,R,z,T,W){for(const k=z.length;T<W;T++){const P=N[T];if(R(P,z[k-1])<0){z.pop();const x=f(z,ee=>R(P,ee)<0);z.splice(x,0,P)}}}function v(N){return N.filter(R=>!!R)}t.coalesce=v;function _(N){let R=0;for(let z=0;z<N.length;z++)N[z]&&(N[R]=N[z],R+=1);N.length=R}t.coalesceInPlace=_;function a(N,R,z){N.splice(z,0,N.splice(R,1)[0])}t.move=a;function o(N){return!Array.isArray(N)||N.length===0}t.isFalsyOrEmpty=o;function b(N){return Array.isArray(N)&&N.length>0}t.isNonEmptyArray=b;function S(N,R=z=>z){const z=new Set;return N.filter(T=>{const W=R(T);return z.has(W)?!1:(z.add(W),!0)})}t.distinct=S;function A(N){const R=new Set;return z=>{const T=N(z);return R.has(T)?!1:(R.add(T),!0)}}t.uniqueFilter=A;function C(N,R){const z=r(N,R);if(z!==-1)return N[z]}t.findLast=C;function r(N,R){for(let z=N.length-1;z>=0;z--){const T=N[z];if(R(T))return z}return-1}t.lastIndex=r;function n(N,R){return N.length>0?N[0]:R}t.firstOrDefault=n;function c(N,R){return N.length>0?N[N.length-1]:R}t.lastOrDefault=c;function u(N,R,z=(T,W)=>T===W){let T=0;for(let W=0,k=Math.min(N.length,R.length);W<k&&z(N[W],R[W]);W++)T++;return T}t.commonPrefixLength=u;function h(N){return[].concat(...N)}t.flatten=h;function O(N,R){let z=typeof R=="number"?N:0;typeof R=="number"?z=N:(z=0,R=N);const T=[];if(z<=R)for(let W=z;W<R;W++)T.push(W);else for(let W=z;W>R;W--)T.push(W);return T}t.range=O;function V(N,R,z){return N.reduce((T,W)=>(T[R(W)]=z?z(W):W,T),Object.create(null))}t.index=V;function ue(N,R){return N.push(R),()=>ie(N,R)}t.insert=ue;function ie(N,R){const z=N.indexOf(R);if(z>-1)return N.splice(z,1),R}t.remove=ie;function ge(N,R,z){const T=N.slice(0,R),W=N.slice(R);return T.concat(z,W)}t.arrayInsert=ge;function ae(N,R){let z;if(typeof R=="number"){let T=R;z=()=>{const W=Math.sin(T++)*179426549;return W-Math.floor(W)}}else z=Math.random;for(let T=N.length-1;T>0;T-=1){const W=Math.floor(z()*(T+1)),k=N[T];N[T]=N[W],N[W]=k}}t.shuffle=ae;function we(N,R){const z=N.indexOf(R);z>-1&&(N.splice(z,1),N.unshift(R))}t.pushToStart=we;function ce(N,R){const z=N.indexOf(R);z>-1&&(N.splice(z,1),N.push(R))}t.pushToEnd=ce;function re(N,R){for(const z of R)N.push(z)}t.pushMany=re;function Ce(N,R){return Array.isArray(N)?N.map(R):R(N)}t.mapArrayOrNot=Ce;function Ie(N){return Array.isArray(N)?N:[N]}t.asArray=Ie;function ne(N){return N[Math.floor(Math.random()*N.length)]}t.getRandomElement=ne;function Z(N,R){for(const z of N){const T=R(z);if(T!==void 0)return T}}t.mapFind=Z;function X(N,R,z){const T=te(N,R),W=N.length,k=z.length;N.length=W+k;for(let P=W-1;P>=T;P--)N[P+k]=N[P];for(let P=0;P<k;P++)N[P+T]=z[P]}t.insertInto=X;function se(N,R,z,T){const W=te(N,R),k=N.splice(W,z);return X(N,W,T),k}t.splice=se;function te(N,R){return R<0?Math.max(R+N.length,0):Math.min(R,N.length)}var I;(function(N){function R(W){return W<0}N.isLessThan=R;function z(W){return W>0}N.isGreaterThan=z;function T(W){return W===0}N.isNeitherLessOrGreaterThan=T,N.greaterThan=1,N.lessThan=-1,N.neitherLessOrGreaterThan=0})(I=t.CompareResult||(t.CompareResult={}));function $(N,R){return(z,T)=>R(N(z),N(T))}t.compareBy=$;function j(...N){return(R,z)=>{for(const T of N){const W=T(R,z);if(!I.isNeitherLessOrGreaterThan(W))return W}return I.neitherLessOrGreaterThan}}t.tieBreakComparators=j;const H=(N,R)=>N-R;t.numberComparator=H;function d(N,R){if(N.length===0)return;let z=N[0];for(let T=1;T<N.length;T++){const W=N[T];R(W,z)>0&&(z=W)}return z}t.findMaxBy=d;function L(N,R){if(N.length===0)return;let z=N[0];for(let T=1;T<N.length;T++){const W=N[T];R(W,z)>=0&&(z=W)}return z}t.findLastMaxBy=L;function U(N,R){return d(N,(z,T)=>-R(z,T))}t.findMinBy=U;class K{constructor(R){this.items=R,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(R){let z=this.firstIdx;for(;z<this.items.length&&R(this.items[z]);)z++;const T=z===this.firstIdx?null:this.items.slice(this.firstIdx,z);return this.firstIdx=z,T}takeFromEndWhile(R){let z=this.lastIdx;for(;z>=0&&R(this.items[z]);)z--;const T=z===this.lastIdx?null:this.items.slice(z+1,this.lastIdx+1);return this.lastIdx=z,T}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const R=this.items[this.firstIdx];return this.firstIdx++,R}removeLast(){const R=this.items[this.lastIdx];return this.lastIdx--,R}takeCount(R){const z=this.items.slice(this.firstIdx,this.firstIdx+R);return this.firstIdx+=R,z}}t.ArrayQueue=K;class Q{constructor(R){this.iterate=R}forEach(R){this.iterate(z=>(R(z),!0))}toArray(){const R=[];return this.iterate(z=>(R.push(z),!0)),R}filter(R){return new Q(z=>this.iterate(T=>R(T)?z(T):!0))}map(R){return new Q(z=>this.iterate(T=>z(R(T))))}some(R){let z=!1;return this.iterate(T=>(z=R(T),!z)),z}findFirst(R){let z;return this.iterate(T=>R(T)?(z=T,!1):!0),z}findLast(R){let z;return this.iterate(T=>(R(T)&&(z=T),!0)),z}findLastMaxBy(R){let z,T=!0;return this.iterate(W=>((T||I.isGreaterThan(R(W,z)))&&(T=!1,z=W),!0)),z}}t.CallbackIterable=Q,Q.empty=new Q(N=>{})}),define(me[42],pe([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.once=void 0;function y(i){const B=this;let M=!1,E;return function(){return M||(M=!0,E=i.apply(B,arguments)),E}}t.once=y}),define(me[71],pe([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.defaultGenerator=t.IdGenerator=void 0;class y{constructor(B){this._prefix=B,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}t.IdGenerator=y,t.defaultGenerator=new y("id#")}),define(me[26],pe([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var y;(function(i){function B(A){return A&&typeof A=="object"&&typeof A[Symbol.iterator]=="function"}i.is=B;const M=Object.freeze([]);function E(){return M}i.empty=E;function*w(A){yield A}i.single=w;function m(A){return A||M}i.from=m;function f(A){return!A||A[Symbol.iterator]().next().done===!0}i.isEmpty=f;function g(A){return A[Symbol.iterator]().next().value}i.first=g;function F(A,C){for(const r of A)if(C(r))return!0;return!1}i.some=F;function l(A,C){for(const r of A)if(C(r))return r}i.find=l;function*s(A,C){for(const r of A)C(r)&&(yield r)}i.filter=s;function*e(A,C){let r=0;for(const n of A)yield C(n,r++)}i.map=e;function*p(...A){for(const C of A)for(const r of C)yield r}i.concat=p;function*D(A){for(const C of A)for(const r of C)yield r}i.concatNested=D;function v(A,C,r){let n=r;for(const c of A)n=C(n,c);return n}i.reduce=v;function _(A,C){let r=0;for(const n of A)C(n,r++)}i.forEach=_;function*a(A,C,r=A.length){for(C<0&&(C+=A.length),r<0?r+=A.length:r>A.length&&(r=A.length);C<r;C++)yield A[C]}i.slice=a;function o(A,C=Number.POSITIVE_INFINITY){const r=[];if(C===0)return[r,A];const n=A[Symbol.iterator]();for(let c=0;c<C;c++){const u=n.next();if(u.done)return[r,i.empty()];r.push(u.value)}return[r,{[Symbol.iterator](){return n}}]}i.consume=o;function b(A){return o(A)[0]}i.collect=b;function S(A,C,r=(n,c)=>n===c){const n=A[Symbol.iterator](),c=C[Symbol.iterator]();for(;;){const u=n.next(),h=c.next();if(u.done!==h.done)return!1;if(u.done)return!0;if(!r(u.value,h.value))return!1}}i.equals=S})(y=t.Iterable||(t.Iterable={}))}),define(me[43],pe([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyChord=t.KeyMod=t.KeyCodeUtils=t.IMMUTABLE_KEY_CODE_TO_CODE=t.IMMUTABLE_CODE_TO_KEY_CODE=t.ScanCodeUtils=t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=t.EVENT_KEY_CODE_MAP=t.ScanCode=t.KeyCode=void 0;var y;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.NumLock=78]="NumLock",e[e.ScrollLock=79]="ScrollLock",e[e.Semicolon=80]="Semicolon",e[e.Equal=81]="Equal",e[e.Comma=82]="Comma",e[e.Minus=83]="Minus",e[e.Period=84]="Period",e[e.Slash=85]="Slash",e[e.Backquote=86]="Backquote",e[e.BracketLeft=87]="BracketLeft",e[e.Backslash=88]="Backslash",e[e.BracketRight=89]="BracketRight",e[e.Quote=90]="Quote",e[e.OEM_8=91]="OEM_8",e[e.IntlBackslash=92]="IntlBackslash",e[e.Numpad0=93]="Numpad0",e[e.Numpad1=94]="Numpad1",e[e.Numpad2=95]="Numpad2",e[e.Numpad3=96]="Numpad3",e[e.Numpad4=97]="Numpad4",e[e.Numpad5=98]="Numpad5",e[e.Numpad6=99]="Numpad6",e[e.Numpad7=100]="Numpad7",e[e.Numpad8=101]="Numpad8",e[e.Numpad9=102]="Numpad9",e[e.NumpadMultiply=103]="NumpadMultiply",e[e.NumpadAdd=104]="NumpadAdd",e[e.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=106]="NumpadSubtract",e[e.NumpadDecimal=107]="NumpadDecimal",e[e.NumpadDivide=108]="NumpadDivide",e[e.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",e[e.ABNT_C1=110]="ABNT_C1",e[e.ABNT_C2=111]="ABNT_C2",e[e.AudioVolumeMute=112]="AudioVolumeMute",e[e.AudioVolumeUp=113]="AudioVolumeUp",e[e.AudioVolumeDown=114]="AudioVolumeDown",e[e.BrowserSearch=115]="BrowserSearch",e[e.BrowserHome=116]="BrowserHome",e[e.BrowserBack=117]="BrowserBack",e[e.BrowserForward=118]="BrowserForward",e[e.MediaTrackNext=119]="MediaTrackNext",e[e.MediaTrackPrevious=120]="MediaTrackPrevious",e[e.MediaStop=121]="MediaStop",e[e.MediaPlayPause=122]="MediaPlayPause",e[e.LaunchMediaPlayer=123]="LaunchMediaPlayer",e[e.LaunchMail=124]="LaunchMail",e[e.LaunchApp2=125]="LaunchApp2",e[e.Clear=126]="Clear",e[e.MAX_VALUE=127]="MAX_VALUE"})(y=t.KeyCode||(t.KeyCode={}));var i;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(i=t.ScanCode||(t.ScanCode={}));class B{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(p,D){this._keyCodeToStr[p]=D,this._strToKeyCode[D.toLowerCase()]=p}keyCodeToStr(p){return this._keyCodeToStr[p]}strToKeyCode(p){return this._strToKeyCode[p.toLowerCase()]||0}}const M=new B,E=new B,w=new B;t.EVENT_KEY_CODE_MAP=new Array(230),t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const m=[],f=Object.create(null),g=Object.create(null);t.ScanCodeUtils={lowerCaseToEnum:e=>g[e]||0,toEnum:e=>f[e]||0,toString:e=>m[e]||"None"},t.IMMUTABLE_CODE_TO_KEY_CODE=[],t.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)t.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=127;e++)t.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",p=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[0,1,1,"Hyper",0,e,0,e,e,e],[0,1,2,"Super",0,e,0,e,e,e],[0,1,3,"Fn",0,e,0,e,e,e],[0,1,4,"FnLock",0,e,0,e,e,e],[0,1,5,"Suspend",0,e,0,e,e,e],[0,1,6,"Resume",0,e,0,e,e,e],[0,1,7,"Turbo",0,e,0,e,e,e],[0,1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[0,1,9,"WakeUp",0,e,0,e,e,e],[31,0,10,"KeyA",31,"A",65,"VK_A",e,e],[32,0,11,"KeyB",32,"B",66,"VK_B",e,e],[33,0,12,"KeyC",33,"C",67,"VK_C",e,e],[34,0,13,"KeyD",34,"D",68,"VK_D",e,e],[35,0,14,"KeyE",35,"E",69,"VK_E",e,e],[36,0,15,"KeyF",36,"F",70,"VK_F",e,e],[37,0,16,"KeyG",37,"G",71,"VK_G",e,e],[38,0,17,"KeyH",38,"H",72,"VK_H",e,e],[39,0,18,"KeyI",39,"I",73,"VK_I",e,e],[40,0,19,"KeyJ",40,"J",74,"VK_J",e,e],[41,0,20,"KeyK",41,"K",75,"VK_K",e,e],[42,0,21,"KeyL",42,"L",76,"VK_L",e,e],[43,0,22,"KeyM",43,"M",77,"VK_M",e,e],[44,0,23,"KeyN",44,"N",78,"VK_N",e,e],[45,0,24,"KeyO",45,"O",79,"VK_O",e,e],[46,0,25,"KeyP",46,"P",80,"VK_P",e,e],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[48,0,27,"KeyR",48,"R",82,"VK_R",e,e],[49,0,28,"KeyS",49,"S",83,"VK_S",e,e],[50,0,29,"KeyT",50,"T",84,"VK_T",e,e],[51,0,30,"KeyU",51,"U",85,"VK_U",e,e],[52,0,31,"KeyV",52,"V",86,"VK_V",e,e],[53,0,32,"KeyW",53,"W",87,"VK_W",e,e],[54,0,33,"KeyX",54,"X",88,"VK_X",e,e],[55,0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[22,0,36,"Digit1",22,"1",49,"VK_1",e,e],[23,0,37,"Digit2",23,"2",50,"VK_2",e,e],[24,0,38,"Digit3",24,"3",51,"VK_3",e,e],[25,0,39,"Digit4",25,"4",52,"VK_4",e,e],[26,0,40,"Digit5",26,"5",53,"VK_5",e,e],[27,0,41,"Digit6",27,"6",54,"VK_6",e,e],[28,0,42,"Digit7",28,"7",55,"VK_7",e,e],[29,0,43,"Digit8",29,"8",56,"VK_8",e,e],[30,0,44,"Digit9",30,"9",57,"VK_9",e,e],[21,0,45,"Digit0",21,"0",48,"VK_0",e,e],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[10,1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,e,0,e,e,e],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[59,1,64,"F1",59,"F1",112,"VK_F1",e,e],[60,1,65,"F2",60,"F2",113,"VK_F2",e,e],[61,1,66,"F3",61,"F3",114,"VK_F3",e,e],[62,1,67,"F4",62,"F4",115,"VK_F4",e,e],[63,1,68,"F5",63,"F5",116,"VK_F5",e,e],[64,1,69,"F6",64,"F6",117,"VK_F6",e,e],[65,1,70,"F7",65,"F7",118,"VK_F7",e,e],[66,1,71,"F8",66,"F8",119,"VK_F8",e,e],[67,1,72,"F9",67,"F9",120,"VK_F9",e,e],[68,1,73,"F10",68,"F10",121,"VK_F10",e,e],[69,1,74,"F11",69,"F11",122,"VK_F11",e,e],[70,1,75,"F12",70,"F12",123,"VK_F12",e,e],[0,1,76,"PrintScreen",0,e,0,e,e,e],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",e,e],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[14,1,80,"Home",14,"Home",36,"VK_HOME",e,e],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[13,1,83,"End",13,"End",35,"VK_END",e,e],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",e,e],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",e,e],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",e,e],[3,1,94,"NumpadEnter",3,e,0,e,e,e],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",e,e],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",e,e],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",e,e],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",e,e],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",e,e],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",e,e],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",e,e],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",e,e],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",e,e],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",e,e],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",e,e],[58,1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[0,1,108,"Power",0,e,0,e,e,e],[0,1,109,"NumpadEqual",0,e,0,e,e,e],[71,1,110,"F13",71,"F13",124,"VK_F13",e,e],[72,1,111,"F14",72,"F14",125,"VK_F14",e,e],[73,1,112,"F15",73,"F15",126,"VK_F15",e,e],[74,1,113,"F16",74,"F16",127,"VK_F16",e,e],[75,1,114,"F17",75,"F17",128,"VK_F17",e,e],[76,1,115,"F18",76,"F18",129,"VK_F18",e,e],[77,1,116,"F19",77,"F19",130,"VK_F19",e,e],[0,1,117,"F20",0,e,0,"VK_F20",e,e],[0,1,118,"F21",0,e,0,"VK_F21",e,e],[0,1,119,"F22",0,e,0,"VK_F22",e,e],[0,1,120,"F23",0,e,0,"VK_F23",e,e],[0,1,121,"F24",0,e,0,"VK_F24",e,e],[0,1,122,"Open",0,e,0,e,e,e],[0,1,123,"Help",0,e,0,e,e,e],[0,1,124,"Select",0,e,0,e,e,e],[0,1,125,"Again",0,e,0,e,e,e],[0,1,126,"Undo",0,e,0,e,e,e],[0,1,127,"Cut",0,e,0,e,e,e],[0,1,128,"Copy",0,e,0,e,e,e],[0,1,129,"Paste",0,e,0,e,e,e],[0,1,130,"Find",0,e,0,e,e,e],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",e,e],[0,1,136,"KanaMode",0,e,0,e,e,e],[0,0,137,"IntlYen",0,e,0,e,e,e],[0,1,138,"Convert",0,e,0,e,e,e],[0,1,139,"NonConvert",0,e,0,e,e,e],[0,1,140,"Lang1",0,e,0,e,e,e],[0,1,141,"Lang2",0,e,0,e,e,e],[0,1,142,"Lang3",0,e,0,e,e,e],[0,1,143,"Lang4",0,e,0,e,e,e],[0,1,144,"Lang5",0,e,0,e,e,e],[0,1,145,"Abort",0,e,0,e,e,e],[0,1,146,"Props",0,e,0,e,e,e],[0,1,147,"NumpadParenLeft",0,e,0,e,e,e],[0,1,148,"NumpadParenRight",0,e,0,e,e,e],[0,1,149,"NumpadBackspace",0,e,0,e,e,e],[0,1,150,"NumpadMemoryStore",0,e,0,e,e,e],[0,1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[0,1,152,"NumpadMemoryClear",0,e,0,e,e,e],[0,1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[0,1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[0,1,155,"NumpadClear",126,"Clear",12,"VK_CLEAR",e,e],[0,1,156,"NumpadClearEntry",0,e,0,e,e,e],[5,1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[4,1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[6,1,0,e,6,"Alt",18,"VK_MENU",e,e],[57,1,0,e,57,"Meta",0,"VK_COMMAND",e,e],[5,1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[4,1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[6,1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[57,1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[5,1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[4,1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[6,1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[57,1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[0,1,165,"BrightnessUp",0,e,0,e,e,e],[0,1,166,"BrightnessDown",0,e,0,e,e,e],[0,1,167,"MediaPlay",0,e,0,e,e,e],[0,1,168,"MediaRecord",0,e,0,e,e,e],[0,1,169,"MediaFastForward",0,e,0,e,e,e],[0,1,170,"MediaRewind",0,e,0,e,e,e],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",e,e],[0,1,174,"Eject",0,e,0,e,e,e],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[0,1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[0,1,180,"SelectTask",0,e,0,e,e,e],[0,1,181,"LaunchScreenSaver",0,e,0,e,e,e],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[0,1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[0,1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[0,1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[0,1,189,"ZoomToggle",0,e,0,e,e,e],[0,1,190,"MailReply",0,e,0,e,e,e],[0,1,191,"MailForward",0,e,0,e,e,e],[0,1,192,"MailSend",0,e,0,e,e,e],[109,1,0,e,109,"KeyInComposition",229,e,e,e],[111,1,0,e,111,"ABNT_C2",194,"VK_ABNT_C2",e,e],[91,1,0,e,91,"OEM_8",223,"VK_OEM_8",e,e],[0,1,0,e,0,e,0,"VK_KANA",e,e],[0,1,0,e,0,e,0,"VK_HANGUL",e,e],[0,1,0,e,0,e,0,"VK_JUNJA",e,e],[0,1,0,e,0,e,0,"VK_FINAL",e,e],[0,1,0,e,0,e,0,"VK_HANJA",e,e],[0,1,0,e,0,e,0,"VK_KANJI",e,e],[0,1,0,e,0,e,0,"VK_CONVERT",e,e],[0,1,0,e,0,e,0,"VK_NONCONVERT",e,e],[0,1,0,e,0,e,0,"VK_ACCEPT",e,e],[0,1,0,e,0,e,0,"VK_MODECHANGE",e,e],[0,1,0,e,0,e,0,"VK_SELECT",e,e],[0,1,0,e,0,e,0,"VK_PRINT",e,e],[0,1,0,e,0,e,0,"VK_EXECUTE",e,e],[0,1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[0,1,0,e,0,e,0,"VK_HELP",e,e],[0,1,0,e,0,e,0,"VK_APPS",e,e],[0,1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[0,1,0,e,0,e,0,"VK_PACKET",e,e],[0,1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_ATTN",e,e],[0,1,0,e,0,e,0,"VK_CRSEL",e,e],[0,1,0,e,0,e,0,"VK_EXSEL",e,e],[0,1,0,e,0,e,0,"VK_EREOF",e,e],[0,1,0,e,0,e,0,"VK_PLAY",e,e],[0,1,0,e,0,e,0,"VK_ZOOM",e,e],[0,1,0,e,0,e,0,"VK_NONAME",e,e],[0,1,0,e,0,e,0,"VK_PA1",e,e],[0,1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],D=[],v=[];for(const _ of p){const[a,o,b,S,A,C,r,n,c,u]=_;if(v[b]||(v[b]=!0,m[b]=S,f[S]=b,g[S.toLowerCase()]=b,o&&(t.IMMUTABLE_CODE_TO_KEY_CODE[b]=A,A!==0&&A!==3&&A!==5&&A!==4&&A!==6&&A!==57&&(t.IMMUTABLE_KEY_CODE_TO_CODE[A]=b))),!D[A]){if(D[A]=!0,!C)throw new Error(`String representation missing for key code ${A} around scan code ${S}`);M.define(A,C),E.define(A,c||C),w.define(A,u||c||C)}r&&(t.EVENT_KEY_CODE_MAP[r]=A),n&&(t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[n]=A)}t.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var F;(function(e){function p(b){return M.keyCodeToStr(b)}e.toString=p;function D(b){return M.strToKeyCode(b)}e.fromString=D;function v(b){return E.keyCodeToStr(b)}e.toUserSettingsUS=v;function _(b){return w.keyCodeToStr(b)}e.toUserSettingsGeneral=_;function a(b){return E.strToKeyCode(b)||w.strToKeyCode(b)}e.fromUserSettings=a;function o(b){if(b>=93&&b<=108)return null;switch(b){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return M.keyCodeToStr(b)}e.toElectronAccelerator=o})(F=t.KeyCodeUtils||(t.KeyCodeUtils={}));var l;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(l=t.KeyMod||(t.KeyMod={}));function s(e,p){const D=(p&65535)<<16>>>0;return(e|D)>>>0}t.KeyChord=s}),define(me[72],pe([1,0,13]),function(J,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ResolvedKeybinding=t.ResolvedKeybindingPart=t.ScanCodeBinding=t.ChordKeybinding=t.SimpleKeybinding=t.createSimpleKeybinding=t.createKeybinding=void 0;var i;(function(F){F[F.CtrlCmd=2048]="CtrlCmd",F[F.Shift=1024]="Shift",F[F.Alt=512]="Alt",F[F.WinCtrl=256]="WinCtrl",F[F.KeyCode=255]="KeyCode"})(i||(i={}));function B(F,l){if(F===0)return null;const s=(F&65535)>>>0,e=(F&4294901760)>>>16;return e!==0?new w([M(s,l),M(e,l)]):new w([M(s,l)])}t.createKeybinding=B;function M(F,l){const s=!!(F&2048),e=!!(F&256),p=l===2?e:s,D=!!(F&1024),v=!!(F&512),_=l===2?s:e,a=F&255;return new E(p,D,v,_,a)}t.createSimpleKeybinding=M;class E{constructor(l,s,e,p,D){this.ctrlKey=l,this.shiftKey=s,this.altKey=e,this.metaKey=p,this.keyCode=D}equals(l){return this.ctrlKey===l.ctrlKey&&this.shiftKey===l.shiftKey&&this.altKey===l.altKey&&this.metaKey===l.metaKey&&this.keyCode===l.keyCode}getHashCode(){const l=this.ctrlKey?"1":"0",s=this.shiftKey?"1":"0",e=this.altKey?"1":"0",p=this.metaKey?"1":"0";return`${l}${s}${e}${p}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new w([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}t.SimpleKeybinding=E;class w{constructor(l){if(l.length===0)throw(0,y.illegalArgument)("parts");this.parts=l}getHashCode(){let l="";for(let s=0,e=this.parts.length;s<e;s++)s!==0&&(l+=";"),l+=this.parts[s].getHashCode();return l}equals(l){if(l===null||this.parts.length!==l.parts.length)return!1;for(let s=0;s<this.parts.length;s++)if(!this.parts[s].equals(l.parts[s]))return!1;return!0}}t.ChordKeybinding=w;class m{constructor(l,s,e,p,D){this.ctrlKey=l,this.shiftKey=s,this.altKey=e,this.metaKey=p,this.scanCode=D}equals(l){return this.ctrlKey===l.ctrlKey&&this.shiftKey===l.shiftKey&&this.altKey===l.altKey&&this.metaKey===l.metaKey&&this.scanCode===l.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}t.ScanCodeBinding=m;class f{constructor(l,s,e,p,D,v){this.ctrlKey=l,this.shiftKey=s,this.altKey=e,this.metaKey=p,this.keyLabel=D,this.keyAriaLabel=v}}t.ResolvedKeybindingPart=f;class g{}t.ResolvedKeybinding=g}),define(me[73],pe([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Lazy=void 0;class y{constructor(B){this.executor=B,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(B){this._error=B}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(B){return new y(()=>B(this.getValue()))}}t.Lazy=y}),define(me[2],pe([1,0,42,26]),function(J,t,y,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.disposeOnReturn=t.ImmortalReference=t.AsyncReferenceCollection=t.ReferenceCollection=t.SafeDisposable=t.RefCountedDisposable=t.MutableDisposable=t.Disposable=t.DisposableStore=t.toDisposable=t.combinedDisposable=t.dispose=t.isDisposable=t.MultiDisposeError=t.markAsSingleton=t.setDisposableTracker=void 0;const B=!1;let M=null;function E(n){M=n}if(t.setDisposableTracker=E,B){const n="__is_disposable_tracked__";E(new class{trackDisposable(c){const u=new Error("Potentially leaked disposable").stack;setTimeout(()=>{c[n]||console.log(u)},3e3)}setParent(c,u){if(c&&c!==_.None)try{c[n]=!0}catch{}}markAsDisposed(c){if(c&&c!==_.None)try{c[n]=!0}catch{}}markAsSingleton(c){}})}function w(n){return M?.trackDisposable(n),n}function m(n){M?.markAsDisposed(n)}function f(n,c){M?.setParent(n,c)}function g(n,c){if(!!M)for(const u of n)M.setParent(u,c)}function F(n){return M?.markAsSingleton(n),n}t.markAsSingleton=F;class l extends Error{constructor(c){super(`Encountered errors while disposing of store. Errors: [${c.join(", ")}]`);this.errors=c}}t.MultiDisposeError=l;function s(n){return typeof n.dispose=="function"&&n.dispose.length===0}t.isDisposable=s;function e(n){if(i.Iterable.is(n)){const c=[];for(const u of n)if(u)try{u.dispose()}catch(h){c.push(h)}if(c.length===1)throw c[0];if(c.length>1)throw new l(c);return Array.isArray(n)?[]:n}else if(n)return n.dispose(),n}t.dispose=e;function p(...n){const c=D(()=>e(n));return g(n,c),c}t.combinedDisposable=p;function D(n){const c=w({dispose:(0,y.once)(()=>{m(c),n()})});return c}t.toDisposable=D;class v{constructor(){this._toDispose=new Set,this._isDisposed=!1,w(this)}dispose(){this._isDisposed||(m(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{e(this._toDispose.values())}finally{this._toDispose.clear()}}add(c){if(!c)return c;if(c===this)throw new Error("Cannot register a disposable on itself!");return f(c,this),this._isDisposed?v.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(c),c}}t.DisposableStore=v,v.DISABLE_DISPOSED_WARNING=!1;class _{constructor(){this._store=new v,w(this),f(this._store,this)}dispose(){m(this),this._store.dispose()}_register(c){if(c===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(c)}}t.Disposable=_,_.None=Object.freeze({dispose(){}});class a{constructor(){this._isDisposed=!1,w(this)}get value(){return this._isDisposed?void 0:this._value}set value(c){this._isDisposed||c===this._value||(this._value?.dispose(),c&&f(c,this),this._value=c)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,m(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const c=this._value;return this._value=void 0,c&&f(c,null),c}}t.MutableDisposable=a;class o{constructor(c){this._disposable=c,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}t.RefCountedDisposable=o;class b{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,w(this)}set(c){let u=c;return this.unset=()=>u=void 0,this.isset=()=>u!==void 0,this.dispose=()=>{u&&(u(),u=void 0,m(this))},this}}t.SafeDisposable=b;class S{constructor(){this.references=new Map}acquire(c,...u){let h=this.references.get(c);h||(h={counter:0,object:this.createReferencedObject(c,...u)},this.references.set(c,h));const{object:O}=h,V=(0,y.once)(()=>{--h.counter==0&&(this.destroyReferencedObject(c,h.object),this.references.delete(c))});return h.counter++,{object:O,dispose:V}}}t.ReferenceCollection=S;class A{constructor(c){this.referenceCollection=c}async acquire(c,...u){const h=this.referenceCollection.acquire(c,...u);try{return{object:await h.object,dispose:()=>h.dispose()}}catch(O){throw h.dispose(),O}}}t.AsyncReferenceCollection=A;class C{constructor(c){this.object=c}dispose(){}}t.ImmortalReference=C;function r(n){const c=new v;try{n(c)}finally{c.dispose()}}t.disposeOnReturn=r}),define(me[74],pe([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkedList=void 0;class y{constructor(M){this.element=M,this.next=y.Undefined,this.prev=y.Undefined}}y.Undefined=new y(void 0);class i{constructor(){this._first=y.Undefined,this._last=y.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===y.Undefined}clear(){let M=this._first;for(;M!==y.Undefined;){const E=M.next;M.prev=y.Undefined,M.next=y.Undefined,M=E}this._first=y.Undefined,this._last=y.Undefined,this._size=0}unshift(M){return this._insert(M,!1)}push(M){return this._insert(M,!0)}_insert(M,E){const w=new y(M);if(this._first===y.Undefined)this._first=w,this._last=w;else if(E){const f=this._last;this._last=w,w.prev=f,f.next=w}else{const f=this._first;this._first=w,w.next=f,f.prev=w}this._size+=1;let m=!1;return()=>{m||(m=!0,this._remove(w))}}shift(){if(this._first!==y.Undefined){const M=this._first.element;return this._remove(this._first),M}}pop(){if(this._last!==y.Undefined){const M=this._last.element;return this._remove(this._last),M}}_remove(M){if(M.prev!==y.Undefined&&M.next!==y.Undefined){const E=M.prev;E.next=M.next,M.next.prev=E}else M.prev===y.Undefined&&M.next===y.Undefined?(this._first=y.Undefined,this._last=y.Undefined):M.next===y.Undefined?(this._last=this._last.prev,this._last.next=y.Undefined):M.prev===y.Undefined&&(this._first=this._first.next,this._first.prev=y.Undefined);this._size-=1}*[Symbol.iterator](){let M=this._first;for(;M!==y.Undefined;)yield M.element,M=M.next}}t.LinkedList=i}),function(J,t){typeof exports=="object"&&typeof module!="undefined"?t(exports):typeof define=="function"&&define.amd?define(me[75],pe([0]),t):(J=typeof globalThis!="undefined"?globalThis:J||self,t(J.marked={}))}(this,function(J){"use strict";function t(N,R){for(var z=0;z<R.length;z++){var T=R[z];T.enumerable=T.enumerable||!1,T.configurable=!0,"value"in T&&(T.writable=!0),Object.defineProperty(N,T.key,T)}}function y(N,R,z){return R&&t(N.prototype,R),z&&t(N,z),Object.defineProperty(N,"prototype",{writable:!1}),N}function i(N,R){if(!!N){if(typeof N=="string")return B(N,R);var z=Object.prototype.toString.call(N).slice(8,-1);if(z==="Object"&&N.constructor&&(z=N.constructor.name),z==="Map"||z==="Set")return Array.from(N);if(z==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(z))return B(N,R)}}function B(N,R){(R==null||R>N.length)&&(R=N.length);for(var z=0,T=new Array(R);z<R;z++)T[z]=N[z];return T}function M(N,R){var z=typeof Symbol!="undefined"&&N[Symbol.iterator]||N["@@iterator"];if(z)return(z=z.call(N)).next.bind(z);if(Array.isArray(N)||(z=i(N))||R&&N&&typeof N.length=="number"){z&&(N=z);var T=0;return function(){return T>=N.length?{done:!0}:{done:!1,value:N[T++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function E(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}J.defaults=E();function w(N){J.defaults=N}var m=/[&<>"']/,f=/[&<>"']/g,g=/[<>"']|&(?!#?\w+;)/,F=/[<>"']|&(?!#?\w+;)/g,l={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},s=function(R){return l[R]};function e(N,R){if(R){if(m.test(N))return N.replace(f,s)}else if(g.test(N))return N.replace(F,s);return N}var p=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function D(N){return N.replace(p,function(R,z){return z=z.toLowerCase(),z==="colon"?":":z.charAt(0)==="#"?z.charAt(1)==="x"?String.fromCharCode(parseInt(z.substring(2),16)):String.fromCharCode(+z.substring(1)):""})}var v=/(^|[^\[])\^/g;function _(N,R){N=typeof N=="string"?N:N.source,R=R||"";var z={replace:function(W,k){return k=k.source||k,k=k.replace(v,"$1"),N=N.replace(W,k),z},getRegex:function(){return new RegExp(N,R)}};return z}var a=/[^\w:]/g,o=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function b(N,R,z){if(N){var T;try{T=decodeURIComponent(D(z)).replace(a,"").toLowerCase()}catch{return null}if(T.indexOf("javascript:")===0||T.indexOf("vbscript:")===0||T.indexOf("data:")===0)return null}R&&!o.test(z)&&(z=n(R,z));try{z=encodeURI(z).replace(/%25/g,"%")}catch{return null}return z}var S={},A=/^[^:]+:\/*[^/]*$/,C=/^([^:]+:)[\s\S]*$/,r=/^([^:]+:\/*[^/]*)[\s\S]*$/;function n(N,R){S[" "+N]||(A.test(N)?S[" "+N]=N+"/":S[" "+N]=O(N,"/",!0)),N=S[" "+N];var z=N.indexOf(":")===-1;return R.substring(0,2)==="//"?z?R:N.replace(C,"$1")+R:R.charAt(0)==="/"?z?R:N.replace(r,"$1")+R:N+R}var c={exec:function(){}};function u(N){for(var R=1,z,T;R<arguments.length;R++){z=arguments[R];for(T in z)Object.prototype.hasOwnProperty.call(z,T)&&(N[T]=z[T])}return N}function h(N,R){var z=N.replace(/\|/g,function(k,P,x){for(var ee=!1,he=P;--he>=0&&x[he]==="\\";)ee=!ee;return ee?"|":" |"}),T=z.split(/ \|/),W=0;if(T[0].trim()||T.shift(),T.length>0&&!T[T.length-1].trim()&&T.pop(),T.length>R)T.splice(R);else for(;T.length<R;)T.push("");for(;W<T.length;W++)T[W]=T[W].trim().replace(/\\\|/g,"|");return T}function O(N,R,z){var T=N.length;if(T===0)return"";for(var W=0;W<T;){var k=N.charAt(T-W-1);if(k===R&&!z)W++;else if(k!==R&&z)W++;else break}return N.slice(0,T-W)}function V(N,R){if(N.indexOf(R[1])===-1)return-1;for(var z=N.length,T=0,W=0;W<z;W++)if(N[W]==="\\")W++;else if(N[W]===R[0])T++;else if(N[W]===R[1]&&(T--,T<0))return W;return-1}function ue(N){N&&N.sanitize&&!N.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function ie(N,R){if(R<1)return"";for(var z="";R>1;)R&1&&(z+=N),R>>=1,N+=N;return z+N}function ge(N,R,z,T){var W=R.href,k=R.title?e(R.title):null,P=N[1].replace(/\\([\[\]])/g,"$1");if(N[0].charAt(0)!=="!"){T.state.inLink=!0;var x={type:"link",raw:z,href:W,title:k,text:P,tokens:T.inlineTokens(P,[])};return T.state.inLink=!1,x}return{type:"image",raw:z,href:W,title:k,text:e(P)}}function ae(N,R){var z=N.match(/^(\s+)(?:```)/);if(z===null)return R;var T=z[1];return R.split(`
`).map(function(W){var k=W.match(/^\s+/);if(k===null)return W;var P=k[0];return P.length>=T.length?W.slice(T.length):W}).join(`
`)}var we=function(){function N(z){this.options=z||J.defaults}var R=N.prototype;return R.space=function(T){var W=this.rules.block.newline.exec(T);if(W&&W[0].length>0)return{type:"space",raw:W[0]}},R.code=function(T){var W=this.rules.block.code.exec(T);if(W){var k=W[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:W[0],codeBlockStyle:"indented",text:this.options.pedantic?k:O(k,`
`)}}},R.fences=function(T){var W=this.rules.block.fences.exec(T);if(W){var k=W[0],P=ae(k,W[3]||"");return{type:"code",raw:k,lang:W[2]?W[2].trim():W[2],text:P}}},R.heading=function(T){var W=this.rules.block.heading.exec(T);if(W){var k=W[2].trim();if(/#$/.test(k)){var P=O(k,"#");(this.options.pedantic||!P||/ $/.test(P))&&(k=P.trim())}var x={type:"heading",raw:W[0],depth:W[1].length,text:k,tokens:[]};return this.lexer.inline(x.text,x.tokens),x}},R.hr=function(T){var W=this.rules.block.hr.exec(T);if(W)return{type:"hr",raw:W[0]}},R.blockquote=function(T){var W=this.rules.block.blockquote.exec(T);if(W){var k=W[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:W[0],tokens:this.lexer.blockTokens(k,[]),text:k}}},R.list=function(T){var W=this.rules.block.list.exec(T);if(W){var k,P,x,ee,he,de,De,ye,ke,Fe,ve,Pe,Re=W[1].trim(),Ge=Re.length>1,He={type:"list",raw:"",ordered:Ge,start:Ge?+Re.slice(0,-1):"",loose:!1,items:[]};Re=Ge?"\\d{1,9}\\"+Re.slice(-1):"\\"+Re,this.options.pedantic&&(Re=Ge?Re:"[*+-]");for(var ze=new RegExp("^( {0,3}"+Re+")((?:[	 ][^\\n]*)?(?:\\n|$))");T&&(Pe=!1,!(!(W=ze.exec(T))||this.rules.block.hr.test(T)));){if(k=W[0],T=T.substring(k.length),ye=W[2].split(`
`,1)[0],ke=T.split(`
`,1)[0],this.options.pedantic?(ee=2,ve=ye.trimLeft()):(ee=W[2].search(/[^ ]/),ee=ee>4?1:ee,ve=ye.slice(ee),ee+=W[1].length),de=!1,!ye&&/^ *$/.test(ke)&&(k+=ke+`
`,T=T.substring(ke.length+1),Pe=!0),!Pe)for(var Xe=new RegExp("^ {0,"+Math.min(3,ee-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),je=new RegExp("^ {0,"+Math.min(3,ee-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)");T&&(Fe=T.split(`
`,1)[0],ye=Fe,this.options.pedantic&&(ye=ye.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Xe.test(ye)||je.test(T)));){if(ye.search(/[^ ]/)>=ee||!ye.trim())ve+=`
`+ye.slice(ee);else if(!de)ve+=`
`+ye;else break;!de&&!ye.trim()&&(de=!0),k+=Fe+`
`,T=T.substring(Fe.length+1)}He.loose||(De?He.loose=!0:/\n *\n *$/.test(k)&&(De=!0)),this.options.gfm&&(P=/^\[[ xX]\] /.exec(ve),P&&(x=P[0]!=="[ ] ",ve=ve.replace(/^\[[ xX]\] +/,""))),He.items.push({type:"list_item",raw:k,task:!!P,checked:x,loose:!1,text:ve}),He.raw+=k}He.items[He.items.length-1].raw=k.trimRight(),He.items[He.items.length-1].text=ve.trimRight(),He.raw=He.raw.trimRight();var Oe=He.items.length;for(he=0;he<Oe;he++){this.lexer.state.top=!1,He.items[he].tokens=this.lexer.blockTokens(He.items[he].text,[]);var q=He.items[he].tokens.filter(function(be){return be.type==="space"}),oe=q.every(function(be){for(var Ee=be.raw.split(""),Ae=0,Me=M(Ee),Ve;!(Ve=Me()).done;){var tt=Ve.value;if(tt===`
`&&(Ae+=1),Ae>1)return!0}return!1});!He.loose&&q.length&&oe&&(He.loose=!0,He.items[he].loose=!0)}return He}},R.html=function(T){var W=this.rules.block.html.exec(T);if(W){var k={type:"html",raw:W[0],pre:!this.options.sanitizer&&(W[1]==="pre"||W[1]==="script"||W[1]==="style"),text:W[0]};return this.options.sanitize&&(k.type="paragraph",k.text=this.options.sanitizer?this.options.sanitizer(W[0]):e(W[0]),k.tokens=[],this.lexer.inline(k.text,k.tokens)),k}},R.def=function(T){var W=this.rules.block.def.exec(T);if(W){W[3]&&(W[3]=W[3].substring(1,W[3].length-1));var k=W[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:k,raw:W[0],href:W[2],title:W[3]}}},R.table=function(T){var W=this.rules.block.table.exec(T);if(W){var k={type:"table",header:h(W[1]).map(function(De){return{text:De}}),align:W[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:W[3]&&W[3].trim()?W[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(k.header.length===k.align.length){k.raw=W[0];var P=k.align.length,x,ee,he,de;for(x=0;x<P;x++)/^ *-+: *$/.test(k.align[x])?k.align[x]="right":/^ *:-+: *$/.test(k.align[x])?k.align[x]="center":/^ *:-+ *$/.test(k.align[x])?k.align[x]="left":k.align[x]=null;for(P=k.rows.length,x=0;x<P;x++)k.rows[x]=h(k.rows[x],k.header.length).map(function(De){return{text:De}});for(P=k.header.length,ee=0;ee<P;ee++)k.header[ee].tokens=[],this.lexer.inline(k.header[ee].text,k.header[ee].tokens);for(P=k.rows.length,ee=0;ee<P;ee++)for(de=k.rows[ee],he=0;he<de.length;he++)de[he].tokens=[],this.lexer.inline(de[he].text,de[he].tokens);return k}}},R.lheading=function(T){var W=this.rules.block.lheading.exec(T);if(W){var k={type:"heading",raw:W[0],depth:W[2].charAt(0)==="="?1:2,text:W[1],tokens:[]};return this.lexer.inline(k.text,k.tokens),k}},R.paragraph=function(T){var W=this.rules.block.paragraph.exec(T);if(W){var k={type:"paragraph",raw:W[0],text:W[1].charAt(W[1].length-1)===`
`?W[1].slice(0,-1):W[1],tokens:[]};return this.lexer.inline(k.text,k.tokens),k}},R.text=function(T){var W=this.rules.block.text.exec(T);if(W){var k={type:"text",raw:W[0],text:W[0],tokens:[]};return this.lexer.inline(k.text,k.tokens),k}},R.escape=function(T){var W=this.rules.inline.escape.exec(T);if(W)return{type:"escape",raw:W[0],text:e(W[1])}},R.tag=function(T){var W=this.rules.inline.tag.exec(T);if(W)return!this.lexer.state.inLink&&/^<a /i.test(W[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(W[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(W[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(W[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:W[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(W[0]):e(W[0]):W[0]}},R.link=function(T){var W=this.rules.inline.link.exec(T);if(W){var k=W[2].trim();if(!this.options.pedantic&&/^</.test(k)){if(!/>$/.test(k))return;var P=O(k.slice(0,-1),"\\");if((k.length-P.length)%2==0)return}else{var x=V(W[2],"()");if(x>-1){var ee=W[0].indexOf("!")===0?5:4,he=ee+W[1].length+x;W[2]=W[2].substring(0,x),W[0]=W[0].substring(0,he).trim(),W[3]=""}}var de=W[2],De="";if(this.options.pedantic){var ye=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(de);ye&&(de=ye[1],De=ye[3])}else De=W[3]?W[3].slice(1,-1):"";return de=de.trim(),/^</.test(de)&&(this.options.pedantic&&!/>$/.test(k)?de=de.slice(1):de=de.slice(1,-1)),ge(W,{href:de&&de.replace(this.rules.inline._escapes,"$1"),title:De&&De.replace(this.rules.inline._escapes,"$1")},W[0],this.lexer)}},R.reflink=function(T,W){var k;if((k=this.rules.inline.reflink.exec(T))||(k=this.rules.inline.nolink.exec(T))){var P=(k[2]||k[1]).replace(/\s+/g," ");if(P=W[P.toLowerCase()],!P||!P.href){var x=k[0].charAt(0);return{type:"text",raw:x,text:x}}return ge(k,P,k[0],this.lexer)}},R.emStrong=function(T,W,k){k===void 0&&(k="");var P=this.rules.inline.emStrong.lDelim.exec(T);if(!!P&&!(P[3]&&k.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var x=P[1]||P[2]||"";if(!x||x&&(k===""||this.rules.inline.punctuation.exec(k))){var ee=P[0].length-1,he,de,De=ee,ye=0,ke=P[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ke.lastIndex=0,W=W.slice(-1*T.length+ee);(P=ke.exec(W))!=null;)if(he=P[1]||P[2]||P[3]||P[4]||P[5]||P[6],!!he){if(de=he.length,P[3]||P[4]){De+=de;continue}else if((P[5]||P[6])&&ee%3&&!((ee+de)%3)){ye+=de;continue}if(De-=de,!(De>0)){if(de=Math.min(de,de+De+ye),Math.min(ee,de)%2){var Fe=T.slice(1,ee+P.index+de);return{type:"em",raw:T.slice(0,ee+P.index+de+1),text:Fe,tokens:this.lexer.inlineTokens(Fe,[])}}var ve=T.slice(2,ee+P.index+de-1);return{type:"strong",raw:T.slice(0,ee+P.index+de+1),text:ve,tokens:this.lexer.inlineTokens(ve,[])}}}}}},R.codespan=function(T){var W=this.rules.inline.code.exec(T);if(W){var k=W[2].replace(/\n/g," "),P=/[^ ]/.test(k),x=/^ /.test(k)&&/ $/.test(k);return P&&x&&(k=k.substring(1,k.length-1)),k=e(k,!0),{type:"codespan",raw:W[0],text:k}}},R.br=function(T){var W=this.rules.inline.br.exec(T);if(W)return{type:"br",raw:W[0]}},R.del=function(T){var W=this.rules.inline.del.exec(T);if(W)return{type:"del",raw:W[0],text:W[2],tokens:this.lexer.inlineTokens(W[2],[])}},R.autolink=function(T,W){var k=this.rules.inline.autolink.exec(T);if(k){var P,x;return k[2]==="@"?(P=e(this.options.mangle?W(k[1]):k[1]),x="mailto:"+P):(P=e(k[1]),x=P),{type:"link",raw:k[0],text:P,href:x,tokens:[{type:"text",raw:P,text:P}]}}},R.url=function(T,W){var k;if(k=this.rules.inline.url.exec(T)){var P,x;if(k[2]==="@")P=e(this.options.mangle?W(k[0]):k[0]),x="mailto:"+P;else{var ee;do ee=k[0],k[0]=this.rules.inline._backpedal.exec(k[0])[0];while(ee!==k[0]);P=e(k[0]),k[1]==="www."?x="http://"+P:x=P}return{type:"link",raw:k[0],text:P,href:x,tokens:[{type:"text",raw:P,text:P}]}}},R.inlineText=function(T,W){var k=this.rules.inline.text.exec(T);if(k){var P;return this.lexer.state.inRawBlock?P=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(k[0]):e(k[0]):k[0]:P=e(this.options.smartypants?W(k[0]):k[0]),{type:"text",raw:k[0],text:P}}},N}(),ce={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:c,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};ce._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,ce._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,ce.def=_(ce.def).replace("label",ce._label).replace("title",ce._title).getRegex(),ce.bullet=/(?:[*+-]|\d{1,9}[.)])/,ce.listItemStart=_(/^( *)(bull) */).replace("bull",ce.bullet).getRegex(),ce.list=_(ce.list).replace(/bull/g,ce.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+ce.def.source+")").getRegex(),ce._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",ce._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,ce.html=_(ce.html,"i").replace("comment",ce._comment).replace("tag",ce._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),ce.paragraph=_(ce._paragraph).replace("hr",ce.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ce._tag).getRegex(),ce.blockquote=_(ce.blockquote).replace("paragraph",ce.paragraph).getRegex(),ce.normal=u({},ce),ce.gfm=u({},ce.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),ce.gfm.table=_(ce.gfm.table).replace("hr",ce.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ce._tag).getRegex(),ce.gfm.paragraph=_(ce._paragraph).replace("hr",ce.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",ce.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ce._tag).getRegex(),ce.pedantic=u({},ce.normal,{html:_(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",ce._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:c,paragraph:_(ce.normal._paragraph).replace("hr",ce.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",ce.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var re={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:c,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:c,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};re._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",re.punctuation=_(re.punctuation).replace(/punctuation/g,re._punctuation).getRegex(),re.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,re.escapedEmSt=/\\\*|\\_/g,re._comment=_(ce._comment).replace("(?:-->|$)","-->").getRegex(),re.emStrong.lDelim=_(re.emStrong.lDelim).replace(/punct/g,re._punctuation).getRegex(),re.emStrong.rDelimAst=_(re.emStrong.rDelimAst,"g").replace(/punct/g,re._punctuation).getRegex(),re.emStrong.rDelimUnd=_(re.emStrong.rDelimUnd,"g").replace(/punct/g,re._punctuation).getRegex(),re._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,re._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,re._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,re.autolink=_(re.autolink).replace("scheme",re._scheme).replace("email",re._email).getRegex(),re._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,re.tag=_(re.tag).replace("comment",re._comment).replace("attribute",re._attribute).getRegex(),re._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,re._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,re._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,re.link=_(re.link).replace("label",re._label).replace("href",re._href).replace("title",re._title).getRegex(),re.reflink=_(re.reflink).replace("label",re._label).replace("ref",ce._label).getRegex(),re.nolink=_(re.nolink).replace("ref",ce._label).getRegex(),re.reflinkSearch=_(re.reflinkSearch,"g").replace("reflink",re.reflink).replace("nolink",re.nolink).getRegex(),re.normal=u({},re),re.pedantic=u({},re.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:_(/^!?\[(label)\]\((.*?)\)/).replace("label",re._label).getRegex(),reflink:_(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",re._label).getRegex()}),re.gfm=u({},re.normal,{escape:_(re.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),re.gfm.url=_(re.gfm.url,"i").replace("email",re.gfm._extended_email).getRegex(),re.breaks=u({},re.gfm,{br:_(re.br).replace("{2,}","*").getRegex(),text:_(re.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function Ce(N){return N.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Ie(N){var R="",z,T,W=N.length;for(z=0;z<W;z++)T=N.charCodeAt(z),Math.random()>.5&&(T="x"+T.toString(16)),R+="&#"+T+";";return R}var ne=function(){function N(z){this.tokens=[],this.tokens.links=Object.create(null),this.options=z||J.defaults,this.options.tokenizer=this.options.tokenizer||new we,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var T={block:ce.normal,inline:re.normal};this.options.pedantic?(T.block=ce.pedantic,T.inline=re.pedantic):this.options.gfm&&(T.block=ce.gfm,this.options.breaks?T.inline=re.breaks:T.inline=re.gfm),this.tokenizer.rules=T}N.lex=function(T,W){var k=new N(W);return k.lex(T)},N.lexInline=function(T,W){var k=new N(W);return k.inlineTokens(T)};var R=N.prototype;return R.lex=function(T){T=T.replace(/\r\n|\r/g,`
`),this.blockTokens(T,this.tokens);for(var W;W=this.inlineQueue.shift();)this.inlineTokens(W.src,W.tokens);return this.tokens},R.blockTokens=function(T,W){var k=this;W===void 0&&(W=[]),this.options.pedantic?T=T.replace(/\t/g,"    ").replace(/^ +$/gm,""):T=T.replace(/^( *)(\t+)/gm,function(De,ye,ke){return ye+"    ".repeat(ke.length)});for(var P,x,ee,he;T;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(De){return(P=De.call({lexer:k},T,W))?(T=T.substring(P.raw.length),W.push(P),!0):!1}))){if(P=this.tokenizer.space(T)){T=T.substring(P.raw.length),P.raw.length===1&&W.length>0?W[W.length-1].raw+=`
`:W.push(P);continue}if(P=this.tokenizer.code(T)){T=T.substring(P.raw.length),x=W[W.length-1],x&&(x.type==="paragraph"||x.type==="text")?(x.raw+=`
`+P.raw,x.text+=`
`+P.text,this.inlineQueue[this.inlineQueue.length-1].src=x.text):W.push(P);continue}if(P=this.tokenizer.fences(T)){T=T.substring(P.raw.length),W.push(P);continue}if(P=this.tokenizer.heading(T)){T=T.substring(P.raw.length),W.push(P);continue}if(P=this.tokenizer.hr(T)){T=T.substring(P.raw.length),W.push(P);continue}if(P=this.tokenizer.blockquote(T)){T=T.substring(P.raw.length),W.push(P);continue}if(P=this.tokenizer.list(T)){T=T.substring(P.raw.length),W.push(P);continue}if(P=this.tokenizer.html(T)){T=T.substring(P.raw.length),W.push(P);continue}if(P=this.tokenizer.def(T)){T=T.substring(P.raw.length),x=W[W.length-1],x&&(x.type==="paragraph"||x.type==="text")?(x.raw+=`
`+P.raw,x.text+=`
`+P.raw,this.inlineQueue[this.inlineQueue.length-1].src=x.text):this.tokens.links[P.tag]||(this.tokens.links[P.tag]={href:P.href,title:P.title});continue}if(P=this.tokenizer.table(T)){T=T.substring(P.raw.length),W.push(P);continue}if(P=this.tokenizer.lheading(T)){T=T.substring(P.raw.length),W.push(P);continue}if(ee=T,this.options.extensions&&this.options.extensions.startBlock&&function(){var De=1/0,ye=T.slice(1),ke=void 0;k.options.extensions.startBlock.forEach(function(Fe){ke=Fe.call({lexer:this},ye),typeof ke=="number"&&ke>=0&&(De=Math.min(De,ke))}),De<1/0&&De>=0&&(ee=T.substring(0,De+1))}(),this.state.top&&(P=this.tokenizer.paragraph(ee))){x=W[W.length-1],he&&x.type==="paragraph"?(x.raw+=`
`+P.raw,x.text+=`
`+P.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=x.text):W.push(P),he=ee.length!==T.length,T=T.substring(P.raw.length);continue}if(P=this.tokenizer.text(T)){T=T.substring(P.raw.length),x=W[W.length-1],x&&x.type==="text"?(x.raw+=`
`+P.raw,x.text+=`
`+P.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=x.text):W.push(P);continue}if(T){var de="Infinite loop on byte: "+T.charCodeAt(0);if(this.options.silent){console.error(de);break}else throw new Error(de)}}return this.state.top=!0,W},R.inline=function(T,W){this.inlineQueue.push({src:T,tokens:W})},R.inlineTokens=function(T,W){var k=this;W===void 0&&(W=[]);var P,x,ee,he=T,de,De,ye;if(this.tokens.links){var ke=Object.keys(this.tokens.links);if(ke.length>0)for(;(de=this.tokenizer.rules.inline.reflinkSearch.exec(he))!=null;)ke.includes(de[0].slice(de[0].lastIndexOf("[")+1,-1))&&(he=he.slice(0,de.index)+"["+ie("a",de[0].length-2)+"]"+he.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(de=this.tokenizer.rules.inline.blockSkip.exec(he))!=null;)he=he.slice(0,de.index)+"["+ie("a",de[0].length-2)+"]"+he.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(de=this.tokenizer.rules.inline.escapedEmSt.exec(he))!=null;)he=he.slice(0,de.index)+"++"+he.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;T;)if(De||(ye=""),De=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ve){return(P=ve.call({lexer:k},T,W))?(T=T.substring(P.raw.length),W.push(P),!0):!1}))){if(P=this.tokenizer.escape(T)){T=T.substring(P.raw.length),W.push(P);continue}if(P=this.tokenizer.tag(T)){T=T.substring(P.raw.length),x=W[W.length-1],x&&P.type==="text"&&x.type==="text"?(x.raw+=P.raw,x.text+=P.text):W.push(P);continue}if(P=this.tokenizer.link(T)){T=T.substring(P.raw.length),W.push(P);continue}if(P=this.tokenizer.reflink(T,this.tokens.links)){T=T.substring(P.raw.length),x=W[W.length-1],x&&P.type==="text"&&x.type==="text"?(x.raw+=P.raw,x.text+=P.text):W.push(P);continue}if(P=this.tokenizer.emStrong(T,he,ye)){T=T.substring(P.raw.length),W.push(P);continue}if(P=this.tokenizer.codespan(T)){T=T.substring(P.raw.length),W.push(P);continue}if(P=this.tokenizer.br(T)){T=T.substring(P.raw.length),W.push(P);continue}if(P=this.tokenizer.del(T)){T=T.substring(P.raw.length),W.push(P);continue}if(P=this.tokenizer.autolink(T,Ie)){T=T.substring(P.raw.length),W.push(P);continue}if(!this.state.inLink&&(P=this.tokenizer.url(T,Ie))){T=T.substring(P.raw.length),W.push(P);continue}if(ee=T,this.options.extensions&&this.options.extensions.startInline&&function(){var ve=1/0,Pe=T.slice(1),Re=void 0;k.options.extensions.startInline.forEach(function(Ge){Re=Ge.call({lexer:this},Pe),typeof Re=="number"&&Re>=0&&(ve=Math.min(ve,Re))}),ve<1/0&&ve>=0&&(ee=T.substring(0,ve+1))}(),P=this.tokenizer.inlineText(ee,Ce)){T=T.substring(P.raw.length),P.raw.slice(-1)!=="_"&&(ye=P.raw.slice(-1)),De=!0,x=W[W.length-1],x&&x.type==="text"?(x.raw+=P.raw,x.text+=P.text):W.push(P);continue}if(T){var Fe="Infinite loop on byte: "+T.charCodeAt(0);if(this.options.silent){console.error(Fe);break}else throw new Error(Fe)}}return W},y(N,null,[{key:"rules",get:function(){return{block:ce,inline:re}}}]),N}(),Z=function(){function N(z){this.options=z||J.defaults}var R=N.prototype;return R.code=function(T,W,k){var P=(W||"").match(/\S*/)[0];if(this.options.highlight){var x=this.options.highlight(T,P);x!=null&&x!==T&&(k=!0,T=x)}return T=T.replace(/\n$/,"")+`
`,P?'<pre><code class="'+this.options.langPrefix+e(P,!0)+'">'+(k?T:e(T,!0))+`</code></pre>
`:"<pre><code>"+(k?T:e(T,!0))+`</code></pre>
`},R.blockquote=function(T){return`<blockquote>
`+T+`</blockquote>
`},R.html=function(T){return T},R.heading=function(T,W,k,P){if(this.options.headerIds){var x=this.options.headerPrefix+P.slug(k);return"<h"+W+' id="'+x+'">'+T+"</h"+W+`>
`}return"<h"+W+">"+T+"</h"+W+`>
`},R.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},R.list=function(T,W,k){var P=W?"ol":"ul",x=W&&k!==1?' start="'+k+'"':"";return"<"+P+x+`>
`+T+"</"+P+`>
`},R.listitem=function(T){return"<li>"+T+`</li>
`},R.checkbox=function(T){return"<input "+(T?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},R.paragraph=function(T){return"<p>"+T+`</p>
`},R.table=function(T,W){return W&&(W="<tbody>"+W+"</tbody>"),`<table>
<thead>
`+T+`</thead>
`+W+`</table>
`},R.tablerow=function(T){return`<tr>
`+T+`</tr>
`},R.tablecell=function(T,W){var k=W.header?"th":"td",P=W.align?"<"+k+' align="'+W.align+'">':"<"+k+">";return P+T+("</"+k+`>
`)},R.strong=function(T){return"<strong>"+T+"</strong>"},R.em=function(T){return"<em>"+T+"</em>"},R.codespan=function(T){return"<code>"+T+"</code>"},R.br=function(){return this.options.xhtml?"<br/>":"<br>"},R.del=function(T){return"<del>"+T+"</del>"},R.link=function(T,W,k){if(T=b(this.options.sanitize,this.options.baseUrl,T),T===null)return k;var P='<a href="'+e(T)+'"';return W&&(P+=' title="'+W+'"'),P+=">"+k+"</a>",P},R.image=function(T,W,k){if(T=b(this.options.sanitize,this.options.baseUrl,T),T===null)return k;var P='<img src="'+T+'" alt="'+k+'"';return W&&(P+=' title="'+W+'"'),P+=this.options.xhtml?"/>":">",P},R.text=function(T){return T},N}(),X=function(){function N(){}var R=N.prototype;return R.strong=function(T){return T},R.em=function(T){return T},R.codespan=function(T){return T},R.del=function(T){return T},R.html=function(T){return T},R.text=function(T){return T},R.link=function(T,W,k){return""+k},R.image=function(T,W,k){return""+k},R.br=function(){return""},N}(),se=function(){function N(){this.seen={}}var R=N.prototype;return R.serialize=function(T){return T.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},R.getNextSafeSlug=function(T,W){var k=T,P=0;if(this.seen.hasOwnProperty(k)){P=this.seen[T];do P++,k=T+"-"+P;while(this.seen.hasOwnProperty(k))}return W||(this.seen[T]=P,this.seen[k]=0),k},R.slug=function(T,W){W===void 0&&(W={});var k=this.serialize(T);return this.getNextSafeSlug(k,W.dryrun)},N}(),te=function(){function N(z){this.options=z||J.defaults,this.options.renderer=this.options.renderer||new Z,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new X,this.slugger=new se}N.parse=function(T,W){var k=new N(W);return k.parse(T)},N.parseInline=function(T,W){var k=new N(W);return k.parseInline(T)};var R=N.prototype;return R.parse=function(T,W){W===void 0&&(W=!0);var k="",P,x,ee,he,de,De,ye,ke,Fe,ve,Pe,Re,Ge,He,ze,Xe,je,Oe,q,oe=T.length;for(P=0;P<oe;P++){if(ve=T[P],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ve.type]&&(q=this.options.extensions.renderers[ve.type].call({parser:this},ve),q!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ve.type))){k+=q||"";continue}switch(ve.type){case"space":continue;case"hr":{k+=this.renderer.hr();continue}case"heading":{k+=this.renderer.heading(this.parseInline(ve.tokens),ve.depth,D(this.parseInline(ve.tokens,this.textRenderer)),this.slugger);continue}case"code":{k+=this.renderer.code(ve.text,ve.lang,ve.escaped);continue}case"table":{for(ke="",ye="",he=ve.header.length,x=0;x<he;x++)ye+=this.renderer.tablecell(this.parseInline(ve.header[x].tokens),{header:!0,align:ve.align[x]});for(ke+=this.renderer.tablerow(ye),Fe="",he=ve.rows.length,x=0;x<he;x++){for(De=ve.rows[x],ye="",de=De.length,ee=0;ee<de;ee++)ye+=this.renderer.tablecell(this.parseInline(De[ee].tokens),{header:!1,align:ve.align[ee]});Fe+=this.renderer.tablerow(ye)}k+=this.renderer.table(ke,Fe);continue}case"blockquote":{Fe=this.parse(ve.tokens),k+=this.renderer.blockquote(Fe);continue}case"list":{for(Pe=ve.ordered,Re=ve.start,Ge=ve.loose,he=ve.items.length,Fe="",x=0;x<he;x++)ze=ve.items[x],Xe=ze.checked,je=ze.task,He="",ze.task&&(Oe=this.renderer.checkbox(Xe),Ge?ze.tokens.length>0&&ze.tokens[0].type==="paragraph"?(ze.tokens[0].text=Oe+" "+ze.tokens[0].text,ze.tokens[0].tokens&&ze.tokens[0].tokens.length>0&&ze.tokens[0].tokens[0].type==="text"&&(ze.tokens[0].tokens[0].text=Oe+" "+ze.tokens[0].tokens[0].text)):ze.tokens.unshift({type:"text",text:Oe}):He+=Oe),He+=this.parse(ze.tokens,Ge),Fe+=this.renderer.listitem(He,je,Xe);k+=this.renderer.list(Fe,Pe,Re);continue}case"html":{k+=this.renderer.html(ve.text);continue}case"paragraph":{k+=this.renderer.paragraph(this.parseInline(ve.tokens));continue}case"text":{for(Fe=ve.tokens?this.parseInline(ve.tokens):ve.text;P+1<oe&&T[P+1].type==="text";)ve=T[++P],Fe+=`
`+(ve.tokens?this.parseInline(ve.tokens):ve.text);k+=W?this.renderer.paragraph(Fe):Fe;continue}default:{var be='Token with "'+ve.type+'" type was not found.';if(this.options.silent){console.error(be);return}else throw new Error(be)}}}return k},R.parseInline=function(T,W){W=W||this.renderer;var k="",P,x,ee,he=T.length;for(P=0;P<he;P++){if(x=T[P],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[x.type]&&(ee=this.options.extensions.renderers[x.type].call({parser:this},x),ee!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(x.type))){k+=ee||"";continue}switch(x.type){case"escape":{k+=W.text(x.text);break}case"html":{k+=W.html(x.text);break}case"link":{k+=W.link(x.href,x.title,this.parseInline(x.tokens,W));break}case"image":{k+=W.image(x.href,x.title,x.text);break}case"strong":{k+=W.strong(this.parseInline(x.tokens,W));break}case"em":{k+=W.em(this.parseInline(x.tokens,W));break}case"codespan":{k+=W.codespan(x.text);break}case"br":{k+=W.br();break}case"del":{k+=W.del(this.parseInline(x.tokens,W));break}case"text":{k+=W.text(x.text);break}default:{var de='Token with "'+x.type+'" type was not found.';if(this.options.silent){console.error(de);return}else throw new Error(de)}}}return k},N}();function I(N,R,z){if(typeof N=="undefined"||N===null)throw new Error("marked(): input parameter is undefined or null");if(typeof N!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(N)+", string expected");if(typeof R=="function"&&(z=R,R=null),R=u({},I.defaults,R||{}),ue(R),z){var T=R.highlight,W;try{W=ne.lex(N,R)}catch(ee){return z(ee)}var k=function(he){var de;if(!he)try{R.walkTokens&&I.walkTokens(W,R.walkTokens),de=te.parse(W,R)}catch(De){he=De}return R.highlight=T,he?z(he):z(null,de)};if(!T||T.length<3||(delete R.highlight,!W.length))return k();var P=0;I.walkTokens(W,function(ee){ee.type==="code"&&(P++,setTimeout(function(){T(ee.text,ee.lang,function(he,de){if(he)return k(he);de!=null&&de!==ee.text&&(ee.text=de,ee.escaped=!0),P--,P===0&&k()})},0))}),P===0&&k();return}try{var x=ne.lex(N,R);return R.walkTokens&&I.walkTokens(x,R.walkTokens),te.parse(x,R)}catch(ee){if(ee.message+=`
Please report this to https://github.com/markedjs/marked.`,R.silent)return"<p>An error occurred:</p><pre>"+e(ee.message+"",!0)+"</pre>";throw ee}}I.options=I.setOptions=function(N){return u(I.defaults,N),w(I.defaults),I},I.getDefaults=E,I.defaults=J.defaults,I.use=function(){for(var N=arguments.length,R=new Array(N),z=0;z<N;z++)R[z]=arguments[z];var T=u.apply(void 0,[{}].concat(R)),W=I.defaults.extensions||{renderers:{},childTokens:{}},k;R.forEach(function(P){if(P.extensions&&(k=!0,P.extensions.forEach(function(ee){if(!ee.name)throw new Error("extension name required");if(ee.renderer){var he=W.renderers?W.renderers[ee.name]:null;he?W.renderers[ee.name]=function(){for(var de=arguments.length,De=new Array(de),ye=0;ye<de;ye++)De[ye]=arguments[ye];var ke=ee.renderer.apply(this,De);return ke===!1&&(ke=he.apply(this,De)),ke}:W.renderers[ee.name]=ee.renderer}if(ee.tokenizer){if(!ee.level||ee.level!=="block"&&ee.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");W[ee.level]?W[ee.level].unshift(ee.tokenizer):W[ee.level]=[ee.tokenizer],ee.start&&(ee.level==="block"?W.startBlock?W.startBlock.push(ee.start):W.startBlock=[ee.start]:ee.level==="inline"&&(W.startInline?W.startInline.push(ee.start):W.startInline=[ee.start]))}ee.childTokens&&(W.childTokens[ee.name]=ee.childTokens)})),P.renderer&&function(){var ee=I.defaults.renderer||new Z,he=function(ye){var ke=ee[ye];ee[ye]=function(){for(var Fe=arguments.length,ve=new Array(Fe),Pe=0;Pe<Fe;Pe++)ve[Pe]=arguments[Pe];var Re=P.renderer[ye].apply(ee,ve);return Re===!1&&(Re=ke.apply(ee,ve)),Re}};for(var de in P.renderer)he(de);T.renderer=ee}(),P.tokenizer&&function(){var ee=I.defaults.tokenizer||new we,he=function(ye){var ke=ee[ye];ee[ye]=function(){for(var Fe=arguments.length,ve=new Array(Fe),Pe=0;Pe<Fe;Pe++)ve[Pe]=arguments[Pe];var Re=P.tokenizer[ye].apply(ee,ve);return Re===!1&&(Re=ke.apply(ee,ve)),Re}};for(var de in P.tokenizer)he(de);T.tokenizer=ee}(),P.walkTokens){var x=I.defaults.walkTokens;T.walkTokens=function(ee){P.walkTokens.call(this,ee),x&&x.call(this,ee)}}k&&(T.extensions=W),I.setOptions(T)})},I.walkTokens=function(N,R){for(var z=function(){var P=W.value;switch(R.call(I,P),P.type){case"table":{for(var x=M(P.header),ee;!(ee=x()).done;){var he=ee.value;I.walkTokens(he.tokens,R)}for(var de=M(P.rows),De;!(De=de()).done;)for(var ye=De.value,ke=M(ye),Fe;!(Fe=ke()).done;){var ve=Fe.value;I.walkTokens(ve.tokens,R)}break}case"list":{I.walkTokens(P.items,R);break}default:I.defaults.extensions&&I.defaults.extensions.childTokens&&I.defaults.extensions.childTokens[P.type]?I.defaults.extensions.childTokens[P.type].forEach(function(Pe){I.walkTokens(P[Pe],R)}):P.tokens&&I.walkTokens(P.tokens,R)}},T=M(N),W;!(W=T()).done;)z()},I.parseInline=function(N,R){if(typeof N=="undefined"||N===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof N!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(N)+", string expected");R=u({},I.defaults,R||{}),ue(R);try{var z=ne.lexInline(N,R);return R.walkTokens&&I.walkTokens(z,R.walkTokens),te.parseInline(z,R)}catch(T){if(T.message+=`
Please report this to https://github.com/markedjs/marked.`,R.silent)return"<p>An error occurred:</p><pre>"+e(T.message+"",!0)+"</pre>";throw T}},I.Parser=te,I.parser=te.parse,I.Renderer=Z,I.TextRenderer=X,I.Lexer=ne,I.lexer=ne.lex,I.Tokenizer=we,I.Slugger=se,I.parse=I;var $=I.options,j=I.setOptions,H=I.use,d=I.walkTokens,L=I.parseInline,U=I,K=te.parse,Q=ne.lex;J.Lexer=ne,J.Parser=te,J.Renderer=Z,J.Slugger=se,J.TextRenderer=X,J.Tokenizer=we,J.getDefaults=E,J.lexer=Q,J.marked=I,J.options=$,J.parse=U,J.parseInline=L,J.parser=K,J.setOptions=j,J.use=H,J.walkTokens=d,Object.defineProperty(J,"__esModule",{value:!0})}),define(me[76],pe([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ArrayNavigator=void 0;class y{constructor(B,M=0,E=B.length,w=M-1){this.items=B,this.start=M,this.end=E,this.index=w}current(){return this.index===this.start-1||this.index===this.end?null:this.items[this.index]}next(){return this.index=Math.min(this.index+1,this.end),this.current()}previous(){return this.index=Math.max(this.index-1,this.start-1),this.current()}first(){return this.index=this.start,this.current()}last(){return this.index=this.end-1,this.current()}}t.ArrayNavigator=y}),define(me[77],pe([1,0,76]),function(J,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HistoryNavigator2=t.HistoryNavigator=void 0;class i{constructor(E=[],w=10){this._initialize(E),this._limit=w,this._onChange()}getHistory(){return this._elements}add(E){this._history.delete(E),this._history.add(E),this._onChange()}next(){return this._currentPosition()!==this._elements.length-1?this._navigator.next():null}previous(){return this._currentPosition()!==0?this._navigator.previous():null}current(){return this._navigator.current()}first(){return this._navigator.first()}last(){return this._navigator.last()}has(E){return this._history.has(E)}clear(){this._initialize([]),this._onChange()}_onChange(){this._reduceToLimit();const E=this._elements;this._navigator=new y.ArrayNavigator(E,0,E.length,E.length)}_reduceToLimit(){const E=this._elements;E.length>this._limit&&this._initialize(E.slice(E.length-this._limit))}_currentPosition(){const E=this._navigator.current();return E?this._elements.indexOf(E):-1}_initialize(E){this._history=new Set;for(const w of E)this._history.add(w)}get _elements(){const E=[];return this._history.forEach(w=>E.push(w)),E}}t.HistoryNavigator=i;class B{constructor(E,w=10){if(this.capacity=w,E.length<1)throw new Error("not supported");this.size=1,this.head=this.tail=this.cursor={value:E[0],previous:void 0,next:void 0};for(let m=1;m<E.length;m++)this.add(E[m])}add(E){const w={value:E,previous:this.tail,next:void 0};for(this.tail.next=w,this.tail=w,this.cursor=this.tail,this.size++;this.size>this.capacity;)this.head=this.head.next,this.head.previous=void 0,this.size--}replaceLast(E){const w=this.tail.value;return this.tail.value=E,w}isAtEnd(){return this.cursor===this.tail}current(){return this.cursor.value}previous(){return this.cursor.previous&&(this.cursor=this.cursor.previous),this.cursor.value}next(){return this.cursor.next&&(this.cursor=this.cursor.next),this.cursor.value}has(E){let w=this.head;for(;w;){if(w.value===E)return!0;w=w.next}return!1}resetCursor(){return this.cursor=this.tail,this.cursor.value}*[Symbol.iterator](){let E=this.head;for(;E;)yield E.value,E=E.next}}t.HistoryNavigator2=B}),define(me[44],pe([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SlidingWindowAverage=t.MovingAverage=t.Counter=t.rot=t.clamp=void 0;function y(w,m,f){return Math.min(Math.max(w,m),f)}t.clamp=y;function i(w,m){return(m+w%m)%m}t.rot=i;class B{constructor(){this._next=0}getNext(){return this._next++}}t.Counter=B;class M{constructor(){this._n=1,this._val=0}update(m){return this._val=this._val+(m-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}t.MovingAverage=M;class E{constructor(m){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(m),this._values.fill(0,0,m)}update(m){const f=this._values[this._index];return this._values[this._index]=m,this._index=(this._index+1)%this._values.length,this._sum-=f,this._sum+=m,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}t.SlidingWindowAverage=E}),define(me[45],pe([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;var y;(function(i){function B(m,f){if(m.start>=f.end||f.start>=m.end)return{start:0,end:0};const g=Math.max(m.start,f.start),F=Math.min(m.end,f.end);return F-g<=0?{start:0,end:0}:{start:g,end:F}}i.intersect=B;function M(m){return m.end-m.start<=0}i.isEmpty=M;function E(m,f){return!M(B(m,f))}i.intersects=E;function w(m,f){const g=[],F={start:m.start,end:Math.min(f.start,m.end)},l={start:Math.max(f.end,m.start),end:m.end};return M(F)||g.push(F),M(l)||g.push(l),g}i.relativeComplement=w})(y=t.Range||(t.Range={}))}),define(me[78],pe([1,0,45]),function(J,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RangeMap=t.consolidate=t.shift=t.groupIntersect=void 0;function i(m,f){const g=[];for(const F of f){if(m.start>=F.range.end)continue;if(m.end<F.range.start)break;const l=y.Range.intersect(m,F.range);y.Range.isEmpty(l)||g.push({range:l,size:F.size})}return g}t.groupIntersect=i;function B({start:m,end:f},g){return{start:m+g,end:f+g}}t.shift=B;function M(m){const f=[];let g=null;for(const F of m){const l=F.range.start,s=F.range.end,e=F.size;if(g&&e===g.size){g.range.end=s;continue}g={range:{start:l,end:s},size:e},f.push(g)}return f}t.consolidate=M;function E(...m){return M(m.reduce((f,g)=>f.concat(g),[]))}class w{constructor(){this.groups=[],this._size=0}splice(f,g,F=[]){const l=F.length-g,s=i({start:0,end:f},this.groups),e=i({start:f+g,end:Number.POSITIVE_INFINITY},this.groups).map(D=>({range:B(D.range,l),size:D.size})),p=F.map((D,v)=>({range:{start:f+v,end:f+v+1},size:D.size}));this.groups=E(s,p,e),this._size=this.groups.reduce((D,v)=>D+v.size*(v.range.end-v.range.start),0)}get count(){const f=this.groups.length;return f?this.groups[f-1].range.end:0}get size(){return this._size}indexAt(f){if(f<0)return-1;let g=0,F=0;for(const l of this.groups){const s=l.range.end-l.range.start,e=F+s*l.size;if(f<e)return g+Math.floor((f-F)/l.size);g+=s,F=e}return g}indexAfter(f){return Math.min(this.indexAt(f)+1,this.count)}positionAt(f){if(f<0)return-1;let g=0,F=0;for(const l of this.groups){const s=l.range.end-l.range.start,e=F+s;if(f<e)return g+(f-F)*l.size;g+=s*l.size,F=e}return-1}}t.RangeMap=w}),define(me[79],pe([1,0,13,2]),function(J,t,y,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedStream=t.prefixedReadable=t.transform=t.toReadable=t.emptyStream=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=t.isReadable=void 0;function B(o){const b=o;return b?typeof b.read=="function":!1}t.isReadable=B;function M(o){const b=o;return b?[b.on,b.pause,b.resume,b.destroy].every(S=>typeof S=="function"):!1}t.isReadableStream=M;function E(o){const b=o;return b?M(b.stream)&&Array.isArray(b.buffer)&&typeof b.ended=="boolean":!1}t.isReadableBufferedStream=E;function w(o,b){return new m(o,b)}t.newWriteableStream=w;class m{constructor(b,S){this.reducer=b,this.options=S,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(b){if(!this.state.destroyed){if(this.state.flowing)this.emitData(b);else if(this.buffer.data.push(b),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(S=>this.pendingWritePromises.push(S))}}error(b){this.state.destroyed||(this.state.flowing?this.emitError(b):this.buffer.error.push(b))}end(b){this.state.destroyed||(typeof b!="undefined"&&this.write(b),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(b){this.listeners.data.slice(0).forEach(S=>S(b))}emitError(b){this.listeners.error.length===0?(0,y.onUnexpectedError)(b):this.listeners.error.slice(0).forEach(S=>S(b))}emitEnd(){this.listeners.end.slice(0).forEach(b=>b())}on(b,S){if(!this.state.destroyed)switch(b){case"data":this.listeners.data.push(S),this.resume();break;case"end":this.listeners.end.push(S),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(S),this.state.flowing&&this.flowErrors();break}}removeListener(b,S){if(this.state.destroyed)return;let A;switch(b){case"data":A=this.listeners.data;break;case"end":A=this.listeners.end;break;case"error":A=this.listeners.error;break}if(A){const C=A.indexOf(S);C>=0&&A.splice(C,1)}}flowData(){if(this.buffer.data.length>0){const b=this.reducer(this.buffer.data);this.emitData(b),this.buffer.data.length=0;const S=[...this.pendingWritePromises];this.pendingWritePromises.length=0,S.forEach(A=>A())}}flowErrors(){if(this.listeners.error.length>0){for(const b of this.buffer.error)this.emitError(b);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function f(o,b){const S=[];let A;for(;(A=o.read())!==null;)S.push(A);return b(S)}t.consumeReadable=f;function g(o,b,S){const A=[];let C;for(;(C=o.read())!==null&&A.length<S;)A.push(C);return C===null&&A.length>0?b(A):{read:()=>{if(A.length>0)return A.shift();if(typeof C!="undefined"){const r=C;return C=void 0,r}return o.read()}}}t.peekReadable=g;function F(o,b){return new Promise((S,A)=>{const C=[];l(o,{onData:r=>{b&&C.push(r)},onError:r=>{b?A(r):S(void 0)},onEnd:()=>{S(b?b(C):void 0)}})})}t.consumeStream=F;function l(o,b){let S=!1;return o.on("error",A=>{S||b.onError(A)}),o.on("end",()=>{S||b.onEnd()}),o.on("data",A=>{S||b.onData(A)}),(0,i.toDisposable)(()=>S=!0)}t.listenStream=l;function s(o,b){return new Promise((S,A)=>{const C=new i.DisposableStore,r=[],n=h=>{if(r.push(h),r.length>b)return C.dispose(),o.pause(),S({stream:o,buffer:r,ended:!1})},c=h=>A(h),u=()=>S({stream:o,buffer:r,ended:!0});C.add((0,i.toDisposable)(()=>o.removeListener("error",c))),o.on("error",c),C.add((0,i.toDisposable)(()=>o.removeListener("end",u))),o.on("end",u),C.add((0,i.toDisposable)(()=>o.removeListener("data",n))),o.on("data",n)})}t.peekStream=s;function e(o,b){const S=w(b);return S.end(o),S}t.toStream=e;function p(){const o=w(()=>{throw new Error("not supported")});return o.end(),o}t.emptyStream=p;function D(o){let b=!1;return{read:()=>b?null:(b=!0,o)}}t.toReadable=D;function v(o,b,S){const A=w(S);return l(o,{onData:C=>A.write(b.data(C)),onError:C=>A.error(b.error?b.error(C):C),onEnd:()=>A.end()}),A}t.transform=v;function _(o,b,S){let A=!1;return{read:()=>{const C=b.read();return A?C:(A=!0,C!==null?S([o,C]):o)}}}t.prefixedReadable=_;function a(o,b,S){let A=!1;const C=w(S);return l(b,{onData:r=>A?C.write(r):(A=!0,C.write(S([o,r]))),onError:r=>C.error(r),onEnd:()=>{A||(A=!0,C.write(o)),C.end()}}),C}t.prefixedStream=a}),define(me[31],pe([1,0,79]),function(J,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.encodeBase64=t.decodeBase64=t.prefixedBufferStream=t.prefixedBufferReadable=t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const i=typeof Buffer!="undefined";let B,M;class E{constructor(h){this.buffer=h,this.byteLength=this.buffer.byteLength}static alloc(h){return i?new E(Buffer.allocUnsafe(h)):new E(new Uint8Array(h))}static wrap(h){return i&&!Buffer.isBuffer(h)&&(h=Buffer.from(h.buffer,h.byteOffset,h.byteLength)),new E(h)}static fromString(h,O){return!(O?.dontUseNodeBuffer||!1)&&i?new E(Buffer.from(h)):(B||(B=new TextEncoder),new E(B.encode(h)))}static fromByteArray(h){const O=E.alloc(h.length);for(let V=0,ue=h.length;V<ue;V++)O.buffer[V]=h[V];return O}static concat(h,O){if(typeof O=="undefined"){O=0;for(let ie=0,ge=h.length;ie<ge;ie++)O+=h[ie].byteLength}const V=E.alloc(O);let ue=0;for(let ie=0,ge=h.length;ie<ge;ie++){const ae=h[ie];V.set(ae,ue),ue+=ae.byteLength}return V}clone(){const h=E.alloc(this.byteLength);return h.set(this),h}toString(){return i?this.buffer.toString():(M||(M=new TextDecoder),M.decode(this.buffer))}slice(h,O){return new E(this.buffer.subarray(h,O))}set(h,O){if(h instanceof E)this.buffer.set(h.buffer,O);else if(h instanceof Uint8Array)this.buffer.set(h,O);else if(h instanceof ArrayBuffer)this.buffer.set(new Uint8Array(h),O);else if(ArrayBuffer.isView(h))this.buffer.set(new Uint8Array(h.buffer,h.byteOffset,h.byteLength),O);else throw new Error("Unknown argument 'array'")}readUInt32BE(h){return f(this.buffer,h)}writeUInt32BE(h,O){g(this.buffer,h,O)}readUInt32LE(h){return F(this.buffer,h)}writeUInt32LE(h,O){l(this.buffer,h,O)}readUInt8(h){return s(this.buffer,h)}writeUInt8(h,O){e(this.buffer,h,O)}}t.VSBuffer=E;function w(u,h){return u[h+0]<<0>>>0|u[h+1]<<8>>>0}t.readUInt16LE=w;function m(u,h,O){u[O+0]=h&255,h=h>>>8,u[O+1]=h&255}t.writeUInt16LE=m;function f(u,h){return u[h]*2**24+u[h+1]*2**16+u[h+2]*2**8+u[h+3]}t.readUInt32BE=f;function g(u,h,O){u[O+3]=h,h=h>>>8,u[O+2]=h,h=h>>>8,u[O+1]=h,h=h>>>8,u[O]=h}t.writeUInt32BE=g;function F(u,h){return u[h+0]<<0>>>0|u[h+1]<<8>>>0|u[h+2]<<16>>>0|u[h+3]<<24>>>0}t.readUInt32LE=F;function l(u,h,O){u[O+0]=h&255,h=h>>>8,u[O+1]=h&255,h=h>>>8,u[O+2]=h&255,h=h>>>8,u[O+3]=h&255}t.writeUInt32LE=l;function s(u,h){return u[h]}t.readUInt8=s;function e(u,h,O){u[O]=h}t.writeUInt8=e;function p(u){return y.consumeReadable(u,h=>E.concat(h))}t.readableToBuffer=p;function D(u){return y.toReadable(u)}t.bufferToReadable=D;function v(u){return y.consumeStream(u,h=>E.concat(h))}t.streamToBuffer=v;async function _(u){return u.ended?E.concat(u.buffer):E.concat([...u.buffer,await v(u.stream)])}t.bufferedStreamToBuffer=_;function a(u){return y.toStream(u,h=>E.concat(h))}t.bufferToStream=a;function o(u){return y.transform(u,{data:h=>typeof h=="string"?E.fromString(h):E.wrap(h)},h=>E.concat(h))}t.streamToBufferReadableStream=o;function b(u){return y.newWriteableStream(h=>E.concat(h),u)}t.newWriteableBufferStream=b;function S(u,h){return y.prefixedReadable(u,h,O=>E.concat(O))}t.prefixedBufferReadable=S;function A(u,h){return y.prefixedStream(u,h,O=>E.concat(O))}t.prefixedBufferStream=A;function C(u){let h=0,O=0,V=0;const ue=new Uint8Array(Math.floor(u.length/4*3)),ie=ae=>{switch(O){case 3:ue[V++]=h|ae,O=0;break;case 2:ue[V++]=h|ae>>>2,h=ae<<6,O=3;break;case 1:ue[V++]=h|ae>>>4,h=ae<<4,O=2;break;default:h=ae<<2,O=1}};for(let ae=0;ae<u.length;ae++){const we=u.charCodeAt(ae);if(we>=65&&we<=90)ie(we-65);else if(we>=97&&we<=122)ie(we-97+26);else if(we>=48&&we<=57)ie(we-48+52);else if(we===43||we===45)ie(62);else if(we===47||we===95)ie(63);else{if(we===61)break;throw new SyntaxError(`Unexpected base64 character ${u[ae]}`)}}const ge=V;for(;O>0;)ie(0);return E.wrap(ue).slice(0,ge)}t.decodeBase64=C;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function c({buffer:u},h=!0,O=!1){const V=O?n:r;let ue="";const ie=u.byteLength%3;let ge=0;for(;ge<u.byteLength-ie;ge+=3){const ae=u[ge+0],we=u[ge+1],ce=u[ge+2];ue+=V[ae>>>2],ue+=V[(ae<<4|we>>>4)&63],ue+=V[(we<<2|ce>>>6)&63],ue+=V[ce&63]}if(ie===1){const ae=u[ge+0];ue+=V[ae>>>2],ue+=V[ae<<4&63],h&&(ue+="==")}else if(ie===2){const ae=u[ge+0],we=u[ge+1];ue+=V[ae>>>2],ue+=V[(ae<<4|we>>>4)&63],ue+=V[we<<2&63],h&&(ue+="=")}return ue}t.encodeBase64=c}),define(me[6],pe([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.withUndefinedAsNull=t.withNullAsUndefined=t.validateConstraint=t.validateConstraints=t.areFunctions=t.isFunction=t.isEmptyObject=t.assertAllDefined=t.assertIsDefined=t.assertType=t.isUndefinedOrNull=t.isDefined=t.isUndefined=t.isBoolean=t.isIterable=t.isNumber=t.isTypedArray=t.isObject=t.isStringArray=t.isString=void 0;function y(A){return typeof A=="string"}t.isString=y;function i(A){return Array.isArray(A)&&A.every(C=>y(C))}t.isStringArray=i;function B(A){return typeof A=="object"&&A!==null&&!Array.isArray(A)&&!(A instanceof RegExp)&&!(A instanceof Date)}t.isObject=B;function M(A){const C=Object.getPrototypeOf(Uint8Array);return typeof A=="object"&&A instanceof C}t.isTypedArray=M;function E(A){return typeof A=="number"&&!isNaN(A)}t.isNumber=E;function w(A){return!!A&&typeof A[Symbol.iterator]=="function"}t.isIterable=w;function m(A){return A===!0||A===!1}t.isBoolean=m;function f(A){return typeof A=="undefined"}t.isUndefined=f;function g(A){return!F(A)}t.isDefined=g;function F(A){return f(A)||A===null}t.isUndefinedOrNull=F;function l(A,C){if(!A)throw new Error(C?`Unexpected type, expected '${C}'`:"Unexpected type")}t.assertType=l;function s(A){if(F(A))throw new Error("Assertion Failed: argument is undefined or null");return A}t.assertIsDefined=s;function e(...A){const C=[];for(let r=0;r<A.length;r++){const n=A[r];if(F(n))throw new Error(`Assertion Failed: argument at index ${r} is undefined or null`);C.push(n)}return C}t.assertAllDefined=e;const p=Object.prototype.hasOwnProperty;function D(A){if(!B(A))return!1;for(const C in A)if(p.call(A,C))return!1;return!0}t.isEmptyObject=D;function v(A){return typeof A=="function"}t.isFunction=v;function _(...A){return A.length>0&&A.every(v)}t.areFunctions=_;function a(A,C){const r=Math.min(A.length,C.length);for(let n=0;n<r;n++)o(A[n],C[n])}t.validateConstraints=a;function o(A,C){if(y(C)){if(typeof A!==C)throw new Error(`argument does not match constraint: typeof ${C}`)}else if(v(C)){try{if(A instanceof C)return}catch{}if(!F(A)&&A.constructor===C||C.length===1&&C.call(void 0,A)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.validateConstraint=o;function b(A){return A===null?void 0:A}t.withNullAsUndefined=b;function S(A){return typeof A=="undefined"?null:A}t.withUndefinedAsNull=S}),define(me[27],pe([1,0,6]),function(J,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createProxyObject=t.getAllMethodNames=t.getAllPropertyNames=t.filter=t.getCaseInsensitive=t.distinct=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function i(v){if(!v||typeof v!="object"||v instanceof RegExp)return v;const _=Array.isArray(v)?[]:{};return Object.keys(v).forEach(a=>{v[a]&&typeof v[a]=="object"?_[a]=i(v[a]):_[a]=v[a]}),_}t.deepClone=i;function B(v){if(!v||typeof v!="object")return v;const _=[v];for(;_.length>0;){const a=_.shift();Object.freeze(a);for(const o in a)if(M.call(a,o)){const b=a[o];typeof b=="object"&&!Object.isFrozen(b)&&!(0,y.isTypedArray)(b)&&_.push(b)}}return v}t.deepFreeze=B;const M=Object.prototype.hasOwnProperty;function E(v,_){return w(v,_,new Set)}t.cloneAndChange=E;function w(v,_,a){if((0,y.isUndefinedOrNull)(v))return v;const o=_(v);if(typeof o!="undefined")return o;if(Array.isArray(v)){const b=[];for(const S of v)b.push(w(S,_,a));return b}if((0,y.isObject)(v)){if(a.has(v))throw new Error("Cannot clone recursive data-structure");a.add(v);const b={};for(const S in v)M.call(v,S)&&(b[S]=w(v[S],_,a));return a.delete(v),b}return v}function m(v,_,a=!0){return(0,y.isObject)(v)?((0,y.isObject)(_)&&Object.keys(_).forEach(o=>{o in v?a&&((0,y.isObject)(v[o])&&(0,y.isObject)(_[o])?m(v[o],_[o],a):v[o]=_[o]):v[o]=_[o]}),v):_}t.mixin=m;function f(v,_){if(v===_)return!0;if(v==null||_===null||_===void 0||typeof v!=typeof _||typeof v!="object"||Array.isArray(v)!==Array.isArray(_))return!1;let a,o;if(Array.isArray(v)){if(v.length!==_.length)return!1;for(a=0;a<v.length;a++)if(!f(v[a],_[a]))return!1}else{const b=[];for(o in v)b.push(o);b.sort();const S=[];for(o in _)S.push(o);if(S.sort(),!f(b,S))return!1;for(a=0;a<b.length;a++)if(!f(v[b[a]],_[b[a]]))return!1}return!0}t.equals=f;function g(v){const _=new Set;return JSON.stringify(v,(a,o)=>{if((0,y.isObject)(o)||Array.isArray(o)){if(_.has(o))return"[Circular]";_.add(o)}return o})}t.safeStringify=g;function F(v,_){const a=Object.create(null);return!v||!_||Object.keys(_).forEach(b=>{const S=v[b],A=_[b];f(S,A)||(a[b]=A)}),a}t.distinct=F;function l(v,_){const a=_.toLowerCase(),o=Object.keys(v).find(b=>b.toLowerCase()===a);return o?v[o]:v[_]}t.getCaseInsensitive=l;function s(v,_){const a=Object.create(null);for(const[o,b]of Object.entries(v))_(o,b)&&(a[o]=b);return a}t.filter=s;function e(v){let _=[],a=Object.getPrototypeOf(v);for(;Object.prototype!==a;)_=_.concat(Object.getOwnPropertyNames(a)),a=Object.getPrototypeOf(a);return _}t.getAllPropertyNames=e;function p(v){const _=[];for(const a of e(v))typeof v[a]=="function"&&_.push(a);return _}t.getAllMethodNames=p;function D(v,_){const a=b=>function(){const S=Array.prototype.slice.call(arguments,0);return _(b,S)},o={};for(const b of v)o[b]=a(b);return o}t.createProxyObject=D}),define(me[80],pe([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CONTEXT_MENU_CLOSE_CHANNEL=t.CONTEXT_MENU_CHANNEL=void 0,t.CONTEXT_MENU_CHANNEL="vscode:contextmenu",t.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(me[81],pe([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Protocol=void 0;class y{constructor(B,M){this.sender=B,this.onMessage=M}send(B){try{this.sender.send("vscode:message",B.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}t.Protocol=y}),define(me[46],pe([7]),{}),define(me[82],pe([7]),{}),define(me[83],pe([7]),{}),define(me[84],pe([7]),{}),define(me[85],pe([1,0,11,83,84]),function(J,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.formatRule=void 0;function i(B){let M=B.definition;for(;M instanceof y.Codicon;)M=M.definition;return`.codicon-${B.id}:before { content: '${M.fontCharacter}'; }`}t.formatRule=i}),define(me[86],pe([7]),{}),define(me[87],pe([7]),{}),define(me[88],pe([7]),{}),define(me[89],pe([7]),{}),define(me[90],pe([7]),{}),define(me[91],pe([7]),{}),define(me[92],pe([7]),{}),define(me[93],pe([7]),{}),define(me[94],pe([7]),{}),define(me[95],pe([12,9]),function(J,t){return J.create("vs/base/browser/ui/actionbar/actionViewItems",t)}),define(me[96],pe([12,9]),function(J,t){return J.create("vs/base/browser/ui/findinput/findInput",t)}),define(me[97],pe([12,9]),function(J,t){return J.create("vs/base/browser/ui/findinput/findInputToggles",t)}),define(me[98],pe([12,9]),function(J,t){return J.create("vs/base/browser/ui/iconLabel/iconLabelHover",t)}),define(me[99],pe([12,9]),function(J,t){return J.create("vs/base/browser/ui/inputbox/inputBox",t)}),define(me[100],pe([12,9]),function(J,t){return J.create("vs/base/browser/ui/selectBox/selectBoxCustom",t)}),define(me[101],pe([12,9]),function(J,t){return J.create("vs/base/browser/ui/tree/abstractTree",t)}),define(me[102],pe([12,9]),function(J,t){return J.create("vs/base/common/actions",t)}),define(me[103],pe([12,9]),function(J,t){return J.create("vs/base/common/platform",t)}),define(me[5],pe([1,0,103]),function(J,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isAndroid=t.isEdge=t.isSafari=t.isFirefox=t.isChrome=t.isLittleEndian=t.OS=t.OperatingSystem=t.setTimeout0=t.setTimeout0IsFaster=t.translationsConfigFile=t.locale=t.Language=t.language=t.userAgent=t.platform=t.isCI=t.isIOS=t.isWebWorker=t.isWeb=t.isElectron=t.isNative=t.isLinuxSnap=t.isLinux=t.isMacintosh=t.isWindows=t.PlatformToString=t.Platform=t.globals=void 0;const i="en";let B=!1,M=!1,E=!1,w=!1,m=!1,f=!1,g=!1,F=!1,l=!1,s,e=i,p,D;t.globals=typeof self=="object"?self:typeof global=="object"?global:{};let v;typeof t.globals.vscode!="undefined"&&typeof t.globals.vscode.process!="undefined"?v=t.globals.vscode.process:typeof process!="undefined"&&(v=process);const _=typeof v?.versions?.electron=="string",a=_&&v?.type==="renderer";if(typeof navigator=="object"&&!a)D=navigator.userAgent,B=D.indexOf("Windows")>=0,M=D.indexOf("Macintosh")>=0,F=(D.indexOf("Macintosh")>=0||D.indexOf("iPad")>=0||D.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,E=D.indexOf("Linux")>=0,f=!0,s=y.getConfiguredDefaultLocale(y.localize(0,null))||i,e=s;else if(typeof v=="object"){B=v.platform==="win32",M=v.platform==="darwin",E=v.platform==="linux",w=E&&!!v.env.SNAP&&!!v.env.SNAP_REVISION,g=_,l=!!v.env.CI||!!v.env.BUILD_ARTIFACTSTAGINGDIRECTORY,s=i,e=i;const u=v.env.VSCODE_NLS_CONFIG;if(u)try{const h=JSON.parse(u),O=h.availableLanguages["*"];s=h.locale,e=O||i,p=h._translationsConfigFile}catch{}m=!0}else console.error("Unable to resolve platform.");var o;(function(u){u[u.Web=0]="Web",u[u.Mac=1]="Mac",u[u.Linux=2]="Linux",u[u.Windows=3]="Windows"})(o=t.Platform||(t.Platform={}));function b(u){switch(u){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.PlatformToString=b;let S=0;M?S=1:B?S=3:E&&(S=2),t.isWindows=B,t.isMacintosh=M,t.isLinux=E,t.isLinuxSnap=w,t.isNative=m,t.isElectron=g,t.isWeb=f,t.isWebWorker=f&&typeof t.globals.importScripts=="function",t.isIOS=F,t.isCI=l,t.platform=S,t.userAgent=D,t.language=e;var A;(function(u){function h(){return t.language}u.value=h;function O(){return t.language.length===2?t.language==="en":t.language.length>=3?t.language[0]==="e"&&t.language[1]==="n"&&t.language[2]==="-":!1}u.isDefaultVariant=O;function V(){return t.language==="en"}u.isDefault=V})(A=t.Language||(t.Language={})),t.locale=s,t.translationsConfigFile=p,t.setTimeout0IsFaster=typeof t.globals.postMessage=="function"&&!t.globals.importScripts,t.setTimeout0=(()=>{if(t.setTimeout0IsFaster){const u=[];t.globals.addEventListener("message",O=>{if(O.data&&O.data.vscodeScheduleAsyncWork)for(let V=0,ue=u.length;V<ue;V++){const ie=u[V];if(ie.id===O.data.vscodeScheduleAsyncWork){u.splice(V,1),ie.callback();return}}});let h=0;return O=>{const V=++h;u.push({id:V,callback:O}),t.globals.postMessage({vscodeScheduleAsyncWork:V},"*")}}return u=>setTimeout(u)})();var C;(function(u){u[u.Windows=1]="Windows",u[u.Macintosh=2]="Macintosh",u[u.Linux=3]="Linux"})(C=t.OperatingSystem||(t.OperatingSystem={})),t.OS=M||F?2:B?1:3;let r=!0,n=!1;function c(){if(!n){n=!0;const u=new Uint8Array(2);u[0]=1,u[1]=2,r=new Uint16Array(u.buffer)[0]===(2<<8)+1}return r}t.isLittleEndian=c,t.isChrome=!!(t.userAgent&&t.userAgent.indexOf("Chrome")>=0),t.isFirefox=!!(t.userAgent&&t.userAgent.indexOf("Firefox")>=0),t.isSafari=!!(!t.isChrome&&t.userAgent&&t.userAgent.indexOf("Safari")>=0),t.isEdge=!!(t.userAgent&&t.userAgent.indexOf("Edg/")>=0),t.isAndroid=!!(t.userAgent&&t.userAgent.indexOf("Android")>=0)}),define(me[104],pe([1,0,5]),function(J,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.arch=t.platform=t.env=t.cwd=void 0;let i;if(typeof y.globals.vscode!="undefined"&&typeof y.globals.vscode.process!="undefined"){const B=y.globals.vscode.process;i={get platform(){return B.platform},get arch(){return B.arch},get env(){return B.env},cwd(){return B.cwd()}}}else typeof process!="undefined"?i={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:i={get platform(){return y.isWindows?"win32":y.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=i.cwd,t.env=i.env,t.platform=i.platform,t.arch=i.arch}),define(me[21],pe([1,0,104]),function(J,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.delimiter=t.sep=t.toNamespacedPath=t.parse=t.format=t.extname=t.basename=t.dirname=t.relative=t.resolve=t.join=t.isAbsolute=t.normalize=t.posix=t.win32=void 0;const i=65,B=97,M=90,E=122,w=46,m=47,f=92,g=58,F=63;class l extends Error{constructor(o,b,S){let A;typeof b=="string"&&b.indexOf("not ")===0?(A="must not be",b=b.replace(/^not /,"")):A="must be";const C=o.indexOf(".")!==-1?"property":"argument";let r=`The "${o}" ${C} ${A} of type ${b}`;r+=`. Received type ${typeof S}`;super(r);this.code="ERR_INVALID_ARG_TYPE"}}function s(a,o){if(typeof a!="string")throw new l(o,"string",a)}function e(a){return a===m||a===f}function p(a){return a===m}function D(a){return a>=i&&a<=M||a>=B&&a<=E}function v(a,o,b,S){let A="",C=0,r=-1,n=0,c=0;for(let u=0;u<=a.length;++u){if(u<a.length)c=a.charCodeAt(u);else{if(S(c))break;c=m}if(S(c)){if(!(r===u-1||n===1))if(n===2){if(A.length<2||C!==2||A.charCodeAt(A.length-1)!==w||A.charCodeAt(A.length-2)!==w){if(A.length>2){const h=A.lastIndexOf(b);h===-1?(A="",C=0):(A=A.slice(0,h),C=A.length-1-A.lastIndexOf(b)),r=u,n=0;continue}else if(A.length!==0){A="",C=0,r=u,n=0;continue}}o&&(A+=A.length>0?`${b}..`:"..",C=2)}else A.length>0?A+=`${b}${a.slice(r+1,u)}`:A=a.slice(r+1,u),C=u-r-1;r=u,n=0}else c===w&&n!==-1?++n:n=-1}return A}function _(a,o){if(o===null||typeof o!="object")throw new l("pathObject","Object",o);const b=o.dir||o.root,S=o.base||`${o.name||""}${o.ext||""}`;return b?b===o.root?`${b}${S}`:`${b}${a}${S}`:S}t.win32={resolve(...a){let o="",b="",S=!1;for(let A=a.length-1;A>=-1;A--){let C;if(A>=0){if(C=a[A],s(C,"path"),C.length===0)continue}else o.length===0?C=y.cwd():(C=y.env[`=${o}`]||y.cwd(),(C===void 0||C.slice(0,2).toLowerCase()!==o.toLowerCase()&&C.charCodeAt(2)===f)&&(C=`${o}\\`));const r=C.length;let n=0,c="",u=!1;const h=C.charCodeAt(0);if(r===1)e(h)&&(n=1,u=!0);else if(e(h))if(u=!0,e(C.charCodeAt(1))){let O=2,V=O;for(;O<r&&!e(C.charCodeAt(O));)O++;if(O<r&&O!==V){const ue=C.slice(V,O);for(V=O;O<r&&e(C.charCodeAt(O));)O++;if(O<r&&O!==V){for(V=O;O<r&&!e(C.charCodeAt(O));)O++;(O===r||O!==V)&&(c=`\\\\${ue}\\${C.slice(V,O)}`,n=O)}}}else n=1;else D(h)&&C.charCodeAt(1)===g&&(c=C.slice(0,2),n=2,r>2&&e(C.charCodeAt(2))&&(u=!0,n=3));if(c.length>0)if(o.length>0){if(c.toLowerCase()!==o.toLowerCase())continue}else o=c;if(S){if(o.length>0)break}else if(b=`${C.slice(n)}\\${b}`,S=u,u&&o.length>0)break}return b=v(b,!S,"\\",e),S?`${o}\\${b}`:`${o}${b}`||"."},normalize(a){s(a,"path");const o=a.length;if(o===0)return".";let b=0,S,A=!1;const C=a.charCodeAt(0);if(o===1)return p(C)?"\\":a;if(e(C))if(A=!0,e(a.charCodeAt(1))){let n=2,c=n;for(;n<o&&!e(a.charCodeAt(n));)n++;if(n<o&&n!==c){const u=a.slice(c,n);for(c=n;n<o&&e(a.charCodeAt(n));)n++;if(n<o&&n!==c){for(c=n;n<o&&!e(a.charCodeAt(n));)n++;if(n===o)return`\\\\${u}\\${a.slice(c)}\\`;n!==c&&(S=`\\\\${u}\\${a.slice(c,n)}`,b=n)}}}else b=1;else D(C)&&a.charCodeAt(1)===g&&(S=a.slice(0,2),b=2,o>2&&e(a.charCodeAt(2))&&(A=!0,b=3));let r=b<o?v(a.slice(b),!A,"\\",e):"";return r.length===0&&!A&&(r="."),r.length>0&&e(a.charCodeAt(o-1))&&(r+="\\"),S===void 0?A?`\\${r}`:r:A?`${S}\\${r}`:`${S}${r}`},isAbsolute(a){s(a,"path");const o=a.length;if(o===0)return!1;const b=a.charCodeAt(0);return e(b)||o>2&&D(b)&&a.charCodeAt(1)===g&&e(a.charCodeAt(2))},join(...a){if(a.length===0)return".";let o,b;for(let C=0;C<a.length;++C){const r=a[C];s(r,"path"),r.length>0&&(o===void 0?o=b=r:o+=`\\${r}`)}if(o===void 0)return".";let S=!0,A=0;if(typeof b=="string"&&e(b.charCodeAt(0))){++A;const C=b.length;C>1&&e(b.charCodeAt(1))&&(++A,C>2&&(e(b.charCodeAt(2))?++A:S=!1))}if(S){for(;A<o.length&&e(o.charCodeAt(A));)A++;A>=2&&(o=`\\${o.slice(A)}`)}return t.win32.normalize(o)},relative(a,o){if(s(a,"from"),s(o,"to"),a===o)return"";const b=t.win32.resolve(a),S=t.win32.resolve(o);if(b===S||(a=b.toLowerCase(),o=S.toLowerCase(),a===o))return"";let A=0;for(;A<a.length&&a.charCodeAt(A)===f;)A++;let C=a.length;for(;C-1>A&&a.charCodeAt(C-1)===f;)C--;const r=C-A;let n=0;for(;n<o.length&&o.charCodeAt(n)===f;)n++;let c=o.length;for(;c-1>n&&o.charCodeAt(c-1)===f;)c--;const u=c-n,h=r<u?r:u;let O=-1,V=0;for(;V<h;V++){const ie=a.charCodeAt(A+V);if(ie!==o.charCodeAt(n+V))break;ie===f&&(O=V)}if(V!==h){if(O===-1)return S}else{if(u>h){if(o.charCodeAt(n+V)===f)return S.slice(n+V+1);if(V===2)return S.slice(n+V)}r>h&&(a.charCodeAt(A+V)===f?O=V:V===2&&(O=3)),O===-1&&(O=0)}let ue="";for(V=A+O+1;V<=C;++V)(V===C||a.charCodeAt(V)===f)&&(ue+=ue.length===0?"..":"\\..");return n+=O,ue.length>0?`${ue}${S.slice(n,c)}`:(S.charCodeAt(n)===f&&++n,S.slice(n,c))},toNamespacedPath(a){if(typeof a!="string")return a;if(a.length===0)return"";const o=t.win32.resolve(a);if(o.length<=2)return a;if(o.charCodeAt(0)===f){if(o.charCodeAt(1)===f){const b=o.charCodeAt(2);if(b!==F&&b!==w)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(D(o.charCodeAt(0))&&o.charCodeAt(1)===g&&o.charCodeAt(2)===f)return`\\\\?\\${o}`;return a},dirname(a){s(a,"path");const o=a.length;if(o===0)return".";let b=-1,S=0;const A=a.charCodeAt(0);if(o===1)return e(A)?a:".";if(e(A)){if(b=S=1,e(a.charCodeAt(1))){let n=2,c=n;for(;n<o&&!e(a.charCodeAt(n));)n++;if(n<o&&n!==c){for(c=n;n<o&&e(a.charCodeAt(n));)n++;if(n<o&&n!==c){for(c=n;n<o&&!e(a.charCodeAt(n));)n++;if(n===o)return a;n!==c&&(b=S=n+1)}}}}else D(A)&&a.charCodeAt(1)===g&&(b=o>2&&e(a.charCodeAt(2))?3:2,S=b);let C=-1,r=!0;for(let n=o-1;n>=S;--n)if(e(a.charCodeAt(n))){if(!r){C=n;break}}else r=!1;if(C===-1){if(b===-1)return".";C=b}return a.slice(0,C)},basename(a,o){o!==void 0&&s(o,"ext"),s(a,"path");let b=0,S=-1,A=!0,C;if(a.length>=2&&D(a.charCodeAt(0))&&a.charCodeAt(1)===g&&(b=2),o!==void 0&&o.length>0&&o.length<=a.length){if(o===a)return"";let r=o.length-1,n=-1;for(C=a.length-1;C>=b;--C){const c=a.charCodeAt(C);if(e(c)){if(!A){b=C+1;break}}else n===-1&&(A=!1,n=C+1),r>=0&&(c===o.charCodeAt(r)?--r==-1&&(S=C):(r=-1,S=n))}return b===S?S=n:S===-1&&(S=a.length),a.slice(b,S)}for(C=a.length-1;C>=b;--C)if(e(a.charCodeAt(C))){if(!A){b=C+1;break}}else S===-1&&(A=!1,S=C+1);return S===-1?"":a.slice(b,S)},extname(a){s(a,"path");let o=0,b=-1,S=0,A=-1,C=!0,r=0;a.length>=2&&a.charCodeAt(1)===g&&D(a.charCodeAt(0))&&(o=S=2);for(let n=a.length-1;n>=o;--n){const c=a.charCodeAt(n);if(e(c)){if(!C){S=n+1;break}continue}A===-1&&(C=!1,A=n+1),c===w?b===-1?b=n:r!==1&&(r=1):b!==-1&&(r=-1)}return b===-1||A===-1||r===0||r===1&&b===A-1&&b===S+1?"":a.slice(b,A)},format:_.bind(null,"\\"),parse(a){s(a,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(a.length===0)return o;const b=a.length;let S=0,A=a.charCodeAt(0);if(b===1)return e(A)?(o.root=o.dir=a,o):(o.base=o.name=a,o);if(e(A)){if(S=1,e(a.charCodeAt(1))){let O=2,V=O;for(;O<b&&!e(a.charCodeAt(O));)O++;if(O<b&&O!==V){for(V=O;O<b&&e(a.charCodeAt(O));)O++;if(O<b&&O!==V){for(V=O;O<b&&!e(a.charCodeAt(O));)O++;O===b?S=O:O!==V&&(S=O+1)}}}}else if(D(A)&&a.charCodeAt(1)===g){if(b<=2)return o.root=o.dir=a,o;if(S=2,e(a.charCodeAt(2))){if(b===3)return o.root=o.dir=a,o;S=3}}S>0&&(o.root=a.slice(0,S));let C=-1,r=S,n=-1,c=!0,u=a.length-1,h=0;for(;u>=S;--u){if(A=a.charCodeAt(u),e(A)){if(!c){r=u+1;break}continue}n===-1&&(c=!1,n=u+1),A===w?C===-1?C=u:h!==1&&(h=1):C!==-1&&(h=-1)}return n!==-1&&(C===-1||h===0||h===1&&C===n-1&&C===r+1?o.base=o.name=a.slice(r,n):(o.name=a.slice(r,C),o.base=a.slice(r,n),o.ext=a.slice(C,n))),r>0&&r!==S?o.dir=a.slice(0,r-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null},t.posix={resolve(...a){let o="",b=!1;for(let S=a.length-1;S>=-1&&!b;S--){const A=S>=0?a[S]:y.cwd();s(A,"path"),A.length!==0&&(o=`${A}/${o}`,b=A.charCodeAt(0)===m)}return o=v(o,!b,"/",p),b?`/${o}`:o.length>0?o:"."},normalize(a){if(s(a,"path"),a.length===0)return".";const o=a.charCodeAt(0)===m,b=a.charCodeAt(a.length-1)===m;return a=v(a,!o,"/",p),a.length===0?o?"/":b?"./":".":(b&&(a+="/"),o?`/${a}`:a)},isAbsolute(a){return s(a,"path"),a.length>0&&a.charCodeAt(0)===m},join(...a){if(a.length===0)return".";let o;for(let b=0;b<a.length;++b){const S=a[b];s(S,"path"),S.length>0&&(o===void 0?o=S:o+=`/${S}`)}return o===void 0?".":t.posix.normalize(o)},relative(a,o){if(s(a,"from"),s(o,"to"),a===o||(a=t.posix.resolve(a),o=t.posix.resolve(o),a===o))return"";const b=1,S=a.length,A=S-b,C=1,r=o.length-C,n=A<r?A:r;let c=-1,u=0;for(;u<n;u++){const O=a.charCodeAt(b+u);if(O!==o.charCodeAt(C+u))break;O===m&&(c=u)}if(u===n)if(r>n){if(o.charCodeAt(C+u)===m)return o.slice(C+u+1);if(u===0)return o.slice(C+u)}else A>n&&(a.charCodeAt(b+u)===m?c=u:u===0&&(c=0));let h="";for(u=b+c+1;u<=S;++u)(u===S||a.charCodeAt(u)===m)&&(h+=h.length===0?"..":"/..");return`${h}${o.slice(C+c)}`},toNamespacedPath(a){return a},dirname(a){if(s(a,"path"),a.length===0)return".";const o=a.charCodeAt(0)===m;let b=-1,S=!0;for(let A=a.length-1;A>=1;--A)if(a.charCodeAt(A)===m){if(!S){b=A;break}}else S=!1;return b===-1?o?"/":".":o&&b===1?"//":a.slice(0,b)},basename(a,o){o!==void 0&&s(o,"ext"),s(a,"path");let b=0,S=-1,A=!0,C;if(o!==void 0&&o.length>0&&o.length<=a.length){if(o===a)return"";let r=o.length-1,n=-1;for(C=a.length-1;C>=0;--C){const c=a.charCodeAt(C);if(c===m){if(!A){b=C+1;break}}else n===-1&&(A=!1,n=C+1),r>=0&&(c===o.charCodeAt(r)?--r==-1&&(S=C):(r=-1,S=n))}return b===S?S=n:S===-1&&(S=a.length),a.slice(b,S)}for(C=a.length-1;C>=0;--C)if(a.charCodeAt(C)===m){if(!A){b=C+1;break}}else S===-1&&(A=!1,S=C+1);return S===-1?"":a.slice(b,S)},extname(a){s(a,"path");let o=-1,b=0,S=-1,A=!0,C=0;for(let r=a.length-1;r>=0;--r){const n=a.charCodeAt(r);if(n===m){if(!A){b=r+1;break}continue}S===-1&&(A=!1,S=r+1),n===w?o===-1?o=r:C!==1&&(C=1):o!==-1&&(C=-1)}return o===-1||S===-1||C===0||C===1&&o===S-1&&o===b+1?"":a.slice(o,S)},format:_.bind(null,"/"),parse(a){s(a,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(a.length===0)return o;const b=a.charCodeAt(0)===m;let S;b?(o.root="/",S=1):S=0;let A=-1,C=0,r=-1,n=!0,c=a.length-1,u=0;for(;c>=S;--c){const h=a.charCodeAt(c);if(h===m){if(!n){C=c+1;break}continue}r===-1&&(n=!1,r=c+1),h===w?A===-1?A=c:u!==1&&(u=1):A!==-1&&(u=-1)}if(r!==-1){const h=C===0&&b?1:C;A===-1||u===0||u===1&&A===r-1&&A===C+1?o.base=o.name=a.slice(h,r):(o.name=a.slice(h,A),o.base=a.slice(h,r),o.ext=a.slice(A,r))}return C>0?o.dir=a.slice(0,C-1):b&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},t.posix.win32=t.win32.win32=t.win32,t.posix.posix=t.win32.posix=t.posix,t.normalize=y.platform==="win32"?t.win32.normalize:t.posix.normalize,t.isAbsolute=y.platform==="win32"?t.win32.isAbsolute:t.posix.isAbsolute,t.join=y.platform==="win32"?t.win32.join:t.posix.join,t.resolve=y.platform==="win32"?t.win32.resolve:t.posix.resolve,t.relative=y.platform==="win32"?t.win32.relative:t.posix.relative,t.dirname=y.platform==="win32"?t.win32.dirname:t.posix.dirname,t.basename=y.platform==="win32"?t.win32.basename:t.posix.basename,t.extname=y.platform==="win32"?t.win32.extname:t.posix.extname,t.format=y.platform==="win32"?t.win32.format:t.posix.format,t.parse=y.platform==="win32"?t.win32.parse:t.posix.parse,t.toNamespacedPath=y.platform==="win32"?t.win32.toNamespacedPath:t.posix.toNamespacedPath,t.sep=y.platform==="win32"?t.win32.sep:t.posix.sep,t.delimiter=y.platform==="win32"?t.win32.delimiter:t.posix.delimiter}),define(me[105],pe([1,0,21]),function(J,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.normalizeMimeType=t.getExtensionForMimeType=t.getMediaMime=t.getMediaOrTextMime=t.Mimes=void 0,t.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const i={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},B={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function M(g){const F=(0,y.extname)(g),l=i[F.toLowerCase()];return l!==void 0?l:E(g)}t.getMediaOrTextMime=M;function E(g){const F=(0,y.extname)(g);return B[F.toLowerCase()]}t.getMediaMime=E;function w(g){for(const F in B)if(B[F]===g)return F}t.getExtensionForMimeType=w;const m=/^(.+)\/(.+?)(;.+)?$/;function f(g,F){const l=m.exec(g);return l?`${l[1].toLowerCase()}/${l[2].toLowerCase()}${l[3]??""}`:F?void 0:g}t.normalizeMimeType=f}),define(me[106],pe([1,0,5]),function(J,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StopWatch=void 0;const i=y.globals.performance&&typeof y.globals.performance.now=="function";class B{constructor(E){this._highResolution=i&&E,this._startTime=this._now(),this._stopTime=-1}static create(E=!0){return new B(E)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?y.globals.performance.now():Date.now()}}t.StopWatch=B}),define(me[3],pe([1,0,13,42,2,74,106]),function(J,t,y,i,B,M,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Relay=t.EventBufferer=t.EventMultiplexer=t.MicrotaskEmitter=t.DebounceEmitter=t.PauseableEmitter=t.AsyncEmitter=t.EventDeliveryQueue=t.Emitter=t.setGlobalLeakWarningThreshold=t.Event=void 0;const w=!1,m=!1;var f;(function(c){c.None=()=>B.Disposable.None;function u(d){if(m){const{onListenerDidAdd:L}=d,U=e.create();let K=0;d.onListenerDidAdd=()=>{++K==2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),U.print()),L?.()}}}function h(d){return(L,U=null,K)=>{let Q=!1,N;return N=d(R=>{if(!Q)return N?N.dispose():Q=!0,L.call(U,R)},null,K),Q&&N.dispose(),N}}c.once=h;function O(d,L,U){return we((K,Q=null,N)=>d(R=>K.call(Q,L(R)),null,N),U)}c.map=O;function V(d,L,U){return we((K,Q=null,N)=>d(R=>{L(R),K.call(Q,R)},null,N),U)}c.forEach=V;function ue(d,L,U){return we((K,Q=null,N)=>d(R=>L(R)&&K.call(Q,R),null,N),U)}c.filter=ue;function ie(d){return d}c.signal=ie;function ge(...d){return(L,U=null,K)=>(0,B.combinedDisposable)(...d.map(Q=>Q(N=>L.call(U,N),null,K)))}c.any=ge;function ae(d,L,U,K){let Q=U;return O(d,N=>(Q=L(Q,N),Q),K)}c.reduce=ae;function we(d,L){let U;const K={onFirstListenerAdd(){U=d(Q.fire,Q)},onLastListenerRemove(){U?.dispose()}};L||u(K);const Q=new D(K);return L?.add(Q),Q.event}function ce(d,L,U=100,K=!1,Q,N){let R,z,T,W=0;const k={leakWarningThreshold:Q,onFirstListenerAdd(){R=d(x=>{W++,z=L(z,x),K&&!T&&(P.fire(z),z=void 0),clearTimeout(T),T=setTimeout(()=>{const ee=z;z=void 0,T=void 0,(!K||W>1)&&P.fire(ee),W=0},U)})},onLastListenerRemove(){R.dispose()}};N||u(k);const P=new D(k);return N?.add(P),P.event}c.debounce=ce;function re(d,L=(K,Q)=>K===Q,U){let K=!0,Q;return ue(d,N=>{const R=K||!L(N,Q);return K=!1,Q=N,R},U)}c.latch=re;function Ce(d,L,U){return[c.filter(d,L,U),c.filter(d,K=>!L(K),U)]}c.split=Ce;function Ie(d,L=!1,U=[]){let K=U.slice(),Q=d(z=>{K?K.push(z):R.fire(z)});const N=()=>{K?.forEach(z=>R.fire(z)),K=null},R=new D({onFirstListenerAdd(){Q||(Q=d(z=>R.fire(z)))},onFirstListenerDidAdd(){K&&(L?setTimeout(N):N())},onLastListenerRemove(){Q&&Q.dispose(),Q=null}});return R.event}c.buffer=Ie;class ne{constructor(L){this.event=L,this.disposables=new B.DisposableStore}map(L){return new ne(O(this.event,L,this.disposables))}forEach(L){return new ne(V(this.event,L,this.disposables))}filter(L){return new ne(ue(this.event,L,this.disposables))}reduce(L,U){return new ne(ae(this.event,L,U,this.disposables))}latch(){return new ne(re(this.event,void 0,this.disposables))}debounce(L,U=100,K=!1,Q){return new ne(ce(this.event,L,U,K,Q,this.disposables))}on(L,U,K){return this.event(L,U,K)}once(L,U,K){return h(this.event)(L,U,K)}dispose(){this.disposables.dispose()}}function Z(d){return new ne(d)}c.chain=Z;function X(d,L,U=K=>K){const K=(...z)=>R.fire(U(...z)),Q=()=>d.on(L,K),N=()=>d.removeListener(L,K),R=new D({onFirstListenerAdd:Q,onLastListenerRemove:N});return R.event}c.fromNodeEventEmitter=X;function se(d,L,U=K=>K){const K=(...z)=>R.fire(U(...z)),Q=()=>d.addEventListener(L,K),N=()=>d.removeEventListener(L,K),R=new D({onFirstListenerAdd:Q,onLastListenerRemove:N});return R.event}c.fromDOMEventEmitter=se;function te(d){return new Promise(L=>h(d)(L))}c.toPromise=te;function I(d,L){return L(void 0),d(U=>L(U))}c.runAndSubscribe=I;function $(d,L){let U=null;function K(N){U?.dispose(),U=new B.DisposableStore,L(N,U)}K(void 0);const Q=d(N=>K(N));return(0,B.toDisposable)(()=>{Q.dispose(),U?.dispose()})}c.runAndSubscribeWithStore=$;class j{constructor(L,U){this.obs=L,this._counter=0,this._hasChanged=!1;const K={onFirstListenerAdd:()=>{L.addObserver(this)},onLastListenerRemove:()=>{L.removeObserver(this)}};U||u(K),this.emitter=new D(K),U&&U.add(this.emitter)}beginUpdate(L){this._counter++}handleChange(L,U){this._hasChanged=!0}endUpdate(L){--this._counter==0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function H(d,L){return new j(d,L).emitter.event}c.fromObservable=H})(f=t.Event||(t.Event={}));class g{constructor(u){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${u}_${g._idPool++}`}start(u){this._stopWatch=new E.StopWatch(!0),this._listenerCount=u}stop(){if(this._stopWatch){const u=this._stopWatch.elapsed();this._elapsedOverall+=u,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${u.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}g._idPool=0;let F=-1;function l(c){const u=F;return F=c,{dispose(){F=u}}}t.setGlobalLeakWarningThreshold=l;class s{constructor(u,h=Math.random().toString(18).slice(2,5)){this.customThreshold=u,this.name=h,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(u,h){let O=F;if(typeof this.customThreshold=="number"&&(O=this.customThreshold),O<=0||h<O)return;this._stacks||(this._stacks=new Map);const V=this._stacks.get(u.value)||0;if(this._stacks.set(u.value,V+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=O*.5;let ue,ie=0;for(const[ge,ae]of this._stacks)(!ue||ie<ae)&&(ue=ge,ie=ae);console.warn(`[${this.name}] potential listener LEAK detected, having ${h} listeners already. MOST frequent listener (${ie}):`),console.warn(ue)}return()=>{const ue=this._stacks.get(u.value)||0;this._stacks.set(u.value,ue-1)}}}class e{constructor(u){this.value=u}static create(){return new e(new Error().stack??"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class p{constructor(u,h,O){this.callback=u,this.callbackThis=h,this.stack=O,this.subscription=new B.SafeDisposable}invoke(u){this.callback.call(this.callbackThis,u)}}class D{constructor(u){this._disposed=!1,this._options=u,this._leakageMon=F>0?new s(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new g(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(w){const u=Array.from(this._listeners);queueMicrotask(()=>{for(const h of u)h.subscription.isset()&&(h.subscription.unset(),h.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(u,h,O)=>{this._listeners||(this._listeners=new M.LinkedList);const V=this._listeners.isEmpty();V&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let ue,ie;this._leakageMon&&this._listeners.size>=30&&(ie=e.create(),ue=this._leakageMon.check(ie,this._listeners.size+1)),w&&(ie=ie??e.create());const ge=new p(u,h,ie),ae=this._listeners.push(ge);V&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,u,h);const we=ge.subscription.set(()=>{ue?.(),this._disposed||(ae(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return O instanceof B.DisposableStore?O.add(we):Array.isArray(O)&&O.push(we),we}),this._event}fire(u){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new _);for(const h of this._listeners)this._deliveryQueue.push(this,h,u);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}t.Emitter=D;class v{constructor(){this._queue=new M.LinkedList}get size(){return this._queue.size}push(u,h,O){this._queue.push(new a(u,h,O))}clear(u){const h=new M.LinkedList;for(const O of this._queue)O.emitter!==u&&h.push(O);this._queue=h}deliver(){for(;this._queue.size>0;){const u=this._queue.shift();try{u.listener.invoke(u.event)}catch(h){(0,y.onUnexpectedError)(h)}}}}t.EventDeliveryQueue=v;class _ extends v{clear(u){this._queue.clear()}}class a{constructor(u,h,O){this.emitter=u,this.listener=h,this.event=O}}class o extends D{async fireAsync(u,h,O){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new M.LinkedList);for(const V of this._listeners)this._asyncDeliveryQueue.push([V,u]);for(;this._asyncDeliveryQueue.size>0&&!h.isCancellationRequested;){const[V,ue]=this._asyncDeliveryQueue.shift(),ie=[],ge={...ue,token:h,waitUntil:ae=>{if(Object.isFrozen(ie))throw new Error("waitUntil can NOT be called asynchronous");O&&(ae=O(ae,V.callback)),ie.push(ae)}};try{V.invoke(ge)}catch(ae){(0,y.onUnexpectedError)(ae);continue}Object.freeze(ie),await Promise.allSettled(ie).then(ae=>{for(const we of ae)we.status==="rejected"&&(0,y.onUnexpectedError)(we.reason)})}}}}t.AsyncEmitter=o;class b extends D{constructor(u){super(u);this._isPaused=0,this._eventQueue=new M.LinkedList,this._mergeFn=u?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const u=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(u))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(u){this._listeners&&(this._isPaused!==0?this._eventQueue.push(u):super.fire(u))}}t.PauseableEmitter=b;class S extends b{constructor(u){super(u);this._delay=u.delay??100}fire(u){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(u)}}t.DebounceEmitter=S;class A extends D{constructor(u){super(u);this._queuedEvents=[],this._mergeFn=u?.merge}fire(u){this._queuedEvents.push(u),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(h=>super.fire(h)),this._queuedEvents=[]})}}t.MicrotaskEmitter=A;class C{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new D({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(u){const h={event:u,listener:null};this.events.push(h),this.hasListeners&&this.hook(h);const O=()=>{this.hasListeners&&this.unhook(h);const V=this.events.indexOf(h);this.events.splice(V,1)};return(0,B.toDisposable)((0,i.once)(O))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(u=>this.hook(u))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(u=>this.unhook(u))}hook(u){u.listener=u.event(h=>this.emitter.fire(h))}unhook(u){u.listener&&u.listener.dispose(),u.listener=null}dispose(){this.emitter.dispose()}}t.EventMultiplexer=C;class r{constructor(){this.buffers=[]}wrapEvent(u){return(h,O,V)=>u(ue=>{const ie=this.buffers[this.buffers.length-1];ie?ie.push(()=>h.call(O,ue)):h.call(O,ue)},void 0,V)}bufferEvents(u){const h=[];this.buffers.push(h);const O=u();return this.buffers.pop(),h.forEach(V=>V()),O}}t.EventBufferer=r;class n{constructor(){this.listening=!1,this.inputEvent=f.None,this.inputEventListener=B.Disposable.None,this.emitter=new D({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(u){this.inputEvent=u,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=u(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}t.Relay=n}),define(me[15],pe([1,0,3,2]),function(J,t,y,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isStandalone=t.isAndroid=t.isElectron=t.isWebkitWebView=t.isSafari=t.isChrome=t.isWebKit=t.isFirefox=t.onDidChangeFullscreen=t.isFullscreen=t.setFullscreen=t.setZoomFactor=t.getZoomFactor=t.getZoomLevel=t.setZoomLevel=t.PixelRatio=t.addMatchMediaChangeListener=void 0;class B{constructor(){this._zoomLevel=0,this._zoomFactor=1,this._fullscreen=!1,this._onDidChangeFullscreen=new y.Emitter,this.onDidChangeFullscreen=this._onDidChangeFullscreen.event}getZoomLevel(){return this._zoomLevel}setZoomLevel(a,o){this._zoomLevel!==a&&(this._zoomLevel=a)}getZoomFactor(){return this._zoomFactor}setZoomFactor(a){this._zoomFactor=a}setFullscreen(a){this._fullscreen!==a&&(this._fullscreen=a,this._onDidChangeFullscreen.fire())}isFullscreen(){return this._fullscreen}}B.INSTANCE=new B;class M extends i.Disposable{constructor(){super();this._onDidChange=this._register(new y.Emitter),this.onDidChange=this._onDidChange.event,this._listener=()=>this._handleChange(!0),this._mediaQueryList=null,this._handleChange(!1)}_handleChange(a){this._mediaQueryList?.removeEventListener("change",this._listener),this._mediaQueryList=matchMedia(`(resolution: ${window.devicePixelRatio}dppx)`),this._mediaQueryList.addEventListener("change",this._listener),a&&this._onDidChange.fire()}}class E extends i.Disposable{constructor(){super();this._onDidChange=this._register(new y.Emitter),this.onDidChange=this._onDidChange.event,this._value=this._getPixelRatio();const a=this._register(new M);this._register(a.onDidChange(()=>{this._value=this._getPixelRatio(),this._onDidChange.fire(this._value)}))}get value(){return this._value}_getPixelRatio(){const a=document.createElement("canvas").getContext("2d"),o=window.devicePixelRatio||1,b=a.webkitBackingStorePixelRatio||a.mozBackingStorePixelRatio||a.msBackingStorePixelRatio||a.oBackingStorePixelRatio||a.backingStorePixelRatio||1;return o/b}}class w{constructor(){this._pixelRatioMonitor=null}_getOrCreatePixelRatioMonitor(){return this._pixelRatioMonitor||(this._pixelRatioMonitor=(0,i.markAsSingleton)(new E)),this._pixelRatioMonitor}get value(){return this._getOrCreatePixelRatioMonitor().value}get onDidChange(){return this._getOrCreatePixelRatioMonitor().onDidChange}}function m(_,a){typeof _=="string"&&(_=window.matchMedia(_)),_.addEventListener("change",a)}t.addMatchMediaChangeListener=m,t.PixelRatio=new w;function f(_,a){B.INSTANCE.setZoomLevel(_,a)}t.setZoomLevel=f;function g(){return B.INSTANCE.getZoomLevel()}t.getZoomLevel=g;function F(){return B.INSTANCE.getZoomFactor()}t.getZoomFactor=F;function l(_){B.INSTANCE.setZoomFactor(_)}t.setZoomFactor=l;function s(_){B.INSTANCE.setFullscreen(_)}t.setFullscreen=s;function e(){return B.INSTANCE.isFullscreen()}t.isFullscreen=e,t.onDidChangeFullscreen=B.INSTANCE.onDidChangeFullscreen;const p=navigator.userAgent;t.isFirefox=p.indexOf("Firefox")>=0,t.isWebKit=p.indexOf("AppleWebKit")>=0,t.isChrome=p.indexOf("Chrome")>=0,t.isSafari=!t.isChrome&&p.indexOf("Safari")>=0,t.isWebkitWebView=!t.isChrome&&!t.isSafari&&t.isWebKit,t.isElectron=p.indexOf("Electron/")>=0,t.isAndroid=p.indexOf("Android")>=0;let D=!1;if(window.matchMedia){const _=window.matchMedia("(display-mode: standalone)"),a=window.matchMedia("(display-mode: fullscreen)");D=_.matches,m(_,({matches:o})=>{D&&a.matches||(D=o)})}function v(){return D}t.isStandalone=v}),define(me[107],pe([1,0,15,5]),function(J,t,y,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BrowserFeatures=t.KeyboardSupport=void 0;var B;(function(M){M[M.Always=0]="Always",M[M.FullScreen=1]="FullScreen",M[M.None=2]="None"})(B=t.KeyboardSupport||(t.KeyboardSupport={})),t.BrowserFeatures={clipboard:{writeText:i.isNative||document.queryCommandSupported&&document.queryCommandSupported("copy")||!!(navigator&&navigator.clipboard&&navigator.clipboard.writeText),readText:i.isNative||!!(navigator&&navigator.clipboard&&navigator.clipboard.readText)},keyboard:(()=>i.isNative||y.isStandalone()?0:navigator.keyboard||y.isSafari?1:2)(),touch:"ontouchstart"in window||navigator.maxTouchPoints>0,pointerEvents:window.PointerEvent&&("ontouchstart"in window||window.navigator.maxTouchPoints>0||navigator.maxTouchPoints>0)}}),define(me[18],pe([1,0,3]),function(J,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DomEmitter=void 0;class i{constructor(M,E,w){const m=f=>this.emitter.fire(f);this.emitter=new y.Emitter({onFirstListenerAdd:()=>M.addEventListener(E,m,w),onLastListenerRemove:()=>M.removeEventListener(E,m,w)})}get event(){return this.emitter.event}dispose(){this.emitter.dispose()}}t.DomEmitter=i}),define(me[19],pe([1,0,15,43,72,5]),function(J,t,y,i,B,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StandardKeyboardEvent=t.printStandardKeyboardEvent=t.printKeyboardEvent=void 0;function E(e){if(e.charCode){const D=String.fromCharCode(e.charCode).toUpperCase();return i.KeyCodeUtils.fromString(D)}const p=e.keyCode;if(p===3)return 7;if(y.isFirefox){if(p===59)return 80;if(p===107)return 81;if(p===109)return 83;if(M.isMacintosh&&p===224)return 57}else if(y.isWebKit){if(p===91)return 57;if(M.isMacintosh&&p===93)return 57;if(!M.isMacintosh&&p===92)return 57}return i.EVENT_KEY_CODE_MAP[p]||0}const w=M.isMacintosh?256:2048,m=512,f=1024,g=M.isMacintosh?2048:256;function F(e){const p=[];return e.ctrlKey&&p.push("ctrl"),e.shiftKey&&p.push("shift"),e.altKey&&p.push("alt"),e.metaKey&&p.push("meta"),`modifiers: [${p.join(",")}], code: ${e.code}, keyCode: ${e.keyCode}, key: ${e.key}`}t.printKeyboardEvent=F;function l(e){const p=[];return e.ctrlKey&&p.push("ctrl"),e.shiftKey&&p.push("shift"),e.altKey&&p.push("alt"),e.metaKey&&p.push("meta"),`modifiers: [${p.join(",")}], code: ${e.code}, keyCode: ${e.keyCode} ('${i.KeyCodeUtils.toString(e.keyCode)}')`}t.printStandardKeyboardEvent=l;class s{constructor(p){this._standardKeyboardEventBrand=!0;const D=p;this.browserEvent=D,this.target=D.target,this.ctrlKey=D.ctrlKey,this.shiftKey=D.shiftKey,this.altKey=D.altKey,this.metaKey=D.metaKey,this.keyCode=E(D),this.code=D.code,this.ctrlKey=this.ctrlKey||this.keyCode===5,this.altKey=this.altKey||this.keyCode===6,this.shiftKey=this.shiftKey||this.keyCode===4,this.metaKey=this.metaKey||this.keyCode===57,this._asKeybinding=this._computeKeybinding(),this._asRuntimeKeybinding=this._computeRuntimeKeybinding()}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()}toKeybinding(){return this._asRuntimeKeybinding}equals(p){return this._asKeybinding===p}_computeKeybinding(){let p=0;this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(p=this.keyCode);let D=0;return this.ctrlKey&&(D|=w),this.altKey&&(D|=m),this.shiftKey&&(D|=f),this.metaKey&&(D|=g),D|=p,D}_computeRuntimeKeybinding(){let p=0;return this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(p=this.keyCode),new B.SimpleKeybinding(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,p)}}t.StandardKeyboardEvent=s}),define(me[20],pe([1,0,15,65,5]),function(J,t,y,i,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StandardWheelEvent=t.DragMouseEvent=t.StandardMouseEvent=void 0;class M{constructor(f){this.timestamp=Date.now(),this.browserEvent=f,this.leftButton=f.button===0,this.middleButton=f.button===1,this.rightButton=f.button===2,this.buttons=f.buttons,this.target=f.target,this.detail=f.detail||1,f.type==="dblclick"&&(this.detail=2),this.ctrlKey=f.ctrlKey,this.shiftKey=f.shiftKey,this.altKey=f.altKey,this.metaKey=f.metaKey,typeof f.pageX=="number"?(this.posx=f.pageX,this.posy=f.pageY):(this.posx=f.clientX+document.body.scrollLeft+document.documentElement.scrollLeft,this.posy=f.clientY+document.body.scrollTop+document.documentElement.scrollTop);const g=i.IframeUtils.getPositionOfChildWindowRelativeToAncestorWindow(self,f.view);this.posx-=g.left,this.posy-=g.top}preventDefault(){this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent.stopPropagation()}}t.StandardMouseEvent=M;class E extends M{constructor(f){super(f);this.dataTransfer=f.dataTransfer}}t.DragMouseEvent=E;class w{constructor(f,g=0,F=0){if(this.browserEvent=f||null,this.target=f?f.target||f.targetNode||f.srcElement:null,this.deltaY=F,this.deltaX=g,f){const l=f,s=f;if(typeof l.wheelDeltaY!="undefined")this.deltaY=l.wheelDeltaY/120;else if(typeof s.VERTICAL_AXIS!="undefined"&&s.axis===s.VERTICAL_AXIS)this.deltaY=-s.detail/3;else if(f.type==="wheel"){const e=f;e.deltaMode===e.DOM_DELTA_LINE?y.isFirefox&&!B.isMacintosh?this.deltaY=-f.deltaY/3:this.deltaY=-f.deltaY:this.deltaY=-f.deltaY/40}if(typeof l.wheelDeltaX!="undefined")y.isSafari&&B.isWindows?this.deltaX=-(l.wheelDeltaX/120):this.deltaX=l.wheelDeltaX/120;else if(typeof s.HORIZONTAL_AXIS!="undefined"&&s.axis===s.HORIZONTAL_AXIS)this.deltaX=-f.detail/3;else if(f.type==="wheel"){const e=f;e.deltaMode===e.DOM_DELTA_LINE?y.isFirefox&&!B.isMacintosh?this.deltaX=-f.deltaX/3:this.deltaX=-f.deltaX:this.deltaX=-f.deltaX/40}this.deltaY===0&&this.deltaX===0&&f.wheelDelta&&(this.deltaY=f.wheelDelta/120)}}preventDefault(){this.browserEvent?.preventDefault()}stopPropagation(){this.browserEvent?.stopPropagation()}}t.StandardWheelEvent=w}),define(me[32],pe([1,0,3,2,102]),function(J,t,y,i,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toAction=t.EmptySubmenuAction=t.SubmenuAction=t.Separator=t.ActionRunner=t.Action=void 0;class M extends i.Disposable{constructor(l,s="",e="",p=!0,D){super();this._onDidChange=this._register(new y.Emitter),this.onDidChange=this._onDidChange.event,this._enabled=!0,this._id=l,this._label=s,this._cssClass=e,this._enabled=p,this._actionCallback=D}get id(){return this._id}get label(){return this._label}set label(l){this._setLabel(l)}_setLabel(l){this._label!==l&&(this._label=l,this._onDidChange.fire({label:l}))}get tooltip(){return this._tooltip||""}set tooltip(l){this._setTooltip(l)}_setTooltip(l){this._tooltip!==l&&(this._tooltip=l,this._onDidChange.fire({tooltip:l}))}get class(){return this._cssClass}set class(l){this._setClass(l)}_setClass(l){this._cssClass!==l&&(this._cssClass=l,this._onDidChange.fire({class:l}))}get enabled(){return this._enabled}set enabled(l){this._setEnabled(l)}_setEnabled(l){this._enabled!==l&&(this._enabled=l,this._onDidChange.fire({enabled:l}))}get checked(){return this._checked}set checked(l){this._setChecked(l)}_setChecked(l){this._checked!==l&&(this._checked=l,this._onDidChange.fire({checked:l}))}async run(l,s){this._actionCallback&&await this._actionCallback(l)}}t.Action=M;class E extends i.Disposable{constructor(){super(...arguments);this._onBeforeRun=this._register(new y.Emitter),this.onBeforeRun=this._onBeforeRun.event,this._onDidRun=this._register(new y.Emitter),this.onDidRun=this._onDidRun.event}async run(l,s){if(!l.enabled)return;this._onBeforeRun.fire({action:l});let e;try{await this.runAction(l,s)}catch(p){e=p}this._onDidRun.fire({action:l,error:e})}async runAction(l,s){await l.run(s)}}t.ActionRunner=E;class w extends M{constructor(l){super(w.ID,l,l?"separator text":"separator");this.checked=!1,this.enabled=!1}static join(...l){let s=[];for(const e of l)e.length&&(s.length?s=[...s,new w,...e]:s=e);return s}}t.Separator=w,w.ID="vs.actions.separator";class m{constructor(l,s,e,p){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=l,this.label=s,this.class=p,this._actions=e}get actions(){return this._actions}dispose(){}async run(){}}t.SubmenuAction=m;class f extends M{constructor(){super(f.ID,B.localize(0,null),void 0,!1)}}t.EmptySubmenuAction=f,f.ID="vs.actions.empty";function g(F){return{id:F.id,label:F.label,class:void 0,enabled:F.enabled??!0,checked:F.checked??!1,run:async()=>F.run(),tooltip:F.label,dispose:()=>{}}}t.toAction=g}),define(me[28],pe([1,0,3]),function(J,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CancellationTokenSource=t.CancellationToken=void 0;const i=Object.freeze(function(w,m){const f=setTimeout(w.bind(m),0);return{dispose(){clearTimeout(f)}}});var B;(function(w){function m(f){return f===w.None||f===w.Cancelled||f instanceof M?!0:!f||typeof f!="object"?!1:typeof f.isCancellationRequested=="boolean"&&typeof f.onCancellationRequested=="function"}w.isCancellationToken=m,w.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:y.Event.None}),w.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:i})})(B=t.CancellationToken||(t.CancellationToken={}));class M{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?i:(this._emitter||(this._emitter=new y.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class E{constructor(m){this._token=void 0,this._parentListener=void 0,this._parentListener=m&&m.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new M),this._token}cancel(){this._token?this._token instanceof M&&this._token.cancel():this._token=B.Cancelled}dispose(m=!1){m&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof M&&this._token.dispose():this._token=B.None}}t.CancellationTokenSource=E}),define(me[108],pe([1,0,28]),function(J,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedFunction=t.LRUCachedFunction=t.Cache=void 0;class i{constructor(w){this.task=w,this.result=null}get(){if(this.result)return this.result;const w=new y.CancellationTokenSource,m=this.task(w.token);return this.result={promise:m,dispose:()=>{this.result=null,w.cancel(),w.dispose()}},this.result}}t.Cache=i;class B{constructor(w){this.fn=w,this.lastCache=void 0,this.lastArgKey=void 0}get(w){const m=JSON.stringify(w);return this.lastArgKey!==m&&(this.lastArgKey=m,this.lastCache=this.fn(w)),this.lastCache}}t.LRUCachedFunction=B;class M{constructor(w){this.fn=w,this._map=new Map}get cachedValues(){return this._map}get(w){if(this._map.has(w))return this._map.get(w);const m=this.fn(w);return this._map.set(w,m),m}}t.CachedFunction=M}),define(me[47],pe([1,0,3,2]),function(J,t,y,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SmoothScrollingOperation=t.SmoothScrollingUpdate=t.Scrollable=t.ScrollState=t.ScrollbarVisibility=void 0;var B;(function(s){s[s.Auto=1]="Auto",s[s.Hidden=2]="Hidden",s[s.Visible=3]="Visible"})(B=t.ScrollbarVisibility||(t.ScrollbarVisibility={}));class M{constructor(e,p,D,v,_,a,o){this._forceIntegerValues=e,this._scrollStateBrand=void 0,this._forceIntegerValues&&(p=p|0,D=D|0,v=v|0,_=_|0,a=a|0,o=o|0),this.rawScrollLeft=v,this.rawScrollTop=o,p<0&&(p=0),v+p>D&&(v=D-p),v<0&&(v=0),_<0&&(_=0),o+_>a&&(o=a-_),o<0&&(o=0),this.width=p,this.scrollWidth=D,this.scrollLeft=v,this.height=_,this.scrollHeight=a,this.scrollTop=o}equals(e){return this.rawScrollLeft===e.rawScrollLeft&&this.rawScrollTop===e.rawScrollTop&&this.width===e.width&&this.scrollWidth===e.scrollWidth&&this.scrollLeft===e.scrollLeft&&this.height===e.height&&this.scrollHeight===e.scrollHeight&&this.scrollTop===e.scrollTop}withScrollDimensions(e,p){return new M(this._forceIntegerValues,typeof e.width!="undefined"?e.width:this.width,typeof e.scrollWidth!="undefined"?e.scrollWidth:this.scrollWidth,p?this.rawScrollLeft:this.scrollLeft,typeof e.height!="undefined"?e.height:this.height,typeof e.scrollHeight!="undefined"?e.scrollHeight:this.scrollHeight,p?this.rawScrollTop:this.scrollTop)}withScrollPosition(e){return new M(this._forceIntegerValues,this.width,this.scrollWidth,typeof e.scrollLeft!="undefined"?e.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof e.scrollTop!="undefined"?e.scrollTop:this.rawScrollTop)}createScrollEvent(e,p){const D=this.width!==e.width,v=this.scrollWidth!==e.scrollWidth,_=this.scrollLeft!==e.scrollLeft,a=this.height!==e.height,o=this.scrollHeight!==e.scrollHeight,b=this.scrollTop!==e.scrollTop;return{inSmoothScrolling:p,oldWidth:e.width,oldScrollWidth:e.scrollWidth,oldScrollLeft:e.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:e.height,oldScrollHeight:e.scrollHeight,oldScrollTop:e.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:D,scrollWidthChanged:v,scrollLeftChanged:_,heightChanged:a,scrollHeightChanged:o,scrollTopChanged:b}}}t.ScrollState=M;class E extends i.Disposable{constructor(e){super();this._scrollableBrand=void 0,this._onScroll=this._register(new y.Emitter),this.onScroll=this._onScroll.event,this._smoothScrollDuration=e.smoothScrollDuration,this._scheduleAtNextAnimationFrame=e.scheduleAtNextAnimationFrame,this._state=new M(e.forceIntegerValues,0,0,0,0,0,0),this._smoothScrolling=null}dispose(){this._smoothScrolling&&(this._smoothScrolling.dispose(),this._smoothScrolling=null),super.dispose()}setSmoothScrollDuration(e){this._smoothScrollDuration=e}validateScrollPosition(e){return this._state.withScrollPosition(e)}getScrollDimensions(){return this._state}setScrollDimensions(e,p){const D=this._state.withScrollDimensions(e,p);this._setState(D,Boolean(this._smoothScrolling)),this._smoothScrolling?.acceptScrollDimensions(this._state)}getFutureScrollPosition(){return this._smoothScrolling?this._smoothScrolling.to:this._state}getCurrentScrollPosition(){return this._state}setScrollPositionNow(e){const p=this._state.withScrollPosition(e);this._smoothScrolling&&(this._smoothScrolling.dispose(),this._smoothScrolling=null),this._setState(p,!1)}setScrollPositionSmooth(e,p){if(this._smoothScrollDuration===0)return this.setScrollPositionNow(e);if(this._smoothScrolling){e={scrollLeft:typeof e.scrollLeft=="undefined"?this._smoothScrolling.to.scrollLeft:e.scrollLeft,scrollTop:typeof e.scrollTop=="undefined"?this._smoothScrolling.to.scrollTop:e.scrollTop};const D=this._state.withScrollPosition(e);if(this._smoothScrolling.to.scrollLeft===D.scrollLeft&&this._smoothScrolling.to.scrollTop===D.scrollTop)return;let v;p?v=new g(this._smoothScrolling.from,D,this._smoothScrolling.startTime,this._smoothScrolling.duration):v=this._smoothScrolling.combine(this._state,D,this._smoothScrollDuration),this._smoothScrolling.dispose(),this._smoothScrolling=v}else{const D=this._state.withScrollPosition(e);this._smoothScrolling=g.start(this._state,D,this._smoothScrollDuration)}this._smoothScrolling.animationFrameDisposable=this._scheduleAtNextAnimationFrame(()=>{!this._smoothScrolling||(this._smoothScrolling.animationFrameDisposable=null,this._performSmoothScrolling())})}_performSmoothScrolling(){if(!this._smoothScrolling)return;const e=this._smoothScrolling.tick(),p=this._state.withScrollPosition(e);if(this._setState(p,!0),!!this._smoothScrolling){if(e.isDone){this._smoothScrolling.dispose(),this._smoothScrolling=null;return}this._smoothScrolling.animationFrameDisposable=this._scheduleAtNextAnimationFrame(()=>{!this._smoothScrolling||(this._smoothScrolling.animationFrameDisposable=null,this._performSmoothScrolling())})}}_setState(e,p){const D=this._state;D.equals(e)||(this._state=e,this._onScroll.fire(this._state.createScrollEvent(D,p)))}}t.Scrollable=E;class w{constructor(e,p,D){this.scrollLeft=e,this.scrollTop=p,this.isDone=D}}t.SmoothScrollingUpdate=w;function m(s,e){const p=e-s;return function(D){return s+p*l(D)}}function f(s,e,p){return function(D){return D<p?s(D/p):e((D-p)/(1-p))}}class g{constructor(e,p,D,v){this.from=e,this.to=p,this.duration=v,this.startTime=D,this.animationFrameDisposable=null,this._initAnimations()}_initAnimations(){this.scrollLeft=this._initAnimation(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.scrollTop=this._initAnimation(this.from.scrollTop,this.to.scrollTop,this.to.height)}_initAnimation(e,p,D){if(Math.abs(e-p)>2.5*D){let _,a;return e<p?(_=e+.75*D,a=p-.75*D):(_=e-.75*D,a=p+.75*D),f(m(e,_),m(a,p),.33)}return m(e,p)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(e){this.to=e.withScrollPosition(this.to),this._initAnimations()}tick(){return this._tick(Date.now())}_tick(e){const p=(e-this.startTime)/this.duration;if(p<1){const D=this.scrollLeft(p),v=this.scrollTop(p);return new w(D,v,!1)}return new w(this.to.scrollLeft,this.to.scrollTop,!0)}combine(e,p,D){return g.start(e,p,D)}static start(e,p,D){D=D+10;const v=Date.now()-10;return new g(e,p,v,D)}}t.SmoothScrollingOperation=g;function F(s){return Math.pow(s,3)}function l(s){return 1-F(1-s)}}),define(me[10],pe([1,0,108,73]),function(J,t,y,i){"use strict";var B;Object.defineProperty(t,"__esModule",{value:!0}),t.InvisibleCharacters=t.AmbiguousCharacters=t.noBreakWhitespace=t.getLeftDeleteOffset=t.GraphemeBreakType=t.getGraphemeBreakType=t.singleLetterHash=t.getNLines=t.uppercaseFirstLetter=t.containsUppercaseCharacter=t.fuzzyContains=t.stripUTF8BOM=t.startsWithUTF8BOM=t.UTF8_BOM_CHARACTER=t.removeAnsiEscapeCodes=t.lcut=t.isEmojiImprecise=t.isFullWidthCharacter=t.containsUnusualLineTerminators=t.UNUSUAL_LINE_TERMINATORS=t.isBasicASCII=t.containsRTL=t.getCharContainingOffset=t.prevCharLength=t.nextCharLength=t.GraphemeIterator=t.CodePointIterator=t.getNextCodePoint=t.computeCodePoint=t.isLowSurrogate=t.isHighSurrogate=t.commonSuffixLength=t.commonPrefixLength=t.startsWithIgnoreCase=t.equalsIgnoreCase=t.isUpperAsciiLetter=t.isLowerAsciiLetter=t.isAsciiDigit=t.compareSubstringIgnoreCase=t.compareIgnoreCase=t.compareSubstring=t.compare=t.replaceAsync=t.lastNonWhitespaceIndex=t.getLeadingWhitespace=t.firstNonWhitespaceIndex=t.splitLines=t.regExpFlags=t.regExpContainsBackreference=t.regExpLeadsToEndlessLoop=t.createRegExp=t.stripWildcards=t.convertSimple2RegExpPattern=t.rtrim=t.ltrim=t.trim=t.truncate=t.count=t.escapeRegExpCharacters=t.escape=t.format2=t.format=t.isFalsyOrWhitespace=void 0;function M(q){return!q||typeof q!="string"?!0:q.trim().length===0}t.isFalsyOrWhitespace=M;const E=/{(\d+)}/g;function w(q,...oe){return oe.length===0?q:q.replace(E,function(be,Ee){const Ae=parseInt(Ee,10);return isNaN(Ae)||Ae<0||Ae>=oe.length?be:oe[Ae]})}t.format=w;const m=/{([^}]+)}/g;function f(q,oe){return q.replace(m,(be,Ee)=>oe[Ee]??be)}t.format2=f;function g(q){return q.replace(/[<>&]/g,function(oe){switch(oe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return oe}})}t.escape=g;function F(q){return q.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.escapeRegExpCharacters=F;function l(q,oe){let be=0;const Ee=oe.charCodeAt(0);for(let Ae=q.length-1;Ae>=0;Ae--)q.charCodeAt(Ae)===Ee&&be++;return be}t.count=l;function s(q,oe,be="\u2026"){return q.length<=oe?q:`${q.substr(0,oe)}${be}`}t.truncate=s;function e(q,oe=" "){const be=p(q,oe);return D(be,oe)}t.trim=e;function p(q,oe){if(!q||!oe)return q;const be=oe.length;if(be===0||q.length===0)return q;let Ee=0;for(;q.indexOf(oe,Ee)===Ee;)Ee=Ee+be;return q.substring(Ee)}t.ltrim=p;function D(q,oe){if(!q||!oe)return q;const be=oe.length,Ee=q.length;if(be===0||Ee===0)return q;let Ae=Ee,Me=-1;for(;Me=q.lastIndexOf(oe,Ae-1),!(Me===-1||Me+be!==Ae);){if(Me===0)return"";Ae=Me}return q.substring(0,Ae)}t.rtrim=D;function v(q){return q.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.convertSimple2RegExpPattern=v;function _(q){return q.replace(/\*/g,"")}t.stripWildcards=_;function a(q,oe,be={}){if(!q)throw new Error("Cannot create regex from empty string");oe||(q=F(q)),be.wholeWord&&(/\B/.test(q.charAt(0))||(q="\\b"+q),/\B/.test(q.charAt(q.length-1))||(q=q+"\\b"));let Ee="";return be.global&&(Ee+="g"),be.matchCase||(Ee+="i"),be.multiline&&(Ee+="m"),be.unicode&&(Ee+="u"),new RegExp(q,Ee)}t.createRegExp=a;function o(q){return q.source==="^"||q.source==="^$"||q.source==="$"||q.source==="^\\s*$"?!1:!!(q.exec("")&&q.lastIndex===0)}t.regExpLeadsToEndlessLoop=o;function b(q){return!!q.match(/([^\\]|^)(\\\\)*\\\d+/)}t.regExpContainsBackreference=b;function S(q){return(q.global?"g":"")+(q.ignoreCase?"i":"")+(q.multiline?"m":"")+(q.unicode?"u":"")}t.regExpFlags=S;function A(q){return q.split(/\r\n|\r|\n/)}t.splitLines=A;function C(q){for(let oe=0,be=q.length;oe<be;oe++){const Ee=q.charCodeAt(oe);if(Ee!==32&&Ee!==9)return oe}return-1}t.firstNonWhitespaceIndex=C;function r(q,oe=0,be=q.length){for(let Ee=oe;Ee<be;Ee++){const Ae=q.charCodeAt(Ee);if(Ae!==32&&Ae!==9)return q.substring(oe,Ee)}return q.substring(oe,be)}t.getLeadingWhitespace=r;function n(q,oe=q.length-1){for(let be=oe;be>=0;be--){const Ee=q.charCodeAt(be);if(Ee!==32&&Ee!==9)return be}return-1}t.lastNonWhitespaceIndex=n;function c(q,oe,be){const Ee=[];let Ae=0;for(const Me of q.matchAll(oe)){if(Ee.push(q.slice(Ae,Me.index)),Me.index===void 0)throw new Error("match.index should be defined");Ae=Me.index+Me[0].length,Ee.push(be(Me[0],...Me.slice(1),Me.index,q,Me.groups))}return Ee.push(q.slice(Ae)),Promise.all(Ee).then(Me=>Me.join(""))}t.replaceAsync=c;function u(q,oe){return q<oe?-1:q>oe?1:0}t.compare=u;function h(q,oe,be=0,Ee=q.length,Ae=0,Me=oe.length){for(;be<Ee&&Ae<Me;be++,Ae++){const Ye=q.charCodeAt(be),qe=oe.charCodeAt(Ae);if(Ye<qe)return-1;if(Ye>qe)return 1}const Ve=Ee-be,tt=Me-Ae;return Ve<tt?-1:Ve>tt?1:0}t.compareSubstring=h;function O(q,oe){return V(q,oe,0,q.length,0,oe.length)}t.compareIgnoreCase=O;function V(q,oe,be=0,Ee=q.length,Ae=0,Me=oe.length){for(;be<Ee&&Ae<Me;be++,Ae++){let Ye=q.charCodeAt(be),qe=oe.charCodeAt(Ae);if(Ye===qe)continue;if(Ye>=128||qe>=128)return h(q.toLowerCase(),oe.toLowerCase(),be,Ee,Ae,Me);ie(Ye)&&(Ye-=32),ie(qe)&&(qe-=32);const Le=Ye-qe;if(Le!==0)return Le}const Ve=Ee-be,tt=Me-Ae;return Ve<tt?-1:Ve>tt?1:0}t.compareSubstringIgnoreCase=V;function ue(q){return q>=48&&q<=57}t.isAsciiDigit=ue;function ie(q){return q>=97&&q<=122}t.isLowerAsciiLetter=ie;function ge(q){return q>=65&&q<=90}t.isUpperAsciiLetter=ge;function ae(q,oe){return q.length===oe.length&&V(q,oe)===0}t.equalsIgnoreCase=ae;function we(q,oe){const be=oe.length;return oe.length>q.length?!1:V(q,oe,0,be)===0}t.startsWithIgnoreCase=we;function ce(q,oe){const be=Math.min(q.length,oe.length);let Ee;for(Ee=0;Ee<be;Ee++)if(q.charCodeAt(Ee)!==oe.charCodeAt(Ee))return Ee;return be}t.commonPrefixLength=ce;function re(q,oe){const be=Math.min(q.length,oe.length);let Ee;const Ae=q.length-1,Me=oe.length-1;for(Ee=0;Ee<be;Ee++)if(q.charCodeAt(Ae-Ee)!==oe.charCodeAt(Me-Ee))return Ee;return be}t.commonSuffixLength=re;function Ce(q){return 55296<=q&&q<=56319}t.isHighSurrogate=Ce;function Ie(q){return 56320<=q&&q<=57343}t.isLowSurrogate=Ie;function ne(q,oe){return(q-55296<<10)+(oe-56320)+65536}t.computeCodePoint=ne;function Z(q,oe,be){const Ee=q.charCodeAt(be);if(Ce(Ee)&&be+1<oe){const Ae=q.charCodeAt(be+1);if(Ie(Ae))return ne(Ee,Ae)}return Ee}t.getNextCodePoint=Z;function X(q,oe){const be=q.charCodeAt(oe-1);if(Ie(be)&&oe>1){const Ee=q.charCodeAt(oe-2);if(Ce(Ee))return ne(Ee,be)}return be}class se{constructor(oe,be=0){this._str=oe,this._len=oe.length,this._offset=be}get offset(){return this._offset}setOffset(oe){this._offset=oe}prevCodePoint(){const oe=X(this._str,this._offset);return this._offset-=oe>=65536?2:1,oe}nextCodePoint(){const oe=Z(this._str,this._len,this._offset);return this._offset+=oe>=65536?2:1,oe}eol(){return this._offset>=this._len}}t.CodePointIterator=se;class te{constructor(oe,be=0){this._iterator=new se(oe,be)}get offset(){return this._iterator.offset}nextGraphemeLength(){const oe=Pe.getInstance(),be=this._iterator,Ee=be.offset;let Ae=oe.getGraphemeBreakType(be.nextCodePoint());for(;!be.eol();){const Me=be.offset,Ve=oe.getGraphemeBreakType(be.nextCodePoint());if(Fe(Ae,Ve)){be.setOffset(Me);break}Ae=Ve}return be.offset-Ee}prevGraphemeLength(){const oe=Pe.getInstance(),be=this._iterator,Ee=be.offset;let Ae=oe.getGraphemeBreakType(be.prevCodePoint());for(;be.offset>0;){const Me=be.offset,Ve=oe.getGraphemeBreakType(be.prevCodePoint());if(Fe(Ve,Ae)){be.setOffset(Me);break}Ae=Ve}return Ee-be.offset}eol(){return this._iterator.eol()}}t.GraphemeIterator=te;function I(q,oe){return new te(q,oe).nextGraphemeLength()}t.nextCharLength=I;function $(q,oe){return new te(q,oe).prevGraphemeLength()}t.prevCharLength=$;function j(q,oe){oe>0&&Ie(q.charCodeAt(oe))&&oe--;const be=oe+I(q,oe);return[be-$(q,be),be]}t.getCharContainingOffset=j;const H=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function d(q){return H.test(q)}t.containsRTL=d;const L=/^[\t\n\r\x20-\x7E]*$/;function U(q){return L.test(q)}t.isBasicASCII=U,t.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function K(q){return t.UNUSUAL_LINE_TERMINATORS.test(q)}t.containsUnusualLineTerminators=K;function Q(q){return q>=11904&&q<=55215||q>=63744&&q<=64255||q>=65281&&q<=65374}t.isFullWidthCharacter=Q;function N(q){return q>=127462&&q<=127487||q===8986||q===8987||q===9200||q===9203||q>=9728&&q<=10175||q===11088||q===11093||q>=127744&&q<=128591||q>=128640&&q<=128764||q>=128992&&q<=129008||q>=129280&&q<=129535||q>=129648&&q<=129782}t.isEmojiImprecise=N;function R(q,oe){if(q.length<oe)return q;const be=/\b/g;let Ee=0;for(;be.test(q)&&!(q.length-be.lastIndex<oe);)Ee=be.lastIndex,be.lastIndex+=1;return q.substring(Ee).replace(/^\s/,"")}t.lcut=R;const z=/\x1B\x5B[12]?K/g,T=/\x1b\[\d+m/g,W=/\x1b\[0?m/g;function k(q){return q&&(q=q.replace(z,""),q=q.replace(T,""),q=q.replace(W,"")),q}t.removeAnsiEscapeCodes=k,t.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function P(q){return!!(q&&q.length>0&&q.charCodeAt(0)===65279)}t.startsWithUTF8BOM=P;function x(q){return P(q)?q.substr(1):q}t.stripUTF8BOM=x;function ee(q,oe){if(!q||!oe||q.length<oe.length)return!1;const be=oe.length,Ee=q.toLowerCase();let Ae=0,Me=-1;for(;Ae<be;){const Ve=Ee.indexOf(oe[Ae],Me+1);if(Ve<0)return!1;Me=Ve,Ae++}return!0}t.fuzzyContains=ee;function he(q,oe=!1){return q?(oe&&(q=q.replace(/\\./g,"")),q.toLowerCase()!==q):!1}t.containsUppercaseCharacter=he;function de(q){return q.charAt(0).toUpperCase()+q.slice(1)}t.uppercaseFirstLetter=de;function De(q,oe=1){if(oe===0)return"";let be=-1;do be=q.indexOf(`
`,be+1),oe--;while(oe>0&&be>=0);return be===-1?q:(q[be-1]==="\r"&&be--,q.substr(0,be))}t.getNLines=De;function ye(q){const oe=90-65+1;return q=q%(2*oe),q<oe?String.fromCharCode(97+q):String.fromCharCode(65+q-oe)}t.singleLetterHash=ye;function ke(q){return Pe.getInstance().getGraphemeBreakType(q)}t.getGraphemeBreakType=ke;function Fe(q,oe){return q===0?oe!==5&&oe!==7:q===2&&oe===3?!1:q===4||q===2||q===3||oe===4||oe===2||oe===3?!0:!(q===8&&(oe===8||oe===9||oe===11||oe===12)||(q===11||q===9)&&(oe===9||oe===10)||(q===12||q===10)&&oe===10||oe===5||oe===13||oe===7||q===1||q===13&&oe===14||q===6&&oe===6)}var ve;(function(q){q[q.Other=0]="Other",q[q.Prepend=1]="Prepend",q[q.CR=2]="CR",q[q.LF=3]="LF",q[q.Control=4]="Control",q[q.Extend=5]="Extend",q[q.Regional_Indicator=6]="Regional_Indicator",q[q.SpacingMark=7]="SpacingMark",q[q.L=8]="L",q[q.V=9]="V",q[q.T=10]="T",q[q.LV=11]="LV",q[q.LVT=12]="LVT",q[q.ZWJ=13]="ZWJ",q[q.Extended_Pictographic=14]="Extended_Pictographic"})(ve=t.GraphemeBreakType||(t.GraphemeBreakType={}));class Pe{constructor(){this._data=Re()}static getInstance(){return Pe._INSTANCE||(Pe._INSTANCE=new Pe),Pe._INSTANCE}getGraphemeBreakType(oe){if(oe<32)return oe===10?3:oe===13?2:4;if(oe<127)return 0;const be=this._data,Ee=be.length/3;let Ae=1;for(;Ae<=Ee;)if(oe<be[3*Ae])Ae=2*Ae;else if(oe>be[3*Ae+1])Ae=2*Ae+1;else return be[3*Ae+2];return 0}}Pe._INSTANCE=null;function Re(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ge(q,oe){if(q===0)return 0;const be=He(q,oe);if(be!==void 0)return be;const Ee=new se(oe,q);return Ee.prevCodePoint(),Ee.offset}t.getLeftDeleteOffset=Ge;function He(q,oe){const be=new se(oe,q);let Ee=be.prevCodePoint();for(;ze(Ee)||Ee===65039||Ee===8419;){if(be.offset===0)return;Ee=be.prevCodePoint()}if(!N(Ee))return;let Ae=be.offset;return Ae>0&&be.prevCodePoint()===8205&&(Ae=be.offset),Ae}function ze(q){return 127995<=q&&q<=127999}var Xe;(function(q){q[q.zwj=8205]="zwj",q[q.emojiVariantSelector=65039]="emojiVariantSelector",q[q.enclosingKeyCap=8419]="enclosingKeyCap"})(Xe||(Xe={})),t.noBreakWhitespace="\xA0";class je{constructor(oe){this.confusableDictionary=oe}static getInstance(oe){return je.cache.get(Array.from(oe))}static getLocales(){return je._locales.getValue()}isAmbiguous(oe){return this.confusableDictionary.has(oe)}getPrimaryConfusable(oe){return this.confusableDictionary.get(oe)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}t.AmbiguousCharacters=je,B=je,je.ambiguousCharacterData=new i.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),je.cache=new y.LRUCachedFunction(q=>{function oe(qe){const Le=new Map;for(let le=0;le<qe.length;le+=2)Le.set(qe[le],qe[le+1]);return Le}function be(qe,Le){const le=new Map(qe);for(const[_e,Ne]of Le)le.set(_e,Ne);return le}function Ee(qe,Le){if(!qe)return Le;const le=new Map;for(const[_e,Ne]of qe)Le.has(_e)&&le.set(_e,Ne);return le}const Ae=B.ambiguousCharacterData.getValue();let Me=q.filter(qe=>!qe.startsWith("_")&&qe in Ae);Me.length===0&&(Me=["_default"]);let Ve;for(const qe of Me){const Le=oe(Ae[qe]);Ve=Ee(Ve,Le)}const tt=oe(Ae._common),Ye=be(tt,Ve);return new je(Ye)}),je._locales=new i.Lazy(()=>Object.keys(je.ambiguousCharacterData.getValue()).filter(q=>!q.startsWith("_")));class Oe{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Oe.getRawData())),this._data}static isInvisibleCharacter(oe){return Oe.getData().has(oe)}static get codePoints(){return Oe.getData()}}t.InvisibleCharacters=Oe,Oe._data=void 0}),define(me[109],pe([1,0,21,5,10,6]),function(J,t,y,i,B,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.randomPath=t.parseLineAndColumnAware=t.indexOfPath=t.getDriveLetter=t.hasDriveLetter=t.isRootOrDriveLetter=t.sanitizeFilePath=t.isWindowsDriveLetter=t.isEqualOrParent=t.isEqual=t.isValidBasename=t.isUNC=t.getRoot=t.toPosixPath=t.toSlashes=t.isPathSeparator=void 0;function E(n){return n===47||n===92}t.isPathSeparator=E;function w(n){return n.replace(/[\\/]/g,y.posix.sep)}t.toSlashes=w;function m(n){return n.indexOf("/")===-1&&(n=w(n)),/^[a-zA-Z]:(\/|$)/.test(n)&&(n="/"+n),n}t.toPosixPath=m;function f(n,c=y.posix.sep){if(!n)return"";const u=n.length,h=n.charCodeAt(0);if(E(h)){if(E(n.charCodeAt(1))&&!E(n.charCodeAt(2))){let V=3;const ue=V;for(;V<u&&!E(n.charCodeAt(V));V++);if(ue!==V&&!E(n.charCodeAt(V+1))){for(V+=1;V<u;V++)if(E(n.charCodeAt(V)))return n.slice(0,V+1).replace(/[\\/]/g,c)}}return c}else if(v(h)&&n.charCodeAt(1)===58)return E(n.charCodeAt(2))?n.slice(0,2)+c:n.slice(0,2);let O=n.indexOf("://");if(O!==-1){for(O+=3;O<u;O++)if(E(n.charCodeAt(O)))return n.slice(0,O+1)}return""}t.getRoot=f;function g(n){if(!i.isWindows||!n||n.length<5)return!1;let c=n.charCodeAt(0);if(c!==92||(c=n.charCodeAt(1),c!==92))return!1;let u=2;const h=u;for(;u<n.length&&(c=n.charCodeAt(u),c!==92);u++);return!(h===u||(c=n.charCodeAt(u+1),isNaN(c)||c===92))}t.isUNC=g;const F=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,s=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function e(n,c=i.isWindows){const u=c?F:l;return!(!n||n.length===0||/^\s+$/.test(n)||(u.lastIndex=0,u.test(n))||c&&s.test(n)||n==="."||n===".."||c&&n[n.length-1]==="."||c&&n.length!==n.trim().length||n.length>255)}t.isValidBasename=e;function p(n,c,u){const h=n===c;return!u||h?h:!n||!c?!1:(0,B.equalsIgnoreCase)(n,c)}t.isEqual=p;function D(n,c,u,h=y.sep){if(n===c)return!0;if(!n||!c||c.length>n.length)return!1;if(u){if(!(0,B.startsWithIgnoreCase)(n,c))return!1;if(c.length===n.length)return!0;let V=c.length;return c.charAt(c.length-1)===h&&V--,n.charAt(V)===h}return c.charAt(c.length-1)!==h&&(c+=h),n.indexOf(c)===0}t.isEqualOrParent=D;function v(n){return n>=65&&n<=90||n>=97&&n<=122}t.isWindowsDriveLetter=v;function _(n,c){return i.isWindows&&n.endsWith(":")&&(n+=y.sep),(0,y.isAbsolute)(n)||(n=(0,y.join)(c,n)),n=(0,y.normalize)(n),i.isWindows?(n=(0,B.rtrim)(n,y.sep),n.endsWith(":")&&(n+=y.sep)):(n=(0,B.rtrim)(n,y.sep),n||(n=y.sep)),n}t.sanitizeFilePath=_;function a(n){const c=(0,y.normalize)(n);return i.isWindows?n.length>3?!1:o(c)&&(n.length===2||c.charCodeAt(2)===92):c===y.posix.sep}t.isRootOrDriveLetter=a;function o(n,c=i.isWindows){return c?v(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}t.hasDriveLetter=o;function b(n){return o(n)?n[0]:void 0}t.getDriveLetter=b;function S(n,c,u){return c.length>n.length?-1:n===c?0:(u&&(n=n.toLowerCase(),c=c.toLowerCase()),n.indexOf(c))}t.indexOfPath=S;function A(n){const c=n.split(":");let u,h,O;for(const V of c){const ue=Number(V);(0,M.isNumber)(ue)?h===void 0?h=ue:O===void 0&&(O=ue):u=u?[u,V].join(":"):V}if(!u)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:u,line:h!==void 0?h:void 0,column:O!==void 0?O:h!==void 0?1:void 0}}t.parseLineAndColumnAware=A;const C="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function r(n,c,u=8){let h="";for(let V=0;V<u;V++)h+=C.charAt(Math.floor(Math.random()*C.length));let O;return c?O=`${c}-${h}`:O=h,n?(0,y.join)(n,O):O}t.randomPath=r}),define(me[110],pe([1,0,10]),function(J,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.toHexString=t.Hasher=t.stringHash=t.numberHash=t.doHash=t.hash=void 0;function i(v){return B(v,0)}t.hash=i;function B(v,_){switch(typeof v){case"object":return v===null?M(349,_):Array.isArray(v)?m(v,_):f(v,_);case"string":return w(v,_);case"boolean":return E(v,_);case"number":return M(v,_);case"undefined":return M(937,_);default:return M(617,_)}}t.doHash=B;function M(v,_){return(_<<5)-_+v|0}t.numberHash=M;function E(v,_){return M(v?433:863,_)}function w(v,_){_=M(149417,_);for(let a=0,o=v.length;a<o;a++)_=M(v.charCodeAt(a),_);return _}t.stringHash=w;function m(v,_){return _=M(104579,_),v.reduce((a,o)=>B(o,a),_)}function f(v,_){return _=M(181387,_),Object.keys(v).sort().reduce((a,o)=>(a=w(o,a),B(v[o],a)),_)}class g{constructor(){this._value=0}get value(){return this._value}hash(_){return this._value=B(_,this._value),this._value}}t.Hasher=g;var F;(function(v){v[v.BLOCK_SIZE=64]="BLOCK_SIZE",v[v.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(F||(F={}));function l(v,_,a=32){const o=a-_,b=~((1<<o)-1);return(v<<_|(b&v)>>>o)>>>0}function s(v,_=0,a=v.byteLength,o=0){for(let b=0;b<a;b++)v[_+b]=o}function e(v,_,a="0"){for(;v.length<_;)v=a+v;return v}function p(v,_=32){return v instanceof ArrayBuffer?Array.from(new Uint8Array(v)).map(a=>a.toString(16).padStart(2,"0")).join(""):e((v>>>0).toString(16),_/4)}t.toHexString=p;class D{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(_){const a=_.length;if(a===0)return;const o=this._buff;let b=this._buffLen,S=this._leftoverHighSurrogate,A,C;for(S!==0?(A=S,C=-1,S=0):(A=_.charCodeAt(0),C=0);;){let r=A;if(y.isHighSurrogate(A))if(C+1<a){const n=_.charCodeAt(C+1);y.isLowSurrogate(n)?(C++,r=y.computeCodePoint(A,n)):r=65533}else{S=A;break}else y.isLowSurrogate(A)&&(r=65533);if(b=this._push(o,b,r),C++,C<a)A=_.charCodeAt(C);else break}this._buffLen=b,this._leftoverHighSurrogate=S}_push(_,a,o){return o<128?_[a++]=o:o<2048?(_[a++]=192|(o&1984)>>>6,_[a++]=128|(o&63)>>>0):o<65536?(_[a++]=224|(o&61440)>>>12,_[a++]=128|(o&4032)>>>6,_[a++]=128|(o&63)>>>0):(_[a++]=240|(o&1835008)>>>18,_[a++]=128|(o&258048)>>>12,_[a++]=128|(o&4032)>>>6,_[a++]=128|(o&63)>>>0),a>=64&&(this._step(),a-=64,this._totalLen+=64,_[0]=_[64+0],_[1]=_[64+1],_[2]=_[64+2]),a}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),p(this._h0)+p(this._h1)+p(this._h2)+p(this._h3)+p(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,s(this._buff,this._buffLen),this._buffLen>56&&(this._step(),s(this._buff));const _=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(_/4294967296),!1),this._buffDV.setUint32(60,_%4294967296,!1),this._step()}_step(){const _=D._bigBlock32,a=this._buffDV;for(let u=0;u<64;u+=4)_.setUint32(u,a.getUint32(u,!1),!1);for(let u=64;u<320;u+=4)_.setUint32(u,l(_.getUint32(u-12,!1)^_.getUint32(u-32,!1)^_.getUint32(u-56,!1)^_.getUint32(u-64,!1),1),!1);let o=this._h0,b=this._h1,S=this._h2,A=this._h3,C=this._h4,r,n,c;for(let u=0;u<80;u++)u<20?(r=b&S|~b&A,n=1518500249):u<40?(r=b^S^A,n=1859775393):u<60?(r=b&S|b&A|S&A,n=2400959708):(r=b^S^A,n=3395469782),c=l(o,5)+r+C+n+_.getUint32(u*4,!1)&4294967295,C=A,A=S,S=l(b,30),b=o,o=c;this._h0=this._h0+o&4294967295,this._h1=this._h1+b&4294967295,this._h2=this._h2+S&4294967295,this._h3=this._h3+A&4294967295,this._h4=this._h4+C&4294967295}}t.StringSHA1=D,D._bigBlock32=new DataView(new ArrayBuffer(320))}),define(me[111],pe([1,0,70,110]),function(J,t,y,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LcsDiff=t.MyArray=t.Debug=t.stringDiff=t.StringDiffSequence=void 0;class B{constructor(l){this.source=l}getElements(){const l=this.source,s=new Int32Array(l.length);for(let e=0,p=l.length;e<p;e++)s[e]=l.charCodeAt(e);return s}}t.StringDiffSequence=B;function M(F,l,s){return new g(new B(F),new B(l)).ComputeDiff(s).changes}t.stringDiff=M;class E{static Assert(l,s){if(!l)throw new Error(s)}}t.Debug=E;class w{static Copy(l,s,e,p,D){for(let v=0;v<D;v++)e[p+v]=l[s+v]}static Copy2(l,s,e,p,D){for(let v=0;v<D;v++)e[p+v]=l[s+v]}}t.MyArray=w;var m;(function(F){F[F.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(m||(m={}));class f{constructor(){this.m_changes=[],this.m_originalStart=1073741824,this.m_modifiedStart=1073741824,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new y.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=1073741824,this.m_modifiedStart=1073741824}AddOriginalElement(l,s){this.m_originalStart=Math.min(this.m_originalStart,l),this.m_modifiedStart=Math.min(this.m_modifiedStart,s),this.m_originalCount++}AddModifiedElement(l,s){this.m_originalStart=Math.min(this.m_originalStart,l),this.m_modifiedStart=Math.min(this.m_modifiedStart,s),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class g{constructor(l,s,e=null){this.ContinueProcessingPredicate=e,this._originalSequence=l,this._modifiedSequence=s;const[p,D,v]=g._getElements(l),[_,a,o]=g._getElements(s);this._hasStrings=v&&o,this._originalStringElements=p,this._originalElementsOrHash=D,this._modifiedStringElements=_,this._modifiedElementsOrHash=a,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(l){return l.length>0&&typeof l[0]=="string"}static _getElements(l){const s=l.getElements();if(g._isStringArray(s)){const e=new Int32Array(s.length);for(let p=0,D=s.length;p<D;p++)e[p]=(0,i.stringHash)(s[p],0);return[s,e,!0]}return s instanceof Int32Array?[[],s,!1]:[[],new Int32Array(s),!1]}ElementsAreEqual(l,s){return this._originalElementsOrHash[l]!==this._modifiedElementsOrHash[s]?!1:this._hasStrings?this._originalStringElements[l]===this._modifiedStringElements[s]:!0}ElementsAreStrictEqual(l,s){if(!this.ElementsAreEqual(l,s))return!1;const e=g._getStrictElement(this._originalSequence,l),p=g._getStrictElement(this._modifiedSequence,s);return e===p}static _getStrictElement(l,s){return typeof l.getStrictElement=="function"?l.getStrictElement(s):null}OriginalElementsAreEqual(l,s){return this._originalElementsOrHash[l]!==this._originalElementsOrHash[s]?!1:this._hasStrings?this._originalStringElements[l]===this._originalStringElements[s]:!0}ModifiedElementsAreEqual(l,s){return this._modifiedElementsOrHash[l]!==this._modifiedElementsOrHash[s]?!1:this._hasStrings?this._modifiedStringElements[l]===this._modifiedStringElements[s]:!0}ComputeDiff(l){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,l)}_ComputeDiff(l,s,e,p,D){const v=[!1];let _=this.ComputeDiffRecursive(l,s,e,p,v);return D&&(_=this.PrettifyChanges(_)),{quitEarly:v[0],changes:_}}ComputeDiffRecursive(l,s,e,p,D){for(D[0]=!1;l<=s&&e<=p&&this.ElementsAreEqual(l,e);)l++,e++;for(;s>=l&&p>=e&&this.ElementsAreEqual(s,p);)s--,p--;if(l>s||e>p){let S;return e<=p?(E.Assert(l===s+1,"originalStart should only be one more than originalEnd"),S=[new y.DiffChange(l,0,e,p-e+1)]):l<=s?(E.Assert(e===p+1,"modifiedStart should only be one more than modifiedEnd"),S=[new y.DiffChange(l,s-l+1,e,0)]):(E.Assert(l===s+1,"originalStart should only be one more than originalEnd"),E.Assert(e===p+1,"modifiedStart should only be one more than modifiedEnd"),S=[]),S}const v=[0],_=[0],a=this.ComputeRecursionPoint(l,s,e,p,v,_,D),o=v[0],b=_[0];if(a!==null)return a;if(!D[0]){const S=this.ComputeDiffRecursive(l,o,e,b,D);let A=[];return D[0]?A=[new y.DiffChange(o+1,s-(o+1)+1,b+1,p-(b+1)+1)]:A=this.ComputeDiffRecursive(o+1,s,b+1,p,D),this.ConcatenateChanges(S,A)}return[new y.DiffChange(l,s-l+1,e,p-e+1)]}WALKTRACE(l,s,e,p,D,v,_,a,o,b,S,A,C,r,n,c,u,h){let O=null,V=null,ue=new f,ie=s,ge=e,ae=C[0]-c[0]-p,we=-1073741824,ce=this.m_forwardHistory.length-1;do{const re=ae+l;re===ie||re<ge&&o[re-1]<o[re+1]?(S=o[re+1],r=S-ae-p,S<we&&ue.MarkNextChange(),we=S,ue.AddModifiedElement(S+1,r),ae=re+1-l):(S=o[re-1]+1,r=S-ae-p,S<we&&ue.MarkNextChange(),we=S-1,ue.AddOriginalElement(S,r+1),ae=re-1-l),ce>=0&&(o=this.m_forwardHistory[ce],l=o[0],ie=1,ge=o.length-1)}while(--ce>=-1);if(O=ue.getReverseChanges(),h[0]){let re=C[0]+1,Ce=c[0]+1;if(O!==null&&O.length>0){const Ie=O[O.length-1];re=Math.max(re,Ie.getOriginalEnd()),Ce=Math.max(Ce,Ie.getModifiedEnd())}V=[new y.DiffChange(re,A-re+1,Ce,n-Ce+1)]}else{ue=new f,ie=v,ge=_,ae=C[0]-c[0]-a,we=1073741824,ce=u?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const re=ae+D;re===ie||re<ge&&b[re-1]>=b[re+1]?(S=b[re+1]-1,r=S-ae-a,S>we&&ue.MarkNextChange(),we=S+1,ue.AddOriginalElement(S+1,r+1),ae=re+1-D):(S=b[re-1],r=S-ae-a,S>we&&ue.MarkNextChange(),we=S,ue.AddModifiedElement(S+1,r+1),ae=re-1-D),ce>=0&&(b=this.m_reverseHistory[ce],D=b[0],ie=1,ge=b.length-1)}while(--ce>=-1);V=ue.getChanges()}return this.ConcatenateChanges(O,V)}ComputeRecursionPoint(l,s,e,p,D,v,_){let a=0,o=0,b=0,S=0,A=0,C=0;l--,e--,D[0]=0,v[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const r=s-l+(p-e),n=r+1,c=new Int32Array(n),u=new Int32Array(n),h=p-e,O=s-l,V=l-e,ue=s-p,ge=(O-h)%2==0;c[h]=l,u[O]=s,_[0]=!1;for(let ae=1;ae<=r/2+1;ae++){let we=0,ce=0;b=this.ClipDiagonalBound(h-ae,ae,h,n),S=this.ClipDiagonalBound(h+ae,ae,h,n);for(let Ce=b;Ce<=S;Ce+=2){Ce===b||Ce<S&&c[Ce-1]<c[Ce+1]?a=c[Ce+1]:a=c[Ce-1]+1,o=a-(Ce-h)-V;const Ie=a;for(;a<s&&o<p&&this.ElementsAreEqual(a+1,o+1);)a++,o++;if(c[Ce]=a,a+o>we+ce&&(we=a,ce=o),!ge&&Math.abs(Ce-O)<=ae-1&&a>=u[Ce])return D[0]=a,v[0]=o,Ie<=u[Ce]&&1447>0&&ae<=1447+1?this.WALKTRACE(h,b,S,V,O,A,C,ue,c,u,a,s,D,o,p,v,ge,_):null}const re=(we-l+(ce-e)-ae)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(we,re))return _[0]=!0,D[0]=we,v[0]=ce,re>0&&1447>0&&ae<=1447+1?this.WALKTRACE(h,b,S,V,O,A,C,ue,c,u,a,s,D,o,p,v,ge,_):(l++,e++,[new y.DiffChange(l,s-l+1,e,p-e+1)]);A=this.ClipDiagonalBound(O-ae,ae,O,n),C=this.ClipDiagonalBound(O+ae,ae,O,n);for(let Ce=A;Ce<=C;Ce+=2){Ce===A||Ce<C&&u[Ce-1]>=u[Ce+1]?a=u[Ce+1]-1:a=u[Ce-1],o=a-(Ce-O)-ue;const Ie=a;for(;a>l&&o>e&&this.ElementsAreEqual(a,o);)a--,o--;if(u[Ce]=a,ge&&Math.abs(Ce-h)<=ae&&a<=c[Ce])return D[0]=a,v[0]=o,Ie>=c[Ce]&&1447>0&&ae<=1447+1?this.WALKTRACE(h,b,S,V,O,A,C,ue,c,u,a,s,D,o,p,v,ge,_):null}if(ae<=1447){let Ce=new Int32Array(S-b+2);Ce[0]=h-b+1,w.Copy2(c,b,Ce,1,S-b+1),this.m_forwardHistory.push(Ce),Ce=new Int32Array(C-A+2),Ce[0]=O-A+1,w.Copy2(u,A,Ce,1,C-A+1),this.m_reverseHistory.push(Ce)}}return this.WALKTRACE(h,b,S,V,O,A,C,ue,c,u,a,s,D,o,p,v,ge,_)}PrettifyChanges(l){for(let s=0;s<l.length;s++){const e=l[s],p=s<l.length-1?l[s+1].originalStart:this._originalElementsOrHash.length,D=s<l.length-1?l[s+1].modifiedStart:this._modifiedElementsOrHash.length,v=e.originalLength>0,_=e.modifiedLength>0;for(;e.originalStart+e.originalLength<p&&e.modifiedStart+e.modifiedLength<D&&(!v||this.OriginalElementsAreEqual(e.originalStart,e.originalStart+e.originalLength))&&(!_||this.ModifiedElementsAreEqual(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const o=this.ElementsAreStrictEqual(e.originalStart,e.modifiedStart);if(this.ElementsAreStrictEqual(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!o)break;e.originalStart++,e.modifiedStart++}const a=[null];if(s<l.length-1&&this.ChangesOverlap(l[s],l[s+1],a)){l[s]=a[0],l.splice(s+1,1),s--;continue}}for(let s=l.length-1;s>=0;s--){const e=l[s];let p=0,D=0;if(s>0){const S=l[s-1];p=S.originalStart+S.originalLength,D=S.modifiedStart+S.modifiedLength}const v=e.originalLength>0,_=e.modifiedLength>0;let a=0,o=this._boundaryScore(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let S=1;;S++){const A=e.originalStart-S,C=e.modifiedStart-S;if(A<p||C<D||v&&!this.OriginalElementsAreEqual(A,A+e.originalLength)||_&&!this.ModifiedElementsAreEqual(C,C+e.modifiedLength))break;const n=(A===p&&C===D?5:0)+this._boundaryScore(A,e.originalLength,C,e.modifiedLength);n>o&&(o=n,a=S)}e.originalStart-=a,e.modifiedStart-=a;const b=[null];if(s>0&&this.ChangesOverlap(l[s-1],l[s],b)){l[s-1]=b[0],l.splice(s,1),s++;continue}}if(this._hasStrings)for(let s=1,e=l.length;s<e;s++){const p=l[s-1],D=l[s],v=D.originalStart-p.originalStart-p.originalLength,_=p.originalStart,a=D.originalStart+D.originalLength,o=a-_,b=p.modifiedStart,S=D.modifiedStart+D.modifiedLength,A=S-b;if(v<5&&o<20&&A<20){const C=this._findBetterContiguousSequence(_,o,b,A,v);if(C){const[r,n]=C;(r!==p.originalStart+p.originalLength||n!==p.modifiedStart+p.modifiedLength)&&(p.originalLength=r-p.originalStart,p.modifiedLength=n-p.modifiedStart,D.originalStart=r+v,D.modifiedStart=n+v,D.originalLength=a-D.originalStart,D.modifiedLength=S-D.modifiedStart)}}}return l}_findBetterContiguousSequence(l,s,e,p,D){if(s<D||p<D)return null;const v=l+s-D+1,_=e+p-D+1;let a=0,o=0,b=0;for(let S=l;S<v;S++)for(let A=e;A<_;A++){const C=this._contiguousSequenceScore(S,A,D);C>0&&C>a&&(a=C,o=S,b=A)}return a>0?[o,b]:null}_contiguousSequenceScore(l,s,e){let p=0;for(let D=0;D<e;D++){if(!this.ElementsAreEqual(l+D,s+D))return 0;p+=this._originalStringElements[l+D].length}return p}_OriginalIsBoundary(l){return l<=0||l>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[l])}_OriginalRegionIsBoundary(l,s){if(this._OriginalIsBoundary(l)||this._OriginalIsBoundary(l-1))return!0;if(s>0){const e=l+s;if(this._OriginalIsBoundary(e-1)||this._OriginalIsBoundary(e))return!0}return!1}_ModifiedIsBoundary(l){return l<=0||l>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[l])}_ModifiedRegionIsBoundary(l,s){if(this._ModifiedIsBoundary(l)||this._ModifiedIsBoundary(l-1))return!0;if(s>0){const e=l+s;if(this._ModifiedIsBoundary(e-1)||this._ModifiedIsBoundary(e))return!0}return!1}_boundaryScore(l,s,e,p){const D=this._OriginalRegionIsBoundary(l,s)?1:0,v=this._ModifiedRegionIsBoundary(e,p)?1:0;return D+v}ConcatenateChanges(l,s){const e=[];if(l.length===0||s.length===0)return s.length>0?s:l;if(this.ChangesOverlap(l[l.length-1],s[0],e)){const p=new Array(l.length+s.length-1);return w.Copy(l,0,p,0,l.length-1),p[l.length-1]=e[0],w.Copy(s,1,p,l.length,s.length-1),p}else{const p=new Array(l.length+s.length);return w.Copy(l,0,p,0,l.length),w.Copy(s,0,p,l.length,s.length),p}}ChangesOverlap(l,s,e){if(E.Assert(l.originalStart<=s.originalStart,"Left change is not less than or equal to right change"),E.Assert(l.modifiedStart<=s.modifiedStart,"Left change is not less than or equal to right change"),l.originalStart+l.originalLength>=s.originalStart||l.modifiedStart+l.modifiedLength>=s.modifiedStart){const p=l.originalStart;let D=l.originalLength;const v=l.modifiedStart;let _=l.modifiedLength;return l.originalStart+l.originalLength>=s.originalStart&&(D=s.originalStart+s.originalLength-l.originalStart),l.modifiedStart+l.modifiedLength>=s.modifiedStart&&(_=s.modifiedStart+s.modifiedLength-l.modifiedStart),e[0]=new y.DiffChange(p,D,v,_),!0}else return e[0]=null,!1}ClipDiagonalBound(l,s,e,p){if(l>=0&&l<p)return l;const D=e,v=p-e-1,_=s%2==0;if(l<0){const a=D%2==0;return _===a?0:1}else{const a=v%2==0;return _===a?p-1:p-2}}}t.LcsDiff=g}),define(me[48],pe([1,0,14,10]),function(J,t,y,i){"use strict";var B,M,E;Object.defineProperty(t,"__esModule",{value:!0}),t.LRUCache=t.LinkedMap=t.Touch=t.ResourceSet=t.ResourceMap=t.TernarySearchTree=t.UriIterator=t.PathIterator=t.ConfigKeysIterator=t.StringIterator=t.setToString=t.mapToString=t.getOrSet=void 0;function w(C,r,n){let c=C.get(r);return c===void 0&&(c=n,C.set(r,c)),c}t.getOrSet=w;function m(C){const r=[];return C.forEach((n,c)=>{r.push(`${c} => ${n}`)}),`Map(${C.size}) {${r.join(", ")}}`}t.mapToString=m;function f(C){const r=[];return C.forEach(n=>{r.push(n)}),`Set(${C.size}) {${r.join(", ")}}`}t.setToString=f;class g{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const n=r.charCodeAt(0),c=this._value.charCodeAt(this._pos);return n-c}value(){return this._value[this._pos]}}t.StringIterator=g;class F{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,i.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,i.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}t.ConfigKeysIterator=F;class l{constructor(r=!0,n=!0){this._splitOnBackslash=r,this._caseSensitive=n}reset(r){this._from=0,this._to=0,this._value=r,this._valueLen=r.length;for(let n=r.length-1;n>=0;n--,this._valueLen--){const c=this._value.charCodeAt(n);if(!(c===47||this._splitOnBackslash&&c===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let r=!0;for(;this._to<this._valueLen;this._to++){const n=this._value.charCodeAt(this._to);if(n===47||this._splitOnBackslash&&n===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,i.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,i.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}t.PathIterator=l;var s;(function(C){C[C.Scheme=1]="Scheme",C[C.Authority=2]="Authority",C[C.Path=3]="Path",C[C.Query=4]="Query",C[C.Fragment=5]="Fragment"})(s||(s={}));class e{constructor(r,n){this._ignorePathCasing=r,this._ignoreQueryAndFragment=n,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new l(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(r)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,i.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,i.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,i.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,i.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}t.UriIterator=e;class p{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const r=this.right;return this.right=r.left,r.left=this,this.updateHeight(),r.updateHeight(),r}rotateRight(){const r=this.left;return this.left=r.right,r.right=this,this.updateHeight(),r.updateHeight(),r}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var D;(function(C){C[C.Left=-1]="Left",C[C.Mid=0]="Mid",C[C.Right=1]="Right"})(D||(D={}));class v{constructor(r){this._iter=r}static forUris(r=()=>!1,n=()=>!1){return new v(new e(r,n))}static forPaths(r=!1){return new v(new l(void 0,!r))}static forStrings(){return new v(new g)}static forConfigKeys(){return new v(new F)}clear(){this._root=void 0}fill(r,n){if(n){const c=n.slice(0);(0,y.shuffle)(c);for(const u of c)this.set(u,r)}else{const c=r.slice(0);(0,y.shuffle)(c);for(const u of c)this.set(u[0],u[1])}}set(r,n){const c=this._iter.reset(r);let u;this._root||(this._root=new p,this._root.segment=c.value());const h=[];for(u=this._root;;){const V=c.cmp(u.segment);if(V>0)u.left||(u.left=new p,u.left.segment=c.value()),h.push([-1,u]),u=u.left;else if(V<0)u.right||(u.right=new p,u.right.segment=c.value()),h.push([1,u]),u=u.right;else if(c.hasNext())c.next(),u.mid||(u.mid=new p,u.mid.segment=c.value()),h.push([0,u]),u=u.mid;else break}const O=u.value;u.value=n,u.key=r;for(let V=h.length-1;V>=0;V--){const ue=h[V][1];ue.updateHeight();const ie=ue.balanceFactor();if(ie<-1||ie>1){const ge=h[V][0],ae=h[V+1][0];if(ge===1&&ae===1)h[V][1]=ue.rotateLeft();else if(ge===-1&&ae===-1)h[V][1]=ue.rotateRight();else if(ge===1&&ae===-1)ue.right=h[V+1][1]=h[V+1][1].rotateRight(),h[V][1]=ue.rotateLeft();else if(ge===-1&&ae===1)ue.left=h[V+1][1]=h[V+1][1].rotateLeft(),h[V][1]=ue.rotateRight();else throw new Error;if(V>0)switch(h[V-1][0]){case-1:h[V-1][1].left=h[V][1];break;case 1:h[V-1][1].right=h[V][1];break;case 0:h[V-1][1].mid=h[V][1];break}else this._root=h[0][1]}}return O}get(r){return this._getNode(r)?.value}_getNode(r){const n=this._iter.reset(r);let c=this._root;for(;c;){const u=n.cmp(c.segment);if(u>0)c=c.left;else if(u<0)c=c.right;else if(n.hasNext())n.next(),c=c.mid;else break}return c}has(r){const n=this._getNode(r);return!(n?.value===void 0&&n?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,n){const c=this._iter.reset(r),u=[];let h=this._root;for(;h;){const O=c.cmp(h.segment);if(O>0)u.push([-1,h]),h=h.left;else if(O<0)u.push([1,h]),h=h.right;else if(c.hasNext())c.next(),u.push([0,h]),h=h.mid;else break}if(!!h){if(n?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const O=this._min(h.right),{key:V,value:ue,segment:ie}=O;this._delete(O.key,!1),h.key=V,h.value=ue,h.segment=ie}else{const O=h.left??h.right;if(u.length>0){const[V,ue]=u[u.length-1];switch(V){case-1:ue.left=O;break;case 0:ue.mid=O;break;case 1:ue.right=O;break}}else this._root=O}for(let O=u.length-1;O>=0;O--){const V=u[O][1];V.updateHeight();const ue=V.balanceFactor();if(ue>1?(V.right.balanceFactor()>=0||(V.right=V.right.rotateRight()),u[O][1]=V.rotateLeft()):ue<-1&&(V.left.balanceFactor()<=0||(V.left=V.left.rotateLeft()),u[O][1]=V.rotateRight()),O>0)switch(u[O-1][0]){case-1:u[O-1][1].left=u[O][1];break;case 1:u[O-1][1].right=u[O][1];break;case 0:u[O-1][1].mid=u[O][1];break}else this._root=u[0][1]}}}_min(r){for(;r.left;)r=r.left;return r}findSubstr(r){const n=this._iter.reset(r);let c=this._root,u;for(;c;){const h=n.cmp(c.segment);if(h>0)c=c.left;else if(h<0)c=c.right;else if(n.hasNext())n.next(),u=c.value||u,c=c.mid;else break}return c&&c.value||u}findSuperstr(r){const n=this._iter.reset(r);let c=this._root;for(;c;){const u=n.cmp(c.segment);if(u>0)c=c.left;else if(u<0)c=c.right;else if(n.hasNext())n.next(),c=c.mid;else return c.mid?this._entries(c.mid):void 0}}forEach(r){for(const[n,c]of this)r(c,n)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(r){const n=[];return this._dfsEntries(r,n),n[Symbol.iterator]()}_dfsEntries(r,n){!r||(r.left&&this._dfsEntries(r.left,n),r.value&&n.push([r.key,r.value]),r.mid&&this._dfsEntries(r.mid,n),r.right&&this._dfsEntries(r.right,n))}_isBalanced(){const r=n=>{if(!n)return!0;const c=n.balanceFactor();return c<-1||c>1?!1:r(n.left)&&r(n.right)};return r(this._root)}}t.TernarySearchTree=v;class _{constructor(r,n){this.uri=r,this.value=n}}class a{constructor(r,n){this[B]="ResourceMap",r instanceof a?(this.map=new Map(r.map),this.toKey=n??a.defaultToKey):(this.map=new Map,this.toKey=r??a.defaultToKey)}set(r,n){return this.map.set(this.toKey(r),new _(r,n)),this}get(r){return this.map.get(this.toKey(r))?.value}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,n){typeof n!="undefined"&&(r=r.bind(n));for(const[c,u]of this.map)r(u.value,u.uri,this)}*values(){for(const r of this.map.values())yield r.value}*keys(){for(const r of this.map.values())yield r.uri}*entries(){for(const r of this.map.values())yield[r.uri,r.value]}*[(B=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.map)yield[r.uri,r.value]}}t.ResourceMap=a,a.defaultToKey=C=>C.toString();class o{constructor(r,n){this[M]="ResourceSet",!r||typeof r=="function"?this._map=new a(r):(this._map=new a(n),r.forEach(this.add,this))}get size(){return this._map.size}add(r){return this._map.set(r,r),this}clear(){this._map.clear()}delete(r){return this._map.delete(r)}forEach(r,n){this._map.forEach((c,u)=>r.call(n,u,u,this))}has(r){return this._map.has(r)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(M=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.ResourceSet=o;var b;(function(C){C[C.None=0]="None",C[C.AsOld=1]="AsOld",C[C.AsNew=2]="AsNew"})(b=t.Touch||(t.Touch={}));class S{constructor(){this[E]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,n=0){const c=this._map.get(r);if(!!c)return n!==0&&this.touch(c,n),c.value}set(r,n,c=0){let u=this._map.get(r);if(u)u.value=n,c!==0&&this.touch(u,c);else{switch(u={key:r,value:n,next:void 0,previous:void 0},c){case 0:this.addItemLast(u);break;case 1:this.addItemFirst(u);break;case 2:this.addItemLast(u);break;default:this.addItemLast(u);break}this._map.set(r,u),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const n=this._map.get(r);if(!!n)return this._map.delete(r),this.removeItem(n),this._size--,n.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,n){const c=this._state;let u=this._head;for(;u;){if(n?r.bind(n)(u.value,u.key,this):r(u.value,u.key,this),this._state!==c)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const r=this,n=this._state;let c=this._head;const u={[Symbol.iterator](){return u},next(){if(r._state!==n)throw new Error("LinkedMap got modified during iteration.");if(c){const h={value:c.key,done:!1};return c=c.next,h}else return{value:void 0,done:!0}}};return u}values(){const r=this,n=this._state;let c=this._head;const u={[Symbol.iterator](){return u},next(){if(r._state!==n)throw new Error("LinkedMap got modified during iteration.");if(c){const h={value:c.value,done:!1};return c=c.next,h}else return{value:void 0,done:!0}}};return u}entries(){const r=this,n=this._state;let c=this._head;const u={[Symbol.iterator](){return u},next(){if(r._state!==n)throw new Error("LinkedMap got modified during iteration.");if(c){const h={value:[c.key,c.value],done:!1};return c=c.next,h}else return{value:void 0,done:!0}}};return u}[(E=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let n=this._head,c=this.size;for(;n&&c>r;)this._map.delete(n.key),n=n.next,c--;this._head=n,this._size=c,n&&(n.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const n=r.next,c=r.previous;if(!n||!c)throw new Error("Invalid list");n.previous=c,c.next=n}r.next=void 0,r.previous=void 0,this._state++}touch(r,n){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(n!==1&&n!==2)){if(n===1){if(r===this._head)return;const c=r.next,u=r.previous;r===this._tail?(u.next=void 0,this._tail=u):(c.previous=u,u.next=c),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(n===2){if(r===this._tail)return;const c=r.next,u=r.previous;r===this._head?(c.previous=void 0,this._head=c):(c.previous=u,u.next=c),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((n,c)=>{r.push([c,n])}),r}fromJSON(r){this.clear();for(const[n,c]of r)this.set(n,c)}}t.LinkedMap=S;class A extends S{constructor(r,n=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,n),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,n=2){return super.get(r,n)}peek(r){return super.get(r,0)}set(r,n){return super.set(r,n,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}t.LRUCache=A}),define(me[33],pe([1,0,48,10]),function(J,t,y,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.fuzzyScoreGraceful=t.fuzzyScoreGracefulAggressive=t.fuzzyScore=t.FuzzyScoreOptions=t.FuzzyScore=t.isPatternInWord=t.createMatches=t.anyScore=t.matchesFuzzy2=t.matchesFuzzy=t.matchesWords=t.matchesCamelCase=t.isUpper=t.matchesSubString=t.matchesContiguousSubString=t.matchesPrefix=t.matchesStrictPrefix=t.or=void 0;function B(...k){return function(P,x){for(let ee=0,he=k.length;ee<he;ee++){const de=k[ee](P,x);if(de)return de}return null}}t.or=B,t.matchesStrictPrefix=M.bind(void 0,!1),t.matchesPrefix=M.bind(void 0,!0);function M(k,P,x){if(!x||x.length<P.length)return null;let ee;return k?ee=i.startsWithIgnoreCase(x,P):ee=x.indexOf(P)===0,ee?P.length>0?[{start:0,end:P.length}]:[]:null}function E(k,P){const x=P.toLowerCase().indexOf(k.toLowerCase());return x===-1?null:[{start:x,end:x+k.length}]}t.matchesContiguousSubString=E;function w(k,P){return m(k.toLowerCase(),P.toLowerCase(),0,0)}t.matchesSubString=w;function m(k,P,x,ee){if(x===k.length)return[];if(ee===P.length)return null;if(k[x]===P[ee]){let he=null;return(he=m(k,P,x+1,ee+1))?v({start:ee,end:ee+1},he):null}return m(k,P,x,ee+1)}function f(k){return 97<=k&&k<=122}function g(k){return 65<=k&&k<=90}t.isUpper=g;function F(k){return 48<=k&&k<=57}function l(k){return k===32||k===9||k===10||k===13}const s=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(k=>s.add(k.charCodeAt(0)));function e(k){return l(k)||s.has(k)}function p(k,P){return k===P||e(k)&&e(P)}function D(k){return f(k)||g(k)||F(k)}function v(k,P){return P.length===0?P=[k]:k.end===P[0].start?P[0].start=k.start:P.unshift(k),P}function _(k,P){for(let x=P;x<k.length;x++){const ee=k.charCodeAt(x);if(g(ee)||F(ee)||x>0&&!D(k.charCodeAt(x-1)))return x}return k.length}function a(k,P,x,ee){if(x===k.length)return[];if(ee===P.length)return null;if(k[x]!==P[ee].toLowerCase())return null;{let he=null,de=ee+1;for(he=a(k,P,x+1,ee+1);!he&&(de=_(P,de))<P.length;)he=a(k,P,x+1,de),de++;return he===null?null:v({start:ee,end:ee+1},he)}}function o(k){let P=0,x=0,ee=0,he=0,de=0;for(let ve=0;ve<k.length;ve++)de=k.charCodeAt(ve),g(de)&&P++,f(de)&&x++,D(de)&&ee++,F(de)&&he++;const De=P/k.length,ye=x/k.length,ke=ee/k.length,Fe=he/k.length;return{upperPercent:De,lowerPercent:ye,alphaPercent:ke,numericPercent:Fe}}function b(k){const{upperPercent:P,lowerPercent:x}=k;return x===0&&P>.6}function S(k){const{upperPercent:P,lowerPercent:x,alphaPercent:ee,numericPercent:he}=k;return x>.2&&P<.8&&ee>.6&&he<.2}function A(k){let P=0,x=0,ee=0,he=0;for(let de=0;de<k.length;de++)ee=k.charCodeAt(de),g(ee)&&P++,f(ee)&&x++,l(ee)&&he++;return(P===0||x===0)&&he===0?k.length<=30:P<=5}function C(k,P){if(!P||(P=P.trim(),P.length===0)||!A(k)||P.length>60)return null;const x=o(P);if(!S(x)){if(!b(x))return null;P=P.toLowerCase()}let ee=null,he=0;for(k=k.toLowerCase();he<P.length&&(ee=a(k,P,0,he))===null;)he=_(P,he+1);return ee}t.matchesCamelCase=C;function r(k,P,x=!1){if(!P||P.length===0)return null;let ee=null,he=0;for(k=k.toLowerCase(),P=P.toLowerCase();he<P.length&&(ee=n(k,P,0,he,x))===null;)he=c(P,he+1);return ee}t.matchesWords=r;function n(k,P,x,ee,he){if(x===k.length)return[];if(ee===P.length)return null;if(p(k.charCodeAt(x),P.charCodeAt(ee))){let de=null,De=ee+1;if(de=n(k,P,x+1,ee+1,he),!he)for(;!de&&(De=c(P,De))<P.length;)de=n(k,P,x+1,De,he),De++;return de?k.charCodeAt(x)!==P.charCodeAt(ee)?de:v({start:ee,end:ee+1},de):null}else return null}function c(k,P){for(let x=P;x<k.length;x++)if(e(k.charCodeAt(x))||x>0&&e(k.charCodeAt(x-1)))return x;return k.length}const u=B(t.matchesPrefix,C,E),h=B(t.matchesPrefix,C,w),O=new y.LRUCache(1e4);function V(k,P,x=!1){if(typeof k!="string"||typeof P!="string")return null;let ee=O.get(k);ee||(ee=new RegExp(i.convertSimple2RegExpPattern(k),"i"),O.set(k,ee));const he=ee.exec(P);return he?[{start:he.index,end:he.index+he[0].length}]:x?h(k,P):u(k,P)}t.matchesFuzzy=V;function ue(k,P){const x=K(k,k.toLowerCase(),0,P,P.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return x?ge(x):null}t.matchesFuzzy2=ue;function ie(k,P,x,ee,he,de){const De=Math.min(13,k.length);for(;x<De;x++){const ye=K(k,P,x,ee,he,de,{firstMatchCanBeWeak:!1,boostFullMatch:!0});if(ye)return ye}return[0,de]}t.anyScore=ie;function ge(k){if(typeof k=="undefined")return[];const P=[],x=k[1];for(let ee=k.length-1;ee>1;ee--){const he=k[ee]+x,de=P[P.length-1];de&&de.end===he?de.end=he+1:P.push({start:he,end:he+1})}return P}t.createMatches=ge;const ae=128;function we(){const k=[],P=[];for(let x=0;x<=ae;x++)P[x]=0;for(let x=0;x<=ae;x++)k.push(P.slice(0));return k}function ce(k){const P=[];for(let x=0;x<=k;x++)P[x]=0;return P}const re=ce(2*ae),Ce=ce(2*ae),Ie=we(),ne=we(),Z=we(),X=!1;function se(k,P,x,ee,he){function de(ye,ke,Fe=" "){for(;ye.length<ke;)ye=Fe+ye;return ye}let De=` |   |${ee.split("").map(ye=>de(ye,3)).join("|")}
`;for(let ye=0;ye<=x;ye++)ye===0?De+=" |":De+=`${P[ye-1]}|`,De+=k[ye].slice(0,he+1).map(ke=>de(ke.toString(),3)).join("|")+`
`;return De}function te(k,P,x,ee){k=k.substr(P),x=x.substr(ee),console.log(se(ne,k,k.length,x,x.length)),console.log(se(Z,k,k.length,x,x.length)),console.log(se(Ie,k,k.length,x,x.length))}function I(k,P){if(P<0||P>=k.length)return!1;const x=k.codePointAt(P);switch(x){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!i.isEmojiImprecise(x)}}function $(k,P){if(P<0||P>=k.length)return!1;switch(k.charCodeAt(P)){case 32:case 9:return!0;default:return!1}}function j(k,P,x){return P[k]!==x[k]}function H(k,P,x,ee,he,de,De=!1){for(;P<x&&he<de;)k[P]===ee[he]&&(De&&(re[P]=he),P+=1),he+=1;return P===x}t.isPatternInWord=H;var d;(function(k){k[k.Diag=1]="Diag",k[k.Left=2]="Left",k[k.LeftLeft=3]="LeftLeft"})(d||(d={}));var L;(function(k){k.Default=[-100,0];function P(x){return!x||x.length===2&&x[0]===-100&&x[1]===0}k.isDefault=P})(L=t.FuzzyScore||(t.FuzzyScore={}));class U{constructor(P,x){this.firstMatchCanBeWeak=P,this.boostFullMatch=x}}t.FuzzyScoreOptions=U,U.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function K(k,P,x,ee,he,de,De=U.default){const ye=k.length>ae?ae:k.length,ke=ee.length>ae?ae:ee.length;if(x>=ye||de>=ke||ye-x>ke-de||!H(P,x,ye,he,de,ke,!0))return;Q(ye,ke,x,de,P,he);let Fe=1,ve=1,Pe=x,Re=de;const Ge=[!1];for(Fe=1,Pe=x;Pe<ye;Fe++,Pe++){const Oe=re[Pe],q=Ce[Pe],oe=Pe+1<ye?Ce[Pe+1]:ke;for(ve=Oe-de+1,Re=Oe;Re<oe;ve++,Re++){let be=Number.MIN_SAFE_INTEGER,Ee=!1;Re<=q&&(be=N(k,P,Pe,x,ee,he,Re,ke,de,Ie[Fe-1][ve-1]===0,Ge));let Ae=0;be!==Number.MAX_SAFE_INTEGER&&(Ee=!0,Ae=be+ne[Fe-1][ve-1]);const Me=Re>Oe,Ve=Me?ne[Fe][ve-1]+(Ie[Fe][ve-1]>0?-5:0):0,tt=Re>Oe+1&&Ie[Fe][ve-1]>0,Ye=tt?ne[Fe][ve-2]+(Ie[Fe][ve-2]>0?-5:0):0;if(tt&&(!Me||Ye>=Ve)&&(!Ee||Ye>=Ae))ne[Fe][ve]=Ye,Z[Fe][ve]=3,Ie[Fe][ve]=0;else if(Me&&(!Ee||Ve>=Ae))ne[Fe][ve]=Ve,Z[Fe][ve]=2,Ie[Fe][ve]=0;else if(Ee)ne[Fe][ve]=Ae,Z[Fe][ve]=1,Ie[Fe][ve]=Ie[Fe-1][ve-1]+1;else throw new Error("not possible")}}if(X&&te(k,x,ee,de),!Ge[0]&&!De.firstMatchCanBeWeak)return;Fe--,ve--;const He=[ne[Fe][ve],de];let ze=0,Xe=0;for(;Fe>=1;){let Oe=ve;do{const q=Z[Fe][Oe];if(q===3)Oe=Oe-2;else if(q===2)Oe=Oe-1;else break}while(Oe>=1);ze>1&&P[x+Fe-1]===he[de+ve-1]&&!j(Oe+de-1,ee,he)&&ze+1>Ie[Fe][Oe]&&(Oe=ve),Oe===ve?ze++:ze=1,Xe||(Xe=Oe),Fe--,ve=Oe-1,He.push(ve)}ke===ye&&De.boostFullMatch&&(He[0]+=2);const je=Xe-ye;return He[0]-=je,He}t.fuzzyScore=K;function Q(k,P,x,ee,he,de){let De=k-1,ye=P-1;for(;De>=x&&ye>=ee;)he[De]===de[ye]&&(Ce[De]=ye,De--),ye--}function N(k,P,x,ee,he,de,De,ye,ke,Fe,ve){if(P[x]!==de[De])return Number.MIN_SAFE_INTEGER;let Pe=1,Re=!1;return De===x-ee?Pe=k[x]===he[De]?7:5:j(De,he,de)&&(De===0||!j(De-1,he,de))?(Pe=k[x]===he[De]?7:5,Re=!0):I(de,De)&&(De===0||!I(de,De-1))?Pe=5:(I(de,De-1)||$(de,De-1))&&(Pe=5,Re=!0),Pe>1&&x===ee&&(ve[0]=!0),Re||(Re=j(De,he,de)||I(de,De-1)||$(de,De-1)),x===ee?De>ke&&(Pe-=Re?3:5):Fe?Pe+=Re?2:0:Pe+=Re?0:1,De+1===ye&&(Pe-=Re?3:5),Pe}function R(k,P,x,ee,he,de,De){return T(k,P,x,ee,he,de,!0,De)}t.fuzzyScoreGracefulAggressive=R;function z(k,P,x,ee,he,de,De){return T(k,P,x,ee,he,de,!1,De)}t.fuzzyScoreGraceful=z;function T(k,P,x,ee,he,de,De,ye){let ke=K(k,P,x,ee,he,de,ye);if(ke&&!De)return ke;if(k.length>=3){const Fe=Math.min(7,k.length-1);for(let ve=x+1;ve<Fe;ve++){const Pe=W(k,ve);if(Pe){const Re=K(Pe,Pe.toLowerCase(),x,ee,he,de,ye);Re&&(Re[0]-=3,(!ke||Re[0]>ke[0])&&(ke=Re))}}}return ke}function W(k,P){if(P+1>=k.length)return;const x=k[P],ee=k[P+1];if(x!==ee)return k.slice(0,P)+ee+x+k.slice(P+2)}}),define(me[34],pe([1,0,11,33,10]),function(J,t,y,i,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.matchesFuzzyIconAware=t.parseLabelWithIcons=t.stripIcons=t.markdownEscapeEscapedIcons=t.escapeIcons=t.iconStartMarker=void 0,t.iconStartMarker="$(";const M=new RegExp(`\\$\\(${y.CSSIcon.iconNameExpression}(?:${y.CSSIcon.iconModifierExpression})?\\)`,"g"),E=new RegExp(y.CSSIcon.iconNameCharacter),w=new RegExp(`(\\\\)?${M.source}`,"g");function m(D){return D.replace(w,(v,_)=>_?v:`\\${v}`)}t.escapeIcons=m;const f=new RegExp(`\\\\${M.source}`,"g");function g(D){return D.replace(f,v=>`\\${v}`)}t.markdownEscapeEscapedIcons=g;const F=new RegExp(`(\\s)?(\\\\)?${M.source}(\\s)?`,"g");function l(D){return D.indexOf(t.iconStartMarker)===-1?D:D.replace(F,(v,_,a,o)=>a?v:_||o||"")}t.stripIcons=l;function s(D){const v=D.indexOf(t.iconStartMarker);return v===-1?{text:D}:e(D,v)}t.parseLabelWithIcons=s;function e(D,v){const _=[];let a="";function o(u){if(u){a+=u;for(const h of u)_.push(A)}}let b=-1,S="",A=0,C,r,n=v;const c=D.length;for(o(D.substr(0,v));n<c;)C=D[n],r=D[n+1],C===t.iconStartMarker[0]&&r===t.iconStartMarker[1]?(b=n,o(S),S=t.iconStartMarker,n++):C===")"&&b!==-1?(A+=n-b+1,b=-1,S=""):b!==-1?E.test(C)?S+=C:(o(S),b=-1,S=""):o(C),n++;return o(S),{text:a,iconOffsets:_}}function p(D,v,_=!1){const{text:a,iconOffsets:o}=v;if(!o||o.length===0)return(0,i.matchesFuzzy)(D,a,_);const b=(0,B.ltrim)(a," "),S=a.length-b.length,A=(0,i.matchesFuzzy)(D,b,_);if(A)for(const C of A){const r=o[C.start+S]+S;C.start+=r,C.end+=r}return A}t.matchesFuzzyIconAware=p}),define(me[16],pe([1,0,21,5]),function(J,t,y,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.uriToFsPath=t.URI=void 0;const B=/^\w[\w\d+.-]*$/,M=/^\//,E=/^\/\//;function w(C,r){if(!C.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${C.authority}", path: "${C.path}", query: "${C.query}", fragment: "${C.fragment}"}`);if(C.scheme&&!B.test(C.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(C.path){if(C.authority){if(!M.test(C.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(E.test(C.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function m(C,r){return!C&&!r?"file":C}function f(C,r){switch(C){case"https":case"http":case"file":r?r[0]!==F&&(r=F+r):r=F;break}return r}const g="",F="/",l=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class s{constructor(r,n,c,u,h,O=!1){typeof r=="object"?(this.scheme=r.scheme||g,this.authority=r.authority||g,this.path=r.path||g,this.query=r.query||g,this.fragment=r.fragment||g):(this.scheme=m(r,O),this.authority=n||g,this.path=f(this.scheme,c||g),this.query=u||g,this.fragment=h||g,w(this,O))}static isUri(r){return r instanceof s?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}get fsPath(){return a(this,!1)}with(r){if(!r)return this;let{scheme:n,authority:c,path:u,query:h,fragment:O}=r;return n===void 0?n=this.scheme:n===null&&(n=g),c===void 0?c=this.authority:c===null&&(c=g),u===void 0?u=this.path:u===null&&(u=g),h===void 0?h=this.query:h===null&&(h=g),O===void 0?O=this.fragment:O===null&&(O=g),n===this.scheme&&c===this.authority&&u===this.path&&h===this.query&&O===this.fragment?this:new p(n,c,u,h,O)}static parse(r,n=!1){const c=l.exec(r);return c?new p(c[2]||g,A(c[4]||g),A(c[5]||g),A(c[7]||g),A(c[9]||g),n):new p(g,g,g,g,g)}static file(r){let n=g;if(i.isWindows&&(r=r.replace(/\\/g,F)),r[0]===F&&r[1]===F){const c=r.indexOf(F,2);c===-1?(n=r.substring(2),r=F):(n=r.substring(2,c),r=r.substring(c)||F)}return new p("file",n,r,g,g)}static from(r){const n=new p(r.scheme,r.authority,r.path,r.query,r.fragment);return w(n,!0),n}static joinPath(r,...n){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let c;return i.isWindows&&r.scheme==="file"?c=s.file(y.win32.join(a(r,!0),...n)).path:c=y.posix.join(r.path,...n),r.with({path:c})}toString(r=!1){return o(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof s)return r;{const n=new p(r);return n._formatted=r.external,n._fsPath=r._sep===e?r.fsPath:null,n}}else return r}}t.URI=s;const e=i.isWindows?1:void 0;class p extends s{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=a(this,!1)),this._fsPath}toString(r=!1){return r?o(this,!0):(this._formatted||(this._formatted=o(this,!1)),this._formatted)}toJSON(){const r={$mid:1};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=e),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const D={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function v(C,r){let n,c=-1;for(let u=0;u<C.length;u++){const h=C.charCodeAt(u);if(h>=97&&h<=122||h>=65&&h<=90||h>=48&&h<=57||h===45||h===46||h===95||h===126||r&&h===47)c!==-1&&(n+=encodeURIComponent(C.substring(c,u)),c=-1),n!==void 0&&(n+=C.charAt(u));else{n===void 0&&(n=C.substr(0,u));const O=D[h];O!==void 0?(c!==-1&&(n+=encodeURIComponent(C.substring(c,u)),c=-1),n+=O):c===-1&&(c=u)}}return c!==-1&&(n+=encodeURIComponent(C.substring(c))),n!==void 0?n:C}function _(C){let r;for(let n=0;n<C.length;n++){const c=C.charCodeAt(n);c===35||c===63?(r===void 0&&(r=C.substr(0,n)),r+=D[c]):r!==void 0&&(r+=C[n])}return r!==void 0?r:C}function a(C,r){let n;return C.authority&&C.path.length>1&&C.scheme==="file"?n=`//${C.authority}${C.path}`:C.path.charCodeAt(0)===47&&(C.path.charCodeAt(1)>=65&&C.path.charCodeAt(1)<=90||C.path.charCodeAt(1)>=97&&C.path.charCodeAt(1)<=122)&&C.path.charCodeAt(2)===58?r?n=C.path.substr(1):n=C.path[1].toLowerCase()+C.path.substr(2):n=C.path,i.isWindows&&(n=n.replace(/\//g,"\\")),n}t.uriToFsPath=a;function o(C,r){const n=r?_:v;let c="",{scheme:u,authority:h,path:O,query:V,fragment:ue}=C;if(u&&(c+=u,c+=":"),(h||u==="file")&&(c+=F,c+=F),h){let ie=h.indexOf("@");if(ie!==-1){const ge=h.substr(0,ie);h=h.substr(ie+1),ie=ge.indexOf(":"),ie===-1?c+=n(ge,!1):(c+=n(ge.substr(0,ie),!1),c+=":",c+=n(ge.substr(ie+1),!1)),c+="@"}h=h.toLowerCase(),ie=h.indexOf(":"),ie===-1?c+=n(h,!1):(c+=n(h.substr(0,ie),!1),c+=h.substr(ie))}if(O){if(O.length>=3&&O.charCodeAt(0)===47&&O.charCodeAt(2)===58){const ie=O.charCodeAt(1);ie>=65&&ie<=90&&(O=`/${String.fromCharCode(ie+32)}:${O.substr(3)}`)}else if(O.length>=2&&O.charCodeAt(1)===58){const ie=O.charCodeAt(0);ie>=65&&ie<=90&&(O=`${String.fromCharCode(ie+32)}:${O.substr(2)}`)}c+=n(O,!0)}return V&&(c+="?",c+=n(V,!1)),ue&&(c+="#",c+=r?ue:v(ue,!1)),c}function b(C){try{return decodeURIComponent(C)}catch{return C.length>3?C.substr(0,3)+b(C.substr(3)):C}}const S=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function A(C){return C.match(S)?C.replace(S,r=>b(r)):C}}),define(me[49],pe([1,0,31,10,16]),function(J,t,y,i,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.parse=t.stringify=void 0;function M(f){return JSON.stringify(f,w)}t.stringify=M;function E(f){let g=JSON.parse(f);return g=m(g),g}t.parse=E;function w(f,g){return g instanceof RegExp?{$mid:2,source:g.source,flags:(0,i.regExpFlags)(g)}:g}function m(f,g=0){if(!f||g>200)return f;if(typeof f=="object"){switch(f.$mid){case 1:return B.URI.revive(f);case 2:return new RegExp(f.source,f.flags);case 14:return new Date(f.source)}if(f instanceof y.VSBuffer||f instanceof Uint8Array)return f;if(Array.isArray(f))for(let F=0;F<f.length;++F)f[F]=m(f[F],g+1);else for(const F in f)Object.hasOwnProperty.call(f,F)&&(f[F]=m(f[F],g+1))}return f}t.revive=m}),define(me[35],pe([1,0,5,16]),function(J,t,y,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileAccess=t.RemoteAuthorities=t.connectionTokenQueryName=t.connectionTokenCookieName=t.Schemas=void 0;var B;(function(w){w.inMemory="inmemory",w.vscode="vscode",w.internal="private",w.walkThrough="walkThrough",w.walkThroughSnippet="walkThroughSnippet",w.http="http",w.https="https",w.file="file",w.mailto="mailto",w.untitled="untitled",w.data="data",w.command="command",w.vscodeRemote="vscode-remote",w.vscodeRemoteResource="vscode-remote-resource",w.vscodeUserData="vscode-userdata",w.vscodeCustomEditor="vscode-custom-editor",w.vscodeNotebook="vscode-notebook",w.vscodeNotebookCell="vscode-notebook-cell",w.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",w.vscodeNotebookCellOutput="vscode-notebook-cell-output",w.vscodeInteractive="vscode-interactive",w.vscodeInteractiveInput="vscode-interactive-input",w.vscodeSettings="vscode-settings",w.vscodeWorkspaceTrust="vscode-workspace-trust",w.vscodeTerminal="vscode-terminal",w.webviewPanel="webview-panel",w.vscodeWebview="vscode-webview",w.extension="extension",w.vscodeFileResource="vscode-file",w.tmp="tmp",w.vsls="vsls",w.vscodeSourceControl="vscode-scm"})(B=t.Schemas||(t.Schemas={})),t.connectionTokenCookieName="vscode-tkn",t.connectionTokenQueryName="tkn";class M{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${B.vscodeRemoteResource}`}setPreferredWebSchema(m){this._preferredWebSchema=m}setDelegate(m){this._delegate=m}setServerRootPath(m){this._remoteResourcesPath=`${m}/${B.vscodeRemoteResource}`}set(m,f,g){this._hosts[m]=f,this._ports[m]=g}setConnectionToken(m,f){this._connectionTokens[m]=f}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(m){if(this._delegate)return this._delegate(m);const f=m.authority;let g=this._hosts[f];g&&g.indexOf(":")!==-1&&(g=`[${g}]`);const F=this._ports[f],l=this._connectionTokens[f];let s=`path=${encodeURIComponent(m.path)}`;return typeof l=="string"&&(s+=`&${t.connectionTokenQueryName}=${encodeURIComponent(l)}`),i.URI.from({scheme:y.isWeb?this._preferredWebSchema:B.vscodeRemoteResource,authority:`${g}:${F}`,path:this._remoteResourcesPath,query:s})}}t.RemoteAuthorities=new M;class E{asBrowserUri(m,f){const g=this.toUri(m,f);return g.scheme===B.vscodeRemote?t.RemoteAuthorities.rewrite(g):g.scheme===B.file&&(y.isNative||y.isWebWorker&&y.globals.origin===`${B.vscodeFileResource}://${E.FALLBACK_AUTHORITY}`)?g.with({scheme:B.vscodeFileResource,authority:g.authority||E.FALLBACK_AUTHORITY,query:null,fragment:null}):g}asFileUri(m,f){const g=this.toUri(m,f);return g.scheme===B.vscodeFileResource?g.with({scheme:B.file,authority:g.authority!==E.FALLBACK_AUTHORITY?g.authority:null,query:null,fragment:null}):g}toUri(m,f){return i.URI.isUri(m)?m:i.URI.parse(f.toUrl(m))}}E.FALLBACK_AUTHORITY="vscode-app",t.FileAccess=new E}),define(me[36],pe([1,0,109,35,21,5,10,16]),function(J,t,y,i,B,M,E,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalResource=t.DataUri=t.distinctParents=t.addTrailingPathSeparator=t.removeTrailingPathSeparator=t.hasTrailingPathSeparator=t.isEqualAuthority=t.isAbsolutePath=t.resolvePath=t.relativePath=t.normalizePath=t.joinPath=t.dirname=t.extname=t.basename=t.basenameOrAuthority=t.getComparisonKey=t.isEqualOrParent=t.isEqual=t.extUriIgnorePathCase=t.extUriBiasedIgnorePathCase=t.extUri=t.ExtUri=t.originalFSPath=void 0;function m(s){return(0,w.uriToFsPath)(s,!0)}t.originalFSPath=m;class f{constructor(e){this._ignorePathCasing=e}compare(e,p,D=!1){return e===p?0:(0,E.compare)(this.getComparisonKey(e,D),this.getComparisonKey(p,D))}isEqual(e,p,D=!1){return e===p?!0:!e||!p?!1:this.getComparisonKey(e,D)===this.getComparisonKey(p,D)}getComparisonKey(e,p=!1){return e.with({path:this._ignorePathCasing(e)?e.path.toLowerCase():void 0,fragment:p?null:void 0}).toString()}ignorePathCasing(e){return this._ignorePathCasing(e)}isEqualOrParent(e,p,D=!1){if(e.scheme===p.scheme){if(e.scheme===i.Schemas.file)return y.isEqualOrParent(m(e),m(p),this._ignorePathCasing(e))&&e.query===p.query&&(D||e.fragment===p.fragment);if((0,t.isEqualAuthority)(e.authority,p.authority))return y.isEqualOrParent(e.path,p.path,this._ignorePathCasing(e),"/")&&e.query===p.query&&(D||e.fragment===p.fragment)}return!1}joinPath(e,...p){return w.URI.joinPath(e,...p)}basenameOrAuthority(e){return(0,t.basename)(e)||e.authority}basename(e){return B.posix.basename(e.path)}extname(e){return B.posix.extname(e.path)}dirname(e){if(e.path.length===0)return e;let p;return e.scheme===i.Schemas.file?p=w.URI.file(B.dirname(m(e))).path:(p=B.posix.dirname(e.path),e.authority&&p.length&&p.charCodeAt(0)!==47&&(console.error(`dirname("${e.toString})) resulted in a relative path`),p="/")),e.with({path:p})}normalizePath(e){if(!e.path.length)return e;let p;return e.scheme===i.Schemas.file?p=w.URI.file(B.normalize(m(e))).path:p=B.posix.normalize(e.path),e.with({path:p})}relativePath(e,p){if(e.scheme!==p.scheme||!(0,t.isEqualAuthority)(e.authority,p.authority))return;if(e.scheme===i.Schemas.file){const _=B.relative(m(e),m(p));return M.isWindows?y.toSlashes(_):_}let D=e.path||"/";const v=p.path||"/";if(this._ignorePathCasing(e)){let _=0;for(const a=Math.min(D.length,v.length);_<a&&!(D.charCodeAt(_)!==v.charCodeAt(_)&&D.charAt(_).toLowerCase()!==v.charAt(_).toLowerCase());_++);D=v.substr(0,_)+D.substr(_)}return B.posix.relative(D,v)}resolvePath(e,p){if(e.scheme===i.Schemas.file){const D=w.URI.file(B.resolve(m(e),p));return e.with({authority:D.authority,path:D.path})}return p=y.toPosixPath(p),e.with({path:B.posix.resolve(e.path,p)})}isAbsolutePath(e){return!!e.path&&e.path[0]==="/"}isEqualAuthority(e,p){return e===p||e!==void 0&&p!==void 0&&(0,E.equalsIgnoreCase)(e,p)}hasTrailingPathSeparator(e,p=B.sep){if(e.scheme===i.Schemas.file){const D=m(e);return D.length>y.getRoot(D).length&&D[D.length-1]===p}else{const D=e.path;return D.length>1&&D.charCodeAt(D.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(e.fsPath)}}removeTrailingPathSeparator(e,p=B.sep){return(0,t.hasTrailingPathSeparator)(e,p)?e.with({path:e.path.substr(0,e.path.length-1)}):e}addTrailingPathSeparator(e,p=B.sep){let D=!1;if(e.scheme===i.Schemas.file){const v=m(e);D=v!==void 0&&v.length===y.getRoot(v).length&&v[v.length-1]===p}else{p="/";const v=e.path;D=v.length===1&&v.charCodeAt(v.length-1)===47}return!D&&!(0,t.hasTrailingPathSeparator)(e,p)?e.with({path:e.path+"/"}):e}}t.ExtUri=f,t.extUri=new f(()=>!1),t.extUriBiasedIgnorePathCase=new f(s=>s.scheme===i.Schemas.file?!M.isLinux:!0),t.extUriIgnorePathCase=new f(s=>!0),t.isEqual=t.extUri.isEqual.bind(t.extUri),t.isEqualOrParent=t.extUri.isEqualOrParent.bind(t.extUri),t.getComparisonKey=t.extUri.getComparisonKey.bind(t.extUri),t.basenameOrAuthority=t.extUri.basenameOrAuthority.bind(t.extUri),t.basename=t.extUri.basename.bind(t.extUri),t.extname=t.extUri.extname.bind(t.extUri),t.dirname=t.extUri.dirname.bind(t.extUri),t.joinPath=t.extUri.joinPath.bind(t.extUri),t.normalizePath=t.extUri.normalizePath.bind(t.extUri),t.relativePath=t.extUri.relativePath.bind(t.extUri),t.resolvePath=t.extUri.resolvePath.bind(t.extUri),t.isAbsolutePath=t.extUri.isAbsolutePath.bind(t.extUri),t.isEqualAuthority=t.extUri.isEqualAuthority.bind(t.extUri),t.hasTrailingPathSeparator=t.extUri.hasTrailingPathSeparator.bind(t.extUri),t.removeTrailingPathSeparator=t.extUri.removeTrailingPathSeparator.bind(t.extUri),t.addTrailingPathSeparator=t.extUri.addTrailingPathSeparator.bind(t.extUri);function g(s,e){const p=[];for(let D=0;D<s.length;D++){const v=e(s[D]);s.some((_,a)=>a===D?!1:(0,t.isEqualOrParent)(v,e(_)))||p.push(s[D])}return p}t.distinctParents=g;var F;(function(s){s.META_DATA_LABEL="label",s.META_DATA_DESCRIPTION="description",s.META_DATA_SIZE="size",s.META_DATA_MIME="mime";function e(p){const D=new Map;p.path.substring(p.path.indexOf(";")+1,p.path.lastIndexOf(";")).split(";").forEach(a=>{const[o,b]=a.split(":");o&&b&&D.set(o,b)});const _=p.path.substring(0,p.path.indexOf(";"));return _&&D.set(s.META_DATA_MIME,_),D}s.parseMetaData=e})(F=t.DataUri||(t.DataUri={}));function l(s,e,p){if(e){let D=s.path;return D&&D[0]!==B.posix.sep&&(D=B.posix.sep+D),s.with({scheme:p,authority:e,path:D})}return s.with({scheme:p})}t.toLocalResource=l}),define(me[8],pe([1,0,28,13,3,2,36,5]),function(J,t,y,i,B,M,E,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createCancelableAsyncIterable=t.CancelableAsyncIterableObject=t.AsyncIterableObject=t.Promises=t.DeferredPromise=t.IntervalCounter=t.TaskSequentializer=t.retry=t.IdleValue=t.runWhenIdle=t.ThrottledWorker=t.RunOnceWorker=t.ProcessTimeRunOnceScheduler=t.RunOnceScheduler=t.IntervalTimer=t.TimeoutTimer=t.ResourceQueue=t.Queue=t.Limiter=t.firstParallel=t.first=t.sequence=t.disposableTimeout=t.timeout=t.AutoOpenBarrier=t.Barrier=t.ThrottledDelayer=t.Delayer=t.MicrotaskDelay=t.SequencerByKey=t.Sequencer=t.Throttler=t.asPromise=t.raceTimeout=t.raceCancellablePromises=t.raceCancellationError=t.raceCancellation=t.createCancelablePromise=t.isThenable=void 0;function m(j){return!!j&&typeof j.then=="function"}t.isThenable=m;function f(j){const H=new y.CancellationTokenSource,d=j(H.token),L=new Promise((U,K)=>{const Q=H.token.onCancellationRequested(()=>{Q.dispose(),H.dispose(),K(new i.CancellationError)});Promise.resolve(d).then(N=>{Q.dispose(),H.dispose(),U(N)},N=>{Q.dispose(),H.dispose(),K(N)})});return new class{cancel(){H.cancel()}then(U,K){return L.then(U,K)}catch(U){return this.then(void 0,U)}finally(U){return L.finally(U)}}}t.createCancelablePromise=f;function g(j,H,d){return new Promise((L,U)=>{const K=H.onCancellationRequested(()=>{K.dispose(),L(d)});j.then(L,U).finally(()=>K.dispose())})}t.raceCancellation=g;function F(j,H){return new Promise((d,L)=>{const U=H.onCancellationRequested(()=>{U.dispose(),L(new i.CancellationError)});j.then(d,L).finally(()=>U.dispose())})}t.raceCancellationError=F;async function l(j){let H=-1;const d=j.map((U,K)=>U.then(Q=>(H=K,Q))),L=await Promise.race(d);return j.forEach((U,K)=>{K!==H&&U.cancel()}),L}t.raceCancellablePromises=l;function s(j,H,d){let L;const U=setTimeout(()=>{L?.(void 0),d?.()},H);return Promise.race([j.finally(()=>clearTimeout(U)),new Promise(K=>L=K)])}t.raceTimeout=s;function e(j){return new Promise((H,d)=>{const L=j();m(L)?L.then(H,d):H(L)})}t.asPromise=e;class p{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(H){if(this.activePromise){if(this.queuedPromiseFactory=H,!this.queuedPromise){const d=()=>{this.queuedPromise=null;const L=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,L};this.queuedPromise=new Promise(L=>{this.activePromise.then(d,d).then(L)})}return new Promise((d,L)=>{this.queuedPromise.then(d,L)})}return this.activePromise=H(),new Promise((d,L)=>{this.activePromise.then(U=>{this.activePromise=null,d(U)},U=>{this.activePromise=null,L(U)})})}}t.Throttler=p;class D{constructor(){this.current=Promise.resolve(null)}queue(H){return this.current=this.current.then(()=>H(),()=>H())}}t.Sequencer=D;class v{constructor(){this.promiseMap=new Map}queue(H,d){const U=(this.promiseMap.get(H)??Promise.resolve()).catch(()=>{}).then(d).finally(()=>{this.promiseMap.get(H)===U&&this.promiseMap.delete(H)});return this.promiseMap.set(H,U),U}}t.SequencerByKey=v;const _=(j,H)=>{let d=!0;const L=setTimeout(()=>{d=!1,H()},j);return{isTriggered:()=>d,dispose:()=>{clearTimeout(L),d=!1}}},a=j=>{let H=!0;return queueMicrotask(()=>{H&&(H=!1,j())}),{isTriggered:()=>H,dispose:()=>{H=!1}}};t.MicrotaskDelay=Symbol("MicrotaskDelay");class o{constructor(H){this.defaultDelay=H,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(H,d=this.defaultDelay){this.task=H,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((U,K)=>{this.doResolve=U,this.doReject=K}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const U=this.task;return this.task=null,U()}}));const L=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=d===t.MicrotaskDelay?a(L):_(d,L),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new i.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}t.Delayer=o;class b{constructor(H){this.delayer=new o(H),this.throttler=new p}trigger(H,d){return this.delayer.trigger(()=>this.throttler.queue(H),d)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}t.ThrottledDelayer=b;class S{constructor(){this._isOpen=!1,this._promise=new Promise((H,d)=>{this._completePromise=H})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}t.Barrier=S;class A extends S{constructor(H){super();this._timeout=setTimeout(()=>this.open(),H)}open(){clearTimeout(this._timeout),super.open()}}t.AutoOpenBarrier=A;function C(j,H){return H?new Promise((d,L)=>{const U=setTimeout(()=>{K.dispose(),d()},j),K=H.onCancellationRequested(()=>{clearTimeout(U),K.dispose(),L(new i.CancellationError)})}):f(d=>C(j,d))}t.timeout=C;function r(j,H=0){const d=setTimeout(j,H);return(0,M.toDisposable)(()=>clearTimeout(d))}t.disposableTimeout=r;function n(j){const H=[];let d=0;const L=j.length;function U(){return d<L?j[d++]():null}function K(Q){Q!=null&&H.push(Q);const N=U();return N?N.then(K):Promise.resolve(H)}return Promise.resolve(null).then(K)}t.sequence=n;function c(j,H=L=>!!L,d=null){let L=0;const U=j.length,K=()=>{if(L>=U)return Promise.resolve(d);const Q=j[L++];return Promise.resolve(Q()).then(R=>H(R)?Promise.resolve(R):K())};return K()}t.first=c;function u(j,H=L=>!!L,d=null){if(j.length===0)return Promise.resolve(d);let L=j.length;const U=()=>{L=-1;for(const K of j)K.cancel?.()};return new Promise((K,Q)=>{for(const N of j)N.then(R=>{--L>=0&&H(R)?(U(),K(R)):L===0&&K(d)}).catch(R=>{--L>=0&&(U(),Q(R))})})}t.firstParallel=u;class h{constructor(H){this._size=0,this.maxDegreeOfParalellism=H,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new B.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(H){return this._size++,new Promise((d,L)=>{this.outstandingPromises.push({factory:H,c:d,e:L}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const H=this.outstandingPromises.shift();this.runningPromises++;const d=H.factory();d.then(H.c,H.e),d.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}t.Limiter=h;class O extends h{constructor(){super(1)}}t.Queue=O;class V{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const H=new Z;return this.drainers.add(H),H.p}isDrained(){for(const[,H]of this.queues)if(H.size>0)return!1;return!0}queueFor(H,d=E.extUri){const L=d.getComparisonKey(H);let U=this.queues.get(L);return U||(U=new O,B.Event.once(U.onDrained)(()=>{U?.dispose(),this.queues.delete(L),this.onDidQueueDrain()}),this.queues.set(L,U)),U}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const H of this.drainers)H.complete();this.drainers.clear()}dispose(){for(const[,H]of this.queues)H.dispose();this.queues.clear(),this.releaseDrainers()}}t.ResourceQueue=V;class ue{constructor(H,d){this._token=-1,typeof H=="function"&&typeof d=="number"&&this.setIfNotSet(H,d)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(H,d){this.cancel(),this._token=setTimeout(()=>{this._token=-1,H()},d)}setIfNotSet(H,d){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,H()},d))}}t.TimeoutTimer=ue;class ie{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(H,d){this.cancel(),this._token=setInterval(()=>{H()},d)}}t.IntervalTimer=ie;class ge{constructor(H,d){this.timeoutToken=-1,this.runner=H,this.timeout=d,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(H=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,H)}get delay(){return this.timeout}set delay(H){this.timeout=H}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}t.RunOnceScheduler=ge;class ae{constructor(H,d){d%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${d}ms is not a multiple of 1000ms.`),this.runner=H,this.timeout=d,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(H=this.timeout){H%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${H}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(H/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}t.ProcessTimeRunOnceScheduler=ae;class we extends ge{constructor(H,d){super(H,d);this.units=[]}work(H){this.units.push(H),this.isScheduled()||this.schedule()}doRun(){const H=this.units;this.units=[],this.runner?.(H)}dispose(){this.units=[],super.dispose()}}t.RunOnceWorker=we;class ce extends M.Disposable{constructor(H,d){super();this.options=H,this.handler=d,this.pendingWork=[],this.throttler=this._register(new M.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(H){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+H.length>this.options.maxBufferedWork)return!1}else if(this.pending+H.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...H),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new ge(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}t.ThrottledWorker=ce,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?t.runWhenIdle=j=>{(0,w.setTimeout0)(()=>{if(H)return;const d=Date.now()+15;j(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,d-Date.now())}}))});let H=!1;return{dispose(){H||(H=!0)}}}:t.runWhenIdle=(j,H)=>{const d=requestIdleCallback(j,typeof H=="number"?{timeout:H}:void 0);let L=!1;return{dispose(){L||(L=!0,cancelIdleCallback(d))}}}}();class re{constructor(H){this._didRun=!1,this._executor=()=>{try{this._value=H()}catch(d){this._error=d}finally{this._didRun=!0}},this._handle=(0,t.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}t.IdleValue=re;async function Ce(j,H,d){let L;for(let U=0;U<d;U++)try{return await j()}catch(K){L=K,await C(H)}throw L}t.retry=Ce;class Ie{hasPending(H){return this._pending?typeof H=="number"?this._pending.taskId===H:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(H,d,L){return this._pending={taskId:H,cancel:()=>L?.(),promise:d},d.then(()=>this.donePending(H),()=>this.donePending(H)),d}donePending(H){this._pending&&H===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const H=this._next;this._next=void 0,H.run().then(H.promiseResolve,H.promiseReject)}}setNext(H){if(this._next)this._next.run=H;else{let d,L;const U=new Promise((K,Q)=>{d=K,L=Q});this._next={run:H,promise:U,promiseResolve:d,promiseReject:L}}return this._next.promise}}t.TaskSequentializer=Ie;class ne{constructor(H,d=()=>Date.now()){this.interval=H,this.nowFn=d,this.lastIncrementTime=0,this.value=0}increment(){const H=this.nowFn();return H-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=H,this.value=0),this.value++,this.value}}t.IntervalCounter=ne;class Z{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((H,d)=>{this.completeCallback=H,this.errorCallback=d})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(H){return new Promise(d=>{this.completeCallback(H),this.resolved=!0,d()})}error(H){return new Promise(d=>{this.errorCallback(H),this.rejected=!0,d()})}cancel(){new Promise(H=>{this.errorCallback(new i.CancellationError),this.rejected=!0,H()})}}t.DeferredPromise=Z;var X;(function(j){async function H(L){let U;const K=await Promise.all(L.map(Q=>Q.then(N=>N,N=>{U||(U=N)})));if(typeof U!="undefined")throw U;return K}j.settled=H;function d(L){return new Promise(async(U,K)=>{try{await L(U,K)}catch(Q){K(Q)}})}j.withAsyncBody=d})(X=t.Promises||(t.Promises={}));var se;(function(j){j[j.Initial=0]="Initial",j[j.DoneOK=1]="DoneOK",j[j.DoneError=2]="DoneError"})(se||(se={}));class te{constructor(H){this._state=0,this._results=[],this._error=null,this._onStateChanged=new B.Emitter,queueMicrotask(async()=>{const d={emitOne:L=>this.emitOne(L),emitMany:L=>this.emitMany(L),reject:L=>this.reject(L)};try{await Promise.resolve(H(d)),this.resolve()}catch(L){this.reject(L)}finally{d.emitOne=void 0,d.emitMany=void 0,d.reject=void 0}})}static fromArray(H){return new te(d=>{d.emitMany(H)})}static fromPromise(H){return new te(async d=>{d.emitMany(await H)})}static fromPromises(H){return new te(async d=>{await Promise.all(H.map(async L=>d.emitOne(await L)))})}static merge(H){return new te(async d=>{await Promise.all(H.map(async L=>{for await(const U of L)d.emitOne(U)}))})}[Symbol.asyncIterator](){let H=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(H<this._results.length)return{done:!1,value:this._results[H++]};if(this._state===1)return{done:!0,value:void 0};await B.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(H,d){return new te(async L=>{for await(const U of H)L.emitOne(d(U))})}map(H){return te.map(this,H)}static filter(H,d){return new te(async L=>{for await(const U of H)d(U)&&L.emitOne(U)})}filter(H){return te.filter(this,H)}static coalesce(H){return te.filter(H,d=>!!d)}coalesce(){return te.coalesce(this)}static async toPromise(H){const d=[];for await(const L of H)d.push(L);return d}toPromise(){return te.toPromise(this)}emitOne(H){this._state===0&&(this._results.push(H),this._onStateChanged.fire())}emitMany(H){this._state===0&&(this._results=this._results.concat(H),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(H){this._state===0&&(this._state=2,this._error=H,this._onStateChanged.fire())}}t.AsyncIterableObject=te,te.EMPTY=te.fromArray([]);class I extends te{constructor(H,d){super(d);this._source=H}cancel(){this._source.cancel()}}t.CancelableAsyncIterableObject=I;function $(j){const H=new y.CancellationTokenSource,d=j(H.token);return new I(H,async L=>{const U=H.token.onCancellationRequested(()=>{U.dispose(),H.dispose(),L.reject(new i.CancellationError)});try{for await(const K of d){if(H.token.isCancellationRequested)return;L.emitOne(K)}U.dispose(),H.dispose()}catch(K){U.dispose(),H.dispose(),L.reject(K)}})}t.createCancelableAsyncIterable=$}),define(me[4],pe([1,0,15,107,19,20,8,13,3,112,2,35,5,6,16]),function(J,t,y,i,B,M,E,w,m,f,g,F,l,s,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.h=t.computeClippingRect=t.DragAndDropObserver=t.getCookieValue=t.ModifierKeyEmitter=t.multibyteAwareBtoa=t.safeInnerHtml=t.hookDomPurifyHrefAndSrcSanitizer=t.detectFullscreen=t.DetectedFullscreenMode=t.triggerUpload=t.triggerDownload=t.asCSSPropertyValue=t.asCSSUrl=t.animate=t.windowOpenWithSuccess=t.windowOpenPopup=t.windowOpenNoOpener=t.computeScreenAwareSize=t.domContentLoaded=t.finalHandler=t.removeTabIndexAndUpdateFocus=t.hide=t.show=t.join=t.$=t.Namespace=t.reset=t.prepend=t.append=t.after=t.trackFocus=t.restoreParentsScrollTop=t.saveParentsScrollTop=t.EventHelper=t.EventType=t.isHTMLElement=t.removeCSSRulesContainingSelector=t.createCSSRule=t.createMetaElement=t.createStyleSheet=t.getActiveElement=t.getShadowRoot=t.isInShadowDOM=t.isShadowRoot=t.hasParentWithClass=t.findParentWithClass=t.isAncestorUsingFlowTo=t.setParentFlowTo=t.isAncestor=t.getLargestChildWidth=t.getTotalHeight=t.getContentHeight=t.getTotalScrollWidth=t.getContentWidth=t.getTotalWidth=t.getDomNodeZoomLevel=t.getDomNodePagePosition=t.position=t.size=t.getTopLeftOffset=t.Dimension=t.getClientArea=t.getComputedStyle=t.addDisposableThrottledListener=t.modify=t.measure=t.scheduleAtNextAnimationFrame=t.runAtThisOrScheduleAtNextAnimationFrame=t.addDisposableGenericMouseUpListener=t.addDisposableGenericMouseMoveListener=t.addDisposableGenericMouseDownListener=t.addStandardDisposableGenericMouseUpListener=t.addStandardDisposableGenericMouseDownListener=t.addStandardDisposableListener=t.addDisposableListener=t.isInDOM=t.clearNode=void 0;function p(Y){Y.replaceChildren()}t.clearNode=p;function D(Y){return Y?.isConnected??!1}t.isInDOM=D;function v(Y,G,fe,Te){let Se=new AbortController;const Ue=typeof Te=="boolean"?{capture:Te,signal:Se.signal}:{signal:Se.signal,...Te??{}};return Y.addEventListener(G,fe,Ue),(0,g.toDisposable)(()=>{Se?.abort(),Se=void 0})}t.addDisposableListener=v;function _(Y){return function(G){return Y(new M.StandardMouseEvent(G))}}function a(Y){return function(G){return Y(new B.StandardKeyboardEvent(G))}}const o=function(G,fe,Te,Se){let Ue=Te;return fe==="click"||fe==="mousedown"?Ue=_(Te):(fe==="keydown"||fe==="keypress"||fe==="keyup")&&(Ue=a(Te)),v(G,fe,Ue,Se)};t.addStandardDisposableListener=o;const b=function(G,fe,Te){const Se=_(fe);return A(G,Se,Te)};t.addStandardDisposableGenericMouseDownListener=b;const S=function(G,fe,Te){const Se=_(fe);return r(G,Se,Te)};t.addStandardDisposableGenericMouseUpListener=S;function A(Y,G,fe){return v(Y,l.isIOS&&i.BrowserFeatures.pointerEvents?t.EventType.POINTER_DOWN:t.EventType.MOUSE_DOWN,G,fe)}t.addDisposableGenericMouseDownListener=A;function C(Y,G,fe){return v(Y,l.isIOS&&i.BrowserFeatures.pointerEvents?t.EventType.POINTER_MOVE:t.EventType.MOUSE_MOVE,G,fe)}t.addDisposableGenericMouseMoveListener=C;function r(Y,G,fe){return v(Y,l.isIOS&&i.BrowserFeatures.pointerEvents?t.EventType.POINTER_UP:t.EventType.MOUSE_UP,G,fe)}t.addDisposableGenericMouseUpListener=r;let n=null;function c(Y){if(!n){const G=fe=>setTimeout(()=>fe(new Date().getTime()),0);n=self.requestAnimationFrame||self.msRequestAnimationFrame||self.webkitRequestAnimationFrame||self.mozRequestAnimationFrame||self.oRequestAnimationFrame||G}return n.call(self,Y)}class u{constructor(G,fe=0){this._runner=G,this.priority=fe,this._canceled=!1}dispose(){this._canceled=!0}execute(){if(!this._canceled)try{this._runner()}catch(G){(0,w.onUnexpectedError)(G)}}static sort(G,fe){return fe.priority-G.priority}}(function(){let Y=[],G=null,fe=!1,Te=!1;const Se=()=>{for(fe=!1,G=Y,Y=[],Te=!0;G.length>0;)G.sort(u.sort),G.shift().execute();Te=!1};t.scheduleAtNextAnimationFrame=(Ue,We=0)=>{const xe=new u(Ue,We);return Y.push(xe),fe||(fe=!0,c(Se)),xe},t.runAtThisOrScheduleAtNextAnimationFrame=(Ue,We)=>{if(Te){const xe=new u(Ue,We);return G.push(xe),xe}else return(0,t.scheduleAtNextAnimationFrame)(Ue,We)}})();function h(Y){return(0,t.scheduleAtNextAnimationFrame)(Y,1e4)}t.measure=h;function O(Y){return(0,t.scheduleAtNextAnimationFrame)(Y,-1e4)}t.modify=O;const V=8,ue=function(Y,G){return G};class ie extends g.Disposable{constructor(G,fe,Te,Se=ue,Ue=V){super();let We=null,xe=0;const et=this._register(new E.TimeoutTimer),gt=()=>{xe=new Date().getTime(),Te(We),We=null};this._register(v(G,fe,Ft=>{We=Se(We,Ft);const mt=new Date().getTime()-xe;mt>=Ue?(et.cancel(),gt()):et.setIfNotSet(gt,Ue-mt)}))}}function ge(Y,G,fe,Te,Se){return new ie(Y,G,fe,Te,Se)}t.addDisposableThrottledListener=ge;function ae(Y){return document.defaultView.getComputedStyle(Y,null)}t.getComputedStyle=ae;function we(Y){if(Y!==document.body)return new re(Y.clientWidth,Y.clientHeight);if(l.isIOS&&window.visualViewport)return new re(window.visualViewport.width,window.visualViewport.height);if(window.innerWidth&&window.innerHeight)return new re(window.innerWidth,window.innerHeight);if(document.body&&document.body.clientWidth&&document.body.clientHeight)return new re(document.body.clientWidth,document.body.clientHeight);if(document.documentElement&&document.documentElement.clientWidth&&document.documentElement.clientHeight)return new re(document.documentElement.clientWidth,document.documentElement.clientHeight);throw new Error("Unable to figure out browser width and height")}t.getClientArea=we;class ce{static convertToPixels(G,fe){return parseFloat(fe)||0}static getDimension(G,fe,Te){const Se=ae(G),Ue=Se?Se.getPropertyValue(fe):"0";return ce.convertToPixels(G,Ue)}static getBorderLeftWidth(G){return ce.getDimension(G,"border-left-width","borderLeftWidth")}static getBorderRightWidth(G){return ce.getDimension(G,"border-right-width","borderRightWidth")}static getBorderTopWidth(G){return ce.getDimension(G,"border-top-width","borderTopWidth")}static getBorderBottomWidth(G){return ce.getDimension(G,"border-bottom-width","borderBottomWidth")}static getPaddingLeft(G){return ce.getDimension(G,"padding-left","paddingLeft")}static getPaddingRight(G){return ce.getDimension(G,"padding-right","paddingRight")}static getPaddingTop(G){return ce.getDimension(G,"padding-top","paddingTop")}static getPaddingBottom(G){return ce.getDimension(G,"padding-bottom","paddingBottom")}static getMarginLeft(G){return ce.getDimension(G,"margin-left","marginLeft")}static getMarginTop(G){return ce.getDimension(G,"margin-top","marginTop")}static getMarginRight(G){return ce.getDimension(G,"margin-right","marginRight")}static getMarginBottom(G){return ce.getDimension(G,"margin-bottom","marginBottom")}}class re{constructor(G,fe){this.width=G,this.height=fe}with(G=this.width,fe=this.height){return G!==this.width||fe!==this.height?new re(G,fe):this}static is(G){return typeof G=="object"&&typeof G.height=="number"&&typeof G.width=="number"}static lift(G){return G instanceof re?G:new re(G.width,G.height)}static equals(G,fe){return G===fe?!0:!G||!fe?!1:G.width===fe.width&&G.height===fe.height}}t.Dimension=re,re.None=new re(0,0);function Ce(Y){let G=Y.offsetParent,fe=Y.offsetTop,Te=Y.offsetLeft;for(;(Y=Y.parentNode)!==null&&Y!==document.body&&Y!==document.documentElement;){fe-=Y.scrollTop;const Se=T(Y)?null:ae(Y);Se&&(Te-=Se.direction!=="rtl"?Y.scrollLeft:-Y.scrollLeft),Y===G&&(Te+=ce.getBorderLeftWidth(Y),fe+=ce.getBorderTopWidth(Y),fe+=Y.offsetTop,Te+=Y.offsetLeft,G=Y.offsetParent)}return{left:Te,top:fe}}t.getTopLeftOffset=Ce;function Ie(Y,G,fe){typeof G=="number"&&(Y.style.width=`${G}px`),typeof fe=="number"&&(Y.style.height=`${fe}px`)}t.size=Ie;function ne(Y,G,fe,Te,Se,Ue="absolute"){typeof G=="number"&&(Y.style.top=`${G}px`),typeof fe=="number"&&(Y.style.right=`${fe}px`),typeof Te=="number"&&(Y.style.bottom=`${Te}px`),typeof Se=="number"&&(Y.style.left=`${Se}px`),Y.style.position=Ue}t.position=ne;function Z(Y){const G=Y.getBoundingClientRect();return{left:G.left+window.scrollX,top:G.top+window.scrollY,width:G.width,height:G.height}}t.getDomNodePagePosition=Z;function X(Y){let G=Y,fe=1;do{const Te=ae(G).zoom;Te!=null&&Te!=="1"&&(fe*=Te),G=G.parentElement}while(G!==null&&G!==document.documentElement);return fe}t.getDomNodeZoomLevel=X;function se(Y){const G=ce.getMarginLeft(Y)+ce.getMarginRight(Y);return Y.offsetWidth+G}t.getTotalWidth=se;function te(Y){const G=ce.getBorderLeftWidth(Y)+ce.getBorderRightWidth(Y),fe=ce.getPaddingLeft(Y)+ce.getPaddingRight(Y);return Y.offsetWidth-G-fe}t.getContentWidth=te;function I(Y){const G=ce.getMarginLeft(Y)+ce.getMarginRight(Y);return Y.scrollWidth+G}t.getTotalScrollWidth=I;function $(Y){const G=ce.getBorderTopWidth(Y)+ce.getBorderBottomWidth(Y),fe=ce.getPaddingTop(Y)+ce.getPaddingBottom(Y);return Y.offsetHeight-G-fe}t.getContentHeight=$;function j(Y){const G=ce.getMarginTop(Y)+ce.getMarginBottom(Y);return Y.offsetHeight+G}t.getTotalHeight=j;function H(Y,G){if(Y===null)return 0;const fe=Ce(Y),Te=Ce(G);return fe.left-Te.left}function d(Y,G){const fe=G.map(Se=>Math.max(I(Se),se(Se))+H(Se,Y)||0);return Math.max(...fe)}t.getLargestChildWidth=d;function L(Y,G){for(;Y;){if(Y===G)return!0;Y=Y.parentNode}return!1}t.isAncestor=L;const U="parentFlowToElementId";function K(Y,G){Y.dataset[U]=G.id}t.setParentFlowTo=K;function Q(Y){const G=Y.dataset[U];return typeof G=="string"?document.getElementById(G):null}function N(Y,G){let fe=Y;for(;fe;){if(fe===G)return!0;if(fe instanceof HTMLElement){const Te=Q(fe);if(Te){fe=Te;continue}}fe=fe.parentNode}return!1}t.isAncestorUsingFlowTo=N;function R(Y,G,fe){for(;Y&&Y.nodeType===Y.ELEMENT_NODE;){if(Y.classList.contains(G))return Y;if(fe){if(typeof fe=="string"){if(Y.classList.contains(fe))return null}else if(Y===fe)return null}Y=Y.parentNode}return null}t.findParentWithClass=R;function z(Y,G,fe){return!!R(Y,G,fe)}t.hasParentWithClass=z;function T(Y){return Y&&!!Y.host&&!!Y.mode}t.isShadowRoot=T;function W(Y){return!!k(Y)}t.isInShadowDOM=W;function k(Y){for(;Y.parentNode;){if(Y===document.body)return null;Y=Y.parentNode}return T(Y)?Y:null}t.getShadowRoot=k;function P(){let Y=document.activeElement;for(;Y?.shadowRoot;)Y=Y.shadowRoot.activeElement;return Y}t.getActiveElement=P;function x(Y=document.getElementsByTagName("head")[0]){const G=document.createElement("style");return G.type="text/css",G.media="screen",Y.appendChild(G),G}t.createStyleSheet=x;function ee(Y=document.getElementsByTagName("head")[0]){const G=document.createElement("meta");return Y.appendChild(G),G}t.createMetaElement=ee;let he=null;function de(){return he||(he=x()),he}function De(Y){return Y?.sheet?.rules?Y.sheet.rules:Y?.sheet?.cssRules?Y.sheet.cssRules:[]}function ye(Y,G,fe=de()){!fe||!G||fe.sheet.insertRule(Y+"{"+G+"}",0)}t.createCSSRule=ye;function ke(Y,G=de()){if(!G)return;const fe=De(G),Te=[];for(let Se=0;Se<fe.length;Se++)fe[Se].selectorText.indexOf(Y)!==-1&&Te.push(Se);for(let Se=Te.length-1;Se>=0;Se--)G.sheet.deleteRule(Te[Se])}t.removeCSSRulesContainingSelector=ke;function Fe(Y){return typeof HTMLElement=="object"?Y instanceof HTMLElement:Y&&typeof Y=="object"&&Y.nodeType===1&&typeof Y.nodeName=="string"}t.isHTMLElement=Fe,t.EventType={CLICK:"click",AUXCLICK:"auxclick",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",MOUSE_WHEEL:"wheel",POINTER_UP:"pointerup",POINTER_DOWN:"pointerdown",POINTER_MOVE:"pointermove",POINTER_LEAVE:"pointerleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",BEFORE_UNLOAD:"beforeunload",UNLOAD:"unload",PAGE_SHOW:"pageshow",PAGE_HIDE:"pagehide",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",FULLSCREEN_CHANGE:"fullscreenchange",WK_FULLSCREEN_CHANGE:"webkitfullscreenchange",SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:y.isWebKit?"webkitAnimationStart":"animationstart",ANIMATION_END:y.isWebKit?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:y.isWebKit?"webkitAnimationIteration":"animationiteration"},t.EventHelper={stop:(Y,G)=>(Y.preventDefault(),G&&Y.stopPropagation(),Y)};function ve(Y){const G=[];for(let fe=0;Y&&Y.nodeType===Y.ELEMENT_NODE;fe++)G[fe]=Y.scrollTop,Y=Y.parentNode;return G}t.saveParentsScrollTop=ve;function Pe(Y,G){for(let fe=0;Y&&Y.nodeType===Y.ELEMENT_NODE;fe++)Y.scrollTop!==G[fe]&&(Y.scrollTop=G[fe]),Y=Y.parentNode}t.restoreParentsScrollTop=Pe;class Re extends g.Disposable{constructor(G){super();this._onDidFocus=this._register(new m.Emitter),this.onDidFocus=this._onDidFocus.event,this._onDidBlur=this._register(new m.Emitter),this.onDidBlur=this._onDidBlur.event;let fe=Re.hasFocusWithin(G),Te=!1;const Se=()=>{Te=!1,fe||(fe=!0,this._onDidFocus.fire())},Ue=()=>{fe&&(Te=!0,window.setTimeout(()=>{Te&&(Te=!1,fe=!1,this._onDidBlur.fire())},0))};this._refreshStateHandler=()=>{Re.hasFocusWithin(G)!==fe&&(fe?Ue():Se())},this._register(v(G,t.EventType.FOCUS,Se,!0)),this._register(v(G,t.EventType.BLUR,Ue,!0)),this._register(v(G,t.EventType.FOCUS_IN,()=>this._refreshStateHandler())),this._register(v(G,t.EventType.FOCUS_OUT,()=>this._refreshStateHandler()))}static hasFocusWithin(G){const fe=k(G),Te=fe?fe.activeElement:document.activeElement;return L(Te,G)}refreshState(){this._refreshStateHandler()}}function Ge(Y){return new Re(Y)}t.trackFocus=Ge;function He(Y,G){return Y.after(G),G}t.after=He;function ze(Y,...G){if(Y.append(...G),G.length===1&&typeof G[0]!="string")return G[0]}t.append=ze;function Xe(Y,G){return Y.insertBefore(G,Y.firstChild),G}t.prepend=Xe;function je(Y,...G){Y.innerText="",ze(Y,...G)}t.reset=je;const Oe=/([\w\-]+)?(#([\w\-]+))?((\.([\w\-]+))*)/;var q;(function(Y){Y.HTML="http://www.w3.org/1999/xhtml",Y.SVG="http://www.w3.org/2000/svg"})(q=t.Namespace||(t.Namespace={}));function oe(Y,G,fe,...Te){const Se=Oe.exec(G);if(!Se)throw new Error("Bad use of emmet");fe={...fe||{}};const Ue=Se[1]||"div";let We;return Y!==q.HTML?We=document.createElementNS(Y,Ue):We=document.createElement(Ue),Se[3]&&(We.id=Se[3]),Se[4]&&(We.className=Se[4].replace(/\./g," ").trim()),Object.keys(fe).forEach(xe=>{const et=fe[xe];typeof et!="undefined"&&(/^on\w+$/.test(xe)?We[xe]=et:xe==="selected"?et&&We.setAttribute(xe,"true"):We.setAttribute(xe,et))}),We.append(...Te),We}function be(Y,G,...fe){return oe(q.HTML,Y,G,...fe)}t.$=be,be.SVG=function(Y,G,...fe){return oe(q.SVG,Y,G,...fe)};function Ee(Y,G){const fe=[];return Y.forEach((Te,Se)=>{Se>0&&(G instanceof Node?fe.push(G.cloneNode()):fe.push(document.createTextNode(G))),fe.push(Te)}),fe}t.join=Ee;function Ae(...Y){for(const G of Y)G.style.display="",G.removeAttribute("aria-hidden")}t.show=Ae;function Me(...Y){for(const G of Y)G.style.display="none",G.setAttribute("aria-hidden","true")}t.hide=Me;function Ve(Y,G){for(;Y&&Y.nodeType===Y.ELEMENT_NODE;){if(Y instanceof HTMLElement&&Y.hasAttribute(G))return Y;Y=Y.parentNode}return null}function tt(Y){!Y||!Y.hasAttribute("tabIndex")||(document.activeElement===Y&&Ve(Y.parentElement,"tabIndex")?.focus(),Y.removeAttribute("tabindex"))}t.removeTabIndexAndUpdateFocus=tt;function Ye(Y){return G=>{G.preventDefault(),G.stopPropagation(),Y(G)}}t.finalHandler=Ye;function qe(){return new Promise(Y=>{document.readyState==="complete"||document&&document.body!==null?Y(void 0):window.addEventListener("DOMContentLoaded",Y,!1)})}t.domContentLoaded=qe;function Le(Y){const G=window.devicePixelRatio*Y;return Math.max(1,Math.floor(G))/window.devicePixelRatio}t.computeScreenAwareSize=Le;function le(Y){window.open(Y,"_blank","noopener")}t.windowOpenNoOpener=le;const _e=780,Ne=640;function $e(Y){const G=Math.floor(window.screenLeft+window.innerWidth/2-_e/2),fe=Math.floor(window.screenTop+window.innerHeight/2-Ne/2);window.open(Y,"_blank",`width=${_e},height=${Ne},top=${fe},left=${G}`)}t.windowOpenPopup=$e;function Ze(Y,G=!0){const fe=window.open();return fe?(G&&(fe.opener=null),fe.location.href=Y,!0):!1}t.windowOpenWithSuccess=Ze;function Qe(Y){const G=()=>{Y(),fe=(0,t.scheduleAtNextAnimationFrame)(G)};let fe=(0,t.scheduleAtNextAnimationFrame)(G);return(0,g.toDisposable)(()=>fe.dispose())}t.animate=Qe,F.RemoteAuthorities.setPreferredWebSchema(/^https:/.test(window.location.href)?"https":"http");function Je(Y){return Y?`url('${F.FileAccess.asBrowserUri(Y).toString(!0).replace(/'/g,"%27")}')`:"url('')"}t.asCSSUrl=Je;function st(Y){return`'${Y.replace(/'/g,"%27")}'`}t.asCSSPropertyValue=st;function ht(Y,G){let fe;if(e.URI.isUri(Y))fe=Y.toString(!0);else{const Se=new Blob([Y]);fe=URL.createObjectURL(Se),setTimeout(()=>URL.revokeObjectURL(fe))}const Te=document.createElement("a");document.body.appendChild(Te),Te.download=G,Te.href=fe,Te.click(),setTimeout(()=>document.body.removeChild(Te))}t.triggerDownload=ht;function yt(){return new Promise(Y=>{const G=document.createElement("input");document.body.appendChild(G),G.type="file",G.multiple=!0,m.Event.once(m.Event.fromDOMEventEmitter(G,"input"))(()=>{Y((0,s.withNullAsUndefined)(G.files))}),G.click(),setTimeout(()=>document.body.removeChild(G))})}t.triggerUpload=yt;var dt;(function(Y){Y[Y.DOCUMENT=1]="DOCUMENT",Y[Y.BROWSER=2]="BROWSER"})(dt=t.DetectedFullscreenMode||(t.DetectedFullscreenMode={}));function Wt(){return document.fullscreenElement||document.webkitFullscreenElement||document.webkitIsFullScreen?{mode:dt.DOCUMENT,guess:!1}:window.innerHeight===screen.height?{mode:dt.BROWSER,guess:!1}:(l.isMacintosh||l.isLinux)&&window.outerHeight===screen.height&&window.outerWidth===screen.width?{mode:dt.BROWSER,guess:!0}:null}t.detectFullscreen=Wt;function zt(Y,G=!1){const fe=document.createElement("a");return f.addHook("afterSanitizeAttributes",Te=>{for(const Se of["href","src"])if(Te.hasAttribute(Se)){const Ue=Te.getAttribute(Se);if(Se==="href"&&Ue.startsWith("#"))continue;if(fe.href=Ue,!Y.includes(fe.protocol.replace(/:$/,""))){if(G&&Se==="src"&&fe.href.startsWith("data:"))continue;Te.removeAttribute(Se)}}}),(0,g.toDisposable)(()=>{f.removeHook("afterSanitizeAttributes")})}t.hookDomPurifyHrefAndSrcSanitizer=zt;const ci=[F.Schemas.http,F.Schemas.https,F.Schemas.command];function hi(Y,G){const fe={ALLOWED_TAGS:["a","button","blockquote","code","div","h1","h2","h3","h4","h5","h6","hr","input","label","li","p","pre","select","small","span","strong","textarea","ul","ol"],ALLOWED_ATTR:["href","data-href","data-command","target","title","name","src","alt","class","id","role","tabindex","style","data-code","width","height","align","x-dispatch","required","checked","placeholder","type"],RETURN_DOM:!1,RETURN_DOM_FRAGMENT:!1},Te=zt(ci);try{const Se=f.sanitize(G,{...fe,RETURN_TRUSTED_TYPE:!0});Y.innerHTML=Se}finally{Te.dispose()}}t.safeInnerHtml=hi;function di(Y){const G=new Uint16Array(Y.length);for(let Se=0;Se<G.length;Se++)G[Se]=Y.charCodeAt(Se);let fe="";const Te=new Uint8Array(G.buffer);for(let Se=0;Se<Te.length;Se++)fe+=String.fromCharCode(Te[Se]);return fe}function fi(Y){return btoa(di(Y))}t.multibyteAwareBtoa=fi;class ft extends m.Emitter{constructor(){super();this._subscriptions=new g.DisposableStore,this._keyStatus={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1},this._subscriptions.add(v(window,"keydown",G=>{if(G.defaultPrevented)return;const fe=new B.StandardKeyboardEvent(G);if(!(fe.keyCode===6&&G.repeat)){if(G.altKey&&!this._keyStatus.altKey)this._keyStatus.lastKeyPressed="alt";else if(G.ctrlKey&&!this._keyStatus.ctrlKey)this._keyStatus.lastKeyPressed="ctrl";else if(G.metaKey&&!this._keyStatus.metaKey)this._keyStatus.lastKeyPressed="meta";else if(G.shiftKey&&!this._keyStatus.shiftKey)this._keyStatus.lastKeyPressed="shift";else if(fe.keyCode!==6)this._keyStatus.lastKeyPressed=void 0;else return;this._keyStatus.altKey=G.altKey,this._keyStatus.ctrlKey=G.ctrlKey,this._keyStatus.metaKey=G.metaKey,this._keyStatus.shiftKey=G.shiftKey,this._keyStatus.lastKeyPressed&&(this._keyStatus.event=G,this.fire(this._keyStatus))}},!0)),this._subscriptions.add(v(window,"keyup",G=>{G.defaultPrevented||(!G.altKey&&this._keyStatus.altKey?this._keyStatus.lastKeyReleased="alt":!G.ctrlKey&&this._keyStatus.ctrlKey?this._keyStatus.lastKeyReleased="ctrl":!G.metaKey&&this._keyStatus.metaKey?this._keyStatus.lastKeyReleased="meta":!G.shiftKey&&this._keyStatus.shiftKey?this._keyStatus.lastKeyReleased="shift":this._keyStatus.lastKeyReleased=void 0,this._keyStatus.lastKeyPressed!==this._keyStatus.lastKeyReleased&&(this._keyStatus.lastKeyPressed=void 0),this._keyStatus.altKey=G.altKey,this._keyStatus.ctrlKey=G.ctrlKey,this._keyStatus.metaKey=G.metaKey,this._keyStatus.shiftKey=G.shiftKey,this._keyStatus.lastKeyReleased&&(this._keyStatus.event=G,this.fire(this._keyStatus)))},!0)),this._subscriptions.add(v(document.body,"mousedown",()=>{this._keyStatus.lastKeyPressed=void 0},!0)),this._subscriptions.add(v(document.body,"mouseup",()=>{this._keyStatus.lastKeyPressed=void 0},!0)),this._subscriptions.add(v(document.body,"mousemove",G=>{G.buttons&&(this._keyStatus.lastKeyPressed=void 0)},!0)),this._subscriptions.add(v(window,"blur",()=>{this.resetKeyStatus()}))}get keyStatus(){return this._keyStatus}get isModifierPressed(){return this._keyStatus.altKey||this._keyStatus.ctrlKey||this._keyStatus.metaKey||this._keyStatus.shiftKey}resetKeyStatus(){this.doResetKeyStatus(),this.fire(this._keyStatus)}doResetKeyStatus(){this._keyStatus={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1}}static getInstance(){return ft.instance||(ft.instance=new ft),ft.instance}dispose(){super.dispose(),this._subscriptions.dispose()}}t.ModifierKeyEmitter=ft;function gi(Y){const G=document.cookie.match("(^|[^;]+)\\s*"+Y+"\\s*=\\s*([^;]+)");return G?G.pop():void 0}t.getCookieValue=gi;class mi extends g.Disposable{constructor(G,fe){super();this.element=G,this.callbacks=fe,this.counter=0,this.dragStartTime=0,this.registerListeners()}registerListeners(){this._register(v(this.element,t.EventType.DRAG_ENTER,G=>{this.counter++,this.dragStartTime=G.timeStamp,this.callbacks.onDragEnter(G)})),this._register(v(this.element,t.EventType.DRAG_OVER,G=>{G.preventDefault(),this.callbacks.onDragOver?.(G,G.timeStamp-this.dragStartTime)})),this._register(v(this.element,t.EventType.DRAG_LEAVE,G=>{this.counter--,this.counter===0&&(this.dragStartTime=0,this.callbacks.onDragLeave(G))})),this._register(v(this.element,t.EventType.DRAG_END,G=>{this.counter=0,this.dragStartTime=0,this.callbacks.onDragEnd(G)})),this._register(v(this.element,t.EventType.DROP,G=>{this.counter=0,this.dragStartTime=0,this.callbacks.onDrop(G)}))}}t.DragAndDropObserver=mi;function pi(Y,G){const fe=Y instanceof HTMLElement?Y.getBoundingClientRect():Y,Te=G.getBoundingClientRect(),Se=Math.max(Te.top-fe.top,0),Ue=Math.max(fe.width-(fe.right-Te.right),0),We=Math.max(fe.height-(fe.bottom-Te.bottom),0),xe=Math.max(Te.left-fe.left,0);return{top:Se,right:Ue,bottom:We,left:xe}}t.computeClippingRect=pi;const bi=/(?<tag>[\w\-]+)?(?:#(?<id>[\w\-]+))?(?<class>(?:\.(?:[\w\-]+))*)(?:@(?<name>(?:[\w\_])+))?/;function wi(Y,...G){let fe,Te;Array.isArray(G[0])?(fe={},Te=G[0]):(fe=G[0]||{},Te=G[1]);const Se=bi.exec(Y);if(!Se||!Se.groups)throw new Error("Bad use of h");const Ue=Se.groups.tag||"div",We=document.createElement(Ue);Se.groups.id&&(We.id=Se.groups.id),Se.groups.class&&(We.className=Se.groups.class.replace(/\./g," ").trim());const xe={};if(Se.groups.name&&(xe[Se.groups.name]=We),Te)for(const et of Te)et instanceof HTMLElement?We.appendChild(et):typeof et=="string"?We.append(et):(Object.assign(xe,et),We.appendChild(et.root));for(const[et,gt]of Object.entries(fe))if(et==="style")for(const[Ft,mt]of Object.entries(gt))We.style.setProperty(Ut(Ft),typeof mt=="number"?mt+"px":""+mt);else et==="tabIndex"?We.tabIndex=gt:We.setAttribute(Ut(et),gt.toString());return xe.root=We,xe}t.h=wi;function Ut(Y){return Y.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase()}}),define(me[50],pe([1,0,4,2,105]),function(J,t,y,i,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.applyDragImage=t.DataTransfers=t.DelayedDragHandler=void 0;class M extends i.Disposable{constructor(m,f){super();this._register((0,y.addDisposableListener)(m,"dragover",g=>{g.preventDefault(),this.timeout||(this.timeout=setTimeout(()=>{f(),this.timeout=null},800))})),["dragleave","drop","dragend"].forEach(g=>{this._register((0,y.addDisposableListener)(m,g,()=>{this.clearDragTimeout()}))})}clearDragTimeout(){this.timeout&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){super.dispose(),this.clearDragTimeout()}}t.DelayedDragHandler=M,t.DataTransfers={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:B.Mimes.text};function E(w,m,f){const g=document.createElement("div");g.className=f,g.textContent=m,w.dataTransfer&&(document.body.appendChild(g),w.dataTransfer.setDragImage(g,-10,-10),setTimeout(()=>document.body.removeChild(g),0))}t.applyDragImage=E}),define(me[51],pe([1,0,4]),function(J,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createElement=t.renderFormattedText=t.renderText=void 0;function i(l,s={}){const e=M(s);return e.textContent=l,e}t.renderText=i;function B(l,s={}){const e=M(s);return m(e,f(l,!!s.renderCodeSegments),s.actionHandler,s.renderCodeSegments),e}t.renderFormattedText=B;function M(l){const s=l.inline?"span":"div",e=document.createElement(s);return l.className&&(e.className=l.className),e}t.createElement=M;class E{constructor(s){this.source=s,this.index=0}eos(){return this.index>=this.source.length}next(){const s=this.peek();return this.advance(),s}peek(){return this.source[this.index]}advance(){this.index++}}var w;(function(l){l[l.Invalid=0]="Invalid",l[l.Root=1]="Root",l[l.Text=2]="Text",l[l.Bold=3]="Bold",l[l.Italics=4]="Italics",l[l.Action=5]="Action",l[l.ActionClose=6]="ActionClose",l[l.Code=7]="Code",l[l.NewLine=8]="NewLine"})(w||(w={}));function m(l,s,e,p){let D;if(s.type===2)D=document.createTextNode(s.content||"");else if(s.type===3)D=document.createElement("b");else if(s.type===4)D=document.createElement("i");else if(s.type===7&&p)D=document.createElement("code");else if(s.type===5&&e){const v=document.createElement("a");e.disposables.add(y.addStandardDisposableListener(v,"click",_=>{e.callback(String(s.index),_)})),D=v}else s.type===8?D=document.createElement("br"):s.type===1&&(D=l);D&&l!==D&&l.appendChild(D),D&&Array.isArray(s.children)&&s.children.forEach(v=>{m(D,v,e,p)})}function f(l,s){const e={type:1,children:[]};let p=0,D=e;const v=[],_=new E(l);for(;!_.eos();){let a=_.next();const o=a==="\\"&&F(_.peek(),s)!==0;if(o&&(a=_.next()),!o&&g(a,s)&&a===_.peek()){_.advance(),D.type===2&&(D=v.pop());const b=F(a,s);if(D.type===b||D.type===5&&b===6)D=v.pop();else{const S={type:b,children:[]};b===5&&(S.index=p,p++),D.children.push(S),v.push(D),D=S}}else if(a===`
`)D.type===2&&(D=v.pop()),D.children.push({type:8});else if(D.type!==2){const b={type:2,content:a};D.children.push(b),v.push(D),D=b}else D.content+=a}return D.type===2&&(D=v.pop()),v.length,e}function g(l,s){return F(l,s)!==0}function F(l,s){switch(l){case"*":return 3;case"_":return 4;case"[":return 5;case"]":return 6;case"`":return s?7:0;default:return 0}}}),define(me[52],pe([1,0,4,2]),function(J,t,y,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.GlobalPointerMoveMonitor=void 0;class B{constructor(){this._hooks=new i.DisposableStore,this._pointerMoveCallback=null,this._onStopCallback=null}dispose(){this.stopMonitoring(!1),this._hooks.dispose()}stopMonitoring(E,w){if(!this.isMonitoring())return;this._hooks.clear(),this._pointerMoveCallback=null;const m=this._onStopCallback;this._onStopCallback=null,E&&m&&m(w)}isMonitoring(){return!!this._pointerMoveCallback}startMonitoring(E,w,m,f,g){this.isMonitoring()&&this.stopMonitoring(!1),this._pointerMoveCallback=f,this._onStopCallback=g;let F=E;try{E.setPointerCapture(w),this._hooks.add((0,i.toDisposable)(()=>{E.releasePointerCapture(w)}))}catch{F=window}this._hooks.add(y.addDisposableListener(F,y.EventType.POINTER_MOVE,l=>{if(l.buttons!==m){this.stopMonitoring(!0);return}l.preventDefault(),this._pointerMoveCallback(l)})),this._hooks.add(y.addDisposableListener(F,y.EventType.POINTER_UP,l=>this.stopMonitoring(!0)))}}t.GlobalPointerMoveMonitor=B});var Ke=this&&this.__decorate||function(J,t,y,i){var B=arguments.length,M=B<3?t:i===null?i=Object.getOwnPropertyDescriptor(t,y):i,E;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(J,t,y,i);else for(var w=J.length-1;w>=0;w--)(E=J[w])&&(M=(B<3?E(M):B>3?E(t,y,M):E(t,y))||M);return B>3&&M&&Object.defineProperty(t,y,M),M};define(me[22],pe([1,0,4,14,25,2]),function(J,t,y,i,B,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Gesture=t.EventType=void 0;var E;(function(m){m.Tap="-monaco-gesturetap",m.Change="-monaco-gesturechange",m.Start="-monaco-gesturestart",m.End="-monaco-gesturesend",m.Contextmenu="-monaco-gesturecontextmenu"})(E=t.EventType||(t.EventType={}));class w extends M.Disposable{constructor(){super();this.dispatched=!1,this.activeTouches={},this.handle=null,this.targets=[],this.ignoreTargets=[],this._lastSetTapCountTime=0,this._register(y.addDisposableListener(document,"touchstart",f=>this.onTouchStart(f),{passive:!1})),this._register(y.addDisposableListener(document,"touchend",f=>this.onTouchEnd(f))),this._register(y.addDisposableListener(document,"touchmove",f=>this.onTouchMove(f),{passive:!1}))}static addTarget(f){return w.isTouchDevice()?(w.INSTANCE||(w.INSTANCE=new w),w.INSTANCE.targets.push(f),{dispose:()=>{w.INSTANCE.targets=w.INSTANCE.targets.filter(g=>g!==f)}}):M.Disposable.None}static ignoreTarget(f){return w.isTouchDevice()?(w.INSTANCE||(w.INSTANCE=new w),w.INSTANCE.ignoreTargets.push(f),{dispose:()=>{w.INSTANCE.ignoreTargets=w.INSTANCE.ignoreTargets.filter(g=>g!==f)}}):M.Disposable.None}static isTouchDevice(){return"ontouchstart"in window||navigator.maxTouchPoints>0}dispose(){this.handle&&(this.handle.dispose(),this.handle=null),super.dispose()}onTouchStart(f){const g=Date.now();this.handle&&(this.handle.dispose(),this.handle=null);for(let F=0,l=f.targetTouches.length;F<l;F++){const s=f.targetTouches.item(F);this.activeTouches[s.identifier]={id:s.identifier,initialTarget:s.target,initialTimeStamp:g,initialPageX:s.pageX,initialPageY:s.pageY,rollingTimestamps:[g],rollingPageX:[s.pageX],rollingPageY:[s.pageY]};const e=this.newGestureEvent(E.Start,s.target);e.pageX=s.pageX,e.pageY=s.pageY,this.dispatchEvent(e)}this.dispatched&&(f.preventDefault(),f.stopPropagation(),this.dispatched=!1)}onTouchEnd(f){const g=Date.now(),F=Object.keys(this.activeTouches).length;for(let l=0,s=f.changedTouches.length;l<s;l++){const e=f.changedTouches.item(l);if(!this.activeTouches.hasOwnProperty(String(e.identifier))){console.warn("move of an UNKNOWN touch",e);continue}const p=this.activeTouches[e.identifier],D=Date.now()-p.initialTimeStamp;if(D<w.HOLD_DELAY&&Math.abs(p.initialPageX-i.tail(p.rollingPageX))<30&&Math.abs(p.initialPageY-i.tail(p.rollingPageY))<30){const v=this.newGestureEvent(E.Tap,p.initialTarget);v.pageX=i.tail(p.rollingPageX),v.pageY=i.tail(p.rollingPageY),this.dispatchEvent(v)}else if(D>=w.HOLD_DELAY&&Math.abs(p.initialPageX-i.tail(p.rollingPageX))<30&&Math.abs(p.initialPageY-i.tail(p.rollingPageY))<30){const v=this.newGestureEvent(E.Contextmenu,p.initialTarget);v.pageX=i.tail(p.rollingPageX),v.pageY=i.tail(p.rollingPageY),this.dispatchEvent(v)}else if(F===1){const v=i.tail(p.rollingPageX),_=i.tail(p.rollingPageY),a=i.tail(p.rollingTimestamps)-p.rollingTimestamps[0],o=v-p.rollingPageX[0],b=_-p.rollingPageY[0],S=this.targets.filter(A=>p.initialTarget instanceof Node&&A.contains(p.initialTarget));this.inertia(S,g,Math.abs(o)/a,o>0?1:-1,v,Math.abs(b)/a,b>0?1:-1,_)}this.dispatchEvent(this.newGestureEvent(E.End,p.initialTarget)),delete this.activeTouches[e.identifier]}this.dispatched&&(f.preventDefault(),f.stopPropagation(),this.dispatched=!1)}newGestureEvent(f,g){const F=document.createEvent("CustomEvent");return F.initEvent(f,!1,!0),F.initialTarget=g,F.tapCount=0,F}dispatchEvent(f){if(f.type===E.Tap){const g=new Date().getTime();let F=0;g-this._lastSetTapCountTime>w.CLEAR_TAP_COUNT_TIME?F=1:F=2,this._lastSetTapCountTime=g,f.tapCount=F}else(f.type===E.Change||f.type===E.Contextmenu)&&(this._lastSetTapCountTime=0);for(let g=0;g<this.ignoreTargets.length;g++)if(f.initialTarget instanceof Node&&this.ignoreTargets[g].contains(f.initialTarget))return;this.targets.forEach(g=>{f.initialTarget instanceof Node&&g.contains(f.initialTarget)&&(g.dispatchEvent(f),this.dispatched=!0)})}inertia(f,g,F,l,s,e,p,D){this.handle=y.scheduleAtNextAnimationFrame(()=>{const v=Date.now(),_=v-g;let a=0,o=0,b=!0;F+=w.SCROLL_FRICTION*_,e+=w.SCROLL_FRICTION*_,F>0&&(b=!1,a=l*F*_),e>0&&(b=!1,o=p*e*_);const S=this.newGestureEvent(E.Change);S.translationX=a,S.translationY=o,f.forEach(A=>A.dispatchEvent(S)),b||this.inertia(f,v,F,l,s+a,e,p,D+o)})}onTouchMove(f){const g=Date.now();for(let F=0,l=f.changedTouches.length;F<l;F++){const s=f.changedTouches.item(F);if(!this.activeTouches.hasOwnProperty(String(s.identifier))){console.warn("end of an UNKNOWN touch",s);continue}const e=this.activeTouches[s.identifier],p=this.newGestureEvent(E.Change,e.initialTarget);p.translationX=s.pageX-i.tail(e.rollingPageX),p.translationY=s.pageY-i.tail(e.rollingPageY),p.pageX=s.pageX,p.pageY=s.pageY,this.dispatchEvent(p),e.rollingPageX.length>3&&(e.rollingPageX.shift(),e.rollingPageY.shift(),e.rollingTimestamps.shift()),e.rollingPageX.push(s.pageX),e.rollingPageY.push(s.pageY),e.rollingTimestamps.push(g)}this.dispatched&&(f.preventDefault(),f.stopPropagation(),this.dispatched=!1)}}w.SCROLL_FRICTION=-.005,w.HOLD_DELAY=700,w.CLEAR_TAP_COUNT_TIME=400,Ke([B.memoize],w,"isTouchDevice",null),t.Gesture=w}),define(me[53],pe([1,0,4,5,82]),function(J,t,y,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.status=t.alert=t.setARIAContainer=void 0;const B=2e4;let M,E,w,m,f;function g(e){M=document.createElement("div"),M.className="monaco-aria-container";const p=()=>{const v=document.createElement("div");return v.className="monaco-alert",v.setAttribute("role","alert"),v.setAttribute("aria-atomic","true"),M.appendChild(v),v};E=p(),w=p();const D=()=>{const v=document.createElement("div");return v.className="monaco-status",v.setAttribute("role","complementary"),v.setAttribute("aria-live","polite"),v.setAttribute("aria-atomic","true"),M.appendChild(v),v};m=D(),f=D(),e.appendChild(M)}t.setARIAContainer=g;function F(e){!M||(E.textContent!==e?(y.clearNode(w),s(E,e)):(y.clearNode(E),s(w,e)))}t.alert=F;function l(e){!M||(i.isMacintosh?F(e):m.textContent!==e?(y.clearNode(f),s(m,e)):(y.clearNode(m),s(f,e)))}t.status=l;function s(e,p){y.clearNode(e),p.length>B&&(p=p.substr(0,B)),e.textContent=p,e.style.visibility="hidden",e.style.visibility="visible"}}),define(me[113],pe([1,0,4,11]),function(J,t,y,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.renderIcon=t.renderLabelWithIcons=void 0;const B=new RegExp(`(\\\\)?\\$\\((${i.CSSIcon.iconNameExpression}(?:${i.CSSIcon.iconModifierExpression})?)\\)`,"g");function M(w){const m=new Array;let f,g=0,F=0;for(;(f=B.exec(w))!==null;){F=f.index||0,m.push(w.substring(g,F)),g=(f.index||0)+f[0].length;const[,l,s]=f;m.push(l?`$(${s})`:E({id:s}))}return g<w.length&&m.push(w.substring(g)),m}t.renderLabelWithIcons=M;function E(w){const m=y.$("span");return m.classList.add(...i.CSSIcon.asClassNameArray(w)),m}t.renderIcon=E}),define(me[114],pe([1,0,4]),function(J,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RowCache=void 0;function i(M){try{M.parentElement?.removeChild(M)}catch{}}class B{constructor(E){this.renderers=E,this.cache=new Map}alloc(E){let w=this.getTemplateCache(E).pop();if(!w){const m=(0,y.$)(".monaco-list-row"),g=this.getRenderer(E).renderTemplate(m);w={domNode:m,templateId:E,templateData:g}}return w}release(E){!E||this.releaseRow(E)}releaseRow(E){const{domNode:w,templateId:m}=E;w&&(w.classList.remove("scrolling"),i(w)),this.getTemplateCache(m).push(E)}getTemplateCache(E){let w=this.cache.get(E);return w||(w=[],this.cache.set(E,w)),w}dispose(){this.cache.forEach((E,w)=>{for(const m of E)this.getRenderer(w).disposeTemplate(m.templateData),m.templateData=null}),this.cache.clear()}getRenderer(E){const w=this.renderers.get(E);if(!w)throw new Error(`No renderer found for ${E}`);return w}}t.RowCache=B}),define(me[115],pe([1,0,8,2]),function(J,t,y,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarVisibilityController=void 0;class B extends i.Disposable{constructor(E,w,m){super();this._visibility=E,this._visibleClassName=w,this._invisibleClassName=m,this._domNode=null,this._isVisible=!1,this._isNeeded=!1,this._rawShouldBeVisible=!1,this._shouldBeVisible=!1,this._revealTimer=this._register(new y.TimeoutTimer)}setVisibility(E){this._visibility!==E&&(this._visibility=E,this._updateShouldBeVisible())}setShouldBeVisible(E){this._rawShouldBeVisible=E,this._updateShouldBeVisible()}_applyVisibilitySetting(){return this._visibility===2?!1:this._visibility===3?!0:this._rawShouldBeVisible}_updateShouldBeVisible(){const E=this._applyVisibilitySetting();this._shouldBeVisible!==E&&(this._shouldBeVisible=E,this.ensureVisibility())}setIsNeeded(E){this._isNeeded!==E&&(this._isNeeded=E,this.ensureVisibility())}setDomNode(E){this._domNode=E,this._domNode.setClassName(this._invisibleClassName),this.setShouldBeVisible(!1)}ensureVisibility(){if(!this._isNeeded){this._hide(!1);return}this._shouldBeVisible?this._reveal():this._hide(!0)}_reveal(){this._isVisible||(this._isVisible=!0,this._revealTimer.setIfNotSet(()=>{this._domNode?.setClassName(this._visibleClassName)},0))}_hide(E){this._revealTimer.cancel(),!!this._isVisible&&(this._isVisible=!1,this._domNode?.setClassName(this._invisibleClassName+(E?" fade":"")))}}t.ScrollbarVisibilityController=B}),define(me[116],pe([1,0,4,22,14,3,2,5]),function(J,t,y,i,B,M,E,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBoxNative=void 0;class m extends E.Disposable{constructor(g,F,l,s){super();this.selected=0,this.selectBoxOptions=s||Object.create(null),this.options=[],this.selectElement=document.createElement("select"),this.selectElement.className="monaco-select-box",typeof this.selectBoxOptions.ariaLabel=="string"&&this.selectElement.setAttribute("aria-label",this.selectBoxOptions.ariaLabel),typeof this.selectBoxOptions.ariaDescription=="string"&&this.selectElement.setAttribute("aria-description",this.selectBoxOptions.ariaDescription),this._onDidSelect=this._register(new M.Emitter),this.styles=l,this.registerListeners(),this.setOptions(g,F)}registerListeners(){this._register(i.Gesture.addTarget(this.selectElement)),[i.EventType.Tap].forEach(g=>{this._register(y.addDisposableListener(this.selectElement,g,F=>{this.selectElement.focus()}))}),this._register(y.addStandardDisposableListener(this.selectElement,"click",g=>{y.EventHelper.stop(g,!0)})),this._register(y.addStandardDisposableListener(this.selectElement,"change",g=>{this.selectElement.title=g.target.value,this._onDidSelect.fire({index:g.target.selectedIndex,selected:g.target.value})})),this._register(y.addStandardDisposableListener(this.selectElement,"keydown",g=>{let F=!1;w.isMacintosh?(g.keyCode===18||g.keyCode===16||g.keyCode===10)&&(F=!0):(g.keyCode===18&&g.altKey||g.keyCode===10||g.keyCode===3)&&(F=!0),F&&g.stopPropagation()}))}get onDidSelect(){return this._onDidSelect.event}setOptions(g,F){(!this.options||!B.equals(this.options,g))&&(this.options=g,this.selectElement.options.length=0,this.options.forEach((l,s)=>{this.selectElement.add(this.createOption(l.text,s,l.isDisabled))})),F!==void 0&&this.select(F)}select(g){this.options.length===0?this.selected=0:g>=0&&g<this.options.length?this.selected=g:g>this.options.length-1?this.select(this.options.length-1):this.selected<0&&(this.selected=0),this.selectElement.selectedIndex=this.selected,this.selected<this.options.length&&typeof this.options[this.selected].text=="string"?this.selectElement.title=this.options[this.selected].text:this.selectElement.title=""}setAriaLabel(g){this.selectBoxOptions.ariaLabel=g,this.selectElement.setAttribute("aria-label",g)}focus(){this.selectElement&&(this.selectElement.tabIndex=0,this.selectElement.focus())}blur(){this.selectElement&&(this.selectElement.tabIndex=-1,this.selectElement.blur())}setFocusable(g){this.selectElement.tabIndex=g?0:-1}render(g){g.classList.add("select-container"),g.appendChild(this.selectElement),this.setOptions(this.options,this.selected),this.applyStyles()}style(g){this.styles=g,this.applyStyles()}applyStyles(){if(this.selectElement){const g=this.styles.selectBackground?this.styles.selectBackground.toString():"",F=this.styles.selectForeground?this.styles.selectForeground.toString():"",l=this.styles.selectBorder?this.styles.selectBorder.toString():"";this.selectElement.style.backgroundColor=g,this.selectElement.style.color=F,this.selectElement.style.borderColor=l}}createOption(g,F,l){const s=document.createElement("option");return s.value=g,s.text=g,s.disabled=!!l,s}}t.SelectBoxNative=m}),define(me[54],pe([1,0,23,14,8,111,3,26]),function(J,t,y,i,B,M,E,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IndexTreeModel=t.getVisibleState=t.isFilterResult=void 0;function m(l){return typeof l=="object"&&"visibility"in l&&"data"in l}t.isFilterResult=m;function f(l){switch(l){case!0:return 1;case!1:return 0;default:return l}}t.getVisibleState=f;function g(l){return typeof l.collapsible=="boolean"}class F{constructor(s,e,p,D={}){this.user=s,this.list=e,this.rootRef=[],this.eventBufferer=new E.EventBufferer,this._onDidChangeCollapseState=new E.Emitter,this.onDidChangeCollapseState=this.eventBufferer.wrapEvent(this._onDidChangeCollapseState.event),this._onDidChangeRenderNodeCount=new E.Emitter,this.onDidChangeRenderNodeCount=this.eventBufferer.wrapEvent(this._onDidChangeRenderNodeCount.event),this._onDidSplice=new E.Emitter,this.onDidSplice=this._onDidSplice.event,this.refilterDelayer=new B.Delayer(B.MicrotaskDelay),this.collapseByDefault=typeof D.collapseByDefault=="undefined"?!1:D.collapseByDefault,this.filter=D.filter,this.autoExpandSingleChildren=typeof D.autoExpandSingleChildren=="undefined"?!1:D.autoExpandSingleChildren,this.root={parent:void 0,element:p,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visibility:1,visible:!0,filterData:void 0}}splice(s,e,p=w.Iterable.empty(),D={}){if(s.length===0)throw new y.TreeError(this.user,"Invalid tree location");D.diffIdentityProvider?this.spliceSmart(D.diffIdentityProvider,s,e,p,D):this.spliceSimple(s,e,p,D)}spliceSmart(s,e,p,D=w.Iterable.empty(),v,_=v.diffDepth??0){const{parentNode:a}=this.getParentNodeWithListIndex(e);if(!a.lastDiffIds)return this.spliceSimple(e,p,D,v);const o=[...D],b=e[e.length-1],S=new M.LcsDiff({getElements:()=>a.lastDiffIds},{getElements:()=>[...a.children.slice(0,b),...o,...a.children.slice(b+p)].map(c=>s.getId(c.element).toString())}).ComputeDiff(!1);if(S.quitEarly)return a.lastDiffIds=void 0,this.spliceSimple(e,p,o,v);const A=e.slice(0,-1),C=(c,u,h)=>{if(_>0)for(let O=0;O<h;O++)c--,u--,this.spliceSmart(s,[...A,c,0],Number.MAX_SAFE_INTEGER,o[u].children,v,_-1)};let r=Math.min(a.children.length,b+p),n=o.length;for(const c of S.changes.sort((u,h)=>h.originalStart-u.originalStart))C(r,n,r-(c.originalStart+c.originalLength)),r=c.originalStart,n=c.modifiedStart-b,this.spliceSimple([...A,r],c.originalLength,w.Iterable.slice(o,n,n+c.modifiedLength),v);C(r,n,r)}spliceSimple(s,e,p=w.Iterable.empty(),{onDidCreateNode:D,onDidDeleteNode:v,diffIdentityProvider:_}){const{parentNode:a,listIndex:o,revealed:b,visible:S}=this.getParentNodeWithListIndex(s),A=[],C=w.Iterable.map(p,ae=>this.createTreeNode(ae,a,a.visible?1:0,b,A,D)),r=s[s.length-1],n=a.children.length>0;let c=0;for(let ae=r;ae>=0&&ae<a.children.length;ae--){const we=a.children[ae];if(we.visible){c=we.visibleChildIndex;break}}const u=[];let h=0,O=0;for(const ae of C)u.push(ae),O+=ae.renderNodeCount,ae.visible&&(ae.visibleChildIndex=c+h++);const V=(0,i.splice)(a.children,r,e,u);_?a.lastDiffIds?(0,i.splice)(a.lastDiffIds,r,e,u.map(ae=>_.getId(ae.element).toString())):a.lastDiffIds=a.children.map(ae=>_.getId(ae.element).toString()):a.lastDiffIds=void 0;let ue=0;for(const ae of V)ae.visible&&ue++;if(ue!==0)for(let ae=r+u.length;ae<a.children.length;ae++){const we=a.children[ae];we.visible&&(we.visibleChildIndex-=ue)}if(a.visibleChildrenCount+=h-ue,b&&S){const ae=V.reduce((we,ce)=>we+(ce.visible?ce.renderNodeCount:0),0);this._updateAncestorsRenderNodeCount(a,O-ae),this.list.splice(o,ae,A)}if(V.length>0&&v){const ae=we=>{v(we),we.children.forEach(ae)};V.forEach(ae)}this._onDidSplice.fire({insertedNodes:u,deletedNodes:V});const ie=a.children.length>0;n!==ie&&this.setCollapsible(s.slice(0,-1),ie);let ge=a;for(;ge;){if(ge.visibility===2){this.refilterDelayer.trigger(()=>this.refilter());break}ge=ge.parent}}rerender(s){if(s.length===0)throw new y.TreeError(this.user,"Invalid tree location");const{node:e,listIndex:p,revealed:D}=this.getTreeNodeWithListIndex(s);e.visible&&D&&this.list.splice(p,1,[e])}updateElementHeight(s,e){if(s.length===0)throw new y.TreeError(this.user,"Invalid tree location");const{listIndex:p}=this.getTreeNodeWithListIndex(s);this.list.updateElementHeight(p,e)}has(s){return this.hasTreeNode(s)}getListIndex(s){const{listIndex:e,visible:p,revealed:D}=this.getTreeNodeWithListIndex(s);return p&&D?e:-1}getListRenderCount(s){return this.getTreeNode(s).renderNodeCount}isCollapsible(s){return this.getTreeNode(s).collapsible}setCollapsible(s,e){const p=this.getTreeNode(s);typeof e=="undefined"&&(e=!p.collapsible);const D={collapsible:e};return this.eventBufferer.bufferEvents(()=>this._setCollapseState(s,D))}isCollapsed(s){return this.getTreeNode(s).collapsed}setCollapsed(s,e,p){const D=this.getTreeNode(s);typeof e=="undefined"&&(e=!D.collapsed);const v={collapsed:e,recursive:p||!1};return this.eventBufferer.bufferEvents(()=>this._setCollapseState(s,v))}_setCollapseState(s,e){const{node:p,listIndex:D,revealed:v}=this.getTreeNodeWithListIndex(s),_=this._setListNodeCollapseState(p,D,v,e);if(p!==this.root&&this.autoExpandSingleChildren&&_&&!g(e)&&p.collapsible&&!p.collapsed&&!e.recursive){let a=-1;for(let o=0;o<p.children.length;o++)if(p.children[o].visible)if(a>-1){a=-1;break}else a=o;a>-1&&this._setCollapseState([...s,a],e)}return _}_setListNodeCollapseState(s,e,p,D){const v=this._setNodeCollapseState(s,D,!1);if(!p||!s.visible||!v)return v;const _=s.renderNodeCount,a=this.updateNodeAfterCollapseChange(s),o=_-(e===-1?0:1);return this.list.splice(e+1,o,a.slice(1)),v}_setNodeCollapseState(s,e,p){let D;if(s===this.root?D=!1:(g(e)?(D=s.collapsible!==e.collapsible,s.collapsible=e.collapsible):s.collapsible?(D=s.collapsed!==e.collapsed,s.collapsed=e.collapsed):D=!1,D&&this._onDidChangeCollapseState.fire({node:s,deep:p})),!g(e)&&e.recursive)for(const v of s.children)D=this._setNodeCollapseState(v,e,!0)||D;return D}expandTo(s){this.eventBufferer.bufferEvents(()=>{let e=this.getTreeNode(s);for(;e.parent;)e=e.parent,s=s.slice(0,s.length-1),e.collapsed&&this._setCollapseState(s,{collapsed:!1,recursive:!1})})}refilter(){const s=this.root.renderNodeCount,e=this.updateNodeAfterFilterChange(this.root);this.list.splice(0,s,e),this.refilterDelayer.cancel()}createTreeNode(s,e,p,D,v,_){const a={parent:e,element:s.element,children:[],depth:e.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:typeof s.collapsible=="boolean"?s.collapsible:typeof s.collapsed!="undefined",collapsed:typeof s.collapsed=="undefined"?this.collapseByDefault:s.collapsed,renderNodeCount:1,visibility:1,visible:!0,filterData:void 0},o=this._filterNode(a,p);a.visibility=o,D&&v.push(a);const b=s.children||w.Iterable.empty(),S=D&&o!==0&&!a.collapsed,A=w.Iterable.map(b,n=>this.createTreeNode(n,a,o,S,v,_));let C=0,r=1;for(const n of A)a.children.push(n),r+=n.renderNodeCount,n.visible&&(n.visibleChildIndex=C++);return a.collapsible=a.collapsible||a.children.length>0,a.visibleChildrenCount=C,a.visible=o===2?C>0:o===1,a.visible?a.collapsed||(a.renderNodeCount=r):(a.renderNodeCount=0,D&&v.pop()),_?.(a),a}updateNodeAfterCollapseChange(s){const e=s.renderNodeCount,p=[];return this._updateNodeAfterCollapseChange(s,p),this._updateAncestorsRenderNodeCount(s.parent,p.length-e),p}_updateNodeAfterCollapseChange(s,e){if(s.visible===!1)return 0;if(e.push(s),s.renderNodeCount=1,!s.collapsed)for(const p of s.children)s.renderNodeCount+=this._updateNodeAfterCollapseChange(p,e);return this._onDidChangeRenderNodeCount.fire(s),s.renderNodeCount}updateNodeAfterFilterChange(s){const e=s.renderNodeCount,p=[];return this._updateNodeAfterFilterChange(s,s.visible?1:0,p),this._updateAncestorsRenderNodeCount(s.parent,p.length-e),p}_updateNodeAfterFilterChange(s,e,p,D=!0){let v;if(s!==this.root){if(v=this._filterNode(s,e),v===0)return s.visible=!1,s.renderNodeCount=0,!1;D&&p.push(s)}const _=p.length;s.renderNodeCount=s===this.root?0:1;let a=!1;if(!s.collapsed||v!==0){let o=0;for(const b of s.children)a=this._updateNodeAfterFilterChange(b,v,p,D&&!s.collapsed)||a,b.visible&&(b.visibleChildIndex=o++);s.visibleChildrenCount=o}else s.visibleChildrenCount=0;return s!==this.root&&(s.visible=v===2?a:v===1,s.visibility=v),s.visible?s.collapsed||(s.renderNodeCount+=p.length-_):(s.renderNodeCount=0,D&&p.pop()),this._onDidChangeRenderNodeCount.fire(s),s.visible}_updateAncestorsRenderNodeCount(s,e){if(e!==0)for(;s;)s.renderNodeCount+=e,this._onDidChangeRenderNodeCount.fire(s),s=s.parent}_filterNode(s,e){const p=this.filter?this.filter.filter(s.element,e):1;return typeof p=="boolean"?(s.filterData=void 0,p?1:0):m(p)?(s.filterData=p.data,f(p.visibility)):(s.filterData=void 0,f(p))}hasTreeNode(s,e=this.root){if(!s||s.length===0)return!0;const[p,...D]=s;return p<0||p>e.children.length?!1:this.hasTreeNode(D,e.children[p])}getTreeNode(s,e=this.root){if(!s||s.length===0)return e;const[p,...D]=s;if(p<0||p>e.children.length)throw new y.TreeError(this.user,"Invalid tree location");return this.getTreeNode(D,e.children[p])}getTreeNodeWithListIndex(s){if(s.length===0)return{node:this.root,listIndex:-1,revealed:!0,visible:!1};const{parentNode:e,listIndex:p,revealed:D,visible:v}=this.getParentNodeWithListIndex(s),_=s[s.length-1];if(_<0||_>e.children.length)throw new y.TreeError(this.user,"Invalid tree location");const a=e.children[_];return{node:a,listIndex:p,revealed:D,visible:v&&a.visible}}getParentNodeWithListIndex(s,e=this.root,p=0,D=!0,v=!0){const[_,...a]=s;if(_<0||_>e.children.length)throw new y.TreeError(this.user,"Invalid tree location");for(let o=0;o<_;o++)p+=e.children[o].renderNodeCount;return D=D&&!e.collapsed,v=v&&e.visible,a.length===0?{parentNode:e,listIndex:p,revealed:D,visible:v}:this.getParentNodeWithListIndex(a,e.children[_],p+1,D,v)}getNode(s=[]){return this.getTreeNode(s)}getNodeLocation(s){const e=[];let p=s;for(;p.parent;)e.push(p.parent.children.indexOf(p)),p=p.parent;return e.reverse()}getParentNodeLocation(s){if(s.length!==0)return s.length===1?[]:(0,i.tail2)(s)[0]}getFirstElementChild(s){const e=this.getTreeNode(s);if(e.children.length!==0)return e.children[0].element}getLastElementAncestor(s=[]){const e=this.getTreeNode(s);if(e.children.length!==0)return this._getLastElementAncestor(e)}_getLastElementAncestor(s){return s.children.length===0?s.element:this._getLastElementAncestor(s.children[s.children.length-1])}}t.IndexTreeModel=F}),define(me[117],pe([1,0,54,23,26]),function(J,t,y,i,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ObjectTreeModel=void 0;class M{constructor(w,m,f={}){this.user=w,this.rootRef=null,this.nodes=new Map,this.nodesByIdentity=new Map,this.model=new y.IndexTreeModel(w,m,null,f),this.onDidSplice=this.model.onDidSplice,this.onDidChangeCollapseState=this.model.onDidChangeCollapseState,this.onDidChangeRenderNodeCount=this.model.onDidChangeRenderNodeCount,f.sorter&&(this.sorter={compare(g,F){return f.sorter.compare(g.element,F.element)}}),this.identityProvider=f.identityProvider}get size(){return this.nodes.size}setChildren(w,m=B.Iterable.empty(),f={}){const g=this.getElementLocation(w);this._setChildren(g,this.preserveCollapseState(m),f)}_setChildren(w,m=B.Iterable.empty(),f){const g=new Set,F=new Set,l=e=>{if(e.element===null)return;const p=e;if(g.add(p.element),this.nodes.set(p.element,p),this.identityProvider){const D=this.identityProvider.getId(p.element).toString();F.add(D),this.nodesByIdentity.set(D,p)}f.onDidCreateNode?.(p)},s=e=>{if(e.element===null)return;const p=e;if(g.has(p.element)||this.nodes.delete(p.element),this.identityProvider){const D=this.identityProvider.getId(p.element).toString();F.has(D)||this.nodesByIdentity.delete(D)}f.onDidDeleteNode?.(p)};this.model.splice([...w,0],Number.MAX_VALUE,m,{...f,onDidCreateNode:l,onDidDeleteNode:s})}preserveCollapseState(w=B.Iterable.empty()){return this.sorter&&(w=[...w].sort(this.sorter.compare.bind(this.sorter))),B.Iterable.map(w,m=>{let f=this.nodes.get(m.element);if(!f&&this.identityProvider){const l=this.identityProvider.getId(m.element).toString();f=this.nodesByIdentity.get(l)}if(!f)return{...m,children:this.preserveCollapseState(m.children)};const g=typeof m.collapsible=="boolean"?m.collapsible:f.collapsible,F=typeof m.collapsed!="undefined"?m.collapsed:f.collapsed;return{...m,collapsible:g,collapsed:F,children:this.preserveCollapseState(m.children)}})}rerender(w){const m=this.getElementLocation(w);this.model.rerender(m)}updateElementHeight(w,m){const f=this.getElementLocation(w);this.model.updateElementHeight(f,m)}resort(w=null,m=!0){if(!this.sorter)return;const f=this.getElementLocation(w),g=this.model.getNode(f);this._setChildren(f,this.resortChildren(g,m),{})}resortChildren(w,m,f=!0){let g=[...w.children];return(m||f)&&(g=g.sort(this.sorter.compare.bind(this.sorter))),B.Iterable.map(g,F=>({element:F.element,collapsible:F.collapsible,collapsed:F.collapsed,children:this.resortChildren(F,m,!1)}))}getFirstElementChild(w=null){const m=this.getElementLocation(w);return this.model.getFirstElementChild(m)}getLastElementAncestor(w=null){const m=this.getElementLocation(w);return this.model.getLastElementAncestor(m)}has(w){return this.nodes.has(w)}getListIndex(w){const m=this.getElementLocation(w);return this.model.getListIndex(m)}getListRenderCount(w){const m=this.getElementLocation(w);return this.model.getListRenderCount(m)}isCollapsible(w){const m=this.getElementLocation(w);return this.model.isCollapsible(m)}setCollapsible(w,m){const f=this.getElementLocation(w);return this.model.setCollapsible(f,m)}isCollapsed(w){const m=this.getElementLocation(w);return this.model.isCollapsed(m)}setCollapsed(w,m,f){const g=this.getElementLocation(w);return this.model.setCollapsed(g,m,f)}expandTo(w){const m=this.getElementLocation(w);this.model.expandTo(m)}refilter(){this.model.refilter()}getNode(w=null){if(w===null)return this.model.getNode(this.model.rootRef);const m=this.nodes.get(w);if(!m)throw new i.TreeError(this.user,`Tree element not found: ${w}`);return m}getNodeLocation(w){return w.element}getParentNodeLocation(w){if(w===null)throw new i.TreeError(this.user,"Invalid getParentNodeLocation call");const m=this.nodes.get(w);if(!m)throw new i.TreeError(this.user,`Tree element not found: ${w}`);const f=this.model.getNodeLocation(m),g=this.model.getParentNodeLocation(f);return this.model.getNode(g).element}getElementLocation(w){if(w===null)return[];const m=this.nodes.get(w);if(!m)throw new i.TreeError(this.user,`Tree element not found: ${w}`);return this.model.getNodeLocation(m)}}t.ObjectTreeModel=M}),define(me[17],pe([1,0,4,19,20,22,2]),function(J,t,y,i,B,M,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Widget=void 0;class w extends E.Disposable{onclick(f,g){this._register(y.addDisposableListener(f,y.EventType.CLICK,F=>g(new B.StandardMouseEvent(F))))}onmousedown(f,g){this._register(y.addDisposableListener(f,y.EventType.MOUSE_DOWN,F=>g(new B.StandardMouseEvent(F))))}onmouseover(f,g){this._register(y.addDisposableListener(f,y.EventType.MOUSE_OVER,F=>g(new B.StandardMouseEvent(F))))}onmouseleave(f,g){this._register(y.addDisposableListener(f,y.EventType.MOUSE_LEAVE,F=>g(new B.StandardMouseEvent(F))))}onkeydown(f,g){this._register(y.addDisposableListener(f,y.EventType.KEY_DOWN,F=>g(new i.StandardKeyboardEvent(F))))}onkeyup(f,g){this._register(y.addDisposableListener(f,y.EventType.KEY_UP,F=>g(new i.StandardKeyboardEvent(F))))}oninput(f,g){this._register(y.addDisposableListener(f,y.EventType.INPUT,g))}onblur(f,g){this._register(y.addDisposableListener(f,y.EventType.BLUR,g))}onfocus(f,g){this._register(y.addDisposableListener(f,y.EventType.FOCUS,g))}onchange(f,g){this._register(y.addDisposableListener(f,y.EventType.CHANGE,g))}ignoreGesture(f){M.Gesture.ignoreTarget(f)}}t.Widget=w}),define(me[37],pe([1,0,52,17,8,4]),function(J,t,y,i,B,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarArrow=t.ARROW_IMG_SIZE=void 0,t.ARROW_IMG_SIZE=11;class E extends i.Widget{constructor(m){super();this._onActivate=m.onActivate,this.bgDomNode=document.createElement("div"),this.bgDomNode.className="arrow-background",this.bgDomNode.style.position="absolute",this.bgDomNode.style.width=m.bgWidth+"px",this.bgDomNode.style.height=m.bgHeight+"px",typeof m.top!="undefined"&&(this.bgDomNode.style.top="0px"),typeof m.left!="undefined"&&(this.bgDomNode.style.left="0px"),typeof m.bottom!="undefined"&&(this.bgDomNode.style.bottom="0px"),typeof m.right!="undefined"&&(this.bgDomNode.style.right="0px"),this.domNode=document.createElement("div"),this.domNode.className=m.className,this.domNode.classList.add(...m.icon.classNamesArray),this.domNode.style.position="absolute",this.domNode.style.width=t.ARROW_IMG_SIZE+"px",this.domNode.style.height=t.ARROW_IMG_SIZE+"px",typeof m.top!="undefined"&&(this.domNode.style.top=m.top+"px"),typeof m.left!="undefined"&&(this.domNode.style.left=m.left+"px"),typeof m.bottom!="undefined"&&(this.domNode.style.bottom=m.bottom+"px"),typeof m.right!="undefined"&&(this.domNode.style.right=m.right+"px"),this._pointerMoveMonitor=this._register(new y.GlobalPointerMoveMonitor),this._register(M.addStandardDisposableListener(this.bgDomNode,M.EventType.POINTER_DOWN,f=>this._arrowPointerDown(f))),this._register(M.addStandardDisposableListener(this.domNode,M.EventType.POINTER_DOWN,f=>this._arrowPointerDown(f))),this._pointerdownRepeatTimer=this._register(new B.IntervalTimer),this._pointerdownScheduleRepeatTimer=this._register(new B.TimeoutTimer)}_arrowPointerDown(m){if(!m.target||!(m.target instanceof Element))return;const f=()=>{this._pointerdownRepeatTimer.cancelAndSet(()=>this._onActivate(),1e3/24)};this._onActivate(),this._pointerdownRepeatTimer.cancel(),this._pointerdownScheduleRepeatTimer.cancelAndSet(f,200),this._pointerMoveMonitor.startMonitoring(m.target,m.pointerId,m.buttons,g=>{},()=>{this._pointerdownRepeatTimer.cancel(),this._pointerdownScheduleRepeatTimer.cancel()}),m.preventDefault()}}t.ScrollbarArrow=E}),define(me[55],pe([1,0,4,40,52,37,115,17,5]),function(J,t,y,i,B,M,E,w,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractScrollbar=void 0;const f=140;class g extends w.Widget{constructor(l){super();this._lazyRender=l.lazyRender,this._host=l.host,this._scrollable=l.scrollable,this._scrollByPage=l.scrollByPage,this._scrollbarState=l.scrollbarState,this._visibilityController=this._register(new E.ScrollbarVisibilityController(l.visibility,"visible scrollbar "+l.extraScrollbarClassName,"invisible scrollbar "+l.extraScrollbarClassName)),this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._pointerMoveMonitor=this._register(new B.GlobalPointerMoveMonitor),this._shouldRender=!0,this.domNode=(0,i.createFastDomNode)(document.createElement("div")),this.domNode.setAttribute("role","presentation"),this.domNode.setAttribute("aria-hidden","true"),this._visibilityController.setDomNode(this.domNode),this.domNode.setPosition("absolute"),this._register(y.addDisposableListener(this.domNode.domNode,y.EventType.POINTER_DOWN,s=>this._domNodePointerDown(s)))}_createArrow(l){const s=this._register(new M.ScrollbarArrow(l));this.domNode.domNode.appendChild(s.bgDomNode),this.domNode.domNode.appendChild(s.domNode)}_createSlider(l,s,e,p){this.slider=(0,i.createFastDomNode)(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop(l),this.slider.setLeft(s),typeof e=="number"&&this.slider.setWidth(e),typeof p=="number"&&this.slider.setHeight(p),this.slider.setLayerHinting(!0),this.slider.setContain("strict"),this.domNode.domNode.appendChild(this.slider.domNode),this._register(y.addDisposableListener(this.slider.domNode,y.EventType.POINTER_DOWN,D=>{D.button===0&&(D.preventDefault(),this._sliderPointerDown(D))})),this.onclick(this.slider.domNode,D=>{D.leftButton&&D.stopPropagation()})}_onElementSize(l){return this._scrollbarState.setVisibleSize(l)&&(this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._shouldRender=!0,this._lazyRender||this.render()),this._shouldRender}_onElementScrollSize(l){return this._scrollbarState.setScrollSize(l)&&(this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._shouldRender=!0,this._lazyRender||this.render()),this._shouldRender}_onElementScrollPosition(l){return this._scrollbarState.setScrollPosition(l)&&(this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._shouldRender=!0,this._lazyRender||this.render()),this._shouldRender}beginReveal(){this._visibilityController.setShouldBeVisible(!0)}beginHide(){this._visibilityController.setShouldBeVisible(!1)}render(){!this._shouldRender||(this._shouldRender=!1,this._renderDomNode(this._scrollbarState.getRectangleLargeSize(),this._scrollbarState.getRectangleSmallSize()),this._updateSlider(this._scrollbarState.getSliderSize(),this._scrollbarState.getArrowSize()+this._scrollbarState.getSliderPosition()))}_domNodePointerDown(l){l.target===this.domNode.domNode&&this._onPointerDown(l)}delegatePointerDown(l){const s=this.domNode.domNode.getClientRects()[0].top,e=s+this._scrollbarState.getSliderPosition(),p=s+this._scrollbarState.getSliderPosition()+this._scrollbarState.getSliderSize(),D=this._sliderPointerPosition(l);e<=D&&D<=p?l.button===0&&(l.preventDefault(),this._sliderPointerDown(l)):this._onPointerDown(l)}_onPointerDown(l){let s,e;if(l.target===this.domNode.domNode&&typeof l.offsetX=="number"&&typeof l.offsetY=="number")s=l.offsetX,e=l.offsetY;else{const D=y.getDomNodePagePosition(this.domNode.domNode);s=l.pageX-D.left,e=l.pageY-D.top}const p=this._pointerDownRelativePosition(s,e);this._setDesiredScrollPositionNow(this._scrollByPage?this._scrollbarState.getDesiredScrollPositionFromOffsetPaged(p):this._scrollbarState.getDesiredScrollPositionFromOffset(p)),l.button===0&&(l.preventDefault(),this._sliderPointerDown(l))}_sliderPointerDown(l){if(!l.target||!(l.target instanceof Element))return;const s=this._sliderPointerPosition(l),e=this._sliderOrthogonalPointerPosition(l),p=this._scrollbarState.clone();this.slider.toggleClassName("active",!0),this._pointerMoveMonitor.startMonitoring(l.target,l.pointerId,l.buttons,D=>{const v=this._sliderOrthogonalPointerPosition(D),_=Math.abs(v-e);if(m.isWindows&&_>f){this._setDesiredScrollPositionNow(p.getScrollPosition());return}const o=this._sliderPointerPosition(D)-s;this._setDesiredScrollPositionNow(p.getDesiredScrollPositionFromDelta(o))},()=>{this.slider.toggleClassName("active",!1),this._host.onDragEnd()}),this._host.onDragStart()}_setDesiredScrollPositionNow(l){const s={};this.writeScrollPosition(s,l),this._scrollable.setScrollPositionNow(s)}updateScrollbarSize(l){this._updateScrollbarSize(l),this._scrollbarState.setScrollbarSize(l),this._shouldRender=!0,this._lazyRender||this.render()}isNeeded(){return this._scrollbarState.isNeeded()}}t.AbstractScrollbar=g}),define(me[118],pe([1,0,20,55,37,41,11]),function(J,t,y,i,B,M,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HorizontalScrollbar=void 0;class w extends i.AbstractScrollbar{constructor(f,g,F){const l=f.getScrollDimensions(),s=f.getCurrentScrollPosition();super({lazyRender:g.lazyRender,host:F,scrollbarState:new M.ScrollbarState(g.horizontalHasArrows?g.arrowSize:0,g.horizontal===2?0:g.horizontalScrollbarSize,g.vertical===2?0:g.verticalScrollbarSize,l.width,l.scrollWidth,s.scrollLeft),visibility:g.horizontal,extraScrollbarClassName:"horizontal",scrollable:f,scrollByPage:g.scrollByPage});if(g.horizontalHasArrows){const e=(g.arrowSize-B.ARROW_IMG_SIZE)/2,p=(g.horizontalScrollbarSize-B.ARROW_IMG_SIZE)/2;this._createArrow({className:"scra",icon:E.Codicon.scrollbarButtonLeft,top:p,left:e,bottom:void 0,right:void 0,bgWidth:g.arrowSize,bgHeight:g.horizontalScrollbarSize,onActivate:()=>this._host.onMouseWheel(new y.StandardWheelEvent(null,1,0))}),this._createArrow({className:"scra",icon:E.Codicon.scrollbarButtonRight,top:p,left:void 0,bottom:void 0,right:e,bgWidth:g.arrowSize,bgHeight:g.horizontalScrollbarSize,onActivate:()=>this._host.onMouseWheel(new y.StandardWheelEvent(null,-1,0))})}this._createSlider(Math.floor((g.horizontalScrollbarSize-g.horizontalSliderSize)/2),0,void 0,g.horizontalSliderSize)}_updateSlider(f,g){this.slider.setWidth(f),this.slider.setLeft(g)}_renderDomNode(f,g){this.domNode.setWidth(f),this.domNode.setHeight(g),this.domNode.setLeft(0),this.domNode.setBottom(0)}onDidScroll(f){return this._shouldRender=this._onElementScrollSize(f.scrollWidth)||this._shouldRender,this._shouldRender=this._onElementScrollPosition(f.scrollLeft)||this._shouldRender,this._shouldRender=this._onElementSize(f.width)||this._shouldRender,this._shouldRender}_pointerDownRelativePosition(f,g){return f}_sliderPointerPosition(f){return f.pageX}_sliderOrthogonalPointerPosition(f){return f.pageY}_updateScrollbarSize(f){this.slider.setHeight(f)}writeScrollPosition(f,g){f.scrollLeft=g}updateOptions(f){this.updateScrollbarSize(f.horizontal===2?0:f.horizontalScrollbarSize),this._scrollbarState.setOppositeScrollbarSize(f.vertical===2?0:f.verticalScrollbarSize),this._visibilityController.setVisibility(f.horizontal),this._scrollByPage=f.scrollByPage}}t.HorizontalScrollbar=w}),define(me[119],pe([1,0,20,55,37,41,11]),function(J,t,y,i,B,M,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.VerticalScrollbar=void 0;class w extends i.AbstractScrollbar{constructor(f,g,F){const l=f.getScrollDimensions(),s=f.getCurrentScrollPosition();super({lazyRender:g.lazyRender,host:F,scrollbarState:new M.ScrollbarState(g.verticalHasArrows?g.arrowSize:0,g.vertical===2?0:g.verticalScrollbarSize,0,l.height,l.scrollHeight,s.scrollTop),visibility:g.vertical,extraScrollbarClassName:"vertical",scrollable:f,scrollByPage:g.scrollByPage});if(g.verticalHasArrows){const e=(g.arrowSize-B.ARROW_IMG_SIZE)/2,p=(g.verticalScrollbarSize-B.ARROW_IMG_SIZE)/2;this._createArrow({className:"scra",icon:E.Codicon.scrollbarButtonUp,top:e,left:p,bottom:void 0,right:void 0,bgWidth:g.verticalScrollbarSize,bgHeight:g.arrowSize,onActivate:()=>this._host.onMouseWheel(new y.StandardWheelEvent(null,0,1))}),this._createArrow({className:"scra",icon:E.Codicon.scrollbarButtonDown,top:void 0,left:p,bottom:e,right:void 0,bgWidth:g.verticalScrollbarSize,bgHeight:g.arrowSize,onActivate:()=>this._host.onMouseWheel(new y.StandardWheelEvent(null,0,-1))})}this._createSlider(0,Math.floor((g.verticalScrollbarSize-g.verticalSliderSize)/2),g.verticalSliderSize,void 0)}_updateSlider(f,g){this.slider.setHeight(f),this.slider.setTop(g)}_renderDomNode(f,g){this.domNode.setWidth(g),this.domNode.setHeight(f),this.domNode.setRight(0),this.domNode.setTop(0)}onDidScroll(f){return this._shouldRender=this._onElementScrollSize(f.scrollHeight)||this._shouldRender,this._shouldRender=this._onElementScrollPosition(f.scrollTop)||this._shouldRender,this._shouldRender=this._onElementSize(f.height)||this._shouldRender,this._shouldRender}_pointerDownRelativePosition(f,g){return g}_sliderPointerPosition(f){return f.pageY}_sliderOrthogonalPointerPosition(f){return f.pageX}_updateScrollbarSize(f){this.slider.setWidth(f)}writeScrollPosition(f,g){f.scrollTop=g}updateOptions(f){this.updateScrollbarSize(f.vertical===2?0:f.verticalScrollbarSize),this._scrollbarState.setOppositeScrollbarSize(0),this._visibilityController.setVisibility(f.vertical),this._scrollByPage=f.scrollByPage}}t.VerticalScrollbar=w}),define(me[56],pe([1,0,15,4,40,20,118,119,17,8,3,2,5,47,89]),function(J,t,y,i,B,M,E,w,m,f,g,F,l,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DomScrollableElement=t.SmoothScrollableElement=t.ScrollableElement=t.AbstractScrollableElement=t.MouseWheelClassifier=void 0;const e=500,p=50,D=!0;class v{constructor(r,n,c){this.timestamp=r,this.deltaX=n,this.deltaY=c,this.score=0}}class _{constructor(){this._capacity=5,this._memory=[],this._front=-1,this._rear=-1}isPhysicalMouseWheel(){if(this._front===-1&&this._rear===-1)return!1;let r=1,n=0,c=1,u=this._rear;do{const h=u===this._front?r:Math.pow(2,-c);if(r-=h,n+=this._memory[u].score*h,u===this._front)break;u=(this._capacity+u-1)%this._capacity,c++}while(!0);return n<=.5}accept(r,n,c){const u=new v(r,n,c);u.score=this._computeScore(u),this._front===-1&&this._rear===-1?(this._memory[0]=u,this._front=0,this._rear=0):(this._rear=(this._rear+1)%this._capacity,this._rear===this._front&&(this._front=(this._front+1)%this._capacity),this._memory[this._rear]=u)}_computeScore(r){if(Math.abs(r.deltaX)>0&&Math.abs(r.deltaY)>0)return 1;let n=.5;const c=this._front===-1&&this._rear===-1?null:this._memory[this._rear];return(!this._isAlmostInt(r.deltaX)||!this._isAlmostInt(r.deltaY))&&(n+=.25),Math.min(Math.max(n,0),1)}_isAlmostInt(r){return Math.abs(Math.round(r)-r)<.01}}t.MouseWheelClassifier=_,_.INSTANCE=new _;class a extends m.Widget{constructor(r,n,c){super();this._onScroll=this._register(new g.Emitter),this.onScroll=this._onScroll.event,this._onWillScroll=this._register(new g.Emitter),this.onWillScroll=this._onWillScroll.event,r.style.overflow="hidden",this._options=A(n),this._scrollable=c,this._register(this._scrollable.onScroll(h=>{this._onWillScroll.fire(h),this._onDidScroll(h),this._onScroll.fire(h)}));const u={onMouseWheel:h=>this._onMouseWheel(h),onDragStart:()=>this._onDragStart(),onDragEnd:()=>this._onDragEnd()};this._verticalScrollbar=this._register(new w.VerticalScrollbar(this._scrollable,this._options,u)),this._horizontalScrollbar=this._register(new E.HorizontalScrollbar(this._scrollable,this._options,u)),this._domNode=document.createElement("div"),this._domNode.className="monaco-scrollable-element "+this._options.className,this._domNode.setAttribute("role","presentation"),this._domNode.style.position="relative",this._domNode.style.overflow="hidden",this._domNode.appendChild(r),this._domNode.appendChild(this._horizontalScrollbar.domNode.domNode),this._domNode.appendChild(this._verticalScrollbar.domNode.domNode),this._options.useShadows?(this._leftShadowDomNode=(0,B.createFastDomNode)(document.createElement("div")),this._leftShadowDomNode.setClassName("shadow"),this._domNode.appendChild(this._leftShadowDomNode.domNode),this._topShadowDomNode=(0,B.createFastDomNode)(document.createElement("div")),this._topShadowDomNode.setClassName("shadow"),this._domNode.appendChild(this._topShadowDomNode.domNode),this._topLeftShadowDomNode=(0,B.createFastDomNode)(document.createElement("div")),this._topLeftShadowDomNode.setClassName("shadow"),this._domNode.appendChild(this._topLeftShadowDomNode.domNode)):(this._leftShadowDomNode=null,this._topShadowDomNode=null,this._topLeftShadowDomNode=null),this._listenOnDomNode=this._options.listenOnDomNode||this._domNode,this._mouseWheelToDispose=[],this._setListeningToMouseWheel(this._options.handleMouseWheel),this.onmouseover(this._listenOnDomNode,h=>this._onMouseOver(h)),this.onmouseleave(this._listenOnDomNode,h=>this._onMouseLeave(h)),this._hideTimeout=this._register(new f.TimeoutTimer),this._isDragging=!1,this._mouseIsOver=!1,this._shouldRender=!0,this._revealOnScroll=!0}get options(){return this._options}dispose(){this._mouseWheelToDispose=(0,F.dispose)(this._mouseWheelToDispose),super.dispose()}getDomNode(){return this._domNode}getOverviewRulerLayoutInfo(){return{parent:this._domNode,insertBefore:this._verticalScrollbar.domNode.domNode}}delegateVerticalScrollbarPointerDown(r){this._verticalScrollbar.delegatePointerDown(r)}getScrollDimensions(){return this._scrollable.getScrollDimensions()}setScrollDimensions(r){this._scrollable.setScrollDimensions(r,!1)}updateClassName(r){this._options.className=r,l.isMacintosh&&(this._options.className+=" mac"),this._domNode.className="monaco-scrollable-element "+this._options.className}updateOptions(r){typeof r.handleMouseWheel!="undefined"&&(this._options.handleMouseWheel=r.handleMouseWheel,this._setListeningToMouseWheel(this._options.handleMouseWheel)),typeof r.mouseWheelScrollSensitivity!="undefined"&&(this._options.mouseWheelScrollSensitivity=r.mouseWheelScrollSensitivity),typeof r.fastScrollSensitivity!="undefined"&&(this._options.fastScrollSensitivity=r.fastScrollSensitivity),typeof r.scrollPredominantAxis!="undefined"&&(this._options.scrollPredominantAxis=r.scrollPredominantAxis),typeof r.horizontal!="undefined"&&(this._options.horizontal=r.horizontal),typeof r.vertical!="undefined"&&(this._options.vertical=r.vertical),typeof r.horizontalScrollbarSize!="undefined"&&(this._options.horizontalScrollbarSize=r.horizontalScrollbarSize),typeof r.verticalScrollbarSize!="undefined"&&(this._options.verticalScrollbarSize=r.verticalScrollbarSize),typeof r.scrollByPage!="undefined"&&(this._options.scrollByPage=r.scrollByPage),this._horizontalScrollbar.updateOptions(this._options),this._verticalScrollbar.updateOptions(this._options),this._options.lazyRender||this._render()}setRevealOnScroll(r){this._revealOnScroll=r}triggerScrollFromMouseWheelEvent(r){this._onMouseWheel(new M.StandardWheelEvent(r))}_setListeningToMouseWheel(r){if(this._mouseWheelToDispose.length>0!==r&&(this._mouseWheelToDispose=(0,F.dispose)(this._mouseWheelToDispose),r)){const c=u=>{this._onMouseWheel(new M.StandardWheelEvent(u))};this._mouseWheelToDispose.push(i.addDisposableListener(this._listenOnDomNode,i.EventType.MOUSE_WHEEL,c,{passive:!1}))}}_onMouseWheel(r){const n=_.INSTANCE;if(D){const h=window.devicePixelRatio/(0,y.getZoomFactor)();l.isWindows||l.isLinux?n.accept(Date.now(),r.deltaX/h,r.deltaY/h):n.accept(Date.now(),r.deltaX,r.deltaY)}let c=!1;if(r.deltaY||r.deltaX){let h=r.deltaY*this._options.mouseWheelScrollSensitivity,O=r.deltaX*this._options.mouseWheelScrollSensitivity;this._options.scrollPredominantAxis&&(Math.abs(h)>=Math.abs(O)?O=0:h=0),this._options.flipAxes&&([h,O]=[O,h]);const V=!l.isMacintosh&&r.browserEvent&&r.browserEvent.shiftKey;(this._options.scrollYToX||V)&&!O&&(O=h,h=0),r.browserEvent&&r.browserEvent.altKey&&(O=O*this._options.fastScrollSensitivity,h=h*this._options.fastScrollSensitivity);const ue=this._scrollable.getFutureScrollPosition();let ie={};if(h){const ge=p*h,ae=ue.scrollTop-(ge<0?Math.floor(ge):Math.ceil(ge));this._verticalScrollbar.writeScrollPosition(ie,ae)}if(O){const ge=p*O,ae=ue.scrollLeft-(ge<0?Math.floor(ge):Math.ceil(ge));this._horizontalScrollbar.writeScrollPosition(ie,ae)}ie=this._scrollable.validateScrollPosition(ie),(ue.scrollLeft!==ie.scrollLeft||ue.scrollTop!==ie.scrollTop)&&(D&&this._options.mouseWheelSmoothScroll&&n.isPhysicalMouseWheel()?this._scrollable.setScrollPositionSmooth(ie):this._scrollable.setScrollPositionNow(ie),c=!0)}let u=c;!u&&this._options.alwaysConsumeMouseWheel&&(u=!0),!u&&this._options.consumeMouseWheelIfScrollbarIsNeeded&&(this._verticalScrollbar.isNeeded()||this._horizontalScrollbar.isNeeded())&&(u=!0),u&&(r.preventDefault(),r.stopPropagation())}_onDidScroll(r){this._shouldRender=this._horizontalScrollbar.onDidScroll(r)||this._shouldRender,this._shouldRender=this._verticalScrollbar.onDidScroll(r)||this._shouldRender,this._options.useShadows&&(this._shouldRender=!0),this._revealOnScroll&&this._reveal(),this._options.lazyRender||this._render()}renderNow(){if(!this._options.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this._render()}_render(){if(!!this._shouldRender&&(this._shouldRender=!1,this._horizontalScrollbar.render(),this._verticalScrollbar.render(),this._options.useShadows)){const r=this._scrollable.getCurrentScrollPosition(),n=r.scrollTop>0,c=r.scrollLeft>0,u=c?" left":"",h=n?" top":"",O=c||n?" top-left-corner":"";this._leftShadowDomNode.setClassName(`shadow${u}`),this._topShadowDomNode.setClassName(`shadow${h}`),this._topLeftShadowDomNode.setClassName(`shadow${O}${h}${u}`)}}_onDragStart(){this._isDragging=!0,this._reveal()}_onDragEnd(){this._isDragging=!1,this._hide()}_onMouseLeave(r){this._mouseIsOver=!1,this._hide()}_onMouseOver(r){this._mouseIsOver=!0,this._reveal()}_reveal(){this._verticalScrollbar.beginReveal(),this._horizontalScrollbar.beginReveal(),this._scheduleHide()}_hide(){!this._mouseIsOver&&!this._isDragging&&(this._verticalScrollbar.beginHide(),this._horizontalScrollbar.beginHide())}_scheduleHide(){!this._mouseIsOver&&!this._isDragging&&this._hideTimeout.cancelAndSet(()=>this._hide(),e)}}t.AbstractScrollableElement=a;class o extends a{constructor(r,n){n=n||{},n.mouseWheelSmoothScroll=!1;const c=new s.Scrollable({forceIntegerValues:!0,smoothScrollDuration:0,scheduleAtNextAnimationFrame:u=>i.scheduleAtNextAnimationFrame(u)});super(r,n,c);this._register(c)}setScrollPosition(r){this._scrollable.setScrollPositionNow(r)}getScrollPosition(){return this._scrollable.getCurrentScrollPosition()}}t.ScrollableElement=o;class b extends a{constructor(r,n,c){super(r,n,c)}setScrollPosition(r){r.reuseAnimation?this._scrollable.setScrollPositionSmooth(r,r.reuseAnimation):this._scrollable.setScrollPositionNow(r)}getScrollPosition(){return this._scrollable.getCurrentScrollPosition()}}t.SmoothScrollableElement=b;class S extends a{constructor(r,n){n=n||{},n.mouseWheelSmoothScroll=!1;const c=new s.Scrollable({forceIntegerValues:!1,smoothScrollDuration:0,scheduleAtNextAnimationFrame:u=>i.scheduleAtNextAnimationFrame(u)});super(r,n,c);this._register(c),this._element=r,this.onScroll(u=>{u.scrollTopChanged&&(this._element.scrollTop=u.scrollTop),u.scrollLeftChanged&&(this._element.scrollLeft=u.scrollLeft)}),this.scanDomNode()}setScrollPosition(r){this._scrollable.setScrollPositionNow(r)}getScrollPosition(){return this._scrollable.getCurrentScrollPosition()}scanDomNode(){this.setScrollDimensions({width:this._element.clientWidth,scrollWidth:this._element.scrollWidth,height:this._element.clientHeight,scrollHeight:this._element.scrollHeight}),this.setScrollPosition({scrollLeft:this._element.scrollLeft,scrollTop:this._element.scrollTop})}}t.DomScrollableElement=S;function A(C){const r={lazyRender:typeof C.lazyRender!="undefined"?C.lazyRender:!1,className:typeof C.className!="undefined"?C.className:"",useShadows:typeof C.useShadows!="undefined"?C.useShadows:!0,handleMouseWheel:typeof C.handleMouseWheel!="undefined"?C.handleMouseWheel:!0,flipAxes:typeof C.flipAxes!="undefined"?C.flipAxes:!1,consumeMouseWheelIfScrollbarIsNeeded:typeof C.consumeMouseWheelIfScrollbarIsNeeded!="undefined"?C.consumeMouseWheelIfScrollbarIsNeeded:!1,alwaysConsumeMouseWheel:typeof C.alwaysConsumeMouseWheel!="undefined"?C.alwaysConsumeMouseWheel:!1,scrollYToX:typeof C.scrollYToX!="undefined"?C.scrollYToX:!1,mouseWheelScrollSensitivity:typeof C.mouseWheelScrollSensitivity!="undefined"?C.mouseWheelScrollSensitivity:1,fastScrollSensitivity:typeof C.fastScrollSensitivity!="undefined"?C.fastScrollSensitivity:5,scrollPredominantAxis:typeof C.scrollPredominantAxis!="undefined"?C.scrollPredominantAxis:!0,mouseWheelSmoothScroll:typeof C.mouseWheelSmoothScroll!="undefined"?C.mouseWheelSmoothScroll:!0,arrowSize:typeof C.arrowSize!="undefined"?C.arrowSize:11,listenOnDomNode:typeof C.listenOnDomNode!="undefined"?C.listenOnDomNode:null,horizontal:typeof C.horizontal!="undefined"?C.horizontal:1,horizontalScrollbarSize:typeof C.horizontalScrollbarSize!="undefined"?C.horizontalScrollbarSize:10,horizontalSliderSize:typeof C.horizontalSliderSize!="undefined"?C.horizontalSliderSize:0,horizontalHasArrows:typeof C.horizontalHasArrows!="undefined"?C.horizontalHasArrows:!1,vertical:typeof C.vertical!="undefined"?C.vertical:1,verticalScrollbarSize:typeof C.verticalScrollbarSize!="undefined"?C.verticalScrollbarSize:10,verticalHasArrows:typeof C.verticalHasArrows!="undefined"?C.verticalHasArrows:!1,verticalSliderSize:typeof C.verticalSliderSize!="undefined"?C.verticalSliderSize:0,scrollByPage:typeof C.scrollByPage!="undefined"?C.scrollByPage:!1};return r.horizontalSliderSize=typeof C.horizontalSliderSize!="undefined"?C.horizontalSliderSize:r.horizontalScrollbarSize,r.verticalSliderSize=typeof C.verticalSliderSize!="undefined"?C.verticalSliderSize:r.verticalScrollbarSize,l.isMacintosh&&(r.className+=" mac"),r}}),define(me[57],pe([1,0,15,50,4,18,22,56,14,8,25,3,2,45,47,78,114]),function(J,t,y,i,B,M,E,w,m,f,g,F,l,s,e,p,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ListView=t.NativeDragAndDropData=t.ExternalElementsDragAndDropData=t.ElementsDragAndDropData=void 0;const v={CurrentDragAndDropData:void 0},_={useShadows:!0,verticalScrollMode:1,setRowLineHeight:!0,setRowHeight:!0,supportDynamicHeights:!1,dnd:{getDragElements(r){return[r]},getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){}},horizontalScrolling:!1,transformOptimization:!0,alwaysConsumeMouseWheel:!0};class a{constructor(n){this.elements=n}get context(){return this._context}set context(n){this._context=n}update(){}getData(){return this.elements}}t.ElementsDragAndDropData=a;class o{constructor(n){this.elements=n}update(){}getData(){return this.elements}}t.ExternalElementsDragAndDropData=o;class b{constructor(){this.types=[],this.files=[]}update(n){if(n.types&&this.types.splice(0,this.types.length,...n.types),n.files){this.files.splice(0,this.files.length);for(let c=0;c<n.files.length;c++){const u=n.files.item(c);u&&(u.size||u.type)&&this.files.push(u)}}}getData(){return{types:this.types,files:this.files}}}t.NativeDragAndDropData=b;function S(r,n){return Array.isArray(r)&&Array.isArray(n)?(0,m.equals)(r,n):r===n}class A{constructor(n){n?.getSetSize?this.getSetSize=n.getSetSize.bind(n):this.getSetSize=(c,u,h)=>h,n?.getPosInSet?this.getPosInSet=n.getPosInSet.bind(n):this.getPosInSet=(c,u)=>u+1,n?.getRole?this.getRole=n.getRole.bind(n):this.getRole=c=>"listitem",n?.isChecked?this.isChecked=n.isChecked.bind(n):this.isChecked=c=>{}}}class C{constructor(n,c,u,h=_){if(this.virtualDelegate=c,this.domId=`list_id_${++C.InstanceCount}`,this.renderers=new Map,this.renderWidth=0,this._scrollHeight=0,this.scrollableElementUpdateDisposable=null,this.scrollableElementWidthDelayer=new f.Delayer(50),this.splicing=!1,this.dragOverAnimationStopDisposable=l.Disposable.None,this.dragOverMouseY=0,this.canDrop=!1,this.currentDragFeedbackDisposable=l.Disposable.None,this.onDragLeaveTimeout=l.Disposable.None,this.disposables=new l.DisposableStore,this._onDidChangeContentHeight=new F.Emitter,this.onDidChangeContentHeight=F.Event.latch(this._onDidChangeContentHeight.event,void 0,this.disposables),this._horizontalScrolling=!1,h.horizontalScrolling&&h.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");this.items=[],this.itemId=0,this.rangeMap=new p.RangeMap;for(const V of u)this.renderers.set(V.templateId,V);this.cache=this.disposables.add(new D.RowCache(this.renderers)),this.lastRenderTop=0,this.lastRenderHeight=0,this.domNode=document.createElement("div"),this.domNode.className="monaco-list",this.domNode.classList.add(this.domId),this.domNode.tabIndex=0,this.domNode.classList.toggle("mouse-support",typeof h.mouseSupport=="boolean"?h.mouseSupport:!0),this._horizontalScrolling=h.horizontalScrolling??_.horizontalScrolling,this.domNode.classList.toggle("horizontal-scrolling",this._horizontalScrolling),this.additionalScrollHeight=typeof h.additionalScrollHeight=="undefined"?0:h.additionalScrollHeight,this.accessibilityProvider=new A(h.accessibilityProvider),this.rowsContainer=document.createElement("div"),this.rowsContainer.className="monaco-list-rows",(h.transformOptimization??_.transformOptimization)&&(this.rowsContainer.style.transform="translate3d(0px, 0px, 0px)"),this.disposables.add(E.Gesture.addTarget(this.rowsContainer)),this.scrollable=new e.Scrollable({forceIntegerValues:!0,smoothScrollDuration:h.smoothScrolling??!1?125:0,scheduleAtNextAnimationFrame:V=>(0,B.scheduleAtNextAnimationFrame)(V)}),this.scrollableElement=this.disposables.add(new w.SmoothScrollableElement(this.rowsContainer,{alwaysConsumeMouseWheel:h.alwaysConsumeMouseWheel??_.alwaysConsumeMouseWheel,horizontal:1,vertical:h.verticalScrollMode??_.verticalScrollMode,useShadows:h.useShadows??_.useShadows,mouseWheelScrollSensitivity:h.mouseWheelScrollSensitivity,fastScrollSensitivity:h.fastScrollSensitivity},this.scrollable)),this.domNode.appendChild(this.scrollableElement.getDomNode()),n.appendChild(this.domNode),this.scrollableElement.onScroll(this.onScroll,this,this.disposables),this.disposables.add((0,B.addDisposableListener)(this.rowsContainer,E.EventType.Change,V=>this.onTouchChange(V))),this.disposables.add((0,B.addDisposableListener)(this.scrollableElement.getDomNode(),"scroll",V=>V.target.scrollTop=0)),this.disposables.add((0,B.addDisposableListener)(this.domNode,"dragover",V=>this.onDragOver(this.toDragEvent(V)))),this.disposables.add((0,B.addDisposableListener)(this.domNode,"drop",V=>this.onDrop(this.toDragEvent(V)))),this.disposables.add((0,B.addDisposableListener)(this.domNode,"dragleave",V=>this.onDragLeave(this.toDragEvent(V)))),this.disposables.add((0,B.addDisposableListener)(this.domNode,"dragend",V=>this.onDragEnd(V))),this.setRowLineHeight=h.setRowLineHeight??_.setRowLineHeight,this.setRowHeight=h.setRowHeight??_.setRowHeight,this.supportDynamicHeights=h.supportDynamicHeights??_.supportDynamicHeights,this.dnd=h.dnd??_.dnd,this.layout()}get contentHeight(){return this.rangeMap.size}get onDidScroll(){return this.scrollableElement.onScroll}get onWillScroll(){return this.scrollableElement.onWillScroll}get containerDomNode(){return this.rowsContainer}get scrollableElementDomNode(){return this.scrollableElement.getDomNode()}get horizontalScrolling(){return this._horizontalScrolling}set horizontalScrolling(n){if(n!==this._horizontalScrolling){if(n&&this.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");if(this._horizontalScrolling=n,this.domNode.classList.toggle("horizontal-scrolling",this._horizontalScrolling),this._horizontalScrolling){for(const c of this.items)this.measureItemWidth(c);this.updateScrollWidth(),this.scrollableElement.setScrollDimensions({width:(0,B.getContentWidth)(this.domNode)}),this.rowsContainer.style.width=`${Math.max(this.scrollWidth||0,this.renderWidth)}px`}else this.scrollableElementWidthDelayer.cancel(),this.scrollableElement.setScrollDimensions({width:this.renderWidth,scrollWidth:this.renderWidth}),this.rowsContainer.style.width=""}}updateOptions(n){n.additionalScrollHeight!==void 0&&(this.additionalScrollHeight=n.additionalScrollHeight,this.scrollableElement.setScrollDimensions({scrollHeight:this.scrollHeight})),n.smoothScrolling!==void 0&&this.scrollable.setSmoothScrollDuration(n.smoothScrolling?125:0),n.horizontalScrolling!==void 0&&(this.horizontalScrolling=n.horizontalScrolling),n.mouseWheelScrollSensitivity!==void 0&&this.scrollableElement.updateOptions({mouseWheelScrollSensitivity:n.mouseWheelScrollSensitivity}),n.fastScrollSensitivity!==void 0&&this.scrollableElement.updateOptions({fastScrollSensitivity:n.fastScrollSensitivity})}triggerScrollFromMouseWheelEvent(n){this.scrollableElement.triggerScrollFromMouseWheelEvent(n)}updateElementHeight(n,c,u){if(n<0||n>=this.items.length)return;const h=this.items[n].size;if(typeof c=="undefined"){if(!this.supportDynamicHeights){console.warn("Dynamic heights not supported");return}this.items[n].lastDynamicHeightWidth=void 0,c=h+this.probeDynamicHeight(n)}if(h===c)return;const O=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight);let V=0;n<O.start||u!==null&&u>n&&u<=O.end?V=c-h:V=0,this.rangeMap.splice(n,1,[{size:c}]),this.items[n].size=c,this.render(O,Math.max(0,this.lastRenderTop+V),this.lastRenderHeight,void 0,void 0,!0),this.setScrollTop(this.lastRenderTop),this.eventuallyUpdateScrollDimensions(),this.supportDynamicHeights&&this._rerender(this.lastRenderTop,this.lastRenderHeight)}splice(n,c,u=[]){if(this.splicing)throw new Error("Can't run recursive splices.");this.splicing=!0;try{return this._splice(n,c,u)}finally{this.splicing=!1,this._onDidChangeContentHeight.fire(this.contentHeight)}}_splice(n,c,u=[]){const h=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight),O={start:n,end:n+c},V=s.Range.intersect(h,O),ue=new Map;for(let $=V.end-1;$>=V.start;$--){const j=this.items[$];if(j.dragStartDisposable.dispose(),j.checkedDisposable.dispose(),j.row){let H=ue.get(j.templateId);H||(H=[],ue.set(j.templateId,H));const d=this.renderers.get(j.templateId);d&&d.disposeElement&&d.disposeElement(j.element,$,j.row.templateData,j.size),H.push(j.row)}j.row=null}const ie={start:n+c,end:this.items.length},ge=s.Range.intersect(ie,h),ae=s.Range.relativeComplement(ie,h),we=u.map($=>({id:String(this.itemId++),element:$,templateId:this.virtualDelegate.getTemplateId($),size:this.virtualDelegate.getHeight($),width:void 0,hasDynamicHeight:!!this.virtualDelegate.hasDynamicHeight&&this.virtualDelegate.hasDynamicHeight($),lastDynamicHeightWidth:void 0,row:null,uri:void 0,dropTarget:!1,dragStartDisposable:l.Disposable.None,checkedDisposable:l.Disposable.None}));let ce;n===0&&c>=this.items.length?(this.rangeMap=new p.RangeMap,this.rangeMap.splice(0,0,we),ce=this.items,this.items=we):(this.rangeMap.splice(n,c,we),ce=this.items.splice(n,c,...we));const re=u.length-c,Ce=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight),Ie=(0,p.shift)(ge,re),ne=s.Range.intersect(Ce,Ie);for(let $=ne.start;$<ne.end;$++)this.updateItemInDOM(this.items[$],$);const Z=s.Range.relativeComplement(Ie,Ce);for(const $ of Z)for(let j=$.start;j<$.end;j++)this.removeItemFromDOM(j);const X=ae.map($=>(0,p.shift)($,re)),te=[{start:n,end:n+u.length},...X].map($=>s.Range.intersect(Ce,$)),I=this.getNextToLastElement(te);for(const $ of te)for(let j=$.start;j<$.end;j++){const H=this.items[j],L=ue.get(H.templateId)?.pop();this.insertItemInDOM(j,I,L)}for(const $ of ue.values())for(const j of $)this.cache.release(j);return this.eventuallyUpdateScrollDimensions(),this.supportDynamicHeights&&this._rerender(this.scrollTop,this.renderHeight),ce.map($=>$.element)}eventuallyUpdateScrollDimensions(){this._scrollHeight=this.contentHeight,this.rowsContainer.style.height=`${this._scrollHeight}px`,this.scrollableElementUpdateDisposable||(this.scrollableElementUpdateDisposable=(0,B.scheduleAtNextAnimationFrame)(()=>{this.scrollableElement.setScrollDimensions({scrollHeight:this.scrollHeight}),this.updateScrollWidth(),this.scrollableElementUpdateDisposable=null}))}eventuallyUpdateScrollWidth(){if(!this.horizontalScrolling){this.scrollableElementWidthDelayer.cancel();return}this.scrollableElementWidthDelayer.trigger(()=>this.updateScrollWidth())}updateScrollWidth(){if(!this.horizontalScrolling)return;let n=0;for(const c of this.items)typeof c.width!="undefined"&&(n=Math.max(n,c.width));this.scrollWidth=n,this.scrollableElement.setScrollDimensions({scrollWidth:n===0?0:n+10})}updateWidth(n){if(!this.horizontalScrolling||typeof this.scrollWidth=="undefined")return;const c=this.items[n];this.measureItemWidth(c),typeof c.width!="undefined"&&c.width>this.scrollWidth&&(this.scrollWidth=c.width,this.scrollableElement.setScrollDimensions({scrollWidth:this.scrollWidth+10}))}rerender(){if(!!this.supportDynamicHeights){for(const n of this.items)n.lastDynamicHeightWidth=void 0;this._rerender(this.lastRenderTop,this.lastRenderHeight)}}get length(){return this.items.length}get renderHeight(){return this.scrollableElement.getScrollDimensions().height}get firstVisibleIndex(){const n=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight),c=this.rangeMap.positionAt(n.start),u=this.rangeMap.positionAt(n.start+1);return u!==-1&&(u-c)/2+c<this.scrollTop?n.start+1:n.start}get lastVisibleIndex(){return this.getRenderRange(this.lastRenderTop,this.lastRenderHeight).end-1}element(n){return this.items[n].element}indexOf(n){return this.items.findIndex(c=>c.element===n)}domElement(n){const c=this.items[n].row;return c&&c.domNode}elementHeight(n){return this.items[n].size}elementTop(n){return this.rangeMap.positionAt(n)}indexAt(n){return this.rangeMap.indexAt(n)}indexAfter(n){return this.rangeMap.indexAfter(n)}layout(n,c){const u={height:typeof n=="number"?n:(0,B.getContentHeight)(this.domNode)};this.scrollableElementUpdateDisposable&&(this.scrollableElementUpdateDisposable.dispose(),this.scrollableElementUpdateDisposable=null,u.scrollHeight=this.scrollHeight),this.scrollableElement.setScrollDimensions(u),typeof c!="undefined"&&(this.renderWidth=c,this.supportDynamicHeights&&this._rerender(this.scrollTop,this.renderHeight)),this.horizontalScrolling&&this.scrollableElement.setScrollDimensions({width:typeof c=="number"?c:(0,B.getContentWidth)(this.domNode)})}render(n,c,u,h,O,V=!1){const ue=this.getRenderRange(c,u),ie=s.Range.relativeComplement(ue,n),ge=s.Range.relativeComplement(n,ue),ae=this.getNextToLastElement(ie);if(V){const we=s.Range.intersect(n,ue);for(let ce=we.start;ce<we.end;ce++)this.updateItemInDOM(this.items[ce],ce)}for(const we of ie)for(let ce=we.start;ce<we.end;ce++)this.insertItemInDOM(ce,ae);for(const we of ge)for(let ce=we.start;ce<we.end;ce++)this.removeItemFromDOM(ce);h!==void 0&&(this.rowsContainer.style.left=`-${h}px`),this.rowsContainer.style.top=`-${c}px`,this.horizontalScrolling&&O!==void 0&&(this.rowsContainer.style.width=`${Math.max(O,this.renderWidth)}px`),this.lastRenderTop=c,this.lastRenderHeight=u}insertItemInDOM(n,c,u){const h=this.items[n];h.row||(h.row=u??this.cache.alloc(h.templateId));const O=this.accessibilityProvider.getRole(h.element)||"listitem";h.row.domNode.setAttribute("role",O);const V=this.accessibilityProvider.isChecked(h.element);if(typeof V=="boolean")h.row.domNode.setAttribute("aria-checked",String(!!V));else if(V){const ge=ae=>h.row.domNode.setAttribute("aria-checked",String(!!ae));ge(V.value),h.checkedDisposable=V.onDidChange(ge)}h.row.domNode.parentElement||(c?this.rowsContainer.insertBefore(h.row.domNode,c):this.rowsContainer.appendChild(h.row.domNode)),this.updateItemInDOM(h,n);const ue=this.renderers.get(h.templateId);if(!ue)throw new Error(`No renderer found for template id ${h.templateId}`);ue?.renderElement(h.element,n,h.row.templateData,h.size);const ie=this.dnd.getDragURI(h.element);h.dragStartDisposable.dispose(),h.row.domNode.draggable=!!ie,ie&&(h.dragStartDisposable=(0,B.addDisposableListener)(h.row.domNode,"dragstart",ge=>this.onDragStart(h.element,ie,ge))),this.horizontalScrolling&&(this.measureItemWidth(h),this.eventuallyUpdateScrollWidth())}measureItemWidth(n){if(!n.row||!n.row.domNode)return;n.row.domNode.style.width=y.isFirefox?"-moz-fit-content":"fit-content",n.width=(0,B.getContentWidth)(n.row.domNode);const c=window.getComputedStyle(n.row.domNode);c.paddingLeft&&(n.width+=parseFloat(c.paddingLeft)),c.paddingRight&&(n.width+=parseFloat(c.paddingRight)),n.row.domNode.style.width=""}updateItemInDOM(n,c){n.row.domNode.style.top=`${this.elementTop(c)}px`,this.setRowHeight&&(n.row.domNode.style.height=`${n.size}px`),this.setRowLineHeight&&(n.row.domNode.style.lineHeight=`${n.size}px`),n.row.domNode.setAttribute("data-index",`${c}`),n.row.domNode.setAttribute("data-last-element",c===this.length-1?"true":"false"),n.row.domNode.setAttribute("data-parity",c%2==0?"even":"odd"),n.row.domNode.setAttribute("aria-setsize",String(this.accessibilityProvider.getSetSize(n.element,c,this.length))),n.row.domNode.setAttribute("aria-posinset",String(this.accessibilityProvider.getPosInSet(n.element,c))),n.row.domNode.setAttribute("id",this.getElementDomId(c)),n.row.domNode.classList.toggle("drop-target",n.dropTarget)}removeItemFromDOM(n){const c=this.items[n];if(c.dragStartDisposable.dispose(),c.checkedDisposable.dispose(),c.row){const u=this.renderers.get(c.templateId);u&&u.disposeElement&&u.disposeElement(c.element,n,c.row.templateData,c.size),this.cache.release(c.row),c.row=null}this.horizontalScrolling&&this.eventuallyUpdateScrollWidth()}getScrollTop(){return this.scrollableElement.getScrollPosition().scrollTop}setScrollTop(n,c){this.scrollableElementUpdateDisposable&&(this.scrollableElementUpdateDisposable.dispose(),this.scrollableElementUpdateDisposable=null,this.scrollableElement.setScrollDimensions({scrollHeight:this.scrollHeight})),this.scrollableElement.setScrollPosition({scrollTop:n,reuseAnimation:c})}getScrollLeft(){return this.scrollableElement.getScrollPosition().scrollLeft}setScrollLeft(n){this.scrollableElementUpdateDisposable&&(this.scrollableElementUpdateDisposable.dispose(),this.scrollableElementUpdateDisposable=null,this.scrollableElement.setScrollDimensions({scrollWidth:this.scrollWidth})),this.scrollableElement.setScrollPosition({scrollLeft:n})}get scrollTop(){return this.getScrollTop()}set scrollTop(n){this.setScrollTop(n)}get scrollHeight(){return this._scrollHeight+(this.horizontalScrolling?10:0)+this.additionalScrollHeight}get onMouseClick(){return F.Event.map(this.disposables.add(new M.DomEmitter(this.domNode,"click")).event,n=>this.toMouseEvent(n),this.disposables)}get onMouseDblClick(){return F.Event.map(this.disposables.add(new M.DomEmitter(this.domNode,"dblclick")).event,n=>this.toMouseEvent(n),this.disposables)}get onMouseMiddleClick(){return F.Event.filter(F.Event.map(this.disposables.add(new M.DomEmitter(this.domNode,"auxclick")).event,n=>this.toMouseEvent(n),this.disposables),n=>n.browserEvent.button===1,this.disposables)}get onMouseUp(){return F.Event.map(this.disposables.add(new M.DomEmitter(this.domNode,"mouseup")).event,n=>this.toMouseEvent(n),this.disposables)}get onMouseDown(){return F.Event.map(this.disposables.add(new M.DomEmitter(this.domNode,"mousedown")).event,n=>this.toMouseEvent(n),this.disposables)}get onMouseOver(){return F.Event.map(this.disposables.add(new M.DomEmitter(this.domNode,"mouseover")).event,n=>this.toMouseEvent(n),this.disposables)}get onMouseMove(){return F.Event.map(this.disposables.add(new M.DomEmitter(this.domNode,"mousemove")).event,n=>this.toMouseEvent(n),this.disposables)}get onMouseOut(){return F.Event.map(this.disposables.add(new M.DomEmitter(this.domNode,"mouseout")).event,n=>this.toMouseEvent(n),this.disposables)}get onContextMenu(){return F.Event.any(F.Event.map(this.disposables.add(new M.DomEmitter(this.domNode,"contextmenu")).event,n=>this.toMouseEvent(n),this.disposables),F.Event.map(this.disposables.add(new M.DomEmitter(this.domNode,E.EventType.Contextmenu)).event,n=>this.toGestureEvent(n),this.disposables))}get onTouchStart(){return F.Event.map(this.disposables.add(new M.DomEmitter(this.domNode,"touchstart")).event,n=>this.toTouchEvent(n),this.disposables)}get onTap(){return F.Event.map(this.disposables.add(new M.DomEmitter(this.rowsContainer,E.EventType.Tap)).event,n=>this.toGestureEvent(n),this.disposables)}toMouseEvent(n){const c=this.getItemIndexFromEventTarget(n.target||null),u=typeof c=="undefined"?void 0:this.items[c],h=u&&u.element;return{browserEvent:n,index:c,element:h}}toTouchEvent(n){const c=this.getItemIndexFromEventTarget(n.target||null),u=typeof c=="undefined"?void 0:this.items[c],h=u&&u.element;return{browserEvent:n,index:c,element:h}}toGestureEvent(n){const c=this.getItemIndexFromEventTarget(n.initialTarget||null),u=typeof c=="undefined"?void 0:this.items[c],h=u&&u.element;return{browserEvent:n,index:c,element:h}}toDragEvent(n){const c=this.getItemIndexFromEventTarget(n.target||null),u=typeof c=="undefined"?void 0:this.items[c],h=u&&u.element;return{browserEvent:n,index:c,element:h}}onScroll(n){try{const c=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight);this.render(c,n.scrollTop,n.height,n.scrollLeft,n.scrollWidth),this.supportDynamicHeights&&this._rerender(n.scrollTop,n.height,n.inSmoothScrolling)}catch(c){throw console.error("Got bad scroll event:",n),c}}onTouchChange(n){n.preventDefault(),n.stopPropagation(),this.scrollTop-=n.translationY}onDragStart(n,c,u){if(!u.dataTransfer)return;const h=this.dnd.getDragElements(n);if(u.dataTransfer.effectAllowed="copyMove",u.dataTransfer.setData(i.DataTransfers.TEXT,c),u.dataTransfer.setDragImage){let O;this.dnd.getDragLabel&&(O=this.dnd.getDragLabel(h,u)),typeof O=="undefined"&&(O=String(h.length));const V=(0,B.$)(".monaco-drag-image");V.textContent=O,document.body.appendChild(V),u.dataTransfer.setDragImage(V,-10,-10),setTimeout(()=>document.body.removeChild(V),0)}this.currentDragData=new a(h),v.CurrentDragAndDropData=new o(h),this.dnd.onDragStart?.(this.currentDragData,u)}onDragOver(n){if(n.browserEvent.preventDefault(),this.onDragLeaveTimeout.dispose(),v.CurrentDragAndDropData&&v.CurrentDragAndDropData.getData()==="vscode-ui"||(this.setupDragAndDropScrollTopAnimation(n.browserEvent),!n.browserEvent.dataTransfer))return!1;if(!this.currentDragData)if(v.CurrentDragAndDropData)this.currentDragData=v.CurrentDragAndDropData;else{if(!n.browserEvent.dataTransfer.types)return!1;this.currentDragData=new b}const c=this.dnd.onDragOver(this.currentDragData,n.element,n.index,n.browserEvent);if(this.canDrop=typeof c=="boolean"?c:c.accept,!this.canDrop)return this.currentDragFeedback=void 0,this.currentDragFeedbackDisposable.dispose(),!1;n.browserEvent.dataTransfer.dropEffect=typeof c!="boolean"&&c.effect===0?"copy":"move";let u;if(typeof c!="boolean"&&c.feedback?u=c.feedback:typeof n.index=="undefined"?u=[-1]:u=[n.index],u=(0,m.distinct)(u).filter(h=>h>=-1&&h<this.length).sort((h,O)=>h-O),u=u[0]===-1?[-1]:u,S(this.currentDragFeedback,u))return!0;if(this.currentDragFeedback=u,this.currentDragFeedbackDisposable.dispose(),u[0]===-1)this.domNode.classList.add("drop-target"),this.rowsContainer.classList.add("drop-target"),this.currentDragFeedbackDisposable=(0,l.toDisposable)(()=>{this.domNode.classList.remove("drop-target"),this.rowsContainer.classList.remove("drop-target")});else{for(const h of u){const O=this.items[h];O.dropTarget=!0,O.row?.domNode.classList.add("drop-target")}this.currentDragFeedbackDisposable=(0,l.toDisposable)(()=>{for(const h of u){const O=this.items[h];O.dropTarget=!1,O.row?.domNode.classList.remove("drop-target")}})}return!0}onDragLeave(n){this.onDragLeaveTimeout.dispose(),this.onDragLeaveTimeout=(0,f.disposableTimeout)(()=>this.clearDragOverFeedback(),100),this.currentDragData&&this.dnd.onDragLeave?.(this.currentDragData,n.element,n.index,n.browserEvent)}onDrop(n){if(!this.canDrop)return;const c=this.currentDragData;this.teardownDragAndDropScrollTopAnimation(),this.clearDragOverFeedback(),this.currentDragData=void 0,v.CurrentDragAndDropData=void 0,!(!c||!n.browserEvent.dataTransfer)&&(n.browserEvent.preventDefault(),c.update(n.browserEvent.dataTransfer),this.dnd.drop(c,n.element,n.index,n.browserEvent))}onDragEnd(n){this.canDrop=!1,this.teardownDragAndDropScrollTopAnimation(),this.clearDragOverFeedback(),this.currentDragData=void 0,v.CurrentDragAndDropData=void 0,this.dnd.onDragEnd?.(n)}clearDragOverFeedback(){this.currentDragFeedback=void 0,this.currentDragFeedbackDisposable.dispose(),this.currentDragFeedbackDisposable=l.Disposable.None}setupDragAndDropScrollTopAnimation(n){if(!this.dragOverAnimationDisposable){const c=(0,B.getTopLeftOffset)(this.domNode).top;this.dragOverAnimationDisposable=(0,B.animate)(this.animateDragAndDropScrollTop.bind(this,c))}this.dragOverAnimationStopDisposable.dispose(),this.dragOverAnimationStopDisposable=(0,f.disposableTimeout)(()=>{this.dragOverAnimationDisposable&&(this.dragOverAnimationDisposable.dispose(),this.dragOverAnimationDisposable=void 0)},1e3),this.dragOverMouseY=n.pageY}animateDragAndDropScrollTop(n){if(this.dragOverMouseY===void 0)return;const c=this.dragOverMouseY-n,u=this.renderHeight-35;c<35?this.scrollTop+=Math.max(-14,Math.floor(.3*(c-35))):c>u&&(this.scrollTop+=Math.min(14,Math.floor(.3*(c-u))))}teardownDragAndDropScrollTopAnimation(){this.dragOverAnimationStopDisposable.dispose(),this.dragOverAnimationDisposable&&(this.dragOverAnimationDisposable.dispose(),this.dragOverAnimationDisposable=void 0)}getItemIndexFromEventTarget(n){const c=this.scrollableElement.getDomNode();let u=n;for(;u instanceof HTMLElement&&u!==this.rowsContainer&&c.contains(u);){const h=u.getAttribute("data-index");if(h){const O=Number(h);if(!isNaN(O))return O}u=u.parentElement}}getRenderRange(n,c){return{start:this.rangeMap.indexAt(n),end:this.rangeMap.indexAfter(n+c-1)}}_rerender(n,c,u){const h=this.getRenderRange(n,c);let O,V;n===this.elementTop(h.start)?(O=h.start,V=0):h.end-h.start>1&&(O=h.start+1,V=this.elementTop(O)-n);let ue=0;for(;;){const ie=this.getRenderRange(n,c);let ge=!1;for(let ae=ie.start;ae<ie.end;ae++){const we=this.probeDynamicHeight(ae);we!==0&&this.rangeMap.splice(ae,1,[this.items[ae]]),ue+=we,ge=ge||we!==0}if(!ge){ue!==0&&this.eventuallyUpdateScrollDimensions();const ae=s.Range.relativeComplement(h,ie);for(const ce of ae)for(let re=ce.start;re<ce.end;re++)this.items[re].row&&this.removeItemFromDOM(re);const we=s.Range.relativeComplement(ie,h);for(const ce of we)for(let re=ce.start;re<ce.end;re++){const Ce=re+1,Ie=Ce<this.items.length?this.items[Ce].row:null,ne=Ie?Ie.domNode:null;this.insertItemInDOM(re,ne)}for(let ce=ie.start;ce<ie.end;ce++)this.items[ce].row&&this.updateItemInDOM(this.items[ce],ce);if(typeof O=="number"){const ce=this.scrollable.getFutureScrollPosition().scrollTop-n,re=this.elementTop(O)-V+ce;this.setScrollTop(re,u)}this._onDidChangeContentHeight.fire(this.contentHeight);return}}}probeDynamicHeight(n){const c=this.items[n];if(this.virtualDelegate.getDynamicHeight){const V=this.virtualDelegate.getDynamicHeight(c.element);if(V!==null){const ue=c.size;return c.size=V,c.lastDynamicHeightWidth=this.renderWidth,V-ue}}if(!c.hasDynamicHeight||c.lastDynamicHeightWidth===this.renderWidth||!!this.virtualDelegate.hasDynamicHeight&&!this.virtualDelegate.hasDynamicHeight(c.element))return 0;const u=c.size;if(!this.setRowHeight&&c.row){const V=c.row.domNode.offsetHeight;return c.size=V,c.lastDynamicHeightWidth=this.renderWidth,V-u}const h=this.cache.alloc(c.templateId);h.domNode.style.height="",this.rowsContainer.appendChild(h.domNode);const O=this.renderers.get(c.templateId);return O&&(O.renderElement(c.element,n,h.templateData,void 0),O.disposeElement?.(c.element,n,h.templateData,void 0)),c.size=h.domNode.offsetHeight,this.virtualDelegate.setDynamicHeight?.(c.element,c.size),c.lastDynamicHeightWidth=this.renderWidth,this.rowsContainer.removeChild(h.domNode),this.cache.release(h),c.size-u}getNextToLastElement(n){const c=n[n.length-1];if(!c)return null;const u=this.items[c.end];return!u||!u.row?null:u.row.domNode}getElementDomId(n){return`${this.domId}_${n}`}dispose(){if(this.items){for(const n of this.items)if(n.row){const c=this.renderers.get(n.row.templateId);c&&(c.disposeElement?.(n.element,-1,n.row.templateData,void 0),c.disposeTemplate(n.row.templateData))}this.items=[]}this.domNode&&this.domNode.parentNode&&this.domNode.parentNode.removeChild(this.domNode),(0,l.dispose)(this.disposables)}}C.InstanceCount=0,Ke([g.memoize],C.prototype,"onMouseClick",null),Ke([g.memoize],C.prototype,"onMouseDblClick",null),Ke([g.memoize],C.prototype,"onMouseMiddleClick",null),Ke([g.memoize],C.prototype,"onMouseUp",null),Ke([g.memoize],C.prototype,"onMouseDown",null),Ke([g.memoize],C.prototype,"onMouseOver",null),Ke([g.memoize],C.prototype,"onMouseMove",null),Ke([g.memoize],C.prototype,"onMouseOut",null),Ke([g.memoize],C.prototype,"onContextMenu",null),Ke([g.memoize],C.prototype,"onTouchStart",null),Ke([g.memoize],C.prototype,"onTap",null),t.ListView=C}),define(me[58],pe([1,0,4,18,19,22,53,67,14,8,24,25,3,33,2,44,27,5,6,66,57,88]),function(J,t,y,i,B,M,E,w,m,f,g,F,l,s,e,p,D,v,_,a,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.List=t.DefaultStyleController=t.MouseController=t.isSelectionRangeChangeEvent=t.isSelectionSingleChangeEvent=t.DefaultKeyboardNavigationDelegate=t.TypeNavigationMode=t.isButton=t.isMonacoEditor=t.isInputElement=void 0;class b{constructor(d){this.trait=d,this.renderedElements=[]}get templateId(){return`template:${this.trait.name}`}renderTemplate(d){return d}renderElement(d,L,U){const K=this.renderedElements.findIndex(Q=>Q.templateData===U);if(K>=0){const Q=this.renderedElements[K];this.trait.unrender(U),Q.index=L}else{const Q={index:L,templateData:U};this.renderedElements.push(Q)}this.trait.renderIndex(L,U)}splice(d,L,U){const K=[];for(const Q of this.renderedElements)Q.index<d?K.push(Q):Q.index>=d+L&&K.push({index:Q.index+U-L,templateData:Q.templateData});this.renderedElements=K}renderIndexes(d){for(const{index:L,templateData:U}of this.renderedElements)d.indexOf(L)>-1&&this.trait.renderIndex(L,U)}disposeTemplate(d){const L=this.renderedElements.findIndex(U=>U.templateData===d);L<0||this.renderedElements.splice(L,1)}}class S{constructor(d){this._trait=d,this.length=0,this.indexes=[],this.sortedIndexes=[],this._onChange=new l.Emitter,this.onChange=this._onChange.event}get name(){return this._trait}get renderer(){return new b(this)}splice(d,L,U){L=Math.max(0,Math.min(L,this.length-d));const K=U.length-L,Q=d+L,N=[...this.sortedIndexes.filter(z=>z<d),...U.map((z,T)=>z?T+d:-1).filter(z=>z!==-1),...this.sortedIndexes.filter(z=>z>=Q).map(z=>z+K)],R=this.length+K;if(this.sortedIndexes.length>0&&N.length===0&&R>0){const z=this.sortedIndexes.find(T=>T>=d)??R-1;N.push(Math.min(z,R-1))}this.renderer.splice(d,L,U.length),this._set(N,N),this.length=R}renderIndex(d,L){L.classList.toggle(this._trait,this.contains(d))}unrender(d){d.classList.remove(this._trait)}set(d,L){return this._set(d,[...d].sort(se),L)}_set(d,L,U){const K=this.indexes,Q=this.sortedIndexes;this.indexes=d,this.sortedIndexes=L;const N=Z(Q,d);return this.renderer.renderIndexes(N),this._onChange.fire({indexes:d,browserEvent:U}),K}get(){return this.indexes}contains(d){return(0,m.binarySearch)(this.sortedIndexes,d,se)>=0}dispose(){(0,e.dispose)(this._onChange)}}Ke([F.memoize],S.prototype,"renderer",null);class A extends S{constructor(d){super("selected");this.setAriaSelected=d}renderIndex(d,L){super.renderIndex(d,L),this.setAriaSelected&&(this.contains(d)?L.setAttribute("aria-selected","true"):L.setAttribute("aria-selected","false"))}}class C{constructor(d,L,U){this.trait=d,this.view=L,this.identityProvider=U}splice(d,L,U){if(!this.identityProvider)return this.trait.splice(d,L,U.map(()=>!1));const K=this.trait.get().map(N=>this.identityProvider.getId(this.view.element(N)).toString()),Q=U.map(N=>K.indexOf(this.identityProvider.getId(N).toString())>-1);this.trait.splice(d,L,Q)}}function r(H){return H.tagName==="INPUT"||H.tagName==="TEXTAREA"}t.isInputElement=r;function n(H){return H.classList.contains("monaco-editor")?!0:H.classList.contains("monaco-list")||!H.parentElement?!1:n(H.parentElement)}t.isMonacoEditor=n;function c(H){return H.tagName==="A"&&H.classList.contains("monaco-button")||H.tagName==="DIV"&&H.classList.contains("monaco-button-dropdown")?!0:H.classList.contains("monaco-list")||!H.parentElement?!1:c(H.parentElement)}t.isButton=c;class u{constructor(d,L,U){this.list=d,this.view=L,this.disposables=new e.DisposableStore,this.multipleSelectionDisposables=new e.DisposableStore,this.onKeyDown.filter(K=>K.keyCode===3).on(this.onEnter,this,this.disposables),this.onKeyDown.filter(K=>K.keyCode===16).on(this.onUpArrow,this,this.disposables),this.onKeyDown.filter(K=>K.keyCode===18).on(this.onDownArrow,this,this.disposables),this.onKeyDown.filter(K=>K.keyCode===11).on(this.onPageUpArrow,this,this.disposables),this.onKeyDown.filter(K=>K.keyCode===12).on(this.onPageDownArrow,this,this.disposables),this.onKeyDown.filter(K=>K.keyCode===9).on(this.onEscape,this,this.disposables),U.multipleSelectionSupport!==!1&&this.onKeyDown.filter(K=>(v.isMacintosh?K.metaKey:K.ctrlKey)&&K.keyCode===31).on(this.onCtrlA,this,this.multipleSelectionDisposables)}get onKeyDown(){return this.disposables.add(l.Event.chain(this.disposables.add(new i.DomEmitter(this.view.domNode,"keydown")).event).filter(d=>!r(d.target)).map(d=>new B.StandardKeyboardEvent(d)))}updateOptions(d){d.multipleSelectionSupport!==void 0&&(this.multipleSelectionDisposables.clear(),d.multipleSelectionSupport&&this.onKeyDown.filter(L=>(v.isMacintosh?L.metaKey:L.ctrlKey)&&L.keyCode===31).on(this.onCtrlA,this,this.multipleSelectionDisposables))}onEnter(d){d.preventDefault(),d.stopPropagation(),this.list.setSelection(this.list.getFocus(),d.browserEvent)}onUpArrow(d){d.preventDefault(),d.stopPropagation(),this.list.focusPrevious(1,!1,d.browserEvent);const L=this.list.getFocus()[0];this.list.setAnchor(L),this.list.reveal(L),this.view.domNode.focus()}onDownArrow(d){d.preventDefault(),d.stopPropagation(),this.list.focusNext(1,!1,d.browserEvent);const L=this.list.getFocus()[0];this.list.setAnchor(L),this.list.reveal(L),this.view.domNode.focus()}onPageUpArrow(d){d.preventDefault(),d.stopPropagation(),this.list.focusPreviousPage(d.browserEvent);const L=this.list.getFocus()[0];this.list.setAnchor(L),this.list.reveal(L),this.view.domNode.focus()}onPageDownArrow(d){d.preventDefault(),d.stopPropagation(),this.list.focusNextPage(d.browserEvent);const L=this.list.getFocus()[0];this.list.setAnchor(L),this.list.reveal(L),this.view.domNode.focus()}onCtrlA(d){d.preventDefault(),d.stopPropagation(),this.list.setSelection((0,m.range)(this.list.length),d.browserEvent),this.list.setAnchor(void 0),this.view.domNode.focus()}onEscape(d){this.list.getSelection().length&&(d.preventDefault(),d.stopPropagation(),this.list.setSelection([],d.browserEvent),this.list.setAnchor(void 0),this.view.domNode.focus())}dispose(){this.disposables.dispose(),this.multipleSelectionDisposables.dispose()}}Ke([F.memoize],u.prototype,"onKeyDown",null);var h;(function(H){H[H.Automatic=0]="Automatic",H[H.Trigger=1]="Trigger"})(h=t.TypeNavigationMode||(t.TypeNavigationMode={}));var O;(function(H){H[H.Idle=0]="Idle",H[H.Typing=1]="Typing"})(O||(O={})),t.DefaultKeyboardNavigationDelegate=new class{mightProducePrintableCharacter(H){return H.ctrlKey||H.metaKey||H.altKey?!1:H.keyCode>=31&&H.keyCode<=56||H.keyCode>=21&&H.keyCode<=30||H.keyCode>=93&&H.keyCode<=102||H.keyCode>=80&&H.keyCode<=90}};class V{constructor(d,L,U,K,Q){this.list=d,this.view=L,this.keyboardNavigationLabelProvider=U,this.keyboardNavigationEventFilter=K,this.delegate=Q,this.enabled=!1,this.state=O.Idle,this.mode=h.Automatic,this.triggered=!1,this.previouslyFocused=-1,this.enabledDisposables=new e.DisposableStore,this.disposables=new e.DisposableStore,this.updateOptions(d.options)}updateOptions(d){d.typeNavigationEnabled??!0?this.enable():this.disable(),this.mode=d.typeNavigationMode??h.Automatic}trigger(){this.triggered=!this.triggered}enable(){if(this.enabled)return;let d=!1;const L=this.enabledDisposables.add(l.Event.chain(this.enabledDisposables.add(new i.DomEmitter(this.view.domNode,"keydown")).event)).filter(Q=>!r(Q.target)).filter(()=>this.mode===h.Automatic||this.triggered).map(Q=>new B.StandardKeyboardEvent(Q)).filter(Q=>d||this.keyboardNavigationEventFilter(Q)).filter(Q=>this.delegate.mightProducePrintableCharacter(Q)).forEach(Q=>y.EventHelper.stop(Q,!0)).map(Q=>Q.browserEvent.key).event,U=l.Event.debounce(L,()=>null,800,void 0,void 0,this.enabledDisposables);l.Event.reduce(l.Event.any(L,U),(Q,N)=>N===null?null:(Q||"")+N,void 0,this.enabledDisposables)(this.onInput,this,this.enabledDisposables),U(this.onClear,this,this.enabledDisposables),L(()=>d=!0,void 0,this.enabledDisposables),U(()=>d=!1,void 0,this.enabledDisposables),this.enabled=!0,this.triggered=!1}disable(){!this.enabled||(this.enabledDisposables.clear(),this.enabled=!1,this.triggered=!1)}onClear(){const d=this.list.getFocus();if(d.length>0&&d[0]===this.previouslyFocused){const L=this.list.options.accessibilityProvider?.getAriaLabel(this.list.element(d[0]));L&&(0,E.alert)(L)}this.previouslyFocused=-1}onInput(d){if(!d){this.state=O.Idle,this.triggered=!1;return}const L=this.list.getFocus(),U=L.length>0?L[0]:0,K=this.state===O.Idle?1:0;this.state=O.Typing;for(let Q=0;Q<this.list.length;Q++){const N=(U+Q+K)%this.list.length,R=this.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(this.view.element(N)),z=R&&R.toString();if(typeof z=="undefined"||(0,s.matchesPrefix)(d,z)){this.previouslyFocused=U,this.list.setFocus([N]),this.list.reveal(N);return}}}dispose(){this.disable(),this.enabledDisposables.dispose(),this.disposables.dispose()}}class ue{constructor(d,L){this.list=d,this.view=L,this.disposables=new e.DisposableStore,this.disposables.add(l.Event.chain(this.disposables.add(new i.DomEmitter(L.domNode,"keydown")).event)).filter(K=>!r(K.target)).map(K=>new B.StandardKeyboardEvent(K)).filter(K=>K.keyCode===2&&!K.ctrlKey&&!K.metaKey&&!K.shiftKey&&!K.altKey).on(this.onTab,this,this.disposables)}onTab(d){if(d.target!==this.view.domNode)return;const L=this.list.getFocus();if(L.length===0)return;const U=this.view.domElement(L[0]);if(!U)return;const K=U.querySelector("[tabIndex]");if(!K||!(K instanceof HTMLElement)||K.tabIndex===-1)return;const Q=window.getComputedStyle(K);Q.visibility==="hidden"||Q.display==="none"||(d.preventDefault(),d.stopPropagation(),K.focus())}dispose(){this.disposables.dispose()}}function ie(H){return v.isMacintosh?H.browserEvent.metaKey:H.browserEvent.ctrlKey}t.isSelectionSingleChangeEvent=ie;function ge(H){return H.browserEvent.shiftKey}t.isSelectionRangeChangeEvent=ge;function ae(H){return H instanceof MouseEvent&&H.button===2}const we={isSelectionSingleChangeEvent:ie,isSelectionRangeChangeEvent:ge};class ce{constructor(d){this.list=d,this.disposables=new e.DisposableStore,this._onPointer=new l.Emitter,this.onPointer=this._onPointer.event,d.options.multipleSelectionSupport!==!1&&(this.multipleSelectionController=this.list.options.multipleSelectionController||we),this.mouseSupport=typeof d.options.mouseSupport=="undefined"||!!d.options.mouseSupport,this.mouseSupport&&(d.onMouseDown(this.onMouseDown,this,this.disposables),d.onContextMenu(this.onContextMenu,this,this.disposables),d.onMouseDblClick(this.onDoubleClick,this,this.disposables),d.onTouchStart(this.onMouseDown,this,this.disposables),this.disposables.add(M.Gesture.addTarget(d.getHTMLElement()))),l.Event.any(d.onMouseClick,d.onMouseMiddleClick,d.onTap)(this.onViewPointer,this,this.disposables)}updateOptions(d){d.multipleSelectionSupport!==void 0&&(this.multipleSelectionController=void 0,d.multipleSelectionSupport&&(this.multipleSelectionController=this.list.options.multipleSelectionController||we))}isSelectionSingleChangeEvent(d){return this.multipleSelectionController?this.multipleSelectionController.isSelectionSingleChangeEvent(d):!1}isSelectionRangeChangeEvent(d){return this.multipleSelectionController?this.multipleSelectionController.isSelectionRangeChangeEvent(d):!1}isSelectionChangeEvent(d){return this.isSelectionSingleChangeEvent(d)||this.isSelectionRangeChangeEvent(d)}onMouseDown(d){n(d.browserEvent.target)||document.activeElement!==d.browserEvent.target&&this.list.domFocus()}onContextMenu(d){if(n(d.browserEvent.target))return;const L=typeof d.index=="undefined"?[]:[d.index];this.list.setFocus(L,d.browserEvent)}onViewPointer(d){if(!this.mouseSupport||r(d.browserEvent.target)||n(d.browserEvent.target))return;const L=d.index;if(typeof L=="undefined"){this.list.setFocus([],d.browserEvent),this.list.setSelection([],d.browserEvent),this.list.setAnchor(void 0);return}if(this.isSelectionRangeChangeEvent(d))return this.changeSelection(d);if(this.isSelectionChangeEvent(d))return this.changeSelection(d);this.list.setFocus([L],d.browserEvent),this.list.setAnchor(L),ae(d.browserEvent)||this.list.setSelection([L],d.browserEvent),this._onPointer.fire(d)}onDoubleClick(d){if(r(d.browserEvent.target)||n(d.browserEvent.target)||this.isSelectionChangeEvent(d))return;const L=this.list.getFocus();this.list.setSelection(L,d.browserEvent)}changeSelection(d){const L=d.index;let U=this.list.getAnchor();if(this.isSelectionRangeChangeEvent(d)){typeof U=="undefined"&&(U=this.list.getFocus()[0]??L,this.list.setAnchor(U));const K=Math.min(U,L),Q=Math.max(U,L),N=(0,m.range)(K,Q+1),R=this.list.getSelection(),z=ne(Z(R,[U]),U);if(z.length===0)return;const T=Z(N,X(R,z));this.list.setSelection(T,d.browserEvent),this.list.setFocus([L],d.browserEvent)}else if(this.isSelectionSingleChangeEvent(d)){const K=this.list.getSelection(),Q=K.filter(N=>N!==L);this.list.setFocus([L]),this.list.setAnchor(L),K.length===Q.length?this.list.setSelection([...Q,L],d.browserEvent):this.list.setSelection(Q,d.browserEvent)}}dispose(){this.disposables.dispose()}}t.MouseController=ce;class re{constructor(d,L){this.styleElement=d,this.selectorSuffix=L}style(d){const L=this.selectorSuffix&&`.${this.selectorSuffix}`,U=[];d.listBackground&&(d.listBackground.isOpaque()?U.push(`.monaco-list${L} .monaco-list-rows { background: ${d.listBackground}; }`):v.isMacintosh||console.warn(`List with id '${this.selectorSuffix}' was styled with a non-opaque background color. This will break sub-pixel antialiasing.`)),d.listFocusBackground&&(U.push(`.monaco-list${L}:focus .monaco-list-row.focused { background-color: ${d.listFocusBackground}; }`),U.push(`.monaco-list${L}:focus .monaco-list-row.focused:hover { background-color: ${d.listFocusBackground}; }`)),d.listFocusForeground&&U.push(`.monaco-list${L}:focus .monaco-list-row.focused { color: ${d.listFocusForeground}; }`),d.listActiveSelectionBackground&&(U.push(`.monaco-list${L}:focus .monaco-list-row.selected { background-color: ${d.listActiveSelectionBackground}; }`),U.push(`.monaco-list${L}:focus .monaco-list-row.selected:hover { background-color: ${d.listActiveSelectionBackground}; }`)),d.listActiveSelectionForeground&&U.push(`.monaco-list${L}:focus .monaco-list-row.selected { color: ${d.listActiveSelectionForeground}; }`),d.listActiveSelectionIconForeground&&U.push(`.monaco-list${L}:focus .monaco-list-row.selected .codicon { color: ${d.listActiveSelectionIconForeground}; }`),d.listFocusAndSelectionOutline&&U.push(`.monaco-list${L}:focus .monaco-list-row.selected { outline-color: ${d.listFocusAndSelectionOutline} !important; }`),d.listFocusAndSelectionBackground&&U.push(`
				.monaco-drag-image,
				.monaco-list${L}:focus .monaco-list-row.selected.focused { background-color: ${d.listFocusAndSelectionBackground}; }
			`),d.listFocusAndSelectionForeground&&U.push(`
				.monaco-drag-image,
				.monaco-list${L}:focus .monaco-list-row.selected.focused { color: ${d.listFocusAndSelectionForeground}; }
			`),d.listInactiveFocusForeground&&(U.push(`.monaco-list${L} .monaco-list-row.focused { color:  ${d.listInactiveFocusForeground}; }`),U.push(`.monaco-list${L} .monaco-list-row.focused:hover { color:  ${d.listInactiveFocusForeground}; }`)),d.listInactiveSelectionIconForeground&&U.push(`.monaco-list${L} .monaco-list-row.focused .codicon { color:  ${d.listInactiveSelectionIconForeground}; }`),d.listInactiveFocusBackground&&(U.push(`.monaco-list${L} .monaco-list-row.focused { background-color:  ${d.listInactiveFocusBackground}; }`),U.push(`.monaco-list${L} .monaco-list-row.focused:hover { background-color:  ${d.listInactiveFocusBackground}; }`)),d.listInactiveSelectionBackground&&(U.push(`.monaco-list${L} .monaco-list-row.selected { background-color:  ${d.listInactiveSelectionBackground}; }`),U.push(`.monaco-list${L} .monaco-list-row.selected:hover { background-color:  ${d.listInactiveSelectionBackground}; }`)),d.listInactiveSelectionForeground&&U.push(`.monaco-list${L} .monaco-list-row.selected { color: ${d.listInactiveSelectionForeground}; }`),d.listHoverBackground&&U.push(`.monaco-list${L}:not(.drop-target) .monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${d.listHoverBackground}; }`),d.listHoverForeground&&U.push(`.monaco-list${L} .monaco-list-row:hover:not(.selected):not(.focused) { color:  ${d.listHoverForeground}; }`),d.listSelectionOutline&&U.push(`.monaco-list${L} .monaco-list-row.selected { outline: 1px dotted ${d.listSelectionOutline}; outline-offset: -1px; }`),d.listFocusOutline&&U.push(`
				.monaco-drag-image,
				.monaco-list${L}:focus .monaco-list-row.focused { outline: 1px solid ${d.listFocusOutline}; outline-offset: -1px; }
				.monaco-workbench.context-menu-visible .monaco-list${L}.last-focused .monaco-list-row.focused { outline: 1px solid ${d.listFocusOutline}; outline-offset: -1px; }
			`),d.listInactiveFocusOutline&&U.push(`.monaco-list${L} .monaco-list-row.focused { outline: 1px dotted ${d.listInactiveFocusOutline}; outline-offset: -1px; }`),d.listHoverOutline&&U.push(`.monaco-list${L} .monaco-list-row:hover { outline: 1px dashed ${d.listHoverOutline}; outline-offset: -1px; }`),d.listDropBackground&&U.push(`
				.monaco-list${L}.drop-target,
				.monaco-list${L} .monaco-list-rows.drop-target,
				.monaco-list${L} .monaco-list-row.drop-target { background-color: ${d.listDropBackground} !important; color: inherit !important; }
			`),d.tableColumnsBorder&&U.push(`
				.monaco-table:hover > .monaco-split-view2,
				.monaco-table:hover > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: ${d.tableColumnsBorder};
			}`),d.tableOddRowsBackgroundColor&&U.push(`
				.monaco-table .monaco-list-row[data-parity=odd]:not(.focused):not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(:focus) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(.focused) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr {
					background-color: ${d.tableOddRowsBackgroundColor};
				}
			`),this.styleElement.textContent=U.join(`
`)}}t.DefaultStyleController=re;const Ce={listFocusBackground:g.Color.fromHex("#7FB0D0"),listActiveSelectionBackground:g.Color.fromHex("#0E639C"),listActiveSelectionForeground:g.Color.fromHex("#FFFFFF"),listActiveSelectionIconForeground:g.Color.fromHex("#FFFFFF"),listFocusAndSelectionOutline:g.Color.fromHex("#90C2F9"),listFocusAndSelectionBackground:g.Color.fromHex("#094771"),listFocusAndSelectionForeground:g.Color.fromHex("#FFFFFF"),listInactiveSelectionBackground:g.Color.fromHex("#3F3F46"),listInactiveSelectionIconForeground:g.Color.fromHex("#FFFFFF"),listHoverBackground:g.Color.fromHex("#2A2D2E"),listDropBackground:g.Color.fromHex("#383B3D"),treeIndentGuidesStroke:g.Color.fromHex("#a9a9a9"),tableColumnsBorder:g.Color.fromHex("#cccccc").transparent(.2),tableOddRowsBackgroundColor:g.Color.fromHex("#cccccc").transparent(.04)},Ie={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0,dnd:{getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){}}};function ne(H,d){const L=H.indexOf(d);if(L===-1)return[];const U=[];let K=L-1;for(;K>=0&&H[K]===d-(L-K);)U.push(H[K--]);for(U.reverse(),K=L;K<H.length&&H[K]===d+(K-L);)U.push(H[K++]);return U}function Z(H,d){const L=[];let U=0,K=0;for(;U<H.length||K<d.length;)if(U>=H.length)L.push(d[K++]);else if(K>=d.length)L.push(H[U++]);else if(H[U]===d[K]){L.push(H[U]),U++,K++;continue}else H[U]<d[K]?L.push(H[U++]):L.push(d[K++]);return L}function X(H,d){const L=[];let U=0,K=0;for(;U<H.length||K<d.length;)if(U>=H.length)L.push(d[K++]);else if(K>=d.length)L.push(H[U++]);else if(H[U]===d[K]){U++,K++;continue}else H[U]<d[K]?L.push(H[U++]):K++;return L}const se=(H,d)=>H-d;class te{constructor(d,L){this._templateId=d,this.renderers=L}get templateId(){return this._templateId}renderTemplate(d){return this.renderers.map(L=>L.renderTemplate(d))}renderElement(d,L,U,K){let Q=0;for(const N of this.renderers)N.renderElement(d,L,U[Q++],K)}disposeElement(d,L,U,K){let Q=0;for(const N of this.renderers)N.disposeElement?.(d,L,U[Q],K),Q+=1}disposeTemplate(d){let L=0;for(const U of this.renderers)U.disposeTemplate(d[L++])}}class I{constructor(d){this.accessibilityProvider=d,this.templateId="a18n"}renderTemplate(d){return d}renderElement(d,L,U){const K=this.accessibilityProvider.getAriaLabel(d);K?U.setAttribute("aria-label",K):U.removeAttribute("aria-label");const Q=this.accessibilityProvider.getAriaLevel&&this.accessibilityProvider.getAriaLevel(d);typeof Q=="number"?U.setAttribute("aria-level",`${Q}`):U.removeAttribute("aria-level")}disposeTemplate(d){}}class ${constructor(d,L){this.list=d,this.dnd=L}getDragElements(d){const L=this.list.getSelectedElements();return L.indexOf(d)>-1?L:[d]}getDragURI(d){return this.dnd.getDragURI(d)}getDragLabel(d,L){if(this.dnd.getDragLabel)return this.dnd.getDragLabel(d,L)}onDragStart(d,L){this.dnd.onDragStart?.(d,L)}onDragOver(d,L,U,K){return this.dnd.onDragOver(d,L,U,K)}onDragLeave(d,L,U,K){this.dnd.onDragLeave?.(d,L,U,K)}onDragEnd(d){this.dnd.onDragEnd?.(d)}drop(d,L,U,K){this.dnd.drop(d,L,U,K)}}class j{constructor(d,L,U,K,Q=Ie){this.user=d,this._options=Q,this.focus=new S("focused"),this.anchor=new S("anchor"),this.eventBufferer=new l.EventBufferer,this._ariaLabel="",this.disposables=new e.DisposableStore,this._onDidDispose=new l.Emitter,this.onDidDispose=this._onDidDispose.event;const N=this._options.accessibilityProvider&&this._options.accessibilityProvider.getWidgetRole?this._options.accessibilityProvider?.getWidgetRole():"list";this.selection=new A(N!=="listbox"),(0,D.mixin)(Q,Ce,!1);const R=[this.focus.renderer,this.selection.renderer];this.accessibilityProvider=Q.accessibilityProvider,this.accessibilityProvider&&(R.push(new I(this.accessibilityProvider)),this.accessibilityProvider.onDidChangeActiveDescendant?.(this.onDidChangeActiveDescendant,this,this.disposables)),K=K.map(T=>new te(T.templateId,[...R,T]));const z={...Q,dnd:Q.dnd&&new $(this,Q.dnd)};if(this.view=new o.ListView(L,U,K,z),this.view.domNode.setAttribute("role",N),Q.styleController)this.styleController=Q.styleController(this.view.domId);else{const T=(0,y.createStyleSheet)(this.view.domNode);this.styleController=new re(T,this.view.domId)}if(this.spliceable=new w.CombinedSpliceable([new C(this.focus,this.view,Q.identityProvider),new C(this.selection,this.view,Q.identityProvider),new C(this.anchor,this.view,Q.identityProvider),this.view]),this.disposables.add(this.focus),this.disposables.add(this.selection),this.disposables.add(this.anchor),this.disposables.add(this.view),this.disposables.add(this._onDidDispose),this.disposables.add(new ue(this,this.view)),(typeof Q.keyboardSupport!="boolean"||Q.keyboardSupport)&&(this.keyboardController=new u(this,this.view,Q),this.disposables.add(this.keyboardController)),Q.keyboardNavigationLabelProvider){const T=Q.keyboardNavigationDelegate||t.DefaultKeyboardNavigationDelegate;this.typeNavigationController=new V(this,this.view,Q.keyboardNavigationLabelProvider,Q.keyboardNavigationEventFilter??(()=>!0),T),this.disposables.add(this.typeNavigationController)}this.mouseController=this.createMouseController(Q),this.disposables.add(this.mouseController),this.onDidChangeFocus(this._onFocusChange,this,this.disposables),this.onDidChangeSelection(this._onSelectionChange,this,this.disposables),this.accessibilityProvider&&(this.ariaLabel=this.accessibilityProvider.getWidgetAriaLabel()),this._options.multipleSelectionSupport!==!1&&this.view.domNode.setAttribute("aria-multiselectable","true")}get onDidChangeFocus(){return l.Event.map(this.eventBufferer.wrapEvent(this.focus.onChange),d=>this.toListEvent(d),this.disposables)}get onDidChangeSelection(){return l.Event.map(this.eventBufferer.wrapEvent(this.selection.onChange),d=>this.toListEvent(d),this.disposables)}get domId(){return this.view.domId}get onDidScroll(){return this.view.onDidScroll}get onMouseClick(){return this.view.onMouseClick}get onMouseDblClick(){return this.view.onMouseDblClick}get onMouseMiddleClick(){return this.view.onMouseMiddleClick}get onPointer(){return this.mouseController.onPointer}get onMouseUp(){return this.view.onMouseUp}get onMouseDown(){return this.view.onMouseDown}get onMouseOver(){return this.view.onMouseOver}get onMouseMove(){return this.view.onMouseMove}get onMouseOut(){return this.view.onMouseOut}get onTouchStart(){return this.view.onTouchStart}get onTap(){return this.view.onTap}get onContextMenu(){let d=!1;const L=this.disposables.add(l.Event.chain(this.disposables.add(new i.DomEmitter(this.view.domNode,"keydown")).event)).map(Q=>new B.StandardKeyboardEvent(Q)).filter(Q=>d=Q.keyCode===58||Q.shiftKey&&Q.keyCode===68).map(Q=>y.EventHelper.stop(Q,!0)).filter(()=>!1).event,U=this.disposables.add(l.Event.chain(this.disposables.add(new i.DomEmitter(this.view.domNode,"keyup")).event)).forEach(()=>d=!1).map(Q=>new B.StandardKeyboardEvent(Q)).filter(Q=>Q.keyCode===58||Q.shiftKey&&Q.keyCode===68).map(Q=>y.EventHelper.stop(Q,!0)).map(({browserEvent:Q})=>{const N=this.getFocus(),R=N.length?N[0]:void 0,z=typeof R!="undefined"?this.view.element(R):void 0,T=typeof R!="undefined"?this.view.domElement(R):this.view.domNode;return{index:R,element:z,anchor:T,browserEvent:Q}}).event,K=this.disposables.add(l.Event.chain(this.view.onContextMenu)).filter(Q=>!d).map(({element:Q,index:N,browserEvent:R})=>({element:Q,index:N,anchor:{x:R.pageX+1,y:R.pageY},browserEvent:R})).event;return l.Event.any(L,U,K)}get onKeyDown(){return this.disposables.add(new i.DomEmitter(this.view.domNode,"keydown")).event}get onKeyUp(){return this.disposables.add(new i.DomEmitter(this.view.domNode,"keyup")).event}get onKeyPress(){return this.disposables.add(new i.DomEmitter(this.view.domNode,"keypress")).event}get onDidFocus(){return l.Event.signal(this.disposables.add(new i.DomEmitter(this.view.domNode,"focus",!0)).event)}get onDidBlur(){return l.Event.signal(this.disposables.add(new i.DomEmitter(this.view.domNode,"blur",!0)).event)}createMouseController(d){return new ce(this)}updateOptions(d={}){this._options={...this._options,...d},this.typeNavigationController?.updateOptions(this._options),this._options.multipleSelectionController!==void 0&&(this._options.multipleSelectionSupport?this.view.domNode.setAttribute("aria-multiselectable","true"):this.view.domNode.removeAttribute("aria-multiselectable")),this.mouseController.updateOptions(d),this.keyboardController?.updateOptions(d),this.view.updateOptions(d)}get options(){return this._options}splice(d,L,U=[]){if(d<0||d>this.view.length)throw new a.ListError(this.user,`Invalid start index: ${d}`);if(L<0)throw new a.ListError(this.user,`Invalid delete count: ${L}`);L===0&&U.length===0||this.eventBufferer.bufferEvents(()=>this.spliceable.splice(d,L,U))}updateWidth(d){this.view.updateWidth(d)}updateElementHeight(d,L){this.view.updateElementHeight(d,L,null)}rerender(){this.view.rerender()}element(d){return this.view.element(d)}indexOf(d){return this.view.indexOf(d)}get length(){return this.view.length}get contentHeight(){return this.view.contentHeight}get onDidChangeContentHeight(){return this.view.onDidChangeContentHeight}get scrollTop(){return this.view.getScrollTop()}set scrollTop(d){this.view.setScrollTop(d)}get scrollLeft(){return this.view.getScrollLeft()}set scrollLeft(d){this.view.setScrollLeft(d)}get scrollHeight(){return this.view.scrollHeight}get renderHeight(){return this.view.renderHeight}get firstVisibleIndex(){return this.view.firstVisibleIndex}get lastVisibleIndex(){return this.view.lastVisibleIndex}get ariaLabel(){return this._ariaLabel}set ariaLabel(d){this._ariaLabel=d,this.view.domNode.setAttribute("aria-label",d)}domFocus(){this.view.domNode.focus({preventScroll:!0})}layout(d,L){this.view.layout(d,L)}triggerTypeNavigation(){this.typeNavigationController?.trigger()}setSelection(d,L){for(const U of d)if(U<0||U>=this.length)throw new a.ListError(this.user,`Invalid index ${U}`);this.selection.set(d,L)}getSelection(){return this.selection.get()}getSelectedElements(){return this.getSelection().map(d=>this.view.element(d))}setAnchor(d){if(typeof d=="undefined"){this.anchor.set([]);return}if(d<0||d>=this.length)throw new a.ListError(this.user,`Invalid index ${d}`);this.anchor.set([d])}getAnchor(){return(0,m.firstOrDefault)(this.anchor.get(),void 0)}getAnchorElement(){const d=this.getAnchor();return typeof d=="undefined"?void 0:this.element(d)}setFocus(d,L){for(const U of d)if(U<0||U>=this.length)throw new a.ListError(this.user,`Invalid index ${U}`);this.focus.set(d,L)}focusNext(d=1,L=!1,U,K){if(this.length===0)return;const Q=this.focus.get(),N=this.findNextIndex(Q.length>0?Q[0]+d:0,L,K);N>-1&&this.setFocus([N],U)}focusPrevious(d=1,L=!1,U,K){if(this.length===0)return;const Q=this.focus.get(),N=this.findPreviousIndex(Q.length>0?Q[0]-d:0,L,K);N>-1&&this.setFocus([N],U)}async focusNextPage(d,L){let U=this.view.indexAt(this.view.getScrollTop()+this.view.renderHeight);U=U===0?0:U-1;const K=this.getFocus()[0];if(K!==U&&(K===void 0||U>K)){const Q=this.findPreviousIndex(U,!1,L);Q>-1&&K!==Q?this.setFocus([Q],d):this.setFocus([U],d)}else{const Q=this.view.getScrollTop();let N=Q+this.view.renderHeight;U>K&&(N-=this.view.elementHeight(U)),this.view.setScrollTop(N),this.view.getScrollTop()!==Q&&(this.setFocus([]),await(0,f.timeout)(0),await this.focusNextPage(d,L))}}async focusPreviousPage(d,L){let U;const K=this.view.getScrollTop();K===0?U=this.view.indexAt(K):U=this.view.indexAfter(K-1);const Q=this.getFocus()[0];if(Q!==U&&(Q===void 0||Q>=U)){const N=this.findNextIndex(U,!1,L);N>-1&&Q!==N?this.setFocus([N],d):this.setFocus([U],d)}else{const N=K;this.view.setScrollTop(K-this.view.renderHeight),this.view.getScrollTop()!==N&&(this.setFocus([]),await(0,f.timeout)(0),await this.focusPreviousPage(d,L))}}focusLast(d,L){if(this.length===0)return;const U=this.findPreviousIndex(this.length-1,!1,L);U>-1&&this.setFocus([U],d)}focusFirst(d,L){this.focusNth(0,d,L)}focusNth(d,L,U){if(this.length===0)return;const K=this.findNextIndex(d,!1,U);K>-1&&this.setFocus([K],L)}findNextIndex(d,L=!1,U){for(let K=0;K<this.length;K++){if(d>=this.length&&!L)return-1;if(d=d%this.length,!U||U(this.element(d)))return d;d++}return-1}findPreviousIndex(d,L=!1,U){for(let K=0;K<this.length;K++){if(d<0&&!L)return-1;if(d=(this.length+d%this.length)%this.length,!U||U(this.element(d)))return d;d--}return-1}getFocus(){return this.focus.get()}getFocusedElements(){return this.getFocus().map(d=>this.view.element(d))}reveal(d,L){if(d<0||d>=this.length)throw new a.ListError(this.user,`Invalid index ${d}`);const U=this.view.getScrollTop(),K=this.view.elementTop(d),Q=this.view.elementHeight(d);if((0,_.isNumber)(L)){const N=Q-this.view.renderHeight;this.view.setScrollTop(N*(0,p.clamp)(L,0,1)+K)}else{const N=K+Q,R=U+this.view.renderHeight;K<U&&N>=R||(K<U||N>=R&&Q>=this.view.renderHeight?this.view.setScrollTop(K):N>=R&&this.view.setScrollTop(N-this.view.renderHeight))}}getRelativeTop(d){if(d<0||d>=this.length)throw new a.ListError(this.user,`Invalid index ${d}`);const L=this.view.getScrollTop(),U=this.view.elementTop(d),K=this.view.elementHeight(d);if(U<L||U+K>L+this.view.renderHeight)return null;const Q=K-this.view.renderHeight;return Math.abs((L-U)/Q)}isDOMFocused(){return this.view.domNode===document.activeElement}getHTMLElement(){return this.view.domNode}getElementID(d){return this.view.getElementDomId(d)}style(d){this.styleController.style(d)}toListEvent({indexes:d,browserEvent:L}){return{indexes:d,elements:d.map(U=>this.view.element(U)),browserEvent:L}}_onFocusChange(){const d=this.focus.get();this.view.domNode.classList.toggle("element-focused",d.length>0),this.onDidChangeActiveDescendant()}onDidChangeActiveDescendant(){const d=this.focus.get();if(d.length>0){let L;this.accessibilityProvider?.getActiveDescendantId&&(L=this.accessibilityProvider.getActiveDescendantId(this.view.element(d[0]))),this.view.domNode.setAttribute("aria-activedescendant",L||this.view.getElementDomId(d[0]))}else this.view.domNode.removeAttribute("aria-activedescendant")}_onSelectionChange(){const d=this.selection.get();this.view.domNode.classList.toggle("selection-none",d.length===0),this.view.domNode.classList.toggle("selection-single",d.length===1),this.view.domNode.classList.toggle("selection-multiple",d.length>1)}dispose(){this._onDidDispose.fire(),this.disposables.dispose(),this._onDidDispose.dispose()}}Ke([F.memoize],j.prototype,"onDidChangeFocus",null),Ke([F.memoize],j.prototype,"onDidChangeSelection",null),Ke([F.memoize],j.prototype,"onContextMenu",null),Ke([F.memoize],j.prototype,"onKeyDown",null),Ke([F.memoize],j.prototype,"onKeyUp",null),Ke([F.memoize],j.prototype,"onKeyPress",null),Ke([F.memoize],j.prototype,"onDidFocus",null),Ke([F.memoize],j.prototype,"onDidBlur",null),t.List=j}),define(me[59],pe([1,0,13,34,36,10,16]),function(J,t,y,i,B,M,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parseHrefAndDimensions=t.removeMarkdownEscapes=t.escapeDoubleQuotes=t.escapeMarkdownSyntaxTokens=t.markdownStringEqual=t.isMarkdownString=t.isEmptyMarkdownString=t.MarkdownString=t.MarkdownStringTextNewlineStyle=void 0;var w;(function(D){D[D.Paragraph=0]="Paragraph",D[D.Break=1]="Break"})(w=t.MarkdownStringTextNewlineStyle||(t.MarkdownStringTextNewlineStyle={}));class m{constructor(v="",_=!1){if(this.value=v,typeof this.value!="string")throw(0,y.illegalArgument)("value");typeof _=="boolean"?(this.isTrusted=_,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=_.isTrusted??void 0,this.supportThemeIcons=_.supportThemeIcons??!1,this.supportHtml=_.supportHtml??!1)}appendText(v,_=0){return this.value+=l(this.supportThemeIcons?(0,i.escapeIcons)(v):v).replace(/([ \t]+)/g,(a,o)=>"&nbsp;".repeat(o.length)).replace(/\>/gm,"\\>").replace(/\n/g,_===1?`\\
`:`

`),this}appendMarkdown(v){return this.value+=v,this}appendCodeblock(v,_){return this.value+="\n```",this.value+=v,this.value+=`
`,this.value+=_,this.value+="\n```\n",this}appendLink(v,_,a){return this.value+="[",this.value+=this._escape(_,"]"),this.value+="](",this.value+=this._escape(String(v),")"),a&&(this.value+=` "${this._escape(this._escape(a,'"'),")")}"`),this.value+=")",this}_escape(v,_){const a=new RegExp((0,M.escapeRegExpCharacters)(_),"g");return v.replace(a,(o,b)=>v.charAt(b-1)!=="\\"?`\\${o}`:o)}}t.MarkdownString=m;function f(D){return g(D)?!D.value:Array.isArray(D)?D.every(f):!0}t.isEmptyMarkdownString=f;function g(D){return D instanceof m?!0:D&&typeof D=="object"?typeof D.value=="string"&&(typeof D.isTrusted=="boolean"||D.isTrusted===void 0)&&(typeof D.supportThemeIcons=="boolean"||D.supportThemeIcons===void 0):!1}t.isMarkdownString=g;function F(D,v){return D===v?!0:!D||!v?!1:D.value===v.value&&D.isTrusted===v.isTrusted&&D.supportThemeIcons===v.supportThemeIcons&&D.supportHtml===v.supportHtml&&(D.baseUri===v.baseUri||!!D.baseUri&&!!v.baseUri&&(0,B.isEqual)(E.URI.from(D.baseUri),E.URI.from(v.baseUri)))}t.markdownStringEqual=F;function l(D){return D.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}t.escapeMarkdownSyntaxTokens=l;function s(D){return D.replace(/"/g,"&quot;")}t.escapeDoubleQuotes=s;function e(D){return D&&D.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}t.removeMarkdownEscapes=e;function p(D){const v=[],_=D.split("|").map(o=>o.trim());D=_[0];const a=_[1];if(a){const o=/height=(\d+)/.exec(a),b=/width=(\d+)/.exec(a),S=o?o[1]:"",A=b?b[1]:"",C=isFinite(parseInt(A)),r=isFinite(parseInt(S));C&&v.push(`width="${A}"`),r&&v.push(`height="${S}"`)}return{href:D,dimensions:v}}t.parseHrefAndDimensions=p}),define(me[120],pe([1,0,4,112,18,51,20,113,13,3,59,34,71,2,75,49,35,27,36,10,16]),function(J,t,y,i,B,M,E,w,m,f,g,F,l,s,e,p,D,v,_,a,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.renderMarkdownAsPlaintext=t.renderStringAsPlaintext=t.renderMarkdown=void 0;function b(u,h={},O={}){const V=new s.DisposableStore;let ue=!1;const ie=(0,M.createElement)(h),ge=function(Z){let X;try{X=(0,p.parse)(decodeURIComponent(Z))}catch{}return X?(X=(0,v.cloneAndChange)(X,se=>{if(u.uris&&u.uris[se])return o.URI.revive(u.uris[se])}),encodeURIComponent(JSON.stringify(X))):Z},ae=function(Z,X){const se=u.uris&&u.uris[Z];let te=o.URI.revive(se);return X?Z.startsWith(D.Schemas.data+":")?Z:(te||(te=o.URI.parse(Z)),D.FileAccess.asBrowserUri(te).toString(!0)):!te||o.URI.parse(Z).toString()===te.toString()?Z:(te.query&&(te=te.with({query:ge(te.query)})),te.toString())},we=new e.marked.Renderer;we.image=(Z,X,se)=>{let te=[],I=[];return Z&&({href:Z,dimensions:te}=(0,g.parseHrefAndDimensions)(Z),I.push(`src="${(0,g.escapeDoubleQuotes)(Z)}"`)),se&&I.push(`alt="${(0,g.escapeDoubleQuotes)(se)}"`),X&&I.push(`title="${(0,g.escapeDoubleQuotes)(X)}"`),te.length&&(I=I.concat(te)),"<img "+I.join(" ")+">"},we.link=(Z,X,se)=>typeof Z!="string"?"":(Z===se&&(se=(0,g.removeMarkdownEscapes)(se)),X=typeof X=="string"?(0,g.escapeDoubleQuotes)((0,g.removeMarkdownEscapes)(X)):"",Z=(0,g.removeMarkdownEscapes)(Z),Z=Z.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;"),`<a href="${Z}" title="${X||Z}">${se}</a>`),we.paragraph=Z=>`<p>${Z}</p>`;const ce=[];if(h.codeBlockRenderer&&(we.code=(Z,X)=>{const se=l.defaultGenerator.nextId(),te=h.codeBlockRenderer(S(X),Z);return ce.push(te.then(I=>[se,I])),`<div class="code" data-code="${se}">${(0,a.escape)(Z)}</div>`}),h.actionHandler){const Z=h.actionHandler.disposables.add(new B.DomEmitter(ie,"click")),X=h.actionHandler.disposables.add(new B.DomEmitter(ie,"auxclick"));h.actionHandler.disposables.add(f.Event.any(Z.event,X.event)(se=>{const te=new E.StandardMouseEvent(se);if(!te.leftButton&&!te.middleButton)return;let I=te.target;if(!(I.tagName!=="A"&&(I=I.parentElement,!I||I.tagName!=="A")))try{let $=I.dataset.href;$&&(u.baseUri&&($=A(o.URI.from(u.baseUri),$)),h.actionHandler.callback($,te))}catch($){(0,m.onUnexpectedError)($)}finally{te.preventDefault()}}))}u.supportHtml||(O.sanitizer=Z=>(u.isTrusted?Z.match(/^(<span[^>]+>)|(<\/\s*span>)$/):void 0)?Z:"",O.sanitize=!0,O.silent=!0),O.renderer=we;let re=u.value??"";re.length>1e5&&(re=`${re.substr(0,1e5)}\u2026`),u.supportThemeIcons&&(re=(0,F.markdownEscapeEscapedIcons)(re));let Ce=e.marked.parse(re,O);u.supportThemeIcons&&(Ce=(0,w.renderLabelWithIcons)(Ce).map(X=>typeof X=="string"?X:X.outerHTML).join(""));const ne=new DOMParser().parseFromString(C(u,Ce),"text/html");if(ne.body.querySelectorAll("img").forEach(Z=>{const X=Z.getAttribute("src");if(X){let se=X;try{u.baseUri&&(se=A(o.URI.from(u.baseUri),se))}catch{}Z.src=ae(se,!0)}}),ne.body.querySelectorAll("a").forEach(Z=>{const X=Z.getAttribute("href");if(Z.setAttribute("href",""),!X||/^data:|javascript:/i.test(X)||/^command:/i.test(X)&&!u.isTrusted||/^command:(\/\/\/)?_workbench\.downloadResource/i.test(X))Z.replaceWith(...Z.childNodes);else{let se=ae(X,!1);u.baseUri&&(se=A(o.URI.from(u.baseUri),X)),Z.dataset.href=se}}),ie.innerHTML=C(u,ne.body.innerHTML),ce.length>0&&Promise.all(ce).then(Z=>{if(ue)return;const X=new Map(Z),se=ie.querySelectorAll("div[data-code]");for(const te of se){const I=X.get(te.dataset.code??"");I&&y.reset(te,I)}h.asyncRenderCallback?.()}),h.asyncRenderCallback)for(const Z of ie.getElementsByTagName("img")){const X=V.add(y.addDisposableListener(Z,"load",()=>{X.dispose(),h.asyncRenderCallback()}))}return{element:ie,dispose:()=>{ue=!0,V.dispose()}}}t.renderMarkdown=b;function S(u){if(!u)return"";const h=u.split(/[\s+|:|,|\{|\?]/,1);return h.length?h[0]:u}function A(u,h){return/^\w[\w\d+.-]*:/.test(h)?h:u.path.endsWith("/")?(0,_.resolvePath)(u,h).toString():(0,_.resolvePath)((0,_.dirname)(u),h).toString()}function C(u,h){const{config:O,allowedSchemes:V}=r(u);i.addHook("uponSanitizeAttribute",(ie,ge)=>{if(ge.attrName==="style"||ge.attrName==="class"){if(ie.tagName==="SPAN"){if(ge.attrName==="style"){ge.keepAttr=/^(color\:#[0-9a-fA-F]+;)?(background-color\:#[0-9a-fA-F]+;)?$/.test(ge.attrValue);return}else if(ge.attrName==="class"){ge.keepAttr=/^codicon codicon-[a-z\-]+( codicon-modifier-[a-z\-]+)?$/.test(ge.attrValue);return}}ge.keepAttr=!1;return}});const ue=y.hookDomPurifyHrefAndSrcSanitizer(V);try{return i.sanitize(h,{...O,RETURN_TRUSTED_TYPE:!0})}finally{i.removeHook("uponSanitizeAttribute"),ue.dispose()}}function r(u){const h=[D.Schemas.http,D.Schemas.https,D.Schemas.mailto,D.Schemas.data,D.Schemas.file,D.Schemas.vscodeFileResource,D.Schemas.vscodeRemote,D.Schemas.vscodeRemoteResource];return u.isTrusted&&h.push(D.Schemas.command),{config:{ALLOWED_TAGS:["ul","li","p","b","i","code","blockquote","ol","h1","h2","h3","h4","h5","h6","hr","em","pre","table","thead","tbody","tr","th","td","div","del","a","strong","br","img","span"],ALLOWED_ATTR:["href","data-href","target","title","src","alt","class","style","data-code","width","height","align"],ALLOW_UNKNOWN_PROTOCOLS:!0},allowedSchemes:h}}function n(u){return typeof u=="string"?u:c(u)}t.renderStringAsPlaintext=n;function c(u){const h=new e.marked.Renderer;h.code=ie=>ie,h.blockquote=ie=>ie,h.html=ie=>"",h.heading=(ie,ge,ae)=>ie+`
`,h.hr=()=>"",h.list=(ie,ge)=>ie,h.listitem=ie=>ie+`
`,h.paragraph=ie=>ie+`
`,h.table=(ie,ge)=>ie+ge+`
`,h.tablerow=ie=>ie,h.tablecell=(ie,ge)=>ie+" ",h.strong=ie=>ie,h.em=ie=>ie,h.codespan=ie=>ie,h.br=()=>`
`,h.del=ie=>ie,h.image=(ie,ge,ae)=>"",h.text=ie=>ie,h.link=(ie,ge,ae)=>ae;let O=u.value??"";O.length>1e5&&(O=`${O.substr(0,1e5)}\u2026`);const V=new Map([["&quot;",'"'],["&nbsp;"," "],["&amp;","&"],["&#39;","'"],["&lt;","<"],["&gt;",">"]]),ue=e.marked.parse(O,{renderer:h}).replace(/&(#\d+|[a-zA-Z]+);/g,ie=>V.get(ie)??ie);return C({isTrusted:!1},ue).toString()}t.renderMarkdownAsPlaintext=c}),define(me[121],pe([1,0,4,8,28,59,34,2,6,98]),function(J,t,y,i,B,M,E,w,m,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.setupCustomHover=t.setupNativeHover=void 0;function g(s,e){(0,m.isString)(e)?s.title=(0,E.stripIcons)(e):e?.markdownNotSupportedFallback?s.title=e.markdownNotSupportedFallback:s.removeAttribute("title")}t.setupNativeHover=g;class F{constructor(e,p,D){this.hoverDelegate=e,this.target=p,this.fadeInAnimation=D}async update(e,p,D){if(this._cancellationTokenSource&&(this._cancellationTokenSource.dispose(!0),this._cancellationTokenSource=void 0),this.isDisposed)return;let v;if(e===void 0||(0,m.isString)(e)||e instanceof HTMLElement)v=e;else if(!(0,m.isFunction)(e.markdown))v=e.markdown??e.markdownNotSupportedFallback;else{this._hoverWidget||this.show((0,f.localize)(0,null),p),this._cancellationTokenSource=new B.CancellationTokenSource;const _=this._cancellationTokenSource.token;if(v=await e.markdown(_),v===void 0&&(v=e.markdownNotSupportedFallback),this.isDisposed||_.isCancellationRequested)return}this.show(v,p,D)}show(e,p,D){const v=this._hoverWidget;if(this.hasContent(e)){const _={content:e,target:this.target,showPointer:this.hoverDelegate.placement==="element",hoverPosition:2,skipFadeInAnimation:!this.fadeInAnimation||!!v,...D};this._hoverWidget=this.hoverDelegate.showHover(_,p)}v?.dispose()}hasContent(e){return e?(0,M.isMarkdownString)(e)?!!e.value:!0:!1}get isDisposed(){return this._hoverWidget?.isDisposed}dispose(){this._hoverWidget?.dispose(),this._cancellationTokenSource?.dispose(!0),this._cancellationTokenSource=void 0}}function l(s,e,p,D){let v,_;const a=(C,r)=>{C&&(_?.dispose(),_=void 0),r&&(v?.dispose(),v=void 0),s.onDidHideHover?.()},o=(C,r,n)=>new i.TimeoutTimer(async()=>{(!_||_.isDisposed)&&(_=new F(s,n||e,C>0),await _.update(p,r,D))},C),b=()=>{if(v)return;const C=new w.DisposableStore,r=u=>a(!1,u.fromElement===e);C.add(y.addDisposableListener(e,y.EventType.MOUSE_LEAVE,r,!0));const n=()=>a(!0,!0);C.add(y.addDisposableListener(e,y.EventType.MOUSE_DOWN,n,!0));const c={targetElements:[e],dispose:()=>{}};if(s.placement===void 0||s.placement==="mouse"){const u=h=>{c.x=h.x+10,h.target instanceof HTMLElement&&h.target.classList.contains("action-label")&&a(!0,!0)};C.add(y.addDisposableListener(e,y.EventType.MOUSE_MOVE,u,!0))}C.add(o(s.delay,!1,c)),v=C},S=y.addDisposableListener(e,y.EventType.MOUSE_OVER,b,!0);return{show:C=>{a(!1,!0),o(0,C)},hide:()=>{a(!0,!0)},update:async(C,r)=>{p=C,await _?.update(p,void 0,r)},dispose:()=>{S.dispose(),a(!0,!0)}}}t.setupCustomHover=l}),define(me[122],pe([1,0,4,18,19,120,58,14,3,43,2,5,100,91]),function(J,t,y,i,B,M,E,w,m,f,g,F,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBoxList=void 0;const s=y.$,e="selectOption.entry.template";class p{get templateId(){return e}renderTemplate(_){const a=Object.create(null);return a.disposables=[],a.root=_,a.text=y.append(_,s(".option-text")),a.detail=y.append(_,s(".option-detail")),a.decoratorRight=y.append(_,s(".option-decorator-right")),a}renderElement(_,a,o){const b=o,S=_.text,A=_.detail,C=_.decoratorRight,r=_.isDisabled;b.text.textContent=S,b.detail.textContent=A||"",b.decoratorRight.innerText=C||"",r?b.root.classList.add("option-disabled"):b.root.classList.remove("option-disabled")}disposeTemplate(_){_.disposables=(0,g.dispose)(_.disposables)}}class D extends g.Disposable{constructor(_,a,o,b,S){super();this.options=[],this._currentSelection=0,this._hasDetails=!1,this._skipLayout=!1,this._sticky=!1,this._isVisible=!1,this.selectBoxOptions=S||Object.create(null),typeof this.selectBoxOptions.minBottomMargin!="number"?this.selectBoxOptions.minBottomMargin=D.DEFAULT_DROPDOWN_MINIMUM_BOTTOM_MARGIN:this.selectBoxOptions.minBottomMargin<0&&(this.selectBoxOptions.minBottomMargin=0),this.selectElement=document.createElement("select"),this.selectElement.className="monaco-select-box monaco-select-box-dropdown-padding",typeof this.selectBoxOptions.ariaLabel=="string"&&this.selectElement.setAttribute("aria-label",this.selectBoxOptions.ariaLabel),typeof this.selectBoxOptions.ariaDescription=="string"&&this.selectElement.setAttribute("aria-description",this.selectBoxOptions.ariaDescription),this._onDidSelect=new m.Emitter,this._register(this._onDidSelect),this.styles=b,this.registerListeners(),this.constructSelectDropDown(o),this.selected=a||0,_&&this.setOptions(_,a)}getHeight(){return 18}getTemplateId(){return e}constructSelectDropDown(_){this.contextViewProvider=_,this.selectDropDownContainer=y.$(".monaco-select-box-dropdown-container"),this.selectDropDownContainer.classList.add("monaco-select-box-dropdown-padding"),this.selectionDetailsPane=y.append(this.selectDropDownContainer,s(".select-box-details-pane"));const a=y.append(this.selectDropDownContainer,s(".select-box-dropdown-container-width-control")),o=y.append(a,s(".width-control-div"));this.widthControlElement=document.createElement("span"),this.widthControlElement.className="option-text-width-control",y.append(o,this.widthControlElement),this._dropDownPosition=0,this.styleElement=y.createStyleSheet(this.selectDropDownContainer),this.selectDropDownContainer.setAttribute("draggable","true"),this._register(y.addDisposableListener(this.selectDropDownContainer,y.EventType.DRAG_START,b=>{y.EventHelper.stop(b,!0)}))}registerListeners(){this._register(y.addStandardDisposableListener(this.selectElement,"change",a=>{this.selected=a.target.selectedIndex,this._onDidSelect.fire({index:a.target.selectedIndex,selected:a.target.value}),!!this.options[this.selected]&&!!this.options[this.selected].text&&(this.selectElement.title=this.options[this.selected].text)})),this._register(y.addDisposableListener(this.selectElement,y.EventType.CLICK,a=>{y.EventHelper.stop(a),this._isVisible?this.hideSelectDropDown(!0):this.showSelectDropDown()})),this._register(y.addDisposableListener(this.selectElement,y.EventType.MOUSE_DOWN,a=>{y.EventHelper.stop(a)}));let _;this._register(y.addDisposableListener(this.selectElement,"touchstart",a=>{_=this._isVisible})),this._register(y.addDisposableListener(this.selectElement,"touchend",a=>{y.EventHelper.stop(a),_?this.hideSelectDropDown(!0):this.showSelectDropDown()})),this._register(y.addDisposableListener(this.selectElement,y.EventType.KEY_DOWN,a=>{const o=new B.StandardKeyboardEvent(a);let b=!1;F.isMacintosh?(o.keyCode===18||o.keyCode===16||o.keyCode===10||o.keyCode===3)&&(b=!0):(o.keyCode===18&&o.altKey||o.keyCode===16&&o.altKey||o.keyCode===10||o.keyCode===3)&&(b=!0),b&&(this.showSelectDropDown(),y.EventHelper.stop(a,!0))}))}get onDidSelect(){return this._onDidSelect.event}setOptions(_,a){w.equals(this.options,_)||(this.options=_,this.selectElement.options.length=0,this._hasDetails=!1,this.options.forEach((o,b)=>{this.selectElement.add(this.createOption(o.text,b,o.isDisabled)),typeof o.description=="string"&&(this._hasDetails=!0)})),a!==void 0&&(this.select(a),this._currentSelection=this.selected)}setOptionsList(){this.selectList?.splice(0,this.selectList.length,this.options)}select(_){_>=0&&_<this.options.length?this.selected=_:_>this.options.length-1?this.select(this.options.length-1):this.selected<0&&(this.selected=0),this.selectElement.selectedIndex=this.selected,!!this.options[this.selected]&&!!this.options[this.selected].text&&(this.selectElement.title=this.options[this.selected].text)}setAriaLabel(_){this.selectBoxOptions.ariaLabel=_,this.selectElement.setAttribute("aria-label",this.selectBoxOptions.ariaLabel)}focus(){this.selectElement&&(this.selectElement.tabIndex=0,this.selectElement.focus())}blur(){this.selectElement&&(this.selectElement.tabIndex=-1,this.selectElement.blur())}setFocusable(_){this.selectElement.tabIndex=_?0:-1}render(_){this.container=_,_.classList.add("select-container"),_.appendChild(this.selectElement),this.applyStyles()}style(_){const a=[];this.styles=_,this.styles.listFocusBackground&&a.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { background-color: ${this.styles.listFocusBackground} !important; }`),this.styles.listFocusForeground&&a.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { color: ${this.styles.listFocusForeground} !important; }`),this.styles.decoratorRightForeground&&a.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.focused) .option-decorator-right { color: ${this.styles.decoratorRightForeground}; }`),this.styles.selectBackground&&this.styles.selectBorder&&!this.styles.selectBorder.equals(this.styles.selectBackground)?(a.push(`.monaco-select-box-dropdown-container { border: 1px solid ${this.styles.selectBorder} } `),a.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.styles.selectBorder} } `),a.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.styles.selectBorder} } `)):this.styles.selectListBorder&&(a.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.styles.selectListBorder} } `),a.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.styles.selectListBorder} } `)),this.styles.listHoverForeground&&a.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { color: ${this.styles.listHoverForeground} !important; }`),this.styles.listHoverBackground&&a.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { background-color: ${this.styles.listHoverBackground} !important; }`),this.styles.listFocusOutline&&a.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { outline: 1.6px dotted ${this.styles.listFocusOutline} !important; outline-offset: -1.6px !important; }`),this.styles.listHoverOutline&&a.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { outline: 1.6px dashed ${this.styles.listHoverOutline} !important; outline-offset: -1.6px !important; }`),a.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled.focused { background-color: transparent !important; color: inherit !important; outline: none !important; }"),a.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled:hover { background-color: transparent !important; color: inherit !important; outline: none !important; }"),this.styleElement.textContent=a.join(`
`),this.applyStyles()}applyStyles(){if(this.selectElement){const _=this.styles.selectBackground?this.styles.selectBackground.toString():"",a=this.styles.selectForeground?this.styles.selectForeground.toString():"",o=this.styles.selectBorder?this.styles.selectBorder.toString():"";this.selectElement.style.backgroundColor=_,this.selectElement.style.color=a,this.selectElement.style.borderColor=o}this.selectList&&this.styleList()}styleList(){if(this.selectList){const _=this.styles.selectBackground?this.styles.selectBackground.toString():"";this.selectList.style({});const a=this.styles.selectListBackground?this.styles.selectListBackground.toString():_;this.selectDropDownListContainer.style.backgroundColor=a,this.selectionDetailsPane.style.backgroundColor=a;const o=this.styles.focusBorder?this.styles.focusBorder.toString():"";this.selectDropDownContainer.style.outlineColor=o,this.selectDropDownContainer.style.outlineOffset="-1px"}}createOption(_,a,o){const b=document.createElement("option");return b.value=_,b.text=_,b.disabled=!!o,b}showSelectDropDown(){this.selectionDetailsPane.innerText="",!(!this.contextViewProvider||this._isVisible)&&(this.createSelectList(this.selectDropDownContainer),this.setOptionsList(),this.contextViewProvider.showContextView({getAnchor:()=>this.selectElement,render:_=>this.renderSelectDropDown(_,!0),layout:()=>{this.layoutSelectDropDown()},onHide:()=>{this.selectDropDownContainer.classList.remove("visible"),this.selectElement.classList.remove("synthetic-focus")},anchorPosition:this._dropDownPosition},this.selectBoxOptions.optionsAsChildren?this.container:void 0),this._isVisible=!0,this.hideSelectDropDown(!1),this.contextViewProvider.showContextView({getAnchor:()=>this.selectElement,render:_=>this.renderSelectDropDown(_),layout:()=>this.layoutSelectDropDown(),onHide:()=>{this.selectDropDownContainer.classList.remove("visible"),this.selectElement.classList.remove("synthetic-focus")},anchorPosition:this._dropDownPosition},this.selectBoxOptions.optionsAsChildren?this.container:void 0),this._currentSelection=this.selected,this._isVisible=!0,this.selectElement.setAttribute("aria-expanded","true"))}hideSelectDropDown(_){!this.contextViewProvider||!this._isVisible||(this._isVisible=!1,this.selectElement.setAttribute("aria-expanded","false"),_&&this.selectElement.focus(),this.contextViewProvider.hideContextView())}renderSelectDropDown(_,a){return _.appendChild(this.selectDropDownContainer),this.layoutSelectDropDown(a),{dispose:()=>{try{_.removeChild(this.selectDropDownContainer)}catch{}}}}measureMaxDetailsHeight(){let _=0;return this.options.forEach((a,o)=>{this.updateDetail(o),this.selectionDetailsPane.offsetHeight>_&&(_=this.selectionDetailsPane.offsetHeight)}),_}layoutSelectDropDown(_){if(this._skipLayout)return!1;if(this.selectList){this.selectDropDownContainer.classList.add("visible");const a=y.getDomNodePagePosition(this.selectElement),o=getComputedStyle(this.selectElement),b=parseFloat(o.getPropertyValue("--dropdown-padding-top"))+parseFloat(o.getPropertyValue("--dropdown-padding-bottom")),S=window.innerHeight-a.top-a.height-(this.selectBoxOptions.minBottomMargin||0),A=a.top-D.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN,C=this.selectElement.offsetWidth,r=this.setWidthControlElement(this.widthControlElement),n=Math.max(r,Math.round(C)).toString()+"px";this.selectDropDownContainer.style.width=n,this.selectList.getHTMLElement().style.height="",this.selectList.layout();let c=this.selectList.contentHeight;const u=this._hasDetails?this.measureMaxDetailsHeight():0,h=c+b+u,O=Math.floor((S-b-u)/this.getHeight()),V=Math.floor((A-b-u)/this.getHeight());if(_)return a.top+a.height>window.innerHeight-22||a.top<D.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN||O<1&&V<1?!1:(O<D.DEFAULT_MINIMUM_VISIBLE_OPTIONS&&V>O&&this.options.length>O?(this._dropDownPosition=1,this.selectDropDownContainer.removeChild(this.selectDropDownListContainer),this.selectDropDownContainer.removeChild(this.selectionDetailsPane),this.selectDropDownContainer.appendChild(this.selectionDetailsPane),this.selectDropDownContainer.appendChild(this.selectDropDownListContainer),this.selectionDetailsPane.classList.remove("border-top"),this.selectionDetailsPane.classList.add("border-bottom")):(this._dropDownPosition=0,this.selectDropDownContainer.removeChild(this.selectDropDownListContainer),this.selectDropDownContainer.removeChild(this.selectionDetailsPane),this.selectDropDownContainer.appendChild(this.selectDropDownListContainer),this.selectDropDownContainer.appendChild(this.selectionDetailsPane),this.selectionDetailsPane.classList.remove("border-bottom"),this.selectionDetailsPane.classList.add("border-top")),!0);if(a.top+a.height>window.innerHeight-22||a.top<D.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN||this._dropDownPosition===0&&O<1||this._dropDownPosition===1&&V<1)return this.hideSelectDropDown(!0),!1;if(this._dropDownPosition===0){if(this._isVisible&&O+V<1)return this.hideSelectDropDown(!0),!1;h>S&&(c=O*this.getHeight())}else h>A&&(c=V*this.getHeight());return this.selectList.layout(c),this.selectList.domFocus(),this.selectList.length>0&&(this.selectList.setFocus([this.selected||0]),this.selectList.reveal(this.selectList.getFocus()[0]||0)),this._hasDetails?(this.selectList.getHTMLElement().style.height=c+b+"px",this.selectDropDownContainer.style.height=""):this.selectDropDownContainer.style.height=c+b+"px",this.updateDetail(this.selected),this.selectDropDownContainer.style.width=n,this.selectDropDownListContainer.setAttribute("tabindex","0"),this.selectElement.classList.add("synthetic-focus"),this.selectDropDownContainer.classList.add("synthetic-focus"),!0}else return!1}setWidthControlElement(_){let a=0;if(_){let o=0,b=0;this.options.forEach((S,A)=>{const C=S.detail?S.detail.length:0,r=S.decoratorRight?S.decoratorRight.length:0,n=S.text.length+C+r;n>b&&(o=A,b=n)}),_.textContent=this.options[o].text+(this.options[o].decoratorRight?this.options[o].decoratorRight+" ":""),a=y.getTotalWidth(_)}return a}createSelectList(_){if(this.selectList)return;this.selectDropDownListContainer=y.append(_,s(".select-box-dropdown-list-container")),this.listRenderer=new p,this.selectList=new E.List("SelectBoxCustom",this.selectDropDownListContainer,this,[this.listRenderer],{useShadows:!1,verticalScrollMode:3,keyboardSupport:!1,mouseSupport:!1,accessibilityProvider:{getAriaLabel:b=>{let S=b.text;return b.detail&&(S+=`. ${b.detail}`),b.decoratorRight&&(S+=`. ${b.decoratorRight}`),b.description&&(S+=`. ${b.description}`),S},getWidgetAriaLabel:()=>(0,l.localize)(0,null),getRole:()=>"option",getWidgetRole:()=>"listbox"}}),this.selectBoxOptions.ariaLabel&&(this.selectList.ariaLabel=this.selectBoxOptions.ariaLabel);const a=this._register(new i.DomEmitter(this.selectDropDownListContainer,"keydown")),o=m.Event.chain(a.event).filter(()=>this.selectList.length>0).map(b=>new B.StandardKeyboardEvent(b));this._register(o.filter(b=>b.keyCode===3).on(b=>this.onEnter(b),this)),this._register(o.filter(b=>b.keyCode===2).on(b=>this.onEnter(b),this)),this._register(o.filter(b=>b.keyCode===9).on(b=>this.onEscape(b),this)),this._register(o.filter(b=>b.keyCode===16).on(b=>this.onUpArrow(b),this)),this._register(o.filter(b=>b.keyCode===18).on(b=>this.onDownArrow(b),this)),this._register(o.filter(b=>b.keyCode===12).on(this.onPageDown,this)),this._register(o.filter(b=>b.keyCode===11).on(this.onPageUp,this)),this._register(o.filter(b=>b.keyCode===14).on(this.onHome,this)),this._register(o.filter(b=>b.keyCode===13).on(this.onEnd,this)),this._register(o.filter(b=>b.keyCode>=21&&b.keyCode<=56||b.keyCode>=80&&b.keyCode<=108).on(this.onCharacter,this)),this._register(y.addDisposableListener(this.selectList.getHTMLElement(),y.EventType.POINTER_UP,b=>this.onPointerUp(b))),this._register(this.selectList.onMouseOver(b=>typeof b.index!="undefined"&&this.selectList.setFocus([b.index]))),this._register(this.selectList.onDidChangeFocus(b=>this.onListFocus(b))),this._register(y.addDisposableListener(this.selectDropDownContainer,y.EventType.FOCUS_OUT,b=>{!this._isVisible||y.isAncestor(b.relatedTarget,this.selectDropDownContainer)||this.onListBlur()})),this.selectList.getHTMLElement().setAttribute("aria-label",this.selectBoxOptions.ariaLabel||""),this.selectList.getHTMLElement().setAttribute("aria-expanded","true"),this.styleList()}onPointerUp(_){if(!this.selectList.length)return;y.EventHelper.stop(_);const a=_.target;if(!a||a.classList.contains("slider"))return;const o=a.closest(".monaco-list-row");if(!o)return;const b=Number(o.getAttribute("data-index")),S=o.classList.contains("option-disabled");b>=0&&b<this.options.length&&!S&&(this.selected=b,this.select(this.selected),this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selectList.getFocus()[0]),this.selected!==this._currentSelection&&(this._currentSelection=this.selected,this._onDidSelect.fire({index:this.selectElement.selectedIndex,selected:this.options[this.selected].text}),!!this.options[this.selected]&&!!this.options[this.selected].text&&(this.selectElement.title=this.options[this.selected].text)),this.hideSelectDropDown(!0))}onListBlur(){this._sticky||(this.selected!==this._currentSelection&&this.select(this._currentSelection),this.hideSelectDropDown(!1))}renderDescriptionMarkdown(_,a){const o=S=>{for(let A=0;A<S.childNodes.length;A++){const C=S.childNodes.item(A);(C.tagName&&C.tagName.toLowerCase())==="img"?S.removeChild(C):o(C)}},b=(0,M.renderMarkdown)({value:_},{actionHandler:a});return b.element.classList.add("select-box-description-markdown"),o(b.element),b.element}onListFocus(_){!this._isVisible||!this._hasDetails||this.updateDetail(_.indexes[0])}updateDetail(_){this.selectionDetailsPane.innerText="";const a=this.options[_],o=a?.description??"",b=a?.descriptionIsMarkdown??!1;if(o){if(b){const S=a.descriptionMarkdownActionHandler;this.selectionDetailsPane.appendChild(this.renderDescriptionMarkdown(o,S))}else this.selectionDetailsPane.innerText=o;this.selectionDetailsPane.style.display="block"}else this.selectionDetailsPane.style.display="none";this._skipLayout=!0,this.contextViewProvider.layout(),this._skipLayout=!1}onEscape(_){y.EventHelper.stop(_),this.select(this._currentSelection),this.hideSelectDropDown(!0)}onEnter(_){y.EventHelper.stop(_),this.selected!==this._currentSelection&&(this._currentSelection=this.selected,this._onDidSelect.fire({index:this.selectElement.selectedIndex,selected:this.options[this.selected].text}),!!this.options[this.selected]&&!!this.options[this.selected].text&&(this.selectElement.title=this.options[this.selected].text)),this.hideSelectDropDown(!0)}onDownArrow(_){if(this.selected<this.options.length-1){y.EventHelper.stop(_,!0);const a=this.options[this.selected+1].isDisabled;if(a&&this.options.length>this.selected+2)this.selected+=2;else{if(a)return;this.selected++}this.select(this.selected),this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selectList.getFocus()[0])}}onUpArrow(_){this.selected>0&&(y.EventHelper.stop(_,!0),this.options[this.selected-1].isDisabled&&this.selected>1?this.selected-=2:this.selected--,this.select(this.selected),this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selectList.getFocus()[0]))}onPageUp(_){y.EventHelper.stop(_),this.selectList.focusPreviousPage(),setTimeout(()=>{this.selected=this.selectList.getFocus()[0],this.options[this.selected].isDisabled&&this.selected<this.options.length-1&&(this.selected++,this.selectList.setFocus([this.selected])),this.selectList.reveal(this.selected),this.select(this.selected)},1)}onPageDown(_){y.EventHelper.stop(_),this.selectList.focusNextPage(),setTimeout(()=>{this.selected=this.selectList.getFocus()[0],this.options[this.selected].isDisabled&&this.selected>0&&(this.selected--,this.selectList.setFocus([this.selected])),this.selectList.reveal(this.selected),this.select(this.selected)},1)}onHome(_){y.EventHelper.stop(_),!(this.options.length<2)&&(this.selected=0,this.options[this.selected].isDisabled&&this.selected>1&&this.selected++,this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selected),this.select(this.selected))}onEnd(_){y.EventHelper.stop(_),!(this.options.length<2)&&(this.selected=this.options.length-1,this.options[this.selected].isDisabled&&this.selected>1&&this.selected--,this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selected),this.select(this.selected))}onCharacter(_){const a=f.KeyCodeUtils.toString(_.keyCode);let o=-1;for(let b=0;b<this.options.length-1;b++)if(o=(b+this.selected+1)%this.options.length,this.options[o].text.charAt(0).toUpperCase()===a&&!this.options[o].isDisabled){this.select(o),this.selectList.setFocus([o]),this.selectList.reveal(this.selectList.getFocus()[0]),y.EventHelper.stop(_);break}}dispose(){this.hideSelectDropDown(!1),super.dispose()}}t.SelectBoxList=D,D.DEFAULT_DROPDOWN_MINIMUM_BOTTOM_MARGIN=32,D.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN=2,D.DEFAULT_MINIMUM_VISIBLE_OPTIONS=3}),define(me[123],pe([1,0,122,116,17,24,27,5,90]),function(J,t,y,i,B,M,E,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBox=t.defaultStyles=void 0,t.defaultStyles={selectBackground:M.Color.fromHex("#3C3C3C"),selectForeground:M.Color.fromHex("#F0F0F0"),selectBorder:M.Color.fromHex("#3C3C3C")};class m extends B.Widget{constructor(g,F,l,s=(0,E.deepClone)(t.defaultStyles),e){super();w.isMacintosh&&!e?.useCustomDrawn?this.selectBoxDelegate=new i.SelectBoxNative(g,F,s,e):this.selectBoxDelegate=new y.SelectBoxList(g,F,l,s,e),this._register(this.selectBoxDelegate)}get onDidSelect(){return this.selectBoxDelegate.onDidSelect}setOptions(g,F){this.selectBoxDelegate.setOptions(g,F)}select(g){this.selectBoxDelegate.select(g)}setAriaLabel(g){this.selectBoxDelegate.setAriaLabel(g)}focus(){this.selectBoxDelegate.focus()}blur(){this.selectBoxDelegate.blur()}setFocusable(g){this.selectBoxDelegate.setFocusable(g)}render(g){this.selectBoxDelegate.render(g)}style(g){this.selectBoxDelegate.style(g)}applyStyles(){this.selectBoxDelegate.applyStyles()}}t.SelectBox=m}),define(me[60],pe([1,0,15,50,4,22,121,123,32,2,5,6,95,46]),function(J,t,y,i,B,M,E,w,m,f,g,F,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectActionViewItem=t.ActionViewItem=t.BaseActionViewItem=void 0;class s extends f.Disposable{constructor(v,_,a={}){super();this.options=a,this._context=v||this,this._action=_,_ instanceof m.Action&&this._register(_.onDidChange(o=>{!this.element||this.handleActionChangeEvent(o)}))}get action(){return this._action}handleActionChangeEvent(v){v.enabled!==void 0&&this.updateEnabled(),v.checked!==void 0&&this.updateChecked(),v.class!==void 0&&this.updateClass(),v.label!==void 0&&(this.updateLabel(),this.updateTooltip()),v.tooltip!==void 0&&this.updateTooltip()}get actionRunner(){return this._actionRunner||(this._actionRunner=this._register(new m.ActionRunner)),this._actionRunner}set actionRunner(v){this._actionRunner=v}isEnabled(){return this._action.enabled}setActionContext(v){this._context=v}render(v){const _=this.element=v;this._register(M.Gesture.addTarget(v));const a=this.options&&this.options.draggable;a&&(v.draggable=!0,y.isFirefox&&this._register((0,B.addDisposableListener)(v,B.EventType.DRAG_START,o=>o.dataTransfer?.setData(i.DataTransfers.TEXT,this._action.label)))),this._register((0,B.addDisposableListener)(_,M.EventType.Tap,o=>this.onClick(o,!0))),this._register((0,B.addDisposableListener)(_,B.EventType.MOUSE_DOWN,o=>{a||B.EventHelper.stop(o,!0),this._action.enabled&&o.button===0&&_.classList.add("active")})),g.isMacintosh&&this._register((0,B.addDisposableListener)(_,B.EventType.CONTEXT_MENU,o=>{o.button===0&&o.ctrlKey===!0&&this.onClick(o)})),this._register((0,B.addDisposableListener)(_,B.EventType.CLICK,o=>{B.EventHelper.stop(o,!0),this.options&&this.options.isMenu||this.onClick(o)})),this._register((0,B.addDisposableListener)(_,B.EventType.DBLCLICK,o=>{B.EventHelper.stop(o,!0)})),[B.EventType.MOUSE_UP,B.EventType.MOUSE_OUT].forEach(o=>{this._register((0,B.addDisposableListener)(_,o,b=>{B.EventHelper.stop(b),_.classList.remove("active")}))})}onClick(v,_=!1){B.EventHelper.stop(v,!0);const a=F.isUndefinedOrNull(this._context)?this.options?.useEventAsContext?v:{preserveFocus:_}:this._context;this.actionRunner.run(this._action,a)}focus(){this.element&&(this.element.tabIndex=0,this.element.focus(),this.element.classList.add("focused"))}isFocused(){return!!this.element?.classList.contains("focused")}blur(){this.element&&(this.element.blur(),this.element.tabIndex=-1,this.element.classList.remove("focused"))}setFocusable(v){this.element&&(this.element.tabIndex=v?0:-1)}get trapsArrowNavigation(){return!1}updateEnabled(){}updateLabel(){}getTooltip(){return this.action.tooltip}updateTooltip(){if(!this.element)return;const v=this.getTooltip()??"";this.updateAriaLabel(),this.options.hoverDelegate?(this.element.title="",this.customHover?this.customHover.update(v):(this.customHover=(0,E.setupCustomHover)(this.options.hoverDelegate,this.element,v),this._store.add(this.customHover))):this.element.title=v}updateAriaLabel(){if(this.element){const v=this.getTooltip()??"";this.element.setAttribute("aria-label",v)}}updateClass(){}updateChecked(){}dispose(){this.element&&(this.element.remove(),this.element=void 0),super.dispose()}}t.BaseActionViewItem=s;class e extends s{constructor(v,_,a={}){super(v,_,a);this.options=a,this.options.icon=a.icon!==void 0?a.icon:!1,this.options.label=a.label!==void 0?a.label:!0,this.cssClass=""}render(v){super.render(v),this.element&&(this.label=(0,B.append)(this.element,(0,B.$)("a.action-label"))),this.label&&(this._action.id===m.Separator.ID?this.label.setAttribute("role","presentation"):this.options.isMenu?this.label.setAttribute("role","menuitem"):this.label.setAttribute("role","button")),this.options.label&&this.options.keybinding&&this.element&&((0,B.append)(this.element,(0,B.$)("span.keybinding")).textContent=this.options.keybinding),this.updateClass(),this.updateLabel(),this.updateTooltip(),this.updateEnabled(),this.updateChecked()}focus(){this.label&&(this.label.tabIndex=0,this.label.focus())}isFocused(){return!!this.label&&this.label?.tabIndex===0}blur(){this.label&&(this.label.tabIndex=-1)}setFocusable(v){this.label&&(this.label.tabIndex=v?0:-1)}updateLabel(){this.options.label&&this.label&&(this.label.textContent=this.action.label)}getTooltip(){let v=null;return this.action.tooltip?v=this.action.tooltip:!this.options.label&&this.action.label&&this.options.icon&&(v=this.action.label,this.options.keybinding&&(v=l.localize(0,null,v,this.options.keybinding))),v??void 0}updateClass(){this.cssClass&&this.label&&this.label.classList.remove(...this.cssClass.split(" ")),this.options.icon?(this.cssClass=this.action.class,this.label&&(this.label.classList.add("codicon"),this.cssClass&&this.label.classList.add(...this.cssClass.split(" "))),this.updateEnabled()):this.label?.classList.remove("codicon")}updateEnabled(){this.action.enabled?(this.label&&(this.label.removeAttribute("aria-disabled"),this.label.classList.remove("disabled")),this.element?.classList.remove("disabled")):(this.label&&(this.label.setAttribute("aria-disabled","true"),this.label.classList.add("disabled")),this.element?.classList.add("disabled"))}updateAriaLabel(){if(this.label){const v=this.getTooltip()??"";this.label.setAttribute("aria-label",v)}}updateChecked(){this.label&&(this.action.checked?this.label.classList.add("checked"):this.label.classList.remove("checked"))}}t.ActionViewItem=e;class p extends s{constructor(v,_,a,o,b,S){super(v,_);this.selectBox=new w.SelectBox(a,o,b,void 0,S),this.selectBox.setFocusable(!1),this._register(this.selectBox),this.registerListeners()}setOptions(v,_){this.selectBox.setOptions(v,_)}select(v){this.selectBox.select(v)}registerListeners(){this._register(this.selectBox.onDidSelect(v=>{this.actionRunner.run(this._action,this.getActionContext(v.selected,v.index))}))}getActionContext(v,_){return v}setFocusable(v){this.selectBox.setFocusable(v)}focus(){this.selectBox?.focus()}blur(){this.selectBox?.blur()}render(v){this.selectBox.render(v)}}t.SelectActionViewItem=p}),define(me[61],pe([1,0,4,19,60,32,3,2,6,46]),function(J,t,y,i,B,M,E,w,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prepareActions=t.ActionBar=t.ActionsOrientation=void 0;var f;(function(l){l[l.HORIZONTAL=0]="HORIZONTAL",l[l.VERTICAL=1]="VERTICAL"})(f=t.ActionsOrientation||(t.ActionsOrientation={}));class g extends w.Disposable{constructor(s,e={}){super();this.triggerKeyDown=!1,this.focusable=!0,this._onDidBlur=this._register(new E.Emitter),this.onDidBlur=this._onDidBlur.event,this._onDidCancel=this._register(new E.Emitter({onFirstListenerAdd:()=>this.cancelHasListener=!0})),this.onDidCancel=this._onDidCancel.event,this.cancelHasListener=!1,this._onDidRun=this._register(new E.Emitter),this.onDidRun=this._onDidRun.event,this._onBeforeRun=this._register(new E.Emitter),this.onBeforeRun=this._onBeforeRun.event,this.options=e,this._context=e.context??null,this._orientation=this.options.orientation??0,this._triggerKeys={keyDown:this.options.triggerKeys?.keyDown??!1,keys:this.options.triggerKeys?.keys??[3,10]},this.options.actionRunner?this._actionRunner=this.options.actionRunner:(this._actionRunner=new M.ActionRunner,this._register(this._actionRunner)),this._register(this._actionRunner.onDidRun(v=>this._onDidRun.fire(v))),this._register(this._actionRunner.onBeforeRun(v=>this._onBeforeRun.fire(v))),this._actionIds=[],this.viewItems=[],this.viewItemDisposables=new Map,this.focusedItem=void 0,this.domNode=document.createElement("div"),this.domNode.className="monaco-action-bar",e.animated!==!1&&this.domNode.classList.add("animated");let p,D;switch(this._orientation){case 0:p=[15],D=[17];break;case 1:p=[16],D=[18],this.domNode.className+=" vertical";break}this._register(y.addDisposableListener(this.domNode,y.EventType.KEY_DOWN,v=>{const _=new i.StandardKeyboardEvent(v);let a=!0;const o=typeof this.focusedItem=="number"?this.viewItems[this.focusedItem]:void 0;p&&(_.equals(p[0])||_.equals(p[1]))?a=this.focusPrevious():D&&(_.equals(D[0])||_.equals(D[1]))?a=this.focusNext():_.equals(9)&&this.cancelHasListener?this._onDidCancel.fire():_.equals(14)?a=this.focusFirst():_.equals(13)?a=this.focusLast():_.equals(2)&&o instanceof B.BaseActionViewItem&&o.trapsArrowNavigation?a=this.focusNext():this.isTriggerKeyEvent(_)?this._triggerKeys.keyDown?this.doTrigger(_):this.triggerKeyDown=!0:a=!1,a&&(_.preventDefault(),_.stopPropagation())})),this._register(y.addDisposableListener(this.domNode,y.EventType.KEY_UP,v=>{const _=new i.StandardKeyboardEvent(v);this.isTriggerKeyEvent(_)?(!this._triggerKeys.keyDown&&this.triggerKeyDown&&(this.triggerKeyDown=!1,this.doTrigger(_)),_.preventDefault(),_.stopPropagation()):(_.equals(2)||_.equals(1024|2))&&this.updateFocusedItem()})),this.focusTracker=this._register(y.trackFocus(this.domNode)),this._register(this.focusTracker.onDidBlur(()=>{(y.getActiveElement()===this.domNode||!y.isAncestor(y.getActiveElement(),this.domNode))&&(this._onDidBlur.fire(),this.focusedItem=void 0,this.previouslyFocusedItem=void 0,this.triggerKeyDown=!1)})),this._register(this.focusTracker.onDidFocus(()=>this.updateFocusedItem())),this.actionsList=document.createElement("ul"),this.actionsList.className="actions-container",this.actionsList.setAttribute("role",this.options.ariaRole||"toolbar"),this.options.ariaLabel&&this.actionsList.setAttribute("aria-label",this.options.ariaLabel),this.domNode.appendChild(this.actionsList),s.appendChild(this.domNode)}refreshRole(){this.length()>=2?this.actionsList.setAttribute("role",this.options.ariaRole||"toolbar"):this.actionsList.setAttribute("role","presentation")}setAriaLabel(s){s?this.actionsList.setAttribute("aria-label",s):this.actionsList.removeAttribute("aria-label")}setFocusable(s){if(this.focusable=s,this.focusable){const e=this.viewItems.find(p=>p instanceof B.BaseActionViewItem&&p.isEnabled());e instanceof B.BaseActionViewItem&&e.setFocusable(!0)}else this.viewItems.forEach(e=>{e instanceof B.BaseActionViewItem&&e.setFocusable(!1)})}isTriggerKeyEvent(s){let e=!1;return this._triggerKeys.keys.forEach(p=>{e=e||s.equals(p)}),e}updateFocusedItem(){for(let s=0;s<this.actionsList.children.length;s++){const e=this.actionsList.children[s];if(y.isAncestor(y.getActiveElement(),e)){this.focusedItem=s;break}}}get context(){return this._context}set context(s){this._context=s,this.viewItems.forEach(e=>e.setActionContext(s))}get actionRunner(){return this._actionRunner}set actionRunner(s){s&&(this._actionRunner=s,this.viewItems.forEach(e=>e.actionRunner=s))}getContainer(){return this.domNode}hasAction(s){return this._actionIds.includes(s.id)}getAction(s){return this.viewItems[s].action}push(s,e={}){const p=Array.isArray(s)?s:[s];let D=m.isNumber(e.index)?e.index:null;p.forEach(v=>{const _=document.createElement("li");_.className="action-item",_.setAttribute("role","presentation");let a;this.options.actionViewItemProvider&&(a=this.options.actionViewItemProvider(v)),a||(a=new B.ActionViewItem(this.context,v,{hoverDelegate:this.options.hoverDelegate,...e})),this.options.allowContextMenu||this.viewItemDisposables.set(a,y.addDisposableListener(_,y.EventType.CONTEXT_MENU,o=>{y.EventHelper.stop(o,!0)})),a.actionRunner=this._actionRunner,a.setActionContext(this.context),a.render(_),this.focusable&&a instanceof B.BaseActionViewItem&&this.viewItems.length===0&&a.setFocusable(!0),D===null||D<0||D>=this.actionsList.children.length?(this.actionsList.appendChild(_),this.viewItems.push(a),this._actionIds.push(v.id)):(this.actionsList.insertBefore(_,this.actionsList.children[D]),this.viewItems.splice(D,0,a),this._actionIds.splice(D,0,v.id),D++)}),typeof this.focusedItem=="number"&&this.focus(this.focusedItem),this.refreshRole()}getWidth(s){if(s>=0&&s<this.actionsList.children.length){const e=this.actionsList.children.item(s);if(e)return e.clientWidth}return 0}getHeight(s){if(s>=0&&s<this.actionsList.children.length){const e=this.actionsList.children.item(s);if(e)return e.clientHeight}return 0}pull(s){s>=0&&s<this.viewItems.length&&(this.actionsList.removeChild(this.actionsList.childNodes[s]),this.viewItemDisposables.get(this.viewItems[s])?.dispose(),this.viewItemDisposables.delete(this.viewItems[s]),(0,w.dispose)(this.viewItems.splice(s,1)),this._actionIds.splice(s,1),this.refreshRole())}clear(){(0,w.dispose)(this.viewItems),this.viewItemDisposables.forEach(s=>s.dispose()),this.viewItemDisposables.clear(),this.viewItems=[],this._actionIds=[],y.clearNode(this.actionsList),this.refreshRole()}length(){return this.viewItems.length}isEmpty(){return this.viewItems.length===0}focus(s){let e=!1,p;if(s===void 0?e=!0:typeof s=="number"?p=s:typeof s=="boolean"&&(e=s),e&&typeof this.focusedItem=="undefined"){const D=this.viewItems.findIndex(v=>v.isEnabled());this.focusedItem=D===-1?void 0:D,this.updateFocus(void 0,void 0,!0)}else p!==void 0&&(this.focusedItem=p),this.updateFocus(void 0,void 0,!0)}focusFirst(){return this.focusedItem=this.length()-1,this.focusNext(!0)}focusLast(){return this.focusedItem=0,this.focusPrevious(!0)}focusNext(s){if(typeof this.focusedItem=="undefined")this.focusedItem=this.viewItems.length-1;else if(this.viewItems.length<=1)return!1;const e=this.focusedItem;let p;do{if(!s&&this.options.preventLoopNavigation&&this.focusedItem+1>=this.viewItems.length)return this.focusedItem=e,!1;this.focusedItem=(this.focusedItem+1)%this.viewItems.length,p=this.viewItems[this.focusedItem]}while(this.focusedItem!==e&&(this.options.focusOnlyEnabledItems&&!p.isEnabled()||p.action.id===M.Separator.ID));return this.updateFocus(),!0}focusPrevious(s){if(typeof this.focusedItem=="undefined")this.focusedItem=0;else if(this.viewItems.length<=1)return!1;const e=this.focusedItem;let p;do{if(this.focusedItem=this.focusedItem-1,this.focusedItem<0){if(!s&&this.options.preventLoopNavigation)return this.focusedItem=e,!1;this.focusedItem=this.viewItems.length-1}p=this.viewItems[this.focusedItem]}while(this.focusedItem!==e&&(this.options.focusOnlyEnabledItems&&!p.isEnabled()||p.action.id===M.Separator.ID));return this.updateFocus(!0),!0}updateFocus(s,e,p=!1){typeof this.focusedItem=="undefined"&&this.actionsList.focus({preventScroll:e}),this.previouslyFocusedItem!==void 0&&this.previouslyFocusedItem!==this.focusedItem&&this.viewItems[this.previouslyFocusedItem]?.blur();const D=this.focusedItem!==void 0&&this.viewItems[this.focusedItem];if(D){let v=!0;m.isFunction(D.focus)||(v=!1),this.options.focusOnlyEnabledItems&&m.isFunction(D.isEnabled)&&!D.isEnabled()&&(v=!1),D.action.id===M.Separator.ID&&(v=!1),v?(p||this.previouslyFocusedItem!==this.focusedItem)&&(D.focus(s),this.previouslyFocusedItem=this.focusedItem):(this.actionsList.focus({preventScroll:e}),this.previouslyFocusedItem=void 0)}}doTrigger(s){if(typeof this.focusedItem=="undefined")return;const e=this.viewItems[this.focusedItem];if(e instanceof B.BaseActionViewItem){const p=e._context===null||e._context===void 0?s:e._context;this.run(e._action,p)}}async run(s,e){await this._actionRunner.run(s,e)}dispose(){(0,w.dispose)(this.viewItems),this.viewItems=[],this._actionIds=[],this.getContainer().remove(),super.dispose()}}t.ActionBar=g;function F(l){if(!l.length)return l;let s=-1;for(let p=0;p<l.length;p++)if(l[p].id!==M.Separator.ID){s=p;break}if(s===-1)return[];l=l.slice(s);for(let p=l.length-1;p>=0&&l[p].id===M.Separator.ID;p--)l.splice(p,1);let e=!1;for(let p=l.length-1;p>=0;p--){const D=l[p].id===M.Separator.ID;D&&!e?l.splice(p,1):D?D&&(e=!1):e=!0}return l}t.prepareActions=F}),define(me[124],pe([1,0,4,18,51,61,53,56,17,24,3,77,27,99,87]),function(J,t,y,i,B,M,E,w,m,f,g,F,l,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HistoryInputBox=t.InputBox=t.MessageType=void 0;const e=y.$;var p;(function(a){a[a.INFO=1]="INFO",a[a.WARNING=2]="WARNING",a[a.ERROR=3]="ERROR"})(p=t.MessageType||(t.MessageType={}));const D={inputBackground:f.Color.fromHex("#3C3C3C"),inputForeground:f.Color.fromHex("#CCCCCC"),inputValidationInfoBorder:f.Color.fromHex("#55AAFF"),inputValidationInfoBackground:f.Color.fromHex("#063B49"),inputValidationWarningBorder:f.Color.fromHex("#B89500"),inputValidationWarningBackground:f.Color.fromHex("#352A05"),inputValidationErrorBorder:f.Color.fromHex("#BE1100"),inputValidationErrorBackground:f.Color.fromHex("#5A1D1D")};class v extends m.Widget{constructor(o,b,S){super();this.state="idle",this.maxHeight=Number.POSITIVE_INFINITY,this._onDidChange=this._register(new g.Emitter),this.onDidChange=this._onDidChange.event,this._onDidHeightChange=this._register(new g.Emitter),this.onDidHeightChange=this._onDidHeightChange.event,this.contextViewProvider=b,this.options=S||Object.create(null),(0,l.mixin)(this.options,D,!1),this.message=null,this.placeholder=this.options.placeholder||"",this.tooltip=this.options.tooltip??(this.placeholder||""),this.ariaLabel=this.options.ariaLabel||"",this.inputBackground=this.options.inputBackground,this.inputForeground=this.options.inputForeground,this.inputBorder=this.options.inputBorder,this.inputValidationInfoBorder=this.options.inputValidationInfoBorder,this.inputValidationInfoBackground=this.options.inputValidationInfoBackground,this.inputValidationInfoForeground=this.options.inputValidationInfoForeground,this.inputValidationWarningBorder=this.options.inputValidationWarningBorder,this.inputValidationWarningBackground=this.options.inputValidationWarningBackground,this.inputValidationWarningForeground=this.options.inputValidationWarningForeground,this.inputValidationErrorBorder=this.options.inputValidationErrorBorder,this.inputValidationErrorBackground=this.options.inputValidationErrorBackground,this.inputValidationErrorForeground=this.options.inputValidationErrorForeground,this.options.validationOptions&&(this.validation=this.options.validationOptions.validation),this.element=y.append(o,e(".monaco-inputbox.idle"));const A=this.options.flexibleHeight?"textarea":"input",C=y.append(this.element,e(".ibwrapper"));if(this.input=y.append(C,e(A+".input.empty")),this.input.setAttribute("autocorrect","off"),this.input.setAttribute("autocapitalize","off"),this.input.setAttribute("spellcheck","false"),this.onfocus(this.input,()=>this.element.classList.add("synthetic-focus")),this.onblur(this.input,()=>this.element.classList.remove("synthetic-focus")),this.options.flexibleHeight){this.maxHeight=typeof this.options.flexibleMaxHeight=="number"?this.options.flexibleMaxHeight:Number.POSITIVE_INFINITY,this.mirror=y.append(C,e("div.mirror")),this.mirror.innerText="\xA0",this.scrollableElement=new w.ScrollableElement(this.element,{vertical:1}),this.options.flexibleWidth&&(this.input.setAttribute("wrap","off"),this.mirror.style.whiteSpace="pre",this.mirror.style.wordWrap="initial"),y.append(o,this.scrollableElement.getDomNode()),this._register(this.scrollableElement),this._register(this.scrollableElement.onScroll(c=>this.input.scrollTop=c.scrollTop));const r=this._register(new i.DomEmitter(document,"selectionchange")),n=g.Event.filter(r.event,()=>document.getSelection()?.anchorNode===C);this._register(n(this.updateScrollDimensions,this)),this._register(this.onDidHeightChange(this.updateScrollDimensions,this))}else this.input.type=this.options.type||"text",this.input.setAttribute("wrap","off");this.ariaLabel&&this.input.setAttribute("aria-label",this.ariaLabel),this.placeholder&&!this.options.showPlaceholderOnFocus&&this.setPlaceHolder(this.placeholder),this.tooltip&&this.setTooltip(this.tooltip),this.oninput(this.input,()=>this.onValueChange()),this.onblur(this.input,()=>this.onBlur()),this.onfocus(this.input,()=>this.onFocus()),this.ignoreGesture(this.input),setTimeout(()=>this.updateMirror(),0),this.options.actions&&(this.actionbar=this._register(new M.ActionBar(this.element)),this.actionbar.push(this.options.actions,{icon:!0,label:!1})),this.applyStyles()}onBlur(){this._hideMessage(),this.options.showPlaceholderOnFocus&&this.input.setAttribute("placeholder","")}onFocus(){this._showMessage(),this.options.showPlaceholderOnFocus&&this.input.setAttribute("placeholder",this.placeholder||"")}setPlaceHolder(o){this.placeholder=o,this.input.setAttribute("placeholder",o)}setTooltip(o){this.tooltip=o,this.input.title=o}setAriaLabel(o){this.ariaLabel=o,o?this.input.setAttribute("aria-label",this.ariaLabel):this.input.removeAttribute("aria-label")}getAriaLabel(){return this.ariaLabel}get mirrorElement(){return this.mirror}get inputElement(){return this.input}get value(){return this.input.value}set value(o){this.input.value!==o&&(this.input.value=o,this.onValueChange())}get height(){return typeof this.cachedHeight=="number"?this.cachedHeight:y.getTotalHeight(this.element)}focus(){this.input.focus()}blur(){this.input.blur()}hasFocus(){return document.activeElement===this.input}select(o=null){this.input.select(),o&&(this.input.setSelectionRange(o.start,o.end),o.end===this.input.value.length&&(this.input.scrollLeft=this.input.scrollWidth))}isSelectionAtEnd(){return this.input.selectionEnd===this.input.value.length&&this.input.selectionStart===this.input.selectionEnd}enable(){this.input.removeAttribute("disabled")}disable(){this.blur(),this.input.disabled=!0,this._hideMessage()}setEnabled(o){o?this.enable():this.disable()}get width(){return y.getTotalWidth(this.input)}set width(o){if(this.options.flexibleHeight&&this.options.flexibleWidth){let b=0;if(this.mirror){const S=parseFloat(this.mirror.style.paddingLeft||"")||0,A=parseFloat(this.mirror.style.paddingRight||"")||0;b=S+A}this.input.style.width=o-b+"px"}else this.input.style.width=o+"px";this.mirror&&(this.mirror.style.width=o+"px")}set paddingRight(o){this.input.style.width=`calc(100% - ${o}px)`,this.mirror&&(this.mirror.style.paddingRight=o+"px")}updateScrollDimensions(){if(typeof this.cachedContentHeight!="number"||typeof this.cachedHeight!="number"||!this.scrollableElement)return;const o=this.cachedContentHeight,b=this.cachedHeight,S=this.input.scrollTop;this.scrollableElement.setScrollDimensions({scrollHeight:o,height:b}),this.scrollableElement.setScrollPosition({scrollTop:S})}showMessage(o,b){this.message=o,this.element.classList.remove("idle"),this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add(this.classForType(o.type));const S=this.stylesForType(this.message.type);this.element.style.border=S.border?`1px solid ${S.border}`:"",(this.hasFocus()||b)&&this._showMessage()}hideMessage(){this.message=null,this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add("idle"),this._hideMessage(),this.applyStyles()}isInputValid(){return!!this.validation&&!this.validation(this.value)}validate(){let o=null;return this.validation&&(o=this.validation(this.value),o?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(o)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),o?.type}stylesForType(o){switch(o){case 1:return{border:this.inputValidationInfoBorder,background:this.inputValidationInfoBackground,foreground:this.inputValidationInfoForeground};case 2:return{border:this.inputValidationWarningBorder,background:this.inputValidationWarningBackground,foreground:this.inputValidationWarningForeground};default:return{border:this.inputValidationErrorBorder,background:this.inputValidationErrorBackground,foreground:this.inputValidationErrorForeground}}}classForType(o){switch(o){case 1:return"info";case 2:return"warning";default:return"error"}}_showMessage(){if(!this.contextViewProvider||!this.message)return;let o;const b=()=>o.style.width=y.getTotalWidth(this.element)+"px";this.contextViewProvider.showContextView({getAnchor:()=>this.element,anchorAlignment:1,render:A=>{if(!this.message)return null;o=y.append(A,e(".monaco-inputbox-container")),b();const C={inline:!0,className:"monaco-inputbox-message"},r=this.message.formatContent?(0,B.renderFormattedText)(this.message.content,C):(0,B.renderText)(this.message.content,C);r.classList.add(this.classForType(this.message.type));const n=this.stylesForType(this.message.type);return r.style.backgroundColor=n.background?n.background.toString():"",r.style.color=n.foreground?n.foreground.toString():"",r.style.border=n.border?`1px solid ${n.border}`:"",y.append(o,r),null},onHide:()=>{this.state="closed"},layout:b});let S;this.message.type===3?S=s.localize(0,null,this.message.content):this.message.type===2?S=s.localize(1,null,this.message.content):S=s.localize(2,null,this.message.content),E.alert(S),this.state="open"}_hideMessage(){!this.contextViewProvider||(this.state==="open"&&this.contextViewProvider.hideContextView(),this.state="idle")}onValueChange(){this._onDidChange.fire(this.value),this.validate(),this.updateMirror(),this.input.classList.toggle("empty",!this.value),this.state==="open"&&this.contextViewProvider&&this.contextViewProvider.layout()}updateMirror(){if(!this.mirror)return;const o=this.value,S=o.charCodeAt(o.length-1)===10?" ":"";(o+S).replace(/\u000c/g,"")?this.mirror.textContent=o+S:this.mirror.innerText="\xA0",this.layout()}style(o){this.inputBackground=o.inputBackground,this.inputForeground=o.inputForeground,this.inputBorder=o.inputBorder,this.inputValidationInfoBackground=o.inputValidationInfoBackground,this.inputValidationInfoForeground=o.inputValidationInfoForeground,this.inputValidationInfoBorder=o.inputValidationInfoBorder,this.inputValidationWarningBackground=o.inputValidationWarningBackground,this.inputValidationWarningForeground=o.inputValidationWarningForeground,this.inputValidationWarningBorder=o.inputValidationWarningBorder,this.inputValidationErrorBackground=o.inputValidationErrorBackground,this.inputValidationErrorForeground=o.inputValidationErrorForeground,this.inputValidationErrorBorder=o.inputValidationErrorBorder,this.applyStyles()}applyStyles(){const o=this.inputBackground?this.inputBackground.toString():"",b=this.inputForeground?this.inputForeground.toString():"",S=this.inputBorder?this.inputBorder.toString():"";this.element.style.backgroundColor=o,this.element.style.color=b,this.input.style.backgroundColor="inherit",this.input.style.color=b,this.element.style.borderWidth=S?"1px":"",this.element.style.borderStyle=S?"solid":"",this.element.style.borderColor=S}layout(){if(!this.mirror)return;const o=this.cachedContentHeight;this.cachedContentHeight=y.getTotalHeight(this.mirror),o!==this.cachedContentHeight&&(this.cachedHeight=Math.min(this.cachedContentHeight,this.maxHeight),this.input.style.height=this.cachedHeight+"px",this._onDidHeightChange.fire(this.cachedContentHeight))}insertAtCursor(o){const b=this.inputElement,S=b.selectionStart,A=b.selectionEnd,C=b.value;S!==null&&A!==null&&(this.value=C.substr(0,S)+o+C.substr(A),b.setSelectionRange(S+1,S+1),this.layout())}dispose(){this._hideMessage(),this.message=null,this.actionbar?.dispose(),super.dispose()}}t.InputBox=v;class _ extends v{constructor(o,b,S){const A=s.localize(3,null),C=` or \u21C5 ${A}`,r=` (\u21C5 ${A})`;super(o,b,S);this._onDidFocus=this._register(new g.Emitter),this.onDidFocus=this._onDidFocus.event,this._onDidBlur=this._register(new g.Emitter),this.onDidBlur=this._onDidBlur.event,this.history=new F.HistoryNavigator(S.history,100);const n=()=>{if(S.showHistoryHint&&S.showHistoryHint()&&!this.placeholder.endsWith(C)&&!this.placeholder.endsWith(r)&&this.history.getHistory().length){const c=this.placeholder.endsWith(")")?C:r,u=this.placeholder+c;S.showPlaceholderOnFocus&&document.activeElement!==this.input?this.placeholder=u:this.setPlaceHolder(u)}};this.observer=new MutationObserver((c,u)=>{c.forEach(h=>{h.target.textContent||n()})}),this.observer.observe(this.input,{attributeFilter:["class"]}),this.onfocus(this.input,()=>n()),this.onblur(this.input,()=>{const c=u=>{if(this.placeholder.endsWith(u)){const h=this.placeholder.slice(0,this.placeholder.length-u.length);return S.showPlaceholderOnFocus?this.placeholder=h:this.setPlaceHolder(h),!0}else return!1};c(r)||c(C)})}dispose(){super.dispose(),this.observer&&(this.observer.disconnect(),this.observer=void 0)}addToHistory(){this.value&&this.value!==this.getCurrentValue()&&this.history.add(this.value)}getHistory(){return this.history.getHistory()}showNextValue(){this.history.has(this.value)||this.addToHistory();let o=this.getNextValue();o&&(o=o===this.value?this.getNextValue():o),o&&(this.value=o,E.status(this.value))}showPreviousValue(){this.history.has(this.value)||this.addToHistory();let o=this.getPreviousValue();o&&(o=o===this.value?this.getPreviousValue():o),o&&(this.value=o,E.status(this.value))}clearHistory(){this.history.clear()}onBlur(){super.onBlur(),this._onDidBlur.fire()}onFocus(){super.onFocus(),this._onDidFocus.fire()}getCurrentValue(){let o=this.history.current();return o||(o=this.history.last(),this.history.next()),o}getPreviousValue(){return this.history.previous()||this.history.first()}getNextValue(){return this.history.next()||this.history.last()}}t.HistoryInputBox=_}),define(me[62],pe([1,0,60,17,11,24,3,92]),function(J,t,y,i,B,M,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Checkbox=t.Toggle=t.ToggleActionViewItem=void 0;const w={inputActiveOptionBorder:M.Color.fromHex("#007ACC00"),inputActiveOptionForeground:M.Color.fromHex("#FFFFFF"),inputActiveOptionBackground:M.Color.fromHex("#0E639C50")};class m extends y.BaseActionViewItem{constructor(l,s,e){super(l,s,e);this.toggle=this._register(new f({actionClassName:this._action.class,isChecked:!!this._action.checked,title:this.options.keybinding?`${this._action.label} (${this.options.keybinding})`:this._action.label,notFocusable:!0})),this._register(this.toggle.onChange(()=>this._action.checked=!!this.toggle&&this.toggle.checked))}render(l){this.element=l,this.element.appendChild(this.toggle.domNode)}updateEnabled(){this.toggle&&(this.isEnabled()?this.toggle.enable():this.toggle.disable())}updateChecked(){this.toggle.checked=!!this._action.checked}focus(){this.toggle.domNode.tabIndex=0,this.toggle.focus()}blur(){this.toggle.domNode.tabIndex=-1,this.toggle.domNode.blur()}setFocusable(l){this.toggle.domNode.tabIndex=l?0:-1}}t.ToggleActionViewItem=m;class f extends i.Widget{constructor(l){super();this._onChange=this._register(new E.Emitter),this.onChange=this._onChange.event,this._onKeyDown=this._register(new E.Emitter),this.onKeyDown=this._onKeyDown.event,this._opts={...w,...l},this._checked=this._opts.isChecked;const s=["monaco-custom-toggle"];this._opts.icon&&(this._icon=this._opts.icon,s.push(...B.CSSIcon.asClassNameArray(this._icon))),this._opts.actionClassName&&s.push(...this._opts.actionClassName.split(" ")),this._checked&&s.push("checked"),this.domNode=document.createElement("div"),this.domNode.title=this._opts.title,this.domNode.classList.add(...s),this._opts.notFocusable||(this.domNode.tabIndex=0),this.domNode.setAttribute("role","checkbox"),this.domNode.setAttribute("aria-checked",String(this._checked)),this.domNode.setAttribute("aria-label",this._opts.title),this.applyStyles(),this.onclick(this.domNode,e=>{this.enabled&&(this.checked=!this._checked,this._onChange.fire(!1),e.preventDefault())}),this.ignoreGesture(this.domNode),this.onkeydown(this.domNode,e=>{if(e.keyCode===10||e.keyCode===3){this.checked=!this._checked,this._onChange.fire(!0),e.preventDefault(),e.stopPropagation();return}this._onKeyDown.fire(e)})}get enabled(){return this.domNode.getAttribute("aria-disabled")!=="true"}focus(){this.domNode.focus()}get checked(){return this._checked}set checked(l){this._checked=l,this.domNode.setAttribute("aria-checked",String(this._checked)),this.domNode.classList.toggle("checked",this._checked),this.applyStyles()}setIcon(l){this._icon&&this.domNode.classList.remove(...B.CSSIcon.asClassNameArray(this._icon)),this._icon=l,this._icon&&this.domNode.classList.add(...B.CSSIcon.asClassNameArray(this._icon))}width(){return 2+2+2+16}style(l){l.inputActiveOptionBorder&&(this._opts.inputActiveOptionBorder=l.inputActiveOptionBorder),l.inputActiveOptionForeground&&(this._opts.inputActiveOptionForeground=l.inputActiveOptionForeground),l.inputActiveOptionBackground&&(this._opts.inputActiveOptionBackground=l.inputActiveOptionBackground),this.applyStyles()}applyStyles(){this.domNode&&(this.domNode.style.borderColor=this._checked&&this._opts.inputActiveOptionBorder?this._opts.inputActiveOptionBorder.toString():"",this.domNode.style.color=this._checked&&this._opts.inputActiveOptionForeground?this._opts.inputActiveOptionForeground.toString():"inherit",this.domNode.style.backgroundColor=this._checked&&this._opts.inputActiveOptionBackground?this._opts.inputActiveOptionBackground.toString():"")}enable(){this.domNode.setAttribute("aria-disabled",String(!1))}disable(){this.domNode.setAttribute("aria-disabled",String(!0))}setTitle(l){this.domNode.title=l,this.domNode.setAttribute("aria-label",l)}}t.Toggle=f;class g extends i.Widget{constructor(l,s){super();this.title=l,this.isChecked=s,this.checkbox=new f({title:this.title,isChecked:this.isChecked,icon:B.Codicon.check,actionClassName:"monaco-checkbox"}),this.domNode=this.checkbox.domNode,this.styles={},this.checkbox.onChange(()=>{this.applyStyles()})}get checked(){return this.checkbox.checked}set checked(l){this.checkbox.checked=l,this.applyStyles()}focus(){this.domNode.focus()}hasFocus(){return this.domNode===document.activeElement}style(l){this.styles=l,this.applyStyles()}applyStyles(){this.domNode.style.color=this.styles.checkboxForeground?this.styles.checkboxForeground.toString():"",this.domNode.style.backgroundColor=this.styles.checkboxBackground?this.styles.checkboxBackground.toString():"",this.domNode.style.borderColor=this.styles.checkboxBorder?this.styles.checkboxBorder.toString():""}}t.Checkbox=g}),define(me[125],pe([1,0,62,11,97]),function(J,t,y,i,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RegexToggle=t.WholeWordsToggle=t.CaseSensitiveToggle=void 0;const M=B.localize(0,null),E=B.localize(1,null),w=B.localize(2,null);class m extends y.Toggle{constructor(l){super({icon:i.Codicon.caseSensitive,title:M+l.appendTitle,isChecked:l.isChecked,inputActiveOptionBorder:l.inputActiveOptionBorder,inputActiveOptionForeground:l.inputActiveOptionForeground,inputActiveOptionBackground:l.inputActiveOptionBackground})}}t.CaseSensitiveToggle=m;class f extends y.Toggle{constructor(l){super({icon:i.Codicon.wholeWord,title:E+l.appendTitle,isChecked:l.isChecked,inputActiveOptionBorder:l.inputActiveOptionBorder,inputActiveOptionForeground:l.inputActiveOptionForeground,inputActiveOptionBackground:l.inputActiveOptionBackground})}}t.WholeWordsToggle=f;class g extends y.Toggle{constructor(l){super({icon:i.Codicon.regex,title:w+l.appendTitle,isChecked:l.isChecked,inputActiveOptionBorder:l.inputActiveOptionBorder,inputActiveOptionForeground:l.inputActiveOptionForeground,inputActiveOptionBackground:l.inputActiveOptionBackground})}}t.RegexToggle=g}),define(me[126],pe([1,0,4,125,124,17,3,96,86]),function(J,t,y,i,B,M,E,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FindInput=void 0;const m=w.localize(0,null);class f extends M.Widget{constructor(F,l,s,e){super();this._showOptionButtons=s,this.fixFocusOnOptionClickEnabled=!0,this.imeSessionInProgress=!1,this.additionalToggles=[],this._onDidOptionChange=this._register(new E.Emitter),this.onDidOptionChange=this._onDidOptionChange.event,this._onKeyDown=this._register(new E.Emitter),this.onKeyDown=this._onKeyDown.event,this._onMouseDown=this._register(new E.Emitter),this.onMouseDown=this._onMouseDown.event,this._onInput=this._register(new E.Emitter),this.onInput=this._onInput.event,this._onKeyUp=this._register(new E.Emitter),this.onKeyUp=this._onKeyUp.event,this._onCaseSensitiveKeyDown=this._register(new E.Emitter),this.onCaseSensitiveKeyDown=this._onCaseSensitiveKeyDown.event,this._onRegexKeyDown=this._register(new E.Emitter),this.onRegexKeyDown=this._onRegexKeyDown.event,this._lastHighlightFindOptions=0,this.contextViewProvider=l,this.placeholder=e.placeholder||"",this.validation=e.validation,this.label=e.label||m,this.inputActiveOptionBorder=e.inputActiveOptionBorder,this.inputActiveOptionForeground=e.inputActiveOptionForeground,this.inputActiveOptionBackground=e.inputActiveOptionBackground,this.inputBackground=e.inputBackground,this.inputForeground=e.inputForeground,this.inputBorder=e.inputBorder,this.inputValidationInfoBorder=e.inputValidationInfoBorder,this.inputValidationInfoBackground=e.inputValidationInfoBackground,this.inputValidationInfoForeground=e.inputValidationInfoForeground,this.inputValidationWarningBorder=e.inputValidationWarningBorder,this.inputValidationWarningBackground=e.inputValidationWarningBackground,this.inputValidationWarningForeground=e.inputValidationWarningForeground,this.inputValidationErrorBorder=e.inputValidationErrorBorder,this.inputValidationErrorBackground=e.inputValidationErrorBackground,this.inputValidationErrorForeground=e.inputValidationErrorForeground;const p=e.appendCaseSensitiveLabel||"",D=e.appendWholeWordsLabel||"",v=e.appendRegexLabel||"",_=e.history||[],a=!!e.flexibleHeight,o=!!e.flexibleWidth,b=e.flexibleMaxHeight;this.domNode=document.createElement("div"),this.domNode.classList.add("monaco-findInput"),this.inputBox=this._register(new B.HistoryInputBox(this.domNode,this.contextViewProvider,{placeholder:this.placeholder||"",ariaLabel:this.label||"",validationOptions:{validation:this.validation},inputBackground:this.inputBackground,inputForeground:this.inputForeground,inputBorder:this.inputBorder,inputValidationInfoBackground:this.inputValidationInfoBackground,inputValidationInfoForeground:this.inputValidationInfoForeground,inputValidationInfoBorder:this.inputValidationInfoBorder,inputValidationWarningBackground:this.inputValidationWarningBackground,inputValidationWarningForeground:this.inputValidationWarningForeground,inputValidationWarningBorder:this.inputValidationWarningBorder,inputValidationErrorBackground:this.inputValidationErrorBackground,inputValidationErrorForeground:this.inputValidationErrorForeground,inputValidationErrorBorder:this.inputValidationErrorBorder,history:_,showHistoryHint:e.showHistoryHint,flexibleHeight:a,flexibleWidth:o,flexibleMaxHeight:b})),this.regex=this._register(new i.RegexToggle({appendTitle:v,isChecked:!1,inputActiveOptionBorder:this.inputActiveOptionBorder,inputActiveOptionForeground:this.inputActiveOptionForeground,inputActiveOptionBackground:this.inputActiveOptionBackground})),this._register(this.regex.onChange(A=>{this._onDidOptionChange.fire(A),!A&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus(),this.validate()})),this._register(this.regex.onKeyDown(A=>{this._onRegexKeyDown.fire(A)})),this.wholeWords=this._register(new i.WholeWordsToggle({appendTitle:D,isChecked:!1,inputActiveOptionBorder:this.inputActiveOptionBorder,inputActiveOptionForeground:this.inputActiveOptionForeground,inputActiveOptionBackground:this.inputActiveOptionBackground})),this._register(this.wholeWords.onChange(A=>{this._onDidOptionChange.fire(A),!A&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus(),this.validate()})),this.caseSensitive=this._register(new i.CaseSensitiveToggle({appendTitle:p,isChecked:!1,inputActiveOptionBorder:this.inputActiveOptionBorder,inputActiveOptionForeground:this.inputActiveOptionForeground,inputActiveOptionBackground:this.inputActiveOptionBackground})),this._register(this.caseSensitive.onChange(A=>{this._onDidOptionChange.fire(A),!A&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus(),this.validate()})),this._register(this.caseSensitive.onKeyDown(A=>{this._onCaseSensitiveKeyDown.fire(A)}));const S=[this.caseSensitive.domNode,this.wholeWords.domNode,this.regex.domNode];this.onkeydown(this.domNode,A=>{if(A.equals(15)||A.equals(17)||A.equals(9)){const C=S.indexOf(document.activeElement);if(C>=0){let r=-1;A.equals(17)?r=(C+1)%S.length:A.equals(15)&&(C===0?r=S.length-1:r=C-1),A.equals(9)?(S[C].blur(),this.inputBox.focus()):r>=0&&S[r].focus(),y.EventHelper.stop(A,!0)}}}),this.controls=document.createElement("div"),this.controls.className="controls",this.controls.style.display=this._showOptionButtons?"block":"none",this.controls.appendChild(this.caseSensitive.domNode),this.controls.appendChild(this.wholeWords.domNode),this.controls.appendChild(this.regex.domNode),this._showOptionButtons||(this.caseSensitive.domNode.style.display="none",this.wholeWords.domNode.style.display="none",this.regex.domNode.style.display="none");for(const A of e?.additionalToggles??[])this._register(A),this.controls.appendChild(A.domNode),this._register(A.onChange(C=>{this._onDidOptionChange.fire(C),!C&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus()})),this.additionalToggles.push(A);this.additionalToggles.length>0&&(this.controls.style.display="block"),this.inputBox.paddingRight=(this._showOptionButtons?this.caseSensitive.width()+this.wholeWords.width()+this.regex.width():0)+this.additionalToggles.reduce((A,C)=>A+C.width(),0),this.domNode.appendChild(this.controls),F?.appendChild(this.domNode),this._register(y.addDisposableListener(this.inputBox.inputElement,"compositionstart",A=>{this.imeSessionInProgress=!0})),this._register(y.addDisposableListener(this.inputBox.inputElement,"compositionend",A=>{this.imeSessionInProgress=!1,this._onInput.fire()})),this.onkeydown(this.inputBox.inputElement,A=>this._onKeyDown.fire(A)),this.onkeyup(this.inputBox.inputElement,A=>this._onKeyUp.fire(A)),this.oninput(this.inputBox.inputElement,A=>this._onInput.fire()),this.onmousedown(this.inputBox.inputElement,A=>this._onMouseDown.fire(A))}get isImeSessionInProgress(){return this.imeSessionInProgress}get onDidChange(){return this.inputBox.onDidChange}enable(){this.domNode.classList.remove("disabled"),this.inputBox.enable(),this.regex.enable(),this.wholeWords.enable(),this.caseSensitive.enable();for(const F of this.additionalToggles)F.enable()}disable(){this.domNode.classList.add("disabled"),this.inputBox.disable(),this.regex.disable(),this.wholeWords.disable(),this.caseSensitive.disable();for(const F of this.additionalToggles)F.disable()}setFocusInputOnOptionClick(F){this.fixFocusOnOptionClickEnabled=F}setEnabled(F){F?this.enable():this.disable()}clear(){this.clearValidation(),this.setValue(""),this.focus()}getValue(){return this.inputBox.value}setValue(F){this.inputBox.value!==F&&(this.inputBox.value=F)}onSearchSubmit(){this.inputBox.addToHistory()}style(F){this.inputActiveOptionBorder=F.inputActiveOptionBorder,this.inputActiveOptionForeground=F.inputActiveOptionForeground,this.inputActiveOptionBackground=F.inputActiveOptionBackground,this.inputBackground=F.inputBackground,this.inputForeground=F.inputForeground,this.inputBorder=F.inputBorder,this.inputValidationInfoBackground=F.inputValidationInfoBackground,this.inputValidationInfoForeground=F.inputValidationInfoForeground,this.inputValidationInfoBorder=F.inputValidationInfoBorder,this.inputValidationWarningBackground=F.inputValidationWarningBackground,this.inputValidationWarningForeground=F.inputValidationWarningForeground,this.inputValidationWarningBorder=F.inputValidationWarningBorder,this.inputValidationErrorBackground=F.inputValidationErrorBackground,this.inputValidationErrorForeground=F.inputValidationErrorForeground,this.inputValidationErrorBorder=F.inputValidationErrorBorder,this.applyStyles()}applyStyles(){if(this.domNode){const F={inputActiveOptionBorder:this.inputActiveOptionBorder,inputActiveOptionForeground:this.inputActiveOptionForeground,inputActiveOptionBackground:this.inputActiveOptionBackground};this.regex.style(F),this.wholeWords.style(F),this.caseSensitive.style(F);for(const s of this.additionalToggles)s.style(F);const l={inputBackground:this.inputBackground,inputForeground:this.inputForeground,inputBorder:this.inputBorder,inputValidationInfoBackground:this.inputValidationInfoBackground,inputValidationInfoForeground:this.inputValidationInfoForeground,inputValidationInfoBorder:this.inputValidationInfoBorder,inputValidationWarningBackground:this.inputValidationWarningBackground,inputValidationWarningForeground:this.inputValidationWarningForeground,inputValidationWarningBorder:this.inputValidationWarningBorder,inputValidationErrorBackground:this.inputValidationErrorBackground,inputValidationErrorForeground:this.inputValidationErrorForeground,inputValidationErrorBorder:this.inputValidationErrorBorder};this.inputBox.style(l)}}select(){this.inputBox.select()}focus(){this.inputBox.focus()}getCaseSensitive(){return this.caseSensitive.checked}setCaseSensitive(F){this.caseSensitive.checked=F}getWholeWords(){return this.wholeWords.checked}setWholeWords(F){this.wholeWords.checked=F}getRegex(){return this.regex.checked}setRegex(F){this.regex.checked=F,this.validate()}focusOnCaseSensitive(){this.caseSensitive.focus()}focusOnRegex(){this.regex.focus()}highlightFindOptions(){this.domNode.classList.remove("highlight-"+this._lastHighlightFindOptions),this._lastHighlightFindOptions=1-this._lastHighlightFindOptions,this.domNode.classList.add("highlight-"+this._lastHighlightFindOptions)}validate(){this.inputBox.validate()}showMessage(F){this.inputBox.showMessage(F)}clearMessage(){this.inputBox.hideMessage()}clearValidation(){this.inputBox.hideMessage()}}t.FindInput=f,f.OPTION_CHANGE="optionChange"}),define(me[127],pe([1,0,4,18,19,61,126,57,58,62,54,23,32,14,8,11,69,3,33,2,44,6,101,93]),function(J,t,y,i,B,M,E,w,m,f,g,F,l,s,e,p,D,v,_,a,o,b,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractTree=t.TreeFindMode=t.ModeToggle=t.RenderIndentGuides=t.AbstractTreeViewState=t.ComposedTreeDelegate=void 0;class A extends w.ElementsDragAndDropData{constructor(I){super(I.elements.map($=>$.element));this.data=I}set context(I){this.data.context=I}get context(){return this.data.context}}function C(te){return te instanceof w.ElementsDragAndDropData?new A(te):te}class r{constructor(I,$){this.modelProvider=I,this.dnd=$,this.autoExpandDisposable=a.Disposable.None}getDragURI(I){return this.dnd.getDragURI(I.element)}getDragLabel(I,$){if(this.dnd.getDragLabel)return this.dnd.getDragLabel(I.map(j=>j.element),$)}onDragStart(I,$){this.dnd.onDragStart?.(C(I),$)}onDragOver(I,$,j,H,d=!0){const L=this.dnd.onDragOver(C(I),$&&$.element,j,H),U=this.autoExpandNode!==$;if(U&&(this.autoExpandDisposable.dispose(),this.autoExpandNode=$),typeof $=="undefined")return L;if(U&&typeof L!="boolean"&&L.autoExpand&&(this.autoExpandDisposable=(0,e.disposableTimeout)(()=>{const z=this.modelProvider(),T=z.getNodeLocation($);z.isCollapsed(T)&&z.setCollapsed(T,!1),this.autoExpandNode=void 0},500)),typeof L=="boolean"||!L.accept||typeof L.bubble=="undefined"||L.feedback){if(!d){const z=typeof L=="boolean"?L:L.accept,T=typeof L=="boolean"?void 0:L.effect;return{accept:z,effect:T,feedback:[j]}}return L}if(L.bubble===1){const z=this.modelProvider(),T=z.getNodeLocation($),W=z.getParentNodeLocation(T),k=z.getNode(W),P=W&&z.getListIndex(W);return this.onDragOver(I,k,P,H,!1)}const K=this.modelProvider(),Q=K.getNodeLocation($),N=K.getListIndex(Q),R=K.getListRenderCount(Q);return{...L,feedback:(0,s.range)(N,N+R)}}drop(I,$,j,H){this.autoExpandDisposable.dispose(),this.autoExpandNode=void 0,this.dnd.drop(C(I),$&&$.element,j,H)}onDragEnd(I){this.dnd.onDragEnd?.(I)}}function n(te,I){return I&&{...I,identityProvider:I.identityProvider&&{getId($){return I.identityProvider.getId($.element)}},dnd:I.dnd&&new r(te,I.dnd),multipleSelectionController:I.multipleSelectionController&&{isSelectionSingleChangeEvent($){return I.multipleSelectionController.isSelectionSingleChangeEvent({...$,element:$.element})},isSelectionRangeChangeEvent($){return I.multipleSelectionController.isSelectionRangeChangeEvent({...$,element:$.element})}},accessibilityProvider:I.accessibilityProvider&&{...I.accessibilityProvider,getSetSize($){const j=te(),H=j.getNodeLocation($),d=j.getParentNodeLocation(H);return j.getNode(d).visibleChildrenCount},getPosInSet($){return $.visibleChildIndex+1},isChecked:I.accessibilityProvider&&I.accessibilityProvider.isChecked?$=>I.accessibilityProvider.isChecked($.element):void 0,getRole:I.accessibilityProvider&&I.accessibilityProvider.getRole?$=>I.accessibilityProvider.getRole($.element):()=>"treeitem",getAriaLabel($){return I.accessibilityProvider.getAriaLabel($.element)},getWidgetAriaLabel(){return I.accessibilityProvider.getWidgetAriaLabel()},getWidgetRole:I.accessibilityProvider&&I.accessibilityProvider.getWidgetRole?()=>I.accessibilityProvider.getWidgetRole():()=>"tree",getAriaLevel:I.accessibilityProvider&&I.accessibilityProvider.getAriaLevel?$=>I.accessibilityProvider.getAriaLevel($.element):$=>$.depth,getActiveDescendantId:I.accessibilityProvider.getActiveDescendantId&&($=>I.accessibilityProvider.getActiveDescendantId($.element))},keyboardNavigationLabelProvider:I.keyboardNavigationLabelProvider&&{...I.keyboardNavigationLabelProvider,getKeyboardNavigationLabel($){return I.keyboardNavigationLabelProvider.getKeyboardNavigationLabel($.element)}}}}class c{constructor(I){this.delegate=I}getHeight(I){return this.delegate.getHeight(I.element)}getTemplateId(I){return this.delegate.getTemplateId(I.element)}hasDynamicHeight(I){return!!this.delegate.hasDynamicHeight&&this.delegate.hasDynamicHeight(I.element)}setDynamicHeight(I,$){this.delegate.setDynamicHeight?.(I.element,$)}}t.ComposedTreeDelegate=c;class u{constructor(I){if(this.focus=new Set(I.focus),this.selection=new Set(I.selection),I.expanded instanceof Array){this.expanded=Object.create(null);for(const $ of I.expanded)this.expanded[$]=1}else this.expanded=I.expanded;this.expanded=I.expanded,this.scrollTop=I.scrollTop}static lift(I){return I instanceof u?I:new u(I)}static empty(I=0){return new u({focus:[],selection:[],expanded:Object.create(null),scrollTop:I})}toJSON(){return{focus:Array.from(this.focus),selection:Array.from(this.selection),expanded:this.expanded,scrollTop:this.scrollTop}}}t.AbstractTreeViewState=u;var h;(function(te){te.None="none",te.OnHover="onHover",te.Always="always"})(h=t.RenderIndentGuides||(t.RenderIndentGuides={}));class O{constructor(I,$=[]){this._elements=$,this.disposables=new a.DisposableStore,this.onDidChange=v.Event.forEach(I,j=>this._elements=j,this.disposables)}get elements(){return this._elements}dispose(){this.disposables.dispose()}}class V{constructor(I,$,j,H,d={}){this.renderer=I,this.modelProvider=$,this.activeNodes=H,this.renderedElements=new Map,this.renderedNodes=new Map,this.indent=V.DefaultIndent,this.hideTwistiesOfChildlessElements=!1,this.shouldRenderIndentGuides=!1,this.renderedIndentGuides=new D.SetMap,this.activeIndentNodes=new Set,this.indentGuidesDisposable=a.Disposable.None,this.disposables=new a.DisposableStore,this.templateId=I.templateId,this.updateOptions(d),v.Event.map(j,L=>L.node)(this.onDidChangeNodeTwistieState,this,this.disposables),I.onDidChangeTwistieState?.(this.onDidChangeTwistieState,this,this.disposables)}updateOptions(I={}){if(typeof I.indent!="undefined"&&(this.indent=(0,o.clamp)(I.indent,0,40)),typeof I.renderIndentGuides!="undefined"){const $=I.renderIndentGuides!==h.None;if($!==this.shouldRenderIndentGuides&&(this.shouldRenderIndentGuides=$,this.indentGuidesDisposable.dispose(),$)){const j=new a.DisposableStore;this.activeNodes.onDidChange(this._onDidChangeActiveNodes,this,j),this.indentGuidesDisposable=j,this._onDidChangeActiveNodes(this.activeNodes.elements)}}typeof I.hideTwistiesOfChildlessElements!="undefined"&&(this.hideTwistiesOfChildlessElements=I.hideTwistiesOfChildlessElements)}renderTemplate(I){const $=(0,y.append)(I,(0,y.$)(".monaco-tl-row")),j=(0,y.append)($,(0,y.$)(".monaco-tl-indent")),H=(0,y.append)($,(0,y.$)(".monaco-tl-twistie")),d=(0,y.append)($,(0,y.$)(".monaco-tl-contents")),L=this.renderer.renderTemplate(d);return{container:I,indent:j,twistie:H,indentGuidesDisposable:a.Disposable.None,templateData:L}}renderElement(I,$,j,H){typeof H=="number"&&(this.renderedNodes.set(I,{templateData:j,height:H}),this.renderedElements.set(I.element,I));const d=V.DefaultIndent+(I.depth-1)*this.indent;j.twistie.style.paddingLeft=`${d}px`,j.indent.style.width=`${d+this.indent-16}px`,this.renderTwistie(I,j),typeof H=="number"&&this.renderIndentGuides(I,j),this.renderer.renderElement(I,$,j.templateData,H)}disposeElement(I,$,j,H){j.indentGuidesDisposable.dispose(),this.renderer.disposeElement?.(I,$,j.templateData,H),typeof H=="number"&&(this.renderedNodes.delete(I),this.renderedElements.delete(I.element))}disposeTemplate(I){this.renderer.disposeTemplate(I.templateData)}onDidChangeTwistieState(I){const $=this.renderedElements.get(I);!$||this.onDidChangeNodeTwistieState($)}onDidChangeNodeTwistieState(I){const $=this.renderedNodes.get(I);!$||(this.renderTwistie(I,$.templateData),this._onDidChangeActiveNodes(this.activeNodes.elements),this.renderIndentGuides(I,$.templateData))}renderTwistie(I,$){$.twistie.classList.remove(...p.Codicon.treeItemExpanded.classNamesArray);let j=!1;this.renderer.renderTwistie&&(j=this.renderer.renderTwistie(I.element,$.twistie)),I.collapsible&&(!this.hideTwistiesOfChildlessElements||I.visibleChildrenCount>0)?(j||$.twistie.classList.add(...p.Codicon.treeItemExpanded.classNamesArray),$.twistie.classList.add("collapsible"),$.twistie.classList.toggle("collapsed",I.collapsed)):$.twistie.classList.remove("collapsible","collapsed"),I.collapsible?$.container.setAttribute("aria-expanded",String(!I.collapsed)):$.container.removeAttribute("aria-expanded")}renderIndentGuides(I,$){if((0,y.clearNode)($.indent),$.indentGuidesDisposable.dispose(),!this.shouldRenderIndentGuides)return;const j=new a.DisposableStore,H=this.modelProvider();let d=I;for(;;){const L=H.getNodeLocation(d),U=H.getParentNodeLocation(L);if(!U)break;const K=H.getNode(U),Q=(0,y.$)(".indent-guide",{style:`width: ${this.indent}px`});this.activeIndentNodes.has(K)&&Q.classList.add("active"),$.indent.childElementCount===0?$.indent.appendChild(Q):$.indent.insertBefore(Q,$.indent.firstElementChild),this.renderedIndentGuides.add(K,Q),j.add((0,a.toDisposable)(()=>this.renderedIndentGuides.delete(K,Q))),d=K}$.indentGuidesDisposable=j}_onDidChangeActiveNodes(I){if(!this.shouldRenderIndentGuides)return;const $=new Set,j=this.modelProvider();I.forEach(H=>{const d=j.getNodeLocation(H);try{const L=j.getParentNodeLocation(d);H.collapsible&&H.children.length>0&&!H.collapsed?$.add(H):L&&$.add(j.getNode(L))}catch{}}),this.activeIndentNodes.forEach(H=>{$.has(H)||this.renderedIndentGuides.forEach(H,d=>d.classList.remove("active"))}),$.forEach(H=>{this.activeIndentNodes.has(H)||this.renderedIndentGuides.forEach(H,d=>d.classList.add("active"))}),this.activeIndentNodes=$}dispose(){this.renderedNodes.clear(),this.renderedElements.clear(),this.indentGuidesDisposable.dispose(),(0,a.dispose)(this.disposables)}}V.DefaultIndent=8;class ue{constructor(I,$,j){this.tree=I,this.keyboardNavigationLabelProvider=$,this._filter=j,this._totalCount=0,this._matchCount=0,this._pattern="",this._lowercasePattern="",this.disposables=new a.DisposableStore,I.onWillRefilter(this.reset,this,this.disposables)}get totalCount(){return this._totalCount}get matchCount(){return this._matchCount}set pattern(I){this._pattern=I,this._lowercasePattern=I.toLowerCase()}filter(I,$){let j=1;if(this._filter){const L=this._filter.filter(I,$);if(typeof L=="boolean"?j=L?1:0:(0,g.isFilterResult)(L)?j=(0,g.getVisibleState)(L.visibility):j=L,j===0)return!1}if(this._totalCount++,!this._pattern)return this._matchCount++,{data:_.FuzzyScore.Default,visibility:j};const H=this.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(I),d=Array.isArray(H)?H:[H];for(const L of d){const U=L&&L.toString();if(typeof U=="undefined")return{data:_.FuzzyScore.Default,visibility:j};const K=(0,_.fuzzyScore)(this._pattern,this._lowercasePattern,0,U,U.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(K)return this._matchCount++,d.length===1?{data:K,visibility:j}:{data:{label:U,score:K},visibility:j}}return this.tree.findMode===ge.Filter?2:{data:_.FuzzyScore.Default,visibility:j}}reset(){this._totalCount=0,this._matchCount=0}dispose(){(0,a.dispose)(this.disposables)}}class ie extends f.Toggle{constructor(I){super({icon:p.Codicon.filter,title:(0,S.localize)(0,null),isChecked:I?.isChecked??!1,inputActiveOptionBorder:I?.inputActiveOptionBorder,inputActiveOptionForeground:I?.inputActiveOptionForeground,inputActiveOptionBackground:I?.inputActiveOptionBackground})}}t.ModeToggle=ie;var ge;(function(te){te[te.Highlight=0]="Highlight",te[te.Filter=1]="Filter"})(ge=t.TreeFindMode||(t.TreeFindMode={}));class ae extends a.Disposable{constructor(I,$,j,H,d){super();this.tree=$,this.elements=(0,y.h)(".monaco-tree-type-filter",[(0,y.h)(".monaco-tree-type-filter-grab.codicon.codicon-debug-gripper@grab",{tabIndex:0}),(0,y.h)(".monaco-tree-type-filter-input@findInput"),(0,y.h)(".monaco-tree-type-filter-actionbar@actionbar")]),this.width=0,this.right=0,this._onDidDisable=new v.Emitter,this.onDidDisable=this._onDidDisable.event,I.appendChild(this.elements.root),this._register((0,a.toDisposable)(()=>I.removeChild(this.elements.root))),this.modeToggle=this._register(new ie({...d,isChecked:H===ge.Filter})),this.onDidChangeMode=v.Event.map(this.modeToggle.onChange,()=>this.modeToggle.checked?ge.Filter:ge.Highlight,this._store),this.findInput=this._register(new E.FindInput(this.elements.findInput,j,!1,{label:(0,S.localize)(3,null),additionalToggles:[this.modeToggle]})),this.actionbar=this._register(new M.ActionBar(this.elements.actionbar)),this.mode=H;const L=this._register(new i.DomEmitter(this.findInput.inputBox.inputElement,"keydown")),U=this._register(v.Event.chain(L.event)).map(R=>new B.StandardKeyboardEvent(R)).event;this._register(U(R=>{switch(R.keyCode){case 18:R.preventDefault(),R.stopPropagation(),this.tree.domFocus();return}}));const K=this._register(new l.Action("close",(0,S.localize)(4,null),"codicon codicon-close",!0,()=>this.dispose()));this.actionbar.push(K,{icon:!0,label:!1});const Q=this._register(new i.DomEmitter(this.elements.grab,"mousedown"));this._register(Q.event(R=>{const z=new a.DisposableStore,T=z.add(new i.DomEmitter(window,"mousemove")),W=z.add(new i.DomEmitter(window,"mouseup")),k=this.right,P=R.pageX;this.elements.grab.classList.add("grabbing");const x=ee=>{const he=ee.pageX-P;this.right=k-he,this.layout()};z.add(T.event(x)),z.add(W.event(ee=>{x(ee),this.elements.grab.classList.remove("grabbing"),z.dispose()}))}));const N=this._register(v.Event.chain(this._register(new i.DomEmitter(this.elements.grab,"keydown")).event)).map(R=>new B.StandardKeyboardEvent(R)).event;this._register(N(R=>{let z;R.keyCode===15?z=Number.POSITIVE_INFINITY:R.keyCode===17?z=0:R.keyCode===10&&(z=this.right===0?Number.POSITIVE_INFINITY:0),z!==void 0&&(R.preventDefault(),R.stopPropagation(),this.right=z,this.layout())})),this.onDidChangeValue=this.findInput.onDidChange,this.style(d??{})}set mode(I){this.modeToggle.checked=I===ge.Filter,this.findInput.inputBox.setPlaceHolder(I===ge.Filter?(0,S.localize)(1,null):(0,S.localize)(2,null))}style(I){this.findInput.style(I),I.listFilterWidgetBackground&&(this.elements.root.style.backgroundColor=I.listFilterWidgetBackground.toString()),I.listFilterWidgetShadow&&(this.elements.root.style.boxShadow=`0 0 8px 2px ${I.listFilterWidgetShadow}`)}focus(){this.findInput.focus()}select(){this.findInput.select()}layout(I=this.width){this.width=I,this.right=(0,o.clamp)(this.right,0,Math.max(0,I-212)),this.elements.root.style.right=`${this.right}px`}showMessage(I){this.findInput.showMessage(I)}clearMessage(){this.findInput.clearMessage()}async dispose(){this._onDidDisable.fire(),this.elements.root.classList.add("disabled"),await(0,e.timeout)(300),super.dispose()}}class we{constructor(I,$,j,H,d){this.tree=I,this.view=j,this.filter=H,this.contextViewProvider=d,this._pattern="",this.width=0,this._onDidChangeMode=new v.Emitter,this.onDidChangeMode=this._onDidChangeMode.event,this._onDidChangePattern=new v.Emitter,this.onDidChangePattern=this._onDidChangePattern.event,this._onDidChangeOpenState=new v.Emitter,this.onDidChangeOpenState=this._onDidChangeOpenState.event,this.enabledDisposables=new a.DisposableStore,this.disposables=new a.DisposableStore,this._mode=I.options.defaultFindMode??ge.Highlight,$.onDidSplice(this.onDidSpliceModel,this,this.disposables)}get pattern(){return this._pattern}get mode(){return this._mode}set mode(I){I!==this._mode&&(this._mode=I,this.widget&&(this.widget.mode=this._mode),this.tree.refilter(),this.render(),this._onDidChangeMode.fire(I))}open(){if(this.widget){this.widget.focus(),this.widget.select();return}this.mode=this.tree.options.defaultFindMode??ge.Highlight,this.widget=new ae(this.view.getHTMLElement(),this.tree,this.contextViewProvider,this.mode,this.styles),this.enabledDisposables.add(this.widget),this.widget.onDidChangeValue(this.onDidChangeValue,this,this.enabledDisposables),this.widget.onDidChangeMode(I=>this.mode=I,void 0,this.enabledDisposables),this.widget.onDidDisable(this.close,this,this.enabledDisposables),this.widget.layout(this.width),this.widget.focus(),this._onDidChangeOpenState.fire(!0)}close(){!this.widget||(this.widget=void 0,this.enabledDisposables.dispose(),this.enabledDisposables=new a.DisposableStore,this.onDidChangeValue(""),this.tree.domFocus(),this._onDidChangeOpenState.fire(!1))}onDidChangeValue(I){this._pattern=I,this._onDidChangePattern.fire(I),this.filter.pattern=I,this.tree.refilter(),I&&this.tree.focusNext(0,!0,void 0,j=>!_.FuzzyScore.isDefault(j.filterData));const $=this.tree.getFocus();if($.length>0){const j=$[0];this.tree.getRelativeTop(j)===null&&this.tree.reveal(j,.5)}this.render()}onDidSpliceModel(){!this.widget||this.pattern.length===0||(this.tree.refilter(),this.render())}render(){const I=this.filter.totalCount>0&&this.filter.matchCount===0;this.pattern&&I?this.widget?.showMessage({type:2,content:(0,S.localize)(5,null)}):this.widget?.clearMessage()}shouldAllowFocus(I){return!this.widget||!this.pattern||this._mode===ge.Filter||this.filter.totalCount>0&&this.filter.matchCount<=1?!0:!_.FuzzyScore.isDefault(I.filterData)}style(I){this.styles=I,this.widget?.style(I)}layout(I){this.width=I,this.widget?.layout(I)}dispose(){this._onDidChangePattern.dispose(),this.enabledDisposables.dispose(),this.disposables.dispose()}}function ce(te){let I=F.TreeMouseEventTarget.Unknown;return(0,y.hasParentWithClass)(te.browserEvent.target,"monaco-tl-twistie","monaco-tl-row")?I=F.TreeMouseEventTarget.Twistie:(0,y.hasParentWithClass)(te.browserEvent.target,"monaco-tl-contents","monaco-tl-row")?I=F.TreeMouseEventTarget.Element:(0,y.hasParentWithClass)(te.browserEvent.target,"monaco-tree-type-filter","monaco-list")&&(I=F.TreeMouseEventTarget.Filter),{browserEvent:te.browserEvent,element:te.element?te.element.element:null,target:I}}function re(te){return{element:te.element?te.element.element:null,browserEvent:te.browserEvent,anchor:te.anchor}}function Ce(te,I){I(te),te.children.forEach($=>Ce($,I))}class Ie{constructor(I,$){this.getFirstViewElementWithTrait=I,this.identityProvider=$,this.nodes=[],this._onDidChange=new v.Emitter,this.onDidChange=this._onDidChange.event}get nodeSet(){return this._nodeSet||(this._nodeSet=this.createNodeSet()),this._nodeSet}set(I,$){!$?.__forceEvent&&(0,s.equals)(this.nodes,I)||this._set(I,!1,$)}_set(I,$,j){if(this.nodes=[...I],this.elements=void 0,this._nodeSet=void 0,!$){const H=this;this._onDidChange.fire({get elements(){return H.get()},browserEvent:j})}}get(){return this.elements||(this.elements=this.nodes.map(I=>I.element)),[...this.elements]}getNodes(){return this.nodes}has(I){return this.nodeSet.has(I)}onDidModelSplice({insertedNodes:I,deletedNodes:$}){if(!this.identityProvider){const K=this.createNodeSet(),Q=N=>K.delete(N);$.forEach(N=>Ce(N,Q)),this.set([...K.values()]);return}const j=new Set,H=K=>j.add(this.identityProvider.getId(K.element).toString());$.forEach(K=>Ce(K,H));const d=new Map,L=K=>d.set(this.identityProvider.getId(K.element).toString(),K);I.forEach(K=>Ce(K,L));const U=[];for(const K of this.nodes){const Q=this.identityProvider.getId(K.element).toString();if(!j.has(Q))U.push(K);else{const R=d.get(Q);R&&U.push(R)}}if(this.nodes.length>0&&U.length===0){const K=this.getFirstViewElementWithTrait();K&&U.push(K)}this._set(U,!0)}createNodeSet(){const I=new Set;for(const $ of this.nodes)I.add($);return I}}class ne extends m.MouseController{constructor(I,$){super(I);this.tree=$}onViewPointer(I){if((0,m.isButton)(I.browserEvent.target)||(0,m.isInputElement)(I.browserEvent.target)||(0,m.isMonacoEditor)(I.browserEvent.target))return;const $=I.element;if(!$)return super.onViewPointer(I);if(this.isSelectionRangeChangeEvent(I)||this.isSelectionSingleChangeEvent(I))return super.onViewPointer(I);const j=I.browserEvent.target,H=j.classList.contains("monaco-tl-twistie")||j.classList.contains("monaco-icon-label")&&j.classList.contains("folder-icon")&&I.browserEvent.offsetX<16;let d=!1;if(typeof this.tree.expandOnlyOnTwistieClick=="function"?d=this.tree.expandOnlyOnTwistieClick($.element):d=!!this.tree.expandOnlyOnTwistieClick,d&&!H&&I.browserEvent.detail!==2)return super.onViewPointer(I);if(!this.tree.expandOnDoubleClick&&I.browserEvent.detail===2)return super.onViewPointer(I);if($.collapsible){const L=this.tree.model,U=L.getNodeLocation($),K=I.browserEvent.altKey;if(this.tree.setFocus([U]),L.setCollapsed(U,void 0,K),d&&H)return}super.onViewPointer(I)}onDoubleClick(I){I.browserEvent.target.classList.contains("monaco-tl-twistie")||!this.tree.expandOnDoubleClick||super.onDoubleClick(I)}}class Z extends m.List{constructor(I,$,j,H,d,L,U,K){super(I,$,j,H,K);this.focusTrait=d,this.selectionTrait=L,this.anchorTrait=U}createMouseController(I){return new ne(this,I.tree)}splice(I,$,j=[]){if(super.splice(I,$,j),j.length===0)return;const H=[],d=[];let L;j.forEach((U,K)=>{this.focusTrait.has(U)&&H.push(I+K),this.selectionTrait.has(U)&&d.push(I+K),this.anchorTrait.has(U)&&(L=I+K)}),H.length>0&&super.setFocus((0,s.distinct)([...super.getFocus(),...H])),d.length>0&&super.setSelection((0,s.distinct)([...super.getSelection(),...d])),typeof L=="number"&&super.setAnchor(L)}setFocus(I,$,j=!1){super.setFocus(I,$),j||this.focusTrait.set(I.map(H=>this.element(H)),$)}setSelection(I,$,j=!1){super.setSelection(I,$),j||this.selectionTrait.set(I.map(H=>this.element(H)),$)}setAnchor(I,$=!1){super.setAnchor(I),$||(typeof I=="undefined"?this.anchorTrait.set([]):this.anchorTrait.set([this.element(I)]))}}class X{constructor(I,$,j,H,d={}){this._user=I,this._options=d,this.eventBufferer=new v.EventBufferer,this.onDidChangeFindOpenState=v.Event.None,this.disposables=new a.DisposableStore,this._onWillRefilter=new v.Emitter,this.onWillRefilter=this._onWillRefilter.event,this._onDidUpdateOptions=new v.Emitter,this.onDidUpdateOptions=this._onDidUpdateOptions.event;const L=new c(j),U=new v.Relay,K=new v.Relay,Q=this.disposables.add(new O(K.event));this.renderers=H.map(z=>new V(z,()=>this.model,U.event,Q,d));for(const z of this.renderers)this.disposables.add(z);let N;d.keyboardNavigationLabelProvider&&(N=new ue(this,d.keyboardNavigationLabelProvider,d.filter),d={...d,filter:N},this.disposables.add(N)),this.focus=new Ie(()=>this.view.getFocusedElements()[0],d.identityProvider),this.selection=new Ie(()=>this.view.getSelectedElements()[0],d.identityProvider),this.anchor=new Ie(()=>this.view.getAnchorElement(),d.identityProvider),this.view=new Z(I,$,L,this.renderers,this.focus,this.selection,this.anchor,{...n(()=>this.model,d),tree:this}),this.model=this.createModel(I,this.view,d),U.input=this.model.onDidChangeCollapseState;const R=v.Event.forEach(this.model.onDidSplice,z=>{this.eventBufferer.bufferEvents(()=>{this.focus.onDidModelSplice(z),this.selection.onDidModelSplice(z)})},this.disposables);if(R(()=>null,null,this.disposables),K.input=v.Event.chain(v.Event.any(R,this.focus.onDidChange,this.selection.onDidChange)).debounce(()=>null,0).map(()=>{const z=new Set;for(const T of this.focus.getNodes())z.add(T);for(const T of this.selection.getNodes())z.add(T);return[...z.values()]}).event,d.keyboardSupport!==!1){const z=v.Event.chain(this.view.onKeyDown).filter(T=>!(0,m.isInputElement)(T.target)).map(T=>new B.StandardKeyboardEvent(T));z.filter(T=>T.keyCode===15).on(this.onLeftArrow,this,this.disposables),z.filter(T=>T.keyCode===17).on(this.onRightArrow,this,this.disposables),z.filter(T=>T.keyCode===10).on(this.onSpace,this,this.disposables)}(d.findWidgetEnabled??!0)&&d.keyboardNavigationLabelProvider&&d.contextViewProvider?(this.findController=new we(this,this.model,this.view,N,d.contextViewProvider),this.focusNavigationFilter=z=>this.findController.shouldAllowFocus(z),this.onDidChangeFindOpenState=this.findController.onDidChangeOpenState,this.disposables.add(this.findController),this.onDidChangeFindMode=this.findController.onDidChangeMode):this.onDidChangeFindMode=v.Event.None,this.styleElement=(0,y.createStyleSheet)(this.view.getHTMLElement()),this.getHTMLElement().classList.toggle("always",this._options.renderIndentGuides===h.Always)}get onDidScroll(){return this.view.onDidScroll}get onDidChangeFocus(){return this.eventBufferer.wrapEvent(this.focus.onDidChange)}get onDidChangeSelection(){return this.eventBufferer.wrapEvent(this.selection.onDidChange)}get onMouseClick(){return v.Event.map(this.view.onMouseClick,ce)}get onMouseDblClick(){return v.Event.filter(v.Event.map(this.view.onMouseDblClick,ce),I=>I.target!==F.TreeMouseEventTarget.Filter)}get onContextMenu(){return v.Event.map(this.view.onContextMenu,re)}get onTap(){return v.Event.map(this.view.onTap,ce)}get onPointer(){return v.Event.map(this.view.onPointer,ce)}get onKeyDown(){return this.view.onKeyDown}get onKeyUp(){return this.view.onKeyUp}get onKeyPress(){return this.view.onKeyPress}get onDidFocus(){return this.view.onDidFocus}get onDidBlur(){return this.view.onDidBlur}get onDidChangeModel(){return v.Event.signal(this.model.onDidSplice)}get onDidChangeCollapseState(){return this.model.onDidChangeCollapseState}get onDidChangeRenderNodeCount(){return this.model.onDidChangeRenderNodeCount}get findMode(){return this.findController?.mode??ge.Highlight}set findMode(I){this.findController&&(this.findController.mode=I)}get onDidChangeFindPattern(){return this.findController?this.findController.onDidChangePattern:v.Event.None}get expandOnDoubleClick(){return typeof this._options.expandOnDoubleClick=="undefined"?!0:this._options.expandOnDoubleClick}get expandOnlyOnTwistieClick(){return typeof this._options.expandOnlyOnTwistieClick=="undefined"?!0:this._options.expandOnlyOnTwistieClick}get onDidDispose(){return this.view.onDidDispose}updateOptions(I={}){this._options={...this._options,...I};for(const $ of this.renderers)$.updateOptions(I);this.view.updateOptions(this._options),this._onDidUpdateOptions.fire(this._options),this.getHTMLElement().classList.toggle("always",this._options.renderIndentGuides===h.Always)}get options(){return this._options}updateWidth(I){const $=this.model.getListIndex(I);$!==-1&&this.view.updateWidth($)}getHTMLElement(){return this.view.getHTMLElement()}get contentHeight(){return this.view.contentHeight}get onDidChangeContentHeight(){return this.view.onDidChangeContentHeight}get scrollTop(){return this.view.scrollTop}set scrollTop(I){this.view.scrollTop=I}get scrollLeft(){return this.view.scrollLeft}set scrollLeft(I){this.view.scrollLeft=I}get scrollHeight(){return this.view.scrollHeight}get renderHeight(){return this.view.renderHeight}get firstVisibleElement(){const I=this.view.firstVisibleIndex;return I<0||I>=this.view.length?void 0:this.view.element(I).element}get lastVisibleElement(){const I=this.view.lastVisibleIndex;return this.view.element(I).element}get ariaLabel(){return this.view.ariaLabel}set ariaLabel(I){this.view.ariaLabel=I}domFocus(){this.view.domFocus()}isDOMFocused(){return this.getHTMLElement()===document.activeElement}layout(I,$){this.view.layout(I,$),(0,b.isNumber)($)&&this.findController?.layout($)}style(I){const $=`.${this.view.domId}`,j=[];I.treeIndentGuidesStroke&&(j.push(`.monaco-list${$}:hover .monaco-tl-indent > .indent-guide, .monaco-list${$}.always .monaco-tl-indent > .indent-guide  { border-color: ${I.treeIndentGuidesStroke.transparent(.4)}; }`),j.push(`.monaco-list${$} .monaco-tl-indent > .indent-guide.active { border-color: ${I.treeIndentGuidesStroke}; }`)),this.styleElement.textContent=j.join(`
`),this.findController?.style(I),this.view.style(I)}getParentElement(I){const $=this.model.getParentNodeLocation(I);return this.model.getNode($).element}getFirstElementChild(I){return this.model.getFirstElementChild(I)}getNode(I){return this.model.getNode(I)}collapse(I,$=!1){return this.model.setCollapsed(I,!0,$)}expand(I,$=!1){return this.model.setCollapsed(I,!1,$)}toggleCollapsed(I,$=!1){return this.model.setCollapsed(I,void 0,$)}expandAll(){this.model.setCollapsed(this.model.rootRef,!1,!0)}collapseAll(){this.model.setCollapsed(this.model.rootRef,!0,!0)}isCollapsible(I){return this.model.isCollapsible(I)}setCollapsible(I,$){return this.model.setCollapsible(I,$)}isCollapsed(I){return this.model.isCollapsed(I)}triggerTypeNavigation(){this.view.triggerTypeNavigation()}openFind(){this.findController?.open()}closeFind(){this.findController?.close()}refilter(){this._onWillRefilter.fire(void 0),this.model.refilter()}setAnchor(I){if(typeof I=="undefined")return this.view.setAnchor(void 0);const $=this.model.getNode(I);this.anchor.set([$]);const j=this.model.getListIndex(I);j>-1&&this.view.setAnchor(j,!0)}getAnchor(){return(0,s.firstOrDefault)(this.anchor.get(),void 0)}setSelection(I,$){const j=I.map(d=>this.model.getNode(d));this.selection.set(j,$);const H=I.map(d=>this.model.getListIndex(d)).filter(d=>d>-1);this.view.setSelection(H,$,!0)}getSelection(){return this.selection.get()}setFocus(I,$){const j=I.map(d=>this.model.getNode(d));this.focus.set(j,$);const H=I.map(d=>this.model.getListIndex(d)).filter(d=>d>-1);this.view.setFocus(H,$,!0)}focusNext(I=1,$=!1,j,H=this.focusNavigationFilter){this.view.focusNext(I,$,j,H)}focusPrevious(I=1,$=!1,j,H=this.focusNavigationFilter){this.view.focusPrevious(I,$,j,H)}focusNextPage(I,$=this.focusNavigationFilter){return this.view.focusNextPage(I,$)}focusPreviousPage(I,$=this.focusNavigationFilter){return this.view.focusPreviousPage(I,$)}focusLast(I,$=this.focusNavigationFilter){this.view.focusLast(I,$)}focusFirst(I,$=this.focusNavigationFilter){this.view.focusFirst(I,$)}getFocus(){return this.focus.get()}reveal(I,$){this.model.expandTo(I);const j=this.model.getListIndex(I);j!==-1&&this.view.reveal(j,$)}getRelativeTop(I){const $=this.model.getListIndex(I);return $===-1?null:this.view.getRelativeTop($)}getViewState(I=this.options.identityProvider){if(!I)throw new F.TreeError(this._user,"Can't get tree view state without an identity provider");const $=L=>I.getId(L).toString(),j=u.empty(this.scrollTop);for(const L of this.getFocus())j.focus.add($(L));for(const L of this.getSelection())j.selection.add($(L));const H=this.model.getNode(),d=[H];for(;d.length>0;){const L=d.shift();L!==H&&L.collapsible&&(j.expanded[$(L.element)]=L.collapsed?0:1),d.push(...L.children)}return j}onLeftArrow(I){I.preventDefault(),I.stopPropagation();const $=this.view.getFocusedElements();if($.length===0)return;const j=$[0],H=this.model.getNodeLocation(j);if(!this.model.setCollapsed(H,!0)){const L=this.model.getParentNodeLocation(H);if(!L)return;const U=this.model.getListIndex(L);this.view.reveal(U),this.view.setFocus([U])}}onRightArrow(I){I.preventDefault(),I.stopPropagation();const $=this.view.getFocusedElements();if($.length===0)return;const j=$[0],H=this.model.getNodeLocation(j);if(!this.model.setCollapsed(H,!1)){if(!j.children.some(K=>K.visible))return;const[L]=this.view.getFocus(),U=L+1;this.view.reveal(U),this.view.setFocus([U])}}onSpace(I){I.preventDefault(),I.stopPropagation();const $=this.view.getFocusedElements();if($.length===0)return;const j=$[0],H=this.model.getNodeLocation(j),d=I.browserEvent.altKey;this.model.setCollapsed(H,void 0,d)}navigate(I){return new se(this.view,this.model,I)}dispose(){(0,a.dispose)(this.disposables),this.view.dispose()}}t.AbstractTree=X;class se{constructor(I,$,j){this.view=I,this.model=$,j?this.index=this.model.getListIndex(j):this.index=-1}current(){return this.index<0||this.index>=this.view.length?null:this.view.element(this.index).element}previous(){return this.index--,this.current()}next(){return this.index++,this.current()}first(){return this.index=0,this.current()}last(){return this.index=this.view.length-1,this.current()}}}),define(me[128],pe([1,0,127,117,23,26]),function(J,t,y,i,B,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DataTree=void 0;class E extends y.AbstractTree{constructor(m,f,g,F,l,s={}){super(m,f,g,F,s);this.user=m,this.dataSource=l,this.nodesByIdentity=new Map,this.identityProvider=s.identityProvider}getInput(){return this.input}setInput(m,f){if(f&&!this.identityProvider)throw new B.TreeError(this.user,"Can't restore tree view state without an identity provider");if(this.input=m,!m){this.nodesByIdentity.clear(),this.model.setChildren(null,M.Iterable.empty());return}if(!f){this._refresh(m);return}const g=[],F=[],l=e=>{const p=this.identityProvider.getId(e).toString();return!f.expanded[p]},s=e=>{const p=this.identityProvider.getId(e.element).toString();f.focus.has(p)&&g.push(e.element),f.selection.has(p)&&F.push(e.element)};this._refresh(m,l,s),this.setFocus(g),this.setSelection(F),f&&typeof f.scrollTop=="number"&&(this.scrollTop=f.scrollTop)}updateChildren(m=this.input){if(typeof this.input=="undefined")throw new B.TreeError(this.user,"Tree input not set");let f;this.identityProvider&&(f=g=>{const F=this.identityProvider.getId(g).toString(),l=this.nodesByIdentity.get(F);if(!!l)return l.collapsed}),this._refresh(m,f)}resort(m=this.input,f=!0){this.model.resort(m===this.input?null:m,f)}refresh(m){if(m===void 0){this.view.rerender();return}this.model.rerender(m)}_refresh(m,f,g){let F;if(this.identityProvider){const l=new Set,s=g;g=e=>{const p=this.identityProvider.getId(e.element).toString();l.add(p),this.nodesByIdentity.set(p,e),s?.(e)},F=e=>{const p=this.identityProvider.getId(e.element).toString();l.has(p)||this.nodesByIdentity.delete(p)}}this.model.setChildren(m===this.input?null:m,this.iterate(m,f).elements,{onDidCreateNode:g,onDidDeleteNode:F})}iterate(m,f){const g=[...this.dataSource.getChildren(m)];return{elements:M.Iterable.map(g,l=>{const{elements:s,size:e}=this.iterate(l,f),p=this.dataSource.hasChildren?this.dataSource.hasChildren(l):void 0,D=e===0?void 0:f&&f(l);return{element:l,children:s,collapsible:p,collapsed:D}}),size:g.length}}createModel(m,f,g){return new i.ObjectTreeModel(m,f,g)}}t.DataTree=E}),define(me[38],pe([1,0,14,8,31,28,25,13,3,2,49,10,6]),function(J,t,y,i,B,M,E,w,m,f,g,F,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.logWithColors=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.ResponseType=t.RequestType=void 0;var s;(function(Z){Z[Z.Promise=100]="Promise",Z[Z.PromiseCancel=101]="PromiseCancel",Z[Z.EventListen=102]="EventListen",Z[Z.EventDispose=103]="EventDispose"})(s=t.RequestType||(t.RequestType={}));function e(Z){switch(Z){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var p;(function(Z){Z[Z.Initialize=200]="Initialize",Z[Z.PromiseSuccess=201]="PromiseSuccess",Z[Z.PromiseError=202]="PromiseError",Z[Z.PromiseErrorObj=203]="PromiseErrorObj",Z[Z.EventFire=204]="EventFire"})(p=t.ResponseType||(t.ResponseType={}));function D(Z){switch(Z){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var v;(function(Z){Z[Z.Uninitialized=0]="Uninitialized",Z[Z.Idle=1]="Idle"})(v||(v={}));class _{constructor(X){this.buffer=X,this.pos=0}read(X){const se=this.buffer.slice(this.pos,this.pos+X);return this.pos+=se.byteLength,se}}class a{constructor(){this.buffers=[]}get buffer(){return B.VSBuffer.concat(this.buffers)}write(X){this.buffers.push(X)}}var o;(function(Z){Z[Z.Undefined=0]="Undefined",Z[Z.String=1]="String",Z[Z.Buffer=2]="Buffer",Z[Z.VSBuffer=3]="VSBuffer",Z[Z.Array=4]="Array",Z[Z.Object=5]="Object"})(o||(o={}));function b(Z){const X=B.VSBuffer.alloc(4);return X.writeUInt32BE(Z,0),X}function S(Z){return Z.read(4).readUInt32BE(0)}function A(Z){const X=B.VSBuffer.alloc(1);return X.writeUInt8(Z,0),X}const C={Undefined:A(o.Undefined),String:A(o.String),Buffer:A(o.Buffer),VSBuffer:A(o.VSBuffer),Array:A(o.Array),Object:A(o.Object)},r=typeof Buffer!="undefined";function n(Z,X){if(typeof X=="undefined")Z.write(C.Undefined);else if(typeof X=="string"){const se=B.VSBuffer.fromString(X);Z.write(C.String),Z.write(b(se.byteLength)),Z.write(se)}else if(r&&Buffer.isBuffer(X)){const se=B.VSBuffer.wrap(X);Z.write(C.Buffer),Z.write(b(se.byteLength)),Z.write(se)}else if(X instanceof B.VSBuffer)Z.write(C.VSBuffer),Z.write(b(X.byteLength)),Z.write(X);else if(Array.isArray(X)){Z.write(C.Array),Z.write(b(X.length));for(const se of X)n(Z,se)}else{const se=B.VSBuffer.fromString(JSON.stringify(X));Z.write(C.Object),Z.write(b(se.byteLength)),Z.write(se)}}function c(Z){switch(Z.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return Z.read(S(Z)).toString();case o.Buffer:return Z.read(S(Z)).buffer;case o.VSBuffer:return Z.read(S(Z));case o.Array:{const se=S(Z),te=[];for(let I=0;I<se;I++)te.push(c(Z));return te}case o.Object:return JSON.parse(Z.read(S(Z)).toString())}}class u{constructor(X,se,te=null,I=1e3){this.protocol=X,this.ctx=se,this.logger=te,this.timeoutDelay=I,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage($=>this.onRawMessage($)),this.sendResponse({type:200})}registerChannel(X,se){this.channels.set(X,se),setTimeout(()=>this.flushPendingRequests(X),0)}sendResponse(X){switch(X.type){case 200:{const se=this.send([X.type]);this.logger?.logOutgoing(se,0,1,D(X.type));return}case 201:case 202:case 204:case 203:{const se=this.send([X.type,X.id],X.data);this.logger?.logOutgoing(se,X.id,1,D(X.type),X.data);return}}}send(X,se=void 0){const te=new a;return n(te,X),n(te,se),this.sendBuffer(te.buffer)}sendBuffer(X){try{return this.protocol.send(X),X.byteLength}catch{return 0}}onRawMessage(X){const se=new _(X),te=c(se),I=c(se),$=te[0];switch($){case 100:return this.logger?.logIncoming(X.byteLength,te[1],1,`${e($)}: ${te[2]}.${te[3]}`,I),this.onPromise({type:$,id:te[1],channelName:te[2],name:te[3],arg:I});case 102:return this.logger?.logIncoming(X.byteLength,te[1],1,`${e($)}: ${te[2]}.${te[3]}`,I),this.onEventListen({type:$,id:te[1],channelName:te[2],name:te[3],arg:I});case 101:return this.logger?.logIncoming(X.byteLength,te[1],1,`${e($)}`),this.disposeActiveRequest({type:$,id:te[1]});case 103:return this.logger?.logIncoming(X.byteLength,te[1],1,`${e($)}`),this.disposeActiveRequest({type:$,id:te[1]})}}onPromise(X){const se=this.channels.get(X.channelName);if(!se){this.collectPendingRequest(X);return}const te=new M.CancellationTokenSource;let I;try{I=se.call(this.ctx,X.name,X.arg,te.token)}catch(H){I=Promise.reject(H)}const $=X.id;I.then(H=>{this.sendResponse({id:$,data:H,type:201}),this.activeRequests.delete(X.id)},H=>{H instanceof Error?this.sendResponse({id:$,data:{message:H.message,name:H.name,stack:H.stack?H.stack.split?H.stack.split(`
`):H.stack:void 0},type:202}):this.sendResponse({id:$,data:H,type:203}),this.activeRequests.delete(X.id)});const j=(0,f.toDisposable)(()=>te.cancel());this.activeRequests.set(X.id,j)}onEventListen(X){const se=this.channels.get(X.channelName);if(!se){this.collectPendingRequest(X);return}const te=X.id,$=se.listen(this.ctx,X.name,X.arg)(j=>this.sendResponse({id:te,data:j,type:204}));this.activeRequests.set(X.id,$)}disposeActiveRequest(X){const se=this.activeRequests.get(X.id);se&&(se.dispose(),this.activeRequests.delete(X.id))}collectPendingRequest(X){let se=this.pendingRequests.get(X.channelName);se||(se=[],this.pendingRequests.set(X.channelName,se));const te=setTimeout(()=>{console.error(`Unknown channel: ${X.channelName}`),X.type===100&&this.sendResponse({id:X.id,data:{name:"Unknown channel",message:`Channel name '${X.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);se.push({request:X,timeoutTimer:te})}flushPendingRequests(X){const se=this.pendingRequests.get(X);if(se){for(const te of se)switch(clearTimeout(te.timeoutTimer),te.request.type){case 100:this.onPromise(te.request);break;case 102:this.onEventListen(te.request);break}this.pendingRequests.delete(X)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,f.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}t.ChannelServer=u;var h;(function(Z){Z[Z.LocalSide=0]="LocalSide",Z[Z.OtherSide=1]="OtherSide"})(h=t.RequestInitiator||(t.RequestInitiator={}));class O{constructor(X,se=null){this.protocol=X,this.isDisposed=!1,this.state=v.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new m.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(te=>this.onBuffer(te)),this.logger=se}getChannel(X){const se=this;return{call(te,I,$){return se.isDisposed?Promise.reject(w.canceled()):se.requestPromise(X,te,I,$)},listen(te,I){return se.isDisposed?m.Event.None:se.requestEvent(X,te,I)}}}requestPromise(X,se,te,I=M.CancellationToken.None){const $=this.lastRequestId++,H={id:$,type:100,channelName:X,name:se,arg:te};if(I.isCancellationRequested)return Promise.reject(w.canceled());let d;return new Promise((U,K)=>{if(I.isCancellationRequested)return K(w.canceled());const Q=()=>{const T=W=>{switch(W.type){case 201:this.handlers.delete($),U(W.data);break;case 202:{this.handlers.delete($);const k=new Error(W.data.message);k.stack=W.data.stack,k.name=W.data.name,K(k);break}case 203:this.handlers.delete($),K(W.data);break}};this.handlers.set($,T),this.sendRequest(H)};let N=null;this.state===v.Idle?Q():(N=(0,i.createCancelablePromise)(T=>this.whenInitialized()),N.then(()=>{N=null,Q()}));const R=()=>{N?(N.cancel(),N=null):this.sendRequest({id:$,type:101}),K(w.canceled())},z=I.onCancellationRequested(R);d=(0,f.combinedDisposable)((0,f.toDisposable)(R),z),this.activeRequests.add(d)}).finally(()=>{this.activeRequests.delete(d)})}requestEvent(X,se,te){const I=this.lastRequestId++,j={id:I,type:102,channelName:X,name:se,arg:te};let H=null;const d=new m.Emitter({onFirstListenerAdd:()=>{H=(0,i.createCancelablePromise)(U=>this.whenInitialized()),H.then(()=>{H=null,this.activeRequests.add(d),this.sendRequest(j)})},onLastListenerRemove:()=>{H?(H.cancel(),H=null):(this.activeRequests.delete(d),this.sendRequest({id:I,type:103}))}}),L=U=>d.fire(U.data);return this.handlers.set(I,L),d.event}sendRequest(X){switch(X.type){case 100:case 102:{const se=this.send([X.type,X.id,X.channelName,X.name],X.arg);this.logger?.logOutgoing(se,X.id,0,`${e(X.type)}: ${X.channelName}.${X.name}`,X.arg);return}case 101:case 103:{const se=this.send([X.type,X.id]);this.logger?.logOutgoing(se,X.id,0,e(X.type));return}}}send(X,se=void 0){const te=new a;return n(te,X),n(te,se),this.sendBuffer(te.buffer)}sendBuffer(X){try{return this.protocol.send(X),X.byteLength}catch{return 0}}onBuffer(X){const se=new _(X),te=c(se),I=c(se),$=te[0];switch($){case 200:return this.logger?.logIncoming(X.byteLength,0,0,D($)),this.onResponse({type:te[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(X.byteLength,te[1],0,D($),I),this.onResponse({type:te[0],id:te[1],data:I})}}onResponse(X){if(X.type===200){this.state=v.Idle,this._onDidInitialize.fire();return}this.handlers.get(X.id)?.(X)}get onDidInitializePromise(){return m.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===v.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,f.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}Ke([E.memoize],O.prototype,"onDidInitializePromise",null),t.ChannelClient=O;class V{constructor(X){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new m.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new m.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,X(({protocol:se,onDidClientDisconnect:te})=>{m.Event.once(se.onMessage)($=>{const j=new _($),H=c(j),d=new u(se,H),L=new O(se);this.channels.forEach((K,Q)=>d.registerChannel(Q,K));const U={channelServer:d,channelClient:L,ctx:H};this._connections.add(U),this._onDidAddConnection.fire(U),te(()=>{d.dispose(),L.dispose(),this._connections.delete(U),this._onDidRemoveConnection.fire(U)})})})}get connections(){const X=[];return this._connections.forEach(se=>X.push(se)),X}getChannel(X,se){const te=this;return{call(I,$,j){let H;if((0,l.isFunction)(se)){const L=(0,y.getRandomElement)(te.connections.filter(se));H=L?Promise.resolve(L):m.Event.toPromise(m.Event.filter(te.onDidAddConnection,se))}else H=se.routeCall(te,I,$);const d=H.then(L=>L.channelClient.getChannel(X));return ie(d).call(I,$,j)},listen(I,$){if((0,l.isFunction)(se))return te.getMulticastEvent(X,se,I,$);const j=se.routeEvent(te,I,$).then(H=>H.channelClient.getChannel(X));return ie(j).listen(I,$)}}}getMulticastEvent(X,se,te,I){const $=this;let j=new f.DisposableStore;const H=new m.Emitter({onFirstListenerAdd:()=>{j=new f.DisposableStore;const d=new m.EventMultiplexer,L=new Map,U=Q=>{const R=Q.channelClient.getChannel(X).listen(te,I),z=d.add(R);L.set(Q,z)},K=Q=>{const N=L.get(Q);!N||(N.dispose(),L.delete(Q))};$.connections.filter(se).forEach(U),m.Event.filter($.onDidAddConnection,se)(U,void 0,j),$.onDidRemoveConnection(K,void 0,j),d.event(H.fire,H,j),j.add(d)},onLastListenerRemove:()=>{j.dispose()}});return H.event}registerChannel(X,se){this.channels.set(X,se),this._connections.forEach(te=>{te.channelServer.registerChannel(X,se)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}t.IPCServer=V;class ue{constructor(X,se,te=null){const I=new a;n(I,se),X.send(I.buffer),this.channelClient=new O(X,te),this.channelServer=new u(X,se,te)}getChannel(X){return this.channelClient.getChannel(X)}registerChannel(X,se){this.channelServer.registerChannel(X,se)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}t.IPCClient=ue;function ie(Z){return{call(X,se,te){return Z.then(I=>I.call(X,se,te))},listen(X,se){const te=new m.Relay;return Z.then(I=>te.input=I.listen(X,se)),te.event}}}t.getDelayedChannel=ie;function ge(Z){let X=!1;return{call(se,te,I){return X?Z.call(se,te,I):(0,i.timeout)(0).then(()=>X=!0).then(()=>Z.call(se,te,I))},listen(se,te){if(X)return Z.listen(se,te);const I=new m.Relay;return(0,i.timeout)(0).then(()=>X=!0).then(()=>I.input=Z.listen(se,te)),I.event}}}t.getNextTickChannel=ge;class ae{constructor(X){this.fn=X}routeCall(X){return this.route(X)}routeEvent(X){return this.route(X)}async route(X){for(const se of X.connections)if(await Promise.resolve(this.fn(se.ctx)))return Promise.resolve(se);return await m.Event.toPromise(X.onDidAddConnection),await this.route(X)}}t.StaticRouter=ae;var we;(function(Z){function X($,j){const H=$,d=j&&j.disableMarshalling,L=new Map;for(const U in H)te(U)&&L.set(U,m.Event.buffer(H[U],!0));return new class{listen(U,K,Q){const N=L.get(K);if(N)return N;if(I(K)){const R=H[K];if(typeof R=="function")return R.call(H,Q)}throw new Error(`Event not found: ${K}`)}call(U,K,Q){const N=H[K];if(typeof N=="function"){if(!d&&Array.isArray(Q))for(let R=0;R<Q.length;R++)Q[R]=(0,g.revive)(Q[R]);return N.apply(H,Q)}throw new Error(`Method not found: ${K}`)}}}Z.fromService=X;function se($,j){const H=j&&j.disableMarshalling;return new Proxy({},{get(d,L){if(typeof L=="string")return j?.properties?.has(L)?j.properties.get(L):I(L)?function(U){return $.listen(L,U)}:te(L)?$.listen(L):async function(...U){let K;j&&!(0,l.isUndefinedOrNull)(j.context)?K=[j.context,...U]:K=U;const Q=await $.call(L,K);return H?Q:(0,g.revive)(Q)};throw new Error(`Property not found: ${String(L)}`)}})}Z.toService=se;function te($){return $[0]==="o"&&$[1]==="n"&&F.isUpperAsciiLetter($.charCodeAt(2))}function I($){return/^onDynamic/.test($)&&F.isUpperAsciiLetter($.charCodeAt(9))}})(we=t.ProxyChannel||(t.ProxyChannel={}));const ce=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function re(Z){if(Array.isArray(Z))return Z;if(Z&&typeof Z=="object"&&typeof Z.toString=="function"){const X=Z.toString();if(X!=="[object Object]")return X}return Z}function Ce(Z){return Array.isArray(Z)?Z.map(re):re(Z)}function Ie(Z,X,se,te,I,$,j){j=Ce(j);const H=ce[I],d=H[te%H.length];let L=[`%c[${Z}]%c[${String(X).padStart(7," ")}]%c[len: ${String(se).padStart(5," ")}]%c${String(te).padStart(5," ")} - ${$}`,"color: darkgreen","color: grey","color: grey",`color: ${d}`];/\($/.test($)?(L=L.concat(j),L.push(")")):L.push(j),console.log.apply(console,L)}t.logWithColors=Ie;class ne{constructor(X,se){this._outgoingPrefix=X,this._incomingPrefix=se,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(X,se,te,I,$){this._totalOutgoing+=X,Ie(this._outgoingPrefix,this._totalOutgoing,X,se,te,I,$)}logIncoming(X,se,te,I,$){this._totalIncoming+=X,Ie(this._incomingPrefix,this._totalIncoming,X,se,te,I,$)}}t.IPCLogger=ne}),define(me[29],pe([1,0,5]),function(J,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.context=t.process=t.webFrame=t.ipcMessagePort=t.ipcRenderer=void 0,t.ipcRenderer=y.globals.vscode.ipcRenderer,t.ipcMessagePort=y.globals.vscode.ipcMessagePort,t.webFrame=y.globals.vscode.webFrame,t.process=y.globals.vscode.process,t.context=y.globals.vscode.context}),define(me[129],pe([1,0,80,29]),function(J,t,y,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.popup=void 0;let B=0;function M(w,m,f){const g=[],F=B++,l=`vscode:onContextMenu${F}`,s=(e,p,D)=>{g[p].click?.(D)};i.ipcRenderer.once(l,s),i.ipcRenderer.once(y.CONTEXT_MENU_CLOSE_CHANNEL,(e,p)=>{p===F&&(i.ipcRenderer.removeListener(l,s),f?.())}),i.ipcRenderer.send(y.CONTEXT_MENU_CHANNEL,F,w.map(e=>E(e,g)),l,m)}t.popup=M;function E(w,m){const f={id:m.length,label:w.label,type:w.type,accelerator:w.accelerator,checked:w.checked,enabled:typeof w.enabled=="boolean"?w.enabled:!0,visible:typeof w.visible=="boolean"?w.visible:!0};return m.push(w),Array.isArray(w.submenu)&&(f.submenu=w.submenu.map(g=>E(g,m))),f}}),define(me[130],pe([1,0,31,3,38,81,29]),function(J,t,y,i,B,M,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=void 0;class w extends B.IPCClient{constructor(f){const g=w.createProtocol();super(g,f);this.protocol=g}static createProtocol(){const f=i.Event.fromNodeEventEmitter(E.ipcRenderer,"vscode:message",(g,F)=>y.VSBuffer.wrap(F));return E.ipcRenderer.send("vscode:hello"),new M.Protocol(E.ipcRenderer,f)}dispose(){this.protocol.disconnect()}}t.Client=w}),define(me[131],pe([12,9]),function(J,t){return J.create("vs/platform/files/common/files",t)}),define(me[132],pe([12,9]),function(J,t){return J.create("vs/platform/theme/common/iconRegistry",t)}),define(me[63],pe([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SyncDescriptor=void 0;class y{constructor(B,M=[],E=!1){this.ctor=B,this.staticArguments=M,this.supportsDelayedInstantiation=E}}t.SyncDescriptor=y}),define(me[133],pe([1,0,63]),function(J,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSingletonServiceDescriptors=t.registerSingleton=void 0;const i=[];function B(E,w,m){w instanceof y.SyncDescriptor||(w=new y.SyncDescriptor(w,[],m)),i.push([E,w])}t.registerSingleton=B;function M(){return i}t.getSingletonServiceDescriptors=M}),define(me[30],pe([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.refineServiceDecorator=t.createDecorator=t.IInstantiationService=t._util=void 0;var y;(function(E){E.serviceIds=new Map,E.DI_TARGET="$di$target",E.DI_DEPENDENCIES="$di$dependencies";function w(m){return m[E.DI_DEPENDENCIES]||[]}E.getServiceDependencies=w})(y=t._util||(t._util={})),t.IInstantiationService=B("instantiationService");function i(E,w,m){w[y.DI_TARGET]===w?w[y.DI_DEPENDENCIES].push({id:E,index:m}):(w[y.DI_DEPENDENCIES]=[{id:E,index:m}],w[y.DI_TARGET]=w)}function B(E){if(y.serviceIds.has(E))return y.serviceIds.get(E);const w=function(m,f,g){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");i(w,m,g)};return w.toString=()=>E,y.serviceIds.set(E,w),w}t.createDecorator=B;function M(E){return E}t.refineServiceDecorator=M}),define(me[134],pe([1,0,30]),function(J,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NullDiagnosticsService=t.isRemoteDiagnosticError=t.IDiagnosticsService=t.ID=void 0,t.ID="diagnosticsService",t.IDiagnosticsService=(0,y.createDecorator)(t.ID);function i(M){return!!M.hostName&&!!M.errorMessage}t.isRemoteDiagnosticError=i;class B{async getPerformanceInfo(E,w){return{}}async getSystemInfo(E,w){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(E,w){return""}async getWorkspaceFileExtensions(E){return{extensions:[]}}async reportWorkspaceStats(E){}}t.NullDiagnosticsService=B}),define(me[135],pe([1,0,48,21,10,6,16,131,30]),function(J,t,y,i,B,M,E,w,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getPlatformLimits=t.Arch=t.ByteSize=t.FALLBACK_MAX_MEMORY_SIZE_MB=t.MIN_MAX_MEMORY_SIZE_MB=t.whenProviderRegistered=t.etag=t.ETAG_DISABLED=t.FileKind=t.FILES_EXCLUDE_CONFIG=t.FILES_ASSOCIATIONS_CONFIG=t.HotExitConfiguration=t.AutoSaveConfiguration=t.FileOperationResult=t.NotModifiedSinceFileOperationError=t.FileOperationError=t.isParent=t.FileChangesEvent=t.FileChangeType=t.FileOperationEvent=t.FileOperation=t.toFileOperationResult=t.toFileSystemProviderErrorCode=t.markAsFileSystemProviderError=t.ensureFileSystemProviderError=t.createFileSystemProviderError=t.FileSystemProviderError=t.FileSystemProviderErrorCode=t.hasFileAtomicReadCapability=t.hasFileReadCapability=t.hasFileReadStreamCapability=t.hasOpenReadWriteCloseCapability=t.hasFileCloneCapability=t.hasFileFolderCopyCapability=t.hasReadWriteCapability=t.FileSystemProviderCapabilities=t.FilePermission=t.FileType=t.isFileOpenForWriteOptions=t.IFileService=void 0,t.IFileService=(0,m.createDecorator)("fileService");function f(ne){return ne.create===!0}t.isFileOpenForWriteOptions=f;var g;(function(ne){ne[ne.Unknown=0]="Unknown",ne[ne.File=1]="File",ne[ne.Directory=2]="Directory",ne[ne.SymbolicLink=64]="SymbolicLink"})(g=t.FileType||(t.FileType={}));var F;(function(ne){ne[ne.Readonly=1]="Readonly"})(F=t.FilePermission||(t.FilePermission={}));var l;(function(ne){ne[ne.FileReadWrite=2]="FileReadWrite",ne[ne.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ne[ne.FileReadStream=16]="FileReadStream",ne[ne.FileFolderCopy=8]="FileFolderCopy",ne[ne.PathCaseSensitive=1024]="PathCaseSensitive",ne[ne.Readonly=2048]="Readonly",ne[ne.Trash=4096]="Trash",ne[ne.FileWriteUnlock=8192]="FileWriteUnlock",ne[ne.FileAtomicRead=16384]="FileAtomicRead",ne[ne.FileClone=32768]="FileClone"})(l=t.FileSystemProviderCapabilities||(t.FileSystemProviderCapabilities={}));function s(ne){return!!(ne.capabilities&2)}t.hasReadWriteCapability=s;function e(ne){return!!(ne.capabilities&8)}t.hasFileFolderCopyCapability=e;function p(ne){return!!(ne.capabilities&32768)}t.hasFileCloneCapability=p;function D(ne){return!!(ne.capabilities&4)}t.hasOpenReadWriteCloseCapability=D;function v(ne){return!!(ne.capabilities&16)}t.hasFileReadStreamCapability=v;function _(ne){return!!(ne.capabilities&2048)}t.hasFileReadCapability=_;function a(ne){return s(ne)?!!(ne.capabilities&16384):!1}t.hasFileAtomicReadCapability=a;var o;(function(ne){ne.FileExists="EntryExists",ne.FileNotFound="EntryNotFound",ne.FileNotADirectory="EntryNotADirectory",ne.FileIsADirectory="EntryIsADirectory",ne.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",ne.FileTooLarge="EntryTooLarge",ne.FileWriteLocked="EntryWriteLocked",ne.NoPermissions="NoPermissions",ne.Unavailable="Unavailable",ne.Unknown="Unknown"})(o=t.FileSystemProviderErrorCode||(t.FileSystemProviderErrorCode={}));class b extends Error{constructor(Z,X){super(Z);this.code=X}}t.FileSystemProviderError=b;function S(ne,Z){const X=new b(ne.toString(),Z);return C(X,Z),X}t.createFileSystemProviderError=S;function A(ne){return ne||S((0,w.localize)(0,null),o.Unknown)}t.ensureFileSystemProviderError=A;function C(ne,Z){return ne.name=Z?`${Z} (FileSystemError)`:"FileSystemError",ne}t.markAsFileSystemProviderError=C;function r(ne){if(!ne)return o.Unknown;if(ne instanceof b)return ne.code;const Z=/^(.+) \(FileSystemError\)$/.exec(ne.name);if(!Z)return o.Unknown;switch(Z[1]){case o.FileExists:return o.FileExists;case o.FileIsADirectory:return o.FileIsADirectory;case o.FileNotADirectory:return o.FileNotADirectory;case o.FileNotFound:return o.FileNotFound;case o.FileExceedsMemoryLimit:return o.FileExceedsMemoryLimit;case o.FileTooLarge:return o.FileTooLarge;case o.FileWriteLocked:return o.FileWriteLocked;case o.NoPermissions:return o.NoPermissions;case o.Unavailable:return o.Unavailable}return o.Unknown}t.toFileSystemProviderErrorCode=r;function n(ne){if(ne instanceof ue)return ne.fileOperationResult;switch(r(ne)){case o.FileNotFound:return 1;case o.FileIsADirectory:return 0;case o.FileNotADirectory:return 10;case o.FileWriteLocked:return 5;case o.NoPermissions:return 6;case o.FileExists:return 4;case o.FileExceedsMemoryLimit:return 9;case o.FileTooLarge:return 7;default:return 11}}t.toFileOperationResult=n;var c;(function(ne){ne[ne.CREATE=0]="CREATE",ne[ne.DELETE=1]="DELETE",ne[ne.MOVE=2]="MOVE",ne[ne.COPY=3]="COPY",ne[ne.WRITE=4]="WRITE"})(c=t.FileOperation||(t.FileOperation={}));class u{constructor(Z,X,se){this.resource=Z,this.operation=X,this.target=se}isOperation(Z){return this.operation===Z}}t.FileOperationEvent=u;var h;(function(ne){ne[ne.UPDATED=0]="UPDATED",ne[ne.ADDED=1]="ADDED",ne[ne.DELETED=2]="DELETED"})(h=t.FileChangeType||(t.FileChangeType={}));class O{constructor(Z,X){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=Z;const se=new Map;for(const te of Z){const I=se.get(te.type);switch(I?I.push([te.resource,te]):se.set(te.type,[[te.resource,te]]),te.type){case 1:this.rawAdded.push(te.resource);break;case 0:this.rawUpdated.push(te.resource);break;case 2:this.rawDeleted.push(te.resource);break}}for(const[te,I]of se)switch(te){case 1:this.added=y.TernarySearchTree.forUris(()=>X),this.added.fill(I);break;case 0:this.updated=y.TernarySearchTree.forUris(()=>X),this.updated.fill(I);break;case 2:this.deleted=y.TernarySearchTree.forUris(()=>X),this.deleted.fill(I);break}}contains(Z,...X){return this.doContains(Z,{includeChildren:!1},...X)}affects(Z,...X){return this.doContains(Z,{includeChildren:!0},...X)}doContains(Z,X,...se){if(!Z)return!1;const te=se.length>0;return!!((!te||se.includes(1))&&(this.added?.get(Z)||X.includeChildren&&this.added?.findSuperstr(Z))||(!te||se.includes(0))&&(this.updated?.get(Z)||X.includeChildren&&this.updated?.findSuperstr(Z))||(!te||se.includes(2))&&(this.deleted?.findSubstr(Z)||X.includeChildren&&this.deleted?.findSuperstr(Z)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}t.FileChangesEvent=O;function V(ne,Z,X){return!ne||!Z||ne===Z||Z.length>ne.length?!1:(Z.charAt(Z.length-1)!==i.sep&&(Z+=i.sep),X?(0,B.startsWithIgnoreCase)(ne,Z):ne.indexOf(Z)===0)}t.isParent=V;class ue extends Error{constructor(Z,X,se){super(Z);this.fileOperationResult=X,this.options=se}}t.FileOperationError=ue;class ie extends ue{constructor(Z,X,se){super(Z,2,se);this.stat=X}}t.NotModifiedSinceFileOperationError=ie;var ge;(function(ne){ne[ne.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ne[ne.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ne[ne.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ne[ne.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ne[ne.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ne[ne.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ne[ne.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ne[ne.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ne[ne.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ne[ne.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",ne[ne.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",ne[ne.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(ge=t.FileOperationResult||(t.FileOperationResult={})),t.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},t.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},t.FILES_ASSOCIATIONS_CONFIG="files.associations",t.FILES_EXCLUDE_CONFIG="files.exclude";var ae;(function(ne){ne[ne.FILE=0]="FILE",ne[ne.FOLDER=1]="FOLDER",ne[ne.ROOT_FOLDER=2]="ROOT_FOLDER"})(ae=t.FileKind||(t.FileKind={})),t.ETAG_DISABLED="";function we(ne){if(!(typeof ne.size!="number"||typeof ne.mtime!="number"))return ne.mtime.toString(29)+ne.size.toString(31)}t.etag=we;async function ce(ne,Z){if(!Z.hasProvider(E.URI.from({scheme:ne.scheme})))return new Promise(X=>{const se=Z.onDidChangeFileSystemProviderRegistrations(te=>{te.scheme===ne.scheme&&te.added&&(se.dispose(),X())})})}t.whenProviderRegistered=ce,t.MIN_MAX_MEMORY_SIZE_MB=2048,t.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class re{static formatSize(Z){return(0,M.isNumber)(Z)||(Z=0),Z<re.KB?(0,w.localize)(1,null,Z.toFixed(0)):Z<re.MB?(0,w.localize)(2,null,(Z/re.KB).toFixed(2)):Z<re.GB?(0,w.localize)(3,null,(Z/re.MB).toFixed(2)):Z<re.TB?(0,w.localize)(4,null,(Z/re.GB).toFixed(2)):(0,w.localize)(5,null,(Z/re.TB).toFixed(2))}}t.ByteSize=re,re.KB=1024,re.MB=re.KB*re.KB,re.GB=re.MB*re.KB,re.TB=re.GB*re.KB;var Ce;(function(ne){ne[ne.IA32=0]="IA32",ne[ne.OTHER=1]="OTHER"})(Ce=t.Arch||(t.Arch={}));function Ie(ne){return{maxFileSize:ne===0?300*re.MB:16*re.GB,maxHeapSize:ne===0?700*re.MB:2*700*re.MB}}t.getPlatformLimits=Ie}),define(me[136],pe([1,0,2,130]),function(J,t,y,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ElectronIPCMainProcessService=void 0;class B extends y.Disposable{constructor(E){super();this.mainProcessConnection=this._register(new i.Client(`window:${E}`))}getChannel(E){return this.mainProcessConnection.getChannel(E)}registerChannel(E,w){this.mainProcessConnection.registerChannel(E,w)}}t.ElectronIPCMainProcessService=B});var Tt=this&&this.__param||function(J,t){return function(y,i){t(y,i,J)}};define(me[137],pe([1,0,38,63,133,30]),function(J,t,y,i,B,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.registerSharedProcessRemoteService=t.ISharedProcessService=t.registerMainProcessRemoteService=t.IMainProcessService=void 0;class E{constructor(s,e,p){const D=p.getChannel(s);return w(e)?new e.channelClientCtor(D):y.ProxyChannel.toService(D,e?.proxyOptions)}}function w(l){return!!l?.channelClientCtor}t.IMainProcessService=(0,M.createDecorator)("mainProcessService");let m=class extends E{constructor(s,e,p){super(s,e,p)}};m=Ke([Tt(2,t.IMainProcessService)],m);function f(l,s,e){(0,B.registerSingleton)(l,new i.SyncDescriptor(m,[s,e],e?.supportsDelayedInstantiation))}t.registerMainProcessRemoteService=f,t.ISharedProcessService=(0,M.createDecorator)("sharedProcessService");let g=class extends E{constructor(s,e,p){super(s,e,p)}};g=Ke([Tt(2,t.ISharedProcessService)],g);function F(l,s,e){(0,B.registerSingleton)(l,new i.SyncDescriptor(g,[s,e],e?.supportsDelayedInstantiation))}t.registerSharedProcessRemoteService=F}),define(me[138],pe([1,0,38,137]),function(J,t,y,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeHostService=void 0;let B=class{constructor(E,w){return this.windowId=E,y.ProxyChannel.toService(w.getChannel("nativeHost"),{context:E,properties:(()=>{const m=new Map;return m.set("windowId",E),m})()})}};B=Ke([Tt(1,i.IMainProcessService)],B),t.NativeHostService=B}),define(me[39],pe([1,0,68,6]),function(J,t,y,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class B{constructor(){this.data=new Map}add(E,w){y.ok(i.isString(E)),y.ok(i.isObject(w)),y.ok(!this.data.has(E),"There is already an extension with this id"),this.data.set(E,w)}knows(E){return this.data.has(E)}as(E){return this.data.get(E)||null}}t.Registry=new B}),define(me[139],pe([1,0,3,39]),function(J,t,y,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function B(w){return w.length>0&&w.charAt(w.length-1)==="#"?w.substring(0,w.length-1):w}class M{constructor(){this._onDidChangeSchema=new y.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(m,f){this.schemasById[B(m)]=f,this._onDidChangeSchema.fire(m)}notifySchemaChanged(m){this._onDidChangeSchema.fire(m)}getSchemaContributions(){return{schemas:this.schemasById}}}const E=new M;i.Registry.add(t.Extensions.JSONContribution,E)}),define(me[140],pe([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isDark=t.isHighContrast=t.ColorScheme=void 0;var y;(function(M){M.DARK="dark",M.LIGHT="light",M.HIGH_CONTRAST_DARK="hcDark",M.HIGH_CONTRAST_LIGHT="hcLight"})(y=t.ColorScheme||(t.ColorScheme={}));function i(M){return M===y.HIGH_CONTRAST_DARK||M===y.HIGH_CONTRAST_LIGHT}t.isHighContrast=i;function B(M){return M===y.DARK||M===y.HIGH_CONTRAST_DARK}t.isDark=B}),define(me[64],pe([1,0,11,3,2,30,39,140]),function(J,t,y,i,B,M,E,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Themable=t.registerThemingParticipant=t.Extensions=t.getThemeTypeSelector=t.FolderThemeIcon=t.FileThemeIcon=t.ThemeIcon=t.themeColorFromId=t.ThemeColor=t.IThemeService=void 0,t.IThemeService=(0,M.createDecorator)("themeService");var m;(function(D){function v(_){return _&&typeof _=="object"&&typeof _.id=="string"}D.isThemeColor=v})(m=t.ThemeColor||(t.ThemeColor={}));function f(D){return{id:D}}t.themeColorFromId=f;var g;(function(D){function v(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color=="undefined"||m.isThemeColor(r.color))}D.isThemeIcon=v;const _=new RegExp(`^\\$\\((${y.CSSIcon.iconNameExpression}(?:${y.CSSIcon.iconModifierExpression})?)\\)$`);function a(r){const n=_.exec(r);if(!n)return;const[,c]=n;return{id:c}}D.fromString=a;function o(r){return{id:r}}D.fromId=o;function b(r,n){let c=r.id;const u=c.lastIndexOf("~");return u!==-1&&(c=c.substring(0,u)),n&&(c=`${c}~${n}`),{id:c}}D.modify=b;function S(r){const n=r.id.lastIndexOf("~");if(n!==-1)return r.id.substring(n+1)}D.getModifier=S;function A(r,n){return r.id===n.id&&r.color?.id===n.color?.id}D.isEqual=A;function C(r,n){return{id:r.id,color:n?f(n):void 0}}D.asThemeIcon=C,D.asClassNameArray=y.CSSIcon.asClassNameArray,D.asClassName=y.CSSIcon.asClassName,D.asCSSSelector=y.CSSIcon.asCSSSelector})(g=t.ThemeIcon||(t.ThemeIcon={})),t.FileThemeIcon=y.Codicon.file,t.FolderThemeIcon=y.Codicon.folder;function F(D){switch(D){case w.ColorScheme.DARK:return"vs-dark";case w.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case w.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}t.getThemeTypeSelector=F,t.Extensions={ThemingContribution:"base.contributions.theming"};class l{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new i.Emitter}onColorThemeChange(v){return this.themingParticipants.push(v),this.onThemingParticipantAddedEmitter.fire(v),(0,B.toDisposable)(()=>{const _=this.themingParticipants.indexOf(v);this.themingParticipants.splice(_,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const s=new l;E.Registry.add(t.Extensions.ThemingContribution,s);function e(D){return s.onColorThemeChange(D)}t.registerThemingParticipant=e;class p extends B.Disposable{constructor(v){super();this.themeService=v,this.theme=v.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(_=>this.onThemeChange(_)))}onThemeChange(v){this.theme=v,this.updateStyles()}updateStyles(){}getColor(v,_){let a=this.theme.getColor(v);return a&&_&&(a=_(a,this.theme)),a?a.toString():null}}t.Themable=p}),define(me[141],pe([1,0,8,11,3,6,16,132,139,39,64]),function(J,t,y,i,B,M,E,w,m,f,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.spinningLoading=t.syncing=t.gotoNextLocation=t.gotoPreviousLocation=t.widgetClose=t.iconsSchemaId=t.getIconRegistry=t.registerIcon=t.IconFontDefinition=t.IconContribution=t.Extensions=void 0,t.Extensions={IconContribution:"base.contributions.icons"};var F;(function(o){function b(S,A){let C=S.defaults;for(;g.ThemeIcon.isThemeIcon(C);){const r=e.getIcon(C.id);if(!r)return;C=r.defaults}return C}o.getDefinition=b})(F=t.IconContribution||(t.IconContribution={}));var l;(function(o){function b(A){return{weight:A.weight,style:A.style,src:A.src.map(C=>({format:C.format,location:C.location.toString()}))}}o.toJSONObject=b;function S(A){const C=r=>(0,M.isString)(r)?r:void 0;if(A&&Array.isArray(A.src)&&A.src.every(r=>(0,M.isString)(r.format)&&(0,M.isString)(r.location)))return{weight:C(A.weight),style:C(A.style),src:A.src.map(r=>({format:r.format,location:E.URI.parse(r.location)}))}}o.fromJSONObject=S})(l=t.IconFontDefinition||(t.IconFontDefinition={}));class s{constructor(){this._onDidChange=new B.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,w.localize)(0,null)},fontCharacter:{type:"string",description:(0,w.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${i.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(b,S,A,C){const r=this.iconsById[b];if(r){if(A&&!r.description){r.description=A,this.iconSchema.properties[b].markdownDescription=`${A} $(${b})`;const u=this.iconReferenceSchema.enum.indexOf(b);u!==-1&&(this.iconReferenceSchema.enumDescriptions[u]=A),this._onDidChange.fire()}return r}const n={id:b,description:A,defaults:S,deprecationMessage:C};this.iconsById[b]=n;const c={$ref:"#/definitions/icons"};return C&&(c.deprecationMessage=C),A&&(c.markdownDescription=`${A}: $(${b})`),this.iconSchema.properties[b]=c,this.iconReferenceSchema.enum.push(b),this.iconReferenceSchema.enumDescriptions.push(A||""),this._onDidChange.fire(),{id:b}}deregisterIcon(b){delete this.iconsById[b],delete this.iconSchema.properties[b];const S=this.iconReferenceSchema.enum.indexOf(b);S!==-1&&(this.iconReferenceSchema.enum.splice(S,1),this.iconReferenceSchema.enumDescriptions.splice(S,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(b=>this.iconsById[b])}getIcon(b){return this.iconsById[b]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(b,S){const A=this.iconFontsById[b];return A||(this.iconFontsById[b]=S,this._onDidChange.fire(),S)}deregisterIconFont(b){delete this.iconFontsById[b]}getIconFont(b){return this.iconFontsById[b]}toString(){const b=(r,n)=>r.id.localeCompare(n.id),S=r=>{for(;g.ThemeIcon.isThemeIcon(r.defaults);)r=this.iconsById[r.defaults.id];return`codicon codicon-${r?r.id:""}`},A=[];A.push("| preview     | identifier                        | default codicon ID                | description"),A.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const C=Object.keys(this.iconsById).map(r=>this.iconsById[r]);for(const r of C.filter(n=>!!n.description).sort(b))A.push(`|<i class="${S(r)}"></i>|${r.id}|${g.ThemeIcon.isThemeIcon(r.defaults)?r.defaults.id:r.id}|${r.description||""}|`);A.push("| preview     | identifier                        "),A.push("| ----------- | --------------------------------- |");for(const r of C.filter(n=>!g.ThemeIcon.isThemeIcon(n.defaults)).sort(b))A.push(`|<i class="${S(r)}"></i>|${r.id}|`);return A.join(`
`)}}const e=new s;f.Registry.add(t.Extensions.IconContribution,e);function p(o,b,S,A){return e.registerIcon(o,b,S,A)}t.registerIcon=p;function D(){return e}t.getIconRegistry=D;function v(){for(const o of i.Codicon.getAll())e.registerIcon(o.id,o.definition,o.description)}v(),t.iconsSchemaId="vscode://schemas/icons";const _=f.Registry.as(m.Extensions.JSONContribution);_.registerSchema(t.iconsSchemaId,e.getIconSchema());const a=new y.RunOnceScheduler(()=>_.notifySchemaChanged(t.iconsSchemaId),200);e.onDidChange(()=>{a.isScheduled()||a.schedule()}),t.widgetClose=p("widget-close",i.Codicon.close,(0,w.localize)(2,null)),t.gotoPreviousLocation=p("goto-previous-location",i.Codicon.arrowUp,(0,w.localize)(3,null)),t.gotoNextLocation=p("goto-next-location",i.Codicon.arrowDown,(0,w.localize)(4,null)),t.syncing=g.ThemeIcon.modify(i.Codicon.sync,"spin"),t.spinningLoading=g.ThemeIcon.modify(i.Codicon.loading,"spin")}),define(me[142],pe([1,0,4,3,141,64]),function(J,t,y,i,B,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnthemedProductIconTheme=t.getIconsStyleSheet=void 0;function E(m){const f=new i.Emitter,g=(0,B.getIconRegistry)();return g.onDidChange(()=>f.fire()),m?.onDidProductIconThemeChange(()=>f.fire()),{onDidChange:f.event,getCSS(){const F=m?m.getProductIconTheme():new w,l={},s=p=>{const D=F.getIcon(p);if(!D)return;const v=D.font;return v?(l[v.id]=v.definition,`.codicon-${p.id}:before { content: '${D.fontCharacter}'; font-family: ${(0,y.asCSSPropertyValue)(v.id)}; }`):`.codicon-${p.id}:before { content: '${D.fontCharacter}'; }`},e=[];for(const p of g.getIcons()){const D=s(p);D&&e.push(D)}for(const p in l){const D=l[p],v=D.weight?`font-weight: ${D.weight};`:"",_=D.style?`font-style: ${D.style};`:"",a=D.src.map(o=>`${(0,y.asCSSUrl)(o.location)} format('${o.format}')`).join(", ");e.push(`@font-face { src: ${a}; font-family: ${(0,y.asCSSPropertyValue)(p)};${v}${_} font-display: block; }`)}return e.join(`
`)}}}t.getIconsStyleSheet=E;class w{getIcon(f){const g=(0,B.getIconRegistry)();let F=f.defaults;for(;M.ThemeIcon.isThemeIcon(F);){const l=g.getIcon(F.id);if(!l)return;F=l.defaults}return F}}t.UnthemedProductIconTheme=w}),define(me[143],pe([1,0,5]),function(J,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.zoomLevelToZoomFactor=t.useWindowControlsOverlay=t.getTitleBarStyle=t.getMenuBarVisibility=t.isFileToOpen=t.isFolderToOpen=t.isWorkspaceToOpen=t.WindowMinimumSize=void 0,t.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function i(g){return!!g.workspaceUri}t.isWorkspaceToOpen=i;function B(g){return!!g.folderUri}t.isFolderToOpen=B;function M(g){return!!g.fileUri}t.isFileToOpen=M;function E(g){const F=w(g),l=g.getValue("window.menuBarVisibility");return l==="default"||F==="native"&&l==="compact"||y.isMacintosh&&y.isNative?"classic":l}t.getMenuBarVisibility=E;function w(g){if(y.isWeb)return"custom";const F=g.getValue("window");if(F){if(y.isMacintosh&&F.nativeTabs===!0||y.isMacintosh&&F.nativeFullScreen===!1)return"native";const e=F.titleBarStyle;if(e==="native"||e==="custom")return e}return y.isLinux?"native":"custom"}t.getTitleBarStyle=w;function m(g,F){return!y.isWindows||y.isWeb||!F.isBuilt||w(g)==="native"?!1:g.getValue("window.experimental.windowControlsOverlay.enabled")}t.useWindowControlsOverlay=m;function f(g=0){return Math.pow(1.2,g)}t.zoomLevelToZoomFactor=f}),define(me[144],pe([1,0,15,29,143]),function(J,t,y,i,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.zoomOut=t.zoomIn=t.applyZoom=void 0;function M(m){i.webFrame.setZoomLevel(m),(0,y.setZoomFactor)((0,B.zoomLevelToZoomFactor)(m)),(0,y.setZoomLevel)(m,!1)}t.applyZoom=M;function E(){M((0,y.getZoomLevel)()+1)}t.zoomIn=E;function w(){M((0,y.getZoomLevel)()-1)}t.zoomOut=w}),define(me[145],pe([1,0,9,4,128,8,129,29,134,135,136,138,142,144,94,85]),function(J,t,y,i,B,M,E,w,m,f,g,F,l,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.startup=void 0;const e=/\s--(inspect|debug)(-brk|port)?=(\d+)?/,p=/\s--(inspect|debug)-port=(\d+)/;class D{getHeight(h){return 22}getTemplateId(h){return C(h)?"process":S(h)?"machine":(0,m.isRemoteDiagnosticError)(h)?"error":A(h)?"header":""}}class v{hasChildren(h){return(0,m.isRemoteDiagnosticError)(h)?!1:C(h)?!!h.children?.length:!0}getChildren(h){return C(h)?h.children?h.children:[]:(0,m.isRemoteDiagnosticError)(h)?[]:A(h)?h.processRoots.length>1?h.processRoots:[h.processRoots[0].rootProcess]:S(h)?[h.rootProcess]:[h.processes]}}class _{constructor(){this.templateId="header"}renderTemplate(h){const O=Object.create(null),V=(0,i.append)(h,(0,i.$)(".row"));return O.name=(0,i.append)(V,(0,i.$)(".nameLabel")),O.CPU=(0,i.append)(V,(0,i.$)(".cpu")),O.memory=(0,i.append)(V,(0,i.$)(".memory")),O.PID=(0,i.append)(V,(0,i.$)(".pid")),O}renderElement(h,O,V,ue){V.name.textContent=(0,y.localize)(0,null),V.CPU.textContent=(0,y.localize)(1,null),V.PID.textContent=(0,y.localize)(2,null),V.memory.textContent=(0,y.localize)(3,null)}disposeTemplate(h){}}class a{constructor(){this.templateId="machine"}renderTemplate(h){const O=Object.create(null),V=(0,i.append)(h,(0,i.$)(".row"));return O.name=(0,i.append)(V,(0,i.$)(".nameLabel")),O}renderElement(h,O,V,ue){V.name.textContent=h.element.name}disposeTemplate(h){}}class o{constructor(){this.templateId="error"}renderTemplate(h){const O=Object.create(null),V=(0,i.append)(h,(0,i.$)(".row"));return O.name=(0,i.append)(V,(0,i.$)(".nameLabel")),O}renderElement(h,O,V,ue){V.name.textContent=h.element.errorMessage}disposeTemplate(h){}}class b{constructor(h,O,V){this.platform=h,this.totalMem=O,this.mapPidToWindowTitle=V,this.templateId="process"}renderTemplate(h){const O=Object.create(null),V=(0,i.append)(h,(0,i.$)(".row"));return O.name=(0,i.append)(V,(0,i.$)(".nameLabel")),O.CPU=(0,i.append)(V,(0,i.$)(".cpu")),O.memory=(0,i.append)(V,(0,i.$)(".memory")),O.PID=(0,i.append)(V,(0,i.$)(".pid")),O}renderElement(h,O,V,ue){const{element:ie}=h;let ge=ie.name;ge==="window"&&(ge=this.mapPidToWindowTitle.get(ie.pid)!==void 0?`${ge} (${this.mapPidToWindowTitle.get(ie.pid)})`:ge);const ae=ie.pid.toFixed(0);V.name.textContent=ge,V.name.title=ie.cmd,V.CPU.textContent=ie.load.toFixed(0),V.PID.textContent=ae,V.PID.parentElement.id=`pid-${ae}`;const we=this.platform==="win32"?ie.mem:this.totalMem*(ie.mem/100);V.memory.textContent=(we/f.ByteSize.MB).toFixed(0)}disposeTemplate(h){}}function S(u){return!!u.name&&!!u.rootProcess}function A(u){return!!u.processRoots}function C(u){return!!u.pid}class r{constructor(h,O){this.data=O,this.mapPidToWindowTitle=new Map;const V=new g.ElectronIPCMainProcessService(h);this.nativeHostService=new F.NativeHostService(h,V),this.applyStyles(O.styles),this.setEventHandlers(O),w.ipcRenderer.on("vscode:windowsInfoResponse",(ue,ie)=>{this.mapPidToWindowTitle=new Map,ie.forEach(ge=>this.mapPidToWindowTitle.set(ge.pid,ge.title))}),w.ipcRenderer.on("vscode:listProcessesResponse",async(ue,ie)=>{ie.forEach((ge,ae)=>{C(ge.rootProcess)&&(ge.rootProcess.name=ae===0?`${this.data.applicationName} main`:"remote agent")}),this.tree?(this.tree.setInput({processes:{processRoots:ie}}),this.tree.layout(window.innerHeight,window.innerWidth)):await this.createProcessTree(ie),this.requestProcessList(0)}),this.lastRequestTime=Date.now(),w.ipcRenderer.send("vscode:windowsInfoRequest"),w.ipcRenderer.send("vscode:listProcesses")}setEventHandlers(h){document.onkeydown=O=>{const V=h.platform==="darwin"?O.metaKey:O.ctrlKey;V&&O.keyCode===87&&(O.stopPropagation(),O.preventDefault(),w.ipcRenderer.send("vscode:closeProcessExplorer")),V&&O.keyCode===187&&(0,s.zoomIn)(),V&&O.keyCode===189&&(0,s.zoomOut)()}}async createProcessTree(h){const O=document.getElementById("process-list");if(!O)return;const{totalmem:V}=await this.nativeHostService.getOSStatistics(),ue=[new b(this.data.platform,V,this.mapPidToWindowTitle),new _,new a,new o];this.tree=new B.DataTree("processExplorer",O,new D,ue,new v,{identityProvider:{getId:ie=>C(ie)?ie.pid.toString():(0,m.isRemoteDiagnosticError)(ie)?ie.hostName:A(ie)?"processes":S(ie)?ie.name:"header"}}),this.tree.setInput({processes:{processRoots:h}}),this.tree.layout(window.innerHeight,window.innerWidth),this.tree.onContextMenu(ie=>{C(ie.element)&&this.showContextMenu(ie.element,!0)}),O.style.height=`${window.innerHeight}px`,window.addEventListener("resize",()=>{O.style.height=`${window.innerHeight}px`,this.tree?.layout(window.innerHeight,window.innerWidth)})}isDebuggable(h){const O=e.exec(h);return O&&O.length>=2||h.indexOf("node ")>=0||h.indexOf("node.exe")>=0}attachTo(h){const O={type:"node",request:"attach",name:`process ${h.pid}`};let V=e.exec(h.cmd);V&&V.length>=2?(V.length===4&&V[3]&&(O.port=parseInt(V[3])),O.protocol=V[1]==="debug"?"legacy":"inspector"):O.processId=String(h.pid),V=p.exec(h.cmd),V&&V.length===3&&(O.port=parseInt(V[2])),w.ipcRenderer.send("vscode:workbenchCommand",{id:"debug.startFromConfig",from:"processExplorer",args:[O]})}applyStyles(h){const O=(0,i.createStyleSheet)(),V=[];h.listFocusBackground&&(V.push(`.monaco-list:focus .monaco-list-row.focused { background-color: ${h.listFocusBackground}; }`),V.push(`.monaco-list:focus .monaco-list-row.focused:hover { background-color: ${h.listFocusBackground}; }`)),h.listFocusForeground&&V.push(`.monaco-list:focus .monaco-list-row.focused { color: ${h.listFocusForeground}; }`),h.listActiveSelectionBackground&&(V.push(`.monaco-list:focus .monaco-list-row.selected { background-color: ${h.listActiveSelectionBackground}; }`),V.push(`.monaco-list:focus .monaco-list-row.selected:hover { background-color: ${h.listActiveSelectionBackground}; }`)),h.listActiveSelectionForeground&&V.push(`.monaco-list:focus .monaco-list-row.selected { color: ${h.listActiveSelectionForeground}; }`),h.listHoverBackground&&V.push(`.monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${h.listHoverBackground}; }`),h.listHoverForeground&&V.push(`.monaco-list-row:hover:not(.selected):not(.focused) { color: ${h.listHoverForeground}; }`),h.listFocusOutline&&V.push(`.monaco-list:focus .monaco-list-row.focused { outline: 1px solid ${h.listFocusOutline}; outline-offset: -1px; }`),h.listHoverOutline&&V.push(`.monaco-list-row:hover { outline: 1px dashed ${h.listHoverOutline}; outline-offset: -1px; }`),h.scrollbarShadowColor&&V.push(`
				.monaco-scrollable-element > .shadow.top {
					box-shadow: ${h.scrollbarShadowColor} 0 6px 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.left {
					box-shadow: ${h.scrollbarShadowColor} 6px 0 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.top.left {
					box-shadow: ${h.scrollbarShadowColor} 6px 6px 6px -6px inset;
				}
			`),h.scrollbarSliderBackgroundColor&&V.push(`
				.monaco-scrollable-element > .scrollbar > .slider {
					background: ${h.scrollbarSliderBackgroundColor};
				}
			`),h.scrollbarSliderHoverBackgroundColor&&V.push(`
				.monaco-scrollable-element > .scrollbar > .slider:hover {
					background: ${h.scrollbarSliderHoverBackgroundColor};
				}
			`),h.scrollbarSliderActiveBackgroundColor&&V.push(`
				.monaco-scrollable-element > .scrollbar > .slider.active {
					background: ${h.scrollbarSliderActiveBackgroundColor};
				}
			`),O.textContent=V.join(`
`),h.color&&(document.body.style.color=h.color)}showContextMenu(h,O){const V=[],ue=Number(h.pid);O&&(V.push({label:(0,y.localize)(4,null),click:()=>{this.nativeHostService.killProcess(ue,"SIGTERM")}}),V.push({label:(0,y.localize)(5,null),click:()=>{this.nativeHostService.killProcess(ue,"SIGKILL")}}),V.push({type:"separator"})),V.push({label:(0,y.localize)(6,null),click:()=>{const ie=this.tree?.getSelection()?.map(ae=>{if(!(!ae||!("pid"in ae)))return ae.pid}).filter(ae=>!!ae);ie?.includes(ue)||(ie.length=0,ie.push(ue));const ge=ie?.map(ae=>document.getElementById(`pid-${ae}`)).filter(ae=>!!ae);if(ge){const ae=ge.map(we=>we.innerText).filter(we=>!!we);this.nativeHostService.writeClipboardText(ae.join(`
`))}}}),V.push({label:(0,y.localize)(7,null),click:()=>{const ie=document.getElementById("process-list");ie&&this.nativeHostService.writeClipboardText(ie.innerText)}}),h&&O&&this.isDebuggable(h.cmd)&&(V.push({type:"separator"}),V.push({label:(0,y.localize)(8,null),click:()=>{this.attachTo(h)}})),(0,E.popup)(V)}requestProcessList(h){setTimeout(()=>{const O=Date.now(),V=h+O-this.lastRequestTime;this.lastRequestTime=O,V>1e3?(w.ipcRenderer.send("vscode:windowsInfoRequest"),w.ipcRenderer.send("vscode:listProcesses")):this.requestProcessList(V)},200)}}function n(){const u=(0,i.createStyleSheet)();u.id="codiconStyles";const h=(0,l.getIconsStyleSheet)(void 0);function O(){u.textContent=h.getCSS()}const V=new M.RunOnceScheduler(O,0);h.onDidChange(()=>V.schedule()),V.schedule()}function c(u){const h=u.data.platform==="win32"?"windows":u.data.platform==="linux"?"linux":"mac";document.body.classList.add(h),n(),(0,s.applyZoom)(u.data.zoomLevel),new r(u.windowId,u.data)}t.startup=c})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/7fee053fdfef9bd86da74dc3c223b95019c5d297/core/vs/code/electron-sandbox/processExplorer/processExplorerMain.js.map
