/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var De=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/errors","vs/base/common/platform","vs/base/common/network","vs/base/common/types","vs/platform/log/common/log","vs/workbench/api/common/extHostRpcService","vs/workbench/api/common/extHostTypeConverters","vs/base/common/arrays","vs/base/common/async","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/buffer","vs/base/common/objects","vs/base/common/map","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/platform/extensions/common/extensions","vs/base/node/pfs","vs/workbench/services/search/common/search","vs/base/common/extpath","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/uuid","vs/editor/common/core/range","vs/base/common/glob","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/process","vs/base/common/severity","vs/platform/files/common/files","vs/platform/registry/common/platform","child_process","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","vs/editor/common/core/position","vs/base/common/errorMessage","vs/base/common/stopwatch","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTunnelService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/base/common/decorators","vs/base/common/functional","vs/base/common/iterator","vs/base/common/hash","vs/base/common/marshalling","fs","vs/editor/common/languages","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/codicons","vs/base/common/collections","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/normalization","os","vs/platform/instantiation/common/extensions","vs/platform/configuration/common/configuration","vs/platform/extensionManagement/common/extensionManagement","vs/platform/instantiation/common/serviceCollection","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/common/webview","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/stream","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/base/common/mime","vs/base/common/processes","vs/base/common/filters","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/uriIpc","vs/base/node/extpath","vs/base/node/processes","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.net","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/platform/tunnel/common/tunnel","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostTelemetryLogService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/json","vs/base/common/marked/marked","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/cache","vs/base/common/iconLabels","vs/editor/common/languageSelector","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/tokenizationRegistry","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/uriTransformer","vs/workbench/common/editor","vs/workbench/api/common/extHostCodeInsets","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","net","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostCLIServer","http","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/node/proxyResolver","vs/workbench/api/node/extHostExtensionService","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","https","tls","vscode-proxy-agent","events","vscode-regexpp","vs/workbench/api/node/extensionHostProcess","minimist"],Ie=function(Z){for(var e=[],u=0,t=Z.length;u<t;u++)e[u]=De[Z[u]];return e};define(De[48],Ie([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.ok=void 0;function u(D,P){if(!D)throw new Error(P?`Assertion failed (${P})`:"Assertion Failed")}e.ok=u;function t(D,P="Unreachable"){throw new Error(P)}e.assertNever=t}),define(De[76],Ie([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function u(y){return y?y.replace(/\$\((.*?)\)/g,(C,E)=>` ${E} `).trim():""}e.getCodiconAriaLabel=u;class t{constructor(C,E,I){this.id=C,this.definition=E,this.description=I,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",t.circleFilled.definition),t.closeDirty=new t("close-dirty",t.circleFilled.definition),t.terminalDecorationSuccess=new t("terminal-decoration-success",t.circleFilled.definition),t.debugBreakpoint=new t("debug-breakpoint",t.circleFilled.definition),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",t.circleFilled.definition),t.debugHint=new t("debug-hint",t.circleFilled.definition),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circle=new t("circle",{fontCharacter:"\\eabc"}),t.circleOutline=new t("circle-outline",t.circle.definition),t.terminalDecorationIncomplete=new t("terminal-decoration-incomplete",t.circle.definition),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",t.circle.definition),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.terminalDecorationMark=new t("terminal-decoration-mark",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLarge=new t("circle-large",{fontCharacter:"\\ebb5"}),t.circleLargeOutline=new t("circle-large-outline",t.circleLarge.definition),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.terminalDecorationError=new t("terminal-decoration-error",t.errorSmall.definition),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\ec09"}),t.commentUnresolved=new t("comment-unresolved",{fontCharacter:"\\ec0a"}),t.gitPullRequestGoToChanges=new t("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),t.gitPullRequestNewChanges=new t("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function D(y,C){const E=["codicon","codicon-"+y];return C&&E.push("codicon-modifier-"+C),E}e.getClassNamesArray=D;var P;(function(y){y.iconNameSegment="[A-Za-z0-9]+",y.iconNameExpression="[A-Za-z0-9-]+",y.iconModifierExpression="~[A-Za-z]+",y.iconNameCharacter="[A-Za-z0-9~-]";const C=new RegExp(`^(${y.iconNameExpression})(${y.iconModifierExpression})?$`);function E(k){if(k instanceof t)return["codicon","codicon-"+k.id];const _=C.exec(k.id);if(!_)return E(t.error);const[,T,w]=_,b=["codicon","codicon-"+T];return w&&b.push("codicon-modifier-"+w.substr(1)),b}y.asClassNameArray=E;function I(k){return E(k).join(" ")}y.asClassName=I;function R(k){return"."+E(k).join(".")}y.asCSSSelector=R})(P=e.CSSIcon||(e.CSSIcon={}))}),define(De[77],Ie([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function u(y,C){const E=Object.create(null);for(const I of y){const R=C(I);let k=E[R];k||(k=E[R]=[]),k.push(I)}return E}e.groupBy=u;function t(y,C){const E=[],I=[];for(const R of y)C.has(R)||E.push(R);for(const R of C)y.has(R)||I.push(R);return{removed:E,added:I}}e.diffSets=t;function D(y,C){const E=[],I=[];for(const[R,k]of y)C.has(R)||E.push(k);for(const[R,k]of C)y.has(R)||I.push(k);return{removed:E,added:I}}e.diffMaps=D;class P{constructor(){this.map=new Map}add(C,E){let I=this.map.get(C);I||(I=new Set,this.map.set(C,I)),I.add(E)}delete(C,E){const I=this.map.get(C);!I||(I.delete(E),I.size===0&&this.map.delete(C))}forEach(C,E){const I=this.map.get(C);!I||I.forEach(E)}}e.SetMap=P}),define(De[57],Ie([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function u(y){return(C,E,I)=>{let R=null,k=null;if(typeof I.value=="function"?(R="value",k=I.value):typeof I.get=="function"&&(R="get",k=I.get),!k)throw new Error("not supported");I[R]=y(k,E)}}e.createDecorator=u;function t(y,C,E){let I=null,R=null;if(typeof E.value=="function"?(I="value",R=E.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof E.get=="function"&&(I="get",R=E.get),!R)throw new Error("not supported");const k=`$memoize$${C}`;E[I]=function(..._){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,_)}),this[k]}}e.memoize=t;function D(y,C,E){return u((I,R)=>{const k=`$debounce$${R}`,_=`$debounce$result$${R}`;return function(...T){this[_]||(this[_]=E?E():void 0),clearTimeout(this[k]),C&&(this[_]=C(this[_],...T),T=[this[_]]),this[k]=setTimeout(()=>{I.apply(this,T),this[_]=E?E():void 0},y)}})}e.debounce=D;function P(y,C,E){return u((I,R)=>{const k=`$throttle$timer$${R}`,_=`$throttle$result$${R}`,T=`$throttle$lastRun$${R}`,w=`$throttle$pending$${R}`;return function(...b){if(this[_]||(this[_]=E?E():void 0),(this[T]===null||this[T]===void 0)&&(this[T]=-Number.MAX_VALUE),C&&(this[_]=C(this[_],...b)),this[w])return;const v=this[T]+y;v<=Date.now()?(this[T]=Date.now(),I.apply(this,[this[_]]),this[_]=E?E():void 0):(this[w]=!0,this[k]=setTimeout(()=>{this[w]=!1,this[T]=Date.now(),I.apply(this,[this[_]]),this[_]=E?E():void 0},v-Date.now()))}})}e.throttle=P}),define(De[10],Ie([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class u{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(c){setTimeout(()=>{throw c.stack?p.isErrorNoTelemetry(c)?new p(c.message+`

`+c.stack):new Error(c.message+`

`+c.stack):c},0)}}addListener(c){return this.listeners.push(c),()=>{this._removeListener(c)}}emit(c){this.listeners.forEach(l=>{l(c)})}_removeListener(c){this.listeners.splice(this.listeners.indexOf(c),1)}setUnexpectedErrorHandler(c){this.unexpectedErrorHandler=c}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(c){this.unexpectedErrorHandler(c),this.emit(c)}onUnexpectedExternalError(c){this.unexpectedErrorHandler(c)}}e.ErrorHandler=u,e.errorHandler=new u;function t(m){e.errorHandler.setUnexpectedErrorHandler(m)}e.setUnexpectedErrorHandler=t;function D(m){E(m)||e.errorHandler.onUnexpectedError(m)}e.onUnexpectedError=D;function P(m){E(m)||e.errorHandler.onUnexpectedExternalError(m)}e.onUnexpectedExternalError=P;function y(m){if(m instanceof Error){const{name:c,message:l}=m,s=m.stacktrace||m.stack;return{$isError:!0,name:c,message:l,stack:s,noTelemetry:p.isErrorNoTelemetry(m)}}return m}e.transformErrorForSerialization=y;const C="Canceled";function E(m){return m instanceof I?!0:m instanceof Error&&m.name===C&&m.message===C}e.isCancellationError=E;class I extends Error{constructor(){super(C);this.name=this.message}}e.CancellationError=I;function R(){const m=new Error(C);return m.name=m.message,m}e.canceled=R;function k(m){return m?new Error(`Illegal argument: ${m}`):new Error("Illegal argument")}e.illegalArgument=k;function _(m){return m?new Error(`Illegal state: ${m}`):new Error("Illegal state")}e.illegalState=_;function T(m){return m?new Error(`readonly property '${m} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=T;function w(m){const c=new Error(`${m} has been disposed`);return c.name="DISPOSED",c}e.disposed=w;function b(m){return m?m.message?m.message:m.stack?m.stack.split(`
`)[0]:String(m):"Error"}e.getErrorMessage=b;class v extends Error{constructor(c){super("NotImplemented");c&&(this.message=c)}}e.NotImplementedError=v;class h extends Error{constructor(c){super("NotSupported");c&&(this.message=c)}}e.NotSupportedError=h;class g extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=g;class p extends Error{constructor(c){super(c);this.name="ErrorNoTelemetry"}static fromError(c){if(c instanceof p)return c;const l=new p;return l.message=c.message,l.stack=c.stack,l}static isErrorNoTelemetry(c){return c.name==="ErrorNoTelemetry"}}e.ErrorNoTelemetry=p;class o extends Error{constructor(c){super(c||"An unexpected bug occurred.");Object.setPrototypeOf(this,o.prototype);debugger}}e.BugIndicatingError=o}),define(De[17],Ie([1,0,10]),function(Z,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function t(ae,de=0){return ae[ae.length-(1+de)]}e.tail=t;function D(ae){if(ae.length===0)throw new Error("Invalid tail call");return[ae.slice(0,ae.length-1),ae[ae.length-1]]}e.tail2=D;function P(ae,de,me=(te,le)=>te===le){if(ae===de)return!0;if(!ae||!de||ae.length!==de.length)return!1;for(let te=0,le=ae.length;te<le;te++)if(!me(ae[te],de[te]))return!1;return!0}e.equals=P;function y(ae,de){const me=ae.length-1;de<me&&(ae[de]=ae[me]),ae.pop()}e.removeFastWithoutKeepingOrder=y;function C(ae,de,me){return E(ae.length,te=>me(ae[te],de))}e.binarySearch=C;function E(ae,de){let me=0,te=ae-1;for(;me<=te;){const le=(me+te)/2|0,ee=de(le);if(ee<0)me=le+1;else if(ee>0)te=le-1;else return le}return-(me+1)}e.binarySearch2=E;function I(ae,de){let me=0,te=ae.length;if(te===0)return 0;for(;me<te;){const le=Math.floor((me+te)/2);de(ae[le])?te=le:me=le+1}return me}e.findFirstInSorted=I;function R(ae,de,me){if(ae=ae|0,ae>=de.length)throw new TypeError("invalid index");const te=de[Math.floor(de.length*Math.random())],le=[],ee=[],re=[];for(const F of de){const W=me(F,te);W<0?le.push(F):W>0?ee.push(F):re.push(F)}return ae<le.length?R(ae,le,me):ae<le.length+re.length?re[0]:R(ae-(le.length+re.length),ee,me)}e.quickSelect=R;function k(ae,de){const me=[];let te;for(const le of ae.slice(0).sort(de))!te||de(te[0],le)!==0?(te=[le],me.push(te)):te.push(le);return me}e.groupBy=k;function _(ae,de,me){const te=[];function le(F,W,G){if(W===0&&G.length===0)return;const Q=te[te.length-1];Q&&Q.start+Q.deleteCount===F?(Q.deleteCount+=W,Q.toInsert.push(...G)):te.push({start:F,deleteCount:W,toInsert:G})}let ee=0,re=0;for(;;){if(ee===ae.length){le(ee,0,de.slice(re));break}if(re===de.length){le(ee,ae.length-ee,[]);break}const F=ae[ee],W=de[re],G=me(F,W);G===0?(ee+=1,re+=1):G<0?(le(ee,1,[]),ee+=1):G>0&&(le(ee,0,[W]),re+=1)}return te}e.sortedDiff=_;function T(ae,de,me){const te=_(ae,de,me),le=[],ee=[];for(const re of te)le.push(...ae.slice(re.start,re.start+re.deleteCount)),ee.push(...re.toInsert);return{removed:le,added:ee}}e.delta=T;function w(ae,de,me){if(me===0)return[];const te=ae.slice(0,me).sort(de);return v(ae,de,te,me,ae.length),te}e.top=w;function b(ae,de,me,te,le){return me===0?Promise.resolve([]):new Promise((ee,re)=>{(async()=>{const F=ae.length,W=ae.slice(0,me).sort(de);for(let G=me,Q=Math.min(me+te,F);G<F;G=Q,Q=Math.min(Q+te,F)){if(G>me&&await new Promise(fe=>setTimeout(fe)),le&&le.isCancellationRequested)throw new u.CancellationError;v(ae,de,W,G,Q)}return W})().then(ee,re)})}e.topAsync=b;function v(ae,de,me,te,le){for(const ee=me.length;te<le;te++){const re=ae[te];if(de(re,me[ee-1])<0){me.pop();const F=I(me,W=>de(re,W)<0);me.splice(F,0,re)}}}function h(ae){return ae.filter(de=>!!de)}e.coalesce=h;function g(ae){let de=0;for(let me=0;me<ae.length;me++)ae[me]&&(ae[de]=ae[me],de+=1);ae.length=de}e.coalesceInPlace=g;function p(ae,de,me){ae.splice(me,0,ae.splice(de,1)[0])}e.move=p;function o(ae){return!Array.isArray(ae)||ae.length===0}e.isFalsyOrEmpty=o;function m(ae){return Array.isArray(ae)&&ae.length>0}e.isNonEmptyArray=m;function c(ae,de=me=>me){const me=new Set;return ae.filter(te=>{const le=de(te);return me.has(le)?!1:(me.add(le),!0)})}e.distinct=c;function l(ae){const de=new Set;return me=>{const te=ae(me);return de.has(te)?!1:(de.add(te),!0)}}e.uniqueFilter=l;function s(ae,de){const me=i(ae,de);if(me!==-1)return ae[me]}e.findLast=s;function i(ae,de){for(let me=ae.length-1;me>=0;me--){const te=ae[me];if(de(te))return me}return-1}e.lastIndex=i;function r(ae,de){return ae.length>0?ae[0]:de}e.firstOrDefault=r;function n(ae,de){return ae.length>0?ae[ae.length-1]:de}e.lastOrDefault=n;function a(ae,de,me=(te,le)=>te===le){let te=0;for(let le=0,ee=Math.min(ae.length,de.length);le<ee&&me(ae[le],de[le]);le++)te++;return te}e.commonPrefixLength=a;function d(ae){return[].concat(...ae)}e.flatten=d;function f(ae,de){let me=typeof de=="number"?ae:0;typeof de=="number"?me=ae:(me=0,de=ae);const te=[];if(me<=de)for(let le=me;le<de;le++)te.push(le);else for(let le=me;le>de;le--)te.push(le);return te}e.range=f;function S(ae,de,me){return ae.reduce((te,le)=>(te[de(le)]=me?me(le):le,te),Object.create(null))}e.index=S;function O(ae,de){return ae.push(de),()=>U(ae,de)}e.insert=O;function U(ae,de){const me=ae.indexOf(de);if(me>-1)return ae.splice(me,1),de}e.remove=U;function M(ae,de,me){const te=ae.slice(0,de),le=ae.slice(de);return te.concat(me,le)}e.arrayInsert=M;function A(ae,de){let me;if(typeof de=="number"){let te=de;me=()=>{const le=Math.sin(te++)*179426549;return le-Math.floor(le)}}else me=Math.random;for(let te=ae.length-1;te>0;te-=1){const le=Math.floor(me()*(te+1)),ee=ae[te];ae[te]=ae[le],ae[le]=ee}}e.shuffle=A;function B(ae,de){const me=ae.indexOf(de);me>-1&&(ae.splice(me,1),ae.unshift(de))}e.pushToStart=B;function x(ae,de){const me=ae.indexOf(de);me>-1&&(ae.splice(me,1),ae.push(de))}e.pushToEnd=x;function N(ae,de){for(const me of de)ae.push(me)}e.pushMany=N;function K(ae,de){return Array.isArray(ae)?ae.map(de):de(ae)}e.mapArrayOrNot=K;function X(ae){return Array.isArray(ae)?ae:[ae]}e.asArray=X;function L(ae){return ae[Math.floor(Math.random()*ae.length)]}e.getRandomElement=L;function $(ae,de){for(const me of ae){const te=de(me);if(te!==void 0)return te}}e.mapFind=$;function H(ae,de,me){const te=J(ae,de),le=ae.length,ee=me.length;ae.length=le+ee;for(let re=le-1;re>=te;re--)ae[re+ee]=ae[re];for(let re=0;re<ee;re++)ae[re+te]=me[re]}e.insertInto=H;function j(ae,de,me,te){const le=J(ae,de),ee=ae.splice(le,me);return H(ae,le,te),ee}e.splice=j;function J(ae,de){return de<0?Math.max(de+ae.length,0):Math.min(de,ae.length)}var Y;(function(ae){function de(le){return le<0}ae.isLessThan=de;function me(le){return le>0}ae.isGreaterThan=me;function te(le){return le===0}ae.isNeitherLessOrGreaterThan=te,ae.greaterThan=1,ae.lessThan=-1,ae.neitherLessOrGreaterThan=0})(Y=e.CompareResult||(e.CompareResult={}));function he(ae,de){return(me,te)=>de(ae(me),ae(te))}e.compareBy=he;function ve(...ae){return(de,me)=>{for(const te of ae){const le=te(de,me);if(!Y.isNeitherLessOrGreaterThan(le))return le}return Y.neitherLessOrGreaterThan}}e.tieBreakComparators=ve;const ne=(ae,de)=>ae-de;e.numberComparator=ne;function pe(ae,de){if(ae.length===0)return;let me=ae[0];for(let te=1;te<ae.length;te++){const le=ae[te];de(le,me)>0&&(me=le)}return me}e.findMaxBy=pe;function Ee(ae,de){if(ae.length===0)return;let me=ae[0];for(let te=1;te<ae.length;te++){const le=ae[te];de(le,me)>=0&&(me=le)}return me}e.findLastMaxBy=Ee;function ke(ae,de){return pe(ae,(me,te)=>-de(me,te))}e.findMinBy=ke;class Oe{constructor(de){this.items=de,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(de){let me=this.firstIdx;for(;me<this.items.length&&de(this.items[me]);)me++;const te=me===this.firstIdx?null:this.items.slice(this.firstIdx,me);return this.firstIdx=me,te}takeFromEndWhile(de){let me=this.lastIdx;for(;me>=0&&de(this.items[me]);)me--;const te=me===this.lastIdx?null:this.items.slice(me+1,this.lastIdx+1);return this.lastIdx=me,te}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const de=this.items[this.firstIdx];return this.firstIdx++,de}removeLast(){const de=this.items[this.lastIdx];return this.lastIdx--,de}takeCount(de){const me=this.items.slice(this.firstIdx,this.firstIdx+de);return this.firstIdx+=de,me}}e.ArrayQueue=Oe;class Be{constructor(de){this.iterate=de}forEach(de){this.iterate(me=>(de(me),!0))}toArray(){const de=[];return this.iterate(me=>(de.push(me),!0)),de}filter(de){return new Be(me=>this.iterate(te=>de(te)?me(te):!0))}map(de){return new Be(me=>this.iterate(te=>me(de(te))))}some(de){let me=!1;return this.iterate(te=>(me=de(te),!me)),me}findFirst(de){let me;return this.iterate(te=>de(te)?(me=te,!1):!0),me}findLast(de){let me;return this.iterate(te=>(de(te)&&(me=te),!0)),me}findLastMaxBy(de){let me,te=!0;return this.iterate(le=>((te||Y.isGreaterThan(de(le,me)))&&(te=!1,me=le),!0)),me}}e.CallbackIterable=Be,Be.empty=new Be(ae=>{})}),define(De[58],Ie([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function u(t){const D=this;let P=!1,y;return function(){return P||(P=!0,y=t.apply(D,arguments)),y}}e.once=u}),define(De[93],Ie([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class u{constructor(D){this._prefix=D,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=u,e.defaultGenerator=new u("id#")}),define(De[59],Ie([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var u;(function(t){function D(l){return l&&typeof l=="object"&&typeof l[Symbol.iterator]=="function"}t.is=D;const P=Object.freeze([]);function y(){return P}t.empty=y;function*C(l){yield l}t.single=C;function E(l){return l||P}t.from=E;function I(l){return!l||l[Symbol.iterator]().next().done===!0}t.isEmpty=I;function R(l){return l[Symbol.iterator]().next().value}t.first=R;function k(l,s){for(const i of l)if(s(i))return!0;return!1}t.some=k;function _(l,s){for(const i of l)if(s(i))return i}t.find=_;function*T(l,s){for(const i of l)s(i)&&(yield i)}t.filter=T;function*w(l,s){let i=0;for(const r of l)yield s(r,i++)}t.map=w;function*b(...l){for(const s of l)for(const i of s)yield i}t.concat=b;function*v(l){for(const s of l)for(const i of s)yield i}t.concatNested=v;function h(l,s,i){let r=i;for(const n of l)r=s(r,n);return r}t.reduce=h;function g(l,s){let i=0;for(const r of l)s(r,i++)}t.forEach=g;function*p(l,s,i=l.length){for(s<0&&(s+=l.length),i<0?i+=l.length:i>l.length&&(i=l.length);s<i;s++)yield l[s]}t.slice=p;function o(l,s=Number.POSITIVE_INFINITY){const i=[];if(s===0)return[i,l];const r=l[Symbol.iterator]();for(let n=0;n<s;n++){const a=r.next();if(a.done)return[i,t.empty()];i.push(a.value)}return[i,{[Symbol.iterator](){return r}}]}t.consume=o;function m(l){return o(l)[0]}t.collect=m;function c(l,s,i=(r,n)=>r===n){const r=l[Symbol.iterator](),n=s[Symbol.iterator]();for(;;){const a=r.next(),d=n.next();if(a.done!==d.done)return!1;if(a.done)return!0;if(!i(a.value,d.value))return!1}}t.equals=c})(u=e.Iterable||(e.Iterable={}))}),define(De[142],Ie([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var u;(function(c){c[c.None=0]="None",c[c.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",c[c.UnexpectedEndOfString=2]="UnexpectedEndOfString",c[c.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",c[c.InvalidUnicode=4]="InvalidUnicode",c[c.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",c[c.InvalidCharacter=6]="InvalidCharacter"})(u=e.ScanError||(e.ScanError={}));var t;(function(c){c[c.OpenBraceToken=1]="OpenBraceToken",c[c.CloseBraceToken=2]="CloseBraceToken",c[c.OpenBracketToken=3]="OpenBracketToken",c[c.CloseBracketToken=4]="CloseBracketToken",c[c.CommaToken=5]="CommaToken",c[c.ColonToken=6]="ColonToken",c[c.NullKeyword=7]="NullKeyword",c[c.TrueKeyword=8]="TrueKeyword",c[c.FalseKeyword=9]="FalseKeyword",c[c.StringLiteral=10]="StringLiteral",c[c.NumericLiteral=11]="NumericLiteral",c[c.LineCommentTrivia=12]="LineCommentTrivia",c[c.BlockCommentTrivia=13]="BlockCommentTrivia",c[c.LineBreakTrivia=14]="LineBreakTrivia",c[c.Trivia=15]="Trivia",c[c.Unknown=16]="Unknown",c[c.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(c){c[c.InvalidSymbol=1]="InvalidSymbol",c[c.InvalidNumberFormat=2]="InvalidNumberFormat",c[c.PropertyNameExpected=3]="PropertyNameExpected",c[c.ValueExpected=4]="ValueExpected",c[c.ColonExpected=5]="ColonExpected",c[c.CommaExpected=6]="CommaExpected",c[c.CloseBraceExpected=7]="CloseBraceExpected",c[c.CloseBracketExpected=8]="CloseBracketExpected",c[c.EndOfFileExpected=9]="EndOfFileExpected",c[c.InvalidCommentToken=10]="InvalidCommentToken",c[c.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",c[c.UnexpectedEndOfString=12]="UnexpectedEndOfString",c[c.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",c[c.InvalidUnicode=14]="InvalidUnicode",c[c.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",c[c.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var P;(function(c){c.DEFAULT={allowTrailingComma:!0}})(P=e.ParseOptions||(e.ParseOptions={}));function y(c,l=!1){let s=0;const i=c.length;let r="",n=0,a=16,d=0;function f(x){let N=0,K=0;for(;N<x;){const X=c.charCodeAt(s);if(X>=48&&X<=57)K=K*16+X-48;else if(X>=65&&X<=70)K=K*16+X-65+10;else if(X>=97&&X<=102)K=K*16+X-97+10;else break;s++,N++}return N<x&&(K=-1),K}function S(x){s=x,r="",n=0,a=16,d=0}function O(){const x=s;if(c.charCodeAt(s)===48)s++;else for(s++;s<c.length&&I(c.charCodeAt(s));)s++;if(s<c.length&&c.charCodeAt(s)===46)if(s++,s<c.length&&I(c.charCodeAt(s)))for(s++;s<c.length&&I(c.charCodeAt(s));)s++;else return d=3,c.substring(x,s);let N=s;if(s<c.length&&(c.charCodeAt(s)===69||c.charCodeAt(s)===101))if(s++,(s<c.length&&c.charCodeAt(s)===43||c.charCodeAt(s)===45)&&s++,s<c.length&&I(c.charCodeAt(s))){for(s++;s<c.length&&I(c.charCodeAt(s));)s++;N=s}else d=3;return c.substring(x,N)}function U(){let x="",N=s;for(;;){if(s>=i){x+=c.substring(N,s),d=2;break}const K=c.charCodeAt(s);if(K===34){x+=c.substring(N,s),s++;break}if(K===92){if(x+=c.substring(N,s),s++,s>=i){d=2;break}switch(c.charCodeAt(s++)){case 34:x+='"';break;case 92:x+="\\";break;case 47:x+="/";break;case 98:x+="\b";break;case 102:x+="\f";break;case 110:x+=`
`;break;case 114:x+="\r";break;case 116:x+="	";break;case 117:{const L=f(4);L>=0?x+=String.fromCharCode(L):d=4;break}default:d=5}N=s;continue}if(K>=0&&K<=31)if(E(K)){x+=c.substring(N,s),d=2;break}else d=6;s++}return x}function M(){if(r="",d=0,n=s,s>=i)return n=i,a=17;let x=c.charCodeAt(s);if(C(x)){do s++,r+=String.fromCharCode(x),x=c.charCodeAt(s);while(C(x));return a=15}if(E(x))return s++,r+=String.fromCharCode(x),x===13&&c.charCodeAt(s)===10&&(s++,r+=`
`),a=14;switch(x){case 123:return s++,a=1;case 125:return s++,a=2;case 91:return s++,a=3;case 93:return s++,a=4;case 58:return s++,a=6;case 44:return s++,a=5;case 34:return s++,r=U(),a=10;case 47:{const N=s-1;if(c.charCodeAt(s+1)===47){for(s+=2;s<i&&!E(c.charCodeAt(s));)s++;return r=c.substring(N,s),a=12}if(c.charCodeAt(s+1)===42){s+=2;const K=i-1;let X=!1;for(;s<K;){if(c.charCodeAt(s)===42&&c.charCodeAt(s+1)===47){s+=2,X=!0;break}s++}return X||(s++,d=1),r=c.substring(N,s),a=13}return r+=String.fromCharCode(x),s++,a=16}case 45:if(r+=String.fromCharCode(x),s++,s===i||!I(c.charCodeAt(s)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=O(),a=11;default:for(;s<i&&A(x);)s++,x=c.charCodeAt(s);if(n!==s){switch(r=c.substring(n,s),r){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return r+=String.fromCharCode(x),s++,a=16}}function A(x){if(C(x)||E(x))return!1;switch(x){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function B(){let x;do x=M();while(x>=12&&x<=15);return x}return{setPosition:S,getPosition:()=>s,scan:l?B:M,getToken:()=>a,getTokenValue:()=>r,getTokenOffset:()=>n,getTokenLength:()=>s-n,getTokenError:()=>d}}e.createScanner=y;function C(c){return c===32||c===9||c===11||c===12||c===160||c===5760||c>=8192&&c<=8203||c===8239||c===8287||c===12288||c===65279}function E(c){return c===10||c===13||c===8232||c===8233}function I(c){return c>=48&&c<=57}var R;(function(c){c[c.nullCharacter=0]="nullCharacter",c[c.maxAsciiCharacter=127]="maxAsciiCharacter",c[c.lineFeed=10]="lineFeed",c[c.carriageReturn=13]="carriageReturn",c[c.lineSeparator=8232]="lineSeparator",c[c.paragraphSeparator=8233]="paragraphSeparator",c[c.nextLine=133]="nextLine",c[c.space=32]="space",c[c.nonBreakingSpace=160]="nonBreakingSpace",c[c.enQuad=8192]="enQuad",c[c.emQuad=8193]="emQuad",c[c.enSpace=8194]="enSpace",c[c.emSpace=8195]="emSpace",c[c.threePerEmSpace=8196]="threePerEmSpace",c[c.fourPerEmSpace=8197]="fourPerEmSpace",c[c.sixPerEmSpace=8198]="sixPerEmSpace",c[c.figureSpace=8199]="figureSpace",c[c.punctuationSpace=8200]="punctuationSpace",c[c.thinSpace=8201]="thinSpace",c[c.hairSpace=8202]="hairSpace",c[c.zeroWidthSpace=8203]="zeroWidthSpace",c[c.narrowNoBreakSpace=8239]="narrowNoBreakSpace",c[c.ideographicSpace=12288]="ideographicSpace",c[c.mathematicalSpace=8287]="mathematicalSpace",c[c.ogham=5760]="ogham",c[c._=95]="_",c[c.$=36]="$",c[c._0=48]="_0",c[c._1=49]="_1",c[c._2=50]="_2",c[c._3=51]="_3",c[c._4=52]="_4",c[c._5=53]="_5",c[c._6=54]="_6",c[c._7=55]="_7",c[c._8=56]="_8",c[c._9=57]="_9",c[c.a=97]="a",c[c.b=98]="b",c[c.c=99]="c",c[c.d=100]="d",c[c.e=101]="e",c[c.f=102]="f",c[c.g=103]="g",c[c.h=104]="h",c[c.i=105]="i",c[c.j=106]="j",c[c.k=107]="k",c[c.l=108]="l",c[c.m=109]="m",c[c.n=110]="n",c[c.o=111]="o",c[c.p=112]="p",c[c.q=113]="q",c[c.r=114]="r",c[c.s=115]="s",c[c.t=116]="t",c[c.u=117]="u",c[c.v=118]="v",c[c.w=119]="w",c[c.x=120]="x",c[c.y=121]="y",c[c.z=122]="z",c[c.A=65]="A",c[c.B=66]="B",c[c.C=67]="C",c[c.D=68]="D",c[c.E=69]="E",c[c.F=70]="F",c[c.G=71]="G",c[c.H=72]="H",c[c.I=73]="I",c[c.J=74]="J",c[c.K=75]="K",c[c.L=76]="L",c[c.M=77]="M",c[c.N=78]="N",c[c.O=79]="O",c[c.P=80]="P",c[c.Q=81]="Q",c[c.R=82]="R",c[c.S=83]="S",c[c.T=84]="T",c[c.U=85]="U",c[c.V=86]="V",c[c.W=87]="W",c[c.X=88]="X",c[c.Y=89]="Y",c[c.Z=90]="Z",c[c.ampersand=38]="ampersand",c[c.asterisk=42]="asterisk",c[c.at=64]="at",c[c.backslash=92]="backslash",c[c.bar=124]="bar",c[c.caret=94]="caret",c[c.closeBrace=125]="closeBrace",c[c.closeBracket=93]="closeBracket",c[c.closeParen=41]="closeParen",c[c.colon=58]="colon",c[c.comma=44]="comma",c[c.dot=46]="dot",c[c.doubleQuote=34]="doubleQuote",c[c.equals=61]="equals",c[c.exclamation=33]="exclamation",c[c.greaterThan=62]="greaterThan",c[c.lessThan=60]="lessThan",c[c.minus=45]="minus",c[c.openBrace=123]="openBrace",c[c.openBracket=91]="openBracket",c[c.openParen=40]="openParen",c[c.percent=37]="percent",c[c.plus=43]="plus",c[c.question=63]="question",c[c.semicolon=59]="semicolon",c[c.singleQuote=39]="singleQuote",c[c.slash=47]="slash",c[c.tilde=126]="tilde",c[c.backspace=8]="backspace",c[c.formFeed=12]="formFeed",c[c.byteOrderMark=65279]="byteOrderMark",c[c.tab=9]="tab",c[c.verticalTab=11]="verticalTab"})(R||(R={}));function k(c,l){const s=[],i=new Object;let r;const n={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function d(f,S,O,U){n.value=f,n.offset=S,n.length=O,n.type=U,n.colonOffset=void 0,r=n}try{p(c,{onObjectBegin:(f,S)=>{if(l<=f)throw i;r=void 0,a=l>f,s.push("")},onObjectProperty:(f,S,O)=>{if(l<S||(d(f,S,O,"property"),s[s.length-1]=f,l<=S+O))throw i},onObjectEnd:(f,S)=>{if(l<=f)throw i;r=void 0,s.pop()},onArrayBegin:(f,S)=>{if(l<=f)throw i;r=void 0,s.push(0)},onArrayEnd:(f,S)=>{if(l<=f)throw i;r=void 0,s.pop()},onLiteralValue:(f,S,O)=>{if(l<S||(d(f,S,O,m(f)),l<=S+O))throw i},onSeparator:(f,S,O)=>{if(l<=S)throw i;if(f===":"&&r&&r.type==="property")r.colonOffset=S,a=!1,r=void 0;else if(f===","){const U=s[s.length-1];typeof U=="number"?s[s.length-1]=U+1:(a=!0,s[s.length-1]=""),r=void 0}}})}catch(f){if(f!==i)throw f}return{path:s,previousNode:r,isAtPropertyKey:a,matches:f=>{let S=0;for(let O=0;S<f.length&&O<s.length;O++)if(f[S]===s[O]||f[S]==="*")S++;else if(f[S]!=="**")return!1;return S===f.length}}}e.getLocation=k;function _(c,l=[],s=P.DEFAULT){let i=null,r=[];const n=[];function a(f){Array.isArray(r)?r.push(f):i!==null&&(r[i]=f)}return p(c,{onObjectBegin:()=>{const f={};a(f),n.push(r),r=f,i=null},onObjectProperty:f=>{i=f},onObjectEnd:()=>{r=n.pop()},onArrayBegin:()=>{const f=[];a(f),n.push(r),r=f,i=null},onArrayEnd:()=>{r=n.pop()},onLiteralValue:a,onError:(f,S,O)=>{l.push({error:f,offset:S,length:O})}},s),r[0]}e.parse=_;function T(c,l=[],s=P.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(f){i.type==="property"&&(i.length=f-i.offset,i=i.parent)}function n(f){return i.children.push(f),f}p(c,{onObjectBegin:f=>{i=n({type:"object",offset:f,length:-1,parent:i,children:[]})},onObjectProperty:(f,S,O)=>{i=n({type:"property",offset:S,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:f,offset:S,length:O,parent:i})},onObjectEnd:(f,S)=>{i.length=f+S-i.offset,i=i.parent,r(f+S)},onArrayBegin:(f,S)=>{i=n({type:"array",offset:f,length:-1,parent:i,children:[]})},onArrayEnd:(f,S)=>{i.length=f+S-i.offset,i=i.parent,r(f+S)},onLiteralValue:(f,S,O)=>{n({type:m(f),offset:S,length:O,parent:i,value:f}),r(S+O)},onSeparator:(f,S,O)=>{i.type==="property"&&(f===":"?i.colonOffset=S:f===","&&r(S))},onError:(f,S,O)=>{l.push({error:f,offset:S,length:O})}},s);const d=i.children[0];return d&&delete d.parent,d}e.parseTree=T;function w(c,l){if(!c)return;let s=c;for(const i of l)if(typeof i=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let r=!1;for(const n of s.children)if(Array.isArray(n.children)&&n.children[0].value===i){s=n.children[1],r=!0;break}if(!r)return}else{const r=i;if(s.type!=="array"||r<0||!Array.isArray(s.children)||r>=s.children.length)return;s=s.children[r]}return s}e.findNodeAtLocation=w;function b(c){if(!c.parent||!c.parent.children)return[];const l=b(c.parent);if(c.parent.type==="property"){const s=c.parent.children[0].value;l.push(s)}else if(c.parent.type==="array"){const s=c.parent.children.indexOf(c);s!==-1&&l.push(s)}return l}e.getNodePath=b;function v(c){switch(c.type){case"array":return c.children.map(v);case"object":{const l=Object.create(null);for(const s of c.children){const i=s.children[1];i&&(l[s.children[0].value]=v(i))}return l}case"null":case"string":case"number":case"boolean":return c.value;default:return}}e.getNodeValue=v;function h(c,l,s=!1){return l>=c.offset&&l<c.offset+c.length||s&&l===c.offset+c.length}e.contains=h;function g(c,l,s=!1){if(h(c,l,s)){const i=c.children;if(Array.isArray(i))for(let r=0;r<i.length&&i[r].offset<=l;r++){const n=g(i[r],l,s);if(n)return n}return c}}e.findNodeAtOffset=g;function p(c,l,s=P.DEFAULT){const i=y(c,!1);function r(he){return he?()=>he(i.getTokenOffset(),i.getTokenLength()):()=>!0}function n(he){return he?ve=>he(ve,i.getTokenOffset(),i.getTokenLength()):()=>!0}const a=r(l.onObjectBegin),d=n(l.onObjectProperty),f=r(l.onObjectEnd),S=r(l.onArrayBegin),O=r(l.onArrayEnd),U=n(l.onLiteralValue),M=n(l.onSeparator),A=r(l.onComment),B=n(l.onError),x=s&&s.disallowComments,N=s&&s.allowTrailingComma;function K(){for(;;){const he=i.scan();switch(i.getTokenError()){case 4:X(14);break;case 5:X(15);break;case 3:X(13);break;case 1:x||X(11);break;case 2:X(12);break;case 6:X(16);break}switch(he){case 12:case 13:x?X(10):A();break;case 16:X(1);break;case 15:case 14:break;default:return he}}}function X(he,ve=[],ne=[]){if(B(he),ve.length+ne.length>0){let pe=i.getToken();for(;pe!==17;){if(ve.indexOf(pe)!==-1){K();break}else if(ne.indexOf(pe)!==-1)break;pe=K()}}}function L(he){const ve=i.getTokenValue();return he?U(ve):d(ve),K(),!0}function $(){switch(i.getToken()){case 11:{let he=0;try{he=JSON.parse(i.getTokenValue()),typeof he!="number"&&(X(2),he=0)}catch{X(2)}U(he);break}case 7:U(null);break;case 8:U(!0);break;case 9:U(!1);break;default:return!1}return K(),!0}function H(){return i.getToken()!==10?(X(3,[],[2,5]),!1):(L(!1),i.getToken()===6?(M(":"),K(),Y()||X(4,[],[2,5])):X(5,[],[2,5]),!0)}function j(){a(),K();let he=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(he||X(4,[],[]),M(","),K(),i.getToken()===2&&N)break}else he&&X(6,[],[]);H()||X(4,[],[2,5]),he=!0}return f(),i.getToken()!==2?X(7,[2],[]):K(),!0}function J(){S(),K();let he=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(he||X(4,[],[]),M(","),K(),i.getToken()===4&&N)break}else he&&X(6,[],[]);Y()||X(4,[],[4,5]),he=!0}return O(),i.getToken()!==4?X(8,[4],[]):K(),!0}function Y(){switch(i.getToken()){case 3:return J();case 1:return j();case 10:return L(!0);default:return $()}}return K(),i.getToken()===17?s.allowEmptyContent?!0:(X(4,[],[]),!1):Y()?(i.getToken()!==17&&X(9,[],[]),!0):(X(4,[],[]),!1)}e.visit=p;function o(c,l){const s=y(c),i=[];let r,n=0,a;do switch(a=s.getPosition(),r=s.scan(),r){case 12:case 13:case 17:n!==a&&i.push(c.substring(n,a)),l!==void 0&&i.push(s.getTokenValue().replace(/[^\r\n]/g,l)),n=s.getPosition();break}while(r!==17);return i.join("")}e.stripComments=o;function m(c){switch(typeof c){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(c){if(Array.isArray(c))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=m}),define(De[78],Ie([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class u{constructor(D){this.executor=D,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(D){this._error=D}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(D){return new u(()=>D(this.getValue()))}}e.Lazy=u}),define(De[6],Ie([1,0,58,59]),function(Z,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const D=!1;let P=null;function y(r){P=r}if(e.setDisposableTracker=y,D){const r="__is_disposable_tracked__";y(new class{trackDisposable(n){const a=new Error("Potentially leaked disposable").stack;setTimeout(()=>{n[r]||console.log(a)},3e3)}setParent(n,a){if(n&&n!==g.None)try{n[r]=!0}catch{}}markAsDisposed(n){if(n&&n!==g.None)try{n[r]=!0}catch{}}markAsSingleton(n){}})}function C(r){return P?.trackDisposable(r),r}function E(r){P?.markAsDisposed(r)}function I(r,n){P?.setParent(r,n)}function R(r,n){if(!!P)for(const a of r)P.setParent(a,n)}function k(r){return P?.markAsSingleton(r),r}e.markAsSingleton=k;class _ extends Error{constructor(n){super(`Encountered errors while disposing of store. Errors: [${n.join(", ")}]`);this.errors=n}}e.MultiDisposeError=_;function T(r){return typeof r.dispose=="function"&&r.dispose.length===0}e.isDisposable=T;function w(r){if(t.Iterable.is(r)){const n=[];for(const a of r)if(a)try{a.dispose()}catch(d){n.push(d)}if(n.length===1)throw n[0];if(n.length>1)throw new _(n);return Array.isArray(r)?[]:r}else if(r)return r.dispose(),r}e.dispose=w;function b(...r){const n=v(()=>w(r));return R(r,n),n}e.combinedDisposable=b;function v(r){const n=C({dispose:(0,u.once)(()=>{E(n),r()})});return n}e.toDisposable=v;class h{constructor(){this._toDispose=new Set,this._isDisposed=!1,C(this)}dispose(){this._isDisposed||(E(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{w(this._toDispose.values())}finally{this._toDispose.clear()}}add(n){if(!n)return n;if(n===this)throw new Error("Cannot register a disposable on itself!");return I(n,this),this._isDisposed?h.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(n),n}}e.DisposableStore=h,h.DISABLE_DISPOSED_WARNING=!1;class g{constructor(){this._store=new h,C(this),I(this._store,this)}dispose(){E(this),this._store.dispose()}_register(n){if(n===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(n)}}e.Disposable=g,g.None=Object.freeze({dispose(){}});class p{constructor(){this._isDisposed=!1,C(this)}get value(){return this._isDisposed?void 0:this._value}set value(n){this._isDisposed||n===this._value||(this._value?.dispose(),n&&I(n,this),this._value=n)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,E(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const n=this._value;return this._value=void 0,n&&I(n,null),n}}e.MutableDisposable=p;class o{constructor(n){this._disposable=n,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=o;class m{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,C(this)}set(n){let a=n;return this.unset=()=>a=void 0,this.isset=()=>a!==void 0,this.dispose=()=>{a&&(a(),a=void 0,E(this))},this}}e.SafeDisposable=m;class c{constructor(){this.references=new Map}acquire(n,...a){let d=this.references.get(n);d||(d={counter:0,object:this.createReferencedObject(n,...a)},this.references.set(n,d));const{object:f}=d,S=(0,u.once)(()=>{--d.counter==0&&(this.destroyReferencedObject(n,d.object),this.references.delete(n))});return d.counter++,{object:f,dispose:S}}}e.ReferenceCollection=c;class l{constructor(n){this.referenceCollection=n}async acquire(n,...a){const d=this.referenceCollection.acquire(n,...a);try{return{object:await d.object,dispose:()=>d.dispose()}}catch(f){throw d.dispose(),f}}}e.AsyncReferenceCollection=l;class s{constructor(n){this.object=n}dispose(){}}e.ImmortalReference=s;function i(r){const n=new h;try{r(n)}finally{n.dispose()}}e.disposeOnReturn=i}),define(De[79],Ie([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class u{constructor(P){this.element=P,this.next=u.Undefined,this.prev=u.Undefined}}u.Undefined=new u(void 0);class t{constructor(){this._first=u.Undefined,this._last=u.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===u.Undefined}clear(){let P=this._first;for(;P!==u.Undefined;){const y=P.next;P.prev=u.Undefined,P.next=u.Undefined,P=y}this._first=u.Undefined,this._last=u.Undefined,this._size=0}unshift(P){return this._insert(P,!1)}push(P){return this._insert(P,!0)}_insert(P,y){const C=new u(P);if(this._first===u.Undefined)this._first=C,this._last=C;else if(y){const I=this._last;this._last=C,C.prev=I,I.next=C}else{const I=this._first;this._first=C,C.next=I,I.prev=C}this._size+=1;let E=!1;return()=>{E||(E=!0,this._remove(C))}}shift(){if(this._first!==u.Undefined){const P=this._first.element;return this._remove(this._first),P}}pop(){if(this._last!==u.Undefined){const P=this._last.element;return this._remove(this._last),P}}_remove(P){if(P.prev!==u.Undefined&&P.next!==u.Undefined){const y=P.prev;y.next=P.next,P.next.prev=y}else P.prev===u.Undefined&&P.next===u.Undefined?(this._first=u.Undefined,this._last=u.Undefined):P.next===u.Undefined?(this._last=this._last.prev,this._last.next=u.Undefined):P.prev===u.Undefined&&(this._first=this._first.next,this._first.prev=u.Undefined);this._size-=1}*[Symbol.iterator](){let P=this._first;for(;P!==u.Undefined;)yield P.element,P=P.next}}e.LinkedList=t}),function(Z,e){typeof exports=="object"&&typeof module!="undefined"?e(exports):typeof define=="function"&&define.amd?define(De[143],Ie([0]),e):(Z=typeof globalThis!="undefined"?globalThis:Z||self,e(Z.marked={}))}(this,function(Z){"use strict";function e(ae,de){for(var me=0;me<de.length;me++){var te=de[me];te.enumerable=te.enumerable||!1,te.configurable=!0,"value"in te&&(te.writable=!0),Object.defineProperty(ae,te.key,te)}}function u(ae,de,me){return de&&e(ae.prototype,de),me&&e(ae,me),Object.defineProperty(ae,"prototype",{writable:!1}),ae}function t(ae,de){if(!!ae){if(typeof ae=="string")return D(ae,de);var me=Object.prototype.toString.call(ae).slice(8,-1);if(me==="Object"&&ae.constructor&&(me=ae.constructor.name),me==="Map"||me==="Set")return Array.from(ae);if(me==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(me))return D(ae,de)}}function D(ae,de){(de==null||de>ae.length)&&(de=ae.length);for(var me=0,te=new Array(de);me<de;me++)te[me]=ae[me];return te}function P(ae,de){var me=typeof Symbol!="undefined"&&ae[Symbol.iterator]||ae["@@iterator"];if(me)return(me=me.call(ae)).next.bind(me);if(Array.isArray(ae)||(me=t(ae))||de&&ae&&typeof ae.length=="number"){me&&(ae=me);var te=0;return function(){return te>=ae.length?{done:!0}:{done:!1,value:ae[te++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function y(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}Z.defaults=y();function C(ae){Z.defaults=ae}var E=/[&<>"']/,I=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,k=/[<>"']|&(?!#?\w+;)/g,_={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},T=function(de){return _[de]};function w(ae,de){if(de){if(E.test(ae))return ae.replace(I,T)}else if(R.test(ae))return ae.replace(k,T);return ae}var b=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function v(ae){return ae.replace(b,function(de,me){return me=me.toLowerCase(),me==="colon"?":":me.charAt(0)==="#"?me.charAt(1)==="x"?String.fromCharCode(parseInt(me.substring(2),16)):String.fromCharCode(+me.substring(1)):""})}var h=/(^|[^\[])\^/g;function g(ae,de){ae=typeof ae=="string"?ae:ae.source,de=de||"";var me={replace:function(le,ee){return ee=ee.source||ee,ee=ee.replace(h,"$1"),ae=ae.replace(le,ee),me},getRegex:function(){return new RegExp(ae,de)}};return me}var p=/[^\w:]/g,o=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function m(ae,de,me){if(ae){var te;try{te=decodeURIComponent(v(me)).replace(p,"").toLowerCase()}catch{return null}if(te.indexOf("javascript:")===0||te.indexOf("vbscript:")===0||te.indexOf("data:")===0)return null}de&&!o.test(me)&&(me=r(de,me));try{me=encodeURI(me).replace(/%25/g,"%")}catch{return null}return me}var c={},l=/^[^:]+:\/*[^/]*$/,s=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function r(ae,de){c[" "+ae]||(l.test(ae)?c[" "+ae]=ae+"/":c[" "+ae]=f(ae,"/",!0)),ae=c[" "+ae];var me=ae.indexOf(":")===-1;return de.substring(0,2)==="//"?me?de:ae.replace(s,"$1")+de:de.charAt(0)==="/"?me?de:ae.replace(i,"$1")+de:ae+de}var n={exec:function(){}};function a(ae){for(var de=1,me,te;de<arguments.length;de++){me=arguments[de];for(te in me)Object.prototype.hasOwnProperty.call(me,te)&&(ae[te]=me[te])}return ae}function d(ae,de){var me=ae.replace(/\|/g,function(ee,re,F){for(var W=!1,G=re;--G>=0&&F[G]==="\\";)W=!W;return W?"|":" |"}),te=me.split(/ \|/),le=0;if(te[0].trim()||te.shift(),te.length>0&&!te[te.length-1].trim()&&te.pop(),te.length>de)te.splice(de);else for(;te.length<de;)te.push("");for(;le<te.length;le++)te[le]=te[le].trim().replace(/\\\|/g,"|");return te}function f(ae,de,me){var te=ae.length;if(te===0)return"";for(var le=0;le<te;){var ee=ae.charAt(te-le-1);if(ee===de&&!me)le++;else if(ee!==de&&me)le++;else break}return ae.slice(0,te-le)}function S(ae,de){if(ae.indexOf(de[1])===-1)return-1;for(var me=ae.length,te=0,le=0;le<me;le++)if(ae[le]==="\\")le++;else if(ae[le]===de[0])te++;else if(ae[le]===de[1]&&(te--,te<0))return le;return-1}function O(ae){ae&&ae.sanitize&&!ae.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function U(ae,de){if(de<1)return"";for(var me="";de>1;)de&1&&(me+=ae),de>>=1,ae+=ae;return me+ae}function M(ae,de,me,te){var le=de.href,ee=de.title?w(de.title):null,re=ae[1].replace(/\\([\[\]])/g,"$1");if(ae[0].charAt(0)!=="!"){te.state.inLink=!0;var F={type:"link",raw:me,href:le,title:ee,text:re,tokens:te.inlineTokens(re,[])};return te.state.inLink=!1,F}return{type:"image",raw:me,href:le,title:ee,text:w(re)}}function A(ae,de){var me=ae.match(/^(\s+)(?:```)/);if(me===null)return de;var te=me[1];return de.split(`
`).map(function(le){var ee=le.match(/^\s+/);if(ee===null)return le;var re=ee[0];return re.length>=te.length?le.slice(te.length):le}).join(`
`)}var B=function(){function ae(me){this.options=me||Z.defaults}var de=ae.prototype;return de.space=function(te){var le=this.rules.block.newline.exec(te);if(le&&le[0].length>0)return{type:"space",raw:le[0]}},de.code=function(te){var le=this.rules.block.code.exec(te);if(le){var ee=le[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:le[0],codeBlockStyle:"indented",text:this.options.pedantic?ee:f(ee,`
`)}}},de.fences=function(te){var le=this.rules.block.fences.exec(te);if(le){var ee=le[0],re=A(ee,le[3]||"");return{type:"code",raw:ee,lang:le[2]?le[2].trim():le[2],text:re}}},de.heading=function(te){var le=this.rules.block.heading.exec(te);if(le){var ee=le[2].trim();if(/#$/.test(ee)){var re=f(ee,"#");(this.options.pedantic||!re||/ $/.test(re))&&(ee=re.trim())}var F={type:"heading",raw:le[0],depth:le[1].length,text:ee,tokens:[]};return this.lexer.inline(F.text,F.tokens),F}},de.hr=function(te){var le=this.rules.block.hr.exec(te);if(le)return{type:"hr",raw:le[0]}},de.blockquote=function(te){var le=this.rules.block.blockquote.exec(te);if(le){var ee=le[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:le[0],tokens:this.lexer.blockTokens(ee,[]),text:ee}}},de.list=function(te){var le=this.rules.block.list.exec(te);if(le){var ee,re,F,W,G,Q,fe,be,ue,Ce,Se,Ue,qe=le[1].trim(),Je=qe.length>1,Qe={type:"list",raw:"",ordered:Je,start:Je?+qe.slice(0,-1):"",loose:!1,items:[]};qe=Je?"\\d{1,9}\\"+qe.slice(-1):"\\"+qe,this.options.pedantic&&(qe=Je?qe:"[*+-]");for(var Re=new RegExp("^( {0,3}"+qe+")((?:[	 ][^\\n]*)?(?:\\n|$))");te&&(Ue=!1,!(!(le=Re.exec(te))||this.rules.block.hr.test(te)));){if(ee=le[0],te=te.substring(ee.length),be=le[2].split(`
`,1)[0],ue=te.split(`
`,1)[0],this.options.pedantic?(W=2,Se=be.trimLeft()):(W=le[2].search(/[^ ]/),W=W>4?1:W,Se=be.slice(W),W+=le[1].length),Q=!1,!be&&/^ *$/.test(ue)&&(ee+=ue+`
`,te=te.substring(ue.length+1),Ue=!0),!Ue)for(var st=new RegExp("^ {0,"+Math.min(3,W-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),se=new RegExp("^ {0,"+Math.min(3,W-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)");te&&(Ce=te.split(`
`,1)[0],be=Ce,this.options.pedantic&&(be=be.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(st.test(be)||se.test(te)));){if(be.search(/[^ ]/)>=W||!be.trim())Se+=`
`+be.slice(W);else if(!Q)Se+=`
`+be;else break;!Q&&!be.trim()&&(Q=!0),ee+=Ce+`
`,te=te.substring(Ce.length+1)}Qe.loose||(fe?Qe.loose=!0:/\n *\n *$/.test(ee)&&(fe=!0)),this.options.gfm&&(re=/^\[[ xX]\] /.exec(Se),re&&(F=re[0]!=="[ ] ",Se=Se.replace(/^\[[ xX]\] +/,""))),Qe.items.push({type:"list_item",raw:ee,task:!!re,checked:F,loose:!1,text:Se}),Qe.raw+=ee}Qe.items[Qe.items.length-1].raw=ee.trimRight(),Qe.items[Qe.items.length-1].text=Se.trimRight(),Qe.raw=Qe.raw.trimRight();var oe=Qe.items.length;for(G=0;G<oe;G++){this.lexer.state.top=!1,Qe.items[G].tokens=this.lexer.blockTokens(Qe.items[G].text,[]);var q=Qe.items[G].tokens.filter(function(Ae){return Ae.type==="space"}),ye=q.every(function(Ae){for(var We=Ae.raw.split(""),ze=0,$e=P(We),Ze;!(Ze=$e()).done;){var it=Ze.value;if(it===`
`&&(ze+=1),ze>1)return!0}return!1});!Qe.loose&&q.length&&ye&&(Qe.loose=!0,Qe.items[G].loose=!0)}return Qe}},de.html=function(te){var le=this.rules.block.html.exec(te);if(le){var ee={type:"html",raw:le[0],pre:!this.options.sanitizer&&(le[1]==="pre"||le[1]==="script"||le[1]==="style"),text:le[0]};return this.options.sanitize&&(ee.type="paragraph",ee.text=this.options.sanitizer?this.options.sanitizer(le[0]):w(le[0]),ee.tokens=[],this.lexer.inline(ee.text,ee.tokens)),ee}},de.def=function(te){var le=this.rules.block.def.exec(te);if(le){le[3]&&(le[3]=le[3].substring(1,le[3].length-1));var ee=le[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ee,raw:le[0],href:le[2],title:le[3]}}},de.table=function(te){var le=this.rules.block.table.exec(te);if(le){var ee={type:"table",header:d(le[1]).map(function(fe){return{text:fe}}),align:le[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:le[3]&&le[3].trim()?le[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ee.header.length===ee.align.length){ee.raw=le[0];var re=ee.align.length,F,W,G,Q;for(F=0;F<re;F++)/^ *-+: *$/.test(ee.align[F])?ee.align[F]="right":/^ *:-+: *$/.test(ee.align[F])?ee.align[F]="center":/^ *:-+ *$/.test(ee.align[F])?ee.align[F]="left":ee.align[F]=null;for(re=ee.rows.length,F=0;F<re;F++)ee.rows[F]=d(ee.rows[F],ee.header.length).map(function(fe){return{text:fe}});for(re=ee.header.length,W=0;W<re;W++)ee.header[W].tokens=[],this.lexer.inline(ee.header[W].text,ee.header[W].tokens);for(re=ee.rows.length,W=0;W<re;W++)for(Q=ee.rows[W],G=0;G<Q.length;G++)Q[G].tokens=[],this.lexer.inline(Q[G].text,Q[G].tokens);return ee}}},de.lheading=function(te){var le=this.rules.block.lheading.exec(te);if(le){var ee={type:"heading",raw:le[0],depth:le[2].charAt(0)==="="?1:2,text:le[1],tokens:[]};return this.lexer.inline(ee.text,ee.tokens),ee}},de.paragraph=function(te){var le=this.rules.block.paragraph.exec(te);if(le){var ee={type:"paragraph",raw:le[0],text:le[1].charAt(le[1].length-1)===`
`?le[1].slice(0,-1):le[1],tokens:[]};return this.lexer.inline(ee.text,ee.tokens),ee}},de.text=function(te){var le=this.rules.block.text.exec(te);if(le){var ee={type:"text",raw:le[0],text:le[0],tokens:[]};return this.lexer.inline(ee.text,ee.tokens),ee}},de.escape=function(te){var le=this.rules.inline.escape.exec(te);if(le)return{type:"escape",raw:le[0],text:w(le[1])}},de.tag=function(te){var le=this.rules.inline.tag.exec(te);if(le)return!this.lexer.state.inLink&&/^<a /i.test(le[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(le[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(le[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(le[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:le[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(le[0]):w(le[0]):le[0]}},de.link=function(te){var le=this.rules.inline.link.exec(te);if(le){var ee=le[2].trim();if(!this.options.pedantic&&/^</.test(ee)){if(!/>$/.test(ee))return;var re=f(ee.slice(0,-1),"\\");if((ee.length-re.length)%2==0)return}else{var F=S(le[2],"()");if(F>-1){var W=le[0].indexOf("!")===0?5:4,G=W+le[1].length+F;le[2]=le[2].substring(0,F),le[0]=le[0].substring(0,G).trim(),le[3]=""}}var Q=le[2],fe="";if(this.options.pedantic){var be=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Q);be&&(Q=be[1],fe=be[3])}else fe=le[3]?le[3].slice(1,-1):"";return Q=Q.trim(),/^</.test(Q)&&(this.options.pedantic&&!/>$/.test(ee)?Q=Q.slice(1):Q=Q.slice(1,-1)),M(le,{href:Q&&Q.replace(this.rules.inline._escapes,"$1"),title:fe&&fe.replace(this.rules.inline._escapes,"$1")},le[0],this.lexer)}},de.reflink=function(te,le){var ee;if((ee=this.rules.inline.reflink.exec(te))||(ee=this.rules.inline.nolink.exec(te))){var re=(ee[2]||ee[1]).replace(/\s+/g," ");if(re=le[re.toLowerCase()],!re||!re.href){var F=ee[0].charAt(0);return{type:"text",raw:F,text:F}}return M(ee,re,ee[0],this.lexer)}},de.emStrong=function(te,le,ee){ee===void 0&&(ee="");var re=this.rules.inline.emStrong.lDelim.exec(te);if(!!re&&!(re[3]&&ee.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var F=re[1]||re[2]||"";if(!F||F&&(ee===""||this.rules.inline.punctuation.exec(ee))){var W=re[0].length-1,G,Q,fe=W,be=0,ue=re[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ue.lastIndex=0,le=le.slice(-1*te.length+W);(re=ue.exec(le))!=null;)if(G=re[1]||re[2]||re[3]||re[4]||re[5]||re[6],!!G){if(Q=G.length,re[3]||re[4]){fe+=Q;continue}else if((re[5]||re[6])&&W%3&&!((W+Q)%3)){be+=Q;continue}if(fe-=Q,!(fe>0)){if(Q=Math.min(Q,Q+fe+be),Math.min(W,Q)%2){var Ce=te.slice(1,W+re.index+Q);return{type:"em",raw:te.slice(0,W+re.index+Q+1),text:Ce,tokens:this.lexer.inlineTokens(Ce,[])}}var Se=te.slice(2,W+re.index+Q-1);return{type:"strong",raw:te.slice(0,W+re.index+Q+1),text:Se,tokens:this.lexer.inlineTokens(Se,[])}}}}}},de.codespan=function(te){var le=this.rules.inline.code.exec(te);if(le){var ee=le[2].replace(/\n/g," "),re=/[^ ]/.test(ee),F=/^ /.test(ee)&&/ $/.test(ee);return re&&F&&(ee=ee.substring(1,ee.length-1)),ee=w(ee,!0),{type:"codespan",raw:le[0],text:ee}}},de.br=function(te){var le=this.rules.inline.br.exec(te);if(le)return{type:"br",raw:le[0]}},de.del=function(te){var le=this.rules.inline.del.exec(te);if(le)return{type:"del",raw:le[0],text:le[2],tokens:this.lexer.inlineTokens(le[2],[])}},de.autolink=function(te,le){var ee=this.rules.inline.autolink.exec(te);if(ee){var re,F;return ee[2]==="@"?(re=w(this.options.mangle?le(ee[1]):ee[1]),F="mailto:"+re):(re=w(ee[1]),F=re),{type:"link",raw:ee[0],text:re,href:F,tokens:[{type:"text",raw:re,text:re}]}}},de.url=function(te,le){var ee;if(ee=this.rules.inline.url.exec(te)){var re,F;if(ee[2]==="@")re=w(this.options.mangle?le(ee[0]):ee[0]),F="mailto:"+re;else{var W;do W=ee[0],ee[0]=this.rules.inline._backpedal.exec(ee[0])[0];while(W!==ee[0]);re=w(ee[0]),ee[1]==="www."?F="http://"+re:F=re}return{type:"link",raw:ee[0],text:re,href:F,tokens:[{type:"text",raw:re,text:re}]}}},de.inlineText=function(te,le){var ee=this.rules.inline.text.exec(te);if(ee){var re;return this.lexer.state.inRawBlock?re=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ee[0]):w(ee[0]):ee[0]:re=w(this.options.smartypants?le(ee[0]):ee[0]),{type:"text",raw:ee[0],text:re}}},ae}(),x={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:n,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};x._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,x._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,x.def=g(x.def).replace("label",x._label).replace("title",x._title).getRegex(),x.bullet=/(?:[*+-]|\d{1,9}[.)])/,x.listItemStart=g(/^( *)(bull) */).replace("bull",x.bullet).getRegex(),x.list=g(x.list).replace(/bull/g,x.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+x.def.source+")").getRegex(),x._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",x._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,x.html=g(x.html,"i").replace("comment",x._comment).replace("tag",x._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),x.paragraph=g(x._paragraph).replace("hr",x.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",x._tag).getRegex(),x.blockquote=g(x.blockquote).replace("paragraph",x.paragraph).getRegex(),x.normal=a({},x),x.gfm=a({},x.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),x.gfm.table=g(x.gfm.table).replace("hr",x.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",x._tag).getRegex(),x.gfm.paragraph=g(x._paragraph).replace("hr",x.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",x.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",x._tag).getRegex(),x.pedantic=a({},x.normal,{html:g(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",x._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:n,paragraph:g(x.normal._paragraph).replace("hr",x.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",x.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var N={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:n,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:n,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};N._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",N.punctuation=g(N.punctuation).replace(/punctuation/g,N._punctuation).getRegex(),N.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,N.escapedEmSt=/\\\*|\\_/g,N._comment=g(x._comment).replace("(?:-->|$)","-->").getRegex(),N.emStrong.lDelim=g(N.emStrong.lDelim).replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimAst=g(N.emStrong.rDelimAst,"g").replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimUnd=g(N.emStrong.rDelimUnd,"g").replace(/punct/g,N._punctuation).getRegex(),N._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,N._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,N._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,N.autolink=g(N.autolink).replace("scheme",N._scheme).replace("email",N._email).getRegex(),N._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,N.tag=g(N.tag).replace("comment",N._comment).replace("attribute",N._attribute).getRegex(),N._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,N._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,N._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,N.link=g(N.link).replace("label",N._label).replace("href",N._href).replace("title",N._title).getRegex(),N.reflink=g(N.reflink).replace("label",N._label).replace("ref",x._label).getRegex(),N.nolink=g(N.nolink).replace("ref",x._label).getRegex(),N.reflinkSearch=g(N.reflinkSearch,"g").replace("reflink",N.reflink).replace("nolink",N.nolink).getRegex(),N.normal=a({},N),N.pedantic=a({},N.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:g(/^!?\[(label)\]\((.*?)\)/).replace("label",N._label).getRegex(),reflink:g(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",N._label).getRegex()}),N.gfm=a({},N.normal,{escape:g(N.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),N.gfm.url=g(N.gfm.url,"i").replace("email",N.gfm._extended_email).getRegex(),N.breaks=a({},N.gfm,{br:g(N.br).replace("{2,}","*").getRegex(),text:g(N.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function K(ae){return ae.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function X(ae){var de="",me,te,le=ae.length;for(me=0;me<le;me++)te=ae.charCodeAt(me),Math.random()>.5&&(te="x"+te.toString(16)),de+="&#"+te+";";return de}var L=function(){function ae(me){this.tokens=[],this.tokens.links=Object.create(null),this.options=me||Z.defaults,this.options.tokenizer=this.options.tokenizer||new B,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var te={block:x.normal,inline:N.normal};this.options.pedantic?(te.block=x.pedantic,te.inline=N.pedantic):this.options.gfm&&(te.block=x.gfm,this.options.breaks?te.inline=N.breaks:te.inline=N.gfm),this.tokenizer.rules=te}ae.lex=function(te,le){var ee=new ae(le);return ee.lex(te)},ae.lexInline=function(te,le){var ee=new ae(le);return ee.inlineTokens(te)};var de=ae.prototype;return de.lex=function(te){te=te.replace(/\r\n|\r/g,`
`),this.blockTokens(te,this.tokens);for(var le;le=this.inlineQueue.shift();)this.inlineTokens(le.src,le.tokens);return this.tokens},de.blockTokens=function(te,le){var ee=this;le===void 0&&(le=[]),this.options.pedantic?te=te.replace(/\t/g,"    ").replace(/^ +$/gm,""):te=te.replace(/^( *)(\t+)/gm,function(fe,be,ue){return be+"    ".repeat(ue.length)});for(var re,F,W,G;te;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(fe){return(re=fe.call({lexer:ee},te,le))?(te=te.substring(re.raw.length),le.push(re),!0):!1}))){if(re=this.tokenizer.space(te)){te=te.substring(re.raw.length),re.raw.length===1&&le.length>0?le[le.length-1].raw+=`
`:le.push(re);continue}if(re=this.tokenizer.code(te)){te=te.substring(re.raw.length),F=le[le.length-1],F&&(F.type==="paragraph"||F.type==="text")?(F.raw+=`
`+re.raw,F.text+=`
`+re.text,this.inlineQueue[this.inlineQueue.length-1].src=F.text):le.push(re);continue}if(re=this.tokenizer.fences(te)){te=te.substring(re.raw.length),le.push(re);continue}if(re=this.tokenizer.heading(te)){te=te.substring(re.raw.length),le.push(re);continue}if(re=this.tokenizer.hr(te)){te=te.substring(re.raw.length),le.push(re);continue}if(re=this.tokenizer.blockquote(te)){te=te.substring(re.raw.length),le.push(re);continue}if(re=this.tokenizer.list(te)){te=te.substring(re.raw.length),le.push(re);continue}if(re=this.tokenizer.html(te)){te=te.substring(re.raw.length),le.push(re);continue}if(re=this.tokenizer.def(te)){te=te.substring(re.raw.length),F=le[le.length-1],F&&(F.type==="paragraph"||F.type==="text")?(F.raw+=`
`+re.raw,F.text+=`
`+re.raw,this.inlineQueue[this.inlineQueue.length-1].src=F.text):this.tokens.links[re.tag]||(this.tokens.links[re.tag]={href:re.href,title:re.title});continue}if(re=this.tokenizer.table(te)){te=te.substring(re.raw.length),le.push(re);continue}if(re=this.tokenizer.lheading(te)){te=te.substring(re.raw.length),le.push(re);continue}if(W=te,this.options.extensions&&this.options.extensions.startBlock&&function(){var fe=1/0,be=te.slice(1),ue=void 0;ee.options.extensions.startBlock.forEach(function(Ce){ue=Ce.call({lexer:this},be),typeof ue=="number"&&ue>=0&&(fe=Math.min(fe,ue))}),fe<1/0&&fe>=0&&(W=te.substring(0,fe+1))}(),this.state.top&&(re=this.tokenizer.paragraph(W))){F=le[le.length-1],G&&F.type==="paragraph"?(F.raw+=`
`+re.raw,F.text+=`
`+re.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=F.text):le.push(re),G=W.length!==te.length,te=te.substring(re.raw.length);continue}if(re=this.tokenizer.text(te)){te=te.substring(re.raw.length),F=le[le.length-1],F&&F.type==="text"?(F.raw+=`
`+re.raw,F.text+=`
`+re.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=F.text):le.push(re);continue}if(te){var Q="Infinite loop on byte: "+te.charCodeAt(0);if(this.options.silent){console.error(Q);break}else throw new Error(Q)}}return this.state.top=!0,le},de.inline=function(te,le){this.inlineQueue.push({src:te,tokens:le})},de.inlineTokens=function(te,le){var ee=this;le===void 0&&(le=[]);var re,F,W,G=te,Q,fe,be;if(this.tokens.links){var ue=Object.keys(this.tokens.links);if(ue.length>0)for(;(Q=this.tokenizer.rules.inline.reflinkSearch.exec(G))!=null;)ue.includes(Q[0].slice(Q[0].lastIndexOf("[")+1,-1))&&(G=G.slice(0,Q.index)+"["+U("a",Q[0].length-2)+"]"+G.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Q=this.tokenizer.rules.inline.blockSkip.exec(G))!=null;)G=G.slice(0,Q.index)+"["+U("a",Q[0].length-2)+"]"+G.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Q=this.tokenizer.rules.inline.escapedEmSt.exec(G))!=null;)G=G.slice(0,Q.index)+"++"+G.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;te;)if(fe||(be=""),fe=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Se){return(re=Se.call({lexer:ee},te,le))?(te=te.substring(re.raw.length),le.push(re),!0):!1}))){if(re=this.tokenizer.escape(te)){te=te.substring(re.raw.length),le.push(re);continue}if(re=this.tokenizer.tag(te)){te=te.substring(re.raw.length),F=le[le.length-1],F&&re.type==="text"&&F.type==="text"?(F.raw+=re.raw,F.text+=re.text):le.push(re);continue}if(re=this.tokenizer.link(te)){te=te.substring(re.raw.length),le.push(re);continue}if(re=this.tokenizer.reflink(te,this.tokens.links)){te=te.substring(re.raw.length),F=le[le.length-1],F&&re.type==="text"&&F.type==="text"?(F.raw+=re.raw,F.text+=re.text):le.push(re);continue}if(re=this.tokenizer.emStrong(te,G,be)){te=te.substring(re.raw.length),le.push(re);continue}if(re=this.tokenizer.codespan(te)){te=te.substring(re.raw.length),le.push(re);continue}if(re=this.tokenizer.br(te)){te=te.substring(re.raw.length),le.push(re);continue}if(re=this.tokenizer.del(te)){te=te.substring(re.raw.length),le.push(re);continue}if(re=this.tokenizer.autolink(te,X)){te=te.substring(re.raw.length),le.push(re);continue}if(!this.state.inLink&&(re=this.tokenizer.url(te,X))){te=te.substring(re.raw.length),le.push(re);continue}if(W=te,this.options.extensions&&this.options.extensions.startInline&&function(){var Se=1/0,Ue=te.slice(1),qe=void 0;ee.options.extensions.startInline.forEach(function(Je){qe=Je.call({lexer:this},Ue),typeof qe=="number"&&qe>=0&&(Se=Math.min(Se,qe))}),Se<1/0&&Se>=0&&(W=te.substring(0,Se+1))}(),re=this.tokenizer.inlineText(W,K)){te=te.substring(re.raw.length),re.raw.slice(-1)!=="_"&&(be=re.raw.slice(-1)),fe=!0,F=le[le.length-1],F&&F.type==="text"?(F.raw+=re.raw,F.text+=re.text):le.push(re);continue}if(te){var Ce="Infinite loop on byte: "+te.charCodeAt(0);if(this.options.silent){console.error(Ce);break}else throw new Error(Ce)}}return le},u(ae,null,[{key:"rules",get:function(){return{block:x,inline:N}}}]),ae}(),$=function(){function ae(me){this.options=me||Z.defaults}var de=ae.prototype;return de.code=function(te,le,ee){var re=(le||"").match(/\S*/)[0];if(this.options.highlight){var F=this.options.highlight(te,re);F!=null&&F!==te&&(ee=!0,te=F)}return te=te.replace(/\n$/,"")+`
`,re?'<pre><code class="'+this.options.langPrefix+w(re,!0)+'">'+(ee?te:w(te,!0))+`</code></pre>
`:"<pre><code>"+(ee?te:w(te,!0))+`</code></pre>
`},de.blockquote=function(te){return`<blockquote>
`+te+`</blockquote>
`},de.html=function(te){return te},de.heading=function(te,le,ee,re){if(this.options.headerIds){var F=this.options.headerPrefix+re.slug(ee);return"<h"+le+' id="'+F+'">'+te+"</h"+le+`>
`}return"<h"+le+">"+te+"</h"+le+`>
`},de.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},de.list=function(te,le,ee){var re=le?"ol":"ul",F=le&&ee!==1?' start="'+ee+'"':"";return"<"+re+F+`>
`+te+"</"+re+`>
`},de.listitem=function(te){return"<li>"+te+`</li>
`},de.checkbox=function(te){return"<input "+(te?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},de.paragraph=function(te){return"<p>"+te+`</p>
`},de.table=function(te,le){return le&&(le="<tbody>"+le+"</tbody>"),`<table>
<thead>
`+te+`</thead>
`+le+`</table>
`},de.tablerow=function(te){return`<tr>
`+te+`</tr>
`},de.tablecell=function(te,le){var ee=le.header?"th":"td",re=le.align?"<"+ee+' align="'+le.align+'">':"<"+ee+">";return re+te+("</"+ee+`>
`)},de.strong=function(te){return"<strong>"+te+"</strong>"},de.em=function(te){return"<em>"+te+"</em>"},de.codespan=function(te){return"<code>"+te+"</code>"},de.br=function(){return this.options.xhtml?"<br/>":"<br>"},de.del=function(te){return"<del>"+te+"</del>"},de.link=function(te,le,ee){if(te=m(this.options.sanitize,this.options.baseUrl,te),te===null)return ee;var re='<a href="'+w(te)+'"';return le&&(re+=' title="'+le+'"'),re+=">"+ee+"</a>",re},de.image=function(te,le,ee){if(te=m(this.options.sanitize,this.options.baseUrl,te),te===null)return ee;var re='<img src="'+te+'" alt="'+ee+'"';return le&&(re+=' title="'+le+'"'),re+=this.options.xhtml?"/>":">",re},de.text=function(te){return te},ae}(),H=function(){function ae(){}var de=ae.prototype;return de.strong=function(te){return te},de.em=function(te){return te},de.codespan=function(te){return te},de.del=function(te){return te},de.html=function(te){return te},de.text=function(te){return te},de.link=function(te,le,ee){return""+ee},de.image=function(te,le,ee){return""+ee},de.br=function(){return""},ae}(),j=function(){function ae(){this.seen={}}var de=ae.prototype;return de.serialize=function(te){return te.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},de.getNextSafeSlug=function(te,le){var ee=te,re=0;if(this.seen.hasOwnProperty(ee)){re=this.seen[te];do re++,ee=te+"-"+re;while(this.seen.hasOwnProperty(ee))}return le||(this.seen[te]=re,this.seen[ee]=0),ee},de.slug=function(te,le){le===void 0&&(le={});var ee=this.serialize(te);return this.getNextSafeSlug(ee,le.dryrun)},ae}(),J=function(){function ae(me){this.options=me||Z.defaults,this.options.renderer=this.options.renderer||new $,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new H,this.slugger=new j}ae.parse=function(te,le){var ee=new ae(le);return ee.parse(te)},ae.parseInline=function(te,le){var ee=new ae(le);return ee.parseInline(te)};var de=ae.prototype;return de.parse=function(te,le){le===void 0&&(le=!0);var ee="",re,F,W,G,Q,fe,be,ue,Ce,Se,Ue,qe,Je,Qe,Re,st,se,oe,q,ye=te.length;for(re=0;re<ye;re++){if(Se=te[re],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Se.type]&&(q=this.options.extensions.renderers[Se.type].call({parser:this},Se),q!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Se.type))){ee+=q||"";continue}switch(Se.type){case"space":continue;case"hr":{ee+=this.renderer.hr();continue}case"heading":{ee+=this.renderer.heading(this.parseInline(Se.tokens),Se.depth,v(this.parseInline(Se.tokens,this.textRenderer)),this.slugger);continue}case"code":{ee+=this.renderer.code(Se.text,Se.lang,Se.escaped);continue}case"table":{for(ue="",be="",G=Se.header.length,F=0;F<G;F++)be+=this.renderer.tablecell(this.parseInline(Se.header[F].tokens),{header:!0,align:Se.align[F]});for(ue+=this.renderer.tablerow(be),Ce="",G=Se.rows.length,F=0;F<G;F++){for(fe=Se.rows[F],be="",Q=fe.length,W=0;W<Q;W++)be+=this.renderer.tablecell(this.parseInline(fe[W].tokens),{header:!1,align:Se.align[W]});Ce+=this.renderer.tablerow(be)}ee+=this.renderer.table(ue,Ce);continue}case"blockquote":{Ce=this.parse(Se.tokens),ee+=this.renderer.blockquote(Ce);continue}case"list":{for(Ue=Se.ordered,qe=Se.start,Je=Se.loose,G=Se.items.length,Ce="",F=0;F<G;F++)Re=Se.items[F],st=Re.checked,se=Re.task,Qe="",Re.task&&(oe=this.renderer.checkbox(st),Je?Re.tokens.length>0&&Re.tokens[0].type==="paragraph"?(Re.tokens[0].text=oe+" "+Re.tokens[0].text,Re.tokens[0].tokens&&Re.tokens[0].tokens.length>0&&Re.tokens[0].tokens[0].type==="text"&&(Re.tokens[0].tokens[0].text=oe+" "+Re.tokens[0].tokens[0].text)):Re.tokens.unshift({type:"text",text:oe}):Qe+=oe),Qe+=this.parse(Re.tokens,Je),Ce+=this.renderer.listitem(Qe,se,st);ee+=this.renderer.list(Ce,Ue,qe);continue}case"html":{ee+=this.renderer.html(Se.text);continue}case"paragraph":{ee+=this.renderer.paragraph(this.parseInline(Se.tokens));continue}case"text":{for(Ce=Se.tokens?this.parseInline(Se.tokens):Se.text;re+1<ye&&te[re+1].type==="text";)Se=te[++re],Ce+=`
`+(Se.tokens?this.parseInline(Se.tokens):Se.text);ee+=le?this.renderer.paragraph(Ce):Ce;continue}default:{var Ae='Token with "'+Se.type+'" type was not found.';if(this.options.silent){console.error(Ae);return}else throw new Error(Ae)}}}return ee},de.parseInline=function(te,le){le=le||this.renderer;var ee="",re,F,W,G=te.length;for(re=0;re<G;re++){if(F=te[re],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[F.type]&&(W=this.options.extensions.renderers[F.type].call({parser:this},F),W!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(F.type))){ee+=W||"";continue}switch(F.type){case"escape":{ee+=le.text(F.text);break}case"html":{ee+=le.html(F.text);break}case"link":{ee+=le.link(F.href,F.title,this.parseInline(F.tokens,le));break}case"image":{ee+=le.image(F.href,F.title,F.text);break}case"strong":{ee+=le.strong(this.parseInline(F.tokens,le));break}case"em":{ee+=le.em(this.parseInline(F.tokens,le));break}case"codespan":{ee+=le.codespan(F.text);break}case"br":{ee+=le.br();break}case"del":{ee+=le.del(this.parseInline(F.tokens,le));break}case"text":{ee+=le.text(F.text);break}default:{var Q='Token with "'+F.type+'" type was not found.';if(this.options.silent){console.error(Q);return}else throw new Error(Q)}}}return ee},ae}();function Y(ae,de,me){if(typeof ae=="undefined"||ae===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ae!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ae)+", string expected");if(typeof de=="function"&&(me=de,de=null),de=a({},Y.defaults,de||{}),O(de),me){var te=de.highlight,le;try{le=L.lex(ae,de)}catch(W){return me(W)}var ee=function(G){var Q;if(!G)try{de.walkTokens&&Y.walkTokens(le,de.walkTokens),Q=J.parse(le,de)}catch(fe){G=fe}return de.highlight=te,G?me(G):me(null,Q)};if(!te||te.length<3||(delete de.highlight,!le.length))return ee();var re=0;Y.walkTokens(le,function(W){W.type==="code"&&(re++,setTimeout(function(){te(W.text,W.lang,function(G,Q){if(G)return ee(G);Q!=null&&Q!==W.text&&(W.text=Q,W.escaped=!0),re--,re===0&&ee()})},0))}),re===0&&ee();return}try{var F=L.lex(ae,de);return de.walkTokens&&Y.walkTokens(F,de.walkTokens),J.parse(F,de)}catch(W){if(W.message+=`
Please report this to https://github.com/markedjs/marked.`,de.silent)return"<p>An error occurred:</p><pre>"+w(W.message+"",!0)+"</pre>";throw W}}Y.options=Y.setOptions=function(ae){return a(Y.defaults,ae),C(Y.defaults),Y},Y.getDefaults=y,Y.defaults=Z.defaults,Y.use=function(){for(var ae=arguments.length,de=new Array(ae),me=0;me<ae;me++)de[me]=arguments[me];var te=a.apply(void 0,[{}].concat(de)),le=Y.defaults.extensions||{renderers:{},childTokens:{}},ee;de.forEach(function(re){if(re.extensions&&(ee=!0,re.extensions.forEach(function(W){if(!W.name)throw new Error("extension name required");if(W.renderer){var G=le.renderers?le.renderers[W.name]:null;G?le.renderers[W.name]=function(){for(var Q=arguments.length,fe=new Array(Q),be=0;be<Q;be++)fe[be]=arguments[be];var ue=W.renderer.apply(this,fe);return ue===!1&&(ue=G.apply(this,fe)),ue}:le.renderers[W.name]=W.renderer}if(W.tokenizer){if(!W.level||W.level!=="block"&&W.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");le[W.level]?le[W.level].unshift(W.tokenizer):le[W.level]=[W.tokenizer],W.start&&(W.level==="block"?le.startBlock?le.startBlock.push(W.start):le.startBlock=[W.start]:W.level==="inline"&&(le.startInline?le.startInline.push(W.start):le.startInline=[W.start]))}W.childTokens&&(le.childTokens[W.name]=W.childTokens)})),re.renderer&&function(){var W=Y.defaults.renderer||new $,G=function(be){var ue=W[be];W[be]=function(){for(var Ce=arguments.length,Se=new Array(Ce),Ue=0;Ue<Ce;Ue++)Se[Ue]=arguments[Ue];var qe=re.renderer[be].apply(W,Se);return qe===!1&&(qe=ue.apply(W,Se)),qe}};for(var Q in re.renderer)G(Q);te.renderer=W}(),re.tokenizer&&function(){var W=Y.defaults.tokenizer||new B,G=function(be){var ue=W[be];W[be]=function(){for(var Ce=arguments.length,Se=new Array(Ce),Ue=0;Ue<Ce;Ue++)Se[Ue]=arguments[Ue];var qe=re.tokenizer[be].apply(W,Se);return qe===!1&&(qe=ue.apply(W,Se)),qe}};for(var Q in re.tokenizer)G(Q);te.tokenizer=W}(),re.walkTokens){var F=Y.defaults.walkTokens;te.walkTokens=function(W){re.walkTokens.call(this,W),F&&F.call(this,W)}}ee&&(te.extensions=le),Y.setOptions(te)})},Y.walkTokens=function(ae,de){for(var me=function(){var re=le.value;switch(de.call(Y,re),re.type){case"table":{for(var F=P(re.header),W;!(W=F()).done;){var G=W.value;Y.walkTokens(G.tokens,de)}for(var Q=P(re.rows),fe;!(fe=Q()).done;)for(var be=fe.value,ue=P(be),Ce;!(Ce=ue()).done;){var Se=Ce.value;Y.walkTokens(Se.tokens,de)}break}case"list":{Y.walkTokens(re.items,de);break}default:Y.defaults.extensions&&Y.defaults.extensions.childTokens&&Y.defaults.extensions.childTokens[re.type]?Y.defaults.extensions.childTokens[re.type].forEach(function(Ue){Y.walkTokens(re[Ue],de)}):re.tokens&&Y.walkTokens(re.tokens,de)}},te=P(ae),le;!(le=te()).done;)me()},Y.parseInline=function(ae,de){if(typeof ae=="undefined"||ae===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ae!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ae)+", string expected");de=a({},Y.defaults,de||{}),O(de);try{var me=L.lexInline(ae,de);return de.walkTokens&&Y.walkTokens(me,de.walkTokens),J.parseInline(me,de)}catch(te){if(te.message+=`
Please report this to https://github.com/markedjs/marked.`,de.silent)return"<p>An error occurred:</p><pre>"+w(te.message+"",!0)+"</pre>";throw te}},Y.Parser=J,Y.parser=J.parse,Y.Renderer=$,Y.TextRenderer=H,Y.Lexer=L,Y.lexer=L.lex,Y.Tokenizer=B,Y.Slugger=j,Y.parse=Y;var he=Y.options,ve=Y.setOptions,ne=Y.use,pe=Y.walkTokens,Ee=Y.parseInline,ke=Y,Oe=J.parse,Be=L.lex;Z.Lexer=L,Z.Parser=J,Z.Renderer=$,Z.Slugger=j,Z.TextRenderer=H,Z.Tokenizer=B,Z.getDefaults=y,Z.lexer=Be,Z.marked=Y,Z.options=he,Z.parse=ke,Z.parseInline=Ee,Z.parser=Oe,Z.setOptions=ve,Z.use=ne,Z.walkTokens=pe,Object.defineProperty(Z,"__esModule",{value:!0})}),define(De[94],Ie([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function u(C,E,I){return Math.min(Math.max(C,E),I)}e.clamp=u;function t(C,E){return(E+C%E)%E}e.rot=t;class D{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=D;class P{constructor(){this._n=1,this._val=0}update(E){return this._val=this._val+(E-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=P;class y{constructor(E){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(E),this._values.fill(0,0,E)}update(E){const I=this._values[this._index];return this._values[this._index]=E,this._index=(this._index+1)%this._values.length,this._sum-=I,this._sum+=E,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=y}),function(){function Z(D){const P=[];typeof D=="number"&&P.push("code/timeOrigin",D);function y(E){P.push(E,Date.now())}function C(){const E=[];for(let I=0;I<P.length;I+=2)E.push({name:P[I],startTime:P[I+1]});return E}return{mark:y,getMarks:C}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Z():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const P=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const y of performance.getEntriesByType("mark"))P.push({name:y.name,startTime:Math.round(D+y.startTime)});return P}};if(typeof process=="object"){const D=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Z(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),Z()}function u(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return u(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=u(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=u(t))}(),function(Z,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var u=e();for(var t in u)(typeof exports=="object"?exports:Z)[t]=u[t]}}(typeof self!="undefined"?self:this,function(){return function(Z){var e={};function u(t){if(e[t])return e[t].exports;var D=e[t]={i:t,l:!1,exports:{}};return Z[t].call(D.exports,D,D.exports,u),D.l=!0,D.exports}return u.m=Z,u.c=e,u.d=function(t,D,P){u.o(t,D)||Object.defineProperty(t,D,{enumerable:!0,get:P})},u.r=function(t){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},u.t=function(t,D){if(1&D&&(t=u(t)),8&D||4&D&&typeof t=="object"&&t&&t.__esModule)return t;var P=Object.create(null);if(u.r(P),Object.defineProperty(P,"default",{enumerable:!0,value:t}),2&D&&typeof t!="string")for(var y in t)u.d(P,y,function(C){return t[C]}.bind(null,y));return P},u.n=function(t){var D=t&&t.__esModule?function(){return t.default}:function(){return t};return u.d(D,"a",D),D},u.o=function(t,D){return Object.prototype.hasOwnProperty.call(t,D)},u.p="",u(u.s=0)}([function(Z,e,u){(function(t){var D;e=Z.exports=ne,D=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var ue=Array.prototype.slice.call(arguments,0);ue.unshift("SEMVER"),console.log.apply(console,ue)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var P=256,y=Number.MAX_SAFE_INTEGER||9007199254740991,C=e.re=[],E=e.src=[],I=0,R=I++;E[R]="0|[1-9]\\d*";var k=I++;E[k]="[0-9]+";var _=I++;E[_]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var T=I++;E[T]="("+E[R]+")\\.("+E[R]+")\\.("+E[R]+")";var w=I++;E[w]="("+E[k]+")\\.("+E[k]+")\\.("+E[k]+")";var b=I++;E[b]="(?:"+E[R]+"|"+E[_]+")";var v=I++;E[v]="(?:"+E[k]+"|"+E[_]+")";var h=I++;E[h]="(?:-("+E[b]+"(?:\\."+E[b]+")*))";var g=I++;E[g]="(?:-?("+E[v]+"(?:\\."+E[v]+")*))";var p=I++;E[p]="[0-9A-Za-z-]+";var o=I++;E[o]="(?:\\+("+E[p]+"(?:\\."+E[p]+")*))";var m=I++,c="v?"+E[T]+E[h]+"?"+E[o]+"?";E[m]="^"+c+"$";var l="[v=\\s]*"+E[w]+E[g]+"?"+E[o]+"?",s=I++;E[s]="^"+l+"$";var i=I++;E[i]="((?:<|>)?=?)";var r=I++;E[r]=E[k]+"|x|X|\\*";var n=I++;E[n]=E[R]+"|x|X|\\*";var a=I++;E[a]="[v=\\s]*("+E[n]+")(?:\\.("+E[n]+")(?:\\.("+E[n]+")(?:"+E[h]+")?"+E[o]+"?)?)?";var d=I++;E[d]="[v=\\s]*("+E[r]+")(?:\\.("+E[r]+")(?:\\.("+E[r]+")(?:"+E[g]+")?"+E[o]+"?)?)?";var f=I++;E[f]="^"+E[i]+"\\s*"+E[a]+"$";var S=I++;E[S]="^"+E[i]+"\\s*"+E[d]+"$";var O=I++;E[O]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var U=I++;E[U]="(?:~>?)";var M=I++;E[M]="(\\s*)"+E[U]+"\\s+",C[M]=new RegExp(E[M],"g");var A=I++;E[A]="^"+E[U]+E[a]+"$";var B=I++;E[B]="^"+E[U]+E[d]+"$";var x=I++;E[x]="(?:\\^)";var N=I++;E[N]="(\\s*)"+E[x]+"\\s+",C[N]=new RegExp(E[N],"g");var K=I++;E[K]="^"+E[x]+E[a]+"$";var X=I++;E[X]="^"+E[x]+E[d]+"$";var L=I++;E[L]="^"+E[i]+"\\s*("+l+")$|^$";var $=I++;E[$]="^"+E[i]+"\\s*("+c+")$|^$";var H=I++;E[H]="(\\s*)"+E[i]+"\\s*("+l+"|"+E[a]+")",C[H]=new RegExp(E[H],"g");var j=I++;E[j]="^\\s*("+E[a]+")\\s+-\\s+("+E[a]+")\\s*$";var J=I++;E[J]="^\\s*("+E[d]+")\\s+-\\s+("+E[d]+")\\s*$";var Y=I++;E[Y]="(<|>)?=?\\s*\\*";for(var he=0;he<35;he++)D(he,E[he]),C[he]||(C[he]=new RegExp(E[he]));function ve(ue,Ce){if(ue instanceof ne)return ue;if(typeof ue!="string"||ue.length>P||!(Ce?C[s]:C[m]).test(ue))return null;try{return new ne(ue,Ce)}catch{return null}}function ne(ue,Ce){if(ue instanceof ne){if(ue.loose===Ce)return ue;ue=ue.version}else if(typeof ue!="string")throw new TypeError("Invalid Version: "+ue);if(ue.length>P)throw new TypeError("version is longer than "+P+" characters");if(!(this instanceof ne))return new ne(ue,Ce);D("SemVer",ue,Ce),this.loose=Ce;var Se=ue.trim().match(Ce?C[s]:C[m]);if(!Se)throw new TypeError("Invalid Version: "+ue);if(this.raw=ue,this.major=+Se[1],this.minor=+Se[2],this.patch=+Se[3],this.major>y||this.major<0)throw new TypeError("Invalid major version");if(this.minor>y||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>y||this.patch<0)throw new TypeError("Invalid patch version");Se[4]?this.prerelease=Se[4].split(".").map(function(Ue){if(/^[0-9]+$/.test(Ue)){var qe=+Ue;if(qe>=0&&qe<y)return qe}return Ue}):this.prerelease=[],this.build=Se[5]?Se[5].split("."):[],this.format()}e.parse=ve,e.valid=function(ue,Ce){var Se=ve(ue,Ce);return Se?Se.version:null},e.clean=function(ue,Ce){var Se=ve(ue.trim().replace(/^[=v]+/,""),Ce);return Se?Se.version:null},e.SemVer=ne,ne.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ne.prototype.toString=function(){return this.version},ne.prototype.compare=function(ue){return D("SemVer.compare",this.version,this.loose,ue),ue instanceof ne||(ue=new ne(ue,this.loose)),this.compareMain(ue)||this.comparePre(ue)},ne.prototype.compareMain=function(ue){return ue instanceof ne||(ue=new ne(ue,this.loose)),Ee(this.major,ue.major)||Ee(this.minor,ue.minor)||Ee(this.patch,ue.patch)},ne.prototype.comparePre=function(ue){if(ue instanceof ne||(ue=new ne(ue,this.loose)),this.prerelease.length&&!ue.prerelease.length)return-1;if(!this.prerelease.length&&ue.prerelease.length)return 1;if(!this.prerelease.length&&!ue.prerelease.length)return 0;var Ce=0;do{var Se=this.prerelease[Ce],Ue=ue.prerelease[Ce];if(D("prerelease compare",Ce,Se,Ue),Se===void 0&&Ue===void 0)return 0;if(Ue===void 0)return 1;if(Se===void 0)return-1;if(Se!==Ue)return Ee(Se,Ue)}while(++Ce)},ne.prototype.inc=function(ue,Ce){switch(ue){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Ce);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Ce);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Ce),this.inc("pre",Ce);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Ce),this.inc("pre",Ce);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Se=this.prerelease.length;--Se>=0;)typeof this.prerelease[Se]=="number"&&(this.prerelease[Se]++,Se=-2);Se===-1&&this.prerelease.push(0)}Ce&&(this.prerelease[0]===Ce?isNaN(this.prerelease[1])&&(this.prerelease=[Ce,0]):this.prerelease=[Ce,0]);break;default:throw new Error("invalid increment argument: "+ue)}return this.format(),this.raw=this.version,this},e.inc=function(ue,Ce,Se,Ue){typeof Se=="string"&&(Ue=Se,Se=void 0);try{return new ne(ue,Se).inc(Ce,Ue).version}catch{return null}},e.diff=function(ue,Ce){if(ae(ue,Ce))return null;var Se=ve(ue),Ue=ve(Ce);if(Se.prerelease.length||Ue.prerelease.length){for(var qe in Se)if((qe==="major"||qe==="minor"||qe==="patch")&&Se[qe]!==Ue[qe])return"pre"+qe;return"prerelease"}for(var qe in Se)if((qe==="major"||qe==="minor"||qe==="patch")&&Se[qe]!==Ue[qe])return qe},e.compareIdentifiers=Ee;var pe=/^[0-9]+$/;function Ee(ue,Ce){var Se=pe.test(ue),Ue=pe.test(Ce);return Se&&Ue&&(ue=+ue,Ce=+Ce),Se&&!Ue?-1:Ue&&!Se?1:ue<Ce?-1:ue>Ce?1:0}function ke(ue,Ce,Se){return new ne(ue,Se).compare(new ne(Ce,Se))}function Oe(ue,Ce,Se){return ke(ue,Ce,Se)>0}function Be(ue,Ce,Se){return ke(ue,Ce,Se)<0}function ae(ue,Ce,Se){return ke(ue,Ce,Se)===0}function de(ue,Ce,Se){return ke(ue,Ce,Se)!==0}function me(ue,Ce,Se){return ke(ue,Ce,Se)>=0}function te(ue,Ce,Se){return ke(ue,Ce,Se)<=0}function le(ue,Ce,Se,Ue){var qe;switch(Ce){case"===":typeof ue=="object"&&(ue=ue.version),typeof Se=="object"&&(Se=Se.version),qe=ue===Se;break;case"!==":typeof ue=="object"&&(ue=ue.version),typeof Se=="object"&&(Se=Se.version),qe=ue!==Se;break;case"":case"=":case"==":qe=ae(ue,Se,Ue);break;case"!=":qe=de(ue,Se,Ue);break;case">":qe=Oe(ue,Se,Ue);break;case">=":qe=me(ue,Se,Ue);break;case"<":qe=Be(ue,Se,Ue);break;case"<=":qe=te(ue,Se,Ue);break;default:throw new TypeError("Invalid operator: "+Ce)}return qe}function ee(ue,Ce){if(ue instanceof ee){if(ue.loose===Ce)return ue;ue=ue.value}if(!(this instanceof ee))return new ee(ue,Ce);D("comparator",ue,Ce),this.loose=Ce,this.parse(ue),this.semver===re?this.value="":this.value=this.operator+this.semver.version,D("comp",this)}e.rcompareIdentifiers=function(ue,Ce){return Ee(Ce,ue)},e.major=function(ue,Ce){return new ne(ue,Ce).major},e.minor=function(ue,Ce){return new ne(ue,Ce).minor},e.patch=function(ue,Ce){return new ne(ue,Ce).patch},e.compare=ke,e.compareLoose=function(ue,Ce){return ke(ue,Ce,!0)},e.rcompare=function(ue,Ce,Se){return ke(Ce,ue,Se)},e.sort=function(ue,Ce){return ue.sort(function(Se,Ue){return e.compare(Se,Ue,Ce)})},e.rsort=function(ue,Ce){return ue.sort(function(Se,Ue){return e.rcompare(Se,Ue,Ce)})},e.gt=Oe,e.lt=Be,e.eq=ae,e.neq=de,e.gte=me,e.lte=te,e.cmp=le,e.Comparator=ee;var re={};function F(ue,Ce){if(ue instanceof F)return ue.loose===Ce?ue:new F(ue.raw,Ce);if(ue instanceof ee)return new F(ue.value,Ce);if(!(this instanceof F))return new F(ue,Ce);if(this.loose=Ce,this.raw=ue,this.set=ue.split(/\s*\|\|\s*/).map(function(Se){return this.parseRange(Se.trim())},this).filter(function(Se){return Se.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ue);this.format()}function W(ue){return!ue||ue.toLowerCase()==="x"||ue==="*"}function G(ue,Ce,Se,Ue,qe,Je,Qe,Re,st,se,oe,q,ye){return((Ce=W(Se)?"":W(Ue)?">="+Se+".0.0":W(qe)?">="+Se+"."+Ue+".0":">="+Ce)+" "+(Re=W(st)?"":W(se)?"<"+(+st+1)+".0.0":W(oe)?"<"+st+"."+(+se+1)+".0":q?"<="+st+"."+se+"."+oe+"-"+q:"<="+Re)).trim()}function Q(ue,Ce){for(var Se=0;Se<ue.length;Se++)if(!ue[Se].test(Ce))return!1;if(Ce.prerelease.length){for(Se=0;Se<ue.length;Se++)if(D(ue[Se].semver),ue[Se].semver!==re&&ue[Se].semver.prerelease.length>0){var Ue=ue[Se].semver;if(Ue.major===Ce.major&&Ue.minor===Ce.minor&&Ue.patch===Ce.patch)return!0}return!1}return!0}function fe(ue,Ce,Se){try{Ce=new F(Ce,Se)}catch{return!1}return Ce.test(ue)}function be(ue,Ce,Se,Ue){var qe,Je,Qe,Re,st;switch(ue=new ne(ue,Ue),Ce=new F(Ce,Ue),Se){case">":qe=Oe,Je=te,Qe=Be,Re=">",st=">=";break;case"<":qe=Be,Je=me,Qe=Oe,Re="<",st="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(fe(ue,Ce,Ue))return!1;for(var se=0;se<Ce.set.length;++se){var oe=Ce.set[se],q=null,ye=null;if(oe.forEach(function(Ae){Ae.semver===re&&(Ae=new ee(">=0.0.0")),q=q||Ae,ye=ye||Ae,qe(Ae.semver,q.semver,Ue)?q=Ae:Qe(Ae.semver,ye.semver,Ue)&&(ye=Ae)}),q.operator===Re||q.operator===st||(!ye.operator||ye.operator===Re)&&Je(ue,ye.semver)||ye.operator===st&&Qe(ue,ye.semver))return!1}return!0}ee.prototype.parse=function(ue){var Ce=this.loose?C[L]:C[$],Se=ue.match(Ce);if(!Se)throw new TypeError("Invalid comparator: "+ue);this.operator=Se[1],this.operator==="="&&(this.operator=""),Se[2]?this.semver=new ne(Se[2],this.loose):this.semver=re},ee.prototype.toString=function(){return this.value},ee.prototype.test=function(ue){return D("Comparator.test",ue,this.loose),this.semver===re||(typeof ue=="string"&&(ue=new ne(ue,this.loose)),le(ue,this.operator,this.semver,this.loose))},ee.prototype.intersects=function(ue,Ce){if(!(ue instanceof ee))throw new TypeError("a Comparator is required");var Se;if(this.operator==="")return Se=new F(ue.value,Ce),fe(this.value,Se,Ce);if(ue.operator==="")return Se=new F(this.value,Ce),fe(ue.semver,Se,Ce);var Ue=!(this.operator!==">="&&this.operator!==">"||ue.operator!==">="&&ue.operator!==">"),qe=!(this.operator!=="<="&&this.operator!=="<"||ue.operator!=="<="&&ue.operator!=="<"),Je=this.semver.version===ue.semver.version,Qe=!(this.operator!==">="&&this.operator!=="<="||ue.operator!==">="&&ue.operator!=="<="),Re=le(this.semver,"<",ue.semver,Ce)&&(this.operator===">="||this.operator===">")&&(ue.operator==="<="||ue.operator==="<"),st=le(this.semver,">",ue.semver,Ce)&&(this.operator==="<="||this.operator==="<")&&(ue.operator===">="||ue.operator===">");return Ue||qe||Je&&Qe||Re||st},e.Range=F,F.prototype.format=function(){return this.range=this.set.map(function(ue){return ue.join(" ").trim()}).join("||").trim(),this.range},F.prototype.toString=function(){return this.range},F.prototype.parseRange=function(ue){var Ce=this.loose;ue=ue.trim(),D("range",ue,Ce);var Se=Ce?C[J]:C[j];ue=ue.replace(Se,G),D("hyphen replace",ue),ue=ue.replace(C[H],"$1$2$3"),D("comparator trim",ue,C[H]),ue=(ue=(ue=ue.replace(C[M],"$1~")).replace(C[N],"$1^")).split(/\s+/).join(" ");var Ue=Ce?C[L]:C[$],qe=ue.split(" ").map(function(Je){return function(Qe,Re){return D("comp",Qe),Qe=function(st,se){return st.trim().split(/\s+/).map(function(oe){return function(q,ye){D("caret",q,ye);var Ae=ye?C[X]:C[K];return q.replace(Ae,function(We,ze,$e,Ze,it){var lt;return D("caret",q,We,ze,$e,Ze,it),W(ze)?lt="":W($e)?lt=">="+ze+".0.0 <"+(+ze+1)+".0.0":W(Ze)?lt=ze==="0"?">="+ze+"."+$e+".0 <"+ze+"."+(+$e+1)+".0":">="+ze+"."+$e+".0 <"+(+ze+1)+".0.0":it?(D("replaceCaret pr",it),it.charAt(0)!=="-"&&(it="-"+it),lt=ze==="0"?$e==="0"?">="+ze+"."+$e+"."+Ze+it+" <"+ze+"."+$e+"."+(+Ze+1):">="+ze+"."+$e+"."+Ze+it+" <"+ze+"."+(+$e+1)+".0":">="+ze+"."+$e+"."+Ze+it+" <"+(+ze+1)+".0.0"):(D("no pr"),lt=ze==="0"?$e==="0"?">="+ze+"."+$e+"."+Ze+" <"+ze+"."+$e+"."+(+Ze+1):">="+ze+"."+$e+"."+Ze+" <"+ze+"."+(+$e+1)+".0":">="+ze+"."+$e+"."+Ze+" <"+(+ze+1)+".0.0"),D("caret return",lt),lt})}(oe,se)}).join(" ")}(Qe,Re),D("caret",Qe),Qe=function(st,se){return st.trim().split(/\s+/).map(function(oe){return function(q,ye){var Ae=ye?C[B]:C[A];return q.replace(Ae,function(We,ze,$e,Ze,it){var lt;return D("tilde",q,We,ze,$e,Ze,it),W(ze)?lt="":W($e)?lt=">="+ze+".0.0 <"+(+ze+1)+".0.0":W(Ze)?lt=">="+ze+"."+$e+".0 <"+ze+"."+(+$e+1)+".0":it?(D("replaceTilde pr",it),it.charAt(0)!=="-"&&(it="-"+it),lt=">="+ze+"."+$e+"."+Ze+it+" <"+ze+"."+(+$e+1)+".0"):lt=">="+ze+"."+$e+"."+Ze+" <"+ze+"."+(+$e+1)+".0",D("tilde return",lt),lt})}(oe,se)}).join(" ")}(Qe,Re),D("tildes",Qe),Qe=function(st,se){return D("replaceXRanges",st,se),st.split(/\s+/).map(function(oe){return function(q,ye){q=q.trim();var Ae=ye?C[S]:C[f];return q.replace(Ae,function(We,ze,$e,Ze,it,lt){D("xRange",q,We,ze,$e,Ze,it,lt);var ht=W($e),tt=ht||W(Ze),at=tt||W(it);return ze==="="&&at&&(ze=""),ht?We=ze===">"||ze==="<"?"<0.0.0":"*":ze&&at?(tt&&(Ze=0),at&&(it=0),ze===">"?(ze=">=",tt?($e=+$e+1,Ze=0,it=0):at&&(Ze=+Ze+1,it=0)):ze==="<="&&(ze="<",tt?$e=+$e+1:Ze=+Ze+1),We=ze+$e+"."+Ze+"."+it):tt?We=">="+$e+".0.0 <"+(+$e+1)+".0.0":at&&(We=">="+$e+"."+Ze+".0 <"+$e+"."+(+Ze+1)+".0"),D("xRange return",We),We})}(oe,se)}).join(" ")}(Qe,Re),D("xrange",Qe),Qe=function(st,se){return D("replaceStars",st,se),st.trim().replace(C[Y],"")}(Qe,Re),D("stars",Qe),Qe}(Je,Ce)}).join(" ").split(/\s+/);return this.loose&&(qe=qe.filter(function(Je){return!!Je.match(Ue)})),qe=qe.map(function(Je){return new ee(Je,Ce)})},F.prototype.intersects=function(ue,Ce){if(!(ue instanceof F))throw new TypeError("a Range is required");return this.set.some(function(Se){return Se.every(function(Ue){return ue.set.some(function(qe){return qe.every(function(Je){return Ue.intersects(Je,Ce)})})})})},e.toComparators=function(ue,Ce){return new F(ue,Ce).set.map(function(Se){return Se.map(function(Ue){return Ue.value}).join(" ").trim().split(" ")})},F.prototype.test=function(ue){if(!ue)return!1;typeof ue=="string"&&(ue=new ne(ue,this.loose));for(var Ce=0;Ce<this.set.length;Ce++)if(Q(this.set[Ce],ue))return!0;return!1},e.satisfies=fe,e.maxSatisfying=function(ue,Ce,Se){var Ue=null,qe=null;try{var Je=new F(Ce,Se)}catch{return null}return ue.forEach(function(Qe){Je.test(Qe)&&(Ue&&qe.compare(Qe)!==-1||(qe=new ne(Ue=Qe,Se)))}),Ue},e.minSatisfying=function(ue,Ce,Se){var Ue=null,qe=null;try{var Je=new F(Ce,Se)}catch{return null}return ue.forEach(function(Qe){Je.test(Qe)&&(Ue&&qe.compare(Qe)!==1||(qe=new ne(Ue=Qe,Se)))}),Ue},e.validRange=function(ue,Ce){try{return new F(ue,Ce).range||"*"}catch{return null}},e.ltr=function(ue,Ce,Se){return be(ue,Ce,"<",Se)},e.gtr=function(ue,Ce,Se){return be(ue,Ce,">",Se)},e.outside=be,e.prerelease=function(ue,Ce){var Se=ve(ue,Ce);return Se&&Se.prerelease.length?Se.prerelease:null},e.intersects=function(ue,Ce,Se){return ue=new F(ue,Se),Ce=new F(Ce,Se),ue.intersects(Ce)},e.coerce=function(ue){if(ue instanceof ne)return ue;if(typeof ue!="string")return null;var Ce=ue.match(C[O]);return Ce==null?null:ve((Ce[1]||"0")+"."+(Ce[2]||"0")+"."+(Ce[3]||"0"))}}).call(this,u(1))},function(Z,e){var u,t,D=Z.exports={};function P(){throw new Error("setTimeout has not been defined")}function y(){throw new Error("clearTimeout has not been defined")}function C(v){if(u===setTimeout)return setTimeout(v,0);if((u===P||!u)&&setTimeout)return u=setTimeout,setTimeout(v,0);try{return u(v,0)}catch{try{return u.call(null,v,0)}catch{return u.call(this,v,0)}}}(function(){try{u=typeof setTimeout=="function"?setTimeout:P}catch{u=P}try{t=typeof clearTimeout=="function"?clearTimeout:y}catch{t=y}})();var E,I=[],R=!1,k=-1;function _(){R&&E&&(R=!1,E.length?I=E.concat(I):k=-1,I.length&&T())}function T(){if(!R){var v=C(_);R=!0;for(var h=I.length;h;){for(E=I,I=[];++k<h;)E&&E[k].run();k=-1,h=I.length}E=null,R=!1,function(g){if(t===clearTimeout)return clearTimeout(g);if((t===y||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(g);try{t(g)}catch{try{return t.call(null,g)}catch{return t.call(this,g)}}}(v)}}function w(v,h){this.fun=v,this.array=h}function b(){}D.nextTick=function(v){var h=new Array(arguments.length-1);if(arguments.length>1)for(var g=1;g<arguments.length;g++)h[g-1]=arguments[g];I.push(new w(v,h)),I.length!==1||R||C(T)},w.prototype.run=function(){this.fun.apply(null,this.array)},D.title="browser",D.browser=!0,D.env={},D.argv=[],D.version="",D.versions={},D.on=b,D.addListener=b,D.once=b,D.off=b,D.removeListener=b,D.removeAllListeners=b,D.emit=b,D.prependListener=b,D.prependOnceListener=b,D.listeners=function(v){return[]},D.binding=function(v){throw new Error("process.binding is not supported")},D.cwd=function(){return"/"},D.chdir=function(v){throw new Error("process.chdir is not supported")},D.umask=function(){return 0}}])}),define(De[95],Ie([1,0,10,6]),function(Z,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function D(o){const m=o;return m?typeof m.read=="function":!1}e.isReadable=D;function P(o){const m=o;return m?[m.on,m.pause,m.resume,m.destroy].every(c=>typeof c=="function"):!1}e.isReadableStream=P;function y(o){const m=o;return m?P(m.stream)&&Array.isArray(m.buffer)&&typeof m.ended=="boolean":!1}e.isReadableBufferedStream=y;function C(o,m){return new E(o,m)}e.newWriteableStream=C;class E{constructor(m,c){this.reducer=m,this.options=c,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(m){if(!this.state.destroyed){if(this.state.flowing)this.emitData(m);else if(this.buffer.data.push(m),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(c=>this.pendingWritePromises.push(c))}}error(m){this.state.destroyed||(this.state.flowing?this.emitError(m):this.buffer.error.push(m))}end(m){this.state.destroyed||(typeof m!="undefined"&&this.write(m),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(m){this.listeners.data.slice(0).forEach(c=>c(m))}emitError(m){this.listeners.error.length===0?(0,u.onUnexpectedError)(m):this.listeners.error.slice(0).forEach(c=>c(m))}emitEnd(){this.listeners.end.slice(0).forEach(m=>m())}on(m,c){if(!this.state.destroyed)switch(m){case"data":this.listeners.data.push(c),this.resume();break;case"end":this.listeners.end.push(c),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(c),this.state.flowing&&this.flowErrors();break}}removeListener(m,c){if(this.state.destroyed)return;let l;switch(m){case"data":l=this.listeners.data;break;case"end":l=this.listeners.end;break;case"error":l=this.listeners.error;break}if(l){const s=l.indexOf(c);s>=0&&l.splice(s,1)}}flowData(){if(this.buffer.data.length>0){const m=this.reducer(this.buffer.data);this.emitData(m),this.buffer.data.length=0;const c=[...this.pendingWritePromises];this.pendingWritePromises.length=0,c.forEach(l=>l())}}flowErrors(){if(this.listeners.error.length>0){for(const m of this.buffer.error)this.emitError(m);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function I(o,m){const c=[];let l;for(;(l=o.read())!==null;)c.push(l);return m(c)}e.consumeReadable=I;function R(o,m,c){const l=[];let s;for(;(s=o.read())!==null&&l.length<c;)l.push(s);return s===null&&l.length>0?m(l):{read:()=>{if(l.length>0)return l.shift();if(typeof s!="undefined"){const i=s;return s=void 0,i}return o.read()}}}e.peekReadable=R;function k(o,m){return new Promise((c,l)=>{const s=[];_(o,{onData:i=>{m&&s.push(i)},onError:i=>{m?l(i):c(void 0)},onEnd:()=>{c(m?m(s):void 0)}})})}e.consumeStream=k;function _(o,m){let c=!1;return o.on("error",l=>{c||m.onError(l)}),o.on("end",()=>{c||m.onEnd()}),o.on("data",l=>{c||m.onData(l)}),(0,t.toDisposable)(()=>c=!0)}e.listenStream=_;function T(o,m){return new Promise((c,l)=>{const s=new t.DisposableStore,i=[],r=d=>{if(i.push(d),i.length>m)return s.dispose(),o.pause(),c({stream:o,buffer:i,ended:!1})},n=d=>l(d),a=()=>c({stream:o,buffer:i,ended:!0});s.add((0,t.toDisposable)(()=>o.removeListener("error",n))),o.on("error",n),s.add((0,t.toDisposable)(()=>o.removeListener("end",a))),o.on("end",a),s.add((0,t.toDisposable)(()=>o.removeListener("data",r))),o.on("data",r)})}e.peekStream=T;function w(o,m){const c=C(m);return c.end(o),c}e.toStream=w;function b(){const o=C(()=>{throw new Error("not supported")});return o.end(),o}e.emptyStream=b;function v(o){let m=!1;return{read:()=>m?null:(m=!0,o)}}e.toReadable=v;function h(o,m,c){const l=C(c);return _(o,{onData:s=>l.write(m.data(s)),onError:s=>l.error(m.error?m.error(s):s),onEnd:()=>l.end()}),l}e.transform=h;function g(o,m,c){let l=!1;return{read:()=>{const s=m.read();return l?s:(l=!0,s!==null?c([o,s]):o)}}}e.prefixedReadable=g;function p(o,m,c){let l=!1;const s=C(c);return _(m,{onData:i=>l?s.write(i):(l=!0,s.write(c([o,i]))),onError:i=>s.error(i),onEnd:()=>{l||(l=!0,s.write(o)),s.end()}}),s}e.prefixedStream=p}),define(De[23],Ie([1,0,95]),function(Z,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer!="undefined";let D,P;class y{constructor(d){this.buffer=d,this.byteLength=this.buffer.byteLength}static alloc(d){return t?new y(Buffer.allocUnsafe(d)):new y(new Uint8Array(d))}static wrap(d){return t&&!Buffer.isBuffer(d)&&(d=Buffer.from(d.buffer,d.byteOffset,d.byteLength)),new y(d)}static fromString(d,f){return!(f?.dontUseNodeBuffer||!1)&&t?new y(Buffer.from(d)):(D||(D=new TextEncoder),new y(D.encode(d)))}static fromByteArray(d){const f=y.alloc(d.length);for(let S=0,O=d.length;S<O;S++)f.buffer[S]=d[S];return f}static concat(d,f){if(typeof f=="undefined"){f=0;for(let U=0,M=d.length;U<M;U++)f+=d[U].byteLength}const S=y.alloc(f);let O=0;for(let U=0,M=d.length;U<M;U++){const A=d[U];S.set(A,O),O+=A.byteLength}return S}clone(){const d=y.alloc(this.byteLength);return d.set(this),d}toString(){return t?this.buffer.toString():(P||(P=new TextDecoder),P.decode(this.buffer))}slice(d,f){return new y(this.buffer.subarray(d,f))}set(d,f){if(d instanceof y)this.buffer.set(d.buffer,f);else if(d instanceof Uint8Array)this.buffer.set(d,f);else if(d instanceof ArrayBuffer)this.buffer.set(new Uint8Array(d),f);else if(ArrayBuffer.isView(d))this.buffer.set(new Uint8Array(d.buffer,d.byteOffset,d.byteLength),f);else throw new Error("Unknown argument 'array'")}readUInt32BE(d){return I(this.buffer,d)}writeUInt32BE(d,f){R(this.buffer,d,f)}readUInt32LE(d){return k(this.buffer,d)}writeUInt32LE(d,f){_(this.buffer,d,f)}readUInt8(d){return T(this.buffer,d)}writeUInt8(d,f){w(this.buffer,d,f)}}e.VSBuffer=y;function C(a,d){return a[d+0]<<0>>>0|a[d+1]<<8>>>0}e.readUInt16LE=C;function E(a,d,f){a[f+0]=d&255,d=d>>>8,a[f+1]=d&255}e.writeUInt16LE=E;function I(a,d){return a[d]*2**24+a[d+1]*2**16+a[d+2]*2**8+a[d+3]}e.readUInt32BE=I;function R(a,d,f){a[f+3]=d,d=d>>>8,a[f+2]=d,d=d>>>8,a[f+1]=d,d=d>>>8,a[f]=d}e.writeUInt32BE=R;function k(a,d){return a[d+0]<<0>>>0|a[d+1]<<8>>>0|a[d+2]<<16>>>0|a[d+3]<<24>>>0}e.readUInt32LE=k;function _(a,d,f){a[f+0]=d&255,d=d>>>8,a[f+1]=d&255,d=d>>>8,a[f+2]=d&255,d=d>>>8,a[f+3]=d&255}e.writeUInt32LE=_;function T(a,d){return a[d]}e.readUInt8=T;function w(a,d,f){a[f]=d}e.writeUInt8=w;function b(a){return u.consumeReadable(a,d=>y.concat(d))}e.readableToBuffer=b;function v(a){return u.toReadable(a)}e.bufferToReadable=v;function h(a){return u.consumeStream(a,d=>y.concat(d))}e.streamToBuffer=h;async function g(a){return a.ended?y.concat(a.buffer):y.concat([...a.buffer,await h(a.stream)])}e.bufferedStreamToBuffer=g;function p(a){return u.toStream(a,d=>y.concat(d))}e.bufferToStream=p;function o(a){return u.transform(a,{data:d=>typeof d=="string"?y.fromString(d):y.wrap(d)},d=>y.concat(d))}e.streamToBufferReadableStream=o;function m(a){return u.newWriteableStream(d=>y.concat(d),a)}e.newWriteableBufferStream=m;function c(a,d){return u.prefixedReadable(a,d,f=>y.concat(f))}e.prefixedBufferReadable=c;function l(a,d){return u.prefixedStream(a,d,f=>y.concat(f))}e.prefixedBufferStream=l;function s(a){let d=0,f=0,S=0;const O=new Uint8Array(Math.floor(a.length/4*3)),U=A=>{switch(f){case 3:O[S++]=d|A,f=0;break;case 2:O[S++]=d|A>>>2,d=A<<6,f=3;break;case 1:O[S++]=d|A>>>4,d=A<<4,f=2;break;default:d=A<<2,f=1}};for(let A=0;A<a.length;A++){const B=a.charCodeAt(A);if(B>=65&&B<=90)U(B-65);else if(B>=97&&B<=122)U(B-97+26);else if(B>=48&&B<=57)U(B-48+52);else if(B===43||B===45)U(62);else if(B===47||B===95)U(63);else{if(B===61)break;throw new SyntaxError(`Unexpected base64 character ${a[A]}`)}}const M=S;for(;f>0;)U(0);return y.wrap(O).slice(0,M)}e.decodeBase64=s;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function n({buffer:a},d=!0,f=!1){const S=f?r:i;let O="";const U=a.byteLength%3;let M=0;for(;M<a.byteLength-U;M+=3){const A=a[M+0],B=a[M+1],x=a[M+2];O+=S[A>>>2],O+=S[(A<<4|B>>>4)&63],O+=S[(B<<2|x>>>6)&63],O+=S[x&63]}if(U===1){const A=a[M+0];O+=S[A>>>2],O+=S[A<<4&63],d&&(O+="==")}else if(U===2){const A=a[M+0],B=a[M+1];O+=S[A>>>2],O+=S[(A<<4|B>>>4)&63],O+=S[B<<2&63],d&&(O+="=")}return O}e.encodeBase64=n}),define(De[13],Ie([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function u(l){return typeof l=="string"}e.isString=u;function t(l){return Array.isArray(l)&&l.every(s=>u(s))}e.isStringArray=t;function D(l){return typeof l=="object"&&l!==null&&!Array.isArray(l)&&!(l instanceof RegExp)&&!(l instanceof Date)}e.isObject=D;function P(l){const s=Object.getPrototypeOf(Uint8Array);return typeof l=="object"&&l instanceof s}e.isTypedArray=P;function y(l){return typeof l=="number"&&!isNaN(l)}e.isNumber=y;function C(l){return!!l&&typeof l[Symbol.iterator]=="function"}e.isIterable=C;function E(l){return l===!0||l===!1}e.isBoolean=E;function I(l){return typeof l=="undefined"}e.isUndefined=I;function R(l){return!k(l)}e.isDefined=R;function k(l){return I(l)||l===null}e.isUndefinedOrNull=k;function _(l,s){if(!l)throw new Error(s?`Unexpected type, expected '${s}'`:"Unexpected type")}e.assertType=_;function T(l){if(k(l))throw new Error("Assertion Failed: argument is undefined or null");return l}e.assertIsDefined=T;function w(...l){const s=[];for(let i=0;i<l.length;i++){const r=l[i];if(k(r))throw new Error(`Assertion Failed: argument at index ${i} is undefined or null`);s.push(r)}return s}e.assertAllDefined=w;const b=Object.prototype.hasOwnProperty;function v(l){if(!D(l))return!1;for(const s in l)if(b.call(l,s))return!1;return!0}e.isEmptyObject=v;function h(l){return typeof l=="function"}e.isFunction=h;function g(...l){return l.length>0&&l.every(h)}e.areFunctions=g;function p(l,s){const i=Math.min(l.length,s.length);for(let r=0;r<i;r++)o(l[r],s[r])}e.validateConstraints=p;function o(l,s){if(u(s)){if(typeof l!==s)throw new Error(`argument does not match constraint: typeof ${s}`)}else if(h(s)){try{if(l instanceof s)return}catch{}if(!k(l)&&l.constructor===s||s.length===1&&s.call(void 0,l)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=o;function m(l){return l===null?void 0:l}e.withNullAsUndefined=m;function c(l){return typeof l=="undefined"?null:l}e.withUndefinedAsNull=c}),define(De[24],Ie([1,0,13]),function(Z,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const g=Array.isArray(h)?[]:{};return Object.keys(h).forEach(p=>{h[p]&&typeof h[p]=="object"?g[p]=t(h[p]):g[p]=h[p]}),g}e.deepClone=t;function D(h){if(!h||typeof h!="object")return h;const g=[h];for(;g.length>0;){const p=g.shift();Object.freeze(p);for(const o in p)if(P.call(p,o)){const m=p[o];typeof m=="object"&&!Object.isFrozen(m)&&!(0,u.isTypedArray)(m)&&g.push(m)}}return h}e.deepFreeze=D;const P=Object.prototype.hasOwnProperty;function y(h,g){return C(h,g,new Set)}e.cloneAndChange=y;function C(h,g,p){if((0,u.isUndefinedOrNull)(h))return h;const o=g(h);if(typeof o!="undefined")return o;if(Array.isArray(h)){const m=[];for(const c of h)m.push(C(c,g,p));return m}if((0,u.isObject)(h)){if(p.has(h))throw new Error("Cannot clone recursive data-structure");p.add(h);const m={};for(const c in h)P.call(h,c)&&(m[c]=C(h[c],g,p));return p.delete(h),m}return h}function E(h,g,p=!0){return(0,u.isObject)(h)?((0,u.isObject)(g)&&Object.keys(g).forEach(o=>{o in h?p&&((0,u.isObject)(h[o])&&(0,u.isObject)(g[o])?E(h[o],g[o],p):h[o]=g[o]):h[o]=g[o]}),h):g}e.mixin=E;function I(h,g){if(h===g)return!0;if(h==null||g===null||g===void 0||typeof h!=typeof g||typeof h!="object"||Array.isArray(h)!==Array.isArray(g))return!1;let p,o;if(Array.isArray(h)){if(h.length!==g.length)return!1;for(p=0;p<h.length;p++)if(!I(h[p],g[p]))return!1}else{const m=[];for(o in h)m.push(o);m.sort();const c=[];for(o in g)c.push(o);if(c.sort(),!I(m,c))return!1;for(p=0;p<m.length;p++)if(!I(h[m[p]],g[m[p]]))return!1}return!0}e.equals=I;function R(h){const g=new Set;return JSON.stringify(h,(p,o)=>{if((0,u.isObject)(o)||Array.isArray(o)){if(g.has(o))return"[Circular]";g.add(o)}return o})}e.safeStringify=R;function k(h,g){const p=Object.create(null);return!h||!g||Object.keys(g).forEach(m=>{const c=h[m],l=g[m];I(c,l)||(p[m]=l)}),p}e.distinct=k;function _(h,g){const p=g.toLowerCase(),o=Object.keys(h).find(m=>m.toLowerCase()===p);return o?h[o]:h[g]}e.getCaseInsensitive=_;function T(h,g){const p=Object.create(null);for(const[o,m]of Object.entries(h))g(o,m)&&(p[o]=m);return p}e.filter=T;function w(h){let g=[],p=Object.getPrototypeOf(h);for(;Object.prototype!==p;)g=g.concat(Object.getOwnPropertyNames(p)),p=Object.getPrototypeOf(p);return g}e.getAllPropertyNames=w;function b(h){const g=[];for(const p of w(h))typeof h[p]=="function"&&g.push(p);return g}e.getAllMethodNames=b;function v(h,g){const p=m=>function(){const c=Array.prototype.slice.call(arguments,0);return g(m,c)},o={};for(const m of h)o[m]=p(m);return o}e.createProxyObject=v}),define(De[96],Ie([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var u;(function(P){P[P.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",P[P.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",P[P.MAX_UINT_8=255]="MAX_UINT_8",P[P.MAX_UINT_16=65535]="MAX_UINT_16",P[P.MAX_UINT_32=4294967295]="MAX_UINT_32",P[P.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(u=e.Constants||(e.Constants={}));function t(P){return P<0?0:P>255?255:P|0}e.toUint8=t;function D(P){return P<0?0:P>4294967295?4294967295:P|0}e.toUint32=D}),define(De[34],Ie([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const u=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(D){return u.test(D)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let D;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?D=crypto.getRandomValues.bind(crypto):D=function(C){for(let E=0;E<C.length;E++)C[E]=Math.floor(Math.random()*256);return C};const P=new Uint8Array(16),y=[];for(let C=0;C<256;C++)y.push(C.toString(16).padStart(2,"0"));return function(){D(P),P[6]=P[6]&15|64,P[8]=P[8]&63|128;let E=0,I="";return I+=y[P[E++]],I+=y[P[E++]],I+=y[P[E++]],I+=y[P[E++]],I+="-",I+=y[P[E++]],I+=y[P[E++]],I+="-",I+=y[P[E++]],I+=y[P[E++]],I+="-",I+=y[P[E++]],I+=y[P[E++]],I+="-",I+=y[P[E++]],I+=y[P[E++]],I+=y[P[E++]],I+=y[P[E++]],I+=y[P[E++]],I+=y[P[E++]],I}}()}),define(De[97],Ie([1,0,96]),function(Z,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class t{constructor(C){const E=(0,u.toUint8)(C);this._defaultValue=E,this._asciiMap=t._createAsciiMap(E),this._map=new Map}static _createAsciiMap(C){const E=new Uint8Array(256);for(let I=0;I<256;I++)E[I]=C;return E}set(C,E){const I=(0,u.toUint8)(E);C>=0&&C<256?this._asciiMap[C]=I:this._map.set(C,I)}get(C){return C>=0&&C<256?this._asciiMap[C]:this._map.get(C)||this._defaultValue}}e.CharacterClassifier=t;var D;(function(y){y[y.False=0]="False",y[y.True=1]="True"})(D||(D={}));class P{constructor(){this._actual=new t(0)}add(C){this._actual.set(C,1)}has(C){return this._actual.get(C)===1}}e.CharacterSet=P}),define(De[49],Ie([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class u{constructor(D,P){this.lineNumber=D,this.column=P}with(D=this.lineNumber,P=this.column){return D===this.lineNumber&&P===this.column?this:new u(D,P)}delta(D=0,P=0){return this.with(this.lineNumber+D,this.column+P)}equals(D){return u.equals(this,D)}static equals(D,P){return!D&&!P?!0:!!D&&!!P&&D.lineNumber===P.lineNumber&&D.column===P.column}isBefore(D){return u.isBefore(this,D)}static isBefore(D,P){return D.lineNumber<P.lineNumber?!0:P.lineNumber<D.lineNumber?!1:D.column<P.column}isBeforeOrEqual(D){return u.isBeforeOrEqual(this,D)}static isBeforeOrEqual(D,P){return D.lineNumber<P.lineNumber?!0:P.lineNumber<D.lineNumber?!1:D.column<=P.column}static compare(D,P){const y=D.lineNumber|0,C=P.lineNumber|0;if(y===C){const E=D.column|0,I=P.column|0;return E-I}return y-C}clone(){return new u(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(D){return new u(D.lineNumber,D.column)}static isIPosition(D){return D&&typeof D.lineNumber=="number"&&typeof D.column=="number"}}e.Position=u}),define(De[35],Ie([1,0,49]),function(Z,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class t{constructor(P,y,C,E){P>C||P===C&&y>E?(this.startLineNumber=C,this.startColumn=E,this.endLineNumber=P,this.endColumn=y):(this.startLineNumber=P,this.startColumn=y,this.endLineNumber=C,this.endColumn=E)}isEmpty(){return t.isEmpty(this)}static isEmpty(P){return P.startLineNumber===P.endLineNumber&&P.startColumn===P.endColumn}containsPosition(P){return t.containsPosition(this,P)}static containsPosition(P,y){return!(y.lineNumber<P.startLineNumber||y.lineNumber>P.endLineNumber||y.lineNumber===P.startLineNumber&&y.column<P.startColumn||y.lineNumber===P.endLineNumber&&y.column>P.endColumn)}static strictContainsPosition(P,y){return!(y.lineNumber<P.startLineNumber||y.lineNumber>P.endLineNumber||y.lineNumber===P.startLineNumber&&y.column<=P.startColumn||y.lineNumber===P.endLineNumber&&y.column>=P.endColumn)}containsRange(P){return t.containsRange(this,P)}static containsRange(P,y){return!(y.startLineNumber<P.startLineNumber||y.endLineNumber<P.startLineNumber||y.startLineNumber>P.endLineNumber||y.endLineNumber>P.endLineNumber||y.startLineNumber===P.startLineNumber&&y.startColumn<P.startColumn||y.endLineNumber===P.endLineNumber&&y.endColumn>P.endColumn)}strictContainsRange(P){return t.strictContainsRange(this,P)}static strictContainsRange(P,y){return!(y.startLineNumber<P.startLineNumber||y.endLineNumber<P.startLineNumber||y.startLineNumber>P.endLineNumber||y.endLineNumber>P.endLineNumber||y.startLineNumber===P.startLineNumber&&y.startColumn<=P.startColumn||y.endLineNumber===P.endLineNumber&&y.endColumn>=P.endColumn)}plusRange(P){return t.plusRange(this,P)}static plusRange(P,y){let C,E,I,R;return y.startLineNumber<P.startLineNumber?(C=y.startLineNumber,E=y.startColumn):y.startLineNumber===P.startLineNumber?(C=y.startLineNumber,E=Math.min(y.startColumn,P.startColumn)):(C=P.startLineNumber,E=P.startColumn),y.endLineNumber>P.endLineNumber?(I=y.endLineNumber,R=y.endColumn):y.endLineNumber===P.endLineNumber?(I=y.endLineNumber,R=Math.max(y.endColumn,P.endColumn)):(I=P.endLineNumber,R=P.endColumn),new t(C,E,I,R)}intersectRanges(P){return t.intersectRanges(this,P)}static intersectRanges(P,y){let C=P.startLineNumber,E=P.startColumn,I=P.endLineNumber,R=P.endColumn;const k=y.startLineNumber,_=y.startColumn,T=y.endLineNumber,w=y.endColumn;return C<k?(C=k,E=_):C===k&&(E=Math.max(E,_)),I>T?(I=T,R=w):I===T&&(R=Math.min(R,w)),C>I||C===I&&E>R?null:new t(C,E,I,R)}equalsRange(P){return t.equalsRange(this,P)}static equalsRange(P,y){return!!P&&!!y&&P.startLineNumber===y.startLineNumber&&P.startColumn===y.startColumn&&P.endLineNumber===y.endLineNumber&&P.endColumn===y.endColumn}getEndPosition(){return t.getEndPosition(this)}static getEndPosition(P){return new u.Position(P.endLineNumber,P.endColumn)}getStartPosition(){return t.getStartPosition(this)}static getStartPosition(P){return new u.Position(P.startLineNumber,P.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(P,y){return new t(this.startLineNumber,this.startColumn,P,y)}setStartPosition(P,y){return new t(P,y,this.endLineNumber,this.endColumn)}collapseToStart(){return t.collapseToStart(this)}delta(P){return new t(this.startLineNumber+P,this.startColumn,this.endLineNumber+P,this.endColumn)}static collapseToStart(P){return new t(P.startLineNumber,P.startColumn,P.startLineNumber,P.startColumn)}static fromPositions(P,y=P){return new t(P.lineNumber,P.column,y.lineNumber,y.column)}static lift(P){return P?new t(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn):null}static isIRange(P){return P&&typeof P.startLineNumber=="number"&&typeof P.startColumn=="number"&&typeof P.endLineNumber=="number"&&typeof P.endColumn=="number"}static areIntersectingOrTouching(P,y){return!(P.endLineNumber<y.startLineNumber||P.endLineNumber===y.startLineNumber&&P.endColumn<y.startColumn||y.endLineNumber<P.startLineNumber||y.endLineNumber===P.startLineNumber&&y.endColumn<P.startColumn)}static areIntersecting(P,y){return!(P.endLineNumber<y.startLineNumber||P.endLineNumber===y.startLineNumber&&P.endColumn<=y.startColumn||y.endLineNumber<P.startLineNumber||y.endLineNumber===P.startLineNumber&&y.endColumn<=P.startColumn)}static compareRangesUsingStarts(P,y){if(P&&y){const I=P.startLineNumber|0,R=y.startLineNumber|0;if(I===R){const k=P.startColumn|0,_=y.startColumn|0;if(k===_){const T=P.endLineNumber|0,w=y.endLineNumber|0;if(T===w){const b=P.endColumn|0,v=y.endColumn|0;return b-v}return T-w}return k-_}return I-R}return(P?1:0)-(y?1:0)}static compareRangesUsingEnds(P,y){return P.endLineNumber===y.endLineNumber?P.endColumn===y.endColumn?P.startLineNumber===y.startLineNumber?P.startColumn-y.startColumn:P.startLineNumber-y.startLineNumber:P.endColumn-y.endColumn:P.endLineNumber-y.endLineNumber}static spansMultipleLines(P){return P.endLineNumber>P.startLineNumber}toJSON(){return this}}e.Range=t}),define(De[144],Ie([1,0,49,35]),function(Z,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var D;(function(y){y[y.LTR=0]="LTR",y[y.RTL=1]="RTL"})(D=e.SelectionDirection||(e.SelectionDirection={}));class P extends t.Range{constructor(C,E,I,R){super(C,E,I,R);this.selectionStartLineNumber=C,this.selectionStartColumn=E,this.positionLineNumber=I,this.positionColumn=R}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(C){return P.selectionsEqual(this,C)}static selectionsEqual(C,E){return C.selectionStartLineNumber===E.selectionStartLineNumber&&C.selectionStartColumn===E.selectionStartColumn&&C.positionLineNumber===E.positionLineNumber&&C.positionColumn===E.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(C,E){return this.getDirection()===0?new P(this.startLineNumber,this.startColumn,C,E):new P(C,E,this.startLineNumber,this.startColumn)}getPosition(){return new u.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new u.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(C,E){return this.getDirection()===0?new P(C,E,this.endLineNumber,this.endColumn):new P(this.endLineNumber,this.endColumn,C,E)}static fromPositions(C,E=C){return new P(C.lineNumber,C.column,E.lineNumber,E.column)}static fromRange(C,E){return E===0?new P(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn):new P(C.endLineNumber,C.endColumn,C.startLineNumber,C.startColumn)}static liftSelection(C){return new P(C.selectionStartLineNumber,C.selectionStartColumn,C.positionLineNumber,C.positionColumn)}static selectionsArrEqual(C,E){if(C&&!E||!C&&E)return!1;if(!C&&!E)return!0;if(C.length!==E.length)return!1;for(let I=0,R=C.length;I<R;I++)if(!this.selectionsEqual(C[I],E[I]))return!1;return!0}static isISelection(C){return C&&typeof C.selectionStartLineNumber=="number"&&typeof C.selectionStartColumn=="number"&&typeof C.positionLineNumber=="number"&&typeof C.positionColumn=="number"}static createWithDirection(C,E,I,R,k){return k===0?new P(C,E,I,R):new P(I,R,C,E)}}e.Selection=P}),define(De[145],Ie([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(De[146],Ie([1,0,97]),function(Z,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var t;(function(y){y[y.Regular=0]="Regular",y[y.Whitespace=1]="Whitespace",y[y.WordSeparator=2]="WordSeparator"})(t=e.WordCharacterClass||(e.WordCharacterClass={}));class D extends u.CharacterClassifier{constructor(C){super(0);for(let E=0,I=C.length;E<I;E++)this.set(C.charCodeAt(E),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=D;function P(y){const C={};return E=>(C.hasOwnProperty(E)||(C[E]=y(E)),C[E])}e.getMapForWordSeparators=P(y=>new D(y))}),define(De[98],Ie([1,0,59,6,79]),function(Z,e,u,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.setDefaultGetWordAtTextConfig=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function P(k=""){let _="(-?\\d*\\.\\d\\w*)|([^";for(const T of e.USUAL_WORD_SEPARATORS)k.indexOf(T)>=0||(_+="\\"+T);return _+="\\s]+)",new RegExp(_,"g")}e.DEFAULT_WORD_REGEXP=P();function y(k){let _=e.DEFAULT_WORD_REGEXP;if(k&&k instanceof RegExp)if(k.global)_=k;else{let T="g";k.ignoreCase&&(T+="i"),k.multiline&&(T+="m"),k.unicode&&(T+="u"),_=new RegExp(k.source,T)}return _.lastIndex=0,_}e.ensureValidWordDefinition=y;const C=new D.LinkedList;C.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function E(k){const _=C.unshift(k);return(0,t.toDisposable)(_)}e.setDefaultGetWordAtTextConfig=E;function I(k,_,T,w,b){if(b||(b=u.Iterable.first(C)),T.length>b.maxLen){let o=k-b.maxLen/2;return o<0?o=0:w+=o,T=T.substring(o,k+b.maxLen/2),I(k,_,T,w,b)}const v=Date.now(),h=k-1-w;let g=-1,p=null;for(let o=1;!(Date.now()-v>=b.timeBudget);o++){const m=h-b.windowSize*o;_.lastIndex=Math.max(0,m);const c=R(_,T,h,g);if(!c&&p||(p=c,m<=0))break;g=m}if(p){const o={word:p[0],startColumn:w+1+p.index,endColumn:w+1+p.index+p[0].length};return _.lastIndex=0,o}return null}e.getWordAtText=I;function R(k,_,T,w){let b;for(;b=k.exec(_);){const v=b.index||0;if(v<=T&&k.lastIndex>=T)return b;if(w>0&&v>w)return null}return null}}),define(De[147],Ie([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var u;(function(y){y[y.None=0]="None",y[y.Indent=1]="Indent",y[y.IndentOutdent=2]="IndentOutdent",y[y.Outdent=3]="Outdent"})(u=e.IndentAction||(e.IndentAction={}));class t{constructor(C){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=C.open,this.close=C.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(C.notIn))for(let E=0,I=C.notIn.length;E<I;E++)switch(C.notIn[E]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(C){switch(C){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(C,E){if(C.getTokenCount()===0)return!0;const I=C.findTokenIndexAtOffset(E-2),R=C.getStandardTokenType(I);return this.isOK(R)}_findNeutralCharacterInRange(C,E){for(let I=C;I<=E;I++){const R=String.fromCharCode(I);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=t;class D{constructor(C){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const E of C)P(this.autoClosingPairsOpenByStart,E.open.charAt(0),E),P(this.autoClosingPairsOpenByEnd,E.open.charAt(E.open.length-1),E),P(this.autoClosingPairsCloseByStart,E.close.charAt(0),E),P(this.autoClosingPairsCloseByEnd,E.close.charAt(E.close.length-1),E),E.close.length===1&&E.open.length===1&&P(this.autoClosingPairsCloseSingleChar,E.close,E)}}e.AutoClosingPairs=D;function P(y,C,E){y.has(C)?y.get(C).push(E):y.set(C,[E])}}),define(De[148],Ie([1,0,97]),function(Z,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var t;(function(T){T[T.Invalid=0]="Invalid",T[T.Start=1]="Start",T[T.H=2]="H",T[T.HT=3]="HT",T[T.HTT=4]="HTT",T[T.HTTP=5]="HTTP",T[T.F=6]="F",T[T.FI=7]="FI",T[T.FIL=8]="FIL",T[T.BeforeColon=9]="BeforeColon",T[T.AfterColon=10]="AfterColon",T[T.AlmostThere=11]="AlmostThere",T[T.End=12]="End",T[T.Accept=13]="Accept",T[T.LastKnownState=14]="LastKnownState"})(t=e.State||(e.State={}));class D{constructor(w,b,v){const h=new Uint8Array(w*b);for(let g=0,p=w*b;g<p;g++)h[g]=v;this._data=h,this.rows=w,this.cols=b}get(w,b){return this._data[w*this.cols+b]}set(w,b,v){this._data[w*this.cols+b]=v}}e.Uint8Matrix=D;class P{constructor(w){let b=0,v=0;for(let g=0,p=w.length;g<p;g++){const[o,m,c]=w[g];m>b&&(b=m),o>v&&(v=o),c>v&&(v=c)}b++,v++;const h=new D(v,b,0);for(let g=0,p=w.length;g<p;g++){const[o,m,c]=w[g];h.set(o,m,c)}this._states=h,this._maxCharCode=b}nextState(w,b){return b<0||b>=this._maxCharCode?0:this._states.get(w,b)}}e.StateMachine=P;let y=null;function C(){return y===null&&(y=new P([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),y}var E;(function(T){T[T.None=0]="None",T[T.ForceTermination=1]="ForceTermination",T[T.CannotEndIn=2]="CannotEndIn"})(E||(E={}));let I=null;function R(){if(I===null){I=new u.CharacterClassifier(0);const T=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let b=0;b<T.length;b++)I.set(T.charCodeAt(b),1);const w=".,;:";for(let b=0;b<w.length;b++)I.set(w.charCodeAt(b),2)}return I}class k{static _createLink(w,b,v,h,g){let p=g-1;do{const o=b.charCodeAt(p);if(w.get(o)!==2)break;p--}while(p>h);if(h>0){const o=b.charCodeAt(h-1),m=b.charCodeAt(p);(o===40&&m===41||o===91&&m===93||o===123&&m===125)&&p--}return{range:{startLineNumber:v,startColumn:h+1,endLineNumber:v,endColumn:p+2},url:b.substring(h,p+1)}}static computeLinks(w,b=C()){const v=R(),h=[];for(let g=1,p=w.getLineCount();g<=p;g++){const o=w.getLineContent(g),m=o.length;let c=0,l=0,s=0,i=1,r=!1,n=!1,a=!1,d=!1;for(;c<m;){let f=!1;const S=o.charCodeAt(c);if(i===13){let O;switch(S){case 40:r=!0,O=0;break;case 41:O=r?0:1;break;case 91:a=!0,n=!0,O=0;break;case 93:a=!1,O=n?0:1;break;case 123:d=!0,O=0;break;case 125:O=d?0:1;break;case 39:O=s===39?1:0;break;case 34:O=s===34?1:0;break;case 96:O=s===96?1:0;break;case 42:O=s===42?1:0;break;case 124:O=s===124?1:0;break;case 32:O=a?0:1;break;default:O=v.get(S)}O===1&&(h.push(k._createLink(v,o,g,l,c)),f=!0)}else if(i===12){let O;S===91?(n=!0,O=0):O=v.get(S),O===1?f=!0:i=13}else i=b.nextState(i,S),i===0&&(f=!0);f&&(i=1,r=!1,n=!1,d=!1,l=c+1,s=S),c++}i===13&&h.push(k._createLink(v,o,g,l,m))}return h}}e.LinkComputer=k;function _(T){return!T||typeof T.getLineCount!="function"||typeof T.getLineContent!="function"?[]:k.computeLinks(T)}e.computeLinks=_}),define(De[99],Ie([1,0,24]),function(Z,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.isITextSnapshot=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.OverviewRulerLane=void 0;var t;(function(p){p[p.Left=1]="Left",p[p.Center=2]="Center",p[p.Right=4]="Right",p[p.Full=7]="Full"})(t=e.OverviewRulerLane||(e.OverviewRulerLane={}));var D;(function(p){p[p.Inline=1]="Inline",p[p.Gutter=2]="Gutter"})(D=e.MinimapPosition||(e.MinimapPosition={}));var P;(function(p){p[p.Both=0]="Both",p[p.Right=1]="Right",p[p.Left=2]="Left",p[p.None=3]="None"})(P=e.InjectedTextCursorStops||(e.InjectedTextCursorStops={}));var y;(function(p){p[p.TextDefined=0]="TextDefined",p[p.LF=1]="LF",p[p.CRLF=2]="CRLF"})(y=e.EndOfLinePreference||(e.EndOfLinePreference={}));var C;(function(p){p[p.LF=1]="LF",p[p.CRLF=2]="CRLF"})(C=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var E;(function(p){p[p.LF=0]="LF",p[p.CRLF=1]="CRLF"})(E=e.EndOfLineSequence||(e.EndOfLineSequence={}));class I{constructor(o){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,o.tabSize|0),this.indentSize=o.tabSize|0,this.insertSpaces=Boolean(o.insertSpaces),this.defaultEOL=o.defaultEOL|0,this.trimAutoWhitespace=Boolean(o.trimAutoWhitespace),this.bracketPairColorizationOptions=o.bracketPairColorizationOptions}equals(o){return this.tabSize===o.tabSize&&this.indentSize===o.indentSize&&this.insertSpaces===o.insertSpaces&&this.defaultEOL===o.defaultEOL&&this.trimAutoWhitespace===o.trimAutoWhitespace&&(0,u.equals)(this.bracketPairColorizationOptions,o.bracketPairColorizationOptions)}createChangeEvent(o){return{tabSize:this.tabSize!==o.tabSize,indentSize:this.indentSize!==o.indentSize,insertSpaces:this.insertSpaces!==o.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==o.trimAutoWhitespace}}}e.TextModelResolvedOptions=I;class R{constructor(o,m){this._findMatchBrand=void 0,this.range=o,this.matches=m}}e.FindMatch=R;var k;(function(p){p[p.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",p[p.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",p[p.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",p[p.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(k=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));function _(p){return p&&typeof p.read=="function"}e.isITextSnapshot=_;var T;(function(p){p[p.Left=0]="Left",p[p.Right=1]="Right",p[p.None=2]="None",p[p.LeftOfInjectedText=3]="LeftOfInjectedText",p[p.RightOfInjectedText=4]="RightOfInjectedText"})(T=e.PositionAffinity||(e.PositionAffinity={}));var w;(function(p){p[p.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(w=e.ModelConstants||(e.ModelConstants={}));class b{constructor(o,m,c,l,s,i){this.identifier=o,this.range=m,this.text=c,this.forceMoveMarkers=l,this.isAutoWhitespaceEdit=s,this._isTracked=i}}e.ValidAnnotatedEditOperation=b;class v{constructor(o,m,c){this.regex=o,this.wordSeparators=m,this.simpleSearch=c}}e.SearchData=v;class h{constructor(o,m,c){this.reverseEdits=o,this.changes=m,this.trimAutoWhitespaceLineNumbers=c}}e.ApplyEditsResult=h;function g(p){return!p.isTooLargeForSyncing()&&!p.isForSimpleWidget}e.shouldSynchronizeModel=g}),define(De[149],Ie([1,0,17,96]),function(Z,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class D{constructor(E){this.values=E,this.prefixSum=new Uint32Array(E.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(E,I){E=(0,t.toUint32)(E);const R=this.values,k=this.prefixSum,_=I.length;return _===0?!1:(this.values=new Uint32Array(R.length+_),this.values.set(R.subarray(0,E),0),this.values.set(R.subarray(E),E+_),this.values.set(I,E),E-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=E-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(E,I){return E=(0,t.toUint32)(E),I=(0,t.toUint32)(I),this.values[E]===I?!1:(this.values[E]=I,E-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=E-1),!0)}removeValues(E,I){E=(0,t.toUint32)(E),I=(0,t.toUint32)(I);const R=this.values,k=this.prefixSum;if(E>=R.length)return!1;const _=R.length-E;return I>=_&&(I=_),I===0?!1:(this.values=new Uint32Array(R.length-I),this.values.set(R.subarray(0,E),0),this.values.set(R.subarray(E+I),E),this.prefixSum=new Uint32Array(this.values.length),E-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=E-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(E){return E<0?0:(E=(0,t.toUint32)(E),this._getPrefixSum(E))}_getPrefixSum(E){if(E<=this.prefixSumValidIndex[0])return this.prefixSum[E];let I=this.prefixSumValidIndex[0]+1;I===0&&(this.prefixSum[0]=this.values[0],I++),E>=this.values.length&&(E=this.values.length-1);for(let R=I;R<=E;R++)this.prefixSum[R]=this.prefixSum[R-1]+this.values[R];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],E),this.prefixSum[E]}getIndexOf(E){E=Math.floor(E),this.getTotalSum();let I=0,R=this.values.length-1,k=0,_=0,T=0;for(;I<=R;)if(k=I+(R-I)/2|0,_=this.prefixSum[k],T=_-this.values[k],E<T)R=k-1;else if(E>=_)I=k+1;else break;return new y(k,E-T)}}e.PrefixSumComputer=D;class P{constructor(E){this._values=E,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(E){return this._ensureValid(),E===0?0:this._prefixSum[E-1]}getIndexOf(E){this._ensureValid();const I=this._indexBySum[E],R=I>0?this._prefixSum[I-1]:0;return new y(I,E-R)}removeValues(E,I){this._values.splice(E,I),this._invalidate(E)}insertValues(E,I){this._values=(0,u.arrayInsert)(this._values,E,I),this._invalidate(E)}_invalidate(E){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,E-1)}_ensureValid(){if(!this._isValid){for(let E=this._validEndIndex+1,I=this._values.length;E<I;E++){const R=this._values[E],k=E>0?this._prefixSum[E-1]:0;this._prefixSum[E]=k+R;for(let _=0;_<R;_++)this._indexBySum[k+_]=E}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(E,I){this._values[E]!==I&&(this._values[E]=I,this._invalidate(E))}}e.ConstantTimePrefixSumComputer=P;class y{constructor(E,I){this.index=E,this.remainder=I,this._prefixSumIndexOfResultBrand=void 0,this.index=E,this.remainder=I}}e.PrefixSumIndexOfResult=y}),define(De[150],Ie([19,20]),function(Z,e){return Z.create("vs/base/common/date",e)}),define(De[151],Ie([1,0,150]),function(Z,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,D=t*60,P=D*24,y=P*7,C=P*30,E=P*365;function I(k,_,T){typeof k!="number"&&(k=k.getTime());const w=Math.round((new Date().getTime()-k)/1e3);if(w<-30)return(0,u.localize)(0,null,I(new Date().getTime()+w*1e3,!1));if(w<30)return(0,u.localize)(1,null);let b;return w<t?(b=w,_?b===1?T?(0,u.localize)(2,null,b):(0,u.localize)(3,null,b):T?(0,u.localize)(4,null,b):(0,u.localize)(5,null,b):b===1?T?(0,u.localize)(6,null,b):(0,u.localize)(7,null,b):T?(0,u.localize)(8,null,b):(0,u.localize)(9,null,b)):w<D?(b=Math.floor(w/t),_?b===1?T?(0,u.localize)(10,null,b):(0,u.localize)(11,null,b):T?(0,u.localize)(12,null,b):(0,u.localize)(13,null,b):b===1?T?(0,u.localize)(14,null,b):(0,u.localize)(15,null,b):T?(0,u.localize)(16,null,b):(0,u.localize)(17,null,b)):w<P?(b=Math.floor(w/D),_?b===1?T?(0,u.localize)(18,null,b):(0,u.localize)(19,null,b):T?(0,u.localize)(20,null,b):(0,u.localize)(21,null,b):b===1?T?(0,u.localize)(22,null,b):(0,u.localize)(23,null,b):T?(0,u.localize)(24,null,b):(0,u.localize)(25,null,b)):w<y?(b=Math.floor(w/P),_?b===1?(0,u.localize)(26,null,b):(0,u.localize)(27,null,b):b===1?(0,u.localize)(28,null,b):(0,u.localize)(29,null,b)):w<C?(b=Math.floor(w/y),_?b===1?T?(0,u.localize)(30,null,b):(0,u.localize)(31,null,b):T?(0,u.localize)(32,null,b):(0,u.localize)(33,null,b):b===1?T?(0,u.localize)(34,null,b):(0,u.localize)(35,null,b):T?(0,u.localize)(36,null,b):(0,u.localize)(37,null,b)):w<E?(b=Math.floor(w/C),_?b===1?T?(0,u.localize)(38,null,b):(0,u.localize)(39,null,b):T?(0,u.localize)(40,null,b):(0,u.localize)(41,null,b):b===1?T?(0,u.localize)(42,null,b):(0,u.localize)(43,null,b):T?(0,u.localize)(44,null,b):(0,u.localize)(45,null,b)):(b=Math.floor(w/E),_?b===1?T?(0,u.localize)(46,null,b):(0,u.localize)(47,null,b):T?(0,u.localize)(48,null,b):(0,u.localize)(49,null,b):b===1?T?(0,u.localize)(50,null,b):(0,u.localize)(51,null,b):T?(0,u.localize)(52,null,b):(0,u.localize)(53,null,b))}e.fromNow=I;function R(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=R}),define(De[152],Ie([19,20]),function(Z,e){return Z.create("vs/base/common/errorMessage",e)}),define(De[50],Ie([1,0,17,13,152]),function(Z,e,u,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function P(k,_){return _&&(k.stack||k.stacktrace)?D.localize(0,null,C(k),y(k.stack)||y(k.stacktrace)):C(k)}function y(k){return Array.isArray(k)?k.join(`
`):k}function C(k){return typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?D.localize(1,null,k.message):k.message||D.localize(2,null)}function E(k=null,_=!1){if(!k)return D.localize(3,null);if(Array.isArray(k)){const T=u.coalesce(k),w=E(T[0],_);return T.length>1?D.localize(4,null,w,T.length):w}if(t.isString(k))return k;if(k.detail){const T=k.detail;if(T.error)return P(T.error,_);if(T.exception)return P(T.exception,_)}return k.stack?P(k,_):k.message?k.message:D.localize(5,null)}e.toErrorMessage=E;function I(k){const _=k;return _ instanceof Error&&Array.isArray(_.actions)}e.isErrorWithActions=I;function R(k,_){let T;return typeof k=="string"?T=new Error(k):T=k,T.actions=_,T}e.createErrorWithActions=R}),define(De[153],Ie([19,20]),function(Z,e){return Z.create("vs/base/common/platform",e)}),define(De[11],Ie([1,0,153]),function(Z,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=void 0;const t="en";let D=!1,P=!1,y=!1,C=!1,E=!1,I=!1,R=!1,k=!1,_=!1,T,w=t,b,v;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?h=e.globals.vscode.process:typeof process!="undefined"&&(h=process);const g=typeof h?.versions?.electron=="string",p=g&&h?.type==="renderer";if(typeof navigator=="object"&&!p)v=navigator.userAgent,D=v.indexOf("Windows")>=0,P=v.indexOf("Macintosh")>=0,k=(v.indexOf("Macintosh")>=0||v.indexOf("iPad")>=0||v.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,y=v.indexOf("Linux")>=0,I=!0,T=u.getConfiguredDefaultLocale(u.localize(0,null))||t,w=T;else if(typeof h=="object"){D=h.platform==="win32",P=h.platform==="darwin",y=h.platform==="linux",C=y&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,R=g,_=!!h.env.CI||!!h.env.BUILD_ARTIFACTSTAGINGDIRECTORY,T=t,w=t;const a=h.env.VSCODE_NLS_CONFIG;if(a)try{const d=JSON.parse(a),f=d.availableLanguages["*"];T=d.locale,w=f||t,b=d._translationsConfigFile}catch{}E=!0}else console.error("Unable to resolve platform.");var o;(function(a){a[a.Web=0]="Web",a[a.Mac=1]="Mac",a[a.Linux=2]="Linux",a[a.Windows=3]="Windows"})(o=e.Platform||(e.Platform={}));function m(a){switch(a){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=m;let c=0;P?c=1:D?c=3:y&&(c=2),e.isWindows=D,e.isMacintosh=P,e.isLinux=y,e.isLinuxSnap=C,e.isNative=E,e.isElectron=R,e.isWeb=I,e.isWebWorker=I&&typeof e.globals.importScripts=="function",e.isIOS=k,e.isCI=_,e.platform=c,e.userAgent=v,e.language=w;var l;(function(a){function d(){return e.language}a.value=d;function f(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}a.isDefaultVariant=f;function S(){return e.language==="en"}a.isDefault=S})(l=e.Language||(e.Language={})),e.locale=T,e.translationsConfigFile=b,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const a=[];e.globals.addEventListener("message",f=>{if(f.data&&f.data.vscodeScheduleAsyncWork)for(let S=0,O=a.length;S<O;S++){const U=a[S];if(U.id===f.data.vscodeScheduleAsyncWork){a.splice(S,1),U.callback();return}}});let d=0;return f=>{const S=++d;a.push({id:S,callback:f}),e.globals.postMessage({vscodeScheduleAsyncWork:S},"*")}}return a=>setTimeout(a)})();var s;(function(a){a[a.Windows=1]="Windows",a[a.Macintosh=2]="Macintosh",a[a.Linux=3]="Linux"})(s=e.OperatingSystem||(e.OperatingSystem={})),e.OS=P||k?2:D?1:3;let i=!0,r=!1;function n(){if(!r){r=!0;const a=new Uint8Array(2);a[0]=1,a[1]=2,i=new Uint16Array(a.buffer)[0]===(2<<8)+1}return i}e.isLittleEndian=n,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(De[40],Ie([1,0,11]),function(Z,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof u.globals.vscode!="undefined"&&typeof u.globals.vscode.process!="undefined"){const D=u.globals.vscode.process;t={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()}}}else typeof process!="undefined"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return u.isWindows?"win32":u.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(De[9],Ie([1,0,40]),function(Z,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,D=97,P=90,y=122,C=46,E=47,I=92,R=58,k=63;class _ extends Error{constructor(o,m,c){let l;typeof m=="string"&&m.indexOf("not ")===0?(l="must not be",m=m.replace(/^not /,"")):l="must be";const s=o.indexOf(".")!==-1?"property":"argument";let i=`The "${o}" ${s} ${l} of type ${m}`;i+=`. Received type ${typeof c}`;super(i);this.code="ERR_INVALID_ARG_TYPE"}}function T(p,o){if(typeof p!="string")throw new _(o,"string",p)}function w(p){return p===E||p===I}function b(p){return p===E}function v(p){return p>=t&&p<=P||p>=D&&p<=y}function h(p,o,m,c){let l="",s=0,i=-1,r=0,n=0;for(let a=0;a<=p.length;++a){if(a<p.length)n=p.charCodeAt(a);else{if(c(n))break;n=E}if(c(n)){if(!(i===a-1||r===1))if(r===2){if(l.length<2||s!==2||l.charCodeAt(l.length-1)!==C||l.charCodeAt(l.length-2)!==C){if(l.length>2){const d=l.lastIndexOf(m);d===-1?(l="",s=0):(l=l.slice(0,d),s=l.length-1-l.lastIndexOf(m)),i=a,r=0;continue}else if(l.length!==0){l="",s=0,i=a,r=0;continue}}o&&(l+=l.length>0?`${m}..`:"..",s=2)}else l.length>0?l+=`${m}${p.slice(i+1,a)}`:l=p.slice(i+1,a),s=a-i-1;i=a,r=0}else n===C&&r!==-1?++r:r=-1}return l}function g(p,o){if(o===null||typeof o!="object")throw new _("pathObject","Object",o);const m=o.dir||o.root,c=o.base||`${o.name||""}${o.ext||""}`;return m?m===o.root?`${m}${c}`:`${m}${p}${c}`:c}e.win32={resolve(...p){let o="",m="",c=!1;for(let l=p.length-1;l>=-1;l--){let s;if(l>=0){if(s=p[l],T(s,"path"),s.length===0)continue}else o.length===0?s=u.cwd():(s=u.env[`=${o}`]||u.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==o.toLowerCase()&&s.charCodeAt(2)===I)&&(s=`${o}\\`));const i=s.length;let r=0,n="",a=!1;const d=s.charCodeAt(0);if(i===1)w(d)&&(r=1,a=!0);else if(w(d))if(a=!0,w(s.charCodeAt(1))){let f=2,S=f;for(;f<i&&!w(s.charCodeAt(f));)f++;if(f<i&&f!==S){const O=s.slice(S,f);for(S=f;f<i&&w(s.charCodeAt(f));)f++;if(f<i&&f!==S){for(S=f;f<i&&!w(s.charCodeAt(f));)f++;(f===i||f!==S)&&(n=`\\\\${O}\\${s.slice(S,f)}`,r=f)}}}else r=1;else v(d)&&s.charCodeAt(1)===R&&(n=s.slice(0,2),r=2,i>2&&w(s.charCodeAt(2))&&(a=!0,r=3));if(n.length>0)if(o.length>0){if(n.toLowerCase()!==o.toLowerCase())continue}else o=n;if(c){if(o.length>0)break}else if(m=`${s.slice(r)}\\${m}`,c=a,a&&o.length>0)break}return m=h(m,!c,"\\",w),c?`${o}\\${m}`:`${o}${m}`||"."},normalize(p){T(p,"path");const o=p.length;if(o===0)return".";let m=0,c,l=!1;const s=p.charCodeAt(0);if(o===1)return b(s)?"\\":p;if(w(s))if(l=!0,w(p.charCodeAt(1))){let r=2,n=r;for(;r<o&&!w(p.charCodeAt(r));)r++;if(r<o&&r!==n){const a=p.slice(n,r);for(n=r;r<o&&w(p.charCodeAt(r));)r++;if(r<o&&r!==n){for(n=r;r<o&&!w(p.charCodeAt(r));)r++;if(r===o)return`\\\\${a}\\${p.slice(n)}\\`;r!==n&&(c=`\\\\${a}\\${p.slice(n,r)}`,m=r)}}}else m=1;else v(s)&&p.charCodeAt(1)===R&&(c=p.slice(0,2),m=2,o>2&&w(p.charCodeAt(2))&&(l=!0,m=3));let i=m<o?h(p.slice(m),!l,"\\",w):"";return i.length===0&&!l&&(i="."),i.length>0&&w(p.charCodeAt(o-1))&&(i+="\\"),c===void 0?l?`\\${i}`:i:l?`${c}\\${i}`:`${c}${i}`},isAbsolute(p){T(p,"path");const o=p.length;if(o===0)return!1;const m=p.charCodeAt(0);return w(m)||o>2&&v(m)&&p.charCodeAt(1)===R&&w(p.charCodeAt(2))},join(...p){if(p.length===0)return".";let o,m;for(let s=0;s<p.length;++s){const i=p[s];T(i,"path"),i.length>0&&(o===void 0?o=m=i:o+=`\\${i}`)}if(o===void 0)return".";let c=!0,l=0;if(typeof m=="string"&&w(m.charCodeAt(0))){++l;const s=m.length;s>1&&w(m.charCodeAt(1))&&(++l,s>2&&(w(m.charCodeAt(2))?++l:c=!1))}if(c){for(;l<o.length&&w(o.charCodeAt(l));)l++;l>=2&&(o=`\\${o.slice(l)}`)}return e.win32.normalize(o)},relative(p,o){if(T(p,"from"),T(o,"to"),p===o)return"";const m=e.win32.resolve(p),c=e.win32.resolve(o);if(m===c||(p=m.toLowerCase(),o=c.toLowerCase(),p===o))return"";let l=0;for(;l<p.length&&p.charCodeAt(l)===I;)l++;let s=p.length;for(;s-1>l&&p.charCodeAt(s-1)===I;)s--;const i=s-l;let r=0;for(;r<o.length&&o.charCodeAt(r)===I;)r++;let n=o.length;for(;n-1>r&&o.charCodeAt(n-1)===I;)n--;const a=n-r,d=i<a?i:a;let f=-1,S=0;for(;S<d;S++){const U=p.charCodeAt(l+S);if(U!==o.charCodeAt(r+S))break;U===I&&(f=S)}if(S!==d){if(f===-1)return c}else{if(a>d){if(o.charCodeAt(r+S)===I)return c.slice(r+S+1);if(S===2)return c.slice(r+S)}i>d&&(p.charCodeAt(l+S)===I?f=S:S===2&&(f=3)),f===-1&&(f=0)}let O="";for(S=l+f+1;S<=s;++S)(S===s||p.charCodeAt(S)===I)&&(O+=O.length===0?"..":"\\..");return r+=f,O.length>0?`${O}${c.slice(r,n)}`:(c.charCodeAt(r)===I&&++r,c.slice(r,n))},toNamespacedPath(p){if(typeof p!="string")return p;if(p.length===0)return"";const o=e.win32.resolve(p);if(o.length<=2)return p;if(o.charCodeAt(0)===I){if(o.charCodeAt(1)===I){const m=o.charCodeAt(2);if(m!==k&&m!==C)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(v(o.charCodeAt(0))&&o.charCodeAt(1)===R&&o.charCodeAt(2)===I)return`\\\\?\\${o}`;return p},dirname(p){T(p,"path");const o=p.length;if(o===0)return".";let m=-1,c=0;const l=p.charCodeAt(0);if(o===1)return w(l)?p:".";if(w(l)){if(m=c=1,w(p.charCodeAt(1))){let r=2,n=r;for(;r<o&&!w(p.charCodeAt(r));)r++;if(r<o&&r!==n){for(n=r;r<o&&w(p.charCodeAt(r));)r++;if(r<o&&r!==n){for(n=r;r<o&&!w(p.charCodeAt(r));)r++;if(r===o)return p;r!==n&&(m=c=r+1)}}}}else v(l)&&p.charCodeAt(1)===R&&(m=o>2&&w(p.charCodeAt(2))?3:2,c=m);let s=-1,i=!0;for(let r=o-1;r>=c;--r)if(w(p.charCodeAt(r))){if(!i){s=r;break}}else i=!1;if(s===-1){if(m===-1)return".";s=m}return p.slice(0,s)},basename(p,o){o!==void 0&&T(o,"ext"),T(p,"path");let m=0,c=-1,l=!0,s;if(p.length>=2&&v(p.charCodeAt(0))&&p.charCodeAt(1)===R&&(m=2),o!==void 0&&o.length>0&&o.length<=p.length){if(o===p)return"";let i=o.length-1,r=-1;for(s=p.length-1;s>=m;--s){const n=p.charCodeAt(s);if(w(n)){if(!l){m=s+1;break}}else r===-1&&(l=!1,r=s+1),i>=0&&(n===o.charCodeAt(i)?--i==-1&&(c=s):(i=-1,c=r))}return m===c?c=r:c===-1&&(c=p.length),p.slice(m,c)}for(s=p.length-1;s>=m;--s)if(w(p.charCodeAt(s))){if(!l){m=s+1;break}}else c===-1&&(l=!1,c=s+1);return c===-1?"":p.slice(m,c)},extname(p){T(p,"path");let o=0,m=-1,c=0,l=-1,s=!0,i=0;p.length>=2&&p.charCodeAt(1)===R&&v(p.charCodeAt(0))&&(o=c=2);for(let r=p.length-1;r>=o;--r){const n=p.charCodeAt(r);if(w(n)){if(!s){c=r+1;break}continue}l===-1&&(s=!1,l=r+1),n===C?m===-1?m=r:i!==1&&(i=1):m!==-1&&(i=-1)}return m===-1||l===-1||i===0||i===1&&m===l-1&&m===c+1?"":p.slice(m,l)},format:g.bind(null,"\\"),parse(p){T(p,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(p.length===0)return o;const m=p.length;let c=0,l=p.charCodeAt(0);if(m===1)return w(l)?(o.root=o.dir=p,o):(o.base=o.name=p,o);if(w(l)){if(c=1,w(p.charCodeAt(1))){let f=2,S=f;for(;f<m&&!w(p.charCodeAt(f));)f++;if(f<m&&f!==S){for(S=f;f<m&&w(p.charCodeAt(f));)f++;if(f<m&&f!==S){for(S=f;f<m&&!w(p.charCodeAt(f));)f++;f===m?c=f:f!==S&&(c=f+1)}}}}else if(v(l)&&p.charCodeAt(1)===R){if(m<=2)return o.root=o.dir=p,o;if(c=2,w(p.charCodeAt(2))){if(m===3)return o.root=o.dir=p,o;c=3}}c>0&&(o.root=p.slice(0,c));let s=-1,i=c,r=-1,n=!0,a=p.length-1,d=0;for(;a>=c;--a){if(l=p.charCodeAt(a),w(l)){if(!n){i=a+1;break}continue}r===-1&&(n=!1,r=a+1),l===C?s===-1?s=a:d!==1&&(d=1):s!==-1&&(d=-1)}return r!==-1&&(s===-1||d===0||d===1&&s===r-1&&s===i+1?o.base=o.name=p.slice(i,r):(o.name=p.slice(i,s),o.base=p.slice(i,r),o.ext=p.slice(s,r))),i>0&&i!==c?o.dir=p.slice(0,i-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...p){let o="",m=!1;for(let c=p.length-1;c>=-1&&!m;c--){const l=c>=0?p[c]:u.cwd();T(l,"path"),l.length!==0&&(o=`${l}/${o}`,m=l.charCodeAt(0)===E)}return o=h(o,!m,"/",b),m?`/${o}`:o.length>0?o:"."},normalize(p){if(T(p,"path"),p.length===0)return".";const o=p.charCodeAt(0)===E,m=p.charCodeAt(p.length-1)===E;return p=h(p,!o,"/",b),p.length===0?o?"/":m?"./":".":(m&&(p+="/"),o?`/${p}`:p)},isAbsolute(p){return T(p,"path"),p.length>0&&p.charCodeAt(0)===E},join(...p){if(p.length===0)return".";let o;for(let m=0;m<p.length;++m){const c=p[m];T(c,"path"),c.length>0&&(o===void 0?o=c:o+=`/${c}`)}return o===void 0?".":e.posix.normalize(o)},relative(p,o){if(T(p,"from"),T(o,"to"),p===o||(p=e.posix.resolve(p),o=e.posix.resolve(o),p===o))return"";const m=1,c=p.length,l=c-m,s=1,i=o.length-s,r=l<i?l:i;let n=-1,a=0;for(;a<r;a++){const f=p.charCodeAt(m+a);if(f!==o.charCodeAt(s+a))break;f===E&&(n=a)}if(a===r)if(i>r){if(o.charCodeAt(s+a)===E)return o.slice(s+a+1);if(a===0)return o.slice(s+a)}else l>r&&(p.charCodeAt(m+a)===E?n=a:a===0&&(n=0));let d="";for(a=m+n+1;a<=c;++a)(a===c||p.charCodeAt(a)===E)&&(d+=d.length===0?"..":"/..");return`${d}${o.slice(s+n)}`},toNamespacedPath(p){return p},dirname(p){if(T(p,"path"),p.length===0)return".";const o=p.charCodeAt(0)===E;let m=-1,c=!0;for(let l=p.length-1;l>=1;--l)if(p.charCodeAt(l)===E){if(!c){m=l;break}}else c=!1;return m===-1?o?"/":".":o&&m===1?"//":p.slice(0,m)},basename(p,o){o!==void 0&&T(o,"ext"),T(p,"path");let m=0,c=-1,l=!0,s;if(o!==void 0&&o.length>0&&o.length<=p.length){if(o===p)return"";let i=o.length-1,r=-1;for(s=p.length-1;s>=0;--s){const n=p.charCodeAt(s);if(n===E){if(!l){m=s+1;break}}else r===-1&&(l=!1,r=s+1),i>=0&&(n===o.charCodeAt(i)?--i==-1&&(c=s):(i=-1,c=r))}return m===c?c=r:c===-1&&(c=p.length),p.slice(m,c)}for(s=p.length-1;s>=0;--s)if(p.charCodeAt(s)===E){if(!l){m=s+1;break}}else c===-1&&(l=!1,c=s+1);return c===-1?"":p.slice(m,c)},extname(p){T(p,"path");let o=-1,m=0,c=-1,l=!0,s=0;for(let i=p.length-1;i>=0;--i){const r=p.charCodeAt(i);if(r===E){if(!l){m=i+1;break}continue}c===-1&&(l=!1,c=i+1),r===C?o===-1?o=i:s!==1&&(s=1):o!==-1&&(s=-1)}return o===-1||c===-1||s===0||s===1&&o===c-1&&o===m+1?"":p.slice(o,c)},format:g.bind(null,"/"),parse(p){T(p,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(p.length===0)return o;const m=p.charCodeAt(0)===E;let c;m?(o.root="/",c=1):c=0;let l=-1,s=0,i=-1,r=!0,n=p.length-1,a=0;for(;n>=c;--n){const d=p.charCodeAt(n);if(d===E){if(!r){s=n+1;break}continue}i===-1&&(r=!1,i=n+1),d===C?l===-1?l=n:a!==1&&(a=1):l!==-1&&(a=-1)}if(i!==-1){const d=s===0&&m?1:s;l===-1||a===0||a===1&&l===i-1&&l===s+1?o.base=o.name=p.slice(d,i):(o.name=p.slice(d,l),o.base=p.slice(d,i),o.ext=p.slice(l,i))}return s>0?o.dir=p.slice(0,s-1):m&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=u.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=u.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=u.platform==="win32"?e.win32.join:e.posix.join,e.resolve=u.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=u.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=u.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=u.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=u.platform==="win32"?e.win32.extname:e.posix.extname,e.format=u.platform==="win32"?e.win32.format:e.posix.format,e.parse=u.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=u.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=u.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=u.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(De[100],Ie([1,0,9]),function(Z,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const t={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},D={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function P(R){const k=(0,u.extname)(R),_=t[k.toLowerCase()];return _!==void 0?_:y(R)}e.getMediaOrTextMime=P;function y(R){const k=(0,u.extname)(R);return D[k.toLowerCase()]}e.getMediaMime=y;function C(R){for(const k in D)if(D[k]===R)return k}e.getExtensionForMimeType=C;const E=/^(.+)\/(.+?)(;.+)?$/;function I(R,k){const _=E.exec(R);return _?`${_[1].toLowerCase()}/${_[2].toLowerCase()}${_[3]??""}`:k?void 0:R}e.normalizeMimeType=I}),define(De[101],Ie([1,0,11]),function(Z,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(C){C[C.stdout=0]="stdout",C[C.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var D;(function(C){C[C.Success=0]="Success",C[C.Unknown=1]="Unknown",C[C.AccessDenied=2]="AccessDenied",C[C.ProcessNotFound=3]="ProcessNotFound"})(D=e.TerminateResponseCode||(e.TerminateResponseCode={}));function P(C,...E){const I=E.reduce((_,T)=>(_[T]=!0,_),{}),R=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(C).filter(_=>!I[_]).forEach(_=>{for(let T=0;T<R.length;T++)if(_.search(R[T])!==-1){delete C[_];break}})}e.sanitizeProcessEnvironment=P;function y(C){!C||(delete C.DEBUG,u.isMacintosh&&delete C.DYLD_LIBRARY_PATH,u.isLinux&&delete C.LD_PRELOAD)}e.removeDangerousEnvVariables=y}),define(De[51],Ie([1,0,11]),function(Z,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=u.globals.performance&&typeof u.globals.performance.now=="function";class D{constructor(y){this._highResolution=t&&y,this._startTime=this._now(),this._stopTime=-1}static create(y=!0){return new D(y)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?u.globals.performance.now():Date.now()}}e.StopWatch=D}),define(De[4],Ie([1,0,10,58,6,79,51]),function(Z,e,u,t,D,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;const C=!1,E=!1;var I;(function(n){n.None=()=>D.Disposable.None;function a(pe){if(E){const{onListenerDidAdd:Ee}=pe,ke=w.create();let Oe=0;pe.onListenerDidAdd=()=>{++Oe==2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ke.print()),Ee?.()}}}function d(pe){return(Ee,ke=null,Oe)=>{let Be=!1,ae;return ae=pe(de=>{if(!Be)return ae?ae.dispose():Be=!0,Ee.call(ke,de)},null,Oe),Be&&ae.dispose(),ae}}n.once=d;function f(pe,Ee,ke){return B((Oe,Be=null,ae)=>pe(de=>Oe.call(Be,Ee(de)),null,ae),ke)}n.map=f;function S(pe,Ee,ke){return B((Oe,Be=null,ae)=>pe(de=>{Ee(de),Oe.call(Be,de)},null,ae),ke)}n.forEach=S;function O(pe,Ee,ke){return B((Oe,Be=null,ae)=>pe(de=>Ee(de)&&Oe.call(Be,de),null,ae),ke)}n.filter=O;function U(pe){return pe}n.signal=U;function M(...pe){return(Ee,ke=null,Oe)=>(0,D.combinedDisposable)(...pe.map(Be=>Be(ae=>Ee.call(ke,ae),null,Oe)))}n.any=M;function A(pe,Ee,ke,Oe){let Be=ke;return f(pe,ae=>(Be=Ee(Be,ae),Be),Oe)}n.reduce=A;function B(pe,Ee){let ke;const Oe={onFirstListenerAdd(){ke=pe(Be.fire,Be)},onLastListenerRemove(){ke?.dispose()}};Ee||a(Oe);const Be=new v(Oe);return Ee?.add(Be),Be.event}function x(pe,Ee,ke=100,Oe=!1,Be,ae){let de,me,te,le=0;const ee={leakWarningThreshold:Be,onFirstListenerAdd(){de=pe(F=>{le++,me=Ee(me,F),Oe&&!te&&(re.fire(me),me=void 0),clearTimeout(te),te=setTimeout(()=>{const W=me;me=void 0,te=void 0,(!Oe||le>1)&&re.fire(W),le=0},ke)})},onLastListenerRemove(){de.dispose()}};ae||a(ee);const re=new v(ee);return ae?.add(re),re.event}n.debounce=x;function N(pe,Ee=(Oe,Be)=>Oe===Be,ke){let Oe=!0,Be;return O(pe,ae=>{const de=Oe||!Ee(ae,Be);return Oe=!1,Be=ae,de},ke)}n.latch=N;function K(pe,Ee,ke){return[n.filter(pe,Ee,ke),n.filter(pe,Oe=>!Ee(Oe),ke)]}n.split=K;function X(pe,Ee=!1,ke=[]){let Oe=ke.slice(),Be=pe(me=>{Oe?Oe.push(me):de.fire(me)});const ae=()=>{Oe?.forEach(me=>de.fire(me)),Oe=null},de=new v({onFirstListenerAdd(){Be||(Be=pe(me=>de.fire(me)))},onFirstListenerDidAdd(){Oe&&(Ee?setTimeout(ae):ae())},onLastListenerRemove(){Be&&Be.dispose(),Be=null}});return de.event}n.buffer=X;class L{constructor(Ee){this.event=Ee,this.disposables=new D.DisposableStore}map(Ee){return new L(f(this.event,Ee,this.disposables))}forEach(Ee){return new L(S(this.event,Ee,this.disposables))}filter(Ee){return new L(O(this.event,Ee,this.disposables))}reduce(Ee,ke){return new L(A(this.event,Ee,ke,this.disposables))}latch(){return new L(N(this.event,void 0,this.disposables))}debounce(Ee,ke=100,Oe=!1,Be){return new L(x(this.event,Ee,ke,Oe,Be,this.disposables))}on(Ee,ke,Oe){return this.event(Ee,ke,Oe)}once(Ee,ke,Oe){return d(this.event)(Ee,ke,Oe)}dispose(){this.disposables.dispose()}}function $(pe){return new L(pe)}n.chain=$;function H(pe,Ee,ke=Oe=>Oe){const Oe=(...me)=>de.fire(ke(...me)),Be=()=>pe.on(Ee,Oe),ae=()=>pe.removeListener(Ee,Oe),de=new v({onFirstListenerAdd:Be,onLastListenerRemove:ae});return de.event}n.fromNodeEventEmitter=H;function j(pe,Ee,ke=Oe=>Oe){const Oe=(...me)=>de.fire(ke(...me)),Be=()=>pe.addEventListener(Ee,Oe),ae=()=>pe.removeEventListener(Ee,Oe),de=new v({onFirstListenerAdd:Be,onLastListenerRemove:ae});return de.event}n.fromDOMEventEmitter=j;function J(pe){return new Promise(Ee=>d(pe)(Ee))}n.toPromise=J;function Y(pe,Ee){return Ee(void 0),pe(ke=>Ee(ke))}n.runAndSubscribe=Y;function he(pe,Ee){let ke=null;function Oe(ae){ke?.dispose(),ke=new D.DisposableStore,Ee(ae,ke)}Oe(void 0);const Be=pe(ae=>Oe(ae));return(0,D.toDisposable)(()=>{Be.dispose(),ke?.dispose()})}n.runAndSubscribeWithStore=he;class ve{constructor(Ee,ke){this.obs=Ee,this._counter=0,this._hasChanged=!1;const Oe={onFirstListenerAdd:()=>{Ee.addObserver(this)},onLastListenerRemove:()=>{Ee.removeObserver(this)}};ke||a(Oe),this.emitter=new v(Oe),ke&&ke.add(this.emitter)}beginUpdate(Ee){this._counter++}handleChange(Ee,ke){this._hasChanged=!0}endUpdate(Ee){--this._counter==0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function ne(pe,Ee){return new ve(pe,Ee).emitter.event}n.fromObservable=ne})(I=e.Event||(e.Event={}));class R{constructor(a){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${a}_${R._idPool++}`}start(a){this._stopWatch=new y.StopWatch(!0),this._listenerCount=a}stop(){if(this._stopWatch){const a=this._stopWatch.elapsed();this._elapsedOverall+=a,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${a.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}R._idPool=0;let k=-1;function _(n){const a=k;return k=n,{dispose(){k=a}}}e.setGlobalLeakWarningThreshold=_;class T{constructor(a,d=Math.random().toString(18).slice(2,5)){this.customThreshold=a,this.name=d,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(a,d){let f=k;if(typeof this.customThreshold=="number"&&(f=this.customThreshold),f<=0||d<f)return;this._stacks||(this._stacks=new Map);const S=this._stacks.get(a.value)||0;if(this._stacks.set(a.value,S+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=f*.5;let O,U=0;for(const[M,A]of this._stacks)(!O||U<A)&&(O=M,U=A);console.warn(`[${this.name}] potential listener LEAK detected, having ${d} listeners already. MOST frequent listener (${U}):`),console.warn(O)}return()=>{const O=this._stacks.get(a.value)||0;this._stacks.set(a.value,O-1)}}}class w{constructor(a){this.value=a}static create(){return new w(new Error().stack??"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class b{constructor(a,d,f){this.callback=a,this.callbackThis=d,this.stack=f,this.subscription=new D.SafeDisposable}invoke(a){this.callback.call(this.callbackThis,a)}}class v{constructor(a){this._disposed=!1,this._options=a,this._leakageMon=k>0?new T(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new R(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(C){const a=Array.from(this._listeners);queueMicrotask(()=>{for(const d of a)d.subscription.isset()&&(d.subscription.unset(),d.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(a,d,f)=>{this._listeners||(this._listeners=new P.LinkedList);const S=this._listeners.isEmpty();S&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let O,U;this._leakageMon&&this._listeners.size>=30&&(U=w.create(),O=this._leakageMon.check(U,this._listeners.size+1)),C&&(U=U??w.create());const M=new b(a,d,U),A=this._listeners.push(M);S&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,a,d);const B=M.subscription.set(()=>{O?.(),this._disposed||(A(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return f instanceof D.DisposableStore?f.add(B):Array.isArray(f)&&f.push(B),B}),this._event}fire(a){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new g);for(const d of this._listeners)this._deliveryQueue.push(this,d,a);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=v;class h{constructor(){this._queue=new P.LinkedList}get size(){return this._queue.size}push(a,d,f){this._queue.push(new p(a,d,f))}clear(a){const d=new P.LinkedList;for(const f of this._queue)f.emitter!==a&&d.push(f);this._queue=d}deliver(){for(;this._queue.size>0;){const a=this._queue.shift();try{a.listener.invoke(a.event)}catch(d){(0,u.onUnexpectedError)(d)}}}}e.EventDeliveryQueue=h;class g extends h{clear(a){this._queue.clear()}}class p{constructor(a,d,f){this.emitter=a,this.listener=d,this.event=f}}class o extends v{async fireAsync(a,d,f){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new P.LinkedList);for(const S of this._listeners)this._asyncDeliveryQueue.push([S,a]);for(;this._asyncDeliveryQueue.size>0&&!d.isCancellationRequested;){const[S,O]=this._asyncDeliveryQueue.shift(),U=[],M={...O,token:d,waitUntil:A=>{if(Object.isFrozen(U))throw new Error("waitUntil can NOT be called asynchronous");f&&(A=f(A,S.callback)),U.push(A)}};try{S.invoke(M)}catch(A){(0,u.onUnexpectedError)(A);continue}Object.freeze(U),await Promise.allSettled(U).then(A=>{for(const B of A)B.status==="rejected"&&(0,u.onUnexpectedError)(B.reason)})}}}}e.AsyncEmitter=o;class m extends v{constructor(a){super(a);this._isPaused=0,this._eventQueue=new P.LinkedList,this._mergeFn=a?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const a=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(a))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(a){this._listeners&&(this._isPaused!==0?this._eventQueue.push(a):super.fire(a))}}e.PauseableEmitter=m;class c extends m{constructor(a){super(a);this._delay=a.delay??100}fire(a){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(a)}}e.DebounceEmitter=c;class l extends v{constructor(a){super(a);this._queuedEvents=[],this._mergeFn=a?.merge}fire(a){this._queuedEvents.push(a),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(d=>super.fire(d)),this._queuedEvents=[]})}}e.MicrotaskEmitter=l;class s{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new v({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(a){const d={event:a,listener:null};this.events.push(d),this.hasListeners&&this.hook(d);const f=()=>{this.hasListeners&&this.unhook(d);const S=this.events.indexOf(d);this.events.splice(S,1)};return(0,D.toDisposable)((0,t.once)(f))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(a=>this.hook(a))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(a=>this.unhook(a))}hook(a){a.listener=a.event(d=>this.emitter.fire(d))}unhook(a){a.listener&&a.listener.dispose(),a.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=s;class i{constructor(){this.buffers=[]}wrapEvent(a){return(d,f,S)=>a(O=>{const U=this.buffers[this.buffers.length-1];U?U.push(()=>d.call(f,O)):d.call(f,O)},void 0,S)}bufferEvents(a){const d=[];this.buffers.push(d);const f=a();return this.buffers.pop(),d.forEach(S=>S()),f}}e.EventBufferer=i;class r{constructor(){this.listening=!1,this.inputEvent=I.None,this.inputEventListener=D.Disposable.None,this.emitter=new v({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(a){this.inputEvent=a,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=a(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=r}),define(De[21],Ie([1,0,4]),function(Z,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(C,E){const I=setTimeout(C.bind(E),0);return{dispose(){clearTimeout(I)}}});var D;(function(C){function E(I){return I===C.None||I===C.Cancelled||I instanceof P?!0:!I||typeof I!="object"?!1:typeof I.isCancellationRequested=="boolean"&&typeof I.onCancellationRequested=="function"}C.isCancellationToken=E,C.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:u.Event.None}),C.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(D=e.CancellationToken||(e.CancellationToken={}));class P{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new u.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class y{constructor(E){this._token=void 0,this._parentListener=void 0,this._parentListener=E&&E.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new P),this._token}cancel(){this._token?this._token instanceof P&&this._token.cancel():this._token=D.Cancelled}dispose(E=!1){E&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof P&&this._token.dispose():this._token=D.None}}e.CancellationTokenSource=y}),define(De[154],Ie([1,0,21]),function(Z,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(C){this.task=C,this.result=null}get(){if(this.result)return this.result;const C=new u.CancellationTokenSource,E=this.task(C.token);return this.result={promise:E,dispose:()=>{this.result=null,C.cancel(),C.dispose()}},this.result}}e.Cache=t;class D{constructor(C){this.fn=C,this.lastCache=void 0,this.lastArgKey=void 0}get(C){const E=JSON.stringify(C);return this.lastArgKey!==E&&(this.lastArgKey=E,this.lastCache=this.fn(C)),this.lastCache}}e.LRUCachedFunction=D;class P{constructor(C){this.fn=C,this._map=new Map}get cachedValues(){return this._map}get(C){if(this._map.has(C))return this._map.get(C);const E=this.fn(C);return this._map.set(C,E),E}}e.CachedFunction=P}),define(De[8],Ie([1,0,154,78]),function(Z,e,u,t){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function P(q){return!q||typeof q!="string"?!0:q.trim().length===0}e.isFalsyOrWhitespace=P;const y=/{(\d+)}/g;function C(q,...ye){return ye.length===0?q:q.replace(y,function(Ae,We){const ze=parseInt(We,10);return isNaN(ze)||ze<0||ze>=ye.length?Ae:ye[ze]})}e.format=C;const E=/{([^}]+)}/g;function I(q,ye){return q.replace(E,(Ae,We)=>ye[We]??Ae)}e.format2=I;function R(q){return q.replace(/[<>&]/g,function(ye){switch(ye){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ye}})}e.escape=R;function k(q){return q.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=k;function _(q,ye){let Ae=0;const We=ye.charCodeAt(0);for(let ze=q.length-1;ze>=0;ze--)q.charCodeAt(ze)===We&&Ae++;return Ae}e.count=_;function T(q,ye,Ae="\u2026"){return q.length<=ye?q:`${q.substr(0,ye)}${Ae}`}e.truncate=T;function w(q,ye=" "){const Ae=b(q,ye);return v(Ae,ye)}e.trim=w;function b(q,ye){if(!q||!ye)return q;const Ae=ye.length;if(Ae===0||q.length===0)return q;let We=0;for(;q.indexOf(ye,We)===We;)We=We+Ae;return q.substring(We)}e.ltrim=b;function v(q,ye){if(!q||!ye)return q;const Ae=ye.length,We=q.length;if(Ae===0||We===0)return q;let ze=We,$e=-1;for(;$e=q.lastIndexOf(ye,ze-1),!($e===-1||$e+Ae!==ze);){if($e===0)return"";ze=$e}return q.substring(0,ze)}e.rtrim=v;function h(q){return q.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=h;function g(q){return q.replace(/\*/g,"")}e.stripWildcards=g;function p(q,ye,Ae={}){if(!q)throw new Error("Cannot create regex from empty string");ye||(q=k(q)),Ae.wholeWord&&(/\B/.test(q.charAt(0))||(q="\\b"+q),/\B/.test(q.charAt(q.length-1))||(q=q+"\\b"));let We="";return Ae.global&&(We+="g"),Ae.matchCase||(We+="i"),Ae.multiline&&(We+="m"),Ae.unicode&&(We+="u"),new RegExp(q,We)}e.createRegExp=p;function o(q){return q.source==="^"||q.source==="^$"||q.source==="$"||q.source==="^\\s*$"?!1:!!(q.exec("")&&q.lastIndex===0)}e.regExpLeadsToEndlessLoop=o;function m(q){return!!q.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=m;function c(q){return(q.global?"g":"")+(q.ignoreCase?"i":"")+(q.multiline?"m":"")+(q.unicode?"u":"")}e.regExpFlags=c;function l(q){return q.split(/\r\n|\r|\n/)}e.splitLines=l;function s(q){for(let ye=0,Ae=q.length;ye<Ae;ye++){const We=q.charCodeAt(ye);if(We!==32&&We!==9)return ye}return-1}e.firstNonWhitespaceIndex=s;function i(q,ye=0,Ae=q.length){for(let We=ye;We<Ae;We++){const ze=q.charCodeAt(We);if(ze!==32&&ze!==9)return q.substring(ye,We)}return q.substring(ye,Ae)}e.getLeadingWhitespace=i;function r(q,ye=q.length-1){for(let Ae=ye;Ae>=0;Ae--){const We=q.charCodeAt(Ae);if(We!==32&&We!==9)return Ae}return-1}e.lastNonWhitespaceIndex=r;function n(q,ye,Ae){const We=[];let ze=0;for(const $e of q.matchAll(ye)){if(We.push(q.slice(ze,$e.index)),$e.index===void 0)throw new Error("match.index should be defined");ze=$e.index+$e[0].length,We.push(Ae($e[0],...$e.slice(1),$e.index,q,$e.groups))}return We.push(q.slice(ze)),Promise.all(We).then($e=>$e.join(""))}e.replaceAsync=n;function a(q,ye){return q<ye?-1:q>ye?1:0}e.compare=a;function d(q,ye,Ae=0,We=q.length,ze=0,$e=ye.length){for(;Ae<We&&ze<$e;Ae++,ze++){const lt=q.charCodeAt(Ae),ht=ye.charCodeAt(ze);if(lt<ht)return-1;if(lt>ht)return 1}const Ze=We-Ae,it=$e-ze;return Ze<it?-1:Ze>it?1:0}e.compareSubstring=d;function f(q,ye){return S(q,ye,0,q.length,0,ye.length)}e.compareIgnoreCase=f;function S(q,ye,Ae=0,We=q.length,ze=0,$e=ye.length){for(;Ae<We&&ze<$e;Ae++,ze++){let lt=q.charCodeAt(Ae),ht=ye.charCodeAt(ze);if(lt===ht)continue;if(lt>=128||ht>=128)return d(q.toLowerCase(),ye.toLowerCase(),Ae,We,ze,$e);U(lt)&&(lt-=32),U(ht)&&(ht-=32);const tt=lt-ht;if(tt!==0)return tt}const Ze=We-Ae,it=$e-ze;return Ze<it?-1:Ze>it?1:0}e.compareSubstringIgnoreCase=S;function O(q){return q>=48&&q<=57}e.isAsciiDigit=O;function U(q){return q>=97&&q<=122}e.isLowerAsciiLetter=U;function M(q){return q>=65&&q<=90}e.isUpperAsciiLetter=M;function A(q,ye){return q.length===ye.length&&S(q,ye)===0}e.equalsIgnoreCase=A;function B(q,ye){const Ae=ye.length;return ye.length>q.length?!1:S(q,ye,0,Ae)===0}e.startsWithIgnoreCase=B;function x(q,ye){const Ae=Math.min(q.length,ye.length);let We;for(We=0;We<Ae;We++)if(q.charCodeAt(We)!==ye.charCodeAt(We))return We;return Ae}e.commonPrefixLength=x;function N(q,ye){const Ae=Math.min(q.length,ye.length);let We;const ze=q.length-1,$e=ye.length-1;for(We=0;We<Ae;We++)if(q.charCodeAt(ze-We)!==ye.charCodeAt($e-We))return We;return Ae}e.commonSuffixLength=N;function K(q){return 55296<=q&&q<=56319}e.isHighSurrogate=K;function X(q){return 56320<=q&&q<=57343}e.isLowSurrogate=X;function L(q,ye){return(q-55296<<10)+(ye-56320)+65536}e.computeCodePoint=L;function $(q,ye,Ae){const We=q.charCodeAt(Ae);if(K(We)&&Ae+1<ye){const ze=q.charCodeAt(Ae+1);if(X(ze))return L(We,ze)}return We}e.getNextCodePoint=$;function H(q,ye){const Ae=q.charCodeAt(ye-1);if(X(Ae)&&ye>1){const We=q.charCodeAt(ye-2);if(K(We))return L(We,Ae)}return Ae}class j{constructor(ye,Ae=0){this._str=ye,this._len=ye.length,this._offset=Ae}get offset(){return this._offset}setOffset(ye){this._offset=ye}prevCodePoint(){const ye=H(this._str,this._offset);return this._offset-=ye>=65536?2:1,ye}nextCodePoint(){const ye=$(this._str,this._len,this._offset);return this._offset+=ye>=65536?2:1,ye}eol(){return this._offset>=this._len}}e.CodePointIterator=j;class J{constructor(ye,Ae=0){this._iterator=new j(ye,Ae)}get offset(){return this._iterator.offset}nextGraphemeLength(){const ye=Ue.getInstance(),Ae=this._iterator,We=Ae.offset;let ze=ye.getGraphemeBreakType(Ae.nextCodePoint());for(;!Ae.eol();){const $e=Ae.offset,Ze=ye.getGraphemeBreakType(Ae.nextCodePoint());if(Ce(ze,Ze)){Ae.setOffset($e);break}ze=Ze}return Ae.offset-We}prevGraphemeLength(){const ye=Ue.getInstance(),Ae=this._iterator,We=Ae.offset;let ze=ye.getGraphemeBreakType(Ae.prevCodePoint());for(;Ae.offset>0;){const $e=Ae.offset,Ze=ye.getGraphemeBreakType(Ae.prevCodePoint());if(Ce(Ze,ze)){Ae.setOffset($e);break}ze=Ze}return We-Ae.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=J;function Y(q,ye){return new J(q,ye).nextGraphemeLength()}e.nextCharLength=Y;function he(q,ye){return new J(q,ye).prevGraphemeLength()}e.prevCharLength=he;function ve(q,ye){ye>0&&X(q.charCodeAt(ye))&&ye--;const Ae=ye+Y(q,ye);return[Ae-he(q,Ae),Ae]}e.getCharContainingOffset=ve;const ne=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function pe(q){return ne.test(q)}e.containsRTL=pe;const Ee=/^[\t\n\r\x20-\x7E]*$/;function ke(q){return Ee.test(q)}e.isBasicASCII=ke,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Oe(q){return e.UNUSUAL_LINE_TERMINATORS.test(q)}e.containsUnusualLineTerminators=Oe;function Be(q){return q>=11904&&q<=55215||q>=63744&&q<=64255||q>=65281&&q<=65374}e.isFullWidthCharacter=Be;function ae(q){return q>=127462&&q<=127487||q===8986||q===8987||q===9200||q===9203||q>=9728&&q<=10175||q===11088||q===11093||q>=127744&&q<=128591||q>=128640&&q<=128764||q>=128992&&q<=129008||q>=129280&&q<=129535||q>=129648&&q<=129782}e.isEmojiImprecise=ae;function de(q,ye){if(q.length<ye)return q;const Ae=/\b/g;let We=0;for(;Ae.test(q)&&!(q.length-Ae.lastIndex<ye);)We=Ae.lastIndex,Ae.lastIndex+=1;return q.substring(We).replace(/^\s/,"")}e.lcut=de;const me=/\x1B\x5B[12]?K/g,te=/\x1b\[\d+m/g,le=/\x1b\[0?m/g;function ee(q){return q&&(q=q.replace(me,""),q=q.replace(te,""),q=q.replace(le,"")),q}e.removeAnsiEscapeCodes=ee,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function re(q){return!!(q&&q.length>0&&q.charCodeAt(0)===65279)}e.startsWithUTF8BOM=re;function F(q){return re(q)?q.substr(1):q}e.stripUTF8BOM=F;function W(q,ye){if(!q||!ye||q.length<ye.length)return!1;const Ae=ye.length,We=q.toLowerCase();let ze=0,$e=-1;for(;ze<Ae;){const Ze=We.indexOf(ye[ze],$e+1);if(Ze<0)return!1;$e=Ze,ze++}return!0}e.fuzzyContains=W;function G(q,ye=!1){return q?(ye&&(q=q.replace(/\\./g,"")),q.toLowerCase()!==q):!1}e.containsUppercaseCharacter=G;function Q(q){return q.charAt(0).toUpperCase()+q.slice(1)}e.uppercaseFirstLetter=Q;function fe(q,ye=1){if(ye===0)return"";let Ae=-1;do Ae=q.indexOf(`
`,Ae+1),ye--;while(ye>0&&Ae>=0);return Ae===-1?q:(q[Ae-1]==="\r"&&Ae--,q.substr(0,Ae))}e.getNLines=fe;function be(q){const ye=90-65+1;return q=q%(2*ye),q<ye?String.fromCharCode(97+q):String.fromCharCode(65+q-ye)}e.singleLetterHash=be;function ue(q){return Ue.getInstance().getGraphemeBreakType(q)}e.getGraphemeBreakType=ue;function Ce(q,ye){return q===0?ye!==5&&ye!==7:q===2&&ye===3?!1:q===4||q===2||q===3||ye===4||ye===2||ye===3?!0:!(q===8&&(ye===8||ye===9||ye===11||ye===12)||(q===11||q===9)&&(ye===9||ye===10)||(q===12||q===10)&&ye===10||ye===5||ye===13||ye===7||q===1||q===13&&ye===14||q===6&&ye===6)}var Se;(function(q){q[q.Other=0]="Other",q[q.Prepend=1]="Prepend",q[q.CR=2]="CR",q[q.LF=3]="LF",q[q.Control=4]="Control",q[q.Extend=5]="Extend",q[q.Regional_Indicator=6]="Regional_Indicator",q[q.SpacingMark=7]="SpacingMark",q[q.L=8]="L",q[q.V=9]="V",q[q.T=10]="T",q[q.LV=11]="LV",q[q.LVT=12]="LVT",q[q.ZWJ=13]="ZWJ",q[q.Extended_Pictographic=14]="Extended_Pictographic"})(Se=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ue{constructor(){this._data=qe()}static getInstance(){return Ue._INSTANCE||(Ue._INSTANCE=new Ue),Ue._INSTANCE}getGraphemeBreakType(ye){if(ye<32)return ye===10?3:ye===13?2:4;if(ye<127)return 0;const Ae=this._data,We=Ae.length/3;let ze=1;for(;ze<=We;)if(ye<Ae[3*ze])ze=2*ze;else if(ye>Ae[3*ze+1])ze=2*ze+1;else return Ae[3*ze+2];return 0}}Ue._INSTANCE=null;function qe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Je(q,ye){if(q===0)return 0;const Ae=Qe(q,ye);if(Ae!==void 0)return Ae;const We=new j(ye,q);return We.prevCodePoint(),We.offset}e.getLeftDeleteOffset=Je;function Qe(q,ye){const Ae=new j(ye,q);let We=Ae.prevCodePoint();for(;Re(We)||We===65039||We===8419;){if(Ae.offset===0)return;We=Ae.prevCodePoint()}if(!ae(We))return;let ze=Ae.offset;return ze>0&&Ae.prevCodePoint()===8205&&(ze=Ae.offset),ze}function Re(q){return 127995<=q&&q<=127999}var st;(function(q){q[q.zwj=8205]="zwj",q[q.emojiVariantSelector=65039]="emojiVariantSelector",q[q.enclosingKeyCap=8419]="enclosingKeyCap"})(st||(st={})),e.noBreakWhitespace="\xA0";class se{constructor(ye){this.confusableDictionary=ye}static getInstance(ye){return se.cache.get(Array.from(ye))}static getLocales(){return se._locales.getValue()}isAmbiguous(ye){return this.confusableDictionary.has(ye)}getPrimaryConfusable(ye){return this.confusableDictionary.get(ye)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=se,D=se,se.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),se.cache=new u.LRUCachedFunction(q=>{function ye(ht){const tt=new Map;for(let at=0;at<ht.length;at+=2)tt.set(ht[at],ht[at+1]);return tt}function Ae(ht,tt){const at=new Map(ht);for(const[Ct,Ot]of tt)at.set(Ct,Ot);return at}function We(ht,tt){if(!ht)return tt;const at=new Map;for(const[Ct,Ot]of ht)tt.has(Ct)&&at.set(Ct,Ot);return at}const ze=D.ambiguousCharacterData.getValue();let $e=q.filter(ht=>!ht.startsWith("_")&&ht in ze);$e.length===0&&($e=["_default"]);let Ze;for(const ht of $e){const tt=ye(ze[ht]);Ze=We(Ze,tt)}const it=ye(ze._common),lt=Ae(it,Ze);return new se(lt)}),se._locales=new t.Lazy(()=>Object.keys(se.ambiguousCharacterData.getValue()).filter(q=>!q.startsWith("_")));class oe{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(oe.getRawData())),this._data}static isInvisibleCharacter(ye){return oe.getData().has(ye)}static get codePoints(){return oe.getData()}}e.InvisibleCharacters=oe,oe._data=void 0}),define(De[31],Ie([1,0,9,11,8,13]),function(Z,e,u,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function y(r){return r===47||r===92}e.isPathSeparator=y;function C(r){return r.replace(/[\\/]/g,u.posix.sep)}e.toSlashes=C;function E(r){return r.indexOf("/")===-1&&(r=C(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=E;function I(r,n=u.posix.sep){if(!r)return"";const a=r.length,d=r.charCodeAt(0);if(y(d)){if(y(r.charCodeAt(1))&&!y(r.charCodeAt(2))){let S=3;const O=S;for(;S<a&&!y(r.charCodeAt(S));S++);if(O!==S&&!y(r.charCodeAt(S+1))){for(S+=1;S<a;S++)if(y(r.charCodeAt(S)))return r.slice(0,S+1).replace(/[\\/]/g,n)}}return n}else if(h(d)&&r.charCodeAt(1)===58)return y(r.charCodeAt(2))?r.slice(0,2)+n:r.slice(0,2);let f=r.indexOf("://");if(f!==-1){for(f+=3;f<a;f++)if(y(r.charCodeAt(f)))return r.slice(0,f+1)}return""}e.getRoot=I;function R(r){if(!t.isWindows||!r||r.length<5)return!1;let n=r.charCodeAt(0);if(n!==92||(n=r.charCodeAt(1),n!==92))return!1;let a=2;const d=a;for(;a<r.length&&(n=r.charCodeAt(a),n!==92);a++);return!(d===a||(n=r.charCodeAt(a+1),isNaN(n)||n===92))}e.isUNC=R;const k=/[\\/:\*\?"<>\|]/g,_=/[\\/]/g,T=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function w(r,n=t.isWindows){const a=n?k:_;return!(!r||r.length===0||/^\s+$/.test(r)||(a.lastIndex=0,a.test(r))||n&&T.test(r)||r==="."||r===".."||n&&r[r.length-1]==="."||n&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=w;function b(r,n,a){const d=r===n;return!a||d?d:!r||!n?!1:(0,D.equalsIgnoreCase)(r,n)}e.isEqual=b;function v(r,n,a,d=u.sep){if(r===n)return!0;if(!r||!n||n.length>r.length)return!1;if(a){if(!(0,D.startsWithIgnoreCase)(r,n))return!1;if(n.length===r.length)return!0;let S=n.length;return n.charAt(n.length-1)===d&&S--,r.charAt(S)===d}return n.charAt(n.length-1)!==d&&(n+=d),r.indexOf(n)===0}e.isEqualOrParent=v;function h(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=h;function g(r,n){return t.isWindows&&r.endsWith(":")&&(r+=u.sep),(0,u.isAbsolute)(r)||(r=(0,u.join)(n,r)),r=(0,u.normalize)(r),t.isWindows?(r=(0,D.rtrim)(r,u.sep),r.endsWith(":")&&(r+=u.sep)):(r=(0,D.rtrim)(r,u.sep),r||(r=u.sep)),r}e.sanitizeFilePath=g;function p(r){const n=(0,u.normalize)(r);return t.isWindows?r.length>3?!1:o(n)&&(r.length===2||n.charCodeAt(2)===92):n===u.posix.sep}e.isRootOrDriveLetter=p;function o(r,n=t.isWindows){return n?h(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=o;function m(r){return o(r)?r[0]:void 0}e.getDriveLetter=m;function c(r,n,a){return n.length>r.length?-1:r===n?0:(a&&(r=r.toLowerCase(),n=n.toLowerCase()),r.indexOf(n))}e.indexOfPath=c;function l(r){const n=r.split(":");let a,d,f;for(const S of n){const O=Number(S);(0,P.isNumber)(O)?d===void 0?d=O:f===void 0&&(f=O):a=a?[a,S].join(":"):S}if(!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:d!==void 0?d:void 0,column:f!==void 0?f:d!==void 0?1:void 0}}e.parseLineAndColumnAware=l;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function i(r,n,a=8){let d="";for(let S=0;S<a;S++)d+=s.charAt(Math.floor(Math.random()*s.length));let f;return n?f=`${n}-${d}`:f=d,r?(0,u.join)(r,f):f}e.randomPath=i}),define(De[60],Ie([1,0,8]),function(Z,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(h){return D(h,0)}e.hash=t;function D(h,g){switch(typeof h){case"object":return h===null?P(349,g):Array.isArray(h)?E(h,g):I(h,g);case"string":return C(h,g);case"boolean":return y(h,g);case"number":return P(h,g);case"undefined":return P(937,g);default:return P(617,g)}}e.doHash=D;function P(h,g){return(g<<5)-g+h|0}e.numberHash=P;function y(h,g){return P(h?433:863,g)}function C(h,g){g=P(149417,g);for(let p=0,o=h.length;p<o;p++)g=P(h.charCodeAt(p),g);return g}e.stringHash=C;function E(h,g){return g=P(104579,g),h.reduce((p,o)=>D(o,p),g)}function I(h,g){return g=P(181387,g),Object.keys(h).sort().reduce((p,o)=>(p=C(o,p),D(h[o],p)),g)}class R{constructor(){this._value=0}get value(){return this._value}hash(g){return this._value=D(g,this._value),this._value}}e.Hasher=R;var k;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(k||(k={}));function _(h,g,p=32){const o=p-g,m=~((1<<o)-1);return(h<<g|(m&h)>>>o)>>>0}function T(h,g=0,p=h.byteLength,o=0){for(let m=0;m<p;m++)h[g+m]=o}function w(h,g,p="0"){for(;h.length<g;)h=p+h;return h}function b(h,g=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(p=>p.toString(16).padStart(2,"0")).join(""):w((h>>>0).toString(16),g/4)}e.toHexString=b;class v{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(g){const p=g.length;if(p===0)return;const o=this._buff;let m=this._buffLen,c=this._leftoverHighSurrogate,l,s;for(c!==0?(l=c,s=-1,c=0):(l=g.charCodeAt(0),s=0);;){let i=l;if(u.isHighSurrogate(l))if(s+1<p){const r=g.charCodeAt(s+1);u.isLowSurrogate(r)?(s++,i=u.computeCodePoint(l,r)):i=65533}else{c=l;break}else u.isLowSurrogate(l)&&(i=65533);if(m=this._push(o,m,i),s++,s<p)l=g.charCodeAt(s);else break}this._buffLen=m,this._leftoverHighSurrogate=c}_push(g,p,o){return o<128?g[p++]=o:o<2048?(g[p++]=192|(o&1984)>>>6,g[p++]=128|(o&63)>>>0):o<65536?(g[p++]=224|(o&61440)>>>12,g[p++]=128|(o&4032)>>>6,g[p++]=128|(o&63)>>>0):(g[p++]=240|(o&1835008)>>>18,g[p++]=128|(o&258048)>>>12,g[p++]=128|(o&4032)>>>6,g[p++]=128|(o&63)>>>0),p>=64&&(this._step(),p-=64,this._totalLen+=64,g[0]=g[64+0],g[1]=g[64+1],g[2]=g[64+2]),p}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),b(this._h0)+b(this._h1)+b(this._h2)+b(this._h3)+b(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,T(this._buff,this._buffLen),this._buffLen>56&&(this._step(),T(this._buff));const g=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(g/4294967296),!1),this._buffDV.setUint32(60,g%4294967296,!1),this._step()}_step(){const g=v._bigBlock32,p=this._buffDV;for(let a=0;a<64;a+=4)g.setUint32(a,p.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)g.setUint32(a,_(g.getUint32(a-12,!1)^g.getUint32(a-32,!1)^g.getUint32(a-56,!1)^g.getUint32(a-64,!1),1),!1);let o=this._h0,m=this._h1,c=this._h2,l=this._h3,s=this._h4,i,r,n;for(let a=0;a<80;a++)a<20?(i=m&c|~m&l,r=1518500249):a<40?(i=m^c^l,r=1859775393):a<60?(i=m&c|m&l|c&l,r=2400959708):(i=m^c^l,r=3395469782),n=_(o,5)+i+s+r+g.getUint32(a*4,!1)&4294967295,s=l,l=c,c=_(m,30),m=o,o=n;this._h0=this._h0+o&4294967295,this._h1=this._h1+m&4294967295,this._h2=this._h2+c&4294967295,this._h3=this._h3+l&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=v,v._bigBlock32=new DataView(new ArrayBuffer(320))}),define(De[25],Ie([1,0,17,8]),function(Z,e,u,t){"use strict";var D,P,y;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function C(s,i,r){let n=s.get(i);return n===void 0&&(n=r,s.set(i,n)),n}e.getOrSet=C;function E(s){const i=[];return s.forEach((r,n)=>{i.push(`${n} => ${r}`)}),`Map(${s.size}) {${i.join(", ")}}`}e.mapToString=E;function I(s){const i=[];return s.forEach(r=>{i.push(r)}),`Set(${s.size}) {${i.join(", ")}}`}e.setToString=I;class R{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const r=i.charCodeAt(0),n=this._value.charCodeAt(this._pos);return r-n}value(){return this._value[this._pos]}}e.StringIterator=R;class k{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,t.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=k;class _{constructor(i=!0,r=!0){this._splitOnBackslash=i,this._caseSensitive=r}reset(i){this._from=0,this._to=0,this._value=i,this._valueLen=i.length;for(let r=i.length-1;r>=0;r--,this._valueLen--){const n=this._value.charCodeAt(r);if(!(n===47||this._splitOnBackslash&&n===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let i=!0;for(;this._to<this._valueLen;this._to++){const r=this._value.charCodeAt(this._to);if(r===47||this._splitOnBackslash&&r===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,t.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=_;var T;(function(s){s[s.Scheme=1]="Scheme",s[s.Authority=2]="Authority",s[s.Path=3]="Path",s[s.Query=4]="Query",s[s.Fragment=5]="Fragment"})(T||(T={}));class w{constructor(i,r){this._ignorePathCasing=i,this._ignoreQueryAndFragment=r,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new _(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(i)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,t.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=w;class b{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const i=this.right;return this.right=i.left,i.left=this,this.updateHeight(),i.updateHeight(),i}rotateRight(){const i=this.left;return this.left=i.right,i.right=this,this.updateHeight(),i.updateHeight(),i}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var v;(function(s){s[s.Left=-1]="Left",s[s.Mid=0]="Mid",s[s.Right=1]="Right"})(v||(v={}));class h{constructor(i){this._iter=i}static forUris(i=()=>!1,r=()=>!1){return new h(new w(i,r))}static forPaths(i=!1){return new h(new _(void 0,!i))}static forStrings(){return new h(new R)}static forConfigKeys(){return new h(new k)}clear(){this._root=void 0}fill(i,r){if(r){const n=r.slice(0);(0,u.shuffle)(n);for(const a of n)this.set(a,i)}else{const n=i.slice(0);(0,u.shuffle)(n);for(const a of n)this.set(a[0],a[1])}}set(i,r){const n=this._iter.reset(i);let a;this._root||(this._root=new b,this._root.segment=n.value());const d=[];for(a=this._root;;){const S=n.cmp(a.segment);if(S>0)a.left||(a.left=new b,a.left.segment=n.value()),d.push([-1,a]),a=a.left;else if(S<0)a.right||(a.right=new b,a.right.segment=n.value()),d.push([1,a]),a=a.right;else if(n.hasNext())n.next(),a.mid||(a.mid=new b,a.mid.segment=n.value()),d.push([0,a]),a=a.mid;else break}const f=a.value;a.value=r,a.key=i;for(let S=d.length-1;S>=0;S--){const O=d[S][1];O.updateHeight();const U=O.balanceFactor();if(U<-1||U>1){const M=d[S][0],A=d[S+1][0];if(M===1&&A===1)d[S][1]=O.rotateLeft();else if(M===-1&&A===-1)d[S][1]=O.rotateRight();else if(M===1&&A===-1)O.right=d[S+1][1]=d[S+1][1].rotateRight(),d[S][1]=O.rotateLeft();else if(M===-1&&A===1)O.left=d[S+1][1]=d[S+1][1].rotateLeft(),d[S][1]=O.rotateRight();else throw new Error;if(S>0)switch(d[S-1][0]){case-1:d[S-1][1].left=d[S][1];break;case 1:d[S-1][1].right=d[S][1];break;case 0:d[S-1][1].mid=d[S][1];break}else this._root=d[0][1]}}return f}get(i){return this._getNode(i)?.value}_getNode(i){const r=this._iter.reset(i);let n=this._root;for(;n;){const a=r.cmp(n.segment);if(a>0)n=n.left;else if(a<0)n=n.right;else if(r.hasNext())r.next(),n=n.mid;else break}return n}has(i){const r=this._getNode(i);return!(r?.value===void 0&&r?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,r){const n=this._iter.reset(i),a=[];let d=this._root;for(;d;){const f=n.cmp(d.segment);if(f>0)a.push([-1,d]),d=d.left;else if(f<0)a.push([1,d]),d=d.right;else if(n.hasNext())n.next(),a.push([0,d]),d=d.mid;else break}if(!!d){if(r?(d.left=void 0,d.mid=void 0,d.right=void 0,d.height=1):(d.key=void 0,d.value=void 0),!d.mid&&!d.value)if(d.left&&d.right){const f=this._min(d.right),{key:S,value:O,segment:U}=f;this._delete(f.key,!1),d.key=S,d.value=O,d.segment=U}else{const f=d.left??d.right;if(a.length>0){const[S,O]=a[a.length-1];switch(S){case-1:O.left=f;break;case 0:O.mid=f;break;case 1:O.right=f;break}}else this._root=f}for(let f=a.length-1;f>=0;f--){const S=a[f][1];S.updateHeight();const O=S.balanceFactor();if(O>1?(S.right.balanceFactor()>=0||(S.right=S.right.rotateRight()),a[f][1]=S.rotateLeft()):O<-1&&(S.left.balanceFactor()<=0||(S.left=S.left.rotateLeft()),a[f][1]=S.rotateRight()),f>0)switch(a[f-1][0]){case-1:a[f-1][1].left=a[f][1];break;case 1:a[f-1][1].right=a[f][1];break;case 0:a[f-1][1].mid=a[f][1];break}else this._root=a[0][1]}}}_min(i){for(;i.left;)i=i.left;return i}findSubstr(i){const r=this._iter.reset(i);let n=this._root,a;for(;n;){const d=r.cmp(n.segment);if(d>0)n=n.left;else if(d<0)n=n.right;else if(r.hasNext())r.next(),a=n.value||a,n=n.mid;else break}return n&&n.value||a}findSuperstr(i){const r=this._iter.reset(i);let n=this._root;for(;n;){const a=r.cmp(n.segment);if(a>0)n=n.left;else if(a<0)n=n.right;else if(r.hasNext())r.next(),n=n.mid;else return n.mid?this._entries(n.mid):void 0}}forEach(i){for(const[r,n]of this)i(n,r)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(i){const r=[];return this._dfsEntries(i,r),r[Symbol.iterator]()}_dfsEntries(i,r){!i||(i.left&&this._dfsEntries(i.left,r),i.value&&r.push([i.key,i.value]),i.mid&&this._dfsEntries(i.mid,r),i.right&&this._dfsEntries(i.right,r))}_isBalanced(){const i=r=>{if(!r)return!0;const n=r.balanceFactor();return n<-1||n>1?!1:i(r.left)&&i(r.right)};return i(this._root)}}e.TernarySearchTree=h;class g{constructor(i,r){this.uri=i,this.value=r}}class p{constructor(i,r){this[D]="ResourceMap",i instanceof p?(this.map=new Map(i.map),this.toKey=r??p.defaultToKey):(this.map=new Map,this.toKey=i??p.defaultToKey)}set(i,r){return this.map.set(this.toKey(i),new g(i,r)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,r){typeof r!="undefined"&&(i=i.bind(r));for(const[n,a]of this.map)i(a.value,a.uri,this)}*values(){for(const i of this.map.values())yield i.value}*keys(){for(const i of this.map.values())yield i.uri}*entries(){for(const i of this.map.values())yield[i.uri,i.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(const[,i]of this.map)yield[i.uri,i.value]}}e.ResourceMap=p,p.defaultToKey=s=>s.toString();class o{constructor(i,r){this[P]="ResourceSet",!i||typeof i=="function"?this._map=new p(i):(this._map=new p(r),i.forEach(this.add,this))}get size(){return this._map.size}add(i){return this._map.set(i,i),this}clear(){this._map.clear()}delete(i){return this._map.delete(i)}forEach(i,r){this._map.forEach((n,a)=>i.call(r,a,a,this))}has(i){return this._map.has(i)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=o;var m;(function(s){s[s.None=0]="None",s[s.AsOld=1]="AsOld",s[s.AsNew=2]="AsNew"})(m=e.Touch||(e.Touch={}));class c{constructor(){this[y]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,r=0){const n=this._map.get(i);if(!!n)return r!==0&&this.touch(n,r),n.value}set(i,r,n=0){let a=this._map.get(i);if(a)a.value=r,n!==0&&this.touch(a,n);else{switch(a={key:i,value:r,next:void 0,previous:void 0},n){case 0:this.addItemLast(a);break;case 1:this.addItemFirst(a);break;case 2:this.addItemLast(a);break;default:this.addItemLast(a);break}this._map.set(i,a),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const r=this._map.get(i);if(!!r)return this._map.delete(i),this.removeItem(r),this._size--,r.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,r){const n=this._state;let a=this._head;for(;a;){if(r?i.bind(r)(a.value,a.key,this):i(a.value,a.key,this),this._state!==n)throw new Error("LinkedMap got modified during iteration.");a=a.next}}keys(){const i=this,r=this._state;let n=this._head;const a={[Symbol.iterator](){return a},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(n){const d={value:n.key,done:!1};return n=n.next,d}else return{value:void 0,done:!0}}};return a}values(){const i=this,r=this._state;let n=this._head;const a={[Symbol.iterator](){return a},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(n){const d={value:n.value,done:!1};return n=n.next,d}else return{value:void 0,done:!0}}};return a}entries(){const i=this,r=this._state;let n=this._head;const a={[Symbol.iterator](){return a},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(n){const d={value:[n.key,n.value],done:!1};return n=n.next,d}else return{value:void 0,done:!0}}};return a}[(y=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let r=this._head,n=this.size;for(;r&&n>i;)this._map.delete(r.key),r=r.next,n--;this._head=r,this._size=n,r&&(r.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const r=i.next,n=i.previous;if(!r||!n)throw new Error("Invalid list");r.previous=n,n.next=r}i.next=void 0,i.previous=void 0,this._state++}touch(i,r){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(i===this._head)return;const n=i.next,a=i.previous;i===this._tail?(a.next=void 0,this._tail=a):(n.previous=a,a.next=n),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(r===2){if(i===this._tail)return;const n=i.next,a=i.previous;i===this._head?(n.previous=void 0,this._head=n):(n.previous=a,a.next=n),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((r,n)=>{i.push([n,r])}),i}fromJSON(i){this.clear();for(const[r,n]of i)this.set(r,n)}}e.LinkedMap=c;class l extends c{constructor(i,r=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,r),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,r=2){return super.get(i,r)}peek(i){return super.get(i,0)}set(i,r){return super.set(i,r,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=l}),define(De[102],Ie([1,0,25,8]),function(Z,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function D(...ee){return function(re,F){for(let W=0,G=ee.length;W<G;W++){const Q=ee[W](re,F);if(Q)return Q}return null}}e.or=D,e.matchesStrictPrefix=P.bind(void 0,!1),e.matchesPrefix=P.bind(void 0,!0);function P(ee,re,F){if(!F||F.length<re.length)return null;let W;return ee?W=t.startsWithIgnoreCase(F,re):W=F.indexOf(re)===0,W?re.length>0?[{start:0,end:re.length}]:[]:null}function y(ee,re){const F=re.toLowerCase().indexOf(ee.toLowerCase());return F===-1?null:[{start:F,end:F+ee.length}]}e.matchesContiguousSubString=y;function C(ee,re){return E(ee.toLowerCase(),re.toLowerCase(),0,0)}e.matchesSubString=C;function E(ee,re,F,W){if(F===ee.length)return[];if(W===re.length)return null;if(ee[F]===re[W]){let G=null;return(G=E(ee,re,F+1,W+1))?h({start:W,end:W+1},G):null}return E(ee,re,F,W+1)}function I(ee){return 97<=ee&&ee<=122}function R(ee){return 65<=ee&&ee<=90}e.isUpper=R;function k(ee){return 48<=ee&&ee<=57}function _(ee){return ee===32||ee===9||ee===10||ee===13}const T=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ee=>T.add(ee.charCodeAt(0)));function w(ee){return _(ee)||T.has(ee)}function b(ee,re){return ee===re||w(ee)&&w(re)}function v(ee){return I(ee)||R(ee)||k(ee)}function h(ee,re){return re.length===0?re=[ee]:ee.end===re[0].start?re[0].start=ee.start:re.unshift(ee),re}function g(ee,re){for(let F=re;F<ee.length;F++){const W=ee.charCodeAt(F);if(R(W)||k(W)||F>0&&!v(ee.charCodeAt(F-1)))return F}return ee.length}function p(ee,re,F,W){if(F===ee.length)return[];if(W===re.length)return null;if(ee[F]!==re[W].toLowerCase())return null;{let G=null,Q=W+1;for(G=p(ee,re,F+1,W+1);!G&&(Q=g(re,Q))<re.length;)G=p(ee,re,F+1,Q),Q++;return G===null?null:h({start:W,end:W+1},G)}}function o(ee){let re=0,F=0,W=0,G=0,Q=0;for(let Se=0;Se<ee.length;Se++)Q=ee.charCodeAt(Se),R(Q)&&re++,I(Q)&&F++,v(Q)&&W++,k(Q)&&G++;const fe=re/ee.length,be=F/ee.length,ue=W/ee.length,Ce=G/ee.length;return{upperPercent:fe,lowerPercent:be,alphaPercent:ue,numericPercent:Ce}}function m(ee){const{upperPercent:re,lowerPercent:F}=ee;return F===0&&re>.6}function c(ee){const{upperPercent:re,lowerPercent:F,alphaPercent:W,numericPercent:G}=ee;return F>.2&&re<.8&&W>.6&&G<.2}function l(ee){let re=0,F=0,W=0,G=0;for(let Q=0;Q<ee.length;Q++)W=ee.charCodeAt(Q),R(W)&&re++,I(W)&&F++,_(W)&&G++;return(re===0||F===0)&&G===0?ee.length<=30:re<=5}function s(ee,re){if(!re||(re=re.trim(),re.length===0)||!l(ee)||re.length>60)return null;const F=o(re);if(!c(F)){if(!m(F))return null;re=re.toLowerCase()}let W=null,G=0;for(ee=ee.toLowerCase();G<re.length&&(W=p(ee,re,0,G))===null;)G=g(re,G+1);return W}e.matchesCamelCase=s;function i(ee,re,F=!1){if(!re||re.length===0)return null;let W=null,G=0;for(ee=ee.toLowerCase(),re=re.toLowerCase();G<re.length&&(W=r(ee,re,0,G,F))===null;)G=n(re,G+1);return W}e.matchesWords=i;function r(ee,re,F,W,G){if(F===ee.length)return[];if(W===re.length)return null;if(b(ee.charCodeAt(F),re.charCodeAt(W))){let Q=null,fe=W+1;if(Q=r(ee,re,F+1,W+1,G),!G)for(;!Q&&(fe=n(re,fe))<re.length;)Q=r(ee,re,F+1,fe,G),fe++;return Q?ee.charCodeAt(F)!==re.charCodeAt(W)?Q:h({start:W,end:W+1},Q):null}else return null}function n(ee,re){for(let F=re;F<ee.length;F++)if(w(ee.charCodeAt(F))||F>0&&w(ee.charCodeAt(F-1)))return F;return ee.length}const a=D(e.matchesPrefix,s,y),d=D(e.matchesPrefix,s,C),f=new u.LRUCache(1e4);function S(ee,re,F=!1){if(typeof ee!="string"||typeof re!="string")return null;let W=f.get(ee);W||(W=new RegExp(t.convertSimple2RegExpPattern(ee),"i"),f.set(ee,W));const G=W.exec(re);return G?[{start:G.index,end:G.index+G[0].length}]:F?d(ee,re):a(ee,re)}e.matchesFuzzy=S;function O(ee,re){const F=Oe(ee,ee.toLowerCase(),0,re,re.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return F?M(F):null}e.matchesFuzzy2=O;function U(ee,re,F,W,G,Q){const fe=Math.min(13,ee.length);for(;F<fe;F++){const be=Oe(ee,re,F,W,G,Q,{firstMatchCanBeWeak:!1,boostFullMatch:!0});if(be)return be}return[0,Q]}e.anyScore=U;function M(ee){if(typeof ee=="undefined")return[];const re=[],F=ee[1];for(let W=ee.length-1;W>1;W--){const G=ee[W]+F,Q=re[re.length-1];Q&&Q.end===G?Q.end=G+1:re.push({start:G,end:G+1})}return re}e.createMatches=M;const A=128;function B(){const ee=[],re=[];for(let F=0;F<=A;F++)re[F]=0;for(let F=0;F<=A;F++)ee.push(re.slice(0));return ee}function x(ee){const re=[];for(let F=0;F<=ee;F++)re[F]=0;return re}const N=x(2*A),K=x(2*A),X=B(),L=B(),$=B(),H=!1;function j(ee,re,F,W,G){function Q(be,ue,Ce=" "){for(;be.length<ue;)be=Ce+be;return be}let fe=` |   |${W.split("").map(be=>Q(be,3)).join("|")}
`;for(let be=0;be<=F;be++)be===0?fe+=" |":fe+=`${re[be-1]}|`,fe+=ee[be].slice(0,G+1).map(ue=>Q(ue.toString(),3)).join("|")+`
`;return fe}function J(ee,re,F,W){ee=ee.substr(re),F=F.substr(W),console.log(j(L,ee,ee.length,F,F.length)),console.log(j($,ee,ee.length,F,F.length)),console.log(j(X,ee,ee.length,F,F.length))}function Y(ee,re){if(re<0||re>=ee.length)return!1;const F=ee.codePointAt(re);switch(F){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!t.isEmojiImprecise(F)}}function he(ee,re){if(re<0||re>=ee.length)return!1;switch(ee.charCodeAt(re)){case 32:case 9:return!0;default:return!1}}function ve(ee,re,F){return re[ee]!==F[ee]}function ne(ee,re,F,W,G,Q,fe=!1){for(;re<F&&G<Q;)ee[re]===W[G]&&(fe&&(N[re]=G),re+=1),G+=1;return re===F}e.isPatternInWord=ne;var pe;(function(ee){ee[ee.Diag=1]="Diag",ee[ee.Left=2]="Left",ee[ee.LeftLeft=3]="LeftLeft"})(pe||(pe={}));var Ee;(function(ee){ee.Default=[-100,0];function re(F){return!F||F.length===2&&F[0]===-100&&F[1]===0}ee.isDefault=re})(Ee=e.FuzzyScore||(e.FuzzyScore={}));class ke{constructor(re,F){this.firstMatchCanBeWeak=re,this.boostFullMatch=F}}e.FuzzyScoreOptions=ke,ke.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function Oe(ee,re,F,W,G,Q,fe=ke.default){const be=ee.length>A?A:ee.length,ue=W.length>A?A:W.length;if(F>=be||Q>=ue||be-F>ue-Q||!ne(re,F,be,G,Q,ue,!0))return;Be(be,ue,F,Q,re,G);let Ce=1,Se=1,Ue=F,qe=Q;const Je=[!1];for(Ce=1,Ue=F;Ue<be;Ce++,Ue++){const oe=N[Ue],q=K[Ue],ye=Ue+1<be?K[Ue+1]:ue;for(Se=oe-Q+1,qe=oe;qe<ye;Se++,qe++){let Ae=Number.MIN_SAFE_INTEGER,We=!1;qe<=q&&(Ae=ae(ee,re,Ue,F,W,G,qe,ue,Q,X[Ce-1][Se-1]===0,Je));let ze=0;Ae!==Number.MAX_SAFE_INTEGER&&(We=!0,ze=Ae+L[Ce-1][Se-1]);const $e=qe>oe,Ze=$e?L[Ce][Se-1]+(X[Ce][Se-1]>0?-5:0):0,it=qe>oe+1&&X[Ce][Se-1]>0,lt=it?L[Ce][Se-2]+(X[Ce][Se-2]>0?-5:0):0;if(it&&(!$e||lt>=Ze)&&(!We||lt>=ze))L[Ce][Se]=lt,$[Ce][Se]=3,X[Ce][Se]=0;else if($e&&(!We||Ze>=ze))L[Ce][Se]=Ze,$[Ce][Se]=2,X[Ce][Se]=0;else if(We)L[Ce][Se]=ze,$[Ce][Se]=1,X[Ce][Se]=X[Ce-1][Se-1]+1;else throw new Error("not possible")}}if(H&&J(ee,F,W,Q),!Je[0]&&!fe.firstMatchCanBeWeak)return;Ce--,Se--;const Qe=[L[Ce][Se],Q];let Re=0,st=0;for(;Ce>=1;){let oe=Se;do{const q=$[Ce][oe];if(q===3)oe=oe-2;else if(q===2)oe=oe-1;else break}while(oe>=1);Re>1&&re[F+Ce-1]===G[Q+Se-1]&&!ve(oe+Q-1,W,G)&&Re+1>X[Ce][oe]&&(oe=Se),oe===Se?Re++:Re=1,st||(st=oe),Ce--,Se=oe-1,Qe.push(Se)}ue===be&&fe.boostFullMatch&&(Qe[0]+=2);const se=st-be;return Qe[0]-=se,Qe}e.fuzzyScore=Oe;function Be(ee,re,F,W,G,Q){let fe=ee-1,be=re-1;for(;fe>=F&&be>=W;)G[fe]===Q[be]&&(K[fe]=be,fe--),be--}function ae(ee,re,F,W,G,Q,fe,be,ue,Ce,Se){if(re[F]!==Q[fe])return Number.MIN_SAFE_INTEGER;let Ue=1,qe=!1;return fe===F-W?Ue=ee[F]===G[fe]?7:5:ve(fe,G,Q)&&(fe===0||!ve(fe-1,G,Q))?(Ue=ee[F]===G[fe]?7:5,qe=!0):Y(Q,fe)&&(fe===0||!Y(Q,fe-1))?Ue=5:(Y(Q,fe-1)||he(Q,fe-1))&&(Ue=5,qe=!0),Ue>1&&F===W&&(Se[0]=!0),qe||(qe=ve(fe,G,Q)||Y(Q,fe-1)||he(Q,fe-1)),F===W?fe>ue&&(Ue-=qe?3:5):Ce?Ue+=qe?2:0:Ue+=qe?0:1,fe+1===be&&(Ue-=qe?3:5),Ue}function de(ee,re,F,W,G,Q,fe){return te(ee,re,F,W,G,Q,!0,fe)}e.fuzzyScoreGracefulAggressive=de;function me(ee,re,F,W,G,Q,fe){return te(ee,re,F,W,G,Q,!1,fe)}e.fuzzyScoreGraceful=me;function te(ee,re,F,W,G,Q,fe,be){let ue=Oe(ee,re,F,W,G,Q,be);if(ue&&!fe)return ue;if(ee.length>=3){const Ce=Math.min(7,ee.length-1);for(let Se=F+1;Se<Ce;Se++){const Ue=le(ee,Se);if(Ue){const qe=Oe(Ue,Ue.toLowerCase(),F,W,G,Q,be);qe&&(qe[0]-=3,(!ue||qe[0]>ue[0])&&(ue=qe))}}}return ue}function le(ee,re){if(re+1>=ee.length)return;const F=ee[re],W=ee[re+1];if(F!==W)return ee.slice(0,re)+W+F+ee.slice(re+2)}}),define(De[155],Ie([1,0,76,102,8]),function(Z,e,u,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const P=new RegExp(`\\$\\(${u.CSSIcon.iconNameExpression}(?:${u.CSSIcon.iconModifierExpression})?\\)`,"g"),y=new RegExp(u.CSSIcon.iconNameCharacter),C=new RegExp(`(\\\\)?${P.source}`,"g");function E(v){return v.replace(C,(h,g)=>g?h:`\\${h}`)}e.escapeIcons=E;const I=new RegExp(`\\\\${P.source}`,"g");function R(v){return v.replace(I,h=>`\\${h}`)}e.markdownEscapeEscapedIcons=R;const k=new RegExp(`(\\s)?(\\\\)?${P.source}(\\s)?`,"g");function _(v){return v.indexOf(e.iconStartMarker)===-1?v:v.replace(k,(h,g,p,o)=>p?h:g||o||"")}e.stripIcons=_;function T(v){const h=v.indexOf(e.iconStartMarker);return h===-1?{text:v}:w(v,h)}e.parseLabelWithIcons=T;function w(v,h){const g=[];let p="";function o(a){if(a){p+=a;for(const d of a)g.push(l)}}let m=-1,c="",l=0,s,i,r=h;const n=v.length;for(o(v.substr(0,h));r<n;)s=v[r],i=v[r+1],s===e.iconStartMarker[0]&&i===e.iconStartMarker[1]?(m=r,o(c),c=e.iconStartMarker,r++):s===")"&&m!==-1?(l+=r-m+1,m=-1,c=""):m!==-1?y.test(s)?c+=s:(o(c),m=-1,c=""):o(s),r++;return o(c),{text:p,iconOffsets:g}}function b(v,h,g=!1){const{text:p,iconOffsets:o}=h;if(!o||o.length===0)return(0,t.matchesFuzzy)(v,p,g);const m=(0,D.ltrim)(p," "),c=p.length-m.length,l=(0,t.matchesFuzzy)(v,m,g);if(l)for(const s of l){const i=o[s.start+c]+c;s.start+=i,s.end+=i}return l}e.matchesFuzzyIconAware=b}),define(De[80],Ie([1,0,25]),function(Z,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new u.LRUCache(1e4);function D(I){return E(I,"NFC",t)}e.normalizeNFC=D;const P=new u.LRUCache(1e4);function y(I){return E(I,"NFD",P)}e.normalizeNFD=y;const C=/[^\u0000-\u0080]/;function E(I,R,k){if(!I)return I;const _=k.get(I);if(_)return _;let T;return C.test(I)?T=I.normalize(R):T=I,k.set(I,T),T}e.removeAccents=function(){const I=/[\u0300-\u036f]/g;return function(R){return y(R).replace(I,"")}}()}),define(De[41],Ie([1,0,8]),function(Z,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(D){D[D.Ignore=0]="Ignore",D[D.Info=1]="Info",D[D.Warning=2]="Warning",D[D.Error=3]="Error"})(t||(t={})),function(D){const P="error",y="warning",C="warn",E="info",I="ignore";function R(_){return _?u.equalsIgnoreCase(P,_)?D.Error:u.equalsIgnoreCase(y,_)||u.equalsIgnoreCase(C,_)?D.Warning:u.equalsIgnoreCase(E,_)?D.Info:D.Ignore:D.Ignore}D.fromValue=R;function k(_){switch(_){case D.Error:return P;case D.Warning:return y;case D.Info:return E;default:return I}}D.toString=k}(t||(t={})),e.default=t}),define(De[2],Ie([1,0,9,11]),function(Z,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,P=/^\//,y=/^\/\//;function C(s,i){if(!s.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!D.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!P.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(y.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function E(s,i){return!s&&!i?"file":s}function I(s,i){switch(s){case"https":case"http":case"file":i?i[0]!==k&&(i=k+i):i=k;break}return i}const R="",k="/",_=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class T{constructor(i,r,n,a,d,f=!1){typeof i=="object"?(this.scheme=i.scheme||R,this.authority=i.authority||R,this.path=i.path||R,this.query=i.query||R,this.fragment=i.fragment||R):(this.scheme=E(i,f),this.authority=r||R,this.path=I(this.scheme,n||R),this.query=a||R,this.fragment=d||R,C(this,f))}static isUri(i){return i instanceof T?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}get fsPath(){return p(this,!1)}with(i){if(!i)return this;let{scheme:r,authority:n,path:a,query:d,fragment:f}=i;return r===void 0?r=this.scheme:r===null&&(r=R),n===void 0?n=this.authority:n===null&&(n=R),a===void 0?a=this.path:a===null&&(a=R),d===void 0?d=this.query:d===null&&(d=R),f===void 0?f=this.fragment:f===null&&(f=R),r===this.scheme&&n===this.authority&&a===this.path&&d===this.query&&f===this.fragment?this:new b(r,n,a,d,f)}static parse(i,r=!1){const n=_.exec(i);return n?new b(n[2]||R,l(n[4]||R),l(n[5]||R),l(n[7]||R),l(n[9]||R),r):new b(R,R,R,R,R)}static file(i){let r=R;if(t.isWindows&&(i=i.replace(/\\/g,k)),i[0]===k&&i[1]===k){const n=i.indexOf(k,2);n===-1?(r=i.substring(2),i=k):(r=i.substring(2,n),i=i.substring(n)||k)}return new b("file",r,i,R,R)}static from(i){const r=new b(i.scheme,i.authority,i.path,i.query,i.fragment);return C(r,!0),r}static joinPath(i,...r){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let n;return t.isWindows&&i.scheme==="file"?n=T.file(u.win32.join(p(i,!0),...r)).path:n=u.posix.join(i.path,...r),i.with({path:n})}toString(i=!1){return o(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof T)return i;{const r=new b(i);return r._formatted=i.external,r._fsPath=i._sep===w?i.fsPath:null,r}}else return i}}e.URI=T;const w=t.isWindows?1:void 0;class b extends T{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=p(this,!1)),this._fsPath}toString(i=!1){return i?o(this,!0):(this._formatted||(this._formatted=o(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=w),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const v={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function h(s,i){let r,n=-1;for(let a=0;a<s.length;a++){const d=s.charCodeAt(a);if(d>=97&&d<=122||d>=65&&d<=90||d>=48&&d<=57||d===45||d===46||d===95||d===126||i&&d===47)n!==-1&&(r+=encodeURIComponent(s.substring(n,a)),n=-1),r!==void 0&&(r+=s.charAt(a));else{r===void 0&&(r=s.substr(0,a));const f=v[d];f!==void 0?(n!==-1&&(r+=encodeURIComponent(s.substring(n,a)),n=-1),r+=f):n===-1&&(n=a)}}return n!==-1&&(r+=encodeURIComponent(s.substring(n))),r!==void 0?r:s}function g(s){let i;for(let r=0;r<s.length;r++){const n=s.charCodeAt(r);n===35||n===63?(i===void 0&&(i=s.substr(0,r)),i+=v[n]):i!==void 0&&(i+=s[r])}return i!==void 0?i:s}function p(s,i){let r;return s.authority&&s.path.length>1&&s.scheme==="file"?r=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?i?r=s.path.substr(1):r=s.path[1].toLowerCase()+s.path.substr(2):r=s.path,t.isWindows&&(r=r.replace(/\//g,"\\")),r}e.uriToFsPath=p;function o(s,i){const r=i?g:h;let n="",{scheme:a,authority:d,path:f,query:S,fragment:O}=s;if(a&&(n+=a,n+=":"),(d||a==="file")&&(n+=k,n+=k),d){let U=d.indexOf("@");if(U!==-1){const M=d.substr(0,U);d=d.substr(U+1),U=M.indexOf(":"),U===-1?n+=r(M,!1):(n+=r(M.substr(0,U),!1),n+=":",n+=r(M.substr(U+1),!1)),n+="@"}d=d.toLowerCase(),U=d.indexOf(":"),U===-1?n+=r(d,!1):(n+=r(d.substr(0,U),!1),n+=d.substr(U))}if(f){if(f.length>=3&&f.charCodeAt(0)===47&&f.charCodeAt(2)===58){const U=f.charCodeAt(1);U>=65&&U<=90&&(f=`/${String.fromCharCode(U+32)}:${f.substr(3)}`)}else if(f.length>=2&&f.charCodeAt(1)===58){const U=f.charCodeAt(0);U>=65&&U<=90&&(f=`${String.fromCharCode(U+32)}:${f.substr(2)}`)}n+=r(f,!0)}return S&&(n+="?",n+=r(S,!1)),O&&(n+="#",n+=i?O:h(O,!1)),n}function m(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+m(s.substr(3)):s}}const c=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function l(s){return s.match(c)?s.replace(c,i=>m(i)):s}}),define(De[61],Ie([1,0,23,8,2]),function(Z,e,u,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function P(I){return JSON.stringify(I,C)}e.stringify=P;function y(I){let R=JSON.parse(I);return R=E(R),R}e.parse=y;function C(I,R){return R instanceof RegExp?{$mid:2,source:R.source,flags:(0,t.regExpFlags)(R)}:R}function E(I,R=0){if(!I||R>200)return I;if(typeof I=="object"){switch(I.$mid){case 1:return D.URI.revive(I);case 2:return new RegExp(I.source,I.flags);case 14:return new Date(I.source)}if(I instanceof u.VSBuffer||I instanceof Uint8Array)return I;if(Array.isArray(I))for(let k=0;k<I.length;++k)I[k]=E(I[k],R+1);else for(const k in I)Object.hasOwnProperty.call(I,k)&&(I[k]=E(I[k],R+1))}return I}e.revive=E}),define(De[12],Ie([1,0,11,2]),function(Z,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var D;(function(C){C.inMemory="inmemory",C.vscode="vscode",C.internal="private",C.walkThrough="walkThrough",C.walkThroughSnippet="walkThroughSnippet",C.http="http",C.https="https",C.file="file",C.mailto="mailto",C.untitled="untitled",C.data="data",C.command="command",C.vscodeRemote="vscode-remote",C.vscodeRemoteResource="vscode-remote-resource",C.vscodeUserData="vscode-userdata",C.vscodeCustomEditor="vscode-custom-editor",C.vscodeNotebook="vscode-notebook",C.vscodeNotebookCell="vscode-notebook-cell",C.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",C.vscodeNotebookCellOutput="vscode-notebook-cell-output",C.vscodeInteractive="vscode-interactive",C.vscodeInteractiveInput="vscode-interactive-input",C.vscodeSettings="vscode-settings",C.vscodeWorkspaceTrust="vscode-workspace-trust",C.vscodeTerminal="vscode-terminal",C.webviewPanel="webview-panel",C.vscodeWebview="vscode-webview",C.extension="extension",C.vscodeFileResource="vscode-file",C.tmp="tmp",C.vsls="vsls",C.vscodeSourceControl="vscode-scm"})(D=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class P{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${D.vscodeRemoteResource}`}setPreferredWebSchema(E){this._preferredWebSchema=E}setDelegate(E){this._delegate=E}setServerRootPath(E){this._remoteResourcesPath=`${E}/${D.vscodeRemoteResource}`}set(E,I,R){this._hosts[E]=I,this._ports[E]=R}setConnectionToken(E,I){this._connectionTokens[E]=I}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(E){if(this._delegate)return this._delegate(E);const I=E.authority;let R=this._hosts[I];R&&R.indexOf(":")!==-1&&(R=`[${R}]`);const k=this._ports[I],_=this._connectionTokens[I];let T=`path=${encodeURIComponent(E.path)}`;return typeof _=="string"&&(T+=`&${e.connectionTokenQueryName}=${encodeURIComponent(_)}`),t.URI.from({scheme:u.isWeb?this._preferredWebSchema:D.vscodeRemoteResource,authority:`${R}:${k}`,path:this._remoteResourcesPath,query:T})}}e.RemoteAuthorities=new P;class y{asBrowserUri(E,I){const R=this.toUri(E,I);return R.scheme===D.vscodeRemote?e.RemoteAuthorities.rewrite(R):R.scheme===D.file&&(u.isNative||u.isWebWorker&&u.globals.origin===`${D.vscodeFileResource}://${y.FALLBACK_AUTHORITY}`)?R.with({scheme:D.vscodeFileResource,authority:R.authority||y.FALLBACK_AUTHORITY,query:null,fragment:null}):R}asFileUri(E,I){const R=this.toUri(E,I);return R.scheme===D.vscodeFileResource?R.with({scheme:D.file,authority:R.authority!==y.FALLBACK_AUTHORITY?R.authority:null,query:null,fragment:null}):R}toUri(E,I){return t.URI.isUri(E)?E:t.URI.parse(I.toUrl(E))}}y.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new y}),define(De[22],Ie([1,0,31,12,9,11,8,2]),function(Z,e,u,t,D,P,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function E(T){return(0,C.uriToFsPath)(T,!0)}e.originalFSPath=E;class I{constructor(w){this._ignorePathCasing=w}compare(w,b,v=!1){return w===b?0:(0,y.compare)(this.getComparisonKey(w,v),this.getComparisonKey(b,v))}isEqual(w,b,v=!1){return w===b?!0:!w||!b?!1:this.getComparisonKey(w,v)===this.getComparisonKey(b,v)}getComparisonKey(w,b=!1){return w.with({path:this._ignorePathCasing(w)?w.path.toLowerCase():void 0,fragment:b?null:void 0}).toString()}ignorePathCasing(w){return this._ignorePathCasing(w)}isEqualOrParent(w,b,v=!1){if(w.scheme===b.scheme){if(w.scheme===t.Schemas.file)return u.isEqualOrParent(E(w),E(b),this._ignorePathCasing(w))&&w.query===b.query&&(v||w.fragment===b.fragment);if((0,e.isEqualAuthority)(w.authority,b.authority))return u.isEqualOrParent(w.path,b.path,this._ignorePathCasing(w),"/")&&w.query===b.query&&(v||w.fragment===b.fragment)}return!1}joinPath(w,...b){return C.URI.joinPath(w,...b)}basenameOrAuthority(w){return(0,e.basename)(w)||w.authority}basename(w){return D.posix.basename(w.path)}extname(w){return D.posix.extname(w.path)}dirname(w){if(w.path.length===0)return w;let b;return w.scheme===t.Schemas.file?b=C.URI.file(D.dirname(E(w))).path:(b=D.posix.dirname(w.path),w.authority&&b.length&&b.charCodeAt(0)!==47&&(console.error(`dirname("${w.toString})) resulted in a relative path`),b="/")),w.with({path:b})}normalizePath(w){if(!w.path.length)return w;let b;return w.scheme===t.Schemas.file?b=C.URI.file(D.normalize(E(w))).path:b=D.posix.normalize(w.path),w.with({path:b})}relativePath(w,b){if(w.scheme!==b.scheme||!(0,e.isEqualAuthority)(w.authority,b.authority))return;if(w.scheme===t.Schemas.file){const g=D.relative(E(w),E(b));return P.isWindows?u.toSlashes(g):g}let v=w.path||"/";const h=b.path||"/";if(this._ignorePathCasing(w)){let g=0;for(const p=Math.min(v.length,h.length);g<p&&!(v.charCodeAt(g)!==h.charCodeAt(g)&&v.charAt(g).toLowerCase()!==h.charAt(g).toLowerCase());g++);v=h.substr(0,g)+v.substr(g)}return D.posix.relative(v,h)}resolvePath(w,b){if(w.scheme===t.Schemas.file){const v=C.URI.file(D.resolve(E(w),b));return w.with({authority:v.authority,path:v.path})}return b=u.toPosixPath(b),w.with({path:D.posix.resolve(w.path,b)})}isAbsolutePath(w){return!!w.path&&w.path[0]==="/"}isEqualAuthority(w,b){return w===b||w!==void 0&&b!==void 0&&(0,y.equalsIgnoreCase)(w,b)}hasTrailingPathSeparator(w,b=D.sep){if(w.scheme===t.Schemas.file){const v=E(w);return v.length>u.getRoot(v).length&&v[v.length-1]===b}else{const v=w.path;return v.length>1&&v.charCodeAt(v.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(w.fsPath)}}removeTrailingPathSeparator(w,b=D.sep){return(0,e.hasTrailingPathSeparator)(w,b)?w.with({path:w.path.substr(0,w.path.length-1)}):w}addTrailingPathSeparator(w,b=D.sep){let v=!1;if(w.scheme===t.Schemas.file){const h=E(w);v=h!==void 0&&h.length===u.getRoot(h).length&&h[h.length-1]===b}else{b="/";const h=w.path;v=h.length===1&&h.charCodeAt(h.length-1)===47}return!v&&!(0,e.hasTrailingPathSeparator)(w,b)?w.with({path:w.path+"/"}):w}}e.ExtUri=I,e.extUri=new I(()=>!1),e.extUriBiasedIgnorePathCase=new I(T=>T.scheme===t.Schemas.file?!P.isLinux:!0),e.extUriIgnorePathCase=new I(T=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function R(T,w){const b=[];for(let v=0;v<T.length;v++){const h=w(T[v]);T.some((g,p)=>p===v?!1:(0,e.isEqualOrParent)(h,w(g)))||b.push(T[v])}return b}e.distinctParents=R;var k;(function(T){T.META_DATA_LABEL="label",T.META_DATA_DESCRIPTION="description",T.META_DATA_SIZE="size",T.META_DATA_MIME="mime";function w(b){const v=new Map;b.path.substring(b.path.indexOf(";")+1,b.path.lastIndexOf(";")).split(";").forEach(p=>{const[o,m]=p.split(":");o&&m&&v.set(o,m)});const g=b.path.substring(0,b.path.indexOf(";"));return g&&v.set(T.META_DATA_MIME,g),v}T.parseMetaData=w})(k=e.DataUri||(e.DataUri={}));function _(T,w,b){if(w){let v=T.path;return v&&v[0]!==D.posix.sep&&(v=D.posix.sep+v),T.with({scheme:b,authority:w,path:v})}return T.with({scheme:b})}e.toLocalResource=_}),define(De[18],Ie([1,0,21,10,4,6,22,11]),function(Z,e,u,t,D,P,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function E(ve){return!!ve&&typeof ve.then=="function"}e.isThenable=E;function I(ve){const ne=new u.CancellationTokenSource,pe=ve(ne.token),Ee=new Promise((ke,Oe)=>{const Be=ne.token.onCancellationRequested(()=>{Be.dispose(),ne.dispose(),Oe(new t.CancellationError)});Promise.resolve(pe).then(ae=>{Be.dispose(),ne.dispose(),ke(ae)},ae=>{Be.dispose(),ne.dispose(),Oe(ae)})});return new class{cancel(){ne.cancel()}then(ke,Oe){return Ee.then(ke,Oe)}catch(ke){return this.then(void 0,ke)}finally(ke){return Ee.finally(ke)}}}e.createCancelablePromise=I;function R(ve,ne,pe){return new Promise((Ee,ke)=>{const Oe=ne.onCancellationRequested(()=>{Oe.dispose(),Ee(pe)});ve.then(Ee,ke).finally(()=>Oe.dispose())})}e.raceCancellation=R;function k(ve,ne){return new Promise((pe,Ee)=>{const ke=ne.onCancellationRequested(()=>{ke.dispose(),Ee(new t.CancellationError)});ve.then(pe,Ee).finally(()=>ke.dispose())})}e.raceCancellationError=k;async function _(ve){let ne=-1;const pe=ve.map((ke,Oe)=>ke.then(Be=>(ne=Oe,Be))),Ee=await Promise.race(pe);return ve.forEach((ke,Oe)=>{Oe!==ne&&ke.cancel()}),Ee}e.raceCancellablePromises=_;function T(ve,ne,pe){let Ee;const ke=setTimeout(()=>{Ee?.(void 0),pe?.()},ne);return Promise.race([ve.finally(()=>clearTimeout(ke)),new Promise(Oe=>Ee=Oe)])}e.raceTimeout=T;function w(ve){return new Promise((ne,pe)=>{const Ee=ve();E(Ee)?Ee.then(ne,pe):ne(Ee)})}e.asPromise=w;class b{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(ne){if(this.activePromise){if(this.queuedPromiseFactory=ne,!this.queuedPromise){const pe=()=>{this.queuedPromise=null;const Ee=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,Ee};this.queuedPromise=new Promise(Ee=>{this.activePromise.then(pe,pe).then(Ee)})}return new Promise((pe,Ee)=>{this.queuedPromise.then(pe,Ee)})}return this.activePromise=ne(),new Promise((pe,Ee)=>{this.activePromise.then(ke=>{this.activePromise=null,pe(ke)},ke=>{this.activePromise=null,Ee(ke)})})}}e.Throttler=b;class v{constructor(){this.current=Promise.resolve(null)}queue(ne){return this.current=this.current.then(()=>ne(),()=>ne())}}e.Sequencer=v;class h{constructor(){this.promiseMap=new Map}queue(ne,pe){const ke=(this.promiseMap.get(ne)??Promise.resolve()).catch(()=>{}).then(pe).finally(()=>{this.promiseMap.get(ne)===ke&&this.promiseMap.delete(ne)});return this.promiseMap.set(ne,ke),ke}}e.SequencerByKey=h;const g=(ve,ne)=>{let pe=!0;const Ee=setTimeout(()=>{pe=!1,ne()},ve);return{isTriggered:()=>pe,dispose:()=>{clearTimeout(Ee),pe=!1}}},p=ve=>{let ne=!0;return queueMicrotask(()=>{ne&&(ne=!1,ve())}),{isTriggered:()=>ne,dispose:()=>{ne=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class o{constructor(ne){this.defaultDelay=ne,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(ne,pe=this.defaultDelay){this.task=ne,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((ke,Oe)=>{this.doResolve=ke,this.doReject=Oe}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const ke=this.task;return this.task=null,ke()}}));const Ee=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=pe===e.MicrotaskDelay?p(Ee):g(pe,Ee),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=o;class m{constructor(ne){this.delayer=new o(ne),this.throttler=new b}trigger(ne,pe){return this.delayer.trigger(()=>this.throttler.queue(ne),pe)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=m;class c{constructor(){this._isOpen=!1,this._promise=new Promise((ne,pe)=>{this._completePromise=ne})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=c;class l extends c{constructor(ne){super();this._timeout=setTimeout(()=>this.open(),ne)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=l;function s(ve,ne){return ne?new Promise((pe,Ee)=>{const ke=setTimeout(()=>{Oe.dispose(),pe()},ve),Oe=ne.onCancellationRequested(()=>{clearTimeout(ke),Oe.dispose(),Ee(new t.CancellationError)})}):I(pe=>s(ve,pe))}e.timeout=s;function i(ve,ne=0){const pe=setTimeout(ve,ne);return(0,P.toDisposable)(()=>clearTimeout(pe))}e.disposableTimeout=i;function r(ve){const ne=[];let pe=0;const Ee=ve.length;function ke(){return pe<Ee?ve[pe++]():null}function Oe(Be){Be!=null&&ne.push(Be);const ae=ke();return ae?ae.then(Oe):Promise.resolve(ne)}return Promise.resolve(null).then(Oe)}e.sequence=r;function n(ve,ne=Ee=>!!Ee,pe=null){let Ee=0;const ke=ve.length,Oe=()=>{if(Ee>=ke)return Promise.resolve(pe);const Be=ve[Ee++];return Promise.resolve(Be()).then(de=>ne(de)?Promise.resolve(de):Oe())};return Oe()}e.first=n;function a(ve,ne=Ee=>!!Ee,pe=null){if(ve.length===0)return Promise.resolve(pe);let Ee=ve.length;const ke=()=>{Ee=-1;for(const Oe of ve)Oe.cancel?.()};return new Promise((Oe,Be)=>{for(const ae of ve)ae.then(de=>{--Ee>=0&&ne(de)?(ke(),Oe(de)):Ee===0&&Oe(pe)}).catch(de=>{--Ee>=0&&(ke(),Be(de))})})}e.firstParallel=a;class d{constructor(ne){this._size=0,this.maxDegreeOfParalellism=ne,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new D.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(ne){return this._size++,new Promise((pe,Ee)=>{this.outstandingPromises.push({factory:ne,c:pe,e:Ee}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const ne=this.outstandingPromises.shift();this.runningPromises++;const pe=ne.factory();pe.then(ne.c,ne.e),pe.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=d;class f extends d{constructor(){super(1)}}e.Queue=f;class S{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const ne=new $;return this.drainers.add(ne),ne.p}isDrained(){for(const[,ne]of this.queues)if(ne.size>0)return!1;return!0}queueFor(ne,pe=y.extUri){const Ee=pe.getComparisonKey(ne);let ke=this.queues.get(Ee);return ke||(ke=new f,D.Event.once(ke.onDrained)(()=>{ke?.dispose(),this.queues.delete(Ee),this.onDidQueueDrain()}),this.queues.set(Ee,ke)),ke}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const ne of this.drainers)ne.complete();this.drainers.clear()}dispose(){for(const[,ne]of this.queues)ne.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=S;class O{constructor(ne,pe){this._token=-1,typeof ne=="function"&&typeof pe=="number"&&this.setIfNotSet(ne,pe)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(ne,pe){this.cancel(),this._token=setTimeout(()=>{this._token=-1,ne()},pe)}setIfNotSet(ne,pe){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,ne()},pe))}}e.TimeoutTimer=O;class U{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(ne,pe){this.cancel(),this._token=setInterval(()=>{ne()},pe)}}e.IntervalTimer=U;class M{constructor(ne,pe){this.timeoutToken=-1,this.runner=ne,this.timeout=pe,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(ne=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,ne)}get delay(){return this.timeout}set delay(ne){this.timeout=ne}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=M;class A{constructor(ne,pe){pe%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${pe}ms is not a multiple of 1000ms.`),this.runner=ne,this.timeout=pe,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(ne=this.timeout){ne%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ne}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(ne/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=A;class B extends M{constructor(ne,pe){super(ne,pe);this.units=[]}work(ne){this.units.push(ne),this.isScheduled()||this.schedule()}doRun(){const ne=this.units;this.units=[],this.runner?.(ne)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=B;class x extends P.Disposable{constructor(ne,pe){super();this.options=ne,this.handler=pe,this.pendingWork=[],this.throttler=this._register(new P.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(ne){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+ne.length>this.options.maxBufferedWork)return!1}else if(this.pending+ne.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...ne),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new M(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=x,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=ve=>{(0,C.setTimeout0)(()=>{if(ne)return;const pe=Date.now()+15;ve(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,pe-Date.now())}}))});let ne=!1;return{dispose(){ne||(ne=!0)}}}:e.runWhenIdle=(ve,ne)=>{const pe=requestIdleCallback(ve,typeof ne=="number"?{timeout:ne}:void 0);let Ee=!1;return{dispose(){Ee||(Ee=!0,cancelIdleCallback(pe))}}}}();class N{constructor(ne){this._didRun=!1,this._executor=()=>{try{this._value=ne()}catch(pe){this._error=pe}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=N;async function K(ve,ne,pe){let Ee;for(let ke=0;ke<pe;ke++)try{return await ve()}catch(Oe){Ee=Oe,await s(ne)}throw Ee}e.retry=K;class X{hasPending(ne){return this._pending?typeof ne=="number"?this._pending.taskId===ne:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(ne,pe,Ee){return this._pending={taskId:ne,cancel:()=>Ee?.(),promise:pe},pe.then(()=>this.donePending(ne),()=>this.donePending(ne)),pe}donePending(ne){this._pending&&ne===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const ne=this._next;this._next=void 0,ne.run().then(ne.promiseResolve,ne.promiseReject)}}setNext(ne){if(this._next)this._next.run=ne;else{let pe,Ee;const ke=new Promise((Oe,Be)=>{pe=Oe,Ee=Be});this._next={run:ne,promise:ke,promiseResolve:pe,promiseReject:Ee}}return this._next.promise}}e.TaskSequentializer=X;class L{constructor(ne,pe=()=>Date.now()){this.interval=ne,this.nowFn=pe,this.lastIncrementTime=0,this.value=0}increment(){const ne=this.nowFn();return ne-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=ne,this.value=0),this.value++,this.value}}e.IntervalCounter=L;class ${constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((ne,pe)=>{this.completeCallback=ne,this.errorCallback=pe})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(ne){return new Promise(pe=>{this.completeCallback(ne),this.resolved=!0,pe()})}error(ne){return new Promise(pe=>{this.errorCallback(ne),this.rejected=!0,pe()})}cancel(){new Promise(ne=>{this.errorCallback(new t.CancellationError),this.rejected=!0,ne()})}}e.DeferredPromise=$;var H;(function(ve){async function ne(Ee){let ke;const Oe=await Promise.all(Ee.map(Be=>Be.then(ae=>ae,ae=>{ke||(ke=ae)})));if(typeof ke!="undefined")throw ke;return Oe}ve.settled=ne;function pe(Ee){return new Promise(async(ke,Oe)=>{try{await Ee(ke,Oe)}catch(Be){Oe(Be)}})}ve.withAsyncBody=pe})(H=e.Promises||(e.Promises={}));var j;(function(ve){ve[ve.Initial=0]="Initial",ve[ve.DoneOK=1]="DoneOK",ve[ve.DoneError=2]="DoneError"})(j||(j={}));class J{constructor(ne){this._state=0,this._results=[],this._error=null,this._onStateChanged=new D.Emitter,queueMicrotask(async()=>{const pe={emitOne:Ee=>this.emitOne(Ee),emitMany:Ee=>this.emitMany(Ee),reject:Ee=>this.reject(Ee)};try{await Promise.resolve(ne(pe)),this.resolve()}catch(Ee){this.reject(Ee)}finally{pe.emitOne=void 0,pe.emitMany=void 0,pe.reject=void 0}})}static fromArray(ne){return new J(pe=>{pe.emitMany(ne)})}static fromPromise(ne){return new J(async pe=>{pe.emitMany(await ne)})}static fromPromises(ne){return new J(async pe=>{await Promise.all(ne.map(async Ee=>pe.emitOne(await Ee)))})}static merge(ne){return new J(async pe=>{await Promise.all(ne.map(async Ee=>{for await(const ke of Ee)pe.emitOne(ke)}))})}[Symbol.asyncIterator](){let ne=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(ne<this._results.length)return{done:!1,value:this._results[ne++]};if(this._state===1)return{done:!0,value:void 0};await D.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(ne,pe){return new J(async Ee=>{for await(const ke of ne)Ee.emitOne(pe(ke))})}map(ne){return J.map(this,ne)}static filter(ne,pe){return new J(async Ee=>{for await(const ke of ne)pe(ke)&&Ee.emitOne(ke)})}filter(ne){return J.filter(this,ne)}static coalesce(ne){return J.filter(ne,pe=>!!pe)}coalesce(){return J.coalesce(this)}static async toPromise(ne){const pe=[];for await(const Ee of ne)pe.push(Ee);return pe}toPromise(){return J.toPromise(this)}emitOne(ne){this._state===0&&(this._results.push(ne),this._onStateChanged.fire())}emitMany(ne){this._state===0&&(this._results=this._results.concat(ne),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(ne){this._state===0&&(this._state=2,this._error=ne,this._onStateChanged.fire())}}e.AsyncIterableObject=J,J.EMPTY=J.fromArray([]);class Y extends J{constructor(ne,pe){super(pe);this._source=ne}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=Y;function he(ve){const ne=new u.CancellationTokenSource,pe=ve(ne.token);return new Y(ne,async Ee=>{const ke=ne.token.onCancellationRequested(()=>{ke.dispose(),ne.dispose(),Ee.reject(new t.CancellationError)});try{for await(const Oe of pe){if(ne.token.isCancellationRequested)return;Ee.emitOne(Oe)}ke.dispose(),ne.dispose()}catch(Oe){ke.dispose(),ne.dispose(),Ee.reject(Oe)}})}e.createCancelableAsyncIterable=he}),define(De[103],Ie([1,0,18,9]),function(Z,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const D=new u.IdleValue(()=>{const f=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:f,collatorIsNumeric:f.resolvedOptions().numeric}}),P=new u.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),y=new u.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function C(f,S,O=!1){const U=f||"",M=S||"",A=D.value.collator.compare(U,M);return D.value.collatorIsNumeric&&A===0&&U!==M?U<M?-1:1:A}e.compareFileNames=C;function E(f,S){const O=P.value.collator;return f=f||"",S=S||"",m(O,f,S)}e.compareFileNamesDefault=E;function I(f,S){const O=P.value.collator;return f=f||"",S=S||"",i(f,S)||m(O,f,S)}e.compareFileNamesUpper=I;function R(f,S){const O=P.value.collator;return f=f||"",S=S||"",s(f,S)||m(O,f,S)}e.compareFileNamesLower=R;function k(f,S){return f=f||"",S=S||"",f===S?0:f<S?-1:1}e.compareFileNamesUnicode=k;function _(f,S,O=!1){O||(f=f&&f.toLowerCase(),S=S&&S.toLowerCase());const[U,M]=p(f),[A,B]=p(S);return U!==A?U<A?-1:1:M===B?0:M<B?-1:1}e.noIntlCompareFileNames=_;function T(f,S){const[O,U]=p(f),[M,A]=p(S);let B=D.value.collator.compare(U,A);if(B===0){if(D.value.collatorIsNumeric&&U!==A)return U<A?-1:1;if(B=D.value.collator.compare(O,M),D.value.collatorIsNumeric&&B===0&&O!==M)return O<M?-1:1}return B}e.compareFileExtensions=T;function w(f,S){f=f||"",S=S||"";const O=o(f),U=o(S),M=P.value.collator,A=y.value.collator;return m(A,O,U)||m(M,f,S)}e.compareFileExtensionsDefault=w;function b(f,S){f=f||"",S=S||"";const O=o(f),U=o(S),M=P.value.collator,A=y.value.collator;return m(A,O,U)||i(f,S)||m(M,f,S)}e.compareFileExtensionsUpper=b;function v(f,S){f=f||"",S=S||"";const O=o(f),U=o(S),M=P.value.collator,A=y.value.collator;return m(A,O,U)||s(f,S)||m(M,f,S)}e.compareFileExtensionsLower=v;function h(f,S){f=f||"",S=S||"";const O=o(f).toLowerCase(),U=o(S).toLowerCase();return O!==U?O<U?-1:1:f!==S?f<S?-1:1:0}e.compareFileExtensionsUnicode=h;const g=/^(.*?)(\.([^.]*))?$/;function p(f,S=!1){const O=f?g.exec(f):[];let U=[O&&O[1]||"",O&&O[3]||""];return S&&(!U[0]&&U[1]||U[0]&&U[0].charAt(0)===".")&&(U=[U[0]+"."+U[1],""]),U}function o(f){const S=f?g.exec(f):[];return S&&S[1]&&S[1].charAt(0)!=="."&&S[3]||""}function m(f,S,O){const U=f.compare(S,O);return U!==0?U:S.length!==O.length?S.length<O.length?-1:1:0}function c(f){const S=f.charAt(0);return S.toLocaleUpperCase()!==S}function l(f){const S=f.charAt(0);return S.toLocaleLowerCase()!==S}function s(f,S){return c(f)&&l(S)?-1:l(f)&&c(S)?1:0}function i(f,S){return l(f)&&c(S)?-1:c(f)&&l(S)?1:0}function r(f,S,O=!1){return O||(f=f&&f.toLowerCase(),S=S&&S.toLowerCase()),f===S?0:f<S?-1:1}function n(f,S,O=!1){const U=f.split(t.sep),M=S.split(t.sep),A=U.length-1,B=M.length-1;let x,N;for(let K=0;;K++){if(x=A===K,N=B===K,x&&N)return C(U[K],M[K],O);if(x)return-1;if(N)return 1;const X=r(U[K],M[K],O);if(X!==0)return X}}e.comparePaths=n;function a(f,S,O){const U=f.toLowerCase(),M=S.toLowerCase(),A=d(f,S,O);if(A)return A;const B=U.endsWith(O),x=M.endsWith(O);if(B!==x)return B?-1:1;const N=C(U,M);return N!==0?N:U.localeCompare(M)}e.compareAnything=a;function d(f,S,O){const U=f.toLowerCase(),M=S.toLowerCase(),A=U.startsWith(O),B=M.startsWith(O);if(A!==B)return A?-1:1;if(A&&B){if(U.length<M.length)return-1;if(U.length>M.length)return 1}return 0}e.compareByPrefix=d}),define(De[104],Ie([1,0,103,102,60,9,11,8]),function(Z,e,u,t,D,P,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const E=0,I=[E,[]];function R(X,L,$,H){if(!X||!L)return I;const j=X.length,J=L.length;if(j<J)return I;const Y=X.toLowerCase();return k(L,$,J,X,Y,j,H)}e.scoreFuzzy=R;function k(X,L,$,H,j,J,Y){const he=[],ve=[];for(let ke=0;ke<$;ke++){const Oe=ke*J,Be=Oe-J,ae=ke>0,de=X[ke],me=L[ke];for(let te=0;te<J;te++){const le=te>0,ee=Oe+te,re=ee-1,F=Be+te-1,W=le?he[re]:0,G=ae&&le?he[F]:0,Q=ae&&le?ve[F]:0;let fe;!G&&ae?fe=0:fe=_(de,me,H,j,te,Q),fe&&G+fe>=W&&(Y||ae||j.startsWith(L,te))?(ve[ee]=Q+1,he[ee]=G+fe):(ve[ee]=E,he[ee]=W)}}const ne=[];let pe=$-1,Ee=J-1;for(;pe>=0&&Ee>=0;){const ke=pe*J+Ee;ve[ke]===E||(ne.push(Ee),pe--),Ee--}return[he[$*J-1],ne.reverse()]}function _(X,L,$,H,j,J){let Y=0;if(!T(L,H[j]))return Y;if(Y+=1,J>0&&(Y+=J*5),X===$[j]&&(Y+=1),j===0)Y+=8;else{const he=w($.charCodeAt(j-1));he?Y+=he:(0,t.isUpper)($.charCodeAt(j))&&J===0&&(Y+=2)}return Y}function T(X,L){return X===L?!0:X==="/"||X==="\\"?L==="/"||L==="\\":!1}function w(X){switch(X){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const b=[void 0,[]];function v(X,L,$=0,H=0){const j=L;return j.values&&j.values.length>1?h(X,j.values,$,H):g(X,L,$,H)}e.scoreFuzzy2=v;function h(X,L,$,H){let j=0;const J=[];for(const Y of L){const[he,ve]=g(X,Y,$,H);if(typeof he!="number")return b;j+=he,J.push(...ve)}return[j,d(J)]}function g(X,L,$,H){const j=(0,t.fuzzyScore)(L.original,L.originalLowercase,$,X,X.toLowerCase(),H,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return j?[j[0],(0,t.createMatches)(j)]:b}const p=Object.freeze({score:0}),o=1<<18,m=1<<17,c=1<<16;function l(X,L,$,H){const j=H.values?H.values:[H];return(0,D.hash)({[H.normalized]:{values:j.map(Y=>({value:Y.normalized,expectContiguousMatch:Y.expectContiguousMatch})),label:X,description:L,allowNonContiguousMatches:$}})}function s(X,L,$,H,j){if(!X||!L.normalized)return p;const J=H.getItemLabel(X);if(!J)return p;const Y=H.getItemDescription(X),he=l(J,Y,$,L),ve=j[he];if(ve)return ve;const ne=i(J,Y,H.getItemPath(X),L,$);return j[he]=ne,ne}e.scoreItemFuzzy=s;function i(X,L,$,H,j){const J=!$||!H.containsPathSeparator;return $&&(y.isLinux?H.pathNormalized===$:(0,C.equalsIgnoreCase)(H.pathNormalized,$))?{score:o,labelMatch:[{start:0,end:X.length}],descriptionMatch:L?[{start:0,end:L.length}]:void 0}:H.values&&H.values.length>1?r(X,L,$,H.values,J,j):n(X,L,$,H,J,j)}function r(X,L,$,H,j,J){let Y=0;const he=[],ve=[];for(const ne of H){const{score:pe,labelMatch:Ee,descriptionMatch:ke}=n(X,L,$,ne,j,J);if(pe===E)return p;Y+=pe,Ee&&he.push(...Ee),ke&&ve.push(...ke)}return{score:Y,labelMatch:d(he),descriptionMatch:d(ve)}}function n(X,L,$,H,j,J){if(j||!L){const[Y,he]=R(X,H.normalized,H.normalizedLowercase,J&&!H.expectContiguousMatch);if(Y){const ve=(0,t.matchesPrefix)(H.normalized,X);let ne;return ve?(ne=m,ne+=Math.round(H.normalized.length/X.length*100)):ne=c,{score:ne+Y,labelMatch:ve||a(he)}}}if(L){let Y=L;$&&(Y=`${L}${P.sep}`);const he=Y.length,ve=`${Y}${X}`,[ne,pe]=R(ve,H.normalized,H.normalizedLowercase,J&&!H.expectContiguousMatch);if(ne){const Ee=a(pe),ke=[],Oe=[];return Ee.forEach(Be=>{Be.start<he&&Be.end>he?(ke.push({start:0,end:Be.end-he}),Oe.push({start:Be.start,end:he})):Be.start>=he?ke.push({start:Be.start-he,end:Be.end-he}):Oe.push(Be)}),{score:ne,labelMatch:ke,descriptionMatch:Oe}}}return p}function a(X){const L=[];if(!X)return L;let $;for(const H of X)$&&$.end===H?$.end+=1:($={start:H,end:H+1},L.push($));return L}function d(X){const L=X.sort((j,J)=>j.start-J.start),$=[];let H;for(const j of L)!H||!f(H,j)?(H=j,$.push(j)):(H.start=Math.min(H.start,j.start),H.end=Math.max(H.end,j.end));return $}function f(X,L){return!(X.end<L.start||L.end<X.start)}function S(X,L,$,H,j,J){const Y=s(X,$,H,j,J),he=s(L,$,H,j,J),ve=Y.score,ne=he.score;if((ve===o||ne===o)&&ve!==ne)return ve===o?-1:1;if(ve>c||ne>c){if(ve!==ne)return ve>ne?-1:1;if(ve<m&&ne<m){const de=U(Y.labelMatch,he.labelMatch);if(de!==0)return de}const Be=j.getItemLabel(X)||"",ae=j.getItemLabel(L)||"";if(Be.length!==ae.length)return Be.length-ae.length}if(ve!==ne)return ve>ne?-1:1;const pe=Array.isArray(Y.labelMatch)&&Y.labelMatch.length>0,Ee=Array.isArray(he.labelMatch)&&he.labelMatch.length>0;if(pe&&!Ee)return-1;if(Ee&&!pe)return 1;const ke=O(X,Y,j),Oe=O(L,he,j);return ke&&Oe&&ke!==Oe?Oe>ke?-1:1:M(X,L,$,j)}e.compareItemsByFuzzyScore=S;function O(X,L,$){let H=-1,j=-1;if(L.descriptionMatch&&L.descriptionMatch.length?H=L.descriptionMatch[0].start:L.labelMatch&&L.labelMatch.length&&(H=L.labelMatch[0].start),L.labelMatch&&L.labelMatch.length){if(j=L.labelMatch[L.labelMatch.length-1].end,L.descriptionMatch&&L.descriptionMatch.length){const J=$.getItemDescription(X);J&&(j+=J.length)}}else L.descriptionMatch&&L.descriptionMatch.length&&(j=L.descriptionMatch[L.descriptionMatch.length-1].end);return j-H}function U(X,L){if(!X&&!L||(!X||!X.length)&&(!L||!L.length))return 0;if(!L||!L.length)return-1;if(!X||!X.length)return 1;const $=X[0].start,j=X[X.length-1].end-$,J=L[0].start,he=L[L.length-1].end-J;return j===he?0:he<j?1:-1}function M(X,L,$,H){const j=H.getItemLabel(X)||"",J=H.getItemLabel(L)||"",Y=H.getItemDescription(X),he=H.getItemDescription(L),ve=j.length+(Y?Y.length:0),ne=J.length+(he?he.length:0);if(ve!==ne)return ve-ne;const pe=H.getItemPath(X),Ee=H.getItemPath(L);return pe&&Ee&&pe.length!==Ee.length?pe.length-Ee.length:j!==J?(0,u.compareAnything)(j,J,$.normalized):Y&&he&&Y!==he?(0,u.compareAnything)(Y,he,$.normalized):pe&&Ee&&pe!==Ee?(0,u.compareAnything)(pe,Ee,$.normalized):0}function A(X){return X.startsWith('"')&&X.endsWith('"')}const B=" ";function x(X){typeof X!="string"&&(X="");const L=X.toLowerCase(),{pathNormalized:$,normalized:H,normalizedLowercase:j}=N(X),J=$.indexOf(P.sep)>=0,Y=A(X);let he;const ve=X.split(B);if(ve.length>1)for(const ne of ve){const pe=A(ne),{pathNormalized:Ee,normalized:ke,normalizedLowercase:Oe}=N(ne);ke&&(he||(he=[]),he.push({original:ne,originalLowercase:ne.toLowerCase(),pathNormalized:Ee,normalized:ke,normalizedLowercase:Oe,expectContiguousMatch:pe}))}return{original:X,originalLowercase:L,pathNormalized:$,normalized:H,normalizedLowercase:j,values:he,containsPathSeparator:J,expectContiguousMatch:Y}}e.prepareQuery=x;function N(X){let L;y.isWindows?L=X.replace(/\//g,P.sep):L=X.replace(/\\/g,P.sep);const $=(0,C.stripWildcards)(L).replace(/\s|"/g,"");return{pathNormalized:L,normalized:$,normalizedLowercase:$.toLowerCase()}}function K(X){return Array.isArray(X)?x(X.map(L=>L.original).join(B)):x(X.original)}e.pieceToQuery=K}),define(De[36],Ie([1,0,17,18,31,25,9,11,8]),function(Z,e,u,t,D,P,y,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function I(){return Object.create(null)}e.getEmptyExpression=I,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const R="[/\\\\]",k="[^/\\\\]",_=/\//g;function T($,H){switch($){case 0:return"";case 1:return`${k}*?`;default:return`(?:${R}|${k}+${R}${H?`|${R}${k}+`:""})*?`}}function w($,H){if(!$)return[];const j=[];let J=!1,Y=!1,he="";for(const ve of $){switch(ve){case H:if(!J&&!Y){j.push(he),he="";continue}break;case"{":J=!0;break;case"}":J=!1;break;case"[":Y=!0;break;case"]":Y=!1;break}he+=ve}return he&&j.push(he),j}e.splitGlobAware=w;function b($){if(!$)return"";let H="";const j=w($,e.GLOB_SPLIT);if(j.every(J=>J===e.GLOBSTAR))H=".*";else{let J=!1;j.forEach((Y,he)=>{if(Y===e.GLOBSTAR){if(J)return;H+=T(2,he===j.length-1)}else{let ve=!1,ne="",pe=!1,Ee="";for(const ke of Y){if(ke!=="}"&&ve){ne+=ke;continue}if(pe&&(ke!=="]"||!Ee)){let Oe;ke==="-"?Oe=ke:(ke==="^"||ke==="!")&&!Ee?Oe="^":ke===e.GLOB_SPLIT?Oe="":Oe=(0,E.escapeRegExpCharacters)(ke),Ee+=Oe;continue}switch(ke){case"{":ve=!0;continue;case"[":pe=!0;continue;case"}":{H+=`(?:${w(ne,",").map(ae=>b(ae)).join("|")})`,ve=!1,ne="";break}case"]":{H+="["+Ee+"]",pe=!1,Ee="";break}case"?":H+=k;continue;case"*":H+=T(1);continue;default:H+=(0,E.escapeRegExpCharacters)(ke)}}he<j.length-1&&(j[he+1]!==e.GLOBSTAR||he+2<j.length)&&(H+=R)}J=Y===e.GLOBSTAR})}return H}const v=/^\*\*\/\*\.[\w\.-]+$/,h=/^\*\*\/([\w\.-]+)\/?$/,g=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,p=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,m=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,c=new P.LRUCache(1e4),l=function(){return!1},s=function(){return null};function i($,H){if(!$)return s;let j;typeof $!="string"?j=$.pattern:j=$,j=j.trim();const J=`${j}_${!!H.trimForExclusions}`;let Y=c.get(J);if(Y)return r(Y,$);let he;return v.test(j)?Y=a(j.substr(4),j):(he=h.exec(n(j,H)))?Y=d(he[1],j):(H.trimForExclusions?p:g).test(j)?Y=f(j,H):(he=o.exec(n(j,H)))?Y=S(he[1].substr(1),j,!0):(he=m.exec(n(j,H)))?Y=S(he[1],j,!1):Y=O(j),c.set(J,Y),r(Y,$)}function r($,H){if(typeof H=="string")return $;const j=function(J,Y){return(0,D.isEqualOrParent)(J,H.base,!C.isLinux)?$(J.substr(H.base.length+1),Y):null};return j.allBasenames=$.allBasenames,j.allPaths=$.allPaths,j.basenames=$.basenames,j.patterns=$.patterns,j}function n($,H){return H.trimForExclusions&&$.endsWith("/**")?$.substr(0,$.length-2):$}function a($,H){return function(j,J){return typeof j=="string"&&j.endsWith($)?H:null}}function d($,H){const j=`/${$}`,J=`\\${$}`,Y=function(ve,ne){return typeof ve!="string"?null:ne?ne===$?H:null:ve===$||ve.endsWith(j)||ve.endsWith(J)?H:null},he=[$];return Y.basenames=he,Y.patterns=[H],Y.allBasenames=he,Y}function f($,H){const j=X($.slice(1,-1).split(",").map(ne=>i(ne,H)).filter(ne=>ne!==s),$),J=j.length;if(!J)return s;if(J===1)return j[0];const Y=function(ne,pe){for(let Ee=0,ke=j.length;Ee<ke;Ee++)if(j[Ee](ne,pe))return $;return null},he=j.find(ne=>!!ne.allBasenames);he&&(Y.allBasenames=he.allBasenames);const ve=j.reduce((ne,pe)=>pe.allPaths?ne.concat(pe.allPaths):ne,[]);return ve.length&&(Y.allPaths=ve),Y}function S($,H,j){const J=y.sep===y.posix.sep,Y=J?$:$.replace(_,y.sep),he=y.sep+Y,ve=y.posix.sep+$;let ne;return j?ne=function(pe,Ee){return typeof pe=="string"&&(pe===Y||pe.endsWith(he)||!J&&(pe===$||pe.endsWith(ve)))?H:null}:ne=function(pe,Ee){return typeof pe=="string"&&(pe===Y||!J&&pe===$)?H:null},ne.allPaths=[(j?"*/":"./")+$],ne}function O($){try{const H=new RegExp(`^${b($)}$`);return function(j){return H.lastIndex=0,typeof j=="string"&&H.test(j)?$:null}}catch{return s}}function U($,H,j){return!$||typeof H!="string"?!1:M($)(H,void 0,j)}e.match=U;function M($,H={}){if(!$)return l;if(typeof $=="string"||A($)){const j=i($,H);if(j===s)return l;const J=function(Y,he){return!!j(Y,he)};return j.allBasenames&&(J.allBasenames=j.allBasenames),j.allPaths&&(J.allPaths=j.allPaths),J}return N($,H)}e.parse=M;function A($){const H=$;return H?typeof H.base=="string"&&typeof H.pattern=="string":!1}e.isRelativePattern=A;function B($){return $.allBasenames||[]}e.getBasenameTerms=B;function x($){return $.allPaths||[]}e.getPathTerms=x;function N($,H){const j=X(Object.getOwnPropertyNames($).map(ne=>K(ne,$[ne],H)).filter(ne=>ne!==s)),J=j.length;if(!J)return s;if(!j.some(ne=>!!ne.requiresSiblings)){if(J===1)return j[0];const ne=function(ke,Oe){let Be;for(let ae=0,de=j.length;ae<de;ae++){const me=j[ae](ke,Oe);if(typeof me=="string")return me;(0,t.isThenable)(me)&&(Be||(Be=[]),Be.push(me))}return Be?(async()=>{for(const ae of Be){const de=await ae;if(typeof de=="string")return de}return null})():null},pe=j.find(ke=>!!ke.allBasenames);pe&&(ne.allBasenames=pe.allBasenames);const Ee=j.reduce((ke,Oe)=>Oe.allPaths?ke.concat(Oe.allPaths):ke,[]);return Ee.length&&(ne.allPaths=Ee),ne}const Y=function(ne,pe,Ee){let ke,Oe;for(let Be=0,ae=j.length;Be<ae;Be++){const de=j[Be];de.requiresSiblings&&Ee&&(pe||(pe=(0,y.basename)(ne)),ke||(ke=pe.substr(0,pe.length-(0,y.extname)(ne).length)));const me=de(ne,pe,ke,Ee);if(typeof me=="string")return me;(0,t.isThenable)(me)&&(Oe||(Oe=[]),Oe.push(me))}return Oe?(async()=>{for(const Be of Oe){const ae=await Be;if(typeof ae=="string")return ae}return null})():null},he=j.find(ne=>!!ne.allBasenames);he&&(Y.allBasenames=he.allBasenames);const ve=j.reduce((ne,pe)=>pe.allPaths?ne.concat(pe.allPaths):ne,[]);return ve.length&&(Y.allPaths=ve),Y}function K($,H,j){if(H===!1)return s;const J=i($,j);if(J===s)return s;if(typeof H=="boolean")return J;if(H){const Y=H.when;if(typeof Y=="string"){const he=(ve,ne,pe,Ee)=>{if(!Ee||!J(ve,ne))return null;const ke=Y.replace("$(basename)",pe),Oe=Ee(ke);return(0,t.isThenable)(Oe)?Oe.then(Be=>Be?$:null):Oe?$:null};return he.requiresSiblings=!0,he}}return J}function X($,H){const j=$.filter(ne=>!!ne.basenames);if(j.length<2)return $;const J=j.reduce((ne,pe)=>{const Ee=pe.basenames;return Ee?ne.concat(Ee):ne},[]);let Y;if(H){Y=[];for(let ne=0,pe=J.length;ne<pe;ne++)Y.push(H)}else Y=j.reduce((ne,pe)=>{const Ee=pe.patterns;return Ee?ne.concat(Ee):ne},[]);const he=function(ne,pe){if(typeof ne!="string")return null;if(!pe){let ke;for(ke=ne.length;ke>0;ke--){const Oe=ne.charCodeAt(ke-1);if(Oe===47||Oe===92)break}pe=ne.substr(ke)}const Ee=J.indexOf(pe);return Ee!==-1?Y[Ee]:null};he.basenames=J,he.patterns=Y,he.allBasenames=J;const ve=$.filter(ne=>!ne.basenames);return ve.push(he),ve}function L($,H){return(0,u.equals)($,H,(j,J)=>typeof j=="string"&&typeof J=="string"?j===J:typeof j!="string"&&typeof J!="string"?j.base===J.base&&j.pattern===J.pattern:!1)}e.patternsEquals=L}),define(De[105],Ie([1,0,10,155,22,8,2]),function(Z,e,u,t,D,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var C;(function(v){v[v.Paragraph=0]="Paragraph",v[v.Break=1]="Break"})(C=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class E{constructor(h="",g=!1){if(this.value=h,typeof this.value!="string")throw(0,u.illegalArgument)("value");typeof g=="boolean"?(this.isTrusted=g,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=g.isTrusted??void 0,this.supportThemeIcons=g.supportThemeIcons??!1,this.supportHtml=g.supportHtml??!1)}appendText(h,g=0){return this.value+=_(this.supportThemeIcons?(0,t.escapeIcons)(h):h).replace(/([ \t]+)/g,(p,o)=>"&nbsp;".repeat(o.length)).replace(/\>/gm,"\\>").replace(/\n/g,g===1?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,g){return this.value+="\n```",this.value+=h,this.value+=`
`,this.value+=g,this.value+="\n```\n",this}appendLink(h,g,p){return this.value+="[",this.value+=this._escape(g,"]"),this.value+="](",this.value+=this._escape(String(h),")"),p&&(this.value+=` "${this._escape(this._escape(p,'"'),")")}"`),this.value+=")",this}_escape(h,g){const p=new RegExp((0,P.escapeRegExpCharacters)(g),"g");return h.replace(p,(o,m)=>h.charAt(m-1)!=="\\"?`\\${o}`:o)}}e.MarkdownString=E;function I(v){return R(v)?!v.value:Array.isArray(v)?v.every(I):!0}e.isEmptyMarkdownString=I;function R(v){return v instanceof E?!0:v&&typeof v=="object"?typeof v.value=="string"&&(typeof v.isTrusted=="boolean"||v.isTrusted===void 0)&&(typeof v.supportThemeIcons=="boolean"||v.supportThemeIcons===void 0):!1}e.isMarkdownString=R;function k(v,h){return v===h?!0:!v||!h?!1:v.value===h.value&&v.isTrusted===h.isTrusted&&v.supportThemeIcons===h.supportThemeIcons&&v.supportHtml===h.supportHtml&&(v.baseUri===h.baseUri||!!v.baseUri&&!!h.baseUri&&(0,D.isEqual)(y.URI.from(v.baseUri),y.URI.from(h.baseUri)))}e.markdownStringEqual=k;function _(v){return v.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=_;function T(v){return v.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=T;function w(v){return v&&v.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=w;function b(v){const h=[],g=v.split("|").map(o=>o.trim());v=g[0];const p=g[1];if(p){const o=/height=(\d+)/.exec(p),m=/width=(\d+)/.exec(p),c=o?o[1]:"",l=m?m[1]:"",s=isFinite(parseInt(l)),i=isFinite(parseInt(c));s&&h.push(`width="${l}"`),i&&h.push(`height="${c}"`)}return{href:v,dimensions:h}}e.parseHrefAndDimensions=b}),define(De[106],Ie([1,0,17,31,9,11,22,8]),function(Z,e,u,t,D,P,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function E(s,i){const{os:r,tildify:n,relative:a}=i;if(a){const S=I(s,a,r);if(typeof S=="string")return S}let d=s.fsPath;if(r===1&&!P.isWindows?d=d.replace(/\//g,"\\"):r!==1&&P.isWindows&&(d=d.replace(/\\/g,"/")),r!==1&&n?.userHome){const S=n.userHome.fsPath;let O;s.scheme!==n.userHome.scheme&&s.path.startsWith(D.posix.sep)?O=n.userHome.with({path:s.path}).fsPath:O=s.fsPath,d=_(O,S,r)}return(r===1?D.win32:D.posix).normalize(R(d,r===1))}e.getPathLabel=E;function I(s,i,r){const n=r===1?D.win32:D.posix,a=r===3?y.extUri:y.extUriIgnorePathCase,d=i.getWorkspace(),f=(0,u.firstOrDefault)(d.folders);if(!f)return;s.scheme!==f.uri.scheme&&s.path.startsWith(D.posix.sep)&&(s=f.uri.with({path:s.path}));const S=i.getWorkspaceFolder(s);if(!S)return;let O;if(a.isEqual(S.uri,s)?O="":O=a.relativePath(S.uri,s)??"",O&&(O=n.normalize(O)),d.folders.length>1&&!i.noPrefix){const U=S.name?S.name:a.basenameOrAuthority(S.uri);O=O?`${U} \u2022 ${O}`:U}return O}function R(s,i=P.isWindows){return(0,t.hasDriveLetter)(s,i)?s.charAt(0).toUpperCase()+s.slice(1):s}e.normalizeDriveLetter=R;let k=Object.create(null);function _(s,i,r=P.OS){if(r===1||!s||!i)return s;let n=k.original===i?k.normalized:void 0;n||(n=i,P.isWindows&&(n=(0,t.toSlashes)(n)),n=`${(0,C.rtrim)(n,D.posix.sep)}${D.posix.sep}`,k={original:i,normalized:n});let a=s;return P.isWindows&&(a=(0,t.toSlashes)(a)),(r===3?a.startsWith(n):(0,C.startsWithIgnoreCase)(a,n))?`~/${a.substr(n.length)}`:s}e.tildify=_;function T(s,i){return s.replace(/^~($|\/|\\)/,`${i}$1`)}e.untildify=T;const w="\u2026",b="\\\\",v="~";function h(s,i=D.sep){const r=new Array(s.length);let n=!1;for(let a=0;a<s.length;a++){const d=s[a];if(d===""){r[a]=`.${i}`;continue}if(!d){r[a]=d;continue}n=!0;let f="",S=d;S.indexOf(b)===0?(f=S.substr(0,S.indexOf(b)+b.length),S=S.substr(S.indexOf(b)+b.length)):S.indexOf(i)===0?(f=S.substr(0,S.indexOf(i)+i.length),S=S.substr(S.indexOf(i)+i.length)):S.indexOf(v)===0&&(f=S.substr(0,S.indexOf(v)+v.length),S=S.substr(S.indexOf(v)+v.length));const O=S.split(i);for(let U=1;n&&U<=O.length;U++)for(let M=O.length-U;n&&M>=0;M--){n=!1;let A=O.slice(M,M+U).join(i);for(let B=0;!n&&B<s.length;B++)if(B!==a&&s[B]&&s[B].indexOf(A)>-1){const x=M+U===O.length,N=M>0&&s[B].indexOf(i)>-1?i+A:A,K=s[B].endsWith(N);n=!x||K}if(!n){let B="";(O[0].endsWith(":")||f!=="")&&(M===1&&(M=0,U++,A=O[0]+i+A),M>0&&(B=O[0]+i),B=f+B),M>0&&(B=B+w+i),B=B+A,M+U<O.length&&(B=B+i+w),r[a]=B}}n&&(r[a]=d)}return r}e.shorten=h;var g;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(g||(g={}));function p(s,i=Object.create(null)){const r=[];let n=!1,a="";for(const d of s)if(d==="$"||n&&d==="{")a&&r.push({value:a,type:g.TEXT}),a="",n=!0;else if(d==="}"&&n){const f=i[a];if(typeof f=="string")f.length&&r.push({value:f,type:g.VARIABLE});else if(f){const S=r[r.length-1];(!S||S.type!==g.SEPARATOR)&&r.push({value:f.label,type:g.SEPARATOR})}a="",n=!1}else a+=d;return a&&!n&&r.push({value:a,type:g.TEXT}),r.filter((d,f)=>{if(d.type===g.SEPARATOR){const S=r[f-1],O=r[f+1];return[S,O].every(U=>U&&(U.type===g.VARIABLE||U.type===g.TEXT)&&U.value.length>0)}return!0}).map(d=>d.value).join("")}e.template=p;function o(s,i){return P.isMacintosh||i?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,P.isMacintosh?"&":"&&"):s.replace(/&&|&/g,r=>r==="&"?"&&":"&")}e.mnemonicMenuLabel=o;function m(s,i){return P.isMacintosh||i?s.replace(/\(&&\w\)|&&/g,""):P.isWindows?s.replace(/&&|&/g,r=>r==="&"?"&&":"&"):s.replace(/&&/g,"_")}e.mnemonicButtonLabel=m;function c(s){return s.replace(/&/g,"&&")}e.unmnemonicLabel=c;function l(s){const i=s.indexOf("/")!==-1?D.posix:D.win32,r=i.basename(s),n=i.dirname(s);return r.length?{name:r,parentPath:n}:{name:n,parentPath:""}}e.splitName=l}),define(De[107],Ie([1,0,2]),function(Z,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(R){return R.toJSON()}class D{constructor(k){this._uriTransformer=k}transformIncoming(k){const _=this._uriTransformer.transformIncoming(k);return _===k?k:t(u.URI.from(_))}transformOutgoing(k){const _=this._uriTransformer.transformOutgoing(k);return _===k?k:t(u.URI.from(_))}transformOutgoingURI(k){const _=this._uriTransformer.transformOutgoing(k);return _===k?k:u.URI.from(_)}transformOutgoingScheme(k){return this._uriTransformer.transformOutgoingScheme(k)}}e.URITransformer=D,e.DefaultURITransformer=new class{transformIncoming(R){return R}transformOutgoing(R){return R}transformOutgoingURI(R){return R}transformOutgoingScheme(R){return R}};function P(R,k,_){if(!R||_>200)return null;if(typeof R=="object"){if(R instanceof u.URI)return k.transformOutgoing(R);for(const T in R)if(Object.hasOwnProperty.call(R,T)){const w=P(R[T],k,_+1);w!==null&&(R[T]=w)}}return null}function y(R,k){const _=P(R,k,0);return _===null?R:_}e.transformOutgoingURIs=y;function C(R,k,_,T){if(!R||T>200)return null;if(typeof R=="object"){if(R.$mid===1)return _?u.URI.revive(k.transformIncoming(R)):k.transformIncoming(R);for(const w in R)if(Object.hasOwnProperty.call(R,w)){const b=C(R[w],k,_,T+1);b!==null&&(R[w]=b)}}return null}function E(R,k){const _=C(R,k,!1,0);return _===null?R:_}e.transformIncomingURIs=E;function I(R,k){const _=C(R,k,!0,0);return _===null?R:_}e.transformAndReviveIncomingURIs=I}),define(De[29],Ie([1,0,62,81,302,18,31,80,9,11,22,2]),function(Z,e,u,t,D,P,y,C,E,I,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var _;(function(N){N[N.UNLINK=0]="UNLINK",N[N.MOVE=1]="MOVE"})(_=e.RimRafMode||(e.RimRafMode={}));async function T(N,K=_.UNLINK){if((0,y.isRootOrDriveLetter)(N))throw new Error("rimraf - will refuse to recursively delete root");return K===_.UNLINK?b(N):w(N)}async function w(N){try{const K=(0,y.randomPath)((0,t.tmpdir)());try{await u.promises.rename(N,K)}catch{return b(N)}b(K).catch(X=>{})}catch(K){if(K.code!=="ENOENT")throw K}}async function b(N){return(0,D.promisify)(u.rm)(N,{recursive:!0,force:!0,maxRetries:3})}function v(N){if((0,y.isRootOrDriveLetter)(N))throw new Error("rimraf - will refuse to recursively delete root");u.rmSync(N,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=v;async function h(N,K){return o(await(K?g(N):(0,D.promisify)(u.readdir)(N)))}async function g(N){try{return await(0,D.promisify)(u.readdir)(N,{withFileTypes:!0})}catch(L){console.warn("[node.js fs] readdir with filetypes failed with error: ",L)}const K=[],X=await h(N);for(const L of X){let $=!1,H=!1,j=!1;try{const J=await e.Promises.lstat((0,E.join)(N,L));$=J.isFile(),H=J.isDirectory(),j=J.isSymbolicLink()}catch(J){console.warn("[node.js fs] unexpected error from lstat after readdir: ",J)}K.push({name:L,isFile:()=>$,isDirectory:()=>H,isSymbolicLink:()=>j})}return K}function p(N){return o(u.readdirSync(N))}e.readdirSync=p;function o(N){return N.map(K=>typeof K=="string"?I.isMacintosh?(0,C.normalizeNFC)(K):K:(K.name=I.isMacintosh?(0,C.normalizeNFC)(K.name):K.name,K))}async function m(N){const K=await h(N),X=[];for(const L of K)await l.existsDirectory((0,E.join)(N,L))&&X.push(L);return X}function c(N,K=1e3){return new Promise(X=>{let L=!1;const $=setInterval(()=>{L||(L=!0,u.access(N,H=>{L=!1,H&&(clearInterval($),X(void 0))}))},K)})}e.whenDeleted=c;var l;(function(N){async function K($){let H;try{if(H=await e.Promises.lstat($),!H.isSymbolicLink())return{stat:H}}catch{}try{return{stat:await e.Promises.stat($),symbolicLink:H?.isSymbolicLink()?{dangling:!1}:void 0}}catch(j){if(j.code==="ENOENT"&&H)return{stat:H,symbolicLink:{dangling:!0}};if(I.isWindows&&j.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink($)),symbolicLink:{dangling:!1}}}catch(J){if(J.code==="ENOENT"&&H)return{stat:H,symbolicLink:{dangling:!0}};throw J}throw j}}N.stat=K;async function X($){try{const{stat:H,symbolicLink:j}=await N.stat($);return H.isFile()&&j?.dangling!==!0}catch{}return!1}N.existsFile=X;async function L($){try{const{stat:H,symbolicLink:j}=await N.stat($);return H.isDirectory()&&j?.dangling!==!0}catch{}return!1}N.existsDirectory=L})(l=e.SymlinkSupport||(e.SymlinkSupport={}));const s=new P.ResourceQueue;function i(N,K,X){return s.queueFor(k.URI.file(N),R.extUriBiasedIgnorePathCase).queue(()=>{const L=f(X);return new Promise(($,H)=>a(N,K,L,j=>j?H(j):$()))})}let r=!0;function n(N){r=N}e.configureFlushOnWrite=n;function a(N,K,X,L){if(!r)return u.writeFile(N,K,{mode:X.mode,flag:X.flag},L);u.open(N,X.flag,X.mode,($,H)=>{if($)return L($);u.writeFile(H,K,j=>{if(j)return u.close(H,()=>L(j));u.fdatasync(H,J=>(J&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",J),n(!1)),u.close(H,Y=>L(Y))))})})}function d(N,K,X){const L=f(X);if(!r)return u.writeFileSync(N,K,{mode:L.mode,flag:L.flag});const $=u.openSync(N,L.flag,L.mode);try{u.writeFileSync($,K);try{u.fdatasyncSync($)}catch(H){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",H),n(!1)}}finally{u.closeSync($)}}e.writeFileSync=d;function f(N){return N?{mode:typeof N.mode=="number"?N.mode:438,flag:typeof N.flag=="string"?N.flag:"w"}:{mode:438,flag:"w"}}async function S(N,K){if(N!==K)try{await e.Promises.rename(N,K)}catch(X){if(N.toLowerCase()!==K.toLowerCase()&&X.code==="EXDEV"||N.endsWith("."))await O(N,K,{preserveSymlinks:!1}),await T(N,_.MOVE);else throw X}}async function O(N,K,X){return M(N,K,{root:{source:N,target:K},options:X,handledSourcePaths:new Set})}const U=511;async function M(N,K,X){if(X.handledSourcePaths.has(N))return;X.handledSourcePaths.add(N);const{stat:L,symbolicLink:$}=await l.stat(N);if($){if(X.options.preserveSymlinks)try{return await x(N,K,X)}catch(H){console.warn("[node.js fs] copy of symlink failed: ",H)}if($.dangling)return}return L.isDirectory()?A(N,K,L.mode&U,X):B(N,K,L.mode&U)}async function A(N,K,X,L){await e.Promises.mkdir(K,{recursive:!0,mode:X});const $=await h(N);for(const H of $)await M((0,E.join)(N,H),(0,E.join)(K,H),L)}async function B(N,K,X){await e.Promises.copyFile(N,K),await e.Promises.chmod(K,X)}async function x(N,K,X){let L=await e.Promises.readlink(N);(0,y.isEqualOrParent)(L,X.root.source,!I.isLinux)&&(L=(0,E.join)(X.root.target,L.substr(X.root.source.length+1))),await e.Promises.symlink(L,K)}e.Promises=new class{get access(){return(0,D.promisify)(u.access)}get stat(){return(0,D.promisify)(u.stat)}get lstat(){return(0,D.promisify)(u.lstat)}get utimes(){return(0,D.promisify)(u.utimes)}get read(){return(N,K,X,L,$)=>new Promise((H,j)=>{u.read(N,K,X,L,$,(J,Y,he)=>J?j(J):H({bytesRead:Y,buffer:he}))})}get readFile(){return(0,D.promisify)(u.readFile)}get write(){return(N,K,X,L,$)=>new Promise((H,j)=>{u.write(N,K,X,L,$,(J,Y,he)=>J?j(J):H({bytesWritten:Y,buffer:he}))})}get appendFile(){return(0,D.promisify)(u.appendFile)}get fdatasync(){return(0,D.promisify)(u.fdatasync)}get truncate(){return(0,D.promisify)(u.truncate)}get rename(){return(0,D.promisify)(u.rename)}get copyFile(){return(0,D.promisify)(u.copyFile)}get open(){return(0,D.promisify)(u.open)}get close(){return(0,D.promisify)(u.close)}get symlink(){return(0,D.promisify)(u.symlink)}get readlink(){return(0,D.promisify)(u.readlink)}get chmod(){return(0,D.promisify)(u.chmod)}get mkdir(){return(0,D.promisify)(u.mkdir)}get unlink(){return(0,D.promisify)(u.unlink)}get rmdir(){return(0,D.promisify)(u.rmdir)}get realpath(){return(0,D.promisify)(u.realpath)}async exists(N){try{return await e.Promises.access(N),!0}catch{return!1}}get readdir(){return h}get readDirsInDir(){return m}get writeFile(){return i}get rm(){return T}get move(){return S}get copy(){return O}}}),define(De[108],Ie([1,0,62,9,11,8,29]),function(Z,e,u,t,D,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function C(_){if(D.isLinux)return _;const T=(0,t.dirname)(_);if(_===T)return _;const w=((0,t.basename)(_)||_).toLowerCase();try{const v=(0,y.readdirSync)(T).filter(h=>h.toLowerCase()===w);if(v.length===1){const h=C(T);if(h)return(0,t.join)(h,v[0])}else if(v.length>1){const h=v.indexOf(w);if(h>=0){const g=C(T);if(g)return(0,t.join)(g,v[h])}}}catch{}return null}e.realcaseSync=C;async function E(_){if(D.isLinux)return _;const T=(0,t.dirname)(_);if(_===T)return _;const w=((0,t.basename)(_)||_).toLowerCase();try{const v=(await y.Promises.readdir(T)).filter(h=>h.toLowerCase()===w);if(v.length===1){const h=await E(T);if(h)return(0,t.join)(h,v[0])}else if(v.length>1){const h=v.indexOf(w);if(h>=0){const g=await E(T);if(g)return(0,t.join)(g,v[h])}}}catch{}return null}e.realcase=E;async function I(_){try{return await y.Promises.realpath(_)}catch{const w=k(_);return await y.Promises.access(w,u.constants.R_OK),w}}e.realpath=I;function R(_){try{return u.realpathSync(_)}catch{const w=k(_);return u.accessSync(w,u.constants.R_OK),w}}e.realpathSync=R;function k(_){return(0,P.rtrim)((0,t.normalize)(_),t.sep)}}),define(De[109],Ie([1,0,9,11,40,101,13,29]),function(Z,e,u,t,D,P,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return P.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return P.TerminateResponseCode}});function E(k=D.env){return k.comspec||"cmd.exe"}e.getWindowsShell=E;function I(k){let _=[],T=!1;const w=function(b){if(T){_.push(b);return}(!k.send(b,h=>{if(h&&console.error(h),T=!1,_.length>0){const g=_.slice(0);_=[],g.forEach(p=>w(p))}})||t.isWindows)&&(T=!0)};return{send:w}}e.createQueuedSender=I;var R;(function(k){async function _(T,w,b){if(u.isAbsolute(T))return T;if(w===void 0&&(w=D.cwd()),u.dirname(T)!=="."||(b===void 0&&y.isString(D.env.PATH)&&(b=D.env.PATH.split(u.delimiter)),b===void 0||b.length===0))return u.join(w,T);async function h(g){if(await C.Promises.exists(g)){let p;try{p=await C.Promises.stat(g)}catch(o){o.message.startsWith("EACCES")&&(p=await C.Promises.lstat(g))}return p?!p.isDirectory():!1}return!1}for(const g of b){let p;if(u.isAbsolute(g)?p=u.join(g,T):p=u.join(w,g,T),await h(p))return p;let o=p+".com";if(await h(o)||(o=p+".exe",await h(o)))return o}return u.join(w,T)}k.findExecutable=_})(R=e.win32||(e.win32={}))});var je=this&&this.__decorate||function(Z,e,u,t){var D=arguments.length,P=D<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,u):t,y;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")P=Reflect.decorate(Z,e,u,t);else for(var C=Z.length-1;C>=0;C--)(y=Z[C])&&(P=(D<3?y(P):D>3?y(e,u,P):y(e,u))||P);return D>3&&P&&Object.defineProperty(e,u,P),P};define(De[110],Ie([1,0,17,18,23,21,57,10,4,6,61,8,13]),function(Z,e,u,t,D,P,y,C,E,I,R,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var T;(function($){$[$.Promise=100]="Promise",$[$.PromiseCancel=101]="PromiseCancel",$[$.EventListen=102]="EventListen",$[$.EventDispose=103]="EventDispose"})(T=e.RequestType||(e.RequestType={}));function w($){switch($){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var b;(function($){$[$.Initialize=200]="Initialize",$[$.PromiseSuccess=201]="PromiseSuccess",$[$.PromiseError=202]="PromiseError",$[$.PromiseErrorObj=203]="PromiseErrorObj",$[$.EventFire=204]="EventFire"})(b=e.ResponseType||(e.ResponseType={}));function v($){switch($){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var h;(function($){$[$.Uninitialized=0]="Uninitialized",$[$.Idle=1]="Idle"})(h||(h={}));class g{constructor(H){this.buffer=H,this.pos=0}read(H){const j=this.buffer.slice(this.pos,this.pos+H);return this.pos+=j.byteLength,j}}class p{constructor(){this.buffers=[]}get buffer(){return D.VSBuffer.concat(this.buffers)}write(H){this.buffers.push(H)}}var o;(function($){$[$.Undefined=0]="Undefined",$[$.String=1]="String",$[$.Buffer=2]="Buffer",$[$.VSBuffer=3]="VSBuffer",$[$.Array=4]="Array",$[$.Object=5]="Object"})(o||(o={}));function m($){const H=D.VSBuffer.alloc(4);return H.writeUInt32BE($,0),H}function c($){return $.read(4).readUInt32BE(0)}function l($){const H=D.VSBuffer.alloc(1);return H.writeUInt8($,0),H}const s={Undefined:l(o.Undefined),String:l(o.String),Buffer:l(o.Buffer),VSBuffer:l(o.VSBuffer),Array:l(o.Array),Object:l(o.Object)},i=typeof Buffer!="undefined";function r($,H){if(typeof H=="undefined")$.write(s.Undefined);else if(typeof H=="string"){const j=D.VSBuffer.fromString(H);$.write(s.String),$.write(m(j.byteLength)),$.write(j)}else if(i&&Buffer.isBuffer(H)){const j=D.VSBuffer.wrap(H);$.write(s.Buffer),$.write(m(j.byteLength)),$.write(j)}else if(H instanceof D.VSBuffer)$.write(s.VSBuffer),$.write(m(H.byteLength)),$.write(H);else if(Array.isArray(H)){$.write(s.Array),$.write(m(H.length));for(const j of H)r($,j)}else{const j=D.VSBuffer.fromString(JSON.stringify(H));$.write(s.Object),$.write(m(j.byteLength)),$.write(j)}}function n($){switch($.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return $.read(c($)).toString();case o.Buffer:return $.read(c($)).buffer;case o.VSBuffer:return $.read(c($));case o.Array:{const j=c($),J=[];for(let Y=0;Y<j;Y++)J.push(n($));return J}case o.Object:return JSON.parse($.read(c($)).toString())}}class a{constructor(H,j,J=null,Y=1e3){this.protocol=H,this.ctx=j,this.logger=J,this.timeoutDelay=Y,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(he=>this.onRawMessage(he)),this.sendResponse({type:200})}registerChannel(H,j){this.channels.set(H,j),setTimeout(()=>this.flushPendingRequests(H),0)}sendResponse(H){switch(H.type){case 200:{const j=this.send([H.type]);this.logger?.logOutgoing(j,0,1,v(H.type));return}case 201:case 202:case 204:case 203:{const j=this.send([H.type,H.id],H.data);this.logger?.logOutgoing(j,H.id,1,v(H.type),H.data);return}}}send(H,j=void 0){const J=new p;return r(J,H),r(J,j),this.sendBuffer(J.buffer)}sendBuffer(H){try{return this.protocol.send(H),H.byteLength}catch{return 0}}onRawMessage(H){const j=new g(H),J=n(j),Y=n(j),he=J[0];switch(he){case 100:return this.logger?.logIncoming(H.byteLength,J[1],1,`${w(he)}: ${J[2]}.${J[3]}`,Y),this.onPromise({type:he,id:J[1],channelName:J[2],name:J[3],arg:Y});case 102:return this.logger?.logIncoming(H.byteLength,J[1],1,`${w(he)}: ${J[2]}.${J[3]}`,Y),this.onEventListen({type:he,id:J[1],channelName:J[2],name:J[3],arg:Y});case 101:return this.logger?.logIncoming(H.byteLength,J[1],1,`${w(he)}`),this.disposeActiveRequest({type:he,id:J[1]});case 103:return this.logger?.logIncoming(H.byteLength,J[1],1,`${w(he)}`),this.disposeActiveRequest({type:he,id:J[1]})}}onPromise(H){const j=this.channels.get(H.channelName);if(!j){this.collectPendingRequest(H);return}const J=new P.CancellationTokenSource;let Y;try{Y=j.call(this.ctx,H.name,H.arg,J.token)}catch(ne){Y=Promise.reject(ne)}const he=H.id;Y.then(ne=>{this.sendResponse({id:he,data:ne,type:201}),this.activeRequests.delete(H.id)},ne=>{ne instanceof Error?this.sendResponse({id:he,data:{message:ne.message,name:ne.name,stack:ne.stack?ne.stack.split?ne.stack.split(`
`):ne.stack:void 0},type:202}):this.sendResponse({id:he,data:ne,type:203}),this.activeRequests.delete(H.id)});const ve=(0,I.toDisposable)(()=>J.cancel());this.activeRequests.set(H.id,ve)}onEventListen(H){const j=this.channels.get(H.channelName);if(!j){this.collectPendingRequest(H);return}const J=H.id,he=j.listen(this.ctx,H.name,H.arg)(ve=>this.sendResponse({id:J,data:ve,type:204}));this.activeRequests.set(H.id,he)}disposeActiveRequest(H){const j=this.activeRequests.get(H.id);j&&(j.dispose(),this.activeRequests.delete(H.id))}collectPendingRequest(H){let j=this.pendingRequests.get(H.channelName);j||(j=[],this.pendingRequests.set(H.channelName,j));const J=setTimeout(()=>{console.error(`Unknown channel: ${H.channelName}`),H.type===100&&this.sendResponse({id:H.id,data:{name:"Unknown channel",message:`Channel name '${H.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);j.push({request:H,timeoutTimer:J})}flushPendingRequests(H){const j=this.pendingRequests.get(H);if(j){for(const J of j)switch(clearTimeout(J.timeoutTimer),J.request.type){case 100:this.onPromise(J.request);break;case 102:this.onEventListen(J.request);break}this.pendingRequests.delete(H)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,I.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=a;var d;(function($){$[$.LocalSide=0]="LocalSide",$[$.OtherSide=1]="OtherSide"})(d=e.RequestInitiator||(e.RequestInitiator={}));class f{constructor(H,j=null){this.protocol=H,this.isDisposed=!1,this.state=h.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new E.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(J=>this.onBuffer(J)),this.logger=j}getChannel(H){const j=this;return{call(J,Y,he){return j.isDisposed?Promise.reject(C.canceled()):j.requestPromise(H,J,Y,he)},listen(J,Y){return j.isDisposed?E.Event.None:j.requestEvent(H,J,Y)}}}requestPromise(H,j,J,Y=P.CancellationToken.None){const he=this.lastRequestId++,ne={id:he,type:100,channelName:H,name:j,arg:J};if(Y.isCancellationRequested)return Promise.reject(C.canceled());let pe;return new Promise((ke,Oe)=>{if(Y.isCancellationRequested)return Oe(C.canceled());const Be=()=>{const te=le=>{switch(le.type){case 201:this.handlers.delete(he),ke(le.data);break;case 202:{this.handlers.delete(he);const ee=new Error(le.data.message);ee.stack=le.data.stack,ee.name=le.data.name,Oe(ee);break}case 203:this.handlers.delete(he),Oe(le.data);break}};this.handlers.set(he,te),this.sendRequest(ne)};let ae=null;this.state===h.Idle?Be():(ae=(0,t.createCancelablePromise)(te=>this.whenInitialized()),ae.then(()=>{ae=null,Be()}));const de=()=>{ae?(ae.cancel(),ae=null):this.sendRequest({id:he,type:101}),Oe(C.canceled())},me=Y.onCancellationRequested(de);pe=(0,I.combinedDisposable)((0,I.toDisposable)(de),me),this.activeRequests.add(pe)}).finally(()=>{this.activeRequests.delete(pe)})}requestEvent(H,j,J){const Y=this.lastRequestId++,ve={id:Y,type:102,channelName:H,name:j,arg:J};let ne=null;const pe=new E.Emitter({onFirstListenerAdd:()=>{ne=(0,t.createCancelablePromise)(ke=>this.whenInitialized()),ne.then(()=>{ne=null,this.activeRequests.add(pe),this.sendRequest(ve)})},onLastListenerRemove:()=>{ne?(ne.cancel(),ne=null):(this.activeRequests.delete(pe),this.sendRequest({id:Y,type:103}))}}),Ee=ke=>pe.fire(ke.data);return this.handlers.set(Y,Ee),pe.event}sendRequest(H){switch(H.type){case 100:case 102:{const j=this.send([H.type,H.id,H.channelName,H.name],H.arg);this.logger?.logOutgoing(j,H.id,0,`${w(H.type)}: ${H.channelName}.${H.name}`,H.arg);return}case 101:case 103:{const j=this.send([H.type,H.id]);this.logger?.logOutgoing(j,H.id,0,w(H.type));return}}}send(H,j=void 0){const J=new p;return r(J,H),r(J,j),this.sendBuffer(J.buffer)}sendBuffer(H){try{return this.protocol.send(H),H.byteLength}catch{return 0}}onBuffer(H){const j=new g(H),J=n(j),Y=n(j),he=J[0];switch(he){case 200:return this.logger?.logIncoming(H.byteLength,0,0,v(he)),this.onResponse({type:J[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(H.byteLength,J[1],0,v(he),Y),this.onResponse({type:J[0],id:J[1],data:Y})}}onResponse(H){if(H.type===200){this.state=h.Idle,this._onDidInitialize.fire();return}this.handlers.get(H.id)?.(H)}get onDidInitializePromise(){return E.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,I.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}je([y.memoize],f.prototype,"onDidInitializePromise",null),e.ChannelClient=f;class S{constructor(H){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new E.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new E.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,H(({protocol:j,onDidClientDisconnect:J})=>{E.Event.once(j.onMessage)(he=>{const ve=new g(he),ne=n(ve),pe=new a(j,ne),Ee=new f(j);this.channels.forEach((Oe,Be)=>pe.registerChannel(Be,Oe));const ke={channelServer:pe,channelClient:Ee,ctx:ne};this._connections.add(ke),this._onDidAddConnection.fire(ke),J(()=>{pe.dispose(),Ee.dispose(),this._connections.delete(ke),this._onDidRemoveConnection.fire(ke)})})})}get connections(){const H=[];return this._connections.forEach(j=>H.push(j)),H}getChannel(H,j){const J=this;return{call(Y,he,ve){let ne;if((0,_.isFunction)(j)){const Ee=(0,u.getRandomElement)(J.connections.filter(j));ne=Ee?Promise.resolve(Ee):E.Event.toPromise(E.Event.filter(J.onDidAddConnection,j))}else ne=j.routeCall(J,Y,he);const pe=ne.then(Ee=>Ee.channelClient.getChannel(H));return U(pe).call(Y,he,ve)},listen(Y,he){if((0,_.isFunction)(j))return J.getMulticastEvent(H,j,Y,he);const ve=j.routeEvent(J,Y,he).then(ne=>ne.channelClient.getChannel(H));return U(ve).listen(Y,he)}}}getMulticastEvent(H,j,J,Y){const he=this;let ve=new I.DisposableStore;const ne=new E.Emitter({onFirstListenerAdd:()=>{ve=new I.DisposableStore;const pe=new E.EventMultiplexer,Ee=new Map,ke=Be=>{const de=Be.channelClient.getChannel(H).listen(J,Y),me=pe.add(de);Ee.set(Be,me)},Oe=Be=>{const ae=Ee.get(Be);!ae||(ae.dispose(),Ee.delete(Be))};he.connections.filter(j).forEach(ke),E.Event.filter(he.onDidAddConnection,j)(ke,void 0,ve),he.onDidRemoveConnection(Oe,void 0,ve),pe.event(ne.fire,ne,ve),ve.add(pe)},onLastListenerRemove:()=>{ve.dispose()}});return ne.event}registerChannel(H,j){this.channels.set(H,j),this._connections.forEach(J=>{J.channelServer.registerChannel(H,j)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=S;class O{constructor(H,j,J=null){const Y=new p;r(Y,j),H.send(Y.buffer),this.channelClient=new f(H,J),this.channelServer=new a(H,j,J)}getChannel(H){return this.channelClient.getChannel(H)}registerChannel(H,j){this.channelServer.registerChannel(H,j)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=O;function U($){return{call(H,j,J){return $.then(Y=>Y.call(H,j,J))},listen(H,j){const J=new E.Relay;return $.then(Y=>J.input=Y.listen(H,j)),J.event}}}e.getDelayedChannel=U;function M($){let H=!1;return{call(j,J,Y){return H?$.call(j,J,Y):(0,t.timeout)(0).then(()=>H=!0).then(()=>$.call(j,J,Y))},listen(j,J){if(H)return $.listen(j,J);const Y=new E.Relay;return(0,t.timeout)(0).then(()=>H=!0).then(()=>Y.input=$.listen(j,J)),Y.event}}}e.getNextTickChannel=M;class A{constructor(H){this.fn=H}routeCall(H){return this.route(H)}routeEvent(H){return this.route(H)}async route(H){for(const j of H.connections)if(await Promise.resolve(this.fn(j.ctx)))return Promise.resolve(j);return await E.Event.toPromise(H.onDidAddConnection),await this.route(H)}}e.StaticRouter=A;var B;(function($){function H(he,ve){const ne=he,pe=ve&&ve.disableMarshalling,Ee=new Map;for(const ke in ne)J(ke)&&Ee.set(ke,E.Event.buffer(ne[ke],!0));return new class{listen(ke,Oe,Be){const ae=Ee.get(Oe);if(ae)return ae;if(Y(Oe)){const de=ne[Oe];if(typeof de=="function")return de.call(ne,Be)}throw new Error(`Event not found: ${Oe}`)}call(ke,Oe,Be){const ae=ne[Oe];if(typeof ae=="function"){if(!pe&&Array.isArray(Be))for(let de=0;de<Be.length;de++)Be[de]=(0,R.revive)(Be[de]);return ae.apply(ne,Be)}throw new Error(`Method not found: ${Oe}`)}}}$.fromService=H;function j(he,ve){const ne=ve&&ve.disableMarshalling;return new Proxy({},{get(pe,Ee){if(typeof Ee=="string")return ve?.properties?.has(Ee)?ve.properties.get(Ee):Y(Ee)?function(ke){return he.listen(Ee,ke)}:J(Ee)?he.listen(Ee):async function(...ke){let Oe;ve&&!(0,_.isUndefinedOrNull)(ve.context)?Oe=[ve.context,...ke]:Oe=ke;const Be=await he.call(Ee,Oe);return ne?Be:(0,R.revive)(Be)};throw new Error(`Property not found: ${String(Ee)}`)}})}$.toService=j;function J(he){return he[0]==="o"&&he[1]==="n"&&k.isUpperAsciiLetter(he.charCodeAt(2))}function Y(he){return/^onDynamic/.test(he)&&k.isUpperAsciiLetter(he.charCodeAt(9))}})(B=e.ProxyChannel||(e.ProxyChannel={}));const x=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function N($){if(Array.isArray($))return $;if($&&typeof $=="object"&&typeof $.toString=="function"){const H=$.toString();if(H!=="[object Object]")return H}return $}function K($){return Array.isArray($)?$.map(N):N($)}function X($,H,j,J,Y,he,ve){ve=K(ve);const ne=x[Y],pe=ne[J%ne.length];let Ee=[`%c[${$}]%c[${String(H).padStart(7," ")}]%c[len: ${String(j).padStart(5," ")}]%c${String(J).padStart(5," ")} - ${he}`,"color: darkgreen","color: grey","color: grey",`color: ${pe}`];/\($/.test(he)?(Ee=Ee.concat(ve),Ee.push(")")):Ee.push(ve),console.log.apply(console,Ee)}e.logWithColors=X;class L{constructor(H,j){this._outgoingPrefix=H,this._incomingPrefix=j,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(H,j,J,Y,he){this._totalOutgoing+=H,X(this._outgoingPrefix,this._totalOutgoing,H,j,J,Y,he)}logIncoming(H,j,J,Y,he){this._totalIncoming+=H,X(this._incomingPrefix,this._totalIncoming,H,j,J,Y,he)}}e.IPCLogger=L}),define(De[111],Ie([1,0,23,4,6,110]),function(Z,e,u,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var y;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(y=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var C;(function(i){i.enableDiagnostics=!1,i.records=[];const r=new WeakMap;let n=0;function a(f,S){if(!r.has(f)){const O=String(++n);r.set(f,O)}return r.get(f)}function d(f,S,O,U){if(!i.enableDiagnostics)return;const M=a(f,S);if(U instanceof u.VSBuffer||U instanceof Uint8Array||U instanceof ArrayBuffer||ArrayBuffer.isView(U)){const A=u.VSBuffer.alloc(U.byteLength);A.set(U),i.records.push({timestamp:Date.now(),id:M,label:S,type:O,buff:A})}else i.records.push({timestamp:Date.now(),id:M,label:S,type:O,data:U})}i.traceSocketEvent=d})(C=e.SocketDiagnostics||(e.SocketDiagnostics={}));var E;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(E=e.SocketCloseEventType||(e.SocketCloseEventType={}));let I=null;function R(){return I||(I=u.VSBuffer.alloc(0)),I}class k{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(r){this._chunks.push(r),this._totalLength+=r.byteLength}read(r){return this._read(r,!0)}peek(r){return this._read(r,!1)}_read(r,n){if(r===0)return R();if(r>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===r){const S=this._chunks[0];return n&&(this._chunks.shift(),this._totalLength-=r),S}if(this._chunks[0].byteLength>r){const S=this._chunks[0].slice(0,r);return n&&(this._chunks[0]=this._chunks[0].slice(r),this._totalLength-=r),S}const a=u.VSBuffer.alloc(r);let d=0,f=0;for(;r>0;){const S=this._chunks[f];if(S.byteLength>r){const O=S.slice(0,r);a.set(O,d),d+=r,n&&(this._chunks[f]=S.slice(r),this._totalLength-=r),r-=r}else a.set(S,d),d+=S.byteLength,n?(this._chunks.shift(),this._totalLength-=S.byteLength):f++,r-=S.byteLength}return a}}e.ChunkStream=k;var _;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume"})(_||(_={}));function T(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var w;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(w=e.ProtocolConstants||(e.ProtocolConstants={}));class b{constructor(r,n,a,d){this.type=r,this.id=n,this.ack=a,this.data=d,this.writtenTime=0}get size(){return this.data.byteLength}}class v extends D.Disposable{constructor(r){super();this._onMessage=this._register(new t.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=r,this._isDisposed=!1,this._incomingData=new k,this._register(this._socket.onData(n=>this.acceptChunk(n))),this.lastReadTime=Date.now()}acceptChunk(r){if(!(!r||r.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(r);this._incomingData.byteLength>=this._state.readLen;){const n=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=n.readUInt32BE(9),this._state.messageType=n.readUInt8(0),this._state.id=n.readUInt32BE(1),this._state.ack=n.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:T(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const a=this._state.messageType,d=this._state.id,f=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",n),this._onMessage.fire(new b(a,d,f,n)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class h{constructor(r){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=r,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(r){if(this._isDisposed)return;r.writtenTime=Date.now(),this.lastWriteTime=Date.now();const n=u.VSBuffer.alloc(13);n.writeUInt8(r.type,0),n.writeUInt32BE(r.id,1),n.writeUInt32BE(r.ack,5),n.writeUInt32BE(r.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:T(r.type),id:r.id,ack:r.ack,messageSize:r.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",r.data),this._writeSoon(n,r.data)}_bufferAdd(r,n){const a=this._totalLength===0;return this._data.push(r,n),this._totalLength+=r.byteLength+n.byteLength,a}_bufferTake(){const r=u.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,r}_writeSoon(r,n){this._bufferAdd(r,n)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const r=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:r.byteLength}),this._socket.write(r)}}class g extends D.Disposable{constructor(r){super();this._onMessage=new t.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=r,this._socketWriter=this._register(new h(this._socket)),this._socketReader=this._register(new v(this._socket)),this._register(this._socketReader.onMessage(n=>{n.type===1&&this._onMessage.fire(n.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(r){this._socketWriter.write(new b(1,0,0,r))}}e.Protocol=g;class p extends P.IPCClient{constructor(r,n,a=null){super(r,n,a);this.protocol=r}static fromSocket(r,n){return new p(new g(r),n)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const r=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),r.end()}}e.Client=p;class o{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new t.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(r){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(r):this._emitter.fire(r):this._bufferedMessages.push(r)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=o;class m{constructor(r){this.data=r,this.next=null}}class c{constructor(){this._first=null,this._last=null}length(){let r=0,n=this._first;for(;n;)n=n.next,r++;return r}peek(){return this._first?this._first.data:null}toArray(){const r=[];let n=0,a=this._first;for(;a;)r[n++]=a.data,a=a.next;return r}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(r){const n=new m(r);if(!this._first){this._first=n,this._last=n;return}this._last.next=n,this._last=n}}class l{constructor(){this.lastRuns=[];const r=Date.now();for(let n=0;n<l._HISTORY_LENGTH;n++)this.lastRuns[n]=r-1e3*n;setInterval(()=>{for(let n=l._HISTORY_LENGTH;n>=1;n--)this.lastRuns[n]=this.lastRuns[n-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return l._INSTANCE||(l._INSTANCE=new l),l._INSTANCE}load(){const r=Date.now(),n=(1+l._HISTORY_LENGTH)*1e3;let a=0;for(let d=0;d<l._HISTORY_LENGTH;d++)r-this.lastRuns[d]<=n&&a++;return 1-a/l._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}l._HISTORY_LENGTH=10,l._INSTANCE=null;class s{constructor(r,n=null,a=l.getInstance()){this._onControlMessage=new o,this.onControlMessage=this._onControlMessage.event,this._onMessage=new o,this.onMessage=this._onMessage.event,this._onDidDispose=new o,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new o,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new o,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=a,this._isReconnecting=!1,this._outgoingUnackMsg=new c,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=r,this._socketWriter=new h(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new v(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(d=>this._receiveMessage(d))),this._socketDisposables.push(this._socket.onClose(d=>this._onSocketClose.fire(d))),n&&this._socketReader.acceptChunk(n)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,D.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const r=new b(5,0,0,R());this._socketWriter.write(r),this._socketWriter.flush()}sendPause(){const r=new b(7,0,0,R());this._socketWriter.write(r)}sendResume(){const r=new b(8,0,0,R());this._socketWriter.write(r)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(r,n){this._isReconnecting=!0,this._socketDisposables=(0,D.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=r,this._socketWriter=new h(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new v(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(a=>this._receiveMessage(a))),this._socketDisposables.push(this._socket.onClose(a=>this._onSocketClose.fire(a))),this._socketReader.acceptChunk(n)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const r=new b(3,0,this._incomingAckId,R());this._socketWriter.write(r);const n=this._outgoingUnackMsg.toArray();for(let a=0,d=n.length;a<d;a++)this._socketWriter.write(n[a]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(r){if(r.ack>this._outgoingAckId){this._outgoingAckId=r.ack;do{const n=this._outgoingUnackMsg.peek();if(n&&n.id<=r.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(r.type){case 0:break;case 1:{if(r.id>this._incomingMsgId)if(r.id!==this._incomingMsgId+1){const n=Date.now();n-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=n,this._socketWriter.write(new b(6,0,0,R())))}else this._incomingMsgId=r.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(r.data);break}case 2:{this._onControlMessage.fire(r.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const n=this._outgoingUnackMsg.toArray();for(let a=0,d=n.length;a<d;a++)this._socketWriter.write(n[a]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(r){const n=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const a=new b(1,n,this._incomingAckId,r);this._outgoingUnackMsg.push(a),this._isReconnecting||(this._socketWriter.write(a),this._recvAckCheck())}sendControl(r){const n=new b(2,0,0,r);this._socketWriter.write(n)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const r=Date.now()-this._incomingMsgLastTime;if(r>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-r+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const r=this._outgoingUnackMsg.peek(),n=Date.now()-r.writtenTime,a=Date.now()-this._socketReader.lastReadTime,d=Date.now()-this._lastSocketTimeoutTime;if(n>=2e4&&a>=2e4&&d>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:n,timeSinceLastReceivedSomeData:a});return}const f=Math.max(2e4-n,2e4-a,2e4-d,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},f)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const r=new b(3,0,this._incomingAckId,R());this._socketWriter.write(r)}}e.PersistentProtocol=s}),define(De[112],Ie([1,0,23,10,4,6,9,11,34,110,111]),function(Z,e,u,t,D,P,y,C,E,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function k(){return{crypto:Z.__$__nodeRequire("crypto"),zlib:Z.__$__nodeRequire("zlib"),net:Z.__$__nodeRequire("net"),os:Z.__$__nodeRequire("os")}}class _{constructor(a,d=""){this.debugLabel=d,this.socket=a,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=f=>{if(this.traceSocketEvent("error",{code:f?.code,message:f?.message}),f){if(f.code==="EPIPE")return;(0,t.onUnexpectedError)(f)}},this.socket.on("error",this._errorListener)}traceSocketEvent(a,d){R.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,a,d)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(a){const d=f=>{this.traceSocketEvent("read",f),a(u.VSBuffer.wrap(f))};return this.socket.on("data",d),{dispose:()=>this.socket.off("data",d)}}onClose(a){const d=f=>{this.traceSocketEvent("close",{hadError:f}),a({type:0,hadError:f,error:void 0})};return this.socket.on("close",d),{dispose:()=>this.socket.off("close",d)}}onEnd(a){const d=()=>{this.traceSocketEvent("nodeEndReceived"),a()};return this.socket.on("end",d),{dispose:()=>this.socket.off("end",d)}}write(a){if(!this.socket.destroyed)try{this.traceSocketEvent("write",a),this.socket.write(a.buffer,d=>{if(d){if(d.code==="EPIPE")return;(0,t.onUnexpectedError)(d)}})}catch(d){if(d.code==="EPIPE")return;(0,t.onUnexpectedError)(d)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((a,d)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),a();return}const f=()=>{this.socket.off("close",f),this.socket.off("end",f),this.socket.off("error",f),this.socket.off("timeout",f),this.socket.off("drain",f),this.traceSocketEvent("nodeDrainEnd"),a()};this.socket.on("close",f),this.socket.on("end",f),this.socket.on("error",f),this.socket.on("timeout",f),this.socket.on("drain",f)})}}e.NodeSocket=_;var T;(function(n){n[n.MinHeaderByteSize=2]="MinHeaderByteSize"})(T||(T={}));var w;(function(n){n[n.PeekHeader=1]="PeekHeader",n[n.ReadHeader=2]="ReadHeader",n[n.ReadBody=3]="ReadBody",n[n.Fin=4]="Fin"})(w||(w={}));class b extends P.Disposable{constructor(a,d,f,S){super();this._onData=this._register(new D.Emitter),this._onClose=this._register(new D.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=a,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:d,inflateBytesLength:f?.byteLength||0,recordInflateBytes:S}),this._flowManager=this._register(new v(this,d,f,S,this._onData,(O,U)=>this._write(O,U))),this._register(this._flowManager.onError(O=>{console.error(O),(0,t.onUnexpectedError)(O),this._onClose.fire({type:0,hadError:!0,error:O})})),this._incomingData=new R.ChunkStream,this._register(this.socket.onData(O=>this._acceptChunk(O))),this._register(this.socket.onClose(O=>this._onClose.fire(O)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(a,d){this.socket.traceSocketEvent(a,d)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(a){return this._onData.event(a)}onClose(a){return this._onClose.event(a)}onEnd(a){return this.socket.onEnd(a)}write(a){this._flowManager.writeMessage(a)}_write(a,d){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",a);let f=2;a.byteLength<126?f+=0:a.byteLength<2**16?f+=2:f+=8;const S=u.VSBuffer.alloc(f);if(d?S.writeUInt8(194,0):S.writeUInt8(130,0),a.byteLength<126)S.writeUInt8(a.byteLength,1);else if(a.byteLength<2**16){S.writeUInt8(126,1);let O=1;S.writeUInt8(a.byteLength>>>8&255,++O),S.writeUInt8(a.byteLength>>>0&255,++O)}else{S.writeUInt8(127,1);let O=1;S.writeUInt8(0,++O),S.writeUInt8(0,++O),S.writeUInt8(0,++O),S.writeUInt8(0,++O),S.writeUInt8(a.byteLength>>>24&255,++O),S.writeUInt8(a.byteLength>>>16&255,++O),S.writeUInt8(a.byteLength>>>8&255,++O),S.writeUInt8(a.byteLength>>>0&255,++O)}this.socket.write(u.VSBuffer.concat([S,a]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(a){if(a.byteLength!==0){for(this._incomingData.acceptChunk(a);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const d=this._incomingData.peek(this._state.readLen),f=d.readUInt8(0),S=(f&128)>>>7,O=(f&64)>>>6,U=d.readUInt8(1),M=(U&128)>>>7,A=U&127;this._state.state=2,this._state.readLen=2+(M?4:0)+(A===126?2:0)+(A===127?8:0),this._state.fin=S,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(O)),this._state.firstFrameOfMessage=Boolean(S),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const d=this._incomingData.read(this._state.readLen),f=d.readUInt8(1),S=(f&128)>>>7;let O=f&127,U=1;O===126?O=d.readUInt8(++U)*2**8+d.readUInt8(++U):O===127&&(O=d.readUInt8(++U)*0+d.readUInt8(++U)*0+d.readUInt8(++U)*0+d.readUInt8(++U)*0+d.readUInt8(++U)*2**24+d.readUInt8(++U)*2**16+d.readUInt8(++U)*2**8+d.readUInt8(++U));let M=0;S&&(M=d.readUInt8(++U)*2**24+d.readUInt8(++U)*2**16+d.readUInt8(++U)*2**8+d.readUInt8(++U)),this._state.state=3,this._state.readLen=O,this._state.mask=M,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const d=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",d),p(d,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",d),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(d,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await D.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=b;class v extends P.Disposable{constructor(a,d,f,S,O,U){super();this._tracer=a,this._onData=O,this._writeFn=U,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new D.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,d?(this._zlibInflateStream=this._register(new h(this._tracer,S,f,{windowBits:15})),this._zlibDeflateStream=this._register(new g(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(M=>this._onError.fire(M))),this._register(this._zlibDeflateStream.onError(M=>this._onError.fire(M)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:u.VSBuffer.alloc(0)}writeMessage(a){this._writeQueue.push(a),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const a=this._writeQueue.shift();if(this._zlibDeflateStream){const d=await this._deflateMessage(this._zlibDeflateStream,a);this._writeFn(d,!0)}else this._writeFn(a,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(a,d){return new Promise((f,S)=>{a.write(d),a.flush(O=>f(O))})}acceptFrame(a,d,f){this._readQueue.push({data:a,isCompressed:d,isLastFrameOfMessage:f}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const a=this._readQueue.shift();if(this._zlibInflateStream&&a.isCompressed){const d=await this._inflateFrame(this._zlibInflateStream,a.data,a.isLastFrameOfMessage);this._onData.fire(d)}else this._onData.fire(a.data)}this._isProcessingReadQueue=!1}}_inflateFrame(a,d,f){return new Promise((S,O)=>{a.write(d),f&&a.write(u.VSBuffer.fromByteArray([0,0,255,255])),a.flush(U=>S(U))})}}class h extends P.Disposable{constructor(a,d,f,S){super();this._tracer=a,this._recordInflateBytes=d,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=k().zlib.createInflateRaw(S),this._zlibInflate.on("error",O=>{this._tracer.traceSocketEvent("zlibInflateError",{message:O?.message,code:O?.code}),this._onError.fire(O)}),this._zlibInflate.on("data",O=>{this._tracer.traceSocketEvent("zlibInflateData",O),this._pendingInflateData.push(u.VSBuffer.wrap(O))}),f&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",f.buffer),this._zlibInflate.write(f.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?u.VSBuffer.concat(this._recordedInflateBytes):u.VSBuffer.alloc(0)}write(a){this._recordInflateBytes&&this._recordedInflateBytes.push(a.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",a),this._zlibInflate.write(a.buffer)}flush(a){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const d=u.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,a(d)})}}class g extends P.Disposable{constructor(a,d){super();this._tracer=a,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=k().zlib.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",f=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:f?.message,code:f?.code}),this._onError.fire(f)}),this._zlibDeflate.on("data",f=>{this._tracer.traceSocketEvent("zlibDeflateData",f),this._pendingDeflateData.push(u.VSBuffer.wrap(f))})}write(a){this._tracer.traceSocketEvent("zlibDeflateWrite",a.buffer),this._zlibDeflate.write(a.buffer)}flush(a){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let d=u.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,d=d.slice(0,d.byteLength-4),a(d)})}}function p(n,a){if(a===0)return;const d=n.byteLength>>>2;for(let A=0;A<d;A++){const B=n.readUInt32BE(A*4);n.writeUInt32BE(B^a,A*4)}const f=d*4,S=n.byteLength-f,O=a>>>24&255,U=a>>>16&255,M=a>>>8&255;S>=1&&n.writeUInt8(n.readUInt8(f)^O,f),S>=2&&n.writeUInt8(n.readUInt8(f+1)^U,f+1),S>=3&&n.writeUInt8(n.readUInt8(f+2)^M,f+2)}e.XDG_RUNTIME_DIR=typeof process!="undefined"?process.env.XDG_RUNTIME_DIR:void 0;const o={[2]:107,[1]:103};function m(){const n=(0,E.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${n}-sock`;let a;return e.XDG_RUNTIME_DIR?a=(0,y.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${n}.sock`):a=(0,y.join)(k().os.tmpdir(),`vscode-ipc-${n}.sock`),l(a),a}e.createRandomIPCHandle=m;function c(n,a,d){const f=k().crypto.createHash("md5").update(n).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${f}-${d}-${a}-sock`;let S;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?S=(0,y.join)(e.XDG_RUNTIME_DIR,`vscode-${f.substr(0,8)}-${d}-${a}.sock`):S=(0,y.join)(n,`${d}-${a}.sock`),l(S),S}e.createStaticIPCHandle=c;function l(n){const a=o[C.platform];typeof a=="number"&&n.length>=a&&console.warn(`WARNING: IPC handle "${n}" is longer than ${a} chars, try a shorter --user-data-dir`)}class s extends I.IPCServer{constructor(a){super(s.toClientConnectionEvent(a));this.server=a}static toClientConnectionEvent(a){const d=D.Event.fromNodeEventEmitter(a,"connection");return D.Event.map(d,f=>({protocol:new R.Protocol(new _(f,"ipc-server-connection")),onDidClientDisconnect:D.Event.once(D.Event.fromNodeEventEmitter(f,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=s;function i(n){return new Promise((a,d)=>{const f=k().net.createServer();f.on("error",d),f.listen(n,()=>{f.removeListener("error",d),a(new s(f))})})}e.serve=i;function r(n,a){return new Promise((d,f)=>{const S=k().net.createConnection(n,()=>{S.removeListener("error",f),d(R.Client.fromSocket(new _(S,`ipc-client${a}`),a))});S.once("error",f)})}e.connect=r}),define(De[156],Ie([1,0,36,9]),function(Z,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function D(P,y,C,E,I,R){if(Array.isArray(P)){let k=0;for(const _ of P){const T=D(_,y,C,E,I,R);if(T===10)return T;T>k&&(k=T)}return k}else{if(typeof P=="string")return E?P==="*"?5:P===C?10:0:0;if(P){const{language:k,pattern:_,scheme:T,hasAccessToAllModels:w,notebookType:b}=P;if(!E&&!w)return 0;b&&I&&(y=I);let v=0;if(T)if(T===y.scheme)v=10;else if(T==="*")v=5;else return 0;if(k)if(k===C)v=10;else if(k==="*")v=Math.max(v,5);else return 0;if(b)if(b===R)v=10;else if(b==="*"&&R!==void 0)v=Math.max(v,5);else return 0;if(_){let h;if(typeof _=="string"?h=_:h={..._,base:(0,t.normalize)(_.base)},h===y.fsPath||(0,u.match)(h,y.fsPath))v=10;else return 0}return v}else return 0}}e.score=D}),define(De[157],Ie([1,0,8,49,149]),function(Z,e,u,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class P{constructor(C,E,I,R){this._uri=C,this._lines=E,this._eol=I,this._versionId=R,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(C){C.eol&&C.eol!==this._eol&&(this._eol=C.eol,this._lineStarts=null);const E=C.changes;for(const I of E)this._acceptDeleteRange(I.range),this._acceptInsertText(new t.Position(I.range.startLineNumber,I.range.startColumn),I.text);this._versionId=C.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const C=this._eol.length,E=this._lines.length,I=new Uint32Array(E);for(let R=0;R<E;R++)I[R]=this._lines[R].length+C;this._lineStarts=new D.PrefixSumComputer(I)}}_setLineText(C,E){this._lines[C]=E,this._lineStarts&&this._lineStarts.setValue(C,this._lines[C].length+this._eol.length)}_acceptDeleteRange(C){if(C.startLineNumber===C.endLineNumber){if(C.startColumn===C.endColumn)return;this._setLineText(C.startLineNumber-1,this._lines[C.startLineNumber-1].substring(0,C.startColumn-1)+this._lines[C.startLineNumber-1].substring(C.endColumn-1));return}this._setLineText(C.startLineNumber-1,this._lines[C.startLineNumber-1].substring(0,C.startColumn-1)+this._lines[C.endLineNumber-1].substring(C.endColumn-1)),this._lines.splice(C.startLineNumber,C.endLineNumber-C.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(C.startLineNumber,C.endLineNumber-C.startLineNumber)}_acceptInsertText(C,E){if(E.length===0)return;const I=(0,u.splitLines)(E);if(I.length===1){this._setLineText(C.lineNumber-1,this._lines[C.lineNumber-1].substring(0,C.column-1)+I[0]+this._lines[C.lineNumber-1].substring(C.column-1));return}I[I.length-1]+=this._lines[C.lineNumber-1].substring(C.column-1),this._setLineText(C.lineNumber-1,this._lines[C.lineNumber-1].substring(0,C.column-1)+I[0]);const R=new Uint32Array(I.length-1);for(let k=1;k<I.length;k++)this._lines.splice(C.lineNumber+k-1,0,I[k]),R[k-1]=I[k].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(C.lineNumber,R)}}e.MirrorTextModel=P}),define(De[158],Ie([1,0,8,146,49,35,99]),function(Z,e,u,t,D,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.isMultilineRegexSource=e.SearchParams=void 0;const C=999;class E{constructor(g,p,o,m){this.searchString=g,this.isRegex=p,this.matchCase=o,this.wordSeparators=m}parseSearchRequest(){if(this.searchString==="")return null;let g;this.isRegex?g=I(this.searchString):g=this.searchString.indexOf(`
`)>=0;let p=null;try{p=u.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:g,global:!0,unicode:!0})}catch{return null}if(!p)return null;let o=!this.isRegex&&!g;return o&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(o=this.matchCase),new y.SearchData(p,this.wordSeparators?(0,t.getMapForWordSeparators)(this.wordSeparators):null,o?this.searchString:null)}}e.SearchParams=E;function I(h){if(!h||h.length===0)return!1;for(let g=0,p=h.length;g<p;g++){const o=h.charCodeAt(g);if(o===10)return!0;if(o===92){if(g++,g>=p)break;const m=h.charCodeAt(g);if(m===110||m===114||m===87)return!0}}return!1}e.isMultilineRegexSource=I;function R(h,g,p){if(!p)return new y.FindMatch(h,null);const o=[];for(let m=0,c=g.length;m<c;m++)o[m]=g[m];return new y.FindMatch(h,o)}e.createFindMatch=R;class k{constructor(g){const p=[];let o=0;for(let m=0,c=g.length;m<c;m++)g.charCodeAt(m)===10&&(p[o++]=m);this._lineFeedsOffsets=p}findLineFeedCountBeforeOffset(g){const p=this._lineFeedsOffsets;let o=0,m=p.length-1;if(m===-1||g<=p[0])return 0;for(;o<m;){const c=o+((m-o)/2>>0);p[c]>=g?m=c-1:p[c+1]>=g?(o=c,m=c):o=c+1}return o+1}}class _{static findMatches(g,p,o,m,c){const l=p.parseSearchRequest();return l?l.regex.multiline?this._doFindMatchesMultiline(g,o,new v(l.wordSeparators,l.regex),m,c):this._doFindMatchesLineByLine(g,o,l,m,c):[]}static _getMultilineMatchRange(g,p,o,m,c,l){let s,i=0;m?(i=m.findLineFeedCountBeforeOffset(c),s=p+c+i):s=p+c;let r;if(m){const f=m.findLineFeedCountBeforeOffset(c+l.length)-i;r=s+l.length+f}else r=s+l.length;const n=g.getPositionAt(s),a=g.getPositionAt(r);return new P.Range(n.lineNumber,n.column,a.lineNumber,a.column)}static _doFindMatchesMultiline(g,p,o,m,c){const l=g.getOffsetAt(p.getStartPosition()),s=g.getValueInRange(p,1),i=g.getEOL()===`\r
`?new k(s):null,r=[];let n=0,a;for(o.reset(0);a=o.next(s);)if(r[n++]=R(this._getMultilineMatchRange(g,l,s,i,a.index,a[0]),a,m),n>=c)return r;return r}static _doFindMatchesLineByLine(g,p,o,m,c){const l=[];let s=0;if(p.startLineNumber===p.endLineNumber){const r=g.getLineContent(p.startLineNumber).substring(p.startColumn-1,p.endColumn-1);return s=this._findMatchesInLine(o,r,p.startLineNumber,p.startColumn-1,s,l,m,c),l}const i=g.getLineContent(p.startLineNumber).substring(p.startColumn-1);s=this._findMatchesInLine(o,i,p.startLineNumber,p.startColumn-1,s,l,m,c);for(let r=p.startLineNumber+1;r<p.endLineNumber&&s<c;r++)s=this._findMatchesInLine(o,g.getLineContent(r),r,0,s,l,m,c);if(s<c){const r=g.getLineContent(p.endLineNumber).substring(0,p.endColumn-1);s=this._findMatchesInLine(o,r,p.endLineNumber,0,s,l,m,c)}return l}static _findMatchesInLine(g,p,o,m,c,l,s,i){const r=g.wordSeparators;if(!s&&g.simpleSearch){const d=g.simpleSearch,f=d.length,S=p.length;let O=-f;for(;(O=p.indexOf(d,O+f))!==-1;)if((!r||b(r,p,S,O,f))&&(l[c++]=new y.FindMatch(new P.Range(o,O+1+m,o,O+1+f+m),null),c>=i))return c;return c}const n=new v(g.wordSeparators,g.regex);let a;n.reset(0);do if(a=n.next(p),a&&(l[c++]=R(new P.Range(o,a.index+1+m,o,a.index+1+a[0].length+m),a,s),c>=i))return c;while(a);return c}static findNextMatch(g,p,o,m){const c=p.parseSearchRequest();if(!c)return null;const l=new v(c.wordSeparators,c.regex);return c.regex.multiline?this._doFindNextMatchMultiline(g,o,l,m):this._doFindNextMatchLineByLine(g,o,l,m)}static _doFindNextMatchMultiline(g,p,o,m){const c=new D.Position(p.lineNumber,1),l=g.getOffsetAt(c),s=g.getLineCount(),i=g.getValueInRange(new P.Range(c.lineNumber,c.column,s,g.getLineMaxColumn(s)),1),r=g.getEOL()===`\r
`?new k(i):null;o.reset(p.column-1);const n=o.next(i);return n?R(this._getMultilineMatchRange(g,l,i,r,n.index,n[0]),n,m):p.lineNumber!==1||p.column!==1?this._doFindNextMatchMultiline(g,new D.Position(1,1),o,m):null}static _doFindNextMatchLineByLine(g,p,o,m){const c=g.getLineCount(),l=p.lineNumber,s=g.getLineContent(l),i=this._findFirstMatchInLine(o,s,l,p.column,m);if(i)return i;for(let r=1;r<=c;r++){const n=(l+r-1)%c,a=g.getLineContent(n+1),d=this._findFirstMatchInLine(o,a,n+1,1,m);if(d)return d}return null}static _findFirstMatchInLine(g,p,o,m,c){g.reset(m-1);const l=g.next(p);return l?R(new P.Range(o,l.index+1,o,l.index+1+l[0].length),l,c):null}static findPreviousMatch(g,p,o,m){const c=p.parseSearchRequest();if(!c)return null;const l=new v(c.wordSeparators,c.regex);return c.regex.multiline?this._doFindPreviousMatchMultiline(g,o,l,m):this._doFindPreviousMatchLineByLine(g,o,l,m)}static _doFindPreviousMatchMultiline(g,p,o,m){const c=this._doFindMatchesMultiline(g,new P.Range(1,1,p.lineNumber,p.column),o,m,10*C);if(c.length>0)return c[c.length-1];const l=g.getLineCount();return p.lineNumber!==l||p.column!==g.getLineMaxColumn(l)?this._doFindPreviousMatchMultiline(g,new D.Position(l,g.getLineMaxColumn(l)),o,m):null}static _doFindPreviousMatchLineByLine(g,p,o,m){const c=g.getLineCount(),l=p.lineNumber,s=g.getLineContent(l).substring(0,p.column-1),i=this._findLastMatchInLine(o,s,l,m);if(i)return i;for(let r=1;r<=c;r++){const n=(c+l-r-1)%c,a=g.getLineContent(n+1),d=this._findLastMatchInLine(o,a,n+1,m);if(d)return d}return null}static _findLastMatchInLine(g,p,o,m){let c=null,l;for(g.reset(0);l=g.next(p);)c=R(new P.Range(o,l.index+1,o,l.index+1+l[0].length),l,m);return c}}e.TextModelSearch=_;function T(h,g,p,o,m){if(o===0)return!0;const c=g.charCodeAt(o-1);if(h.get(c)!==0||c===13||c===10)return!0;if(m>0){const l=g.charCodeAt(o);if(h.get(l)!==0)return!0}return!1}function w(h,g,p,o,m){if(o+m===p)return!0;const c=g.charCodeAt(o+m);if(h.get(c)!==0||c===13||c===10)return!0;if(m>0){const l=g.charCodeAt(o+m-1);if(h.get(l)!==0)return!0}return!1}function b(h,g,p,o,m){return T(h,g,p,o,m)&&w(h,g,p,o,m)}e.isValidMatch=b;class v{constructor(g,p){this._wordSeparators=g,this._searchRegex=p,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(g){this._searchRegex.lastIndex=g,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(g){const p=g.length;let o;do{if(this._prevMatchStartIndex+this._prevMatchLength===p||(o=this._searchRegex.exec(g),!o))return null;const m=o.index,c=o[0].length;if(m===this._prevMatchStartIndex&&c===this._prevMatchLength){if(c===0){u.getNextCodePoint(g,p,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=m,this._prevMatchLength=c,!this._wordSeparators||b(this._wordSeparators,g,p,m,c))return o}while(o);return null}}e.Searcher=v}),define(De[113],Ie([1,0,23,11]),function(Z,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var D;(function(k){k[k.Full=1]="Full",k[k.Delta=2]="Delta"})(D||(D={}));function P(k){for(let _=0,T=k.length;_<T;_+=4){const w=k[_+0],b=k[_+1],v=k[_+2],h=k[_+3];k[_+0]=h,k[_+1]=v,k[_+2]=b,k[_+3]=w}}function y(k){const _=new Uint8Array(k.buffer,k.byteOffset,k.length*4);return t.isLittleEndian()||P(_),u.VSBuffer.wrap(_)}function C(k){const _=k.buffer;if(t.isLittleEndian()||P(_),_.byteOffset%4==0)return new Uint32Array(_.buffer,_.byteOffset,_.length/4);{const T=new Uint8Array(_.byteLength);return T.set(_),new Uint32Array(T.buffer,T.byteOffset,T.length/4)}}function E(k){const _=new Uint32Array(I(k));let T=0;if(_[T++]=k.id,k.type==="full")_[T++]=1,_[T++]=k.data.length,_.set(k.data,T),T+=k.data.length;else{_[T++]=2,_[T++]=k.deltas.length;for(const w of k.deltas)_[T++]=w.start,_[T++]=w.deleteCount,w.data?(_[T++]=w.data.length,_.set(w.data,T),T+=w.data.length):_[T++]=0}return y(_)}e.encodeSemanticTokensDto=E;function I(k){let _=0;if(_+=1+1,k.type==="full")_+=1+k.data.length;else{_+=1,_+=(1+1+1)*k.deltas.length;for(const T of k.deltas)T.data&&(_+=T.data.length)}return _}function R(k){const _=C(k);let T=0;const w=_[T++];if(_[T++]===1){const g=_[T++],p=_.subarray(T,T+g);return T+=g,{id:w,type:"full",data:p}}const v=_[T++],h=[];for(let g=0;g<v;g++){const p=_[T++],o=_[T++],m=_[T++];let c;m>0&&(c=_.subarray(T,T+m),T+=m),h[g]={start:p,deleteCount:o,data:c}}return{id:w,type:"delta",deltas:h}}e.decodeSemanticTokensDto=R}),define(De[159],Ie([1,0,4,6]),function(Z,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class D{constructor(){this._map=new Map,this._factories=new Map,this._onDidChange=new u.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(C){this._onDidChange.fire({changedLanguages:C,changedColorMap:!1})}register(C,E){return this._map.set(C,E),this.fire([C]),(0,t.toDisposable)(()=>{this._map.get(C)===E&&(this._map.delete(C),this.fire([C]))})}registerFactory(C,E){this._factories.get(C)?.dispose();const I=new P(this,C,E);return this._factories.set(C,I),(0,t.toDisposable)(()=>{const R=this._factories.get(C);!R||R!==I||(this._factories.delete(C),R.dispose())})}async getOrCreate(C){const E=this.get(C);if(E)return E;const I=this._factories.get(C);return!I||I.isResolved?null:(await I.resolve(),this.get(C))}get(C){return this._map.get(C)||null}isResolved(C){if(this.get(C))return!0;const I=this._factories.get(C);return!!(!I||I.isResolved)}setColorMap(C){this._colorMap=C,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistry=D;class P extends t.Disposable{constructor(C,E,I){super();this._registry=C,this._languageId=E,this._factory=I,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}get isResolved(){return this._isResolved}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const C=await Promise.resolve(this._factory.createTokenizationSupport());this._isResolved=!0,C&&!this._isDisposed&&this._register(this._registry.register(this._languageId,C))}}}),define(De[63],Ie([1,0,76,2,35,159]),function(Z,e,u,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class y{constructor(f,S,O){this._tokenBrand=void 0,this.offset=f,this.type=S,this.language=O}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=y;class C{constructor(f,S){this._tokenizationResultBrand=void 0,this.tokens=f,this.endState=S}}e.TokenizationResult=C;class E{constructor(f,S){this._encodedTokenizationResultBrand=void 0,this.tokens=f,this.endState=S}}e.EncodedTokenizationResult=E;var I;(function(d){d[d.Method=0]="Method",d[d.Function=1]="Function",d[d.Constructor=2]="Constructor",d[d.Field=3]="Field",d[d.Variable=4]="Variable",d[d.Class=5]="Class",d[d.Struct=6]="Struct",d[d.Interface=7]="Interface",d[d.Module=8]="Module",d[d.Property=9]="Property",d[d.Event=10]="Event",d[d.Operator=11]="Operator",d[d.Unit=12]="Unit",d[d.Value=13]="Value",d[d.Constant=14]="Constant",d[d.Enum=15]="Enum",d[d.EnumMember=16]="EnumMember",d[d.Keyword=17]="Keyword",d[d.Text=18]="Text",d[d.Color=19]="Color",d[d.File=20]="File",d[d.Reference=21]="Reference",d[d.Customcolor=22]="Customcolor",d[d.Folder=23]="Folder",d[d.TypeParameter=24]="TypeParameter",d[d.User=25]="User",d[d.Issue=26]="Issue",d[d.Snippet=27]="Snippet"})(I=e.CompletionItemKind||(e.CompletionItemKind={}));var R;(function(d){const f=new Map;f.set(0,u.Codicon.symbolMethod),f.set(1,u.Codicon.symbolFunction),f.set(2,u.Codicon.symbolConstructor),f.set(3,u.Codicon.symbolField),f.set(4,u.Codicon.symbolVariable),f.set(5,u.Codicon.symbolClass),f.set(6,u.Codicon.symbolStruct),f.set(7,u.Codicon.symbolInterface),f.set(8,u.Codicon.symbolModule),f.set(9,u.Codicon.symbolProperty),f.set(10,u.Codicon.symbolEvent),f.set(11,u.Codicon.symbolOperator),f.set(12,u.Codicon.symbolUnit),f.set(13,u.Codicon.symbolValue),f.set(15,u.Codicon.symbolEnum),f.set(14,u.Codicon.symbolConstant),f.set(15,u.Codicon.symbolEnum),f.set(16,u.Codicon.symbolEnumMember),f.set(17,u.Codicon.symbolKeyword),f.set(27,u.Codicon.symbolSnippet),f.set(18,u.Codicon.symbolText),f.set(19,u.Codicon.symbolColor),f.set(20,u.Codicon.symbolFile),f.set(21,u.Codicon.symbolReference),f.set(22,u.Codicon.symbolCustomColor),f.set(23,u.Codicon.symbolFolder),f.set(24,u.Codicon.symbolTypeParameter),f.set(25,u.Codicon.account),f.set(26,u.Codicon.issues);function S(M){let A=f.get(M);return A||(console.info("No codicon found for CompletionItemKind "+M),A=u.Codicon.symbolProperty),A}d.toIcon=S;const O=new Map;O.set("method",0),O.set("function",1),O.set("constructor",2),O.set("field",3),O.set("variable",4),O.set("class",5),O.set("struct",6),O.set("interface",7),O.set("module",8),O.set("property",9),O.set("event",10),O.set("operator",11),O.set("unit",12),O.set("value",13),O.set("constant",14),O.set("enum",15),O.set("enum-member",16),O.set("enumMember",16),O.set("keyword",17),O.set("snippet",27),O.set("text",18),O.set("color",19),O.set("file",20),O.set("reference",21),O.set("customcolor",22),O.set("folder",23),O.set("type-parameter",24),O.set("typeParameter",24),O.set("account",25),O.set("issue",26);function U(M,A){let B=O.get(M);return typeof B=="undefined"&&!A&&(B=9),B}d.fromString=U})(R=e.CompletionItemKinds||(e.CompletionItemKinds={}));var k;(function(d){d[d.Deprecated=1]="Deprecated"})(k=e.CompletionItemTag||(e.CompletionItemTag={}));var _;(function(d){d[d.KeepWhitespace=1]="KeepWhitespace",d[d.InsertAsSnippet=4]="InsertAsSnippet"})(_=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var T;(function(d){d[d.Invoke=0]="Invoke",d[d.TriggerCharacter=1]="TriggerCharacter",d[d.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(T=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var w;(function(d){d[d.Automatic=0]="Automatic",d[d.Explicit=1]="Explicit"})(w=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var b;(function(d){d[d.Invoke=1]="Invoke",d[d.Auto=2]="Auto"})(b=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var v;(function(d){d[d.Invoke=1]="Invoke",d[d.TriggerCharacter=2]="TriggerCharacter",d[d.ContentChange=3]="ContentChange"})(v=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var h;(function(d){d[d.Text=0]="Text",d[d.Read=1]="Read",d[d.Write=2]="Write"})(h=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function g(d){return d&&t.URI.isUri(d.uri)&&D.Range.isIRange(d.range)&&(D.Range.isIRange(d.originSelectionRange)||D.Range.isIRange(d.targetSelectionRange))}e.isLocationLink=g;var p;(function(d){d[d.File=0]="File",d[d.Module=1]="Module",d[d.Namespace=2]="Namespace",d[d.Package=3]="Package",d[d.Class=4]="Class",d[d.Method=5]="Method",d[d.Property=6]="Property",d[d.Field=7]="Field",d[d.Constructor=8]="Constructor",d[d.Enum=9]="Enum",d[d.Interface=10]="Interface",d[d.Function=11]="Function",d[d.Variable=12]="Variable",d[d.Constant=13]="Constant",d[d.String=14]="String",d[d.Number=15]="Number",d[d.Boolean=16]="Boolean",d[d.Array=17]="Array",d[d.Object=18]="Object",d[d.Key=19]="Key",d[d.Null=20]="Null",d[d.EnumMember=21]="EnumMember",d[d.Struct=22]="Struct",d[d.Event=23]="Event",d[d.Operator=24]="Operator",d[d.TypeParameter=25]="TypeParameter"})(p=e.SymbolKind||(e.SymbolKind={}));var o;(function(d){d[d.Deprecated=1]="Deprecated"})(o=e.SymbolTag||(e.SymbolTag={}));var m;(function(d){const f=new Map;f.set(0,u.Codicon.symbolFile),f.set(1,u.Codicon.symbolModule),f.set(2,u.Codicon.symbolNamespace),f.set(3,u.Codicon.symbolPackage),f.set(4,u.Codicon.symbolClass),f.set(5,u.Codicon.symbolMethod),f.set(6,u.Codicon.symbolProperty),f.set(7,u.Codicon.symbolField),f.set(8,u.Codicon.symbolConstructor),f.set(9,u.Codicon.symbolEnum),f.set(10,u.Codicon.symbolInterface),f.set(11,u.Codicon.symbolFunction),f.set(12,u.Codicon.symbolVariable),f.set(13,u.Codicon.symbolConstant),f.set(14,u.Codicon.symbolString),f.set(15,u.Codicon.symbolNumber),f.set(16,u.Codicon.symbolBoolean),f.set(17,u.Codicon.symbolArray),f.set(18,u.Codicon.symbolObject),f.set(19,u.Codicon.symbolKey),f.set(20,u.Codicon.symbolNull),f.set(21,u.Codicon.symbolEnumMember),f.set(22,u.Codicon.symbolStruct),f.set(23,u.Codicon.symbolEvent),f.set(24,u.Codicon.symbolOperator),f.set(25,u.Codicon.symbolTypeParameter);function S(O){let U=f.get(O);return U||(console.info("No codicon found for SymbolKind "+O),U=u.Codicon.symbolProperty),U}d.toIcon=S})(m=e.SymbolKinds||(e.SymbolKinds={}));class c{constructor(f){this.value=f}}e.FoldingRangeKind=c,c.Comment=new c("comment"),c.Imports=new c("imports"),c.Region=new c("region");var l;(function(d){function f(S){return!S||typeof S!="object"?!1:typeof S.id=="string"&&typeof S.title=="string"}d.is=f})(l=e.Command||(e.Command={}));var s;(function(d){d[d.Collapsed=0]="Collapsed",d[d.Expanded=1]="Expanded"})(s=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var i;(function(d){d[d.Unresolved=0]="Unresolved",d[d.Resolved=1]="Resolved"})(i=e.CommentThreadState||(e.CommentThreadState={}));var r;(function(d){d[d.Editing=0]="Editing",d[d.Preview=1]="Preview"})(r=e.CommentMode||(e.CommentMode={}));var n;(function(d){d[d.Type=1]="Type",d[d.Parameter=2]="Parameter"})(n=e.InlayHintKind||(e.InlayHintKind={})),e.TokenizationRegistry=new P.TokenizationRegistry;var a;(function(d){d[d.None=0]="None",d[d.Option=1]="Option",d[d.Default=2]="Default",d[d.Preferred=3]="Preferred"})(a=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(De[160],Ie([19,20]),function(Z,e){return Z.create("vs/editor/common/config/editorOptions",e)}),define(De[114],Ie([1,0,160,11,98,17,24,145]),function(Z,e,u,t,D,P,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var E;(function(se){se[se.None=0]="None",se[se.Keep=1]="Keep",se[se.Brackets=2]="Brackets",se[se.Advanced=3]="Advanced",se[se.Full=4]="Full"})(E=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class I{constructor(oe){this._values=oe}hasChanged(oe){return this._values[oe]}}e.ConfigurationChangedEvent=I;class R{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=R;class k{constructor(oe,q,ye,Ae){this.id=oe,this.name=q,this.defaultValue=ye,this.schema=Ae}applyUpdate(oe,q){return T(oe,q)}compute(oe,q,ye){return ye}}class _{constructor(oe,q){this.newValue=oe,this.didChange=q}}e.ApplyUpdateResult=_;function T(se,oe){if(typeof se!="object"||typeof oe!="object"||!se||!oe)return new _(oe,se!==oe);if(Array.isArray(se)||Array.isArray(oe)){const ye=Array.isArray(se)&&Array.isArray(oe)&&P.equals(se,oe);return new _(oe,!ye)}let q=!1;for(const ye in oe)if(oe.hasOwnProperty(ye)){const Ae=T(se[ye],oe[ye]);Ae.didChange&&(se[ye]=Ae.newValue,q=!0)}return new _(se,q)}class w{constructor(oe){this.schema=void 0,this.id=oe,this.name="_never_",this.defaultValue=void 0}applyUpdate(oe,q){return T(oe,q)}validate(oe){return this.defaultValue}}class b{constructor(oe,q,ye,Ae){this.id=oe,this.name=q,this.defaultValue=ye,this.schema=Ae}applyUpdate(oe,q){return T(oe,q)}validate(oe){return typeof oe=="undefined"?this.defaultValue:oe}compute(oe,q,ye){return ye}}function v(se,oe){return typeof se=="undefined"?oe:se==="false"?!1:Boolean(se)}e.boolean=v;class h extends b{constructor(oe,q,ye,Ae=void 0){typeof Ae!="undefined"&&(Ae.type="boolean",Ae.default=ye);super(oe,q,ye,Ae)}validate(oe){return v(oe,this.defaultValue)}}function g(se,oe,q,ye){if(typeof se=="undefined")return oe;let Ae=parseInt(se,10);return isNaN(Ae)?oe:(Ae=Math.max(q,Ae),Ae=Math.min(ye,Ae),Ae|0)}e.clampedInt=g;class p extends b{constructor(oe,q,ye,Ae,We,ze=void 0){typeof ze!="undefined"&&(ze.type="integer",ze.default=ye,ze.minimum=Ae,ze.maximum=We);super(oe,q,ye,ze);this.minimum=Ae,this.maximum=We}static clampedInt(oe,q,ye,Ae){return g(oe,q,ye,Ae)}validate(oe){return p.clampedInt(oe,this.defaultValue,this.minimum,this.maximum)}}class o extends b{constructor(oe,q,ye,Ae,We){typeof We!="undefined"&&(We.type="number",We.default=ye);super(oe,q,ye,We);this.validationFn=Ae}static clamp(oe,q,ye){return oe<q?q:oe>ye?ye:oe}static float(oe,q){if(typeof oe=="number")return oe;if(typeof oe=="undefined")return q;const ye=parseFloat(oe);return isNaN(ye)?q:ye}validate(oe){return this.validationFn(o.float(oe,this.defaultValue))}}class m extends b{static string(oe,q){return typeof oe!="string"?q:oe}constructor(oe,q,ye,Ae=void 0){typeof Ae!="undefined"&&(Ae.type="string",Ae.default=ye);super(oe,q,ye,Ae)}validate(oe){return m.string(oe,this.defaultValue)}}function c(se,oe,q){return typeof se!="string"||q.indexOf(se)===-1?oe:se}e.stringSet=c;class l extends b{constructor(oe,q,ye,Ae,We=void 0){typeof We!="undefined"&&(We.type="string",We.enum=Ae,We.default=ye);super(oe,q,ye,We);this._allowedValues=Ae}validate(oe){return c(oe,this.defaultValue,this._allowedValues)}}class s extends k{constructor(oe,q,ye,Ae,We,ze,$e=void 0){typeof $e!="undefined"&&($e.type="string",$e.enum=We,$e.default=Ae);super(oe,q,ye,$e);this._allowedValues=We,this._convert=ze}validate(oe){return typeof oe!="string"?this.defaultValue:this._allowedValues.indexOf(oe)===-1?this.defaultValue:this._convert(oe)}}function i(se){switch(se){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class r extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[u.localize(0,null),u.localize(1,null),u.localize(2,null)],default:"auto",description:u.localize(3,null)})}validate(oe){switch(oe){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(oe,q,ye){return ye===0?oe.accessibilitySupport:ye}}class n extends k{constructor(){const oe={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",oe,{"editor.comments.insertSpace":{type:"boolean",default:oe.insertSpace,description:u.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:oe.ignoreEmptyLines,description:u.localize(5,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const q=oe;return{insertSpace:v(q.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:v(q.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var a;(function(se){se[se.Hidden=0]="Hidden",se[se.Blink=1]="Blink",se[se.Smooth=2]="Smooth",se[se.Phase=3]="Phase",se[se.Expand=4]="Expand",se[se.Solid=5]="Solid"})(a=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function d(se){switch(se){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var f;(function(se){se[se.Line=1]="Line",se[se.Block=2]="Block",se[se.Underline=3]="Underline",se[se.LineThin=4]="LineThin",se[se.BlockOutline=5]="BlockOutline",se[se.UnderlineThin=6]="UnderlineThin"})(f=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function S(se){switch(se){case f.Line:return"line";case f.Block:return"block";case f.Underline:return"underline";case f.LineThin:return"line-thin";case f.BlockOutline:return"block-outline";case f.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=S;function O(se){switch(se){case"line":return f.Line;case"block":return f.Block;case"underline":return f.Underline;case"line-thin":return f.LineThin;case"block-outline":return f.BlockOutline;case"underline-thin":return f.UnderlineThin}}class U extends w{constructor(){super(130)}compute(oe,q,ye){const Ae=["monaco-editor"];return q.get(35)&&Ae.push(q.get(35)),oe.extraEditorClassName&&Ae.push(oe.extraEditorClassName),q.get(68)==="default"?Ae.push("mouse-default"):q.get(68)==="copy"&&Ae.push("mouse-copy"),q.get(102)&&Ae.push("showUnused"),q.get(128)&&Ae.push("showDeprecated"),Ae.join(" ")}}class M extends h{constructor(){super(33,"emptySelectionClipboard",!0,{description:u.localize(6,null)})}compute(oe,q,ye){return ye&&oe.emptySelectionClipboard}}class A extends k{constructor(){const oe={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(37,"find",oe,{"editor.find.cursorMoveOnType":{type:"boolean",default:oe.cursorMoveOnType,description:u.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:oe.seedSearchStringFromSelection,enumDescriptions:[u.localize(8,null),u.localize(9,null),u.localize(10,null)],description:u.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:oe.autoFindInSelection,enumDescriptions:[u.localize(12,null),u.localize(13,null),u.localize(14,null)],description:u.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:oe.globalFindClipboard,description:u.localize(16,null),included:t.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:oe.addExtraSpaceOnTop,description:u.localize(17,null)},"editor.find.loop":{type:"boolean",default:oe.loop,description:u.localize(18,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const q=oe;return{cursorMoveOnType:v(q.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof oe.seedSearchStringFromSelection=="boolean"?oe.seedSearchStringFromSelection?"always":"never":c(q.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof oe.autoFindInSelection=="boolean"?oe.autoFindInSelection?"always":"never":c(q.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:v(q.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:v(q.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:v(q.loop,this.defaultValue.loop)}}}class B extends k{constructor(){super(47,"fontLigatures",B.OFF,{anyOf:[{type:"boolean",description:u.localize(19,null)},{type:"string",description:u.localize(20,null)}],description:u.localize(21,null),default:!1})}validate(oe){return typeof oe=="undefined"?this.defaultValue:typeof oe=="string"?oe==="false"?B.OFF:oe==="true"?B.ON:oe:Boolean(oe)?B.ON:B.OFF}}e.EditorFontLigatures=B,B.OFF='"liga" off, "calt" off',B.ON='"liga" on, "calt" on';class x extends w{constructor(){super(46)}compute(oe,q,ye){return oe.fontInfo}}class N extends b{constructor(){super(48,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:u.localize(22,null)})}validate(oe){const q=o.float(oe,this.defaultValue);return q===0?e.EDITOR_FONT_DEFAULTS.fontSize:o.clamp(q,6,100)}compute(oe,q,ye){return oe.fontInfo.fontSize}}class K extends k{constructor(){super(49,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:K.MINIMUM_VALUE,maximum:K.MAXIMUM_VALUE,errorMessage:u.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:K.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:u.localize(24,null)})}validate(oe){return oe==="normal"||oe==="bold"?oe:String(p.clampedInt(oe,e.EDITOR_FONT_DEFAULTS.fontWeight,K.MINIMUM_VALUE,K.MAXIMUM_VALUE))}}K.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],K.MINIMUM_VALUE=1,K.MAXIMUM_VALUE=1e3;class X extends k{constructor(){const oe={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},q={type:"string",enum:["peek","gotoAndPeek","goto"],default:oe.multiple,enumDescriptions:[u.localize(25,null),u.localize(26,null),u.localize(27,null)]},ye=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(53,"gotoLocation",oe,{"editor.gotoLocation.multiple":{deprecationMessage:u.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:u.localize(29,null),...q},"editor.gotoLocation.multipleTypeDefinitions":{description:u.localize(30,null),...q},"editor.gotoLocation.multipleDeclarations":{description:u.localize(31,null),...q},"editor.gotoLocation.multipleImplementations":{description:u.localize(32,null),...q},"editor.gotoLocation.multipleReferences":{description:u.localize(33,null),...q},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:oe.alternativeDefinitionCommand,enum:ye,description:u.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:oe.alternativeTypeDefinitionCommand,enum:ye,description:u.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:oe.alternativeDeclarationCommand,enum:ye,description:u.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:oe.alternativeImplementationCommand,enum:ye,description:u.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:oe.alternativeReferenceCommand,enum:ye,description:u.localize(38,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const q=oe;return{multiple:c(q.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:q.multipleDefinitions??c(q.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:q.multipleTypeDefinitions??c(q.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:q.multipleDeclarations??c(q.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:q.multipleImplementations??c(q.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:q.multipleReferences??c(q.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:m.string(q.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:m.string(q.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:m.string(q.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:m.string(q.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:m.string(q.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class L extends k{constructor(){const oe={enabled:!0,delay:300,sticky:!0,above:!0};super(55,"hover",oe,{"editor.hover.enabled":{type:"boolean",default:oe.enabled,description:u.localize(39,null)},"editor.hover.delay":{type:"number",default:oe.delay,minimum:0,maximum:1e4,description:u.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:oe.sticky,description:u.localize(41,null)},"editor.hover.above":{type:"boolean",default:oe.above,description:u.localize(42,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const q=oe;return{enabled:v(q.enabled,this.defaultValue.enabled),delay:p.clampedInt(q.delay,this.defaultValue.delay,0,1e4),sticky:v(q.sticky,this.defaultValue.sticky),above:v(q.above,this.defaultValue.above)}}}var $;(function(se){se[se.None=0]="None",se[se.Text=1]="Text",se[se.Blocks=2]="Blocks"})($=e.RenderMinimap||(e.RenderMinimap={}));class H extends w{constructor(){super(133)}compute(oe,q,ye){return H.computeLayout(q,{memory:oe.memory,outerWidth:oe.outerWidth,outerHeight:oe.outerHeight,isDominatedByLongLines:oe.isDominatedByLongLines,lineHeight:oe.fontInfo.lineHeight,viewLineCount:oe.viewLineCount,lineNumbersDigitCount:oe.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:oe.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:oe.fontInfo.maxDigitWidth,pixelRatio:oe.pixelRatio})}static computeContainedMinimapLineCount(oe){const q=oe.height/oe.lineHeight,ye=oe.scrollBeyondLastLine?q-1:0,Ae=(oe.viewLineCount+ye)/(oe.pixelRatio*oe.height),We=Math.floor(oe.viewLineCount/Ae);return{typicalViewportLineCount:q,extraLinesBeyondLastLine:ye,desiredRatio:Ae,minimapLineCount:We}}static _computeMinimapLayout(oe,q){const ye=oe.outerWidth,Ae=oe.outerHeight,We=oe.pixelRatio;if(!oe.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(We*Ae),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ae};const ze=q.stableMinimapLayoutInput,$e=ze&&oe.outerHeight===ze.outerHeight&&oe.lineHeight===ze.lineHeight&&oe.typicalHalfwidthCharacterWidth===ze.typicalHalfwidthCharacterWidth&&oe.pixelRatio===ze.pixelRatio&&oe.scrollBeyondLastLine===ze.scrollBeyondLastLine&&oe.minimap.enabled===ze.minimap.enabled&&oe.minimap.side===ze.minimap.side&&oe.minimap.size===ze.minimap.size&&oe.minimap.showSlider===ze.minimap.showSlider&&oe.minimap.renderCharacters===ze.minimap.renderCharacters&&oe.minimap.maxColumn===ze.minimap.maxColumn&&oe.minimap.scale===ze.minimap.scale&&oe.verticalScrollbarWidth===ze.verticalScrollbarWidth&&oe.isViewportWrapping===ze.isViewportWrapping,Ze=oe.lineHeight,it=oe.typicalHalfwidthCharacterWidth,lt=oe.scrollBeyondLastLine,ht=oe.minimap.renderCharacters;let tt=We>=2?Math.round(oe.minimap.scale*2):oe.minimap.scale;const at=oe.minimap.maxColumn,Ct=oe.minimap.size,Ot=oe.minimap.side,It=oe.verticalScrollbarWidth,mt=oe.viewLineCount,kt=oe.remainingWidth,Ut=oe.isViewportWrapping,Ft=ht?2:3;let Ge=Math.floor(We*Ae);const Nt=Ge/We;let Lt=!1,Bt=!1,bt=Ft*tt,Te=tt/We,Le=1;if(Ct==="fill"||Ct==="fit"){const{typicalViewportLineCount:Ke,extraLinesBeyondLastLine:ft,desiredRatio:pt,minimapLineCount:Dt}=H.computeContainedMinimapLineCount({viewLineCount:mt,scrollBeyondLastLine:lt,height:Ae,lineHeight:Ze,pixelRatio:We});if(mt/Dt>1)Lt=!0,Bt=!0,tt=1,bt=1,Te=tt/We;else{let St=!1,At=tt+1;if(Ct==="fit"){const gt=Math.ceil((mt+ft)*bt);Ut&&$e&&kt<=q.stableFitRemainingWidth?(St=!0,At=q.stableFitMaxMinimapScale):St=gt>Ge}if(Ct==="fill"||St){Lt=!0;const gt=tt;bt=Math.min(Ze*We,Math.max(1,Math.floor(1/pt))),Ut&&$e&&kt<=q.stableFitRemainingWidth&&(At=q.stableFitMaxMinimapScale),tt=Math.min(At,Math.max(1,Math.floor(bt/Ft))),tt>gt&&(Le=Math.min(2,tt/gt)),Te=tt/We/Le,Ge=Math.ceil(Math.max(Ke,mt+ft)*bt),Ut?(q.stableMinimapLayoutInput=oe,q.stableFitRemainingWidth=kt,q.stableFitMaxMinimapScale=tt):(q.stableMinimapLayoutInput=null,q.stableFitRemainingWidth=0)}}}const _e=Math.floor(at*Te),ie=Math.min(_e,Math.max(0,Math.floor((kt-It-2)*Te/(it+Te)))+e.MINIMAP_GUTTER_WIDTH);let Fe=Math.floor(We*ie);const Ve=Fe/We;Fe=Math.floor(Fe*Le);const rt=ht?1:2,Ye=Ot==="left"?0:ye-ie-It;return{renderMinimap:rt,minimapLeft:Ye,minimapWidth:ie,minimapHeightIsEditorHeight:Lt,minimapIsSampling:Bt,minimapScale:tt,minimapLineHeight:bt,minimapCanvasInnerWidth:Fe,minimapCanvasInnerHeight:Ge,minimapCanvasOuterWidth:Ve,minimapCanvasOuterHeight:Nt}}static computeLayout(oe,q){const ye=q.outerWidth|0,Ae=q.outerHeight|0,We=q.lineHeight|0,ze=q.lineNumbersDigitCount|0,$e=q.typicalHalfwidthCharacterWidth,Ze=q.maxDigitWidth,it=q.pixelRatio,lt=q.viewLineCount,ht=oe.get(125),tt=ht==="inherit"?oe.get(124):ht,at=tt==="inherit"?oe.get(120):tt,Ct=oe.get(123),Ot=oe.get(2),It=q.isDominatedByLongLines,mt=oe.get(52),kt=oe.get(62).renderType!==0,Ut=oe.get(63),Ft=oe.get(96),Ge=oe.get(67),Nt=oe.get(94),Lt=Nt.verticalScrollbarSize,Bt=Nt.verticalHasArrows,bt=Nt.arrowSize,Te=Nt.horizontalScrollbarSize,Le=oe.get(60),_e=oe.get(39),ie=oe.get(101)!=="never";let Fe;if(typeof Le=="string"&&/^\d+(\.\d+)?ch$/.test(Le)){const xt=parseFloat(Le.substr(0,Le.length-2));Fe=p.clampedInt(xt*$e,0,0,1e3)}else Fe=p.clampedInt(Le,0,0,1e3);_e&&ie&&(Fe+=16);let Ve=0;if(kt){const xt=Math.max(ze,Ut);Ve=Math.round(xt*Ze)}let rt=0;mt&&(rt=We);let Ye=0,Ke=Ye+rt,ft=Ke+Ve,pt=ft+Fe;const Dt=ye-rt-Ve-Fe;let vt=!1,St=!1,At=-1;Ot!==2&&(tt==="inherit"&&It?(vt=!0,St=!0):at==="on"||at==="bounded"?St=!0:at==="wordWrapColumn"&&(At=Ct));const gt=H._computeMinimapLayout({outerWidth:ye,outerHeight:Ae,lineHeight:We,typicalHalfwidthCharacterWidth:$e,pixelRatio:it,scrollBeyondLastLine:Ft,minimap:Ge,verticalScrollbarWidth:Lt,viewLineCount:lt,remainingWidth:Dt,isViewportWrapping:St},q.memory||new R);gt.renderMinimap!==0&&gt.minimapLeft===0&&(Ye+=gt.minimapWidth,Ke+=gt.minimapWidth,ft+=gt.minimapWidth,pt+=gt.minimapWidth);const Yt=Dt-gt.minimapWidth,Jt=Math.max(1,Math.floor((Yt-Lt-2)/$e)),Et=Bt?bt:0;return St&&(At=Math.max(1,Jt),at==="bounded"&&(At=Math.min(At,Ct))),{width:ye,height:Ae,glyphMarginLeft:Ye,glyphMarginWidth:rt,lineNumbersLeft:Ke,lineNumbersWidth:Ve,decorationsLeft:ft,decorationsWidth:Fe,contentLeft:pt,contentWidth:Yt,minimap:gt,viewportColumn:Jt,isWordWrapMinified:vt,isViewportWrapping:St,wrappingColumn:At,verticalScrollbarWidth:Lt,horizontalScrollbarHeight:Te,overviewRuler:{top:Et,width:Lt,height:Ae-2*Et,right:0}}}}e.EditorLayoutInfoComputer=H;class j extends k{constructor(){const oe={enabled:!0};super(59,"lightbulb",oe,{"editor.lightbulb.enabled":{type:"boolean",default:oe.enabled,description:u.localize(43,null)}})}validate(oe){return!oe||typeof oe!="object"?this.defaultValue:{enabled:v(oe.enabled,this.defaultValue.enabled)}}}class J extends k{constructor(){const oe={stickyScroll:{enabled:!1}};super(34,"experimental",oe,{"editor.experimental.stickyScroll.enabled":{type:"boolean",default:oe.stickyScroll.enabled,description:u.localize(44,null)}})}validate(oe){return!oe||typeof oe!="object"?this.defaultValue:{stickyScroll:{enabled:v(oe.stickyScroll?.enabled,this.defaultValue.stickyScroll.enabled)}}}}class Y extends k{constructor(){const oe={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(129,"inlayHints",oe,{"editor.inlayHints.enabled":{type:"string",default:oe.enabled,description:u.localize(45,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[u.localize(46,null),u.localize(47,null),u.localize(48,null),u.localize(49,null)]},"editor.inlayHints.fontSize":{type:"number",default:oe.fontSize,markdownDescription:u.localize(50,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:oe.fontFamily,markdownDescription:u.localize(51,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:oe.padding,description:u.localize(52,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const q=oe;return typeof q.enabled=="boolean"&&(q.enabled=q.enabled?"on":"off"),{enabled:c(q.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:p.clampedInt(q.fontSize,this.defaultValue.fontSize,0,100),fontFamily:m.string(q.fontFamily,this.defaultValue.fontFamily),padding:v(q.padding,this.defaultValue.padding)}}}class he extends o{constructor(){super(61,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,oe=>o.clamp(oe,0,150),{markdownDescription:u.localize(53,null)})}compute(oe,q,ye){return oe.fontInfo.lineHeight}}class ve extends k{constructor(){const oe={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(67,"minimap",oe,{"editor.minimap.enabled":{type:"boolean",default:oe.enabled,description:u.localize(54,null)},"editor.minimap.autohide":{type:"boolean",default:oe.autohide,description:u.localize(55,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[u.localize(56,null),u.localize(57,null),u.localize(58,null)],default:oe.size,description:u.localize(59,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:oe.side,description:u.localize(60,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:oe.showSlider,description:u.localize(61,null)},"editor.minimap.scale":{type:"number",default:oe.scale,minimum:1,maximum:3,enum:[1,2,3],description:u.localize(62,null)},"editor.minimap.renderCharacters":{type:"boolean",default:oe.renderCharacters,description:u.localize(63,null)},"editor.minimap.maxColumn":{type:"number",default:oe.maxColumn,description:u.localize(64,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const q=oe;return{enabled:v(q.enabled,this.defaultValue.enabled),autohide:v(q.autohide,this.defaultValue.autohide),size:c(q.size,this.defaultValue.size,["proportional","fill","fit"]),side:c(q.side,this.defaultValue.side,["right","left"]),showSlider:c(q.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:v(q.renderCharacters,this.defaultValue.renderCharacters),scale:p.clampedInt(q.scale,1,1,3),maxColumn:p.clampedInt(q.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ne(se){return se==="ctrlCmd"?t.isMacintosh?"metaKey":"ctrlKey":"altKey"}class pe extends k{constructor(){super(77,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:u.localize(65,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:u.localize(66,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const q=oe;return{top:p.clampedInt(q.top,0,0,1e3),bottom:p.clampedInt(q.bottom,0,0,1e3)}}}class Ee extends k{constructor(){const oe={enabled:!0,cycle:!1};super(78,"parameterHints",oe,{"editor.parameterHints.enabled":{type:"boolean",default:oe.enabled,description:u.localize(67,null)},"editor.parameterHints.cycle":{type:"boolean",default:oe.cycle,description:u.localize(68,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const q=oe;return{enabled:v(q.enabled,this.defaultValue.enabled),cycle:v(q.cycle,this.defaultValue.cycle)}}}class ke extends w{constructor(){super(131)}compute(oe,q,ye){return oe.pixelRatio}}class Oe extends k{constructor(){const oe={other:"on",comments:"off",strings:"off"},q=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[u.localize(69,null),u.localize(70,null),u.localize(71,null)]}];super(81,"quickSuggestions",oe,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:q,default:oe.strings,description:u.localize(72,null)},comments:{anyOf:q,default:oe.comments,description:u.localize(73,null)},other:{anyOf:q,default:oe.other,description:u.localize(74,null)}},default:oe,markdownDescription:u.localize(75,null,"#editor.suggestOnTriggerCharacters#")});this.defaultValue=oe}validate(oe){if(typeof oe=="boolean"){const it=oe?"on":"off";return{comments:it,strings:it,other:it}}if(!oe||typeof oe!="object")return this.defaultValue;const{other:q,comments:ye,strings:Ae}=oe,We=["on","inline","off"];let ze,$e,Ze;return typeof q=="boolean"?ze=q?"on":"off":ze=c(q,this.defaultValue.other,We),typeof ye=="boolean"?$e=ye?"on":"off":$e=c(ye,this.defaultValue.comments,We),typeof Ae=="boolean"?Ze=Ae?"on":"off":Ze=c(Ae,this.defaultValue.strings,We),{other:ze,comments:$e,strings:Ze}}}var Be;(function(se){se[se.Off=0]="Off",se[se.On=1]="On",se[se.Relative=2]="Relative",se[se.Interval=3]="Interval",se[se.Custom=4]="Custom"})(Be=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class ae extends k{constructor(){super(62,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[u.localize(76,null),u.localize(77,null),u.localize(78,null),u.localize(79,null)],default:"on",description:u.localize(80,null)})}validate(oe){let q=this.defaultValue.renderType,ye=this.defaultValue.renderFn;return typeof oe!="undefined"&&(typeof oe=="function"?(q=4,ye=oe):oe==="interval"?q=3:oe==="relative"?q=2:oe==="on"?q=1:q=0),{renderType:q,renderFn:ye}}}function de(se){const oe=se.get(89);return oe==="editable"?se.get(83):oe!=="on"}e.filterValidationDecorations=de;class me extends k{constructor(){const oe=[],q={type:"number",description:u.localize(81,null)};super(93,"rulers",oe,{type:"array",items:{anyOf:[q,{type:["object"],properties:{column:q,color:{type:"string",description:u.localize(82,null),format:"color-hex"}}}]},default:oe,description:u.localize(83,null)})}validate(oe){if(Array.isArray(oe)){const q=[];for(const ye of oe)if(typeof ye=="number")q.push({column:p.clampedInt(ye,0,0,1e4),color:null});else if(ye&&typeof ye=="object"){const Ae=ye;q.push({column:p.clampedInt(Ae.column,0,0,1e4),color:Ae.color})}return q.sort((ye,Ae)=>ye.column-Ae.column),q}return this.defaultValue}}function te(se,oe){if(typeof se!="string")return oe;switch(se){case"hidden":return 2;case"visible":return 3;default:return 1}}class le extends k{constructor(){const oe={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(94,"scrollbar",oe,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[u.localize(84,null),u.localize(85,null),u.localize(86,null)],default:"auto",description:u.localize(87,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[u.localize(88,null),u.localize(89,null),u.localize(90,null)],default:"auto",description:u.localize(91,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:oe.verticalScrollbarSize,description:u.localize(92,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:oe.horizontalScrollbarSize,description:u.localize(93,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:oe.scrollByPage,description:u.localize(94,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const q=oe,ye=p.clampedInt(q.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ae=p.clampedInt(q.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:p.clampedInt(q.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:te(q.vertical,this.defaultValue.vertical),horizontal:te(q.horizontal,this.defaultValue.horizontal),useShadows:v(q.useShadows,this.defaultValue.useShadows),verticalHasArrows:v(q.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:v(q.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:v(q.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:v(q.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:ye,horizontalSliderSize:p.clampedInt(q.horizontalSliderSize,ye,0,1e3),verticalScrollbarSize:Ae,verticalSliderSize:p.clampedInt(q.verticalSliderSize,Ae,0,1e3),scrollByPage:v(q.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class ee extends k{constructor(){const oe={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(115,"unicodeHighlight",oe,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:oe.nonBasicASCII,description:u.localize(95,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:oe.invisibleCharacters,description:u.localize(96,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:oe.ambiguousCharacters,description:u.localize(97,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:oe.includeComments,description:u.localize(98,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:oe.includeStrings,description:u.localize(99,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:oe.allowedCharacters,description:u.localize(100,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:oe.allowedLocales,description:u.localize(101,null)}})}applyUpdate(oe,q){let ye=!1;q.allowedCharacters&&oe&&(y.equals(oe.allowedCharacters,q.allowedCharacters)||(oe={...oe,allowedCharacters:q.allowedCharacters},ye=!0)),q.allowedLocales&&oe&&(y.equals(oe.allowedLocales,q.allowedLocales)||(oe={...oe,allowedLocales:q.allowedLocales},ye=!0));const Ae=super.applyUpdate(oe,q);return ye?new _(Ae.newValue,!0):Ae}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const q=oe;return{nonBasicASCII:G(q.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:v(q.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:v(q.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:G(q.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:G(q.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(oe.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(oe.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(oe,q){if(typeof oe!="object"||!oe)return q;const ye={};for(const[Ae,We]of Object.entries(oe))We===!0&&(ye[Ae]=!0);return ye}}class re extends k{constructor(){const oe={enabled:!0,mode:"subwordSmart"};super(57,"inlineSuggest",oe,{"editor.inlineSuggest.enabled":{type:"boolean",default:oe.enabled,description:u.localize(102,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const q=oe;return{enabled:v(q.enabled,this.defaultValue.enabled),mode:c(q.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class F extends k{constructor(){const oe={enabled:C.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:C.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",oe,{"editor.bracketPairColorization.enabled":{type:"boolean",default:oe.enabled,markdownDescription:u.localize(103,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:oe.independentColorPoolPerBracketType,description:u.localize(104,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const q=oe;return{enabled:v(q.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:v(q.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class W extends k{constructor(){const oe={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",oe,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[u.localize(105,null),u.localize(106,null),u.localize(107,null)],default:oe.bracketPairs,description:u.localize(108,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[u.localize(109,null),u.localize(110,null),u.localize(111,null)],default:oe.bracketPairsHorizontal,description:u.localize(112,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:oe.highlightActiveBracketPair,description:u.localize(113,null)},"editor.guides.indentation":{type:"boolean",default:oe.indentation,description:u.localize(114,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[u.localize(115,null),u.localize(116,null),u.localize(117,null)],default:oe.highlightActiveIndentation,description:u.localize(118,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const q=oe;return{bracketPairs:G(q.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:G(q.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:v(q.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:v(q.indentation,this.defaultValue.indentation),highlightActiveIndentation:G(q.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function G(se,oe,q){const ye=q.indexOf(se);return ye===-1?oe:q[ye]}class Q extends k{constructor(){const oe={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(108,"suggest",oe,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[u.localize(119,null),u.localize(120,null)],default:oe.insertMode,description:u.localize(121,null)},"editor.suggest.filterGraceful":{type:"boolean",default:oe.filterGraceful,description:u.localize(122,null)},"editor.suggest.localityBonus":{type:"boolean",default:oe.localityBonus,description:u.localize(123,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:oe.shareSuggestSelections,markdownDescription:u.localize(124,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:oe.snippetsPreventQuickSuggestions,description:u.localize(125,null)},"editor.suggest.showIcons":{type:"boolean",default:oe.showIcons,description:u.localize(126,null)},"editor.suggest.showStatusBar":{type:"boolean",default:oe.showStatusBar,description:u.localize(127,null)},"editor.suggest.preview":{type:"boolean",default:oe.preview,description:u.localize(128,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:oe.showInlineDetails,description:u.localize(129,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:u.localize(130,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:u.localize(131,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:u.localize(132,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:u.localize(133,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:u.localize(134,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:u.localize(135,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:u.localize(136,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:u.localize(137,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:u.localize(138,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:u.localize(139,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:u.localize(140,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:u.localize(141,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:u.localize(142,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:u.localize(143,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:u.localize(144,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:u.localize(145,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:u.localize(146,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:u.localize(147,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:u.localize(148,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:u.localize(149,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:u.localize(150,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:u.localize(151,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:u.localize(152,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:u.localize(153,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:u.localize(154,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:u.localize(155,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:u.localize(156,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:u.localize(157,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:u.localize(158,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:u.localize(159,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:u.localize(160,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const q=oe;return{insertMode:c(q.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:v(q.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:v(q.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:v(q.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:v(q.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:v(q.showIcons,this.defaultValue.showIcons),showStatusBar:v(q.showStatusBar,this.defaultValue.showStatusBar),preview:v(q.preview,this.defaultValue.preview),previewMode:c(q.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:v(q.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:v(q.showMethods,this.defaultValue.showMethods),showFunctions:v(q.showFunctions,this.defaultValue.showFunctions),showConstructors:v(q.showConstructors,this.defaultValue.showConstructors),showDeprecated:v(q.showDeprecated,this.defaultValue.showDeprecated),showFields:v(q.showFields,this.defaultValue.showFields),showVariables:v(q.showVariables,this.defaultValue.showVariables),showClasses:v(q.showClasses,this.defaultValue.showClasses),showStructs:v(q.showStructs,this.defaultValue.showStructs),showInterfaces:v(q.showInterfaces,this.defaultValue.showInterfaces),showModules:v(q.showModules,this.defaultValue.showModules),showProperties:v(q.showProperties,this.defaultValue.showProperties),showEvents:v(q.showEvents,this.defaultValue.showEvents),showOperators:v(q.showOperators,this.defaultValue.showOperators),showUnits:v(q.showUnits,this.defaultValue.showUnits),showValues:v(q.showValues,this.defaultValue.showValues),showConstants:v(q.showConstants,this.defaultValue.showConstants),showEnums:v(q.showEnums,this.defaultValue.showEnums),showEnumMembers:v(q.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:v(q.showKeywords,this.defaultValue.showKeywords),showWords:v(q.showWords,this.defaultValue.showWords),showColors:v(q.showColors,this.defaultValue.showColors),showFiles:v(q.showFiles,this.defaultValue.showFiles),showReferences:v(q.showReferences,this.defaultValue.showReferences),showFolders:v(q.showFolders,this.defaultValue.showFolders),showTypeParameters:v(q.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:v(q.showSnippets,this.defaultValue.showSnippets),showUsers:v(q.showUsers,this.defaultValue.showUsers),showIssues:v(q.showIssues,this.defaultValue.showIssues)}}}class fe extends k{constructor(){super(104,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:u.localize(161,null),default:!0,type:"boolean"}})}validate(oe){return!oe||typeof oe!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:v(oe.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class be extends w{constructor(){super(132)}compute(oe,q,ye){return q.get(83)?!0:oe.tabFocusMode}}var ue;(function(se){se[se.None=0]="None",se[se.Same=1]="Same",se[se.Indent=2]="Indent",se[se.DeepIndent=3]="DeepIndent"})(ue=e.WrappingIndent||(e.WrappingIndent={}));function Ce(se){switch(se){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class Se extends w{constructor(){super(134)}compute(oe,q,ye){const Ae=q.get(133);return{isDominatedByLongLines:oe.isDominatedByLongLines,isWordWrapMinified:Ae.isWordWrapMinified,isViewportWrapping:Ae.isViewportWrapping,wrappingColumn:Ae.wrappingColumn}}}class Ue extends k{constructor(){const oe={enabled:!0};super(32,"dropIntoEditor",oe,{"editor.dropIntoEditor.enabled":{type:"boolean",default:oe.enabled,markdownDescription:u.localize(162,null)}})}validate(oe){return!oe||typeof oe!="object"?this.defaultValue:{enabled:v(oe.enabled,this.defaultValue.enabled)}}}const qe="Consolas, 'Courier New', monospace",Je="Menlo, Monaco, 'Courier New', monospace",Qe="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:t.isMacintosh?Je:t.isLinux?Qe:qe,fontWeight:"normal",fontSize:t.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Re(se){return e.editorOptionsRegistry[se.id]=se,se}var st;(function(se){se[se.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",se[se.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",se[se.accessibilitySupport=2]="accessibilitySupport",se[se.accessibilityPageSize=3]="accessibilityPageSize",se[se.ariaLabel=4]="ariaLabel",se[se.autoClosingBrackets=5]="autoClosingBrackets",se[se.autoClosingDelete=6]="autoClosingDelete",se[se.autoClosingOvertype=7]="autoClosingOvertype",se[se.autoClosingQuotes=8]="autoClosingQuotes",se[se.autoIndent=9]="autoIndent",se[se.automaticLayout=10]="automaticLayout",se[se.autoSurround=11]="autoSurround",se[se.bracketPairColorization=12]="bracketPairColorization",se[se.guides=13]="guides",se[se.codeLens=14]="codeLens",se[se.codeLensFontFamily=15]="codeLensFontFamily",se[se.codeLensFontSize=16]="codeLensFontSize",se[se.colorDecorators=17]="colorDecorators",se[se.columnSelection=18]="columnSelection",se[se.comments=19]="comments",se[se.contextmenu=20]="contextmenu",se[se.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",se[se.cursorBlinking=22]="cursorBlinking",se[se.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",se[se.cursorStyle=24]="cursorStyle",se[se.cursorSurroundingLines=25]="cursorSurroundingLines",se[se.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",se[se.cursorWidth=27]="cursorWidth",se[se.disableLayerHinting=28]="disableLayerHinting",se[se.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",se[se.domReadOnly=30]="domReadOnly",se[se.dragAndDrop=31]="dragAndDrop",se[se.dropIntoEditor=32]="dropIntoEditor",se[se.emptySelectionClipboard=33]="emptySelectionClipboard",se[se.experimental=34]="experimental",se[se.extraEditorClassName=35]="extraEditorClassName",se[se.fastScrollSensitivity=36]="fastScrollSensitivity",se[se.find=37]="find",se[se.fixedOverflowWidgets=38]="fixedOverflowWidgets",se[se.folding=39]="folding",se[se.foldingStrategy=40]="foldingStrategy",se[se.foldingHighlight=41]="foldingHighlight",se[se.foldingImportsByDefault=42]="foldingImportsByDefault",se[se.foldingMaximumRegions=43]="foldingMaximumRegions",se[se.unfoldOnClickAfterEndOfLine=44]="unfoldOnClickAfterEndOfLine",se[se.fontFamily=45]="fontFamily",se[se.fontInfo=46]="fontInfo",se[se.fontLigatures=47]="fontLigatures",se[se.fontSize=48]="fontSize",se[se.fontWeight=49]="fontWeight",se[se.formatOnPaste=50]="formatOnPaste",se[se.formatOnType=51]="formatOnType",se[se.glyphMargin=52]="glyphMargin",se[se.gotoLocation=53]="gotoLocation",se[se.hideCursorInOverviewRuler=54]="hideCursorInOverviewRuler",se[se.hover=55]="hover",se[se.inDiffEditor=56]="inDiffEditor",se[se.inlineSuggest=57]="inlineSuggest",se[se.letterSpacing=58]="letterSpacing",se[se.lightbulb=59]="lightbulb",se[se.lineDecorationsWidth=60]="lineDecorationsWidth",se[se.lineHeight=61]="lineHeight",se[se.lineNumbers=62]="lineNumbers",se[se.lineNumbersMinChars=63]="lineNumbersMinChars",se[se.linkedEditing=64]="linkedEditing",se[se.links=65]="links",se[se.matchBrackets=66]="matchBrackets",se[se.minimap=67]="minimap",se[se.mouseStyle=68]="mouseStyle",se[se.mouseWheelScrollSensitivity=69]="mouseWheelScrollSensitivity",se[se.mouseWheelZoom=70]="mouseWheelZoom",se[se.multiCursorMergeOverlapping=71]="multiCursorMergeOverlapping",se[se.multiCursorModifier=72]="multiCursorModifier",se[se.multiCursorPaste=73]="multiCursorPaste",se[se.occurrencesHighlight=74]="occurrencesHighlight",se[se.overviewRulerBorder=75]="overviewRulerBorder",se[se.overviewRulerLanes=76]="overviewRulerLanes",se[se.padding=77]="padding",se[se.parameterHints=78]="parameterHints",se[se.peekWidgetDefaultFocus=79]="peekWidgetDefaultFocus",se[se.definitionLinkOpensInPeek=80]="definitionLinkOpensInPeek",se[se.quickSuggestions=81]="quickSuggestions",se[se.quickSuggestionsDelay=82]="quickSuggestionsDelay",se[se.readOnly=83]="readOnly",se[se.renameOnType=84]="renameOnType",se[se.renderControlCharacters=85]="renderControlCharacters",se[se.renderFinalNewline=86]="renderFinalNewline",se[se.renderLineHighlight=87]="renderLineHighlight",se[se.renderLineHighlightOnlyWhenFocus=88]="renderLineHighlightOnlyWhenFocus",se[se.renderValidationDecorations=89]="renderValidationDecorations",se[se.renderWhitespace=90]="renderWhitespace",se[se.revealHorizontalRightPadding=91]="revealHorizontalRightPadding",se[se.roundedSelection=92]="roundedSelection",se[se.rulers=93]="rulers",se[se.scrollbar=94]="scrollbar",se[se.scrollBeyondLastColumn=95]="scrollBeyondLastColumn",se[se.scrollBeyondLastLine=96]="scrollBeyondLastLine",se[se.scrollPredominantAxis=97]="scrollPredominantAxis",se[se.selectionClipboard=98]="selectionClipboard",se[se.selectionHighlight=99]="selectionHighlight",se[se.selectOnLineNumbers=100]="selectOnLineNumbers",se[se.showFoldingControls=101]="showFoldingControls",se[se.showUnused=102]="showUnused",se[se.snippetSuggestions=103]="snippetSuggestions",se[se.smartSelect=104]="smartSelect",se[se.smoothScrolling=105]="smoothScrolling",se[se.stickyTabStops=106]="stickyTabStops",se[se.stopRenderingLineAfter=107]="stopRenderingLineAfter",se[se.suggest=108]="suggest",se[se.suggestFontSize=109]="suggestFontSize",se[se.suggestLineHeight=110]="suggestLineHeight",se[se.suggestOnTriggerCharacters=111]="suggestOnTriggerCharacters",se[se.suggestSelection=112]="suggestSelection",se[se.tabCompletion=113]="tabCompletion",se[se.tabIndex=114]="tabIndex",se[se.unicodeHighlighting=115]="unicodeHighlighting",se[se.unusualLineTerminators=116]="unusualLineTerminators",se[se.useShadowDOM=117]="useShadowDOM",se[se.useTabStops=118]="useTabStops",se[se.wordSeparators=119]="wordSeparators",se[se.wordWrap=120]="wordWrap",se[se.wordWrapBreakAfterCharacters=121]="wordWrapBreakAfterCharacters",se[se.wordWrapBreakBeforeCharacters=122]="wordWrapBreakBeforeCharacters",se[se.wordWrapColumn=123]="wordWrapColumn",se[se.wordWrapOverride1=124]="wordWrapOverride1",se[se.wordWrapOverride2=125]="wordWrapOverride2",se[se.wrappingIndent=126]="wrappingIndent",se[se.wrappingStrategy=127]="wrappingStrategy",se[se.showDeprecated=128]="showDeprecated",se[se.inlayHints=129]="inlayHints",se[se.editorClassName=130]="editorClassName",se[se.pixelRatio=131]="pixelRatio",se[se.tabFocusMode=132]="tabFocusMode",se[se.layoutInfo=133]="layoutInfo",se[se.wrappingInfo=134]="wrappingInfo"})(st=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Re(new h(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:u.localize(163,null)})),acceptSuggestionOnEnter:Re(new l(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",u.localize(164,null),""],markdownDescription:u.localize(165,null)})),accessibilitySupport:Re(new r),accessibilityPageSize:Re(new p(3,"accessibilityPageSize",10,1,1073741824,{description:u.localize(166,null)})),ariaLabel:Re(new m(4,"ariaLabel",u.localize(167,null))),autoClosingBrackets:Re(new l(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",u.localize(168,null),u.localize(169,null),""],description:u.localize(170,null)})),autoClosingDelete:Re(new l(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",u.localize(171,null),""],description:u.localize(172,null)})),autoClosingOvertype:Re(new l(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",u.localize(173,null),""],description:u.localize(174,null)})),autoClosingQuotes:Re(new l(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",u.localize(175,null),u.localize(176,null),""],description:u.localize(177,null)})),autoIndent:Re(new s(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],i,{enumDescriptions:[u.localize(178,null),u.localize(179,null),u.localize(180,null),u.localize(181,null),u.localize(182,null)],description:u.localize(183,null)})),automaticLayout:Re(new h(10,"automaticLayout",!1)),autoSurround:Re(new l(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[u.localize(184,null),u.localize(185,null),u.localize(186,null),""],description:u.localize(187,null)})),bracketPairColorization:Re(new F),bracketPairGuides:Re(new W),stickyTabStops:Re(new h(106,"stickyTabStops",!1,{description:u.localize(188,null)})),codeLens:Re(new h(14,"codeLens",!0,{description:u.localize(189,null)})),codeLensFontFamily:Re(new m(15,"codeLensFontFamily","",{description:u.localize(190,null)})),codeLensFontSize:Re(new p(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:u.localize(191,null)})),colorDecorators:Re(new h(17,"colorDecorators",!0,{description:u.localize(192,null)})),columnSelection:Re(new h(18,"columnSelection",!1,{description:u.localize(193,null)})),comments:Re(new n),contextmenu:Re(new h(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Re(new h(21,"copyWithSyntaxHighlighting",!0,{description:u.localize(194,null)})),cursorBlinking:Re(new s(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],d,{description:u.localize(195,null)})),cursorSmoothCaretAnimation:Re(new h(23,"cursorSmoothCaretAnimation",!1,{description:u.localize(196,null)})),cursorStyle:Re(new s(24,"cursorStyle",f.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],O,{description:u.localize(197,null)})),cursorSurroundingLines:Re(new p(25,"cursorSurroundingLines",0,0,1073741824,{description:u.localize(198,null)})),cursorSurroundingLinesStyle:Re(new l(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[u.localize(199,null),u.localize(200,null)],description:u.localize(201,null)})),cursorWidth:Re(new p(27,"cursorWidth",0,0,1073741824,{markdownDescription:u.localize(202,null)})),disableLayerHinting:Re(new h(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Re(new h(29,"disableMonospaceOptimizations",!1)),domReadOnly:Re(new h(30,"domReadOnly",!1)),dragAndDrop:Re(new h(31,"dragAndDrop",!0,{description:u.localize(203,null)})),emptySelectionClipboard:Re(new M),dropIntoEditor:Re(new Ue),experimental:Re(new J),extraEditorClassName:Re(new m(35,"extraEditorClassName","")),fastScrollSensitivity:Re(new o(36,"fastScrollSensitivity",5,se=>se<=0?5:se,{markdownDescription:u.localize(204,null)})),find:Re(new A),fixedOverflowWidgets:Re(new h(38,"fixedOverflowWidgets",!1)),folding:Re(new h(39,"folding",!0,{description:u.localize(205,null)})),foldingStrategy:Re(new l(40,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[u.localize(206,null),u.localize(207,null)],description:u.localize(208,null)})),foldingHighlight:Re(new h(41,"foldingHighlight",!0,{description:u.localize(209,null)})),foldingImportsByDefault:Re(new h(42,"foldingImportsByDefault",!1,{description:u.localize(210,null)})),foldingMaximumRegions:Re(new p(43,"foldingMaximumRegions",5e3,10,65e3,{description:u.localize(211,null)})),unfoldOnClickAfterEndOfLine:Re(new h(44,"unfoldOnClickAfterEndOfLine",!1,{description:u.localize(212,null)})),fontFamily:Re(new m(45,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:u.localize(213,null)})),fontInfo:Re(new x),fontLigatures2:Re(new B),fontSize:Re(new N),fontWeight:Re(new K),formatOnPaste:Re(new h(50,"formatOnPaste",!1,{description:u.localize(214,null)})),formatOnType:Re(new h(51,"formatOnType",!1,{description:u.localize(215,null)})),glyphMargin:Re(new h(52,"glyphMargin",!0,{description:u.localize(216,null)})),gotoLocation:Re(new X),hideCursorInOverviewRuler:Re(new h(54,"hideCursorInOverviewRuler",!1,{description:u.localize(217,null)})),hover:Re(new L),inDiffEditor:Re(new h(56,"inDiffEditor",!1)),letterSpacing:Re(new o(58,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,se=>o.clamp(se,-5,20),{description:u.localize(218,null)})),lightbulb:Re(new j),lineDecorationsWidth:Re(new b(60,"lineDecorationsWidth",10)),lineHeight:Re(new he),lineNumbers:Re(new ae),lineNumbersMinChars:Re(new p(63,"lineNumbersMinChars",5,1,300)),linkedEditing:Re(new h(64,"linkedEditing",!1,{description:u.localize(219,null)})),links:Re(new h(65,"links",!0,{description:u.localize(220,null)})),matchBrackets:Re(new l(66,"matchBrackets","always",["always","near","never"],{description:u.localize(221,null)})),minimap:Re(new ve),mouseStyle:Re(new l(68,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Re(new o(69,"mouseWheelScrollSensitivity",1,se=>se===0?1:se,{markdownDescription:u.localize(222,null)})),mouseWheelZoom:Re(new h(70,"mouseWheelZoom",!1,{markdownDescription:u.localize(223,null)})),multiCursorMergeOverlapping:Re(new h(71,"multiCursorMergeOverlapping",!0,{description:u.localize(224,null)})),multiCursorModifier:Re(new s(72,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ne,{markdownEnumDescriptions:[u.localize(225,null),u.localize(226,null)],markdownDescription:u.localize(227,null)})),multiCursorPaste:Re(new l(73,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[u.localize(228,null),u.localize(229,null)],markdownDescription:u.localize(230,null)})),occurrencesHighlight:Re(new h(74,"occurrencesHighlight",!0,{description:u.localize(231,null)})),overviewRulerBorder:Re(new h(75,"overviewRulerBorder",!0,{description:u.localize(232,null)})),overviewRulerLanes:Re(new p(76,"overviewRulerLanes",3,0,3)),padding:Re(new pe),parameterHints:Re(new Ee),peekWidgetDefaultFocus:Re(new l(79,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[u.localize(233,null),u.localize(234,null)],description:u.localize(235,null)})),definitionLinkOpensInPeek:Re(new h(80,"definitionLinkOpensInPeek",!1,{description:u.localize(236,null)})),quickSuggestions:Re(new Oe),quickSuggestionsDelay:Re(new p(82,"quickSuggestionsDelay",10,0,1073741824,{description:u.localize(237,null)})),readOnly:Re(new h(83,"readOnly",!1)),renameOnType:Re(new h(84,"renameOnType",!1,{description:u.localize(238,null),markdownDeprecationMessage:u.localize(239,null)})),renderControlCharacters:Re(new h(85,"renderControlCharacters",!0,{description:u.localize(240,null),restricted:!0})),renderFinalNewline:Re(new h(86,"renderFinalNewline",!0,{description:u.localize(241,null)})),renderLineHighlight:Re(new l(87,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",u.localize(242,null)],description:u.localize(243,null)})),renderLineHighlightOnlyWhenFocus:Re(new h(88,"renderLineHighlightOnlyWhenFocus",!1,{description:u.localize(244,null)})),renderValidationDecorations:Re(new l(89,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Re(new l(90,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",u.localize(245,null),u.localize(246,null),u.localize(247,null),""],description:u.localize(248,null)})),revealHorizontalRightPadding:Re(new p(91,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Re(new h(92,"roundedSelection",!0,{description:u.localize(249,null)})),rulers:Re(new me),scrollbar:Re(new le),scrollBeyondLastColumn:Re(new p(95,"scrollBeyondLastColumn",4,0,1073741824,{description:u.localize(250,null)})),scrollBeyondLastLine:Re(new h(96,"scrollBeyondLastLine",!0,{description:u.localize(251,null)})),scrollPredominantAxis:Re(new h(97,"scrollPredominantAxis",!0,{description:u.localize(252,null)})),selectionClipboard:Re(new h(98,"selectionClipboard",!0,{description:u.localize(253,null),included:t.isLinux})),selectionHighlight:Re(new h(99,"selectionHighlight",!0,{description:u.localize(254,null)})),selectOnLineNumbers:Re(new h(100,"selectOnLineNumbers",!0)),showFoldingControls:Re(new l(101,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[u.localize(255,null),u.localize(256,null),u.localize(257,null)],description:u.localize(258,null)})),showUnused:Re(new h(102,"showUnused",!0,{description:u.localize(259,null)})),showDeprecated:Re(new h(128,"showDeprecated",!0,{description:u.localize(260,null)})),inlayHints:Re(new Y),snippetSuggestions:Re(new l(103,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[u.localize(261,null),u.localize(262,null),u.localize(263,null),u.localize(264,null)],description:u.localize(265,null)})),smartSelect:Re(new fe),smoothScrolling:Re(new h(105,"smoothScrolling",!1,{description:u.localize(266,null)})),stopRenderingLineAfter:Re(new p(107,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Re(new Q),inlineSuggest:Re(new re),suggestFontSize:Re(new p(109,"suggestFontSize",0,0,1e3,{markdownDescription:u.localize(267,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Re(new p(110,"suggestLineHeight",0,0,1e3,{markdownDescription:u.localize(268,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Re(new h(111,"suggestOnTriggerCharacters",!0,{description:u.localize(269,null)})),suggestSelection:Re(new l(112,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[u.localize(270,null),u.localize(271,null),u.localize(272,null)],description:u.localize(273,null)})),tabCompletion:Re(new l(113,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[u.localize(274,null),u.localize(275,null),u.localize(276,null)],description:u.localize(277,null)})),tabIndex:Re(new p(114,"tabIndex",0,-1,1073741824)),unicodeHighlight:Re(new ee),unusualLineTerminators:Re(new l(116,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[u.localize(278,null),u.localize(279,null),u.localize(280,null)],description:u.localize(281,null)})),useShadowDOM:Re(new h(117,"useShadowDOM",!0)),useTabStops:Re(new h(118,"useTabStops",!0,{description:u.localize(282,null)})),wordSeparators:Re(new m(119,"wordSeparators",D.USUAL_WORD_SEPARATORS,{description:u.localize(283,null)})),wordWrap:Re(new l(120,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[u.localize(284,null),u.localize(285,null),u.localize(286,null),u.localize(287,null)],description:u.localize(288,null)})),wordWrapBreakAfterCharacters:Re(new m(121,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Re(new m(122,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Re(new p(123,"wordWrapColumn",80,1,1073741824,{markdownDescription:u.localize(289,null)})),wordWrapOverride1:Re(new l(124,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Re(new l(125,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Re(new s(126,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Ce,{enumDescriptions:[u.localize(290,null),u.localize(291,null),u.localize(292,null),u.localize(293,null)],description:u.localize(294,null)})),wrappingStrategy:Re(new l(127,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[u.localize(295,null),u.localize(296,null)],description:u.localize(297,null)})),editorClassName:Re(new U),pixelRatio:Re(new ke),tabFocusMode:Re(new be),layoutInfo:Re(new H),wrappingInfo:Re(new Se)}}),define(De[161],Ie([19,20]),function(Z,e){return Z.create("vs/platform/configuration/common/configurationRegistry",e)}),define(De[162],Ie([19,20]),function(Z,e){return Z.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(De[163],Ie([19,20]),function(Z,e){return Z.create("vs/platform/extensions/common/extensionValidator",e)}),define(De[164],Ie([19,20]),function(Z,e){return Z.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(De[165],Ie([19,20]),function(Z,e){return Z.create("vs/platform/files/common/files",e)}),define(De[166],Ie([19,20]),function(Z,e){return Z.create("vs/platform/markers/common/markers",e)}),define(De[167],Ie([19,20]),function(Z,e){return Z.create("vs/platform/workspace/common/workspace",e)}),define(De[168],Ie([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(De[169],Ie([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostExtensionService",e)}),define(De[170],Ie([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostProgress",e)}),define(De[171],Ie([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostStatusBar",e)}),define(De[172],Ie([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostTerminalService",e)}),define(De[173],Ie([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostTreeViews",e)}),define(De[174],Ie([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostWorkspace",e)}),define(De[175],Ie([19,20]),function(Z,e){return Z.create("vs/workbench/api/node/extHostDebugService",e)}),define(De[176],Ie([19,20]),function(Z,e){return Z.create("vs/workbench/api/node/extHostTunnelService",e)}),define(De[177],Ie([19,20]),function(Z,e){return Z.create("vs/workbench/common/editor",e)}),define(De[178],Ie([19,20]),function(Z,e){return Z.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(De[179],Ie([19,20]),function(Z,e){return Z.create("vs/workbench/contrib/debug/common/debug",e)}),define(De[180],Ie([19,20]),function(Z,e){return Z.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(De[181],Ie([19,20]),function(Z,e){return Z.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(De[182],Ie([19,20]),function(Z,e){return Z.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(De[183],Ie([19,20]),function(Z,e){return Z.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(De[184],Ie([19,20]),function(Z,e){return Z.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(De[185],Ie([19,20]),function(Z,e){return Z.create("vs/workbench/services/search/common/queryBuilder",e)}),define(De[186],Ie([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionSource=e.TextEditorSelectionRevealType=e.EditorOpenSource=e.EditorResolution=e.EditorActivation=void 0;var u;(function(C){C[C.ACTIVATE=1]="ACTIVATE",C[C.RESTORE=2]="RESTORE",C[C.PRESERVE=3]="PRESERVE"})(u=e.EditorActivation||(e.EditorActivation={}));var t;(function(C){C[C.PICK=0]="PICK",C[C.DISABLED=1]="DISABLED",C[C.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(t=e.EditorResolution||(e.EditorResolution={}));var D;(function(C){C[C.API=0]="API",C[C.USER=1]="USER"})(D=e.EditorOpenSource||(e.EditorOpenSource={}));var P;(function(C){C[C.Center=0]="Center",C[C.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",C[C.NearTop=2]="NearTop",C[C.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(P=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}));var y;(function(C){C.PROGRAMMATIC="api",C.NAVIGATION="code.navigation",C.JUMP="code.jump"})(y=e.TextEditorSelectionSource||(e.TextEditorSelectionSource={}))}),define(De[187],Ie([1,0,22,41,163,303]),function(Z,e,u,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const y=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,C=/^-(\d{4})(\d{2})(\d{2})$/;function E(h){return h=h.trim(),h==="*"||y.test(h)}e.isValidVersionStr=E;function I(h){if(!E(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const g=h.match(y);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.parseVersion=I;function R(h){if(!h)return null;const g=h.majorBase,p=h.majorMustEqual,o=h.minorBase;let m=h.minorMustEqual;const c=h.patchBase;let l=h.patchMustEqual;h.hasCaret&&(g===0||(m=!1),l=!1);let s=0;if(h.preRelease){const i=C.exec(h.preRelease);if(i){const[,r,n,a]=i;s=Date.UTC(Number(r),Number(n)-1,Number(a))}}return{majorBase:g,majorMustEqual:p,minorBase:o,minorMustEqual:m,patchBase:c,patchMustEqual:l,isMinimum:h.hasGreaterEquals,notBefore:s}}e.normalizeVersion=R;function k(h,g,p){let o;typeof h=="string"?o=R(I(h)):o=h;let m;g instanceof Date?m=g.getTime():typeof g=="string"&&(m=new Date(g).getTime());let c;if(typeof p=="string"?c=R(I(p)):c=p,!o||!c)return!1;const l=o.majorBase,s=o.minorBase,i=o.patchBase;let r=c.majorBase,n=c.minorBase,a=c.patchBase;const d=c.notBefore;let f=c.majorMustEqual,S=c.minorMustEqual,O=c.patchMustEqual;return c.isMinimum?l>r?!0:l<r?!1:s>n?!0:s<n||m&&m<d?!1:i>=a:(l===1&&r===0&&(!f||!S||!O)&&(r=1,n=0,a=0,f=!0,S=!1,O=!1),l<r?!1:l>r?!f:s<n?!1:s>n?!S:i<a?!1:i>a?!O:!(m&&m<d))}e.isValidVersion=k;function _(h,g,p,o,m){const c=[];if(typeof o.publisher!="undefined"&&typeof o.publisher!="string")return c.push([t.default.Error,D.localize(0,null)]),c;if(typeof o.name!="string")return c.push([t.default.Error,D.localize(1,null,"name")]),c;if(typeof o.version!="string")return c.push([t.default.Error,D.localize(2,null,"version")]),c;if(!o.engines)return c.push([t.default.Error,D.localize(3,null,"engines")]),c;if(typeof o.engines.vscode!="string")return c.push([t.default.Error,D.localize(4,null,"engines.vscode")]),c;if(typeof o.extensionDependencies!="undefined"&&!v(o.extensionDependencies))return c.push([t.default.Error,D.localize(5,null,"extensionDependencies")]),c;if(typeof o.activationEvents!="undefined"){if(!v(o.activationEvents))return c.push([t.default.Error,D.localize(6,null,"activationEvents")]),c;if(typeof o.main=="undefined"&&typeof o.browser=="undefined")return c.push([t.default.Error,D.localize(7,null,"activationEvents","main")]),c}if(typeof o.extensionKind!="undefined"&&typeof o.main=="undefined"&&c.push([t.default.Warning,D.localize(8,null,"extensionKind")]),typeof o.main!="undefined"){if(typeof o.main!="string")return c.push([t.default.Error,D.localize(9,null,"main")]),c;{const i=(0,u.joinPath)(p,o.main);(0,u.isEqualOrParent)(i,p)||c.push([t.default.Warning,D.localize(10,null,i.path,p.path)])}if(typeof o.activationEvents=="undefined")return c.push([t.default.Error,D.localize(11,null,"activationEvents","main")]),c}if(typeof o.browser!="undefined"){if(typeof o.browser!="string")return c.push([t.default.Error,D.localize(12,null,"browser")]),c;{const i=(0,u.joinPath)(p,o.browser);(0,u.isEqualOrParent)(i,p)||c.push([t.default.Warning,D.localize(13,null,i.path,p.path)])}if(typeof o.activationEvents=="undefined")return c.push([t.default.Error,D.localize(14,null,"activationEvents","browser")]),c}if(!P.valid(o.version))return c.push([t.default.Error,D.localize(15,null)]),c;const l=[];if(!T(h,g,o,m,l))for(const i of l)c.push([t.default.Error,i]);return c}e.validateExtensionManifest=_;function T(h,g,p,o,m){return o||typeof p.main=="undefined"&&typeof p.browser=="undefined"?!0:b(h,g,p.engines.vscode,m)}e.isValidExtensionVersion=T;function w(h,g,p){return h==="*"||b(g,p,h)}e.isEngineValid=w;function b(h,g,p,o=[]){const m=R(I(p));if(!m)return o.push(D.localize(16,null,p)),!1;if(m.majorBase===0){if(!m.majorMustEqual||!m.minorMustEqual)return o.push(D.localize(17,null,p)),!1}else if(!m.majorMustEqual)return o.push(D.localize(18,null,p)),!1;return k(h,g,m)?!0:(o.push(D.localize(19,null,h,p)),!1)}function v(h){if(!Array.isArray(h))return!1;for(let g=0,p=h.length;g<p;g++)if(typeof h[g]!="string")return!1;return!0}}),define(De[115],Ie([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class u{constructor(D,P=[],y=!1){this.ctor=D,this.staticArguments=P,this.supportsDelayedInstantiation=y}}e.SyncDescriptor=u}),define(De[82],Ie([1,0,115]),function(Z,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const t=[];function D(y,C,E){C instanceof u.SyncDescriptor||(C=new u.SyncDescriptor(C,[],E)),t.push([y,C])}e.registerSingleton=D;function P(){return t}e.getSingletonServiceDescriptors=P}),define(De[188],Ie([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class u{constructor(P){this.incoming=new Map,this.outgoing=new Map,this.data=P}}e.Node=u;class t{constructor(P){this._hashFn=P,this._nodes=new Map}roots(){const P=[];for(const y of this._nodes.values())y.outgoing.size===0&&P.push(y);return P}insertEdge(P,y){const C=this.lookupOrInsertNode(P),E=this.lookupOrInsertNode(y);C.outgoing.set(this._hashFn(y),E),E.incoming.set(this._hashFn(P),C)}removeNode(P){const y=this._hashFn(P);this._nodes.delete(y);for(const C of this._nodes.values())C.outgoing.delete(y),C.incoming.delete(y)}lookupOrInsertNode(P){const y=this._hashFn(P);let C=this._nodes.get(y);return C||(C=new u(P),this._nodes.set(y,C)),C}lookup(P){return this._nodes.get(this._hashFn(P))}isEmpty(){return this._nodes.size===0}toString(){const P=[];for(const[y,C]of this._nodes)P.push(`${y}, (incoming)[${[...C.incoming.keys()].join(", ")}], (outgoing)[${[...C.outgoing.keys()].join(",")}]`);return P.join(`
`)}findCycleSlow(){for(const[P,y]of this._nodes){const C=new Set([P]),E=this._findCycle(y,C);if(E)return E}}_findCycle(P,y){for(const[C,E]of P.outgoing){if(y.has(C))return[...y,C].join(" -> ");y.add(C);const I=this._findCycle(E,y);if(I)return I;y.delete(C)}}}e.Graph=t}),define(De[3],Ie([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var u;(function(y){y.serviceIds=new Map,y.DI_TARGET="$di$target",y.DI_DEPENDENCIES="$di$dependencies";function C(E){return E[y.DI_DEPENDENCIES]||[]}y.getServiceDependencies=C})(u=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function t(y,C,E){C[u.DI_TARGET]===C?C[u.DI_DEPENDENCIES].push({id:y,index:E}):(C[u.DI_DEPENDENCIES]=[{id:y,index:E}],C[u.DI_TARGET]=C)}function D(y){if(u.serviceIds.has(y))return u.serviceIds.get(y);const C=function(E,I,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(C,E,R)};return C.toString=()=>y,u.serviceIds.set(y,C),C}e.createDecorator=D;function P(y){return y}e.refineServiceDecorator=P}),define(De[83],Ie([1,0,13,2,3]),function(Z,e,u,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,D.createDecorator)("configurationService");function P(h){return h&&typeof h=="object"&&(!h.overrideIdentifier||typeof h.overrideIdentifier=="string")&&(!h.resource||h.resource instanceof t.URI)}e.isConfigurationOverrides=P;function y(h){return h&&typeof h=="object"&&(!h.overrideIdentifiers||Array.isArray(h.overrideIdentifiers))&&!h.overrideIdentifier&&(!h.resource||h.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=y;var C;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.USER=2]="USER",h[h.USER_LOCAL=3]="USER_LOCAL",h[h.USER_REMOTE=4]="USER_REMOTE",h[h.WORKSPACE=5]="WORKSPACE",h[h.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",h[h.DEFAULT=7]="DEFAULT",h[h.MEMORY=8]="MEMORY"})(C=e.ConfigurationTarget||(e.ConfigurationTarget={}));function E(h){switch(h){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=E;function I(h,g){const p=Object.create(null);for(const o in h)R(p,o,h[o],g);return p}e.toValuesTree=I;function R(h,g,p,o){const m=g.split("."),c=m.pop();let l=h;for(let s=0;s<m.length;s++){const i=m[s];let r=l[i];switch(typeof r){case"undefined":r=l[i]=Object.create(null);break;case"object":break;default:o(`Ignoring ${g} as ${m.slice(0,s+1).join(".")} is ${JSON.stringify(r)}`);return}l=r}if(typeof l=="object"&&l!==null)try{l[c]=p}catch{o(`Ignoring ${g} as ${m.join(".")} is ${JSON.stringify(l)}`)}else o(`Ignoring ${g} as ${m.join(".")} is ${JSON.stringify(l)}`)}e.addToValueTree=R;function k(h,g){const p=g.split(".");_(h,p)}e.removeFromValueTree=k;function _(h,g){const p=g.shift();if(g.length===0){delete h[p];return}if(Object.keys(h).indexOf(p)!==-1){const o=h[p];typeof o=="object"&&!Array.isArray(o)&&(_(o,g),Object.keys(o).length===0&&delete h[p])}}function T(h,g,p){function o(l,s){let i=l;for(const r of s){if(typeof i!="object"||i===null)return;i=i[r]}return i}const m=g.split("."),c=o(h,m);return typeof c=="undefined"?p:c}e.getConfigurationValue=T;function w(h,g,p){Object.keys(g).forEach(o=>{o!=="__proto__"&&(o in h?u.isObject(h[o])&&u.isObject(g[o])?w(h[o],g[o],p):p&&(h[o]=g[o]):h[o]=g[o])})}e.merge=w;function b(h,g,p){const o=h.inspect(g),m=h.inspect(p);return typeof o.userValue!="undefined"||typeof o.workspaceValue!="undefined"||typeof o.workspaceFolderValue!="undefined"?o.value:typeof m.userValue!="undefined"||typeof m.workspaceValue!="undefined"||typeof m.workspaceFolderValue!="undefined"?m.value:o.defaultValue}e.getMigratedSettingValue=b;function v(h){return h.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=v}),define(De[52],Ie([1,0,11,8,3]),function(Z,e,u,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const P=new Map;P.set("false",!1),P.set("true",!0),P.set("isMac",u.isMacintosh),P.set("isLinux",u.isLinux),P.set("isWindows",u.isWindows),P.set("isWeb",u.isWeb),P.set("isMacNative",u.isMacintosh&&!u.isWeb),P.set("isEdge",u.isEdge),P.set("isFirefox",u.isFirefox),P.set("isChrome",u.isChrome),P.set("isSafari",u.isSafari);const y=Object.prototype.hasOwnProperty;var C;(function(M){M[M.False=0]="False",M[M.True=1]="True",M[M.Defined=2]="Defined",M[M.Not=3]="Not",M[M.Equals=4]="Equals",M[M.NotEquals=5]="NotEquals",M[M.And=6]="And",M[M.Regex=7]="Regex",M[M.NotRegex=8]="NotRegex",M[M.Or=9]="Or",M[M.In=10]="In",M[M.NotIn=11]="NotIn",M[M.Greater=12]="Greater",M[M.GreaterEquals=13]="GreaterEquals",M[M.Smaller=14]="Smaller",M[M.SmallerEquals=15]="SmallerEquals"})(C=e.ContextKeyExprType||(e.ContextKeyExprType={}));class E{static false(){return k.INSTANCE}static true(){return _.INSTANCE}static has(A){return T.create(A)}static equals(A,B){return w.create(A,B)}static notEquals(A,B){return h.create(A,B)}static regex(A,B){return s.create(A,B)}static in(A,B){return b.create(A,B)}static notIn(A,B){return v.create(A,B)}static not(A){return g.create(A)}static and(...A){return n.create(A,null)}static or(...A){return a.create(A,null,!0)}static greater(A,B){return o.create(A,B)}static greaterEquals(A,B){return m.create(A,B)}static smaller(A,B){return c.create(A,B)}static smallerEquals(A,B){return l.create(A,B)}static deserialize(A,B=!1){if(!!A)return this._deserializeOrExpression(A,B)}static _deserializeOrExpression(A,B){const x=A.split("||");return a.create(x.map(N=>this._deserializeAndExpression(N,B)),null,!0)}static _deserializeAndExpression(A,B){const x=A.split("&&");return n.create(x.map(N=>this._deserializeOne(N,B)),null)}static _deserializeOne(A,B){if(A=A.trim(),A.indexOf("!=")>=0){const x=A.split("!=");return h.create(x[0].trim(),this._deserializeValue(x[1],B))}if(A.indexOf("==")>=0){const x=A.split("==");return w.create(x[0].trim(),this._deserializeValue(x[1],B))}if(A.indexOf("=~")>=0){const x=A.split("=~");return s.create(x[0].trim(),this._deserializeRegexValue(x[1],B))}if(A.indexOf(" not in ")>=0){const x=A.split(" not in ");return v.create(x[0].trim(),x[1].trim())}if(A.indexOf(" in ")>=0){const x=A.split(" in ");return b.create(x[0].trim(),x[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(A)){const x=A.split(">=");return m.create(x[0].trim(),x[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(A)){const x=A.split(">");return o.create(x[0].trim(),x[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(A)){const x=A.split("<=");return l.create(x[0].trim(),x[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(A)){const x=A.split("<");return c.create(x[0].trim(),x[1].trim())}return/^\!\s*/.test(A)?g.create(A.substr(1).trim()):T.create(A)}static _deserializeValue(A,B){if(A=A.trim(),A==="true")return!0;if(A==="false")return!1;const x=/^'([^']*)'$/.exec(A);return x?x[1].trim():A}static _deserializeRegexValue(A,B){if((0,t.isFalsyOrWhitespace)(A)){if(B)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const x=A.indexOf("/"),N=A.lastIndexOf("/");if(x===N||x<0){if(B)throw new Error(`bad regexp-value '${A}', missing /-enclosure`);return console.warn(`bad regexp-value '${A}', missing /-enclosure`),null}const K=A.slice(x+1,N),X=A[N+1]==="i"?"i":"";try{return new RegExp(K,X)}catch(L){if(B)throw new Error(`bad regexp-value '${A}', parse error: ${L}`);return console.warn(`bad regexp-value '${A}', parse error: ${L}`),null}}}e.ContextKeyExpr=E;function I(M,A){const B=M?M.substituteConstants():void 0,x=A?A.substituteConstants():void 0;return!B&&!x?!0:!B||!x?!1:B.equals(x)}e.expressionsAreEqualWithConstantSubstitution=I;function R(M,A){return M.cmp(A)}class k{constructor(){this.type=0}cmp(A){return this.type-A.type}equals(A){return A.type===this.type}substituteConstants(){return this}evaluate(A){return!1}serialize(){return"false"}keys(){return[]}map(A){return this}negate(){return _.INSTANCE}}e.ContextKeyFalseExpr=k,k.INSTANCE=new k;class _{constructor(){this.type=1}cmp(A){return this.type-A.type}equals(A){return A.type===this.type}substituteConstants(){return this}evaluate(A){return!0}serialize(){return"true"}keys(){return[]}map(A){return this}negate(){return k.INSTANCE}}e.ContextKeyTrueExpr=_,_.INSTANCE=new _;class T{constructor(A,B){this.key=A,this.negated=B,this.type=2}static create(A,B=null){const x=P.get(A);return typeof x=="boolean"?x?_.INSTANCE:k.INSTANCE:new T(A,B)}cmp(A){return A.type!==this.type?this.type-A.type:f(this.key,A.key)}equals(A){return A.type===this.type?this.key===A.key:!1}substituteConstants(){const A=P.get(this.key);return typeof A=="boolean"?A?_.INSTANCE:k.INSTANCE:this}evaluate(A){return!!A.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(A){return A.mapDefined(this.key)}negate(){return this.negated||(this.negated=g.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=T;class w{constructor(A,B,x){this.key=A,this.value=B,this.negated=x,this.type=4}static create(A,B,x=null){if(typeof B=="boolean")return B?T.create(A,x):g.create(A,x);const N=P.get(A);return typeof N=="boolean"?B===(N?"true":"false")?_.INSTANCE:k.INSTANCE:new w(A,B,x)}cmp(A){return A.type!==this.type?this.type-A.type:S(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){const A=P.get(this.key);if(typeof A=="boolean"){const B=A?"true":"false";return this.value===B?_.INSTANCE:k.INSTANCE}return this}evaluate(A){return A.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(A){return A.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=h.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=w;class b{constructor(A,B){this.key=A,this.valueKey=B,this.type=10,this.negated=null}static create(A,B){return new b(A,B)}cmp(A){return A.type!==this.type?this.type-A.type:S(this.key,this.valueKey,A.key,A.valueKey)}equals(A){return A.type===this.type?this.key===A.key&&this.valueKey===A.valueKey:!1}substituteConstants(){return this}evaluate(A){const B=A.getValue(this.valueKey),x=A.getValue(this.key);return Array.isArray(B)?B.includes(x):typeof x=="string"&&typeof B=="object"&&B!==null?y.call(B,x):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(A){return A.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=v.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=b;class v{constructor(A,B){this.key=A,this.valueKey=B,this.type=11,this._negated=b.create(A,B)}static create(A,B){return new v(A,B)}cmp(A){return A.type!==this.type?this.type-A.type:this._negated.cmp(A._negated)}equals(A){return A.type===this.type?this._negated.equals(A._negated):!1}substituteConstants(){return this}evaluate(A){return!this._negated.evaluate(A)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(A){return A.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=v;class h{constructor(A,B,x){this.key=A,this.value=B,this.negated=x,this.type=5}static create(A,B,x=null){if(typeof B=="boolean")return B?g.create(A,x):T.create(A,x);const N=P.get(A);return typeof N=="boolean"?B===(N?"true":"false")?k.INSTANCE:_.INSTANCE:new h(A,B,x)}cmp(A){return A.type!==this.type?this.type-A.type:S(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){const A=P.get(this.key);if(typeof A=="boolean"){const B=A?"true":"false";return this.value===B?k.INSTANCE:_.INSTANCE}return this}evaluate(A){return A.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(A){return A.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=w.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=h;class g{constructor(A,B){this.key=A,this.negated=B,this.type=3}static create(A,B=null){const x=P.get(A);return typeof x=="boolean"?x?k.INSTANCE:_.INSTANCE:new g(A,B)}cmp(A){return A.type!==this.type?this.type-A.type:f(this.key,A.key)}equals(A){return A.type===this.type?this.key===A.key:!1}substituteConstants(){const A=P.get(this.key);return typeof A=="boolean"?A?k.INSTANCE:_.INSTANCE:this}evaluate(A){return!A.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(A){return A.mapNot(this.key)}negate(){return this.negated||(this.negated=T.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=g;function p(M,A){if(typeof M=="string"){const B=parseFloat(M);isNaN(B)||(M=B)}return typeof M=="string"||typeof M=="number"?A(M):k.INSTANCE}class o{constructor(A,B,x){this.key=A,this.value=B,this.negated=x,this.type=12}static create(A,B,x=null){return p(B,N=>new o(A,N,x))}cmp(A){return A.type!==this.type?this.type-A.type:S(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){return this}evaluate(A){return typeof this.value=="string"?!1:parseFloat(A.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(A){return A.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=o;class m{constructor(A,B,x){this.key=A,this.value=B,this.negated=x,this.type=13}static create(A,B,x=null){return p(B,N=>new m(A,N,x))}cmp(A){return A.type!==this.type?this.type-A.type:S(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){return this}evaluate(A){return typeof this.value=="string"?!1:parseFloat(A.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(A){return A.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=c.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=m;class c{constructor(A,B,x){this.key=A,this.value=B,this.negated=x,this.type=14}static create(A,B,x=null){return p(B,N=>new c(A,N,x))}cmp(A){return A.type!==this.type?this.type-A.type:S(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){return this}evaluate(A){return typeof this.value=="string"?!1:parseFloat(A.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(A){return A.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=m.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=c;class l{constructor(A,B,x){this.key=A,this.value=B,this.negated=x,this.type=15}static create(A,B,x=null){return p(B,N=>new l(A,N,x))}cmp(A){return A.type!==this.type?this.type-A.type:S(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){return this}evaluate(A){return typeof this.value=="string"?!1:parseFloat(A.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(A){return A.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=o.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=l;class s{constructor(A,B){this.key=A,this.regexp=B,this.type=7,this.negated=null}static create(A,B){return new s(A,B)}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.key<A.key)return-1;if(this.key>A.key)return 1;const B=this.regexp?this.regexp.source:"",x=A.regexp?A.regexp.source:"";return B<x?-1:B>x?1:0}equals(A){if(A.type===this.type){const B=this.regexp?this.regexp.source:"",x=A.regexp?A.regexp.source:"";return this.key===A.key&&B===x}return!1}substituteConstants(){return this}evaluate(A){const B=A.getValue(this.key);return this.regexp?this.regexp.test(B):!1}serialize(){const A=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${A}`}keys(){return[this.key]}map(A){return A.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=i.create(this)),this.negated}}e.ContextKeyRegexExpr=s;class i{constructor(A){this._actual=A,this.type=8}static create(A){return new i(A)}cmp(A){return A.type!==this.type?this.type-A.type:this._actual.cmp(A._actual)}equals(A){return A.type===this.type?this._actual.equals(A._actual):!1}substituteConstants(){return this}evaluate(A){return!this._actual.evaluate(A)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(A){return new i(this._actual.map(A))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=i;function r(M){let A=null;for(let B=0,x=M.length;B<x;B++){const N=M[B].substituteConstants();if(M[B]!==N&&A===null){A=[];for(let K=0;K<B;K++)A[K]=M[K]}A!==null&&(A[B]=N)}return A===null?M:A}class n{constructor(A,B){this.expr=A,this.negated=B,this.type=6}static create(A,B){return n._normalizeArr(A,B)}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.expr.length<A.expr.length)return-1;if(this.expr.length>A.expr.length)return 1;for(let B=0,x=this.expr.length;B<x;B++){const N=R(this.expr[B],A.expr[B]);if(N!==0)return N}return 0}equals(A){if(A.type===this.type){if(this.expr.length!==A.expr.length)return!1;for(let B=0,x=this.expr.length;B<x;B++)if(!this.expr[B].equals(A.expr[B]))return!1;return!0}return!1}substituteConstants(){const A=r(this.expr);return A===this.expr?this:n.create(A,this.negated)}evaluate(A){for(let B=0,x=this.expr.length;B<x;B++)if(!this.expr[B].evaluate(A))return!1;return!0}static _normalizeArr(A,B){const x=[];let N=!1;for(const K of A)if(!!K){if(K.type===1){N=!0;continue}if(K.type===0)return k.INSTANCE;if(K.type===6){x.push(...K.expr);continue}x.push(K)}if(x.length===0&&N)return _.INSTANCE;if(x.length!==0){if(x.length===1)return x[0];x.sort(R);for(let K=1;K<x.length;K++)x[K-1].equals(x[K])&&(x.splice(K,1),K--);if(x.length===1)return x[0];for(;x.length>1;){const K=x[x.length-1];if(K.type!==9)break;x.pop();const X=x.pop(),L=x.length===0,$=a.create(K.expr.map(H=>n.create([H,X],null)),null,L);$&&(x.push($),x.sort(R))}return x.length===1?x[0]:new n(x,B)}}serialize(){return this.expr.map(A=>A.serialize()).join(" && ")}keys(){const A=[];for(const B of this.expr)A.push(...B.keys());return A}map(A){return new n(this.expr.map(B=>B.map(A)),null)}negate(){if(!this.negated){const A=[];for(const B of this.expr)A.push(B.negate());this.negated=a.create(A,this,!0)}return this.negated}}class a{constructor(A,B){this.expr=A,this.negated=B,this.type=9}static create(A,B,x){return a._normalizeArr(A,B,x)}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.expr.length<A.expr.length)return-1;if(this.expr.length>A.expr.length)return 1;for(let B=0,x=this.expr.length;B<x;B++){const N=R(this.expr[B],A.expr[B]);if(N!==0)return N}return 0}equals(A){if(A.type===this.type){if(this.expr.length!==A.expr.length)return!1;for(let B=0,x=this.expr.length;B<x;B++)if(!this.expr[B].equals(A.expr[B]))return!1;return!0}return!1}substituteConstants(){const A=r(this.expr);return A===this.expr?this:a.create(A,this.negated,!1)}evaluate(A){for(let B=0,x=this.expr.length;B<x;B++)if(this.expr[B].evaluate(A))return!0;return!1}static _normalizeArr(A,B,x){let N=[],K=!1;if(A){for(let X=0,L=A.length;X<L;X++){const $=A[X];if(!!$){if($.type===0){K=!0;continue}if($.type===1)return _.INSTANCE;if($.type===9){N=N.concat($.expr);continue}N.push($)}}if(N.length===0&&K)return k.INSTANCE;N.sort(R)}if(N.length!==0){if(N.length===1)return N[0];for(let X=1;X<N.length;X++)N[X-1].equals(N[X])&&(N.splice(X,1),X--);if(N.length===1)return N[0];if(x){for(let X=0;X<N.length;X++)for(let L=X+1;L<N.length;L++)O(N[X],N[L])&&(N.splice(L,1),L--);if(N.length===1)return N[0]}return new a(N,B)}}serialize(){return this.expr.map(A=>A.serialize()).join(" || ")}keys(){const A=[];for(const B of this.expr)A.push(...B.keys());return A}map(A){return new a(this.expr.map(B=>B.map(A)),null)}negate(){if(!this.negated){const A=[];for(const B of this.expr)A.push(B.negate());for(;A.length>1;){const B=A.shift(),x=A.shift(),N=[];for(const X of U(B))for(const L of U(x))N.push(n.create([X,L],null));const K=A.length===0;A.unshift(a.create(N,null,K))}this.negated=A[0]}return this.negated}}class d extends T{constructor(A,B,x){super(A,null);this._defaultValue=B,typeof x=="object"?d._info.push({...x,key:A}):x!==!0&&d._info.push({key:A,description:x,type:B!=null?typeof B:void 0})}static all(){return d._info.values()}bindTo(A){return A.createKey(this.key,this._defaultValue)}getValue(A){return A.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(A){return w.create(this.key,A)}notEqualsTo(A){return h.create(this.key,A)}}e.RawContextKey=d,d._info=[],e.IContextKeyService=(0,D.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function f(M,A){return M<A?-1:M>A?1:0}function S(M,A,B,x){return M<B?-1:M>B?1:A<x?-1:A>x?1:0}function O(M,A){if(A.type===6&&M.type!==9&&M.type!==6){for(const N of A.expr)if(M.equals(N))return!0}const B=M.negate(),x=U(B).concat(U(A));x.sort(R);for(let N=0;N<x.length;N++){const X=x[N].negate();for(let L=N+1;L<x.length;L++){const $=x[L];if(X.equals($))return!0}}return!1}e.implies=O;function U(M){return M.type===9?M.expr:[M]}}),define(De[189],Ie([1,0,3]),function(Z,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,u.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,u.refineServiceDecorator)(e.IEnvironmentService)}),define(De[84],Ie([1,0,162,3]),function(Z,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IServerExtensionManagementService=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function D(h){switch(h){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=D;function P(h){switch(h){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=P;function y(h,g){switch(h){case 3:return g==="x64"?"win32-x64":g==="ia32"?"win32-ia32":g==="arm64"?"win32-arm64":"unknown";case 2:return g==="x64"?"linux-x64":g==="arm64"?"linux-arm64":g==="arm"?"linux-armhf":"unknown";case"alpine":return g==="x64"?"alpine-x64":g==="arm64"?"alpine-arm64":"unknown";case 1:return g==="x64"?"darwin-x64":g==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=y;function C(h,g){return g==="web"&&!h.includes("web")}e.isNotWebExtensionInWebTargetPlatform=C;function E(h,g,p){return C(g,p)?!1:h==="undefined"||h==="universal"?!0:h==="unknown"?!1:h===p?!0:I(p).includes(h)}e.isTargetPlatformCompatible=E;function I(h){switch(h){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=I;function R(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.isIExtensionIdentifier=R;var k;(function(h){h[h.NoneOrRelevance=0]="NoneOrRelevance",h[h.LastUpdatedDate=1]="LastUpdatedDate",h[h.Title=2]="Title",h[h.PublisherName=3]="PublisherName",h[h.InstallCount=4]="InstallCount",h[h.PublishedDate=10]="PublishedDate",h[h.AverageRating=6]="AverageRating",h[h.WeightedRating=12]="WeightedRating"})(k=e.SortBy||(e.SortBy={}));var _;(function(h){h[h.Default=0]="Default",h[h.Ascending=1]="Ascending",h[h.Descending=2]="Descending"})(_=e.SortOrder||(e.SortOrder={}));var T;(function(h){h.Install="install",h.Uninstall="uninstall"})(T=e.StatisticType||(e.StatisticType={}));var w;(function(h){h[h.None=1]="None",h[h.Install=2]="Install",h[h.Update=3]="Update",h[h.Migrate=4]="Migrate"})(w=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var b;(function(h){h.Unsupported="Unsupported",h.Deprecated="Deprecated",h.Malicious="Malicious",h.Incompatible="Incompatible",h.IncompatiblePreRelease="IncompatiblePreRelease",h.IncompatibleTargetPlatform="IncompatibleTargetPlatform",h.ReleaseVersionNotFound="ReleaseVersionNotFound",h.Invalid="Invalid",h.Download="Download",h.Extract="Extract",h.Delete="Delete",h.Rename="Rename",h.CorruptZip="CorruptZip",h.IncompleteZip="IncompleteZip",h.Internal="Internal"})(b=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class v extends Error{constructor(g,p){super(g);this.code=p,this.name=p}}e.ExtensionManagementError=v,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.IServerExtensionManagementService=(0,t.refineServiceDecorator)(e.IExtensionManagementService),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,u.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,u.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,t.createDecorator)("IExtensionManagementCLIService")}),define(De[190],Ie([1,0,3]),function(Z,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,u.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,u.createDecorator)("externalTerminal")}),define(De[191],Ie([1,0,44,12,9,11,101,29,109,164,190]),function(Z,e,u,t,D,P,y,C,E,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const k=I.localize(0,null);class _{async getDefaultTerminalForPlatforms(){return{windows:T.getDefaultTerminalWindows(),linux:await b.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class T extends _{openTerminal(o,m){return this.spawnTerminal(u,o,E.getWindowsShell(),m)}spawnTerminal(o,m,c,l){const s=m.windowsExec||T.getDefaultTerminalWindows();l&&l[1]===":"&&(l=l[0].toUpperCase()+l.substr(1));const i=D.basename(s).toLowerCase();if(i==="cmder"||i==="cmder.exe")return o.spawn(s,l?[l]:void 0),Promise.resolve(void 0);const r=["/c","start","/wait"];return s.indexOf(" ")>=0&&r.push('""'),r.push(s),(i==="wt"||i==="wt.exe")&&r.push("-d ."),new Promise((n,a)=>{const d=v(process),f=o.spawn(c,r,{cwd:l,env:d});f.on("error",a),f.on("exit",()=>n())})}runInTerminal(o,m,c,l,s){const i="windowsExec"in s&&s.windowsExec?s.windowsExec:T.getDefaultTerminalWindows();return new Promise((r,n)=>{const a=`"${m} - ${k}"`,d=`""${c.join('" "')}" & pause"`,f=["/c","start",a,"/wait",i,"/c",d],S=Object.assign({},v(process),l);Object.keys(S).filter(M=>S[M]===null).forEach(M=>delete S[M]);const O={cwd:m,env:S,windowsVerbatimArguments:!0};u.spawn(T.CMD,f,O).on("error",M=>{n(h(M))}),r(void 0)})}static getDefaultTerminalWindows(){if(!T._DEFAULT_TERMINAL_WINDOWS){const o=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");T._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${o?"Sysnative":"System32"}\\cmd.exe`}return T._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=T,T.CMD="cmd.exe";class w extends _{openTerminal(o,m){return this.spawnTerminal(u,o,m)}runInTerminal(o,m,c,l,s){const i=s.osxExec||R.DEFAULT_TERMINAL_OSX;return new Promise((r,n)=>{if(i===R.DEFAULT_TERMINAL_OSX||i==="iTerm.app"){const a=i===R.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",f=[t.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${a}.scpt`,Z).fsPath,"-t",o||k,"-w",m];for(const U of c)f.push("-a"),f.push(U);if(l){const U=Object.assign({},v(process),l);for(const M in U){const A=U[M];A===null?(f.push("-u"),f.push(M)):(f.push("-e"),f.push(`${M}=${A}`))}}let S="";const O=u.spawn(w.OSASCRIPT,f);O.on("error",U=>{n(h(U))}),O.stderr.on("data",U=>{S+=U.toString()}),O.on("exit",U=>{if(U===0)r(void 0);else if(S){const M=S.split(`
`,1);n(new Error(M[0]))}else n(new Error(I.localize(1,null,a,U)))})}else n(new Error(I.localize(2,null,i)))})}spawnTerminal(o,m,c){const l=m.osxExec||R.DEFAULT_TERMINAL_OSX;return new Promise((s,i)=>{const r=["-a",l];c&&r.push(c);const n=v(process),a=o.spawn("/usr/bin/open",r,{cwd:c,env:n});a.on("error",i),a.on("exit",()=>s())})}}e.MacExternalTerminalService=w,w.OSASCRIPT="/usr/bin/osascript";class b extends _{openTerminal(o,m){return this.spawnTerminal(u,o,m)}runInTerminal(o,m,c,l,s){const i=s.linuxExec?Promise.resolve(s.linuxExec):b.getDefaultTerminalLinuxReady();return new Promise((r,n)=>{const a=[];i.then(d=>{d.indexOf("gnome-terminal")>=0?a.push("-x"):a.push("-e"),a.push("bash"),a.push("-c");const f=`${g(c)}; echo; read -p "${b.WAIT_MESSAGE}" -n1;`;a.push(`''${f}''`);const S=Object.assign({},v(process),l);Object.keys(S).filter(A=>S[A]===null).forEach(A=>delete S[A]);const O={cwd:m,env:S};let U="";const M=u.spawn(d,a,O);M.on("error",A=>{n(h(A))}),M.stderr.on("data",A=>{U+=A.toString()}),M.on("exit",A=>{if(A===0)r(void 0);else if(U){const B=U.split(`
`,1);n(new Error(B[0]))}else n(new Error(I.localize(4,null,d,A)))})})})}static async getDefaultTerminalLinuxReady(){if(!b._DEFAULT_TERMINAL_LINUX_READY)if(!P.isLinux)b._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const o=await C.Promises.exists("/etc/debian_version");b._DEFAULT_TERMINAL_LINUX_READY=new Promise(m=>{o?m("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?m("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?m("konsole"):process.env.COLORTERM?m(process.env.COLORTERM):process.env.TERM?m(process.env.TERM):m("xterm")})}return b._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(o,m,c){const l=m.linuxExec?Promise.resolve(m.linuxExec):b.getDefaultTerminalLinuxReady();return new Promise((s,i)=>{l.then(r=>{const n=v(process),a=o.spawn(r,[],{cwd:c,env:n});a.on("error",i),a.on("exit",()=>s())})})}}e.LinuxExternalTerminalService=b,b.WAIT_MESSAGE=I.localize(3,null);function v(p){const o={...p.env};return(0,y.sanitizeProcessEnvironment)(o),o}function h(p){return"errno"in p&&p.errno==="ENOENT"&&"path"in p&&typeof p.path=="string"?new Error(I.localize(5,null,p.path)):p}function g(p){let o="";for(const m of p)m.indexOf(" ")>=0?o+='"'+m+'"':o+=m,o+=" ";return o}}),define(De[42],Ie([1,0,25,9,8,13,2,165,3]),function(Z,e,u,t,D,P,y,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,E.createDecorator)("fileService");function I(L){return L.create===!0}e.isFileOpenForWriteOptions=I;var R;(function(L){L[L.Unknown=0]="Unknown",L[L.File=1]="File",L[L.Directory=2]="Directory",L[L.SymbolicLink=64]="SymbolicLink"})(R=e.FileType||(e.FileType={}));var k;(function(L){L[L.Readonly=1]="Readonly"})(k=e.FilePermission||(e.FilePermission={}));var _;(function(L){L[L.FileReadWrite=2]="FileReadWrite",L[L.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",L[L.FileReadStream=16]="FileReadStream",L[L.FileFolderCopy=8]="FileFolderCopy",L[L.PathCaseSensitive=1024]="PathCaseSensitive",L[L.Readonly=2048]="Readonly",L[L.Trash=4096]="Trash",L[L.FileWriteUnlock=8192]="FileWriteUnlock",L[L.FileAtomicRead=16384]="FileAtomicRead",L[L.FileClone=32768]="FileClone"})(_=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function T(L){return!!(L.capabilities&2)}e.hasReadWriteCapability=T;function w(L){return!!(L.capabilities&8)}e.hasFileFolderCopyCapability=w;function b(L){return!!(L.capabilities&32768)}e.hasFileCloneCapability=b;function v(L){return!!(L.capabilities&4)}e.hasOpenReadWriteCloseCapability=v;function h(L){return!!(L.capabilities&16)}e.hasFileReadStreamCapability=h;function g(L){return!!(L.capabilities&2048)}e.hasFileReadCapability=g;function p(L){return T(L)?!!(L.capabilities&16384):!1}e.hasFileAtomicReadCapability=p;var o;(function(L){L.FileExists="EntryExists",L.FileNotFound="EntryNotFound",L.FileNotADirectory="EntryNotADirectory",L.FileIsADirectory="EntryIsADirectory",L.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",L.FileTooLarge="EntryTooLarge",L.FileWriteLocked="EntryWriteLocked",L.NoPermissions="NoPermissions",L.Unavailable="Unavailable",L.Unknown="Unknown"})(o=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class m extends Error{constructor($,H){super($);this.code=H}}e.FileSystemProviderError=m;function c(L,$){const H=new m(L.toString(),$);return s(H,$),H}e.createFileSystemProviderError=c;function l(L){return L||c((0,C.localize)(0,null),o.Unknown)}e.ensureFileSystemProviderError=l;function s(L,$){return L.name=$?`${$} (FileSystemError)`:"FileSystemError",L}e.markAsFileSystemProviderError=s;function i(L){if(!L)return o.Unknown;if(L instanceof m)return L.code;const $=/^(.+) \(FileSystemError\)$/.exec(L.name);if(!$)return o.Unknown;switch($[1]){case o.FileExists:return o.FileExists;case o.FileIsADirectory:return o.FileIsADirectory;case o.FileNotADirectory:return o.FileNotADirectory;case o.FileNotFound:return o.FileNotFound;case o.FileExceedsMemoryLimit:return o.FileExceedsMemoryLimit;case o.FileTooLarge:return o.FileTooLarge;case o.FileWriteLocked:return o.FileWriteLocked;case o.NoPermissions:return o.NoPermissions;case o.Unavailable:return o.Unavailable}return o.Unknown}e.toFileSystemProviderErrorCode=i;function r(L){if(L instanceof O)return L.fileOperationResult;switch(i(L)){case o.FileNotFound:return 1;case o.FileIsADirectory:return 0;case o.FileNotADirectory:return 10;case o.FileWriteLocked:return 5;case o.NoPermissions:return 6;case o.FileExists:return 4;case o.FileExceedsMemoryLimit:return 9;case o.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var n;(function(L){L[L.CREATE=0]="CREATE",L[L.DELETE=1]="DELETE",L[L.MOVE=2]="MOVE",L[L.COPY=3]="COPY",L[L.WRITE=4]="WRITE"})(n=e.FileOperation||(e.FileOperation={}));class a{constructor($,H,j){this.resource=$,this.operation=H,this.target=j}isOperation($){return this.operation===$}}e.FileOperationEvent=a;var d;(function(L){L[L.UPDATED=0]="UPDATED",L[L.ADDED=1]="ADDED",L[L.DELETED=2]="DELETED"})(d=e.FileChangeType||(e.FileChangeType={}));class f{constructor($,H){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=$;const j=new Map;for(const J of $){const Y=j.get(J.type);switch(Y?Y.push([J.resource,J]):j.set(J.type,[[J.resource,J]]),J.type){case 1:this.rawAdded.push(J.resource);break;case 0:this.rawUpdated.push(J.resource);break;case 2:this.rawDeleted.push(J.resource);break}}for(const[J,Y]of j)switch(J){case 1:this.added=u.TernarySearchTree.forUris(()=>H),this.added.fill(Y);break;case 0:this.updated=u.TernarySearchTree.forUris(()=>H),this.updated.fill(Y);break;case 2:this.deleted=u.TernarySearchTree.forUris(()=>H),this.deleted.fill(Y);break}}contains($,...H){return this.doContains($,{includeChildren:!1},...H)}affects($,...H){return this.doContains($,{includeChildren:!0},...H)}doContains($,H,...j){if(!$)return!1;const J=j.length>0;return!!((!J||j.includes(1))&&(this.added?.get($)||H.includeChildren&&this.added?.findSuperstr($))||(!J||j.includes(0))&&(this.updated?.get($)||H.includeChildren&&this.updated?.findSuperstr($))||(!J||j.includes(2))&&(this.deleted?.findSubstr($)||H.includeChildren&&this.deleted?.findSuperstr($)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=f;function S(L,$,H){return!L||!$||L===$||$.length>L.length?!1:($.charAt($.length-1)!==t.sep&&($+=t.sep),H?(0,D.startsWithIgnoreCase)(L,$):L.indexOf($)===0)}e.isParent=S;class O extends Error{constructor($,H,j){super($);this.fileOperationResult=H,this.options=j}}e.FileOperationError=O;class U extends O{constructor($,H,j){super($,2,j);this.stat=H}}e.NotModifiedSinceFileOperationError=U;var M;(function(L){L[L.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",L[L.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",L[L.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",L[L.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",L[L.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",L[L.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",L[L.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",L[L.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",L[L.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",L[L.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",L[L.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",L[L.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(M=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var A;(function(L){L[L.FILE=0]="FILE",L[L.FOLDER=1]="FOLDER",L[L.ROOT_FOLDER=2]="ROOT_FOLDER"})(A=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function B(L){if(!(typeof L.size!="number"||typeof L.mtime!="number"))return L.mtime.toString(29)+L.size.toString(31)}e.etag=B;async function x(L,$){if(!$.hasProvider(y.URI.from({scheme:L.scheme})))return new Promise(H=>{const j=$.onDidChangeFileSystemProviderRegistrations(J=>{J.scheme===L.scheme&&J.added&&(j.dispose(),H())})})}e.whenProviderRegistered=x,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class N{static formatSize($){return(0,P.isNumber)($)||($=0),$<N.KB?(0,C.localize)(1,null,$.toFixed(0)):$<N.MB?(0,C.localize)(2,null,($/N.KB).toFixed(2)):$<N.GB?(0,C.localize)(3,null,($/N.MB).toFixed(2)):$<N.TB?(0,C.localize)(4,null,($/N.GB).toFixed(2)):(0,C.localize)(5,null,($/N.TB).toFixed(2))}}e.ByteSize=N,N.KB=1024,N.MB=N.KB*N.KB,N.GB=N.MB*N.KB,N.TB=N.GB*N.KB;var K;(function(L){L[L.IA32=0]="IA32",L[L.OTHER=1]="OTHER"})(K=e.Arch||(e.Arch={}));function X(L){return{maxFileSize:L===0?300*N.MB:16*N.GB,maxHeapSize:L===0?700*N.MB:2*700*N.MB}}e.getPlatformLimits=X}),define(De[85],Ie([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class u{constructor(...D){this._entries=new Map;for(const[P,y]of D)this.set(P,y)}set(D,P){const y=this._entries.get(D);return this._entries.set(D,P),y}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=u}),define(De[192],Ie([1,0,18,10,115,188,3,85]),function(Z,e,u,t,D,P,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const E=!1;class I extends Error{constructor(w){super("cyclic dependency between services");this.message=w.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${w.toString()}`}}class R{constructor(w=new C.ServiceCollection,b=!1,v){this._activeInstantiations=new Set,this._services=w,this._strict=b,this._parent=v,this._services.set(y.IInstantiationService,this)}createChild(w){return new R(w,this._strict,this)}invokeFunction(w,...b){const v=_.traceInvocation(w);let h=!1;try{return w({get:p=>{if(h)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const o=this._getOrCreateServiceInstance(p,v);if(!o)throw new Error(`[invokeFunction] unknown service '${p}'`);return o}},...b)}finally{h=!0,v.stop()}}createInstance(w,...b){let v,h;return w instanceof D.SyncDescriptor?(v=_.traceCreation(w.ctor),h=this._createInstance(w.ctor,w.staticArguments.concat(b),v)):(v=_.traceCreation(w),h=this._createInstance(w,b,v)),v.stop(),h}_createInstance(w,b=[],v){const h=y._util.getServiceDependencies(w).sort((o,m)=>o.index-m.index),g=[];for(const o of h){const m=this._getOrCreateServiceInstance(o.id,v);m||this._throwIfStrict(`[createInstance] ${w.name} depends on UNKNOWN service ${o.id}.`,!1),g.push(m)}const p=h.length>0?h[0].index:b.length;if(b.length!==p){console.trace(`[createInstance] First service dependency of ${w.name} at position ${p+1} conflicts with ${b.length} static arguments`);const o=p-b.length;o>0?b=b.concat(new Array(o)):b=b.slice(0,p)}return new w(...[...b,...g])}_setServiceInstance(w,b){if(this._services.get(w)instanceof D.SyncDescriptor)this._services.set(w,b);else if(this._parent)this._parent._setServiceInstance(w,b);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(w){const b=this._services.get(w);return!b&&this._parent?this._parent._getServiceInstanceOrDescriptor(w):b}_getOrCreateServiceInstance(w,b){const v=this._getServiceInstanceOrDescriptor(w);return v instanceof D.SyncDescriptor?this._safeCreateAndCacheServiceInstance(w,v,b.branch(w,!0)):(b.branch(w,!1),v)}_safeCreateAndCacheServiceInstance(w,b,v){if(this._activeInstantiations.has(w))throw new Error(`illegal state - RECURSIVELY instantiating service '${w}'`);this._activeInstantiations.add(w);try{return this._createAndCacheServiceInstance(w,b,v)}finally{this._activeInstantiations.delete(w)}}_createAndCacheServiceInstance(w,b,v){const h=new P.Graph(o=>o.id.toString());let g=0;const p=[{id:w,desc:b,_trace:v}];for(;p.length;){const o=p.pop();if(h.lookupOrInsertNode(o),g++>1e3)throw new I(h);for(const m of y._util.getServiceDependencies(o.desc.ctor)){const c=this._getServiceInstanceOrDescriptor(m.id);if(c||this._throwIfStrict(`[createInstance] ${w} depends on ${m.id} which is NOT registered.`,!0),c instanceof D.SyncDescriptor){const l={id:m.id,desc:c,_trace:o._trace.branch(m.id,!0)};h.insertEdge(o,l),p.push(l)}}}for(;;){const o=h.roots();if(o.length===0){if(!h.isEmpty())throw new I(h);break}for(const{data:m}of o){if(this._getServiceInstanceOrDescriptor(m.id)instanceof D.SyncDescriptor){const l=this._createServiceInstanceWithOwner(m.id,m.desc.ctor,m.desc.staticArguments,m.desc.supportsDelayedInstantiation,m._trace);this._setServiceInstance(m.id,l)}h.removeNode(m)}}return this._getServiceInstanceOrDescriptor(w)}_createServiceInstanceWithOwner(w,b,v=[],h,g){if(this._services.get(w)instanceof D.SyncDescriptor)return this._createServiceInstance(b,v,h,g);if(this._parent)return this._parent._createServiceInstanceWithOwner(w,b,v,h,g);throw new Error(`illegalState - creating UNKNOWN service instance ${b.name}`)}_createServiceInstance(w,b=[],v,h){if(v){const g=new u.IdleValue(()=>this._createInstance(w,b,h));return new Proxy(Object.create(null),{get(p,o){if(o in p)return p[o];const m=g.value;let c=m[o];return typeof c!="function"||(c=c.bind(m),p[o]=c),c},set(p,o,m){return g.value[o]=m,!0}})}else return this._createInstance(w,b,h)}_throwIfStrict(w,b){if(b&&console.warn(w),this._strict)throw new Error(w)}}e.InstantiationService=R;var k;(function(T){T[T.Creation=0]="Creation",T[T.Invocation=1]="Invocation",T[T.Branch=2]="Branch"})(k||(k={}));class _{constructor(w,b){this.type=w,this.name=b,this._start=Date.now(),this._dep=[]}static traceInvocation(w){return E?new _(1,w.name||w.toString().substring(0,42).replace(/\n/g,"")):_._None}static traceCreation(w){return E?new _(0,w.name):_._None}branch(w,b){const v=new _(2,w.toString());return this._dep.push([w,b,v]),v}stop(){const w=Date.now()-this._start;_._totals+=w;let b=!1;function v(g,p){const o=[],m=new Array(g+1).join("	");for(const[c,l,s]of p._dep)if(l&&s){b=!0,o.push(`${m}CREATES -> ${c}`);const i=v(g+1,s);i&&o.push(i)}else o.push(`${m}uses -> ${c}`);return o.join(`
`)}const h=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${v(1,this)}`,`DONE, took ${w.toFixed(2)}ms (grand total ${_._totals.toFixed(2)}ms)`];(w>2||b)&&console.log(h.join(`
`))}}e.Trace=_,_._None=new class extends _{constructor(){super(-1,null)}stop(){}branch(){return this}},_._totals=0}),define(De[14],Ie([1,0,50,4,6,11,3]),function(Z,e,u,t,D,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,y.createDecorator)("logService"),e.ILoggerService=(0,y.createDecorator)("loggerService");function C(){return new Date().toISOString()}var E;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(E=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=E.Info;function I(l,s,i){switch(s){case E.Trace:l.trace(i);break;case E.Debug:l.debug(i);break;case E.Info:l.info(i);break;case E.Warning:l.warn(i);break;case E.Error:l.error(i);break;case E.Critical:l.critical(i);break;default:throw new Error("Invalid log level")}}e.log=I;function R(l){let s="";for(let i=0;i<l.length;i++){let r=l[i];if(typeof r=="object")try{r=JSON.stringify(r)}catch{}s+=(i>0?" ":"")+r}return s}e.format=R;class k extends D.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(s){this.level!==s&&(this.level=s,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=k;class _ extends k{constructor(s){super();this.logAlways=s}checkLogLevel(s){return this.logAlways||this.getLevel()<=s}trace(s,...i){this.checkLogLevel(E.Trace)&&this.log(E.Trace,R([s,...i]))}debug(s,...i){this.checkLogLevel(E.Debug)&&this.log(E.Debug,R([s,...i]))}info(s,...i){this.checkLogLevel(E.Info)&&this.log(E.Info,R([s,...i]))}warn(s,...i){this.checkLogLevel(E.Warning)&&this.log(E.Warning,R([s,...i]))}error(s,...i){if(this.checkLogLevel(E.Error))if(s instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=s.stack,this.log(E.Error,R(r))}else this.log(E.Error,R([s,...i]))}critical(s,...i){this.checkLogLevel(E.Critical)&&this.log(E.Critical,R([s,...i]))}flush(){}}e.AbstractMessageLogger=_;class T extends k{constructor(s=e.DEFAULT_LOG_LEVEL){super();this.setLevel(s),this.useColors=!P.isWindows}trace(s,...i){this.getLevel()<=E.Trace&&(this.useColors?console.log(`[90m[main ${C()}][0m`,s,...i):console.log(`[main ${C()}]`,s,...i))}debug(s,...i){this.getLevel()<=E.Debug&&(this.useColors?console.log(`[90m[main ${C()}][0m`,s,...i):console.log(`[main ${C()}]`,s,...i))}info(s,...i){this.getLevel()<=E.Info&&(this.useColors?console.log(`[90m[main ${C()}][0m`,s,...i):console.log(`[main ${C()}]`,s,...i))}warn(s,...i){this.getLevel()<=E.Warning&&(this.useColors?console.warn(`[93m[main ${C()}][0m`,s,...i):console.warn(`[main ${C()}]`,s,...i))}error(s,...i){this.getLevel()<=E.Error&&(this.useColors?console.error(`[91m[main ${C()}][0m`,s,...i):console.error(`[main ${C()}]`,s,...i))}critical(s,...i){this.getLevel()<=E.Critical&&(this.useColors?console.error(`[90m[main ${C()}][0m`,s,...i):console.error(`[main ${C()}]`,s,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=T;class w extends k{constructor(s=e.DEFAULT_LOG_LEVEL){super();this.setLevel(s)}trace(s,...i){this.getLevel()<=E.Trace&&console.log("%cTRACE","color: #888",s,...i)}debug(s,...i){this.getLevel()<=E.Debug&&console.log("%cDEBUG","background: #eee; color: #888",s,...i)}info(s,...i){this.getLevel()<=E.Info&&console.log("%c INFO","color: #33f",s,...i)}warn(s,...i){this.getLevel()<=E.Warning&&console.log("%c WARN","color: #993",s,...i)}error(s,...i){this.getLevel()<=E.Error&&console.log("%c  ERR","color: #f33",s,...i)}critical(s,...i){this.getLevel()<=E.Critical&&console.log("%cCRITI","background: #f33; color: white",s,...i)}dispose(){}flush(){}}e.ConsoleLogger=w;class b extends k{constructor(s,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=s,this.setLevel(i)}trace(s,...i){this.getLevel()<=E.Trace&&this.adapter.log(E.Trace,[this.extractMessage(s),...i])}debug(s,...i){this.getLevel()<=E.Debug&&this.adapter.log(E.Debug,[this.extractMessage(s),...i])}info(s,...i){this.getLevel()<=E.Info&&this.adapter.log(E.Info,[this.extractMessage(s),...i])}warn(s,...i){this.getLevel()<=E.Warning&&this.adapter.log(E.Warning,[this.extractMessage(s),...i])}error(s,...i){this.getLevel()<=E.Error&&this.adapter.log(E.Error,[this.extractMessage(s),...i])}critical(s,...i){this.getLevel()<=E.Critical&&this.adapter.log(E.Critical,[this.extractMessage(s),...i])}extractMessage(s){return typeof s=="string"?s:(0,u.toErrorMessage)(s,this.getLevel()<=E.Trace)}dispose(){}flush(){}}e.AdapterLogger=b;class v extends k{constructor(s){super();this.logServices=s,s.length&&this.setLevel(s[0].getLevel())}setLevel(s){for(const i of this.logServices)i.setLevel(s);super.setLevel(s)}trace(s,...i){for(const r of this.logServices)r.trace(s,...i)}debug(s,...i){for(const r of this.logServices)r.debug(s,...i)}info(s,...i){for(const r of this.logServices)r.info(s,...i)}warn(s,...i){for(const r of this.logServices)r.warn(s,...i)}error(s,...i){for(const r of this.logServices)r.error(s,...i)}critical(s,...i){for(const r of this.logServices)r.critical(s,...i)}flush(){for(const s of this.logServices)s.flush()}dispose(){for(const s of this.logServices)s.dispose()}}e.MultiplexLogService=v;class h extends D.Disposable{constructor(s){super();this.logger=s,this._register(s)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(s){this.logger.setLevel(s)}getLevel(){return this.logger.getLevel()}trace(s,...i){this.logger.trace(s,...i)}debug(s,...i){this.logger.debug(s,...i)}info(s,...i){this.logger.info(s,...i)}warn(s,...i){this.logger.warn(s,...i)}error(s,...i){this.logger.error(s,...i)}critical(s,...i){this.logger.critical(s,...i)}flush(){this.logger.flush()}}e.LogService=h;class g extends D.Disposable{constructor(s,i){super();this.logLevel=s,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(n=>n.setLevel(r))}))}getLogger(s){return this.loggers.get(s.toString())}createLogger(s,i){let r=this.loggers.get(s.toString());return r||(r=this.doCreateLogger(s,i?.always?E.Trace:this.logLevel,i),this.loggers.set(s.toString(),r),i?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(s=>s.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=g;class p{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(s){}getLevel(){return E.Info}trace(s,...i){}debug(s,...i){}info(s,...i){}warn(s,...i){}error(s,...i){}critical(s,...i){}dispose(){}flush(){}}e.NullLogService=p;function o(l){if(l.verbose)return E.Trace;if(typeof l.logLevel=="string"){const s=m(l.logLevel.toLowerCase());if(s!==void 0)return s}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=o;function m(l){switch(l){case"trace":return E.Trace;case"debug":return E.Debug;case"info":return E.Info;case"warn":return E.Warning;case"error":return E.Error;case"critical":return E.Critical;case"off":return E.Off}}e.parseLogLevel=m;function c(l){switch(l){case E.Trace:return"trace";case E.Debug:return"debug";case E.Info:return"info";case E.Warning:return"warn";case E.Error:return"error";case E.Critical:return"critical";case E.Off:return"off"}}e.LogLevelToString=c}),define(De[193],Ie([1,0,42,14]),function(Z,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function D(C,E,I,R,k){try{const _=await new Promise((w,b)=>{Z(["spdlog"],w,b)});_.setFlushOn(t.LogLevel.Trace);const T=await _.createAsyncRotatingLogger(C,E,I,R);return k&&T.clearFormatters(),T}catch(_){console.error(_)}return null}function P(C,E,I){switch(E){case t.LogLevel.Trace:C.trace(I);break;case t.LogLevel.Debug:C.debug(I);break;case t.LogLevel.Info:C.info(I);break;case t.LogLevel.Warning:C.warn(I);break;case t.LogLevel.Error:C.error(I);break;case t.LogLevel.Critical:C.critical(I);break;default:throw new Error("Invalid log level")}}class y extends t.AbstractMessageLogger{constructor(E,I,R,k,_){super();this.buffer=[],this.setLevel(_),this._loggerCreationPromise=this._createSpdLogLogger(E,I,R,k),this._register(this.onDidChangeLogLevel(T=>{this._logger?.setLevel(T)}))}async _createSpdLogLogger(E,I,R,k){const _=R?6:1,T=30/_*u.ByteSize.MB,w=await D(E,I,T,_,k);if(w){this._logger=w,this._logger.setLevel(this.getLevel());for(const{level:b,message:v}of this.buffer)P(this._logger,b,v);this.buffer=[]}}log(E,I){this._logger?P(this._logger,E,I):this.getLevel()<=E&&this.buffer.push({level:E,message:I})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=y}),define(De[116],Ie([1,0,41,166,3]),function(Z,e,u,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var P;(function(E){E[E.Unnecessary=1]="Unnecessary",E[E.Deprecated=2]="Deprecated"})(P=e.MarkerTag||(e.MarkerTag={}));var y;(function(E){E[E.Hint=1]="Hint",E[E.Info=2]="Info",E[E.Warning=4]="Warning",E[E.Error=8]="Error"})(y=e.MarkerSeverity||(e.MarkerSeverity={})),function(E){function I(w,b){return b-w}E.compare=I;const R=Object.create(null);R[E.Error]=(0,t.localize)(0,null),R[E.Warning]=(0,t.localize)(1,null),R[E.Info]=(0,t.localize)(2,null);function k(w){return R[w]||""}E.toString=k;function _(w){switch(w){case u.default.Error:return E.Error;case u.default.Warning:return E.Warning;case u.default.Info:return E.Info;case u.default.Ignore:return E.Hint}}E.fromSeverity=_;function T(w){switch(w){case E.Error:return u.default.Error;case E.Warning:return u.default.Warning;case E.Info:return u.default.Info;case E.Hint:return u.default.Ignore}}E.toSeverity=T}(y=e.MarkerSeverity||(e.MarkerSeverity={}));var C;(function(E){const I="";function R(_){return k(_,!0)}E.makeKey=R;function k(_,T){const w=[I];return _.source?w.push(_.source.replace("\xA6","\\\xA6")):w.push(I),_.code?typeof _.code=="string"?w.push(_.code.replace("\xA6","\\\xA6")):w.push(_.code.value.replace("\xA6","\\\xA6")):w.push(I),_.severity!==void 0&&_.severity!==null?w.push(y.toString(_.severity)):w.push(I),_.message&&T?w.push(_.message.replace("\xA6","\\\xA6")):w.push(I),_.startLineNumber!==void 0&&_.startLineNumber!==null?w.push(_.startLineNumber.toString()):w.push(I),_.startColumn!==void 0&&_.startColumn!==null?w.push(_.startColumn.toString()):w.push(I),_.endLineNumber!==void 0&&_.endLineNumber!==null?w.push(_.endLineNumber.toString()):w.push(I),_.endColumn!==void 0&&_.endColumn!==null?w.push(_.endColumn.toString()):w.push(I),w.push(I),w.join("\xA6")}E.makeKeyOptionalMessage=k})(C=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,D.createDecorator)("markerService")}),define(De[194],Ie([1,0,4,41,3]),function(Z,e,u,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=t.default,e.INotificationService=(0,D.createDecorator)("notificationService");var P;(function(I){I[I.WORKSPACE=0]="WORKSPACE",I[I.PROFILE=1]="PROFILE",I[I.APPLICATION=2]="APPLICATION"})(P=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var y;(function(I){I[I.OFF=0]="OFF",I[I.SILENT=1]="SILENT",I[I.ERROR=2]="ERROR"})(y=e.NotificationsFilter||(e.NotificationsFilter={}));class C{constructor(){this.progress=new E,this.onDidClose=u.Event.None,this.onDidChangeVisibility=u.Event.None}updateSeverity(R){}updateMessage(R){}updateActions(R){}close(){}}e.NoOpNotification=C;class E{infinite(){}done(){}total(R){}worked(R){}}e.NoOpProgress=E}),define(De[117],Ie([1,0,6,8,2,3]),function(Z,e,u,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,P.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return u.Disposable.None},registerValidator(){return u.Disposable.None},registerExternalUriResolver(){return u.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return u.Disposable.None},async open(){return!1},async resolveExternalUri(R){return{resolved:R,dispose(){}}}});function y(R,k){return D.URI.isUri(R)?(0,t.equalsIgnoreCase)(R.scheme,k):(0,t.startsWithIgnoreCase)(R,k+":")}e.matchesScheme=y;function C(R,...k){return k.some(_=>y(R,_))}e.matchesSomeScheme=C;function E(R,k){return R.with({fragment:`${k.startLineNumber},${k.startColumn}${k.endLineNumber?`-${k.endLineNumber}${k.endColumn?`,${k.endColumn}`:""}`:""}`})}e.withSelection=E;function I(R){let k;const _=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(R.fragment);return _&&(k={startLineNumber:parseInt(_[1]),startColumn:_[2]?parseInt(_[2]):1,endLineNumber:_[4]?parseInt(_[4]):void 0,endColumn:_[4]?_[5]?parseInt(_[5]):1:void 0},R=R.with({fragment:""})),{selection:k,uri:R}}e.extractSelection=I}),define(De[195],Ie([1,0,12,11,40,22]),function(Z,e,u,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let y;if(typeof t.globals.vscode!="undefined"&&typeof t.globals.vscode.context!="undefined"){const C=t.globals.vscode.context.configuration();if(C)y=C.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof Z?.__$__nodeRequire=="function"){const C=(0,P.dirname)(u.FileAccess.asFileUri("",Z));y=Z.__$__nodeRequire((0,P.joinPath)(C,"product.json").fsPath);const E=Z.__$__nodeRequire((0,P.joinPath)(C,"package.json").fsPath);D.env.VSCODE_DEV&&Object.assign(y,{nameShort:`${y.nameShort} Dev`,nameLong:`${y.nameLong} Dev`,dataFolderName:`${y.dataFolderName}-dev`,serverDataFolderName:y.serverDataFolderName?`${y.serverDataFolderName}-dev`:void 0}),Object.assign(y,{version:E.version})}else y={},Object.keys(y).length===0&&Object.assign(y,{version:"1.67.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=y}),define(De[196],Ie([1,0,3]),function(Z,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,u.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var xe=this&&this.__param||function(Z,e){return function(u,t){e(u,t,Z)}};define(De[118],Ie([1,0,18,21,6,3]),function(Z,e,u,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,P.createDecorator)("progressService");var y;(function(R){R[R.Explorer=1]="Explorer",R[R.Scm=3]="Scm",R[R.Extensions=5]="Extensions",R[R.Window=10]="Window",R[R.Notification=15]="Notification",R[R.Dialog=20]="Dialog"})(y=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class C{constructor(k){this.callback=k}get value(){return this._value}report(k){this._value=k,this.callback(this._value)}}e.Progress=C,C.None=Object.freeze({report(){}});let E=class extends D.Disposable{constructor(k,_){super();this.deferred=new u.DeferredPromise,_.withProgress(k,T=>(this.reporter=T,this.lastStep&&T.report(this.lastStep),this.deferred.p)),this._register((0,D.toDisposable)(()=>this.deferred.complete()))}report(k){this.reporter?this.reporter.report(k):this.lastStep=k}};E=je([xe(1,e.IProgressService)],E),e.UnmanagedProgress=E;class I extends D.Disposable{constructor(k){super();this.progressIndicator=k,this.currentOperationId=0,this.currentOperationDisposables=this._register(new D.DisposableStore)}start(k){this.stop();const _=++this.currentOperationId,T=new t.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{_===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},k),this.currentOperationDisposables.add((0,D.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,D.toDisposable)(()=>T.cancel())),this.currentOperationDisposables.add((0,D.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:_,token:T.token,stop:()=>this.doStop(_),isCurrent:()=>this.currentOperationId===_}}stop(){this.doStop(this.currentOperationId)}doStop(k){this.currentOperationId===k&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=I,e.IEditorProgressService=(0,P.createDecorator)("editorProgressService")}),define(De[43],Ie([1,0,48,13]),function(Z,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(y,C){u.ok(t.isString(y)),u.ok(t.isObject(C)),u.ok(!this.data.has(y),"There is already an extension with this id"),this.data.set(y,C)}knows(y){return this.data.has(y)}as(y){return this.data.get(y)||null}}e.Registry=new D}),define(De[119],Ie([1,0,4,43]),function(Z,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(C){return C.length>0&&C.charAt(C.length-1)==="#"?C.substring(0,C.length-1):C}class P{constructor(){this._onDidChangeSchema=new u.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(E,I){this.schemasById[D(E)]=I,this._onDidChangeSchema.fire(E)}notifySchemaChanged(E){this._onDidChangeSchema.fire(E)}getSchemaContributions(){return{schemas:this.schemasById}}}const y=new P;t.Registry.add(e.Extensions.JSONContribution,y)}),define(De[120],Ie([1,0,17,4,13,161,83,119,43]),function(Z,e,u,t,D,P,y,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var I;(function(m){m.Multiline="multilineText",m.Singleline="singlelineText"})(I=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var R;(function(m){m[m.APPLICATION=1]="APPLICATION",m[m.MACHINE=2]="MACHINE",m[m.WINDOW=3]="WINDOW",m[m.RESOURCE=4]="RESOURCE",m[m.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",m[m.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const k=E.Registry.as(C.Extensions.JSONContribution);class _{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:P.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(c,l=!0){this.registerConfigurations([c],l)}registerConfigurations(c,l=!0){const s=this.doRegisterConfigurations(c,l);k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}deregisterConfigurations(c){const l=this.doDeregisterConfigurations(c);k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l})}updateConfigurations({add:c,remove:l}){const s=[];s.push(...this.doDeregisterConfigurations(l)),s.push(...this.doRegisterConfigurations(c,!1)),k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,u.distinct)(s)})}registerDefaultConfigurations(c){const l=[],s=[];for(const{overrides:i,source:r}of c)for(const n in i)if(l.push(n),e.OVERRIDE_PROPERTY_REGEX.test(n)){const a=this.configurationDefaultsOverrides.get(n),d=a?.valuesSources??new Map;if(r)for(const U of Object.keys(i[n]))d.set(U,r);const f={...a?.value||{},...i[n]};this.configurationDefaultsOverrides.set(n,{source:r,value:f,valuesSources:d});const S=(0,y.getLanguageTagSettingPlainKey)(n),O={type:"object",default:f,description:P.localize(1,null,S),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:f,source:D.isString(r)?void 0:r,defaultValueSource:r};s.push(...b(n)),this.configurationProperties[n]=O,this.defaultLanguageConfigurationOverridesNode.properties[n]=O}else{this.configurationDefaultsOverrides.set(n,{value:i[n],source:r});const a=this.configurationProperties[n];a&&(this.updatePropertyDefaultValue(n,a),this.updateSchema(n,a))}this.registerOverrideIdentifiers(s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l,defaultsOverrides:!0})}deregisterDefaultConfigurations(c){const l=[];for(const{overrides:s,source:i}of c)for(const r in s){const n=this.configurationDefaultsOverrides.get(r),a=D.isString(i)?i:i?.id,d=D.isString(n?.source)?n?.source:n?.source?.id;if(a===d)if(l.push(r),this.configurationDefaultsOverrides.delete(r),e.OVERRIDE_PROPERTY_REGEX.test(r))delete this.configurationProperties[r],delete this.defaultLanguageConfigurationOverridesNode.properties[r];else{const f=this.configurationProperties[r];f&&(this.updatePropertyDefaultValue(r,f),this.updateSchema(r,f))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...c){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(c){for(const l of c)this.overrideIdentifiers.add(l);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(c,l){const s=[];return c.forEach(i=>{s.push(...this.validateAndRegisterProperties(i,l,i.extensionInfo,i.restrictedProperties)),this.configurationContributors.push(i),this.registerJSONConfiguration(i)}),s}doDeregisterConfigurations(c){const l=[],s=i=>{if(i.properties)for(const r in i.properties){l.push(r);const n=this.configurationProperties[r];n?.policy?.name&&this.policyConfigurations.delete(n.policy.name),delete this.configurationProperties[r],this.removeFromSchema(r,i.properties[r])}i.allOf?.forEach(r=>s(r))};for(const i of c){s(i);const r=this.configurationContributors.indexOf(i);r!==-1&&this.configurationContributors.splice(r,1)}return l}validateAndRegisterProperties(c,l=!0,s,i,r=3){r=D.isUndefinedOrNull(c.scope)?r:c.scope;const n=[],a=c.properties;if(a)for(const f in a){const S=a[f];if(l&&p(f,S)){delete a[f];continue}if(S.source=s,S.defaultDefaultValue=a[f].default,this.updatePropertyDefaultValue(f,S),e.OVERRIDE_PROPERTY_REGEX.test(f)?S.scope=void 0:(S.scope=D.isUndefinedOrNull(S.scope)?r:S.scope,S.restricted=D.isUndefinedOrNull(S.restricted)?!!i?.includes(f):S.restricted),a[f].hasOwnProperty("included")&&!a[f].included){this.excludedConfigurationProperties[f]=a[f],delete a[f];continue}else this.configurationProperties[f]=a[f],a[f].policy?.name&&this.policyConfigurations.set(a[f].policy.name,f);!a[f].deprecationMessage&&a[f].markdownDeprecationMessage&&(a[f].deprecationMessage=a[f].markdownDeprecationMessage),n.push(f)}const d=c.allOf;if(d)for(const f of d)n.push(...this.validateAndRegisterProperties(f,l,s,i,r));return n}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(c){const l=s=>{const i=s.properties;if(i)for(const n in i)this.updateSchema(n,i[n]);s.allOf?.forEach(l)};l(c)}updateSchema(c,l){switch(e.allSettings.properties[c]=l,l.scope){case 1:e.applicationSettings.properties[c]=l;break;case 2:e.machineSettings.properties[c]=l;break;case 6:e.machineOverridableSettings.properties[c]=l;break;case 3:e.windowSettings.properties[c]=l;break;case 4:e.resourceSettings.properties[c]=l;break;case 5:e.resourceSettings.properties[c]=l,this.resourceLanguageSettingsSchema.properties[c]=l;break}}removeFromSchema(c,l){switch(delete e.allSettings.properties[c],l.scope){case 1:delete e.applicationSettings.properties[c];break;case 2:delete e.machineSettings.properties[c];break;case 6:delete e.machineOverridableSettings.properties[c];break;case 3:delete e.windowSettings.properties[c];break;case 4:case 5:delete e.resourceSettings.properties[c],delete this.resourceLanguageSettingsSchema.properties[c];break}}updateOverridePropertyPatternKey(){for(const c of this.overrideIdentifiers.values()){const l=`[${c}]`,s={type:"object",description:P.localize(2,null),errorMessage:P.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(l,s),e.allSettings.properties[l]=s,e.applicationSettings.properties[l]=s,e.machineSettings.properties[l]=s,e.machineOverridableSettings.properties[l]=s,e.windowSettings.properties[l]=s,e.resourceSettings.properties[l]=s}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const c={type:"object",description:P.localize(4,null),errorMessage:P.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=c,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=c,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=c,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=c,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=c,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=c,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(c,l){const s=this.configurationDefaultsOverrides.get(c);let i=s?.value,r=s?.source;D.isUndefined(i)&&(i=l.defaultDefaultValue,r=void 0),D.isUndefined(i)&&(i=h(l.type)),l.default=i,l.defaultValueSource=r}}const T="\\[([^\\]]+)\\]",w=new RegExp(T,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${T})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function b(m){const c=[];if(e.OVERRIDE_PROPERTY_REGEX.test(m)){let l=w.exec(m);for(;l?.length;){const s=l[1].trim();s&&c.push(s),l=w.exec(m)}}return(0,u.distinct)(c)}e.overrideIdentifiersFromKey=b;function v(m){return m.reduce((c,l)=>`${c}[${l}]`,"")}e.keyFromOverrideIdentifiers=v;function h(m){switch(Array.isArray(m)?m[0]:m){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=h;const g=new _;E.Registry.add(e.Extensions.Configuration,g);function p(m,c){return m.trim()?e.OVERRIDE_PROPERTY_REGEX.test(m)?P.localize(7,null,m):g.getConfigurationProperties()[m]!==void 0?P.localize(8,null,m):c.policy?.name&&g.getPolicyConfigurations().get(c.policy?.name)!==void 0?P.localize(9,null,m,c.policy?.name,g.getPolicyConfigurations().get(c.policy?.name)):null:P.localize(6,null)}e.validateProperty=p;function o(){const m=[],c=g.getConfigurationProperties();for(const l of Object.keys(c))m.push([l,c[l].scope]);return m.push(["launch",4]),m.push(["task",4]),m}e.getScopes=o}),define(De[197],Ie([1,0,17,4,142,6,25,24,13,2,83,120,43]),function(Z,e,u,t,D,P,y,C,E,I,R,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class T{constructor(l={},s=[],i=[]){this._contents=l,this._keys=s,this._overrides=i,this.frozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(l){return l?(0,R.getConfigurationValue)(this.contents,l):this.contents}getOverrideValue(l,s){const i=this.getContentsForOverrideIdentifer(s);return i?l?(0,R.getConfigurationValue)(i,l):i:void 0}getKeysForOverrideIdentifier(l){const s=[];for(const i of this.overrides)i.identifiers.includes(l)&&s.push(...i.keys);return u.distinct(s)}getAllOverrideIdentifiers(){const l=[];for(const s of this.overrides)l.push(...s.identifiers);return u.distinct(l)}override(l){let s=this.overrideConfigurations.get(l);return s||(s=this.createOverrideConfigurationModel(l),this.overrideConfigurations.set(l,s)),s}merge(...l){const s=C.deepClone(this.contents),i=C.deepClone(this.overrides),r=[...this.keys];for(const n of l)if(!n.isEmpty()){this.mergeContents(s,n.contents);for(const a of n.overrides){const[d]=i.filter(f=>u.equals(f.identifiers,a.identifiers));d?(this.mergeContents(d.contents,a.contents),d.keys.push(...a.keys),d.keys=u.distinct(d.keys)):i.push(C.deepClone(a))}for(const a of n.keys)r.indexOf(a)===-1&&r.push(a)}return new T(s,r,i)}freeze(){return this.frozen=!0,this}clone(){return new T(C.deepClone(this.contents),[...this.keys],C.deepClone(this.overrides))}createOverrideConfigurationModel(l){const s=this.getContentsForOverrideIdentifer(l);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const i={};for(const r of u.distinct([...Object.keys(this.contents),...Object.keys(s)])){let n=this.contents[r];const a=s[r];a&&(typeof n=="object"&&typeof a=="object"?(n=C.deepClone(n),this.mergeContents(n,a)):n=a),i[r]=n}return new T(i,this.keys,this.overrides)}mergeContents(l,s){for(const i of Object.keys(s)){if(i in l&&E.isObject(l[i])&&E.isObject(s[i])){this.mergeContents(l[i],s[i]);continue}l[i]=C.deepClone(s[i])}}checkAndFreeze(l){return this.frozen&&!Object.isFrozen(l)?C.deepFreeze(l):l}getContentsForOverrideIdentifer(l){let s=null,i=null;const r=n=>{n&&(i?this.mergeContents(i,n):i=C.deepClone(n))};for(const n of this.overrides)u.equals(n.identifiers,[l])?s=n.contents:n.identifiers.includes(l)&&r(n.contents);return r(s),i}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(l,s){this.addKey(l),(0,R.addToValueTree)(this.contents,l,s,i=>{throw new Error(i)})}removeValue(l){this.removeKey(l)&&(0,R.removeFromValueTree)(this.contents,l)}addKey(l){let s=this.keys.length;for(let i=0;i<s;i++)l.indexOf(this.keys[i])===0&&(s=i);this.keys.splice(s,1,l)}removeKey(l){const s=this.keys.indexOf(l);return s!==-1?(this.keys.splice(s,1),!0):!1}}e.ConfigurationModel=T;class w{constructor(l){this._name=l,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new T}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(l,s){if(!E.isUndefinedOrNull(l)){const i=this.doParseContent(l);this.parseRaw(i,s)}}reparse(l){this._raw&&this.parseRaw(this._raw,l)}parseRaw(l,s){this._raw=l;const{contents:i,keys:r,overrides:n,restricted:a}=this.doParseRaw(l,s);this._configurationModel=new T(i,r,n),this._restrictedConfigurations=a||[]}doParseContent(l){let s={},i=null,r=[];const n=[],a=[];function d(S){Array.isArray(r)?r.push(S):i!==null&&(r[i]=S)}const f={onObjectBegin:()=>{const S={};d(S),n.push(r),r=S,i=null},onObjectProperty:S=>{i=S},onObjectEnd:()=>{r=n.pop()},onArrayBegin:()=>{const S=[];d(S),n.push(r),r=S,i=null},onArrayEnd:()=>{r=n.pop()},onLiteralValue:d,onError:(S,O,U)=>{a.push({error:S,offset:O,length:U})}};if(l)try{D.visit(l,f),s=r[0]||{}}catch(S){console.error(`Error while parsing settings file ${this._name}: ${S}`),this._parseErrors=[S]}return s}doParseRaw(l,s){const i=_.Registry.as(k.Extensions.Configuration).getConfigurationProperties(),r=this.filter(l,i,!0,s);l=r.raw;const n=(0,R.toValuesTree)(l,f=>console.error(`Conflict in settings file ${this._name}: ${f}`)),a=Object.keys(l),d=this.toOverrides(l,f=>console.error(`Conflict in settings file ${this._name}: ${f}`));return{contents:n,keys:a,overrides:d,restricted:r.restricted}}filter(l,s,i,r){if(!r?.scopes&&!r?.skipRestricted)return{raw:l,restricted:[]};const n={},a=[];for(const d in l)if(k.OVERRIDE_PROPERTY_REGEX.test(d)&&i){const f=this.filter(l[d],s,!1,r);n[d]=f.raw,a.push(...f.restricted)}else{const f=s[d],S=f?typeof f.scope!="undefined"?f.scope:3:void 0;f?.restricted&&a.push(d),(S===void 0||r.scopes===void 0||r.scopes.includes(S))&&(r.skipRestricted&&f?.restricted||(n[d]=l[d]))}return{raw:n,restricted:a}}toOverrides(l,s){const i=[];for(const r of Object.keys(l))if(k.OVERRIDE_PROPERTY_REGEX.test(r)){const n={};for(const a in l[r])n[a]=l[r][a];i.push({identifiers:(0,k.overrideIdentifiersFromKey)(r),keys:Object.keys(n),contents:(0,R.toValuesTree)(n,s)})}return i}}e.ConfigurationModelParser=w;class b extends P.Disposable{constructor(l,s,i,r){super();this.userSettingsResource=l,this.scopes=s,this.fileService=r,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new w(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(i.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.any(t.Event.filter(this.fileService.onDidFilesChange,n=>n.contains(this.userSettingsResource)),t.Event.filter(this.fileService.onDidRunOperation,n=>(n.isOperation(0)||n.isOperation(3)||n.isOperation(1)||n.isOperation(4))&&i.isEqual(n.resource,l)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const l=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(l.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new T}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=b;class v{constructor(l,s,i,r,n=new T,a=new T,d=new y.ResourceMap,f=new T,S=new y.ResourceMap,O=!0){this._defaultConfiguration=l,this._policyConfiguration=s,this._applicationConfiguration=i,this._localUserConfiguration=r,this._remoteUserConfiguration=n,this._workspaceConfiguration=a,this._folderConfigurations=d,this._memoryConfiguration=f,this._memoryConfigurationByResource=S,this._freeze=O,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new y.ResourceMap,this._userConfiguration=null}getValue(l,s,i){return this.getConsolidatedConfigurationModel(l,s,i).getValue(l)}updateValue(l,s,i={}){let r;i.resource?(r=this._memoryConfigurationByResource.get(i.resource),r||(r=new T,this._memoryConfigurationByResource.set(i.resource,r))):r=this._memoryConfiguration,s===void 0?r.removeValue(l):r.setValue(l,s),i.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(l,s,i){const r=this.getConsolidatedConfigurationModel(l,s,i),n=this.getFolderConfigurationModelForResource(s.resource,i),a=s.resource?this._memoryConfigurationByResource.get(s.resource)||this._memoryConfiguration:this._memoryConfiguration,d=s.overrideIdentifier?this._defaultConfiguration.freeze().override(s.overrideIdentifier).getValue(l):this._defaultConfiguration.freeze().getValue(l),f=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().getValue(l),S=this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze().getValue(l),O=s.overrideIdentifier?this.userConfiguration.freeze().override(s.overrideIdentifier).getValue(l):this.userConfiguration.freeze().getValue(l),U=s.overrideIdentifier?this.localUserConfiguration.freeze().override(s.overrideIdentifier).getValue(l):this.localUserConfiguration.freeze().getValue(l),M=s.overrideIdentifier?this.remoteUserConfiguration.freeze().override(s.overrideIdentifier).getValue(l):this.remoteUserConfiguration.freeze().getValue(l),A=i?s.overrideIdentifier?this._workspaceConfiguration.freeze().override(s.overrideIdentifier).getValue(l):this._workspaceConfiguration.freeze().getValue(l):void 0,B=n?s.overrideIdentifier?n.freeze().override(s.overrideIdentifier).getValue(l):n.freeze().getValue(l):void 0,x=s.overrideIdentifier?a.override(s.overrideIdentifier).getValue(l):a.getValue(l),N=r.getValue(l),K=u.distinct(r.overrides.map(X=>X.identifiers).flat()).filter(X=>r.getOverrideValue(l,X)!==void 0);return{defaultValue:d,policyValue:f,applicationValue:S,userValue:O,userLocalValue:U,userRemoteValue:M,workspaceValue:A,workspaceFolderValue:B,memoryValue:x,value:N,default:d!==void 0?{value:this._defaultConfiguration.freeze().getValue(l),override:s.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(l,s.overrideIdentifier):void 0}:void 0,policy:f!==void 0?{value:f}:void 0,application:S!==void 0?{value:S,override:s.overrideIdentifier?this.applicationConfiguration.freeze().getOverrideValue(l,s.overrideIdentifier):void 0}:void 0,user:O!==void 0?{value:this.userConfiguration.freeze().getValue(l),override:s.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(l,s.overrideIdentifier):void 0}:void 0,userLocal:U!==void 0?{value:this.localUserConfiguration.freeze().getValue(l),override:s.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(l,s.overrideIdentifier):void 0}:void 0,userRemote:M!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(l),override:s.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(l,s.overrideIdentifier):void 0}:void 0,workspace:A!==void 0?{value:this._workspaceConfiguration.freeze().getValue(l),override:s.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(l,s.overrideIdentifier):void 0}:void 0,workspaceFolder:B!==void 0?{value:n?.freeze().getValue(l),override:s.overrideIdentifier?n?.freeze().getOverrideValue(l,s.overrideIdentifier):void 0}:void 0,memory:x!==void 0?{value:a.getValue(l),override:s.overrideIdentifier?a.getOverrideValue(l,s.overrideIdentifier):void 0}:void 0,overrideIdentifiers:K.length?K:void 0}}keys(l){const s=this.getFolderConfigurationModelForResource(void 0,l);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:s?s.freeze().keys:[]}}updateDefaultConfiguration(l){this._defaultConfiguration=l,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(l){this._policyConfiguration=l}updateApplicationConfiguration(l){this._applicationConfiguration=l,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(l){this._localUserConfiguration=l,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(l){this._remoteUserConfiguration=l,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(l){this._workspaceConfiguration=l,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(l,s){this._folderConfigurations.set(l,s),this._foldersConsolidatedConfigurations.delete(l)}deleteFolderConfiguration(l){this.folderConfigurations.delete(l),this._foldersConsolidatedConfigurations.delete(l)}compareAndUpdateDefaultConfiguration(l,s){const i=[];if(!s){const{added:r,updated:n,removed:a}=o(this._defaultConfiguration,l);s=[...r,...n,...a]}for(const r of s)for(const n of(0,k.overrideIdentifiersFromKey)(r)){const a=this._defaultConfiguration.getKeysForOverrideIdentifier(n),d=l.getKeysForOverrideIdentifier(n),f=[...d.filter(S=>a.indexOf(S)===-1),...a.filter(S=>d.indexOf(S)===-1),...a.filter(S=>!C.equals(this._defaultConfiguration.override(n).getValue(S),l.override(n).getValue(S)))];i.push([n,f])}return this.updateDefaultConfiguration(l),{keys:s,overrides:i}}compareAndUpdatePolicyConfiguration(l){const{added:s,updated:i,removed:r}=o(this._policyConfiguration,l),n=[...s,...i,...r];return n.length&&this.updatePolicyConfiguration(l),{keys:n,overrides:[]}}compareAndUpdateApplicationConfiguration(l){const{added:s,updated:i,removed:r,overrides:n}=o(this.applicationConfiguration,l),a=[...s,...i,...r];return a.length&&this.updateApplicationConfiguration(l),{keys:a,overrides:n}}compareAndUpdateLocalUserConfiguration(l){const{added:s,updated:i,removed:r,overrides:n}=o(this.localUserConfiguration,l),a=[...s,...i,...r];return a.length&&this.updateLocalUserConfiguration(l),{keys:a,overrides:n}}compareAndUpdateRemoteUserConfiguration(l){const{added:s,updated:i,removed:r,overrides:n}=o(this.remoteUserConfiguration,l),a=[...s,...i,...r];return a.length&&this.updateRemoteUserConfiguration(l),{keys:a,overrides:n}}compareAndUpdateWorkspaceConfiguration(l){const{added:s,updated:i,removed:r,overrides:n}=o(this.workspaceConfiguration,l),a=[...s,...i,...r];return a.length&&this.updateWorkspaceConfiguration(l),{keys:a,overrides:n}}compareAndUpdateFolderConfiguration(l,s){const i=this.folderConfigurations.get(l),{added:r,updated:n,removed:a,overrides:d}=o(i,s),f=[...r,...n,...a];return(f.length||!i)&&this.updateFolderConfiguration(l,s),{keys:f,overrides:d}}compareAndDeleteFolderConfiguration(l){const s=this.folderConfigurations.get(l);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(l);const{added:i,updated:r,removed:n,overrides:a}=o(s,void 0);return{keys:[...i,...r,...n],overrides:a}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(l,s,i){let r=this.getConsolidatedConfigurationModelForResource(s,i);return s.overrideIdentifier&&(r=r.override(s.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(l)!==void 0&&(r=r.merge(this._policyConfiguration)),r}getConsolidatedConfigurationModelForResource({resource:l},s){let i=this.getWorkspaceConsolidatedConfiguration();if(s&&l){const r=s.getFolder(l);r&&(i=this.getFolderConsolidatedConfiguration(r.uri)||i);const n=this._memoryConfigurationByResource.get(l);n&&(i=i.merge(n))}return i}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(l){let s=this._foldersConsolidatedConfigurations.get(l);if(!s){const i=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(l);r?(s=i.merge(r),this._freeze&&(s=s.freeze()),this._foldersConsolidatedConfigurations.set(l,s)):s=i}return s}getFolderConfigurationModelForResource(l,s){if(s&&l){const i=s.getFolder(l);if(i)return this._folderConfigurations.get(i.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((l,s)=>{const{contents:i,overrides:r,keys:n}=this._folderConfigurations.get(s);return l.push([s,{contents:i,overrides:r,keys:n}]),l},[])}}allKeys(){const l=new Set;return this._defaultConfiguration.freeze().keys.forEach(s=>l.add(s)),this.userConfiguration.freeze().keys.forEach(s=>l.add(s)),this._workspaceConfiguration.freeze().keys.forEach(s=>l.add(s)),this._folderConfigurations.forEach(s=>s.freeze().keys.forEach(i=>l.add(i))),[...l.values()]}allOverrideIdentifiers(){const l=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(s=>l.add(s)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(s=>l.add(s)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(s=>l.add(s)),this._folderConfigurations.forEach(s=>s.freeze().getAllOverrideIdentifiers().forEach(i=>l.add(i))),[...l.values()]}getAllKeysForOverrideIdentifier(l){const s=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(l).forEach(i=>s.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(l).forEach(i=>s.add(i)),this._workspaceConfiguration.getKeysForOverrideIdentifier(l).forEach(i=>s.add(i)),this._folderConfigurations.forEach(i=>i.getKeysForOverrideIdentifier(l).forEach(r=>s.add(r))),[...s.values()]}static parse(l){const s=this.parseConfigurationModel(l.defaults),i=this.parseConfigurationModel(l.policy),r=this.parseConfigurationModel(l.application),n=this.parseConfigurationModel(l.user),a=this.parseConfigurationModel(l.workspace),d=l.folders.reduce((f,S)=>(f.set(I.URI.revive(S[0]),this.parseConfigurationModel(S[1])),f),new y.ResourceMap);return new v(s,i,r,n,new T,a,d,new T,new y.ResourceMap,!1)}static parseConfigurationModel(l){return new T(l.contents,l.keys,l.overrides).freeze()}}e.Configuration=v;function h(...c){if(c.length===0)return{keys:[],overrides:[]};if(c.length===1)return c[0];const l=new Set,s=new Map;for(const r of c)r.keys.forEach(n=>l.add(n)),r.overrides.forEach(([n,a])=>{const d=(0,y.getOrSet)(s,n,new Set);a.forEach(f=>d.add(f))});const i=[];return s.forEach((r,n)=>i.push([n,[...r.values()]])),{keys:[...l.values()],overrides:i}}e.mergeChanges=h;class g{constructor(l,s,i,r){this.change=l,this.previous=s,this.currentConfiguraiton=i,this.currentWorkspace=r,this._previousConfiguration=void 0;const n=new Set;l.keys.forEach(d=>n.add(d)),l.overrides.forEach(([,d])=>d.forEach(f=>n.add(f))),this.affectedKeys=[...n.values()];const a=new T;this.affectedKeys.forEach(d=>a.setValue(d,{})),this.affectedKeysTree=a.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=v.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(l,s){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,l)){if(s){const i=this.previousConfiguration?this.previousConfiguration.getValue(l,s,this.previous?.workspace):void 0,r=this.currentConfiguraiton.getValue(l,s,this.currentWorkspace);return!C.equals(i,r)}return!0}return!1}doesAffectedKeysTreeContains(l,s){let i=(0,R.toValuesTree)({[s]:!0},()=>{}),r;for(;typeof i=="object"&&(r=Object.keys(i)[0]);){if(l=l[r],!l)return!1;i=i[r]}return!0}}e.ConfigurationChangeEvent=g;class p extends g{constructor(l,s,i,r){super({keys:l.allKeys(),overrides:[]},void 0,l,s);this.source=i,this.sourceConfig=r}}e.AllKeysConfigurationChangeEvent=p;function o(c,l){const{added:s,removed:i,updated:r}=m(l,c),n=[],a=c?.getAllOverrideIdentifiers()||[],d=l?.getAllOverrideIdentifiers()||[];if(l){const f=d.filter(S=>!a.includes(S));for(const S of f)n.push([S,l.getKeysForOverrideIdentifier(S)])}if(c){const f=a.filter(S=>!d.includes(S));for(const S of f)n.push([S,c.getKeysForOverrideIdentifier(S)])}if(l&&c){for(const f of a)if(d.includes(f)){const S=m({contents:c.getOverrideValue(void 0,f)||{},keys:c.getKeysForOverrideIdentifier(f)},{contents:l.getOverrideValue(void 0,f)||{},keys:l.getKeysForOverrideIdentifier(f)});n.push([f,[...S.added,...S.removed,...S.updated]])}}return{added:s,removed:i,updated:r,overrides:n}}function m(c,l){const s=c?l?c.keys.filter(n=>l.keys.indexOf(n)===-1):[...c.keys]:[],i=l?c?l.keys.filter(n=>c.keys.indexOf(n)===-1):[...l.keys]:[],r=[];if(c&&l){for(const n of l.keys)if(c.keys.indexOf(n)!==-1){const a=(0,R.getConfigurationValue)(l.contents,n),d=(0,R.getConfigurationValue)(c.contents,n);C.equals(a,d)||r.push(n)}}return{added:s,removed:i,updated:r}}}),define(De[121],Ie([1,0,10,3]),function(Z,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var D;(function(y){y.Unknown="Unknown",y.NotAvailable="NotAvailable",y.TemporarilyNotAvailable="TemporarilyNotAvailable",y.NoResolverFound="NoResolverFound"})(D=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class P extends u.ErrorNoTelemetry{constructor(C,E=D.Unknown,I){super(C);this._message=C,this._code=E,this._detail=I,this.isHandled=E===D.NotAvailable&&I===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,P.prototype)}static isTemporarilyNotAvailable(C){return C instanceof P&&C._code===D.TemporarilyNotAvailable}static isNoResolverFound(C){return C instanceof P&&C._code===D.NoResolverFound}static isHandled(C){return C instanceof P&&C.isHandled}}e.RemoteAuthorityResolverError=P}),define(De[122],Ie([1,0,12]),function(Z,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(I){return I.scheme===u.Schemas.vscodeRemote?I.authority:void 0}e.getRemoteAuthority=t;function D(I){if(!I)return;const R=I.indexOf("+");return R<0?I:I.substr(0,R)}e.getRemoteName=D;function P(I){return`/${I.quality??"oss"}-${I.commit??"dev"}`}e.getRemoteServerRootPath=P;function y(I){const{host:R,port:k}=E(I);if(typeof k=="undefined")throw new Error("Remote authority doesn't contain a port!");return{host:R,port:k}}e.parseAuthorityWithPort=y;function C(I,R){let{host:k,port:_}=E(I);return typeof _=="undefined"&&(_=R),{host:k,port:_}}e.parseAuthorityWithOptionalPort=C;function E(I){const R=I.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(R)return{host:R[1],port:parseInt(R[2],10)};const k=I.match(/^(\[[0-9a-z:]+\])$/);if(k)return{host:k[1],port:void 0};const _=I.match(/(.*):(\d+)$/);return _?{host:_[1],port:parseInt(_[2],10)}:{host:I,port:void 0}}}),define(De[28],Ie([1,0,8,3,122]),function(Z,e,u,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function P(w){if(typeof w=="object"&&w!==null&&w.supported!==!0)return w.description}e.getWorkspaceSupportTypeMessage=P;function y(w){return w&&typeof w=="object"&&typeof w.id=="string"&&(!w.uuid||typeof w.uuid=="string")}e.isIExtensionIdentifier=y,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var C;(function(w){w[w.System=0]="System",w[w.User=1]="User"})(C=e.ExtensionType||(e.ExtensionType={}));var E;(function(w){w.WIN32_X64="win32-x64",w.WIN32_IA32="win32-ia32",w.WIN32_ARM64="win32-arm64",w.LINUX_X64="linux-x64",w.LINUX_ARM64="linux-arm64",w.LINUX_ARMHF="linux-armhf",w.ALPINE_X64="alpine-x64",w.ALPINE_ARM64="alpine-arm64",w.DARWIN_X64="darwin-x64",w.DARWIN_ARM64="darwin-arm64",w.WEB="web",w.UNIVERSAL="universal",w.UNKNOWN="unknown",w.UNDEFINED="undefined"})(E=e.TargetPlatform||(e.TargetPlatform={}));class I{constructor(b){this.value=b,this._lower=b.toLowerCase()}static equals(b,v){if(typeof b=="undefined"||b===null)return typeof v=="undefined"||v===null;if(typeof v=="undefined"||v===null)return!1;if(typeof b=="string"||typeof v=="string"){const h=typeof b=="string"?b:b.value,g=typeof v=="string"?v:v.value;return u.equalsIgnoreCase(h,g)}return b._lower===v._lower}static toKey(b){return typeof b=="string"?b.toLowerCase():b._lower}}e.ExtensionIdentifier=I;function R(w){return k(w)}e.isApplicationScopedExtension=R;function k(w){return w.contributes&&w.contributes.localizations?w.contributes.localizations.length>0:!1}e.isLanguagePackExtension=k;function _(w){return w.contributes&&w.contributes.authentication?w.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=_;function T(w,b){if(b){const v=`onResolveRemoteAuthority:${(0,D.getRemoteName)(b)}`;return w.activationEvents?.indexOf(v)!==-1}return!1}e.isResolverExtension=T,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(De[198],Ie([1,0,8,84,28,11,2,10,40]),function(Z,e,u,t,D,P,y,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function I(l,s){return l.uuid&&s.uuid?l.uuid===s.uuid:l.id===s.id?!0:(0,u.compareIgnoreCase)(l.id,s.id)===0}e.areSameExtensions=I;const R=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class k{constructor(s,i,r="undefined"){this.version=i,this.targetPlatform=r,this.id=s.id}static create(s){const i=s.manifest?s.manifest.version:s.version,r=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new k(s.identifier,i,r)}static parse(s){const i=R.exec(s);return i&&i[1]&&i[2]?new k({id:i[1]},i[2],i[4]||void 0):null}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof k?I(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.ExtensionKey=k;const _=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function T(l){const s=_.exec(l);return s&&s[1]?[b(s[1]),s[2]]:[b(l),void 0]}e.getIdAndVersion=T;function w(l,s){return`${l}.${s}`}e.getExtensionId=w;function b(l){return l.toLocaleLowerCase()}e.adoptToGalleryExtensionId=b;function v(l,s){return b(w(l,s))}e.getGalleryExtensionId=v;function h(l,s){const i=[],r=n=>{for(const a of i)if(a.some(d=>I(s(d),s(n))))return a;return null};for(const n of l){const a=r(n);a?a.push(n):i.push([n])}return i}e.groupByExtension=h;function g(l){return{id:l.identifier.id,name:l.manifest.name,galleryId:null,publisherId:l.publisherId,publisherName:l.manifest.publisher,publisherDisplayName:l.publisherDisplayName,dependencies:l.manifest.extensionDependencies&&l.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=g;function p(l){return{id:l.identifier.id,name:l.name,galleryId:l.identifier.uuid,publisherId:l.publisherId,publisherName:l.publisher,publisherDisplayName:l.publisherDisplayName,isPreReleaseVersion:l.properties.isPreReleaseVersion,dependencies:!!(l.properties.dependencies&&l.properties.dependencies.length>0),...l.telemetryData}}e.getGalleryExtensionTelemetryData=p,e.BetterMergeId=new D.ExtensionIdentifier("pprice.better-merge");function o(l,s){const i=[],r=s.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const n=r.shift();if(n&&i.every(a=>!I(a.identifier,{id:n}))){const a=l.filter(d=>I(d.identifier,{id:n}));a.length===1&&(i.push(a[0]),r.push(...a[0].manifest.extensionDependencies?.slice(0)??[]))}}return i}e.getExtensionDependencies=o;async function m(l,s){if(!P.isLinux)return!1;let i;try{i=(await l.readFile(y.URI.file("/etc/os-release"))).value.toString()}catch{try{i=(await l.readFile(y.URI.file("/usr/lib/os-release"))).value.toString()}catch(n){s.debug("Error while getting the os-release file.",(0,C.getErrorMessage)(n))}}return!!i&&(i.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=m;async function c(l,s){const i=await m(l,s),r=(0,t.getTargetPlatform)(i?"alpine":P.platform,E.arch);return s.debug("ComputeTargetPlatform:",r),r}e.computeTargetPlatform=c}),define(De[199],Ie([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class u{constructor(){this.validators=new Map}vsda(){return new Promise((D,P)=>Z(["vsda"],D,P))}async createNewMessage(D){try{const P=await this.vsda(),y=new P.validator;if(y){const C=String(u._nextId++);return this.validators.set(C,y),{id:C,data:y.createNewMessage(D)}}}catch{}return{id:"",data:D}}async validate(D,P){if(!D.id)return!0;const y=this.validators.get(D.id);if(!y)return!1;this.validators.delete(D.id);try{return y.validate(P)==="ok"}catch{return!1}}async sign(D){try{const P=await this.vsda(),y=new P.signer;if(y)return y.sign(D)}catch{}return D}}e.SignService=u,u._nextId=1}),define(De[200],Ie([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class u{constructor(D){this._callback=D,this._terminalBufferMap=new Map}dispose(){for(const D of this._terminalBufferMap.values())D.dispose()}startBuffering(D,P,y=5){const C=P(E=>{const I=typeof E=="string"?E:E.data;let R=this._terminalBufferMap.get(D);if(R){R.data.push(I);return}const k=setTimeout(()=>this.flushBuffer(D),y);R={data:[I],timeoutId:k,dispose:()=>{clearTimeout(k),this.flushBuffer(D),C.dispose()}},this._terminalBufferMap.set(D,R)});return C}stopBuffering(D){this._terminalBufferMap.get(D)?.dispose()}flushBuffer(D){const P=this._terminalBufferMap.get(D);P&&(this._terminalBufferMap.delete(D),this._callback(D,P.data.join("")))}}e.TerminalDataBufferer=u}),define(De[201],Ie([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var u;(function(P){P.DARK="dark",P.LIGHT="light",P.HIGH_CONTRAST_DARK="hcDark",P.HIGH_CONTRAST_LIGHT="hcLight"})(u=e.ColorScheme||(e.ColorScheme={}));function t(P){return P===u.HIGH_CONTRAST_DARK||P===u.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function D(P){return P===u.DARK||P===u.HIGH_CONTRAST_DARK}e.isDark=D}),define(De[86],Ie([1,0,76,4,6,3,43,201]),function(Z,e,u,t,D,P,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,P.createDecorator)("themeService");var E;(function(v){function h(g){return g&&typeof g=="object"&&typeof g.id=="string"}v.isThemeColor=h})(E=e.ThemeColor||(e.ThemeColor={}));function I(v){return{id:v}}e.themeColorFromId=I;var R;(function(v){function h(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color=="undefined"||E.isThemeColor(i.color))}v.isThemeIcon=h;const g=new RegExp(`^\\$\\((${u.CSSIcon.iconNameExpression}(?:${u.CSSIcon.iconModifierExpression})?)\\)$`);function p(i){const r=g.exec(i);if(!r)return;const[,n]=r;return{id:n}}v.fromString=p;function o(i){return{id:i}}v.fromId=o;function m(i,r){let n=i.id;const a=n.lastIndexOf("~");return a!==-1&&(n=n.substring(0,a)),r&&(n=`${n}~${r}`),{id:n}}v.modify=m;function c(i){const r=i.id.lastIndexOf("~");if(r!==-1)return i.id.substring(r+1)}v.getModifier=c;function l(i,r){return i.id===r.id&&i.color?.id===r.color?.id}v.isEqual=l;function s(i,r){return{id:i.id,color:r?I(r):void 0}}v.asThemeIcon=s,v.asClassNameArray=u.CSSIcon.asClassNameArray,v.asClassName=u.CSSIcon.asClassName,v.asCSSSelector=u.CSSIcon.asCSSSelector})(R=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=u.Codicon.file,e.FolderThemeIcon=u.Codicon.folder;function k(v){switch(v){case C.ColorScheme.DARK:return"vs-dark";case C.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case C.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=k,e.Extensions={ThemingContribution:"base.contributions.theming"};class _{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(h){return this.themingParticipants.push(h),this.onThemingParticipantAddedEmitter.fire(h),(0,D.toDisposable)(()=>{const g=this.themingParticipants.indexOf(h);this.themingParticipants.splice(g,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const T=new _;y.Registry.add(e.Extensions.ThemingContribution,T);function w(v){return T.onColorThemeChange(v)}e.registerThemingParticipant=w;class b extends D.Disposable{constructor(h){super();this.themeService=h,this.theme=h.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(g=>this.onThemeChange(g)))}onThemeChange(h){this.theme=h,this.updateStyles()}updateStyles(){}getColor(h,g){let p=this.theme.getColor(h);return p&&g&&(p=g(p,this.theme)),p?p.toString():null}}e.Themable=b}),define(De[123],Ie([1,0,4,11,3,14]),function(Z,e,u,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,D.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,D.createDecorator)("sharedTunnelsService");var y;(function(b){b.Http="http",b.Https="https"})(y=e.TunnelProtocol||(e.TunnelProtocol={}));var C;(function(b){b.ConstantPrivate="constantPrivate",b.Private="private",b.Public="public"})(C=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var E;(function(b){b[b.Notify=1]="Notify",b[b.OpenBrowser=2]="OpenBrowser",b[b.OpenPreview=3]="OpenPreview",b[b.Silent=4]="Silent",b[b.Ignore=5]="Ignore",b[b.OpenBrowserOnce=6]="OpenBrowserOnce"})(E=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function I(b){if(b.scheme!=="http"&&b.scheme!=="https")return;const v=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(b.authority);if(!!v)return{address:v[1],port:+v[2]}}e.extractLocalHostUriMetaDataForPortMapping=I,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function R(b){return e.LOCALHOST_ADDRESSES.indexOf(b)>=0}e.isLocalhost=R,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function k(b){return e.ALL_INTERFACES_ADDRESSES.indexOf(b)>=0}e.isAllInterfaces=k;function _(b,v){return v?v!==1&&b<1024:!t.isWindows&&b<1024}e.isPortPrivileged=_;class T{constructor(v,h,g){this.remoteAddress=v,this.localAddress=h,this._dispose=g,this._onDispose=new u.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=T;let w=class{constructor(v){this.logService=v,this._onTunnelOpened=new u.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new u.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new u.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(v){return this._tunnelProvider=v,v?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(v){this._canElevate=v.elevation,this._privacyOptions=v.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const v=[],h=Array.from(this._tunnels.values());for(const g of h){const p=Array.from(g.values());for(const o of p){const m=await o.value;m&&v.push(m)}}return v}async dispose(){for(const v of this._tunnels.values()){for(const{value:h}of v.values())await h.then(g=>g?.dispose());v.clear()}this._tunnels.clear()}openTunnel(v,h,g,p,o=!1,m,c){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${h}:${g} on local port ${p}.`),!v)return;if(h||(h="localhost"),this._tunnelProvider&&this._factoryInProgress.has(g)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const l=this.retainOrCreateTunnel(v,h,g,p,o,m,c);return l?l.then(s=>{if(!s){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(h,g);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const i=this.makeTunnel(s);return(s.tunnelRemoteHost!==h||s.tunnelRemotePort!==g)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(i),i}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),l)}makeTunnel(v){return{tunnelRemotePort:v.tunnelRemotePort,tunnelRemoteHost:v.tunnelRemoteHost,tunnelLocalPort:v.tunnelLocalPort,localAddress:v.localAddress,privacy:v.privacy,protocol:v.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${v.tunnelRemoteHost}:${v.tunnelRemotePort} `);const h=this._tunnels.get(v.tunnelRemoteHost);if(h){const g=h.get(v.tunnelRemotePort);g&&(g.refcount--,await this.tryDisposeTunnel(v.tunnelRemoteHost,v.tunnelRemotePort,g))}}}}async tryDisposeTunnel(v,h,g){if(g.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${v}:${h}.`);const p=g.value.then(async o=>{o&&(await o.dispose(!0),this._onTunnelClosed.fire({host:o.tunnelRemoteHost,port:o.tunnelRemotePort}))});return this._tunnels.has(v)&&this._tunnels.get(v).delete(h),p}}async closeTunnel(v,h){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${v}:${h} `);const g=this._tunnels.get(v);if(g&&g.has(h)){const p=g.get(h);p.refcount=0,await this.tryDisposeTunnel(v,h,p)}}addTunnelToMap(v,h,g){this._tunnels.has(v)||this._tunnels.set(v,new Map),this._tunnels.get(v).set(h,{refcount:1,value:g})}async removeEmptyTunnelFromMap(v,h){const g=this._tunnels.get(v);g&&(await g.get(h)||g.delete(h),g.size===0&&this._tunnels.delete(v))}getTunnelFromMap(v,h){const g=[v];R(v)?(g.push(...e.LOCALHOST_ADDRESSES),g.push(...e.ALL_INTERFACES_ADDRESSES)):k(v)&&g.push(...e.ALL_INTERFACES_ADDRESSES);const p=g.map(o=>this._tunnels.get(o));for(const o of p){const m=o?.get(h);if(m)return m}}canTunnel(v){return!!I(v)}createWithProvider(v,h,g,p,o,m,c){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${h}:${g} on local port ${p}.`);const l=g;this._factoryInProgress.add(l);const i={elevationRequired:o?_(p===void 0?g:p):!1},r={remoteAddress:{host:h,port:g},localAddressPort:p,privacy:m,public:m?m!==C.Private:void 0,protocol:c},n=v.forwardPort(r,i);return n?(this.addTunnelToMap(h,g,n),n.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(l)})):this._factoryInProgress.delete(l),n}};w=je([xe(0,P.ILogService)],w),e.AbstractTunnelService=w}),define(De[202],Ie([1,0,12]),function(Z,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function t(E){return E.scheme!==u.Schemas.file&&E.scheme!==u.Schemas.vscodeRemote}e.isVirtualResource=t;function D(E){if(E.folders.length)return E.folders.every(I=>t(I.uri))?E.folders[0].uri:void 0;if(E.configuration&&t(E.configuration))return E.configuration}e.getVirtualWorkspaceLocation=D;function P(E){return D(E)?.scheme}e.getVirtualWorkspaceScheme=P;function y(E){return D(E)?.authority}e.getVirtualWorkspaceAuthority=y;function C(E){return D(E)!==void 0}e.isVirtualWorkspace=C}),define(De[45],Ie([1,0,167,9,25,22,2,3,12]),function(Z,e,u,t,D,P,y,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,C.createDecorator)("contextService");function I(s){const i=s;return typeof i?.id=="string"&&y.URI.isUri(i.uri)}e.isSingleFolderWorkspaceIdentifier=I;function R(s){if(s.configuration)return{id:s.id,configPath:s.configuration};if(s.folders.length===1)return{id:s.id,uri:s.folders[0].uri}}e.toWorkspaceIdentifier=R;function k(s){const i=s;return typeof i?.id=="string"&&y.URI.isUri(i.configPath)}e.isWorkspaceIdentifier=k;function _(s){const i=s;if(i?.uri)return{id:i.id,uri:y.URI.revive(i.uri)};const r=s;if(r?.configPath)return{id:r.id,configPath:y.URI.revive(r.configPath)};if(s?.id)return{id:s.id}}e.reviveIdentifier=_;var T;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(T=e.WorkbenchState||(e.WorkbenchState={}));function w(s){const i=s;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&Array.isArray(i.folders))}e.isWorkspace=w;function b(s){const i=s;return!!(i&&typeof i=="object"&&y.URI.isUri(i.uri)&&typeof i.name=="string"&&typeof i.toResource=="function")}e.isWorkspaceFolder=b;class v{constructor(i,r,n,a,d){this._id=i,this._transient=n,this._configuration=a,this._ignorePathCasing=d,this._foldersMap=D.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=r}update(i){this._id=i.id,this._configuration=i.configuration,this._transient=i.transient,this._ignorePathCasing=i._ignorePathCasing,this.folders=i.folders}get folders(){return this._folders}set folders(i){this._folders=i,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(i){this._configuration=i}getFolder(i){return i&&this._foldersMap.findSubstr(i)||null}updateFoldersMap(){this._foldersMap=D.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const i of this.folders)this._foldersMap.set(i.uri,i)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=v;class h{constructor(i,r){this.raw=r,this.uri=i.uri,this.index=i.index,this.name=i.name}toResource(i){return(0,P.joinPath)(this.uri,i)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=h;function g(s){return new h({uri:s,index:0,name:(0,P.basenameOrAuthority)(s)},{uri:s.toString()})}e.toWorkspaceFolder=g,e.WORKSPACE_EXTENSION="code-workspace";const p=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,u.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function o(s,i){return P.extUriBiasedIgnorePathCase.isEqualOrParent(s,i.untitledWorkspacesHome)}e.isUntitledWorkspace=o;function m(s){let i;return y.URI.isUri(s)?i=s:i=s.configuration,i?.scheme===E.Schemas.tmp}e.isTemporaryWorkspace=m;function c(s,i){return!o(s,i)&&!m(s)}e.isSavedWorkspace=c;function l(s){return(typeof s=="string"?(0,t.extname)(s):(0,P.extname)(s))===p}e.hasWorkspaceFileExtension=l}),define(De[87],Ie([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class u{constructor(D){this.id=D,this._data=new Map,this._idPool=1}add(D){const P=this._idPool++;return this._data.set(P,D),this.logDebugInfo(),P}get(D,P){return this._data.has(D)?this._data.get(D)[P]:void 0}delete(D){this._data.delete(D),this.logDebugInfo()}logDebugInfo(){!u.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=u,u.enableDebugLogging=!1}),define(De[46],Ie([1,0,12,22,3]),function(Z,e,u,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class P{constructor(){this._systemSchemes=new Set(Object.keys(u.Schemas)),this._providerInfo=new Map,this.extUri=new t.ExtUri(C=>{const E=this._providerInfo.get(C.scheme);return!(E===void 0||E&1024)})}$acceptProviderInfos(C,E){E===null?this._providerInfo.delete(C.scheme):this._providerInfo.set(C.scheme,E)}isFreeScheme(C){return!this._providerInfo.has(C)&&!this._systemSchemes.has(C)}getCapabilities(C){return this._providerInfo.get(C)}}e.ExtHostFileSystemInfo=P,e.IExtHostFileSystemInfo=(0,D.createDecorator)("IExtHostFileSystemInfo")}),define(De[26],Ie([1,0,3]),function(Z,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,u.createDecorator)("IExtHostInitDataService")}),define(De[203],Ie([1,0,18]),function(Z,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class t{constructor(y,C,E){this._deferredPromises=new Map,this._id=y,this._shared=C,this._storage=E,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(I=>(this._value=I,this)),this._storageListener=this._storage.onDidChangeStorage(I=>{I.shared===this._shared&&I.key===this._id&&(this._value=I.value)}),this._scheduler=new u.RunOnceScheduler(()=>{const I=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const R of I.values())R.complete()}catch(R){for(const k of I.values())k.error(R)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,y])=>y!==void 0).map(([y])=>y)}get whenReady(){return this._init}get(y,C){let E=this._value[y];return typeof E=="undefined"&&(E=C),E}update(y,C){this._value[y]=C;const E=this._deferredPromises.get(y);if(E!==void 0)return E.p;const I=new u.DeferredPromise;return this._deferredPromises.set(y,I),this._scheduler.isScheduled()||this._scheduler.schedule(),I.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=t;class D extends t{constructor(y,C){super(y.identifier.value,!0,C);this._extension=y}setKeysForSync(y){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},y)}}e.ExtensionGlobalMemento=D}),define(De[204],Ie([1,0,4,2]),function(Z,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class D{constructor(y){this._notebooksAndEditors=y,this._onDidSaveNotebookDocument=new u.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new u.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(y,C,E,I){const k=this._notebooksAndEditors.getNotebookDocument(t.URI.revive(y)).acceptModelChanged(C.value,E,I);this._onDidChangeNotebookDocument.fire(k)}$acceptDirtyStateChanged(y,C){this._notebooksAndEditors.getNotebookDocument(t.URI.revive(y)).acceptDirty(C)}$acceptModelSaved(y){const C=this._notebooksAndEditors.getNotebookDocument(t.URI.revive(y));this._onDidSaveNotebookDocument.fire(C.apiNotebook)}}e.ExtHostNotebookDocuments=D}),define(De[15],Ie([1,0,3]),function(Z,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,u.createDecorator)("IExtHostRpcService");class t{constructor(P){this.getProxy=P.getProxy.bind(P),this.set=P.set.bind(P),this.dispose=P.dispose.bind(P),this.assertRegistered=P.assertRegistered.bind(P),this.drain=P.drain.bind(P)}}e.ExtHostRpcService=t});var et=this&&this.__classPrivateFieldSet||function(Z,e,u,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!D:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(Z,u):D?D.value=u:e.set(Z,u),u},Me=this&&this.__classPrivateFieldGet||function(Z,e,u,t){if(u==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?t:u==="a"?t.call(Z):t?t.value:e.get(Z)};define(De[205],Ie([1,0,28,4]),function(Z,e,u,t){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class P{constructor(C,E){D.set(this,void 0),this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this._id=u.ExtensionIdentifier.toKey(C.identifier),et(this,D,E,"f"),Me(this,D,"f").onDidChangePassword(I=>{I.extensionId===this._id&&this._onDidChange.fire({key:I.key})})}get(C){return Me(this,D,"f").get(this._id,C)}store(C,E){return Me(this,D,"f").store(this._id,C,E)}delete(C){return Me(this,D,"f").delete(this._id,C)}}e.ExtensionSecrets=P,D=new WeakMap}),define(De[124],Ie([1,0,3,4]),function(Z,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class D{constructor(){this._onDidChangeTelemetryEnabled=new t.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=new t.Emitter,this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=0}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._productConfig.error?this._level>=2:!1,isUsageEnabled:this._productConfig.usage?this._level>=3:!1}}$initializeTelemetryLevel(y,C){this._level=y,this._productConfig=C||{usage:!0,error:!0}}$onDidChangeTelemetryLevel(y){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=y,this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails())}}e.ExtHostTelemetry=D,e.IExtHostTelemetry=(0,u.createDecorator)("IExtHostTelemetry")}),define(De[53],Ie([1,0,3,123,4,15]),function(Z,e,u,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var y;(function(E){function I(k){return{remoteAddress:k.remoteAddress,localAddress:k.localAddress,public:!!k.public,privacy:k.privacy??(k.public?t.TunnelPrivacyId.Public:t.TunnelPrivacyId.Private),protocol:k.protocol}}E.fromApiTunnel=I;function R(k){return{remoteAddress:{host:k.tunnelRemoteHost,port:k.tunnelRemotePort},localAddress:k.localAddress,public:k.privacy!==t.TunnelPrivacyId.ConstantPrivate&&k.privacy!==t.TunnelPrivacyId.ConstantPrivate,privacy:k.privacy,protocol:k.protocol}}E.fromServiceTunnel=R})(y=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,u.createDecorator)("IExtHostTunnelService");let C=class{constructor(I){this.onDidChangeTunnels=new D.Emitter().event}async $applyCandidateFilter(I){return I}async openTunnel(I,R){}async getTunnels(){return[]}async setTunnelFactory(I){return{dispose:()=>{}}}registerPortsAttributesProvider(I,R){return{dispose:()=>{}}}async $providePortAttributes(I,R,k,_,T){return[]}async $forwardPort(I,R){}async $closeTunnel(I){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};C=je([xe(0,P.IExtHostRpcService)],C),e.ExtHostTunnelService=C});var et=this&&this.__classPrivateFieldSet||function(Z,e,u,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!D:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(Z,u):D?D.value=u:e.set(Z,u),u},Me=this&&this.__classPrivateFieldGet||function(Z,e,u,t){if(u==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?t:u==="a"?t.call(Z):t?t.value:e.get(Z)};define(De[7],Ie([1,0,17,10,105,25,100,8,13,2,34,42,121]),function(Z,e,u,t,D,P,y,C,E,I,R,k,_){"use strict";var T,w,b,v,h,g,p,o,m,c,l,s,i,r,n,a,d,f,S,O,U,M,A;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKindNew=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionsNew=e.InlineSuggestionNew=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function B(V){function z(){return Reflect.construct(V,arguments,this.constructor)}return Object.defineProperty(z,"name",Object.getOwnPropertyDescriptor(V,"name")),Object.setPrototypeOf(z,V),Object.setPrototypeOf(z.prototype,V.prototype),z}let x=g=class{constructor(z){T.set(this,void 0),et(this,T,z,"f")}static from(...z){let ce=z;return new g(function(){if(ce){for(const Pe of ce)Pe&&typeof Pe.dispose=="function"&&Pe.dispose();ce=void 0}})}dispose(){typeof Me(this,T,"f")=="function"&&(Me(this,T,"f").call(this),et(this,T,void 0,"f"))}};T=new WeakMap,x=g=je([B],x),e.Disposable=x;let N=p=class{constructor(z,ce){if(z<0)throw(0,t.illegalArgument)("line must be non-negative");if(ce<0)throw(0,t.illegalArgument)("character must be non-negative");this._line=z,this._character=ce}static Min(...z){if(z.length===0)throw new TypeError;let ce=z[0];for(let Pe=1;Pe<z.length;Pe++){const Xe=z[Pe];Xe.isBefore(ce)&&(ce=Xe)}return ce}static Max(...z){if(z.length===0)throw new TypeError;let ce=z[0];for(let Pe=1;Pe<z.length;Pe++){const Xe=z[Pe];Xe.isAfter(ce)&&(ce=Xe)}return ce}static isPosition(z){if(!z)return!1;if(z instanceof p)return!0;const{line:ce,character:Pe}=z;return typeof ce=="number"&&typeof Pe=="number"}static of(z){if(z instanceof p)return z;if(this.isPosition(z))return new p(z.line,z.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}isBefore(z){return this._line<z._line?!0:z._line<this._line?!1:this._character<z._character}isBeforeOrEqual(z){return this._line<z._line?!0:z._line<this._line?!1:this._character<=z._character}isAfter(z){return!this.isBeforeOrEqual(z)}isAfterOrEqual(z){return!this.isBefore(z)}isEqual(z){return this._line===z._line&&this._character===z._character}compareTo(z){return this._line<z._line?-1:this._line>z.line?1:this._character<z._character?-1:this._character>z._character?1:0}translate(z,ce=0){if(z===null||ce===null)throw(0,t.illegalArgument)();let Pe;return typeof z=="undefined"?Pe=0:typeof z=="number"?Pe=z:(Pe=typeof z.lineDelta=="number"?z.lineDelta:0,ce=typeof z.characterDelta=="number"?z.characterDelta:0),Pe===0&&ce===0?this:new p(this.line+Pe,this.character+ce)}with(z,ce=this.character){if(z===null||ce===null)throw(0,t.illegalArgument)();let Pe;return typeof z=="undefined"?Pe=this.line:typeof z=="number"?Pe=z:(Pe=typeof z.line=="number"?z.line:this.line,ce=typeof z.character=="number"?z.character:this.character),Pe===this.line&&ce===this.character?this:new p(Pe,ce)}toJSON(){return{line:this.line,character:this.character}}};N=p=je([B],N),e.Position=N;let K=o=class{constructor(z,ce,Pe,Xe){let nt,ct;if(typeof z=="number"&&typeof ce=="number"&&typeof Pe=="number"&&typeof Xe=="number"?(nt=new N(z,ce),ct=new N(Pe,Xe)):N.isPosition(z)&&N.isPosition(ce)&&(nt=N.of(z),ct=N.of(ce)),!nt||!ct)throw new Error("Invalid arguments");nt.isBefore(ct)?(this._start=nt,this._end=ct):(this._start=ct,this._end=nt)}static isRange(z){return z instanceof o?!0:z?N.isPosition(z.start)&&N.isPosition(z.end):!1}static of(z){if(z instanceof o)return z;if(this.isRange(z))return new o(z.start,z.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}contains(z){return o.isRange(z)?this.contains(z.start)&&this.contains(z.end):N.isPosition(z)?!(N.of(z).isBefore(this._start)||this._end.isBefore(z)):!1}isEqual(z){return this._start.isEqual(z._start)&&this._end.isEqual(z._end)}intersection(z){const ce=N.Max(z.start,this._start),Pe=N.Min(z.end,this._end);if(!ce.isAfter(Pe))return new o(ce,Pe)}union(z){if(this.contains(z))return this;if(z.contains(this))return z;const ce=N.Min(z.start,this._start),Pe=N.Max(z.end,this.end);return new o(ce,Pe)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(z,ce=this.end){if(z===null||ce===null)throw(0,t.illegalArgument)();let Pe;return z?N.isPosition(z)?Pe=z:(Pe=z.start||this.start,ce=z.end||this.end):Pe=this.start,Pe.isEqual(this._start)&&ce.isEqual(this.end)?this:new o(Pe,ce)}toJSON(){return[this.start,this.end]}};K=o=je([B],K),e.Range=K;let X=m=class extends K{constructor(z,ce,Pe,Xe){let nt,ct;if(typeof z=="number"&&typeof ce=="number"&&typeof Pe=="number"&&typeof Xe=="number"?(nt=new N(z,ce),ct=new N(Pe,Xe)):N.isPosition(z)&&N.isPosition(ce)&&(nt=N.of(z),ct=N.of(ce)),!nt||!ct)throw new Error("Invalid arguments");super(nt,ct);this._anchor=nt,this._active=ct}static isSelection(z){return z instanceof m?!0:z?K.isRange(z)&&N.isPosition(z.anchor)&&N.isPosition(z.active)&&typeof z.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};X=m=je([B],X),e.Selection=X;class L{constructor(z,ce,Pe){if(typeof z!="string"||z.length===0)throw(0,t.illegalArgument)("host");if(typeof ce!="number"||ce===0||Math.round(ce)!==ce)throw(0,t.illegalArgument)("port");if(typeof Pe!="undefined"&&(typeof Pe!="string"||Pe.length===0||!/^[0-9A-Za-z\-]+$/.test(Pe)))throw(0,t.illegalArgument)("connectionToken");this.host=z,this.port=Math.round(ce),this.connectionToken=Pe}}e.ResolvedAuthority=L;class $ extends Error{constructor(z,ce=_.RemoteAuthorityResolverErrorCode.Unknown,Pe){super(z);this._message=z,this._code=ce,this._detail=Pe,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,$.prototype)}static NotAvailable(z,ce){return new $(z,_.RemoteAuthorityResolverErrorCode.NotAvailable,ce)}static TemporarilyNotAvailable(z){return new $(z,_.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=$;var H;(function(V){V[V.LF=1]="LF",V[V.CRLF=2]="CRLF"})(H=e.EndOfLine||(e.EndOfLine={}));var j;(function(V){V[V.Replace=1]="Replace",V[V.Append=2]="Append",V[V.Prepend=3]="Prepend"})(j=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let J=c=class{constructor(z,ce){this._range=z,this._newText=ce}static isTextEdit(z){return z instanceof c?!0:z?K.isRange(z)&&typeof z.newText=="string":!1}static replace(z,ce){return new c(z,ce)}static insert(z,ce){return c.replace(new K(z,z),ce)}static delete(z){return c.replace(z,"")}static setEndOfLine(z){const ce=new c(new K(new N(0,0),new N(0,0)),"");return ce.newEol=z,ce}get range(){return this._range}set range(z){if(z&&!K.isRange(z))throw(0,t.illegalArgument)("range");this._range=z}get newText(){return this._newText||""}set newText(z){if(z&&typeof z!="string")throw(0,t.illegalArgument)("newText");this._newText=z}get newEol(){return this._newEol}set newEol(z){if(z&&typeof z!="number")throw(0,t.illegalArgument)("newEol");this._newEol=z}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};J=c=je([B],J),e.TextEdit=J;let Y=l=class{constructor(z,ce){this.range=z,this.newCells=ce}static isNotebookCellEdit(z){return z instanceof l?!0:z?$t.isNotebookRange(z)&&Array.isArray(z.newCells):!1}static replaceCells(z,ce){return new l(z,ce)}static insertCells(z,ce){return new l(new $t(z,z),ce)}static deleteCells(z){return new l(z,[])}static updateCellMetadata(z,ce){const Pe=new l(new $t(z,z),[]);return Pe.newCellMetadata=ce,Pe}static updateNotebookMetadata(z){const ce=new l(new $t(0,0),[]);return ce.newNotebookMetadata=z,ce}};Y=l=je([B],Y),e.NotebookEdit=Y;var he;(function(V){V[V.File=1]="File",V[V.Text=2]="Text",V[V.Cell=3]="Cell",V[V.CellReplace=5]="CellReplace",V[V.Snippet=6]="Snippet"})(he=e.FileEditType||(e.FileEditType={}));let ve=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(z,ce,Pe,Xe){this._edits.push({_type:1,from:z,to:ce,options:Pe,metadata:Xe})}createFile(z,ce,Pe){this._edits.push({_type:1,from:void 0,to:z,options:ce,metadata:Pe})}deleteFile(z,ce,Pe){this._edits.push({_type:1,from:z,to:void 0,options:ce,metadata:Pe})}replaceNotebookMetadata(z,ce,Pe){this._edits.push({_type:3,metadata:Pe,uri:z,edit:{editType:5,metadata:ce},notebookMetadata:ce})}replaceNotebookCells(z,ce,Pe,Xe,nt){let ct,ut,yt=[],Rt;if($t.isNotebookRange(ce)&&Kt.isNotebookCellDataArray(Pe)&&!Kt.isNotebookCellDataArray(Xe)?(ct=ce.start,ut=ce.end,yt=Pe,Rt=Xe):typeof ce=="number"&&typeof Pe=="number"&&Kt.isNotebookCellDataArray(Xe)&&(ct=ce,ut=Pe,yt=Xe,Rt=nt),ct===void 0||ut===void 0)throw new Error("Invalid arguments");(ct!==ut||yt.length>0)&&this._edits.push({_type:5,uri:z,index:ct,count:ut-ct,cells:yt,metadata:Rt})}replaceNotebookCellMetadata(z,ce,Pe,Xe){this._edits.push({_type:3,metadata:Xe,uri:z,edit:{editType:8,index:ce,metadata:Pe}})}replace(z,ce,Pe,Xe){typeof Pe=="string"?this._edits.push({_type:2,uri:z,edit:new J(ce,Pe),metadata:Xe}):this._edits.push({_type:6,uri:z,range:ce,edit:Pe,metadata:Xe})}insert(z,ce,Pe,Xe){this.replace(z,new K(ce,ce),Pe,Xe)}delete(z,ce,Pe){this.replace(z,ce,"",Pe)}has(z){return this._edits.some(ce=>ce._type===2&&ce.uri.toString()===z.toString())}set(z,ce){if(ce)for(const Pe of ce)Pe&&(Y.isNotebookCellEdit(Pe)?Pe.newCellMetadata?this.replaceNotebookCellMetadata(z,Pe.range.start,Pe.newCellMetadata):Pe.newNotebookMetadata?this.replaceNotebookMetadata(z,Pe.newNotebookMetadata):this.replaceNotebookCells(z,Pe.range,Pe.newCells):this._edits.push({_type:2,uri:z,edit:Pe}));else{for(let Pe=0;Pe<this._edits.length;Pe++){const Xe=this._edits[Pe];Xe._type===2&&Xe.uri.toString()===z.toString()&&(this._edits[Pe]=void 0)}(0,u.coalesceInPlace)(this._edits)}}get(z){const ce=[];for(const Pe of this._edits)Pe._type===2&&Pe.uri.toString()===z.toString()&&ce.push(Pe.edit);return ce}entries(){const z=new P.ResourceMap;for(const ce of this._edits)if(ce._type===2){let Pe=z.get(ce.uri);Pe||(Pe=[ce.uri,[]],z.set(ce.uri,Pe)),Pe[1].push(ce.edit)}return[...z.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};ve=je([B],ve),e.WorkspaceEdit=ve;let ne=s=class{constructor(z){this._tabstop=1,this.value=z||""}static isSnippetString(z){return z instanceof s?!0:z?typeof z.value=="string":!1}static _escape(z){return z.replace(/\$|}|\\/g,"\\$&")}appendText(z){return this.value+=s._escape(z),this}appendTabstop(z=this._tabstop++){return this.value+="$",this.value+=z,this}appendPlaceholder(z,ce=this._tabstop++){if(typeof z=="function"){const Pe=new s;Pe._tabstop=this._tabstop,z(Pe),this._tabstop=Pe._tabstop,z=Pe.value}else z=s._escape(z);return this.value+="${",this.value+=ce,this.value+=":",this.value+=z,this.value+="}",this}appendChoice(z,ce=this._tabstop++){const Pe=z.map(Xe=>Xe.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ce,this.value+="|",this.value+=Pe,this.value+="|}",this}appendVariable(z,ce){if(typeof ce=="function"){const Pe=new s;Pe._tabstop=this._tabstop,ce(Pe),this._tabstop=Pe._tabstop,ce=Pe.value}else typeof ce=="string"&&(ce=ce.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=z,ce&&(this.value+=":",this.value+=ce),this.value+="}",this}};ne=s=je([B],ne),e.SnippetString=ne;var pe;(function(V){V[V.Unnecessary=1]="Unnecessary",V[V.Deprecated=2]="Deprecated"})(pe=e.DiagnosticTag||(e.DiagnosticTag={}));var Ee;(function(V){V[V.Hint=3]="Hint",V[V.Information=2]="Information",V[V.Warning=1]="Warning",V[V.Error=0]="Error"})(Ee=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let ke=i=class{constructor(z,ce){if(this.uri=z,ce)if(K.isRange(ce))this.range=K.of(ce);else if(N.isPosition(ce))this.range=new K(ce,ce);else throw new Error("Illegal argument")}static isLocation(z){return z instanceof i?!0:z?K.isRange(z.range)&&I.URI.isUri(z.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};ke=i=je([B],ke),e.Location=ke;let Oe=class{constructor(z,ce){this.location=z,this.message=ce}static is(z){return z?typeof z.message=="string"&&z.location&&K.isRange(z.location.range)&&I.URI.isUri(z.location.uri):!1}static isEqual(z,ce){return z===ce?!0:!z||!ce?!1:z.message===ce.message&&z.location.range.isEqual(ce.location.range)&&z.location.uri.toString()===ce.location.uri.toString()}};Oe=je([B],Oe),e.DiagnosticRelatedInformation=Oe;let Be=class{constructor(z,ce,Pe=Ee.Error){if(!K.isRange(z))throw new TypeError("range must be set");if(!ce)throw new TypeError("message must be set");this.range=z,this.message=ce,this.severity=Pe}toJSON(){return{severity:Ee[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(z,ce){return z===ce?!0:!z||!ce?!1:z.message===ce.message&&z.severity===ce.severity&&z.code===ce.code&&z.severity===ce.severity&&z.source===ce.source&&z.range.isEqual(ce.range)&&(0,u.equals)(z.tags,ce.tags)&&(0,u.equals)(z.relatedInformation,ce.relatedInformation,Oe.isEqual)}};Be=je([B],Be),e.Diagnostic=Be;let ae=class{constructor(z,ce){if(!z)throw new Error("Illegal argument, contents must be defined");Array.isArray(z)?this.contents=z:this.contents=[z],this.range=ce}};ae=je([B],ae),e.Hover=ae;var de;(function(V){V[V.Text=0]="Text",V[V.Read=1]="Read",V[V.Write=2]="Write"})(de=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let me=class{constructor(z,ce=de.Text){this.range=z,this.kind=ce}toJSON(){return{range:this.range,kind:de[this.kind]}}};me=je([B],me),e.DocumentHighlight=me;var te;(function(V){V[V.File=0]="File",V[V.Module=1]="Module",V[V.Namespace=2]="Namespace",V[V.Package=3]="Package",V[V.Class=4]="Class",V[V.Method=5]="Method",V[V.Property=6]="Property",V[V.Field=7]="Field",V[V.Constructor=8]="Constructor",V[V.Enum=9]="Enum",V[V.Interface=10]="Interface",V[V.Function=11]="Function",V[V.Variable=12]="Variable",V[V.Constant=13]="Constant",V[V.String=14]="String",V[V.Number=15]="Number",V[V.Boolean=16]="Boolean",V[V.Array=17]="Array",V[V.Object=18]="Object",V[V.Key=19]="Key",V[V.Null=20]="Null",V[V.EnumMember=21]="EnumMember",V[V.Struct=22]="Struct",V[V.Event=23]="Event",V[V.Operator=24]="Operator",V[V.TypeParameter=25]="TypeParameter"})(te=e.SymbolKind||(e.SymbolKind={}));var le;(function(V){V[V.Deprecated=1]="Deprecated"})(le=e.SymbolTag||(e.SymbolTag={}));let ee=r=class{constructor(z,ce,Pe,Xe,nt){this.name=z,this.kind=ce,this.containerName=nt,typeof Pe=="string"&&(this.containerName=Pe),Xe instanceof ke?this.location=Xe:Pe instanceof K&&(this.location=new ke(Xe,Pe)),r.validate(this)}static validate(z){if(!z.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:te[this.kind],location:this.location,containerName:this.containerName}}};ee=r=je([B],ee),e.SymbolInformation=ee;let re=n=class{constructor(z,ce,Pe,Xe,nt){this.name=z,this.detail=ce,this.kind=Pe,this.range=Xe,this.selectionRange=nt,this.children=[],n.validate(this)}static validate(z){if(!z.name)throw new Error("name must not be falsy");if(!z.range.contains(z.selectionRange))throw new Error("selectionRange must be contained in fullRange");z.children?.forEach(n.validate)}};re=n=je([B],re),e.DocumentSymbol=re;var F;(function(V){V[V.Invoke=1]="Invoke",V[V.Automatic=2]="Automatic"})(F=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let W=class{constructor(z,ce){this.title=z,this.kind=ce}};W=je([B],W),e.CodeAction=W;let G=a=class{constructor(z){this.value=z}append(z){return new a(this.value?this.value+a.sep+z:z)}intersects(z){return this.contains(z)||z.contains(this)}contains(z){return this.value===z.value||z.value.startsWith(this.value+a.sep)}};G.sep=".",G=a=je([B],G),e.CodeActionKind=G,G.Empty=new G(""),G.QuickFix=G.Empty.append("quickfix"),G.Refactor=G.Empty.append("refactor"),G.RefactorExtract=G.Refactor.append("extract"),G.RefactorInline=G.Refactor.append("inline"),G.RefactorRewrite=G.Refactor.append("rewrite"),G.Source=G.Empty.append("source"),G.SourceOrganizeImports=G.Source.append("organizeImports"),G.SourceFixAll=G.Source.append("fixAll");let Q=class{constructor(z,ce){if(this.range=z,this.parent=ce,ce&&!ce.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};Q=je([B],Q),e.SelectionRange=Q;class fe{constructor(z,ce,Pe,Xe,nt,ct){this.kind=z,this.name=ce,this.detail=Pe,this.uri=Xe,this.range=nt,this.selectionRange=ct}}e.CallHierarchyItem=fe;class be{constructor(z,ce){this.fromRanges=ce,this.from=z}}e.CallHierarchyIncomingCall=be;class ue{constructor(z,ce){this.fromRanges=ce,this.to=z}}e.CallHierarchyOutgoingCall=ue;var Ce;(function(V){V[V.Information=0]="Information",V[V.Warning=1]="Warning",V[V.Error=2]="Error"})(Ce=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Se=class{constructor(z,ce){this.range=z,this.command=ce}get isResolved(){return!!this.command}};Se=je([B],Se),e.CodeLens=Se;let Ue=d=class{constructor(z,ce=!1){w.set(this,void 0),et(this,w,new D.MarkdownString(z,{supportThemeIcons:ce}),"f")}static isMarkdownString(z){return z instanceof d?!0:z&&z.appendCodeblock&&z.appendMarkdown&&z.appendText&&z.value!==void 0}get value(){return Me(this,w,"f").value}set value(z){Me(this,w,"f").value=z}get isTrusted(){return Me(this,w,"f").isTrusted}set isTrusted(z){Me(this,w,"f").isTrusted=z}get supportThemeIcons(){return Me(this,w,"f").supportThemeIcons}set supportThemeIcons(z){Me(this,w,"f").supportThemeIcons=z}get supportHtml(){return Me(this,w,"f").supportHtml}set supportHtml(z){Me(this,w,"f").supportHtml=z}get baseUri(){return Me(this,w,"f").baseUri}set baseUri(z){Me(this,w,"f").baseUri=z}appendText(z){return Me(this,w,"f").appendText(z),this}appendMarkdown(z){return Me(this,w,"f").appendMarkdown(z),this}appendCodeblock(z,ce){return Me(this,w,"f").appendCodeblock(ce??"",z),this}};w=new WeakMap,Ue=d=je([B],Ue),e.MarkdownString=Ue;let qe=class{constructor(z,ce){this.label=z,this.documentation=ce}};qe=je([B],qe),e.ParameterInformation=qe;let Je=class{constructor(z,ce){this.label=z,this.documentation=ce,this.parameters=[]}};Je=je([B],Je),e.SignatureInformation=Je;let Qe=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};Qe=je([B],Qe),e.SignatureHelp=Qe;var Re;(function(V){V[V.Invoke=1]="Invoke",V[V.TriggerCharacter=2]="TriggerCharacter",V[V.ContentChange=3]="ContentChange"})(Re=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var st;(function(V){V[V.Type=1]="Type",V[V.Parameter=2]="Parameter"})(st=e.InlayHintKind||(e.InlayHintKind={}));let se=class{constructor(z){this.value=z}};se=je([B],se),e.InlayHintLabelPart=se;let oe=class{constructor(z,ce,Pe){this.position=z,this.label=ce,this.kind=Pe}};oe=je([B],oe),e.InlayHint=oe;var q;(function(V){V[V.Invoke=0]="Invoke",V[V.TriggerCharacter=1]="TriggerCharacter",V[V.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(q=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ye;(function(V){V[V.Text=0]="Text",V[V.Method=1]="Method",V[V.Function=2]="Function",V[V.Constructor=3]="Constructor",V[V.Field=4]="Field",V[V.Variable=5]="Variable",V[V.Class=6]="Class",V[V.Interface=7]="Interface",V[V.Module=8]="Module",V[V.Property=9]="Property",V[V.Unit=10]="Unit",V[V.Value=11]="Value",V[V.Enum=12]="Enum",V[V.Keyword=13]="Keyword",V[V.Snippet=14]="Snippet",V[V.Color=15]="Color",V[V.File=16]="File",V[V.Reference=17]="Reference",V[V.Folder=18]="Folder",V[V.EnumMember=19]="EnumMember",V[V.Constant=20]="Constant",V[V.Struct=21]="Struct",V[V.Event=22]="Event",V[V.Operator=23]="Operator",V[V.TypeParameter=24]="TypeParameter",V[V.User=25]="User",V[V.Issue=26]="Issue"})(ye=e.CompletionItemKind||(e.CompletionItemKind={}));var Ae;(function(V){V[V.Deprecated=1]="Deprecated"})(Ae=e.CompletionItemTag||(e.CompletionItemTag={}));let We=class{constructor(z,ce){this.label=z,this.kind=ce}toJSON(){return{label:this.label,kind:this.kind&&ye[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};We=je([B],We),e.CompletionItem=We;let ze=class{constructor(z=[],ce=!1){this.items=z,this.isIncomplete=ce}};ze=je([B],ze),e.CompletionList=ze;let $e=class{constructor(z,ce,Pe){this.insertText=z,this.range=ce,this.command=Pe}};$e=je([B],$e),e.InlineSuggestion=$e;let Ze=class{constructor(z){this.commands=void 0,this.items=z}};Ze=je([B],Ze),e.InlineSuggestionList=Ze;let it=class{constructor(z,ce,Pe){this.insertText=z,this.range=ce,this.command=Pe}};it=je([B],it),e.InlineSuggestionNew=it;let lt=class{constructor(z,ce){this.items=z,this.commands=ce}};lt=je([B],lt),e.InlineSuggestionsNew=lt;var ht;(function(V){V[V.Active=-1]="Active",V[V.Beside=-2]="Beside",V[V.One=1]="One",V[V.Two=2]="Two",V[V.Three=3]="Three",V[V.Four=4]="Four",V[V.Five=5]="Five",V[V.Six=6]="Six",V[V.Seven=7]="Seven",V[V.Eight=8]="Eight",V[V.Nine=9]="Nine"})(ht=e.ViewColumn||(e.ViewColumn={}));var tt;(function(V){V[V.Left=1]="Left",V[V.Right=2]="Right"})(tt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var at;(function(V){V[V.Off=0]="Off",V[V.On=1]="On",V[V.Relative=2]="Relative"})(at=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ct;(function(V){V[V.Manual=1]="Manual",V[V.AfterDelay=2]="AfterDelay",V[V.FocusOut=3]="FocusOut"})(Ct=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ot;(function(V){V[V.Default=0]="Default",V[V.InCenter=1]="InCenter",V[V.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",V[V.AtTop=3]="AtTop"})(Ot=e.TextEditorRevealType||(e.TextEditorRevealType={}));var It;(function(V){V[V.Keyboard=1]="Keyboard",V[V.Mouse=2]="Mouse",V[V.Command=3]="Command"})(It=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var mt;(function(V){V[V.Undo=1]="Undo",V[V.Redo=2]="Redo"})(mt=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var kt;(function(V){V[V.OpenOpen=0]="OpenOpen",V[V.ClosedClosed=1]="ClosedClosed",V[V.OpenClosed=2]="OpenClosed",V[V.ClosedOpen=3]="ClosedOpen"})(kt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(V){function z(ce){switch(ce){case"keyboard":return V.Keyboard;case"mouse":return V.Mouse;case"api":return V.Command}}V.fromValue=z}(It=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Ut=class{constructor(z,ce){if(ce&&!I.URI.isUri(ce))throw(0,t.illegalArgument)("target");if(!K.isRange(z)||z.isEmpty)throw(0,t.illegalArgument)("range");this.range=z,this.target=ce}};Ut=je([B],Ut),e.DocumentLink=Ut;let Ft=class{constructor(z,ce,Pe,Xe){this.red=z,this.green=ce,this.blue=Pe,this.alpha=Xe}};Ft=je([B],Ft),e.Color=Ft;let Ge=class{constructor(z,ce){if(ce&&!(ce instanceof Ft))throw(0,t.illegalArgument)("color");if(!K.isRange(z)||z.isEmpty)throw(0,t.illegalArgument)("range");this.range=z,this.color=ce}};Ge=je([B],Ge),e.ColorInformation=Ge;let Nt=class{constructor(z){if(!z||typeof z!="string")throw(0,t.illegalArgument)("label");this.label=z}};Nt=je([B],Nt),e.ColorPresentation=Nt;var Lt;(function(V){V[V.RGB=0]="RGB",V[V.HEX=1]="HEX",V[V.HSL=2]="HSL"})(Lt=e.ColorFormat||(e.ColorFormat={}));var Bt;(function(V){V[V.Error=0]="Error",V[V.Warning=1]="Warning",V[V.Information=2]="Information"})(Bt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var bt;(function(V){V[V.Unknown=0]="Unknown",V[V.Shutdown=1]="Shutdown",V[V.Process=2]="Process",V[V.User=3]="User",V[V.Extension=4]="Extension"})(bt=e.TerminalExitReason||(e.TerminalExitReason={}));class Te{constructor(z,ce,Pe){if(this.startIndex=z,this.length=ce,this.tooltip=Pe,typeof z!="number"||z<0)throw(0,t.illegalArgument)("startIndex");if(typeof ce!="number"||ce<1)throw(0,t.illegalArgument)("length");if(Pe!==void 0&&typeof Pe!="string")throw(0,t.illegalArgument)("tooltip")}}e.TerminalLink=Te;var Le;(function(V){V[V.Panel=1]="Panel",V[V.Editor=2]="Editor"})(Le=e.TerminalLocation||(e.TerminalLocation={}));class _e{constructor(z){if(this.options=z,typeof z!="object")throw(0,t.illegalArgument)("options")}}e.TerminalProfile=_e;var ie;(function(V){V[V.Always=1]="Always",V[V.Silent=2]="Silent",V[V.Never=3]="Never"})(ie=e.TaskRevealKind||(e.TaskRevealKind={}));var Fe;(function(V){V[V.Shared=1]="Shared",V[V.Dedicated=2]="Dedicated",V[V.New=3]="New"})(Fe=e.TaskPanelKind||(e.TaskPanelKind={}));let Ve=f=class{constructor(z,ce){if(this.label=ce,typeof z!="string"||typeof ce!="string")throw(0,t.illegalArgument)("name");this._id=z}static from(z){switch(z){case"clean":return f.Clean;case"build":return f.Build;case"rebuild":return f.Rebuild;case"test":return f.Test;default:return}}get id(){return this._id}};Ve.Clean=new f("clean","Clean"),Ve.Build=new f("build","Build"),Ve.Rebuild=new f("rebuild","Rebuild"),Ve.Test=new f("test","Test"),Ve=f=je([B],Ve),e.TaskGroup=Ve;function rt(V){let z="";for(let ce=0;ce<V.length;ce++)z+=V[ce].replace(/,/g,",,")+",";return z}let Ye=class{constructor(z,ce,Pe){if(typeof z!="string")throw(0,t.illegalArgument)("process");this._args=[],this._process=z,ce!==void 0&&(Array.isArray(ce)?(this._args=ce,this._options=Pe):this._options=ce)}get process(){return this._process}set process(z){if(typeof z!="string")throw(0,t.illegalArgument)("process");this._process=z}get args(){return this._args}set args(z){Array.isArray(z)||(z=[]),this._args=z}get options(){return this._options}set options(z){this._options=z}computeId(){const z=[];if(z.push("process"),this._process!==void 0&&z.push(this._process),this._args&&this._args.length>0)for(const ce of this._args)z.push(ce);return rt(z)}};Ye=je([B],Ye),e.ProcessExecution=Ye;let Ke=class{constructor(z,ce,Pe){if(this._args=[],Array.isArray(ce)){if(!z)throw(0,t.illegalArgument)("command can't be undefined or null");if(typeof z!="string"&&typeof z.value!="string")throw(0,t.illegalArgument)("command");this._command=z,this._args=ce,this._options=Pe}else{if(typeof z!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=z,this._options=ce}}get commandLine(){return this._commandLine}set commandLine(z){if(typeof z!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=z}get command(){return this._command?this._command:""}set command(z){if(typeof z!="string"&&typeof z.value!="string")throw(0,t.illegalArgument)("command");this._command=z}get args(){return this._args}set args(z){this._args=z||[]}get options(){return this._options}set options(z){this._options=z}computeId(){const z=[];if(z.push("shell"),this._commandLine!==void 0&&z.push(this._commandLine),this._command!==void 0&&z.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const ce of this._args)z.push(typeof ce=="string"?ce:ce.value);return rt(z)}};Ke=je([B],Ke),e.ShellExecution=Ke;var ft;(function(V){V[V.Escape=1]="Escape",V[V.Strong=2]="Strong",V[V.Weak=3]="Weak"})(ft=e.ShellQuoting||(e.ShellQuoting={}));var pt;(function(V){V[V.Global=1]="Global",V[V.Workspace=2]="Workspace"})(pt=e.TaskScope||(e.TaskScope={}));class Dt{constructor(z){this._callback=z}computeId(){return"customExecution"+(0,R.generateUuid)()}set callback(z){this._callback=z}get callback(){return this._callback}}e.CustomExecution=Dt;let vt=S=class{constructor(z,ce,Pe,Xe,nt,ct){this.__deprecated=!1,this._definition=this.definition=z;let ut;typeof ce=="string"?(this._name=this.name=ce,this._source=this.source=Pe,this.execution=Xe,ut=nt,this.__deprecated=!0):ce===pt.Global||ce===pt.Workspace?(this.target=ce,this._name=this.name=Pe,this._source=this.source=Xe,this.execution=nt,ut=ct):(this.target=ce,this._name=this.name=Pe,this._source=this.source=Xe,this.execution=nt,ut=ct),typeof ut=="string"?(this._problemMatchers=[ut],this._hasDefinedMatchers=!0):Array.isArray(ut)?(this._problemMatchers=ut,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(z){this.__id=z}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Ye?this._definition={type:S.ProcessType,id:this._execution.computeId()}:this._execution instanceof Ke?this._definition={type:S.ShellType,id:this._execution.computeId()}:this._execution instanceof Dt?this._definition={type:S.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:S.EmptyType,id:(0,R.generateUuid)()}}get definition(){return this._definition}set definition(z){if(z==null)throw(0,t.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=z}get scope(){return this._scope}set target(z){this.clear(),this._scope=z}get name(){return this._name}set name(z){if(typeof z!="string")throw(0,t.illegalArgument)("name");this.clear(),this._name=z}get execution(){return this._execution}set execution(z){z===null&&(z=void 0),this.clear(),this._execution=z;const ce=this._definition.type;(S.EmptyType===ce||S.ProcessType===ce||S.ShellType===ce||S.ExtensionCallbackType===ce)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(z){if(Array.isArray(z))this.clear(),this._problemMatchers=z,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(z){z!==!0&&z!==!1&&(z=!1),this.clear(),this._isBackground=z}get source(){return this._source}set source(z){if(typeof z!="string"||z.length===0)throw(0,t.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=z}get group(){return this._group}set group(z){z===null&&(z=void 0),this.clear(),this._group=z}get detail(){return this._detail}set detail(z){z===null&&(z=void 0),this._detail=z}get presentationOptions(){return this._presentationOptions}set presentationOptions(z){z==null&&(z=Object.create(null)),this.clear(),this._presentationOptions=z}get runOptions(){return this._runOptions}set runOptions(z){z==null&&(z=Object.create(null)),this.clear(),this._runOptions=z}};vt.ExtensionCallbackType="customExecution",vt.ProcessType="process",vt.ShellType="shell",vt.EmptyType="$empty",vt=S=je([B],vt),e.Task=vt;var St;(function(V){V[V.SourceControl=1]="SourceControl",V[V.Window=10]="Window",V[V.Notification=15]="Notification"})(St=e.ProgressLocation||(e.ProgressLocation={}));let At=O=class{constructor(z,ce=gt.None){this.collapsibleState=ce,I.URI.isUri(z)?this.resourceUri=z:this.label=z}static isTreeItem(z){if(z instanceof O)return!0;const ce=z;if(ce.label!==void 0&&!(0,E.isString)(ce.label)&&!ce.label.label)return console.log("INVALID tree item, invalid label",ce.label),!1;if(ce.id!==void 0&&!(0,E.isString)(ce.id))return console.log("INVALID tree item, invalid id",ce.id),!1;if(ce.iconPath!==void 0&&!(0,E.isString)(ce.iconPath)&&!I.URI.isUri(ce.iconPath)&&!(0,E.isString)(ce.iconPath.id)){const Pe=ce.iconPath;if(!(0,E.isString)(Pe.light)&&!I.URI.isUri(Pe.light)&&!(0,E.isString)(Pe.dark)&&!I.URI.isUri(Pe.dark))return console.log("INVALID tree item, invalid iconPath",ce.iconPath),!1}return ce.description!==void 0&&!(0,E.isString)(ce.description)&&typeof ce.description!="boolean"?(console.log("INVALID tree item, invalid description",ce.description),!1):ce.resourceUri!==void 0&&!I.URI.isUri(ce.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",ce.resourceUri),!1):ce.tooltip!==void 0&&!(0,E.isString)(ce.tooltip)&&!(ce.tooltip instanceof Ue)?(console.log("INVALID tree item, invalid tooltip",ce.tooltip),!1):ce.command!==void 0&&!ce.command.command?(console.log("INVALID tree item, invalid command",ce.command),!1):ce.collapsibleState!==void 0&&ce.collapsibleState<gt.None&&ce.collapsibleState>gt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",ce.collapsibleState),!1):ce.contextValue!==void 0&&!(0,E.isString)(ce.contextValue)?(console.log("INVALID tree item, invalid contextValue",ce.contextValue),!1):ce.accessibilityInformation!==void 0&&!ce.accessibilityInformation.label?(console.log("INVALID tree item, invalid accessibilityInformation",ce.accessibilityInformation),!1):!0}};At=O=je([B],At),e.TreeItem=At;var gt;(function(V){V[V.None=0]="None",V[V.Collapsed=1]="Collapsed",V[V.Expanded=2]="Expanded"})(gt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Yt=class{constructor(z){this.value=z}async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}};Yt=je([B],Yt),e.DataTransferItem=Yt;let Jt=class{constructor(z){b.set(this,new Map);for(const[ce,Pe]of z??[]){const Xe=Me(this,b,"f").get(ce);Xe?Xe.push(Pe):Me(this,b,"f").set(ce,[Pe])}}get(z){return Me(this,b,"f").get(z)?.[0]}set(z,ce){Me(this,b,"f").set(z,[ce])}forEach(z,ce){for(const[Pe,Xe]of Me(this,b,"f"))for(const nt of Xe)z.call(ce,nt,Pe,this)}*[(b=new WeakMap,Symbol.iterator)](){for(const[z,ce]of Me(this,b,"f"))for(const Pe of ce)yield[z,Pe]}};Jt=je([B],Jt),e.DataTransfer=Jt;let Et=class{constructor(z){this.insertText=z}};Et=je([B],Et),e.DocumentDropEdit=Et;let xt=class{constructor(z){this.insertText=z}};xt=je([B],xt),e.DocumentPasteEdit=xt;let zt=class{constructor(z,ce){this.id=z,this.color=ce}};zt=je([B],zt),e.ThemeIcon=zt,zt.File=new zt("file"),zt.Folder=new zt("folder");let an=class{constructor(z){this.id=z}};an=je([B],an),e.ThemeColor=an;var Pn;(function(V){V[V.Global=1]="Global",V[V.Workspace=2]="Workspace",V[V.WorkspaceFolder=3]="WorkspaceFolder"})(Pn=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Tt=class{constructor(z,ce){if(typeof z!="string"&&(!z||!I.URI.isUri(z)&&!I.URI.isUri(z.uri)))throw(0,t.illegalArgument)("base");if(typeof ce!="string")throw(0,t.illegalArgument)("pattern");typeof z=="string"?this.baseUri=I.URI.file(z):I.URI.isUri(z)?this.baseUri=z:this.baseUri=z.uri,this.pattern=ce}get base(){return this._base}set base(z){this._base=z,this._baseUri=I.URI.file(z)}get baseUri(){return this._baseUri}set baseUri(z){this._baseUri=z,this._base=z.fsPath}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};Tt=je([B],Tt),e.RelativePattern=Tt;let qt=class{constructor(z,ce,Pe,Xe){this.enabled=typeof z=="boolean"?z:!0,typeof ce=="string"&&(this.condition=ce),typeof Pe=="string"&&(this.hitCondition=Pe),typeof Xe=="string"&&(this.logMessage=Xe)}get id(){return this._id||(this._id=(0,R.generateUuid)()),this._id}};qt=je([B],qt),e.Breakpoint=qt;let gn=class extends qt{constructor(z,ce,Pe,Xe,nt){super(ce,Pe,Xe,nt);if(z===null)throw(0,t.illegalArgument)("location");this.location=z}};gn=je([B],gn),e.SourceBreakpoint=gn;let Zt=class extends qt{constructor(z,ce,Pe,Xe,nt){super(ce,Pe,Xe,nt);this.functionName=z}};Zt=je([B],Zt),e.FunctionBreakpoint=Zt;let en=class extends qt{constructor(z,ce,Pe,Xe,nt,ct,ut){super(Xe,nt,ct,ut);if(!ce)throw(0,t.illegalArgument)("dataId");this.label=z,this.dataId=ce,this.canPersist=Pe}};en=je([B],en),e.DataBreakpoint=en;let dt=class{constructor(z,ce,Pe){this.command=z,this.args=ce||[],this.options=Pe}};dt=je([B],dt),e.DebugAdapterExecutable=dt;let pn=class{constructor(z,ce){this.port=z,this.host=ce}};pn=je([B],pn),e.DebugAdapterServer=pn;let Wt=class{constructor(z){this.path=z}};Wt=je([B],Wt),e.DebugAdapterNamedPipeServer=Wt;let Gt=class{constructor(z){this.implementation=z}};Gt=je([B],Gt),e.DebugAdapterInlineImplementation=Gt;let cn=class{constructor(z,ce){this.range=z,this.expression=ce}};cn=je([B],cn),e.EvaluatableExpression=cn;var An;(function(V){V[V.Invoke=0]="Invoke",V[V.Automatic=1]="Automatic"})(An=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var Cn;(function(V){V[V.Invoke=0]="Invoke",V[V.Automatic=1]="Automatic"})(Cn=e.InlineCompletionTriggerKindNew||(e.InlineCompletionTriggerKindNew={}));let vn=class{constructor(z,ce){this.range=z,this.text=ce}};vn=je([B],vn),e.InlineValueText=vn;let ln=class{constructor(z,ce,Pe=!0){this.range=z,this.variableName=ce,this.caseSensitiveLookup=Pe}};ln=je([B],ln),e.InlineValueVariableLookup=ln;let tn=class{constructor(z,ce){this.range=z,this.expression=ce}};tn=je([B],tn),e.InlineValueEvaluatableExpression=tn;let bn=class{constructor(z,ce){this.frameId=z,this.stoppedLocation=ce}};bn=je([B],bn),e.InlineValueContext=bn;var wn;(function(V){V[V.Changed=1]="Changed",V[V.Created=2]="Created",V[V.Deleted=3]="Deleted"})(wn=e.FileChangeType||(e.FileChangeType={}));let nn=U=class extends Error{constructor(z,ce=k.FileSystemProviderErrorCode.Unknown,Pe){super(I.URI.isUri(z)?z.toString(!0):z);this.code=Pe?.name??"Unknown",(0,k.markAsFileSystemProviderError)(this,ce),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,U.prototype),typeof Error.captureStackTrace=="function"&&typeof Pe=="function"&&Error.captureStackTrace(this,Pe)}static FileExists(z){return new U(z,k.FileSystemProviderErrorCode.FileExists,U.FileExists)}static FileNotFound(z){return new U(z,k.FileSystemProviderErrorCode.FileNotFound,U.FileNotFound)}static FileNotADirectory(z){return new U(z,k.FileSystemProviderErrorCode.FileNotADirectory,U.FileNotADirectory)}static FileIsADirectory(z){return new U(z,k.FileSystemProviderErrorCode.FileIsADirectory,U.FileIsADirectory)}static NoPermissions(z){return new U(z,k.FileSystemProviderErrorCode.NoPermissions,U.NoPermissions)}static Unavailable(z){return new U(z,k.FileSystemProviderErrorCode.Unavailable,U.Unavailable)}};nn=U=je([B],nn),e.FileSystemError=nn;let En=class{constructor(z,ce,Pe){this.start=z,this.end=ce,this.kind=Pe}};En=je([B],En),e.FoldingRange=En;var Rn;(function(V){V[V.Comment=1]="Comment",V[V.Imports=2]="Imports",V[V.Region=3]="Region"})(Rn=e.FoldingRangeKind||(e.FoldingRangeKind={}));var rn;(function(V){V[V.Collapsed=0]="Collapsed",V[V.Expanded=1]="Expanded"})(rn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Ln;(function(V){V[V.Editing=0]="Editing",V[V.Preview=1]="Preview"})(Ln=e.CommentMode||(e.CommentMode={}));var On;(function(V){V[V.Unresolved=0]="Unresolved",V[V.Resolved=1]="Resolved"})(On=e.CommentThreadState||(e.CommentThreadState={}));class Fn{constructor(z,ce=[]){this.tokenTypes=z,this.tokenModifiers=ce}}e.SemanticTokensLegend=Fn;function Nn(V){return typeof V=="undefined"||(0,E.isStringArray)(V)}class sn{constructor(z){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,z){this._hasLegend=!0;for(let ce=0,Pe=z.tokenTypes.length;ce<Pe;ce++)this._tokenTypeStrToInt.set(z.tokenTypes[ce],ce);for(let ce=0,Pe=z.tokenModifiers.length;ce<Pe;ce++)this._tokenModifierStrToInt.set(z.tokenModifiers[ce],ce)}}push(z,ce,Pe,Xe,nt){if(typeof z=="number"&&typeof ce=="number"&&typeof Pe=="number"&&typeof Xe=="number"&&(typeof nt=="number"||typeof nt=="undefined"))return typeof nt=="undefined"&&(nt=0),this._pushEncoded(z,ce,Pe,Xe,nt);if(K.isRange(z)&&typeof ce=="string"&&Nn(Pe))return this._push(z,ce,Pe);throw(0,t.illegalArgument)()}_push(z,ce,Pe){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(z.start.line!==z.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ce))throw new Error("`tokenType` is not in the provided legend");const Xe=z.start.line,nt=z.start.character,ct=z.end.character-z.start.character,ut=this._tokenTypeStrToInt.get(ce);let yt=0;if(Pe)for(const Rt of Pe){if(!this._tokenModifierStrToInt.has(Rt))throw new Error("`tokenModifier` is not in the provided legend");const Ht=this._tokenModifierStrToInt.get(Rt);yt|=1<<Ht>>>0}this._pushEncoded(Xe,nt,ct,ut,yt)}_pushEncoded(z,ce,Pe,Xe,nt){if(this._dataIsSortedAndDeltaEncoded&&(z<this._prevLine||z===this._prevLine&&ce<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const yt=this._data.length/5|0;let Rt=0,Ht=0;for(let jt=0;jt<yt;jt++){let Xt=this._data[5*jt],Sn=this._data[5*jt+1];Xt===0?(Xt=Rt,Sn+=Ht):Xt+=Rt,this._data[5*jt]=Xt,this._data[5*jt+1]=Sn,Rt=Xt,Ht=Sn}}let ct=z,ut=ce;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ct-=this._prevLine,ct===0&&(ut-=this._prevChar)),this._data[this._dataLen++]=ct,this._data[this._dataLen++]=ut,this._data[this._dataLen++]=Pe,this._data[this._dataLen++]=Xe,this._data[this._dataLen++]=nt,this._prevLine=z,this._prevChar=ce}static _sortAndDeltaEncode(z){const ce=[],Pe=z.length/5|0;for(let ut=0;ut<Pe;ut++)ce[ut]=ut;ce.sort((ut,yt)=>{const Rt=z[5*ut],Ht=z[5*yt];if(Rt===Ht){const jt=z[5*ut+1],Xt=z[5*yt+1];return jt-Xt}return Rt-Ht});const Xe=new Uint32Array(z.length);let nt=0,ct=0;for(let ut=0;ut<Pe;ut++){const yt=5*ce[ut],Rt=z[yt+0],Ht=z[yt+1],jt=z[yt+2],Xt=z[yt+3],Sn=z[yt+4],Yn=Rt-nt,wi=Yn===0?Ht-ct:Ht,yn=5*ut;Xe[yn+0]=Yn,Xe[yn+1]=wi,Xe[yn+2]=jt,Xe[yn+3]=Xt,Xe[yn+4]=Sn,nt=Rt,ct=Ht}return Xe}build(z){return this._dataIsSortedAndDeltaEncoded?new un(new Uint32Array(this._data),z):new un(sn._sortAndDeltaEncode(this._data),z)}}e.SemanticTokensBuilder=sn;class un{constructor(z,ce){this.resultId=ce,this.data=z}}e.SemanticTokens=un;class Dn{constructor(z,ce,Pe){this.start=z,this.deleteCount=ce,this.data=Pe}}e.SemanticTokensEdit=Dn;class He{constructor(z,ce){this.resultId=ce,this.edits=z}}e.SemanticTokensEdits=He;var Vt;(function(V){V[V.Separate=0]="Separate",V[V.MergeWithParent=1]="MergeWithParent"})(Vt=e.DebugConsoleMode||(e.DebugConsoleMode={}));let on=class{constructor(){}};on.Back={iconPath:new zt("arrow-left")},on=je([B],on),e.QuickInputButtons=on;var wt;(function(V){V[V.Separator=-1]="Separator",V[V.Default=0]="Default"})(wt=e.QuickPickItemKind||(e.QuickPickItemKind={}));var Mn;(function(V){V[V.Info=1]="Info",V[V.Warning=2]="Warning",V[V.Error=3]="Error"})(Mn=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var Un;(function(V){V[V.UI=1]="UI",V[V.Workspace=2]="Workspace"})(Un=e.ExtensionKind||(e.ExtensionKind={}));class In{constructor(z,ce,Pe){this.badge=z,this.tooltip=ce,this.color=Pe}static validate(z){if(z.badge){let ce=(0,C.nextCharLength)(z.badge,0);if(ce<z.badge.length&&(ce+=(0,C.nextCharLength)(z.badge,ce)),z.badge.length>ce)throw new Error("The 'badge'-property must be undefined or a short character")}if(!z.color&&!z.badge&&!z.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=In;let _n=class{constructor(z){this.kind=z}};_n=je([B],_n),e.ColorTheme=_n;var dn;(function(V){V[V.Light=1]="Light",V[V.Dark=2]="Dark",V[V.HighContrast=3]="HighContrast",V[V.HighContrastLight=4]="HighContrastLight"})(dn=e.ColorThemeKind||(e.ColorThemeKind={}));class $t{constructor(z,ce){if(z<0)throw(0,t.illegalArgument)("start must be positive");if(ce<0)throw(0,t.illegalArgument)("end must be positive");z<=ce?(this._start=z,this._end=ce):(this._start=ce,this._end=z)}static isNotebookRange(z){return z instanceof $t?!0:z?typeof z.start=="number"&&typeof z.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(z){let ce=this._start,Pe=this._end;return z.start!==void 0&&(ce=z.start),z.end!==void 0&&(Pe=z.end),ce===this._start&&Pe===this._end?this:new $t(ce,Pe)}}e.NotebookRange=$t;class Kt{constructor(z,ce,Pe,Xe,nt,ct,ut){this.kind=z,this.value=ce,this.languageId=Pe,this.mime=Xe,this.outputs=nt??[],this.metadata=ct,this.executionSummary=ut,Kt.validate(this)}static validate(z){if(typeof z.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof z.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof z.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(z){return Array.isArray(z)&&z.every(ce=>Kt.isNotebookCellData(ce))}static isNotebookCellData(z){return!0}}e.NotebookCellData=Kt;class Bn{constructor(z){this.cells=z}}e.NotebookData=Bn;class Mt{constructor(z,ce){this.data=z,this.mime=ce;const Pe=(0,y.normalizeMimeType)(ce,!0);if(!Pe)throw new Error(`INVALID mime type: ${ce}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Pe}static isNotebookCellOutputItem(z){return z instanceof Mt?!0:z?typeof z.mime=="string"&&z.data instanceof Uint8Array:!1}static error(z){const ce={name:z.name,message:z.message,stack:z.stack};return Mt.json(ce,"application/vnd.code.notebook.error")}static stdout(z){return Mt.text(z,"application/vnd.code.notebook.stdout")}static stderr(z){return Mt.text(z,"application/vnd.code.notebook.stderr")}static bytes(z,ce="application/octet-stream"){return new Mt(z,ce)}static text(z,ce=y.Mimes.text){const Pe=Me(Mt,v,"f",h).encode(String(z));return new Mt(Pe,ce)}static json(z,ce="text/x-json"){const Pe=JSON.stringify(z,void 0,"	");return Mt.text(Pe,ce)}}e.NotebookCellOutputItem=Mt,v=Mt,h={value:new TextEncoder};class hn{constructor(z,ce,Pe){this.items=hn.ensureUniqueMimeTypes(z,!0),typeof ce=="string"?(this.id=ce,this.metadata=Pe):(this.id=(0,R.generateUuid)(),this.metadata=ce??Pe)}static isNotebookCellOutput(z){return z instanceof hn?!0:!z||typeof z!="object"?!1:typeof z.id=="string"&&Array.isArray(z.items)}static ensureUniqueMimeTypes(z,ce=!1){const Pe=new Set,Xe=new Set;for(let nt=0;nt<z.length;nt++){const ct=z[nt],ut=(0,y.normalizeMimeType)(ct.mime);if(!Pe.has(ut)){Pe.add(ut);continue}Xe.add(nt),ce&&console.warn(`DUPLICATED mime type '${ct.mime}' will be dropped`)}return Xe.size===0?z:z.filter((nt,ct)=>!Xe.has(ct))}}e.NotebookCellOutput=hn;var zn;(function(V){V[V.Markup=1]="Markup",V[V.Code=2]="Code"})(zn=e.NotebookCellKind||(e.NotebookCellKind={}));var Wn;(function(V){V[V.Idle=1]="Idle",V[V.Pending=2]="Pending",V[V.Executing=3]="Executing"})(Wn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var $n;(function(V){V[V.Left=1]="Left",V[V.Right=2]="Right"})($n=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Hn;(function(V){V[V.Default=0]="Default",V[V.InCenter=1]="InCenter",V[V.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",V[V.AtTop=3]="AtTop"})(Hn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class ge{constructor(z,ce){this.text=z,this.alignment=ce}}e.NotebookCellStatusBarItem=ge;var we;(function(V){V[V.Default=1]="Default",V[V.Preferred=2]="Preferred"})(we=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Ne{constructor(z,ce=[]){this.uri=z,this.provides=(0,u.asArray)(ce)}}e.NotebookRendererScript=Ne;let ot=class{constructor(z,ce){this.label=z,this.timestamp=ce}};ot=je([B],ot),e.TimelineItem=ot;var _t;(function(V){V[V.Production=1]="Production",V[V.Development=2]="Development",V[V.Test=3]="Test"})(_t=e.ExtensionMode||(e.ExtensionMode={}));var Pt;(function(V){V[V.Node=1]="Node",V[V.Webworker=2]="Webworker"})(Pt=e.ExtensionRuntime||(e.ExtensionRuntime={}));var ti;(function(V){V[V.Other=0]="Other",V[V.Comment=1]="Comment",V[V.String=2]="String",V[V.RegEx=3]="RegEx"})(ti=e.StandardTokenType||(e.StandardTokenType={}));class ni{constructor(z,ce){this.ranges=z,this.wordPattern=ce}}e.LinkedEditingRanges=ni;class ii{constructor(z,ce){this._port=z,this._autoForwardAction=ce}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=ii;var ri;(function(V){V[V.Queued=1]="Queued",V[V.Running=2]="Running",V[V.Passed=3]="Passed",V[V.Failed=4]="Failed",V[V.Skipped=5]="Skipped",V[V.Errored=6]="Errored"})(ri=e.TestResultState||(e.TestResultState={}));var si;(function(V){V[V.Run=1]="Run",V[V.Debug=2]="Debug",V[V.Coverage=3]="Coverage"})(si=e.TestRunProfileKind||(e.TestRunProfileKind={}));let xn=class{constructor(z=void 0,ce=void 0,Pe=void 0){this.include=z,this.exclude=ce,this.profile=Pe}};xn=je([B],xn),e.TestRunRequest=xn;let Vn=M=class{constructor(z){this.message=z}static diff(z,ce,Pe){const Xe=new M(z);return Xe.expectedOutput=ce,Xe.actualOutput=Pe,Xe}};Vn=M=je([B],Vn),e.TestMessage=Vn;let jn=class{constructor(z){this.id=z}};jn=je([B],jn),e.TestTag=jn;let fn=class{constructor(z,ce){this.covered=z,this.total=ce}};fn=je([B],fn),e.CoveredCount=fn;let qn=A=class{constructor(z,ce,Pe,Xe){this.uri=z,this.statementCoverage=ce,this.branchCoverage=Pe,this.functionCoverage=Xe}static fromDetails(z,ce){const Pe=new fn(0,0),Xe=new fn(0,0),nt=new fn(0,0);for(const ut of ce)if("branches"in ut){Pe.total+=1,Pe.covered+=ut.executionCount>0?1:0;for(const yt of ut.branches)Xe.total+=1,Xe.covered+=yt.executionCount>0?1:0}else nt.total+=1,nt.covered+=ut.executionCount>0?1:0;const ct=new A(z,Pe,Xe.total>0?Xe:void 0,nt.total>0?nt:void 0);return ct.detailedCoverage=ce,ct}};qn=A=je([B],qn),e.FileCoverage=qn;let Gn=class{constructor(z,ce,Pe=[]){this.executionCount=z,this.location=ce,this.branches=Pe}};Gn=je([B],Gn),e.StatementCoverage=Gn;let Kn=class{constructor(z,ce){this.executionCount=z,this.location=ce}};Kn=je([B],Kn),e.BranchCoverage=Kn;let Xn=class{constructor(z,ce){this.executionCount=z,this.location=ce}};Xn=je([B],Xn),e.FunctionCoverage=Xn;var oi;(function(V){V[V.None=0]="None",V[V.Option=1]="Option",V[V.Default=2]="Default",V[V.Preferred=3]="Preferred"})(oi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var ai;(function(V){V[V.Untrusted=0]="Untrusted",V[V.Trusted=1]="Trusted",V[V.Unspecified=2]="Unspecified"})(ai=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var ci;(function(V){V[V.Notify=1]="Notify",V[V.OpenBrowser=2]="OpenBrowser",V[V.OpenPreview=3]="OpenPreview",V[V.Silent=4]="Silent",V[V.Ignore=5]="Ignore",V[V.OpenBrowserOnce=6]="OpenBrowserOnce"})(ci=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class li{constructor(z,ce,Pe,Xe,nt,ct){this.kind=z,this.name=ce,this.detail=Pe,this.uri=Xe,this.range=nt,this.selectionRange=ct}}e.TypeHierarchyItem=li;class ui{constructor(z){this.uri=z}}e.TextTabInput=ui;class di{constructor(z,ce){this.original=z,this.modified=ce}}e.TextDiffTabInput=di;class hi{constructor(z,ce,Pe,Xe){this.base=z,this.input1=ce,this.input2=Pe,this.result=Xe}}e.TextMergeTabInput=hi;class fi{constructor(z,ce){this.uri=z,this.viewType=ce}}e.CustomEditorTabInput=fi;class mi{constructor(z){this.viewType=z}}e.WebviewEditorTabInput=mi;class gi{constructor(z,ce){this.uri=z,this.notebookType=ce}}e.NotebookEditorTabInput=gi;class pi{constructor(z,ce,Pe){this.original=z,this.modified=ce,this.notebookType=Pe}}e.NotebookDiffEditorTabInput=pi;class vi{constructor(){}}e.TerminalEditorTabInput=vi;class bi{constructor(z,ce){this.uri=z,this.inputBoxUri=ce}}e.InteractiveWindowInput=bi}),define(De[125],Ie([1,0,48,12,8,157,98,7,17]),function(Z,e,u,t,D,P,y,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const I=new Map;function R(w,b){b?I.set(w,b):I.delete(w)}e.setWordDefinitionFor=R;function k(w){return I.get(w)}e.getWordDefinitionFor=k;class _ extends P.MirrorTextModel{constructor(b,v,h,g,p,o,m,c){super(v,h,g,p);this._proxy=b,this._languageId=o,this._isDirty=m,this.notebook=c,this._isDisposed=!1}dispose(){(0,u.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(b){return(0,E.equals)(this._lines,b)}get document(){if(!this._document){const b=this;this._document={get uri(){return b._uri},get fileName(){return b._uri.fsPath},get isUntitled(){return b._uri.scheme===t.Schemas.untitled},get languageId(){return b._languageId},get version(){return b._versionId},get isClosed(){return b._isDisposed},get isDirty(){return b._isDirty},save(){return b._save()},getText(v){return v?b._getTextInRange(v):b.getText()},get eol(){return b._eol===`
`?C.EndOfLine.LF:C.EndOfLine.CRLF},get lineCount(){return b._lines.length},lineAt(v){return b._lineAt(v)},offsetAt(v){return b._offsetAt(v)},positionAt(v){return b._positionAt(v)},validateRange(v){return b._validateRange(v)},validatePosition(v){return b._validatePosition(v)},getWordRangeAtPosition(v,h){return b._getWordRangeAtPosition(v,h)}}}return Object.freeze(this._document)}_acceptLanguageId(b){(0,u.ok)(!this._isDisposed),this._languageId=b}_acceptIsDirty(b){(0,u.ok)(!this._isDisposed),this._isDirty=b}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(b){const v=this._validateRange(b);if(v.isEmpty)return"";if(v.isSingleLine)return this._lines[v.start.line].substring(v.start.character,v.end.character);const h=this._eol,g=v.start.line,p=v.end.line,o=[];o.push(this._lines[g].substring(v.start.character));for(let m=g+1;m<p;m++)o.push(this._lines[m]);return o.push(this._lines[p].substring(0,v.end.character)),o.join(h)}_lineAt(b){let v;if(b instanceof C.Position?v=b.line:typeof b=="number"&&(v=b),typeof v!="number"||v<0||v>=this._lines.length||Math.floor(v)!==v)throw new Error("Illegal value for `line`");return new T(v,this._lines[v],v===this._lines.length-1)}_offsetAt(b){return b=this._validatePosition(b),this._ensureLineStarts(),this._lineStarts.getPrefixSum(b.line-1)+b.character}_positionAt(b){b=Math.floor(b),b=Math.max(0,b),this._ensureLineStarts();const v=this._lineStarts.getIndexOf(b),h=this._lines[v.index].length;return new C.Position(v.index,Math.min(v.remainder,h))}_validateRange(b){if(!(b instanceof C.Range))throw new Error("Invalid argument");const v=this._validatePosition(b.start),h=this._validatePosition(b.end);return v===b.start&&h===b.end?b:new C.Range(v.line,v.character,h.line,h.character)}_validatePosition(b){if(!(b instanceof C.Position))throw new Error("Invalid argument");if(this._lines.length===0)return b.with(0,0);let{line:v,character:h}=b,g=!1;if(v<0)v=0,h=0,g=!0;else if(v>=this._lines.length)v=this._lines.length-1,h=this._lines[v].length,g=!0;else{const p=this._lines[v].length;h<0?(h=0,g=!0):h>p&&(h=p,g=!0)}return g?new C.Position(v,h):b}_getWordRangeAtPosition(b,v){const h=this._validatePosition(b);if(!v)v=k(this._languageId);else if((0,D.regExpLeadsToEndlessLoop)(v))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${v.source}' because it matches the empty string.`);const g=(0,y.getWordAtText)(h.character+1,(0,y.ensureValidWordDefinition)(v),this._lines[h.line],0);if(g)return new C.Range(h.line,g.startColumn-1,h.line,g.endColumn-1)}}e.ExtHostDocumentData=_;class T{constructor(b,v,h){this._line=b,this._text=v,this._isLastLine=h}get lineNumber(){return this._line}get text(){return this._text}get range(){return new C.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new C.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=T}),define(De[206],Ie([1,0,7,15,4]),function(Z,e,u,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let P=class{constructor(C){this._actual=new u.ColorTheme(u.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new D.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(C){let E;switch(C){case"light":E=u.ColorThemeKind.Light;break;case"hcDark":E=u.ColorThemeKind.HighContrast;break;case"hcLight":E=u.ColorThemeKind.HighContrastLight;break;default:E=u.ColorThemeKind.Dark}this._actual=new u.ColorTheme(E),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};P=je([xe(0,t.IExtHostRpcService)],P),e.ExtHostTheming=P}),define(De[64],Ie([1,0,3]),function(Z,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,u.createDecorator)("IURITransformerService");class t{constructor(P){P?(this.transformIncoming=P.transformIncoming.bind(P),this.transformOutgoing=P.transformOutgoing.bind(P),this.transformOutgoingURI=P.transformOutgoingURI.bind(P),this.transformOutgoingScheme=P.transformOutgoingScheme.bind(P)):(this.transformIncoming=y=>y,this.transformOutgoing=y=>y,this.transformOutgoingURI=y=>y,this.transformOutgoingScheme=y=>y)}}e.URITransformerService=t}),define(De[207],Ie([1,0,23]),function(Z,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class t{constructor(){this.buffers=[]}add(E){let I=this.buffers.indexOf(E);return I<0&&(I=this.buffers.length,this.buffers.push(E)),I}}function D(C,E){if(E.serializeBuffersForPostMessage){const I=new t,R=(T,w)=>{if(w instanceof ArrayBuffer){const b=I.add(w);return{$$vscode_array_buffer_reference$$:!0,index:b}}else if(ArrayBuffer.isView(w)){const b=P(w);if(b){const v=I.add(w.buffer);return{$$vscode_array_buffer_reference$$:!0,index:v,view:{type:b,byteLength:w.byteLength,byteOffset:w.byteOffset}}}}return w},k=JSON.stringify(C,R),_=I.buffers.map(T=>{const w=new Uint8Array(T);return u.VSBuffer.wrap(w)});return{message:k,buffers:_}}else return{message:JSON.stringify(C),buffers:[]}}e.serializeWebviewMessage=D;function P(C){switch(C.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function y(C,E){const I=E.map(_=>{const T=new ArrayBuffer(_.byteLength);return new Uint8Array(T).set(_.buffer),T}),R=E.length?(_,T)=>{if(T&&typeof T=="object"&&T.$$vscode_array_buffer_reference$$){const w=T,{index:b}=w,v=I[b];if(w.view)switch(w.view.type){case 1:return new Int8Array(v,w.view.byteOffset,w.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(v,w.view.byteOffset,w.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(v,w.view.byteOffset,w.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(v,w.view.byteOffset,w.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(v,w.view.byteOffset,w.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(v,w.view.byteOffset,w.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(v,w.view.byteOffset,w.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(v,w.view.byteOffset,w.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(v,w.view.byteOffset,w.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(v,w.view.byteOffset,w.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(v,w.view.byteOffset,w.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return v}return T}:void 0;return{message:JSON.parse(C,R),arrayBuffers:I}}e.deserializeWebviewMessage=y}),define(De[208],Ie([1,0,107]),function(Z,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function t(P){return{transformIncoming:y=>y.scheme==="vscode-remote"?{scheme:"file",path:y.path,query:y.query,fragment:y.fragment}:y.scheme==="file"?{scheme:"vscode-local",path:y.path,query:y.query,fragment:y.fragment}:y,transformOutgoing:y=>y.scheme==="file"?{scheme:"vscode-remote",authority:P,path:y.path,query:y.query,fragment:y.fragment}:y.scheme==="vscode-local"?{scheme:"file",path:y.path,query:y.query,fragment:y.fragment}:y,transformOutgoingScheme:y=>y==="file"?"vscode-remote":y==="vscode-local"?"file":y}}function D(P){return new u.URITransformer(t(P))}e.createURITransformer=D}),define(De[209],Ie([1,0,177,13,2,6,3,43,42,17,12]),function(Z,e,u,t,D,P,y,C,E,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,u.localize)(0,null),providerDisplayName:(0,u.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var k;(function(L){L[L.PROGRAMMATIC=1]="PROGRAMMATIC",L[L.USER=2]="USER",L[L.EDIT=3]="EDIT",L[L.NAVIGATION=4]="NAVIGATION",L[L.JUMP=5]="JUMP"})(k=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var _;(function(L){L[L.IDENTICAL=1]="IDENTICAL",L[L.SIMILAR=2]="SIMILAR",L[L.DIFFERENT=3]="DIFFERENT"})(_=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function T(L){const $=L;return!!$&&typeof $.getSelection=="function"&&!!$.onDidChangeSelection}e.isEditorPaneWithSelection=T;function w(L,$,H){for(const j of H.visibleEditorPanes)if(j.group.id===$&&L.matches(j.input))return j.getViewState()}e.findViewStateForEditor=w;function b(L){if(i(L))return!1;const $=L;return D.URI.isUri($?.resource)}e.isResourceEditorInput=b;function v(L){if(i(L))return!1;const $=L;return $?.original!==void 0&&$.modified!==void 0}e.isResourceDiffEditorInput=v;function h(L){if(i(L)||v(L))return!1;const $=L;return $?.primary!==void 0&&$.secondary!==void 0}e.isResourceSideBySideEditorInput=h;function g(L){if(i(L))return!1;const $=L;return $?$.resource===void 0||$.resource.scheme===R.Schemas.untitled||$.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=g;function p(L){if(i(L))return!1;const $=L;return D.URI.isUri($?.base?.resource)&&D.URI.isUri($?.input1?.resource)&&D.URI.isUri($?.input2?.resource)&&D.URI.isUri($?.result?.resource)}e.isResourceMergeEditorInput=p;var o;(function(L){L[L.SHORT=0]="SHORT",L[L.MEDIUM=1]="MEDIUM",L[L.LONG=2]="LONG"})(o=e.Verbosity||(e.Verbosity={}));var m;(function(L){L[L.EXPLICIT=1]="EXPLICIT",L[L.AUTO=2]="AUTO",L[L.FOCUS_CHANGE=3]="FOCUS_CHANGE",L[L.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(m=e.SaveReason||(e.SaveReason={}));class c{constructor(){this.mapIdToSaveSource=new Map}registerSource($,H){let j=this.mapIdToSaveSource.get($);return j||(j={source:$,label:H},this.mapIdToSaveSource.set($,j)),j.source}getSourceLabel($){return this.mapIdToSaveSource.get($)?.label??$}}e.SaveSourceRegistry=new c;var l;(function(L){L[L.None=0]="None",L[L.Readonly=2]="Readonly",L[L.Untitled=4]="Untitled",L[L.Singleton=8]="Singleton",L[L.RequiresTrust=16]="RequiresTrust",L[L.CanSplitInGroup=32]="CanSplitInGroup",L[L.ForceDescription=64]="ForceDescription",L[L.CanDropIntoEditor=128]="CanDropIntoEditor",L[L.MultipleEditors=256]="MultipleEditors"})(l=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class s extends P.Disposable{}e.AbstractEditorInput=s;function i(L){return L instanceof s}e.isEditorInput=i;function r(L){const $=L;return D.URI.isUri($?.preferredResource)}function n(L){const $=L;return i($?.primary)&&i($?.secondary)}e.isSideBySideEditorInput=n;function a(L){const $=L;return i($?.modified)&&i($?.original)}e.isDiffEditorInput=a;function d(L){return i(L?.editor)}e.isEditorInputWithOptions=d;function f(L){const $=L;return d(L)&&$?.group!==void 0}e.isEditorInputWithOptionsAndGroup=f;function S(L){const $=L;return typeof $?.groupId=="number"&&i($.editor)}e.isEditorIdentifier=S;var O;(function(L){L[L.UNKNOWN=0]="UNKNOWN",L[L.REPLACE=1]="REPLACE",L[L.MOVE=2]="MOVE",L[L.UNPIN=3]="UNPIN"})(O=e.EditorCloseContext||(e.EditorCloseContext={}));var U;(function(L){L[L.GROUP_ACTIVE=0]="GROUP_ACTIVE",L[L.GROUP_INDEX=1]="GROUP_INDEX",L[L.GROUP_LOCKED=2]="GROUP_LOCKED",L[L.EDITOR_OPEN=3]="EDITOR_OPEN",L[L.EDITOR_CLOSE=4]="EDITOR_CLOSE",L[L.EDITOR_MOVE=5]="EDITOR_MOVE",L[L.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",L[L.EDITOR_LABEL=7]="EDITOR_LABEL",L[L.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",L[L.EDITOR_PIN=9]="EDITOR_PIN",L[L.EDITOR_STICKY=10]="EDITOR_STICKY",L[L.EDITOR_DIRTY=11]="EDITOR_DIRTY",L[L.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(U=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var M;(function(L){L[L.PRIMARY=1]="PRIMARY",L[L.SECONDARY=2]="SECONDARY",L[L.BOTH=3]="BOTH",L[L.ANY=4]="ANY"})(M=e.SideBySideEditor||(e.SideBySideEditor={}));class A{getOriginalUri($,H){if(!$)return;if(p($))return e.EditorResourceAccessor.getOriginalUri($.result,H);if(H?.supportSideBySide){const{primary:J,secondary:Y}=this.getSideEditors($);if(J&&Y){if(H?.supportSideBySide===M.BOTH)return{primary:this.getOriginalUri(J,{filterByScheme:H.filterByScheme}),secondary:this.getOriginalUri(Y,{filterByScheme:H.filterByScheme})};if(H?.supportSideBySide===M.ANY)return this.getOriginalUri(J,{filterByScheme:H.filterByScheme})??this.getOriginalUri(Y,{filterByScheme:H.filterByScheme});$=H.supportSideBySide===M.PRIMARY?J:Y}}if(v($)||h($)||p($))return;const j=r($)?$.preferredResource:$.resource;return!j||!H||!H.filterByScheme?j:this.filterUri(j,H.filterByScheme)}getSideEditors($){return n($)||h($)?{primary:$.primary,secondary:$.secondary}:a($)||v($)?{primary:$.modified,secondary:$.original}:{primary:void 0,secondary:void 0}}getCanonicalUri($,H){if(!$)return;if(p($))return e.EditorResourceAccessor.getCanonicalUri($.result,H);if(H?.supportSideBySide){const{primary:J,secondary:Y}=this.getSideEditors($);if(J&&Y){if(H?.supportSideBySide===M.BOTH)return{primary:this.getCanonicalUri(J,{filterByScheme:H.filterByScheme}),secondary:this.getCanonicalUri(Y,{filterByScheme:H.filterByScheme})};if(H?.supportSideBySide===M.ANY)return this.getCanonicalUri(J,{filterByScheme:H.filterByScheme})??this.getCanonicalUri(Y,{filterByScheme:H.filterByScheme});$=H.supportSideBySide===M.PRIMARY?J:Y}}if(v($)||h($)||p($))return;const j=$.resource;return!j||!H||!H.filterByScheme?j:this.filterUri(j,H.filterByScheme)}filterUri($,H){if(Array.isArray(H)){if(H.some(j=>$.scheme===j))return $}else if(H===$.scheme)return $}}e.EditorResourceAccessor=new A;var B;(function(L){L[L.LEFT=0]="LEFT",L[L.RIGHT=1]="RIGHT"})(B=e.CloseDirection||(e.CloseDirection={}));class x{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start($){const H=this.instantiationService=$.get(y.IInstantiationService);for(const[j,J]of this.editorSerializerConstructors)this.createEditorSerializer(j,J,H);this.editorSerializerConstructors.clear()}createEditorSerializer($,H,j){const J=j.createInstance(H);this.editorSerializerInstances.set($,J)}registerFileEditorFactory($){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=$}getFileEditorFactory(){return(0,t.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer($,H){if(this.editorSerializerConstructors.has($)||this.editorSerializerInstances.has($))throw new Error(`A editor serializer with type ID '${$}' was already registered.`);return this.instantiationService?this.createEditorSerializer($,H,this.instantiationService):this.editorSerializerConstructors.set($,H),(0,P.toDisposable)(()=>{this.editorSerializerConstructors.delete($),this.editorSerializerInstances.delete($)})}getEditorSerializer($){return this.editorSerializerInstances.get(typeof $=="string"?$:$.typeId)}}C.Registry.add(e.EditorExtensions.EditorFactory,new x);async function N(L,$){if(!L||!L.length)return[];const H=await Promise.all(L.map(async j=>{const J=D.URI.revive(j.fileUri);if(!J||!await $.canHandleResource(J))return;let he=j.exists,ve=j.type;if(typeof he!="boolean"||typeof ve!="number")try{ve=(await $.stat(J)).isDirectory?E.FileType.Directory:E.FileType.Unknown,he=!0}catch{he=!1}if(!he&&j.openOnlyIfExists||ve===E.FileType.Directory)return;const ne={...j.options,pinned:!0};let pe;return he?pe={resource:J,options:ne}:pe={resource:J,options:ne,forceUntitled:!0},pe}));return(0,I.coalesce)(H)}e.pathsToEditors=N;var K;(function(L){L[L.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",L[L.SEQUENTIAL=1]="SEQUENTIAL"})(K=e.EditorsOrder||(e.EditorsOrder={}));function X(L){const $=L;if(!$)return!1;const H=$;if(H.modified)return X(H.modified);const j=$;return!!(j.contributionsState&&j.viewState&&Array.isArray(j.cursorState))}e.isTextEditorViewState=X}),define(De[88],Ie([1,0,12,2]),function(Z,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function D(C,E){return C.scheme===u.Schemas.http||C.scheme===u.Schemas.https?C:(E&&E.authority&&E.isRemote&&C.scheme===u.Schemas.file&&(C=t.URI.from({scheme:u.Schemas.vscodeRemote,authority:E.authority,path:C.path})),t.URI.from({scheme:u.Schemas.https,authority:`${C.scheme}+${P(C.authority)}.${e.webviewRootResourceAuthority}`,path:C.path,fragment:C.fragment,query:C.query}))}e.asWebviewUri=D;function P(C){return C.replace(/./g,E=>{const I=E.charCodeAt(0);return I>=97&&I<=122||I>=65&&I<=90||I>=48&&I<=57?E:"-"+I.toString(16).padStart(4,"0")})}function y(C){return C.replace(/-([0-9a-f]{4})/g,(E,I)=>String.fromCharCode(parseInt(I,16)))}e.decodeAuthority=y}),define(De[210],Ie([1,0,4,6,88]),function(Z,e,u,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class P{constructor(C,E,I){this._proxy=C,this._editors=E,this._remoteInfo=I,this._handlePool=0,this._disposables=new t.DisposableStore,this._insets=new Map,this._disposables.add(E.onDidChangeVisibleTextEditors(()=>{const R=E.getVisibleTextEditors();for(const k of this._insets.values())R.indexOf(k.editor)<0&&k.inset.dispose()}))}dispose(){this._insets.forEach(C=>C.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(C,E,I,R,k){let _;for(const p of this._editors.getVisibleTextEditors(!0))if(p.value===C){_=p;break}if(!_)throw new Error("not a visible editor");const T=this,w=this._handlePool++,b=new u.Emitter,v=new u.Emitter,h=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(p){return(0,D.asWebviewUri)(p,T._remoteInfo)}get cspSource(){return D.webviewGenericCspSource}set options(p){this._options=p,T._proxy.$setOptions(w,p)}get options(){return this._options}set html(p){this._html=p,T._proxy.$setHtml(w,p)}get html(){return this._html}get onDidReceiveMessage(){return b.event}postMessage(p){return T._proxy.$postMessage(w,p)}},g=new class{constructor(){this.editor=C,this.line=E,this.height=I,this.webview=h,this.onDidDispose=v.event}dispose(){T._insets.has(w)&&(T._insets.delete(w),T._proxy.$disposeEditorInset(w),v.fire(),v.dispose(),b.dispose())}};return this._proxy.$createEditorInset(w,_.id,_.value.document.uri,E+1,I,R||{},k.identifier,k.extensionLocation),this._insets.set(w,{editor:C,inset:g,onDidReceiveMessage:b}),g}$onDidDispose(C){const E=this._insets.get(C);E&&E.inset.dispose()}$onDidReceiveMessage(C,E){this._insets.get(C)?.onDidReceiveMessage.fire(E)}}e.ExtHostEditorInsets=P}),define(De[126],Ie([1,0,4,18,178]),function(Z,e,u,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class P{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new u.Emitter,this._onExit=new u.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(C){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=C}onEvent(C){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=C}onRequest(C){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=C}sendResponse(C){C.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${C.command}`)):this.internalSend("response",C)}sendRequest(C,E,I,R){const k={command:C};if(E&&Object.keys(E).length>0&&(k.arguments=E),this.internalSend("request",k),typeof R=="number"){const _=setTimeout(()=>{clearTimeout(_);const T=this.pendingRequests.get(k.seq);if(T){this.pendingRequests.delete(k.seq);const w={type:"response",seq:0,request_seq:k.seq,success:!1,command:C,message:(0,D.localize)(0,null,R,C)};T(w)}},R)}return I&&this.pendingRequests.set(k.seq,I),k.seq}acceptMessage(C){this.messageCallback?this.messageCallback(C):(this.queue.push(C),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(C,E){return C.type!=="event"||E.type!=="event"}async processQueue(){let C;for(;this.queue.length;){if((!C||this.needsTaskBoundaryBetween(this.queue[0],C))&&await(0,t.timeout)(0),C=this.queue.shift(),!C)return;switch(C.type){case"event":this.eventCallback?.(C);break;case"request":this.requestCallback?.(C);break;case"response":{const E=C,I=this.pendingRequests.get(E.request_seq);I&&(this.pendingRequests.delete(E.request_seq),I(E));break}}}}internalSend(C,E){E.type=C,E.seq=this.sequence++,this.sendMessage(E)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const C=new Map;this.pendingRequests.forEach((E,I)=>C.set(I,E)),await(0,t.timeout)(500),C.forEach((E,I)=>{E({type:"response",seq:0,request_seq:I,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(I)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=P}),define(De[211],Ie([1,0,179,52,3]),function(Z,e,u,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerUiMessage=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ACCESS_TYPE=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.DEBUG_SERVICE_ID=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.DEBUG_SERVICE_ID="debugService",e.CONTEXT_DEBUG_TYPE=new t.RawContextKey("debugType",void 0,{type:"string",description:u.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new t.RawContextKey("debugConfigurationType",void 0,{type:"string",description:u.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new t.RawContextKey("debugState","inactive",{type:"string",description:u.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new t.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:u.localize(3,null)}),e.CONTEXT_IN_DEBUG_MODE=new t.RawContextKey("inDebugMode",!1,{type:"boolean",description:u.localize(4,null)}),e.CONTEXT_IN_DEBUG_REPL=new t.RawContextKey("inDebugRepl",!1,{type:"boolean",description:u.localize(5,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new t.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:u.localize(6,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new t.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:u.localize(7,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new t.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:u.localize(8,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new t.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:u.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new t.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:u.localize(10,null)}),e.CONTEXT_VARIABLES_FOCUSED=new t.RawContextKey("variablesFocused",!0,{type:"boolean",description:u.localize(11,null)}),e.CONTEXT_EXPRESSION_SELECTED=new t.RawContextKey("expressionSelected",!1,{type:"boolean",description:u.localize(12,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new t.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:u.localize(13,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new t.RawContextKey("callStackItemType",void 0,{type:"string",description:u.localize(14,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new t.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:u.localize(15,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new t.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:u.localize(16,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new t.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:u.localize(17,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new t.RawContextKey("watchItemType",void 0,{type:"string",description:u.localize(18,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new t.RawContextKey("canViewMemory",void 0,{type:"boolean",description:u.localize(19,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new t.RawContextKey("breakpointItemType",void 0,{type:"string",description:u.localize(20,null)}),e.CONTEXT_BREAKPOINT_ACCESS_TYPE=new t.RawContextKey("breakpointAccessType",void 0,{type:"string",description:u.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new t.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:u.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new t.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:u.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new t.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:u.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new t.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:u.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new t.RawContextKey("stepBackSupported",!1,{type:"boolean",description:u.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new t.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:u.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new t.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:u.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new t.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:u.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new t.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:u.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new t.RawContextKey("breakpointsExist",!1,{type:"boolean",description:u.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new t.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:u.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new t.RawContextKey("debugExtensionAvailable",!1,{type:"boolean",description:u.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new t.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:u.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new t.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:u.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new t.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:u.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new t.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:u.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new t.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:u.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new t.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:u.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new t.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:u.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new t.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:u.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new t.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:u.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new t.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:u.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new t.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:u.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new t.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:u.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new t.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:u.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new t.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:u.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new t.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:u.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new t.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:u.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new t.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:u.localize(50,null)});const P=_=>u.localize(51,null,_);e.debuggerDisabledMessage=P,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:u.localize(52,null)};var y;(function(_){_[_.Inactive=0]="Inactive",_[_.Initializing=1]="Initializing",_[_.Stopped=2]="Stopped",_[_.Running=3]="Running"})(y=e.State||(e.State={}));function C(_){switch(_){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=C;var E;(function(_){_[_.Valid=0]="Valid",_[_.Unreadable=1]="Unreadable",_[_.Error=2]="Error"})(E=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var I;(function(_){_[_.Initial=1]="Initial",_[_.Dynamic=2]="Dynamic"})(I=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var R;(function(_){_.UnverifiedBreakpoints="unverifiedBreakpoints"})(R=e.DebuggerUiMessage||(e.DebuggerUiMessage={})),e.IDebugService=(0,D.createDecorator)(e.DEBUG_SERVICE_ID);var k;(function(_){_[_.CONDITION=0]="CONDITION",_[_.HIT_COUNT=1]="HIT_COUNT",_[_.LOG_MESSAGE=2]="LOG_MESSAGE"})(k=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(De[212],Ie([1,0,8,2,9,24,12]),function(Z,e,u,t,D,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const C=/{([^}]+)}/g;function E(s,i,r){return s.replace(C,function(n,a){return i&&a.length>0&&a[0]!=="_"?n:r&&r.hasOwnProperty(a)?r[a]:n})}e.formatPII=E;function I(s){const i={};for(const r of Object.keys(s))r.startsWith("!")||(i[r]=s[r]);return i}e.filterExceptionsFromTelemetry=I;function R(s){return s.configuration.request==="attach"&&!k(s)&&(!s.parentSession||R(s.parentSession))}e.isSessionAttach=R;function k(s){let i=s.configuration.type;if(!!i)return i==="vslsShare"&&(i=s.configuration.adapterProxy.configuration.type),(0,u.equalsIgnoreCase)(i,"extensionhost")||(0,u.equalsIgnoreCase)(i,"pwa-extensionhost")?s:s.parentSession?k(s.parentSession):void 0}e.getExtensionHostDebugSession=k;function _(s){return s.type&&(s.label||s.program||s.runtime)}e.isDebuggerMainContribution=_;function T(s,i,r){let n,a=0;const d=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let f=null;for(;f=d.exec(s);){const S=f.index+1,O=S+f[0].length;if(S<=i&&O>=r){n=f[0],a=S;break}}if(n){const S=/\w+/g;let O=null;for(;(O=S.exec(n))&&!(O.index+1+a+O[0].length>=r););O&&(n=n.substring(0,S.lastIndex))}return n?{start:a,end:a+n.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=T;const w=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function b(s){return!!(s&&s.match(w))}e.isUri=b;function v(s){if(typeof s.path=="string"&&!(typeof s.sourceReference=="number"&&s.sourceReference>0)){if(b(s.path))return t.URI.parse(s.path);if((0,D.isAbsolute)(s.path))return t.URI.file(s.path)}return s.path}function h(s){if(typeof s.path=="object"){const i=t.URI.revive(s.path);if(i)return i.scheme===y.Schemas.file?i.fsPath:i.toString()}return s.path}function g(s,i){const r=i?v:h,n=(0,P.deepClone)(s);return o(n,(a,d)=>{a&&d&&(d.path=r(d))}),n}e.convertToDAPaths=g;function p(s,i){const r=i?v:h,n=(0,P.deepClone)(s);return o(n,(a,d)=>{!a&&d&&(d.path=r(d))}),n}e.convertToVSCPaths=p;function o(s,i){switch(s.type){case"event":{const r=s;switch(r.event){case"output":i(!1,r.body.source);break;case"loadedSource":i(!1,r.body.source);break;case"breakpoint":i(!1,r.body.breakpoint.source);break;default:break}break}case"request":{const r=s;switch(r.command){case"setBreakpoints":i(!0,r.arguments.source);break;case"breakpointLocations":i(!0,r.arguments.source);break;case"source":i(!0,r.arguments.source);break;case"gotoTargets":i(!0,r.arguments.source);break;case"launchVSCode":r.arguments.args.forEach(n=>i(!1,n));break;default:break}break}case"response":{const r=s;if(r.success&&r.body)switch(r.command){case"stackTrace":r.body.stackFrames.forEach(n=>i(!1,n.source));break;case"loadedSources":r.body.sources.forEach(n=>i(!1,n));break;case"scopes":r.body.scopes.forEach(n=>i(!1,n.source));break;case"setFunctionBreakpoints":r.body.breakpoints.forEach(n=>i(!1,n.source));break;case"setBreakpoints":r.body.breakpoints.forEach(n=>i(!1,n.source));break;case"disassemble":r.body?.instructions.forEach(a=>i(!1,a.location));break;default:break}break}}}function m(s){return s.filter(i=>!i.presentation?.hidden).sort((i,r)=>i.presentation?r.presentation?i.presentation.group?r.presentation.group?i.presentation.group!==r.presentation.group?i.presentation.group.localeCompare(r.presentation.group):c(i.presentation.order,r.presentation.order):-1:r.presentation.group?1:c(i.presentation.order,r.presentation.order):-1:r.presentation?1:0)}e.getVisibleAndSorted=m;function c(s,i){return typeof s!="number"?typeof i!="number"?0:1:typeof i!="number"?-1:s-i}async function l(s,i){const r=s.getValue("debug.saveBeforeStart",{overrideIdentifier:i.activeTextEditorLanguageId});if(r!=="none"&&(await i.saveAll(),r==="allEditorsInActiveGroup")){const n=i.activeEditorPane;n&&n.input.resource?.scheme===y.Schemas.untitled&&await i.save({editor:n.input,groupId:n.group.id})}await s.reloadConfiguration()}e.saveAllBeforeDebugStart=l}),define(De[213],Ie([1,0,29,44,180,214,9,8,24,11,84,126]),function(Z,e,u,t,D,P,y,C,E,I,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class _ extends k.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(g,p){this.outputStream=p,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,g.on("data",o=>this.handleData(o))}sendMessage(g){if(this.outputStream){const p=JSON.stringify(g);this.outputStream.write(`Content-Length: ${Buffer.byteLength(p,"utf8")}${_.TWO_CRLF}${p}`,"utf8")}}handleData(g){for(this.rawData=Buffer.concat([this.rawData,g]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const p=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,p.length>0)try{this.acceptMessage(JSON.parse(p))}catch(o){this._onError.fire(new Error((o.message||o)+`
`+p))}continue}}else{const p=this.rawData.indexOf(_.TWO_CRLF);if(p!==-1){const m=this.rawData.toString("utf8",0,p).split(_.HEADER_LINESEPARATOR);for(const c of m){const l=c.split(_.HEADER_FIELDSEPARATOR);l[0]==="Content-Length"&&(this.contentLength=Number(l[1]))}this.rawData=this.rawData.slice(p+_.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=_,_.TWO_CRLF=`\r
\r
`,_.HEADER_LINESEPARATOR=/\r?\n/,_.HEADER_FIELDSEPARATOR=/: */;class T extends _{startSession(){return new Promise((g,p)=>{let o=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),g(),o=!0}),this.socket.on("close",()=>{o?this._onError.fire(new Error("connection closed")):p(new Error("connection closed"))}),this.socket.on("error",m=>{o?this._onError.fire(m):p(m)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=T;class w extends T{constructor(g){super();this.adapterServer=g}createConnection(g){return P.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",g)}}e.SocketDebugAdapter=w;class b extends T{constructor(g){super();this.adapterServer=g}createConnection(g){return P.createConnection(this.adapterServer.path,g)}}e.NamedPipeDebugAdapter=b;class v extends _{constructor(g,p,o){super();this.adapterExecutable=g,this.debugType=p,this.outputService=o}async startSession(){const g=this.adapterExecutable.command,p=this.adapterExecutable.args,o=this.adapterExecutable.options||{};try{if(g)if(y.isAbsolute(g)){if(!await u.Promises.exists(g))throw new Error(D.localize(0,null,g))}else g.indexOf("/")<0&&g.indexOf("\\")<0;else throw new Error(D.localize(1,null,this.debugType));let m=process.env;if(o.env&&Object.keys(o.env).length>0&&(m=E.mixin(E.deepClone(process.env),o.env)),g==="node")if(Array.isArray(p)&&p.length>0){const l=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,s={env:m,execArgv:l?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};o.cwd&&(s.cwd=o.cwd);const i=t.fork(p[0],p.slice(1),s);if(!i.pid)throw new Error(D.localize(2,null,p[0]));this.serverProcess=i}else throw new Error(D.localize(3,null));else{const l={env:m};o.cwd&&(l.cwd=o.cwd),this.serverProcess=t.spawn(g,p,l)}this.serverProcess.on("error",l=>{this._onError.fire(l)}),this.serverProcess.on("exit",(l,s)=>{this._onExit.fire(l)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",l=>{this._onError.fire(l)}),this.serverProcess.stdin.on("error",l=>{this._onError.fire(l)});const c=this.outputService;if(c){const l=s=>s.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",s=>{c.getChannel(R.ExtensionsChannelId)?.append(l(s))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(m){this._onError.fire(m)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),I.isWindows?new Promise((g,p)=>{const o=t.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(m,c,l){if(m)return p(m)});o.on("exit",g),o.on("error",p)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(g,p){if(!g)return;const o=Object.create(null);g.runtime&&(g.runtime.indexOf("./")===0?o.runtime=y.join(p,g.runtime):o.runtime=g.runtime),g.runtimeArgs&&(o.runtimeArgs=g.runtimeArgs),g.program&&(y.isAbsolute(g.program)?o.program=g.program:o.program=y.join(p,g.program)),g.args&&(o.args=g.args);const m=g;return m.win&&(o.win=v.extract(m.win,p)),m.winx86&&(o.winx86=v.extract(m.winx86,p)),m.windows&&(o.windows=v.extract(m.windows,p)),m.osx&&(o.osx=v.extract(m.osx,p)),m.linux&&(o.linux=v.extract(m.linux,p)),o}static platformAdapterExecutable(g,p){let o=Object.create(null);p=p.toLowerCase();for(const r of g)if(r.contributes){const n=r.contributes.debuggers;n&&n.length>0&&n.filter(a=>typeof a.type=="string"&&C.equalsIgnoreCase(a.type,p)).forEach(a=>{const d=v.extract(a,r.extensionLocation.fsPath);o=E.mixin(o,d,r.isBuiltin)})}let m;I.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?m=o.winx86||o.win||o.windows:I.isWindows?m=o.win||o.windows:I.isMacintosh?m=o.osx:I.isLinux&&(m=o.linux),m=m||o;const c=m.program||o.program,l=m.args||o.args,s=m.runtime||o.runtime,i=m.runtimeArgs||o.runtimeArgs;if(s)return{type:"executable",command:s,args:(i||[]).concat(typeof c=="string"?[c]:[]).concat(l||[])};if(c)return{type:"executable",command:c,args:l||[]}}}e.ExecutableDebugAdapter=v}),define(De[215],Ie([1,0,44,31,11]),function(Z,e,u,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=void 0;function P(I,R){return new Promise((k,_)=>{let T="";const w=u.spawn(I,R);w.pid&&w.stdout.on("data",b=>{T+=b.toString()}),w.on("error",b=>{_(b)}),w.on("close",b=>{k(T)})})}async function y(I){if(I)if(D.isWindows){const R=await new Promise((k,_)=>{Z(["windows-process-tree"],k,_)});return new Promise(k=>{R.getProcessTree(I,_=>{k(!!_&&_.children.length>0)})})}else return P("/usr/bin/pgrep",["-lP",String(I)]).then(R=>{const k=R.trim();return!(k.length===0||k.indexOf(" tmux")>=0)},R=>!0);return Promise.resolve(!0)}e.hasChildProcesses=y;var C;(function(I){I[I.cmd=0]="cmd",I[I.powershell=1]="powershell",I[I.bash=2]="bash"})(C||(C={}));function E(I,R,k,_,T){I=I.trim().toLowerCase();let w;I.indexOf("powershell")>=0||I.indexOf("pwsh")>=0?w=1:I.indexOf("cmd.exe")>=0?w=0:I.indexOf("bash")>=0?w=2:D.isWindows?w=0:w=2;let b,v=" ";switch(w){case 1:if(b=h=>(h=h.replace(/\'/g,"''"),h.length>0&&h.charAt(h.length-1)==="\\"?`'${h}\\'`:`'${h}'`),_){const h=(0,t.getDriveLetter)(_);h&&(v+=`${h}:; `),v+=`cd ${b(_)}; `}if(T)for(const h in T){const g=T[h];g===null?v+=`Remove-Item env:${h}; `:v+=`\${env:${h}}='${g}'; `}if(R.length>0){const h=R.shift(),g=k?h:b(h);v+=g[0]==="'"?`& ${g} `:`${g} `;for(const p of R)v+=p==="<"||p===">"||k?p:b(p),v+=" "}break;case 0:if(b=h=>(h=h.replace(/\"/g,'""'),h=h.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(g=>h.includes(g))||h.length===0?`"${h}"`:h),_){const h=(0,t.getDriveLetter)(_);h&&(v+=`${h}: && `),v+=`cd ${b(_)} && `}if(T){v+='cmd /C "';for(const h in T){let g=T[h];g===null?v+=`set "${h}=" && `:(g=g.replace(/[&^|<>]/g,p=>`^${p}`),v+=`set "${h}=${g}" && `)}}for(const h of R)v+=h==="<"||h===">"||k?h:b(h),v+=" ";T&&(v+='"');break;case 2:{b=g=>(g=g.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),g.length===0?'""':g);const h=g=>/[^\w@%\/+=,.:^-]/.test(g)?`'${g.replace(/'/g,"'\\''")}'`:g;if(_&&(v+=`cd ${b(_)} ; `),T){v+="/usr/bin/env";for(const g in T){const p=T[g];p===null?v+=` -u ${h(g)}`:v+=` ${h(`${g}=${p}`)}`}v+=" "}for(const g of R)v+=g==="<"||g===">"||k?g:b(g),v+=" ";break}}return v}e.prepareCommand=E}),define(De[127],Ie([1,0,23,36,59,100,12,9,11,52]),function(Z,e,u,t,D,P,y,C,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor";var R;(function(n){n[n.Markup=1]="Markup",n[n.Code=2]="Code"})(R=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",P.Mimes.latex,P.Mimes.markdown,"image/png","image/jpeg",P.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[P.Mimes.latex,P.Mimes.markdown,"application/json",P.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var k;(function(n){n[n.Running=1]="Running",n[n.Idle=2]="Idle"})(k=e.NotebookRunState||(e.NotebookRunState={}));var _;(function(n){n[n.Unconfirmed=1]="Unconfirmed",n[n.Pending=2]="Pending",n[n.Executing=3]="Executing"})(_=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var T;(function(n){n[n.WithHardKernelDependency=0]="WithHardKernelDependency",n[n.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",n[n.Pure=2]="Pure",n[n.Never=3]="Never"})(T=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var w;(function(n){n.Always="always",n.Never="never",n.Optional="optional"})(w=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var b;(function(n){n[n.ModelChange=1]="ModelChange",n[n.Move=2]="Move",n[n.ChangeCellLanguage=5]="ChangeCellLanguage",n[n.Initialize=6]="Initialize",n[n.ChangeCellMetadata=7]="ChangeCellMetadata",n[n.Output=8]="Output",n[n.OutputItem=9]="OutputItem",n[n.ChangeCellContent=10]="ChangeCellContent",n[n.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",n[n.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",n[n.ChangeCellMime=13]="ChangeCellMime",n[n.Unknown=100]="Unknown"})(b=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var v;(function(n){n[n.Handle=0]="Handle",n[n.Index=1]="Index"})(v=e.SelectionStateType||(e.SelectionStateType={}));var h;(function(n){n[n.Replace=1]="Replace",n[n.Output=2]="Output",n[n.Metadata=3]="Metadata",n[n.CellLanguage=4]="CellLanguage",n[n.DocumentMetadata=5]="DocumentMetadata",n[n.Move=6]="Move",n[n.OutputItems=7]="OutputItems",n[n.PartialMetadata=8]="PartialMetadata",n[n.PartialInternalMetadata=9]="PartialInternalMetadata"})(h=e.CellEditType||(e.CellEditType={}));var g;(function(n){n.scheme=y.Schemas.vscodeNotebookCell;const a=["W","X","Y","Z","a","b","c","d","e","f"],d=new RegExp(`^[${a.join("")}]+`),f=7;function S(N,K){const X=K.toString(f),$=`${X.length<a.length?a[X.length-1]:"z"}${X}s${(0,u.encodeBase64)(u.VSBuffer.fromString(N.scheme),!0,!0)}`;return N.with({scheme:n.scheme,fragment:$})}n.generate=S;function O(N){if(N.scheme!==n.scheme)return;const K=N.fragment.indexOf("s");if(K<0)return;const X=parseInt(N.fragment.substring(0,K).replace(d,""),f),L=(0,u.decodeBase64)(N.fragment.substring(K+1)).toString();if(!isNaN(X))return{handle:X,notebook:N.with({scheme:L,fragment:null})}}n.parse=O;const U=/^(\d{8,})(\w[\w\d+.-]*)$/;function M(N,K){return N.with({scheme:y.Schemas.vscodeNotebookCellOutput,fragment:`op${K??""},${N.scheme!==y.Schemas.file?N.scheme:""}`})}n.generateCellOutputUri=M;function A(N){if(N.scheme!==y.Schemas.vscodeNotebookCellOutput)return;const K=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(N.fragment);if(!K)return;const X=K[1]&&K[1]!==""?K[1]:void 0,L=K[2];return{outputId:X,notebook:N.with({scheme:L||y.Schemas.file,fragment:null})}}n.parseCellOutputUri=A;function B(N,K,X){return N.with({scheme:X,fragment:`ch${K.toString().padStart(7,"0")}${N.scheme!==y.Schemas.file?N.scheme:""}`})}n.generateCellUri=B;function x(N,K){if(N.scheme!==K)return;const X=U.exec(N.fragment);return X?{handle:Number(X[1]),notebook:N.with({scheme:N.fragment.substring(X[0].length)||y.Schemas.file,fragment:null})}:void 0}n.parseCellUri=x})(g=e.CellUri||(e.CellUri={}));const p=n=>E.isWindows?n.replace(/\//g,"\\"):n;class o{constructor(a=[],d=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=d,this.order=[...new Set(a)].map(f=>({pattern:f,matches:t.parse(p(f))}))}sort(a){const d=new Map(D.Iterable.map(a,S=>[S,p(S)]));let f=[];for(const{matches:S}of this.order)for(const[O,U]of d)if(S(U)){f.push(O),d.delete(O);break}return d.size&&(f=f.concat([...d.keys()].sort((S,O)=>this.defaultOrder.indexOf(S)-this.defaultOrder.indexOf(O)))),f}prioritize(a,d){const f=this.findIndex(a);if(f===-1){this.order.unshift({pattern:a,matches:t.parse(p(a))});return}const S=new Set(d.map(U=>this.findIndex(U,f)));S.delete(-1);const O=Array.from(S).sort();this.order.splice(f+1,0,...O.map(U=>this.order[U]));for(let U=O.length-1;U>=0;U--)this.order.splice(O[U],1)}toArray(){return this.order.map(a=>a.pattern)}findIndex(a,d=this.order.length){const f=p(a);for(let S=0;S<d;S++)if(this.order[S].matches(f))return S;return-1}}e.MimeTypeDisplayOrder=o;function m(n,a,d,f=(S,O)=>S===O){const S=[];function O(A,B,x){if(B===0&&x.length===0)return;const N=S[S.length-1];N&&N.start+N.deleteCount===A?(N.deleteCount+=B,N.toInsert.push(...x)):S.push({start:A,deleteCount:B,toInsert:x})}let U=0,M=0;for(;;){if(U===n.length){O(U,0,a.slice(M));break}if(M===a.length){O(U,n.length-U,[]);break}const A=n[U],B=a[M];if(f(A,B)){U+=1,M+=1;continue}d(B)?(O(U,1,[]),U+=1):(O(U,0,[B]),M+=1)}return S}e.diff=m,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new I.RawContextKey("notebookEditorCursorAtBoundary","none");var c;(function(n){n.default="default",n.option="option"})(c=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function l(n){const a=n;return!!((typeof a.include=="string"||t.isRelativePattern(a.include))&&(typeof a.exclude=="string"||t.isRelativePattern(a.exclude)))}e.isDocumentExcludePattern=l;function s(n,a,d){if(Array.isArray(n.viewType)&&n.viewType.indexOf(a)>=0||n.viewType===a)return!0;if(n.filenamePattern){const f=l(n.filenamePattern)?n.filenamePattern.include:n.filenamePattern,S=l(n.filenamePattern)?n.filenamePattern.exclude:void 0;if(t.match(f,(0,C.basename)(d.fsPath).toLowerCase()))return!(S&&t.match(S,(0,C.basename)(d.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=s,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily"};var i;(function(n){n[n.Left=1]="Left",n[n.Right=2]="Right"})(i=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class r{static create(a){return`${r._prefix}${a}`}static parse(a){if(a.startsWith(r._prefix))return a.substring(r._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=r,r._prefix="notebook/"}),define(De[216],Ie([1,0,3]),function(Z,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var t;(function(D){D[D.Output=1]="Output",D[D.OutputItems=2]="OutputItems",D[D.ExecutionState=3]="ExecutionState"})(t=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,u.createDecorator)("INotebookExecutionService")}),define(De[217],Ie([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function u(y){return[...y.entries()]}e.serializeEnvironmentVariableCollection=u;function t(y){return new Map(y)}e.deserializeEnvironmentVariableCollection=t;function D(y){return Array.from(y.entries()).map(C=>[C[0],u(C[1].map)])}e.serializeEnvironmentVariableCollections=D;function P(y){return new Map(y.map(C=>[C[0],{map:t(C[1])}]))}e.deserializeEnvironmentVariableCollections=P}),define(De[65],Ie([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var u;(function(P){P.Delimiter="\0"})(u=e.TestIdPathParts||(e.TestIdPathParts={}));var t;(function(P){P[P.IsSame=0]="IsSame",P[P.Disconnected=1]="Disconnected",P[P.IsChild=2]="IsChild",P[P.IsParent=3]="IsParent"})(t=e.TestPosition||(e.TestPosition={}));class D{constructor(y,C=y.length){if(this.path=y,this.viewEnd=C,y.length===0||C<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(y,C,E=y.parent){if(y.id===C)return new D([C]);const I=[y.id];for(let R=E;R&&R.id!==C;R=R.parent)I.push(R.id);return I.push(C),new D(I.reverse())}static isRoot(y){return!y.includes("\0")}static root(y){const C=y.indexOf("\0");return C===-1?y:y.slice(0,C)}static fromString(y){return new D(y.split("\0"))}static join(y,C){return new D([...y.path,C])}static joinToString(y,C){return y.toString()+"\0"+C}static compare(y,C){return y===C?0:C.startsWith(y+"\0")?2:y.startsWith(C+"\0")?3:1}get parentId(){return this.viewEnd>1?new D(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let y=1;y<=this.viewEnd;y++)yield new D(this.path,y)}compare(y){if(typeof y=="string")return D.compare(this.toString(),y);for(let C=0;C<y.viewEnd&&C<this.viewEnd;C++)if(y.path[C]!==this.path[C])return 1;return y.viewEnd>this.viewEnd?2:y.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let y=1;y<this.viewEnd;y++)this.stringifed+="\0",this.stringifed+=this.path[y]}return this.stringifed}}e.TestId=D}),define(De[66],Ie([1,0,2,35]),function(Z,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var D;(function(r){r[r.Unset=0]="Unset",r[r.Queued=1]="Queued",r[r.Running=2]="Running",r[r.Passed=3]="Passed",r[r.Failed=4]="Failed",r[r.Skipped=5]="Skipped",r[r.Errored=6]="Errored"})(D=e.TestResultState||(e.TestResultState={}));var P;(function(r){r[r.Run=2]="Run",r[r.Debug=4]="Debug",r[r.Coverage=8]="Coverage",r[r.HasNonDefaultProfile=16]="HasNonDefaultProfile",r[r.HasConfigurable=32]="HasConfigurable"})(P=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var y;(function(r){r.serialize=n=>({range:n.range.toJSON(),uri:n.uri.toJSON()}),r.deserialize=n=>({range:t.Range.lift(n.range),uri:u.URI.revive(n.uri)})})(y=e.IRichLocation||(e.IRichLocation={}));var C;(function(r){r[r.Error=0]="Error",r[r.Output=1]="Output"})(C=e.TestMessageType||(e.TestMessageType={}));var E;(function(r){r.serialize=n=>({message:n.message,type:0,expected:n.expected,actual:n.actual,location:n.location&&y.serialize(n.location)}),r.deserialize=n=>({message:n.message,type:0,expected:n.expected,actual:n.actual,location:n.location&&y.deserialize(n.location)})})(E=e.ITestErrorMessage||(e.ITestErrorMessage={}));var I;(function(r){r.serialize=n=>({message:n.message,type:1,offset:n.offset,length:n.length,location:n.location&&y.serialize(n.location)}),r.deserialize=n=>({message:n.message,type:1,offset:n.offset,length:n.length,location:n.location&&y.deserialize(n.location)})})(I=e.ITestOutputMessage||(e.ITestOutputMessage={}));var R;(function(r){r.serialize=n=>n.type===0?E.serialize(n):I.serialize(n),r.deserialize=n=>n.type===0?E.deserialize(n):I.deserialize(n)})(R=e.ITestMessage||(e.ITestMessage={}));var k;(function(r){r.serializeWithoutMessages=n=>({state:n.state,duration:n.duration,messages:[]}),r.serialize=n=>({state:n.state,duration:n.duration,messages:n.messages.map(R.serialize)}),r.deserialize=n=>({state:n.state,duration:n.duration,messages:n.messages.map(R.deserialize)})})(k=e.ITestTaskState||(e.ITestTaskState={}));const _="\0",T=(r,n)=>r+_+n;e.namespaceTestTag=T;const w=r=>{const n=r.indexOf(_);return{ctrlId:r.slice(0,n),tagId:r.slice(n+1)}};e.denamespaceTestTag=w;var b;(function(r){r.serialize=n=>({extId:n.extId,label:n.label,tags:n.tags,busy:n.busy,children:void 0,uri:n.uri?.toJSON(),range:n.range?.toJSON()||null,description:n.description,error:n.error,sortText:n.sortText}),r.deserialize=n=>({extId:n.extId,label:n.label,tags:n.tags,busy:n.busy,children:void 0,uri:n.uri?u.URI.revive(n.uri):void 0,range:n.range?t.Range.lift(n.range):null,description:n.description,error:n.error,sortText:n.sortText})})(b=e.ITestItem||(e.ITestItem={}));var v;(function(r){r[r.NotExpandable=0]="NotExpandable",r[r.Expandable=1]="Expandable",r[r.BusyExpanding=2]="BusyExpanding",r[r.Expanded=3]="Expanded"})(v=e.TestItemExpandState||(e.TestItemExpandState={}));var h;(function(r){r.serialize=n=>({controllerId:n.controllerId,expand:n.expand,parent:n.parent,item:b.serialize(n.item)}),r.deserialize=n=>({controllerId:n.controllerId,expand:n.expand,parent:n.parent,item:b.deserialize(n.item)})})(h=e.InternalTestItem||(e.InternalTestItem={}));var g;(function(r){r.serialize=n=>{let a;return n.item&&(a={},n.item.label!==void 0&&(a.label=n.item.label),n.item.tags!==void 0&&(a.tags=n.item.tags),n.item.busy!==void 0&&(a.busy=n.item.busy),n.item.uri!==void 0&&(a.uri=n.item.uri?.toJSON()),n.item.range!==void 0&&(a.range=n.item.range?.toJSON()),n.item.description!==void 0&&(a.description=n.item.description),n.item.error!==void 0&&(a.error=n.item.error),n.item.sortText!==void 0&&(a.sortText=n.item.sortText)),{extId:n.extId,expand:n.expand,item:a}},r.deserialize=n=>{let a;return n.item&&(a={},n.item.label!==void 0&&(a.label=n.item.label),n.item.tags!==void 0&&(a.tags=n.item.tags),n.item.busy!==void 0&&(a.busy=n.item.busy),n.item.range!==void 0&&(a.range=n.item.range?t.Range.lift(n.item.range):null),n.item.description!==void 0&&(a.description=n.item.description),n.item.error!==void 0&&(a.error=n.item.error),n.item.sortText!==void 0&&(a.sortText=n.item.sortText)),{extId:n.extId,expand:n.expand,item:a}}})(g=e.ITestItemUpdate||(e.ITestItemUpdate={}));const p=(r,n)=>{n.expand!==void 0&&(r.expand=n.expand),n.item!==void 0&&(r.item=r.item?Object.assign(r.item,n.item):n.item)};e.applyTestItemUpdate=p;var o;(function(r){r.serializeWithoutMessages=n=>({...h.serialize(n),ownComputedState:n.ownComputedState,computedState:n.computedState,tasks:n.tasks.map(k.serializeWithoutMessages),retired:n.retired}),r.serialize=n=>({...h.serialize(n),ownComputedState:n.ownComputedState,computedState:n.computedState,tasks:n.tasks.map(k.serialize),retired:n.retired})})(o=e.TestResultItem||(e.TestResultItem={}));var m;(function(r){r[r.Function=0]="Function",r[r.Statement=1]="Statement"})(m=e.DetailType||(e.DetailType={}));var c;(function(r){r[r.Add=0]="Add",r[r.Update=1]="Update",r[r.Remove=2]="Remove",r[r.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",r[r.Retire=4]="Retire",r[r.AddTag=5]="AddTag",r[r.RemoveTag=6]="RemoveTag"})(c=e.TestDiffOpType||(e.TestDiffOpType={}));var l;(function(r){r.deserialize=n=>n.op===0?{op:n.op,item:h.deserialize(n.item)}:n.op===1?{op:n.op,item:g.deserialize(n.item)}:n,r.serialize=n=>n.op===0?{op:n.op,item:h.serialize(n.item)}:n.op===1?{op:n.op,item:g.serialize(n.item)}:n})(l=e.TestsDiffOp||(e.TestsDiffOp={}));class s{add(n){}update(n){}remove(n,a){}complete(){}}e.IncrementalChangeCollector=s;class i{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(n){const a=this.createChangeCollector();for(const d of n)switch(d.op){case 0:{const f=h.deserialize(d.item);if(f.parent){if(this.items.has(f.parent)){const S=this.items.get(f.parent);S.children.add(f.item.extId);const O=this.createItem(f,S);this.items.set(f.item.extId,O),a.add(O)}}else{const S=this.createItem(f);this.roots.add(S),this.items.set(f.item.extId,S),a.add(S)}f.expand===2&&this.busyControllerCount++;break}case 1:{const f=g.deserialize(d.item),S=this.items.get(f.extId);if(!S)break;f.expand!==void 0&&(S.expand===2&&this.busyControllerCount--,f.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(S,f),a.update(S);break}case 2:{const f=this.items.get(d.itemId);if(!f)break;f.parent?this.items.get(f.parent).children.delete(f.item.extId):this.roots.delete(f);const S=[[d.itemId]];for(;S.length;)for(const O of S.pop()){const U=this.items.get(O);U&&(S.push(U.children),this.items.delete(O),a.remove(U,U!==f),U.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(d.itemId);break;case 3:this.updatePendingRoots(d.amount);break;case 5:this._tags.set(d.tag.id,d.tag);break;case 6:this._tags.delete(d.id);break}a.complete()}retireTest(n){}updatePendingRoots(n){this.pendingRootCount+=n}createChangeCollector(){return new s}}e.AbstractIncrementalTestCollection=i}),define(De[89],Ie([1,0,18,4,6,48,66,65]),function(Z,e,u,t,D,P,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var E;(function(h){h[h.Upsert=0]="Upsert",h[h.SetTags=1]="SetTags",h[h.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",h[h.RemoveChild=3]="RemoveChild",h[h.SetProp=4]="SetProp",h[h.Bulk=5]="Bulk"})(E=e.TestItemEventOp||(e.TestItemEventOp={}));const I=(h,g)=>h===g,R={range:(h,g)=>h===g?!0:!h||!g?!1:h.equalsRange(g),busy:I,label:I,description:I,error:I,tags:(h,g)=>!(h.length!==g.length||h.some(p=>!g.includes(p)))},k=(h,g)=>{let p;for(const[o,m]of Object.entries(R))m(h[o],g[o])||(p?p[o]=g[o]:p={[o]:g[o]});return p};class _ extends D.Disposable{constructor(g){super();this.options=g,this.debounceSendDiff=this._register(new u.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new t.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}get root(){return this.options.root}set resolveHandler(g){this._resolveHandler=g;for(const p of this.tree.values())this.updateExpandability(p)}collectDiff(){const g=this.diff;return this.diff=[],g}pushDiff(g){const p=this.diff[this.diff.length-1];if(p&&g.op===1){if(p.op===1&&p.item.extId===g.item.extId){(0,y.applyTestItemUpdate)(p.item,g.item);return}if(p.op===0&&p.item.item.extId===g.item.extId){(0,y.applyTestItemUpdate)(p.item,g.item);return}}this.diff.push(g),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(g,p){const o=this.tree.get(g);if(!!o){if((o.expandLevels===void 0||p>o.expandLevels)&&(o.expandLevels=p),o.expand===1){const m=this.resolveChildren(o);return m.isOpen()?this.expandChildren(o,p-1):m.wait().then(()=>this.expandChildren(o,p-1))}else if(o.expand===3)return o.resolveBarrier?.isOpen()===!1?o.resolveBarrier.wait().then(()=>this.expandChildren(o,p-1)):this.expandChildren(o,p-1)}}dispose(){for(const g of this.tree.values())this.options.getApiFor(g.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(g,p){switch(p.op){case 3:this.removeItem(C.TestId.joinToString(g.fullId,p.id));break;case 0:this.upsertItem(p.item,g);break;case 5:for(const o of p.ops)this.onTestItemEvent(g,o);break;case 1:this.diffTagRefs(p.new,p.old,g.fullId.toString());break;case 2:this.updateExpandability(g);break;case 4:this.pushDiff({op:1,item:{extId:g.fullId.toString(),item:p.update}});break;default:(0,P.assertNever)(p)}}upsertItem(g,p){const o=C.TestId.fromExtHostTestItem(g,this.root.id,p?.actual),m=this.options.getApiFor(g);m.parent&&m.parent!==p?.actual&&this.options.getChildren(m.parent).delete(g.id);let c=this.tree.get(o.toString());if(!c){c={fullId:o,actual:g,parent:p?o.parentId:null,expandLevels:p?.expandLevels?p.expandLevels-1:void 0,expand:0},g.tags.forEach(this.incrementTagRefs,this),this.tree.set(c.fullId.toString(),c),this.setItemParent(g,p),this.pushDiff({op:0,item:{parent:c.parent&&c.parent.toString(),controllerId:this.options.controllerId,expand:c.expand,item:this.options.toITestItem(g)}}),this.connectItemAndChildren(g,c,p);return}if(c.actual===g){this.connectItem(g,c,p);return}const l=this.options.getChildren(c.actual),s=c.actual,i=k(this.options.toITestItem(s),this.options.toITestItem(g));this.options.getApiFor(s).listener=void 0,c.actual=g,c.expand=0,i&&(i.hasOwnProperty("tags")&&(this.diffTagRefs(g.tags,s.tags,o.toString()),delete i.tags),this.onTestItemEvent(c,{op:4,update:i})),this.connectItemAndChildren(g,c,p);for(const[r,n]of l)this.options.getChildren(g).get(n.id)||this.removeItem(C.TestId.joinToString(o,n.id))}diffTagRefs(g,p,o){const m=new Set(p.map(c=>c.id));for(const c of g)m.delete(c.id)||this.incrementTagRefs(c);this.pushDiff({op:1,item:{extId:o,item:{tags:g.map(c=>(0,y.namespaceTestTag)(this.options.controllerId,c.id))}}}),m.forEach(this.decrementTagRefs,this)}incrementTagRefs(g){const p=this.tags.get(g.id);p?p.refCount++:(this.tags.set(g.id,{refCount:1}),this.pushDiff({op:5,tag:{id:(0,y.namespaceTestTag)(this.options.controllerId,g.id)}}))}decrementTagRefs(g){const p=this.tags.get(g);p&&!--p.refCount&&(this.tags.delete(g),this.pushDiff({op:6,id:(0,y.namespaceTestTag)(this.options.controllerId,g)}))}setItemParent(g,p){this.options.getApiFor(g).parent=p&&p.actual!==this.root?p.actual:void 0}connectItem(g,p,o){this.setItemParent(g,o);const m=this.options.getApiFor(g);m.parent=o?.actual,m.listener=c=>this.onTestItemEvent(p,c),this.updateExpandability(p)}connectItemAndChildren(g,p,o){this.connectItem(g,p,o);for(const[m,c]of this.options.getChildren(g))this.upsertItem(c,p)}updateExpandability(g){let p;this._resolveHandler?g.resolveBarrier?p=g.resolveBarrier.isOpen()?3:2:p=g.actual.canResolveChildren?1:0:p=0,p!==g.expand&&(g.expand=p,this.pushDiff({op:1,item:{extId:g.fullId.toString(),expand:p}}),p===1&&g.expandLevels!==void 0&&this.resolveChildren(g))}expandChildren(g,p){if(p<0)return;const o=[];for(const[m,c]of this.options.getChildren(g.actual)){const l=this.expand(C.TestId.joinToString(g.fullId,c.id),p);(0,u.isThenable)(l)&&o.push(l)}if(o.length)return Promise.all(o).then(()=>{})}resolveChildren(g){if(g.resolveBarrier)return g.resolveBarrier;if(!this._resolveHandler){const c=new u.Barrier;return c.open(),c}g.expand=2,this.pushExpandStateUpdate(g);const p=g.resolveBarrier=new u.Barrier,o=c=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,c)};let m;try{m=this._resolveHandler(g.actual===this.root?void 0:g.actual)}catch(c){o(c)}return(0,u.isThenable)(m)?m.catch(o).then(()=>{p.open(),this.updateExpandability(g)}):(p.open(),this.updateExpandability(g)),g.resolveBarrier}pushExpandStateUpdate(g){this.pushDiff({op:1,item:{extId:g.fullId.toString(),expand:g.expand}})}removeItem(g){const p=this.tree.get(g);if(!p)throw new Error("attempting to remove non-existent child");this.pushDiff({op:2,itemId:g});const o=[p];for(;o.length;){const m=o.pop();if(!!m){this.options.getApiFor(m.actual).listener=void 0;for(const c of m.actual.tags)this.decrementTagRefs(c.id);this.tree.delete(m.fullId.toString());for(const[c,l]of this.options.getChildren(m.actual))o.push(this.tree.get(C.TestId.joinToString(m.fullId,l.id)))}}}flushDiff(){const g=this.collectDiff();g.length&&this.diffOpEmitter.fire(g)}}e.TestItemCollection=_;class T extends Error{constructor(g){super(`Attempted to insert a duplicate test item ID ${g}`)}}e.DuplicateTestItemError=T;class w extends Error{constructor(g){super(`TestItem with ID "${g}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=w;class b extends Error{constructor(g,p,o){super(`TestItem with ID "${g}" is from controller "${p}" and cannot be added as a child of an item from controller "${o}".`)}}e.MixedTestItemController=b;const v=(h,g,p)=>{let o=new Map;return{get size(){return o.size},forEach(m,c){for(const l of o.values())m.call(c,l,this)},[Symbol.iterator](){return o.entries()},replace(m){const c=new Map,l=new Set(o.keys()),s={op:5,ops:[]};for(const i of m){if(!(i instanceof p))throw new w(i.id);const r=g(i).controllerId;if(r!==h.controllerId)throw new b(i.id,r,h.controllerId);if(c.has(i.id))throw new T(i.id);c.set(i.id,i),l.delete(i.id),s.ops.push({op:0,item:i})}for(const i of l.keys())s.ops.push({op:3,id:i});h.listener?.(s),o=c},add(m){if(!(m instanceof p))throw new w(m.id);o.set(m.id,m),h.listener?.({op:0,item:m})},delete(m){o.delete(m)&&h.listener?.({op:3,id:m})},get(m){return o.get(m)},toJSON(){return Array.from(o.values())}}};e.createTestItemChildren=v}),define(De[128],Ie([1,0,89]),function(Z,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const t=new WeakMap,D=(y,C)=>{const E={controllerId:C};return t.set(y,E),E};e.createPrivateApiFor=D;const P=y=>{const C=t.get(y);if(!C)throw new u.InvalidTestItemError(y?.id||"<unknown>");return C};e.getPrivateApiFor=P}),define(De[218],Ie([1,0,3]),function(Z,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,u.createDecorator)("configurationResolverService");var t;(function(P){P.Unknown="unknown",P.Env="env",P.Config="config",P.Command="command",P.Input="input",P.ExtensionInstallFolder="extensionInstallFolder",P.WorkspaceFolder="workspaceFolder",P.Cwd="cwd",P.WorkspaceFolderBasename="workspaceFolderBasename",P.UserHome="userHome",P.LineNumber="lineNumber",P.SelectedText="selectedText",P.File="file",P.FileWorkspaceFolder="fileWorkspaceFolder",P.RelativeFile="relativeFile",P.RelativeFileDirname="relativeFileDirname",P.FileDirname="fileDirname",P.FileExtname="fileExtname",P.FileBasename="fileBasename",P.FileBasenameNoExtension="fileBasenameNoExtension",P.FileDirnameBasename="fileDirnameBasename",P.ExecPath="execPath",P.ExecInstallFolder="execInstallFolder",P.PathSeparator="pathSeparator"})(t=e.VariableKind||(e.VariableKind={}));class D extends Error{constructor(y,C){super(C);this.variable=y}}e.VariableError=D}),define(De[219],Ie([1,0,9,40,13,24,11,106,183,218,8]),function(Z,e,u,t,D,P,y,C,E,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class k{constructor(T,w,b,v){this._contributedVariables=new Map,this._context=T,this._labelService=w,this._userHomePromise=b,v&&(this._envVariablesPromise=v.then(h=>this.prepareEnv(h)))}prepareEnv(T){if(y.isWindows){const w=Object.create(null);return Object.keys(T).forEach(b=>{w[b.toLowerCase()]=T[b]}),w}return T}resolveWithEnvironment(T,w,b){return this.recursiveResolve({env:this.prepareEnv(T),userHome:void 0},w?w.uri:void 0,b)}async resolveAsync(T,w){const b={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(b,T?T.uri:void 0,w)}async resolveAnyBase(T,w,b,v){const h=P.deepClone(w);y.isWindows&&h.windows?Object.keys(h.windows).forEach(p=>h[p]=h.windows[p]):y.isMacintosh&&h.osx?Object.keys(h.osx).forEach(p=>h[p]=h.osx[p]):y.isLinux&&h.linux&&Object.keys(h.linux).forEach(p=>h[p]=h.linux[p]),delete h.windows,delete h.osx,delete h.linux;const g={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(g,T?T.uri:void 0,h,b,v)}async resolveAnyAsync(T,w,b){return this.resolveAnyBase(T,w,b)}async resolveAnyMap(T,w,b){const v=new Map;return{newConfig:await this.resolveAnyBase(T,w,b,v),resolvedVariables:v}}resolveWithInteractionReplace(T,w,b,v){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(T,w,b,v){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(T,w){if(this._contributedVariables.has(T))throw new Error("Variable "+T+" is contributed twice.");this._contributedVariables.set(T,w)}async recursiveResolve(T,w,b,v,h){if(D.isString(b))return this.resolveString(T,w,b,v,h);if(Array.isArray(b))return Promise.all(b.map(g=>this.recursiveResolve(T,w,g,v,h)));if(D.isObject(b)){const g=Object.create(null),p=await Promise.all(Object.keys(b).map(async o=>[await this.resolveString(T,w,o,v,h),await this.recursiveResolve(T,w,b[o],v,h)]));for(const[o,m]of p)g[o]=m;return g}return b}resolveString(T,w,b,v,h){return(0,R.replaceAsync)(b,k.VARIABLE_REGEXP,async(g,p)=>{if(p.includes(k.VARIABLE_LHS))return g;let o=await this.evaluateSingleVariable(T,g,p,w,v);return h?.set(p,o),o!==g&&D.isString(o)&&o.match(k.VARIABLE_REGEXP)&&(o=await this.resolveString(T,w,o,v,h)),o})}fsPath(T){return this._labelService?this._labelService.getUriLabel(T,{noPrefix:!0}):T.fsPath}async evaluateSingleVariable(T,w,b,v,h){let g;const p=b.split(":");p.length>1&&(b=p[0],g=p[1]);const o=l=>{const s=this._context.getFilePath();if(s)return s;throw new I.VariableError(l,(0,E.localize)(0,null,w))},m=l=>{const s=o(l);if(this._context.getWorkspaceFolderPathForFile){const i=this._context.getWorkspaceFolderPathForFile();if(i)return i}throw new I.VariableError(l,(0,E.localize)(1,null,w,u.basename(s)))},c=l=>{if(g){const s=this._context.getFolderUri(g);if(s)return s;throw new I.VariableError(l,(0,E.localize)(2,null,w,g))}if(v)return v;throw this._context.getWorkspaceFolderCount()>1?new I.VariableError(l,(0,E.localize)(3,null,w)):new I.VariableError(l,(0,E.localize)(4,null,w))};switch(b){case"env":if(g){if(T.env){const l=T.env[y.isWindows?g.toLowerCase():g];if(D.isString(l))return l}return""}throw new I.VariableError(I.VariableKind.Env,(0,E.localize)(5,null,w));case"config":if(g){const l=this._context.getConfigurationValue(v,g);if(D.isUndefinedOrNull(l))throw new I.VariableError(I.VariableKind.Config,(0,E.localize)(6,null,w,g));if(D.isObject(l))throw new I.VariableError(I.VariableKind.Config,(0,E.localize)(7,null,w,g));return l}throw new I.VariableError(I.VariableKind.Config,(0,E.localize)(8,null,w));case"command":return this.resolveFromMap(I.VariableKind.Command,w,g,h,"command");case"input":return this.resolveFromMap(I.VariableKind.Input,w,g,h,"input");case"extensionInstallFolder":if(g){const l=await this._context.getExtension(g);if(!l)throw new I.VariableError(I.VariableKind.ExtensionInstallFolder,(0,E.localize)(9,null,w,g));return this.fsPath(l.extensionLocation)}throw new I.VariableError(I.VariableKind.ExtensionInstallFolder,(0,E.localize)(10,null,w));default:switch(b){case"workspaceRoot":case"workspaceFolder":return(0,C.normalizeDriveLetter)(this.fsPath(c(I.VariableKind.WorkspaceFolder)));case"cwd":return v||g?(0,C.normalizeDriveLetter)(this.fsPath(c(I.VariableKind.Cwd))):t.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return u.basename(this.fsPath(c(I.VariableKind.WorkspaceFolderBasename)));case"userHome":{if(T.userHome)return T.userHome;throw new I.VariableError(I.VariableKind.UserHome,(0,E.localize)(11,null,w))}case"lineNumber":{const l=this._context.getLineNumber();if(l)return l;throw new I.VariableError(I.VariableKind.LineNumber,(0,E.localize)(12,null,w))}case"selectedText":{const l=this._context.getSelectedText();if(l)return l;throw new I.VariableError(I.VariableKind.SelectedText,(0,E.localize)(13,null,w))}case"file":return o(I.VariableKind.File);case"fileWorkspaceFolder":return m(I.VariableKind.FileWorkspaceFolder);case"relativeFile":return v||g?u.relative(this.fsPath(c(I.VariableKind.RelativeFile)),o(I.VariableKind.RelativeFile)):o(I.VariableKind.RelativeFile);case"relativeFileDirname":{const l=u.dirname(o(I.VariableKind.RelativeFileDirname));if(v||g){const s=u.relative(this.fsPath(c(I.VariableKind.RelativeFileDirname)),l);return s.length===0?".":s}return l}case"fileDirname":return u.dirname(o(I.VariableKind.FileDirname));case"fileExtname":return u.extname(o(I.VariableKind.FileExtname));case"fileBasename":return u.basename(o(I.VariableKind.FileBasename));case"fileBasenameNoExtension":{const l=u.basename(o(I.VariableKind.FileBasenameNoExtension));return l.slice(0,l.length-u.extname(l).length)}case"fileDirnameBasename":return u.basename(u.dirname(o(I.VariableKind.FileDirnameBasename)));case"execPath":{const l=this._context.getExecPath();return l||w}case"execInstallFolder":{const l=this._context.getAppRoot();return l||w}case"pathSeparator":return u.sep;default:try{const l=g?`${b}:${g}`:b;return this.resolveFromMap(I.VariableKind.Unknown,w,l,h,void 0)}catch{return w}}}}resolveFromMap(T,w,b,v,h){if(b&&v){const g=h===void 0?v[b]:v[h+":"+b];if(typeof g=="string")return g;throw new I.VariableError(T,(0,E.localize)(14,null,w))}return w}}e.AbstractVariableResolverService=k,k.VARIABLE_LHS="${",k.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(De[129],Ie([1,0,3,209]),function(Z,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,u.createDecorator)("editorGroupsService");var D;(function(w){w[w.UP=0]="UP",w[w.DOWN=1]="DOWN",w[w.LEFT=2]="LEFT",w[w.RIGHT=3]="RIGHT"})(D=e.GroupDirection||(e.GroupDirection={}));var P;(function(w){w[w.HORIZONTAL=0]="HORIZONTAL",w[w.VERTICAL=1]="VERTICAL"})(P=e.GroupOrientation||(e.GroupOrientation={}));var y;(function(w){w[w.FIRST=0]="FIRST",w[w.LAST=1]="LAST",w[w.NEXT=2]="NEXT",w[w.PREVIOUS=3]="PREVIOUS"})(y=e.GroupLocation||(e.GroupLocation={}));var C;(function(w){w[w.MAXIMIZE=0]="MAXIMIZE",w[w.EVEN=1]="EVEN",w[w.TOGGLE=2]="TOGGLE"})(C=e.GroupsArrangement||(e.GroupsArrangement={}));var E;(function(w){w[w.COPY_EDITORS=0]="COPY_EDITORS",w[w.MOVE_EDITORS=1]="MOVE_EDITORS"})(E=e.MergeGroupMode||(e.MergeGroupMode={}));function I(w){const b=w;return(0,t.isEditorInput)(b?.editor)&&(0,t.isEditorInput)(b?.replacement)}e.isEditorReplacement=I;var R;(function(w){w[w.CREATION_TIME=0]="CREATION_TIME",w[w.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",w[w.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R=e.GroupsOrder||(e.GroupsOrder={}));var k;(function(w){w[w.NEW_EDITOR=1]="NEW_EDITOR",w[w.MOVE_EDITOR=2]="MOVE_EDITOR",w[w.COPY_EDITOR=3]="COPY_EDITOR"})(k=e.OpenEditorContext||(e.OpenEditorContext={}));function _(w){const b=w;return!!b&&typeof b.id=="number"&&Array.isArray(b.editors)}e.isEditorGroup=_;function T(w){return w.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=T}),define(De[220],Ie([1,0,3,129]),function(Z,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,u.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function D(P){const y=P;return typeof P=="number"||(0,t.isEditorGroup)(y)}e.isPreferredGroup=D}),define(De[16],Ie([1,0,17,23,105,25,143,61,24,13,2,35,63,186,116,128,127,65,66,220,7,58]),function(Z,e,u,t,D,P,y,C,E,I,R,k,_,T,w,b,v,h,g,p,o,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var c;(function(Te){function Le(ie){const{selectionStartLineNumber:Fe,selectionStartColumn:Ve,positionLineNumber:rt,positionColumn:Ye}=ie,Ke=new o.Position(Fe-1,Ve-1),ft=new o.Position(rt-1,Ye-1);return new o.Selection(Ke,ft)}Te.to=Le;function _e(ie){const{anchor:Fe,active:Ve}=ie;return{selectionStartLineNumber:Fe.line+1,selectionStartColumn:Fe.character+1,positionLineNumber:Ve.line+1,positionColumn:Ve.character+1}}Te.from=_e})(c=e.Selection||(e.Selection={}));var l;(function(Te){function Le(ie){if(!ie)return;const{start:Fe,end:Ve}=ie;return{startLineNumber:Fe.line+1,startColumn:Fe.character+1,endLineNumber:Ve.line+1,endColumn:Ve.character+1}}Te.from=Le;function _e(ie){if(!ie)return;const{startLineNumber:Fe,startColumn:Ve,endLineNumber:rt,endColumn:Ye}=ie;return new o.Range(Fe-1,Ve-1,rt-1,Ye-1)}Te.to=_e})(l=e.Range||(e.Range={}));var s;(function(Te){function Le(_e){switch(_e){case 1:return o.StandardTokenType.Comment;case 0:return o.StandardTokenType.Other;case 3:return o.StandardTokenType.RegEx;case 2:return o.StandardTokenType.String}}Te.to=Le})(s=e.TokenType||(e.TokenType={}));var i;(function(Te){function Le(ie){return new o.Position(ie.lineNumber-1,ie.column-1)}Te.to=Le;function _e(ie){return{lineNumber:ie.line+1,column:ie.character+1}}Te.from=_e})(i=e.Position||(e.Position={}));var r;(function(Te){function Le(Fe,Ve){return(0,u.coalesce)((0,u.asArray)(Fe).map(rt=>_e(rt,Ve)))}Te.from=Le;function _e(Fe,Ve){if(typeof Fe=="string")return{$serialized:!0,language:Fe};if(Fe)return{$serialized:!0,language:Fe.language,scheme:ie(Fe.scheme,Ve),pattern:q.from(Fe.pattern)??void 0,exclusive:Fe.exclusive,notebookType:Fe.notebookType}}function ie(Fe,Ve){return Ve&&typeof Fe=="string"?Ve.transformOutgoingScheme(Fe):Fe}})(r=e.DocumentSelector||(e.DocumentSelector={}));var n;(function(Te){function Le(ie){switch(ie){case o.DiagnosticTag.Unnecessary:return 1;case o.DiagnosticTag.Deprecated:return 2}}Te.from=Le;function _e(ie){switch(ie){case 1:return o.DiagnosticTag.Unnecessary;case 2:return o.DiagnosticTag.Deprecated;default:return}}Te.to=_e})(n=e.DiagnosticTag||(e.DiagnosticTag={}));var a;(function(Te){function Le(ie){let Fe;return ie.code&&((0,I.isString)(ie.code)||(0,I.isNumber)(ie.code)?Fe=String(ie.code):Fe={value:String(ie.code.value),target:ie.code.target}),{...l.from(ie.range),message:ie.message,source:ie.source,code:Fe,severity:f.from(ie.severity),relatedInformation:ie.relatedInformation&&ie.relatedInformation.map(d.from),tags:Array.isArray(ie.tags)?(0,u.coalesce)(ie.tags.map(n.from)):void 0}}Te.from=Le;function _e(ie){const Fe=new o.Diagnostic(l.to(ie),ie.message,f.to(ie.severity));return Fe.source=ie.source,Fe.code=(0,I.isString)(ie.code)?ie.code:ie.code?.value,Fe.relatedInformation=ie.relatedInformation&&ie.relatedInformation.map(d.to),Fe.tags=ie.tags&&(0,u.coalesce)(ie.tags.map(n.to)),Fe}Te.to=_e})(a=e.Diagnostic||(e.Diagnostic={}));var d;(function(Te){function Le(ie){return{...l.from(ie.location.range),message:ie.message,resource:ie.location.uri}}Te.from=Le;function _e(ie){return new o.DiagnosticRelatedInformation(new o.Location(ie.resource,l.to(ie)),ie.message)}Te.to=_e})(d=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var f;(function(Te){function Le(ie){switch(ie){case o.DiagnosticSeverity.Error:return w.MarkerSeverity.Error;case o.DiagnosticSeverity.Warning:return w.MarkerSeverity.Warning;case o.DiagnosticSeverity.Information:return w.MarkerSeverity.Info;case o.DiagnosticSeverity.Hint:return w.MarkerSeverity.Hint}return w.MarkerSeverity.Error}Te.from=Le;function _e(ie){switch(ie){case w.MarkerSeverity.Info:return o.DiagnosticSeverity.Information;case w.MarkerSeverity.Warning:return o.DiagnosticSeverity.Warning;case w.MarkerSeverity.Error:return o.DiagnosticSeverity.Error;case w.MarkerSeverity.Hint:return o.DiagnosticSeverity.Hint;default:return o.DiagnosticSeverity.Error}}Te.to=_e})(f=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var S;(function(Te){function Le(ie){return typeof ie=="number"&&ie>=o.ViewColumn.One?ie-1:ie===o.ViewColumn.Beside?p.SIDE_GROUP:p.ACTIVE_GROUP}Te.from=Le;function _e(ie){if(typeof ie=="number"&&ie>=0)return ie+1;throw new Error("invalid 'EditorGroupColumn'")}Te.to=_e})(S=e.ViewColumn||(e.ViewColumn={}));function O(Te){return typeof Te.range!="undefined"}function U(Te){return Te.length===0?!0:!!O(Te[0])}e.isDecorationOptionsArr=U;var M;(function(Te){function Le(Ye){return Ye.map(Te.from)}Te.fromMany=Le;function _e(Ye){return Ye&&typeof Ye=="object"&&typeof Ye.language=="string"&&typeof Ye.value=="string"}function ie(Ye){let Ke;if(_e(Ye)){const{language:vt,value:St}=Ye;Ke={value:"```"+vt+`
`+St+"\n```\n"}}else o.MarkdownString.isMarkdownString(Ye)?Ke={value:Ye.value,isTrusted:Ye.isTrusted,supportThemeIcons:Ye.supportThemeIcons,supportHtml:Ye.supportHtml,baseUri:Ye.baseUri}:typeof Ye=="string"?Ke={value:Ye}:Ke={value:""};const ft=Object.create(null);Ke.uris=ft;const pt=vt=>{try{let St=R.URI.parse(vt,!0);St=St.with({query:Fe(St.query,ft)}),ft[vt]=St}catch{}return""},Dt=new y.marked.Renderer;return Dt.link=pt,Dt.image=vt=>typeof vt=="string"?pt(D.parseHrefAndDimensions(vt).href):"",(0,y.marked)(Ke.value,{renderer:Dt}),Ke}Te.from=ie;function Fe(Ye,Ke){if(!Ye)return Ye;let ft;try{ft=(0,C.parse)(Ye)}catch{}if(!ft)return Ye;let pt=!1;return ft=(0,E.cloneAndChange)(ft,Dt=>{if(R.URI.isUri(Dt)){const vt=`__uri_${Math.random().toString(16).slice(2,8)}`;return Ke[vt]=Dt,pt=!0,vt}else return}),pt?JSON.stringify(ft):Ye}function Ve(Ye){const Ke=new o.MarkdownString(Ye.value,Ye.supportThemeIcons);return Ke.isTrusted=Ye.isTrusted,Ke.supportHtml=Ye.supportHtml,Ke.baseUri=Ye.baseUri?R.URI.from(Ye.baseUri):void 0,Ke}Te.to=Ve;function rt(Ye){if(!!Ye)return typeof Ye=="string"?Ye:Te.from(Ye)}Te.fromStrict=rt})(M=e.MarkdownString||(e.MarkdownString={}));function A(Te){return U(Te)?Te.map(Le=>({range:l.from(Le.range),hoverMessage:Array.isArray(Le.hoverMessage)?M.fromMany(Le.hoverMessage):Le.hoverMessage?M.from(Le.hoverMessage):void 0,renderOptions:Le.renderOptions})):Te.map(Le=>({range:l.from(Le)}))}e.fromRangeOrRangeWithMessage=A;function B(Te){return typeof Te=="undefined"?Te:typeof Te=="string"?R.URI.file(Te):Te}e.pathOrURIToURI=B;var x;(function(Te){function Le(_e){return typeof _e=="undefined"?_e:{contentText:_e.contentText,contentIconPath:_e.contentIconPath?B(_e.contentIconPath):void 0,border:_e.border,borderColor:_e.borderColor,fontStyle:_e.fontStyle,fontWeight:_e.fontWeight,textDecoration:_e.textDecoration,color:_e.color,backgroundColor:_e.backgroundColor,margin:_e.margin,width:_e.width,height:_e.height}}Te.from=Le})(x=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var N;(function(Te){function Le(_e){return typeof _e=="undefined"?_e:{backgroundColor:_e.backgroundColor,outline:_e.outline,outlineColor:_e.outlineColor,outlineStyle:_e.outlineStyle,outlineWidth:_e.outlineWidth,border:_e.border,borderColor:_e.borderColor,borderRadius:_e.borderRadius,borderSpacing:_e.borderSpacing,borderStyle:_e.borderStyle,borderWidth:_e.borderWidth,fontStyle:_e.fontStyle,fontWeight:_e.fontWeight,textDecoration:_e.textDecoration,cursor:_e.cursor,color:_e.color,opacity:_e.opacity,letterSpacing:_e.letterSpacing,gutterIconPath:_e.gutterIconPath?B(_e.gutterIconPath):void 0,gutterIconSize:_e.gutterIconSize,overviewRulerColor:_e.overviewRulerColor,before:_e.before?x.from(_e.before):void 0,after:_e.after?x.from(_e.after):void 0}}Te.from=Le})(N=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var K;(function(Te){function Le(_e){if(typeof _e=="undefined")return _e;switch(_e){case o.DecorationRangeBehavior.OpenOpen:return 0;case o.DecorationRangeBehavior.ClosedClosed:return 1;case o.DecorationRangeBehavior.OpenClosed:return 2;case o.DecorationRangeBehavior.ClosedOpen:return 3}}Te.from=Le})(K=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var X;(function(Te){function Le(_e){return{isWholeLine:_e.isWholeLine,rangeBehavior:_e.rangeBehavior?K.from(_e.rangeBehavior):void 0,overviewRulerLane:_e.overviewRulerLane,light:_e.light?N.from(_e.light):void 0,dark:_e.dark?N.from(_e.dark):void 0,backgroundColor:_e.backgroundColor,outline:_e.outline,outlineColor:_e.outlineColor,outlineStyle:_e.outlineStyle,outlineWidth:_e.outlineWidth,border:_e.border,borderColor:_e.borderColor,borderRadius:_e.borderRadius,borderSpacing:_e.borderSpacing,borderStyle:_e.borderStyle,borderWidth:_e.borderWidth,fontStyle:_e.fontStyle,fontWeight:_e.fontWeight,textDecoration:_e.textDecoration,cursor:_e.cursor,color:_e.color,opacity:_e.opacity,letterSpacing:_e.letterSpacing,gutterIconPath:_e.gutterIconPath?B(_e.gutterIconPath):void 0,gutterIconSize:_e.gutterIconSize,overviewRulerColor:_e.overviewRulerColor,before:_e.before?x.from(_e.before):void 0,after:_e.after?x.from(_e.after):void 0}}Te.from=Le})(X=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var L;(function(Te){function Le(ie){return{text:ie.newText,eol:ie.newEol&&Qe.from(ie.newEol),range:l.from(ie.range)}}Te.from=Le;function _e(ie){const Fe=new o.TextEdit(l.to(ie.range),ie.text);return Fe.newEol=typeof ie.eol=="undefined"?void 0:Qe.to(ie.eol),Fe}Te.to=_e})(L=e.TextEdit||(e.TextEdit={}));var $;(function(Te){function Le(ie,Fe,Ve){const rt={edits:[]};if(ie instanceof o.WorkspaceEdit){const Ye=new P.ResourceSet;for(const Ke of ie._allEntries())Ke._type===1&&R.URI.isUri(Ke.to)&&Ke.from===void 0&&Ye.add(Ke.to);for(const Ke of ie._allEntries())if(Ke._type===1)rt.edits.push({oldResource:Ke.from,newResource:Ke.to,options:Ke.options,metadata:Ke.metadata});else if(Ke._type===2)rt.edits.push({resource:Ke.uri,textEdit:L.from(Ke.edit),versionId:Ye.has(Ke.uri)?void 0:Fe?.getTextDocumentVersion(Ke.uri),metadata:Ke.metadata});else if(Ke._type===6){if(!Ve){console.warn("DROPPING snippet text edit because proposal IS NOT ENABLED",Ke);continue}rt.edits.push({resource:Ke.uri,textEdit:{range:l.from(Ke.range),text:Ke.edit.value,insertAsSnippet:!0},versionId:Ye.has(Ke.uri)?void 0:Fe?.getTextDocumentVersion(Ke.uri),metadata:Ke.metadata})}else Ke._type===3?rt.edits.push({metadata:Ke.metadata,resource:Ke.uri,cellEdit:Ke.edit,notebookMetadata:Ke.notebookMetadata,notebookVersionId:Fe?.getNotebookDocumentVersion(Ke.uri)}):Ke._type===5&&rt.edits.push({metadata:Ke.metadata,resource:Ke.uri,notebookVersionId:Fe?.getNotebookDocumentVersion(Ke.uri),cellEdit:{editType:1,index:Ke.index,count:Ke.count,cells:Ke.cells.map(it.from)}})}return rt}Te.from=Le;function _e(ie){const Fe=new o.WorkspaceEdit;for(const Ve of ie.edits)Ve.textEdit?Fe.replace(R.URI.revive(Ve.resource),l.to(Ve.textEdit.range),Ve.textEdit.text):Fe.renameFile(R.URI.revive(Ve.oldResource),R.URI.revive(Ve.newResource),Ve.options);return Fe}Te.to=_e})($=e.WorkspaceEdit||(e.WorkspaceEdit={}));var H;(function(Te){const Le=Object.create(null);Le[o.SymbolKind.File]=0,Le[o.SymbolKind.Module]=1,Le[o.SymbolKind.Namespace]=2,Le[o.SymbolKind.Package]=3,Le[o.SymbolKind.Class]=4,Le[o.SymbolKind.Method]=5,Le[o.SymbolKind.Property]=6,Le[o.SymbolKind.Field]=7,Le[o.SymbolKind.Constructor]=8,Le[o.SymbolKind.Enum]=9,Le[o.SymbolKind.Interface]=10,Le[o.SymbolKind.Function]=11,Le[o.SymbolKind.Variable]=12,Le[o.SymbolKind.Constant]=13,Le[o.SymbolKind.String]=14,Le[o.SymbolKind.Number]=15,Le[o.SymbolKind.Boolean]=16,Le[o.SymbolKind.Array]=17,Le[o.SymbolKind.Object]=18,Le[o.SymbolKind.Key]=19,Le[o.SymbolKind.Null]=20,Le[o.SymbolKind.EnumMember]=21,Le[o.SymbolKind.Struct]=22,Le[o.SymbolKind.Event]=23,Le[o.SymbolKind.Operator]=24,Le[o.SymbolKind.TypeParameter]=25;function _e(Fe){return typeof Le[Fe]=="number"?Le[Fe]:6}Te.from=_e;function ie(Fe){for(const Ve in Le)if(Le[Ve]===Fe)return Number(Ve);return o.SymbolKind.Property}Te.to=ie})(H=e.SymbolKind||(e.SymbolKind={}));var j;(function(Te){function Le(ie){switch(ie){case o.SymbolTag.Deprecated:return 1}}Te.from=Le;function _e(ie){switch(ie){case 1:return o.SymbolTag.Deprecated}}Te.to=_e})(j=e.SymbolTag||(e.SymbolTag={}));var J;(function(Te){function Le(ie){return{name:ie.name,kind:H.from(ie.kind),tags:ie.tags&&ie.tags.map(j.from),containerName:ie.containerName,location:pe.from(ie.location)}}Te.from=Le;function _e(ie){const Fe=new o.SymbolInformation(ie.name,H.to(ie.kind),ie.containerName,pe.to(ie.location));return Fe.tags=ie.tags&&ie.tags.map(j.to),Fe}Te.to=_e})(J=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var Y;(function(Te){function Le(ie){const Fe={name:ie.name||"!!MISSING: name!!",detail:ie.detail,range:l.from(ie.range),selectionRange:l.from(ie.selectionRange),kind:H.from(ie.kind),tags:ie.tags?.map(j.from)??[]};return ie.children&&(Fe.children=ie.children.map(Le)),Fe}Te.from=Le;function _e(ie){const Fe=new o.DocumentSymbol(ie.name,ie.detail,H.to(ie.kind),l.to(ie.range),l.to(ie.selectionRange));return(0,u.isNonEmptyArray)(ie.tags)&&(Fe.tags=ie.tags.map(j.to)),ie.children&&(Fe.children=ie.children.map(_e)),Fe}Te.to=_e})(Y=e.DocumentSymbol||(e.DocumentSymbol={}));var he;(function(Te){function Le(ie){const Fe=new o.CallHierarchyItem(H.to(ie.kind),ie.name,ie.detail||"",R.URI.revive(ie.uri),l.to(ie.range),l.to(ie.selectionRange));return Fe._sessionId=ie._sessionId,Fe._itemId=ie._itemId,Fe}Te.to=Le;function _e(ie,Fe,Ve){if(Fe=Fe??ie._sessionId,Ve=Ve??ie._itemId,Fe===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:Ve,name:ie.name,detail:ie.detail,kind:H.from(ie.kind),uri:ie.uri,range:l.from(ie.range),selectionRange:l.from(ie.selectionRange),tags:ie.tags?.map(j.from)}}Te.from=_e})(he=e.CallHierarchyItem||(e.CallHierarchyItem={}));var ve;(function(Te){function Le(_e){return new o.CallHierarchyIncomingCall(he.to(_e.from),_e.fromRanges.map(ie=>l.to(ie)))}Te.to=Le})(ve=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var ne;(function(Te){function Le(_e){return new o.CallHierarchyOutgoingCall(he.to(_e.to),_e.fromRanges.map(ie=>l.to(ie)))}Te.to=Le})(ne=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var pe;(function(Te){function Le(ie){return{range:ie.range&&l.from(ie.range),uri:ie.uri}}Te.from=Le;function _e(ie){return new o.Location(R.URI.revive(ie.uri),l.to(ie.range))}Te.to=_e})(pe=e.location||(e.location={}));var Ee;(function(Te){function Le(ie){const Fe=ie,Ve=ie;return{originSelectionRange:Fe.originSelectionRange?l.from(Fe.originSelectionRange):void 0,uri:Fe.targetUri?Fe.targetUri:Ve.uri,range:l.from(Fe.targetRange?Fe.targetRange:Ve.range),targetSelectionRange:Fe.targetSelectionRange?l.from(Fe.targetSelectionRange):void 0}}Te.from=Le;function _e(ie){return{targetUri:R.URI.revive(ie.uri),targetRange:l.to(ie.range),targetSelectionRange:ie.targetSelectionRange?l.to(ie.targetSelectionRange):void 0,originSelectionRange:ie.originSelectionRange?l.to(ie.originSelectionRange):void 0}}Te.to=_e})(Ee=e.DefinitionLink||(e.DefinitionLink={}));var ke;(function(Te){function Le(ie){return{range:l.from(ie.range),contents:M.fromMany(ie.contents)}}Te.from=Le;function _e(ie){return new o.Hover(ie.contents.map(M.to),l.to(ie.range))}Te.to=_e})(ke=e.Hover||(e.Hover={}));var Oe;(function(Te){function Le(ie){return{range:l.from(ie.range),expression:ie.expression}}Te.from=Le;function _e(ie){return new o.EvaluatableExpression(l.to(ie.range),ie.expression)}Te.to=_e})(Oe=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Be;(function(Te){function Le(ie){if(ie instanceof o.InlineValueText)return{type:"text",range:l.from(ie.range),text:ie.text};if(ie instanceof o.InlineValueVariableLookup)return{type:"variable",range:l.from(ie.range),variableName:ie.variableName,caseSensitiveLookup:ie.caseSensitiveLookup};if(ie instanceof o.InlineValueEvaluatableExpression)return{type:"expression",range:l.from(ie.range),expression:ie.expression};throw new Error("Unknown 'InlineValue' type")}Te.from=Le;function _e(ie){switch(ie.type){case"text":return{range:l.to(ie.range),text:ie.text};case"variable":return{range:l.to(ie.range),variableName:ie.variableName,caseSensitiveLookup:ie.caseSensitiveLookup};case"expression":return{range:l.to(ie.range),expression:ie.expression}}}Te.to=_e})(Be=e.InlineValue||(e.InlineValue={}));var ae;(function(Te){function Le(ie){return{frameId:ie.frameId,stoppedLocation:l.from(ie.stoppedLocation)}}Te.from=Le;function _e(ie){return new o.InlineValueContext(ie.frameId,l.to(ie.stoppedLocation))}Te.to=_e})(ae=e.InlineValueContext||(e.InlineValueContext={}));var de;(function(Te){function Le(ie){return{range:l.from(ie.range),kind:ie.kind}}Te.from=Le;function _e(ie){return new o.DocumentHighlight(l.to(ie.range),ie.kind)}Te.to=_e})(de=e.DocumentHighlight||(e.DocumentHighlight={}));var me;(function(Te){function Le(_e){switch(_e){case 1:return o.CompletionTriggerKind.TriggerCharacter;case 2:return o.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return o.CompletionTriggerKind.Invoke}}Te.to=Le})(me=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var te;(function(Te){function Le(_e){return{triggerKind:me.to(_e.triggerKind),triggerCharacter:_e.triggerCharacter}}Te.to=Le})(te=e.CompletionContext||(e.CompletionContext={}));var le;(function(Te){function Le(ie){switch(ie){case o.CompletionItemTag.Deprecated:return 1}}Te.from=Le;function _e(ie){switch(ie){case 1:return o.CompletionItemTag.Deprecated}}Te.to=_e})(le=e.CompletionItemTag||(e.CompletionItemTag={}));var ee;(function(Te){const Le=new Map([[o.CompletionItemKind.Method,0],[o.CompletionItemKind.Function,1],[o.CompletionItemKind.Constructor,2],[o.CompletionItemKind.Field,3],[o.CompletionItemKind.Variable,4],[o.CompletionItemKind.Class,5],[o.CompletionItemKind.Interface,7],[o.CompletionItemKind.Struct,6],[o.CompletionItemKind.Module,8],[o.CompletionItemKind.Property,9],[o.CompletionItemKind.Unit,12],[o.CompletionItemKind.Value,13],[o.CompletionItemKind.Constant,14],[o.CompletionItemKind.Enum,15],[o.CompletionItemKind.EnumMember,16],[o.CompletionItemKind.Keyword,17],[o.CompletionItemKind.Snippet,27],[o.CompletionItemKind.Text,18],[o.CompletionItemKind.Color,19],[o.CompletionItemKind.File,20],[o.CompletionItemKind.Reference,21],[o.CompletionItemKind.Folder,23],[o.CompletionItemKind.Event,10],[o.CompletionItemKind.Operator,11],[o.CompletionItemKind.TypeParameter,24],[o.CompletionItemKind.Issue,26],[o.CompletionItemKind.User,25]]);function _e(Ve){return Le.get(Ve)??9}Te.from=_e;const ie=new Map([[0,o.CompletionItemKind.Method],[1,o.CompletionItemKind.Function],[2,o.CompletionItemKind.Constructor],[3,o.CompletionItemKind.Field],[4,o.CompletionItemKind.Variable],[5,o.CompletionItemKind.Class],[7,o.CompletionItemKind.Interface],[6,o.CompletionItemKind.Struct],[8,o.CompletionItemKind.Module],[9,o.CompletionItemKind.Property],[12,o.CompletionItemKind.Unit],[13,o.CompletionItemKind.Value],[14,o.CompletionItemKind.Constant],[15,o.CompletionItemKind.Enum],[16,o.CompletionItemKind.EnumMember],[17,o.CompletionItemKind.Keyword],[27,o.CompletionItemKind.Snippet],[18,o.CompletionItemKind.Text],[19,o.CompletionItemKind.Color],[20,o.CompletionItemKind.File],[21,o.CompletionItemKind.Reference],[23,o.CompletionItemKind.Folder],[10,o.CompletionItemKind.Event],[11,o.CompletionItemKind.Operator],[24,o.CompletionItemKind.TypeParameter],[25,o.CompletionItemKind.User],[26,o.CompletionItemKind.Issue]]);function Fe(Ve){return ie.get(Ve)??o.CompletionItemKind.Property}Te.to=Fe})(ee=e.CompletionItemKind||(e.CompletionItemKind={}));var re;(function(Te){function Le(_e,ie){const Fe=new o.CompletionItem(_e.label);return Fe.insertText=_e.insertText,Fe.kind=ee.to(_e.kind),Fe.tags=_e.tags?.map(le.to),Fe.detail=_e.detail,Fe.documentation=D.isMarkdownString(_e.documentation)?M.to(_e.documentation):_e.documentation,Fe.sortText=_e.sortText,Fe.filterText=_e.filterText,Fe.preselect=_e.preselect,Fe.commitCharacters=_e.commitCharacters,k.Range.isIRange(_e.range)?Fe.range=l.to(_e.range):typeof _e.range=="object"&&(Fe.range={inserting:l.to(_e.range.insert),replacing:l.to(_e.range.replace)}),Fe.keepWhitespace=typeof _e.insertTextRules=="undefined"?!1:Boolean(_e.insertTextRules&1),typeof _e.insertTextRules!="undefined"&&_e.insertTextRules&4?Fe.insertText=new o.SnippetString(_e.insertText):(Fe.insertText=_e.insertText,Fe.textEdit=Fe.range instanceof o.Range?new o.TextEdit(Fe.range,Fe.insertText):void 0),_e.additionalTextEdits&&_e.additionalTextEdits.length>0&&(Fe.additionalTextEdits=_e.additionalTextEdits.map(Ve=>L.to(Ve))),Fe.command=ie&&_e.command?ie.fromInternal(_e.command):void 0,Fe}Te.to=Le})(re=e.CompletionItem||(e.CompletionItem={}));var F;(function(Te){function Le(ie){return{label:ie.label,documentation:M.fromStrict(ie.documentation)}}Te.from=Le;function _e(ie){return{label:ie.label,documentation:D.isMarkdownString(ie.documentation)?M.to(ie.documentation):ie.documentation}}Te.to=_e})(F=e.ParameterInformation||(e.ParameterInformation={}));var W;(function(Te){function Le(ie){return{label:ie.label,documentation:M.fromStrict(ie.documentation),parameters:Array.isArray(ie.parameters)?ie.parameters.map(F.from):[],activeParameter:ie.activeParameter}}Te.from=Le;function _e(ie){return{label:ie.label,documentation:D.isMarkdownString(ie.documentation)?M.to(ie.documentation):ie.documentation,parameters:Array.isArray(ie.parameters)?ie.parameters.map(F.to):[],activeParameter:ie.activeParameter}}Te.to=_e})(W=e.SignatureInformation||(e.SignatureInformation={}));var G;(function(Te){function Le(ie){return{activeSignature:ie.activeSignature,activeParameter:ie.activeParameter,signatures:Array.isArray(ie.signatures)?ie.signatures.map(W.from):[]}}Te.from=Le;function _e(ie){return{activeSignature:ie.activeSignature,activeParameter:ie.activeParameter,signatures:Array.isArray(ie.signatures)?ie.signatures.map(W.to):[]}}Te.to=_e})(G=e.SignatureHelp||(e.SignatureHelp={}));var Q;(function(Te){function Le(_e,ie){const Fe=new o.InlayHint(i.to(ie.position),typeof ie.label=="string"?ie.label:ie.label.map(fe.to.bind(void 0,_e)),ie.kind&&be.to(ie.kind));return Fe.textEdits=ie.textEdits&&ie.textEdits.map(L.to),Fe.tooltip=D.isMarkdownString(ie.tooltip)?M.to(ie.tooltip):ie.tooltip,Fe.paddingLeft=ie.paddingLeft,Fe.paddingRight=ie.paddingRight,Fe}Te.to=Le})(Q=e.InlayHint||(e.InlayHint={}));var fe;(function(Te){function Le(_e,ie){const Fe=new o.InlayHintLabelPart(ie.label);return Fe.tooltip=D.isMarkdownString(ie.tooltip)?M.to(ie.tooltip):ie.tooltip,_.Command.is(ie.command)&&(Fe.command=_e.fromInternal(ie.command)),ie.location&&(Fe.location=pe.to(ie.location)),Fe}Te.to=Le})(fe=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var be;(function(Te){function Le(ie){return ie}Te.from=Le;function _e(ie){return ie}Te.to=_e})(be=e.InlayHintKind||(e.InlayHintKind={}));var ue;(function(Te){function Le(ie){return{range:l.from(ie.range),url:ie.target,tooltip:ie.tooltip}}Te.from=Le;function _e(ie){let Fe;if(ie.url)try{Fe=typeof ie.url=="string"?R.URI.parse(ie.url,!0):R.URI.revive(ie.url)}catch{}return new o.DocumentLink(l.to(ie.range),Fe)}Te.to=_e})(ue=e.DocumentLink||(e.DocumentLink={}));var Ce;(function(Te){function Le(ie){const Fe=new o.ColorPresentation(ie.label);return ie.textEdit&&(Fe.textEdit=L.to(ie.textEdit)),ie.additionalTextEdits&&(Fe.additionalTextEdits=ie.additionalTextEdits.map(Ve=>L.to(Ve))),Fe}Te.to=Le;function _e(ie){return{label:ie.label,textEdit:ie.textEdit?L.from(ie.textEdit):void 0,additionalTextEdits:ie.additionalTextEdits?ie.additionalTextEdits.map(Fe=>L.from(Fe)):void 0}}Te.from=_e})(Ce=e.ColorPresentation||(e.ColorPresentation={}));var Se;(function(Te){function Le(ie){return new o.Color(ie[0],ie[1],ie[2],ie[3])}Te.to=Le;function _e(ie){return[ie.red,ie.green,ie.blue,ie.alpha]}Te.from=_e})(Se=e.Color||(e.Color={}));var Ue;(function(Te){function Le(ie){return{range:l.from(ie.range)}}Te.from=Le;function _e(ie){return new o.SelectionRange(l.to(ie.range))}Te.to=_e})(Ue=e.SelectionRange||(e.SelectionRange={}));var qe;(function(Te){function Le(_e){switch(_e){case 2:return o.TextDocumentSaveReason.AfterDelay;case 1:return o.TextDocumentSaveReason.Manual;case 3:case 4:return o.TextDocumentSaveReason.FocusOut}}Te.to=Le})(qe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Je;(function(Te){function Le(ie){switch(ie){case o.TextEditorLineNumbersStyle.Off:return 0;case o.TextEditorLineNumbersStyle.Relative:return 2;case o.TextEditorLineNumbersStyle.On:default:return 1}}Te.from=Le;function _e(ie){switch(ie){case 0:return o.TextEditorLineNumbersStyle.Off;case 2:return o.TextEditorLineNumbersStyle.Relative;case 1:default:return o.TextEditorLineNumbersStyle.On}}Te.to=_e})(Je=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Qe;(function(Te){function Le(ie){if(ie===o.EndOfLine.CRLF)return 1;if(ie===o.EndOfLine.LF)return 0}Te.from=Le;function _e(ie){if(ie===1)return o.EndOfLine.CRLF;if(ie===0)return o.EndOfLine.LF}Te.to=_e})(Qe=e.EndOfLine||(e.EndOfLine={}));var Re;(function(Te){function Le(_e){if(typeof _e=="object")return _e.viewId;switch(_e){case o.ProgressLocation.SourceControl:return 3;case o.ProgressLocation.Window:return 10;case o.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Te.from=Le})(Re=e.ProgressLocation||(e.ProgressLocation={}));var st;(function(Te){function Le(_e){const ie={start:_e.start+1,end:_e.end+1};return _e.kind&&(ie.kind=se.from(_e.kind)),ie}Te.from=Le})(st=e.FoldingRange||(e.FoldingRange={}));var se;(function(Te){function Le(_e){if(_e)switch(_e){case o.FoldingRangeKind.Comment:return _.FoldingRangeKind.Comment;case o.FoldingRangeKind.Imports:return _.FoldingRangeKind.Imports;case o.FoldingRangeKind.Region:return _.FoldingRangeKind.Region}}Te.from=Le})(se=e.FoldingRangeKind||(e.FoldingRangeKind={}));var oe;(function(Te){function Le(_e){if(_e)return{pinned:typeof _e.preview=="boolean"?!_e.preview:void 0,inactive:_e.background,preserveFocus:_e.preserveFocus,selection:typeof _e.selection=="object"?l.from(_e.selection):void 0,override:typeof _e.override=="boolean"?T.EditorResolution.DISABLED:void 0}}Te.from=Le})(oe=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var q;(function(Te){function Le(Ve){return Ve instanceof o.RelativePattern?Ve.toJSON():typeof Ve=="string"?Ve:_e(Ve)||ie(Ve)?new o.RelativePattern(Ve.baseUri??Ve.base,Ve.pattern).toJSON():Ve}Te.from=Le;function _e(Ve){const rt=Ve;return rt?R.URI.isUri(rt.baseUri)&&typeof rt.pattern=="string":!1}function ie(Ve){const rt=Ve;return rt?typeof rt.base=="string"&&typeof rt.pattern=="string":!1}function Fe(Ve){return typeof Ve=="string"?Ve:new o.RelativePattern(R.URI.revive(Ve.baseUri),Ve.pattern)}Te.to=Fe})(q=e.GlobPattern||(e.GlobPattern={}));var ye;(function(Te){function Le(_e){if(_e){if(Array.isArray(_e))return _e.map(Le);if(typeof _e=="string")return _e;{const ie=_e;return{language:ie.language,scheme:ie.scheme,pattern:q.from(ie.pattern),exclusive:ie.exclusive,notebookType:ie.notebookType}}}else return}Te.from=Le})(ye=e.LanguageSelector||(e.LanguageSelector={}));var Ae;(function(Te){function Le(ie){return{start:ie.start,end:ie.end}}Te.from=Le;function _e(ie){return new o.NotebookRange(ie.start,ie.end)}Te.to=_e})(Ae=e.NotebookRange||(e.NotebookRange={}));var We;(function(Te){function Le(ie){return{timing:typeof ie.runStartTime=="number"&&typeof ie.runEndTime=="number"?{startTime:ie.runStartTime,endTime:ie.runEndTime}:void 0,executionOrder:ie.executionOrder,success:ie.lastRunSuccess}}Te.to=Le;function _e(ie){return{lastRunSuccess:ie.success,runStartTime:ie.timing?.startTime,runEndTime:ie.timing?.endTime,executionOrder:ie.executionOrder}}Te.from=_e})(We=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var ze;(function(Te){function Le(_e){if(_e===v.NotebookCellExecutionState.Unconfirmed)return o.NotebookCellExecutionState.Pending;if(_e===v.NotebookCellExecutionState.Pending)return;if(_e===v.NotebookCellExecutionState.Executing)return o.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${_e}`)}Te.to=Le})(ze=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var $e;(function(Te){function Le(ie){switch(ie){case o.NotebookCellKind.Markup:return v.CellKind.Markup;case o.NotebookCellKind.Code:default:return v.CellKind.Code}}Te.from=Le;function _e(ie){switch(ie){case v.CellKind.Markup:return o.NotebookCellKind.Markup;case v.CellKind.Code:default:return o.NotebookCellKind.Code}}Te.to=_e})($e=e.NotebookCellKind||(e.NotebookCellKind={}));var Ze;(function(Te){function Le(ie){const Fe={metadata:ie.metadata??Object.create(null),cells:[]};for(const Ve of ie.cells)o.NotebookCellData.validate(Ve),Fe.cells.push(it.from(Ve));return Fe}Te.from=Le;function _e(ie){const Fe=new o.NotebookData(ie.cells.map(it.to));return(0,I.isEmptyObject)(ie.metadata)||(Fe.metadata=ie.metadata),Fe}Te.to=_e})(Ze=e.NotebookData||(e.NotebookData={}));var it;(function(Te){function Le(ie){return{cellKind:$e.from(ie.kind),language:ie.languageId,mime:ie.mime,source:ie.value,metadata:ie.metadata,internalMetadata:We.from(ie.executionSummary??{}),outputs:ie.outputs?ie.outputs.map(ht.from):[]}}Te.from=Le;function _e(ie){return new o.NotebookCellData($e.to(ie.cellKind),ie.source,ie.language,ie.mime,ie.outputs?ie.outputs.map(ht.to):void 0,ie.metadata,ie.internalMetadata?We.to(ie.internalMetadata):void 0)}Te.to=_e})(it=e.NotebookCellData||(e.NotebookCellData={}));var lt;(function(Te){function Le(ie){return{mime:ie.mime,valueBytes:t.VSBuffer.wrap(ie.data)}}Te.from=Le;function _e(ie){return new o.NotebookCellOutputItem(ie.valueBytes.buffer,ie.mime)}Te.to=_e})(lt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var ht;(function(Te){function Le(ie){return{outputId:ie.id,items:ie.items.map(lt.from),metadata:ie.metadata}}Te.from=Le;function _e(ie){const Fe=ie.items.map(lt.to);return new o.NotebookCellOutput(Fe,ie.outputId,ie.metadata)}Te.to=_e})(ht=e.NotebookCellOutput||(e.NotebookCellOutput={}));var tt;(function(Te){function Le(Fe){return ie(Fe)?{include:(0,I.withNullAsUndefined)(q.from(Fe.include)),exclude:(0,I.withNullAsUndefined)(q.from(Fe.exclude))}:(0,I.withNullAsUndefined)(q.from(Fe))}Te.from=Le;function _e(Fe){return ie(Fe)?{include:q.to(Fe.include),exclude:q.to(Fe.exclude)}:q.to(Fe)}Te.to=_e;function ie(Fe){const Ve=Fe;return Ve?!(0,I.isUndefinedOrNull)(Ve.include)&&!(0,I.isUndefinedOrNull)(Ve.exclude):!1}})(tt=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var at;(function(Te){function Le(_e,ie,Fe){const Ve=typeof _e.command=="string"?{title:"",command:_e.command}:_e.command;return{alignment:_e.alignment===o.NotebookCellStatusBarAlignment.Left?1:2,command:ie.toInternal(Ve,Fe),text:_e.text,tooltip:_e.tooltip,accessibilityInformation:_e.accessibilityInformation,priority:_e.priority}}Te.from=Le})(at=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Ct;(function(Te){function Le(_e){return{transientOutputs:_e?.transientOutputs??!1,transientCellMetadata:_e?.transientCellMetadata??{},transientDocumentMetadata:_e?.transientDocumentMetadata??{}}}Te.from=Le})(Ct=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Ot;(function(Te){function Le(ie){return{uri:ie.uri,provides:ie.provides}}Te.from=Le;function _e(ie){return new o.NotebookRendererScript(R.URI.revive(ie.uri),ie.provides)}Te.to=_e})(Ot=e.NotebookRendererScript||(e.NotebookRendererScript={}));var It;(function(Te){function Le(ie){return{message:M.fromStrict(ie.message)||"",type:0,expected:ie.expectedOutput,actual:ie.actualOutput,location:ie.location&&{range:l.from(ie.location.range),uri:ie.location.uri}}}Te.from=Le;function _e(ie){const Fe=new o.TestMessage(typeof ie.message=="string"?ie.message:M.to(ie.message));return Fe.actualOutput=ie.actual,Fe.expectedOutput=ie.expected,Fe.location=ie.location?pe.to(ie.location):void 0,Fe}Te.to=_e})(It=e.TestMessage||(e.TestMessage={}));var mt;(function(Te){Te.namespace=g.namespaceTestTag,Te.denamespace=g.denamespaceTestTag})(mt=e.TestTag||(e.TestTag={}));var kt;(function(Te){function Le(ie){const Fe=(0,b.getPrivateApiFor)(ie).controllerId;return{extId:h.TestId.fromExtHostTestItem(ie,Fe).toString(),label:ie.label,uri:R.URI.revive(ie.uri),busy:!1,tags:ie.tags.map(Ve=>mt.namespace(Fe,Ve.id)),range:k.Range.lift(l.from(ie.range)),description:ie.description||null,sortText:ie.sortText||null,error:ie.error&&M.fromStrict(ie.error)||null}}Te.from=Le;function _e(ie){return{parent:void 0,error:void 0,id:h.TestId.fromString(ie.extId).localId,label:ie.label,uri:R.URI.revive(ie.uri),tags:(ie.tags||[]).map(Fe=>{const{tagId:Ve}=mt.denamespace(Fe);return new o.TestTag(Ve)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:l.to(ie.range||void 0),canResolveChildren:!1,busy:!1,description:ie.description||void 0,sortText:ie.sortText||void 0}}Te.toPlain=_e})(kt=e.TestItem||(e.TestItem={})),function(Te){function Le(ie){return{id:ie.id}}Te.from=Le;function _e(ie){return new o.TestTag(ie.id)}Te.to=_e}(mt=e.TestTag||(e.TestTag={}));var Ut;(function(Te){const Le=(ie,Fe)=>{const Ve=[];for(const[Ye,Ke]of Fe)h.TestId.compare(Ke.item.extId,Ye)===2&&(Fe.delete(Ye),Ve.push(Ke));const rt={...kt.toPlain(ie.item),parent:void 0,taskStates:ie.tasks.map(Ye=>({state:Ye.state,duration:Ye.duration,messages:Ye.messages.filter(Ke=>Ke.type===0).map(It.to)})),children:Ve.map(Ye=>Le(Ye,Fe))};for(const Ye of rt.children)Ye.parent=rt;return rt};function _e(ie){const Fe=[],Ve=new Map;for(const rt of ie.items)Ve.set(rt.item.extId,rt),ie.request.targets.some(Ye=>Ye.controllerId===rt.controllerId&&Ye.testIds.includes(rt.item.extId))&&Fe.push(rt);return{completedAt:ie.completedAt,results:Fe.map(rt=>Le(rt,Ve))}}Te.to=_e})(Ut=e.TestResults||(e.TestResults={}));var Ft;(function(Te){function Le(Ve){return{covered:Ve.covered,total:Ve.covered}}function _e(Ve){return"line"in Ve?i.from(Ve):l.from(Ve)}function ie(Ve){return"branches"in Ve?{count:Ve.executionCount,location:_e(Ve.location),type:1,branches:Ve.branches.length?Ve.branches.map(rt=>({count:rt.executionCount,location:rt.location&&_e(rt.location)})):void 0}:{type:0,count:Ve.executionCount,location:_e(Ve.location)}}Te.fromDetailed=ie;function Fe(Ve){return{uri:Ve.uri,statement:Le(Ve.statementCoverage),branch:Ve.branchCoverage&&Le(Ve.branchCoverage),function:Ve.functionCoverage&&Le(Ve.functionCoverage),details:Ve.detailedCoverage?.map(ie)}}Te.fromFile=Fe})(Ft=e.TestCoverage||(e.TestCoverage={}));var Ge;(function(Te){function Le(_e){switch(_e){case 1:return o.CodeActionTriggerKind.Invoke;case 2:return o.CodeActionTriggerKind.Automatic}}Te.to=Le})(Ge=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Nt;(function(Te){function Le(ie){const Fe=new o.TypeHierarchyItem(H.to(ie.kind),ie.name,ie.detail||"",R.URI.revive(ie.uri),l.to(ie.range),l.to(ie.selectionRange));return Fe._sessionId=ie._sessionId,Fe._itemId=ie._itemId,Fe}Te.to=Le;function _e(ie,Fe,Ve){if(Fe=Fe??ie._sessionId,Ve=Ve??ie._itemId,Fe===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:Ve,kind:H.from(ie.kind),name:ie.name,detail:ie.detail??"",uri:ie.uri,range:l.from(ie.range),selectionRange:l.from(ie.selectionRange),tags:ie.tags?.map(j.from)}}Te.from=_e})(Nt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Lt;(function(Te){function Le(_e){if(!!_e)return{value:_e.value,tooltip:_e.tooltip}}Te.from=Le})(Lt=e.ViewBadge||(e.ViewBadge={}));var Bt;(function(Te){function Le(_e,ie){const Fe=_e.fileData;return Fe?new class extends o.DataTransferItem{asFile(){return{name:Fe.name,uri:R.URI.revive(Fe.uri),data:(0,m.once)(()=>ie())}}}(""):new o.DataTransferItem(_e.asString)}Te.toDataTransferItem=Le})(Bt=e.DataTransferItem||(e.DataTransferItem={}));var bt;(function(Te){function Le(ie,Fe){const Ve=ie.items.map(([rt,Ye],Ke)=>[rt,Bt.toDataTransferItem(Ye,()=>Fe(Ke))]);return new o.DataTransfer(Ve)}Te.toDataTransfer=Le;async function _e(ie){const Fe={items:[]},Ve=[];return ie.forEach((rt,Ye)=>{Ve.push((async()=>{const Ke=await rt.asString(),ft=rt.asFile();Fe.items.push([Ye,{asString:Ke,fileData:ft?{name:ft.name,uri:ft.uri}:void 0}])})())}),await Promise.all(Ve),Fe}Te.toDataTransferDTO=_e})(bt=e.DataTransfer||(e.DataTransfer={}))}),define(De[221],Ie([1,0,2,10,7,16,79]),function(Z,e,u,t,D,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class C{constructor(I,R,k,_={timeout:1500,errors:3}){this._logService=I,this._documents=R,this._mainThreadBulkEdits=k,this._thresholds=_,this._callbacks=new y.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(I){return(R,k,_)=>{const w={dispose:this._callbacks.push([R,k,I])};return Array.isArray(_)&&_.push(w),w}}async $participateInSave(I,R){const k=u.URI.revive(I);let _=!1;const T=setTimeout(()=>_=!0,this._thresholds.timeout),w=[];try{for(const b of[...this._callbacks]){if(_)break;const v=this._documents.getDocument(k),h=await this._deliverEventAsyncAndBlameBadListeners(b,{document:v,reason:P.TextDocumentSaveReason.to(R)});w.push(h)}}finally{clearTimeout(T)}return w}_deliverEventAsyncAndBlameBadListeners([I,R,k],_){const T=this._badListeners.get(I);return typeof T=="number"&&T>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(k,I,R,_).then(()=>!0,w=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' threw ERROR`),this._logService.error(w),!(w instanceof Error)||w.message!=="concurrent_edits"){const b=this._badListeners.get(I);this._badListeners.set(I,b?b+1:1),typeof b=="number"&&b>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(I,R,k,_){const T=[],w=Date.now(),{document:b,reason:v}=_,{version:h}=b,g=Object.freeze({document:b,reason:v,waitUntil(p){if(Object.isFrozen(T))throw(0,t.illegalState)("waitUntil can not be called async");T.push(Promise.resolve(p))}});try{R.apply(k,[g])}catch(p){return Promise.reject(p)}return Object.freeze(T),new Promise((p,o)=>{const m=setTimeout(()=>o(new Error("timeout")),this._thresholds.timeout);return Promise.all(T).then(c=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' finished after ${Date.now()-w}ms`),clearTimeout(m),p(c)}).catch(c=>{clearTimeout(m),o(c)})}).then(p=>{const o={edits:[]};for(const m of p)if(Array.isArray(m)&&m.every(c=>c instanceof D.TextEdit))for(const{newText:c,newEol:l,range:s}of m)o.edits.push({resource:b.uri,versionId:void 0,textEdit:{range:s&&P.Range.from(s),text:c,eol:l&&P.EndOfLine.from(l)}});if(o.edits.length!==0)return h===b.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(o):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=C}),define(De[222],Ie([1,0,12,2,16,7,127]),function(Z,e,u,t,D,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class C{constructor(k,_,T,w){this.start=k,this.deletedCount=_,this.deletedItems=T,this.items=w}asApiEvent(){return{range:new P.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(k=>k.apiCell),removedCells:this.deletedItems}}}class E{constructor(k,_,T){this.notebook=k,this._extHostDocument=_,this._cellData=T,this.handle=T.handle,this.uri=t.URI.revive(T.uri),this.cellKind=T.cellKind,this._outputs=T.outputs.map(D.NotebookCellOutput.to),this._internalMetadata=T.internalMetadata??{},this._metadata=Object.freeze(T.metadata??{}),this._previousResult=Object.freeze(D.NotebookCellExecutionSummary.to(T.internalMetadata??{}))}static asModelAddData(k,_){return{EOL:_.eol,lines:_.source,languageId:_.language,uri:_.uri,isDirty:!1,versionId:1,notebook:k}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const k=this,_=this._extHostDocument.getDocument(this.uri);if(!_)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const T={get index(){return k.notebook.getCellIndex(k)},notebook:k.notebook.apiNotebook,kind:D.NotebookCellKind.to(this._cellData.cellKind),document:_.document,get mime(){return k._mime},set mime(w){k._mime=w},get outputs(){return k._outputs.slice(0)},get metadata(){return k._metadata},get executionSummary(){return k._previousResult}};this._apiCell=Object.freeze(T)}return this._apiCell}setOutputs(k){this._outputs=k.map(D.NotebookCellOutput.to)}setOutputItems(k,_,T){const w=T.map(D.NotebookCellOutputItem.to),b=this._outputs.find(v=>v.id===k);b&&(_||(b.items.length=0),b.items.push(...w))}setMetadata(k){this._metadata=Object.freeze(k)}setInternalMetadata(k){this._internalMetadata=k,this._previousResult=Object.freeze(D.NotebookCellExecutionSummary.to(k))}setMime(k){}}e.ExtHostCell=E;class I{constructor(k,_,T,w,b){this._proxy=k,this._textDocumentsAndEditors=_,this._textDocuments=T,this.uri=w,this.handle=I._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=b.viewType,this._metadata=Object.freeze(b.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,b.cells]],!0,void 0),this._versionId=b.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const k=this,_={get uri(){return k.uri},get version(){return k._versionId},get notebookType(){return k._notebookType},get isDirty(){return k._isDirty},get isUntitled(){return k.uri.scheme===u.Schemas.untitled},get isClosed(){return k._disposed},get metadata(){return k._metadata},get cellCount(){return k._cells.length},cellAt(T){return T=k._validateIndex(T),k._cells[T].apiCell},getCells(T){return(T?k._getCells(T):k._cells).map(b=>b.apiCell)},save(){return k._save()}};this._notebook=Object.freeze(_)}return this._notebook}updateBackup(k){this._backup?.delete(),this._backup=k}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(k){k.metadata&&(this._metadata=Object.freeze({...this._metadata,...k.metadata}))}acceptDirty(k){this._isDirty=k}acceptModelChanged(k,_,T){this._versionId=k.versionId,this._isDirty=_,this.acceptDocumentPropertiesChanged({metadata:T});const w={notebook:this.apiNotebook,metadata:T,cellChanges:[],contentChanges:[]},b=[];for(const h of k.rawEvents)h.kind===y.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(h.changes,!1,w.contentChanges):h.kind===y.NotebookCellsChangeType.Move?this._moveCell(h.index,h.newIdx,w.contentChanges):h.kind===y.NotebookCellsChangeType.Output?(this._setCellOutputs(h.index,h.outputs),b.push({cell:this._cells[h.index].apiCell,outputs:this._cells[h.index].apiCell.outputs})):h.kind===y.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(h.index,h.outputId,h.append,h.outputItems),b.push({cell:this._cells[h.index].apiCell,outputs:this._cells[h.index].apiCell.outputs})):h.kind===y.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(h.index,h.language),b.push({cell:this._cells[h.index].apiCell,document:this._cells[h.index].apiCell.document})):h.kind===y.NotebookCellsChangeType.ChangeCellContent?b.push({cell:this._cells[h.index].apiCell,document:this._cells[h.index].apiCell.document}):h.kind===y.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(h.index,h.mime):h.kind===y.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(h.index,h.metadata),b.push({cell:this._cells[h.index].apiCell,metadata:this._cells[h.index].apiCell.metadata})):h.kind===y.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(h.index,h.internalMetadata),b.push({cell:this._cells[h.index].apiCell,executionSummary:this._cells[h.index].apiCell.executionSummary}));const v=new Map;for(let h=0;h<b.length;h++){const g=b[h],p=v.get(g.cell);if(p===void 0){const o=w.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...g});v.set(g.cell,o-1)}else w.cellChanges[p]={...w.cellChanges[p],...g}}return Object.freeze(w),Object.freeze(w.cellChanges),Object.freeze(w.contentChanges),w}_validateIndex(k){return k=k|0,k<0?0:k>=this._cells.length?this._cells.length-1:k}_validateRange(k){let _=k.start|0,T=k.end|0;return _<0&&(_=0),T>this._cells.length&&(T=this._cells.length),k.with({start:_,end:T})}_getCells(k){k=this._validateRange(k);const _=[];for(let T=k.start;T<k.end;T++)_.push(this._cells[T]);return _}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(k,_,T){if(this._disposed)return;const w=[],b=[],v=[];if(k.reverse().forEach(h=>{const p=h[2].map(c=>{const l=new E(this,this._textDocumentsAndEditors,c);return _||b.push(E.asModelAddData(this.apiNotebook,c)),l}),o=new C(h[0],h[1],[],p),m=this._cells.splice(h[0],h[1],...p);for(const c of m)v.push(c.uri),o.deletedItems.push(c.apiCell);w.push(o)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:b,removedDocuments:v}),T)for(const h of w)T.push(h.asApiEvent())}_moveCell(k,_,T){const w=this._cells.splice(k,1);this._cells.splice(_,0,...w);const b=[new C(k,1,w.map(v=>v.apiCell),[]),new C(_,0,[],w)];for(const v of b)T.push(v.asApiEvent())}_setCellOutputs(k,_){this._cells[k].setOutputs(_)}_setCellOutputItems(k,_,T,w){this._cells[k].setOutputItems(_,T,w)}_changeCellLanguage(k,_){const T=this._cells[k];T.apiCell.document.languageId!==_&&this._textDocuments.$acceptModelLanguageChanged(T.uri,_)}_changeCellMime(k,_){const T=this._cells[k];T.apiCell.mime=_}_changeCellMetadata(k,_){this._cells[k].setMetadata(_)}_changeCellInternalMetadata(k,_){this._cells[k].setInternalMetadata(_)}getCellFromApiCell(k){return this._cells.find(_=>_.apiCell===k)}getCellFromIndex(k){return this._cells[k]}getCell(k){return this._cells.find(_=>_.handle===k)}getCellIndex(k){return this._cells.indexOf(k)}}e.ExtHostNotebookDocument=I,I._handlePool=0}),define(De[130],Ie([1,0,7,16,10]),function(Z,e,u,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class P{constructor(E){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=E}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(E){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:E})}replaceCellMetadata(E,I){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:E,metadata:I})}replaceCells(E,I,R){this._throwIfFinalized(),!(E===I&&R.length===0)&&this._collectedEdits.push({editType:1,index:E,count:I-E,cells:R.map(t.NotebookCellData.from)})}}class y{constructor(E,I,R,k,_,T){this.id=E,this._proxy=I,this.notebookData=R,this._selections=[],this._visibleRanges=[],this._visible=!1,this._selections=_,this._visibleRanges=k,this._viewColumn=T}get apiEditor(){if(!this._editor){const E=this;this._editor={get document(){return E.notebookData.apiNotebook},get notebook(){return E.notebookData.apiNotebook},get selection(){return E._selections[0]},set selection(I){this.selections=[I]},get selections(){return E._selections},set selections(I){if(!Array.isArray(I)||!I.every(u.NotebookRange.isNotebookRange))throw(0,D.illegalArgument)("selections");E._selections=I,E._trySetSelections(I)},get visibleRanges(){return E._visibleRanges},revealRange(I,R){E._proxy.$tryRevealRange(E.id,t.NotebookRange.from(I),R??u.NotebookEditorRevealType.Default)},get viewColumn(){return E._viewColumn},edit(I){const R=new P(this.document.version);return I(R),E._applyEdit(R.finalize())}},y.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(E){this._visible=E}_acceptVisibleRanges(E){this._visibleRanges=E}_acceptSelections(E){this._selections=E}_trySetSelections(E){this._proxy.$trySetSelections(this.id,E.map(t.NotebookRange.from))}_acceptViewColumn(E){this._viewColumn=E}_applyEdit(E){if(E.cellEdits.length===0)return Promise.resolve(!0);const I=[];let R=-1;for(let k=0;k<E.cellEdits.length;k++){if(R<0){I.push(E.cellEdits[k]),R++;continue}const T=I[R],w=E.cellEdits[k];if(T.editType===1&&w.editType===1&&T.index===w.index){T.cells.push(...E.cellEdits[k].cells),T.count+=E.cellEdits[k].count;continue}I.push(E.cellEdits[k]),R++}return this._proxy.$tryApplyEdits(this.id,E.documentVersionId,I)}}e.ExtHostNotebookEditor=y,y.apiEditorsToExtHost=new WeakMap}),define(De[223],Ie([1,0,4,14,16]),function(Z,e,u,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let P=class{constructor(C,E){this._logService=C,this._notebooksAndEditors=E,this._onDidChangeNotebookEditorSelection=new u.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new u.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}$acceptEditorPropertiesChanged(C,E){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",C,E);const I=this._notebooksAndEditors.getEditorById(C);E.visibleRanges&&I._acceptVisibleRanges(E.visibleRanges.ranges.map(D.NotebookRange.to)),E.selections&&I._acceptSelections(E.selections.selections.map(D.NotebookRange.to)),E.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:I.apiEditor,visibleRanges:I.apiEditor.visibleRanges}),E.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:I.apiEditor,selections:I.apiEditor.selections}))}$acceptEditorViewColumns(C){for(const E in C)this._notebooksAndEditors.getEditorById(E)._acceptViewColumn(D.ViewColumn.to(C[E]))}};P=je([xe(0,t.ILogService)],P),e.ExtHostNotebookEditors=P}),define(De[224],Ie([1,0,16,118,170,21,57,10]),function(Z,e,u,t,D,P,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class E{constructor(_){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=_}async withProgress(_,T,w){const b=this._handles++,{title:v,location:h,cancellable:g}=T,p={label:(0,D.localize)(0,null,_.displayName||_.name),id:_.identifier.value};return this._proxy.$startProgress(b,{location:u.ProgressLocation.from(h),title:v,source:p,cancellable:g},_.isUnderDevelopment?void 0:_.identifier.value).catch(C.onUnexpectedExternalError),this._withProgress(b,w,!!g)}_withProgress(_,T,w){let b;w&&(b=new P.CancellationTokenSource,this._mapHandleToCancellationSource.set(_,b));const v=g=>{this._proxy.$progressEnd(g),this._mapHandleToCancellationSource.delete(g),b?.dispose()};let h;try{h=T(new R(this._proxy,_),w&&b?b.token:P.CancellationToken.None)}catch(g){throw v(_),g}return h.then(g=>v(_),g=>v(_)),h}$acceptProgressCanceled(_){const T=this._mapHandleToCancellationSource.get(_);T&&(T.cancel(),this._mapHandleToCancellationSource.delete(_))}}e.ExtHostProgress=E;function I(k,_){return k.message=_.message,typeof _.increment=="number"&&(typeof k.increment=="number"?k.increment+=_.increment:k.increment=_.increment),k}class R extends t.Progress{constructor(_,T){super(w=>this.throttledReport(w));this._proxy=_,this._handle=T}throttledReport(_){this._proxy.$progressReport(this._handle,_)}}je([(0,y.throttle)(100,(k,_)=>I(k,_),()=>Object.create(null))],R.prototype,"throttledReport",null)}),define(De[131],Ie([1,0,35,128,65,89,66,16,2]),function(Z,e,u,t,D,P,y,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const I=(p,o,m,c)=>{let l=o;return{enumerable:!0,configurable:!1,get(){return l},set(s){if(!m(l,s)){const i=l;l=s,p.listener?.(c(s,i))}}}},R=(p,o)=>p===o,k={range:(p,o)=>p===o?!0:!p||!o?!1:p.isEqual(o),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(p,o)=>!(p.length!==o.length||p.some(m=>!o.find(c=>m.id===c.id)))},_=p=>o=>({op:4,update:p(o)}),T=(p,o)=>({range:I(p,void 0,k.range,_(m=>({range:u.Range.lift(C.Range.from(m))}))),label:I(p,o,k.label,_(m=>({label:m}))),description:I(p,void 0,k.description,_(m=>({description:m}))),sortText:I(p,void 0,k.sortText,_(m=>({sortText:m}))),canResolveChildren:I(p,!1,k.canResolveChildren,m=>({op:2,state:m})),busy:I(p,!1,k.busy,_(m=>({busy:m}))),error:I(p,void 0,k.error,_(m=>({error:C.MarkdownString.fromStrict(m)||null}))),tags:I(p,[],k.tags,(m,c)=>({op:1,new:m.map(C.TestTag.from),old:c.map(C.TestTag.from)}))}),w=p=>{const o=D.TestId.fromString(p.extId),m=new v(o.controllerId,o.localId,p.label,E.URI.revive(p.uri)||void 0);return m.range=C.Range.to(p.range||void 0),m.description=p.description||void 0,m.sortText=p.sortText||void 0,m.tags=p.tags.map(c=>C.TestTag.to({id:(0,y.denamespaceTestTag)(c).tagId})),m},b=p=>{let o;for(const m of p.tests){const c=w(m.item);(0,t.getPrivateApiFor)(c).parent=o,o=c}return o};e.toItemFromContext=b;class v{constructor(o,m,c,l){if(m.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(m)} symbol`);const s=(0,t.createPrivateApiFor)(this,o);Object.defineProperties(this,{id:{value:m,enumerable:!0,writable:!1},uri:{value:l,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return s.parent instanceof h?void 0:s.parent}},children:{value:(0,P.createTestItemChildren)(s,t.getPrivateApiFor,v),enumerable:!0,writable:!1},...T(s,c)})}}e.TestItemImpl=v;class h extends v{constructor(o,m){super(o,o,m,void 0)}}e.TestItemRootImpl=h;class g extends P.TestItemCollection{constructor(o,m){super({controllerId:o,getApiFor:t.getPrivateApiFor,getChildren:c=>c.children,root:new h(o,m),toITestItem:C.TestItem.from})}}e.ExtHostTestItemCollection=g}),define(De[132],Ie([1,0,48,10,93,16,7]),function(Z,e,u,t,D,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class C{constructor(_,T,w){const b=C._Keys.nextId();_.$registerTextEditorDecorationType(T.identifier,b,P.DecorationRenderOptions.from(w)),this.value=Object.freeze({key:b,dispose(){_.$removeTextEditorDecorationType(b)}})}}e.TextEditorDecorationType=C,C._Keys=new D.IdGenerator("TextEditorDecorationType");class E{constructor(_,T){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=_,this._documentVersionId=_.version,this._undoStopBefore=T.undoStopBefore,this._undoStopAfter=T.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(_,T){this._throwIfFinalized();let w=null;if(_ instanceof y.Position)w=new y.Range(_,_);else if(_ instanceof y.Range)w=_;else throw new Error("Unrecognized location");this._pushEdit(w,T,!1)}insert(_,T){this._throwIfFinalized(),this._pushEdit(new y.Range(_,_),T,!0)}delete(_){this._throwIfFinalized();let T=null;if(_ instanceof y.Range)T=_;else throw new Error("Unrecognized location");this._pushEdit(T,null,!0)}_pushEdit(_,T,w){const b=this._document.validateRange(_);this._collectedEdits.push({range:b,text:T,forceMoveMarkers:w})}setEndOfLine(_){if(this._throwIfFinalized(),_!==y.EndOfLine.LF&&_!==y.EndOfLine.CRLF)throw(0,t.illegalArgument)("endOfLine");this._setEndOfLine=_}}e.TextEditorEdit=E;class I{constructor(_,T,w,b){this._proxy=_,this._id=T,this._accept(w),this._logService=b;const v=this;this.value={get tabSize(){return v._tabSize},set tabSize(h){v._setTabSize(h)},get insertSpaces(){return v._insertSpaces},set insertSpaces(h){v._setInsertSpaces(h)},get cursorStyle(){return v._cursorStyle},set cursorStyle(h){v._setCursorStyle(h)},get lineNumbers(){return v._lineNumbers},set lineNumbers(h){v._setLineNumbers(h)}}}_accept(_){this._tabSize=_.tabSize,this._insertSpaces=_.insertSpaces,this._cursorStyle=_.cursorStyle,this._lineNumbers=P.TextEditorLineNumbersStyle.to(_.lineNumbers)}_validateTabSize(_){if(_==="auto")return"auto";if(typeof _=="number"){const T=Math.floor(_);return T>0?T:null}if(typeof _=="string"){const T=parseInt(_,10);return isNaN(T)?null:T>0?T:null}return null}_setTabSize(_){const T=this._validateTabSize(_);if(T!==null){if(typeof T=="number"){if(this._tabSize===T)return;this._tabSize=T}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:T}))}}_validateInsertSpaces(_){return _==="auto"?"auto":_==="false"?!1:Boolean(_)}_setInsertSpaces(_){const T=this._validateInsertSpaces(_);if(typeof T=="boolean"){if(this._insertSpaces===T)return;this._insertSpaces=T}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:T}))}_setCursorStyle(_){this._cursorStyle!==_&&(this._cursorStyle=_,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:_})))}_setLineNumbers(_){this._lineNumbers!==_&&(this._lineNumbers=_,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:P.TextEditorLineNumbersStyle.from(_)})))}assign(_){const T={};let w=!1;if(typeof _.tabSize!="undefined"){const b=this._validateTabSize(_.tabSize);b==="auto"?(w=!0,T.tabSize=b):typeof b=="number"&&this._tabSize!==b&&(this._tabSize=b,w=!0,T.tabSize=b)}if(typeof _.insertSpaces!="undefined"){const b=this._validateInsertSpaces(_.insertSpaces);b==="auto"?(w=!0,T.insertSpaces=b):this._insertSpaces!==b&&(this._insertSpaces=b,w=!0,T.insertSpaces=b)}typeof _.cursorStyle!="undefined"&&this._cursorStyle!==_.cursorStyle&&(this._cursorStyle=_.cursorStyle,w=!0,T.cursorStyle=_.cursorStyle),typeof _.lineNumbers!="undefined"&&this._lineNumbers!==_.lineNumbers&&(this._lineNumbers=_.lineNumbers,w=!0,T.lineNumbers=P.TextEditorLineNumbersStyle.from(_.lineNumbers)),w&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,T))}_warnOnError(_,T){T.catch(w=>{this._logService.warn(`ExtHostTextEditorOptions '${_}' failed:'`),this._logService.warn(w)})}}e.ExtHostTextEditorOptions=I;class R{constructor(_,T,w,b,v,h,g,p){this.id=_,this._proxy=T,this._logService=w,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=v,this._options=new I(this._proxy,this.id,h,w),this._visibleRanges=g,this._viewColumn=p;const o=this;this.value=Object.freeze({get document(){return b.getValue()},set document(m){throw(0,t.readonly)("document")},get selection(){return o._selections&&o._selections[0]},set selection(m){if(!(m instanceof y.Selection))throw(0,t.illegalArgument)("selection");o._selections=[m],o._trySetSelection()},get selections(){return o._selections},set selections(m){if(!Array.isArray(m)||m.some(c=>!(c instanceof y.Selection)))throw(0,t.illegalArgument)("selections");o._selections=m,o._trySetSelection()},get visibleRanges(){return o._visibleRanges},set visibleRanges(m){throw(0,t.readonly)("visibleRanges")},get options(){return o._options.value},set options(m){o._disposed||o._options.assign(m)},get viewColumn(){return o._viewColumn},set viewColumn(m){throw(0,t.readonly)("viewColumn")},edit(m,c={undoStopBefore:!0,undoStopAfter:!0}){if(o._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const l=new E(b.getValue(),c);return m(l),o._applyEdit(l)},insertSnippet(m,c,l={undoStopBefore:!0,undoStopAfter:!0}){if(o._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!c||Array.isArray(c)&&c.length===0)s=o._selections.map(i=>P.Range.from(i));else if(c instanceof y.Position){const{lineNumber:i,column:r}=P.Position.from(c);s=[{startLineNumber:i,startColumn:r,endLineNumber:i,endColumn:r}]}else if(c instanceof y.Range)s=[P.Range.from(c)];else{s=[];for(const i of c)if(i instanceof y.Range)s.push(P.Range.from(i));else{const{lineNumber:r,column:n}=P.Position.from(i);s.push({startLineNumber:r,startColumn:n,endLineNumber:r,endColumn:n})}}return T.$tryInsertSnippet(_,b.getValue().version,m.value,s,l)},setDecorations(m,c){const l=c.length===0;l&&!o._hasDecorationsForKey.has(m.key)||(l?o._hasDecorationsForKey.delete(m.key):o._hasDecorationsForKey.add(m.key),o._runOnProxy(()=>{if(P.isDecorationOptionsArr(c))return T.$trySetDecorations(_,m.key,P.fromRangeOrRangeWithMessage(c));{const s=new Array(4*c.length);for(let i=0,r=c.length;i<r;i++){const n=c[i];s[4*i]=n.start.line+1,s[4*i+1]=n.start.character+1,s[4*i+2]=n.end.line+1,s[4*i+3]=n.end.character+1}return T.$trySetDecorationsFast(_,m.key,s)}}))},revealRange(m,c){o._runOnProxy(()=>T.$tryRevealRange(_,P.Range.from(m),c||y.TextEditorRevealType.Default))},show(m){T.$tryShowEditor(_,P.ViewColumn.from(m))},hide(){T.$tryHideEditor(_)}})}dispose(){(0,u.ok)(!this._disposed),this._disposed=!0}_acceptOptions(_){(0,u.ok)(!this._disposed),this._options._accept(_)}_acceptVisibleRanges(_){(0,u.ok)(!this._disposed),this._visibleRanges=_}_acceptViewColumn(_){(0,u.ok)(!this._disposed),this._viewColumn=_}_acceptSelections(_){(0,u.ok)(!this._disposed),this._selections=_}async _trySetSelection(){const _=this._selections.map(P.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,_)),this.value}_applyEdit(_){const T=_.finalize();if(T.edits.length===0&&!T.setEndOfLine)return Promise.resolve(!0);const w=T.edits.map(v=>v.range);w.sort((v,h)=>v.end.line===h.end.line?v.end.character===h.end.character?v.start.line===h.start.line?v.start.character-h.start.character:v.start.line-h.start.line:v.end.character-h.end.character:v.end.line-h.end.line);for(let v=0,h=w.length-1;v<h;v++){const g=w[v].end;if(w[v+1].start.isBefore(g))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const b=T.edits.map(v=>({range:P.Range.from(v.range),text:v.text,forceMoveMarkers:v.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,T.documentVersionId,b,{setEndOfLine:typeof T.setEndOfLine=="number"?P.EndOfLine.from(T.setEndOfLine):void 0,undoStopBefore:T.undoStopBefore,undoStopAfter:T.undoStopAfter})}_runOnProxy(_){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):_().then(()=>this,T=>(T instanceof Error&&T.name==="DISPOSED"||this._logService.warn(T),null))}}e.ExtHostTextEditor=R}),define(De[225],Ie([1,0,3,189]),function(Z,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,u.refineServiceDecorator)(t.IEnvironmentService)}),define(De[226],Ie([1,0,28,4,9]),function(Z,e,u,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class P{constructor(k){this.removedDueToLooping=k}}e.DeltaExtensionsResult=P;class y{constructor(k){this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=k,this._initialize()}_initialize(){this._extensionDescriptions.sort(E),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const k of this._extensionDescriptions){if(this._extensionsMap.has(u.ExtensionIdentifier.toKey(k.identifier))){console.error("Extension `"+k.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(u.ExtensionIdentifier.toKey(k.identifier),k),this._extensionsArr.push(k),Array.isArray(k.activationEvents))for(let _ of k.activationEvents)_==="onUri"&&(_=`onUri:${u.ExtensionIdentifier.toKey(k.identifier)}`),this._activationMap.has(_)||this._activationMap.set(_,[]),this._activationMap.get(_).push(k)}}set(k){this._extensionDescriptions=k,this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(k,_){this._extensionDescriptions=I(this._extensionDescriptions,_),this._extensionDescriptions=this._extensionDescriptions.concat(k);const T=y._findLoopingExtensions(this._extensionDescriptions);return this._extensionDescriptions=I(this._extensionDescriptions,T.map(w=>w.identifier)),this._initialize(),this._onDidChange.fire(void 0),new P(T)}static _findLoopingExtensions(k){const _=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(h){this._nodesSet.has(h)||(this._nodesSet.add(h),this._nodesArr.push(h))}addArc(h,g){this.addNode(h),this.addNode(g),this._arcs.has(h)?this._arcs.get(h).push(g):this._arcs.set(h,[g])}getArcs(h){return this._arcs.has(h)?this._arcs.get(h):[]}hasOnlyGoodArcs(h,g){const p=_.getArcs(h);for(let o=0;o<p.length;o++)if(!g.has(p[o]))return!1;return!0}getNodes(){return this._nodesArr}},T=new Map;for(const h of k){const g=u.ExtensionIdentifier.toKey(h.identifier);if(T.set(g,h),h.extensionDependencies)for(const p of h.extensionDependencies){const o=u.ExtensionIdentifier.toKey(p);_.addArc(g,o)}}const w=new Set;_.getNodes().filter(h=>_.getArcs(h).length===0).forEach(h=>w.add(h));const b=_.getNodes().filter(h=>!w.has(h));let v;do{v=!1;for(let h=0;h<b.length;h++){const g=b[h];_.hasOnlyGoodArcs(g,w)&&(b.splice(h,1),h--,w.add(g),v=!0)}}while(v);return b.map(h=>T.get(h))}containsActivationEvent(k){return this._activationMap.has(k)}containsExtension(k){return this._extensionsMap.has(u.ExtensionIdentifier.toKey(k))}getExtensionDescriptionsForActivationEvent(k){const _=this._activationMap.get(k);return _?_.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(k){const _=this._extensionsMap.get(u.ExtensionIdentifier.toKey(k));return _||void 0}getExtensionDescriptionByUUID(k){for(const _ of this._extensionsArr)if(_.uuid===k)return _}getExtensionDescriptionByIdOrUUID(k,_){return this.getExtensionDescription(k)??(_?this.getExtensionDescriptionByUUID(_):void 0)}}e.ExtensionDescriptionRegistry=y;var C;(function(R){R[R.Builtin=0]="Builtin",R[R.User=1]="User",R[R.Dev=2]="Dev"})(C||(C={}));function E(R,k){const _=R.isBuiltin?0:R.isUnderDevelopment?2:1,T=k.isBuiltin?0:k.isUnderDevelopment?2:1;if(_!==T)return _-T;const w=D.posix.basename(R.extensionLocation.path),b=D.posix.basename(k.extensionLocation.path);return w<b?-1:w>b?1:0}function I(R,k){const _=new Set;return k.forEach(T=>_.add(u.ExtensionIdentifier.toKey(T))),R.filter(T=>!_.has(u.ExtensionIdentifier.toKey(T.identifier)))}}),define(De[227],Ie([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readExtHostConnection=e.writeExtHostConnection=e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0;var u;(function(R){R[R.IPC=1]="IPC",R[R.Socket=2]="Socket",R[R.MessagePort=3]="MessagePort"})(u=e.ExtHostConnectionType||(e.ExtHostConnectionType={}));class t{constructor(k){this.pipeName=k,this.type=1}serialize(k){k[t.ENV_KEY]=this.pipeName}}e.IPCExtHostConnection=t,t.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK";class D{constructor(){this.type=2}serialize(k){k[D.ENV_KEY]="1"}}e.SocketExtHostConnection=D,D.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET";class P{constructor(){this.type=3}serialize(k){k[P.ENV_KEY]="1"}}e.MessagePortExtHostConnection=P,P.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT";function y(R){delete R[t.ENV_KEY],delete R[D.ENV_KEY],delete R[P.ENV_KEY]}function C(R,k){y(k),R.serialize(k)}e.writeExtHostConnection=C;function E(R){if(R[t.ENV_KEY])return I(R,new t(R[t.ENV_KEY]));if(R[D.ENV_KEY])return I(R,new D);if(R[P.ENV_KEY])return I(R,new P);throw new Error("No connection information defined in environment!")}e.readExtHostConnection=E;function I(R,k){return y(R),k}}),define(De[133],Ie([1,0,23]),function(Z,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var t;(function(I){I[I.Desktop=1]="Desktop",I[I.Web=2]="Web"})(t=e.UIKind||(e.UIKind={}));var D;(function(I){I[I.VersionMismatch=55]="VersionMismatch",I[I.UnexpectedError=81]="UnexpectedError"})(D=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var P;(function(I){I[I.Initialized=0]="Initialized",I[I.Ready=1]="Ready",I[I.Terminate=2]="Terminate"})(P=e.MessageType||(e.MessageType={}));function y(I){const R=u.VSBuffer.alloc(1);switch(I){case 0:R.writeUInt8(1,0);break;case 1:R.writeUInt8(2,0);break;case 2:R.writeUInt8(3,0);break}return R}e.createMessageOfType=y;function C(I,R){if(I.byteLength!==1)return!1;switch(I.readUInt8(0)){case 1:return R===0;case 2:return R===1;case 3:return R===2;default:return!1}}e.isMessageOfType=C;var E;(function(I){I.Start="START_NATIVE_LOG",I.End="END_NATIVE_LOG"})(E=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(De[27],Ie([1,0,4,2,3,28,198]),function(Z,e,u,t,D,P,y){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new P.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:t.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,D.createDecorator)("extensionService");class E{constructor(n){this.affinity=n,this.kind=1}equals(n){return this.kind===n.kind&&this.affinity===n.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=E;class I{constructor(){this.kind=2,this.affinity=0}equals(n){return this.kind===n.kind}asString(){return"LocalWebWorker"}}e.LocalWebWorkerRunningLocation=I;class R{constructor(){this.kind=3,this.affinity=0}equals(n){return this.kind===n.kind}asString(){return"Remote"}}e.RemoteRunningLocation=R;class k{constructor(n){this.dependency=n}}e.MissingExtensionDependency=k;var _;(function(r){r[r.LocalProcess=1]="LocalProcess",r[r.LocalWebWorker=2]="LocalWebWorker",r[r.Remote=3]="Remote"})(_=e.ExtensionHostKind||(e.ExtensionHostKind={}));function T(r){if(r===null)return"None";switch(r){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=T;class w{constructor(){this._allExtensions=[],this._myExtensions=[]}toDelta(){return{toRemove:[],toAdd:this._allExtensions,myToRemove:[],myToAdd:this._myExtensions}}set(n,a){const d=[],f=[],S=[],O=[],U=h(this._allExtensions),M=h(n),A=(K,X)=>K.extensionLocation.toString()===X.extensionLocation.toString()||K.isBuiltin===X.isBuiltin||K.isUserBuiltin===X.isUserBuiltin||K.isUnderDevelopment===X.isUnderDevelopment;for(const K of this._allExtensions){const X=M.get(P.ExtensionIdentifier.toKey(K.identifier));if(!X){d.push(K.identifier),U.delete(P.ExtensionIdentifier.toKey(K.identifier));continue}if(!A(K,X)){d.push(K.identifier),U.delete(P.ExtensionIdentifier.toKey(K.identifier));continue}}for(const K of n){const X=U.get(P.ExtensionIdentifier.toKey(K.identifier));if(!X){f.push(K);continue}if(!A(X,K)){d.push(X.identifier),U.delete(P.ExtensionIdentifier.toKey(X.identifier));continue}}const B=v(this._myExtensions),x=v(a);for(const K of this._myExtensions)x.has(P.ExtensionIdentifier.toKey(K))||S.push(K);for(const K of a)B.has(P.ExtensionIdentifier.toKey(K))||O.push(K);const N={toRemove:d,toAdd:f,myToRemove:S,myToAdd:O};return this.delta(N),N}delta(n){const{toRemove:a,toAdd:d,myToRemove:f,myToAdd:S}=n,O=v(a),U=v(f);for(let M=0;M<this._allExtensions.length;M++)O.has(P.ExtensionIdentifier.toKey(this._allExtensions[M].identifier))&&(this._allExtensions.splice(M,1),M--);for(let M=0;M<this._myExtensions.length;M++)U.has(P.ExtensionIdentifier.toKey(this._myExtensions[M]))&&(this._myExtensions.splice(M,1),M--);for(const M of d)this._allExtensions.push(M);for(const M of S)this._myExtensions.push(M)}containsExtension(n){for(const a of this._myExtensions)if(P.ExtensionIdentifier.equals(a,n))return!0;return!1}}e.ExtensionHostExtensions=w;class b{constructor(n){if(this[C]="ExtensionIdentifierSet",this._map=new Map,this._toKey=P.ExtensionIdentifier.toKey,n)for(const a of n)this.add(a)}get size(){return this._map.size}add(n){return this._map.set(this._toKey(n),n),this}clear(){this._map.clear()}delete(n){return this._map.delete(this._toKey(n))}has(n){return this._map.has(this._toKey(n))}forEach(n,a){this._map.forEach(d=>n.call(a,d,d,this))}*entries(){for(const[n,a]of this._map)yield[a,a]}keys(){return this._map.values()}values(){return this._map.values()}[(C=Symbol.toStringTag,Symbol.iterator)](){return this._map.values()}}e.ExtensionIdentifierSet=b;function v(r){const n=new Set;for(const a of r)n.add(P.ExtensionIdentifier.toKey(a));return n}e.extensionIdentifiersArrayToSet=v;function h(r){const n=new Map;for(const a of r)n.set(P.ExtensionIdentifier.toKey(a.identifier),a);return n}function g(r,n){return r.enabledApiProposals?r.enabledApiProposals.includes(n):!1}e.isProposedApiEnabled=g;function p(r,n){if(!g(r,n))throw new Error(`Extension '${r.identifier.value}' CANNOT use API proposal: ${n}.
Its package.json#enabledApiProposals-property declares: ${r.enabledApiProposals?.join(", ")??"[]"} but NOT ${n}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${r.identifier.value}`)}e.checkProposedApiEnabled=p;class o{constructor(n,a,d,f){this.codeLoadingTime=n,this.activateCallTime=a,this.activateResolvedTime=d,this.activationReason=f}}e.ActivationTimes=o;class m{constructor(n,a){this.description=n,this.value=a}}e.ExtensionPointContribution=m,e.ExtensionHostLogFileName="exthost";var c;(function(r){r[r.Normal=0]="Normal",r[r.Immediate=1]="Immediate"})(c=e.ActivationKind||(e.ActivationKind={}));function l(r){return{type:r.isBuiltin?0:1,isBuiltin:r.isBuiltin||r.isUserBuiltin,identifier:{id:(0,y.getGalleryExtensionId)(r.publisher,r.name),uuid:r.uuid},manifest:r,location:r.extensionLocation,targetPlatform:r.targetPlatform,validations:[],isValid:!0}}e.toExtension=l;function s(r,n){return{identifier:new P.ExtensionIdentifier((0,y.getExtensionId)(r.manifest.publisher,r.manifest.name)),isBuiltin:r.type===0,isUserBuiltin:r.type===1&&r.isBuiltin,isUnderDevelopment:!!n,extensionLocation:r.location,...r.manifest,uuid:r.identifier.uuid,targetPlatform:r.targetPlatform,browserNlsBundleUris:r.browserNlsBundleUris}}e.toExtensionDescription=s;class i{constructor(){this.onDidRegisterExtensions=u.Event.None,this.onDidChangeExtensionsStatus=u.Event.None,this.onDidChangeExtensions=u.Event.None,this.onWillActivateByEvent=u.Event.None,this.onDidChangeResponsiveChange=u.Event.None}activateByEvent(n){return Promise.resolve(void 0)}activationEventIsDone(n){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(n){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(n,a){return Promise.resolve(0)}getInspectPorts(n,a){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(n){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(n,a){return Promise.resolve()}}e.NullExtensionService=i}),define(De[228],Ie([1,0,10,28,27,14,18]),function(Z,e,u,t,D,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class C{constructor(v,h,g,p){this.startup=v,this.codeLoadingTime=h,this.activateCallTime=g,this.activateResolvedTime=p}}e.ExtensionActivationTimes=C,C.NONE=new C(!1,-1,-1,-1);class E{constructor(v){this._startup=v,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(v,h){return v===-1||h===-1?-1:h-v}build(){return new C(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=E;class I{constructor(v,h,g,p,o,m){this.activationFailed=v,this.activationFailedError=h,this.activationTimes=g,this.module=p,this.exports=o,this.subscriptions=m}}e.ActivatedExtension=I;class R extends I{constructor(v){super(!1,null,v,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=R;class k extends I{constructor(){super(!1,null,C.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=k;class _ extends I{constructor(v){super(!0,v,C.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=_;let T=class{constructor(v,h,g,p,o){this._logService=o,this._registry=v,this._resolvedExtensionsSet=new Set,h.forEach(m=>this._resolvedExtensionsSet.add(t.ExtensionIdentifier.toKey(m))),this._externalExtensionsMap=new Map,g.forEach(m=>this._externalExtensionsMap.set(t.ExtensionIdentifier.toKey(m),m)),this._host=p,this._operations=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[v,h]of this._operations)h.dispose()}isActivated(v){const h=this._operations.get(t.ExtensionIdentifier.toKey(v));return Boolean(h&&h.value)}getActivatedExtension(v){const h=this._operations.get(t.ExtensionIdentifier.toKey(v));if(!h||!h.value)throw new Error(`Extension '${v.value}' is not known or not activated`);return h.value}async activateByEvent(v,h){if(this._alreadyActivatedEvents[v])return;const g=this._registry.getExtensionDescriptionsForActivationEvent(v);await this._activateExtensions(g.map(p=>({id:p.identifier,reason:{startup:h,extensionId:p.identifier,activationEvent:v}}))),this._alreadyActivatedEvents[v]=!0}activateById(v,h){const g=this._registry.getExtensionDescription(v);if(!g)throw new Error(`Extension '${v}' is not known`);return this._activateExtensions([{id:g.identifier,reason:h}])}async _activateExtensions(v){const h=v.filter(g=>!this.isActivated(g.id)).map(g=>this._handleActivationRequest(g));await Promise.all(h.map(g=>g.wait()))}_handleActivationRequest(v){if(this._operations.has(t.ExtensionIdentifier.toKey(v.id)))return this._operations.get(t.ExtensionIdentifier.toKey(v.id));if(this._externalExtensionsMap.has(t.ExtensionIdentifier.toKey(v.id)))return this._createAndSaveOperation(v,null,[],null);const h=this._registry.getExtensionDescription(v.id);if(!h){const o=new Error(`Cannot activate unknown extension '${v.id.value}'`),m=this._createAndSaveOperation(v,null,[],new _(o));return this._host.onExtensionActivationError(v.id,o,new D.MissingExtensionDependency(v.id.value)),m}const g=[],p=typeof h.extensionDependencies=="undefined"?[]:h.extensionDependencies;for(const o of p){if(this._resolvedExtensionsSet.has(t.ExtensionIdentifier.toKey(o)))continue;const m=this._operations.get(t.ExtensionIdentifier.toKey(o));if(m){g.push(m);continue}if(this._externalExtensionsMap.has(t.ExtensionIdentifier.toKey(o))){g.push(this._handleActivationRequest({id:this._externalExtensionsMap.get(t.ExtensionIdentifier.toKey(o)),reason:v.reason}));continue}const c=this._registry.getExtensionDescription(o);if(c){if(!c.main&&!c.browser)continue;g.push(this._handleActivationRequest({id:c.identifier,reason:v.reason}));continue}const l=h.displayName||h.identifier.value,s=new Error(`Cannot activate the '${l}' extension because it depends on unknown extension '${o}'`),i=this._createAndSaveOperation(v,h.displayName,[],new _(s));return this._host.onExtensionActivationError(h.identifier,s,new D.MissingExtensionDependency(o)),i}return this._createAndSaveOperation(v,h.displayName,g,null)}_createAndSaveOperation(v,h,g,p){const o=new w(v.id,h,v.reason,g,p,this._host,this._logService);return this._operations.set(t.ExtensionIdentifier.toKey(v.id),o),o}};T=je([xe(4,P.ILogService)],T),e.ExtensionsActivator=T;let w=class{constructor(v,h,g,p,o,m,c){this._id=v,this._displayName=h,this._reason=g,this._deps=p,this._value=o,this._host=m,this._logService=c,this._barrier=new y.Barrier,this._isDisposed=!1,this._initialize()}get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let v=0;v<this._deps.length;v++){const h=this._deps[v];if(h.value&&!h.value.activationFailed){this._deps.splice(v,1),v--;continue}if(h.value&&h.value.activationFailed){const g=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${h.friendlyName}' failed to activate`);g.detail=h.value.activationFailedError,this._value=new _(g),this._host.onExtensionActivationError(this._id,g,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(v=>v.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(v){const h=new Error;if(v&&v.name&&(h.name=v.name),v&&v.message?h.message=`Activating extension '${this._id.value}' failed: ${v.message}.`:h.message=`Activating extension '${this._id.value}' failed: ${v}.`,v&&v.stack&&(h.stack=v.stack),this._value=new _(h),this._isDisposed&&u.isCancellationError(v))return;this._host.onExtensionActivationError(this._id,h,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(v)}}};w=je([xe(6,P.ILogService)],w)}),define(De[229],Ie([1,0,14,26,27]),function(Z,e,u,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let P=class extends u.LogService{constructor(C,E){super(C.createLogger(E.logFile,{name:D.ExtensionHostLogFileName}))}};P=je([xe(0,u.ILoggerService),xe(1,t.IExtHostInitDataService)],P),e.ExtHostLogService=P}),define(De[230],Ie([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",badges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.badges.d.ts",commentsResolvedState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsResolvedState.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorToolbar:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorToolbar.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewSize.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",contribWebviewContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribWebviewContext.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineCompletionsNew:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsNew.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookContentProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookContentProvider.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDebugOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDebugOptions.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookEditor.d.ts",notebookEditorEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookEditorEdit.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookWorkspaceEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookWorkspaceEdit.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",snippetWorkspaceEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.snippetWorkspaceEdit.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",telemetryLog:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetryLog.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(De[231],Ie([1,0,184,10,41,84,119,43,28,230,196]),function(Z,e,u,t,D,P,y,C,E,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const k=C.Registry.as(y.Extensions.JSONContribution);class _{constructor(o,m,c){this._messageHandler=o,this._extension=m,this._extensionPointId=c}_msg(o,m){this._messageHandler({type:o,message:m,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(o){this._msg(D.default.Error,o)}warn(o){this._msg(D.default.Warning,o)}info(o){this._msg(D.default.Info,o)}}e.ExtensionMessageCollector=_;class T{constructor(o,m){this.added=o,this.removed=m}static _toSet(o){const m=new Set;for(let c=0,l=o.length;c<l;c++)m.add(E.ExtensionIdentifier.toKey(o[c].description.identifier));return m}static compute(o,m){if(!o||!o.length)return new T(m,[]);if(!m||!m.length)return new T([],o);const c=this._toSet(o),l=this._toSet(m),s=m.filter(r=>!c.has(E.ExtensionIdentifier.toKey(r.description.identifier))),i=o.filter(r=>!l.has(E.ExtensionIdentifier.toKey(r.description.identifier)));return new T(s,i)}}e.ExtensionPointUserDelta=T;class w{constructor(o,m){this.name=o,this.defaultExtensionKind=m,this._handler=null,this._users=null,this._delta=null}setHandler(o){if(this._handler!==null)throw new Error("Handler already set!");this._handler=o,this._handle()}acceptUsers(o){this._delta=T.compute(this._users,o),this._users=o,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(o){(0,t.onUnexpectedError)(o)}}}e.ExtensionPoint=w;const b={type:"string",enum:["ui","workspace"],enumDescriptions:[u.localize(0,null),u.localize(1,null)]},v="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:u.localize(2,null),properties:{vscode:{type:"string",description:u.localize(3,null),default:"^1.22.0"}}},publisher:{description:u.localize(4,null),type:"string"},displayName:{description:u.localize(5,null),type:"string"},categories:{description:u.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:E.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:u.localize(7,null)}]}},galleryBanner:{type:"object",description:u.localize(8,null),properties:{color:{description:u.localize(9,null),type:"string"},theme:{description:u.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:u.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:u.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:u.localize(13,null)},enabledApiProposals:{markdownDescription:u.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(I.allApiProposals),markdownEnumDescriptions:Object.values(I.allApiProposals)}},activationEvents:{description:u.localize(15,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:u.localize(16,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:u.localize(17,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:u.localize(18,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:u.localize(19,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:u.localize(20,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:u.localize(21,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:u.localize(22,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:u.localize(23,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:u.localize(24,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:u.localize(25,null),body:"onStartupFinished"},{label:"onTaskType",description:u.localize(26,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:u.localize(27,null),body:"onFileSystem:${1:scheme}"},{label:"onSearch",description:u.localize(28,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:u.localize(29,null)},{label:"onIdentity",body:"onIdentity:${8:identity}",description:u.localize(30,null)},{label:"onUri",body:"onUri",description:u.localize(31,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:u.localize(32,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:u.localize(33,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:u.localize(34,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:u.localize(35,null)},{label:"onRenderer",description:u.localize(36,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:u.localize(37,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:u.localize(38,null)},{label:"*",description:u.localize(39,null),body:"*"}]}},badges:{type:"array",description:u.localize(40,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:u.localize(41,null)},href:{type:"string",description:u.localize(42,null)},description:{type:"string",description:u.localize(43,null)}}}},markdown:{type:"string",description:u.localize(44,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:u.localize(45,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:u.localize(46,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:P.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:u.localize(47,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:P.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:u.localize(48,null),type:"array",items:b,default:["workspace"],defaultSnippets:[{body:["ui"],description:u.localize(49,null)},{body:["workspace"],description:u.localize(50,null)},{body:["ui","workspace"],description:u.localize(51,null)},{body:["workspace","ui"],description:u.localize(52,null)},{body:[],description:u.localize(53,null)}]},capabilities:{description:u.localize(54,null),type:"object",properties:{virtualWorkspaces:{description:u.localize(55,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:u.localize(56,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[u.localize(57,null),u.localize(58,null),u.localize(59,null)]},description:{type:"string",markdownDescription:u.localize(60,null)}}},untrustedWorkspaces:{description:u.localize(61,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:u.localize(62,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[u.localize(63,null),u.localize(64,null),u.localize(65,null)]},restrictedConfigurations:{description:u.localize(66,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:u.localize(67,null)}}}}},sponsor:{description:u.localize(68,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:u.localize(69,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:u.localize(70,null),type:"string"},"vscode:uninstall":{description:u.localize(71,null),type:"string"}}},icon:{type:"string",description:u.localize(72,null)}}};class h{constructor(){this._extensionPoints=new Map}registerExtensionPoint(o){if(this._extensionPoints.has(o.extensionPoint))throw new Error("Duplicate extension point: "+o.extensionPoint);const m=new w(o.extensionPoint,o.defaultExtensionKind);return this._extensionPoints.set(o.extensionPoint,m),e.schema.properties.contributes.properties[o.extensionPoint]=o.jsonSchema,k.registerSchema(v,e.schema),m}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=h;const g={ExtensionsRegistry:"ExtensionsRegistry"};C.Registry.add(g.ExtensionsRegistry,new h),e.ExtensionsRegistry=C.Registry.as(g.ExtensionsRegistry),k.registerSchema(v,e.schema),k.registerSchema(R.productSchemaId,{properties:{extensionEnabledApiProposals:{description:u.localize(73,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(I.allApiProposals),markdownEnumDescriptions:Object.values(I.allApiProposals)}}]}}}})}),define(De[232],Ie([1,0,181,13,24,231,52,4]),function(Z,e,u,t,D,P,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=e.TaskDefinitionRegistryImpl=void 0;const E={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:u.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:u.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:u.localize(2,null),default:""}}};var I;(function(_){function T(w,b,v){if(!w)return;const h=t.isString(w.type)?w.type:void 0;if(!h||h.length===0){v.error(u.localize(3,null));return}const g=[];if(Array.isArray(w.required))for(const p of w.required)t.isString(p)&&g.push(p);return{extensionId:b.value,taskType:h,required:g,properties:w.properties?D.deepClone(w.properties):{},when:w.when?y.ContextKeyExpr.deserialize(w.when):void 0}}_.from=T})(I||(I={}));const R=P.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",jsonSchema:{description:u.localize(4,null),type:"array",items:E}});class k{constructor(){this._onDefinitionsChanged=new C.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((T,w)=>{R.setHandler((b,v)=>{this._schema=void 0;try{for(const h of v.removed){const g=h.value;for(const p of g)this.taskTypes&&p.type&&this.taskTypes[p.type]&&delete this.taskTypes[p.type]}for(const h of v.added){const g=h.value;for(const p of g){const o=I.from(p,h.description.identifier,h.collector);o&&(this.taskTypes[o.taskType]=o)}}(v.removed.length>0||v.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}T(void 0)})})}onReady(){return this.readyPromise}get(T){return this.taskTypes[T]}all(){return Object.keys(this.taskTypes).map(T=>this.taskTypes[T])}getJsonSchema(){if(this._schema===void 0){const T=[];for(const w of this.all()){const b={type:"object",additionalProperties:!1};w.required.length>0&&(b.required=w.required.slice(0)),w.properties!==void 0?b.properties=D.deepClone(w.properties):b.properties=Object.create(null),b.properties.type={type:"string",enum:[w.taskType]},T.push(b)}this._schema={oneOf:T}}return this._schema}}e.TaskDefinitionRegistryImpl=k,e.TaskDefinitionRegistry=new k}),define(De[233],Ie([1,0,182,13,22,24,52,232]),function(Z,e,u,t,D,P,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new y.RawContextKey("taskRunning",!1,u.localize(0,null)),e.TASKS_CATEGORY={value:u.localize(1,null),original:"Tasks"};var E;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(E=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(N){function K(X){if(!X)return N.Strong;switch(X.toLowerCase()){case"escape":return N.Escape;case"strong":return N.Strong;case"weak":return N.Weak;default:return N.Strong}}N.from=K}(E=e.ShellQuoting||(e.ShellQuoting={}));var I;(function(N){N.defaults={cwd:"${workspaceFolder}"}})(I=e.CommandOptions||(e.CommandOptions={}));var R;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(R=e.RevealKind||(e.RevealKind={})),function(N){function K(X){switch(X.toLowerCase()){case"always":return N.Always;case"silent":return N.Silent;case"never":return N.Never;default:return N.Always}}N.fromString=K}(R=e.RevealKind||(e.RevealKind={}));var k;(function(N){N[N.Never=1]="Never",N[N.OnProblem=2]="OnProblem",N[N.Always=3]="Always"})(k=e.RevealProblemKind||(e.RevealProblemKind={})),function(N){function K(X){switch(X.toLowerCase()){case"always":return N.Always;case"never":return N.Never;case"onproblem":return N.OnProblem;default:return N.OnProblem}}N.fromString=K}(k=e.RevealProblemKind||(e.RevealProblemKind={}));var _;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(_=e.PanelKind||(e.PanelKind={})),function(N){function K(X){switch(X.toLowerCase()){case"shared":return N.Shared;case"dedicated":return N.Dedicated;case"new":return N.New;default:return N.Shared}}N.fromString=K}(_=e.PanelKind||(e.PanelKind={}));var T;(function(N){N.defaults={echo:!0,reveal:R.Always,revealProblems:k.Never,focus:!1,panel:_.Shared,showReuseMessage:!0,clear:!1}})(T=e.PresentationOptions||(e.PresentationOptions={}));var w;(function(N){N[N.Shell=1]="Shell",N[N.Process=2]="Process",N[N.CustomExecution=3]="CustomExecution"})(w=e.RuntimeType||(e.RuntimeType={})),function(N){function K(L){switch(L.toLowerCase()){case"shell":return N.Shell;case"process":return N.Process;case"customExecution":return N.CustomExecution;default:return N.Process}}N.fromString=K;function X(L){switch(L){case N.Shell:return"shell";case N.Process:return"process";case N.CustomExecution:return"customExecution";default:return"process"}}N.toString=X}(w=e.RuntimeType||(e.RuntimeType={}));var b;(function(N){function K(X){return t.isString(X)?X:X.value}N.value=K})(b=e.CommandString||(e.CommandString={}));var v;(function(N){N.Clean={_id:"clean",isDefault:!1},N.Build={_id:"build",isDefault:!1},N.Rebuild={_id:"rebuild",isDefault:!1},N.Test={_id:"test",isDefault:!1};function K(L){return L===N.Clean._id||L===N.Build._id||L===N.Rebuild._id||L===N.Test._id}N.is=K;function X(L){if(L!==void 0)return t.isString(L)?K(L)?{_id:L,isDefault:!1}:void 0:L}N.from=X})(v=e.TaskGroup||(e.TaskGroup={}));var h;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.Folder=3]="Folder"})(h=e.TaskScope||(e.TaskScope={}));var g;(function(N){N.Workspace="workspace",N.Extension="extension",N.InMemory="inMemory",N.WorkspaceFile="workspaceFile",N.User="user";function K(X){switch(X){case N.User:return 2;case N.WorkspaceFile:return 5;default:return 6}}N.toConfigurationTarget=K})(g=e.TaskSourceKind||(e.TaskSourceKind={}));var p;(function(N){N.parallel="parallel",N.sequence="sequence"})(p=e.DependsOrder||(e.DependsOrder={}));var o;(function(N){N[N.default=1]="default",N[N.folderOpen=2]="folderOpen"})(o=e.RunOnOptions||(e.RunOnOptions={}));var m;(function(N){N.defaults={reevaluateOnRerun:!0,runOn:o.default,instanceLimit:1}})(m=e.RunOptions||(e.RunOptions={}));class c{constructor(K,X,L,$,H,j){this._label="",this._id=K,X&&(this._label=X),L&&(this.type=L),this.runOptions=$,this.configurationProperties=H,this._source=j}getDefinition(K){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const K={folder:this.getFolderId(),id:this._id};return JSON.stringify(K)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(K,X=!1){if(K===void 0)return!1;if(t.isString(K))return K===this._label||K===this.configurationProperties.identifier||X&&K===this._id;const L=this.getDefinition(!0);return L!==void 0&&L._key===K._key}getQualifiedLabel(){const K=this.getWorkspaceFolder();return K?`${this._label} (${K.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(K){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),K&&(this._taskLoadMessages=this._taskLoadMessages.concat(K))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=c;class l extends c{constructor(K,X,L,$,H,j,J,Y){super(K,L,void 0,J,Y,X);this.command={},this._source=X,this.hasDefinedMatchers=j,H&&(this.command=H)}clone(){return new l(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(K=!1){if(K&&this._source.customizes!==void 0)return this._source.customizes;{let X;switch(this.command?this.command.runtime:void 0){case w.Shell:X="shell";break;case w.Process:X="process";break;case w.CustomExecution:X="customExecution";break;case void 0:X="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:X,_key:this._id,id:this._id}}}static is(K){return K instanceof l}getMapKey(){const K=this._source.config.workspaceFolder;return K?`${K.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===g.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const K=this.getFolderId();if(!K)return;let X=this.configurationProperties.identifier;this._source.kind!==g.Workspace&&(X+=this._source.kind);const L={type:e.CUSTOMIZED_TASK_TYPE,folder:K,id:X};return JSON.stringify(L)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?D.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(K){return new l(K._id,K._source,K._label,K.type,K.command,K.hasDefinedMatchers,K.runOptions,K.configurationProperties)}}e.CustomTask=l;class s extends c{constructor(K,X,L,$,H,j,J){super(K,L,$,j,J,X);this._source=X,this.configures=H}static is(K){return K instanceof s}fromObject(K){return K}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?D.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===g.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const K=this.getFolderId();if(!K)return;let X=this.configurationProperties.identifier;this._source.kind!==g.Workspace&&(X+=this._source.kind);const L={type:e.CUSTOMIZED_TASK_TYPE,folder:K,id:X};return JSON.stringify(L)}}e.ConfiguringTask=s;class i extends c{constructor(K,X,L,$,H,j,J,Y,he){super(K,L,$,Y,he,X);this.defines=H,this.hasDefinedMatchers=J,this.command=j,this.icon=he.icon,this.hide=he.hide}clone(){return new i(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(K){return K instanceof i}getMapKey(){const K=this._source.workspaceFolder;return K?`${this._source.scope.toString()}|${K.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const K={type:"contributed",scope:this._source.scope,id:this._id};return K.folder=this.getFolderId(),JSON.stringify(K)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(K){return new i(K._id,K._source,K._label,K.type,K.defines,K.command,K.hasDefinedMatchers,K.runOptions,K.configurationProperties)}}e.ContributedTask=i;class r extends c{constructor(K,X,L,$,H,j){super(K,L,$,H,j,X);this._source=X}clone(){return new r(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(K){return K instanceof r}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(K){return new r(K._id,K._source,K._label,K.type,K.runOptions,K.configurationProperties)}}e.InMemoryTask=r;var n;(function(N){N[N.Process=1]="Process",N[N.Terminal=2]="Terminal"})(n=e.ExecutionEngine||(e.ExecutionEngine={})),function(N){N._default=N.Terminal}(n=e.ExecutionEngine||(e.ExecutionEngine={}));var a;(function(N){N[N.V0_1_0=1]="V0_1_0",N[N.V2_0_0=2]="V2_0_0"})(a=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class d{constructor(K){this._order=new Map;for(let X=0;X<K.length;X++)this._order.set(K[X].uri.toString(),X)}compare(K,X){const L=K.getWorkspaceFolder(),$=X.getWorkspaceFolder();if(L&&$){let H=this._order.get(L.uri.toString());H=H===void 0?0:H+1;let j=this._order.get($.uri.toString());return j=j===void 0?0:j+1,H===j?K._label.localeCompare(X._label):H-j}else return!L&&$?-1:L&&!$?1:0}}e.TaskSorter=d;var f;(function(N){N.DependsOnStarted="dependsOnStarted",N.AcquiredInput="acquiredInput",N.Start="start",N.ProcessStarted="processStarted",N.Active="active",N.Inactive="inactive",N.Changed="changed",N.Terminated="terminated",N.ProcessEnded="processEnded",N.End="end"})(f=e.TaskEventKind||(e.TaskEventKind={}));var S;(function(N){N.SingleRun="singleRun",N.Background="background"})(S=e.TaskRunType||(e.TaskRunType={}));var O;(function(N){N[N.System=0]="System",N[N.User=1]="User",N[N.FolderOpen=2]="FolderOpen",N[N.ConfigurationChange=3]="ConfigurationChange",N[N.Reconnect=4]="Reconnect"})(O=e.TaskRunSource||(e.TaskRunSource={}));var U;(function(N){function K(X,L,$,H,j){if(L){const J={kind:X,taskId:L._id,taskName:L.configurationProperties.name,runType:L.configurationProperties.isBackground?"background":"singleRun",group:L.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:void 0,__task:L};return X==="start"?(J.terminalId=$,J.resolvedVariables=H):X==="processStarted"?J.processId=$:X==="processEnded"&&(J.exitCode=$),Object.freeze(J)}else return Object.freeze({kind:"changed"})}N.create=K})(U=e.TaskEvent||(e.TaskEvent={}));var M;(function(N){function K(L){const $=Object.keys(L).sort();let H="";for(const j of $){let J=L[j];J instanceof Object?J=K(J):typeof J=="string"&&(J=J.replace(/,/g,",,")),H+=j+","+J+","}return H}function X(L){const H={_key:K(L),type:L.taskType};return Object.assign(H,L),H}N.create=X})(M=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var A;(function(N){N.AutoDetect="task.autoDetect",N.SaveBeforeRun="task.saveBeforeRun",N.ShowDecorations="task.showDecorations",N.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",N.SlowProviderWarning="task.slowProviderWarning",N.QuickOpenHistory="task.quickOpen.history",N.QuickOpenDetail="task.quickOpen.detail",N.QuickOpenSkip="task.quickOpen.skip",N.QuickOpenShowAll="task.quickOpen.showAll",N.AllowAutomaticTasks="task.allowAutomaticTasks",N.Reconnection="task.experimental.reconnection"})(A=e.TaskSettingId||(e.TaskSettingId={}));var B;(function(N){N.Tasks="tasks",N.SuppressTaskName="tasks.suppressTaskName",N.Windows="tasks.windows",N.Osx="tasks.osx",N.Linux="tasks.linux",N.ShowOutput="tasks.showOutput",N.IsShellCommand="tasks.isShellCommand",N.ServiceTestSetting="tasks.service.testSetting"})(B=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var x;(function(N){function K(X,L){const $=C.TaskDefinitionRegistry.get(X.type);if($===void 0){const Y=P.deepClone(X);return delete Y._key,M.create(Y)}const H=Object.create(null);H.type=$.taskType;const j=new Set;$.required.forEach(Y=>j.add(Y));const J=$.properties;for(const Y of Object.keys(J)){const he=X[Y];if(he!=null)H[Y]=he;else if(j.has(Y)){const ve=J[Y];if(ve.default!==void 0)H[Y]=P.deepClone(ve.default);else switch(ve.type){case"boolean":H[Y]=!1;break;case"number":case"integer":H[Y]=0;break;case"string":H[Y]="";break;default:L.error(u.localize(2,null,JSON.stringify(X,void 0,0),Y));return}}}return M.create(H)}N.createTaskIdentifier=K})(x=e.TaskDefinition||(e.TaskDefinition={}))}),define(De[234],Ie([1,0,10]),function(Z,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class t{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((y,C)=>{this._actualOk=y,this._actualErr=C,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(y){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=y,this._actual&&this._actualOk(y))}resolveErr(y){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=y,this._actual?this._actualErr(y):(0,u.onUnexpectedError)(y))}then(y,C){return this._ensureActual().then(y,C)}catch(y){return this._ensureActual().then(void 0,y)}finally(y){return this._ensureActual().finally(y)}}e.LazyPromise=t;class D extends t{constructor(){super();this._hasErr=!0,this._err=new u.CancellationError}}e.CanceledLazyPromise=D}),define(De[54],Ie([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class u{constructor(E){this._proxyIdentifierBrand=void 0,this.sid=E,this.nid=++u.count}}e.ProxyIdentifier=u,u.count=0;const t=[];function D(C){const E=new u(C);return t[E.nid]=E,E}e.createProxyIdentifier=D;function P(C){return t[C].sid}e.getStringIdentifierForProxy=P;class y{constructor(E){this.value=E}}e.SerializableObjectWithBuffers=y}),define(De[5],Ie([1,0,61,54]),function(Z,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var D;(function(h){h[h.Default=0]="Default",h[h.InCenter=1]="InCenter",h[h.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",h[h.AtTop=3]="AtTop"})(D=e.TextEditorRevealType||(e.TextEditorRevealType={}));var P;(function(h){h[h.UnknownInput=0]="UnknownInput",h[h.TextInput=1]="TextInput",h[h.TextDiffInput=2]="TextDiffInput",h[h.TextMergeInput=3]="TextMergeInput",h[h.NotebookInput=4]="NotebookInput",h[h.NotebookDiffInput=5]="NotebookDiffInput",h[h.CustomEditorInput=6]="CustomEditorInput",h[h.WebviewEditorInput=7]="WebviewEditorInput",h[h.TerminalEditorInput=8]="TerminalEditorInput",h[h.InteractiveEditorInput=9]="InteractiveEditorInput"})(P=e.TabInputKind||(e.TabInputKind={}));var y;(function(h){h[h.TAB_OPEN=0]="TAB_OPEN",h[h.TAB_CLOSE=1]="TAB_CLOSE",h[h.TAB_UPDATE=2]="TAB_UPDATE",h[h.TAB_MOVE=3]="TAB_MOVE"})(y=e.TabModelOperationKind||(e.TabModelOperationKind={}));var C;(function(h){h[h.Editable=0]="Editable",h[h.SupportsHotExit=1]="SupportsHotExit"})(C=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var E;(function(h){h[h.Int8Array=1]="Int8Array",h[h.Uint8Array=2]="Uint8Array",h[h.Uint8ClampedArray=3]="Uint8ClampedArray",h[h.Int16Array=4]="Int16Array",h[h.Uint16Array=5]="Uint16Array",h[h.Int32Array=6]="Int32Array",h[h.Uint32Array=7]="Uint32Array",h[h.Float32Array=8]="Float32Array",h[h.Float64Array=9]="Float64Array",h[h.BigInt64Array=10]="BigInt64Array",h[h.BigUint64Array=11]="BigUint64Array"})(E=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var I;(function(h){h[h.Text=1]="Text",h[h.Error=2]="Error",h[h.Rich=3]="Rich"})(I=e.CellOutputKind||(e.CellOutputKind={}));var R;(function(h){h[h.Default=0]="Default",h[h.InCenter=1]="InCenter",h[h.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",h[h.AtTop=3]="AtTop"})(R=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var k;(function(h){h[h.None=0]="None",h[h.Process=1]="Process",h[h.Output=2]="Output"})(k=e.CandidatePortSource||(e.CandidatePortSource={}));class _{static mixin(g){return g._id=_._n++,g}}e.IdObject=_,_._n=0;var T;(function(h){h.label="a",h.kind="b",h.detail="c",h.documentation="d",h.sortText="e",h.filterText="f",h.preselect="g",h.insertText="h",h.insertTextRules="i",h.range="j",h.commitCharacters="k",h.additionalTextEdits="l",h.command="m",h.kindModifier="n"})(T=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var w;(function(h){h.defaultRanges="a",h.completions="b",h.isIncomplete="c",h.duration="d"})(w=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));function b(h){return h&&h.edits&&(0,u.revive)(h),h}e.reviveWorkspaceEditDto=b;var v;(function(h){h[h.Workspace=0]="Workspace",h[h.TextDocument=1]="TextDocument"})(v=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,t.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,t.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,t.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,t.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,t.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,t.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,t.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,t.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,t.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,t.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,t.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,t.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,t.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,t.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,t.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,t.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,t.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,t.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,t.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,t.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,t.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,t.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,t.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,t.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,t.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,t.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,t.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,t.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,t.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,t.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,t.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,t.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,t.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,t.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,t.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,t.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,t.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,t.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,t.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,t.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,t.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,t.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,t.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,t.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,t.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,t.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,t.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,t.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,t.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,t.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,t.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,t.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,t.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,t.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,t.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,t.createProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,t.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,t.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,t.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,t.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,t.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,t.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,t.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,t.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,t.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,t.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,t.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,t.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,t.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,t.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,t.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,t.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,t.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,t.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,t.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,t.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,t.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,t.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,t.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,t.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,t.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,t.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,t.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,t.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,t.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,t.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,t.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,t.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,t.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,t.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,t.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,t.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,t.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,t.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,t.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,t.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,t.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,t.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,t.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,t.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,t.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,t.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,t.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,t.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,t.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,t.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,t.createProxyIdentifier)("ExtHostTelemetry")}}),define(De[90],Ie([1,0,5,4,3]),function(Z,e,u,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class P{constructor(C){this._onDidChangePassword=new t.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=C.getProxy(u.MainContext.MainThreadSecretState)}async $onDidChangePassword(C){this._onDidChangePassword.fire(C)}get(C,E){return this._proxy.$getPassword(C,E)}store(C,E,I){return this._proxy.$setPassword(C,E,I)}delete(C,E){return this._proxy.$deletePassword(C,E)}}e.ExtHostSecretState=P,e.IExtHostSecretState=(0,D.createDecorator)("IExtHostSecretState")}),define(De[67],Ie([1,0,3,14,5,15]),function(Z,e,u,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,u.createDecorator)("IExtHostApiDeprecationService");let y=class{constructor(E,I){this._extHostLogService=I,this._reportedUsages=new Set,this._telemetryShape=E.getProxy(D.MainContext.MainThreadTelemetry)}report(E,I,R){const k=this.getUsageKey(E,I);this._reportedUsages.has(k)||(this._reportedUsages.add(k),I.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${E}' is deprecated. ${R}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:I.identifier.value,apiId:E}))}getUsageKey(E,I){return`${E}-${I.identifier.value}`}};y=je([xe(0,P.IExtHostRpcService),xe(1,t.ILogService)],y),e.ExtHostApiDeprecationService=y,e.NullApiDeprecationService=Object.freeze(new class{report(C,E,I){}})}),define(De[235],Ie([1,0,4,5,7,28]),function(Z,e,u,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class y{constructor(E){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new u.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=E.getProxy(t.MainContext.MainThreadAuthentication)}$setProviders(E){return this._providers=E,Promise.resolve()}async getSession(E,I,R,k={}){const _=P.ExtensionIdentifier.toKey(E.identifier),T=this._inFlightRequests.get(_)||[],w=[...R].sort().join(" ");let b=T.find(v=>v.providerId===I&&v.scopes===w);if(b)return b.result;{const v=this._getSession(E,_,I,R,k);b={providerId:I,scopes:w,result:v},T.push(b),this._inFlightRequests.set(_,T);try{await v}finally{const h=T.findIndex(g=>g.providerId===I&&g.scopes===w);h>-1&&(T.splice(h),this._inFlightRequests.set(_,T))}return v}}async _getSession(E,I,R,k,_={}){await this._proxy.$ensureProvider(R);const T=E.displayName||E.name;return this._proxy.$getSession(R,k,I,T,_)}async removeSession(E,I){const R=this._authenticationProviders.get(E);return R?R.provider.removeSession(I):this._proxy.$removeSession(E,I)}registerAuthenticationProvider(E,I,R,k){if(this._authenticationProviders.get(E))throw new Error(`An authentication provider with id '${E}' is already registered.`);this._authenticationProviders.set(E,{label:I,provider:R,options:k??{supportsMultipleAccounts:!1}}),this._providers.find(T=>T.id===E)||this._providers.push({id:E,label:I});const _=R.onDidChangeSessions(T=>{this._proxy.$sendDidChangeSessions(E,{added:T.added??[],changed:T.changed??[],removed:T.removed??[]})});return this._proxy.$registerAuthenticationProvider(E,I,k?.supportsMultipleAccounts??!1),new D.Disposable(()=>{_.dispose(),this._authenticationProviders.delete(E);const T=this._providers.findIndex(w=>w.id===E);T>-1&&this._providers.splice(T),this._proxy.$unregisterAuthenticationProvider(E)})}$createSession(E,I){const R=this._authenticationProviders.get(E);if(R)return Promise.resolve(R.provider.createSession(I));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$removeSession(E,I){const R=this._authenticationProviders.get(E);if(R)return Promise.resolve(R.provider.removeSession(I));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$getSessions(E,I){const R=this._authenticationProviders.get(E);if(R)return Promise.resolve(R.provider.getSessions(I));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$onDidChangeAuthenticationSessions(E,I){return this._onDidChangeSessions.fire({provider:{id:E,label:I}}),Promise.resolve()}}e.ExtHostAuthentication=y}),define(De[236],Ie([1,0,5,15,16,27]),function(Z,e,u,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let y=class{constructor(E,I){this._proxy=E.getProxy(u.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:R=>I.getDocument(R)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(E,I){const R=(0,P.isProposedApiEnabled)(I,"snippetWorkspaceEdit"),k=D.WorkspaceEdit.from(E,this._versionInformationProvider,R);return this._proxy.$tryApplyWorkspaceEdit(k)}};y=je([xe(0,t.IExtHostRpcService)],y),e.ExtHostBulkEdits=y}),define(De[237],Ie([1,0,5]),function(Z,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class t{constructor(P){const y=P.getProxy(u.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return y.$readText()},writeText(C){return y.$writeText(C)}})}}e.ExtHostClipboard=t});var et=this&&this.__classPrivateFieldSet||function(Z,e,u,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!D:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(Z,u):D?D.value=u:e.set(Z,u),u},Me=this&&this.__classPrivateFieldGet||function(Z,e,u,t){if(u==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?t:u==="a"?t.call(Z):t?t.value:e.get(Z)};define(De[37],Ie([1,0,13,7,16,24,5,17,14,61,35,49,2,6,3,15,131,23,54,50]),function(Z,e,u,t,D,P,y,C,E,I,R,k,_,T,w,b,v,h,g,p){"use strict";var o,m;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let c=class{constructor(a,d){o.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,m.set(this,void 0),et(this,o,a.getProxy(y.MainContext.MainThreadCommands),"f"),this._logService=d,et(this,m,a.getProxy(y.MainContext.MainThreadTelemetry),"f"),this.converter=new l(this,f=>{const S=this._apiCommands.get(f);return S?.result===i.Void?S:void 0},d),this._argumentProcessors=[{processArgument(f){return(0,I.revive)(f)}},{processArgument(f){return(0,P.cloneAndChange)(f,function(S){if(R.Range.isIRange(S))return D.Range.to(S);if(k.Position.isIPosition(S))return D.Position.to(S);if(R.Range.isIRange(S.range)&&_.URI.isUri(S.uri))return D.location.to(S);if(S instanceof h.VSBuffer)return S.buffer.buffer;if(!Array.isArray(S))return S})}}]}registerArgumentProcessor(a){this._argumentProcessors.push(a)}registerApiCommand(a){const d=this.registerCommand(!1,a.id,async(...f)=>{const S=a.args.map((U,M)=>{if(!U.validate(f[M]))throw new Error(`Invalid argument '${U.name}' when running '${a.id}', received: ${f[M]}`);return U.convert(f[M])}),O=await this.executeCommand(a.internalId,...S);return a.result.convert(O,f,this.converter)},void 0,{description:a.description,args:a.args,returns:a.result.description});return this._apiCommands.set(a.id,a),new t.Disposable(()=>{d.dispose(),this._apiCommands.delete(a.id)})}registerCommand(a,d,f,S,O,U){if(this._logService.trace("ExtHostCommands#registerCommand",d),!d.trim().length)throw new Error("invalid id");if(this._commands.has(d))throw new Error(`command '${d}' already exists`);return this._commands.set(d,{callback:f,thisArg:S,description:O,extension:U}),a&&Me(this,o,"f").$registerCommand(d),new t.Disposable(()=>{this._commands.delete(d)&&a&&Me(this,o,"f").$unregisterCommand(d)})}executeCommand(a,...d){return this._logService.trace("ExtHostCommands#executeCommand",a),this._doExecuteCommand(a,d,!0)}async _doExecuteCommand(a,d,f){if(this._commands.has(a))return Me(this,o,"f").$fireCommandActivationEvent(a),this._executeContributedCommand(a,d,!1);{let S=!1;const O=(0,P.cloneAndChange)(d,function(U){if(U instanceof t.Position)return D.Position.from(U);if(U instanceof t.Range)return D.Range.from(U);if(U instanceof t.Location)return D.location.from(U);if(t.NotebookRange.isNotebookRange(U))return D.NotebookRange.from(U);if(U instanceof ArrayBuffer)return S=!0,h.VSBuffer.wrap(new Uint8Array(U));if(U instanceof Uint8Array)return S=!0,h.VSBuffer.wrap(U);if(U instanceof h.VSBuffer)return S=!0,U;if(!Array.isArray(U))return U});try{const U=await Me(this,o,"f").$executeCommand(a,S?new g.SerializableObjectWithBuffers(O):O,f);return(0,I.revive)(U)}catch(U){if(U instanceof Error&&U.message==="$executeCommand:retry")return this._doExecuteCommand(a,d,!1);throw U}}}async _executeContributedCommand(a,d,f){const S=this._commands.get(a);if(!S)throw new Error("Unknown command");this._reportTelemetry(S,a);const{callback:O,thisArg:U,description:M}=S;if(M)for(let A=0;A<M.args.length;A++)try{(0,u.validateConstraint)(d[A],M.args[A].constraint)}catch{throw new Error(`Running the contributed command: '${a}' failed. Illegal argument '${M.args[A].name}' - ${M.args[A].description}`)}try{return await O.apply(U,d)}catch(A){if(a===this.converter.delegatingCommandId){const B=this.converter.getActualCommand(...d);B&&(a=B.command)}throw this._logService.error(A,a,S.extension?.identifier),f?new class extends Error{constructor(){super((0,p.toErrorMessage)(A));this.id=a,this.source=S.extension?.displayName??S.extension?.name}}:A}}_reportTelemetry(a,d){!a.extension||a.extension.isBuiltin||Me(this,m,"f").$publicLog2("Extension:ActionExecuted",{extensionId:a.extension.identifier.value,id:d})}$executeContributedCommand(a,...d){return this._logService.trace("ExtHostCommands#$executeContributedCommand",a),this._commands.has(a)?(d=d.map(f=>this._argumentProcessors.reduce((S,O)=>O.processArgument(S),f)),this._executeContributedCommand(a,d,!0)):Promise.reject(new Error(`Contributed command '${a}' does not exist.`))}getCommands(a=!1){return this._logService.trace("ExtHostCommands#getCommands",a),Me(this,o,"f").$getCommands().then(d=>(a&&(d=d.filter(f=>f[0]!=="_")),d))}$getContributedCommandHandlerDescriptions(){const a=Object.create(null);for(const[d,f]of this._commands){const{description:S}=f;S&&(a[d]=S)}return Promise.resolve(a)}};o=new WeakMap,m=new WeakMap,c=je([xe(0,b.IExtHostRpcService),xe(1,E.ILogService)],c),e.ExtHostCommands=c,e.IExtHostCommands=(0,w.createDecorator)("IExtHostCommands");class l{constructor(a,d,f){this._commands=a,this._lookupApiCommand=d,this._logService=f,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(a,d){if(!a)return;const f={$ident:void 0,id:a.command,title:a.title,tooltip:a.tooltip};if(!a.command)return f;const S=this._lookupApiCommand(a.command);if(S)f.id=S.internalId,f.arguments=S.args.map((O,U)=>O.convert(a.arguments&&a.arguments[U]));else if((0,C.isNonEmptyArray)(a.arguments)){const O=++this._cachIdPool;this._cache.set(O,a),d.add((0,T.toDisposable)(()=>{this._cache.delete(O),this._logService.trace("CommandsConverter#DISPOSE",O)})),f.$ident=O,f.id=this.delegatingCommandId,f.arguments=[O],this._logService.trace("CommandsConverter#CREATE",a.command,O)}return f}fromInternal(a){return typeof a.$ident=="number"?this._cache.get(a.$ident):{command:a.id,title:a.title,arguments:a.arguments}}getActualCommand(...a){return this._cache.get(a[0])}_executeConvertedCommand(...a){const d=this.getActualCommand(...a);return this._logService.trace("CommandsConverter#EXECUTE",a[0],d?d.command:"MISSING"),d?this._commands.executeCommand(d.command,...d.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=l;class s{constructor(a,d,f,S){this.name=a,this.description=d,this.validate=f,this.convert=S}optional(){return new s(this.name,`(optional) ${this.description}`,a=>a==null||this.validate(a),a=>a===void 0?void 0:a===null?null:this.convert(a))}with(a,d){return new s(a??this.name,d??this.description,this.validate,this.convert)}}e.ApiCommandArgument=s,s.Uri=new s("uri","Uri of a text document",n=>_.URI.isUri(n),n=>n),s.Position=new s("position","A position in a text document",n=>t.Position.isPosition(n),D.Position.from),s.Range=new s("range","A range in a text document",n=>t.Range.isRange(n),D.Range.from),s.Selection=new s("selection","A selection in a text document",n=>t.Selection.isSelection(n),D.Selection.from),s.Number=new s("number","",n=>typeof n=="number",n=>n),s.String=new s("string","",n=>typeof n=="string",n=>n),s.CallHierarchyItem=new s("item","A call hierarchy item",n=>n instanceof t.CallHierarchyItem,D.CallHierarchyItem.from),s.TypeHierarchyItem=new s("item","A type hierarchy item",n=>n instanceof t.TypeHierarchyItem,D.TypeHierarchyItem.from),s.TestItem=new s("testItem","A VS Code TestItem",n=>n instanceof v.TestItemImpl,D.TestItem.from);class i{constructor(a,d){this.description=a,this.convert=d}}e.ApiCommandResult=i,i.Void=new i("no result",n=>n);class r{constructor(a,d,f,S,O){this.id=a,this.internalId=d,this.description=f,this.args=S,this.result=O}}e.ApiCommand=r}),define(De[238],Ie([1,0,2,16,7,63,37,17,113,117,12]),function(Z,e,u,t,D,P,y,C,E,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const k=[new y.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",T(t.DocumentHighlight.to))),new y.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(b,v)=>{if((0,C.isFalsyOrEmpty)(b))return;class h extends D.SymbolInformation{static to(p){const o=new h(p.name,t.SymbolKind.to(p.kind),p.containerName||"",new D.Location(v[0],t.Range.to(p.range)));return o.detail=p.detail,o.range=o.location.range,o.selectionRange=t.Range.to(p.selectionRange),o.children=p.children?p.children.map(h.to):[],o}}return b.map(h.to)})),new y.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("options","Formatting options",b=>!0,b=>b)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",T(t.TextEdit.to))),new y.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range,new y.ApiCommandArgument("options","Formatting options",b=>!0,b=>b)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",T(t.TextEdit.to))),new y.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,new y.ApiCommandArgument("ch","Trigger character",b=>typeof b=="string",b=>b),new y.ApiCommandArgument("options","Formatting options",b=>!0,b=>b)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",T(t.TextEdit.to))),new y.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",w)),new y.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",w)),new y.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",w)),new y.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",w)),new y.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location-instances.",T(t.location.to))),new y.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Hover-instances.",T(t.Hover.to))),new y.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("position","A position in a text document",b=>Array.isArray(b)&&b.every(v=>D.Position.isPosition(v)),b=>b.map(t.Position.from))],new y.ApiCommandResult("A promise that resolves to an array of ranges.",b=>b.map(v=>{let h;for(const g of v.reverse())h=new D.SelectionRange(t.Range.to(g),h);return h}))),new y.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[y.ApiCommandArgument.String.with("query","Search string")],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",b=>b.map(t.WorkspaceSymbol.to))),new y.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A CallHierarchyItem or undefined",b=>b.map(t.CallHierarchyItem.to))),new y.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",b=>b.map(t.CallHierarchyIncomingCall.to))),new y.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",b=>b.map(t.CallHierarchyOutgoingCall.to))),new y.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to a range and placeholder text.",b=>{if(!!b)return{range:t.Range.to(b.range),placeholder:b.text}})),new y.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("newName","The new symbol name")],new y.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",b=>{if(!!b){if(b.rejectReason)throw new Error(b.rejectReason);return t.WorkspaceEdit.to(b)}})),new y.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new y.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",b=>b.map(t.DocumentLink.to))),new y.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",b=>{if(!!b)return new D.SemanticTokensLegend(b.tokenTypes,b.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",b=>{if(!b)return;const v=(0,E.decodeSemanticTokensDto)(b);if(v.type==="full")return new D.SemanticTokens(v.data,void 0)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range.optional()],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",b=>{if(!!b)return new D.SemanticTokensLegend(b.tokenTypes,b.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",b=>{if(!b)return;const v=(0,E.decodeSemanticTokensDto)(b);if(v.type==="full")return new D.SemanticTokens(v.data,void 0)})),new y.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new y.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(b,v,h)=>{if(!b)return new D.CompletionList([]);const g=b.suggestions.map(p=>t.CompletionItem.to(p,h));return new D.CompletionList(g,b.incomplete)})),new y.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new y.ApiCommandResult("A promise that resolves to SignatureHelp.",b=>{if(b)return t.SignatureHelp.to(b)})),new y.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new y.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(b,v,h)=>T(g=>new D.CodeLens(t.Range.to(g.range),g.command&&h.fromInternal(g.command)))(b))),new y.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",b=>D.Range.isRange(b),b=>D.Selection.isSelection(b)?t.Selection.from(b):t.Range.from(b)),y.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new y.ApiCommandResult("A promise that resolves to an array of Command-instances.",(b,v,h)=>T(g=>{if(g._isSynthetic){if(!g.command)throw new Error("Synthetic code actions must have a command");return h.fromInternal(g.command)}else{const p=new D.CodeAction(g.title,g.kind?new D.CodeActionKind(g.kind):void 0);return g.edit&&(p.edit=t.WorkspaceEdit.to(g.edit)),g.command&&(p.command=h.fromInternal(g.command)),p.isPreferred=g.isPreferred,p}})(b))),new y.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",b=>b?b.map(v=>new D.ColorInformation(t.Range.to(v.range),t.Color.to(v.color))):[])),new y.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new y.ApiCommandArgument("color","The color to show and insert",b=>b instanceof D.Color,t.Color.from),new y.ApiCommandArgument("context","Context object with uri and range",b=>!0,b=>({uri:b.uri,range:t.Range.from(b.range)}))],new y.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",b=>b?b.map(t.ColorPresentation.to):[])),new y.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of Inlay objects",(b,v,h)=>b.map(t.InlayHint.to.bind(void 0,h)))),new y.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new y.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",T(b=>({viewType:b.viewType,displayName:b.displayName,options:{transientOutputs:b.options.transientOutputs,transientCellMetadata:b.options.transientCellMetadata,transientDocumentMetadata:b.options.transientDocumentMetadata},filenamePattern:b.filenamePattern.map(v=>t.NotebookExclusiveDocumentPattern.to(v))})))),new y.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of InlineValue objects",b=>b.map(t.InlineValue.to))),new y.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new y.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",b=>u.URI.isUri(b)||typeof b=="string"&&(0,I.matchesSomeScheme)(b,R.Schemas.http,R.Schemas.https),b=>b),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",b=>b===void 0||typeof b=="number"||typeof b=="object",b=>b&&(typeof b=="number"?[t.ViewColumn.from(b),void 0]:[t.ViewColumn.from(b.viewColumn),t.TextEditorOpenOptions.from(b)])).optional(),y.ApiCommandArgument.String.with("label","").optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[y.ApiCommandArgument.Uri.with("resource","Resource to open"),y.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",b=>b===void 0||typeof b=="number"||typeof b=="object",b=>b&&(typeof b=="number"?[t.ViewColumn.from(b),void 0]:[t.ViewColumn.from(b.viewColumn),t.TextEditorOpenOptions.from(b)])).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[y.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),y.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),y.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",b=>b===void 0||typeof b=="object",b=>b&&[t.ViewColumn.from(b.viewColumn),t.TextEditorOpenOptions.from(b)]).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A TypeHierarchyItem or undefined",b=>b.map(t.TypeHierarchyItem.to))),new y.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[y.ApiCommandArgument.TypeHierarchyItem],new y.ApiCommandResult("A TypeHierarchyItem or undefined",b=>b.map(t.TypeHierarchyItem.to))),new y.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[y.ApiCommandArgument.TypeHierarchyItem],new y.ApiCommandResult("A TypeHierarchyItem or undefined",b=>b.map(t.TypeHierarchyItem.to))),new y.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[y.ApiCommandArgument.TestItem],y.ApiCommandResult.Void),new y.ApiCommand("vscode.experimental.editSession.continue","_workbench.experimental.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[y.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],y.ApiCommandResult.Void)];class _{static register(v){k.forEach(v.registerApiCommand,v)}}e.ExtHostApiCommands=_;function T(b){return v=>{if(Array.isArray(v))return v.map(b)}}function w(b){if(!Array.isArray(b))return;const v=[];for(const h of b)P.isLocationLink(h)?v.push(t.DefinitionLink.to(h)):v.push(t.location.to(h));return v}}),define(De[239],Ie([1,0,18,57,4,6,2,63,28,16,7,27,5]),function(Z,e,u,t,D,P,y,C,E,I,R,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function T(w,b,v){const h=w.getProxy(_.MainContext.MainThreadComments);class g{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,b.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===6){const a=this._commentControllers.get(n.handle);return a?a.value:n}else if(n&&n.$mid===7){const a=this._commentControllers.get(n.commentControlHandle);if(!a)return n;const d=a.getCommentThread(n.commentThreadHandle);return d?d.value:n}else if(n&&n.$mid===8){const a=this._commentControllers.get(n.thread.commentControlHandle);if(!a)return n;const d=a.getCommentThread(n.thread.commentThreadHandle);return d?{thread:d.value,text:n.text}:n}else if(n&&n.$mid===9){const a=this._commentControllers.get(n.thread.commentControlHandle);if(!a)return n;const d=a.getCommentThread(n.thread.commentThreadHandle);if(!d)return n;const f=n.commentUniqueId,S=d.getCommentByUniqueId(f);return S||n}else if(n&&n.$mid===10){const a=this._commentControllers.get(n.thread.commentControlHandle);if(!a)return n;const d=a.getCommentThread(n.thread.commentThreadHandle);if(!d)return n;const f=n.text,S=n.commentUniqueId,O=d.getCommentByUniqueId(S);return O?(O.body=f,O):n}return n}})}createCommentController(n,a,d){const f=g.handlePool++,S=new o(n,f,a,d);this._commentControllers.set(S.handle,S);const O=this._commentControllersByExtension.get(E.ExtensionIdentifier.toKey(n.identifier))||[];return O.push(S),this._commentControllersByExtension.set(E.ExtensionIdentifier.toKey(n.identifier),O),S.value}$createCommentThreadTemplate(n,a,d){const f=this._commentControllers.get(n);!f||f.$createCommentThreadTemplate(a,d)}async $updateCommentThreadTemplate(n,a,d){const f=this._commentControllers.get(n);!f||f.$updateCommentThreadTemplate(a,d)}$deleteCommentThread(n,a){this._commentControllers.get(n)?.$deleteCommentThread(a)}$provideCommentingRanges(n,a,d){const f=this._commentControllers.get(n);if(!f||!f.commentingRangeProvider)return Promise.resolve(void 0);const S=v.getDocument(y.URI.revive(a));return(0,u.asPromise)(()=>f.commentingRangeProvider.provideCommentingRanges(S,d)).then(O=>O?O.map(U=>I.Range.from(U)):void 0)}$toggleReaction(n,a,d,f,S){const O=this._commentControllers.get(n);return!O||!O.reactionHandler?Promise.resolve(void 0):(0,u.asPromise)(()=>{const U=O.getCommentThread(a);if(U){const M=U.getCommentByUniqueId(f.uniqueIdInThread);if(O!==void 0&&M&&O.reactionHandler)return O.reactionHandler(M,l(S))}return Promise.resolve(void 0)})}dispose(){}}g.handlePool=0;class p{constructor(n,a,d,f,S,O,U,M){this._commentControllerHandle=a,this._id=d,this._uri=f,this._range=S,this._comments=O,this.extensionDescription=U,this._isTemplate=M,this.handle=p._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new D.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new P.MutableDisposable,this._acceptInputDisposables.value=new P.DisposableStore,this._id===void 0&&(this._id=`${n}.${this.handle}`),h.$createCommentThread(a,this.handle,this._id,this._uri,I.Range.from(this._range),U.identifier,this._isTemplate),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=O,this._localDisposables.push({dispose:()=>{h.$deleteCommentThread(a,this.handle)}});const A=this;this.value={get uri(){return A.uri},get range(){return A.range},set range(B){A.range=B},get comments(){return A.comments},set comments(B){A.comments=B},get collapsibleState(){return A.collapsibleState},set collapsibleState(B){A.collapsibleState=B},get canReply(){return A.canReply},set canReply(B){A.canReply=B},get contextValue(){return A.contextValue},set contextValue(B){A.contextValue=B},get label(){return A.label},set label(B){A.label=B},get state(){return A.state},set state(B){A.state=B},dispose:()=>{A.dispose()}}}set threadId(n){this._id=n}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(n){n.isEqual(this._range)||(this._range=n,this.modifications.range=n,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(n){this._canReply!==n&&(this._canReply=n,this.modifications.canReply=n,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(n){this._label=n,this.modifications.label=n,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(n){this._contextValue=n,this.modifications.contextValue=n,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(n){this._comments=n,this.modifications.comments=n,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(n){this._collapseState=n,this.modifications.collapsibleState=n,this._onDidUpdateCommentThread.fire()}get state(){return(0,k.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state}set state(n){(0,k.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state=n,this.modifications.state=n,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new P.DisposableStore);const n=d=>Object.prototype.hasOwnProperty.call(this.modifications,d),a={};n("range")&&(a.range=I.Range.from(this._range)),n("label")&&(a.label=this.label),n("contextValue")&&(a.contextValue=this.contextValue??null),n("comments")&&(a.comments=this._comments.map(d=>m(this,d,this._commentsMap))),n("collapsibleState")&&(a.collapseState=s(this._collapseState)),n("canReply")&&(a.canReply=this.canReply),n("state")&&(a.state=i(this._state)),n("isTemplate")&&(a.isTemplate=this._isTemplate),this.modifications={},h.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,a)}getCommentByUniqueId(n){for(const a of this._commentsMap){const d=a[0],f=a[1];if(n===f)return d}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(n=>n.dispose())}}p._handlePool=0,je([(0,t.debounce)(100)],p.prototype,"eventuallyUpdateCommentThread",null);class o{constructor(n,a,d,f){this._extension=n,this._handle=a,this._id=d,this._label=f,this._threads=new Map,h.$registerCommentController(this.handle,d,f);const S=this;this.value=Object.freeze({id:S.id,label:S.label,get options(){return S.options},set options(O){S.options=O},get commentingRangeProvider(){return S.commentingRangeProvider},set commentingRangeProvider(O){S.commentingRangeProvider=O},get reactionHandler(){return S.reactionHandler},set reactionHandler(O){S.reactionHandler=O},createCommentThread(O,U,M){return S.createCommentThread(O,U,M).value},dispose:()=>{S.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{h.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(n){this._commentingRangeProvider=n,h.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(n){this._reactionHandler=n,h.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!n})}get options(){return this._options}set options(n){this._options=n,h.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(n,a,d,f){if(typeof n=="string"){const S=new p(this.id,this.handle,n,a,d,f,this._extension,!1);return this._threads.set(S.handle,S),S}else{const S=new p(this.id,this.handle,void 0,n,a,d,this._extension,!1);return this._threads.set(S.handle,S),S}}$createCommentThreadTemplate(n,a){const d=new p(this.id,this.handle,void 0,y.URI.revive(n),I.Range.to(a),[],this._extension,!0);return d.collapsibleState=C.CommentThreadCollapsibleState.Expanded,this._threads.set(d.handle,d),d}$updateCommentThreadTemplate(n,a){const d=this._threads.get(n);d&&(d.range=I.Range.to(a))}$deleteCommentThread(n){this._threads.get(n)?.dispose(),this._threads.delete(n)}getCommentThread(n){return this._threads.get(n)}dispose(){this._threads.forEach(n=>{n.dispose()}),this._localDisposables.forEach(n=>n.dispose())}}function m(r,n,a){let d=a.get(n);d||(d=++r.commentHandle,a.set(n,d));const f=n.author&&n.author.iconPath?n.author.iconPath.toString():void 0;return{mode:n.mode,contextValue:n.contextValue,uniqueIdInThread:d,body:typeof n.body=="string"?n.body:I.MarkdownString.from(n.body),userName:n.author.name,userIconPath:f,label:n.label,commentReactions:n.reactions?n.reactions.map(S=>c(S)):void 0,timestamp:n.timestamp?.toJSON()}}function c(r){return{label:r.label,iconPath:r.iconPath?I.pathOrURIToURI(r.iconPath):void 0,count:r.count,hasReacted:r.authorHasReacted}}function l(r){return{label:r.label||"",count:r.count||0,iconPath:r.iconPath?y.URI.revive(r.iconPath):"",authorHasReacted:r.hasReacted||!1}}function s(r){if(r!==void 0)switch(r){case R.CommentThreadCollapsibleState.Expanded:return C.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return C.CommentThreadCollapsibleState.Collapsed}return C.CommentThreadCollapsibleState.Collapsed}function i(r){if(r!==void 0)switch(r){case R.CommentThreadState.Unresolved:return C.CommentThreadState.Unresolved;case R.CommentThreadState.Resolved:return C.CommentThreadState.Resolved}return C.CommentThreadState.Unresolved}return new g}e.createExtHostComments=T}),define(De[240],Ie([1,0,24,5,26,15]),function(Z,e,u,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let y=class{constructor(R,k){this._mainThreadConsole=R.getProxy(t.MainContext.MainThreadConsole),this._includeStack=k.consoleForward.includeStack,this._logNative=k.consoleForward.logNative,this._wrapConsoleMethod("info","log"),this._wrapConsoleMethod("log","log"),this._wrapConsoleMethod("warn","warn"),this._wrapConsoleMethod("error","error")}_wrapConsoleMethod(R,k){const _=this,T=console[R];Object.defineProperty(console,R,{set:()=>{},get:()=>function(){_._handleConsoleCall(R,k,T,arguments)}})}_handleConsoleCall(R,k,_,T){this._mainThreadConsole.$logExtensionHostMessage({type:"__$console",severity:k,arguments:E(T,this._includeStack)}),this._logNative&&this._nativeConsoleLogMessage(R,_,T)}};y=je([xe(0,P.IExtHostRpcService),xe(1,D.IExtHostInitDataService)],y),e.AbstractExtHostConsoleForwarder=y;const C=1e5;function E(I,R){const k=[];if(I.length)for(let _=0;_<I.length;_++){let T=I[_];if(typeof T=="undefined")T="undefined";else if(T instanceof Error){const w=T;w.stack?T=w.stack:T=w.toString()}k.push(T)}if(R){const _=new Error().stack;_&&k.push({__$stack:_.split(`
`).slice(3).join(`
`)})}try{const _=(0,u.safeStringify)(k);return _.length>C?"Output omitted for a large object that exceeds the limits":_}catch(_){return`Output omitted for an object that cannot be inspected ('${_.toString()}')`}}}),define(De[134],Ie([1,0,2,5,7,3,15,14,17,8,9]),function(Z,e,u,t,D,P,y,C,E,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let k=class kn{constructor(T,w){this._logService=w,this._provider=new Map,this._proxy=T.getProxy(t.MainContext.MainThreadDecorations)}registerFileDecorationProvider(T,w){const b=kn._handlePool++;this._provider.set(b,{provider:T,extensionId:w}),this._proxy.$registerDecorationProvider(b,w.value);const v=T.onDidChangeFileDecorations&&T.onDidChangeFileDecorations(h=>{if(!h){this._proxy.$onDidChange(b,null);return}const g=(0,E.asArray)(h);if(g.length<=kn._maxEventSize){this._proxy.$onDidChange(b,g);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",w.value,g.length);const p=g.map(c=>({uri:c,rank:(0,I.count)(c.path,"/")})),o=(0,E.groupBy)(p,(c,l)=>c.rank-l.rank||(0,I.compare)(c.uri.path,l.uri.path)),m=[];e:for(const c of o){let l;for(const s of c){const i=(0,R.dirname)(s.uri.path);if(l!==i&&(l=i,m.push(s.uri)>=kn._maxEventSize))break e}}this._proxy.$onDidChange(b,m)});return new D.Disposable(()=>{v?.dispose(),this._proxy.$unregisterDecorationProvider(b),this._provider.delete(b)})}async $provideDecorations(T,w,b){if(!this._provider.has(T))return Object.create(null);const v=Object.create(null),{provider:h,extensionId:g}=this._provider.get(T);return await Promise.all(w.map(async p=>{try{const{uri:o,id:m}=p,c=await Promise.resolve(h.provideFileDecoration(u.URI.revive(o),b));if(!c)return;try{D.FileDecoration.validate(c),v[m]=[c.propagate,c.tooltip,c.badge,c.color]}catch(l){this._logService.warn(`INVALID decoration from extension '${g.value}': ${l}`)}}catch(o){this._logService.error(o)}})),v}};k._handlePool=0,k._maxEventSize=250,k=je([xe(0,y.IExtHostRpcService),xe(1,C.ILogService)],k),e.ExtHostDecorations=k,e.IExtHostDecorations=(0,P.createDecorator)("IExtHostDecorations")});var et=this&&this.__classPrivateFieldSet||function(Z,e,u,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!D:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(Z,u):D?D.value=u:e.set(Z,u),u},Me=this&&this.__classPrivateFieldGet||function(Z,e,u,t){if(u==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?t:u==="a"?t.call(Z):t?t.value:e.get(Z)};define(De[241],Ie([1,0,168,116,2,5,7,16,4,14,25,46]),function(Z,e,u,t,D,P,y,C,E,I,R,k){"use strict";var _,T,w;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class b{constructor(g,p,o,m,c,l){this._name=g,this._owner=p,this._maxDiagnosticsPerFile=o,_.set(this,void 0),T.set(this,void 0),w.set(this,void 0),this._isDisposed=!1,et(this,w,new R.ResourceMap(s=>m.getComparisonKey(s)),"f"),et(this,_,c,"f"),et(this,T,l,"f")}dispose(){this._isDisposed||(Me(this,T,"f").fire([...Me(this,w,"f").keys()]),Me(this,_,"f")?.$clear(this._owner),Me(this,w,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(g,p){if(!g){this.clear();return}this._checkDisposed();let o=[];if(D.URI.isUri(g)){if(!p){this.delete(g);return}Me(this,w,"f").set(g,p.slice()),o=[g]}else if(Array.isArray(g)){o=[];let c;g=[...g].sort(b._compareIndexedTuplesByUri);for(const l of g){const[s,i]=l;if((!c||s.toString()!==c.toString())&&(c&&Me(this,w,"f").get(c).length===0&&Me(this,w,"f").delete(c),c=s,o.push(s),Me(this,w,"f").set(s,[])),i)Me(this,w,"f").get(s)?.push(...i);else{const r=Me(this,w,"f").get(s);r&&(r.length=0)}}}if(Me(this,T,"f").fire(o),!Me(this,_,"f"))return;const m=[];for(const c of o){let l=[];const s=Me(this,w,"f").get(c);if(s)if(s.length>this._maxDiagnosticsPerFile){l=[];const i=[y.DiagnosticSeverity.Error,y.DiagnosticSeverity.Warning,y.DiagnosticSeverity.Information,y.DiagnosticSeverity.Hint];e:for(let r=0;r<4;r++)for(const n of s)if(n.severity===i[r]&&l.push(C.Diagnostic.from(n))===this._maxDiagnosticsPerFile)break e;l.push({severity:t.MarkerSeverity.Info,message:(0,u.localize)(0,null,s.length-this._maxDiagnosticsPerFile),startLineNumber:l[l.length-1].startLineNumber,startColumn:l[l.length-1].startColumn,endLineNumber:l[l.length-1].endLineNumber,endColumn:l[l.length-1].endColumn})}else l=s.map(i=>C.Diagnostic.from(i));m.push([c,l])}Me(this,_,"f").$changeMany(this._owner,m)}delete(g){this._checkDisposed(),Me(this,T,"f").fire([g]),Me(this,w,"f").delete(g),Me(this,_,"f")?.$changeMany(this._owner,[[g,void 0]])}clear(){this._checkDisposed(),Me(this,T,"f").fire([...Me(this,w,"f").keys()]),Me(this,w,"f").clear(),Me(this,_,"f")?.$clear(this._owner)}forEach(g,p){this._checkDisposed();for(const[o,m]of this)g.call(p,o,m,this)}*[(_=new WeakMap,T=new WeakMap,w=new WeakMap,Symbol.iterator)](){this._checkDisposed();for(const g of Me(this,w,"f").keys())yield[g,this.get(g)]}get(g){this._checkDisposed();const p=Me(this,w,"f").get(g);return Array.isArray(p)?Object.freeze(p.slice(0)):[]}has(g){return this._checkDisposed(),Array.isArray(Me(this,w,"f").get(g))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(g,p){return g[0].toString()<p[0].toString()?-1:g[0].toString()>p[0].toString()?1:0}}e.DiagnosticCollection=b;let v=class mn{constructor(g,p,o){this._logService=p,this._fileSystemInfoService=o,this._collections=new Map,this._onDidChangeDiagnostics=new E.DebounceEmitter({merge:m=>m.flat(),delay:50}),this.onDidChangeDiagnostics=E.Event.map(this._onDidChangeDiagnostics.event,mn._mapper),this._proxy=g.getProxy(P.MainContext.MainThreadDiagnostics)}static _mapper(g){const p=new R.ResourceMap;for(const o of g)p.set(o,o);return{uris:Object.freeze(Array.from(p.values()))}}createDiagnosticCollection(g,p){const{_collections:o,_proxy:m,_onDidChangeDiagnostics:c,_logService:l,_fileSystemInfoService:s}=this,i=new class{$changeMany(a,d){m.$changeMany(a,d),l.trace("[DiagnosticCollection] change many (extension, owner, uris)",g.value,a,d.length===0?"CLEARING":d)}$clear(a){m.$clear(a),l.trace("[DiagnosticCollection] remove all (extension, owner)",g.value,a)}dispose(){m.dispose()}};let r;if(!p)p="_generated_diagnostic_collection_name_#"+mn._idPool++,r=p;else if(!o.has(p))r=p;else{this._logService.warn(`DiagnosticCollection with name '${p}' does already exist.`);do r=p+mn._idPool++;while(o.has(r))}return new class extends b{constructor(){super(p,r,mn._maxDiagnosticsPerFile,s.extUri,i,c);o.set(r,this)}dispose(){super.dispose(),o.delete(r)}}}getDiagnostics(g){if(g)return this._getDiagnostics(g);{const p=new Map,o=[];for(const m of this._collections.values())m.forEach((c,l)=>{let s=p.get(c.toString());typeof s=="undefined"&&(s=o.length,p.set(c.toString(),s),o.push([c,[]])),o[s][1]=o[s][1].concat(...l)});return o}}_getDiagnostics(g){let p=[];for(const o of this._collections.values())o.has(g)&&(p=p.concat(o.get(g)));return p}$acceptMarkersChange(g){if(!this._mirrorCollection){const p="_generated_mirror",o=new b(p,p,mn._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(p,o),this._mirrorCollection=o}for(const[p,o]of g)this._mirrorCollection.set(D.URI.revive(p),o.map(C.Diagnostic.to))}};v._idPool=0,v._maxDiagnosticsPerFile=1e3,v=je([xe(1,I.ILogService),xe(2,k.IExtHostFileSystemInfo)],v),e.ExtHostDiagnostics=v}),define(De[242],Ie([1,0,2,5]),function(Z,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class D{constructor(y){this._proxy=y.getProxy(t.MainContext.MainThreadDialogs)}showOpenDialog(y){return this._proxy.$showOpenDialog(y).then(C=>C?C.map(E=>u.URI.revive(E)):void 0)}showSaveDialog(y){return this._proxy.$showSaveDialog(y).then(C=>C?u.URI.revive(C):void 0)}}e.ExtHostDialogs=D}),define(De[243],Ie([1,0,10,2,7,5,12,21,8]),function(Z,e,u,t,D,P,y,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class I{constructor(k,_,T){this._documentsAndEditors=_,this._logService=T,this._documentContentProviders=new Map,this._proxy=k.getProxy(P.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(k,_){if(Object.keys(y.Schemas).indexOf(k)>=0)throw new Error(`scheme '${k}' already registered`);const T=I._handlePool++;this._documentContentProviders.set(T,_),this._proxy.$registerTextContentProvider(T,k);let w;return typeof _.onDidChange=="function"&&(w=_.onDidChange(b=>{if(b.scheme!==k){this._logService.warn(`Provider for scheme '${k}' is firing event for schema '${b.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(b)&&this.$provideTextDocumentContent(T,b).then(v=>{if(!v&&typeof v!="string")return;const h=this._documentsAndEditors.getDocument(b);if(!h)return;const g=(0,E.splitLines)(v);if(!h.equalLines(g))return this._proxy.$onVirtualDocumentChange(b,v)},u.onUnexpectedError)})),new D.Disposable(()=>{this._documentContentProviders.delete(T)&&this._proxy.$unregisterTextContentProvider(T),w&&(w.dispose(),w=void 0)})}$provideTextDocumentContent(k,_){const T=this._documentContentProviders.get(k);return T?Promise.resolve(T.provideTextDocumentContent(t.URI.revive(_),C.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${_.scheme}`))}}e.ExtHostDocumentContentProvider=I,I._handlePool=0}),define(De[244],Ie([1,0,4,6,2,5,125,16,13,24,7]),function(Z,e,u,t,D,P,y,C,E,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class k{constructor(T,w){this._onDidAddDocument=new u.Emitter,this._onDidRemoveDocument=new u.Emitter,this._onDidChangeDocument=new u.Emitter,this._onDidSaveDocument=new u.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new t.DisposableStore,this._documentLoader=new Map,this._proxy=T.getProxy(P.MainContext.MainThreadDocuments),this._documentsAndEditors=w,this._documentsAndEditors.onDidRemoveDocuments(b=>{for(const v of b)this._onDidRemoveDocument.fire(v.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(b=>{for(const v of b)this._onDidAddDocument.fire(v.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(T){if(!T)return;const w=this._documentsAndEditors.getDocument(T);if(w)return w}getDocument(T){const w=this.getDocumentData(T);if(!w?.document)throw new Error(`Unable to retrieve document from URI '${T}'`);return w.document}ensureDocumentData(T){const w=this._documentsAndEditors.getDocument(T);if(w)return Promise.resolve(w);let b=this._documentLoader.get(T.toString());return b||(b=this._proxy.$tryOpenDocument(T).then(v=>{this._documentLoader.delete(T.toString());const h=D.URI.revive(v);return(0,E.assertIsDefined)(this._documentsAndEditors.getDocument(h))},v=>(this._documentLoader.delete(T.toString()),Promise.reject(v))),this._documentLoader.set(T.toString(),b)),b}createDocumentData(T){return this._proxy.$tryCreateDocument(T).then(w=>D.URI.revive(w))}$acceptModelLanguageChanged(T,w){const b=D.URI.revive(T),v=this._documentsAndEditors.getDocument(b);if(!v)throw new Error("unknown document");this._onDidRemoveDocument.fire(v.document),v._acceptLanguageId(w),this._onDidAddDocument.fire(v.document)}$acceptModelSaved(T){const w=D.URI.revive(T),b=this._documentsAndEditors.getDocument(w);if(!b)throw new Error("unknown document");this.$acceptDirtyStateChanged(T,!1),this._onDidSaveDocument.fire(b.document)}$acceptDirtyStateChanged(T,w){const b=D.URI.revive(T),v=this._documentsAndEditors.getDocument(b);if(!v)throw new Error("unknown document");v._acceptIsDirty(w),this._onDidChangeDocument.fire({document:v.document,contentChanges:[],reason:void 0})}$acceptModelChanged(T,w,b){const v=D.URI.revive(T),h=this._documentsAndEditors.getDocument(v);if(!h)throw new Error("unknown document");h._acceptIsDirty(b),h.onEvents(w);let g;w.isUndoing?g=R.TextDocumentChangeReason.Undo:w.isRedoing&&(g=R.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,I.deepFreeze)({document:h.document,contentChanges:w.changes.map(p=>({range:C.Range.to(p.range),rangeOffset:p.rangeOffset,rangeLength:p.rangeLength,text:p.text})),reason:g}))}setWordDefinitionFor(T,w){(0,y.setWordDefinitionFor)(T,w)}}e.ExtHostDocuments=k}),define(De[55],Ie([1,0,48,4,6,2,3,5,125,15,132,16,14,25,12,59,78]),function(Z,e,u,t,D,P,y,C,E,I,R,k,_,T,w,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class h{constructor(o){this.value=o,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let g=class{constructor(o,m){this._extHostRpc=o,this._logService=m,this._activeEditorId=null,this._editors=new Map,this._documents=new T.ResourceMap,this._onDidAddDocuments=new t.Emitter,this._onDidRemoveDocuments=new t.Emitter,this._onDidChangeVisibleTextEditors=new t.Emitter,this._onDidChangeActiveTextEditor=new t.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(o){this.acceptDocumentsAndEditorsDelta(o)}acceptDocumentsAndEditorsDelta(o){const m=[],c=[],l=[];if(o.removedDocuments)for(const s of o.removedDocuments){const i=P.URI.revive(s),r=this._documents.get(i);r?.unref()&&(this._documents.delete(i),m.push(r.value))}if(o.addedDocuments)for(const s of o.addedDocuments){const i=P.URI.revive(s.uri);let r=this._documents.get(i);if(r&&i.scheme!==w.Schemas.vscodeNotebookCell&&i.scheme!==w.Schemas.vscodeInteractiveInput)throw new Error(`document '${i} already exists!'`);r||(r=new h(new E.ExtHostDocumentData(this._extHostRpc.getProxy(C.MainContext.MainThreadDocuments),i,s.lines,s.EOL,s.versionId,s.languageId,s.isDirty,s.notebook)),this._documents.set(i,r),c.push(r.value)),r.ref()}if(o.removedEditors)for(const s of o.removedEditors){const i=this._editors.get(s);this._editors.delete(s),i&&l.push(i)}if(o.addedEditors)for(const s of o.addedEditors){const i=P.URI.revive(s.documentUri);u.ok(this._documents.has(i),`document '${i}' does not exist`),u.ok(!this._editors.has(s.id),`editor '${s.id}' already exists!`);const r=this._documents.get(i).value,n=new R.ExtHostTextEditor(s.id,this._extHostRpc.getProxy(C.MainContext.MainThreadTextEditors),this._logService,new v.Lazy(()=>r.document),s.selections.map(k.Selection.to),s.options,s.visibleRanges.map(a=>k.Range.to(a)),typeof s.editorPosition=="number"?k.ViewColumn.to(s.editorPosition):void 0);this._editors.set(s.id,n)}o.newActiveEditor!==void 0&&(u.ok(o.newActiveEditor===null||this._editors.has(o.newActiveEditor),`active editor '${o.newActiveEditor}' does not exist`),this._activeEditorId=o.newActiveEditor),(0,D.dispose)(m),(0,D.dispose)(l),o.removedDocuments&&this._onDidRemoveDocuments.fire(m),o.addedDocuments&&this._onDidAddDocuments.fire(c),(o.removedEditors||o.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(s=>s.value)),o.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(o){return this._documents.get(o)?.value}allDocuments(){return b.Iterable.map(this._documents.values(),o=>o.value)}getEditor(o){return this._editors.get(o)}activeEditor(o){if(!this._activeEditorId)return;const m=this._editors.get(this._activeEditorId);return o?m:m?.value}allEditors(){return[...this._editors.values()]}};g=je([xe(0,I.IExtHostRpcService),xe(1,_.ILogService)],g),e.ExtHostDocumentsAndEditors=g,e.IExtHostDocumentsAndEditors=(0,y.createDecorator)("IExtHostDocumentsAndEditors")}),define(De[56],Ie([1,0,16,5,2,4,3,7,15,13,77]),function(Z,e,u,t,D,P,y,C,E,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,y.createDecorator)("IExtHostEditorTabs");class k{constructor(v,h,g){this._activeTabIdGetter=g,this._parentGroup=h,this.acceptDtoUpdate(v)}get apiObject(){if(!this._apiObject){const v=this,h={get isActive(){return v._dto.id===v._activeTabIdGetter()},get label(){return v._dto.label},get input(){return v._input},get isDirty(){return v._dto.isDirty},get isPinned(){return v._dto.isPinned},get isPreview(){return v._dto.isPreview},get group(){return v._parentGroup.apiObject}};this._apiObject=Object.freeze(h)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(v){this._dto=v,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case 1:return new C.TextTabInput(D.URI.revive(this._dto.input.uri));case 2:return new C.TextDiffTabInput(D.URI.revive(this._dto.input.original),D.URI.revive(this._dto.input.modified));case 3:return new C.TextMergeTabInput(D.URI.revive(this._dto.input.base),D.URI.revive(this._dto.input.input1),D.URI.revive(this._dto.input.input2),D.URI.revive(this._dto.input.result));case 6:return new C.CustomEditorTabInput(D.URI.revive(this._dto.input.uri),this._dto.input.viewType);case 7:return new C.WebviewEditorTabInput(this._dto.input.viewType);case 4:return new C.NotebookEditorTabInput(D.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case 5:return new C.NotebookDiffEditorTabInput(D.URI.revive(this._dto.input.original),D.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case 8:return new C.TerminalEditorTabInput;case 9:return new C.InteractiveWindowInput(D.URI.revive(this._dto.input.uri),D.URI.revive(this._dto.input.inputBoxUri));default:return}}}class _{constructor(v,h){this._tabs=[],this._activeTabId="",this._dto=v,this._activeGroupIdGetter=h;for(const g of v.tabs)g.isActive&&(this._activeTabId=g.id),this._tabs.push(new k(g,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const v=this,h={get isActive(){return v._dto.groupId===v._activeGroupIdGetter()},get viewColumn(){return u.ViewColumn.to(v._dto.viewColumn)},get activeTab(){return v._tabs.find(g=>g.tabId===v._activeTabId)?.apiObject},get tabs(){return Object.freeze(v._tabs.map(g=>g.apiObject))}};this._apiObject=Object.freeze(h)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(v){this._dto=v}acceptTabOperation(v){if(v.kind===0){const g=new k(v.tabDto,this,()=>this.activeTabId());return this._tabs.splice(v.index,0,g),v.tabDto.isActive&&(this._activeTabId=g.tabId),g}else if(v.kind===1){const g=this._tabs.splice(v.index,1)[0];if(!g)throw new Error(`Tab close updated received for index ${v.index} which does not exist`);return g.tabId===this._activeTabId&&(this._activeTabId=""),g}else if(v.kind===3){if(v.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const g=this._tabs.splice(v.oldIndex,1)[0];if(!g)throw new Error(`Tab move updated received for index ${v.oldIndex} which does not exist`);return this._tabs.splice(v.index,0,g),g}const h=this._tabs.find(g=>g.tabId===v.tabDto.id);if(!h)throw new Error("INVALID tab");return v.tabDto.isActive?this._activeTabId=v.tabDto.id:this._activeTabId===v.tabDto.id&&!v.tabDto.isActive&&(this._activeTabId=""),h.acceptDtoUpdate(v.tabDto),h}activeTabId(){return this._activeTabId}}let T=class{constructor(v){this._onDidChangeTabs=new P.Emitter,this._onDidChangeTabGroups=new P.Emitter,this._extHostTabGroups=[],this._proxy=v.getProxy(t.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const v=this,h={onDidChangeTabGroups:v._onDidChangeTabGroups.event,onDidChangeTabs:v._onDidChangeTabs.event,get all(){return Object.freeze(v._extHostTabGroups.map(g=>g.apiObject))},get activeTabGroup(){const g=v._activeGroupId;return(0,I.assertIsDefined)(v._extHostTabGroups.find(o=>o.groupId===g)?.apiObject)},close:async(g,p)=>{const o=Array.isArray(g)?g:[g];return o.length?w(o[0])?this._closeGroups(o,p):this._closeTabs(o,p):!0}};this._apiObject=Object.freeze(h)}return this._apiObject}$acceptEditorTabModel(v){const h=new Set(this._extHostTabGroups.map(s=>s.groupId)),g=new Set(v.map(s=>s.groupId)),p=(0,R.diffSets)(h,g),o=this._extHostTabGroups.filter(s=>p.removed.includes(s.groupId)).map(s=>s.apiObject),m=[],c=[];this._extHostTabGroups=v.map(s=>{const i=new _(s,()=>this._activeGroupId);return p.added.includes(i.groupId)?m.push(i.apiObject):c.push(i.apiObject),i});const l=(0,I.assertIsDefined)(v.find(s=>s.isActive===!0)?.groupId);l!==void 0&&this._activeGroupId!==l&&(this._activeGroupId=l),this._onDidChangeTabGroups.fire(Object.freeze({opened:m,closed:o,changed:c}))}$acceptTabGroupUpdate(v){const h=this._extHostTabGroups.find(g=>g.groupId===v.groupId);if(!h)throw new Error("Update Group IPC call received before group creation.");h.acceptGroupDtoUpdate(v),v.isActive&&(this._activeGroupId=v.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[h.apiObject],opened:[],closed:[]}))}$acceptTabOperation(v){const h=this._extHostTabGroups.find(p=>p.groupId===v.groupId);if(!h)throw new Error("Update Tabs IPC call received before group creation.");const g=h.acceptTabOperation(v);switch(v.kind){case 0:this._onDidChangeTabs.fire(Object.freeze({opened:[g.apiObject],closed:[],changed:[]}));return;case 1:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[g.apiObject],changed:[]}));return;case 3:case 2:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[g.apiObject]}));return}}_findExtHostTabFromApi(v){for(const h of this._extHostTabGroups)for(const g of h.tabs)if(g.apiObject===v)return g}_findExtHostTabGroupFromApi(v){return this._extHostTabGroups.find(h=>h.apiObject===v)}async _closeTabs(v,h){const g=[];for(const p of v){const o=this._findExtHostTabFromApi(p);if(!o)throw new Error("Tab close: Invalid tab not found!");g.push(o.tabId)}return this._proxy.$closeTab(g,h)}async _closeGroups(v,h){const g=[];for(const p of v){const o=this._findExtHostTabGroupFromApi(p);if(!o)throw new Error("Group close: Invalid group not found!");g.push(o.groupId)}return this._proxy.$closeGroup(g,h)}};T=je([xe(0,E.IExtHostRpcService)],T),e.ExtHostEditorTabs=T;function w(b){return b.tabs!==void 0}}),define(De[245],Ie([1,0,2,5,6,7,16,148,8,23,27]),function(Z,e,u,t,D,P,y,C,E,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class k{constructor(){this._schemes=[]}add(w){this._stateMachine=void 0,this._schemes.push(w)}delete(w){const b=this._schemes.indexOf(w);b>=0&&(this._schemes.splice(b,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const w=this._schemes.sort(),b=[];let v,h,g=14,p=14;for(const o of w){let m=v?(0,E.commonPrefixLength)(v,o):0;for(m===0?h=1:h=p;m<o.length;m++)m+1===o.length?(g=p,p=9):p+=1,b.push([h,o.toUpperCase().charCodeAt(m),p]),b.push([h,o.toLowerCase().charCodeAt(m),p]),h=p;v=o,p=g}b.push([9,58,10]),b.push([10,47,12]),this._stateMachine=new C.StateMachine(b)}}provideDocumentLinks(w){this._initStateMachine();const b=[],v=C.LinkComputer.computeLinks({getLineContent(h){return w.lineAt(h-1).text},getLineCount(){return w.lineCount}},this._stateMachine);for(const h of v){const g=y.DocumentLink.to(h);g.target&&b.push(g)}return b}}class _{constructor(w,b){this._extHostLanguageFeatures=b,this._linkProvider=new k,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=w.getProxy(t.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(w,b,v,h={}){if(this._registeredSchemes.has(b))throw new Error(`a provider for the scheme '${b}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(w,"*",this._linkProvider));const g=this._handlePool++;this._linkProvider.add(b),this._registeredSchemes.add(b),this._fsProvider.set(g,v);let p=2;h.isCaseSensitive&&(p+=1024),h.isReadonly&&(p+=2048),typeof v.copy=="function"&&(p+=8),typeof v.open=="function"&&typeof v.close=="function"&&typeof v.read=="function"&&typeof v.write=="function"&&((0,R.checkProposedApiEnabled)(w,"fsChunks"),p+=4),this._proxy.$registerFileSystemProvider(g,b,p).catch(m=>{console.error(`FAILED to register filesystem provider of ${w.identifier.value}-extension for the scheme ${b}`),console.error(m)});const o=v.onDidChangeFile(m=>{const c=[];for(const l of m){const{uri:s,type:i}=l;if(s.scheme!==b)continue;let r;switch(i){case P.FileChangeType.Changed:r=0;break;case P.FileChangeType.Created:r=1;break;case P.FileChangeType.Deleted:r=2;break;default:throw new Error("Unknown FileChangeType")}c.push({resource:s,type:r})}this._proxy.$onFileSystemChange(g,c)});return(0,D.toDisposable)(()=>{o.dispose(),this._linkProvider.delete(b),this._registeredSchemes.delete(b),this._fsProvider.delete(g),this._proxy.$unregisterProvider(g)})}static _asIStat(w){const{type:b,ctime:v,mtime:h,size:g,permissions:p}=w;return{type:b,ctime:v,mtime:h,size:g,permissions:p}}$stat(w,b){return Promise.resolve(this._getFsProvider(w).stat(u.URI.revive(b))).then(v=>_._asIStat(v))}$readdir(w,b){return Promise.resolve(this._getFsProvider(w).readDirectory(u.URI.revive(b)))}$readFile(w,b){return Promise.resolve(this._getFsProvider(w).readFile(u.URI.revive(b))).then(v=>I.VSBuffer.wrap(v))}$writeFile(w,b,v,h){return Promise.resolve(this._getFsProvider(w).writeFile(u.URI.revive(b),v.buffer,h))}$delete(w,b,v){return Promise.resolve(this._getFsProvider(w).delete(u.URI.revive(b),v))}$rename(w,b,v,h){return Promise.resolve(this._getFsProvider(w).rename(u.URI.revive(b),u.URI.revive(v),h))}$copy(w,b,v,h){const g=this._getFsProvider(w);if(!g.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(g.copy(u.URI.revive(b),u.URI.revive(v),h))}$mkdir(w,b){return Promise.resolve(this._getFsProvider(w).createDirectory(u.URI.revive(b)))}$watch(w,b,v,h){const g=this._getFsProvider(w).watch(u.URI.revive(v),h);this._watches.set(b,g)}$unwatch(w,b){const v=this._watches.get(b);v&&(v.dispose(),this._watches.delete(b))}$open(w,b,v){const h=this._getFsProvider(w);if(!h.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(h.open(u.URI.revive(b),v))}$close(w,b){const v=this._getFsProvider(w);if(!v.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(v.close(b))}$read(w,b,v,h){const g=this._getFsProvider(w);if(!g.read)throw new Error('FileSystemProvider does not implement "read"');const p=I.VSBuffer.alloc(h);return Promise.resolve(g.read(b,v,p.buffer,0,h)).then(o=>p.slice(0,o))}$write(w,b,v,h){const g=this._getFsProvider(w);if(!g.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(g.write(b,v,h.buffer,0,h.byteLength))}_getFsProvider(w){const b=this._fsProvider.get(w);if(!b){const v=new Error;throw v.name="ENOPRO",v.message="no provider",v}return b}}e.ExtHostFileSystem=_}),define(De[68],Ie([1,0,5,42,7,23,3,15,46,6]),function(Z,e,u,t,D,P,y,C,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let R=class Qt{constructor(_,T){this._fileSystemProvider=new Map,this._proxy=_.getProxy(u.MainContext.MainThreadFileSystem);const w=this;this.value=Object.freeze({async stat(b){try{const v=w._fileSystemProvider.get(b.scheme);if(!v)return await w._proxy.$stat(b);await w._proxy.$ensureActivation(b.scheme);const h=await v.stat(b);return{type:h.type,ctime:h.ctime,mtime:h.mtime,size:h.size,permissions:h.permissions}}catch(v){Qt._handleError(v)}},async readDirectory(b){try{const v=w._fileSystemProvider.get(b.scheme);return v?(await w._proxy.$ensureActivation(b.scheme),(await v.readDirectory(b)).slice()):await w._proxy.$readdir(b)}catch(v){return Qt._handleError(v)}},async createDirectory(b){try{return await w._proxy.$mkdir(b)}catch(v){return Qt._handleError(v)}},async readFile(b){try{const v=w._fileSystemProvider.get(b.scheme);return v?(await w._proxy.$ensureActivation(b.scheme),(await v.readFile(b)).slice()):(await w._proxy.$readFile(b)).buffer}catch(v){return Qt._handleError(v)}},async writeFile(b,v){try{return await w._proxy.$writeFile(b,P.VSBuffer.wrap(v))}catch(h){return Qt._handleError(h)}},async delete(b,v){try{const h=w._fileSystemProvider.get(b.scheme);return h?(await w._proxy.$ensureActivation(b.scheme),await h.delete(b,{recursive:!1,...v})):await w._proxy.$delete(b,{recursive:!1,useTrash:!1,...v})}catch(h){return Qt._handleError(h)}},async rename(b,v,h){try{return await w._proxy.$rename(b,v,{overwrite:!1,...h})}catch(g){return Qt._handleError(g)}},async copy(b,v,h){try{return await w._proxy.$copy(b,v,{overwrite:!1,...h})}catch(g){return Qt._handleError(g)}},isWritableFileSystem(b){const v=T.getCapabilities(b);if(typeof v=="number")return!(v&2048)}})}static _handleError(_){if(_ instanceof D.FileSystemError)throw _;if(!(_ instanceof Error))throw new D.FileSystemError(String(_));if(_.name==="ENOPRO")throw D.FileSystemError.Unavailable(_.message);switch(_.name){case t.FileSystemProviderErrorCode.FileExists:throw D.FileSystemError.FileExists(_.message);case t.FileSystemProviderErrorCode.FileNotFound:throw D.FileSystemError.FileNotFound(_.message);case t.FileSystemProviderErrorCode.FileNotADirectory:throw D.FileSystemError.FileNotADirectory(_.message);case t.FileSystemProviderErrorCode.FileIsADirectory:throw D.FileSystemError.FileIsADirectory(_.message);case t.FileSystemProviderErrorCode.NoPermissions:throw D.FileSystemError.NoPermissions(_.message);case t.FileSystemProviderErrorCode.Unavailable:throw D.FileSystemError.Unavailable(_.message);default:throw new D.FileSystemError(_.message,_.name)}}addFileSystemProvider(_,T){return this._fileSystemProvider.set(_,T),(0,I.toDisposable)(()=>this._fileSystemProvider.delete(_))}};R=je([xe(0,C.IExtHostRpcService),xe(1,E.IExtHostFileSystemInfo)],R),e.ExtHostConsumerFileSystem=R,e.IExtHostConsumerFileSystem=(0,y.createDecorator)("IExtHostConsumerFileSystem")}),define(De[246],Ie([1,0,4,36,2,5,16,7,27]),function(Z,e,u,t,D,P,y,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class I{constructor(_,T,w,b,v,h,g,p){this._onDidCreate=new u.Emitter,this._onDidChange=new u.Emitter,this._onDidDelete=new u.Emitter;const o=this.ensureWatching(_,w,v);this._config=0,h&&(this._config+=1),g&&(this._config+=2),p&&(this._config+=4);const m=(0,t.parse)(v),c=typeof v=="string",l=b(s=>{if(!h)for(const i of s.created){const r=D.URI.revive(i);m(r.fsPath)&&(!c||T.getWorkspaceFolder(r))&&this._onDidCreate.fire(r)}if(!g)for(const i of s.changed){const r=D.URI.revive(i);m(r.fsPath)&&(!c||T.getWorkspaceFolder(r))&&this._onDidChange.fire(r)}if(!p)for(const i of s.deleted){const r=D.URI.revive(i);m(r.fsPath)&&(!c||T.getWorkspaceFolder(r))&&this._onDidDelete.fire(r)}});this._disposable=C.Disposable.from(o,this._onDidCreate,this._onDidChange,this._onDidDelete,l)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}ensureWatching(_,T,w){const b=C.Disposable.from();if(typeof w=="string")return b;const v=_.getProxy(P.MainContext.MainThreadFileSystem);let h=!1;(w.pattern.includes(t.GLOBSTAR)||w.pattern.includes(t.GLOB_SPLIT))&&(h=!0);const g=Math.random();return v.$watch(T.identifier.value,g,w.baseUri,{recursive:h,excludes:[]}),C.Disposable.from({dispose:()=>v.$unwatch(g)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class R{constructor(_,T,w){this._mainContext=_,this._logService=T,this._extHostDocumentsAndEditors=w,this._onFileSystemEvent=new u.Emitter,this._onDidRenameFile=new u.Emitter,this._onDidCreateFile=new u.Emitter,this._onDidDeleteFile=new u.Emitter,this._onWillRenameFile=new u.AsyncEmitter,this._onWillCreateFile=new u.AsyncEmitter,this._onWillDeleteFile=new u.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(_,T,w,b,v,h){return new I(this._mainContext,_,T,this._onFileSystemEvent.event,y.GlobPattern.from(w),b,v,h)}$onFileEvent(_){this._onFileSystemEvent.fire(_)}$onDidRunFileOperation(_,T){switch(_){case 2:this._onDidRenameFile.fire(Object.freeze({files:T.map(w=>({oldUri:D.URI.revive(w.source),newUri:D.URI.revive(w.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:T.map(w=>D.URI.revive(w.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:T.map(w=>D.URI.revive(w.target))}));break;default:}}getOnWillRenameFileEvent(_){return this._createWillExecuteEvent(_,this._onWillRenameFile)}getOnWillCreateFileEvent(_){return this._createWillExecuteEvent(_,this._onWillCreateFile)}getOnWillDeleteFileEvent(_){return this._createWillExecuteEvent(_,this._onWillDeleteFile)}_createWillExecuteEvent(_,T){return(w,b,v)=>{const h=function(p){w.call(b,p)};return h.extension=_,T.event(h,void 0,v)}}async $onWillRunFileOperation(_,T,w,b){switch(_){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:T.map(v=>({oldUri:D.URI.revive(v.source),newUri:D.URI.revive(v.target)}))},w,b);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:T.map(v=>D.URI.revive(v.target))},w,b);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:T.map(v=>D.URI.revive(v.target))},w,b)}}async _fireWillEvent(_,T,w,b){const v=new Set,h=[];if(await _.fireAsync(T,b,async(p,o)=>{const m=Date.now(),c=await Promise.resolve(p);c instanceof C.WorkspaceEdit&&(h.push([o.extension,c]),v.add(o.extension.displayName??o.extension.identifier.value)),Date.now()-m>w&&this._logService.warn("SLOW file-participant",o.extension.identifier)}),b.isCancellationRequested||h.length===0)return;const g={edits:[]};for(const[p,o]of h){const{edits:m}=y.WorkspaceEdit.from(o,{getTextDocumentVersion:c=>this._extHostDocumentsAndEditors.getDocument(c)?.version,getNotebookDocumentVersion:()=>{}},(0,E.isProposedApiEnabled)(p,"snippetWorkspaceEdit"));g.edits=g.edits.concat(m)}return{edit:g,extensionNames:Array.from(v)}}}e.ExtHostFileSystemEventService=R}),define(De[247],Ie([1,0,2,37]),function(Z,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class D{constructor(y,C,E,I,R){this._extHostNotebooks=C,this._textDocumentsAndEditors=E,this._commands=I;const k=new t.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new t.ApiCommandArgument("showOptions","Show Options",_=>!0,_=>_),new t.ApiCommandArgument("resource","Interactive resource Uri",_=>!0,_=>_),new t.ApiCommandArgument("controllerId","Notebook controller Id",_=>!0,_=>_),new t.ApiCommandArgument("title","Interactive editor title",_=>!0,_=>_)],new t.ApiCommandResult("Notebook and input URI",_=>{if(R.debug("[ExtHostInteractive] open iw with notebook editor id",_.notebookEditorId),_.notebookEditorId!==void 0){const T=this._extHostNotebooks.getEditorById(_.notebookEditorId);return R.debug("[ExtHostInteractive] notebook editor found",T.id),{notebookUri:u.URI.revive(_.notebookUri),inputUri:u.URI.revive(_.inputUri),notebookEditor:T.apiEditor}}return R.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",_.notebookUri,_.inputUri),{notebookUri:u.URI.revive(_.notebookUri),inputUri:u.URI.revive(_.inputUri)}}));this._commands.registerApiCommand(k)}$willAddInteractiveDocument(y,C,E,I){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:C,lines:[""],languageId:E,uri:y,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(u.URI.revive(I))?.apiNotebook}]})}$willRemoveInteractiveDocument(y,C){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[y]})}}e.ExtHostInteractive=D}),define(De[248],Ie([1,0,6,5]),function(Z,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class D{constructor(y){this._handlePool=0,this._proxy=y.getProxy(t.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(y){const C=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(C,y),(0,u.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(C)})}}e.ExtHostLabelService=D}),define(De[249],Ie([1,0,2,24,16,7,63,5,8,35,17,13,144,21,6,113,93,87,51,10,18,27]),function(Z,e,u,t,D,P,y,C,E,I,R,k,_,T,w,b,v,h,g,p,o,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class c{constructor(F,W){this._documents=F,this._provider=W}async provideDocumentSymbols(F,W){const G=this._documents.getDocument(F),Q=await this._provider.provideDocumentSymbols(G,W);if(!(0,R.isFalsyOrEmpty)(Q))return Q[0]instanceof P.DocumentSymbol?Q.map(D.DocumentSymbol.from):c._asDocumentSymbolTree(Q)}static _asDocumentSymbolTree(F){F=F.slice(0).sort((Q,fe)=>{let be=Q.location.range.start.compareTo(fe.location.range.start);return be===0&&(be=fe.location.range.end.compareTo(Q.location.range.end)),be});const W=[],G=[];for(const Q of F){const fe={name:Q.name||"!!MISSING: name!!",kind:D.SymbolKind.from(Q.kind),tags:Q.tags?.map(D.SymbolTag.from)||[],detail:"",containerName:Q.containerName,range:D.Range.from(Q.location.range),selectionRange:D.Range.from(Q.location.range),children:[]};for(;;){if(G.length===0){G.push(fe),W.push(fe);break}const be=G[G.length-1];if(I.Range.containsRange(be.range,fe.range)&&!I.Range.equalsRange(be.range,fe.range)){be.children?.push(fe),G.push(fe);break}G.pop()}}return W}}class l{constructor(F,W,G){this._documents=F,this._commands=W,this._provider=G,this._cache=new h.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(F,W){const G=this._documents.getDocument(F),Q=await this._provider.provideCodeLenses(G,W);if(!Q||W.isCancellationRequested)return;const fe=this._cache.add(Q),be=new w.DisposableStore;this._disposables.set(fe,be);const ue={cacheId:fe,lenses:[]};for(let Ce=0;Ce<Q.length;Ce++)ue.lenses.push({cacheId:[fe,Ce],range:D.Range.from(Q[Ce].range),command:this._commands.toInternal(Q[Ce].command,be)});return ue}async resolveCodeLens(F,W){const G=F.cacheId&&this._cache.get(...F.cacheId);if(!G)return;let Q;if(typeof this._provider.resolveCodeLens!="function"||G.isResolved?Q=G:Q=await this._provider.resolveCodeLens(G,W),Q||(Q=G),W.isCancellationRequested)return;const fe=F.cacheId&&this._disposables.get(F.cacheId[0]);if(!!fe)return F.command=this._commands.toInternal(Q.command??l._badCmd,fe),F}releaseCodeLenses(F){this._disposables.get(F)?.dispose(),this._disposables.delete(F),this._cache.delete(F)}}l._badCmd={command:"missing",title:"!!MISSING: command!!"};function s(re){return Array.isArray(re)?re.map(D.DefinitionLink.from):re?[D.DefinitionLink.from(re)]:[]}class i{constructor(F,W){this._documents=F,this._provider=W}async provideDefinition(F,W,G){const Q=this._documents.getDocument(F),fe=D.Position.to(W),be=await this._provider.provideDefinition(Q,fe,G);return s(be)}}class r{constructor(F,W){this._documents=F,this._provider=W}async provideDeclaration(F,W,G){const Q=this._documents.getDocument(F),fe=D.Position.to(W),be=await this._provider.provideDeclaration(Q,fe,G);return s(be)}}class n{constructor(F,W){this._documents=F,this._provider=W}async provideImplementation(F,W,G){const Q=this._documents.getDocument(F),fe=D.Position.to(W),be=await this._provider.provideImplementation(Q,fe,G);return s(be)}}class a{constructor(F,W){this._documents=F,this._provider=W}async provideTypeDefinition(F,W,G){const Q=this._documents.getDocument(F),fe=D.Position.to(W),be=await this._provider.provideTypeDefinition(Q,fe,G);return s(be)}}class d{constructor(F,W){this._documents=F,this._provider=W}async provideHover(F,W,G){const Q=this._documents.getDocument(F),fe=D.Position.to(W),be=await this._provider.provideHover(Q,fe,G);if(!(!be||(0,R.isFalsyOrEmpty)(be.contents)))return be.range||(be.range=Q.getWordRangeAtPosition(fe)),be.range||(be.range=new P.Range(fe,fe)),D.Hover.from(be)}}class f{constructor(F,W){this._documents=F,this._provider=W}async provideEvaluatableExpression(F,W,G){const Q=this._documents.getDocument(F),fe=D.Position.to(W),be=await this._provider.provideEvaluatableExpression(Q,fe,G);if(be)return D.EvaluatableExpression.from(be)}}class S{constructor(F,W){this._documents=F,this._provider=W}async provideInlineValues(F,W,G,Q){const fe=this._documents.getDocument(F),be=await this._provider.provideInlineValues(fe,D.Range.to(W),D.InlineValueContext.to(G),Q);if(Array.isArray(be))return be.map(ue=>D.InlineValue.from(ue))}}class O{constructor(F,W){this._documents=F,this._provider=W}async provideDocumentHighlights(F,W,G){const Q=this._documents.getDocument(F),fe=D.Position.to(W),be=await this._provider.provideDocumentHighlights(Q,fe,G);if(Array.isArray(be))return be.map(D.DocumentHighlight.from)}}class U{constructor(F,W){this._documents=F,this._provider=W}async provideLinkedEditingRanges(F,W,G){const Q=this._documents.getDocument(F),fe=D.Position.to(W),be=await this._provider.provideLinkedEditingRanges(Q,fe,G);if(be&&Array.isArray(be.ranges))return{ranges:(0,R.coalesce)(be.ranges.map(D.Range.from)),wordPattern:be.wordPattern}}}class M{constructor(F,W){this._documents=F,this._provider=W}async provideReferences(F,W,G,Q){const fe=this._documents.getDocument(F),be=D.Position.to(W),ue=await this._provider.provideReferences(fe,be,G,Q);if(Array.isArray(ue))return ue.map(D.location.from)}}class A{constructor(F,W,G,Q,fe,be,ue){this._documents=F,this._commands=W,this._diagnostics=G,this._provider=Q,this._logService=fe,this._extension=be,this._apiDeprecation=ue,this._cache=new h.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(F,W,G,Q){const fe=this._documents.getDocument(F),be=_.Selection.isISelection(W)?D.Selection.to(W):D.Range.to(W),ue=[];for(const Qe of this._diagnostics.getDiagnostics(F))if(be.intersection(Qe.range)&&ue.push(Qe)>A._maxCodeActionsPerFile)break;const Ce={diagnostics:ue,only:G.only?new P.CodeActionKind(G.only):void 0,triggerKind:D.CodeActionTriggerKind.to(G.trigger)},Se=await this._provider.provideCodeActions(fe,be,Ce,Q);if(!(0,R.isNonEmptyArray)(Se)||Q.isCancellationRequested)return;const Ue=this._cache.add(Se),qe=new w.DisposableStore;this._disposables.set(Ue,qe);const Je=[];for(let Qe=0;Qe<Se.length;Qe++){const Re=Se[Qe];!Re||(A._isCommand(Re)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Je.push({_isSynthetic:!0,title:Re.title,command:this._commands.toInternal(Re,qe)})):(Ce.only&&(Re.kind?Ce.only.contains(Re.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ce.only.value} 'requested but returned code action is of kind '${Re.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ce.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Je.push({cacheId:[Ue,Qe],title:Re.title,command:Re.command&&this._commands.toInternal(Re.command,qe),diagnostics:Re.diagnostics&&Re.diagnostics.map(D.Diagnostic.from),edit:Re.edit&&D.WorkspaceEdit.from(Re.edit,void 0,(0,m.isProposedApiEnabled)(this._extension,"snippetWorkspaceEdit")),kind:Re.kind&&Re.kind.value,isPreferred:Re.isPreferred,disabled:Re.disabled?.reason})))}return{cacheId:Ue,actions:Je}}async resolveCodeAction(F,W){const[G,Q]=F,fe=this._cache.get(G,Q);if(!fe||A._isCommand(fe)||!this._provider.resolveCodeAction)return;const be=await this._provider.resolveCodeAction(fe,W)??fe;return be?.edit?D.WorkspaceEdit.from(be.edit,void 0,(0,m.isProposedApiEnabled)(this._extension,"snippetWorkspaceEdit")):void 0}releaseCodeActions(F){this._disposables.get(F)?.dispose(),this._disposables.delete(F),this._cache.delete(F)}static _isCommand(F){return typeof F.command=="string"&&typeof F.title=="string"}}A._maxCodeActionsPerFile=1e3;class B{constructor(F,W,G,Q){this._proxy=F,this._documents=W,this._provider=G,this._handle=Q}async prepareDocumentPaste(F,W,G,Q){if(!this._provider.prepareDocumentPaste)return;const fe=this._documents.getDocument(F),be=W.map(Ce=>D.Range.to(Ce)),ue=D.DataTransfer.toDataTransfer(G,()=>{throw new p.NotImplementedError});return await this._provider.prepareDocumentPaste(fe,be,ue,Q),D.DataTransfer.toDataTransferDTO(ue)}async providePasteEdits(F,W,G,Q,fe){const be=this._documents.getDocument(W),ue=G.map(Ue=>D.Range.to(Ue)),Ce=D.DataTransfer.toDataTransfer(Q,async Ue=>(await this._proxy.$resolvePasteFileData(this._handle,F,Ue)).buffer),Se=await this._provider.provideDocumentPasteEdits(be,ue,Ce,fe);if(!!Se)return{insertText:typeof Se.insertText=="string"?Se.insertText:{snippet:Se.insertText.value},additionalEdit:Se.additionalEdit?D.WorkspaceEdit.from(Se.additionalEdit,void 0,!0):void 0}}}class x{constructor(F,W){this._documents=F,this._provider=W}async provideDocumentFormattingEdits(F,W,G){const Q=this._documents.getDocument(F),fe=await this._provider.provideDocumentFormattingEdits(Q,W,G);if(Array.isArray(fe))return fe.map(D.TextEdit.from)}}class N{constructor(F,W){this._documents=F,this._provider=W}async provideDocumentRangeFormattingEdits(F,W,G,Q){const fe=this._documents.getDocument(F),be=D.Range.to(W),ue=await this._provider.provideDocumentRangeFormattingEdits(fe,be,G,Q);if(Array.isArray(ue))return ue.map(D.TextEdit.from)}}class K{constructor(F,W){this._documents=F,this._provider=W,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(F,W,G,Q,fe){const be=this._documents.getDocument(F),ue=D.Position.to(W),Ce=await this._provider.provideOnTypeFormattingEdits(be,ue,G,Q,fe);if(Array.isArray(Ce))return Ce.map(D.TextEdit.from)}}class X{constructor(F,W){this._provider=F,this._logService=W,this._cache=new h.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(F,W){const G=await this._provider.provideWorkspaceSymbols(F,W);if(!(0,R.isNonEmptyArray)(G))return{symbols:[]};const Q=this._cache.add(G),fe={cacheId:Q,symbols:[]};for(let be=0;be<G.length;be++){const ue=G[be];if(!ue||!ue.name){this._logService.warn("INVALID SymbolInformation",ue);continue}fe.symbols.push({...D.WorkspaceSymbol.from(ue),cacheId:[Q,be]})}return fe}async resolveWorkspaceSymbol(F,W){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!F.cacheId)return F;const G=this._cache.get(...F.cacheId);if(G){const Q=await this._provider.resolveWorkspaceSymbol(G,W);return Q&&(0,t.mixin)(F,D.WorkspaceSymbol.from(Q),!0)}}releaseWorkspaceSymbols(F){this._cache.delete(F)}}class L{constructor(F,W,G){this._documents=F,this._provider=W,this._logService=G}static supportsResolving(F){return typeof F.prepareRename=="function"}async provideRenameEdits(F,W,G,Q){const fe=this._documents.getDocument(F),be=D.Position.to(W);try{const ue=await this._provider.provideRenameEdits(fe,be,G,Q);return ue?D.WorkspaceEdit.from(ue):void 0}catch(ue){const Ce=L._asMessage(ue);return Ce?{rejectReason:Ce,edits:void 0}:Promise.reject(ue)}}async resolveRenameLocation(F,W,G){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const Q=this._documents.getDocument(F),fe=D.Position.to(W);try{const be=await this._provider.prepareRename(Q,fe,G);let ue,Ce;if(P.Range.isRange(be)?(ue=be,Ce=Q.getText(be)):(0,k.isObject)(be)&&(ue=be.range,Ce=be.placeholder),!ue||!Ce)return;if(ue.start.line>fe.line||ue.end.line<fe.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:D.Range.from(ue),text:Ce}}catch(be){const ue=L._asMessage(be);return ue?{rejectReason:ue,range:void 0,text:void 0}:Promise.reject(be)}}static _asMessage(F){return typeof F=="string"?F:F instanceof Error&&typeof F.message=="string"?F.message:void 0}}class ${constructor(F,W){this.resultId=F,this.tokens=W}}class H{constructor(F,W){this._documents=F,this._provider=W,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(F,W,G){const Q=this._documents.getDocument(F),fe=W!==0?this._previousResults.get(W):null;let be=typeof fe?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(Q,fe.resultId,G):await this._provider.provideDocumentSemanticTokens(Q,G);return fe&&this._previousResults.delete(W),be?(be=H._fixProvidedSemanticTokens(be),this._send(H._convertToEdits(fe,be),be)):null}async releaseDocumentSemanticColoring(F){this._previousResults.delete(F)}static _fixProvidedSemanticTokens(F){return H._isSemanticTokens(F)?H._isCorrectSemanticTokens(F)?F:new P.SemanticTokens(new Uint32Array(F.data),F.resultId):H._isSemanticTokensEdits(F)?H._isCorrectSemanticTokensEdits(F)?F:new P.SemanticTokensEdits(F.edits.map(W=>new P.SemanticTokensEdit(W.start,W.deleteCount,W.data?new Uint32Array(W.data):W.data)),F.resultId):F}static _isSemanticTokens(F){return F&&!!F.data}static _isCorrectSemanticTokens(F){return F.data instanceof Uint32Array}static _isSemanticTokensEdits(F){return F&&Array.isArray(F.edits)}static _isCorrectSemanticTokensEdits(F){for(const W of F.edits)if(!(W.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(F,W){if(!H._isSemanticTokens(W)||!F||!F.tokens)return W;const G=F.tokens,Q=G.length,fe=W.data,be=fe.length;let ue=0;const Ce=Math.min(Q,be);for(;ue<Ce&&G[ue]===fe[ue];)ue++;if(ue===Q&&ue===be)return new P.SemanticTokensEdits([],W.resultId);let Se=0;const Ue=Ce-ue;for(;Se<Ue&&G[Q-Se-1]===fe[be-Se-1];)Se++;return new P.SemanticTokensEdits([{start:ue,deleteCount:Q-ue-Se,data:fe.subarray(ue,be-Se)}],W.resultId)}_send(F,W){if(H._isSemanticTokens(F)){const G=this._nextResultId++;return this._previousResults.set(G,new $(F.resultId,F.data)),(0,b.encodeSemanticTokensDto)({id:G,type:"full",data:F.data})}if(H._isSemanticTokensEdits(F)){const G=this._nextResultId++;return H._isSemanticTokens(W)?this._previousResults.set(G,new $(W.resultId,W.data)):this._previousResults.set(G,new $(F.resultId)),(0,b.encodeSemanticTokensDto)({id:G,type:"delta",deltas:(F.edits||[]).map(Q=>({start:Q.start,deleteCount:Q.deleteCount,data:Q.data}))})}return null}}e.DocumentSemanticTokensAdapter=H;class j{constructor(F,W){this._documents=F,this._provider=W}async provideDocumentRangeSemanticTokens(F,W,G){const Q=this._documents.getDocument(F),fe=await this._provider.provideDocumentRangeSemanticTokens(Q,D.Range.to(W),G);return fe?this._send(fe):null}_send(F){return(0,b.encodeSemanticTokensDto)({id:0,type:"full",data:F.data})}}e.DocumentRangeSemanticTokensAdapter=j;class J{constructor(F,W,G,Q,fe){this._documents=F,this._commands=W,this._provider=G,this._apiDeprecation=Q,this._extension=fe,this._cache=new h.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(F){return typeof F.resolveCompletionItem=="function"}async provideCompletionItems(F,W,G,Q){const fe=this._documents.getDocument(F),be=D.Position.to(W),ue=fe.getWordRangeAtPosition(be)||new P.Range(be,be),Ce=ue.with({end:be}),Se=new g.StopWatch(!0),Ue=await this._provider.provideCompletionItems(fe,be,Q,D.CompletionContext.to(G));if(!Ue||Q.isCancellationRequested)return;const qe=Array.isArray(Ue)?new P.CompletionList(Ue):Ue,Je=J.supportsResolving(this._provider)?this._cache.add(qe.items):this._cache.add([]),Qe=new w.DisposableStore;this._disposables.set(Je,Qe);const Re=[],st={x:Je,b:Re,a:{replace:D.Range.from(ue),insert:D.Range.from(Ce)},c:qe.isIncomplete||void 0,d:Se.elapsed()};for(let se=0;se<qe.items.length;se++){const oe=qe.items[se],q=this._convertCompletionItem(oe,[Je,se],Ce,ue);Re.push(q)}return st}async resolveCompletionItem(F,W){if(typeof this._provider.resolveCompletionItem!="function")return;const G=this._cache.get(...F);if(!G)return;const Q=await this._provider.resolveCompletionItem(G,W);if(!!Q)return this._convertCompletionItem(Q,F)}releaseCompletionItems(F){this._disposables.get(F)?.dispose(),this._disposables.delete(F),this._cache.delete(F)}_convertCompletionItem(F,W,G,Q){const fe=this._disposables.get(W[0]);if(!fe)throw Error("DisposableStore is missing...");const be={x:W,a:F.label,b:F.kind!==void 0?D.CompletionItemKind.from(F.kind):void 0,n:F.tags&&F.tags.map(D.CompletionItemTag.from),c:F.detail,d:typeof F.documentation=="undefined"?void 0:D.MarkdownString.fromStrict(F.documentation),e:F.sortText!==F.label?F.sortText:void 0,f:F.filterText!==F.label?F.filterText:void 0,g:F.preselect||void 0,i:F.keepWhitespace?1:0,k:F.commitCharacters,l:F.additionalTextEdits&&F.additionalTextEdits.map(D.TextEdit.from),m:this._commands.toInternal(F.command,fe)};F.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),be.h=F.textEdit.newText):typeof F.insertText=="string"?be.h=F.insertText:F.insertText instanceof P.SnippetString&&(be.h=F.insertText.value,be.i|=4);let ue;return F.textEdit?ue=F.textEdit.range:F.range&&(ue=F.range),P.Range.isRange(ue)?be.j=D.Range.from(ue):ue&&(!G?.isEqual(ue.inserting)||!Q?.isEqual(ue.replacing))&&(be.j={insert:D.Range.from(ue.inserting),replace:D.Range.from(ue.replacing)}),be}}class Y{async provideInlineCompletions(F,W,G,Q){}disposeCompletions(F){}handleDidShowCompletionItem(F,W){}}class he extends Y{constructor(F,W,G,Q){super();this._extension=F,this._documents=W,this._provider=G,this._commands=Q,this._references=new ne,this._isAdditionsProposedApiEnabled=(0,m.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[y.InlineCompletionTriggerKind.Automatic]:P.InlineCompletionTriggerKind.Automatic,[y.InlineCompletionTriggerKind.Explicit]:P.InlineCompletionTriggerKind.Invoke}}get supportsHandleDidShowCompletionItem(){return(0,m.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&typeof this._provider.handleDidShowCompletionItem=="function"}async provideInlineCompletions(F,W,G,Q){const fe=this._documents.getDocument(F),be=D.Position.to(W),ue=await this._provider.provideInlineCompletionItems(fe,be,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:D.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[G.triggerKind]},Q);if(!ue||Q.isCancellationRequested)return;const Ce=Array.isArray(ue)?ue:ue.items,Se=this._isAdditionsProposedApiEnabled?Array.isArray(ue)?[]:ue.commands||[]:[];let Ue;return{pid:this._references.createReferenceId({dispose(){Ue?.dispose()},items:Ce}),items:Ce.map((Je,Qe)=>{let Re;Je.command&&(Ue||(Ue=new w.DisposableStore),Re=this._commands.toInternal(Je.command,Ue));const st=Je.insertText;return{insertText:typeof st=="string"?st:{snippet:st.value},filterText:Je.filterText,range:Je.range?D.Range.from(Je.range):void 0,command:Re,idx:Qe,completeBracketPairs:this._isAdditionsProposedApiEnabled?Je.completeBracketPairs:!1}}),commands:Se.map(Je=>(Ue||(Ue=new w.DisposableStore),this._commands.toInternal(Je,Ue)))}}disposeCompletions(F){this._references.disposeReferenceId(F)?.dispose()}handleDidShowCompletionItem(F,W){const G=this._references.get(F)?.items[W];G&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem(G)}}class ve extends Y{constructor(F,W,G,Q){super();this.extension=F,this._documents=W,this._provider=G,this._commands=Q,this._references=new ne,this.isAdditionProposedApiEnabled=(0,m.isProposedApiEnabled)(this.extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[y.InlineCompletionTriggerKind.Automatic]:P.InlineCompletionTriggerKindNew.Automatic,[y.InlineCompletionTriggerKind.Explicit]:P.InlineCompletionTriggerKindNew.Invoke}}async provideInlineCompletions(F,W,G,Q){const fe=this._documents.getDocument(F),be=D.Position.to(W),ue=await this._provider.provideInlineCompletionItems(fe,be,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:D.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[G.triggerKind]},Q);if(!ue||Q.isCancellationRequested)return;const Ce=Array.isArray(ue)?ue:ue.items,Se=Array.isArray(ue)?[]:ue.commands||[];let Ue;return{pid:this._references.createReferenceId({dispose(){Ue?.dispose()},items:Ce}),items:Ce.map((Je,Qe)=>{let Re;Je.command&&(Ue||(Ue=new w.DisposableStore),Re=this._commands.toInternal(Je.command,Ue));const st=Je.insertText;return{insertText:typeof st=="string"?st:{snippet:st.value},filterText:Je.filterText,range:Je.range?D.Range.from(Je.range):void 0,command:Re,idx:Qe,completeBracketPairs:this.isAdditionProposedApiEnabled?Je.completeBracketPairs:!1}}),commands:Se.map(Je=>(Ue||(Ue=new w.DisposableStore),this._commands.toInternal(Je,Ue)))}}disposeCompletions(F){this._references.disposeReferenceId(F)?.dispose()}handleDidShowCompletionItem(F,W){const G=this._references.get(F)?.items[W];G&&this._provider.handleDidShowCompletionItem&&this.isAdditionProposedApiEnabled&&this._provider.handleDidShowCompletionItem(G)}}class ne{constructor(){this._references=new Map,this._idPool=1}createReferenceId(F){const W=this._idPool++;return this._references.set(W,F),W}disposeReferenceId(F){const W=this._references.get(F);return this._references.delete(F),W}get(F){return this._references.get(F)}}class pe{constructor(F,W){this._documents=F,this._provider=W,this._cache=new h.Cache("SignatureHelp")}async provideSignatureHelp(F,W,G,Q){const fe=this._documents.getDocument(F),be=D.Position.to(W),ue=this.reviveContext(G),Ce=await this._provider.provideSignatureHelp(fe,be,Q,ue);if(Ce){const Se=this._cache.add([Ce]);return{...D.SignatureHelp.from(Ce),id:Se}}}reviveContext(F){let W;if(F.activeSignatureHelp){const G=D.SignatureHelp.to(F.activeSignatureHelp),Q=this._cache.get(F.activeSignatureHelp.id,0);Q?(W=Q,W.activeSignature=G.activeSignature,W.activeParameter=G.activeParameter):W=G}return{...F,activeSignatureHelp:W}}releaseSignatureHelp(F){this._cache.delete(F)}}class Ee{constructor(F,W,G,Q,fe){this._documents=F,this._commands=W,this._provider=G,this._logService=Q,this._extension=fe,this._cache=new h.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(F,W,G){const Q=this._documents.getDocument(F),fe=D.Range.to(W),be=await this._provider.provideInlayHints(Q,fe,G);if(!Array.isArray(be)||be.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${W}`);return}if(G.isCancellationRequested)return;const ue=this._cache.add(be);this._disposables.set(ue,new w.DisposableStore);const Ce={hints:[],cacheId:ue};for(let Se=0;Se<be.length;Se++)this._isValidInlayHint(be[Se],fe)&&Ce.hints.push(this._convertInlayHint(be[Se],[ue,Se]));return this._logService.trace(`[InlayHints] ${Ce.hints.length} inlay hints from '${this._extension.identifier.value}' for ${W}`),Ce}async resolveInlayHint(F,W){if(typeof this._provider.resolveInlayHint!="function")return;const G=this._cache.get(...F);if(!G)return;const Q=await this._provider.resolveInlayHint(G,W);if(!!Q&&!!this._isValidInlayHint(Q))return this._convertInlayHint(Q,F)}releaseHints(F){this._disposables.get(F)?.dispose(),this._disposables.delete(F),this._cache.delete(F)}_isValidInlayHint(F,W){return F.label.length===0||Array.isArray(F.label)&&F.label.every(G=>G.value.length===0)?(console.log("INVALID inlay hint, empty label",F),!1):!(W&&!W.contains(F.position))}_convertInlayHint(F,W){const G=this._disposables.get(W[0]);if(!G)throw Error("DisposableStore is missing...");const Q={label:"",cacheId:W,tooltip:D.MarkdownString.fromStrict(F.tooltip),position:D.Position.from(F.position),textEdits:F.textEdits&&F.textEdits.map(D.TextEdit.from),kind:F.kind&&D.InlayHintKind.from(F.kind),paddingLeft:F.paddingLeft,paddingRight:F.paddingRight};return typeof F.label=="string"?Q.label=F.label:Q.label=F.label.map(fe=>{const be={label:fe.value};return be.tooltip=D.MarkdownString.fromStrict(fe.tooltip),P.Location.isLocation(fe.location)&&(be.location=D.location.from(fe.location)),fe.command&&(be.command=this._commands.toInternal(fe.command,G)),be}),Q}}class ke{constructor(F,W){this._documents=F,this._provider=W,this._cache=new h.Cache("DocumentLink")}async provideLinks(F,W){const G=this._documents.getDocument(F),Q=await this._provider.provideDocumentLinks(G,W);if(!(!Array.isArray(Q)||Q.length===0)&&!W.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:Q.filter(ke._validateLink).map(D.DocumentLink.from)};{const fe=this._cache.add(Q),be={links:[],cacheId:fe};for(let ue=0;ue<Q.length;ue++){if(!ke._validateLink(Q[ue]))continue;const Ce=D.DocumentLink.from(Q[ue]);Ce.cacheId=[fe,ue],be.links.push(Ce)}return be}}}static _validateLink(F){return F.target&&F.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(F,W){if(typeof this._provider.resolveDocumentLink!="function")return;const G=this._cache.get(...F);if(!G)return;const Q=await this._provider.resolveDocumentLink(G,W);if(!(!Q||!ke._validateLink(Q)))return D.DocumentLink.from(Q)}releaseLinks(F){this._cache.delete(F)}}class Oe{constructor(F,W){this._documents=F,this._provider=W}async provideColors(F,W){const G=this._documents.getDocument(F),Q=await this._provider.provideDocumentColors(G,W);return Array.isArray(Q)?Q.map(be=>({color:D.Color.from(be.color),range:D.Range.from(be.range)})):[]}async provideColorPresentations(F,W,G){const Q=this._documents.getDocument(F),fe=D.Range.to(W.range),be=D.Color.to(W.color),ue=await this._provider.provideColorPresentations(be,{document:Q,range:fe},G);if(!!Array.isArray(ue))return ue.map(D.ColorPresentation.from)}}class Be{constructor(F,W){this._documents=F,this._provider=W}async provideFoldingRanges(F,W,G){const Q=this._documents.getDocument(F),fe=await this._provider.provideFoldingRanges(Q,W,G);if(!!Array.isArray(fe))return fe.map(D.FoldingRange.from)}}class ae{constructor(F,W,G){this._documents=F,this._provider=W,this._logService=G}async provideSelectionRanges(F,W,G){const Q=this._documents.getDocument(F),fe=W.map(D.Position.to),be=await this._provider.provideSelectionRanges(Q,fe,G);if(!(0,R.isNonEmptyArray)(be))return[];if(be.length!==fe.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const ue=[];for(let Ce=0;Ce<fe.length;Ce++){const Se=[];ue.push(Se);let Ue=fe[Ce],qe=be[Ce];for(;;){if(!qe.range.contains(Ue))throw new Error("INVALID selection range, must contain the previous range");if(Se.push(D.SelectionRange.from(qe)),!qe.parent)break;Ue=qe.range,qe=qe.parent}}return ue}}class de{constructor(F,W){this._documents=F,this._provider=W,this._idPool=new v.IdGenerator(""),this._cache=new Map}async prepareSession(F,W,G){const Q=this._documents.getDocument(F),fe=D.Position.to(W),be=await this._provider.prepareCallHierarchy(Q,fe,G);if(!be)return;const ue=this._idPool.nextId();return this._cache.set(ue,new Map),Array.isArray(be)?be.map(Ce=>this._cacheAndConvertItem(ue,Ce)):[this._cacheAndConvertItem(ue,be)]}async provideCallsTo(F,W,G){const Q=this._itemFromCache(F,W);if(!Q)throw new Error("missing call hierarchy item");const fe=await this._provider.provideCallHierarchyIncomingCalls(Q,G);if(!!fe)return fe.map(be=>({from:this._cacheAndConvertItem(F,be.from),fromRanges:be.fromRanges.map(ue=>D.Range.from(ue))}))}async provideCallsFrom(F,W,G){const Q=this._itemFromCache(F,W);if(!Q)throw new Error("missing call hierarchy item");const fe=await this._provider.provideCallHierarchyOutgoingCalls(Q,G);if(!!fe)return fe.map(be=>({to:this._cacheAndConvertItem(F,be.to),fromRanges:be.fromRanges.map(ue=>D.Range.from(ue))}))}releaseSession(F){this._cache.delete(F)}_cacheAndConvertItem(F,W){const G=this._cache.get(F),Q=D.CallHierarchyItem.from(W,F,G.size.toString(36));return G.set(Q._itemId,W),Q}_itemFromCache(F,W){return this._cache.get(F)?.get(W)}}class me{constructor(F,W){this._documents=F,this._provider=W,this._idPool=new v.IdGenerator(""),this._cache=new Map}async prepareSession(F,W,G){const Q=this._documents.getDocument(F),fe=D.Position.to(W),be=await this._provider.prepareTypeHierarchy(Q,fe,G);if(!be)return;const ue=this._idPool.nextId();return this._cache.set(ue,new Map),Array.isArray(be)?be.map(Ce=>this._cacheAndConvertItem(ue,Ce)):[this._cacheAndConvertItem(ue,be)]}async provideSupertypes(F,W,G){const Q=this._itemFromCache(F,W);if(!Q)throw new Error("missing type hierarchy item");const fe=await this._provider.provideTypeHierarchySupertypes(Q,G);if(!!fe)return fe.map(be=>this._cacheAndConvertItem(F,be))}async provideSubtypes(F,W,G){const Q=this._itemFromCache(F,W);if(!Q)throw new Error("missing type hierarchy item");const fe=await this._provider.provideTypeHierarchySubtypes(Q,G);if(!!fe)return fe.map(be=>this._cacheAndConvertItem(F,be))}releaseSession(F){this._cache.delete(F)}_cacheAndConvertItem(F,W){const G=this._cache.get(F),Q=D.TypeHierarchyItem.from(W,F,G.size.toString(36));return G.set(Q._itemId,W),Q}_itemFromCache(F,W){return this._cache.get(F)?.get(W)}}class te{constructor(F,W,G,Q){this._proxy=F,this._documents=W,this._provider=G,this._handle=Q}async provideDocumentOnDropEdits(F,W,G,Q,fe){const be=this._documents.getDocument(W),ue=D.Position.to(G),Ce=D.DataTransfer.toDataTransfer(Q,async Ue=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,F,Ue)).buffer),Se=await this._provider.provideDocumentDropEdits(be,ue,Ce,fe);if(!!Se)return{insertText:typeof Se.insertText=="string"?Se.insertText:{snippet:Se.insertText.value},additionalEdit:Se.additionalEdit?D.WorkspaceEdit.from(Se.additionalEdit,void 0,!0):void 0}}}class le{constructor(F,W){this.adapter=F,this.extension=W}}class ee{constructor(F,W,G,Q,fe,be,ue){this._adapter=new Map,this._uriTransformer=W,this._proxy=F.getProxy(C.MainContext.MainThreadLanguageFeatures),this._documents=G,this._commands=Q,this._diagnostics=fe,this._logService=be,this._apiDeprecation=ue}_transformDocumentSelector(F){return D.DocumentSelector.from(F,this._uriTransformer)}_createDisposable(F){return new P.Disposable(()=>{this._adapter.delete(F),this._proxy.$unregister(F)})}_nextHandle(){return ee._handlePool++}async _withAdapter(F,W,G,Q,fe,be=!1){const ue=this._adapter.get(F);if(!ue||!(ue.adapter instanceof W))return Q;const Ce=Date.now();be||this._logService.trace(`[${ue.extension.identifier.value}] INVOKE provider '${G.toString().replace(/[\r\n]/g,"")}'`);const Se=G(ue.adapter,ue.extension);return Promise.resolve(Se).catch(Ue=>{(0,p.isCancellationError)(Ue)||(this._logService.error(`[${ue.extension.identifier.value}] provider FAILED`),this._logService.error(Ue))}).finally(()=>{be||this._logService.trace(`[${ue.extension.identifier.value}] provider DONE after ${Date.now()-Ce}ms`)}),T.CancellationToken.isCancellationToken(fe)?(0,o.raceCancellationError)(Se,fe):Se}_addNewAdapter(F,W){const G=this._nextHandle();return this._adapter.set(G,new le(F,W)),G}static _extLabel(F){return F.displayName||F.name}registerDocumentSymbolProvider(F,W,G,Q){const fe=this._addNewAdapter(new c(this._documents,G),F),be=Q&&Q.label||ee._extLabel(F);return this._proxy.$registerDocumentSymbolProvider(fe,this._transformDocumentSelector(W),be),this._createDisposable(fe)}$provideDocumentSymbols(F,W,G){return this._withAdapter(F,c,Q=>Q.provideDocumentSymbols(u.URI.revive(W),G),void 0,G)}registerCodeLensProvider(F,W,G){const Q=this._nextHandle(),fe=typeof G.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(Q,new le(new l(this._documents,this._commands.converter,G),F)),this._proxy.$registerCodeLensSupport(Q,this._transformDocumentSelector(W),fe);let be=this._createDisposable(Q);if(fe!==void 0){const ue=G.onDidChangeCodeLenses(Ce=>this._proxy.$emitCodeLensEvent(fe));be=P.Disposable.from(be,ue)}return be}$provideCodeLenses(F,W,G){return this._withAdapter(F,l,Q=>Q.provideCodeLenses(u.URI.revive(W),G),void 0,G)}$resolveCodeLens(F,W,G){return this._withAdapter(F,l,Q=>Q.resolveCodeLens(W,G),void 0,void 0)}$releaseCodeLenses(F,W){this._withAdapter(F,l,G=>Promise.resolve(G.releaseCodeLenses(W)),void 0,void 0)}registerDefinitionProvider(F,W,G){const Q=this._addNewAdapter(new i(this._documents,G),F);return this._proxy.$registerDefinitionSupport(Q,this._transformDocumentSelector(W)),this._createDisposable(Q)}$provideDefinition(F,W,G,Q){return this._withAdapter(F,i,fe=>fe.provideDefinition(u.URI.revive(W),G,Q),[],Q)}registerDeclarationProvider(F,W,G){const Q=this._addNewAdapter(new r(this._documents,G),F);return this._proxy.$registerDeclarationSupport(Q,this._transformDocumentSelector(W)),this._createDisposable(Q)}$provideDeclaration(F,W,G,Q){return this._withAdapter(F,r,fe=>fe.provideDeclaration(u.URI.revive(W),G,Q),[],Q)}registerImplementationProvider(F,W,G){const Q=this._addNewAdapter(new n(this._documents,G),F);return this._proxy.$registerImplementationSupport(Q,this._transformDocumentSelector(W)),this._createDisposable(Q)}$provideImplementation(F,W,G,Q){return this._withAdapter(F,n,fe=>fe.provideImplementation(u.URI.revive(W),G,Q),[],Q)}registerTypeDefinitionProvider(F,W,G){const Q=this._addNewAdapter(new a(this._documents,G),F);return this._proxy.$registerTypeDefinitionSupport(Q,this._transformDocumentSelector(W)),this._createDisposable(Q)}$provideTypeDefinition(F,W,G,Q){return this._withAdapter(F,a,fe=>fe.provideTypeDefinition(u.URI.revive(W),G,Q),[],Q)}registerHoverProvider(F,W,G,Q){const fe=this._addNewAdapter(new d(this._documents,G),F);return this._proxy.$registerHoverProvider(fe,this._transformDocumentSelector(W)),this._createDisposable(fe)}$provideHover(F,W,G,Q){return this._withAdapter(F,d,fe=>fe.provideHover(u.URI.revive(W),G,Q),void 0,Q)}registerEvaluatableExpressionProvider(F,W,G,Q){const fe=this._addNewAdapter(new f(this._documents,G),F);return this._proxy.$registerEvaluatableExpressionProvider(fe,this._transformDocumentSelector(W)),this._createDisposable(fe)}$provideEvaluatableExpression(F,W,G,Q){return this._withAdapter(F,f,fe=>fe.provideEvaluatableExpression(u.URI.revive(W),G,Q),void 0,Q)}registerInlineValuesProvider(F,W,G,Q){const fe=typeof G.onDidChangeInlineValues=="function"?this._nextHandle():void 0,be=this._addNewAdapter(new S(this._documents,G),F);this._proxy.$registerInlineValuesProvider(be,this._transformDocumentSelector(W),fe);let ue=this._createDisposable(be);if(fe!==void 0){const Ce=G.onDidChangeInlineValues(Se=>this._proxy.$emitInlineValuesEvent(fe));ue=P.Disposable.from(ue,Ce)}return ue}$provideInlineValues(F,W,G,Q,fe){return this._withAdapter(F,S,be=>be.provideInlineValues(u.URI.revive(W),G,Q,fe),void 0,fe)}registerDocumentHighlightProvider(F,W,G){const Q=this._addNewAdapter(new O(this._documents,G),F);return this._proxy.$registerDocumentHighlightProvider(Q,this._transformDocumentSelector(W)),this._createDisposable(Q)}$provideDocumentHighlights(F,W,G,Q){return this._withAdapter(F,O,fe=>fe.provideDocumentHighlights(u.URI.revive(W),G,Q),void 0,Q)}registerLinkedEditingRangeProvider(F,W,G){const Q=this._addNewAdapter(new U(this._documents,G),F);return this._proxy.$registerLinkedEditingRangeProvider(Q,this._transformDocumentSelector(W)),this._createDisposable(Q)}$provideLinkedEditingRanges(F,W,G,Q){return this._withAdapter(F,U,async fe=>{const be=await fe.provideLinkedEditingRanges(u.URI.revive(W),G,Q);if(be)return{ranges:be.ranges,wordPattern:be.wordPattern?ee._serializeRegExp(be.wordPattern):void 0}},void 0,Q)}registerReferenceProvider(F,W,G){const Q=this._addNewAdapter(new M(this._documents,G),F);return this._proxy.$registerReferenceSupport(Q,this._transformDocumentSelector(W)),this._createDisposable(Q)}$provideReferences(F,W,G,Q,fe){return this._withAdapter(F,M,be=>be.provideReferences(u.URI.revive(W),G,Q,fe),void 0,fe)}registerCodeActionProvider(F,W,G,Q){const fe=new w.DisposableStore,be=this._addNewAdapter(new A(this._documents,this._commands.converter,this._diagnostics,G,this._logService,F,this._apiDeprecation),F);return this._proxy.$registerQuickFixSupport(be,this._transformDocumentSelector(W),{providedKinds:Q?.providedCodeActionKinds?.map(ue=>ue.value),documentation:Q?.documentation?.map(ue=>({kind:ue.kind.value,command:this._commands.converter.toInternal(ue.command,fe)}))},ee._extLabel(F),Boolean(G.resolveCodeAction)),fe.add(this._createDisposable(be)),fe}$provideCodeActions(F,W,G,Q,fe){return this._withAdapter(F,A,be=>be.provideCodeActions(u.URI.revive(W),G,Q,fe),void 0,fe)}$resolveCodeAction(F,W,G){return this._withAdapter(F,A,Q=>Q.resolveCodeAction(W,G),void 0,void 0)}$releaseCodeActions(F,W){this._withAdapter(F,A,G=>Promise.resolve(G.releaseCodeActions(W)),void 0,void 0)}registerDocumentFormattingEditProvider(F,W,G){const Q=this._addNewAdapter(new x(this._documents,G),F);return this._proxy.$registerDocumentFormattingSupport(Q,this._transformDocumentSelector(W),F.identifier,F.displayName||F.name),this._createDisposable(Q)}$provideDocumentFormattingEdits(F,W,G,Q){return this._withAdapter(F,x,fe=>fe.provideDocumentFormattingEdits(u.URI.revive(W),G,Q),void 0,Q)}registerDocumentRangeFormattingEditProvider(F,W,G){const Q=this._addNewAdapter(new N(this._documents,G),F);return this._proxy.$registerRangeFormattingSupport(Q,this._transformDocumentSelector(W),F.identifier,F.displayName||F.name),this._createDisposable(Q)}$provideDocumentRangeFormattingEdits(F,W,G,Q,fe){return this._withAdapter(F,N,be=>be.provideDocumentRangeFormattingEdits(u.URI.revive(W),G,Q,fe),void 0,fe)}registerOnTypeFormattingEditProvider(F,W,G,Q){const fe=this._addNewAdapter(new K(this._documents,G),F);return this._proxy.$registerOnTypeFormattingSupport(fe,this._transformDocumentSelector(W),Q,F.identifier),this._createDisposable(fe)}$provideOnTypeFormattingEdits(F,W,G,Q,fe,be){return this._withAdapter(F,K,ue=>ue.provideOnTypeFormattingEdits(u.URI.revive(W),G,Q,fe,be),void 0,be)}registerWorkspaceSymbolProvider(F,W){const G=this._addNewAdapter(new X(W,this._logService),F);return this._proxy.$registerNavigateTypeSupport(G,typeof W.resolveWorkspaceSymbol=="function"),this._createDisposable(G)}$provideWorkspaceSymbols(F,W,G){return this._withAdapter(F,X,Q=>Q.provideWorkspaceSymbols(W,G),{symbols:[]},G)}$resolveWorkspaceSymbol(F,W,G){return this._withAdapter(F,X,Q=>Q.resolveWorkspaceSymbol(W,G),void 0,void 0)}$releaseWorkspaceSymbols(F,W){this._withAdapter(F,X,G=>G.releaseWorkspaceSymbols(W),void 0,void 0)}registerRenameProvider(F,W,G){const Q=this._addNewAdapter(new L(this._documents,G,this._logService),F);return this._proxy.$registerRenameSupport(Q,this._transformDocumentSelector(W),L.supportsResolving(G)),this._createDisposable(Q)}$provideRenameEdits(F,W,G,Q,fe){return this._withAdapter(F,L,be=>be.provideRenameEdits(u.URI.revive(W),G,Q,fe),void 0,fe)}$resolveRenameLocation(F,W,G,Q){return this._withAdapter(F,L,fe=>fe.resolveRenameLocation(u.URI.revive(W),G,Q),void 0,Q)}registerDocumentSemanticTokensProvider(F,W,G,Q){const fe=this._addNewAdapter(new H(this._documents,G),F),be=typeof G.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(fe,this._transformDocumentSelector(W),Q,be);let ue=this._createDisposable(fe);if(be){const Ce=G.onDidChangeSemanticTokens(Se=>this._proxy.$emitDocumentSemanticTokensEvent(be));ue=P.Disposable.from(ue,Ce)}return ue}$provideDocumentSemanticTokens(F,W,G,Q){return this._withAdapter(F,H,fe=>fe.provideDocumentSemanticTokens(u.URI.revive(W),G,Q),null,Q)}$releaseDocumentSemanticTokens(F,W){this._withAdapter(F,H,G=>G.releaseDocumentSemanticColoring(W),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(F,W,G,Q){const fe=this._addNewAdapter(new j(this._documents,G),F);return this._proxy.$registerDocumentRangeSemanticTokensProvider(fe,this._transformDocumentSelector(W),Q),this._createDisposable(fe)}$provideDocumentRangeSemanticTokens(F,W,G,Q){return this._withAdapter(F,j,fe=>fe.provideDocumentRangeSemanticTokens(u.URI.revive(W),G,Q),null,Q)}registerCompletionItemProvider(F,W,G,Q){const fe=this._addNewAdapter(new J(this._documents,this._commands.converter,G,this._apiDeprecation,F),F);return this._proxy.$registerCompletionsProvider(fe,this._transformDocumentSelector(W),Q,J.supportsResolving(G),`${F.identifier.value}(${Q.join("")})`),this._createDisposable(fe)}$provideCompletionItems(F,W,G,Q,fe){return this._withAdapter(F,J,be=>be.provideCompletionItems(u.URI.revive(W),G,Q,fe),void 0,fe)}$resolveCompletionItem(F,W,G){return this._withAdapter(F,J,Q=>Q.resolveCompletionItem(W,G),void 0,G)}$releaseCompletionItems(F,W){this._withAdapter(F,J,G=>G.releaseCompletionItems(W),void 0,void 0)}registerInlineCompletionsProvider(F,W,G){const Q=new he(F,this._documents,G,this._commands.converter),fe=this._addNewAdapter(Q,F);return this._proxy.$registerInlineCompletionsSupport(fe,this._transformDocumentSelector(W),Q.supportsHandleDidShowCompletionItem),this._createDisposable(fe)}registerInlineCompletionsProviderNew(F,W,G){const Q=this._addNewAdapter(new ve(F,this._documents,G,this._commands.converter),F);return this._proxy.$registerInlineCompletionsSupport(Q,this._transformDocumentSelector(W),!0),this._createDisposable(Q)}$provideInlineCompletions(F,W,G,Q,fe){return this._withAdapter(F,Y,be=>be.provideInlineCompletions(u.URI.revive(W),G,Q,fe),void 0,fe)}$handleInlineCompletionDidShow(F,W,G){this._withAdapter(F,Y,async Q=>{Q.handleDidShowCompletionItem(W,G)},void 0,void 0)}$freeInlineCompletionsList(F,W){this._withAdapter(F,Y,async G=>{G.disposeCompletions(W)},void 0,void 0)}registerSignatureHelpProvider(F,W,G,Q){const fe=Array.isArray(Q)?{triggerCharacters:Q,retriggerCharacters:[]}:Q,be=this._addNewAdapter(new pe(this._documents,G),F);return this._proxy.$registerSignatureHelpProvider(be,this._transformDocumentSelector(W),fe),this._createDisposable(be)}$provideSignatureHelp(F,W,G,Q,fe){return this._withAdapter(F,pe,be=>be.provideSignatureHelp(u.URI.revive(W),G,Q,fe),void 0,fe)}$releaseSignatureHelp(F,W){this._withAdapter(F,pe,G=>G.releaseSignatureHelp(W),void 0,void 0)}registerInlayHintsProvider(F,W,G){const Q=typeof G.onDidChangeInlayHints=="function"?this._nextHandle():void 0,fe=this._addNewAdapter(new Ee(this._documents,this._commands.converter,G,this._logService,F),F);this._proxy.$registerInlayHintsProvider(fe,this._transformDocumentSelector(W),typeof G.resolveInlayHint=="function",Q,ee._extLabel(F));let be=this._createDisposable(fe);if(Q!==void 0){const ue=G.onDidChangeInlayHints(Ce=>this._proxy.$emitInlayHintsEvent(Q));be=P.Disposable.from(be,ue)}return be}$provideInlayHints(F,W,G,Q){return this._withAdapter(F,Ee,fe=>fe.provideInlayHints(u.URI.revive(W),G,Q),void 0,Q)}$resolveInlayHint(F,W,G){return this._withAdapter(F,Ee,Q=>Q.resolveInlayHint(W,G),void 0,G)}$releaseInlayHints(F,W){this._withAdapter(F,Ee,G=>G.releaseHints(W),void 0,void 0)}registerDocumentLinkProvider(F,W,G){const Q=this._addNewAdapter(new ke(this._documents,G),F);return this._proxy.$registerDocumentLinkProvider(Q,this._transformDocumentSelector(W),typeof G.resolveDocumentLink=="function"),this._createDisposable(Q)}$provideDocumentLinks(F,W,G){return this._withAdapter(F,ke,Q=>Q.provideLinks(u.URI.revive(W),G),void 0,G,W.scheme==="output")}$resolveDocumentLink(F,W,G){return this._withAdapter(F,ke,Q=>Q.resolveLink(W,G),void 0,void 0,!0)}$releaseDocumentLinks(F,W){this._withAdapter(F,ke,G=>G.releaseLinks(W),void 0,void 0,!0)}registerColorProvider(F,W,G){const Q=this._addNewAdapter(new Oe(this._documents,G),F);return this._proxy.$registerDocumentColorProvider(Q,this._transformDocumentSelector(W)),this._createDisposable(Q)}$provideDocumentColors(F,W,G){return this._withAdapter(F,Oe,Q=>Q.provideColors(u.URI.revive(W),G),[],G)}$provideColorPresentations(F,W,G,Q){return this._withAdapter(F,Oe,fe=>fe.provideColorPresentations(u.URI.revive(W),G,Q),void 0,Q)}registerFoldingRangeProvider(F,W,G){const Q=this._nextHandle(),fe=typeof G.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(Q,new le(new Be(this._documents,G),F)),this._proxy.$registerFoldingRangeProvider(Q,this._transformDocumentSelector(W),fe);let be=this._createDisposable(Q);if(fe!==void 0){const ue=G.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(fe));be=P.Disposable.from(be,ue)}return be}$provideFoldingRanges(F,W,G,Q){return this._withAdapter(F,Be,fe=>fe.provideFoldingRanges(u.URI.revive(W),G,Q),void 0,Q)}registerSelectionRangeProvider(F,W,G){const Q=this._addNewAdapter(new ae(this._documents,G,this._logService),F);return this._proxy.$registerSelectionRangeProvider(Q,this._transformDocumentSelector(W)),this._createDisposable(Q)}$provideSelectionRanges(F,W,G,Q){return this._withAdapter(F,ae,fe=>fe.provideSelectionRanges(u.URI.revive(W),G,Q),[],Q)}registerCallHierarchyProvider(F,W,G){const Q=this._addNewAdapter(new de(this._documents,G),F);return this._proxy.$registerCallHierarchyProvider(Q,this._transformDocumentSelector(W)),this._createDisposable(Q)}$prepareCallHierarchy(F,W,G,Q){return this._withAdapter(F,de,fe=>Promise.resolve(fe.prepareSession(u.URI.revive(W),G,Q)),void 0,Q)}$provideCallHierarchyIncomingCalls(F,W,G,Q){return this._withAdapter(F,de,fe=>fe.provideCallsTo(W,G,Q),void 0,Q)}$provideCallHierarchyOutgoingCalls(F,W,G,Q){return this._withAdapter(F,de,fe=>fe.provideCallsFrom(W,G,Q),void 0,Q)}$releaseCallHierarchy(F,W){this._withAdapter(F,de,G=>Promise.resolve(G.releaseSession(W)),void 0,void 0)}registerTypeHierarchyProvider(F,W,G){const Q=this._addNewAdapter(new me(this._documents,G),F);return this._proxy.$registerTypeHierarchyProvider(Q,this._transformDocumentSelector(W)),this._createDisposable(Q)}$prepareTypeHierarchy(F,W,G,Q){return this._withAdapter(F,me,fe=>Promise.resolve(fe.prepareSession(u.URI.revive(W),G,Q)),void 0,Q)}$provideTypeHierarchySupertypes(F,W,G,Q){return this._withAdapter(F,me,fe=>fe.provideSupertypes(W,G,Q),void 0,Q)}$provideTypeHierarchySubtypes(F,W,G,Q){return this._withAdapter(F,me,fe=>fe.provideSubtypes(W,G,Q),void 0,Q)}$releaseTypeHierarchy(F,W){this._withAdapter(F,me,G=>Promise.resolve(G.releaseSession(W)),void 0,void 0)}registerDocumentOnDropEditProvider(F,W,G){const Q=this._nextHandle();return this._adapter.set(Q,new le(new te(this._proxy,this._documents,G,Q),F)),this._proxy.$registerDocumentOnDropEditProvider(Q,this._transformDocumentSelector(W)),this._createDisposable(Q)}$provideDocumentOnDropEdits(F,W,G,Q,fe,be){return this._withAdapter(F,te,ue=>Promise.resolve(ue.provideDocumentOnDropEdits(W,u.URI.revive(G),Q,fe,be)),void 0,void 0)}registerDocumentPasteEditProvider(F,W,G,Q){const fe=this._nextHandle();return this._adapter.set(fe,new le(new B(this._proxy,this._documents,G,fe),F)),this._proxy.$registerPasteEditProvider(fe,this._transformDocumentSelector(W),!!G.prepareDocumentPaste,Q.pasteMimeTypes),this._createDisposable(fe)}$prepareDocumentPaste(F,W,G,Q,fe){return this._withAdapter(F,B,be=>be.prepareDocumentPaste(u.URI.revive(W),G,Q,fe),void 0,fe)}$providePasteEdits(F,W,G,Q,fe,be){return this._withAdapter(F,B,ue=>ue.providePasteEdits(W,u.URI.revive(G),Q,fe,be),void 0,be)}static _serializeRegExp(F){return{pattern:F.source,flags:(0,E.regExpFlags)(F)}}static _serializeIndentationRule(F){return{decreaseIndentPattern:ee._serializeRegExp(F.decreaseIndentPattern),increaseIndentPattern:ee._serializeRegExp(F.increaseIndentPattern),indentNextLinePattern:F.indentNextLinePattern?ee._serializeRegExp(F.indentNextLinePattern):void 0,unIndentedLinePattern:F.unIndentedLinePattern?ee._serializeRegExp(F.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(F){return{beforeText:ee._serializeRegExp(F.beforeText),afterText:F.afterText?ee._serializeRegExp(F.afterText):void 0,previousLineText:F.previousLineText?ee._serializeRegExp(F.previousLineText):void 0,action:F.action}}static _serializeOnEnterRules(F){return F.map(ee._serializeOnEnterRule)}setLanguageConfiguration(F,W,G){const{wordPattern:Q}=G;if(Q&&(0,E.regExpLeadsToEndlessLoop)(Q))throw new Error(`Invalid language configuration: wordPattern '${Q}' is not allowed to match the empty string.`);Q?this._documents.setWordDefinitionFor(W,Q):this._documents.setWordDefinitionFor(W,void 0),G.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",F,"Do not use."),G.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",F,"Do not use.");const fe=this._nextHandle(),be={comments:G.comments,brackets:G.brackets,wordPattern:G.wordPattern?ee._serializeRegExp(G.wordPattern):void 0,indentationRules:G.indentationRules?ee._serializeIndentationRule(G.indentationRules):void 0,onEnterRules:G.onEnterRules?ee._serializeOnEnterRules(G.onEnterRules):void 0,__electricCharacterSupport:G.__electricCharacterSupport,__characterPairSupport:G.__characterPairSupport};return this._proxy.$setLanguageConfiguration(fe,W,be),this._createDisposable(fe)}$setWordDefinitions(F){for(const W of F)this._documents.setWordDefinitionFor(W.languageId,new RegExp(W.regexSource,W.regexFlags))}}e.ExtHostLanguageFeatures=ee,ee._handlePool=0}),define(De[250],Ie([1,0,5,16,7,41,18,6]),function(Z,e,u,t,D,P,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class E{constructor(R,k,_,T){this._documents=k,this._commands=_,this._uriTransformer=T,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=R.getProxy(u.MainContext.MainThreadLanguages)}$acceptLanguageIds(R){this._languageIds=R}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(R,k){await this._proxy.$changeLanguage(R,k);const _=this._documents.getDocumentData(R);if(!_)throw new Error(`document '${R.toString()}' NOT found`);return _.document}async tokenAtPosition(R,k){const _=R.version,T=t.Position.from(k),w=await this._proxy.$tokensAtPosition(R.uri,T),b={type:D.StandardTokenType.Other,range:R.getWordRangeAtPosition(k)??new D.Range(k.line,k.character,k.line,k.character)};if(!w)return b;const v={range:t.Range.to(w.range),type:t.TokenType.to(w.type)};return!v.range.contains(k)||_!==R.version?b:v}createLanguageStatusItem(R,k,_){const T=this._handlePool++,w=this._proxy,b=this._ids,v=`${R.identifier.value}/${k}`;if(b.has(v))throw new Error(`LanguageStatusItem with id '${k}' ALREADY exists`);b.add(v);const h={selector:_,id:k,name:R.displayName??R.name,severity:D.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let g;const p=new C.DisposableStore,o=()=>{g?.dispose(),g=(0,y.disposableTimeout)(()=>{p.clear(),this._proxy.$setLanguageStatus(T,{id:v,name:h.name??R.displayName??R.name,source:R.displayName??R.name,selector:t.DocumentSelector.from(h.selector,this._uriTransformer),label:h.text,detail:h.detail??"",severity:h.severity===D.LanguageStatusSeverity.Error?P.default.Error:h.severity===D.LanguageStatusSeverity.Warning?P.default.Warning:P.default.Info,command:h.command&&this._commands.toInternal(h.command,p),accessibilityInfo:h.accessibilityInformation,busy:h.busy})},0)},m={dispose(){p.dispose(),g?.dispose(),w.$removeLanguageStatus(T),b.delete(v)},get id(){return h.id},get name(){return h.name},set name(c){h.name=c,o()},get selector(){return h.selector},set selector(c){h.selector=c,o()},get text(){return h.text},set text(c){h.text=c,o()},get detail(){return h.detail},set detail(c){h.detail=c,o()},get severity(){return h.severity},set severity(c){h.severity=c,o()},get accessibilityInformation(){return h.accessibilityInformation},set accessibilityInformation(c){h.accessibilityInformation=c,o()},get command(){return h.command},set command(c){h.command=c,o()},get busy(){return h.busy},set busy(c){h.busy=c,o()}};return o(),m}}e.ExtHostLanguages=E}),define(De[135],Ie([1,0,14,5,26,15,4]),function(Z,e,u,t,D,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let C=class extends u.AbstractLoggerService{constructor(R,k){const _=new y.Emitter;super(k.logLevel,_.event);this._proxy=R.getProxy(t.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(_)}$setLevel(R){this._onDidChangeLogLevel.fire(R)}doCreateLogger(R,k,_){return new E(this._proxy,R,k,_)}};C=je([xe(0,P.IExtHostRpcService),xe(1,D.IExtHostInitDataService)],C),e.ExtHostLoggerService=C;class E extends u.AbstractMessageLogger{constructor(R,k,_,T){super(T?.always);this.proxy=R,this.file=k,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(_),this.proxy.$createLogger(k,T).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(R,k){const _=[[R,k]];this.isLoggerCreated?this.doLog(_):this.buffer.push(..._)}doLog(R){this.proxy.$log(this.file,R)}}}),define(De[251],Ie([1,0,5,14,27]),function(Z,e,u,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function P(C){return C&&C.title}let y=class{constructor(E,I){this._logService=I,this._proxy=E.getProxy(u.MainContext.MainThreadMessageService)}showMessage(E,I,R,k,_){const T={source:{identifier:E.identifier,label:E.displayName||E.name}};let w;typeof k=="string"||P(k)?w=[k,..._]:(T.modal=k?.modal,T.useCustom=k?.useCustom,T.detail=k?.detail,w=_),T.useCustom&&(0,D.checkProposedApiEnabled)(E,"resolvers");const b=[];for(let v=0;v<w.length;v++){const h=w[v];if(typeof h=="string")b.push({title:h,handle:v,isCloseAffordance:!1});else if(typeof h=="object"){const{title:g,isCloseAffordance:p}=h;b.push({title:g,isCloseAffordance:!!p,handle:v})}else this._logService.warn("Invalid message item:",h)}return this._proxy.$showMessage(I,R,T,b).then(v=>{if(typeof v=="number")return w[v]})}};y=je([xe(1,t.ILogService)],y),e.ExtHostMessageService=y}),define(De[252],Ie([1,0,23,4,60,6,25,8,13,2,87,5,37,16,7,54,222,130]),function(Z,e,u,t,D,P,y,C,E,I,R,k,_,T,w,b,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class g{constructor(o,m,c,l,s){this._textDocumentsAndEditors=c,this._textDocuments=l,this._extensionStoragePaths=s,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new y.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new t.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new t.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new t.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new t.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new R.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=o.getProxy(k.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=o.getProxy(k.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=o.getProxy(k.MainContext.MainThreadNotebookEditors),this._commandsConverter=m.converter,m.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===12){const r=i.notebookEditor?.notebookUri,n=i.cell.handle,d=this._documents.get(r)?.getCell(n);if(d)return d.apiCell}return i}}),g._registerApiCommands(m)}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(o=>o.apiEditor)}getEditorById(o){const m=this._editors.get(o);if(!m)throw new Error(`unknown text editor: ${o}. known editors: ${[...this._editors.keys()]} `);return m}getIdByEditor(o){for(const[m,c]of this._editors)if(c.apiEditor===o)return m}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(o,m){const c=this._documents.get(o);if(!c&&!m)throw new Error(`NO notebook document for '${o}'`);return c}_getProviderData(o){const m=this._notebookContentProviders.get(o);if(!m)throw new Error(`NO provider for '${o}'`);return m}registerNotebookContentProvider(o,m,c,l,s){if((0,C.isFalsyOrWhitespace)(m))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(m))throw new Error(`Notebook provider for '${m}' already registered`);this._notebookContentProviders.set(m,{extension:o,provider:c});let i;return c.onDidChangeNotebookContentOptions&&(i=c.onDidChangeNotebookContentOptions(()=>{const r=T.NotebookDocumentContentOptions.from(c.options);this._notebookProxy.$updateNotebookProviderOptions(m,r)})),this._notebookProxy.$registerNotebookProvider({id:o.identifier,location:o.extensionLocation},m,T.NotebookDocumentContentOptions.from(l),g._convertNotebookRegistrationData(o,s)),new w.Disposable(()=>{i?.dispose(),this._notebookContentProviders.delete(m),this._notebookProxy.$unregisterNotebookProvider(m)})}static _convertNotebookRegistrationData(o,m){if(!m)return;const c=m.filenamePattern.map(l=>T.NotebookExclusiveDocumentPattern.from(l)).filter(l=>l!==void 0);if(m.filenamePattern&&!c){console.warn(`Notebook content provider view options file name pattern is invalid ${m.filenamePattern}`);return}return{extension:o.identifier,providerDisplayName:o.displayName||o.name,displayName:m.displayName,filenamePattern:c,exclusive:m.exclusive||!1}}registerNotebookCellStatusBarItemProvider(o,m,c){const l=g._notebookStatusBarItemProviderHandlePool++,s=typeof c.onDidChangeCellStatusBarItems=="function"?g._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(l,c),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(l,s,m);let i;return s!==void 0&&(i=c.onDidChangeCellStatusBarItems(r=>this._notebookProxy.$emitCellStatusBarEvent(s))),new w.Disposable(()=>{this._notebookStatusBarItemProviders.delete(l),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(l,s),i?.dispose()})}async createNotebookDocument(o){const m=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:o.viewType,content:o.content&&T.NotebookData.from(o.content)});return I.URI.revive(m)}async openNotebookDocument(o){const m=this._documents.get(o);if(m)return m.apiNotebook;const c=await this._notebookDocumentsProxy.$tryOpenNotebook(o),l=this._documents.get(I.URI.revive(c));return(0,E.assertIsDefined)(l?.apiNotebook)}async showNotebookDocument(o,m){I.URI.isUri(o)&&(o=await this.openNotebookDocument(o));let c;typeof m=="object"?c={position:T.ViewColumn.from(m.viewColumn),preserveFocus:m.preserveFocus,selections:m.selections&&m.selections.map(T.NotebookRange.from),pinned:typeof m.preview=="boolean"?!m.preview:void 0}:c={preserveFocus:!1};const l=await this._notebookEditorsProxy.$tryShowNotebookDocument(o.uri,o.notebookType,c),s=l&&this._editors.get(l)?.apiEditor;if(s)return s;throw l?new Error(`Could NOT open editor for "${o.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${o.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(o,m,c,l){const s=this._notebookStatusBarItemProviders.get(o),i=I.URI.revive(m),r=this._documents.get(i);if(!r||!s)return;const n=r.getCellFromIndex(c);if(!n)return;const a=await s.provideCellStatusBarItems(n.apiCell,l);if(!a)return;const d=new P.DisposableStore,f=this._statusBarCache.add([d]),O=(Array.isArray(a)?a:[a]).map(U=>T.NotebookStatusBarItem.from(U,this._commandsConverter,d));return{cacheId:f,items:O}}$releaseNotebookCellStatusBarItems(o){this._statusBarCache.delete(o)}registerNotebookSerializer(o,m,c,l,s){if((0,C.isFalsyOrWhitespace)(m))throw new Error("viewType cannot be empty or just whitespace");const i=this._handlePool++;return this._notebookSerializer.set(i,c),this._notebookProxy.$registerNotebookSerializer(i,{id:o.identifier,location:o.extensionLocation},m,T.NotebookDocumentContentOptions.from(l),g._convertNotebookRegistrationData(o,s)),(0,P.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(i)})}async $dataToNotebook(o,m,c){const l=this._notebookSerializer.get(o);if(!l)throw new Error("NO serializer found");const s=await l.deserializeNotebook(m.buffer,c);return new b.SerializableObjectWithBuffers(T.NotebookData.from(s))}async $notebookToData(o,m,c){const l=this._notebookSerializer.get(o);if(!l)throw new Error("NO serializer found");const s=await l.serializeNotebook(T.NotebookData.to(m.value),c);return u.VSBuffer.wrap(s)}async $openNotebook(o,m,c,l,s){const{provider:i}=this._getProviderData(o),r=await i.openNotebook(I.URI.revive(m),{backupId:c,untitledDocumentData:l?.buffer},s);return new b.SerializableObjectWithBuffers({metadata:r.metadata??Object.create(null),cells:r.cells.map(T.NotebookCellData.from)})}async $saveNotebook(o,m,c){const l=this.getNotebookDocument(I.URI.revive(m)),{provider:s}=this._getProviderData(o);return await s.saveNotebook(l.apiNotebook,c),!0}async $saveNotebookAs(o,m,c,l){const s=this.getNotebookDocument(I.URI.revive(m)),{provider:i}=this._getProviderData(o);return await i.saveNotebookAs(I.URI.revive(c),s.apiNotebook,l),!0}async $backupNotebook(o,m,c){const l=this.getNotebookDocument(I.URI.revive(m)),s=this._getProviderData(o),i=this._extensionStoragePaths.workspaceValue(s.extension)??this._extensionStoragePaths.globalValue(s.extension),r=String((0,D.hash)([l.uri.toString(),this._backupIdPool++])),n=I.URI.joinPath(i,r),a=await s.provider.backupNotebook(l.apiNotebook,{destination:n},c);return l.updateBackup(a),a.id}_createExtHostEditor(o,m,c){if(this._editors.has(m))throw new Error(`editor with id ALREADY EXSIST: ${m}`);const l=new h.ExtHostNotebookEditor(m,this._notebookEditorsProxy,o,c.visibleRanges.map(T.NotebookRange.to),c.selections.map(T.NotebookRange.to),typeof c.viewColumn=="number"?T.ViewColumn.to(c.viewColumn):void 0);this._editors.set(m,l)}$acceptDocumentAndEditorsDelta(o){if(o.value.removedDocuments)for(const c of o.value.removedDocuments){const l=I.URI.revive(c),s=this._documents.get(l);s&&(s.dispose(),this._documents.delete(l),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:s.apiNotebook.getCells().map(i=>i.document.uri)}),this._onDidCloseNotebookDocument.fire(s.apiNotebook));for(const i of this._editors.values())i.notebookData.uri.toString()===l.toString()&&this._editors.delete(i.id)}if(o.value.addedDocuments){const c=[];for(const l of o.value.addedDocuments){const s=I.URI.revive(l.uri);if(this._documents.has(s))throw new Error(`adding EXISTING notebook ${s} `);const i=new v.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,s,l);c.push(...l.cells.map(r=>v.ExtHostCell.asModelAddData(i.apiNotebook,r))),this._documents.get(s)?.dispose(),this._documents.set(s,i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:c}),this._onDidOpenNotebookDocument.fire(i.apiNotebook)}}if(o.value.addedEditors)for(const c of o.value.addedEditors){if(this._editors.has(c.id))return;const l=I.URI.revive(c.documentUri),s=this._documents.get(l);s&&this._createExtHostEditor(s,c.id,c)}const m=[];if(o.value.removedEditors)for(const c of o.value.removedEditors){const l=this._editors.get(c);l&&(this._editors.delete(c),this._activeNotebookEditor?.id===l.id&&(this._activeNotebookEditor=void 0),m.push(l))}if(o.value.visibleEditors){this._visibleNotebookEditors=o.value.visibleEditors.map(l=>this._editors.get(l)).filter(l=>!!l);const c=new Set;this._visibleNotebookEditors.forEach(l=>c.add(l.id));for(const l of this._editors.values()){const s=c.has(l.id);l._acceptVisibility(s)}this._visibleNotebookEditors=[...this._editors.values()].map(l=>l).filter(l=>l.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}o.value.newActiveEditor===null?this._activeNotebookEditor=void 0:o.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(o.value.newActiveEditor)),o.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(o){const m=_.ApiCommandArgument.String.with("notebookType","A notebook type"),c=new _.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[m,new _.ApiCommandArgument("data","Bytes to convert to data",s=>s instanceof Uint8Array,s=>u.VSBuffer.wrap(s))],new _.ApiCommandResult("Notebook Data",s=>T.NotebookData.to(s.value))),l=new _.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[m,new _.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",s=>!0,s=>new b.SerializableObjectWithBuffers(T.NotebookData.from(s)))],new _.ApiCommandResult("Bytes",s=>s.buffer));o.registerApiCommand(c),o.registerApiCommand(l)}}e.ExtHostNotebookController=g,g._notebookStatusBarItemProviderHandlePool=0}),define(De[253],Ie([1,0,17,18,21,4,6,25,2,28,14,5,37,16,7,88,216,27,54]),function(Z,e,u,t,D,P,y,C,E,I,R,k,_,T,w,b,v,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let p=class{constructor(i,r,n,a,d){this._initData=r,this._extHostNotebook=n,this._commands=a,this._logService=d,this._activeExecutions=new C.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new P.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=i.getProxy(k.MainContext.MainThreadNotebookKernels);const f=new _.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new _.ApiCommandArgument("options","Select kernel options",S=>!0,S=>{if(S&&"notebookEditor"in S&&"id"in S){const O=this._extHostNotebook.getIdByEditor(S.notebookEditor);return{id:S.id,extension:S.extension,notebookEditorId:O}}else if(S&&"notebookEditor"in S){const O=this._extHostNotebook.getIdByEditor(S.notebookEditor);if(O===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${S.notebookEditor.document.uri.toString()}`);return{notebookEditorId:O}}return S})],_.ApiCommandResult.Void);this._commands.registerApiCommand(f)}createNotebookController(i,r,n,a,d,f){for(const J of this._kernelData.values())if(J.controller.id===r&&I.ExtensionIdentifier.equals(i.identifier,J.extensionId))throw new Error(`notebook controller with id '${r}' ALREADY exist`);const S=this._handlePool++,O=this;this._logService.trace(`NotebookController[${S}], CREATED by ${i.identifier.value}, ${r}`);const U=()=>console.warn(`NO execute handler from notebook controller '${N.id}' of extension: '${i.identifier}'`);let M=!1;const A=new y.DisposableStore,B=new P.Emitter,x=new P.Emitter,N={id:l(i.identifier,r),notebookType:n,extensionId:i.identifier,extensionLocation:i.extensionLocation,label:a||i.identifier.value,preloads:f?f.map(T.NotebookRendererScript.from):[]};let K=d??U,X;this._proxy.$addKernel(S,N).catch(J=>{console.log(J),M=!0});let L=0;const $=()=>{if(M)return;const J=++L;Promise.resolve().then(()=>{J===L&&this._proxy.$updateKernel(S,N)})},H=new C.ResourceMap,j={get id(){return r},get notebookType(){return N.notebookType},onDidChangeSelectedNotebooks:B.event,get label(){return N.label},set label(J){N.label=J??i.displayName??i.name,$()},get detail(){return N.detail??""},set detail(J){N.detail=J,$()},get description(){return N.description??""},set description(J){N.description=J,$()},get kind(){return(0,h.checkProposedApiEnabled)(i,"notebookControllerKind"),N.kind??""},set kind(J){(0,h.checkProposedApiEnabled)(i,"notebookControllerKind"),N.kind=J,$()},get supportedLanguages(){return N.supportedLanguages},set supportedLanguages(J){N.supportedLanguages=J,$()},get supportsExecutionOrder(){return N.supportsExecutionOrder??!1},set supportsExecutionOrder(J){N.supportsExecutionOrder=J,$()},get rendererScripts(){return N.preloads?N.preloads.map(T.NotebookRendererScript.to):[]},get executeHandler(){return K},set executeHandler(J){K=J??U},get interruptHandler(){return X},set interruptHandler(J){X=J,N.supportsInterrupt=Boolean(J),$()},createNotebookCellExecution(J){if(M)throw new Error("notebook controller is DISPOSED");if(!H.has(J.notebook.uri))throw O._logService.trace(`NotebookController[${S}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(H.keys()).map(Y=>Y.toString())),new Error(`notebook controller is NOT associated to notebook: ${J.notebook.uri.toString()}`);return O._createNotebookCellExecution(J,l(i.identifier,this.id))},dispose:()=>{M||(this._logService.trace(`NotebookController[${S}], DISPOSED`),M=!0,this._kernelData.delete(S),A.dispose(),B.dispose(),x.dispose(),this._proxy.$removeKernel(S))},updateNotebookAffinity(J,Y){O._proxy.$updateNotebookPriority(S,J.uri,Y)},onDidReceiveMessage:x.event,postMessage(J,Y){return(0,h.checkProposedApiEnabled)(i,"notebookMessaging"),O._proxy.$postMessage(S,Y&&O._extHostNotebook.getIdByEditor(Y),J)},asWebviewUri(J){return(0,h.checkProposedApiEnabled)(i,"notebookMessaging"),(0,b.asWebviewUri)(J,O._initData.remote)}};return this._kernelData.set(S,{extensionId:i.identifier,controller:j,onDidReceiveMessage:x,onDidChangeSelection:B,associatedNotebooks:H}),j}getIdByController(i){for(const[r,n]of this._kernelData)if(n.controller===i)return l(n.extensionId,i.id);return null}$acceptNotebookAssociation(i,r,n){const a=this._kernelData.get(i);if(a){const d=this._extHostNotebook.getNotebookDocument(E.URI.revive(r));n?a.associatedNotebooks.set(d.uri,!0):a.associatedNotebooks.delete(d.uri),this._logService.trace(`NotebookController[${i}] ASSOCIATE notebook`,d.uri.toString(),n),a.onDidChangeSelection.fire({selected:n,notebook:d.apiNotebook})}}async $executeCells(i,r,n){const a=this._kernelData.get(i);if(!a)return;const d=this._extHostNotebook.getNotebookDocument(E.URI.revive(r)),f=[];for(const S of n){const O=d.getCell(S);O&&f.push(O.apiCell)}try{this._logService.trace(`NotebookController[${i}] EXECUTE cells`,d.uri.toString(),f.length),await a.controller.executeHandler.call(a.controller,f,d.apiNotebook,a.controller)}catch(S){this._logService.error(`NotebookController[${i}] execute cells FAILED`,S),console.error(S)}}async $cancelCells(i,r,n){const a=this._kernelData.get(i);if(!a)return;const d=this._extHostNotebook.getNotebookDocument(E.URI.revive(r));if(a.controller.interruptHandler)await a.controller.interruptHandler.call(a.controller,d.apiNotebook);else for(const f of n){const S=d.getCell(f);S&&this._activeExecutions.get(S.uri)?.cancel()}}$acceptKernelMessageFromRenderer(i,r,n){const a=this._kernelData.get(i);if(!a)return;const d=this._extHostNotebook.getEditorById(r);a.onDidReceiveMessage.fire(Object.freeze({editor:d.apiEditor,message:n}))}$cellExecutionChanged(i,r,n){const d=this._extHostNotebook.getNotebookDocument(E.URI.revive(i)).getCell(r);if(d){const f=n?T.NotebookCellExecutionState.to(n):w.NotebookCellExecutionState.Idle;f!==void 0&&this._onDidChangeCellExecutionState.fire({cell:d.apiCell,state:f})}}_createNotebookCellExecution(i,r){if(i.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const a=this._extHostNotebook.getNotebookDocument(i.notebook.uri).getCellFromApiCell(i);if(!a)throw new Error("invalid cell");if(this._activeExecutions.has(a.uri))throw new Error(`duplicate execution for ${a.uri}`);const d=new m(r,a,this._proxy);this._activeExecutions.set(a.uri,d);const f=d.onDidChangeState(()=>{d.state===o.Resolved&&(d.dispose(),f.dispose(),this._activeExecutions.delete(a.uri))});return d.asApiObject()}};p=je([xe(4,R.ILogService)],p),e.ExtHostNotebookKernels=p;var o;(function(s){s[s.Init=0]="Init",s[s.Started=1]="Started",s[s.Resolved=2]="Resolved"})(o||(o={}));class m extends y.Disposable{constructor(i,r,n){super();this._cell=r,this._proxy=n,this._handle=m.HANDLE++,this._onDidChangeState=new P.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=o.Init,this._tokenSource=this._register(new D.CancellationTokenSource),this._collector=new c(10,a=>this.update(a)),this._executionOrder=r.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,i,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(i){await this._collector.addItem(i)}async update(i){const r=Array.isArray(i)?i:[i];return this._proxy.$updateExecution(this._handle,new g.SerializableObjectWithBuffers(r))}verifyStateForOutput(){if(this._state===o.Init)throw new Error("Must call start before modifying cell output");if(this._state===o.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(i){let r=this._cell;if(i&&(r=this._cell.notebook.getCellFromApiCell(i)),!r)throw new Error("INVALID cell");return r.handle}validateAndConvertOutputs(i){return i.map(r=>{const n=w.NotebookCellOutput.ensureUniqueMimeTypes(r.items,!0);return n===r.items?T.NotebookCellOutput.from(r):T.NotebookCellOutput.from({items:n,id:r.id,metadata:r.metadata})})}async updateOutputs(i,r,n){const a=this.cellIndexToHandle(r),d=this.validateAndConvertOutputs((0,u.asArray)(i));return this.updateSoon({editType:v.CellExecutionUpdateType.Output,cellHandle:a,append:n,outputs:d})}async updateOutputItems(i,r,n){return i=w.NotebookCellOutput.ensureUniqueMimeTypes((0,u.asArray)(i),!0),this.updateSoon({editType:v.CellExecutionUpdateType.OutputItems,items:i.map(T.NotebookCellOutputItem.from),outputId:r.id,append:n})}asApiObject(){const i=this;return Object.freeze({get token(){return i._tokenSource.token},get cell(){return i._cell.apiCell},get executionOrder(){return i._executionOrder},set executionOrder(n){i._executionOrder=n,i.update([{editType:v.CellExecutionUpdateType.ExecutionState,executionOrder:i._executionOrder}])},start(n){if(i._state===o.Resolved||i._state===o.Started)throw new Error("Cannot call start again");i._state=o.Started,i._onDidChangeState.fire(),i.update({editType:v.CellExecutionUpdateType.ExecutionState,runStartTime:n})},end(n,a){if(i._state===o.Resolved)throw new Error("Cannot call resolve twice");i._state=o.Resolved,i._onDidChangeState.fire(),i._collector.flush(),i._proxy.$completeExecution(i._handle,new g.SerializableObjectWithBuffers({runEndTime:a,lastRunSuccess:n}))},clearOutput(n){return i.verifyStateForOutput(),i.updateOutputs([],n,!1)},appendOutput(n,a){return i.verifyStateForOutput(),i.updateOutputs(n,a,!0)},replaceOutput(n,a){return i.verifyStateForOutput(),i.updateOutputs(n,a,!1)},appendOutputItems(n,a){return i.verifyStateForOutput(),i.updateOutputItems(n,a,!0)},replaceOutputItems(n,a){return i.verifyStateForOutput(),i.updateOutputItems(n,a,!1)}})}}m.HANDLE=0;class c{constructor(i,r){this.delay=i,this.callback=r,this.batch=[],this.startedTimer=Date.now()}addItem(i){return this.batch.push(i),this.currentDeferred||(this.currentDeferred=new t.DeferredPromise,this.startedTimer=Date.now(),(0,t.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const i=this.currentDeferred;this.currentDeferred=void 0;const r=this.batch;return this.batch=[],this.callback(r).finally(()=>i.complete())}}function l(s,i){return`${s.value}/${i}`}e.createKernelId=l}),define(De[254],Ie([1,0,4,5,130]),function(Z,e,u,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class P{constructor(C,E){this._extHostNotebook=E,this._rendererMessageEmitters=new Map,this.proxy=C.getProxy(t.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(C,E,I){const R=this._extHostNotebook.getEditorById(C);this._rendererMessageEmitters.get(E)?.fire({editor:R.apiEditor,message:I})}createRendererMessaging(C,E){if(!C.contributes?.notebookRenderer?.some(R=>R.id===E))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${E})`);return{onDidReceiveMessage:(R,k,_)=>this.getOrCreateEmitterFor(E).event(R,k,_),postMessage:(R,k)=>{D.ExtHostNotebookEditor.apiEditorsToExtHost.has(R)&&([R,k]=[k,R]);const _=k&&D.ExtHostNotebookEditor.apiEditorsToExtHost.get(k);return this.proxy.$postMessage(_?.id,E,R)}}}getOrCreateEmitterFor(C){let E=this._rendererMessageEmitters.get(C);return E||(E=new u.Emitter({onLastListenerRemove:()=>{E?.dispose(),this._rendererMessageEmitters.delete(C)}}),this._rendererMessageEmitters.set(C,E),E)}}e.ExtHostNotebookRenderers=P}),define(De[255],Ie([1,0,21,4,6,5,2,7,10,17,41,86]),function(Z,e,u,t,D,P,y,C,E,I,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function _(T,w,b){const v=T.getProxy(P.MainContext.MainThreadQuickOpen);class h{constructor(r,n){this._sessions=new Map,this._instances=0,this._workspace=r,this._commands=n}showQuickPick(r,n,a=u.CancellationToken.None){this._onDidSelectItem=void 0;const d=Promise.resolve(r),f=++this._instances,S=v.$show(f,{title:n?.title,placeHolder:n?.placeHolder,matchOnDescription:n?.matchOnDescription,matchOnDetail:n?.matchOnDetail,ignoreFocusLost:n?.ignoreFocusOut,canPickMany:n?.canPickMany},a),O={},U=S.then(()=>O);return Promise.race([U,d]).then(M=>{if(M!==O)return d.then(A=>{const B=[];for(let x=0;x<A.length;x++){const N=A[x];typeof N=="string"?B.push({label:N,handle:x}):N.kind===C.QuickPickItemKind.Separator?B.push({type:"separator",label:N.label}):B.push({label:N.label,description:N.description,detail:N.detail,picked:N.picked,alwaysShow:N.alwaysShow,handle:x})}return n&&typeof n.onDidSelectItem=="function"&&(this._onDidSelectItem=x=>{n.onDidSelectItem(A[x])}),v.$setItems(f,B),S.then(x=>{if(typeof x=="number")return A[x];if(Array.isArray(x))return x.map(N=>A[N])})})}).then(void 0,M=>{if(!(0,E.isCancellationError)(M))return v.$setError(f,M),Promise.reject(M)})}$onItemSelected(r){this._onDidSelectItem?.(r)}showInput(r,n=u.CancellationToken.None){return this._validateInput=r?.validateInput,v.$input(r,typeof this._validateInput=="function",n).then(void 0,a=>{if(!(0,E.isCancellationError)(a))return Promise.reject(a)})}async $validateInput(r){if(!this._validateInput)return;const n=await this._validateInput(r);if(!n||typeof n=="string")return n;let a;switch(n.severity){case C.InputBoxValidationSeverity.Info:a=R.default.Info;break;case C.InputBoxValidationSeverity.Warning:a=R.default.Warning;break;case C.InputBoxValidationSeverity.Error:a=R.default.Error;break;default:a=n.message?R.default.Error:R.default.Ignore;break}return{content:n.message,severity:a}}async showWorkspaceFolderPick(r,n=u.CancellationToken.None){const a=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[r]);if(!a)return;const d=await this._workspace.getWorkspaceFolders2();if(!!d)return d.find(f=>f.uri.toString()===a.uri.toString())}createQuickPick(r){const n=new l(r,()=>this._sessions.delete(n._id));return this._sessions.set(n._id,n),n}createInputBox(r){const n=new s(r,()=>this._sessions.delete(n._id));return this._sessions.set(n._id,n),n}$onDidChangeValue(r,n){this._sessions.get(r)?._fireDidChangeValue(n)}$onDidAccept(r){this._sessions.get(r)?._fireDidAccept()}$onDidChangeActive(r,n){const a=this._sessions.get(r);a instanceof l&&a._fireDidChangeActive(n)}$onDidChangeSelection(r,n){const a=this._sessions.get(r);a instanceof l&&a._fireDidChangeSelection(n)}$onDidTriggerButton(r,n){this._sessions.get(r)?._fireDidTriggerButton(n)}$onDidTriggerItemButton(r,n,a){const d=this._sessions.get(r);d instanceof l&&d._fireDidTriggerItemButton(n,a)}$onDidHide(r){this._sessions.get(r)?._fireDidHide()}}class g{constructor(r,n){this._extensionId=r,this._onDidDispose=n,this._id=l._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new t.Emitter,this._onDidChangeValueEmitter=new t.Emitter,this._onDidTriggerButtonEmitter=new t.Emitter,this._onDidHideEmitter=new t.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(r){this._title=r,this.update({title:r})}get step(){return this._steps}set step(r){this._steps=r,this.update({step:r})}get totalSteps(){return this._totalSteps}set totalSteps(r){this._totalSteps=r,this.update({totalSteps:r})}get enabled(){return this._enabled}set enabled(r){this._enabled=r,this.update({enabled:r})}get busy(){return this._busy}set busy(r){this._busy=r,this.update({busy:r})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(r){this._ignoreFocusOut=r,this.update({ignoreFocusOut:r})}get value(){return this._value}set value(r){this._value=r,this.update({value:r})}get placeholder(){return this._placeholder}set placeholder(r){this._placeholder=r,this.update({placeholder:r})}get buttons(){return this._buttons}set buttons(r){this._buttons=r.slice(),this._handlesToButtons.clear(),r.forEach((n,a)=>{const d=n===C.QuickInputButtons.Back?-1:a;this._handlesToButtons.set(d,n)}),this.update({buttons:r.map((n,a)=>({...c(n),tooltip:n.tooltip,handle:n===C.QuickInputButtons.Back?-1:a}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(r){this._value=r,this._onDidChangeValueEmitter.fire(r)}_fireDidTriggerButton(r){const n=this._handlesToButtons.get(r);n&&this._onDidTriggerButtonEmitter.fire(n)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,D.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),v.$dispose(this._id))}update(r){if(!this._disposed){for(const n of Object.keys(r)){const a=r[n];this._pendingUpdate[n]=a===void 0?null:a}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){v.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}g._nextId=1;function p(i){if(i instanceof C.ThemeIcon)return{id:i.id};const r=m(i),n=o(i);return{dark:typeof r=="string"?y.URI.file(r):r,light:typeof n=="string"?y.URI.file(n):n}}function o(i){return typeof i=="object"&&"light"in i?i.light:i}function m(i){return typeof i=="object"&&"dark"in i?i.dark:i}function c(i){const r=p(i.iconPath);let n,a;return"id"in r?a=k.ThemeIcon.asClassName(r):n=r,{iconPath:n,iconClass:a}}class l extends g{constructor(r,n){super(r.identifier,n);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new t.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new t.Emitter,this._onDidTriggerItemButtonEmitter=new t.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(r){this._items=r.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),r.forEach((a,d)=>{this._handlesToItems.set(d,a),this._itemsToHandles.set(a,d)});const n=[];for(let a=0;a<r.length;a++){const d=r[a];d.kind===C.QuickPickItemKind.Separator?n.push({type:"separator",label:d.label}):n.push({handle:a,label:d.label,description:d.description,detail:d.detail,picked:d.picked,alwaysShow:d.alwaysShow,buttons:d.buttons?.map((f,S)=>({...c(f),tooltip:f.tooltip,handle:S}))})}this.update({items:n})}get canSelectMany(){return this._canSelectMany}set canSelectMany(r){this._canSelectMany=r,this.update({canSelectMany:r})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(r){this._matchOnDescription=r,this.update({matchOnDescription:r})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(r){this._matchOnDetail=r,this.update({matchOnDetail:r})}get sortByLabel(){return this._sortByLabel}set sortByLabel(r){this._sortByLabel=r,this.update({sortByLabel:r})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(r){this._keepScrollPosition=r,this.update({keepScrollPosition:r})}get activeItems(){return this._activeItems}set activeItems(r){this._activeItems=r.filter(n=>this._itemsToHandles.has(n)),this.update({activeItems:this._activeItems.map(n=>this._itemsToHandles.get(n))})}get selectedItems(){return this._selectedItems}set selectedItems(r){this._selectedItems=r.filter(n=>this._itemsToHandles.has(n)),this.update({selectedItems:this._selectedItems.map(n=>this._itemsToHandles.get(n))})}_fireDidChangeActive(r){const n=(0,I.coalesce)(r.map(a=>this._handlesToItems.get(a)));this._activeItems=n,this._onDidChangeActiveEmitter.fire(n)}_fireDidChangeSelection(r){const n=(0,I.coalesce)(r.map(a=>this._handlesToItems.get(a)));this._selectedItems=n,this._onDidChangeSelectionEmitter.fire(n)}_fireDidTriggerItemButton(r,n){const a=this._handlesToItems.get(r);if(!a||!a.buttons||!a.buttons.length)return;const d=a.buttons[n];d&&this._onDidTriggerItemButtonEmitter.fire({button:d,item:a})}}class s extends g{constructor(r,n){super(r.identifier,n);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(r){this._password=r,this.update({password:r})}get prompt(){return this._prompt}set prompt(r){this._prompt=r,this.update({prompt:r})}get validationMessage(){return this._validationMessage}set validationMessage(r){this._validationMessage=r,r?typeof r=="string"?this.update({validationMessage:r,severity:R.default.Error}):this.update({validationMessage:r.message,severity:r.severity??R.default.Error}):this.update({validationMessage:void 0,severity:R.default.Ignore})}}return new h(w,b)}e.createExtHostQuickOpen=_});var et=this&&this.__classPrivateFieldSet||function(Z,e,u,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!D:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(Z,u):D?D.value=u:e.set(Z,u),u},Me=this&&this.__classPrivateFieldGet||function(Z,e,u,t){if(u==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?t:u==="a"?t.call(Z):t?t.value:e.get(Z)};define(De[256],Ie([1,0,2,4,57,6,18,5,17,103,14,28,86,16,27]),function(Z,e,u,t,D,P,y,C,E,I,R,k,_,T,w){"use strict";var b,v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function h(d){if(d)return typeof d.iconPath=="string"?u.URI.file(d.iconPath):u.URI.isUri(d.iconPath)||_.ThemeIcon.isThemeIcon(d.iconPath)?d.iconPath:void 0}function g(d,f){if(!d.iconPath&&!f.iconPath)return 0;if(d.iconPath){if(!f.iconPath)return 1}else return-1;const S=typeof d.iconPath=="string"?d.iconPath:u.URI.isUri(d.iconPath)?d.iconPath.fsPath:d.iconPath.id,O=typeof f.iconPath=="string"?f.iconPath:u.URI.isUri(f.iconPath)?f.iconPath.fsPath:f.iconPath.id;return(0,I.comparePaths)(S,O)}function p(d,f){let S=0;if(d.strikeThrough!==f.strikeThrough)return d.strikeThrough?1:-1;if(d.faded!==f.faded)return d.faded?1:-1;if(d.tooltip!==f.tooltip)return(d.tooltip||"").localeCompare(f.tooltip||"");if(S=g(d,f),S!==0)return S;if(d.light&&f.light)S=g(d.light,f.light);else{if(d.light)return 1;if(f.light)return-1}if(S!==0)return S;if(d.dark&&f.dark)S=g(d.dark,f.dark);else{if(d.dark)return 1;if(f.dark)return-1}return S}function o(d,f){if(d.command!==f.command)return d.command<f.command?-1:1;if(d.title!==f.title)return d.title<f.title?-1:1;if(d.tooltip!==f.tooltip){if(d.tooltip!==void 0&&f.tooltip!==void 0)return d.tooltip<f.tooltip?-1:1;if(d.tooltip!==void 0)return 1;if(f.tooltip!==void 0)return-1}if(d.arguments===f.arguments)return 0;if(d.arguments)if(f.arguments){if(d.arguments.length!==f.arguments.length)return d.arguments.length-f.arguments.length}else return 1;else return-1;for(let S=0;S<d.arguments.length;S++){const O=d.arguments[S],U=f.arguments[S];if(O!==U)return O<U?-1:1}return 0}function m(d,f){let S=(0,I.comparePaths)(d.resourceUri.fsPath,f.resourceUri.fsPath,!0);if(S!==0)return S;if(d.command&&f.command)S=o(d.command,f.command);else{if(d.command)return 1;if(f.command)return-1}if(S!==0)return S;if(d.decorations&&f.decorations)S=p(d.decorations,f.decorations);else{if(d.decorations)return 1;if(f.decorations)return-1}return S}function c(d,f){for(let S=0;S<d.length;S++)if(d[S]!==f[S])return!1;return!0}function l(d,f){return d.command===f.command&&d.title===f.title&&d.tooltip===f.tooltip&&(d.arguments&&f.arguments?c(d.arguments,f.arguments):d.arguments===f.arguments)}function s(d,f){return(0,E.equals)(d,f,l)}class i{constructor(f,S,O){this._extension=f,this._sourceControlHandle=O,b.set(this,void 0),this._value="",this._onDidChange=new t.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,et(this,b,S,"f")}get value(){return this._value}set value(f){f=f??"",Me(this,b,"f").$setInputBoxValue(this._sourceControlHandle,f),this.updateValue(f)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(f){Me(this,b,"f").$setInputBoxPlaceholder(this._sourceControlHandle,f),this._placeholder=f}get validateInput(){return(0,w.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(f){if((0,w.checkProposedApiEnabled)(this._extension,"scmValidation"),f&&typeof f!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=f,Me(this,b,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!f)}get enabled(){return this._enabled}set enabled(f){f=!!f,this._enabled!==f&&(this._enabled=f,Me(this,b,"f").$setInputBoxEnablement(this._sourceControlHandle,f))}get visible(){return this._visible}set visible(f){f=!!f,this._visible!==f&&(this._visible=f,Me(this,b,"f").$setInputBoxVisibility(this._sourceControlHandle,f))}showValidationMessage(f,S){(0,w.checkProposedApiEnabled)(this._extension,"scmValidation"),Me(this,b,"f").$showValidationMessage(this._sourceControlHandle,f,S)}$onInputBoxValueChange(f){this.updateValue(f)}updateValue(f){this._value=f,this._onDidChange.fire(f)}}e.ExtHostSCMInputBox=i,b=new WeakMap;class r{constructor(f,S,O,U,M){this._proxy=f,this._commands=S,this._sourceControlHandle=O,this._id=U,this._label=M,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new t.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=r._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(f){this._label=f,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,f)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(f){this._hideWhenEmpty=f,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(f){this._resourceStates=[...f],this._onDidUpdateResourceStates.fire()}getResourceState(f){return this._resourceStatesMap.get(f)}$executeResourceCommand(f,S){const O=this._resourceStatesCommandsMap.get(f);return O?(0,y.asPromise)(()=>this._commands.executeCommand(O.command,...O.arguments||[],S)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const f=[...this._resourceStates].sort(m),O=(0,E.sortedDiff)(this._resourceSnapshot,f,m).map(A=>{const B=A.toInsert.map(x=>{const N=this._resourceHandlePool++;this._resourceStatesMap.set(N,x);const K=x.resourceUri;let X;if(x.command)if(x.command.command==="vscode.open"||x.command.command==="vscode.diff"){const pe=new P.DisposableStore;X=this._commands.converter.toInternal(x.command,pe),this._resourceStatesDisposablesMap.set(N,pe)}else this._resourceStatesCommandsMap.set(N,x.command);const L=h(x.decorations),$=x.decorations&&h(x.decorations.light)||L,H=x.decorations&&h(x.decorations.dark)||L,j=[$,H],J=x.decorations&&x.decorations.tooltip||"",Y=x.decorations&&!!x.decorations.strikeThrough,he=x.decorations&&!!x.decorations.faded,ve=x.contextValue||"";return{rawResource:[N,K,j,J,Y,he,ve,X],handle:N}});return{start:A.start,deleteCount:A.deleteCount,toInsert:B}}),U=O.map(({start:A,deleteCount:B,toInsert:x})=>[A,B,x.map(N=>N.rawResource)]),M=O.reverse();for(const{start:A,deleteCount:B,toInsert:x}of M){const N=x.map(X=>X.handle),K=this._handlesSnapshot.splice(A,B,...N);for(const X of K)this._resourceStatesMap.delete(X),this._resourceStatesCommandsMap.delete(X),this._resourceStatesDisposablesMap.get(X)?.dispose(),this._resourceStatesDisposablesMap.delete(X)}return this._resourceSnapshot=f,U}dispose(){this._disposed=!0,this._onDidDispose.fire()}}r._handlePool=0;class n{constructor(f,S,O,U,M,A){this._extension=f,this._commands=O,this._id=U,this._label=M,this._rootUri=A,v.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new P.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new P.MutableDisposable,this._statusBarDisposables=new P.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new t.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=n._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,et(this,v,S,"f"),this._inputBox=new i(f,Me(this,v,"f"),this.handle),Me(this,v,"f").$registerSourceControl(this.handle,U,M,A)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(f){this._count!==f&&(this._count=f,Me(this,v,"f").$updateSourceControl(this.handle,{count:f}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(f){this._quickDiffProvider=f,Me(this,v,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!f})}get commitTemplate(){return this._commitTemplate}set commitTemplate(f){f!==this._commitTemplate&&(this._commitTemplate=f,Me(this,v,"f").$updateSourceControl(this.handle,{commitTemplate:f}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(f){this._acceptInputDisposables.value=new P.DisposableStore,this._acceptInputCommand=f;const S=this._commands.converter.toInternal(f,this._acceptInputDisposables.value);Me(this,v,"f").$updateSourceControl(this.handle,{acceptInputCommand:S})}get actionButton(){return(0,w.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(f){(0,w.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new P.DisposableStore,this._actionButton=f;const S=f!==void 0?{command:this._commands.converter.toInternal(f.command,this._actionButtonDisposables.value),secondaryCommands:f.secondaryCommands?.map(O=>O.map(U=>this._commands.converter.toInternal(U,this._actionButtonDisposables.value))),description:f.description,enabled:f.enabled}:void 0;Me(this,v,"f").$updateSourceControl(this.handle,{actionButton:S??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(f){if(this._statusBarCommands&&f&&s(this._statusBarCommands,f))return;this._statusBarDisposables.value=new P.DisposableStore,this._statusBarCommands=f;const S=(f||[]).map(O=>this._commands.converter.toInternal(O,this._statusBarDisposables.value));Me(this,v,"f").$updateSourceControl(this.handle,{statusBarCommands:S})}get selected(){return this._selected}createResourceGroup(f,S){const O=new r(Me(this,v,"f"),this._commands,this.handle,f,S),U=t.Event.once(O.onDidDispose)(()=>this.createdResourceGroups.delete(O));return this.createdResourceGroups.set(O,U),this.eventuallyAddResourceGroups(),O}eventuallyAddResourceGroups(){const f=[],S=[];for(const[O,U]of this.createdResourceGroups){U.dispose();const M=O.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(O),this.eventuallyUpdateResourceStates()});t.Event.once(O.onDidDispose)(()=>{this.updatedResourceGroups.delete(O),M.dispose(),this._groups.delete(O.handle),Me(this,v,"f").$unregisterGroup(this.handle,O.handle)}),f.push([O.handle,O.id,O.label,O.features]);const A=O._takeResourceStateSnapshot();A.length>0&&S.push([O.handle,A]),this._groups.set(O.handle,O)}Me(this,v,"f").$registerGroups(this.handle,f,S),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const f=[];this.updatedResourceGroups.forEach(S=>{const O=S._takeResourceStateSnapshot();O.length!==0&&f.push([S.handle,O])}),f.length>0&&Me(this,v,"f").$spliceResourceStates(this.handle,f),this.updatedResourceGroups.clear()}getResourceGroup(f){return this._groups.get(f)}setSelectionState(f){this._selected=f,this._onDidChangeSelection.fire(f)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(f=>f.dispose()),Me(this,v,"f").$unregisterSourceControl(this.handle)}}v=new WeakMap,n._handlePool=0,je([(0,D.debounce)(100)],n.prototype,"eventuallyAddResourceGroups",null),je([(0,D.debounce)(100)],n.prototype,"eventuallyUpdateResourceStates",null);let a=class Jn{constructor(f,S,O){this._commands=S,this.logService=O,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new t.Emitter,this._proxy=f.getProxy(C.MainContext.MainThreadSCM),this._telemetry=f.getProxy(C.MainContext.MainThreadTelemetry),S.registerArgumentProcessor({processArgument:U=>{if(U&&U.$mid===3){const M=this._sourceControls.get(U.sourceControlHandle);if(!M)return U;const A=M.getResourceGroup(U.groupHandle);return A?A.getResourceState(U.handle):U}else if(U&&U.$mid===4){const M=this._sourceControls.get(U.sourceControlHandle);return M?M.getResourceGroup(U.groupHandle):U}else if(U&&U.$mid===5){const M=this._sourceControls.get(U.handle);return M||U}return U}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(f,S,O,U){this.logService.trace("ExtHostSCM#createSourceControl",f.identifier.value,S,O,U),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:f.identifier.value});const M=Jn._handlePool++,A=new n(f,this._proxy,this._commands,S,O,U);this._sourceControls.set(M,A);const B=this._sourceControlsByExtension.get(k.ExtensionIdentifier.toKey(f.identifier))||[];return B.push(A),this._sourceControlsByExtension.set(k.ExtensionIdentifier.toKey(f.identifier),B),A}getLastInputBox(f){this.logService.trace("ExtHostSCM#getLastInputBox",f.identifier.value);const S=this._sourceControlsByExtension.get(k.ExtensionIdentifier.toKey(f.identifier)),O=S&&S[S.length-1];return O&&O.inputBox}$provideOriginalResource(f,S,O){const U=u.URI.revive(S);this.logService.trace("ExtHostSCM#$provideOriginalResource",f,U.toString());const M=this._sourceControls.get(f);return!M||!M.quickDiffProvider||!M.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,y.asPromise)(()=>M.quickDiffProvider.provideOriginalResource(U,O)).then(A=>A||null)}$onInputBoxValueChange(f,S){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",f);const O=this._sourceControls.get(f);return O&&O.inputBox.$onInputBoxValueChange(S),Promise.resolve(void 0)}$executeResourceCommand(f,S,O,U){this.logService.trace("ExtHostSCM#$executeResourceCommand",f,S,O);const M=this._sourceControls.get(f);if(!M)return Promise.resolve(void 0);const A=M.getResourceGroup(S);return A?A.$executeResourceCommand(O,U):Promise.resolve(void 0)}$validateInput(f,S,O){this.logService.trace("ExtHostSCM#$validateInput",f);const U=this._sourceControls.get(f);return!U||!U.inputBox.validateInput?Promise.resolve(void 0):(0,y.asPromise)(()=>U.inputBox.validateInput(S,O)).then(M=>{if(!M)return Promise.resolve(void 0);const A=T.MarkdownString.fromStrict(M.message);return A?Promise.resolve([A,M.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(f){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",f),f!==void 0&&this._sourceControls.get(f)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=f,Promise.resolve(void 0)}};a._handlePool=0,a=je([xe(2,R.ILogService)],a),e.ExtHostSCM=a});var et=this&&this.__classPrivateFieldSet||function(Z,e,u,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!D:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(Z,u):D?D.value=u:e.set(Z,u),u},Me=this&&this.__classPrivateFieldGet||function(Z,e,u,t){if(u==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?t:u==="a"?t.call(Z):t?t.value:e.get(Z)};define(De[257],Ie([1,0,7,5,171,6,16,13]),function(Z,e,u,t,D,P,y,C){"use strict";var E,I;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class R{constructor(w,b,v,h,g=u.StatusBarAlignment.Left,p){E.set(this,void 0),I.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new P.DisposableStore,et(this,E,w,"f"),et(this,I,b,"f"),this._entryId=R.ID_GEN++,this._extension=v,this._id=h,this._alignment=g,this._priority=this.validatePriority(p)}validatePriority(w){if(!!(0,C.isNumber)(w))return w===Number.POSITIVE_INFINITY?Number.MAX_VALUE:w===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:w}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(w){this._text=w,this.update()}set name(w){this._name=w,this.update()}set tooltip(w){this._tooltip=w,this.update()}set color(w){this._color=w,this.update()}set backgroundColor(w){w&&!R.ALLOWED_BACKGROUND_COLORS.has(w.id)&&(w=void 0),this._backgroundColor=w,this.update()}set command(w){this._command?.fromApi!==w&&(this._internalCommandRegistration.clear(),typeof w=="string"?this._command={fromApi:w,internal:Me(this,I,"f").toInternal({title:"",command:w},this._internalCommandRegistration)}:w?this._command={fromApi:w,internal:Me(this,I,"f").toInternal(w,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(w){this._accessibilityInformation=w,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Me(this,E,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let w;this._extension?this._id?w=`${this._extension.identifier.value}.${this._id}`:w=this._extension.identifier.value:w=this._id;let b;this._name?b=this._name:b=(0,D.localize)(0,null,this._extension.displayName||this._extension.name);let v=this._color;this._backgroundColor&&(v=R.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const h=y.MarkdownString.fromStrict(this._tooltip);Me(this,E,"f").$setEntry(this._entryId,w,b,this._text,h,this._command?.internal,v,this._backgroundColor,this._alignment===u.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=R,E=new WeakMap,I=new WeakMap,R.ID_GEN=0,R.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new u.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new u.ThemeColor("statusBarItem.warningForeground")]]);class k{constructor(w){this._messages=[],this._item=w.createStatusBarEntry(void 0,"status.extensionMessage",u.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,D.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(w){const b={message:w};return this._messages.unshift(b),this._update(),new u.Disposable(()=>{const v=this._messages.indexOf(b);v>=0&&(this._messages.splice(v,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class _{constructor(w,b){this._proxy=w.getProxy(t.MainContext.MainThreadStatusBar),this._commands=b,this._statusMessage=new k(this)}createStatusBarEntry(w,b,v,h){return new R(this._proxy,this._commands,w,b,v,h)}setStatusBarMessage(w,b){const v=this._statusMessage.setMessage(w);let h;return typeof b=="number"?h=setTimeout(()=>v.dispose(),b):typeof b!="undefined"&&b.then(()=>v.dispose(),()=>v.dispose()),new u.Disposable(()=>{v.dispose(),clearTimeout(h)})}}e.ExtHostStatusBar=_}),define(De[91],Ie([1,0,5,4,3]),function(Z,e,u,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class P{constructor(C){this._onDidChangeStorage=new t.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=C.getProxy(u.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(C,E){this._proxy.$registerExtensionStorageKeysToSync(C,E)}initializeExtensionStorage(C,E,I){return this._proxy.$initializeExtensionStorage(C,E).then(R=>R||I)}setValue(C,E,I){return this._proxy.$setValue(C,E,I)}$acceptValue(C,E,I){this._onDidChangeStorage.fire({shared:C,key:E,value:I})}}e.ExtHostStorage=P,e.IExtHostStorage=(0,D.createDecorator)("IExtHostStorage")}),define(De[69],Ie([1,0,3,26,14,68,2]),function(Z,e,u,t,D,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,u.createDecorator)("IExtensionStoragePaths");let C=class{constructor(I,R,k){this._logService=R,this._extHostFileSystem=k,this._workspace=I.workspace??void 0,this._environment=I.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(_=>this._value=_)}async _getWorkspaceStorageURI(I){return y.URI.joinPath(this._environment.workspaceStorageHome,I)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const I=this._workspace.id,R=await this._getWorkspaceStorageURI(I);try{return await this._extHostFileSystem.value.stat(R),this._logService.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",R),await this._extHostFileSystem.value.createDirectory(R),await this._extHostFileSystem.value.writeFile(y.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:y.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),R}catch(k){this._logService.error("[ExtHostStorage]",k);return}}workspaceValue(I){if(this._value)return y.URI.joinPath(this._value,I.identifier.value)}globalValue(I){return y.URI.joinPath(this._environment.globalStorageHome,I.identifier.value.toLowerCase())}onWillDeactivateAll(){}};C=je([xe(0,t.IExtHostInitDataService),xe(1,D.ILogService),xe(2,P.IExtHostConsumerFileSystem)],C),e.ExtensionStoragePaths=C}),define(De[136],Ie([1,0,3,5,15]),function(Z,e,u,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTelemetryLogService=e.IExtHostTelemetryLogService=void 0,e.IExtHostTelemetryLogService=(0,u.createDecorator)("IExtHostTelemetryLogService");let P=class{constructor(C){this._telemetryShape=C.getProxy(t.MainContext.MainThreadTelemetry)}logToTelemetryOutputChannel(C,E,I){this._telemetryShape.$logTelemetryToOutputChannel(`${C.identifier.value}/${E}`,I)}};P=je([xe(0,D.IExtHostRpcService)],P),e.ExtHostTelemetryLogService=P}),define(De[38],Ie([1,0,4,5,3,2,15,6,7,172,10,217,21,34,200,86,13,18]),function(Z,e,u,t,D,P,y,C,E,I,R,k,_,T,w,b,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,D.createDecorator)("IExtHostTerminalService");class g{constructor(n,a,d,f){this._proxy=n,this._id=a,this._creationOptions=d,this._name=f,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(O=>this._pidPromiseComplete=O);const S=this;this.value={get name(){return S._name||""},get processId(){return S._pidPromise},get creationOptions(){return S._creationOptions},get exitStatus(){return S._exitStatus},get state(){return S._state},sendText(O,U=!0){S._checkDisposed(),S._proxy.$sendText(S._id,O,U)},show(O){S._checkDisposed(),S._proxy.$show(S._id,O)},hide(){S._checkDisposed(),S._proxy.$hide(S._id)},dispose(){S._disposed||(S._disposed=!0,S._proxy.$dispose(S._id))},get dimensions(){if(!(S._cols===void 0||S._rows===void 0))return{columns:S._cols,rows:S._rows}}}}async create(n,a){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:n.name,shellPath:(0,v.withNullAsUndefined)(n.shellPath),shellArgs:(0,v.withNullAsUndefined)(n.shellArgs),cwd:(0,v.withNullAsUndefined)(n.cwd),env:(0,v.withNullAsUndefined)(n.env),icon:(0,v.withNullAsUndefined)(s(n.iconPath)),color:b.ThemeColor.isThemeColor(n.color)?n.color.id:void 0,initialText:(0,v.withNullAsUndefined)(n.message),strictEnv:(0,v.withNullAsUndefined)(n.strictEnv),hideFromUser:(0,v.withNullAsUndefined)(n.hideFromUser),isFeatureTerminal:(0,v.withNullAsUndefined)(a?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,v.withNullAsUndefined)(a?.useShellEnvironment),location:a?.location||this._serializeParentTerminal(n.location,a?.resolvedExtHostIdentifier),isTransient:(0,v.withNullAsUndefined)(n.isTransient)})}async createExtensionTerminal(n,a,d,f){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:d,color:b.ThemeColor.isThemeColor(f)?f.id:void 0,location:this._serializeParentTerminal(n,a),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(n,a){return typeof n=="object"?"parentTerminal"in n&&n.parentTerminal&&a?{parentTerminal:a}:"viewColumn"in n?{viewColumn:n.viewColumn,preserveFocus:n.preserveFocus}:void 0:n}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(n){this._name=n}setExitStatus(n,a){this._exitStatus=Object.freeze({code:n,reason:a})}setDimensions(n,a){return n===this._cols&&a===this._rows||n===0||a===0?!1:(this._cols=n,this._rows=a,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(n){this._pidPromiseComplete?(this._pidPromiseComplete(n),this._pidPromiseComplete=void 0):this._pidPromise.then(a=>{a!==n&&(this._pidPromise=Promise.resolve(n))})}}e.ExtHostTerminal=g;class p{constructor(n){this._pty=n,this.id=0,this.shouldPersist=!1,this._onProcessData=new u.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new u.Emitter,this._onDidChangeProperty=new u.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new u.Emitter,this.onProcessExit=this._onProcessExit.event}get onProcessReady(){return this._onProcessReady.event}refreshProperty(n){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${n}`)}updateProperty(n,a){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${n}, value: ${a}`)}async start(){}shutdown(){this._pty.close()}input(n){this._pty.handleInput?.(n)}resize(n,a){this._pty.setDimensions?.({columns:n,rows:a})}async processBinary(n){}acknowledgeDataEvent(n){}async setUnicodeVersion(n){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(n){this._pty.onDidWrite(a=>this._onProcessData.fire(a)),this._pty.onDidClose?.((a=void 0)=>{this._onProcessExit.fire(a===void 0?void 0:a)}),this._pty.onDidOverrideDimensions?.(a=>{a&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:a.columns,rows:a.rows}})}),this._pty.onDidChangeName?.(a=>{this._onDidChangeProperty.fire({type:"title",value:a})}),this._pty.open(n||void 0),n&&this._pty.setDimensions?.(n),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=p;let o=1,m=class extends C.Disposable{constructor(n,a){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new u.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new u.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new u.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new u.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new u.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=a.getProxy(t.MainContext.MainThreadTerminalService),this._bufferer=new w.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new u.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(n),this._register({dispose:()=>{for(const[d,f]of this._terminalProcesses)f.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(n=>n.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(n){return(n?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(n){return(n?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(n,a){const d=new g(this._proxy,(0,T.generateUuid)(),n,n.name),f=new p(n.pty);return d.createExtensionTerminal(n.location,this._serializeParentTerminal(n,a).resolvedExtHostIdentifier,s(n.iconPath),i(n.color)).then(S=>{const O=this._setupExtHostProcessListeners(S,f);this._terminalProcessDisposables[S]=O}),this._terminals.push(d),d.value}_serializeParentTerminal(n,a){if(a=a||{},n.location&&typeof n.location=="object"&&"parentTerminal"in n.location){const d=n.location.parentTerminal;if(d){const f=this._terminals.find(S=>S.value===d);f&&(a.resolvedExtHostIdentifier=f._id)}}else n.location&&typeof n.location!="object"?a.location=n.location:a.location&&typeof a.location=="object"&&"splitActiveTerminal"in a.location&&(a.location={splitActiveTerminal:!0});return a}attachPtyToTerminal(n,a){if(!this._getTerminalById(n))throw new Error(`Cannot resolve terminal with id ${n} for virtual process`);const f=new p(a),S=this._setupExtHostProcessListeners(n,f);this._terminalProcessDisposables[n]=S}async $acceptActiveTerminalChanged(n){const a=this._activeTerminal;if(n===null){this._activeTerminal=void 0,a!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const d=this._getTerminalById(n);d&&(this._activeTerminal=d,a!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(n,a){const d=this._getTerminalById(n);d&&this._onDidWriteTerminalData.fire({terminal:d.value,data:a})}async $acceptTerminalDimensions(n,a,d){const f=this._getTerminalById(n);f&&f.setDimensions(a,d)&&this._onDidChangeTerminalDimensions.fire({terminal:f.value,dimensions:f.value.dimensions})}async $acceptTerminalMaximumDimensions(n,a,d){this._terminalProcesses.get(n)?.resize(a,d)}async $acceptTerminalTitleChange(n,a){const d=this._getTerminalById(n);d&&(d.name=a)}async $acceptTerminalClosed(n,a,d){const f=this._getTerminalObjectIndexById(this._terminals,n);if(f!==null){const S=this._terminals.splice(f,1)[0];S.setExitStatus(a,d),this._onDidCloseTerminal.fire(S.value)}}$acceptTerminalOpened(n,a,d,f){if(a){const U=this._getTerminalObjectIndexById(this._terminals,a);if(U!==null){this._terminals[U]._id=n,this._onDidOpenTerminal.fire(this.terminals[U]),this._terminals[U].isOpen=!0;return}}const S={name:f.name,shellPath:f.executable,shellArgs:f.args,cwd:typeof f.cwd=="string"?f.cwd:P.URI.revive(f.cwd),env:f.env,hideFromUser:f.hideFromUser},O=new g(this._proxy,n,S,d);this._terminals.push(O),this._onDidOpenTerminal.fire(O.value),O.isOpen=!0}async $acceptTerminalProcessId(n,a){this._getTerminalById(n)?._setProcessId(a)}async $startExtensionTerminal(n,a){const d=this._getTerminalById(n);if(!d)return{message:(0,I.localize)(0,null,n)};d.isOpen||await new Promise(S=>{const O=this.onDidOpenTerminal(async U=>{U===d.value&&(O.dispose(),S())})});const f=this._terminalProcesses.get(n);f?f.startSendingEvents(a):this._extensionTerminalAwaitingStart[n]={initialDimensions:a}}_setupExtHostProcessListeners(n,a){const d=new C.DisposableStore;d.add(a.onProcessReady(S=>this._proxy.$sendProcessReady(n,S.pid,S.cwd))),d.add(a.onDidChangeProperty(S=>this._proxy.$sendProcessProperty(n,S))),this._bufferer.startBuffering(n,a.onProcessData),d.add(a.onProcessExit(S=>this._onProcessExit(n,S))),this._terminalProcesses.set(n,a);const f=this._extensionTerminalAwaitingStart[n];return f&&a instanceof p&&(a.startSendingEvents(f.initialDimensions),delete this._extensionTerminalAwaitingStart[n]),d}$acceptProcessAckDataEvent(n,a){this._terminalProcesses.get(n)?.acknowledgeDataEvent(a)}$acceptProcessInput(n,a){this._terminalProcesses.get(n)?.input(a)}$acceptTerminalInteraction(n){const a=this._getTerminalById(n);a?.setInteractedWith()&&this._onDidChangeTerminalState.fire(a.value)}$acceptProcessResize(n,a,d){try{this._terminalProcesses.get(n)?.resize(a,d)}catch(f){if(f.code!=="EPIPE"&&f.code!=="ERR_IPC_CHANNEL_CLOSED")throw f}}$acceptProcessShutdown(n,a){this._terminalProcesses.get(n)?.shutdown(a)}$acceptProcessRequestInitialCwd(n){this._terminalProcesses.get(n)?.getInitialCwd().then(a=>this._proxy.$sendProcessProperty(n,{type:"initialCwd",value:a}))}$acceptProcessRequestCwd(n){this._terminalProcesses.get(n)?.getCwd().then(a=>this._proxy.$sendProcessProperty(n,{type:"cwd",value:a}))}$acceptProcessRequestLatency(n){return Promise.resolve(n)}registerLinkProvider(n){return this._linkProviders.add(n),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new E.Disposable(()=>{this._linkProviders.delete(n),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(n,a,d){if(this._profileProviders.has(a))throw new Error(`Terminal profile provider "${a}" already registered`);return this._profileProviders.set(a,d),this._proxy.$registerProfileProvider(a,n.identifier.value),new E.Disposable(()=>{this._profileProviders.delete(a),this._proxy.$unregisterProfileProvider(a)})}async $createContributedProfileTerminal(n,a){const d=new _.CancellationTokenSource().token;let f=await this._profileProviders.get(n)?.provideTerminalProfile(d);if(!d.isCancellationRequested){if(f&&!("options"in f)&&(f={options:f}),!f||!("options"in f))throw new Error(`No terminal profile options provided for id "${n}"`);if("pty"in f.options){this.createExtensionTerminal(f.options,a);return}this.createTerminalFromOptions(f.options,a)}}async $provideLinks(n,a){const d=this._getTerminalById(n);if(!d)return[];this._terminalLinkCache.delete(n),this._terminalLinkCancellationSource.get(n)?.dispose(!0);const S=new _.CancellationTokenSource;this._terminalLinkCancellationSource.set(n,S);const O=[],U={terminal:d.value,line:a},M=[];for(const x of this._linkProviders)M.push(h.Promises.withAsyncBody(async N=>{S.token.onCancellationRequested(()=>N({provider:x,links:[]}));const K=await x.provideTerminalLinks(U,S.token)||[];S.token.isCancellationRequested||N({provider:x,links:K})}));const A=await Promise.all(M);if(S.token.isCancellationRequested)return[];const B=new Map;for(const x of A)x&&x.links.length>0&&O.push(...x.links.map(N=>{const K={id:o++,startIndex:N.startIndex,length:N.length,label:N.tooltip};return B.set(K.id,{provider:x.provider,link:N}),K}));return this._terminalLinkCache.set(n,B),O}$activateLink(n,a){const d=this._terminalLinkCache.get(n)?.get(a);!d||d.provider.handleTerminalLink(d.link)}_onProcessExit(n,a){this._bufferer.stopBuffering(n),this._terminalProcesses.delete(n),delete this._extensionTerminalAwaitingStart[n];const d=this._terminalProcessDisposables[n];d&&(d.dispose(),delete this._terminalProcessDisposables[n]),this._proxy.$sendProcessExit(n,a)}_getTerminalById(n){return this._getTerminalObjectById(this._terminals,n)}_getTerminalObjectById(n,a){const d=this._getTerminalObjectIndexById(n,a);return d!==null?n[d]:null}_getTerminalObjectIndexById(n,a){let d=null;return n.some((f,S)=>f._id===a?(d=S,!0):!1),d}getEnvironmentVariableCollection(n){let a=this._environmentVariableCollections.get(n.identifier.value);return a||(a=new c,this._setEnvironmentVariableCollection(n.identifier.value,a)),a}_syncEnvironmentVariableCollection(n,a){const d=(0,k.serializeEnvironmentVariableCollection)(a.map);this._proxy.$setEnvironmentVariableCollection(n,a.persistent,d.length===0?void 0:d)}$initEnvironmentVariableCollections(n){n.forEach(a=>{const d=a[0],f=new c(a[1]);this._setEnvironmentVariableCollection(d,f)})}$acceptDefaultProfile(n,a){this._defaultProfile=n,this._defaultAutomationProfile=a}_setEnvironmentVariableCollection(n,a){this._environmentVariableCollections.set(n,a),a.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(n,a)})}};m=je([xe(1,y.IExtHostRpcService)],m),e.BaseExtHostTerminalService=m;class c{constructor(n){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new u.Emitter,this.map=new Map(n)}get persistent(){return this._persistent}set persistent(n){this._persistent=n,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(n,a){this._setIfDiffers(n,{value:a,type:E.EnvironmentVariableMutatorType.Replace})}append(n,a){this._setIfDiffers(n,{value:a,type:E.EnvironmentVariableMutatorType.Append})}prepend(n,a){this._setIfDiffers(n,{value:a,type:E.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(n,a){const d=this.map.get(n);(!d||d.value!==a.value||d.type!==a.type)&&(this.map.set(n,a),this._onDidChangeCollection.fire())}get(n){return this.map.get(n)}forEach(n,a){this.map.forEach((d,f)=>n.call(a,f,d,this))}[Symbol.iterator](){return this.map.entries()}delete(n){this.map.delete(n),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=c;let l=class extends m{constructor(n){super(!1,n)}createTerminal(n,a,d){throw new R.NotSupportedError}createTerminalFromOptions(n,a){throw new R.NotSupportedError}};l=je([xe(0,y.IExtHostRpcService)],l),e.WorkerExtHostTerminalService=l;function s(r){if(!(!r||typeof r=="string"))return"id"in r?{id:r.id,color:r.color}:r}function i(r){return b.ThemeColor.isThemeColor(r)?r:void 0}});var et=this&&this.__classPrivateFieldSet||function(Z,e,u,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!D:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(Z,u):D?D.value=u:e.set(Z,u),u},Me=this&&this.__classPrivateFieldGet||function(Z,e,u,t){if(u==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?t:u==="a"?t.call(Z):t?t.value:e.get(Z)};define(De[258],Ie([1,0,17,23,21,4,58,60,6,24,13,34,5,15,131,16,7,65,89,66]),function(Z,e,u,t,D,P,y,C,E,I,R,k,_,T,w,b,v,h,g,p){"use strict";var o,m;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let c=class{constructor(M,A){this.resultsChangedEmitter=new P.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=M.getProxy(_.MainContext.MainThreadTesting),this.observer=new f(this.proxy),this.runTracker=new s(this.proxy),A.registerArgumentProcessor({processArgument:B=>B?.$mid===13?(0,w.toItemFromContext)(B):B})}createTestController(M,A,B){if(this.controllers.has(M))throw new Error(`Attempt to insert a duplicate controller with ID "${M}"`);const x=new E.DisposableStore,N=x.add(new w.ExtHostTestItemCollection(M,A));N.root.label=A;const K=new Map,X=this.proxy,L={items:N.root.children,get label(){return A},set label(H){A=H,N.root.label=H,X.$updateController(M,{label:A})},get refreshHandler(){return B},set refreshHandler(H){B=H,X.$updateController(M,{canRefresh:!!H})},get id(){return M},createRunProfile:(H,j,J,Y,he)=>{let ve=(0,C.hash)(H);for(;K.has(ve);)ve++;return new S(this.proxy,K,M,ve,H,j,J,Y,he)},createTestItem(H,j,J){return new w.TestItemImpl(M,H,j,J)},createTestRun:(H,j,J=!0)=>this.runTracker.createTestRun(M,N,H,j,J),set resolveHandler(H){N.resolveHandler=H},get resolveHandler(){return N.resolveHandler},dispose:()=>{x.dispose()}};X.$registerTestController(M,A,!!B),x.add((0,E.toDisposable)(()=>X.$unregisterTestController(M)));const $={controller:L,collection:N,profiles:K};return this.controllers.set(M,$),x.add((0,E.toDisposable)(()=>this.controllers.delete(M))),x.add(N.onDidGenerateDiff(H=>X.$publishDiff(M,H.map(p.TestsDiffOp.serialize)))),L}createTestObserver(){return this.observer.checkout()}async runTests(M,A=D.CancellationToken.None){const B=i(M);if(!B)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const x=this.controllers.get(B.controllerId);if(!x)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:M.include?.map(N=>h.TestId.fromExtHostTestItem(N,x.collection.root.id).toString())??[x.collection.root.id],profileGroup:O[B.kind],profileId:B.profileId,controllerId:B.controllerId}],exclude:M.exclude?.map(N=>N.id)},A)}$provideFileCoverage(M,A,B){return(0,u.mapFind)(this.runTracker.trackers,N=>N.id===M?N.getCoverage(A):void 0)?.provideFileCoverage(B)??Promise.resolve([])}$resolveFileCoverage(M,A,B,x){return(0,u.mapFind)(this.runTracker.trackers,K=>K.id===M?K.getCoverage(A):void 0)?.resolveFileCoverage(B,x)??Promise.resolve([])}$configureRunProfile(M,A){this.controllers.get(M)?.profiles.get(A)?.configureHandler?.()}async $refreshTests(M,A){await this.controllers.get(M)?.controller.refreshHandler?.(A)}$publishTestResults(M){this.results=Object.freeze(M.map(A=>(0,I.deepFreeze)(b.TestResults.to(A))).concat(this.results).sort((A,B)=>B.completedAt-A.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(M,A){const B=this.controllers.get(h.TestId.fromString(M).controllerId)?.collection;B&&(await B.expand(M,A<0?1/0:A),B.flushDiff())}$acceptDiff(M){this.observer.applyDiff(M.map(p.TestsDiffOp.deserialize))}async $runControllerTests(M,A){return Promise.all(M.map(B=>this.runControllerTestRequest(B,A)))}async runControllerTestRequest(M,A){const B=this.controllers.get(M.controllerId);if(!B)return{};const{collection:x,profiles:N}=B,K=N.get(M.profileId);if(!K)return{};const X=M.testIds.map(j=>x.tree.get(j)).filter(R.isDefined),L=M.excludeExtIds.map(j=>B.collection.tree.get(j)).filter(R.isDefined).filter(j=>X.some(J=>J.fullId.compare(j.fullId)===2));if(!X.length)return{};const $=new v.TestRunRequest(X.some(j=>j.actual instanceof w.TestItemRootImpl)?void 0:X.map(j=>j.actual),L.map(j=>j.actual),K),H=this.runTracker.prepareForMainThreadTestRun($,r.fromInternal(M,B.collection),A);try{return await K.runHandler($,A),{}}catch(j){return{error:String(j)}}finally{H.isRunning&&!A.isCancellationRequested&&await P.Event.toPromise(H.onEnd),H.dispose()}}$cancelExtensionTestRun(M){M===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(M)}};c=je([xe(0,T.IExtHostRpcService)],c),e.ExtHostTesting=c;class l extends E.Disposable{constructor(M,A,B){super();this.dto=M,this.proxy=A,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new P.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new D.CancellationTokenSource(B)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:x}of this.tasks.values())x.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(M){return this.tasks.get(M)?.coverage}createRun(M){const A=this.dto.id,B=this.dto.controllerId,x=(0,k.generateUuid)(),N=new n(this.proxy,A,x),K=H=>(j,...J)=>{if(L){console.warn(`Setting the state of test "${j.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(j)||(this.ensureTestIsKnown(j),H(j,...J))},X=(H,j)=>{const J=j instanceof Array?j.map(b.TestMessage.from):[b.TestMessage.from(j)];if(H.uri&&H.range){const Y={range:b.Range.from(H.range),uri:H.uri};for(const he of J)he.location=he.location||Y}this.proxy.$appendTestMessagesInRun(A,x,h.TestId.fromExtHostTestItem(H,B).toString(),J)};let L=!1;const $={isPersisted:this.dto.isPersisted,token:this.cts.token,name:M,get coverageProvider(){return N.coverageProvider},set coverageProvider(H){N.coverageProvider=H},enqueued:K(H=>{this.proxy.$updateTestStateInRun(A,x,h.TestId.fromExtHostTestItem(H,B).toString(),1)}),skipped:K(H=>{this.proxy.$updateTestStateInRun(A,x,h.TestId.fromExtHostTestItem(H,B).toString(),5)}),started:K(H=>{this.proxy.$updateTestStateInRun(A,x,h.TestId.fromExtHostTestItem(H,B).toString(),2)}),errored:K((H,j,J)=>{X(H,j),this.proxy.$updateTestStateInRun(A,x,h.TestId.fromExtHostTestItem(H,B).toString(),6,J)}),failed:K((H,j,J)=>{X(H,j),this.proxy.$updateTestStateInRun(A,x,h.TestId.fromExtHostTestItem(H,B).toString(),4,J)}),passed:K((H,j)=>{this.proxy.$updateTestStateInRun(A,x,h.TestId.fromExtHostTestItem(H,this.dto.controllerId).toString(),3,j)}),appendOutput:(H,j,J)=>{L||(J&&(this.dto.isIncluded(J)?this.ensureTestIsKnown(J):J=void 0),this.proxy.$appendOutputToRun(A,x,t.VSBuffer.fromString(H),j&&b.location.from(j),J&&h.TestId.fromExtHostTestItem(J,B).toString()))},end:()=>{L||(L=!0,this.proxy.$finishedTestRunTask(A,x),this.tasks.delete(x),this.isRunning||this.dispose())}};return this.tasks.set(x,{run:$,coverage:N}),this.proxy.$startedTestRunTask(A,{id:x,name:M,running:!0}),$}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(M){if(!(M instanceof w.TestItemImpl))throw new g.InvalidTestItemError(M.id);if(this.sharedTestIds.has(h.TestId.fromExtHostTestItem(M,this.dto.controllerId).toString()))return;const A=[],B=this.dto.colllection.root;for(;;){const x=b.TestItem.from(M);if(A.unshift(x),this.sharedTestIds.has(x.extId)||(this.sharedTestIds.add(x.extId),M===B))break;M=M.parent||B}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,A)}}class s{constructor(M){this.proxy=M,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(M,A,B){return this.getTracker(M,A,B)}cancelRunById(M){for(const A of this.tracked.values())if(A.id===M){A.dispose();return}}cancelAllRuns(){for(const M of this.tracked.values())M.dispose()}createTestRun(M,A,B,x,N){const K=this.tracked.get(B);if(K)return K.createRun(x);const X=r.fromPublic(M,A,B,N),L=i(B);this.proxy.$startedExtensionTestRun({controllerId:M,profile:L&&{group:O[L.kind],id:L.profileId},exclude:B.exclude?.map(H=>h.TestId.fromExtHostTestItem(H,A.root.id).toString())??[],id:X.id,include:B.include?.map(H=>h.TestId.fromExtHostTestItem(H,A.root.id).toString())??[A.root.id],persist:N});const $=this.getTracker(B,X);return $.onEnd(()=>this.proxy.$finishedExtensionTestRun(X.id)),$.createRun(x)}getTracker(M,A,B){const x=new l(A,this.proxy,B);return this.tracked.set(M,x),x.onEnd(()=>this.tracked.delete(M)),x}}e.TestRunCoordinator=s;const i=U=>{if(!!U.profile){if(!(U.profile instanceof S))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return U.profile}};class r{constructor(M,A,B,x,N,K){this.controllerId=M,this.id=A,this.isPersisted=N,this.colllection=K,this.includePrefix=B.map(X=>X+"\0"),this.excludePrefix=x.map(X=>X+"\0")}static fromPublic(M,A,B,x){return new r(M,(0,k.generateUuid)(),B.include?.map(N=>h.TestId.fromExtHostTestItem(N,M).toString())??[M],B.exclude?.map(N=>h.TestId.fromExtHostTestItem(N,M).toString())??[],x,A)}static fromInternal(M,A){return new r(M.controllerId,M.runId,M.testIds,M.excludeExtIds,!0,A)}isIncluded(M){const A=h.TestId.fromExtHostTestItem(M,this.controllerId).toString()+"\0";for(const B of this.excludePrefix)if(A===B||A.startsWith(B))return!1;for(const B of this.includePrefix)if(A===B||A.startsWith(B))return!0;return!1}}e.TestRunDto=r;class n{constructor(M,A,B){this.proxy=M,this.runId=A,this.taskId=B}set coverageProvider(M){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!M||(this._coverageProvider=M,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(M){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(M))());try{return(await this.fileCoverage)?.map(b.TestCoverage.fromFile)??[]}catch(A){throw this.fileCoverage=void 0,A}}async resolveFileCoverage(M,A){const B=await this.fileCoverage;let x=B?.[M];return!this._coverageProvider||!B||!x?[]:(x.detailedCoverage||(x=B[M]=await this._coverageProvider.resolveFileCoverage?.(x,A)??x),x.detailedCoverage?.map(b.TestCoverage.fromDetailed)??[])}}class a extends p.IncrementalChangeCollector{constructor(M){super();this.emitter=M,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(M){this.added.add(M)}update(M){Object.assign(M.revived,b.TestItem.toPlain(M.item)),this.added.has(M)||this.updated.add(M)}remove(M){if(this.added.has(M)){this.added.delete(M);return}if(this.updated.delete(M),M.parent&&this.alreadyRemoved.has(M.parent)){this.alreadyRemoved.add(M.item.extId);return}this.removed.add(M)}getChangeEvent(){const{added:M,updated:A,removed:B}=this;return{get added(){return[...M].map(x=>x.revived)},get updated(){return[...A].map(x=>x.revived)},get removed(){return[...B].map(x=>x.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class d extends p.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new P.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(M){return this.items.get(M)}getMirroredTestDataByReference(M){return this.items.get(M.id)}createItem(M,A){return{...M,revived:b.TestItem.toPlain(M.item),depth:A?A.depth+1:0,children:new Set}}createChangeCollector(){return new a(this.changeEmitter)}}e.MirroredTestCollection=d;class f{constructor(M){this.proxy=M}checkout(){this.current||(this.current=this.createObserverData());const M=this.current;return M.observers++,{onDidChangeTest:M.tests.onDidChangeTests,get tests(){return[...M.tests.rootTests].map(A=>A.revived)},dispose:(0,y.once)(()=>{--M.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(M){return this.current?.tests.getMirroredTestDataByReference(M)}applyDiff(M){this.current?.tests.apply(M)}createObserverData(){const M=new d;return this.proxy.$subscribeToDiffs(),{observers:0,tests:M}}}class S{constructor(M,A,B,x,N,K,X,L=!1,$=void 0){this.controllerId=B,this.profileId=x,this._label=N,this.kind=K,this.runHandler=X,this._isDefault=L,this._tag=$,o.set(this,void 0),m.set(this,void 0),et(this,o,M,"f"),et(this,m,A,"f"),A.set(x,this);const H=O[K];if(typeof H!="number")throw new Error(`Unknown TestRunProfile.group ${K}`);Me(this,o,"f").$publishTestRunProfile({profileId:x,controllerId:B,tag:$?b.TestTag.namespace(this.controllerId,$.id):null,label:N,group:H,isDefault:L,hasConfigurationHandler:!1})}get label(){return this._label}set label(M){M!==this._label&&(this._label=M,Me(this,o,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:M}))}get isDefault(){return this._isDefault}set isDefault(M){M!==this._isDefault&&(this._isDefault=M,Me(this,o,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:M}))}get tag(){return this._tag}set tag(M){M?.id!==this._tag?.id&&(this._tag=M,Me(this,o,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:M?b.TestTag.namespace(this.controllerId,M.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(M){M!==this._configureHandler&&(this._configureHandler=M,Me(this,o,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!M}))}dispose(){Me(this,m,"f")?.delete(this.profileId)&&(et(this,m,void 0,"f"),Me(this,o,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=S,o=new WeakMap,m=new WeakMap;const O={[v.TestRunProfileKind.Coverage]:8,[v.TestRunProfileKind.Debug]:4,[v.TestRunProfileKind.Run]:2}}),define(De[259],Ie([1,0,17,4,5,132,16,7]),function(Z,e,u,t,D,P,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class E{constructor(R,k){this._extHostDocumentsAndEditors=k,this._onDidChangeTextEditorSelection=new t.Emitter,this._onDidChangeTextEditorOptions=new t.Emitter,this._onDidChangeTextEditorVisibleRanges=new t.Emitter,this._onDidChangeTextEditorViewColumn=new t.Emitter,this._onDidChangeActiveTextEditor=new t.Emitter,this._onDidChangeVisibleTextEditors=new t.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=R.getProxy(D.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(_=>this._onDidChangeVisibleTextEditors.fire(_)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(_=>this._onDidChangeActiveTextEditor.fire(_))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(R){const k=this._extHostDocumentsAndEditors.allEditors();return R?k:k.map(_=>_.value)}async showTextDocument(R,k,_){let T;typeof k=="number"?T={position:y.ViewColumn.from(k),preserveFocus:_}:typeof k=="object"?T={position:y.ViewColumn.from(k.viewColumn),preserveFocus:k.preserveFocus,selection:typeof k.selection=="object"?y.Range.from(k.selection):void 0,pinned:typeof k.preview=="boolean"?!k.preview:void 0}:T={preserveFocus:!1};const w=await this._proxy.$tryShowTextDocument(R.uri,T),b=w&&this._extHostDocumentsAndEditors.getEditor(w);if(b)return b.value;throw w?new Error(`Could NOT open editor for "${R.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${R.uri.toString()}".`)}createTextEditorDecorationType(R,k){return new P.TextEditorDecorationType(this._proxy,R,k).value}$acceptEditorPropertiesChanged(R,k){const _=this._extHostDocumentsAndEditors.getEditor(R);if(!_)throw new Error("unknown text editor");if(k.options&&_._acceptOptions(k.options),k.selections){const T=k.selections.selections.map(y.Selection.to);_._acceptSelections(T)}if(k.visibleRanges){const T=u.coalesce(k.visibleRanges.map(y.Range.to));_._acceptVisibleRanges(T)}if(k.options&&this._onDidChangeTextEditorOptions.fire({textEditor:_.value,options:{...k.options,lineNumbers:y.TextEditorLineNumbersStyle.to(k.options.lineNumbers)}}),k.selections){const T=C.TextEditorSelectionChangeKind.fromValue(k.selections.source),w=k.selections.selections.map(y.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:_.value,selections:w,kind:T})}if(k.visibleRanges){const T=u.coalesce(k.visibleRanges.map(y.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:_.value,visibleRanges:T})}}$acceptEditorPositionData(R){for(const k in R){const _=this._extHostDocumentsAndEditors.getEditor(k);if(!_)throw new Error("Unknown text editor");const T=y.ViewColumn.to(R[k]);_.value.viewColumn!==T&&(_._acceptViewColumn(T),this._onDidChangeTextEditorViewColumn.fire({textEditor:_.value,viewColumn:T}))}}getDiffInformation(R){return Promise.resolve(this._proxy.$getDiffInformation(R))}}e.ExtHostEditors=E}),define(De[260],Ie([1,0,2,3,5,6,7,16,13]),function(Z,e,u,t,D,P,y,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,t.createDecorator)("IExtHostTimeline");class I{constructor(_,T){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=_.getProxy(D.MainContext.MainThreadTimeline),T.registerArgumentProcessor({processArgument:w=>{if(w&&w.$mid===11){const b=w.uri===void 0?void 0:u.URI.revive(w.uri);return this._itemsBySourceAndUriMap.get(w.source)?.get(R(b))?.get(w.handle)}return w}})}async $getTimeline(_,T,w,b){return this._providers.get(_)?.provideTimeline(u.URI.revive(T),w,b)}registerTimelineProvider(_,T,w,b){const v=new P.DisposableStore,h=this.convertTimelineItem(T.id,b,v).bind(this);let g;T.onDidChange&&(g=T.onDidChange(o=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...o,id:T.id}),this));const p=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...T,scheme:_,onDidChange:void 0,async provideTimeline(o,m,c){m?.resetCache&&(v.clear(),p.get(T.id)?.clear());const l=await T.provideTimeline(o,m,c);if(l==null)return;const s=h(o,m);return{...l,source:T.id,items:l.items.map(s)}},dispose(){for(const o of p.values())o.get(T.id)?.clear();g?.dispose(),v.dispose()}})}convertTimelineItem(_,T,w){return(b,v)=>{let h;if(v?.cacheResults){let g=this._itemsBySourceAndUriMap.get(_);g===void 0&&(g=new Map,this._itemsBySourceAndUriMap.set(_,g));const p=R(b);h=g.get(p),h===void 0&&(h=new Map,g.set(p,h))}return g=>{const{iconPath:p,...o}=g,m=`${_}|${g.id??g.timestamp}`;h?.set(m,g);let c,l,s;g.iconPath&&(p instanceof y.ThemeIcon?s={id:p.id,color:p.color}:u.URI.isUri(p)?(c=p,l=p):{light:c,dark:l}=p);let i;return y.MarkdownString.isMarkdownString(o.tooltip)?i=C.MarkdownString.from(o.tooltip):(0,E.isString)(o.tooltip)?i=o.tooltip:y.MarkdownString.isMarkdownString(o.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),i=C.MarkdownString.from(o.detail)):(0,E.isString)(o.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),i=o.detail),{...o,id:o.id??void 0,handle:m,source:_,command:g.command?T.toInternal(g.command,w):void 0,icon:c,iconDark:l,themeIcon:s,tooltip:i,accessibilityInformation:g.accessibilityInformation}}}}registerTimelineProviderCore(_){if(this._providers.get(_.id))throw new Error(`Timeline Provider ${_.id} already exists.`);return this._proxy.$registerTimelineProvider({id:_.id,label:_.label,scheme:_.scheme}),this._providers.set(_.id,_),(0,P.toDisposable)(()=>{for(const w of this._itemsBySourceAndUriMap.values())w.get(_.id)?.clear();this._providers.delete(_.id),this._proxy.$unregisterTimelineProvider(_.id),_.dispose()})}}e.ExtHostTimeline=I;function R(k){return k?.toString()}}),define(De[261],Ie([1,0,6,12,2,5]),function(Z,e,u,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class y{constructor(E){this._openers=new Map,this._proxy=E.getProxy(P.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(E,I,R,k){if(this._openers.has(I))throw new Error(`Opener with id '${I}' already registered`);const _=k.schemes.find(T=>!y.supportedSchemes.has(T));if(_)throw new Error(`Scheme '${_}' is not supported. Only http and https are currently supported.`);return this._openers.set(I,R),this._proxy.$registerUriOpener(I,k.schemes,E,k.label),(0,u.toDisposable)(()=>{this._openers.delete(I),this._proxy.$unregisterUriOpener(I)})}async $canOpenUri(E,I,R){const k=this._openers.get(E);if(!k)throw new Error(`Unknown opener with id: ${E}`);const _=D.URI.revive(I);return k.canOpenExternalUri(_,R)}async $openUri(E,I,R){const k=this._openers.get(E);if(!k)throw new Error(`Unknown opener id: '${E}'`);return k.openExternalUri(D.URI.revive(I.resolvedUri),{sourceUri:D.URI.revive(I.sourceUri)},R)}}e.ExtHostUriOpeners=y,y.supportedSchemes=new Set([t.Schemas.http,t.Schemas.https])}),define(De[262],Ie([1,0,5,2,6,10,28]),function(Z,e,u,t,D,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class C{constructor(I){this.handles=new Set,this.handlers=new Map,this._proxy=I.getProxy(u.MainContext.MainThreadUrls)}registerUriHandler(I,R){if(this.handles.has(y.ExtensionIdentifier.toKey(I)))throw new Error(`Protocol handler already registered for extension ${I}`);const k=C.HandlePool++;return this.handles.add(y.ExtensionIdentifier.toKey(I)),this.handlers.set(k,R),this._proxy.$registerUriHandler(k,I),(0,D.toDisposable)(()=>{this.handles.delete(y.ExtensionIdentifier.toKey(I)),this.handlers.delete(k),this._proxy.$unregisterUriHandler(k)})}$handleExternalUri(I,R){const k=this.handlers.get(I);if(!k)return Promise.resolve(void 0);try{k.handleUri(t.URI.revive(R))}catch(_){(0,P.onUnexpectedError)(_)}return Promise.resolve(void 0)}async createAppUri(I){return t.URI.revive(await this._proxy.$createAppUri(I))}}e.ExtHostUrls=C,C.HandlePool=0});var et=this&&this.__classPrivateFieldSet||function(Z,e,u,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!D:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(Z,u):D?D.value=u:e.set(Z,u),u},Me=this&&this.__classPrivateFieldGet||function(Z,e,u,t){if(u==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?t:u==="a"?t.call(Z):t?t.value:e.get(Z)};define(De[70],Ie([1,0,4,12,2,187,207,88,5]),function(Z,e,u,t,D,P,y,C,E){"use strict";var I,R,k,_,T,w,b,v,h,g,p,o;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class m{constructor(d,f,S,O,U,M,A){I.set(this,void 0),R.set(this,void 0),k.set(this,void 0),_.set(this,void 0),T.set(this,void 0),w.set(this,void 0),b.set(this,""),v.set(this,void 0),h.set(this,!1),g.set(this,!1),p.set(this,!1),this._onMessageEmitter=new u.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,o.set(this,new u.Emitter),this._onDidDispose=Me(this,o,"f").event,et(this,I,d,"f"),et(this,R,f,"f"),et(this,v,S,"f"),et(this,_,O,"f"),et(this,T,U,"f"),et(this,w,M,"f"),et(this,p,c(M),"f"),et(this,k,A,"f")}dispose(){et(this,h,!0,"f"),Me(this,o,"f").fire(),Me(this,o,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(d){return et(this,g,!0,"f"),(0,C.asWebviewUri)(d,Me(this,_,"f"))}get cspSource(){const d=Me(this,w,"f").extensionLocation;if(d.scheme===t.Schemas.https||d.scheme===t.Schemas.http){let f=d.toString();return f.endsWith("/")||(f+="/"),f+" "+C.webviewGenericCspSource}return C.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Me(this,b,"f")}set html(d){this.assertNotDisposed(),Me(this,b,"f")!==d&&(et(this,b,d,"f"),!Me(this,g,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(d)&&(et(this,g,!0,"f"),Me(this,k,"f").report("Webview vscode-resource: uris",Me(this,w,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Me(this,R,"f").$setHtml(Me(this,I,"f"),d))}get options(){return this.assertNotDisposed(),Me(this,v,"f")}set options(d){this.assertNotDisposed(),Me(this,R,"f").$setOptions(Me(this,I,"f"),i(Me(this,w,"f"),Me(this,T,"f"),d)),et(this,v,d,"f")}async postMessage(d){if(Me(this,h,"f"))return!1;const f=(0,y.serializeWebviewMessage)(d,{serializeBuffersForPostMessage:Me(this,p,"f")});return Me(this,R,"f").$postMessage(Me(this,I,"f"),f.message,...f.buffers)}assertNotDisposed(){if(Me(this,h,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=m,I=new WeakMap,R=new WeakMap,k=new WeakMap,_=new WeakMap,T=new WeakMap,w=new WeakMap,b=new WeakMap,v=new WeakMap,h=new WeakMap,g=new WeakMap,p=new WeakMap,o=new WeakMap;function c(a){try{const d=(0,P.normalizeVersion)((0,P.parseVersion)(a.engines.vscode));return!!d&&d.majorBase>=1&&d.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=c;class l{constructor(d,f,S,O,U){this.remoteInfo=f,this.workspace=S,this._logService=O,this._deprecationService=U,this._webviews=new Map,this._webviewProxy=d.getProxy(E.MainContext.MainThreadWebviews)}$onMessage(d,f,S){const O=this.getWebview(d);if(O){const{message:U}=(0,y.deserializeWebviewMessage)(f,S.value);O._onMessageEmitter.fire(U)}}$onMissingCsp(d,f){this._logService.warn(`${f} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(d,f,S){const O=new m(d,this._webviewProxy,r(f),this.remoteInfo,this.workspace,S,this._deprecationService);return this._webviews.set(d,O),O._onDidDispose(()=>{this._webviews.delete(d)}),O}deleteWebview(d){this._webviews.delete(d)}getWebview(d){return this._webviews.get(d)}}e.ExtHostWebviews=l;function s(a){return{id:a.identifier,location:a.extensionLocation}}e.toExtensionData=s;function i(a,d,f){return{enableCommandUris:f.enableCommandUris,enableScripts:f.enableScripts,enableForms:f.enableForms,portMapping:f.portMapping,localResourceRoots:f.localResourceRoots||n(a,d)}}e.serializeWebviewOptions=i;function r(a){return{enableCommandUris:a.enableCommandUris,enableScripts:a.enableScripts,enableForms:a.enableForms,portMapping:a.portMapping,localResourceRoots:a.localResourceRoots?.map(d=>D.URI.from(d))}}e.reviveOptions=r;function n(a,d){return[...(d?.getWorkspaceFolders()||[]).map(f=>f.uri),a.extensionLocation]}}),define(De[263],Ie([1,0,21,60,6,12,22,2,16,70,87,5,7]),function(Z,e,u,t,D,P,y,C,E,I,R,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class T{constructor(c,l){this.document=c,this._storagePath=l,this._backupCounter=1,this._edits=new R.Cache("custom documents")}addEdit(c){return this._edits.add([c])}async undo(c,l){await this.getEdit(c).undo(),l||this.disposeBackup()}async redo(c,l){await this.getEdit(c).redo(),l||this.disposeBackup()}disposeEdits(c){for(const l of c)this._edits.delete(l)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const c=o(this.document.uri)+this._backupCounter++;return(0,y.joinPath)(this._storagePath,c)}updateBackup(c){this._backup?.delete(),this._backup=c}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(c){const l=this._edits.get(c,0);if(!l)throw new Error("No edit found");return l}}class w{constructor(){this._documents=new Map}get(c,l){return this._documents.get(this.key(c,l))}add(c,l,s){const i=this.key(c,l.uri);if(this._documents.has(i))throw new Error(`Document already exists for viewType:${c} resource:${l.uri}`);const r=new T(l,s);return this._documents.set(i,r),r}delete(c,l){const s=this.key(c,l.uri);this._documents.delete(s)}key(c,l){return`${c}@@@${l}`}}var b;(function(m){m[m.Text=0]="Text",m[m.Custom=1]="Custom"})(b||(b={}));class v{constructor(){this._providers=new Map}addTextProvider(c,l,s){return this.add(0,c,l,s)}addCustomProvider(c,l,s){return this.add(1,c,l,s)}get(c){return this._providers.get(c)}add(c,l,s,i){if(this._providers.has(l))throw new Error(`Provider for viewType:${l} already registered`);return this._providers.set(l,{type:c,extension:s,provider:i}),new _.Disposable(()=>this._providers.delete(l))}}class h{constructor(c,l,s,i,r){this._extHostDocuments=l,this._extensionStoragePaths=s,this._extHostWebview=i,this._extHostWebviewPanels=r,this._editorProviders=new v,this._documents=new w,this._proxy=c.getProxy(k.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(c,l,s,i){const r=new D.DisposableStore;return g(s)?(r.add(this._editorProviders.addTextProvider(l,c,s)),this._proxy.$registerTextEditorProvider((0,I.toExtensionData)(c),l,i.webviewOptions||{},{supportsMove:!!s.moveCustomTextEditor},(0,I.shouldSerializeBuffersForPostMessage)(c))):(r.add(this._editorProviders.addCustomProvider(l,c,s)),this.supportEditing(s)&&r.add(s.onDidChangeCustomDocument(n=>{const a=this.getCustomDocumentEntry(l,n.document.uri);if(p(n)){const d=a.addEdit(n);this._proxy.$onDidEdit(n.document.uri,l,d,n.label)}else this._proxy.$onContentChange(n.document.uri,l)})),this._proxy.$registerCustomEditorProvider((0,I.toExtensionData)(c),l,i.webviewOptions||{},!!i.supportsMultipleEditorsPerDocument,(0,I.shouldSerializeBuffersForPostMessage)(c))),_.Disposable.from(r,new _.Disposable(()=>{this._proxy.$unregisterEditorProvider(l)}))}async $createCustomDocument(c,l,s,i,r){const n=this._editorProviders.get(l);if(!n)throw new Error(`No provider found for '${l}'`);if(n.type!==1)throw new Error(`Invalid provide type for '${l}'`);const a=C.URI.revive(c),d=await n.provider.openCustomDocument(a,{backupId:s,untitledDocumentData:i?.buffer},r);let f;return this.supportEditing(n.provider)&&this._extensionStoragePaths&&(f=this._extensionStoragePaths.workspaceValue(n.extension)??this._extensionStoragePaths.globalValue(n.extension)),this._documents.add(l,d,f),{editable:this.supportEditing(n.provider)}}async $disposeCustomDocument(c,l){const s=this._editorProviders.get(l);if(!s)throw new Error(`No provider found for '${l}'`);if(s.type!==1)throw new Error(`Invalid provider type for '${l}'`);const i=C.URI.revive(c),{document:r}=this.getCustomDocumentEntry(l,i);this._documents.delete(l,r),r.dispose()}async $resolveWebviewEditor(c,l,s,i,r,n){const a=this._editorProviders.get(s);if(!a)throw new Error(`No provider found for '${s}'`);const d=E.ViewColumn.to(r),f=this._extHostWebview.createNewWebview(l,i.webviewOptions,a.extension),S=this._extHostWebviewPanels.createNewWebviewPanel(l,s,i.title,d,i.panelOptions,f,!0),O=C.URI.revive(c);switch(a.type){case 1:{const{document:U}=this.getCustomDocumentEntry(s,O);return a.provider.resolveCustomEditor(U,S,n)}case 0:{const U=this._extHostDocuments.getDocument(O);return a.provider.resolveCustomTextEditor(U,S,n)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(c,l,s){this.getCustomDocumentEntry(l,c).disposeEdits(s)}async $onMoveCustomEditor(c,l,s){const i=this._editorProviders.get(s);if(!i)throw new Error(`No provider found for '${s}'`);if(!i.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${s}'`);const r=this._extHostWebviewPanels.getWebviewPanel(c);if(!r)throw new Error("No webview found");const n=C.URI.revive(l),a=this._extHostDocuments.getDocument(n);await i.provider.moveCustomTextEditor(a,r,u.CancellationToken.None)}async $undo(c,l,s,i){return this.getCustomDocumentEntry(l,c).undo(s,i)}async $redo(c,l,s,i){return this.getCustomDocumentEntry(l,c).redo(s,i)}async $revert(c,l,s){const i=this.getCustomDocumentEntry(l,c);await this.getCustomEditorProvider(l).revertCustomDocument(i.document,s),i.disposeBackup()}async $onSave(c,l,s){const i=this.getCustomDocumentEntry(l,c);await this.getCustomEditorProvider(l).saveCustomDocument(i.document,s),i.disposeBackup()}async $onSaveAs(c,l,s,i){const r=this.getCustomDocumentEntry(l,c);return this.getCustomEditorProvider(l).saveCustomDocumentAs(r.document,C.URI.revive(s),i)}async $backup(c,l,s){const i=this.getCustomDocumentEntry(l,c),n=await this.getCustomEditorProvider(l).backupCustomDocument(i.document,{destination:i.getNewBackupUri()},s);return i.updateBackup(n),n.id}getCustomDocumentEntry(c,l){const s=this._documents.get(c,C.URI.revive(l));if(!s)throw new Error("No custom document found");return s}getCustomEditorProvider(c){const s=this._editorProviders.get(c)?.provider;if(!s||!this.supportEditing(s))throw new Error("Custom document is not editable");return s}supportEditing(c){return!!c.onDidChangeCustomDocument}}e.ExtHostCustomEditors=h;function g(m){return typeof m.resolveCustomTextEditor=="function"}function p(m){return typeof m.undo=="function"&&typeof m.redo=="function"}function o(m){const c=m.scheme===P.Schemas.file||m.scheme===P.Schemas.untitled?m.fsPath:m.toString();return(0,t.hash)(c)+""}});var et=this&&this.__classPrivateFieldSet||function(Z,e,u,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!D:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(Z,u):D?D.value=u:e.set(Z,u),u},Me=this&&this.__classPrivateFieldGet||function(Z,e,u,t){if(u==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?t:u==="a"?t.call(Z):t?t.value:e.get(Z)};define(De[264],Ie([1,0,4,6,2,34,16,70,5,7]),function(Z,e,u,t,D,P,y,C,E,I){"use strict";var R,k,_,T,w,b,v,h,g,p,o,m,c;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class l extends t.Disposable{constructor(n,a,d,f){super();R.set(this,void 0),k.set(this,void 0),_.set(this,void 0),T.set(this,void 0),w.set(this,void 0),b.set(this,void 0),v.set(this,void 0),h.set(this,void 0),g.set(this,!0),p.set(this,void 0),o.set(this,!1),m.set(this,this._register(new u.Emitter)),this.onDidDispose=Me(this,m,"f").event,c.set(this,this._register(new u.Emitter)),this.onDidChangeViewState=Me(this,c,"f").event,et(this,R,n,"f"),et(this,k,a,"f"),et(this,T,d,"f"),et(this,_,f.viewType,"f"),et(this,w,f.panelOptions,"f"),et(this,h,f.viewColumn,"f"),et(this,b,f.title,"f"),et(this,p,f.active,"f")}dispose(){Me(this,o,"f")||(et(this,o,!0,"f"),Me(this,m,"f").fire(),Me(this,k,"f").$disposeWebview(Me(this,R,"f")),Me(this,T,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Me(this,T,"f")}get viewType(){return this.assertNotDisposed(),Me(this,_,"f")}get title(){return this.assertNotDisposed(),Me(this,b,"f")}set title(n){this.assertNotDisposed(),Me(this,b,"f")!==n&&(et(this,b,n,"f"),Me(this,k,"f").$setTitle(Me(this,R,"f"),n))}get iconPath(){return this.assertNotDisposed(),Me(this,v,"f")}set iconPath(n){this.assertNotDisposed(),Me(this,v,"f")!==n&&(et(this,v,n,"f"),Me(this,k,"f").$setIconPath(Me(this,R,"f"),D.URI.isUri(n)?{light:n,dark:n}:n))}get options(){return Me(this,w,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Me(this,h,"f")=="number"&&Me(this,h,"f")<0))return Me(this,h,"f")}get active(){return this.assertNotDisposed(),Me(this,p,"f")}get visible(){return this.assertNotDisposed(),Me(this,g,"f")}_updateViewState(n){Me(this,o,"f")||(this.active!==n.active||this.visible!==n.visible||this.viewColumn!==n.viewColumn)&&(et(this,p,n.active,"f"),et(this,g,n.visible,"f"),et(this,h,n.viewColumn,"f"),Me(this,c,"f").fire({webviewPanel:this}))}reveal(n,a){this.assertNotDisposed(),Me(this,k,"f").$reveal(Me(this,R,"f"),{viewColumn:typeof n=="undefined"?void 0:y.ViewColumn.from(n),preserveFocus:!!a})}assertNotDisposed(){if(Me(this,o,"f"))throw new Error("Webview is disposed")}}R=new WeakMap,k=new WeakMap,_=new WeakMap,T=new WeakMap,w=new WeakMap,b=new WeakMap,v=new WeakMap,h=new WeakMap,g=new WeakMap,p=new WeakMap,o=new WeakMap,m=new WeakMap,c=new WeakMap;class s{constructor(n,a,d){this.webviews=a,this.workspace=d,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=n.getProxy(E.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,P.generateUuid)()}createWebviewPanel(n,a,d,f,S={}){const O=typeof f=="object"?f.viewColumn:f,U={viewColumn:y.ViewColumn.from(O),preserveFocus:typeof f=="object"&&!!f.preserveFocus},M=(0,C.shouldSerializeBuffersForPostMessage)(n),A=s.newHandle();this._proxy.$createWebviewPanel((0,C.toExtensionData)(n),A,a,{title:d,panelOptions:i(S),webviewOptions:(0,C.serializeWebviewOptions)(n,this.workspace,S),serializeBuffersForPostMessage:M},U);const B=this.webviews.createNewWebview(A,S,n);return this.createNewWebviewPanel(A,a,d,O,S,B,!0)}$onDidChangeWebviewPanelViewStates(n){const a=Object.keys(n);a.sort((d,f)=>{const S=n[d],O=n[f];return S.active?1:O.active?-1:+S.visible-+O.visible});for(const d of a){const f=this.getWebviewPanel(d);if(!f)continue;const S=n[d];f._updateViewState({active:S.active,visible:S.visible,viewColumn:y.ViewColumn.to(S.position)})}}async $onDidDisposeWebviewPanel(n){this.getWebviewPanel(n)?.dispose(),this._webviewPanels.delete(n),this.webviews.deleteWebview(n)}registerWebviewPanelSerializer(n,a,d){if(this._serializers.has(a))throw new Error(`Serializer for '${a}' already registered`);return this._serializers.set(a,{serializer:d,extension:n}),this._proxy.$registerSerializer(a,{serializeBuffersForPostMessage:(0,C.shouldSerializeBuffersForPostMessage)(n)}),new I.Disposable(()=>{this._serializers.delete(a),this._proxy.$unregisterSerializer(a)})}async $deserializeWebviewPanel(n,a,d,f){const S=this._serializers.get(a);if(!S)throw new Error(`No serializer found for '${a}'`);const{serializer:O,extension:U}=S,M=this.webviews.createNewWebview(n,d.webviewOptions,U),A=this.createNewWebviewPanel(n,a,d.title,f,d.panelOptions,M,d.active);await O.deserializeWebviewPanel(A,d.state)}createNewWebviewPanel(n,a,d,f,S,O,U){const M=new l(n,this._proxy,O,{viewType:a,title:d,viewColumn:f,panelOptions:S,active:U});return this._webviewPanels.set(n,M),M}getWebviewPanel(n){return this._webviewPanels.get(n)}}e.ExtHostWebviewPanels=s;function i(r){return{enableFindWidget:r.enableFindWidget,retainContextWhenHidden:r.retainContextWhenHidden}}});var et=this&&this.__classPrivateFieldSet||function(Z,e,u,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!D:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(Z,u):D?D.value=u:e.set(Z,u),u},Me=this&&this.__classPrivateFieldGet||function(Z,e,u,t){if(u==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?t:u==="a"?t.call(Z):t?t.value:e.get(Z)};define(De[265],Ie([1,0,4,6,70,27,16,5,7]),function(Z,e,u,t,D,P,y,C,E){"use strict";var I,R,k,_,T,w,b,v,h,g,p,o;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class m extends t.Disposable{constructor(s,i,r,n,a,d,f){super();I.set(this,void 0),R.set(this,void 0),k.set(this,void 0),_.set(this,void 0),T.set(this,void 0),w.set(this,!1),b.set(this,void 0),v.set(this,void 0),h.set(this,void 0),g.set(this,void 0),p.set(this,this._register(new u.Emitter)),this.onDidChangeVisibility=Me(this,p,"f").event,o.set(this,this._register(new u.Emitter)),this.onDidDispose=Me(this,o,"f").event,et(this,k,r,"f"),et(this,v,n,"f"),et(this,I,s,"f"),et(this,R,i,"f"),et(this,_,a,"f"),et(this,T,d,"f"),et(this,b,f,"f")}dispose(){Me(this,w,"f")||(et(this,w,!0,"f"),Me(this,o,"f").fire(),Me(this,_,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Me(this,v,"f")}set title(s){this.assertNotDisposed(),Me(this,v,"f")!==s&&(et(this,v,s,"f"),Me(this,R,"f").$setWebviewViewTitle(Me(this,I,"f"),s))}get description(){return this.assertNotDisposed(),Me(this,h,"f")}set description(s){this.assertNotDisposed(),Me(this,h,"f")!==s&&(et(this,h,s,"f"),Me(this,R,"f").$setWebviewViewDescription(Me(this,I,"f"),s))}get visible(){return Me(this,b,"f")}get webview(){return Me(this,_,"f")}get viewType(){return Me(this,k,"f")}_setVisible(s){s===Me(this,b,"f")||Me(this,w,"f")||(et(this,b,s,"f"),Me(this,p,"f").fire())}get badge(){return this.assertNotDisposed(),(0,P.checkProposedApiEnabled)(Me(this,T,"f"),"badges"),Me(this,g,"f")}set badge(s){this.assertNotDisposed(),(0,P.checkProposedApiEnabled)(Me(this,T,"f"),"badges"),!(s?.value===Me(this,g,"f")?.value&&s?.tooltip===Me(this,g,"f")?.tooltip)&&(et(this,g,y.ViewBadge.from(s),"f"),Me(this,R,"f").$setWebviewViewBadge(Me(this,I,"f"),s))}show(s){this.assertNotDisposed(),Me(this,R,"f").$show(Me(this,I,"f"),!!s)}assertNotDisposed(){if(Me(this,w,"f"))throw new Error("Webview is disposed")}}I=new WeakMap,R=new WeakMap,k=new WeakMap,_=new WeakMap,T=new WeakMap,w=new WeakMap,b=new WeakMap,v=new WeakMap,h=new WeakMap,g=new WeakMap,p=new WeakMap,o=new WeakMap;class c{constructor(s,i){this._extHostWebview=i,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=s.getProxy(C.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(s,i,r,n){if(this._viewProviders.has(i))throw new Error(`View provider for '${i}' already registered`);return this._viewProviders.set(i,{provider:r,extension:s}),this._proxy.$registerWebviewViewProvider((0,D.toExtensionData)(s),i,{retainContextWhenHidden:n?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,D.shouldSerializeBuffersForPostMessage)(s)}),new E.Disposable(()=>{this._viewProviders.delete(i),this._proxy.$unregisterWebviewViewProvider(i)})}async $resolveWebviewView(s,i,r,n,a){const d=this._viewProviders.get(i);if(!d)throw new Error(`No view provider found for '${i}'`);const{provider:f,extension:S}=d,O=this._extHostWebview.createNewWebview(s,{},S),U=new m(s,this._proxy,i,r,O,S,!0);this._webviewViews.set(s,U),await f.resolveWebviewView(U,{state:n},a)}async $onDidChangeWebviewViewVisibility(s,i){this.getWebviewView(s)._setVisible(i)}async $disposeWebviewView(s){const i=this.getWebviewView(s);this._webviewViews.delete(s),i.dispose(),this._extHostWebview.deleteWebview(s)}getWebviewView(s){const i=this._webviewViews.get(s);if(!i)throw new Error("No webview found");return i}}e.ExtHostWebviewViews=c}),define(De[137],Ie([1,0,4,5,2,12,8,3,15]),function(Z,e,u,t,D,P,y,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let I=class Zn{constructor(k){this._onDidChangeWindowState=new u.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Zn.InitialState,this._proxy=k.getProxy(t.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(_=>this.$onDidChangeWindowFocus(_))}get state(){return this._state}$onDidChangeWindowFocus(k){k!==this._state.focused&&(this._state={...this._state,focused:k},this._onDidChangeWindowState.fire(this._state))}openUri(k,_){let T;if(typeof k=="string"){T=k;try{k=D.URI.parse(k)}catch{return Promise.reject(`Invalid uri - '${k}'`)}}return(0,y.isFalsyOrWhitespace)(k.scheme)?Promise.reject("Invalid scheme - cannot be empty"):k.scheme===P.Schemas.command?Promise.reject(`Invalid scheme '${k.scheme}'`):this._proxy.$openUri(k,T,_)}async asExternalUri(k,_){if((0,y.isFalsyOrWhitespace)(k.scheme))return Promise.reject("Invalid scheme - cannot be empty");const T=await this._proxy.$asExternalUri(k,_);return D.URI.from(T)}};I.InitialState={focused:!0},I=je([xe(0,E.IExtHostRpcService)],I),e.ExtHostWindow=I,e.IExtHostWindow=(0,C.createDecorator)("IExtHostWindow")}),define(De[266],Ie([1,0,112,267,62,37,2,14,45]),function(Z,e,u,t,D,P,y,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class I{constructor(_,T,w){this._commands=_,this.logService=T,this._ipcHandlePath=w,this._server=t.createServer((b,v)=>this.onRequest(b,v)),this.setup().catch(b=>(T.error(b),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",_=>this.logService.error(_))}catch{this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(_,T){const w=(v,h)=>{T.writeHead(v,{"content-type":"application/json"}),T.end(JSON.stringify(h||null),g=>g&&this.logService.error(g))},b=[];_.setEncoding("utf8"),_.on("data",v=>b.push(v)),_.on("end",async()=>{try{const v=JSON.parse(b.join(""));let h;switch(v.type){case"open":h=await this.open(v);break;case"openExternal":h=await this.openExternal(v);break;case"status":h=await this.getStatus(v);break;case"extensionManagement":h=await this.manageExtensions(v);break;default:w(404,`Unknown message type: ${v.type}`);break}w(200,h)}catch(v){const h=v instanceof Error?v.message:JSON.stringify(v);w(500,h),this.logService.error("Error while processing pipe request",v)}})}async open(_){const{fileURIs:T,folderURIs:w,forceNewWindow:b,diffMode:v,mergeMode:h,addMode:g,forceReuseWindow:p,gotoLineMode:o,waitMarkerFilePath:m,remoteAuthority:c}=_,l=[];if(Array.isArray(w))for(const n of w)try{l.push({folderUri:y.URI.parse(n)})}catch{}if(Array.isArray(T))for(const n of T)try{(0,E.hasWorkspaceFileExtension)(n)?l.push({workspaceUri:y.URI.parse(n)}):l.push({fileUri:y.URI.parse(n)})}catch{}const s=m?y.URI.file(m):void 0,r={forceNewWindow:b,diffMode:v,mergeMode:h,addMode:g,gotoLineMode:o,forceReuseWindow:p,preferNewWindow:!p&&!s&&!g,waitMarkerFileURI:s,remoteAuthority:c};return this._commands.executeCommand("_remoteCLI.windowOpen",l,r),""}async openExternal(_){for(const T of _.uris){const w=y.URI.parse(T),b=w.scheme==="file"?w:T;await this._commands.executeCommand("_remoteCLI.openExternal",b)}}async manageExtensions(_){const T=b=>b?.map(v=>/\.vsix$/i.test(v)?y.URI.parse(v):v),w={list:_.list,install:T(_.install),uninstall:T(_.uninstall),force:_.force};return await this._commands.executeCommand("_remoteCLI.manageExtensions",w)}async getStatus(_){return await this._commands.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&D.existsSync(this._ipcHandlePath)&&D.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=I;let R=class extends I{constructor(_,T){super(_,T,(0,u.createRandomIPCHandle)())}};R=je([xe(0,P.IExtHostCommands),xe(1,C.ILogService)],R),e.CLIServer=R}),define(De[268],Ie([1,0,240,26,15]),function(Z,e,u,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;const P=1024*1024;let y=class extends u.AbstractExtHostConsoleForwarder{constructor(E,I){super(E,I);this._isMakingConsoleCall=!1,this._wrapStream("stderr","error"),this._wrapStream("stdout","log")}_nativeConsoleLogMessage(E,I,R){const k=E==="error"||E==="warn"?process.stderr:process.stdout;this._isMakingConsoleCall=!0,k.write(`
START_NATIVE_LOG
`),I.apply(console,R),k.write(`
END_NATIVE_LOG
`),this._isMakingConsoleCall=!1}_wrapStream(E,I){const R=process[E],k=R.write;let _="";Object.defineProperty(R,"write",{set:()=>{},get:()=>(T,w,b)=>{if(!this._isMakingConsoleCall){_+=T.toString(w);const v=_.length>P?_.length:_.lastIndexOf(`
`);v!==-1&&(console[I](_.slice(0,v)),_=_.slice(v+1))}k.call(R,T,w,b)}})}};y=je([xe(0,D.IExtHostRpcService),xe(1,t.IExtHostInitDataService)],y),e.ExtHostConsoleForwarder=y}),define(De[269],Ie([1,0,9,81,34,37,6,5,2,15]),function(Z,e,u,t,D,P,y,C,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let R=class extends y.Disposable{constructor(_,T){super();const w=_.getProxy(C.MainContext.MainThreadDownloadService);T.registerCommand(!1,"_workbench.downloadResource",async b=>{const v=E.URI.file((0,u.join)((0,t.tmpdir)(),(0,D.generateUuid)()));return await w.$download(b,v),v})}};R=je([xe(0,I.IExtHostRpcService),xe(1,P.IExtHostCommands)],R),e.ExtHostDownloadService=R}),define(De[270],Ie([1,0,135,12,193,34]),function(Z,e,u,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class y extends u.ExtHostLoggerService{doCreateLogger(E,I,R){return E.scheme===t.Schemas.file?new D.SpdLogLogger(R?.name||(0,P.generateUuid)(),E.fsPath,!R?.donotRotate,!!R?.donotUseFormatters,I):super.doCreateLogger(E,I,R)}}e.ExtHostLoggerService=y}),define(De[271],Ie([1,0,62,9,2,69,6,12,18,29]),function(Z,e,u,t,D,P,y,C,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class R extends P.ExtensionStoragePaths{constructor(){super(...arguments);this._workspaceStorageLock=null}async _getWorkspaceStorageURI(c){const l=await super._getWorkspaceStorageURI(c);if(l.scheme!==C.Schemas.file)return l;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${l.fsPath}.`),l;const s=l.fsPath;let i=0;do{let r;i===0?r=s:r=/[/\\]$/.test(s)?`${s.substr(0,s.length-1)}-${i}`:`${s}-${i}`,await k(r);const n=t.join(r,"vscode.lock"),a=await b(this._logService,n,!1);if(a)return this._workspaceStorageLock=a,process.on("exit",()=>{a.dispose()}),D.URI.file(r);i++}while(i<10);return l}onWillDeactivateAll(){this._workspaceStorageLock?.setWillRelease(6e3)}}e.ExtensionStoragePaths=R;async function k(m){try{await I.Promises.stat(m);return}catch{}try{await I.Promises.mkdir(m,{recursive:!0})}catch{}}const _=1e3,T=10*60*1e3;class w extends y.Disposable{constructor(c,l){super();this.logService=c,this.filename=l,this._timer=this._register(new E.IntervalTimer),this._timer.cancelAndSet(async()=>{const s=await v(c,l);(!s||s.pid!==process.pid)&&(c.info(`Lock '${l}': The lock was lost unexpectedly.`),this._timer.cancel());try{await I.Promises.utimes(l,new Date,new Date)}catch(i){c.error(i),c.info(`Lock '${l}': Could not update mtime.`)}},_)}dispose(){super.dispose();try{u.unlinkSync(this.filename)}catch{}}async setWillRelease(c){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${c} ms.`);try{const l={pid:process.pid,willReleaseAt:Date.now()+c};await I.Promises.writeFile(this.filename,JSON.stringify(l),{flag:"w"})}catch(l){this.logService.error(l)}}}async function b(m,c,l){try{const i={pid:process.pid,willReleaseAt:0};await I.Promises.writeFile(c,JSON.stringify(i),{flag:"wx"})}catch(i){m.error(i)}const s=await v(m,c);return!s||s.pid!==process.pid?l?(m.info(`Lock '${c}': Could not acquire lock, giving up.`),null):(m.info(`Lock '${c}': Could not acquire lock, checking if the file is stale.`),p(m,c)):(m.info(`Lock '${c}': Lock acquired.`),new w(m,c))}async function v(m,c){let l;try{l=await I.Promises.readFile(c)}catch(s){return m.error(s),null}try{return JSON.parse(String(l))}catch(s){return m.error(s),null}}async function h(m,c){let l;try{l=await I.Promises.stat(c)}catch(s){return m.error(s),0}return l.mtime.getTime()}function g(m){try{return process.kill(m,0),!0}catch{return!1}}async function p(m,c){const l=await v(m,c);if(!l)return m.info(`Lock '${c}': Could not read pid of lock holder.`),o(m,c);if(l.willReleaseAt){let a=l.willReleaseAt-Date.now();if(a<5e3){for(a>0?m.info(`Lock '${c}': The lockfile is scheduled to be released in ${a} ms.`):m.info(`Lock '${c}': The lockfile is scheduled to have been released.`);a>0;){if(await(0,E.timeout)(Math.min(100,a)),await h(m,c)===0)return o(m,c);a=l.willReleaseAt-Date.now()}return o(m,c)}}if(!g(l.pid))return m.info(`Lock '${c}': The pid ${l.pid} appears to be gone.`),o(m,c);const s=await h(m,c),i=Date.now()-s;if(i<=T)return m.info(`Lock '${c}': The lock does not look stale, elapsed: ${i} ms, giving up.`),null;m.info(`Lock '${c}': The lock looks stale, waiting for 2s.`),await(0,E.timeout)(2e3);const r=await h(m,c),n=Date.now()-r;return n<=T?(m.info(`Lock '${c}': The lock does not look stale, elapsed: ${n} ms, giving up.`),null):(m.info(`Lock '${c}': The lock looks stale even after waiting for 2s.`),o(m,c))}async function o(m,c){m.info(`Lock '${c}': Deleting a stale lock.`);try{await I.Promises.unlink(c)}catch{}return b(m,c,!0)}}),define(De[272],Ie([1,0,34,15,38]),function(Z,e,u,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let P=class extends D.BaseExtHostTerminalService{constructor(C){super(!0,C)}createTerminal(C,E,I){return this.createTerminalFromOptions({name:C,shellPath:E,shellArgs:I})}createTerminalFromOptions(C,E){const I=new D.ExtHostTerminal(this._proxy,(0,u.generateUuid)(),C,C.name);return this._terminals.push(I),I.create(C,this._serializeParentTerminal(C,E)),I.value}};P=je([xe(0,t.IExtHostRpcService)],P),e.ExtHostTerminalService=P}),define(De[273],Ie([1,0,5,15,176,6,26,2,44,22,29,7,11,53,4,123,94,14]),function(Z,e,u,t,D,P,y,C,E,I,R,k,_,T,w,b,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class g extends b.DisposableTunnel{}function p(a){const d=a.trim().split(`
`),f=[];return d.forEach(O=>{const U=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(O);U&&U.length>=3&&f.push({pid:parseInt(U[1],10),socket:parseInt(U[2],10)})}),f.reduce((O,U)=>(O[U.socket]=U,O),{})}e.getSockets=p;function o(...a){const d=[].concat(...a.map(c));return[...new Map(d.filter(f=>f.st==="0A").map(f=>{const S=f.local_address.split(":");return{socket:parseInt(f.inode,10),ip:m(S[0]),port:parseInt(S[1],16)}}).map(f=>[f.ip+":"+f.port,f])).values()]}e.loadListeningPorts=o;function m(a){let d="";if(a.length===8)for(let f=a.length-2;f>=0;f-=2)d+=parseInt(a.substr(f,2),16),f!==0&&(d+=".");else for(let f=a.length-4;f>=0;f-=4)d+=parseInt(a.substr(f,4),16).toString(16),f!==0&&(d+=":");return d}e.parseIpAddress=m;function c(a){const d=a.trim().split(`
`),f=d.shift().trim().split(/\s+/).filter(O=>O!=="rx_queue"&&O!=="tm->when");return d.map(O=>O.trim().split(/\s+/).reduce((U,M,A)=>(U[f[A]||A]=M,U),{}))}e.loadConnectionTable=c;function l(a){return!!a.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||a.indexOf("out/server-main.js")!==-1||a.indexOf("_productName=VSCode")!==-1}function s(a){const d=a.trim().split(`
`),f=[];return d.forEach(S=>{const O=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(S);O&&O.length>=4&&f.push({pid:parseInt(O[1],10),ppid:parseInt(O[2]),cmd:O[3]})}),f}e.getRootProcesses=s;async function i(a,d,f){const S=f.reduce((U,M)=>(U[M.pid]=M,U),{}),O=[];return a.forEach(({socket:U,ip:M,port:A})=>{const B=d[U]?d[U].pid:void 0,x=B?S[B]?.cmd:void 0;B&&x&&!l(x)&&O.push({host:M,port:A,detail:x,pid:B})}),O}e.findPorts=i;function r(a,d,f){const S=new Map,O=s(d);for(const U of a){const M=f.get(U.port);if(M){S.set(U.port,M);continue}const A=O.find(B=>B.cmd.includes(`${U.port}`));if(A){let B=A,x;do x=O.find(N=>N.ppid===B.pid),x&&(B=x);while(x);S.set(U.port,{host:U.ip,port:U.port,pid:B.pid,detail:B.cmd,ppid:B.ppid})}else S.set(U.port,{host:U.ip,port:U.port,ppid:Number.MAX_VALUE})}return S}e.tryFindRootPorts=r;let n=class extends P.Disposable{constructor(d,f,S){super();this.logService=S,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new w.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=d.getProxy(u.MainContext.MainThreadTunnelService),_.isLinux&&f.remote.isRemote&&f.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(d,f){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${d.identifier.value} called openTunnel API for ${f.remoteAddress.host}:${f.remoteAddress.port}.`);const S=await this._proxy.$openTunnel(f,d.displayName);if(S){const O=new g(S.remoteAddress,S.localAddress,()=>this._proxy.$closeTunnel(S.remoteAddress));return this._register(O),O}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(d){return Math.max(d*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(d,f){const S=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(S,{selector:d,provider:f}),this._proxy.$registerPortsAttributesProvider(d,S),new k.Disposable(()=>{this._portAttributesProviders.delete(S),this._proxy.$unregisterPortsAttributesProvider(S)})}async $providePortAttributes(d,f,S,O,U){const M=[];for(const B of d){const x=this._portAttributesProviders.get(B);if(!x)return[];M.push(...await Promise.all(f.map(async N=>x.provider.providePortAttributes(N,S,O,U))))}const A=M.filter(B=>!!B);return A.length>0?A.map(B=>({autoForwardAction:B.autoForwardAction,port:B.port})):[]}async $registerCandidateFinder(d){if(d&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=d;const f=new v.MovingAverage;let S;for(;this._candidateFindingEnabled;){const O=new Date().getTime(),U=(await this.findCandidatePorts()).filter(A=>(0,b.isLocalhost)(A.host)||(0,b.isAllInterfaces)(A.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${U.map(A=>A.port).join(", ")}`);const M=new Date().getTime()-O;f.update(M),(!S||JSON.stringify(S)!==JSON.stringify(U))&&(S=U,await this._proxy.$onFoundNewCandidates(S)),await new Promise(A=>setTimeout(()=>A(),this.calculateDelay(f.value)))}}async setTunnelFactory(d){if(d){if(d.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(d.candidatePortSource),d.showCandidatePort&&(this._showCandidatePort=d.showCandidatePort,this._proxy.$setCandidateFilter()),d.tunnelFactory){this._forwardPortProvider=d.tunnelFactory;let f=d.tunnelFeatures?.privacyOptions??[];d.tunnelFeatures?.public&&f.length===0&&(f=[{id:"private",label:D.localize(0,null),themeIcon:"lock"},{id:"public",label:D.localize(1,null),themeIcon:"eye"}]);const S=d.tunnelFeatures?{elevation:!!d.tunnelFeatures?.elevation,public:!!d.tunnelFeatures?.public,privacyOptions:f}:void 0;this._proxy.$setTunnelProvider(S)}}else this._forwardPortProvider=void 0;return(0,P.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(d,f){if(this._extensionTunnels.has(d.host)){const S=this._extensionTunnels.get(d.host);S.has(d.port)&&(f&&S.get(d.port).disposeListener.dispose(),await S.get(d.port).tunnel.dispose(),S.delete(d.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(d,f){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const S=this._forwardPortProvider(d,f);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),S!==void 0){const O=await S;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(d.remoteAddress.host)||this._extensionTunnels.set(d.remoteAddress.host,new Map);const U=this._register(O.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(O.remoteAddress))));return this._extensionTunnels.get(d.remoteAddress.host).set(d.remoteAddress.port,{tunnel:O,disposeListener:U}),T.TunnelDtoConverter.fromApiTunnel(O)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(d){const f=await Promise.all(d.map(O=>this._showCandidatePort(O.host,O.port,O.detail??""))),S=d.filter((O,U)=>f[U]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${d.map(O=>O.port).join(", ")} to ${S.map(O=>O.port).join(", ")}`),S}async findCandidatePorts(){let d="",f="";try{d=await R.Promises.readFile("/proc/net/tcp","utf8"),f=await R.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const S=o(d,f),O=await new Promise(X=>{(0,E.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(L,$,H)=>{X($)})}),U=p(O),M=await R.Promises.readdir("/proc"),A=[];for(const X of M)try{const L=Number(X),$=I.joinPath(C.URI.file("/proc"),X);if((await R.Promises.stat($.fsPath)).isDirectory()&&!isNaN(L)){const j=await R.Promises.readlink(I.joinPath($,"cwd").fsPath),J=await R.Promises.readFile(I.joinPath($,"cmdline").fsPath,"utf8");A.push({pid:L,cwd:j,cmd:J})}}catch{}const B=[],x=S.filter(X=>{const L=U[X.socket];return L||B.push(X),L}),N=i(x,U,A);let K;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${B.length}`),B.length>0){const X=await new Promise(L=>{(0,E.exec)("ps -F -A -l | grep root",($,H,j)=>{L(H)})});this._foundRootPorts=r(B,X,this._foundRootPorts),K=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${K.join(", ")}`)}return N.then(X=>K?X.concat(K):X)}};n=je([xe(0,t.IExtHostRpcService),xe(1,y.IExtHostInitDataService),xe(2,h.ILogService)],n),e.ExtHostTunnelService=n}),define(De[274],Ie([1,0,18,23,21,10,4,6,107,234,54]),function(Z,e,u,t,D,P,y,C,E,I,R){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function _(S,O){try{return JSON.stringify(S,O)}catch{return"null"}}const T="$$ref$$",w={[T]:-1};class b{constructor(O,U){this.jsonString=O,this.referencedBuffers=U}}function v(S,O=null,U=!1){const M=[];return{jsonString:(U?_:JSON.stringify)(S,(B,x)=>{if(typeof x=="undefined")return w;if(typeof x=="object"){if(x instanceof t.VSBuffer){const N=M.push(x)-1;return{[T]:N}}if(O)return O(B,x)}return x}),referencedBuffers:M}}e.stringifyJsonWithBufferRefs=v;function h(S,O,U){return JSON.parse(S,(M,A)=>{if(A){const B=A[T];if(typeof B=="number")return O[B];if(U&&A.$mid===1)return U.transformIncoming(A)}return A})}e.parseJsonAndRestoreBufferRefs=h;function g(S,O){return JSON.stringify(S,O)}function p(S){return S?(O,U)=>U&&U.$mid===1?S.transformOutgoing(U):U:null}var o;(function(S){S[S.LocalSide=0]="LocalSide",S[S.OtherSide=1]="OtherSide"})(o=e.RequestInitiator||(e.RequestInitiator={}));var m;(function(S){S[S.Responsive=0]="Responsive",S[S.Unresponsive=1]="Unresponsive"})(m=e.ResponsiveState||(e.ResponsiveState={}));const c=()=>{},l=Symbol.for("rpcProtocol"),s=Symbol.for("rpcProxy");class i extends C.Disposable{constructor(O,U=null,M=null){super();this[k]=!0,this._onDidChangeResponsiveState=this._register(new y.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=O,this._logger=U,this._uriTransformer=M,this._uriReplacer=p(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let A=0,B=R.ProxyIdentifier.count;A<B;A++)this._locals[A]=null,this._proxies[A]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new u.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(A=>this._receiveOneMessage(A))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(O=>{this._pendingRPCReplies[O].resolveErr(P.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(O){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(O){this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(O){this._responsiveState!==O&&(this._responsiveState=O,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(O){return this._uriTransformer?(0,E.transformIncomingURIs)(O,this._uriTransformer):O}getProxy(O){const{nid:U,sid:M}=O;return this._proxies[U]||(this._proxies[U]=this._createProxy(U,M)),this._proxies[U]}_createProxy(O,U){const M={get:(A,B)=>(typeof B=="string"&&!A[B]&&B.charCodeAt(0)===36&&(A[B]=(...x)=>this._remoteCall(O,B,x)),B===s?U:A[B])};return new Proxy(Object.create(null),M)}set(O,U){return this._locals[O.nid]=U,U}assertRegistered(O){for(let U=0,M=O.length;U<M;U++){const A=O[U];if(!this._locals[A.nid])throw new Error(`Missing proxy instance ${A.sid}`)}}_receiveOneMessage(O){if(this._isDisposed)return;const U=O.byteLength,M=r.read(O,0),A=M.readUInt8(),B=M.readUInt32();switch(A){case 1:case 2:{let{rpcId:x,method:N,args:K}=a.deserializeRequestJSONArgs(M);this._uriTransformer&&(K=(0,E.transformIncomingURIs)(K,this._uriTransformer)),this._receiveRequest(U,B,x,N,K,A===2);break}case 3:case 4:{let{rpcId:x,method:N,args:K}=a.deserializeRequestMixedArgs(M);this._uriTransformer&&(K=(0,E.transformIncomingURIs)(K,this._uriTransformer)),this._receiveRequest(U,B,x,N,K,A===4);break}case 5:{this._logger?.logIncoming(U,B,0,"ack"),this._onDidReceiveAcknowledge(B);break}case 6:{this._receiveCancel(U,B);break}case 7:{this._receiveReply(U,B,void 0);break}case 9:{let x=a.deserializeReplyOKJSON(M);this._uriTransformer&&(x=(0,E.transformIncomingURIs)(x,this._uriTransformer)),this._receiveReply(U,B,x);break}case 10:{const x=a.deserializeReplyOKJSONWithBuffers(M,this._uriTransformer);this._receiveReply(U,B,x);break}case 8:{const x=a.deserializeReplyOKVSBuffer(M);this._receiveReply(U,B,x);break}case 11:{let x=a.deserializeReplyErrError(M);this._uriTransformer&&(x=(0,E.transformIncomingURIs)(x,this._uriTransformer)),this._receiveReplyErr(U,B,x);break}case 12:{this._receiveReplyErr(U,B,void 0);break}default:console.error("received unexpected message"),console.error(O)}}_receiveRequest(O,U,M,A,B,x){this._logger?.logIncoming(O,U,1,`receiveRequest ${(0,R.getStringIdentifierForProxy)(M)}.${A}(`,B);const N=String(U);let K,X;if(x){const $=new D.CancellationTokenSource;B.push($.token),K=this._invokeHandler(M,A,B),X=()=>$.cancel()}else K=this._invokeHandler(M,A,B),X=c;this._cancelInvokedHandlers[N]=X;const L=a.serializeAcknowledged(U);this._logger?.logOutgoing(L.byteLength,U,1,"ack"),this._protocol.send(L),K.then($=>{delete this._cancelInvokedHandlers[N];const H=a.serializeReplyOK(U,$,this._uriReplacer);this._logger?.logOutgoing(H.byteLength,U,1,"reply:",$),this._protocol.send(H)},$=>{delete this._cancelInvokedHandlers[N];const H=a.serializeReplyErr(U,$);this._logger?.logOutgoing(H.byteLength,U,1,"replyErr:",$),this._protocol.send(H)})}_receiveCancel(O,U){this._logger?.logIncoming(O,U,1,"receiveCancel");const M=String(U);this._cancelInvokedHandlers[M]?.()}_receiveReply(O,U,M){this._logger?.logIncoming(O,U,0,"receiveReply:",M);const A=String(U);if(!this._pendingRPCReplies.hasOwnProperty(A))return;const B=this._pendingRPCReplies[A];delete this._pendingRPCReplies[A],B.resolveOk(M)}_receiveReplyErr(O,U,M){this._logger?.logIncoming(O,U,0,"receiveReplyErr:",M);const A=String(U);if(!this._pendingRPCReplies.hasOwnProperty(A))return;const B=this._pendingRPCReplies[A];delete this._pendingRPCReplies[A];let x;M&&(M.$isError?(x=new Error,x.name=M.name,x.message=M.message,x.stack=M.stack):x=M),B.resolveErr(x)}_invokeHandler(O,U,M){try{return Promise.resolve(this._doInvokeHandler(O,U,M))}catch(A){return Promise.reject(A)}}_doInvokeHandler(O,U,M){const A=this._locals[O];if(!A)throw new Error("Unknown actor "+(0,R.getStringIdentifierForProxy)(O));const B=A[U];if(typeof B!="function")throw new Error("Unknown method "+U+" on actor "+(0,R.getStringIdentifierForProxy)(O));return B.apply(A,M)}_remoteCall(O,U,M){if(this._isDisposed)return new I.CanceledLazyPromise;let A=null;if(M.length>0&&D.CancellationToken.isCancellationToken(M[M.length-1])&&(A=M.pop()),A&&A.isCancellationRequested)return Promise.reject(P.canceled());const B=a.serializeRequestArguments(M,this._uriReplacer),x=++this._lastMessageId,N=String(x),K=new I.LazyPromise;A&&A.onCancellationRequested(()=>{const L=a.serializeCancel(x);this._logger?.logOutgoing(L.byteLength,x,0,"cancel"),this._protocol.send(a.serializeCancel(x))}),this._pendingRPCReplies[N]=K,this._onWillSendRequest(x);const X=a.serializeRequest(x,O,U,B,!!A);return this._logger?.logOutgoing(X.byteLength,x,0,`request: ${(0,R.getStringIdentifierForProxy)(O)}.${U}(`,M),this._protocol.send(X),K}}e.RPCProtocol=i,k=l,i.UNRESPONSIVE_TIME=3*1e3;class r{constructor(O,U){this._buff=O,this._offset=U}static alloc(O,U,M){const A=new r(t.VSBuffer.alloc(M+1+4),0);return A.writeUInt8(O),A.writeUInt32(U),A}static read(O,U){return new r(O,U)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(O){this._buff.writeUInt8(O,this._offset),this._offset+=1}readUInt8(){const O=this._buff.readUInt8(this._offset);return this._offset+=1,O}writeUInt32(O){this._buff.writeUInt32BE(O,this._offset),this._offset+=4}readUInt32(){const O=this._buff.readUInt32BE(this._offset);return this._offset+=4,O}static sizeShortString(O){return 1+O.byteLength}writeShortString(O){this._buff.writeUInt8(O.byteLength,this._offset),this._offset+=1,this._buff.set(O,this._offset),this._offset+=O.byteLength}readShortString(){const O=this._buff.readUInt8(this._offset);this._offset+=1;const M=this._buff.slice(this._offset,this._offset+O).toString();return this._offset+=O,M}static sizeLongString(O){return 4+O.byteLength}writeLongString(O){this._buff.writeUInt32BE(O.byteLength,this._offset),this._offset+=4,this._buff.set(O,this._offset),this._offset+=O.byteLength}readLongString(){const O=this._buff.readUInt32BE(this._offset);this._offset+=4;const M=this._buff.slice(this._offset,this._offset+O).toString();return this._offset+=O,M}writeBuffer(O){this._buff.writeUInt32BE(O.byteLength,this._offset),this._offset+=4,this._buff.set(O,this._offset),this._offset+=O.byteLength}static sizeVSBuffer(O){return 4+O.byteLength}writeVSBuffer(O){this._buff.writeUInt32BE(O.byteLength,this._offset),this._offset+=4,this._buff.set(O,this._offset),this._offset+=O.byteLength}readVSBuffer(){const O=this._buff.readUInt32BE(this._offset);this._offset+=4;const U=this._buff.slice(this._offset,this._offset+O);return this._offset+=O,U}static sizeMixedArray(O){let U=0;U+=1;for(let M=0,A=O.length;M<A;M++){const B=O[M];switch(U+=1,B.type){case 1:U+=this.sizeLongString(B.value);break;case 2:U+=this.sizeVSBuffer(B.value);break;case 3:U+=this.sizeUInt32,U+=this.sizeLongString(B.value);for(let x=0;x<B.buffers.length;++x)U+=this.sizeVSBuffer(B.buffers[x]);break;case 4:break}}return U}writeMixedArray(O){this._buff.writeUInt8(O.length,this._offset),this._offset+=1;for(let U=0,M=O.length;U<M;U++){const A=O[U];switch(A.type){case 1:this.writeUInt8(1),this.writeLongString(A.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(A.value);break;case 3:this.writeUInt8(3),this.writeUInt32(A.buffers.length),this.writeLongString(A.value);for(let B=0;B<A.buffers.length;++B)this.writeBuffer(A.buffers[B]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const O=this._buff.readUInt8(this._offset);this._offset+=1;const U=new Array(O);for(let M=0;M<O;M++)switch(this.readUInt8()){case 1:U[M]=this.readLongString();break;case 2:U[M]=this.readVSBuffer();break;case 3:{const B=this.readUInt32(),x=this.readLongString(),N=[];for(let K=0;K<B;++K)N.push(this.readVSBuffer());U[M]=new R.SerializableObjectWithBuffers(h(x,N,null));break}case 4:U[M]=void 0;break}return U}}r.sizeUInt32=4;var n;(function(S){S[S.Simple=0]="Simple",S[S.Mixed=1]="Mixed"})(n||(n={}));class a{static _useMixedArgSerialization(O){for(let U=0,M=O.length;U<M;U++)if(O[U]instanceof t.VSBuffer||O[U]instanceof R.SerializableObjectWithBuffers||typeof O[U]=="undefined")return!0;return!1}static serializeRequestArguments(O,U){if(this._useMixedArgSerialization(O)){const M=[];for(let A=0,B=O.length;A<B;A++){const x=O[A];if(x instanceof t.VSBuffer)M[A]={type:2,value:x};else if(typeof x=="undefined")M[A]={type:4};else if(x instanceof R.SerializableObjectWithBuffers){const{jsonString:N,referencedBuffers:K}=v(x.value,U);M[A]={type:3,value:t.VSBuffer.fromString(N),buffers:K}}else M[A]={type:1,value:t.VSBuffer.fromString(g(x,U))}}return{type:1,args:M}}return{type:0,args:g(O,U)}}static serializeRequest(O,U,M,A,B){switch(A.type){case 0:return this._requestJSONArgs(O,U,M,A.args,B);case 1:return this._requestMixedArgs(O,U,M,A.args,B)}}static _requestJSONArgs(O,U,M,A,B){const x=t.VSBuffer.fromString(M),N=t.VSBuffer.fromString(A);let K=0;K+=r.sizeUInt8(),K+=r.sizeShortString(x),K+=r.sizeLongString(N);const X=r.alloc(B?2:1,O,K);return X.writeUInt8(U),X.writeShortString(x),X.writeLongString(N),X.buffer}static deserializeRequestJSONArgs(O){const U=O.readUInt8(),M=O.readShortString(),A=O.readLongString();return{rpcId:U,method:M,args:JSON.parse(A)}}static _requestMixedArgs(O,U,M,A,B){const x=t.VSBuffer.fromString(M);let N=0;N+=r.sizeUInt8(),N+=r.sizeShortString(x),N+=r.sizeMixedArray(A);const K=r.alloc(B?4:3,O,N);return K.writeUInt8(U),K.writeShortString(x),K.writeMixedArray(A),K.buffer}static deserializeRequestMixedArgs(O){const U=O.readUInt8(),M=O.readShortString(),A=O.readMixedArray(),B=new Array(A.length);for(let x=0,N=A.length;x<N;x++){const K=A[x];typeof K=="string"?B[x]=JSON.parse(K):B[x]=K}return{rpcId:U,method:M,args:B}}static serializeAcknowledged(O){return r.alloc(5,O,0).buffer}static serializeCancel(O){return r.alloc(6,O,0).buffer}static serializeReplyOK(O,U,M){if(typeof U=="undefined")return this._serializeReplyOKEmpty(O);if(U instanceof t.VSBuffer)return this._serializeReplyOKVSBuffer(O,U);if(U instanceof R.SerializableObjectWithBuffers){const{jsonString:A,referencedBuffers:B}=v(U.value,M,!0);return this._serializeReplyOKJSONWithBuffers(O,A,B)}else return this._serializeReplyOKJSON(O,_(U,M))}static _serializeReplyOKEmpty(O){return r.alloc(7,O,0).buffer}static _serializeReplyOKVSBuffer(O,U){let M=0;M+=r.sizeVSBuffer(U);const A=r.alloc(8,O,M);return A.writeVSBuffer(U),A.buffer}static deserializeReplyOKVSBuffer(O){return O.readVSBuffer()}static _serializeReplyOKJSON(O,U){const M=t.VSBuffer.fromString(U);let A=0;A+=r.sizeLongString(M);const B=r.alloc(9,O,A);return B.writeLongString(M),B.buffer}static _serializeReplyOKJSONWithBuffers(O,U,M){const A=t.VSBuffer.fromString(U);let B=0;B+=r.sizeUInt32,B+=r.sizeLongString(A);for(const N of M)B+=r.sizeVSBuffer(N);const x=r.alloc(10,O,B);x.writeUInt32(M.length),x.writeLongString(A);for(const N of M)x.writeBuffer(N);return x.buffer}static deserializeReplyOKJSON(O){const U=O.readLongString();return JSON.parse(U)}static deserializeReplyOKJSONWithBuffers(O,U){const M=O.readUInt32(),A=O.readLongString(),B=[];for(let x=0;x<M;++x)B.push(O.readVSBuffer());return new R.SerializableObjectWithBuffers(h(A,B,U))}static serializeReplyErr(O,U){const M=U?_(P.transformErrorForSerialization(U),null):void 0;if(typeof M!="string")return this._serializeReplyErrEmpty(O);const A=t.VSBuffer.fromString(M);let B=0;B+=r.sizeLongString(A);const x=r.alloc(11,O,B);return x.writeLongString(A),x.buffer}static deserializeReplyErrError(O){const U=O.readLongString();return JSON.parse(U)}static _serializeReplyErrEmpty(O){return r.alloc(12,O,0).buffer}}var d;(function(S){S[S.RequestJSONArgs=1]="RequestJSONArgs",S[S.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",S[S.RequestMixedArgs=3]="RequestMixedArgs",S[S.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",S[S.Acknowledged=5]="Acknowledged",S[S.Cancel=6]="Cancel",S[S.ReplyOKEmpty=7]="ReplyOKEmpty",S[S.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",S[S.ReplyOKJSON=9]="ReplyOKJSON",S[S.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",S[S.ReplyErrError=11]="ReplyErrError",S[S.ReplyErrEmpty=12]="ReplyErrEmpty"})(d||(d={}));var f;(function(S){S[S.String=1]="String",S[S.VSBuffer=2]="VSBuffer",S[S.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",S[S.Undefined=4]="Undefined"})(f||(f={}))}),define(De[275],Ie([1,0,4,43,52,3,42,10,18]),function(Z,e,u,t,D,P,y,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerLogChannel=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new D.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new D.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new D.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,P.createDecorator)(e.OUTPUT_SERVICE_ID);var I;(function(T){T[T.Append=1]="Append",T[T.Replace=2]="Replace",T[T.Clear=3]="Clear"})(I=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class R{constructor(){this.channels=new Map,this._onDidRegisterChannel=new u.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new u.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(w){this.channels.has(w.id)||(this.channels.set(w.id,w),this._onDidRegisterChannel.fire(w.id))}getChannels(){const w=[];return this.channels.forEach(b=>w.push(b)),w}getChannel(w){return this.channels.get(w)}removeChannel(w){this.channels.delete(w),this._onDidRemoveChannel.fire(w)}}t.Registry.add(e.Extensions.OutputChannels,new R);function k(T,w,b,v,h){return(0,E.createCancelablePromise)(async g=>{await(0,y.whenProviderRegistered)(b,v);const p=t.Registry.as(e.Extensions.OutputChannels);try{await _(b,1,v,h,g),p.registerChannel({id:T,label:w,file:b,log:!0})}catch(o){(0,C.isCancellationError)(o)||h.error("Error while registering log channel",b.toString(),(0,C.getErrorMessage)(o))}})}e.registerLogChannel=k;async function _(T,w,b,v,h){if(!await b.exists(T)){if(h.isCancellationRequested)throw new C.CancellationError;if(w>10)throw new Error("Timed out while waiting for file to be created");v.debug("[Registering Log Channel] File does not exist. Waiting for 1s to retry.",T.toString()),await(0,E.timeout)(1e3,h),await _(T,w+1,b,v,h)}}}),define(De[138],Ie([1,0,5,6,3,15,14,275,68,26,46,151,23,13]),function(Z,e,u,t,D,P,y,C,E,I,R,k,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class w extends t.Disposable{constructor(h,g,p,o){super();this.id=h,this.name=g,this.logger=p,this.proxy=o,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(h){this.append(h+`
`)}append(h){this.write(h),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,C.OutputChannelUpdateMode.Append))}clear(){const h=this.offset;this.logger.flush(),this.proxy.$update(this.id,C.OutputChannelUpdateMode.Clear,h)}replace(h){const g=this.offset;this.write(h),this.proxy.$update(this.id,C.OutputChannelUpdateMode.Replace,g),this.visible&&this.logger.flush()}show(h,g){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof h=="boolean"?h:g))}hide(){this.proxy.$close(this.id)}write(h){this.offset+=_.VSBuffer.fromString(h).byteLength,this.logger.info(h)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=w;let b=class{constructor(h,g,p,o,m){this.extHostFileSystem=p,this.extHostFileSystemInfo=o,this.loggerService=m,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=h.getProxy(u.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(g.logsLocation,`output_logging_${(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(h){this.visibleChannelId=h;for(const[g,p]of this.channels)p.visible=g===this.visibleChannelId}createOutputChannel(h,g,p){if(h=h.trim(),!h)throw new Error("illegal argument `name`. must not be falsy");if((0,T.isString)(g)&&!g.trim())throw new Error("illegal argument `languageId`. must not be empty");const o=this.doCreateOutputChannel(h,g,p);return o.then(m=>{this.channels.set(m.id,m),m.visible=m.id===this.visibleChannelId}),this.createExtHostOutputChannel(h,o)}async doCreateOutputChannel(h,g,p){const o=await this.createOutputDirectory(),m=this.extHostFileSystemInfo.extUri.joinPath(o,`${this.namePool++}-${h.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),c=this.loggerService.createLogger(m,{always:!0,donotRotate:!0,donotUseFormatters:!0}),l=await this.proxy.$register(h,!1,m,g,p.identifier.value);return new w(l,h,c,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(h,g){let p=!1;const o=()=>{if(p)throw new Error("Channel has been closed")};return{get name(){return h},append(m){o(),g.then(c=>c.append(m))},appendLine(m){o(),g.then(c=>c.appendLine(m))},clear(){o(),g.then(m=>m.clear())},replace(m){o(),g.then(c=>c.replace(m))},show(m,c){o(),g.then(l=>l.show(m,c))},hide(){o(),g.then(m=>m.hide())},dispose(){p=!0,g.then(m=>m.dispose())}}}};b=je([xe(0,P.IExtHostRpcService),xe(1,I.IExtHostInitDataService),xe(2,E.IExtHostConsumerFileSystem),xe(3,R.IExtHostFileSystemInfo),xe(4,y.ILoggerService)],b),e.ExtHostOutputService=b,e.IExtHostOutputService=(0,D.createDecorator)("IExtHostOutputService")}),define(De[276],Ie([1,0,3]),function(Z,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,u.createDecorator)("remoteAgentService")}),define(De[277],Ie([1,0,31,12,9,11,22,2,3,202,45,225,276]),function(Z,e,u,t,D,P,y,C,E,I,R,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,E.createDecorator)("pathService");let T=class ei{constructor(b,v,h,g){this.localUserHome=b,this.remoteAgentService=v,this.environmentService=h,this.contextService=g,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||P.OS)(),this.resolveUserHome=(async()=>{const p=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=p?.userHome??b})()}hasValidBasename(b,v,h){return typeof v=="string"||typeof v=="undefined"?this.resolveOS.then(g=>this.doHasValidBasename(b,g,v)):this.doHasValidBasename(b,v,h)}doHasValidBasename(b,v,h){return b.scheme===t.Schemas.file||b.scheme===t.Schemas.vscodeRemote?(0,u.isValidBasename)(h??(0,y.basename)(b),v===1):!0}get defaultUriScheme(){return ei.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(b,v){if(b.remoteAuthority)return t.Schemas.vscodeRemote;const h=(0,I.getVirtualWorkspaceScheme)(v.getWorkspace());if(h)return h;const g=v.getWorkspace().folders[0];if(g)return g.uri.scheme;const p=v.getWorkspace().configuration;return p?p.scheme:t.Schemas.file}userHome(b){return b?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(b=>b===1?D.win32:D.posix)}async fileURI(b){let v="";if(await this.resolveOS===1&&(b=b.replace(/\\/g,"/")),b[0]==="/"&&b[1]==="/"){const g=b.indexOf("/",2);g===-1?(v=b.substring(2),b="/"):(v=b.substring(2,g),b=b.substring(g)||"/")}return C.URI.from({scheme:t.Schemas.file,authority:v,path:b,query:"",fragment:""})}};T=je([xe(1,_.IRemoteAgentService),xe(2,k.IWorkbenchEnvironmentService),xe(3,R.IWorkspaceContextService)],T),e.AbstractPathService=T}),define(De[71],Ie([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class u{constructor(y,C){this.line=y,this.character=C}isBefore(y){return!1}isBeforeOrEqual(y){return!1}isAfter(y){return!1}isAfterOrEqual(y){return!1}isEqual(y){return!1}compareTo(y){return 0}translate(y,C){return new u(0,0)}with(y){return new u(0,0)}}e.Position=u;class t{constructor(y,C,E,I){this.isEmpty=!1,this.isSingleLine=!1,this.start=new u(y,C),this.end=new u(E,I)}contains(y){return!1}isEqual(y){return!1}intersection(y){}union(y){return new t(0,0,0,0)}with(y){return new t(0,0,0,0)}}e.Range=t;var D;(function(P){P[P.Information=1]="Information",P[P.Warning=2]="Warning"})(D=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(De[30],Ie([1,0,17,36,24,31,8,3,9,10,71,18]),function(Z,e,u,t,D,P,y,C,E,I,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const _="\u27EA ",T=" characters skipped \u27EB",w=(_.length+T.length+5)*2;e.ISearchService=(0,C.createDecorator)("searchService");var b;(function(j){j[j.file=0]="file",j[j.text=1]="text"})(b=e.SearchProviderType||(e.SearchProviderType={}));var v;(function(j){j[j.File=1]="File",j[j.Text=2]="Text"})(v=e.QueryType||(e.QueryType={}));function h(j){return!!j.preview}e.resultIsMatch=h;function g(j){return!!j.resource}e.isFileMatch=g;function p(j){return!!j.message}e.isProgressMessage=p;var o;(function(j){j[j.Normal=0]="Normal",j[j.NewSearchStarted=1]="NewSearchStarted"})(o=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class m{constructor(J){this.resource=J,this.results=[]}}e.FileMatch=m;class c{constructor(J,Y,he){this.ranges=Y;const ve=Array.isArray(Y)?Y:[Y];if(he&&he.matchLines===1&&l(ve)){J=(0,y.getNLines)(J,he.matchLines);let ne="",pe=0,Ee=0;const ke=Math.floor(he.charsPerLine/5),Oe=[];for(const Be of ve){const ae=Math.max(Be.startColumn-ke,0),de=Be.startColumn+he.charsPerLine;if(ae>Ee+ke+w){const me=_+(ae-Ee)+T;ne+=me+J.slice(ae,de),pe+=ae-(Ee+me.length)}else ne+=J.slice(Ee,de);Oe.push(new i(0,Be.startColumn-pe,Be.endColumn-pe)),Ee=de}this.preview={text:ne,matches:Array.isArray(this.ranges)?Oe:Oe[0]}}else{const ne=Array.isArray(Y)?Y[0].startLineNumber:Y.startLineNumber;this.preview={text:J,matches:(0,u.mapArrayOrNot)(Y,pe=>new s(pe.startLineNumber-ne,pe.startColumn,pe.endLineNumber-ne,pe.endColumn))}}}}e.TextSearchMatch=c;function l(j){const J=j[0].startLineNumber;for(const Y of j)if(Y.startLineNumber!==J||Y.endLineNumber!==J)return!1;return!0}class s{constructor(J,Y,he,ve){this.startLineNumber=J,this.startColumn=Y,this.endLineNumber=he,this.endColumn=ve}}e.SearchRange=s;class i extends s{constructor(J,Y,he){super(J,Y,J,he)}}e.OneLineRange=i;var r;(function(j){j.Default="default",j.FileNames="fileNames",j.Type="type",j.Modified="modified",j.CountDescending="countDescending",j.CountAscending="countAscending"})(r=e.SearchSortOrder||(e.SearchSortOrder={}));function n(j,J=!0){const Y=j&&j.files&&j.files.exclude,he=J&&j&&j.search&&j.search.exclude;if(!Y&&!he)return;if(!Y||!he)return Y||he;let ve=Object.create(null);return ve=D.mixin(ve,D.deepClone(Y)),ve=D.mixin(ve,D.deepClone(he),!0),ve}e.getExcludes=n;function a(j,J){return j.excludePattern&&t.match(j.excludePattern,J)?!1:j.includePattern||j.usingSearchPaths?j.includePattern&&t.match(j.includePattern,J)?!0:j.usingSearchPaths?!!j.folderQueries&&j.folderQueries.some(Y=>{const he=Y.folder.fsPath;if(P.isEqualOrParent(J,he)){const ve=E.relative(he,J);return!Y.includePattern||!!t.match(Y.includePattern,ve)}else return!1}):!1:!0}e.pathIncludedInQuery=a;var d;(function(j){j[j.unknownEncoding=1]="unknownEncoding",j[j.regexParseError=2]="regexParseError",j[j.globParseError=3]="globParseError",j[j.invalidLiteral=4]="invalidLiteral",j[j.rgProcessError=5]="rgProcessError",j[j.other=6]="other",j[j.canceled=7]="canceled"})(d=e.SearchErrorCode||(e.SearchErrorCode={}));class f extends Error{constructor(J,Y){super(J);this.code=Y}}e.SearchError=f;function S(j){const J=j.message;if((0,I.isCancellationError)(j))return new f(J,d.canceled);try{const Y=JSON.parse(J);return new f(Y.message,Y.code)}catch{return new f(J,d.other)}}e.deserializeSearchError=S;function O(j){const J={message:j.message,code:j.code};return new Error(JSON.stringify(J))}e.serializeSearchError=O;function U(j){return j.type==="error"?!0:j.type==="success"}e.isSerializedSearchComplete=U;function M(j){return j.type==="success"}e.isSerializedSearchSuccess=M;function A(j){return!!j.path}e.isSerializedFileMatch=A;function B(j,J){const Y=j.searchPath?j.searchPath:j.relativePath;return(0,y.fuzzyContains)(Y,J)}e.isFilePatternMatch=B;class x{constructor(J){this.path=J,this.results=[]}addMatch(J){this.results.push(J)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=x;function N(j,J){const Y={...j||{},...J||{}};return Object.keys(Y).filter(he=>{const ve=Y[he];return typeof ve=="boolean"&&ve})}e.resolvePatternsForProvider=N;class K{constructor(J,Y){this._parsedIncludeExpression=null,this._excludeExpression={...J.excludePattern||{},...Y.excludePattern||{}},this._parsedExcludeExpression=t.parse(this._excludeExpression);let he=J.includePattern;Y.includePattern&&(he?he={...he,...Y.includePattern}:he=Y.includePattern),he&&(this._parsedIncludeExpression=t.parse(he))}matchesExcludesSync(J,Y,he){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(J,Y,he))}includedInQuerySync(J,Y,he){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(J,Y,he)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(J,Y,he))}includedInQuery(J,Y,he){const ve=this._parsedExcludeExpression(J,Y,he),ne=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(J,Y,he):!0;return(0,k.isThenable)(ve)?ve.then(pe=>pe?!1:ne()):ne()}hasSiblingExcludeClauses(){return X(this._excludeExpression)}}e.QueryGlobTester=K;function X(j){for(const J in j)if(typeof j[J]!="boolean")return!0;return!1}function L(j){if(!j)return;let J;return Y=>(J||(J=(j()||Promise.resolve([])).then(he=>he?H(he):{})),J.then(he=>!!he[Y]))}e.hasSiblingPromiseFn=L;function $(j){if(!j)return;let J;return Y=>{if(!J){const he=j();J=he?H(he):{}}return!!J[Y]}}e.hasSiblingFn=$;function H(j){const J={};for(const Y of j)J[Y]=!0;return J}}),define(De[32],Ie([1,0,17,18,21,4,25,12,94,22,8,13,2,174,3,14,194,45,46,26,15,16,7,30,5]),function(Z,e,u,t,D,P,y,C,E,I,R,k,_,T,w,b,v,h,g,p,o,m,c,l,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function i(U,M,A){return new I.ExtUri(B=>d(B,A)).isEqual(U,M)}function r(U,M,A){return i(U.uri,M.uri,A)?0:(0,R.compare)(U.uri.toString(),M.uri.toString())}function n(U,M,A){return U.index!==M.index?U.index<M.index?-1:1:i(U.uri,M.uri,A)?(0,R.compare)(U.name,M.name):(0,R.compare)(U.uri.toString(),M.uri.toString())}function a(U,M,A,B){const x=U.slice(0).sort((K,X)=>A(K,X,B)),N=M.slice(0).sort((K,X)=>A(K,X,B));return(0,u.delta)(x,N,(K,X)=>A(K,X,B))}function d(U,M){const A=M.getCapabilities(U.scheme);return!(A&&A&1024)}class f extends h.Workspace{constructor(M,A,B,x,N,K,X){super(M,B.map(L=>new h.WorkspaceFolder(L)),x,N,X);this._name=A,this._isUntitled=K,this._workspaceFolders=[],this._structure=y.TernarySearchTree.forUris(X),B.forEach(L=>{this._workspaceFolders.push(L),this._structure.set(L.uri,L)})}static toExtHostWorkspace(M,A,B,x){if(!M)return{workspace:null,added:[],removed:[]};const{id:N,name:K,folders:X,configuration:L,transient:$,isUntitled:H}=M,j=[],J=A;A?X.forEach((ne,pe)=>{const Ee=_.URI.revive(ne.uri),ke=f._findFolder(B||A,Ee,x);ke?(ke.name=ne.name,ke.index=ne.index,j.push(ke)):j.push({uri:Ee,name:ne.name,index:pe})}):j.push(...X.map(({uri:ne,name:pe,index:Ee})=>({uri:_.URI.revive(ne),name:pe,index:Ee}))),j.sort((ne,pe)=>ne.index<pe.index?-1:1);const Y=new f(N,K,j,!!$,L?_.URI.revive(L):null,!!H,ne=>d(ne,x)),{added:he,removed:ve}=a(J?J.workspaceFolders:[],Y.workspaceFolders,r,x);return{workspace:Y,added:he,removed:ve}}static _findFolder(M,A,B){for(let x=0;x<M.folders.length;x++){const N=M.workspaceFolders[x];if(i(N.uri,A,B))return N}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(M,A){return A&&this._structure.get(M)&&(M=(0,I.dirname)(M)),this._structure.findSubstr(M)}resolveWorkspaceFolder(M){return this._structure.get(M)}}let S=class{constructor(M,A,B,x){this._onDidChangeWorkspace=new P.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new P.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=x,this._extHostFileSystemInfo=B,this._requestIdProvider=new E.Counter,this._barrier=new t.Barrier,this._proxy=M.getProxy(s.MainContext.MainThreadWorkspace),this._messageService=M.getProxy(s.MainContext.MainThreadMessageService);const N=A.workspace;this._confirmedWorkspace=N?new f(N.id,N.name,[],!!N.transient,N.configuration?_.URI.revive(N.configuration):null,!!N.isUntitled,K=>d(K,B)):void 0}$initializeWorkspace(M,A){this._trusted=A,this.$acceptWorkspaceData(M),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?_.URI.from({scheme:C.Schemas.untitled,path:(0,I.basename)((0,I.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(M,A,B,...x){const N=[];if(Array.isArray(x)&&x.forEach(H=>{_.URI.isUri(H.uri)&&!N.some(j=>i(j.uri,H.uri,this._extHostFileSystemInfo))&&N.push({uri:H.uri,name:H.name||(0,I.basenameOrAuthority)(H.uri)})}),this._unconfirmedWorkspace||[A,B].some(H=>typeof H!="number"||H<0)||B===0&&N.length===0)return!1;const K=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(A+B>K.length)return!1;const X=K.slice(0);X.splice(A,B,...N.map(H=>({uri:H.uri,name:H.name||(0,I.basenameOrAuthority)(H.uri),index:void 0})));for(let H=0;H<X.length;H++){const j=X[H];if(X.some((J,Y)=>Y!==H&&i(j.uri,J.uri,this._extHostFileSystemInfo)))return!1}X.forEach((H,j)=>H.index=j);const{added:L,removed:$}=a(K,X,n,this._extHostFileSystemInfo);if(L.length===0&&$.length===0)return!1;if(this._proxy){const H=M.displayName||M.name;this._proxy.$updateWorkspaceFolders(H,A,B,N).then(void 0,j=>{this._unconfirmedWorkspace=void 0;const J={source:{identifier:M.identifier,label:M.displayName||M.name}};this._messageService.$showMessage(v.Severity.Error,(0,T.localize)(0,null,H,j.toString()),J,[])})}return this.trySetWorkspaceFolders(X),!0}getWorkspaceFolder(M,A){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(M,A)}async getWorkspaceFolder2(M,A){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(M,A)}async resolveWorkspaceFolder(M){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(M)}getPath(){if(!this._actualWorkspace)return;const{folders:M}=this._actualWorkspace;if(M.length!==0)return M[0].uri.fsPath}getRelativePath(M,A){let B,x="";if(typeof M=="string"?(B=_.URI.file(M),x=M):typeof M!="undefined"&&(B=M,x=M.fsPath),!B)return x;const N=this.getWorkspaceFolder(B,!0);if(!N)return x;typeof A=="undefined"&&this._actualWorkspace&&(A=this._actualWorkspace.folders.length>1);let K=(0,I.relativePath)(N.uri,B);return A&&N.name&&(K=`${N.name}/${K}`),K}trySetWorkspaceFolders(M){this._actualWorkspace&&(this._unconfirmedWorkspace=f.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:M,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(M){const{workspace:A,added:B,removed:x}=f.toExtHostWorkspace(M,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=A||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:B,removed:x}))}findFiles(M,A,B,x,N=D.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${x.value}, entryPoint: findFiles`);let K;if(A===null?K=!1:A&&(typeof A=="string"?K=A:K=A.pattern),N&&N.isCancellationRequested)return Promise.resolve([]);const{includePattern:X,folder:L}=O(m.GlobPattern.from(M));return this._proxy.$startFileSearch((0,k.withUndefinedAsNull)(X),(0,k.withUndefinedAsNull)(L),(0,k.withUndefinedAsNull)(K),(0,k.withUndefinedAsNull)(B),N).then($=>Array.isArray($)?$.map(H=>_.URI.revive(H)):[])}async findTextInFiles(M,A,B,x,N=D.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${x.value}, entryPoint: findTextInFiles`);const K=this._requestIdProvider.getNext(),X=typeof A.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:A.previewOptions,{includePattern:L,folder:$}=O(m.GlobPattern.from(A.include)),H=typeof A.exclude=="string"?A.exclude:A.exclude?A.exclude.pattern:void 0,j={ignoreSymlinks:typeof A.followSymlinks=="boolean"?!A.followSymlinks:void 0,disregardIgnoreFiles:typeof A.useIgnoreFiles=="boolean"?!A.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof A.useGlobalIgnoreFiles=="boolean"?!A.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof A.useParentIgnoreFiles=="boolean"?!A.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof A.useDefaultExcludes=="boolean"?!A.useDefaultExcludes:!0,fileEncoding:A.encoding,maxResults:A.maxResults,previewOptions:X,afterContext:A.afterContext,beforeContext:A.beforeContext,includePattern:L,excludePattern:H},J=!1;if(this._activeSearchCallbacks[K]=Y=>{if(J)return;const he=_.URI.revive(Y.resource);Y.results.forEach(ve=>{(0,l.resultIsMatch)(ve)?B({uri:he,preview:{text:ve.preview.text,matches:(0,u.mapArrayOrNot)(ve.preview.matches,ne=>new c.Range(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))},ranges:(0,u.mapArrayOrNot)(ve.ranges,ne=>new c.Range(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))}):B({uri:he,text:ve.text,lineNumber:ve.lineNumber})})},N.isCancellationRequested)return{};try{const Y=await this._proxy.$startTextSearch(M,(0,k.withUndefinedAsNull)($),j,K,N);return delete this._activeSearchCallbacks[K],Y||{}}catch(Y){throw delete this._activeSearchCallbacks[K],Y}}$handleTextSearchResult(M,A){this._activeSearchCallbacks[A]?.(M)}saveAll(M){return this._proxy.$saveAll(M)}resolveProxy(M){return this._proxy.$resolveProxy(M)}get trusted(){return this._trusted}requestWorkspaceTrust(M){return this._proxy.$requestWorkspaceTrust(M)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};S=je([xe(0,o.IExtHostRpcService),xe(1,p.IExtHostInitDataService),xe(2,g.IExtHostFileSystemInfo),xe(3,b.ILogService)],S),e.ExtHostWorkspace=S,e.IExtHostWorkspace=(0,w.createDecorator)("IExtHostWorkspace");function O(U){let M,A;return U&&(typeof U=="string"?M=U:(M=U.pattern,A=_.URI.revive(U.baseUri))),{includePattern:M,folder:A}}}),define(De[33],Ie([1,0,24,4,32,5,7,197,120,13,18,3,15,14,2]),function(Z,e,u,t,D,P,y,C,E,I,R,k,_,T,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function b(l,s){if(s){const i=s.split(".");let r=l;for(let n=0;r&&n<i.length;n++)r=r[i[n]];return r}}function v(l){return l instanceof w.URI}function h(l){return l&&l.uri instanceof w.URI&&l.languageId&&typeof l.languageId=="string"}function g(l){return l&&!l.uri&&l.languageId&&typeof l.languageId=="string"}function p(l){return l&&l.uri instanceof w.URI&&(!l.name||typeof l.name=="string")&&(!l.index||typeof l.index=="number")}function o(l){if(v(l))return{resource:l};if(h(l))return{resource:l.uri,overrideIdentifier:l.languageId};if(g(l))return{overrideIdentifier:l.languageId};if(p(l))return{resource:l.uri};if(l===null)return{resource:null}}let m=class{constructor(s,i,r){this._proxy=s.getProxy(P.MainContext.MainThreadConfiguration),this._extHostWorkspace=i,this._logService=r,this._barrier=new R.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(s=>this._actual)}$initializeConfiguration(s){this._actual=new c(this._proxy,this._extHostWorkspace,s,this._logService),this._barrier.open()}$acceptConfigurationChanged(s,i){this.getConfigProvider().then(r=>r.$acceptConfigurationChanged(s,i))}};m=je([xe(0,_.IExtHostRpcService),xe(1,D.IExtHostWorkspace),xe(2,T.ILogService)],m),e.ExtHostConfiguration=m;class c{constructor(s,i,r,n){this._onDidChangeConfiguration=new t.Emitter,this._proxy=s,this._logService=n,this._extHostWorkspace=i,this._configuration=C.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(s,i){const r={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=C.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(i,r))}getConfiguration(s,i,r){const n=o(i)||{},a=this._toReadonlyValue(s?b(this._configuration.getValue(void 0,n,this._extHostWorkspace.workspace),s):this._configuration.getValue(void 0,n,this._extHostWorkspace.workspace));s&&this._validateConfigurationAccess(s,n,r?.identifier);function d(S){if(S==null)return null;if(typeof S=="boolean")return S?2:5;switch(S){case y.ConfigurationTarget.Global:return 2;case y.ConfigurationTarget.Workspace:return 5;case y.ConfigurationTarget.WorkspaceFolder:return 6}}const f={has(S){return typeof b(a,S)!="undefined"},get:(S,O)=>{this._validateConfigurationAccess(s?`${s}.${S}`:S,n,r?.identifier);let U=b(a,S);if(typeof U=="undefined")U=O;else{let M;const A=(B,x)=>{let N;const K=()=>{M=M||(0,u.deepClone)(a),N=N||b(M,x)};return(0,I.isObject)(B)?new Proxy(B,{get:(X,L)=>{if(typeof L=="string"&&L.toLowerCase()==="tojson")return K(),()=>N;if(M)return N=N||b(M,x),N[L];const $=X[L];return typeof L=="string"?A($,`${x}.${L}`):$},set:(X,L,$)=>(K(),N&&(N[L]=$),!0),deleteProperty:(X,L)=>(K(),N&&delete N[L],!0),defineProperty:(X,L,$)=>(K(),N&&Object.defineProperty(N,L,$),!0)}):B};U=A(U,S)}return U},update:(S,O,U,M)=>{S=s?`${s}.${S}`:S;const A=d(U);return O!==void 0?this._proxy.$updateConfigurationOption(A,S,O,n,M):this._proxy.$removeConfigurationOption(A,S,n,M)},inspect:S=>{S=s?`${s}.${S}`:S;const O=(0,u.deepClone)(this._configuration.inspect(S,n,this._extHostWorkspace.workspace));if(O)return{key:S,defaultValue:O.policy?.value??O.default?.value,globalValue:O.user?.value??O.application?.value,workspaceValue:O.workspace?.value,workspaceFolderValue:O.workspaceFolder?.value,defaultLanguageValue:O.default?.override,globalLanguageValue:O.user?.override??O.application?.override,workspaceLanguageValue:O.workspace?.override,workspaceFolderLanguageValue:O.workspaceFolder?.override,languageIds:O.overrideIdentifiers}}};return typeof a=="object"&&(0,u.mixin)(f,a,!1),Object.freeze(f)}_toReadonlyValue(s){const i=r=>(0,I.isObject)(r)?new Proxy(r,{get:(n,a)=>i(n[a]),set:(n,a,d)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(a)}' of object`)},deleteProperty:(n,a)=>{throw new Error(`TypeError: Cannot delete read only property '${String(a)}' of object`)},defineProperty:(n,a)=>{throw new Error(`TypeError: Cannot define property '${String(a)}' for a readonly object`)},setPrototypeOf:n=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):r;return i(s)}_validateConfigurationAccess(s,i,r){const n=E.OVERRIDE_PROPERTY_REGEX.test(s)?4:this._configurationScopes.get(s),a=r?`[${r.value}] `:"";if(n===4){typeof i?.resource=="undefined"&&this._logService.warn(`${a}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(n===3){i?.resource&&this._logService.warn(`${a}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(s,i){const r=new C.ConfigurationChangeEvent(s,i,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(n,a)=>r.affectsConfiguration(n,o(a))})}_toMap(s){return s.reduce((i,r)=>(i.set(r[0],r[1]),i),new Map)}}e.ExtHostConfigProvider=c,e.IExtHostConfiguration=(0,k.createDecorator)("IExtHostConfiguration")});var et=this&&this.__classPrivateFieldSet||function(Z,e,u,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!D:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(Z,u):D?D.value=u:e.set(Z,u),u},Me=this&&this.__classPrivateFieldGet||function(Z,e,u,t){if(u==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?t:u==="a"?t.call(Z):t?t.value:e.get(Z)};define(De[72],Ie([1,0,2,18,4,5,7,32,55,33,21,38,15,26,3,12,11,14,67,233,10]),function(Z,e,u,t,D,P,y,C,E,I,R,k,_,T,w,b,v,h,g,p,o){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var c;(function(x){function N(X){if(X!=null)return X}x.from=N;function K(X){if(X!=null)return X}x.to=K})(c=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var l;(function(x){function N(X){if(X!=null)return X}x.from=N;function K(X){if(X!=null)return X}x.to=K})(l=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var s;(function(x){function N(X){if(X!=null)return X}x.from=N;function K(X){if(X!=null)return X}x.to=K})(s=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var i;(function(x){function N(L){if(L){const $=L;return $&&!!$.process}else return!1}x.is=N;function K(L){if(L==null)return;const $={process:L.process,args:L.args};return L.options&&($.options=s.from(L.options)),$}x.from=K;function X(L){if(L!=null)return new y.ProcessExecution(L.process,L.args,L.options)}x.to=X})(i=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var r;(function(x){function N(X){if(X!=null)return X}x.from=N;function K(X){if(X!=null)return X}x.to=K})(r=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var n;(function(x){function N(L){if(L){const $=L;return $&&(!!$.commandLine||!!$.command)}else return!1}x.is=N;function K(L){if(L==null)return;const $={};return L.commandLine!==void 0?$.commandLine=L.commandLine:($.command=L.command,$.args=L.args),L.options&&($.options=r.from(L.options)),$}x.from=K;function X(L){if(!(L==null||L.command===void 0&&L.commandLine===void 0))return L.commandLine?new y.ShellExecution(L.commandLine,L.options):new y.ShellExecution(L.command,L.args?L.args:[],L.options)}x.to=X})(n=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var a;(function(x){function N(L){if(L){const $=L;return $&&$.customExecution==="customExecution"}else return!1}x.is=N;function K(L){return{customExecution:"customExecution"}}x.from=K;function X(L,$){return $.get(L)}x.to=X})(a=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var d;(function(x){function N(K,X){let L;return K.scope!==void 0&&typeof K.scope!="number"?L=K.scope.uri:K.scope!==void 0&&typeof K.scope=="number"&&(K.scope===y.TaskScope.Workspace&&X&&X.workspaceFile?L=X.workspaceFile:L=p.USER_TASKS_GROUP_KEY),{id:K._id,workspaceFolder:L}}x.from=N})(d=e.TaskHandleDTO||(e.TaskHandleDTO={}));var f;(function(x){function N(K){if(K!=null)return{_id:K.id,isDefault:K.isDefault}}x.from=N})(f=e.TaskGroupDTO||(e.TaskGroupDTO={}));var S;(function(x){function N(L,$){if(L==null)return[];const H=[];for(const j of L){const J=K(j,$);J&&H.push(J)}return H}x.fromMany=N;function K(L,$){if(L==null)return;let H;L.execution instanceof y.ProcessExecution?H=i.from(L.execution):L.execution instanceof y.ShellExecution?H=n.from(L.execution):L.execution&&L.execution instanceof y.CustomExecution&&(H=a.from(L.execution));const j=c.from(L.definition);let J;return L.scope?typeof L.scope=="number"?J=L.scope:J=L.scope.uri:J=y.TaskScope.Workspace,!j||!J?void 0:{_id:L._id,definition:j,name:L.name,source:{extensionId:$.identifier.value,label:L.source,scope:J},execution:H,isBackground:L.isBackground,group:f.from(L.group),presentationOptions:l.from(L.presentationOptions),problemMatchers:L.problemMatchers,hasDefinedMatchers:L.hasDefinedMatchers,runOptions:L.runOptions?L.runOptions:{reevaluateOnRerun:!0},detail:L.detail}}x.from=K;async function X(L,$,H){if(L==null)return;let j;i.is(L.execution)?j=i.to(L.execution):n.is(L.execution)?j=n.to(L.execution):a.is(L.execution)&&(j=a.to(L._id,H));const J=c.to(L.definition);let Y;if(L.source&&(L.source.scope!==void 0?typeof L.source.scope=="number"?Y=L.source.scope:Y=await $.resolveWorkspaceFolder(u.URI.revive(L.source.scope)):Y=y.TaskScope.Workspace),!J||!Y)return;const he=new y.Task(J,Y,L.name,L.source.label,j,L.problemMatchers);return L.isBackground!==void 0&&(he.isBackground=L.isBackground),L.group!==void 0&&(he.group=y.TaskGroup.from(L.group._id),he.group&&L.group.isDefault&&(he.group=new y.TaskGroup(he.group.id,he.group.label),L.group.isDefault===!0&&(he.group.isDefault=L.group.isDefault))),L.presentationOptions&&(he.presentationOptions=l.to(L.presentationOptions)),L._id&&(he._id=L._id),L.detail&&(he.detail=L.detail),he}x.to=X})(S=e.TaskDTO||(e.TaskDTO={}));var O;(function(x){function N(X){return X}x.from=N;function K(X){if(!!X)return Object.assign(Object.create(null),X)}x.to=K})(O=e.TaskFilterDTO||(e.TaskFilterDTO={}));class U{constructor(N,K,X){this._id=K,this._task=X,m.set(this,void 0),et(this,m,N,"f")}get task(){return this._task}terminate(){Me(this,m,"f").terminateTask(this)}fireDidStartProcess(N){}fireDidEndProcess(N){}}m=new WeakMap;var M;(function(x){function N(K){return{id:K._id,task:void 0}}x.from=N})(M=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let A=class{constructor(N,K,X,L,$,H,j,J){this._onDidExecuteTask=new D.Emitter,this._onDidTerminateTask=new D.Emitter,this._onDidTaskProcessStarted=new D.Emitter,this._onDidTaskProcessEnded=new D.Emitter,this._proxy=N.getProxy(P.MainContext.MainThreadTask),this._workspaceProvider=X,this._editorService=L,this._configurationService=$,this._terminalService=H,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=j,this._deprecationService=J,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(N,K,X){if(!X)return new y.Disposable(()=>{});const L=this.nextHandle();return this._handlers.set(L,{type:K,provider:X,extension:N}),this._proxy.$registerTaskProvider(L,K),new y.Disposable(()=>{this._handlers.delete(L),this._proxy.$unregisterTaskProvider(L)})}registerTaskSystem(N,K){this._proxy.$registerTaskSystem(N,K)}fetchTasks(N){return this._proxy.$fetchTasks(O.from(N)).then(async K=>{const X=[];for(const L of K){const $=await S.to(L,this._workspaceProvider,this._providedCustomExecutions2);$&&X.push($)}return X})}get taskExecutions(){const N=[];return this._taskExecutions.forEach(K=>N.push(K)),N}terminateTask(N){if(!(N instanceof U))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(N._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(N,K,X){const L=this._providedCustomExecutions2.get(N.id);L&&(this._activeCustomExecutions2.set(N.id,L),this._terminalService.attachPtyToTerminal(K,await L.callback(X))),this._lastStartedTask=N.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(N)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(N){const K=await this.getTaskExecution(N);this._taskExecutionPromises.delete(N.id),this._taskExecutions.delete(N.id),this.customExecutionComplete(N),this._onDidTerminateTask.fire({execution:K})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(N){const K=await this.getTaskExecution(N.id);this._onDidTaskProcessStarted.fire({execution:K,processId:N.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(N){const K=await this.getTaskExecution(N.id);this._onDidTaskProcessEnded.fire({execution:K,exitCode:N.exitCode})}$provideTasks(N,K){const X=this._handlers.get(N);if(!X)return Promise.reject(new Error("no handler found"));const L=[],$=(0,t.asPromise)(()=>X.provider.provideTasks(R.CancellationToken.None)).then(H=>this.provideTasksInternal(K,L,X,H));return new Promise(H=>{$.then(j=>{Promise.all(L).then(()=>{H(j)})})})}async $resolveTask(N,K){const X=this._handlers.get(N);if(!X)return Promise.reject(new Error("no handler found"));if(K.definition.type!==X.type)throw new Error(`Unexpected: Task of type [${K.definition.type}] cannot be resolved by provider of type [${X.type}].`);const L=await S.to(K,this._workspaceProvider,this._providedCustomExecutions2);if(!L)throw new Error("Unexpected: Task cannot be resolved.");const $=await X.provider.resolveTask(L,R.CancellationToken.None);if(!$)return;this.checkDeprecation($,X);const H=S.from($,X.extension);if(!H)throw new Error("Unexpected: Task cannot be resolved.");if($.definition!==L.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return a.is(H.execution)&&await this.addCustomExecution(H,$,!0),await this.resolveTaskInternal(H)}nextHandle(){return this._handleCounter++}async addCustomExecution(N,K,X){const L=await this._proxy.$createTaskId(N);!X&&!this._providedCustomExecutions2.has(L)&&(this._notProvidedCustomExecutions.add(L),this._activeCustomExecutions2.set(L,K.execution)),this._providedCustomExecutions2.set(L,K.execution)}async getTaskExecution(N,K){if(typeof N=="string"){const $=this._taskExecutionPromises.get(N);if(!$)throw new Error("Unexpected: The specified task is missing an execution");return $}const X=this._taskExecutionPromises.get(N.id);if(X)return X;const L=new Promise(($,H)=>{function j(J,Y,he){he?$(new U(J,Y.id,he)):H("Unexpected: Task does not exist.")}K?j(this,N,K):S.to(N.task,this._workspaceProvider,this._providedCustomExecutions2).then(J=>j(this,N,J))});return this._taskExecutionPromises.set(N.id,L),L.then($=>(this._taskExecutions.set(N.id,$),$),$=>Promise.reject($))}checkDeprecation(N,K){N._deprecated&&this._deprecationService.report("Task.constructor",K.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(N){this._activeCustomExecutions2.get(N.id)&&this._activeCustomExecutions2.delete(N.id),this._notProvidedCustomExecutions.has(N.id)&&this._lastStartedTask!==N.id&&(this._providedCustomExecutions2.delete(N.id),this._notProvidedCustomExecutions.delete(N.id));const X=this._notProvidedCustomExecutions.values();let L=X.next();for(;!L.done;)!this._activeCustomExecutions2.has(L.value)&&this._lastStartedTask!==L.value&&(this._providedCustomExecutions2.delete(L.value),this._notProvidedCustomExecutions.delete(L.value)),L=X.next()}};A=je([xe(0,_.IExtHostRpcService),xe(1,T.IExtHostInitDataService),xe(2,C.IExtHostWorkspace),xe(3,E.IExtHostDocumentsAndEditors),xe(4,I.IExtHostConfiguration),xe(5,k.IExtHostTerminalService),xe(6,h.ILogService),xe(7,g.IExtHostApiDeprecationService)],A),e.ExtHostTaskBase=A;let B=class extends A{constructor(N,K,X,L,$,H,j,J){super(N,K,X,L,$,H,j,J);this.registerTaskSystem(b.Schemas.vscodeRemote,{scheme:b.Schemas.vscodeRemote,authority:"",platform:v.PlatformToString(0)})}async executeTask(N,K){if(!K.execution)throw new Error("Tasks to execute must include an execution");const X=S.from(K,N);if(X===void 0)throw new Error("Task is not valid");if(a.is(X.execution))await this.addCustomExecution(X,K,!1);else throw new o.NotSupportedError;const L=await this.getTaskExecution(await this._proxy.$getTaskExecution(X),K);return this._proxy.$executeTask(X).catch($=>{throw new Error($)}),L}provideTasksInternal(N,K,X,L){const $=[];if(L)for(const H of L){this.checkDeprecation(H,X),(!H.definition||!N[H.definition.type])&&this._logService.warn(`The task [${H.source}, ${H.name}] uses an undefined task type. The task will be ignored in the future.`);const j=S.from(H,X.extension);j&&a.is(j.execution)?($.push(j),K.push(this.addCustomExecution(j,H,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:$,extension:X.extension}}async resolveTaskInternal(N){if(a.is(N.execution))return N;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(N,K){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(N,K,X){}};B=je([xe(0,_.IExtHostRpcService),xe(1,T.IExtHostInitDataService),xe(2,C.IExtHostWorkspace),xe(3,E.IExtHostDocumentsAndEditors),xe(4,I.IExtHostConfiguration),xe(5,k.IExtHostTerminalService),xe(6,h.ILogService),xe(7,g.IExtHostApiDeprecationService)],B),e.WorkerExtHostTask=B,e.IExtHostTask=(0,w.createDecorator)("IExtHostTask")}),define(De[278],Ie([1,0,9,21,50,36,22,51,30]),function(Z,e,u,t,D,P,y,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class I{constructor(_,T,w){this.config=_,this.provider=T,this.sessionToken=w,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=_.filePattern,this.includePattern=_.includePattern&&P.parse(_.includePattern),this.maxResults=_.maxResults||void 0,this.exists=_.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=_.excludePattern&&P.parse(_.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(_=>_.cancel()),this.activeCancellationTokens=new Set}search(_){const T=this.config.folderQueries||[];return new Promise((w,b)=>{const v=h=>{this.resultCount++,_(h)};if(this.isCanceled)return w({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(h=>{const g=h.toString(),p=u.basename(g);this.globalExcludePattern&&this.globalExcludePattern(g,p)||this.matchFile(v,{base:h,basename:p})}),Promise.all(T.map(h=>this.searchInFolder(h,v))).then(h=>{w({limitHit:this.isLimitHit,stats:h[0]||void 0})},h=>{b(new Error((0,D.toErrorMessage)(h)))})})}async searchInFolder(_,T){const w=new t.CancellationTokenSource,b=this.getSearchOptionsForFolder(_),v=this.initDirectoryTree(),h=new E.QueryGlobTester(this.config,_),g=!h.hasSiblingExcludeClauses();let p;try{this.activeCancellationTokens.add(w),p=C.StopWatch.create();const o=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},b,w.token),m=p.elapsed(),c=C.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(o&&o.forEach(l=>{const s=u.posix.relative(_.folder.path,l.path);if(g){const i=u.basename(l.path);this.matchFile(T,{base:_.folder,relativePath:s,basename:i});return}this.addDirectoryEntries(v,_.folder,s,T)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(v,h,T),{providerTime:m,postProcessTime:c.elapsed()})}finally{w.dispose(),this.activeCancellationTokens.delete(w)}}getSearchOptionsForFolder(_){const T=(0,E.resolvePatternsForProvider)(this.config.includePattern,_.includePattern),w=(0,E.resolvePatternsForProvider)(this.config.excludePattern,_.excludePattern);return{folder:_.folder,excludes:w,includes:T,useIgnoreFiles:!_.disregardIgnoreFiles,useGlobalIgnoreFiles:!_.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!_.disregardParentIgnoreFiles,followSymlinks:!_.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const _={rootEntries:[],pathToEntries:Object.create(null)};return _.pathToEntries["."]=_.rootEntries,_}addDirectoryEntries({pathToEntries:_},T,w,b){if(w===this.filePattern){const h=u.basename(this.filePattern);this.matchFile(b,{base:T,relativePath:this.filePattern,basename:h})}function v(h){const g=u.basename(h),p=u.dirname(h);let o=_[p];o||(o=_[p]=[],v(p)),o.push({base:T,relativePath:h,basename:g})}v(w)}matchDirectoryTree({rootEntries:_,pathToEntries:T},w,b){const v=this,h=this.filePattern;function g(p){const o=(0,E.hasSiblingFn)(()=>p.map(m=>m.basename));for(let m=0,c=p.length;m<c;m++){const l=p[m],{relativePath:s,basename:i}=l;if(w.matchesExcludesSync(s,i,h!==i?o:void 0))continue;const r=T[s];if(r)g(r);else{if(s===h)continue;v.matchFile(b,l)}if(v.isLimitHit)break}}g(_)}matchFile(_,T){(!this.includePattern||T.relativePath&&this.includePattern(T.relativePath,T.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||_(T))}}class R{constructor(){this.sessions=new Map}fileSearch(_,T,w,b){const v=this.getSessionTokenSource(_.cacheKey),h=new I(_,T,v&&v.token);let g=0;const p=o=>{g+=o.length,w(o.map(m=>this.rawMatchToSearchItem(m)))};return this.doSearch(h,R.BATCH_SIZE,p,b).then(o=>({limitHit:o.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:g,detailStats:o.stats}}))}clearCache(_){this.getSessionTokenSource(_)?.cancel()}getSessionTokenSource(_){if(!!_)return this.sessions.has(_)||this.sessions.set(_,new t.CancellationTokenSource),this.sessions.get(_)}rawMatchToSearchItem(_){return _.relativePath?{resource:y.joinPath(_.base,_.relativePath)}:{resource:_.base}}doSearch(_,T,w,b){b.onCancellationRequested(()=>{_.cancel()});const v=g=>{g&&(h.push(g),T>0&&h.length>=T&&(w(h),h=[]))};let h=[];return _.search(v).then(g=>(h.length&&w(h),g),g=>(h.length&&w(h),Promise.reject(g)))}}e.FileSearchManager=R,R.BATCH_SIZE=512}),define(De[279],Ie([1,0,17,77,36,106,25,12,9,22,8,13,2,158,185,83,14,45,129,277,30]),function(Z,e,u,t,D,P,y,C,E,I,R,k,_,T,w,b,v,h,g,p,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let m=class{constructor(f,S,O,U,M){this.configurationService=f,this.workspaceContextService=S,this.editorGroupsService=O,this.logService=U,this.pathService=M}text(f,S,O={}){f=this.getContentPattern(f,O);const U=this.configurationService.getValue(),M=S&&S.some(B=>!this.configurationService.getValue({resource:B}).search.useRipgrep);return{...this.commonQuery(S?.map(h.toWorkspaceFolder),O),type:2,contentPattern:f,previewOptions:O.previewOptions,maxFileSize:O.maxFileSize,usePCRE2:U.search.usePCRE2||M||!1,beforeContext:O.beforeContext,afterContext:O.afterContext,userDisabledExcludesAndIgnoreFiles:O.disregardExcludeSettings&&O.disregardIgnoreFiles}}getContentPattern(f,S){const O=this.configurationService.getValue();f.isRegExp&&(f.pattern=f.pattern.replace(/\r?\n/g,"\\n"));const U={...f,wordSeparators:O.editor.wordSeparators};return this.isCaseSensitive(f,S)&&(U.isCaseSensitive=!0),this.isMultiline(f)&&(U.isMultiline=!0),U}file(f,S={}){return{...this.commonQuery(f,S),type:1,filePattern:S.filePattern?S.filePattern.trim():S.filePattern,exists:S.exists,sortByScore:S.sortByScore,cacheKey:S.cacheKey}}handleIncludeExclude(f,S){return f?(f=Array.isArray(f)?f.map(r):r(f),S?this.parseSearchPaths(f):{pattern:l(...Array.isArray(f)?f:[f])}):{}}commonQuery(f=[],S={}){const O=this.handleIncludeExclude(S.includePattern,S.expandPatterns),U=this.handleIncludeExclude(S.excludePattern,S.expandPatterns),M=f.length>1,A=(O.searchPaths&&O.searchPaths.length?O.searchPaths.map(N=>this.getFolderQueryForSearchPath(N,S,U)):f.map(N=>this.getFolderQueryForRoot(N,S,U,M))).filter(N=>!!N),B={_reason:S._reason,folderQueries:A,usingSearchPaths:!!(O.searchPaths&&O.searchPaths.length),extraFileResources:S.extraFileResources,excludePattern:U.pattern,includePattern:O.pattern,onlyOpenEditors:S.onlyOpenEditors,maxResults:S.maxResults};if(S.onlyOpenEditors){const N=u.coalesce(u.flatten(this.editorGroupsService.groups.map(L=>L.editors.map($=>$.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(N));const K=N.filter(L=>(0,o.pathIncludedInQuery)(B,L.fsPath)),X=this.commonQueryFromFileList(K);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(X)),{...B,...X}}const x=S.extraFileResources&&S.extraFileResources.filter(N=>(0,o.pathIncludedInQuery)(B,N.fsPath));return B.extraFileResources=x&&x.length?x:void 0,B}commonQueryFromFileList(f){const S=[],O=new y.ResourceMap,U={};let M=!1;return f.forEach(A=>{if(A.scheme===C.Schemas.walkThrough)return;if((0,I.isAbsolutePath)(A)){const x=this.workspaceContextService.getWorkspaceFolder(A)?.uri??A.with({path:E.dirname(A.fsPath)});let N=O.get(x);N||(M=!0,N={folder:x,includePattern:{}},S.push(N),O.set(x,N));const K=E.relative(x.fsPath,A.fsPath);(0,k.assertIsDefined)(N.includePattern)[K.replace(/\\/g,"/")]=!0}else A.fsPath&&(M=!0,U[A.fsPath]=!0)}),{folderQueries:S,includePattern:U,usingSearchPaths:!0,excludePattern:M?void 0:{"**/*":!0}}}isCaseSensitive(f,S){if(S.isSmartCase){if(f.isRegExp){if(R.containsUppercaseCharacter(f.pattern,!0))return!0}else if(R.containsUppercaseCharacter(f.pattern))return!0}return!!f.isCaseSensitive}isMultiline(f){return f.isMultiline||f.isRegExp&&(0,T.isMultilineRegexSource)(f.pattern)||f.pattern.indexOf(`
`)>=0?!0:!!f.isMultiline}parseSearchPaths(f){const S=X=>E.isAbsolute(X)||/^\.\.?([\/\\]|$)/.test(X),U=(Array.isArray(f)?f:s(f)).map(X=>{const L=this.pathService.resolvedUserHome;return L?(0,P.untildify)(X,L.scheme===C.Schemas.file?L.fsPath:L.path):X}),M=t.groupBy(U,X=>S(X)?"searchPaths":"exprSegments"),A=(M.exprSegments||[]).map(X=>R.rtrim(X,"/")).map(X=>R.rtrim(X,"\\")).map(X=>(X[0]==="."&&(X="*"+X),i(X))),B={},x=this.expandSearchPathPatterns(M.searchPaths||[]);x&&x.length&&(B.searchPaths=x);const N=u.flatten(A),K=l(...N);return K&&(B.pattern=K),B}getExcludesForFolder(f,S){return S.disregardExcludeSettings?void 0:(0,o.getExcludes)(f,!S.disregardSearchExcludeSettings)}expandSearchPathPatterns(f){if(!f||!f.length)return[];const S=u.flatten(f.map(U=>{let{pathPortion:M,globPortion:A}=c(U);A&&(A=n(A));const B=this.expandOneSearchPath(M);return u.flatten(B.map(x=>this.resolveOneSearchPathPattern(x,A)))})),O=new Map;return S.forEach(U=>{const M=U.searchPath.toString(),A=O.get(M);A?U.pattern&&(A.pattern=A.pattern||{},A.pattern[U.pattern]=!0):O.set(M,{searchPath:U.searchPath,pattern:U.pattern?l(U.pattern):void 0})}),Array.from(O.values())}expandOneSearchPath(f){if(E.isAbsolute(f)){const S=this.workspaceContextService.getWorkspace().folders;return S[0]&&S[0].uri.scheme!==C.Schemas.file?[{searchPath:S[0].uri.with({path:f})}]:[{searchPath:_.URI.file(E.normalize(f))}]}if(this.workspaceContextService.getWorkbenchState()===2){const S=this.workspaceContextService.getWorkspace().folders[0].uri;if(f=r(f),f.startsWith("../")||f===".."){const U=E.posix.resolve(S.path,f);return[{searchPath:S.with({path:U})}]}const O=n(f);return[{searchPath:S,pattern:O}]}else{if(f==="./"||f===".\\")return[];{const S=f.replace(/^\.[\/\\]/,""),U=this.workspaceContextService.getWorkspace().folders.map(M=>{const A=S.match(new RegExp(`^${R.escapeRegExpCharacters(M.name)}(?:/(.*)|$)`));return A?{match:A,folder:M}:null}).filter(k.isDefined);if(U.length)return U.map(M=>{const A=M.match[1];return{searchPath:M.folder.uri,pattern:A&&n(A)}});{const M=f.match(/\.[\/\\](.+)[\/\\]?/),A=M?M[1]:f,B=w.localize(0,null,A);throw new Error(B)}}}}resolveOneSearchPathPattern(f,S){const O=f.pattern&&S?`${f.pattern}/${S}`:f.pattern||S,U=[{searchPath:f.searchPath,pattern:O}];return O&&!O.endsWith("**")&&U.push({searchPath:f.searchPath,pattern:O+"/**"}),U}getFolderQueryForSearchPath(f,S,O){const U=this.getFolderQueryForRoot((0,h.toWorkspaceFolder)(f.searchPath),S,O,!1);return U?{...U,includePattern:f.pattern}:null}getFolderQueryForRoot(f,S,O,U){let M;const A=_.URI.isUri(f)?f:f.uri;if(O.searchPaths){const X=O.searchPaths.filter(L=>(0,I.isEqual)(L.searchPath,A))[0];if(X&&!X.pattern)return null;X&&(M=X.pattern)}const B=this.configurationService.getValue({resource:A}),N={...this.getExcludesForFolder(B,S)||{},...M||{}},K=_.URI.isUri(f)?(0,I.basename)(f):f.name;return{folder:A,folderName:U?K:void 0,excludePattern:Object.keys(N).length>0?N:void 0,fileEncoding:B.files&&B.files.encoding,disregardIgnoreFiles:typeof S.disregardIgnoreFiles=="boolean"?S.disregardIgnoreFiles:!B.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof S.disregardGlobalIgnoreFiles=="boolean"?S.disregardGlobalIgnoreFiles:!B.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof S.disregardParentIgnoreFiles=="boolean"?S.disregardParentIgnoreFiles:!B.search.useParentIgnoreFiles,ignoreSymlinks:typeof S.ignoreSymlinks=="boolean"?S.ignoreSymlinks:!B.search.followSymlinks}}};m=je([xe(0,b.IConfigurationService),xe(1,h.IWorkspaceContextService),xe(2,g.IEditorGroupsService),xe(3,v.ILogService),xe(4,p.IPathService)],m),e.QueryBuilder=m;function c(d){const f=d.match(/[\*\{\}\(\)\[\]\?]/);if(f){const S=f.index,O=d.substr(0,S).match(/[/|\\][^/\\]*$/);if(O){let U=d.substr(0,O.index);return U.match(/[/\\]/)||(U+="/"),{pathPortion:U,globPortion:d.substr((O.index||0)+1)}}}return{pathPortion:d}}function l(...d){return d.length?d.reduce((f,S)=>(f[S]=!0,f),Object.create(null)):void 0}function s(d){return D.splitGlobAware(d,",").map(f=>f.trim()).filter(f=>!!f.length)}function i(d){return[`**/${d}/**`,`**/${d}`].map(S=>S.replace(/\*\*\/\*\*/g,"**"))}function r(d){return d.replace(/\\/g,"/")}function n(d){return r(d).replace(/^\.\//,"").replace(/\/+$/g,"")}function a(d,f){d=u.distinct(d,U=>U.toString());const S=[],O=f.getWorkspace();return d&&d.forEach(U=>{let M;if(f.getWorkbenchState()===2)M=(0,I.relativePath)(O.folders[0].uri,U),M&&M!=="."&&(M="./"+M);else{const A=f.getWorkspaceFolder(U);if(A){const B=A.name;if(O.folders.filter(N=>N.name===B).length===1){const N=(0,I.relativePath)(A.uri,U);N===""?M=`./${A.name}`:M=`./${A.name}/${N}`}else M=U.fsPath}}M&&S.push(M)}),S}e.resolveResourcesForSearchIncludes=a}),define(De[280],Ie([1,0,22,2,21,10,3,279,30,45]),function(Z,e,u,t,D,P,y,C,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const R=7e3;function k(b,v){const h=v.activationEvents;if(!h)return Promise.resolve(void 0);const g=[],p=[];for(const i of h)if(/^workspaceContains:/.test(i)){const r=i.substr("workspaceContains:".length);r.indexOf("*")>=0||r.indexOf("?")>=0||b.forceUsingSearch?p.push(r):g.push(r)}if(g.length===0&&p.length===0)return Promise.resolve(void 0);let o;const m=new Promise((i,r)=>{o=i}),c=i=>o({activationEvent:i}),l=Promise.all(g.map(i=>_(b,i,c))).then(()=>{}),s=T(b,v.identifier,p,c);return Promise.all([l,s]).then(()=>{o(void 0)}),m}e.checkActivateWorkspaceContainsExtension=k;async function _(b,v,h){for(const g of b.folders)if(await b.exists(u.joinPath(t.URI.revive(g),v))){h(`workspaceContains:${v}`);return}}async function T(b,v,h,g){if(h.length===0)return Promise.resolve(void 0);const p=new D.CancellationTokenSource,o=b.checkExists(b.folders,h,p.token),m=setTimeout(async()=>{p.cancel(),b.logService.info(`Not activating extension '${v.value}': Timed out while searching for 'workspaceContains' pattern ${h.join(",")}`)},R);let c=!1;try{c=await o}catch(l){P.isCancellationError(l)||P.onUnexpectedError(l)}p.dispose(),clearTimeout(m),c&&g(`workspaceContains:${h.join(",")}`)}function w(b,v,h,g){const p=b.get(y.IInstantiationService),o=b.get(E.ISearchService),c=p.createInstance(C.QueryBuilder).file(v.map(l=>(0,I.toWorkspaceFolder)(t.URI.revive(l))),{_reason:"checkExists",includePattern:h,exists:!0});return o.fileSearch(c,g).then(l=>!!l.limitHit,l=>P.isCancellationError(l)?!1:Promise.reject(l))}e.checkGlobFileExists=w});var et=this&&this.__classPrivateFieldSet||function(Z,e,u,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!D:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(Z,u):D?D.value=u:e.set(Z,u),u},Me=this&&this.__classPrivateFieldGet||function(Z,e,u,t){if(u==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?t:u==="a"?t.call(Z):t?t.value:e.get(Z)};define(De[39],Ie([1,0,169,9,73,22,18,6,25,2,14,5,33,228,91,32,27,226,10,28,23,203,7,121,3,26,69,15,85,53,38,4,280,90,205,12]),function(Z,e,u,t,D,P,y,C,E,I,R,k,_,T,w,b,v,h,g,p,o,m,c,l,s,i,r,n,a,d,f,S,O,U,M,A){"use strict";var B,x,N;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,s.createDecorator)("IHostUtils");let K=class Tn extends C.Disposable{constructor(Y,he,ve,ne,pe,Ee,ke,Oe,Be,ae){super();this._onDidChangeRemoteConnectionData=this._register(new S.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._isTerminating=!1,this._hostUtils=he,this._extHostContext=ve,this._initData=ke,this._extHostWorkspace=ne,this._extHostConfiguration=pe,this._logService=Ee,this._extHostTunnelService=Be,this._extHostTerminalService=ae,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(k.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(k.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(k.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new y.Barrier,this._readyToStartExtensionHost=new y.Barrier,this._readyToRunExtensions=new y.Barrier,this._eagerExtensionsActivated=new y.Barrier,this._globalRegistry=new h.ExtensionDescriptionRegistry(this._initData.allExtensions);const de=(0,v.extensionIdentifiersArrayToSet)(this._initData.myExtensions);this._myRegistry=new h.ExtensionDescriptionRegistry($(this._globalRegistry,de)),this._storage=new w.ExtHostStorage(this._extHostContext),this._secretState=new U.ExtHostSecretState(this._extHostContext),this._storagePath=Oe,this._instaService=Y.createChild(new a.ServiceCollection([w.IExtHostStorage,this._storage],[U.IExtHostSecretState,this._secretState]));let me=[],te=[];this._initData.remote.isRemote&&(me=this._initData.allExtensions.filter(ee=>!ee.main&&!ee.browser).map(ee=>ee.identifier),te=this._initData.allExtensions.filter(ee=>!de.has(p.ExtensionIdentifier.toKey(ee.identifier.value))).filter(ee=>(ee.main||ee.browser)&&ee.api==="none").map(ee=>ee.identifier));const le=(0,v.extensionIdentifiersArrayToSet)(te);this._activator=this._register(new T.ExtensionsActivator(this._myRegistry,me,te,{onExtensionActivationError:(ee,re,F)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(ee,g.transformErrorForSerialization(re),F)},actualActivateExtension:async(ee,re)=>{if(le.has(p.ExtensionIdentifier.toKey(ee)))return await this._mainThreadExtensionsProxy.$activateExtension(ee,re),new T.HostExtension;const F=this._myRegistry.getExtensionDescription(ee);return this._activateExtension(F,re)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),D.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(Y){g.onUnexpectedError(Y)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let Y=[];try{Y=this._myRegistry.getAllExtensionDescriptions().map(pe=>pe.identifier).filter(pe=>this.isActivated(pe)).map(pe=>this._deactivate(pe))}catch{}await Promise.all(Y)}terminate(Y,he=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${Y}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),g.setUnexpectedErrorHandler(ne=>{this._logService.error(ne)}),this._extHostContext.dispose();const ve=this._deactivateAll();Promise.race([(0,y.timeout)(5e3),ve]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${he}`):this._logService.info(`Extension host exiting with code ${he}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(he)})}isActivated(Y){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(Y):!1}async getExtension(Y){const he=await this._mainThreadExtensionsProxy.$getExtension(Y);let ve;if(he?.browserNlsBundleUris){ve={};for(const ne of Object.keys(he.browserNlsBundleUris))ve[ne]=I.URI.revive(he.browserNlsBundleUris[ne])}return he&&{...he,identifier:new p.ExtensionIdentifier(he.identifier.value),extensionLocation:I.URI.revive(he.extensionLocation),browserNlsBundleUris:ve}}_activateByEvent(Y,he){return this._activator.activateByEvent(Y,he)}_activateById(Y,he){return this._activator.activateById(Y,he)}activateByIdWithErrors(Y,he){return this._activateById(Y,he).then(()=>{const ve=this._activator.getActivatedExtension(Y);if(ve.activationFailed)return Promise.reject(ve.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(Y=>this._myRegistry)}getExtensionExports(Y){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(Y).exports:null}async _realPathExtensionUri(Y){if(Y.scheme!==A.Schemas.file)return Y;const he=await this._hostUtils.realpath(Y.fsPath);return I.URI.file(he)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(Y=>new j(Y))),this._extensionPathIndex}async _createExtensionPathIndex(Y){const he=E.TernarySearchTree.forUris(ve=>P.extUriBiasedIgnorePathCase.ignorePathCasing(ve));return await Promise.all(Y.map(async ve=>{if(this._getEntryPoint(ve)){const ne=await this._realPathExtensionUri(ve.extensionLocation);he.set(ne,ve)}})),he}_deactivate(Y){let he=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(Y))return he;const ve=this._activator.getActivatedExtension(Y);if(!ve)return he;try{typeof ve.module.deactivate=="function"&&(he=Promise.resolve(ve.module.deactivate()).then(void 0,ne=>(this._logService.error(ne),Promise.resolve(void 0))))}catch(ne){this._logService.error(`An error occurred when deactivating the extension '${Y.value}':`),this._logService.error(ne)}try{(0,C.dispose)(ve.subscriptions)}catch(ne){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${Y.value}':`),this._logService.error(ne)}return he}async _activateExtension(Y,he){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(Y.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(Y.identifier),this._doActivateExtension(Y,he).then(ve=>{const ne=ve.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(Y.identifier,ne.codeLoadingTime,ne.activateCallTime,ne.activateResolvedTime,he),this._logExtensionActivationTimes(Y,he,"success",ne),ve},ve=>{throw this._logExtensionActivationTimes(Y,he,"failure"),ve})}_logExtensionActivationTimes(Y,he,ve,ne){const pe=X(Y,he);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...pe,...ne||{},outcome:ve})}_doActivateExtension(Y,he){const ve=X(Y,he);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",ve);const ne=this._getEntryPoint(Y);if(!ne)return Promise.resolve(new T.EmptyExtension(T.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${Y.identifier.value}, startup: ${he.startup}, activationEvent: '${he.activationEvent}'${Y.identifier.value!==he.extensionId.value?`, root cause: ${he.extensionId.value}`:""}`),this._logService.flush();const pe=new T.ExtensionActivationTimesBuilder(he.startup);return Promise.all([this._loadCommonJSModule(Y,(0,P.joinPath)(Y.extensionLocation,ne),pe),this._loadExtensionContext(Y)]).then(Ee=>(D.mark(`code/extHost/willActivateExtension/${Y.identifier.value}`),Tn._callActivate(this._logService,Y.identifier,Ee[0],Ee[1],pe))).then(Ee=>(D.mark(`code/extHost/didActivateExtension/${Y.identifier.value}`),Ee))}_loadExtensionContext(Y){const he=new m.ExtensionGlobalMemento(Y,this._storage),ve=new m.ExtensionMemento(Y.identifier.value,!1,this._storage),ne=new M.ExtensionSecrets(Y,this._secretState),pe=Y.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?c.ExtensionMode.Test:c.ExtensionMode.Development:c.ExtensionMode.Production,Ee=this._initData.remote.isRemote?c.ExtensionKind.Workspace:c.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${Y.identifier.value}`),Promise.all([he.whenReady,ve.whenReady,this._storagePath.whenReady]).then(()=>{const ke=this;let Oe,Be;const ae=(0,v.isProposedApiEnabled)(Y,"ipc")?this._initData.messagePorts?.get(p.ExtensionIdentifier.toKey(Y.identifier)):void 0;return Object.freeze({globalState:he,workspaceState:ve,secrets:ne,subscriptions:[],get extensionUri(){return Y.extensionLocation},get extensionPath(){return Y.extensionLocation.fsPath},asAbsolutePath(de){return t.join(Y.extensionLocation.fsPath,de)},get storagePath(){return ke._storagePath.workspaceValue(Y)?.fsPath},get globalStoragePath(){return ke._storagePath.globalValue(Y).fsPath},get logPath(){return t.join(ke._initData.logsLocation.fsPath,Y.identifier.value)},get logUri(){return I.URI.joinPath(ke._initData.logsLocation,Y.identifier.value)},get storageUri(){return ke._storagePath.workspaceValue(Y)},get globalStorageUri(){return ke._storagePath.globalValue(Y)},get extensionMode(){return pe},get extension(){return Oe===void 0&&(Oe=new L(ke,Y.identifier,Y,Ee,!1)),Oe},get extensionRuntime(){return(0,v.checkProposedApiEnabled)(Y,"extensionRuntime"),ke.extensionRuntime},get environmentVariableCollection(){return ke._extHostTerminalService.getEnvironmentVariableCollection(Y)},get messagePassingProtocol(){if(!Be){if(!ae)return;const de=S.Event.buffer(S.Event.fromDOMEventEmitter(ae,"message",me=>me.data));ae.start(),Be={onDidReceiveMessage:de,postMessage:ae.postMessage.bind(ae)}}return Be}})})}static _callActivate(Y,he,ve,ne,pe){return ve=ve||{activate:void 0,deactivate:void 0},this._callActivateOptional(Y,he,ve,ne,pe).then(Ee=>new T.ActivatedExtension(!1,null,pe.build(),ve,Ee,ne.subscriptions))}static _callActivateOptional(Y,he,ve,ne,pe){if(typeof ve.activate=="function")try{pe.activateCallStart(),Y.trace(`ExtensionService#_callActivateOptional ${he.value}`);const Ee=typeof global=="object"?global:self,ke=ve.activate.apply(Ee,[ne]);return pe.activateCallStop(),pe.activateResolveStart(),Promise.resolve(ke).then(Oe=>(pe.activateResolveStop(),Oe))}catch(Ee){return Promise.reject(Ee)}else return Promise.resolve(ve)}_activateOneStartupFinished(Y,he){this._activateById(Y.identifier,{startup:!1,extensionId:Y.identifier,activationEvent:he}).then(void 0,ve=>{this._logService.error(ve)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(D.getMarks());for(const Y of this._myRegistry.getAllExtensionDescriptions())if(Y.activationEvents)for(const he of Y.activationEvents)he==="onStartupFinished"&&this._activateOneStartupFinished(Y,he)}_handleEagerExtensions(){const Y=this._activateByEvent("*",!0).then(void 0,pe=>{this._logService.error(pe)});this._register(this._extHostWorkspace.onDidChangeWorkspace(pe=>this._handleWorkspaceContainsEagerExtensions(pe.added)));const he=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],ve=this._handleWorkspaceContainsEagerExtensions(he),ne=Promise.all([Y,ve]).then(()=>{});return Promise.race([ne,(0,y.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),ne}_handleWorkspaceContainsEagerExtensions(Y){return Y.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(he=>this._handleWorkspaceContainsEagerExtension(Y,he))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(Y,he){if(this.isActivated(he.identifier))return;const ve=!this._initData.remote.isRemote&&!!this._initData.remote.authority,ne={logService:this._logService,folders:Y.map(Ee=>Ee.uri),forceUsingSearch:ve,exists:Ee=>this._hostUtils.exists(Ee.fsPath),checkExists:(Ee,ke,Oe)=>this._mainThreadWorkspaceProxy.$checkExists(Ee,ke,Oe)},pe=await(0,O.checkActivateWorkspaceContainsExtension)(ne,he);if(!!pe)return this._activateById(he.identifier,{startup:!0,extensionId:he.identifier,activationEvent:pe.activationEvent}).then(void 0,Ee=>this._logService.error(Ee))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(Y){throw console.error(Y),Y}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:Y,extensionTestsLocationURI:he}=this._initData.environment;if(!Y||!he)throw new Error(u.localize(0,null));const ve=await this._loadCommonJSModule(null,he,new T.ExtensionActivationTimesBuilder(!1));if(!ve||typeof ve.run!="function")throw new Error(u.localize(1,null,he.toString()));return new Promise((ne,pe)=>{const Ee=(Be,ae)=>{Be?pe(Be):ne(typeof ae=="number"&&ae>0?1:0)},ke=(0,P.originalFSPath)(he),Oe=ve.run(ke,Ee);Oe&&Oe.then&&Oe.then(()=>{ne(0)}).catch(Be=>{pe(Be instanceof Error&&Be.stack?Be.stack:String(Be))})})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(Y,he){return this._resolvers[Y]=he,(0,C.toDisposable)(()=>{delete this._resolvers[Y]})}async _activateAndGetResolver(Y){const he=Y.indexOf("+");if(he===-1)throw new Error("Not an authority that can be resolved!");const ve=Y.substr(0,he);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${ve}`,!1),{authorityPrefix:ve,resolver:this._resolvers[ve]}}async $resolveAuthority(Y,he){this._logService.info(`$resolveAuthority invoked for authority (${H(Y)})`);const{authorityPrefix:ve,resolver:ne}=await this._activateAndGetResolver(Y);if(!ne)return{type:"error",error:{code:l.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${ve}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelFactory(ne)),D.mark(`code/extHost/willResolveAuthority/${ve}`);const pe=await ne.resolve(Y,{resolveAttempt:he});D.mark(`code/extHost/didResolveAuthorityOK/${ve}`);const Ee={authority:Y,host:pe.host,port:pe.port,connectionToken:pe.connectionToken},ke={extensionHostEnv:pe.extensionHostEnv,isTrusted:pe.isTrusted,authenticationSession:pe.authenticationSessionForInitializingExtensions?{id:pe.authenticationSessionForInitializingExtensions.id,providerId:pe.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:Ee,options:ke,tunnelInformation:{environmentTunnels:pe.environmentTunnels,features:pe.tunnelFeatures}}}}catch(pe){if(D.mark(`code/extHost/didResolveAuthorityError/${ve}`),pe instanceof c.RemoteAuthorityResolverError)return{type:"error",error:{code:pe._code,message:pe._message,detail:pe._detail}};throw pe}}async $getCanonicalURI(Y,he){this._logService.info(`$getCanonicalURI invoked for authority (${H(Y)})`);const{resolver:ve}=await this._activateAndGetResolver(Y);if(!ve)return null;const ne=I.URI.revive(he);if(typeof ve.getCanonicalURI=="undefined")return ne;const pe=await(0,y.asPromise)(()=>ve.getCanonicalURI(ne));return pe||ne}static _applyExtensionsDelta(Y,he,ve){const ne=new h.ExtensionDescriptionRegistry(Y.getAllExtensionDescriptions());ne.deltaExtensions(ve.toAdd,ve.toRemove);const pe=(0,v.extensionIdentifiersArrayToSet)(he.getAllExtensionDescriptions().map(ke=>ke.identifier));for(const ke of ve.myToRemove)pe.delete(p.ExtensionIdentifier.toKey(ke));for(const ke of ve.myToAdd)pe.add(p.ExtensionIdentifier.toKey(ke));const Ee=$(ne,pe);return{globalRegistry:ne,myExtensions:Ee}}$startExtensionHost(Y){Y.toAdd.forEach(ne=>ne.extensionLocation=I.URI.revive(ne.extensionLocation));const{globalRegistry:he,myExtensions:ve}=Tn._applyExtensionsDelta(this._globalRegistry,this._myRegistry,Y);return this._globalRegistry.set(he.getAllExtensionDescriptions()),this._myRegistry.set(ve),this._startExtensionHost()}$activateByEvent(Y,he){return he===1?this._activateByEvent(Y,!1):this._readyToRunExtensions.wait().then(ve=>this._activateByEvent(Y,!1))}async $activate(Y,he){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(Y)?(await this._activateById(Y,he),!0):!1}async $deltaExtensions(Y){Y.toAdd.forEach(Ee=>Ee.extensionLocation=I.URI.revive(Ee.extensionLocation));const{globalRegistry:he,myExtensions:ve}=Tn._applyExtensionsDelta(this._globalRegistry,this._myRegistry,Y),ne=await this._createExtensionPathIndex(ve);return(await this.getExtensionPathIndex()).setSearchTree(ne),this._globalRegistry.set(he.getAllExtensionDescriptions()),this._myRegistry.set(ve),Promise.resolve(void 0)}async $test_latency(Y){return Y}async $test_up(Y){return Y.byteLength}async $test_down(Y){const he=o.VSBuffer.alloc(Y),ve=Math.random()%256;for(let ne=0;ne<Y;ne++)he.writeUInt8(ve,ne);return he}async $updateRemoteConnectionData(Y){this._remoteConnectionData=Y,this._onDidChangeRemoteConnectionData.fire()}};K=je([xe(0,s.IInstantiationService),xe(1,e.IHostUtils),xe(2,n.IExtHostRpcService),xe(3,b.IExtHostWorkspace),xe(4,_.IExtHostConfiguration),xe(5,R.ILogService),xe(6,i.IExtHostInitDataService),xe(7,r.IExtensionStoragePaths),xe(8,d.IExtHostTunnelService),xe(9,f.IExtHostTerminalService)],K),e.AbstractExtHostExtensionService=K;function X(J,Y){return{id:J.identifier.value,name:J.name,extensionVersion:J.version,publisherDisplayName:J.publisher,activationEvents:J.activationEvents?J.activationEvents.join(","):null,isBuiltin:J.isBuiltin,reason:Y.activationEvent,reasonId:Y.extensionId.value}}e.IExtHostExtensionService=(0,s.createDecorator)("IExtHostExtensionService");class L{constructor(Y,he,ve,ne,pe){B.set(this,void 0),x.set(this,void 0),N.set(this,void 0),et(this,B,Y,"f"),et(this,x,he,"f"),et(this,N,ve.identifier,"f"),this.id=ve.identifier.value,this.extensionUri=ve.extensionLocation,this.extensionPath=t.normalize((0,P.originalFSPath)(ve.extensionLocation)),this.packageJSON=ve,this.extensionKind=ne,this.isFromDifferentExtensionHost=pe}get isActive(){return Me(this,B,"f").isActivated(Me(this,N,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Me(this,B,"f").getExtensionExports(Me(this,N,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Me(this,B,"f").activateByIdWithErrors(Me(this,N,"f"),{startup:!1,extensionId:Me(this,x,"f"),activationEvent:"api"}),this.exports}}e.Extension=L,B=new WeakMap,x=new WeakMap,N=new WeakMap;function $(J,Y){return J.getAllExtensionDescriptions().filter(he=>Y.has(p.ExtensionIdentifier.toKey(he.identifier)))}function H(J){const Y=J.indexOf("+");return Y===-1?J:J.substring(0,Y)}class j{constructor(Y){this._searchTree=Y}setSearchTree(Y){this._searchTree=Y}findSubstr(Y){return this._searchTree.findSubstr(Y)}forEach(Y){return this._searchTree.forEach(Y)}}e.ExtensionPaths=j}),define(De[281],Ie([1,0,73,2,5,33,27,28,15,26,3,39,40,14,8]),function(Z,e,u,t,D,P,y,C,E,I,R,k,_,T,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let b=class{constructor(m,c,l,s,i,r,n){this._apiFactory=m,this._extensionRegistry=c,this._instaService=l,this._extHostConfiguration=s,this._extHostExtensionService=i,this._initData=r,this._logService=n,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),u.mark("code/extHost/willWaitForConfig");const m=await this._extHostConfiguration.getConfigProvider();u.mark("code/extHost/didWaitForConfig");const c=await this._extHostExtensionService.getExtensionPathIndex();this.register(new h(this._apiFactory,c,this._extensionRegistry,m,this._logService)),this.register(this._instaService.createInstance(g,c)),this.register(this._instaService.createInstance(v)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(p,c,this._initData.environment.appUriScheme))}register(m){if("nodeModuleName"in m)if(Array.isArray(m.nodeModuleName))for(const c of m.nodeModuleName)this._factories.set(c,m);else this._factories.set(m.nodeModuleName,m);typeof m.alternativeModuleName=="function"&&this._alternatives.push(c=>m.alternativeModuleName(c))}};b=je([xe(2,R.IInstantiationService),xe(3,P.IExtHostConfiguration),xe(4,k.IExtHostExtensionService),xe(5,I.IExtHostInitDataService),xe(6,T.ILogService)],b),e.RequireInterceptor=b;let v=class Qn{constructor(m){if(m.environment.appRoot&&Qn.aliased.size){const c=(0,w.escapeRegExpCharacters)(this.forceForwardSlashes(m.environment.appRoot.fsPath)),l="[a-z0-9_.-]",s=`@${l}+\\/${l}+|${l}+`,i="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${c}/${i}\\/)(${s})(.*)$`,"i")}}alternativeModuleName(m){if(!this.re)return;const c=this.re.exec(this.forceForwardSlashes(m));if(!c)return;const[,l,s,i]=c,r=Qn.aliased.get(s);if(r!==void 0)return console.warn(`${s} as been renamed to ${r}, please update your imports`),l+r+i}forceForwardSlashes(m){return m.replace(/\\/g,"/")}};v.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),v=je([xe(0,I.IExtHostInitDataService)],v);class h{constructor(m,c,l,s,i){this._apiFactory=m,this._extensionPaths=c,this._extensionRegistry=l,this._configProvider=s,this._logService=i,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(m,c){const l=this._extensionPaths.findSubstr(c);if(l){let s=this._extApiImpl.get(C.ExtensionIdentifier.toKey(l.identifier));return s||(s=this._apiFactory(l,this._extensionRegistry,this._configProvider),this._extApiImpl.set(C.ExtensionIdentifier.toKey(l.identifier),s)),s}if(!this._defaultApiImpl){let s="";this._extensionPaths.forEach((i,r)=>s+=`	${r} -> ${i.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${c}. These are the extension path mappings: 
${s}`),this._defaultApiImpl=this._apiFactory(y.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let g=class{constructor(m,c,l){this._extensionPaths=m,this.nodeModuleName="keytar",this._mainThreadTelemetry=c.getProxy(D.MainContext.MainThreadTelemetry);const{environment:s}=l,i=c.getProxy(D.MainContext.MainThreadKeytar);if(s.appRoot){let r=s.appRoot.fsPath;_.platform==="win32"&&(r=r.replace(/\\/g,"/")),r[r.length-1]==="/"&&(r=r.substr(0,r.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${r}/node_modules.asar/keytar`),this.alternativeNames.add(`${r}/node_modules/keytar`)}this._impl={getPassword:(r,n)=>i.$getPassword(r,n),setPassword:(r,n,a)=>i.$setPassword(r,n,a),deletePassword:(r,n)=>i.$deletePassword(r,n),findPassword:r=>i.$findPassword(r),findCredentials(r){return i.$findCredentials(r)}}}load(m,c){const l=this._extensionPaths.findSubstr(c);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:l?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(m){const c=m.length;if(c<=7||!this.alternativeNames)return;const l=c-7;if((m.charAt(l)==="/"||m.charAt(l)==="\\")&&m.endsWith("keytar")&&(m=m.replace(/\\/g,"/"),this.alternativeNames.has(m)))return"keytar"}};g=je([xe(1,E.IExtHostRpcService),xe(2,I.IExtHostInitDataService)],g);let p=class{constructor(m,c,l){this._extensionPaths=m,this._appUriScheme=c,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=l.getProxy(D.MainContext.MainThreadTelemetry);const s=l.getProxy(D.MainContext.MainThreadWindow);this._impl=(i,r)=>{const n=t.URI.parse(i);return r?this.callOriginal(i,r):n.scheme==="http"||n.scheme==="https"?s.$openUri(n,i,{allowTunneling:!0}):n.scheme==="mailto"||n.scheme===this._appUriScheme?s.$openUri(n,i,{}):this.callOriginal(i,r)}}load(m,c,l){const s=this._extensionPaths.findSubstr(c);return s&&(this._extensionId=s.identifier.value,this.sendShimmingTelemetry()),this._original=l(m),this._impl}callOriginal(m,c){return this.sendNoForwardTelemetry(),this._original(m,c)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};p=je([xe(2,E.IExtHostRpcService)],p)}),define(De[47],Ie([1,0,78,6,9,40,3,55,56,39,7,32,219,33]),function(Z,e,u,t,D,P,y,C,E,I,R,k,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,y.createDecorator)("IExtHostVariableResolverProvider");class w extends _.AbstractVariableResolverService{constructor(h,g,p,o,m,c,l){function s(){if(p){const i=p.activeEditor();if(i)return i.document.uri;const r=o.tabGroups.all.find(n=>n.isActive)?.activeTab;if(r!==void 0){if(r.input instanceof R.TextDiffTabInput||r.input instanceof R.NotebookDiffEditorTabInput)return r.input.modified;if(r.input instanceof R.TextTabInput||r.input instanceof R.NotebookEditorTabInput||r.input instanceof R.CustomEditorTabInput)return r.input.uri}}}super({getFolderUri:i=>{const r=c.folders.filter(n=>n.name===i);if(r&&r.length>0)return r[0].uri},getWorkspaceFolderCount:()=>c.folders.length,getConfigurationValue:(i,r)=>m.getConfiguration(void 0,i).get(r),getAppRoot:()=>P.cwd(),getExecPath:()=>P.env.VSCODE_EXEC_PATH,getFilePath:()=>{const i=s();if(i)return D.normalize(i.fsPath)},getWorkspaceFolderPathForFile:()=>{if(g){const i=s();if(i){const r=g.getWorkspaceFolder(i);if(r)return D.normalize(r.uri.fsPath)}}},getSelectedText:()=>{if(p){const i=p.activeEditor();if(i&&!i.selection.isEmpty)return i.document.getText(i.selection)}},getLineNumber:()=>{if(p){const i=p.activeEditor();if(i)return String(i.selection.end.line+1)}},getExtension:i=>h.getExtension(i)},void 0,l?Promise.resolve(l):void 0,Promise.resolve(P.env))}}let b=class extends t.Disposable{constructor(h,g,p,o,m){super();this.extensionService=h,this.workspaceService=g,this.editorService=p,this.configurationService=o,this.editorTabs=m,this._resolver=new u.Lazy(async()=>{const c=await this.configurationService.getConfigProvider(),s={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async i=>{s.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new w(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,c,s,this.homeDir())})}getResolver(){return this._resolver.getValue()}homeDir(){}};b=je([xe(0,I.IExtHostExtensionService),xe(1,k.IExtHostWorkspace),xe(2,C.IExtHostDocumentsAndEditors),xe(3,T.IExtHostConfiguration),xe(4,E.IExtHostEditorTabs)],b),e.ExtHostVariableResolverProviderService=b}),define(De[74],Ie([1,0,18,4,13,2,3,5,56,39,15,7,32,126,212,33,47]),function(Z,e,u,t,D,P,y,C,E,I,R,k,_,T,w,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,y.createDecorator)("IExtHostDebugService");let h=class{constructor(s,i,r,n,a,d){this._workspaceService=i,this._extensionService=r,this._configurationService=n,this._editorTabs=a,this._variableResolver=d,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new t.Emitter,this._onDidTerminateDebugSession=new t.Emitter,this._onDidChangeActiveDebugSession=new t.Emitter,this._onDidReceiveDebugSessionCustomEvent=new t.Emitter,this._debugServiceProxy=s.getProxy(C.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new t.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new p(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(f=>{f.onDidChange(S=>{this.registerAllDebugTypes(f)}),this.registerAllDebugTypes(f)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(s,i){const r=s;if(typeof r.sourceReference=="number"&&r.sourceReference>0){let n=`debug:${encodeURIComponent(r.path||"")}`,a="?";return i&&(n+=`${a}session=${encodeURIComponent(i.id)}`,a="&"),n+=`${a}ref=${r.sourceReference}`,P.URI.parse(n)}else{if(r.path)return P.URI.file(r.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(s){const i=[];for(const r of s.getAllExtensionDescriptions())if(r.contributes){const n=r.contributes.debuggers;if(n&&n.length>0)for(const a of n)(0,w.isDebuggerMainContribution)(a)&&i.push(a.type)}this._debugServiceProxy.$registerDebugTypes(i)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const s=[];return this._breakpoints.forEach(i=>s.push(i)),s}addBreakpoints(s){this.startBreakpoints();const i=s.filter(a=>{const d=a.id;return this._breakpoints.has(d)?!1:(this._breakpoints.set(d,a),!0)});this.fireBreakpointChanges(i,[],[]);const r=[],n=new Map;for(const a of i)if(a instanceof k.SourceBreakpoint){let d=n.get(a.location.uri.toString());d||(d={type:"sourceMulti",uri:a.location.uri,lines:[]},n.set(a.location.uri.toString(),d),r.push(d)),d.lines.push({id:a.id,enabled:a.enabled,condition:a.condition,hitCondition:a.hitCondition,logMessage:a.logMessage,line:a.location.range.start.line,character:a.location.range.start.character})}else a instanceof k.FunctionBreakpoint&&r.push({type:"function",id:a.id,enabled:a.enabled,hitCondition:a.hitCondition,logMessage:a.logMessage,condition:a.condition,functionName:a.functionName});return this._debugServiceProxy.$registerBreakpoints(r)}removeBreakpoints(s){this.startBreakpoints();const i=s.filter(d=>this._breakpoints.delete(d.id));this.fireBreakpointChanges([],i,[]);const r=i.filter(d=>d instanceof k.SourceBreakpoint).map(d=>d.id),n=i.filter(d=>d instanceof k.FunctionBreakpoint).map(d=>d.id),a=i.filter(d=>d instanceof k.DataBreakpoint).map(d=>d.id);return this._debugServiceProxy.$unregisterBreakpoints(r,n,a)}startDebugging(s,i,r){return this._debugServiceProxy.$startDebugging(s?s.uri:void 0,i,{parentSessionID:r.parentSession?r.parentSession.id:void 0,lifecycleManagedByParent:r.lifecycleManagedByParent,repl:r.consoleMode===k.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:r.noDebug,compact:r.compact,debugUI:r.debugUI,suppressSaveBeforeStart:r.suppressSaveBeforeStart})}stopDebugging(s){return this._debugServiceProxy.$stopDebugging(s?s.id:void 0)}registerDebugConfigurationProvider(s,i,r){if(!i)return new k.Disposable(()=>{});const n=this._configProviderHandleCounter++;return this._configProviders.push({type:s,handle:n,provider:i}),this._debugServiceProxy.$registerDebugConfigurationProvider(s,r,!!i.provideDebugConfigurations,!!i.resolveDebugConfiguration,!!i.resolveDebugConfigurationWithSubstitutedVariables,n),new k.Disposable(()=>{this._configProviders=this._configProviders.filter(a=>a.provider!==i),this._debugServiceProxy.$unregisterDebugConfigurationProvider(n)})}registerDebugAdapterDescriptorFactory(s,i,r){if(!r)return new k.Disposable(()=>{});if(!this.definesDebugType(s,i))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${i}' debugger.`);if(this.getAdapterDescriptorFactoryByType(i))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const n=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:i,handle:n,factory:r}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(i,n),new k.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(a=>a.factory!==r),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(n)})}registerDebugAdapterTrackerFactory(s,i){if(!i)return new k.Disposable(()=>{});const r=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:s,handle:r,factory:i}),new k.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(n=>n.factory!==i)})}async $runInTerminal(s,i){return Promise.resolve(void 0)}async $substituteVariables(s,i){let r;const n=await this.getFolder(s);return n&&(r={uri:n.uri,name:n.name,index:n.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(r,i)}createDebugAdapter(s,i){if(s.type==="implementation")return new m(s.implementation)}createSignService(){}async $startDASession(s,i){const r=this,n=await this.getSession(i);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(n.type),n).then(a=>{if(!a)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${n.type}' (extension might have failed to activate)`);const d=this.convertToDto(a),f=this.createDebugAdapter(d,n);if(!f)throw new Error(`Couldn't create a debug adapter for type '${n.type}'.`);const S=f;return this._debugAdapters.set(s,S),this.getDebugAdapterTrackers(n).then(O=>(O&&this._debugAdaptersTrackers.set(s,O),S.onMessage(async U=>{if(U.type==="request"&&U.command==="handshake"){const M=U,A={type:"response",seq:0,command:M.command,request_seq:M.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const B=await this._signService.sign(M.arguments.value);A.body={signature:B},S.sendResponse(A)}else throw new Error("no signer")}catch(B){A.success=!1,A.message=B.message,S.sendResponse(A)}}else O&&O.onDidSendMessage&&O.onDidSendMessage(U),U=(0,w.convertToVSCPaths)(U,!0),r._debugServiceProxy.$acceptDAMessage(s,U)}),S.onError(U=>{O&&O.onError&&O.onError(U),this._debugServiceProxy.$acceptDAError(s,U.name,U.message,U.stack)}),S.onExit(U=>{O&&O.onExit&&O.onExit((0,D.withNullAsUndefined)(U),void 0),this._debugServiceProxy.$acceptDAExit(s,(0,D.withNullAsUndefined)(U),void 0)}),O&&O.onWillStartSession&&O.onWillStartSession(),S.startSession()))})}$sendDAMessage(s,i){i=(0,w.convertToDAPaths)(i,!1);const r=this._debugAdaptersTrackers.get(s);r&&r.onWillReceiveMessage&&r.onWillReceiveMessage(i),this._debugAdapters.get(s)?.sendMessage(i)}$stopDASession(s){const i=this._debugAdaptersTrackers.get(s);this._debugAdaptersTrackers.delete(s),i&&i.onWillStopSession&&i.onWillStopSession();const r=this._debugAdapters.get(s);return this._debugAdapters.delete(s),r?r.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(s){const i=[],r=[],n=[];if(s.added)for(const a of s.added){const d=a.id;if(d&&!this._breakpoints.has(d)){let f;if(a.type==="function")f=new k.FunctionBreakpoint(a.functionName,a.enabled,a.condition,a.hitCondition,a.logMessage);else if(a.type==="data")f=new k.DataBreakpoint(a.label,a.dataId,a.canPersist,a.enabled,a.hitCondition,a.condition,a.logMessage);else{const S=P.URI.revive(a.uri);f=new k.SourceBreakpoint(new k.Location(S,new k.Position(a.line,a.character)),a.enabled,a.condition,a.hitCondition,a.logMessage)}f._id=d,this._breakpoints.set(d,f),i.push(f)}}if(s.removed)for(const a of s.removed){const d=this._breakpoints.get(a);d&&(this._breakpoints.delete(a),r.push(d))}if(s.changed){for(const a of s.changed)if(a.id){const d=this._breakpoints.get(a.id);if(d){if(d instanceof k.FunctionBreakpoint&&a.type==="function"){const f=d;f.enabled=a.enabled,f.condition=a.condition,f.hitCondition=a.hitCondition,f.logMessage=a.logMessage,f.functionName=a.functionName}else if(d instanceof k.SourceBreakpoint&&a.type==="source"){const f=d;f.enabled=a.enabled,f.condition=a.condition,f.hitCondition=a.hitCondition,f.logMessage=a.logMessage,f.location=new k.Location(P.URI.revive(a.uri),new k.Position(a.line,a.character))}n.push(d)}}}this.fireBreakpointChanges(i,r,n)}$provideDebugConfigurations(s,i,r){return(0,u.asPromise)(async()=>{const n=this.getConfigProviderByHandle(s);if(!n)throw new Error("no DebugConfigurationProvider found");if(!n.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const a=await this.getFolder(i);return n.provideDebugConfigurations(a,r)}).then(n=>{if(!n)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return n})}$resolveDebugConfiguration(s,i,r,n){return(0,u.asPromise)(async()=>{const a=this.getConfigProviderByHandle(s);if(!a)throw new Error("no DebugConfigurationProvider found");if(!a.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const d=await this.getFolder(i);return a.resolveDebugConfiguration(d,r,n)})}$resolveDebugConfigurationWithSubstitutedVariables(s,i,r,n){return(0,u.asPromise)(async()=>{const a=this.getConfigProviderByHandle(s);if(!a)throw new Error("no DebugConfigurationProvider found");if(!a.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const d=await this.getFolder(i);return a.resolveDebugConfigurationWithSubstitutedVariables(d,r,n)})}async $provideDebugAdapter(s,i){const r=this.getAdapterDescriptorFactoryByHandle(s);if(!r)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const n=await this.getSession(i);return this.getAdapterDescriptor(r,n).then(a=>{if(!a)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${n.type}'`);return this.convertToDto(a)})}async $acceptDebugSessionStarted(s){const i=await this.getSession(s);this._onDidStartDebugSession.fire(i)}async $acceptDebugSessionTerminated(s){const i=await this.getSession(s);i&&(this._onDidTerminateDebugSession.fire(i),this._debugSessions.delete(i.id))}async $acceptDebugSessionActiveChanged(s){this._activeDebugSession=s?await this.getSession(s):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(s,i){(await this.getSession(s))?._acceptNameChanged(i)}async $acceptDebugSessionCustomEvent(s,i){const n={session:await this.getSession(s),event:i.event,body:i.body};this._onDidReceiveDebugSessionCustomEvent.fire(n)}convertToDto(s){if(s instanceof k.DebugAdapterExecutable)return{type:"executable",command:s.command,args:s.args,options:s.options};if(s instanceof k.DebugAdapterServer)return{type:"server",port:s.port,host:s.host};if(s instanceof k.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:s.path};if(s instanceof k.DebugAdapterInlineImplementation)return{type:"implementation",implementation:s.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(s){const i=this._adapterFactories.filter(r=>r.type===s);if(i.length>0)return i[0].factory}getAdapterDescriptorFactoryByHandle(s){const i=this._adapterFactories.filter(r=>r.handle===s);if(i.length>0)return i[0].factory}getConfigProviderByHandle(s){const i=this._configProviders.filter(r=>r.handle===s);if(i.length>0)return i[0].provider}definesDebugType(s,i){if(s.contributes){const r=s.contributes.debuggers;if(r&&r.length>0){for(const n of r)if(n.label&&n.type&&n.type===i)return!0}}return!1}getDebugAdapterTrackers(s){const r=s.configuration.type,n=this._trackerFactories.filter(a=>a.type===r||a.type==="*").map(a=>(0,u.asPromise)(()=>a.factory.createDebugAdapterTracker(s)).then(d=>d,d=>null));return Promise.race([Promise.all(n).then(a=>{const d=a.filter(f=>!!f);if(d.length>0)return new o(d)}),new Promise((a,d)=>{const f=setTimeout(()=>{clearTimeout(f),d(new Error("timeout"))},1e3)})]).catch(a=>{})}async getAdapterDescriptor(s,i){const r=i.configuration.debugServer;if(typeof r=="number")return Promise.resolve(new k.DebugAdapterServer(r));if(s){const a=await this._extensionService.getExtensionRegistry();return(0,u.asPromise)(()=>s.createDebugAdapterDescriptor(i,this.daExecutableFromPackage(i,a))).then(d=>{if(d)return d})}const n=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(i,n))}daExecutableFromPackage(s,i){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(s,i,r){(s.length>0||i.length>0||r.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:s,removed:i,changed:r}))}async getSession(s){if(s)if(typeof s=="string"){const i=this._debugSessions.get(s);if(i)return i}else{let i=this._debugSessions.get(s.id);if(!i){const r=await this.getFolder(s.folderUri),n=s.parent?this._debugSessions.get(s.parent):void 0;i=new g(this._debugServiceProxy,s.id,s.type,s.name,r,s.configuration,n),this._debugSessions.set(i.id,i),this._debugServiceProxy.$sessionCached(i.id)}return i}throw new Error("cannot find session")}getFolder(s){if(s){const i=P.URI.revive(s);return this._workspaceService.resolveWorkspaceFolder(i)}return Promise.resolve(void 0)}};h=je([xe(0,R.IExtHostRpcService),xe(1,_.IExtHostWorkspace),xe(2,I.IExtHostExtensionService),xe(3,b.IExtHostConfiguration),xe(4,E.IExtHostEditorTabs),xe(5,v.IExtHostVariableResolverProvider)],h),e.ExtHostDebugServiceBase=h;class g{constructor(s,i,r,n,a,d,f){this._debugServiceProxy=s,this._id=i,this._type=r,this._name=n,this._workspaceFolder=a,this._configuration=d,this._parentSession=f}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(s){this._name=s,this._debugServiceProxy.$setDebugSessionName(this._id,s)}get parentSession(){return this._parentSession}_acceptNameChanged(s){this._name=s}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(s,i){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,s,i)}getDebugProtocolBreakpoint(s){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,s.id)}}e.ExtHostDebugSession=g;class p{constructor(s){this.value=Object.freeze({append(i){s.$appendDebugConsole(i)},appendLine(i){this.append(i+`
`)}})}}e.ExtHostDebugConsole=p;class o{constructor(s){this.trackers=s}onWillStartSession(){this.trackers.forEach(s=>s.onWillStartSession?s.onWillStartSession():void 0)}onWillReceiveMessage(s){this.trackers.forEach(i=>i.onWillReceiveMessage?i.onWillReceiveMessage(s):void 0)}onDidSendMessage(s){this.trackers.forEach(i=>i.onDidSendMessage?i.onDidSendMessage(s):void 0)}onWillStopSession(){this.trackers.forEach(s=>s.onWillStopSession?s.onWillStopSession():void 0)}onError(s){this.trackers.forEach(i=>i.onError?i.onError(s):void 0)}onExit(s,i){this.trackers.forEach(r=>r.onExit?r.onExit(s,i):void 0)}}class m extends T.AbstractDebugAdapter{constructor(s){super();this.implementation=s,s.onDidSendMessage(i=>{this.acceptMessage(i)})}startSession(){return Promise.resolve(void 0)}sendMessage(s){this.implementation.handleMessage(s)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let c=class extends h{constructor(s,i,r,n,a,d){super(s,i,r,n,a,d)}};c=je([xe(0,R.IExtHostRpcService),xe(1,_.IExtHostWorkspace),xe(2,I.IExtHostExtensionService),xe(3,b.IExtHostConfiguration),xe(4,E.IExtHostEditorTabs),xe(5,v.IExtHostVariableResolverProvider)],c),e.WorkerExtHostDebugService=c}),define(De[282],Ie([1,0,10,73,2,5,274,14,82,85,26,192,15,64,39]),function(Z,e,u,t,D,P,y,C,E,I,R,k,_,T,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class b{constructor(h,g,p,o,m){this._hostUtils=p,this._rpcProtocol=new y.RPCProtocol(h,null,o),g=b._transform(g,this._rpcProtocol);const c=new I.ServiceCollection(...(0,E.getSingletonServiceDescriptors)());c.set(R.IExtHostInitDataService,{_serviceBrand:void 0,...g,messagePorts:m}),c.set(_.IExtHostRpcService,new _.ExtHostRpcService(this._rpcProtocol)),c.set(T.IURITransformerService,new T.URITransformerService(o)),c.set(w.IHostUtils,p);const l=new k.InstantiationService(c,!0);this._logService=l.invokeFunction(n=>n.get(C.ILogService)),t.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",g),this._extensionService=l.invokeFunction(n=>n.get(w.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const s=new WeakMap;this._extensionService.getExtensionPathIndex().then(n=>{Error.prepareStackTrace=(a,d)=>{let f="",S,O;for(const U of d)f+=`
	at ${U.toString()}`,O=U.getFileName(),!S&&O&&(S=n.findSubstr(D.URI.file(O)));return s.set(a,S),`${a.name||"Error"}: ${a.message||""}${f}`}});const i=this._rpcProtocol.getProxy(P.MainContext.MainThreadExtensionService),r=this._rpcProtocol.getProxy(P.MainContext.MainThreadErrors);u.setUnexpectedErrorHandler(n=>{const a=u.transformErrorForSerialization(n),d=s.get(n);d?i.$onExtensionRuntimeError(d.identifier,a):r.$onUnexpectedError(a)})}async asBrowserUri(h){const g=this._rpcProtocol.getProxy(P.MainContext.MainThreadExtensionService);return D.URI.revive(await g.$asBrowserUri(h))}terminate(h){this._extensionService.terminate(h)}static _transform(h,g){h.allExtensions.forEach(o=>{o.extensionLocation=D.URI.revive(g.transformIncomingURIs(o.extensionLocation));const m={};o.browserNlsBundleUris&&(Object.keys(o.browserNlsBundleUris).forEach(c=>m[c]=D.URI.revive(g.transformIncomingURIs(o.browserNlsBundleUris[c]))),o.browserNlsBundleUris=m)}),h.environment.appRoot=D.URI.revive(g.transformIncomingURIs(h.environment.appRoot));const p=h.environment.extensionDevelopmentLocationURI;return p&&(h.environment.extensionDevelopmentLocationURI=p.map(o=>D.URI.revive(g.transformIncomingURIs(o)))),h.environment.extensionTestsLocationURI=D.URI.revive(g.transformIncomingURIs(h.environment.extensionTestsLocationURI)),h.environment.globalStorageHome=D.URI.revive(g.transformIncomingURIs(h.environment.globalStorageHome)),h.environment.workspaceStorageHome=D.URI.revive(g.transformIncomingURIs(h.environment.workspaceStorageHome)),h.logsLocation=D.URI.revive(g.transformIncomingURIs(h.logsLocation)),h.logFile=D.URI.revive(g.transformIncomingURIs(h.logFile)),h.workspace=g.transformIncomingURIs(h.workspace),h}}e.ExtensionHostMain=b}),define(De[283],Ie([1,0,18,11,175,191,199,74,56,39,15,38,7,47,32,213,215,33]),function(Z,e,u,t,D,P,y,C,E,I,R,k,_,T,w,b,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.runInExternalTerminal=e.ExtHostDebugService=void 0;let g=class extends C.ExtHostDebugServiceBase{constructor(l,s,i,r,n,a,d){super(l,s,i,r,a,d);this._terminalService=n,this._integratedTerminalInstances=new m}createDebugAdapter(l,s){switch(l.type){case"server":return new b.SocketDebugAdapter(l);case"pipeServer":return new b.NamedPipeDebugAdapter(l);case"executable":return new b.ExecutableDebugAdapter(l,s.type)}return super.createDebugAdapter(l,s)}daExecutableFromPackage(l,s){const i=b.ExecutableDebugAdapter.platformAdapterExecutable(s.getAllExtensionDescriptions(),l.type);if(i)return new _.DebugAdapterExecutable(i.command,i.args,i.options)}createSignService(){return new y.SignService}async $runInTerminal(l,s){if(l.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(B=>{this._integratedTerminalInstances.onTerminalClosed(B)}));const i=await this._configurationService.getConfigProvider(),r=this._terminalService.getDefaultShell(!0),n=this._terminalService.getDefaultShellArgs(!0),a=l.title||D.localize(0,null),d=JSON.stringify({shell:r,shellArgs:n});let f=await this._integratedTerminalInstances.checkout(d,a),S,O=!1;if(f)S=l.cwd;else{const B={shellPath:r,shellArgs:n,cwd:l.cwd,name:a,iconPath:new _.ThemeIcon("debug")};O=!0,f=this._terminalService.createTerminalFromOptions(B,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(f,d)}f.show(!0);const U=await f.processId;O?await new Promise(B=>setTimeout(B,1e3)):i.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(r.indexOf("powershell")>=0||r.indexOf("pwsh")>=0||r.indexOf("cmd.exe")>=0?f.sendText("cls"):r.indexOf("bash")>=0?f.sendText("clear"):t.isWindows?f.sendText("cls"):f.sendText("clear"));const M=(0,v.prepareCommand)(r,l.args,!!l.argsCanBeInterpretedByShell,S,l.env);f.sendText(M);const A=this.onDidTerminateDebugSession(B=>{B.id===s&&(this._integratedTerminalInstances.free(f),A.dispose())});return U}else if(l.kind==="external")return o(l,await this._configurationService.getConfigProvider());return super.$runInTerminal(l,s)}};g=je([xe(0,R.IExtHostRpcService),xe(1,w.IExtHostWorkspace),xe(2,I.IExtHostExtensionService),xe(3,h.IExtHostConfiguration),xe(4,k.IExtHostTerminalService),xe(5,E.IExtHostEditorTabs),xe(6,T.IExtHostVariableResolverProvider)],g),e.ExtHostDebugService=g;let p;function o(c,l){if(!p)if(t.isWindows)p=new P.WindowsExternalTerminalService;else if(t.isMacintosh)p=new P.MacExternalTerminalService;else if(t.isLinux)p=new P.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const s=l.getConfiguration("terminal");return p.runInTerminal(c.title,c.cwd,c.args,c.env||{},s.external||{})}e.runInExternalTerminal=o;class m{constructor(){this._terminalInstances=new Map}async checkout(l,s){const r=[...this._terminalInstances.entries()].map(([n,a])=>(0,u.createCancelablePromise)(async d=>{if(n.name!==s||a.lastUsedAt!==-1&&await(0,v.hasChildProcesses)(await n.processId))return null;const f=Date.now();return a.lastUsedAt+m.minUseDelay>f||d.isCancellationRequested||a.config!==l?null:(a.lastUsedAt=f,n)}));return await(0,u.firstParallel)(r,n=>!!n)}insert(l,s){this._terminalInstances.set(l,{lastUsedAt:Date.now(),config:s})}free(l){const s=this._terminalInstances.get(l);s&&(s.lastUsedAt=-1)}onTerminalClosed(l){this._terminalInstances.delete(l)}}m.minUseDelay=1e3}),define(De[284],Ie([1,0,9,2,109,32,55,33,45,38,15,26,72,12,14,67,22,81,47]),function(Z,e,u,t,D,P,y,C,E,I,R,k,_,T,w,b,v,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let p=class extends _.ExtHostTaskBase{constructor(m,c,l,s,i,r,n,a,d){super(m,c,l,s,i,r,n,a);this.workspaceService=l,this.variableResolver=d,c.remote.isRemote&&c.remote.authority?this.registerTaskSystem(T.Schemas.vscodeRemote,{scheme:T.Schemas.vscodeRemote,authority:c.remote.authority,platform:process.platform}):this.registerTaskSystem(T.Schemas.file,{scheme:T.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(m,c){const l=c;if(!c.execution&&l._id===void 0)throw new Error("Tasks to execute must include an execution");if(l._id!==void 0){const s=_.TaskHandleDTO.from(l,this.workspaceService),i=await this._proxy.$getTaskExecution(s);if(i.task===void 0)throw new Error("Task from execution DTO is undefined");const r=await this.getTaskExecution(i,c);return this._proxy.$executeTask(s).catch(()=>{}),r}else{const s=_.TaskDTO.from(c,m);if(s===void 0)return Promise.reject(new Error("Task is not valid"));_.CustomExecutionDTO.is(s.execution)&&await this.addCustomExecution(s,c,!1);const i=await this.getTaskExecution(await this._proxy.$getTaskExecution(s),c);return this._proxy.$executeTask(s).catch(()=>{}),i}}provideTasksInternal(m,c,l,s){const i=[];if(s)for(const r of s){this.checkDeprecation(r,l),(!r.definition||!m[r.definition.type])&&this._logService.warn(`The task [${r.source}, ${r.name}] uses an undefined task type. The task will be ignored in the future.`);const n=_.TaskDTO.from(r,l.extension);n&&(i.push(n),_.CustomExecutionDTO.is(n.execution)&&c.push(this.addCustomExecution(n,r,!0)))}return{tasks:i,extension:l.extension}}async resolveTaskInternal(m){return m}async getAFolder(m){let c=m&&m.length>0?m[0]:void 0;if(!c){const l=t.URI.file((0,h.homedir)());c=new E.WorkspaceFolder({uri:l,name:v.basename(l),index:0})}return{uri:c.uri,name:c.name,index:c.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(m,c){const l=t.URI.revive(m),s={process:void 0,variables:Object.create(null)},i=await this._workspaceProvider.resolveWorkspaceFolder(l),r=await this._workspaceProvider.getWorkspaceFolders2()??[],n=await this.variableResolver.getResolver(),a=i?{uri:i.uri,name:i.name,index:i.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(r);for(const d of c.variables)s.variables[d]=await n.resolveAsync(a,d);if(c.process!==void 0){let d;if(c.process.path!==void 0){d=c.process.path.split(u.delimiter);for(let f=0;f<d.length;f++)d[f]=await n.resolveAsync(a,d[f])}s.process=await D.win32.findExecutable(await n.resolveAsync(a,c.process.name),c.process.cwd!==void 0?await n.resolveAsync(a,c.process.cwd):void 0,d)}return s}async $jsonTasksSupported(){return!0}async $findExecutable(m,c,l){return D.win32.findExecutable(m,c,l)}};p=je([xe(0,R.IExtHostRpcService),xe(1,k.IExtHostInitDataService),xe(2,P.IExtHostWorkspace),xe(3,y.IExtHostDocumentsAndEditors),xe(4,C.IExtHostConfiguration),xe(5,I.IExtHostTerminalService),xe(6,w.ILogService),xe(7,b.IExtHostApiDeprecationService),xe(8,g.IExtHostVariableResolverProvider)],p),e.ExtHostTask=p}),define(De[285],Ie([1,0,81,47]),function(Z,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostVariableResolverProviderService=void 0;class D extends t.ExtHostVariableResolverProviderService{homeDir(){return(0,u.homedir)()}}e.NodeExtHostVariableResolverProviderService=D}),define(De[139],Ie([1,0,17,18,21,50,12,9,22,2,30]),function(Z,e,u,t,D,P,y,C,E,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class k{constructor(g,p,o,m){this.query=g,this.provider=p,this.fileUtils=o,this.processType=m,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(g,p){const o=this.query.folderQueries||[],m=new D.CancellationTokenSource;return p.onCancellationRequested(()=>m.cancel()),new Promise((c,l)=>{this.collector=new T(g);let s=!1;const i=(r,n)=>{if(!s&&!this.isLimitHit){const a=this.resultSize(r);b(r)&&typeof this.query.maxResults=="number"&&this.resultCount+a>this.query.maxResults&&(this.isLimitHit=!0,s=!0,m.cancel(),r=this.trimResultToSize(r,this.query.maxResults-this.resultCount));const d=this.resultSize(r);this.resultCount+=d,(d>0||!b(r))&&this.collector.add(r,n)}};Promise.all(o.map((r,n)=>this.searchInFolder(r,a=>i(a,n),m.token))).then(r=>{m.dispose(),this.collector.flush();const n=r.some(a=>!!a&&!!a.limitHit);c({limitHit:this.isLimitHit||n,messages:(0,u.flatten)(r.map(a=>a?.message?Array.isArray(a.message)?a.message:[a.message]:[])),stats:{type:this.processType}})},r=>{m.dispose();const n=(0,P.toErrorMessage)(r);l(new Error(n))})})}resultSize(g){return b(g)?Array.isArray(g.ranges)?g.ranges.length:1:0}trimResultToSize(g,p){const o=Array.isArray(g.ranges)?g.ranges:[g.ranges],m=Array.isArray(g.preview.matches)?g.preview.matches:[g.preview.matches];return{ranges:o.slice(0,p),preview:{matches:m.slice(0,p),text:g.preview.text},uri:g.uri}}async searchInFolder(g,p,o){const m=new R.QueryGlobTester(this.query,g),c=[],l={report:r=>{if(!this.validateProviderResult(r))return;const n=g.folder.scheme===y.Schemas.file?(0,R.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(E.dirname(r.uri))):void 0,a=E.relativePath(g.folder,r.uri);if(a){const d=m.includedInQuery(a,C.basename(a),n);(0,t.isThenable)(d)?c.push(d.then(f=>{f&&p(r)})):d&&p(r)}}},s=this.getSearchOptionsForFolder(g),i=await this.provider.provideTextSearchResults(_(this.query.contentPattern),s,l,o);return c.length&&await Promise.all(c),i}validateProviderResult(g){if(b(g)){if(Array.isArray(g.ranges)){if(!Array.isArray(g.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(g.preview.matches.length!==g.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(g.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(g){const p=(0,R.resolvePatternsForProvider)(this.query.includePattern,g.includePattern),o=(0,R.resolvePatternsForProvider)(this.query.excludePattern,g.excludePattern),m={folder:I.URI.from(g.folder),excludes:o,includes:p,useIgnoreFiles:!g.disregardIgnoreFiles,useGlobalIgnoreFiles:!g.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!g.disregardParentIgnoreFiles,followSymlinks:!g.ignoreSymlinks,encoding:g.fileEncoding&&this.fileUtils.toCanonicalName(g.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return m.usePCRE2=this.query.usePCRE2,m}}e.TextSearchManager=k;function _(h){return{isCaseSensitive:h.isCaseSensitive||!1,isRegExp:h.isRegExp||!1,isWordMatch:h.isWordMatch||!1,isMultiline:h.isMultiline||!1,pattern:h.pattern}}class T{constructor(g){this._onResult=g,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new v(512,p=>this.sendItems(p))}add(g,p){this._currentFileMatch&&(this._currentFolderIdx!==p||!E.isEqual(this._currentUri,g.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=p,this._currentFileMatch={resource:g.uri,results:[]}),this._currentFileMatch.results.push(w(g))}pushToCollector(){const g=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,g)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(g){this._onResult(g)}}e.TextSearchResultsCollector=T;function w(h){return b(h)?{preview:{matches:(0,u.mapArrayOrNot)(h.preview.matches,g=>({startLineNumber:g.start.line,startColumn:g.start.character,endLineNumber:g.end.line,endColumn:g.end.character})),text:h.preview.text},ranges:(0,u.mapArrayOrNot)(h.ranges,g=>({startLineNumber:g.start.line,startColumn:g.start.character,endLineNumber:g.end.line,endColumn:g.end.character}))}:{text:h.text,lineNumber:h.lineNumber}}function b(h){return!!h.preview}e.extensionResultIsMatch=b;class v{constructor(g,p){this.maxBatchSize=g,this.cb=p,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(g,p){!g||this.addItemToBatch(g,p)}addItems(g,p){!g||this.addItemsToBatch(g,p)}addItemToBatch(g,p){this.batch.push(g),this.batchSize+=p,this.onUpdate()}addItemsToBatch(g,p){this.batch=this.batch.concat(g),this.batchSize+=p,this.onUpdate()}onUpdate(){this.totalNumberCompleted<v.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},v.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=v,v.TIMEOUT=4e3,v.START_BATCH_AFTER_COUNT=50}),define(De[75],Ie([1,0,6,5,3,278,15,64,14,2,139]),function(Z,e,u,t,D,P,y,C,E,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,D.createDecorator)("IExtHostSearch");let k=class{constructor(b,v,h){this.extHostRpc=b,this._uriTransformer=v,this._logService=h,this._proxy=this.extHostRpc.getProxy(t.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new P.FileSearchManager}_transformScheme(b){return this._uriTransformer.transformOutgoingScheme(b)}registerTextSearchProvider(b,v){if(this._textSearchUsedSchemes.has(b))throw new Error(`a text search provider for the scheme '${b}' is already registered`);this._textSearchUsedSchemes.add(b);const h=this._handlePool++;return this._textSearchProvider.set(h,v),this._proxy.$registerTextSearchProvider(h,this._transformScheme(b)),(0,u.toDisposable)(()=>{this._textSearchUsedSchemes.delete(b),this._textSearchProvider.delete(h),this._proxy.$unregisterProvider(h)})}registerFileSearchProvider(b,v){if(this._fileSearchUsedSchemes.has(b))throw new Error(`a file search provider for the scheme '${b}' is already registered`);this._fileSearchUsedSchemes.add(b);const h=this._handlePool++;return this._fileSearchProvider.set(h,v),this._proxy.$registerFileSearchProvider(h,this._transformScheme(b)),(0,u.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(b),this._fileSearchProvider.delete(h),this._proxy.$unregisterProvider(h)})}$provideFileSearchResults(b,v,h,g){const p=_(h),o=this._fileSearchProvider.get(b);if(o)return this._fileSearchManager.fileSearch(p,o,m=>{this._proxy.$handleFileMatch(b,v,m.map(c=>c.resource))},g);throw new Error("unknown provider: "+b)}$clearCache(b){return this._fileSearchManager.clearCache(b),Promise.resolve(void 0)}$provideTextSearchResults(b,v,h,g){const p=this._textSearchProvider.get(b);if(!p||!p.provideTextSearchResults)throw new Error(`Unknown provider ${b}`);const o=_(h);return this.createTextSearchManager(o,p).search(c=>this._proxy.$handleTextMatch(b,v,c),g)}$enableExtensionHostSearch(){}createTextSearchManager(b,v){return new R.TextSearchManager(b,v,{readdir:h=>Promise.resolve([]),toCanonicalName:h=>h},"textSearchProvider")}};k=je([xe(0,y.IExtHostRpcService),xe(1,C.IURITransformerService),xe(2,E.ILogService)],k),e.ExtHostSearch=k;function _(w){return{...w,folderQueries:w.folderQueries&&w.folderQueries.map(T),extraFileResources:w.extraFileResources&&w.extraFileResources.map(b=>I.URI.revive(b))}}e.reviveQuery=_;function T(w){return{...w,folder:I.URI.revive(w.folder)}}}),define(De[286],Ie([1,0,82,138,32,134,33,37,55,38,72,74,75,91,53,67,137,68,46,90,124,56,135,14,229,47,136]),function(Z,e,u,t,D,P,y,C,E,I,R,k,_,T,w,b,v,h,g,p,o,m,c,l,s,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,u.registerSingleton)(l.ILoggerService,c.ExtHostLoggerService),(0,u.registerSingleton)(l.ILogService,s.ExtHostLogService),(0,u.registerSingleton)(b.IExtHostApiDeprecationService,b.ExtHostApiDeprecationService),(0,u.registerSingleton)(C.IExtHostCommands,C.ExtHostCommands),(0,u.registerSingleton)(y.IExtHostConfiguration,y.ExtHostConfiguration),(0,u.registerSingleton)(h.IExtHostConsumerFileSystem,h.ExtHostConsumerFileSystem),(0,u.registerSingleton)(k.IExtHostDebugService,k.WorkerExtHostDebugService),(0,u.registerSingleton)(P.IExtHostDecorations,P.ExtHostDecorations),(0,u.registerSingleton)(E.IExtHostDocumentsAndEditors,E.ExtHostDocumentsAndEditors),(0,u.registerSingleton)(g.IExtHostFileSystemInfo,g.ExtHostFileSystemInfo),(0,u.registerSingleton)(t.IExtHostOutputService,t.ExtHostOutputService),(0,u.registerSingleton)(_.IExtHostSearch,_.ExtHostSearch),(0,u.registerSingleton)(T.IExtHostStorage,T.ExtHostStorage),(0,u.registerSingleton)(R.IExtHostTask,R.WorkerExtHostTask),(0,u.registerSingleton)(I.IExtHostTerminalService,I.WorkerExtHostTerminalService),(0,u.registerSingleton)(w.IExtHostTunnelService,w.ExtHostTunnelService),(0,u.registerSingleton)(v.IExtHostWindow,v.ExtHostWindow),(0,u.registerSingleton)(D.IExtHostWorkspace,D.ExtHostWorkspace),(0,u.registerSingleton)(p.IExtHostSecretState,p.ExtHostSecretState),(0,u.registerSingleton)(o.IExtHostTelemetry,o.ExtHostTelemetry),(0,u.registerSingleton)(r.IExtHostTelemetryLogService,r.ExtHostTelemetryLogService),(0,u.registerSingleton)(m.IExtHostEditorTabs,m.ExtHostEditorTabs),(0,u.registerSingleton)(i.IExtHostVariableResolverProvider,i.ExtHostVariableResolverProviderService)}),define(De[92],Ie([1,0,17,14,30,71]),function(Z,e,u,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function y(k){return k.startsWith("**")||k.startsWith("/")?k:`/${k}`}e.anchorGlob=y;function C(k,_,T,w){const b=(0,u.mapArrayOrNot)(T,E),v=new D.TextSearchMatch(_,b,w),h=v.preview.matches;return{ranges:(0,u.mapArrayOrNot)(b,I),uri:k,preview:{text:v.preview.text,matches:(0,u.mapArrayOrNot)(h,I)}}}e.createTextSearchResult=C;function E(k){return new D.SearchRange(k.start.line,k.start.character,k.end.line,k.end.character)}function I(k){return new P.Range(k.startLineNumber,k.startColumn,k.endLineNumber,k.endColumn)}let R=class{constructor(_,T){this.prefix=_,this.logService=T}appendLine(_){this.logService.debug(`${this.prefix}#search`,_)}};R=je([xe(1,t.ILogService)],R),e.OutputChannel=R}),define(De[287],Ie([1,0,44,9,80,31,11,8,92,288]),function(Z,e,u,t,D,P,y,C,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const R=I.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function k(p,o,m,c){const l=_(p,o,m,c),s=o.folder.fsPath;return{cmd:u.spawn(R,l.args,{cwd:s}),rgDiskPath:R,siblingClauses:l.siblingClauses,rgArgs:l,cwd:s}}e.spawnRipgrepCmd=k;function _(p,o,m,c){const l=["--files","--hidden","--case-sensitive"];w([o],m,!1).forEach(i=>{const r=(0,E.anchorGlob)(i);if(l.push("-g",r),y.isMacintosh){const n=(0,D.normalizeNFD)(r);n!==r&&l.push("-g",n)}});const s=T([o],c,void 0,!1);return s.globArgs.forEach(i=>{const r=`!${(0,E.anchorGlob)(i)}`;if(l.push("-g",r),y.isMacintosh){const n=(0,D.normalizeNFD)(r);n!==r&&l.push("-g",n)}}),o.disregardIgnoreFiles!==!1?l.push("--no-ignore"):o.disregardParentIgnoreFiles!==!1&&l.push("--no-ignore-parent"),o.ignoreSymlinks||l.push("--follow"),p.exists&&l.push("--quiet"),l.push("--no-config"),o.disregardGlobalIgnoreFiles&&l.push("--no-ignore-global"),{args:l,siblingClauses:s.siblingClauses}}function T(p,o,m,c=!0){const l=[];let s={};return p.forEach(i=>{const r=Object.assign({},i.excludePattern||{},o||{}),n=b(r,c?i.folder.fsPath:void 0,m);l.push(...n.globArgs),n.siblingClauses&&(s=Object.assign(s,n.siblingClauses))}),{globArgs:l,siblingClauses:s}}e.foldersToRgExcludeGlobs=T;function w(p,o,m=!0){const c=[];return p.forEach(l=>{const s=Object.assign({},o||{},l.includePattern||{}),i=b(s,m?l.folder.fsPath:void 0);c.push(...i.globArgs)}),c}e.foldersToIncludeGlobs=w;function b(p,o,m){const c=[],l={};return Object.keys(p).forEach(s=>{if(m&&m.has(s)||!s)return;const i=p[s];s=h(o?v(o,s):s),s.startsWith("\\\\")?s="\\\\"+s.substr(2).replace(/\\/g,"/"):s=s.replace(/\\/g,"/"),typeof i=="boolean"&&i?(s.startsWith("\\\\")&&(s+="**"),c.push(g(s))):i&&i.when&&(l[s]=i)}),{globArgs:c,siblingClauses:l}}function v(p,o){return t.isAbsolute(o)?o:t.join(p,o)}e.getAbsoluteGlob=v;function h(p){return p=C.rtrim(p,"\\"),C.rtrim(p,"/")}function g(p){return P.getRoot(p).toLowerCase()==="c:/"?p.replace(/^c:[/\\]/i,"/"):p}e.fixDriveC=g}),define(De[289],Ie([1,0,44,62,9,290,17,50,36,80,31,11,51,8,13,29,30,287,104]),function(Z,e,u,t,D,P,y,C,E,I,R,k,_,T,w,b,v,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const p=new Set;process.on("exit",()=>{p.forEach(s=>s())});class o{constructor(i){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=i,this.filePattern=i.filePattern||"",this.includePattern=i.includePattern&&E.parse(i.includePattern),this.maxResults=i.maxResults||null,this.exists=!!i.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,g.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=i.excludePattern&&E.parse(i.excludePattern),this.folderExcludePatterns=new Map,i.folderQueries.forEach(r=>{const n=Object.assign({},r.excludePattern||{},this.config.excludePattern||{}),a=r.folder.fsPath;i.folderQueries.map(d=>d.folder.fsPath).filter(d=>d!==a).forEach(d=>{(0,R.isEqualOrParent)(d,a)&&(n[D.relative(a,d)]=!0)}),this.folderExcludePatterns.set(a,new c(n,a))})}cancel(){this.isCanceled=!0,p.forEach(i=>i())}walk(i,r,n,a,d){if(this.fileWalkSW=_.StopWatch.create(!1),this.isCanceled)return d(null,this.isLimitHit);r.forEach(f=>{const S=D.basename(f.fsPath);this.globalExcludePattern&&this.globalExcludePattern(f.fsPath,S)||this.matchFile(n,{relativePath:f.fsPath,searchPath:void 0})}),this.cmdSW=_.StopWatch.create(!1),this.parallel(i,(f,S)=>{this.call(this.cmdTraversal,this,f,n,a,O=>{if(O){const U=(0,C.toErrorMessage)(O);console.error(U),this.errors.push(U),S(O,void 0)}else S(null,void 0)})},(f,S)=>{this.fileWalkSW.stop();const O=f?y.coalesce(f)[0]:null;d(O,this.isLimitHit)})}parallel(i,r,n){const a=new Array(i.length),d=new Array(i.length);let f=!1,S=0;if(i.length===0)return n(null,[]);i.forEach((O,U)=>{r(O,(M,A)=>{if(M?(f=!0,a[U]=null,d[U]=M):(a[U]=A,d[U]=null),++S===i.length)return n(f?d:null,a)})})}call(i,r,...n){try{i.apply(r,n)}catch(a){n[n.length-1](a)}}cmdTraversal(i,r,n,a){const d=i.folder.fsPath,f=k.isMacintosh,S=()=>B&&B.kill();p.add(S);let O=X=>{p.delete(S),O=()=>{},a(X)},U="";const M=this.initDirectoryTree(),A=(0,h.spawnRipgrepCmd)(this.config,i,this.config.includePattern,this.folderExcludePatterns.get(i.folder.fsPath).expression),B=A.cmd,x=!Object.keys(A.siblingClauses).length,N=A.rgArgs.args.map(X=>X.match(/^-/)?X:`'${X}'`).join(" ");let K=`${A.rgDiskPath} ${N}
 - cwd: ${A.cwd}`;A.rgArgs.siblingClauses&&(K+=`
 - Sibling clauses: ${JSON.stringify(A.rgArgs.siblingClauses)}`),n({message:K}),this.cmdResultCount=0,this.collectStdout(B,"utf8",n,(X,L,$)=>{if(X){O(X);return}if(this.isLimitHit){O();return}const j=(U+(f?I.normalizeNFC(L||""):L)).split(`
`);if($){const J=j.length;j[J-1]=j[J-1].trim(),j[J-1]||j.pop()}else U=j.pop()||"";if(j.length&&j[0].indexOf(`
`)!==-1){O(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=j.length,x){for(const J of j)if(this.matchFile(r,{base:d,relativePath:J,searchPath:this.getSearchPath(i,J)}),this.isLimitHit){S();break}($||this.isLimitHit)&&O();return}this.addDirectoryEntries(i,M,d,j,r),$&&(this.matchDirectoryTree(M,d,r),O())})}spawnFindCmd(i){const r=this.folderExcludePatterns.get(i.folder.fsPath),n=r.getBasenameTerms(),a=r.getPathTerms(),d=["-L","."];if(n.length||a.length){d.push("-not","(","(");for(const f of n)d.push("-name",f),d.push("-o");for(const f of a)d.push("-path",f),d.push("-o");d.pop(),d.push(")","-prune",")")}return d.push("-type","f"),u.spawn("find",d,{cwd:i.folder.fsPath})}readStdout(i,r,n){let a="";this.collectStdout(i,r,()=>{},(d,f,S)=>{if(d){n(d);return}a+=f,S&&n(null,a)})}collectStdout(i,r,n,a){let d=(O,U,M)=>{(O||M)&&(d=()=>{},this.cmdSW?.stop()),a(O,U,M)},f=!1;i.stdout?(this.forwardData(i.stdout,r,d),i.stdout.once("data",()=>f=!0)):n({message:"stdout is null"});let S;i.stderr?S=this.collectData(i.stderr):n({message:"stderr is null"}),i.on("error",O=>{d(O)}),i.on("close",O=>{let U;!f&&(U=this.decodeData(S,r))&&l(U)?d(new Error(`command failed with error code ${O}: ${this.decodeData(S,r)}`)):(this.exists&&O===0&&(this.isLimitHit=!0),d(null,"",!0))})}forwardData(i,r,n){const a=new P.StringDecoder(r);return i.on("data",d=>{n(null,a.write(d))}),a}collectData(i){const r=[];return i.on("data",n=>{r.push(n)}),r}decodeData(i,r){const n=new P.StringDecoder(r);return i.map(a=>n.write(a)).join("")}initDirectoryTree(){const i={rootEntries:[],pathToEntries:Object.create(null)};return i.pathToEntries["."]=i.rootEntries,i}addDirectoryEntries(i,{pathToEntries:r},n,a,d){a.indexOf(this.filePattern)!==-1&&this.matchFile(d,{base:n,relativePath:this.filePattern,searchPath:this.getSearchPath(i,this.filePattern)});const f=S=>{const O=D.basename(S),U=D.dirname(S);let M=r[U];M||(M=r[U]=[],f(U)),M.push({base:n,relativePath:S,basename:O,searchPath:this.getSearchPath(i,S)})};a.forEach(f)}matchDirectoryTree({rootEntries:i,pathToEntries:r},n,a){const d=this,f=this.folderExcludePatterns.get(n),S=this.filePattern;function O(U){d.directoriesWalked++;const M=(0,v.hasSiblingFn)(()=>U.map(A=>A.basename));for(let A=0,B=U.length;A<B;A++){const x=U[A],{relativePath:N,basename:K}=x;if(f.test(N,K,S!==K?M:void 0))continue;const X=r[N];if(X)O(X);else{if(d.filesWalked++,N===S)continue;d.matchFile(a,x)}if(d.isLimitHit)break}}O(i)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(i,r,n,a,d){const f=i.folder,S=(0,v.hasSiblingFn)(()=>n);this.parallel(n,(O,U)=>{if(this.isCanceled||this.isLimitHit)return U(null);const M=r?[r,O].join(D.sep):O;if(this.folderExcludePatterns.get(i.folder.fsPath).test(M,O,this.config.filePattern!==O?S:void 0))return U(null);const A=[f.fsPath,M].join(D.sep);t.lstat(A,(B,x)=>{if(B||this.isCanceled||this.isLimitHit)return U(null);this.statLinkIfNeeded(A,x,(N,K)=>N||this.isCanceled||this.isLimitHit?U(null):K.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(A,x,(X,L)=>X||this.isCanceled||this.isLimitHit||(L=L||"",this.walkedPaths[L])?U(null):(this.walkedPaths[L]=!0,b.Promises.readdir(A).then($=>{if(this.isCanceled||this.isLimitHit)return U(null);this.doWalk(i,M,$,a,H=>U(H||null))},$=>{U(null)})))):(this.filesWalked++,M===this.filePattern||this.maxFilesize&&w.isNumber(K.size)&&K.size>this.maxFilesize||this.matchFile(a,{base:f.fsPath,relativePath:M,searchPath:this.getSearchPath(i,M)}),U(null,void 0)))})},O=>{const U=O&&y.coalesce(O);return d(U&&U.length>0?U[0]:void 0)})}matchFile(i,r){this.isFileMatch(r)&&(!this.includePattern||this.includePattern(r.relativePath,D.basename(r.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||i(r))}isFileMatch(i){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,v.isFilePatternMatch)(i,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(i,r,n){return r.isSymbolicLink()?t.stat(i,n):n(null,r)}realPathIfNeeded(i,r,n){return r.isSymbolicLink()?t.realpath(i,(a,d)=>a?n(a):n(null,d)):n(null,i)}getSearchPath(i,r){return i.folderName?D.join(i.folderName,r):r}}e.FileWalker=o;class m{constructor(i){this.folderQueries=i.folderQueries,this.extraFiles=i.extraFileResources||[],this.walker=new o(i)}search(i,r,n){this.walker.walk(this.folderQueries,this.extraFiles,i,r,(a,d)=>{n(a,{limitHit:d,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=m;class c{constructor(i,r){this.expression=i,this.root=r,this.init(i)}init(i){let r,n;Object.keys(i).filter(a=>i[a]).forEach(a=>{D.isAbsolute(a)?(r=r||E.getEmptyExpression(),r[a]=i[a]):(n=n||E.getEmptyExpression(),n[a]=i[a])}),this.absoluteParsedExpr=r&&E.parse(r,{trimForExclusions:!0}),this.relativeParsedExpr=n&&E.parse(n,{trimForExclusions:!0})}test(i,r,n){return this.relativeParsedExpr&&this.relativeParsedExpr(i,r,n)||this.absoluteParsedExpr&&this.absoluteParsedExpr(D.join(this.root,i),r,n)}getBasenameTerms(){const i=[];return this.absoluteParsedExpr&&i.push(...E.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(...E.getBasenameTerms(this.relativeParsedExpr)),i}getPathTerms(){const i=[];return this.absoluteParsedExpr&&i.push(...E.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(...E.getPathTerms(this.relativeParsedExpr)),i}}function l(s){const i=s.trim().split(`
`),r=i[0].trim();if(r.startsWith("Error parsing regex"))return r;if(r.startsWith("regex parse error"))return T.uppercaseFirstLetter(i[i.length-1].trim());if(r.startsWith("error parsing glob")||r.startsWith("unsupported encoding"))return r.charAt(0).toUpperCase()+r.substr(1);if(r==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(r.startsWith("Literal "))return r}e.rgErrorMsgForDisplay=l}),define(De[291],Ie([1,0,95,23]),function(Z,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function D(s){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(i=>i===s)}e.isUTFEncoding=D,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const P=512,y=512,C=512*8,E=512*128;var I;(function(s){s[s.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(I=e.DecodeStreamErrorKind||(e.DecodeStreamErrorKind={}));class R extends Error{constructor(i,r){super(i);this.decodeStreamErrorKind=r}}e.DecodeStreamError=R;class k{constructor(i){this.iconvLiteDecoder=i}static async create(i){let r;if(i!==e.UTF8)r=(await new Promise((a,d)=>{Z(["@vscode/iconv-lite-umd"],a,d)})).getDecoder(b(i));else{const n=new TextDecoder;r={write(a){return n.decode(a,{stream:!0})},end(){return n.decode()}}}return new k(r)}write(i){return this.iconvLiteDecoder.write(i)}end(){return this.iconvLiteDecoder.end()}}function _(s,i){const r=i.minBytesRequiredForDetection??i.guessEncoding?C:y;return new Promise((n,a)=>{const d=(0,u.newWriteableStream)(A=>A.join("")),f=[];let S=0,O,U;const M=async()=>{try{const A=await l({buffer:t.VSBuffer.concat(f),bytesRead:S},i.guessEncoding);if(A.seemsBinary&&i.acceptTextOnly)throw new R("Stream is binary but only text is accepted for decoding",1);A.encoding=await i.overwriteEncoding(A.encoding),O=await k.create(A.encoding);const B=O.write(t.VSBuffer.concat(f).buffer);d.write(B),f.length=0,S=0,n({stream:d,detected:A})}catch(A){U?.dispose(),d.destroy(),a(A)}};U=(0,u.listenStream)(s,{onData:async A=>{O?d.write(O.write(A.buffer)):(f.push(A),S+=A.byteLength,S>=r&&(s.pause(),await M(),setTimeout(()=>s.resume())))},onError:A=>d.error(A),onEnd:async()=>{O||await M(),d.end(O?.end())}})})}e.toDecodeStream=_;async function T(s,i,r){const a=(await new Promise((S,O)=>{Z(["@vscode/iconv-lite-umd"],S,O)})).getEncoder(b(i),r);let d=!1,f=!1;return{read(){if(f)return null;const S=s.read();if(typeof S!="string"){if(f=!0,!d&&r?.addBOM)switch(i){case e.UTF8:case e.UTF8_with_bom:return t.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return t.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return t.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const O=a.end();return O&&O.length>0?(d=!0,t.VSBuffer.wrap(O)):null}return d=!0,t.VSBuffer.wrap(a.write(S))}}}e.toEncodeReadable=T;async function w(s){return(await new Promise((r,n)=>{Z(["@vscode/iconv-lite-umd"],r,n)})).encodingExists(b(s))}e.encodingExists=w;function b(s){return s===e.UTF8_with_bom||s===null?e.UTF8:s}e.toNodeEncoding=b;function v(s,i){if(!s||i<e.UTF16be_BOM.length)return null;const r=s.readUInt8(0),n=s.readUInt8(1);if(r===e.UTF16be_BOM[0]&&n===e.UTF16be_BOM[1])return e.UTF16be;if(r===e.UTF16le_BOM[0]&&n===e.UTF16le_BOM[1])return e.UTF16le;if(i<e.UTF8_BOM.length)return null;const a=s.readUInt8(2);return r===e.UTF8_BOM[0]&&n===e.UTF8_BOM[1]&&a===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=v;const h=["ascii","utf-16","utf-32"];async function g(s){const i=await new Promise((f,S)=>{Z(["jschardet"],f,S)}),r=s.slice(0,E),n=m(r.buffer),a=i.detect(n);if(!a||!a.encoding)return null;const d=a.encoding.toLowerCase();return 0<=h.indexOf(d)?null:o(a.encoding)}const p={ibm866:"cp866",big5:"cp950"};function o(s){const i=s.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return p[i]||i}function m(s){let i="";for(let r=0;r<s.length;r++)i+=String.fromCharCode(s[r]);return i}function c(s){switch(s){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const i=s.match(/windows(\d+)/);return i?"windows-"+i[1]:s}}}e.toCanonicalName=c;function l({buffer:s,bytesRead:i},r){let n=v(s,i),a=!1;if(n!==e.UTF16be&&n!==e.UTF16le&&s){let d=!0,f=!0,S=!1;for(let O=0;O<i&&O<P;O++){const U=O%2==1,M=s.readUInt8(O)===0;if(M&&(S=!0),d&&(U&&!M||!U&&M)&&(d=!1),f&&(U&&M||!U&&!M)&&(f=!1),M&&!d&&!f)break}S&&(d?n=e.UTF16le:f?n=e.UTF16be:a=!0)}return r&&!a&&!n&&s?g(s.slice(0,i)).then(d=>({seemsBinary:!1,encoding:d})):{seemsBinary:a,encoding:n}}e.detectEncodingFromBuffer=l,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(De[140],Ie([1,0,291,29,139]),function(Z,e,u,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class P extends D.TextSearchManager{constructor(C,E,I=t,R="searchProcess"){super(C,E,{readdir:k=>I.Promises.readdir(k.fsPath),toCanonicalName:k=>(0,u.toCanonicalName)(k)},R)}}e.NativeTextSearchManager=P}),define(De[292],Ie([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class u{constructor(){this._dragOperations=new Map,this._renderedElements=new Map}removeDragOperationTransfer(D){if(D&&this._dragOperations.has(D)){const P=this._dragOperations.get(D);return this._dragOperations.delete(D),P}}addDragOperationTransfer(D,P){this._dragOperations.set(D,P)}getRenderedTreeElement(D){if(this._renderedElements.has(D))return this._renderedElements.get(D)}addRenderedTreeItemElement(D,P){this._renderedElements.set(D,P)}removeRenderedTreeItemElement(D){this._renderedElements.has(D)&&this._renderedElements.delete(D)}}e.TreeviewsService=u}),define(De[293],Ie([1,0,173,7,22,2,4,6,18,7,13,17,16,21,292,27]),function(Z,e,u,t,D,P,y,C,E,I,R,k,_,T,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function v(p,o){if((0,R.isString)(p))return{label:p};if(p&&typeof p=="object"&&typeof p.label=="string"){let m;return Array.isArray(p.highlights)&&(m=p.highlights.filter(c=>c.length===2&&typeof c[0]=="number"&&typeof c[1]=="number"),m=m.length?m:void 0),{label:p.label,highlights:m}}}class h{constructor(o,m,c){this._proxy=o,this.commands=m,this.logService=c,this.treeViews=new Map,this.treeDragAndDropService=new w.TreeviewsService;function l(s){return s&&s.$treeViewId&&(s.$treeItemHandle||s.$selectedTreeItems)}m.registerArgumentProcessor({processArgument:s=>l(s)?this.convertArgument(s):Array.isArray(s)&&s.length>0?s.map(i=>l(i)?this.convertArgument(i):i):s})}registerTreeDataProvider(o,m,c){const l=this.createTreeView(o,{treeDataProvider:m},c);return{dispose:()=>l.dispose()}}createTreeView(o,m,c){if(!m||!m.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const l=m.dragAndDropController?.dropMimeTypes??[],s=m.dragAndDropController?.dragMimeTypes??[],i=!!m.dragAndDropController?.handleDrag,r=!!m.dragAndDropController?.handleDrop,n=this._proxy.$registerTreeViewDataProvider(o,{showCollapseAll:!!m.showCollapseAll,canSelectMany:!!m.canSelectMany,dropMimeTypes:l,dragMimeTypes:s,hasHandleDrag:i,hasHandleDrop:r}),a=this.createExtHostTreeView(o,m,c);return{get onDidCollapseElement(){return a.onDidCollapseElement},get onDidExpandElement(){return a.onDidExpandElement},get selection(){return a.selectedElements},get onDidChangeSelection(){return a.onDidChangeSelection},get visible(){return a.visible},get onDidChangeVisibility(){return a.onDidChangeVisibility},get message(){return a.message},set message(d){a.message=d},get title(){return a.title},set title(d){a.title=d},get description(){return a.description},set description(d){a.description=d},get badge(){return(0,b.checkProposedApiEnabled)(c,"badges"),a.badge},set badge(d){(0,b.checkProposedApiEnabled)(c,"badges"),a.badge=d},reveal:(d,f)=>a.reveal(d,f),dispose:async()=>{await n,this.treeViews.delete(o),a.dispose()}}}$getChildren(o,m){const c=this.treeViews.get(o);return c?c.getChildren(m):Promise.reject(new Error((0,u.localize)(0,null,o)))}async $handleDrop(o,m,c,l,s,i,r,n){const a=this.treeViews.get(o);if(!a)return Promise.reject(new Error((0,u.localize)(1,null,o)));const d=_.DataTransfer.toDataTransfer(c,async f=>(await this._proxy.$resolveDropFileData(o,m,f)).buffer);return r===o&&n&&await this.addAdditionalTransferItems(d,a,n,s,i),a.onDrop(d,l,s)}async addAdditionalTransferItems(o,m,c,l,s){const i=this.treeDragAndDropService.removeDragOperationTransfer(s);if(i)(await i)?.forEach((r,n)=>{r&&o.set(n,r)});else if(s&&m.handleDrag){const r=m.handleDrag(c,o,l);this.treeDragAndDropService.addDragOperationTransfer(s,r),await r}return o}async $handleDrag(o,m,c,l){const s=this.treeViews.get(o);if(!s)return Promise.reject(new Error((0,u.localize)(2,null,o)));const i=await this.addAdditionalTransferItems(new t.DataTransfer,s,m,l,c);if(!!i)return _.DataTransfer.toDataTransferDTO(i)}async $hasResolve(o){const m=this.treeViews.get(o);if(!m)throw new Error((0,u.localize)(3,null,o));return m.hasResolve}$resolve(o,m,c){const l=this.treeViews.get(o);if(!l)throw new Error((0,u.localize)(4,null,o));return l.resolveTreeItem(m,c)}$setExpanded(o,m,c){const l=this.treeViews.get(o);if(!l)throw new Error((0,u.localize)(5,null,o));l.setExpanded(m,c)}$setSelection(o,m){const c=this.treeViews.get(o);if(!c)throw new Error((0,u.localize)(6,null,o));c.setSelection(m)}$setVisible(o,m){const c=this.treeViews.get(o);if(!c)throw new Error((0,u.localize)(7,null,o));c.setVisible(m)}createExtHostTreeView(o,m,c){const l=new g(o,m,this._proxy,this.commands.converter,this.logService,c);return this.treeViews.set(o,l),l}convertArgument(o){const m=this.treeViews.get(o.$treeViewId);return m&&"$treeItemHandle"in o?m.getExtensionElement(o.$treeItemHandle):m&&"$selectedTreeItems"in o&&o.$selectedTreeItems?{selectedTreeItems:m.selectedElements}:null}}e.ExtHostTreeViews=h;class g extends C.Disposable{constructor(o,m,c,l,s,i){super();if(this.viewId=o,this.proxy=c,this.commands=l,this.logService=s,this.extension=i,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new y.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new y.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new y.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new y.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new y.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new T.CancellationTokenSource,i.contributes&&i.contributes.views)for(const a in i.contributes.views)for(const d of i.contributes.views[a])d.id===o&&(this._title=d.name);this.dataProvider=m.treeDataProvider,this.dndController=m.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(a=>this._onDidChangeData.fire({message:!1,element:a})));let r,n;this._register(y.Event.debounce(this._onDidChangeData.event,(a,d)=>(a||(a={message:!1,elements:[]}),d.element!==!1&&(r||(r=new Promise(f=>n=f),this.refreshPromise=this.refreshPromise.then(()=>r)),Array.isArray(d.element)?a.elements.push(...d.element):a.elements.push(d.element)),d.message&&(a.message=!0),a),200,!0)(({message:a,elements:d})=>{d.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const f=n;return r=null,this.refresh(d).then(()=>f())})),a&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(o=>this.getExtensionElement(o)).filter(o=>!(0,R.isUndefinedOrNull)(o))}async getChildren(o){const m=o?this.getExtensionElement(o):void 0;if(o&&!m)return this.logService.error(`No tree item with id '${o}' found.`),Promise.resolve([]);let c=this.getChildrenNodes(o);return c||(c=await this.fetchChildrenNodes(m)),c?c.map(l=>l.item):void 0}getExtensionElement(o){return this.elements.get(o)}reveal(o,m){m=m||{select:!0,focus:!1};const c=(0,R.isUndefinedOrNull)(m.select)?!0:m.select,l=(0,R.isUndefinedOrNull)(m.focus)?!1:m.focus,s=(0,R.isUndefinedOrNull)(m.expand)?!1:m.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):o?this.refreshPromise.then(()=>this.resolveUnknownParentChain(o)).then(i=>this.resolveTreeNode(o,i[i.length-1]).then(r=>this.proxy.$reveal(this.viewId,{item:r.item,parentChain:i.map(n=>n.item)},{select:c,focus:l,expand:s})),i=>this.logService.error(i)):this.proxy.$reveal(this.viewId,void 0,{select:c,focus:l,expand:s})}get message(){return this._message}set message(o){this._message=o,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(o){this._title=o,this.proxy.$setTitle(this.viewId,o,this._description)}get description(){return this._description}set description(o){this._description=o,this.proxy.$setTitle(this.viewId,this._title,o)}get badge(){return this._badge}set badge(o){this._badge?.value===o?.value&&this._badge?.tooltip===o?.tooltip||(this._badge=_.ViewBadge.from(o),this.proxy.$setBadge(this.viewId,o))}setExpanded(o,m){const c=this.getExtensionElement(o);c&&(m?this._onDidExpandElement.fire(Object.freeze({element:c})):this._onDidCollapseElement.fire(Object.freeze({element:c})))}setSelection(o){(0,k.equals)(this._selectedHandles,o)||(this._selectedHandles=o,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(o){o!==this._visible&&(this._visible=o,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async handleDrag(o,m,c){const l=[];for(const s of o){const i=this.getExtensionElement(s);i&&l.push(i)}if(!(!this.dndController?.handleDrag||l.length===0))return await this.dndController.handleDrag(l,m,c),m}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(o,m,c){const l=m?this.getExtensionElement(m):void 0;if(!(!l&&m||!this.dndController?.handleDrop))return(0,E.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(l,o,c):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(o,m){if(!this.dataProvider.resolveTreeItem)return;const c=this.elements.get(o);if(c){const l=this.nodes.get(c);if(l){const s=await this.dataProvider.resolveTreeItem(l.extensionItem,c,m)??l.extensionItem;return this.validateTreeItem(s),l.item.tooltip=this.getTooltip(s.tooltip),l.item.command=this.getCommand(l.disposableStore,s.command),l.item}}}resolveUnknownParentChain(o){return this.resolveParent(o).then(m=>m?this.resolveUnknownParentChain(m).then(c=>this.resolveTreeNode(m,c[c.length-1]).then(l=>(c.push(l),c))):Promise.resolve([]))}resolveParent(o){const m=this.nodes.get(o);return m?Promise.resolve(m.parent?this.elements.get(m.parent.item.handle):void 0):(0,E.asPromise)(()=>this.dataProvider.getParent(o))}resolveTreeNode(o,m){const c=this.nodes.get(o);return c?Promise.resolve(c):(0,E.asPromise)(()=>this.dataProvider.getTreeItem(o)).then(l=>this.createHandle(o,l,m,!0)).then(l=>this.getChildren(m?m.item.handle:void 0).then(()=>{const s=this.getExtensionElement(l);if(s){const i=this.nodes.get(s);if(i)return Promise.resolve(i)}throw new Error(`Cannot resolve tree item for element ${l}`)}))}getChildrenNodes(o){if(o){let m;if(typeof o=="string"){const c=this.getExtensionElement(o);m=c?this.nodes.get(c):void 0}else m=o;return m&&m.children||void 0}return this.roots}async fetchChildrenNodes(o){this.clearChildren(o);const m=new T.CancellationTokenSource(this._refreshCancellationSource.token);try{const c=o?this.nodes.get(o):void 0,l=await this.dataProvider.getChildren(o);if(m.token.isCancellationRequested)return;const s=await Promise.all((0,k.coalesce)(l||[]).map(async i=>{const r=await this.dataProvider.getTreeItem(i);return r&&!m.token.isCancellationRequested?this.createAndRegisterTreeNode(i,r,c):null}));return m.token.isCancellationRequested?void 0:(0,k.coalesce)(s)}finally{m.dispose()}}refresh(o){if(o.some(c=>!c))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new T.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const c=this.getHandlesToRefresh(o);if(c.length)return this.refreshHandles(c)}return Promise.resolve(void 0)}getHandlesToRefresh(o){const m=new Set,c=o.map(s=>this.nodes.get(s));for(const s of c)if(s&&!m.has(s.item.handle)){let i=s;for(;i&&i.parent&&c.findIndex(r=>i&&i.parent&&r&&r.item.handle===i.parent.item.handle)===-1;){const r=this.elements.get(i.parent.item.handle);i=r?this.nodes.get(r):void 0}i&&!i.parent&&m.add(s.item.handle)}const l=[];return m.forEach(s=>{const i=this.elements.get(s);if(i){const r=this.nodes.get(i);r&&(!r.parent||!m.has(r.parent.item.handle))&&l.push(s)}}),l}refreshHandles(o){const m={};return Promise.all(o.map(c=>this.refreshNode(c).then(l=>{l&&(m[c]=l.item)}))).then(()=>Object.keys(m).length?this.proxy.$refresh(this.viewId,m):void 0)}refreshNode(o){const m=this.getExtensionElement(o);if(m){const c=this.nodes.get(m);if(c)return this.clearChildren(m),(0,E.asPromise)(()=>this.dataProvider.getTreeItem(m)).then(l=>{if(l){const s=this.createTreeNode(m,l,c.parent);return this.updateNodeCache(m,s,c,c.parent),c.dispose(),s}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(o,m,c){const l=this.createTreeNode(o,m,c);if(m.id&&this.elements.has(l.item.handle))throw new Error((0,u.localize)(8,null,m.id));return this.addNodeToCache(o,l),this.addNodeToParentCache(l,c),l}getTooltip(o){return I.MarkdownString.isMarkdownString(o)?_.MarkdownString.from(o):o}getCommand(o,m){return m?{...this.commands.toInternal(m,o),originalId:m.command}:void 0}validateTreeItem(o){I.TreeItem.isTreeItem(o)||console.log(`Extension ${this.extension.identifier.value} has provided an invalid tree item.`)}createTreeNode(o,m,c){this.validateTreeItem(m);const l=new C.DisposableStore,s=this.createHandle(o,m,c),i=this.getLightIconPath(m);return{item:{handle:s,parentHandle:c?c.item.handle:void 0,label:v(m.label,this.extension),description:m.description,resourceUri:m.resourceUri,tooltip:this.getTooltip(m.tooltip),command:this.getCommand(l,m.command),contextValue:m.contextValue,icon:i,iconDark:this.getDarkIconPath(m)||i,themeIcon:this.getThemeIcon(m),collapsibleState:(0,R.isUndefinedOrNull)(m.collapsibleState)?I.TreeItemCollapsibleState.None:m.collapsibleState,accessibilityInformation:m.accessibilityInformation},extensionItem:m,parent:c,children:void 0,disposableStore:l,dispose(){l.dispose()}}}getThemeIcon(o){return o.iconPath instanceof I.ThemeIcon?o.iconPath:void 0}createHandle(o,{id:m,label:c,resourceUri:l},s,i){if(m)return`${g.ID_HANDLE_PREFIX}/${m}`;const r=v(c,this.extension),n=s?s.item.handle:g.LABEL_HANDLE_PREFIX;let a=r?r.label:l?(0,D.basename)(l):"";a=a.indexOf("/")!==-1?a.replace("/","//"):a;const d=this.nodes.has(o)?this.nodes.get(o).item.handle:void 0,f=this.getChildrenNodes(s)||[];let S,O=0;do{if(S=`${n}/${O}:${a}`,i||!this.elements.has(S)||d===S)break;O++}while(O<=f.length);return S}getLightIconPath(o){if(o.iconPath&&!(o.iconPath instanceof I.ThemeIcon))return typeof o.iconPath=="string"||P.URI.isUri(o.iconPath)?this.getIconPath(o.iconPath):this.getIconPath(o.iconPath.light)}getDarkIconPath(o){if(o.iconPath&&!(o.iconPath instanceof I.ThemeIcon)&&o.iconPath.dark)return this.getIconPath(o.iconPath.dark)}getIconPath(o){return P.URI.isUri(o)?o:P.URI.file(o)}addNodeToCache(o,m){this.elements.set(m.item.handle,o),this.nodes.set(o,m)}updateNodeCache(o,m,c,l){this.elements.delete(m.item.handle),this.nodes.delete(o),m.item.handle!==c.item.handle&&this.elements.delete(c.item.handle),this.addNodeToCache(o,m);const s=this.getChildrenNodes(l)||[],i=s.filter(r=>r.item.handle===c.item.handle)[0];i&&s.splice(s.indexOf(i),1,m)}addNodeToParentCache(o,m){m?(m.children||(m.children=[]),m.children.push(o)):(this.roots||(this.roots=[]),this.roots.push(o))}clearChildren(o){if(o){const m=this.nodes.get(o);if(m){if(m.children)for(const c of m.children){const l=this.elements.get(c.item.handle);l&&this.clear(l)}m.children=void 0}}else this.clearAll()}clear(o){const m=this.nodes.get(o);if(m){if(m.children)for(const c of m.children){const l=this.elements.get(c.item.handle);l&&this.clear(l)}this.nodes.delete(o),this.elements.delete(m.item.handle),m.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(o=>o.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}g.LABEL_HANDLE_PREFIX="0",g.ID_HANDLE_PREFIX="1"}),define(De[294],Ie([1,0,21,10,4,41,2,114,99,147,156,42,5,133,238,237,37,239,33,241,242,243,221,244,55,39,245,246,249,250,251,138,224,255,256,257,91,38,259,293,16,7,262,70,137,32,210,248,122,134,72,74,75,14,64,15,26,252,206,53,67,235,260,69,68,265,263,264,236,46,258,261,90,56,124,253,71,254,12,117,223,204,247,6,27,211,8,136]),function(Z,e,u,t,D,P,y,C,E,I,R,k,_,T,w,b,v,h,g,p,o,m,c,l,s,i,r,n,a,d,f,S,O,U,M,A,B,x,N,K,X,L,$,H,j,J,Y,he,ve,ne,pe,Ee,ke,Oe,Be,ae,de,me,te,le,ee,re,F,W,G,Q,fe,be,ue,Ce,Se,Ue,qe,Je,Qe,Re,st,se,oe,q,ye,Ae,We,ze,$e,Ze,it,lt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function ht(tt){const at=tt.get(de.IExtHostInitDataService),Ct=tt.get(Ce.IExtHostFileSystemInfo),Ot=tt.get(G.IExtHostConsumerFileSystem),It=tt.get(i.IExtHostExtensionService),mt=tt.get(J.IExtHostWorkspace),kt=tt.get(Qe.IExtHostTelemetry),Ut=tt.get(g.IExtHostConfiguration),Ft=tt.get(Be.IURITransformerService),Ge=tt.get(ae.IExtHostRpcService),Nt=tt.get(B.IExtHostStorage),Lt=tt.get(W.IExtensionStoragePaths),Bt=tt.get(Oe.ILoggerService),bt=tt.get(Oe.ILogService),Te=tt.get(le.IExtHostTunnelService),Le=tt.get(lt.IExtHostTelemetryLogService),_e=tt.get(ee.IExtHostApiDeprecationService),ie=tt.get(j.IExtHostWindow),Fe=tt.get(qe.IExtHostSecretState),Ve=tt.get(Je.IExtHostEditorTabs);Ge.set(_.ExtHostContext.ExtHostFileSystemInfo,Ct),Ge.set(_.ExtHostContext.ExtHostLogLevelServiceShape,Bt),Ge.set(_.ExtHostContext.ExtHostWorkspace,mt),Ge.set(_.ExtHostContext.ExtHostConfiguration,Ut),Ge.set(_.ExtHostContext.ExtHostExtensionService,It),Ge.set(_.ExtHostContext.ExtHostStorage,Nt),Ge.set(_.ExtHostContext.ExtHostTunnelService,Te),Ge.set(_.ExtHostContext.ExtHostWindow,ie),Ge.set(_.ExtHostContext.ExtHostSecretState,Fe),Ge.set(_.ExtHostContext.ExtHostTelemetry,kt),Ge.set(_.ExtHostContext.ExtHostEditorTabs,Ve);const rt=Ge.set(_.ExtHostContext.ExtHostDecorations,tt.get(ne.IExtHostDecorations)),Ye=Ge.set(_.ExtHostContext.ExtHostDocumentsAndEditors,tt.get(s.IExtHostDocumentsAndEditors)),Ke=Ge.set(_.ExtHostContext.ExtHostCommands,tt.get(v.IExtHostCommands)),ft=Ge.set(_.ExtHostContext.ExtHostTerminalService,tt.get(x.IExtHostTerminalService)),pt=Ge.set(_.ExtHostContext.ExtHostDebugService,tt.get(Ee.IExtHostDebugService)),Dt=Ge.set(_.ExtHostContext.ExtHostSearch,tt.get(ke.IExtHostSearch)),vt=Ge.set(_.ExtHostContext.ExtHostTask,tt.get(pe.IExtHostTask)),St=Ge.set(_.ExtHostContext.ExtHostOutputService,tt.get(S.IExtHostOutputService)),At=Ge.set(_.ExtHostContext.ExtHostUrls,new $.ExtHostUrls(Ge)),gt=Ge.set(_.ExtHostContext.ExtHostDocuments,new l.ExtHostDocuments(Ge,Ye)),Yt=Ge.set(_.ExtHostContext.ExtHostDocumentContentProviders,new m.ExtHostDocumentContentProvider(Ge,Ye,bt)),Jt=Ge.set(_.ExtHostContext.ExtHostDocumentSaveParticipant,new c.ExtHostDocumentSaveParticipant(bt,gt,Ge.getProxy(_.MainContext.MainThreadBulkEdits))),Et=Ge.set(_.ExtHostContext.ExtHostNotebook,new me.ExtHostNotebookController(Ge,Ke,Ye,gt,Lt)),xt=Ge.set(_.ExtHostContext.ExtHostNotebookDocuments,new Ae.ExtHostNotebookDocuments(Et)),zt=Ge.set(_.ExtHostContext.ExtHostNotebookEditors,new ye.ExtHostNotebookEditors(bt,Et)),an=Ge.set(_.ExtHostContext.ExtHostNotebookKernels,new Re.ExtHostNotebookKernels(Ge,at,Et,Ke,bt)),Pn=Ge.set(_.ExtHostContext.ExtHostNotebookRenderers,new se.ExtHostNotebookRenderers(Ge,Et)),Tt=Ge.set(_.ExtHostContext.ExtHostEditors,new N.ExtHostEditors(Ge,Ye)),qt=Ge.set(_.ExtHostContext.ExtHostTreeViews,new K.ExtHostTreeViews(Ge.getProxy(_.MainContext.MainThreadTreeViews),Ke,bt)),gn=Ge.set(_.ExtHostContext.ExtHostEditorInsets,new Y.ExtHostEditorInsets(Ge.getProxy(_.MainContext.MainThreadEditorInsets),Tt,at.remote)),Zt=Ge.set(_.ExtHostContext.ExtHostDiagnostics,new p.ExtHostDiagnostics(Ge,bt,Ct)),en=Ge.set(_.ExtHostContext.ExtHostLanguages,new d.ExtHostLanguages(Ge,gt,Ke.converter,Ft)),dt=Ge.set(_.ExtHostContext.ExtHostLanguageFeatures,new a.ExtHostLanguageFeatures(Ge,Ft,gt,Ke,Zt,bt,_e)),pn=Ge.set(_.ExtHostContext.ExtHostFileSystem,new r.ExtHostFileSystem(Ge,dt)),Wt=Ge.set(_.ExtHostContext.ExtHostFileSystemEventService,new n.ExtHostFileSystemEventService(Ge,bt,Ye)),Gt=Ge.set(_.ExtHostContext.ExtHostQuickOpen,(0,U.createExtHostQuickOpen)(Ge,mt,Ke)),cn=Ge.set(_.ExtHostContext.ExtHostSCM,new M.ExtHostSCM(Ge,Ke,bt)),An=Ge.set(_.ExtHostContext.ExtHostComments,(0,h.createExtHostComments)(Ge,Ke,gt)),Cn=Ge.set(_.ExtHostContext.ExtHostProgress,new O.ExtHostProgress(Ge.getProxy(_.MainContext.MainThreadProgress))),vn=Ge.set(_.ExtHostContext.ExtHosLabelService,new he.ExtHostLabelService(Ge)),ln=Ge.set(_.ExtHostContext.ExtHostTheming,new te.ExtHostTheming(Ge)),tn=Ge.set(_.ExtHostContext.ExtHostAuthentication,new re.ExtHostAuthentication(Ge)),bn=Ge.set(_.ExtHostContext.ExtHostTimeline,new F.ExtHostTimeline(Ge,Ke)),wn=Ge.set(_.ExtHostContext.ExtHostWebviews,new H.ExtHostWebviews(Ge,at.remote,mt,bt,_e)),nn=Ge.set(_.ExtHostContext.ExtHostWebviewPanels,new be.ExtHostWebviewPanels(Ge,wn,mt)),En=Ge.set(_.ExtHostContext.ExtHostCustomEditors,new fe.ExtHostCustomEditors(Ge,gt,Lt,wn,nn)),Rn=Ge.set(_.ExtHostContext.ExtHostWebviewViews,new Q.ExtHostWebviewViews(Ge,wn)),rn=Ge.set(_.ExtHostContext.ExtHostTesting,new Se.ExtHostTesting(Ge,Ke)),Ln=Ge.set(_.ExtHostContext.ExtHostUriOpeners,new Ue.ExtHostUriOpeners(Ge));Ge.set(_.ExtHostContext.ExtHostInteractive,new We.ExtHostInteractive(Ge,Et,Ye,Ke,bt));const On=Object.values(_.ExtHostContext);Ge.assertRegistered(On);const Fn=new ue.ExtHostBulkEdits(Ge,Ye),Nn=new b.ExtHostClipboard(Ge),sn=new f.ExtHostMessageService(Ge,bt),un=new o.ExtHostDialogs(Ge),Dn=new A.ExtHostStatusBar(Ge,Ke.converter);return w.ExtHostApiCommands.register(Ke),function(He,Vt,on){const wt=function(){let ge=!He.isUnderDevelopment;function we(){ge||(bt.info(`Extension '${He.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ge=!0)}return function Ne(ot){if(Array.isArray(ot))ot.forEach(Ne);else if(typeof ot=="string")we();else{const _t=ot;typeof _t.scheme=="undefined"&&we(),typeof _t.exclusive=="boolean"&&(0,$e.checkProposedApiEnabled)(He,"documentFiltersExclusive")}return ot}}(),Mn={getSession(ge,we,Ne){return tn.getSession(He,ge,we,Ne)},async hasSession(ge,we){return(0,$e.checkProposedApiEnabled)(He,"authSession"),!!await tn.getSession(He,ge,we,{silent:!0})},get onDidChangeSessions(){return tn.onDidChangeSessions},registerAuthenticationProvider(ge,we,Ne,ot){return tn.registerAuthenticationProvider(ge,we,Ne,ot)}},Un={registerCommand(ge,we,Ne){return Ke.registerCommand(!0,ge,we,Ne,void 0,He)},registerTextEditorCommand(ge,we,Ne){return Ke.registerCommand(!0,ge,(...ot)=>{const _t=Tt.getActiveTextEditor();if(!_t){bt.warn("Cannot execute "+ge+" because there is no active text editor.");return}return _t.edit(Pt=>{we.apply(Ne,[_t,Pt,...ot])}).then(Pt=>{Pt||bt.warn("Edits from command "+ge+" were not applied.")},Pt=>{bt.warn("An error occurred while running command "+ge,Pt)})},void 0,void 0,He)},registerDiffInformationCommand:(ge,we,Ne)=>((0,$e.checkProposedApiEnabled)(He,"diffCommand"),Ke.registerCommand(!0,ge,async(...ot)=>{const _t=Ye.activeEditor(!0);if(!_t){bt.warn("Cannot execute "+ge+" because there is no active text editor.");return}const Pt=await Tt.getDiffInformation(_t.id);we.apply(Ne,[Pt,...ot])},void 0,void 0,He)),executeCommand(ge,...we){return Ke.executeCommand(ge,...we)},getCommands(ge=!1){return Ke.getCommands(ge)}},In={get machineId(){return at.telemetryInfo.machineId},get sessionId(){return at.telemetryInfo.sessionId},get language(){return at.environment.appLanguage},get appName(){return at.environment.appName},get appRoot(){return at.environment.appRoot?.fsPath??""},get appHost(){return at.environment.appHost},get uriScheme(){return at.environment.appUriScheme},get clipboard(){return Nn.value},get shell(){return ft.getDefaultShell(!1)},get isTelemetryEnabled(){return kt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return kt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,$e.checkProposedApiEnabled)(He,"telemetry"),kt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,$e.checkProposedApiEnabled)(He,"telemetry"),kt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){const ge=Date.now()-new Date(at.telemetryInfo.firstSessionDate).getTime();return isNaN(ge)?!1:ge<1e3*60*60*24},openExternal(ge,we){return ie.openUri(ge,{allowTunneling:!!at.remote.authority,allowContributedOpeners:we?.allowContributedOpeners})},async asExternalUri(ge){if(ge.scheme===at.environment.appUriScheme)return At.createAppUri(ge);try{return await ie.asExternalUri(ge,{allowTunneling:!!at.remote.authority})}catch(we){if((0,q.matchesScheme)(ge,oe.Schemas.http)||(0,q.matchesScheme)(ge,oe.Schemas.https))return ge;throw we}},get remoteName(){return(0,ve.getRemoteName)(at.remote.authority)},get remoteAuthority(){return(0,$e.checkProposedApiEnabled)(He,"resolvers"),at.remote.authority},get uiKind(){return at.uiKind}};at.environment.extensionTestsLocationURI||Object.freeze(In);const _n={createTestController(ge,we,Ne){return rn.createTestController(ge,we,Ne)},createTestObserver(){return(0,$e.checkProposedApiEnabled)(He,"testObserver"),rn.createTestObserver()},runTests(ge){return(0,$e.checkProposedApiEnabled)(He,"testObserver"),rn.runTests(ge)},get onDidChangeTestResults(){return(0,$e.checkProposedApiEnabled)(He,"testObserver"),rn.onResultsChanged},get testResults(){return(0,$e.checkProposedApiEnabled)(He,"testObserver"),rn.results}},dn=at.remote.isRemote?L.ExtensionKind.Workspace:L.ExtensionKind.UI,$t={getExtension(ge,we){(0,it.equalsIgnoreCase)(ge,"ms-vscode.references-view")&&(_e.report("The extension 'ms-vscode.references-view' has been renamed.",He,"Use 'vscode.references-view' instead."),ge="vscode.references-view"),(0,$e.isProposedApiEnabled)(He,"extensionsAny")||(we=!1);const Ne=Vt.mine.getExtensionDescription(ge);if(Ne)return new i.Extension(It,He.identifier,Ne,dn,!1);if(we){const ot=Vt.all.getExtensionDescription(ge);if(ot)return new i.Extension(It,He.identifier,ot,dn,!0)}},get all(){const ge=[];for(const we of Vt.mine.getAllExtensionDescriptions())ge.push(new i.Extension(It,He.identifier,we,dn,!1));return ge},get allAcrossExtensionHosts(){(0,$e.checkProposedApiEnabled)(He,"extensionsAny");const ge=new $e.ExtensionIdentifierSet(Vt.mine.getAllExtensionDescriptions().map(Ne=>Ne.identifier)),we=[];for(const Ne of Vt.all.getAllExtensionDescriptions()){const ot=!ge.has(Ne.identifier);we.push(new i.Extension(It,He.identifier,Ne,dn,ot))}return we},get onDidChange(){return(0,$e.isProposedApiEnabled)(He,"extensionsAny")?D.Event.any(Vt.mine.onDidChange,Vt.all.onDidChange):Vt.mine.onDidChange}},Kt={createDiagnosticCollection(ge){return Zt.createDiagnosticCollection(He.identifier,ge)},get onDidChangeDiagnostics(){return Zt.onDidChangeDiagnostics},getDiagnostics:ge=>Zt.getDiagnostics(ge),getLanguages(){return en.getLanguages()},setTextDocumentLanguage(ge,we){return en.changeLanguage(ge.uri,we)},match(ge,we){const Ne=gt.getDocumentData(we.uri)?.notebook;return(0,R.score)(X.LanguageSelector.from(ge),we.uri,we.languageId,!0,Ne?.uri,Ne?.notebookType)},registerCodeActionsProvider(ge,we,Ne){return dt.registerCodeActionProvider(He,wt(ge),we,Ne)},registerDocumentPasteEditProvider(ge,we,Ne){return(0,$e.checkProposedApiEnabled)(He,"documentPaste"),dt.registerDocumentPasteEditProvider(He,wt(ge),we,Ne)},registerCodeLensProvider(ge,we){return dt.registerCodeLensProvider(He,wt(ge),we)},registerDefinitionProvider(ge,we){return dt.registerDefinitionProvider(He,wt(ge),we)},registerDeclarationProvider(ge,we){return dt.registerDeclarationProvider(He,wt(ge),we)},registerImplementationProvider(ge,we){return dt.registerImplementationProvider(He,wt(ge),we)},registerTypeDefinitionProvider(ge,we){return dt.registerTypeDefinitionProvider(He,wt(ge),we)},registerHoverProvider(ge,we){return dt.registerHoverProvider(He,wt(ge),we,He.identifier)},registerEvaluatableExpressionProvider(ge,we){return dt.registerEvaluatableExpressionProvider(He,wt(ge),we,He.identifier)},registerInlineValuesProvider(ge,we){return dt.registerInlineValuesProvider(He,wt(ge),we,He.identifier)},registerDocumentHighlightProvider(ge,we){return dt.registerDocumentHighlightProvider(He,wt(ge),we)},registerLinkedEditingRangeProvider(ge,we){return dt.registerLinkedEditingRangeProvider(He,wt(ge),we)},registerReferenceProvider(ge,we){return dt.registerReferenceProvider(He,wt(ge),we)},registerRenameProvider(ge,we){return dt.registerRenameProvider(He,wt(ge),we)},registerDocumentSymbolProvider(ge,we,Ne){return dt.registerDocumentSymbolProvider(He,wt(ge),we,Ne)},registerWorkspaceSymbolProvider(ge){return dt.registerWorkspaceSymbolProvider(He,ge)},registerDocumentFormattingEditProvider(ge,we){return dt.registerDocumentFormattingEditProvider(He,wt(ge),we)},registerDocumentRangeFormattingEditProvider(ge,we){return dt.registerDocumentRangeFormattingEditProvider(He,wt(ge),we)},registerOnTypeFormattingEditProvider(ge,we,Ne,...ot){return dt.registerOnTypeFormattingEditProvider(He,wt(ge),we,[Ne].concat(ot))},registerDocumentSemanticTokensProvider(ge,we,Ne){return dt.registerDocumentSemanticTokensProvider(He,wt(ge),we,Ne)},registerDocumentRangeSemanticTokensProvider(ge,we,Ne){return dt.registerDocumentRangeSemanticTokensProvider(He,wt(ge),we,Ne)},registerSignatureHelpProvider(ge,we,Ne,...ot){return typeof Ne=="object"?dt.registerSignatureHelpProvider(He,wt(ge),we,Ne):dt.registerSignatureHelpProvider(He,wt(ge),we,typeof Ne=="undefined"?[]:[Ne,...ot])},registerCompletionItemProvider(ge,we,...Ne){return dt.registerCompletionItemProvider(He,wt(ge),we,Ne)},registerInlineCompletionItemProvider(ge,we){return we.handleDidShowCompletionItem&&(0,$e.checkProposedApiEnabled)(He,"inlineCompletionsAdditions"),dt.registerInlineCompletionsProvider(He,wt(ge),we)},registerInlineCompletionItemProviderNew(ge,we){if((0,$e.checkProposedApiEnabled)(He,"inlineCompletionsNew"),we.handleDidShowCompletionItem&&!(0,$e.isProposedApiEnabled)(He,"inlineCompletionsAdditions"))throw new Error(`When the method "handleDidShowCompletionItem" is implemented on a provider, the usage of the proposed api 'inlineCompletionsAdditions' must be declared!`);return dt.registerInlineCompletionsProviderNew(He,wt(ge),we)},registerDocumentLinkProvider(ge,we){return dt.registerDocumentLinkProvider(He,wt(ge),we)},registerColorProvider(ge,we){return dt.registerColorProvider(He,wt(ge),we)},registerFoldingRangeProvider(ge,we){return dt.registerFoldingRangeProvider(He,wt(ge),we)},registerSelectionRangeProvider(ge,we){return dt.registerSelectionRangeProvider(He,ge,we)},registerCallHierarchyProvider(ge,we){return dt.registerCallHierarchyProvider(He,ge,we)},registerTypeHierarchyProvider(ge,we){return dt.registerTypeHierarchyProvider(He,ge,we)},setLanguageConfiguration:(ge,we)=>dt.setLanguageConfiguration(He,ge,we),getTokenInformationAtPosition(ge,we){return(0,$e.checkProposedApiEnabled)(He,"tokenInformation"),en.tokenAtPosition(ge,we)},registerInlayHintsProvider(ge,we){return dt.registerInlayHintsProvider(He,ge,we)},createLanguageStatusItem(ge,we){return en.createLanguageStatusItem(He,ge,we)},registerDocumentDropEditProvider(ge,we){return dt.registerDocumentOnDropEditProvider(He,ge,we)}},Bn={get activeTextEditor(){return Tt.getActiveTextEditor()},get visibleTextEditors(){return Tt.getVisibleTextEditors()},get activeTerminal(){return ft.activeTerminal},get terminals(){return ft.terminals},async showTextDocument(ge,we,Ne){const ot=await(y.URI.isUri(ge)?Promise.resolve(Mt.openTextDocument(ge)):Promise.resolve(ge));return Tt.showTextDocument(ot,we,Ne)},createTextEditorDecorationType(ge){return Tt.createTextEditorDecorationType(He,ge)},onDidChangeActiveTextEditor(ge,we,Ne){return Tt.onDidChangeActiveTextEditor(ge,we,Ne)},onDidChangeVisibleTextEditors(ge,we,Ne){return Tt.onDidChangeVisibleTextEditors(ge,we,Ne)},onDidChangeTextEditorSelection(ge,we,Ne){return Tt.onDidChangeTextEditorSelection(ge,we,Ne)},onDidChangeTextEditorOptions(ge,we,Ne){return Tt.onDidChangeTextEditorOptions(ge,we,Ne)},onDidChangeTextEditorVisibleRanges(ge,we,Ne){return Tt.onDidChangeTextEditorVisibleRanges(ge,we,Ne)},onDidChangeTextEditorViewColumn(ge,we,Ne){return Tt.onDidChangeTextEditorViewColumn(ge,we,Ne)},onDidCloseTerminal(ge,we,Ne){return ft.onDidCloseTerminal(ge,we,Ne)},onDidOpenTerminal(ge,we,Ne){return ft.onDidOpenTerminal(ge,we,Ne)},onDidChangeActiveTerminal(ge,we,Ne){return ft.onDidChangeActiveTerminal(ge,we,Ne)},onDidChangeTerminalDimensions(ge,we,Ne){return(0,$e.checkProposedApiEnabled)(He,"terminalDimensions"),ft.onDidChangeTerminalDimensions(ge,we,Ne)},onDidChangeTerminalState(ge,we,Ne){return ft.onDidChangeTerminalState(ge,we,Ne)},onDidWriteTerminalData(ge,we,Ne){return(0,$e.checkProposedApiEnabled)(He,"terminalDataWriteEvent"),ft.onDidWriteTerminalData(ge,we,Ne)},get state(){return ie.state},onDidChangeWindowState(ge,we,Ne){return ie.onDidChangeWindowState(ge,we,Ne)},showInformationMessage(ge,...we){return sn.showMessage(He,P.default.Info,ge,we[0],we.slice(1))},showWarningMessage(ge,...we){return sn.showMessage(He,P.default.Warning,ge,we[0],we.slice(1))},showErrorMessage(ge,...we){return sn.showMessage(He,P.default.Error,ge,we[0],we.slice(1))},showQuickPick(ge,we,Ne){return Gt.showQuickPick(ge,we,Ne)},showWorkspaceFolderPick(ge){return Gt.showWorkspaceFolderPick(ge)},showInputBox(ge,we){return Gt.showInput(ge,we)},showOpenDialog(ge){return un.showOpenDialog(ge)},showSaveDialog(ge){return un.showSaveDialog(ge)},createStatusBarItem(ge,we,Ne){let ot,_t,Pt;return typeof ge=="string"?(ot=ge,_t=we,Pt=Ne):(_t=ge,Pt=we),Dn.createStatusBarEntry(He,ot,_t,Pt)},setStatusBarMessage(ge,we){return Dn.setStatusBarMessage(ge,we)},withScmProgress(ge){return _e.report("window.withScmProgress",He,"Use 'withProgress' instead."),Cn.withProgress(He,{location:L.ProgressLocation.SourceControl},(we,Ne)=>ge({report(ot){}}))},withProgress(ge,we){return Cn.withProgress(He,ge,we)},createOutputChannel(ge,we){return St.createOutputChannel(ge,we,He)},createWebviewPanel(ge,we,Ne,ot){return nn.createWebviewPanel(He,ge,we,Ne,ot)},createWebviewTextEditorInset(ge,we,Ne,ot){return(0,$e.checkProposedApiEnabled)(He,"editorInsets"),gn.createWebviewEditorInset(ge,we,Ne,ot,He)},createTerminal(ge,we,Ne){return typeof ge=="object"?"pty"in ge?ft.createExtensionTerminal(ge):ft.createTerminalFromOptions(ge):ft.createTerminal(ge,we,Ne)},registerTerminalLinkProvider(ge){return ft.registerLinkProvider(ge)},registerTerminalProfileProvider(ge,we){return ft.registerProfileProvider(He,ge,we)},registerTreeDataProvider(ge,we){return qt.registerTreeDataProvider(ge,we,He)},createTreeView(ge,we){return qt.createTreeView(ge,we,He)},registerWebviewPanelSerializer:(ge,we)=>nn.registerWebviewPanelSerializer(He,ge,we),registerCustomEditorProvider:(ge,we,Ne={})=>En.registerCustomEditorProvider(He,ge,we,Ne),registerFileDecorationProvider(ge){return rt.registerFileDecorationProvider(ge,He.identifier)},registerUriHandler(ge){return At.registerUriHandler(He.identifier,ge)},createQuickPick(){return Gt.createQuickPick(He)},createInputBox(){return Gt.createInputBox(He)},get activeColorTheme(){return ln.activeColorTheme},onDidChangeActiveColorTheme(ge,we,Ne){return ln.onDidChangeActiveColorTheme(ge,we,Ne)},registerWebviewViewProvider(ge,we,Ne){return Rn.registerWebviewViewProvider(He,ge,we,Ne?.webviewOptions)},get activeNotebookEditor(){return Et.activeNotebookEditor},onDidChangeActiveNotebookEditor(ge,we,Ne){return Et.onDidChangeActiveNotebookEditor(ge,we,Ne)},get visibleNotebookEditors(){return Et.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return Et.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ge,we,Ne){return zt.onDidChangeNotebookEditorSelection(ge,we,Ne)},onDidChangeNotebookEditorVisibleRanges(ge,we,Ne){return zt.onDidChangeNotebookEditorVisibleRanges(ge,we,Ne)},showNotebookDocument(ge,we){return y.URI.isUri(ge)&&_e.report("window.showNotebookDocument(uri)",He,"Please use 'workspace.openNotebookDocument' and 'window.showNotebookDocument'"),Et.showNotebookDocument(ge,we)},registerExternalUriOpener(ge,we,Ne){return(0,$e.checkProposedApiEnabled)(He,"externalUriOpener"),Ln.registerExternalUriOpener(He.identifier,ge,we,Ne)},get tabGroups(){return Ve.tabGroups},logTelemetryToOutputChannel(ge,we){(0,$e.checkProposedApiEnabled)(He,"telemetryLog"),Le.logToTelemetryOutputChannel(He,ge,we)}},Mt={get rootPath(){return _e.report("workspace.rootPath",He,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),mt.getPath()},set rootPath(ge){throw t.readonly()},getWorkspaceFolder(ge){return mt.getWorkspaceFolder(ge)},get workspaceFolders(){return mt.getWorkspaceFolders()},get name(){return mt.name},set name(ge){throw t.readonly()},get workspaceFile(){return mt.workspaceFile},set workspaceFile(ge){throw t.readonly()},updateWorkspaceFolders:(ge,we,...Ne)=>mt.updateWorkspaceFolders(He,ge,we||0,...Ne),onDidChangeWorkspaceFolders:function(ge,we,Ne){return mt.onDidChangeWorkspace(ge,we,Ne)},asRelativePath:(ge,we)=>mt.getRelativePath(ge,we),findFiles:(ge,we,Ne,ot)=>mt.findFiles(ge,we,Ne,He.identifier,ot),findTextInFiles:(ge,we,Ne,ot)=>{(0,$e.checkProposedApiEnabled)(He,"findTextInFiles");let _t,Pt;return typeof we=="object"?(_t=we,Pt=Ne):(_t={},Pt=we,ot=Ne),mt.findTextInFiles(ge,_t||{},Pt,He.identifier,ot)},saveAll:ge=>mt.saveAll(ge),applyEdit(ge){return Fn.applyWorkspaceEdit(ge,He)},createFileSystemWatcher:(ge,we,Ne,ot)=>Wt.createFileSystemWatcher(mt,He,ge,we,Ne,ot),get textDocuments(){return gt.getAllDocumentData().map(ge=>ge.document)},set textDocuments(ge){throw t.readonly()},openTextDocument(ge){let we;const Ne=ge;if(typeof ge=="string")we=Promise.resolve(y.URI.file(ge));else if(y.URI.isUri(ge))we=Promise.resolve(ge);else if(!Ne||typeof Ne=="object")we=gt.createDocumentData(Ne);else throw new Error("illegal argument - uriOrFileNameOrOptions");return we.then(ot=>gt.ensureDocumentData(ot).then(_t=>_t.document))},onDidOpenTextDocument:(ge,we,Ne)=>gt.onDidAddDocument(ge,we,Ne),onDidCloseTextDocument:(ge,we,Ne)=>gt.onDidRemoveDocument(ge,we,Ne),onDidChangeTextDocument:(ge,we,Ne)=>gt.onDidChangeDocument(ge,we,Ne),onDidSaveTextDocument:(ge,we,Ne)=>gt.onDidSaveDocument(ge,we,Ne),onWillSaveTextDocument:(ge,we,Ne)=>Jt.getOnWillSaveTextDocumentEvent(He)(ge,we,Ne),get notebookDocuments(){return Et.notebookDocuments.map(ge=>ge.apiNotebook)},async openNotebookDocument(ge,we){let Ne;if(y.URI.isUri(ge))Ne=ge,await Et.openNotebookDocument(ge);else if(typeof ge=="string")Ne=y.URI.revive(await Et.createNotebookDocument({viewType:ge,content:we}));else throw new Error("Invalid arguments");return Et.getNotebookDocument(Ne).apiNotebook},onDidSaveNotebookDocument(ge,we,Ne){return xt.onDidSaveNotebookDocument(ge,we,Ne)},onDidChangeNotebookDocument(ge,we,Ne){return xt.onDidChangeNotebookDocument(ge,we,Ne)},get onDidOpenNotebookDocument(){return Et.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Et.onDidCloseNotebookDocument},registerNotebookSerializer(ge,we,Ne,ot){return Et.registerNotebookSerializer(He,ge,we,Ne,(0,$e.isProposedApiEnabled)(He,"notebookLiveShare")?ot:void 0)},registerNotebookContentProvider:(ge,we,Ne,ot)=>((0,$e.checkProposedApiEnabled)(He,"notebookContentProvider"),_e.report("workspace.registerNotebookContentProvider",He,"The notebookContentProvider API is not on track for finalization and will be removed."),Et.registerNotebookContentProvider(He,ge,we,Ne,(0,$e.isProposedApiEnabled)(He,"notebookLiveShare")?ot:void 0)),onDidChangeConfiguration:(ge,we,Ne)=>on.onDidChangeConfiguration(ge,we,Ne),getConfiguration(ge,we){return we=arguments.length===1?void 0:we,on.getConfiguration(ge,we,He)},registerTextDocumentContentProvider(ge,we){return Yt.registerTextDocumentContentProvider(ge,we)},registerTaskProvider:(ge,we)=>(_e.report("window.registerTaskProvider",He,"Use the corresponding function on the 'tasks' namespace instead"),vt.registerTaskProvider(He,ge,we)),registerFileSystemProvider(ge,we,Ne){return(0,ze.combinedDisposable)(pn.registerFileSystemProvider(He,ge,we,Ne),Ot.addFileSystemProvider(ge,we))},get fs(){return Ot.value},registerFileSearchProvider:(ge,we)=>((0,$e.checkProposedApiEnabled)(He,"fileSearchProvider"),Dt.registerFileSearchProvider(ge,we)),registerTextSearchProvider:(ge,we)=>((0,$e.checkProposedApiEnabled)(He,"textSearchProvider"),Dt.registerTextSearchProvider(ge,we)),registerRemoteAuthorityResolver:(ge,we)=>((0,$e.checkProposedApiEnabled)(He,"resolvers"),It.registerRemoteAuthorityResolver(ge,we)),registerResourceLabelFormatter:ge=>((0,$e.checkProposedApiEnabled)(He,"resolvers"),vn.$registerResourceLabelFormatter(ge)),onDidCreateFiles:(ge,we,Ne)=>Wt.onDidCreateFile(ge,we,Ne),onDidDeleteFiles:(ge,we,Ne)=>Wt.onDidDeleteFile(ge,we,Ne),onDidRenameFiles:(ge,we,Ne)=>Wt.onDidRenameFile(ge,we,Ne),onWillCreateFiles:(ge,we,Ne)=>Wt.getOnWillCreateFileEvent(He)(ge,we,Ne),onWillDeleteFiles:(ge,we,Ne)=>Wt.getOnWillDeleteFileEvent(He)(ge,we,Ne),onWillRenameFiles:(ge,we,Ne)=>Wt.getOnWillRenameFileEvent(He)(ge,we,Ne),openTunnel:ge=>((0,$e.checkProposedApiEnabled)(He,"resolvers"),Te.openTunnel(He,ge).then(we=>{if(!we)throw new Error("cannot open tunnel");return we})),get tunnels(){return(0,$e.checkProposedApiEnabled)(He,"resolvers"),Te.getTunnels()},onDidChangeTunnels:(ge,we,Ne)=>((0,$e.checkProposedApiEnabled)(He,"resolvers"),Te.onDidChangeTunnels(ge,we,Ne)),registerPortAttributesProvider:(ge,we)=>((0,$e.checkProposedApiEnabled)(He,"portsAttributes"),Te.registerPortsAttributesProvider(ge,we)),registerTimelineProvider:(ge,we)=>((0,$e.checkProposedApiEnabled)(He,"timeline"),bn.registerTimelineProvider(ge,we,He.identifier,Ke.converter)),get isTrusted(){return mt.trusted},requestWorkspaceTrust:ge=>((0,$e.checkProposedApiEnabled)(He,"workspaceTrust"),mt.requestWorkspaceTrust(ge)),onDidGrantWorkspaceTrust:(ge,we,Ne)=>mt.onDidGrantWorkspaceTrust(ge,we,Ne)},hn={get inputBox(){return _e.report("scm.inputBox",He,"Use 'SourceControl.inputBox' instead"),cn.getLastInputBox(He)},createSourceControl(ge,we,Ne){return cn.createSourceControl(He,ge,we,Ne)}},zn={createCommentController(ge,we){return An.createCommentController(He,ge,we)}},Wn={get activeDebugSession(){return pt.activeDebugSession},get activeDebugConsole(){return pt.activeDebugConsole},get breakpoints(){return pt.breakpoints},onDidStartDebugSession(ge,we,Ne){return pt.onDidStartDebugSession(ge,we,Ne)},onDidTerminateDebugSession(ge,we,Ne){return pt.onDidTerminateDebugSession(ge,we,Ne)},onDidChangeActiveDebugSession(ge,we,Ne){return pt.onDidChangeActiveDebugSession(ge,we,Ne)},onDidReceiveDebugSessionCustomEvent(ge,we,Ne){return pt.onDidReceiveDebugSessionCustomEvent(ge,we,Ne)},onDidChangeBreakpoints(ge,we,Ne){return pt.onDidChangeBreakpoints(ge,we,Ne)},registerDebugConfigurationProvider(ge,we,Ne){return pt.registerDebugConfigurationProvider(ge,we,Ne||Ze.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ge,we){return pt.registerDebugAdapterDescriptorFactory(He,ge,we)},registerDebugAdapterTrackerFactory(ge,we){return pt.registerDebugAdapterTrackerFactory(ge,we)},startDebugging(ge,we,Ne){return!Ne||typeof Ne=="object"&&"configuration"in Ne?pt.startDebugging(ge,we,{parentSession:Ne}):pt.startDebugging(ge,we,Ne||{})},stopDebugging(ge){return pt.stopDebugging(ge)},addBreakpoints(ge){return pt.addBreakpoints(ge)},removeBreakpoints(ge){return pt.removeBreakpoints(ge)},asDebugSourceUri(ge,we){return pt.asDebugSourceUri(ge,we)}},$n={registerTaskProvider:(ge,we)=>vt.registerTaskProvider(He,ge,we),fetchTasks:ge=>vt.fetchTasks(ge),executeTask:ge=>vt.executeTask(He,ge),get taskExecutions(){return vt.taskExecutions},onDidStartTask:(ge,we,Ne)=>vt.onDidStartTask(ge,we,Ne),onDidEndTask:(ge,we,Ne)=>vt.onDidEndTask(ge,we,Ne),onDidStartTaskProcess:(ge,we,Ne)=>vt.onDidStartTaskProcess(ge,we,Ne),onDidEndTaskProcess:(ge,we,Ne)=>vt.onDidEndTaskProcess(ge,we,Ne)},Hn={createNotebookController(ge,we,Ne,ot,_t){return an.createNotebookController(He,ge,we,Ne,ot,(0,$e.isProposedApiEnabled)(He,"notebookMessaging")?_t:void 0)},registerNotebookCellStatusBarItemProvider:(ge,we)=>Et.registerNotebookCellStatusBarItemProvider(He,ge,we),createRendererMessaging(ge){return Pn.createRendererMessaging(He,ge)},onDidChangeNotebookCellExecutionState(ge,we,Ne){return(0,$e.checkProposedApiEnabled)(He,"notebookCellExecutionState"),an.onDidChangeNotebookCellExecutionState(ge,we,Ne)}};return{version:at.version,authentication:Mn,commands:Un,comments:zn,debug:Wn,env:In,extensions:$t,languages:Kt,notebooks:Hn,scm:hn,tasks:$n,tests:_n,window:Bn,workspace:Mt,Breakpoint:L.Breakpoint,CallHierarchyIncomingCall:L.CallHierarchyIncomingCall,CallHierarchyItem:L.CallHierarchyItem,CallHierarchyOutgoingCall:L.CallHierarchyOutgoingCall,CancellationError:t.CancellationError,CancellationTokenSource:u.CancellationTokenSource,CandidatePortSource:_.CandidatePortSource,CodeAction:L.CodeAction,CodeActionKind:L.CodeActionKind,CodeActionTriggerKind:L.CodeActionTriggerKind,CodeLens:L.CodeLens,Color:L.Color,ColorInformation:L.ColorInformation,ColorPresentation:L.ColorPresentation,ColorThemeKind:L.ColorThemeKind,CommentMode:L.CommentMode,CommentThreadCollapsibleState:L.CommentThreadCollapsibleState,CommentThreadState:L.CommentThreadState,CompletionItem:L.CompletionItem,CompletionItemKind:L.CompletionItemKind,CompletionItemTag:L.CompletionItemTag,CompletionList:L.CompletionList,CompletionTriggerKind:L.CompletionTriggerKind,ConfigurationTarget:L.ConfigurationTarget,CustomExecution:L.CustomExecution,DebugAdapterExecutable:L.DebugAdapterExecutable,DebugAdapterInlineImplementation:L.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:L.DebugAdapterNamedPipeServer,DebugAdapterServer:L.DebugAdapterServer,DebugConfigurationProviderTriggerKind:Ze.DebugConfigurationProviderTriggerKind,DebugConsoleMode:L.DebugConsoleMode,DecorationRangeBehavior:L.DecorationRangeBehavior,Diagnostic:L.Diagnostic,DiagnosticRelatedInformation:L.DiagnosticRelatedInformation,DiagnosticSeverity:L.DiagnosticSeverity,DiagnosticTag:L.DiagnosticTag,Disposable:L.Disposable,DocumentHighlight:L.DocumentHighlight,DocumentHighlightKind:L.DocumentHighlightKind,DocumentLink:L.DocumentLink,DocumentSymbol:L.DocumentSymbol,EndOfLine:L.EndOfLine,EnvironmentVariableMutatorType:L.EnvironmentVariableMutatorType,EvaluatableExpression:L.EvaluatableExpression,InlineValueText:L.InlineValueText,InlineValueVariableLookup:L.InlineValueVariableLookup,InlineValueEvaluatableExpression:L.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:L.InlineCompletionTriggerKind,InlineCompletionTriggerKindNew:L.InlineCompletionTriggerKindNew,EventEmitter:D.Emitter,ExtensionKind:L.ExtensionKind,ExtensionMode:L.ExtensionMode,ExternalUriOpenerPriority:L.ExternalUriOpenerPriority,FileChangeType:L.FileChangeType,FileDecoration:L.FileDecoration,FileSystemError:L.FileSystemError,FileType:k.FileType,FilePermission:k.FilePermission,FoldingRange:L.FoldingRange,FoldingRangeKind:L.FoldingRangeKind,FunctionBreakpoint:L.FunctionBreakpoint,InlineCompletionItem:L.InlineSuggestion,InlineCompletionItemNew:L.InlineSuggestionNew,InlineCompletionList:L.InlineSuggestionList,InlineCompletionListNew:L.InlineSuggestionsNew,Hover:L.Hover,IndentAction:I.IndentAction,Location:L.Location,MarkdownString:L.MarkdownString,OverviewRulerLane:E.OverviewRulerLane,ParameterInformation:L.ParameterInformation,PortAutoForwardAction:L.PortAutoForwardAction,Position:L.Position,ProcessExecution:L.ProcessExecution,ProgressLocation:L.ProgressLocation,QuickInputButtons:L.QuickInputButtons,Range:L.Range,RelativePattern:L.RelativePattern,Selection:L.Selection,SelectionRange:L.SelectionRange,SemanticTokens:L.SemanticTokens,SemanticTokensBuilder:L.SemanticTokensBuilder,SemanticTokensEdit:L.SemanticTokensEdit,SemanticTokensEdits:L.SemanticTokensEdits,SemanticTokensLegend:L.SemanticTokensLegend,ShellExecution:L.ShellExecution,ShellQuoting:L.ShellQuoting,SignatureHelp:L.SignatureHelp,SignatureHelpTriggerKind:L.SignatureHelpTriggerKind,SignatureInformation:L.SignatureInformation,SnippetString:L.SnippetString,SourceBreakpoint:L.SourceBreakpoint,StandardTokenType:L.StandardTokenType,StatusBarAlignment:L.StatusBarAlignment,SymbolInformation:L.SymbolInformation,SymbolKind:L.SymbolKind,SymbolTag:L.SymbolTag,Task:L.Task,TaskGroup:L.TaskGroup,TaskPanelKind:L.TaskPanelKind,TaskRevealKind:L.TaskRevealKind,TaskScope:L.TaskScope,TerminalLink:L.TerminalLink,TerminalLocation:L.TerminalLocation,TerminalProfile:L.TerminalProfile,TextDocumentSaveReason:L.TextDocumentSaveReason,TextEdit:L.TextEdit,TextEditorCursorStyle:C.TextEditorCursorStyle,TextEditorLineNumbersStyle:L.TextEditorLineNumbersStyle,TextEditorRevealType:L.TextEditorRevealType,TextEditorSelectionChangeKind:L.TextEditorSelectionChangeKind,TextDocumentChangeReason:L.TextDocumentChangeReason,ThemeColor:L.ThemeColor,ThemeIcon:L.ThemeIcon,TreeItem:L.TreeItem,TreeItemCollapsibleState:L.TreeItemCollapsibleState,TypeHierarchyItem:L.TypeHierarchyItem,UIKind:T.UIKind,Uri:y.URI,ViewColumn:L.ViewColumn,WorkspaceEdit:L.WorkspaceEdit,DocumentDropEdit:L.DocumentDropEdit,DocumentPasteEdit:L.DocumentPasteEdit,InlayHint:L.InlayHint,InlayHintLabelPart:L.InlayHintLabelPart,InlayHintKind:L.InlayHintKind,RemoteAuthorityResolverError:L.RemoteAuthorityResolverError,ResolvedAuthority:L.ResolvedAuthority,SourceControlInputBoxValidationType:L.SourceControlInputBoxValidationType,ExtensionRuntime:L.ExtensionRuntime,TimelineItem:L.TimelineItem,NotebookRange:L.NotebookRange,NotebookCellKind:L.NotebookCellKind,NotebookCellExecutionState:L.NotebookCellExecutionState,NotebookCellData:L.NotebookCellData,NotebookData:L.NotebookData,NotebookRendererScript:L.NotebookRendererScript,NotebookCellStatusBarAlignment:L.NotebookCellStatusBarAlignment,NotebookEditorRevealType:L.NotebookEditorRevealType,NotebookCellOutput:L.NotebookCellOutput,NotebookCellOutputItem:L.NotebookCellOutputItem,NotebookCellStatusBarItem:L.NotebookCellStatusBarItem,NotebookControllerAffinity:L.NotebookControllerAffinity,NotebookEdit:L.NotebookEdit,PortAttributes:L.PortAttributes,LinkedEditingRanges:L.LinkedEditingRanges,TestResultState:L.TestResultState,TestRunRequest:L.TestRunRequest,TestMessage:L.TestMessage,TestTag:L.TestTag,TestRunProfileKind:L.TestRunProfileKind,TextSearchCompleteMessageType:st.TextSearchCompleteMessageType,DataTransfer:L.DataTransfer,DataTransferItem:L.DataTransferItem,CoveredCount:L.CoveredCount,FileCoverage:L.FileCoverage,StatementCoverage:L.StatementCoverage,BranchCoverage:L.BranchCoverage,FunctionCoverage:L.FunctionCoverage,WorkspaceTrustState:L.WorkspaceTrustState,LanguageStatusSeverity:L.LanguageStatusSeverity,QuickPickItemKind:L.QuickPickItemKind,InputBoxValidationSeverity:L.InputBoxValidationSeverity,TabInputText:L.TextTabInput,TabInputTextDiff:L.TextDiffTabInput,TabInputTextMerge:L.TextMergeTabInput,TabInputCustom:L.CustomEditorTabInput,TabInputNotebook:L.NotebookEditorTabInput,TabInputNotebookDiff:L.NotebookDiffEditorTabInput,TabInputWebview:L.WebviewEditorTabInput,TabInputTerminal:L.TerminalEditorTabInput,TabInputInteractiveWindow:L.InteractiveWindowInput,TerminalExitReason:L.TerminalExitReason}}}e.createApiFactoryAndRegisterActors=ht}),define(De[295],Ie([1,0,267,304,305,2,306]),function(Z,e,u,t,D,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function C(k,_,T,w,b,v){const h=v.environment.useHostProxy,g=typeof h=="boolean"?h:!v.remote.isRemote,p=(0,y.createProxyResolver)({resolveProxy:m=>k.resolveProxy(m),getHttpProxySetting:()=>_.getConfiguration("http").get("proxy"),log:(m,c,...l)=>{switch(m){case y.LogLevel.Trace:w.trace(c,...l);break;case y.LogLevel.Debug:w.debug(c,...l);break;case y.LogLevel.Info:w.info(c,...l);break;case y.LogLevel.Warning:w.warn(c,...l);break;case y.LogLevel.Error:w.error(c,...l);break;case y.LogLevel.Critical:w.critical(c,...l);break;case y.LogLevel.Off:break;default:s(m,c,l);break}function s(i,r,...n){w.error("Unknown log level",i),w.error(r,...n)}},getLogLevel:()=>w.getLevel(),proxyResolveTelemetry:()=>{},useHostProxy:g,env:process.env}),o=E(_,p);return R(T,o)}e.connectProxyResolver=C;function E(k,_){const T={config:k.getConfiguration("http").get("proxySupport")||"off"};k.onDidChangeConfiguration(b=>{T.config=k.getConfiguration("http").get("proxySupport")||"off"});const w={config:!!k.getConfiguration("http").get("systemCertificates")};return k.onDidChangeConfiguration(b=>{w.config=!!k.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},u,(0,y.createHttpPatch)(u,_,{config:"off"},w,!0)),on:Object.assign({},u,(0,y.createHttpPatch)(u,_,{config:"on"},w,!0)),override:Object.assign({},u,(0,y.createHttpPatch)(u,_,{config:"override"},w,!0)),onRequest:Object.assign({},u,(0,y.createHttpPatch)(u,_,T,w,!0)),default:Object.assign(u,(0,y.createHttpPatch)(u,_,T,w,!1))},https:{off:Object.assign({},t,(0,y.createHttpPatch)(t,_,{config:"off"},w,!0)),on:Object.assign({},t,(0,y.createHttpPatch)(t,_,{config:"on"},w,!0)),override:Object.assign({},t,(0,y.createHttpPatch)(t,_,{config:"override"},w,!0)),onRequest:Object.assign({},t,(0,y.createHttpPatch)(t,_,T,w,!0)),default:Object.assign(t,(0,y.createHttpPatch)(t,_,T,w,!1))},tls:Object.assign(D,(0,y.createTlsPatch)(D))}}const I=new Map;function R(k,_){return k.getExtensionPathIndex().then(T=>{const w=Z.__$__nodeRequire("module"),b=w._load;w._load=function(h,g,p){if(h==="tls")return _.tls;if(h!=="http"&&h!=="https")return b.apply(this,arguments);const o=_[h],m=T.findSubstr(P.URI.file(g.filename));let c=I.get(m);if(c||I.set(m,c={}),!c[h]){const l=o.default;c[h]={...l}}return c[h]}})}}),define(De[296],Ie([1,0,73,294,281,295,39,269,2,12,7,266,108,268]),function(Z,e,u,t,D,P,y,C,E,I,R,k,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class w extends D.RequireInterceptor{_installInterceptor(){const h=this,g=Z.__$__nodeRequire("module"),p=g._load;g._load=function(l,s,i){return l=m(l),h._factories.has(l)?h._factories.get(l).load(l,E.URI.file((0,_.realpathSync)(s.filename)),r=>p.apply(this,[r,s,i])):p.apply(this,arguments)};const o=g._resolveLookupPaths;g._resolveLookupPaths=(c,l)=>o.call(this,m(c),l);const m=c=>{for(const l of h._alternatives){const s=l(c);if(s){c=s;break}}return c}}}class b extends y.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=R.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){this._instaService.createInstance(T.ExtHostConsoleForwarder);const h=this._instaService.invokeFunction(t.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(C.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const o=this._instaService.createInstance(k.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=o.ipcHandlePath}await this._instaService.createInstance(w,h,{mine:this._myRegistry,all:this._globalRegistry}).install(),u.mark("code/extHost/didInitAPI");const p=await this._extHostConfiguration.getConfigProvider();await(0,P.connectProxyResolver)(this._extHostWorkspace,p,this,this._logService,this._mainThreadTelemetryProxy,this._initData),u.mark("code/extHost/didInitProxyResolver")}_getEntryPoint(h){return h.main}_loadCommonJSModule(h,g,p){if(g.scheme!==I.Schemas.file)throw new Error(`Cannot load URI: '${g}', must be of file-scheme`);let o=null;p.codeLoadingStart(),this._logService.trace(`ExtensionService#loadCommonJSModule ${g.toString(!0)}`),this._logService.flush();const m=h?.identifier.value;try{m&&u.mark(`code/extHost/willLoadExtensionCode/${m}`),o=Z.__$__nodeRequire(g.fsPath)}catch(c){return Promise.reject(c)}finally{m&&u.mark(`code/extHost/didLoadExtensionCode/${m}`),p.codeLoadingStop()}return Promise.resolve(o)}async $setRemoteEnvironment(h){if(!!this._initData.remote.isRemote)for(const g in h){const p=h[g];p===null?delete process.env[g]:process.env[g]=p}}}e.ExtHostExtensionService=b}),define(De[141],Ie([1,0,44,307,290,17,77,36,9,8,2,30,71,308,288,92]),function(Z,e,u,t,D,P,y,C,E,I,R,k,_,T,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const v=w.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class h{constructor(f){this.outputChannel=f}provideTextSearchResults(f,S,O,U){return this.outputChannel.appendLine(`provideTextSearchResults ${f.pattern}, ${JSON.stringify({...S,folder:S.folder.toString()})}`),new Promise((M,A)=>{U.onCancellationRequested(()=>H());const B=l(f,S),x=S.folder.fsPath,N=B.map(ve=>ve.match(/^-/)?ve:`'${ve}'`).join(" ");this.outputChannel.appendLine(`${v} ${N}
 - cwd: ${x}`);let K=u.spawn(v,B,{cwd:x});K.on("error",ve=>{console.error(ve),this.outputChannel.appendLine("Error: "+(ve&&ve.message)),A((0,k.serializeSearchError)(new k.SearchError(ve&&ve.message,k.SearchErrorCode.rgProcessError)))});let X=!1;const L=new o(S.maxResults,x,S.previewOptions);L.on("result",ve=>{X=!0,J="",O.report(ve)});let $=!1;const H=()=>{$=!0,K?.kill(),L?.cancel()};let j=!1;L.on("hitLimit",()=>{j=!0,H()});let J="";K.stdout.on("data",ve=>{L.handleData(ve),X||(J+=ve)});let Y=!1;K.stdout.once("data",()=>Y=!0);let he="";K.stderr.on("data",ve=>{const ne=ve.toString();this.outputChannel.appendLine(ne),he+=ne}),K.on("close",()=>{if(this.outputChannel.appendLine(Y?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(X?"Got result from parser":"No result from parser"),J&&this.outputChannel.appendLine(`Got data without result: ${J}`),this.outputChannel.appendLine(""),$)M({limitHit:j});else{L.flush(),K=null;let ve;he&&!Y&&(ve=g(he))?A((0,k.serializeSearchError)(new k.SearchError(ve.message,ve.code))):M({limitHit:j})}})})}}e.RipgrepTextSearchEngine=h;function g(d){const f=d.split(`
`),S=f[0].trim();if(f.some(U=>U.startsWith("regex parse error")))return new k.SearchError(p(f),k.SearchErrorCode.regexParseError);const O=S.match(/grep config error: unknown encoding: (.*)/);if(O)return new k.SearchError(`Unknown encoding: ${O[1]}`,k.SearchErrorCode.unknownEncoding);if(S.startsWith("error parsing glob"))return new k.SearchError(S.charAt(0).toUpperCase()+S.substr(1),k.SearchErrorCode.globParseError);if(S.startsWith("the literal"))return new k.SearchError(S.charAt(0).toUpperCase()+S.substr(1),k.SearchErrorCode.invalidLiteral);if(S.startsWith("PCRE2: error compiling pattern"))return new k.SearchError(S,k.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=g;function p(d){const f=["Regex parse error"],S=d.filter(O=>O.startsWith("PCRE2:"));if(S.length>=1){const O=S[0].replace("PCRE2:","");if(O.indexOf(":")!==-1&&O.split(":").length>=2){const U=O.split(":")[1];f.push(":"+U)}}return f.join("")}e.buildRegexParseError=p;class o extends t.EventEmitter{constructor(f,S,O){super();this.maxResults=f,this.rootFolder=S,this.previewOptions=O,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new D.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(f,S){return super.on(f,S),this}handleData(f){if(this.isDone)return;const S=typeof f=="string"?f:this.stringDecoder.write(f);this.handleDecodedData(S)}handleDecodedData(f){let S=f.indexOf(`
`);const O=this.remainder+f;if(S>=0)S+=this.remainder.length;else{this.remainder=O;return}let U=0;for(;S>=0;)this.handleLine(O.substring(U,S).trim()),U=S+1,S=O.indexOf(`
`,U);this.remainder=O.substring(U)}handleLine(f){if(this.isDone||!f)return;let S;try{S=JSON.parse(f)}catch{throw new Error(`malformed line from rg: ${f}`)}if(S.type==="match"){const O=m(S.data.path),U=R.URI.file(E.join(this.rootFolder,O)),M=this.createTextSearchMatch(S.data,U);this.onResult(M),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(S.type==="context"){const O=m(S.data.path),U=R.URI.file(E.join(this.rootFolder,O));this.createTextSearchContext(S.data,U).forEach(A=>this.onResult(A))}}createTextSearchMatch(f,S){const O=f.line_number-1,U=m(f.lines),M=Buffer.from(U);let A=0,B=0,x=O;f.submatches.length===0&&f.submatches.push(U.length?{start:0,end:1,match:{text:U[0]}}:{start:0,end:0,match:{text:""}});const N=(0,P.coalesce)(f.submatches.map((K,X)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const L=m(K.match),$=M.slice(A,K.start).toString().length,H=B+$,j=c(L),J=x,Y=j.numLines+J,he=j.numLines>0?j.lastLineLength:j.lastLineLength+H;return A=K.end,B=he,x=Y,new _.Range(J,H,Y,he)}));return(0,b.createTextSearchResult)(S,U,N,this.previewOptions)}createTextSearchContext(f,S){const O=m(f.lines),U=f.line_number;return O.replace(/\r?\n$/,"").split(`
`).map((M,A)=>({text:M,uri:S,lineNumber:U+A}))}onResult(f){this.emit("result",f)}}e.RipgrepParser=o;function m(d){return d.bytes?Buffer.from(d.bytes,"base64").toString():d.text}function c(d){const f=/\n/g;let S=0,O=-1,U;for(;U=f.exec(d);)S++,O=U.index;const M=O>=0?d.length-O-1:d.length;return{numLines:S,lastLineLength:M}}function l(d,f){const S=["--hidden"];S.push(d.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:O,otherIncludes:U}=(0,y.groupBy)(f.includes,A=>A.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(U&&U.length){const A=new Set;U.forEach(B=>{A.add(B)}),S.push("-g","!*"),A.forEach(B=>{s(B).map(b.anchorGlob).forEach(x=>{S.push("-g",x)})})}O&&O.length&&O.forEach(A=>{S.push("-g",A)}),f.excludes.map(b.anchorGlob).forEach(A=>S.push("-g",`!${A}`)),f.maxFileSize&&S.push("--max-filesize",f.maxFileSize+""),f.useIgnoreFiles?f.useParentIgnoreFiles||S.push("--no-ignore-parent"):S.push("--no-ignore"),f.followSymlinks&&S.push("--follow"),f.encoding&&f.encoding!=="utf8"&&S.push("--encoding",f.encoding),d.pattern==="--"&&(d.isRegExp=!0,d.pattern="\\-\\-"),d.isMultiline&&!d.isRegExp&&(d.pattern=(0,I.escapeRegExpCharacters)(d.pattern),d.isRegExp=!0),f.usePCRE2&&S.push("--pcre2"),S.push("--crlf"),d.isRegExp&&(d.pattern=i(d.pattern),S.push("--engine","auto"));let M;if(d.isWordMatch){const B=(0,I.createRegExp)(d.pattern,!!d.isRegExp,{wholeWord:d.isWordMatch}).source.replace(/\\\//g,"/");S.push("--regexp",B)}else if(d.isRegExp){let A=n(d.pattern);A=a(A),S.push("--regexp",A)}else M=d.pattern,S.push("--fixed-strings");return S.push("--no-config"),f.useGlobalIgnoreFiles||S.push("--no-ignore-global"),S.push("--json"),d.isMultiline&&S.push("--multiline"),f.beforeContext&&S.push("--before-context",f.beforeContext+""),f.afterContext&&S.push("--after-context",f.afterContext+""),S.push("--"),M&&S.push(M),S.push("."),S}function s(d){const f=(0,C.splitGlobAware)(d,"/");return f.map((S,O)=>f.slice(0,O+1).join("/"))}e.spreadGlobComponents=s;function i(d){const f=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;d.match(f);)d=d.replace(f,"$1\\x{$2}");const S=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;d.match(S);)d=d.replace(S,"$1\\x{$2}");return d}e.unicodeEscapesToPCRE2=i;const r=d=>d.type==="Assertion"&&d.kind==="lookbehind";function n(d){let f;try{f=new T.RegExpParser().parsePattern(d)}catch{return d}let S="",O=0;const U=(B,x,N)=>{S+=d.slice(O,B)+N,O=x},M=[];return new T.RegExpVisitor({onCharacterEnter(B){if(B.raw!=="\\n")return;const x=M[0];if(!x)U(B.start,B.end,"\\r?\\n");else if(!M.some(r))if(x.type==="CharacterClass")if(x.negate){const N=d.slice(x.start+2,B.start)+d.slice(B.end,x.end-1);x.parent?.type==="Quantifier"?U(x.start,x.end,N?`[^${N}]`:"."):U(x.start,x.end,"(?!\\r?\\n"+(N?`|[${N}]`:"")+")")}else{const N=d.slice(x.start+1,B.start)+d.slice(B.end,x.end-1);U(x.start,x.end,N===""?"\\r?\\n":`(?:[${N}]|\\r?\\n)`)}else x.type==="Quantifier"&&U(B.start,B.end,"(?:\\r?\\n)")},onQuantifierEnter(B){M.unshift(B)},onQuantifierLeave(){M.shift()},onCharacterClassRangeEnter(B){M.unshift(B)},onCharacterClassRangeLeave(){M.shift()},onCharacterClassEnter(B){M.unshift(B)},onCharacterClassLeave(){M.shift()},onAssertionEnter(B){r(B)&&M.push(B)},onAssertionLeave(B){M[0]===B&&M.shift()}}).visit(f),S+=d.slice(O),S}e.fixRegexNewline=n;function a(d){return d.replace(/\n/g,"\\r?\\n")}e.fixNewline=a}),define(De[297],Ie([1,0,21,141,118,12]),function(Z,e,u,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class y{constructor(I){this.outputChannel=I,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(I,R,k,_){const T=new t.RipgrepTextSearchEngine(this.outputChannel);if(R.folder.scheme===P.Schemas.vscodeUserData){const w={...R,folder:R.folder.with({scheme:P.Schemas.file})},b=new D.Progress(v=>k.report({...v,uri:v.uri.with({scheme:R.folder.scheme})}));return this.withToken(_,v=>T.provideTextSearchResults(I,w,b,v))}else return this.withToken(_,w=>T.provideTextSearchResults(I,R,k,w))}async withToken(I,R){const k=C(I);this.inProgress.add(k);const _=await R(k.token);return this.inProgress.delete(k),_}dispose(){this.inProgress.forEach(I=>I.cancel())}}e.RipgrepSearchProvider=y;function C(E){const I=new u.CancellationTokenSource;return E.onCancellationRequested(()=>I.cancel()),I}}),define(De[298],Ie([1,0,29,141,140]),function(Z,e,u,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class P{constructor(E){this.query=E}search(E,I,R){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const k={appendLine(T){R({message:T})}},_=new D.NativeTextSearchManager(this.query,new t.RipgrepTextSearchEngine(k),u);return new Promise((T,w)=>_.search(b=>{I(b.map(y))},E).then(b=>T({limitHit:b.limitHit,type:"success",stats:b.stats}),w))}}e.TextSearchEngineAdapter=P;function y(C){return{path:C.resource&&C.resource.fsPath,results:C.results,numMatches:(C.results||[]).reduce((E,I)=>{if(I.ranges){const R=I;return E+(Array.isArray(R.ranges)?R.ranges.length:1)}else return E+1},0)}}}),define(De[299],Ie([1,0,17,18,10,4,104,9,51,2,42,30,289,298]),function(Z,e,u,t,D,P,y,C,E,I,R,k,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class w{constructor(o="searchProcess"){this.processType=o,this.caches=Object.create(null)}fileSearch(o){let m;const c=h(o),l=new P.Emitter({onFirstListenerDidAdd:()=>{m=(0,t.createCancelablePromise)(s=>this.doFileSearchWithEngine(_.Engine,c,i=>l.fire(i),s)),m.then(s=>l.fire(s),s=>l.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onLastListenerRemove:()=>{m.cancel()}});return l.event}textSearch(o){let m;const c=h(o),l=new P.Emitter({onFirstListenerDidAdd:()=>{m=(0,t.createCancelablePromise)(s=>this.ripgrepTextSearch(c,i=>l.fire(i),s)),m.then(s=>l.fire(s),s=>l.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onLastListenerRemove:()=>{m.cancel()}});return l.event}ripgrepTextSearch(o,m,c){return o.maxFileSize=(0,R.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new T.TextSearchEngineAdapter(o).search(c,m,m)}doFileSearch(o,m,c){return this.doFileSearchWithEngine(_.Engine,o,m,c)}doFileSearchWithEngine(o,m,c,l,s=w.BATCH_SIZE){let i=0;const r=a=>{Array.isArray(a)?(i+=a.length,c(a.map(d=>this.rawMatchToSearchItem(d)))):a.relativePath?(i++,c(this.rawMatchToSearchItem(a))):c(a)};if(m.sortByScore){let a=this.trySortedSearchFromCache(m,r,l);if(!a){const d=m.maxResults?Object.assign({},m,{maxResults:null}):m,f=new o(d);a=this.doSortedSearch(f,m,c,r,l)}return new Promise((d,f)=>{a.then(([S,O])=>{const U=O.map(M=>this.rawMatchToSearchItem(M));this.sendProgress(U,c,s),d(S)},f)})}const n=new o(m);return this.doSearch(n,r,s,l).then(a=>({limitHit:a.limitHit,type:"success",stats:{detailStats:a.stats,type:this.processType,fromCache:!1,resultCount:i,sortingTime:void 0}}))}rawMatchToSearchItem(o){return{path:o.base?(0,C.join)(o.base,o.relativePath):o.relativePath}}doSortedSearch(o,m,c,l,s){const i=new P.Emitter;let r=(0,t.createCancelablePromise)(a=>{let d=[];const f=S=>{Array.isArray(S)?d=S:(l(S),i.fire(S))};return this.doSearch(o,f,-1,a).then(S=>[S,d])}),n;if(m.cacheKey){n=this.getOrCreateCache(m.cacheKey);const a={promise:r,event:i.event,resolved:!1};n.resultsToSearchCache[m.filePattern||""]=a,r.then(()=>{a.resolved=!0},d=>{delete n.resultsToSearchCache[m.filePattern||""]}),r=this.preventCancellation(r)}return r.then(([a,d])=>{const f=n?n.scorerCache:Object.create(null),S=(typeof m.maxResults!="number"||m.maxResults>0)&&E.StopWatch.create(!1);return this.sortResults(m,d,f,s).then(O=>{const U=S?S.elapsed():-1;return[{type:"success",stats:{detailStats:a.stats,sortingTime:U,fromCache:!1,type:this.processType,workspaceFolderCount:m.folderQueries.length,resultCount:O.length},messages:a.messages,limitHit:a.limitHit||typeof m.maxResults=="number"&&d.length>m.maxResults},O]})})}getOrCreateCache(o){const m=this.caches[o];return m||(this.caches[o]=new b)}trySortedSearchFromCache(o,m,c){const l=o.cacheKey&&this.caches[o.cacheKey];if(!l)return;const s=this.getResultsFromCache(l,o.filePattern||"",m,c);if(s)return s.then(([i,r,n])=>{const a=E.StopWatch.create(!1);return this.sortResults(o,r,l.scorerCache,c).then(d=>{const f=a.elapsed(),S={fromCache:!0,detailStats:n,type:this.processType,resultCount:r.length,sortingTime:f};return[{type:"success",limitHit:i.limitHit||typeof o.maxResults=="number"&&r.length>o.maxResults,stats:S},d]})})}sortResults(o,m,c,l){const s=(0,y.prepareQuery)(o.filePattern||""),i=(n,a)=>(0,y.compareItemsByFuzzyScore)(n,a,s,!0,v,c),r=typeof o.maxResults=="number"?o.maxResults:Number.MAX_VALUE;return u.topAsync(m,i,r,1e4,l)}sendProgress(o,m,c){if(c&&c>0)for(let l=0;l<o.length;l+=c)m(o.slice(l,l+c));else m(o)}getResultsFromCache(o,m,c,l){const s=E.StopWatch.create(!1),i=m.indexOf(C.sep)>=0;let r;for(const f in o.resultsToSearchCache)if(m.startsWith(f)){if(i&&f.indexOf(C.sep)<0&&f!=="")continue;const S=o.resultsToSearchCache[f];r={promise:this.preventCancellation(S.promise),event:S.event,resolved:S.resolved};break}if(!r)return null;const n=s.elapsed(),a=E.StopWatch.create(!1),d=r.event(c);return l&&l.onCancellationRequested(()=>{d.dispose()}),r.promise.then(([f,S])=>{if(l&&l.isCancellationRequested)throw(0,D.canceled)();const O=[],U=(0,y.prepareQuery)(m).normalizedLowercase;for(const M of S)!(0,k.isFilePatternMatch)(M,U)||O.push(M);return[f,O,{cacheWasResolved:r.resolved,cacheLookupTime:n,cacheFilterTime:a.elapsed(),cacheEntryCount:S.length}]})}doSearch(o,m,c,l){return new Promise((s,i)=>{let r=[];l?.onCancellationRequested(()=>o.cancel()),o.search(n=>{n&&(c?(r.push(n),c>0&&r.length>=c&&(m(r),r=[])):m(n))},n=>{m(n)},(n,a)=>{r.length&&m(r),n?i(n):s(a)})})}clearCache(o){return delete this.caches[o],Promise.resolve(void 0)}preventCancellation(o){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(m,c){return o.then(m,c)}catch(m){return this.then(void 0,m)}finally(m){return o.finally(m)}}}}e.SearchService=w,w.BATCH_SIZE=512;class b{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const v=new class{getItemLabel(p){return(0,C.basename)(p.relativePath)}getItemDescription(p){return(0,C.dirname)(p.relativePath)}getItemPath(p){return p.relativePath}};function h(p){return{...p,folderQueries:p.folderQueries&&p.folderQueries.map(g),extraFileResources:p.extraFileResources&&p.extraFileResources.map(o=>I.URI.revive(o))}}function g(p){return{...p,folder:I.URI.revive(p.folder)}}}),define(De[300],Ie([1,0,6,12,2,29,14,26,15,75,64,30,299,297,92,140]),function(Z,e,u,t,D,P,y,C,E,I,R,k,_,T,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let v=class extends I.ExtHostSearch{constructor(g,p,o,m){super(g,o,m);this._pfs=P,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1;const c=new w.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(t.Schemas.vscodeUserData,new T.RipgrepSearchProvider(c)),p.remote.isRemote&&p.remote.authority&&this._registerEHSearchProviders()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const g=new w.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(t.Schemas.file,new T.RipgrepSearchProvider(g)),this.registerInternalFileSearchProvider(t.Schemas.file,new _.SearchService("fileSearchProvider"))}registerInternalFileSearchProvider(g,p){const o=this._handlePool++;return this._internalFileSearchProvider=p,this._internalFileSearchHandle=o,this._proxy.$registerFileSearchProvider(o,this._transformScheme(g)),(0,u.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(o)})}$provideFileSearchResults(g,p,o,m){const c=(0,I.reviveQuery)(o);return g===this._internalFileSearchHandle?this.doInternalFileSearch(g,p,c,m):super.$provideFileSearchResults(g,p,o,m)}doInternalFileSearch(g,p,o,m){const c=l=>{if((0,k.isSerializedFileMatch)(l)&&(l=[l]),Array.isArray(l)){this._proxy.$handleFileMatch(g,p,l.map(s=>D.URI.file(s.path)));return}l.message&&this._logService.debug("ExtHostSearch",l.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(o,c,m)}$clearCache(g){return this._internalFileSearchProvider?.clearCache(g),super.$clearCache(g)}createTextSearchManager(g,p){return new b.NativeTextSearchManager(g,p,void 0,"textSearchProvider")}};v=je([xe(0,E.IExtHostRpcService),xe(1,C.IExtHostInitDataService),xe(2,R.IURITransformerService),xe(3,y.ILogService)],v),e.NativeExtHostSearch=v}),define(De[301],Ie([1,0,82,272,284,283,300,296,273,74,39,75,72,38,53,69,271,270,14,285,47]),function(Z,e,u,t,D,P,y,C,E,I,R,k,_,T,w,b,v,h,g,p,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,u.registerSingleton)(R.IExtHostExtensionService,C.ExtHostExtensionService),(0,u.registerSingleton)(g.ILoggerService,h.ExtHostLoggerService),(0,u.registerSingleton)(b.IExtensionStoragePaths,v.ExtensionStoragePaths),(0,u.registerSingleton)(I.IExtHostDebugService,P.ExtHostDebugService),(0,u.registerSingleton)(k.IExtHostSearch,y.NativeExtHostSearch),(0,u.registerSingleton)(_.IExtHostTask,D.ExtHostTask),(0,u.registerSingleton)(T.IExtHostTerminalService,t.ExtHostTerminalService),(0,u.registerSingleton)(w.IExtHostTunnelService,E.ExtHostTunnelService),(0,u.registerSingleton)(o.IExtHostVariableResolverProvider,p.NodeExtHostVariableResolverProviderService)}),define(De[309],Ie([1,0,214,310,73,10,111,112,195,133,282,23,29,108,18,114,208,227,286,301]),function(Z,e,u,t,D,P,y,C,E,I,R,k,_,T,w,b,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let n=0;n<process.execArgv.length;n++)process.execArgv[n]==="--inspect-port=0"&&(process.execArgv.splice(n,1),n--)}();const g=t(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const r=Z.__$__nodeRequire("module"),n=r._load;r._load=function(a){if(a==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return n.apply(this,arguments)}})();const p=process.exit.bind(process);function o(r){process.exit=function(n){if(r)p(n);else{const a=new Error("An extension called process.exit() and this was prevented.");console.warn(a.stack)}},process.crash=function(){const n=new Error("An extension called process.crash() and this was prevented.");console.warn(n.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let m=function(r){p()};function c(){const r=(0,h.readExtHostConnection)(process.env);if(r.type===3)return new Promise((n,a)=>{const d=f=>{const S=f[0],O=new y.BufferedEmitter;S.on("message",U=>O.fire(k.VSBuffer.wrap(U.data))),S.on("close",()=>{m("renderer closed the MessagePort")}),S.start(),n({onMessage:O.event,send:U=>S.postMessage(U.buffer)})};if(global.vscodePorts){const f=global.vscodePorts;delete global.vscodePorts,d(f)}else global.vscodePortsCallback=d});if(r.type===2)return new Promise((n,a)=>{let d=null;const f=setTimeout(()=>{m("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),S=108e5,O=3e5,U=new w.ProcessTimeRunOnceScheduler(()=>m("renderer disconnected for too long (1)"),S),M=new w.ProcessTimeRunOnceScheduler(()=>m("renderer disconnected for too long (2)"),O);process.on("message",(B,x)=>{if(B&&B.type==="VSCODE_EXTHOST_IPC_SOCKET"){x.setNoDelay(!0);const N=k.VSBuffer.wrap(Buffer.from(B.initialDataChunk,"base64"));let K;if(B.skipWebSocketFrames)K=new C.NodeSocket(x,"extHost-socket");else{const X=k.VSBuffer.wrap(Buffer.from(B.inflateBytes,"base64"));K=new C.WebSocketNodeSocket(new C.NodeSocket(x,"extHost-socket"),B.permessageDeflate,X,!1)}d?(U.cancel(),M.cancel(),d.beginAcceptReconnection(K,N),d.endAcceptReconnection(),d.sendResume()):(clearTimeout(f),d=new y.PersistentProtocol(K,N),d.sendResume(),d.onDidDispose(()=>m("renderer disconnected")),n(d),d.onSocketClose(()=>{U.schedule()}))}if(B&&B.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(M.isScheduled())return;U.isScheduled()&&M.schedule()}});const A={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(A)});{const n=r.pipeName;return new Promise((a,d)=>{const f=u.createConnection(n,()=>{f.removeListener("error",d);const S=new y.PersistentProtocol(new C.NodeSocket(f,"extHost-renderer"));S.sendResume(),a(S)});f.once("error",d),f.on("close",()=>{m("renderer closed the socket")})})}}async function l(){const r=await c();return new class{constructor(){this._onMessage=new y.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,r.onMessage(n=>{(0,I.isMessageOfType)(n,2)?(this._terminating=!0,m("received terminate message from renderer")):this._onMessage.fire(n)})}send(n){this._terminating||r.send(n)}async drain(){if(r.drain)return r.drain()}}}function s(r){return new Promise(n=>{const a=r.onMessage(d=>{a.dispose();const f=JSON.parse(d.toString()),S=f.commit,O=E.default.commit;if(S&&O&&S!==O&&p(55),f.parentPid){let U=0;setInterval(function(){try{process.kill(f.parentPid,0),U=0}catch(A){A&&A.code==="EPERM"?(U++,U>=3&&m(`parent process ${f.parentPid} does not exist anymore (3 x EPERM): ${A.message} (code: ${A.code}) (errno: ${A.errno})`)):m(`parent process ${f.parentPid} does not exist anymore: ${A.message} (code: ${A.code}) (errno: ${A.errno})`)}},1e3);let M;try{M=Z.__$__nodeRequire("native-watchdog"),M.start(f.parentPid)}catch(A){(0,P.onUnexpectedError)(A)}}r.send((0,I.createMessageOfType)(0)),n({protocol:r,initData:f})});r.send((0,I.createMessageOfType)(1))})}async function i(){const r=[];process.on("unhandledRejection",(U,M)=>{r.push(M),setTimeout(()=>{const A=r.indexOf(M);A>=0&&M.catch(B=>{r.splice(A,1),(0,P.isCancellationError)(B)||(console.warn(`rejected promise not handled within 1 second: ${B}`),B&&B.stack&&console.warn(`stack trace: ${B.stack}`),U&&(0,P.onUnexpectedError)(U))})},1e3)}),process.on("rejectionHandled",U=>{const M=r.indexOf(U);M>=0&&r.splice(M,1)}),process.on("uncaughtException",function(U){(0,P.onUnexpectedError)(U)}),D.mark("code/extHost/willConnectToRenderer");const n=await l();D.mark("code/extHost/didConnectToRenderer");const a=await s(n);D.mark("code/extHost/didWaitForInitData");const{initData:d}=a;o(!!d.environment.extensionTestsLocationURI),d.environment.useHostProxy=g.useHostProxy!==void 0?g.useHostProxy!=="false":void 0,d.environment.skipWorkspaceStorageLock=(0,b.boolean)(g.skipWorkspaceStorageLock,!1);const f=new class{constructor(){this.pid=process.pid}exit(M){p(M)}exists(M){return _.Promises.exists(M)}realpath(M){return(0,T.realpath)(M)}};let S=null;d.remote.authority&&g.transformURIs&&(S=(0,v.createURITransformer)(d.remote.authority));const O=new R.ExtensionHostMain(a.protocol,d,f,S);m=U=>O.terminate(U)}e.startExtensionHostProcess=i,i().catch(r=>console.log(r))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/7fee053fdfef9bd86da74dc3c223b95019c5d297/core/vs/workbench/api/node/extensionHostProcess.js.map
