/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ye=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/workbench/api/common/extHostTypes","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypeConverters","vs/base/common/strings","vs/base/common/types","vs/base/common/errors","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/async","vs/platform/log/common/log","vs/base/common/arrays","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/path","vs/base/common/cancellation","vs/base/common/platform","vs/base/common/resources","vs/base/common/buffer","vs/workbench/services/extensions/common/extensions","vs/base/common/map","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/severity","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/glob","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostCommands","vs/base/common/extpath","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/uuid","vs/base/common/errorMessage","vs/base/common/assert","vs/platform/workspace/common/workspace","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/editor/common/core/range","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/marshalling","vs/platform/instantiation/common/extensions","vs/platform/configuration/common/configuration","vs/platform/instantiation/common/serviceCollection","vs/base/common/process","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/common/webview","vs/workbench/contrib/testing/common/testItemCollection","vs/editor/common/languages","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/collections","vs/base/common/idGenerator","vs/base/common/mime","vs/base/common/htmlContent","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostDecorations","vs/base/common/hash","vs/workbench/api/common/extHostTelemetryLogService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/codicons","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/editor","vs/workbench/api/common/extHostCodeInsets","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/lazy","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.common.services","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/base/common/linkedList","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],De=function(ne){for(var e=[],a=0,v=ne.length;a<v;a++)e[a]=ye[ne[a]];return e};define(ye[72],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function a(D,P){const E=Object.create(null);for(const T of D){const O=P(T);let y=E[O];y||(y=E[O]=[]),y.push(T)}return E}e.groupBy=a;function v(D,P){const E=[],T=[];for(const O of D)P.has(O)||E.push(O);for(const O of P)D.has(O)||T.push(O);return{removed:E,added:T}}e.diffSets=v;function b(D,P){const E=[],T=[];for(const[O,y]of D)P.has(O)||E.push(y);for(const[O,y]of P)D.has(O)||T.push(y);return{removed:E,added:T}}e.diffMaps=b;class M{constructor(){this.map=new Map}add(P,E){let T=this.map.get(P);T||(T=new Set,this.map.set(P,T)),T.add(E)}delete(P,E){const T=this.map.get(P);!T||(T.delete(E),T.size===0&&this.map.delete(P))}forEach(P,E){const T=this.map.get(P);!T||T.forEach(E)}}e.SetMap=M}),define(ye[54],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function a(D){return(P,E,T)=>{let O=null,y=null;if(typeof T.value=="function"?(O="value",y=T.value):typeof T.get=="function"&&(O="get",y=T.get),!y)throw new Error("not supported");T[O]=D(y,E)}}e.createDecorator=a;function v(D,P,E){let T=null,O=null;if(typeof E.value=="function"?(T="value",O=E.value,O.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof E.get=="function"&&(T="get",O=E.get),!O)throw new Error("not supported");const y=`$memoize$${P}`;E[T]=function(...m){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:O.apply(this,m)}),this[y]}}e.memoize=v;function b(D,P,E){return a((T,O)=>{const y=`$debounce$${O}`,m=`$debounce$result$${O}`;return function(...k){this[m]||(this[m]=E?E():void 0),clearTimeout(this[y]),P&&(this[m]=P(this[m],...k),k=[this[m]]),this[y]=setTimeout(()=>{T.apply(this,k),this[m]=E?E():void 0},D)}})}e.debounce=b;function M(D,P,E){return a((T,O)=>{const y=`$throttle$timer$${O}`,m=`$throttle$result$${O}`,k=`$throttle$lastRun$${O}`,f=`$throttle$pending$${O}`;return function(...h){if(this[m]||(this[m]=E?E():void 0),(this[k]===null||this[k]===void 0)&&(this[k]=-Number.MAX_VALUE),P&&(this[m]=P(this[m],...h)),this[f])return;const d=this[k]+D;d<=Date.now()?(this[k]=Date.now(),T.apply(this,[this[m]]),this[m]=E?E():void 0):(this[f]=!0,this[y]=setTimeout(()=>{this[f]=!1,this[k]=Date.now(),T.apply(this,[this[m]]),this[m]=E?E():void 0},d-Date.now()))}})}e.throttle=M}),define(ye[73],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class a{constructor(b){this._prefix=b,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=a,e.defaultGenerator=new a("id#")}),define(ye[105],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var a;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(a=e.ScanError||(e.ScanError={}));var v;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(v=e.SyntaxKind||(e.SyntaxKind={}));var b;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(b=e.ParseErrorCode||(e.ParseErrorCode={}));var M;(function(s){s.DEFAULT={allowTrailingComma:!0}})(M=e.ParseOptions||(e.ParseOptions={}));function D(s,u=!1){let n=0;const i=s.length;let r="",t=0,c=16,_=0;function p($){let F=0,q=0;for(;F<$;){const ie=s.charCodeAt(n);if(ie>=48&&ie<=57)q=q*16+ie-48;else if(ie>=65&&ie<=70)q=q*16+ie-65+10;else if(ie>=97&&ie<=102)q=q*16+ie-97+10;else break;n++,F++}return F<$&&(q=-1),q}function C($){n=$,r="",t=0,c=16,_=0}function U(){const $=n;if(s.charCodeAt(n)===48)n++;else for(n++;n<s.length&&T(s.charCodeAt(n));)n++;if(n<s.length&&s.charCodeAt(n)===46)if(n++,n<s.length&&T(s.charCodeAt(n)))for(n++;n<s.length&&T(s.charCodeAt(n));)n++;else return _=3,s.substring($,n);let F=n;if(n<s.length&&(s.charCodeAt(n)===69||s.charCodeAt(n)===101))if(n++,(n<s.length&&s.charCodeAt(n)===43||s.charCodeAt(n)===45)&&n++,n<s.length&&T(s.charCodeAt(n))){for(n++;n<s.length&&T(s.charCodeAt(n));)n++;F=n}else _=3;return s.substring($,F)}function W(){let $="",F=n;for(;;){if(n>=i){$+=s.substring(F,n),_=2;break}const q=s.charCodeAt(n);if(q===34){$+=s.substring(F,n),n++;break}if(q===92){if($+=s.substring(F,n),n++,n>=i){_=2;break}switch(s.charCodeAt(n++)){case 34:$+='"';break;case 92:$+="\\";break;case 47:$+="/";break;case 98:$+="\b";break;case 102:$+="\f";break;case 110:$+=`
`;break;case 114:$+="\r";break;case 116:$+="	";break;case 117:{const A=p(4);A>=0?$+=String.fromCharCode(A):_=4;break}default:_=5}F=n;continue}if(q>=0&&q<=31)if(E(q)){$+=s.substring(F,n),_=2;break}else _=6;n++}return $}function L(){if(r="",_=0,t=n,n>=i)return t=i,c=17;let $=s.charCodeAt(n);if(P($)){do n++,r+=String.fromCharCode($),$=s.charCodeAt(n);while(P($));return c=15}if(E($))return n++,r+=String.fromCharCode($),$===13&&s.charCodeAt(n)===10&&(n++,r+=`
`),c=14;switch($){case 123:return n++,c=1;case 125:return n++,c=2;case 91:return n++,c=3;case 93:return n++,c=4;case 58:return n++,c=6;case 44:return n++,c=5;case 34:return n++,r=W(),c=10;case 47:{const F=n-1;if(s.charCodeAt(n+1)===47){for(n+=2;n<i&&!E(s.charCodeAt(n));)n++;return r=s.substring(F,n),c=12}if(s.charCodeAt(n+1)===42){n+=2;const q=i-1;let ie=!1;for(;n<q;){if(s.charCodeAt(n)===42&&s.charCodeAt(n+1)===47){n+=2,ie=!0;break}n++}return ie||(n++,_=1),r=s.substring(F,n),c=13}return r+=String.fromCharCode($),n++,c=16}case 45:if(r+=String.fromCharCode($),n++,n===i||!T(s.charCodeAt(n)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=U(),c=11;default:for(;n<i&&S($);)n++,$=s.charCodeAt(n);if(t!==n){switch(r=s.substring(t,n),r){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return r+=String.fromCharCode($),n++,c=16}}function S($){if(P($)||E($))return!1;switch($){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function z(){let $;do $=L();while($>=12&&$<=15);return $}return{setPosition:C,getPosition:()=>n,scan:u?z:L,getToken:()=>c,getTokenValue:()=>r,getTokenOffset:()=>t,getTokenLength:()=>n-t,getTokenError:()=>_}}e.createScanner=D;function P(s){return s===32||s===9||s===11||s===12||s===160||s===5760||s>=8192&&s<=8203||s===8239||s===8287||s===12288||s===65279}function E(s){return s===10||s===13||s===8232||s===8233}function T(s){return s>=48&&s<=57}var O;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(O||(O={}));function y(s,u){const n=[],i=new Object;let r;const t={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function _(p,C,U,W){t.value=p,t.offset=C,t.length=U,t.type=W,t.colonOffset=void 0,r=t}try{R(s,{onObjectBegin:(p,C)=>{if(u<=p)throw i;r=void 0,c=u>p,n.push("")},onObjectProperty:(p,C,U)=>{if(u<C||(_(p,C,U,"property"),n[n.length-1]=p,u<=C+U))throw i},onObjectEnd:(p,C)=>{if(u<=p)throw i;r=void 0,n.pop()},onArrayBegin:(p,C)=>{if(u<=p)throw i;r=void 0,n.push(0)},onArrayEnd:(p,C)=>{if(u<=p)throw i;r=void 0,n.pop()},onLiteralValue:(p,C,U)=>{if(u<C||(_(p,C,U,w(p)),u<=C+U))throw i},onSeparator:(p,C,U)=>{if(u<=C)throw i;if(p===":"&&r&&r.type==="property")r.colonOffset=C,c=!1,r=void 0;else if(p===","){const W=n[n.length-1];typeof W=="number"?n[n.length-1]=W+1:(c=!0,n[n.length-1]=""),r=void 0}}})}catch(p){if(p!==i)throw p}return{path:n,previousNode:r,isAtPropertyKey:c,matches:p=>{let C=0;for(let U=0;C<p.length&&U<n.length;U++)if(p[C]===n[U]||p[C]==="*")C++;else if(p[C]!=="**")return!1;return C===p.length}}}e.getLocation=y;function m(s,u=[],n=M.DEFAULT){let i=null,r=[];const t=[];function c(p){Array.isArray(r)?r.push(p):i!==null&&(r[i]=p)}return R(s,{onObjectBegin:()=>{const p={};c(p),t.push(r),r=p,i=null},onObjectProperty:p=>{i=p},onObjectEnd:()=>{r=t.pop()},onArrayBegin:()=>{const p=[];c(p),t.push(r),r=p,i=null},onArrayEnd:()=>{r=t.pop()},onLiteralValue:c,onError:(p,C,U)=>{u.push({error:p,offset:C,length:U})}},n),r[0]}e.parse=m;function k(s,u=[],n=M.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(p){i.type==="property"&&(i.length=p-i.offset,i=i.parent)}function t(p){return i.children.push(p),p}R(s,{onObjectBegin:p=>{i=t({type:"object",offset:p,length:-1,parent:i,children:[]})},onObjectProperty:(p,C,U)=>{i=t({type:"property",offset:C,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:p,offset:C,length:U,parent:i})},onObjectEnd:(p,C)=>{i.length=p+C-i.offset,i=i.parent,r(p+C)},onArrayBegin:(p,C)=>{i=t({type:"array",offset:p,length:-1,parent:i,children:[]})},onArrayEnd:(p,C)=>{i.length=p+C-i.offset,i=i.parent,r(p+C)},onLiteralValue:(p,C,U)=>{t({type:w(p),offset:C,length:U,parent:i,value:p}),r(C+U)},onSeparator:(p,C,U)=>{i.type==="property"&&(p===":"?i.colonOffset=C:p===","&&r(C))},onError:(p,C,U)=>{u.push({error:p,offset:C,length:U})}},n);const _=i.children[0];return _&&delete _.parent,_}e.parseTree=k;function f(s,u){if(!s)return;let n=s;for(const i of u)if(typeof i=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let r=!1;for(const t of n.children)if(Array.isArray(t.children)&&t.children[0].value===i){n=t.children[1],r=!0;break}if(!r)return}else{const r=i;if(n.type!=="array"||r<0||!Array.isArray(n.children)||r>=n.children.length)return;n=n.children[r]}return n}e.findNodeAtLocation=f;function h(s){if(!s.parent||!s.parent.children)return[];const u=h(s.parent);if(s.parent.type==="property"){const n=s.parent.children[0].value;u.push(n)}else if(s.parent.type==="array"){const n=s.parent.children.indexOf(s);n!==-1&&u.push(n)}return u}e.getNodePath=h;function d(s){switch(s.type){case"array":return s.children.map(d);case"object":{const u=Object.create(null);for(const n of s.children){const i=n.children[1];i&&(u[n.children[0].value]=d(i))}return u}case"null":case"string":case"number":case"boolean":return s.value;default:return}}e.getNodeValue=d;function o(s,u,n=!1){return u>=s.offset&&u<s.offset+s.length||n&&u===s.offset+s.length}e.contains=o;function g(s,u,n=!1){if(o(s,u,n)){const i=s.children;if(Array.isArray(i))for(let r=0;r<i.length&&i[r].offset<=u;r++){const t=g(i[r],u,n);if(t)return t}return s}}e.findNodeAtOffset=g;function R(s,u,n=M.DEFAULT){const i=D(s,!1);function r(Ee){return Ee?()=>Ee(i.getTokenOffset(),i.getTokenLength()):()=>!0}function t(Ee){return Ee?be=>Ee(be,i.getTokenOffset(),i.getTokenLength()):()=>!0}const c=r(u.onObjectBegin),_=t(u.onObjectProperty),p=r(u.onObjectEnd),C=r(u.onArrayBegin),U=r(u.onArrayEnd),W=t(u.onLiteralValue),L=t(u.onSeparator),S=r(u.onComment),z=t(u.onError),$=n&&n.disallowComments,F=n&&n.allowTrailingComma;function q(){for(;;){const Ee=i.scan();switch(i.getTokenError()){case 4:ie(14);break;case 5:ie(15);break;case 3:ie(13);break;case 1:$||ie(11);break;case 2:ie(12);break;case 6:ie(16);break}switch(Ee){case 12:case 13:$?ie(10):S();break;case 16:ie(1);break;case 15:case 14:break;default:return Ee}}}function ie(Ee,be=[],ee=[]){if(z(Ee),be.length+ee.length>0){let ve=i.getToken();for(;ve!==17;){if(be.indexOf(ve)!==-1){q();break}else if(ee.indexOf(ve)!==-1)break;ve=q()}}}function A(Ee){const be=i.getTokenValue();return Ee?W(be):_(be),q(),!0}function Z(){switch(i.getToken()){case 11:{let Ee=0;try{Ee=JSON.parse(i.getTokenValue()),typeof Ee!="number"&&(ie(2),Ee=0)}catch{ie(2)}W(Ee);break}case 7:W(null);break;case 8:W(!0);break;case 9:W(!1);break;default:return!1}return q(),!0}function le(){return i.getToken()!==10?(ie(3,[],[2,5]),!1):(A(!1),i.getToken()===6?(L(":"),q(),te()||ie(4,[],[2,5])):ie(5,[],[2,5]),!0)}function oe(){c(),q();let Ee=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(Ee||ie(4,[],[]),L(","),q(),i.getToken()===2&&F)break}else Ee&&ie(6,[],[]);le()||ie(4,[],[2,5]),Ee=!0}return p(),i.getToken()!==2?ie(7,[2],[]):q(),!0}function ue(){C(),q();let Ee=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(Ee||ie(4,[],[]),L(","),q(),i.getToken()===4&&F)break}else Ee&&ie(6,[],[]);te()||ie(4,[],[4,5]),Ee=!0}return U(),i.getToken()!==4?ie(8,[4],[]):q(),!0}function te(){switch(i.getToken()){case 3:return ue();case 1:return oe();case 10:return A(!0);default:return Z()}}return q(),i.getToken()===17?n.allowEmptyContent?!0:(ie(4,[],[]),!1):te()?(i.getToken()!==17&&ie(9,[],[]),!0):(ie(4,[],[]),!1)}e.visit=R;function l(s,u){const n=D(s),i=[];let r,t=0,c;do switch(c=n.getPosition(),r=n.scan(),r){case 12:case 13:case 17:t!==c&&i.push(s.substring(t,c)),u!==void 0&&i.push(n.getTokenValue().replace(/[^\r\n]/g,u)),t=n.getPosition();break}while(r!==17);return i.join("")}e.stripComments=l;function w(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=w}),function(ne,e){typeof exports=="object"&&typeof module!="undefined"?e(exports):typeof define=="function"&&define.amd?define(ye[106],De([0]),e):(ne=typeof globalThis!="undefined"?globalThis:ne||self,e(ne.marked={}))}(this,function(ne){"use strict";function e(Ie,Se){for(var ke=0;ke<Se.length;ke++){var ae=Se[ke];ae.enumerable=ae.enumerable||!1,ae.configurable=!0,"value"in ae&&(ae.writable=!0),Object.defineProperty(Ie,ae.key,ae)}}function a(Ie,Se,ke){return Se&&e(Ie.prototype,Se),ke&&e(Ie,ke),Object.defineProperty(Ie,"prototype",{writable:!1}),Ie}function v(Ie,Se){if(!!Ie){if(typeof Ie=="string")return b(Ie,Se);var ke=Object.prototype.toString.call(Ie).slice(8,-1);if(ke==="Object"&&Ie.constructor&&(ke=Ie.constructor.name),ke==="Map"||ke==="Set")return Array.from(Ie);if(ke==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ke))return b(Ie,Se)}}function b(Ie,Se){(Se==null||Se>Ie.length)&&(Se=Ie.length);for(var ke=0,ae=new Array(Se);ke<Se;ke++)ae[ke]=Ie[ke];return ae}function M(Ie,Se){var ke=typeof Symbol!="undefined"&&Ie[Symbol.iterator]||Ie["@@iterator"];if(ke)return(ke=ke.call(Ie)).next.bind(ke);if(Array.isArray(Ie)||(ke=v(Ie))||Se&&Ie&&typeof Ie.length=="number"){ke&&(Ie=ke);var ae=0;return function(){return ae>=Ie.length?{done:!0}:{done:!1,value:Ie[ae++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function D(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ne.defaults=D();function P(Ie){ne.defaults=Ie}var E=/[&<>"']/,T=/[&<>"']/g,O=/[<>"']|&(?!#?\w+;)/,y=/[<>"']|&(?!#?\w+;)/g,m={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},k=function(Se){return m[Se]};function f(Ie,Se){if(Se){if(E.test(Ie))return Ie.replace(T,k)}else if(O.test(Ie))return Ie.replace(y,k);return Ie}var h=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function d(Ie){return Ie.replace(h,function(Se,ke){return ke=ke.toLowerCase(),ke==="colon"?":":ke.charAt(0)==="#"?ke.charAt(1)==="x"?String.fromCharCode(parseInt(ke.substring(2),16)):String.fromCharCode(+ke.substring(1)):""})}var o=/(^|[^\[])\^/g;function g(Ie,Se){Ie=typeof Ie=="string"?Ie:Ie.source,Se=Se||"";var ke={replace:function(ce,G){return G=G.source||G,G=G.replace(o,"$1"),Ie=Ie.replace(ce,G),ke},getRegex:function(){return new RegExp(Ie,Se)}};return ke}var R=/[^\w:]/g,l=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function w(Ie,Se,ke){if(Ie){var ae;try{ae=decodeURIComponent(d(ke)).replace(R,"").toLowerCase()}catch{return null}if(ae.indexOf("javascript:")===0||ae.indexOf("vbscript:")===0||ae.indexOf("data:")===0)return null}Se&&!l.test(ke)&&(ke=r(Se,ke));try{ke=encodeURI(ke).replace(/%25/g,"%")}catch{return null}return ke}var s={},u=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function r(Ie,Se){s[" "+Ie]||(u.test(Ie)?s[" "+Ie]=Ie+"/":s[" "+Ie]=p(Ie,"/",!0)),Ie=s[" "+Ie];var ke=Ie.indexOf(":")===-1;return Se.substring(0,2)==="//"?ke?Se:Ie.replace(n,"$1")+Se:Se.charAt(0)==="/"?ke?Se:Ie.replace(i,"$1")+Se:Ie+Se}var t={exec:function(){}};function c(Ie){for(var Se=1,ke,ae;Se<arguments.length;Se++){ke=arguments[Se];for(ae in ke)Object.prototype.hasOwnProperty.call(ke,ae)&&(Ie[ae]=ke[ae])}return Ie}function _(Ie,Se){var ke=Ie.replace(/\|/g,function(G,Q,I){for(var B=!1,H=Q;--H>=0&&I[H]==="\\";)B=!B;return B?"|":" |"}),ae=ke.split(/ \|/),ce=0;if(ae[0].trim()||ae.shift(),ae.length>0&&!ae[ae.length-1].trim()&&ae.pop(),ae.length>Se)ae.splice(Se);else for(;ae.length<Se;)ae.push("");for(;ce<ae.length;ce++)ae[ce]=ae[ce].trim().replace(/\\\|/g,"|");return ae}function p(Ie,Se,ke){var ae=Ie.length;if(ae===0)return"";for(var ce=0;ce<ae;){var G=Ie.charAt(ae-ce-1);if(G===Se&&!ke)ce++;else if(G!==Se&&ke)ce++;else break}return Ie.slice(0,ae-ce)}function C(Ie,Se){if(Ie.indexOf(Se[1])===-1)return-1;for(var ke=Ie.length,ae=0,ce=0;ce<ke;ce++)if(Ie[ce]==="\\")ce++;else if(Ie[ce]===Se[0])ae++;else if(Ie[ce]===Se[1]&&(ae--,ae<0))return ce;return-1}function U(Ie){Ie&&Ie.sanitize&&!Ie.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function W(Ie,Se){if(Se<1)return"";for(var ke="";Se>1;)Se&1&&(ke+=Ie),Se>>=1,Ie+=Ie;return ke+Ie}function L(Ie,Se,ke,ae){var ce=Se.href,G=Se.title?f(Se.title):null,Q=Ie[1].replace(/\\([\[\]])/g,"$1");if(Ie[0].charAt(0)!=="!"){ae.state.inLink=!0;var I={type:"link",raw:ke,href:ce,title:G,text:Q,tokens:ae.inlineTokens(Q,[])};return ae.state.inLink=!1,I}return{type:"image",raw:ke,href:ce,title:G,text:f(Q)}}function S(Ie,Se){var ke=Ie.match(/^(\s+)(?:```)/);if(ke===null)return Se;var ae=ke[1];return Se.split(`
`).map(function(ce){var G=ce.match(/^\s+/);if(G===null)return ce;var Q=G[0];return Q.length>=ae.length?ce.slice(ae.length):ce}).join(`
`)}var z=function(){function Ie(ke){this.options=ke||ne.defaults}var Se=Ie.prototype;return Se.space=function(ae){var ce=this.rules.block.newline.exec(ae);if(ce&&ce[0].length>0)return{type:"space",raw:ce[0]}},Se.code=function(ae){var ce=this.rules.block.code.exec(ae);if(ce){var G=ce[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ce[0],codeBlockStyle:"indented",text:this.options.pedantic?G:p(G,`
`)}}},Se.fences=function(ae){var ce=this.rules.block.fences.exec(ae);if(ce){var G=ce[0],Q=S(G,ce[3]||"");return{type:"code",raw:G,lang:ce[2]?ce[2].trim():ce[2],text:Q}}},Se.heading=function(ae){var ce=this.rules.block.heading.exec(ae);if(ce){var G=ce[2].trim();if(/#$/.test(G)){var Q=p(G,"#");(this.options.pedantic||!Q||/ $/.test(Q))&&(G=Q.trim())}var I={type:"heading",raw:ce[0],depth:ce[1].length,text:G,tokens:[]};return this.lexer.inline(I.text,I.tokens),I}},Se.hr=function(ae){var ce=this.rules.block.hr.exec(ae);if(ce)return{type:"hr",raw:ce[0]}},Se.blockquote=function(ae){var ce=this.rules.block.blockquote.exec(ae);if(ce){var G=ce[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ce[0],tokens:this.lexer.blockTokens(G,[]),text:G}}},Se.list=function(ae){var ce=this.rules.block.list.exec(ae);if(ce){var G,Q,I,B,H,V,se,de,J,pe,ge,Ne,Be=ce[1].trim(),Je=Be.length>1,Ge={type:"list",raw:"",ordered:Je,start:Je?+Be.slice(0,-1):"",loose:!1,items:[]};Be=Je?"\\d{1,9}\\"+Be.slice(-1):"\\"+Be,this.options.pedantic&&(Be=Je?Be:"[*+-]");for(var Te=new RegExp("^( {0,3}"+Be+")((?:[	 ][^\\n]*)?(?:\\n|$))");ae&&(Ne=!1,!(!(ce=Te.exec(ae))||this.rules.block.hr.test(ae)));){if(G=ce[0],ae=ae.substring(G.length),de=ce[2].split(`
`,1)[0],J=ae.split(`
`,1)[0],this.options.pedantic?(B=2,ge=de.trimLeft()):(B=ce[2].search(/[^ ]/),B=B>4?1:B,ge=de.slice(B),B+=ce[1].length),V=!1,!de&&/^ *$/.test(J)&&(G+=J+`
`,ae=ae.substring(J.length+1),Ne=!0),!Ne)for(var rt=new RegExp("^ {0,"+Math.min(3,B-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),K=new RegExp("^ {0,"+Math.min(3,B-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)");ae&&(pe=ae.split(`
`,1)[0],de=pe,this.options.pedantic&&(de=de.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(rt.test(de)||K.test(ae)));){if(de.search(/[^ ]/)>=B||!de.trim())ge+=`
`+de.slice(B);else if(!V)ge+=`
`+de;else break;!V&&!de.trim()&&(V=!0),G+=pe+`
`,ae=ae.substring(pe.length+1)}Ge.loose||(se?Ge.loose=!0:/\n *\n *$/.test(G)&&(se=!0)),this.options.gfm&&(Q=/^\[[ xX]\] /.exec(ge),Q&&(I=Q[0]!=="[ ] ",ge=ge.replace(/^\[[ xX]\] +/,""))),Ge.items.push({type:"list_item",raw:G,task:!!Q,checked:I,loose:!1,text:ge}),Ge.raw+=G}Ge.items[Ge.items.length-1].raw=G.trimRight(),Ge.items[Ge.items.length-1].text=ge.trimRight(),Ge.raw=Ge.raw.trimRight();var X=Ge.items.length;for(H=0;H<X;H++){this.lexer.state.top=!1,Ge.items[H].tokens=this.lexer.blockTokens(Ge.items[H].text,[]);var fe=Ge.items[H].tokens.filter(function(He){return He.type==="space"}),Ue=fe.every(function(He){for(var Ze=He.raw.split(""),qe=0,We=M(Ze),nt;!(nt=We()).done;){var ot=nt.value;if(ot===`
`&&(qe+=1),qe>1)return!0}return!1});!Ge.loose&&fe.length&&Ue&&(Ge.loose=!0,Ge.items[H].loose=!0)}return Ge}},Se.html=function(ae){var ce=this.rules.block.html.exec(ae);if(ce){var G={type:"html",raw:ce[0],pre:!this.options.sanitizer&&(ce[1]==="pre"||ce[1]==="script"||ce[1]==="style"),text:ce[0]};return this.options.sanitize&&(G.type="paragraph",G.text=this.options.sanitizer?this.options.sanitizer(ce[0]):f(ce[0]),G.tokens=[],this.lexer.inline(G.text,G.tokens)),G}},Se.def=function(ae){var ce=this.rules.block.def.exec(ae);if(ce){ce[3]&&(ce[3]=ce[3].substring(1,ce[3].length-1));var G=ce[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:G,raw:ce[0],href:ce[2],title:ce[3]}}},Se.table=function(ae){var ce=this.rules.block.table.exec(ae);if(ce){var G={type:"table",header:_(ce[1]).map(function(se){return{text:se}}),align:ce[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ce[3]&&ce[3].trim()?ce[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(G.header.length===G.align.length){G.raw=ce[0];var Q=G.align.length,I,B,H,V;for(I=0;I<Q;I++)/^ *-+: *$/.test(G.align[I])?G.align[I]="right":/^ *:-+: *$/.test(G.align[I])?G.align[I]="center":/^ *:-+ *$/.test(G.align[I])?G.align[I]="left":G.align[I]=null;for(Q=G.rows.length,I=0;I<Q;I++)G.rows[I]=_(G.rows[I],G.header.length).map(function(se){return{text:se}});for(Q=G.header.length,B=0;B<Q;B++)G.header[B].tokens=[],this.lexer.inline(G.header[B].text,G.header[B].tokens);for(Q=G.rows.length,B=0;B<Q;B++)for(V=G.rows[B],H=0;H<V.length;H++)V[H].tokens=[],this.lexer.inline(V[H].text,V[H].tokens);return G}}},Se.lheading=function(ae){var ce=this.rules.block.lheading.exec(ae);if(ce){var G={type:"heading",raw:ce[0],depth:ce[2].charAt(0)==="="?1:2,text:ce[1],tokens:[]};return this.lexer.inline(G.text,G.tokens),G}},Se.paragraph=function(ae){var ce=this.rules.block.paragraph.exec(ae);if(ce){var G={type:"paragraph",raw:ce[0],text:ce[1].charAt(ce[1].length-1)===`
`?ce[1].slice(0,-1):ce[1],tokens:[]};return this.lexer.inline(G.text,G.tokens),G}},Se.text=function(ae){var ce=this.rules.block.text.exec(ae);if(ce){var G={type:"text",raw:ce[0],text:ce[0],tokens:[]};return this.lexer.inline(G.text,G.tokens),G}},Se.escape=function(ae){var ce=this.rules.inline.escape.exec(ae);if(ce)return{type:"escape",raw:ce[0],text:f(ce[1])}},Se.tag=function(ae){var ce=this.rules.inline.tag.exec(ae);if(ce)return!this.lexer.state.inLink&&/^<a /i.test(ce[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ce[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ce[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ce[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ce[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ce[0]):f(ce[0]):ce[0]}},Se.link=function(ae){var ce=this.rules.inline.link.exec(ae);if(ce){var G=ce[2].trim();if(!this.options.pedantic&&/^</.test(G)){if(!/>$/.test(G))return;var Q=p(G.slice(0,-1),"\\");if((G.length-Q.length)%2==0)return}else{var I=C(ce[2],"()");if(I>-1){var B=ce[0].indexOf("!")===0?5:4,H=B+ce[1].length+I;ce[2]=ce[2].substring(0,I),ce[0]=ce[0].substring(0,H).trim(),ce[3]=""}}var V=ce[2],se="";if(this.options.pedantic){var de=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(V);de&&(V=de[1],se=de[3])}else se=ce[3]?ce[3].slice(1,-1):"";return V=V.trim(),/^</.test(V)&&(this.options.pedantic&&!/>$/.test(G)?V=V.slice(1):V=V.slice(1,-1)),L(ce,{href:V&&V.replace(this.rules.inline._escapes,"$1"),title:se&&se.replace(this.rules.inline._escapes,"$1")},ce[0],this.lexer)}},Se.reflink=function(ae,ce){var G;if((G=this.rules.inline.reflink.exec(ae))||(G=this.rules.inline.nolink.exec(ae))){var Q=(G[2]||G[1]).replace(/\s+/g," ");if(Q=ce[Q.toLowerCase()],!Q||!Q.href){var I=G[0].charAt(0);return{type:"text",raw:I,text:I}}return L(G,Q,G[0],this.lexer)}},Se.emStrong=function(ae,ce,G){G===void 0&&(G="");var Q=this.rules.inline.emStrong.lDelim.exec(ae);if(!!Q&&!(Q[3]&&G.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var I=Q[1]||Q[2]||"";if(!I||I&&(G===""||this.rules.inline.punctuation.exec(G))){var B=Q[0].length-1,H,V,se=B,de=0,J=Q[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(J.lastIndex=0,ce=ce.slice(-1*ae.length+B);(Q=J.exec(ce))!=null;)if(H=Q[1]||Q[2]||Q[3]||Q[4]||Q[5]||Q[6],!!H){if(V=H.length,Q[3]||Q[4]){se+=V;continue}else if((Q[5]||Q[6])&&B%3&&!((B+V)%3)){de+=V;continue}if(se-=V,!(se>0)){if(V=Math.min(V,V+se+de),Math.min(B,V)%2){var pe=ae.slice(1,B+Q.index+V);return{type:"em",raw:ae.slice(0,B+Q.index+V+1),text:pe,tokens:this.lexer.inlineTokens(pe,[])}}var ge=ae.slice(2,B+Q.index+V-1);return{type:"strong",raw:ae.slice(0,B+Q.index+V+1),text:ge,tokens:this.lexer.inlineTokens(ge,[])}}}}}},Se.codespan=function(ae){var ce=this.rules.inline.code.exec(ae);if(ce){var G=ce[2].replace(/\n/g," "),Q=/[^ ]/.test(G),I=/^ /.test(G)&&/ $/.test(G);return Q&&I&&(G=G.substring(1,G.length-1)),G=f(G,!0),{type:"codespan",raw:ce[0],text:G}}},Se.br=function(ae){var ce=this.rules.inline.br.exec(ae);if(ce)return{type:"br",raw:ce[0]}},Se.del=function(ae){var ce=this.rules.inline.del.exec(ae);if(ce)return{type:"del",raw:ce[0],text:ce[2],tokens:this.lexer.inlineTokens(ce[2],[])}},Se.autolink=function(ae,ce){var G=this.rules.inline.autolink.exec(ae);if(G){var Q,I;return G[2]==="@"?(Q=f(this.options.mangle?ce(G[1]):G[1]),I="mailto:"+Q):(Q=f(G[1]),I=Q),{type:"link",raw:G[0],text:Q,href:I,tokens:[{type:"text",raw:Q,text:Q}]}}},Se.url=function(ae,ce){var G;if(G=this.rules.inline.url.exec(ae)){var Q,I;if(G[2]==="@")Q=f(this.options.mangle?ce(G[0]):G[0]),I="mailto:"+Q;else{var B;do B=G[0],G[0]=this.rules.inline._backpedal.exec(G[0])[0];while(B!==G[0]);Q=f(G[0]),G[1]==="www."?I="http://"+Q:I=Q}return{type:"link",raw:G[0],text:Q,href:I,tokens:[{type:"text",raw:Q,text:Q}]}}},Se.inlineText=function(ae,ce){var G=this.rules.inline.text.exec(ae);if(G){var Q;return this.lexer.state.inRawBlock?Q=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(G[0]):f(G[0]):G[0]:Q=f(this.options.smartypants?ce(G[0]):G[0]),{type:"text",raw:G[0],text:Q}}},Ie}(),$={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:t,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};$._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,$._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,$.def=g($.def).replace("label",$._label).replace("title",$._title).getRegex(),$.bullet=/(?:[*+-]|\d{1,9}[.)])/,$.listItemStart=g(/^( *)(bull) */).replace("bull",$.bullet).getRegex(),$.list=g($.list).replace(/bull/g,$.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+$.def.source+")").getRegex(),$._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",$._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,$.html=g($.html,"i").replace("comment",$._comment).replace("tag",$._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),$.paragraph=g($._paragraph).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",$._tag).getRegex(),$.blockquote=g($.blockquote).replace("paragraph",$.paragraph).getRegex(),$.normal=c({},$),$.gfm=c({},$.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),$.gfm.table=g($.gfm.table).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",$._tag).getRegex(),$.gfm.paragraph=g($._paragraph).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",$.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",$._tag).getRegex(),$.pedantic=c({},$.normal,{html:g(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",$._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:t,paragraph:g($.normal._paragraph).replace("hr",$.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",$.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var F={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:t,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:t,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};F._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",F.punctuation=g(F.punctuation).replace(/punctuation/g,F._punctuation).getRegex(),F.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,F.escapedEmSt=/\\\*|\\_/g,F._comment=g($._comment).replace("(?:-->|$)","-->").getRegex(),F.emStrong.lDelim=g(F.emStrong.lDelim).replace(/punct/g,F._punctuation).getRegex(),F.emStrong.rDelimAst=g(F.emStrong.rDelimAst,"g").replace(/punct/g,F._punctuation).getRegex(),F.emStrong.rDelimUnd=g(F.emStrong.rDelimUnd,"g").replace(/punct/g,F._punctuation).getRegex(),F._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,F._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,F._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,F.autolink=g(F.autolink).replace("scheme",F._scheme).replace("email",F._email).getRegex(),F._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,F.tag=g(F.tag).replace("comment",F._comment).replace("attribute",F._attribute).getRegex(),F._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,F._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,F._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,F.link=g(F.link).replace("label",F._label).replace("href",F._href).replace("title",F._title).getRegex(),F.reflink=g(F.reflink).replace("label",F._label).replace("ref",$._label).getRegex(),F.nolink=g(F.nolink).replace("ref",$._label).getRegex(),F.reflinkSearch=g(F.reflinkSearch,"g").replace("reflink",F.reflink).replace("nolink",F.nolink).getRegex(),F.normal=c({},F),F.pedantic=c({},F.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:g(/^!?\[(label)\]\((.*?)\)/).replace("label",F._label).getRegex(),reflink:g(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",F._label).getRegex()}),F.gfm=c({},F.normal,{escape:g(F.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),F.gfm.url=g(F.gfm.url,"i").replace("email",F.gfm._extended_email).getRegex(),F.breaks=c({},F.gfm,{br:g(F.br).replace("{2,}","*").getRegex(),text:g(F.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function q(Ie){return Ie.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function ie(Ie){var Se="",ke,ae,ce=Ie.length;for(ke=0;ke<ce;ke++)ae=Ie.charCodeAt(ke),Math.random()>.5&&(ae="x"+ae.toString(16)),Se+="&#"+ae+";";return Se}var A=function(){function Ie(ke){this.tokens=[],this.tokens.links=Object.create(null),this.options=ke||ne.defaults,this.options.tokenizer=this.options.tokenizer||new z,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ae={block:$.normal,inline:F.normal};this.options.pedantic?(ae.block=$.pedantic,ae.inline=F.pedantic):this.options.gfm&&(ae.block=$.gfm,this.options.breaks?ae.inline=F.breaks:ae.inline=F.gfm),this.tokenizer.rules=ae}Ie.lex=function(ae,ce){var G=new Ie(ce);return G.lex(ae)},Ie.lexInline=function(ae,ce){var G=new Ie(ce);return G.inlineTokens(ae)};var Se=Ie.prototype;return Se.lex=function(ae){ae=ae.replace(/\r\n|\r/g,`
`),this.blockTokens(ae,this.tokens);for(var ce;ce=this.inlineQueue.shift();)this.inlineTokens(ce.src,ce.tokens);return this.tokens},Se.blockTokens=function(ae,ce){var G=this;ce===void 0&&(ce=[]),this.options.pedantic?ae=ae.replace(/\t/g,"    ").replace(/^ +$/gm,""):ae=ae.replace(/^( *)(\t+)/gm,function(se,de,J){return de+"    ".repeat(J.length)});for(var Q,I,B,H;ae;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(se){return(Q=se.call({lexer:G},ae,ce))?(ae=ae.substring(Q.raw.length),ce.push(Q),!0):!1}))){if(Q=this.tokenizer.space(ae)){ae=ae.substring(Q.raw.length),Q.raw.length===1&&ce.length>0?ce[ce.length-1].raw+=`
`:ce.push(Q);continue}if(Q=this.tokenizer.code(ae)){ae=ae.substring(Q.raw.length),I=ce[ce.length-1],I&&(I.type==="paragraph"||I.type==="text")?(I.raw+=`
`+Q.raw,I.text+=`
`+Q.text,this.inlineQueue[this.inlineQueue.length-1].src=I.text):ce.push(Q);continue}if(Q=this.tokenizer.fences(ae)){ae=ae.substring(Q.raw.length),ce.push(Q);continue}if(Q=this.tokenizer.heading(ae)){ae=ae.substring(Q.raw.length),ce.push(Q);continue}if(Q=this.tokenizer.hr(ae)){ae=ae.substring(Q.raw.length),ce.push(Q);continue}if(Q=this.tokenizer.blockquote(ae)){ae=ae.substring(Q.raw.length),ce.push(Q);continue}if(Q=this.tokenizer.list(ae)){ae=ae.substring(Q.raw.length),ce.push(Q);continue}if(Q=this.tokenizer.html(ae)){ae=ae.substring(Q.raw.length),ce.push(Q);continue}if(Q=this.tokenizer.def(ae)){ae=ae.substring(Q.raw.length),I=ce[ce.length-1],I&&(I.type==="paragraph"||I.type==="text")?(I.raw+=`
`+Q.raw,I.text+=`
`+Q.raw,this.inlineQueue[this.inlineQueue.length-1].src=I.text):this.tokens.links[Q.tag]||(this.tokens.links[Q.tag]={href:Q.href,title:Q.title});continue}if(Q=this.tokenizer.table(ae)){ae=ae.substring(Q.raw.length),ce.push(Q);continue}if(Q=this.tokenizer.lheading(ae)){ae=ae.substring(Q.raw.length),ce.push(Q);continue}if(B=ae,this.options.extensions&&this.options.extensions.startBlock&&function(){var se=1/0,de=ae.slice(1),J=void 0;G.options.extensions.startBlock.forEach(function(pe){J=pe.call({lexer:this},de),typeof J=="number"&&J>=0&&(se=Math.min(se,J))}),se<1/0&&se>=0&&(B=ae.substring(0,se+1))}(),this.state.top&&(Q=this.tokenizer.paragraph(B))){I=ce[ce.length-1],H&&I.type==="paragraph"?(I.raw+=`
`+Q.raw,I.text+=`
`+Q.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=I.text):ce.push(Q),H=B.length!==ae.length,ae=ae.substring(Q.raw.length);continue}if(Q=this.tokenizer.text(ae)){ae=ae.substring(Q.raw.length),I=ce[ce.length-1],I&&I.type==="text"?(I.raw+=`
`+Q.raw,I.text+=`
`+Q.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=I.text):ce.push(Q);continue}if(ae){var V="Infinite loop on byte: "+ae.charCodeAt(0);if(this.options.silent){console.error(V);break}else throw new Error(V)}}return this.state.top=!0,ce},Se.inline=function(ae,ce){this.inlineQueue.push({src:ae,tokens:ce})},Se.inlineTokens=function(ae,ce){var G=this;ce===void 0&&(ce=[]);var Q,I,B,H=ae,V,se,de;if(this.tokens.links){var J=Object.keys(this.tokens.links);if(J.length>0)for(;(V=this.tokenizer.rules.inline.reflinkSearch.exec(H))!=null;)J.includes(V[0].slice(V[0].lastIndexOf("[")+1,-1))&&(H=H.slice(0,V.index)+"["+W("a",V[0].length-2)+"]"+H.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(V=this.tokenizer.rules.inline.blockSkip.exec(H))!=null;)H=H.slice(0,V.index)+"["+W("a",V[0].length-2)+"]"+H.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(V=this.tokenizer.rules.inline.escapedEmSt.exec(H))!=null;)H=H.slice(0,V.index)+"++"+H.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ae;)if(se||(de=""),se=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ge){return(Q=ge.call({lexer:G},ae,ce))?(ae=ae.substring(Q.raw.length),ce.push(Q),!0):!1}))){if(Q=this.tokenizer.escape(ae)){ae=ae.substring(Q.raw.length),ce.push(Q);continue}if(Q=this.tokenizer.tag(ae)){ae=ae.substring(Q.raw.length),I=ce[ce.length-1],I&&Q.type==="text"&&I.type==="text"?(I.raw+=Q.raw,I.text+=Q.text):ce.push(Q);continue}if(Q=this.tokenizer.link(ae)){ae=ae.substring(Q.raw.length),ce.push(Q);continue}if(Q=this.tokenizer.reflink(ae,this.tokens.links)){ae=ae.substring(Q.raw.length),I=ce[ce.length-1],I&&Q.type==="text"&&I.type==="text"?(I.raw+=Q.raw,I.text+=Q.text):ce.push(Q);continue}if(Q=this.tokenizer.emStrong(ae,H,de)){ae=ae.substring(Q.raw.length),ce.push(Q);continue}if(Q=this.tokenizer.codespan(ae)){ae=ae.substring(Q.raw.length),ce.push(Q);continue}if(Q=this.tokenizer.br(ae)){ae=ae.substring(Q.raw.length),ce.push(Q);continue}if(Q=this.tokenizer.del(ae)){ae=ae.substring(Q.raw.length),ce.push(Q);continue}if(Q=this.tokenizer.autolink(ae,ie)){ae=ae.substring(Q.raw.length),ce.push(Q);continue}if(!this.state.inLink&&(Q=this.tokenizer.url(ae,ie))){ae=ae.substring(Q.raw.length),ce.push(Q);continue}if(B=ae,this.options.extensions&&this.options.extensions.startInline&&function(){var ge=1/0,Ne=ae.slice(1),Be=void 0;G.options.extensions.startInline.forEach(function(Je){Be=Je.call({lexer:this},Ne),typeof Be=="number"&&Be>=0&&(ge=Math.min(ge,Be))}),ge<1/0&&ge>=0&&(B=ae.substring(0,ge+1))}(),Q=this.tokenizer.inlineText(B,q)){ae=ae.substring(Q.raw.length),Q.raw.slice(-1)!=="_"&&(de=Q.raw.slice(-1)),se=!0,I=ce[ce.length-1],I&&I.type==="text"?(I.raw+=Q.raw,I.text+=Q.text):ce.push(Q);continue}if(ae){var pe="Infinite loop on byte: "+ae.charCodeAt(0);if(this.options.silent){console.error(pe);break}else throw new Error(pe)}}return ce},a(Ie,null,[{key:"rules",get:function(){return{block:$,inline:F}}}]),Ie}(),Z=function(){function Ie(ke){this.options=ke||ne.defaults}var Se=Ie.prototype;return Se.code=function(ae,ce,G){var Q=(ce||"").match(/\S*/)[0];if(this.options.highlight){var I=this.options.highlight(ae,Q);I!=null&&I!==ae&&(G=!0,ae=I)}return ae=ae.replace(/\n$/,"")+`
`,Q?'<pre><code class="'+this.options.langPrefix+f(Q,!0)+'">'+(G?ae:f(ae,!0))+`</code></pre>
`:"<pre><code>"+(G?ae:f(ae,!0))+`</code></pre>
`},Se.blockquote=function(ae){return`<blockquote>
`+ae+`</blockquote>
`},Se.html=function(ae){return ae},Se.heading=function(ae,ce,G,Q){if(this.options.headerIds){var I=this.options.headerPrefix+Q.slug(G);return"<h"+ce+' id="'+I+'">'+ae+"</h"+ce+`>
`}return"<h"+ce+">"+ae+"</h"+ce+`>
`},Se.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Se.list=function(ae,ce,G){var Q=ce?"ol":"ul",I=ce&&G!==1?' start="'+G+'"':"";return"<"+Q+I+`>
`+ae+"</"+Q+`>
`},Se.listitem=function(ae){return"<li>"+ae+`</li>
`},Se.checkbox=function(ae){return"<input "+(ae?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Se.paragraph=function(ae){return"<p>"+ae+`</p>
`},Se.table=function(ae,ce){return ce&&(ce="<tbody>"+ce+"</tbody>"),`<table>
<thead>
`+ae+`</thead>
`+ce+`</table>
`},Se.tablerow=function(ae){return`<tr>
`+ae+`</tr>
`},Se.tablecell=function(ae,ce){var G=ce.header?"th":"td",Q=ce.align?"<"+G+' align="'+ce.align+'">':"<"+G+">";return Q+ae+("</"+G+`>
`)},Se.strong=function(ae){return"<strong>"+ae+"</strong>"},Se.em=function(ae){return"<em>"+ae+"</em>"},Se.codespan=function(ae){return"<code>"+ae+"</code>"},Se.br=function(){return this.options.xhtml?"<br/>":"<br>"},Se.del=function(ae){return"<del>"+ae+"</del>"},Se.link=function(ae,ce,G){if(ae=w(this.options.sanitize,this.options.baseUrl,ae),ae===null)return G;var Q='<a href="'+f(ae)+'"';return ce&&(Q+=' title="'+ce+'"'),Q+=">"+G+"</a>",Q},Se.image=function(ae,ce,G){if(ae=w(this.options.sanitize,this.options.baseUrl,ae),ae===null)return G;var Q='<img src="'+ae+'" alt="'+G+'"';return ce&&(Q+=' title="'+ce+'"'),Q+=this.options.xhtml?"/>":">",Q},Se.text=function(ae){return ae},Ie}(),le=function(){function Ie(){}var Se=Ie.prototype;return Se.strong=function(ae){return ae},Se.em=function(ae){return ae},Se.codespan=function(ae){return ae},Se.del=function(ae){return ae},Se.html=function(ae){return ae},Se.text=function(ae){return ae},Se.link=function(ae,ce,G){return""+G},Se.image=function(ae,ce,G){return""+G},Se.br=function(){return""},Ie}(),oe=function(){function Ie(){this.seen={}}var Se=Ie.prototype;return Se.serialize=function(ae){return ae.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Se.getNextSafeSlug=function(ae,ce){var G=ae,Q=0;if(this.seen.hasOwnProperty(G)){Q=this.seen[ae];do Q++,G=ae+"-"+Q;while(this.seen.hasOwnProperty(G))}return ce||(this.seen[ae]=Q,this.seen[G]=0),G},Se.slug=function(ae,ce){ce===void 0&&(ce={});var G=this.serialize(ae);return this.getNextSafeSlug(G,ce.dryrun)},Ie}(),ue=function(){function Ie(ke){this.options=ke||ne.defaults,this.options.renderer=this.options.renderer||new Z,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new le,this.slugger=new oe}Ie.parse=function(ae,ce){var G=new Ie(ce);return G.parse(ae)},Ie.parseInline=function(ae,ce){var G=new Ie(ce);return G.parseInline(ae)};var Se=Ie.prototype;return Se.parse=function(ae,ce){ce===void 0&&(ce=!0);var G="",Q,I,B,H,V,se,de,J,pe,ge,Ne,Be,Je,Ge,Te,rt,K,X,fe,Ue=ae.length;for(Q=0;Q<Ue;Q++){if(ge=ae[Q],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ge.type]&&(fe=this.options.extensions.renderers[ge.type].call({parser:this},ge),fe!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ge.type))){G+=fe||"";continue}switch(ge.type){case"space":continue;case"hr":{G+=this.renderer.hr();continue}case"heading":{G+=this.renderer.heading(this.parseInline(ge.tokens),ge.depth,d(this.parseInline(ge.tokens,this.textRenderer)),this.slugger);continue}case"code":{G+=this.renderer.code(ge.text,ge.lang,ge.escaped);continue}case"table":{for(J="",de="",H=ge.header.length,I=0;I<H;I++)de+=this.renderer.tablecell(this.parseInline(ge.header[I].tokens),{header:!0,align:ge.align[I]});for(J+=this.renderer.tablerow(de),pe="",H=ge.rows.length,I=0;I<H;I++){for(se=ge.rows[I],de="",V=se.length,B=0;B<V;B++)de+=this.renderer.tablecell(this.parseInline(se[B].tokens),{header:!1,align:ge.align[B]});pe+=this.renderer.tablerow(de)}G+=this.renderer.table(J,pe);continue}case"blockquote":{pe=this.parse(ge.tokens),G+=this.renderer.blockquote(pe);continue}case"list":{for(Ne=ge.ordered,Be=ge.start,Je=ge.loose,H=ge.items.length,pe="",I=0;I<H;I++)Te=ge.items[I],rt=Te.checked,K=Te.task,Ge="",Te.task&&(X=this.renderer.checkbox(rt),Je?Te.tokens.length>0&&Te.tokens[0].type==="paragraph"?(Te.tokens[0].text=X+" "+Te.tokens[0].text,Te.tokens[0].tokens&&Te.tokens[0].tokens.length>0&&Te.tokens[0].tokens[0].type==="text"&&(Te.tokens[0].tokens[0].text=X+" "+Te.tokens[0].tokens[0].text)):Te.tokens.unshift({type:"text",text:X}):Ge+=X),Ge+=this.parse(Te.tokens,Je),pe+=this.renderer.listitem(Ge,K,rt);G+=this.renderer.list(pe,Ne,Be);continue}case"html":{G+=this.renderer.html(ge.text);continue}case"paragraph":{G+=this.renderer.paragraph(this.parseInline(ge.tokens));continue}case"text":{for(pe=ge.tokens?this.parseInline(ge.tokens):ge.text;Q+1<Ue&&ae[Q+1].type==="text";)ge=ae[++Q],pe+=`
`+(ge.tokens?this.parseInline(ge.tokens):ge.text);G+=ce?this.renderer.paragraph(pe):pe;continue}default:{var He='Token with "'+ge.type+'" type was not found.';if(this.options.silent){console.error(He);return}else throw new Error(He)}}}return G},Se.parseInline=function(ae,ce){ce=ce||this.renderer;var G="",Q,I,B,H=ae.length;for(Q=0;Q<H;Q++){if(I=ae[Q],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[I.type]&&(B=this.options.extensions.renderers[I.type].call({parser:this},I),B!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(I.type))){G+=B||"";continue}switch(I.type){case"escape":{G+=ce.text(I.text);break}case"html":{G+=ce.html(I.text);break}case"link":{G+=ce.link(I.href,I.title,this.parseInline(I.tokens,ce));break}case"image":{G+=ce.image(I.href,I.title,I.text);break}case"strong":{G+=ce.strong(this.parseInline(I.tokens,ce));break}case"em":{G+=ce.em(this.parseInline(I.tokens,ce));break}case"codespan":{G+=ce.codespan(I.text);break}case"br":{G+=ce.br();break}case"del":{G+=ce.del(this.parseInline(I.tokens,ce));break}case"text":{G+=ce.text(I.text);break}default:{var V='Token with "'+I.type+'" type was not found.';if(this.options.silent){console.error(V);return}else throw new Error(V)}}}return G},Ie}();function te(Ie,Se,ke){if(typeof Ie=="undefined"||Ie===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Ie!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ie)+", string expected");if(typeof Se=="function"&&(ke=Se,Se=null),Se=c({},te.defaults,Se||{}),U(Se),ke){var ae=Se.highlight,ce;try{ce=A.lex(Ie,Se)}catch(B){return ke(B)}var G=function(H){var V;if(!H)try{Se.walkTokens&&te.walkTokens(ce,Se.walkTokens),V=ue.parse(ce,Se)}catch(se){H=se}return Se.highlight=ae,H?ke(H):ke(null,V)};if(!ae||ae.length<3||(delete Se.highlight,!ce.length))return G();var Q=0;te.walkTokens(ce,function(B){B.type==="code"&&(Q++,setTimeout(function(){ae(B.text,B.lang,function(H,V){if(H)return G(H);V!=null&&V!==B.text&&(B.text=V,B.escaped=!0),Q--,Q===0&&G()})},0))}),Q===0&&G();return}try{var I=A.lex(Ie,Se);return Se.walkTokens&&te.walkTokens(I,Se.walkTokens),ue.parse(I,Se)}catch(B){if(B.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+f(B.message+"",!0)+"</pre>";throw B}}te.options=te.setOptions=function(Ie){return c(te.defaults,Ie),P(te.defaults),te},te.getDefaults=D,te.defaults=ne.defaults,te.use=function(){for(var Ie=arguments.length,Se=new Array(Ie),ke=0;ke<Ie;ke++)Se[ke]=arguments[ke];var ae=c.apply(void 0,[{}].concat(Se)),ce=te.defaults.extensions||{renderers:{},childTokens:{}},G;Se.forEach(function(Q){if(Q.extensions&&(G=!0,Q.extensions.forEach(function(B){if(!B.name)throw new Error("extension name required");if(B.renderer){var H=ce.renderers?ce.renderers[B.name]:null;H?ce.renderers[B.name]=function(){for(var V=arguments.length,se=new Array(V),de=0;de<V;de++)se[de]=arguments[de];var J=B.renderer.apply(this,se);return J===!1&&(J=H.apply(this,se)),J}:ce.renderers[B.name]=B.renderer}if(B.tokenizer){if(!B.level||B.level!=="block"&&B.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ce[B.level]?ce[B.level].unshift(B.tokenizer):ce[B.level]=[B.tokenizer],B.start&&(B.level==="block"?ce.startBlock?ce.startBlock.push(B.start):ce.startBlock=[B.start]:B.level==="inline"&&(ce.startInline?ce.startInline.push(B.start):ce.startInline=[B.start]))}B.childTokens&&(ce.childTokens[B.name]=B.childTokens)})),Q.renderer&&function(){var B=te.defaults.renderer||new Z,H=function(de){var J=B[de];B[de]=function(){for(var pe=arguments.length,ge=new Array(pe),Ne=0;Ne<pe;Ne++)ge[Ne]=arguments[Ne];var Be=Q.renderer[de].apply(B,ge);return Be===!1&&(Be=J.apply(B,ge)),Be}};for(var V in Q.renderer)H(V);ae.renderer=B}(),Q.tokenizer&&function(){var B=te.defaults.tokenizer||new z,H=function(de){var J=B[de];B[de]=function(){for(var pe=arguments.length,ge=new Array(pe),Ne=0;Ne<pe;Ne++)ge[Ne]=arguments[Ne];var Be=Q.tokenizer[de].apply(B,ge);return Be===!1&&(Be=J.apply(B,ge)),Be}};for(var V in Q.tokenizer)H(V);ae.tokenizer=B}(),Q.walkTokens){var I=te.defaults.walkTokens;ae.walkTokens=function(B){Q.walkTokens.call(this,B),I&&I.call(this,B)}}G&&(ae.extensions=ce),te.setOptions(ae)})},te.walkTokens=function(Ie,Se){for(var ke=function(){var Q=ce.value;switch(Se.call(te,Q),Q.type){case"table":{for(var I=M(Q.header),B;!(B=I()).done;){var H=B.value;te.walkTokens(H.tokens,Se)}for(var V=M(Q.rows),se;!(se=V()).done;)for(var de=se.value,J=M(de),pe;!(pe=J()).done;){var ge=pe.value;te.walkTokens(ge.tokens,Se)}break}case"list":{te.walkTokens(Q.items,Se);break}default:te.defaults.extensions&&te.defaults.extensions.childTokens&&te.defaults.extensions.childTokens[Q.type]?te.defaults.extensions.childTokens[Q.type].forEach(function(Ne){te.walkTokens(Q[Ne],Se)}):Q.tokens&&te.walkTokens(Q.tokens,Se)}},ae=M(Ie),ce;!(ce=ae()).done;)ke()},te.parseInline=function(Ie,Se){if(typeof Ie=="undefined"||Ie===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Ie!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Ie)+", string expected");Se=c({},te.defaults,Se||{}),U(Se);try{var ke=A.lexInline(Ie,Se);return Se.walkTokens&&te.walkTokens(ke,Se.walkTokens),ue.parseInline(ke,Se)}catch(ae){if(ae.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+f(ae.message+"",!0)+"</pre>";throw ae}},te.Parser=ue,te.parser=ue.parse,te.Renderer=Z,te.TextRenderer=le,te.Lexer=A,te.lexer=A.lex,te.Tokenizer=z,te.Slugger=oe,te.parse=te;var Ee=te.options,be=te.setOptions,ee=te.use,ve=te.walkTokens,Ae=te.parseInline,Fe=te,$e=ue.parse,Qe=A.lex;ne.Lexer=A,ne.Parser=ue,ne.Renderer=Z,ne.Slugger=oe,ne.TextRenderer=le,ne.Tokenizer=z,ne.getDefaults=D,ne.lexer=Qe,ne.marked=te,ne.options=Ee,ne.parse=Fe,ne.parseInline=Ae,ne.parser=$e,ne.setOptions=be,ne.use=ee,ne.walkTokens=ve,Object.defineProperty(ne,"__esModule",{value:!0})}),define(ye[107],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function a(P,E,T){return Math.min(Math.max(P,E),T)}e.clamp=a;function v(P,E){return(E+P%E)%E}e.rot=v;class b{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=b;class M{constructor(){this._n=1,this._val=0}update(E){return this._val=this._val+(E-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=M;class D{constructor(E){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(E),this._values.fill(0,0,E)}update(E){const T=this._values[this._index];return this._values[this._index]=E,this._index=(this._index+1)%this._values.length,this._sum-=T,this._sum+=E,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=D}),function(){function ne(b){const M=[];typeof b=="number"&&M.push("code/timeOrigin",b);function D(E){M.push(E,Date.now())}function P(){const E=[];for(let T=0;T<M.length;T+=2)E.push({name:M[T],startTime:M[T+1]});return E}return{mark:D,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ne():{mark(b){performance.mark(b)},getMarks(){let b=performance.timeOrigin;typeof b!="number"&&(b=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(b)}];for(const D of performance.getEntriesByType("mark"))M.push({name:D.name,startTime:Math.round(b+D.startTime)});return M}};if(typeof process=="object"){const b=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return ne(b)}else return console.trace("perf-util loaded in UNKNOWN environment"),ne()}function a(b){return b.MonacoPerformanceMarks||(b.MonacoPerformanceMarks=e()),b.MonacoPerformanceMarks}var v;typeof global=="object"?v=global:typeof self=="object"?v=self:v={},typeof define=="function"?define("vs/base/common/performance",[],function(){return a(v)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=a(v):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),v.perf=a(v))}(),function(ne,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var a=e();for(var v in a)(typeof exports=="object"?exports:ne)[v]=a[v]}}(typeof self!="undefined"?self:this,function(){return function(ne){var e={};function a(v){if(e[v])return e[v].exports;var b=e[v]={i:v,l:!1,exports:{}};return ne[v].call(b.exports,b,b.exports,a),b.l=!0,b.exports}return a.m=ne,a.c=e,a.d=function(v,b,M){a.o(v,b)||Object.defineProperty(v,b,{enumerable:!0,get:M})},a.r=function(v){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(v,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(v,"__esModule",{value:!0})},a.t=function(v,b){if(1&b&&(v=a(v)),8&b||4&b&&typeof v=="object"&&v&&v.__esModule)return v;var M=Object.create(null);if(a.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:v}),2&b&&typeof v!="string")for(var D in v)a.d(M,D,function(P){return v[P]}.bind(null,D));return M},a.n=function(v){var b=v&&v.__esModule?function(){return v.default}:function(){return v};return a.d(b,"a",b),b},a.o=function(v,b){return Object.prototype.hasOwnProperty.call(v,b)},a.p="",a(a.s=0)}([function(ne,e,a){(function(v){var b;e=ne.exports=ee,b=typeof v=="object"&&v.env&&v.env.NODE_DEBUG&&/\bsemver\b/i.test(v.env.NODE_DEBUG)?function(){var J=Array.prototype.slice.call(arguments,0);J.unshift("SEMVER"),console.log.apply(console,J)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],E=e.src=[],T=0,O=T++;E[O]="0|[1-9]\\d*";var y=T++;E[y]="[0-9]+";var m=T++;E[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var k=T++;E[k]="("+E[O]+")\\.("+E[O]+")\\.("+E[O]+")";var f=T++;E[f]="("+E[y]+")\\.("+E[y]+")\\.("+E[y]+")";var h=T++;E[h]="(?:"+E[O]+"|"+E[m]+")";var d=T++;E[d]="(?:"+E[y]+"|"+E[m]+")";var o=T++;E[o]="(?:-("+E[h]+"(?:\\."+E[h]+")*))";var g=T++;E[g]="(?:-?("+E[d]+"(?:\\."+E[d]+")*))";var R=T++;E[R]="[0-9A-Za-z-]+";var l=T++;E[l]="(?:\\+("+E[R]+"(?:\\."+E[R]+")*))";var w=T++,s="v?"+E[k]+E[o]+"?"+E[l]+"?";E[w]="^"+s+"$";var u="[v=\\s]*"+E[f]+E[g]+"?"+E[l]+"?",n=T++;E[n]="^"+u+"$";var i=T++;E[i]="((?:<|>)?=?)";var r=T++;E[r]=E[y]+"|x|X|\\*";var t=T++;E[t]=E[O]+"|x|X|\\*";var c=T++;E[c]="[v=\\s]*("+E[t]+")(?:\\.("+E[t]+")(?:\\.("+E[t]+")(?:"+E[o]+")?"+E[l]+"?)?)?";var _=T++;E[_]="[v=\\s]*("+E[r]+")(?:\\.("+E[r]+")(?:\\.("+E[r]+")(?:"+E[g]+")?"+E[l]+"?)?)?";var p=T++;E[p]="^"+E[i]+"\\s*"+E[c]+"$";var C=T++;E[C]="^"+E[i]+"\\s*"+E[_]+"$";var U=T++;E[U]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var W=T++;E[W]="(?:~>?)";var L=T++;E[L]="(\\s*)"+E[W]+"\\s+",P[L]=new RegExp(E[L],"g");var S=T++;E[S]="^"+E[W]+E[c]+"$";var z=T++;E[z]="^"+E[W]+E[_]+"$";var $=T++;E[$]="(?:\\^)";var F=T++;E[F]="(\\s*)"+E[$]+"\\s+",P[F]=new RegExp(E[F],"g");var q=T++;E[q]="^"+E[$]+E[c]+"$";var ie=T++;E[ie]="^"+E[$]+E[_]+"$";var A=T++;E[A]="^"+E[i]+"\\s*("+u+")$|^$";var Z=T++;E[Z]="^"+E[i]+"\\s*("+s+")$|^$";var le=T++;E[le]="(\\s*)"+E[i]+"\\s*("+u+"|"+E[c]+")",P[le]=new RegExp(E[le],"g");var oe=T++;E[oe]="^\\s*("+E[c]+")\\s+-\\s+("+E[c]+")\\s*$";var ue=T++;E[ue]="^\\s*("+E[_]+")\\s+-\\s+("+E[_]+")\\s*$";var te=T++;E[te]="(<|>)?=?\\s*\\*";for(var Ee=0;Ee<35;Ee++)b(Ee,E[Ee]),P[Ee]||(P[Ee]=new RegExp(E[Ee]));function be(J,pe){if(J instanceof ee)return J;if(typeof J!="string"||J.length>M||!(pe?P[n]:P[w]).test(J))return null;try{return new ee(J,pe)}catch{return null}}function ee(J,pe){if(J instanceof ee){if(J.loose===pe)return J;J=J.version}else if(typeof J!="string")throw new TypeError("Invalid Version: "+J);if(J.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof ee))return new ee(J,pe);b("SemVer",J,pe),this.loose=pe;var ge=J.trim().match(pe?P[n]:P[w]);if(!ge)throw new TypeError("Invalid Version: "+J);if(this.raw=J,this.major=+ge[1],this.minor=+ge[2],this.patch=+ge[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");ge[4]?this.prerelease=ge[4].split(".").map(function(Ne){if(/^[0-9]+$/.test(Ne)){var Be=+Ne;if(Be>=0&&Be<D)return Be}return Ne}):this.prerelease=[],this.build=ge[5]?ge[5].split("."):[],this.format()}e.parse=be,e.valid=function(J,pe){var ge=be(J,pe);return ge?ge.version:null},e.clean=function(J,pe){var ge=be(J.trim().replace(/^[=v]+/,""),pe);return ge?ge.version:null},e.SemVer=ee,ee.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ee.prototype.toString=function(){return this.version},ee.prototype.compare=function(J){return b("SemVer.compare",this.version,this.loose,J),J instanceof ee||(J=new ee(J,this.loose)),this.compareMain(J)||this.comparePre(J)},ee.prototype.compareMain=function(J){return J instanceof ee||(J=new ee(J,this.loose)),Ae(this.major,J.major)||Ae(this.minor,J.minor)||Ae(this.patch,J.patch)},ee.prototype.comparePre=function(J){if(J instanceof ee||(J=new ee(J,this.loose)),this.prerelease.length&&!J.prerelease.length)return-1;if(!this.prerelease.length&&J.prerelease.length)return 1;if(!this.prerelease.length&&!J.prerelease.length)return 0;var pe=0;do{var ge=this.prerelease[pe],Ne=J.prerelease[pe];if(b("prerelease compare",pe,ge,Ne),ge===void 0&&Ne===void 0)return 0;if(Ne===void 0)return 1;if(ge===void 0)return-1;if(ge!==Ne)return Ae(ge,Ne)}while(++pe)},ee.prototype.inc=function(J,pe){switch(J){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",pe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",pe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",pe),this.inc("pre",pe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",pe),this.inc("pre",pe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ge=this.prerelease.length;--ge>=0;)typeof this.prerelease[ge]=="number"&&(this.prerelease[ge]++,ge=-2);ge===-1&&this.prerelease.push(0)}pe&&(this.prerelease[0]===pe?isNaN(this.prerelease[1])&&(this.prerelease=[pe,0]):this.prerelease=[pe,0]);break;default:throw new Error("invalid increment argument: "+J)}return this.format(),this.raw=this.version,this},e.inc=function(J,pe,ge,Ne){typeof ge=="string"&&(Ne=ge,ge=void 0);try{return new ee(J,ge).inc(pe,Ne).version}catch{return null}},e.diff=function(J,pe){if(Ie(J,pe))return null;var ge=be(J),Ne=be(pe);if(ge.prerelease.length||Ne.prerelease.length){for(var Be in ge)if((Be==="major"||Be==="minor"||Be==="patch")&&ge[Be]!==Ne[Be])return"pre"+Be;return"prerelease"}for(var Be in ge)if((Be==="major"||Be==="minor"||Be==="patch")&&ge[Be]!==Ne[Be])return Be},e.compareIdentifiers=Ae;var ve=/^[0-9]+$/;function Ae(J,pe){var ge=ve.test(J),Ne=ve.test(pe);return ge&&Ne&&(J=+J,pe=+pe),ge&&!Ne?-1:Ne&&!ge?1:J<pe?-1:J>pe?1:0}function Fe(J,pe,ge){return new ee(J,ge).compare(new ee(pe,ge))}function $e(J,pe,ge){return Fe(J,pe,ge)>0}function Qe(J,pe,ge){return Fe(J,pe,ge)<0}function Ie(J,pe,ge){return Fe(J,pe,ge)===0}function Se(J,pe,ge){return Fe(J,pe,ge)!==0}function ke(J,pe,ge){return Fe(J,pe,ge)>=0}function ae(J,pe,ge){return Fe(J,pe,ge)<=0}function ce(J,pe,ge,Ne){var Be;switch(pe){case"===":typeof J=="object"&&(J=J.version),typeof ge=="object"&&(ge=ge.version),Be=J===ge;break;case"!==":typeof J=="object"&&(J=J.version),typeof ge=="object"&&(ge=ge.version),Be=J!==ge;break;case"":case"=":case"==":Be=Ie(J,ge,Ne);break;case"!=":Be=Se(J,ge,Ne);break;case">":Be=$e(J,ge,Ne);break;case">=":Be=ke(J,ge,Ne);break;case"<":Be=Qe(J,ge,Ne);break;case"<=":Be=ae(J,ge,Ne);break;default:throw new TypeError("Invalid operator: "+pe)}return Be}function G(J,pe){if(J instanceof G){if(J.loose===pe)return J;J=J.value}if(!(this instanceof G))return new G(J,pe);b("comparator",J,pe),this.loose=pe,this.parse(J),this.semver===Q?this.value="":this.value=this.operator+this.semver.version,b("comp",this)}e.rcompareIdentifiers=function(J,pe){return Ae(pe,J)},e.major=function(J,pe){return new ee(J,pe).major},e.minor=function(J,pe){return new ee(J,pe).minor},e.patch=function(J,pe){return new ee(J,pe).patch},e.compare=Fe,e.compareLoose=function(J,pe){return Fe(J,pe,!0)},e.rcompare=function(J,pe,ge){return Fe(pe,J,ge)},e.sort=function(J,pe){return J.sort(function(ge,Ne){return e.compare(ge,Ne,pe)})},e.rsort=function(J,pe){return J.sort(function(ge,Ne){return e.rcompare(ge,Ne,pe)})},e.gt=$e,e.lt=Qe,e.eq=Ie,e.neq=Se,e.gte=ke,e.lte=ae,e.cmp=ce,e.Comparator=G;var Q={};function I(J,pe){if(J instanceof I)return J.loose===pe?J:new I(J.raw,pe);if(J instanceof G)return new I(J.value,pe);if(!(this instanceof I))return new I(J,pe);if(this.loose=pe,this.raw=J,this.set=J.split(/\s*\|\|\s*/).map(function(ge){return this.parseRange(ge.trim())},this).filter(function(ge){return ge.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+J);this.format()}function B(J){return!J||J.toLowerCase()==="x"||J==="*"}function H(J,pe,ge,Ne,Be,Je,Ge,Te,rt,K,X,fe,Ue){return((pe=B(ge)?"":B(Ne)?">="+ge+".0.0":B(Be)?">="+ge+"."+Ne+".0":">="+pe)+" "+(Te=B(rt)?"":B(K)?"<"+(+rt+1)+".0.0":B(X)?"<"+rt+"."+(+K+1)+".0":fe?"<="+rt+"."+K+"."+X+"-"+fe:"<="+Te)).trim()}function V(J,pe){for(var ge=0;ge<J.length;ge++)if(!J[ge].test(pe))return!1;if(pe.prerelease.length){for(ge=0;ge<J.length;ge++)if(b(J[ge].semver),J[ge].semver!==Q&&J[ge].semver.prerelease.length>0){var Ne=J[ge].semver;if(Ne.major===pe.major&&Ne.minor===pe.minor&&Ne.patch===pe.patch)return!0}return!1}return!0}function se(J,pe,ge){try{pe=new I(pe,ge)}catch{return!1}return pe.test(J)}function de(J,pe,ge,Ne){var Be,Je,Ge,Te,rt;switch(J=new ee(J,Ne),pe=new I(pe,Ne),ge){case">":Be=$e,Je=ae,Ge=Qe,Te=">",rt=">=";break;case"<":Be=Qe,Je=ke,Ge=$e,Te="<",rt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(se(J,pe,Ne))return!1;for(var K=0;K<pe.set.length;++K){var X=pe.set[K],fe=null,Ue=null;if(X.forEach(function(He){He.semver===Q&&(He=new G(">=0.0.0")),fe=fe||He,Ue=Ue||He,Be(He.semver,fe.semver,Ne)?fe=He:Ge(He.semver,Ue.semver,Ne)&&(Ue=He)}),fe.operator===Te||fe.operator===rt||(!Ue.operator||Ue.operator===Te)&&Je(J,Ue.semver)||Ue.operator===rt&&Ge(J,Ue.semver))return!1}return!0}G.prototype.parse=function(J){var pe=this.loose?P[A]:P[Z],ge=J.match(pe);if(!ge)throw new TypeError("Invalid comparator: "+J);this.operator=ge[1],this.operator==="="&&(this.operator=""),ge[2]?this.semver=new ee(ge[2],this.loose):this.semver=Q},G.prototype.toString=function(){return this.value},G.prototype.test=function(J){return b("Comparator.test",J,this.loose),this.semver===Q||(typeof J=="string"&&(J=new ee(J,this.loose)),ce(J,this.operator,this.semver,this.loose))},G.prototype.intersects=function(J,pe){if(!(J instanceof G))throw new TypeError("a Comparator is required");var ge;if(this.operator==="")return ge=new I(J.value,pe),se(this.value,ge,pe);if(J.operator==="")return ge=new I(this.value,pe),se(J.semver,ge,pe);var Ne=!(this.operator!==">="&&this.operator!==">"||J.operator!==">="&&J.operator!==">"),Be=!(this.operator!=="<="&&this.operator!=="<"||J.operator!=="<="&&J.operator!=="<"),Je=this.semver.version===J.semver.version,Ge=!(this.operator!==">="&&this.operator!=="<="||J.operator!==">="&&J.operator!=="<="),Te=ce(this.semver,"<",J.semver,pe)&&(this.operator===">="||this.operator===">")&&(J.operator==="<="||J.operator==="<"),rt=ce(this.semver,">",J.semver,pe)&&(this.operator==="<="||this.operator==="<")&&(J.operator===">="||J.operator===">");return Ne||Be||Je&&Ge||Te||rt},e.Range=I,I.prototype.format=function(){return this.range=this.set.map(function(J){return J.join(" ").trim()}).join("||").trim(),this.range},I.prototype.toString=function(){return this.range},I.prototype.parseRange=function(J){var pe=this.loose;J=J.trim(),b("range",J,pe);var ge=pe?P[ue]:P[oe];J=J.replace(ge,H),b("hyphen replace",J),J=J.replace(P[le],"$1$2$3"),b("comparator trim",J,P[le]),J=(J=(J=J.replace(P[L],"$1~")).replace(P[F],"$1^")).split(/\s+/).join(" ");var Ne=pe?P[A]:P[Z],Be=J.split(" ").map(function(Je){return function(Ge,Te){return b("comp",Ge),Ge=function(rt,K){return rt.trim().split(/\s+/).map(function(X){return function(fe,Ue){b("caret",fe,Ue);var He=Ue?P[ie]:P[q];return fe.replace(He,function(Ze,qe,We,nt,ot){var ht;return b("caret",fe,Ze,qe,We,nt,ot),B(qe)?ht="":B(We)?ht=">="+qe+".0.0 <"+(+qe+1)+".0.0":B(nt)?ht=qe==="0"?">="+qe+"."+We+".0 <"+qe+"."+(+We+1)+".0":">="+qe+"."+We+".0 <"+(+qe+1)+".0.0":ot?(b("replaceCaret pr",ot),ot.charAt(0)!=="-"&&(ot="-"+ot),ht=qe==="0"?We==="0"?">="+qe+"."+We+"."+nt+ot+" <"+qe+"."+We+"."+(+nt+1):">="+qe+"."+We+"."+nt+ot+" <"+qe+"."+(+We+1)+".0":">="+qe+"."+We+"."+nt+ot+" <"+(+qe+1)+".0.0"):(b("no pr"),ht=qe==="0"?We==="0"?">="+qe+"."+We+"."+nt+" <"+qe+"."+We+"."+(+nt+1):">="+qe+"."+We+"."+nt+" <"+qe+"."+(+We+1)+".0":">="+qe+"."+We+"."+nt+" <"+(+qe+1)+".0.0"),b("caret return",ht),ht})}(X,K)}).join(" ")}(Ge,Te),b("caret",Ge),Ge=function(rt,K){return rt.trim().split(/\s+/).map(function(X){return function(fe,Ue){var He=Ue?P[z]:P[S];return fe.replace(He,function(Ze,qe,We,nt,ot){var ht;return b("tilde",fe,Ze,qe,We,nt,ot),B(qe)?ht="":B(We)?ht=">="+qe+".0.0 <"+(+qe+1)+".0.0":B(nt)?ht=">="+qe+"."+We+".0 <"+qe+"."+(+We+1)+".0":ot?(b("replaceTilde pr",ot),ot.charAt(0)!=="-"&&(ot="-"+ot),ht=">="+qe+"."+We+"."+nt+ot+" <"+qe+"."+(+We+1)+".0"):ht=">="+qe+"."+We+"."+nt+" <"+qe+"."+(+We+1)+".0",b("tilde return",ht),ht})}(X,K)}).join(" ")}(Ge,Te),b("tildes",Ge),Ge=function(rt,K){return b("replaceXRanges",rt,K),rt.split(/\s+/).map(function(X){return function(fe,Ue){fe=fe.trim();var He=Ue?P[C]:P[p];return fe.replace(He,function(Ze,qe,We,nt,ot,ht){b("xRange",fe,Ze,qe,We,nt,ot,ht);var kt=B(We),it=kt||B(nt),dt=it||B(ot);return qe==="="&&dt&&(qe=""),kt?Ze=qe===">"||qe==="<"?"<0.0.0":"*":qe&&dt?(it&&(nt=0),dt&&(ot=0),qe===">"?(qe=">=",it?(We=+We+1,nt=0,ot=0):dt&&(nt=+nt+1,ot=0)):qe==="<="&&(qe="<",it?We=+We+1:nt=+nt+1),Ze=qe+We+"."+nt+"."+ot):it?Ze=">="+We+".0.0 <"+(+We+1)+".0.0":dt&&(Ze=">="+We+"."+nt+".0 <"+We+"."+(+nt+1)+".0"),b("xRange return",Ze),Ze})}(X,K)}).join(" ")}(Ge,Te),b("xrange",Ge),Ge=function(rt,K){return b("replaceStars",rt,K),rt.trim().replace(P[te],"")}(Ge,Te),b("stars",Ge),Ge}(Je,pe)}).join(" ").split(/\s+/);return this.loose&&(Be=Be.filter(function(Je){return!!Je.match(Ne)})),Be=Be.map(function(Je){return new G(Je,pe)})},I.prototype.intersects=function(J,pe){if(!(J instanceof I))throw new TypeError("a Range is required");return this.set.some(function(ge){return ge.every(function(Ne){return J.set.some(function(Be){return Be.every(function(Je){return Ne.intersects(Je,pe)})})})})},e.toComparators=function(J,pe){return new I(J,pe).set.map(function(ge){return ge.map(function(Ne){return Ne.value}).join(" ").trim().split(" ")})},I.prototype.test=function(J){if(!J)return!1;typeof J=="string"&&(J=new ee(J,this.loose));for(var pe=0;pe<this.set.length;pe++)if(V(this.set[pe],J))return!0;return!1},e.satisfies=se,e.maxSatisfying=function(J,pe,ge){var Ne=null,Be=null;try{var Je=new I(pe,ge)}catch{return null}return J.forEach(function(Ge){Je.test(Ge)&&(Ne&&Be.compare(Ge)!==-1||(Be=new ee(Ne=Ge,ge)))}),Ne},e.minSatisfying=function(J,pe,ge){var Ne=null,Be=null;try{var Je=new I(pe,ge)}catch{return null}return J.forEach(function(Ge){Je.test(Ge)&&(Ne&&Be.compare(Ge)!==1||(Be=new ee(Ne=Ge,ge)))}),Ne},e.validRange=function(J,pe){try{return new I(J,pe).range||"*"}catch{return null}},e.ltr=function(J,pe,ge){return de(J,pe,"<",ge)},e.gtr=function(J,pe,ge){return de(J,pe,">",ge)},e.outside=de,e.prerelease=function(J,pe){var ge=be(J,pe);return ge&&ge.prerelease.length?ge.prerelease:null},e.intersects=function(J,pe,ge){return J=new I(J,ge),pe=new I(pe,ge),J.intersects(pe)},e.coerce=function(J){if(J instanceof ee)return J;if(typeof J!="string")return null;var pe=J.match(P[U]);return pe==null?null:be((pe[1]||"0")+"."+(pe[2]||"0")+"."+(pe[3]||"0"))}}).call(this,a(1))},function(ne,e){var a,v,b=ne.exports={};function M(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function P(d){if(a===setTimeout)return setTimeout(d,0);if((a===M||!a)&&setTimeout)return a=setTimeout,setTimeout(d,0);try{return a(d,0)}catch{try{return a.call(null,d,0)}catch{return a.call(this,d,0)}}}(function(){try{a=typeof setTimeout=="function"?setTimeout:M}catch{a=M}try{v=typeof clearTimeout=="function"?clearTimeout:D}catch{v=D}})();var E,T=[],O=!1,y=-1;function m(){O&&E&&(O=!1,E.length?T=E.concat(T):y=-1,T.length&&k())}function k(){if(!O){var d=P(m);O=!0;for(var o=T.length;o;){for(E=T,T=[];++y<o;)E&&E[y].run();y=-1,o=T.length}E=null,O=!1,function(g){if(v===clearTimeout)return clearTimeout(g);if((v===D||!v)&&clearTimeout)return v=clearTimeout,clearTimeout(g);try{v(g)}catch{try{return v.call(null,g)}catch{return v.call(this,g)}}}(d)}}function f(d,o){this.fun=d,this.array=o}function h(){}b.nextTick=function(d){var o=new Array(arguments.length-1);if(arguments.length>1)for(var g=1;g<arguments.length;g++)o[g-1]=arguments[g];T.push(new f(d,o)),T.length!==1||O||P(k)},f.prototype.run=function(){this.fun.apply(null,this.array)},b.title="browser",b.browser=!0,b.env={},b.argv=[],b.version="",b.versions={},b.on=h,b.addListener=h,b.once=h,b.off=h,b.removeListener=h,b.removeAllListeners=h,b.emit=h,b.prependListener=h,b.prependOnceListener=h,b.listeners=function(d){return[]},b.binding=function(d){throw new Error("process.binding is not supported")},b.cwd=function(){return"/"},b.chdir=function(d){throw new Error("process.chdir is not supported")},b.umask=function(){return 0}}])}),define(ye[108],De([1,0,11,7]),function(ne,e,a,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function b(l){const w=l;return w?typeof w.read=="function":!1}e.isReadable=b;function M(l){const w=l;return w?[w.on,w.pause,w.resume,w.destroy].every(s=>typeof s=="function"):!1}e.isReadableStream=M;function D(l){const w=l;return w?M(w.stream)&&Array.isArray(w.buffer)&&typeof w.ended=="boolean":!1}e.isReadableBufferedStream=D;function P(l,w){return new E(l,w)}e.newWriteableStream=P;class E{constructor(w,s){this.reducer=w,this.options=s,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(w){if(!this.state.destroyed){if(this.state.flowing)this.emitData(w);else if(this.buffer.data.push(w),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(s=>this.pendingWritePromises.push(s))}}error(w){this.state.destroyed||(this.state.flowing?this.emitError(w):this.buffer.error.push(w))}end(w){this.state.destroyed||(typeof w!="undefined"&&this.write(w),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(w){this.listeners.data.slice(0).forEach(s=>s(w))}emitError(w){this.listeners.error.length===0?(0,a.onUnexpectedError)(w):this.listeners.error.slice(0).forEach(s=>s(w))}emitEnd(){this.listeners.end.slice(0).forEach(w=>w())}on(w,s){if(!this.state.destroyed)switch(w){case"data":this.listeners.data.push(s),this.resume();break;case"end":this.listeners.end.push(s),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(s),this.state.flowing&&this.flowErrors();break}}removeListener(w,s){if(this.state.destroyed)return;let u;switch(w){case"data":u=this.listeners.data;break;case"end":u=this.listeners.end;break;case"error":u=this.listeners.error;break}if(u){const n=u.indexOf(s);n>=0&&u.splice(n,1)}}flowData(){if(this.buffer.data.length>0){const w=this.reducer(this.buffer.data);this.emitData(w),this.buffer.data.length=0;const s=[...this.pendingWritePromises];this.pendingWritePromises.length=0,s.forEach(u=>u())}}flowErrors(){if(this.listeners.error.length>0){for(const w of this.buffer.error)this.emitError(w);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function T(l,w){const s=[];let u;for(;(u=l.read())!==null;)s.push(u);return w(s)}e.consumeReadable=T;function O(l,w,s){const u=[];let n;for(;(n=l.read())!==null&&u.length<s;)u.push(n);return n===null&&u.length>0?w(u):{read:()=>{if(u.length>0)return u.shift();if(typeof n!="undefined"){const i=n;return n=void 0,i}return l.read()}}}e.peekReadable=O;function y(l,w){return new Promise((s,u)=>{const n=[];m(l,{onData:i=>{w&&n.push(i)},onError:i=>{w?u(i):s(void 0)},onEnd:()=>{s(w?w(n):void 0)}})})}e.consumeStream=y;function m(l,w){let s=!1;return l.on("error",u=>{s||w.onError(u)}),l.on("end",()=>{s||w.onEnd()}),l.on("data",u=>{s||w.onData(u)}),(0,v.toDisposable)(()=>s=!0)}e.listenStream=m;function k(l,w){return new Promise((s,u)=>{const n=new v.DisposableStore,i=[],r=_=>{if(i.push(_),i.length>w)return n.dispose(),l.pause(),s({stream:l,buffer:i,ended:!1})},t=_=>u(_),c=()=>s({stream:l,buffer:i,ended:!0});n.add((0,v.toDisposable)(()=>l.removeListener("error",t))),l.on("error",t),n.add((0,v.toDisposable)(()=>l.removeListener("end",c))),l.on("end",c),n.add((0,v.toDisposable)(()=>l.removeListener("data",r))),l.on("data",r)})}e.peekStream=k;function f(l,w){const s=P(w);return s.end(l),s}e.toStream=f;function h(){const l=P(()=>{throw new Error("not supported")});return l.end(),l}e.emptyStream=h;function d(l){let w=!1;return{read:()=>w?null:(w=!0,l)}}e.toReadable=d;function o(l,w,s){const u=P(s);return m(l,{onData:n=>u.write(w.data(n)),onError:n=>u.error(w.error?w.error(n):n),onEnd:()=>u.end()}),u}e.transform=o;function g(l,w,s){let u=!1;return{read:()=>{const n=w.read();return u?n:(u=!0,n!==null?s([l,n]):l)}}}e.prefixedReadable=g;function R(l,w,s){let u=!1;const n=P(s);return m(w,{onData:i=>u?n.write(i):(u=!0,n.write(s([l,i]))),onError:i=>n.error(i),onEnd:()=>{u||(u=!0,n.write(l)),n.end()}}),n}e.prefixedStream=R}),define(ye[23],De([1,0,108]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const v=typeof Buffer!="undefined";let b,M;class D{constructor(_){this.buffer=_,this.byteLength=this.buffer.byteLength}static alloc(_){return v?new D(Buffer.allocUnsafe(_)):new D(new Uint8Array(_))}static wrap(_){return v&&!Buffer.isBuffer(_)&&(_=Buffer.from(_.buffer,_.byteOffset,_.byteLength)),new D(_)}static fromString(_,p){return!(p?.dontUseNodeBuffer||!1)&&v?new D(Buffer.from(_)):(b||(b=new TextEncoder),new D(b.encode(_)))}static fromByteArray(_){const p=D.alloc(_.length);for(let C=0,U=_.length;C<U;C++)p.buffer[C]=_[C];return p}static concat(_,p){if(typeof p=="undefined"){p=0;for(let W=0,L=_.length;W<L;W++)p+=_[W].byteLength}const C=D.alloc(p);let U=0;for(let W=0,L=_.length;W<L;W++){const S=_[W];C.set(S,U),U+=S.byteLength}return C}clone(){const _=D.alloc(this.byteLength);return _.set(this),_}toString(){return v?this.buffer.toString():(M||(M=new TextDecoder),M.decode(this.buffer))}slice(_,p){return new D(this.buffer.subarray(_,p))}set(_,p){if(_ instanceof D)this.buffer.set(_.buffer,p);else if(_ instanceof Uint8Array)this.buffer.set(_,p);else if(_ instanceof ArrayBuffer)this.buffer.set(new Uint8Array(_),p);else if(ArrayBuffer.isView(_))this.buffer.set(new Uint8Array(_.buffer,_.byteOffset,_.byteLength),p);else throw new Error("Unknown argument 'array'")}readUInt32BE(_){return T(this.buffer,_)}writeUInt32BE(_,p){O(this.buffer,_,p)}readUInt32LE(_){return y(this.buffer,_)}writeUInt32LE(_,p){m(this.buffer,_,p)}readUInt8(_){return k(this.buffer,_)}writeUInt8(_,p){f(this.buffer,_,p)}}e.VSBuffer=D;function P(c,_){return c[_+0]<<0>>>0|c[_+1]<<8>>>0}e.readUInt16LE=P;function E(c,_,p){c[p+0]=_&255,_=_>>>8,c[p+1]=_&255}e.writeUInt16LE=E;function T(c,_){return c[_]*2**24+c[_+1]*2**16+c[_+2]*2**8+c[_+3]}e.readUInt32BE=T;function O(c,_,p){c[p+3]=_,_=_>>>8,c[p+2]=_,_=_>>>8,c[p+1]=_,_=_>>>8,c[p]=_}e.writeUInt32BE=O;function y(c,_){return c[_+0]<<0>>>0|c[_+1]<<8>>>0|c[_+2]<<16>>>0|c[_+3]<<24>>>0}e.readUInt32LE=y;function m(c,_,p){c[p+0]=_&255,_=_>>>8,c[p+1]=_&255,_=_>>>8,c[p+2]=_&255,_=_>>>8,c[p+3]=_&255}e.writeUInt32LE=m;function k(c,_){return c[_]}e.readUInt8=k;function f(c,_,p){c[p]=_}e.writeUInt8=f;function h(c){return a.consumeReadable(c,_=>D.concat(_))}e.readableToBuffer=h;function d(c){return a.toReadable(c)}e.bufferToReadable=d;function o(c){return a.consumeStream(c,_=>D.concat(_))}e.streamToBuffer=o;async function g(c){return c.ended?D.concat(c.buffer):D.concat([...c.buffer,await o(c.stream)])}e.bufferedStreamToBuffer=g;function R(c){return a.toStream(c,_=>D.concat(_))}e.bufferToStream=R;function l(c){return a.transform(c,{data:_=>typeof _=="string"?D.fromString(_):D.wrap(_)},_=>D.concat(_))}e.streamToBufferReadableStream=l;function w(c){return a.newWriteableStream(_=>D.concat(_),c)}e.newWriteableBufferStream=w;function s(c,_){return a.prefixedReadable(c,_,p=>D.concat(p))}e.prefixedBufferReadable=s;function u(c,_){return a.prefixedStream(c,_,p=>D.concat(p))}e.prefixedBufferStream=u;function n(c){let _=0,p=0,C=0;const U=new Uint8Array(Math.floor(c.length/4*3)),W=S=>{switch(p){case 3:U[C++]=_|S,p=0;break;case 2:U[C++]=_|S>>>2,_=S<<6,p=3;break;case 1:U[C++]=_|S>>>4,_=S<<4,p=2;break;default:_=S<<2,p=1}};for(let S=0;S<c.length;S++){const z=c.charCodeAt(S);if(z>=65&&z<=90)W(z-65);else if(z>=97&&z<=122)W(z-97+26);else if(z>=48&&z<=57)W(z-48+52);else if(z===43||z===45)W(62);else if(z===47||z===95)W(63);else{if(z===61)break;throw new SyntaxError(`Unexpected base64 character ${c[S]}`)}}const L=C;for(;p>0;)W(0);return D.wrap(U).slice(0,L)}e.decodeBase64=n;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function t({buffer:c},_=!0,p=!1){const C=p?r:i;let U="";const W=c.byteLength%3;let L=0;for(;L<c.byteLength-W;L+=3){const S=c[L+0],z=c[L+1],$=c[L+2];U+=C[S>>>2],U+=C[(S<<4|z>>>4)&63],U+=C[(z<<2|$>>>6)&63],U+=C[$&63]}if(W===1){const S=c[L+0];U+=C[S>>>2],U+=C[S<<4&63],_&&(U+="==")}else if(W===2){const S=c[L+0],z=c[L+1];U+=C[S>>>2],U+=C[(S<<4|z>>>4)&63],U+=C[z<<2&63],_&&(U+="=")}return U}e.encodeBase64=t}),define(ye[42],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const a=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function v(b){return a.test(b)}e.isUUID=v,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let b;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?b=crypto.getRandomValues.bind(crypto):b=function(P){for(let E=0;E<P.length;E++)P[E]=Math.floor(Math.random()*256);return P};const M=new Uint8Array(16),D=[];for(let P=0;P<256;P++)D.push(P.toString(16).padStart(2,"0"));return function(){b(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let E=0,T="";return T+=D[M[E++]],T+=D[M[E++]],T+=D[M[E++]],T+=D[M[E++]],T+="-",T+=D[M[E++]],T+=D[M[E++]],T+="-",T+=D[M[E++]],T+=D[M[E++]],T+="-",T+=D[M[E++]],T+=D[M[E++]],T+="-",T+=D[M[E++]],T+=D[M[E++]],T+=D[M[E++]],T+=D[M[E++]],T+=D[M[E++]],T+=D[M[E++]],T}}()}),define(ye[109],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(ye[110],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var a;(function(D){D[D.None=0]="None",D[D.Indent=1]="Indent",D[D.IndentOutdent=2]="IndentOutdent",D[D.Outdent=3]="Outdent"})(a=e.IndentAction||(e.IndentAction={}));class v{constructor(P){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=P.open,this.close=P.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(P.notIn))for(let E=0,T=P.notIn.length;E<T;E++)switch(P.notIn[E]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(P){switch(P){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(P,E){if(P.getTokenCount()===0)return!0;const T=P.findTokenIndexAtOffset(E-2),O=P.getStandardTokenType(T);return this.isOK(O)}_findNeutralCharacterInRange(P,E){for(let T=P;T<=E;T++){const O=String.fromCharCode(T);if(!this.open.includes(O)&&!this.close.includes(O))return O}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=v;class b{constructor(P){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const E of P)M(this.autoClosingPairsOpenByStart,E.open.charAt(0),E),M(this.autoClosingPairsOpenByEnd,E.open.charAt(E.open.length-1),E),M(this.autoClosingPairsCloseByStart,E.close.charAt(0),E),M(this.autoClosingPairsCloseByEnd,E.close.charAt(E.close.length-1),E),E.close.length===1&&E.open.length===1&&M(this.autoClosingPairsCloseSingleChar,E.close,E)}}e.AutoClosingPairs=b;function M(D,P,E){D.has(P)?D.get(P).push(E):D.set(P,[E])}}),define(ye[111],De([17,18]),function(ne,e){return ne.create("vs/base/common/date",e)}),define(ye[112],De([1,0,111]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const v=60,b=v*60,M=b*24,D=M*7,P=M*30,E=M*365;function T(y,m,k){typeof y!="number"&&(y=y.getTime());const f=Math.round((new Date().getTime()-y)/1e3);if(f<-30)return(0,a.localize)(0,null,T(new Date().getTime()+f*1e3,!1));if(f<30)return(0,a.localize)(1,null);let h;return f<v?(h=f,m?h===1?k?(0,a.localize)(2,null,h):(0,a.localize)(3,null,h):k?(0,a.localize)(4,null,h):(0,a.localize)(5,null,h):h===1?k?(0,a.localize)(6,null,h):(0,a.localize)(7,null,h):k?(0,a.localize)(8,null,h):(0,a.localize)(9,null,h)):f<b?(h=Math.floor(f/v),m?h===1?k?(0,a.localize)(10,null,h):(0,a.localize)(11,null,h):k?(0,a.localize)(12,null,h):(0,a.localize)(13,null,h):h===1?k?(0,a.localize)(14,null,h):(0,a.localize)(15,null,h):k?(0,a.localize)(16,null,h):(0,a.localize)(17,null,h)):f<M?(h=Math.floor(f/b),m?h===1?k?(0,a.localize)(18,null,h):(0,a.localize)(19,null,h):k?(0,a.localize)(20,null,h):(0,a.localize)(21,null,h):h===1?k?(0,a.localize)(22,null,h):(0,a.localize)(23,null,h):k?(0,a.localize)(24,null,h):(0,a.localize)(25,null,h)):f<D?(h=Math.floor(f/M),m?h===1?(0,a.localize)(26,null,h):(0,a.localize)(27,null,h):h===1?(0,a.localize)(28,null,h):(0,a.localize)(29,null,h)):f<P?(h=Math.floor(f/D),m?h===1?k?(0,a.localize)(30,null,h):(0,a.localize)(31,null,h):k?(0,a.localize)(32,null,h):(0,a.localize)(33,null,h):h===1?k?(0,a.localize)(34,null,h):(0,a.localize)(35,null,h):k?(0,a.localize)(36,null,h):(0,a.localize)(37,null,h)):f<E?(h=Math.floor(f/P),m?h===1?k?(0,a.localize)(38,null,h):(0,a.localize)(39,null,h):k?(0,a.localize)(40,null,h):(0,a.localize)(41,null,h):h===1?k?(0,a.localize)(42,null,h):(0,a.localize)(43,null,h):k?(0,a.localize)(44,null,h):(0,a.localize)(45,null,h)):(h=Math.floor(f/E),m?h===1?k?(0,a.localize)(46,null,h):(0,a.localize)(47,null,h):k?(0,a.localize)(48,null,h):(0,a.localize)(49,null,h):h===1?k?(0,a.localize)(50,null,h):(0,a.localize)(51,null,h):k?(0,a.localize)(52,null,h):(0,a.localize)(53,null,h))}e.fromNow=T;function O(y){return y.getFullYear()+"-"+String(y.getMonth()+1).padStart(2,"0")+"-"+String(y.getDate()).padStart(2,"0")+"T"+String(y.getHours()).padStart(2,"0")+":"+String(y.getMinutes()).padStart(2,"0")+":"+String(y.getSeconds()).padStart(2,"0")+"."+(y.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=O}),define(ye[113],De([17,18]),function(ne,e){return ne.create("vs/base/common/errorMessage",e)}),define(ye[43],De([1,0,16,10,113]),function(ne,e,a,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function M(y,m){return m&&(y.stack||y.stacktrace)?b.localize(0,null,P(y),D(y.stack)||D(y.stacktrace)):P(y)}function D(y){return Array.isArray(y)?y.join(`
`):y}function P(y){return typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?b.localize(1,null,y.message):y.message||b.localize(2,null)}function E(y=null,m=!1){if(!y)return b.localize(3,null);if(Array.isArray(y)){const k=a.coalesce(y),f=E(k[0],m);return k.length>1?b.localize(4,null,f,k.length):f}if(v.isString(y))return y;if(y.detail){const k=y.detail;if(k.error)return M(k.error,m);if(k.exception)return M(k.exception,m)}return y.stack?M(y,m):y.message?y.message:b.localize(5,null)}e.toErrorMessage=E;function T(y){const m=y;return m instanceof Error&&Array.isArray(m.actions)}e.isErrorWithActions=T;function O(y,m){let k;return typeof y=="string"?k=new Error(y):k=y,k.actions=m,k}e.createErrorWithActions=O}),define(ye[74],De([1,0,19]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const v={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},b={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function M(O){const y=(0,a.extname)(O),m=v[y.toLowerCase()];return m!==void 0?m:D(O)}e.getMediaOrTextMime=M;function D(O){const y=(0,a.extname)(O);return b[y.toLowerCase()]}e.getMediaMime=D;function P(O){for(const y in b)if(b[y]===O)return y}e.getExtensionForMimeType=P;const E=/^(.+)\/(.+?)(;.+)?$/;function T(O,y){const m=E.exec(O);return m?`${m[1].toLowerCase()}/${m[2].toLowerCase()}${m[3]??""}`:y?void 0:O}e.normalizeMimeType=T}),define(ye[37],De([1,0,19,21,9,10]),function(ne,e,a,v,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function D(r){return r===47||r===92}e.isPathSeparator=D;function P(r){return r.replace(/[\\/]/g,a.posix.sep)}e.toSlashes=P;function E(r){return r.indexOf("/")===-1&&(r=P(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=E;function T(r,t=a.posix.sep){if(!r)return"";const c=r.length,_=r.charCodeAt(0);if(D(_)){if(D(r.charCodeAt(1))&&!D(r.charCodeAt(2))){let C=3;const U=C;for(;C<c&&!D(r.charCodeAt(C));C++);if(U!==C&&!D(r.charCodeAt(C+1))){for(C+=1;C<c;C++)if(D(r.charCodeAt(C)))return r.slice(0,C+1).replace(/[\\/]/g,t)}}return t}else if(o(_)&&r.charCodeAt(1)===58)return D(r.charCodeAt(2))?r.slice(0,2)+t:r.slice(0,2);let p=r.indexOf("://");if(p!==-1){for(p+=3;p<c;p++)if(D(r.charCodeAt(p)))return r.slice(0,p+1)}return""}e.getRoot=T;function O(r){if(!v.isWindows||!r||r.length<5)return!1;let t=r.charCodeAt(0);if(t!==92||(t=r.charCodeAt(1),t!==92))return!1;let c=2;const _=c;for(;c<r.length&&(t=r.charCodeAt(c),t!==92);c++);return!(_===c||(t=r.charCodeAt(c+1),isNaN(t)||t===92))}e.isUNC=O;const y=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,k=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(r,t=v.isWindows){const c=t?y:m;return!(!r||r.length===0||/^\s+$/.test(r)||(c.lastIndex=0,c.test(r))||t&&k.test(r)||r==="."||r===".."||t&&r[r.length-1]==="."||t&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=f;function h(r,t,c){const _=r===t;return!c||_?_:!r||!t?!1:(0,b.equalsIgnoreCase)(r,t)}e.isEqual=h;function d(r,t,c,_=a.sep){if(r===t)return!0;if(!r||!t||t.length>r.length)return!1;if(c){if(!(0,b.startsWithIgnoreCase)(r,t))return!1;if(t.length===r.length)return!0;let C=t.length;return t.charAt(t.length-1)===_&&C--,r.charAt(C)===_}return t.charAt(t.length-1)!==_&&(t+=_),r.indexOf(t)===0}e.isEqualOrParent=d;function o(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=o;function g(r,t){return v.isWindows&&r.endsWith(":")&&(r+=a.sep),(0,a.isAbsolute)(r)||(r=(0,a.join)(t,r)),r=(0,a.normalize)(r),v.isWindows?(r=(0,b.rtrim)(r,a.sep),r.endsWith(":")&&(r+=a.sep)):(r=(0,b.rtrim)(r,a.sep),r||(r=a.sep)),r}e.sanitizeFilePath=g;function R(r){const t=(0,a.normalize)(r);return v.isWindows?r.length>3?!1:l(t)&&(r.length===2||t.charCodeAt(2)===92):t===a.posix.sep}e.isRootOrDriveLetter=R;function l(r,t=v.isWindows){return t?o(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=l;function w(r){return l(r)?r[0]:void 0}e.getDriveLetter=w;function s(r,t,c){return t.length>r.length?-1:r===t?0:(c&&(r=r.toLowerCase(),t=t.toLowerCase()),r.indexOf(t))}e.indexOfPath=s;function u(r){const t=r.split(":");let c,_,p;for(const C of t){const U=Number(C);(0,M.isNumber)(U)?_===void 0?_=U:p===void 0&&(p=U):c=c?[c,C].join(":"):C}if(!c)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:c,line:_!==void 0?_:void 0,column:p!==void 0?p:_!==void 0?1:void 0}}e.parseLineAndColumnAware=u;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function i(r,t,c=8){let _="";for(let C=0;C<c;C++)_+=n.charAt(Math.floor(Math.random()*n.length));let p;return t?p=`${t}-${_}`:p=_,r?(0,a.join)(r,p):p}e.randomPath=i}),define(ye[25],De([1,0,16,9]),function(ne,e,a,v){"use strict";var b,M,D;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function P(n,i,r){let t=n.get(i);return t===void 0&&(t=r,n.set(i,t)),t}e.getOrSet=P;function E(n){const i=[];return n.forEach((r,t)=>{i.push(`${t} => ${r}`)}),`Map(${n.size}) {${i.join(", ")}}`}e.mapToString=E;function T(n){const i=[];return n.forEach(r=>{i.push(r)}),`Set(${n.size}) {${i.join(", ")}}`}e.setToString=T;class O{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const r=i.charCodeAt(0),t=this._value.charCodeAt(this._pos);return r-t}value(){return this._value[this._pos]}}e.StringIterator=O;class y{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,v.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,v.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=y;class m{constructor(i=!0,r=!0){this._splitOnBackslash=i,this._caseSensitive=r}reset(i){this._from=0,this._to=0,this._value=i,this._valueLen=i.length;for(let r=i.length-1;r>=0;r--,this._valueLen--){const t=this._value.charCodeAt(r);if(!(t===47||this._splitOnBackslash&&t===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let i=!0;for(;this._to<this._valueLen;this._to++){const r=this._value.charCodeAt(this._to);if(r===47||this._splitOnBackslash&&r===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,v.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,v.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=m;var k;(function(n){n[n.Scheme=1]="Scheme",n[n.Authority=2]="Authority",n[n.Path=3]="Path",n[n.Query=4]="Query",n[n.Fragment=5]="Fragment"})(k||(k={}));class f{constructor(i,r){this._ignorePathCasing=i,this._ignoreQueryAndFragment=r,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new m(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(i)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,v.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,v.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,v.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,v.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=f;class h{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const i=this.right;return this.right=i.left,i.left=this,this.updateHeight(),i.updateHeight(),i}rotateRight(){const i=this.left;return this.left=i.right,i.right=this,this.updateHeight(),i.updateHeight(),i}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var d;(function(n){n[n.Left=-1]="Left",n[n.Mid=0]="Mid",n[n.Right=1]="Right"})(d||(d={}));class o{constructor(i){this._iter=i}static forUris(i=()=>!1,r=()=>!1){return new o(new f(i,r))}static forPaths(i=!1){return new o(new m(void 0,!i))}static forStrings(){return new o(new O)}static forConfigKeys(){return new o(new y)}clear(){this._root=void 0}fill(i,r){if(r){const t=r.slice(0);(0,a.shuffle)(t);for(const c of t)this.set(c,i)}else{const t=i.slice(0);(0,a.shuffle)(t);for(const c of t)this.set(c[0],c[1])}}set(i,r){const t=this._iter.reset(i);let c;this._root||(this._root=new h,this._root.segment=t.value());const _=[];for(c=this._root;;){const C=t.cmp(c.segment);if(C>0)c.left||(c.left=new h,c.left.segment=t.value()),_.push([-1,c]),c=c.left;else if(C<0)c.right||(c.right=new h,c.right.segment=t.value()),_.push([1,c]),c=c.right;else if(t.hasNext())t.next(),c.mid||(c.mid=new h,c.mid.segment=t.value()),_.push([0,c]),c=c.mid;else break}const p=c.value;c.value=r,c.key=i;for(let C=_.length-1;C>=0;C--){const U=_[C][1];U.updateHeight();const W=U.balanceFactor();if(W<-1||W>1){const L=_[C][0],S=_[C+1][0];if(L===1&&S===1)_[C][1]=U.rotateLeft();else if(L===-1&&S===-1)_[C][1]=U.rotateRight();else if(L===1&&S===-1)U.right=_[C+1][1]=_[C+1][1].rotateRight(),_[C][1]=U.rotateLeft();else if(L===-1&&S===1)U.left=_[C+1][1]=_[C+1][1].rotateLeft(),_[C][1]=U.rotateRight();else throw new Error;if(C>0)switch(_[C-1][0]){case-1:_[C-1][1].left=_[C][1];break;case 1:_[C-1][1].right=_[C][1];break;case 0:_[C-1][1].mid=_[C][1];break}else this._root=_[0][1]}}return p}get(i){return this._getNode(i)?.value}_getNode(i){const r=this._iter.reset(i);let t=this._root;for(;t;){const c=r.cmp(t.segment);if(c>0)t=t.left;else if(c<0)t=t.right;else if(r.hasNext())r.next(),t=t.mid;else break}return t}has(i){const r=this._getNode(i);return!(r?.value===void 0&&r?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,r){const t=this._iter.reset(i),c=[];let _=this._root;for(;_;){const p=t.cmp(_.segment);if(p>0)c.push([-1,_]),_=_.left;else if(p<0)c.push([1,_]),_=_.right;else if(t.hasNext())t.next(),c.push([0,_]),_=_.mid;else break}if(!!_){if(r?(_.left=void 0,_.mid=void 0,_.right=void 0,_.height=1):(_.key=void 0,_.value=void 0),!_.mid&&!_.value)if(_.left&&_.right){const p=this._min(_.right),{key:C,value:U,segment:W}=p;this._delete(p.key,!1),_.key=C,_.value=U,_.segment=W}else{const p=_.left??_.right;if(c.length>0){const[C,U]=c[c.length-1];switch(C){case-1:U.left=p;break;case 0:U.mid=p;break;case 1:U.right=p;break}}else this._root=p}for(let p=c.length-1;p>=0;p--){const C=c[p][1];C.updateHeight();const U=C.balanceFactor();if(U>1?(C.right.balanceFactor()>=0||(C.right=C.right.rotateRight()),c[p][1]=C.rotateLeft()):U<-1&&(C.left.balanceFactor()<=0||(C.left=C.left.rotateLeft()),c[p][1]=C.rotateRight()),p>0)switch(c[p-1][0]){case-1:c[p-1][1].left=c[p][1];break;case 1:c[p-1][1].right=c[p][1];break;case 0:c[p-1][1].mid=c[p][1];break}else this._root=c[0][1]}}}_min(i){for(;i.left;)i=i.left;return i}findSubstr(i){const r=this._iter.reset(i);let t=this._root,c;for(;t;){const _=r.cmp(t.segment);if(_>0)t=t.left;else if(_<0)t=t.right;else if(r.hasNext())r.next(),c=t.value||c,t=t.mid;else break}return t&&t.value||c}findSuperstr(i){const r=this._iter.reset(i);let t=this._root;for(;t;){const c=r.cmp(t.segment);if(c>0)t=t.left;else if(c<0)t=t.right;else if(r.hasNext())r.next(),t=t.mid;else return t.mid?this._entries(t.mid):void 0}}forEach(i){for(const[r,t]of this)i(t,r)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(i){const r=[];return this._dfsEntries(i,r),r[Symbol.iterator]()}_dfsEntries(i,r){!i||(i.left&&this._dfsEntries(i.left,r),i.value&&r.push([i.key,i.value]),i.mid&&this._dfsEntries(i.mid,r),i.right&&this._dfsEntries(i.right,r))}_isBalanced(){const i=r=>{if(!r)return!0;const t=r.balanceFactor();return t<-1||t>1?!1:i(r.left)&&i(r.right)};return i(this._root)}}e.TernarySearchTree=o;class g{constructor(i,r){this.uri=i,this.value=r}}class R{constructor(i,r){this[b]="ResourceMap",i instanceof R?(this.map=new Map(i.map),this.toKey=r??R.defaultToKey):(this.map=new Map,this.toKey=i??R.defaultToKey)}set(i,r){return this.map.set(this.toKey(i),new g(i,r)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,r){typeof r!="undefined"&&(i=i.bind(r));for(const[t,c]of this.map)i(c.value,c.uri,this)}*values(){for(const i of this.map.values())yield i.value}*keys(){for(const i of this.map.values())yield i.uri}*entries(){for(const i of this.map.values())yield[i.uri,i.value]}*[(b=Symbol.toStringTag,Symbol.iterator)](){for(const[,i]of this.map)yield[i.uri,i.value]}}e.ResourceMap=R,R.defaultToKey=n=>n.toString();class l{constructor(i,r){this[M]="ResourceSet",!i||typeof i=="function"?this._map=new R(i):(this._map=new R(r),i.forEach(this.add,this))}get size(){return this._map.size}add(i){return this._map.set(i,i),this}clear(){this._map.clear()}delete(i){return this._map.delete(i)}forEach(i,r){this._map.forEach((t,c)=>i.call(r,c,c,this))}has(i){return this._map.has(i)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(M=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=l;var w;(function(n){n[n.None=0]="None",n[n.AsOld=1]="AsOld",n[n.AsNew=2]="AsNew"})(w=e.Touch||(e.Touch={}));class s{constructor(){this[D]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,r=0){const t=this._map.get(i);if(!!t)return r!==0&&this.touch(t,r),t.value}set(i,r,t=0){let c=this._map.get(i);if(c)c.value=r,t!==0&&this.touch(c,t);else{switch(c={key:i,value:r,next:void 0,previous:void 0},t){case 0:this.addItemLast(c);break;case 1:this.addItemFirst(c);break;case 2:this.addItemLast(c);break;default:this.addItemLast(c);break}this._map.set(i,c),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const r=this._map.get(i);if(!!r)return this._map.delete(i),this.removeItem(r),this._size--,r.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,r){const t=this._state;let c=this._head;for(;c;){if(r?i.bind(r)(c.value,c.key,this):i(c.value,c.key,this),this._state!==t)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const i=this,r=this._state;let t=this._head;const c={[Symbol.iterator](){return c},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(t){const _={value:t.key,done:!1};return t=t.next,_}else return{value:void 0,done:!0}}};return c}values(){const i=this,r=this._state;let t=this._head;const c={[Symbol.iterator](){return c},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(t){const _={value:t.value,done:!1};return t=t.next,_}else return{value:void 0,done:!0}}};return c}entries(){const i=this,r=this._state;let t=this._head;const c={[Symbol.iterator](){return c},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(t){const _={value:[t.key,t.value],done:!1};return t=t.next,_}else return{value:void 0,done:!0}}};return c}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let r=this._head,t=this.size;for(;r&&t>i;)this._map.delete(r.key),r=r.next,t--;this._head=r,this._size=t,r&&(r.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const r=i.next,t=i.previous;if(!r||!t)throw new Error("Invalid list");r.previous=t,t.next=r}i.next=void 0,i.previous=void 0,this._state++}touch(i,r){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(i===this._head)return;const t=i.next,c=i.previous;i===this._tail?(c.next=void 0,this._tail=c):(t.previous=c,c.next=t),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(r===2){if(i===this._tail)return;const t=i.next,c=i.previous;i===this._head?(t.previous=void 0,this._head=t):(t.previous=c,c.next=t),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((r,t)=>{i.push([t,r])}),i}fromJSON(i){this.clear();for(const[r,t]of i)this.set(r,t)}}e.LinkedMap=s;class u extends s{constructor(i,r=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,r),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,r=2){return super.get(i,r)}peek(i){return super.get(i,0)}set(i,r){return super.set(i,r,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=u}),define(ye[114],De([1,0,25,9]),function(ne,e,a,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function b(...G){return function(Q,I){for(let B=0,H=G.length;B<H;B++){const V=G[B](Q,I);if(V)return V}return null}}e.or=b,e.matchesStrictPrefix=M.bind(void 0,!1),e.matchesPrefix=M.bind(void 0,!0);function M(G,Q,I){if(!I||I.length<Q.length)return null;let B;return G?B=v.startsWithIgnoreCase(I,Q):B=I.indexOf(Q)===0,B?Q.length>0?[{start:0,end:Q.length}]:[]:null}function D(G,Q){const I=Q.toLowerCase().indexOf(G.toLowerCase());return I===-1?null:[{start:I,end:I+G.length}]}e.matchesContiguousSubString=D;function P(G,Q){return E(G.toLowerCase(),Q.toLowerCase(),0,0)}e.matchesSubString=P;function E(G,Q,I,B){if(I===G.length)return[];if(B===Q.length)return null;if(G[I]===Q[B]){let H=null;return(H=E(G,Q,I+1,B+1))?o({start:B,end:B+1},H):null}return E(G,Q,I,B+1)}function T(G){return 97<=G&&G<=122}function O(G){return 65<=G&&G<=90}e.isUpper=O;function y(G){return 48<=G&&G<=57}function m(G){return G===32||G===9||G===10||G===13}const k=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(G=>k.add(G.charCodeAt(0)));function f(G){return m(G)||k.has(G)}function h(G,Q){return G===Q||f(G)&&f(Q)}function d(G){return T(G)||O(G)||y(G)}function o(G,Q){return Q.length===0?Q=[G]:G.end===Q[0].start?Q[0].start=G.start:Q.unshift(G),Q}function g(G,Q){for(let I=Q;I<G.length;I++){const B=G.charCodeAt(I);if(O(B)||y(B)||I>0&&!d(G.charCodeAt(I-1)))return I}return G.length}function R(G,Q,I,B){if(I===G.length)return[];if(B===Q.length)return null;if(G[I]!==Q[B].toLowerCase())return null;{let H=null,V=B+1;for(H=R(G,Q,I+1,B+1);!H&&(V=g(Q,V))<Q.length;)H=R(G,Q,I+1,V),V++;return H===null?null:o({start:B,end:B+1},H)}}function l(G){let Q=0,I=0,B=0,H=0,V=0;for(let ge=0;ge<G.length;ge++)V=G.charCodeAt(ge),O(V)&&Q++,T(V)&&I++,d(V)&&B++,y(V)&&H++;const se=Q/G.length,de=I/G.length,J=B/G.length,pe=H/G.length;return{upperPercent:se,lowerPercent:de,alphaPercent:J,numericPercent:pe}}function w(G){const{upperPercent:Q,lowerPercent:I}=G;return I===0&&Q>.6}function s(G){const{upperPercent:Q,lowerPercent:I,alphaPercent:B,numericPercent:H}=G;return I>.2&&Q<.8&&B>.6&&H<.2}function u(G){let Q=0,I=0,B=0,H=0;for(let V=0;V<G.length;V++)B=G.charCodeAt(V),O(B)&&Q++,T(B)&&I++,m(B)&&H++;return(Q===0||I===0)&&H===0?G.length<=30:Q<=5}function n(G,Q){if(!Q||(Q=Q.trim(),Q.length===0)||!u(G)||Q.length>60)return null;const I=l(Q);if(!s(I)){if(!w(I))return null;Q=Q.toLowerCase()}let B=null,H=0;for(G=G.toLowerCase();H<Q.length&&(B=R(G,Q,0,H))===null;)H=g(Q,H+1);return B}e.matchesCamelCase=n;function i(G,Q,I=!1){if(!Q||Q.length===0)return null;let B=null,H=0;for(G=G.toLowerCase(),Q=Q.toLowerCase();H<Q.length&&(B=r(G,Q,0,H,I))===null;)H=t(Q,H+1);return B}e.matchesWords=i;function r(G,Q,I,B,H){if(I===G.length)return[];if(B===Q.length)return null;if(h(G.charCodeAt(I),Q.charCodeAt(B))){let V=null,se=B+1;if(V=r(G,Q,I+1,B+1,H),!H)for(;!V&&(se=t(Q,se))<Q.length;)V=r(G,Q,I+1,se,H),se++;return V?G.charCodeAt(I)!==Q.charCodeAt(B)?V:o({start:B,end:B+1},V):null}else return null}function t(G,Q){for(let I=Q;I<G.length;I++)if(f(G.charCodeAt(I))||I>0&&f(G.charCodeAt(I-1)))return I;return G.length}const c=b(e.matchesPrefix,n,D),_=b(e.matchesPrefix,n,P),p=new a.LRUCache(1e4);function C(G,Q,I=!1){if(typeof G!="string"||typeof Q!="string")return null;let B=p.get(G);B||(B=new RegExp(v.convertSimple2RegExpPattern(G),"i"),p.set(G,B));const H=B.exec(Q);return H?[{start:H.index,end:H.index+H[0].length}]:I?_(G,Q):c(G,Q)}e.matchesFuzzy=C;function U(G,Q){const I=$e(G,G.toLowerCase(),0,Q,Q.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return I?L(I):null}e.matchesFuzzy2=U;function W(G,Q,I,B,H,V){const se=Math.min(13,G.length);for(;I<se;I++){const de=$e(G,Q,I,B,H,V,{firstMatchCanBeWeak:!1,boostFullMatch:!0});if(de)return de}return[0,V]}e.anyScore=W;function L(G){if(typeof G=="undefined")return[];const Q=[],I=G[1];for(let B=G.length-1;B>1;B--){const H=G[B]+I,V=Q[Q.length-1];V&&V.end===H?V.end=H+1:Q.push({start:H,end:H+1})}return Q}e.createMatches=L;const S=128;function z(){const G=[],Q=[];for(let I=0;I<=S;I++)Q[I]=0;for(let I=0;I<=S;I++)G.push(Q.slice(0));return G}function $(G){const Q=[];for(let I=0;I<=G;I++)Q[I]=0;return Q}const F=$(2*S),q=$(2*S),ie=z(),A=z(),Z=z(),le=!1;function oe(G,Q,I,B,H){function V(de,J,pe=" "){for(;de.length<J;)de=pe+de;return de}let se=` |   |${B.split("").map(de=>V(de,3)).join("|")}
`;for(let de=0;de<=I;de++)de===0?se+=" |":se+=`${Q[de-1]}|`,se+=G[de].slice(0,H+1).map(J=>V(J.toString(),3)).join("|")+`
`;return se}function ue(G,Q,I,B){G=G.substr(Q),I=I.substr(B),console.log(oe(A,G,G.length,I,I.length)),console.log(oe(Z,G,G.length,I,I.length)),console.log(oe(ie,G,G.length,I,I.length))}function te(G,Q){if(Q<0||Q>=G.length)return!1;const I=G.codePointAt(Q);switch(I){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!v.isEmojiImprecise(I)}}function Ee(G,Q){if(Q<0||Q>=G.length)return!1;switch(G.charCodeAt(Q)){case 32:case 9:return!0;default:return!1}}function be(G,Q,I){return Q[G]!==I[G]}function ee(G,Q,I,B,H,V,se=!1){for(;Q<I&&H<V;)G[Q]===B[H]&&(se&&(F[Q]=H),Q+=1),H+=1;return Q===I}e.isPatternInWord=ee;var ve;(function(G){G[G.Diag=1]="Diag",G[G.Left=2]="Left",G[G.LeftLeft=3]="LeftLeft"})(ve||(ve={}));var Ae;(function(G){G.Default=[-100,0];function Q(I){return!I||I.length===2&&I[0]===-100&&I[1]===0}G.isDefault=Q})(Ae=e.FuzzyScore||(e.FuzzyScore={}));class Fe{constructor(Q,I){this.firstMatchCanBeWeak=Q,this.boostFullMatch=I}}e.FuzzyScoreOptions=Fe,Fe.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function $e(G,Q,I,B,H,V,se=Fe.default){const de=G.length>S?S:G.length,J=B.length>S?S:B.length;if(I>=de||V>=J||de-I>J-V||!ee(Q,I,de,H,V,J,!0))return;Qe(de,J,I,V,Q,H);let pe=1,ge=1,Ne=I,Be=V;const Je=[!1];for(pe=1,Ne=I;Ne<de;pe++,Ne++){const X=F[Ne],fe=q[Ne],Ue=Ne+1<de?q[Ne+1]:J;for(ge=X-V+1,Be=X;Be<Ue;ge++,Be++){let He=Number.MIN_SAFE_INTEGER,Ze=!1;Be<=fe&&(He=Ie(G,Q,Ne,I,B,H,Be,J,V,ie[pe-1][ge-1]===0,Je));let qe=0;He!==Number.MAX_SAFE_INTEGER&&(Ze=!0,qe=He+A[pe-1][ge-1]);const We=Be>X,nt=We?A[pe][ge-1]+(ie[pe][ge-1]>0?-5:0):0,ot=Be>X+1&&ie[pe][ge-1]>0,ht=ot?A[pe][ge-2]+(ie[pe][ge-2]>0?-5:0):0;if(ot&&(!We||ht>=nt)&&(!Ze||ht>=qe))A[pe][ge]=ht,Z[pe][ge]=3,ie[pe][ge]=0;else if(We&&(!Ze||nt>=qe))A[pe][ge]=nt,Z[pe][ge]=2,ie[pe][ge]=0;else if(Ze)A[pe][ge]=qe,Z[pe][ge]=1,ie[pe][ge]=ie[pe-1][ge-1]+1;else throw new Error("not possible")}}if(le&&ue(G,I,B,V),!Je[0]&&!se.firstMatchCanBeWeak)return;pe--,ge--;const Ge=[A[pe][ge],V];let Te=0,rt=0;for(;pe>=1;){let X=ge;do{const fe=Z[pe][X];if(fe===3)X=X-2;else if(fe===2)X=X-1;else break}while(X>=1);Te>1&&Q[I+pe-1]===H[V+ge-1]&&!be(X+V-1,B,H)&&Te+1>ie[pe][X]&&(X=ge),X===ge?Te++:Te=1,rt||(rt=X),pe--,ge=X-1,Ge.push(ge)}J===de&&se.boostFullMatch&&(Ge[0]+=2);const K=rt-de;return Ge[0]-=K,Ge}e.fuzzyScore=$e;function Qe(G,Q,I,B,H,V){let se=G-1,de=Q-1;for(;se>=I&&de>=B;)H[se]===V[de]&&(q[se]=de,se--),de--}function Ie(G,Q,I,B,H,V,se,de,J,pe,ge){if(Q[I]!==V[se])return Number.MIN_SAFE_INTEGER;let Ne=1,Be=!1;return se===I-B?Ne=G[I]===H[se]?7:5:be(se,H,V)&&(se===0||!be(se-1,H,V))?(Ne=G[I]===H[se]?7:5,Be=!0):te(V,se)&&(se===0||!te(V,se-1))?Ne=5:(te(V,se-1)||Ee(V,se-1))&&(Ne=5,Be=!0),Ne>1&&I===B&&(ge[0]=!0),Be||(Be=be(se,H,V)||te(V,se-1)||Ee(V,se-1)),I===B?se>J&&(Ne-=Be?3:5):pe?Ne+=Be?2:0:Ne+=Be?0:1,se+1===de&&(Ne-=Be?3:5),Ne}function Se(G,Q,I,B,H,V,se){return ae(G,Q,I,B,H,V,!0,se)}e.fuzzyScoreGracefulAggressive=Se;function ke(G,Q,I,B,H,V,se){return ae(G,Q,I,B,H,V,!1,se)}e.fuzzyScoreGraceful=ke;function ae(G,Q,I,B,H,V,se,de){let J=$e(G,Q,I,B,H,V,de);if(J&&!se)return J;if(G.length>=3){const pe=Math.min(7,G.length-1);for(let ge=I+1;ge<pe;ge++){const Ne=ce(G,ge);if(Ne){const Be=$e(Ne,Ne.toLowerCase(),I,B,H,V,de);Be&&(Be[0]-=3,(!J||Be[0]>J[0])&&(J=Be))}}}return J}function ce(G,Q){if(Q+1>=G.length)return;const I=G[Q],B=G[Q+1];if(I!==B)return G.slice(0,Q)+B+I+G.slice(Q+2)}}),define(ye[115],De([1,0,116,114,9]),function(ne,e,a,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const M=new RegExp(`\\$\\(${a.CSSIcon.iconNameExpression}(?:${a.CSSIcon.iconModifierExpression})?\\)`,"g"),D=new RegExp(a.CSSIcon.iconNameCharacter),P=new RegExp(`(\\\\)?${M.source}`,"g");function E(d){return d.replace(P,(o,g)=>g?o:`\\${o}`)}e.escapeIcons=E;const T=new RegExp(`\\\\${M.source}`,"g");function O(d){return d.replace(T,o=>`\\${o}`)}e.markdownEscapeEscapedIcons=O;const y=new RegExp(`(\\s)?(\\\\)?${M.source}(\\s)?`,"g");function m(d){return d.indexOf(e.iconStartMarker)===-1?d:d.replace(y,(o,g,R,l)=>R?o:g||l||"")}e.stripIcons=m;function k(d){const o=d.indexOf(e.iconStartMarker);return o===-1?{text:d}:f(d,o)}e.parseLabelWithIcons=k;function f(d,o){const g=[];let R="";function l(c){if(c){R+=c;for(const _ of c)g.push(u)}}let w=-1,s="",u=0,n,i,r=o;const t=d.length;for(l(d.substr(0,o));r<t;)n=d[r],i=d[r+1],n===e.iconStartMarker[0]&&i===e.iconStartMarker[1]?(w=r,l(s),s=e.iconStartMarker,r++):n===")"&&w!==-1?(u+=r-w+1,w=-1,s=""):w!==-1?D.test(n)?s+=n:(l(s),w=-1,s=""):l(n),r++;return l(s),{text:R,iconOffsets:g}}function h(d,o,g=!1){const{text:R,iconOffsets:l}=o;if(!l||l.length===0)return(0,v.matchesFuzzy)(d,R,g);const w=(0,b.ltrim)(R," "),s=R.length-w.length,u=(0,v.matchesFuzzy)(d,w,g);if(u)for(const n of u){const i=l[n.start+s]+s;n.start+=i,n.end+=i}return u}e.matchesFuzzyIconAware=h}),define(ye[29],De([1,0,9]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var v;(function(b){b[b.Ignore=0]="Ignore",b[b.Info=1]="Info",b[b.Warning=2]="Warning",b[b.Error=3]="Error"})(v||(v={})),function(b){const M="error",D="warning",P="warn",E="info",T="ignore";function O(m){return m?a.equalsIgnoreCase(M,m)?b.Error:a.equalsIgnoreCase(D,m)||a.equalsIgnoreCase(P,m)?b.Warning:a.equalsIgnoreCase(E,m)?b.Info:b.Ignore:b.Ignore}b.fromValue=O;function y(m){switch(m){case b.Error:return M;case b.Warning:return D;case b.Info:return E;default:return T}}b.toString=y}(v||(v={})),e.default=v}),define(ye[55],De([1,0,23,9,2]),function(ne,e,a,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function M(T){return JSON.stringify(T,P)}e.stringify=M;function D(T){let O=JSON.parse(T);return O=E(O),O}e.parse=D;function P(T,O){return O instanceof RegExp?{$mid:2,source:O.source,flags:(0,v.regExpFlags)(O)}:O}function E(T,O=0){if(!T||O>200)return T;if(typeof T=="object"){switch(T.$mid){case 1:return b.URI.revive(T);case 2:return new RegExp(T.source,T.flags);case 14:return new Date(T.source)}if(T instanceof a.VSBuffer||T instanceof Uint8Array)return T;if(Array.isArray(T))for(let y=0;y<T.length;++y)T[y]=E(T[y],O+1);else for(const y in T)Object.hasOwnProperty.call(T,y)&&(T[y]=E(T[y],O+1))}return T}e.revive=E}),define(ye[12],De([1,0,21,2]),function(ne,e,a,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var b;(function(P){P.inMemory="inmemory",P.vscode="vscode",P.internal="private",P.walkThrough="walkThrough",P.walkThroughSnippet="walkThroughSnippet",P.http="http",P.https="https",P.file="file",P.mailto="mailto",P.untitled="untitled",P.data="data",P.command="command",P.vscodeRemote="vscode-remote",P.vscodeRemoteResource="vscode-remote-resource",P.vscodeUserData="vscode-userdata",P.vscodeCustomEditor="vscode-custom-editor",P.vscodeNotebook="vscode-notebook",P.vscodeNotebookCell="vscode-notebook-cell",P.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",P.vscodeNotebookCellOutput="vscode-notebook-cell-output",P.vscodeInteractive="vscode-interactive",P.vscodeInteractiveInput="vscode-interactive-input",P.vscodeSettings="vscode-settings",P.vscodeWorkspaceTrust="vscode-workspace-trust",P.vscodeTerminal="vscode-terminal",P.webviewPanel="webview-panel",P.vscodeWebview="vscode-webview",P.extension="extension",P.vscodeFileResource="vscode-file",P.tmp="tmp",P.vsls="vsls",P.vscodeSourceControl="vscode-scm"})(b=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class M{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${b.vscodeRemoteResource}`}setPreferredWebSchema(E){this._preferredWebSchema=E}setDelegate(E){this._delegate=E}setServerRootPath(E){this._remoteResourcesPath=`${E}/${b.vscodeRemoteResource}`}set(E,T,O){this._hosts[E]=T,this._ports[E]=O}setConnectionToken(E,T){this._connectionTokens[E]=T}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(E){if(this._delegate)return this._delegate(E);const T=E.authority;let O=this._hosts[T];O&&O.indexOf(":")!==-1&&(O=`[${O}]`);const y=this._ports[T],m=this._connectionTokens[T];let k=`path=${encodeURIComponent(E.path)}`;return typeof m=="string"&&(k+=`&${e.connectionTokenQueryName}=${encodeURIComponent(m)}`),v.URI.from({scheme:a.isWeb?this._preferredWebSchema:b.vscodeRemoteResource,authority:`${O}:${y}`,path:this._remoteResourcesPath,query:k})}}e.RemoteAuthorities=new M;class D{asBrowserUri(E,T){const O=this.toUri(E,T);return O.scheme===b.vscodeRemote?e.RemoteAuthorities.rewrite(O):O.scheme===b.file&&(a.isNative||a.isWebWorker&&a.globals.origin===`${b.vscodeFileResource}://${D.FALLBACK_AUTHORITY}`)?O.with({scheme:b.vscodeFileResource,authority:O.authority||D.FALLBACK_AUTHORITY,query:null,fragment:null}):O}asFileUri(E,T){const O=this.toUri(E,T);return O.scheme===b.vscodeFileResource?O.with({scheme:b.file,authority:O.authority!==D.FALLBACK_AUTHORITY?O.authority:null,query:null,fragment:null}):O}toUri(E,T){return v.URI.isUri(E)?E:v.URI.parse(T.toUrl(E))}}D.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new D}),define(ye[22],De([1,0,37,12,19,21,9,2]),function(ne,e,a,v,b,M,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function E(k){return(0,P.uriToFsPath)(k,!0)}e.originalFSPath=E;class T{constructor(f){this._ignorePathCasing=f}compare(f,h,d=!1){return f===h?0:(0,D.compare)(this.getComparisonKey(f,d),this.getComparisonKey(h,d))}isEqual(f,h,d=!1){return f===h?!0:!f||!h?!1:this.getComparisonKey(f,d)===this.getComparisonKey(h,d)}getComparisonKey(f,h=!1){return f.with({path:this._ignorePathCasing(f)?f.path.toLowerCase():void 0,fragment:h?null:void 0}).toString()}ignorePathCasing(f){return this._ignorePathCasing(f)}isEqualOrParent(f,h,d=!1){if(f.scheme===h.scheme){if(f.scheme===v.Schemas.file)return a.isEqualOrParent(E(f),E(h),this._ignorePathCasing(f))&&f.query===h.query&&(d||f.fragment===h.fragment);if((0,e.isEqualAuthority)(f.authority,h.authority))return a.isEqualOrParent(f.path,h.path,this._ignorePathCasing(f),"/")&&f.query===h.query&&(d||f.fragment===h.fragment)}return!1}joinPath(f,...h){return P.URI.joinPath(f,...h)}basenameOrAuthority(f){return(0,e.basename)(f)||f.authority}basename(f){return b.posix.basename(f.path)}extname(f){return b.posix.extname(f.path)}dirname(f){if(f.path.length===0)return f;let h;return f.scheme===v.Schemas.file?h=P.URI.file(b.dirname(E(f))).path:(h=b.posix.dirname(f.path),f.authority&&h.length&&h.charCodeAt(0)!==47&&(console.error(`dirname("${f.toString})) resulted in a relative path`),h="/")),f.with({path:h})}normalizePath(f){if(!f.path.length)return f;let h;return f.scheme===v.Schemas.file?h=P.URI.file(b.normalize(E(f))).path:h=b.posix.normalize(f.path),f.with({path:h})}relativePath(f,h){if(f.scheme!==h.scheme||!(0,e.isEqualAuthority)(f.authority,h.authority))return;if(f.scheme===v.Schemas.file){const g=b.relative(E(f),E(h));return M.isWindows?a.toSlashes(g):g}let d=f.path||"/";const o=h.path||"/";if(this._ignorePathCasing(f)){let g=0;for(const R=Math.min(d.length,o.length);g<R&&!(d.charCodeAt(g)!==o.charCodeAt(g)&&d.charAt(g).toLowerCase()!==o.charAt(g).toLowerCase());g++);d=o.substr(0,g)+d.substr(g)}return b.posix.relative(d,o)}resolvePath(f,h){if(f.scheme===v.Schemas.file){const d=P.URI.file(b.resolve(E(f),h));return f.with({authority:d.authority,path:d.path})}return h=a.toPosixPath(h),f.with({path:b.posix.resolve(f.path,h)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,h){return f===h||f!==void 0&&h!==void 0&&(0,D.equalsIgnoreCase)(f,h)}hasTrailingPathSeparator(f,h=b.sep){if(f.scheme===v.Schemas.file){const d=E(f);return d.length>a.getRoot(d).length&&d[d.length-1]===h}else{const d=f.path;return d.length>1&&d.charCodeAt(d.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,h=b.sep){return(0,e.hasTrailingPathSeparator)(f,h)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,h=b.sep){let d=!1;if(f.scheme===v.Schemas.file){const o=E(f);d=o!==void 0&&o.length===a.getRoot(o).length&&o[o.length-1]===h}else{h="/";const o=f.path;d=o.length===1&&o.charCodeAt(o.length-1)===47}return!d&&!(0,e.hasTrailingPathSeparator)(f,h)?f.with({path:f.path+"/"}):f}}e.ExtUri=T,e.extUri=new T(()=>!1),e.extUriBiasedIgnorePathCase=new T(k=>k.scheme===v.Schemas.file?!M.isLinux:!0),e.extUriIgnorePathCase=new T(k=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function O(k,f){const h=[];for(let d=0;d<k.length;d++){const o=f(k[d]);k.some((g,R)=>R===d?!1:(0,e.isEqualOrParent)(o,f(g)))||h.push(k[d])}return h}e.distinctParents=O;var y;(function(k){k.META_DATA_LABEL="label",k.META_DATA_DESCRIPTION="description",k.META_DATA_SIZE="size",k.META_DATA_MIME="mime";function f(h){const d=new Map;h.path.substring(h.path.indexOf(";")+1,h.path.lastIndexOf(";")).split(";").forEach(R=>{const[l,w]=R.split(":");l&&w&&d.set(l,w)});const g=h.path.substring(0,h.path.indexOf(";"));return g&&d.set(k.META_DATA_MIME,g),d}k.parseMetaData=f})(y=e.DataUri||(e.DataUri={}));function m(k,f,h){if(f){let d=k.path;return d&&d[0]!==b.posix.sep&&(d=b.posix.sep+d),k.with({scheme:h,authority:f,path:d})}return k.with({scheme:h})}e.toLocalResource=m}),define(ye[14],De([1,0,20,11,5,7,22,21]),function(ne,e,a,v,b,M,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function E(be){return!!be&&typeof be.then=="function"}e.isThenable=E;function T(be){const ee=new a.CancellationTokenSource,ve=be(ee.token),Ae=new Promise((Fe,$e)=>{const Qe=ee.token.onCancellationRequested(()=>{Qe.dispose(),ee.dispose(),$e(new v.CancellationError)});Promise.resolve(ve).then(Ie=>{Qe.dispose(),ee.dispose(),Fe(Ie)},Ie=>{Qe.dispose(),ee.dispose(),$e(Ie)})});return new class{cancel(){ee.cancel()}then(Fe,$e){return Ae.then(Fe,$e)}catch(Fe){return this.then(void 0,Fe)}finally(Fe){return Ae.finally(Fe)}}}e.createCancelablePromise=T;function O(be,ee,ve){return new Promise((Ae,Fe)=>{const $e=ee.onCancellationRequested(()=>{$e.dispose(),Ae(ve)});be.then(Ae,Fe).finally(()=>$e.dispose())})}e.raceCancellation=O;function y(be,ee){return new Promise((ve,Ae)=>{const Fe=ee.onCancellationRequested(()=>{Fe.dispose(),Ae(new v.CancellationError)});be.then(ve,Ae).finally(()=>Fe.dispose())})}e.raceCancellationError=y;async function m(be){let ee=-1;const ve=be.map((Fe,$e)=>Fe.then(Qe=>(ee=$e,Qe))),Ae=await Promise.race(ve);return be.forEach((Fe,$e)=>{$e!==ee&&Fe.cancel()}),Ae}e.raceCancellablePromises=m;function k(be,ee,ve){let Ae;const Fe=setTimeout(()=>{Ae?.(void 0),ve?.()},ee);return Promise.race([be.finally(()=>clearTimeout(Fe)),new Promise($e=>Ae=$e)])}e.raceTimeout=k;function f(be){return new Promise((ee,ve)=>{const Ae=be();E(Ae)?Ae.then(ee,ve):ee(Ae)})}e.asPromise=f;class h{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(ee){if(this.activePromise){if(this.queuedPromiseFactory=ee,!this.queuedPromise){const ve=()=>{this.queuedPromise=null;const Ae=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,Ae};this.queuedPromise=new Promise(Ae=>{this.activePromise.then(ve,ve).then(Ae)})}return new Promise((ve,Ae)=>{this.queuedPromise.then(ve,Ae)})}return this.activePromise=ee(),new Promise((ve,Ae)=>{this.activePromise.then(Fe=>{this.activePromise=null,ve(Fe)},Fe=>{this.activePromise=null,Ae(Fe)})})}}e.Throttler=h;class d{constructor(){this.current=Promise.resolve(null)}queue(ee){return this.current=this.current.then(()=>ee(),()=>ee())}}e.Sequencer=d;class o{constructor(){this.promiseMap=new Map}queue(ee,ve){const Fe=(this.promiseMap.get(ee)??Promise.resolve()).catch(()=>{}).then(ve).finally(()=>{this.promiseMap.get(ee)===Fe&&this.promiseMap.delete(ee)});return this.promiseMap.set(ee,Fe),Fe}}e.SequencerByKey=o;const g=(be,ee)=>{let ve=!0;const Ae=setTimeout(()=>{ve=!1,ee()},be);return{isTriggered:()=>ve,dispose:()=>{clearTimeout(Ae),ve=!1}}},R=be=>{let ee=!0;return queueMicrotask(()=>{ee&&(ee=!1,be())}),{isTriggered:()=>ee,dispose:()=>{ee=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class l{constructor(ee){this.defaultDelay=ee,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(ee,ve=this.defaultDelay){this.task=ee,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Fe,$e)=>{this.doResolve=Fe,this.doReject=$e}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Fe=this.task;return this.task=null,Fe()}}));const Ae=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=ve===e.MicrotaskDelay?R(Ae):g(ve,Ae),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new v.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=l;class w{constructor(ee){this.delayer=new l(ee),this.throttler=new h}trigger(ee,ve){return this.delayer.trigger(()=>this.throttler.queue(ee),ve)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=w;class s{constructor(){this._isOpen=!1,this._promise=new Promise((ee,ve)=>{this._completePromise=ee})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=s;class u extends s{constructor(ee){super();this._timeout=setTimeout(()=>this.open(),ee)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=u;function n(be,ee){return ee?new Promise((ve,Ae)=>{const Fe=setTimeout(()=>{$e.dispose(),ve()},be),$e=ee.onCancellationRequested(()=>{clearTimeout(Fe),$e.dispose(),Ae(new v.CancellationError)})}):T(ve=>n(be,ve))}e.timeout=n;function i(be,ee=0){const ve=setTimeout(be,ee);return(0,M.toDisposable)(()=>clearTimeout(ve))}e.disposableTimeout=i;function r(be){const ee=[];let ve=0;const Ae=be.length;function Fe(){return ve<Ae?be[ve++]():null}function $e(Qe){Qe!=null&&ee.push(Qe);const Ie=Fe();return Ie?Ie.then($e):Promise.resolve(ee)}return Promise.resolve(null).then($e)}e.sequence=r;function t(be,ee=Ae=>!!Ae,ve=null){let Ae=0;const Fe=be.length,$e=()=>{if(Ae>=Fe)return Promise.resolve(ve);const Qe=be[Ae++];return Promise.resolve(Qe()).then(Se=>ee(Se)?Promise.resolve(Se):$e())};return $e()}e.first=t;function c(be,ee=Ae=>!!Ae,ve=null){if(be.length===0)return Promise.resolve(ve);let Ae=be.length;const Fe=()=>{Ae=-1;for(const $e of be)$e.cancel?.()};return new Promise(($e,Qe)=>{for(const Ie of be)Ie.then(Se=>{--Ae>=0&&ee(Se)?(Fe(),$e(Se)):Ae===0&&$e(ve)}).catch(Se=>{--Ae>=0&&(Fe(),Qe(Se))})})}e.firstParallel=c;class _{constructor(ee){this._size=0,this.maxDegreeOfParalellism=ee,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new b.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(ee){return this._size++,new Promise((ve,Ae)=>{this.outstandingPromises.push({factory:ee,c:ve,e:Ae}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const ee=this.outstandingPromises.shift();this.runningPromises++;const ve=ee.factory();ve.then(ee.c,ee.e),ve.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=_;class p extends _{constructor(){super(1)}}e.Queue=p;class C{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const ee=new Z;return this.drainers.add(ee),ee.p}isDrained(){for(const[,ee]of this.queues)if(ee.size>0)return!1;return!0}queueFor(ee,ve=D.extUri){const Ae=ve.getComparisonKey(ee);let Fe=this.queues.get(Ae);return Fe||(Fe=new p,b.Event.once(Fe.onDrained)(()=>{Fe?.dispose(),this.queues.delete(Ae),this.onDidQueueDrain()}),this.queues.set(Ae,Fe)),Fe}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const ee of this.drainers)ee.complete();this.drainers.clear()}dispose(){for(const[,ee]of this.queues)ee.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=C;class U{constructor(ee,ve){this._token=-1,typeof ee=="function"&&typeof ve=="number"&&this.setIfNotSet(ee,ve)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(ee,ve){this.cancel(),this._token=setTimeout(()=>{this._token=-1,ee()},ve)}setIfNotSet(ee,ve){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,ee()},ve))}}e.TimeoutTimer=U;class W{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(ee,ve){this.cancel(),this._token=setInterval(()=>{ee()},ve)}}e.IntervalTimer=W;class L{constructor(ee,ve){this.timeoutToken=-1,this.runner=ee,this.timeout=ve,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(ee=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,ee)}get delay(){return this.timeout}set delay(ee){this.timeout=ee}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=L;class S{constructor(ee,ve){ve%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ve}ms is not a multiple of 1000ms.`),this.runner=ee,this.timeout=ve,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(ee=this.timeout){ee%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ee}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(ee/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=S;class z extends L{constructor(ee,ve){super(ee,ve);this.units=[]}work(ee){this.units.push(ee),this.isScheduled()||this.schedule()}doRun(){const ee=this.units;this.units=[],this.runner?.(ee)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=z;class $ extends M.Disposable{constructor(ee,ve){super();this.options=ee,this.handler=ve,this.pendingWork=[],this.throttler=this._register(new M.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(ee){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+ee.length>this.options.maxBufferedWork)return!1}else if(this.pending+ee.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...ee),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new L(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=$,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=be=>{(0,P.setTimeout0)(()=>{if(ee)return;const ve=Date.now()+15;be(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ve-Date.now())}}))});let ee=!1;return{dispose(){ee||(ee=!0)}}}:e.runWhenIdle=(be,ee)=>{const ve=requestIdleCallback(be,typeof ee=="number"?{timeout:ee}:void 0);let Ae=!1;return{dispose(){Ae||(Ae=!0,cancelIdleCallback(ve))}}}}();class F{constructor(ee){this._didRun=!1,this._executor=()=>{try{this._value=ee()}catch(ve){this._error=ve}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=F;async function q(be,ee,ve){let Ae;for(let Fe=0;Fe<ve;Fe++)try{return await be()}catch($e){Ae=$e,await n(ee)}throw Ae}e.retry=q;class ie{hasPending(ee){return this._pending?typeof ee=="number"?this._pending.taskId===ee:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(ee,ve,Ae){return this._pending={taskId:ee,cancel:()=>Ae?.(),promise:ve},ve.then(()=>this.donePending(ee),()=>this.donePending(ee)),ve}donePending(ee){this._pending&&ee===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const ee=this._next;this._next=void 0,ee.run().then(ee.promiseResolve,ee.promiseReject)}}setNext(ee){if(this._next)this._next.run=ee;else{let ve,Ae;const Fe=new Promise(($e,Qe)=>{ve=$e,Ae=Qe});this._next={run:ee,promise:Fe,promiseResolve:ve,promiseReject:Ae}}return this._next.promise}}e.TaskSequentializer=ie;class A{constructor(ee,ve=()=>Date.now()){this.interval=ee,this.nowFn=ve,this.lastIncrementTime=0,this.value=0}increment(){const ee=this.nowFn();return ee-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=ee,this.value=0),this.value++,this.value}}e.IntervalCounter=A;class Z{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((ee,ve)=>{this.completeCallback=ee,this.errorCallback=ve})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(ee){return new Promise(ve=>{this.completeCallback(ee),this.resolved=!0,ve()})}error(ee){return new Promise(ve=>{this.errorCallback(ee),this.rejected=!0,ve()})}cancel(){new Promise(ee=>{this.errorCallback(new v.CancellationError),this.rejected=!0,ee()})}}e.DeferredPromise=Z;var le;(function(be){async function ee(Ae){let Fe;const $e=await Promise.all(Ae.map(Qe=>Qe.then(Ie=>Ie,Ie=>{Fe||(Fe=Ie)})));if(typeof Fe!="undefined")throw Fe;return $e}be.settled=ee;function ve(Ae){return new Promise(async(Fe,$e)=>{try{await Ae(Fe,$e)}catch(Qe){$e(Qe)}})}be.withAsyncBody=ve})(le=e.Promises||(e.Promises={}));var oe;(function(be){be[be.Initial=0]="Initial",be[be.DoneOK=1]="DoneOK",be[be.DoneError=2]="DoneError"})(oe||(oe={}));class ue{constructor(ee){this._state=0,this._results=[],this._error=null,this._onStateChanged=new b.Emitter,queueMicrotask(async()=>{const ve={emitOne:Ae=>this.emitOne(Ae),emitMany:Ae=>this.emitMany(Ae),reject:Ae=>this.reject(Ae)};try{await Promise.resolve(ee(ve)),this.resolve()}catch(Ae){this.reject(Ae)}finally{ve.emitOne=void 0,ve.emitMany=void 0,ve.reject=void 0}})}static fromArray(ee){return new ue(ve=>{ve.emitMany(ee)})}static fromPromise(ee){return new ue(async ve=>{ve.emitMany(await ee)})}static fromPromises(ee){return new ue(async ve=>{await Promise.all(ee.map(async Ae=>ve.emitOne(await Ae)))})}static merge(ee){return new ue(async ve=>{await Promise.all(ee.map(async Ae=>{for await(const Fe of Ae)ve.emitOne(Fe)}))})}[Symbol.asyncIterator](){let ee=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(ee<this._results.length)return{done:!1,value:this._results[ee++]};if(this._state===1)return{done:!0,value:void 0};await b.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(ee,ve){return new ue(async Ae=>{for await(const Fe of ee)Ae.emitOne(ve(Fe))})}map(ee){return ue.map(this,ee)}static filter(ee,ve){return new ue(async Ae=>{for await(const Fe of ee)ve(Fe)&&Ae.emitOne(Fe)})}filter(ee){return ue.filter(this,ee)}static coalesce(ee){return ue.filter(ee,ve=>!!ve)}coalesce(){return ue.coalesce(this)}static async toPromise(ee){const ve=[];for await(const Ae of ee)ve.push(Ae);return ve}toPromise(){return ue.toPromise(this)}emitOne(ee){this._state===0&&(this._results.push(ee),this._onStateChanged.fire())}emitMany(ee){this._state===0&&(this._results=this._results.concat(ee),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(ee){this._state===0&&(this._state=2,this._error=ee,this._onStateChanged.fire())}}e.AsyncIterableObject=ue,ue.EMPTY=ue.fromArray([]);class te extends ue{constructor(ee,ve){super(ve);this._source=ee}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=te;function Ee(be){const ee=new a.CancellationTokenSource,ve=be(ee.token);return new te(ee,async Ae=>{const Fe=ee.token.onCancellationRequested(()=>{Fe.dispose(),ee.dispose(),Ae.reject(new v.CancellationError)});try{for await(const $e of ve){if(ee.token.isCancellationRequested)return;Ae.emitOne($e)}Fe.dispose(),ee.dispose()}catch($e){Fe.dispose(),ee.dispose(),Ae.reject($e)}})}e.createCancelableAsyncIterable=Ee}),define(ye[117],De([1,0,14,19]),function(ne,e,a,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const b=new a.IdleValue(()=>{const p=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:p,collatorIsNumeric:p.resolvedOptions().numeric}}),M=new a.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),D=new a.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function P(p,C,U=!1){const W=p||"",L=C||"",S=b.value.collator.compare(W,L);return b.value.collatorIsNumeric&&S===0&&W!==L?W<L?-1:1:S}e.compareFileNames=P;function E(p,C){const U=M.value.collator;return p=p||"",C=C||"",w(U,p,C)}e.compareFileNamesDefault=E;function T(p,C){const U=M.value.collator;return p=p||"",C=C||"",i(p,C)||w(U,p,C)}e.compareFileNamesUpper=T;function O(p,C){const U=M.value.collator;return p=p||"",C=C||"",n(p,C)||w(U,p,C)}e.compareFileNamesLower=O;function y(p,C){return p=p||"",C=C||"",p===C?0:p<C?-1:1}e.compareFileNamesUnicode=y;function m(p,C,U=!1){U||(p=p&&p.toLowerCase(),C=C&&C.toLowerCase());const[W,L]=R(p),[S,z]=R(C);return W!==S?W<S?-1:1:L===z?0:L<z?-1:1}e.noIntlCompareFileNames=m;function k(p,C){const[U,W]=R(p),[L,S]=R(C);let z=b.value.collator.compare(W,S);if(z===0){if(b.value.collatorIsNumeric&&W!==S)return W<S?-1:1;if(z=b.value.collator.compare(U,L),b.value.collatorIsNumeric&&z===0&&U!==L)return U<L?-1:1}return z}e.compareFileExtensions=k;function f(p,C){p=p||"",C=C||"";const U=l(p),W=l(C),L=M.value.collator,S=D.value.collator;return w(S,U,W)||w(L,p,C)}e.compareFileExtensionsDefault=f;function h(p,C){p=p||"",C=C||"";const U=l(p),W=l(C),L=M.value.collator,S=D.value.collator;return w(S,U,W)||i(p,C)||w(L,p,C)}e.compareFileExtensionsUpper=h;function d(p,C){p=p||"",C=C||"";const U=l(p),W=l(C),L=M.value.collator,S=D.value.collator;return w(S,U,W)||n(p,C)||w(L,p,C)}e.compareFileExtensionsLower=d;function o(p,C){p=p||"",C=C||"";const U=l(p).toLowerCase(),W=l(C).toLowerCase();return U!==W?U<W?-1:1:p!==C?p<C?-1:1:0}e.compareFileExtensionsUnicode=o;const g=/^(.*?)(\.([^.]*))?$/;function R(p,C=!1){const U=p?g.exec(p):[];let W=[U&&U[1]||"",U&&U[3]||""];return C&&(!W[0]&&W[1]||W[0]&&W[0].charAt(0)===".")&&(W=[W[0]+"."+W[1],""]),W}function l(p){const C=p?g.exec(p):[];return C&&C[1]&&C[1].charAt(0)!=="."&&C[3]||""}function w(p,C,U){const W=p.compare(C,U);return W!==0?W:C.length!==U.length?C.length<U.length?-1:1:0}function s(p){const C=p.charAt(0);return C.toLocaleUpperCase()!==C}function u(p){const C=p.charAt(0);return C.toLocaleLowerCase()!==C}function n(p,C){return s(p)&&u(C)?-1:u(p)&&s(C)?1:0}function i(p,C){return u(p)&&s(C)?-1:s(p)&&u(C)?1:0}function r(p,C,U=!1){return U||(p=p&&p.toLowerCase(),C=C&&C.toLowerCase()),p===C?0:p<C?-1:1}function t(p,C,U=!1){const W=p.split(v.sep),L=C.split(v.sep),S=W.length-1,z=L.length-1;let $,F;for(let q=0;;q++){if($=S===q,F=z===q,$&&F)return P(W[q],L[q],U);if($)return-1;if(F)return 1;const ie=r(W[q],L[q],U);if(ie!==0)return ie}}e.comparePaths=t;function c(p,C,U){const W=p.toLowerCase(),L=C.toLowerCase(),S=_(p,C,U);if(S)return S;const z=W.endsWith(U),$=L.endsWith(U);if(z!==$)return z?-1:1;const F=P(W,L);return F!==0?F:W.localeCompare(L)}e.compareAnything=c;function _(p,C,U){const W=p.toLowerCase(),L=C.toLowerCase(),S=W.startsWith(U),z=L.startsWith(U);if(S!==z)return S?-1:1;if(S&&z){if(W.length<L.length)return-1;if(W.length>L.length)return 1}return 0}e.compareByPrefix=_}),define(ye[34],De([1,0,16,14,37,25,19,21,9]),function(ne,e,a,v,b,M,D,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function T(){return Object.create(null)}e.getEmptyExpression=T,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const O="[/\\\\]",y="[^/\\\\]",m=/\//g;function k(Z,le){switch(Z){case 0:return"";case 1:return`${y}*?`;default:return`(?:${O}|${y}+${O}${le?`|${O}${y}+`:""})*?`}}function f(Z,le){if(!Z)return[];const oe=[];let ue=!1,te=!1,Ee="";for(const be of Z){switch(be){case le:if(!ue&&!te){oe.push(Ee),Ee="";continue}break;case"{":ue=!0;break;case"}":ue=!1;break;case"[":te=!0;break;case"]":te=!1;break}Ee+=be}return Ee&&oe.push(Ee),oe}e.splitGlobAware=f;function h(Z){if(!Z)return"";let le="";const oe=f(Z,e.GLOB_SPLIT);if(oe.every(ue=>ue===e.GLOBSTAR))le=".*";else{let ue=!1;oe.forEach((te,Ee)=>{if(te===e.GLOBSTAR){if(ue)return;le+=k(2,Ee===oe.length-1)}else{let be=!1,ee="",ve=!1,Ae="";for(const Fe of te){if(Fe!=="}"&&be){ee+=Fe;continue}if(ve&&(Fe!=="]"||!Ae)){let $e;Fe==="-"?$e=Fe:(Fe==="^"||Fe==="!")&&!Ae?$e="^":Fe===e.GLOB_SPLIT?$e="":$e=(0,E.escapeRegExpCharacters)(Fe),Ae+=$e;continue}switch(Fe){case"{":be=!0;continue;case"[":ve=!0;continue;case"}":{le+=`(?:${f(ee,",").map(Ie=>h(Ie)).join("|")})`,be=!1,ee="";break}case"]":{le+="["+Ae+"]",ve=!1,Ae="";break}case"?":le+=y;continue;case"*":le+=k(1);continue;default:le+=(0,E.escapeRegExpCharacters)(Fe)}}Ee<oe.length-1&&(oe[Ee+1]!==e.GLOBSTAR||Ee+2<oe.length)&&(le+=O)}ue=te===e.GLOBSTAR})}return le}const d=/^\*\*\/\*\.[\w\.-]+$/,o=/^\*\*\/([\w\.-]+)\/?$/,g=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,R=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,l=/^\*\*((\/[\w\.-]+)+)\/?$/,w=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,s=new M.LRUCache(1e4),u=function(){return!1},n=function(){return null};function i(Z,le){if(!Z)return n;let oe;typeof Z!="string"?oe=Z.pattern:oe=Z,oe=oe.trim();const ue=`${oe}_${!!le.trimForExclusions}`;let te=s.get(ue);if(te)return r(te,Z);let Ee;return d.test(oe)?te=c(oe.substr(4),oe):(Ee=o.exec(t(oe,le)))?te=_(Ee[1],oe):(le.trimForExclusions?R:g).test(oe)?te=p(oe,le):(Ee=l.exec(t(oe,le)))?te=C(Ee[1].substr(1),oe,!0):(Ee=w.exec(t(oe,le)))?te=C(Ee[1],oe,!1):te=U(oe),s.set(ue,te),r(te,Z)}function r(Z,le){if(typeof le=="string")return Z;const oe=function(ue,te){return(0,b.isEqualOrParent)(ue,le.base,!P.isLinux)?Z(ue.substr(le.base.length+1),te):null};return oe.allBasenames=Z.allBasenames,oe.allPaths=Z.allPaths,oe.basenames=Z.basenames,oe.patterns=Z.patterns,oe}function t(Z,le){return le.trimForExclusions&&Z.endsWith("/**")?Z.substr(0,Z.length-2):Z}function c(Z,le){return function(oe,ue){return typeof oe=="string"&&oe.endsWith(Z)?le:null}}function _(Z,le){const oe=`/${Z}`,ue=`\\${Z}`,te=function(be,ee){return typeof be!="string"?null:ee?ee===Z?le:null:be===Z||be.endsWith(oe)||be.endsWith(ue)?le:null},Ee=[Z];return te.basenames=Ee,te.patterns=[le],te.allBasenames=Ee,te}function p(Z,le){const oe=ie(Z.slice(1,-1).split(",").map(ee=>i(ee,le)).filter(ee=>ee!==n),Z),ue=oe.length;if(!ue)return n;if(ue===1)return oe[0];const te=function(ee,ve){for(let Ae=0,Fe=oe.length;Ae<Fe;Ae++)if(oe[Ae](ee,ve))return Z;return null},Ee=oe.find(ee=>!!ee.allBasenames);Ee&&(te.allBasenames=Ee.allBasenames);const be=oe.reduce((ee,ve)=>ve.allPaths?ee.concat(ve.allPaths):ee,[]);return be.length&&(te.allPaths=be),te}function C(Z,le,oe){const ue=D.sep===D.posix.sep,te=ue?Z:Z.replace(m,D.sep),Ee=D.sep+te,be=D.posix.sep+Z;let ee;return oe?ee=function(ve,Ae){return typeof ve=="string"&&(ve===te||ve.endsWith(Ee)||!ue&&(ve===Z||ve.endsWith(be)))?le:null}:ee=function(ve,Ae){return typeof ve=="string"&&(ve===te||!ue&&ve===Z)?le:null},ee.allPaths=[(oe?"*/":"./")+Z],ee}function U(Z){try{const le=new RegExp(`^${h(Z)}$`);return function(oe){return le.lastIndex=0,typeof oe=="string"&&le.test(oe)?Z:null}}catch{return n}}function W(Z,le,oe){return!Z||typeof le!="string"?!1:L(Z)(le,void 0,oe)}e.match=W;function L(Z,le={}){if(!Z)return u;if(typeof Z=="string"||S(Z)){const oe=i(Z,le);if(oe===n)return u;const ue=function(te,Ee){return!!oe(te,Ee)};return oe.allBasenames&&(ue.allBasenames=oe.allBasenames),oe.allPaths&&(ue.allPaths=oe.allPaths),ue}return F(Z,le)}e.parse=L;function S(Z){const le=Z;return le?typeof le.base=="string"&&typeof le.pattern=="string":!1}e.isRelativePattern=S;function z(Z){return Z.allBasenames||[]}e.getBasenameTerms=z;function $(Z){return Z.allPaths||[]}e.getPathTerms=$;function F(Z,le){const oe=ie(Object.getOwnPropertyNames(Z).map(ee=>q(ee,Z[ee],le)).filter(ee=>ee!==n)),ue=oe.length;if(!ue)return n;if(!oe.some(ee=>!!ee.requiresSiblings)){if(ue===1)return oe[0];const ee=function(Fe,$e){let Qe;for(let Ie=0,Se=oe.length;Ie<Se;Ie++){const ke=oe[Ie](Fe,$e);if(typeof ke=="string")return ke;(0,v.isThenable)(ke)&&(Qe||(Qe=[]),Qe.push(ke))}return Qe?(async()=>{for(const Ie of Qe){const Se=await Ie;if(typeof Se=="string")return Se}return null})():null},ve=oe.find(Fe=>!!Fe.allBasenames);ve&&(ee.allBasenames=ve.allBasenames);const Ae=oe.reduce((Fe,$e)=>$e.allPaths?Fe.concat($e.allPaths):Fe,[]);return Ae.length&&(ee.allPaths=Ae),ee}const te=function(ee,ve,Ae){let Fe,$e;for(let Qe=0,Ie=oe.length;Qe<Ie;Qe++){const Se=oe[Qe];Se.requiresSiblings&&Ae&&(ve||(ve=(0,D.basename)(ee)),Fe||(Fe=ve.substr(0,ve.length-(0,D.extname)(ee).length)));const ke=Se(ee,ve,Fe,Ae);if(typeof ke=="string")return ke;(0,v.isThenable)(ke)&&($e||($e=[]),$e.push(ke))}return $e?(async()=>{for(const Qe of $e){const Ie=await Qe;if(typeof Ie=="string")return Ie}return null})():null},Ee=oe.find(ee=>!!ee.allBasenames);Ee&&(te.allBasenames=Ee.allBasenames);const be=oe.reduce((ee,ve)=>ve.allPaths?ee.concat(ve.allPaths):ee,[]);return be.length&&(te.allPaths=be),te}function q(Z,le,oe){if(le===!1)return n;const ue=i(Z,oe);if(ue===n)return n;if(typeof le=="boolean")return ue;if(le){const te=le.when;if(typeof te=="string"){const Ee=(be,ee,ve,Ae)=>{if(!Ae||!ue(be,ee))return null;const Fe=te.replace("$(basename)",ve),$e=Ae(Fe);return(0,v.isThenable)($e)?$e.then(Qe=>Qe?Z:null):$e?Z:null};return Ee.requiresSiblings=!0,Ee}}return ue}function ie(Z,le){const oe=Z.filter(ee=>!!ee.basenames);if(oe.length<2)return Z;const ue=oe.reduce((ee,ve)=>{const Ae=ve.basenames;return Ae?ee.concat(Ae):ee},[]);let te;if(le){te=[];for(let ee=0,ve=ue.length;ee<ve;ee++)te.push(le)}else te=oe.reduce((ee,ve)=>{const Ae=ve.patterns;return Ae?ee.concat(Ae):ee},[]);const Ee=function(ee,ve){if(typeof ee!="string")return null;if(!ve){let Fe;for(Fe=ee.length;Fe>0;Fe--){const $e=ee.charCodeAt(Fe-1);if($e===47||$e===92)break}ve=ee.substr(Fe)}const Ae=ue.indexOf(ve);return Ae!==-1?te[Ae]:null};Ee.basenames=ue,Ee.patterns=te,Ee.allBasenames=ue;const be=Z.filter(ee=>!ee.basenames);return be.push(Ee),be}function A(Z,le){return(0,a.equals)(Z,le,(oe,ue)=>typeof oe=="string"&&typeof ue=="string"?oe===ue:typeof oe!="string"&&typeof ue!="string"?oe.base===ue.base&&oe.pattern===ue.pattern:!1)}e.patternsEquals=A}),define(ye[75],De([1,0,11,115,22,9,2]),function(ne,e,a,v,b,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var P;(function(d){d[d.Paragraph=0]="Paragraph",d[d.Break=1]="Break"})(P=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class E{constructor(o="",g=!1){if(this.value=o,typeof this.value!="string")throw(0,a.illegalArgument)("value");typeof g=="boolean"?(this.isTrusted=g,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=g.isTrusted??void 0,this.supportThemeIcons=g.supportThemeIcons??!1,this.supportHtml=g.supportHtml??!1)}appendText(o,g=0){return this.value+=m(this.supportThemeIcons?(0,v.escapeIcons)(o):o).replace(/([ \t]+)/g,(R,l)=>"&nbsp;".repeat(l.length)).replace(/\>/gm,"\\>").replace(/\n/g,g===1?`\\
`:`

`),this}appendMarkdown(o){return this.value+=o,this}appendCodeblock(o,g){return this.value+="\n```",this.value+=o,this.value+=`
`,this.value+=g,this.value+="\n```\n",this}appendLink(o,g,R){return this.value+="[",this.value+=this._escape(g,"]"),this.value+="](",this.value+=this._escape(String(o),")"),R&&(this.value+=` "${this._escape(this._escape(R,'"'),")")}"`),this.value+=")",this}_escape(o,g){const R=new RegExp((0,M.escapeRegExpCharacters)(g),"g");return o.replace(R,(l,w)=>o.charAt(w-1)!=="\\"?`\\${l}`:l)}}e.MarkdownString=E;function T(d){return O(d)?!d.value:Array.isArray(d)?d.every(T):!0}e.isEmptyMarkdownString=T;function O(d){return d instanceof E?!0:d&&typeof d=="object"?typeof d.value=="string"&&(typeof d.isTrusted=="boolean"||d.isTrusted===void 0)&&(typeof d.supportThemeIcons=="boolean"||d.supportThemeIcons===void 0):!1}e.isMarkdownString=O;function y(d,o){return d===o?!0:!d||!o?!1:d.value===o.value&&d.isTrusted===o.isTrusted&&d.supportThemeIcons===o.supportThemeIcons&&d.supportHtml===o.supportHtml&&(d.baseUri===o.baseUri||!!d.baseUri&&!!o.baseUri&&(0,b.isEqual)(D.URI.from(d.baseUri),D.URI.from(o.baseUri)))}e.markdownStringEqual=y;function m(d){return d.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=m;function k(d){return d.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=k;function f(d){return d&&d.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=f;function h(d){const o=[],g=d.split("|").map(l=>l.trim());d=g[0];const R=g[1];if(R){const l=/height=(\d+)/.exec(R),w=/width=(\d+)/.exec(R),s=l?l[1]:"",u=w?w[1]:"",n=isFinite(parseInt(u)),i=isFinite(parseInt(s));n&&o.push(`width="${u}"`),i&&o.push(`height="${s}"`)}return{href:d,dimensions:o}}e.parseHrefAndDimensions=h}),define(ye[76],De([1,0,16,37,19,21,22,9]),function(ne,e,a,v,b,M,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function E(n,i){const{os:r,tildify:t,relative:c}=i;if(c){const C=T(n,c,r);if(typeof C=="string")return C}let _=n.fsPath;if(r===1&&!M.isWindows?_=_.replace(/\//g,"\\"):r!==1&&M.isWindows&&(_=_.replace(/\\/g,"/")),r!==1&&t?.userHome){const C=t.userHome.fsPath;let U;n.scheme!==t.userHome.scheme&&n.path.startsWith(b.posix.sep)?U=t.userHome.with({path:n.path}).fsPath:U=n.fsPath,_=m(U,C,r)}return(r===1?b.win32:b.posix).normalize(O(_,r===1))}e.getPathLabel=E;function T(n,i,r){const t=r===1?b.win32:b.posix,c=r===3?D.extUri:D.extUriIgnorePathCase,_=i.getWorkspace(),p=(0,a.firstOrDefault)(_.folders);if(!p)return;n.scheme!==p.uri.scheme&&n.path.startsWith(b.posix.sep)&&(n=p.uri.with({path:n.path}));const C=i.getWorkspaceFolder(n);if(!C)return;let U;if(c.isEqual(C.uri,n)?U="":U=c.relativePath(C.uri,n)??"",U&&(U=t.normalize(U)),_.folders.length>1&&!i.noPrefix){const W=C.name?C.name:c.basenameOrAuthority(C.uri);U=U?`${W} \u2022 ${U}`:W}return U}function O(n,i=M.isWindows){return(0,v.hasDriveLetter)(n,i)?n.charAt(0).toUpperCase()+n.slice(1):n}e.normalizeDriveLetter=O;let y=Object.create(null);function m(n,i,r=M.OS){if(r===1||!n||!i)return n;let t=y.original===i?y.normalized:void 0;t||(t=i,M.isWindows&&(t=(0,v.toSlashes)(t)),t=`${(0,P.rtrim)(t,b.posix.sep)}${b.posix.sep}`,y={original:i,normalized:t});let c=n;return M.isWindows&&(c=(0,v.toSlashes)(c)),(r===3?c.startsWith(t):(0,P.startsWithIgnoreCase)(c,t))?`~/${c.substr(t.length)}`:n}e.tildify=m;function k(n,i){return n.replace(/^~($|\/|\\)/,`${i}$1`)}e.untildify=k;const f="\u2026",h="\\\\",d="~";function o(n,i=b.sep){const r=new Array(n.length);let t=!1;for(let c=0;c<n.length;c++){const _=n[c];if(_===""){r[c]=`.${i}`;continue}if(!_){r[c]=_;continue}t=!0;let p="",C=_;C.indexOf(h)===0?(p=C.substr(0,C.indexOf(h)+h.length),C=C.substr(C.indexOf(h)+h.length)):C.indexOf(i)===0?(p=C.substr(0,C.indexOf(i)+i.length),C=C.substr(C.indexOf(i)+i.length)):C.indexOf(d)===0&&(p=C.substr(0,C.indexOf(d)+d.length),C=C.substr(C.indexOf(d)+d.length));const U=C.split(i);for(let W=1;t&&W<=U.length;W++)for(let L=U.length-W;t&&L>=0;L--){t=!1;let S=U.slice(L,L+W).join(i);for(let z=0;!t&&z<n.length;z++)if(z!==c&&n[z]&&n[z].indexOf(S)>-1){const $=L+W===U.length,F=L>0&&n[z].indexOf(i)>-1?i+S:S,q=n[z].endsWith(F);t=!$||q}if(!t){let z="";(U[0].endsWith(":")||p!=="")&&(L===1&&(L=0,W++,S=U[0]+i+S),L>0&&(z=U[0]+i),z=p+z),L>0&&(z=z+f+i),z=z+S,L+W<U.length&&(z=z+i+f),r[c]=z}}t&&(r[c]=_)}return r}e.shorten=o;var g;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(g||(g={}));function R(n,i=Object.create(null)){const r=[];let t=!1,c="";for(const _ of n)if(_==="$"||t&&_==="{")c&&r.push({value:c,type:g.TEXT}),c="",t=!0;else if(_==="}"&&t){const p=i[c];if(typeof p=="string")p.length&&r.push({value:p,type:g.VARIABLE});else if(p){const C=r[r.length-1];(!C||C.type!==g.SEPARATOR)&&r.push({value:p.label,type:g.SEPARATOR})}c="",t=!1}else c+=_;return c&&!t&&r.push({value:c,type:g.TEXT}),r.filter((_,p)=>{if(_.type===g.SEPARATOR){const C=r[p-1],U=r[p+1];return[C,U].every(W=>W&&(W.type===g.VARIABLE||W.type===g.TEXT)&&W.value.length>0)}return!0}).map(_=>_.value).join("")}e.template=R;function l(n,i){return M.isMacintosh||i?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.isMacintosh?"&":"&&"):n.replace(/&&|&/g,r=>r==="&"?"&&":"&")}e.mnemonicMenuLabel=l;function w(n,i){return M.isMacintosh||i?n.replace(/\(&&\w\)|&&/g,""):M.isWindows?n.replace(/&&|&/g,r=>r==="&"?"&&":"&"):n.replace(/&&/g,"_")}e.mnemonicButtonLabel=w;function s(n){return n.replace(/&/g,"&&")}e.unmnemonicLabel=s;function u(n){const i=n.indexOf("/")!==-1?b.posix:b.win32,r=i.basename(n),t=i.dirname(n);return r.length?{name:r,parentPath:t}:{name:t,parentPath:""}}e.splitName=u}),define(ye[118],De([1,0,2]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function v(O){return O.toJSON()}class b{constructor(y){this._uriTransformer=y}transformIncoming(y){const m=this._uriTransformer.transformIncoming(y);return m===y?y:v(a.URI.from(m))}transformOutgoing(y){const m=this._uriTransformer.transformOutgoing(y);return m===y?y:v(a.URI.from(m))}transformOutgoingURI(y){const m=this._uriTransformer.transformOutgoing(y);return m===y?y:a.URI.from(m)}transformOutgoingScheme(y){return this._uriTransformer.transformOutgoingScheme(y)}}e.URITransformer=b,e.DefaultURITransformer=new class{transformIncoming(O){return O}transformOutgoing(O){return O}transformOutgoingURI(O){return O}transformOutgoingScheme(O){return O}};function M(O,y,m){if(!O||m>200)return null;if(typeof O=="object"){if(O instanceof a.URI)return y.transformOutgoing(O);for(const k in O)if(Object.hasOwnProperty.call(O,k)){const f=M(O[k],y,m+1);f!==null&&(O[k]=f)}}return null}function D(O,y){const m=M(O,y,0);return m===null?O:m}e.transformOutgoingURIs=D;function P(O,y,m,k){if(!O||k>200)return null;if(typeof O=="object"){if(O.$mid===1)return m?a.URI.revive(y.transformIncoming(O)):y.transformIncoming(O);for(const f in O)if(Object.hasOwnProperty.call(O,f)){const h=P(O[f],y,m,k+1);h!==null&&(O[f]=h)}}return null}function E(O,y){const m=P(O,y,!1,0);return m===null?O:m}e.transformIncomingURIs=E;function T(O,y){const m=P(O,y,!0,0);return m===null?O:m}e.transformAndReviveIncomingURIs=T}),define(ye[119],De([1,0,34,19]),function(ne,e,a,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function b(M,D,P,E,T,O){if(Array.isArray(M)){let y=0;for(const m of M){const k=b(m,D,P,E,T,O);if(k===10)return k;k>y&&(y=k)}return y}else{if(typeof M=="string")return E?M==="*"?5:M===P?10:0:0;if(M){const{language:y,pattern:m,scheme:k,hasAccessToAllModels:f,notebookType:h}=M;if(!E&&!f)return 0;h&&T&&(D=T);let d=0;if(k)if(k===D.scheme)d=10;else if(k==="*")d=5;else return 0;if(y)if(y===P)d=10;else if(y==="*")d=Math.max(d,5);else return 0;if(h)if(h===O)d=10;else if(h==="*"&&O!==void 0)d=Math.max(d,5);else return 0;if(m){let o;if(typeof m=="string"?o=m:o={...m,base:(0,v.normalize)(m.base)},o===D.fsPath||(0,a.match)(o,D.fsPath))d=10;else return 0}return d}else return 0}}e.score=b}),define(ye[77],De([1,0,23,21]),function(ne,e,a,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var b;(function(y){y[y.Full=1]="Full",y[y.Delta=2]="Delta"})(b||(b={}));function M(y){for(let m=0,k=y.length;m<k;m+=4){const f=y[m+0],h=y[m+1],d=y[m+2],o=y[m+3];y[m+0]=o,y[m+1]=d,y[m+2]=h,y[m+3]=f}}function D(y){const m=new Uint8Array(y.buffer,y.byteOffset,y.length*4);return v.isLittleEndian()||M(m),a.VSBuffer.wrap(m)}function P(y){const m=y.buffer;if(v.isLittleEndian()||M(m),m.byteOffset%4==0)return new Uint32Array(m.buffer,m.byteOffset,m.length/4);{const k=new Uint8Array(m.byteLength);return k.set(m),new Uint32Array(k.buffer,k.byteOffset,k.length/4)}}function E(y){const m=new Uint32Array(T(y));let k=0;if(m[k++]=y.id,y.type==="full")m[k++]=1,m[k++]=y.data.length,m.set(y.data,k),k+=y.data.length;else{m[k++]=2,m[k++]=y.deltas.length;for(const f of y.deltas)m[k++]=f.start,m[k++]=f.deleteCount,f.data?(m[k++]=f.data.length,m.set(f.data,k),k+=f.data.length):m[k++]=0}return D(m)}e.encodeSemanticTokensDto=E;function T(y){let m=0;if(m+=1+1,y.type==="full")m+=1+y.data.length;else{m+=1,m+=(1+1+1)*y.deltas.length;for(const k of y.deltas)k.data&&(m+=k.data.length)}return m}function O(y){const m=P(y);let k=0;const f=m[k++];if(m[k++]===1){const g=m[k++],R=m.subarray(k,k+g);return k+=g,{id:f,type:"full",data:R}}const d=m[k++],o=[];for(let g=0;g<d;g++){const R=m[k++],l=m[k++],w=m[k++];let s;w>0&&(s=m.subarray(k,k+w),k+=w),o[g]={start:R,deleteCount:l,data:s}}return{id:f,type:"delta",deltas:o}}e.decodeSemanticTokensDto=O}),define(ye[120],De([17,18]),function(ne,e){return ne.create("vs/editor/common/config/editorOptions",e)}),define(ye[121],De([1,0,120,21,122,16,26,109]),function(ne,e,a,v,b,M,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var E;(function(K){K[K.None=0]="None",K[K.Keep=1]="Keep",K[K.Brackets=2]="Brackets",K[K.Advanced=3]="Advanced",K[K.Full=4]="Full"})(E=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class T{constructor(X){this._values=X}hasChanged(X){return this._values[X]}}e.ConfigurationChangedEvent=T;class O{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=O;class y{constructor(X,fe,Ue,He){this.id=X,this.name=fe,this.defaultValue=Ue,this.schema=He}applyUpdate(X,fe){return k(X,fe)}compute(X,fe,Ue){return Ue}}class m{constructor(X,fe){this.newValue=X,this.didChange=fe}}e.ApplyUpdateResult=m;function k(K,X){if(typeof K!="object"||typeof X!="object"||!K||!X)return new m(X,K!==X);if(Array.isArray(K)||Array.isArray(X)){const Ue=Array.isArray(K)&&Array.isArray(X)&&M.equals(K,X);return new m(X,!Ue)}let fe=!1;for(const Ue in X)if(X.hasOwnProperty(Ue)){const He=k(K[Ue],X[Ue]);He.didChange&&(K[Ue]=He.newValue,fe=!0)}return new m(K,fe)}class f{constructor(X){this.schema=void 0,this.id=X,this.name="_never_",this.defaultValue=void 0}applyUpdate(X,fe){return k(X,fe)}validate(X){return this.defaultValue}}class h{constructor(X,fe,Ue,He){this.id=X,this.name=fe,this.defaultValue=Ue,this.schema=He}applyUpdate(X,fe){return k(X,fe)}validate(X){return typeof X=="undefined"?this.defaultValue:X}compute(X,fe,Ue){return Ue}}function d(K,X){return typeof K=="undefined"?X:K==="false"?!1:Boolean(K)}e.boolean=d;class o extends h{constructor(X,fe,Ue,He=void 0){typeof He!="undefined"&&(He.type="boolean",He.default=Ue);super(X,fe,Ue,He)}validate(X){return d(X,this.defaultValue)}}function g(K,X,fe,Ue){if(typeof K=="undefined")return X;let He=parseInt(K,10);return isNaN(He)?X:(He=Math.max(fe,He),He=Math.min(Ue,He),He|0)}e.clampedInt=g;class R extends h{constructor(X,fe,Ue,He,Ze,qe=void 0){typeof qe!="undefined"&&(qe.type="integer",qe.default=Ue,qe.minimum=He,qe.maximum=Ze);super(X,fe,Ue,qe);this.minimum=He,this.maximum=Ze}static clampedInt(X,fe,Ue,He){return g(X,fe,Ue,He)}validate(X){return R.clampedInt(X,this.defaultValue,this.minimum,this.maximum)}}class l extends h{constructor(X,fe,Ue,He,Ze){typeof Ze!="undefined"&&(Ze.type="number",Ze.default=Ue);super(X,fe,Ue,Ze);this.validationFn=He}static clamp(X,fe,Ue){return X<fe?fe:X>Ue?Ue:X}static float(X,fe){if(typeof X=="number")return X;if(typeof X=="undefined")return fe;const Ue=parseFloat(X);return isNaN(Ue)?fe:Ue}validate(X){return this.validationFn(l.float(X,this.defaultValue))}}class w extends h{static string(X,fe){return typeof X!="string"?fe:X}constructor(X,fe,Ue,He=void 0){typeof He!="undefined"&&(He.type="string",He.default=Ue);super(X,fe,Ue,He)}validate(X){return w.string(X,this.defaultValue)}}function s(K,X,fe){return typeof K!="string"||fe.indexOf(K)===-1?X:K}e.stringSet=s;class u extends h{constructor(X,fe,Ue,He,Ze=void 0){typeof Ze!="undefined"&&(Ze.type="string",Ze.enum=He,Ze.default=Ue);super(X,fe,Ue,Ze);this._allowedValues=He}validate(X){return s(X,this.defaultValue,this._allowedValues)}}class n extends y{constructor(X,fe,Ue,He,Ze,qe,We=void 0){typeof We!="undefined"&&(We.type="string",We.enum=Ze,We.default=He);super(X,fe,Ue,We);this._allowedValues=Ze,this._convert=qe}validate(X){return typeof X!="string"?this.defaultValue:this._allowedValues.indexOf(X)===-1?this.defaultValue:this._convert(X)}}function i(K){switch(K){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class r extends y{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[a.localize(0,null),a.localize(1,null),a.localize(2,null)],default:"auto",description:a.localize(3,null)})}validate(X){switch(X){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(X,fe,Ue){return Ue===0?X.accessibilitySupport:Ue}}class t extends y{constructor(){const X={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",X,{"editor.comments.insertSpace":{type:"boolean",default:X.insertSpace,description:a.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:X.ignoreEmptyLines,description:a.localize(5,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{insertSpace:d(fe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:d(fe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var c;(function(K){K[K.Hidden=0]="Hidden",K[K.Blink=1]="Blink",K[K.Smooth=2]="Smooth",K[K.Phase=3]="Phase",K[K.Expand=4]="Expand",K[K.Solid=5]="Solid"})(c=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function _(K){switch(K){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var p;(function(K){K[K.Line=1]="Line",K[K.Block=2]="Block",K[K.Underline=3]="Underline",K[K.LineThin=4]="LineThin",K[K.BlockOutline=5]="BlockOutline",K[K.UnderlineThin=6]="UnderlineThin"})(p=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function C(K){switch(K){case p.Line:return"line";case p.Block:return"block";case p.Underline:return"underline";case p.LineThin:return"line-thin";case p.BlockOutline:return"block-outline";case p.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=C;function U(K){switch(K){case"line":return p.Line;case"block":return p.Block;case"underline":return p.Underline;case"line-thin":return p.LineThin;case"block-outline":return p.BlockOutline;case"underline-thin":return p.UnderlineThin}}class W extends f{constructor(){super(130)}compute(X,fe,Ue){const He=["monaco-editor"];return fe.get(35)&&He.push(fe.get(35)),X.extraEditorClassName&&He.push(X.extraEditorClassName),fe.get(68)==="default"?He.push("mouse-default"):fe.get(68)==="copy"&&He.push("mouse-copy"),fe.get(102)&&He.push("showUnused"),fe.get(128)&&He.push("showDeprecated"),He.join(" ")}}class L extends o{constructor(){super(33,"emptySelectionClipboard",!0,{description:a.localize(6,null)})}compute(X,fe,Ue){return Ue&&X.emptySelectionClipboard}}class S extends y{constructor(){const X={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(37,"find",X,{"editor.find.cursorMoveOnType":{type:"boolean",default:X.cursorMoveOnType,description:a.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:X.seedSearchStringFromSelection,enumDescriptions:[a.localize(8,null),a.localize(9,null),a.localize(10,null)],description:a.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:X.autoFindInSelection,enumDescriptions:[a.localize(12,null),a.localize(13,null),a.localize(14,null)],description:a.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:X.globalFindClipboard,description:a.localize(16,null),included:v.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:X.addExtraSpaceOnTop,description:a.localize(17,null)},"editor.find.loop":{type:"boolean",default:X.loop,description:a.localize(18,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{cursorMoveOnType:d(fe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof X.seedSearchStringFromSelection=="boolean"?X.seedSearchStringFromSelection?"always":"never":s(fe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof X.autoFindInSelection=="boolean"?X.autoFindInSelection?"always":"never":s(fe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:d(fe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:d(fe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:d(fe.loop,this.defaultValue.loop)}}}class z extends y{constructor(){super(47,"fontLigatures",z.OFF,{anyOf:[{type:"boolean",description:a.localize(19,null)},{type:"string",description:a.localize(20,null)}],description:a.localize(21,null),default:!1})}validate(X){return typeof X=="undefined"?this.defaultValue:typeof X=="string"?X==="false"?z.OFF:X==="true"?z.ON:X:Boolean(X)?z.ON:z.OFF}}e.EditorFontLigatures=z,z.OFF='"liga" off, "calt" off',z.ON='"liga" on, "calt" on';class $ extends f{constructor(){super(46)}compute(X,fe,Ue){return X.fontInfo}}class F extends h{constructor(){super(48,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:a.localize(22,null)})}validate(X){const fe=l.float(X,this.defaultValue);return fe===0?e.EDITOR_FONT_DEFAULTS.fontSize:l.clamp(fe,6,100)}compute(X,fe,Ue){return X.fontInfo.fontSize}}class q extends y{constructor(){super(49,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:q.MINIMUM_VALUE,maximum:q.MAXIMUM_VALUE,errorMessage:a.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:q.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:a.localize(24,null)})}validate(X){return X==="normal"||X==="bold"?X:String(R.clampedInt(X,e.EDITOR_FONT_DEFAULTS.fontWeight,q.MINIMUM_VALUE,q.MAXIMUM_VALUE))}}q.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],q.MINIMUM_VALUE=1,q.MAXIMUM_VALUE=1e3;class ie extends y{constructor(){const X={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},fe={type:"string",enum:["peek","gotoAndPeek","goto"],default:X.multiple,enumDescriptions:[a.localize(25,null),a.localize(26,null),a.localize(27,null)]},Ue=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(53,"gotoLocation",X,{"editor.gotoLocation.multiple":{deprecationMessage:a.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:a.localize(29,null),...fe},"editor.gotoLocation.multipleTypeDefinitions":{description:a.localize(30,null),...fe},"editor.gotoLocation.multipleDeclarations":{description:a.localize(31,null),...fe},"editor.gotoLocation.multipleImplementations":{description:a.localize(32,null),...fe},"editor.gotoLocation.multipleReferences":{description:a.localize(33,null),...fe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:X.alternativeDefinitionCommand,enum:Ue,description:a.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:X.alternativeTypeDefinitionCommand,enum:Ue,description:a.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:X.alternativeDeclarationCommand,enum:Ue,description:a.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:X.alternativeImplementationCommand,enum:Ue,description:a.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:X.alternativeReferenceCommand,enum:Ue,description:a.localize(38,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{multiple:s(fe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:fe.multipleDefinitions??s(fe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:fe.multipleTypeDefinitions??s(fe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:fe.multipleDeclarations??s(fe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:fe.multipleImplementations??s(fe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:fe.multipleReferences??s(fe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:w.string(fe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:w.string(fe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:w.string(fe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:w.string(fe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:w.string(fe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class A extends y{constructor(){const X={enabled:!0,delay:300,sticky:!0,above:!0};super(55,"hover",X,{"editor.hover.enabled":{type:"boolean",default:X.enabled,description:a.localize(39,null)},"editor.hover.delay":{type:"number",default:X.delay,minimum:0,maximum:1e4,description:a.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:X.sticky,description:a.localize(41,null)},"editor.hover.above":{type:"boolean",default:X.above,description:a.localize(42,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{enabled:d(fe.enabled,this.defaultValue.enabled),delay:R.clampedInt(fe.delay,this.defaultValue.delay,0,1e4),sticky:d(fe.sticky,this.defaultValue.sticky),above:d(fe.above,this.defaultValue.above)}}}var Z;(function(K){K[K.None=0]="None",K[K.Text=1]="Text",K[K.Blocks=2]="Blocks"})(Z=e.RenderMinimap||(e.RenderMinimap={}));class le extends f{constructor(){super(133)}compute(X,fe,Ue){return le.computeLayout(fe,{memory:X.memory,outerWidth:X.outerWidth,outerHeight:X.outerHeight,isDominatedByLongLines:X.isDominatedByLongLines,lineHeight:X.fontInfo.lineHeight,viewLineCount:X.viewLineCount,lineNumbersDigitCount:X.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:X.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:X.fontInfo.maxDigitWidth,pixelRatio:X.pixelRatio})}static computeContainedMinimapLineCount(X){const fe=X.height/X.lineHeight,Ue=X.scrollBeyondLastLine?fe-1:0,He=(X.viewLineCount+Ue)/(X.pixelRatio*X.height),Ze=Math.floor(X.viewLineCount/He);return{typicalViewportLineCount:fe,extraLinesBeyondLastLine:Ue,desiredRatio:He,minimapLineCount:Ze}}static _computeMinimapLayout(X,fe){const Ue=X.outerWidth,He=X.outerHeight,Ze=X.pixelRatio;if(!X.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ze*He),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:He};const qe=fe.stableMinimapLayoutInput,We=qe&&X.outerHeight===qe.outerHeight&&X.lineHeight===qe.lineHeight&&X.typicalHalfwidthCharacterWidth===qe.typicalHalfwidthCharacterWidth&&X.pixelRatio===qe.pixelRatio&&X.scrollBeyondLastLine===qe.scrollBeyondLastLine&&X.minimap.enabled===qe.minimap.enabled&&X.minimap.side===qe.minimap.side&&X.minimap.size===qe.minimap.size&&X.minimap.showSlider===qe.minimap.showSlider&&X.minimap.renderCharacters===qe.minimap.renderCharacters&&X.minimap.maxColumn===qe.minimap.maxColumn&&X.minimap.scale===qe.minimap.scale&&X.verticalScrollbarWidth===qe.verticalScrollbarWidth&&X.isViewportWrapping===qe.isViewportWrapping,nt=X.lineHeight,ot=X.typicalHalfwidthCharacterWidth,ht=X.scrollBeyondLastLine,kt=X.minimap.renderCharacters;let it=Ze>=2?Math.round(X.minimap.scale*2):X.minimap.scale;const dt=X.minimap.maxColumn,Ot=X.minimap.size,Wt=X.minimap.side,Dt=X.verticalScrollbarWidth,ft=X.viewLineCount,Ct=X.remainingWidth,Lt=X.isViewportWrapping,Ft=kt?2:3;let Ve=Math.floor(Ze*He);const Nt=Ve/Ze;let Rt=!1,Ut=!1,vt=Ft*it,we=it/Ze,Ce=1;if(Ot==="fill"||Ot==="fit"){const{typicalViewportLineCount:je,extraLinesBeyondLastLine:ut,desiredRatio:gt,minimapLineCount:yt}=le.computeContainedMinimapLineCount({viewLineCount:ft,scrollBeyondLastLine:ht,height:He,lineHeight:nt,pixelRatio:Ze});if(ft/yt>1)Rt=!0,Ut=!0,it=1,vt=1,we=it/Ze;else{let _t=!1,Pt=it+1;if(Ot==="fit"){const mt=Math.ceil((ft+ut)*vt);Lt&&We&&Ct<=fe.stableFitRemainingWidth?(_t=!0,Pt=fe.stableFitMaxMinimapScale):_t=mt>Ve}if(Ot==="fill"||_t){Rt=!0;const mt=it;vt=Math.min(nt*Ze,Math.max(1,Math.floor(1/gt))),Lt&&We&&Ct<=fe.stableFitRemainingWidth&&(Pt=fe.stableFitMaxMinimapScale),it=Math.min(Pt,Math.max(1,Math.floor(vt/Ft))),it>mt&&(Ce=Math.min(2,it/mt)),we=it/Ze/Ce,Ve=Math.ceil(Math.max(je,ft+ut)*vt),Lt?(fe.stableMinimapLayoutInput=X,fe.stableFitRemainingWidth=Ct,fe.stableFitMaxMinimapScale=it):(fe.stableMinimapLayoutInput=null,fe.stableFitRemainingWidth=0)}}}const me=Math.floor(dt*we),j=Math.min(me,Math.max(0,Math.floor((Ct-Dt-2)*we/(ot+we)))+e.MINIMAP_GUTTER_WIDTH);let Pe=Math.floor(Ze*j);const Le=Pe/Ze;Pe=Math.floor(Pe*Ce);const tt=kt?1:2,Xe=Wt==="left"?0:Ue-j-Dt;return{renderMinimap:tt,minimapLeft:Xe,minimapWidth:j,minimapHeightIsEditorHeight:Rt,minimapIsSampling:Ut,minimapScale:it,minimapLineHeight:vt,minimapCanvasInnerWidth:Pe,minimapCanvasInnerHeight:Ve,minimapCanvasOuterWidth:Le,minimapCanvasOuterHeight:Nt}}static computeLayout(X,fe){const Ue=fe.outerWidth|0,He=fe.outerHeight|0,Ze=fe.lineHeight|0,qe=fe.lineNumbersDigitCount|0,We=fe.typicalHalfwidthCharacterWidth,nt=fe.maxDigitWidth,ot=fe.pixelRatio,ht=fe.viewLineCount,kt=X.get(125),it=kt==="inherit"?X.get(124):kt,dt=it==="inherit"?X.get(120):it,Ot=X.get(123),Wt=X.get(2),Dt=fe.isDominatedByLongLines,ft=X.get(52),Ct=X.get(62).renderType!==0,Lt=X.get(63),Ft=X.get(96),Ve=X.get(67),Nt=X.get(94),Rt=Nt.verticalScrollbarSize,Ut=Nt.verticalHasArrows,vt=Nt.arrowSize,we=Nt.horizontalScrollbarSize,Ce=X.get(60),me=X.get(39),j=X.get(101)!=="never";let Pe;if(typeof Ce=="string"&&/^\d+(\.\d+)?ch$/.test(Ce)){const Ht=parseFloat(Ce.substr(0,Ce.length-2));Pe=R.clampedInt(Ht*We,0,0,1e3)}else Pe=R.clampedInt(Ce,0,0,1e3);me&&j&&(Pe+=16);let Le=0;if(Ct){const Ht=Math.max(qe,Lt);Le=Math.round(Ht*nt)}let tt=0;ft&&(tt=Ze);let Xe=0,je=Xe+tt,ut=je+Le,gt=ut+Pe;const yt=Ue-tt-Le-Pe;let pt=!1,_t=!1,Pt=-1;Wt!==2&&(it==="inherit"&&Dt?(pt=!0,_t=!0):dt==="on"||dt==="bounded"?_t=!0:dt==="wordWrapColumn"&&(Pt=Ot));const mt=le._computeMinimapLayout({outerWidth:Ue,outerHeight:He,lineHeight:Ze,typicalHalfwidthCharacterWidth:We,pixelRatio:ot,scrollBeyondLastLine:Ft,minimap:Ve,verticalScrollbarWidth:Rt,viewLineCount:ht,remainingWidth:yt,isViewportWrapping:_t},fe.memory||new O);mt.renderMinimap!==0&&mt.minimapLeft===0&&(Xe+=mt.minimapWidth,je+=mt.minimapWidth,ut+=mt.minimapWidth,gt+=mt.minimapWidth);const Yt=yt-mt.minimapWidth,Jt=Math.max(1,Math.floor((Yt-Rt-2)/We)),bt=Ut?vt:0;return _t&&(Pt=Math.max(1,Jt),dt==="bounded"&&(Pt=Math.min(Pt,Ot))),{width:Ue,height:He,glyphMarginLeft:Xe,glyphMarginWidth:tt,lineNumbersLeft:je,lineNumbersWidth:Le,decorationsLeft:ut,decorationsWidth:Pe,contentLeft:gt,contentWidth:Yt,minimap:mt,viewportColumn:Jt,isWordWrapMinified:pt,isViewportWrapping:_t,wrappingColumn:Pt,verticalScrollbarWidth:Rt,horizontalScrollbarHeight:we,overviewRuler:{top:bt,width:Rt,height:He-2*bt,right:0}}}}e.EditorLayoutInfoComputer=le;class oe extends y{constructor(){const X={enabled:!0};super(59,"lightbulb",X,{"editor.lightbulb.enabled":{type:"boolean",default:X.enabled,description:a.localize(43,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:d(X.enabled,this.defaultValue.enabled)}}}class ue extends y{constructor(){const X={stickyScroll:{enabled:!1}};super(34,"experimental",X,{"editor.experimental.stickyScroll.enabled":{type:"boolean",default:X.stickyScroll.enabled,description:a.localize(44,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{stickyScroll:{enabled:d(X.stickyScroll?.enabled,this.defaultValue.stickyScroll.enabled)}}}}class te extends y{constructor(){const X={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(129,"inlayHints",X,{"editor.inlayHints.enabled":{type:"string",default:X.enabled,description:a.localize(45,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[a.localize(46,null),a.localize(47,null),a.localize(48,null),a.localize(49,null)]},"editor.inlayHints.fontSize":{type:"number",default:X.fontSize,markdownDescription:a.localize(50,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:X.fontFamily,markdownDescription:a.localize(51,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:X.padding,description:a.localize(52,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return typeof fe.enabled=="boolean"&&(fe.enabled=fe.enabled?"on":"off"),{enabled:s(fe.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:R.clampedInt(fe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:w.string(fe.fontFamily,this.defaultValue.fontFamily),padding:d(fe.padding,this.defaultValue.padding)}}}class Ee extends l{constructor(){super(61,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,X=>l.clamp(X,0,150),{markdownDescription:a.localize(53,null)})}compute(X,fe,Ue){return X.fontInfo.lineHeight}}class be extends y{constructor(){const X={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(67,"minimap",X,{"editor.minimap.enabled":{type:"boolean",default:X.enabled,description:a.localize(54,null)},"editor.minimap.autohide":{type:"boolean",default:X.autohide,description:a.localize(55,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[a.localize(56,null),a.localize(57,null),a.localize(58,null)],default:X.size,description:a.localize(59,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:X.side,description:a.localize(60,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:X.showSlider,description:a.localize(61,null)},"editor.minimap.scale":{type:"number",default:X.scale,minimum:1,maximum:3,enum:[1,2,3],description:a.localize(62,null)},"editor.minimap.renderCharacters":{type:"boolean",default:X.renderCharacters,description:a.localize(63,null)},"editor.minimap.maxColumn":{type:"number",default:X.maxColumn,description:a.localize(64,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{enabled:d(fe.enabled,this.defaultValue.enabled),autohide:d(fe.autohide,this.defaultValue.autohide),size:s(fe.size,this.defaultValue.size,["proportional","fill","fit"]),side:s(fe.side,this.defaultValue.side,["right","left"]),showSlider:s(fe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:d(fe.renderCharacters,this.defaultValue.renderCharacters),scale:R.clampedInt(fe.scale,1,1,3),maxColumn:R.clampedInt(fe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ee(K){return K==="ctrlCmd"?v.isMacintosh?"metaKey":"ctrlKey":"altKey"}class ve extends y{constructor(){super(77,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:a.localize(65,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:a.localize(66,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{top:R.clampedInt(fe.top,0,0,1e3),bottom:R.clampedInt(fe.bottom,0,0,1e3)}}}class Ae extends y{constructor(){const X={enabled:!0,cycle:!1};super(78,"parameterHints",X,{"editor.parameterHints.enabled":{type:"boolean",default:X.enabled,description:a.localize(67,null)},"editor.parameterHints.cycle":{type:"boolean",default:X.cycle,description:a.localize(68,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{enabled:d(fe.enabled,this.defaultValue.enabled),cycle:d(fe.cycle,this.defaultValue.cycle)}}}class Fe extends f{constructor(){super(131)}compute(X,fe,Ue){return X.pixelRatio}}class $e extends y{constructor(){const X={other:"on",comments:"off",strings:"off"},fe=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[a.localize(69,null),a.localize(70,null),a.localize(71,null)]}];super(81,"quickSuggestions",X,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:fe,default:X.strings,description:a.localize(72,null)},comments:{anyOf:fe,default:X.comments,description:a.localize(73,null)},other:{anyOf:fe,default:X.other,description:a.localize(74,null)}},default:X,markdownDescription:a.localize(75,null,"#editor.suggestOnTriggerCharacters#")});this.defaultValue=X}validate(X){if(typeof X=="boolean"){const ot=X?"on":"off";return{comments:ot,strings:ot,other:ot}}if(!X||typeof X!="object")return this.defaultValue;const{other:fe,comments:Ue,strings:He}=X,Ze=["on","inline","off"];let qe,We,nt;return typeof fe=="boolean"?qe=fe?"on":"off":qe=s(fe,this.defaultValue.other,Ze),typeof Ue=="boolean"?We=Ue?"on":"off":We=s(Ue,this.defaultValue.comments,Ze),typeof He=="boolean"?nt=He?"on":"off":nt=s(He,this.defaultValue.strings,Ze),{other:qe,comments:We,strings:nt}}}var Qe;(function(K){K[K.Off=0]="Off",K[K.On=1]="On",K[K.Relative=2]="Relative",K[K.Interval=3]="Interval",K[K.Custom=4]="Custom"})(Qe=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Ie extends y{constructor(){super(62,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[a.localize(76,null),a.localize(77,null),a.localize(78,null),a.localize(79,null)],default:"on",description:a.localize(80,null)})}validate(X){let fe=this.defaultValue.renderType,Ue=this.defaultValue.renderFn;return typeof X!="undefined"&&(typeof X=="function"?(fe=4,Ue=X):X==="interval"?fe=3:X==="relative"?fe=2:X==="on"?fe=1:fe=0),{renderType:fe,renderFn:Ue}}}function Se(K){const X=K.get(89);return X==="editable"?K.get(83):X!=="on"}e.filterValidationDecorations=Se;class ke extends y{constructor(){const X=[],fe={type:"number",description:a.localize(81,null)};super(93,"rulers",X,{type:"array",items:{anyOf:[fe,{type:["object"],properties:{column:fe,color:{type:"string",description:a.localize(82,null),format:"color-hex"}}}]},default:X,description:a.localize(83,null)})}validate(X){if(Array.isArray(X)){const fe=[];for(const Ue of X)if(typeof Ue=="number")fe.push({column:R.clampedInt(Ue,0,0,1e4),color:null});else if(Ue&&typeof Ue=="object"){const He=Ue;fe.push({column:R.clampedInt(He.column,0,0,1e4),color:He.color})}return fe.sort((Ue,He)=>Ue.column-He.column),fe}return this.defaultValue}}function ae(K,X){if(typeof K!="string")return X;switch(K){case"hidden":return 2;case"visible":return 3;default:return 1}}class ce extends y{constructor(){const X={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(94,"scrollbar",X,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[a.localize(84,null),a.localize(85,null),a.localize(86,null)],default:"auto",description:a.localize(87,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[a.localize(88,null),a.localize(89,null),a.localize(90,null)],default:"auto",description:a.localize(91,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:X.verticalScrollbarSize,description:a.localize(92,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:X.horizontalScrollbarSize,description:a.localize(93,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:X.scrollByPage,description:a.localize(94,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X,Ue=R.clampedInt(fe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),He=R.clampedInt(fe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:R.clampedInt(fe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:ae(fe.vertical,this.defaultValue.vertical),horizontal:ae(fe.horizontal,this.defaultValue.horizontal),useShadows:d(fe.useShadows,this.defaultValue.useShadows),verticalHasArrows:d(fe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:d(fe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:d(fe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:d(fe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ue,horizontalSliderSize:R.clampedInt(fe.horizontalSliderSize,Ue,0,1e3),verticalScrollbarSize:He,verticalSliderSize:R.clampedInt(fe.verticalSliderSize,He,0,1e3),scrollByPage:d(fe.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class G extends y{constructor(){const X={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(115,"unicodeHighlight",X,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.nonBasicASCII,description:a.localize(95,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:X.invisibleCharacters,description:a.localize(96,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:X.ambiguousCharacters,description:a.localize(97,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeComments,description:a.localize(98,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeStrings,description:a.localize(99,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:X.allowedCharacters,description:a.localize(100,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:X.allowedLocales,description:a.localize(101,null)}})}applyUpdate(X,fe){let Ue=!1;fe.allowedCharacters&&X&&(D.equals(X.allowedCharacters,fe.allowedCharacters)||(X={...X,allowedCharacters:fe.allowedCharacters},Ue=!0)),fe.allowedLocales&&X&&(D.equals(X.allowedLocales,fe.allowedLocales)||(X={...X,allowedLocales:fe.allowedLocales},Ue=!0));const He=super.applyUpdate(X,fe);return Ue?new m(He.newValue,!0):He}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{nonBasicASCII:H(fe.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:d(fe.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:d(fe.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:H(fe.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:H(fe.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(X.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(X.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(X,fe){if(typeof X!="object"||!X)return fe;const Ue={};for(const[He,Ze]of Object.entries(X))Ze===!0&&(Ue[He]=!0);return Ue}}class Q extends y{constructor(){const X={enabled:!0,mode:"subwordSmart"};super(57,"inlineSuggest",X,{"editor.inlineSuggest.enabled":{type:"boolean",default:X.enabled,description:a.localize(102,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{enabled:d(fe.enabled,this.defaultValue.enabled),mode:s(fe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class I extends y{constructor(){const X={enabled:P.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:P.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",X,{"editor.bracketPairColorization.enabled":{type:"boolean",default:X.enabled,markdownDescription:a.localize(103,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:X.independentColorPoolPerBracketType,description:a.localize(104,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{enabled:d(fe.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:d(fe.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class B extends y{constructor(){const X={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",X,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[a.localize(105,null),a.localize(106,null),a.localize(107,null)],default:X.bracketPairs,description:a.localize(108,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[a.localize(109,null),a.localize(110,null),a.localize(111,null)],default:X.bracketPairsHorizontal,description:a.localize(112,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:X.highlightActiveBracketPair,description:a.localize(113,null)},"editor.guides.indentation":{type:"boolean",default:X.indentation,description:a.localize(114,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[a.localize(115,null),a.localize(116,null),a.localize(117,null)],default:X.highlightActiveIndentation,description:a.localize(118,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{bracketPairs:H(fe.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:H(fe.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:d(fe.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:d(fe.indentation,this.defaultValue.indentation),highlightActiveIndentation:H(fe.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function H(K,X,fe){const Ue=fe.indexOf(K);return Ue===-1?X:fe[Ue]}class V extends y{constructor(){const X={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(108,"suggest",X,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[a.localize(119,null),a.localize(120,null)],default:X.insertMode,description:a.localize(121,null)},"editor.suggest.filterGraceful":{type:"boolean",default:X.filterGraceful,description:a.localize(122,null)},"editor.suggest.localityBonus":{type:"boolean",default:X.localityBonus,description:a.localize(123,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:X.shareSuggestSelections,markdownDescription:a.localize(124,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:X.snippetsPreventQuickSuggestions,description:a.localize(125,null)},"editor.suggest.showIcons":{type:"boolean",default:X.showIcons,description:a.localize(126,null)},"editor.suggest.showStatusBar":{type:"boolean",default:X.showStatusBar,description:a.localize(127,null)},"editor.suggest.preview":{type:"boolean",default:X.preview,description:a.localize(128,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:X.showInlineDetails,description:a.localize(129,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:a.localize(130,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:a.localize(131,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:a.localize(132,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:a.localize(133,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:a.localize(134,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:a.localize(135,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:a.localize(136,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:a.localize(137,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:a.localize(138,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:a.localize(139,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:a.localize(140,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:a.localize(141,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:a.localize(142,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:a.localize(143,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:a.localize(144,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:a.localize(145,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:a.localize(146,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:a.localize(147,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:a.localize(148,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:a.localize(149,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:a.localize(150,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:a.localize(151,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:a.localize(152,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:a.localize(153,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:a.localize(154,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:a.localize(155,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:a.localize(156,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:a.localize(157,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:a.localize(158,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:a.localize(159,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:a.localize(160,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{insertMode:s(fe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:d(fe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:d(fe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:d(fe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:d(fe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:d(fe.showIcons,this.defaultValue.showIcons),showStatusBar:d(fe.showStatusBar,this.defaultValue.showStatusBar),preview:d(fe.preview,this.defaultValue.preview),previewMode:s(fe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:d(fe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:d(fe.showMethods,this.defaultValue.showMethods),showFunctions:d(fe.showFunctions,this.defaultValue.showFunctions),showConstructors:d(fe.showConstructors,this.defaultValue.showConstructors),showDeprecated:d(fe.showDeprecated,this.defaultValue.showDeprecated),showFields:d(fe.showFields,this.defaultValue.showFields),showVariables:d(fe.showVariables,this.defaultValue.showVariables),showClasses:d(fe.showClasses,this.defaultValue.showClasses),showStructs:d(fe.showStructs,this.defaultValue.showStructs),showInterfaces:d(fe.showInterfaces,this.defaultValue.showInterfaces),showModules:d(fe.showModules,this.defaultValue.showModules),showProperties:d(fe.showProperties,this.defaultValue.showProperties),showEvents:d(fe.showEvents,this.defaultValue.showEvents),showOperators:d(fe.showOperators,this.defaultValue.showOperators),showUnits:d(fe.showUnits,this.defaultValue.showUnits),showValues:d(fe.showValues,this.defaultValue.showValues),showConstants:d(fe.showConstants,this.defaultValue.showConstants),showEnums:d(fe.showEnums,this.defaultValue.showEnums),showEnumMembers:d(fe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:d(fe.showKeywords,this.defaultValue.showKeywords),showWords:d(fe.showWords,this.defaultValue.showWords),showColors:d(fe.showColors,this.defaultValue.showColors),showFiles:d(fe.showFiles,this.defaultValue.showFiles),showReferences:d(fe.showReferences,this.defaultValue.showReferences),showFolders:d(fe.showFolders,this.defaultValue.showFolders),showTypeParameters:d(fe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:d(fe.showSnippets,this.defaultValue.showSnippets),showUsers:d(fe.showUsers,this.defaultValue.showUsers),showIssues:d(fe.showIssues,this.defaultValue.showIssues)}}}class se extends y{constructor(){super(104,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:a.localize(161,null),default:!0,type:"boolean"}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:d(X.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class de extends f{constructor(){super(132)}compute(X,fe,Ue){return fe.get(83)?!0:X.tabFocusMode}}var J;(function(K){K[K.None=0]="None",K[K.Same=1]="Same",K[K.Indent=2]="Indent",K[K.DeepIndent=3]="DeepIndent"})(J=e.WrappingIndent||(e.WrappingIndent={}));function pe(K){switch(K){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class ge extends f{constructor(){super(134)}compute(X,fe,Ue){const He=fe.get(133);return{isDominatedByLongLines:X.isDominatedByLongLines,isWordWrapMinified:He.isWordWrapMinified,isViewportWrapping:He.isViewportWrapping,wrappingColumn:He.wrappingColumn}}}class Ne extends y{constructor(){const X={enabled:!0};super(32,"dropIntoEditor",X,{"editor.dropIntoEditor.enabled":{type:"boolean",default:X.enabled,markdownDescription:a.localize(162,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:d(X.enabled,this.defaultValue.enabled)}}}const Be="Consolas, 'Courier New', monospace",Je="Menlo, Monaco, 'Courier New', monospace",Ge="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:v.isMacintosh?Je:v.isLinux?Ge:Be,fontWeight:"normal",fontSize:v.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Te(K){return e.editorOptionsRegistry[K.id]=K,K}var rt;(function(K){K[K.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",K[K.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",K[K.accessibilitySupport=2]="accessibilitySupport",K[K.accessibilityPageSize=3]="accessibilityPageSize",K[K.ariaLabel=4]="ariaLabel",K[K.autoClosingBrackets=5]="autoClosingBrackets",K[K.autoClosingDelete=6]="autoClosingDelete",K[K.autoClosingOvertype=7]="autoClosingOvertype",K[K.autoClosingQuotes=8]="autoClosingQuotes",K[K.autoIndent=9]="autoIndent",K[K.automaticLayout=10]="automaticLayout",K[K.autoSurround=11]="autoSurround",K[K.bracketPairColorization=12]="bracketPairColorization",K[K.guides=13]="guides",K[K.codeLens=14]="codeLens",K[K.codeLensFontFamily=15]="codeLensFontFamily",K[K.codeLensFontSize=16]="codeLensFontSize",K[K.colorDecorators=17]="colorDecorators",K[K.columnSelection=18]="columnSelection",K[K.comments=19]="comments",K[K.contextmenu=20]="contextmenu",K[K.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",K[K.cursorBlinking=22]="cursorBlinking",K[K.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",K[K.cursorStyle=24]="cursorStyle",K[K.cursorSurroundingLines=25]="cursorSurroundingLines",K[K.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",K[K.cursorWidth=27]="cursorWidth",K[K.disableLayerHinting=28]="disableLayerHinting",K[K.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",K[K.domReadOnly=30]="domReadOnly",K[K.dragAndDrop=31]="dragAndDrop",K[K.dropIntoEditor=32]="dropIntoEditor",K[K.emptySelectionClipboard=33]="emptySelectionClipboard",K[K.experimental=34]="experimental",K[K.extraEditorClassName=35]="extraEditorClassName",K[K.fastScrollSensitivity=36]="fastScrollSensitivity",K[K.find=37]="find",K[K.fixedOverflowWidgets=38]="fixedOverflowWidgets",K[K.folding=39]="folding",K[K.foldingStrategy=40]="foldingStrategy",K[K.foldingHighlight=41]="foldingHighlight",K[K.foldingImportsByDefault=42]="foldingImportsByDefault",K[K.foldingMaximumRegions=43]="foldingMaximumRegions",K[K.unfoldOnClickAfterEndOfLine=44]="unfoldOnClickAfterEndOfLine",K[K.fontFamily=45]="fontFamily",K[K.fontInfo=46]="fontInfo",K[K.fontLigatures=47]="fontLigatures",K[K.fontSize=48]="fontSize",K[K.fontWeight=49]="fontWeight",K[K.formatOnPaste=50]="formatOnPaste",K[K.formatOnType=51]="formatOnType",K[K.glyphMargin=52]="glyphMargin",K[K.gotoLocation=53]="gotoLocation",K[K.hideCursorInOverviewRuler=54]="hideCursorInOverviewRuler",K[K.hover=55]="hover",K[K.inDiffEditor=56]="inDiffEditor",K[K.inlineSuggest=57]="inlineSuggest",K[K.letterSpacing=58]="letterSpacing",K[K.lightbulb=59]="lightbulb",K[K.lineDecorationsWidth=60]="lineDecorationsWidth",K[K.lineHeight=61]="lineHeight",K[K.lineNumbers=62]="lineNumbers",K[K.lineNumbersMinChars=63]="lineNumbersMinChars",K[K.linkedEditing=64]="linkedEditing",K[K.links=65]="links",K[K.matchBrackets=66]="matchBrackets",K[K.minimap=67]="minimap",K[K.mouseStyle=68]="mouseStyle",K[K.mouseWheelScrollSensitivity=69]="mouseWheelScrollSensitivity",K[K.mouseWheelZoom=70]="mouseWheelZoom",K[K.multiCursorMergeOverlapping=71]="multiCursorMergeOverlapping",K[K.multiCursorModifier=72]="multiCursorModifier",K[K.multiCursorPaste=73]="multiCursorPaste",K[K.occurrencesHighlight=74]="occurrencesHighlight",K[K.overviewRulerBorder=75]="overviewRulerBorder",K[K.overviewRulerLanes=76]="overviewRulerLanes",K[K.padding=77]="padding",K[K.parameterHints=78]="parameterHints",K[K.peekWidgetDefaultFocus=79]="peekWidgetDefaultFocus",K[K.definitionLinkOpensInPeek=80]="definitionLinkOpensInPeek",K[K.quickSuggestions=81]="quickSuggestions",K[K.quickSuggestionsDelay=82]="quickSuggestionsDelay",K[K.readOnly=83]="readOnly",K[K.renameOnType=84]="renameOnType",K[K.renderControlCharacters=85]="renderControlCharacters",K[K.renderFinalNewline=86]="renderFinalNewline",K[K.renderLineHighlight=87]="renderLineHighlight",K[K.renderLineHighlightOnlyWhenFocus=88]="renderLineHighlightOnlyWhenFocus",K[K.renderValidationDecorations=89]="renderValidationDecorations",K[K.renderWhitespace=90]="renderWhitespace",K[K.revealHorizontalRightPadding=91]="revealHorizontalRightPadding",K[K.roundedSelection=92]="roundedSelection",K[K.rulers=93]="rulers",K[K.scrollbar=94]="scrollbar",K[K.scrollBeyondLastColumn=95]="scrollBeyondLastColumn",K[K.scrollBeyondLastLine=96]="scrollBeyondLastLine",K[K.scrollPredominantAxis=97]="scrollPredominantAxis",K[K.selectionClipboard=98]="selectionClipboard",K[K.selectionHighlight=99]="selectionHighlight",K[K.selectOnLineNumbers=100]="selectOnLineNumbers",K[K.showFoldingControls=101]="showFoldingControls",K[K.showUnused=102]="showUnused",K[K.snippetSuggestions=103]="snippetSuggestions",K[K.smartSelect=104]="smartSelect",K[K.smoothScrolling=105]="smoothScrolling",K[K.stickyTabStops=106]="stickyTabStops",K[K.stopRenderingLineAfter=107]="stopRenderingLineAfter",K[K.suggest=108]="suggest",K[K.suggestFontSize=109]="suggestFontSize",K[K.suggestLineHeight=110]="suggestLineHeight",K[K.suggestOnTriggerCharacters=111]="suggestOnTriggerCharacters",K[K.suggestSelection=112]="suggestSelection",K[K.tabCompletion=113]="tabCompletion",K[K.tabIndex=114]="tabIndex",K[K.unicodeHighlighting=115]="unicodeHighlighting",K[K.unusualLineTerminators=116]="unusualLineTerminators",K[K.useShadowDOM=117]="useShadowDOM",K[K.useTabStops=118]="useTabStops",K[K.wordSeparators=119]="wordSeparators",K[K.wordWrap=120]="wordWrap",K[K.wordWrapBreakAfterCharacters=121]="wordWrapBreakAfterCharacters",K[K.wordWrapBreakBeforeCharacters=122]="wordWrapBreakBeforeCharacters",K[K.wordWrapColumn=123]="wordWrapColumn",K[K.wordWrapOverride1=124]="wordWrapOverride1",K[K.wordWrapOverride2=125]="wordWrapOverride2",K[K.wrappingIndent=126]="wrappingIndent",K[K.wrappingStrategy=127]="wrappingStrategy",K[K.showDeprecated=128]="showDeprecated",K[K.inlayHints=129]="inlayHints",K[K.editorClassName=130]="editorClassName",K[K.pixelRatio=131]="pixelRatio",K[K.tabFocusMode=132]="tabFocusMode",K[K.layoutInfo=133]="layoutInfo",K[K.wrappingInfo=134]="wrappingInfo"})(rt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Te(new o(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:a.localize(163,null)})),acceptSuggestionOnEnter:Te(new u(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",a.localize(164,null),""],markdownDescription:a.localize(165,null)})),accessibilitySupport:Te(new r),accessibilityPageSize:Te(new R(3,"accessibilityPageSize",10,1,1073741824,{description:a.localize(166,null)})),ariaLabel:Te(new w(4,"ariaLabel",a.localize(167,null))),autoClosingBrackets:Te(new u(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(168,null),a.localize(169,null),""],description:a.localize(170,null)})),autoClosingDelete:Te(new u(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",a.localize(171,null),""],description:a.localize(172,null)})),autoClosingOvertype:Te(new u(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",a.localize(173,null),""],description:a.localize(174,null)})),autoClosingQuotes:Te(new u(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(175,null),a.localize(176,null),""],description:a.localize(177,null)})),autoIndent:Te(new n(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],i,{enumDescriptions:[a.localize(178,null),a.localize(179,null),a.localize(180,null),a.localize(181,null),a.localize(182,null)],description:a.localize(183,null)})),automaticLayout:Te(new o(10,"automaticLayout",!1)),autoSurround:Te(new u(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[a.localize(184,null),a.localize(185,null),a.localize(186,null),""],description:a.localize(187,null)})),bracketPairColorization:Te(new I),bracketPairGuides:Te(new B),stickyTabStops:Te(new o(106,"stickyTabStops",!1,{description:a.localize(188,null)})),codeLens:Te(new o(14,"codeLens",!0,{description:a.localize(189,null)})),codeLensFontFamily:Te(new w(15,"codeLensFontFamily","",{description:a.localize(190,null)})),codeLensFontSize:Te(new R(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:a.localize(191,null)})),colorDecorators:Te(new o(17,"colorDecorators",!0,{description:a.localize(192,null)})),columnSelection:Te(new o(18,"columnSelection",!1,{description:a.localize(193,null)})),comments:Te(new t),contextmenu:Te(new o(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Te(new o(21,"copyWithSyntaxHighlighting",!0,{description:a.localize(194,null)})),cursorBlinking:Te(new n(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],_,{description:a.localize(195,null)})),cursorSmoothCaretAnimation:Te(new o(23,"cursorSmoothCaretAnimation",!1,{description:a.localize(196,null)})),cursorStyle:Te(new n(24,"cursorStyle",p.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],U,{description:a.localize(197,null)})),cursorSurroundingLines:Te(new R(25,"cursorSurroundingLines",0,0,1073741824,{description:a.localize(198,null)})),cursorSurroundingLinesStyle:Te(new u(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[a.localize(199,null),a.localize(200,null)],description:a.localize(201,null)})),cursorWidth:Te(new R(27,"cursorWidth",0,0,1073741824,{markdownDescription:a.localize(202,null)})),disableLayerHinting:Te(new o(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Te(new o(29,"disableMonospaceOptimizations",!1)),domReadOnly:Te(new o(30,"domReadOnly",!1)),dragAndDrop:Te(new o(31,"dragAndDrop",!0,{description:a.localize(203,null)})),emptySelectionClipboard:Te(new L),dropIntoEditor:Te(new Ne),experimental:Te(new ue),extraEditorClassName:Te(new w(35,"extraEditorClassName","")),fastScrollSensitivity:Te(new l(36,"fastScrollSensitivity",5,K=>K<=0?5:K,{markdownDescription:a.localize(204,null)})),find:Te(new S),fixedOverflowWidgets:Te(new o(38,"fixedOverflowWidgets",!1)),folding:Te(new o(39,"folding",!0,{description:a.localize(205,null)})),foldingStrategy:Te(new u(40,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[a.localize(206,null),a.localize(207,null)],description:a.localize(208,null)})),foldingHighlight:Te(new o(41,"foldingHighlight",!0,{description:a.localize(209,null)})),foldingImportsByDefault:Te(new o(42,"foldingImportsByDefault",!1,{description:a.localize(210,null)})),foldingMaximumRegions:Te(new R(43,"foldingMaximumRegions",5e3,10,65e3,{description:a.localize(211,null)})),unfoldOnClickAfterEndOfLine:Te(new o(44,"unfoldOnClickAfterEndOfLine",!1,{description:a.localize(212,null)})),fontFamily:Te(new w(45,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:a.localize(213,null)})),fontInfo:Te(new $),fontLigatures2:Te(new z),fontSize:Te(new F),fontWeight:Te(new q),formatOnPaste:Te(new o(50,"formatOnPaste",!1,{description:a.localize(214,null)})),formatOnType:Te(new o(51,"formatOnType",!1,{description:a.localize(215,null)})),glyphMargin:Te(new o(52,"glyphMargin",!0,{description:a.localize(216,null)})),gotoLocation:Te(new ie),hideCursorInOverviewRuler:Te(new o(54,"hideCursorInOverviewRuler",!1,{description:a.localize(217,null)})),hover:Te(new A),inDiffEditor:Te(new o(56,"inDiffEditor",!1)),letterSpacing:Te(new l(58,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,K=>l.clamp(K,-5,20),{description:a.localize(218,null)})),lightbulb:Te(new oe),lineDecorationsWidth:Te(new h(60,"lineDecorationsWidth",10)),lineHeight:Te(new Ee),lineNumbers:Te(new Ie),lineNumbersMinChars:Te(new R(63,"lineNumbersMinChars",5,1,300)),linkedEditing:Te(new o(64,"linkedEditing",!1,{description:a.localize(219,null)})),links:Te(new o(65,"links",!0,{description:a.localize(220,null)})),matchBrackets:Te(new u(66,"matchBrackets","always",["always","near","never"],{description:a.localize(221,null)})),minimap:Te(new be),mouseStyle:Te(new u(68,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Te(new l(69,"mouseWheelScrollSensitivity",1,K=>K===0?1:K,{markdownDescription:a.localize(222,null)})),mouseWheelZoom:Te(new o(70,"mouseWheelZoom",!1,{markdownDescription:a.localize(223,null)})),multiCursorMergeOverlapping:Te(new o(71,"multiCursorMergeOverlapping",!0,{description:a.localize(224,null)})),multiCursorModifier:Te(new n(72,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ee,{markdownEnumDescriptions:[a.localize(225,null),a.localize(226,null)],markdownDescription:a.localize(227,null)})),multiCursorPaste:Te(new u(73,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[a.localize(228,null),a.localize(229,null)],markdownDescription:a.localize(230,null)})),occurrencesHighlight:Te(new o(74,"occurrencesHighlight",!0,{description:a.localize(231,null)})),overviewRulerBorder:Te(new o(75,"overviewRulerBorder",!0,{description:a.localize(232,null)})),overviewRulerLanes:Te(new R(76,"overviewRulerLanes",3,0,3)),padding:Te(new ve),parameterHints:Te(new Ae),peekWidgetDefaultFocus:Te(new u(79,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[a.localize(233,null),a.localize(234,null)],description:a.localize(235,null)})),definitionLinkOpensInPeek:Te(new o(80,"definitionLinkOpensInPeek",!1,{description:a.localize(236,null)})),quickSuggestions:Te(new $e),quickSuggestionsDelay:Te(new R(82,"quickSuggestionsDelay",10,0,1073741824,{description:a.localize(237,null)})),readOnly:Te(new o(83,"readOnly",!1)),renameOnType:Te(new o(84,"renameOnType",!1,{description:a.localize(238,null),markdownDeprecationMessage:a.localize(239,null)})),renderControlCharacters:Te(new o(85,"renderControlCharacters",!0,{description:a.localize(240,null),restricted:!0})),renderFinalNewline:Te(new o(86,"renderFinalNewline",!0,{description:a.localize(241,null)})),renderLineHighlight:Te(new u(87,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",a.localize(242,null)],description:a.localize(243,null)})),renderLineHighlightOnlyWhenFocus:Te(new o(88,"renderLineHighlightOnlyWhenFocus",!1,{description:a.localize(244,null)})),renderValidationDecorations:Te(new u(89,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Te(new u(90,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",a.localize(245,null),a.localize(246,null),a.localize(247,null),""],description:a.localize(248,null)})),revealHorizontalRightPadding:Te(new R(91,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Te(new o(92,"roundedSelection",!0,{description:a.localize(249,null)})),rulers:Te(new ke),scrollbar:Te(new ce),scrollBeyondLastColumn:Te(new R(95,"scrollBeyondLastColumn",4,0,1073741824,{description:a.localize(250,null)})),scrollBeyondLastLine:Te(new o(96,"scrollBeyondLastLine",!0,{description:a.localize(251,null)})),scrollPredominantAxis:Te(new o(97,"scrollPredominantAxis",!0,{description:a.localize(252,null)})),selectionClipboard:Te(new o(98,"selectionClipboard",!0,{description:a.localize(253,null),included:v.isLinux})),selectionHighlight:Te(new o(99,"selectionHighlight",!0,{description:a.localize(254,null)})),selectOnLineNumbers:Te(new o(100,"selectOnLineNumbers",!0)),showFoldingControls:Te(new u(101,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[a.localize(255,null),a.localize(256,null),a.localize(257,null)],description:a.localize(258,null)})),showUnused:Te(new o(102,"showUnused",!0,{description:a.localize(259,null)})),showDeprecated:Te(new o(128,"showDeprecated",!0,{description:a.localize(260,null)})),inlayHints:Te(new te),snippetSuggestions:Te(new u(103,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[a.localize(261,null),a.localize(262,null),a.localize(263,null),a.localize(264,null)],description:a.localize(265,null)})),smartSelect:Te(new se),smoothScrolling:Te(new o(105,"smoothScrolling",!1,{description:a.localize(266,null)})),stopRenderingLineAfter:Te(new R(107,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Te(new V),inlineSuggest:Te(new Q),suggestFontSize:Te(new R(109,"suggestFontSize",0,0,1e3,{markdownDescription:a.localize(267,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Te(new R(110,"suggestLineHeight",0,0,1e3,{markdownDescription:a.localize(268,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Te(new o(111,"suggestOnTriggerCharacters",!0,{description:a.localize(269,null)})),suggestSelection:Te(new u(112,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[a.localize(270,null),a.localize(271,null),a.localize(272,null)],description:a.localize(273,null)})),tabCompletion:Te(new u(113,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[a.localize(274,null),a.localize(275,null),a.localize(276,null)],description:a.localize(277,null)})),tabIndex:Te(new R(114,"tabIndex",0,-1,1073741824)),unicodeHighlight:Te(new G),unusualLineTerminators:Te(new u(116,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[a.localize(278,null),a.localize(279,null),a.localize(280,null)],description:a.localize(281,null)})),useShadowDOM:Te(new o(117,"useShadowDOM",!0)),useTabStops:Te(new o(118,"useTabStops",!0,{description:a.localize(282,null)})),wordSeparators:Te(new w(119,"wordSeparators",b.USUAL_WORD_SEPARATORS,{description:a.localize(283,null)})),wordWrap:Te(new u(120,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[a.localize(284,null),a.localize(285,null),a.localize(286,null),a.localize(287,null)],description:a.localize(288,null)})),wordWrapBreakAfterCharacters:Te(new w(121,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Te(new w(122,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Te(new R(123,"wordWrapColumn",80,1,1073741824,{markdownDescription:a.localize(289,null)})),wordWrapOverride1:Te(new u(124,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Te(new u(125,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Te(new n(126,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],pe,{enumDescriptions:[a.localize(290,null),a.localize(291,null),a.localize(292,null),a.localize(293,null)],description:a.localize(294,null)})),wrappingStrategy:Te(new u(127,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[a.localize(295,null),a.localize(296,null)],description:a.localize(297,null)})),editorClassName:Te(new W),pixelRatio:Te(new Fe),tabFocusMode:Te(new de),layoutInfo:Te(new le),wrappingInfo:Te(new ge)}}),define(ye[123],De([17,18]),function(ne,e){return ne.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ye[124],De([17,18]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ye[125],De([17,18]),function(ne,e){return ne.create("vs/platform/extensions/common/extensionValidator",e)}),define(ye[126],De([17,18]),function(ne,e){return ne.create("vs/platform/files/common/files",e)}),define(ye[127],De([17,18]),function(ne,e){return ne.create("vs/platform/markers/common/markers",e)}),define(ye[128],De([17,18]),function(ne,e){return ne.create("vs/platform/workspace/common/workspace",e)}),define(ye[129],De([17,18]),function(ne,e){return ne.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ye[130],De([17,18]),function(ne,e){return ne.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ye[131],De([17,18]),function(ne,e){return ne.create("vs/workbench/api/common/extHostProgress",e)}),define(ye[132],De([17,18]),function(ne,e){return ne.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ye[133],De([17,18]),function(ne,e){return ne.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ye[134],De([17,18]),function(ne,e){return ne.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ye[135],De([17,18]),function(ne,e){return ne.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ye[136],De([17,18]),function(ne,e){return ne.create("vs/workbench/common/editor",e)}),define(ye[137],De([17,18]),function(ne,e){return ne.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ye[138],De([17,18]),function(ne,e){return ne.create("vs/workbench/contrib/debug/common/debug",e)}),define(ye[139],De([17,18]),function(ne,e){return ne.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(ye[140],De([17,18]),function(ne,e){return ne.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(ye[141],De([17,18]),function(ne,e){return ne.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ye[142],De([17,18]),function(ne,e){return ne.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(ye[143],De([17,18]),function(ne,e){return ne.create("vs/workbench/services/search/common/queryBuilder",e)}),define(ye[144],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionSource=e.TextEditorSelectionRevealType=e.EditorOpenSource=e.EditorResolution=e.EditorActivation=void 0;var a;(function(P){P[P.ACTIVATE=1]="ACTIVATE",P[P.RESTORE=2]="RESTORE",P[P.PRESERVE=3]="PRESERVE"})(a=e.EditorActivation||(e.EditorActivation={}));var v;(function(P){P[P.PICK=0]="PICK",P[P.DISABLED=1]="DISABLED",P[P.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(v=e.EditorResolution||(e.EditorResolution={}));var b;(function(P){P[P.API=0]="API",P[P.USER=1]="USER"})(b=e.EditorOpenSource||(e.EditorOpenSource={}));var M;(function(P){P[P.Center=0]="Center",P[P.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",P[P.NearTop=2]="NearTop",P[P.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(M=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}));var D;(function(P){P.PROGRAMMATIC="api",P.NAVIGATION="code.navigation",P.JUMP="code.jump"})(D=e.TextEditorSelectionSource||(e.TextEditorSelectionSource={}))}),define(ye[145],De([1,0,22,29,125,240]),function(ne,e,a,v,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function E(o){return o=o.trim(),o==="*"||D.test(o)}e.isValidVersionStr=E;function T(o){if(!E(o))return null;if(o=o.trim(),o==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const g=o.match(D);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.parseVersion=T;function O(o){if(!o)return null;const g=o.majorBase,R=o.majorMustEqual,l=o.minorBase;let w=o.minorMustEqual;const s=o.patchBase;let u=o.patchMustEqual;o.hasCaret&&(g===0||(w=!1),u=!1);let n=0;if(o.preRelease){const i=P.exec(o.preRelease);if(i){const[,r,t,c]=i;n=Date.UTC(Number(r),Number(t)-1,Number(c))}}return{majorBase:g,majorMustEqual:R,minorBase:l,minorMustEqual:w,patchBase:s,patchMustEqual:u,isMinimum:o.hasGreaterEquals,notBefore:n}}e.normalizeVersion=O;function y(o,g,R){let l;typeof o=="string"?l=O(T(o)):l=o;let w;g instanceof Date?w=g.getTime():typeof g=="string"&&(w=new Date(g).getTime());let s;if(typeof R=="string"?s=O(T(R)):s=R,!l||!s)return!1;const u=l.majorBase,n=l.minorBase,i=l.patchBase;let r=s.majorBase,t=s.minorBase,c=s.patchBase;const _=s.notBefore;let p=s.majorMustEqual,C=s.minorMustEqual,U=s.patchMustEqual;return s.isMinimum?u>r?!0:u<r?!1:n>t?!0:n<t||w&&w<_?!1:i>=c:(u===1&&r===0&&(!p||!C||!U)&&(r=1,t=0,c=0,p=!0,C=!1,U=!1),u<r?!1:u>r?!p:n<t?!1:n>t?!C:i<c?!1:i>c?!U:!(w&&w<_))}e.isValidVersion=y;function m(o,g,R,l,w){const s=[];if(typeof l.publisher!="undefined"&&typeof l.publisher!="string")return s.push([v.default.Error,b.localize(0,null)]),s;if(typeof l.name!="string")return s.push([v.default.Error,b.localize(1,null,"name")]),s;if(typeof l.version!="string")return s.push([v.default.Error,b.localize(2,null,"version")]),s;if(!l.engines)return s.push([v.default.Error,b.localize(3,null,"engines")]),s;if(typeof l.engines.vscode!="string")return s.push([v.default.Error,b.localize(4,null,"engines.vscode")]),s;if(typeof l.extensionDependencies!="undefined"&&!d(l.extensionDependencies))return s.push([v.default.Error,b.localize(5,null,"extensionDependencies")]),s;if(typeof l.activationEvents!="undefined"){if(!d(l.activationEvents))return s.push([v.default.Error,b.localize(6,null,"activationEvents")]),s;if(typeof l.main=="undefined"&&typeof l.browser=="undefined")return s.push([v.default.Error,b.localize(7,null,"activationEvents","main")]),s}if(typeof l.extensionKind!="undefined"&&typeof l.main=="undefined"&&s.push([v.default.Warning,b.localize(8,null,"extensionKind")]),typeof l.main!="undefined"){if(typeof l.main!="string")return s.push([v.default.Error,b.localize(9,null,"main")]),s;{const i=(0,a.joinPath)(R,l.main);(0,a.isEqualOrParent)(i,R)||s.push([v.default.Warning,b.localize(10,null,i.path,R.path)])}if(typeof l.activationEvents=="undefined")return s.push([v.default.Error,b.localize(11,null,"activationEvents","main")]),s}if(typeof l.browser!="undefined"){if(typeof l.browser!="string")return s.push([v.default.Error,b.localize(12,null,"browser")]),s;{const i=(0,a.joinPath)(R,l.browser);(0,a.isEqualOrParent)(i,R)||s.push([v.default.Warning,b.localize(13,null,i.path,R.path)])}if(typeof l.activationEvents=="undefined")return s.push([v.default.Error,b.localize(14,null,"activationEvents","browser")]),s}if(!M.valid(l.version))return s.push([v.default.Error,b.localize(15,null)]),s;const u=[];if(!k(o,g,l,w,u))for(const i of u)s.push([v.default.Error,i]);return s}e.validateExtensionManifest=m;function k(o,g,R,l,w){return l||typeof R.main=="undefined"&&typeof R.browser=="undefined"?!0:h(o,g,R.engines.vscode,w)}e.isValidExtensionVersion=k;function f(o,g,R){return o==="*"||h(g,R,o)}e.isEngineValid=f;function h(o,g,R,l=[]){const w=O(T(R));if(!w)return l.push(b.localize(16,null,R)),!1;if(w.majorBase===0){if(!w.majorMustEqual||!w.minorMustEqual)return l.push(b.localize(17,null,R)),!1}else if(!w.majorMustEqual)return l.push(b.localize(18,null,R)),!1;return y(o,g,w)?!0:(l.push(b.localize(19,null,o,R)),!1)}function d(o){if(!Array.isArray(o))return!1;for(let g=0,R=o.length;g<R;g++)if(typeof o[g]!="string")return!1;return!0}}),define(ye[78],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class a{constructor(b,M=[],D=!1){this.ctor=b,this.staticArguments=M,this.supportsDelayedInstantiation=D}}e.SyncDescriptor=a}),define(ye[56],De([1,0,78]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const v=[];function b(D,P,E){P instanceof a.SyncDescriptor||(P=new a.SyncDescriptor(P,[],E)),v.push([D,P])}e.registerSingleton=b;function M(){return v}e.getSingletonServiceDescriptors=M}),define(ye[146],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class a{constructor(M){this.incoming=new Map,this.outgoing=new Map,this.data=M}}e.Node=a;class v{constructor(M){this._hashFn=M,this._nodes=new Map}roots(){const M=[];for(const D of this._nodes.values())D.outgoing.size===0&&M.push(D);return M}insertEdge(M,D){const P=this.lookupOrInsertNode(M),E=this.lookupOrInsertNode(D);P.outgoing.set(this._hashFn(D),E),E.incoming.set(this._hashFn(M),P)}removeNode(M){const D=this._hashFn(M);this._nodes.delete(D);for(const P of this._nodes.values())P.outgoing.delete(D),P.incoming.delete(D)}lookupOrInsertNode(M){const D=this._hashFn(M);let P=this._nodes.get(D);return P||(P=new a(M),this._nodes.set(D,P)),P}lookup(M){return this._nodes.get(this._hashFn(M))}isEmpty(){return this._nodes.size===0}toString(){const M=[];for(const[D,P]of this._nodes)M.push(`${D}, (incoming)[${[...P.incoming.keys()].join(", ")}], (outgoing)[${[...P.outgoing.keys()].join(",")}]`);return M.join(`
`)}findCycleSlow(){for(const[M,D]of this._nodes){const P=new Set([M]),E=this._findCycle(D,P);if(E)return E}}_findCycle(M,D){for(const[P,E]of M.outgoing){if(D.has(P))return[...D,P].join(" -> ");D.add(P);const T=this._findCycle(E,D);if(T)return T;D.delete(P)}}}e.Graph=v}),define(ye[3],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var a;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function P(E){return E[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=P})(a=e._util||(e._util={})),e.IInstantiationService=b("instantiationService");function v(D,P,E){P[a.DI_TARGET]===P?P[a.DI_DEPENDENCIES].push({id:D,index:E}):(P[a.DI_DEPENDENCIES]=[{id:D,index:E}],P[a.DI_TARGET]=P)}function b(D){if(a.serviceIds.has(D))return a.serviceIds.get(D);const P=function(E,T,O){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");v(P,E,O)};return P.toString=()=>D,a.serviceIds.set(D,P),P}e.createDecorator=b;function M(D){return D}e.refineServiceDecorator=M}),define(ye[57],De([1,0,10,2,3]),function(ne,e,a,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,b.createDecorator)("configurationService");function M(o){return o&&typeof o=="object"&&(!o.overrideIdentifier||typeof o.overrideIdentifier=="string")&&(!o.resource||o.resource instanceof v.URI)}e.isConfigurationOverrides=M;function D(o){return o&&typeof o=="object"&&(!o.overrideIdentifiers||Array.isArray(o.overrideIdentifiers))&&!o.overrideIdentifier&&(!o.resource||o.resource instanceof v.URI)}e.isConfigurationUpdateOverrides=D;var P;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.USER=2]="USER",o[o.USER_LOCAL=3]="USER_LOCAL",o[o.USER_REMOTE=4]="USER_REMOTE",o[o.WORKSPACE=5]="WORKSPACE",o[o.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",o[o.DEFAULT=7]="DEFAULT",o[o.MEMORY=8]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function E(o){switch(o){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=E;function T(o,g){const R=Object.create(null);for(const l in o)O(R,l,o[l],g);return R}e.toValuesTree=T;function O(o,g,R,l){const w=g.split("."),s=w.pop();let u=o;for(let n=0;n<w.length;n++){const i=w[n];let r=u[i];switch(typeof r){case"undefined":r=u[i]=Object.create(null);break;case"object":break;default:l(`Ignoring ${g} as ${w.slice(0,n+1).join(".")} is ${JSON.stringify(r)}`);return}u=r}if(typeof u=="object"&&u!==null)try{u[s]=R}catch{l(`Ignoring ${g} as ${w.join(".")} is ${JSON.stringify(u)}`)}else l(`Ignoring ${g} as ${w.join(".")} is ${JSON.stringify(u)}`)}e.addToValueTree=O;function y(o,g){const R=g.split(".");m(o,R)}e.removeFromValueTree=y;function m(o,g){const R=g.shift();if(g.length===0){delete o[R];return}if(Object.keys(o).indexOf(R)!==-1){const l=o[R];typeof l=="object"&&!Array.isArray(l)&&(m(l,g),Object.keys(l).length===0&&delete o[R])}}function k(o,g,R){function l(u,n){let i=u;for(const r of n){if(typeof i!="object"||i===null)return;i=i[r]}return i}const w=g.split("."),s=l(o,w);return typeof s=="undefined"?R:s}e.getConfigurationValue=k;function f(o,g,R){Object.keys(g).forEach(l=>{l!=="__proto__"&&(l in o?a.isObject(o[l])&&a.isObject(g[l])?f(o[l],g[l],R):R&&(o[l]=g[l]):o[l]=g[l])})}e.merge=f;function h(o,g,R){const l=o.inspect(g),w=o.inspect(R);return typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:typeof w.userValue!="undefined"||typeof w.workspaceValue!="undefined"||typeof w.workspaceFolderValue!="undefined"?w.value:l.defaultValue}e.getMigratedSettingValue=h;function d(o){return o.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=d}),define(ye[38],De([1,0,21,9,3]),function(ne,e,a,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const M=new Map;M.set("false",!1),M.set("true",!0),M.set("isMac",a.isMacintosh),M.set("isLinux",a.isLinux),M.set("isWindows",a.isWindows),M.set("isWeb",a.isWeb),M.set("isMacNative",a.isMacintosh&&!a.isWeb),M.set("isEdge",a.isEdge),M.set("isFirefox",a.isFirefox),M.set("isChrome",a.isChrome),M.set("isSafari",a.isSafari);const D=Object.prototype.hasOwnProperty;var P;(function(L){L[L.False=0]="False",L[L.True=1]="True",L[L.Defined=2]="Defined",L[L.Not=3]="Not",L[L.Equals=4]="Equals",L[L.NotEquals=5]="NotEquals",L[L.And=6]="And",L[L.Regex=7]="Regex",L[L.NotRegex=8]="NotRegex",L[L.Or=9]="Or",L[L.In=10]="In",L[L.NotIn=11]="NotIn",L[L.Greater=12]="Greater",L[L.GreaterEquals=13]="GreaterEquals",L[L.Smaller=14]="Smaller",L[L.SmallerEquals=15]="SmallerEquals"})(P=e.ContextKeyExprType||(e.ContextKeyExprType={}));class E{static false(){return y.INSTANCE}static true(){return m.INSTANCE}static has(S){return k.create(S)}static equals(S,z){return f.create(S,z)}static notEquals(S,z){return o.create(S,z)}static regex(S,z){return n.create(S,z)}static in(S,z){return h.create(S,z)}static notIn(S,z){return d.create(S,z)}static not(S){return g.create(S)}static and(...S){return t.create(S,null)}static or(...S){return c.create(S,null,!0)}static greater(S,z){return l.create(S,z)}static greaterEquals(S,z){return w.create(S,z)}static smaller(S,z){return s.create(S,z)}static smallerEquals(S,z){return u.create(S,z)}static deserialize(S,z=!1){if(!!S)return this._deserializeOrExpression(S,z)}static _deserializeOrExpression(S,z){const $=S.split("||");return c.create($.map(F=>this._deserializeAndExpression(F,z)),null,!0)}static _deserializeAndExpression(S,z){const $=S.split("&&");return t.create($.map(F=>this._deserializeOne(F,z)),null)}static _deserializeOne(S,z){if(S=S.trim(),S.indexOf("!=")>=0){const $=S.split("!=");return o.create($[0].trim(),this._deserializeValue($[1],z))}if(S.indexOf("==")>=0){const $=S.split("==");return f.create($[0].trim(),this._deserializeValue($[1],z))}if(S.indexOf("=~")>=0){const $=S.split("=~");return n.create($[0].trim(),this._deserializeRegexValue($[1],z))}if(S.indexOf(" not in ")>=0){const $=S.split(" not in ");return d.create($[0].trim(),$[1].trim())}if(S.indexOf(" in ")>=0){const $=S.split(" in ");return h.create($[0].trim(),$[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(S)){const $=S.split(">=");return w.create($[0].trim(),$[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(S)){const $=S.split(">");return l.create($[0].trim(),$[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(S)){const $=S.split("<=");return u.create($[0].trim(),$[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(S)){const $=S.split("<");return s.create($[0].trim(),$[1].trim())}return/^\!\s*/.test(S)?g.create(S.substr(1).trim()):k.create(S)}static _deserializeValue(S,z){if(S=S.trim(),S==="true")return!0;if(S==="false")return!1;const $=/^'([^']*)'$/.exec(S);return $?$[1].trim():S}static _deserializeRegexValue(S,z){if((0,v.isFalsyOrWhitespace)(S)){if(z)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const $=S.indexOf("/"),F=S.lastIndexOf("/");if($===F||$<0){if(z)throw new Error(`bad regexp-value '${S}', missing /-enclosure`);return console.warn(`bad regexp-value '${S}', missing /-enclosure`),null}const q=S.slice($+1,F),ie=S[F+1]==="i"?"i":"";try{return new RegExp(q,ie)}catch(A){if(z)throw new Error(`bad regexp-value '${S}', parse error: ${A}`);return console.warn(`bad regexp-value '${S}', parse error: ${A}`),null}}}e.ContextKeyExpr=E;function T(L,S){const z=L?L.substituteConstants():void 0,$=S?S.substituteConstants():void 0;return!z&&!$?!0:!z||!$?!1:z.equals($)}e.expressionsAreEqualWithConstantSubstitution=T;function O(L,S){return L.cmp(S)}class y{constructor(){this.type=0}cmp(S){return this.type-S.type}equals(S){return S.type===this.type}substituteConstants(){return this}evaluate(S){return!1}serialize(){return"false"}keys(){return[]}map(S){return this}negate(){return m.INSTANCE}}e.ContextKeyFalseExpr=y,y.INSTANCE=new y;class m{constructor(){this.type=1}cmp(S){return this.type-S.type}equals(S){return S.type===this.type}substituteConstants(){return this}evaluate(S){return!0}serialize(){return"true"}keys(){return[]}map(S){return this}negate(){return y.INSTANCE}}e.ContextKeyTrueExpr=m,m.INSTANCE=new m;class k{constructor(S,z){this.key=S,this.negated=z,this.type=2}static create(S,z=null){const $=M.get(S);return typeof $=="boolean"?$?m.INSTANCE:y.INSTANCE:new k(S,z)}cmp(S){return S.type!==this.type?this.type-S.type:p(this.key,S.key)}equals(S){return S.type===this.type?this.key===S.key:!1}substituteConstants(){const S=M.get(this.key);return typeof S=="boolean"?S?m.INSTANCE:y.INSTANCE:this}evaluate(S){return!!S.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(S){return S.mapDefined(this.key)}negate(){return this.negated||(this.negated=g.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=k;class f{constructor(S,z,$){this.key=S,this.value=z,this.negated=$,this.type=4}static create(S,z,$=null){if(typeof z=="boolean")return z?k.create(S,$):g.create(S,$);const F=M.get(S);return typeof F=="boolean"?z===(F?"true":"false")?m.INSTANCE:y.INSTANCE:new f(S,z,$)}cmp(S){return S.type!==this.type?this.type-S.type:C(this.key,this.value,S.key,S.value)}equals(S){return S.type===this.type?this.key===S.key&&this.value===S.value:!1}substituteConstants(){const S=M.get(this.key);if(typeof S=="boolean"){const z=S?"true":"false";return this.value===z?m.INSTANCE:y.INSTANCE}return this}evaluate(S){return S.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(S){return S.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=o.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=f;class h{constructor(S,z){this.key=S,this.valueKey=z,this.type=10,this.negated=null}static create(S,z){return new h(S,z)}cmp(S){return S.type!==this.type?this.type-S.type:C(this.key,this.valueKey,S.key,S.valueKey)}equals(S){return S.type===this.type?this.key===S.key&&this.valueKey===S.valueKey:!1}substituteConstants(){return this}evaluate(S){const z=S.getValue(this.valueKey),$=S.getValue(this.key);return Array.isArray(z)?z.includes($):typeof $=="string"&&typeof z=="object"&&z!==null?D.call(z,$):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(S){return S.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=d.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=h;class d{constructor(S,z){this.key=S,this.valueKey=z,this.type=11,this._negated=h.create(S,z)}static create(S,z){return new d(S,z)}cmp(S){return S.type!==this.type?this.type-S.type:this._negated.cmp(S._negated)}equals(S){return S.type===this.type?this._negated.equals(S._negated):!1}substituteConstants(){return this}evaluate(S){return!this._negated.evaluate(S)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(S){return S.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=d;class o{constructor(S,z,$){this.key=S,this.value=z,this.negated=$,this.type=5}static create(S,z,$=null){if(typeof z=="boolean")return z?g.create(S,$):k.create(S,$);const F=M.get(S);return typeof F=="boolean"?z===(F?"true":"false")?y.INSTANCE:m.INSTANCE:new o(S,z,$)}cmp(S){return S.type!==this.type?this.type-S.type:C(this.key,this.value,S.key,S.value)}equals(S){return S.type===this.type?this.key===S.key&&this.value===S.value:!1}substituteConstants(){const S=M.get(this.key);if(typeof S=="boolean"){const z=S?"true":"false";return this.value===z?y.INSTANCE:m.INSTANCE}return this}evaluate(S){return S.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(S){return S.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=f.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=o;class g{constructor(S,z){this.key=S,this.negated=z,this.type=3}static create(S,z=null){const $=M.get(S);return typeof $=="boolean"?$?y.INSTANCE:m.INSTANCE:new g(S,z)}cmp(S){return S.type!==this.type?this.type-S.type:p(this.key,S.key)}equals(S){return S.type===this.type?this.key===S.key:!1}substituteConstants(){const S=M.get(this.key);return typeof S=="boolean"?S?y.INSTANCE:m.INSTANCE:this}evaluate(S){return!S.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(S){return S.mapNot(this.key)}negate(){return this.negated||(this.negated=k.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=g;function R(L,S){if(typeof L=="string"){const z=parseFloat(L);isNaN(z)||(L=z)}return typeof L=="string"||typeof L=="number"?S(L):y.INSTANCE}class l{constructor(S,z,$){this.key=S,this.value=z,this.negated=$,this.type=12}static create(S,z,$=null){return R(z,F=>new l(S,F,$))}cmp(S){return S.type!==this.type?this.type-S.type:C(this.key,this.value,S.key,S.value)}equals(S){return S.type===this.type?this.key===S.key&&this.value===S.value:!1}substituteConstants(){return this}evaluate(S){return typeof this.value=="string"?!1:parseFloat(S.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(S){return S.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=l;class w{constructor(S,z,$){this.key=S,this.value=z,this.negated=$,this.type=13}static create(S,z,$=null){return R(z,F=>new w(S,F,$))}cmp(S){return S.type!==this.type?this.type-S.type:C(this.key,this.value,S.key,S.value)}equals(S){return S.type===this.type?this.key===S.key&&this.value===S.value:!1}substituteConstants(){return this}evaluate(S){return typeof this.value=="string"?!1:parseFloat(S.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(S){return S.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=s.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=w;class s{constructor(S,z,$){this.key=S,this.value=z,this.negated=$,this.type=14}static create(S,z,$=null){return R(z,F=>new s(S,F,$))}cmp(S){return S.type!==this.type?this.type-S.type:C(this.key,this.value,S.key,S.value)}equals(S){return S.type===this.type?this.key===S.key&&this.value===S.value:!1}substituteConstants(){return this}evaluate(S){return typeof this.value=="string"?!1:parseFloat(S.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(S){return S.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=w.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=s;class u{constructor(S,z,$){this.key=S,this.value=z,this.negated=$,this.type=15}static create(S,z,$=null){return R(z,F=>new u(S,F,$))}cmp(S){return S.type!==this.type?this.type-S.type:C(this.key,this.value,S.key,S.value)}equals(S){return S.type===this.type?this.key===S.key&&this.value===S.value:!1}substituteConstants(){return this}evaluate(S){return typeof this.value=="string"?!1:parseFloat(S.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(S){return S.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=u;class n{constructor(S,z){this.key=S,this.regexp=z,this.type=7,this.negated=null}static create(S,z){return new n(S,z)}cmp(S){if(S.type!==this.type)return this.type-S.type;if(this.key<S.key)return-1;if(this.key>S.key)return 1;const z=this.regexp?this.regexp.source:"",$=S.regexp?S.regexp.source:"";return z<$?-1:z>$?1:0}equals(S){if(S.type===this.type){const z=this.regexp?this.regexp.source:"",$=S.regexp?S.regexp.source:"";return this.key===S.key&&z===$}return!1}substituteConstants(){return this}evaluate(S){const z=S.getValue(this.key);return this.regexp?this.regexp.test(z):!1}serialize(){const S=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${S}`}keys(){return[this.key]}map(S){return S.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=i.create(this)),this.negated}}e.ContextKeyRegexExpr=n;class i{constructor(S){this._actual=S,this.type=8}static create(S){return new i(S)}cmp(S){return S.type!==this.type?this.type-S.type:this._actual.cmp(S._actual)}equals(S){return S.type===this.type?this._actual.equals(S._actual):!1}substituteConstants(){return this}evaluate(S){return!this._actual.evaluate(S)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(S){return new i(this._actual.map(S))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=i;function r(L){let S=null;for(let z=0,$=L.length;z<$;z++){const F=L[z].substituteConstants();if(L[z]!==F&&S===null){S=[];for(let q=0;q<z;q++)S[q]=L[q]}S!==null&&(S[z]=F)}return S===null?L:S}class t{constructor(S,z){this.expr=S,this.negated=z,this.type=6}static create(S,z){return t._normalizeArr(S,z)}cmp(S){if(S.type!==this.type)return this.type-S.type;if(this.expr.length<S.expr.length)return-1;if(this.expr.length>S.expr.length)return 1;for(let z=0,$=this.expr.length;z<$;z++){const F=O(this.expr[z],S.expr[z]);if(F!==0)return F}return 0}equals(S){if(S.type===this.type){if(this.expr.length!==S.expr.length)return!1;for(let z=0,$=this.expr.length;z<$;z++)if(!this.expr[z].equals(S.expr[z]))return!1;return!0}return!1}substituteConstants(){const S=r(this.expr);return S===this.expr?this:t.create(S,this.negated)}evaluate(S){for(let z=0,$=this.expr.length;z<$;z++)if(!this.expr[z].evaluate(S))return!1;return!0}static _normalizeArr(S,z){const $=[];let F=!1;for(const q of S)if(!!q){if(q.type===1){F=!0;continue}if(q.type===0)return y.INSTANCE;if(q.type===6){$.push(...q.expr);continue}$.push(q)}if($.length===0&&F)return m.INSTANCE;if($.length!==0){if($.length===1)return $[0];$.sort(O);for(let q=1;q<$.length;q++)$[q-1].equals($[q])&&($.splice(q,1),q--);if($.length===1)return $[0];for(;$.length>1;){const q=$[$.length-1];if(q.type!==9)break;$.pop();const ie=$.pop(),A=$.length===0,Z=c.create(q.expr.map(le=>t.create([le,ie],null)),null,A);Z&&($.push(Z),$.sort(O))}return $.length===1?$[0]:new t($,z)}}serialize(){return this.expr.map(S=>S.serialize()).join(" && ")}keys(){const S=[];for(const z of this.expr)S.push(...z.keys());return S}map(S){return new t(this.expr.map(z=>z.map(S)),null)}negate(){if(!this.negated){const S=[];for(const z of this.expr)S.push(z.negate());this.negated=c.create(S,this,!0)}return this.negated}}class c{constructor(S,z){this.expr=S,this.negated=z,this.type=9}static create(S,z,$){return c._normalizeArr(S,z,$)}cmp(S){if(S.type!==this.type)return this.type-S.type;if(this.expr.length<S.expr.length)return-1;if(this.expr.length>S.expr.length)return 1;for(let z=0,$=this.expr.length;z<$;z++){const F=O(this.expr[z],S.expr[z]);if(F!==0)return F}return 0}equals(S){if(S.type===this.type){if(this.expr.length!==S.expr.length)return!1;for(let z=0,$=this.expr.length;z<$;z++)if(!this.expr[z].equals(S.expr[z]))return!1;return!0}return!1}substituteConstants(){const S=r(this.expr);return S===this.expr?this:c.create(S,this.negated,!1)}evaluate(S){for(let z=0,$=this.expr.length;z<$;z++)if(this.expr[z].evaluate(S))return!0;return!1}static _normalizeArr(S,z,$){let F=[],q=!1;if(S){for(let ie=0,A=S.length;ie<A;ie++){const Z=S[ie];if(!!Z){if(Z.type===0){q=!0;continue}if(Z.type===1)return m.INSTANCE;if(Z.type===9){F=F.concat(Z.expr);continue}F.push(Z)}}if(F.length===0&&q)return y.INSTANCE;F.sort(O)}if(F.length!==0){if(F.length===1)return F[0];for(let ie=1;ie<F.length;ie++)F[ie-1].equals(F[ie])&&(F.splice(ie,1),ie--);if(F.length===1)return F[0];if($){for(let ie=0;ie<F.length;ie++)for(let A=ie+1;A<F.length;A++)U(F[ie],F[A])&&(F.splice(A,1),A--);if(F.length===1)return F[0]}return new c(F,z)}}serialize(){return this.expr.map(S=>S.serialize()).join(" || ")}keys(){const S=[];for(const z of this.expr)S.push(...z.keys());return S}map(S){return new c(this.expr.map(z=>z.map(S)),null)}negate(){if(!this.negated){const S=[];for(const z of this.expr)S.push(z.negate());for(;S.length>1;){const z=S.shift(),$=S.shift(),F=[];for(const ie of W(z))for(const A of W($))F.push(t.create([ie,A],null));const q=S.length===0;S.unshift(c.create(F,null,q))}this.negated=S[0]}return this.negated}}class _ extends k{constructor(S,z,$){super(S,null);this._defaultValue=z,typeof $=="object"?_._info.push({...$,key:S}):$!==!0&&_._info.push({key:S,description:$,type:z!=null?typeof z:void 0})}static all(){return _._info.values()}bindTo(S){return S.createKey(this.key,this._defaultValue)}getValue(S){return S.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(S){return f.create(this.key,S)}notEqualsTo(S){return o.create(this.key,S)}}e.RawContextKey=_,_._info=[],e.IContextKeyService=(0,b.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function p(L,S){return L<S?-1:L>S?1:0}function C(L,S,z,$){return L<z?-1:L>z?1:S<$?-1:S>$?1:0}function U(L,S){if(S.type===6&&L.type!==9&&L.type!==6){for(const F of S.expr)if(L.equals(F))return!0}const z=L.negate(),$=W(z).concat(W(S));$.sort(O);for(let F=0;F<$.length;F++){const ie=$[F].negate();for(let A=F+1;A<$.length;A++){const Z=$[A];if(ie.equals(Z))return!0}}return!1}e.implies=U;function W(L){return L.type===9?L.expr:[L]}}),define(ye[147],De([1,0,3]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,a.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,a.refineServiceDecorator)(e.IEnvironmentService)}),define(ye[79],De([1,0,124,3]),function(ne,e,a,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IServerExtensionManagementService=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function b(o){switch(o){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=b;function M(o){switch(o){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=M;function D(o,g){switch(o){case 3:return g==="x64"?"win32-x64":g==="ia32"?"win32-ia32":g==="arm64"?"win32-arm64":"unknown";case 2:return g==="x64"?"linux-x64":g==="arm64"?"linux-arm64":g==="arm"?"linux-armhf":"unknown";case"alpine":return g==="x64"?"alpine-x64":g==="arm64"?"alpine-arm64":"unknown";case 1:return g==="x64"?"darwin-x64":g==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=D;function P(o,g){return g==="web"&&!o.includes("web")}e.isNotWebExtensionInWebTargetPlatform=P;function E(o,g,R){return P(g,R)?!1:o==="undefined"||o==="universal"?!0:o==="unknown"?!1:o===R?!0:T(R).includes(o)}e.isTargetPlatformCompatible=E;function T(o){switch(o){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=T;function O(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(!o.uuid||typeof o.uuid=="string")}e.isIExtensionIdentifier=O;var y;(function(o){o[o.NoneOrRelevance=0]="NoneOrRelevance",o[o.LastUpdatedDate=1]="LastUpdatedDate",o[o.Title=2]="Title",o[o.PublisherName=3]="PublisherName",o[o.InstallCount=4]="InstallCount",o[o.PublishedDate=10]="PublishedDate",o[o.AverageRating=6]="AverageRating",o[o.WeightedRating=12]="WeightedRating"})(y=e.SortBy||(e.SortBy={}));var m;(function(o){o[o.Default=0]="Default",o[o.Ascending=1]="Ascending",o[o.Descending=2]="Descending"})(m=e.SortOrder||(e.SortOrder={}));var k;(function(o){o.Install="install",o.Uninstall="uninstall"})(k=e.StatisticType||(e.StatisticType={}));var f;(function(o){o[o.None=1]="None",o[o.Install=2]="Install",o[o.Update=3]="Update",o[o.Migrate=4]="Migrate"})(f=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,v.createDecorator)("extensionGalleryService");var h;(function(o){o.Unsupported="Unsupported",o.Deprecated="Deprecated",o.Malicious="Malicious",o.Incompatible="Incompatible",o.IncompatiblePreRelease="IncompatiblePreRelease",o.IncompatibleTargetPlatform="IncompatibleTargetPlatform",o.ReleaseVersionNotFound="ReleaseVersionNotFound",o.Invalid="Invalid",o.Download="Download",o.Extract="Extract",o.Delete="Delete",o.Rename="Rename",o.CorruptZip="CorruptZip",o.IncompleteZip="IncompleteZip",o.Internal="Internal"})(h=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class d extends Error{constructor(g,R){super(g);this.code=R,this.name=R}}e.ExtensionManagementError=d,e.IExtensionManagementService=(0,v.createDecorator)("extensionManagementService"),e.IServerExtensionManagementService=(0,v.refineServiceDecorator)(e.IExtensionManagementService),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,v.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,v.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,a.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,a.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,v.createDecorator)("IExtensionManagementCLIService")}),define(ye[39],De([1,0,25,19,9,10,2,126,3]),function(ne,e,a,v,b,M,D,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,E.createDecorator)("fileService");function T(A){return A.create===!0}e.isFileOpenForWriteOptions=T;var O;(function(A){A[A.Unknown=0]="Unknown",A[A.File=1]="File",A[A.Directory=2]="Directory",A[A.SymbolicLink=64]="SymbolicLink"})(O=e.FileType||(e.FileType={}));var y;(function(A){A[A.Readonly=1]="Readonly"})(y=e.FilePermission||(e.FilePermission={}));var m;(function(A){A[A.FileReadWrite=2]="FileReadWrite",A[A.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",A[A.FileReadStream=16]="FileReadStream",A[A.FileFolderCopy=8]="FileFolderCopy",A[A.PathCaseSensitive=1024]="PathCaseSensitive",A[A.Readonly=2048]="Readonly",A[A.Trash=4096]="Trash",A[A.FileWriteUnlock=8192]="FileWriteUnlock",A[A.FileAtomicRead=16384]="FileAtomicRead",A[A.FileClone=32768]="FileClone"})(m=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function k(A){return!!(A.capabilities&2)}e.hasReadWriteCapability=k;function f(A){return!!(A.capabilities&8)}e.hasFileFolderCopyCapability=f;function h(A){return!!(A.capabilities&32768)}e.hasFileCloneCapability=h;function d(A){return!!(A.capabilities&4)}e.hasOpenReadWriteCloseCapability=d;function o(A){return!!(A.capabilities&16)}e.hasFileReadStreamCapability=o;function g(A){return!!(A.capabilities&2048)}e.hasFileReadCapability=g;function R(A){return k(A)?!!(A.capabilities&16384):!1}e.hasFileAtomicReadCapability=R;var l;(function(A){A.FileExists="EntryExists",A.FileNotFound="EntryNotFound",A.FileNotADirectory="EntryNotADirectory",A.FileIsADirectory="EntryIsADirectory",A.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",A.FileTooLarge="EntryTooLarge",A.FileWriteLocked="EntryWriteLocked",A.NoPermissions="NoPermissions",A.Unavailable="Unavailable",A.Unknown="Unknown"})(l=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class w extends Error{constructor(Z,le){super(Z);this.code=le}}e.FileSystemProviderError=w;function s(A,Z){const le=new w(A.toString(),Z);return n(le,Z),le}e.createFileSystemProviderError=s;function u(A){return A||s((0,P.localize)(0,null),l.Unknown)}e.ensureFileSystemProviderError=u;function n(A,Z){return A.name=Z?`${Z} (FileSystemError)`:"FileSystemError",A}e.markAsFileSystemProviderError=n;function i(A){if(!A)return l.Unknown;if(A instanceof w)return A.code;const Z=/^(.+) \(FileSystemError\)$/.exec(A.name);if(!Z)return l.Unknown;switch(Z[1]){case l.FileExists:return l.FileExists;case l.FileIsADirectory:return l.FileIsADirectory;case l.FileNotADirectory:return l.FileNotADirectory;case l.FileNotFound:return l.FileNotFound;case l.FileExceedsMemoryLimit:return l.FileExceedsMemoryLimit;case l.FileTooLarge:return l.FileTooLarge;case l.FileWriteLocked:return l.FileWriteLocked;case l.NoPermissions:return l.NoPermissions;case l.Unavailable:return l.Unavailable}return l.Unknown}e.toFileSystemProviderErrorCode=i;function r(A){if(A instanceof U)return A.fileOperationResult;switch(i(A)){case l.FileNotFound:return 1;case l.FileIsADirectory:return 0;case l.FileNotADirectory:return 10;case l.FileWriteLocked:return 5;case l.NoPermissions:return 6;case l.FileExists:return 4;case l.FileExceedsMemoryLimit:return 9;case l.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var t;(function(A){A[A.CREATE=0]="CREATE",A[A.DELETE=1]="DELETE",A[A.MOVE=2]="MOVE",A[A.COPY=3]="COPY",A[A.WRITE=4]="WRITE"})(t=e.FileOperation||(e.FileOperation={}));class c{constructor(Z,le,oe){this.resource=Z,this.operation=le,this.target=oe}isOperation(Z){return this.operation===Z}}e.FileOperationEvent=c;var _;(function(A){A[A.UPDATED=0]="UPDATED",A[A.ADDED=1]="ADDED",A[A.DELETED=2]="DELETED"})(_=e.FileChangeType||(e.FileChangeType={}));class p{constructor(Z,le){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=Z;const oe=new Map;for(const ue of Z){const te=oe.get(ue.type);switch(te?te.push([ue.resource,ue]):oe.set(ue.type,[[ue.resource,ue]]),ue.type){case 1:this.rawAdded.push(ue.resource);break;case 0:this.rawUpdated.push(ue.resource);break;case 2:this.rawDeleted.push(ue.resource);break}}for(const[ue,te]of oe)switch(ue){case 1:this.added=a.TernarySearchTree.forUris(()=>le),this.added.fill(te);break;case 0:this.updated=a.TernarySearchTree.forUris(()=>le),this.updated.fill(te);break;case 2:this.deleted=a.TernarySearchTree.forUris(()=>le),this.deleted.fill(te);break}}contains(Z,...le){return this.doContains(Z,{includeChildren:!1},...le)}affects(Z,...le){return this.doContains(Z,{includeChildren:!0},...le)}doContains(Z,le,...oe){if(!Z)return!1;const ue=oe.length>0;return!!((!ue||oe.includes(1))&&(this.added?.get(Z)||le.includeChildren&&this.added?.findSuperstr(Z))||(!ue||oe.includes(0))&&(this.updated?.get(Z)||le.includeChildren&&this.updated?.findSuperstr(Z))||(!ue||oe.includes(2))&&(this.deleted?.findSubstr(Z)||le.includeChildren&&this.deleted?.findSuperstr(Z)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=p;function C(A,Z,le){return!A||!Z||A===Z||Z.length>A.length?!1:(Z.charAt(Z.length-1)!==v.sep&&(Z+=v.sep),le?(0,b.startsWithIgnoreCase)(A,Z):A.indexOf(Z)===0)}e.isParent=C;class U extends Error{constructor(Z,le,oe){super(Z);this.fileOperationResult=le,this.options=oe}}e.FileOperationError=U;class W extends U{constructor(Z,le,oe){super(Z,2,oe);this.stat=le}}e.NotModifiedSinceFileOperationError=W;var L;(function(A){A[A.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",A[A.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",A[A.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",A[A.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",A[A.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",A[A.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",A[A.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",A[A.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",A[A.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",A[A.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",A[A.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",A[A.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(L=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var S;(function(A){A[A.FILE=0]="FILE",A[A.FOLDER=1]="FOLDER",A[A.ROOT_FOLDER=2]="ROOT_FOLDER"})(S=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function z(A){if(!(typeof A.size!="number"||typeof A.mtime!="number"))return A.mtime.toString(29)+A.size.toString(31)}e.etag=z;async function $(A,Z){if(!Z.hasProvider(D.URI.from({scheme:A.scheme})))return new Promise(le=>{const oe=Z.onDidChangeFileSystemProviderRegistrations(ue=>{ue.scheme===A.scheme&&ue.added&&(oe.dispose(),le())})})}e.whenProviderRegistered=$,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class F{static formatSize(Z){return(0,M.isNumber)(Z)||(Z=0),Z<F.KB?(0,P.localize)(1,null,Z.toFixed(0)):Z<F.MB?(0,P.localize)(2,null,(Z/F.KB).toFixed(2)):Z<F.GB?(0,P.localize)(3,null,(Z/F.MB).toFixed(2)):Z<F.TB?(0,P.localize)(4,null,(Z/F.GB).toFixed(2)):(0,P.localize)(5,null,(Z/F.TB).toFixed(2))}}e.ByteSize=F,F.KB=1024,F.MB=F.KB*F.KB,F.GB=F.MB*F.KB,F.TB=F.GB*F.KB;var q;(function(A){A[A.IA32=0]="IA32",A[A.OTHER=1]="OTHER"})(q=e.Arch||(e.Arch={}));function ie(A){return{maxFileSize:A===0?300*F.MB:16*F.GB,maxHeapSize:A===0?700*F.MB:2*700*F.MB}}e.getPlatformLimits=ie}),define(ye[58],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class a{constructor(...b){this._entries=new Map;for(const[M,D]of b)this.set(M,D)}set(b,M){const D=this._entries.get(b);return this._entries.set(b,M),D}has(b){return this._entries.has(b)}get(b){return this._entries.get(b)}}e.ServiceCollection=a}),define(ye[148],De([1,0,14,11,78,146,3,58]),function(ne,e,a,v,b,M,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const E=!1;class T extends Error{constructor(f){super("cyclic dependency between services");this.message=f.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${f.toString()}`}}class O{constructor(f=new P.ServiceCollection,h=!1,d){this._activeInstantiations=new Set,this._services=f,this._strict=h,this._parent=d,this._services.set(D.IInstantiationService,this)}createChild(f){return new O(f,this._strict,this)}invokeFunction(f,...h){const d=m.traceInvocation(f);let o=!1;try{return f({get:R=>{if(o)throw(0,v.illegalState)("service accessor is only valid during the invocation of its target method");const l=this._getOrCreateServiceInstance(R,d);if(!l)throw new Error(`[invokeFunction] unknown service '${R}'`);return l}},...h)}finally{o=!0,d.stop()}}createInstance(f,...h){let d,o;return f instanceof b.SyncDescriptor?(d=m.traceCreation(f.ctor),o=this._createInstance(f.ctor,f.staticArguments.concat(h),d)):(d=m.traceCreation(f),o=this._createInstance(f,h,d)),d.stop(),o}_createInstance(f,h=[],d){const o=D._util.getServiceDependencies(f).sort((l,w)=>l.index-w.index),g=[];for(const l of o){const w=this._getOrCreateServiceInstance(l.id,d);w||this._throwIfStrict(`[createInstance] ${f.name} depends on UNKNOWN service ${l.id}.`,!1),g.push(w)}const R=o.length>0?o[0].index:h.length;if(h.length!==R){console.trace(`[createInstance] First service dependency of ${f.name} at position ${R+1} conflicts with ${h.length} static arguments`);const l=R-h.length;l>0?h=h.concat(new Array(l)):h=h.slice(0,R)}return new f(...[...h,...g])}_setServiceInstance(f,h){if(this._services.get(f)instanceof b.SyncDescriptor)this._services.set(f,h);else if(this._parent)this._parent._setServiceInstance(f,h);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(f){const h=this._services.get(f);return!h&&this._parent?this._parent._getServiceInstanceOrDescriptor(f):h}_getOrCreateServiceInstance(f,h){const d=this._getServiceInstanceOrDescriptor(f);return d instanceof b.SyncDescriptor?this._safeCreateAndCacheServiceInstance(f,d,h.branch(f,!0)):(h.branch(f,!1),d)}_safeCreateAndCacheServiceInstance(f,h,d){if(this._activeInstantiations.has(f))throw new Error(`illegal state - RECURSIVELY instantiating service '${f}'`);this._activeInstantiations.add(f);try{return this._createAndCacheServiceInstance(f,h,d)}finally{this._activeInstantiations.delete(f)}}_createAndCacheServiceInstance(f,h,d){const o=new M.Graph(l=>l.id.toString());let g=0;const R=[{id:f,desc:h,_trace:d}];for(;R.length;){const l=R.pop();if(o.lookupOrInsertNode(l),g++>1e3)throw new T(o);for(const w of D._util.getServiceDependencies(l.desc.ctor)){const s=this._getServiceInstanceOrDescriptor(w.id);if(s||this._throwIfStrict(`[createInstance] ${f} depends on ${w.id} which is NOT registered.`,!0),s instanceof b.SyncDescriptor){const u={id:w.id,desc:s,_trace:l._trace.branch(w.id,!0)};o.insertEdge(l,u),R.push(u)}}}for(;;){const l=o.roots();if(l.length===0){if(!o.isEmpty())throw new T(o);break}for(const{data:w}of l){if(this._getServiceInstanceOrDescriptor(w.id)instanceof b.SyncDescriptor){const u=this._createServiceInstanceWithOwner(w.id,w.desc.ctor,w.desc.staticArguments,w.desc.supportsDelayedInstantiation,w._trace);this._setServiceInstance(w.id,u)}o.removeNode(w)}}return this._getServiceInstanceOrDescriptor(f)}_createServiceInstanceWithOwner(f,h,d=[],o,g){if(this._services.get(f)instanceof b.SyncDescriptor)return this._createServiceInstance(h,d,o,g);if(this._parent)return this._parent._createServiceInstanceWithOwner(f,h,d,o,g);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}_createServiceInstance(f,h=[],d,o){if(d){const g=new a.IdleValue(()=>this._createInstance(f,h,o));return new Proxy(Object.create(null),{get(R,l){if(l in R)return R[l];const w=g.value;let s=w[l];return typeof s!="function"||(s=s.bind(w),R[l]=s),s},set(R,l,w){return g.value[l]=w,!0}})}else return this._createInstance(f,h,o)}_throwIfStrict(f,h){if(h&&console.warn(f),this._strict)throw new Error(f)}}e.InstantiationService=O;var y;(function(k){k[k.Creation=0]="Creation",k[k.Invocation=1]="Invocation",k[k.Branch=2]="Branch"})(y||(y={}));class m{constructor(f,h){this.type=f,this.name=h,this._start=Date.now(),this._dep=[]}static traceInvocation(f){return E?new m(1,f.name||f.toString().substring(0,42).replace(/\n/g,"")):m._None}static traceCreation(f){return E?new m(0,f.name):m._None}branch(f,h){const d=new m(2,f.toString());return this._dep.push([f,h,d]),d}stop(){const f=Date.now()-this._start;m._totals+=f;let h=!1;function d(g,R){const l=[],w=new Array(g+1).join("	");for(const[s,u,n]of R._dep)if(u&&n){h=!0,l.push(`${w}CREATES -> ${s}`);const i=d(g+1,n);i&&l.push(i)}else l.push(`${w}uses -> ${s}`);return l.join(`
`)}const o=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${d(1,this)}`,`DONE, took ${f.toFixed(2)}ms (grand total ${m._totals.toFixed(2)}ms)`];(f>2||h)&&console.log(o.join(`
`))}}e.Trace=m,m._None=new class extends m{constructor(){super(-1,null)}stop(){}branch(){return this}},m._totals=0}),define(ye[15],De([1,0,43,5,7,21,3]),function(ne,e,a,v,b,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,D.createDecorator)("logService"),e.ILoggerService=(0,D.createDecorator)("loggerService");function P(){return new Date().toISOString()}var E;(function(u){u[u.Trace=0]="Trace",u[u.Debug=1]="Debug",u[u.Info=2]="Info",u[u.Warning=3]="Warning",u[u.Error=4]="Error",u[u.Critical=5]="Critical",u[u.Off=6]="Off"})(E=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=E.Info;function T(u,n,i){switch(n){case E.Trace:u.trace(i);break;case E.Debug:u.debug(i);break;case E.Info:u.info(i);break;case E.Warning:u.warn(i);break;case E.Error:u.error(i);break;case E.Critical:u.critical(i);break;default:throw new Error("Invalid log level")}}e.log=T;function O(u){let n="";for(let i=0;i<u.length;i++){let r=u[i];if(typeof r=="object")try{r=JSON.stringify(r)}catch{}n+=(i>0?" ":"")+r}return n}e.format=O;class y extends b.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new v.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(n){this.level!==n&&(this.level=n,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=y;class m extends y{constructor(n){super();this.logAlways=n}checkLogLevel(n){return this.logAlways||this.getLevel()<=n}trace(n,...i){this.checkLogLevel(E.Trace)&&this.log(E.Trace,O([n,...i]))}debug(n,...i){this.checkLogLevel(E.Debug)&&this.log(E.Debug,O([n,...i]))}info(n,...i){this.checkLogLevel(E.Info)&&this.log(E.Info,O([n,...i]))}warn(n,...i){this.checkLogLevel(E.Warning)&&this.log(E.Warning,O([n,...i]))}error(n,...i){if(this.checkLogLevel(E.Error))if(n instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=n.stack,this.log(E.Error,O(r))}else this.log(E.Error,O([n,...i]))}critical(n,...i){this.checkLogLevel(E.Critical)&&this.log(E.Critical,O([n,...i]))}flush(){}}e.AbstractMessageLogger=m;class k extends y{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n),this.useColors=!M.isWindows}trace(n,...i){this.getLevel()<=E.Trace&&(this.useColors?console.log(`[90m[main ${P()}][0m`,n,...i):console.log(`[main ${P()}]`,n,...i))}debug(n,...i){this.getLevel()<=E.Debug&&(this.useColors?console.log(`[90m[main ${P()}][0m`,n,...i):console.log(`[main ${P()}]`,n,...i))}info(n,...i){this.getLevel()<=E.Info&&(this.useColors?console.log(`[90m[main ${P()}][0m`,n,...i):console.log(`[main ${P()}]`,n,...i))}warn(n,...i){this.getLevel()<=E.Warning&&(this.useColors?console.warn(`[93m[main ${P()}][0m`,n,...i):console.warn(`[main ${P()}]`,n,...i))}error(n,...i){this.getLevel()<=E.Error&&(this.useColors?console.error(`[91m[main ${P()}][0m`,n,...i):console.error(`[main ${P()}]`,n,...i))}critical(n,...i){this.getLevel()<=E.Critical&&(this.useColors?console.error(`[90m[main ${P()}][0m`,n,...i):console.error(`[main ${P()}]`,n,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=k;class f extends y{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n)}trace(n,...i){this.getLevel()<=E.Trace&&console.log("%cTRACE","color: #888",n,...i)}debug(n,...i){this.getLevel()<=E.Debug&&console.log("%cDEBUG","background: #eee; color: #888",n,...i)}info(n,...i){this.getLevel()<=E.Info&&console.log("%c INFO","color: #33f",n,...i)}warn(n,...i){this.getLevel()<=E.Warning&&console.log("%c WARN","color: #993",n,...i)}error(n,...i){this.getLevel()<=E.Error&&console.log("%c  ERR","color: #f33",n,...i)}critical(n,...i){this.getLevel()<=E.Critical&&console.log("%cCRITI","background: #f33; color: white",n,...i)}dispose(){}flush(){}}e.ConsoleLogger=f;class h extends y{constructor(n,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=n,this.setLevel(i)}trace(n,...i){this.getLevel()<=E.Trace&&this.adapter.log(E.Trace,[this.extractMessage(n),...i])}debug(n,...i){this.getLevel()<=E.Debug&&this.adapter.log(E.Debug,[this.extractMessage(n),...i])}info(n,...i){this.getLevel()<=E.Info&&this.adapter.log(E.Info,[this.extractMessage(n),...i])}warn(n,...i){this.getLevel()<=E.Warning&&this.adapter.log(E.Warning,[this.extractMessage(n),...i])}error(n,...i){this.getLevel()<=E.Error&&this.adapter.log(E.Error,[this.extractMessage(n),...i])}critical(n,...i){this.getLevel()<=E.Critical&&this.adapter.log(E.Critical,[this.extractMessage(n),...i])}extractMessage(n){return typeof n=="string"?n:(0,a.toErrorMessage)(n,this.getLevel()<=E.Trace)}dispose(){}flush(){}}e.AdapterLogger=h;class d extends y{constructor(n){super();this.logServices=n,n.length&&this.setLevel(n[0].getLevel())}setLevel(n){for(const i of this.logServices)i.setLevel(n);super.setLevel(n)}trace(n,...i){for(const r of this.logServices)r.trace(n,...i)}debug(n,...i){for(const r of this.logServices)r.debug(n,...i)}info(n,...i){for(const r of this.logServices)r.info(n,...i)}warn(n,...i){for(const r of this.logServices)r.warn(n,...i)}error(n,...i){for(const r of this.logServices)r.error(n,...i)}critical(n,...i){for(const r of this.logServices)r.critical(n,...i)}flush(){for(const n of this.logServices)n.flush()}dispose(){for(const n of this.logServices)n.dispose()}}e.MultiplexLogService=d;class o extends b.Disposable{constructor(n){super();this.logger=n,this._register(n)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(n){this.logger.setLevel(n)}getLevel(){return this.logger.getLevel()}trace(n,...i){this.logger.trace(n,...i)}debug(n,...i){this.logger.debug(n,...i)}info(n,...i){this.logger.info(n,...i)}warn(n,...i){this.logger.warn(n,...i)}error(n,...i){this.logger.error(n,...i)}critical(n,...i){this.logger.critical(n,...i)}flush(){this.logger.flush()}}e.LogService=o;class g extends b.Disposable{constructor(n,i){super();this.logLevel=n,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(t=>t.setLevel(r))}))}getLogger(n){return this.loggers.get(n.toString())}createLogger(n,i){let r=this.loggers.get(n.toString());return r||(r=this.doCreateLogger(n,i?.always?E.Trace:this.logLevel,i),this.loggers.set(n.toString(),r),i?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(n=>n.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=g;class R{constructor(){this.onDidChangeLogLevel=new v.Emitter().event}setLevel(n){}getLevel(){return E.Info}trace(n,...i){}debug(n,...i){}info(n,...i){}warn(n,...i){}error(n,...i){}critical(n,...i){}dispose(){}flush(){}}e.NullLogService=R;function l(u){if(u.verbose)return E.Trace;if(typeof u.logLevel=="string"){const n=w(u.logLevel.toLowerCase());if(n!==void 0)return n}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=l;function w(u){switch(u){case"trace":return E.Trace;case"debug":return E.Debug;case"info":return E.Info;case"warn":return E.Warning;case"error":return E.Error;case"critical":return E.Critical;case"off":return E.Off}}e.parseLogLevel=w;function s(u){switch(u){case E.Trace:return"trace";case E.Debug:return"debug";case E.Info:return"info";case E.Warning:return"warn";case E.Error:return"error";case E.Critical:return"critical";case E.Off:return"off"}}e.LogLevelToString=s}),define(ye[80],De([1,0,29,127,3]),function(ne,e,a,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var M;(function(E){E[E.Unnecessary=1]="Unnecessary",E[E.Deprecated=2]="Deprecated"})(M=e.MarkerTag||(e.MarkerTag={}));var D;(function(E){E[E.Hint=1]="Hint",E[E.Info=2]="Info",E[E.Warning=4]="Warning",E[E.Error=8]="Error"})(D=e.MarkerSeverity||(e.MarkerSeverity={})),function(E){function T(f,h){return h-f}E.compare=T;const O=Object.create(null);O[E.Error]=(0,v.localize)(0,null),O[E.Warning]=(0,v.localize)(1,null),O[E.Info]=(0,v.localize)(2,null);function y(f){return O[f]||""}E.toString=y;function m(f){switch(f){case a.default.Error:return E.Error;case a.default.Warning:return E.Warning;case a.default.Info:return E.Info;case a.default.Ignore:return E.Hint}}E.fromSeverity=m;function k(f){switch(f){case E.Error:return a.default.Error;case E.Warning:return a.default.Warning;case E.Info:return a.default.Info;case E.Hint:return a.default.Ignore}}E.toSeverity=k}(D=e.MarkerSeverity||(e.MarkerSeverity={}));var P;(function(E){const T="";function O(m){return y(m,!0)}E.makeKey=O;function y(m,k){const f=[T];return m.source?f.push(m.source.replace("\xA6","\\\xA6")):f.push(T),m.code?typeof m.code=="string"?f.push(m.code.replace("\xA6","\\\xA6")):f.push(m.code.value.replace("\xA6","\\\xA6")):f.push(T),m.severity!==void 0&&m.severity!==null?f.push(D.toString(m.severity)):f.push(T),m.message&&k?f.push(m.message.replace("\xA6","\\\xA6")):f.push(T),m.startLineNumber!==void 0&&m.startLineNumber!==null?f.push(m.startLineNumber.toString()):f.push(T),m.startColumn!==void 0&&m.startColumn!==null?f.push(m.startColumn.toString()):f.push(T),m.endLineNumber!==void 0&&m.endLineNumber!==null?f.push(m.endLineNumber.toString()):f.push(T),m.endColumn!==void 0&&m.endColumn!==null?f.push(m.endColumn.toString()):f.push(T),f.push(T),f.join("\xA6")}E.makeKeyOptionalMessage=y})(P=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,b.createDecorator)("markerService")}),define(ye[149],De([1,0,5,29,3]),function(ne,e,a,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=v.default,e.INotificationService=(0,b.createDecorator)("notificationService");var M;(function(T){T[T.WORKSPACE=0]="WORKSPACE",T[T.PROFILE=1]="PROFILE",T[T.APPLICATION=2]="APPLICATION"})(M=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var D;(function(T){T[T.OFF=0]="OFF",T[T.SILENT=1]="SILENT",T[T.ERROR=2]="ERROR"})(D=e.NotificationsFilter||(e.NotificationsFilter={}));class P{constructor(){this.progress=new E,this.onDidClose=a.Event.None,this.onDidChangeVisibility=a.Event.None}updateSeverity(O){}updateMessage(O){}updateActions(O){}close(){}}e.NoOpNotification=P;class E{infinite(){}done(){}total(O){}worked(O){}}e.NoOpProgress=E}),define(ye[81],De([1,0,7,9,2,3]),function(ne,e,a,v,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,M.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return a.Disposable.None},registerValidator(){return a.Disposable.None},registerExternalUriResolver(){return a.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return a.Disposable.None},async open(){return!1},async resolveExternalUri(O){return{resolved:O,dispose(){}}}});function D(O,y){return b.URI.isUri(O)?(0,v.equalsIgnoreCase)(O.scheme,y):(0,v.startsWithIgnoreCase)(O,y+":")}e.matchesScheme=D;function P(O,...y){return y.some(m=>D(O,m))}e.matchesSomeScheme=P;function E(O,y){return O.with({fragment:`${y.startLineNumber},${y.startColumn}${y.endLineNumber?`-${y.endLineNumber}${y.endColumn?`,${y.endColumn}`:""}`:""}`})}e.withSelection=E;function T(O){let y;const m=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(O.fragment);return m&&(y={startLineNumber:parseInt(m[1]),startColumn:m[2]?parseInt(m[2]):1,endLineNumber:m[4]?parseInt(m[4]):void 0,endColumn:m[4]?m[5]?parseInt(m[5]):1:void 0},O=O.with({fragment:""})),{selection:y,uri:O}}e.extractSelection=T}),define(ye[150],De([1,0,3]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,a.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var ze=this&&this.__decorate||function(ne,e,a,v){var b=arguments.length,M=b<3?e:v===null?v=Object.getOwnPropertyDescriptor(e,a):v,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(ne,e,a,v);else for(var P=ne.length-1;P>=0;P--)(D=ne[P])&&(M=(b<3?D(M):b>3?D(e,a,M):D(e,a))||M);return b>3&&M&&Object.defineProperty(e,a,M),M},xe=this&&this.__param||function(ne,e){return function(a,v){e(a,v,ne)}};define(ye[151],De([1,0,14,20,7,3]),function(ne,e,a,v,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,M.createDecorator)("progressService");var D;(function(O){O[O.Explorer=1]="Explorer",O[O.Scm=3]="Scm",O[O.Extensions=5]="Extensions",O[O.Window=10]="Window",O[O.Notification=15]="Notification",O[O.Dialog=20]="Dialog"})(D=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class P{constructor(y){this.callback=y}get value(){return this._value}report(y){this._value=y,this.callback(this._value)}}e.Progress=P,P.None=Object.freeze({report(){}});let E=class extends b.Disposable{constructor(y,m){super();this.deferred=new a.DeferredPromise,m.withProgress(y,k=>(this.reporter=k,this.lastStep&&k.report(this.lastStep),this.deferred.p)),this._register((0,b.toDisposable)(()=>this.deferred.complete()))}report(y){this.reporter?this.reporter.report(y):this.lastStep=y}};E=ze([xe(1,e.IProgressService)],E),e.UnmanagedProgress=E;class T extends b.Disposable{constructor(y){super();this.progressIndicator=y,this.currentOperationId=0,this.currentOperationDisposables=this._register(new b.DisposableStore)}start(y){this.stop();const m=++this.currentOperationId,k=new v.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{m===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},y),this.currentOperationDisposables.add((0,b.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,b.toDisposable)(()=>k.cancel())),this.currentOperationDisposables.add((0,b.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:m,token:k.token,stop:()=>this.doStop(m),isCurrent:()=>this.currentOperationId===m}}stop(){this.doStop(this.currentOperationId)}doStop(y){this.currentOperationId===y&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=T,e.IEditorProgressService=(0,M.createDecorator)("editorProgressService")}),define(ye[30],De([1,0,44,10]),function(ne,e,a,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class b{constructor(){this.data=new Map}add(D,P){a.ok(v.isString(D)),a.ok(v.isObject(P)),a.ok(!this.data.has(D),"There is already an extension with this id"),this.data.set(D,P)}knows(D){return this.data.has(D)}as(D){return this.data.get(D)||null}}e.Registry=new b}),define(ye[82],De([1,0,5,30]),function(ne,e,a,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function b(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class M{constructor(){this._onDidChangeSchema=new a.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(E,T){this.schemasById[b(E)]=T,this._onDidChangeSchema.fire(E)}notifySchemaChanged(E){this._onDidChangeSchema.fire(E)}getSchemaContributions(){return{schemas:this.schemasById}}}const D=new M;v.Registry.add(e.Extensions.JSONContribution,D)}),define(ye[83],De([1,0,16,5,10,123,57,82,30]),function(ne,e,a,v,b,M,D,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var T;(function(w){w.Multiline="multilineText",w.Singleline="singlelineText"})(T=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var O;(function(w){w[w.APPLICATION=1]="APPLICATION",w[w.MACHINE=2]="MACHINE",w[w.WINDOW=3]="WINDOW",w[w.RESOURCE=4]="RESOURCE",w[w.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",w[w.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(O=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const y=E.Registry.as(P.Extensions.JSONContribution);class m{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new v.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new v.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(s,u=!0){this.registerConfigurations([s],u)}registerConfigurations(s,u=!0){const n=this.doRegisterConfigurations(s,u);y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}deregisterConfigurations(s){const u=this.doDeregisterConfigurations(s);y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:u})}updateConfigurations({add:s,remove:u}){const n=[];n.push(...this.doDeregisterConfigurations(u)),n.push(...this.doRegisterConfigurations(s,!1)),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,a.distinct)(n)})}registerDefaultConfigurations(s){const u=[],n=[];for(const{overrides:i,source:r}of s)for(const t in i)if(u.push(t),e.OVERRIDE_PROPERTY_REGEX.test(t)){const c=this.configurationDefaultsOverrides.get(t),_=c?.valuesSources??new Map;if(r)for(const W of Object.keys(i[t]))_.set(W,r);const p={...c?.value||{},...i[t]};this.configurationDefaultsOverrides.set(t,{source:r,value:p,valuesSources:_});const C=(0,D.getLanguageTagSettingPlainKey)(t),U={type:"object",default:p,description:M.localize(1,null,C),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:p,source:b.isString(r)?void 0:r,defaultValueSource:r};n.push(...h(t)),this.configurationProperties[t]=U,this.defaultLanguageConfigurationOverridesNode.properties[t]=U}else{this.configurationDefaultsOverrides.set(t,{value:i[t],source:r});const c=this.configurationProperties[t];c&&(this.updatePropertyDefaultValue(t,c),this.updateSchema(t,c))}this.registerOverrideIdentifiers(n),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:u,defaultsOverrides:!0})}deregisterDefaultConfigurations(s){const u=[];for(const{overrides:n,source:i}of s)for(const r in n){const t=this.configurationDefaultsOverrides.get(r),c=b.isString(i)?i:i?.id,_=b.isString(t?.source)?t?.source:t?.source?.id;if(c===_)if(u.push(r),this.configurationDefaultsOverrides.delete(r),e.OVERRIDE_PROPERTY_REGEX.test(r))delete this.configurationProperties[r],delete this.defaultLanguageConfigurationOverridesNode.properties[r];else{const p=this.configurationProperties[r];p&&(this.updatePropertyDefaultValue(r,p),this.updateSchema(r,p))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:u,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...s){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(s){for(const u of s)this.overrideIdentifiers.add(u);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(s,u){const n=[];return s.forEach(i=>{n.push(...this.validateAndRegisterProperties(i,u,i.extensionInfo,i.restrictedProperties)),this.configurationContributors.push(i),this.registerJSONConfiguration(i)}),n}doDeregisterConfigurations(s){const u=[],n=i=>{if(i.properties)for(const r in i.properties){u.push(r);const t=this.configurationProperties[r];t?.policy?.name&&this.policyConfigurations.delete(t.policy.name),delete this.configurationProperties[r],this.removeFromSchema(r,i.properties[r])}i.allOf?.forEach(r=>n(r))};for(const i of s){n(i);const r=this.configurationContributors.indexOf(i);r!==-1&&this.configurationContributors.splice(r,1)}return u}validateAndRegisterProperties(s,u=!0,n,i,r=3){r=b.isUndefinedOrNull(s.scope)?r:s.scope;const t=[],c=s.properties;if(c)for(const p in c){const C=c[p];if(u&&R(p,C)){delete c[p];continue}if(C.source=n,C.defaultDefaultValue=c[p].default,this.updatePropertyDefaultValue(p,C),e.OVERRIDE_PROPERTY_REGEX.test(p)?C.scope=void 0:(C.scope=b.isUndefinedOrNull(C.scope)?r:C.scope,C.restricted=b.isUndefinedOrNull(C.restricted)?!!i?.includes(p):C.restricted),c[p].hasOwnProperty("included")&&!c[p].included){this.excludedConfigurationProperties[p]=c[p],delete c[p];continue}else this.configurationProperties[p]=c[p],c[p].policy?.name&&this.policyConfigurations.set(c[p].policy.name,p);!c[p].deprecationMessage&&c[p].markdownDeprecationMessage&&(c[p].deprecationMessage=c[p].markdownDeprecationMessage),t.push(p)}const _=s.allOf;if(_)for(const p of _)t.push(...this.validateAndRegisterProperties(p,u,n,i,r));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(s){const u=n=>{const i=n.properties;if(i)for(const t in i)this.updateSchema(t,i[t]);n.allOf?.forEach(u)};u(s)}updateSchema(s,u){switch(e.allSettings.properties[s]=u,u.scope){case 1:e.applicationSettings.properties[s]=u;break;case 2:e.machineSettings.properties[s]=u;break;case 6:e.machineOverridableSettings.properties[s]=u;break;case 3:e.windowSettings.properties[s]=u;break;case 4:e.resourceSettings.properties[s]=u;break;case 5:e.resourceSettings.properties[s]=u,this.resourceLanguageSettingsSchema.properties[s]=u;break}}removeFromSchema(s,u){switch(delete e.allSettings.properties[s],u.scope){case 1:delete e.applicationSettings.properties[s];break;case 2:delete e.machineSettings.properties[s];break;case 6:delete e.machineOverridableSettings.properties[s];break;case 3:delete e.windowSettings.properties[s];break;case 4:case 5:delete e.resourceSettings.properties[s],delete this.resourceLanguageSettingsSchema.properties[s];break}}updateOverridePropertyPatternKey(){for(const s of this.overrideIdentifiers.values()){const u=`[${s}]`,n={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(u,n),e.allSettings.properties[u]=n,e.applicationSettings.properties[u]=n,e.machineSettings.properties[u]=n,e.machineOverridableSettings.properties[u]=n,e.windowSettings.properties[u]=n,e.resourceSettings.properties[u]=n}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const s={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(s,u){const n=this.configurationDefaultsOverrides.get(s);let i=n?.value,r=n?.source;b.isUndefined(i)&&(i=u.defaultDefaultValue,r=void 0),b.isUndefined(i)&&(i=o(u.type)),u.default=i,u.defaultValueSource=r}}const k="\\[([^\\]]+)\\]",f=new RegExp(k,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${k})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function h(w){const s=[];if(e.OVERRIDE_PROPERTY_REGEX.test(w)){let u=f.exec(w);for(;u?.length;){const n=u[1].trim();n&&s.push(n),u=f.exec(w)}}return(0,a.distinct)(s)}e.overrideIdentifiersFromKey=h;function d(w){return w.reduce((s,u)=>`${s}[${u}]`,"")}e.keyFromOverrideIdentifiers=d;function o(w){switch(Array.isArray(w)?w[0]:w){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=o;const g=new m;E.Registry.add(e.Extensions.Configuration,g);function R(w,s){return w.trim()?e.OVERRIDE_PROPERTY_REGEX.test(w)?M.localize(7,null,w):g.getConfigurationProperties()[w]!==void 0?M.localize(8,null,w):s.policy?.name&&g.getPolicyConfigurations().get(s.policy?.name)!==void 0?M.localize(9,null,w,s.policy?.name,g.getPolicyConfigurations().get(s.policy?.name)):null:M.localize(6,null)}e.validateProperty=R;function l(){const w=[],s=g.getConfigurationProperties();for(const u of Object.keys(s))w.push([u,s[u].scope]);return w.push(["launch",4]),w.push(["task",4]),w}e.getScopes=l}),define(ye[152],De([1,0,16,5,105,7,25,26,10,2,57,83,30]),function(ne,e,a,v,b,M,D,P,E,T,O,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class k{constructor(u={},n=[],i=[]){this._contents=u,this._keys=n,this._overrides=i,this.frozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(u){return u?(0,O.getConfigurationValue)(this.contents,u):this.contents}getOverrideValue(u,n){const i=this.getContentsForOverrideIdentifer(n);return i?u?(0,O.getConfigurationValue)(i,u):i:void 0}getKeysForOverrideIdentifier(u){const n=[];for(const i of this.overrides)i.identifiers.includes(u)&&n.push(...i.keys);return a.distinct(n)}getAllOverrideIdentifiers(){const u=[];for(const n of this.overrides)u.push(...n.identifiers);return a.distinct(u)}override(u){let n=this.overrideConfigurations.get(u);return n||(n=this.createOverrideConfigurationModel(u),this.overrideConfigurations.set(u,n)),n}merge(...u){const n=P.deepClone(this.contents),i=P.deepClone(this.overrides),r=[...this.keys];for(const t of u)if(!t.isEmpty()){this.mergeContents(n,t.contents);for(const c of t.overrides){const[_]=i.filter(p=>a.equals(p.identifiers,c.identifiers));_?(this.mergeContents(_.contents,c.contents),_.keys.push(...c.keys),_.keys=a.distinct(_.keys)):i.push(P.deepClone(c))}for(const c of t.keys)r.indexOf(c)===-1&&r.push(c)}return new k(n,r,i)}freeze(){return this.frozen=!0,this}clone(){return new k(P.deepClone(this.contents),[...this.keys],P.deepClone(this.overrides))}createOverrideConfigurationModel(u){const n=this.getContentsForOverrideIdentifer(u);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const i={};for(const r of a.distinct([...Object.keys(this.contents),...Object.keys(n)])){let t=this.contents[r];const c=n[r];c&&(typeof t=="object"&&typeof c=="object"?(t=P.deepClone(t),this.mergeContents(t,c)):t=c),i[r]=t}return new k(i,this.keys,this.overrides)}mergeContents(u,n){for(const i of Object.keys(n)){if(i in u&&E.isObject(u[i])&&E.isObject(n[i])){this.mergeContents(u[i],n[i]);continue}u[i]=P.deepClone(n[i])}}checkAndFreeze(u){return this.frozen&&!Object.isFrozen(u)?P.deepFreeze(u):u}getContentsForOverrideIdentifer(u){let n=null,i=null;const r=t=>{t&&(i?this.mergeContents(i,t):i=P.deepClone(t))};for(const t of this.overrides)a.equals(t.identifiers,[u])?n=t.contents:t.identifiers.includes(u)&&r(t.contents);return r(n),i}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(u,n){this.addKey(u),(0,O.addToValueTree)(this.contents,u,n,i=>{throw new Error(i)})}removeValue(u){this.removeKey(u)&&(0,O.removeFromValueTree)(this.contents,u)}addKey(u){let n=this.keys.length;for(let i=0;i<n;i++)u.indexOf(this.keys[i])===0&&(n=i);this.keys.splice(n,1,u)}removeKey(u){const n=this.keys.indexOf(u);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=k;class f{constructor(u){this._name=u,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new k}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(u,n){if(!E.isUndefinedOrNull(u)){const i=this.doParseContent(u);this.parseRaw(i,n)}}reparse(u){this._raw&&this.parseRaw(this._raw,u)}parseRaw(u,n){this._raw=u;const{contents:i,keys:r,overrides:t,restricted:c}=this.doParseRaw(u,n);this._configurationModel=new k(i,r,t),this._restrictedConfigurations=c||[]}doParseContent(u){let n={},i=null,r=[];const t=[],c=[];function _(C){Array.isArray(r)?r.push(C):i!==null&&(r[i]=C)}const p={onObjectBegin:()=>{const C={};_(C),t.push(r),r=C,i=null},onObjectProperty:C=>{i=C},onObjectEnd:()=>{r=t.pop()},onArrayBegin:()=>{const C=[];_(C),t.push(r),r=C,i=null},onArrayEnd:()=>{r=t.pop()},onLiteralValue:_,onError:(C,U,W)=>{c.push({error:C,offset:U,length:W})}};if(u)try{b.visit(u,p),n=r[0]||{}}catch(C){console.error(`Error while parsing settings file ${this._name}: ${C}`),this._parseErrors=[C]}return n}doParseRaw(u,n){const i=m.Registry.as(y.Extensions.Configuration).getConfigurationProperties(),r=this.filter(u,i,!0,n);u=r.raw;const t=(0,O.toValuesTree)(u,p=>console.error(`Conflict in settings file ${this._name}: ${p}`)),c=Object.keys(u),_=this.toOverrides(u,p=>console.error(`Conflict in settings file ${this._name}: ${p}`));return{contents:t,keys:c,overrides:_,restricted:r.restricted}}filter(u,n,i,r){if(!r?.scopes&&!r?.skipRestricted)return{raw:u,restricted:[]};const t={},c=[];for(const _ in u)if(y.OVERRIDE_PROPERTY_REGEX.test(_)&&i){const p=this.filter(u[_],n,!1,r);t[_]=p.raw,c.push(...p.restricted)}else{const p=n[_],C=p?typeof p.scope!="undefined"?p.scope:3:void 0;p?.restricted&&c.push(_),(C===void 0||r.scopes===void 0||r.scopes.includes(C))&&(r.skipRestricted&&p?.restricted||(t[_]=u[_]))}return{raw:t,restricted:c}}toOverrides(u,n){const i=[];for(const r of Object.keys(u))if(y.OVERRIDE_PROPERTY_REGEX.test(r)){const t={};for(const c in u[r])t[c]=u[r][c];i.push({identifiers:(0,y.overrideIdentifiersFromKey)(r),keys:Object.keys(t),contents:(0,O.toValuesTree)(t,n)})}return i}}e.ConfigurationModelParser=f;class h extends M.Disposable{constructor(u,n,i,r){super();this.userSettingsResource=u,this.scopes=n,this.fileService=r,this._onDidChange=this._register(new v.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new f(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(i.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(v.Event.any(v.Event.filter(this.fileService.onDidFilesChange,t=>t.contains(this.userSettingsResource)),v.Event.filter(this.fileService.onDidRunOperation,t=>(t.isOperation(0)||t.isOperation(3)||t.isOperation(1)||t.isOperation(4))&&i.isEqual(t.resource,u)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const u=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(u.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new k}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=h;class d{constructor(u,n,i,r,t=new k,c=new k,_=new D.ResourceMap,p=new k,C=new D.ResourceMap,U=!0){this._defaultConfiguration=u,this._policyConfiguration=n,this._applicationConfiguration=i,this._localUserConfiguration=r,this._remoteUserConfiguration=t,this._workspaceConfiguration=c,this._folderConfigurations=_,this._memoryConfiguration=p,this._memoryConfigurationByResource=C,this._freeze=U,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new D.ResourceMap,this._userConfiguration=null}getValue(u,n,i){return this.getConsolidatedConfigurationModel(u,n,i).getValue(u)}updateValue(u,n,i={}){let r;i.resource?(r=this._memoryConfigurationByResource.get(i.resource),r||(r=new k,this._memoryConfigurationByResource.set(i.resource,r))):r=this._memoryConfiguration,n===void 0?r.removeValue(u):r.setValue(u,n),i.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(u,n,i){const r=this.getConsolidatedConfigurationModel(u,n,i),t=this.getFolderConfigurationModelForResource(n.resource,i),c=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,_=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(u):this._defaultConfiguration.freeze().getValue(u),p=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().getValue(u),C=this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze().getValue(u),U=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(u):this.userConfiguration.freeze().getValue(u),W=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(u):this.localUserConfiguration.freeze().getValue(u),L=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(u):this.remoteUserConfiguration.freeze().getValue(u),S=i?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(u):this._workspaceConfiguration.freeze().getValue(u):void 0,z=t?n.overrideIdentifier?t.freeze().override(n.overrideIdentifier).getValue(u):t.freeze().getValue(u):void 0,$=n.overrideIdentifier?c.override(n.overrideIdentifier).getValue(u):c.getValue(u),F=r.getValue(u),q=a.distinct(r.overrides.map(ie=>ie.identifiers).flat()).filter(ie=>r.getOverrideValue(u,ie)!==void 0);return{defaultValue:_,policyValue:p,applicationValue:C,userValue:U,userLocalValue:W,userRemoteValue:L,workspaceValue:S,workspaceFolderValue:z,memoryValue:$,value:F,default:_!==void 0?{value:this._defaultConfiguration.freeze().getValue(u),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(u,n.overrideIdentifier):void 0}:void 0,policy:p!==void 0?{value:p}:void 0,application:C!==void 0?{value:C,override:n.overrideIdentifier?this.applicationConfiguration.freeze().getOverrideValue(u,n.overrideIdentifier):void 0}:void 0,user:U!==void 0?{value:this.userConfiguration.freeze().getValue(u),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(u,n.overrideIdentifier):void 0}:void 0,userLocal:W!==void 0?{value:this.localUserConfiguration.freeze().getValue(u),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(u,n.overrideIdentifier):void 0}:void 0,userRemote:L!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(u),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(u,n.overrideIdentifier):void 0}:void 0,workspace:S!==void 0?{value:this._workspaceConfiguration.freeze().getValue(u),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(u,n.overrideIdentifier):void 0}:void 0,workspaceFolder:z!==void 0?{value:t?.freeze().getValue(u),override:n.overrideIdentifier?t?.freeze().getOverrideValue(u,n.overrideIdentifier):void 0}:void 0,memory:$!==void 0?{value:c.getValue(u),override:n.overrideIdentifier?c.getOverrideValue(u,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:q.length?q:void 0}}keys(u){const n=this.getFolderConfigurationModelForResource(void 0,u);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(u){this._defaultConfiguration=u,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(u){this._policyConfiguration=u}updateApplicationConfiguration(u){this._applicationConfiguration=u,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(u){this._localUserConfiguration=u,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(u){this._remoteUserConfiguration=u,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(u){this._workspaceConfiguration=u,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(u,n){this._folderConfigurations.set(u,n),this._foldersConsolidatedConfigurations.delete(u)}deleteFolderConfiguration(u){this.folderConfigurations.delete(u),this._foldersConsolidatedConfigurations.delete(u)}compareAndUpdateDefaultConfiguration(u,n){const i=[];if(!n){const{added:r,updated:t,removed:c}=l(this._defaultConfiguration,u);n=[...r,...t,...c]}for(const r of n)for(const t of(0,y.overrideIdentifiersFromKey)(r)){const c=this._defaultConfiguration.getKeysForOverrideIdentifier(t),_=u.getKeysForOverrideIdentifier(t),p=[..._.filter(C=>c.indexOf(C)===-1),...c.filter(C=>_.indexOf(C)===-1),...c.filter(C=>!P.equals(this._defaultConfiguration.override(t).getValue(C),u.override(t).getValue(C)))];i.push([t,p])}return this.updateDefaultConfiguration(u),{keys:n,overrides:i}}compareAndUpdatePolicyConfiguration(u){const{added:n,updated:i,removed:r}=l(this._policyConfiguration,u),t=[...n,...i,...r];return t.length&&this.updatePolicyConfiguration(u),{keys:t,overrides:[]}}compareAndUpdateApplicationConfiguration(u){const{added:n,updated:i,removed:r,overrides:t}=l(this.applicationConfiguration,u),c=[...n,...i,...r];return c.length&&this.updateApplicationConfiguration(u),{keys:c,overrides:t}}compareAndUpdateLocalUserConfiguration(u){const{added:n,updated:i,removed:r,overrides:t}=l(this.localUserConfiguration,u),c=[...n,...i,...r];return c.length&&this.updateLocalUserConfiguration(u),{keys:c,overrides:t}}compareAndUpdateRemoteUserConfiguration(u){const{added:n,updated:i,removed:r,overrides:t}=l(this.remoteUserConfiguration,u),c=[...n,...i,...r];return c.length&&this.updateRemoteUserConfiguration(u),{keys:c,overrides:t}}compareAndUpdateWorkspaceConfiguration(u){const{added:n,updated:i,removed:r,overrides:t}=l(this.workspaceConfiguration,u),c=[...n,...i,...r];return c.length&&this.updateWorkspaceConfiguration(u),{keys:c,overrides:t}}compareAndUpdateFolderConfiguration(u,n){const i=this.folderConfigurations.get(u),{added:r,updated:t,removed:c,overrides:_}=l(i,n),p=[...r,...t,...c];return(p.length||!i)&&this.updateFolderConfiguration(u,n),{keys:p,overrides:_}}compareAndDeleteFolderConfiguration(u){const n=this.folderConfigurations.get(u);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(u);const{added:i,updated:r,removed:t,overrides:c}=l(n,void 0);return{keys:[...i,...r,...t],overrides:c}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(u,n,i){let r=this.getConsolidatedConfigurationModelForResource(n,i);return n.overrideIdentifier&&(r=r.override(n.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(u)!==void 0&&(r=r.merge(this._policyConfiguration)),r}getConsolidatedConfigurationModelForResource({resource:u},n){let i=this.getWorkspaceConsolidatedConfiguration();if(n&&u){const r=n.getFolder(u);r&&(i=this.getFolderConsolidatedConfiguration(r.uri)||i);const t=this._memoryConfigurationByResource.get(u);t&&(i=i.merge(t))}return i}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(u){let n=this._foldersConsolidatedConfigurations.get(u);if(!n){const i=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(u);r?(n=i.merge(r),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(u,n)):n=i}return n}getFolderConfigurationModelForResource(u,n){if(n&&u){const i=n.getFolder(u);if(i)return this._folderConfigurations.get(i.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((u,n)=>{const{contents:i,overrides:r,keys:t}=this._folderConfigurations.get(n);return u.push([n,{contents:i,overrides:r,keys:t}]),u},[])}}allKeys(){const u=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>u.add(n)),this.userConfiguration.freeze().keys.forEach(n=>u.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>u.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(i=>u.add(i))),[...u.values()]}allOverrideIdentifiers(){const u=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>u.add(n)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>u.add(n)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>u.add(n)),this._folderConfigurations.forEach(n=>n.freeze().getAllOverrideIdentifiers().forEach(i=>u.add(i))),[...u.values()]}getAllKeysForOverrideIdentifier(u){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(u).forEach(i=>n.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(u).forEach(i=>n.add(i)),this._workspaceConfiguration.getKeysForOverrideIdentifier(u).forEach(i=>n.add(i)),this._folderConfigurations.forEach(i=>i.getKeysForOverrideIdentifier(u).forEach(r=>n.add(r))),[...n.values()]}static parse(u){const n=this.parseConfigurationModel(u.defaults),i=this.parseConfigurationModel(u.policy),r=this.parseConfigurationModel(u.application),t=this.parseConfigurationModel(u.user),c=this.parseConfigurationModel(u.workspace),_=u.folders.reduce((p,C)=>(p.set(T.URI.revive(C[0]),this.parseConfigurationModel(C[1])),p),new D.ResourceMap);return new d(n,i,r,t,new k,c,_,new k,new D.ResourceMap,!1)}static parseConfigurationModel(u){return new k(u.contents,u.keys,u.overrides).freeze()}}e.Configuration=d;function o(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const u=new Set,n=new Map;for(const r of s)r.keys.forEach(t=>u.add(t)),r.overrides.forEach(([t,c])=>{const _=(0,D.getOrSet)(n,t,new Set);c.forEach(p=>_.add(p))});const i=[];return n.forEach((r,t)=>i.push([t,[...r.values()]])),{keys:[...u.values()],overrides:i}}e.mergeChanges=o;class g{constructor(u,n,i,r){this.change=u,this.previous=n,this.currentConfiguraiton=i,this.currentWorkspace=r,this._previousConfiguration=void 0;const t=new Set;u.keys.forEach(_=>t.add(_)),u.overrides.forEach(([,_])=>_.forEach(p=>t.add(p))),this.affectedKeys=[...t.values()];const c=new k;this.affectedKeys.forEach(_=>c.setValue(_,{})),this.affectedKeysTree=c.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=d.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(u,n){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,u)){if(n){const i=this.previousConfiguration?this.previousConfiguration.getValue(u,n,this.previous?.workspace):void 0,r=this.currentConfiguraiton.getValue(u,n,this.currentWorkspace);return!P.equals(i,r)}return!0}return!1}doesAffectedKeysTreeContains(u,n){let i=(0,O.toValuesTree)({[n]:!0},()=>{}),r;for(;typeof i=="object"&&(r=Object.keys(i)[0]);){if(u=u[r],!u)return!1;i=i[r]}return!0}}e.ConfigurationChangeEvent=g;class R extends g{constructor(u,n,i,r){super({keys:u.allKeys(),overrides:[]},void 0,u,n);this.source=i,this.sourceConfig=r}}e.AllKeysConfigurationChangeEvent=R;function l(s,u){const{added:n,removed:i,updated:r}=w(u,s),t=[],c=s?.getAllOverrideIdentifiers()||[],_=u?.getAllOverrideIdentifiers()||[];if(u){const p=_.filter(C=>!c.includes(C));for(const C of p)t.push([C,u.getKeysForOverrideIdentifier(C)])}if(s){const p=c.filter(C=>!_.includes(C));for(const C of p)t.push([C,s.getKeysForOverrideIdentifier(C)])}if(u&&s){for(const p of c)if(_.includes(p)){const C=w({contents:s.getOverrideValue(void 0,p)||{},keys:s.getKeysForOverrideIdentifier(p)},{contents:u.getOverrideValue(void 0,p)||{},keys:u.getKeysForOverrideIdentifier(p)});t.push([p,[...C.added,...C.removed,...C.updated]])}}return{added:n,removed:i,updated:r,overrides:t}}function w(s,u){const n=s?u?s.keys.filter(t=>u.keys.indexOf(t)===-1):[...s.keys]:[],i=u?s?u.keys.filter(t=>s.keys.indexOf(t)===-1):[...u.keys]:[],r=[];if(s&&u){for(const t of u.keys)if(s.keys.indexOf(t)!==-1){const c=(0,O.getConfigurationValue)(u.contents,t),_=(0,O.getConfigurationValue)(s.contents,t);P.equals(c,_)||r.push(t)}}return{added:n,removed:i,updated:r}}}),define(ye[84],De([1,0,11,3]),function(ne,e,a,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,v.createDecorator)("remoteAuthorityResolverService");var b;(function(D){D.Unknown="Unknown",D.NotAvailable="NotAvailable",D.TemporarilyNotAvailable="TemporarilyNotAvailable",D.NoResolverFound="NoResolverFound"})(b=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class M extends a.ErrorNoTelemetry{constructor(P,E=b.Unknown,T){super(P);this._message=P,this._code=E,this._detail=T,this.isHandled=E===b.NotAvailable&&T===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,M.prototype)}static isTemporarilyNotAvailable(P){return P instanceof M&&P._code===b.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof M&&P._code===b.NoResolverFound}static isHandled(P){return P instanceof M&&P.isHandled}}e.RemoteAuthorityResolverError=M}),define(ye[85],De([1,0,12]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function v(T){return T.scheme===a.Schemas.vscodeRemote?T.authority:void 0}e.getRemoteAuthority=v;function b(T){if(!T)return;const O=T.indexOf("+");return O<0?T:T.substr(0,O)}e.getRemoteName=b;function M(T){return`/${T.quality??"oss"}-${T.commit??"dev"}`}e.getRemoteServerRootPath=M;function D(T){const{host:O,port:y}=E(T);if(typeof y=="undefined")throw new Error("Remote authority doesn't contain a port!");return{host:O,port:y}}e.parseAuthorityWithPort=D;function P(T,O){let{host:y,port:m}=E(T);return typeof m=="undefined"&&(m=O),{host:y,port:m}}e.parseAuthorityWithOptionalPort=P;function E(T){const O=T.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(O)return{host:O[1],port:parseInt(O[2],10)};const y=T.match(/^(\[[0-9a-z:]+\])$/);if(y)return{host:y[1],port:void 0};const m=T.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:T,port:void 0}}}),define(ye[27],De([1,0,9,3,85]),function(ne,e,a,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function M(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}e.getWorkspaceSupportTypeMessage=M;function D(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=D,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));var E;(function(f){f.WIN32_X64="win32-x64",f.WIN32_IA32="win32-ia32",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(E=e.TargetPlatform||(e.TargetPlatform={}));class T{constructor(h){this.value=h,this._lower=h.toLowerCase()}static equals(h,d){if(typeof h=="undefined"||h===null)return typeof d=="undefined"||d===null;if(typeof d=="undefined"||d===null)return!1;if(typeof h=="string"||typeof d=="string"){const o=typeof h=="string"?h:h.value,g=typeof d=="string"?d:d.value;return a.equalsIgnoreCase(o,g)}return h._lower===d._lower}static toKey(h){return typeof h=="string"?h.toLowerCase():h._lower}}e.ExtensionIdentifier=T;function O(f){return y(f)}e.isApplicationScopedExtension=O;function y(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}e.isLanguagePackExtension=y;function m(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=m;function k(f,h){if(h){const d=`onResolveRemoteAuthority:${(0,b.getRemoteName)(h)}`;return f.activationEvents?.indexOf(d)!==-1}return!1}e.isResolverExtension=k,e.IBuiltinExtensionsScannerService=(0,v.createDecorator)("IBuiltinExtensionsScannerService")}),define(ye[153],De([1,0,9,79,27,21,2,11,59]),function(ne,e,a,v,b,M,D,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function T(u,n){return u.uuid&&n.uuid?u.uuid===n.uuid:u.id===n.id?!0:(0,a.compareIgnoreCase)(u.id,n.id)===0}e.areSameExtensions=T;const O=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class y{constructor(n,i,r="undefined"){this.version=i,this.targetPlatform=r,this.id=n.id}static create(n){const i=n.manifest?n.manifest.version:n.version,r=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new y(n.identifier,i,r)}static parse(n){const i=O.exec(n);return i&&i[1]&&i[2]?new y({id:i[1]},i[2],i[4]||void 0):null}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof y?T(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.ExtensionKey=y;const m=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function k(u){const n=m.exec(u);return n&&n[1]?[h(n[1]),n[2]]:[h(u),void 0]}e.getIdAndVersion=k;function f(u,n){return`${u}.${n}`}e.getExtensionId=f;function h(u){return u.toLocaleLowerCase()}e.adoptToGalleryExtensionId=h;function d(u,n){return h(f(u,n))}e.getGalleryExtensionId=d;function o(u,n){const i=[],r=t=>{for(const c of i)if(c.some(_=>T(n(_),n(t))))return c;return null};for(const t of u){const c=r(t);c?c.push(t):i.push([t])}return i}e.groupByExtension=o;function g(u){return{id:u.identifier.id,name:u.manifest.name,galleryId:null,publisherId:u.publisherId,publisherName:u.manifest.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:u.manifest.extensionDependencies&&u.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=g;function R(u){return{id:u.identifier.id,name:u.name,galleryId:u.identifier.uuid,publisherId:u.publisherId,publisherName:u.publisher,publisherDisplayName:u.publisherDisplayName,isPreReleaseVersion:u.properties.isPreReleaseVersion,dependencies:!!(u.properties.dependencies&&u.properties.dependencies.length>0),...u.telemetryData}}e.getGalleryExtensionTelemetryData=R,e.BetterMergeId=new b.ExtensionIdentifier("pprice.better-merge");function l(u,n){const i=[],r=n.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const t=r.shift();if(t&&i.every(c=>!T(c.identifier,{id:t}))){const c=u.filter(_=>T(_.identifier,{id:t}));c.length===1&&(i.push(c[0]),r.push(...c[0].manifest.extensionDependencies?.slice(0)??[]))}}return i}e.getExtensionDependencies=l;async function w(u,n){if(!M.isLinux)return!1;let i;try{i=(await u.readFile(D.URI.file("/etc/os-release"))).value.toString()}catch{try{i=(await u.readFile(D.URI.file("/usr/lib/os-release"))).value.toString()}catch(t){n.debug("Error while getting the os-release file.",(0,P.getErrorMessage)(t))}}return!!i&&(i.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=w;async function s(u,n){const i=await w(u,n),r=(0,v.getTargetPlatform)(i?"alpine":M.platform,E.arch);return n.debug("ComputeTargetPlatform:",r),r}e.computeTargetPlatform=s}),define(ye[154],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class a{constructor(b){this._callback=b,this._terminalBufferMap=new Map}dispose(){for(const b of this._terminalBufferMap.values())b.dispose()}startBuffering(b,M,D=5){const P=M(E=>{const T=typeof E=="string"?E:E.data;let O=this._terminalBufferMap.get(b);if(O){O.data.push(T);return}const y=setTimeout(()=>this.flushBuffer(b),D);O={data:[T],timeoutId:y,dispose:()=>{clearTimeout(y),this.flushBuffer(b),P.dispose()}},this._terminalBufferMap.set(b,O)});return P}stopBuffering(b){this._terminalBufferMap.get(b)?.dispose()}flushBuffer(b){const M=this._terminalBufferMap.get(b);M&&(this._terminalBufferMap.delete(b),this._callback(b,M.data.join("")))}}e.TerminalDataBufferer=a}),define(ye[155],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var a;(function(M){M.DARK="dark",M.LIGHT="light",M.HIGH_CONTRAST_DARK="hcDark",M.HIGH_CONTRAST_LIGHT="hcLight"})(a=e.ColorScheme||(e.ColorScheme={}));function v(M){return M===a.HIGH_CONTRAST_DARK||M===a.HIGH_CONTRAST_LIGHT}e.isHighContrast=v;function b(M){return M===a.DARK||M===a.HIGH_CONTRAST_DARK}e.isDark=b}),define(ye[60],De([1,0,116,5,7,3,30,155]),function(ne,e,a,v,b,M,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,M.createDecorator)("themeService");var E;(function(d){function o(g){return g&&typeof g=="object"&&typeof g.id=="string"}d.isThemeColor=o})(E=e.ThemeColor||(e.ThemeColor={}));function T(d){return{id:d}}e.themeColorFromId=T;var O;(function(d){function o(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color=="undefined"||E.isThemeColor(i.color))}d.isThemeIcon=o;const g=new RegExp(`^\\$\\((${a.CSSIcon.iconNameExpression}(?:${a.CSSIcon.iconModifierExpression})?)\\)$`);function R(i){const r=g.exec(i);if(!r)return;const[,t]=r;return{id:t}}d.fromString=R;function l(i){return{id:i}}d.fromId=l;function w(i,r){let t=i.id;const c=t.lastIndexOf("~");return c!==-1&&(t=t.substring(0,c)),r&&(t=`${t}~${r}`),{id:t}}d.modify=w;function s(i){const r=i.id.lastIndexOf("~");if(r!==-1)return i.id.substring(r+1)}d.getModifier=s;function u(i,r){return i.id===r.id&&i.color?.id===r.color?.id}d.isEqual=u;function n(i,r){return{id:i.id,color:r?T(r):void 0}}d.asThemeIcon=n,d.asClassNameArray=a.CSSIcon.asClassNameArray,d.asClassName=a.CSSIcon.asClassName,d.asCSSSelector=a.CSSIcon.asCSSSelector})(O=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=a.Codicon.file,e.FolderThemeIcon=a.Codicon.folder;function y(d){switch(d){case P.ColorScheme.DARK:return"vs-dark";case P.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case P.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=y,e.Extensions={ThemingContribution:"base.contributions.theming"};class m{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new v.Emitter}onColorThemeChange(o){return this.themingParticipants.push(o),this.onThemingParticipantAddedEmitter.fire(o),(0,b.toDisposable)(()=>{const g=this.themingParticipants.indexOf(o);this.themingParticipants.splice(g,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const k=new m;D.Registry.add(e.Extensions.ThemingContribution,k);function f(d){return k.onColorThemeChange(d)}e.registerThemingParticipant=f;class h extends b.Disposable{constructor(o){super();this.themeService=o,this.theme=o.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(g=>this.onThemeChange(g)))}onThemeChange(o){this.theme=o,this.updateStyles()}updateStyles(){}getColor(o,g){let R=this.theme.getColor(o);return R&&g&&(R=g(R,this.theme)),R?R.toString():null}}e.Themable=h}),define(ye[156],De([1,0,5,21,3,15]),function(ne,e,a,v,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,b.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,b.createDecorator)("sharedTunnelsService");var D;(function(h){h.Http="http",h.Https="https"})(D=e.TunnelProtocol||(e.TunnelProtocol={}));var P;(function(h){h.ConstantPrivate="constantPrivate",h.Private="private",h.Public="public"})(P=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var E;(function(h){h[h.Notify=1]="Notify",h[h.OpenBrowser=2]="OpenBrowser",h[h.OpenPreview=3]="OpenPreview",h[h.Silent=4]="Silent",h[h.Ignore=5]="Ignore",h[h.OpenBrowserOnce=6]="OpenBrowserOnce"})(E=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function T(h){if(h.scheme!=="http"&&h.scheme!=="https")return;const d=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(h.authority);if(!!d)return{address:d[1],port:+d[2]}}e.extractLocalHostUriMetaDataForPortMapping=T,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function O(h){return e.LOCALHOST_ADDRESSES.indexOf(h)>=0}e.isLocalhost=O,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function y(h){return e.ALL_INTERFACES_ADDRESSES.indexOf(h)>=0}e.isAllInterfaces=y;function m(h,d){return d?d!==1&&h<1024:!v.isWindows&&h<1024}e.isPortPrivileged=m;class k{constructor(d,o,g){this.remoteAddress=d,this.localAddress=o,this._dispose=g,this._onDispose=new a.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=k;let f=class{constructor(d){this.logService=d,this._onTunnelOpened=new a.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new a.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new a.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(d){return this._tunnelProvider=d,d?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(d){this._canElevate=d.elevation,this._privacyOptions=d.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const d=[],o=Array.from(this._tunnels.values());for(const g of o){const R=Array.from(g.values());for(const l of R){const w=await l.value;w&&d.push(w)}}return d}async dispose(){for(const d of this._tunnels.values()){for(const{value:o}of d.values())await o.then(g=>g?.dispose());d.clear()}this._tunnels.clear()}openTunnel(d,o,g,R,l=!1,w,s){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${o}:${g} on local port ${R}.`),!d)return;if(o||(o="localhost"),this._tunnelProvider&&this._factoryInProgress.has(g)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const u=this.retainOrCreateTunnel(d,o,g,R,l,w,s);return u?u.then(n=>{if(!n){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(o,g);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const i=this.makeTunnel(n);return(n.tunnelRemoteHost!==o||n.tunnelRemotePort!==g)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(i),i}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),u)}makeTunnel(d){return{tunnelRemotePort:d.tunnelRemotePort,tunnelRemoteHost:d.tunnelRemoteHost,tunnelLocalPort:d.tunnelLocalPort,localAddress:d.localAddress,privacy:d.privacy,protocol:d.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${d.tunnelRemoteHost}:${d.tunnelRemotePort} `);const o=this._tunnels.get(d.tunnelRemoteHost);if(o){const g=o.get(d.tunnelRemotePort);g&&(g.refcount--,await this.tryDisposeTunnel(d.tunnelRemoteHost,d.tunnelRemotePort,g))}}}}async tryDisposeTunnel(d,o,g){if(g.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${d}:${o}.`);const R=g.value.then(async l=>{l&&(await l.dispose(!0),this._onTunnelClosed.fire({host:l.tunnelRemoteHost,port:l.tunnelRemotePort}))});return this._tunnels.has(d)&&this._tunnels.get(d).delete(o),R}}async closeTunnel(d,o){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${d}:${o} `);const g=this._tunnels.get(d);if(g&&g.has(o)){const R=g.get(o);R.refcount=0,await this.tryDisposeTunnel(d,o,R)}}addTunnelToMap(d,o,g){this._tunnels.has(d)||this._tunnels.set(d,new Map),this._tunnels.get(d).set(o,{refcount:1,value:g})}async removeEmptyTunnelFromMap(d,o){const g=this._tunnels.get(d);g&&(await g.get(o)||g.delete(o),g.size===0&&this._tunnels.delete(d))}getTunnelFromMap(d,o){const g=[d];O(d)?(g.push(...e.LOCALHOST_ADDRESSES),g.push(...e.ALL_INTERFACES_ADDRESSES)):y(d)&&g.push(...e.ALL_INTERFACES_ADDRESSES);const R=g.map(l=>this._tunnels.get(l));for(const l of R){const w=l?.get(o);if(w)return w}}canTunnel(d){return!!T(d)}createWithProvider(d,o,g,R,l,w,s){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${o}:${g} on local port ${R}.`);const u=g;this._factoryInProgress.add(u);const i={elevationRequired:l?m(R===void 0?g:R):!1},r={remoteAddress:{host:o,port:g},localAddressPort:R,privacy:w,public:w?w!==P.Private:void 0,protocol:s},t=d.forwardPort(r,i);return t?(this.addTunnelToMap(o,g,t),t.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(u)})):this._factoryInProgress.delete(u),t}};f=ze([xe(0,M.ILogService)],f),e.AbstractTunnelService=f}),define(ye[157],De([1,0,12]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function v(E){return E.scheme!==a.Schemas.file&&E.scheme!==a.Schemas.vscodeRemote}e.isVirtualResource=v;function b(E){if(E.folders.length)return E.folders.every(T=>v(T.uri))?E.folders[0].uri:void 0;if(E.configuration&&v(E.configuration))return E.configuration}e.getVirtualWorkspaceLocation=b;function M(E){return b(E)?.scheme}e.getVirtualWorkspaceScheme=M;function D(E){return b(E)?.authority}e.getVirtualWorkspaceAuthority=D;function P(E){return b(E)!==void 0}e.isVirtualWorkspace=P}),define(ye[45],De([1,0,128,19,25,22,2,3,12]),function(ne,e,a,v,b,M,D,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,P.createDecorator)("contextService");function T(n){const i=n;return typeof i?.id=="string"&&D.URI.isUri(i.uri)}e.isSingleFolderWorkspaceIdentifier=T;function O(n){if(n.configuration)return{id:n.id,configPath:n.configuration};if(n.folders.length===1)return{id:n.id,uri:n.folders[0].uri}}e.toWorkspaceIdentifier=O;function y(n){const i=n;return typeof i?.id=="string"&&D.URI.isUri(i.configPath)}e.isWorkspaceIdentifier=y;function m(n){const i=n;if(i?.uri)return{id:i.id,uri:D.URI.revive(i.uri)};const r=n;if(r?.configPath)return{id:r.id,configPath:D.URI.revive(r.configPath)};if(n?.id)return{id:n.id}}e.reviveIdentifier=m;var k;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(k=e.WorkbenchState||(e.WorkbenchState={}));function f(n){const i=n;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&Array.isArray(i.folders))}e.isWorkspace=f;function h(n){const i=n;return!!(i&&typeof i=="object"&&D.URI.isUri(i.uri)&&typeof i.name=="string"&&typeof i.toResource=="function")}e.isWorkspaceFolder=h;class d{constructor(i,r,t,c,_){this._id=i,this._transient=t,this._configuration=c,this._ignorePathCasing=_,this._foldersMap=b.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=r}update(i){this._id=i.id,this._configuration=i.configuration,this._transient=i.transient,this._ignorePathCasing=i._ignorePathCasing,this.folders=i.folders}get folders(){return this._folders}set folders(i){this._folders=i,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(i){this._configuration=i}getFolder(i){return i&&this._foldersMap.findSubstr(i)||null}updateFoldersMap(){this._foldersMap=b.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const i of this.folders)this._foldersMap.set(i.uri,i)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=d;class o{constructor(i,r){this.raw=r,this.uri=i.uri,this.index=i.index,this.name=i.name}toResource(i){return(0,M.joinPath)(this.uri,i)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=o;function g(n){return new o({uri:n,index:0,name:(0,M.basenameOrAuthority)(n)},{uri:n.toString()})}e.toWorkspaceFolder=g,e.WORKSPACE_EXTENSION="code-workspace";const R=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,a.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function l(n,i){return M.extUriBiasedIgnorePathCase.isEqualOrParent(n,i.untitledWorkspacesHome)}e.isUntitledWorkspace=l;function w(n){let i;return D.URI.isUri(n)?i=n:i=n.configuration,i?.scheme===E.Schemas.tmp}e.isTemporaryWorkspace=w;function s(n,i){return!l(n,i)&&!w(n)}e.isSavedWorkspace=s;function u(n){return(typeof n=="string"?(0,v.extname)(n):(0,M.extname)(n))===R}e.hasWorkspaceFileExtension=u}),define(ye[61],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class a{constructor(b){this.id=b,this._data=new Map,this._idPool=1}add(b){const M=this._idPool++;return this._data.set(M,b),this.logDebugInfo(),M}get(b,M){return this._data.has(b)?this._data.get(b)[M]:void 0}delete(b){this._data.delete(b),this.logDebugInfo()}logDebugInfo(){!a.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=a,a.enableDebugLogging=!1}),define(ye[35],De([1,0,12,22,3]),function(ne,e,a,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class M{constructor(){this._systemSchemes=new Set(Object.keys(a.Schemas)),this._providerInfo=new Map,this.extUri=new v.ExtUri(P=>{const E=this._providerInfo.get(P.scheme);return!(E===void 0||E&1024)})}$acceptProviderInfos(P,E){E===null?this._providerInfo.delete(P.scheme):this._providerInfo.set(P.scheme,E)}isFreeScheme(P){return!this._providerInfo.has(P)&&!this._systemSchemes.has(P)}getCapabilities(P){return this._providerInfo.get(P)}}e.ExtHostFileSystemInfo=M,e.IExtHostFileSystemInfo=(0,b.createDecorator)("IExtHostFileSystemInfo")}),define(ye[28],De([1,0,3]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,a.createDecorator)("IExtHostInitDataService")}),define(ye[158],De([1,0,14]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class v{constructor(D,P,E){this._deferredPromises=new Map,this._id=D,this._shared=P,this._storage=E,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(T=>(this._value=T,this)),this._storageListener=this._storage.onDidChangeStorage(T=>{T.shared===this._shared&&T.key===this._id&&(this._value=T.value)}),this._scheduler=new a.RunOnceScheduler(()=>{const T=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const O of T.values())O.complete()}catch(O){for(const y of T.values())y.error(O)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,D])=>D!==void 0).map(([D])=>D)}get whenReady(){return this._init}get(D,P){let E=this._value[D];return typeof E=="undefined"&&(E=P),E}update(D,P){this._value[D]=P;const E=this._deferredPromises.get(D);if(E!==void 0)return E.p;const T=new a.DeferredPromise;return this._deferredPromises.set(D,T),this._scheduler.isScheduled()||this._scheduler.schedule(),T.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=v;class b extends v{constructor(D,P){super(D.identifier.value,!0,P);this._extension=D}setKeysForSync(D){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},D)}}e.ExtensionGlobalMemento=b}),define(ye[159],De([1,0,5,2]),function(ne,e,a,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class b{constructor(D){this._notebooksAndEditors=D,this._onDidSaveNotebookDocument=new a.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new a.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(D,P,E,T){const y=this._notebooksAndEditors.getNotebookDocument(v.URI.revive(D)).acceptModelChanged(P.value,E,T);this._onDidChangeNotebookDocument.fire(y)}$acceptDirtyStateChanged(D,P){this._notebooksAndEditors.getNotebookDocument(v.URI.revive(D)).acceptDirty(P)}$acceptModelSaved(D){const P=this._notebooksAndEditors.getNotebookDocument(v.URI.revive(D));this._onDidSaveNotebookDocument.fire(P.apiNotebook)}}e.ExtHostNotebookDocuments=b}),define(ye[13],De([1,0,3]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,a.createDecorator)("IExtHostRpcService");class v{constructor(M){this.getProxy=M.getProxy.bind(M),this.set=M.set.bind(M),this.dispose=M.dispose.bind(M),this.assertRegistered=M.assertRegistered.bind(M),this.drain=M.drain.bind(M)}}e.ExtHostRpcService=v});var Ye=this&&this.__classPrivateFieldSet||function(ne,e,a,v,b){if(v==="m")throw new TypeError("Private method is not writable");if(v==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return v==="a"?b.call(ne,a):b?b.value=a:e.set(ne,a),a},Oe=this&&this.__classPrivateFieldGet||function(ne,e,a,v){if(a==="a"&&!v)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!v:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?v:a==="a"?v.call(ne):v?v.value:e.get(ne)};define(ye[160],De([1,0,27,5]),function(ne,e,a,v){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class M{constructor(P,E){b.set(this,void 0),this._onDidChange=new v.Emitter,this.onDidChange=this._onDidChange.event,this._id=a.ExtensionIdentifier.toKey(P.identifier),Ye(this,b,E,"f"),Oe(this,b,"f").onDidChangePassword(T=>{T.extensionId===this._id&&this._onDidChange.fire({key:T.key})})}get(P){return Oe(this,b,"f").get(this._id,P)}store(P,E){return Oe(this,b,"f").store(this._id,P,E)}delete(P){return Oe(this,b,"f").delete(this._id,P)}}e.ExtensionSecrets=M,b=new WeakMap}),define(ye[86],De([1,0,3,5]),function(ne,e,a,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class b{constructor(){this._onDidChangeTelemetryEnabled=new v.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=new v.Emitter,this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=0}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._productConfig.error?this._level>=2:!1,isUsageEnabled:this._productConfig.usage?this._level>=3:!1}}$initializeTelemetryLevel(D,P){this._level=D,this._productConfig=P||{usage:!0,error:!0}}$onDidChangeTelemetryLevel(D){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=D,this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails())}}e.ExtHostTelemetry=b,e.IExtHostTelemetry=(0,a.createDecorator)("IExtHostTelemetry")}),define(ye[62],De([1,0,3,156,5,13]),function(ne,e,a,v,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var D;(function(E){function T(y){return{remoteAddress:y.remoteAddress,localAddress:y.localAddress,public:!!y.public,privacy:y.privacy??(y.public?v.TunnelPrivacyId.Public:v.TunnelPrivacyId.Private),protocol:y.protocol}}E.fromApiTunnel=T;function O(y){return{remoteAddress:{host:y.tunnelRemoteHost,port:y.tunnelRemotePort},localAddress:y.localAddress,public:y.privacy!==v.TunnelPrivacyId.ConstantPrivate&&y.privacy!==v.TunnelPrivacyId.ConstantPrivate,privacy:y.privacy,protocol:y.protocol}}E.fromServiceTunnel=O})(D=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,a.createDecorator)("IExtHostTunnelService");let P=class{constructor(T){this.onDidChangeTunnels=new b.Emitter().event}async $applyCandidateFilter(T){return T}async openTunnel(T,O){}async getTunnels(){return[]}async setTunnelFactory(T){return{dispose:()=>{}}}registerPortsAttributesProvider(T,O){return{dispose:()=>{}}}async $providePortAttributes(T,O,y,m,k){return[]}async $forwardPort(T,O){}async $closeTunnel(T){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};P=ze([xe(0,M.IExtHostRpcService)],P),e.ExtHostTunnelService=P});var Ye=this&&this.__classPrivateFieldSet||function(ne,e,a,v,b){if(v==="m")throw new TypeError("Private method is not writable");if(v==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return v==="a"?b.call(ne,a):b?b.value=a:e.set(ne,a),a},Oe=this&&this.__classPrivateFieldGet||function(ne,e,a,v){if(a==="a"&&!v)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!v:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?v:a==="a"?v.call(ne):v?v.value:e.get(ne)};define(ye[6],De([1,0,16,11,75,25,74,9,10,2,42,39,84]),function(ne,e,a,v,b,M,D,P,E,T,O,y,m){"use strict";var k,f,h,d,o,g,R,l,w,s,u,n,i,r,t,c,_,p,C,U,W,L,S;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKindNew=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionsNew=e.InlineSuggestionNew=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function z(x){function N(){return Reflect.construct(x,arguments,this.constructor)}return Object.defineProperty(N,"name",Object.getOwnPropertyDescriptor(x,"name")),Object.setPrototypeOf(N,x),Object.setPrototypeOf(N.prototype,x.prototype),N}let $=g=class{constructor(N){k.set(this,void 0),Ye(this,k,N,"f")}static from(...N){let Y=N;return new g(function(){if(Y){for(const _e of Y)_e&&typeof _e.dispose=="function"&&_e.dispose();Y=void 0}})}dispose(){typeof Oe(this,k,"f")=="function"&&(Oe(this,k,"f").call(this),Ye(this,k,void 0,"f"))}};k=new WeakMap,$=g=ze([z],$),e.Disposable=$;let F=R=class{constructor(N,Y){if(N<0)throw(0,v.illegalArgument)("line must be non-negative");if(Y<0)throw(0,v.illegalArgument)("character must be non-negative");this._line=N,this._character=Y}static Min(...N){if(N.length===0)throw new TypeError;let Y=N[0];for(let _e=1;_e<N.length;_e++){const Ke=N[_e];Ke.isBefore(Y)&&(Y=Ke)}return Y}static Max(...N){if(N.length===0)throw new TypeError;let Y=N[0];for(let _e=1;_e<N.length;_e++){const Ke=N[_e];Ke.isAfter(Y)&&(Y=Ke)}return Y}static isPosition(N){if(!N)return!1;if(N instanceof R)return!0;const{line:Y,character:_e}=N;return typeof Y=="number"&&typeof _e=="number"}static of(N){if(N instanceof R)return N;if(this.isPosition(N))return new R(N.line,N.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}isBefore(N){return this._line<N._line?!0:N._line<this._line?!1:this._character<N._character}isBeforeOrEqual(N){return this._line<N._line?!0:N._line<this._line?!1:this._character<=N._character}isAfter(N){return!this.isBeforeOrEqual(N)}isAfterOrEqual(N){return!this.isBefore(N)}isEqual(N){return this._line===N._line&&this._character===N._character}compareTo(N){return this._line<N._line?-1:this._line>N.line?1:this._character<N._character?-1:this._character>N._character?1:0}translate(N,Y=0){if(N===null||Y===null)throw(0,v.illegalArgument)();let _e;return typeof N=="undefined"?_e=0:typeof N=="number"?_e=N:(_e=typeof N.lineDelta=="number"?N.lineDelta:0,Y=typeof N.characterDelta=="number"?N.characterDelta:0),_e===0&&Y===0?this:new R(this.line+_e,this.character+Y)}with(N,Y=this.character){if(N===null||Y===null)throw(0,v.illegalArgument)();let _e;return typeof N=="undefined"?_e=this.line:typeof N=="number"?_e=N:(_e=typeof N.line=="number"?N.line:this.line,Y=typeof N.character=="number"?N.character:this.character),_e===this.line&&Y===this.character?this:new R(_e,Y)}toJSON(){return{line:this.line,character:this.character}}};F=R=ze([z],F),e.Position=F;let q=l=class{constructor(N,Y,_e,Ke){let et,at;if(typeof N=="number"&&typeof Y=="number"&&typeof _e=="number"&&typeof Ke=="number"?(et=new F(N,Y),at=new F(_e,Ke)):F.isPosition(N)&&F.isPosition(Y)&&(et=F.of(N),at=F.of(Y)),!et||!at)throw new Error("Invalid arguments");et.isBefore(at)?(this._start=et,this._end=at):(this._start=at,this._end=et)}static isRange(N){return N instanceof l?!0:N?F.isPosition(N.start)&&F.isPosition(N.end):!1}static of(N){if(N instanceof l)return N;if(this.isRange(N))return new l(N.start,N.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}contains(N){return l.isRange(N)?this.contains(N.start)&&this.contains(N.end):F.isPosition(N)?!(F.of(N).isBefore(this._start)||this._end.isBefore(N)):!1}isEqual(N){return this._start.isEqual(N._start)&&this._end.isEqual(N._end)}intersection(N){const Y=F.Max(N.start,this._start),_e=F.Min(N.end,this._end);if(!Y.isAfter(_e))return new l(Y,_e)}union(N){if(this.contains(N))return this;if(N.contains(this))return N;const Y=F.Min(N.start,this._start),_e=F.Max(N.end,this.end);return new l(Y,_e)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(N,Y=this.end){if(N===null||Y===null)throw(0,v.illegalArgument)();let _e;return N?F.isPosition(N)?_e=N:(_e=N.start||this.start,Y=N.end||this.end):_e=this.start,_e.isEqual(this._start)&&Y.isEqual(this.end)?this:new l(_e,Y)}toJSON(){return[this.start,this.end]}};q=l=ze([z],q),e.Range=q;let ie=w=class extends q{constructor(N,Y,_e,Ke){let et,at;if(typeof N=="number"&&typeof Y=="number"&&typeof _e=="number"&&typeof Ke=="number"?(et=new F(N,Y),at=new F(_e,Ke)):F.isPosition(N)&&F.isPosition(Y)&&(et=F.of(N),at=F.of(Y)),!et||!at)throw new Error("Invalid arguments");super(et,at);this._anchor=et,this._active=at}static isSelection(N){return N instanceof w?!0:N?q.isRange(N)&&F.isPosition(N.anchor)&&F.isPosition(N.active)&&typeof N.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};ie=w=ze([z],ie),e.Selection=ie;class A{constructor(N,Y,_e){if(typeof N!="string"||N.length===0)throw(0,v.illegalArgument)("host");if(typeof Y!="number"||Y===0||Math.round(Y)!==Y)throw(0,v.illegalArgument)("port");if(typeof _e!="undefined"&&(typeof _e!="string"||_e.length===0||!/^[0-9A-Za-z\-]+$/.test(_e)))throw(0,v.illegalArgument)("connectionToken");this.host=N,this.port=Math.round(Y),this.connectionToken=_e}}e.ResolvedAuthority=A;class Z extends Error{constructor(N,Y=m.RemoteAuthorityResolverErrorCode.Unknown,_e){super(N);this._message=N,this._code=Y,this._detail=_e,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,Z.prototype)}static NotAvailable(N,Y){return new Z(N,m.RemoteAuthorityResolverErrorCode.NotAvailable,Y)}static TemporarilyNotAvailable(N){return new Z(N,m.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=Z;var le;(function(x){x[x.LF=1]="LF",x[x.CRLF=2]="CRLF"})(le=e.EndOfLine||(e.EndOfLine={}));var oe;(function(x){x[x.Replace=1]="Replace",x[x.Append=2]="Append",x[x.Prepend=3]="Prepend"})(oe=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let ue=s=class{constructor(N,Y){this._range=N,this._newText=Y}static isTextEdit(N){return N instanceof s?!0:N?q.isRange(N)&&typeof N.newText=="string":!1}static replace(N,Y){return new s(N,Y)}static insert(N,Y){return s.replace(new q(N,N),Y)}static delete(N){return s.replace(N,"")}static setEndOfLine(N){const Y=new s(new q(new F(0,0),new F(0,0)),"");return Y.newEol=N,Y}get range(){return this._range}set range(N){if(N&&!q.isRange(N))throw(0,v.illegalArgument)("range");this._range=N}get newText(){return this._newText||""}set newText(N){if(N&&typeof N!="string")throw(0,v.illegalArgument)("newText");this._newText=N}get newEol(){return this._newEol}set newEol(N){if(N&&typeof N!="number")throw(0,v.illegalArgument)("newEol");this._newEol=N}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};ue=s=ze([z],ue),e.TextEdit=ue;let te=u=class{constructor(N,Y){this.range=N,this.newCells=Y}static isNotebookCellEdit(N){return N instanceof u?!0:N?xt.isNotebookRange(N)&&Array.isArray(N.newCells):!1}static replaceCells(N,Y){return new u(N,Y)}static insertCells(N,Y){return new u(new xt(N,N),Y)}static deleteCells(N){return new u(N,[])}static updateCellMetadata(N,Y){const _e=new u(new xt(N,N),[]);return _e.newCellMetadata=Y,_e}static updateNotebookMetadata(N){const Y=new u(new xt(0,0),[]);return Y.newNotebookMetadata=N,Y}};te=u=ze([z],te),e.NotebookEdit=te;var Ee;(function(x){x[x.File=1]="File",x[x.Text=2]="Text",x[x.Cell=3]="Cell",x[x.CellReplace=5]="CellReplace",x[x.Snippet=6]="Snippet"})(Ee=e.FileEditType||(e.FileEditType={}));let be=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(N,Y,_e,Ke){this._edits.push({_type:1,from:N,to:Y,options:_e,metadata:Ke})}createFile(N,Y,_e){this._edits.push({_type:1,from:void 0,to:N,options:Y,metadata:_e})}deleteFile(N,Y,_e){this._edits.push({_type:1,from:N,to:void 0,options:Y,metadata:_e})}replaceNotebookMetadata(N,Y,_e){this._edits.push({_type:3,metadata:_e,uri:N,edit:{editType:5,metadata:Y},notebookMetadata:Y})}replaceNotebookCells(N,Y,_e,Ke,et){let at,lt,St=[],At;if(xt.isNotebookRange(Y)&&Gt.isNotebookCellDataArray(_e)&&!Gt.isNotebookCellDataArray(Ke)?(at=Y.start,lt=Y.end,St=_e,At=Ke):typeof Y=="number"&&typeof _e=="number"&&Gt.isNotebookCellDataArray(Ke)&&(at=Y,lt=_e,St=Ke,At=et),at===void 0||lt===void 0)throw new Error("Invalid arguments");(at!==lt||St.length>0)&&this._edits.push({_type:5,uri:N,index:at,count:lt-at,cells:St,metadata:At})}replaceNotebookCellMetadata(N,Y,_e,Ke){this._edits.push({_type:3,metadata:Ke,uri:N,edit:{editType:8,index:Y,metadata:_e}})}replace(N,Y,_e,Ke){typeof _e=="string"?this._edits.push({_type:2,uri:N,edit:new ue(Y,_e),metadata:Ke}):this._edits.push({_type:6,uri:N,range:Y,edit:_e,metadata:Ke})}insert(N,Y,_e,Ke){this.replace(N,new q(Y,Y),_e,Ke)}delete(N,Y,_e){this.replace(N,Y,"",_e)}has(N){return this._edits.some(Y=>Y._type===2&&Y.uri.toString()===N.toString())}set(N,Y){if(Y)for(const _e of Y)_e&&(te.isNotebookCellEdit(_e)?_e.newCellMetadata?this.replaceNotebookCellMetadata(N,_e.range.start,_e.newCellMetadata):_e.newNotebookMetadata?this.replaceNotebookMetadata(N,_e.newNotebookMetadata):this.replaceNotebookCells(N,_e.range,_e.newCells):this._edits.push({_type:2,uri:N,edit:_e}));else{for(let _e=0;_e<this._edits.length;_e++){const Ke=this._edits[_e];Ke._type===2&&Ke.uri.toString()===N.toString()&&(this._edits[_e]=void 0)}(0,a.coalesceInPlace)(this._edits)}}get(N){const Y=[];for(const _e of this._edits)_e._type===2&&_e.uri.toString()===N.toString()&&Y.push(_e.edit);return Y}entries(){const N=new M.ResourceMap;for(const Y of this._edits)if(Y._type===2){let _e=N.get(Y.uri);_e||(_e=[Y.uri,[]],N.set(Y.uri,_e)),_e[1].push(Y.edit)}return[...N.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};be=ze([z],be),e.WorkspaceEdit=be;let ee=n=class{constructor(N){this._tabstop=1,this.value=N||""}static isSnippetString(N){return N instanceof n?!0:N?typeof N.value=="string":!1}static _escape(N){return N.replace(/\$|}|\\/g,"\\$&")}appendText(N){return this.value+=n._escape(N),this}appendTabstop(N=this._tabstop++){return this.value+="$",this.value+=N,this}appendPlaceholder(N,Y=this._tabstop++){if(typeof N=="function"){const _e=new n;_e._tabstop=this._tabstop,N(_e),this._tabstop=_e._tabstop,N=_e.value}else N=n._escape(N);return this.value+="${",this.value+=Y,this.value+=":",this.value+=N,this.value+="}",this}appendChoice(N,Y=this._tabstop++){const _e=N.map(Ke=>Ke.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=Y,this.value+="|",this.value+=_e,this.value+="|}",this}appendVariable(N,Y){if(typeof Y=="function"){const _e=new n;_e._tabstop=this._tabstop,Y(_e),this._tabstop=_e._tabstop,Y=_e.value}else typeof Y=="string"&&(Y=Y.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=N,Y&&(this.value+=":",this.value+=Y),this.value+="}",this}};ee=n=ze([z],ee),e.SnippetString=ee;var ve;(function(x){x[x.Unnecessary=1]="Unnecessary",x[x.Deprecated=2]="Deprecated"})(ve=e.DiagnosticTag||(e.DiagnosticTag={}));var Ae;(function(x){x[x.Hint=3]="Hint",x[x.Information=2]="Information",x[x.Warning=1]="Warning",x[x.Error=0]="Error"})(Ae=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let Fe=i=class{constructor(N,Y){if(this.uri=N,Y)if(q.isRange(Y))this.range=q.of(Y);else if(F.isPosition(Y))this.range=new q(Y,Y);else throw new Error("Illegal argument")}static isLocation(N){return N instanceof i?!0:N?q.isRange(N.range)&&T.URI.isUri(N.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};Fe=i=ze([z],Fe),e.Location=Fe;let $e=class{constructor(N,Y){this.location=N,this.message=Y}static is(N){return N?typeof N.message=="string"&&N.location&&q.isRange(N.location.range)&&T.URI.isUri(N.location.uri):!1}static isEqual(N,Y){return N===Y?!0:!N||!Y?!1:N.message===Y.message&&N.location.range.isEqual(Y.location.range)&&N.location.uri.toString()===Y.location.uri.toString()}};$e=ze([z],$e),e.DiagnosticRelatedInformation=$e;let Qe=class{constructor(N,Y,_e=Ae.Error){if(!q.isRange(N))throw new TypeError("range must be set");if(!Y)throw new TypeError("message must be set");this.range=N,this.message=Y,this.severity=_e}toJSON(){return{severity:Ae[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(N,Y){return N===Y?!0:!N||!Y?!1:N.message===Y.message&&N.severity===Y.severity&&N.code===Y.code&&N.severity===Y.severity&&N.source===Y.source&&N.range.isEqual(Y.range)&&(0,a.equals)(N.tags,Y.tags)&&(0,a.equals)(N.relatedInformation,Y.relatedInformation,$e.isEqual)}};Qe=ze([z],Qe),e.Diagnostic=Qe;let Ie=class{constructor(N,Y){if(!N)throw new Error("Illegal argument, contents must be defined");Array.isArray(N)?this.contents=N:this.contents=[N],this.range=Y}};Ie=ze([z],Ie),e.Hover=Ie;var Se;(function(x){x[x.Text=0]="Text",x[x.Read=1]="Read",x[x.Write=2]="Write"})(Se=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let ke=class{constructor(N,Y=Se.Text){this.range=N,this.kind=Y}toJSON(){return{range:this.range,kind:Se[this.kind]}}};ke=ze([z],ke),e.DocumentHighlight=ke;var ae;(function(x){x[x.File=0]="File",x[x.Module=1]="Module",x[x.Namespace=2]="Namespace",x[x.Package=3]="Package",x[x.Class=4]="Class",x[x.Method=5]="Method",x[x.Property=6]="Property",x[x.Field=7]="Field",x[x.Constructor=8]="Constructor",x[x.Enum=9]="Enum",x[x.Interface=10]="Interface",x[x.Function=11]="Function",x[x.Variable=12]="Variable",x[x.Constant=13]="Constant",x[x.String=14]="String",x[x.Number=15]="Number",x[x.Boolean=16]="Boolean",x[x.Array=17]="Array",x[x.Object=18]="Object",x[x.Key=19]="Key",x[x.Null=20]="Null",x[x.EnumMember=21]="EnumMember",x[x.Struct=22]="Struct",x[x.Event=23]="Event",x[x.Operator=24]="Operator",x[x.TypeParameter=25]="TypeParameter"})(ae=e.SymbolKind||(e.SymbolKind={}));var ce;(function(x){x[x.Deprecated=1]="Deprecated"})(ce=e.SymbolTag||(e.SymbolTag={}));let G=r=class{constructor(N,Y,_e,Ke,et){this.name=N,this.kind=Y,this.containerName=et,typeof _e=="string"&&(this.containerName=_e),Ke instanceof Fe?this.location=Ke:_e instanceof q&&(this.location=new Fe(Ke,_e)),r.validate(this)}static validate(N){if(!N.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:ae[this.kind],location:this.location,containerName:this.containerName}}};G=r=ze([z],G),e.SymbolInformation=G;let Q=t=class{constructor(N,Y,_e,Ke,et){this.name=N,this.detail=Y,this.kind=_e,this.range=Ke,this.selectionRange=et,this.children=[],t.validate(this)}static validate(N){if(!N.name)throw new Error("name must not be falsy");if(!N.range.contains(N.selectionRange))throw new Error("selectionRange must be contained in fullRange");N.children?.forEach(t.validate)}};Q=t=ze([z],Q),e.DocumentSymbol=Q;var I;(function(x){x[x.Invoke=1]="Invoke",x[x.Automatic=2]="Automatic"})(I=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let B=class{constructor(N,Y){this.title=N,this.kind=Y}};B=ze([z],B),e.CodeAction=B;let H=c=class{constructor(N){this.value=N}append(N){return new c(this.value?this.value+c.sep+N:N)}intersects(N){return this.contains(N)||N.contains(this)}contains(N){return this.value===N.value||N.value.startsWith(this.value+c.sep)}};H.sep=".",H=c=ze([z],H),e.CodeActionKind=H,H.Empty=new H(""),H.QuickFix=H.Empty.append("quickfix"),H.Refactor=H.Empty.append("refactor"),H.RefactorExtract=H.Refactor.append("extract"),H.RefactorInline=H.Refactor.append("inline"),H.RefactorRewrite=H.Refactor.append("rewrite"),H.Source=H.Empty.append("source"),H.SourceOrganizeImports=H.Source.append("organizeImports"),H.SourceFixAll=H.Source.append("fixAll");let V=class{constructor(N,Y){if(this.range=N,this.parent=Y,Y&&!Y.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};V=ze([z],V),e.SelectionRange=V;class se{constructor(N,Y,_e,Ke,et,at){this.kind=N,this.name=Y,this.detail=_e,this.uri=Ke,this.range=et,this.selectionRange=at}}e.CallHierarchyItem=se;class de{constructor(N,Y){this.fromRanges=Y,this.from=N}}e.CallHierarchyIncomingCall=de;class J{constructor(N,Y){this.fromRanges=Y,this.to=N}}e.CallHierarchyOutgoingCall=J;var pe;(function(x){x[x.Information=0]="Information",x[x.Warning=1]="Warning",x[x.Error=2]="Error"})(pe=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let ge=class{constructor(N,Y){this.range=N,this.command=Y}get isResolved(){return!!this.command}};ge=ze([z],ge),e.CodeLens=ge;let Ne=_=class{constructor(N,Y=!1){f.set(this,void 0),Ye(this,f,new b.MarkdownString(N,{supportThemeIcons:Y}),"f")}static isMarkdownString(N){return N instanceof _?!0:N&&N.appendCodeblock&&N.appendMarkdown&&N.appendText&&N.value!==void 0}get value(){return Oe(this,f,"f").value}set value(N){Oe(this,f,"f").value=N}get isTrusted(){return Oe(this,f,"f").isTrusted}set isTrusted(N){Oe(this,f,"f").isTrusted=N}get supportThemeIcons(){return Oe(this,f,"f").supportThemeIcons}set supportThemeIcons(N){Oe(this,f,"f").supportThemeIcons=N}get supportHtml(){return Oe(this,f,"f").supportHtml}set supportHtml(N){Oe(this,f,"f").supportHtml=N}get baseUri(){return Oe(this,f,"f").baseUri}set baseUri(N){Oe(this,f,"f").baseUri=N}appendText(N){return Oe(this,f,"f").appendText(N),this}appendMarkdown(N){return Oe(this,f,"f").appendMarkdown(N),this}appendCodeblock(N,Y){return Oe(this,f,"f").appendCodeblock(Y??"",N),this}};f=new WeakMap,Ne=_=ze([z],Ne),e.MarkdownString=Ne;let Be=class{constructor(N,Y){this.label=N,this.documentation=Y}};Be=ze([z],Be),e.ParameterInformation=Be;let Je=class{constructor(N,Y){this.label=N,this.documentation=Y,this.parameters=[]}};Je=ze([z],Je),e.SignatureInformation=Je;let Ge=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};Ge=ze([z],Ge),e.SignatureHelp=Ge;var Te;(function(x){x[x.Invoke=1]="Invoke",x[x.TriggerCharacter=2]="TriggerCharacter",x[x.ContentChange=3]="ContentChange"})(Te=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var rt;(function(x){x[x.Type=1]="Type",x[x.Parameter=2]="Parameter"})(rt=e.InlayHintKind||(e.InlayHintKind={}));let K=class{constructor(N){this.value=N}};K=ze([z],K),e.InlayHintLabelPart=K;let X=class{constructor(N,Y,_e){this.position=N,this.label=Y,this.kind=_e}};X=ze([z],X),e.InlayHint=X;var fe;(function(x){x[x.Invoke=0]="Invoke",x[x.TriggerCharacter=1]="TriggerCharacter",x[x.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(fe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ue;(function(x){x[x.Text=0]="Text",x[x.Method=1]="Method",x[x.Function=2]="Function",x[x.Constructor=3]="Constructor",x[x.Field=4]="Field",x[x.Variable=5]="Variable",x[x.Class=6]="Class",x[x.Interface=7]="Interface",x[x.Module=8]="Module",x[x.Property=9]="Property",x[x.Unit=10]="Unit",x[x.Value=11]="Value",x[x.Enum=12]="Enum",x[x.Keyword=13]="Keyword",x[x.Snippet=14]="Snippet",x[x.Color=15]="Color",x[x.File=16]="File",x[x.Reference=17]="Reference",x[x.Folder=18]="Folder",x[x.EnumMember=19]="EnumMember",x[x.Constant=20]="Constant",x[x.Struct=21]="Struct",x[x.Event=22]="Event",x[x.Operator=23]="Operator",x[x.TypeParameter=24]="TypeParameter",x[x.User=25]="User",x[x.Issue=26]="Issue"})(Ue=e.CompletionItemKind||(e.CompletionItemKind={}));var He;(function(x){x[x.Deprecated=1]="Deprecated"})(He=e.CompletionItemTag||(e.CompletionItemTag={}));let Ze=class{constructor(N,Y){this.label=N,this.kind=Y}toJSON(){return{label:this.label,kind:this.kind&&Ue[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ze=ze([z],Ze),e.CompletionItem=Ze;let qe=class{constructor(N=[],Y=!1){this.items=N,this.isIncomplete=Y}};qe=ze([z],qe),e.CompletionList=qe;let We=class{constructor(N,Y,_e){this.insertText=N,this.range=Y,this.command=_e}};We=ze([z],We),e.InlineSuggestion=We;let nt=class{constructor(N){this.commands=void 0,this.items=N}};nt=ze([z],nt),e.InlineSuggestionList=nt;let ot=class{constructor(N,Y,_e){this.insertText=N,this.range=Y,this.command=_e}};ot=ze([z],ot),e.InlineSuggestionNew=ot;let ht=class{constructor(N,Y){this.items=N,this.commands=Y}};ht=ze([z],ht),e.InlineSuggestionsNew=ht;var kt;(function(x){x[x.Active=-1]="Active",x[x.Beside=-2]="Beside",x[x.One=1]="One",x[x.Two=2]="Two",x[x.Three=3]="Three",x[x.Four=4]="Four",x[x.Five=5]="Five",x[x.Six=6]="Six",x[x.Seven=7]="Seven",x[x.Eight=8]="Eight",x[x.Nine=9]="Nine"})(kt=e.ViewColumn||(e.ViewColumn={}));var it;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(it=e.StatusBarAlignment||(e.StatusBarAlignment={}));var dt;(function(x){x[x.Off=0]="Off",x[x.On=1]="On",x[x.Relative=2]="Relative"})(dt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ot;(function(x){x[x.Manual=1]="Manual",x[x.AfterDelay=2]="AfterDelay",x[x.FocusOut=3]="FocusOut"})(Ot=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Wt;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})(Wt=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Dt;(function(x){x[x.Keyboard=1]="Keyboard",x[x.Mouse=2]="Mouse",x[x.Command=3]="Command"})(Dt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var ft;(function(x){x[x.Undo=1]="Undo",x[x.Redo=2]="Redo"})(ft=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Ct;(function(x){x[x.OpenOpen=0]="OpenOpen",x[x.ClosedClosed=1]="ClosedClosed",x[x.OpenClosed=2]="OpenClosed",x[x.ClosedOpen=3]="ClosedOpen"})(Ct=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(x){function N(Y){switch(Y){case"keyboard":return x.Keyboard;case"mouse":return x.Mouse;case"api":return x.Command}}x.fromValue=N}(Dt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Lt=class{constructor(N,Y){if(Y&&!T.URI.isUri(Y))throw(0,v.illegalArgument)("target");if(!q.isRange(N)||N.isEmpty)throw(0,v.illegalArgument)("range");this.range=N,this.target=Y}};Lt=ze([z],Lt),e.DocumentLink=Lt;let Ft=class{constructor(N,Y,_e,Ke){this.red=N,this.green=Y,this.blue=_e,this.alpha=Ke}};Ft=ze([z],Ft),e.Color=Ft;let Ve=class{constructor(N,Y){if(Y&&!(Y instanceof Ft))throw(0,v.illegalArgument)("color");if(!q.isRange(N)||N.isEmpty)throw(0,v.illegalArgument)("range");this.range=N,this.color=Y}};Ve=ze([z],Ve),e.ColorInformation=Ve;let Nt=class{constructor(N){if(!N||typeof N!="string")throw(0,v.illegalArgument)("label");this.label=N}};Nt=ze([z],Nt),e.ColorPresentation=Nt;var Rt;(function(x){x[x.RGB=0]="RGB",x[x.HEX=1]="HEX",x[x.HSL=2]="HSL"})(Rt=e.ColorFormat||(e.ColorFormat={}));var Ut;(function(x){x[x.Error=0]="Error",x[x.Warning=1]="Warning",x[x.Information=2]="Information"})(Ut=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var vt;(function(x){x[x.Unknown=0]="Unknown",x[x.Shutdown=1]="Shutdown",x[x.Process=2]="Process",x[x.User=3]="User",x[x.Extension=4]="Extension"})(vt=e.TerminalExitReason||(e.TerminalExitReason={}));class we{constructor(N,Y,_e){if(this.startIndex=N,this.length=Y,this.tooltip=_e,typeof N!="number"||N<0)throw(0,v.illegalArgument)("startIndex");if(typeof Y!="number"||Y<1)throw(0,v.illegalArgument)("length");if(_e!==void 0&&typeof _e!="string")throw(0,v.illegalArgument)("tooltip")}}e.TerminalLink=we;var Ce;(function(x){x[x.Panel=1]="Panel",x[x.Editor=2]="Editor"})(Ce=e.TerminalLocation||(e.TerminalLocation={}));class me{constructor(N){if(this.options=N,typeof N!="object")throw(0,v.illegalArgument)("options")}}e.TerminalProfile=me;var j;(function(x){x[x.Always=1]="Always",x[x.Silent=2]="Silent",x[x.Never=3]="Never"})(j=e.TaskRevealKind||(e.TaskRevealKind={}));var Pe;(function(x){x[x.Shared=1]="Shared",x[x.Dedicated=2]="Dedicated",x[x.New=3]="New"})(Pe=e.TaskPanelKind||(e.TaskPanelKind={}));let Le=p=class{constructor(N,Y){if(this.label=Y,typeof N!="string"||typeof Y!="string")throw(0,v.illegalArgument)("name");this._id=N}static from(N){switch(N){case"clean":return p.Clean;case"build":return p.Build;case"rebuild":return p.Rebuild;case"test":return p.Test;default:return}}get id(){return this._id}};Le.Clean=new p("clean","Clean"),Le.Build=new p("build","Build"),Le.Rebuild=new p("rebuild","Rebuild"),Le.Test=new p("test","Test"),Le=p=ze([z],Le),e.TaskGroup=Le;function tt(x){let N="";for(let Y=0;Y<x.length;Y++)N+=x[Y].replace(/,/g,",,")+",";return N}let Xe=class{constructor(N,Y,_e){if(typeof N!="string")throw(0,v.illegalArgument)("process");this._args=[],this._process=N,Y!==void 0&&(Array.isArray(Y)?(this._args=Y,this._options=_e):this._options=Y)}get process(){return this._process}set process(N){if(typeof N!="string")throw(0,v.illegalArgument)("process");this._process=N}get args(){return this._args}set args(N){Array.isArray(N)||(N=[]),this._args=N}get options(){return this._options}set options(N){this._options=N}computeId(){const N=[];if(N.push("process"),this._process!==void 0&&N.push(this._process),this._args&&this._args.length>0)for(const Y of this._args)N.push(Y);return tt(N)}};Xe=ze([z],Xe),e.ProcessExecution=Xe;let je=class{constructor(N,Y,_e){if(this._args=[],Array.isArray(Y)){if(!N)throw(0,v.illegalArgument)("command can't be undefined or null");if(typeof N!="string"&&typeof N.value!="string")throw(0,v.illegalArgument)("command");this._command=N,this._args=Y,this._options=_e}else{if(typeof N!="string")throw(0,v.illegalArgument)("commandLine");this._commandLine=N,this._options=Y}}get commandLine(){return this._commandLine}set commandLine(N){if(typeof N!="string")throw(0,v.illegalArgument)("commandLine");this._commandLine=N}get command(){return this._command?this._command:""}set command(N){if(typeof N!="string"&&typeof N.value!="string")throw(0,v.illegalArgument)("command");this._command=N}get args(){return this._args}set args(N){this._args=N||[]}get options(){return this._options}set options(N){this._options=N}computeId(){const N=[];if(N.push("shell"),this._commandLine!==void 0&&N.push(this._commandLine),this._command!==void 0&&N.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const Y of this._args)N.push(typeof Y=="string"?Y:Y.value);return tt(N)}};je=ze([z],je),e.ShellExecution=je;var ut;(function(x){x[x.Escape=1]="Escape",x[x.Strong=2]="Strong",x[x.Weak=3]="Weak"})(ut=e.ShellQuoting||(e.ShellQuoting={}));var gt;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace"})(gt=e.TaskScope||(e.TaskScope={}));class yt{constructor(N){this._callback=N}computeId(){return"customExecution"+(0,O.generateUuid)()}set callback(N){this._callback=N}get callback(){return this._callback}}e.CustomExecution=yt;let pt=C=class{constructor(N,Y,_e,Ke,et,at){this.__deprecated=!1,this._definition=this.definition=N;let lt;typeof Y=="string"?(this._name=this.name=Y,this._source=this.source=_e,this.execution=Ke,lt=et,this.__deprecated=!0):Y===gt.Global||Y===gt.Workspace?(this.target=Y,this._name=this.name=_e,this._source=this.source=Ke,this.execution=et,lt=at):(this.target=Y,this._name=this.name=_e,this._source=this.source=Ke,this.execution=et,lt=at),typeof lt=="string"?(this._problemMatchers=[lt],this._hasDefinedMatchers=!0):Array.isArray(lt)?(this._problemMatchers=lt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(N){this.__id=N}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Xe?this._definition={type:C.ProcessType,id:this._execution.computeId()}:this._execution instanceof je?this._definition={type:C.ShellType,id:this._execution.computeId()}:this._execution instanceof yt?this._definition={type:C.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:C.EmptyType,id:(0,O.generateUuid)()}}get definition(){return this._definition}set definition(N){if(N==null)throw(0,v.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=N}get scope(){return this._scope}set target(N){this.clear(),this._scope=N}get name(){return this._name}set name(N){if(typeof N!="string")throw(0,v.illegalArgument)("name");this.clear(),this._name=N}get execution(){return this._execution}set execution(N){N===null&&(N=void 0),this.clear(),this._execution=N;const Y=this._definition.type;(C.EmptyType===Y||C.ProcessType===Y||C.ShellType===Y||C.ExtensionCallbackType===Y)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(N){if(Array.isArray(N))this.clear(),this._problemMatchers=N,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(N){N!==!0&&N!==!1&&(N=!1),this.clear(),this._isBackground=N}get source(){return this._source}set source(N){if(typeof N!="string"||N.length===0)throw(0,v.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=N}get group(){return this._group}set group(N){N===null&&(N=void 0),this.clear(),this._group=N}get detail(){return this._detail}set detail(N){N===null&&(N=void 0),this._detail=N}get presentationOptions(){return this._presentationOptions}set presentationOptions(N){N==null&&(N=Object.create(null)),this.clear(),this._presentationOptions=N}get runOptions(){return this._runOptions}set runOptions(N){N==null&&(N=Object.create(null)),this.clear(),this._runOptions=N}};pt.ExtensionCallbackType="customExecution",pt.ProcessType="process",pt.ShellType="shell",pt.EmptyType="$empty",pt=C=ze([z],pt),e.Task=pt;var _t;(function(x){x[x.SourceControl=1]="SourceControl",x[x.Window=10]="Window",x[x.Notification=15]="Notification"})(_t=e.ProgressLocation||(e.ProgressLocation={}));let Pt=U=class{constructor(N,Y=mt.None){this.collapsibleState=Y,T.URI.isUri(N)?this.resourceUri=N:this.label=N}static isTreeItem(N){if(N instanceof U)return!0;const Y=N;if(Y.label!==void 0&&!(0,E.isString)(Y.label)&&!Y.label.label)return console.log("INVALID tree item, invalid label",Y.label),!1;if(Y.id!==void 0&&!(0,E.isString)(Y.id))return console.log("INVALID tree item, invalid id",Y.id),!1;if(Y.iconPath!==void 0&&!(0,E.isString)(Y.iconPath)&&!T.URI.isUri(Y.iconPath)&&!(0,E.isString)(Y.iconPath.id)){const _e=Y.iconPath;if(!(0,E.isString)(_e.light)&&!T.URI.isUri(_e.light)&&!(0,E.isString)(_e.dark)&&!T.URI.isUri(_e.dark))return console.log("INVALID tree item, invalid iconPath",Y.iconPath),!1}return Y.description!==void 0&&!(0,E.isString)(Y.description)&&typeof Y.description!="boolean"?(console.log("INVALID tree item, invalid description",Y.description),!1):Y.resourceUri!==void 0&&!T.URI.isUri(Y.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Y.resourceUri),!1):Y.tooltip!==void 0&&!(0,E.isString)(Y.tooltip)&&!(Y.tooltip instanceof Ne)?(console.log("INVALID tree item, invalid tooltip",Y.tooltip),!1):Y.command!==void 0&&!Y.command.command?(console.log("INVALID tree item, invalid command",Y.command),!1):Y.collapsibleState!==void 0&&Y.collapsibleState<mt.None&&Y.collapsibleState>mt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Y.collapsibleState),!1):Y.contextValue!==void 0&&!(0,E.isString)(Y.contextValue)?(console.log("INVALID tree item, invalid contextValue",Y.contextValue),!1):Y.accessibilityInformation!==void 0&&!Y.accessibilityInformation.label?(console.log("INVALID tree item, invalid accessibilityInformation",Y.accessibilityInformation),!1):!0}};Pt=U=ze([z],Pt),e.TreeItem=Pt;var mt;(function(x){x[x.None=0]="None",x[x.Collapsed=1]="Collapsed",x[x.Expanded=2]="Expanded"})(mt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Yt=class{constructor(N){this.value=N}async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}};Yt=ze([z],Yt),e.DataTransferItem=Yt;let Jt=class{constructor(N){h.set(this,new Map);for(const[Y,_e]of N??[]){const Ke=Oe(this,h,"f").get(Y);Ke?Ke.push(_e):Oe(this,h,"f").set(Y,[_e])}}get(N){return Oe(this,h,"f").get(N)?.[0]}set(N,Y){Oe(this,h,"f").set(N,[Y])}forEach(N,Y){for(const[_e,Ke]of Oe(this,h,"f"))for(const et of Ke)N.call(Y,et,_e,this)}*[(h=new WeakMap,Symbol.iterator)](){for(const[N,Y]of Oe(this,h,"f"))for(const _e of Y)yield[N,_e]}};Jt=ze([z],Jt),e.DataTransfer=Jt;let bt=class{constructor(N){this.insertText=N}};bt=ze([z],bt),e.DocumentDropEdit=bt;let Ht=class{constructor(N){this.insertText=N}};Ht=ze([z],Ht),e.DocumentPasteEdit=Ht;let Bt=class{constructor(N,Y){this.id=N,this.color=Y}};Bt=ze([z],Bt),e.ThemeIcon=Bt,Bt.File=new Bt("file"),Bt.Folder=new Bt("folder");let oi=class{constructor(N){this.id=N}};oi=ze([z],oi),e.ThemeColor=oi;var ki;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace",x[x.WorkspaceFolder=3]="WorkspaceFolder"})(ki=e.ConfigurationTarget||(e.ConfigurationTarget={}));let It=class{constructor(N,Y){if(typeof N!="string"&&(!N||!T.URI.isUri(N)&&!T.URI.isUri(N.uri)))throw(0,v.illegalArgument)("base");if(typeof Y!="string")throw(0,v.illegalArgument)("pattern");typeof N=="string"?this.baseUri=T.URI.file(N):T.URI.isUri(N)?this.baseUri=N:this.baseUri=N.uri,this.pattern=Y}get base(){return this._base}set base(N){this._base=N,this._baseUri=T.URI.file(N)}get baseUri(){return this._baseUri}set baseUri(N){this._baseUri=N,this._base=N.fsPath}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};It=ze([z],It),e.RelativePattern=It;let qt=class{constructor(N,Y,_e,Ke){this.enabled=typeof N=="boolean"?N:!0,typeof Y=="string"&&(this.condition=Y),typeof _e=="string"&&(this.hitCondition=_e),typeof Ke=="string"&&(this.logMessage=Ke)}get id(){return this._id||(this._id=(0,O.generateUuid)()),this._id}};qt=ze([z],qt),e.Breakpoint=qt;let mi=class extends qt{constructor(N,Y,_e,Ke,et){super(Y,_e,Ke,et);if(N===null)throw(0,v.illegalArgument)("location");this.location=N}};mi=ze([z],mi),e.SourceBreakpoint=mi;let Zt=class extends qt{constructor(N,Y,_e,Ke,et){super(Y,_e,Ke,et);this.functionName=N}};Zt=ze([z],Zt),e.FunctionBreakpoint=Zt;let ei=class extends qt{constructor(N,Y,_e,Ke,et,at,lt){super(Ke,et,at,lt);if(!Y)throw(0,v.illegalArgument)("dataId");this.label=N,this.dataId=Y,this.canPersist=_e}};ei=ze([z],ei),e.DataBreakpoint=ei;let ct=class{constructor(N,Y,_e){this.command=N,this.args=Y||[],this.options=_e}};ct=ze([z],ct),e.DebugAdapterExecutable=ct;let gi=class{constructor(N,Y){this.port=N,this.host=Y}};gi=ze([z],gi),e.DebugAdapterServer=gi;let zt=class{constructor(N){this.path=N}};zt=ze([z],zt),e.DebugAdapterNamedPipeServer=zt;let Kt=class{constructor(N){this.implementation=N}};Kt=ze([z],Kt),e.DebugAdapterInlineImplementation=Kt;let ai=class{constructor(N,Y){this.range=N,this.expression=Y}};ai=ze([z],ai),e.EvaluatableExpression=ai;var Pi;(function(x){x[x.Invoke=0]="Invoke",x[x.Automatic=1]="Automatic"})(Pi=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var yi;(function(x){x[x.Invoke=0]="Invoke",x[x.Automatic=1]="Automatic"})(yi=e.InlineCompletionTriggerKindNew||(e.InlineCompletionTriggerKindNew={}));let pi=class{constructor(N,Y){this.range=N,this.text=Y}};pi=ze([z],pi),e.InlineValueText=pi;let li=class{constructor(N,Y,_e=!0){this.range=N,this.variableName=Y,this.caseSensitiveLookup=_e}};li=ze([z],li),e.InlineValueVariableLookup=li;let ti=class{constructor(N,Y){this.range=N,this.expression=Y}};ti=ze([z],ti),e.InlineValueEvaluatableExpression=ti;let vi=class{constructor(N,Y){this.frameId=N,this.stoppedLocation=Y}};vi=ze([z],vi),e.InlineValueContext=vi;var Ei;(function(x){x[x.Changed=1]="Changed",x[x.Created=2]="Created",x[x.Deleted=3]="Deleted"})(Ei=e.FileChangeType||(e.FileChangeType={}));let ii=W=class extends Error{constructor(N,Y=y.FileSystemProviderErrorCode.Unknown,_e){super(T.URI.isUri(N)?N.toString(!0):N);this.code=_e?.name??"Unknown",(0,y.markAsFileSystemProviderError)(this,Y),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,W.prototype),typeof Error.captureStackTrace=="function"&&typeof _e=="function"&&Error.captureStackTrace(this,_e)}static FileExists(N){return new W(N,y.FileSystemProviderErrorCode.FileExists,W.FileExists)}static FileNotFound(N){return new W(N,y.FileSystemProviderErrorCode.FileNotFound,W.FileNotFound)}static FileNotADirectory(N){return new W(N,y.FileSystemProviderErrorCode.FileNotADirectory,W.FileNotADirectory)}static FileIsADirectory(N){return new W(N,y.FileSystemProviderErrorCode.FileIsADirectory,W.FileIsADirectory)}static NoPermissions(N){return new W(N,y.FileSystemProviderErrorCode.NoPermissions,W.NoPermissions)}static Unavailable(N){return new W(N,y.FileSystemProviderErrorCode.Unavailable,W.Unavailable)}};ii=W=ze([z],ii),e.FileSystemError=ii;let bi=class{constructor(N,Y,_e){this.start=N,this.end=Y,this.kind=_e}};bi=ze([z],bi),e.FoldingRange=bi;var Ai;(function(x){x[x.Comment=1]="Comment",x[x.Imports=2]="Imports",x[x.Region=3]="Region"})(Ai=e.FoldingRangeKind||(e.FoldingRangeKind={}));var ni;(function(x){x[x.Collapsed=0]="Collapsed",x[x.Expanded=1]="Expanded"})(ni=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Ri;(function(x){x[x.Editing=0]="Editing",x[x.Preview=1]="Preview"})(Ri=e.CommentMode||(e.CommentMode={}));var Oi;(function(x){x[x.Unresolved=0]="Unresolved",x[x.Resolved=1]="Resolved"})(Oi=e.CommentThreadState||(e.CommentThreadState={}));class Fi{constructor(N,Y=[]){this.tokenTypes=N,this.tokenModifiers=Y}}e.SemanticTokensLegend=Fi;function Ni(x){return typeof x=="undefined"||(0,E.isStringArray)(x)}class ri{constructor(N){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,N){this._hasLegend=!0;for(let Y=0,_e=N.tokenTypes.length;Y<_e;Y++)this._tokenTypeStrToInt.set(N.tokenTypes[Y],Y);for(let Y=0,_e=N.tokenModifiers.length;Y<_e;Y++)this._tokenModifierStrToInt.set(N.tokenModifiers[Y],Y)}}push(N,Y,_e,Ke,et){if(typeof N=="number"&&typeof Y=="number"&&typeof _e=="number"&&typeof Ke=="number"&&(typeof et=="number"||typeof et=="undefined"))return typeof et=="undefined"&&(et=0),this._pushEncoded(N,Y,_e,Ke,et);if(q.isRange(N)&&typeof Y=="string"&&Ni(_e))return this._push(N,Y,_e);throw(0,v.illegalArgument)()}_push(N,Y,_e){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(N.start.line!==N.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(Y))throw new Error("`tokenType` is not in the provided legend");const Ke=N.start.line,et=N.start.character,at=N.end.character-N.start.character,lt=this._tokenTypeStrToInt.get(Y);let St=0;if(_e)for(const At of _e){if(!this._tokenModifierStrToInt.has(At))throw new Error("`tokenModifier` is not in the provided legend");const $t=this._tokenModifierStrToInt.get(At);St|=1<<$t>>>0}this._pushEncoded(Ke,et,at,lt,St)}_pushEncoded(N,Y,_e,Ke,et){if(this._dataIsSortedAndDeltaEncoded&&(N<this._prevLine||N===this._prevLine&&Y<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const St=this._data.length/5|0;let At=0,$t=0;for(let jt=0;jt<St;jt++){let Xt=this._data[5*jt],_i=this._data[5*jt+1];Xt===0?(Xt=At,_i+=$t):Xt+=At,this._data[5*jt]=Xt,this._data[5*jt+1]=_i,At=Xt,$t=_i}}let at=N,lt=Y;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(at-=this._prevLine,at===0&&(lt-=this._prevChar)),this._data[this._dataLen++]=at,this._data[this._dataLen++]=lt,this._data[this._dataLen++]=_e,this._data[this._dataLen++]=Ke,this._data[this._dataLen++]=et,this._prevLine=N,this._prevChar=Y}static _sortAndDeltaEncode(N){const Y=[],_e=N.length/5|0;for(let lt=0;lt<_e;lt++)Y[lt]=lt;Y.sort((lt,St)=>{const At=N[5*lt],$t=N[5*St];if(At===$t){const jt=N[5*lt+1],Xt=N[5*St+1];return jt-Xt}return At-$t});const Ke=new Uint32Array(N.length);let et=0,at=0;for(let lt=0;lt<_e;lt++){const St=5*Y[lt],At=N[St+0],$t=N[St+1],jt=N[St+2],Xt=N[St+3],_i=N[St+4],Qi=At-et,bn=Qi===0?$t-at:$t,Si=5*lt;Ke[Si+0]=Qi,Ke[Si+1]=bn,Ke[Si+2]=jt,Ke[Si+3]=Xt,Ke[Si+4]=_i,et=At,at=$t}return Ke}build(N){return this._dataIsSortedAndDeltaEncoded?new ci(new Uint32Array(this._data),N):new ci(ri._sortAndDeltaEncode(this._data),N)}}e.SemanticTokensBuilder=ri;class ci{constructor(N,Y){this.resultId=Y,this.data=N}}e.SemanticTokens=ci;class Di{constructor(N,Y,_e){this.start=N,this.deleteCount=Y,this.data=_e}}e.SemanticTokensEdit=Di;class Me{constructor(N,Y){this.resultId=Y,this.edits=N}}e.SemanticTokensEdits=Me;var Vt;(function(x){x[x.Separate=0]="Separate",x[x.MergeWithParent=1]="MergeWithParent"})(Vt=e.DebugConsoleMode||(e.DebugConsoleMode={}));let si=class{constructor(){}};si.Back={iconPath:new Bt("arrow-left")},si=ze([z],si),e.QuickInputButtons=si;var Et;(function(x){x[x.Separator=-1]="Separator",x[x.Default=0]="Default"})(Et=e.QuickPickItemKind||(e.QuickPickItemKind={}));var Mi;(function(x){x[x.Info=1]="Info",x[x.Warning=2]="Warning",x[x.Error=3]="Error"})(Mi=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var Li;(function(x){x[x.UI=1]="UI",x[x.Workspace=2]="Workspace"})(Li=e.ExtensionKind||(e.ExtensionKind={}));class Ci{constructor(N,Y,_e){this.badge=N,this.tooltip=Y,this.color=_e}static validate(N){if(N.badge){let Y=(0,P.nextCharLength)(N.badge,0);if(Y<N.badge.length&&(Y+=(0,P.nextCharLength)(N.badge,Y)),N.badge.length>Y)throw new Error("The 'badge'-property must be undefined or a short character")}if(!N.color&&!N.badge&&!N.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=Ci;let wi=class{constructor(N){this.kind=N}};wi=ze([z],wi),e.ColorTheme=wi;var ui;(function(x){x[x.Light=1]="Light",x[x.Dark=2]="Dark",x[x.HighContrast=3]="HighContrast",x[x.HighContrastLight=4]="HighContrastLight"})(ui=e.ColorThemeKind||(e.ColorThemeKind={}));class xt{constructor(N,Y){if(N<0)throw(0,v.illegalArgument)("start must be positive");if(Y<0)throw(0,v.illegalArgument)("end must be positive");N<=Y?(this._start=N,this._end=Y):(this._start=Y,this._end=N)}static isNotebookRange(N){return N instanceof xt?!0:N?typeof N.start=="number"&&typeof N.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(N){let Y=this._start,_e=this._end;return N.start!==void 0&&(Y=N.start),N.end!==void 0&&(_e=N.end),Y===this._start&&_e===this._end?this:new xt(Y,_e)}}e.NotebookRange=xt;class Gt{constructor(N,Y,_e,Ke,et,at,lt){this.kind=N,this.value=Y,this.languageId=_e,this.mime=Ke,this.outputs=et??[],this.metadata=at,this.executionSummary=lt,Gt.validate(this)}static validate(N){if(typeof N.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof N.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof N.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(N){return Array.isArray(N)&&N.every(Y=>Gt.isNotebookCellData(Y))}static isNotebookCellData(N){return!0}}e.NotebookCellData=Gt;class Ui{constructor(N){this.cells=N}}e.NotebookData=Ui;class Mt{constructor(N,Y){this.data=N,this.mime=Y;const _e=(0,D.normalizeMimeType)(Y,!0);if(!_e)throw new Error(`INVALID mime type: ${Y}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=_e}static isNotebookCellOutputItem(N){return N instanceof Mt?!0:N?typeof N.mime=="string"&&N.data instanceof Uint8Array:!1}static error(N){const Y={name:N.name,message:N.message,stack:N.stack};return Mt.json(Y,"application/vnd.code.notebook.error")}static stdout(N){return Mt.text(N,"application/vnd.code.notebook.stdout")}static stderr(N){return Mt.text(N,"application/vnd.code.notebook.stderr")}static bytes(N,Y="application/octet-stream"){return new Mt(N,Y)}static text(N,Y=D.Mimes.text){const _e=Oe(Mt,d,"f",o).encode(String(N));return new Mt(_e,Y)}static json(N,Y="text/x-json"){const _e=JSON.stringify(N,void 0,"	");return Mt.text(_e,Y)}}e.NotebookCellOutputItem=Mt,d=Mt,o={value:new TextEncoder};class di{constructor(N,Y,_e){this.items=di.ensureUniqueMimeTypes(N,!0),typeof Y=="string"?(this.id=Y,this.metadata=_e):(this.id=(0,O.generateUuid)(),this.metadata=Y??_e)}static isNotebookCellOutput(N){return N instanceof di?!0:!N||typeof N!="object"?!1:typeof N.id=="string"&&Array.isArray(N.items)}static ensureUniqueMimeTypes(N,Y=!1){const _e=new Set,Ke=new Set;for(let et=0;et<N.length;et++){const at=N[et],lt=(0,D.normalizeMimeType)(at.mime);if(!_e.has(lt)){_e.add(lt);continue}Ke.add(et),Y&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return Ke.size===0?N:N.filter((et,at)=>!Ke.has(at))}}e.NotebookCellOutput=di;var Bi;(function(x){x[x.Markup=1]="Markup",x[x.Code=2]="Code"})(Bi=e.NotebookCellKind||(e.NotebookCellKind={}));var zi;(function(x){x[x.Idle=1]="Idle",x[x.Pending=2]="Pending",x[x.Executing=3]="Executing"})(zi=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var xi;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(xi=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var $i;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})($i=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class re{constructor(N,Y){this.text=N,this.alignment=Y}}e.NotebookCellStatusBarItem=re;var he;(function(x){x[x.Default=1]="Default",x[x.Preferred=2]="Preferred"})(he=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Re{constructor(N,Y=[]){this.uri=N,this.provides=(0,a.asArray)(Y)}}e.NotebookRendererScript=Re;let st=class{constructor(N,Y){this.label=N,this.timestamp=Y}};st=ze([z],st),e.TimelineItem=st;var wt;(function(x){x[x.Production=1]="Production",x[x.Development=2]="Development",x[x.Test=3]="Test"})(wt=e.ExtensionMode||(e.ExtensionMode={}));var Tt;(function(x){x[x.Node=1]="Node",x[x.Webworker=2]="Webworker"})(Tt=e.ExtensionRuntime||(e.ExtensionRuntime={}));var en;(function(x){x[x.Other=0]="Other",x[x.Comment=1]="Comment",x[x.String=2]="String",x[x.RegEx=3]="RegEx"})(en=e.StandardTokenType||(e.StandardTokenType={}));class tn{constructor(N,Y){this.ranges=N,this.wordPattern=Y}}e.LinkedEditingRanges=tn;class nn{constructor(N,Y){this._port=N,this._autoForwardAction=Y}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=nn;var rn;(function(x){x[x.Queued=1]="Queued",x[x.Running=2]="Running",x[x.Passed=3]="Passed",x[x.Failed=4]="Failed",x[x.Skipped=5]="Skipped",x[x.Errored=6]="Errored"})(rn=e.TestResultState||(e.TestResultState={}));var sn;(function(x){x[x.Run=1]="Run",x[x.Debug=2]="Debug",x[x.Coverage=3]="Coverage"})(sn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Wi=class{constructor(N=void 0,Y=void 0,_e=void 0){this.include=N,this.exclude=Y,this.profile=_e}};Wi=ze([z],Wi),e.TestRunRequest=Wi;let Hi=L=class{constructor(N){this.message=N}static diff(N,Y,_e){const Ke=new L(N);return Ke.expectedOutput=Y,Ke.actualOutput=_e,Ke}};Hi=L=ze([z],Hi),e.TestMessage=Hi;let Vi=class{constructor(N){this.id=N}};Vi=ze([z],Vi),e.TestTag=Vi;let hi=class{constructor(N,Y){this.covered=N,this.total=Y}};hi=ze([z],hi),e.CoveredCount=hi;let ji=S=class{constructor(N,Y,_e,Ke){this.uri=N,this.statementCoverage=Y,this.branchCoverage=_e,this.functionCoverage=Ke}static fromDetails(N,Y){const _e=new hi(0,0),Ke=new hi(0,0),et=new hi(0,0);for(const lt of Y)if("branches"in lt){_e.total+=1,_e.covered+=lt.executionCount>0?1:0;for(const St of lt.branches)Ke.total+=1,Ke.covered+=St.executionCount>0?1:0}else et.total+=1,et.covered+=lt.executionCount>0?1:0;const at=new S(N,_e,Ke.total>0?Ke:void 0,et.total>0?et:void 0);return at.detailedCoverage=Y,at}};ji=S=ze([z],ji),e.FileCoverage=ji;let qi=class{constructor(N,Y,_e=[]){this.executionCount=N,this.location=Y,this.branches=_e}};qi=ze([z],qi),e.StatementCoverage=qi;let Ki=class{constructor(N,Y){this.executionCount=N,this.location=Y}};Ki=ze([z],Ki),e.BranchCoverage=Ki;let Gi=class{constructor(N,Y){this.executionCount=N,this.location=Y}};Gi=ze([z],Gi),e.FunctionCoverage=Gi;var on;(function(x){x[x.None=0]="None",x[x.Option=1]="Option",x[x.Default=2]="Default",x[x.Preferred=3]="Preferred"})(on=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var an;(function(x){x[x.Untrusted=0]="Untrusted",x[x.Trusted=1]="Trusted",x[x.Unspecified=2]="Unspecified"})(an=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var ln;(function(x){x[x.Notify=1]="Notify",x[x.OpenBrowser=2]="OpenBrowser",x[x.OpenPreview=3]="OpenPreview",x[x.Silent=4]="Silent",x[x.Ignore=5]="Ignore",x[x.OpenBrowserOnce=6]="OpenBrowserOnce"})(ln=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class cn{constructor(N,Y,_e,Ke,et,at){this.kind=N,this.name=Y,this.detail=_e,this.uri=Ke,this.range=et,this.selectionRange=at}}e.TypeHierarchyItem=cn;class un{constructor(N){this.uri=N}}e.TextTabInput=un;class dn{constructor(N,Y){this.original=N,this.modified=Y}}e.TextDiffTabInput=dn;class hn{constructor(N,Y,_e,Ke){this.base=N,this.input1=Y,this.input2=_e,this.result=Ke}}e.TextMergeTabInput=hn;class fn{constructor(N,Y){this.uri=N,this.viewType=Y}}e.CustomEditorTabInput=fn;class mn{constructor(N){this.viewType=N}}e.WebviewEditorTabInput=mn;class gn{constructor(N,Y){this.uri=N,this.notebookType=Y}}e.NotebookEditorTabInput=gn;class pn{constructor(N,Y,_e){this.original=N,this.modified=Y,this.notebookType=_e}}e.NotebookDiffEditorTabInput=pn;class vn{constructor(){}}e.TerminalEditorTabInput=vn;class En{constructor(N,Y){this.uri=N,this.inputBoxUri=Y}}e.InteractiveWindowInput=En}),define(ye[87],De([1,0,44,12,9,241,122,6,16]),function(ne,e,a,v,b,M,D,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const T=new Map;function O(f,h){h?T.set(f,h):T.delete(f)}e.setWordDefinitionFor=O;function y(f){return T.get(f)}e.getWordDefinitionFor=y;class m extends M.MirrorTextModel{constructor(h,d,o,g,R,l,w,s){super(d,o,g,R);this._proxy=h,this._languageId=l,this._isDirty=w,this.notebook=s,this._isDisposed=!1}dispose(){(0,a.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(h){return(0,E.equals)(this._lines,h)}get document(){if(!this._document){const h=this;this._document={get uri(){return h._uri},get fileName(){return h._uri.fsPath},get isUntitled(){return h._uri.scheme===v.Schemas.untitled},get languageId(){return h._languageId},get version(){return h._versionId},get isClosed(){return h._isDisposed},get isDirty(){return h._isDirty},save(){return h._save()},getText(d){return d?h._getTextInRange(d):h.getText()},get eol(){return h._eol===`
`?P.EndOfLine.LF:P.EndOfLine.CRLF},get lineCount(){return h._lines.length},lineAt(d){return h._lineAt(d)},offsetAt(d){return h._offsetAt(d)},positionAt(d){return h._positionAt(d)},validateRange(d){return h._validateRange(d)},validatePosition(d){return h._validatePosition(d)},getWordRangeAtPosition(d,o){return h._getWordRangeAtPosition(d,o)}}}return Object.freeze(this._document)}_acceptLanguageId(h){(0,a.ok)(!this._isDisposed),this._languageId=h}_acceptIsDirty(h){(0,a.ok)(!this._isDisposed),this._isDirty=h}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(h){const d=this._validateRange(h);if(d.isEmpty)return"";if(d.isSingleLine)return this._lines[d.start.line].substring(d.start.character,d.end.character);const o=this._eol,g=d.start.line,R=d.end.line,l=[];l.push(this._lines[g].substring(d.start.character));for(let w=g+1;w<R;w++)l.push(this._lines[w]);return l.push(this._lines[R].substring(0,d.end.character)),l.join(o)}_lineAt(h){let d;if(h instanceof P.Position?d=h.line:typeof h=="number"&&(d=h),typeof d!="number"||d<0||d>=this._lines.length||Math.floor(d)!==d)throw new Error("Illegal value for `line`");return new k(d,this._lines[d],d===this._lines.length-1)}_offsetAt(h){return h=this._validatePosition(h),this._ensureLineStarts(),this._lineStarts.getPrefixSum(h.line-1)+h.character}_positionAt(h){h=Math.floor(h),h=Math.max(0,h),this._ensureLineStarts();const d=this._lineStarts.getIndexOf(h),o=this._lines[d.index].length;return new P.Position(d.index,Math.min(d.remainder,o))}_validateRange(h){if(!(h instanceof P.Range))throw new Error("Invalid argument");const d=this._validatePosition(h.start),o=this._validatePosition(h.end);return d===h.start&&o===h.end?h:new P.Range(d.line,d.character,o.line,o.character)}_validatePosition(h){if(!(h instanceof P.Position))throw new Error("Invalid argument");if(this._lines.length===0)return h.with(0,0);let{line:d,character:o}=h,g=!1;if(d<0)d=0,o=0,g=!0;else if(d>=this._lines.length)d=this._lines.length-1,o=this._lines[d].length,g=!0;else{const R=this._lines[d].length;o<0?(o=0,g=!0):o>R&&(o=R,g=!0)}return g?new P.Position(d,o):h}_getWordRangeAtPosition(h,d){const o=this._validatePosition(h);if(!d)d=y(this._languageId);else if((0,b.regExpLeadsToEndlessLoop)(d))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${d.source}' because it matches the empty string.`);const g=(0,D.getWordAtText)(o.character+1,(0,D.ensureValidWordDefinition)(d),this._lines[o.line],0);if(g)return new P.Range(o.line,g.startColumn-1,o.line,g.endColumn-1)}}e.ExtHostDocumentData=m;class k{constructor(h,d,o){this._line=h,this._text=d,this._isLastLine=o}get lineNumber(){return this._line}get text(){return this._text}get range(){return new P.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new P.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=k}),define(ye[161],De([1,0,6,13,5]),function(ne,e,a,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let M=class{constructor(P){this._actual=new a.ColorTheme(a.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new b.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(P){let E;switch(P){case"light":E=a.ColorThemeKind.Light;break;case"hcDark":E=a.ColorThemeKind.HighContrast;break;case"hcLight":E=a.ColorThemeKind.HighContrastLight;break;default:E=a.ColorThemeKind.Dark}this._actual=new a.ColorTheme(E),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};M=ze([xe(0,v.IExtHostRpcService)],M),e.ExtHostTheming=M}),define(ye[63],De([1,0,3]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,a.createDecorator)("IURITransformerService");class v{constructor(M){M?(this.transformIncoming=M.transformIncoming.bind(M),this.transformOutgoing=M.transformOutgoing.bind(M),this.transformOutgoingURI=M.transformOutgoingURI.bind(M),this.transformOutgoingScheme=M.transformOutgoingScheme.bind(M)):(this.transformIncoming=D=>D,this.transformOutgoing=D=>D,this.transformOutgoingURI=D=>D,this.transformOutgoingScheme=D=>D)}}e.URITransformerService=v}),define(ye[162],De([1,0,23]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class v{constructor(){this.buffers=[]}add(E){let T=this.buffers.indexOf(E);return T<0&&(T=this.buffers.length,this.buffers.push(E)),T}}function b(P,E){if(E.serializeBuffersForPostMessage){const T=new v,O=(k,f)=>{if(f instanceof ArrayBuffer){const h=T.add(f);return{$$vscode_array_buffer_reference$$:!0,index:h}}else if(ArrayBuffer.isView(f)){const h=M(f);if(h){const d=T.add(f.buffer);return{$$vscode_array_buffer_reference$$:!0,index:d,view:{type:h,byteLength:f.byteLength,byteOffset:f.byteOffset}}}}return f},y=JSON.stringify(P,O),m=T.buffers.map(k=>{const f=new Uint8Array(k);return a.VSBuffer.wrap(f)});return{message:y,buffers:m}}else return{message:JSON.stringify(P),buffers:[]}}e.serializeWebviewMessage=b;function M(P){switch(P.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function D(P,E){const T=E.map(m=>{const k=new ArrayBuffer(m.byteLength);return new Uint8Array(k).set(m.buffer),k}),O=E.length?(m,k)=>{if(k&&typeof k=="object"&&k.$$vscode_array_buffer_reference$$){const f=k,{index:h}=f,d=T[h];if(f.view)switch(f.view.type){case 1:return new Int8Array(d,f.view.byteOffset,f.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(d,f.view.byteOffset,f.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(d,f.view.byteOffset,f.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(d,f.view.byteOffset,f.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(d,f.view.byteOffset,f.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(d,f.view.byteOffset,f.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(d,f.view.byteOffset,f.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(d,f.view.byteOffset,f.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(d,f.view.byteOffset,f.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(d,f.view.byteOffset,f.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(d,f.view.byteOffset,f.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return d}return k}:void 0;return{message:JSON.parse(P,O),arrayBuffers:T}}e.deserializeWebviewMessage=D}),define(ye[163],De([1,0,136,10,2,7,3,30,39,16,12]),function(ne,e,a,v,b,M,D,P,E,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,a.localize)(0,null),providerDisplayName:(0,a.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var y;(function(A){A[A.PROGRAMMATIC=1]="PROGRAMMATIC",A[A.USER=2]="USER",A[A.EDIT=3]="EDIT",A[A.NAVIGATION=4]="NAVIGATION",A[A.JUMP=5]="JUMP"})(y=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var m;(function(A){A[A.IDENTICAL=1]="IDENTICAL",A[A.SIMILAR=2]="SIMILAR",A[A.DIFFERENT=3]="DIFFERENT"})(m=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function k(A){const Z=A;return!!Z&&typeof Z.getSelection=="function"&&!!Z.onDidChangeSelection}e.isEditorPaneWithSelection=k;function f(A,Z,le){for(const oe of le.visibleEditorPanes)if(oe.group.id===Z&&A.matches(oe.input))return oe.getViewState()}e.findViewStateForEditor=f;function h(A){if(i(A))return!1;const Z=A;return b.URI.isUri(Z?.resource)}e.isResourceEditorInput=h;function d(A){if(i(A))return!1;const Z=A;return Z?.original!==void 0&&Z.modified!==void 0}e.isResourceDiffEditorInput=d;function o(A){if(i(A)||d(A))return!1;const Z=A;return Z?.primary!==void 0&&Z.secondary!==void 0}e.isResourceSideBySideEditorInput=o;function g(A){if(i(A))return!1;const Z=A;return Z?Z.resource===void 0||Z.resource.scheme===O.Schemas.untitled||Z.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=g;function R(A){if(i(A))return!1;const Z=A;return b.URI.isUri(Z?.base?.resource)&&b.URI.isUri(Z?.input1?.resource)&&b.URI.isUri(Z?.input2?.resource)&&b.URI.isUri(Z?.result?.resource)}e.isResourceMergeEditorInput=R;var l;(function(A){A[A.SHORT=0]="SHORT",A[A.MEDIUM=1]="MEDIUM",A[A.LONG=2]="LONG"})(l=e.Verbosity||(e.Verbosity={}));var w;(function(A){A[A.EXPLICIT=1]="EXPLICIT",A[A.AUTO=2]="AUTO",A[A.FOCUS_CHANGE=3]="FOCUS_CHANGE",A[A.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(w=e.SaveReason||(e.SaveReason={}));class s{constructor(){this.mapIdToSaveSource=new Map}registerSource(Z,le){let oe=this.mapIdToSaveSource.get(Z);return oe||(oe={source:Z,label:le},this.mapIdToSaveSource.set(Z,oe)),oe.source}getSourceLabel(Z){return this.mapIdToSaveSource.get(Z)?.label??Z}}e.SaveSourceRegistry=new s;var u;(function(A){A[A.None=0]="None",A[A.Readonly=2]="Readonly",A[A.Untitled=4]="Untitled",A[A.Singleton=8]="Singleton",A[A.RequiresTrust=16]="RequiresTrust",A[A.CanSplitInGroup=32]="CanSplitInGroup",A[A.ForceDescription=64]="ForceDescription",A[A.CanDropIntoEditor=128]="CanDropIntoEditor",A[A.MultipleEditors=256]="MultipleEditors"})(u=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class n extends M.Disposable{}e.AbstractEditorInput=n;function i(A){return A instanceof n}e.isEditorInput=i;function r(A){const Z=A;return b.URI.isUri(Z?.preferredResource)}function t(A){const Z=A;return i(Z?.primary)&&i(Z?.secondary)}e.isSideBySideEditorInput=t;function c(A){const Z=A;return i(Z?.modified)&&i(Z?.original)}e.isDiffEditorInput=c;function _(A){return i(A?.editor)}e.isEditorInputWithOptions=_;function p(A){const Z=A;return _(A)&&Z?.group!==void 0}e.isEditorInputWithOptionsAndGroup=p;function C(A){const Z=A;return typeof Z?.groupId=="number"&&i(Z.editor)}e.isEditorIdentifier=C;var U;(function(A){A[A.UNKNOWN=0]="UNKNOWN",A[A.REPLACE=1]="REPLACE",A[A.MOVE=2]="MOVE",A[A.UNPIN=3]="UNPIN"})(U=e.EditorCloseContext||(e.EditorCloseContext={}));var W;(function(A){A[A.GROUP_ACTIVE=0]="GROUP_ACTIVE",A[A.GROUP_INDEX=1]="GROUP_INDEX",A[A.GROUP_LOCKED=2]="GROUP_LOCKED",A[A.EDITOR_OPEN=3]="EDITOR_OPEN",A[A.EDITOR_CLOSE=4]="EDITOR_CLOSE",A[A.EDITOR_MOVE=5]="EDITOR_MOVE",A[A.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",A[A.EDITOR_LABEL=7]="EDITOR_LABEL",A[A.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",A[A.EDITOR_PIN=9]="EDITOR_PIN",A[A.EDITOR_STICKY=10]="EDITOR_STICKY",A[A.EDITOR_DIRTY=11]="EDITOR_DIRTY",A[A.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(W=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var L;(function(A){A[A.PRIMARY=1]="PRIMARY",A[A.SECONDARY=2]="SECONDARY",A[A.BOTH=3]="BOTH",A[A.ANY=4]="ANY"})(L=e.SideBySideEditor||(e.SideBySideEditor={}));class S{getOriginalUri(Z,le){if(!Z)return;if(R(Z))return e.EditorResourceAccessor.getOriginalUri(Z.result,le);if(le?.supportSideBySide){const{primary:ue,secondary:te}=this.getSideEditors(Z);if(ue&&te){if(le?.supportSideBySide===L.BOTH)return{primary:this.getOriginalUri(ue,{filterByScheme:le.filterByScheme}),secondary:this.getOriginalUri(te,{filterByScheme:le.filterByScheme})};if(le?.supportSideBySide===L.ANY)return this.getOriginalUri(ue,{filterByScheme:le.filterByScheme})??this.getOriginalUri(te,{filterByScheme:le.filterByScheme});Z=le.supportSideBySide===L.PRIMARY?ue:te}}if(d(Z)||o(Z)||R(Z))return;const oe=r(Z)?Z.preferredResource:Z.resource;return!oe||!le||!le.filterByScheme?oe:this.filterUri(oe,le.filterByScheme)}getSideEditors(Z){return t(Z)||o(Z)?{primary:Z.primary,secondary:Z.secondary}:c(Z)||d(Z)?{primary:Z.modified,secondary:Z.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(Z,le){if(!Z)return;if(R(Z))return e.EditorResourceAccessor.getCanonicalUri(Z.result,le);if(le?.supportSideBySide){const{primary:ue,secondary:te}=this.getSideEditors(Z);if(ue&&te){if(le?.supportSideBySide===L.BOTH)return{primary:this.getCanonicalUri(ue,{filterByScheme:le.filterByScheme}),secondary:this.getCanonicalUri(te,{filterByScheme:le.filterByScheme})};if(le?.supportSideBySide===L.ANY)return this.getCanonicalUri(ue,{filterByScheme:le.filterByScheme})??this.getCanonicalUri(te,{filterByScheme:le.filterByScheme});Z=le.supportSideBySide===L.PRIMARY?ue:te}}if(d(Z)||o(Z)||R(Z))return;const oe=Z.resource;return!oe||!le||!le.filterByScheme?oe:this.filterUri(oe,le.filterByScheme)}filterUri(Z,le){if(Array.isArray(le)){if(le.some(oe=>Z.scheme===oe))return Z}else if(le===Z.scheme)return Z}}e.EditorResourceAccessor=new S;var z;(function(A){A[A.LEFT=0]="LEFT",A[A.RIGHT=1]="RIGHT"})(z=e.CloseDirection||(e.CloseDirection={}));class ${constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(Z){const le=this.instantiationService=Z.get(D.IInstantiationService);for(const[oe,ue]of this.editorSerializerConstructors)this.createEditorSerializer(oe,ue,le);this.editorSerializerConstructors.clear()}createEditorSerializer(Z,le,oe){const ue=oe.createInstance(le);this.editorSerializerInstances.set(Z,ue)}registerFileEditorFactory(Z){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=Z}getFileEditorFactory(){return(0,v.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(Z,le){if(this.editorSerializerConstructors.has(Z)||this.editorSerializerInstances.has(Z))throw new Error(`A editor serializer with type ID '${Z}' was already registered.`);return this.instantiationService?this.createEditorSerializer(Z,le,this.instantiationService):this.editorSerializerConstructors.set(Z,le),(0,M.toDisposable)(()=>{this.editorSerializerConstructors.delete(Z),this.editorSerializerInstances.delete(Z)})}getEditorSerializer(Z){return this.editorSerializerInstances.get(typeof Z=="string"?Z:Z.typeId)}}P.Registry.add(e.EditorExtensions.EditorFactory,new $);async function F(A,Z){if(!A||!A.length)return[];const le=await Promise.all(A.map(async oe=>{const ue=b.URI.revive(oe.fileUri);if(!ue||!await Z.canHandleResource(ue))return;let Ee=oe.exists,be=oe.type;if(typeof Ee!="boolean"||typeof be!="number")try{be=(await Z.stat(ue)).isDirectory?E.FileType.Directory:E.FileType.Unknown,Ee=!0}catch{Ee=!1}if(!Ee&&oe.openOnlyIfExists||be===E.FileType.Directory)return;const ee={...oe.options,pinned:!0};let ve;return Ee?ve={resource:ue,options:ee}:ve={resource:ue,options:ee,forceUntitled:!0},ve}));return(0,T.coalesce)(le)}e.pathsToEditors=F;var q;(function(A){A[A.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",A[A.SEQUENTIAL=1]="SEQUENTIAL"})(q=e.EditorsOrder||(e.EditorsOrder={}));function ie(A){const Z=A;if(!Z)return!1;const le=Z;if(le.modified)return ie(le.modified);const oe=Z;return!!(oe.contributionsState&&oe.viewState&&Array.isArray(oe.cursorState))}e.isTextEditorViewState=ie}),define(ye[64],De([1,0,12,2]),function(ne,e,a,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function b(P,E){return P.scheme===a.Schemas.http||P.scheme===a.Schemas.https?P:(E&&E.authority&&E.isRemote&&P.scheme===a.Schemas.file&&(P=v.URI.from({scheme:a.Schemas.vscodeRemote,authority:E.authority,path:P.path})),v.URI.from({scheme:a.Schemas.https,authority:`${P.scheme}+${M(P.authority)}.${e.webviewRootResourceAuthority}`,path:P.path,fragment:P.fragment,query:P.query}))}e.asWebviewUri=b;function M(P){return P.replace(/./g,E=>{const T=E.charCodeAt(0);return T>=97&&T<=122||T>=65&&T<=90||T>=48&&T<=57?E:"-"+T.toString(16).padStart(4,"0")})}function D(P){return P.replace(/-([0-9a-f]{4})/g,(E,T)=>String.fromCharCode(parseInt(T,16)))}e.decodeAuthority=D}),define(ye[164],De([1,0,5,7,64]),function(ne,e,a,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class M{constructor(P,E,T){this._proxy=P,this._editors=E,this._remoteInfo=T,this._handlePool=0,this._disposables=new v.DisposableStore,this._insets=new Map,this._disposables.add(E.onDidChangeVisibleTextEditors(()=>{const O=E.getVisibleTextEditors();for(const y of this._insets.values())O.indexOf(y.editor)<0&&y.inset.dispose()}))}dispose(){this._insets.forEach(P=>P.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(P,E,T,O,y){let m;for(const R of this._editors.getVisibleTextEditors(!0))if(R.value===P){m=R;break}if(!m)throw new Error("not a visible editor");const k=this,f=this._handlePool++,h=new a.Emitter,d=new a.Emitter,o=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(R){return(0,b.asWebviewUri)(R,k._remoteInfo)}get cspSource(){return b.webviewGenericCspSource}set options(R){this._options=R,k._proxy.$setOptions(f,R)}get options(){return this._options}set html(R){this._html=R,k._proxy.$setHtml(f,R)}get html(){return this._html}get onDidReceiveMessage(){return h.event}postMessage(R){return k._proxy.$postMessage(f,R)}},g=new class{constructor(){this.editor=P,this.line=E,this.height=T,this.webview=o,this.onDidDispose=d.event}dispose(){k._insets.has(f)&&(k._insets.delete(f),k._proxy.$disposeEditorInset(f),d.fire(),d.dispose(),h.dispose())}};return this._proxy.$createEditorInset(f,m.id,m.value.document.uri,E+1,T,O||{},y.identifier,y.extensionLocation),this._insets.set(f,{editor:P,inset:g,onDidReceiveMessage:h}),g}$onDidDispose(P){const E=this._insets.get(P);E&&E.inset.dispose()}$onDidReceiveMessage(P,E){this._insets.get(P)?.onDidReceiveMessage.fire(E)}}e.ExtHostEditorInsets=M}),define(ye[165],De([1,0,5,14,137]),function(ne,e,a,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class M{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new a.Emitter,this._onExit=new a.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(P){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=P}onEvent(P){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=P}onRequest(P){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=P}sendResponse(P){P.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${P.command}`)):this.internalSend("response",P)}sendRequest(P,E,T,O){const y={command:P};if(E&&Object.keys(E).length>0&&(y.arguments=E),this.internalSend("request",y),typeof O=="number"){const m=setTimeout(()=>{clearTimeout(m);const k=this.pendingRequests.get(y.seq);if(k){this.pendingRequests.delete(y.seq);const f={type:"response",seq:0,request_seq:y.seq,success:!1,command:P,message:(0,b.localize)(0,null,O,P)};k(f)}},O)}return T&&this.pendingRequests.set(y.seq,T),y.seq}acceptMessage(P){this.messageCallback?this.messageCallback(P):(this.queue.push(P),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(P,E){return P.type!=="event"||E.type!=="event"}async processQueue(){let P;for(;this.queue.length;){if((!P||this.needsTaskBoundaryBetween(this.queue[0],P))&&await(0,v.timeout)(0),P=this.queue.shift(),!P)return;switch(P.type){case"event":this.eventCallback?.(P);break;case"request":this.requestCallback?.(P);break;case"response":{const E=P,T=this.pendingRequests.get(E.request_seq);T&&(this.pendingRequests.delete(E.request_seq),T(E));break}}}}internalSend(P,E){E.type=P,E.seq=this.sequence++,this.sendMessage(E)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const P=new Map;this.pendingRequests.forEach((E,T)=>P.set(T,E)),await(0,v.timeout)(500),P.forEach((E,T)=>{E({type:"response",seq:0,request_seq:T,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(T)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=M}),define(ye[166],De([1,0,138,38,3]),function(ne,e,a,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerUiMessage=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ACCESS_TYPE=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.DEBUG_SERVICE_ID=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.DEBUG_SERVICE_ID="debugService",e.CONTEXT_DEBUG_TYPE=new v.RawContextKey("debugType",void 0,{type:"string",description:a.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new v.RawContextKey("debugConfigurationType",void 0,{type:"string",description:a.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new v.RawContextKey("debugState","inactive",{type:"string",description:a.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new v.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:a.localize(3,null)}),e.CONTEXT_IN_DEBUG_MODE=new v.RawContextKey("inDebugMode",!1,{type:"boolean",description:a.localize(4,null)}),e.CONTEXT_IN_DEBUG_REPL=new v.RawContextKey("inDebugRepl",!1,{type:"boolean",description:a.localize(5,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new v.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:a.localize(6,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new v.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:a.localize(7,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new v.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:a.localize(8,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new v.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:a.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new v.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:a.localize(10,null)}),e.CONTEXT_VARIABLES_FOCUSED=new v.RawContextKey("variablesFocused",!0,{type:"boolean",description:a.localize(11,null)}),e.CONTEXT_EXPRESSION_SELECTED=new v.RawContextKey("expressionSelected",!1,{type:"boolean",description:a.localize(12,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new v.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:a.localize(13,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new v.RawContextKey("callStackItemType",void 0,{type:"string",description:a.localize(14,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new v.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:a.localize(15,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new v.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:a.localize(16,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new v.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:a.localize(17,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new v.RawContextKey("watchItemType",void 0,{type:"string",description:a.localize(18,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new v.RawContextKey("canViewMemory",void 0,{type:"boolean",description:a.localize(19,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new v.RawContextKey("breakpointItemType",void 0,{type:"string",description:a.localize(20,null)}),e.CONTEXT_BREAKPOINT_ACCESS_TYPE=new v.RawContextKey("breakpointAccessType",void 0,{type:"string",description:a.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new v.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:a.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new v.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:a.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new v.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:a.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new v.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:a.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new v.RawContextKey("stepBackSupported",!1,{type:"boolean",description:a.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new v.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:a.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new v.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:a.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new v.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:a.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new v.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:a.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new v.RawContextKey("breakpointsExist",!1,{type:"boolean",description:a.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new v.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:a.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new v.RawContextKey("debugExtensionAvailable",!1,{type:"boolean",description:a.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new v.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:a.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new v.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:a.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new v.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:a.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new v.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:a.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new v.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:a.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new v.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:a.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new v.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:a.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new v.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:a.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new v.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:a.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new v.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:a.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new v.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:a.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new v.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:a.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new v.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:a.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new v.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:a.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new v.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:a.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new v.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:a.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new v.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:a.localize(50,null)});const M=m=>a.localize(51,null,m);e.debuggerDisabledMessage=M,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:a.localize(52,null)};var D;(function(m){m[m.Inactive=0]="Inactive",m[m.Initializing=1]="Initializing",m[m.Stopped=2]="Stopped",m[m.Running=3]="Running"})(D=e.State||(e.State={}));function P(m){switch(m){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=P;var E;(function(m){m[m.Valid=0]="Valid",m[m.Unreadable=1]="Unreadable",m[m.Error=2]="Error"})(E=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var T;(function(m){m[m.Initial=1]="Initial",m[m.Dynamic=2]="Dynamic"})(T=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var O;(function(m){m.UnverifiedBreakpoints="unverifiedBreakpoints"})(O=e.DebuggerUiMessage||(e.DebuggerUiMessage={})),e.IDebugService=(0,b.createDecorator)(e.DEBUG_SERVICE_ID);var y;(function(m){m[m.CONDITION=0]="CONDITION",m[m.HIT_COUNT=1]="HIT_COUNT",m[m.LOG_MESSAGE=2]="LOG_MESSAGE"})(y=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(ye[167],De([1,0,9,2,19,26,12]),function(ne,e,a,v,b,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const P=/{([^}]+)}/g;function E(n,i,r){return n.replace(P,function(t,c){return i&&c.length>0&&c[0]!=="_"?t:r&&r.hasOwnProperty(c)?r[c]:t})}e.formatPII=E;function T(n){const i={};for(const r of Object.keys(n))r.startsWith("!")||(i[r]=n[r]);return i}e.filterExceptionsFromTelemetry=T;function O(n){return n.configuration.request==="attach"&&!y(n)&&(!n.parentSession||O(n.parentSession))}e.isSessionAttach=O;function y(n){let i=n.configuration.type;if(!!i)return i==="vslsShare"&&(i=n.configuration.adapterProxy.configuration.type),(0,a.equalsIgnoreCase)(i,"extensionhost")||(0,a.equalsIgnoreCase)(i,"pwa-extensionhost")?n:n.parentSession?y(n.parentSession):void 0}e.getExtensionHostDebugSession=y;function m(n){return n.type&&(n.label||n.program||n.runtime)}e.isDebuggerMainContribution=m;function k(n,i,r){let t,c=0;const _=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let p=null;for(;p=_.exec(n);){const C=p.index+1,U=C+p[0].length;if(C<=i&&U>=r){t=p[0],c=C;break}}if(t){const C=/\w+/g;let U=null;for(;(U=C.exec(t))&&!(U.index+1+c+U[0].length>=r););U&&(t=t.substring(0,C.lastIndex))}return t?{start:c,end:c+t.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=k;const f=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function h(n){return!!(n&&n.match(f))}e.isUri=h;function d(n){if(typeof n.path=="string"&&!(typeof n.sourceReference=="number"&&n.sourceReference>0)){if(h(n.path))return v.URI.parse(n.path);if((0,b.isAbsolute)(n.path))return v.URI.file(n.path)}return n.path}function o(n){if(typeof n.path=="object"){const i=v.URI.revive(n.path);if(i)return i.scheme===D.Schemas.file?i.fsPath:i.toString()}return n.path}function g(n,i){const r=i?d:o,t=(0,M.deepClone)(n);return l(t,(c,_)=>{c&&_&&(_.path=r(_))}),t}e.convertToDAPaths=g;function R(n,i){const r=i?d:o,t=(0,M.deepClone)(n);return l(t,(c,_)=>{!c&&_&&(_.path=r(_))}),t}e.convertToVSCPaths=R;function l(n,i){switch(n.type){case"event":{const r=n;switch(r.event){case"output":i(!1,r.body.source);break;case"loadedSource":i(!1,r.body.source);break;case"breakpoint":i(!1,r.body.breakpoint.source);break;default:break}break}case"request":{const r=n;switch(r.command){case"setBreakpoints":i(!0,r.arguments.source);break;case"breakpointLocations":i(!0,r.arguments.source);break;case"source":i(!0,r.arguments.source);break;case"gotoTargets":i(!0,r.arguments.source);break;case"launchVSCode":r.arguments.args.forEach(t=>i(!1,t));break;default:break}break}case"response":{const r=n;if(r.success&&r.body)switch(r.command){case"stackTrace":r.body.stackFrames.forEach(t=>i(!1,t.source));break;case"loadedSources":r.body.sources.forEach(t=>i(!1,t));break;case"scopes":r.body.scopes.forEach(t=>i(!1,t.source));break;case"setFunctionBreakpoints":r.body.breakpoints.forEach(t=>i(!1,t.source));break;case"setBreakpoints":r.body.breakpoints.forEach(t=>i(!1,t.source));break;case"disassemble":r.body?.instructions.forEach(c=>i(!1,c.location));break;default:break}break}}}function w(n){return n.filter(i=>!i.presentation?.hidden).sort((i,r)=>i.presentation?r.presentation?i.presentation.group?r.presentation.group?i.presentation.group!==r.presentation.group?i.presentation.group.localeCompare(r.presentation.group):s(i.presentation.order,r.presentation.order):-1:r.presentation.group?1:s(i.presentation.order,r.presentation.order):-1:r.presentation?1:0)}e.getVisibleAndSorted=w;function s(n,i){return typeof n!="number"?typeof i!="number"?0:1:typeof i!="number"?-1:n-i}async function u(n,i){const r=n.getValue("debug.saveBeforeStart",{overrideIdentifier:i.activeTextEditorLanguageId});if(r!=="none"&&(await i.saveAll(),r==="allEditorsInActiveGroup")){const t=i.activeEditorPane;t&&t.input.resource?.scheme===D.Schemas.untitled&&await i.save({editor:t.input,groupId:t.group.id})}await n.reloadConfiguration()}e.saveAllBeforeDebugStart=u}),define(ye[88],De([1,0,23,34,168,74,12,19,21,38]),function(ne,e,a,v,b,M,D,P,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor";var O;(function(t){t[t.Markup=1]="Markup",t[t.Code=2]="Code"})(O=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",M.Mimes.latex,M.Mimes.markdown,"image/png","image/jpeg",M.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[M.Mimes.latex,M.Mimes.markdown,"application/json",M.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var y;(function(t){t[t.Running=1]="Running",t[t.Idle=2]="Idle"})(y=e.NotebookRunState||(e.NotebookRunState={}));var m;(function(t){t[t.Unconfirmed=1]="Unconfirmed",t[t.Pending=2]="Pending",t[t.Executing=3]="Executing"})(m=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var k;(function(t){t[t.WithHardKernelDependency=0]="WithHardKernelDependency",t[t.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",t[t.Pure=2]="Pure",t[t.Never=3]="Never"})(k=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var f;(function(t){t.Always="always",t.Never="never",t.Optional="optional"})(f=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var h;(function(t){t[t.ModelChange=1]="ModelChange",t[t.Move=2]="Move",t[t.ChangeCellLanguage=5]="ChangeCellLanguage",t[t.Initialize=6]="Initialize",t[t.ChangeCellMetadata=7]="ChangeCellMetadata",t[t.Output=8]="Output",t[t.OutputItem=9]="OutputItem",t[t.ChangeCellContent=10]="ChangeCellContent",t[t.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",t[t.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",t[t.ChangeCellMime=13]="ChangeCellMime",t[t.Unknown=100]="Unknown"})(h=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var d;(function(t){t[t.Handle=0]="Handle",t[t.Index=1]="Index"})(d=e.SelectionStateType||(e.SelectionStateType={}));var o;(function(t){t[t.Replace=1]="Replace",t[t.Output=2]="Output",t[t.Metadata=3]="Metadata",t[t.CellLanguage=4]="CellLanguage",t[t.DocumentMetadata=5]="DocumentMetadata",t[t.Move=6]="Move",t[t.OutputItems=7]="OutputItems",t[t.PartialMetadata=8]="PartialMetadata",t[t.PartialInternalMetadata=9]="PartialInternalMetadata"})(o=e.CellEditType||(e.CellEditType={}));var g;(function(t){t.scheme=D.Schemas.vscodeNotebookCell;const c=["W","X","Y","Z","a","b","c","d","e","f"],_=new RegExp(`^[${c.join("")}]+`),p=7;function C(F,q){const ie=q.toString(p),Z=`${ie.length<c.length?c[ie.length-1]:"z"}${ie}s${(0,a.encodeBase64)(a.VSBuffer.fromString(F.scheme),!0,!0)}`;return F.with({scheme:t.scheme,fragment:Z})}t.generate=C;function U(F){if(F.scheme!==t.scheme)return;const q=F.fragment.indexOf("s");if(q<0)return;const ie=parseInt(F.fragment.substring(0,q).replace(_,""),p),A=(0,a.decodeBase64)(F.fragment.substring(q+1)).toString();if(!isNaN(ie))return{handle:ie,notebook:F.with({scheme:A,fragment:null})}}t.parse=U;const W=/^(\d{8,})(\w[\w\d+.-]*)$/;function L(F,q){return F.with({scheme:D.Schemas.vscodeNotebookCellOutput,fragment:`op${q??""},${F.scheme!==D.Schemas.file?F.scheme:""}`})}t.generateCellOutputUri=L;function S(F){if(F.scheme!==D.Schemas.vscodeNotebookCellOutput)return;const q=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(F.fragment);if(!q)return;const ie=q[1]&&q[1]!==""?q[1]:void 0,A=q[2];return{outputId:ie,notebook:F.with({scheme:A||D.Schemas.file,fragment:null})}}t.parseCellOutputUri=S;function z(F,q,ie){return F.with({scheme:ie,fragment:`ch${q.toString().padStart(7,"0")}${F.scheme!==D.Schemas.file?F.scheme:""}`})}t.generateCellUri=z;function $(F,q){if(F.scheme!==q)return;const ie=W.exec(F.fragment);return ie?{handle:Number(ie[1]),notebook:F.with({scheme:F.fragment.substring(ie[0].length)||D.Schemas.file,fragment:null})}:void 0}t.parseCellUri=$})(g=e.CellUri||(e.CellUri={}));const R=t=>E.isWindows?t.replace(/\//g,"\\"):t;class l{constructor(c=[],_=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=_,this.order=[...new Set(c)].map(p=>({pattern:p,matches:v.parse(R(p))}))}sort(c){const _=new Map(b.Iterable.map(c,C=>[C,R(C)]));let p=[];for(const{matches:C}of this.order)for(const[U,W]of _)if(C(W)){p.push(U),_.delete(U);break}return _.size&&(p=p.concat([..._.keys()].sort((C,U)=>this.defaultOrder.indexOf(C)-this.defaultOrder.indexOf(U)))),p}prioritize(c,_){const p=this.findIndex(c);if(p===-1){this.order.unshift({pattern:c,matches:v.parse(R(c))});return}const C=new Set(_.map(W=>this.findIndex(W,p)));C.delete(-1);const U=Array.from(C).sort();this.order.splice(p+1,0,...U.map(W=>this.order[W]));for(let W=U.length-1;W>=0;W--)this.order.splice(U[W],1)}toArray(){return this.order.map(c=>c.pattern)}findIndex(c,_=this.order.length){const p=R(c);for(let C=0;C<_;C++)if(this.order[C].matches(p))return C;return-1}}e.MimeTypeDisplayOrder=l;function w(t,c,_,p=(C,U)=>C===U){const C=[];function U(S,z,$){if(z===0&&$.length===0)return;const F=C[C.length-1];F&&F.start+F.deleteCount===S?(F.deleteCount+=z,F.toInsert.push(...$)):C.push({start:S,deleteCount:z,toInsert:$})}let W=0,L=0;for(;;){if(W===t.length){U(W,0,c.slice(L));break}if(L===c.length){U(W,t.length-W,[]);break}const S=t[W],z=c[L];if(p(S,z)){W+=1,L+=1;continue}_(z)?(U(W,1,[]),W+=1):(U(W,0,[z]),L+=1)}return C}e.diff=w,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new T.RawContextKey("notebookEditorCursorAtBoundary","none");var s;(function(t){t.default="default",t.option="option"})(s=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function u(t){const c=t;return!!((typeof c.include=="string"||v.isRelativePattern(c.include))&&(typeof c.exclude=="string"||v.isRelativePattern(c.exclude)))}e.isDocumentExcludePattern=u;function n(t,c,_){if(Array.isArray(t.viewType)&&t.viewType.indexOf(c)>=0||t.viewType===c)return!0;if(t.filenamePattern){const p=u(t.filenamePattern)?t.filenamePattern.include:t.filenamePattern,C=u(t.filenamePattern)?t.filenamePattern.exclude:void 0;if(v.match(p,(0,P.basename)(_.fsPath).toLowerCase()))return!(C&&v.match(C,(0,P.basename)(_.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=n,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily"};var i;(function(t){t[t.Left=1]="Left",t[t.Right=2]="Right"})(i=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class r{static create(c){return`${r._prefix}${c}`}static parse(c){if(c.startsWith(r._prefix))return c.substring(r._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=r,r._prefix="notebook/"}),define(ye[169],De([1,0,3]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var v;(function(b){b[b.Output=1]="Output",b[b.OutputItems=2]="OutputItems",b[b.ExecutionState=3]="ExecutionState"})(v=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,a.createDecorator)("INotebookExecutionService")}),define(ye[170],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function a(D){return[...D.entries()]}e.serializeEnvironmentVariableCollection=a;function v(D){return new Map(D)}e.deserializeEnvironmentVariableCollection=v;function b(D){return Array.from(D.entries()).map(P=>[P[0],a(P[1].map)])}e.serializeEnvironmentVariableCollections=b;function M(D){return new Map(D.map(P=>[P[0],{map:v(P[1])}]))}e.deserializeEnvironmentVariableCollections=M}),define(ye[46],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var a;(function(M){M.Delimiter="\0"})(a=e.TestIdPathParts||(e.TestIdPathParts={}));var v;(function(M){M[M.IsSame=0]="IsSame",M[M.Disconnected=1]="Disconnected",M[M.IsChild=2]="IsChild",M[M.IsParent=3]="IsParent"})(v=e.TestPosition||(e.TestPosition={}));class b{constructor(D,P=D.length){if(this.path=D,this.viewEnd=P,D.length===0||P<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(D,P,E=D.parent){if(D.id===P)return new b([P]);const T=[D.id];for(let O=E;O&&O.id!==P;O=O.parent)T.push(O.id);return T.push(P),new b(T.reverse())}static isRoot(D){return!D.includes("\0")}static root(D){const P=D.indexOf("\0");return P===-1?D:D.slice(0,P)}static fromString(D){return new b(D.split("\0"))}static join(D,P){return new b([...D.path,P])}static joinToString(D,P){return D.toString()+"\0"+P}static compare(D,P){return D===P?0:P.startsWith(D+"\0")?2:D.startsWith(P+"\0")?3:1}get parentId(){return this.viewEnd>1?new b(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let D=1;D<=this.viewEnd;D++)yield new b(this.path,D)}compare(D){if(typeof D=="string")return b.compare(this.toString(),D);for(let P=0;P<D.viewEnd&&P<this.viewEnd;P++)if(D.path[P]!==this.path[P])return 1;return D.viewEnd>this.viewEnd?2:D.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let D=1;D<this.viewEnd;D++)this.stringifed+="\0",this.stringifed+=this.path[D]}return this.stringifed}}e.TestId=b}),define(ye[47],De([1,0,2,48]),function(ne,e,a,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var b;(function(r){r[r.Unset=0]="Unset",r[r.Queued=1]="Queued",r[r.Running=2]="Running",r[r.Passed=3]="Passed",r[r.Failed=4]="Failed",r[r.Skipped=5]="Skipped",r[r.Errored=6]="Errored"})(b=e.TestResultState||(e.TestResultState={}));var M;(function(r){r[r.Run=2]="Run",r[r.Debug=4]="Debug",r[r.Coverage=8]="Coverage",r[r.HasNonDefaultProfile=16]="HasNonDefaultProfile",r[r.HasConfigurable=32]="HasConfigurable"})(M=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var D;(function(r){r.serialize=t=>({range:t.range.toJSON(),uri:t.uri.toJSON()}),r.deserialize=t=>({range:v.Range.lift(t.range),uri:a.URI.revive(t.uri)})})(D=e.IRichLocation||(e.IRichLocation={}));var P;(function(r){r[r.Error=0]="Error",r[r.Output=1]="Output"})(P=e.TestMessageType||(e.TestMessageType={}));var E;(function(r){r.serialize=t=>({message:t.message,type:0,expected:t.expected,actual:t.actual,location:t.location&&D.serialize(t.location)}),r.deserialize=t=>({message:t.message,type:0,expected:t.expected,actual:t.actual,location:t.location&&D.deserialize(t.location)})})(E=e.ITestErrorMessage||(e.ITestErrorMessage={}));var T;(function(r){r.serialize=t=>({message:t.message,type:1,offset:t.offset,length:t.length,location:t.location&&D.serialize(t.location)}),r.deserialize=t=>({message:t.message,type:1,offset:t.offset,length:t.length,location:t.location&&D.deserialize(t.location)})})(T=e.ITestOutputMessage||(e.ITestOutputMessage={}));var O;(function(r){r.serialize=t=>t.type===0?E.serialize(t):T.serialize(t),r.deserialize=t=>t.type===0?E.deserialize(t):T.deserialize(t)})(O=e.ITestMessage||(e.ITestMessage={}));var y;(function(r){r.serializeWithoutMessages=t=>({state:t.state,duration:t.duration,messages:[]}),r.serialize=t=>({state:t.state,duration:t.duration,messages:t.messages.map(O.serialize)}),r.deserialize=t=>({state:t.state,duration:t.duration,messages:t.messages.map(O.deserialize)})})(y=e.ITestTaskState||(e.ITestTaskState={}));const m="\0",k=(r,t)=>r+m+t;e.namespaceTestTag=k;const f=r=>{const t=r.indexOf(m);return{ctrlId:r.slice(0,t),tagId:r.slice(t+1)}};e.denamespaceTestTag=f;var h;(function(r){r.serialize=t=>({extId:t.extId,label:t.label,tags:t.tags,busy:t.busy,children:void 0,uri:t.uri?.toJSON(),range:t.range?.toJSON()||null,description:t.description,error:t.error,sortText:t.sortText}),r.deserialize=t=>({extId:t.extId,label:t.label,tags:t.tags,busy:t.busy,children:void 0,uri:t.uri?a.URI.revive(t.uri):void 0,range:t.range?v.Range.lift(t.range):null,description:t.description,error:t.error,sortText:t.sortText})})(h=e.ITestItem||(e.ITestItem={}));var d;(function(r){r[r.NotExpandable=0]="NotExpandable",r[r.Expandable=1]="Expandable",r[r.BusyExpanding=2]="BusyExpanding",r[r.Expanded=3]="Expanded"})(d=e.TestItemExpandState||(e.TestItemExpandState={}));var o;(function(r){r.serialize=t=>({controllerId:t.controllerId,expand:t.expand,parent:t.parent,item:h.serialize(t.item)}),r.deserialize=t=>({controllerId:t.controllerId,expand:t.expand,parent:t.parent,item:h.deserialize(t.item)})})(o=e.InternalTestItem||(e.InternalTestItem={}));var g;(function(r){r.serialize=t=>{let c;return t.item&&(c={},t.item.label!==void 0&&(c.label=t.item.label),t.item.tags!==void 0&&(c.tags=t.item.tags),t.item.busy!==void 0&&(c.busy=t.item.busy),t.item.uri!==void 0&&(c.uri=t.item.uri?.toJSON()),t.item.range!==void 0&&(c.range=t.item.range?.toJSON()),t.item.description!==void 0&&(c.description=t.item.description),t.item.error!==void 0&&(c.error=t.item.error),t.item.sortText!==void 0&&(c.sortText=t.item.sortText)),{extId:t.extId,expand:t.expand,item:c}},r.deserialize=t=>{let c;return t.item&&(c={},t.item.label!==void 0&&(c.label=t.item.label),t.item.tags!==void 0&&(c.tags=t.item.tags),t.item.busy!==void 0&&(c.busy=t.item.busy),t.item.range!==void 0&&(c.range=t.item.range?v.Range.lift(t.item.range):null),t.item.description!==void 0&&(c.description=t.item.description),t.item.error!==void 0&&(c.error=t.item.error),t.item.sortText!==void 0&&(c.sortText=t.item.sortText)),{extId:t.extId,expand:t.expand,item:c}}})(g=e.ITestItemUpdate||(e.ITestItemUpdate={}));const R=(r,t)=>{t.expand!==void 0&&(r.expand=t.expand),t.item!==void 0&&(r.item=r.item?Object.assign(r.item,t.item):t.item)};e.applyTestItemUpdate=R;var l;(function(r){r.serializeWithoutMessages=t=>({...o.serialize(t),ownComputedState:t.ownComputedState,computedState:t.computedState,tasks:t.tasks.map(y.serializeWithoutMessages),retired:t.retired}),r.serialize=t=>({...o.serialize(t),ownComputedState:t.ownComputedState,computedState:t.computedState,tasks:t.tasks.map(y.serialize),retired:t.retired})})(l=e.TestResultItem||(e.TestResultItem={}));var w;(function(r){r[r.Function=0]="Function",r[r.Statement=1]="Statement"})(w=e.DetailType||(e.DetailType={}));var s;(function(r){r[r.Add=0]="Add",r[r.Update=1]="Update",r[r.Remove=2]="Remove",r[r.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",r[r.Retire=4]="Retire",r[r.AddTag=5]="AddTag",r[r.RemoveTag=6]="RemoveTag"})(s=e.TestDiffOpType||(e.TestDiffOpType={}));var u;(function(r){r.deserialize=t=>t.op===0?{op:t.op,item:o.deserialize(t.item)}:t.op===1?{op:t.op,item:g.deserialize(t.item)}:t,r.serialize=t=>t.op===0?{op:t.op,item:o.serialize(t.item)}:t.op===1?{op:t.op,item:g.serialize(t.item)}:t})(u=e.TestsDiffOp||(e.TestsDiffOp={}));class n{add(t){}update(t){}remove(t,c){}complete(){}}e.IncrementalChangeCollector=n;class i{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(t){const c=this.createChangeCollector();for(const _ of t)switch(_.op){case 0:{const p=o.deserialize(_.item);if(p.parent){if(this.items.has(p.parent)){const C=this.items.get(p.parent);C.children.add(p.item.extId);const U=this.createItem(p,C);this.items.set(p.item.extId,U),c.add(U)}}else{const C=this.createItem(p);this.roots.add(C),this.items.set(p.item.extId,C),c.add(C)}p.expand===2&&this.busyControllerCount++;break}case 1:{const p=g.deserialize(_.item),C=this.items.get(p.extId);if(!C)break;p.expand!==void 0&&(C.expand===2&&this.busyControllerCount--,p.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(C,p),c.update(C);break}case 2:{const p=this.items.get(_.itemId);if(!p)break;p.parent?this.items.get(p.parent).children.delete(p.item.extId):this.roots.delete(p);const C=[[_.itemId]];for(;C.length;)for(const U of C.pop()){const W=this.items.get(U);W&&(C.push(W.children),this.items.delete(U),c.remove(W,W!==p),W.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(_.itemId);break;case 3:this.updatePendingRoots(_.amount);break;case 5:this._tags.set(_.tag.id,_.tag);break;case 6:this._tags.delete(_.id);break}c.complete()}retireTest(t){}updatePendingRoots(t){this.pendingRootCount+=t}createChangeCollector(){return new n}}e.AbstractIncrementalTestCollection=i}),define(ye[65],De([1,0,14,5,7,44,47,46]),function(ne,e,a,v,b,M,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var E;(function(o){o[o.Upsert=0]="Upsert",o[o.SetTags=1]="SetTags",o[o.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",o[o.RemoveChild=3]="RemoveChild",o[o.SetProp=4]="SetProp",o[o.Bulk=5]="Bulk"})(E=e.TestItemEventOp||(e.TestItemEventOp={}));const T=(o,g)=>o===g,O={range:(o,g)=>o===g?!0:!o||!g?!1:o.equalsRange(g),busy:T,label:T,description:T,error:T,tags:(o,g)=>!(o.length!==g.length||o.some(R=>!g.includes(R)))},y=(o,g)=>{let R;for(const[l,w]of Object.entries(O))w(o[l],g[l])||(R?R[l]=g[l]:R={[l]:g[l]});return R};class m extends b.Disposable{constructor(g){super();this.options=g,this.debounceSendDiff=this._register(new a.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new v.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}get root(){return this.options.root}set resolveHandler(g){this._resolveHandler=g;for(const R of this.tree.values())this.updateExpandability(R)}collectDiff(){const g=this.diff;return this.diff=[],g}pushDiff(g){const R=this.diff[this.diff.length-1];if(R&&g.op===1){if(R.op===1&&R.item.extId===g.item.extId){(0,D.applyTestItemUpdate)(R.item,g.item);return}if(R.op===0&&R.item.item.extId===g.item.extId){(0,D.applyTestItemUpdate)(R.item,g.item);return}}this.diff.push(g),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(g,R){const l=this.tree.get(g);if(!!l){if((l.expandLevels===void 0||R>l.expandLevels)&&(l.expandLevels=R),l.expand===1){const w=this.resolveChildren(l);return w.isOpen()?this.expandChildren(l,R-1):w.wait().then(()=>this.expandChildren(l,R-1))}else if(l.expand===3)return l.resolveBarrier?.isOpen()===!1?l.resolveBarrier.wait().then(()=>this.expandChildren(l,R-1)):this.expandChildren(l,R-1)}}dispose(){for(const g of this.tree.values())this.options.getApiFor(g.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(g,R){switch(R.op){case 3:this.removeItem(P.TestId.joinToString(g.fullId,R.id));break;case 0:this.upsertItem(R.item,g);break;case 5:for(const l of R.ops)this.onTestItemEvent(g,l);break;case 1:this.diffTagRefs(R.new,R.old,g.fullId.toString());break;case 2:this.updateExpandability(g);break;case 4:this.pushDiff({op:1,item:{extId:g.fullId.toString(),item:R.update}});break;default:(0,M.assertNever)(R)}}upsertItem(g,R){const l=P.TestId.fromExtHostTestItem(g,this.root.id,R?.actual),w=this.options.getApiFor(g);w.parent&&w.parent!==R?.actual&&this.options.getChildren(w.parent).delete(g.id);let s=this.tree.get(l.toString());if(!s){s={fullId:l,actual:g,parent:R?l.parentId:null,expandLevels:R?.expandLevels?R.expandLevels-1:void 0,expand:0},g.tags.forEach(this.incrementTagRefs,this),this.tree.set(s.fullId.toString(),s),this.setItemParent(g,R),this.pushDiff({op:0,item:{parent:s.parent&&s.parent.toString(),controllerId:this.options.controllerId,expand:s.expand,item:this.options.toITestItem(g)}}),this.connectItemAndChildren(g,s,R);return}if(s.actual===g){this.connectItem(g,s,R);return}const u=this.options.getChildren(s.actual),n=s.actual,i=y(this.options.toITestItem(n),this.options.toITestItem(g));this.options.getApiFor(n).listener=void 0,s.actual=g,s.expand=0,i&&(i.hasOwnProperty("tags")&&(this.diffTagRefs(g.tags,n.tags,l.toString()),delete i.tags),this.onTestItemEvent(s,{op:4,update:i})),this.connectItemAndChildren(g,s,R);for(const[r,t]of u)this.options.getChildren(g).get(t.id)||this.removeItem(P.TestId.joinToString(l,t.id))}diffTagRefs(g,R,l){const w=new Set(R.map(s=>s.id));for(const s of g)w.delete(s.id)||this.incrementTagRefs(s);this.pushDiff({op:1,item:{extId:l,item:{tags:g.map(s=>(0,D.namespaceTestTag)(this.options.controllerId,s.id))}}}),w.forEach(this.decrementTagRefs,this)}incrementTagRefs(g){const R=this.tags.get(g.id);R?R.refCount++:(this.tags.set(g.id,{refCount:1}),this.pushDiff({op:5,tag:{id:(0,D.namespaceTestTag)(this.options.controllerId,g.id)}}))}decrementTagRefs(g){const R=this.tags.get(g);R&&!--R.refCount&&(this.tags.delete(g),this.pushDiff({op:6,id:(0,D.namespaceTestTag)(this.options.controllerId,g)}))}setItemParent(g,R){this.options.getApiFor(g).parent=R&&R.actual!==this.root?R.actual:void 0}connectItem(g,R,l){this.setItemParent(g,l);const w=this.options.getApiFor(g);w.parent=l?.actual,w.listener=s=>this.onTestItemEvent(R,s),this.updateExpandability(R)}connectItemAndChildren(g,R,l){this.connectItem(g,R,l);for(const[w,s]of this.options.getChildren(g))this.upsertItem(s,R)}updateExpandability(g){let R;this._resolveHandler?g.resolveBarrier?R=g.resolveBarrier.isOpen()?3:2:R=g.actual.canResolveChildren?1:0:R=0,R!==g.expand&&(g.expand=R,this.pushDiff({op:1,item:{extId:g.fullId.toString(),expand:R}}),R===1&&g.expandLevels!==void 0&&this.resolveChildren(g))}expandChildren(g,R){if(R<0)return;const l=[];for(const[w,s]of this.options.getChildren(g.actual)){const u=this.expand(P.TestId.joinToString(g.fullId,s.id),R);(0,a.isThenable)(u)&&l.push(u)}if(l.length)return Promise.all(l).then(()=>{})}resolveChildren(g){if(g.resolveBarrier)return g.resolveBarrier;if(!this._resolveHandler){const s=new a.Barrier;return s.open(),s}g.expand=2,this.pushExpandStateUpdate(g);const R=g.resolveBarrier=new a.Barrier,l=s=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,s)};let w;try{w=this._resolveHandler(g.actual===this.root?void 0:g.actual)}catch(s){l(s)}return(0,a.isThenable)(w)?w.catch(l).then(()=>{R.open(),this.updateExpandability(g)}):(R.open(),this.updateExpandability(g)),g.resolveBarrier}pushExpandStateUpdate(g){this.pushDiff({op:1,item:{extId:g.fullId.toString(),expand:g.expand}})}removeItem(g){const R=this.tree.get(g);if(!R)throw new Error("attempting to remove non-existent child");this.pushDiff({op:2,itemId:g});const l=[R];for(;l.length;){const w=l.pop();if(!!w){this.options.getApiFor(w.actual).listener=void 0;for(const s of w.actual.tags)this.decrementTagRefs(s.id);this.tree.delete(w.fullId.toString());for(const[s,u]of this.options.getChildren(w.actual))l.push(this.tree.get(P.TestId.joinToString(w.fullId,u.id)))}}}flushDiff(){const g=this.collectDiff();g.length&&this.diffOpEmitter.fire(g)}}e.TestItemCollection=m;class k extends Error{constructor(g){super(`Attempted to insert a duplicate test item ID ${g}`)}}e.DuplicateTestItemError=k;class f extends Error{constructor(g){super(`TestItem with ID "${g}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=f;class h extends Error{constructor(g,R,l){super(`TestItem with ID "${g}" is from controller "${R}" and cannot be added as a child of an item from controller "${l}".`)}}e.MixedTestItemController=h;const d=(o,g,R)=>{let l=new Map;return{get size(){return l.size},forEach(w,s){for(const u of l.values())w.call(s,u,this)},[Symbol.iterator](){return l.entries()},replace(w){const s=new Map,u=new Set(l.keys()),n={op:5,ops:[]};for(const i of w){if(!(i instanceof R))throw new f(i.id);const r=g(i).controllerId;if(r!==o.controllerId)throw new h(i.id,r,o.controllerId);if(s.has(i.id))throw new k(i.id);s.set(i.id,i),u.delete(i.id),n.ops.push({op:0,item:i})}for(const i of u.keys())n.ops.push({op:3,id:i});o.listener?.(n),l=s},add(w){if(!(w instanceof R))throw new f(w.id);l.set(w.id,w),o.listener?.({op:0,item:w})},delete(w){l.delete(w)&&o.listener?.({op:3,id:w})},get(w){return l.get(w)},toJSON(){return Array.from(l.values())}}};e.createTestItemChildren=d}),define(ye[89],De([1,0,65]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const v=new WeakMap,b=(D,P)=>{const E={controllerId:P};return v.set(D,E),E};e.createPrivateApiFor=b;const M=D=>{const P=v.get(D);if(!P)throw new a.InvalidTestItemError(D?.id||"<unknown>");return P};e.getPrivateApiFor=M}),define(ye[171],De([1,0,3]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,a.createDecorator)("configurationResolverService");var v;(function(M){M.Unknown="unknown",M.Env="env",M.Config="config",M.Command="command",M.Input="input",M.ExtensionInstallFolder="extensionInstallFolder",M.WorkspaceFolder="workspaceFolder",M.Cwd="cwd",M.WorkspaceFolderBasename="workspaceFolderBasename",M.UserHome="userHome",M.LineNumber="lineNumber",M.SelectedText="selectedText",M.File="file",M.FileWorkspaceFolder="fileWorkspaceFolder",M.RelativeFile="relativeFile",M.RelativeFileDirname="relativeFileDirname",M.FileDirname="fileDirname",M.FileExtname="fileExtname",M.FileBasename="fileBasename",M.FileBasenameNoExtension="fileBasenameNoExtension",M.FileDirnameBasename="fileDirnameBasename",M.ExecPath="execPath",M.ExecInstallFolder="execInstallFolder",M.PathSeparator="pathSeparator"})(v=e.VariableKind||(e.VariableKind={}));class b extends Error{constructor(D,P){super(P);this.variable=D}}e.VariableError=b}),define(ye[172],De([1,0,19,59,10,26,21,76,141,171,9]),function(ne,e,a,v,b,M,D,P,E,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class y{constructor(k,f,h,d){this._contributedVariables=new Map,this._context=k,this._labelService=f,this._userHomePromise=h,d&&(this._envVariablesPromise=d.then(o=>this.prepareEnv(o)))}prepareEnv(k){if(D.isWindows){const f=Object.create(null);return Object.keys(k).forEach(h=>{f[h.toLowerCase()]=k[h]}),f}return k}resolveWithEnvironment(k,f,h){return this.recursiveResolve({env:this.prepareEnv(k),userHome:void 0},f?f.uri:void 0,h)}async resolveAsync(k,f){const h={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(h,k?k.uri:void 0,f)}async resolveAnyBase(k,f,h,d){const o=M.deepClone(f);D.isWindows&&o.windows?Object.keys(o.windows).forEach(R=>o[R]=o.windows[R]):D.isMacintosh&&o.osx?Object.keys(o.osx).forEach(R=>o[R]=o.osx[R]):D.isLinux&&o.linux&&Object.keys(o.linux).forEach(R=>o[R]=o.linux[R]),delete o.windows,delete o.osx,delete o.linux;const g={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(g,k?k.uri:void 0,o,h,d)}async resolveAnyAsync(k,f,h){return this.resolveAnyBase(k,f,h)}async resolveAnyMap(k,f,h){const d=new Map;return{newConfig:await this.resolveAnyBase(k,f,h,d),resolvedVariables:d}}resolveWithInteractionReplace(k,f,h,d){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(k,f,h,d){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(k,f){if(this._contributedVariables.has(k))throw new Error("Variable "+k+" is contributed twice.");this._contributedVariables.set(k,f)}async recursiveResolve(k,f,h,d,o){if(b.isString(h))return this.resolveString(k,f,h,d,o);if(Array.isArray(h))return Promise.all(h.map(g=>this.recursiveResolve(k,f,g,d,o)));if(b.isObject(h)){const g=Object.create(null),R=await Promise.all(Object.keys(h).map(async l=>[await this.resolveString(k,f,l,d,o),await this.recursiveResolve(k,f,h[l],d,o)]));for(const[l,w]of R)g[l]=w;return g}return h}resolveString(k,f,h,d,o){return(0,O.replaceAsync)(h,y.VARIABLE_REGEXP,async(g,R)=>{if(R.includes(y.VARIABLE_LHS))return g;let l=await this.evaluateSingleVariable(k,g,R,f,d);return o?.set(R,l),l!==g&&b.isString(l)&&l.match(y.VARIABLE_REGEXP)&&(l=await this.resolveString(k,f,l,d,o)),l})}fsPath(k){return this._labelService?this._labelService.getUriLabel(k,{noPrefix:!0}):k.fsPath}async evaluateSingleVariable(k,f,h,d,o){let g;const R=h.split(":");R.length>1&&(h=R[0],g=R[1]);const l=u=>{const n=this._context.getFilePath();if(n)return n;throw new T.VariableError(u,(0,E.localize)(0,null,f))},w=u=>{const n=l(u);if(this._context.getWorkspaceFolderPathForFile){const i=this._context.getWorkspaceFolderPathForFile();if(i)return i}throw new T.VariableError(u,(0,E.localize)(1,null,f,a.basename(n)))},s=u=>{if(g){const n=this._context.getFolderUri(g);if(n)return n;throw new T.VariableError(u,(0,E.localize)(2,null,f,g))}if(d)return d;throw this._context.getWorkspaceFolderCount()>1?new T.VariableError(u,(0,E.localize)(3,null,f)):new T.VariableError(u,(0,E.localize)(4,null,f))};switch(h){case"env":if(g){if(k.env){const u=k.env[D.isWindows?g.toLowerCase():g];if(b.isString(u))return u}return""}throw new T.VariableError(T.VariableKind.Env,(0,E.localize)(5,null,f));case"config":if(g){const u=this._context.getConfigurationValue(d,g);if(b.isUndefinedOrNull(u))throw new T.VariableError(T.VariableKind.Config,(0,E.localize)(6,null,f,g));if(b.isObject(u))throw new T.VariableError(T.VariableKind.Config,(0,E.localize)(7,null,f,g));return u}throw new T.VariableError(T.VariableKind.Config,(0,E.localize)(8,null,f));case"command":return this.resolveFromMap(T.VariableKind.Command,f,g,o,"command");case"input":return this.resolveFromMap(T.VariableKind.Input,f,g,o,"input");case"extensionInstallFolder":if(g){const u=await this._context.getExtension(g);if(!u)throw new T.VariableError(T.VariableKind.ExtensionInstallFolder,(0,E.localize)(9,null,f,g));return this.fsPath(u.extensionLocation)}throw new T.VariableError(T.VariableKind.ExtensionInstallFolder,(0,E.localize)(10,null,f));default:switch(h){case"workspaceRoot":case"workspaceFolder":return(0,P.normalizeDriveLetter)(this.fsPath(s(T.VariableKind.WorkspaceFolder)));case"cwd":return d||g?(0,P.normalizeDriveLetter)(this.fsPath(s(T.VariableKind.Cwd))):v.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return a.basename(this.fsPath(s(T.VariableKind.WorkspaceFolderBasename)));case"userHome":{if(k.userHome)return k.userHome;throw new T.VariableError(T.VariableKind.UserHome,(0,E.localize)(11,null,f))}case"lineNumber":{const u=this._context.getLineNumber();if(u)return u;throw new T.VariableError(T.VariableKind.LineNumber,(0,E.localize)(12,null,f))}case"selectedText":{const u=this._context.getSelectedText();if(u)return u;throw new T.VariableError(T.VariableKind.SelectedText,(0,E.localize)(13,null,f))}case"file":return l(T.VariableKind.File);case"fileWorkspaceFolder":return w(T.VariableKind.FileWorkspaceFolder);case"relativeFile":return d||g?a.relative(this.fsPath(s(T.VariableKind.RelativeFile)),l(T.VariableKind.RelativeFile)):l(T.VariableKind.RelativeFile);case"relativeFileDirname":{const u=a.dirname(l(T.VariableKind.RelativeFileDirname));if(d||g){const n=a.relative(this.fsPath(s(T.VariableKind.RelativeFileDirname)),u);return n.length===0?".":n}return u}case"fileDirname":return a.dirname(l(T.VariableKind.FileDirname));case"fileExtname":return a.extname(l(T.VariableKind.FileExtname));case"fileBasename":return a.basename(l(T.VariableKind.FileBasename));case"fileBasenameNoExtension":{const u=a.basename(l(T.VariableKind.FileBasenameNoExtension));return u.slice(0,u.length-a.extname(u).length)}case"fileDirnameBasename":return a.basename(a.dirname(l(T.VariableKind.FileDirnameBasename)));case"execPath":{const u=this._context.getExecPath();return u||f}case"execInstallFolder":{const u=this._context.getAppRoot();return u||f}case"pathSeparator":return a.sep;default:try{const u=g?`${h}:${g}`:h;return this.resolveFromMap(T.VariableKind.Unknown,f,u,o,void 0)}catch{return f}}}}resolveFromMap(k,f,h,d,o){if(h&&d){const g=o===void 0?d[h]:d[o+":"+h];if(typeof g=="string")return g;throw new T.VariableError(k,(0,E.localize)(14,null,f))}return f}}e.AbstractVariableResolverService=y,y.VARIABLE_LHS="${",y.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(ye[90],De([1,0,3,163]),function(ne,e,a,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,a.createDecorator)("editorGroupsService");var b;(function(f){f[f.UP=0]="UP",f[f.DOWN=1]="DOWN",f[f.LEFT=2]="LEFT",f[f.RIGHT=3]="RIGHT"})(b=e.GroupDirection||(e.GroupDirection={}));var M;(function(f){f[f.HORIZONTAL=0]="HORIZONTAL",f[f.VERTICAL=1]="VERTICAL"})(M=e.GroupOrientation||(e.GroupOrientation={}));var D;(function(f){f[f.FIRST=0]="FIRST",f[f.LAST=1]="LAST",f[f.NEXT=2]="NEXT",f[f.PREVIOUS=3]="PREVIOUS"})(D=e.GroupLocation||(e.GroupLocation={}));var P;(function(f){f[f.MAXIMIZE=0]="MAXIMIZE",f[f.EVEN=1]="EVEN",f[f.TOGGLE=2]="TOGGLE"})(P=e.GroupsArrangement||(e.GroupsArrangement={}));var E;(function(f){f[f.COPY_EDITORS=0]="COPY_EDITORS",f[f.MOVE_EDITORS=1]="MOVE_EDITORS"})(E=e.MergeGroupMode||(e.MergeGroupMode={}));function T(f){const h=f;return(0,v.isEditorInput)(h?.editor)&&(0,v.isEditorInput)(h?.replacement)}e.isEditorReplacement=T;var O;(function(f){f[f.CREATION_TIME=0]="CREATION_TIME",f[f.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",f[f.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(O=e.GroupsOrder||(e.GroupsOrder={}));var y;(function(f){f[f.NEW_EDITOR=1]="NEW_EDITOR",f[f.MOVE_EDITOR=2]="MOVE_EDITOR",f[f.COPY_EDITOR=3]="COPY_EDITOR"})(y=e.OpenEditorContext||(e.OpenEditorContext={}));function m(f){const h=f;return!!h&&typeof h.id=="number"&&Array.isArray(h.editors)}e.isEditorGroup=m;function k(f){return f.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=k}),define(ye[173],De([1,0,3,90]),function(ne,e,a,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,a.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function b(M){const D=M;return typeof M=="number"||(0,v.isEditorGroup)(D)}e.isPreferredGroup=b}),define(ye[8],De([1,0,16,23,75,25,106,55,26,10,2,48,66,144,80,89,88,46,47,173,6,174]),function(ne,e,a,v,b,M,D,P,E,T,O,y,m,k,f,h,d,o,g,R,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var s;(function(we){function Ce(j){const{selectionStartLineNumber:Pe,selectionStartColumn:Le,positionLineNumber:tt,positionColumn:Xe}=j,je=new l.Position(Pe-1,Le-1),ut=new l.Position(tt-1,Xe-1);return new l.Selection(je,ut)}we.to=Ce;function me(j){const{anchor:Pe,active:Le}=j;return{selectionStartLineNumber:Pe.line+1,selectionStartColumn:Pe.character+1,positionLineNumber:Le.line+1,positionColumn:Le.character+1}}we.from=me})(s=e.Selection||(e.Selection={}));var u;(function(we){function Ce(j){if(!j)return;const{start:Pe,end:Le}=j;return{startLineNumber:Pe.line+1,startColumn:Pe.character+1,endLineNumber:Le.line+1,endColumn:Le.character+1}}we.from=Ce;function me(j){if(!j)return;const{startLineNumber:Pe,startColumn:Le,endLineNumber:tt,endColumn:Xe}=j;return new l.Range(Pe-1,Le-1,tt-1,Xe-1)}we.to=me})(u=e.Range||(e.Range={}));var n;(function(we){function Ce(me){switch(me){case 1:return l.StandardTokenType.Comment;case 0:return l.StandardTokenType.Other;case 3:return l.StandardTokenType.RegEx;case 2:return l.StandardTokenType.String}}we.to=Ce})(n=e.TokenType||(e.TokenType={}));var i;(function(we){function Ce(j){return new l.Position(j.lineNumber-1,j.column-1)}we.to=Ce;function me(j){return{lineNumber:j.line+1,column:j.character+1}}we.from=me})(i=e.Position||(e.Position={}));var r;(function(we){function Ce(Pe,Le){return(0,a.coalesce)((0,a.asArray)(Pe).map(tt=>me(tt,Le)))}we.from=Ce;function me(Pe,Le){if(typeof Pe=="string")return{$serialized:!0,language:Pe};if(Pe)return{$serialized:!0,language:Pe.language,scheme:j(Pe.scheme,Le),pattern:fe.from(Pe.pattern)??void 0,exclusive:Pe.exclusive,notebookType:Pe.notebookType}}function j(Pe,Le){return Le&&typeof Pe=="string"?Le.transformOutgoingScheme(Pe):Pe}})(r=e.DocumentSelector||(e.DocumentSelector={}));var t;(function(we){function Ce(j){switch(j){case l.DiagnosticTag.Unnecessary:return 1;case l.DiagnosticTag.Deprecated:return 2}}we.from=Ce;function me(j){switch(j){case 1:return l.DiagnosticTag.Unnecessary;case 2:return l.DiagnosticTag.Deprecated;default:return}}we.to=me})(t=e.DiagnosticTag||(e.DiagnosticTag={}));var c;(function(we){function Ce(j){let Pe;return j.code&&((0,T.isString)(j.code)||(0,T.isNumber)(j.code)?Pe=String(j.code):Pe={value:String(j.code.value),target:j.code.target}),{...u.from(j.range),message:j.message,source:j.source,code:Pe,severity:p.from(j.severity),relatedInformation:j.relatedInformation&&j.relatedInformation.map(_.from),tags:Array.isArray(j.tags)?(0,a.coalesce)(j.tags.map(t.from)):void 0}}we.from=Ce;function me(j){const Pe=new l.Diagnostic(u.to(j),j.message,p.to(j.severity));return Pe.source=j.source,Pe.code=(0,T.isString)(j.code)?j.code:j.code?.value,Pe.relatedInformation=j.relatedInformation&&j.relatedInformation.map(_.to),Pe.tags=j.tags&&(0,a.coalesce)(j.tags.map(t.to)),Pe}we.to=me})(c=e.Diagnostic||(e.Diagnostic={}));var _;(function(we){function Ce(j){return{...u.from(j.location.range),message:j.message,resource:j.location.uri}}we.from=Ce;function me(j){return new l.DiagnosticRelatedInformation(new l.Location(j.resource,u.to(j)),j.message)}we.to=me})(_=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var p;(function(we){function Ce(j){switch(j){case l.DiagnosticSeverity.Error:return f.MarkerSeverity.Error;case l.DiagnosticSeverity.Warning:return f.MarkerSeverity.Warning;case l.DiagnosticSeverity.Information:return f.MarkerSeverity.Info;case l.DiagnosticSeverity.Hint:return f.MarkerSeverity.Hint}return f.MarkerSeverity.Error}we.from=Ce;function me(j){switch(j){case f.MarkerSeverity.Info:return l.DiagnosticSeverity.Information;case f.MarkerSeverity.Warning:return l.DiagnosticSeverity.Warning;case f.MarkerSeverity.Error:return l.DiagnosticSeverity.Error;case f.MarkerSeverity.Hint:return l.DiagnosticSeverity.Hint;default:return l.DiagnosticSeverity.Error}}we.to=me})(p=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var C;(function(we){function Ce(j){return typeof j=="number"&&j>=l.ViewColumn.One?j-1:j===l.ViewColumn.Beside?R.SIDE_GROUP:R.ACTIVE_GROUP}we.from=Ce;function me(j){if(typeof j=="number"&&j>=0)return j+1;throw new Error("invalid 'EditorGroupColumn'")}we.to=me})(C=e.ViewColumn||(e.ViewColumn={}));function U(we){return typeof we.range!="undefined"}function W(we){return we.length===0?!0:!!U(we[0])}e.isDecorationOptionsArr=W;var L;(function(we){function Ce(Xe){return Xe.map(we.from)}we.fromMany=Ce;function me(Xe){return Xe&&typeof Xe=="object"&&typeof Xe.language=="string"&&typeof Xe.value=="string"}function j(Xe){let je;if(me(Xe)){const{language:pt,value:_t}=Xe;je={value:"```"+pt+`
`+_t+"\n```\n"}}else l.MarkdownString.isMarkdownString(Xe)?je={value:Xe.value,isTrusted:Xe.isTrusted,supportThemeIcons:Xe.supportThemeIcons,supportHtml:Xe.supportHtml,baseUri:Xe.baseUri}:typeof Xe=="string"?je={value:Xe}:je={value:""};const ut=Object.create(null);je.uris=ut;const gt=pt=>{try{let _t=O.URI.parse(pt,!0);_t=_t.with({query:Pe(_t.query,ut)}),ut[pt]=_t}catch{}return""},yt=new D.marked.Renderer;return yt.link=gt,yt.image=pt=>typeof pt=="string"?gt(b.parseHrefAndDimensions(pt).href):"",(0,D.marked)(je.value,{renderer:yt}),je}we.from=j;function Pe(Xe,je){if(!Xe)return Xe;let ut;try{ut=(0,P.parse)(Xe)}catch{}if(!ut)return Xe;let gt=!1;return ut=(0,E.cloneAndChange)(ut,yt=>{if(O.URI.isUri(yt)){const pt=`__uri_${Math.random().toString(16).slice(2,8)}`;return je[pt]=yt,gt=!0,pt}else return}),gt?JSON.stringify(ut):Xe}function Le(Xe){const je=new l.MarkdownString(Xe.value,Xe.supportThemeIcons);return je.isTrusted=Xe.isTrusted,je.supportHtml=Xe.supportHtml,je.baseUri=Xe.baseUri?O.URI.from(Xe.baseUri):void 0,je}we.to=Le;function tt(Xe){if(!!Xe)return typeof Xe=="string"?Xe:we.from(Xe)}we.fromStrict=tt})(L=e.MarkdownString||(e.MarkdownString={}));function S(we){return W(we)?we.map(Ce=>({range:u.from(Ce.range),hoverMessage:Array.isArray(Ce.hoverMessage)?L.fromMany(Ce.hoverMessage):Ce.hoverMessage?L.from(Ce.hoverMessage):void 0,renderOptions:Ce.renderOptions})):we.map(Ce=>({range:u.from(Ce)}))}e.fromRangeOrRangeWithMessage=S;function z(we){return typeof we=="undefined"?we:typeof we=="string"?O.URI.file(we):we}e.pathOrURIToURI=z;var $;(function(we){function Ce(me){return typeof me=="undefined"?me:{contentText:me.contentText,contentIconPath:me.contentIconPath?z(me.contentIconPath):void 0,border:me.border,borderColor:me.borderColor,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,color:me.color,backgroundColor:me.backgroundColor,margin:me.margin,width:me.width,height:me.height}}we.from=Ce})($=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var F;(function(we){function Ce(me){return typeof me=="undefined"?me:{backgroundColor:me.backgroundColor,outline:me.outline,outlineColor:me.outlineColor,outlineStyle:me.outlineStyle,outlineWidth:me.outlineWidth,border:me.border,borderColor:me.borderColor,borderRadius:me.borderRadius,borderSpacing:me.borderSpacing,borderStyle:me.borderStyle,borderWidth:me.borderWidth,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,cursor:me.cursor,color:me.color,opacity:me.opacity,letterSpacing:me.letterSpacing,gutterIconPath:me.gutterIconPath?z(me.gutterIconPath):void 0,gutterIconSize:me.gutterIconSize,overviewRulerColor:me.overviewRulerColor,before:me.before?$.from(me.before):void 0,after:me.after?$.from(me.after):void 0}}we.from=Ce})(F=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var q;(function(we){function Ce(me){if(typeof me=="undefined")return me;switch(me){case l.DecorationRangeBehavior.OpenOpen:return 0;case l.DecorationRangeBehavior.ClosedClosed:return 1;case l.DecorationRangeBehavior.OpenClosed:return 2;case l.DecorationRangeBehavior.ClosedOpen:return 3}}we.from=Ce})(q=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var ie;(function(we){function Ce(me){return{isWholeLine:me.isWholeLine,rangeBehavior:me.rangeBehavior?q.from(me.rangeBehavior):void 0,overviewRulerLane:me.overviewRulerLane,light:me.light?F.from(me.light):void 0,dark:me.dark?F.from(me.dark):void 0,backgroundColor:me.backgroundColor,outline:me.outline,outlineColor:me.outlineColor,outlineStyle:me.outlineStyle,outlineWidth:me.outlineWidth,border:me.border,borderColor:me.borderColor,borderRadius:me.borderRadius,borderSpacing:me.borderSpacing,borderStyle:me.borderStyle,borderWidth:me.borderWidth,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,cursor:me.cursor,color:me.color,opacity:me.opacity,letterSpacing:me.letterSpacing,gutterIconPath:me.gutterIconPath?z(me.gutterIconPath):void 0,gutterIconSize:me.gutterIconSize,overviewRulerColor:me.overviewRulerColor,before:me.before?$.from(me.before):void 0,after:me.after?$.from(me.after):void 0}}we.from=Ce})(ie=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var A;(function(we){function Ce(j){return{text:j.newText,eol:j.newEol&&Ge.from(j.newEol),range:u.from(j.range)}}we.from=Ce;function me(j){const Pe=new l.TextEdit(u.to(j.range),j.text);return Pe.newEol=typeof j.eol=="undefined"?void 0:Ge.to(j.eol),Pe}we.to=me})(A=e.TextEdit||(e.TextEdit={}));var Z;(function(we){function Ce(j,Pe,Le){const tt={edits:[]};if(j instanceof l.WorkspaceEdit){const Xe=new M.ResourceSet;for(const je of j._allEntries())je._type===1&&O.URI.isUri(je.to)&&je.from===void 0&&Xe.add(je.to);for(const je of j._allEntries())if(je._type===1)tt.edits.push({oldResource:je.from,newResource:je.to,options:je.options,metadata:je.metadata});else if(je._type===2)tt.edits.push({resource:je.uri,textEdit:A.from(je.edit),versionId:Xe.has(je.uri)?void 0:Pe?.getTextDocumentVersion(je.uri),metadata:je.metadata});else if(je._type===6){if(!Le){console.warn("DROPPING snippet text edit because proposal IS NOT ENABLED",je);continue}tt.edits.push({resource:je.uri,textEdit:{range:u.from(je.range),text:je.edit.value,insertAsSnippet:!0},versionId:Xe.has(je.uri)?void 0:Pe?.getTextDocumentVersion(je.uri),metadata:je.metadata})}else je._type===3?tt.edits.push({metadata:je.metadata,resource:je.uri,cellEdit:je.edit,notebookMetadata:je.notebookMetadata,notebookVersionId:Pe?.getNotebookDocumentVersion(je.uri)}):je._type===5&&tt.edits.push({metadata:je.metadata,resource:je.uri,notebookVersionId:Pe?.getNotebookDocumentVersion(je.uri),cellEdit:{editType:1,index:je.index,count:je.count,cells:je.cells.map(ot.from)}})}return tt}we.from=Ce;function me(j){const Pe=new l.WorkspaceEdit;for(const Le of j.edits)Le.textEdit?Pe.replace(O.URI.revive(Le.resource),u.to(Le.textEdit.range),Le.textEdit.text):Pe.renameFile(O.URI.revive(Le.oldResource),O.URI.revive(Le.newResource),Le.options);return Pe}we.to=me})(Z=e.WorkspaceEdit||(e.WorkspaceEdit={}));var le;(function(we){const Ce=Object.create(null);Ce[l.SymbolKind.File]=0,Ce[l.SymbolKind.Module]=1,Ce[l.SymbolKind.Namespace]=2,Ce[l.SymbolKind.Package]=3,Ce[l.SymbolKind.Class]=4,Ce[l.SymbolKind.Method]=5,Ce[l.SymbolKind.Property]=6,Ce[l.SymbolKind.Field]=7,Ce[l.SymbolKind.Constructor]=8,Ce[l.SymbolKind.Enum]=9,Ce[l.SymbolKind.Interface]=10,Ce[l.SymbolKind.Function]=11,Ce[l.SymbolKind.Variable]=12,Ce[l.SymbolKind.Constant]=13,Ce[l.SymbolKind.String]=14,Ce[l.SymbolKind.Number]=15,Ce[l.SymbolKind.Boolean]=16,Ce[l.SymbolKind.Array]=17,Ce[l.SymbolKind.Object]=18,Ce[l.SymbolKind.Key]=19,Ce[l.SymbolKind.Null]=20,Ce[l.SymbolKind.EnumMember]=21,Ce[l.SymbolKind.Struct]=22,Ce[l.SymbolKind.Event]=23,Ce[l.SymbolKind.Operator]=24,Ce[l.SymbolKind.TypeParameter]=25;function me(Pe){return typeof Ce[Pe]=="number"?Ce[Pe]:6}we.from=me;function j(Pe){for(const Le in Ce)if(Ce[Le]===Pe)return Number(Le);return l.SymbolKind.Property}we.to=j})(le=e.SymbolKind||(e.SymbolKind={}));var oe;(function(we){function Ce(j){switch(j){case l.SymbolTag.Deprecated:return 1}}we.from=Ce;function me(j){switch(j){case 1:return l.SymbolTag.Deprecated}}we.to=me})(oe=e.SymbolTag||(e.SymbolTag={}));var ue;(function(we){function Ce(j){return{name:j.name,kind:le.from(j.kind),tags:j.tags&&j.tags.map(oe.from),containerName:j.containerName,location:ve.from(j.location)}}we.from=Ce;function me(j){const Pe=new l.SymbolInformation(j.name,le.to(j.kind),j.containerName,ve.to(j.location));return Pe.tags=j.tags&&j.tags.map(oe.to),Pe}we.to=me})(ue=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var te;(function(we){function Ce(j){const Pe={name:j.name||"!!MISSING: name!!",detail:j.detail,range:u.from(j.range),selectionRange:u.from(j.selectionRange),kind:le.from(j.kind),tags:j.tags?.map(oe.from)??[]};return j.children&&(Pe.children=j.children.map(Ce)),Pe}we.from=Ce;function me(j){const Pe=new l.DocumentSymbol(j.name,j.detail,le.to(j.kind),u.to(j.range),u.to(j.selectionRange));return(0,a.isNonEmptyArray)(j.tags)&&(Pe.tags=j.tags.map(oe.to)),j.children&&(Pe.children=j.children.map(me)),Pe}we.to=me})(te=e.DocumentSymbol||(e.DocumentSymbol={}));var Ee;(function(we){function Ce(j){const Pe=new l.CallHierarchyItem(le.to(j.kind),j.name,j.detail||"",O.URI.revive(j.uri),u.to(j.range),u.to(j.selectionRange));return Pe._sessionId=j._sessionId,Pe._itemId=j._itemId,Pe}we.to=Ce;function me(j,Pe,Le){if(Pe=Pe??j._sessionId,Le=Le??j._itemId,Pe===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:Pe,_itemId:Le,name:j.name,detail:j.detail,kind:le.from(j.kind),uri:j.uri,range:u.from(j.range),selectionRange:u.from(j.selectionRange),tags:j.tags?.map(oe.from)}}we.from=me})(Ee=e.CallHierarchyItem||(e.CallHierarchyItem={}));var be;(function(we){function Ce(me){return new l.CallHierarchyIncomingCall(Ee.to(me.from),me.fromRanges.map(j=>u.to(j)))}we.to=Ce})(be=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var ee;(function(we){function Ce(me){return new l.CallHierarchyOutgoingCall(Ee.to(me.to),me.fromRanges.map(j=>u.to(j)))}we.to=Ce})(ee=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var ve;(function(we){function Ce(j){return{range:j.range&&u.from(j.range),uri:j.uri}}we.from=Ce;function me(j){return new l.Location(O.URI.revive(j.uri),u.to(j.range))}we.to=me})(ve=e.location||(e.location={}));var Ae;(function(we){function Ce(j){const Pe=j,Le=j;return{originSelectionRange:Pe.originSelectionRange?u.from(Pe.originSelectionRange):void 0,uri:Pe.targetUri?Pe.targetUri:Le.uri,range:u.from(Pe.targetRange?Pe.targetRange:Le.range),targetSelectionRange:Pe.targetSelectionRange?u.from(Pe.targetSelectionRange):void 0}}we.from=Ce;function me(j){return{targetUri:O.URI.revive(j.uri),targetRange:u.to(j.range),targetSelectionRange:j.targetSelectionRange?u.to(j.targetSelectionRange):void 0,originSelectionRange:j.originSelectionRange?u.to(j.originSelectionRange):void 0}}we.to=me})(Ae=e.DefinitionLink||(e.DefinitionLink={}));var Fe;(function(we){function Ce(j){return{range:u.from(j.range),contents:L.fromMany(j.contents)}}we.from=Ce;function me(j){return new l.Hover(j.contents.map(L.to),u.to(j.range))}we.to=me})(Fe=e.Hover||(e.Hover={}));var $e;(function(we){function Ce(j){return{range:u.from(j.range),expression:j.expression}}we.from=Ce;function me(j){return new l.EvaluatableExpression(u.to(j.range),j.expression)}we.to=me})($e=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Qe;(function(we){function Ce(j){if(j instanceof l.InlineValueText)return{type:"text",range:u.from(j.range),text:j.text};if(j instanceof l.InlineValueVariableLookup)return{type:"variable",range:u.from(j.range),variableName:j.variableName,caseSensitiveLookup:j.caseSensitiveLookup};if(j instanceof l.InlineValueEvaluatableExpression)return{type:"expression",range:u.from(j.range),expression:j.expression};throw new Error("Unknown 'InlineValue' type")}we.from=Ce;function me(j){switch(j.type){case"text":return{range:u.to(j.range),text:j.text};case"variable":return{range:u.to(j.range),variableName:j.variableName,caseSensitiveLookup:j.caseSensitiveLookup};case"expression":return{range:u.to(j.range),expression:j.expression}}}we.to=me})(Qe=e.InlineValue||(e.InlineValue={}));var Ie;(function(we){function Ce(j){return{frameId:j.frameId,stoppedLocation:u.from(j.stoppedLocation)}}we.from=Ce;function me(j){return new l.InlineValueContext(j.frameId,u.to(j.stoppedLocation))}we.to=me})(Ie=e.InlineValueContext||(e.InlineValueContext={}));var Se;(function(we){function Ce(j){return{range:u.from(j.range),kind:j.kind}}we.from=Ce;function me(j){return new l.DocumentHighlight(u.to(j.range),j.kind)}we.to=me})(Se=e.DocumentHighlight||(e.DocumentHighlight={}));var ke;(function(we){function Ce(me){switch(me){case 1:return l.CompletionTriggerKind.TriggerCharacter;case 2:return l.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return l.CompletionTriggerKind.Invoke}}we.to=Ce})(ke=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ae;(function(we){function Ce(me){return{triggerKind:ke.to(me.triggerKind),triggerCharacter:me.triggerCharacter}}we.to=Ce})(ae=e.CompletionContext||(e.CompletionContext={}));var ce;(function(we){function Ce(j){switch(j){case l.CompletionItemTag.Deprecated:return 1}}we.from=Ce;function me(j){switch(j){case 1:return l.CompletionItemTag.Deprecated}}we.to=me})(ce=e.CompletionItemTag||(e.CompletionItemTag={}));var G;(function(we){const Ce=new Map([[l.CompletionItemKind.Method,0],[l.CompletionItemKind.Function,1],[l.CompletionItemKind.Constructor,2],[l.CompletionItemKind.Field,3],[l.CompletionItemKind.Variable,4],[l.CompletionItemKind.Class,5],[l.CompletionItemKind.Interface,7],[l.CompletionItemKind.Struct,6],[l.CompletionItemKind.Module,8],[l.CompletionItemKind.Property,9],[l.CompletionItemKind.Unit,12],[l.CompletionItemKind.Value,13],[l.CompletionItemKind.Constant,14],[l.CompletionItemKind.Enum,15],[l.CompletionItemKind.EnumMember,16],[l.CompletionItemKind.Keyword,17],[l.CompletionItemKind.Snippet,27],[l.CompletionItemKind.Text,18],[l.CompletionItemKind.Color,19],[l.CompletionItemKind.File,20],[l.CompletionItemKind.Reference,21],[l.CompletionItemKind.Folder,23],[l.CompletionItemKind.Event,10],[l.CompletionItemKind.Operator,11],[l.CompletionItemKind.TypeParameter,24],[l.CompletionItemKind.Issue,26],[l.CompletionItemKind.User,25]]);function me(Le){return Ce.get(Le)??9}we.from=me;const j=new Map([[0,l.CompletionItemKind.Method],[1,l.CompletionItemKind.Function],[2,l.CompletionItemKind.Constructor],[3,l.CompletionItemKind.Field],[4,l.CompletionItemKind.Variable],[5,l.CompletionItemKind.Class],[7,l.CompletionItemKind.Interface],[6,l.CompletionItemKind.Struct],[8,l.CompletionItemKind.Module],[9,l.CompletionItemKind.Property],[12,l.CompletionItemKind.Unit],[13,l.CompletionItemKind.Value],[14,l.CompletionItemKind.Constant],[15,l.CompletionItemKind.Enum],[16,l.CompletionItemKind.EnumMember],[17,l.CompletionItemKind.Keyword],[27,l.CompletionItemKind.Snippet],[18,l.CompletionItemKind.Text],[19,l.CompletionItemKind.Color],[20,l.CompletionItemKind.File],[21,l.CompletionItemKind.Reference],[23,l.CompletionItemKind.Folder],[10,l.CompletionItemKind.Event],[11,l.CompletionItemKind.Operator],[24,l.CompletionItemKind.TypeParameter],[25,l.CompletionItemKind.User],[26,l.CompletionItemKind.Issue]]);function Pe(Le){return j.get(Le)??l.CompletionItemKind.Property}we.to=Pe})(G=e.CompletionItemKind||(e.CompletionItemKind={}));var Q;(function(we){function Ce(me,j){const Pe=new l.CompletionItem(me.label);return Pe.insertText=me.insertText,Pe.kind=G.to(me.kind),Pe.tags=me.tags?.map(ce.to),Pe.detail=me.detail,Pe.documentation=b.isMarkdownString(me.documentation)?L.to(me.documentation):me.documentation,Pe.sortText=me.sortText,Pe.filterText=me.filterText,Pe.preselect=me.preselect,Pe.commitCharacters=me.commitCharacters,y.Range.isIRange(me.range)?Pe.range=u.to(me.range):typeof me.range=="object"&&(Pe.range={inserting:u.to(me.range.insert),replacing:u.to(me.range.replace)}),Pe.keepWhitespace=typeof me.insertTextRules=="undefined"?!1:Boolean(me.insertTextRules&1),typeof me.insertTextRules!="undefined"&&me.insertTextRules&4?Pe.insertText=new l.SnippetString(me.insertText):(Pe.insertText=me.insertText,Pe.textEdit=Pe.range instanceof l.Range?new l.TextEdit(Pe.range,Pe.insertText):void 0),me.additionalTextEdits&&me.additionalTextEdits.length>0&&(Pe.additionalTextEdits=me.additionalTextEdits.map(Le=>A.to(Le))),Pe.command=j&&me.command?j.fromInternal(me.command):void 0,Pe}we.to=Ce})(Q=e.CompletionItem||(e.CompletionItem={}));var I;(function(we){function Ce(j){return{label:j.label,documentation:L.fromStrict(j.documentation)}}we.from=Ce;function me(j){return{label:j.label,documentation:b.isMarkdownString(j.documentation)?L.to(j.documentation):j.documentation}}we.to=me})(I=e.ParameterInformation||(e.ParameterInformation={}));var B;(function(we){function Ce(j){return{label:j.label,documentation:L.fromStrict(j.documentation),parameters:Array.isArray(j.parameters)?j.parameters.map(I.from):[],activeParameter:j.activeParameter}}we.from=Ce;function me(j){return{label:j.label,documentation:b.isMarkdownString(j.documentation)?L.to(j.documentation):j.documentation,parameters:Array.isArray(j.parameters)?j.parameters.map(I.to):[],activeParameter:j.activeParameter}}we.to=me})(B=e.SignatureInformation||(e.SignatureInformation={}));var H;(function(we){function Ce(j){return{activeSignature:j.activeSignature,activeParameter:j.activeParameter,signatures:Array.isArray(j.signatures)?j.signatures.map(B.from):[]}}we.from=Ce;function me(j){return{activeSignature:j.activeSignature,activeParameter:j.activeParameter,signatures:Array.isArray(j.signatures)?j.signatures.map(B.to):[]}}we.to=me})(H=e.SignatureHelp||(e.SignatureHelp={}));var V;(function(we){function Ce(me,j){const Pe=new l.InlayHint(i.to(j.position),typeof j.label=="string"?j.label:j.label.map(se.to.bind(void 0,me)),j.kind&&de.to(j.kind));return Pe.textEdits=j.textEdits&&j.textEdits.map(A.to),Pe.tooltip=b.isMarkdownString(j.tooltip)?L.to(j.tooltip):j.tooltip,Pe.paddingLeft=j.paddingLeft,Pe.paddingRight=j.paddingRight,Pe}we.to=Ce})(V=e.InlayHint||(e.InlayHint={}));var se;(function(we){function Ce(me,j){const Pe=new l.InlayHintLabelPart(j.label);return Pe.tooltip=b.isMarkdownString(j.tooltip)?L.to(j.tooltip):j.tooltip,m.Command.is(j.command)&&(Pe.command=me.fromInternal(j.command)),j.location&&(Pe.location=ve.to(j.location)),Pe}we.to=Ce})(se=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var de;(function(we){function Ce(j){return j}we.from=Ce;function me(j){return j}we.to=me})(de=e.InlayHintKind||(e.InlayHintKind={}));var J;(function(we){function Ce(j){return{range:u.from(j.range),url:j.target,tooltip:j.tooltip}}we.from=Ce;function me(j){let Pe;if(j.url)try{Pe=typeof j.url=="string"?O.URI.parse(j.url,!0):O.URI.revive(j.url)}catch{}return new l.DocumentLink(u.to(j.range),Pe)}we.to=me})(J=e.DocumentLink||(e.DocumentLink={}));var pe;(function(we){function Ce(j){const Pe=new l.ColorPresentation(j.label);return j.textEdit&&(Pe.textEdit=A.to(j.textEdit)),j.additionalTextEdits&&(Pe.additionalTextEdits=j.additionalTextEdits.map(Le=>A.to(Le))),Pe}we.to=Ce;function me(j){return{label:j.label,textEdit:j.textEdit?A.from(j.textEdit):void 0,additionalTextEdits:j.additionalTextEdits?j.additionalTextEdits.map(Pe=>A.from(Pe)):void 0}}we.from=me})(pe=e.ColorPresentation||(e.ColorPresentation={}));var ge;(function(we){function Ce(j){return new l.Color(j[0],j[1],j[2],j[3])}we.to=Ce;function me(j){return[j.red,j.green,j.blue,j.alpha]}we.from=me})(ge=e.Color||(e.Color={}));var Ne;(function(we){function Ce(j){return{range:u.from(j.range)}}we.from=Ce;function me(j){return new l.SelectionRange(u.to(j.range))}we.to=me})(Ne=e.SelectionRange||(e.SelectionRange={}));var Be;(function(we){function Ce(me){switch(me){case 2:return l.TextDocumentSaveReason.AfterDelay;case 1:return l.TextDocumentSaveReason.Manual;case 3:case 4:return l.TextDocumentSaveReason.FocusOut}}we.to=Ce})(Be=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Je;(function(we){function Ce(j){switch(j){case l.TextEditorLineNumbersStyle.Off:return 0;case l.TextEditorLineNumbersStyle.Relative:return 2;case l.TextEditorLineNumbersStyle.On:default:return 1}}we.from=Ce;function me(j){switch(j){case 0:return l.TextEditorLineNumbersStyle.Off;case 2:return l.TextEditorLineNumbersStyle.Relative;case 1:default:return l.TextEditorLineNumbersStyle.On}}we.to=me})(Je=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ge;(function(we){function Ce(j){if(j===l.EndOfLine.CRLF)return 1;if(j===l.EndOfLine.LF)return 0}we.from=Ce;function me(j){if(j===1)return l.EndOfLine.CRLF;if(j===0)return l.EndOfLine.LF}we.to=me})(Ge=e.EndOfLine||(e.EndOfLine={}));var Te;(function(we){function Ce(me){if(typeof me=="object")return me.viewId;switch(me){case l.ProgressLocation.SourceControl:return 3;case l.ProgressLocation.Window:return 10;case l.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}we.from=Ce})(Te=e.ProgressLocation||(e.ProgressLocation={}));var rt;(function(we){function Ce(me){const j={start:me.start+1,end:me.end+1};return me.kind&&(j.kind=K.from(me.kind)),j}we.from=Ce})(rt=e.FoldingRange||(e.FoldingRange={}));var K;(function(we){function Ce(me){if(me)switch(me){case l.FoldingRangeKind.Comment:return m.FoldingRangeKind.Comment;case l.FoldingRangeKind.Imports:return m.FoldingRangeKind.Imports;case l.FoldingRangeKind.Region:return m.FoldingRangeKind.Region}}we.from=Ce})(K=e.FoldingRangeKind||(e.FoldingRangeKind={}));var X;(function(we){function Ce(me){if(me)return{pinned:typeof me.preview=="boolean"?!me.preview:void 0,inactive:me.background,preserveFocus:me.preserveFocus,selection:typeof me.selection=="object"?u.from(me.selection):void 0,override:typeof me.override=="boolean"?k.EditorResolution.DISABLED:void 0}}we.from=Ce})(X=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var fe;(function(we){function Ce(Le){return Le instanceof l.RelativePattern?Le.toJSON():typeof Le=="string"?Le:me(Le)||j(Le)?new l.RelativePattern(Le.baseUri??Le.base,Le.pattern).toJSON():Le}we.from=Ce;function me(Le){const tt=Le;return tt?O.URI.isUri(tt.baseUri)&&typeof tt.pattern=="string":!1}function j(Le){const tt=Le;return tt?typeof tt.base=="string"&&typeof tt.pattern=="string":!1}function Pe(Le){return typeof Le=="string"?Le:new l.RelativePattern(O.URI.revive(Le.baseUri),Le.pattern)}we.to=Pe})(fe=e.GlobPattern||(e.GlobPattern={}));var Ue;(function(we){function Ce(me){if(me){if(Array.isArray(me))return me.map(Ce);if(typeof me=="string")return me;{const j=me;return{language:j.language,scheme:j.scheme,pattern:fe.from(j.pattern),exclusive:j.exclusive,notebookType:j.notebookType}}}else return}we.from=Ce})(Ue=e.LanguageSelector||(e.LanguageSelector={}));var He;(function(we){function Ce(j){return{start:j.start,end:j.end}}we.from=Ce;function me(j){return new l.NotebookRange(j.start,j.end)}we.to=me})(He=e.NotebookRange||(e.NotebookRange={}));var Ze;(function(we){function Ce(j){return{timing:typeof j.runStartTime=="number"&&typeof j.runEndTime=="number"?{startTime:j.runStartTime,endTime:j.runEndTime}:void 0,executionOrder:j.executionOrder,success:j.lastRunSuccess}}we.to=Ce;function me(j){return{lastRunSuccess:j.success,runStartTime:j.timing?.startTime,runEndTime:j.timing?.endTime,executionOrder:j.executionOrder}}we.from=me})(Ze=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var qe;(function(we){function Ce(me){if(me===d.NotebookCellExecutionState.Unconfirmed)return l.NotebookCellExecutionState.Pending;if(me===d.NotebookCellExecutionState.Pending)return;if(me===d.NotebookCellExecutionState.Executing)return l.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${me}`)}we.to=Ce})(qe=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var We;(function(we){function Ce(j){switch(j){case l.NotebookCellKind.Markup:return d.CellKind.Markup;case l.NotebookCellKind.Code:default:return d.CellKind.Code}}we.from=Ce;function me(j){switch(j){case d.CellKind.Markup:return l.NotebookCellKind.Markup;case d.CellKind.Code:default:return l.NotebookCellKind.Code}}we.to=me})(We=e.NotebookCellKind||(e.NotebookCellKind={}));var nt;(function(we){function Ce(j){const Pe={metadata:j.metadata??Object.create(null),cells:[]};for(const Le of j.cells)l.NotebookCellData.validate(Le),Pe.cells.push(ot.from(Le));return Pe}we.from=Ce;function me(j){const Pe=new l.NotebookData(j.cells.map(ot.to));return(0,T.isEmptyObject)(j.metadata)||(Pe.metadata=j.metadata),Pe}we.to=me})(nt=e.NotebookData||(e.NotebookData={}));var ot;(function(we){function Ce(j){return{cellKind:We.from(j.kind),language:j.languageId,mime:j.mime,source:j.value,metadata:j.metadata,internalMetadata:Ze.from(j.executionSummary??{}),outputs:j.outputs?j.outputs.map(kt.from):[]}}we.from=Ce;function me(j){return new l.NotebookCellData(We.to(j.cellKind),j.source,j.language,j.mime,j.outputs?j.outputs.map(kt.to):void 0,j.metadata,j.internalMetadata?Ze.to(j.internalMetadata):void 0)}we.to=me})(ot=e.NotebookCellData||(e.NotebookCellData={}));var ht;(function(we){function Ce(j){return{mime:j.mime,valueBytes:v.VSBuffer.wrap(j.data)}}we.from=Ce;function me(j){return new l.NotebookCellOutputItem(j.valueBytes.buffer,j.mime)}we.to=me})(ht=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var kt;(function(we){function Ce(j){return{outputId:j.id,items:j.items.map(ht.from),metadata:j.metadata}}we.from=Ce;function me(j){const Pe=j.items.map(ht.to);return new l.NotebookCellOutput(Pe,j.outputId,j.metadata)}we.to=me})(kt=e.NotebookCellOutput||(e.NotebookCellOutput={}));var it;(function(we){function Ce(Pe){return j(Pe)?{include:(0,T.withNullAsUndefined)(fe.from(Pe.include)),exclude:(0,T.withNullAsUndefined)(fe.from(Pe.exclude))}:(0,T.withNullAsUndefined)(fe.from(Pe))}we.from=Ce;function me(Pe){return j(Pe)?{include:fe.to(Pe.include),exclude:fe.to(Pe.exclude)}:fe.to(Pe)}we.to=me;function j(Pe){const Le=Pe;return Le?!(0,T.isUndefinedOrNull)(Le.include)&&!(0,T.isUndefinedOrNull)(Le.exclude):!1}})(it=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var dt;(function(we){function Ce(me,j,Pe){const Le=typeof me.command=="string"?{title:"",command:me.command}:me.command;return{alignment:me.alignment===l.NotebookCellStatusBarAlignment.Left?1:2,command:j.toInternal(Le,Pe),text:me.text,tooltip:me.tooltip,accessibilityInformation:me.accessibilityInformation,priority:me.priority}}we.from=Ce})(dt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Ot;(function(we){function Ce(me){return{transientOutputs:me?.transientOutputs??!1,transientCellMetadata:me?.transientCellMetadata??{},transientDocumentMetadata:me?.transientDocumentMetadata??{}}}we.from=Ce})(Ot=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Wt;(function(we){function Ce(j){return{uri:j.uri,provides:j.provides}}we.from=Ce;function me(j){return new l.NotebookRendererScript(O.URI.revive(j.uri),j.provides)}we.to=me})(Wt=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Dt;(function(we){function Ce(j){return{message:L.fromStrict(j.message)||"",type:0,expected:j.expectedOutput,actual:j.actualOutput,location:j.location&&{range:u.from(j.location.range),uri:j.location.uri}}}we.from=Ce;function me(j){const Pe=new l.TestMessage(typeof j.message=="string"?j.message:L.to(j.message));return Pe.actualOutput=j.actual,Pe.expectedOutput=j.expected,Pe.location=j.location?ve.to(j.location):void 0,Pe}we.to=me})(Dt=e.TestMessage||(e.TestMessage={}));var ft;(function(we){we.namespace=g.namespaceTestTag,we.denamespace=g.denamespaceTestTag})(ft=e.TestTag||(e.TestTag={}));var Ct;(function(we){function Ce(j){const Pe=(0,h.getPrivateApiFor)(j).controllerId;return{extId:o.TestId.fromExtHostTestItem(j,Pe).toString(),label:j.label,uri:O.URI.revive(j.uri),busy:!1,tags:j.tags.map(Le=>ft.namespace(Pe,Le.id)),range:y.Range.lift(u.from(j.range)),description:j.description||null,sortText:j.sortText||null,error:j.error&&L.fromStrict(j.error)||null}}we.from=Ce;function me(j){return{parent:void 0,error:void 0,id:o.TestId.fromString(j.extId).localId,label:j.label,uri:O.URI.revive(j.uri),tags:(j.tags||[]).map(Pe=>{const{tagId:Le}=ft.denamespace(Pe);return new l.TestTag(Le)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:u.to(j.range||void 0),canResolveChildren:!1,busy:!1,description:j.description||void 0,sortText:j.sortText||void 0}}we.toPlain=me})(Ct=e.TestItem||(e.TestItem={})),function(we){function Ce(j){return{id:j.id}}we.from=Ce;function me(j){return new l.TestTag(j.id)}we.to=me}(ft=e.TestTag||(e.TestTag={}));var Lt;(function(we){const Ce=(j,Pe)=>{const Le=[];for(const[Xe,je]of Pe)o.TestId.compare(je.item.extId,Xe)===2&&(Pe.delete(Xe),Le.push(je));const tt={...Ct.toPlain(j.item),parent:void 0,taskStates:j.tasks.map(Xe=>({state:Xe.state,duration:Xe.duration,messages:Xe.messages.filter(je=>je.type===0).map(Dt.to)})),children:Le.map(Xe=>Ce(Xe,Pe))};for(const Xe of tt.children)Xe.parent=tt;return tt};function me(j){const Pe=[],Le=new Map;for(const tt of j.items)Le.set(tt.item.extId,tt),j.request.targets.some(Xe=>Xe.controllerId===tt.controllerId&&Xe.testIds.includes(tt.item.extId))&&Pe.push(tt);return{completedAt:j.completedAt,results:Pe.map(tt=>Ce(tt,Le))}}we.to=me})(Lt=e.TestResults||(e.TestResults={}));var Ft;(function(we){function Ce(Le){return{covered:Le.covered,total:Le.covered}}function me(Le){return"line"in Le?i.from(Le):u.from(Le)}function j(Le){return"branches"in Le?{count:Le.executionCount,location:me(Le.location),type:1,branches:Le.branches.length?Le.branches.map(tt=>({count:tt.executionCount,location:tt.location&&me(tt.location)})):void 0}:{type:0,count:Le.executionCount,location:me(Le.location)}}we.fromDetailed=j;function Pe(Le){return{uri:Le.uri,statement:Ce(Le.statementCoverage),branch:Le.branchCoverage&&Ce(Le.branchCoverage),function:Le.functionCoverage&&Ce(Le.functionCoverage),details:Le.detailedCoverage?.map(j)}}we.fromFile=Pe})(Ft=e.TestCoverage||(e.TestCoverage={}));var Ve;(function(we){function Ce(me){switch(me){case 1:return l.CodeActionTriggerKind.Invoke;case 2:return l.CodeActionTriggerKind.Automatic}}we.to=Ce})(Ve=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Nt;(function(we){function Ce(j){const Pe=new l.TypeHierarchyItem(le.to(j.kind),j.name,j.detail||"",O.URI.revive(j.uri),u.to(j.range),u.to(j.selectionRange));return Pe._sessionId=j._sessionId,Pe._itemId=j._itemId,Pe}we.to=Ce;function me(j,Pe,Le){if(Pe=Pe??j._sessionId,Le=Le??j._itemId,Pe===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:Pe,_itemId:Le,kind:le.from(j.kind),name:j.name,detail:j.detail??"",uri:j.uri,range:u.from(j.range),selectionRange:u.from(j.selectionRange),tags:j.tags?.map(oe.from)}}we.from=me})(Nt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Rt;(function(we){function Ce(me){if(!!me)return{value:me.value,tooltip:me.tooltip}}we.from=Ce})(Rt=e.ViewBadge||(e.ViewBadge={}));var Ut;(function(we){function Ce(me,j){const Pe=me.fileData;return Pe?new class extends l.DataTransferItem{asFile(){return{name:Pe.name,uri:O.URI.revive(Pe.uri),data:(0,w.once)(()=>j())}}}(""):new l.DataTransferItem(me.asString)}we.toDataTransferItem=Ce})(Ut=e.DataTransferItem||(e.DataTransferItem={}));var vt;(function(we){function Ce(j,Pe){const Le=j.items.map(([tt,Xe],je)=>[tt,Ut.toDataTransferItem(Xe,()=>Pe(je))]);return new l.DataTransfer(Le)}we.toDataTransfer=Ce;async function me(j){const Pe={items:[]},Le=[];return j.forEach((tt,Xe)=>{Le.push((async()=>{const je=await tt.asString(),ut=tt.asFile();Pe.items.push([Xe,{asString:je,fileData:ut?{name:ut.name,uri:ut.uri}:void 0}])})())}),await Promise.all(Le),Pe}we.toDataTransferDTO=me})(vt=e.DataTransfer||(e.DataTransfer={}))}),define(ye[175],De([1,0,2,11,6,8,242]),function(ne,e,a,v,b,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class P{constructor(T,O,y,m={timeout:1500,errors:3}){this._logService=T,this._documents=O,this._mainThreadBulkEdits=y,this._thresholds=m,this._callbacks=new D.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(T){return(O,y,m)=>{const f={dispose:this._callbacks.push([O,y,T])};return Array.isArray(m)&&m.push(f),f}}async $participateInSave(T,O){const y=a.URI.revive(T);let m=!1;const k=setTimeout(()=>m=!0,this._thresholds.timeout),f=[];try{for(const h of[...this._callbacks]){if(m)break;const d=this._documents.getDocument(y),o=await this._deliverEventAsyncAndBlameBadListeners(h,{document:d,reason:M.TextDocumentSaveReason.to(O)});f.push(o)}}finally{clearTimeout(k)}return f}_deliverEventAsyncAndBlameBadListeners([T,O,y],m){const k=this._badListeners.get(T);return typeof k=="number"&&k>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(y,T,O,m).then(()=>!0,f=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${y.identifier.value}' threw ERROR`),this._logService.error(f),!(f instanceof Error)||f.message!=="concurrent_edits"){const h=this._badListeners.get(T);this._badListeners.set(T,h?h+1:1),typeof h=="number"&&h>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${y.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(T,O,y,m){const k=[],f=Date.now(),{document:h,reason:d}=m,{version:o}=h,g=Object.freeze({document:h,reason:d,waitUntil(R){if(Object.isFrozen(k))throw(0,v.illegalState)("waitUntil can not be called async");k.push(Promise.resolve(R))}});try{O.apply(y,[g])}catch(R){return Promise.reject(R)}return Object.freeze(k),new Promise((R,l)=>{const w=setTimeout(()=>l(new Error("timeout")),this._thresholds.timeout);return Promise.all(k).then(s=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${T.identifier.value}' finished after ${Date.now()-f}ms`),clearTimeout(w),R(s)}).catch(s=>{clearTimeout(w),l(s)})}).then(R=>{const l={edits:[]};for(const w of R)if(Array.isArray(w)&&w.every(s=>s instanceof b.TextEdit))for(const{newText:s,newEol:u,range:n}of w)l.edits.push({resource:h.uri,versionId:void 0,textEdit:{range:n&&M.Range.from(n),text:s,eol:u&&M.EndOfLine.from(u)}});if(l.edits.length!==0)return o===h.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(l):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=P}),define(ye[176],De([1,0,12,2,8,6,88]),function(ne,e,a,v,b,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class P{constructor(y,m,k,f){this.start=y,this.deletedCount=m,this.deletedItems=k,this.items=f}asApiEvent(){return{range:new M.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(y=>y.apiCell),removedCells:this.deletedItems}}}class E{constructor(y,m,k){this.notebook=y,this._extHostDocument=m,this._cellData=k,this.handle=k.handle,this.uri=v.URI.revive(k.uri),this.cellKind=k.cellKind,this._outputs=k.outputs.map(b.NotebookCellOutput.to),this._internalMetadata=k.internalMetadata??{},this._metadata=Object.freeze(k.metadata??{}),this._previousResult=Object.freeze(b.NotebookCellExecutionSummary.to(k.internalMetadata??{}))}static asModelAddData(y,m){return{EOL:m.eol,lines:m.source,languageId:m.language,uri:m.uri,isDirty:!1,versionId:1,notebook:y}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const y=this,m=this._extHostDocument.getDocument(this.uri);if(!m)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const k={get index(){return y.notebook.getCellIndex(y)},notebook:y.notebook.apiNotebook,kind:b.NotebookCellKind.to(this._cellData.cellKind),document:m.document,get mime(){return y._mime},set mime(f){y._mime=f},get outputs(){return y._outputs.slice(0)},get metadata(){return y._metadata},get executionSummary(){return y._previousResult}};this._apiCell=Object.freeze(k)}return this._apiCell}setOutputs(y){this._outputs=y.map(b.NotebookCellOutput.to)}setOutputItems(y,m,k){const f=k.map(b.NotebookCellOutputItem.to),h=this._outputs.find(d=>d.id===y);h&&(m||(h.items.length=0),h.items.push(...f))}setMetadata(y){this._metadata=Object.freeze(y)}setInternalMetadata(y){this._internalMetadata=y,this._previousResult=Object.freeze(b.NotebookCellExecutionSummary.to(y))}setMime(y){}}e.ExtHostCell=E;class T{constructor(y,m,k,f,h){this._proxy=y,this._textDocumentsAndEditors=m,this._textDocuments=k,this.uri=f,this.handle=T._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=h.viewType,this._metadata=Object.freeze(h.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,h.cells]],!0,void 0),this._versionId=h.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const y=this,m={get uri(){return y.uri},get version(){return y._versionId},get notebookType(){return y._notebookType},get isDirty(){return y._isDirty},get isUntitled(){return y.uri.scheme===a.Schemas.untitled},get isClosed(){return y._disposed},get metadata(){return y._metadata},get cellCount(){return y._cells.length},cellAt(k){return k=y._validateIndex(k),y._cells[k].apiCell},getCells(k){return(k?y._getCells(k):y._cells).map(h=>h.apiCell)},save(){return y._save()}};this._notebook=Object.freeze(m)}return this._notebook}updateBackup(y){this._backup?.delete(),this._backup=y}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(y){y.metadata&&(this._metadata=Object.freeze({...this._metadata,...y.metadata}))}acceptDirty(y){this._isDirty=y}acceptModelChanged(y,m,k){this._versionId=y.versionId,this._isDirty=m,this.acceptDocumentPropertiesChanged({metadata:k});const f={notebook:this.apiNotebook,metadata:k,cellChanges:[],contentChanges:[]},h=[];for(const o of y.rawEvents)o.kind===D.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(o.changes,!1,f.contentChanges):o.kind===D.NotebookCellsChangeType.Move?this._moveCell(o.index,o.newIdx,f.contentChanges):o.kind===D.NotebookCellsChangeType.Output?(this._setCellOutputs(o.index,o.outputs),h.push({cell:this._cells[o.index].apiCell,outputs:this._cells[o.index].apiCell.outputs})):o.kind===D.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(o.index,o.outputId,o.append,o.outputItems),h.push({cell:this._cells[o.index].apiCell,outputs:this._cells[o.index].apiCell.outputs})):o.kind===D.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(o.index,o.language),h.push({cell:this._cells[o.index].apiCell,document:this._cells[o.index].apiCell.document})):o.kind===D.NotebookCellsChangeType.ChangeCellContent?h.push({cell:this._cells[o.index].apiCell,document:this._cells[o.index].apiCell.document}):o.kind===D.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(o.index,o.mime):o.kind===D.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(o.index,o.metadata),h.push({cell:this._cells[o.index].apiCell,metadata:this._cells[o.index].apiCell.metadata})):o.kind===D.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(o.index,o.internalMetadata),h.push({cell:this._cells[o.index].apiCell,executionSummary:this._cells[o.index].apiCell.executionSummary}));const d=new Map;for(let o=0;o<h.length;o++){const g=h[o],R=d.get(g.cell);if(R===void 0){const l=f.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...g});d.set(g.cell,l-1)}else f.cellChanges[R]={...f.cellChanges[R],...g}}return Object.freeze(f),Object.freeze(f.cellChanges),Object.freeze(f.contentChanges),f}_validateIndex(y){return y=y|0,y<0?0:y>=this._cells.length?this._cells.length-1:y}_validateRange(y){let m=y.start|0,k=y.end|0;return m<0&&(m=0),k>this._cells.length&&(k=this._cells.length),y.with({start:m,end:k})}_getCells(y){y=this._validateRange(y);const m=[];for(let k=y.start;k<y.end;k++)m.push(this._cells[k]);return m}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(y,m,k){if(this._disposed)return;const f=[],h=[],d=[];if(y.reverse().forEach(o=>{const R=o[2].map(s=>{const u=new E(this,this._textDocumentsAndEditors,s);return m||h.push(E.asModelAddData(this.apiNotebook,s)),u}),l=new P(o[0],o[1],[],R),w=this._cells.splice(o[0],o[1],...R);for(const s of w)d.push(s.uri),l.deletedItems.push(s.apiCell);f.push(l)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:h,removedDocuments:d}),k)for(const o of f)k.push(o.asApiEvent())}_moveCell(y,m,k){const f=this._cells.splice(y,1);this._cells.splice(m,0,...f);const h=[new P(y,1,f.map(d=>d.apiCell),[]),new P(m,0,[],f)];for(const d of h)k.push(d.asApiEvent())}_setCellOutputs(y,m){this._cells[y].setOutputs(m)}_setCellOutputItems(y,m,k,f){this._cells[y].setOutputItems(m,k,f)}_changeCellLanguage(y,m){const k=this._cells[y];k.apiCell.document.languageId!==m&&this._textDocuments.$acceptModelLanguageChanged(k.uri,m)}_changeCellMime(y,m){const k=this._cells[y];k.apiCell.mime=m}_changeCellMetadata(y,m){this._cells[y].setMetadata(m)}_changeCellInternalMetadata(y,m){this._cells[y].setInternalMetadata(m)}getCellFromApiCell(y){return this._cells.find(m=>m.apiCell===y)}getCellFromIndex(y){return this._cells[y]}getCell(y){return this._cells.find(m=>m.handle===y)}getCellIndex(y){return this._cells.indexOf(y)}}e.ExtHostNotebookDocument=T,T._handlePool=0}),define(ye[91],De([1,0,6,8,11]),function(ne,e,a,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class M{constructor(E){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=E}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(E){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:E})}replaceCellMetadata(E,T){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:E,metadata:T})}replaceCells(E,T,O){this._throwIfFinalized(),!(E===T&&O.length===0)&&this._collectedEdits.push({editType:1,index:E,count:T-E,cells:O.map(v.NotebookCellData.from)})}}class D{constructor(E,T,O,y,m,k){this.id=E,this._proxy=T,this.notebookData=O,this._selections=[],this._visibleRanges=[],this._visible=!1,this._selections=m,this._visibleRanges=y,this._viewColumn=k}get apiEditor(){if(!this._editor){const E=this;this._editor={get document(){return E.notebookData.apiNotebook},get notebook(){return E.notebookData.apiNotebook},get selection(){return E._selections[0]},set selection(T){this.selections=[T]},get selections(){return E._selections},set selections(T){if(!Array.isArray(T)||!T.every(a.NotebookRange.isNotebookRange))throw(0,b.illegalArgument)("selections");E._selections=T,E._trySetSelections(T)},get visibleRanges(){return E._visibleRanges},revealRange(T,O){E._proxy.$tryRevealRange(E.id,v.NotebookRange.from(T),O??a.NotebookEditorRevealType.Default)},get viewColumn(){return E._viewColumn},edit(T){const O=new M(this.document.version);return T(O),E._applyEdit(O.finalize())}},D.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(E){this._visible=E}_acceptVisibleRanges(E){this._visibleRanges=E}_acceptSelections(E){this._selections=E}_trySetSelections(E){this._proxy.$trySetSelections(this.id,E.map(v.NotebookRange.from))}_acceptViewColumn(E){this._viewColumn=E}_applyEdit(E){if(E.cellEdits.length===0)return Promise.resolve(!0);const T=[];let O=-1;for(let y=0;y<E.cellEdits.length;y++){if(O<0){T.push(E.cellEdits[y]),O++;continue}const k=T[O],f=E.cellEdits[y];if(k.editType===1&&f.editType===1&&k.index===f.index){k.cells.push(...E.cellEdits[y].cells),k.count+=E.cellEdits[y].count;continue}T.push(E.cellEdits[y]),O++}return this._proxy.$tryApplyEdits(this.id,E.documentVersionId,T)}}e.ExtHostNotebookEditor=D,D.apiEditorsToExtHost=new WeakMap}),define(ye[177],De([1,0,5,15,8]),function(ne,e,a,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let M=class{constructor(P,E){this._logService=P,this._notebooksAndEditors=E,this._onDidChangeNotebookEditorSelection=new a.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new a.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}$acceptEditorPropertiesChanged(P,E){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",P,E);const T=this._notebooksAndEditors.getEditorById(P);E.visibleRanges&&T._acceptVisibleRanges(E.visibleRanges.ranges.map(b.NotebookRange.to)),E.selections&&T._acceptSelections(E.selections.selections.map(b.NotebookRange.to)),E.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:T.apiEditor,visibleRanges:T.apiEditor.visibleRanges}),E.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:T.apiEditor,selections:T.apiEditor.selections}))}$acceptEditorViewColumns(P){for(const E in P)this._notebooksAndEditors.getEditorById(E)._acceptViewColumn(b.ViewColumn.to(P[E]))}};M=ze([xe(0,v.ILogService)],M),e.ExtHostNotebookEditors=M}),define(ye[178],De([1,0,8,151,131,20,54,11]),function(ne,e,a,v,b,M,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class E{constructor(m){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=m}async withProgress(m,k,f){const h=this._handles++,{title:d,location:o,cancellable:g}=k,R={label:(0,b.localize)(0,null,m.displayName||m.name),id:m.identifier.value};return this._proxy.$startProgress(h,{location:a.ProgressLocation.from(o),title:d,source:R,cancellable:g},m.isUnderDevelopment?void 0:m.identifier.value).catch(P.onUnexpectedExternalError),this._withProgress(h,f,!!g)}_withProgress(m,k,f){let h;f&&(h=new M.CancellationTokenSource,this._mapHandleToCancellationSource.set(m,h));const d=g=>{this._proxy.$progressEnd(g),this._mapHandleToCancellationSource.delete(g),h?.dispose()};let o;try{o=k(new O(this._proxy,m),f&&h?h.token:M.CancellationToken.None)}catch(g){throw d(m),g}return o.then(g=>d(m),g=>d(m)),o}$acceptProgressCanceled(m){const k=this._mapHandleToCancellationSource.get(m);k&&(k.cancel(),this._mapHandleToCancellationSource.delete(m))}}e.ExtHostProgress=E;function T(y,m){return y.message=m.message,typeof m.increment=="number"&&(typeof y.increment=="number"?y.increment+=m.increment:y.increment=m.increment),y}class O extends v.Progress{constructor(m,k){super(f=>this.throttledReport(f));this._proxy=m,this._handle=k}throttledReport(m){this._proxy.$progressReport(this._handle,m)}}ze([(0,D.throttle)(100,(y,m)=>T(y,m),()=>Object.create(null))],O.prototype,"throttledReport",null)}),define(ye[92],De([1,0,48,89,46,65,47,8,2]),function(ne,e,a,v,b,M,D,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const T=(R,l,w,s)=>{let u=l;return{enumerable:!0,configurable:!1,get(){return u},set(n){if(!w(u,n)){const i=u;u=n,R.listener?.(s(n,i))}}}},O=(R,l)=>R===l,y={range:(R,l)=>R===l?!0:!R||!l?!1:R.isEqual(l),label:O,description:O,sortText:O,busy:O,error:O,canResolveChildren:O,tags:(R,l)=>!(R.length!==l.length||R.some(w=>!l.find(s=>w.id===s.id)))},m=R=>l=>({op:4,update:R(l)}),k=(R,l)=>({range:T(R,void 0,y.range,m(w=>({range:a.Range.lift(P.Range.from(w))}))),label:T(R,l,y.label,m(w=>({label:w}))),description:T(R,void 0,y.description,m(w=>({description:w}))),sortText:T(R,void 0,y.sortText,m(w=>({sortText:w}))),canResolveChildren:T(R,!1,y.canResolveChildren,w=>({op:2,state:w})),busy:T(R,!1,y.busy,m(w=>({busy:w}))),error:T(R,void 0,y.error,m(w=>({error:P.MarkdownString.fromStrict(w)||null}))),tags:T(R,[],y.tags,(w,s)=>({op:1,new:w.map(P.TestTag.from),old:s.map(P.TestTag.from)}))}),f=R=>{const l=b.TestId.fromString(R.extId),w=new d(l.controllerId,l.localId,R.label,E.URI.revive(R.uri)||void 0);return w.range=P.Range.to(R.range||void 0),w.description=R.description||void 0,w.sortText=R.sortText||void 0,w.tags=R.tags.map(s=>P.TestTag.to({id:(0,D.denamespaceTestTag)(s).tagId})),w},h=R=>{let l;for(const w of R.tests){const s=f(w.item);(0,v.getPrivateApiFor)(s).parent=l,l=s}return l};e.toItemFromContext=h;class d{constructor(l,w,s,u){if(w.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(w)} symbol`);const n=(0,v.createPrivateApiFor)(this,l);Object.defineProperties(this,{id:{value:w,enumerable:!0,writable:!1},uri:{value:u,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return n.parent instanceof o?void 0:n.parent}},children:{value:(0,M.createTestItemChildren)(n,v.getPrivateApiFor,d),enumerable:!0,writable:!1},...k(n,s)})}}e.TestItemImpl=d;class o extends d{constructor(l,w){super(l,l,w,void 0)}}e.TestItemRootImpl=o;class g extends M.TestItemCollection{constructor(l,w){super({controllerId:l,getApiFor:v.getPrivateApiFor,getChildren:s=>s.children,root:new o(l,w),toITestItem:P.TestItem.from})}}e.ExtHostTestItemCollection=g}),define(ye[93],De([1,0,44,11,73,8,6]),function(ne,e,a,v,b,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class P{constructor(m,k,f){const h=P._Keys.nextId();m.$registerTextEditorDecorationType(k.identifier,h,M.DecorationRenderOptions.from(f)),this.value=Object.freeze({key:h,dispose(){m.$removeTextEditorDecorationType(h)}})}}e.TextEditorDecorationType=P,P._Keys=new b.IdGenerator("TextEditorDecorationType");class E{constructor(m,k){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=m,this._documentVersionId=m.version,this._undoStopBefore=k.undoStopBefore,this._undoStopAfter=k.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(m,k){this._throwIfFinalized();let f=null;if(m instanceof D.Position)f=new D.Range(m,m);else if(m instanceof D.Range)f=m;else throw new Error("Unrecognized location");this._pushEdit(f,k,!1)}insert(m,k){this._throwIfFinalized(),this._pushEdit(new D.Range(m,m),k,!0)}delete(m){this._throwIfFinalized();let k=null;if(m instanceof D.Range)k=m;else throw new Error("Unrecognized location");this._pushEdit(k,null,!0)}_pushEdit(m,k,f){const h=this._document.validateRange(m);this._collectedEdits.push({range:h,text:k,forceMoveMarkers:f})}setEndOfLine(m){if(this._throwIfFinalized(),m!==D.EndOfLine.LF&&m!==D.EndOfLine.CRLF)throw(0,v.illegalArgument)("endOfLine");this._setEndOfLine=m}}e.TextEditorEdit=E;class T{constructor(m,k,f,h){this._proxy=m,this._id=k,this._accept(f),this._logService=h;const d=this;this.value={get tabSize(){return d._tabSize},set tabSize(o){d._setTabSize(o)},get insertSpaces(){return d._insertSpaces},set insertSpaces(o){d._setInsertSpaces(o)},get cursorStyle(){return d._cursorStyle},set cursorStyle(o){d._setCursorStyle(o)},get lineNumbers(){return d._lineNumbers},set lineNumbers(o){d._setLineNumbers(o)}}}_accept(m){this._tabSize=m.tabSize,this._insertSpaces=m.insertSpaces,this._cursorStyle=m.cursorStyle,this._lineNumbers=M.TextEditorLineNumbersStyle.to(m.lineNumbers)}_validateTabSize(m){if(m==="auto")return"auto";if(typeof m=="number"){const k=Math.floor(m);return k>0?k:null}if(typeof m=="string"){const k=parseInt(m,10);return isNaN(k)?null:k>0?k:null}return null}_setTabSize(m){const k=this._validateTabSize(m);if(k!==null){if(typeof k=="number"){if(this._tabSize===k)return;this._tabSize=k}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:k}))}}_validateInsertSpaces(m){return m==="auto"?"auto":m==="false"?!1:Boolean(m)}_setInsertSpaces(m){const k=this._validateInsertSpaces(m);if(typeof k=="boolean"){if(this._insertSpaces===k)return;this._insertSpaces=k}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:k}))}_setCursorStyle(m){this._cursorStyle!==m&&(this._cursorStyle=m,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:m})))}_setLineNumbers(m){this._lineNumbers!==m&&(this._lineNumbers=m,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:M.TextEditorLineNumbersStyle.from(m)})))}assign(m){const k={};let f=!1;if(typeof m.tabSize!="undefined"){const h=this._validateTabSize(m.tabSize);h==="auto"?(f=!0,k.tabSize=h):typeof h=="number"&&this._tabSize!==h&&(this._tabSize=h,f=!0,k.tabSize=h)}if(typeof m.insertSpaces!="undefined"){const h=this._validateInsertSpaces(m.insertSpaces);h==="auto"?(f=!0,k.insertSpaces=h):this._insertSpaces!==h&&(this._insertSpaces=h,f=!0,k.insertSpaces=h)}typeof m.cursorStyle!="undefined"&&this._cursorStyle!==m.cursorStyle&&(this._cursorStyle=m.cursorStyle,f=!0,k.cursorStyle=m.cursorStyle),typeof m.lineNumbers!="undefined"&&this._lineNumbers!==m.lineNumbers&&(this._lineNumbers=m.lineNumbers,f=!0,k.lineNumbers=M.TextEditorLineNumbersStyle.from(m.lineNumbers)),f&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,k))}_warnOnError(m,k){k.catch(f=>{this._logService.warn(`ExtHostTextEditorOptions '${m}' failed:'`),this._logService.warn(f)})}}e.ExtHostTextEditorOptions=T;class O{constructor(m,k,f,h,d,o,g,R){this.id=m,this._proxy=k,this._logService=f,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=d,this._options=new T(this._proxy,this.id,o,f),this._visibleRanges=g,this._viewColumn=R;const l=this;this.value=Object.freeze({get document(){return h.getValue()},set document(w){throw(0,v.readonly)("document")},get selection(){return l._selections&&l._selections[0]},set selection(w){if(!(w instanceof D.Selection))throw(0,v.illegalArgument)("selection");l._selections=[w],l._trySetSelection()},get selections(){return l._selections},set selections(w){if(!Array.isArray(w)||w.some(s=>!(s instanceof D.Selection)))throw(0,v.illegalArgument)("selections");l._selections=w,l._trySetSelection()},get visibleRanges(){return l._visibleRanges},set visibleRanges(w){throw(0,v.readonly)("visibleRanges")},get options(){return l._options.value},set options(w){l._disposed||l._options.assign(w)},get viewColumn(){return l._viewColumn},set viewColumn(w){throw(0,v.readonly)("viewColumn")},edit(w,s={undoStopBefore:!0,undoStopAfter:!0}){if(l._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const u=new E(h.getValue(),s);return w(u),l._applyEdit(u)},insertSnippet(w,s,u={undoStopBefore:!0,undoStopAfter:!0}){if(l._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let n;if(!s||Array.isArray(s)&&s.length===0)n=l._selections.map(i=>M.Range.from(i));else if(s instanceof D.Position){const{lineNumber:i,column:r}=M.Position.from(s);n=[{startLineNumber:i,startColumn:r,endLineNumber:i,endColumn:r}]}else if(s instanceof D.Range)n=[M.Range.from(s)];else{n=[];for(const i of s)if(i instanceof D.Range)n.push(M.Range.from(i));else{const{lineNumber:r,column:t}=M.Position.from(i);n.push({startLineNumber:r,startColumn:t,endLineNumber:r,endColumn:t})}}return k.$tryInsertSnippet(m,h.getValue().version,w.value,n,u)},setDecorations(w,s){const u=s.length===0;u&&!l._hasDecorationsForKey.has(w.key)||(u?l._hasDecorationsForKey.delete(w.key):l._hasDecorationsForKey.add(w.key),l._runOnProxy(()=>{if(M.isDecorationOptionsArr(s))return k.$trySetDecorations(m,w.key,M.fromRangeOrRangeWithMessage(s));{const n=new Array(4*s.length);for(let i=0,r=s.length;i<r;i++){const t=s[i];n[4*i]=t.start.line+1,n[4*i+1]=t.start.character+1,n[4*i+2]=t.end.line+1,n[4*i+3]=t.end.character+1}return k.$trySetDecorationsFast(m,w.key,n)}}))},revealRange(w,s){l._runOnProxy(()=>k.$tryRevealRange(m,M.Range.from(w),s||D.TextEditorRevealType.Default))},show(w){k.$tryShowEditor(m,M.ViewColumn.from(w))},hide(){k.$tryHideEditor(m)}})}dispose(){(0,a.ok)(!this._disposed),this._disposed=!0}_acceptOptions(m){(0,a.ok)(!this._disposed),this._options._accept(m)}_acceptVisibleRanges(m){(0,a.ok)(!this._disposed),this._visibleRanges=m}_acceptViewColumn(m){(0,a.ok)(!this._disposed),this._viewColumn=m}_acceptSelections(m){(0,a.ok)(!this._disposed),this._selections=m}async _trySetSelection(){const m=this._selections.map(M.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,m)),this.value}_applyEdit(m){const k=m.finalize();if(k.edits.length===0&&!k.setEndOfLine)return Promise.resolve(!0);const f=k.edits.map(d=>d.range);f.sort((d,o)=>d.end.line===o.end.line?d.end.character===o.end.character?d.start.line===o.start.line?d.start.character-o.start.character:d.start.line-o.start.line:d.end.character-o.end.character:d.end.line-o.end.line);for(let d=0,o=f.length-1;d<o;d++){const g=f[d].end;if(f[d+1].start.isBefore(g))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const h=k.edits.map(d=>({range:M.Range.from(d.range),text:d.text,forceMoveMarkers:d.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,k.documentVersionId,h,{setEndOfLine:typeof k.setEndOfLine=="number"?M.EndOfLine.from(k.setEndOfLine):void 0,undoStopBefore:k.undoStopBefore,undoStopAfter:k.undoStopAfter})}_runOnProxy(m){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):m().then(()=>this,k=>(k instanceof Error&&k.name==="DISPOSED"||this._logService.warn(k),null))}}e.ExtHostTextEditor=O}),define(ye[179],De([1,0,3,147]),function(ne,e,a,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,a.refineServiceDecorator)(v.IEnvironmentService)}),define(ye[180],De([1,0,27,5,19]),function(ne,e,a,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class M{constructor(y){this.removedDueToLooping=y}}e.DeltaExtensionsResult=M;class D{constructor(y){this._onDidChange=new v.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=y,this._initialize()}_initialize(){this._extensionDescriptions.sort(E),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const y of this._extensionDescriptions){if(this._extensionsMap.has(a.ExtensionIdentifier.toKey(y.identifier))){console.error("Extension `"+y.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(a.ExtensionIdentifier.toKey(y.identifier),y),this._extensionsArr.push(y),Array.isArray(y.activationEvents))for(let m of y.activationEvents)m==="onUri"&&(m=`onUri:${a.ExtensionIdentifier.toKey(y.identifier)}`),this._activationMap.has(m)||this._activationMap.set(m,[]),this._activationMap.get(m).push(y)}}set(y){this._extensionDescriptions=y,this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(y,m){this._extensionDescriptions=T(this._extensionDescriptions,m),this._extensionDescriptions=this._extensionDescriptions.concat(y);const k=D._findLoopingExtensions(this._extensionDescriptions);return this._extensionDescriptions=T(this._extensionDescriptions,k.map(f=>f.identifier)),this._initialize(),this._onDidChange.fire(void 0),new M(k)}static _findLoopingExtensions(y){const m=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(o){this._nodesSet.has(o)||(this._nodesSet.add(o),this._nodesArr.push(o))}addArc(o,g){this.addNode(o),this.addNode(g),this._arcs.has(o)?this._arcs.get(o).push(g):this._arcs.set(o,[g])}getArcs(o){return this._arcs.has(o)?this._arcs.get(o):[]}hasOnlyGoodArcs(o,g){const R=m.getArcs(o);for(let l=0;l<R.length;l++)if(!g.has(R[l]))return!1;return!0}getNodes(){return this._nodesArr}},k=new Map;for(const o of y){const g=a.ExtensionIdentifier.toKey(o.identifier);if(k.set(g,o),o.extensionDependencies)for(const R of o.extensionDependencies){const l=a.ExtensionIdentifier.toKey(R);m.addArc(g,l)}}const f=new Set;m.getNodes().filter(o=>m.getArcs(o).length===0).forEach(o=>f.add(o));const h=m.getNodes().filter(o=>!f.has(o));let d;do{d=!1;for(let o=0;o<h.length;o++){const g=h[o];m.hasOnlyGoodArcs(g,f)&&(h.splice(o,1),o--,f.add(g),d=!0)}}while(d);return h.map(o=>k.get(o))}containsActivationEvent(y){return this._activationMap.has(y)}containsExtension(y){return this._extensionsMap.has(a.ExtensionIdentifier.toKey(y))}getExtensionDescriptionsForActivationEvent(y){const m=this._activationMap.get(y);return m?m.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(y){const m=this._extensionsMap.get(a.ExtensionIdentifier.toKey(y));return m||void 0}getExtensionDescriptionByUUID(y){for(const m of this._extensionsArr)if(m.uuid===y)return m}getExtensionDescriptionByIdOrUUID(y,m){return this.getExtensionDescription(y)??(m?this.getExtensionDescriptionByUUID(m):void 0)}}e.ExtensionDescriptionRegistry=D;var P;(function(O){O[O.Builtin=0]="Builtin",O[O.User=1]="User",O[O.Dev=2]="Dev"})(P||(P={}));function E(O,y){const m=O.isBuiltin?0:O.isUnderDevelopment?2:1,k=y.isBuiltin?0:y.isUnderDevelopment?2:1;if(m!==k)return m-k;const f=b.posix.basename(O.extensionLocation.path),h=b.posix.basename(y.extensionLocation.path);return f<h?-1:f>h?1:0}function T(O,y){const m=new Set;return y.forEach(k=>m.add(a.ExtensionIdentifier.toKey(k))),O.filter(k=>!m.has(a.ExtensionIdentifier.toKey(k.identifier)))}}),define(ye[94],De([1,0,23]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var v;(function(T){T[T.Desktop=1]="Desktop",T[T.Web=2]="Web"})(v=e.UIKind||(e.UIKind={}));var b;(function(T){T[T.VersionMismatch=55]="VersionMismatch",T[T.UnexpectedError=81]="UnexpectedError"})(b=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var M;(function(T){T[T.Initialized=0]="Initialized",T[T.Ready=1]="Ready",T[T.Terminate=2]="Terminate"})(M=e.MessageType||(e.MessageType={}));function D(T){const O=a.VSBuffer.alloc(1);switch(T){case 0:O.writeUInt8(1,0);break;case 1:O.writeUInt8(2,0);break;case 2:O.writeUInt8(3,0);break}return O}e.createMessageOfType=D;function P(T,O){if(T.byteLength!==1)return!1;switch(T.readUInt8(0)){case 1:return O===0;case 2:return O===1;case 3:return O===2;default:return!1}}e.isMessageOfType=P;var E;(function(T){T.Start="START_NATIVE_LOG",T.End="END_NATIVE_LOG"})(E=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(ye[24],De([1,0,5,2,3,27,153]),function(ne,e,a,v,b,M,D){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new M.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:v.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,b.createDecorator)("extensionService");class E{constructor(t){this.affinity=t,this.kind=1}equals(t){return this.kind===t.kind&&this.affinity===t.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=E;class T{constructor(){this.kind=2,this.affinity=0}equals(t){return this.kind===t.kind}asString(){return"LocalWebWorker"}}e.LocalWebWorkerRunningLocation=T;class O{constructor(){this.kind=3,this.affinity=0}equals(t){return this.kind===t.kind}asString(){return"Remote"}}e.RemoteRunningLocation=O;class y{constructor(t){this.dependency=t}}e.MissingExtensionDependency=y;var m;(function(r){r[r.LocalProcess=1]="LocalProcess",r[r.LocalWebWorker=2]="LocalWebWorker",r[r.Remote=3]="Remote"})(m=e.ExtensionHostKind||(e.ExtensionHostKind={}));function k(r){if(r===null)return"None";switch(r){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=k;class f{constructor(){this._allExtensions=[],this._myExtensions=[]}toDelta(){return{toRemove:[],toAdd:this._allExtensions,myToRemove:[],myToAdd:this._myExtensions}}set(t,c){const _=[],p=[],C=[],U=[],W=o(this._allExtensions),L=o(t),S=(q,ie)=>q.extensionLocation.toString()===ie.extensionLocation.toString()||q.isBuiltin===ie.isBuiltin||q.isUserBuiltin===ie.isUserBuiltin||q.isUnderDevelopment===ie.isUnderDevelopment;for(const q of this._allExtensions){const ie=L.get(M.ExtensionIdentifier.toKey(q.identifier));if(!ie){_.push(q.identifier),W.delete(M.ExtensionIdentifier.toKey(q.identifier));continue}if(!S(q,ie)){_.push(q.identifier),W.delete(M.ExtensionIdentifier.toKey(q.identifier));continue}}for(const q of t){const ie=W.get(M.ExtensionIdentifier.toKey(q.identifier));if(!ie){p.push(q);continue}if(!S(ie,q)){_.push(ie.identifier),W.delete(M.ExtensionIdentifier.toKey(ie.identifier));continue}}const z=d(this._myExtensions),$=d(c);for(const q of this._myExtensions)$.has(M.ExtensionIdentifier.toKey(q))||C.push(q);for(const q of c)z.has(M.ExtensionIdentifier.toKey(q))||U.push(q);const F={toRemove:_,toAdd:p,myToRemove:C,myToAdd:U};return this.delta(F),F}delta(t){const{toRemove:c,toAdd:_,myToRemove:p,myToAdd:C}=t,U=d(c),W=d(p);for(let L=0;L<this._allExtensions.length;L++)U.has(M.ExtensionIdentifier.toKey(this._allExtensions[L].identifier))&&(this._allExtensions.splice(L,1),L--);for(let L=0;L<this._myExtensions.length;L++)W.has(M.ExtensionIdentifier.toKey(this._myExtensions[L]))&&(this._myExtensions.splice(L,1),L--);for(const L of _)this._allExtensions.push(L);for(const L of C)this._myExtensions.push(L)}containsExtension(t){for(const c of this._myExtensions)if(M.ExtensionIdentifier.equals(c,t))return!0;return!1}}e.ExtensionHostExtensions=f;class h{constructor(t){if(this[P]="ExtensionIdentifierSet",this._map=new Map,this._toKey=M.ExtensionIdentifier.toKey,t)for(const c of t)this.add(c)}get size(){return this._map.size}add(t){return this._map.set(this._toKey(t),t),this}clear(){this._map.clear()}delete(t){return this._map.delete(this._toKey(t))}has(t){return this._map.has(this._toKey(t))}forEach(t,c){this._map.forEach(_=>t.call(c,_,_,this))}*entries(){for(const[t,c]of this._map)yield[c,c]}keys(){return this._map.values()}values(){return this._map.values()}[(P=Symbol.toStringTag,Symbol.iterator)](){return this._map.values()}}e.ExtensionIdentifierSet=h;function d(r){const t=new Set;for(const c of r)t.add(M.ExtensionIdentifier.toKey(c));return t}e.extensionIdentifiersArrayToSet=d;function o(r){const t=new Map;for(const c of r)t.set(M.ExtensionIdentifier.toKey(c.identifier),c);return t}function g(r,t){return r.enabledApiProposals?r.enabledApiProposals.includes(t):!1}e.isProposedApiEnabled=g;function R(r,t){if(!g(r,t))throw new Error(`Extension '${r.identifier.value}' CANNOT use API proposal: ${t}.
Its package.json#enabledApiProposals-property declares: ${r.enabledApiProposals?.join(", ")??"[]"} but NOT ${t}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${r.identifier.value}`)}e.checkProposedApiEnabled=R;class l{constructor(t,c,_,p){this.codeLoadingTime=t,this.activateCallTime=c,this.activateResolvedTime=_,this.activationReason=p}}e.ActivationTimes=l;class w{constructor(t,c){this.description=t,this.value=c}}e.ExtensionPointContribution=w,e.ExtensionHostLogFileName="exthost";var s;(function(r){r[r.Normal=0]="Normal",r[r.Immediate=1]="Immediate"})(s=e.ActivationKind||(e.ActivationKind={}));function u(r){return{type:r.isBuiltin?0:1,isBuiltin:r.isBuiltin||r.isUserBuiltin,identifier:{id:(0,D.getGalleryExtensionId)(r.publisher,r.name),uuid:r.uuid},manifest:r,location:r.extensionLocation,targetPlatform:r.targetPlatform,validations:[],isValid:!0}}e.toExtension=u;function n(r,t){return{identifier:new M.ExtensionIdentifier((0,D.getExtensionId)(r.manifest.publisher,r.manifest.name)),isBuiltin:r.type===0,isUserBuiltin:r.type===1&&r.isBuiltin,isUnderDevelopment:!!t,extensionLocation:r.location,...r.manifest,uuid:r.identifier.uuid,targetPlatform:r.targetPlatform,browserNlsBundleUris:r.browserNlsBundleUris}}e.toExtensionDescription=n;class i{constructor(){this.onDidRegisterExtensions=a.Event.None,this.onDidChangeExtensionsStatus=a.Event.None,this.onDidChangeExtensions=a.Event.None,this.onWillActivateByEvent=a.Event.None,this.onDidChangeResponsiveChange=a.Event.None}activateByEvent(t){return Promise.resolve(void 0)}activationEventIsDone(t){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(t){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(t,c){return Promise.resolve(0)}getInspectPorts(t,c){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(t){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(t,c){return Promise.resolve()}}e.NullExtensionService=i}),define(ye[181],De([1,0,11,27,24,15,14]),function(ne,e,a,v,b,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class P{constructor(d,o,g,R){this.startup=d,this.codeLoadingTime=o,this.activateCallTime=g,this.activateResolvedTime=R}}e.ExtensionActivationTimes=P,P.NONE=new P(!1,-1,-1,-1);class E{constructor(d){this._startup=d,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(d,o){return d===-1||o===-1?-1:o-d}build(){return new P(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=E;class T{constructor(d,o,g,R,l,w){this.activationFailed=d,this.activationFailedError=o,this.activationTimes=g,this.module=R,this.exports=l,this.subscriptions=w}}e.ActivatedExtension=T;class O extends T{constructor(d){super(!1,null,d,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=O;class y extends T{constructor(){super(!1,null,P.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=y;class m extends T{constructor(d){super(!0,d,P.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=m;let k=class{constructor(d,o,g,R,l){this._logService=l,this._registry=d,this._resolvedExtensionsSet=new Set,o.forEach(w=>this._resolvedExtensionsSet.add(v.ExtensionIdentifier.toKey(w))),this._externalExtensionsMap=new Map,g.forEach(w=>this._externalExtensionsMap.set(v.ExtensionIdentifier.toKey(w),w)),this._host=R,this._operations=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[d,o]of this._operations)o.dispose()}isActivated(d){const o=this._operations.get(v.ExtensionIdentifier.toKey(d));return Boolean(o&&o.value)}getActivatedExtension(d){const o=this._operations.get(v.ExtensionIdentifier.toKey(d));if(!o||!o.value)throw new Error(`Extension '${d.value}' is not known or not activated`);return o.value}async activateByEvent(d,o){if(this._alreadyActivatedEvents[d])return;const g=this._registry.getExtensionDescriptionsForActivationEvent(d);await this._activateExtensions(g.map(R=>({id:R.identifier,reason:{startup:o,extensionId:R.identifier,activationEvent:d}}))),this._alreadyActivatedEvents[d]=!0}activateById(d,o){const g=this._registry.getExtensionDescription(d);if(!g)throw new Error(`Extension '${d}' is not known`);return this._activateExtensions([{id:g.identifier,reason:o}])}async _activateExtensions(d){const o=d.filter(g=>!this.isActivated(g.id)).map(g=>this._handleActivationRequest(g));await Promise.all(o.map(g=>g.wait()))}_handleActivationRequest(d){if(this._operations.has(v.ExtensionIdentifier.toKey(d.id)))return this._operations.get(v.ExtensionIdentifier.toKey(d.id));if(this._externalExtensionsMap.has(v.ExtensionIdentifier.toKey(d.id)))return this._createAndSaveOperation(d,null,[],null);const o=this._registry.getExtensionDescription(d.id);if(!o){const l=new Error(`Cannot activate unknown extension '${d.id.value}'`),w=this._createAndSaveOperation(d,null,[],new m(l));return this._host.onExtensionActivationError(d.id,l,new b.MissingExtensionDependency(d.id.value)),w}const g=[],R=typeof o.extensionDependencies=="undefined"?[]:o.extensionDependencies;for(const l of R){if(this._resolvedExtensionsSet.has(v.ExtensionIdentifier.toKey(l)))continue;const w=this._operations.get(v.ExtensionIdentifier.toKey(l));if(w){g.push(w);continue}if(this._externalExtensionsMap.has(v.ExtensionIdentifier.toKey(l))){g.push(this._handleActivationRequest({id:this._externalExtensionsMap.get(v.ExtensionIdentifier.toKey(l)),reason:d.reason}));continue}const s=this._registry.getExtensionDescription(l);if(s){if(!s.main&&!s.browser)continue;g.push(this._handleActivationRequest({id:s.identifier,reason:d.reason}));continue}const u=o.displayName||o.identifier.value,n=new Error(`Cannot activate the '${u}' extension because it depends on unknown extension '${l}'`),i=this._createAndSaveOperation(d,o.displayName,[],new m(n));return this._host.onExtensionActivationError(o.identifier,n,new b.MissingExtensionDependency(l)),i}return this._createAndSaveOperation(d,o.displayName,g,null)}_createAndSaveOperation(d,o,g,R){const l=new f(d.id,o,d.reason,g,R,this._host,this._logService);return this._operations.set(v.ExtensionIdentifier.toKey(d.id),l),l}};k=ze([xe(4,M.ILogService)],k),e.ExtensionsActivator=k;let f=class{constructor(d,o,g,R,l,w,s){this._id=d,this._displayName=o,this._reason=g,this._deps=R,this._value=l,this._host=w,this._logService=s,this._barrier=new D.Barrier,this._isDisposed=!1,this._initialize()}get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let d=0;d<this._deps.length;d++){const o=this._deps[d];if(o.value&&!o.value.activationFailed){this._deps.splice(d,1),d--;continue}if(o.value&&o.value.activationFailed){const g=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${o.friendlyName}' failed to activate`);g.detail=o.value.activationFailedError,this._value=new m(g),this._host.onExtensionActivationError(this._id,g,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(d=>d.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(d){const o=new Error;if(d&&d.name&&(o.name=d.name),d&&d.message?o.message=`Activating extension '${this._id.value}' failed: ${d.message}.`:o.message=`Activating extension '${this._id.value}' failed: ${d}.`,d&&d.stack&&(o.stack=d.stack),this._value=new m(o),this._isDisposed&&a.isCancellationError(d))return;this._host.onExtensionActivationError(this._id,o,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(d)}}};f=ze([xe(6,M.ILogService)],f)}),define(ye[182],De([1,0,15,28,24]),function(ne,e,a,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let M=class extends a.LogService{constructor(P,E){super(P.createLogger(E.logFile,{name:b.ExtensionHostLogFileName}))}};M=ze([xe(0,a.ILoggerService),xe(1,v.IExtHostInitDataService)],M),e.ExtHostLogService=M}),define(ye[183],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",badges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.badges.d.ts",commentsResolvedState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsResolvedState.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorToolbar:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorToolbar.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewSize.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",contribWebviewContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribWebviewContext.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineCompletionsNew:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsNew.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookContentProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookContentProvider.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDebugOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDebugOptions.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookEditor.d.ts",notebookEditorEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookEditorEdit.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookWorkspaceEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookWorkspaceEdit.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",snippetWorkspaceEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.snippetWorkspaceEdit.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",telemetryLog:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetryLog.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(ye[184],De([1,0,142,11,29,79,82,30,27,183,150]),function(ne,e,a,v,b,M,D,P,E,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const y=P.Registry.as(D.Extensions.JSONContribution);class m{constructor(l,w,s){this._messageHandler=l,this._extension=w,this._extensionPointId=s}_msg(l,w){this._messageHandler({type:l,message:w,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(l){this._msg(b.default.Error,l)}warn(l){this._msg(b.default.Warning,l)}info(l){this._msg(b.default.Info,l)}}e.ExtensionMessageCollector=m;class k{constructor(l,w){this.added=l,this.removed=w}static _toSet(l){const w=new Set;for(let s=0,u=l.length;s<u;s++)w.add(E.ExtensionIdentifier.toKey(l[s].description.identifier));return w}static compute(l,w){if(!l||!l.length)return new k(w,[]);if(!w||!w.length)return new k([],l);const s=this._toSet(l),u=this._toSet(w),n=w.filter(r=>!s.has(E.ExtensionIdentifier.toKey(r.description.identifier))),i=l.filter(r=>!u.has(E.ExtensionIdentifier.toKey(r.description.identifier)));return new k(n,i)}}e.ExtensionPointUserDelta=k;class f{constructor(l,w){this.name=l,this.defaultExtensionKind=w,this._handler=null,this._users=null,this._delta=null}setHandler(l){if(this._handler!==null)throw new Error("Handler already set!");this._handler=l,this._handle()}acceptUsers(l){this._delta=k.compute(this._users,l),this._users=l,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(l){(0,v.onUnexpectedError)(l)}}}e.ExtensionPoint=f;const h={type:"string",enum:["ui","workspace"],enumDescriptions:[a.localize(0,null),a.localize(1,null)]},d="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:a.localize(2,null),properties:{vscode:{type:"string",description:a.localize(3,null),default:"^1.22.0"}}},publisher:{description:a.localize(4,null),type:"string"},displayName:{description:a.localize(5,null),type:"string"},categories:{description:a.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:E.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:a.localize(7,null)}]}},galleryBanner:{type:"object",description:a.localize(8,null),properties:{color:{description:a.localize(9,null),type:"string"},theme:{description:a.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:a.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:a.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:a.localize(13,null)},enabledApiProposals:{markdownDescription:a.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(T.allApiProposals),markdownEnumDescriptions:Object.values(T.allApiProposals)}},activationEvents:{description:a.localize(15,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:a.localize(16,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:a.localize(17,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:a.localize(18,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:a.localize(19,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:a.localize(20,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:a.localize(21,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:a.localize(22,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:a.localize(23,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:a.localize(24,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:a.localize(25,null),body:"onStartupFinished"},{label:"onTaskType",description:a.localize(26,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:a.localize(27,null),body:"onFileSystem:${1:scheme}"},{label:"onSearch",description:a.localize(28,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:a.localize(29,null)},{label:"onIdentity",body:"onIdentity:${8:identity}",description:a.localize(30,null)},{label:"onUri",body:"onUri",description:a.localize(31,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:a.localize(32,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:a.localize(33,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:a.localize(34,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:a.localize(35,null)},{label:"onRenderer",description:a.localize(36,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:a.localize(37,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:a.localize(38,null)},{label:"*",description:a.localize(39,null),body:"*"}]}},badges:{type:"array",description:a.localize(40,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:a.localize(41,null)},href:{type:"string",description:a.localize(42,null)},description:{type:"string",description:a.localize(43,null)}}}},markdown:{type:"string",description:a.localize(44,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:a.localize(45,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:a.localize(46,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:a.localize(47,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:a.localize(48,null),type:"array",items:h,default:["workspace"],defaultSnippets:[{body:["ui"],description:a.localize(49,null)},{body:["workspace"],description:a.localize(50,null)},{body:["ui","workspace"],description:a.localize(51,null)},{body:["workspace","ui"],description:a.localize(52,null)},{body:[],description:a.localize(53,null)}]},capabilities:{description:a.localize(54,null),type:"object",properties:{virtualWorkspaces:{description:a.localize(55,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:a.localize(56,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[a.localize(57,null),a.localize(58,null),a.localize(59,null)]},description:{type:"string",markdownDescription:a.localize(60,null)}}},untrustedWorkspaces:{description:a.localize(61,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:a.localize(62,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[a.localize(63,null),a.localize(64,null),a.localize(65,null)]},restrictedConfigurations:{description:a.localize(66,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:a.localize(67,null)}}}}},sponsor:{description:a.localize(68,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:a.localize(69,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:a.localize(70,null),type:"string"},"vscode:uninstall":{description:a.localize(71,null),type:"string"}}},icon:{type:"string",description:a.localize(72,null)}}};class o{constructor(){this._extensionPoints=new Map}registerExtensionPoint(l){if(this._extensionPoints.has(l.extensionPoint))throw new Error("Duplicate extension point: "+l.extensionPoint);const w=new f(l.extensionPoint,l.defaultExtensionKind);return this._extensionPoints.set(l.extensionPoint,w),e.schema.properties.contributes.properties[l.extensionPoint]=l.jsonSchema,y.registerSchema(d,e.schema),w}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=o;const g={ExtensionsRegistry:"ExtensionsRegistry"};P.Registry.add(g.ExtensionsRegistry,new o),e.ExtensionsRegistry=P.Registry.as(g.ExtensionsRegistry),y.registerSchema(d,e.schema),y.registerSchema(O.productSchemaId,{properties:{extensionEnabledApiProposals:{description:a.localize(73,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(T.allApiProposals),markdownEnumDescriptions:Object.values(T.allApiProposals)}}]}}}})}),define(ye[185],De([1,0,139,10,26,184,38,5]),function(ne,e,a,v,b,M,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=e.TaskDefinitionRegistryImpl=void 0;const E={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:a.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:a.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:a.localize(2,null),default:""}}};var T;(function(m){function k(f,h,d){if(!f)return;const o=v.isString(f.type)?f.type:void 0;if(!o||o.length===0){d.error(a.localize(3,null));return}const g=[];if(Array.isArray(f.required))for(const R of f.required)v.isString(R)&&g.push(R);return{extensionId:h.value,taskType:o,required:g,properties:f.properties?b.deepClone(f.properties):{},when:f.when?D.ContextKeyExpr.deserialize(f.when):void 0}}m.from=k})(T||(T={}));const O=M.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",jsonSchema:{description:a.localize(4,null),type:"array",items:E}});class y{constructor(){this._onDefinitionsChanged=new P.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((k,f)=>{O.setHandler((h,d)=>{this._schema=void 0;try{for(const o of d.removed){const g=o.value;for(const R of g)this.taskTypes&&R.type&&this.taskTypes[R.type]&&delete this.taskTypes[R.type]}for(const o of d.added){const g=o.value;for(const R of g){const l=T.from(R,o.description.identifier,o.collector);l&&(this.taskTypes[l.taskType]=l)}}(d.removed.length>0||d.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}k(void 0)})})}onReady(){return this.readyPromise}get(k){return this.taskTypes[k]}all(){return Object.keys(this.taskTypes).map(k=>this.taskTypes[k])}getJsonSchema(){if(this._schema===void 0){const k=[];for(const f of this.all()){const h={type:"object",additionalProperties:!1};f.required.length>0&&(h.required=f.required.slice(0)),f.properties!==void 0?h.properties=b.deepClone(f.properties):h.properties=Object.create(null),h.properties.type={type:"string",enum:[f.taskType]},k.push(h)}this._schema={oneOf:k}}return this._schema}}e.TaskDefinitionRegistryImpl=y,e.TaskDefinitionRegistry=new y}),define(ye[186],De([1,0,140,10,22,26,38,185]),function(ne,e,a,v,b,M,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new D.RawContextKey("taskRunning",!1,a.localize(0,null)),e.TASKS_CATEGORY={value:a.localize(1,null),original:"Tasks"};var E;(function(F){F[F.Escape=1]="Escape",F[F.Strong=2]="Strong",F[F.Weak=3]="Weak"})(E=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(F){function q(ie){if(!ie)return F.Strong;switch(ie.toLowerCase()){case"escape":return F.Escape;case"strong":return F.Strong;case"weak":return F.Weak;default:return F.Strong}}F.from=q}(E=e.ShellQuoting||(e.ShellQuoting={}));var T;(function(F){F.defaults={cwd:"${workspaceFolder}"}})(T=e.CommandOptions||(e.CommandOptions={}));var O;(function(F){F[F.Always=1]="Always",F[F.Silent=2]="Silent",F[F.Never=3]="Never"})(O=e.RevealKind||(e.RevealKind={})),function(F){function q(ie){switch(ie.toLowerCase()){case"always":return F.Always;case"silent":return F.Silent;case"never":return F.Never;default:return F.Always}}F.fromString=q}(O=e.RevealKind||(e.RevealKind={}));var y;(function(F){F[F.Never=1]="Never",F[F.OnProblem=2]="OnProblem",F[F.Always=3]="Always"})(y=e.RevealProblemKind||(e.RevealProblemKind={})),function(F){function q(ie){switch(ie.toLowerCase()){case"always":return F.Always;case"never":return F.Never;case"onproblem":return F.OnProblem;default:return F.OnProblem}}F.fromString=q}(y=e.RevealProblemKind||(e.RevealProblemKind={}));var m;(function(F){F[F.Shared=1]="Shared",F[F.Dedicated=2]="Dedicated",F[F.New=3]="New"})(m=e.PanelKind||(e.PanelKind={})),function(F){function q(ie){switch(ie.toLowerCase()){case"shared":return F.Shared;case"dedicated":return F.Dedicated;case"new":return F.New;default:return F.Shared}}F.fromString=q}(m=e.PanelKind||(e.PanelKind={}));var k;(function(F){F.defaults={echo:!0,reveal:O.Always,revealProblems:y.Never,focus:!1,panel:m.Shared,showReuseMessage:!0,clear:!1}})(k=e.PresentationOptions||(e.PresentationOptions={}));var f;(function(F){F[F.Shell=1]="Shell",F[F.Process=2]="Process",F[F.CustomExecution=3]="CustomExecution"})(f=e.RuntimeType||(e.RuntimeType={})),function(F){function q(A){switch(A.toLowerCase()){case"shell":return F.Shell;case"process":return F.Process;case"customExecution":return F.CustomExecution;default:return F.Process}}F.fromString=q;function ie(A){switch(A){case F.Shell:return"shell";case F.Process:return"process";case F.CustomExecution:return"customExecution";default:return"process"}}F.toString=ie}(f=e.RuntimeType||(e.RuntimeType={}));var h;(function(F){function q(ie){return v.isString(ie)?ie:ie.value}F.value=q})(h=e.CommandString||(e.CommandString={}));var d;(function(F){F.Clean={_id:"clean",isDefault:!1},F.Build={_id:"build",isDefault:!1},F.Rebuild={_id:"rebuild",isDefault:!1},F.Test={_id:"test",isDefault:!1};function q(A){return A===F.Clean._id||A===F.Build._id||A===F.Rebuild._id||A===F.Test._id}F.is=q;function ie(A){if(A!==void 0)return v.isString(A)?q(A)?{_id:A,isDefault:!1}:void 0:A}F.from=ie})(d=e.TaskGroup||(e.TaskGroup={}));var o;(function(F){F[F.Global=1]="Global",F[F.Workspace=2]="Workspace",F[F.Folder=3]="Folder"})(o=e.TaskScope||(e.TaskScope={}));var g;(function(F){F.Workspace="workspace",F.Extension="extension",F.InMemory="inMemory",F.WorkspaceFile="workspaceFile",F.User="user";function q(ie){switch(ie){case F.User:return 2;case F.WorkspaceFile:return 5;default:return 6}}F.toConfigurationTarget=q})(g=e.TaskSourceKind||(e.TaskSourceKind={}));var R;(function(F){F.parallel="parallel",F.sequence="sequence"})(R=e.DependsOrder||(e.DependsOrder={}));var l;(function(F){F[F.default=1]="default",F[F.folderOpen=2]="folderOpen"})(l=e.RunOnOptions||(e.RunOnOptions={}));var w;(function(F){F.defaults={reevaluateOnRerun:!0,runOn:l.default,instanceLimit:1}})(w=e.RunOptions||(e.RunOptions={}));class s{constructor(q,ie,A,Z,le,oe){this._label="",this._id=q,ie&&(this._label=ie),A&&(this.type=A),this.runOptions=Z,this.configurationProperties=le,this._source=oe}getDefinition(q){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const q={folder:this.getFolderId(),id:this._id};return JSON.stringify(q)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(q,ie=!1){if(q===void 0)return!1;if(v.isString(q))return q===this._label||q===this.configurationProperties.identifier||ie&&q===this._id;const A=this.getDefinition(!0);return A!==void 0&&A._key===q._key}getQualifiedLabel(){const q=this.getWorkspaceFolder();return q?`${this._label} (${q.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(q){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),q&&(this._taskLoadMessages=this._taskLoadMessages.concat(q))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=s;class u extends s{constructor(q,ie,A,Z,le,oe,ue,te){super(q,A,void 0,ue,te,ie);this.command={},this._source=ie,this.hasDefinedMatchers=oe,le&&(this.command=le)}clone(){return new u(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(q=!1){if(q&&this._source.customizes!==void 0)return this._source.customizes;{let ie;switch(this.command?this.command.runtime:void 0){case f.Shell:ie="shell";break;case f.Process:ie="process";break;case f.CustomExecution:ie="customExecution";break;case void 0:ie="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:ie,_key:this._id,id:this._id}}}static is(q){return q instanceof u}getMapKey(){const q=this._source.config.workspaceFolder;return q?`${q.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===g.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const q=this.getFolderId();if(!q)return;let ie=this.configurationProperties.identifier;this._source.kind!==g.Workspace&&(ie+=this._source.kind);const A={type:e.CUSTOMIZED_TASK_TYPE,folder:q,id:ie};return JSON.stringify(A)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?b.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(q){return new u(q._id,q._source,q._label,q.type,q.command,q.hasDefinedMatchers,q.runOptions,q.configurationProperties)}}e.CustomTask=u;class n extends s{constructor(q,ie,A,Z,le,oe,ue){super(q,A,Z,oe,ue,ie);this._source=ie,this.configures=le}static is(q){return q instanceof n}fromObject(q){return q}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?b.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===g.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const q=this.getFolderId();if(!q)return;let ie=this.configurationProperties.identifier;this._source.kind!==g.Workspace&&(ie+=this._source.kind);const A={type:e.CUSTOMIZED_TASK_TYPE,folder:q,id:ie};return JSON.stringify(A)}}e.ConfiguringTask=n;class i extends s{constructor(q,ie,A,Z,le,oe,ue,te,Ee){super(q,A,Z,te,Ee,ie);this.defines=le,this.hasDefinedMatchers=ue,this.command=oe,this.icon=Ee.icon,this.hide=Ee.hide}clone(){return new i(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(q){return q instanceof i}getMapKey(){const q=this._source.workspaceFolder;return q?`${this._source.scope.toString()}|${q.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const q={type:"contributed",scope:this._source.scope,id:this._id};return q.folder=this.getFolderId(),JSON.stringify(q)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(q){return new i(q._id,q._source,q._label,q.type,q.defines,q.command,q.hasDefinedMatchers,q.runOptions,q.configurationProperties)}}e.ContributedTask=i;class r extends s{constructor(q,ie,A,Z,le,oe){super(q,A,Z,le,oe,ie);this._source=ie}clone(){return new r(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(q){return q instanceof r}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(q){return new r(q._id,q._source,q._label,q.type,q.runOptions,q.configurationProperties)}}e.InMemoryTask=r;var t;(function(F){F[F.Process=1]="Process",F[F.Terminal=2]="Terminal"})(t=e.ExecutionEngine||(e.ExecutionEngine={})),function(F){F._default=F.Terminal}(t=e.ExecutionEngine||(e.ExecutionEngine={}));var c;(function(F){F[F.V0_1_0=1]="V0_1_0",F[F.V2_0_0=2]="V2_0_0"})(c=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class _{constructor(q){this._order=new Map;for(let ie=0;ie<q.length;ie++)this._order.set(q[ie].uri.toString(),ie)}compare(q,ie){const A=q.getWorkspaceFolder(),Z=ie.getWorkspaceFolder();if(A&&Z){let le=this._order.get(A.uri.toString());le=le===void 0?0:le+1;let oe=this._order.get(Z.uri.toString());return oe=oe===void 0?0:oe+1,le===oe?q._label.localeCompare(ie._label):le-oe}else return!A&&Z?-1:A&&!Z?1:0}}e.TaskSorter=_;var p;(function(F){F.DependsOnStarted="dependsOnStarted",F.AcquiredInput="acquiredInput",F.Start="start",F.ProcessStarted="processStarted",F.Active="active",F.Inactive="inactive",F.Changed="changed",F.Terminated="terminated",F.ProcessEnded="processEnded",F.End="end"})(p=e.TaskEventKind||(e.TaskEventKind={}));var C;(function(F){F.SingleRun="singleRun",F.Background="background"})(C=e.TaskRunType||(e.TaskRunType={}));var U;(function(F){F[F.System=0]="System",F[F.User=1]="User",F[F.FolderOpen=2]="FolderOpen",F[F.ConfigurationChange=3]="ConfigurationChange",F[F.Reconnect=4]="Reconnect"})(U=e.TaskRunSource||(e.TaskRunSource={}));var W;(function(F){function q(ie,A,Z,le,oe){if(A){const ue={kind:ie,taskId:A._id,taskName:A.configurationProperties.name,runType:A.configurationProperties.isBackground?"background":"singleRun",group:A.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:void 0,__task:A};return ie==="start"?(ue.terminalId=Z,ue.resolvedVariables=le):ie==="processStarted"?ue.processId=Z:ie==="processEnded"&&(ue.exitCode=Z),Object.freeze(ue)}else return Object.freeze({kind:"changed"})}F.create=q})(W=e.TaskEvent||(e.TaskEvent={}));var L;(function(F){function q(A){const Z=Object.keys(A).sort();let le="";for(const oe of Z){let ue=A[oe];ue instanceof Object?ue=q(ue):typeof ue=="string"&&(ue=ue.replace(/,/g,",,")),le+=oe+","+ue+","}return le}function ie(A){const le={_key:q(A),type:A.taskType};return Object.assign(le,A),le}F.create=ie})(L=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var S;(function(F){F.AutoDetect="task.autoDetect",F.SaveBeforeRun="task.saveBeforeRun",F.ShowDecorations="task.showDecorations",F.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",F.SlowProviderWarning="task.slowProviderWarning",F.QuickOpenHistory="task.quickOpen.history",F.QuickOpenDetail="task.quickOpen.detail",F.QuickOpenSkip="task.quickOpen.skip",F.QuickOpenShowAll="task.quickOpen.showAll",F.AllowAutomaticTasks="task.allowAutomaticTasks",F.Reconnection="task.experimental.reconnection"})(S=e.TaskSettingId||(e.TaskSettingId={}));var z;(function(F){F.Tasks="tasks",F.SuppressTaskName="tasks.suppressTaskName",F.Windows="tasks.windows",F.Osx="tasks.osx",F.Linux="tasks.linux",F.ShowOutput="tasks.showOutput",F.IsShellCommand="tasks.isShellCommand",F.ServiceTestSetting="tasks.service.testSetting"})(z=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var $;(function(F){function q(ie,A){const Z=P.TaskDefinitionRegistry.get(ie.type);if(Z===void 0){const te=M.deepClone(ie);return delete te._key,L.create(te)}const le=Object.create(null);le.type=Z.taskType;const oe=new Set;Z.required.forEach(te=>oe.add(te));const ue=Z.properties;for(const te of Object.keys(ue)){const Ee=ie[te];if(Ee!=null)le[te]=Ee;else if(oe.has(te)){const be=ue[te];if(be.default!==void 0)le[te]=M.deepClone(be.default);else switch(be.type){case"boolean":le[te]=!1;break;case"number":case"integer":le[te]=0;break;case"string":le[te]="";break;default:A.error(a.localize(2,null,JSON.stringify(ie,void 0,0),te));return}}}return L.create(le)}F.createTaskIdentifier=q})($=e.TaskDefinition||(e.TaskDefinition={}))}),define(ye[187],De([1,0,11]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class v{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((D,P)=>{this._actualOk=D,this._actualErr=P,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(D){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=D,this._actual&&this._actualOk(D))}resolveErr(D){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=D,this._actual?this._actualErr(D):(0,a.onUnexpectedError)(D))}then(D,P){return this._ensureActual().then(D,P)}catch(D){return this._ensureActual().then(void 0,D)}finally(D){return this._ensureActual().finally(D)}}e.LazyPromise=v;class b extends v{constructor(){super();this._hasErr=!0,this._err=new a.CancellationError}}e.CanceledLazyPromise=b}),define(ye[40],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class a{constructor(E){this._proxyIdentifierBrand=void 0,this.sid=E,this.nid=++a.count}}e.ProxyIdentifier=a,a.count=0;const v=[];function b(P){const E=new a(P);return v[E.nid]=E,E}e.createProxyIdentifier=b;function M(P){return v[P].sid}e.getStringIdentifierForProxy=M;class D{constructor(E){this.value=E}}e.SerializableObjectWithBuffers=D}),define(ye[4],De([1,0,55,40]),function(ne,e,a,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var b;(function(o){o[o.Default=0]="Default",o[o.InCenter=1]="InCenter",o[o.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",o[o.AtTop=3]="AtTop"})(b=e.TextEditorRevealType||(e.TextEditorRevealType={}));var M;(function(o){o[o.UnknownInput=0]="UnknownInput",o[o.TextInput=1]="TextInput",o[o.TextDiffInput=2]="TextDiffInput",o[o.TextMergeInput=3]="TextMergeInput",o[o.NotebookInput=4]="NotebookInput",o[o.NotebookDiffInput=5]="NotebookDiffInput",o[o.CustomEditorInput=6]="CustomEditorInput",o[o.WebviewEditorInput=7]="WebviewEditorInput",o[o.TerminalEditorInput=8]="TerminalEditorInput",o[o.InteractiveEditorInput=9]="InteractiveEditorInput"})(M=e.TabInputKind||(e.TabInputKind={}));var D;(function(o){o[o.TAB_OPEN=0]="TAB_OPEN",o[o.TAB_CLOSE=1]="TAB_CLOSE",o[o.TAB_UPDATE=2]="TAB_UPDATE",o[o.TAB_MOVE=3]="TAB_MOVE"})(D=e.TabModelOperationKind||(e.TabModelOperationKind={}));var P;(function(o){o[o.Editable=0]="Editable",o[o.SupportsHotExit=1]="SupportsHotExit"})(P=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var E;(function(o){o[o.Int8Array=1]="Int8Array",o[o.Uint8Array=2]="Uint8Array",o[o.Uint8ClampedArray=3]="Uint8ClampedArray",o[o.Int16Array=4]="Int16Array",o[o.Uint16Array=5]="Uint16Array",o[o.Int32Array=6]="Int32Array",o[o.Uint32Array=7]="Uint32Array",o[o.Float32Array=8]="Float32Array",o[o.Float64Array=9]="Float64Array",o[o.BigInt64Array=10]="BigInt64Array",o[o.BigUint64Array=11]="BigUint64Array"})(E=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var T;(function(o){o[o.Text=1]="Text",o[o.Error=2]="Error",o[o.Rich=3]="Rich"})(T=e.CellOutputKind||(e.CellOutputKind={}));var O;(function(o){o[o.Default=0]="Default",o[o.InCenter=1]="InCenter",o[o.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",o[o.AtTop=3]="AtTop"})(O=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var y;(function(o){o[o.None=0]="None",o[o.Process=1]="Process",o[o.Output=2]="Output"})(y=e.CandidatePortSource||(e.CandidatePortSource={}));class m{static mixin(g){return g._id=m._n++,g}}e.IdObject=m,m._n=0;var k;(function(o){o.label="a",o.kind="b",o.detail="c",o.documentation="d",o.sortText="e",o.filterText="f",o.preselect="g",o.insertText="h",o.insertTextRules="i",o.range="j",o.commitCharacters="k",o.additionalTextEdits="l",o.command="m",o.kindModifier="n"})(k=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var f;(function(o){o.defaultRanges="a",o.completions="b",o.isIncomplete="c",o.duration="d"})(f=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));function h(o){return o&&o.edits&&(0,a.revive)(o),o}e.reviveWorkspaceEditDto=h;var d;(function(o){o[o.Workspace=0]="Workspace",o[o.TextDocument=1]="TextDocument"})(d=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,v.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,v.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,v.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,v.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,v.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,v.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,v.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,v.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,v.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,v.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,v.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,v.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,v.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,v.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,v.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,v.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,v.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,v.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,v.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,v.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,v.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,v.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,v.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,v.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,v.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,v.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,v.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,v.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,v.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,v.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,v.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,v.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,v.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,v.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,v.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,v.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,v.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,v.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,v.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,v.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,v.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,v.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,v.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,v.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,v.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,v.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,v.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,v.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,v.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,v.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,v.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,v.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,v.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,v.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,v.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,v.createProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,v.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,v.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,v.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,v.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,v.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,v.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,v.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,v.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,v.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,v.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,v.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,v.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,v.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,v.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,v.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,v.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,v.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,v.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,v.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,v.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,v.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,v.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,v.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,v.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,v.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,v.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,v.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,v.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,v.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,v.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,v.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,v.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,v.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,v.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,v.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,v.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,v.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,v.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,v.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,v.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,v.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,v.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,v.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,v.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,v.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,v.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,v.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,v.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,v.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,v.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,v.createProxyIdentifier)("ExtHostTelemetry")}}),define(ye[67],De([1,0,4,5,3]),function(ne,e,a,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class M{constructor(P){this._onDidChangePassword=new v.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=P.getProxy(a.MainContext.MainThreadSecretState)}async $onDidChangePassword(P){this._onDidChangePassword.fire(P)}get(P,E){return this._proxy.$getPassword(P,E)}store(P,E,T){return this._proxy.$setPassword(P,E,T)}delete(P,E){return this._proxy.$deletePassword(P,E)}}e.ExtHostSecretState=M,e.IExtHostSecretState=(0,b.createDecorator)("IExtHostSecretState")}),define(ye[68],De([1,0,3,15,4,13]),function(ne,e,a,v,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,a.createDecorator)("IExtHostApiDeprecationService");let D=class{constructor(E,T){this._extHostLogService=T,this._reportedUsages=new Set,this._telemetryShape=E.getProxy(b.MainContext.MainThreadTelemetry)}report(E,T,O){const y=this.getUsageKey(E,T);this._reportedUsages.has(y)||(this._reportedUsages.add(y),T.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${E}' is deprecated. ${O}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:T.identifier.value,apiId:E}))}getUsageKey(E,T){return`${E}-${T.identifier.value}`}};D=ze([xe(0,M.IExtHostRpcService),xe(1,v.ILogService)],D),e.ExtHostApiDeprecationService=D,e.NullApiDeprecationService=Object.freeze(new class{report(P,E,T){}})}),define(ye[188],De([1,0,5,4,6,27]),function(ne,e,a,v,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class D{constructor(E){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new a.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=E.getProxy(v.MainContext.MainThreadAuthentication)}$setProviders(E){return this._providers=E,Promise.resolve()}async getSession(E,T,O,y={}){const m=M.ExtensionIdentifier.toKey(E.identifier),k=this._inFlightRequests.get(m)||[],f=[...O].sort().join(" ");let h=k.find(d=>d.providerId===T&&d.scopes===f);if(h)return h.result;{const d=this._getSession(E,m,T,O,y);h={providerId:T,scopes:f,result:d},k.push(h),this._inFlightRequests.set(m,k);try{await d}finally{const o=k.findIndex(g=>g.providerId===T&&g.scopes===f);o>-1&&(k.splice(o),this._inFlightRequests.set(m,k))}return d}}async _getSession(E,T,O,y,m={}){await this._proxy.$ensureProvider(O);const k=E.displayName||E.name;return this._proxy.$getSession(O,y,T,k,m)}async removeSession(E,T){const O=this._authenticationProviders.get(E);return O?O.provider.removeSession(T):this._proxy.$removeSession(E,T)}registerAuthenticationProvider(E,T,O,y){if(this._authenticationProviders.get(E))throw new Error(`An authentication provider with id '${E}' is already registered.`);this._authenticationProviders.set(E,{label:T,provider:O,options:y??{supportsMultipleAccounts:!1}}),this._providers.find(k=>k.id===E)||this._providers.push({id:E,label:T});const m=O.onDidChangeSessions(k=>{this._proxy.$sendDidChangeSessions(E,{added:k.added??[],changed:k.changed??[],removed:k.removed??[]})});return this._proxy.$registerAuthenticationProvider(E,T,y?.supportsMultipleAccounts??!1),new b.Disposable(()=>{m.dispose(),this._authenticationProviders.delete(E);const k=this._providers.findIndex(f=>f.id===E);k>-1&&this._providers.splice(k),this._proxy.$unregisterAuthenticationProvider(E)})}$createSession(E,T){const O=this._authenticationProviders.get(E);if(O)return Promise.resolve(O.provider.createSession(T));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$removeSession(E,T){const O=this._authenticationProviders.get(E);if(O)return Promise.resolve(O.provider.removeSession(T));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$getSessions(E,T){const O=this._authenticationProviders.get(E);if(O)return Promise.resolve(O.provider.getSessions(T));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$onDidChangeAuthenticationSessions(E,T){return this._onDidChangeSessions.fire({provider:{id:E,label:T}}),Promise.resolve()}}e.ExtHostAuthentication=D}),define(ye[189],De([1,0,4,13,8,24]),function(ne,e,a,v,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let D=class{constructor(E,T){this._proxy=E.getProxy(a.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:O=>T.getDocument(O)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(E,T){const O=(0,M.isProposedApiEnabled)(T,"snippetWorkspaceEdit"),y=b.WorkspaceEdit.from(E,this._versionInformationProvider,O);return this._proxy.$tryApplyWorkspaceEdit(y)}};D=ze([xe(0,v.IExtHostRpcService)],D),e.ExtHostBulkEdits=D}),define(ye[190],De([1,0,4]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class v{constructor(M){const D=M.getProxy(a.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return D.$readText()},writeText(P){return D.$writeText(P)}})}}e.ExtHostClipboard=v});var Ye=this&&this.__classPrivateFieldSet||function(ne,e,a,v,b){if(v==="m")throw new TypeError("Private method is not writable");if(v==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return v==="a"?b.call(ne,a):b?b.value=a:e.set(ne,a),a},Oe=this&&this.__classPrivateFieldGet||function(ne,e,a,v){if(a==="a"&&!v)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!v:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?v:a==="a"?v.call(ne):v?v.value:e.get(ne)};define(ye[36],De([1,0,10,6,8,26,4,16,15,55,48,243,2,7,3,13,92,23,40,43]),function(ne,e,a,v,b,M,D,P,E,T,O,y,m,k,f,h,d,o,g,R){"use strict";var l,w;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let s=class{constructor(c,_){l.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,w.set(this,void 0),Ye(this,l,c.getProxy(D.MainContext.MainThreadCommands),"f"),this._logService=_,Ye(this,w,c.getProxy(D.MainContext.MainThreadTelemetry),"f"),this.converter=new u(this,p=>{const C=this._apiCommands.get(p);return C?.result===i.Void?C:void 0},_),this._argumentProcessors=[{processArgument(p){return(0,T.revive)(p)}},{processArgument(p){return(0,M.cloneAndChange)(p,function(C){if(O.Range.isIRange(C))return b.Range.to(C);if(y.Position.isIPosition(C))return b.Position.to(C);if(O.Range.isIRange(C.range)&&m.URI.isUri(C.uri))return b.location.to(C);if(C instanceof o.VSBuffer)return C.buffer.buffer;if(!Array.isArray(C))return C})}}]}registerArgumentProcessor(c){this._argumentProcessors.push(c)}registerApiCommand(c){const _=this.registerCommand(!1,c.id,async(...p)=>{const C=c.args.map((W,L)=>{if(!W.validate(p[L]))throw new Error(`Invalid argument '${W.name}' when running '${c.id}', received: ${p[L]}`);return W.convert(p[L])}),U=await this.executeCommand(c.internalId,...C);return c.result.convert(U,p,this.converter)},void 0,{description:c.description,args:c.args,returns:c.result.description});return this._apiCommands.set(c.id,c),new v.Disposable(()=>{_.dispose(),this._apiCommands.delete(c.id)})}registerCommand(c,_,p,C,U,W){if(this._logService.trace("ExtHostCommands#registerCommand",_),!_.trim().length)throw new Error("invalid id");if(this._commands.has(_))throw new Error(`command '${_}' already exists`);return this._commands.set(_,{callback:p,thisArg:C,description:U,extension:W}),c&&Oe(this,l,"f").$registerCommand(_),new v.Disposable(()=>{this._commands.delete(_)&&c&&Oe(this,l,"f").$unregisterCommand(_)})}executeCommand(c,..._){return this._logService.trace("ExtHostCommands#executeCommand",c),this._doExecuteCommand(c,_,!0)}async _doExecuteCommand(c,_,p){if(this._commands.has(c))return Oe(this,l,"f").$fireCommandActivationEvent(c),this._executeContributedCommand(c,_,!1);{let C=!1;const U=(0,M.cloneAndChange)(_,function(W){if(W instanceof v.Position)return b.Position.from(W);if(W instanceof v.Range)return b.Range.from(W);if(W instanceof v.Location)return b.location.from(W);if(v.NotebookRange.isNotebookRange(W))return b.NotebookRange.from(W);if(W instanceof ArrayBuffer)return C=!0,o.VSBuffer.wrap(new Uint8Array(W));if(W instanceof Uint8Array)return C=!0,o.VSBuffer.wrap(W);if(W instanceof o.VSBuffer)return C=!0,W;if(!Array.isArray(W))return W});try{const W=await Oe(this,l,"f").$executeCommand(c,C?new g.SerializableObjectWithBuffers(U):U,p);return(0,T.revive)(W)}catch(W){if(W instanceof Error&&W.message==="$executeCommand:retry")return this._doExecuteCommand(c,_,!1);throw W}}}async _executeContributedCommand(c,_,p){const C=this._commands.get(c);if(!C)throw new Error("Unknown command");this._reportTelemetry(C,c);const{callback:U,thisArg:W,description:L}=C;if(L)for(let S=0;S<L.args.length;S++)try{(0,a.validateConstraint)(_[S],L.args[S].constraint)}catch{throw new Error(`Running the contributed command: '${c}' failed. Illegal argument '${L.args[S].name}' - ${L.args[S].description}`)}try{return await U.apply(W,_)}catch(S){if(c===this.converter.delegatingCommandId){const z=this.converter.getActualCommand(..._);z&&(c=z.command)}throw this._logService.error(S,c,C.extension?.identifier),p?new class extends Error{constructor(){super((0,R.toErrorMessage)(S));this.id=c,this.source=C.extension?.displayName??C.extension?.name}}:S}}_reportTelemetry(c,_){!c.extension||c.extension.isBuiltin||Oe(this,w,"f").$publicLog2("Extension:ActionExecuted",{extensionId:c.extension.identifier.value,id:_})}$executeContributedCommand(c,..._){return this._logService.trace("ExtHostCommands#$executeContributedCommand",c),this._commands.has(c)?(_=_.map(p=>this._argumentProcessors.reduce((C,U)=>U.processArgument(C),p)),this._executeContributedCommand(c,_,!0)):Promise.reject(new Error(`Contributed command '${c}' does not exist.`))}getCommands(c=!1){return this._logService.trace("ExtHostCommands#getCommands",c),Oe(this,l,"f").$getCommands().then(_=>(c&&(_=_.filter(p=>p[0]!=="_")),_))}$getContributedCommandHandlerDescriptions(){const c=Object.create(null);for(const[_,p]of this._commands){const{description:C}=p;C&&(c[_]=C)}return Promise.resolve(c)}};l=new WeakMap,w=new WeakMap,s=ze([xe(0,h.IExtHostRpcService),xe(1,E.ILogService)],s),e.ExtHostCommands=s,e.IExtHostCommands=(0,f.createDecorator)("IExtHostCommands");class u{constructor(c,_,p){this._commands=c,this._lookupApiCommand=_,this._logService=p,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(c,_){if(!c)return;const p={$ident:void 0,id:c.command,title:c.title,tooltip:c.tooltip};if(!c.command)return p;const C=this._lookupApiCommand(c.command);if(C)p.id=C.internalId,p.arguments=C.args.map((U,W)=>U.convert(c.arguments&&c.arguments[W]));else if((0,P.isNonEmptyArray)(c.arguments)){const U=++this._cachIdPool;this._cache.set(U,c),_.add((0,k.toDisposable)(()=>{this._cache.delete(U),this._logService.trace("CommandsConverter#DISPOSE",U)})),p.$ident=U,p.id=this.delegatingCommandId,p.arguments=[U],this._logService.trace("CommandsConverter#CREATE",c.command,U)}return p}fromInternal(c){return typeof c.$ident=="number"?this._cache.get(c.$ident):{command:c.id,title:c.title,arguments:c.arguments}}getActualCommand(...c){return this._cache.get(c[0])}_executeConvertedCommand(...c){const _=this.getActualCommand(...c);return this._logService.trace("CommandsConverter#EXECUTE",c[0],_?_.command:"MISSING"),_?this._commands.executeCommand(_.command,..._.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=u;class n{constructor(c,_,p,C){this.name=c,this.description=_,this.validate=p,this.convert=C}optional(){return new n(this.name,`(optional) ${this.description}`,c=>c==null||this.validate(c),c=>c===void 0?void 0:c===null?null:this.convert(c))}with(c,_){return new n(c??this.name,_??this.description,this.validate,this.convert)}}e.ApiCommandArgument=n,n.Uri=new n("uri","Uri of a text document",t=>m.URI.isUri(t),t=>t),n.Position=new n("position","A position in a text document",t=>v.Position.isPosition(t),b.Position.from),n.Range=new n("range","A range in a text document",t=>v.Range.isRange(t),b.Range.from),n.Selection=new n("selection","A selection in a text document",t=>v.Selection.isSelection(t),b.Selection.from),n.Number=new n("number","",t=>typeof t=="number",t=>t),n.String=new n("string","",t=>typeof t=="string",t=>t),n.CallHierarchyItem=new n("item","A call hierarchy item",t=>t instanceof v.CallHierarchyItem,b.CallHierarchyItem.from),n.TypeHierarchyItem=new n("item","A type hierarchy item",t=>t instanceof v.TypeHierarchyItem,b.TypeHierarchyItem.from),n.TestItem=new n("testItem","A VS Code TestItem",t=>t instanceof d.TestItemImpl,b.TestItem.from);class i{constructor(c,_){this.description=c,this.convert=_}}e.ApiCommandResult=i,i.Void=new i("no result",t=>t);class r{constructor(c,_,p,C,U){this.id=c,this.internalId=_,this.description=p,this.args=C,this.result=U}}e.ApiCommand=r}),define(ye[191],De([1,0,2,8,6,66,36,16,77,81,12]),function(ne,e,a,v,b,M,D,P,E,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const y=[new D.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",k(v.DocumentHighlight.to))),new D.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(h,d)=>{if((0,P.isFalsyOrEmpty)(h))return;class o extends b.SymbolInformation{static to(R){const l=new o(R.name,v.SymbolKind.to(R.kind),R.containerName||"",new b.Location(d[0],v.Range.to(R.range)));return l.detail=R.detail,l.range=l.location.range,l.selectionRange=v.Range.to(R.selectionRange),l.children=R.children?R.children.map(o.to):[],l}}return h.map(o.to)})),new D.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("options","Formatting options",h=>!0,h=>h)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",k(v.TextEdit.to))),new D.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range,new D.ApiCommandArgument("options","Formatting options",h=>!0,h=>h)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",k(v.TextEdit.to))),new D.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,new D.ApiCommandArgument("ch","Trigger character",h=>typeof h=="string",h=>h),new D.ApiCommandArgument("options","Formatting options",h=>!0,h=>h)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",k(v.TextEdit.to))),new D.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new D.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new D.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new D.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new D.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location-instances.",k(v.location.to))),new D.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Hover-instances.",k(v.Hover.to))),new D.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("position","A position in a text document",h=>Array.isArray(h)&&h.every(d=>b.Position.isPosition(d)),h=>h.map(v.Position.from))],new D.ApiCommandResult("A promise that resolves to an array of ranges.",h=>h.map(d=>{let o;for(const g of d.reverse())o=new b.SelectionRange(v.Range.to(g),o);return o}))),new D.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[D.ApiCommandArgument.String.with("query","Search string")],new D.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",h=>h.map(v.WorkspaceSymbol.to))),new D.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A CallHierarchyItem or undefined",h=>h.map(v.CallHierarchyItem.to))),new D.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[D.ApiCommandArgument.CallHierarchyItem],new D.ApiCommandResult("A CallHierarchyItem or undefined",h=>h.map(v.CallHierarchyIncomingCall.to))),new D.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[D.ApiCommandArgument.CallHierarchyItem],new D.ApiCommandResult("A CallHierarchyItem or undefined",h=>h.map(v.CallHierarchyOutgoingCall.to))),new D.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to a range and placeholder text.",h=>{if(!!h)return{range:v.Range.to(h.range),placeholder:h.text}})),new D.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("newName","The new symbol name")],new D.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",h=>{if(!!h){if(h.rejectReason)throw new Error(h.rejectReason);return v.WorkspaceEdit.to(h)}})),new D.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new D.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",h=>h.map(v.DocumentLink.to))),new D.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",h=>{if(!!h)return new b.SemanticTokensLegend(h.tokenTypes,h.tokenModifiers)})),new D.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to SemanticTokens.",h=>{if(!h)return;const d=(0,E.decodeSemanticTokensDto)(h);if(d.type==="full")return new b.SemanticTokens(d.data,void 0)})),new D.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range.optional()],new D.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",h=>{if(!!h)return new b.SemanticTokensLegend(h.tokenTypes,h.tokenModifiers)})),new D.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to SemanticTokens.",h=>{if(!h)return;const d=(0,E.decodeSemanticTokensDto)(h);if(d.type==="full")return new b.SemanticTokens(d.data,void 0)})),new D.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),D.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new D.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(h,d,o)=>{if(!h)return new b.CompletionList([]);const g=h.suggestions.map(R=>v.CompletionItem.to(R,o));return new b.CompletionList(g,h.incomplete)})),new D.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new D.ApiCommandResult("A promise that resolves to SignatureHelp.",h=>{if(h)return v.SignatureHelp.to(h)})),new D.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new D.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(h,d,o)=>k(g=>new b.CodeLens(v.Range.to(g.range),g.command&&o.fromInternal(g.command)))(h))),new D.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",h=>b.Range.isRange(h),h=>b.Selection.isSelection(h)?v.Selection.from(h):v.Range.from(h)),D.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),D.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new D.ApiCommandResult("A promise that resolves to an array of Command-instances.",(h,d,o)=>k(g=>{if(g._isSynthetic){if(!g.command)throw new Error("Synthetic code actions must have a command");return o.fromInternal(g.command)}else{const R=new b.CodeAction(g.title,g.kind?new b.CodeActionKind(g.kind):void 0);return g.edit&&(R.edit=v.WorkspaceEdit.to(g.edit)),g.command&&(R.command=o.fromInternal(g.command)),R.isPreferred=g.isPreferred,R}})(h))),new D.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",h=>h?h.map(d=>new b.ColorInformation(v.Range.to(d.range),v.Color.to(d.color))):[])),new D.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new D.ApiCommandArgument("color","The color to show and insert",h=>h instanceof b.Color,v.Color.from),new D.ApiCommandArgument("context","Context object with uri and range",h=>!0,h=>({uri:h.uri,range:v.Range.from(h.range)}))],new D.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",h=>h?h.map(v.ColorPresentation.to):[])),new D.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to an array of Inlay objects",(h,d,o)=>h.map(v.InlayHint.to.bind(void 0,o)))),new D.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new D.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",k(h=>({viewType:h.viewType,displayName:h.displayName,options:{transientOutputs:h.options.transientOutputs,transientCellMetadata:h.options.transientCellMetadata,transientDocumentMetadata:h.options.transientDocumentMetadata},filenamePattern:h.filenamePattern.map(d=>v.NotebookExclusiveDocumentPattern.to(d))})))),new D.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to an array of InlineValue objects",h=>h.map(v.InlineValue.to))),new D.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new D.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",h=>a.URI.isUri(h)||typeof h=="string"&&(0,T.matchesSomeScheme)(h,O.Schemas.http,O.Schemas.https),h=>h),new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",h=>h===void 0||typeof h=="number"||typeof h=="object",h=>h&&(typeof h=="number"?[v.ViewColumn.from(h),void 0]:[v.ViewColumn.from(h.viewColumn),v.TextEditorOpenOptions.from(h)])).optional(),D.ApiCommandArgument.String.with("label","").optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[D.ApiCommandArgument.Uri.with("resource","Resource to open"),D.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",h=>h===void 0||typeof h=="number"||typeof h=="object",h=>h&&(typeof h=="number"?[v.ViewColumn.from(h),void 0]:[v.ViewColumn.from(h.viewColumn),v.TextEditorOpenOptions.from(h)])).optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[D.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),D.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),D.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",h=>h===void 0||typeof h=="object",h=>h&&[v.ViewColumn.from(h.viewColumn),v.TextEditorOpenOptions.from(h)]).optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A TypeHierarchyItem or undefined",h=>h.map(v.TypeHierarchyItem.to))),new D.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[D.ApiCommandArgument.TypeHierarchyItem],new D.ApiCommandResult("A TypeHierarchyItem or undefined",h=>h.map(v.TypeHierarchyItem.to))),new D.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[D.ApiCommandArgument.TypeHierarchyItem],new D.ApiCommandResult("A TypeHierarchyItem or undefined",h=>h.map(v.TypeHierarchyItem.to))),new D.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[D.ApiCommandArgument.TestItem],D.ApiCommandResult.Void),new D.ApiCommand("vscode.experimental.editSession.continue","_workbench.experimental.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[D.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],D.ApiCommandResult.Void)];class m{static register(d){y.forEach(d.registerApiCommand,d)}}e.ExtHostApiCommands=m;function k(h){return d=>{if(Array.isArray(d))return d.map(h)}}function f(h){if(!Array.isArray(h))return;const d=[];for(const o of h)M.isLocationLink(o)?d.push(v.DefinitionLink.to(o)):d.push(v.location.to(o));return d}}),define(ye[192],De([1,0,14,54,5,7,2,66,27,8,6,24,4]),function(ne,e,a,v,b,M,D,P,E,T,O,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function k(f,h,d){const o=f.getProxy(m.MainContext.MainThreadComments);class g{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,h.registerArgumentProcessor({processArgument:t=>{if(t&&t.$mid===6){const c=this._commentControllers.get(t.handle);return c?c.value:t}else if(t&&t.$mid===7){const c=this._commentControllers.get(t.commentControlHandle);if(!c)return t;const _=c.getCommentThread(t.commentThreadHandle);return _?_.value:t}else if(t&&t.$mid===8){const c=this._commentControllers.get(t.thread.commentControlHandle);if(!c)return t;const _=c.getCommentThread(t.thread.commentThreadHandle);return _?{thread:_.value,text:t.text}:t}else if(t&&t.$mid===9){const c=this._commentControllers.get(t.thread.commentControlHandle);if(!c)return t;const _=c.getCommentThread(t.thread.commentThreadHandle);if(!_)return t;const p=t.commentUniqueId,C=_.getCommentByUniqueId(p);return C||t}else if(t&&t.$mid===10){const c=this._commentControllers.get(t.thread.commentControlHandle);if(!c)return t;const _=c.getCommentThread(t.thread.commentThreadHandle);if(!_)return t;const p=t.text,C=t.commentUniqueId,U=_.getCommentByUniqueId(C);return U?(U.body=p,U):t}return t}})}createCommentController(t,c,_){const p=g.handlePool++,C=new l(t,p,c,_);this._commentControllers.set(C.handle,C);const U=this._commentControllersByExtension.get(E.ExtensionIdentifier.toKey(t.identifier))||[];return U.push(C),this._commentControllersByExtension.set(E.ExtensionIdentifier.toKey(t.identifier),U),C.value}$createCommentThreadTemplate(t,c,_){const p=this._commentControllers.get(t);!p||p.$createCommentThreadTemplate(c,_)}async $updateCommentThreadTemplate(t,c,_){const p=this._commentControllers.get(t);!p||p.$updateCommentThreadTemplate(c,_)}$deleteCommentThread(t,c){this._commentControllers.get(t)?.$deleteCommentThread(c)}$provideCommentingRanges(t,c,_){const p=this._commentControllers.get(t);if(!p||!p.commentingRangeProvider)return Promise.resolve(void 0);const C=d.getDocument(D.URI.revive(c));return(0,a.asPromise)(()=>p.commentingRangeProvider.provideCommentingRanges(C,_)).then(U=>U?U.map(W=>T.Range.from(W)):void 0)}$toggleReaction(t,c,_,p,C){const U=this._commentControllers.get(t);return!U||!U.reactionHandler?Promise.resolve(void 0):(0,a.asPromise)(()=>{const W=U.getCommentThread(c);if(W){const L=W.getCommentByUniqueId(p.uniqueIdInThread);if(U!==void 0&&L&&U.reactionHandler)return U.reactionHandler(L,u(C))}return Promise.resolve(void 0)})}dispose(){}}g.handlePool=0;class R{constructor(t,c,_,p,C,U,W,L){this._commentControllerHandle=c,this._id=_,this._uri=p,this._range=C,this._comments=U,this.extensionDescription=W,this._isTemplate=L,this.handle=R._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new b.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new M.MutableDisposable,this._acceptInputDisposables.value=new M.DisposableStore,this._id===void 0&&(this._id=`${t}.${this.handle}`),o.$createCommentThread(c,this.handle,this._id,this._uri,T.Range.from(this._range),W.identifier,this._isTemplate),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=U,this._localDisposables.push({dispose:()=>{o.$deleteCommentThread(c,this.handle)}});const S=this;this.value={get uri(){return S.uri},get range(){return S.range},set range(z){S.range=z},get comments(){return S.comments},set comments(z){S.comments=z},get collapsibleState(){return S.collapsibleState},set collapsibleState(z){S.collapsibleState=z},get canReply(){return S.canReply},set canReply(z){S.canReply=z},get contextValue(){return S.contextValue},set contextValue(z){S.contextValue=z},get label(){return S.label},set label(z){S.label=z},get state(){return S.state},set state(z){S.state=z},dispose:()=>{S.dispose()}}}set threadId(t){this._id=t}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(t){t.isEqual(this._range)||(this._range=t,this.modifications.range=t,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(t){this._canReply!==t&&(this._canReply=t,this.modifications.canReply=t,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(t){this._label=t,this.modifications.label=t,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(t){this._contextValue=t,this.modifications.contextValue=t,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(t){this._comments=t,this.modifications.comments=t,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(t){this._collapseState=t,this.modifications.collapsibleState=t,this._onDidUpdateCommentThread.fire()}get state(){return(0,y.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state}set state(t){(0,y.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state=t,this.modifications.state=t,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new M.DisposableStore);const t=_=>Object.prototype.hasOwnProperty.call(this.modifications,_),c={};t("range")&&(c.range=T.Range.from(this._range)),t("label")&&(c.label=this.label),t("contextValue")&&(c.contextValue=this.contextValue??null),t("comments")&&(c.comments=this._comments.map(_=>w(this,_,this._commentsMap))),t("collapsibleState")&&(c.collapseState=n(this._collapseState)),t("canReply")&&(c.canReply=this.canReply),t("state")&&(c.state=i(this._state)),t("isTemplate")&&(c.isTemplate=this._isTemplate),this.modifications={},o.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,c)}getCommentByUniqueId(t){for(const c of this._commentsMap){const _=c[0],p=c[1];if(t===p)return _}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(t=>t.dispose())}}R._handlePool=0,ze([(0,v.debounce)(100)],R.prototype,"eventuallyUpdateCommentThread",null);class l{constructor(t,c,_,p){this._extension=t,this._handle=c,this._id=_,this._label=p,this._threads=new Map,o.$registerCommentController(this.handle,_,p);const C=this;this.value=Object.freeze({id:C.id,label:C.label,get options(){return C.options},set options(U){C.options=U},get commentingRangeProvider(){return C.commentingRangeProvider},set commentingRangeProvider(U){C.commentingRangeProvider=U},get reactionHandler(){return C.reactionHandler},set reactionHandler(U){C.reactionHandler=U},createCommentThread(U,W,L){return C.createCommentThread(U,W,L).value},dispose:()=>{C.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{o.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(t){this._commentingRangeProvider=t,o.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(t){this._reactionHandler=t,o.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!t})}get options(){return this._options}set options(t){this._options=t,o.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(t,c,_,p){if(typeof t=="string"){const C=new R(this.id,this.handle,t,c,_,p,this._extension,!1);return this._threads.set(C.handle,C),C}else{const C=new R(this.id,this.handle,void 0,t,c,_,this._extension,!1);return this._threads.set(C.handle,C),C}}$createCommentThreadTemplate(t,c){const _=new R(this.id,this.handle,void 0,D.URI.revive(t),T.Range.to(c),[],this._extension,!0);return _.collapsibleState=P.CommentThreadCollapsibleState.Expanded,this._threads.set(_.handle,_),_}$updateCommentThreadTemplate(t,c){const _=this._threads.get(t);_&&(_.range=T.Range.to(c))}$deleteCommentThread(t){this._threads.get(t)?.dispose(),this._threads.delete(t)}getCommentThread(t){return this._threads.get(t)}dispose(){this._threads.forEach(t=>{t.dispose()}),this._localDisposables.forEach(t=>t.dispose())}}function w(r,t,c){let _=c.get(t);_||(_=++r.commentHandle,c.set(t,_));const p=t.author&&t.author.iconPath?t.author.iconPath.toString():void 0;return{mode:t.mode,contextValue:t.contextValue,uniqueIdInThread:_,body:typeof t.body=="string"?t.body:T.MarkdownString.from(t.body),userName:t.author.name,userIconPath:p,label:t.label,commentReactions:t.reactions?t.reactions.map(C=>s(C)):void 0,timestamp:t.timestamp?.toJSON()}}function s(r){return{label:r.label,iconPath:r.iconPath?T.pathOrURIToURI(r.iconPath):void 0,count:r.count,hasReacted:r.authorHasReacted}}function u(r){return{label:r.label||"",count:r.count||0,iconPath:r.iconPath?D.URI.revive(r.iconPath):"",authorHasReacted:r.hasReacted||!1}}function n(r){if(r!==void 0)switch(r){case O.CommentThreadCollapsibleState.Expanded:return P.CommentThreadCollapsibleState.Expanded;case O.CommentThreadCollapsibleState.Collapsed:return P.CommentThreadCollapsibleState.Collapsed}return P.CommentThreadCollapsibleState.Collapsed}function i(r){if(r!==void 0)switch(r){case O.CommentThreadState.Unresolved:return P.CommentThreadState.Unresolved;case O.CommentThreadState.Resolved:return P.CommentThreadState.Resolved}return P.CommentThreadState.Unresolved}return new g}e.createExtHostComments=k}),define(ye[193],De([1,0,26,4,28,13]),function(ne,e,a,v,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let D=class{constructor(O,y){this._mainThreadConsole=O.getProxy(v.MainContext.MainThreadConsole),this._includeStack=y.consoleForward.includeStack,this._logNative=y.consoleForward.logNative,this._wrapConsoleMethod("info","log"),this._wrapConsoleMethod("log","log"),this._wrapConsoleMethod("warn","warn"),this._wrapConsoleMethod("error","error")}_wrapConsoleMethod(O,y){const m=this,k=console[O];Object.defineProperty(console,O,{set:()=>{},get:()=>function(){m._handleConsoleCall(O,y,k,arguments)}})}_handleConsoleCall(O,y,m,k){this._mainThreadConsole.$logExtensionHostMessage({type:"__$console",severity:y,arguments:E(k,this._includeStack)}),this._logNative&&this._nativeConsoleLogMessage(O,m,k)}};D=ze([xe(0,M.IExtHostRpcService),xe(1,b.IExtHostInitDataService)],D),e.AbstractExtHostConsoleForwarder=D;const P=1e5;function E(T,O){const y=[];if(T.length)for(let m=0;m<T.length;m++){let k=T[m];if(typeof k=="undefined")k="undefined";else if(k instanceof Error){const f=k;f.stack?k=f.stack:k=f.toString()}y.push(k)}if(O){const m=new Error().stack;m&&y.push({__$stack:m.split(`
`).slice(3).join(`
`)})}try{const m=(0,a.safeStringify)(y);return m.length>P?"Output omitted for a large object that exceeds the limits":m}catch(m){return`Output omitted for an object that cannot be inspected ('${m.toString()}')`}}}),define(ye[95],De([1,0,2,4,6,3,13,15,16,9,19]),function(ne,e,a,v,b,M,D,P,E,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let y=class Ii{constructor(k,f){this._logService=f,this._provider=new Map,this._proxy=k.getProxy(v.MainContext.MainThreadDecorations)}registerFileDecorationProvider(k,f){const h=Ii._handlePool++;this._provider.set(h,{provider:k,extensionId:f}),this._proxy.$registerDecorationProvider(h,f.value);const d=k.onDidChangeFileDecorations&&k.onDidChangeFileDecorations(o=>{if(!o){this._proxy.$onDidChange(h,null);return}const g=(0,E.asArray)(o);if(g.length<=Ii._maxEventSize){this._proxy.$onDidChange(h,g);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",f.value,g.length);const R=g.map(s=>({uri:s,rank:(0,T.count)(s.path,"/")})),l=(0,E.groupBy)(R,(s,u)=>s.rank-u.rank||(0,T.compare)(s.uri.path,u.uri.path)),w=[];e:for(const s of l){let u;for(const n of s){const i=(0,O.dirname)(n.uri.path);if(u!==i&&(u=i,w.push(n.uri)>=Ii._maxEventSize))break e}}this._proxy.$onDidChange(h,w)});return new b.Disposable(()=>{d?.dispose(),this._proxy.$unregisterDecorationProvider(h),this._provider.delete(h)})}async $provideDecorations(k,f,h){if(!this._provider.has(k))return Object.create(null);const d=Object.create(null),{provider:o,extensionId:g}=this._provider.get(k);return await Promise.all(f.map(async R=>{try{const{uri:l,id:w}=R,s=await Promise.resolve(o.provideFileDecoration(a.URI.revive(l),h));if(!s)return;try{b.FileDecoration.validate(s),d[w]=[s.propagate,s.tooltip,s.badge,s.color]}catch(u){this._logService.warn(`INVALID decoration from extension '${g.value}': ${u}`)}}catch(l){this._logService.error(l)}})),d}};y._handlePool=0,y._maxEventSize=250,y=ze([xe(0,D.IExtHostRpcService),xe(1,P.ILogService)],y),e.ExtHostDecorations=y,e.IExtHostDecorations=(0,M.createDecorator)("IExtHostDecorations")});var Ye=this&&this.__classPrivateFieldSet||function(ne,e,a,v,b){if(v==="m")throw new TypeError("Private method is not writable");if(v==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return v==="a"?b.call(ne,a):b?b.value=a:e.set(ne,a),a},Oe=this&&this.__classPrivateFieldGet||function(ne,e,a,v){if(a==="a"&&!v)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!v:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?v:a==="a"?v.call(ne):v?v.value:e.get(ne)};define(ye[194],De([1,0,129,80,2,4,6,8,5,15,25,35]),function(ne,e,a,v,b,M,D,P,E,T,O,y){"use strict";var m,k,f;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class h{constructor(g,R,l,w,s,u){this._name=g,this._owner=R,this._maxDiagnosticsPerFile=l,m.set(this,void 0),k.set(this,void 0),f.set(this,void 0),this._isDisposed=!1,Ye(this,f,new O.ResourceMap(n=>w.getComparisonKey(n)),"f"),Ye(this,m,s,"f"),Ye(this,k,u,"f")}dispose(){this._isDisposed||(Oe(this,k,"f").fire([...Oe(this,f,"f").keys()]),Oe(this,m,"f")?.$clear(this._owner),Oe(this,f,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(g,R){if(!g){this.clear();return}this._checkDisposed();let l=[];if(b.URI.isUri(g)){if(!R){this.delete(g);return}Oe(this,f,"f").set(g,R.slice()),l=[g]}else if(Array.isArray(g)){l=[];let s;g=[...g].sort(h._compareIndexedTuplesByUri);for(const u of g){const[n,i]=u;if((!s||n.toString()!==s.toString())&&(s&&Oe(this,f,"f").get(s).length===0&&Oe(this,f,"f").delete(s),s=n,l.push(n),Oe(this,f,"f").set(n,[])),i)Oe(this,f,"f").get(n)?.push(...i);else{const r=Oe(this,f,"f").get(n);r&&(r.length=0)}}}if(Oe(this,k,"f").fire(l),!Oe(this,m,"f"))return;const w=[];for(const s of l){let u=[];const n=Oe(this,f,"f").get(s);if(n)if(n.length>this._maxDiagnosticsPerFile){u=[];const i=[D.DiagnosticSeverity.Error,D.DiagnosticSeverity.Warning,D.DiagnosticSeverity.Information,D.DiagnosticSeverity.Hint];e:for(let r=0;r<4;r++)for(const t of n)if(t.severity===i[r]&&u.push(P.Diagnostic.from(t))===this._maxDiagnosticsPerFile)break e;u.push({severity:v.MarkerSeverity.Info,message:(0,a.localize)(0,null,n.length-this._maxDiagnosticsPerFile),startLineNumber:u[u.length-1].startLineNumber,startColumn:u[u.length-1].startColumn,endLineNumber:u[u.length-1].endLineNumber,endColumn:u[u.length-1].endColumn})}else u=n.map(i=>P.Diagnostic.from(i));w.push([s,u])}Oe(this,m,"f").$changeMany(this._owner,w)}delete(g){this._checkDisposed(),Oe(this,k,"f").fire([g]),Oe(this,f,"f").delete(g),Oe(this,m,"f")?.$changeMany(this._owner,[[g,void 0]])}clear(){this._checkDisposed(),Oe(this,k,"f").fire([...Oe(this,f,"f").keys()]),Oe(this,f,"f").clear(),Oe(this,m,"f")?.$clear(this._owner)}forEach(g,R){this._checkDisposed();for(const[l,w]of this)g.call(R,l,w,this)}*[(m=new WeakMap,k=new WeakMap,f=new WeakMap,Symbol.iterator)](){this._checkDisposed();for(const g of Oe(this,f,"f").keys())yield[g,this.get(g)]}get(g){this._checkDisposed();const R=Oe(this,f,"f").get(g);return Array.isArray(R)?Object.freeze(R.slice(0)):[]}has(g){return this._checkDisposed(),Array.isArray(Oe(this,f,"f").get(g))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(g,R){return g[0].toString()<R[0].toString()?-1:g[0].toString()>R[0].toString()?1:0}}e.DiagnosticCollection=h;let d=class fi{constructor(g,R,l){this._logService=R,this._fileSystemInfoService=l,this._collections=new Map,this._onDidChangeDiagnostics=new E.DebounceEmitter({merge:w=>w.flat(),delay:50}),this.onDidChangeDiagnostics=E.Event.map(this._onDidChangeDiagnostics.event,fi._mapper),this._proxy=g.getProxy(M.MainContext.MainThreadDiagnostics)}static _mapper(g){const R=new O.ResourceMap;for(const l of g)R.set(l,l);return{uris:Object.freeze(Array.from(R.values()))}}createDiagnosticCollection(g,R){const{_collections:l,_proxy:w,_onDidChangeDiagnostics:s,_logService:u,_fileSystemInfoService:n}=this,i=new class{$changeMany(c,_){w.$changeMany(c,_),u.trace("[DiagnosticCollection] change many (extension, owner, uris)",g.value,c,_.length===0?"CLEARING":_)}$clear(c){w.$clear(c),u.trace("[DiagnosticCollection] remove all (extension, owner)",g.value,c)}dispose(){w.dispose()}};let r;if(!R)R="_generated_diagnostic_collection_name_#"+fi._idPool++,r=R;else if(!l.has(R))r=R;else{this._logService.warn(`DiagnosticCollection with name '${R}' does already exist.`);do r=R+fi._idPool++;while(l.has(r))}return new class extends h{constructor(){super(R,r,fi._maxDiagnosticsPerFile,n.extUri,i,s);l.set(r,this)}dispose(){super.dispose(),l.delete(r)}}}getDiagnostics(g){if(g)return this._getDiagnostics(g);{const R=new Map,l=[];for(const w of this._collections.values())w.forEach((s,u)=>{let n=R.get(s.toString());typeof n=="undefined"&&(n=l.length,R.set(s.toString(),n),l.push([s,[]])),l[n][1]=l[n][1].concat(...u)});return l}}_getDiagnostics(g){let R=[];for(const l of this._collections.values())l.has(g)&&(R=R.concat(l.get(g)));return R}$acceptMarkersChange(g){if(!this._mirrorCollection){const R="_generated_mirror",l=new h(R,R,fi._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(R,l),this._mirrorCollection=l}for(const[R,l]of g)this._mirrorCollection.set(b.URI.revive(R),l.map(P.Diagnostic.to))}};d._idPool=0,d._maxDiagnosticsPerFile=1e3,d=ze([xe(1,T.ILogService),xe(2,y.IExtHostFileSystemInfo)],d),e.ExtHostDiagnostics=d}),define(ye[195],De([1,0,2,4]),function(ne,e,a,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class b{constructor(D){this._proxy=D.getProxy(v.MainContext.MainThreadDialogs)}showOpenDialog(D){return this._proxy.$showOpenDialog(D).then(P=>P?P.map(E=>a.URI.revive(E)):void 0)}showSaveDialog(D){return this._proxy.$showSaveDialog(D).then(P=>P?a.URI.revive(P):void 0)}}e.ExtHostDialogs=b}),define(ye[196],De([1,0,11,2,6,4,12,20,9]),function(ne,e,a,v,b,M,D,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class T{constructor(y,m,k){this._documentsAndEditors=m,this._logService=k,this._documentContentProviders=new Map,this._proxy=y.getProxy(M.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(y,m){if(Object.keys(D.Schemas).indexOf(y)>=0)throw new Error(`scheme '${y}' already registered`);const k=T._handlePool++;this._documentContentProviders.set(k,m),this._proxy.$registerTextContentProvider(k,y);let f;return typeof m.onDidChange=="function"&&(f=m.onDidChange(h=>{if(h.scheme!==y){this._logService.warn(`Provider for scheme '${y}' is firing event for schema '${h.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(h)&&this.$provideTextDocumentContent(k,h).then(d=>{if(!d&&typeof d!="string")return;const o=this._documentsAndEditors.getDocument(h);if(!o)return;const g=(0,E.splitLines)(d);if(!o.equalLines(g))return this._proxy.$onVirtualDocumentChange(h,d)},a.onUnexpectedError)})),new b.Disposable(()=>{this._documentContentProviders.delete(k)&&this._proxy.$unregisterTextContentProvider(k),f&&(f.dispose(),f=void 0)})}$provideTextDocumentContent(y,m){const k=this._documentContentProviders.get(y);return k?Promise.resolve(k.provideTextDocumentContent(v.URI.revive(m),P.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${m.scheme}`))}}e.ExtHostDocumentContentProvider=T,T._handlePool=0}),define(ye[197],De([1,0,5,7,2,4,87,8,10,26,6]),function(ne,e,a,v,b,M,D,P,E,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class y{constructor(k,f){this._onDidAddDocument=new a.Emitter,this._onDidRemoveDocument=new a.Emitter,this._onDidChangeDocument=new a.Emitter,this._onDidSaveDocument=new a.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new v.DisposableStore,this._documentLoader=new Map,this._proxy=k.getProxy(M.MainContext.MainThreadDocuments),this._documentsAndEditors=f,this._documentsAndEditors.onDidRemoveDocuments(h=>{for(const d of h)this._onDidRemoveDocument.fire(d.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(h=>{for(const d of h)this._onDidAddDocument.fire(d.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(k){if(!k)return;const f=this._documentsAndEditors.getDocument(k);if(f)return f}getDocument(k){const f=this.getDocumentData(k);if(!f?.document)throw new Error(`Unable to retrieve document from URI '${k}'`);return f.document}ensureDocumentData(k){const f=this._documentsAndEditors.getDocument(k);if(f)return Promise.resolve(f);let h=this._documentLoader.get(k.toString());return h||(h=this._proxy.$tryOpenDocument(k).then(d=>{this._documentLoader.delete(k.toString());const o=b.URI.revive(d);return(0,E.assertIsDefined)(this._documentsAndEditors.getDocument(o))},d=>(this._documentLoader.delete(k.toString()),Promise.reject(d))),this._documentLoader.set(k.toString(),h)),h}createDocumentData(k){return this._proxy.$tryCreateDocument(k).then(f=>b.URI.revive(f))}$acceptModelLanguageChanged(k,f){const h=b.URI.revive(k),d=this._documentsAndEditors.getDocument(h);if(!d)throw new Error("unknown document");this._onDidRemoveDocument.fire(d.document),d._acceptLanguageId(f),this._onDidAddDocument.fire(d.document)}$acceptModelSaved(k){const f=b.URI.revive(k),h=this._documentsAndEditors.getDocument(f);if(!h)throw new Error("unknown document");this.$acceptDirtyStateChanged(k,!1),this._onDidSaveDocument.fire(h.document)}$acceptDirtyStateChanged(k,f){const h=b.URI.revive(k),d=this._documentsAndEditors.getDocument(h);if(!d)throw new Error("unknown document");d._acceptIsDirty(f),this._onDidChangeDocument.fire({document:d.document,contentChanges:[],reason:void 0})}$acceptModelChanged(k,f,h){const d=b.URI.revive(k),o=this._documentsAndEditors.getDocument(d);if(!o)throw new Error("unknown document");o._acceptIsDirty(h),o.onEvents(f);let g;f.isUndoing?g=O.TextDocumentChangeReason.Undo:f.isRedoing&&(g=O.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,T.deepFreeze)({document:o.document,contentChanges:f.changes.map(R=>({range:P.Range.to(R.range),rangeOffset:R.rangeOffset,rangeLength:R.rangeLength,text:R.text})),reason:g}))}setWordDefinitionFor(k,f){(0,D.setWordDefinitionFor)(k,f)}}e.ExtHostDocuments=y}),define(ye[49],De([1,0,44,5,7,2,3,4,87,13,93,8,15,25,12,168,198]),function(ne,e,a,v,b,M,D,P,E,T,O,y,m,k,f,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class o{constructor(l){this.value=l,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let g=class{constructor(l,w){this._extHostRpc=l,this._logService=w,this._activeEditorId=null,this._editors=new Map,this._documents=new k.ResourceMap,this._onDidAddDocuments=new v.Emitter,this._onDidRemoveDocuments=new v.Emitter,this._onDidChangeVisibleTextEditors=new v.Emitter,this._onDidChangeActiveTextEditor=new v.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(l){this.acceptDocumentsAndEditorsDelta(l)}acceptDocumentsAndEditorsDelta(l){const w=[],s=[],u=[];if(l.removedDocuments)for(const n of l.removedDocuments){const i=M.URI.revive(n),r=this._documents.get(i);r?.unref()&&(this._documents.delete(i),w.push(r.value))}if(l.addedDocuments)for(const n of l.addedDocuments){const i=M.URI.revive(n.uri);let r=this._documents.get(i);if(r&&i.scheme!==f.Schemas.vscodeNotebookCell&&i.scheme!==f.Schemas.vscodeInteractiveInput)throw new Error(`document '${i} already exists!'`);r||(r=new o(new E.ExtHostDocumentData(this._extHostRpc.getProxy(P.MainContext.MainThreadDocuments),i,n.lines,n.EOL,n.versionId,n.languageId,n.isDirty,n.notebook)),this._documents.set(i,r),s.push(r.value)),r.ref()}if(l.removedEditors)for(const n of l.removedEditors){const i=this._editors.get(n);this._editors.delete(n),i&&u.push(i)}if(l.addedEditors)for(const n of l.addedEditors){const i=M.URI.revive(n.documentUri);a.ok(this._documents.has(i),`document '${i}' does not exist`),a.ok(!this._editors.has(n.id),`editor '${n.id}' already exists!`);const r=this._documents.get(i).value,t=new O.ExtHostTextEditor(n.id,this._extHostRpc.getProxy(P.MainContext.MainThreadTextEditors),this._logService,new d.Lazy(()=>r.document),n.selections.map(y.Selection.to),n.options,n.visibleRanges.map(c=>y.Range.to(c)),typeof n.editorPosition=="number"?y.ViewColumn.to(n.editorPosition):void 0);this._editors.set(n.id,t)}l.newActiveEditor!==void 0&&(a.ok(l.newActiveEditor===null||this._editors.has(l.newActiveEditor),`active editor '${l.newActiveEditor}' does not exist`),this._activeEditorId=l.newActiveEditor),(0,b.dispose)(w),(0,b.dispose)(u),l.removedDocuments&&this._onDidRemoveDocuments.fire(w),l.addedDocuments&&this._onDidAddDocuments.fire(s),(l.removedEditors||l.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(n=>n.value)),l.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(l){return this._documents.get(l)?.value}allDocuments(){return h.Iterable.map(this._documents.values(),l=>l.value)}getEditor(l){return this._editors.get(l)}activeEditor(l){if(!this._activeEditorId)return;const w=this._editors.get(this._activeEditorId);return l?w:w?.value}allEditors(){return[...this._editors.values()]}};g=ze([xe(0,T.IExtHostRpcService),xe(1,m.ILogService)],g),e.ExtHostDocumentsAndEditors=g,e.IExtHostDocumentsAndEditors=(0,D.createDecorator)("IExtHostDocumentsAndEditors")}),define(ye[50],De([1,0,8,4,2,5,3,6,13,10,72]),function(ne,e,a,v,b,M,D,P,E,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,D.createDecorator)("IExtHostEditorTabs");class y{constructor(d,o,g){this._activeTabIdGetter=g,this._parentGroup=o,this.acceptDtoUpdate(d)}get apiObject(){if(!this._apiObject){const d=this,o={get isActive(){return d._dto.id===d._activeTabIdGetter()},get label(){return d._dto.label},get input(){return d._input},get isDirty(){return d._dto.isDirty},get isPinned(){return d._dto.isPinned},get isPreview(){return d._dto.isPreview},get group(){return d._parentGroup.apiObject}};this._apiObject=Object.freeze(o)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(d){this._dto=d,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case 1:return new P.TextTabInput(b.URI.revive(this._dto.input.uri));case 2:return new P.TextDiffTabInput(b.URI.revive(this._dto.input.original),b.URI.revive(this._dto.input.modified));case 3:return new P.TextMergeTabInput(b.URI.revive(this._dto.input.base),b.URI.revive(this._dto.input.input1),b.URI.revive(this._dto.input.input2),b.URI.revive(this._dto.input.result));case 6:return new P.CustomEditorTabInput(b.URI.revive(this._dto.input.uri),this._dto.input.viewType);case 7:return new P.WebviewEditorTabInput(this._dto.input.viewType);case 4:return new P.NotebookEditorTabInput(b.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case 5:return new P.NotebookDiffEditorTabInput(b.URI.revive(this._dto.input.original),b.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case 8:return new P.TerminalEditorTabInput;case 9:return new P.InteractiveWindowInput(b.URI.revive(this._dto.input.uri),b.URI.revive(this._dto.input.inputBoxUri));default:return}}}class m{constructor(d,o){this._tabs=[],this._activeTabId="",this._dto=d,this._activeGroupIdGetter=o;for(const g of d.tabs)g.isActive&&(this._activeTabId=g.id),this._tabs.push(new y(g,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const d=this,o={get isActive(){return d._dto.groupId===d._activeGroupIdGetter()},get viewColumn(){return a.ViewColumn.to(d._dto.viewColumn)},get activeTab(){return d._tabs.find(g=>g.tabId===d._activeTabId)?.apiObject},get tabs(){return Object.freeze(d._tabs.map(g=>g.apiObject))}};this._apiObject=Object.freeze(o)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(d){this._dto=d}acceptTabOperation(d){if(d.kind===0){const g=new y(d.tabDto,this,()=>this.activeTabId());return this._tabs.splice(d.index,0,g),d.tabDto.isActive&&(this._activeTabId=g.tabId),g}else if(d.kind===1){const g=this._tabs.splice(d.index,1)[0];if(!g)throw new Error(`Tab close updated received for index ${d.index} which does not exist`);return g.tabId===this._activeTabId&&(this._activeTabId=""),g}else if(d.kind===3){if(d.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const g=this._tabs.splice(d.oldIndex,1)[0];if(!g)throw new Error(`Tab move updated received for index ${d.oldIndex} which does not exist`);return this._tabs.splice(d.index,0,g),g}const o=this._tabs.find(g=>g.tabId===d.tabDto.id);if(!o)throw new Error("INVALID tab");return d.tabDto.isActive?this._activeTabId=d.tabDto.id:this._activeTabId===d.tabDto.id&&!d.tabDto.isActive&&(this._activeTabId=""),o.acceptDtoUpdate(d.tabDto),o}activeTabId(){return this._activeTabId}}let k=class{constructor(d){this._onDidChangeTabs=new M.Emitter,this._onDidChangeTabGroups=new M.Emitter,this._extHostTabGroups=[],this._proxy=d.getProxy(v.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const d=this,o={onDidChangeTabGroups:d._onDidChangeTabGroups.event,onDidChangeTabs:d._onDidChangeTabs.event,get all(){return Object.freeze(d._extHostTabGroups.map(g=>g.apiObject))},get activeTabGroup(){const g=d._activeGroupId;return(0,T.assertIsDefined)(d._extHostTabGroups.find(l=>l.groupId===g)?.apiObject)},close:async(g,R)=>{const l=Array.isArray(g)?g:[g];return l.length?f(l[0])?this._closeGroups(l,R):this._closeTabs(l,R):!0}};this._apiObject=Object.freeze(o)}return this._apiObject}$acceptEditorTabModel(d){const o=new Set(this._extHostTabGroups.map(n=>n.groupId)),g=new Set(d.map(n=>n.groupId)),R=(0,O.diffSets)(o,g),l=this._extHostTabGroups.filter(n=>R.removed.includes(n.groupId)).map(n=>n.apiObject),w=[],s=[];this._extHostTabGroups=d.map(n=>{const i=new m(n,()=>this._activeGroupId);return R.added.includes(i.groupId)?w.push(i.apiObject):s.push(i.apiObject),i});const u=(0,T.assertIsDefined)(d.find(n=>n.isActive===!0)?.groupId);u!==void 0&&this._activeGroupId!==u&&(this._activeGroupId=u),this._onDidChangeTabGroups.fire(Object.freeze({opened:w,closed:l,changed:s}))}$acceptTabGroupUpdate(d){const o=this._extHostTabGroups.find(g=>g.groupId===d.groupId);if(!o)throw new Error("Update Group IPC call received before group creation.");o.acceptGroupDtoUpdate(d),d.isActive&&(this._activeGroupId=d.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[o.apiObject],opened:[],closed:[]}))}$acceptTabOperation(d){const o=this._extHostTabGroups.find(R=>R.groupId===d.groupId);if(!o)throw new Error("Update Tabs IPC call received before group creation.");const g=o.acceptTabOperation(d);switch(d.kind){case 0:this._onDidChangeTabs.fire(Object.freeze({opened:[g.apiObject],closed:[],changed:[]}));return;case 1:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[g.apiObject],changed:[]}));return;case 3:case 2:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[g.apiObject]}));return}}_findExtHostTabFromApi(d){for(const o of this._extHostTabGroups)for(const g of o.tabs)if(g.apiObject===d)return g}_findExtHostTabGroupFromApi(d){return this._extHostTabGroups.find(o=>o.apiObject===d)}async _closeTabs(d,o){const g=[];for(const R of d){const l=this._findExtHostTabFromApi(R);if(!l)throw new Error("Tab close: Invalid tab not found!");g.push(l.tabId)}return this._proxy.$closeTab(g,o)}async _closeGroups(d,o){const g=[];for(const R of d){const l=this._findExtHostTabGroupFromApi(R);if(!l)throw new Error("Group close: Invalid group not found!");g.push(l.groupId)}return this._proxy.$closeGroup(g,o)}};k=ze([xe(0,E.IExtHostRpcService)],k),e.ExtHostEditorTabs=k;function f(h){return h.tabs!==void 0}}),define(ye[199],De([1,0,2,4,7,6,8,244,9,23,24]),function(ne,e,a,v,b,M,D,P,E,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class y{constructor(){this._schemes=[]}add(f){this._stateMachine=void 0,this._schemes.push(f)}delete(f){const h=this._schemes.indexOf(f);h>=0&&(this._schemes.splice(h,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const f=this._schemes.sort(),h=[];let d,o,g=14,R=14;for(const l of f){let w=d?(0,E.commonPrefixLength)(d,l):0;for(w===0?o=1:o=R;w<l.length;w++)w+1===l.length?(g=R,R=9):R+=1,h.push([o,l.toUpperCase().charCodeAt(w),R]),h.push([o,l.toLowerCase().charCodeAt(w),R]),o=R;d=l,R=g}h.push([9,58,10]),h.push([10,47,12]),this._stateMachine=new P.StateMachine(h)}}provideDocumentLinks(f){this._initStateMachine();const h=[],d=P.LinkComputer.computeLinks({getLineContent(o){return f.lineAt(o-1).text},getLineCount(){return f.lineCount}},this._stateMachine);for(const o of d){const g=D.DocumentLink.to(o);g.target&&h.push(g)}return h}}class m{constructor(f,h){this._extHostLanguageFeatures=h,this._linkProvider=new y,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=f.getProxy(v.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(f,h,d,o={}){if(this._registeredSchemes.has(h))throw new Error(`a provider for the scheme '${h}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(f,"*",this._linkProvider));const g=this._handlePool++;this._linkProvider.add(h),this._registeredSchemes.add(h),this._fsProvider.set(g,d);let R=2;o.isCaseSensitive&&(R+=1024),o.isReadonly&&(R+=2048),typeof d.copy=="function"&&(R+=8),typeof d.open=="function"&&typeof d.close=="function"&&typeof d.read=="function"&&typeof d.write=="function"&&((0,O.checkProposedApiEnabled)(f,"fsChunks"),R+=4),this._proxy.$registerFileSystemProvider(g,h,R).catch(w=>{console.error(`FAILED to register filesystem provider of ${f.identifier.value}-extension for the scheme ${h}`),console.error(w)});const l=d.onDidChangeFile(w=>{const s=[];for(const u of w){const{uri:n,type:i}=u;if(n.scheme!==h)continue;let r;switch(i){case M.FileChangeType.Changed:r=0;break;case M.FileChangeType.Created:r=1;break;case M.FileChangeType.Deleted:r=2;break;default:throw new Error("Unknown FileChangeType")}s.push({resource:n,type:r})}this._proxy.$onFileSystemChange(g,s)});return(0,b.toDisposable)(()=>{l.dispose(),this._linkProvider.delete(h),this._registeredSchemes.delete(h),this._fsProvider.delete(g),this._proxy.$unregisterProvider(g)})}static _asIStat(f){const{type:h,ctime:d,mtime:o,size:g,permissions:R}=f;return{type:h,ctime:d,mtime:o,size:g,permissions:R}}$stat(f,h){return Promise.resolve(this._getFsProvider(f).stat(a.URI.revive(h))).then(d=>m._asIStat(d))}$readdir(f,h){return Promise.resolve(this._getFsProvider(f).readDirectory(a.URI.revive(h)))}$readFile(f,h){return Promise.resolve(this._getFsProvider(f).readFile(a.URI.revive(h))).then(d=>T.VSBuffer.wrap(d))}$writeFile(f,h,d,o){return Promise.resolve(this._getFsProvider(f).writeFile(a.URI.revive(h),d.buffer,o))}$delete(f,h,d){return Promise.resolve(this._getFsProvider(f).delete(a.URI.revive(h),d))}$rename(f,h,d,o){return Promise.resolve(this._getFsProvider(f).rename(a.URI.revive(h),a.URI.revive(d),o))}$copy(f,h,d,o){const g=this._getFsProvider(f);if(!g.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(g.copy(a.URI.revive(h),a.URI.revive(d),o))}$mkdir(f,h){return Promise.resolve(this._getFsProvider(f).createDirectory(a.URI.revive(h)))}$watch(f,h,d,o){const g=this._getFsProvider(f).watch(a.URI.revive(d),o);this._watches.set(h,g)}$unwatch(f,h){const d=this._watches.get(h);d&&(d.dispose(),this._watches.delete(h))}$open(f,h,d){const o=this._getFsProvider(f);if(!o.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(o.open(a.URI.revive(h),d))}$close(f,h){const d=this._getFsProvider(f);if(!d.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(d.close(h))}$read(f,h,d,o){const g=this._getFsProvider(f);if(!g.read)throw new Error('FileSystemProvider does not implement "read"');const R=T.VSBuffer.alloc(o);return Promise.resolve(g.read(h,d,R.buffer,0,o)).then(l=>R.slice(0,l))}$write(f,h,d,o){const g=this._getFsProvider(f);if(!g.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(g.write(h,d,o.buffer,0,o.byteLength))}_getFsProvider(f){const h=this._fsProvider.get(f);if(!h){const d=new Error;throw d.name="ENOPRO",d.message="no provider",d}return h}}e.ExtHostFileSystem=m}),define(ye[51],De([1,0,4,39,6,23,3,13,35,7]),function(ne,e,a,v,b,M,D,P,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let O=class Qt{constructor(m,k){this._fileSystemProvider=new Map,this._proxy=m.getProxy(a.MainContext.MainThreadFileSystem);const f=this;this.value=Object.freeze({async stat(h){try{const d=f._fileSystemProvider.get(h.scheme);if(!d)return await f._proxy.$stat(h);await f._proxy.$ensureActivation(h.scheme);const o=await d.stat(h);return{type:o.type,ctime:o.ctime,mtime:o.mtime,size:o.size,permissions:o.permissions}}catch(d){Qt._handleError(d)}},async readDirectory(h){try{const d=f._fileSystemProvider.get(h.scheme);return d?(await f._proxy.$ensureActivation(h.scheme),(await d.readDirectory(h)).slice()):await f._proxy.$readdir(h)}catch(d){return Qt._handleError(d)}},async createDirectory(h){try{return await f._proxy.$mkdir(h)}catch(d){return Qt._handleError(d)}},async readFile(h){try{const d=f._fileSystemProvider.get(h.scheme);return d?(await f._proxy.$ensureActivation(h.scheme),(await d.readFile(h)).slice()):(await f._proxy.$readFile(h)).buffer}catch(d){return Qt._handleError(d)}},async writeFile(h,d){try{return await f._proxy.$writeFile(h,M.VSBuffer.wrap(d))}catch(o){return Qt._handleError(o)}},async delete(h,d){try{const o=f._fileSystemProvider.get(h.scheme);return o?(await f._proxy.$ensureActivation(h.scheme),await o.delete(h,{recursive:!1,...d})):await f._proxy.$delete(h,{recursive:!1,useTrash:!1,...d})}catch(o){return Qt._handleError(o)}},async rename(h,d,o){try{return await f._proxy.$rename(h,d,{overwrite:!1,...o})}catch(g){return Qt._handleError(g)}},async copy(h,d,o){try{return await f._proxy.$copy(h,d,{overwrite:!1,...o})}catch(g){return Qt._handleError(g)}},isWritableFileSystem(h){const d=k.getCapabilities(h);if(typeof d=="number")return!(d&2048)}})}static _handleError(m){if(m instanceof b.FileSystemError)throw m;if(!(m instanceof Error))throw new b.FileSystemError(String(m));if(m.name==="ENOPRO")throw b.FileSystemError.Unavailable(m.message);switch(m.name){case v.FileSystemProviderErrorCode.FileExists:throw b.FileSystemError.FileExists(m.message);case v.FileSystemProviderErrorCode.FileNotFound:throw b.FileSystemError.FileNotFound(m.message);case v.FileSystemProviderErrorCode.FileNotADirectory:throw b.FileSystemError.FileNotADirectory(m.message);case v.FileSystemProviderErrorCode.FileIsADirectory:throw b.FileSystemError.FileIsADirectory(m.message);case v.FileSystemProviderErrorCode.NoPermissions:throw b.FileSystemError.NoPermissions(m.message);case v.FileSystemProviderErrorCode.Unavailable:throw b.FileSystemError.Unavailable(m.message);default:throw new b.FileSystemError(m.message,m.name)}}addFileSystemProvider(m,k){return this._fileSystemProvider.set(m,k),(0,T.toDisposable)(()=>this._fileSystemProvider.delete(m))}};O=ze([xe(0,P.IExtHostRpcService),xe(1,E.IExtHostFileSystemInfo)],O),e.ExtHostConsumerFileSystem=O,e.IExtHostConsumerFileSystem=(0,D.createDecorator)("IExtHostConsumerFileSystem")}),define(ye[200],De([1,0,5,34,2,4,8,6,24]),function(ne,e,a,v,b,M,D,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class T{constructor(m,k,f,h,d,o,g,R){this._onDidCreate=new a.Emitter,this._onDidChange=new a.Emitter,this._onDidDelete=new a.Emitter;const l=this.ensureWatching(m,f,d);this._config=0,o&&(this._config+=1),g&&(this._config+=2),R&&(this._config+=4);const w=(0,v.parse)(d),s=typeof d=="string",u=h(n=>{if(!o)for(const i of n.created){const r=b.URI.revive(i);w(r.fsPath)&&(!s||k.getWorkspaceFolder(r))&&this._onDidCreate.fire(r)}if(!g)for(const i of n.changed){const r=b.URI.revive(i);w(r.fsPath)&&(!s||k.getWorkspaceFolder(r))&&this._onDidChange.fire(r)}if(!R)for(const i of n.deleted){const r=b.URI.revive(i);w(r.fsPath)&&(!s||k.getWorkspaceFolder(r))&&this._onDidDelete.fire(r)}});this._disposable=P.Disposable.from(l,this._onDidCreate,this._onDidChange,this._onDidDelete,u)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}ensureWatching(m,k,f){const h=P.Disposable.from();if(typeof f=="string")return h;const d=m.getProxy(M.MainContext.MainThreadFileSystem);let o=!1;(f.pattern.includes(v.GLOBSTAR)||f.pattern.includes(v.GLOB_SPLIT))&&(o=!0);const g=Math.random();return d.$watch(k.identifier.value,g,f.baseUri,{recursive:o,excludes:[]}),P.Disposable.from({dispose:()=>d.$unwatch(g)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class O{constructor(m,k,f){this._mainContext=m,this._logService=k,this._extHostDocumentsAndEditors=f,this._onFileSystemEvent=new a.Emitter,this._onDidRenameFile=new a.Emitter,this._onDidCreateFile=new a.Emitter,this._onDidDeleteFile=new a.Emitter,this._onWillRenameFile=new a.AsyncEmitter,this._onWillCreateFile=new a.AsyncEmitter,this._onWillDeleteFile=new a.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(m,k,f,h,d,o){return new T(this._mainContext,m,k,this._onFileSystemEvent.event,D.GlobPattern.from(f),h,d,o)}$onFileEvent(m){this._onFileSystemEvent.fire(m)}$onDidRunFileOperation(m,k){switch(m){case 2:this._onDidRenameFile.fire(Object.freeze({files:k.map(f=>({oldUri:b.URI.revive(f.source),newUri:b.URI.revive(f.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:k.map(f=>b.URI.revive(f.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:k.map(f=>b.URI.revive(f.target))}));break;default:}}getOnWillRenameFileEvent(m){return this._createWillExecuteEvent(m,this._onWillRenameFile)}getOnWillCreateFileEvent(m){return this._createWillExecuteEvent(m,this._onWillCreateFile)}getOnWillDeleteFileEvent(m){return this._createWillExecuteEvent(m,this._onWillDeleteFile)}_createWillExecuteEvent(m,k){return(f,h,d)=>{const o=function(R){f.call(h,R)};return o.extension=m,k.event(o,void 0,d)}}async $onWillRunFileOperation(m,k,f,h){switch(m){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:k.map(d=>({oldUri:b.URI.revive(d.source),newUri:b.URI.revive(d.target)}))},f,h);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:k.map(d=>b.URI.revive(d.target))},f,h);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:k.map(d=>b.URI.revive(d.target))},f,h)}}async _fireWillEvent(m,k,f,h){const d=new Set,o=[];if(await m.fireAsync(k,h,async(R,l)=>{const w=Date.now(),s=await Promise.resolve(R);s instanceof P.WorkspaceEdit&&(o.push([l.extension,s]),d.add(l.extension.displayName??l.extension.identifier.value)),Date.now()-w>f&&this._logService.warn("SLOW file-participant",l.extension.identifier)}),h.isCancellationRequested||o.length===0)return;const g={edits:[]};for(const[R,l]of o){const{edits:w}=D.WorkspaceEdit.from(l,{getTextDocumentVersion:s=>this._extHostDocumentsAndEditors.getDocument(s)?.version,getNotebookDocumentVersion:()=>{}},(0,E.isProposedApiEnabled)(R,"snippetWorkspaceEdit"));g.edits=g.edits.concat(w)}return{edit:g,extensionNames:Array.from(d)}}}e.ExtHostFileSystemEventService=O}),define(ye[201],De([1,0,2,36]),function(ne,e,a,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class b{constructor(D,P,E,T,O){this._extHostNotebooks=P,this._textDocumentsAndEditors=E,this._commands=T;const y=new v.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new v.ApiCommandArgument("showOptions","Show Options",m=>!0,m=>m),new v.ApiCommandArgument("resource","Interactive resource Uri",m=>!0,m=>m),new v.ApiCommandArgument("controllerId","Notebook controller Id",m=>!0,m=>m),new v.ApiCommandArgument("title","Interactive editor title",m=>!0,m=>m)],new v.ApiCommandResult("Notebook and input URI",m=>{if(O.debug("[ExtHostInteractive] open iw with notebook editor id",m.notebookEditorId),m.notebookEditorId!==void 0){const k=this._extHostNotebooks.getEditorById(m.notebookEditorId);return O.debug("[ExtHostInteractive] notebook editor found",k.id),{notebookUri:a.URI.revive(m.notebookUri),inputUri:a.URI.revive(m.inputUri),notebookEditor:k.apiEditor}}return O.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",m.notebookUri,m.inputUri),{notebookUri:a.URI.revive(m.notebookUri),inputUri:a.URI.revive(m.inputUri)}}));this._commands.registerApiCommand(y)}$willAddInteractiveDocument(D,P,E,T){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:P,lines:[""],languageId:E,uri:D,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(a.URI.revive(T))?.apiNotebook}]})}$willRemoveInteractiveDocument(D,P){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[D]})}}e.ExtHostInteractive=b}),define(ye[202],De([1,0,7,4]),function(ne,e,a,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class b{constructor(D){this._handlePool=0,this._proxy=D.getProxy(v.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(D){const P=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(P,D),(0,a.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(P)})}}e.ExtHostLabelService=b}),define(ye[203],De([1,0,2,26,8,6,66,4,9,48,16,10,245,20,7,77,73,61,204,11,14,24]),function(ne,e,a,v,b,M,D,P,E,T,O,y,m,k,f,h,d,o,g,R,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class s{constructor(I,B){this._documents=I,this._provider=B}async provideDocumentSymbols(I,B){const H=this._documents.getDocument(I),V=await this._provider.provideDocumentSymbols(H,B);if(!(0,O.isFalsyOrEmpty)(V))return V[0]instanceof M.DocumentSymbol?V.map(b.DocumentSymbol.from):s._asDocumentSymbolTree(V)}static _asDocumentSymbolTree(I){I=I.slice(0).sort((V,se)=>{let de=V.location.range.start.compareTo(se.location.range.start);return de===0&&(de=se.location.range.end.compareTo(V.location.range.end)),de});const B=[],H=[];for(const V of I){const se={name:V.name||"!!MISSING: name!!",kind:b.SymbolKind.from(V.kind),tags:V.tags?.map(b.SymbolTag.from)||[],detail:"",containerName:V.containerName,range:b.Range.from(V.location.range),selectionRange:b.Range.from(V.location.range),children:[]};for(;;){if(H.length===0){H.push(se),B.push(se);break}const de=H[H.length-1];if(T.Range.containsRange(de.range,se.range)&&!T.Range.equalsRange(de.range,se.range)){de.children?.push(se),H.push(se);break}H.pop()}}return B}}class u{constructor(I,B,H){this._documents=I,this._commands=B,this._provider=H,this._cache=new o.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(I,B){const H=this._documents.getDocument(I),V=await this._provider.provideCodeLenses(H,B);if(!V||B.isCancellationRequested)return;const se=this._cache.add(V),de=new f.DisposableStore;this._disposables.set(se,de);const J={cacheId:se,lenses:[]};for(let pe=0;pe<V.length;pe++)J.lenses.push({cacheId:[se,pe],range:b.Range.from(V[pe].range),command:this._commands.toInternal(V[pe].command,de)});return J}async resolveCodeLens(I,B){const H=I.cacheId&&this._cache.get(...I.cacheId);if(!H)return;let V;if(typeof this._provider.resolveCodeLens!="function"||H.isResolved?V=H:V=await this._provider.resolveCodeLens(H,B),V||(V=H),B.isCancellationRequested)return;const se=I.cacheId&&this._disposables.get(I.cacheId[0]);if(!!se)return I.command=this._commands.toInternal(V.command??u._badCmd,se),I}releaseCodeLenses(I){this._disposables.get(I)?.dispose(),this._disposables.delete(I),this._cache.delete(I)}}u._badCmd={command:"missing",title:"!!MISSING: command!!"};function n(Q){return Array.isArray(Q)?Q.map(b.DefinitionLink.from):Q?[b.DefinitionLink.from(Q)]:[]}class i{constructor(I,B){this._documents=I,this._provider=B}async provideDefinition(I,B,H){const V=this._documents.getDocument(I),se=b.Position.to(B),de=await this._provider.provideDefinition(V,se,H);return n(de)}}class r{constructor(I,B){this._documents=I,this._provider=B}async provideDeclaration(I,B,H){const V=this._documents.getDocument(I),se=b.Position.to(B),de=await this._provider.provideDeclaration(V,se,H);return n(de)}}class t{constructor(I,B){this._documents=I,this._provider=B}async provideImplementation(I,B,H){const V=this._documents.getDocument(I),se=b.Position.to(B),de=await this._provider.provideImplementation(V,se,H);return n(de)}}class c{constructor(I,B){this._documents=I,this._provider=B}async provideTypeDefinition(I,B,H){const V=this._documents.getDocument(I),se=b.Position.to(B),de=await this._provider.provideTypeDefinition(V,se,H);return n(de)}}class _{constructor(I,B){this._documents=I,this._provider=B}async provideHover(I,B,H){const V=this._documents.getDocument(I),se=b.Position.to(B),de=await this._provider.provideHover(V,se,H);if(!(!de||(0,O.isFalsyOrEmpty)(de.contents)))return de.range||(de.range=V.getWordRangeAtPosition(se)),de.range||(de.range=new M.Range(se,se)),b.Hover.from(de)}}class p{constructor(I,B){this._documents=I,this._provider=B}async provideEvaluatableExpression(I,B,H){const V=this._documents.getDocument(I),se=b.Position.to(B),de=await this._provider.provideEvaluatableExpression(V,se,H);if(de)return b.EvaluatableExpression.from(de)}}class C{constructor(I,B){this._documents=I,this._provider=B}async provideInlineValues(I,B,H,V){const se=this._documents.getDocument(I),de=await this._provider.provideInlineValues(se,b.Range.to(B),b.InlineValueContext.to(H),V);if(Array.isArray(de))return de.map(J=>b.InlineValue.from(J))}}class U{constructor(I,B){this._documents=I,this._provider=B}async provideDocumentHighlights(I,B,H){const V=this._documents.getDocument(I),se=b.Position.to(B),de=await this._provider.provideDocumentHighlights(V,se,H);if(Array.isArray(de))return de.map(b.DocumentHighlight.from)}}class W{constructor(I,B){this._documents=I,this._provider=B}async provideLinkedEditingRanges(I,B,H){const V=this._documents.getDocument(I),se=b.Position.to(B),de=await this._provider.provideLinkedEditingRanges(V,se,H);if(de&&Array.isArray(de.ranges))return{ranges:(0,O.coalesce)(de.ranges.map(b.Range.from)),wordPattern:de.wordPattern}}}class L{constructor(I,B){this._documents=I,this._provider=B}async provideReferences(I,B,H,V){const se=this._documents.getDocument(I),de=b.Position.to(B),J=await this._provider.provideReferences(se,de,H,V);if(Array.isArray(J))return J.map(b.location.from)}}class S{constructor(I,B,H,V,se,de,J){this._documents=I,this._commands=B,this._diagnostics=H,this._provider=V,this._logService=se,this._extension=de,this._apiDeprecation=J,this._cache=new o.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(I,B,H,V){const se=this._documents.getDocument(I),de=m.Selection.isISelection(B)?b.Selection.to(B):b.Range.to(B),J=[];for(const Ge of this._diagnostics.getDiagnostics(I))if(de.intersection(Ge.range)&&J.push(Ge)>S._maxCodeActionsPerFile)break;const pe={diagnostics:J,only:H.only?new M.CodeActionKind(H.only):void 0,triggerKind:b.CodeActionTriggerKind.to(H.trigger)},ge=await this._provider.provideCodeActions(se,de,pe,V);if(!(0,O.isNonEmptyArray)(ge)||V.isCancellationRequested)return;const Ne=this._cache.add(ge),Be=new f.DisposableStore;this._disposables.set(Ne,Be);const Je=[];for(let Ge=0;Ge<ge.length;Ge++){const Te=ge[Ge];!Te||(S._isCommand(Te)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Je.push({_isSynthetic:!0,title:Te.title,command:this._commands.toInternal(Te,Be)})):(pe.only&&(Te.kind?pe.only.contains(Te.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${pe.only.value} 'requested but returned code action is of kind '${Te.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${pe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Je.push({cacheId:[Ne,Ge],title:Te.title,command:Te.command&&this._commands.toInternal(Te.command,Be),diagnostics:Te.diagnostics&&Te.diagnostics.map(b.Diagnostic.from),edit:Te.edit&&b.WorkspaceEdit.from(Te.edit,void 0,(0,w.isProposedApiEnabled)(this._extension,"snippetWorkspaceEdit")),kind:Te.kind&&Te.kind.value,isPreferred:Te.isPreferred,disabled:Te.disabled?.reason})))}return{cacheId:Ne,actions:Je}}async resolveCodeAction(I,B){const[H,V]=I,se=this._cache.get(H,V);if(!se||S._isCommand(se)||!this._provider.resolveCodeAction)return;const de=await this._provider.resolveCodeAction(se,B)??se;return de?.edit?b.WorkspaceEdit.from(de.edit,void 0,(0,w.isProposedApiEnabled)(this._extension,"snippetWorkspaceEdit")):void 0}releaseCodeActions(I){this._disposables.get(I)?.dispose(),this._disposables.delete(I),this._cache.delete(I)}static _isCommand(I){return typeof I.command=="string"&&typeof I.title=="string"}}S._maxCodeActionsPerFile=1e3;class z{constructor(I,B,H,V){this._proxy=I,this._documents=B,this._provider=H,this._handle=V}async prepareDocumentPaste(I,B,H,V){if(!this._provider.prepareDocumentPaste)return;const se=this._documents.getDocument(I),de=B.map(pe=>b.Range.to(pe)),J=b.DataTransfer.toDataTransfer(H,()=>{throw new R.NotImplementedError});return await this._provider.prepareDocumentPaste(se,de,J,V),b.DataTransfer.toDataTransferDTO(J)}async providePasteEdits(I,B,H,V,se){const de=this._documents.getDocument(B),J=H.map(Ne=>b.Range.to(Ne)),pe=b.DataTransfer.toDataTransfer(V,async Ne=>(await this._proxy.$resolvePasteFileData(this._handle,I,Ne)).buffer),ge=await this._provider.provideDocumentPasteEdits(de,J,pe,se);if(!!ge)return{insertText:typeof ge.insertText=="string"?ge.insertText:{snippet:ge.insertText.value},additionalEdit:ge.additionalEdit?b.WorkspaceEdit.from(ge.additionalEdit,void 0,!0):void 0}}}class ${constructor(I,B){this._documents=I,this._provider=B}async provideDocumentFormattingEdits(I,B,H){const V=this._documents.getDocument(I),se=await this._provider.provideDocumentFormattingEdits(V,B,H);if(Array.isArray(se))return se.map(b.TextEdit.from)}}class F{constructor(I,B){this._documents=I,this._provider=B}async provideDocumentRangeFormattingEdits(I,B,H,V){const se=this._documents.getDocument(I),de=b.Range.to(B),J=await this._provider.provideDocumentRangeFormattingEdits(se,de,H,V);if(Array.isArray(J))return J.map(b.TextEdit.from)}}class q{constructor(I,B){this._documents=I,this._provider=B,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(I,B,H,V,se){const de=this._documents.getDocument(I),J=b.Position.to(B),pe=await this._provider.provideOnTypeFormattingEdits(de,J,H,V,se);if(Array.isArray(pe))return pe.map(b.TextEdit.from)}}class ie{constructor(I,B){this._provider=I,this._logService=B,this._cache=new o.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(I,B){const H=await this._provider.provideWorkspaceSymbols(I,B);if(!(0,O.isNonEmptyArray)(H))return{symbols:[]};const V=this._cache.add(H),se={cacheId:V,symbols:[]};for(let de=0;de<H.length;de++){const J=H[de];if(!J||!J.name){this._logService.warn("INVALID SymbolInformation",J);continue}se.symbols.push({...b.WorkspaceSymbol.from(J),cacheId:[V,de]})}return se}async resolveWorkspaceSymbol(I,B){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!I.cacheId)return I;const H=this._cache.get(...I.cacheId);if(H){const V=await this._provider.resolveWorkspaceSymbol(H,B);return V&&(0,v.mixin)(I,b.WorkspaceSymbol.from(V),!0)}}releaseWorkspaceSymbols(I){this._cache.delete(I)}}class A{constructor(I,B,H){this._documents=I,this._provider=B,this._logService=H}static supportsResolving(I){return typeof I.prepareRename=="function"}async provideRenameEdits(I,B,H,V){const se=this._documents.getDocument(I),de=b.Position.to(B);try{const J=await this._provider.provideRenameEdits(se,de,H,V);return J?b.WorkspaceEdit.from(J):void 0}catch(J){const pe=A._asMessage(J);return pe?{rejectReason:pe,edits:void 0}:Promise.reject(J)}}async resolveRenameLocation(I,B,H){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const V=this._documents.getDocument(I),se=b.Position.to(B);try{const de=await this._provider.prepareRename(V,se,H);let J,pe;if(M.Range.isRange(de)?(J=de,pe=V.getText(de)):(0,y.isObject)(de)&&(J=de.range,pe=de.placeholder),!J||!pe)return;if(J.start.line>se.line||J.end.line<se.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:b.Range.from(J),text:pe}}catch(de){const J=A._asMessage(de);return J?{rejectReason:J,range:void 0,text:void 0}:Promise.reject(de)}}static _asMessage(I){return typeof I=="string"?I:I instanceof Error&&typeof I.message=="string"?I.message:void 0}}class Z{constructor(I,B){this.resultId=I,this.tokens=B}}class le{constructor(I,B){this._documents=I,this._provider=B,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(I,B,H){const V=this._documents.getDocument(I),se=B!==0?this._previousResults.get(B):null;let de=typeof se?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(V,se.resultId,H):await this._provider.provideDocumentSemanticTokens(V,H);return se&&this._previousResults.delete(B),de?(de=le._fixProvidedSemanticTokens(de),this._send(le._convertToEdits(se,de),de)):null}async releaseDocumentSemanticColoring(I){this._previousResults.delete(I)}static _fixProvidedSemanticTokens(I){return le._isSemanticTokens(I)?le._isCorrectSemanticTokens(I)?I:new M.SemanticTokens(new Uint32Array(I.data),I.resultId):le._isSemanticTokensEdits(I)?le._isCorrectSemanticTokensEdits(I)?I:new M.SemanticTokensEdits(I.edits.map(B=>new M.SemanticTokensEdit(B.start,B.deleteCount,B.data?new Uint32Array(B.data):B.data)),I.resultId):I}static _isSemanticTokens(I){return I&&!!I.data}static _isCorrectSemanticTokens(I){return I.data instanceof Uint32Array}static _isSemanticTokensEdits(I){return I&&Array.isArray(I.edits)}static _isCorrectSemanticTokensEdits(I){for(const B of I.edits)if(!(B.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(I,B){if(!le._isSemanticTokens(B)||!I||!I.tokens)return B;const H=I.tokens,V=H.length,se=B.data,de=se.length;let J=0;const pe=Math.min(V,de);for(;J<pe&&H[J]===se[J];)J++;if(J===V&&J===de)return new M.SemanticTokensEdits([],B.resultId);let ge=0;const Ne=pe-J;for(;ge<Ne&&H[V-ge-1]===se[de-ge-1];)ge++;return new M.SemanticTokensEdits([{start:J,deleteCount:V-J-ge,data:se.subarray(J,de-ge)}],B.resultId)}_send(I,B){if(le._isSemanticTokens(I)){const H=this._nextResultId++;return this._previousResults.set(H,new Z(I.resultId,I.data)),(0,h.encodeSemanticTokensDto)({id:H,type:"full",data:I.data})}if(le._isSemanticTokensEdits(I)){const H=this._nextResultId++;return le._isSemanticTokens(B)?this._previousResults.set(H,new Z(B.resultId,B.data)):this._previousResults.set(H,new Z(I.resultId)),(0,h.encodeSemanticTokensDto)({id:H,type:"delta",deltas:(I.edits||[]).map(V=>({start:V.start,deleteCount:V.deleteCount,data:V.data}))})}return null}}e.DocumentSemanticTokensAdapter=le;class oe{constructor(I,B){this._documents=I,this._provider=B}async provideDocumentRangeSemanticTokens(I,B,H){const V=this._documents.getDocument(I),se=await this._provider.provideDocumentRangeSemanticTokens(V,b.Range.to(B),H);return se?this._send(se):null}_send(I){return(0,h.encodeSemanticTokensDto)({id:0,type:"full",data:I.data})}}e.DocumentRangeSemanticTokensAdapter=oe;class ue{constructor(I,B,H,V,se){this._documents=I,this._commands=B,this._provider=H,this._apiDeprecation=V,this._extension=se,this._cache=new o.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(I){return typeof I.resolveCompletionItem=="function"}async provideCompletionItems(I,B,H,V){const se=this._documents.getDocument(I),de=b.Position.to(B),J=se.getWordRangeAtPosition(de)||new M.Range(de,de),pe=J.with({end:de}),ge=new g.StopWatch(!0),Ne=await this._provider.provideCompletionItems(se,de,V,b.CompletionContext.to(H));if(!Ne||V.isCancellationRequested)return;const Be=Array.isArray(Ne)?new M.CompletionList(Ne):Ne,Je=ue.supportsResolving(this._provider)?this._cache.add(Be.items):this._cache.add([]),Ge=new f.DisposableStore;this._disposables.set(Je,Ge);const Te=[],rt={x:Je,b:Te,a:{replace:b.Range.from(J),insert:b.Range.from(pe)},c:Be.isIncomplete||void 0,d:ge.elapsed()};for(let K=0;K<Be.items.length;K++){const X=Be.items[K],fe=this._convertCompletionItem(X,[Je,K],pe,J);Te.push(fe)}return rt}async resolveCompletionItem(I,B){if(typeof this._provider.resolveCompletionItem!="function")return;const H=this._cache.get(...I);if(!H)return;const V=await this._provider.resolveCompletionItem(H,B);if(!!V)return this._convertCompletionItem(V,I)}releaseCompletionItems(I){this._disposables.get(I)?.dispose(),this._disposables.delete(I),this._cache.delete(I)}_convertCompletionItem(I,B,H,V){const se=this._disposables.get(B[0]);if(!se)throw Error("DisposableStore is missing...");const de={x:B,a:I.label,b:I.kind!==void 0?b.CompletionItemKind.from(I.kind):void 0,n:I.tags&&I.tags.map(b.CompletionItemTag.from),c:I.detail,d:typeof I.documentation=="undefined"?void 0:b.MarkdownString.fromStrict(I.documentation),e:I.sortText!==I.label?I.sortText:void 0,f:I.filterText!==I.label?I.filterText:void 0,g:I.preselect||void 0,i:I.keepWhitespace?1:0,k:I.commitCharacters,l:I.additionalTextEdits&&I.additionalTextEdits.map(b.TextEdit.from),m:this._commands.toInternal(I.command,se)};I.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),de.h=I.textEdit.newText):typeof I.insertText=="string"?de.h=I.insertText:I.insertText instanceof M.SnippetString&&(de.h=I.insertText.value,de.i|=4);let J;return I.textEdit?J=I.textEdit.range:I.range&&(J=I.range),M.Range.isRange(J)?de.j=b.Range.from(J):J&&(!H?.isEqual(J.inserting)||!V?.isEqual(J.replacing))&&(de.j={insert:b.Range.from(J.inserting),replace:b.Range.from(J.replacing)}),de}}class te{async provideInlineCompletions(I,B,H,V){}disposeCompletions(I){}handleDidShowCompletionItem(I,B){}}class Ee extends te{constructor(I,B,H,V){super();this._extension=I,this._documents=B,this._provider=H,this._commands=V,this._references=new ee,this._isAdditionsProposedApiEnabled=(0,w.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[D.InlineCompletionTriggerKind.Automatic]:M.InlineCompletionTriggerKind.Automatic,[D.InlineCompletionTriggerKind.Explicit]:M.InlineCompletionTriggerKind.Invoke}}get supportsHandleDidShowCompletionItem(){return(0,w.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&typeof this._provider.handleDidShowCompletionItem=="function"}async provideInlineCompletions(I,B,H,V){const se=this._documents.getDocument(I),de=b.Position.to(B),J=await this._provider.provideInlineCompletionItems(se,de,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:b.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[H.triggerKind]},V);if(!J||V.isCancellationRequested)return;const pe=Array.isArray(J)?J:J.items,ge=this._isAdditionsProposedApiEnabled?Array.isArray(J)?[]:J.commands||[]:[];let Ne;return{pid:this._references.createReferenceId({dispose(){Ne?.dispose()},items:pe}),items:pe.map((Je,Ge)=>{let Te;Je.command&&(Ne||(Ne=new f.DisposableStore),Te=this._commands.toInternal(Je.command,Ne));const rt=Je.insertText;return{insertText:typeof rt=="string"?rt:{snippet:rt.value},filterText:Je.filterText,range:Je.range?b.Range.from(Je.range):void 0,command:Te,idx:Ge,completeBracketPairs:this._isAdditionsProposedApiEnabled?Je.completeBracketPairs:!1}}),commands:ge.map(Je=>(Ne||(Ne=new f.DisposableStore),this._commands.toInternal(Je,Ne)))}}disposeCompletions(I){this._references.disposeReferenceId(I)?.dispose()}handleDidShowCompletionItem(I,B){const H=this._references.get(I)?.items[B];H&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem(H)}}class be extends te{constructor(I,B,H,V){super();this.extension=I,this._documents=B,this._provider=H,this._commands=V,this._references=new ee,this.isAdditionProposedApiEnabled=(0,w.isProposedApiEnabled)(this.extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[D.InlineCompletionTriggerKind.Automatic]:M.InlineCompletionTriggerKindNew.Automatic,[D.InlineCompletionTriggerKind.Explicit]:M.InlineCompletionTriggerKindNew.Invoke}}async provideInlineCompletions(I,B,H,V){const se=this._documents.getDocument(I),de=b.Position.to(B),J=await this._provider.provideInlineCompletionItems(se,de,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:b.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[H.triggerKind]},V);if(!J||V.isCancellationRequested)return;const pe=Array.isArray(J)?J:J.items,ge=Array.isArray(J)?[]:J.commands||[];let Ne;return{pid:this._references.createReferenceId({dispose(){Ne?.dispose()},items:pe}),items:pe.map((Je,Ge)=>{let Te;Je.command&&(Ne||(Ne=new f.DisposableStore),Te=this._commands.toInternal(Je.command,Ne));const rt=Je.insertText;return{insertText:typeof rt=="string"?rt:{snippet:rt.value},filterText:Je.filterText,range:Je.range?b.Range.from(Je.range):void 0,command:Te,idx:Ge,completeBracketPairs:this.isAdditionProposedApiEnabled?Je.completeBracketPairs:!1}}),commands:ge.map(Je=>(Ne||(Ne=new f.DisposableStore),this._commands.toInternal(Je,Ne)))}}disposeCompletions(I){this._references.disposeReferenceId(I)?.dispose()}handleDidShowCompletionItem(I,B){const H=this._references.get(I)?.items[B];H&&this._provider.handleDidShowCompletionItem&&this.isAdditionProposedApiEnabled&&this._provider.handleDidShowCompletionItem(H)}}class ee{constructor(){this._references=new Map,this._idPool=1}createReferenceId(I){const B=this._idPool++;return this._references.set(B,I),B}disposeReferenceId(I){const B=this._references.get(I);return this._references.delete(I),B}get(I){return this._references.get(I)}}class ve{constructor(I,B){this._documents=I,this._provider=B,this._cache=new o.Cache("SignatureHelp")}async provideSignatureHelp(I,B,H,V){const se=this._documents.getDocument(I),de=b.Position.to(B),J=this.reviveContext(H),pe=await this._provider.provideSignatureHelp(se,de,V,J);if(pe){const ge=this._cache.add([pe]);return{...b.SignatureHelp.from(pe),id:ge}}}reviveContext(I){let B;if(I.activeSignatureHelp){const H=b.SignatureHelp.to(I.activeSignatureHelp),V=this._cache.get(I.activeSignatureHelp.id,0);V?(B=V,B.activeSignature=H.activeSignature,B.activeParameter=H.activeParameter):B=H}return{...I,activeSignatureHelp:B}}releaseSignatureHelp(I){this._cache.delete(I)}}class Ae{constructor(I,B,H,V,se){this._documents=I,this._commands=B,this._provider=H,this._logService=V,this._extension=se,this._cache=new o.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(I,B,H){const V=this._documents.getDocument(I),se=b.Range.to(B),de=await this._provider.provideInlayHints(V,se,H);if(!Array.isArray(de)||de.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${B}`);return}if(H.isCancellationRequested)return;const J=this._cache.add(de);this._disposables.set(J,new f.DisposableStore);const pe={hints:[],cacheId:J};for(let ge=0;ge<de.length;ge++)this._isValidInlayHint(de[ge],se)&&pe.hints.push(this._convertInlayHint(de[ge],[J,ge]));return this._logService.trace(`[InlayHints] ${pe.hints.length} inlay hints from '${this._extension.identifier.value}' for ${B}`),pe}async resolveInlayHint(I,B){if(typeof this._provider.resolveInlayHint!="function")return;const H=this._cache.get(...I);if(!H)return;const V=await this._provider.resolveInlayHint(H,B);if(!!V&&!!this._isValidInlayHint(V))return this._convertInlayHint(V,I)}releaseHints(I){this._disposables.get(I)?.dispose(),this._disposables.delete(I),this._cache.delete(I)}_isValidInlayHint(I,B){return I.label.length===0||Array.isArray(I.label)&&I.label.every(H=>H.value.length===0)?(console.log("INVALID inlay hint, empty label",I),!1):!(B&&!B.contains(I.position))}_convertInlayHint(I,B){const H=this._disposables.get(B[0]);if(!H)throw Error("DisposableStore is missing...");const V={label:"",cacheId:B,tooltip:b.MarkdownString.fromStrict(I.tooltip),position:b.Position.from(I.position),textEdits:I.textEdits&&I.textEdits.map(b.TextEdit.from),kind:I.kind&&b.InlayHintKind.from(I.kind),paddingLeft:I.paddingLeft,paddingRight:I.paddingRight};return typeof I.label=="string"?V.label=I.label:V.label=I.label.map(se=>{const de={label:se.value};return de.tooltip=b.MarkdownString.fromStrict(se.tooltip),M.Location.isLocation(se.location)&&(de.location=b.location.from(se.location)),se.command&&(de.command=this._commands.toInternal(se.command,H)),de}),V}}class Fe{constructor(I,B){this._documents=I,this._provider=B,this._cache=new o.Cache("DocumentLink")}async provideLinks(I,B){const H=this._documents.getDocument(I),V=await this._provider.provideDocumentLinks(H,B);if(!(!Array.isArray(V)||V.length===0)&&!B.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:V.filter(Fe._validateLink).map(b.DocumentLink.from)};{const se=this._cache.add(V),de={links:[],cacheId:se};for(let J=0;J<V.length;J++){if(!Fe._validateLink(V[J]))continue;const pe=b.DocumentLink.from(V[J]);pe.cacheId=[se,J],de.links.push(pe)}return de}}}static _validateLink(I){return I.target&&I.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(I,B){if(typeof this._provider.resolveDocumentLink!="function")return;const H=this._cache.get(...I);if(!H)return;const V=await this._provider.resolveDocumentLink(H,B);if(!(!V||!Fe._validateLink(V)))return b.DocumentLink.from(V)}releaseLinks(I){this._cache.delete(I)}}class $e{constructor(I,B){this._documents=I,this._provider=B}async provideColors(I,B){const H=this._documents.getDocument(I),V=await this._provider.provideDocumentColors(H,B);return Array.isArray(V)?V.map(de=>({color:b.Color.from(de.color),range:b.Range.from(de.range)})):[]}async provideColorPresentations(I,B,H){const V=this._documents.getDocument(I),se=b.Range.to(B.range),de=b.Color.to(B.color),J=await this._provider.provideColorPresentations(de,{document:V,range:se},H);if(!!Array.isArray(J))return J.map(b.ColorPresentation.from)}}class Qe{constructor(I,B){this._documents=I,this._provider=B}async provideFoldingRanges(I,B,H){const V=this._documents.getDocument(I),se=await this._provider.provideFoldingRanges(V,B,H);if(!!Array.isArray(se))return se.map(b.FoldingRange.from)}}class Ie{constructor(I,B,H){this._documents=I,this._provider=B,this._logService=H}async provideSelectionRanges(I,B,H){const V=this._documents.getDocument(I),se=B.map(b.Position.to),de=await this._provider.provideSelectionRanges(V,se,H);if(!(0,O.isNonEmptyArray)(de))return[];if(de.length!==se.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const J=[];for(let pe=0;pe<se.length;pe++){const ge=[];J.push(ge);let Ne=se[pe],Be=de[pe];for(;;){if(!Be.range.contains(Ne))throw new Error("INVALID selection range, must contain the previous range");if(ge.push(b.SelectionRange.from(Be)),!Be.parent)break;Ne=Be.range,Be=Be.parent}}return J}}class Se{constructor(I,B){this._documents=I,this._provider=B,this._idPool=new d.IdGenerator(""),this._cache=new Map}async prepareSession(I,B,H){const V=this._documents.getDocument(I),se=b.Position.to(B),de=await this._provider.prepareCallHierarchy(V,se,H);if(!de)return;const J=this._idPool.nextId();return this._cache.set(J,new Map),Array.isArray(de)?de.map(pe=>this._cacheAndConvertItem(J,pe)):[this._cacheAndConvertItem(J,de)]}async provideCallsTo(I,B,H){const V=this._itemFromCache(I,B);if(!V)throw new Error("missing call hierarchy item");const se=await this._provider.provideCallHierarchyIncomingCalls(V,H);if(!!se)return se.map(de=>({from:this._cacheAndConvertItem(I,de.from),fromRanges:de.fromRanges.map(J=>b.Range.from(J))}))}async provideCallsFrom(I,B,H){const V=this._itemFromCache(I,B);if(!V)throw new Error("missing call hierarchy item");const se=await this._provider.provideCallHierarchyOutgoingCalls(V,H);if(!!se)return se.map(de=>({to:this._cacheAndConvertItem(I,de.to),fromRanges:de.fromRanges.map(J=>b.Range.from(J))}))}releaseSession(I){this._cache.delete(I)}_cacheAndConvertItem(I,B){const H=this._cache.get(I),V=b.CallHierarchyItem.from(B,I,H.size.toString(36));return H.set(V._itemId,B),V}_itemFromCache(I,B){return this._cache.get(I)?.get(B)}}class ke{constructor(I,B){this._documents=I,this._provider=B,this._idPool=new d.IdGenerator(""),this._cache=new Map}async prepareSession(I,B,H){const V=this._documents.getDocument(I),se=b.Position.to(B),de=await this._provider.prepareTypeHierarchy(V,se,H);if(!de)return;const J=this._idPool.nextId();return this._cache.set(J,new Map),Array.isArray(de)?de.map(pe=>this._cacheAndConvertItem(J,pe)):[this._cacheAndConvertItem(J,de)]}async provideSupertypes(I,B,H){const V=this._itemFromCache(I,B);if(!V)throw new Error("missing type hierarchy item");const se=await this._provider.provideTypeHierarchySupertypes(V,H);if(!!se)return se.map(de=>this._cacheAndConvertItem(I,de))}async provideSubtypes(I,B,H){const V=this._itemFromCache(I,B);if(!V)throw new Error("missing type hierarchy item");const se=await this._provider.provideTypeHierarchySubtypes(V,H);if(!!se)return se.map(de=>this._cacheAndConvertItem(I,de))}releaseSession(I){this._cache.delete(I)}_cacheAndConvertItem(I,B){const H=this._cache.get(I),V=b.TypeHierarchyItem.from(B,I,H.size.toString(36));return H.set(V._itemId,B),V}_itemFromCache(I,B){return this._cache.get(I)?.get(B)}}class ae{constructor(I,B,H,V){this._proxy=I,this._documents=B,this._provider=H,this._handle=V}async provideDocumentOnDropEdits(I,B,H,V,se){const de=this._documents.getDocument(B),J=b.Position.to(H),pe=b.DataTransfer.toDataTransfer(V,async Ne=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,I,Ne)).buffer),ge=await this._provider.provideDocumentDropEdits(de,J,pe,se);if(!!ge)return{insertText:typeof ge.insertText=="string"?ge.insertText:{snippet:ge.insertText.value},additionalEdit:ge.additionalEdit?b.WorkspaceEdit.from(ge.additionalEdit,void 0,!0):void 0}}}class ce{constructor(I,B){this.adapter=I,this.extension=B}}class G{constructor(I,B,H,V,se,de,J){this._adapter=new Map,this._uriTransformer=B,this._proxy=I.getProxy(P.MainContext.MainThreadLanguageFeatures),this._documents=H,this._commands=V,this._diagnostics=se,this._logService=de,this._apiDeprecation=J}_transformDocumentSelector(I){return b.DocumentSelector.from(I,this._uriTransformer)}_createDisposable(I){return new M.Disposable(()=>{this._adapter.delete(I),this._proxy.$unregister(I)})}_nextHandle(){return G._handlePool++}async _withAdapter(I,B,H,V,se,de=!1){const J=this._adapter.get(I);if(!J||!(J.adapter instanceof B))return V;const pe=Date.now();de||this._logService.trace(`[${J.extension.identifier.value}] INVOKE provider '${H.toString().replace(/[\r\n]/g,"")}'`);const ge=H(J.adapter,J.extension);return Promise.resolve(ge).catch(Ne=>{(0,R.isCancellationError)(Ne)||(this._logService.error(`[${J.extension.identifier.value}] provider FAILED`),this._logService.error(Ne))}).finally(()=>{de||this._logService.trace(`[${J.extension.identifier.value}] provider DONE after ${Date.now()-pe}ms`)}),k.CancellationToken.isCancellationToken(se)?(0,l.raceCancellationError)(ge,se):ge}_addNewAdapter(I,B){const H=this._nextHandle();return this._adapter.set(H,new ce(I,B)),H}static _extLabel(I){return I.displayName||I.name}registerDocumentSymbolProvider(I,B,H,V){const se=this._addNewAdapter(new s(this._documents,H),I),de=V&&V.label||G._extLabel(I);return this._proxy.$registerDocumentSymbolProvider(se,this._transformDocumentSelector(B),de),this._createDisposable(se)}$provideDocumentSymbols(I,B,H){return this._withAdapter(I,s,V=>V.provideDocumentSymbols(a.URI.revive(B),H),void 0,H)}registerCodeLensProvider(I,B,H){const V=this._nextHandle(),se=typeof H.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(V,new ce(new u(this._documents,this._commands.converter,H),I)),this._proxy.$registerCodeLensSupport(V,this._transformDocumentSelector(B),se);let de=this._createDisposable(V);if(se!==void 0){const J=H.onDidChangeCodeLenses(pe=>this._proxy.$emitCodeLensEvent(se));de=M.Disposable.from(de,J)}return de}$provideCodeLenses(I,B,H){return this._withAdapter(I,u,V=>V.provideCodeLenses(a.URI.revive(B),H),void 0,H)}$resolveCodeLens(I,B,H){return this._withAdapter(I,u,V=>V.resolveCodeLens(B,H),void 0,void 0)}$releaseCodeLenses(I,B){this._withAdapter(I,u,H=>Promise.resolve(H.releaseCodeLenses(B)),void 0,void 0)}registerDefinitionProvider(I,B,H){const V=this._addNewAdapter(new i(this._documents,H),I);return this._proxy.$registerDefinitionSupport(V,this._transformDocumentSelector(B)),this._createDisposable(V)}$provideDefinition(I,B,H,V){return this._withAdapter(I,i,se=>se.provideDefinition(a.URI.revive(B),H,V),[],V)}registerDeclarationProvider(I,B,H){const V=this._addNewAdapter(new r(this._documents,H),I);return this._proxy.$registerDeclarationSupport(V,this._transformDocumentSelector(B)),this._createDisposable(V)}$provideDeclaration(I,B,H,V){return this._withAdapter(I,r,se=>se.provideDeclaration(a.URI.revive(B),H,V),[],V)}registerImplementationProvider(I,B,H){const V=this._addNewAdapter(new t(this._documents,H),I);return this._proxy.$registerImplementationSupport(V,this._transformDocumentSelector(B)),this._createDisposable(V)}$provideImplementation(I,B,H,V){return this._withAdapter(I,t,se=>se.provideImplementation(a.URI.revive(B),H,V),[],V)}registerTypeDefinitionProvider(I,B,H){const V=this._addNewAdapter(new c(this._documents,H),I);return this._proxy.$registerTypeDefinitionSupport(V,this._transformDocumentSelector(B)),this._createDisposable(V)}$provideTypeDefinition(I,B,H,V){return this._withAdapter(I,c,se=>se.provideTypeDefinition(a.URI.revive(B),H,V),[],V)}registerHoverProvider(I,B,H,V){const se=this._addNewAdapter(new _(this._documents,H),I);return this._proxy.$registerHoverProvider(se,this._transformDocumentSelector(B)),this._createDisposable(se)}$provideHover(I,B,H,V){return this._withAdapter(I,_,se=>se.provideHover(a.URI.revive(B),H,V),void 0,V)}registerEvaluatableExpressionProvider(I,B,H,V){const se=this._addNewAdapter(new p(this._documents,H),I);return this._proxy.$registerEvaluatableExpressionProvider(se,this._transformDocumentSelector(B)),this._createDisposable(se)}$provideEvaluatableExpression(I,B,H,V){return this._withAdapter(I,p,se=>se.provideEvaluatableExpression(a.URI.revive(B),H,V),void 0,V)}registerInlineValuesProvider(I,B,H,V){const se=typeof H.onDidChangeInlineValues=="function"?this._nextHandle():void 0,de=this._addNewAdapter(new C(this._documents,H),I);this._proxy.$registerInlineValuesProvider(de,this._transformDocumentSelector(B),se);let J=this._createDisposable(de);if(se!==void 0){const pe=H.onDidChangeInlineValues(ge=>this._proxy.$emitInlineValuesEvent(se));J=M.Disposable.from(J,pe)}return J}$provideInlineValues(I,B,H,V,se){return this._withAdapter(I,C,de=>de.provideInlineValues(a.URI.revive(B),H,V,se),void 0,se)}registerDocumentHighlightProvider(I,B,H){const V=this._addNewAdapter(new U(this._documents,H),I);return this._proxy.$registerDocumentHighlightProvider(V,this._transformDocumentSelector(B)),this._createDisposable(V)}$provideDocumentHighlights(I,B,H,V){return this._withAdapter(I,U,se=>se.provideDocumentHighlights(a.URI.revive(B),H,V),void 0,V)}registerLinkedEditingRangeProvider(I,B,H){const V=this._addNewAdapter(new W(this._documents,H),I);return this._proxy.$registerLinkedEditingRangeProvider(V,this._transformDocumentSelector(B)),this._createDisposable(V)}$provideLinkedEditingRanges(I,B,H,V){return this._withAdapter(I,W,async se=>{const de=await se.provideLinkedEditingRanges(a.URI.revive(B),H,V);if(de)return{ranges:de.ranges,wordPattern:de.wordPattern?G._serializeRegExp(de.wordPattern):void 0}},void 0,V)}registerReferenceProvider(I,B,H){const V=this._addNewAdapter(new L(this._documents,H),I);return this._proxy.$registerReferenceSupport(V,this._transformDocumentSelector(B)),this._createDisposable(V)}$provideReferences(I,B,H,V,se){return this._withAdapter(I,L,de=>de.provideReferences(a.URI.revive(B),H,V,se),void 0,se)}registerCodeActionProvider(I,B,H,V){const se=new f.DisposableStore,de=this._addNewAdapter(new S(this._documents,this._commands.converter,this._diagnostics,H,this._logService,I,this._apiDeprecation),I);return this._proxy.$registerQuickFixSupport(de,this._transformDocumentSelector(B),{providedKinds:V?.providedCodeActionKinds?.map(J=>J.value),documentation:V?.documentation?.map(J=>({kind:J.kind.value,command:this._commands.converter.toInternal(J.command,se)}))},G._extLabel(I),Boolean(H.resolveCodeAction)),se.add(this._createDisposable(de)),se}$provideCodeActions(I,B,H,V,se){return this._withAdapter(I,S,de=>de.provideCodeActions(a.URI.revive(B),H,V,se),void 0,se)}$resolveCodeAction(I,B,H){return this._withAdapter(I,S,V=>V.resolveCodeAction(B,H),void 0,void 0)}$releaseCodeActions(I,B){this._withAdapter(I,S,H=>Promise.resolve(H.releaseCodeActions(B)),void 0,void 0)}registerDocumentFormattingEditProvider(I,B,H){const V=this._addNewAdapter(new $(this._documents,H),I);return this._proxy.$registerDocumentFormattingSupport(V,this._transformDocumentSelector(B),I.identifier,I.displayName||I.name),this._createDisposable(V)}$provideDocumentFormattingEdits(I,B,H,V){return this._withAdapter(I,$,se=>se.provideDocumentFormattingEdits(a.URI.revive(B),H,V),void 0,V)}registerDocumentRangeFormattingEditProvider(I,B,H){const V=this._addNewAdapter(new F(this._documents,H),I);return this._proxy.$registerRangeFormattingSupport(V,this._transformDocumentSelector(B),I.identifier,I.displayName||I.name),this._createDisposable(V)}$provideDocumentRangeFormattingEdits(I,B,H,V,se){return this._withAdapter(I,F,de=>de.provideDocumentRangeFormattingEdits(a.URI.revive(B),H,V,se),void 0,se)}registerOnTypeFormattingEditProvider(I,B,H,V){const se=this._addNewAdapter(new q(this._documents,H),I);return this._proxy.$registerOnTypeFormattingSupport(se,this._transformDocumentSelector(B),V,I.identifier),this._createDisposable(se)}$provideOnTypeFormattingEdits(I,B,H,V,se,de){return this._withAdapter(I,q,J=>J.provideOnTypeFormattingEdits(a.URI.revive(B),H,V,se,de),void 0,de)}registerWorkspaceSymbolProvider(I,B){const H=this._addNewAdapter(new ie(B,this._logService),I);return this._proxy.$registerNavigateTypeSupport(H,typeof B.resolveWorkspaceSymbol=="function"),this._createDisposable(H)}$provideWorkspaceSymbols(I,B,H){return this._withAdapter(I,ie,V=>V.provideWorkspaceSymbols(B,H),{symbols:[]},H)}$resolveWorkspaceSymbol(I,B,H){return this._withAdapter(I,ie,V=>V.resolveWorkspaceSymbol(B,H),void 0,void 0)}$releaseWorkspaceSymbols(I,B){this._withAdapter(I,ie,H=>H.releaseWorkspaceSymbols(B),void 0,void 0)}registerRenameProvider(I,B,H){const V=this._addNewAdapter(new A(this._documents,H,this._logService),I);return this._proxy.$registerRenameSupport(V,this._transformDocumentSelector(B),A.supportsResolving(H)),this._createDisposable(V)}$provideRenameEdits(I,B,H,V,se){return this._withAdapter(I,A,de=>de.provideRenameEdits(a.URI.revive(B),H,V,se),void 0,se)}$resolveRenameLocation(I,B,H,V){return this._withAdapter(I,A,se=>se.resolveRenameLocation(a.URI.revive(B),H,V),void 0,V)}registerDocumentSemanticTokensProvider(I,B,H,V){const se=this._addNewAdapter(new le(this._documents,H),I),de=typeof H.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(se,this._transformDocumentSelector(B),V,de);let J=this._createDisposable(se);if(de){const pe=H.onDidChangeSemanticTokens(ge=>this._proxy.$emitDocumentSemanticTokensEvent(de));J=M.Disposable.from(J,pe)}return J}$provideDocumentSemanticTokens(I,B,H,V){return this._withAdapter(I,le,se=>se.provideDocumentSemanticTokens(a.URI.revive(B),H,V),null,V)}$releaseDocumentSemanticTokens(I,B){this._withAdapter(I,le,H=>H.releaseDocumentSemanticColoring(B),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(I,B,H,V){const se=this._addNewAdapter(new oe(this._documents,H),I);return this._proxy.$registerDocumentRangeSemanticTokensProvider(se,this._transformDocumentSelector(B),V),this._createDisposable(se)}$provideDocumentRangeSemanticTokens(I,B,H,V){return this._withAdapter(I,oe,se=>se.provideDocumentRangeSemanticTokens(a.URI.revive(B),H,V),null,V)}registerCompletionItemProvider(I,B,H,V){const se=this._addNewAdapter(new ue(this._documents,this._commands.converter,H,this._apiDeprecation,I),I);return this._proxy.$registerCompletionsProvider(se,this._transformDocumentSelector(B),V,ue.supportsResolving(H),`${I.identifier.value}(${V.join("")})`),this._createDisposable(se)}$provideCompletionItems(I,B,H,V,se){return this._withAdapter(I,ue,de=>de.provideCompletionItems(a.URI.revive(B),H,V,se),void 0,se)}$resolveCompletionItem(I,B,H){return this._withAdapter(I,ue,V=>V.resolveCompletionItem(B,H),void 0,H)}$releaseCompletionItems(I,B){this._withAdapter(I,ue,H=>H.releaseCompletionItems(B),void 0,void 0)}registerInlineCompletionsProvider(I,B,H){const V=new Ee(I,this._documents,H,this._commands.converter),se=this._addNewAdapter(V,I);return this._proxy.$registerInlineCompletionsSupport(se,this._transformDocumentSelector(B),V.supportsHandleDidShowCompletionItem),this._createDisposable(se)}registerInlineCompletionsProviderNew(I,B,H){const V=this._addNewAdapter(new be(I,this._documents,H,this._commands.converter),I);return this._proxy.$registerInlineCompletionsSupport(V,this._transformDocumentSelector(B),!0),this._createDisposable(V)}$provideInlineCompletions(I,B,H,V,se){return this._withAdapter(I,te,de=>de.provideInlineCompletions(a.URI.revive(B),H,V,se),void 0,se)}$handleInlineCompletionDidShow(I,B,H){this._withAdapter(I,te,async V=>{V.handleDidShowCompletionItem(B,H)},void 0,void 0)}$freeInlineCompletionsList(I,B){this._withAdapter(I,te,async H=>{H.disposeCompletions(B)},void 0,void 0)}registerSignatureHelpProvider(I,B,H,V){const se=Array.isArray(V)?{triggerCharacters:V,retriggerCharacters:[]}:V,de=this._addNewAdapter(new ve(this._documents,H),I);return this._proxy.$registerSignatureHelpProvider(de,this._transformDocumentSelector(B),se),this._createDisposable(de)}$provideSignatureHelp(I,B,H,V,se){return this._withAdapter(I,ve,de=>de.provideSignatureHelp(a.URI.revive(B),H,V,se),void 0,se)}$releaseSignatureHelp(I,B){this._withAdapter(I,ve,H=>H.releaseSignatureHelp(B),void 0,void 0)}registerInlayHintsProvider(I,B,H){const V=typeof H.onDidChangeInlayHints=="function"?this._nextHandle():void 0,se=this._addNewAdapter(new Ae(this._documents,this._commands.converter,H,this._logService,I),I);this._proxy.$registerInlayHintsProvider(se,this._transformDocumentSelector(B),typeof H.resolveInlayHint=="function",V,G._extLabel(I));let de=this._createDisposable(se);if(V!==void 0){const J=H.onDidChangeInlayHints(pe=>this._proxy.$emitInlayHintsEvent(V));de=M.Disposable.from(de,J)}return de}$provideInlayHints(I,B,H,V){return this._withAdapter(I,Ae,se=>se.provideInlayHints(a.URI.revive(B),H,V),void 0,V)}$resolveInlayHint(I,B,H){return this._withAdapter(I,Ae,V=>V.resolveInlayHint(B,H),void 0,H)}$releaseInlayHints(I,B){this._withAdapter(I,Ae,H=>H.releaseHints(B),void 0,void 0)}registerDocumentLinkProvider(I,B,H){const V=this._addNewAdapter(new Fe(this._documents,H),I);return this._proxy.$registerDocumentLinkProvider(V,this._transformDocumentSelector(B),typeof H.resolveDocumentLink=="function"),this._createDisposable(V)}$provideDocumentLinks(I,B,H){return this._withAdapter(I,Fe,V=>V.provideLinks(a.URI.revive(B),H),void 0,H,B.scheme==="output")}$resolveDocumentLink(I,B,H){return this._withAdapter(I,Fe,V=>V.resolveLink(B,H),void 0,void 0,!0)}$releaseDocumentLinks(I,B){this._withAdapter(I,Fe,H=>H.releaseLinks(B),void 0,void 0,!0)}registerColorProvider(I,B,H){const V=this._addNewAdapter(new $e(this._documents,H),I);return this._proxy.$registerDocumentColorProvider(V,this._transformDocumentSelector(B)),this._createDisposable(V)}$provideDocumentColors(I,B,H){return this._withAdapter(I,$e,V=>V.provideColors(a.URI.revive(B),H),[],H)}$provideColorPresentations(I,B,H,V){return this._withAdapter(I,$e,se=>se.provideColorPresentations(a.URI.revive(B),H,V),void 0,V)}registerFoldingRangeProvider(I,B,H){const V=this._nextHandle(),se=typeof H.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(V,new ce(new Qe(this._documents,H),I)),this._proxy.$registerFoldingRangeProvider(V,this._transformDocumentSelector(B),se);let de=this._createDisposable(V);if(se!==void 0){const J=H.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(se));de=M.Disposable.from(de,J)}return de}$provideFoldingRanges(I,B,H,V){return this._withAdapter(I,Qe,se=>se.provideFoldingRanges(a.URI.revive(B),H,V),void 0,V)}registerSelectionRangeProvider(I,B,H){const V=this._addNewAdapter(new Ie(this._documents,H,this._logService),I);return this._proxy.$registerSelectionRangeProvider(V,this._transformDocumentSelector(B)),this._createDisposable(V)}$provideSelectionRanges(I,B,H,V){return this._withAdapter(I,Ie,se=>se.provideSelectionRanges(a.URI.revive(B),H,V),[],V)}registerCallHierarchyProvider(I,B,H){const V=this._addNewAdapter(new Se(this._documents,H),I);return this._proxy.$registerCallHierarchyProvider(V,this._transformDocumentSelector(B)),this._createDisposable(V)}$prepareCallHierarchy(I,B,H,V){return this._withAdapter(I,Se,se=>Promise.resolve(se.prepareSession(a.URI.revive(B),H,V)),void 0,V)}$provideCallHierarchyIncomingCalls(I,B,H,V){return this._withAdapter(I,Se,se=>se.provideCallsTo(B,H,V),void 0,V)}$provideCallHierarchyOutgoingCalls(I,B,H,V){return this._withAdapter(I,Se,se=>se.provideCallsFrom(B,H,V),void 0,V)}$releaseCallHierarchy(I,B){this._withAdapter(I,Se,H=>Promise.resolve(H.releaseSession(B)),void 0,void 0)}registerTypeHierarchyProvider(I,B,H){const V=this._addNewAdapter(new ke(this._documents,H),I);return this._proxy.$registerTypeHierarchyProvider(V,this._transformDocumentSelector(B)),this._createDisposable(V)}$prepareTypeHierarchy(I,B,H,V){return this._withAdapter(I,ke,se=>Promise.resolve(se.prepareSession(a.URI.revive(B),H,V)),void 0,V)}$provideTypeHierarchySupertypes(I,B,H,V){return this._withAdapter(I,ke,se=>se.provideSupertypes(B,H,V),void 0,V)}$provideTypeHierarchySubtypes(I,B,H,V){return this._withAdapter(I,ke,se=>se.provideSubtypes(B,H,V),void 0,V)}$releaseTypeHierarchy(I,B){this._withAdapter(I,ke,H=>Promise.resolve(H.releaseSession(B)),void 0,void 0)}registerDocumentOnDropEditProvider(I,B,H){const V=this._nextHandle();return this._adapter.set(V,new ce(new ae(this._proxy,this._documents,H,V),I)),this._proxy.$registerDocumentOnDropEditProvider(V,this._transformDocumentSelector(B)),this._createDisposable(V)}$provideDocumentOnDropEdits(I,B,H,V,se,de){return this._withAdapter(I,ae,J=>Promise.resolve(J.provideDocumentOnDropEdits(B,a.URI.revive(H),V,se,de)),void 0,void 0)}registerDocumentPasteEditProvider(I,B,H,V){const se=this._nextHandle();return this._adapter.set(se,new ce(new z(this._proxy,this._documents,H,se),I)),this._proxy.$registerPasteEditProvider(se,this._transformDocumentSelector(B),!!H.prepareDocumentPaste,V.pasteMimeTypes),this._createDisposable(se)}$prepareDocumentPaste(I,B,H,V,se){return this._withAdapter(I,z,de=>de.prepareDocumentPaste(a.URI.revive(B),H,V,se),void 0,se)}$providePasteEdits(I,B,H,V,se,de){return this._withAdapter(I,z,J=>J.providePasteEdits(B,a.URI.revive(H),V,se,de),void 0,de)}static _serializeRegExp(I){return{pattern:I.source,flags:(0,E.regExpFlags)(I)}}static _serializeIndentationRule(I){return{decreaseIndentPattern:G._serializeRegExp(I.decreaseIndentPattern),increaseIndentPattern:G._serializeRegExp(I.increaseIndentPattern),indentNextLinePattern:I.indentNextLinePattern?G._serializeRegExp(I.indentNextLinePattern):void 0,unIndentedLinePattern:I.unIndentedLinePattern?G._serializeRegExp(I.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(I){return{beforeText:G._serializeRegExp(I.beforeText),afterText:I.afterText?G._serializeRegExp(I.afterText):void 0,previousLineText:I.previousLineText?G._serializeRegExp(I.previousLineText):void 0,action:I.action}}static _serializeOnEnterRules(I){return I.map(G._serializeOnEnterRule)}setLanguageConfiguration(I,B,H){const{wordPattern:V}=H;if(V&&(0,E.regExpLeadsToEndlessLoop)(V))throw new Error(`Invalid language configuration: wordPattern '${V}' is not allowed to match the empty string.`);V?this._documents.setWordDefinitionFor(B,V):this._documents.setWordDefinitionFor(B,void 0),H.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",I,"Do not use."),H.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",I,"Do not use.");const se=this._nextHandle(),de={comments:H.comments,brackets:H.brackets,wordPattern:H.wordPattern?G._serializeRegExp(H.wordPattern):void 0,indentationRules:H.indentationRules?G._serializeIndentationRule(H.indentationRules):void 0,onEnterRules:H.onEnterRules?G._serializeOnEnterRules(H.onEnterRules):void 0,__electricCharacterSupport:H.__electricCharacterSupport,__characterPairSupport:H.__characterPairSupport};return this._proxy.$setLanguageConfiguration(se,B,de),this._createDisposable(se)}$setWordDefinitions(I){for(const B of I)this._documents.setWordDefinitionFor(B.languageId,new RegExp(B.regexSource,B.regexFlags))}}e.ExtHostLanguageFeatures=G,G._handlePool=0}),define(ye[205],De([1,0,4,8,6,29,14,7]),function(ne,e,a,v,b,M,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class E{constructor(O,y,m,k){this._documents=y,this._commands=m,this._uriTransformer=k,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=O.getProxy(a.MainContext.MainThreadLanguages)}$acceptLanguageIds(O){this._languageIds=O}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(O,y){await this._proxy.$changeLanguage(O,y);const m=this._documents.getDocumentData(O);if(!m)throw new Error(`document '${O.toString()}' NOT found`);return m.document}async tokenAtPosition(O,y){const m=O.version,k=v.Position.from(y),f=await this._proxy.$tokensAtPosition(O.uri,k),h={type:b.StandardTokenType.Other,range:O.getWordRangeAtPosition(y)??new b.Range(y.line,y.character,y.line,y.character)};if(!f)return h;const d={range:v.Range.to(f.range),type:v.TokenType.to(f.type)};return!d.range.contains(y)||m!==O.version?h:d}createLanguageStatusItem(O,y,m){const k=this._handlePool++,f=this._proxy,h=this._ids,d=`${O.identifier.value}/${y}`;if(h.has(d))throw new Error(`LanguageStatusItem with id '${y}' ALREADY exists`);h.add(d);const o={selector:m,id:y,name:O.displayName??O.name,severity:b.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let g;const R=new P.DisposableStore,l=()=>{g?.dispose(),g=(0,D.disposableTimeout)(()=>{R.clear(),this._proxy.$setLanguageStatus(k,{id:d,name:o.name??O.displayName??O.name,source:O.displayName??O.name,selector:v.DocumentSelector.from(o.selector,this._uriTransformer),label:o.text,detail:o.detail??"",severity:o.severity===b.LanguageStatusSeverity.Error?M.default.Error:o.severity===b.LanguageStatusSeverity.Warning?M.default.Warning:M.default.Info,command:o.command&&this._commands.toInternal(o.command,R),accessibilityInfo:o.accessibilityInformation,busy:o.busy})},0)},w={dispose(){R.dispose(),g?.dispose(),f.$removeLanguageStatus(k),h.delete(d)},get id(){return o.id},get name(){return o.name},set name(s){o.name=s,l()},get selector(){return o.selector},set selector(s){o.selector=s,l()},get text(){return o.text},set text(s){o.text=s,l()},get detail(){return o.detail},set detail(s){o.detail=s,l()},get severity(){return o.severity},set severity(s){o.severity=s,l()},get accessibilityInformation(){return o.accessibilityInformation},set accessibilityInformation(s){o.accessibilityInformation=s,l()},get command(){return o.command},set command(s){o.command=s,l()},get busy(){return o.busy},set busy(s){o.busy=s,l()}};return l(),w}}e.ExtHostLanguages=E}),define(ye[206],De([1,0,15,4,28,13,5]),function(ne,e,a,v,b,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let P=class extends a.AbstractLoggerService{constructor(O,y){const m=new D.Emitter;super(y.logLevel,m.event);this._proxy=O.getProxy(v.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(m)}$setLevel(O){this._onDidChangeLogLevel.fire(O)}doCreateLogger(O,y,m){return new E(this._proxy,O,y,m)}};P=ze([xe(0,M.IExtHostRpcService),xe(1,b.IExtHostInitDataService)],P),e.ExtHostLoggerService=P;class E extends a.AbstractMessageLogger{constructor(O,y,m,k){super(k?.always);this.proxy=O,this.file=y,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(m),this.proxy.$createLogger(y,k).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(O,y){const m=[[O,y]];this.isLoggerCreated?this.doLog(m):this.buffer.push(...m)}doLog(O){this.proxy.$log(this.file,O)}}}),define(ye[207],De([1,0,4,15,24]),function(ne,e,a,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function M(P){return P&&P.title}let D=class{constructor(E,T){this._logService=T,this._proxy=E.getProxy(a.MainContext.MainThreadMessageService)}showMessage(E,T,O,y,m){const k={source:{identifier:E.identifier,label:E.displayName||E.name}};let f;typeof y=="string"||M(y)?f=[y,...m]:(k.modal=y?.modal,k.useCustom=y?.useCustom,k.detail=y?.detail,f=m),k.useCustom&&(0,b.checkProposedApiEnabled)(E,"resolvers");const h=[];for(let d=0;d<f.length;d++){const o=f[d];if(typeof o=="string")h.push({title:o,handle:d,isCloseAffordance:!1});else if(typeof o=="object"){const{title:g,isCloseAffordance:R}=o;h.push({title:g,isCloseAffordance:!!R,handle:d})}else this._logService.warn("Invalid message item:",o)}return this._proxy.$showMessage(T,O,k,h).then(d=>{if(typeof d=="number")return f[d]})}};D=ze([xe(1,v.ILogService)],D),e.ExtHostMessageService=D}),define(ye[208],De([1,0,23,5,96,7,25,9,10,2,61,4,36,8,6,40,176,91]),function(ne,e,a,v,b,M,D,P,E,T,O,y,m,k,f,h,d,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class g{constructor(l,w,s,u,n){this._textDocumentsAndEditors=s,this._textDocuments=u,this._extensionStoragePaths=n,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new D.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new v.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new v.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new v.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new v.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new O.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=l.getProxy(y.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=l.getProxy(y.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=l.getProxy(y.MainContext.MainThreadNotebookEditors),this._commandsConverter=w.converter,w.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===12){const r=i.notebookEditor?.notebookUri,t=i.cell.handle,_=this._documents.get(r)?.getCell(t);if(_)return _.apiCell}return i}}),g._registerApiCommands(w)}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(l=>l.apiEditor)}getEditorById(l){const w=this._editors.get(l);if(!w)throw new Error(`unknown text editor: ${l}. known editors: ${[...this._editors.keys()]} `);return w}getIdByEditor(l){for(const[w,s]of this._editors)if(s.apiEditor===l)return w}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(l,w){const s=this._documents.get(l);if(!s&&!w)throw new Error(`NO notebook document for '${l}'`);return s}_getProviderData(l){const w=this._notebookContentProviders.get(l);if(!w)throw new Error(`NO provider for '${l}'`);return w}registerNotebookContentProvider(l,w,s,u,n){if((0,P.isFalsyOrWhitespace)(w))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(w))throw new Error(`Notebook provider for '${w}' already registered`);this._notebookContentProviders.set(w,{extension:l,provider:s});let i;return s.onDidChangeNotebookContentOptions&&(i=s.onDidChangeNotebookContentOptions(()=>{const r=k.NotebookDocumentContentOptions.from(s.options);this._notebookProxy.$updateNotebookProviderOptions(w,r)})),this._notebookProxy.$registerNotebookProvider({id:l.identifier,location:l.extensionLocation},w,k.NotebookDocumentContentOptions.from(u),g._convertNotebookRegistrationData(l,n)),new f.Disposable(()=>{i?.dispose(),this._notebookContentProviders.delete(w),this._notebookProxy.$unregisterNotebookProvider(w)})}static _convertNotebookRegistrationData(l,w){if(!w)return;const s=w.filenamePattern.map(u=>k.NotebookExclusiveDocumentPattern.from(u)).filter(u=>u!==void 0);if(w.filenamePattern&&!s){console.warn(`Notebook content provider view options file name pattern is invalid ${w.filenamePattern}`);return}return{extension:l.identifier,providerDisplayName:l.displayName||l.name,displayName:w.displayName,filenamePattern:s,exclusive:w.exclusive||!1}}registerNotebookCellStatusBarItemProvider(l,w,s){const u=g._notebookStatusBarItemProviderHandlePool++,n=typeof s.onDidChangeCellStatusBarItems=="function"?g._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(u,s),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(u,n,w);let i;return n!==void 0&&(i=s.onDidChangeCellStatusBarItems(r=>this._notebookProxy.$emitCellStatusBarEvent(n))),new f.Disposable(()=>{this._notebookStatusBarItemProviders.delete(u),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(u,n),i?.dispose()})}async createNotebookDocument(l){const w=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:l.viewType,content:l.content&&k.NotebookData.from(l.content)});return T.URI.revive(w)}async openNotebookDocument(l){const w=this._documents.get(l);if(w)return w.apiNotebook;const s=await this._notebookDocumentsProxy.$tryOpenNotebook(l),u=this._documents.get(T.URI.revive(s));return(0,E.assertIsDefined)(u?.apiNotebook)}async showNotebookDocument(l,w){T.URI.isUri(l)&&(l=await this.openNotebookDocument(l));let s;typeof w=="object"?s={position:k.ViewColumn.from(w.viewColumn),preserveFocus:w.preserveFocus,selections:w.selections&&w.selections.map(k.NotebookRange.from),pinned:typeof w.preview=="boolean"?!w.preview:void 0}:s={preserveFocus:!1};const u=await this._notebookEditorsProxy.$tryShowNotebookDocument(l.uri,l.notebookType,s),n=u&&this._editors.get(u)?.apiEditor;if(n)return n;throw u?new Error(`Could NOT open editor for "${l.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${l.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(l,w,s,u){const n=this._notebookStatusBarItemProviders.get(l),i=T.URI.revive(w),r=this._documents.get(i);if(!r||!n)return;const t=r.getCellFromIndex(s);if(!t)return;const c=await n.provideCellStatusBarItems(t.apiCell,u);if(!c)return;const _=new M.DisposableStore,p=this._statusBarCache.add([_]),U=(Array.isArray(c)?c:[c]).map(W=>k.NotebookStatusBarItem.from(W,this._commandsConverter,_));return{cacheId:p,items:U}}$releaseNotebookCellStatusBarItems(l){this._statusBarCache.delete(l)}registerNotebookSerializer(l,w,s,u,n){if((0,P.isFalsyOrWhitespace)(w))throw new Error("viewType cannot be empty or just whitespace");const i=this._handlePool++;return this._notebookSerializer.set(i,s),this._notebookProxy.$registerNotebookSerializer(i,{id:l.identifier,location:l.extensionLocation},w,k.NotebookDocumentContentOptions.from(u),g._convertNotebookRegistrationData(l,n)),(0,M.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(i)})}async $dataToNotebook(l,w,s){const u=this._notebookSerializer.get(l);if(!u)throw new Error("NO serializer found");const n=await u.deserializeNotebook(w.buffer,s);return new h.SerializableObjectWithBuffers(k.NotebookData.from(n))}async $notebookToData(l,w,s){const u=this._notebookSerializer.get(l);if(!u)throw new Error("NO serializer found");const n=await u.serializeNotebook(k.NotebookData.to(w.value),s);return a.VSBuffer.wrap(n)}async $openNotebook(l,w,s,u,n){const{provider:i}=this._getProviderData(l),r=await i.openNotebook(T.URI.revive(w),{backupId:s,untitledDocumentData:u?.buffer},n);return new h.SerializableObjectWithBuffers({metadata:r.metadata??Object.create(null),cells:r.cells.map(k.NotebookCellData.from)})}async $saveNotebook(l,w,s){const u=this.getNotebookDocument(T.URI.revive(w)),{provider:n}=this._getProviderData(l);return await n.saveNotebook(u.apiNotebook,s),!0}async $saveNotebookAs(l,w,s,u){const n=this.getNotebookDocument(T.URI.revive(w)),{provider:i}=this._getProviderData(l);return await i.saveNotebookAs(T.URI.revive(s),n.apiNotebook,u),!0}async $backupNotebook(l,w,s){const u=this.getNotebookDocument(T.URI.revive(w)),n=this._getProviderData(l),i=this._extensionStoragePaths.workspaceValue(n.extension)??this._extensionStoragePaths.globalValue(n.extension),r=String((0,b.hash)([u.uri.toString(),this._backupIdPool++])),t=T.URI.joinPath(i,r),c=await n.provider.backupNotebook(u.apiNotebook,{destination:t},s);return u.updateBackup(c),c.id}_createExtHostEditor(l,w,s){if(this._editors.has(w))throw new Error(`editor with id ALREADY EXSIST: ${w}`);const u=new o.ExtHostNotebookEditor(w,this._notebookEditorsProxy,l,s.visibleRanges.map(k.NotebookRange.to),s.selections.map(k.NotebookRange.to),typeof s.viewColumn=="number"?k.ViewColumn.to(s.viewColumn):void 0);this._editors.set(w,u)}$acceptDocumentAndEditorsDelta(l){if(l.value.removedDocuments)for(const s of l.value.removedDocuments){const u=T.URI.revive(s),n=this._documents.get(u);n&&(n.dispose(),this._documents.delete(u),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:n.apiNotebook.getCells().map(i=>i.document.uri)}),this._onDidCloseNotebookDocument.fire(n.apiNotebook));for(const i of this._editors.values())i.notebookData.uri.toString()===u.toString()&&this._editors.delete(i.id)}if(l.value.addedDocuments){const s=[];for(const u of l.value.addedDocuments){const n=T.URI.revive(u.uri);if(this._documents.has(n))throw new Error(`adding EXISTING notebook ${n} `);const i=new d.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,n,u);s.push(...u.cells.map(r=>d.ExtHostCell.asModelAddData(i.apiNotebook,r))),this._documents.get(n)?.dispose(),this._documents.set(n,i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:s}),this._onDidOpenNotebookDocument.fire(i.apiNotebook)}}if(l.value.addedEditors)for(const s of l.value.addedEditors){if(this._editors.has(s.id))return;const u=T.URI.revive(s.documentUri),n=this._documents.get(u);n&&this._createExtHostEditor(n,s.id,s)}const w=[];if(l.value.removedEditors)for(const s of l.value.removedEditors){const u=this._editors.get(s);u&&(this._editors.delete(s),this._activeNotebookEditor?.id===u.id&&(this._activeNotebookEditor=void 0),w.push(u))}if(l.value.visibleEditors){this._visibleNotebookEditors=l.value.visibleEditors.map(u=>this._editors.get(u)).filter(u=>!!u);const s=new Set;this._visibleNotebookEditors.forEach(u=>s.add(u.id));for(const u of this._editors.values()){const n=s.has(u.id);u._acceptVisibility(n)}this._visibleNotebookEditors=[...this._editors.values()].map(u=>u).filter(u=>u.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}l.value.newActiveEditor===null?this._activeNotebookEditor=void 0:l.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(l.value.newActiveEditor)),l.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(l){const w=m.ApiCommandArgument.String.with("notebookType","A notebook type"),s=new m.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[w,new m.ApiCommandArgument("data","Bytes to convert to data",n=>n instanceof Uint8Array,n=>a.VSBuffer.wrap(n))],new m.ApiCommandResult("Notebook Data",n=>k.NotebookData.to(n.value))),u=new m.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[w,new m.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",n=>!0,n=>new h.SerializableObjectWithBuffers(k.NotebookData.from(n)))],new m.ApiCommandResult("Bytes",n=>n.buffer));l.registerApiCommand(s),l.registerApiCommand(u)}}e.ExtHostNotebookController=g,g._notebookStatusBarItemProviderHandlePool=0}),define(ye[209],De([1,0,16,14,20,5,7,25,2,27,15,4,36,8,6,64,169,24,40]),function(ne,e,a,v,b,M,D,P,E,T,O,y,m,k,f,h,d,o,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let R=class{constructor(i,r,t,c,_){this._initData=r,this._extHostNotebook=t,this._commands=c,this._logService=_,this._activeExecutions=new P.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new M.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=i.getProxy(y.MainContext.MainThreadNotebookKernels);const p=new m.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new m.ApiCommandArgument("options","Select kernel options",C=>!0,C=>{if(C&&"notebookEditor"in C&&"id"in C){const U=this._extHostNotebook.getIdByEditor(C.notebookEditor);return{id:C.id,extension:C.extension,notebookEditorId:U}}else if(C&&"notebookEditor"in C){const U=this._extHostNotebook.getIdByEditor(C.notebookEditor);if(U===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${C.notebookEditor.document.uri.toString()}`);return{notebookEditorId:U}}return C})],m.ApiCommandResult.Void);this._commands.registerApiCommand(p)}createNotebookController(i,r,t,c,_,p){for(const ue of this._kernelData.values())if(ue.controller.id===r&&T.ExtensionIdentifier.equals(i.identifier,ue.extensionId))throw new Error(`notebook controller with id '${r}' ALREADY exist`);const C=this._handlePool++,U=this;this._logService.trace(`NotebookController[${C}], CREATED by ${i.identifier.value}, ${r}`);const W=()=>console.warn(`NO execute handler from notebook controller '${F.id}' of extension: '${i.identifier}'`);let L=!1;const S=new D.DisposableStore,z=new M.Emitter,$=new M.Emitter,F={id:u(i.identifier,r),notebookType:t,extensionId:i.identifier,extensionLocation:i.extensionLocation,label:c||i.identifier.value,preloads:p?p.map(k.NotebookRendererScript.from):[]};let q=_??W,ie;this._proxy.$addKernel(C,F).catch(ue=>{console.log(ue),L=!0});let A=0;const Z=()=>{if(L)return;const ue=++A;Promise.resolve().then(()=>{ue===A&&this._proxy.$updateKernel(C,F)})},le=new P.ResourceMap,oe={get id(){return r},get notebookType(){return F.notebookType},onDidChangeSelectedNotebooks:z.event,get label(){return F.label},set label(ue){F.label=ue??i.displayName??i.name,Z()},get detail(){return F.detail??""},set detail(ue){F.detail=ue,Z()},get description(){return F.description??""},set description(ue){F.description=ue,Z()},get kind(){return(0,o.checkProposedApiEnabled)(i,"notebookControllerKind"),F.kind??""},set kind(ue){(0,o.checkProposedApiEnabled)(i,"notebookControllerKind"),F.kind=ue,Z()},get supportedLanguages(){return F.supportedLanguages},set supportedLanguages(ue){F.supportedLanguages=ue,Z()},get supportsExecutionOrder(){return F.supportsExecutionOrder??!1},set supportsExecutionOrder(ue){F.supportsExecutionOrder=ue,Z()},get rendererScripts(){return F.preloads?F.preloads.map(k.NotebookRendererScript.to):[]},get executeHandler(){return q},set executeHandler(ue){q=ue??W},get interruptHandler(){return ie},set interruptHandler(ue){ie=ue,F.supportsInterrupt=Boolean(ue),Z()},createNotebookCellExecution(ue){if(L)throw new Error("notebook controller is DISPOSED");if(!le.has(ue.notebook.uri))throw U._logService.trace(`NotebookController[${C}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(le.keys()).map(te=>te.toString())),new Error(`notebook controller is NOT associated to notebook: ${ue.notebook.uri.toString()}`);return U._createNotebookCellExecution(ue,u(i.identifier,this.id))},dispose:()=>{L||(this._logService.trace(`NotebookController[${C}], DISPOSED`),L=!0,this._kernelData.delete(C),S.dispose(),z.dispose(),$.dispose(),this._proxy.$removeKernel(C))},updateNotebookAffinity(ue,te){U._proxy.$updateNotebookPriority(C,ue.uri,te)},onDidReceiveMessage:$.event,postMessage(ue,te){return(0,o.checkProposedApiEnabled)(i,"notebookMessaging"),U._proxy.$postMessage(C,te&&U._extHostNotebook.getIdByEditor(te),ue)},asWebviewUri(ue){return(0,o.checkProposedApiEnabled)(i,"notebookMessaging"),(0,h.asWebviewUri)(ue,U._initData.remote)}};return this._kernelData.set(C,{extensionId:i.identifier,controller:oe,onDidReceiveMessage:$,onDidChangeSelection:z,associatedNotebooks:le}),oe}getIdByController(i){for(const[r,t]of this._kernelData)if(t.controller===i)return u(t.extensionId,i.id);return null}$acceptNotebookAssociation(i,r,t){const c=this._kernelData.get(i);if(c){const _=this._extHostNotebook.getNotebookDocument(E.URI.revive(r));t?c.associatedNotebooks.set(_.uri,!0):c.associatedNotebooks.delete(_.uri),this._logService.trace(`NotebookController[${i}] ASSOCIATE notebook`,_.uri.toString(),t),c.onDidChangeSelection.fire({selected:t,notebook:_.apiNotebook})}}async $executeCells(i,r,t){const c=this._kernelData.get(i);if(!c)return;const _=this._extHostNotebook.getNotebookDocument(E.URI.revive(r)),p=[];for(const C of t){const U=_.getCell(C);U&&p.push(U.apiCell)}try{this._logService.trace(`NotebookController[${i}] EXECUTE cells`,_.uri.toString(),p.length),await c.controller.executeHandler.call(c.controller,p,_.apiNotebook,c.controller)}catch(C){this._logService.error(`NotebookController[${i}] execute cells FAILED`,C),console.error(C)}}async $cancelCells(i,r,t){const c=this._kernelData.get(i);if(!c)return;const _=this._extHostNotebook.getNotebookDocument(E.URI.revive(r));if(c.controller.interruptHandler)await c.controller.interruptHandler.call(c.controller,_.apiNotebook);else for(const p of t){const C=_.getCell(p);C&&this._activeExecutions.get(C.uri)?.cancel()}}$acceptKernelMessageFromRenderer(i,r,t){const c=this._kernelData.get(i);if(!c)return;const _=this._extHostNotebook.getEditorById(r);c.onDidReceiveMessage.fire(Object.freeze({editor:_.apiEditor,message:t}))}$cellExecutionChanged(i,r,t){const _=this._extHostNotebook.getNotebookDocument(E.URI.revive(i)).getCell(r);if(_){const p=t?k.NotebookCellExecutionState.to(t):f.NotebookCellExecutionState.Idle;p!==void 0&&this._onDidChangeCellExecutionState.fire({cell:_.apiCell,state:p})}}_createNotebookCellExecution(i,r){if(i.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const c=this._extHostNotebook.getNotebookDocument(i.notebook.uri).getCellFromApiCell(i);if(!c)throw new Error("invalid cell");if(this._activeExecutions.has(c.uri))throw new Error(`duplicate execution for ${c.uri}`);const _=new w(r,c,this._proxy);this._activeExecutions.set(c.uri,_);const p=_.onDidChangeState(()=>{_.state===l.Resolved&&(_.dispose(),p.dispose(),this._activeExecutions.delete(c.uri))});return _.asApiObject()}};R=ze([xe(4,O.ILogService)],R),e.ExtHostNotebookKernels=R;var l;(function(n){n[n.Init=0]="Init",n[n.Started=1]="Started",n[n.Resolved=2]="Resolved"})(l||(l={}));class w extends D.Disposable{constructor(i,r,t){super();this._cell=r,this._proxy=t,this._handle=w.HANDLE++,this._onDidChangeState=new M.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=l.Init,this._tokenSource=this._register(new b.CancellationTokenSource),this._collector=new s(10,c=>this.update(c)),this._executionOrder=r.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,i,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(i){await this._collector.addItem(i)}async update(i){const r=Array.isArray(i)?i:[i];return this._proxy.$updateExecution(this._handle,new g.SerializableObjectWithBuffers(r))}verifyStateForOutput(){if(this._state===l.Init)throw new Error("Must call start before modifying cell output");if(this._state===l.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(i){let r=this._cell;if(i&&(r=this._cell.notebook.getCellFromApiCell(i)),!r)throw new Error("INVALID cell");return r.handle}validateAndConvertOutputs(i){return i.map(r=>{const t=f.NotebookCellOutput.ensureUniqueMimeTypes(r.items,!0);return t===r.items?k.NotebookCellOutput.from(r):k.NotebookCellOutput.from({items:t,id:r.id,metadata:r.metadata})})}async updateOutputs(i,r,t){const c=this.cellIndexToHandle(r),_=this.validateAndConvertOutputs((0,a.asArray)(i));return this.updateSoon({editType:d.CellExecutionUpdateType.Output,cellHandle:c,append:t,outputs:_})}async updateOutputItems(i,r,t){return i=f.NotebookCellOutput.ensureUniqueMimeTypes((0,a.asArray)(i),!0),this.updateSoon({editType:d.CellExecutionUpdateType.OutputItems,items:i.map(k.NotebookCellOutputItem.from),outputId:r.id,append:t})}asApiObject(){const i=this;return Object.freeze({get token(){return i._tokenSource.token},get cell(){return i._cell.apiCell},get executionOrder(){return i._executionOrder},set executionOrder(t){i._executionOrder=t,i.update([{editType:d.CellExecutionUpdateType.ExecutionState,executionOrder:i._executionOrder}])},start(t){if(i._state===l.Resolved||i._state===l.Started)throw new Error("Cannot call start again");i._state=l.Started,i._onDidChangeState.fire(),i.update({editType:d.CellExecutionUpdateType.ExecutionState,runStartTime:t})},end(t,c){if(i._state===l.Resolved)throw new Error("Cannot call resolve twice");i._state=l.Resolved,i._onDidChangeState.fire(),i._collector.flush(),i._proxy.$completeExecution(i._handle,new g.SerializableObjectWithBuffers({runEndTime:c,lastRunSuccess:t}))},clearOutput(t){return i.verifyStateForOutput(),i.updateOutputs([],t,!1)},appendOutput(t,c){return i.verifyStateForOutput(),i.updateOutputs(t,c,!0)},replaceOutput(t,c){return i.verifyStateForOutput(),i.updateOutputs(t,c,!1)},appendOutputItems(t,c){return i.verifyStateForOutput(),i.updateOutputItems(t,c,!0)},replaceOutputItems(t,c){return i.verifyStateForOutput(),i.updateOutputItems(t,c,!1)}})}}w.HANDLE=0;class s{constructor(i,r){this.delay=i,this.callback=r,this.batch=[],this.startedTimer=Date.now()}addItem(i){return this.batch.push(i),this.currentDeferred||(this.currentDeferred=new v.DeferredPromise,this.startedTimer=Date.now(),(0,v.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const i=this.currentDeferred;this.currentDeferred=void 0;const r=this.batch;return this.batch=[],this.callback(r).finally(()=>i.complete())}}function u(n,i){return`${n.value}/${i}`}e.createKernelId=u}),define(ye[210],De([1,0,5,4,91]),function(ne,e,a,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class M{constructor(P,E){this._extHostNotebook=E,this._rendererMessageEmitters=new Map,this.proxy=P.getProxy(v.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(P,E,T){const O=this._extHostNotebook.getEditorById(P);this._rendererMessageEmitters.get(E)?.fire({editor:O.apiEditor,message:T})}createRendererMessaging(P,E){if(!P.contributes?.notebookRenderer?.some(O=>O.id===E))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${E})`);return{onDidReceiveMessage:(O,y,m)=>this.getOrCreateEmitterFor(E).event(O,y,m),postMessage:(O,y)=>{b.ExtHostNotebookEditor.apiEditorsToExtHost.has(O)&&([O,y]=[y,O]);const m=y&&b.ExtHostNotebookEditor.apiEditorsToExtHost.get(y);return this.proxy.$postMessage(m?.id,E,O)}}}getOrCreateEmitterFor(P){let E=this._rendererMessageEmitters.get(P);return E||(E=new a.Emitter({onLastListenerRemove:()=>{E?.dispose(),this._rendererMessageEmitters.delete(P)}}),this._rendererMessageEmitters.set(P,E),E)}}e.ExtHostNotebookRenderers=M}),define(ye[211],De([1,0,20,5,7,4,2,6,11,16,29,60]),function(ne,e,a,v,b,M,D,P,E,T,O,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function m(k,f,h){const d=k.getProxy(M.MainContext.MainThreadQuickOpen);class o{constructor(r,t){this._sessions=new Map,this._instances=0,this._workspace=r,this._commands=t}showQuickPick(r,t,c=a.CancellationToken.None){this._onDidSelectItem=void 0;const _=Promise.resolve(r),p=++this._instances,C=d.$show(p,{title:t?.title,placeHolder:t?.placeHolder,matchOnDescription:t?.matchOnDescription,matchOnDetail:t?.matchOnDetail,ignoreFocusLost:t?.ignoreFocusOut,canPickMany:t?.canPickMany},c),U={},W=C.then(()=>U);return Promise.race([W,_]).then(L=>{if(L!==U)return _.then(S=>{const z=[];for(let $=0;$<S.length;$++){const F=S[$];typeof F=="string"?z.push({label:F,handle:$}):F.kind===P.QuickPickItemKind.Separator?z.push({type:"separator",label:F.label}):z.push({label:F.label,description:F.description,detail:F.detail,picked:F.picked,alwaysShow:F.alwaysShow,handle:$})}return t&&typeof t.onDidSelectItem=="function"&&(this._onDidSelectItem=$=>{t.onDidSelectItem(S[$])}),d.$setItems(p,z),C.then($=>{if(typeof $=="number")return S[$];if(Array.isArray($))return $.map(F=>S[F])})})}).then(void 0,L=>{if(!(0,E.isCancellationError)(L))return d.$setError(p,L),Promise.reject(L)})}$onItemSelected(r){this._onDidSelectItem?.(r)}showInput(r,t=a.CancellationToken.None){return this._validateInput=r?.validateInput,d.$input(r,typeof this._validateInput=="function",t).then(void 0,c=>{if(!(0,E.isCancellationError)(c))return Promise.reject(c)})}async $validateInput(r){if(!this._validateInput)return;const t=await this._validateInput(r);if(!t||typeof t=="string")return t;let c;switch(t.severity){case P.InputBoxValidationSeverity.Info:c=O.default.Info;break;case P.InputBoxValidationSeverity.Warning:c=O.default.Warning;break;case P.InputBoxValidationSeverity.Error:c=O.default.Error;break;default:c=t.message?O.default.Error:O.default.Ignore;break}return{content:t.message,severity:c}}async showWorkspaceFolderPick(r,t=a.CancellationToken.None){const c=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[r]);if(!c)return;const _=await this._workspace.getWorkspaceFolders2();if(!!_)return _.find(p=>p.uri.toString()===c.uri.toString())}createQuickPick(r){const t=new u(r,()=>this._sessions.delete(t._id));return this._sessions.set(t._id,t),t}createInputBox(r){const t=new n(r,()=>this._sessions.delete(t._id));return this._sessions.set(t._id,t),t}$onDidChangeValue(r,t){this._sessions.get(r)?._fireDidChangeValue(t)}$onDidAccept(r){this._sessions.get(r)?._fireDidAccept()}$onDidChangeActive(r,t){const c=this._sessions.get(r);c instanceof u&&c._fireDidChangeActive(t)}$onDidChangeSelection(r,t){const c=this._sessions.get(r);c instanceof u&&c._fireDidChangeSelection(t)}$onDidTriggerButton(r,t){this._sessions.get(r)?._fireDidTriggerButton(t)}$onDidTriggerItemButton(r,t,c){const _=this._sessions.get(r);_ instanceof u&&_._fireDidTriggerItemButton(t,c)}$onDidHide(r){this._sessions.get(r)?._fireDidHide()}}class g{constructor(r,t){this._extensionId=r,this._onDidDispose=t,this._id=u._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new v.Emitter,this._onDidChangeValueEmitter=new v.Emitter,this._onDidTriggerButtonEmitter=new v.Emitter,this._onDidHideEmitter=new v.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(r){this._title=r,this.update({title:r})}get step(){return this._steps}set step(r){this._steps=r,this.update({step:r})}get totalSteps(){return this._totalSteps}set totalSteps(r){this._totalSteps=r,this.update({totalSteps:r})}get enabled(){return this._enabled}set enabled(r){this._enabled=r,this.update({enabled:r})}get busy(){return this._busy}set busy(r){this._busy=r,this.update({busy:r})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(r){this._ignoreFocusOut=r,this.update({ignoreFocusOut:r})}get value(){return this._value}set value(r){this._value=r,this.update({value:r})}get placeholder(){return this._placeholder}set placeholder(r){this._placeholder=r,this.update({placeholder:r})}get buttons(){return this._buttons}set buttons(r){this._buttons=r.slice(),this._handlesToButtons.clear(),r.forEach((t,c)=>{const _=t===P.QuickInputButtons.Back?-1:c;this._handlesToButtons.set(_,t)}),this.update({buttons:r.map((t,c)=>({...s(t),tooltip:t.tooltip,handle:t===P.QuickInputButtons.Back?-1:c}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(r){this._value=r,this._onDidChangeValueEmitter.fire(r)}_fireDidTriggerButton(r){const t=this._handlesToButtons.get(r);t&&this._onDidTriggerButtonEmitter.fire(t)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,b.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),d.$dispose(this._id))}update(r){if(!this._disposed){for(const t of Object.keys(r)){const c=r[t];this._pendingUpdate[t]=c===void 0?null:c}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){d.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}g._nextId=1;function R(i){if(i instanceof P.ThemeIcon)return{id:i.id};const r=w(i),t=l(i);return{dark:typeof r=="string"?D.URI.file(r):r,light:typeof t=="string"?D.URI.file(t):t}}function l(i){return typeof i=="object"&&"light"in i?i.light:i}function w(i){return typeof i=="object"&&"dark"in i?i.dark:i}function s(i){const r=R(i.iconPath);let t,c;return"id"in r?c=y.ThemeIcon.asClassName(r):t=r,{iconPath:t,iconClass:c}}class u extends g{constructor(r,t){super(r.identifier,t);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new v.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new v.Emitter,this._onDidTriggerItemButtonEmitter=new v.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(r){this._items=r.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),r.forEach((c,_)=>{this._handlesToItems.set(_,c),this._itemsToHandles.set(c,_)});const t=[];for(let c=0;c<r.length;c++){const _=r[c];_.kind===P.QuickPickItemKind.Separator?t.push({type:"separator",label:_.label}):t.push({handle:c,label:_.label,description:_.description,detail:_.detail,picked:_.picked,alwaysShow:_.alwaysShow,buttons:_.buttons?.map((p,C)=>({...s(p),tooltip:p.tooltip,handle:C}))})}this.update({items:t})}get canSelectMany(){return this._canSelectMany}set canSelectMany(r){this._canSelectMany=r,this.update({canSelectMany:r})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(r){this._matchOnDescription=r,this.update({matchOnDescription:r})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(r){this._matchOnDetail=r,this.update({matchOnDetail:r})}get sortByLabel(){return this._sortByLabel}set sortByLabel(r){this._sortByLabel=r,this.update({sortByLabel:r})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(r){this._keepScrollPosition=r,this.update({keepScrollPosition:r})}get activeItems(){return this._activeItems}set activeItems(r){this._activeItems=r.filter(t=>this._itemsToHandles.has(t)),this.update({activeItems:this._activeItems.map(t=>this._itemsToHandles.get(t))})}get selectedItems(){return this._selectedItems}set selectedItems(r){this._selectedItems=r.filter(t=>this._itemsToHandles.has(t)),this.update({selectedItems:this._selectedItems.map(t=>this._itemsToHandles.get(t))})}_fireDidChangeActive(r){const t=(0,T.coalesce)(r.map(c=>this._handlesToItems.get(c)));this._activeItems=t,this._onDidChangeActiveEmitter.fire(t)}_fireDidChangeSelection(r){const t=(0,T.coalesce)(r.map(c=>this._handlesToItems.get(c)));this._selectedItems=t,this._onDidChangeSelectionEmitter.fire(t)}_fireDidTriggerItemButton(r,t){const c=this._handlesToItems.get(r);if(!c||!c.buttons||!c.buttons.length)return;const _=c.buttons[t];_&&this._onDidTriggerItemButtonEmitter.fire({button:_,item:c})}}class n extends g{constructor(r,t){super(r.identifier,t);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(r){this._password=r,this.update({password:r})}get prompt(){return this._prompt}set prompt(r){this._prompt=r,this.update({prompt:r})}get validationMessage(){return this._validationMessage}set validationMessage(r){this._validationMessage=r,r?typeof r=="string"?this.update({validationMessage:r,severity:O.default.Error}):this.update({validationMessage:r.message,severity:r.severity??O.default.Error}):this.update({validationMessage:void 0,severity:O.default.Ignore})}}return new o(f,h)}e.createExtHostQuickOpen=m});var Ye=this&&this.__classPrivateFieldSet||function(ne,e,a,v,b){if(v==="m")throw new TypeError("Private method is not writable");if(v==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return v==="a"?b.call(ne,a):b?b.value=a:e.set(ne,a),a},Oe=this&&this.__classPrivateFieldGet||function(ne,e,a,v){if(a==="a"&&!v)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!v:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?v:a==="a"?v.call(ne):v?v.value:e.get(ne)};define(ye[212],De([1,0,2,5,54,7,14,4,16,117,15,27,60,8,24]),function(ne,e,a,v,b,M,D,P,E,T,O,y,m,k,f){"use strict";var h,d;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function o(_){if(_)return typeof _.iconPath=="string"?a.URI.file(_.iconPath):a.URI.isUri(_.iconPath)||m.ThemeIcon.isThemeIcon(_.iconPath)?_.iconPath:void 0}function g(_,p){if(!_.iconPath&&!p.iconPath)return 0;if(_.iconPath){if(!p.iconPath)return 1}else return-1;const C=typeof _.iconPath=="string"?_.iconPath:a.URI.isUri(_.iconPath)?_.iconPath.fsPath:_.iconPath.id,U=typeof p.iconPath=="string"?p.iconPath:a.URI.isUri(p.iconPath)?p.iconPath.fsPath:p.iconPath.id;return(0,T.comparePaths)(C,U)}function R(_,p){let C=0;if(_.strikeThrough!==p.strikeThrough)return _.strikeThrough?1:-1;if(_.faded!==p.faded)return _.faded?1:-1;if(_.tooltip!==p.tooltip)return(_.tooltip||"").localeCompare(p.tooltip||"");if(C=g(_,p),C!==0)return C;if(_.light&&p.light)C=g(_.light,p.light);else{if(_.light)return 1;if(p.light)return-1}if(C!==0)return C;if(_.dark&&p.dark)C=g(_.dark,p.dark);else{if(_.dark)return 1;if(p.dark)return-1}return C}function l(_,p){if(_.command!==p.command)return _.command<p.command?-1:1;if(_.title!==p.title)return _.title<p.title?-1:1;if(_.tooltip!==p.tooltip){if(_.tooltip!==void 0&&p.tooltip!==void 0)return _.tooltip<p.tooltip?-1:1;if(_.tooltip!==void 0)return 1;if(p.tooltip!==void 0)return-1}if(_.arguments===p.arguments)return 0;if(_.arguments)if(p.arguments){if(_.arguments.length!==p.arguments.length)return _.arguments.length-p.arguments.length}else return 1;else return-1;for(let C=0;C<_.arguments.length;C++){const U=_.arguments[C],W=p.arguments[C];if(U!==W)return U<W?-1:1}return 0}function w(_,p){let C=(0,T.comparePaths)(_.resourceUri.fsPath,p.resourceUri.fsPath,!0);if(C!==0)return C;if(_.command&&p.command)C=l(_.command,p.command);else{if(_.command)return 1;if(p.command)return-1}if(C!==0)return C;if(_.decorations&&p.decorations)C=R(_.decorations,p.decorations);else{if(_.decorations)return 1;if(p.decorations)return-1}return C}function s(_,p){for(let C=0;C<_.length;C++)if(_[C]!==p[C])return!1;return!0}function u(_,p){return _.command===p.command&&_.title===p.title&&_.tooltip===p.tooltip&&(_.arguments&&p.arguments?s(_.arguments,p.arguments):_.arguments===p.arguments)}function n(_,p){return(0,E.equals)(_,p,u)}class i{constructor(p,C,U){this._extension=p,this._sourceControlHandle=U,h.set(this,void 0),this._value="",this._onDidChange=new v.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,Ye(this,h,C,"f")}get value(){return this._value}set value(p){p=p??"",Oe(this,h,"f").$setInputBoxValue(this._sourceControlHandle,p),this.updateValue(p)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(p){Oe(this,h,"f").$setInputBoxPlaceholder(this._sourceControlHandle,p),this._placeholder=p}get validateInput(){return(0,f.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(p){if((0,f.checkProposedApiEnabled)(this._extension,"scmValidation"),p&&typeof p!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=p,Oe(this,h,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!p)}get enabled(){return this._enabled}set enabled(p){p=!!p,this._enabled!==p&&(this._enabled=p,Oe(this,h,"f").$setInputBoxEnablement(this._sourceControlHandle,p))}get visible(){return this._visible}set visible(p){p=!!p,this._visible!==p&&(this._visible=p,Oe(this,h,"f").$setInputBoxVisibility(this._sourceControlHandle,p))}showValidationMessage(p,C){(0,f.checkProposedApiEnabled)(this._extension,"scmValidation"),Oe(this,h,"f").$showValidationMessage(this._sourceControlHandle,p,C)}$onInputBoxValueChange(p){this.updateValue(p)}updateValue(p){this._value=p,this._onDidChange.fire(p)}}e.ExtHostSCMInputBox=i,h=new WeakMap;class r{constructor(p,C,U,W,L){this._proxy=p,this._commands=C,this._sourceControlHandle=U,this._id=W,this._label=L,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new v.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new v.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=r._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(p){this._label=p,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,p)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(p){this._hideWhenEmpty=p,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(p){this._resourceStates=[...p],this._onDidUpdateResourceStates.fire()}getResourceState(p){return this._resourceStatesMap.get(p)}$executeResourceCommand(p,C){const U=this._resourceStatesCommandsMap.get(p);return U?(0,D.asPromise)(()=>this._commands.executeCommand(U.command,...U.arguments||[],C)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const p=[...this._resourceStates].sort(w),U=(0,E.sortedDiff)(this._resourceSnapshot,p,w).map(S=>{const z=S.toInsert.map($=>{const F=this._resourceHandlePool++;this._resourceStatesMap.set(F,$);const q=$.resourceUri;let ie;if($.command)if($.command.command==="vscode.open"||$.command.command==="vscode.diff"){const ve=new M.DisposableStore;ie=this._commands.converter.toInternal($.command,ve),this._resourceStatesDisposablesMap.set(F,ve)}else this._resourceStatesCommandsMap.set(F,$.command);const A=o($.decorations),Z=$.decorations&&o($.decorations.light)||A,le=$.decorations&&o($.decorations.dark)||A,oe=[Z,le],ue=$.decorations&&$.decorations.tooltip||"",te=$.decorations&&!!$.decorations.strikeThrough,Ee=$.decorations&&!!$.decorations.faded,be=$.contextValue||"";return{rawResource:[F,q,oe,ue,te,Ee,be,ie],handle:F}});return{start:S.start,deleteCount:S.deleteCount,toInsert:z}}),W=U.map(({start:S,deleteCount:z,toInsert:$})=>[S,z,$.map(F=>F.rawResource)]),L=U.reverse();for(const{start:S,deleteCount:z,toInsert:$}of L){const F=$.map(ie=>ie.handle),q=this._handlesSnapshot.splice(S,z,...F);for(const ie of q)this._resourceStatesMap.delete(ie),this._resourceStatesCommandsMap.delete(ie),this._resourceStatesDisposablesMap.get(ie)?.dispose(),this._resourceStatesDisposablesMap.delete(ie)}return this._resourceSnapshot=p,W}dispose(){this._disposed=!0,this._onDidDispose.fire()}}r._handlePool=0;class t{constructor(p,C,U,W,L,S){this._extension=p,this._commands=U,this._id=W,this._label=L,this._rootUri=S,d.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new M.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new M.MutableDisposable,this._statusBarDisposables=new M.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new v.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=t._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,Ye(this,d,C,"f"),this._inputBox=new i(p,Oe(this,d,"f"),this.handle),Oe(this,d,"f").$registerSourceControl(this.handle,W,L,S)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(p){this._count!==p&&(this._count=p,Oe(this,d,"f").$updateSourceControl(this.handle,{count:p}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(p){this._quickDiffProvider=p,Oe(this,d,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!p})}get commitTemplate(){return this._commitTemplate}set commitTemplate(p){p!==this._commitTemplate&&(this._commitTemplate=p,Oe(this,d,"f").$updateSourceControl(this.handle,{commitTemplate:p}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(p){this._acceptInputDisposables.value=new M.DisposableStore,this._acceptInputCommand=p;const C=this._commands.converter.toInternal(p,this._acceptInputDisposables.value);Oe(this,d,"f").$updateSourceControl(this.handle,{acceptInputCommand:C})}get actionButton(){return(0,f.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(p){(0,f.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new M.DisposableStore,this._actionButton=p;const C=p!==void 0?{command:this._commands.converter.toInternal(p.command,this._actionButtonDisposables.value),secondaryCommands:p.secondaryCommands?.map(U=>U.map(W=>this._commands.converter.toInternal(W,this._actionButtonDisposables.value))),description:p.description,enabled:p.enabled}:void 0;Oe(this,d,"f").$updateSourceControl(this.handle,{actionButton:C??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(p){if(this._statusBarCommands&&p&&n(this._statusBarCommands,p))return;this._statusBarDisposables.value=new M.DisposableStore,this._statusBarCommands=p;const C=(p||[]).map(U=>this._commands.converter.toInternal(U,this._statusBarDisposables.value));Oe(this,d,"f").$updateSourceControl(this.handle,{statusBarCommands:C})}get selected(){return this._selected}createResourceGroup(p,C){const U=new r(Oe(this,d,"f"),this._commands,this.handle,p,C),W=v.Event.once(U.onDidDispose)(()=>this.createdResourceGroups.delete(U));return this.createdResourceGroups.set(U,W),this.eventuallyAddResourceGroups(),U}eventuallyAddResourceGroups(){const p=[],C=[];for(const[U,W]of this.createdResourceGroups){W.dispose();const L=U.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(U),this.eventuallyUpdateResourceStates()});v.Event.once(U.onDidDispose)(()=>{this.updatedResourceGroups.delete(U),L.dispose(),this._groups.delete(U.handle),Oe(this,d,"f").$unregisterGroup(this.handle,U.handle)}),p.push([U.handle,U.id,U.label,U.features]);const S=U._takeResourceStateSnapshot();S.length>0&&C.push([U.handle,S]),this._groups.set(U.handle,U)}Oe(this,d,"f").$registerGroups(this.handle,p,C),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const p=[];this.updatedResourceGroups.forEach(C=>{const U=C._takeResourceStateSnapshot();U.length!==0&&p.push([C.handle,U])}),p.length>0&&Oe(this,d,"f").$spliceResourceStates(this.handle,p),this.updatedResourceGroups.clear()}getResourceGroup(p){return this._groups.get(p)}setSelectionState(p){this._selected=p,this._onDidChangeSelection.fire(p)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(p=>p.dispose()),Oe(this,d,"f").$unregisterSourceControl(this.handle)}}d=new WeakMap,t._handlePool=0,ze([(0,b.debounce)(100)],t.prototype,"eventuallyAddResourceGroups",null),ze([(0,b.debounce)(100)],t.prototype,"eventuallyUpdateResourceStates",null);let c=class Yi{constructor(p,C,U){this._commands=C,this.logService=U,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new v.Emitter,this._proxy=p.getProxy(P.MainContext.MainThreadSCM),this._telemetry=p.getProxy(P.MainContext.MainThreadTelemetry),C.registerArgumentProcessor({processArgument:W=>{if(W&&W.$mid===3){const L=this._sourceControls.get(W.sourceControlHandle);if(!L)return W;const S=L.getResourceGroup(W.groupHandle);return S?S.getResourceState(W.handle):W}else if(W&&W.$mid===4){const L=this._sourceControls.get(W.sourceControlHandle);return L?L.getResourceGroup(W.groupHandle):W}else if(W&&W.$mid===5){const L=this._sourceControls.get(W.handle);return L||W}return W}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(p,C,U,W){this.logService.trace("ExtHostSCM#createSourceControl",p.identifier.value,C,U,W),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:p.identifier.value});const L=Yi._handlePool++,S=new t(p,this._proxy,this._commands,C,U,W);this._sourceControls.set(L,S);const z=this._sourceControlsByExtension.get(y.ExtensionIdentifier.toKey(p.identifier))||[];return z.push(S),this._sourceControlsByExtension.set(y.ExtensionIdentifier.toKey(p.identifier),z),S}getLastInputBox(p){this.logService.trace("ExtHostSCM#getLastInputBox",p.identifier.value);const C=this._sourceControlsByExtension.get(y.ExtensionIdentifier.toKey(p.identifier)),U=C&&C[C.length-1];return U&&U.inputBox}$provideOriginalResource(p,C,U){const W=a.URI.revive(C);this.logService.trace("ExtHostSCM#$provideOriginalResource",p,W.toString());const L=this._sourceControls.get(p);return!L||!L.quickDiffProvider||!L.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,D.asPromise)(()=>L.quickDiffProvider.provideOriginalResource(W,U)).then(S=>S||null)}$onInputBoxValueChange(p,C){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",p);const U=this._sourceControls.get(p);return U&&U.inputBox.$onInputBoxValueChange(C),Promise.resolve(void 0)}$executeResourceCommand(p,C,U,W){this.logService.trace("ExtHostSCM#$executeResourceCommand",p,C,U);const L=this._sourceControls.get(p);if(!L)return Promise.resolve(void 0);const S=L.getResourceGroup(C);return S?S.$executeResourceCommand(U,W):Promise.resolve(void 0)}$validateInput(p,C,U){this.logService.trace("ExtHostSCM#$validateInput",p);const W=this._sourceControls.get(p);return!W||!W.inputBox.validateInput?Promise.resolve(void 0):(0,D.asPromise)(()=>W.inputBox.validateInput(C,U)).then(L=>{if(!L)return Promise.resolve(void 0);const S=k.MarkdownString.fromStrict(L.message);return S?Promise.resolve([S,L.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(p){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",p),p!==void 0&&this._sourceControls.get(p)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=p,Promise.resolve(void 0)}};c._handlePool=0,c=ze([xe(2,O.ILogService)],c),e.ExtHostSCM=c});var Ye=this&&this.__classPrivateFieldSet||function(ne,e,a,v,b){if(v==="m")throw new TypeError("Private method is not writable");if(v==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return v==="a"?b.call(ne,a):b?b.value=a:e.set(ne,a),a},Oe=this&&this.__classPrivateFieldGet||function(ne,e,a,v){if(a==="a"&&!v)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!v:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?v:a==="a"?v.call(ne):v?v.value:e.get(ne)};define(ye[213],De([1,0,6,4,132,7,8,10]),function(ne,e,a,v,b,M,D,P){"use strict";var E,T;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class O{constructor(f,h,d,o,g=a.StatusBarAlignment.Left,R){E.set(this,void 0),T.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new M.DisposableStore,Ye(this,E,f,"f"),Ye(this,T,h,"f"),this._entryId=O.ID_GEN++,this._extension=d,this._id=o,this._alignment=g,this._priority=this.validatePriority(R)}validatePriority(f){if(!!(0,P.isNumber)(f))return f===Number.POSITIVE_INFINITY?Number.MAX_VALUE:f===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:f}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(f){this._text=f,this.update()}set name(f){this._name=f,this.update()}set tooltip(f){this._tooltip=f,this.update()}set color(f){this._color=f,this.update()}set backgroundColor(f){f&&!O.ALLOWED_BACKGROUND_COLORS.has(f.id)&&(f=void 0),this._backgroundColor=f,this.update()}set command(f){this._command?.fromApi!==f&&(this._internalCommandRegistration.clear(),typeof f=="string"?this._command={fromApi:f,internal:Oe(this,T,"f").toInternal({title:"",command:f},this._internalCommandRegistration)}:f?this._command={fromApi:f,internal:Oe(this,T,"f").toInternal(f,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(f){this._accessibilityInformation=f,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Oe(this,E,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let f;this._extension?this._id?f=`${this._extension.identifier.value}.${this._id}`:f=this._extension.identifier.value:f=this._id;let h;this._name?h=this._name:h=(0,b.localize)(0,null,this._extension.displayName||this._extension.name);let d=this._color;this._backgroundColor&&(d=O.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const o=D.MarkdownString.fromStrict(this._tooltip);Oe(this,E,"f").$setEntry(this._entryId,f,h,this._text,o,this._command?.internal,d,this._backgroundColor,this._alignment===a.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=O,E=new WeakMap,T=new WeakMap,O.ID_GEN=0,O.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new a.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new a.ThemeColor("statusBarItem.warningForeground")]]);class y{constructor(f){this._messages=[],this._item=f.createStatusBarEntry(void 0,"status.extensionMessage",a.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,b.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(f){const h={message:f};return this._messages.unshift(h),this._update(),new a.Disposable(()=>{const d=this._messages.indexOf(h);d>=0&&(this._messages.splice(d,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class m{constructor(f,h){this._proxy=f.getProxy(v.MainContext.MainThreadStatusBar),this._commands=h,this._statusMessage=new y(this)}createStatusBarEntry(f,h,d,o){return new O(this._proxy,this._commands,f,h,d,o)}setStatusBarMessage(f,h){const d=this._statusMessage.setMessage(f);let o;return typeof h=="number"?o=setTimeout(()=>d.dispose(),h):typeof h!="undefined"&&h.then(()=>d.dispose(),()=>d.dispose()),new a.Disposable(()=>{d.dispose(),clearTimeout(o)})}}e.ExtHostStatusBar=m}),define(ye[69],De([1,0,4,5,3]),function(ne,e,a,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class M{constructor(P){this._onDidChangeStorage=new v.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=P.getProxy(a.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(P,E){this._proxy.$registerExtensionStorageKeysToSync(P,E)}initializeExtensionStorage(P,E,T){return this._proxy.$initializeExtensionStorage(P,E).then(O=>O||T)}setValue(P,E,T){return this._proxy.$setValue(P,E,T)}$acceptValue(P,E,T){this._onDidChangeStorage.fire({shared:P,key:E,value:T})}}e.ExtHostStorage=M,e.IExtHostStorage=(0,b.createDecorator)("IExtHostStorage")}),define(ye[70],De([1,0,3,28,15,51,2]),function(ne,e,a,v,b,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,a.createDecorator)("IExtensionStoragePaths");let P=class{constructor(T,O,y){this._logService=O,this._extHostFileSystem=y,this._workspace=T.workspace??void 0,this._environment=T.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(m=>this._value=m)}async _getWorkspaceStorageURI(T){return D.URI.joinPath(this._environment.workspaceStorageHome,T)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const T=this._workspace.id,O=await this._getWorkspaceStorageURI(T);try{return await this._extHostFileSystem.value.stat(O),this._logService.trace("[ExtHostStorage] storage dir already exists",O),O}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",O),await this._extHostFileSystem.value.createDirectory(O),await this._extHostFileSystem.value.writeFile(D.URI.joinPath(O,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:D.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),O}catch(y){this._logService.error("[ExtHostStorage]",y);return}}workspaceValue(T){if(this._value)return D.URI.joinPath(this._value,T.identifier.value)}globalValue(T){return D.URI.joinPath(this._environment.globalStorageHome,T.identifier.value.toLowerCase())}onWillDeactivateAll(){}};P=ze([xe(0,v.IExtHostInitDataService),xe(1,b.ILogService),xe(2,M.IExtHostConsumerFileSystem)],P),e.ExtensionStoragePaths=P}),define(ye[97],De([1,0,3,4,13]),function(ne,e,a,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTelemetryLogService=e.IExtHostTelemetryLogService=void 0,e.IExtHostTelemetryLogService=(0,a.createDecorator)("IExtHostTelemetryLogService");let M=class{constructor(P){this._telemetryShape=P.getProxy(v.MainContext.MainThreadTelemetry)}logToTelemetryOutputChannel(P,E,T){this._telemetryShape.$logTelemetryToOutputChannel(`${P.identifier.value}/${E}`,T)}};M=ze([xe(0,b.IExtHostRpcService)],M),e.ExtHostTelemetryLogService=M}),define(ye[52],De([1,0,5,4,3,2,13,7,6,133,11,170,20,42,154,60,10,14]),function(ne,e,a,v,b,M,D,P,E,T,O,y,m,k,f,h,d,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,b.createDecorator)("IExtHostTerminalService");class g{constructor(t,c,_,p){this._proxy=t,this._id=c,this._creationOptions=_,this._name=p,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(U=>this._pidPromiseComplete=U);const C=this;this.value={get name(){return C._name||""},get processId(){return C._pidPromise},get creationOptions(){return C._creationOptions},get exitStatus(){return C._exitStatus},get state(){return C._state},sendText(U,W=!0){C._checkDisposed(),C._proxy.$sendText(C._id,U,W)},show(U){C._checkDisposed(),C._proxy.$show(C._id,U)},hide(){C._checkDisposed(),C._proxy.$hide(C._id)},dispose(){C._disposed||(C._disposed=!0,C._proxy.$dispose(C._id))},get dimensions(){if(!(C._cols===void 0||C._rows===void 0))return{columns:C._cols,rows:C._rows}}}}async create(t,c){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:t.name,shellPath:(0,d.withNullAsUndefined)(t.shellPath),shellArgs:(0,d.withNullAsUndefined)(t.shellArgs),cwd:(0,d.withNullAsUndefined)(t.cwd),env:(0,d.withNullAsUndefined)(t.env),icon:(0,d.withNullAsUndefined)(n(t.iconPath)),color:h.ThemeColor.isThemeColor(t.color)?t.color.id:void 0,initialText:(0,d.withNullAsUndefined)(t.message),strictEnv:(0,d.withNullAsUndefined)(t.strictEnv),hideFromUser:(0,d.withNullAsUndefined)(t.hideFromUser),isFeatureTerminal:(0,d.withNullAsUndefined)(c?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,d.withNullAsUndefined)(c?.useShellEnvironment),location:c?.location||this._serializeParentTerminal(t.location,c?.resolvedExtHostIdentifier),isTransient:(0,d.withNullAsUndefined)(t.isTransient)})}async createExtensionTerminal(t,c,_,p){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:_,color:h.ThemeColor.isThemeColor(p)?p.id:void 0,location:this._serializeParentTerminal(t,c),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(t,c){return typeof t=="object"?"parentTerminal"in t&&t.parentTerminal&&c?{parentTerminal:c}:"viewColumn"in t?{viewColumn:t.viewColumn,preserveFocus:t.preserveFocus}:void 0:t}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(t){this._name=t}setExitStatus(t,c){this._exitStatus=Object.freeze({code:t,reason:c})}setDimensions(t,c){return t===this._cols&&c===this._rows||t===0||c===0?!1:(this._cols=t,this._rows=c,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(t){this._pidPromiseComplete?(this._pidPromiseComplete(t),this._pidPromiseComplete=void 0):this._pidPromise.then(c=>{c!==t&&(this._pidPromise=Promise.resolve(t))})}}e.ExtHostTerminal=g;class R{constructor(t){this._pty=t,this.id=0,this.shouldPersist=!1,this._onProcessData=new a.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new a.Emitter,this._onDidChangeProperty=new a.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new a.Emitter,this.onProcessExit=this._onProcessExit.event}get onProcessReady(){return this._onProcessReady.event}refreshProperty(t){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${t}`)}updateProperty(t,c){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${t}, value: ${c}`)}async start(){}shutdown(){this._pty.close()}input(t){this._pty.handleInput?.(t)}resize(t,c){this._pty.setDimensions?.({columns:t,rows:c})}async processBinary(t){}acknowledgeDataEvent(t){}async setUnicodeVersion(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this._pty.onDidWrite(c=>this._onProcessData.fire(c)),this._pty.onDidClose?.((c=void 0)=>{this._onProcessExit.fire(c===void 0?void 0:c)}),this._pty.onDidOverrideDimensions?.(c=>{c&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:c.columns,rows:c.rows}})}),this._pty.onDidChangeName?.(c=>{this._onDidChangeProperty.fire({type:"title",value:c})}),this._pty.open(t||void 0),t&&this._pty.setDimensions?.(t),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=R;let l=1,w=class extends P.Disposable{constructor(t,c){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new a.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new a.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new a.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new a.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new a.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=c.getProxy(v.MainContext.MainThreadTerminalService),this._bufferer=new f.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new a.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(t),this._register({dispose:()=>{for(const[_,p]of this._terminalProcesses)p.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(t=>t.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(t){return(t?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(t){return(t?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(t,c){const _=new g(this._proxy,(0,k.generateUuid)(),t,t.name),p=new R(t.pty);return _.createExtensionTerminal(t.location,this._serializeParentTerminal(t,c).resolvedExtHostIdentifier,n(t.iconPath),i(t.color)).then(C=>{const U=this._setupExtHostProcessListeners(C,p);this._terminalProcessDisposables[C]=U}),this._terminals.push(_),_.value}_serializeParentTerminal(t,c){if(c=c||{},t.location&&typeof t.location=="object"&&"parentTerminal"in t.location){const _=t.location.parentTerminal;if(_){const p=this._terminals.find(C=>C.value===_);p&&(c.resolvedExtHostIdentifier=p._id)}}else t.location&&typeof t.location!="object"?c.location=t.location:c.location&&typeof c.location=="object"&&"splitActiveTerminal"in c.location&&(c.location={splitActiveTerminal:!0});return c}attachPtyToTerminal(t,c){if(!this._getTerminalById(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const p=new R(c),C=this._setupExtHostProcessListeners(t,p);this._terminalProcessDisposables[t]=C}async $acceptActiveTerminalChanged(t){const c=this._activeTerminal;if(t===null){this._activeTerminal=void 0,c!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const _=this._getTerminalById(t);_&&(this._activeTerminal=_,c!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(t,c){const _=this._getTerminalById(t);_&&this._onDidWriteTerminalData.fire({terminal:_.value,data:c})}async $acceptTerminalDimensions(t,c,_){const p=this._getTerminalById(t);p&&p.setDimensions(c,_)&&this._onDidChangeTerminalDimensions.fire({terminal:p.value,dimensions:p.value.dimensions})}async $acceptTerminalMaximumDimensions(t,c,_){this._terminalProcesses.get(t)?.resize(c,_)}async $acceptTerminalTitleChange(t,c){const _=this._getTerminalById(t);_&&(_.name=c)}async $acceptTerminalClosed(t,c,_){const p=this._getTerminalObjectIndexById(this._terminals,t);if(p!==null){const C=this._terminals.splice(p,1)[0];C.setExitStatus(c,_),this._onDidCloseTerminal.fire(C.value)}}$acceptTerminalOpened(t,c,_,p){if(c){const W=this._getTerminalObjectIndexById(this._terminals,c);if(W!==null){this._terminals[W]._id=t,this._onDidOpenTerminal.fire(this.terminals[W]),this._terminals[W].isOpen=!0;return}}const C={name:p.name,shellPath:p.executable,shellArgs:p.args,cwd:typeof p.cwd=="string"?p.cwd:M.URI.revive(p.cwd),env:p.env,hideFromUser:p.hideFromUser},U=new g(this._proxy,t,C,_);this._terminals.push(U),this._onDidOpenTerminal.fire(U.value),U.isOpen=!0}async $acceptTerminalProcessId(t,c){this._getTerminalById(t)?._setProcessId(c)}async $startExtensionTerminal(t,c){const _=this._getTerminalById(t);if(!_)return{message:(0,T.localize)(0,null,t)};_.isOpen||await new Promise(C=>{const U=this.onDidOpenTerminal(async W=>{W===_.value&&(U.dispose(),C())})});const p=this._terminalProcesses.get(t);p?p.startSendingEvents(c):this._extensionTerminalAwaitingStart[t]={initialDimensions:c}}_setupExtHostProcessListeners(t,c){const _=new P.DisposableStore;_.add(c.onProcessReady(C=>this._proxy.$sendProcessReady(t,C.pid,C.cwd))),_.add(c.onDidChangeProperty(C=>this._proxy.$sendProcessProperty(t,C))),this._bufferer.startBuffering(t,c.onProcessData),_.add(c.onProcessExit(C=>this._onProcessExit(t,C))),this._terminalProcesses.set(t,c);const p=this._extensionTerminalAwaitingStart[t];return p&&c instanceof R&&(c.startSendingEvents(p.initialDimensions),delete this._extensionTerminalAwaitingStart[t]),_}$acceptProcessAckDataEvent(t,c){this._terminalProcesses.get(t)?.acknowledgeDataEvent(c)}$acceptProcessInput(t,c){this._terminalProcesses.get(t)?.input(c)}$acceptTerminalInteraction(t){const c=this._getTerminalById(t);c?.setInteractedWith()&&this._onDidChangeTerminalState.fire(c.value)}$acceptProcessResize(t,c,_){try{this._terminalProcesses.get(t)?.resize(c,_)}catch(p){if(p.code!=="EPIPE"&&p.code!=="ERR_IPC_CHANNEL_CLOSED")throw p}}$acceptProcessShutdown(t,c){this._terminalProcesses.get(t)?.shutdown(c)}$acceptProcessRequestInitialCwd(t){this._terminalProcesses.get(t)?.getInitialCwd().then(c=>this._proxy.$sendProcessProperty(t,{type:"initialCwd",value:c}))}$acceptProcessRequestCwd(t){this._terminalProcesses.get(t)?.getCwd().then(c=>this._proxy.$sendProcessProperty(t,{type:"cwd",value:c}))}$acceptProcessRequestLatency(t){return Promise.resolve(t)}registerLinkProvider(t){return this._linkProviders.add(t),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new E.Disposable(()=>{this._linkProviders.delete(t),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(t,c,_){if(this._profileProviders.has(c))throw new Error(`Terminal profile provider "${c}" already registered`);return this._profileProviders.set(c,_),this._proxy.$registerProfileProvider(c,t.identifier.value),new E.Disposable(()=>{this._profileProviders.delete(c),this._proxy.$unregisterProfileProvider(c)})}async $createContributedProfileTerminal(t,c){const _=new m.CancellationTokenSource().token;let p=await this._profileProviders.get(t)?.provideTerminalProfile(_);if(!_.isCancellationRequested){if(p&&!("options"in p)&&(p={options:p}),!p||!("options"in p))throw new Error(`No terminal profile options provided for id "${t}"`);if("pty"in p.options){this.createExtensionTerminal(p.options,c);return}this.createTerminalFromOptions(p.options,c)}}async $provideLinks(t,c){const _=this._getTerminalById(t);if(!_)return[];this._terminalLinkCache.delete(t),this._terminalLinkCancellationSource.get(t)?.dispose(!0);const C=new m.CancellationTokenSource;this._terminalLinkCancellationSource.set(t,C);const U=[],W={terminal:_.value,line:c},L=[];for(const $ of this._linkProviders)L.push(o.Promises.withAsyncBody(async F=>{C.token.onCancellationRequested(()=>F({provider:$,links:[]}));const q=await $.provideTerminalLinks(W,C.token)||[];C.token.isCancellationRequested||F({provider:$,links:q})}));const S=await Promise.all(L);if(C.token.isCancellationRequested)return[];const z=new Map;for(const $ of S)$&&$.links.length>0&&U.push(...$.links.map(F=>{const q={id:l++,startIndex:F.startIndex,length:F.length,label:F.tooltip};return z.set(q.id,{provider:$.provider,link:F}),q}));return this._terminalLinkCache.set(t,z),U}$activateLink(t,c){const _=this._terminalLinkCache.get(t)?.get(c);!_||_.provider.handleTerminalLink(_.link)}_onProcessExit(t,c){this._bufferer.stopBuffering(t),this._terminalProcesses.delete(t),delete this._extensionTerminalAwaitingStart[t];const _=this._terminalProcessDisposables[t];_&&(_.dispose(),delete this._terminalProcessDisposables[t]),this._proxy.$sendProcessExit(t,c)}_getTerminalById(t){return this._getTerminalObjectById(this._terminals,t)}_getTerminalObjectById(t,c){const _=this._getTerminalObjectIndexById(t,c);return _!==null?t[_]:null}_getTerminalObjectIndexById(t,c){let _=null;return t.some((p,C)=>p._id===c?(_=C,!0):!1),_}getEnvironmentVariableCollection(t){let c=this._environmentVariableCollections.get(t.identifier.value);return c||(c=new s,this._setEnvironmentVariableCollection(t.identifier.value,c)),c}_syncEnvironmentVariableCollection(t,c){const _=(0,y.serializeEnvironmentVariableCollection)(c.map);this._proxy.$setEnvironmentVariableCollection(t,c.persistent,_.length===0?void 0:_)}$initEnvironmentVariableCollections(t){t.forEach(c=>{const _=c[0],p=new s(c[1]);this._setEnvironmentVariableCollection(_,p)})}$acceptDefaultProfile(t,c){this._defaultProfile=t,this._defaultAutomationProfile=c}_setEnvironmentVariableCollection(t,c){this._environmentVariableCollections.set(t,c),c.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(t,c)})}};w=ze([xe(1,D.IExtHostRpcService)],w),e.BaseExtHostTerminalService=w;class s{constructor(t){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new a.Emitter,this.map=new Map(t)}get persistent(){return this._persistent}set persistent(t){this._persistent=t,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(t,c){this._setIfDiffers(t,{value:c,type:E.EnvironmentVariableMutatorType.Replace})}append(t,c){this._setIfDiffers(t,{value:c,type:E.EnvironmentVariableMutatorType.Append})}prepend(t,c){this._setIfDiffers(t,{value:c,type:E.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(t,c){const _=this.map.get(t);(!_||_.value!==c.value||_.type!==c.type)&&(this.map.set(t,c),this._onDidChangeCollection.fire())}get(t){return this.map.get(t)}forEach(t,c){this.map.forEach((_,p)=>t.call(c,p,_,this))}[Symbol.iterator](){return this.map.entries()}delete(t){this.map.delete(t),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=s;let u=class extends w{constructor(t){super(!1,t)}createTerminal(t,c,_){throw new O.NotSupportedError}createTerminalFromOptions(t,c){throw new O.NotSupportedError}};u=ze([xe(0,D.IExtHostRpcService)],u),e.WorkerExtHostTerminalService=u;function n(r){if(!(!r||typeof r=="string"))return"id"in r?{id:r.id,color:r.color}:r}function i(r){return h.ThemeColor.isThemeColor(r)?r:void 0}});var Ye=this&&this.__classPrivateFieldSet||function(ne,e,a,v,b){if(v==="m")throw new TypeError("Private method is not writable");if(v==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return v==="a"?b.call(ne,a):b?b.value=a:e.set(ne,a),a},Oe=this&&this.__classPrivateFieldGet||function(ne,e,a,v){if(a==="a"&&!v)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!v:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?v:a==="a"?v.call(ne):v?v.value:e.get(ne)};define(ye[214],De([1,0,16,23,20,5,174,96,7,26,10,42,4,13,92,8,6,46,65,47]),function(ne,e,a,v,b,M,D,P,E,T,O,y,m,k,f,h,d,o,g,R){"use strict";var l,w;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let s=class{constructor(L,S){this.resultsChangedEmitter=new M.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=L.getProxy(m.MainContext.MainThreadTesting),this.observer=new p(this.proxy),this.runTracker=new n(this.proxy),S.registerArgumentProcessor({processArgument:z=>z?.$mid===13?(0,f.toItemFromContext)(z):z})}createTestController(L,S,z){if(this.controllers.has(L))throw new Error(`Attempt to insert a duplicate controller with ID "${L}"`);const $=new E.DisposableStore,F=$.add(new f.ExtHostTestItemCollection(L,S));F.root.label=S;const q=new Map,ie=this.proxy,A={items:F.root.children,get label(){return S},set label(le){S=le,F.root.label=le,ie.$updateController(L,{label:S})},get refreshHandler(){return z},set refreshHandler(le){z=le,ie.$updateController(L,{canRefresh:!!le})},get id(){return L},createRunProfile:(le,oe,ue,te,Ee)=>{let be=(0,P.hash)(le);for(;q.has(be);)be++;return new C(this.proxy,q,L,be,le,oe,ue,te,Ee)},createTestItem(le,oe,ue){return new f.TestItemImpl(L,le,oe,ue)},createTestRun:(le,oe,ue=!0)=>this.runTracker.createTestRun(L,F,le,oe,ue),set resolveHandler(le){F.resolveHandler=le},get resolveHandler(){return F.resolveHandler},dispose:()=>{$.dispose()}};ie.$registerTestController(L,S,!!z),$.add((0,E.toDisposable)(()=>ie.$unregisterTestController(L)));const Z={controller:A,collection:F,profiles:q};return this.controllers.set(L,Z),$.add((0,E.toDisposable)(()=>this.controllers.delete(L))),$.add(F.onDidGenerateDiff(le=>ie.$publishDiff(L,le.map(R.TestsDiffOp.serialize)))),A}createTestObserver(){return this.observer.checkout()}async runTests(L,S=b.CancellationToken.None){const z=i(L);if(!z)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const $=this.controllers.get(z.controllerId);if(!$)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:L.include?.map(F=>o.TestId.fromExtHostTestItem(F,$.collection.root.id).toString())??[$.collection.root.id],profileGroup:U[z.kind],profileId:z.profileId,controllerId:z.controllerId}],exclude:L.exclude?.map(F=>F.id)},S)}$provideFileCoverage(L,S,z){return(0,a.mapFind)(this.runTracker.trackers,F=>F.id===L?F.getCoverage(S):void 0)?.provideFileCoverage(z)??Promise.resolve([])}$resolveFileCoverage(L,S,z,$){return(0,a.mapFind)(this.runTracker.trackers,q=>q.id===L?q.getCoverage(S):void 0)?.resolveFileCoverage(z,$)??Promise.resolve([])}$configureRunProfile(L,S){this.controllers.get(L)?.profiles.get(S)?.configureHandler?.()}async $refreshTests(L,S){await this.controllers.get(L)?.controller.refreshHandler?.(S)}$publishTestResults(L){this.results=Object.freeze(L.map(S=>(0,T.deepFreeze)(h.TestResults.to(S))).concat(this.results).sort((S,z)=>z.completedAt-S.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(L,S){const z=this.controllers.get(o.TestId.fromString(L).controllerId)?.collection;z&&(await z.expand(L,S<0?1/0:S),z.flushDiff())}$acceptDiff(L){this.observer.applyDiff(L.map(R.TestsDiffOp.deserialize))}async $runControllerTests(L,S){return Promise.all(L.map(z=>this.runControllerTestRequest(z,S)))}async runControllerTestRequest(L,S){const z=this.controllers.get(L.controllerId);if(!z)return{};const{collection:$,profiles:F}=z,q=F.get(L.profileId);if(!q)return{};const ie=L.testIds.map(oe=>$.tree.get(oe)).filter(O.isDefined),A=L.excludeExtIds.map(oe=>z.collection.tree.get(oe)).filter(O.isDefined).filter(oe=>ie.some(ue=>ue.fullId.compare(oe.fullId)===2));if(!ie.length)return{};const Z=new d.TestRunRequest(ie.some(oe=>oe.actual instanceof f.TestItemRootImpl)?void 0:ie.map(oe=>oe.actual),A.map(oe=>oe.actual),q),le=this.runTracker.prepareForMainThreadTestRun(Z,r.fromInternal(L,z.collection),S);try{return await q.runHandler(Z,S),{}}catch(oe){return{error:String(oe)}}finally{le.isRunning&&!S.isCancellationRequested&&await M.Event.toPromise(le.onEnd),le.dispose()}}$cancelExtensionTestRun(L){L===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(L)}};s=ze([xe(0,k.IExtHostRpcService)],s),e.ExtHostTesting=s;class u extends E.Disposable{constructor(L,S,z){super();this.dto=L,this.proxy=S,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new M.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new b.CancellationTokenSource(z)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:$}of this.tasks.values())$.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(L){return this.tasks.get(L)?.coverage}createRun(L){const S=this.dto.id,z=this.dto.controllerId,$=(0,y.generateUuid)(),F=new t(this.proxy,S,$),q=le=>(oe,...ue)=>{if(A){console.warn(`Setting the state of test "${oe.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(oe)||(this.ensureTestIsKnown(oe),le(oe,...ue))},ie=(le,oe)=>{const ue=oe instanceof Array?oe.map(h.TestMessage.from):[h.TestMessage.from(oe)];if(le.uri&&le.range){const te={range:h.Range.from(le.range),uri:le.uri};for(const Ee of ue)Ee.location=Ee.location||te}this.proxy.$appendTestMessagesInRun(S,$,o.TestId.fromExtHostTestItem(le,z).toString(),ue)};let A=!1;const Z={isPersisted:this.dto.isPersisted,token:this.cts.token,name:L,get coverageProvider(){return F.coverageProvider},set coverageProvider(le){F.coverageProvider=le},enqueued:q(le=>{this.proxy.$updateTestStateInRun(S,$,o.TestId.fromExtHostTestItem(le,z).toString(),1)}),skipped:q(le=>{this.proxy.$updateTestStateInRun(S,$,o.TestId.fromExtHostTestItem(le,z).toString(),5)}),started:q(le=>{this.proxy.$updateTestStateInRun(S,$,o.TestId.fromExtHostTestItem(le,z).toString(),2)}),errored:q((le,oe,ue)=>{ie(le,oe),this.proxy.$updateTestStateInRun(S,$,o.TestId.fromExtHostTestItem(le,z).toString(),6,ue)}),failed:q((le,oe,ue)=>{ie(le,oe),this.proxy.$updateTestStateInRun(S,$,o.TestId.fromExtHostTestItem(le,z).toString(),4,ue)}),passed:q((le,oe)=>{this.proxy.$updateTestStateInRun(S,$,o.TestId.fromExtHostTestItem(le,this.dto.controllerId).toString(),3,oe)}),appendOutput:(le,oe,ue)=>{A||(ue&&(this.dto.isIncluded(ue)?this.ensureTestIsKnown(ue):ue=void 0),this.proxy.$appendOutputToRun(S,$,v.VSBuffer.fromString(le),oe&&h.location.from(oe),ue&&o.TestId.fromExtHostTestItem(ue,z).toString()))},end:()=>{A||(A=!0,this.proxy.$finishedTestRunTask(S,$),this.tasks.delete($),this.isRunning||this.dispose())}};return this.tasks.set($,{run:Z,coverage:F}),this.proxy.$startedTestRunTask(S,{id:$,name:L,running:!0}),Z}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(L){if(!(L instanceof f.TestItemImpl))throw new g.InvalidTestItemError(L.id);if(this.sharedTestIds.has(o.TestId.fromExtHostTestItem(L,this.dto.controllerId).toString()))return;const S=[],z=this.dto.colllection.root;for(;;){const $=h.TestItem.from(L);if(S.unshift($),this.sharedTestIds.has($.extId)||(this.sharedTestIds.add($.extId),L===z))break;L=L.parent||z}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,S)}}class n{constructor(L){this.proxy=L,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(L,S,z){return this.getTracker(L,S,z)}cancelRunById(L){for(const S of this.tracked.values())if(S.id===L){S.dispose();return}}cancelAllRuns(){for(const L of this.tracked.values())L.dispose()}createTestRun(L,S,z,$,F){const q=this.tracked.get(z);if(q)return q.createRun($);const ie=r.fromPublic(L,S,z,F),A=i(z);this.proxy.$startedExtensionTestRun({controllerId:L,profile:A&&{group:U[A.kind],id:A.profileId},exclude:z.exclude?.map(le=>o.TestId.fromExtHostTestItem(le,S.root.id).toString())??[],id:ie.id,include:z.include?.map(le=>o.TestId.fromExtHostTestItem(le,S.root.id).toString())??[S.root.id],persist:F});const Z=this.getTracker(z,ie);return Z.onEnd(()=>this.proxy.$finishedExtensionTestRun(ie.id)),Z.createRun($)}getTracker(L,S,z){const $=new u(S,this.proxy,z);return this.tracked.set(L,$),$.onEnd(()=>this.tracked.delete(L)),$}}e.TestRunCoordinator=n;const i=W=>{if(!!W.profile){if(!(W.profile instanceof C))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return W.profile}};class r{constructor(L,S,z,$,F,q){this.controllerId=L,this.id=S,this.isPersisted=F,this.colllection=q,this.includePrefix=z.map(ie=>ie+"\0"),this.excludePrefix=$.map(ie=>ie+"\0")}static fromPublic(L,S,z,$){return new r(L,(0,y.generateUuid)(),z.include?.map(F=>o.TestId.fromExtHostTestItem(F,L).toString())??[L],z.exclude?.map(F=>o.TestId.fromExtHostTestItem(F,L).toString())??[],$,S)}static fromInternal(L,S){return new r(L.controllerId,L.runId,L.testIds,L.excludeExtIds,!0,S)}isIncluded(L){const S=o.TestId.fromExtHostTestItem(L,this.controllerId).toString()+"\0";for(const z of this.excludePrefix)if(S===z||S.startsWith(z))return!1;for(const z of this.includePrefix)if(S===z||S.startsWith(z))return!0;return!1}}e.TestRunDto=r;class t{constructor(L,S,z){this.proxy=L,this.runId=S,this.taskId=z}set coverageProvider(L){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!L||(this._coverageProvider=L,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(L){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(L))());try{return(await this.fileCoverage)?.map(h.TestCoverage.fromFile)??[]}catch(S){throw this.fileCoverage=void 0,S}}async resolveFileCoverage(L,S){const z=await this.fileCoverage;let $=z?.[L];return!this._coverageProvider||!z||!$?[]:($.detailedCoverage||($=z[L]=await this._coverageProvider.resolveFileCoverage?.($,S)??$),$.detailedCoverage?.map(h.TestCoverage.fromDetailed)??[])}}class c extends R.IncrementalChangeCollector{constructor(L){super();this.emitter=L,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(L){this.added.add(L)}update(L){Object.assign(L.revived,h.TestItem.toPlain(L.item)),this.added.has(L)||this.updated.add(L)}remove(L){if(this.added.has(L)){this.added.delete(L);return}if(this.updated.delete(L),L.parent&&this.alreadyRemoved.has(L.parent)){this.alreadyRemoved.add(L.item.extId);return}this.removed.add(L)}getChangeEvent(){const{added:L,updated:S,removed:z}=this;return{get added(){return[...L].map($=>$.revived)},get updated(){return[...S].map($=>$.revived)},get removed(){return[...z].map($=>$.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class _ extends R.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new M.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(L){return this.items.get(L)}getMirroredTestDataByReference(L){return this.items.get(L.id)}createItem(L,S){return{...L,revived:h.TestItem.toPlain(L.item),depth:S?S.depth+1:0,children:new Set}}createChangeCollector(){return new c(this.changeEmitter)}}e.MirroredTestCollection=_;class p{constructor(L){this.proxy=L}checkout(){this.current||(this.current=this.createObserverData());const L=this.current;return L.observers++,{onDidChangeTest:L.tests.onDidChangeTests,get tests(){return[...L.tests.rootTests].map(S=>S.revived)},dispose:(0,D.once)(()=>{--L.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(L){return this.current?.tests.getMirroredTestDataByReference(L)}applyDiff(L){this.current?.tests.apply(L)}createObserverData(){const L=new _;return this.proxy.$subscribeToDiffs(),{observers:0,tests:L}}}class C{constructor(L,S,z,$,F,q,ie,A=!1,Z=void 0){this.controllerId=z,this.profileId=$,this._label=F,this.kind=q,this.runHandler=ie,this._isDefault=A,this._tag=Z,l.set(this,void 0),w.set(this,void 0),Ye(this,l,L,"f"),Ye(this,w,S,"f"),S.set($,this);const le=U[q];if(typeof le!="number")throw new Error(`Unknown TestRunProfile.group ${q}`);Oe(this,l,"f").$publishTestRunProfile({profileId:$,controllerId:z,tag:Z?h.TestTag.namespace(this.controllerId,Z.id):null,label:F,group:le,isDefault:A,hasConfigurationHandler:!1})}get label(){return this._label}set label(L){L!==this._label&&(this._label=L,Oe(this,l,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:L}))}get isDefault(){return this._isDefault}set isDefault(L){L!==this._isDefault&&(this._isDefault=L,Oe(this,l,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:L}))}get tag(){return this._tag}set tag(L){L?.id!==this._tag?.id&&(this._tag=L,Oe(this,l,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:L?h.TestTag.namespace(this.controllerId,L.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(L){L!==this._configureHandler&&(this._configureHandler=L,Oe(this,l,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!L}))}dispose(){Oe(this,w,"f")?.delete(this.profileId)&&(Ye(this,w,void 0,"f"),Oe(this,l,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=C,l=new WeakMap,w=new WeakMap;const U={[d.TestRunProfileKind.Coverage]:8,[d.TestRunProfileKind.Debug]:4,[d.TestRunProfileKind.Run]:2}}),define(ye[215],De([1,0,16,5,4,93,8,6]),function(ne,e,a,v,b,M,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class E{constructor(O,y){this._extHostDocumentsAndEditors=y,this._onDidChangeTextEditorSelection=new v.Emitter,this._onDidChangeTextEditorOptions=new v.Emitter,this._onDidChangeTextEditorVisibleRanges=new v.Emitter,this._onDidChangeTextEditorViewColumn=new v.Emitter,this._onDidChangeActiveTextEditor=new v.Emitter,this._onDidChangeVisibleTextEditors=new v.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=O.getProxy(b.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(m=>this._onDidChangeVisibleTextEditors.fire(m)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(m=>this._onDidChangeActiveTextEditor.fire(m))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(O){const y=this._extHostDocumentsAndEditors.allEditors();return O?y:y.map(m=>m.value)}async showTextDocument(O,y,m){let k;typeof y=="number"?k={position:D.ViewColumn.from(y),preserveFocus:m}:typeof y=="object"?k={position:D.ViewColumn.from(y.viewColumn),preserveFocus:y.preserveFocus,selection:typeof y.selection=="object"?D.Range.from(y.selection):void 0,pinned:typeof y.preview=="boolean"?!y.preview:void 0}:k={preserveFocus:!1};const f=await this._proxy.$tryShowTextDocument(O.uri,k),h=f&&this._extHostDocumentsAndEditors.getEditor(f);if(h)return h.value;throw f?new Error(`Could NOT open editor for "${O.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${O.uri.toString()}".`)}createTextEditorDecorationType(O,y){return new M.TextEditorDecorationType(this._proxy,O,y).value}$acceptEditorPropertiesChanged(O,y){const m=this._extHostDocumentsAndEditors.getEditor(O);if(!m)throw new Error("unknown text editor");if(y.options&&m._acceptOptions(y.options),y.selections){const k=y.selections.selections.map(D.Selection.to);m._acceptSelections(k)}if(y.visibleRanges){const k=a.coalesce(y.visibleRanges.map(D.Range.to));m._acceptVisibleRanges(k)}if(y.options&&this._onDidChangeTextEditorOptions.fire({textEditor:m.value,options:{...y.options,lineNumbers:D.TextEditorLineNumbersStyle.to(y.options.lineNumbers)}}),y.selections){const k=P.TextEditorSelectionChangeKind.fromValue(y.selections.source),f=y.selections.selections.map(D.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:m.value,selections:f,kind:k})}if(y.visibleRanges){const k=a.coalesce(y.visibleRanges.map(D.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:m.value,visibleRanges:k})}}$acceptEditorPositionData(O){for(const y in O){const m=this._extHostDocumentsAndEditors.getEditor(y);if(!m)throw new Error("Unknown text editor");const k=D.ViewColumn.to(O[y]);m.value.viewColumn!==k&&(m._acceptViewColumn(k),this._onDidChangeTextEditorViewColumn.fire({textEditor:m.value,viewColumn:k}))}}getDiffInformation(O){return Promise.resolve(this._proxy.$getDiffInformation(O))}}e.ExtHostEditors=E}),define(ye[216],De([1,0,2,3,4,7,6,8,10]),function(ne,e,a,v,b,M,D,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,v.createDecorator)("IExtHostTimeline");class T{constructor(m,k){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=m.getProxy(b.MainContext.MainThreadTimeline),k.registerArgumentProcessor({processArgument:f=>{if(f&&f.$mid===11){const h=f.uri===void 0?void 0:a.URI.revive(f.uri);return this._itemsBySourceAndUriMap.get(f.source)?.get(O(h))?.get(f.handle)}return f}})}async $getTimeline(m,k,f,h){return this._providers.get(m)?.provideTimeline(a.URI.revive(k),f,h)}registerTimelineProvider(m,k,f,h){const d=new M.DisposableStore,o=this.convertTimelineItem(k.id,h,d).bind(this);let g;k.onDidChange&&(g=k.onDidChange(l=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...l,id:k.id}),this));const R=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...k,scheme:m,onDidChange:void 0,async provideTimeline(l,w,s){w?.resetCache&&(d.clear(),R.get(k.id)?.clear());const u=await k.provideTimeline(l,w,s);if(u==null)return;const n=o(l,w);return{...u,source:k.id,items:u.items.map(n)}},dispose(){for(const l of R.values())l.get(k.id)?.clear();g?.dispose(),d.dispose()}})}convertTimelineItem(m,k,f){return(h,d)=>{let o;if(d?.cacheResults){let g=this._itemsBySourceAndUriMap.get(m);g===void 0&&(g=new Map,this._itemsBySourceAndUriMap.set(m,g));const R=O(h);o=g.get(R),o===void 0&&(o=new Map,g.set(R,o))}return g=>{const{iconPath:R,...l}=g,w=`${m}|${g.id??g.timestamp}`;o?.set(w,g);let s,u,n;g.iconPath&&(R instanceof D.ThemeIcon?n={id:R.id,color:R.color}:a.URI.isUri(R)?(s=R,u=R):{light:s,dark:u}=R);let i;return D.MarkdownString.isMarkdownString(l.tooltip)?i=P.MarkdownString.from(l.tooltip):(0,E.isString)(l.tooltip)?i=l.tooltip:D.MarkdownString.isMarkdownString(l.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),i=P.MarkdownString.from(l.detail)):(0,E.isString)(l.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),i=l.detail),{...l,id:l.id??void 0,handle:w,source:m,command:g.command?k.toInternal(g.command,f):void 0,icon:s,iconDark:u,themeIcon:n,tooltip:i,accessibilityInformation:g.accessibilityInformation}}}}registerTimelineProviderCore(m){if(this._providers.get(m.id))throw new Error(`Timeline Provider ${m.id} already exists.`);return this._proxy.$registerTimelineProvider({id:m.id,label:m.label,scheme:m.scheme}),this._providers.set(m.id,m),(0,M.toDisposable)(()=>{for(const f of this._itemsBySourceAndUriMap.values())f.get(m.id)?.clear();this._providers.delete(m.id),this._proxy.$unregisterTimelineProvider(m.id),m.dispose()})}}e.ExtHostTimeline=T;function O(y){return y?.toString()}}),define(ye[217],De([1,0,7,12,2,4]),function(ne,e,a,v,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class D{constructor(E){this._openers=new Map,this._proxy=E.getProxy(M.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(E,T,O,y){if(this._openers.has(T))throw new Error(`Opener with id '${T}' already registered`);const m=y.schemes.find(k=>!D.supportedSchemes.has(k));if(m)throw new Error(`Scheme '${m}' is not supported. Only http and https are currently supported.`);return this._openers.set(T,O),this._proxy.$registerUriOpener(T,y.schemes,E,y.label),(0,a.toDisposable)(()=>{this._openers.delete(T),this._proxy.$unregisterUriOpener(T)})}async $canOpenUri(E,T,O){const y=this._openers.get(E);if(!y)throw new Error(`Unknown opener with id: ${E}`);const m=b.URI.revive(T);return y.canOpenExternalUri(m,O)}async $openUri(E,T,O){const y=this._openers.get(E);if(!y)throw new Error(`Unknown opener id: '${E}'`);return y.openExternalUri(b.URI.revive(T.resolvedUri),{sourceUri:b.URI.revive(T.sourceUri)},O)}}e.ExtHostUriOpeners=D,D.supportedSchemes=new Set([v.Schemas.http,v.Schemas.https])}),define(ye[218],De([1,0,4,2,7,11,27]),function(ne,e,a,v,b,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class P{constructor(T){this.handles=new Set,this.handlers=new Map,this._proxy=T.getProxy(a.MainContext.MainThreadUrls)}registerUriHandler(T,O){if(this.handles.has(D.ExtensionIdentifier.toKey(T)))throw new Error(`Protocol handler already registered for extension ${T}`);const y=P.HandlePool++;return this.handles.add(D.ExtensionIdentifier.toKey(T)),this.handlers.set(y,O),this._proxy.$registerUriHandler(y,T),(0,b.toDisposable)(()=>{this.handles.delete(D.ExtensionIdentifier.toKey(T)),this.handlers.delete(y),this._proxy.$unregisterUriHandler(y)})}$handleExternalUri(T,O){const y=this.handlers.get(T);if(!y)return Promise.resolve(void 0);try{y.handleUri(v.URI.revive(O))}catch(m){(0,M.onUnexpectedError)(m)}return Promise.resolve(void 0)}async createAppUri(T){return v.URI.revive(await this._proxy.$createAppUri(T))}}e.ExtHostUrls=P,P.HandlePool=0});var Ye=this&&this.__classPrivateFieldSet||function(ne,e,a,v,b){if(v==="m")throw new TypeError("Private method is not writable");if(v==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return v==="a"?b.call(ne,a):b?b.value=a:e.set(ne,a),a},Oe=this&&this.__classPrivateFieldGet||function(ne,e,a,v){if(a==="a"&&!v)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!v:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?v:a==="a"?v.call(ne):v?v.value:e.get(ne)};define(ye[53],De([1,0,5,12,2,145,162,64,4]),function(ne,e,a,v,b,M,D,P,E){"use strict";var T,O,y,m,k,f,h,d,o,g,R,l;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class w{constructor(_,p,C,U,W,L,S){T.set(this,void 0),O.set(this,void 0),y.set(this,void 0),m.set(this,void 0),k.set(this,void 0),f.set(this,void 0),h.set(this,""),d.set(this,void 0),o.set(this,!1),g.set(this,!1),R.set(this,!1),this._onMessageEmitter=new a.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,l.set(this,new a.Emitter),this._onDidDispose=Oe(this,l,"f").event,Ye(this,T,_,"f"),Ye(this,O,p,"f"),Ye(this,d,C,"f"),Ye(this,m,U,"f"),Ye(this,k,W,"f"),Ye(this,f,L,"f"),Ye(this,R,s(L),"f"),Ye(this,y,S,"f")}dispose(){Ye(this,o,!0,"f"),Oe(this,l,"f").fire(),Oe(this,l,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(_){return Ye(this,g,!0,"f"),(0,P.asWebviewUri)(_,Oe(this,m,"f"))}get cspSource(){const _=Oe(this,f,"f").extensionLocation;if(_.scheme===v.Schemas.https||_.scheme===v.Schemas.http){let p=_.toString();return p.endsWith("/")||(p+="/"),p+" "+P.webviewGenericCspSource}return P.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Oe(this,h,"f")}set html(_){this.assertNotDisposed(),Oe(this,h,"f")!==_&&(Ye(this,h,_,"f"),!Oe(this,g,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(_)&&(Ye(this,g,!0,"f"),Oe(this,y,"f").report("Webview vscode-resource: uris",Oe(this,f,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Oe(this,O,"f").$setHtml(Oe(this,T,"f"),_))}get options(){return this.assertNotDisposed(),Oe(this,d,"f")}set options(_){this.assertNotDisposed(),Oe(this,O,"f").$setOptions(Oe(this,T,"f"),i(Oe(this,f,"f"),Oe(this,k,"f"),_)),Ye(this,d,_,"f")}async postMessage(_){if(Oe(this,o,"f"))return!1;const p=(0,D.serializeWebviewMessage)(_,{serializeBuffersForPostMessage:Oe(this,R,"f")});return Oe(this,O,"f").$postMessage(Oe(this,T,"f"),p.message,...p.buffers)}assertNotDisposed(){if(Oe(this,o,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=w,T=new WeakMap,O=new WeakMap,y=new WeakMap,m=new WeakMap,k=new WeakMap,f=new WeakMap,h=new WeakMap,d=new WeakMap,o=new WeakMap,g=new WeakMap,R=new WeakMap,l=new WeakMap;function s(c){try{const _=(0,M.normalizeVersion)((0,M.parseVersion)(c.engines.vscode));return!!_&&_.majorBase>=1&&_.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=s;class u{constructor(_,p,C,U,W){this.remoteInfo=p,this.workspace=C,this._logService=U,this._deprecationService=W,this._webviews=new Map,this._webviewProxy=_.getProxy(E.MainContext.MainThreadWebviews)}$onMessage(_,p,C){const U=this.getWebview(_);if(U){const{message:W}=(0,D.deserializeWebviewMessage)(p,C.value);U._onMessageEmitter.fire(W)}}$onMissingCsp(_,p){this._logService.warn(`${p} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(_,p,C){const U=new w(_,this._webviewProxy,r(p),this.remoteInfo,this.workspace,C,this._deprecationService);return this._webviews.set(_,U),U._onDidDispose(()=>{this._webviews.delete(_)}),U}deleteWebview(_){this._webviews.delete(_)}getWebview(_){return this._webviews.get(_)}}e.ExtHostWebviews=u;function n(c){return{id:c.identifier,location:c.extensionLocation}}e.toExtensionData=n;function i(c,_,p){return{enableCommandUris:p.enableCommandUris,enableScripts:p.enableScripts,enableForms:p.enableForms,portMapping:p.portMapping,localResourceRoots:p.localResourceRoots||t(c,_)}}e.serializeWebviewOptions=i;function r(c){return{enableCommandUris:c.enableCommandUris,enableScripts:c.enableScripts,enableForms:c.enableForms,portMapping:c.portMapping,localResourceRoots:c.localResourceRoots?.map(_=>b.URI.from(_))}}e.reviveOptions=r;function t(c,_){return[...(_?.getWorkspaceFolders()||[]).map(p=>p.uri),c.extensionLocation]}}),define(ye[219],De([1,0,20,96,7,12,22,2,8,53,61,4,6]),function(ne,e,a,v,b,M,D,P,E,T,O,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class k{constructor(s,u){this.document=s,this._storagePath=u,this._backupCounter=1,this._edits=new O.Cache("custom documents")}addEdit(s){return this._edits.add([s])}async undo(s,u){await this.getEdit(s).undo(),u||this.disposeBackup()}async redo(s,u){await this.getEdit(s).redo(),u||this.disposeBackup()}disposeEdits(s){for(const u of s)this._edits.delete(u)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const s=l(this.document.uri)+this._backupCounter++;return(0,D.joinPath)(this._storagePath,s)}updateBackup(s){this._backup?.delete(),this._backup=s}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(s){const u=this._edits.get(s,0);if(!u)throw new Error("No edit found");return u}}class f{constructor(){this._documents=new Map}get(s,u){return this._documents.get(this.key(s,u))}add(s,u,n){const i=this.key(s,u.uri);if(this._documents.has(i))throw new Error(`Document already exists for viewType:${s} resource:${u.uri}`);const r=new k(u,n);return this._documents.set(i,r),r}delete(s,u){const n=this.key(s,u.uri);this._documents.delete(n)}key(s,u){return`${s}@@@${u}`}}var h;(function(w){w[w.Text=0]="Text",w[w.Custom=1]="Custom"})(h||(h={}));class d{constructor(){this._providers=new Map}addTextProvider(s,u,n){return this.add(0,s,u,n)}addCustomProvider(s,u,n){return this.add(1,s,u,n)}get(s){return this._providers.get(s)}add(s,u,n,i){if(this._providers.has(u))throw new Error(`Provider for viewType:${u} already registered`);return this._providers.set(u,{type:s,extension:n,provider:i}),new m.Disposable(()=>this._providers.delete(u))}}class o{constructor(s,u,n,i,r){this._extHostDocuments=u,this._extensionStoragePaths=n,this._extHostWebview=i,this._extHostWebviewPanels=r,this._editorProviders=new d,this._documents=new f,this._proxy=s.getProxy(y.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(s,u,n,i){const r=new b.DisposableStore;return g(n)?(r.add(this._editorProviders.addTextProvider(u,s,n)),this._proxy.$registerTextEditorProvider((0,T.toExtensionData)(s),u,i.webviewOptions||{},{supportsMove:!!n.moveCustomTextEditor},(0,T.shouldSerializeBuffersForPostMessage)(s))):(r.add(this._editorProviders.addCustomProvider(u,s,n)),this.supportEditing(n)&&r.add(n.onDidChangeCustomDocument(t=>{const c=this.getCustomDocumentEntry(u,t.document.uri);if(R(t)){const _=c.addEdit(t);this._proxy.$onDidEdit(t.document.uri,u,_,t.label)}else this._proxy.$onContentChange(t.document.uri,u)})),this._proxy.$registerCustomEditorProvider((0,T.toExtensionData)(s),u,i.webviewOptions||{},!!i.supportsMultipleEditorsPerDocument,(0,T.shouldSerializeBuffersForPostMessage)(s))),m.Disposable.from(r,new m.Disposable(()=>{this._proxy.$unregisterEditorProvider(u)}))}async $createCustomDocument(s,u,n,i,r){const t=this._editorProviders.get(u);if(!t)throw new Error(`No provider found for '${u}'`);if(t.type!==1)throw new Error(`Invalid provide type for '${u}'`);const c=P.URI.revive(s),_=await t.provider.openCustomDocument(c,{backupId:n,untitledDocumentData:i?.buffer},r);let p;return this.supportEditing(t.provider)&&this._extensionStoragePaths&&(p=this._extensionStoragePaths.workspaceValue(t.extension)??this._extensionStoragePaths.globalValue(t.extension)),this._documents.add(u,_,p),{editable:this.supportEditing(t.provider)}}async $disposeCustomDocument(s,u){const n=this._editorProviders.get(u);if(!n)throw new Error(`No provider found for '${u}'`);if(n.type!==1)throw new Error(`Invalid provider type for '${u}'`);const i=P.URI.revive(s),{document:r}=this.getCustomDocumentEntry(u,i);this._documents.delete(u,r),r.dispose()}async $resolveWebviewEditor(s,u,n,i,r,t){const c=this._editorProviders.get(n);if(!c)throw new Error(`No provider found for '${n}'`);const _=E.ViewColumn.to(r),p=this._extHostWebview.createNewWebview(u,i.webviewOptions,c.extension),C=this._extHostWebviewPanels.createNewWebviewPanel(u,n,i.title,_,i.panelOptions,p,!0),U=P.URI.revive(s);switch(c.type){case 1:{const{document:W}=this.getCustomDocumentEntry(n,U);return c.provider.resolveCustomEditor(W,C,t)}case 0:{const W=this._extHostDocuments.getDocument(U);return c.provider.resolveCustomTextEditor(W,C,t)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(s,u,n){this.getCustomDocumentEntry(u,s).disposeEdits(n)}async $onMoveCustomEditor(s,u,n){const i=this._editorProviders.get(n);if(!i)throw new Error(`No provider found for '${n}'`);if(!i.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${n}'`);const r=this._extHostWebviewPanels.getWebviewPanel(s);if(!r)throw new Error("No webview found");const t=P.URI.revive(u),c=this._extHostDocuments.getDocument(t);await i.provider.moveCustomTextEditor(c,r,a.CancellationToken.None)}async $undo(s,u,n,i){return this.getCustomDocumentEntry(u,s).undo(n,i)}async $redo(s,u,n,i){return this.getCustomDocumentEntry(u,s).redo(n,i)}async $revert(s,u,n){const i=this.getCustomDocumentEntry(u,s);await this.getCustomEditorProvider(u).revertCustomDocument(i.document,n),i.disposeBackup()}async $onSave(s,u,n){const i=this.getCustomDocumentEntry(u,s);await this.getCustomEditorProvider(u).saveCustomDocument(i.document,n),i.disposeBackup()}async $onSaveAs(s,u,n,i){const r=this.getCustomDocumentEntry(u,s);return this.getCustomEditorProvider(u).saveCustomDocumentAs(r.document,P.URI.revive(n),i)}async $backup(s,u,n){const i=this.getCustomDocumentEntry(u,s),t=await this.getCustomEditorProvider(u).backupCustomDocument(i.document,{destination:i.getNewBackupUri()},n);return i.updateBackup(t),t.id}getCustomDocumentEntry(s,u){const n=this._documents.get(s,P.URI.revive(u));if(!n)throw new Error("No custom document found");return n}getCustomEditorProvider(s){const n=this._editorProviders.get(s)?.provider;if(!n||!this.supportEditing(n))throw new Error("Custom document is not editable");return n}supportEditing(s){return!!s.onDidChangeCustomDocument}}e.ExtHostCustomEditors=o;function g(w){return typeof w.resolveCustomTextEditor=="function"}function R(w){return typeof w.undo=="function"&&typeof w.redo=="function"}function l(w){const s=w.scheme===M.Schemas.file||w.scheme===M.Schemas.untitled?w.fsPath:w.toString();return(0,v.hash)(s)+""}});var Ye=this&&this.__classPrivateFieldSet||function(ne,e,a,v,b){if(v==="m")throw new TypeError("Private method is not writable");if(v==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return v==="a"?b.call(ne,a):b?b.value=a:e.set(ne,a),a},Oe=this&&this.__classPrivateFieldGet||function(ne,e,a,v){if(a==="a"&&!v)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!v:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?v:a==="a"?v.call(ne):v?v.value:e.get(ne)};define(ye[220],De([1,0,5,7,2,42,8,53,4,6]),function(ne,e,a,v,b,M,D,P,E,T){"use strict";var O,y,m,k,f,h,d,o,g,R,l,w,s;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class u extends v.Disposable{constructor(t,c,_,p){super();O.set(this,void 0),y.set(this,void 0),m.set(this,void 0),k.set(this,void 0),f.set(this,void 0),h.set(this,void 0),d.set(this,void 0),o.set(this,void 0),g.set(this,!0),R.set(this,void 0),l.set(this,!1),w.set(this,this._register(new a.Emitter)),this.onDidDispose=Oe(this,w,"f").event,s.set(this,this._register(new a.Emitter)),this.onDidChangeViewState=Oe(this,s,"f").event,Ye(this,O,t,"f"),Ye(this,y,c,"f"),Ye(this,k,_,"f"),Ye(this,m,p.viewType,"f"),Ye(this,f,p.panelOptions,"f"),Ye(this,o,p.viewColumn,"f"),Ye(this,h,p.title,"f"),Ye(this,R,p.active,"f")}dispose(){Oe(this,l,"f")||(Ye(this,l,!0,"f"),Oe(this,w,"f").fire(),Oe(this,y,"f").$disposeWebview(Oe(this,O,"f")),Oe(this,k,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Oe(this,k,"f")}get viewType(){return this.assertNotDisposed(),Oe(this,m,"f")}get title(){return this.assertNotDisposed(),Oe(this,h,"f")}set title(t){this.assertNotDisposed(),Oe(this,h,"f")!==t&&(Ye(this,h,t,"f"),Oe(this,y,"f").$setTitle(Oe(this,O,"f"),t))}get iconPath(){return this.assertNotDisposed(),Oe(this,d,"f")}set iconPath(t){this.assertNotDisposed(),Oe(this,d,"f")!==t&&(Ye(this,d,t,"f"),Oe(this,y,"f").$setIconPath(Oe(this,O,"f"),b.URI.isUri(t)?{light:t,dark:t}:t))}get options(){return Oe(this,f,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Oe(this,o,"f")=="number"&&Oe(this,o,"f")<0))return Oe(this,o,"f")}get active(){return this.assertNotDisposed(),Oe(this,R,"f")}get visible(){return this.assertNotDisposed(),Oe(this,g,"f")}_updateViewState(t){Oe(this,l,"f")||(this.active!==t.active||this.visible!==t.visible||this.viewColumn!==t.viewColumn)&&(Ye(this,R,t.active,"f"),Ye(this,g,t.visible,"f"),Ye(this,o,t.viewColumn,"f"),Oe(this,s,"f").fire({webviewPanel:this}))}reveal(t,c){this.assertNotDisposed(),Oe(this,y,"f").$reveal(Oe(this,O,"f"),{viewColumn:typeof t=="undefined"?void 0:D.ViewColumn.from(t),preserveFocus:!!c})}assertNotDisposed(){if(Oe(this,l,"f"))throw new Error("Webview is disposed")}}O=new WeakMap,y=new WeakMap,m=new WeakMap,k=new WeakMap,f=new WeakMap,h=new WeakMap,d=new WeakMap,o=new WeakMap,g=new WeakMap,R=new WeakMap,l=new WeakMap,w=new WeakMap,s=new WeakMap;class n{constructor(t,c,_){this.webviews=c,this.workspace=_,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=t.getProxy(E.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,M.generateUuid)()}createWebviewPanel(t,c,_,p,C={}){const U=typeof p=="object"?p.viewColumn:p,W={viewColumn:D.ViewColumn.from(U),preserveFocus:typeof p=="object"&&!!p.preserveFocus},L=(0,P.shouldSerializeBuffersForPostMessage)(t),S=n.newHandle();this._proxy.$createWebviewPanel((0,P.toExtensionData)(t),S,c,{title:_,panelOptions:i(C),webviewOptions:(0,P.serializeWebviewOptions)(t,this.workspace,C),serializeBuffersForPostMessage:L},W);const z=this.webviews.createNewWebview(S,C,t);return this.createNewWebviewPanel(S,c,_,U,C,z,!0)}$onDidChangeWebviewPanelViewStates(t){const c=Object.keys(t);c.sort((_,p)=>{const C=t[_],U=t[p];return C.active?1:U.active?-1:+C.visible-+U.visible});for(const _ of c){const p=this.getWebviewPanel(_);if(!p)continue;const C=t[_];p._updateViewState({active:C.active,visible:C.visible,viewColumn:D.ViewColumn.to(C.position)})}}async $onDidDisposeWebviewPanel(t){this.getWebviewPanel(t)?.dispose(),this._webviewPanels.delete(t),this.webviews.deleteWebview(t)}registerWebviewPanelSerializer(t,c,_){if(this._serializers.has(c))throw new Error(`Serializer for '${c}' already registered`);return this._serializers.set(c,{serializer:_,extension:t}),this._proxy.$registerSerializer(c,{serializeBuffersForPostMessage:(0,P.shouldSerializeBuffersForPostMessage)(t)}),new T.Disposable(()=>{this._serializers.delete(c),this._proxy.$unregisterSerializer(c)})}async $deserializeWebviewPanel(t,c,_,p){const C=this._serializers.get(c);if(!C)throw new Error(`No serializer found for '${c}'`);const{serializer:U,extension:W}=C,L=this.webviews.createNewWebview(t,_.webviewOptions,W),S=this.createNewWebviewPanel(t,c,_.title,p,_.panelOptions,L,_.active);await U.deserializeWebviewPanel(S,_.state)}createNewWebviewPanel(t,c,_,p,C,U,W){const L=new u(t,this._proxy,U,{viewType:c,title:_,viewColumn:p,panelOptions:C,active:W});return this._webviewPanels.set(t,L),L}getWebviewPanel(t){return this._webviewPanels.get(t)}}e.ExtHostWebviewPanels=n;function i(r){return{enableFindWidget:r.enableFindWidget,retainContextWhenHidden:r.retainContextWhenHidden}}});var Ye=this&&this.__classPrivateFieldSet||function(ne,e,a,v,b){if(v==="m")throw new TypeError("Private method is not writable");if(v==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return v==="a"?b.call(ne,a):b?b.value=a:e.set(ne,a),a},Oe=this&&this.__classPrivateFieldGet||function(ne,e,a,v){if(a==="a"&&!v)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!v:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?v:a==="a"?v.call(ne):v?v.value:e.get(ne)};define(ye[221],De([1,0,5,7,53,24,8,4,6]),function(ne,e,a,v,b,M,D,P,E){"use strict";var T,O,y,m,k,f,h,d,o,g,R,l;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class w extends v.Disposable{constructor(n,i,r,t,c,_,p){super();T.set(this,void 0),O.set(this,void 0),y.set(this,void 0),m.set(this,void 0),k.set(this,void 0),f.set(this,!1),h.set(this,void 0),d.set(this,void 0),o.set(this,void 0),g.set(this,void 0),R.set(this,this._register(new a.Emitter)),this.onDidChangeVisibility=Oe(this,R,"f").event,l.set(this,this._register(new a.Emitter)),this.onDidDispose=Oe(this,l,"f").event,Ye(this,y,r,"f"),Ye(this,d,t,"f"),Ye(this,T,n,"f"),Ye(this,O,i,"f"),Ye(this,m,c,"f"),Ye(this,k,_,"f"),Ye(this,h,p,"f")}dispose(){Oe(this,f,"f")||(Ye(this,f,!0,"f"),Oe(this,l,"f").fire(),Oe(this,m,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Oe(this,d,"f")}set title(n){this.assertNotDisposed(),Oe(this,d,"f")!==n&&(Ye(this,d,n,"f"),Oe(this,O,"f").$setWebviewViewTitle(Oe(this,T,"f"),n))}get description(){return this.assertNotDisposed(),Oe(this,o,"f")}set description(n){this.assertNotDisposed(),Oe(this,o,"f")!==n&&(Ye(this,o,n,"f"),Oe(this,O,"f").$setWebviewViewDescription(Oe(this,T,"f"),n))}get visible(){return Oe(this,h,"f")}get webview(){return Oe(this,m,"f")}get viewType(){return Oe(this,y,"f")}_setVisible(n){n===Oe(this,h,"f")||Oe(this,f,"f")||(Ye(this,h,n,"f"),Oe(this,R,"f").fire())}get badge(){return this.assertNotDisposed(),(0,M.checkProposedApiEnabled)(Oe(this,k,"f"),"badges"),Oe(this,g,"f")}set badge(n){this.assertNotDisposed(),(0,M.checkProposedApiEnabled)(Oe(this,k,"f"),"badges"),!(n?.value===Oe(this,g,"f")?.value&&n?.tooltip===Oe(this,g,"f")?.tooltip)&&(Ye(this,g,D.ViewBadge.from(n),"f"),Oe(this,O,"f").$setWebviewViewBadge(Oe(this,T,"f"),n))}show(n){this.assertNotDisposed(),Oe(this,O,"f").$show(Oe(this,T,"f"),!!n)}assertNotDisposed(){if(Oe(this,f,"f"))throw new Error("Webview is disposed")}}T=new WeakMap,O=new WeakMap,y=new WeakMap,m=new WeakMap,k=new WeakMap,f=new WeakMap,h=new WeakMap,d=new WeakMap,o=new WeakMap,g=new WeakMap,R=new WeakMap,l=new WeakMap;class s{constructor(n,i){this._extHostWebview=i,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=n.getProxy(P.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(n,i,r,t){if(this._viewProviders.has(i))throw new Error(`View provider for '${i}' already registered`);return this._viewProviders.set(i,{provider:r,extension:n}),this._proxy.$registerWebviewViewProvider((0,b.toExtensionData)(n),i,{retainContextWhenHidden:t?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,b.shouldSerializeBuffersForPostMessage)(n)}),new E.Disposable(()=>{this._viewProviders.delete(i),this._proxy.$unregisterWebviewViewProvider(i)})}async $resolveWebviewView(n,i,r,t,c){const _=this._viewProviders.get(i);if(!_)throw new Error(`No view provider found for '${i}'`);const{provider:p,extension:C}=_,U=this._extHostWebview.createNewWebview(n,{},C),W=new w(n,this._proxy,i,r,U,C,!0);this._webviewViews.set(n,W),await p.resolveWebviewView(W,{state:t},c)}async $onDidChangeWebviewViewVisibility(n,i){this.getWebviewView(n)._setVisible(i)}async $disposeWebviewView(n){const i=this.getWebviewView(n);this._webviewViews.delete(n),i.dispose(),this._extHostWebview.deleteWebview(n)}getWebviewView(n){const i=this._webviewViews.get(n);if(!i)throw new Error("No webview found");return i}}e.ExtHostWebviewViews=s}),define(ye[98],De([1,0,5,4,2,12,9,3,13]),function(ne,e,a,v,b,M,D,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let T=class Ji{constructor(y){this._onDidChangeWindowState=new a.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Ji.InitialState,this._proxy=y.getProxy(v.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(m=>this.$onDidChangeWindowFocus(m))}get state(){return this._state}$onDidChangeWindowFocus(y){y!==this._state.focused&&(this._state={...this._state,focused:y},this._onDidChangeWindowState.fire(this._state))}openUri(y,m){let k;if(typeof y=="string"){k=y;try{y=b.URI.parse(y)}catch{return Promise.reject(`Invalid uri - '${y}'`)}}return(0,D.isFalsyOrWhitespace)(y.scheme)?Promise.reject("Invalid scheme - cannot be empty"):y.scheme===M.Schemas.command?Promise.reject(`Invalid scheme '${y.scheme}'`):this._proxy.$openUri(y,k,m)}async asExternalUri(y,m){if((0,D.isFalsyOrWhitespace)(y.scheme))return Promise.reject("Invalid scheme - cannot be empty");const k=await this._proxy.$asExternalUri(y,m);return b.URI.from(k)}};T.InitialState={focused:!0},T=ze([xe(0,E.IExtHostRpcService)],T),e.ExtHostWindow=T,e.IExtHostWindow=(0,P.createDecorator)("IExtHostWindow")}),define(ye[222],De([1,0,193,28,13]),function(ne,e,a,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;let M=class extends a.AbstractExtHostConsoleForwarder{constructor(P,E){super(P,E)}_nativeConsoleLogMessage(P,E,T){E.apply(console,T)}};M=ze([xe(0,b.IExtHostRpcService),xe(1,v.IExtHostInitDataService)],M),e.ExtHostConsoleForwarder=M}),define(ye[223],De([1,0,14,23,20,11,5,7,118,187,40]),function(ne,e,a,v,b,M,D,P,E,T,O){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function m(C,U){try{return JSON.stringify(C,U)}catch{return"null"}}const k="$$ref$$",f={[k]:-1};class h{constructor(U,W){this.jsonString=U,this.referencedBuffers=W}}function d(C,U=null,W=!1){const L=[];return{jsonString:(W?m:JSON.stringify)(C,(z,$)=>{if(typeof $=="undefined")return f;if(typeof $=="object"){if($ instanceof v.VSBuffer){const F=L.push($)-1;return{[k]:F}}if(U)return U(z,$)}return $}),referencedBuffers:L}}e.stringifyJsonWithBufferRefs=d;function o(C,U,W){return JSON.parse(C,(L,S)=>{if(S){const z=S[k];if(typeof z=="number")return U[z];if(W&&S.$mid===1)return W.transformIncoming(S)}return S})}e.parseJsonAndRestoreBufferRefs=o;function g(C,U){return JSON.stringify(C,U)}function R(C){return C?(U,W)=>W&&W.$mid===1?C.transformOutgoing(W):W:null}var l;(function(C){C[C.LocalSide=0]="LocalSide",C[C.OtherSide=1]="OtherSide"})(l=e.RequestInitiator||(e.RequestInitiator={}));var w;(function(C){C[C.Responsive=0]="Responsive",C[C.Unresponsive=1]="Unresponsive"})(w=e.ResponsiveState||(e.ResponsiveState={}));const s=()=>{},u=Symbol.for("rpcProtocol"),n=Symbol.for("rpcProxy");class i extends P.Disposable{constructor(U,W=null,L=null){super();this[y]=!0,this._onDidChangeResponsiveState=this._register(new D.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=U,this._logger=W,this._uriTransformer=L,this._uriReplacer=R(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let S=0,z=O.ProxyIdentifier.count;S<z;S++)this._locals[S]=null,this._proxies[S]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new a.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(S=>this._receiveOneMessage(S))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(U=>{this._pendingRPCReplies[U].resolveErr(M.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(U){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(U){this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(U){this._responsiveState!==U&&(this._responsiveState=U,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(U){return this._uriTransformer?(0,E.transformIncomingURIs)(U,this._uriTransformer):U}getProxy(U){const{nid:W,sid:L}=U;return this._proxies[W]||(this._proxies[W]=this._createProxy(W,L)),this._proxies[W]}_createProxy(U,W){const L={get:(S,z)=>(typeof z=="string"&&!S[z]&&z.charCodeAt(0)===36&&(S[z]=(...$)=>this._remoteCall(U,z,$)),z===n?W:S[z])};return new Proxy(Object.create(null),L)}set(U,W){return this._locals[U.nid]=W,W}assertRegistered(U){for(let W=0,L=U.length;W<L;W++){const S=U[W];if(!this._locals[S.nid])throw new Error(`Missing proxy instance ${S.sid}`)}}_receiveOneMessage(U){if(this._isDisposed)return;const W=U.byteLength,L=r.read(U,0),S=L.readUInt8(),z=L.readUInt32();switch(S){case 1:case 2:{let{rpcId:$,method:F,args:q}=c.deserializeRequestJSONArgs(L);this._uriTransformer&&(q=(0,E.transformIncomingURIs)(q,this._uriTransformer)),this._receiveRequest(W,z,$,F,q,S===2);break}case 3:case 4:{let{rpcId:$,method:F,args:q}=c.deserializeRequestMixedArgs(L);this._uriTransformer&&(q=(0,E.transformIncomingURIs)(q,this._uriTransformer)),this._receiveRequest(W,z,$,F,q,S===4);break}case 5:{this._logger?.logIncoming(W,z,0,"ack"),this._onDidReceiveAcknowledge(z);break}case 6:{this._receiveCancel(W,z);break}case 7:{this._receiveReply(W,z,void 0);break}case 9:{let $=c.deserializeReplyOKJSON(L);this._uriTransformer&&($=(0,E.transformIncomingURIs)($,this._uriTransformer)),this._receiveReply(W,z,$);break}case 10:{const $=c.deserializeReplyOKJSONWithBuffers(L,this._uriTransformer);this._receiveReply(W,z,$);break}case 8:{const $=c.deserializeReplyOKVSBuffer(L);this._receiveReply(W,z,$);break}case 11:{let $=c.deserializeReplyErrError(L);this._uriTransformer&&($=(0,E.transformIncomingURIs)($,this._uriTransformer)),this._receiveReplyErr(W,z,$);break}case 12:{this._receiveReplyErr(W,z,void 0);break}default:console.error("received unexpected message"),console.error(U)}}_receiveRequest(U,W,L,S,z,$){this._logger?.logIncoming(U,W,1,`receiveRequest ${(0,O.getStringIdentifierForProxy)(L)}.${S}(`,z);const F=String(W);let q,ie;if($){const Z=new b.CancellationTokenSource;z.push(Z.token),q=this._invokeHandler(L,S,z),ie=()=>Z.cancel()}else q=this._invokeHandler(L,S,z),ie=s;this._cancelInvokedHandlers[F]=ie;const A=c.serializeAcknowledged(W);this._logger?.logOutgoing(A.byteLength,W,1,"ack"),this._protocol.send(A),q.then(Z=>{delete this._cancelInvokedHandlers[F];const le=c.serializeReplyOK(W,Z,this._uriReplacer);this._logger?.logOutgoing(le.byteLength,W,1,"reply:",Z),this._protocol.send(le)},Z=>{delete this._cancelInvokedHandlers[F];const le=c.serializeReplyErr(W,Z);this._logger?.logOutgoing(le.byteLength,W,1,"replyErr:",Z),this._protocol.send(le)})}_receiveCancel(U,W){this._logger?.logIncoming(U,W,1,"receiveCancel");const L=String(W);this._cancelInvokedHandlers[L]?.()}_receiveReply(U,W,L){this._logger?.logIncoming(U,W,0,"receiveReply:",L);const S=String(W);if(!this._pendingRPCReplies.hasOwnProperty(S))return;const z=this._pendingRPCReplies[S];delete this._pendingRPCReplies[S],z.resolveOk(L)}_receiveReplyErr(U,W,L){this._logger?.logIncoming(U,W,0,"receiveReplyErr:",L);const S=String(W);if(!this._pendingRPCReplies.hasOwnProperty(S))return;const z=this._pendingRPCReplies[S];delete this._pendingRPCReplies[S];let $;L&&(L.$isError?($=new Error,$.name=L.name,$.message=L.message,$.stack=L.stack):$=L),z.resolveErr($)}_invokeHandler(U,W,L){try{return Promise.resolve(this._doInvokeHandler(U,W,L))}catch(S){return Promise.reject(S)}}_doInvokeHandler(U,W,L){const S=this._locals[U];if(!S)throw new Error("Unknown actor "+(0,O.getStringIdentifierForProxy)(U));const z=S[W];if(typeof z!="function")throw new Error("Unknown method "+W+" on actor "+(0,O.getStringIdentifierForProxy)(U));return z.apply(S,L)}_remoteCall(U,W,L){if(this._isDisposed)return new T.CanceledLazyPromise;let S=null;if(L.length>0&&b.CancellationToken.isCancellationToken(L[L.length-1])&&(S=L.pop()),S&&S.isCancellationRequested)return Promise.reject(M.canceled());const z=c.serializeRequestArguments(L,this._uriReplacer),$=++this._lastMessageId,F=String($),q=new T.LazyPromise;S&&S.onCancellationRequested(()=>{const A=c.serializeCancel($);this._logger?.logOutgoing(A.byteLength,$,0,"cancel"),this._protocol.send(c.serializeCancel($))}),this._pendingRPCReplies[F]=q,this._onWillSendRequest($);const ie=c.serializeRequest($,U,W,z,!!S);return this._logger?.logOutgoing(ie.byteLength,$,0,`request: ${(0,O.getStringIdentifierForProxy)(U)}.${W}(`,L),this._protocol.send(ie),q}}e.RPCProtocol=i,y=u,i.UNRESPONSIVE_TIME=3*1e3;class r{constructor(U,W){this._buff=U,this._offset=W}static alloc(U,W,L){const S=new r(v.VSBuffer.alloc(L+1+4),0);return S.writeUInt8(U),S.writeUInt32(W),S}static read(U,W){return new r(U,W)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(U){this._buff.writeUInt8(U,this._offset),this._offset+=1}readUInt8(){const U=this._buff.readUInt8(this._offset);return this._offset+=1,U}writeUInt32(U){this._buff.writeUInt32BE(U,this._offset),this._offset+=4}readUInt32(){const U=this._buff.readUInt32BE(this._offset);return this._offset+=4,U}static sizeShortString(U){return 1+U.byteLength}writeShortString(U){this._buff.writeUInt8(U.byteLength,this._offset),this._offset+=1,this._buff.set(U,this._offset),this._offset+=U.byteLength}readShortString(){const U=this._buff.readUInt8(this._offset);this._offset+=1;const L=this._buff.slice(this._offset,this._offset+U).toString();return this._offset+=U,L}static sizeLongString(U){return 4+U.byteLength}writeLongString(U){this._buff.writeUInt32BE(U.byteLength,this._offset),this._offset+=4,this._buff.set(U,this._offset),this._offset+=U.byteLength}readLongString(){const U=this._buff.readUInt32BE(this._offset);this._offset+=4;const L=this._buff.slice(this._offset,this._offset+U).toString();return this._offset+=U,L}writeBuffer(U){this._buff.writeUInt32BE(U.byteLength,this._offset),this._offset+=4,this._buff.set(U,this._offset),this._offset+=U.byteLength}static sizeVSBuffer(U){return 4+U.byteLength}writeVSBuffer(U){this._buff.writeUInt32BE(U.byteLength,this._offset),this._offset+=4,this._buff.set(U,this._offset),this._offset+=U.byteLength}readVSBuffer(){const U=this._buff.readUInt32BE(this._offset);this._offset+=4;const W=this._buff.slice(this._offset,this._offset+U);return this._offset+=U,W}static sizeMixedArray(U){let W=0;W+=1;for(let L=0,S=U.length;L<S;L++){const z=U[L];switch(W+=1,z.type){case 1:W+=this.sizeLongString(z.value);break;case 2:W+=this.sizeVSBuffer(z.value);break;case 3:W+=this.sizeUInt32,W+=this.sizeLongString(z.value);for(let $=0;$<z.buffers.length;++$)W+=this.sizeVSBuffer(z.buffers[$]);break;case 4:break}}return W}writeMixedArray(U){this._buff.writeUInt8(U.length,this._offset),this._offset+=1;for(let W=0,L=U.length;W<L;W++){const S=U[W];switch(S.type){case 1:this.writeUInt8(1),this.writeLongString(S.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(S.value);break;case 3:this.writeUInt8(3),this.writeUInt32(S.buffers.length),this.writeLongString(S.value);for(let z=0;z<S.buffers.length;++z)this.writeBuffer(S.buffers[z]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const U=this._buff.readUInt8(this._offset);this._offset+=1;const W=new Array(U);for(let L=0;L<U;L++)switch(this.readUInt8()){case 1:W[L]=this.readLongString();break;case 2:W[L]=this.readVSBuffer();break;case 3:{const z=this.readUInt32(),$=this.readLongString(),F=[];for(let q=0;q<z;++q)F.push(this.readVSBuffer());W[L]=new O.SerializableObjectWithBuffers(o($,F,null));break}case 4:W[L]=void 0;break}return W}}r.sizeUInt32=4;var t;(function(C){C[C.Simple=0]="Simple",C[C.Mixed=1]="Mixed"})(t||(t={}));class c{static _useMixedArgSerialization(U){for(let W=0,L=U.length;W<L;W++)if(U[W]instanceof v.VSBuffer||U[W]instanceof O.SerializableObjectWithBuffers||typeof U[W]=="undefined")return!0;return!1}static serializeRequestArguments(U,W){if(this._useMixedArgSerialization(U)){const L=[];for(let S=0,z=U.length;S<z;S++){const $=U[S];if($ instanceof v.VSBuffer)L[S]={type:2,value:$};else if(typeof $=="undefined")L[S]={type:4};else if($ instanceof O.SerializableObjectWithBuffers){const{jsonString:F,referencedBuffers:q}=d($.value,W);L[S]={type:3,value:v.VSBuffer.fromString(F),buffers:q}}else L[S]={type:1,value:v.VSBuffer.fromString(g($,W))}}return{type:1,args:L}}return{type:0,args:g(U,W)}}static serializeRequest(U,W,L,S,z){switch(S.type){case 0:return this._requestJSONArgs(U,W,L,S.args,z);case 1:return this._requestMixedArgs(U,W,L,S.args,z)}}static _requestJSONArgs(U,W,L,S,z){const $=v.VSBuffer.fromString(L),F=v.VSBuffer.fromString(S);let q=0;q+=r.sizeUInt8(),q+=r.sizeShortString($),q+=r.sizeLongString(F);const ie=r.alloc(z?2:1,U,q);return ie.writeUInt8(W),ie.writeShortString($),ie.writeLongString(F),ie.buffer}static deserializeRequestJSONArgs(U){const W=U.readUInt8(),L=U.readShortString(),S=U.readLongString();return{rpcId:W,method:L,args:JSON.parse(S)}}static _requestMixedArgs(U,W,L,S,z){const $=v.VSBuffer.fromString(L);let F=0;F+=r.sizeUInt8(),F+=r.sizeShortString($),F+=r.sizeMixedArray(S);const q=r.alloc(z?4:3,U,F);return q.writeUInt8(W),q.writeShortString($),q.writeMixedArray(S),q.buffer}static deserializeRequestMixedArgs(U){const W=U.readUInt8(),L=U.readShortString(),S=U.readMixedArray(),z=new Array(S.length);for(let $=0,F=S.length;$<F;$++){const q=S[$];typeof q=="string"?z[$]=JSON.parse(q):z[$]=q}return{rpcId:W,method:L,args:z}}static serializeAcknowledged(U){return r.alloc(5,U,0).buffer}static serializeCancel(U){return r.alloc(6,U,0).buffer}static serializeReplyOK(U,W,L){if(typeof W=="undefined")return this._serializeReplyOKEmpty(U);if(W instanceof v.VSBuffer)return this._serializeReplyOKVSBuffer(U,W);if(W instanceof O.SerializableObjectWithBuffers){const{jsonString:S,referencedBuffers:z}=d(W.value,L,!0);return this._serializeReplyOKJSONWithBuffers(U,S,z)}else return this._serializeReplyOKJSON(U,m(W,L))}static _serializeReplyOKEmpty(U){return r.alloc(7,U,0).buffer}static _serializeReplyOKVSBuffer(U,W){let L=0;L+=r.sizeVSBuffer(W);const S=r.alloc(8,U,L);return S.writeVSBuffer(W),S.buffer}static deserializeReplyOKVSBuffer(U){return U.readVSBuffer()}static _serializeReplyOKJSON(U,W){const L=v.VSBuffer.fromString(W);let S=0;S+=r.sizeLongString(L);const z=r.alloc(9,U,S);return z.writeLongString(L),z.buffer}static _serializeReplyOKJSONWithBuffers(U,W,L){const S=v.VSBuffer.fromString(W);let z=0;z+=r.sizeUInt32,z+=r.sizeLongString(S);for(const F of L)z+=r.sizeVSBuffer(F);const $=r.alloc(10,U,z);$.writeUInt32(L.length),$.writeLongString(S);for(const F of L)$.writeBuffer(F);return $.buffer}static deserializeReplyOKJSON(U){const W=U.readLongString();return JSON.parse(W)}static deserializeReplyOKJSONWithBuffers(U,W){const L=U.readUInt32(),S=U.readLongString(),z=[];for(let $=0;$<L;++$)z.push(U.readVSBuffer());return new O.SerializableObjectWithBuffers(o(S,z,W))}static serializeReplyErr(U,W){const L=W?m(M.transformErrorForSerialization(W),null):void 0;if(typeof L!="string")return this._serializeReplyErrEmpty(U);const S=v.VSBuffer.fromString(L);let z=0;z+=r.sizeLongString(S);const $=r.alloc(11,U,z);return $.writeLongString(S),$.buffer}static deserializeReplyErrError(U){const W=U.readLongString();return JSON.parse(W)}static _serializeReplyErrEmpty(U){return r.alloc(12,U,0).buffer}}var _;(function(C){C[C.RequestJSONArgs=1]="RequestJSONArgs",C[C.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",C[C.RequestMixedArgs=3]="RequestMixedArgs",C[C.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",C[C.Acknowledged=5]="Acknowledged",C[C.Cancel=6]="Cancel",C[C.ReplyOKEmpty=7]="ReplyOKEmpty",C[C.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",C[C.ReplyOKJSON=9]="ReplyOKJSON",C[C.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",C[C.ReplyErrError=11]="ReplyErrError",C[C.ReplyErrEmpty=12]="ReplyErrEmpty"})(_||(_={}));var p;(function(C){C[C.String=1]="String",C[C.VSBuffer=2]="VSBuffer",C[C.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",C[C.Undefined=4]="Undefined"})(p||(p={}))}),define(ye[224],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const a=function(M){const D=P=>{self.removeEventListener("message",D);const E=P.data;Object.defineProperties(self,{postMessage:{value(T,O){E.postMessage(T,O)}},onmessage:{get(){return E.onmessage},set(T){E.onmessage=T}}}),E.addEventListener("message",T=>{self.dispatchEvent(new MessageEvent("message",{data:T.data}))}),E.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(M)};self.addEventListener("message",D)}.toString();class v extends EventTarget{constructor(M,D,P){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const E=`((${a})('${D}'))`,T=new Blob([E],{type:"application/javascript"}),O=URL.createObjectURL(T),y=new MessageChannel,m=O,k={type:"_newWorker",id:m,port:y.port2,url:O,options:P};M(k,[y.port2]),this.postMessage=y.port1.postMessage.bind(y.port1),this.terminate=()=>{M({type:"_terminateWorker",id:m}),URL.revokeObjectURL(O),y.port1.close(),y.port2.close()},Object.defineProperties(this,{onmessage:{get(){return y.port1.onmessage},set(f){y.port1.onmessage=f}},onmessageerror:{get(){return y.port1.onmessageerror},set(f){y.port1.onmessageerror=f}}}),y.port1.addEventListener("messageerror",f=>{const h=new MessageEvent("messageerror",{data:f.data});this.dispatchEvent(h)}),y.port1.addEventListener("message",f=>{const h=new MessageEvent("message",{data:f.data});this.dispatchEvent(h)}),y.port1.start()}}e.NestedWorker=v}),define(ye[225],De([1,0,5,30,38,3,39,11,14]),function(ne,e,a,v,b,M,D,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerLogChannel=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new b.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new b.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new b.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,M.createDecorator)(e.OUTPUT_SERVICE_ID);var T;(function(k){k[k.Append=1]="Append",k[k.Replace=2]="Replace",k[k.Clear=3]="Clear"})(T=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class O{constructor(){this.channels=new Map,this._onDidRegisterChannel=new a.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new a.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(f){this.channels.has(f.id)||(this.channels.set(f.id,f),this._onDidRegisterChannel.fire(f.id))}getChannels(){const f=[];return this.channels.forEach(h=>f.push(h)),f}getChannel(f){return this.channels.get(f)}removeChannel(f){this.channels.delete(f),this._onDidRemoveChannel.fire(f)}}v.Registry.add(e.Extensions.OutputChannels,new O);function y(k,f,h,d,o){return(0,E.createCancelablePromise)(async g=>{await(0,D.whenProviderRegistered)(h,d);const R=v.Registry.as(e.Extensions.OutputChannels);try{await m(h,1,d,o,g),R.registerChannel({id:k,label:f,file:h,log:!0})}catch(l){(0,P.isCancellationError)(l)||o.error("Error while registering log channel",h.toString(),(0,P.getErrorMessage)(l))}})}e.registerLogChannel=y;async function m(k,f,h,d,o){if(!await h.exists(k)){if(o.isCancellationRequested)throw new P.CancellationError;if(f>10)throw new Error("Timed out while waiting for file to be created");d.debug("[Registering Log Channel] File does not exist. Waiting for 1s to retry.",k.toString()),await(0,E.timeout)(1e3,o),await m(k,f+1,h,d,o)}}}),define(ye[99],De([1,0,4,7,3,13,15,225,51,28,35,112,23,10]),function(ne,e,a,v,b,M,D,P,E,T,O,y,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class f extends v.Disposable{constructor(o,g,R,l){super();this.id=o,this.name=g,this.logger=R,this.proxy=l,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(o){this.append(o+`
`)}append(o){this.write(o),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,P.OutputChannelUpdateMode.Append))}clear(){const o=this.offset;this.logger.flush(),this.proxy.$update(this.id,P.OutputChannelUpdateMode.Clear,o)}replace(o){const g=this.offset;this.write(o),this.proxy.$update(this.id,P.OutputChannelUpdateMode.Replace,g),this.visible&&this.logger.flush()}show(o,g){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof o=="boolean"?o:g))}hide(){this.proxy.$close(this.id)}write(o){this.offset+=m.VSBuffer.fromString(o).byteLength,this.logger.info(o)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=f;let h=class{constructor(o,g,R,l,w){this.extHostFileSystem=R,this.extHostFileSystemInfo=l,this.loggerService=w,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=o.getProxy(a.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(g.logsLocation,`output_logging_${(0,y.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(o){this.visibleChannelId=o;for(const[g,R]of this.channels)R.visible=g===this.visibleChannelId}createOutputChannel(o,g,R){if(o=o.trim(),!o)throw new Error("illegal argument `name`. must not be falsy");if((0,k.isString)(g)&&!g.trim())throw new Error("illegal argument `languageId`. must not be empty");const l=this.doCreateOutputChannel(o,g,R);return l.then(w=>{this.channels.set(w.id,w),w.visible=w.id===this.visibleChannelId}),this.createExtHostOutputChannel(o,l)}async doCreateOutputChannel(o,g,R){const l=await this.createOutputDirectory(),w=this.extHostFileSystemInfo.extUri.joinPath(l,`${this.namePool++}-${o.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),s=this.loggerService.createLogger(w,{always:!0,donotRotate:!0,donotUseFormatters:!0}),u=await this.proxy.$register(o,!1,w,g,R.identifier.value);return new f(u,o,s,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(o,g){let R=!1;const l=()=>{if(R)throw new Error("Channel has been closed")};return{get name(){return o},append(w){l(),g.then(s=>s.append(w))},appendLine(w){l(),g.then(s=>s.appendLine(w))},clear(){l(),g.then(w=>w.clear())},replace(w){l(),g.then(s=>s.replace(w))},show(w,s){l(),g.then(u=>u.show(w,s))},hide(){l(),g.then(w=>w.hide())},dispose(){R=!0,g.then(w=>w.dispose())}}}};h=ze([xe(0,M.IExtHostRpcService),xe(1,T.IExtHostInitDataService),xe(2,E.IExtHostConsumerFileSystem),xe(3,O.IExtHostFileSystemInfo),xe(4,D.ILoggerService)],h),e.ExtHostOutputService=h,e.IExtHostOutputService=(0,b.createDecorator)("IExtHostOutputService")}),define(ye[226],De([1,0,3]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,a.createDecorator)("remoteAgentService")}),define(ye[227],De([1,0,37,12,19,21,22,2,3,157,45,179,226]),function(ne,e,a,v,b,M,D,P,E,T,O,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,E.createDecorator)("pathService");let k=class Zi{constructor(h,d,o,g){this.localUserHome=h,this.remoteAgentService=d,this.environmentService=o,this.contextService=g,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||M.OS)(),this.resolveUserHome=(async()=>{const R=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=R?.userHome??h})()}hasValidBasename(h,d,o){return typeof d=="string"||typeof d=="undefined"?this.resolveOS.then(g=>this.doHasValidBasename(h,g,d)):this.doHasValidBasename(h,d,o)}doHasValidBasename(h,d,o){return h.scheme===v.Schemas.file||h.scheme===v.Schemas.vscodeRemote?(0,a.isValidBasename)(o??(0,D.basename)(h),d===1):!0}get defaultUriScheme(){return Zi.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(h,d){if(h.remoteAuthority)return v.Schemas.vscodeRemote;const o=(0,T.getVirtualWorkspaceScheme)(d.getWorkspace());if(o)return o;const g=d.getWorkspace().folders[0];if(g)return g.uri.scheme;const R=d.getWorkspace().configuration;return R?R.scheme:v.Schemas.file}userHome(h){return h?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(h=>h===1?b.win32:b.posix)}async fileURI(h){let d="";if(await this.resolveOS===1&&(h=h.replace(/\\/g,"/")),h[0]==="/"&&h[1]==="/"){const g=h.indexOf("/",2);g===-1?(d=h.substring(2),h="/"):(d=h.substring(2,g),h=h.substring(g)||"/")}return P.URI.from({scheme:v.Schemas.file,authority:d,path:h,query:"",fragment:""})}};k=ze([xe(1,m.IRemoteAgentService),xe(2,y.IWorkbenchEnvironmentService),xe(3,O.IWorkspaceContextService)],k),e.AbstractPathService=k}),define(ye[100],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class a{constructor(D,P){this.line=D,this.character=P}isBefore(D){return!1}isBeforeOrEqual(D){return!1}isAfter(D){return!1}isAfterOrEqual(D){return!1}isEqual(D){return!1}compareTo(D){return 0}translate(D,P){return new a(0,0)}with(D){return new a(0,0)}}e.Position=a;class v{constructor(D,P,E,T){this.isEmpty=!1,this.isSingleLine=!1,this.start=new a(D,P),this.end=new a(E,T)}contains(D){return!1}isEqual(D){return!1}intersection(D){}union(D){return new v(0,0,0,0)}with(D){return new v(0,0,0,0)}}e.Range=v;var b;(function(M){M[M.Information=1]="Information",M[M.Warning=2]="Warning"})(b=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(ye[41],De([1,0,16,34,26,37,9,3,19,11,100,14]),function(ne,e,a,v,b,M,D,P,E,T,O,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return O.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const m="\u27EA ",k=" characters skipped \u27EB",f=(m.length+k.length+5)*2;e.ISearchService=(0,P.createDecorator)("searchService");var h;(function(oe){oe[oe.file=0]="file",oe[oe.text=1]="text"})(h=e.SearchProviderType||(e.SearchProviderType={}));var d;(function(oe){oe[oe.File=1]="File",oe[oe.Text=2]="Text"})(d=e.QueryType||(e.QueryType={}));function o(oe){return!!oe.preview}e.resultIsMatch=o;function g(oe){return!!oe.resource}e.isFileMatch=g;function R(oe){return!!oe.message}e.isProgressMessage=R;var l;(function(oe){oe[oe.Normal=0]="Normal",oe[oe.NewSearchStarted=1]="NewSearchStarted"})(l=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class w{constructor(ue){this.resource=ue,this.results=[]}}e.FileMatch=w;class s{constructor(ue,te,Ee){this.ranges=te;const be=Array.isArray(te)?te:[te];if(Ee&&Ee.matchLines===1&&u(be)){ue=(0,D.getNLines)(ue,Ee.matchLines);let ee="",ve=0,Ae=0;const Fe=Math.floor(Ee.charsPerLine/5),$e=[];for(const Qe of be){const Ie=Math.max(Qe.startColumn-Fe,0),Se=Qe.startColumn+Ee.charsPerLine;if(Ie>Ae+Fe+f){const ke=m+(Ie-Ae)+k;ee+=ke+ue.slice(Ie,Se),ve+=Ie-(Ae+ke.length)}else ee+=ue.slice(Ae,Se);$e.push(new i(0,Qe.startColumn-ve,Qe.endColumn-ve)),Ae=Se}this.preview={text:ee,matches:Array.isArray(this.ranges)?$e:$e[0]}}else{const ee=Array.isArray(te)?te[0].startLineNumber:te.startLineNumber;this.preview={text:ue,matches:(0,a.mapArrayOrNot)(te,ve=>new n(ve.startLineNumber-ee,ve.startColumn,ve.endLineNumber-ee,ve.endColumn))}}}}e.TextSearchMatch=s;function u(oe){const ue=oe[0].startLineNumber;for(const te of oe)if(te.startLineNumber!==ue||te.endLineNumber!==ue)return!1;return!0}class n{constructor(ue,te,Ee,be){this.startLineNumber=ue,this.startColumn=te,this.endLineNumber=Ee,this.endColumn=be}}e.SearchRange=n;class i extends n{constructor(ue,te,Ee){super(ue,te,ue,Ee)}}e.OneLineRange=i;var r;(function(oe){oe.Default="default",oe.FileNames="fileNames",oe.Type="type",oe.Modified="modified",oe.CountDescending="countDescending",oe.CountAscending="countAscending"})(r=e.SearchSortOrder||(e.SearchSortOrder={}));function t(oe,ue=!0){const te=oe&&oe.files&&oe.files.exclude,Ee=ue&&oe&&oe.search&&oe.search.exclude;if(!te&&!Ee)return;if(!te||!Ee)return te||Ee;let be=Object.create(null);return be=b.mixin(be,b.deepClone(te)),be=b.mixin(be,b.deepClone(Ee),!0),be}e.getExcludes=t;function c(oe,ue){return oe.excludePattern&&v.match(oe.excludePattern,ue)?!1:oe.includePattern||oe.usingSearchPaths?oe.includePattern&&v.match(oe.includePattern,ue)?!0:oe.usingSearchPaths?!!oe.folderQueries&&oe.folderQueries.some(te=>{const Ee=te.folder.fsPath;if(M.isEqualOrParent(ue,Ee)){const be=E.relative(Ee,ue);return!te.includePattern||!!v.match(te.includePattern,be)}else return!1}):!1:!0}e.pathIncludedInQuery=c;var _;(function(oe){oe[oe.unknownEncoding=1]="unknownEncoding",oe[oe.regexParseError=2]="regexParseError",oe[oe.globParseError=3]="globParseError",oe[oe.invalidLiteral=4]="invalidLiteral",oe[oe.rgProcessError=5]="rgProcessError",oe[oe.other=6]="other",oe[oe.canceled=7]="canceled"})(_=e.SearchErrorCode||(e.SearchErrorCode={}));class p extends Error{constructor(ue,te){super(ue);this.code=te}}e.SearchError=p;function C(oe){const ue=oe.message;if((0,T.isCancellationError)(oe))return new p(ue,_.canceled);try{const te=JSON.parse(ue);return new p(te.message,te.code)}catch{return new p(ue,_.other)}}e.deserializeSearchError=C;function U(oe){const ue={message:oe.message,code:oe.code};return new Error(JSON.stringify(ue))}e.serializeSearchError=U;function W(oe){return oe.type==="error"?!0:oe.type==="success"}e.isSerializedSearchComplete=W;function L(oe){return oe.type==="success"}e.isSerializedSearchSuccess=L;function S(oe){return!!oe.path}e.isSerializedFileMatch=S;function z(oe,ue){const te=oe.searchPath?oe.searchPath:oe.relativePath;return(0,D.fuzzyContains)(te,ue)}e.isFilePatternMatch=z;class ${constructor(ue){this.path=ue,this.results=[]}addMatch(ue){this.results.push(ue)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=$;function F(oe,ue){const te={...oe||{},...ue||{}};return Object.keys(te).filter(Ee=>{const be=te[Ee];return typeof be=="boolean"&&be})}e.resolvePatternsForProvider=F;class q{constructor(ue,te){this._parsedIncludeExpression=null,this._excludeExpression={...ue.excludePattern||{},...te.excludePattern||{}},this._parsedExcludeExpression=v.parse(this._excludeExpression);let Ee=ue.includePattern;te.includePattern&&(Ee?Ee={...Ee,...te.includePattern}:Ee=te.includePattern),Ee&&(this._parsedIncludeExpression=v.parse(Ee))}matchesExcludesSync(ue,te,Ee){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ue,te,Ee))}includedInQuerySync(ue,te,Ee){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ue,te,Ee)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(ue,te,Ee))}includedInQuery(ue,te,Ee){const be=this._parsedExcludeExpression(ue,te,Ee),ee=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(ue,te,Ee):!0;return(0,y.isThenable)(be)?be.then(ve=>ve?!1:ee()):ee()}hasSiblingExcludeClauses(){return ie(this._excludeExpression)}}e.QueryGlobTester=q;function ie(oe){for(const ue in oe)if(typeof oe[ue]!="boolean")return!0;return!1}function A(oe){if(!oe)return;let ue;return te=>(ue||(ue=(oe()||Promise.resolve([])).then(Ee=>Ee?le(Ee):{})),ue.then(Ee=>!!Ee[te]))}e.hasSiblingPromiseFn=A;function Z(oe){if(!oe)return;let ue;return te=>{if(!ue){const Ee=oe();ue=Ee?le(Ee):{}}return!!ue[te]}}e.hasSiblingFn=Z;function le(oe){const ue={};for(const te of oe)ue[te]=!0;return ue}}),define(ye[31],De([1,0,16,14,20,5,25,12,107,22,9,10,2,135,3,15,149,45,35,28,13,8,6,41,4]),function(ne,e,a,v,b,M,D,P,E,T,O,y,m,k,f,h,d,o,g,R,l,w,s,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function i(W,L,S){return new T.ExtUri(z=>_(z,S)).isEqual(W,L)}function r(W,L,S){return i(W.uri,L.uri,S)?0:(0,O.compare)(W.uri.toString(),L.uri.toString())}function t(W,L,S){return W.index!==L.index?W.index<L.index?-1:1:i(W.uri,L.uri,S)?(0,O.compare)(W.name,L.name):(0,O.compare)(W.uri.toString(),L.uri.toString())}function c(W,L,S,z){const $=W.slice(0).sort((q,ie)=>S(q,ie,z)),F=L.slice(0).sort((q,ie)=>S(q,ie,z));return(0,a.delta)($,F,(q,ie)=>S(q,ie,z))}function _(W,L){const S=L.getCapabilities(W.scheme);return!(S&&S&1024)}class p extends o.Workspace{constructor(L,S,z,$,F,q,ie){super(L,z.map(A=>new o.WorkspaceFolder(A)),$,F,ie);this._name=S,this._isUntitled=q,this._workspaceFolders=[],this._structure=D.TernarySearchTree.forUris(ie),z.forEach(A=>{this._workspaceFolders.push(A),this._structure.set(A.uri,A)})}static toExtHostWorkspace(L,S,z,$){if(!L)return{workspace:null,added:[],removed:[]};const{id:F,name:q,folders:ie,configuration:A,transient:Z,isUntitled:le}=L,oe=[],ue=S;S?ie.forEach((ee,ve)=>{const Ae=m.URI.revive(ee.uri),Fe=p._findFolder(z||S,Ae,$);Fe?(Fe.name=ee.name,Fe.index=ee.index,oe.push(Fe)):oe.push({uri:Ae,name:ee.name,index:ve})}):oe.push(...ie.map(({uri:ee,name:ve,index:Ae})=>({uri:m.URI.revive(ee),name:ve,index:Ae}))),oe.sort((ee,ve)=>ee.index<ve.index?-1:1);const te=new p(F,q,oe,!!Z,A?m.URI.revive(A):null,!!le,ee=>_(ee,$)),{added:Ee,removed:be}=c(ue?ue.workspaceFolders:[],te.workspaceFolders,r,$);return{workspace:te,added:Ee,removed:be}}static _findFolder(L,S,z){for(let $=0;$<L.folders.length;$++){const F=L.workspaceFolders[$];if(i(F.uri,S,z))return F}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(L,S){return S&&this._structure.get(L)&&(L=(0,T.dirname)(L)),this._structure.findSubstr(L)}resolveWorkspaceFolder(L){return this._structure.get(L)}}let C=class{constructor(L,S,z,$){this._onDidChangeWorkspace=new M.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new M.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=$,this._extHostFileSystemInfo=z,this._requestIdProvider=new E.Counter,this._barrier=new v.Barrier,this._proxy=L.getProxy(n.MainContext.MainThreadWorkspace),this._messageService=L.getProxy(n.MainContext.MainThreadMessageService);const F=S.workspace;this._confirmedWorkspace=F?new p(F.id,F.name,[],!!F.transient,F.configuration?m.URI.revive(F.configuration):null,!!F.isUntitled,q=>_(q,z)):void 0}$initializeWorkspace(L,S){this._trusted=S,this.$acceptWorkspaceData(L),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?m.URI.from({scheme:P.Schemas.untitled,path:(0,T.basename)((0,T.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(L,S,z,...$){const F=[];if(Array.isArray($)&&$.forEach(le=>{m.URI.isUri(le.uri)&&!F.some(oe=>i(oe.uri,le.uri,this._extHostFileSystemInfo))&&F.push({uri:le.uri,name:le.name||(0,T.basenameOrAuthority)(le.uri)})}),this._unconfirmedWorkspace||[S,z].some(le=>typeof le!="number"||le<0)||z===0&&F.length===0)return!1;const q=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(S+z>q.length)return!1;const ie=q.slice(0);ie.splice(S,z,...F.map(le=>({uri:le.uri,name:le.name||(0,T.basenameOrAuthority)(le.uri),index:void 0})));for(let le=0;le<ie.length;le++){const oe=ie[le];if(ie.some((ue,te)=>te!==le&&i(oe.uri,ue.uri,this._extHostFileSystemInfo)))return!1}ie.forEach((le,oe)=>le.index=oe);const{added:A,removed:Z}=c(q,ie,t,this._extHostFileSystemInfo);if(A.length===0&&Z.length===0)return!1;if(this._proxy){const le=L.displayName||L.name;this._proxy.$updateWorkspaceFolders(le,S,z,F).then(void 0,oe=>{this._unconfirmedWorkspace=void 0;const ue={source:{identifier:L.identifier,label:L.displayName||L.name}};this._messageService.$showMessage(d.Severity.Error,(0,k.localize)(0,null,le,oe.toString()),ue,[])})}return this.trySetWorkspaceFolders(ie),!0}getWorkspaceFolder(L,S){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,S)}async getWorkspaceFolder2(L,S){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,S)}async resolveWorkspaceFolder(L){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(L)}getPath(){if(!this._actualWorkspace)return;const{folders:L}=this._actualWorkspace;if(L.length!==0)return L[0].uri.fsPath}getRelativePath(L,S){let z,$="";if(typeof L=="string"?(z=m.URI.file(L),$=L):typeof L!="undefined"&&(z=L,$=L.fsPath),!z)return $;const F=this.getWorkspaceFolder(z,!0);if(!F)return $;typeof S=="undefined"&&this._actualWorkspace&&(S=this._actualWorkspace.folders.length>1);let q=(0,T.relativePath)(F.uri,z);return S&&F.name&&(q=`${F.name}/${q}`),q}trySetWorkspaceFolders(L){this._actualWorkspace&&(this._unconfirmedWorkspace=p.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:L,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(L){const{workspace:S,added:z,removed:$}=p.toExtHostWorkspace(L,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=S||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:z,removed:$}))}findFiles(L,S,z,$,F=b.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${$.value}, entryPoint: findFiles`);let q;if(S===null?q=!1:S&&(typeof S=="string"?q=S:q=S.pattern),F&&F.isCancellationRequested)return Promise.resolve([]);const{includePattern:ie,folder:A}=U(w.GlobPattern.from(L));return this._proxy.$startFileSearch((0,y.withUndefinedAsNull)(ie),(0,y.withUndefinedAsNull)(A),(0,y.withUndefinedAsNull)(q),(0,y.withUndefinedAsNull)(z),F).then(Z=>Array.isArray(Z)?Z.map(le=>m.URI.revive(le)):[])}async findTextInFiles(L,S,z,$,F=b.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${$.value}, entryPoint: findTextInFiles`);const q=this._requestIdProvider.getNext(),ie=typeof S.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:S.previewOptions,{includePattern:A,folder:Z}=U(w.GlobPattern.from(S.include)),le=typeof S.exclude=="string"?S.exclude:S.exclude?S.exclude.pattern:void 0,oe={ignoreSymlinks:typeof S.followSymlinks=="boolean"?!S.followSymlinks:void 0,disregardIgnoreFiles:typeof S.useIgnoreFiles=="boolean"?!S.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof S.useGlobalIgnoreFiles=="boolean"?!S.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof S.useParentIgnoreFiles=="boolean"?!S.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof S.useDefaultExcludes=="boolean"?!S.useDefaultExcludes:!0,fileEncoding:S.encoding,maxResults:S.maxResults,previewOptions:ie,afterContext:S.afterContext,beforeContext:S.beforeContext,includePattern:A,excludePattern:le},ue=!1;if(this._activeSearchCallbacks[q]=te=>{if(ue)return;const Ee=m.URI.revive(te.resource);te.results.forEach(be=>{(0,u.resultIsMatch)(be)?z({uri:Ee,preview:{text:be.preview.text,matches:(0,a.mapArrayOrNot)(be.preview.matches,ee=>new s.Range(ee.startLineNumber,ee.startColumn,ee.endLineNumber,ee.endColumn))},ranges:(0,a.mapArrayOrNot)(be.ranges,ee=>new s.Range(ee.startLineNumber,ee.startColumn,ee.endLineNumber,ee.endColumn))}):z({uri:Ee,text:be.text,lineNumber:be.lineNumber})})},F.isCancellationRequested)return{};try{const te=await this._proxy.$startTextSearch(L,(0,y.withUndefinedAsNull)(Z),oe,q,F);return delete this._activeSearchCallbacks[q],te||{}}catch(te){throw delete this._activeSearchCallbacks[q],te}}$handleTextSearchResult(L,S){this._activeSearchCallbacks[S]?.(L)}saveAll(L){return this._proxy.$saveAll(L)}resolveProxy(L){return this._proxy.$resolveProxy(L)}get trusted(){return this._trusted}requestWorkspaceTrust(L){return this._proxy.$requestWorkspaceTrust(L)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};C=ze([xe(0,l.IExtHostRpcService),xe(1,R.IExtHostInitDataService),xe(2,g.IExtHostFileSystemInfo),xe(3,h.ILogService)],C),e.ExtHostWorkspace=C,e.IExtHostWorkspace=(0,f.createDecorator)("IExtHostWorkspace");function U(W){let L,S;return W&&(typeof W=="string"?L=W:(L=W.pattern,S=m.URI.revive(W.baseUri))),{includePattern:L,folder:S}}}),define(ye[32],De([1,0,26,5,31,4,6,152,83,10,14,3,13,15,2]),function(ne,e,a,v,b,M,D,P,E,T,O,y,m,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function h(u,n){if(n){const i=n.split(".");let r=u;for(let t=0;r&&t<i.length;t++)r=r[i[t]];return r}}function d(u){return u instanceof f.URI}function o(u){return u&&u.uri instanceof f.URI&&u.languageId&&typeof u.languageId=="string"}function g(u){return u&&!u.uri&&u.languageId&&typeof u.languageId=="string"}function R(u){return u&&u.uri instanceof f.URI&&(!u.name||typeof u.name=="string")&&(!u.index||typeof u.index=="number")}function l(u){if(d(u))return{resource:u};if(o(u))return{resource:u.uri,overrideIdentifier:u.languageId};if(g(u))return{overrideIdentifier:u.languageId};if(R(u))return{resource:u.uri};if(u===null)return{resource:null}}let w=class{constructor(n,i,r){this._proxy=n.getProxy(M.MainContext.MainThreadConfiguration),this._extHostWorkspace=i,this._logService=r,this._barrier=new O.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(n=>this._actual)}$initializeConfiguration(n){this._actual=new s(this._proxy,this._extHostWorkspace,n,this._logService),this._barrier.open()}$acceptConfigurationChanged(n,i){this.getConfigProvider().then(r=>r.$acceptConfigurationChanged(n,i))}};w=ze([xe(0,m.IExtHostRpcService),xe(1,b.IExtHostWorkspace),xe(2,k.ILogService)],w),e.ExtHostConfiguration=w;class s{constructor(n,i,r,t){this._onDidChangeConfiguration=new v.Emitter,this._proxy=n,this._logService=t,this._extHostWorkspace=i,this._configuration=P.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(n,i){const r={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=P.Configuration.parse(n),this._configurationScopes=this._toMap(n.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(i,r))}getConfiguration(n,i,r){const t=l(i)||{},c=this._toReadonlyValue(n?h(this._configuration.getValue(void 0,t,this._extHostWorkspace.workspace),n):this._configuration.getValue(void 0,t,this._extHostWorkspace.workspace));n&&this._validateConfigurationAccess(n,t,r?.identifier);function _(C){if(C==null)return null;if(typeof C=="boolean")return C?2:5;switch(C){case D.ConfigurationTarget.Global:return 2;case D.ConfigurationTarget.Workspace:return 5;case D.ConfigurationTarget.WorkspaceFolder:return 6}}const p={has(C){return typeof h(c,C)!="undefined"},get:(C,U)=>{this._validateConfigurationAccess(n?`${n}.${C}`:C,t,r?.identifier);let W=h(c,C);if(typeof W=="undefined")W=U;else{let L;const S=(z,$)=>{let F;const q=()=>{L=L||(0,a.deepClone)(c),F=F||h(L,$)};return(0,T.isObject)(z)?new Proxy(z,{get:(ie,A)=>{if(typeof A=="string"&&A.toLowerCase()==="tojson")return q(),()=>F;if(L)return F=F||h(L,$),F[A];const Z=ie[A];return typeof A=="string"?S(Z,`${$}.${A}`):Z},set:(ie,A,Z)=>(q(),F&&(F[A]=Z),!0),deleteProperty:(ie,A)=>(q(),F&&delete F[A],!0),defineProperty:(ie,A,Z)=>(q(),F&&Object.defineProperty(F,A,Z),!0)}):z};W=S(W,C)}return W},update:(C,U,W,L)=>{C=n?`${n}.${C}`:C;const S=_(W);return U!==void 0?this._proxy.$updateConfigurationOption(S,C,U,t,L):this._proxy.$removeConfigurationOption(S,C,t,L)},inspect:C=>{C=n?`${n}.${C}`:C;const U=(0,a.deepClone)(this._configuration.inspect(C,t,this._extHostWorkspace.workspace));if(U)return{key:C,defaultValue:U.policy?.value??U.default?.value,globalValue:U.user?.value??U.application?.value,workspaceValue:U.workspace?.value,workspaceFolderValue:U.workspaceFolder?.value,defaultLanguageValue:U.default?.override,globalLanguageValue:U.user?.override??U.application?.override,workspaceLanguageValue:U.workspace?.override,workspaceFolderLanguageValue:U.workspaceFolder?.override,languageIds:U.overrideIdentifiers}}};return typeof c=="object"&&(0,a.mixin)(p,c,!1),Object.freeze(p)}_toReadonlyValue(n){const i=r=>(0,T.isObject)(r)?new Proxy(r,{get:(t,c)=>i(t[c]),set:(t,c,_)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(c)}' of object`)},deleteProperty:(t,c)=>{throw new Error(`TypeError: Cannot delete read only property '${String(c)}' of object`)},defineProperty:(t,c)=>{throw new Error(`TypeError: Cannot define property '${String(c)}' for a readonly object`)},setPrototypeOf:t=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):r;return i(n)}_validateConfigurationAccess(n,i,r){const t=E.OVERRIDE_PROPERTY_REGEX.test(n)?4:this._configurationScopes.get(n),c=r?`[${r.value}] `:"";if(t===4){typeof i?.resource=="undefined"&&this._logService.warn(`${c}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${n}', provide the URI of a resource or 'null' for any resource.`);return}if(t===3){i?.resource&&this._logService.warn(`${c}Accessing a window scoped configuration for a resource is not expected. To associate '${n}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(n,i){const r=new P.ConfigurationChangeEvent(n,i,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(t,c)=>r.affectsConfiguration(t,l(c))})}_toMap(n){return n.reduce((i,r)=>(i.set(r[0],r[1]),i),new Map)}}e.ExtHostConfigProvider=s,e.IExtHostConfiguration=(0,y.createDecorator)("IExtHostConfiguration")});var Ye=this&&this.__classPrivateFieldSet||function(ne,e,a,v,b){if(v==="m")throw new TypeError("Private method is not writable");if(v==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return v==="a"?b.call(ne,a):b?b.value=a:e.set(ne,a),a},Oe=this&&this.__classPrivateFieldGet||function(ne,e,a,v){if(a==="a"&&!v)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!v:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?v:a==="a"?v.call(ne):v?v.value:e.get(ne)};define(ye[101],De([1,0,2,14,5,4,6,31,49,32,20,52,13,28,3,12,21,15,68,186,11]),function(ne,e,a,v,b,M,D,P,E,T,O,y,m,k,f,h,d,o,g,R,l){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var s;(function($){function F(ie){if(ie!=null)return ie}$.from=F;function q(ie){if(ie!=null)return ie}$.to=q})(s=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var u;(function($){function F(ie){if(ie!=null)return ie}$.from=F;function q(ie){if(ie!=null)return ie}$.to=q})(u=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var n;(function($){function F(ie){if(ie!=null)return ie}$.from=F;function q(ie){if(ie!=null)return ie}$.to=q})(n=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var i;(function($){function F(A){if(A){const Z=A;return Z&&!!Z.process}else return!1}$.is=F;function q(A){if(A==null)return;const Z={process:A.process,args:A.args};return A.options&&(Z.options=n.from(A.options)),Z}$.from=q;function ie(A){if(A!=null)return new D.ProcessExecution(A.process,A.args,A.options)}$.to=ie})(i=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var r;(function($){function F(ie){if(ie!=null)return ie}$.from=F;function q(ie){if(ie!=null)return ie}$.to=q})(r=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var t;(function($){function F(A){if(A){const Z=A;return Z&&(!!Z.commandLine||!!Z.command)}else return!1}$.is=F;function q(A){if(A==null)return;const Z={};return A.commandLine!==void 0?Z.commandLine=A.commandLine:(Z.command=A.command,Z.args=A.args),A.options&&(Z.options=r.from(A.options)),Z}$.from=q;function ie(A){if(!(A==null||A.command===void 0&&A.commandLine===void 0))return A.commandLine?new D.ShellExecution(A.commandLine,A.options):new D.ShellExecution(A.command,A.args?A.args:[],A.options)}$.to=ie})(t=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var c;(function($){function F(A){if(A){const Z=A;return Z&&Z.customExecution==="customExecution"}else return!1}$.is=F;function q(A){return{customExecution:"customExecution"}}$.from=q;function ie(A,Z){return Z.get(A)}$.to=ie})(c=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var _;(function($){function F(q,ie){let A;return q.scope!==void 0&&typeof q.scope!="number"?A=q.scope.uri:q.scope!==void 0&&typeof q.scope=="number"&&(q.scope===D.TaskScope.Workspace&&ie&&ie.workspaceFile?A=ie.workspaceFile:A=R.USER_TASKS_GROUP_KEY),{id:q._id,workspaceFolder:A}}$.from=F})(_=e.TaskHandleDTO||(e.TaskHandleDTO={}));var p;(function($){function F(q){if(q!=null)return{_id:q.id,isDefault:q.isDefault}}$.from=F})(p=e.TaskGroupDTO||(e.TaskGroupDTO={}));var C;(function($){function F(A,Z){if(A==null)return[];const le=[];for(const oe of A){const ue=q(oe,Z);ue&&le.push(ue)}return le}$.fromMany=F;function q(A,Z){if(A==null)return;let le;A.execution instanceof D.ProcessExecution?le=i.from(A.execution):A.execution instanceof D.ShellExecution?le=t.from(A.execution):A.execution&&A.execution instanceof D.CustomExecution&&(le=c.from(A.execution));const oe=s.from(A.definition);let ue;return A.scope?typeof A.scope=="number"?ue=A.scope:ue=A.scope.uri:ue=D.TaskScope.Workspace,!oe||!ue?void 0:{_id:A._id,definition:oe,name:A.name,source:{extensionId:Z.identifier.value,label:A.source,scope:ue},execution:le,isBackground:A.isBackground,group:p.from(A.group),presentationOptions:u.from(A.presentationOptions),problemMatchers:A.problemMatchers,hasDefinedMatchers:A.hasDefinedMatchers,runOptions:A.runOptions?A.runOptions:{reevaluateOnRerun:!0},detail:A.detail}}$.from=q;async function ie(A,Z,le){if(A==null)return;let oe;i.is(A.execution)?oe=i.to(A.execution):t.is(A.execution)?oe=t.to(A.execution):c.is(A.execution)&&(oe=c.to(A._id,le));const ue=s.to(A.definition);let te;if(A.source&&(A.source.scope!==void 0?typeof A.source.scope=="number"?te=A.source.scope:te=await Z.resolveWorkspaceFolder(a.URI.revive(A.source.scope)):te=D.TaskScope.Workspace),!ue||!te)return;const Ee=new D.Task(ue,te,A.name,A.source.label,oe,A.problemMatchers);return A.isBackground!==void 0&&(Ee.isBackground=A.isBackground),A.group!==void 0&&(Ee.group=D.TaskGroup.from(A.group._id),Ee.group&&A.group.isDefault&&(Ee.group=new D.TaskGroup(Ee.group.id,Ee.group.label),A.group.isDefault===!0&&(Ee.group.isDefault=A.group.isDefault))),A.presentationOptions&&(Ee.presentationOptions=u.to(A.presentationOptions)),A._id&&(Ee._id=A._id),A.detail&&(Ee.detail=A.detail),Ee}$.to=ie})(C=e.TaskDTO||(e.TaskDTO={}));var U;(function($){function F(ie){return ie}$.from=F;function q(ie){if(!!ie)return Object.assign(Object.create(null),ie)}$.to=q})(U=e.TaskFilterDTO||(e.TaskFilterDTO={}));class W{constructor(F,q,ie){this._id=q,this._task=ie,w.set(this,void 0),Ye(this,w,F,"f")}get task(){return this._task}terminate(){Oe(this,w,"f").terminateTask(this)}fireDidStartProcess(F){}fireDidEndProcess(F){}}w=new WeakMap;var L;(function($){function F(q){return{id:q._id,task:void 0}}$.from=F})(L=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let S=class{constructor(F,q,ie,A,Z,le,oe,ue){this._onDidExecuteTask=new b.Emitter,this._onDidTerminateTask=new b.Emitter,this._onDidTaskProcessStarted=new b.Emitter,this._onDidTaskProcessEnded=new b.Emitter,this._proxy=F.getProxy(M.MainContext.MainThreadTask),this._workspaceProvider=ie,this._editorService=A,this._configurationService=Z,this._terminalService=le,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=oe,this._deprecationService=ue,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(F,q,ie){if(!ie)return new D.Disposable(()=>{});const A=this.nextHandle();return this._handlers.set(A,{type:q,provider:ie,extension:F}),this._proxy.$registerTaskProvider(A,q),new D.Disposable(()=>{this._handlers.delete(A),this._proxy.$unregisterTaskProvider(A)})}registerTaskSystem(F,q){this._proxy.$registerTaskSystem(F,q)}fetchTasks(F){return this._proxy.$fetchTasks(U.from(F)).then(async q=>{const ie=[];for(const A of q){const Z=await C.to(A,this._workspaceProvider,this._providedCustomExecutions2);Z&&ie.push(Z)}return ie})}get taskExecutions(){const F=[];return this._taskExecutions.forEach(q=>F.push(q)),F}terminateTask(F){if(!(F instanceof W))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(F._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(F,q,ie){const A=this._providedCustomExecutions2.get(F.id);A&&(this._activeCustomExecutions2.set(F.id,A),this._terminalService.attachPtyToTerminal(q,await A.callback(ie))),this._lastStartedTask=F.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(F)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(F){const q=await this.getTaskExecution(F);this._taskExecutionPromises.delete(F.id),this._taskExecutions.delete(F.id),this.customExecutionComplete(F),this._onDidTerminateTask.fire({execution:q})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(F){const q=await this.getTaskExecution(F.id);this._onDidTaskProcessStarted.fire({execution:q,processId:F.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(F){const q=await this.getTaskExecution(F.id);this._onDidTaskProcessEnded.fire({execution:q,exitCode:F.exitCode})}$provideTasks(F,q){const ie=this._handlers.get(F);if(!ie)return Promise.reject(new Error("no handler found"));const A=[],Z=(0,v.asPromise)(()=>ie.provider.provideTasks(O.CancellationToken.None)).then(le=>this.provideTasksInternal(q,A,ie,le));return new Promise(le=>{Z.then(oe=>{Promise.all(A).then(()=>{le(oe)})})})}async $resolveTask(F,q){const ie=this._handlers.get(F);if(!ie)return Promise.reject(new Error("no handler found"));if(q.definition.type!==ie.type)throw new Error(`Unexpected: Task of type [${q.definition.type}] cannot be resolved by provider of type [${ie.type}].`);const A=await C.to(q,this._workspaceProvider,this._providedCustomExecutions2);if(!A)throw new Error("Unexpected: Task cannot be resolved.");const Z=await ie.provider.resolveTask(A,O.CancellationToken.None);if(!Z)return;this.checkDeprecation(Z,ie);const le=C.from(Z,ie.extension);if(!le)throw new Error("Unexpected: Task cannot be resolved.");if(Z.definition!==A.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return c.is(le.execution)&&await this.addCustomExecution(le,Z,!0),await this.resolveTaskInternal(le)}nextHandle(){return this._handleCounter++}async addCustomExecution(F,q,ie){const A=await this._proxy.$createTaskId(F);!ie&&!this._providedCustomExecutions2.has(A)&&(this._notProvidedCustomExecutions.add(A),this._activeCustomExecutions2.set(A,q.execution)),this._providedCustomExecutions2.set(A,q.execution)}async getTaskExecution(F,q){if(typeof F=="string"){const Z=this._taskExecutionPromises.get(F);if(!Z)throw new Error("Unexpected: The specified task is missing an execution");return Z}const ie=this._taskExecutionPromises.get(F.id);if(ie)return ie;const A=new Promise((Z,le)=>{function oe(ue,te,Ee){Ee?Z(new W(ue,te.id,Ee)):le("Unexpected: Task does not exist.")}q?oe(this,F,q):C.to(F.task,this._workspaceProvider,this._providedCustomExecutions2).then(ue=>oe(this,F,ue))});return this._taskExecutionPromises.set(F.id,A),A.then(Z=>(this._taskExecutions.set(F.id,Z),Z),Z=>Promise.reject(Z))}checkDeprecation(F,q){F._deprecated&&this._deprecationService.report("Task.constructor",q.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(F){this._activeCustomExecutions2.get(F.id)&&this._activeCustomExecutions2.delete(F.id),this._notProvidedCustomExecutions.has(F.id)&&this._lastStartedTask!==F.id&&(this._providedCustomExecutions2.delete(F.id),this._notProvidedCustomExecutions.delete(F.id));const ie=this._notProvidedCustomExecutions.values();let A=ie.next();for(;!A.done;)!this._activeCustomExecutions2.has(A.value)&&this._lastStartedTask!==A.value&&(this._providedCustomExecutions2.delete(A.value),this._notProvidedCustomExecutions.delete(A.value)),A=ie.next()}};S=ze([xe(0,m.IExtHostRpcService),xe(1,k.IExtHostInitDataService),xe(2,P.IExtHostWorkspace),xe(3,E.IExtHostDocumentsAndEditors),xe(4,T.IExtHostConfiguration),xe(5,y.IExtHostTerminalService),xe(6,o.ILogService),xe(7,g.IExtHostApiDeprecationService)],S),e.ExtHostTaskBase=S;let z=class extends S{constructor(F,q,ie,A,Z,le,oe,ue){super(F,q,ie,A,Z,le,oe,ue);this.registerTaskSystem(h.Schemas.vscodeRemote,{scheme:h.Schemas.vscodeRemote,authority:"",platform:d.PlatformToString(0)})}async executeTask(F,q){if(!q.execution)throw new Error("Tasks to execute must include an execution");const ie=C.from(q,F);if(ie===void 0)throw new Error("Task is not valid");if(c.is(ie.execution))await this.addCustomExecution(ie,q,!1);else throw new l.NotSupportedError;const A=await this.getTaskExecution(await this._proxy.$getTaskExecution(ie),q);return this._proxy.$executeTask(ie).catch(Z=>{throw new Error(Z)}),A}provideTasksInternal(F,q,ie,A){const Z=[];if(A)for(const le of A){this.checkDeprecation(le,ie),(!le.definition||!F[le.definition.type])&&this._logService.warn(`The task [${le.source}, ${le.name}] uses an undefined task type. The task will be ignored in the future.`);const oe=C.from(le,ie.extension);oe&&c.is(oe.execution)?(Z.push(oe),q.push(this.addCustomExecution(oe,le,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:Z,extension:ie.extension}}async resolveTaskInternal(F){if(c.is(F.execution))return F;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(F,q){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(F,q,ie){}};z=ze([xe(0,m.IExtHostRpcService),xe(1,k.IExtHostInitDataService),xe(2,P.IExtHostWorkspace),xe(3,E.IExtHostDocumentsAndEditors),xe(4,T.IExtHostConfiguration),xe(5,y.IExtHostTerminalService),xe(6,o.ILogService),xe(7,g.IExtHostApiDeprecationService)],z),e.WorkerExtHostTask=z,e.IExtHostTask=(0,f.createDecorator)("IExtHostTask")}),define(ye[228],De([1,0,19,20,43,34,22,204,41]),function(ne,e,a,v,b,M,D,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class T{constructor(m,k,f){this.config=m,this.provider=k,this.sessionToken=f,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=m.filePattern,this.includePattern=m.includePattern&&M.parse(m.includePattern),this.maxResults=m.maxResults||void 0,this.exists=m.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=m.excludePattern&&M.parse(m.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(m=>m.cancel()),this.activeCancellationTokens=new Set}search(m){const k=this.config.folderQueries||[];return new Promise((f,h)=>{const d=o=>{this.resultCount++,m(o)};if(this.isCanceled)return f({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(o=>{const g=o.toString(),R=a.basename(g);this.globalExcludePattern&&this.globalExcludePattern(g,R)||this.matchFile(d,{base:o,basename:R})}),Promise.all(k.map(o=>this.searchInFolder(o,d))).then(o=>{f({limitHit:this.isLimitHit,stats:o[0]||void 0})},o=>{h(new Error((0,b.toErrorMessage)(o)))})})}async searchInFolder(m,k){const f=new v.CancellationTokenSource,h=this.getSearchOptionsForFolder(m),d=this.initDirectoryTree(),o=new E.QueryGlobTester(this.config,m),g=!o.hasSiblingExcludeClauses();let R;try{this.activeCancellationTokens.add(f),R=P.StopWatch.create();const l=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},h,f.token),w=R.elapsed(),s=P.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(l&&l.forEach(u=>{const n=a.posix.relative(m.folder.path,u.path);if(g){const i=a.basename(u.path);this.matchFile(k,{base:m.folder,relativePath:n,basename:i});return}this.addDirectoryEntries(d,m.folder,n,k)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(d,o,k),{providerTime:w,postProcessTime:s.elapsed()})}finally{f.dispose(),this.activeCancellationTokens.delete(f)}}getSearchOptionsForFolder(m){const k=(0,E.resolvePatternsForProvider)(this.config.includePattern,m.includePattern),f=(0,E.resolvePatternsForProvider)(this.config.excludePattern,m.excludePattern);return{folder:m.folder,excludes:f,includes:k,useIgnoreFiles:!m.disregardIgnoreFiles,useGlobalIgnoreFiles:!m.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!m.disregardParentIgnoreFiles,followSymlinks:!m.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const m={rootEntries:[],pathToEntries:Object.create(null)};return m.pathToEntries["."]=m.rootEntries,m}addDirectoryEntries({pathToEntries:m},k,f,h){if(f===this.filePattern){const o=a.basename(this.filePattern);this.matchFile(h,{base:k,relativePath:this.filePattern,basename:o})}function d(o){const g=a.basename(o),R=a.dirname(o);let l=m[R];l||(l=m[R]=[],d(R)),l.push({base:k,relativePath:o,basename:g})}d(f)}matchDirectoryTree({rootEntries:m,pathToEntries:k},f,h){const d=this,o=this.filePattern;function g(R){const l=(0,E.hasSiblingFn)(()=>R.map(w=>w.basename));for(let w=0,s=R.length;w<s;w++){const u=R[w],{relativePath:n,basename:i}=u;if(f.matchesExcludesSync(n,i,o!==i?l:void 0))continue;const r=k[n];if(r)g(r);else{if(n===o)continue;d.matchFile(h,u)}if(d.isLimitHit)break}}g(m)}matchFile(m,k){(!this.includePattern||k.relativePath&&this.includePattern(k.relativePath,k.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||m(k))}}class O{constructor(){this.sessions=new Map}fileSearch(m,k,f,h){const d=this.getSessionTokenSource(m.cacheKey),o=new T(m,k,d&&d.token);let g=0;const R=l=>{g+=l.length,f(l.map(w=>this.rawMatchToSearchItem(w)))};return this.doSearch(o,O.BATCH_SIZE,R,h).then(l=>({limitHit:l.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:g,detailStats:l.stats}}))}clearCache(m){this.getSessionTokenSource(m)?.cancel()}getSessionTokenSource(m){if(!!m)return this.sessions.has(m)||this.sessions.set(m,new v.CancellationTokenSource),this.sessions.get(m)}rawMatchToSearchItem(m){return m.relativePath?{resource:D.joinPath(m.base,m.relativePath)}:{resource:m.base}}doSearch(m,k,f,h){h.onCancellationRequested(()=>{m.cancel()});const d=g=>{g&&(o.push(g),k>0&&o.length>=k&&(f(o),o=[]))};let o=[];return m.search(d).then(g=>(o.length&&f(o),g),g=>(o.length&&f(o),Promise.reject(g)))}}e.FileSearchManager=O,O.BATCH_SIZE=512}),define(ye[229],De([1,0,16,72,34,76,25,12,19,22,9,10,2,246,143,57,15,45,90,227,41]),function(ne,e,a,v,b,M,D,P,E,T,O,y,m,k,f,h,d,o,g,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let w=class{constructor(p,C,U,W,L){this.configurationService=p,this.workspaceContextService=C,this.editorGroupsService=U,this.logService=W,this.pathService=L}text(p,C,U={}){p=this.getContentPattern(p,U);const W=this.configurationService.getValue(),L=C&&C.some(z=>!this.configurationService.getValue({resource:z}).search.useRipgrep);return{...this.commonQuery(C?.map(o.toWorkspaceFolder),U),type:2,contentPattern:p,previewOptions:U.previewOptions,maxFileSize:U.maxFileSize,usePCRE2:W.search.usePCRE2||L||!1,beforeContext:U.beforeContext,afterContext:U.afterContext,userDisabledExcludesAndIgnoreFiles:U.disregardExcludeSettings&&U.disregardIgnoreFiles}}getContentPattern(p,C){const U=this.configurationService.getValue();p.isRegExp&&(p.pattern=p.pattern.replace(/\r?\n/g,"\\n"));const W={...p,wordSeparators:U.editor.wordSeparators};return this.isCaseSensitive(p,C)&&(W.isCaseSensitive=!0),this.isMultiline(p)&&(W.isMultiline=!0),W}file(p,C={}){return{...this.commonQuery(p,C),type:1,filePattern:C.filePattern?C.filePattern.trim():C.filePattern,exists:C.exists,sortByScore:C.sortByScore,cacheKey:C.cacheKey}}handleIncludeExclude(p,C){return p?(p=Array.isArray(p)?p.map(r):r(p),C?this.parseSearchPaths(p):{pattern:u(...Array.isArray(p)?p:[p])}):{}}commonQuery(p=[],C={}){const U=this.handleIncludeExclude(C.includePattern,C.expandPatterns),W=this.handleIncludeExclude(C.excludePattern,C.expandPatterns),L=p.length>1,S=(U.searchPaths&&U.searchPaths.length?U.searchPaths.map(F=>this.getFolderQueryForSearchPath(F,C,W)):p.map(F=>this.getFolderQueryForRoot(F,C,W,L))).filter(F=>!!F),z={_reason:C._reason,folderQueries:S,usingSearchPaths:!!(U.searchPaths&&U.searchPaths.length),extraFileResources:C.extraFileResources,excludePattern:W.pattern,includePattern:U.pattern,onlyOpenEditors:C.onlyOpenEditors,maxResults:C.maxResults};if(C.onlyOpenEditors){const F=a.coalesce(a.flatten(this.editorGroupsService.groups.map(A=>A.editors.map(Z=>Z.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(F));const q=F.filter(A=>(0,l.pathIncludedInQuery)(z,A.fsPath)),ie=this.commonQueryFromFileList(q);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(ie)),{...z,...ie}}const $=C.extraFileResources&&C.extraFileResources.filter(F=>(0,l.pathIncludedInQuery)(z,F.fsPath));return z.extraFileResources=$&&$.length?$:void 0,z}commonQueryFromFileList(p){const C=[],U=new D.ResourceMap,W={};let L=!1;return p.forEach(S=>{if(S.scheme===P.Schemas.walkThrough)return;if((0,T.isAbsolutePath)(S)){const $=this.workspaceContextService.getWorkspaceFolder(S)?.uri??S.with({path:E.dirname(S.fsPath)});let F=U.get($);F||(L=!0,F={folder:$,includePattern:{}},C.push(F),U.set($,F));const q=E.relative($.fsPath,S.fsPath);(0,y.assertIsDefined)(F.includePattern)[q.replace(/\\/g,"/")]=!0}else S.fsPath&&(L=!0,W[S.fsPath]=!0)}),{folderQueries:C,includePattern:W,usingSearchPaths:!0,excludePattern:L?void 0:{"**/*":!0}}}isCaseSensitive(p,C){if(C.isSmartCase){if(p.isRegExp){if(O.containsUppercaseCharacter(p.pattern,!0))return!0}else if(O.containsUppercaseCharacter(p.pattern))return!0}return!!p.isCaseSensitive}isMultiline(p){return p.isMultiline||p.isRegExp&&(0,k.isMultilineRegexSource)(p.pattern)||p.pattern.indexOf(`
`)>=0?!0:!!p.isMultiline}parseSearchPaths(p){const C=ie=>E.isAbsolute(ie)||/^\.\.?([\/\\]|$)/.test(ie),W=(Array.isArray(p)?p:n(p)).map(ie=>{const A=this.pathService.resolvedUserHome;return A?(0,M.untildify)(ie,A.scheme===P.Schemas.file?A.fsPath:A.path):ie}),L=v.groupBy(W,ie=>C(ie)?"searchPaths":"exprSegments"),S=(L.exprSegments||[]).map(ie=>O.rtrim(ie,"/")).map(ie=>O.rtrim(ie,"\\")).map(ie=>(ie[0]==="."&&(ie="*"+ie),i(ie))),z={},$=this.expandSearchPathPatterns(L.searchPaths||[]);$&&$.length&&(z.searchPaths=$);const F=a.flatten(S),q=u(...F);return q&&(z.pattern=q),z}getExcludesForFolder(p,C){return C.disregardExcludeSettings?void 0:(0,l.getExcludes)(p,!C.disregardSearchExcludeSettings)}expandSearchPathPatterns(p){if(!p||!p.length)return[];const C=a.flatten(p.map(W=>{let{pathPortion:L,globPortion:S}=s(W);S&&(S=t(S));const z=this.expandOneSearchPath(L);return a.flatten(z.map($=>this.resolveOneSearchPathPattern($,S)))})),U=new Map;return C.forEach(W=>{const L=W.searchPath.toString(),S=U.get(L);S?W.pattern&&(S.pattern=S.pattern||{},S.pattern[W.pattern]=!0):U.set(L,{searchPath:W.searchPath,pattern:W.pattern?u(W.pattern):void 0})}),Array.from(U.values())}expandOneSearchPath(p){if(E.isAbsolute(p)){const C=this.workspaceContextService.getWorkspace().folders;return C[0]&&C[0].uri.scheme!==P.Schemas.file?[{searchPath:C[0].uri.with({path:p})}]:[{searchPath:m.URI.file(E.normalize(p))}]}if(this.workspaceContextService.getWorkbenchState()===2){const C=this.workspaceContextService.getWorkspace().folders[0].uri;if(p=r(p),p.startsWith("../")||p===".."){const W=E.posix.resolve(C.path,p);return[{searchPath:C.with({path:W})}]}const U=t(p);return[{searchPath:C,pattern:U}]}else{if(p==="./"||p===".\\")return[];{const C=p.replace(/^\.[\/\\]/,""),W=this.workspaceContextService.getWorkspace().folders.map(L=>{const S=C.match(new RegExp(`^${O.escapeRegExpCharacters(L.name)}(?:/(.*)|$)`));return S?{match:S,folder:L}:null}).filter(y.isDefined);if(W.length)return W.map(L=>{const S=L.match[1];return{searchPath:L.folder.uri,pattern:S&&t(S)}});{const L=p.match(/\.[\/\\](.+)[\/\\]?/),S=L?L[1]:p,z=f.localize(0,null,S);throw new Error(z)}}}}resolveOneSearchPathPattern(p,C){const U=p.pattern&&C?`${p.pattern}/${C}`:p.pattern||C,W=[{searchPath:p.searchPath,pattern:U}];return U&&!U.endsWith("**")&&W.push({searchPath:p.searchPath,pattern:U+"/**"}),W}getFolderQueryForSearchPath(p,C,U){const W=this.getFolderQueryForRoot((0,o.toWorkspaceFolder)(p.searchPath),C,U,!1);return W?{...W,includePattern:p.pattern}:null}getFolderQueryForRoot(p,C,U,W){let L;const S=m.URI.isUri(p)?p:p.uri;if(U.searchPaths){const ie=U.searchPaths.filter(A=>(0,T.isEqual)(A.searchPath,S))[0];if(ie&&!ie.pattern)return null;ie&&(L=ie.pattern)}const z=this.configurationService.getValue({resource:S}),F={...this.getExcludesForFolder(z,C)||{},...L||{}},q=m.URI.isUri(p)?(0,T.basename)(p):p.name;return{folder:S,folderName:W?q:void 0,excludePattern:Object.keys(F).length>0?F:void 0,fileEncoding:z.files&&z.files.encoding,disregardIgnoreFiles:typeof C.disregardIgnoreFiles=="boolean"?C.disregardIgnoreFiles:!z.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof C.disregardGlobalIgnoreFiles=="boolean"?C.disregardGlobalIgnoreFiles:!z.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof C.disregardParentIgnoreFiles=="boolean"?C.disregardParentIgnoreFiles:!z.search.useParentIgnoreFiles,ignoreSymlinks:typeof C.ignoreSymlinks=="boolean"?C.ignoreSymlinks:!z.search.followSymlinks}}};w=ze([xe(0,h.IConfigurationService),xe(1,o.IWorkspaceContextService),xe(2,g.IEditorGroupsService),xe(3,d.ILogService),xe(4,R.IPathService)],w),e.QueryBuilder=w;function s(_){const p=_.match(/[\*\{\}\(\)\[\]\?]/);if(p){const C=p.index,U=_.substr(0,C).match(/[/|\\][^/\\]*$/);if(U){let W=_.substr(0,U.index);return W.match(/[/\\]/)||(W+="/"),{pathPortion:W,globPortion:_.substr((U.index||0)+1)}}}return{pathPortion:_}}function u(..._){return _.length?_.reduce((p,C)=>(p[C]=!0,p),Object.create(null)):void 0}function n(_){return b.splitGlobAware(_,",").map(p=>p.trim()).filter(p=>!!p.length)}function i(_){return[`**/${_}/**`,`**/${_}`].map(C=>C.replace(/\*\*\/\*\*/g,"**"))}function r(_){return _.replace(/\\/g,"/")}function t(_){return r(_).replace(/^\.\//,"").replace(/\/+$/g,"")}function c(_,p){_=a.distinct(_,W=>W.toString());const C=[],U=p.getWorkspace();return _&&_.forEach(W=>{let L;if(p.getWorkbenchState()===2)L=(0,T.relativePath)(U.folders[0].uri,W),L&&L!=="."&&(L="./"+L);else{const S=p.getWorkspaceFolder(W);if(S){const z=S.name;if(U.folders.filter(F=>F.name===z).length===1){const F=(0,T.relativePath)(S.uri,W);F===""?L=`./${S.name}`:L=`./${S.name}/${F}`}else L=W.fsPath}}L&&C.push(L)}),C}e.resolveResourcesForSearchIncludes=c}),define(ye[230],De([1,0,22,2,20,11,3,229,41,45]),function(ne,e,a,v,b,M,D,P,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const O=7e3;function y(h,d){const o=d.activationEvents;if(!o)return Promise.resolve(void 0);const g=[],R=[];for(const i of o)if(/^workspaceContains:/.test(i)){const r=i.substr("workspaceContains:".length);r.indexOf("*")>=0||r.indexOf("?")>=0||h.forceUsingSearch?R.push(r):g.push(r)}if(g.length===0&&R.length===0)return Promise.resolve(void 0);let l;const w=new Promise((i,r)=>{l=i}),s=i=>l({activationEvent:i}),u=Promise.all(g.map(i=>m(h,i,s))).then(()=>{}),n=k(h,d.identifier,R,s);return Promise.all([u,n]).then(()=>{l(void 0)}),w}e.checkActivateWorkspaceContainsExtension=y;async function m(h,d,o){for(const g of h.folders)if(await h.exists(a.joinPath(v.URI.revive(g),d))){o(`workspaceContains:${d}`);return}}async function k(h,d,o,g){if(o.length===0)return Promise.resolve(void 0);const R=new b.CancellationTokenSource,l=h.checkExists(h.folders,o,R.token),w=setTimeout(async()=>{R.cancel(),h.logService.info(`Not activating extension '${d.value}': Timed out while searching for 'workspaceContains' pattern ${o.join(",")}`)},O);let s=!1;try{s=await l}catch(u){M.isCancellationError(u)||M.onUnexpectedError(u)}R.dispose(),clearTimeout(w),s&&g(`workspaceContains:${o.join(",")}`)}function f(h,d,o,g){const R=h.get(D.IInstantiationService),l=h.get(E.ISearchService),s=R.createInstance(P.QueryBuilder).file(d.map(u=>(0,T.toWorkspaceFolder)(v.URI.revive(u))),{_reason:"checkExists",includePattern:o,exists:!0});return l.fileSearch(s,g).then(u=>!!u.limitHit,u=>M.isCancellationError(u)?!1:Promise.reject(u))}e.checkGlobFileExists=f});var Ye=this&&this.__classPrivateFieldSet||function(ne,e,a,v,b){if(v==="m")throw new TypeError("Private method is not writable");if(v==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return v==="a"?b.call(ne,a):b?b.value=a:e.set(ne,a),a},Oe=this&&this.__classPrivateFieldGet||function(ne,e,a,v){if(a==="a"&&!v)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!v:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?v:a==="a"?v.call(ne):v?v.value:e.get(ne)};define(ye[33],De([1,0,130,19,71,22,14,7,25,2,15,4,32,181,69,31,24,180,11,27,23,158,6,84,3,28,70,13,58,62,52,5,230,67,160,12]),function(ne,e,a,v,b,M,D,P,E,T,O,y,m,k,f,h,d,o,g,R,l,w,s,u,n,i,r,t,c,_,p,C,U,W,L,S){"use strict";var z,$,F;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,n.createDecorator)("IHostUtils");let q=class Ti extends P.Disposable{constructor(te,Ee,be,ee,ve,Ae,Fe,$e,Qe,Ie){super();this._onDidChangeRemoteConnectionData=this._register(new C.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._isTerminating=!1,this._hostUtils=Ee,this._extHostContext=be,this._initData=Fe,this._extHostWorkspace=ee,this._extHostConfiguration=ve,this._logService=Ae,this._extHostTunnelService=Qe,this._extHostTerminalService=Ie,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(y.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(y.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(y.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new D.Barrier,this._readyToStartExtensionHost=new D.Barrier,this._readyToRunExtensions=new D.Barrier,this._eagerExtensionsActivated=new D.Barrier,this._globalRegistry=new o.ExtensionDescriptionRegistry(this._initData.allExtensions);const Se=(0,d.extensionIdentifiersArrayToSet)(this._initData.myExtensions);this._myRegistry=new o.ExtensionDescriptionRegistry(Z(this._globalRegistry,Se)),this._storage=new f.ExtHostStorage(this._extHostContext),this._secretState=new W.ExtHostSecretState(this._extHostContext),this._storagePath=$e,this._instaService=te.createChild(new c.ServiceCollection([f.IExtHostStorage,this._storage],[W.IExtHostSecretState,this._secretState]));let ke=[],ae=[];this._initData.remote.isRemote&&(ke=this._initData.allExtensions.filter(G=>!G.main&&!G.browser).map(G=>G.identifier),ae=this._initData.allExtensions.filter(G=>!Se.has(R.ExtensionIdentifier.toKey(G.identifier.value))).filter(G=>(G.main||G.browser)&&G.api==="none").map(G=>G.identifier));const ce=(0,d.extensionIdentifiersArrayToSet)(ae);this._activator=this._register(new k.ExtensionsActivator(this._myRegistry,ke,ae,{onExtensionActivationError:(G,Q,I)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(G,g.transformErrorForSerialization(Q),I)},actualActivateExtension:async(G,Q)=>{if(ce.has(R.ExtensionIdentifier.toKey(G)))return await this._mainThreadExtensionsProxy.$activateExtension(G,Q),new k.HostExtension;const I=this._myRegistry.getExtensionDescription(G);return this._activateExtension(I,Q)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),b.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(te){g.onUnexpectedError(te)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let te=[];try{te=this._myRegistry.getAllExtensionDescriptions().map(ve=>ve.identifier).filter(ve=>this.isActivated(ve)).map(ve=>this._deactivate(ve))}catch{}await Promise.all(te)}terminate(te,Ee=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${te}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),g.setUnexpectedErrorHandler(ee=>{this._logService.error(ee)}),this._extHostContext.dispose();const be=this._deactivateAll();Promise.race([(0,D.timeout)(5e3),be]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${Ee}`):this._logService.info(`Extension host exiting with code ${Ee}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(Ee)})}isActivated(te){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(te):!1}async getExtension(te){const Ee=await this._mainThreadExtensionsProxy.$getExtension(te);let be;if(Ee?.browserNlsBundleUris){be={};for(const ee of Object.keys(Ee.browserNlsBundleUris))be[ee]=T.URI.revive(Ee.browserNlsBundleUris[ee])}return Ee&&{...Ee,identifier:new R.ExtensionIdentifier(Ee.identifier.value),extensionLocation:T.URI.revive(Ee.extensionLocation),browserNlsBundleUris:be}}_activateByEvent(te,Ee){return this._activator.activateByEvent(te,Ee)}_activateById(te,Ee){return this._activator.activateById(te,Ee)}activateByIdWithErrors(te,Ee){return this._activateById(te,Ee).then(()=>{const be=this._activator.getActivatedExtension(te);if(be.activationFailed)return Promise.reject(be.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(te=>this._myRegistry)}getExtensionExports(te){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(te).exports:null}async _realPathExtensionUri(te){if(te.scheme!==S.Schemas.file)return te;const Ee=await this._hostUtils.realpath(te.fsPath);return T.URI.file(Ee)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(te=>new oe(te))),this._extensionPathIndex}async _createExtensionPathIndex(te){const Ee=E.TernarySearchTree.forUris(be=>M.extUriBiasedIgnorePathCase.ignorePathCasing(be));return await Promise.all(te.map(async be=>{if(this._getEntryPoint(be)){const ee=await this._realPathExtensionUri(be.extensionLocation);Ee.set(ee,be)}})),Ee}_deactivate(te){let Ee=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(te))return Ee;const be=this._activator.getActivatedExtension(te);if(!be)return Ee;try{typeof be.module.deactivate=="function"&&(Ee=Promise.resolve(be.module.deactivate()).then(void 0,ee=>(this._logService.error(ee),Promise.resolve(void 0))))}catch(ee){this._logService.error(`An error occurred when deactivating the extension '${te.value}':`),this._logService.error(ee)}try{(0,P.dispose)(be.subscriptions)}catch(ee){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${te.value}':`),this._logService.error(ee)}return Ee}async _activateExtension(te,Ee){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(te.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(te.identifier),this._doActivateExtension(te,Ee).then(be=>{const ee=be.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(te.identifier,ee.codeLoadingTime,ee.activateCallTime,ee.activateResolvedTime,Ee),this._logExtensionActivationTimes(te,Ee,"success",ee),be},be=>{throw this._logExtensionActivationTimes(te,Ee,"failure"),be})}_logExtensionActivationTimes(te,Ee,be,ee){const ve=ie(te,Ee);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...ve,...ee||{},outcome:be})}_doActivateExtension(te,Ee){const be=ie(te,Ee);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",be);const ee=this._getEntryPoint(te);if(!ee)return Promise.resolve(new k.EmptyExtension(k.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${te.identifier.value}, startup: ${Ee.startup}, activationEvent: '${Ee.activationEvent}'${te.identifier.value!==Ee.extensionId.value?`, root cause: ${Ee.extensionId.value}`:""}`),this._logService.flush();const ve=new k.ExtensionActivationTimesBuilder(Ee.startup);return Promise.all([this._loadCommonJSModule(te,(0,M.joinPath)(te.extensionLocation,ee),ve),this._loadExtensionContext(te)]).then(Ae=>(b.mark(`code/extHost/willActivateExtension/${te.identifier.value}`),Ti._callActivate(this._logService,te.identifier,Ae[0],Ae[1],ve))).then(Ae=>(b.mark(`code/extHost/didActivateExtension/${te.identifier.value}`),Ae))}_loadExtensionContext(te){const Ee=new w.ExtensionGlobalMemento(te,this._storage),be=new w.ExtensionMemento(te.identifier.value,!1,this._storage),ee=new L.ExtensionSecrets(te,this._secretState),ve=te.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?s.ExtensionMode.Test:s.ExtensionMode.Development:s.ExtensionMode.Production,Ae=this._initData.remote.isRemote?s.ExtensionKind.Workspace:s.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${te.identifier.value}`),Promise.all([Ee.whenReady,be.whenReady,this._storagePath.whenReady]).then(()=>{const Fe=this;let $e,Qe;const Ie=(0,d.isProposedApiEnabled)(te,"ipc")?this._initData.messagePorts?.get(R.ExtensionIdentifier.toKey(te.identifier)):void 0;return Object.freeze({globalState:Ee,workspaceState:be,secrets:ee,subscriptions:[],get extensionUri(){return te.extensionLocation},get extensionPath(){return te.extensionLocation.fsPath},asAbsolutePath(Se){return v.join(te.extensionLocation.fsPath,Se)},get storagePath(){return Fe._storagePath.workspaceValue(te)?.fsPath},get globalStoragePath(){return Fe._storagePath.globalValue(te).fsPath},get logPath(){return v.join(Fe._initData.logsLocation.fsPath,te.identifier.value)},get logUri(){return T.URI.joinPath(Fe._initData.logsLocation,te.identifier.value)},get storageUri(){return Fe._storagePath.workspaceValue(te)},get globalStorageUri(){return Fe._storagePath.globalValue(te)},get extensionMode(){return ve},get extension(){return $e===void 0&&($e=new A(Fe,te.identifier,te,Ae,!1)),$e},get extensionRuntime(){return(0,d.checkProposedApiEnabled)(te,"extensionRuntime"),Fe.extensionRuntime},get environmentVariableCollection(){return Fe._extHostTerminalService.getEnvironmentVariableCollection(te)},get messagePassingProtocol(){if(!Qe){if(!Ie)return;const Se=C.Event.buffer(C.Event.fromDOMEventEmitter(Ie,"message",ke=>ke.data));Ie.start(),Qe={onDidReceiveMessage:Se,postMessage:Ie.postMessage.bind(Ie)}}return Qe}})})}static _callActivate(te,Ee,be,ee,ve){return be=be||{activate:void 0,deactivate:void 0},this._callActivateOptional(te,Ee,be,ee,ve).then(Ae=>new k.ActivatedExtension(!1,null,ve.build(),be,Ae,ee.subscriptions))}static _callActivateOptional(te,Ee,be,ee,ve){if(typeof be.activate=="function")try{ve.activateCallStart(),te.trace(`ExtensionService#_callActivateOptional ${Ee.value}`);const Ae=typeof global=="object"?global:self,Fe=be.activate.apply(Ae,[ee]);return ve.activateCallStop(),ve.activateResolveStart(),Promise.resolve(Fe).then($e=>(ve.activateResolveStop(),$e))}catch(Ae){return Promise.reject(Ae)}else return Promise.resolve(be)}_activateOneStartupFinished(te,Ee){this._activateById(te.identifier,{startup:!1,extensionId:te.identifier,activationEvent:Ee}).then(void 0,be=>{this._logService.error(be)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(b.getMarks());for(const te of this._myRegistry.getAllExtensionDescriptions())if(te.activationEvents)for(const Ee of te.activationEvents)Ee==="onStartupFinished"&&this._activateOneStartupFinished(te,Ee)}_handleEagerExtensions(){const te=this._activateByEvent("*",!0).then(void 0,ve=>{this._logService.error(ve)});this._register(this._extHostWorkspace.onDidChangeWorkspace(ve=>this._handleWorkspaceContainsEagerExtensions(ve.added)));const Ee=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],be=this._handleWorkspaceContainsEagerExtensions(Ee),ee=Promise.all([te,be]).then(()=>{});return Promise.race([ee,(0,D.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),ee}_handleWorkspaceContainsEagerExtensions(te){return te.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(Ee=>this._handleWorkspaceContainsEagerExtension(te,Ee))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(te,Ee){if(this.isActivated(Ee.identifier))return;const be=!this._initData.remote.isRemote&&!!this._initData.remote.authority,ee={logService:this._logService,folders:te.map(Ae=>Ae.uri),forceUsingSearch:be,exists:Ae=>this._hostUtils.exists(Ae.fsPath),checkExists:(Ae,Fe,$e)=>this._mainThreadWorkspaceProxy.$checkExists(Ae,Fe,$e)},ve=await(0,U.checkActivateWorkspaceContainsExtension)(ee,Ee);if(!!ve)return this._activateById(Ee.identifier,{startup:!0,extensionId:Ee.identifier,activationEvent:ve.activationEvent}).then(void 0,Ae=>this._logService.error(Ae))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(te){throw console.error(te),te}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:te,extensionTestsLocationURI:Ee}=this._initData.environment;if(!te||!Ee)throw new Error(a.localize(0,null));const be=await this._loadCommonJSModule(null,Ee,new k.ExtensionActivationTimesBuilder(!1));if(!be||typeof be.run!="function")throw new Error(a.localize(1,null,Ee.toString()));return new Promise((ee,ve)=>{const Ae=(Qe,Ie)=>{Qe?ve(Qe):ee(typeof Ie=="number"&&Ie>0?1:0)},Fe=(0,M.originalFSPath)(Ee),$e=be.run(Fe,Ae);$e&&$e.then&&$e.then(()=>{ee(0)}).catch(Qe=>{ve(Qe instanceof Error&&Qe.stack?Qe.stack:String(Qe))})})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(te,Ee){return this._resolvers[te]=Ee,(0,P.toDisposable)(()=>{delete this._resolvers[te]})}async _activateAndGetResolver(te){const Ee=te.indexOf("+");if(Ee===-1)throw new Error("Not an authority that can be resolved!");const be=te.substr(0,Ee);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${be}`,!1),{authorityPrefix:be,resolver:this._resolvers[be]}}async $resolveAuthority(te,Ee){this._logService.info(`$resolveAuthority invoked for authority (${le(te)})`);const{authorityPrefix:be,resolver:ee}=await this._activateAndGetResolver(te);if(!ee)return{type:"error",error:{code:u.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${be}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelFactory(ee)),b.mark(`code/extHost/willResolveAuthority/${be}`);const ve=await ee.resolve(te,{resolveAttempt:Ee});b.mark(`code/extHost/didResolveAuthorityOK/${be}`);const Ae={authority:te,host:ve.host,port:ve.port,connectionToken:ve.connectionToken},Fe={extensionHostEnv:ve.extensionHostEnv,isTrusted:ve.isTrusted,authenticationSession:ve.authenticationSessionForInitializingExtensions?{id:ve.authenticationSessionForInitializingExtensions.id,providerId:ve.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:Ae,options:Fe,tunnelInformation:{environmentTunnels:ve.environmentTunnels,features:ve.tunnelFeatures}}}}catch(ve){if(b.mark(`code/extHost/didResolveAuthorityError/${be}`),ve instanceof s.RemoteAuthorityResolverError)return{type:"error",error:{code:ve._code,message:ve._message,detail:ve._detail}};throw ve}}async $getCanonicalURI(te,Ee){this._logService.info(`$getCanonicalURI invoked for authority (${le(te)})`);const{resolver:be}=await this._activateAndGetResolver(te);if(!be)return null;const ee=T.URI.revive(Ee);if(typeof be.getCanonicalURI=="undefined")return ee;const ve=await(0,D.asPromise)(()=>be.getCanonicalURI(ee));return ve||ee}static _applyExtensionsDelta(te,Ee,be){const ee=new o.ExtensionDescriptionRegistry(te.getAllExtensionDescriptions());ee.deltaExtensions(be.toAdd,be.toRemove);const ve=(0,d.extensionIdentifiersArrayToSet)(Ee.getAllExtensionDescriptions().map(Fe=>Fe.identifier));for(const Fe of be.myToRemove)ve.delete(R.ExtensionIdentifier.toKey(Fe));for(const Fe of be.myToAdd)ve.add(R.ExtensionIdentifier.toKey(Fe));const Ae=Z(ee,ve);return{globalRegistry:ee,myExtensions:Ae}}$startExtensionHost(te){te.toAdd.forEach(ee=>ee.extensionLocation=T.URI.revive(ee.extensionLocation));const{globalRegistry:Ee,myExtensions:be}=Ti._applyExtensionsDelta(this._globalRegistry,this._myRegistry,te);return this._globalRegistry.set(Ee.getAllExtensionDescriptions()),this._myRegistry.set(be),this._startExtensionHost()}$activateByEvent(te,Ee){return Ee===1?this._activateByEvent(te,!1):this._readyToRunExtensions.wait().then(be=>this._activateByEvent(te,!1))}async $activate(te,Ee){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(te)?(await this._activateById(te,Ee),!0):!1}async $deltaExtensions(te){te.toAdd.forEach(Ae=>Ae.extensionLocation=T.URI.revive(Ae.extensionLocation));const{globalRegistry:Ee,myExtensions:be}=Ti._applyExtensionsDelta(this._globalRegistry,this._myRegistry,te),ee=await this._createExtensionPathIndex(be);return(await this.getExtensionPathIndex()).setSearchTree(ee),this._globalRegistry.set(Ee.getAllExtensionDescriptions()),this._myRegistry.set(be),Promise.resolve(void 0)}async $test_latency(te){return te}async $test_up(te){return te.byteLength}async $test_down(te){const Ee=l.VSBuffer.alloc(te),be=Math.random()%256;for(let ee=0;ee<te;ee++)Ee.writeUInt8(be,ee);return Ee}async $updateRemoteConnectionData(te){this._remoteConnectionData=te,this._onDidChangeRemoteConnectionData.fire()}};q=ze([xe(0,n.IInstantiationService),xe(1,e.IHostUtils),xe(2,t.IExtHostRpcService),xe(3,h.IExtHostWorkspace),xe(4,m.IExtHostConfiguration),xe(5,O.ILogService),xe(6,i.IExtHostInitDataService),xe(7,r.IExtensionStoragePaths),xe(8,_.IExtHostTunnelService),xe(9,p.IExtHostTerminalService)],q),e.AbstractExtHostExtensionService=q;function ie(ue,te){return{id:ue.identifier.value,name:ue.name,extensionVersion:ue.version,publisherDisplayName:ue.publisher,activationEvents:ue.activationEvents?ue.activationEvents.join(","):null,isBuiltin:ue.isBuiltin,reason:te.activationEvent,reasonId:te.extensionId.value}}e.IExtHostExtensionService=(0,n.createDecorator)("IExtHostExtensionService");class A{constructor(te,Ee,be,ee,ve){z.set(this,void 0),$.set(this,void 0),F.set(this,void 0),Ye(this,z,te,"f"),Ye(this,$,Ee,"f"),Ye(this,F,be.identifier,"f"),this.id=be.identifier.value,this.extensionUri=be.extensionLocation,this.extensionPath=v.normalize((0,M.originalFSPath)(be.extensionLocation)),this.packageJSON=be,this.extensionKind=ee,this.isFromDifferentExtensionHost=ve}get isActive(){return Oe(this,z,"f").isActivated(Oe(this,F,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Oe(this,z,"f").getExtensionExports(Oe(this,F,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Oe(this,z,"f").activateByIdWithErrors(Oe(this,F,"f"),{startup:!1,extensionId:Oe(this,$,"f"),activationEvent:"api"}),this.exports}}e.Extension=A,z=new WeakMap,$=new WeakMap,F=new WeakMap;function Z(ue,te){return ue.getAllExtensionDescriptions().filter(Ee=>te.has(R.ExtensionIdentifier.toKey(Ee.identifier)))}function le(ue){const te=ue.indexOf("+");return te===-1?ue:ue.substring(0,te)}class oe{constructor(te){this._searchTree=te}setSearchTree(te){this._searchTree=te}findSubstr(te){return this._searchTree.findSubstr(te)}forEach(te){return this._searchTree.forEach(te)}}e.ExtensionPaths=oe}),define(ye[231],De([1,0,71,2,4,32,24,27,13,28,3,33,59,15,9]),function(ne,e,a,v,b,M,D,P,E,T,O,y,m,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let h=class{constructor(w,s,u,n,i,r,t){this._apiFactory=w,this._extensionRegistry=s,this._instaService=u,this._extHostConfiguration=n,this._extHostExtensionService=i,this._initData=r,this._logService=t,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),a.mark("code/extHost/willWaitForConfig");const w=await this._extHostConfiguration.getConfigProvider();a.mark("code/extHost/didWaitForConfig");const s=await this._extHostExtensionService.getExtensionPathIndex();this.register(new o(this._apiFactory,s,this._extensionRegistry,w,this._logService)),this.register(this._instaService.createInstance(g,s)),this.register(this._instaService.createInstance(d)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(R,s,this._initData.environment.appUriScheme))}register(w){if("nodeModuleName"in w)if(Array.isArray(w.nodeModuleName))for(const s of w.nodeModuleName)this._factories.set(s,w);else this._factories.set(w.nodeModuleName,w);typeof w.alternativeModuleName=="function"&&this._alternatives.push(s=>w.alternativeModuleName(s))}};h=ze([xe(2,O.IInstantiationService),xe(3,M.IExtHostConfiguration),xe(4,y.IExtHostExtensionService),xe(5,T.IExtHostInitDataService),xe(6,k.ILogService)],h),e.RequireInterceptor=h;let d=class Xi{constructor(w){if(w.environment.appRoot&&Xi.aliased.size){const s=(0,f.escapeRegExpCharacters)(this.forceForwardSlashes(w.environment.appRoot.fsPath)),u="[a-z0-9_.-]",n=`@${u}+\\/${u}+|${u}+`,i="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${s}/${i}\\/)(${n})(.*)$`,"i")}}alternativeModuleName(w){if(!this.re)return;const s=this.re.exec(this.forceForwardSlashes(w));if(!s)return;const[,u,n,i]=s,r=Xi.aliased.get(n);if(r!==void 0)return console.warn(`${n} as been renamed to ${r}, please update your imports`),u+r+i}forceForwardSlashes(w){return w.replace(/\\/g,"/")}};d.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),d=ze([xe(0,T.IExtHostInitDataService)],d);class o{constructor(w,s,u,n,i){this._apiFactory=w,this._extensionPaths=s,this._extensionRegistry=u,this._configProvider=n,this._logService=i,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(w,s){const u=this._extensionPaths.findSubstr(s);if(u){let n=this._extApiImpl.get(P.ExtensionIdentifier.toKey(u.identifier));return n||(n=this._apiFactory(u,this._extensionRegistry,this._configProvider),this._extApiImpl.set(P.ExtensionIdentifier.toKey(u.identifier),n)),n}if(!this._defaultApiImpl){let n="";this._extensionPaths.forEach((i,r)=>n+=`	${r} -> ${i.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${s}. These are the extension path mappings: 
${n}`),this._defaultApiImpl=this._apiFactory(D.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let g=class{constructor(w,s,u){this._extensionPaths=w,this.nodeModuleName="keytar",this._mainThreadTelemetry=s.getProxy(b.MainContext.MainThreadTelemetry);const{environment:n}=u,i=s.getProxy(b.MainContext.MainThreadKeytar);if(n.appRoot){let r=n.appRoot.fsPath;m.platform==="win32"&&(r=r.replace(/\\/g,"/")),r[r.length-1]==="/"&&(r=r.substr(0,r.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${r}/node_modules.asar/keytar`),this.alternativeNames.add(`${r}/node_modules/keytar`)}this._impl={getPassword:(r,t)=>i.$getPassword(r,t),setPassword:(r,t,c)=>i.$setPassword(r,t,c),deletePassword:(r,t)=>i.$deletePassword(r,t),findPassword:r=>i.$findPassword(r),findCredentials(r){return i.$findCredentials(r)}}}load(w,s){const u=this._extensionPaths.findSubstr(s);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:u?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(w){const s=w.length;if(s<=7||!this.alternativeNames)return;const u=s-7;if((w.charAt(u)==="/"||w.charAt(u)==="\\")&&w.endsWith("keytar")&&(w=w.replace(/\\/g,"/"),this.alternativeNames.has(w)))return"keytar"}};g=ze([xe(1,E.IExtHostRpcService),xe(2,T.IExtHostInitDataService)],g);let R=class{constructor(w,s,u){this._extensionPaths=w,this._appUriScheme=s,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=u.getProxy(b.MainContext.MainThreadTelemetry);const n=u.getProxy(b.MainContext.MainThreadWindow);this._impl=(i,r)=>{const t=v.URI.parse(i);return r?this.callOriginal(i,r):t.scheme==="http"||t.scheme==="https"?n.$openUri(t,i,{allowTunneling:!0}):t.scheme==="mailto"||t.scheme===this._appUriScheme?n.$openUri(t,i,{}):this.callOriginal(i,r)}}load(w,s,u){const n=this._extensionPaths.findSubstr(s);return n&&(this._extensionId=n.identifier.value,this.sendShimmingTelemetry()),this._original=u(w),this._impl}callOriginal(w,s){return this.sendNoForwardTelemetry(),this._original(w,s)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};R=ze([xe(2,E.IExtHostRpcService)],R)}),define(ye[102],De([1,0,198,7,19,59,3,49,50,33,6,31,172,32]),function(ne,e,a,v,b,M,D,P,E,T,O,y,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,D.createDecorator)("IExtHostVariableResolverProvider");class f extends m.AbstractVariableResolverService{constructor(o,g,R,l,w,s,u){function n(){if(R){const i=R.activeEditor();if(i)return i.document.uri;const r=l.tabGroups.all.find(t=>t.isActive)?.activeTab;if(r!==void 0){if(r.input instanceof O.TextDiffTabInput||r.input instanceof O.NotebookDiffEditorTabInput)return r.input.modified;if(r.input instanceof O.TextTabInput||r.input instanceof O.NotebookEditorTabInput||r.input instanceof O.CustomEditorTabInput)return r.input.uri}}}super({getFolderUri:i=>{const r=s.folders.filter(t=>t.name===i);if(r&&r.length>0)return r[0].uri},getWorkspaceFolderCount:()=>s.folders.length,getConfigurationValue:(i,r)=>w.getConfiguration(void 0,i).get(r),getAppRoot:()=>M.cwd(),getExecPath:()=>M.env.VSCODE_EXEC_PATH,getFilePath:()=>{const i=n();if(i)return b.normalize(i.fsPath)},getWorkspaceFolderPathForFile:()=>{if(g){const i=n();if(i){const r=g.getWorkspaceFolder(i);if(r)return b.normalize(r.uri.fsPath)}}},getSelectedText:()=>{if(R){const i=R.activeEditor();if(i&&!i.selection.isEmpty)return i.document.getText(i.selection)}},getLineNumber:()=>{if(R){const i=R.activeEditor();if(i)return String(i.selection.end.line+1)}},getExtension:i=>o.getExtension(i)},void 0,u?Promise.resolve(u):void 0,Promise.resolve(M.env))}}let h=class extends v.Disposable{constructor(o,g,R,l,w){super();this.extensionService=o,this.workspaceService=g,this.editorService=R,this.configurationService=l,this.editorTabs=w,this._resolver=new a.Lazy(async()=>{const s=await this.configurationService.getConfigProvider(),n={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async i=>{n.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new f(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,s,n,this.homeDir())})}getResolver(){return this._resolver.getValue()}homeDir(){}};h=ze([xe(0,T.IExtHostExtensionService),xe(1,y.IExtHostWorkspace),xe(2,P.IExtHostDocumentsAndEditors),xe(3,k.IExtHostConfiguration),xe(4,E.IExtHostEditorTabs)],h),e.ExtHostVariableResolverProviderService=h}),define(ye[103],De([1,0,14,5,10,2,3,4,50,33,13,6,31,165,167,32,102]),function(ne,e,a,v,b,M,D,P,E,T,O,y,m,k,f,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,D.createDecorator)("IExtHostDebugService");let o=class{constructor(n,i,r,t,c,_){this._workspaceService=i,this._extensionService=r,this._configurationService=t,this._editorTabs=c,this._variableResolver=_,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new v.Emitter,this._onDidTerminateDebugSession=new v.Emitter,this._onDidChangeActiveDebugSession=new v.Emitter,this._onDidReceiveDebugSessionCustomEvent=new v.Emitter,this._debugServiceProxy=n.getProxy(P.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new v.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new R(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(p=>{p.onDidChange(C=>{this.registerAllDebugTypes(p)}),this.registerAllDebugTypes(p)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(n,i){const r=n;if(typeof r.sourceReference=="number"&&r.sourceReference>0){let t=`debug:${encodeURIComponent(r.path||"")}`,c="?";return i&&(t+=`${c}session=${encodeURIComponent(i.id)}`,c="&"),t+=`${c}ref=${r.sourceReference}`,M.URI.parse(t)}else{if(r.path)return M.URI.file(r.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(n){const i=[];for(const r of n.getAllExtensionDescriptions())if(r.contributes){const t=r.contributes.debuggers;if(t&&t.length>0)for(const c of t)(0,f.isDebuggerMainContribution)(c)&&i.push(c.type)}this._debugServiceProxy.$registerDebugTypes(i)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const n=[];return this._breakpoints.forEach(i=>n.push(i)),n}addBreakpoints(n){this.startBreakpoints();const i=n.filter(c=>{const _=c.id;return this._breakpoints.has(_)?!1:(this._breakpoints.set(_,c),!0)});this.fireBreakpointChanges(i,[],[]);const r=[],t=new Map;for(const c of i)if(c instanceof y.SourceBreakpoint){let _=t.get(c.location.uri.toString());_||(_={type:"sourceMulti",uri:c.location.uri,lines:[]},t.set(c.location.uri.toString(),_),r.push(_)),_.lines.push({id:c.id,enabled:c.enabled,condition:c.condition,hitCondition:c.hitCondition,logMessage:c.logMessage,line:c.location.range.start.line,character:c.location.range.start.character})}else c instanceof y.FunctionBreakpoint&&r.push({type:"function",id:c.id,enabled:c.enabled,hitCondition:c.hitCondition,logMessage:c.logMessage,condition:c.condition,functionName:c.functionName});return this._debugServiceProxy.$registerBreakpoints(r)}removeBreakpoints(n){this.startBreakpoints();const i=n.filter(_=>this._breakpoints.delete(_.id));this.fireBreakpointChanges([],i,[]);const r=i.filter(_=>_ instanceof y.SourceBreakpoint).map(_=>_.id),t=i.filter(_=>_ instanceof y.FunctionBreakpoint).map(_=>_.id),c=i.filter(_=>_ instanceof y.DataBreakpoint).map(_=>_.id);return this._debugServiceProxy.$unregisterBreakpoints(r,t,c)}startDebugging(n,i,r){return this._debugServiceProxy.$startDebugging(n?n.uri:void 0,i,{parentSessionID:r.parentSession?r.parentSession.id:void 0,lifecycleManagedByParent:r.lifecycleManagedByParent,repl:r.consoleMode===y.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:r.noDebug,compact:r.compact,debugUI:r.debugUI,suppressSaveBeforeStart:r.suppressSaveBeforeStart})}stopDebugging(n){return this._debugServiceProxy.$stopDebugging(n?n.id:void 0)}registerDebugConfigurationProvider(n,i,r){if(!i)return new y.Disposable(()=>{});const t=this._configProviderHandleCounter++;return this._configProviders.push({type:n,handle:t,provider:i}),this._debugServiceProxy.$registerDebugConfigurationProvider(n,r,!!i.provideDebugConfigurations,!!i.resolveDebugConfiguration,!!i.resolveDebugConfigurationWithSubstitutedVariables,t),new y.Disposable(()=>{this._configProviders=this._configProviders.filter(c=>c.provider!==i),this._debugServiceProxy.$unregisterDebugConfigurationProvider(t)})}registerDebugAdapterDescriptorFactory(n,i,r){if(!r)return new y.Disposable(()=>{});if(!this.definesDebugType(n,i))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${i}' debugger.`);if(this.getAdapterDescriptorFactoryByType(i))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const t=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:i,handle:t,factory:r}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(i,t),new y.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(c=>c.factory!==r),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(t)})}registerDebugAdapterTrackerFactory(n,i){if(!i)return new y.Disposable(()=>{});const r=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:n,handle:r,factory:i}),new y.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(t=>t.factory!==i)})}async $runInTerminal(n,i){return Promise.resolve(void 0)}async $substituteVariables(n,i){let r;const t=await this.getFolder(n);return t&&(r={uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(r,i)}createDebugAdapter(n,i){if(n.type==="implementation")return new w(n.implementation)}createSignService(){}async $startDASession(n,i){const r=this,t=await this.getSession(i);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(t.type),t).then(c=>{if(!c)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${t.type}' (extension might have failed to activate)`);const _=this.convertToDto(c),p=this.createDebugAdapter(_,t);if(!p)throw new Error(`Couldn't create a debug adapter for type '${t.type}'.`);const C=p;return this._debugAdapters.set(n,C),this.getDebugAdapterTrackers(t).then(U=>(U&&this._debugAdaptersTrackers.set(n,U),C.onMessage(async W=>{if(W.type==="request"&&W.command==="handshake"){const L=W,S={type:"response",seq:0,command:L.command,request_seq:L.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const z=await this._signService.sign(L.arguments.value);S.body={signature:z},C.sendResponse(S)}else throw new Error("no signer")}catch(z){S.success=!1,S.message=z.message,C.sendResponse(S)}}else U&&U.onDidSendMessage&&U.onDidSendMessage(W),W=(0,f.convertToVSCPaths)(W,!0),r._debugServiceProxy.$acceptDAMessage(n,W)}),C.onError(W=>{U&&U.onError&&U.onError(W),this._debugServiceProxy.$acceptDAError(n,W.name,W.message,W.stack)}),C.onExit(W=>{U&&U.onExit&&U.onExit((0,b.withNullAsUndefined)(W),void 0),this._debugServiceProxy.$acceptDAExit(n,(0,b.withNullAsUndefined)(W),void 0)}),U&&U.onWillStartSession&&U.onWillStartSession(),C.startSession()))})}$sendDAMessage(n,i){i=(0,f.convertToDAPaths)(i,!1);const r=this._debugAdaptersTrackers.get(n);r&&r.onWillReceiveMessage&&r.onWillReceiveMessage(i),this._debugAdapters.get(n)?.sendMessage(i)}$stopDASession(n){const i=this._debugAdaptersTrackers.get(n);this._debugAdaptersTrackers.delete(n),i&&i.onWillStopSession&&i.onWillStopSession();const r=this._debugAdapters.get(n);return this._debugAdapters.delete(n),r?r.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(n){const i=[],r=[],t=[];if(n.added)for(const c of n.added){const _=c.id;if(_&&!this._breakpoints.has(_)){let p;if(c.type==="function")p=new y.FunctionBreakpoint(c.functionName,c.enabled,c.condition,c.hitCondition,c.logMessage);else if(c.type==="data")p=new y.DataBreakpoint(c.label,c.dataId,c.canPersist,c.enabled,c.hitCondition,c.condition,c.logMessage);else{const C=M.URI.revive(c.uri);p=new y.SourceBreakpoint(new y.Location(C,new y.Position(c.line,c.character)),c.enabled,c.condition,c.hitCondition,c.logMessage)}p._id=_,this._breakpoints.set(_,p),i.push(p)}}if(n.removed)for(const c of n.removed){const _=this._breakpoints.get(c);_&&(this._breakpoints.delete(c),r.push(_))}if(n.changed){for(const c of n.changed)if(c.id){const _=this._breakpoints.get(c.id);if(_){if(_ instanceof y.FunctionBreakpoint&&c.type==="function"){const p=_;p.enabled=c.enabled,p.condition=c.condition,p.hitCondition=c.hitCondition,p.logMessage=c.logMessage,p.functionName=c.functionName}else if(_ instanceof y.SourceBreakpoint&&c.type==="source"){const p=_;p.enabled=c.enabled,p.condition=c.condition,p.hitCondition=c.hitCondition,p.logMessage=c.logMessage,p.location=new y.Location(M.URI.revive(c.uri),new y.Position(c.line,c.character))}t.push(_)}}}this.fireBreakpointChanges(i,r,t)}$provideDebugConfigurations(n,i,r){return(0,a.asPromise)(async()=>{const t=this.getConfigProviderByHandle(n);if(!t)throw new Error("no DebugConfigurationProvider found");if(!t.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const c=await this.getFolder(i);return t.provideDebugConfigurations(c,r)}).then(t=>{if(!t)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return t})}$resolveDebugConfiguration(n,i,r,t){return(0,a.asPromise)(async()=>{const c=this.getConfigProviderByHandle(n);if(!c)throw new Error("no DebugConfigurationProvider found");if(!c.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const _=await this.getFolder(i);return c.resolveDebugConfiguration(_,r,t)})}$resolveDebugConfigurationWithSubstitutedVariables(n,i,r,t){return(0,a.asPromise)(async()=>{const c=this.getConfigProviderByHandle(n);if(!c)throw new Error("no DebugConfigurationProvider found");if(!c.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const _=await this.getFolder(i);return c.resolveDebugConfigurationWithSubstitutedVariables(_,r,t)})}async $provideDebugAdapter(n,i){const r=this.getAdapterDescriptorFactoryByHandle(n);if(!r)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const t=await this.getSession(i);return this.getAdapterDescriptor(r,t).then(c=>{if(!c)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${t.type}'`);return this.convertToDto(c)})}async $acceptDebugSessionStarted(n){const i=await this.getSession(n);this._onDidStartDebugSession.fire(i)}async $acceptDebugSessionTerminated(n){const i=await this.getSession(n);i&&(this._onDidTerminateDebugSession.fire(i),this._debugSessions.delete(i.id))}async $acceptDebugSessionActiveChanged(n){this._activeDebugSession=n?await this.getSession(n):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(n,i){(await this.getSession(n))?._acceptNameChanged(i)}async $acceptDebugSessionCustomEvent(n,i){const t={session:await this.getSession(n),event:i.event,body:i.body};this._onDidReceiveDebugSessionCustomEvent.fire(t)}convertToDto(n){if(n instanceof y.DebugAdapterExecutable)return{type:"executable",command:n.command,args:n.args,options:n.options};if(n instanceof y.DebugAdapterServer)return{type:"server",port:n.port,host:n.host};if(n instanceof y.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:n.path};if(n instanceof y.DebugAdapterInlineImplementation)return{type:"implementation",implementation:n.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(n){const i=this._adapterFactories.filter(r=>r.type===n);if(i.length>0)return i[0].factory}getAdapterDescriptorFactoryByHandle(n){const i=this._adapterFactories.filter(r=>r.handle===n);if(i.length>0)return i[0].factory}getConfigProviderByHandle(n){const i=this._configProviders.filter(r=>r.handle===n);if(i.length>0)return i[0].provider}definesDebugType(n,i){if(n.contributes){const r=n.contributes.debuggers;if(r&&r.length>0){for(const t of r)if(t.label&&t.type&&t.type===i)return!0}}return!1}getDebugAdapterTrackers(n){const r=n.configuration.type,t=this._trackerFactories.filter(c=>c.type===r||c.type==="*").map(c=>(0,a.asPromise)(()=>c.factory.createDebugAdapterTracker(n)).then(_=>_,_=>null));return Promise.race([Promise.all(t).then(c=>{const _=c.filter(p=>!!p);if(_.length>0)return new l(_)}),new Promise((c,_)=>{const p=setTimeout(()=>{clearTimeout(p),_(new Error("timeout"))},1e3)})]).catch(c=>{})}async getAdapterDescriptor(n,i){const r=i.configuration.debugServer;if(typeof r=="number")return Promise.resolve(new y.DebugAdapterServer(r));if(n){const c=await this._extensionService.getExtensionRegistry();return(0,a.asPromise)(()=>n.createDebugAdapterDescriptor(i,this.daExecutableFromPackage(i,c))).then(_=>{if(_)return _})}const t=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(i,t))}daExecutableFromPackage(n,i){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(n,i,r){(n.length>0||i.length>0||r.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:n,removed:i,changed:r}))}async getSession(n){if(n)if(typeof n=="string"){const i=this._debugSessions.get(n);if(i)return i}else{let i=this._debugSessions.get(n.id);if(!i){const r=await this.getFolder(n.folderUri),t=n.parent?this._debugSessions.get(n.parent):void 0;i=new g(this._debugServiceProxy,n.id,n.type,n.name,r,n.configuration,t),this._debugSessions.set(i.id,i),this._debugServiceProxy.$sessionCached(i.id)}return i}throw new Error("cannot find session")}getFolder(n){if(n){const i=M.URI.revive(n);return this._workspaceService.resolveWorkspaceFolder(i)}return Promise.resolve(void 0)}};o=ze([xe(0,O.IExtHostRpcService),xe(1,m.IExtHostWorkspace),xe(2,T.IExtHostExtensionService),xe(3,h.IExtHostConfiguration),xe(4,E.IExtHostEditorTabs),xe(5,d.IExtHostVariableResolverProvider)],o),e.ExtHostDebugServiceBase=o;class g{constructor(n,i,r,t,c,_,p){this._debugServiceProxy=n,this._id=i,this._type=r,this._name=t,this._workspaceFolder=c,this._configuration=_,this._parentSession=p}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(n){this._name=n,this._debugServiceProxy.$setDebugSessionName(this._id,n)}get parentSession(){return this._parentSession}_acceptNameChanged(n){this._name=n}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(n,i){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,n,i)}getDebugProtocolBreakpoint(n){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,n.id)}}e.ExtHostDebugSession=g;class R{constructor(n){this.value=Object.freeze({append(i){n.$appendDebugConsole(i)},appendLine(i){this.append(i+`
`)}})}}e.ExtHostDebugConsole=R;class l{constructor(n){this.trackers=n}onWillStartSession(){this.trackers.forEach(n=>n.onWillStartSession?n.onWillStartSession():void 0)}onWillReceiveMessage(n){this.trackers.forEach(i=>i.onWillReceiveMessage?i.onWillReceiveMessage(n):void 0)}onDidSendMessage(n){this.trackers.forEach(i=>i.onDidSendMessage?i.onDidSendMessage(n):void 0)}onWillStopSession(){this.trackers.forEach(n=>n.onWillStopSession?n.onWillStopSession():void 0)}onError(n){this.trackers.forEach(i=>i.onError?i.onError(n):void 0)}onExit(n,i){this.trackers.forEach(r=>r.onExit?r.onExit(n,i):void 0)}}class w extends k.AbstractDebugAdapter{constructor(n){super();this.implementation=n,n.onDidSendMessage(i=>{this.acceptMessage(i)})}startSession(){return Promise.resolve(void 0)}sendMessage(n){this.implementation.handleMessage(n)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let s=class extends o{constructor(n,i,r,t,c,_){super(n,i,r,t,c,_)}};s=ze([xe(0,O.IExtHostRpcService),xe(1,m.IExtHostWorkspace),xe(2,T.IExtHostExtensionService),xe(3,h.IExtHostConfiguration),xe(4,E.IExtHostEditorTabs),xe(5,d.IExtHostVariableResolverProvider)],s),e.WorkerExtHostDebugService=s}),define(ye[232],De([1,0,11,71,2,4,223,15,56,58,28,148,13,63,33]),function(ne,e,a,v,b,M,D,P,E,T,O,y,m,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class h{constructor(o,g,R,l,w){this._hostUtils=R,this._rpcProtocol=new D.RPCProtocol(o,null,l),g=h._transform(g,this._rpcProtocol);const s=new T.ServiceCollection(...(0,E.getSingletonServiceDescriptors)());s.set(O.IExtHostInitDataService,{_serviceBrand:void 0,...g,messagePorts:w}),s.set(m.IExtHostRpcService,new m.ExtHostRpcService(this._rpcProtocol)),s.set(k.IURITransformerService,new k.URITransformerService(l)),s.set(f.IHostUtils,R);const u=new y.InstantiationService(s,!0);this._logService=u.invokeFunction(t=>t.get(P.ILogService)),v.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",g),this._extensionService=u.invokeFunction(t=>t.get(f.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const n=new WeakMap;this._extensionService.getExtensionPathIndex().then(t=>{Error.prepareStackTrace=(c,_)=>{let p="",C,U;for(const W of _)p+=`
	at ${W.toString()}`,U=W.getFileName(),!C&&U&&(C=t.findSubstr(b.URI.file(U)));return n.set(c,C),`${c.name||"Error"}: ${c.message||""}${p}`}});const i=this._rpcProtocol.getProxy(M.MainContext.MainThreadExtensionService),r=this._rpcProtocol.getProxy(M.MainContext.MainThreadErrors);a.setUnexpectedErrorHandler(t=>{const c=a.transformErrorForSerialization(t),_=n.get(t);_?i.$onExtensionRuntimeError(_.identifier,c):r.$onUnexpectedError(c)})}async asBrowserUri(o){const g=this._rpcProtocol.getProxy(M.MainContext.MainThreadExtensionService);return b.URI.revive(await g.$asBrowserUri(o))}terminate(o){this._extensionService.terminate(o)}static _transform(o,g){o.allExtensions.forEach(l=>{l.extensionLocation=b.URI.revive(g.transformIncomingURIs(l.extensionLocation));const w={};l.browserNlsBundleUris&&(Object.keys(l.browserNlsBundleUris).forEach(s=>w[s]=b.URI.revive(g.transformIncomingURIs(l.browserNlsBundleUris[s]))),l.browserNlsBundleUris=w)}),o.environment.appRoot=b.URI.revive(g.transformIncomingURIs(o.environment.appRoot));const R=o.environment.extensionDevelopmentLocationURI;return R&&(o.environment.extensionDevelopmentLocationURI=R.map(l=>b.URI.revive(g.transformIncomingURIs(l)))),o.environment.extensionTestsLocationURI=b.URI.revive(g.transformIncomingURIs(o.environment.extensionTestsLocationURI)),o.environment.globalStorageHome=b.URI.revive(g.transformIncomingURIs(o.environment.globalStorageHome)),o.environment.workspaceStorageHome=b.URI.revive(g.transformIncomingURIs(o.environment.workspaceStorageHome)),o.logsLocation=b.URI.revive(g.transformIncomingURIs(o.logsLocation)),o.logFile=b.URI.revive(g.transformIncomingURIs(o.logFile)),o.workspace=g.transformIncomingURIs(o.workspace),o}}e.ExtensionHostMain=h}),define(ye[233],De([1,0,16,14,20,43,12,19,22,2,41]),function(ne,e,a,v,b,M,D,P,E,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class y{constructor(g,R,l,w){this.query=g,this.provider=R,this.fileUtils=l,this.processType=w,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(g,R){const l=this.query.folderQueries||[],w=new b.CancellationTokenSource;return R.onCancellationRequested(()=>w.cancel()),new Promise((s,u)=>{this.collector=new k(g);let n=!1;const i=(r,t)=>{if(!n&&!this.isLimitHit){const c=this.resultSize(r);h(r)&&typeof this.query.maxResults=="number"&&this.resultCount+c>this.query.maxResults&&(this.isLimitHit=!0,n=!0,w.cancel(),r=this.trimResultToSize(r,this.query.maxResults-this.resultCount));const _=this.resultSize(r);this.resultCount+=_,(_>0||!h(r))&&this.collector.add(r,t)}};Promise.all(l.map((r,t)=>this.searchInFolder(r,c=>i(c,t),w.token))).then(r=>{w.dispose(),this.collector.flush();const t=r.some(c=>!!c&&!!c.limitHit);s({limitHit:this.isLimitHit||t,messages:(0,a.flatten)(r.map(c=>c?.message?Array.isArray(c.message)?c.message:[c.message]:[])),stats:{type:this.processType}})},r=>{w.dispose();const t=(0,M.toErrorMessage)(r);u(new Error(t))})})}resultSize(g){return h(g)?Array.isArray(g.ranges)?g.ranges.length:1:0}trimResultToSize(g,R){const l=Array.isArray(g.ranges)?g.ranges:[g.ranges],w=Array.isArray(g.preview.matches)?g.preview.matches:[g.preview.matches];return{ranges:l.slice(0,R),preview:{matches:w.slice(0,R),text:g.preview.text},uri:g.uri}}async searchInFolder(g,R,l){const w=new O.QueryGlobTester(this.query,g),s=[],u={report:r=>{if(!this.validateProviderResult(r))return;const t=g.folder.scheme===D.Schemas.file?(0,O.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(E.dirname(r.uri))):void 0,c=E.relativePath(g.folder,r.uri);if(c){const _=w.includedInQuery(c,P.basename(c),t);(0,v.isThenable)(_)?s.push(_.then(p=>{p&&R(r)})):_&&R(r)}}},n=this.getSearchOptionsForFolder(g),i=await this.provider.provideTextSearchResults(m(this.query.contentPattern),n,u,l);return s.length&&await Promise.all(s),i}validateProviderResult(g){if(h(g)){if(Array.isArray(g.ranges)){if(!Array.isArray(g.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(g.preview.matches.length!==g.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(g.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(g){const R=(0,O.resolvePatternsForProvider)(this.query.includePattern,g.includePattern),l=(0,O.resolvePatternsForProvider)(this.query.excludePattern,g.excludePattern),w={folder:T.URI.from(g.folder),excludes:l,includes:R,useIgnoreFiles:!g.disregardIgnoreFiles,useGlobalIgnoreFiles:!g.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!g.disregardParentIgnoreFiles,followSymlinks:!g.ignoreSymlinks,encoding:g.fileEncoding&&this.fileUtils.toCanonicalName(g.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return w.usePCRE2=this.query.usePCRE2,w}}e.TextSearchManager=y;function m(o){return{isCaseSensitive:o.isCaseSensitive||!1,isRegExp:o.isRegExp||!1,isWordMatch:o.isWordMatch||!1,isMultiline:o.isMultiline||!1,pattern:o.pattern}}class k{constructor(g){this._onResult=g,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new d(512,R=>this.sendItems(R))}add(g,R){this._currentFileMatch&&(this._currentFolderIdx!==R||!E.isEqual(this._currentUri,g.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=R,this._currentFileMatch={resource:g.uri,results:[]}),this._currentFileMatch.results.push(f(g))}pushToCollector(){const g=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,g)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(g){this._onResult(g)}}e.TextSearchResultsCollector=k;function f(o){return h(o)?{preview:{matches:(0,a.mapArrayOrNot)(o.preview.matches,g=>({startLineNumber:g.start.line,startColumn:g.start.character,endLineNumber:g.end.line,endColumn:g.end.character})),text:o.preview.text},ranges:(0,a.mapArrayOrNot)(o.ranges,g=>({startLineNumber:g.start.line,startColumn:g.start.character,endLineNumber:g.end.line,endColumn:g.end.character}))}:{text:o.text,lineNumber:o.lineNumber}}function h(o){return!!o.preview}e.extensionResultIsMatch=h;class d{constructor(g,R){this.maxBatchSize=g,this.cb=R,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(g,R){!g||this.addItemToBatch(g,R)}addItems(g,R){!g||this.addItemsToBatch(g,R)}addItemToBatch(g,R){this.batch.push(g),this.batchSize+=R,this.onUpdate()}addItemsToBatch(g,R){this.batch=this.batch.concat(g),this.batchSize+=R,this.onUpdate()}onUpdate(){this.totalNumberCompleted<d.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},d.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=d,d.TIMEOUT=4e3,d.START_BATCH_AFTER_COUNT=50}),define(ye[104],De([1,0,7,4,3,228,13,63,15,2,233]),function(ne,e,a,v,b,M,D,P,E,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,b.createDecorator)("IExtHostSearch");let y=class{constructor(h,d,o){this.extHostRpc=h,this._uriTransformer=d,this._logService=o,this._proxy=this.extHostRpc.getProxy(v.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new M.FileSearchManager}_transformScheme(h){return this._uriTransformer.transformOutgoingScheme(h)}registerTextSearchProvider(h,d){if(this._textSearchUsedSchemes.has(h))throw new Error(`a text search provider for the scheme '${h}' is already registered`);this._textSearchUsedSchemes.add(h);const o=this._handlePool++;return this._textSearchProvider.set(o,d),this._proxy.$registerTextSearchProvider(o,this._transformScheme(h)),(0,a.toDisposable)(()=>{this._textSearchUsedSchemes.delete(h),this._textSearchProvider.delete(o),this._proxy.$unregisterProvider(o)})}registerFileSearchProvider(h,d){if(this._fileSearchUsedSchemes.has(h))throw new Error(`a file search provider for the scheme '${h}' is already registered`);this._fileSearchUsedSchemes.add(h);const o=this._handlePool++;return this._fileSearchProvider.set(o,d),this._proxy.$registerFileSearchProvider(o,this._transformScheme(h)),(0,a.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(h),this._fileSearchProvider.delete(o),this._proxy.$unregisterProvider(o)})}$provideFileSearchResults(h,d,o,g){const R=m(o),l=this._fileSearchProvider.get(h);if(l)return this._fileSearchManager.fileSearch(R,l,w=>{this._proxy.$handleFileMatch(h,d,w.map(s=>s.resource))},g);throw new Error("unknown provider: "+h)}$clearCache(h){return this._fileSearchManager.clearCache(h),Promise.resolve(void 0)}$provideTextSearchResults(h,d,o,g){const R=this._textSearchProvider.get(h);if(!R||!R.provideTextSearchResults)throw new Error(`Unknown provider ${h}`);const l=m(o);return this.createTextSearchManager(l,R).search(s=>this._proxy.$handleTextMatch(h,d,s),g)}$enableExtensionHostSearch(){}createTextSearchManager(h,d){return new O.TextSearchManager(h,d,{readdir:o=>Promise.resolve([]),toCanonicalName:o=>o},"textSearchProvider")}};y=ze([xe(0,D.IExtHostRpcService),xe(1,P.IURITransformerService),xe(2,E.ILogService)],y),e.ExtHostSearch=y;function m(f){return{...f,folderQueries:f.folderQueries&&f.folderQueries.map(k),extraFileResources:f.extraFileResources&&f.extraFileResources.map(h=>T.URI.revive(h))}}e.reviveQuery=m;function k(f){return{...f,folder:T.URI.revive(f.folder)}}}),define(ye[234],De([1,0,56,99,31,95,32,36,49,52,101,103,104,69,62,68,98,51,35,67,86,50,206,15,182,102,97]),function(ne,e,a,v,b,M,D,P,E,T,O,y,m,k,f,h,d,o,g,R,l,w,s,u,n,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,a.registerSingleton)(u.ILoggerService,s.ExtHostLoggerService),(0,a.registerSingleton)(u.ILogService,n.ExtHostLogService),(0,a.registerSingleton)(h.IExtHostApiDeprecationService,h.ExtHostApiDeprecationService),(0,a.registerSingleton)(P.IExtHostCommands,P.ExtHostCommands),(0,a.registerSingleton)(D.IExtHostConfiguration,D.ExtHostConfiguration),(0,a.registerSingleton)(o.IExtHostConsumerFileSystem,o.ExtHostConsumerFileSystem),(0,a.registerSingleton)(y.IExtHostDebugService,y.WorkerExtHostDebugService),(0,a.registerSingleton)(M.IExtHostDecorations,M.ExtHostDecorations),(0,a.registerSingleton)(E.IExtHostDocumentsAndEditors,E.ExtHostDocumentsAndEditors),(0,a.registerSingleton)(g.IExtHostFileSystemInfo,g.ExtHostFileSystemInfo),(0,a.registerSingleton)(v.IExtHostOutputService,v.ExtHostOutputService),(0,a.registerSingleton)(m.IExtHostSearch,m.ExtHostSearch),(0,a.registerSingleton)(k.IExtHostStorage,k.ExtHostStorage),(0,a.registerSingleton)(O.IExtHostTask,O.WorkerExtHostTask),(0,a.registerSingleton)(T.IExtHostTerminalService,T.WorkerExtHostTerminalService),(0,a.registerSingleton)(f.IExtHostTunnelService,f.ExtHostTunnelService),(0,a.registerSingleton)(d.IExtHostWindow,d.ExtHostWindow),(0,a.registerSingleton)(b.IExtHostWorkspace,b.ExtHostWorkspace),(0,a.registerSingleton)(R.IExtHostSecretState,R.ExtHostSecretState),(0,a.registerSingleton)(l.IExtHostTelemetry,l.ExtHostTelemetry),(0,a.registerSingleton)(r.IExtHostTelemetryLogService,r.ExtHostTelemetryLogService),(0,a.registerSingleton)(w.IExtHostEditorTabs,w.ExtHostEditorTabs),(0,a.registerSingleton)(i.IExtHostVariableResolverProvider,i.ExtHostVariableResolverProviderService)}),define(ye[235],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class a{constructor(){this._dragOperations=new Map,this._renderedElements=new Map}removeDragOperationTransfer(b){if(b&&this._dragOperations.has(b)){const M=this._dragOperations.get(b);return this._dragOperations.delete(b),M}}addDragOperationTransfer(b,M){this._dragOperations.set(b,M)}getRenderedTreeElement(b){if(this._renderedElements.has(b))return this._renderedElements.get(b)}addRenderedTreeItemElement(b,M){this._renderedElements.set(b,M)}removeRenderedTreeItemElement(b){this._renderedElements.has(b)&&this._renderedElements.delete(b)}}e.TreeviewsService=a}),define(ye[236],De([1,0,134,6,22,2,5,7,14,6,10,16,8,20,235,24]),function(ne,e,a,v,b,M,D,P,E,T,O,y,m,k,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function d(R,l){if((0,O.isString)(R))return{label:R};if(R&&typeof R=="object"&&typeof R.label=="string"){let w;return Array.isArray(R.highlights)&&(w=R.highlights.filter(s=>s.length===2&&typeof s[0]=="number"&&typeof s[1]=="number"),w=w.length?w:void 0),{label:R.label,highlights:w}}}class o{constructor(l,w,s){this._proxy=l,this.commands=w,this.logService=s,this.treeViews=new Map,this.treeDragAndDropService=new f.TreeviewsService;function u(n){return n&&n.$treeViewId&&(n.$treeItemHandle||n.$selectedTreeItems)}w.registerArgumentProcessor({processArgument:n=>u(n)?this.convertArgument(n):Array.isArray(n)&&n.length>0?n.map(i=>u(i)?this.convertArgument(i):i):n})}registerTreeDataProvider(l,w,s){const u=this.createTreeView(l,{treeDataProvider:w},s);return{dispose:()=>u.dispose()}}createTreeView(l,w,s){if(!w||!w.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const u=w.dragAndDropController?.dropMimeTypes??[],n=w.dragAndDropController?.dragMimeTypes??[],i=!!w.dragAndDropController?.handleDrag,r=!!w.dragAndDropController?.handleDrop,t=this._proxy.$registerTreeViewDataProvider(l,{showCollapseAll:!!w.showCollapseAll,canSelectMany:!!w.canSelectMany,dropMimeTypes:u,dragMimeTypes:n,hasHandleDrag:i,hasHandleDrop:r}),c=this.createExtHostTreeView(l,w,s);return{get onDidCollapseElement(){return c.onDidCollapseElement},get onDidExpandElement(){return c.onDidExpandElement},get selection(){return c.selectedElements},get onDidChangeSelection(){return c.onDidChangeSelection},get visible(){return c.visible},get onDidChangeVisibility(){return c.onDidChangeVisibility},get message(){return c.message},set message(_){c.message=_},get title(){return c.title},set title(_){c.title=_},get description(){return c.description},set description(_){c.description=_},get badge(){return(0,h.checkProposedApiEnabled)(s,"badges"),c.badge},set badge(_){(0,h.checkProposedApiEnabled)(s,"badges"),c.badge=_},reveal:(_,p)=>c.reveal(_,p),dispose:async()=>{await t,this.treeViews.delete(l),c.dispose()}}}$getChildren(l,w){const s=this.treeViews.get(l);return s?s.getChildren(w):Promise.reject(new Error((0,a.localize)(0,null,l)))}async $handleDrop(l,w,s,u,n,i,r,t){const c=this.treeViews.get(l);if(!c)return Promise.reject(new Error((0,a.localize)(1,null,l)));const _=m.DataTransfer.toDataTransfer(s,async p=>(await this._proxy.$resolveDropFileData(l,w,p)).buffer);return r===l&&t&&await this.addAdditionalTransferItems(_,c,t,n,i),c.onDrop(_,u,n)}async addAdditionalTransferItems(l,w,s,u,n){const i=this.treeDragAndDropService.removeDragOperationTransfer(n);if(i)(await i)?.forEach((r,t)=>{r&&l.set(t,r)});else if(n&&w.handleDrag){const r=w.handleDrag(s,l,u);this.treeDragAndDropService.addDragOperationTransfer(n,r),await r}return l}async $handleDrag(l,w,s,u){const n=this.treeViews.get(l);if(!n)return Promise.reject(new Error((0,a.localize)(2,null,l)));const i=await this.addAdditionalTransferItems(new v.DataTransfer,n,w,u,s);if(!!i)return m.DataTransfer.toDataTransferDTO(i)}async $hasResolve(l){const w=this.treeViews.get(l);if(!w)throw new Error((0,a.localize)(3,null,l));return w.hasResolve}$resolve(l,w,s){const u=this.treeViews.get(l);if(!u)throw new Error((0,a.localize)(4,null,l));return u.resolveTreeItem(w,s)}$setExpanded(l,w,s){const u=this.treeViews.get(l);if(!u)throw new Error((0,a.localize)(5,null,l));u.setExpanded(w,s)}$setSelection(l,w){const s=this.treeViews.get(l);if(!s)throw new Error((0,a.localize)(6,null,l));s.setSelection(w)}$setVisible(l,w){const s=this.treeViews.get(l);if(!s)throw new Error((0,a.localize)(7,null,l));s.setVisible(w)}createExtHostTreeView(l,w,s){const u=new g(l,w,this._proxy,this.commands.converter,this.logService,s);return this.treeViews.set(l,u),u}convertArgument(l){const w=this.treeViews.get(l.$treeViewId);return w&&"$treeItemHandle"in l?w.getExtensionElement(l.$treeItemHandle):w&&"$selectedTreeItems"in l&&l.$selectedTreeItems?{selectedTreeItems:w.selectedElements}:null}}e.ExtHostTreeViews=o;class g extends P.Disposable{constructor(l,w,s,u,n,i){super();if(this.viewId=l,this.proxy=s,this.commands=u,this.logService=n,this.extension=i,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new D.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new D.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new D.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new D.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new D.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new k.CancellationTokenSource,i.contributes&&i.contributes.views)for(const c in i.contributes.views)for(const _ of i.contributes.views[c])_.id===l&&(this._title=_.name);this.dataProvider=w.treeDataProvider,this.dndController=w.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(c=>this._onDidChangeData.fire({message:!1,element:c})));let r,t;this._register(D.Event.debounce(this._onDidChangeData.event,(c,_)=>(c||(c={message:!1,elements:[]}),_.element!==!1&&(r||(r=new Promise(p=>t=p),this.refreshPromise=this.refreshPromise.then(()=>r)),Array.isArray(_.element)?c.elements.push(..._.element):c.elements.push(_.element)),_.message&&(c.message=!0),c),200,!0)(({message:c,elements:_})=>{_.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const p=t;return r=null,this.refresh(_).then(()=>p())})),c&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(l=>this.getExtensionElement(l)).filter(l=>!(0,O.isUndefinedOrNull)(l))}async getChildren(l){const w=l?this.getExtensionElement(l):void 0;if(l&&!w)return this.logService.error(`No tree item with id '${l}' found.`),Promise.resolve([]);let s=this.getChildrenNodes(l);return s||(s=await this.fetchChildrenNodes(w)),s?s.map(u=>u.item):void 0}getExtensionElement(l){return this.elements.get(l)}reveal(l,w){w=w||{select:!0,focus:!1};const s=(0,O.isUndefinedOrNull)(w.select)?!0:w.select,u=(0,O.isUndefinedOrNull)(w.focus)?!1:w.focus,n=(0,O.isUndefinedOrNull)(w.expand)?!1:w.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):l?this.refreshPromise.then(()=>this.resolveUnknownParentChain(l)).then(i=>this.resolveTreeNode(l,i[i.length-1]).then(r=>this.proxy.$reveal(this.viewId,{item:r.item,parentChain:i.map(t=>t.item)},{select:s,focus:u,expand:n})),i=>this.logService.error(i)):this.proxy.$reveal(this.viewId,void 0,{select:s,focus:u,expand:n})}get message(){return this._message}set message(l){this._message=l,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(l){this._title=l,this.proxy.$setTitle(this.viewId,l,this._description)}get description(){return this._description}set description(l){this._description=l,this.proxy.$setTitle(this.viewId,this._title,l)}get badge(){return this._badge}set badge(l){this._badge?.value===l?.value&&this._badge?.tooltip===l?.tooltip||(this._badge=m.ViewBadge.from(l),this.proxy.$setBadge(this.viewId,l))}setExpanded(l,w){const s=this.getExtensionElement(l);s&&(w?this._onDidExpandElement.fire(Object.freeze({element:s})):this._onDidCollapseElement.fire(Object.freeze({element:s})))}setSelection(l){(0,y.equals)(this._selectedHandles,l)||(this._selectedHandles=l,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(l){l!==this._visible&&(this._visible=l,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async handleDrag(l,w,s){const u=[];for(const n of l){const i=this.getExtensionElement(n);i&&u.push(i)}if(!(!this.dndController?.handleDrag||u.length===0))return await this.dndController.handleDrag(u,w,s),w}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(l,w,s){const u=w?this.getExtensionElement(w):void 0;if(!(!u&&w||!this.dndController?.handleDrop))return(0,E.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(u,l,s):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(l,w){if(!this.dataProvider.resolveTreeItem)return;const s=this.elements.get(l);if(s){const u=this.nodes.get(s);if(u){const n=await this.dataProvider.resolveTreeItem(u.extensionItem,s,w)??u.extensionItem;return this.validateTreeItem(n),u.item.tooltip=this.getTooltip(n.tooltip),u.item.command=this.getCommand(u.disposableStore,n.command),u.item}}}resolveUnknownParentChain(l){return this.resolveParent(l).then(w=>w?this.resolveUnknownParentChain(w).then(s=>this.resolveTreeNode(w,s[s.length-1]).then(u=>(s.push(u),s))):Promise.resolve([]))}resolveParent(l){const w=this.nodes.get(l);return w?Promise.resolve(w.parent?this.elements.get(w.parent.item.handle):void 0):(0,E.asPromise)(()=>this.dataProvider.getParent(l))}resolveTreeNode(l,w){const s=this.nodes.get(l);return s?Promise.resolve(s):(0,E.asPromise)(()=>this.dataProvider.getTreeItem(l)).then(u=>this.createHandle(l,u,w,!0)).then(u=>this.getChildren(w?w.item.handle:void 0).then(()=>{const n=this.getExtensionElement(u);if(n){const i=this.nodes.get(n);if(i)return Promise.resolve(i)}throw new Error(`Cannot resolve tree item for element ${u}`)}))}getChildrenNodes(l){if(l){let w;if(typeof l=="string"){const s=this.getExtensionElement(l);w=s?this.nodes.get(s):void 0}else w=l;return w&&w.children||void 0}return this.roots}async fetchChildrenNodes(l){this.clearChildren(l);const w=new k.CancellationTokenSource(this._refreshCancellationSource.token);try{const s=l?this.nodes.get(l):void 0,u=await this.dataProvider.getChildren(l);if(w.token.isCancellationRequested)return;const n=await Promise.all((0,y.coalesce)(u||[]).map(async i=>{const r=await this.dataProvider.getTreeItem(i);return r&&!w.token.isCancellationRequested?this.createAndRegisterTreeNode(i,r,s):null}));return w.token.isCancellationRequested?void 0:(0,y.coalesce)(n)}finally{w.dispose()}}refresh(l){if(l.some(s=>!s))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new k.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const s=this.getHandlesToRefresh(l);if(s.length)return this.refreshHandles(s)}return Promise.resolve(void 0)}getHandlesToRefresh(l){const w=new Set,s=l.map(n=>this.nodes.get(n));for(const n of s)if(n&&!w.has(n.item.handle)){let i=n;for(;i&&i.parent&&s.findIndex(r=>i&&i.parent&&r&&r.item.handle===i.parent.item.handle)===-1;){const r=this.elements.get(i.parent.item.handle);i=r?this.nodes.get(r):void 0}i&&!i.parent&&w.add(n.item.handle)}const u=[];return w.forEach(n=>{const i=this.elements.get(n);if(i){const r=this.nodes.get(i);r&&(!r.parent||!w.has(r.parent.item.handle))&&u.push(n)}}),u}refreshHandles(l){const w={};return Promise.all(l.map(s=>this.refreshNode(s).then(u=>{u&&(w[s]=u.item)}))).then(()=>Object.keys(w).length?this.proxy.$refresh(this.viewId,w):void 0)}refreshNode(l){const w=this.getExtensionElement(l);if(w){const s=this.nodes.get(w);if(s)return this.clearChildren(w),(0,E.asPromise)(()=>this.dataProvider.getTreeItem(w)).then(u=>{if(u){const n=this.createTreeNode(w,u,s.parent);return this.updateNodeCache(w,n,s,s.parent),s.dispose(),n}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(l,w,s){const u=this.createTreeNode(l,w,s);if(w.id&&this.elements.has(u.item.handle))throw new Error((0,a.localize)(8,null,w.id));return this.addNodeToCache(l,u),this.addNodeToParentCache(u,s),u}getTooltip(l){return T.MarkdownString.isMarkdownString(l)?m.MarkdownString.from(l):l}getCommand(l,w){return w?{...this.commands.toInternal(w,l),originalId:w.command}:void 0}validateTreeItem(l){T.TreeItem.isTreeItem(l)||console.log(`Extension ${this.extension.identifier.value} has provided an invalid tree item.`)}createTreeNode(l,w,s){this.validateTreeItem(w);const u=new P.DisposableStore,n=this.createHandle(l,w,s),i=this.getLightIconPath(w);return{item:{handle:n,parentHandle:s?s.item.handle:void 0,label:d(w.label,this.extension),description:w.description,resourceUri:w.resourceUri,tooltip:this.getTooltip(w.tooltip),command:this.getCommand(u,w.command),contextValue:w.contextValue,icon:i,iconDark:this.getDarkIconPath(w)||i,themeIcon:this.getThemeIcon(w),collapsibleState:(0,O.isUndefinedOrNull)(w.collapsibleState)?T.TreeItemCollapsibleState.None:w.collapsibleState,accessibilityInformation:w.accessibilityInformation},extensionItem:w,parent:s,children:void 0,disposableStore:u,dispose(){u.dispose()}}}getThemeIcon(l){return l.iconPath instanceof T.ThemeIcon?l.iconPath:void 0}createHandle(l,{id:w,label:s,resourceUri:u},n,i){if(w)return`${g.ID_HANDLE_PREFIX}/${w}`;const r=d(s,this.extension),t=n?n.item.handle:g.LABEL_HANDLE_PREFIX;let c=r?r.label:u?(0,b.basename)(u):"";c=c.indexOf("/")!==-1?c.replace("/","//"):c;const _=this.nodes.has(l)?this.nodes.get(l).item.handle:void 0,p=this.getChildrenNodes(n)||[];let C,U=0;do{if(C=`${t}/${U}:${c}`,i||!this.elements.has(C)||_===C)break;U++}while(U<=p.length);return C}getLightIconPath(l){if(l.iconPath&&!(l.iconPath instanceof T.ThemeIcon))return typeof l.iconPath=="string"||M.URI.isUri(l.iconPath)?this.getIconPath(l.iconPath):this.getIconPath(l.iconPath.light)}getDarkIconPath(l){if(l.iconPath&&!(l.iconPath instanceof T.ThemeIcon)&&l.iconPath.dark)return this.getIconPath(l.iconPath.dark)}getIconPath(l){return M.URI.isUri(l)?l:M.URI.file(l)}addNodeToCache(l,w){this.elements.set(w.item.handle,l),this.nodes.set(l,w)}updateNodeCache(l,w,s,u){this.elements.delete(w.item.handle),this.nodes.delete(l),w.item.handle!==s.item.handle&&this.elements.delete(s.item.handle),this.addNodeToCache(l,w);const n=this.getChildrenNodes(u)||[],i=n.filter(r=>r.item.handle===s.item.handle)[0];i&&n.splice(n.indexOf(i),1,w)}addNodeToParentCache(l,w){w?(w.children||(w.children=[]),w.children.push(l)):(this.roots||(this.roots=[]),this.roots.push(l))}clearChildren(l){if(l){const w=this.nodes.get(l);if(w){if(w.children)for(const s of w.children){const u=this.elements.get(s.item.handle);u&&this.clear(u)}w.children=void 0}}else this.clearAll()}clear(l){const w=this.nodes.get(l);if(w){if(w.children)for(const s of w.children){const u=this.elements.get(s.item.handle);u&&this.clear(u)}this.nodes.delete(l),this.elements.delete(w.item.handle),w.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(l=>l.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}g.LABEL_HANDLE_PREFIX="0",g.ID_HANDLE_PREFIX="1"}),define(ye[237],De([1,0,20,11,5,29,2,121,247,110,119,39,4,94,191,190,36,192,32,194,195,196,175,197,49,33,199,200,203,205,207,99,178,211,212,213,69,52,215,236,8,6,218,53,98,31,164,202,85,95,101,103,104,15,63,13,28,208,161,62,68,188,216,70,51,221,219,220,189,35,214,217,67,50,86,209,100,210,12,81,177,159,201,7,24,166,9,97]),function(ne,e,a,v,b,M,D,P,E,T,O,y,m,k,f,h,d,o,g,R,l,w,s,u,n,i,r,t,c,_,p,C,U,W,L,S,z,$,F,q,ie,A,Z,le,oe,ue,te,Ee,be,ee,ve,Ae,Fe,$e,Qe,Ie,Se,ke,ae,ce,G,Q,I,B,H,V,se,de,J,pe,ge,Ne,Be,Je,Ge,Te,rt,K,X,fe,Ue,He,Ze,qe,We,nt,ot,ht){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function kt(it){const dt=it.get(Se.IExtHostInitDataService),Ot=it.get(pe.IExtHostFileSystemInfo),Wt=it.get(H.IExtHostConsumerFileSystem),Dt=it.get(i.IExtHostExtensionService),ft=it.get(ue.IExtHostWorkspace),Ct=it.get(Ge.IExtHostTelemetry),Lt=it.get(g.IExtHostConfiguration),Ft=it.get(Qe.IURITransformerService),Ve=it.get(Ie.IExtHostRpcService),Nt=it.get(z.IExtHostStorage),Rt=it.get(B.IExtensionStoragePaths),Ut=it.get($e.ILoggerService),vt=it.get($e.ILogService),we=it.get(ce.IExtHostTunnelService),Ce=it.get(ht.IExtHostTelemetryLogService),me=it.get(G.IExtHostApiDeprecationService),j=it.get(oe.IExtHostWindow),Pe=it.get(Be.IExtHostSecretState),Le=it.get(Je.IExtHostEditorTabs);Ve.set(m.ExtHostContext.ExtHostFileSystemInfo,Ot),Ve.set(m.ExtHostContext.ExtHostLogLevelServiceShape,Ut),Ve.set(m.ExtHostContext.ExtHostWorkspace,ft),Ve.set(m.ExtHostContext.ExtHostConfiguration,Lt),Ve.set(m.ExtHostContext.ExtHostExtensionService,Dt),Ve.set(m.ExtHostContext.ExtHostStorage,Nt),Ve.set(m.ExtHostContext.ExtHostTunnelService,we),Ve.set(m.ExtHostContext.ExtHostWindow,j),Ve.set(m.ExtHostContext.ExtHostSecretState,Pe),Ve.set(m.ExtHostContext.ExtHostTelemetry,Ct),Ve.set(m.ExtHostContext.ExtHostEditorTabs,Le);const tt=Ve.set(m.ExtHostContext.ExtHostDecorations,it.get(ee.IExtHostDecorations)),Xe=Ve.set(m.ExtHostContext.ExtHostDocumentsAndEditors,it.get(n.IExtHostDocumentsAndEditors)),je=Ve.set(m.ExtHostContext.ExtHostCommands,it.get(d.IExtHostCommands)),ut=Ve.set(m.ExtHostContext.ExtHostTerminalService,it.get($.IExtHostTerminalService)),gt=Ve.set(m.ExtHostContext.ExtHostDebugService,it.get(Ae.IExtHostDebugService)),yt=Ve.set(m.ExtHostContext.ExtHostSearch,it.get(Fe.IExtHostSearch)),pt=Ve.set(m.ExtHostContext.ExtHostTask,it.get(ve.IExtHostTask)),_t=Ve.set(m.ExtHostContext.ExtHostOutputService,it.get(C.IExtHostOutputService)),Pt=Ve.set(m.ExtHostContext.ExtHostUrls,new Z.ExtHostUrls(Ve)),mt=Ve.set(m.ExtHostContext.ExtHostDocuments,new u.ExtHostDocuments(Ve,Xe)),Yt=Ve.set(m.ExtHostContext.ExtHostDocumentContentProviders,new w.ExtHostDocumentContentProvider(Ve,Xe,vt)),Jt=Ve.set(m.ExtHostContext.ExtHostDocumentSaveParticipant,new s.ExtHostDocumentSaveParticipant(vt,mt,Ve.getProxy(m.MainContext.MainThreadBulkEdits))),bt=Ve.set(m.ExtHostContext.ExtHostNotebook,new ke.ExtHostNotebookController(Ve,je,Xe,mt,Rt)),Ht=Ve.set(m.ExtHostContext.ExtHostNotebookDocuments,new He.ExtHostNotebookDocuments(bt)),Bt=Ve.set(m.ExtHostContext.ExtHostNotebookEditors,new Ue.ExtHostNotebookEditors(vt,bt)),oi=Ve.set(m.ExtHostContext.ExtHostNotebookKernels,new Te.ExtHostNotebookKernels(Ve,dt,bt,je,vt)),ki=Ve.set(m.ExtHostContext.ExtHostNotebookRenderers,new K.ExtHostNotebookRenderers(Ve,bt)),It=Ve.set(m.ExtHostContext.ExtHostEditors,new F.ExtHostEditors(Ve,Xe)),qt=Ve.set(m.ExtHostContext.ExtHostTreeViews,new q.ExtHostTreeViews(Ve.getProxy(m.MainContext.MainThreadTreeViews),je,vt)),mi=Ve.set(m.ExtHostContext.ExtHostEditorInsets,new te.ExtHostEditorInsets(Ve.getProxy(m.MainContext.MainThreadEditorInsets),It,dt.remote)),Zt=Ve.set(m.ExtHostContext.ExtHostDiagnostics,new R.ExtHostDiagnostics(Ve,vt,Ot)),ei=Ve.set(m.ExtHostContext.ExtHostLanguages,new _.ExtHostLanguages(Ve,mt,je.converter,Ft)),ct=Ve.set(m.ExtHostContext.ExtHostLanguageFeatures,new c.ExtHostLanguageFeatures(Ve,Ft,mt,je,Zt,vt,me)),gi=Ve.set(m.ExtHostContext.ExtHostFileSystem,new r.ExtHostFileSystem(Ve,ct)),zt=Ve.set(m.ExtHostContext.ExtHostFileSystemEventService,new t.ExtHostFileSystemEventService(Ve,vt,Xe)),Kt=Ve.set(m.ExtHostContext.ExtHostQuickOpen,(0,W.createExtHostQuickOpen)(Ve,ft,je)),ai=Ve.set(m.ExtHostContext.ExtHostSCM,new L.ExtHostSCM(Ve,je,vt)),Pi=Ve.set(m.ExtHostContext.ExtHostComments,(0,o.createExtHostComments)(Ve,je,mt)),yi=Ve.set(m.ExtHostContext.ExtHostProgress,new U.ExtHostProgress(Ve.getProxy(m.MainContext.MainThreadProgress))),pi=Ve.set(m.ExtHostContext.ExtHosLabelService,new Ee.ExtHostLabelService(Ve)),li=Ve.set(m.ExtHostContext.ExtHostTheming,new ae.ExtHostTheming(Ve)),ti=Ve.set(m.ExtHostContext.ExtHostAuthentication,new Q.ExtHostAuthentication(Ve)),vi=Ve.set(m.ExtHostContext.ExtHostTimeline,new I.ExtHostTimeline(Ve,je)),Ei=Ve.set(m.ExtHostContext.ExtHostWebviews,new le.ExtHostWebviews(Ve,dt.remote,ft,vt,me)),ii=Ve.set(m.ExtHostContext.ExtHostWebviewPanels,new de.ExtHostWebviewPanels(Ve,Ei,ft)),bi=Ve.set(m.ExtHostContext.ExtHostCustomEditors,new se.ExtHostCustomEditors(Ve,mt,Rt,Ei,ii)),Ai=Ve.set(m.ExtHostContext.ExtHostWebviewViews,new V.ExtHostWebviewViews(Ve,Ei)),ni=Ve.set(m.ExtHostContext.ExtHostTesting,new ge.ExtHostTesting(Ve,je)),Ri=Ve.set(m.ExtHostContext.ExtHostUriOpeners,new Ne.ExtHostUriOpeners(Ve));Ve.set(m.ExtHostContext.ExtHostInteractive,new Ze.ExtHostInteractive(Ve,bt,Xe,je,vt));const Oi=Object.values(m.ExtHostContext);Ve.assertRegistered(Oi);const Fi=new J.ExtHostBulkEdits(Ve,Xe),Ni=new h.ExtHostClipboard(Ve),ri=new p.ExtHostMessageService(Ve,vt),ci=new l.ExtHostDialogs(Ve),Di=new S.ExtHostStatusBar(Ve,je.converter);return f.ExtHostApiCommands.register(je),function(Me,Vt,si){const Et=function(){let re=!Me.isUnderDevelopment;function he(){re||(vt.info(`Extension '${Me.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),re=!0)}return function Re(st){if(Array.isArray(st))st.forEach(Re);else if(typeof st=="string")he();else{const wt=st;typeof wt.scheme=="undefined"&&he(),typeof wt.exclusive=="boolean"&&(0,We.checkProposedApiEnabled)(Me,"documentFiltersExclusive")}return st}}(),Mi={getSession(re,he,Re){return ti.getSession(Me,re,he,Re)},async hasSession(re,he){return(0,We.checkProposedApiEnabled)(Me,"authSession"),!!await ti.getSession(Me,re,he,{silent:!0})},get onDidChangeSessions(){return ti.onDidChangeSessions},registerAuthenticationProvider(re,he,Re,st){return ti.registerAuthenticationProvider(re,he,Re,st)}},Li={registerCommand(re,he,Re){return je.registerCommand(!0,re,he,Re,void 0,Me)},registerTextEditorCommand(re,he,Re){return je.registerCommand(!0,re,(...st)=>{const wt=It.getActiveTextEditor();if(!wt){vt.warn("Cannot execute "+re+" because there is no active text editor.");return}return wt.edit(Tt=>{he.apply(Re,[wt,Tt,...st])}).then(Tt=>{Tt||vt.warn("Edits from command "+re+" were not applied.")},Tt=>{vt.warn("An error occurred while running command "+re,Tt)})},void 0,void 0,Me)},registerDiffInformationCommand:(re,he,Re)=>((0,We.checkProposedApiEnabled)(Me,"diffCommand"),je.registerCommand(!0,re,async(...st)=>{const wt=Xe.activeEditor(!0);if(!wt){vt.warn("Cannot execute "+re+" because there is no active text editor.");return}const Tt=await It.getDiffInformation(wt.id);he.apply(Re,[Tt,...st])},void 0,void 0,Me)),executeCommand(re,...he){return je.executeCommand(re,...he)},getCommands(re=!1){return je.getCommands(re)}},Ci={get machineId(){return dt.telemetryInfo.machineId},get sessionId(){return dt.telemetryInfo.sessionId},get language(){return dt.environment.appLanguage},get appName(){return dt.environment.appName},get appRoot(){return dt.environment.appRoot?.fsPath??""},get appHost(){return dt.environment.appHost},get uriScheme(){return dt.environment.appUriScheme},get clipboard(){return Ni.value},get shell(){return ut.getDefaultShell(!1)},get isTelemetryEnabled(){return Ct.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Ct.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,We.checkProposedApiEnabled)(Me,"telemetry"),Ct.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,We.checkProposedApiEnabled)(Me,"telemetry"),Ct.onDidChangeTelemetryConfiguration},get isNewAppInstall(){const re=Date.now()-new Date(dt.telemetryInfo.firstSessionDate).getTime();return isNaN(re)?!1:re<1e3*60*60*24},openExternal(re,he){return j.openUri(re,{allowTunneling:!!dt.remote.authority,allowContributedOpeners:he?.allowContributedOpeners})},async asExternalUri(re){if(re.scheme===dt.environment.appUriScheme)return Pt.createAppUri(re);try{return await j.asExternalUri(re,{allowTunneling:!!dt.remote.authority})}catch(he){if((0,fe.matchesScheme)(re,X.Schemas.http)||(0,fe.matchesScheme)(re,X.Schemas.https))return re;throw he}},get remoteName(){return(0,be.getRemoteName)(dt.remote.authority)},get remoteAuthority(){return(0,We.checkProposedApiEnabled)(Me,"resolvers"),dt.remote.authority},get uiKind(){return dt.uiKind}};dt.environment.extensionTestsLocationURI||Object.freeze(Ci);const wi={createTestController(re,he,Re){return ni.createTestController(re,he,Re)},createTestObserver(){return(0,We.checkProposedApiEnabled)(Me,"testObserver"),ni.createTestObserver()},runTests(re){return(0,We.checkProposedApiEnabled)(Me,"testObserver"),ni.runTests(re)},get onDidChangeTestResults(){return(0,We.checkProposedApiEnabled)(Me,"testObserver"),ni.onResultsChanged},get testResults(){return(0,We.checkProposedApiEnabled)(Me,"testObserver"),ni.results}},ui=dt.remote.isRemote?A.ExtensionKind.Workspace:A.ExtensionKind.UI,xt={getExtension(re,he){(0,ot.equalsIgnoreCase)(re,"ms-vscode.references-view")&&(me.report("The extension 'ms-vscode.references-view' has been renamed.",Me,"Use 'vscode.references-view' instead."),re="vscode.references-view"),(0,We.isProposedApiEnabled)(Me,"extensionsAny")||(he=!1);const Re=Vt.mine.getExtensionDescription(re);if(Re)return new i.Extension(Dt,Me.identifier,Re,ui,!1);if(he){const st=Vt.all.getExtensionDescription(re);if(st)return new i.Extension(Dt,Me.identifier,st,ui,!0)}},get all(){const re=[];for(const he of Vt.mine.getAllExtensionDescriptions())re.push(new i.Extension(Dt,Me.identifier,he,ui,!1));return re},get allAcrossExtensionHosts(){(0,We.checkProposedApiEnabled)(Me,"extensionsAny");const re=new We.ExtensionIdentifierSet(Vt.mine.getAllExtensionDescriptions().map(Re=>Re.identifier)),he=[];for(const Re of Vt.all.getAllExtensionDescriptions()){const st=!re.has(Re.identifier);he.push(new i.Extension(Dt,Me.identifier,Re,ui,st))}return he},get onDidChange(){return(0,We.isProposedApiEnabled)(Me,"extensionsAny")?b.Event.any(Vt.mine.onDidChange,Vt.all.onDidChange):Vt.mine.onDidChange}},Gt={createDiagnosticCollection(re){return Zt.createDiagnosticCollection(Me.identifier,re)},get onDidChangeDiagnostics(){return Zt.onDidChangeDiagnostics},getDiagnostics:re=>Zt.getDiagnostics(re),getLanguages(){return ei.getLanguages()},setTextDocumentLanguage(re,he){return ei.changeLanguage(re.uri,he)},match(re,he){const Re=mt.getDocumentData(he.uri)?.notebook;return(0,O.score)(ie.LanguageSelector.from(re),he.uri,he.languageId,!0,Re?.uri,Re?.notebookType)},registerCodeActionsProvider(re,he,Re){return ct.registerCodeActionProvider(Me,Et(re),he,Re)},registerDocumentPasteEditProvider(re,he,Re){return(0,We.checkProposedApiEnabled)(Me,"documentPaste"),ct.registerDocumentPasteEditProvider(Me,Et(re),he,Re)},registerCodeLensProvider(re,he){return ct.registerCodeLensProvider(Me,Et(re),he)},registerDefinitionProvider(re,he){return ct.registerDefinitionProvider(Me,Et(re),he)},registerDeclarationProvider(re,he){return ct.registerDeclarationProvider(Me,Et(re),he)},registerImplementationProvider(re,he){return ct.registerImplementationProvider(Me,Et(re),he)},registerTypeDefinitionProvider(re,he){return ct.registerTypeDefinitionProvider(Me,Et(re),he)},registerHoverProvider(re,he){return ct.registerHoverProvider(Me,Et(re),he,Me.identifier)},registerEvaluatableExpressionProvider(re,he){return ct.registerEvaluatableExpressionProvider(Me,Et(re),he,Me.identifier)},registerInlineValuesProvider(re,he){return ct.registerInlineValuesProvider(Me,Et(re),he,Me.identifier)},registerDocumentHighlightProvider(re,he){return ct.registerDocumentHighlightProvider(Me,Et(re),he)},registerLinkedEditingRangeProvider(re,he){return ct.registerLinkedEditingRangeProvider(Me,Et(re),he)},registerReferenceProvider(re,he){return ct.registerReferenceProvider(Me,Et(re),he)},registerRenameProvider(re,he){return ct.registerRenameProvider(Me,Et(re),he)},registerDocumentSymbolProvider(re,he,Re){return ct.registerDocumentSymbolProvider(Me,Et(re),he,Re)},registerWorkspaceSymbolProvider(re){return ct.registerWorkspaceSymbolProvider(Me,re)},registerDocumentFormattingEditProvider(re,he){return ct.registerDocumentFormattingEditProvider(Me,Et(re),he)},registerDocumentRangeFormattingEditProvider(re,he){return ct.registerDocumentRangeFormattingEditProvider(Me,Et(re),he)},registerOnTypeFormattingEditProvider(re,he,Re,...st){return ct.registerOnTypeFormattingEditProvider(Me,Et(re),he,[Re].concat(st))},registerDocumentSemanticTokensProvider(re,he,Re){return ct.registerDocumentSemanticTokensProvider(Me,Et(re),he,Re)},registerDocumentRangeSemanticTokensProvider(re,he,Re){return ct.registerDocumentRangeSemanticTokensProvider(Me,Et(re),he,Re)},registerSignatureHelpProvider(re,he,Re,...st){return typeof Re=="object"?ct.registerSignatureHelpProvider(Me,Et(re),he,Re):ct.registerSignatureHelpProvider(Me,Et(re),he,typeof Re=="undefined"?[]:[Re,...st])},registerCompletionItemProvider(re,he,...Re){return ct.registerCompletionItemProvider(Me,Et(re),he,Re)},registerInlineCompletionItemProvider(re,he){return he.handleDidShowCompletionItem&&(0,We.checkProposedApiEnabled)(Me,"inlineCompletionsAdditions"),ct.registerInlineCompletionsProvider(Me,Et(re),he)},registerInlineCompletionItemProviderNew(re,he){if((0,We.checkProposedApiEnabled)(Me,"inlineCompletionsNew"),he.handleDidShowCompletionItem&&!(0,We.isProposedApiEnabled)(Me,"inlineCompletionsAdditions"))throw new Error(`When the method "handleDidShowCompletionItem" is implemented on a provider, the usage of the proposed api 'inlineCompletionsAdditions' must be declared!`);return ct.registerInlineCompletionsProviderNew(Me,Et(re),he)},registerDocumentLinkProvider(re,he){return ct.registerDocumentLinkProvider(Me,Et(re),he)},registerColorProvider(re,he){return ct.registerColorProvider(Me,Et(re),he)},registerFoldingRangeProvider(re,he){return ct.registerFoldingRangeProvider(Me,Et(re),he)},registerSelectionRangeProvider(re,he){return ct.registerSelectionRangeProvider(Me,re,he)},registerCallHierarchyProvider(re,he){return ct.registerCallHierarchyProvider(Me,re,he)},registerTypeHierarchyProvider(re,he){return ct.registerTypeHierarchyProvider(Me,re,he)},setLanguageConfiguration:(re,he)=>ct.setLanguageConfiguration(Me,re,he),getTokenInformationAtPosition(re,he){return(0,We.checkProposedApiEnabled)(Me,"tokenInformation"),ei.tokenAtPosition(re,he)},registerInlayHintsProvider(re,he){return ct.registerInlayHintsProvider(Me,re,he)},createLanguageStatusItem(re,he){return ei.createLanguageStatusItem(Me,re,he)},registerDocumentDropEditProvider(re,he){return ct.registerDocumentOnDropEditProvider(Me,re,he)}},Ui={get activeTextEditor(){return It.getActiveTextEditor()},get visibleTextEditors(){return It.getVisibleTextEditors()},get activeTerminal(){return ut.activeTerminal},get terminals(){return ut.terminals},async showTextDocument(re,he,Re){const st=await(D.URI.isUri(re)?Promise.resolve(Mt.openTextDocument(re)):Promise.resolve(re));return It.showTextDocument(st,he,Re)},createTextEditorDecorationType(re){return It.createTextEditorDecorationType(Me,re)},onDidChangeActiveTextEditor(re,he,Re){return It.onDidChangeActiveTextEditor(re,he,Re)},onDidChangeVisibleTextEditors(re,he,Re){return It.onDidChangeVisibleTextEditors(re,he,Re)},onDidChangeTextEditorSelection(re,he,Re){return It.onDidChangeTextEditorSelection(re,he,Re)},onDidChangeTextEditorOptions(re,he,Re){return It.onDidChangeTextEditorOptions(re,he,Re)},onDidChangeTextEditorVisibleRanges(re,he,Re){return It.onDidChangeTextEditorVisibleRanges(re,he,Re)},onDidChangeTextEditorViewColumn(re,he,Re){return It.onDidChangeTextEditorViewColumn(re,he,Re)},onDidCloseTerminal(re,he,Re){return ut.onDidCloseTerminal(re,he,Re)},onDidOpenTerminal(re,he,Re){return ut.onDidOpenTerminal(re,he,Re)},onDidChangeActiveTerminal(re,he,Re){return ut.onDidChangeActiveTerminal(re,he,Re)},onDidChangeTerminalDimensions(re,he,Re){return(0,We.checkProposedApiEnabled)(Me,"terminalDimensions"),ut.onDidChangeTerminalDimensions(re,he,Re)},onDidChangeTerminalState(re,he,Re){return ut.onDidChangeTerminalState(re,he,Re)},onDidWriteTerminalData(re,he,Re){return(0,We.checkProposedApiEnabled)(Me,"terminalDataWriteEvent"),ut.onDidWriteTerminalData(re,he,Re)},get state(){return j.state},onDidChangeWindowState(re,he,Re){return j.onDidChangeWindowState(re,he,Re)},showInformationMessage(re,...he){return ri.showMessage(Me,M.default.Info,re,he[0],he.slice(1))},showWarningMessage(re,...he){return ri.showMessage(Me,M.default.Warning,re,he[0],he.slice(1))},showErrorMessage(re,...he){return ri.showMessage(Me,M.default.Error,re,he[0],he.slice(1))},showQuickPick(re,he,Re){return Kt.showQuickPick(re,he,Re)},showWorkspaceFolderPick(re){return Kt.showWorkspaceFolderPick(re)},showInputBox(re,he){return Kt.showInput(re,he)},showOpenDialog(re){return ci.showOpenDialog(re)},showSaveDialog(re){return ci.showSaveDialog(re)},createStatusBarItem(re,he,Re){let st,wt,Tt;return typeof re=="string"?(st=re,wt=he,Tt=Re):(wt=re,Tt=he),Di.createStatusBarEntry(Me,st,wt,Tt)},setStatusBarMessage(re,he){return Di.setStatusBarMessage(re,he)},withScmProgress(re){return me.report("window.withScmProgress",Me,"Use 'withProgress' instead."),yi.withProgress(Me,{location:A.ProgressLocation.SourceControl},(he,Re)=>re({report(st){}}))},withProgress(re,he){return yi.withProgress(Me,re,he)},createOutputChannel(re,he){return _t.createOutputChannel(re,he,Me)},createWebviewPanel(re,he,Re,st){return ii.createWebviewPanel(Me,re,he,Re,st)},createWebviewTextEditorInset(re,he,Re,st){return(0,We.checkProposedApiEnabled)(Me,"editorInsets"),mi.createWebviewEditorInset(re,he,Re,st,Me)},createTerminal(re,he,Re){return typeof re=="object"?"pty"in re?ut.createExtensionTerminal(re):ut.createTerminalFromOptions(re):ut.createTerminal(re,he,Re)},registerTerminalLinkProvider(re){return ut.registerLinkProvider(re)},registerTerminalProfileProvider(re,he){return ut.registerProfileProvider(Me,re,he)},registerTreeDataProvider(re,he){return qt.registerTreeDataProvider(re,he,Me)},createTreeView(re,he){return qt.createTreeView(re,he,Me)},registerWebviewPanelSerializer:(re,he)=>ii.registerWebviewPanelSerializer(Me,re,he),registerCustomEditorProvider:(re,he,Re={})=>bi.registerCustomEditorProvider(Me,re,he,Re),registerFileDecorationProvider(re){return tt.registerFileDecorationProvider(re,Me.identifier)},registerUriHandler(re){return Pt.registerUriHandler(Me.identifier,re)},createQuickPick(){return Kt.createQuickPick(Me)},createInputBox(){return Kt.createInputBox(Me)},get activeColorTheme(){return li.activeColorTheme},onDidChangeActiveColorTheme(re,he,Re){return li.onDidChangeActiveColorTheme(re,he,Re)},registerWebviewViewProvider(re,he,Re){return Ai.registerWebviewViewProvider(Me,re,he,Re?.webviewOptions)},get activeNotebookEditor(){return bt.activeNotebookEditor},onDidChangeActiveNotebookEditor(re,he,Re){return bt.onDidChangeActiveNotebookEditor(re,he,Re)},get visibleNotebookEditors(){return bt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return bt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(re,he,Re){return Bt.onDidChangeNotebookEditorSelection(re,he,Re)},onDidChangeNotebookEditorVisibleRanges(re,he,Re){return Bt.onDidChangeNotebookEditorVisibleRanges(re,he,Re)},showNotebookDocument(re,he){return D.URI.isUri(re)&&me.report("window.showNotebookDocument(uri)",Me,"Please use 'workspace.openNotebookDocument' and 'window.showNotebookDocument'"),bt.showNotebookDocument(re,he)},registerExternalUriOpener(re,he,Re){return(0,We.checkProposedApiEnabled)(Me,"externalUriOpener"),Ri.registerExternalUriOpener(Me.identifier,re,he,Re)},get tabGroups(){return Le.tabGroups},logTelemetryToOutputChannel(re,he){(0,We.checkProposedApiEnabled)(Me,"telemetryLog"),Ce.logToTelemetryOutputChannel(Me,re,he)}},Mt={get rootPath(){return me.report("workspace.rootPath",Me,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(re){throw v.readonly()},getWorkspaceFolder(re){return ft.getWorkspaceFolder(re)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(re){throw v.readonly()},get workspaceFile(){return ft.workspaceFile},set workspaceFile(re){throw v.readonly()},updateWorkspaceFolders:(re,he,...Re)=>ft.updateWorkspaceFolders(Me,re,he||0,...Re),onDidChangeWorkspaceFolders:function(re,he,Re){return ft.onDidChangeWorkspace(re,he,Re)},asRelativePath:(re,he)=>ft.getRelativePath(re,he),findFiles:(re,he,Re,st)=>ft.findFiles(re,he,Re,Me.identifier,st),findTextInFiles:(re,he,Re,st)=>{(0,We.checkProposedApiEnabled)(Me,"findTextInFiles");let wt,Tt;return typeof he=="object"?(wt=he,Tt=Re):(wt={},Tt=he,st=Re),ft.findTextInFiles(re,wt||{},Tt,Me.identifier,st)},saveAll:re=>ft.saveAll(re),applyEdit(re){return Fi.applyWorkspaceEdit(re,Me)},createFileSystemWatcher:(re,he,Re,st)=>zt.createFileSystemWatcher(ft,Me,re,he,Re,st),get textDocuments(){return mt.getAllDocumentData().map(re=>re.document)},set textDocuments(re){throw v.readonly()},openTextDocument(re){let he;const Re=re;if(typeof re=="string")he=Promise.resolve(D.URI.file(re));else if(D.URI.isUri(re))he=Promise.resolve(re);else if(!Re||typeof Re=="object")he=mt.createDocumentData(Re);else throw new Error("illegal argument - uriOrFileNameOrOptions");return he.then(st=>mt.ensureDocumentData(st).then(wt=>wt.document))},onDidOpenTextDocument:(re,he,Re)=>mt.onDidAddDocument(re,he,Re),onDidCloseTextDocument:(re,he,Re)=>mt.onDidRemoveDocument(re,he,Re),onDidChangeTextDocument:(re,he,Re)=>mt.onDidChangeDocument(re,he,Re),onDidSaveTextDocument:(re,he,Re)=>mt.onDidSaveDocument(re,he,Re),onWillSaveTextDocument:(re,he,Re)=>Jt.getOnWillSaveTextDocumentEvent(Me)(re,he,Re),get notebookDocuments(){return bt.notebookDocuments.map(re=>re.apiNotebook)},async openNotebookDocument(re,he){let Re;if(D.URI.isUri(re))Re=re,await bt.openNotebookDocument(re);else if(typeof re=="string")Re=D.URI.revive(await bt.createNotebookDocument({viewType:re,content:he}));else throw new Error("Invalid arguments");return bt.getNotebookDocument(Re).apiNotebook},onDidSaveNotebookDocument(re,he,Re){return Ht.onDidSaveNotebookDocument(re,he,Re)},onDidChangeNotebookDocument(re,he,Re){return Ht.onDidChangeNotebookDocument(re,he,Re)},get onDidOpenNotebookDocument(){return bt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return bt.onDidCloseNotebookDocument},registerNotebookSerializer(re,he,Re,st){return bt.registerNotebookSerializer(Me,re,he,Re,(0,We.isProposedApiEnabled)(Me,"notebookLiveShare")?st:void 0)},registerNotebookContentProvider:(re,he,Re,st)=>((0,We.checkProposedApiEnabled)(Me,"notebookContentProvider"),me.report("workspace.registerNotebookContentProvider",Me,"The notebookContentProvider API is not on track for finalization and will be removed."),bt.registerNotebookContentProvider(Me,re,he,Re,(0,We.isProposedApiEnabled)(Me,"notebookLiveShare")?st:void 0)),onDidChangeConfiguration:(re,he,Re)=>si.onDidChangeConfiguration(re,he,Re),getConfiguration(re,he){return he=arguments.length===1?void 0:he,si.getConfiguration(re,he,Me)},registerTextDocumentContentProvider(re,he){return Yt.registerTextDocumentContentProvider(re,he)},registerTaskProvider:(re,he)=>(me.report("window.registerTaskProvider",Me,"Use the corresponding function on the 'tasks' namespace instead"),pt.registerTaskProvider(Me,re,he)),registerFileSystemProvider(re,he,Re){return(0,qe.combinedDisposable)(gi.registerFileSystemProvider(Me,re,he,Re),Wt.addFileSystemProvider(re,he))},get fs(){return Wt.value},registerFileSearchProvider:(re,he)=>((0,We.checkProposedApiEnabled)(Me,"fileSearchProvider"),yt.registerFileSearchProvider(re,he)),registerTextSearchProvider:(re,he)=>((0,We.checkProposedApiEnabled)(Me,"textSearchProvider"),yt.registerTextSearchProvider(re,he)),registerRemoteAuthorityResolver:(re,he)=>((0,We.checkProposedApiEnabled)(Me,"resolvers"),Dt.registerRemoteAuthorityResolver(re,he)),registerResourceLabelFormatter:re=>((0,We.checkProposedApiEnabled)(Me,"resolvers"),pi.$registerResourceLabelFormatter(re)),onDidCreateFiles:(re,he,Re)=>zt.onDidCreateFile(re,he,Re),onDidDeleteFiles:(re,he,Re)=>zt.onDidDeleteFile(re,he,Re),onDidRenameFiles:(re,he,Re)=>zt.onDidRenameFile(re,he,Re),onWillCreateFiles:(re,he,Re)=>zt.getOnWillCreateFileEvent(Me)(re,he,Re),onWillDeleteFiles:(re,he,Re)=>zt.getOnWillDeleteFileEvent(Me)(re,he,Re),onWillRenameFiles:(re,he,Re)=>zt.getOnWillRenameFileEvent(Me)(re,he,Re),openTunnel:re=>((0,We.checkProposedApiEnabled)(Me,"resolvers"),we.openTunnel(Me,re).then(he=>{if(!he)throw new Error("cannot open tunnel");return he})),get tunnels(){return(0,We.checkProposedApiEnabled)(Me,"resolvers"),we.getTunnels()},onDidChangeTunnels:(re,he,Re)=>((0,We.checkProposedApiEnabled)(Me,"resolvers"),we.onDidChangeTunnels(re,he,Re)),registerPortAttributesProvider:(re,he)=>((0,We.checkProposedApiEnabled)(Me,"portsAttributes"),we.registerPortsAttributesProvider(re,he)),registerTimelineProvider:(re,he)=>((0,We.checkProposedApiEnabled)(Me,"timeline"),vi.registerTimelineProvider(re,he,Me.identifier,je.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:re=>((0,We.checkProposedApiEnabled)(Me,"workspaceTrust"),ft.requestWorkspaceTrust(re)),onDidGrantWorkspaceTrust:(re,he,Re)=>ft.onDidGrantWorkspaceTrust(re,he,Re)},di={get inputBox(){return me.report("scm.inputBox",Me,"Use 'SourceControl.inputBox' instead"),ai.getLastInputBox(Me)},createSourceControl(re,he,Re){return ai.createSourceControl(Me,re,he,Re)}},Bi={createCommentController(re,he){return Pi.createCommentController(Me,re,he)}},zi={get activeDebugSession(){return gt.activeDebugSession},get activeDebugConsole(){return gt.activeDebugConsole},get breakpoints(){return gt.breakpoints},onDidStartDebugSession(re,he,Re){return gt.onDidStartDebugSession(re,he,Re)},onDidTerminateDebugSession(re,he,Re){return gt.onDidTerminateDebugSession(re,he,Re)},onDidChangeActiveDebugSession(re,he,Re){return gt.onDidChangeActiveDebugSession(re,he,Re)},onDidReceiveDebugSessionCustomEvent(re,he,Re){return gt.onDidReceiveDebugSessionCustomEvent(re,he,Re)},onDidChangeBreakpoints(re,he,Re){return gt.onDidChangeBreakpoints(re,he,Re)},registerDebugConfigurationProvider(re,he,Re){return gt.registerDebugConfigurationProvider(re,he,Re||nt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(re,he){return gt.registerDebugAdapterDescriptorFactory(Me,re,he)},registerDebugAdapterTrackerFactory(re,he){return gt.registerDebugAdapterTrackerFactory(re,he)},startDebugging(re,he,Re){return!Re||typeof Re=="object"&&"configuration"in Re?gt.startDebugging(re,he,{parentSession:Re}):gt.startDebugging(re,he,Re||{})},stopDebugging(re){return gt.stopDebugging(re)},addBreakpoints(re){return gt.addBreakpoints(re)},removeBreakpoints(re){return gt.removeBreakpoints(re)},asDebugSourceUri(re,he){return gt.asDebugSourceUri(re,he)}},xi={registerTaskProvider:(re,he)=>pt.registerTaskProvider(Me,re,he),fetchTasks:re=>pt.fetchTasks(re),executeTask:re=>pt.executeTask(Me,re),get taskExecutions(){return pt.taskExecutions},onDidStartTask:(re,he,Re)=>pt.onDidStartTask(re,he,Re),onDidEndTask:(re,he,Re)=>pt.onDidEndTask(re,he,Re),onDidStartTaskProcess:(re,he,Re)=>pt.onDidStartTaskProcess(re,he,Re),onDidEndTaskProcess:(re,he,Re)=>pt.onDidEndTaskProcess(re,he,Re)},$i={createNotebookController(re,he,Re,st,wt){return oi.createNotebookController(Me,re,he,Re,st,(0,We.isProposedApiEnabled)(Me,"notebookMessaging")?wt:void 0)},registerNotebookCellStatusBarItemProvider:(re,he)=>bt.registerNotebookCellStatusBarItemProvider(Me,re,he),createRendererMessaging(re){return ki.createRendererMessaging(Me,re)},onDidChangeNotebookCellExecutionState(re,he,Re){return(0,We.checkProposedApiEnabled)(Me,"notebookCellExecutionState"),oi.onDidChangeNotebookCellExecutionState(re,he,Re)}};return{version:dt.version,authentication:Mi,commands:Li,comments:Bi,debug:zi,env:Ci,extensions:xt,languages:Gt,notebooks:$i,scm:di,tasks:xi,tests:wi,window:Ui,workspace:Mt,Breakpoint:A.Breakpoint,CallHierarchyIncomingCall:A.CallHierarchyIncomingCall,CallHierarchyItem:A.CallHierarchyItem,CallHierarchyOutgoingCall:A.CallHierarchyOutgoingCall,CancellationError:v.CancellationError,CancellationTokenSource:a.CancellationTokenSource,CandidatePortSource:m.CandidatePortSource,CodeAction:A.CodeAction,CodeActionKind:A.CodeActionKind,CodeActionTriggerKind:A.CodeActionTriggerKind,CodeLens:A.CodeLens,Color:A.Color,ColorInformation:A.ColorInformation,ColorPresentation:A.ColorPresentation,ColorThemeKind:A.ColorThemeKind,CommentMode:A.CommentMode,CommentThreadCollapsibleState:A.CommentThreadCollapsibleState,CommentThreadState:A.CommentThreadState,CompletionItem:A.CompletionItem,CompletionItemKind:A.CompletionItemKind,CompletionItemTag:A.CompletionItemTag,CompletionList:A.CompletionList,CompletionTriggerKind:A.CompletionTriggerKind,ConfigurationTarget:A.ConfigurationTarget,CustomExecution:A.CustomExecution,DebugAdapterExecutable:A.DebugAdapterExecutable,DebugAdapterInlineImplementation:A.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:A.DebugAdapterNamedPipeServer,DebugAdapterServer:A.DebugAdapterServer,DebugConfigurationProviderTriggerKind:nt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:A.DebugConsoleMode,DecorationRangeBehavior:A.DecorationRangeBehavior,Diagnostic:A.Diagnostic,DiagnosticRelatedInformation:A.DiagnosticRelatedInformation,DiagnosticSeverity:A.DiagnosticSeverity,DiagnosticTag:A.DiagnosticTag,Disposable:A.Disposable,DocumentHighlight:A.DocumentHighlight,DocumentHighlightKind:A.DocumentHighlightKind,DocumentLink:A.DocumentLink,DocumentSymbol:A.DocumentSymbol,EndOfLine:A.EndOfLine,EnvironmentVariableMutatorType:A.EnvironmentVariableMutatorType,EvaluatableExpression:A.EvaluatableExpression,InlineValueText:A.InlineValueText,InlineValueVariableLookup:A.InlineValueVariableLookup,InlineValueEvaluatableExpression:A.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:A.InlineCompletionTriggerKind,InlineCompletionTriggerKindNew:A.InlineCompletionTriggerKindNew,EventEmitter:b.Emitter,ExtensionKind:A.ExtensionKind,ExtensionMode:A.ExtensionMode,ExternalUriOpenerPriority:A.ExternalUriOpenerPriority,FileChangeType:A.FileChangeType,FileDecoration:A.FileDecoration,FileSystemError:A.FileSystemError,FileType:y.FileType,FilePermission:y.FilePermission,FoldingRange:A.FoldingRange,FoldingRangeKind:A.FoldingRangeKind,FunctionBreakpoint:A.FunctionBreakpoint,InlineCompletionItem:A.InlineSuggestion,InlineCompletionItemNew:A.InlineSuggestionNew,InlineCompletionList:A.InlineSuggestionList,InlineCompletionListNew:A.InlineSuggestionsNew,Hover:A.Hover,IndentAction:T.IndentAction,Location:A.Location,MarkdownString:A.MarkdownString,OverviewRulerLane:E.OverviewRulerLane,ParameterInformation:A.ParameterInformation,PortAutoForwardAction:A.PortAutoForwardAction,Position:A.Position,ProcessExecution:A.ProcessExecution,ProgressLocation:A.ProgressLocation,QuickInputButtons:A.QuickInputButtons,Range:A.Range,RelativePattern:A.RelativePattern,Selection:A.Selection,SelectionRange:A.SelectionRange,SemanticTokens:A.SemanticTokens,SemanticTokensBuilder:A.SemanticTokensBuilder,SemanticTokensEdit:A.SemanticTokensEdit,SemanticTokensEdits:A.SemanticTokensEdits,SemanticTokensLegend:A.SemanticTokensLegend,ShellExecution:A.ShellExecution,ShellQuoting:A.ShellQuoting,SignatureHelp:A.SignatureHelp,SignatureHelpTriggerKind:A.SignatureHelpTriggerKind,SignatureInformation:A.SignatureInformation,SnippetString:A.SnippetString,SourceBreakpoint:A.SourceBreakpoint,StandardTokenType:A.StandardTokenType,StatusBarAlignment:A.StatusBarAlignment,SymbolInformation:A.SymbolInformation,SymbolKind:A.SymbolKind,SymbolTag:A.SymbolTag,Task:A.Task,TaskGroup:A.TaskGroup,TaskPanelKind:A.TaskPanelKind,TaskRevealKind:A.TaskRevealKind,TaskScope:A.TaskScope,TerminalLink:A.TerminalLink,TerminalLocation:A.TerminalLocation,TerminalProfile:A.TerminalProfile,TextDocumentSaveReason:A.TextDocumentSaveReason,TextEdit:A.TextEdit,TextEditorCursorStyle:P.TextEditorCursorStyle,TextEditorLineNumbersStyle:A.TextEditorLineNumbersStyle,TextEditorRevealType:A.TextEditorRevealType,TextEditorSelectionChangeKind:A.TextEditorSelectionChangeKind,TextDocumentChangeReason:A.TextDocumentChangeReason,ThemeColor:A.ThemeColor,ThemeIcon:A.ThemeIcon,TreeItem:A.TreeItem,TreeItemCollapsibleState:A.TreeItemCollapsibleState,TypeHierarchyItem:A.TypeHierarchyItem,UIKind:k.UIKind,Uri:D.URI,ViewColumn:A.ViewColumn,WorkspaceEdit:A.WorkspaceEdit,DocumentDropEdit:A.DocumentDropEdit,DocumentPasteEdit:A.DocumentPasteEdit,InlayHint:A.InlayHint,InlayHintLabelPart:A.InlayHintLabelPart,InlayHintKind:A.InlayHintKind,RemoteAuthorityResolverError:A.RemoteAuthorityResolverError,ResolvedAuthority:A.ResolvedAuthority,SourceControlInputBoxValidationType:A.SourceControlInputBoxValidationType,ExtensionRuntime:A.ExtensionRuntime,TimelineItem:A.TimelineItem,NotebookRange:A.NotebookRange,NotebookCellKind:A.NotebookCellKind,NotebookCellExecutionState:A.NotebookCellExecutionState,NotebookCellData:A.NotebookCellData,NotebookData:A.NotebookData,NotebookRendererScript:A.NotebookRendererScript,NotebookCellStatusBarAlignment:A.NotebookCellStatusBarAlignment,NotebookEditorRevealType:A.NotebookEditorRevealType,NotebookCellOutput:A.NotebookCellOutput,NotebookCellOutputItem:A.NotebookCellOutputItem,NotebookCellStatusBarItem:A.NotebookCellStatusBarItem,NotebookControllerAffinity:A.NotebookControllerAffinity,NotebookEdit:A.NotebookEdit,PortAttributes:A.PortAttributes,LinkedEditingRanges:A.LinkedEditingRanges,TestResultState:A.TestResultState,TestRunRequest:A.TestRunRequest,TestMessage:A.TestMessage,TestTag:A.TestTag,TestRunProfileKind:A.TestRunProfileKind,TextSearchCompleteMessageType:rt.TextSearchCompleteMessageType,DataTransfer:A.DataTransfer,DataTransferItem:A.DataTransferItem,CoveredCount:A.CoveredCount,FileCoverage:A.FileCoverage,StatementCoverage:A.StatementCoverage,BranchCoverage:A.BranchCoverage,FunctionCoverage:A.FunctionCoverage,WorkspaceTrustState:A.WorkspaceTrustState,LanguageStatusSeverity:A.LanguageStatusSeverity,QuickPickItemKind:A.QuickPickItemKind,InputBoxValidationSeverity:A.InputBoxValidationSeverity,TabInputText:A.TextTabInput,TabInputTextDiff:A.TextDiffTabInput,TabInputTextMerge:A.TextMergeTabInput,TabInputCustom:A.CustomEditorTabInput,TabInputNotebook:A.NotebookEditorTabInput,TabInputNotebookDiff:A.NotebookDiffEditorTabInput,TabInputWebview:A.WebviewEditorTabInput,TabInputTerminal:A.TerminalEditorTabInput,TabInputInteractiveWindow:A.InteractiveWindowInput,TerminalExitReason:A.TerminalExitReason}}}e.createApiFactoryAndRegisterActors=kt}),define(ye[238],De([1,0,237,33,2,231,6,14,222,21]),function(ne,e,a,v,b,M,D,P,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class O extends M.RequireInterceptor{_installInterceptor(){}getModule(f,h){for(const d of this._alternatives){const o=d(f);if(o){f=o;break}}if(this._factories.has(f))return this._factories.get(f).load(f,h,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class y extends v.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=D.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){this._instaService.createInstance(E.ExtHostConsoleForwarder);const f=this._instaService.invokeFunction(a.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(O,f,{mine:this._myRegistry,all:this._globalRegistry}),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(f){return f.browser}async _loadCommonJSModule(f,h,d){h=h.with({path:m(h.path,".js")});const o=f?.identifier.value;o&&performance.mark(`code/extHost/willFetchExtensionCode/${o}`);const g=b.URI.revive(await this._mainThreadExtensionsProxy.$asBrowserUri(h)),R=await fetch(g.toString(!0));if(o&&performance.mark(`code/extHost/didFetchExtensionCode/${o}`),R.status!==200)throw new Error(R.statusText);const l=await R.text(),w=`${h.toString(!0)}#vscode-extension`,s=`${l}
//# sourceURL=${w}`;let u;try{u=new Function("module","exports","require",s)}catch(c){throw console.error(o?`Loading code for extension ${o} failed: ${c.message}`:`Loading code failed: ${c.message}`),console.error(`${h.toString(!0)}${typeof c.line=="number"?` line ${c.line}`:""}${typeof c.column=="number"?` column ${c.column}`:""}`),console.error(c),c}const n=await this.fetchTranslatedStrings(f),i={},r={exports:i},t=c=>{if(c==="vscode-nls-web-data")return n;const _=this._fakeModules.getModule(c,h);if(_===void 0)throw new Error(`Cannot load module '${c}'`);return _};try{return d.codeLoadingStart(),o&&performance.mark(`code/extHost/willLoadExtensionCode/${o}`),u(r,i,t),r.exports!==i?r.exports:i}finally{o&&performance.mark(`code/extHost/didLoadExtensionCode/${o}`),d.codeLoadingStop()}}async $setRemoteEnvironment(f){}async _waitForDebuggerAttachment(f=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const h=Date.now()+f;for(;Date.now()<h&&!("__jsDebugIsReady"in globalThis);)await(0,P.timeout)(10)}async fetchTranslatedStrings(f){let h={};if(!f)return{};const d=T.Language.isDefaultVariant()?f.browserNlsBundleUris?.en:f.browserNlsBundleUris?.[T.Language.value()]??f.browserNlsBundleUris?.en;if(f&&d)try{const o=await fetch(d.toString(!0));if(!o.ok)throw new Error(await o.text());h=await o.json()}catch(o){try{console.error(`Failed to load translations for ${f.identifier.value} from ${d}: ${o.message}`);const g=f.browserNlsBundleUris?.en;if(g){const R=await fetch(g.toString(!0));if(!R.ok)throw new Error(await R.text());h=await R.json()}throw new Error("No English strings found")}catch(g){console.error(g)}}return h}}e.ExtHostExtensionService=y;function m(k,f){return k.endsWith(f)?k:k+f}}),define(ye[239],De([1,0,56,33,70,238]),function(ne,e,a,v,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,a.registerSingleton)(v.IExtHostExtensionService,M.ExtHostExtensionService),(0,a.registerSingleton)(b.IExtensionStoragePaths,b.ExtensionStoragePaths)}),define(ye[248],De([1,0,23,5,94,232,224,19,71,12,2,234,239]),function(ne,e,a,v,b,M,D,P,E,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const y=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const m=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function k(s){return/^(file|vscode-remote):/i.test(s)}const f=fetch.bind(self);function h(s){self.fetch=async function(u,n){return u instanceof Request||k(String(u))&&(u=(await s(O.URI.parse(String(u)))).toString(!0)),f(u,n)},self.XMLHttpRequest=class extends XMLHttpRequest{open(u,n,i,r,t){(async()=>{k(n.toString())&&(n=(await s(O.URI.parse(n.toString()))).toString(!0)),super.open(u,n,i??!0,r,t)})()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const s=self.Worker;Worker=function(u,n){if(/^file:/i.test(u.toString()))u=T.FileAccess.asBrowserUri(O.URI.parse(u.toString())).toString(!0);else if(/^vscode-remote:/i.test(u.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const r=`(${function(p){function C(L){return typeof L=="string"||L instanceof URL?String(L).replace(/^file:\/\//i,"vscode-file://vscode-app"):L}const U=fetch.bind(self);self.fetch=function(L,S){return L instanceof Request?U(L,S):U(C(L),S)},self.XMLHttpRequest=class extends XMLHttpRequest{open(L,S,z,$,F){return super.open(L,C(S),z??!0,$,F)}};const W=importScripts.bind(self);self.importScripts=(...L)=>{W(...L.map(C))},W(p)}.toString()}('${u}'))`;n=n||{},n.name=n.name||P.basename(u.toString());const t=new Blob([r],{type:"application/javascript"}),c=URL.createObjectURL(t);return new s(c,n)}}else self.Worker=class extends D.NestedWorker{constructor(s,u){super(m,s,{name:P.basename(s.toString()),...u})}};const d=new class{constructor(){this.pid=void 0}exit(s){y()}async exists(s){return!0}async realpath(s){return s}};class o{constructor(){const u=new MessageChannel,n=new v.Emitter;let i=!1;m(u.port2,[u.port2]),u.port1.onmessage=r=>{const{data:t}=r;if(!(t instanceof ArrayBuffer)){console.warn("UNKNOWN data received",t);return}const c=a.VSBuffer.wrap(new Uint8Array(t,0,t.byteLength));if((0,b.isMessageOfType)(c,2)){i=!0,R("received terminate message from renderer");return}n.fire(c)},this.protocol={onMessage:n.event,send:r=>{if(!i){const t=r.buffer.buffer.slice(r.buffer.byteOffset,r.buffer.byteOffset+r.buffer.byteLength);u.port1.postMessage(t,[t])}}}}}function g(s){return new Promise(u=>{const n=s.onMessage(i=>{n.dispose();const r=JSON.parse(i.toString());s.send((0,b.createMessageOfType)(0)),u({protocol:s,initData:r})});s.send((0,b.createMessageOfType)(1))})}let R=s=>y();function l(s){return!!s&&typeof s=="object"&&s.type==="vscode.init"&&s.data instanceof Map}function w(){E.mark("code/extHost/willConnectToRenderer");const s=new o;return{onmessage(u){!l(u)||g(s.protocol).then(n=>{E.mark("code/extHost/didWaitForInitData");const i=new M.ExtensionHostMain(n.protocol,n.initData,d,null,u.data);h(r=>i.asBrowserUri(r)),R=r=>i.terminate(r)})}}}e.create=w})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/7fee053fdfef9bd86da74dc3c223b95019c5d297/core/vs/workbench/api/worker/extensionHostWorker.js.map
